<?php

interface Zend_WebPush_Interface
{
    /**
     * Connect to the Push Server
     *
     * @return Push
     */
    public function connect();

    /**
     * Send a Push Message
     *
     * @param Zend_Mobile_Push_Message_Interface $message
     * @return boolean
     */
    public function send(Zend_WebPush_Message_Abstract $message);

    /**
     * Close the Connection to the Push Server
     *
     * @return void
     */
    public function close();

    /**
     * Set Options
     *
     * @param array $options
     * @return Zend_Mobile_Push_Abstract
     */
    public function setOptions(array $options);
}