<?php namespace PrimeMessenger\Primemessenger;

class User extends Resource
{

    protected $userId;

    public function __construct($userId = null, $client = null, $href = null)
    {
        parent::__construct($href, $client);
        if (!is_null($userId)) {
            $this->userId = $userId;
        }
    }

    public function create($data = [])
    {
        return $this->request(Client::POST, $this->uri(), $data);
    }

    public function update($data = [])
    {
        return $this->request(Client::PUT, $this->uri(), $data);
    }

    public function delete()
    {
        return $this->request(Client::DELETE, $this->uri());
    }

    public function addFriend($data = [])
    {
        return $this->request(Client::POST, $this->uri('add-friend'), $data);
    }

    public function removeFriend($data = [])
    {
        return $this->request(Client::POST, $this->uri('remove-friend'), $data);
    }

    public function blockUsers($data = [])
    {
        return $this->request(Client::POST, $this->uri('block'), $data);
    }

    public function unblockUsers($data = [])
    {
        return $this->request(Client::POST, $this->uri('unblock'), $data);
    }

    public function logout($data = [])
    {
        return $this->request(Client::POST, $this->uri('loggedOut'), $data);
    }

    public function login($data = [])
    {
        return $this->request(Client::POST, $this->uri('login'), $data);
    }

    protected function uri($urlSuffix = null)
    {
        if (!empty($this->href)) {
            return $this->getHref();
        }
        return $this->uriForUser($urlSuffix);
    }

    protected function uriForUser($urlSuffix)
    {
        $baseUrl = Client::PATH_CUSTOMER;
        
        if (!$this->userId) {
            $uri = $baseUrl;
        } else {
            $uri = $baseUrl . '/' . rawurlencode($this->userId);
        }

        if ($urlSuffix) {
            return $uri . '/' . rawurlencode($urlSuffix);
        }

        return $uri;
    }
}
