<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Blog
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 * @version    $Id: Core.php 9747 2012-07-26 02:08:08Z john $
 * @author     Jung
 */

/**
 * @category   Application_Extensions
 * @package    Blog
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 */
class Advancedactivitypost_Api_Core extends Core_Api_Abstract {

  public function getItemTableClass($type) {

    // Generate item table class manually
    $module = 'Advancedactivitypost';
    $class = $module . '_Model_DbTable_' . self::typeToClassSuffix($type, $module);
    if (substr($class, -1, 1) === 'y' && substr($class, -3) !== 'way') {
      $class = substr($class, 0, -1) . 'ies';
    } else if (substr($class, -1, 1) !== 's') {
      $class .= 's';
    }
    return $class;
  }

  /**
   * Used to inflect item types to class suffix.
   * 
   * @param string $type
   * @param string $module
   * @return string
   */
  static public function typeToClassSuffix($type, $module) {
    $parts = explode('_', $type);
    if (count($parts) > 1 && ($parts[0] === strtolower($module)||$parts[0] === strtolower('Advancedactivity'))) {
      array_shift($parts);
    }
    $partial = str_replace(' ', '', ucwords(join(' ', $parts)));
    return $partial;
  }

}