<?php
/**
 * SocialEngine
 *
 * @category   Application_Core
 * @package    Core
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 * @version    $Id: AdminMenusController.php 9747 2012-07-26 02:08:08Z john $
 * @author     John
 */

/**
 * @category   Application_Core
 * @package    Core
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 */ 
class Advancedactivitypost_AdminCategoriesController extends Core_Controller_Action_Admin
{
  
  public function init()
  {
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('advancedactivity_admin_main', array(), 'advancedactivitypost_admin_main_categories');
  }
  
  public function indexAction()
  { 
    // Get Categories
    $this->view->categoryItems =  Engine_Api::_()->getDbtable('categories', 'advancedactivitypost')->getCategories();
  }

  public function createAction()
  {
    // Get form
    $this->view->form = $form = new Advancedactivitypost_Form_Admin_Category_ItemCreate();

    // Check stuff
    if( !$this->getRequest()->isPost() ) {
      return;
    }
    if( !$form->isValid($this->getRequest()->getPost()) ) {
      return;
    }

    // Save
    $values = $form->getValues();
    $category_name = $values['category_name'];
    unset($values['category_name']);

    $categoryItemsTable = Engine_Api::_()->getDbtable('categories', 'advancedactivitypost');

    $categoryItem = $categoryItemsTable->createRow();
    $categoryItem->category_name = $category_name;
    
    //$categoryItem->photo_id = $category_name;
    $categoryItem->order = '999'; 
    $categoryItem->save();

    $this->view->status = true;
    $this->view->form = null;
  }

  public function editAction()
  {
    $this->view->category_name = $category_name = $this->_getParam('category_name');

    //GET CATEGORY ITEM 
     $this->view->categoryItem = $categoryItem = Engine_Api::_()->getDbtable('categories', 'advancedactivitypost')->getCategories($category_name);

    if( !$categoryItem ) {
      throw new Core_Model_Exception('missing menu item');
    }

    // Get form
    $this->view->form = $form = new Advancedactivitypost_Form_Admin_Category_ItemEdit();

    // Make safe
    $categoryItemData = $categoryItem->toArray();

    // Check stuff
    if( !$this->getRequest()->isPost() ) {
      $form->populate($categoryItemData);
      return;
    }
    if( !$form->isValid($this->getRequest()->getPost()) ) {
      return;
    }

    // Save
    $values = $form->getValues();

    $categoryItem->category_name = $values['category_name'];
   // $categoryItem->enabled = !empty($values['enabled']);
    unset($values['category_name']);
    unset($values['enabled']);

    $categoryItem->save();
    
    $this->view->status = true;
    $this->view->form = null;
  }

  public function deleteAction()
  {
    $this->view->category_name = $category_name = $this->_getParam('category_name');

     //GET CATEGORY ITEM 
     $this->view->categoryItem = $categoryItem = Engine_Api::_()->getDbtable('categories', 'advancedactivitypost')->getCategories($category_name);

    if( !$categoryItem) {
      throw new Core_Model_Exception('missing menu item');
    }

    // Get form
    $this->view->form = $form = new Advancedactivitypost_Form_Admin_Category_ItemDelete();
    
    // Check stuff
    if( !$this->getRequest()->isPost() ) {
      return;
    }
    if( !$form->isValid($this->getRequest()->getPost()) ) {
      return;
    }

    $categoryItem->delete();

    $this->view->form = null;
    $this->view->status = true;
  }

  public function orderAction()
  {
    if( !$this->getRequest()->isPost() ) {
      return;
    }
    
     //GET CATEGORY ITEM 
    $categoryItems = Engine_Api::_()->getDbtable('categories', 'advancedactivitypost')->getCategories();
    foreach( $categoryItems as $categoryItem ) {
      $order = $this->getRequest()->getParam('admin_menus_item_'.$categoryItem->category_name);
      if( !$order ){
        $order = 999;
      }
      $categoryItem->order = $order;
      $categoryItem->save();
    }
    return;
  }

}
