<?php

class Advancedactivitypost_IndexController extends Core_Controller_Action_Standard {

  public function browseCategoryAction() {
    $this->view->category_id = $this->_getParam('category_id');
    $this->view->category = Engine_Api::_()->getItem("advancedactivity_category", $this->view->category_id);
    if (empty($this->view->category)) {
      return $this->_forward('notfound', 'error', 'core');
    }

    $this->_helper->content
            ->setContentName("advancedactivitypost_index_browse_category")
            //->setNoRender()
            ->setEnabled()
    ;
  }

  public function editCategoryAction() {
    if (!$this->_helper->requireUser()->isValid())
      return;
    $action_id = $this->view->action_id = $this->_getParam('action_id');

    if (empty($action_id)) {
      return $this->_forward('notfound', 'error', 'core');
    }
    $viewer = Engine_Api::_()->user()->getViewer();
    $actionTable = Engine_Api::_()->getDbtable('actions', 'advancedactivity');
    $this->view->action = $action = $actionTable->getActionById($action_id);

    $actionOwner = Engine_Api::_()->getItemByGuid($action->subject_type . "_" . $action->subject_id);
    if (!$actionOwner->isSelf($viewer)) {
      return $this->_forward('notfound', 'error', 'core');
    }

    $tableCategories = Engine_Api::_()->getDbtable('categories', 'advancedactivitypost');
    $this->view->categoriesList = $categoriesList = $tableCategories->getCategories();
    if (!count($categoriesList))
      return $this->_forward('notfound', 'error', 'core');
    if (!$this->getRequest()->isPost())
      return;

    try {
      $db = $actionTable->getAdapter();
      $db->beginTransaction();
      $action->category_id = $_POST['category_id'];
      $action->save();
      $this->view->status = true;
      $db->commit();
    } catch (Exception $e) {
      $db->rollBack();
      throw $e;
    }
    return $this->_forward('success', 'utility', 'core', array(
                'messages' => array(Zend_Registry::get('Zend_Translate')->_('Your changes have been saved.')),
                'layout' => 'default-simple',
                'parentRefresh' => true,
    ));
  }

}
