<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Advancedactivity
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 6590 2012-26-01 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Advancedactivitypost_Installer extends Engine_Package_Installer_Module {

  function onPreinstall() {

    parent::onPreinstall();
  }

  function onInstall() {
    $db = $this->getDb();




    $Column = $db->query("SHOW COLUMNS FROM `engine4_activity_actions` LIKE 'category_id'")->fetch();
    if (empty($Column)) {
      $db->query("ALTER TABLE `engine4_activity_actions` ADD `category_id` INT( 11 ) NOT NULL DEFAULT '0'");
    }
    $this->_addCategroyFeedBrowsePage();
    parent::onInstall();
  }

  protected function _addCategroyFeedBrowsePage() {
    $db = $this->getDb();

    // profile page
    $page_id = $db->select()
            ->from('engine4_core_pages', 'page_id')
            ->where('name = ?', 'advancedactivitypost_index_browse_category')
            ->limit(1)
            ->query()
            ->fetchColumn();

    // insert if it doesn't exist yet
    if (!$page_id) {
      // Insert page
      $db->insert('engine4_core_pages', array(
          'name' => 'advancedactivitypost_index_browse_category',
          'displayname' => 'Advanced Activity Feed - Category Base Browse Activity Feed Page',
          'title' => 'Browse Activity Feed',
          'description' => 'This page browse the activty feed base on a categroy.',
          'custom' => 0,
      ));
      $page_id = $db->lastInsertId();

      // Insert top
      $db->insert('engine4_core_content', array(
          'type' => 'container',
          'name' => 'top',
          'page_id' => $page_id,
          'order' => 1,
      ));
      $top_id = $db->lastInsertId();

      // Insert main
      $db->insert('engine4_core_content', array(
          'type' => 'container',
          'name' => 'main',
          'page_id' => $page_id,
          'order' => 2,
      ));
      $main_id = $db->lastInsertId();

      // Insert top-middle
      $db->insert('engine4_core_content', array(
          'type' => 'container',
          'name' => 'middle',
          'page_id' => $page_id,
          'parent_content_id' => $top_id,
      ));
      $top_middle_id = $db->lastInsertId();

      // Insert main-middle
      $db->insert('engine4_core_content', array(
          'type' => 'container',
          'name' => 'middle',
          'page_id' => $page_id,
          'parent_content_id' => $main_id,
          'order' => 2,
      ));
      $main_middle_id = $db->lastInsertId();

      // Insert main-right
      $db->insert('engine4_core_content', array(
          'type' => 'container',
          'name' => 'right',
          'page_id' => $page_id,
          'parent_content_id' => $main_id,
          'order' => 1,
      ));
      $main_right_id = $db->lastInsertId();

      // Insert menu
//      $db->insert('engine4_core_content', array(
//        'type' => 'widget',
//        'name' => 'blog.browse-menu',
//        'page_id' => $page_id,
//        'parent_content_id' => $top_middle_id,
//        'order' => 1,
//      ));
      // Insert content
      $db->insert('engine4_core_content', array(
          'type' => 'widget',
          'name' => 'core.content',
          'page_id' => $page_id,
          'parent_content_id' => $main_middle_id,
          'order' => 1,
      ));

      $db->insert('engine4_core_content', array(
          'type' => 'widget',
          'name' => 'advancedactivity.post-feed-button',
          'page_id' => $page_id,
          'parent_content_id' => $main_right_id,
          'order' => 1,
      ));
      $db->insert('engine4_core_content', array(
          'type' => 'widget',
          'name' => 'advancedactivitypost.categories-list',
          'page_id' => $page_id,
          'parent_content_id' => $main_right_id,
          'order' => 2,
      ));
     $db->insert('engine4_core_content', array(
          'type' => 'widget',
          'name' => 'advancedactivitypost.feed-short',
          'page_id' => $page_id,
          'parent_content_id' => $main_right_id,
          'order' => 2,
      ));
    }
  }

}

?>
