<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions 
 * @package    Seaocore
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 2010-11-18 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Bigstep_Api_Core extends Core_Api_Abstract {

  private $_byPassModuleWhichAreNotEnabledOnDemo = array("sitebusiness", "siteeventticket", "sitehomepagevideo");
  
  private $_getCorrectPtypesOfOldPlugins = array(
      "feedbacks" => "feedback",
      "documentsv4" => "document",
      "groupdocumentsv4" => "groupdocument",
      "backup" => "dbbackup",
      "like" => "sitelike",
  );

  private function _getHardCodedPluginsURL() {
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
    return array(
        "sitemobileiosapp" => array(
            "url" => "https://itunes.apple.com/us/app/socialengine-mobile-app/id907432094"
        ),
        "sitemobileandroidapp" => array(
            "url" => "https://play.google.com/store/apps/details?id=com.socialengineaddons.demo"
        ),
        "siteverify" => array(
            "url" => "/profile/emmaw"
        ),
        "siteadvsearch" => array(
            "url" => "/search"
        ),
        "sitemember" => array(
            "url" => "/members"
        ),
        "sitestaticpage" => array(
            "url" => "/get-thicker-hair"
        ),
        "sitestore" => array(
            "url" => "/stores/products"
        ),
        "siteusercoverphoto" => array(
            "url" => "/profile/arnoldj"
        ),
        "sitemobile" => array(
            "url" => "/?switch-mode=mobile"
        ),
        "sitevideoview" => array(
            "url" => "/videos"
        ),
        "eventdocument" => array(
            "url" => "/event/educational-trip-to-florida/53/tab/9709"
        ),
        "advancedslideshow" => array(
            "url" => "/pages/advanced-slideshow-plugin-multiple-slideshows-demo"
        ),
        "sitealbum" => array(
            "url" => "/albums"
        ),
        "facebookse" => array(
            "url" => "/pages/facebook"
        ),
        "facebooksepage" => array(
            "url" => "/pages/facebook"
        ),
        "facebooksefeed" => array(
            "url" => "/pages/facebook"
        ),
        "poke" => array(
            "url" => "/pages/pokes"
        ),
        "birthday" => array(
            "url" => "/birthday/index/viewallcalender"
        ),
        "mcard" => array(
            "url" => $view->url(array("id" => $viewer_id), "user_profile", false)
        ),
        "suggestion" => array(
            "url" => "/pages/suggestions"
        ),
        "feedback" => array(
            "url" => "/feedback"
        ),
        "nestedcomment" => array(
            "url" => "/property/339/home-with-overlooking-lake/tab/3809"
        ),
        "sitemenu" => array(
            "url" => "/menu/advanced"
        ),
        "sitemailtemplates" => array(
            "url" => "http://admindemo.socialengineaddons.com/admin/sitemailtemplates/settings/manage"
        ),
        "mapprofiletypelevel" => array(
            "url" => "http://admindemo.socialengineaddons.com/admin/mapprofiletypelevel/settings/"
        ),
        "eventdocument" => array(
            "url" => "/seevent/42"
        ),
        "userconnection" => array(
            "url" => $view->url(array("id" => $viewer_id), "user_profile", false)
        ),
        "sitecontentcoverphoto" => array(
            "url" => "/cinnamonhotel"
        ),
        "siteslideshow" => array(
            "url" => "/pages/advanced-slideshow-plugin-multiple-slideshows-demo"
        ),
        "sitereviewkit" => array(
            "url" => "/electronics"
        ),
        "sitebusiness" => array(
            "url" => "/pageitems/pinboard-browse"
        ),
        "sitehomepagevideo" => array(
            "url" => "http://demo.sell-tickets.socialengineaddons.com"
        ),
        "siteeventticket" => array(
            "url" => "http://demo.sell-tickets.socialengineaddons.com"
        ),
    );
  }

  // Make an array where you want to show the plugin information tip.
  private function _changePtypeAccordingToModuleName() {
    $showPluginInformationTip = array();
    $showPluginInformationTip['sitestore'] = array(
        array(
            "module" => "sitestoreproduct", "controller" => "index", "action" => "home"
        ),
        array(
            "module" => "sitestoreproduct", "controller" => "index", "action" => "index"
        )
    );

    $showPluginInformationTip['sitereview'] = array(
        array(
            "module" => "sitereview", "controller" => "index", "action" => "view"
        ),
        array(
            "module" => "sitereview", "controller" => "index", "action" => "map"
        )
    );

    $showPluginInformationTip['siteusercoverphoto'] = array(
        array(
            "module" => "user", "controller" => "profile", "action" => "index"
        )
    );

    $showPluginInformationTip['sitemember'] = array(
        array(
            "module" => "sitemember", "controller" => "location", "action" => "userby-locations"
        )
    );

    $showPluginInformationTip['sitemenu'] = array(
        array(
            "module" => "bigstep", "controller" => "index", "action" => "advanced-menu"
        )
    );

    $showPluginInformationTip['sitevideoview'] = array(
        array(
            "module" => "video", "controller" => "index", "action" => "browse"
        )
    );

    $showPluginInformationTip['eventdocument'] = array(
        array(
            "module" => "event", "controller" => "index", "action" => "view"
        )
    );

    $showPluginInformationTip['advancedactivity'] = array(
        array(
            "module" => "user", "controller" => "index", "action" => "home"
        )
    );

    $showPluginInformationTip['advancedslideshow'] = array(
        array(
            "module" => "core", "controller" => "pages", "action" => "advanced-slideshow-plugin-multiple-slideshows-demo"
        )
    );

    $showPluginInformationTip['communityad'] = array(
        array(
            "module" => "communityad", "controller" => "display", "action" => "adboard"
        )
    );

    $showPluginInformationTip['facebookse'] = array(
        array(
            "module" => "facebooksepage", "controller" => "index", "action" => "userfbinvite"
        )
    );

    $showPluginInformationTip['birthday'] = array(
        array(
            "module" => "birthday", "controller" => "index", "action" => "viewallcalender"
        )
    );

    $showPluginInformationTip['suggestion'] = array(
        array(
            "module" => "core", "controller" => "pages", "action" => "suggestions"
        )
    );
    
    $showPluginInformationTip['facebookse'] = array(
        array(
            "module" => "core", "controller" => "pages", "action" => "facebook"
        )
    );
    
    $showPluginInformationTip['siteevent'] = array(
        array(
            "module" => "siteevent", "controller" => "index", "action" => "view"
        )
    );

    $showPluginInformationTip['sitepage'] = array(
        array(
            "module" => "sitepage", "controller" => "index", "action" => "view"
        )
    );
    
    $showPluginInformationTip['sitegroup'] = array(
        array(
            "module" => "sitegroup", "controller" => "index", "action" => "view"
        )
    );
    return $showPluginInformationTip;
  }

  private function _getMenuParams($name, array $options = array(), $activeItem = null) {
    $menu = $this->_getMenu($name);
    $pages = array();

    foreach ( $menu as $row ) {
      // Check enabled
      if ( isset($row->enabled) && !$row->enabled ) {
        continue;
      }

      // Plugin
      $page = null;
      $multi = false;
      if ( !empty($row->plugin) ) {

        // Support overriding the method
        if ( strpos($row->plugin, '::') !== false ) {
          list($pluginName, $method) = explode('::', $row->plugin);
        } else {
          $pluginName = $row->plugin;
          $method = 'onMenuInitialize_' . $this->_formatMenuName($row->name);
        }

        // Load the plugin
        try {
          $plugin = Engine_Api::_()->loadClass($pluginName);
        } catch ( Exception $e ) {
          // Silence exceptions
          continue;
        }

        // Run plugin
        try {
          $result = $plugin->$method($row);
        } catch ( Exception $e ) {
          // Silence exceptions
          continue;
        }

        if ( $result === true ) {
          // Just generate normally
        } else if ( $result === false ) {
          // Don't generate
          continue;
        } else if ( is_array($result) ) {
          // We got either page params or multiple page params back
          // Single
          if ( array_values($result) !== $result ) {
            $page = $result;
          }
          // Multi
          else {
            // We have to do this manually
            foreach ( $result as $key => $value ) {
              if ( is_numeric($key) ) {
                if ( !empty($options) ) {
                  $value = array_merge_recursive($value, $options);
                }
                if ( !isset($result['label']) )
                  $result['label'] = $row->label;
                $pages[] = $value;
              }
            }
            continue;
          }
        } else if ( $result instanceof Zend_Db_Table_Row_Abstract && $result->getTable() instanceof Core_Model_DbTable_MenuItems ) {
          // We got the row (or a different row?) back ...
          $row = $result;
        } else {
          // We got a weird data type back
          continue;
        }
      }

      // No page was made, use row
      if ( null === $page ) {
        $page = ( array ) $row->params;
      }

      if ( $row->module ) {
        $page['module'] = $row->module;
      }

      // Add label
      if ( !isset($page['label']) ) {
        $page['label'] = $row->label;
      }

      // Add type for URI
      if ( isset($page['uri']) && !isset($page['type']) ) {
        $page['type'] = 'uri';
      }

      // Add custom options
      if ( !empty($options) ) {
        $page = array_merge_recursive($page, $options);
      }

      // Standardize arguments
      if ( !isset($page['reset_params']) ) {
        $page['reset_params'] = true;
      }

      // Set page as active, if necessary
      if ( !isset($page['active']) && null !== $activeItem && $activeItem == $row->name ) {
        $page['active'] = true;
      }

      $page['class'] = (!empty($page['class']) ? $page['class'] . ' ' : '' ) . 'menu_' . $name;
      $page['class'] .= " " . $row->name;

      // Get submenu
      if ( $row->submenu ) {
        $page['pages'] = $this->_getMenuParams($row->submenu);
      }

      // Maintain menu item order 
      $page['order'] = $row->order;

      $pages[] = $page;
    }

    return $pages;
  }

  private function _getMenu($name) {
    // Get only enabled modules
    $enabledModuleNames = Engine_Api::_()->getDbtable('modules', 'core')->getEnabledModuleNames();

    // Get items
    $table = Engine_Api::_()->getDbtable('menuItems', 'core');
    $select = $table->select()
            ->where('menu = ?', $name)
            ->where('module IN(?)', $enabledModuleNames)
            ->order('order ASC');

    return $table->fetchAll($select);
  }

  protected function _formatMenuName($name) {
    $name = str_replace('_', ' ', $name);
    $name = ucwords($name);
    $name = str_replace(' ', '', $name);
    return $name;
  }

  private function _shouldShowTip($ptype) {
    $flag = false;
    $front = Zend_Controller_Front::getInstance();
    $module = $front->getRequest()->getModuleName();
    $action = $front->getRequest()->getActionName();
    $controller = $front->getRequest()->getControllerName();
    
    $_changePtypeAccordingToModuleName = $this->_changePtypeAccordingToModuleName();
    if ( ($module == $ptype) && ($controller == 'index') && (($action == 'index') || ($action == 'home') || ($action == 'browse')) ) {
      $flag = true;
    } elseif ( isset($_changePtypeAccordingToModuleName[$ptype]) && !empty($_changePtypeAccordingToModuleName[$ptype]) ) {
      foreach ( $_changePtypeAccordingToModuleName[$ptype] as $modules ) {
        if ( (isset($modules['module']) && (!empty($modules['module'])) && ($modules['module'] == $module) ) &&
                (isset($modules['controller']) && (!empty($modules['controller'])) && ($modules['controller'] == $controller)) &&
                (isset($modules['action']) && (!empty($modules['action'])) && ($modules['action'] == $action)) ) {
          $flag = true;
          break;
        }
      }
    }
    return $flag;
  }

  public function getSEAOPlugins($fetchSingleModuleInfo = false) {
//    if ( !empty($fetchSingleModuleInfo) ) {
//      $cache = Zend_Registry::get('Zend_Cache');
//      $getCache = $cache->load("socialengineaddons_plugins_rss_feed");
//      if ( empty($getCache) && $cache instanceof Zend_Cache_Core ) {
//        $rss = Zend_Feed::import('http://www.socialengineaddons.com/plugins/feed');
//        $cache->setLifetime(604800);
//        $cache->save($rss, "socialengineaddons_plugins_rss_feed");
//      } else {
//        $rss = $getCache;
//      }
//      //    $cache->remove("socialengineaddons_plugins_rss_feed");
//    } else {
//      $rss = Zend_Feed::import('http://www.socialengineaddons.com/plugins/feed');
//    }


    $cache = Zend_Registry::get('Zend_Cache');
    $getCache = $cache->load("socialengineaddons_plugins_rss_feed");
    if ( empty($getCache) && $cache instanceof Zend_Cache_Core ) {
      $rss = Zend_Feed::import('http://www.socialengineaddons.com/plugins/feed?order=popularity');
      $cache->setLifetime(604800);
      $cache->save($rss, "socialengineaddons_plugins_rss_feed");
    } else {
      $rss = $getCache;
    }

    // Get core_main menus information.
    $tempFlag = false;
    $coreMainMenu = $this->_getMenuParams("core_main");
    $getNavigationURL = array();
    foreach ( $coreMainMenu as $menu ) {
      $navigation = new Zend_Navigation();
      $navigation->addPage($menu);
      if ( @current(@current($navigation))->getHref() ) {
        $getNavigationURL[$menu['module']] = array(
            "url" => @current(@current($navigation))->getHref()
        );
      }
    }
    $getHardCodedPluginsURL = $this->_getHardCodedPluginsURL();
    $getFinalNavigationArray = @array_merge($getNavigationURL, $getHardCodedPluginsURL);

    if ( empty($fetchSingleModuleInfo) )
      $response['getNavigationURL'] = $getFinalNavigationArray;        

    // Loop over each channel item and store relevant data
    foreach ( $rss as $item ) {
      $ptype = $item->ptype();
      
      $price = $item->price();
      $price = str_replace("$", "", $price);
      $price = (float) $price;

      if($price <= 0)
        continue;

      // There are wrong ptype set by us for very old plugins, which correct following.
      if ( array_key_exists($ptype, $this->_getCorrectPtypesOfOldPlugins) && !empty($this->_getCorrectPtypesOfOldPlugins[$ptype]) )
        $ptype = $this->_getCorrectPtypesOfOldPlugins[$ptype];

      if ( !in_array($ptype, $this->_byPassModuleWhichAreNotEnabledOnDemo) && !Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled($ptype) )
        continue;

      $plugin_info['ptype'] = $ptype;
      $plugin_info['title'] = $item->title();
      $plugin_info['product_version'] = $item->version();
      $plugin_info['link'] = $item->link();
      $plugin_info['price'] = $item->price();
      $plugin_info['socialengine_url'] = $item->socialengine_url();
      $plugin_info['icon'] = $item->icon();
      $plugin_info['description'] = $item->description();

      if ( !empty($fetchSingleModuleInfo) && ($this->_shouldShowTip($ptype)) ) {
        $tempFlag = true;
        $channel = $plugin_info;
        break;
      } else {
        if($ptype == "sitereview" && array_key_exists("sitereview", $channel)) {
          $channel["sitereviewkit"] = $channel["sitereview"];
          unset($channel["sitereview"]);
        }
        
        $channel[$ptype] = $plugin_info;
      }
    }

    if ( !empty($fetchSingleModuleInfo) && !empty($tempFlag) )
      $channel['url'] = $getFinalNavigationArray[$ptype]['url'];
    
    
    $response['channel'] = $channel;

    if ( !empty($fetchSingleModuleInfo) && empty($tempFlag) )
      return;

    return $response;
  }

  public function truncation($string, $length = null) {
    $string = strip_tags($string);
    return $string = Engine_String::strlen($string) > $length ? Engine_String::substr($string, 0, ($length - 3)) . '...' : $string;
  }

}
