<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitealbum
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Global.php 2011-08-026 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Bigstep_Form_Admin_Demo extends Engine_Form {

    public function init() {

        $this->setTitle('Make Demo Setup Sql')
                ->setDescription("Create SQL Files of selected plugins from 'Select Modules'. After successfully creation you will get the '.tar' directory of respective sql. Which include the sql file and readme file. All type of instruction regarding the sql file for 'Developer' included in readme file. So read this file carefully before applying the sql file to client site.");

        $this->addElement('Text', 'site_link', array(
            'label' => 'Site URL',
            'autocomplete' => 'off',
            'required' => true,
            'allowEmpty' => false,
            'description' => 'Please enter correct site URL(Ex: google.com). Please do not enter "http" ot "https".'
        ));

        $this->addElement('Text', 'site_dbname', array(
            'label' => 'Demo Database Name',
            'autocomplete' => 'off',
            'required' => true,
            'allowEmpty' => false,
            'value' => 'demo',
            'description' => 'Please enter a demo Database Name.'
        ));

        $this->addElement('Text', 'site_license_key', array(
            'label' => 'SocialEngine License Key',
            'autocomplete' => 'off',
            'required' => true,
            'allowEmpty' => false,
            'description' => 'Please enter a valid license key of client site.'
        ));

        $this->addElement('Text', 'site_title', array(
            'label' => 'Site Title',
            'autocomplete' => 'off',
            'required' => true,
            'allowEmpty' => false,
            'description' => 'CORE_FORM_ADMIN_SETTINGS_GENERAL_SITETITLE_DESCRIPTION'
        ));

        $this->addElement('Textarea', 'site_description', array(
            'label' => 'Site Description',
            'autocomplete' => 'off',
            'required' => true,
            'allowEmpty' => false,
            'description' => 'CORE_FORM_ADMIN_SETTINGS_GENERAL_SITEDESCRIPTION_DESCRIPTION'
        ));

        $this->addElement('Text', 'site_admin_email', array(
            'label' => 'Admin Email Id',
            'autocomplete' => 'off',
            'required' => true,
            'allowEmpty' => false,
            'validators' => array(
                array('NotEmpty', true),
                array('EmailAddress', true),
            ),
            'description' => 'Please enter correct admin email id. Ex: admin@siteurl.com'
        ));

        $not_include = array('activity', 'authorization', 'announcement', 'messages', 'core', 'fields', 'invite', 'network', 'payment', 'storage', 'user', 'bigstep', 'seaocore');

        $module_table = Engine_Api::_()->getDbTable('modules', 'core');
        $module_name = $module_table->info('name');
        $select = $module_table->select()
                ->from($module_name, array('name', 'title'))
                //->where($module_name . '.type =?', 'extra')
                ->where($module_name . '.name not in(?)', $not_include);

        $contentModule = $select->query()->fetchAll();
        foreach ($contentModule as $modules) {
            $contentModuleArray[$modules['name']] = $modules['title'];
        }

        $this->addElement('MultiCheckbox', 'modules_name', array(
            'description' => 'Select modules name which <b>you do not</b> want to install on site setup.',
            'label' => 'Select Modules',
            'multiOptions' => $contentModuleArray,
        ));
        $this->modules_name->addDecorator('Description', array('placement' => Zend_Form_Decorator_Abstract::PREPEND, 'escape' => false));


        // Element: submit
        $this->addElement('Button', 'submit', array(
            'label' => 'Create SQL',
            'type' => 'submit',
            'ignore' => true
        ));
    }

}