<?php

class Bigstep_AdminDemoController extends Core_Controller_Action_Admin {

    public function indexAction() {

        // Zend_Feed required DOMDocument
        // @todo add to sanity check
        if (!class_exists('DOMDocument', false)) {
            $this->view->badPhpVersion = true;
            return;
        }

        $viewer = Engine_Api::_()->user()->getViewer();
        if (empty($viewer) || empty($viewer->level_id) || ($viewer->level_id != 1)) {
            return;
        }

        $this->view->form = $form = new Bigstep_Form_Admin_Demo();


        if (!$this->getRequest()->isPost()) {
            return;
        }
        if (!$form->isValid($this->getRequest()->getPost())) {
            return;
        }

        $values = $form->getValues();

        //CALLING FUNCTION FROM COMMON QUERY.
        $string = $this->makeSqlQuery($values);

        if (!empty($string)) {
            $this->view->success = true;
            $ZIP_NAME = 'demosql.tar';
            $files_to_zip = array();
            $files_to_zip[] = "demosql.sql";
            $files_to_zip[] = "readme.php";
            $zipPath = APPLICATION_PATH . "/public/demosql/";
            $result = $this->createZip($files_to_zip, $ZIP_NAME, $zipPath);
        } else {
            $this->view->success = false;
            $this->view->message = array("Sorry! We can not create sql files, Problem could be in server responce OR demosql directory not exist at '/application/modules/Bigstep/controllers/demosql' location. Please check manualy.");
        }
        $form->addNotice('You have succes created a demo setup sql file.');
    }

    /* creates a compressed tar file */

    protected function createZip($files = array(), $ZIP_NAME, $destination = '', $overwrite = false) {

        // EMPTY THE DIRECTORY.
        // we open the directory
        $destination = APPLICATION_PATH . "/public/demosql/";

        // CREATE A DIRECTORY, IF DIRECTORY ARE NOT AVAILABLE.
        $filename = $destination;
        $zipPath = $filename . $ZIP_NAME;
        $is_dir = is_dir($filename);
        if (empty($is_dir)) {
            @mkdir($filename);
        }
        @chmod($filename, 0777);
        @chmod($destination, 0777);
        @chmod($zipPath, 0777);
        $destination = $zipPath;


        // Delete Content from the directory, if available any type of directory.
// 		$handle = opendir($destination);
// 		$is_files = readdir($handle); 
// 		if( !empty($is_files) ) {
// 			// and scan through the items inside
// 			while (FALSE !== ($item = readdir($handle))) {
// 				if($item != '.' && $item != '..') {
// 					// we build the new path to delete
// 					$path = $destination . $item;
// 					unlink($path);
// 				}
// 			}
// 		}
//     // close the directory
//     closedir($handle);

        $valid_files = array();
        if (is_array($files)) {
            //cycle through each file
            foreach ($files as $file) {
                //make sure the file exists
                //if(file_exists($file)) {
                $valid_files[] = $file;
            }
        }

        //if we have good files...
        if (count($valid_files)) {
            //create the archive
            $zip = new Archive_Tar($destination);

            //add the files
            foreach ($valid_files as $file) {
                $filePath = APPLICATION_PATH . "/application/modules/Bigstep/controllers/demosql/" . $file;
                $getArray[] = $filePath;
            }
            $dontIncludeInDirectoryName = APPLICATION_PATH . "/application/modules/Bigstep/controllers/demosql/";

            $zip->addModify($getArray, '', $dontIncludeInDirectoryName);
            //close the zip -- done!
            // $zip->close();
            @chmod($destination, 0777);

// 	    // Kill zend's ob
//       $isGZIPEnabled = false;
//       if (ob_get_level()) {
//         $isGZIPEnabled = true;
//         @ob_end_clean();
//       }
// 
// 			header("Pragma: public");
// 			header("Expires: 0");
// 			header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
// 			header("Cache-Control: private", false);
// 			header("Content-Type: application/zip");
// 			header("Content-Disposition: attachment; filename=" . basename($destination) . ";" );
// 			header("Content-Transfer-Encoding: binary");
// 			if(empty($isGZIPEnabled)){
//         header("Content-Length: " . filesize($destination));
//         @flush();
//       }
// 			readfile($destination);
            //check to make sure the file exists
            return file_exists($destination);
        } else {
            return false;
        }
    }

    public function makeSqlQuery($params = array()) {

        $db = Engine_Db_Table::getDefaultAdapter();

        $final_query = '';
        $final_query = '
UPDATE `engine4_storage_files` SET `service_id` = "1" WHERE `engine4_storage_files`.`service_id` =2;
DELETE FROM `engine4_storage_services` WHERE `engine4_storage_services`.`service_id` = 2;
UPDATE `engine4_storage_services` SET `default` = "1" WHERE `engine4_storage_services`.`service_id` =1;
UPDATE  `engine4_users` SET  `email` =  "' . $params['site_admin_email'] . '" WHERE  `engine4_users`.`user_id` ="1" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "' . $params['site_title'] . '" WHERE `engine4_core_settings`.`name` = "core.general.site.title" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "' . $params['site_description'] . '" WHERE `engine4_core_settings`.`name` = "core.general.site.description" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "' . $params['site_license_key'] . '" WHERE `engine4_core_settings`.`name` = "core.license.key" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "' . $params['site_admin_email'] . '" WHERE `engine4_core_settings`.`name` = "core.mail.contact" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "no-reply@' . $params['site_link'] . '" WHERE `engine4_core_settings`.`name` = "core.mail.from" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.static.baseurl" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.analytics.code" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.general.site.keywords" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.general.analytics" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.facebook.appid" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.facebook.secret" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "none" WHERE `engine4_core_settings`.`name` = "core.facebook.enable" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.twitter.key" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.twitter.secret" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "none" WHERE `engine4_core_settings`.`name` = "core.twitter.enable" LIMIT 1 ;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "sitepage.defaultpagecreate.email" LIMIT 1;
DELETE FROM `engine4_core_modules` WHERE `engine4_core_modules`.`name` = "bigstep"; 
DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`name` = "core.html-block";
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "birthdayemail.admin" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "event.contactemail.admin" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "siteeventemail.admin" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "testemail.admin" LIMIT 1;
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "document.secret.key";
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "eventdocument.secret.key";
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "groupdocument.secret.key";
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "siteeventdocument.secret.key";
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "sitegroupdocument.secret.key";
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "sitepagedocument.secret.key";
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "document.api.key";
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "eventdocument.api.key";
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "groupdocument.api.key";
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "siteeventdocument.api.key";
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "sitegroupdocument.api.key";
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "sitepagedocument.api.key";
UPDATE `engine4_core_settings` SET `value` = "csv" WHERE `engine4_core_settings`.`name` = "core.translate.adapter" LIMIT 1 ;
UPDATE `engine4_core_themes` SET `active` = "0" WHERE `engine4_core_themes`.`name` ="demotheme" LIMIT 1 ;
DELETE FROM `engine4_invites` WHERE `engine4_invites`.`id` = "15" LIMIT 1;
DELETE FROM `engine4_invites` WHERE `engine4_invites`.`id` = "17" LIMIT 1;
DELETE FROM `engine4_invites` WHERE `engine4_invites`.`id` = "20" LIMIT 1;
DELETE FROM `engine4_invites` WHERE `engine4_invites`.`id` = "37" LIMIT 1;
DELETE FROM `engine4_invites` WHERE `engine4_invites`.`id` = "38" LIMIT 1;
DELETE FROM `engine4_invites` WHERE `engine4_invites`.`id` = "354" LIMIT 1;
TRUNCATE TABLE `engine4_announcement_announcements`;
TRUNCATE TABLE `engine4_core_reports`;
TRUNCATE TABLE `engine4_core_bannedemails`;
TRUNCATE TABLE `engine4_core_bannedips`;
TRUNCATE TABLE `engine4_core_bannedusernames`;
TRUNCATE TABLE `engine4_user_logins`;
TRUNCATE TABLE `engine4_core_jobs`;
TRUNCATE TABLE `engine4_core_adcampaigns`;
TRUNCATE TABLE `engine4_core_statistics`;
TRUNCATE TABLE `engine4_core_referrers`;
TRUNCATE TABLE `engine4_payment_transactions`;
TRUNCATE TABLE `engine4_activity_notifications`;
TRUNCATE TABLE `engine4_core_session`;
TRUNCATE TABLE `engine4_user_facebook`;
TRUNCATE TABLE `engine4_user_twitter`;
TRUNCATE TABLE `engine4_user_verify`;
DELETE FROM `engine4_payment_gateways` WHERE `engine4_payment_gateways`.`gateway_id` = "1" LIMIT 1;
DELETE FROM `engine4_payment_gateways` WHERE `engine4_payment_gateways`.`gateway_id` = "2" LIMIT 1;
DELETE FROM `engine4_payment_gateways` WHERE `engine4_payment_gateways`.`gateway_id` = "3" LIMIT 1;

INSERT INTO `engine4_payment_gateways` (`title`, `description`, `enabled`, `plugin`, `config`, `test_mode`) VALUES
("2Checkout", NULL, 0, "Payment_Plugin_Gateway_2Checkout", NULL, 0),
("PayPal", NULL, 0, "Payment_Plugin_Gateway_PayPal", NULL, 0),
("Testing", NULL, 0, "Payment_Plugin_Gateway_Testing", NULL, 1);
DELETE FROM `engine4_invites` WHERE `engine4_invites`.`id` = "16" LIMIT 1;
DELETE FROM `engine4_core_pages` WHERE `engine4_core_pages`.`page_id` = "544" LIMIT 1;
DELETE FROM `engine4_invites` WHERE `engine4_invites`.`id` = "36" LIMIT 1;
DELETE FROM `engine4_invites` WHERE `engine4_invites`.`id` = "75" LIMIT 1;
';

        //start update query for user table.
        $usertable = Engine_Api::_()->getDbtable('users', 'user');
        $select = $usertable->select()->from($usertable->info('name'), 'email')->where('email LIKE ?', '%seaddons.com%');
        $usersitepages = $usertable->fetchAll($select);
        foreach ($usersitepages->toarray() as $email) {
            $replace_email = '@' . $params["site_link"];
            $email = $email['email'];
            $emails = str_replace('@seaddons.com', $replace_email, $email);
            $final_query .= 'UPDATE `engine4_users` SET `email` = "' . $emails . '" WHERE `engine4_users`.`email` = "' . $email . '";';
        }
        //END UPDATE QUERY FOR USER TABLE.
        //HERE WE HAVE TO DROP WHICH MODULE ALL TABLE WHICH WE DO NOT WANT TO SETUP AT HIS SITE.
        $table_name = array();
        $module_array = $params['modules_name'];
        if (!empty($module_array)) {
            foreach ($module_array as $module) {
                $tables_array = $db->query("SHOW tables like '%engine4_" . $module . "_%'")->fetchAll();
                foreach ($tables_array as $table) {
                    $temp = "Tables_in_" . $params['site_dbname'] . " (%engine4_" . $module . "_%)";
                    $table_name = $table[$temp];
                    $table_exist = $db->query("SHOW TABLES LIKE '$table_name'")->fetch();
                    if (!empty($table_exist)) {
                        $final_query .= "DROP TABLE IF EXISTS `$table_name`;";
                    }
                }
            }

            //We have disabled the all modules which do not want to installed on the site.
            foreach ($module_array as $module) {
                //$final_query .= "UPDATE `engine4_core_modules` SET `enabled` = '0' WHERE `engine4_core_modules`.`name` = '$module';";
                $final_query .= 'DELETE FROM `engine4_core_modules` WHERE `engine4_core_modules`.`name` = "' . $module . '" LIMIT 1;';
                $final_query .= 'DELETE FROM `engine4_activity_notificationtypes` WHERE `engine4_activity_notificationtypes`.`module` = "' . $module . '";';
                $final_query .= 'DELETE FROM `engine4_seaocores` WHERE `engine4_seaocores`.`module_name` = "' . $module . '";';
                $final_query .= 'DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`name` LIKE "' . $module . '.%";';
            }

            //delete page from 'engine4_core_pages' table.
            foreach ($module_array as $module) {
                $tables_array = $db->query("SELECT * FROM `engine4_core_pages` WHERE `name` LIKE '%$module%'")->fetchAll();
                foreach ($tables_array as $table) {
                    $page_name = $table['name'];
                    $final_query .= 'DELETE FROM `engine4_core_pages` WHERE `engine4_core_pages`.`name` = "' . $page_name . '";';
                }
            }

            //delete settings from 'engine4_core_settings' table.
            foreach ($module_array as $module) {
                $module = $module . '.%';
                $tables_array = $db->query("SELECT * FROM `engine4_core_settings` WHERE `name` LIKE '$module'")->fetchAll();
                foreach ($tables_array as $table) {
                    $name = $table['name'];
                    $final_query .= 'DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "' . $name . '";';
                }
            }

            //delete page from 'engine4_core_menuitems' table.
            foreach ($module_array as $module) {
                $tables_array = $db->query("SELECT * FROM `engine4_core_menuitems` WHERE `module` LIKE '%$module%'")->fetchAll();
                foreach ($tables_array as $table) {
                    $page_name = $table['name'];
                    $final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`module` = "' . $module . '";';
                }
            }

            //UPDATE DEMO.SOCIALENGINEADDONS.COM AND SOCIALENGINEADDONS.COM TO SITE URL.
// 			if(in_array('advancedslideshow', $params['modules_name'])){
// 				$replace_url = $params["site_link"];
// 				$final_query .= "UPDATE `engine4_advancedslideshow_images` SET `url` = REPLACE(url, 'demo.socialengineaddons.com', '$replace_url') WHERE `url` LIKE '%demo.socialengineaddons.com%';";
// 				$final_query .= "UPDATE `engine4_advancedslideshow_images` SET `url` = REPLACE(url, 'socialengineaddons.com', '$replace_url') WHERE `url` LIKE '%socialengineaddons.com%';";
// 				$final_query .= "UPDATE `engine4_advancedslideshow_images` SET `slide_html` = REPLACE(slide_html, 'demo.socialengineaddons.com', '$replace_url') WHERE `slide_html` LIKE '%demo.socialengineaddons.com%';";
// 				$final_query .= "UPDATE `engine4_advancedslideshow_images` SET `slide_html` = REPLACE(slide_html, 'socialengineaddons.com', '$replace_url') WHERE `slide_html` LIKE '%socialengineaddons.com%';";
// 			}
            //start update query for user table.
            if (isset($params['modules_name']) && in_array('sitestoreproduct', $params['modules_name'])) {
                $orderaddressesTable = Engine_Api::_()->getDbtable('orderaddresses', 'sitestoreproduct');
                $select = $orderaddressesTable->select()->from($orderaddressesTable->info('name'), 'email')->where('email LIKE ?', '%bigsteptech.com%');
                $results = $orderaddressesTable->fetchAll($select);
                foreach ($results->toarray() as $email) {
                    $replace_email = '@' . $params["site_link"];
                    $email = $email['email'];
                    $emails = str_replace('@bigsteptech.com', $replace_email, $email);
                    $final_query .= 'UPDATE `engine4_sitestoreproduct_order_addresses` SET `email` = "' . $emails . '" WHERE `engine4_sitestoreproduct_order_addresses`.`email` = "' . $email . '";';
                }
                //END UPDATE QUERY FOR USER TABLE.
            }

            if (in_array('poke', $params['modules_name'])) {
                $final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "634" LIMIT 1;';
            }

            if (in_array('advancedslideshow', $params['modules_name'])) {
                $final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "635" LIMIT 1;';
            }

            if (in_array('suggestion', $params['modules_name'])) {
                $final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "636" LIMIT 1;';
            }

            if (in_array('facebookse', $params['modules_name'])) {
                $final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "637" LIMIT 1;';
            }

            if (in_array('sitereview', $params['modules_name']) && in_array('sitereviewlistingtype', $params['modules_name'])) {
                $final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "1208" LIMIT 1;';
                $final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "1218" LIMIT 1;';
            }

            if (in_array('sitefaq', $params['modules_name'])) {
                $final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "1219" LIMIT 1;';
            }

            if (in_array('sitebusiness', $params['modules_name'])) {
                $final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "1454" LIMIT 1;';
            }

            if (in_array('siteevent', $params['modules_name'])) {
                $final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "2612" LIMIT 1;';
                $final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "2614" LIMIT 1;';
                $final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "2619" LIMIT 1;';
            }

            if (in_array('sitestaticpage', $params['modules_name'])) {
                $final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "2772" LIMIT 1;';
            }
            $final_query .= 'UPDATE `engine4_core_menuitems` SET `params` = REPLACE(params, "demo.socialengineaddons.com", "' . $params['site_link'] . '") WHERE `params` LIKE "%demo.socialengineaddons.com%";';
        }

        $final_query = trim($final_query);
        $sqlFilePath = APPLICATION_PATH . "/application/modules/Bigstep/controllers/demosql/";
        @chmod($sqlFilePath, 0777);

        // Make a sql file here.
        $myFile = $sqlFilePath . "demosql.sql";
        $is_file_exist = file_exists($myFile);
        if (empty($is_file_exist)) {
            return;
        }
        $fh = fopen($myFile, 'w') or die("can't open file");
        fwrite($fh, $final_query); // Correct code.
        fclose($fh);
        return true;
    }

}