<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions 
 * @package    Bigstep
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: IndexController.php (var) 2010-07-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Bigstep_IndexController extends Core_Controller_Action_Standard {

    public function indexAction() {
        
    }

    private function gitFetch($remoteName) {
        $output = @shell_exec('git fetch ' . $remoteName . ' 2>&1');
        
        if(strstr($output, 'permission')) {
            echo "There are permission problem with '.git' directory. Please login with SSH ROOT and give 777 permission to '.git' directory.";
            exit;
        }
        
        return $output;
    }

    private function gitCheckout($path, $remoteName, $branchName) {
        $path = @trim($path);
        $path = @trim($path, "/");
        $path = @ltrim($path, "/");
        $path = @rtrim($path, "/");
        $output = @shell_exec('git checkout ' . $remoteName . '/' . $branchName . ' -- ' . $path . ' 2>&1');
        return $output;
    }

    private function compareString($filename) {

        $pathArray = array();
        $pathArray[] = 'application/modules';
        $pathArray[] = 'demo2.socialengineaddons.com/application/modules';
        $pathArray[] = 'admindemo.socialengineaddons.com/application/modules';
        $pathArray[] = 'socialcommerce.socialengineaddons.com/application/modules';
        $pathArray[] = 'application';
        $pathArray[] = 'demo2.socialengineaddons.com/application';
        $pathArray[] = 'admindemo.socialengineaddons.com/application';
        $pathArray[] = 'socialcommerce.socialengineaddons.com/application';

        $filename = trim($filename, '/');

//    if (!strstr($filename, $pathArray['0']))
//        return 0;

        foreach ($pathArray as $path) {
            if (strcmp($path, $filename) == 0)
                return 0;
        }

        return 1;
    }

    public function gitUpAction() {
        $viewer = Engine_Api::_()->user()->getViewer();
        if (empty($viewer))
            return $this->_forward('notfound', 'error', 'core');

        $viewer_id = $viewer->getIdentity();
        if (empty($viewer_id))
            return $this->_forward('notfound', 'error', 'core');

        if (!empty($viewer->level_id) && !in_array($viewer->level_id, array(1, 2)))
            return $this->_forward('notfound', 'error', 'core');

    $errorInGitPull = false;
    if(!is_writable(APPLICATION_PATH . '/.git/')){
      $this->view->errorMessage = "<ul class='form-errors'><li><ul class='error'>There are permission problem with '.git' directory. Please login with SSH ROOT and give 777 permission to '.git' directory.</ul></li></ul>";
      $errorInGitPull = true;
    }
        
        ini_set('memory_limit', '2048M');
        set_time_limit(0);

        if (!empty($_POST) && empty($errorInGitPull)) {
//      @chmod(APPLICATION_PATH . '/.git/', 777);
            $remoteName = 'sev4v';
            $branchName = $_POST["branch_name"];
            unset($_POST["branch_name"]);

            $getAllBranch = @shell_exec("git branch");
            if (!empty($getAllBranch) && !strstr($getAllBranch, $branchName)) {
                $this->view->errorMessage = "<ul class='form-errors'><li><ul class='error'>Entered branch name are not valid. Please enter correct Branch Name.</ul></li></ul>";
                return;
            } else {
                $successMessageArray = array();
                $this->gitFetch($remoteName);
                foreach ($_POST as $filename) {

                    if (empty($filename))
                        continue;

                    $tempFileName = false;
                    if (strstr($filename, "application/modules/")) {
                        $tempFileName = @str_replace('application/modules/', '', $filename);
                    } else if (strstr($filename, "application/themes/")) {
                        $tempFileName = @str_replace('application/themes/', '', $filename);
                    }

                    if (empty($tempFileName) || (!empty($filename) && !$this->compareString($filename))) {
                        $this->view->errorMessage = "<ul class='form-errors'><li><ul class='error'>You are not allowed to GIT PULL for File Path: <b>'$filename'</b></ul></li></ul>";
                        return;
                    }

//          @chmod($filename, 777);
                    $getCheckout = $this->gitCheckout($filename, $remoteName, $branchName);
                    if (strstr($getCheckout, "error:")) {
                        $getGitErrorArray = explode("error:", $getCheckout);
                        if (!empty($getGitErrorArray[1]))
                            $this->view->errorMessage = "<ul class='form-errors'><li><ul class='error'>GIT ERROR: " . $getGitErrorArray[1] . "</ul></li></ul>";
                        return;
                    }else {
                        $successMessageArray[] = '<ul class="form-notices"><li>' . $filename . ': File / Directory Successfully Pulled.</li></ul>';
                    }
                }

                $this->view->successMessage = $successMessageArray;
            }
        }
    }

    public function advancedMenuAction() {
        $this->_helper->content
                ->setNoRender()
                ->setEnabled();
    }

    public function getInvalidFilesListAction() {
        $viewer = Engine_Api::_()->user()->getViewer();
        if (empty($viewer))
            return $this->_forward('notfound', 'error', 'core');

        $viewer_id = $viewer->getIdentity();
        if (empty($viewer_id))
            return $this->_forward('notfound', 'error', 'core');

        if (!empty($viewer->level_id) && !in_array($viewer->level_id, array(1, 2)))
            return $this->_forward('notfound', 'error', 'core');
        
        $cookieName = $_SERVER['HTTP_HOST'] . ".setInvalidFilePath";
        $this->view->cookieName = $cookieName = str_replace(".", "_", $cookieName);
        
        $this->view->page = $page = $this->_getParam('page', 1);        
        
        $table = Engine_Api::_()->getItemtable('storage_file');
        $name = $table->info('name');
        $select = $table->select()
                ->order('file_id DESC');
        
        $paginator = Zend_Paginator::factory($select);
        $paginator->setCurrentPageNumber($page);
        $paginator->setItemCountPerPage(100);
        $this->view->paginator = $paginator;
    }
    
}