<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Calendar
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminBannerController.php 6590 2016-07-07 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Calendar_Form_Group_Create extends Engine_Form
{
    public function init()
    {
        $this
            ->setTitle('Create New Group')
            ->setAttrib('name', 'calendar_group_create');

        $this->addElement('Text', 'title', array(
            'label' => 'Group Name',
            'allowEmpty' => false,
            'required' => true,
            'validators' => array(
                array('NotEmpty', true),
                array('StringLength', false, array(1, 64)),
            ),
            'filters' => array(
                'StripTags',
                new Engine_Filter_Censor(),
            ),
        ));

        $this->addElement('File', 'photo', array(
            'label' => 'Calendar Group Photo',
            'accept' => 'image/*',
        ));
        $this->photo->addValidator('Extension', false, 'jpg,png,gif,jpeg');

        $this->addElement('Text', 'to', array(
            'label' => 'Add Existing Members',
            'required' => false
        ));

        $this->addElement('Text', 'non_members', array(
            'label' => 'Add Non-existing Members',
            'description' => "Please enter E-mail Addresses seperated by a comma(,). ",
            'required' => false,
        ));

        $this->addElement('Hidden', 'toValues', array(
          'label' => 'Added Members',
          'order' => 3,
        ));
        Engine_Form::addDefaultDecorators($this->toValues);

        // Buttons
        $this->addElement('Button', 'submit', array(
            'label' => 'Save Changes',
            'type' => 'submit',
            'ignore' => true,
            'decorators' => array(
                'ViewHelper',
            ),
        ));

    }
}