<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Calendar
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminBannerController.php 6590 2016-07-07 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Calendar_Form_Schedule_Import extends Engine_Form
{
    public $_error = array();

    public function init()
    {
        $this->setTitle('Import Schedule')
        ->setAttrib('enctype', 'multipart/form-data')
        ->setAttrib('class', 'global_form global_form_popup');

        $this->addElement('File', 'filename', array(
            'label' => 'File',
            'required' => true,
            'description' => 'Upload a .ics format file to import Schedules/Events.'
        ));
        $this->filename->addValidator('Extension', false, 'ics');
        $this->filename->getDecorator('Description')->setOption('placement', 'append');

        // Element: submit
        $this->addElement('Button', 'submit', array(
            'label' => 'Import',
            'type' => 'submit',
        ));

        $this->addElement('Cancel', 'cancel', array(
            'label' => 'cancel',
            'link' => true,
            'prependText' => ' or ',
            'onclick' => 'javascript:parent.Smoothbox.close()',
            'decorators' => array(
                'ViewHelper',
            ),
        ));

        $this->addDisplayGroup(array(
            'submit',
            'cancel',
        ), 'buttons', array(
            'decorators' => array(
                'FormElements',
                'DivDivDivWrapper'
            ),
        ));

    }
}