<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Blog
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 * @version    $Id: Blog.php 10072 2013-07-24 22:38:42Z john $
 * @author     Jung
 */

/**
 * @category   Application_Extensions
 * @package    Blog
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 */
class Calendar_Model_Calendar extends Core_Model_Item_Abstract
{

    /**
     * Gets an absolute URL to the page to view this item
     *
     * @return string
     */
    public function getHref($params = array())
    {
        $slug = $this->getSlug();

        $params = array_merge(array(
            'route' => 'calendar_entry_view',
            'reset' => true,
            'calendar_id' => $this->calendar_id,
        ), $params);
        $route = $params['route'];
        $reset = $params['reset'];
        unset($params['route']);
        unset($params['reset']);
        return Zend_Controller_Front::getInstance()->getRouter()
            ->assemble($params, $route, $reset);
    }

    public function claimStatus()
    {
        $viewer = Engine_Api::_()->user()->getViewer();
        $table = Engine_Api::_()->getItemTable('calendar_claim');
        $select = $table->select()
            ->where('calendar_id = ?', $this->getIdentity())
            ->where('user_id = ?', $viewer->getIdentity())
            ->order('claim_id ASC')
            ->limit(1);

        $claim = $table->fetchRow($select);
        if(!empty($claim->status)) {
            return $claim->status;
        }

        return;
    }

    public function isClaimable()
    {
        $viewer = Engine_Api::_()->user()->getViewer();
        $memberTable = Engine_Api::_()->getDbtable('groupmembers', 'calendar');
        $select = $memberTable->select()
                        ->where('user_email = ?', $viewer->email);

        $rows = $memberTable->fetchAll($select);
        $groups = array();
        foreach ($rows as $row) {
            $groups[] = $row->group_id;
        }

        $table = Engine_Api::_()->getDbtable('members', 'calendar');
        $select = $table->select()
                        ->where('user_email = ?', $viewer->email);

        if(!empty($groups)) {
            $select = $select->orwhere('group_id IN(?)', $groups);
        }
        $rows = $table->fetchAll($select);
        foreach ($rows as $row) {
            if($row->calendar_id == $this->getIdentity())
                return true;
        }

        return false;

    }

}