<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Calendar
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminBannerController.php 6590 2016-07-07 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Calendar_Model_DbTable_Groupmembers extends Core_Model_Item_DbTable_Abstract
{
    protected $_rowClass = "Calendar_Model_Groupmember";

    public function getAllMembers($group_id) {
        $select = $this->select()
                    ->where('group_id = ?', $group_id);

        return $this->fetchAll($select);
    }

    public function getUsers($title, $limit = 10, $group_id) {

    //MAKE QUERY
        $viewer = Engine_Api::_()->user()->getViewer();
        $table = Engine_Api::_()->getDbtable('users', 'user');
        $getAddedMembers = $this->getAllMembers($group_id);
        $data = array();
        foreach ($getAddedMembers as $member) {
        	$data[] = $member->user_email;
        }
        $select = $table->select()
                ->from($table->info('name'), array('user_id', 'displayname', 'photo_id', 'email'));
                
        $select->where($table->info('name') . ".displayname LIKE ? ", '%' . $title . '%')
        		->where('email NOT IN (?)', $data)
                ->where('enabled = ?', '1')
                ->where('user_id != ?', $viewer->getIdentity())
                ->where('verified = ?', '1')
                ->where('approved = ?', '1')
                ->order('displayname ASC')
                ->limit($limit);
        //FETCH RESULTS
        return $table->fetchAll($select);
    }
}