<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Calendar
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminBannerController.php 6590 2016-07-07 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Calendar_Model_DbTable_Groups extends Core_Model_Item_DbTable_Abstract
{
    protected $_rowClass = "Calendar_Model_Group";

    public function getAllGroups() {
    	$viewer = Engine_Api::_()->user()->getViewer();
        $select = $this->select()
                    ->where('owner_id = ?', $viewer->getIdentity());

        return $this->fetchAll($select);
    }

    public function getSearchGroups($title) {
        $viewer = Engine_Api::_()->user()->getViewer();
        $select = $this->select()
                	->where("title LIKE ? ", '%' . $title . '%')
                    ->where('owner_id = ?', $viewer->getIdentity());

        return $this->fetchAll($select);
    }

    public function getBrowseGroups() {
        $viewer = Engine_Api::_()->user()->getViewer();
        $table = Engine_Api::_()->getDbtable('groupmembers', 'calendar');
        $select = $table->select()
                        ->where('user_email = ?', $viewer->email);

        $rows = $table->fetchAll($select);
        $groups = array();
        foreach ($rows as $row) {
            $groups[] = $row->group_id;
        }
        if(empty($groups)){
            return;
        }
        $select = $this->select()
                    ->where('group_id IN(?)', $groups);

        return $this->fetchAll($select);
    }
}