<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Calendar
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminBannerController.php 6590 2016-07-07 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Calendar_Model_DbTable_Members extends Core_Model_Item_DbTable_Abstract
{
    protected $_rowClass = "Calendar_Model_Member";

    public function getCalendarMembers($calendar) {
      $calendar_id = $calendar->calendar_id;
      $select = $this->select()
                      ->where('calendar_id = ?', $calendar_id)
                      ->where('user_id != ?', $calendar->owner_id);

      $members = $this->fetchAll($select);
      $userTable = Engine_Api::_()->getDbtable('users', 'user');
      $groupTable = Engine_Api::_()->getDbtable('groups', 'calendar');
      $existUsers = array();
      $users = array();
      foreach ($members as $member) {
        if($member->group_id == 0) {
          $select = $userTable->select()
                            ->where('email = ? ', $member->user_email);
          $user = $userTable->fetchRow($select);

          if(!empty($user->email)) {
           $existUsers[] = array(
              'id' => $user->user_id,
              'guid' => $user->user_id."1111",
              'label' => $user->displayname,
              'email' => $user->email
            );
          } else {
            $users[] = $member->user_email;
          }
        } else {
          $select = $groupTable->select()
                            ->where('group_id = ?', $member->group_id);
          $group = $groupTable->fetchRow($select);
          $existUsers[] = array(
              'id' => $group->group_id."_group",
              'guid' => $group->group_id."0000",
              'label' => $group->title." (Group)"
            );
        }
      }

      $data = array();
      $data['exist'] = $existUsers;
      $data['users'] = $users;
      return $data;
    }

    public function deleteCalendarMembers($calendar_id, $data, $user=false) {
      $select = $this->select()
                     ->where('calendar_id = ?', $calendar_id);

      if($user) {
        $select->where('user_email = ?', $data);
      } else {
        $select->where('group_id = ?', $data);
      }

      $members = $this->fetchAll($select);

       foreach( $members as $member ) {
          $list = Engine_Api::_()->getItem('calendar_member', $member->member_id);
          $list->delete();
      }
    }

    public function getMembers($calendar_id) {
      $select = $this->select()
                      ->where('calendar_id = ?', $calendar_id);

      return $this->fetchAll($select);
    }
}