<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Calendar
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminBannerController.php 6590 2016-07-07 00:00:00Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */

class Calendar_Plugin_Core extends Zend_Controller_Plugin_Abstract
{

    public function onUserDeleteBefore($event)
    {
            $payload = $event->getPayload();
            if( $payload instanceof User_Model_User ) {
                // Delete calendars
                $calendarTable = Engine_Api::_()->getDbtable('calendars', 'calendar');
                $memberTable = Engine_Api::_()->getDbtable('members', 'calendar');
                $ownerTable = Engine_Api::_()->getDbtable('owners', 'calendar');
                $calendarSelect = $calendarTable->select()->where('owner_id = ?', $payload->getIdentity());
                foreach( $calendarTable->fetchAll($calendarSelect) as $calendar ) {
                        $memberSelect = $memberTable->select()->where('calendar_id = ?', $calendar->calendar_id);
                        foreach( $memberTable->fetchAll($memberSelect) as $member ) {
                            $member->delete();
                        }

                        $ownerSelect = $ownerTable->select()->where('calendar_id = ?', $calendar->calendar_id);
                        foreach( $ownerTable->fetchAll($ownerSelect) as $owner ) {
                            $owner->delete();
                        }
                    $calendar->delete();
                }

                // Delete from calendar members
                $memberSelect = $memberTable->select()->where('user_email = ?', $payload->email);
                foreach( $memberTable->fetchAll($memberSelect) as $member ) {
                    $member->delete();
                }

                // Delete from calendar owners
                $ownerSelect = $ownerTable->select()->where('user_id = ?', $payload->getIdentity());
                foreach( $ownerTable->fetchAll($ownerSelect) as $owner ) {
                    $owner->delete();
                }

                // Delete claims
                $claimTable = Engine_Api::_()->getDbtable('claims', 'calendar');
                $claimSelect = $claimTable->select()->where('user_id = ?', $payload->getIdentity());
                foreach( $claimTable->fetchAll($claimSelect) as $claim ) {
                    $claim->delete();
                }

                // Delete from group members
                $groupmemberTable = Engine_Api::_()->getDbtable('groupmembers', 'calendar');
                $groupmemberSelect = $groupmemberTable->select()->where('user_email = ?', $payload->email);
                foreach( $groupmemberTable->fetchAll($groupmemberSelect) as $groupmember ) {
                    $groupmember->delete();
                }

                // Delete groups
                $groupTable = Engine_Api::_()->getDbtable('groups', 'calendar');
                $groupSelect = $groupTable->select()->where('owner_id = ?', $payload->getIdentity());
                foreach( $groupTable->fetchAll($groupSelect) as $group ) {
                    $groupmemberSelect = $groupmemberTable->select()->where('group_id = ?', $group->group_id);
                    // delete group members too
                    foreach( $groupmemberTable->fetchAll($groupmemberSelect) as $groupmember ) {
                        $groupmember->delete();
                    }
                    $group->delete();
                }

                // Delete schedules
                $scheduleTable = Engine_Api::_()->getDbtable('schedules', 'calendar');
                $scheduleSelect = $scheduleTable->select()->where('owner_id = ?', $payload->getIdentity());
                foreach( $scheduleTable->fetchAll($scheduleSelect) as $schedule ) {
                    $schedule->delete();
                }
            }
    }
}
?>