<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Calendar
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminBannerController.php 6590 2016-07-07 00:00:00Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */

class Calendar_Plugin_Menus
{
  public function canCreateCalendars()
  {
    // Must be logged in
    $viewer = Engine_Api::_()->user()->getViewer();
    if( !$viewer || !$viewer->getIdentity() ) {
      return false;
    }

    // Must be able to create blogs
    if( !Engine_Api::_()->authorization()->isAllowed('calendar', $viewer, 'create') ) {
      return false;
    }

    return true;
  }

  public function canViewCalendars()
  {
    // Must be logged in
    $viewer = Engine_Api::_()->user()->getViewer();
    if( !$viewer || !$viewer->getIdentity() ) {
      return false;
    }

    // Must be able to view calendar
    if( !Engine_Api::_()->authorization()->isAllowed('calendar', $viewer, 'view') ) {
      return false;
    }

    return true;
  }

  public function canClaimCalendars()
  {
    // Must be logged in
    $viewer = Engine_Api::_()->user()->getViewer();
    if( !$viewer || !$viewer->getIdentity() ) {
      return false;
    }

    // Must be able to view calendar
    if( !Engine_Api::_()->authorization()->isAllowed('calendar', $viewer, 'view') ) {
      return false;
    }

    // Must be able to claim calendar
    if( !Engine_Api::_()->authorization()->isAllowed('calendar', $viewer, 'claim') ) {
      return false;
    }

    return true;
  }

  public function canViewSchedules()
  {
    // Must be logged in
    $viewer = Engine_Api::_()->user()->getViewer();
    if( !$viewer || !$viewer->getIdentity() ) {
      return false;
    }

    return true;
  }  
}