<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Communityadsponsored
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Install.php 2011-12-19 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Communityadsponsored_Installer extends Engine_Package_Installer_Module {

  function onPreInstall() {

    $getErrorMsg = $this->getVersion(); 
    if (!empty($getErrorMsg)) {
      return $this->_error($getErrorMsg);
    }
    parent::onPreInstall();
  }

  function onInstall() {

    $db = $this->getDb();

    $select = new Zend_Db_Select($db);
    $select
      ->from('engine4_core_modules')
      ->where('name = ?', 'communityad');
    $modules_version = $select->query()->fetchObject();
    // "Communityad Ads Plugin" should be Installed.
    if (!empty($modules_version)) {
      // "Communityad Ads Plugin" should be enabled.
      if( !empty($modules_version->enabled) ) {
	 // "Communityad Ads Plugin" version should be > 4.1.8p1.
	if( $modules_version->version > '4.1.8' ) {
	  $table_exist = $db->query("SHOW TABLES LIKE 'engine4_communityad_adtype'")->fetch();
	  if( !empty($table_exist) ) {
	    $is_sponsoredStoryAvailable = $db->query("SELECT * FROM  `engine4_communityad_adtype` WHERE  `type` LIKE  'sponsored_stories' LIMIT 1;")->fetch();
	    if( empty($is_sponsoredStoryAvailable) ) {
	      $db->query("INSERT IGNORE INTO `engine4_communityad_adtype` (`type`, `title`, `status`)VALUES ('sponsored_stories', 'Sponsored Stories', '1')");
	    }
	  }else {
	    $db->query("
	    CREATE TABLE IF NOT EXISTS  `engine4_communityad_adtype` (
	    `adtype_id` INT NOT NULL AUTO_INCREMENT PRIMARY KEY ,
	    `type` VARCHAR( 255 ) NOT NULL ,
	    `title` VARCHAR( 255 ) NOT NULL ,
	    `status` INT NOT NULL
	    ) ENGINE = InnoDB CHARSET=utf8 COLLATE utf8_unicode_ci;
	    ");
	    $db->query("INSERT IGNORE INTO `engine4_communityad_adtype` (`type`, `title`, `status`)VALUES ('sponsored_stories', 'Sponsored Stories', '1')");
	  }
	}else {
	  $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();
	  return $this->_error("<span style='color:red'>Note: You have  not upgrade the latest version 4.1.8p1 of Advertisements / Community Ads Plugin on your site yet. Please upgrade it first before installing the Advertisements / Community Ads - Sponsored Stories Extension.</span><br/> <a href='" . $base_url . "/manage'>Click here</a> to go Manage Packages");
	}

      }else {
	$base_url = Zend_Controller_Front::getInstance()->getBaseUrl();
	return $this->_error("<span style='color:red'>Note: You have installed the Advertisements / Community Ads Plugin but not enabled it on your site yet. Please enabled it first before installing the Advertisements / Community Ads - Sponsored Stories Extension.</span><br/> <a href='" . $base_url . "/manage'>Click here</a> to activate the Page Plugin.");
      }
    }else {
      $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();
      return $this->_error("<span style='color:red'>Note: You have not installed the Advertisements / Community Ads Plugin on your site yet. Please install it first before installing the Advertisements / Community Ads - Sponsored Stories Extension.</span><br/> <a href='" . $base_url . "/manage'>Click here</a> to go Manage Packages.");
    }
    
    $this->_addUserHomeContent();
    parent::onInstall();
  }

  protected function _addUserHomeContent(){
    // install content areas
    
    $db     = $this->getDb();
    $select = new Zend_Db_Select($db);

    $select
      ->from('engine4_core_pages')
      ->where('name = ?', 'user_index_home')
      ->limit(1);
    $page_id = $select->query()->fetchObject()->page_id;


    
    // Check if it's already been placed
    $select = new Zend_Db_Select($db);
    $select
      ->from('engine4_core_content')
      ->where('page_id = ?', $page_id)
      ->where('type = ?', 'widget')
      ->where('name = ?', 'communityad.sponsored-stories')
      ;
    $info = $select->query()->fetch();
    if( empty($info) ) {
      // right_id (will always be there)
      $select = new Zend_Db_Select($db);
      $select
        ->from('engine4_core_content')              
        ->where('page_id = ?', $page_id)
        ->where('type = ?', 'container')
        ->where('name = ?', 'right')
        ->limit(1);
      $right_id = $select->query()->fetchObject()->content_id;
      if ($right_id) {
        $db->insert('engine4_core_content', array(
            'page_id' => $page_id,
            'type' => 'widget',
            'name' => 'communityad.sponsored-stories',
            'parent_content_id' => ($right_id),
            'order' => 999,
        ));
      }
    }
  }

  public function onEnable() {

    $db = $this->getDb();
    $db->query("UPDATE `engine4_communityad_adtype` SET `status` = '1' WHERE `engine4_communityad_adtype`.`type` = 'sponsored_stories' LIMIT 1 ;");
    
    parent::onEnable();
  }

  public function onDisable() {
  
    $db = $this->getDb();
    $db->query("UPDATE `engine4_communityad_adtype` SET `status` = '0' WHERE `engine4_communityad_adtype`.`type` = 'sponsored_stories' LIMIT 1 ;");
    parent::onDisable();
  }

  public function onPostInstall() {

    $db = $this->getDb();
		$select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'sitemobile')
            ->where('enabled = ?', 1);
    $is_sitemobile_object = $select->query()->fetchObject();
    if(!empty($is_sitemobile_object)) {
			$db->query("INSERT IGNORE INTO `engine4_sitemobile_modules` (`name`, `visibility`) VALUES ('communityadsponsored','1')");
			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_sitemobile_modules')
							->where('name = ?', 'communityadsponsored')
							->where('integrated = ?', 0);
			$is_sitemobile_object = $select->query()->fetchObject();
      if($is_sitemobile_object)  {
				$actionName = Zend_Controller_Front::getInstance()->getRequest()->getActionName();
				$controllerName = Zend_Controller_Front::getInstance()->getRequest()->getControllerName();
				if($controllerName == 'manage' && $actionName == 'install') {
          $view = new Zend_View();
					$baseUrl = ( !empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://':'http://') .  $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
					$redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
					$redirector->gotoUrl($baseUrl . 'admin/sitemobile/module/enable-mobile/enable_mobile/1/name/communityadsponsored/integrated/0/redirect/install');
				} 
      } 
    }
  }

  private function getVersion() {
  
    $db = $this->getDb();

    $errorMsg = '';
    $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();

    $modArray = array(
      'sitemobile' => '4.6.0p4',
    );
    
    $finalModules = array();
    foreach ($modArray as $key => $value) {
    		$select = new Zend_Db_Select($db);
		$select->from('engine4_core_modules')
					->where('name = ?', "$key")
					->where('enabled = ?', 1);
		$isModEnabled = $select->query()->fetchObject();
			if (!empty($isModEnabled)) {
				$select = new Zend_Db_Select($db);
				$select->from('engine4_core_modules',array('title', 'version'))
					->where('name = ?', "$key")
					->where('enabled = ?', 1);
				$getModVersion = $select->query()->fetchObject();

				$isModSupport = $this->checkVersion($getModVersion->version, $value);
				if (empty($isModSupport)) {
					$finalModules[] = $getModVersion->title;
				}
			}
    }

    foreach ($finalModules as $modArray) {
      $errorMsg .= '<div class="tip"><span style="background-color: #da5252;color:#FFFFFF;">Note: You do not have the latest version of the "' . $modArray . '". Please upgrade "' . $modArray . '" on your website to the latest version available in your SocialEngineAddOns Client Area to enable its integration with "Mobile / Tablet Plugin".<br/> Please <a class="" href="' . $base_url . '/manage">Click here</a> to go Manage Packages.</span></div>';
    }

    return $errorMsg;
  }
  
    private function checkVersion($databaseVersion, $checkDependancyVersion) {
        $f = $databaseVersion;
        $s = $checkDependancyVersion;
        if (strcasecmp($f, $s) == 0)
            return -1;

        $fArr = explode(".", $f);
        $sArr = explode('.', $s);
        if (count($fArr) <= count($sArr))
            $count = count($fArr);
        else
            $count = count($sArr);

        for ($i = 0; $i < $count; $i++) {
            $fValue = $fArr[$i];
            $sValue = $sArr[$i];
            if (is_numeric($fValue) && is_numeric($sValue)) {
                if ($fValue > $sValue)
                    return 1;
                elseif ($fValue < $sValue)
                    return 0;
                else {
                    if (($i + 1) == $count) {
                        return -1;
                    } else
                        continue;
                }
            }
            elseif (is_string($fValue) && is_numeric($sValue)) {
                $fsArr = explode("p", $fValue);

                if ($fsArr[0] > $sValue)
                    return 1;
                elseif ($fsArr[0] < $sValue)
                    return 0;
                else {
                    return 1;
                }
            } elseif (is_numeric($fValue) && is_string($sValue)) {
                $ssArr = explode("p", $sValue);

                if ($fValue > $ssArr[0])
                    return 1;
                elseif ($fValue < $ssArr[0])
                    return 0;
                else {
                    return 0;
                }
            } elseif (is_string($fValue) && is_string($sValue)) {
                $fsArr = explode("p", $fValue);
                $ssArr = explode("p", $sValue);
                if ($fsArr[0] > $ssArr[0])
                    return 1;
                elseif ($fsArr[0] < $ssArr[0])
                    return 0;
                else {
                    if ($fsArr[1] > $ssArr[1])
                        return 1;
                    elseif ($fsArr[1] < $ssArr[1])
                        return 0;
                    else {
                        return -1;
                    }
                }
            }
        }
    }  
}