<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Document
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Settemplate.php 2016-07-12 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Document_Api_Settemplate extends Core_Api_Abstract {

    public function checkPageId($name = false) {

        if (!$name)
            return false;

        $db = Engine_Db_Table::getDefaultAdapter();
        $select = new Zend_Db_Select($db);
        $page_id = $select
                        ->from('engine4_core_pages', 'page_id')
                        ->where('name = ?', $name)
                        ->query()->fetchColumn();

        return $page_id;
    }

    public function deletePageAndContent($page_id) {

        $db = Engine_Db_Table::getDefaultAdapter();
        $db->query("DELETE FROM `engine4_core_pages` WHERE `engine4_core_pages`.`page_id` = $page_id");
        $db->query("DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`page_id` = $page_id");
    }

    public function documentHome($reset) {

        $db = Engine_Db_Table::getDefaultAdapter();
        $page_id = $this->checkPageId('document_index_home');
        if ($page_id && $reset) {
            $this->deletePageAndContent($page_id);
            $page_id = false;
        }

        if (empty($page_id)) {
            //CREATE PAGE IF NOT EXIST
            $db->insert('engine4_core_pages', array(
                'name' => 'document_index_home',
                'displayname' => 'Documents - Documents Home Page',
                'title' => 'Documents Home Page',
                'description' => 'This is the document home page.',
                'custom' => 0
            ));
            $page_id = $db->lastInsertId('engine4_core_pages');

            //MAIN CONTAINER
            $db->insert('engine4_core_content', array(
                'page_id' => $page_id,
                'type' => 'container',
                'name' => 'main',
                'parent_content_id' => null,
                'order' => 2,
                'params' => '',
            ));
            $main_container_id = $db->lastInsertId('engine4_core_content');

            //MAIN MIDDLE CONTAINER
            $db->insert('engine4_core_content', array(
                'page_id' => $page_id,
                'type' => 'container',
                'name' => 'middle',
                'parent_content_id' => $main_container_id,
                'order' => 6,
                'params' => '',
            ));
            $main_middle_container_id = $db->lastInsertId('engine4_core_content');

            //MAIN NAVIGATION WIDGET
            $db->insert('engine4_core_content', array(
                'page_id' => $page_id,
                'type' => 'widget',
                'name' => 'document.navigation-documents',
                'parent_content_id' => $main_middle_container_id,
                'order' => 3,
                'params' => '',
            ));

            $db->insert('engine4_core_content', array(
                'page_id' => $page_id,
                'type' => 'widget',
                'name' => 'document.categories-withicon-grid-view',
                'parent_content_id' => $main_middle_container_id,
                'order' => 4,
                'params' => '{"title":"","titleCount":true,"orderBy":"cat_order","showAllCategories":"1","columnWidth":"222","columnHeight":"205","showIcon":"1","nomobile":"0","name":"document.categories-withicon-grid-view"}',
            ));

            $db->insert('engine4_core_content', array(
                'page_id' => $page_id,
                'type' => 'widget',
                'name' => 'document.ajax-home-documents',
                'parent_content_id' => $main_middle_container_id,
                'order' => 5,
                'params' => '{"title":"Featured Documents","titleCount":"","layoutsViews":["2"],"layoutsOrder":"2","layoutsTabs":["4"],"recentOrder":"","popularOrder":"","randomOrder":"","featuredOrder":"","sponosredOrder":"","listLimit":"10","gridLimit":"10","documentOption":["title","owner","featured","sponsored","view","like","comment","rating","likeButton","facebook","twitter","linkedin","googleplus"],"columnWidth":"210","columnHeight":"345","descriptionListTruncation":"225","category_id":"0","documentType":"0","nomobile":"0","name":"document.ajax-home-documents"}',
            ));

            $db->insert('engine4_core_content', array(
                'page_id' => $page_id,
                'type' => 'widget',
                'name' => 'document.categories-grid-view-documents',
                'parent_content_id' => $main_middle_container_id,
                'order' => 6,
                'params' => '{"title":"Arts & Culture","titleCount":true,"category_id":"1","documentType":"0","columnWidth":"210","columnHeight":"280","documentOption":["title","owner","featured","sponsored","view","like","comment","rating","likeButton","facebook","twitter","linkedin","googleplus"],"truncation":"10","nomobile":"0","name":"document.categories-grid-view-documents"}',
            ));


            $db->insert('engine4_core_content', array(
                'page_id' => $page_id,
                'type' => 'widget',
                'name' => 'document.categories-grid-view-documents',
                'parent_content_id' => $main_middle_container_id,
                'order' => 7,
                'params' => '{"title":"Health ","titleCount":true,"category_id":"46","documentType":"0","columnWidth":"210","columnHeight":"280","documentOption":["title","owner","featured","sponsored","view","like","comment","rating","likeButton","facebook","twitter","linkedin","googleplus"],"truncation":"10","nomobile":"0","name":"document.categories-grid-view-documents"}',
            ));

            $db->insert('engine4_core_content', array(
                'page_id' => $page_id,
                'type' => 'widget',
                'name' => 'document.categories-grid-view-documents',
                'parent_content_id' => $main_middle_container_id,
                'order' => 8,
                'params' => '{"title":"Recreation","titleCount":true,"category_id":"47","documentType":"0","columnWidth":"210","columnHeight":"280","documentOption":["title","owner","featured","sponsored","view","like","comment","rating","likeButton","facebook","twitter","linkedin","googleplus"],"truncation":"10","nomobile":"0","name":"document.categories-grid-view-documents"}',
            ));
        }
    }

    public function documentBrowse($reset) {
        $db = Engine_Db_Table::getDefaultAdapter();
        $page_id = $this->checkPageId('document_index_browse');
        if ($page_id && $reset) {
            $this->deletePageAndContent($page_id);
            $page_id = false;
        }
        $contentTable = Engine_Api::_()->getDbtable('content', 'core');
        $pageTable = Engine_Api::_()->getDbtable('pages', 'core');

        if (empty($page_id)) {
            $pageCreate = $pageTable->createRow();
            $pageCreate->name = 'document_index_browse';
            $pageCreate->displayname = 'Documents - Documents Browse Page';
            $pageCreate->title = 'Documents Browse Page';
            $pageCreate->description = 'This is the document browse page.';
            $pageCreate->custom = 0;
            $pageCreate->save();
            $page_id = $pageCreate->page_id;

            // Insert Top Container.
            $topContainer = $contentTable->createRow();
            $topContainer->page_id = $page_id;
            $topContainer->type = 'container';
            $topContainer->name = 'top';
            $topContainer->order = 1;
            $topContainer->save();

            // Insert Top-Middle Container.
            $topMiddleContainer = $contentTable->createRow();
            $topMiddleContainer->page_id = $page_id;
            $topMiddleContainer->type = 'container';
            $topMiddleContainer->name = 'middle';
            $topMiddleContainer->parent_content_id = $topContainer->content_id;
            $topMiddleContainer->order = 6;
            $topMiddleContainer->save();

            // Insert widgets: In Top-Middle Container.
            $topMiddleWidgets = $contentTable->createRow();
            $topMiddleWidgets->page_id = $page_id;
            $topMiddleWidgets->type = 'widget';
            $topMiddleWidgets->name = 'document.navigation-documents';
            $topMiddleWidgets->parent_content_id = $topMiddleContainer->content_id;
            $topMiddleWidgets->order = 1;
            $topMiddleWidgets->params = '{"title":"","titleCount":"true"}';
            $topMiddleWidgets->save();

            $topMiddleWidgets = $contentTable->createRow();
            $topMiddleWidgets->page_id = $page_id;
            $topMiddleWidgets->type = 'widget';
            $topMiddleWidgets->name = 'document.featured-documents';
            $topMiddleWidgets->parent_content_id = $topMiddleContainer->content_id;
            $topMiddleWidgets->order = 3;
            $topMiddleWidgets->params = '{"title":"Featured Documents","titleCount":true,"category_id":"0","documentType":"0","columnWidth":"190","documentOption":["title","owner","featured","sponsored","view","like","comment","rating","likeButton","facebook","twitter","linkedin","googleplus"],"itemCount":"20","nomobile":"0","name":"document.featured-documents"}';
            $topMiddleWidgets->save();

            // Insert Main Container.
            $mainContainer = $contentTable->createRow();
            $mainContainer->page_id = $page_id;
            $mainContainer->type = 'container';
            $mainContainer->name = 'main';
            $mainContainer->order = 2;
            $mainContainer->save();

            // Insert Main-Right Container.
            $mainRightContainer = $contentTable->createRow();
            $mainRightContainer->page_id = $page_id;
            $mainRightContainer->type = 'container';
            $mainRightContainer->name = 'right';
            $mainRightContainer->parent_content_id = $mainContainer->content_id;
            $mainRightContainer->order = 5;
            $mainRightContainer->save();

            // Insert widgets: In Main Container.
            $topRightWidgets_1 = $contentTable->createRow();
            $topRightWidgets_1->page_id = $page_id;
            $topRightWidgets_1->type = 'widget';
            $topRightWidgets_1->name = 'document.create-documents';
            $topRightWidgets_1->parent_content_id = $mainRightContainer->content_id;
            $topRightWidgets_1->order = 1;
            $topRightWidgets_1->params = '';
            $topRightWidgets_1->save();

            // Insert widgets: In Main Container.
            $topRightWidgets_1 = $contentTable->createRow();
            $topRightWidgets_1->page_id = $page_id;
            $topRightWidgets_1->type = 'widget';
            $topRightWidgets_1->name = 'document.sidebar-categories-documents';
            $topRightWidgets_1->parent_content_id = $mainRightContainer->content_id;
            $topRightWidgets_1->order = 2;
            $topRightWidgets_1->params = '{"title":"Categories","titleCount":"true"}';
            $topRightWidgets_1->save();


            $topRightWidgets_1 = $contentTable->createRow();
            $topRightWidgets_1->page_id = $page_id;
            $topRightWidgets_1->type = 'widget';
            $topRightWidgets_1->name = 'document.search-documents';
            $topRightWidgets_1->parent_content_id = $mainRightContainer->content_id;
            $topRightWidgets_1->order = 3;
            $topMiddleWidgets->params = '{"viewType":"vertical","showAllCategories":"1","title":"","nomobile":"0","name":"document.search-documents"}';
            $topRightWidgets_1->save();

            // Insert widgets: In Main Container.
            $topRightWidgets_2 = $contentTable->createRow();
            $topRightWidgets_2->page_id = $page_id;
            $topRightWidgets_2->type = 'widget';
            $topRightWidgets_2->name = 'document.tagcloud-documents';
            $topRightWidgets_2->parent_content_id = $mainRightContainer->content_id;
            $topRightWidgets_2->order = 4 ;
            $topRightWidgets_2->params = '{"title":"","titleCount":true,"orderingType":"1","itemCount":"10","loaded_by_ajax":"1","nomobile":"0","name":"document.tagcloud-documents"}';
            $topRightWidgets_2->save();

            // Insert Main-Middle Container.
            $mainMiddleContainer = $contentTable->createRow();
            $mainMiddleContainer->page_id = $page_id;
            $mainMiddleContainer->type = 'container';
            $mainMiddleContainer->name = 'middle';
            $mainMiddleContainer->parent_content_id = $mainContainer->content_id;
            $mainMiddleContainer->order = 6;
            $mainMiddleContainer->save();

            // Insert widgets: In Main Container.
            $topRightWidgets_2 = $contentTable->createRow();
            $topRightWidgets_2->page_id = $page_id;
            $topRightWidgets_2->type = 'widget';
            $topRightWidgets_2->name = 'document.browse-documents';
            $topRightWidgets_2->parent_content_id = $mainMiddleContainer->content_id;
            $topRightWidgets_2->order = 3;
            $topRightWidgets_2->params = '{"title":"","titleCount":true,"orderby":"fespfe","documentType":"0","layoutsViews":["1","2"],"layoutsOrder":"2","documentOption":["title","owner","featured","sponsored","view","like","comment","rating","likeButton","facebook","twitter","linkedin","googleplus"],"show_content":"2","columnWidth":"205","columnHeight":"335","itemCount":"12","truncation":"23","descriptionTruncation":"225","nomobile":"0","name":"document.browse-documents"}';
            $topRightWidgets_2->save();
        }
    }

    public function documentManage($reset) {
        $db = Engine_Db_Table::getDefaultAdapter();
        $page_id = $this->checkPageId('document_index_manage');
        if ($page_id && $reset) {
            $this->deletePageAndContent($page_id);
            $page_id = false;
        }
        $contentTable = Engine_Api::_()->getDbtable('content', 'core');
        $pageTable = Engine_Api::_()->getDbtable('pages', 'core');

        if (empty($page_id)) {
            $pageCreate = $pageTable->createRow();
            $pageCreate->name = 'document_index_manage';
            $pageCreate->displayname = 'Documents - Documents Manage Page';
            $pageCreate->title = 'Documents Manage Page';
            $pageCreate->description = 'This is the document manage page.';
            $pageCreate->custom = 0;
            $pageCreate->save();
            $page_id = $pageCreate->page_id;

            // Insert Top Container.
            $topContainer = $contentTable->createRow();
            $topContainer->page_id = $page_id;
            $topContainer->type = 'container';
            $topContainer->name = 'top';
            $topContainer->order = 1;
            $topContainer->save();

            // Insert Top-Middle Container.
            $topMiddleContainer = $contentTable->createRow();
            $topMiddleContainer->page_id = $page_id;
            $topMiddleContainer->type = 'container';
            $topMiddleContainer->name = 'middle';
            $topMiddleContainer->parent_content_id = $topContainer->content_id;
            $topMiddleContainer->order = 6;
            $topMiddleContainer->save();

            // Insert widgets: In Top-Middle Container.
            $topMiddleWidgets = $contentTable->createRow();
            $topMiddleWidgets->page_id = $page_id;
            $topMiddleWidgets->type = 'widget';
            $topMiddleWidgets->name = 'document.navigation-documents';
            $topMiddleWidgets->parent_content_id = $topMiddleContainer->content_id;
            $topMiddleWidgets->order = 1;
            $topMiddleWidgets->params = '{"title":"","titleCount":"true"}';
            $topMiddleWidgets->save();

            // Insert Main Container.
            $mainContainer = $contentTable->createRow();
            $mainContainer->page_id = $page_id;
            $mainContainer->type = 'container';
            $mainContainer->name = 'main';
            $mainContainer->order = 2;
            $mainContainer->save();

            // Insert Main-Right Container.
            $mainRightContainer = $contentTable->createRow();
            $mainRightContainer->page_id = $page_id;
            $mainRightContainer->type = 'container';
            $mainRightContainer->name = 'right';
            $mainRightContainer->parent_content_id = $mainContainer->content_id;
            $mainRightContainer->order = 5;
            $mainRightContainer->save();

            // Insert widgets: In Main Container.
            $topRightWidgets_1 = $contentTable->createRow();
            $topRightWidgets_1->page_id = $page_id;
            $topRightWidgets_1->type = 'widget';
            $topRightWidgets_1->name = 'document.create-documents';
            $topRightWidgets_1->parent_content_id = $mainRightContainer->content_id;
            $topRightWidgets_1->order = 1;
            $topRightWidgets_1->params = '{"title":"","titleCount":"true"}';
            $topRightWidgets_1->save();

            // Insert widgets: In Main Container.
            $topRightWidgets_1 = $contentTable->createRow();
            $topRightWidgets_1->page_id = $page_id;
            $topRightWidgets_1->type = 'widget';
            $topRightWidgets_1->name = 'document.search-documents';
            $topRightWidgets_1->parent_content_id = $mainRightContainer->content_id;
            $topRightWidgets_1->order = 2;
            $topRightWidgets_1->params = '{"title":"Search Documents","name":"document.search-documents"}';
            $topRightWidgets_1->save();

            // Insert widgets: In Main Container.
            $topRightWidgets_2 = $contentTable->createRow();
            $topRightWidgets_2->page_id = $page_id;
            $topRightWidgets_2->type = 'widget';
            $topRightWidgets_2->name = 'document.document-owner-documents';
            $topRightWidgets_2->parent_content_id = $mainRightContainer->content_id;
            $topRightWidgets_2->order = 3;
            $topRightWidgets_2->params = '{"title":"","documentOption":["title","owner","featured","sponsored","view","like","comment","rating","likeButton","facebook","twitter","linkedin","googleplus"],"columnWidth":"210","columnHeight":"340","itemCount":"2","category_id":"0","documentType":"0","truncation":"10","nomobile":"0","name":"document.document-owner-documents"}';
            $topRightWidgets_2->save();


            // Insert Main-Middle Container.
            $mainMiddleContainer = $contentTable->createRow();
            $mainMiddleContainer->page_id = $page_id;
            $mainMiddleContainer->type = 'container';
            $mainMiddleContainer->name = 'middle';
            $mainMiddleContainer->parent_content_id = $mainContainer->content_id;
            $mainMiddleContainer->order = 6;
            $mainMiddleContainer->save();

            // Insert widgets: In Main Container.
            $topRightWidgets_2 = $contentTable->createRow();
            $topRightWidgets_2->page_id = $page_id;
            $topRightWidgets_2->type = 'widget';
            $topRightWidgets_2->name = 'document.manage-documents';
            $topRightWidgets_2->parent_content_id = $mainMiddleContainer->content_id;
            $topRightWidgets_2->order = 3;
            $topRightWidgets_2->params = '{"title":"","titleCount":true,"layoutsViews":["1","2"],"layoutsOrder":"2","columnWidth":"205","columnHeight":"355","documentOption":["title","owner","featured","sponsored","view","like","comment","rating","likeButton","facebook","twitter","linkedin","googleplus"],"show_content":"2","truncation":"80","descriptionTruncation":"225","itemCount":"12","nomobile":"0","name":"document.manage-documents"}';
            $topRightWidgets_2->save();
        }
    }

    public function documentCreation($reset) {
        $db = Engine_Db_Table::getDefaultAdapter();
        $page_id = $this->checkPageId('document_index_create');
        if ($page_id && $reset) {
            $this->deletePageAndContent($page_id);
            $page_id = false;
        }

        $contentTable = Engine_Api::_()->getDbtable('content', 'core');
        $pageTable = Engine_Api::_()->getDbtable('pages', 'core');

        if (empty($page_id)) {
            $pageCreate = $pageTable->createRow();
            $pageCreate->name = 'document_index_create';
            $pageCreate->displayname = 'Documents - Documents Upload Page';
            $pageCreate->title = 'Documents Upload Page';
            $pageCreate->description = 'This is the document upload page.';
            $pageCreate->custom = 0;
            $pageCreate->save();
            $page_id = $pageCreate->page_id;

            // Insert Top Container.
            $topContainer = $contentTable->createRow();
            $topContainer->page_id = $page_id;
            $topContainer->type = 'container';
            $topContainer->name = 'top';
            $topContainer->order = 1;
            $topContainer->save();

            // Insert Top-Middle Container.
            $topMiddleContainer = $contentTable->createRow();
            $topMiddleContainer->page_id = $page_id;
            $topMiddleContainer->type = 'container';
            $topMiddleContainer->name = 'middle';
            $topMiddleContainer->parent_content_id = $topContainer->content_id;
            $topMiddleContainer->order = 6;
            $topMiddleContainer->save();

            // Insert widgets: In Top-Middle Container.
            $topMiddleWidgets = $contentTable->createRow();
            $topMiddleWidgets->page_id = $page_id;
            $topMiddleWidgets->type = 'widget';
            $topMiddleWidgets->name = 'document.navigation-documents';
            $topMiddleWidgets->parent_content_id = $topMiddleContainer->content_id;
            $topMiddleWidgets->order = 1;
            $topMiddleWidgets->params = '{"title":"","titleCount":"true"}';
            $topMiddleWidgets->save();

            // Insert Main Container.
            $mainContainer = $contentTable->createRow();
            $mainContainer->page_id = $page_id;
            $mainContainer->type = 'container';
            $mainContainer->name = 'main';
            $mainContainer->order = 2;
            $mainContainer->save();

            // Insert Main-Middle Container.
            $mainMiddleContainer = $contentTable->createRow();
            $mainMiddleContainer->page_id = $page_id;
            $mainMiddleContainer->type = 'container';
            $mainMiddleContainer->name = 'middle';
            $mainMiddleContainer->parent_content_id = $mainContainer->content_id;
            $mainMiddleContainer->order = 6;
            $mainMiddleContainer->save();

            // Insert widgets: In Top-Middle Container.
            $topMiddleWidgets = $contentTable->createRow();
            $topMiddleWidgets->page_id = $page_id;
            $topMiddleWidgets->type = 'widget';
            $topMiddleWidgets->name = 'core.content';
            $topMiddleWidgets->parent_content_id = $mainMiddleContainer->content_id;
            $topMiddleWidgets->order = 2;
            $topMiddleWidgets->params = '{"title":"","titleCount":"true"}';
            $topMiddleWidgets->save();
        }
    }

    public function documentEdit($reset) {
        $db = Engine_Db_Table::getDefaultAdapter();
        $page_id = $this->checkPageId('document_index_edit');
        if ($page_id && $reset) {
            $this->deletePageAndContent($page_id);
            $page_id = false;
        }

        $contentTable = Engine_Api::_()->getDbtable('content', 'core');
        $pageTable = Engine_Api::_()->getDbtable('pages', 'core');

        if (empty($page_id)) {
            $pageCreate = $pageTable->createRow();
            $pageCreate->name = 'document_index_edit';
            $pageCreate->displayname = 'Documents - Documents Edit Page';
            $pageCreate->title = 'Documents Edit Page';
            $pageCreate->description = 'This is the document edit page.';
            $pageCreate->custom = 0;
            $pageCreate->save();
            $page_id = $pageCreate->page_id;

            // Insert Top Container.
            $topContainer = $contentTable->createRow();
            $topContainer->page_id = $page_id;
            $topContainer->type = 'container';
            $topContainer->name = 'top';
            $topContainer->order = 1;
            $topContainer->save();

            // Insert Top-Middle Container.
            $topMiddleContainer = $contentTable->createRow();
            $topMiddleContainer->page_id = $page_id;
            $topMiddleContainer->type = 'container';
            $topMiddleContainer->name = 'middle';
            $topMiddleContainer->parent_content_id = $topContainer->content_id;
            $topMiddleContainer->order = 6;
            $topMiddleContainer->save();

            // Insert widgets: In Top-Middle Container.
            $topMiddleWidgets = $contentTable->createRow();
            $topMiddleWidgets->page_id = $page_id;
            $topMiddleWidgets->type = 'widget';
            $topMiddleWidgets->name = 'document.navigation-documents';
            $topMiddleWidgets->parent_content_id = $topMiddleContainer->content_id;
            $topMiddleWidgets->order = 1;
            $topMiddleWidgets->params = '{"title":"","titleCount":"true"}';
            $topMiddleWidgets->save();

            // Insert Main Container.
            $mainContainer = $contentTable->createRow();
            $mainContainer->page_id = $page_id;
            $mainContainer->type = 'container';
            $mainContainer->name = 'main';
            $mainContainer->order = 2;
            $mainContainer->save();

            // Insert Main-Middle Container.
            $mainMiddleContainer = $contentTable->createRow();
            $mainMiddleContainer->page_id = $page_id;
            $mainMiddleContainer->type = 'container';
            $mainMiddleContainer->name = 'middle';
            $mainMiddleContainer->parent_content_id = $mainContainer->content_id;
            $mainMiddleContainer->order = 6;
            $mainMiddleContainer->save();

            // Insert widgets: In Top-Middle Container.
            $topMiddleWidgets = $contentTable->createRow();
            $topMiddleWidgets->page_id = $page_id;
            $topMiddleWidgets->type = 'widget';
            $topMiddleWidgets->name = 'core.content';
            $topMiddleWidgets->parent_content_id = $mainMiddleContainer->content_id;
            $topMiddleWidgets->order = 2;
            $topMiddleWidgets->params = '{"title":"","titleCount":"true"}';
            $topMiddleWidgets->save();
        }
    }

    public function documentView($reset) {
        $db = Engine_Db_Table::getDefaultAdapter();
        $page_id = $this->checkPageId('document_index_view');
        if ($page_id && $reset) {
            $this->deletePageAndContent($page_id);
            $page_id = false;
        }

        if (empty($page_id)) {
            //CREATE PAGE IF NOT EXIST
            $db->insert('engine4_core_pages', array(
                'name' => 'document_index_view',
                'displayname' => 'Documents - Document View Page',
                'title' => 'Document View Page',
                'description' => 'This is the document view page.',
                'custom' => 0,
                'layout' => 'default',
            ));
            $page_id = $db->lastInsertId('engine4_core_pages');

            //TOP CONTAINER
            $db->insert('engine4_core_content', array(
                'page_id' => $page_id,
                'type' => 'container',
                'name' => 'top',
                'parent_content_id' => null,
                'order' => 1,
                'params' => '',
            ));
            $top_container_id = $db->lastInsertId('engine4_core_content');

            $db->insert('engine4_core_content', array(
                'page_id' => $page_id,
                'type' => 'container',
                'name' => 'middle',
                'parent_content_id' => $top_container_id,
                'order' => 2,
                'params' => '',
            ));
            $top_middle_container_id = $db->lastInsertId('engine4_core_content');

            $db->insert('engine4_core_content', array(
                'page_id' => $page_id,
                'type' => 'widget',
                'name' => 'document.list-profile-breadcrumb',
                'parent_content_id' => $top_middle_container_id,
                'order' => 3,
                'params' => '',
            ));

            //MAIN CONTAINER
            $db->insert('engine4_core_content', array(
                'page_id' => $page_id,
                'type' => 'container',
                'name' => 'main',
                'parent_content_id' => null,
                'order' => 2,
                'params' => '',
            ));
            $main_container_id = $db->lastInsertId('engine4_core_content');

            //RIGHT CONTAINER
            $db->insert('engine4_core_content', array(
                'page_id' => $page_id,
                'type' => 'container',
                'name' => 'right',
                'parent_content_id' => $main_container_id,
                'order' => 5,
                'params' => '',
            ));
            $right_container_id = $db->lastInsertId('engine4_core_content');

            //MAIN MIDDLE CONTAINER
            $db->insert('engine4_core_content', array(
                'page_id' => $page_id,
                'type' => 'container',
                'name' => 'middle',
                'parent_content_id' => $main_container_id,
                'order' => 6,
                'params' => '',
            ));
            $main_middle_container_id = $db->lastInsertId('engine4_core_content');

            //DOCUMENT VIEWER WINDOW WIDGET
            $db->insert('engine4_core_content', array(
                'page_id' => $page_id,
                'type' => 'widget',
                'name' => 'document.document-view-documents',
                'parent_content_id' => $main_middle_container_id,
                'order' => 3,
                'params' => '{}',
            ));

            if (Engine_Api::_()->hasModuleBootstrap('nestedcomment')) {
                $db->insert('engine4_core_content', array(
                    'page_id' => $page_id,
                    'type' => 'widget',
                    'name' => 'nestedcomment.comments',
                    'parent_content_id' => $main_middle_container_id,
                    'order' => 4,
                    'params' => '{}',
                ));
            } else {
                $db->insert('engine4_core_content', array(
                    'page_id' => $page_id,
                    'type' => 'widget',
                    'name' => 'core.comments',
                    'parent_content_id' => $main_middle_container_id,
                    'order' => 4,
                    'params' => '{}',
                ));
            }


            //DOCUMENT OWNER PHOTO WIDGET
            $db->insert('engine4_core_content', array(
                'page_id' => $page_id,
                'type' => 'widget',
                'name' => 'document.document-owner-photo-documents',
                'parent_content_id' => $right_container_id,
                'order' => 5,
                'params' => '',
            ));

            //DOCUMENT OPTIONS WIDGET
            $db->insert('engine4_core_content', array(
                'page_id' => $page_id,
                'type' => 'widget',
                'name' => 'document.options-documents',
                'parent_content_id' => $right_container_id,
                'order' => 6,
                'params' => '',
            ));

            //SEARCH BOX WIDGET
            $db->insert('engine4_core_content', array(
                'page_id' => $page_id,
                'type' => 'widget',
                'name' => 'document.search-box-documents',
                'parent_content_id' => $right_container_id,
                'order' => 7,
                'params' => '{"title":"Search Documents","titleCount":"true"}',
            ));


            $social_share_default_code = '{"title":"Social Share","titleCount":true,"code":"<div class=\"addthis_toolbox addthis_default_style \">\r\n<a class=\"addthis_button_preferred_1\"><\/a>\r\n<a class=\"addthis_button_preferred_2\"><\/a>\r\n<a class=\"addthis_button_preferred_3\"><\/a>\r\n<a class=\"addthis_button_preferred_4\"><\/a>\r\n<a class=\"addthis_button_preferred_5\"><\/a>\r\n<a class=\"addthis_button_compact\"><\/a>\r\n<a class=\"addthis_counter addthis_bubble_style\"><\/a>\r\n<\/div>\r\n<script type=\"text\/javascript\">\r\nvar addthis_config = {\r\n          services_compact: \"facebook, twitter, linkedin, google, digg, more\",\r\n          services_exclude: \"print, email\"\r\n}\r\n<\/script>\r\n<script type=\"text\/javascript\" src=\"http:\/\/s7.addthis.com\/js\/250\/addthis_widget.js\"><\/script>","nomobile":"","name":"document.socialshare-documents"}';

            //SOCIAL SHARE BUTTONS WIDGET
            $db->insert('engine4_core_content', array(
                'page_id' => $page_id,
                'type' => 'widget',
                'name' => 'document.socialshare-documents',
                'parent_content_id' => $right_container_id,
                'order' => 9,
                'params' => $social_share_default_code,
            ));

            //TAG CLOUD WIDGET
            $db->insert('engine4_core_content', array(
                'page_id' => $page_id,
                'type' => 'widget',
                'name' => 'document.tagcloud-documents',
                'parent_content_id' => $right_container_id,
                'order' => 11,
                'params' => '{"title":"","titleCount":true,"orderingType":"1","itemCount":"10","loaded_by_ajax":"1","nomobile":"0","name":"document.tagcloud-documents"}',
            ));

            //ARCHIVES WIDGET
            $db->insert('engine4_core_content', array(
                'page_id' => $page_id,
                'type' => 'widget',
                'name' => 'document.archives-documents',
                'parent_content_id' => $right_container_id,
                'order' => 12,
                'params' => '{"title":"Archives","titleCount":"true"}',
            ));
        }
    }

    public function documentCategoriesHome($reset) {
        $db = Engine_Db_Table::getDefaultAdapter();
        $page_id = $this->checkPageId('document_index_categories');
        if ($page_id && $reset) {
            $this->deletePageAndContent($page_id);
            $page_id = false;
        }
        $contentTable = Engine_Api::_()->getDbtable('content', 'core');
        $pageTable = Engine_Api::_()->getDbtable('pages', 'core');
        if (empty($page_id)) {
            $pageCreate = $pageTable->createRow();
            $pageCreate->name = 'document_index_categories';
            $pageCreate->displayname = 'Documents - Documents Categories Page';
            $pageCreate->title = 'Documents Categories Page';
            $pageCreate->description = 'This is the document categories page.';
            $pageCreate->custom = 0;
            $pageCreate->save();
            $page_id = $pageCreate->page_id;

            // Insert Top Container.
            $topContainer = $contentTable->createRow();
            $topContainer->page_id = $page_id;
            $topContainer->type = 'container';
            $topContainer->name = 'top';
            $topContainer->order = 1;
            $topContainer->save();

            // Insert Top-Middle Container.
            $topMiddleContainer = $contentTable->createRow();
            $topMiddleContainer->page_id = $page_id;
            $topMiddleContainer->type = 'container';
            $topMiddleContainer->name = 'middle';
            $topMiddleContainer->parent_content_id = $topContainer->content_id;
            $topMiddleContainer->order = 6;
            $topMiddleContainer->save();

            // Insert widgets: In Top-Middle Container.
            $topMiddleWidgets = $contentTable->createRow();
            $topMiddleWidgets->page_id = $page_id;
            $topMiddleWidgets->type = 'widget';
            $topMiddleWidgets->name = 'document.navigation-documents';
            $topMiddleWidgets->parent_content_id = $topMiddleContainer->content_id;
            $topMiddleWidgets->order = 1;
            $topMiddleWidgets->params = '{"title":"","titleCount":"true"}';
            $topMiddleWidgets->save();

            // Insert Main Container.
            $mainContainer = $contentTable->createRow();
            $mainContainer->page_id = $page_id;
            $mainContainer->type = 'container';
            $mainContainer->name = 'main';
            $mainContainer->order = 2;
            $mainContainer->save();

            // Insert Main-Middle Container.
            $mainMiddleContainer = $contentTable->createRow();
            $mainMiddleContainer->page_id = $page_id;
            $mainMiddleContainer->type = 'container';
            $mainMiddleContainer->name = 'middle';
            $mainMiddleContainer->parent_content_id = $mainContainer->content_id;
            $mainMiddleContainer->order = 6;
            $mainMiddleContainer->save();

            // Insert widgets: In Top-Middle Container.
            $topMiddleWidgets = $contentTable->createRow();
            $topMiddleWidgets->page_id = $page_id;
            $topMiddleWidgets->type = 'widget';
            $topMiddleWidgets->name = 'document.categories-withicon-grid-view';
            $topMiddleWidgets->parent_content_id = $mainMiddleContainer->content_id;
            $topMiddleWidgets->order = 2;
            $topMiddleWidgets->params = '{"title":"","titleCount":true,"orderBy":"cat_order","showAllCategories":"1","columnWidth":"222","columnHeight":"210","showIcon":"1","nomobile":"0","name":"document.categories-withicon-grid-view"}';
            $topMiddleWidgets->save();

            // Insert widgets: In Top-Middle Container.
            $topMiddleWidgets = $contentTable->createRow();
            $topMiddleWidgets->page_id = $page_id;
            $topMiddleWidgets->type = 'widget';
            $topMiddleWidgets->name = 'document.categories-grid-view-documents';
            $topMiddleWidgets->parent_content_id = $mainMiddleContainer->content_id;
            $topMiddleWidgets->order = 3;
            $topMiddleWidgets->params = '{"title":"","titleCount":true,"category_id":"1","documentType":"0","columnWidth":"210","columnHeight":"325","documentOption":["title","owner","featured","sponsored","view","like","comment","rating","likeButton","facebook","twitter","linkedin","googleplus"],"truncation":"18","nomobile":"0","name":"document.categories-grid-view-documents"}';
            $topMiddleWidgets->save();
        }
    }

    public function documentMemberProfile($reset) {
        $db = Engine_Db_Table::getDefaultAdapter();
        $page_id = $this->checkPageId('user_profile_index');
        if ($page_id && $reset) {

            $db->query("DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`name` = 'document.profile-documents' AND `engine4_core_content`.`page_id` = $page_id");
            $db->query("DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`name` = 'document.profile-doc-documents' AND `engine4_core_content`.`page_id` = $page_id");
            $contentTable = Engine_Api::_()->getDbtable('content', 'core');
            $contentTableName = $contentTable->info('name');
            $selectContainerId = $contentTable->select()
                    ->from($contentTableName, array('content_id'))
                    ->where('page_id =?', $page_id)
                    ->where('type = ?', 'widget')
                    ->where('name = ?', 'core.container-tabs')
                    ->limit(1);
            $fetchContainerId = $selectContainerId->query()->fetchAll();
            if (!empty($fetchContainerId)) {
                $containerId = $fetchContainerId[0]['content_id'];
                $contentWidget = $contentTable->createRow();
                $contentWidget->page_id = $page_id;
                $contentWidget->type = 'widget';
                $contentWidget->name = 'document.profile-documents';
                $contentWidget->parent_content_id = $containerId;
                $contentWidget->order = 998;
                $contentWidget->params = '{"title":"Documents","titleCount":true,"layoutsViews":["1","2"],"layoutsOrder":"2","columnWidth":"195","columnHeight":"355","documentOption":["title","owner","featured","sponsored","view","like","comment","rating","likeButton","facebook","twitter","linkedin","googleplus"],"itemCount":"12","truncation":"80","descriptionTruncation":"225","nomobile":"0","name":"document.profile-documents"}';
                $contentWidget->save();

                $social_share_default_code = '{"title":"Profile Document","titleCount":true,"code":"<div class=\"addthis_toolbox addthis_default_style \">\r\n<a class=\"addthis_button_preferred_1\"><\/a>\r\n<a class=\"addthis_button_preferred_2\"><\/a>\r\n<a class=\"addthis_button_preferred_3\"><\/a>\r\n<a class=\"addthis_button_preferred_4\"><\/a>\r\n<a class=\"addthis_button_preferred_5\"><\/a>\r\n<a class=\"addthis_button_compact\"><\/a>\r\n<a class=\"addthis_counter addthis_bubble_style\"><\/a>\r\n<\/div>\r\n<script type=\"text\/javascript\">\r\nvar addthis_config = {\r\n          services_compact: \"facebook, twitter, linkedin, google, digg, more\",\r\n          services_exclude: \"print, email\"\r\n}\r\n<\/script>\r\n<script type=\"text\/javascript\" src=\"http:\/\/s7.addthis.com\/js\/250\/addthis_widget.js\"><\/script>","nomobile":"","name":"document.profile-doc-documents"}';

                $db->insert('engine4_core_content', array(
                    'page_id' => $page_id,
                    'type' => 'widget',
                    'name' => 'document.profile-doc-documents',
                    'parent_content_id' => $containerId,
                    'order' => 999,
                    'params' => $social_share_default_code,
                ));
            }
        }
    }

    public function documentBrowseMobi($reset) {
        $db = Engine_Db_Table::getDefaultAdapter();
        $page_id = $this->checkPageId('document_index_mobi-browse');
        if ($page_id && $reset) {
            $this->deletePageAndContent($page_id);
            $page_id = false;
        }

        if (!$page_id) {
            //CREATE PAGE IF NOT EXIST
            $db->insert('engine4_core_pages', array(
                'name' => 'document_index_mobi-browse',
                'displayname' => 'Documents - Mobile Documents Browse Page',
                'title' => 'Mobile Documents Browse Page',
                'description' => 'This is the mobile browse document page.',
                'custom' => 0,
                'layout' => 'default',
            ));
            $page_id = $db->lastInsertId('engine4_core_pages');

            //MAIN CONTAINER
            $db->insert('engine4_core_content', array(
                'page_id' => $page_id,
                'type' => 'container',
                'name' => 'main',
                'parent_content_id' => null,
                'order' => 1,
                'params' => '',
            ));
            $main_container_id = $db->lastInsertId('engine4_core_content');

            //MIDDLE CONTAINER
            $db->insert('engine4_core_content', array(
                'page_id' => $page_id,
                'type' => 'container',
                'name' => 'middle',
                'parent_content_id' => $main_container_id,
                'order' => 2,
                'params' => '',
            ));
            $middle_container_id = $db->lastInsertId('engine4_core_content');

            //MAIN NAVIGATION WIDGET
            $db->insert('engine4_core_content', array(
                'page_id' => $page_id,
                'type' => 'widget',
                'name' => 'document.navigation-documents',
                'parent_content_id' => $middle_container_id,
                'order' => 3,
                'params' => '',
            ));

            //SEARCH FORM WIDGET
            $db->insert('engine4_core_content', array(
                'page_id' => $page_id,
                'type' => 'widget',
                'name' => 'document.search-documents',
                'parent_content_id' => $middle_container_id,
                'order' => 4,
                'params' => '',
            ));

            //BROWSE DOCUMENTS WIDGET
            $db->insert('engine4_core_content', array(
                'page_id' => $page_id,
                'type' => 'widget',
                'name' => 'document.browse-documents',
                'parent_content_id' => $middle_container_id,
                'order' => 5,
                'params' => '{"title":"","titleCount":true,"orderby":"document_id","documentOption":["title","owner","featured","sponsored","view","like","comment","rating","likeButton","facebook","twitter","linkedin","googleplus"],"show_content":"2","itemCount":"10","truncation":"80","descriptionTruncation":"225","nomobile":"0","name":"document.browse-documents"}',
            ));
        }
    }

    public function documentHomeMobi($reset) {
        $db = Engine_Db_Table::getDefaultAdapter();
        $page_id = $this->checkPageId('document_index_mobi-home');
        if ($page_id && $reset) {
            $this->deletePageAndContent($page_id);
            $page_id = false;
        }
        if (!$page_id) {
            //CREATE PAGE IF NOT EXIST
            $db->insert('engine4_core_pages', array(
                'name' => 'document_index_mobi-home',
                'displayname' => 'Documents - Mobile Documents Home Page',
                'title' => 'Mobile Documents Home Page',
                'description' => 'This is the mobile document home page.',
                'custom' => 0,
                'layout' => 'default',
            ));
            $page_id = $db->lastInsertId('engine4_core_pages');

            //MAIN CONTAINER
            $db->insert('engine4_core_content', array(
                'page_id' => $page_id,
                'type' => 'container',
                'name' => 'main',
                'parent_content_id' => null,
                'order' => 1,
                'params' => '',
            ));
            $main_container_id = $db->lastInsertId('engine4_core_content');

            //MIDDLE CONTAINER
            $db->insert('engine4_core_content', array(
                'page_id' => $page_id,
                'type' => 'container',
                'name' => 'middle',
                'parent_content_id' => $main_container_id,
                'order' => 2,
                'params' => '',
            ));
            $middle_container_id = $db->lastInsertId('engine4_core_content');

            //MAIN NAVIGATION WIDGET
            $db->insert('engine4_core_content', array(
                'page_id' => $page_id,
                'type' => 'widget',
                'name' => 'document.navigation-documents',
                'parent_content_id' => $middle_container_id,
                'order' => 3,
                'params' => '',
            ));

            //SEARCH FORM WIDGET
            $db->insert('engine4_core_content', array(
                'page_id' => $page_id,
                'type' => 'widget',
                'name' => 'document.search-documents',
                'parent_content_id' => $middle_container_id,
                'order' => 4,
                'params' => '',
            ));

            //HOME DOCUMENTS WIDGET
            $db->insert('engine4_core_content', array(
                'page_id' => $page_id,
                'type' => 'widget',
                'name' => 'document.ajax-home-documents',
                'parent_content_id' => $middle_container_id,
                'order' => 5,
                'params' => '{"title":"","titleCount":"","layoutsViews":["1","2"],"layoutsOrder":"1","layoutsTabs":["1","2","3","4","5"],"recentOrder":"1","popularOrder":"2","randomOrder":"3","featuredOrder":"4","sponosredOrder":"5","listLimit":"10","gridLimit":"15","documentOption":["title","owner","featured","sponsored","view","like","comment","rating","likeButton","facebook","twitter","linkedin","googleplus"],"columnWidth":"210","columnHeight":"325","descriptionListTruncation":"225","category_id":"0","nomobile":"0","name":"document.ajax-home-documents"}',
            ));
        }
    }

    public function documentViewMobi($reset) {
        $db = Engine_Db_Table::getDefaultAdapter();
        $page_id = $this->checkPageId('document_index_mobi-view');
        if ($page_id && $reset) {
            $this->deletePageAndContent($page_id);
            $page_id = false;
        }
        if (!$page_id) {
            $db->insert('engine4_core_pages', array(
                'name' => 'document_index_mobi-view',
                'displayname' => 'Documents - Mobile Document View Page',
                'title' => 'Mobile Document View Page',
                'description' => 'This is the mobile view document page.',
                'custom' => 0,
                'layout' => 'default',
            ));
            $page_id = $db->lastInsertId('engine4_core_pages');

            //MAIN CONTAINER
            $db->insert('engine4_core_content', array(
                'page_id' => $page_id,
                'type' => 'container',
                'name' => 'main',
                'parent_content_id' => null,
                'order' => 1,
                'params' => '',
            ));
            $main_container_id = $db->lastInsertId('engine4_core_content');

            //MIDDLE CONTAINER
            $db->insert('engine4_core_content', array(
                'page_id' => $page_id,
                'type' => 'container',
                'name' => 'middle',
                'parent_content_id' => $main_container_id,
                'order' => 2,
                'params' => '',
            ));
            $middle_container_id = $db->lastInsertId('engine4_core_content');

            //VIEW DOCUMENTS WIDGET
            $db->insert('engine4_core_content', array(
                'page_id' => $page_id,
                'type' => 'widget',
                'name' => 'document.document-view-documents',
                'parent_content_id' => $middle_container_id,
                'order' => 5,
                'params' => '',
            ));
        }
    }

}
