<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Document
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Category.php 6590 2016-07-12 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Document_Model_Category extends Core_Model_Item_Abstract {

    /**
     * Return slug corrosponding to category name
     *
     * @return categoryname
     */
    public function getCategorySlug() {
        return Engine_Api::_()->seaocore()->getSlug($this->category_name, 225);
    }

    public function getHref($params = array()) {

        if ($this->subcat_dependency) {
            $type = 'subsubcategory';
            $params['subsubcategory_id'] = $this->category_id;
            $params['subsubcategoryname'] = $this->getCategorySlug();
            $cat = $this->getTable()->getCategory($this->cat_dependency);
            $params['subcategory_id'] = $cat->category_id;
            $params['subcategoryname'] = $cat->getCategorySlug();
            $cat = $this->getTable()->getCategory($cat->cat_dependency);
            $params['category_id'] = $cat->category_id;
            $params['categoryname'] = $cat->getCategorySlug();
        } else if ($this->cat_dependency) {
            $type = 'subcategory';
            $params['subcategory_id'] = $this->category_id;
            $params['subcategoryname'] = $this->getCategorySlug();
            $cat = $this->getTable()->getCategory($this->cat_dependency);
            $params['category_id'] = $cat->category_id;
            $params['categoryname'] = $cat->getCategorySlug();
        } else {
            $type = 'category';
            $params['category_id'] = $this->category_id;
            $params['categoryname'] = $this->getCategorySlug();
        }

        $route = "document_general_$type";
//        if ($type == 'category' && Engine_API::_()->seaocore()->checkSitemobileMode('fullsite-mode')) {
//            $route = Engine_Api::_()->document()->getCategoryHomeRoute();
//        }
        $params = array_merge(array(
            'route' => $route,
            'reset' => true,
                ), $params);
        $route = $params['route'];
        $reset = $params['reset'];
        unset($params['route']);
        unset($params['reset']);
        return Zend_Controller_Front::getInstance()->getRouter()
                        ->assemble($params, $route, $reset);
    }

    public function getTitle($inflect = false) {
        if ($inflect) {
            return ucwords($this->category_name);
        } else {
            return $this->category_name;
        }
    }

    /**
     * Set category icon
     *
     */
    public function setPhoto($photo) {

        //GET PHOTO DETAILS
        $name = basename($photo['tmp_name']);
        $path = dirname($photo['tmp_name']);
        $mainName = $path . '/' . $photo['name'];

        //GET VIEWER ID
        $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
        $photo_params = array(
            'parent_id' => $this->category_id,
            'parent_type' => "document_category",
        );

        //RESIZE IMAGE WORK
        $image = Engine_Image::factory();
        $image->open($photo['tmp_name']);
        $image->open($photo['tmp_name'])
                ->resample(0, 0, $image->width, $image->height, $image->width, $image->height)
                ->write($mainName)
                ->destroy();

        try {
            $photoFile = Engine_Api::_()->storage()->create($mainName, $photo_params);
        } catch (Exception $e) {
            if ($e->getCode() == Storage_Api_Storage::SPACE_LIMIT_REACHED_CODE) {
                echo $e->getMessage();
                exit();
            }
        }

        return $photoFile;
    }

}
