<?php
/**
 * SocialEngine
 *
 * @category   Application_Core
 * @package    Document
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 * @version    $Id: Users.php 9747 2012-07-26 02:08:08Z john $
 * @author     John
 */

/**
 * @category   Application_Core
 * @package    User
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 */
class Document_Model_DbTable_AddFileDetails extends Engine_Db_Table
{
  protected $_name = 'document_fileimport';

  protected $_rowClass = 'Document_Model_Fileimport';

  public function deleteRow( $fileId, $deleteValues )
  {
  	$sqlquery = $this->select()
               ->from($this->info('name'))
               ->where('fileimport_id = ?', $fileId);
    $fileDetailsIs = $this->fetchAll($sqlquery)->toArray();
  

      if(count($fileDetailsIs) == 0) {
      	return ;
      }
        $db = Engine_Db_Table::getDefaultAdapter();
        $getCountRows = $fileDetailsIs[0]['total_count'] ;
        foreach ($deleteValues as $value) {
          $sqlquery = "DELETE FROM `".$fileDetailsIs[0]['table_name']."` WHERE unique_Id = $value" ;
          
          $status = $db->query($sqlquery);
          if( $status->rowCount() == NULL) {
          	continue ;
          }
          $getCountRows = $getCountRows - $status->rowCount();
          if( $getCountRows > 0) {
          	$this->update(array('total_count' => $getCountRows), array('fileimport_id = ?' => $fileDetailsIs[0]['fileimport_id']));

            // here 1 for row delete 
           $setFlag = 1;
          } else if( $getCountRows == 0 ) {
          	$dropTable = " DROP TABLE If EXISTS `".$fileDetailsIs[0]['table_name']."`" ;
            $db->query($dropTable);
          	$this->delete(array('fileimport_id = ?' => $fileDetailsIs[0]['fileimport_id']));
            $setFlag = 0;
            $path = APPLICATION_PATH . "/public/document/fileimport_".$fileDetailsIs[0]['fileimport_id'] ;
            $this->removeDirectory($path);
          }
        }
        return $setFlag;
  }

  public function removeDirectory($path) 
  {
      $files = glob($path . '/*');
      foreach ($files as $file) {
        is_dir($file) ? $this->removeDirectory($file) : unlink($file);
      }
      rmdir($path);
      return;
  }
}