<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Document
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminMigrateController.php 6590 2016-07-12 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$settings = Engine_Api::_()->getApi('settings', 'core');

$scribd_api_key = $settings->getSetting('document.api.key', $settings->getSetting('sitepagedocument.api.key', $settings->getSetting('sitebusinessdocument.api.key', $settings->getSetting('sitegroupdocument.api.key', $settings->getSetting('sitestoredocument.api.key', $settings->getSetting('siteeventdocument.api.key'))))));

$scribd_secret = $settings->getSetting('document.secret.key', $settings->getSetting('sitepagedocument.secret.key', $settings->getSetting('sitebusinessdocument.secret.key', $settings->getSetting('sitegroupdocument.secret.key', $settings->getSetting('sitestoredocument.secret.key', $settings->getSetting('siteeventdocument.secret.key'))))));
if ($scribd_api_key && $scribd_secret) {
    include_once APPLICATION_PATH . '/application/modules/Document/Api/Scribd.php';
}

include_once APPLICATION_PATH . '/application/modules/Document/Api/GDSEMedia.php';

class Document_AdminMigrateController extends Core_Controller_Action_Admin {

    protected $_document_google_email;
    protected $_document_client_id;
    protected $_document_service_account_name;
    protected $_document_private_key_url_path;
    protected $_GDSEMedia;

    //COMMON ACTION WHICH CALL BEFORE EVERY ACTION OF THIS CONTROLLER
    public function init() {

        $coreApi = Engine_Api::_()->document();

        $document_client_id = $this->_document_client_id = $coreApi->getGoogleClientId();
        $getGoogleClientSecretKey = $this->_getGoogleClientSecretKey = $coreApi->getGoogleClientSecretKey();
        $document_google_email = $this->_document_google_email = $coreApi->getGoogleEmail();
        $document_hide_old_fields = Engine_Api::_()->getApi('settings', 'core')->getSetting('document.hide.old.fields', 0);
        if ($document_hide_old_fields) {
            $this->_GDSEMedia = new GDSEMedia($document_client_id, null, null, $getGoogleClientSecretKey);
        } else {

            $document_service_account_name = $this->_document_service_account_name = $coreApi->getGoogleServiceAccountName();
            $document_private_key_url_path = $this->_document_private_key_url_path = $coreApi->getPrivateKeyUrl();
            if ($document_google_email && $document_client_id && $document_service_account_name && $document_private_key_url_path) {
                $this->_GDSEMedia = new GDSEMedia($document_client_id, $document_service_account_name, $document_private_key_url_path);
            }
        }
        $this->scribd_api_key = Engine_Api::_()->getApi('settings', 'core')->document_api_key;
        $this->scribd_secret = Engine_Api::_()->getApi('settings', 'core')->document_secret_key;
        if ($this->scribd_api_key && $this->scribd_secret) {
            $this->scribd = new Scribd($this->scribd_api_key, $this->scribd_secret);
        }
    }

    public function indexAction() {
        global $gdsem_apiConfig;
        //GET VIEWER DETAILS
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();
        $level_id = $viewer->level_id;
        set_time_limit(0);
        ini_set("max_execution_time", "900");
        ini_set("memory_limit", "256M");

        //GET NAVIGATION
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('document_admin_main', array(), 'document_admin_main_import');

        $this->view->subNavigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('document_admin_main_import', array(), 'document_admin_main_migrate');
        $this->view->documentCount = Engine_Api::_()->getDbtable('documents', 'document')
                ->getDocumentsCount(array('migrated' => 0));

        $this->view->gdseMedia = $this->_GDSEMedia;

        if ($this->_GDSEMedia) {
            $gdsem_apiConfig['use_objects'] = true;
            $this->view->ebot = $this->_GDSEMedia->getAbout();
        }
        $gdsem_apiConfig['use_objects'] = false;
        $start = $this->_getParam('start', 0);

        $this->view->autoMigration = $this->_getParam('autoMigration', 0);

        //1 for completed
        $this->view->status = $this->_getParam('status', 0);
        if ($start) {
            $results = Engine_Api::_()->getDbtable('documents', 'document')->getDocuments(array('migrated' => 0, 'selectLimit' => 25));
            $download_format = 'pdf';
            //GET VIEWER DETAILS
            $folderId = $this->_GDSEMedia->getFolder($viewer->email. '-' . $viewer_id);

            $this->_GDSEMedia->setPermissions($folderId, $this->_document_google_email);
            $fileParent = new Google_ParentReference();
            $fileParent->setId($folderId);

            foreach ($results as $result) {
                $this->scribd->my_user_id = $result['owner_id'];

                if ($result['download_allow']) {

                    try {
                        $link = $this->scribd->getDownloadUrl($result['doc_id'], $download_format);
                        $link = trim($link['download_link']);
                        $ext = pathinfo($link, PATHINFO_EXTENSION);
                        $name = $result['document_title'] . '_' . $result['doc_id'] . '.' . $ext;
                        $curl_handle = curl_init();
                        curl_setopt($curl_handle, CURLOPT_URL, $link);
                        curl_setopt($curl_handle, CURLOPT_CONNECTTIMEOUT, 0);
                        curl_setopt($curl_handle, CURLOPT_TIMEOUT, 0);
                        curl_setopt($curl_handle, CURLOPT_SSL_VERIFYPEER, FALSE);
                        curl_setopt($curl_handle, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']);
                        curl_setopt($curl_handle, CURLOPT_FOLLOWLOCATION, 1);
                        curl_setopt($curl_handle, CURLOPT_RETURNTRANSFER, TRUE);
                        $JsonResponse = curl_exec($curl_handle);
                        $http_code = curl_getinfo($curl_handle);
                        $dir_name_temp = 'document_scribd';
                        $temp_doc_file = APPLICATION_PATH . '/public/' . $dir_name_temp;

                        if (!is_dir($temp_doc_file)) {
                            mkdir($temp_doc_file, 0777, true);
                        }
                        $fileName = $temp_doc_file . '/' . $name;
                        file_put_contents($fileName, $JsonResponse);


                        $mimeType = Engine_Api::_()->document()->get_mime_content_type($fileName);
                        $fileId = $this->_GDSEMedia->createFileFromPath($fileName, $name, $result['document_description'], $fileParent, $mimeType, $result['download_allow']);
                    } catch (Exception $ex) {
                        $this->view->excep_error = 1;
                    }
                    if ($this->view->excep_error) {
                        $filename_id = $result['filename_id'];
                        $fileObj = Engine_Api::_()->getItem('storage_file', $filename_id);
                        $fileName = $link = APPLICATION_PATH . '/' . $fileObj->storage_path;
                        $ext = pathinfo($link, PATHINFO_EXTENSION);
                        $name = $result['document_title'] . '_' . $result['doc_id'] . '.' . $ext;

                        $mimeType = Engine_Api::_()->document()->get_mime_content_type($fileName);
                        $fileId = $this->_GDSEMedia->createFileFromPath($fileName, $name, $result['document_description'], $fileParent, $mimeType, $result['download_allow']);
                    }
                } else {
                    $filename_id = $result['filename_id'];
                    $fileObj = Engine_Api::_()->getItem('storage_file', $filename_id);
                    $fileName = $link = APPLICATION_PATH . '/' . $fileObj->storage_path;
                    $ext = pathinfo($link, PATHINFO_EXTENSION);
                    $name = $result['document_title'] . '_' . $result['doc_id'] . '.' . $ext;

                    $mimeType = Engine_Api::_()->document()->get_mime_content_type($fileName);
                    $fileId = $this->_GDSEMedia->createFileFromPath($fileName, $name, $result['document_description'], $fileParent, $mimeType, $result['download_allow']);
                }
                $this->_GDSEMedia->setPermissions($fileId, 'me', 'reader', 'anyone');
                $file = $this->_GDSEMedia->files->get($fileId);
                $document_model = Engine_Api::_()->getItem('document', $result['document_id']);
                $document_model->migrated = 1;
                $document_model->google_file_id = $fileId;
                $document_model->google_folder_id = $folderId;
                //$document_model->thumbnail = $file['thumbnailLink'];
                $document_model->save();
            }

            $documentCount = Engine_Api::_()->getDbtable('documents', 'document')->getDocumentsCount(array('migrated' => 0));
            if ($documentCount > 0) {
                $this->_redirect("admin/document/migrate?autoMigration=1");
            } else {
                $this->_redirect("admin/document/migrate");
            }
        }
    }

}
