<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Document
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: widgetSettings.php 6590 2016-07-12 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$db = Engine_Db_Table::getDefaultAdapter();
$templateApi = Engine_Api::_()->getApi('settemplate', 'document');
$templateApi->documentHome(true);
$templateApi->documentBrowse(true);
$templateApi->documentManage(true);
$templateApi->documentCreation(true);
$templateApi->documentEdit(true);
$templateApi->documentView(true);
$templateApi->documentCategoriesHome(true);
$templateApi->documentMemberProfile(true);
$templateApi->documentBrowseMobi(true);
$templateApi->documentHomeMobi(true);
$templateApi->documentViewMobi(true);

$coreMenuItems = Engine_Api::_()->getDbtable('menuItems', 'core');
$coreMainDocument = $coreMenuItems->select()->where('name =?', 'core_main_document');
$isCoreMainDocument = $coreMenuItems->fetchAll($coreMainDocument)->toArray();
if (empty($isCoreMainDocument)) {
    $coreMenuItems->insert(array(
        'name' => 'core_main_document',
        'module' => 'document',
        'label' => 'Documents',
        'plugin' => 'Document_Plugin_Menus::canViewDocuments',
        'params' => '{"route":"document_home","icon":"fa fa fa-files"}',
        'menu' => 'core_main',
        'submenu' => '',
        'order' => '4',
    ));
}


$documentAdminMainManage = $coreMenuItems->select()->where('name =?', 'document_admin_main_manage');
$isDocumentAdminMainManage = $coreMenuItems->fetchAll($documentAdminMainManage)->toArray();
if (empty($isDocumentAdminMainManage)) {
    $coreMenuItems->insert(array(
        'name' => 'document_admin_main_manage',
        'module' => 'document',
        'label' => 'Manage Documents',
        'plugin' => NULL,
        'params' => '{"route":"admin_default","module":"document","controller":"manage"}',
        'menu' => 'document_admin_main',
        'submenu' => '',
        'custom' => '0',
        'order' => '8',
    ));
}

$documentAdminMainProfilemaps = $coreMenuItems->select()->where('name =?', 'document_admin_main_profilemaps');
$isDocumentAdminMainProfilemaps = $coreMenuItems->fetchAll($documentAdminMainProfilemaps)->toArray();
if (empty($isDocumentAdminMainProfilemaps)) {
    $coreMenuItems->insert(array(
        'name' => 'document_admin_main_profilemaps',
        'module' => 'document',
        'label' => 'Category-Doc Profile Mapping',
        'plugin' => NULL,
        'params' => '{"route":"admin_default","module":"document","controller":"profilemaps","action":"manage"}',
        'menu' => 'document_admin_main',
        'submenu' => '',
        'custom' => '0',
        'order' => '5',
    ));
}

$documentAdminMainFormSearch = $coreMenuItems->select()->where('name =?', 'document_admin_main_form_search');
$isDocumentAdminMainFormSearch = $coreMenuItems->fetchAll($documentAdminMainFormSearch)->toArray();
if (empty($isDocumentAdminMainFormSearch)) {
    $coreMenuItems->insert(array(
        'name' => 'document_admin_main_form_search',
        'module' => 'document',
        'label' => 'Search Form Settings',
        'plugin' => NULL,
        'params' => '{"route":"admin_default","module":"document","controller":"settings","action":"form-search"}',
        'menu' => 'document_admin_main',
        'submenu' => '',
        'custom' => '0',
        'order' => '6',
    ));
}

$documentAdminMainLevel = $coreMenuItems->select()->where('name =?', 'document_admin_main_level');
$isDocumentAdminMainLevel = $coreMenuItems->fetchAll($documentAdminMainLevel)->toArray();
if (empty($isDocumentAdminMainLevel)) {
    $coreMenuItems->insert(array(
        'name' => 'document_admin_main_level',
        'module' => 'document',
        'label' => 'Member Level Settings',
        'plugin' => NULL,
        'params' => '{"route":"admin_default","module":"document","controller":"settings","action":"level"}',
        'menu' => 'document_admin_main',
        'submenu' => '',
        'custom' => '0',
        'order' => '2',
    ));
}

$documentAdminMainCategories = $coreMenuItems->select()->where('name =?', 'document_admin_main_categories');
$isDocumentAdminMainCategories = $coreMenuItems->fetchAll($documentAdminMainCategories)->toArray();
if (empty($isDocumentAdminMainCategories)) {
    $coreMenuItems->insert(array(
        'name' => 'document_admin_main_categories',
        'module' => 'document',
        'label' => 'Categories',
        'plugin' => NULL,
        'params' => '{"route":"admin_default","module":"document","controller":"settings", "action":"categories"}',
        'menu' => 'document_admin_main',
        'submenu' => '',
        'custom' => '0',
        'order' => '3',
    ));
}

$documentAdminMainFields = $coreMenuItems->select()->where('name =?', 'document_admin_main_fields');
$isDocumentAdminMainFields = $coreMenuItems->fetchAll($documentAdminMainFields)->toArray();
if (empty($isDocumentAdminMainFields)) {
    $coreMenuItems->insert(array(
        'name' => 'document_admin_main_fields',
        'module' => 'document',
        'label' => 'Profile Fields',
        'plugin' => NULL,
        'params' => '{"route":"admin_default","module":"document","controller":"fields"}',
        'menu' => 'document_admin_main',
        'submenu' => '',
        'custom' => '0',
        'order' => '4',
    ));
}

$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("document_admin_main_support", "document", "Support","", \'{"route":"admin_default","module":"document","controller":"support"}\', "document_admin_main", "",  1, 0, 998)');

$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("document_admin_main_accountinformation", "document", "Account Information", "", \'{"route":"admin_default","module":"document","controller":"account-information"}\', "document_admin_main", "", 1, 0, 9)');

$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("document_admin_main_template", "document", "Layout Templates","", \'{"route":"admin_default","module":"document","controller":"settings","action":"set-template"}\', "document_admin_main", "",  1, 0, 7)');

$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("document_admin_main_accountinformation", "document", "Account Information", "", \'{"route":"admin_default","module":"document","controller":"account-information"}\', "document_admin_main", "", 1, 0, 9)');

$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("document_admin_main_migrate", "document", "Import Documents of Documents / Scribd iPaper Plugin", "", \'{"route":"admin_default","module":"document","controller":"migrate"}\', "document_admin_main_import", "", 1, 0, 10)');

$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("document_admin_main_import", "document", "Import Documents", "", \'{"route":"admin_default","module":"document","controller":"migrate"}\', "document_admin_main", "", 1, 0, 10)');

//$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("document_admin_main_migrate", "document", "Migrate Dcouments", "", \'{"route":"admin_default","module":"document","controller":"migrate"}\', "document_admin_main", "", 1, 0, 10)');

$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("document_admin_main_integrations", "document", "Plugins Integrations","", \'{"route":"admin_default","module":"document","controller":"settings","action":"integrations"}\', "document_admin_main", "",  1, 0, 11)');

$db->query('INSERT IGNORE INTO `engine4_core_menuitems` ( `name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("document_main_categories", "document", "Categories", "", \'{"route":"document_categories"}\', "document_main", "", 1, 0, 4)');

$db->query("INSERT IGNORE INTO `engine4_seaocore_searchformsetting` (`module`, `name`, `display`, `order`, `label`) VALUES ('document', 'content_type', '1', '5', 'Content Type');");

$db->query("UPDATE `engine4_core_menuitems` SET `order` = 8  WHERE `engine4_core_menuitems`.`name` = 'document_admin_main_manage' AND `engine4_core_menuitems`.`module` = 'document' LIMIT 1 ;");

$db->query("UPDATE `engine4_core_menuitems` SET `order` = 999  WHERE `engine4_core_menuitems`.`name` = 'document_admin_main_faq' AND `engine4_core_menuitems`.`module` = 'document' LIMIT 1 ;");

$column_exist = $db->query("SHOW COLUMNS FROM engine4_documents LIKE 'parent_type'")->fetch();
if (empty($column_exist)) {
    $db->query("ALTER TABLE `engine4_documents` ADD `parent_type` VARCHAR(255) COLLATE utf8_unicode_ci NULL DEFAULT NULL");
}

$column_exist = $db->query("SHOW COLUMNS FROM engine4_documents LIKE 'parent_id'")->fetch();
if (empty($column_exist)) {
    $db->query("ALTER TABLE `engine4_documents` ADD `parent_id` INT(11) COLLATE utf8_unicode_ci NULL DEFAULT NULL");
}

$column_exist = $db->query("SHOW COLUMNS FROM engine4_documents LIKE 'fulltext'")->fetch();
if (empty($column_exist)) {
    $db->query("ALTER TABLE `engine4_documents` ADD `fulltext` LONGTEXT COLLATE utf8_unicode_ci NULL DEFAULT NULL");
}
$column_exist = $db->query("SHOW COLUMNS FROM engine4_documents LIKE 'networks_privacy'")->fetch();
if (empty($column_exist)) {
    $db->query("ALTER TABLE `engine4_documents` ADD `networks_privacy` MEDIUMTEXT COLLATE utf8_unicode_ci NULL DEFAULT NULL");
}

$column_exist = $db->query("SHOW COLUMNS FROM engine4_document_categories LIKE 'profile_type'")->fetch();
if (empty($column_exist)) {
    $db->query("ALTER TABLE `engine4_document_categories` ADD `profile_type`  int(11) COLLATE utf8_unicode_ci NULL DEFAULT NULL;");
}

$column_exist = $db->query("SHOW COLUMNS FROM engine4_document_categories LIKE 'icon_id'")->fetch();
if (empty($column_exist)) {
    $db->query("ALTER TABLE `engine4_document_categories` ADD `icon_id`  int(64) COLLATE utf8_unicode_ci NULL DEFAULT NULL;");
}

$column_exist = $db->query("SHOW COLUMNS FROM engine4_document_categories LIKE 'image_id'")->fetch();
if (empty($column_exist)) {
    $db->query("ALTER TABLE `engine4_document_categories` ADD `image_id`  int(64) COLLATE utf8_unicode_ci NULL DEFAULT NULL;");
}

$column_exist = $db->query("SHOW COLUMNS FROM engine4_documents LIKE 'google_folder_id'")->fetch();
if (empty($column_exist)) {
    $db->query("ALTER TABLE `engine4_documents` ADD `google_folder_id`  varchar(512) COLLATE utf8_unicode_ci NULL DEFAULT NULL;");
}

$column_exist = $db->query("SHOW COLUMNS FROM engine4_documents LIKE 'google_file_id'")->fetch();
if (empty($column_exist)) {
    $db->query("ALTER TABLE `engine4_documents` ADD `google_file_id`  varchar(512) COLLATE utf8_unicode_ci NULL DEFAULT NULL;");
}

$column_exist = $db->query("SHOW COLUMNS FROM engine4_documents LIKE 'migrated'")->fetch();
if (empty($column_exist)) {
    $db->query("ALTER TABLE `engine4_documents` ADD `migrated` tinyint(1) NULL DEFAULT '0';");
}


$table_exist = $db->query("SHOW TABLES LIKE 'engine4_documents'")->fetch();
if (!empty($table_exist)) {
    $column_exist = $db->query("SHOW COLUMNS FROM engine4_documents LIKE 'photo_id'")->fetch();
    if (empty($column_exist)) {
        $db->query("ALTER TABLE `engine4_documents` ADD `photo_id` INT( 11 ) NOT NULL DEFAULT '0'");
    }

    $column_exist = $db->query("SHOW COLUMNS FROM engine4_documents LIKE 'document_slug'")->fetch();
    if (!empty($column_exist)) {
        $db->query("ALTER TABLE `engine4_documents` DROP `document_slug`");
    }

    $column_exist = $db->query("SHOW COLUMNS FROM engine4_documents LIKE 'profile_doc'")->fetch();
    if (empty($column_exist)) {
        $db->query("ALTER TABLE `engine4_documents` ADD `profile_doc` TINYINT( 2 ) NOT NULL DEFAULT '0'");
    }

    $column_exist = $db->query("SHOW COLUMNS FROM engine4_documents LIKE 'subcategory_id'")->fetch();
    if (empty($column_exist)) {
        $db->query("ALTER TABLE `engine4_documents` ADD  `subcategory_id` int( 11 ) NOT NULL DEFAULT '0'");
    }

    $column_exist = $db->query("SHOW COLUMNS FROM engine4_documents LIKE 'subsubcategory_id'")->fetch();
    if (empty($column_exist)) {
        $db->query("ALTER TABLE `engine4_documents` ADD  `subsubcategory_id` int( 11 ) NOT NULL DEFAULT '0'");
    }

    $column_exist = $db->query("SHOW COLUMNS FROM engine4_documents LIKE 'sponsored'")->fetch();
    if (empty($column_exist)) {
        $db->query("ALTER TABLE `engine4_documents` ADD `sponsored` TINYINT( 1 ) NOT NULL DEFAULT '0'");
    }

    $column_exist = $db->query("SHOW COLUMNS FROM engine4_documents LIKE 'email_allow'")->fetch();
    if (!empty($column_exist)) {
        $db->query("ALTER TABLE `engine4_documents` CHANGE `email_allow` `email_allow` TINYINT( 1 ) NOT NULL DEFAULT '0'");
    }

    $column_exist = $db->query("SHOW COLUMNS FROM engine4_documents LIKE 'secure_allow'")->fetch();
    if (!empty($column_exist)) {
        $db->query("ALTER TABLE `engine4_documents` CHANGE `secure_allow` `secure_allow` TINYINT( 1 ) NOT NULL DEFAULT '0'");
    }

    $column_exist = $db->query("SHOW COLUMNS FROM engine4_documents LIKE 'download_allow'")->fetch();
    if (!empty($column_exist)) {
        $db->query("ALTER TABLE `engine4_documents` CHANGE `download_allow` `download_allow` TINYINT( 1 ) NOT NULL DEFAULT '0'");
    }

    $column_exist = $db->query("SHOW COLUMNS FROM engine4_documents LIKE 'activity_feed'")->fetch();
    if (empty($column_exist)) {
        $db->query("ALTER TABLE `engine4_documents` ADD `activity_feed` TINYINT( 2 ) NOT NULL DEFAULT '0' AFTER `status`");

        //PUT activity_feed = 1 if status = 1;
        $db->query("UPDATE `engine4_documents` SET activity_feed = 1 WHERE status = 1");
    }

    $column_exist = $db->query("SHOW COLUMNS FROM engine4_documents LIKE 'like_count'")->fetch();
    if (empty($column_exist)) {
        //ADD like_count COLUMN TO DOCUMENT TABLE
        $db->query("ALTER TABLE `engine4_documents` ADD `like_count` INT( 11 ) NOT NULL DEFAULT '0' AFTER `comment_count`");
    }
}

$table_exist = $db->query("SHOW TABLES LIKE 'engine4_document_categories'")->fetch();
if (!empty($table_exist)) {

    $column_exist = $db->query("SHOW COLUMNS FROM engine4_document_categories LIKE 'user_id'")->fetch();
    if (!empty($column_exist)) {
        $db->query("ALTER TABLE `engine4_document_categories` DROP `user_id`");
    }

    $column_exist = $db->query("SHOW COLUMNS FROM engine4_document_categories LIKE 'cat_order'")->fetch();
    if (empty($column_exist)) {
        $db->query("ALTER TABLE `engine4_document_categories` ADD `cat_order` INT( 5 ) NOT NULL DEFAULT '0'");
    }

    $column_exist = $db->query("SHOW COLUMNS FROM engine4_document_categories LIKE 'cat_dependency'")->fetch();
    if (empty($column_exist)) {
        $db->query("ALTER TABLE `engine4_document_categories` ADD `cat_dependency` INT( 5 ) NOT NULL DEFAULT '0'");
    }

    $column_exist = $db->query("SHOW COLUMNS FROM engine4_document_categories LIKE 'subcat_dependency'")->fetch();
    if (empty($column_exist)) {
        $db->query("ALTER TABLE `engine4_document_categories` ADD `subcat_dependency` INT( 5 ) NOT NULL DEFAULT '0'");
    }
}


$profilemapsTable = $db->query('SHOW TABLES LIKE \'engine4_document_profilemaps\'')->fetch();
if (!empty($profilemapsTable)) {
    $categoryIdIndex = $db->query("SHOW INDEX FROM `engine4_document_profilemaps` WHERE Key_name = 'category_id'")->fetch();
    if (empty($categoryIdIndex)) {
        $db->query("ALTER TABLE `engine4_document_profilemaps` ADD INDEX ( `category_id` )");
    }
}

$categoriesTable = $db->query('SHOW TABLES LIKE \'engine4_document_categories\'')->fetch();
if (!empty($categoriesTable)) {

    $catDependencyIndex = $db->query("SHOW INDEX FROM `engine4_document_categories` WHERE Key_name = 'cat_dependency'")->fetch();
    if (empty($catDependencyIndex)) {
        $db->query("ALTER TABLE `engine4_document_categories` ADD INDEX ( `cat_dependency` )");
    }

    $subcatDependencyIndex = $db->query("SHOW INDEX FROM `engine4_document_categories` WHERE Key_name = 'subcat_dependency'")->fetch();
    if (empty($subcatDependencyIndex)) {
        $db->query("ALTER TABLE `engine4_document_categories` ADD INDEX ( `subcat_dependency` )");
    }
}


$documentTable = $db->query('SHOW TABLES LIKE \'engine4_documents\'')->fetch();
if (!empty($documentTable)) {
    $featuredIndex = $db->query("SHOW INDEX FROM `engine4_documents` WHERE Key_name = 'featured'")->fetch();
    if (empty($featuredIndex)) {
        $db->query("ALTER TABLE `engine4_documents` ADD INDEX ( `featured` )");
    }

    $sponsoredIndex = $db->query("SHOW INDEX FROM `engine4_documents` WHERE Key_name = 'sponsored'")->fetch();
    if (empty($sponsoredIndex)) {
        $db->query("ALTER TABLE `engine4_documents` ADD INDEX ( `sponsored` )");
    }

    $categoryIdIndex = $db->query("SHOW INDEX FROM `engine4_documents` WHERE Key_name = 'category_id'")->fetch();
    if (empty($categoryIdIndex)) {
        $db->query("ALTER TABLE `engine4_documents` ADD INDEX ( `category_id` )");
    }

    $profileDocIndex = $db->query("SHOW INDEX FROM `engine4_documents` WHERE Key_name = 'profile_doc'")->fetch();
    if (empty($profileDocIndex)) {
        $db->query("ALTER TABLE `engine4_documents` ADD INDEX ( `profile_doc` )");
    }

    $searchIndex = $db->query("SHOW INDEX FROM `engine4_documents` WHERE Key_name = 'search'")->fetch();
    if (!empty($searchIndex)) {
        $db->query("ALTER TABLE `engine4_documents` DROP INDEX search");
        $db->query("ALTER TABLE `engine4_documents` ADD INDEX (`draft`, `search`, `status`, `approved`)");
    }
}

@ini_set('memory_limit', '-1');
@ini_set('max_execution_time', 600);
Engine_Api::_()->getDbtable('categories', 'document')->uploadDefaultImages();
