<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Document
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 6590 2016-07-12 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
$contentTypes = Engine_Api::_()->getDbtable('modules', 'document')->getIntegratedModules(array('enabled' => 1));
$contentTypeArray = array();
if (!empty($contentTypes)) {
    if (!empty($contentTypes))
        $contentTypeArray[] = 'All';
    $moduleTitle = '';
    foreach ($contentTypes as $contentType) {
        if ($contentType['item_title']) {
            $contentTypeArray['user'] = 'Member Documents';
            $contentTypeArray[$contentType['item_type']] = $contentType['item_title'];
        } else {
            if (Engine_Api::_()->hasModuleBootstrap('sitereview') && Engine_Api::_()->hasModuleBootstrap('sitereviewlistingtype')) {
                $moduleTitle = 'Reviews & Ratings - Multiple Listing Types';
            } elseif (Engine_Api::_()->hasModuleBootstrap('sitereview')) {
                $moduleTitle = 'Multiple Listing Types Plugin Core (Reviews & Ratings Plugin)';
            }
            $explodedResourceType = explode('_', $contentType['item_type']);
            if (isset($explodedResourceType[2]) && $moduleTitle) {
                $listingtypesTitle = Engine_Api::_()->getDbtable('listingtypes', 'sitereview')->getListingRow($explodedResourceType[2])->title_plural;
                $listingtypesTitle = $listingtypesTitle . ' ( ' . $moduleTitle . ' ) ';
                $contentTypeArray[$contentType['item_type']] = $listingtypesTitle;
            } else {
                $contentTypeArray[$contentType['item_type']] = Engine_Api::_()->getDbtable('modules', 'document')->getModuleTitle($contentType['item_module']);
            }
        }
    }
}
if (!empty($contentTypeArray)) {
    $contentTypeElement = array(
        'Select',
        'documentType',
        array(
            'label' => 'Document Type',
            'multiOptions' => $contentTypeArray,
        ),
        'value' => '',
    );
} else {
    $contentTypeElement = array(
        'Hidden',
        'documentType',
        array(
            'label' => 'Document Type',
            'value' => 'All',
            'order' => 1001
        )
    );
}
$popularityDuration = array(
    'Select',
    'interval',
    array(
        'label' => 'Popularity Duration (This duration will be applicable to all Popularity Criteria except Views.)',
        'multiOptions' => array('week' => '1 Week', 'month' => '1 Month', 'overall' => 'Overall'),
        'value' => 'overall',
    )
);

$itemCount = array(
    'Text',
    'itemCount',
    array(
        'label' => 'Count',
        'description' => '(number of documents to show)',
        'value' => 10,
    )
);

$titleTruncationElement = array(
    'Text',
    'truncation',
    array(
        'label' => 'Title Truncation Limit',
        'value' => 10,
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    )
);

$descriptionTruncationElement = array(
    'Text',
    'descriptionTruncation',
    array(
        'label' => 'Description Truncation Limit',
        'value' => 560,
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    )
);

$descriptionTruncationListElement = array(
    'Text',
    'descriptionListTruncation',
    array(
        'label' => 'Description Truncation Limit (List View)',
        'value' => 225,
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    )
);

$documentOption = array(
    'MultiCheckbox',
    'documentOption',
    array(
        'label' => 'Choose the options that you want to display for the documents in this block.',
        'multiOptions' => array(
            'title' => 'Document Title',
            'owner' => 'Owner',
            'featured' => 'Featured',
            'sponsored' => 'Sponsored',
            'view' => 'Views',
            'like' => 'Likes',
            'comment' => 'Comments',
            'rating' => 'Ratings',
            'likeButton' => 'Like Button',
            'facebook' => 'Facebook [Social Share Link]',
            'twitter' => 'Twitter [Social Share Link]',
            'linkedin' => 'LinkedIn [Social Share Link]',
            'googleplus' => 'Google+ [Social Share Link]'
        ),
    )
);

$gridColumnWidth = array(
    'Text',
    'columnWidth',
    array(
        'label' => 'Column width for Grid View.',
        'value' => '210',
    )
);
$gridColumnHeight = array(
    'Text',
    'columnHeight',
    array(
        'label' => 'Column height for Grid View.',
        'value' => '355',
    )
);


$columnWidth = array(
    'Text',
    'columnWidth',
    array(
        'label' => 'Column width for Document.',
        'value' => '234',
    )
);
$columnHeight = array(
    'Text',
    'columnHeight',
    array(
        'label' => 'Column height for Document.',
        'value' => '216',
    )
);

$imageWidth = array(
    'Text',
    'imageWidth',
    array(
        'label' => 'Enter the height of document image.',
        'value' => '234',
    )
);
$imageHeight = array(
    'Text',
    'imageHeight',
    array(
        'label' => 'Enter the width of document image.',
        'value' => '216',
    )
);

$categories = Engine_Api::_()->getDbTable('categories', 'document')->getCategories(0, 0);
if (count($categories) != 0) {
    $categories_prepared[0] = "";
    foreach ($categories as $category) {
        $categories_prepared[$category->category_id] = $category->category_name;
    }
}

$categoryElement = array(
    'Select',
    'category_id',
    array(
        'label' => 'Category',
        'multiOptions' => $categories_prepared,
    )
);

$category_documents_multioptions = array(
    'views' => 'Views',
    'like_count' => 'Likes',
    'comment_count' => 'Comments',
        )
;


$popularity = array(
    'Select',
    'popularity',
    array(
        'label' => 'Popularity / Sorting Criteria',
        'multiOptions' => $category_documents_multioptions,
        'value' => 'views',
    )
);

return array(
    array(
        'title' => 'Ajax based main Documents Home Widget',
        'description' => "Contains multiple Ajax based tabs showing Recently Posted, Popular, Random, Featured and Sponsored documents in a block in separate ajax based tabs. You can configure various settings for this widget from the Edit section of this widget.",
        'category' => 'Documents',
        'type' => 'widget',
        'name' => 'document.ajax-home-documents',
        'defaultParams' => array(
            'title' => "",
            'titleCount' => "",
            'layoutsViews' => array("0" => "1", "1" => "2", "2" => "3"),
            'layoutsOrder' => 1,
            'layoutsTabs' => array("0" => "1", "1" => "2", "2" => "3", "3" => "4", "4" => '5'),
            'recentOrder' => 1,
            'popularOrder' => 2,
            'randomOrder' => 3,
            'featuredOrder' => 4,
            'sponosredOrder' => 5,
            'listLimit' => 10,
            'gridLimit' => 15,
            'documentOption' => array('title', 'owner', 'featured', 'sponsored', 'view', 'like', 'comment', 'rating', 'likeButton', 'facebook', 'twitter', 'linkedin', 'googleplus'),
            'columnWidth' => '210',
            'columnHeight' => '355',
            'descriptionListTruncation' => '225'
        ),
        'adminForm' => array(
            'elements' => array(
                $categoryElement,
                $contentTypeElement,
                array(
                    'MultiCheckbox',
                    'layoutsViews',
                    array(
                        'label' => 'Select the view type for documents.',
                        'multiOptions' => array("1" => "List View", "2" => "Grid View"),
                    ),
                ),
                array(
                    'Radio',
                    'layoutsOrder',
                    array(
                        'label' => 'Select a default view type for documents.',
                        'multiOptions' => array("1" => "List View", "2" => "Grid View"),
                    )
                ),
                array(
                    'Text',
                    'listLimit',
                    array(
                        'label' => 'Count',
                        'description' => '(Number of items to show in list view)',
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                    ),
                ),
                $gridColumnWidth,
                $gridColumnHeight,
                array(
                    'Text',
                    'gridLimit',
                    array(
                        'label' => 'Count',
                        'description' => '(Number of items to show in grid view.)',
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        )
                    ),
                ),
                $documentOption,
                array(
                    'MultiCheckbox',
                    'layoutsTabs',
                    array(
                        'label' => 'Select the tabs that you want to be available in this block.',
                        'multiOptions' => array("1" => "Recent", "2" => "Most Popular", "3" => "Random", "4" => "Featured", "5" => "Sponsored"),
                    ),
                ),
                array(
                    'Text',
                    'recentOrder',
                    array(
                        'label' => 'Recent Tab (order)',
                    ),
                ),
                array(
                    'Text',
                    'popularOrder',
                    array(
                        'label' => 'Most Popular Tab (order)',
                    ),
                ),
                array(
                    'Text',
                    'randomOrder',
                    array(
                        'label' => 'Random Tab (order)',
                    ),
                ),
                array(
                    'Text',
                    'featuredOrder',
                    array(
                        'label' => 'Featured Tab (order)',
                    ),
                ),
                array(
                    'Text',
                    'sponosredOrder',
                    array(
                        'label' => 'Sponosred Tab (order)',
                    ),
                ),
                $descriptionTruncationListElement
            ),
        ),
    ),
    array(
        'title' => 'Browse Documents',
        'description' => 'Displays a list of all documents present on the website. This widget should be place on Browse Documents Page.',
        'category' => 'Documents',
        'type' => 'widget',
        'name' => 'document.browse-documents',
        'autoEdit' => true,
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
            'orderby' => 'document_id'
        ),
        'adminForm' => array(
            'elements' => array(
                $contentTypeElement,
                array(
                    'MultiCheckbox',
                    'layoutsViews',
                    array(
                        'label' => 'Select the view type for documents.',
                        'multiOptions' => array("1" => "List View", "2" => "Grid View"),
                    ),
                ),
                array(
                    'Radio',
                    'layoutsOrder',
                    array(
                        'label' => 'Select a default view type for documents.',
                        'multiOptions' => array("1" => "List View", "2" => "Grid View"),
                    )
                ),
                $documentOption,
                array(
                    'Radio',
                    'orderby',
                    array(
                        'label' => 'Default Ordering of Documents',
                        'multiOptions' => array("document_id" => "All documents in descending order of creation.",
                            "views" => "All documents in descending order of views.",
                            "document_title" => "All documents in alphabetical order.",
                            "sponsored" => "Sponsored documents followed by others in descending order of creation.",
                            "featured" => "Featured documents followed by others in descending order of creation.",
                            "fespfe" => "Sponsored & Featured documents followed by Sponsored documents followed by Featured documents followed by others in descending order of creation.",
                            "spfesp" => "Featured & Sponsored documents followed by Featured documents followed by Sponsored documents followed by others in descending order of creation."
                        ),
                        'value' => 'document_id',
                    )
                ),
                array(
                    'Select',
                    'show_content',
                    array(
                        'label' => 'What do you want for view more content?',
                        'multiOptions' => array(
                            '2' => 'Show View More Link at Bottom',
                            '3' => 'Auto Load Documents on Scrolling Down'),
                        'value' => 2,
                    )
                ),
                $gridColumnWidth,
                $gridColumnHeight,
                $itemCount,
                $titleTruncationElement,
                $descriptionTruncationElement
            ),
        ),
    ),
    array(
        'title' => 'Category Navigation Bar',
        'description' => 'Displays categories in this block. You can configure various settings for this widget from the Edit settings.',
        'category' => 'Documents',
        'type' => 'widget',
        'name' => 'document.listtypes-categories',
        'autoEdit' => true,
        'adminForm' => array(
            'elements' => array(
                array(
                    'Radio',
                    'viewDisplayHR',
                    array(
                        'label' => 'Select the placement position of the navigation bar',
                        'multiOptions' => array(
                            1 => 'Horizontal',
                            0 => 'Vertical'
                        ),
                        'value' => 1,
                    )
                ),
            ))
    ),
    array(
        'title' => 'Categorically Popular Documents',
        'description' => 'This attractive widget categorically displays the most popular documents on your site. It displays 5 Documents for each category. From the edit popup of this widget, you can choose the number of categories to show, criteria for popularity and the duration for consideration of popularity.',
        'category' => 'Documents',
        'type' => 'widget',
        'name' => 'document.categorized-documents',
        'defaultParams' => array(
            'title' => 'Categorically Popular Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Category Count',
                        'description' => 'No. of categories to show. Enter 0 for showing all categories.',
                        'value' => 0,
                    )
                ),
                array(
                    'Text',
                    'documentCount',
                    array(
                        'label' => 'Documents Count per Category',
                        'description' => 'No. of Documents to be shown in each category.',
                        'value' => 5,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                    )
                ),
                $popularityDuration,
                $titleTruncationElement,
            ),
        ),
    ),
    array(
        'title' => 'Categories Hierarchy for Documents (sidebar)',
        'description' => 'Displays the Categories, Sub-categories and 3<sup>rd</sup> Level-categories of documents in an expandable form. Clicking on them will redirect the viewer to the list of documents created in that category.',
        'category' => 'Documents',
        'type' => 'widget',
        'name' => 'document.sidebar-categories-documents',
        'defaultParams' => array(
            'title' => 'Categories',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => 'Categories Hierarchy for Documents',
        'description' => 'Displays the Categories, Sub-categories and 3<sup>rd</sup> Level-categories of documents in an expandable form. Clicking on them will redirect the viewer to the list of documents created in that category.',
        'category' => 'Documents',
        'type' => 'widget',
        'name' => 'document.middle-column-categories-documents',
        'defaultParams' => array(
            'title' => 'Categories',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Radio',
                    'showAllCategories',
                    array(
                        'label' => 'Do you want all the categories, sub-categories and 3rd level categories to be shown to the users even if they have 0 documents in them?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 0,
                    )
                ),
                array(
                    'Radio',
                    'show2ndlevelCategory',
                    array(
                        'label' => 'Do you want to show 2nd level category to the viewer?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
                array(
                    'Radio',
                    'show3rdlevelCategory',
                    array(
                        'label' => 'Do you want to show 3rd level category to the viewer? (This settings will only work if you choose to show sub-categories from the setting above.)',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 0,
                    )
                ),
            )
        ),
    ),
    array(
        'title' => 'Content Type: Profile Documents',
        'description' => "Displays a list of documents in the content being currently viewed. You can manage the content types for which document owners will be able to manage documents from the Manage Modules section of Documents Sharing Plugin - Google Docs Viewer. This widget should be placed on content's Profile page.",
        'category' => 'Documents',
        'type' => 'widget',
        'name' => 'document.contenttype-documents',
        'defaultParams' => array(
            'title' => 'Documents',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'MultiCheckbox',
                    'layoutsViews',
                    array(
                        'label' => 'Select the view type for documents.',
                        'multiOptions' => array("1" => "List View", "2" => "Grid View"),
                    ),
                ),
                array(
                    'Radio',
                    'layoutsOrder',
                    array(
                        'label' => 'Select a default view type for documents.',
                        'multiOptions' => array("1" => "List View", "2" => "Grid View"),
                    )
                ),
                $gridColumnWidth,
                $gridColumnHeight,
                $documentOption,
                array(
                    'Select',
                    'show_content',
                    array(
                        'label' => 'What do you want for view more content?',
                        'multiOptions' => array(
                            '1' => 'Pagination',
                            '2' => 'Show View More Link at Bottom',
                            '3' => 'Auto Load Documents on Scrolling Down'),
                        'value' => 2,
                    )
                ),
                $itemCount,
                $titleTruncationElement,
                $descriptionTruncationElement
            ),
        ),
    ),
    array(
        'title' => 'Upload New Document',
        'description' => 'Displays a create document link.( Create link will be visible if user level is allowed to create documents )',
        'category' => 'Documents',
        'type' => 'widget',
        'name' => 'document.create-documents',
    ),
    array(
        'title' => 'Document Social Share Buttons',
        'description' => "Contains Social Sharing buttons and enables users to easily share Documents on their favorite Social Networks. This widget should be placed on the Document View Page. You can customize the code for social sharing buttons from Global Settings of this plugin by adding your own code generated from: <a href='http://www.addthis.com' target='_blank'>http://www.addthis.com</a>",
        'category' => 'Documents',
        'type' => 'widget',
        'name' => 'document.socialshare-documents',
        'defaultParams' => array(
            'title' => 'Social Share',
            'titleCount' => true,
        ),
        'requirements' => array(
            'subject' => 'document',
        ),
        'adminForm' => array(
            'elements' => array(
            ),
        ),
    ),
    array(
        'title' => 'Document Viewer',
        'description' => 'Displays the document viewer for viewing document. You can select the viewer type from ‘Global Settings’ of this plugin. This widget should be placed on Document View Page',
        'category' => 'Documents',
        'type' => 'widget',
        'name' => 'document.document-view-documents',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'requirements' => array(
            'subject' => 'document',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'documentViewerHeight',
                    array(
                        'descript'
                        . ''
                        . 'ion' => 'Enter the height of the document viewer (in pixels).',
                        'value' => 600,
                    )
                ),
//                array(
//                    'Text',
//                    'documentViewerWidth',
//                    array(
//                        'description' => 'Enter the width of the document viewer (in pixels).',
//                        'value' => 730,
//                    )
//                ),
            ),
        ),
    ),
    array(
        'title' => 'Document View Page Options',
        'description' => 'Displays the various action links that can be performed on the document on document’s view page (edit, download, report, share, etc ). This widget should be placed on the Document View Page in the right column, below the Document Owner’s photo. You can manage the action links available here from the Menu Editor section by choosing Document View Page Options Menu.',
        'category' => 'Documents',
        'type' => 'widget',
        'name' => 'document.options-documents',
        'requirements' => array(
            'subject' => 'document',
        ),
        'adminForm' => array(
            'elements' => array(
            ),
        ),
    ),
    array(
        'title' => 'Special Documents',
        'description' => 'Displays documents as special documents. You can choose the documents to be shown in this widget by editing the settings of this widget. This widget should be placed in the left / right side bar on the respective widgetized page.',
        'category' => 'Documents',
        'type' => 'widget',
        'autoEdit' => true,
        'name' => 'document.special-documents',
        'adminForm' => 'Document_Form_Admin_Widget_Specialdocuments',
        'defaultParams' => array(
            'title' => 'Special Documents',
            'documentOption' => array('title', 'owner', 'featured', 'sponsored', 'view', 'like', 'comment', 'rating', 'likeButton', 'facebook', 'twitter', 'linkedin', 'googleplus'),
            'columnWidth' => '210',
            'columnHeight' => '355',
            'itemCount' => 3
        ),
    ),
    array(
        'title' => 'Featured Documents Carousel',
        'description' => 'Displays a list of featured documents in carousel.',
        'category' => 'Documents',
        'type' => 'widget',
        'name' => 'document.featured-documents',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                $categoryElement,
                $contentTypeElement,
                $gridColumnWidth,
                $documentOption,
                $itemCount,
            ),
        ),
    ),
    array(
        'title' => 'Featured Documents',
        'description' => 'Displays a list of featured documents.',
        'category' => 'Documents',
        'type' => 'widget',
        'name' => 'document.featurelist-documents',
        'defaultParams' => array(
            'title' => 'Featured Documents',
            'titleCount' => true,
            'documentOption' => array('title', 'owner', 'featured', 'sponsored', 'view', 'like', 'comment', 'rating', 'likeButton', 'facebook', 'twitter', 'linkedin', 'googleplus'),
            'columnWidth' => '210',
            'columnHeight' => '355',
            'itemCount' => 3
        ),
        'adminForm' => array(
            'elements' => array(
                $categoryElement,
                $contentTypeElement,
                $gridColumnWidth,
                $gridColumnHeight,
                $documentOption,
                $titleTruncationElement,
                $itemCount,
            ),
        ),
    ),
    array(
        'title' => 'Featured Documents Slideshow',
        'description' => 'Displays the featured documents in an attractive form of Slideshow with interactive controls.',
        'category' => 'Documents',
        'type' => 'widget',
        'name' => 'document.slideshow-featured-documents',
        'defaultParams' => array(
            'title' => 'Featured Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                $categoryElement,
                $contentTypeElement,
                $descriptionTruncationElement,
                $itemCount,
            ),
        ),
    ),
    array(
        'title' => 'Member’s Profile Document',
        'description' => "Displays the member’s documents on their profile. This widget should be placed in the tabbed blocks area of Member Profile Page.",
        'category' => 'Documents',
        'type' => 'widget',
        'name' => 'document.profile-doc-documents',
        'defaultParams' => array(
            'title' => 'Profile Document',
            'titleCount' => true,
        ),
        'requirements' => array(
            'subject' => 'user',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'documentViewerHeight',
                    array(
                        'label' => 'Enter the height of the document viewer (in pixels).',
                        'value' => 600,
                    )
                ),
//                array(
//                    'Text',
//                    'documentViewerWidth',
//                    array(
//                        'description' => 'Enter the width of the document viewer (in pixels).',
//                        'value' => 730,
//                    )
//                ),
                array(
                    'Radio',
                    'download',
                    array(
                        'label' => "Do you want to show the 'Download' link to members? [ Note: You can apply this setting on per member level basis from ‘Member Level Settings’. ]",
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
                array(
                    'Radio',
                    'email',
                    array(
                        'label' => "Do you want to show the 'Email Document' link to members?[ Note: You can apply this setting on per member level basis from ‘Member Level Settings’. ]",
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
                array(
                    'Radio',
                    'share',
                    array(
                        'label' => "Do you want to show the 'Share' link to members? [Note: This link is also dependent on Global Settings section of this plugin.]",
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
                array(
                    'Radio',
                    'report',
                    array(
                        'label' => "Do you want to show the 'Report' link to members? [Note: This link is also dependent on Global Settings of this plugin.]",
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
                array(
                    'Radio',
                    'comment_like',
                    array(
                        'label' => "Do you want to show the Comments box to members? (This box also has the link for “Like”)? [Note: These are also dependent on Member Level Settings.]",
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
                $titleTruncationElement,
            ),
        ),
    ),
    array(
        'title' => 'Manage Documents',
        'description' => 'Displays a list of manage documents.',
        'category' => 'Documents',
        'type' => 'widget',
        'name' => 'document.manage-documents',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'MultiCheckbox',
                    'layoutsViews',
                    array(
                        'label' => 'Select the view type for documents.',
                        'multiOptions' => array("1" => "List View", "2" => "Grid View"),
                    ),
                ),
                array(
                    'Radio',
                    'layoutsOrder',
                    array(
                        'label' => 'Select a default view type for documents.',
                        'multiOptions' => array("1" => "List View", "2" => "Grid View"),
                    )
                ),
                
                $gridColumnWidth,
                $gridColumnHeight,
                $documentOption,
                  array(
                    'Select',
                    'show_content',
                    array(
                        'label' => 'What do you want for view more content?',
                        'multiOptions' => array(
                            '1' => 'Pagination',
                            '2' => 'Show View More Link at Bottom',
                            '3' => 'Auto Load Documents on Scrolling Down'),
                        'value' => 2,
                    )
                ),
                $titleTruncationElement,
                $descriptionTruncationElement,
                $itemCount,
            ),
        ),
    ),
    array(
        'title' => 'Most Commented Documents',
        'description' => 'Displays a list of most commented documents.',
        'category' => 'Documents',
        'type' => 'widget',
        'name' => 'document.comment-documents',
        'defaultParams' => array(
            'title' => 'Most Commented Documents',
            'titleCount' => true,
            'documentOption' => array('title', 'owner', 'featured', 'sponsored', 'view', 'like', 'comment', 'rating', 'likeButton', 'facebook', 'twitter', 'linkedin', 'googleplus'),
            'columnWidth' => '210',
            'columnHeight' => '355',
            'itemCount' => 3
        ),
        'adminForm' => array(
            'elements' => array(
                $categoryElement,
                $contentTypeElement,
                $gridColumnWidth,
                $gridColumnHeight,
                $documentOption,
                $titleTruncationElement,
                $itemCount,
            ),
        ),
    ),
    array(
        'title' => 'Message for No Documents',
        'description' => 'Displays a message to users when there are no documents. This widget should be placed in the top of the middle column of Documents Home page.',
        'category' => 'Documents',
        'type' => 'widget',
        'name' => 'document.zero-documents',
    ),
    array(
        'title' => 'Most Liked Documents',
        'description' => 'Displays a list of most liked documents.',
        'category' => 'Documents',
        'type' => 'widget',
        'name' => 'document.like-documents',
        'defaultParams' => array(
            'title' => 'Most Liked Documents',
            'titleCount' => true,
            'documentOption' => array('title', 'owner', 'featured', 'sponsored', 'view', 'like', 'comment', 'rating', 'likeButton', 'facebook', 'twitter', 'linkedin', 'googleplus'),
            'columnWidth' => '210',
            'columnHeight' => '355',
            'itemCount' => 3
        ),
        'adminForm' => array(
            'elements' => array(
                $categoryElement,
                $contentTypeElement,
                $gridColumnWidth,
                $gridColumnHeight,
                $documentOption,
                $titleTruncationElement,
                $itemCount,
            ),
        ),
    ),
    array(
        'title' => 'Navigation Tabs',
        'description' => 'Display navigation tabs',
        'category' => 'Documents',
        'type' => 'widget',
        'name' => 'document.navigation-documents',
    ),
    array(
        'title' => "Owner’s Document Archives",
        'description' => 'Displays the month-wise archives for the documents posted by the document owner. This widget should be placed on Document View Page.',
        'category' => 'Documents',
        'type' => 'widget',
        'name' => 'document.archives-documents',
        'defaultParams' => array(
            'title' => 'Archives',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => 'Owner’s Photo',
        'description' => 'Displays the document owner’s photo with owner’s name. This widget should be placed in the right column of Document View Page.',
        'category' => 'Documents',
        'type' => 'widget',
        'name' => 'document.document-owner-photo-documents',
        'requirements' => array(
            'subject' => 'document',
        ),
    ),
    array(
        'title' => "Owner’s Documents",
        'description' => 'Displays a list of owner’s other documents. This widget should be placed on Document View Page.',
        'category' => 'Documents',
        'type' => 'widget',
        'name' => 'document.document-owner-documents',
        'defaultParams' => array(
            'title' => '',
            'documentOption' => array('title', 'owner', 'featured', 'sponsored', 'view', 'like', 'comment', 'rating', 'likeButton', 'facebook', 'twitter', 'linkedin', 'googleplus'),
            'columnWidth' => '210',
            'columnHeight' => '355',
            'itemCount' => 3
        ),
        'requirements' => array(
            'subject' => 'document',
        ),
        'adminForm' => array(
            'elements' => array(
                $categoryElement,
                $contentTypeElement,
                $gridColumnWidth,
                $gridColumnHeight,
                $documentOption,
                $titleTruncationElement,
                $itemCount,
            ),
        ),
    ),
    array(
        'title' => 'Profile Documents',
        'description' => 'Displays a member\'s documents on their profile.',
        'category' => 'Documents',
        'type' => 'widget',
        'name' => 'document.profile-documents',
        'defaultParams' => array(
            'title' => 'Documents',
            'titleCount' => true,
        ),
        'requirements' => array(
            'subject' => 'user',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'MultiCheckbox',
                    'layoutsViews',
                    array(
                        'label' => 'Select the view type for documents.',
                        'multiOptions' => array("1" => "List View", "2" => "Grid View"),
                    ),
                ),
                array(
                    'Radio',
                    'layoutsOrder',
                    array(
                        'label' => 'Select a default view type for documents.',
                        'multiOptions' => array("1" => "List View", "2" => "Grid View"),
                    )
                ),
                $gridColumnWidth,
                $gridColumnHeight,
                $documentOption,
                $itemCount,
                $titleTruncationElement,
                $descriptionTruncationElement
            ),
        ),
    ),
    array(
        'title' => 'Popular Documents',
        'description' => 'Displays a list of most viewed documents.',
        'category' => 'Documents',
        'type' => 'widget',
        'name' => 'document.popular-documents',
        'defaultParams' => array(
            'title' => 'Popular Documents',
            'titleCount' => true,
            'documentOption' => array('title', 'owner', 'featured', 'sponsored', 'view', 'like', 'comment', 'rating', 'likeButton', 'facebook', 'twitter', 'linkedin', 'googleplus'),
            'columnWidth' => '210',
            'columnHeight' => '355',
            'itemCount' => 3
        ),
        'adminForm' => array(
            'elements' => array(
                $categoryElement,
                $contentTypeElement,
                $gridColumnWidth,
                $gridColumnHeight,
                $documentOption,
                $titleTruncationElement,
                $itemCount,
            ),
        ),
    ),
    array(
        'title' => 'Popular Tags',
        'description' => 'Shows popular tags with frequency.',
        'category' => 'Documents',
        'type' => 'widget',
        'name' => 'document.tagcloud-documents',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Radio',
                    'orderingType',
                    array(
                        'label' => 'Do you want to show popular document tags in alphabetical order?',
                        'multiOptions' => array(
                            '1' => 'Yes',
                            '0' => 'No'
                        ),
                        'value' => '1',
                    )
                ),
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(Number of tags to show. Enter 0 for displaying all tags.)',
                        'value' => 25,
                    )
                ),
                array(
                    'Radio',
                    'loaded_by_ajax',
                    array(
                        'label' => 'Widget Content Loading',
                        'description' => 'Do you want the content of this widget to be loaded via AJAX, after the loading of main webpage content? (Enabling this can improve webpage loading speed. Disabling this would load content of this widget along with the page content.)',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
            ),
        ),
    ),
    array(
        'title' => 'Recent Documents',
        'description' => 'Displays a list of recently created documents.',
        'category' => 'Documents',
        'type' => 'widget',
        'name' => 'document.recent-documents',
        'defaultParams' => array(
            'title' => 'Recent Documents',
            'documentOption' => array('title', 'owner', 'featured', 'sponsored', 'view', 'like', 'comment', 'rating', 'likeButton', 'facebook', 'twitter', 'linkedin', 'googleplus'),
            'columnWidth' => '210',
            'columnHeight' => '355',
            'itemCount' => 3
        ),
        'adminForm' => array(
            'elements' => array(
                $categoryElement,
                $contentTypeElement,
                $gridColumnWidth,
                $gridColumnHeight,
                $documentOption,
                $titleTruncationElement,
                $itemCount,
            ),
        ),
    ),
    array(
        'title' => 'Sponsored Documents Carousel',
        'description' => 'This widget contains an attractive AJAX based carousel, showcasing the sponsored Documents on the site.',
        'category' => 'Documents',
        'type' => 'widget',
        'name' => 'document.sponsored-documents',
        'defaultParams' => array(
            'title' => 'Sponsored Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                $categoryElement,
                $contentTypeElement,
                array(
                    'Text',
                    'interval',
                    array(
                        'label' => 'Speed',
                        'description' => '(transition interval between two slides in millisecs)',
                        'value' => 300,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                    )
                ),
                $gridColumnWidth,
                $gridColumnHeight,
                $documentOption,
                $titleTruncationElement,
                $itemCount,
            ),
        ),
    ),
    array(
        'title' => 'Search Documents form',
        'description' => 'Displays search form.',
        'category' => 'Documents',
        'type' => 'widget',
        'name' => 'document.search-documents',
        'adminForm' => array(
            'elements' => array(
                array(
                    'Radio',
                    'viewType',
                    array(
                        'label' => 'Show Search Form',
                        'multiOptions' => array(
                            'horizontal' => 'Horizontal',
                            'vertical' => 'Vertical',
                        ),
                        'value' => 'vertical'
                    )
                ),
                array(
                    'Radio',
                    'showAllCategories',
                    array(
                        'label' => 'Do you want all the categories, sub-categories and 3rd level categories to be shown to the users even if they have 0 documents in them?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
            )
        )
    ),
    array(
        'title' => 'Search Text Box',
        'description' => 'Displays search box at document view page. This widget should be placed on Document View Page in right/left column',
        'category' => 'Documents',
        'type' => 'widget',
        'name' => 'document.search-box-documents',
        'defaultParams' => array(
            'title' => 'Search Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Select',
                    'category_id',
                    array(
                        'label' => 'Category',
                        'multiOptions' => $categories_prepared,
                    )
                ),
            ),
        ),
    ),
    array(
        'title' => 'Top Rated Documents',
        'description' => 'Displays a list of top rated documents.',
        'category' => 'Documents',
        'type' => 'widget',
        'name' => 'document.rate-documents',
        'defaultParams' => array(
            'title' => 'Top Rated Documents',
            'titleCount' => true,
            'documentOption' => array('title', 'owner', 'featured', 'sponsored', 'view', 'like', 'comment', 'rating', 'likeButton', 'facebook', 'twitter', 'linkedin', 'googleplus'),
            'columnWidth' => '210',
            'columnHeight' => '355',
            'itemCount' => 3
        ),
        'adminForm' => array(
            'elements' => array(
                $categoryElement,
                $contentTypeElement,
                $gridColumnWidth,
                $gridColumnHeight,
                $documentOption,
                $titleTruncationElement,
                $itemCount,
            ),
        ),
    ),
    array(
        'title' => 'Document Categories: Displays Categories in Grid View with Icons',
        'description' => 'Displays document categories with icons in grid view on Document Categories Home page.',
        'category' => 'Documents',
        'type' => 'widget',
        'autoEdit' => true,
        'name' => 'document.categories-withicon-grid-view',
        'defaultParams' => array(
            'title' => 'Categories',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Radio',
                    'orderBy',
                    array(
                        'label' => 'Default ordering of Categories in Grid View.',
                        'multiOptions' => array(
                            'category_name' => 'Category Name',
                            'cat_order' => 'Category Order according to creation'
                        ),
                        'value' => 'cat_order',
                    )
                ),
                array(
                    'Radio',
                    'showAllCategories',
                    array(
                        'label' => 'Do you want all the categories to be shown to the users even if they have 0 documents in them?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 0,
                    )
                ),
                array(
                    'Text',
                    'columnWidth',
                    array(
                        'label' => 'Column width for Grid View.',
                        'value' => '234',
                    )
                ),
                array(
                    'Text',
                    'columnHeight',
                    array(
                        'label' => 'Column height for Grid View.',
                        'value' => '216',
                    )
                ),
                array(
                    'Radio',
                    'showIcon',
                    array(
                        'label' => 'Do you want to show categories icon ?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
            )
        ),
    ),
    array(
        'title' => 'Category Based Documents',
        'description' => 'Displays the category based Documents.',
        'category' => 'Documents',
        'type' => 'widget',
        'name' => 'document.categories-grid-view-documents',
        'defaultParams' => array(
            'title' => 'Categories',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                $categoryElement,
                $contentTypeElement,
                $gridColumnWidth,
                $gridColumnHeight,
                $documentOption,
                $titleTruncationElement
            ),
        ),
    ),
    array(
        'title' => 'Document Profile: Breadcrumb',
        'description' => 'Displays breadcrumb of the document based on the categories. This widget should be placed on the Documents Profile page.',
        'category' => 'Documents',
        'type' => 'widget',
        'name' => 'document.list-profile-breadcrumb',
        'adminForm' => array(
            'elements' => array(
            ),
        ),
    ),
        )
?>
