<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Document
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2016-07-12 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Document_Widget_AjaxHomeDocumentsController extends Engine_Content_Widget_Abstract {

    public function indexAction() {
        $this->view->id = $this->view->identity;

        //GET DOCUMENT TABLE
        $documentTable = Engine_Api::_()->getDbtable('documents', 'document');
        $showTabArray = $this->_getParam('layoutsTabs', array("0" => "1", "1" => "2", "2" => "3", "3" => "4", "4" => '5'));
        $document_ajaxHomeDocuments = Zend_Registry::isRegistered('document_ajaxHomeDocuments') ? Zend_Registry::get('document_ajaxHomeDocuments') : null;
        $ShowViewArray = $this->_getParam('layoutsViews', array("0" => "1", "1" => "2", "2" => "3"));
        $defaultOrder = $this->_getParam('layoutsOrder', 1);
        $this->view->widgetSettings = $this->_getAllParams();
        //in_array function gives warning if we document option do not come form settings, so used default params
        $this->view->widgetSettings['documentOption'] = $this->_getParam('documentOption', array('title', 'owner', 'featured', 'sponsored', 'view', 'like', 'comment', 'rating', 'likeButton', 'facebook', 'twitter', 'linkedin', 'googleplus'));

        $this->view->listView = 0;
        $this->view->gridView = 0;
        $this->view->defaultView = -1;
        $listLimit = 0;
        $gridLimit = 0;
        if(empty($document_ajaxHomeDocuments))
            return $this->setNoRender();
        
        if (in_array("1", $ShowViewArray)) {
            $this->view->listView = 1;
            $listLimit = $this->_getParam('listLimit', 10);
            if ($this->view->defaultView == -1 || $defaultOrder == 1)
                $this->view->defaultView = 0;
        }
        if (in_array("2", $ShowViewArray)) {
            $this->view->gridView = 1;
            $gridLimit = $this->_getParam('gridLimit', 15);
            if ($this->view->defaultView == -1 || $defaultOrder == 2)
                $this->view->defaultView = 1;
        }
        if (in_array("3", $ShowViewArray)) {
            $this->view->map_view = 1;
            $listLimit = $this->_getParam('listLimit', 10);
            if ($this->view->defaultView == -1 || $defaultOrder == 3)
                $this->view->defaultView = 2;
        }

        $documentRecently = array();
        $documentViewed = array();
        $documentRandom = array();
        $documentFeatured = array();
        $documentSponosred = array();

        if (in_array("1", $showTabArray)) {
            $params = array();
            $params['limit'] = 1;
            $documentRecently = $documentTable->widgetDocumentsData($params);
        }

        if (in_array("2", $showTabArray)) {
            $params = array();
            $params['limit'] = 1;
            $params['orderby'] = 'views DESC';
            $params['zero_count'] = 'views';
            $documentViewed = $documentTable->widgetDocumentsData($params);
        }

        if (in_array("3", $showTabArray)) {
            $params = array();
            $params['limit'] = 1;
            $params['orderby'] = 'RAND() DESC';
            $documentRandom = $documentTable->widgetDocumentsData($params);
        }

        if (in_array("4", $showTabArray)) {
            $params = array();
            $params['limit'] = 1;
            $params['orderby'] = 'featured DESC';
            $params['featured'] = 1;
            $documentFeatured = $documentTable->widgetDocumentsData($params);
        }

        if (in_array("5", $showTabArray)) {
            $params = array();
            $params['limit'] = 1;
            $params['orderby'] = 'sponsored DESC';
            $params['sponsored'] = 1;
            $documentSponosred = $documentTable->widgetDocumentsData($params);
        }

        if ((!(Count($documentRecently) > 0) && !(Count($documentViewed) > 0) && !(Count($documentRandom) > 0 ) && !(Count($documentFeatured) > 0 ) && !(Count($documentSponosred) > 0 )) || ($this->view->defaultView == -1)) {
            return $this->setNoRender();
        }

        $tabsOrder = array();
        $tabs = array();
        $menuTabs = array();
        if (Count($documentRecently) > 0) {
            $tabs['recent'] = array('title' => 'Recent', 'tabShow' => 'Recently Posted');
            $tabsOrder['recent'] = $this->_getParam('recentOrder', 1);
        }
        if (Count($documentViewed) > 0) {
            $tabs['popular'] = array('title' => 'Most Popular', 'tabShow' => 'Most Viewed');
            $tabsOrder['popular'] = $this->_getParam('popularOrder', 2);
        }
        if (Count($documentRandom) > 0) {
            $tabs['random'] = array('title' => 'Random', 'tabShow' => 'Random');
            $tabsOrder['random'] = $this->_getParam('randomOrder', 3);
        }

        if (Count($documentFeatured) > 0) {
            $tabs['featured'] = array('title' => 'Featured', 'tabShow' => 'Featured');
            $tabsOrder['featured'] = $this->_getParam('featuredOrder', 4);
        }
        if (Count($documentSponosred) > 0) {
            $tabs['sponosred'] = array('title' => 'Sponsored', 'tabShow' => 'Sponosred');
            $tabsOrder['sponosred'] = $this->_getParam('sponosredOrder', 5);
        }
        @asort($tabsOrder);
        $firstIndex = key($tabsOrder);
        foreach ($tabsOrder as $key => $value) {
            $menuTabs[$key] = $tabs[$key];
        }

        $this->view->tabs = $menuTabs;
        $this->view->active_tab_list = $listLimit;
        $this->view->active_tab_image = $gridLimit;
        $limit = $listLimit > $gridLimit ? $listLimit : $gridLimit;

        if ($menuTabs[$firstIndex]['tabShow'] == 'Most Viewed') {
            $params = array();
            $params['orderby'] = 'views DESC';
            $params['zero_count'] = 'views';
            $params['limit'] = $limit;
        } elseif ($menuTabs[$firstIndex]['tabShow'] == 'Featured') {
            $params = array();
            $params['orderby'] = 'featured DESC';
            $params['featured'] = 1;
            $params['limit'] = $limit;
        } elseif ($menuTabs[$firstIndex]['tabShow'] == 'Sponosred') {
            $params = array();
            $params['orderby'] = 'sponsored DESC';
            $params['sponsored'] = 1;
            $params['limit'] = $limit;
        } elseif ($menuTabs[$firstIndex]['tabShow'] == 'Random') {
            $params = array();
            $params['orderby'] = 'RAND() DESC';
            $params['limit'] = $limit;
        } else {
            $params = array();
            $params['limit'] = $limit;
        }
        $params['category_id'] = $this->view->widgetSettings['category_id'];

        $request = Zend_Controller_Front::getInstance()->getRequest();
        $params['documentType'] = $contentType = $request->getParam('documentType', null);
        if (empty($contentType)) {
            $params['documentType'] = $this->_getParam('documentType', 'All');
        }
        $this->view->documentType = $params['documentType'];
        //SEND DATA TO TPL
        $this->view->documents = $documentTable->widgetDocumentsData($params);
    }

}
