<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Document
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2016-07-12 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Document_Widget_CategoriesGridViewDocumentsController extends Engine_Content_Widget_Abstract {

    public function indexAction() {

        //GET DOCUMENT TABLE
        $documentTable = Engine_Api::_()->getDbtable('documents', 'document');
        $this->view->widgetSettings = $this->_getAllParams();
        //in_array function gives warning if we document option do not come form settings, so used default params
        $this->view->widgetSettings['documentOption'] = $this->_getParam('documentOption', array('title', 'owner', 'featured', 'sponsored', 'view', 'like', 'comment', 'rating', 'likeButton', 'facebook', 'twitter', 'linkedin', 'googleplus'));
        $params = array();
        $params['category_id'] = $this->view->widgetSettings['category_id'];

        $this->view->documentCount = $documentTable->getDocumentsCount($params);


        $params['limit'] = 5;
        if (empty($params['category_id']))
            return $this->setNoRender();
        $this->getElement()->removeDecorator('Title');
        $request = Zend_Controller_Front::getInstance()->getRequest();
        $params['documentType'] = $contentType = $request->getParam('documentType', null);
        if (empty($contentType)) {
            $params['documentType'] = $this->_getParam('documentType', 'All');
        }
        $this->view->documents = $documentTable->widgetDocumentsData($params);
        $documentCategoriesGridViewDocuments = Zend_Registry::isRegistered('documentCategoriesGridViewDocuments') ? Zend_Registry::get('documentCategoriesGridViewDocuments') : null;
        if (empty($documentCategoriesGridViewDocuments))
            return $this->setNoRender();

        if (!count($this->view->documents)) {
            return $this->setNoRender();
        }

        $this->view->categoryObj = Engine_Api::_()->getItem('document_category', $params['category_id']);

        $this->view->truncation = $this->_getParam('truncation', '30');
        if (!$this->view->categoryObj) {
            return $this->setNoRender();
        }
    }

}
