<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Document
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2016-07-12 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Document_Widget_CategoriesWithiconGridViewController extends Engine_Content_Widget_Abstract {

    public function indexAction() {

        $tableCategory = Engine_Api::_()->getDbtable('categories', 'document');
        $tableDocument = Engine_Api::_()->getDbtable('documents', 'document');
        $this->view->columnWidth = $this->_getParam('columnWidth', 268);
        $this->view->columnHeight = $this->_getParam('columnHeight', 260);
        $showAllCategories = $this->_getParam('showAllCategories', 0);
        $orderBy = $this->_getParam('orderBy', 'cat_order');
        $this->view->showIcon = $this->_getParam('showIcon', 1);
        $this->view->storage = Engine_Api::_()->storage();
        $havingDocuments = !$showAllCategories;

        // GET ALL CATEGORIES
        $categories = $tableCategory->getDocumentCategories(array('fetchColumns' => array('category_id', 'cat_dependency', 'category_name', 'cat_order', 'icon_id', 'image_id'), 'cat_depandancy' => 1, 'havingDocuments' => $havingDocuments, 'orderBy' => $orderBy));
        $count = count($categories);
        if ($count == 0)
            return $this->setNoRender();

        $categoryParams = array();
        foreach ($categories as $category) {

            $tempCategoryParams['category_id'] = $category->getIdentity();
            $tempCategoryParams['title'] = $category->getTitle();
            $tempCategoryParams['order'] = $category->cat_order;
            $tempCategoryParams['icon_id'] = $category->icon_id;
            $tempCategoryParams['image_id'] = $category->image_id;
            $tempCategoryParams['count'] = !empty($count) ? $tableDocument->getDocumentsCount(array('category_id' => $category->category_id, 'columnName' => 'category_id', 'foruser' => 1)) : false;
            $categoryParams[] = $tempCategoryParams;
        }
        $this->view->categoryParams = $categoryParams;
    }

}
