<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Document
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2016-07-12 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Document_Widget_CreateDocumentsController extends Engine_Content_Widget_Abstract {

    public function indexAction() {
        //GET VIEWER DETAILS
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();
        if (!empty($viewer_id)) {
            $level_id = $viewer->level_id;
        } else {
            $level_id = Engine_Api::_()->getDbtable('levels', 'authorization')->fetchRow(array('type = ?' => "public"))->level_id;
        }
        
        //IF CAN NOT VIEW AND CREATE DOCUMENTS THEN DON'T RENDER THE WIDGET
        $can_view = Engine_Api::_()->authorization()->getPermission($level_id, 'document', 'view');
        $documentCreateDocuments = Zend_Registry::isRegistered('documentCreateDocuments') ? Zend_Registry::get('documentCreateDocuments') : null;
        $can_create = Engine_Api::_()->authorization()->getPermission($level_id, 'document', 'create');
        if (empty($can_view) || empty($can_create) || empty($viewer_id) || empty($documentCreateDocuments)) {
            return $this->setNoRender();
        }
    }

}

?>