<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Document
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2016-07-12 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Document_Widget_DocumentOwnerDocumentsController extends Engine_Content_Widget_Abstract {

    public function indexAction() {
        //SET NO RENDER IF NO SUBJECT
        if (!Engine_Api::_()->core()->hasSubject()) {
            return $this->setNoRender();
        }

        //SET NO RENDER IF SUBJECT OF DOCUMENT IS NOT FIND
        $document = Engine_Api::_()->core()->getSubject('document');
        if (empty($document)) {
            return $this->setNoRender();
        }   
        $this->getElement()->removeDecorator('Title');
        //GET OWNER INFORMATION
        $this->view->owner = $document->getOwner();
        $this->view->widgetSettings = $this->_getAllParams();
        //in_array function gives warning if we document option do not come form settings, so used default params
        $this->view->widgetSettings['documentOption'] = $this->_getParam('documentOption', array('title', 'owner', 'featured', 'sponsored', 'view', 'like', 'comment', 'rating', 'likeButton', 'facebook', 'twitter', 'linkedin', 'googleplus'));
        //FETCH DOCUMENTS
        $params = array();
        $params['orderby'] = 'document_id DESC';
        $params['owner_id'] = $document->owner_id;
        $params['document_id'] = $document->document_id;
        $params['category_id'] = $this->_getParam('category_id');
        $params['limit'] = $this->_getParam('itemCount', 3);
        $request = Zend_Controller_Front::getInstance()->getRequest();
        $params['documentType'] = $contentType = $request->getParam('documentType', null);
        if (empty($contentType)) {
            $params['documentType'] = $params['documentType'] = $this->_getParam('documentType', 'All');
        }
        $this->view->paginator = Engine_Api::_()->getDbtable('documents', 'document')->widgetDocumentsData($params);

        //SET NO RENDER IF DATA IS EMPTY
        if (Count($this->view->paginator) <= 0) {
            return $this->setNoRender();
        }
    }

}

?>