<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Document
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2016-07-12 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Document_Widget_DocumentOwnerPhotoDocumentsController extends Engine_Content_Widget_Abstract {

    public function indexAction() {
        //DON'T RENDER IF SUBJECT IS NOT SET
        if (!Engine_Api::_()->core()->hasSubject()) {
            return $this->setNoRender();
        }

        //GET SUBJECT
        $document = Engine_Api::_()->core()->getSubject();

        $this->view->document = $document;

        //GET DOCUMENT OWNER
        $this->view->owner = $document->getOwner();
        
        $documentOwnerPhotoDocuments = Zend_Registry::isRegistered('documentOwnerPhotoDocuments') ? Zend_Registry::get('documentOwnerPhotoDocuments') : null;
        $this->view->circularImage = Engine_Api::_()->getApi('settings', 'core')->getSetting('document.circular.image', 1);
        if(empty($documentOwnerPhotoDocuments))
            return $this->setNoRender();
    }

}

?>