<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Document
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2016-07-12 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Document_Widget_ListProfileBreadcrumbController extends Seaocore_Content_Widget_Abstract {

    public function indexAction() {

        $front = Zend_Controller_Front::getInstance();
        $module = $front->getRequest()->getModuleName();
        $action = $front->getRequest()->getActionName();
        $controller = $front->getRequest()->getControllerName();
        //DONT RENDER IF SUBJECT IS NOT SET
        if (!Engine_Api::_()->core()->hasSubject('document')) {
            return $this->setNoRender();
        }

        //GET SUBJECT
        $this->view->document = $document = Engine_Api::_()->core()->getSubject('document');
        $documentListProfileBreadcrumb = Zend_Registry::isRegistered('documentListProfileBreadcrumb') ? Zend_Registry::get('documentListProfileBreadcrumb') : null;
        if(empty($documentListProfileBreadcrumb))
            return $this->setNoRender();

        //GET CATEGORY TABLE
        $this->view->tableCategory = Engine_Api::_()->getDbTable('categories', 'document');
        if (!empty($document->category_id)) {
            $this->view->category_name = $this->view->tableCategory->getCategory($document->category_id)->category_name;

            if (!empty($document->subcategory_id)) {
                $this->view->subcategory_name = $this->view->tableCategory->getCategory($document->subcategory_id)->category_name;

                if (!empty($document->subsubcategory_id)) {
                    $this->view->subsubcategory_name = $this->view->tableCategory->getCategory($document->subsubcategory_id)->category_name;
                }
            }
        }
    }

}
