<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Document
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2016-07-12 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Document_Widget_ManagedocumentsController extends Seaocore_Content_Widget_Abstract {

    public function indexAction() {
        //GET VIEWER DETAILS
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();
        $level_id = $viewer->level_id;
        $this->view->is_ajax = $isAjax = $this->_getParam('isajax', 0);
        $this->view->widgetSettings = $this->_getAllParams();
        //in_array function gives warning if we document option do not come form settings, so used default params
        $this->view->widgetSettings['documentOption'] = $this->_getParam('documentOption', array('title', 'owner', 'featured', 'sponsored', 'view', 'like', 'comment', 'rating', 'likeButton', 'facebook', 'twitter', 'linkedin', 'googleplus'));
         if ($this->_getParam('widgetSettings')) {
            $this->view->widgetSettings = $this->_getParam('widgetSettings');
        }
        //GET NAVIGATION
        $documentManageDocuments = Zend_Registry::isRegistered('documentManageDocuments') ? Zend_Registry::get('documentManageDocuments') : null;
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('document_main', array(), 'document_main_manage');
        $this->view->showContent = $this->_getParam('show_content', 2);
        //VIEW, EDIT, DELETE AND PROFILE DOCUMENT CHECKS FOR DOCUMENT
        $this->view->can_view = Engine_Api::_()->authorization()->getPermission($level_id, 'document', 'view');
        $this->view->can_edit = Engine_Api::_()->authorization()->getPermission($level_id, 'document', 'edit');
        $this->view->can_delete = Engine_Api::_()->authorization()->getPermission($level_id, 'document', 'delete');
        $this->view->can_profile_doc = Engine_Api::_()->authorization()->getPermission($level_id, 'document', 'profile_doc');
        $this->view->layoutsViews = $layoutsViews = $this->_getParam('layoutsViews', array("1" => "1", "2" => "2"));
        $this->view->layoutsOrder = $layoutsOrder = $this->_getParam('layoutsOrder', 2);
        $this->view->countLayoutsViews = count($layoutsViews);
        $this->view->listView = 0;
        $this->view->gridView = 0;
        if (in_array("1", $layoutsViews)) {
            $this->view->listView = 1;
            if ($layoutsOrder == 1)
                $this->view->defaultView = 0;
        }
        if (in_array("2", $layoutsViews)) {
            $this->view->gridView = 1;
            if ($layoutsOrder == 2)
                $this->view->defaultView = 1;
        }
        if(empty($documentManageDocuments))
            return $this->setNoRender();

        //CHECK VIEWER CAN CREATE DOCUMENT
        $this->view->can_create = Engine_Api::_()->authorization()->isAllowed('document', $viewer, 'create');

        //CHECK THAT RATING IS VIEABLE OR NOT
        $this->view->show_rate = Engine_Api::_()->getApi('settings', 'core')->getSetting('document.rating', 1);

        //GET SEARCH FORM
        $this->view->form = $form = new Document_Form_Search();
        $form->removeElement('show');

        //GET FORM VALUES
        if ($form->isValid($this->_getAllParams())) {
            $values = $form->getValues();
        } else {
            $values = array();
        }
        $this->view->formValues = $values;

        $values['user_id'] = $viewer_id;
        $this->view->assign($values);
        $documentTable = Engine_Api::_()->getDbtable('documents', 'document');

        if ($_GET) {
            $values = array_merge($values, $_GET);
        }

        $request = Zend_Controller_Front::getInstance()->getRequest();
        $page = $request->getParam('page', 1);

        //GET CUSTOM FIELD VALUES
        $customFieldValues = array_intersect_key($values, $form->getFieldElements());

        //GET PAGINATOR
        $this->view->paginator = $paginator = $documentTable->getDocumentsPaginator($values, $customFieldValues);
         $this->view->totalCount = $paginator->getTotalItemCount();
        $this->view->total_count = $total_documents = $this->_getParam('itemCount', 10);
        $this->view->paginator->setItemCountPerPage($total_documents);
        $this->view->paginator->setCurrentPageNumber($page);
    }

}
