<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Document
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2016-07-12 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Document_Widget_RateDocumentsController extends Engine_Content_Widget_Abstract {

    public function indexAction() {
        //CHECK THAT RATING IS ALLOWED OR NOT
        $show_rate = Engine_Api::_()->getApi('settings', 'core')->getSetting('document.rating', 1);
        if (empty($show_rate)) {
            return $this->setNoRender();
        }
        $this->view->widgetSettings = $this->_getAllParams();

        $params = array();
        $params['orderby'] = 'rating DESC';
        $params['zero_count'] = 'rating';
        $params['limit'] = $this->_getParam('itemCount', 3);
        $params['category_id'] = $this->_getParam('category_id');
        $request = Zend_Controller_Front::getInstance()->getRequest();
        $params['documentType'] = $contentType = $request->getParam('documentType', null);
        if (empty($contentType)) {
            $params['documentType'] = $this->_getParam('documentType', 'All');
        }
        $this->view->documentType = $params['documentType'];
        $documentRateDocuments = Zend_Registry::isRegistered('documentRateDocuments') ? Zend_Registry::get('documentRateDocuments') : null;
        $this->view->paginator = Engine_Api::_()->getDbtable('documents', 'document')->widgetDocumentsData($params);

        if(empty($documentRateDocuments))
            return $this->setNoRender();
        
        if (Count($this->view->paginator) <= 0) {
            return $this->setNoRender();
        }
    }

}
