<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Documentintegration
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminModulesController.php 6590 2015-1-22 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Documentintegration_AdminModulesController extends Core_Controller_Action_Admin {

    protected $_enabledModuleNames;

    public function indexAction() {
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('document_admin_main', array(), 'document_admin_main_modules');
        $this->view->integrated = $integrated = Engine_Api::_()->getDbtable('modules', 'document')->getIntegratedModules();
    }

    public function addAction() {

        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('document_admin_main', array(), 'document_admin_main_modules');

        $this->view->form = $form = new Documentintegration_Form_Admin_Module_Add();

        if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
            $values = $form->getValues();
            //BEGIN TRANSACTION
            $db = Engine_Db_Table::getDefaultAdapter();
            $db->beginTransaction();
            try {
                $integratedTable = Engine_Api::_()->getDbtable('modules', 'document');
                $resourceTypeTable = Engine_Api::_()->getItemTable($values['item_type']);
                $primaryId = current($resourceTypeTable->info("primary"));
                if (!empty($primaryId))
                    $values['item_id'] = $primaryId;
                $row = $integratedTable->createRow();
                $row->setFromArray($values);
                $row->save();

                foreach ($values as $key => $value) {
                    Engine_Api::_()->getApi('settings', 'core')->setSetting($key, $value);
                }

                $db->commit();
            } catch (Exception $e) {
                $db->rollBack();
                throw $e;
            }
            $this->_redirect('admin/documentintegration/modules');
        }
    }

    public function editAction() {

        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('document_admin_main', array(), 'document_admin_main_modules');

        $id = Zend_Controller_Front::getInstance()->getRequest()->getParam('id', null);
        $integratedTable = Engine_Api::_()->getDbTable('modules', 'document');
        $integratedTableResult = $integratedTable->fetchRow(array('module_id = ?' => $id));
        $integratedRowValues = $integratedTableResult->toArray();
        $item_module = Zend_Controller_Front::getInstance()->getRequest()->getParam('item_module', null);
        $this->view->form = $form = new Documentintegration_Form_Admin_Module_Edit();

        $form->populate($integratedRowValues);

        if ($item_module == 'sitereview') {
            $form->item_type->setValue('sitereview_listing');
        }

        if ($this->getRequest()->isPost() && !$form->isValid($this->getRequest()->getPost())) {
            if ($item_module == 'sitereview') {
                $form->item_module->setValue('sitereview');
                $form->item_type->setValue('sitereview_listing');
            } else {
                $form->item_module->setValue($item_module);
                $form->item_type->setValue($integratedRowValues->item_type);
            }
            $form->item_module->setAttrib('disable', true);
            $form->item_type->setAttrib('disable', true);
            return;
        }

        $form->item_module->setAttrib('disable', true);
        $form->item_type->setAttrib('disable', true);

        if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
            $values = $form->getValues();
            $item_type = $integratedTableResult->item_type;
            $item_module = $integratedTableResult->item_module;
            $item_id = $integratedTableResult->item_id;
            $type = $item_module . 'document_document';
            unset($values['item_module']);
            unset($values['item_type']);


            //BEGIN TRANSACTION
            $db = Engine_Db_Table::getDefaultAdapter();
            $db->beginTransaction();
            try {
                $integratedTableResult->setFromArray($values);
                $integratedTableResult->save();

                foreach ($values as $key => $value) {
                    Engine_Api::_()->getApi('settings', 'core')->setSetting($key, $value);
                }

                $db->commit();
            } catch (Exception $e) {
                $db->rollBack();
                throw $e;
            }
            $this->_redirect('admin/documentintegration/modules');
        }
    }

    public function deleteAction() {
        $this->_helper->layout->setLayout('admin-simple');
        $this->view->id = $id = $this->_getParam('id');
        $integratedTable = Engine_Api::_()->getDbtable('modules', 'document');
        $integratedTableSelect = $integratedTable->fetchRow(array('module_id = ?' => $id));
        $this->view->module = $integratedTableSelect->item_module;
        if ($this->getRequest()->isPost()) {
            $integratedTableSelect->delete();
            $this->_forward('success', 'utility', 'core', array(
                'smoothboxClose' => 10,
                'parentRefresh' => 10,
                'messages' => array(Zend_Registry::get('Zend_Translate')->_(''))
            ));
        }
    }

    public function enabledDisabledAction() {
        $id = $this->_getParam('id');
        $coreModuleTable = Engine_Api::_()->getDbtable('modules', 'core');
        $db = Engine_Db_Table::getDefaultAdapter();
        $db->beginTransaction();
        $table = Engine_Api::_()->getDbtable('modules', 'document');
        $select = $table->select()->where('module_id =?', $id);
        $content = $table->fetchRow($select);
        $enabled = $content->enabled;
        $integrated = $content->integrated;

        if ($content->enabled == 0 && $content->integrated == 0) {
            $item_type = $content->item_type;
            $item_module = $content->item_module;
            $item_id = $content->item_id;
            $document_id = false;
            if ($item_module == 'sitepage' || $item_module == 'sitebusiness' || $item_module == 'sitegroup' || $item_module == 'sitestore') {
                $type = $item_module . 'document_document';
                $explodedArray = explode('_', $item_id);
                $itemShortType = 'getWidgetized' . ucfirst($explodedArray[0]);
                if (Engine_Api::_()->$item_module()->$itemShortType()) {
                    $page_id = Engine_Api::_()->$item_module()->$itemShortType()->page_id;
                }
                $db = Engine_Db_Table::getDefaultAdapter();

                Engine_Api::_()->getDbtable('admincontent', $item_module)->setAdminDefaultInfo('document.contenttype-documents', $page_id, 'Documents', 'true', '117', '{"title":"Documents","layoutsViews":["1","2"],"layoutsOrder":"2","columnWidth":"195","columnHeight":"355","documentOption":["title","owner","featured","sponsored","view","like","comment","rating","likeButton","facebook","twitter","linkedin","googleplus"],"show_content":"2","itemCount":"12","truncation":"10","descriptionTruncation":"225","nomobile":"0","name":"document.contenttype-documents"}');

                if (Engine_Api::_()->hasModuleBootstrap('sitemobile')) {
                    $itemMobileShortType = 'getMobileWidgetized' . ucfirst($explodedArray[0]);

                    $mobilepage_id = Engine_Api::_()->$item_module()->$itemMobileShortType()->page_id;
                    if ($mobilepage_id) {
                        Engine_Api::_()->getDbtable('mobileadmincontent', $item_module)->setAdminDefaultInfo('document.contenttype-documents', $mobilepage_id, 'Documents', 'true', '117', '{"title":"Documents","layoutsViews":["1","2"],"layoutsOrder":"2","columnWidth":"195","columnHeight":"355","documentOption":["title","owner","featured","sponsored","view","like","comment","rating","likeButton","facebook","twitter","linkedin","googleplus"],"show_content":"2","itemCount":"12","truncation":"10","descriptionTruncation":"225","nomobile":"0","name":"document.contenttype-documents"}');

                        Engine_Api::_()->getApi('mobilelayoutcore', $item_module)->setContentDefaultInfo('document.contenttype-documents', $mobilepage_id, 'Documents', 'true', '117', '{"title":"Documents","layoutsViews":["1","2"],"layoutsOrder":"2","columnWidth":"195","columnHeight":"355","documentOption":["title","owner","featured","sponsored","view","like","comment","rating","likeButton","facebook","twitter","linkedin","googleplus"],"show_content":"2","itemCount":"12","truncation":"10","descriptionTruncation":"225","nomobile":"0","name":"document.contenttype-documents"}');
                    }
                }

                Engine_Api::_()->getApi('layoutcore', $item_module)->setContentDefaultInfo('document.contenttype-documents', $page_id, 'Documents', 'true', '117', '{"title":"Documents","layoutsViews":["1","2"],"layoutsOrder":"2","columnWidth":"195","columnHeight":"355","documentOption":["title","owner","featured","sponsored","view","like","comment","rating","likeButton","facebook","twitter","linkedin","googleplus"],"show_content":"2","itemCount":"12","truncation":"10","descriptionTruncation":"225","nomobile":"0","name":"document.contenttype-documents"}');

                if ($item_module == 'sitepage') {

                    //GET SITEPAGE CONTENT TABLE
                    $sitepagecontentTable = Engine_Api::_()->getDbtable('content', 'sitepage');
                    //GET SITEPAGE CONTENT PAGES TABLE
                    $sitepagepageTable = Engine_Api::_()->getDbtable('contentpages', 'sitepage');
                    $selectsitepagePage = $sitepagepageTable->select()
                            ->from($sitepagepageTable->info('name'), array('contentpage_id'))
                            ->where('name =?', 'sitepage_index_view');
                    $contentpages_id = $selectsitepagePage->query()->fetchAll();
                    foreach ($contentpages_id as $key => $value) {
                        $sitepagecontentTable->setDefaultInfo('document.contenttype-documents', $value['contentpage_id'], 'Documents', 'true', '117', '{"title":"Documents","layoutsViews":["1","2"],"layoutsOrder":"2","columnWidth":"195","columnHeight":"355","documentOption":["title","owner","featured","sponsored","view","like","comment","rating","likeButton","facebook","twitter","linkedin","googleplus"],"show_content":"2","itemCount":"12","truncation":"10","descriptionTruncation":"225","nomobile":"0","name":"document.contenttype-documents"}');
                    }

                    if (Engine_Api::_()->hasModuleBootstrap('sitemobile') && Engine_Api::_()->$item_module()->getMobileWidgetizedPage()) {

                        //GET SITEPAGE CONTENT TABLE
                        $sitepagemobilecontentTable = Engine_Api::_()->getDbtable('mobileContent', 'sitepage');
                        //GET SITEPAGE CONTENT PAGES TABLE
                        $sitepagemobilecontentpagesTable = Engine_Api::_()->getDbtable('mobileContentpages', 'sitepage');
                        $selectsitepagemobilePage = $sitepagemobilecontentpagesTable->select()
                                ->from($sitepagemobilecontentpagesTable->info('name'), array('mobilecontentpage_id'))
                                ->where('name =?', 'sitepage_index_view');
                        $contentmobilepages_id = $selectsitepagemobilePage->query()->fetchAll();
                        foreach ($contentmobilepages_id as $key => $value) {
                            $sitepagemobilecontentTable->setDefaultInfo('document.contenttype-documents', $value['mobilecontentpage_id'], 'Documents', 'true', '117', '{"title":"Documents","layoutsViews":["1","2"],"layoutsOrder":"2","columnWidth":"195","columnHeight":"355","documentOption":["title","owner","featured","sponsored","view","like","comment","rating","likeButton","facebook","twitter","linkedin","googleplus"],"show_content":"2","itemCount":"12","truncation":"10","descriptionTruncation":"225","nomobile":"0","name":"document.contenttype-documents"}');
                        }
                    }

                    $db->query("INSERT IGNORE INTO `engine4_core_settings` ( `name`, `value`) VALUES( 'document.leader.owner.sitepage.page', '1');");
                    if (Engine_Api::_()->sitepage()->hasPackageEnable()) {
                        Engine_Api::_()->sitepage()->oninstallPackageEnableSubMOdules('sitepagedocument');
                    }
                    $sitepagedocumentEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitepagedocument');

                    if ($sitepagedocumentEnabled) {
                        $sitepagedocumentTable = Engine_Api::_()->getDbTable('documents', 'sitepagedocument');

                        $coreModuleTable->update(array('enabled' => 0), array('name = ?' => 'sitepagedocument'));
                        Engine_Api::_()->getDbtable('content', 'core')->delete(array('name =?' => 'sitepagedocument.profile-sitepagedocuments'));
                        Engine_Api::_()->getDbtable('content', 'core')->delete(array('name =?' => 'sitepagedocument.profile-documents'));
                        Engine_Api::_()->getDbtable('admincontent', 'sitepage')->delete(array('name =?' => 'sitepagedocument.profile-sitepagedocuments'));
                        Engine_Api::_()->getDbtable('admincontent', 'sitepage')->delete(array('name =?' => 'sitepagedocument.profile-documents'));
                        Engine_Api::_()->getDbtable('content', 'sitepage')->delete(array('name =?' => 'sitepagedocument.profile-sitepagedocuments'));
                        Engine_Api::_()->getDbtable('content', 'sitepage')->delete(array('name =?' => 'sitepagedocument.profile-documents'));
                    }
                } elseif ($item_module == 'sitebusiness') {
                    //GET SITEBUSINESS CONTENT TABLE
                    $sitebusinesscontentTable = Engine_Api::_()->getDbtable('content', 'sitebusiness');
                    //GET SITEBUSINESS CONTENT PAGES TABLE
                    $sitebusinessbusinessTable = Engine_Api::_()->getDbtable('contentbusinesses', 'sitebusiness');
                    $selectsitebusinessBusiness = $sitebusinessbusinessTable->select()
                            ->from($sitebusinessbusinessTable->info('name'), array('contentbusiness_id'))
                            ->where('name =?', 'sitebusiness_index_view');
                    $contentbusinesses_id = $selectsitebusinessBusiness->query()->fetchAll();
                    foreach ($contentbusinesses_id as $key => $value) {
                        $sitebusinesscontentTable->setDefaultInfo('document.contenttype-documents', $value['contentbusiness_id'], 'Documents', 'true', '117', '{"title":"Documents","layoutsViews":["1","2"],"layoutsOrder":"2","columnWidth":"195","columnHeight":"355","documentOption":["title","owner","featured","sponsored","view","like","comment","rating","likeButton","facebook","twitter","linkedin","googleplus"],"show_content":"2","itemCount":"12","truncation":"10","descriptionTruncation":"225","nomobile":"0","name":"document.contenttype-documents"}');
                    }

                    if (Engine_Api::_()->hasModuleBootstrap('sitemobile') && Engine_Api::_()->$item_module()->getMobileWidgetizedBusiness()) {
                        //GET SITEBUSINESS CONTENT TABLE
                        $sitebusinesscontentTable = Engine_Api::_()->getDbtable('mobileContent', 'sitebusiness');
                        //GET SITEBUSINESS CONTENT PAGES TABLE
                        $sitebusinessbusinessTable = Engine_Api::_()->getDbtable('mobileContentbusinesses', 'sitebusiness');
                        $selectsitebusinessBusiness = $sitebusinessbusinessTable->select()
                                ->from($sitebusinessbusinessTable->info('name'), array('mobilecontentbusiness_id'))
                                ->where('name =?', 'sitebusiness_index_view');
                        $contentbusinesses_id = $selectsitebusinessBusiness->query()->fetchAll();
                        foreach ($contentbusinesses_id as $key => $value) {
                            $sitebusinesscontentTable->setDefaultInfo('document.contenttype-documents', $value['mobilecontentbusiness_id'], 'Documents', 'true', '117', '{"title":"Documents","layoutsViews":["1","2"],"layoutsOrder":"2","columnWidth":"195","columnHeight":"355","documentOption":["title","owner","featured","sponsored","view","like","comment","rating","likeButton","facebook","twitter","linkedin","googleplus"],"show_content":"2","itemCount":"12","truncation":"10","descriptionTruncation":"225","nomobile":"0","name":"document.contenttype-documents"}');
                        }
                    }


                    $db->query("INSERT IGNORE INTO `engine4_core_settings` ( `name`, `value`) VALUES( 'document.leader.owner.sitebusiness.business', '1');");
                    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
                        Engine_Api::_()->sitebusiness()->oninstallPackageEnableSubMOdules('sitebusinessdocument');
                    }
                    $sitebusinessdocumentEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessdocument');

                    if ($sitebusinessdocumentEnabled) {
                        $sitebusinessdocumentTable = Engine_Api::_()->getDbTable('documents', 'sitebusinessdocument');
                        $sitebusinessdocumentTableName = $sitebusinessdocumentTable->info('name');
                        $document_id = $sitebusinessdocumentTable->select()
                                ->from($sitebusinessdocumentTableName, 'document_id')
                                ->query()
                                ->fetchColumn();
                        if (!$document_id) {
                            $coreModuleTable->update(array('enabled' => 0), array('name = ?' => 'sitebusinessdocument'));
                            Engine_Api::_()->getDbtable('content', 'core')->delete(array('name =?' => 'sitebusinessdocument.profile-sitebusinessdocuments'));
                            Engine_Api::_()->getDbtable('content', 'core')->delete(array('name =?' => 'sitebusinessdocument.profile-documents'));
                            Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->delete(array('name =?' => 'sitebusinessdocument.profile-sitebusinessdocuments'));
                            Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->delete(array('name =?' => 'sitebusinessdocument.profile-documents'));
                            Engine_Api::_()->getDbtable('content', 'sitebusiness')->delete(array('name =?' => 'sitebusinessdocument.profile-sitebusinessdocuments'));
                            Engine_Api::_()->getDbtable('content', 'sitebusiness')->delete(array('name =?' => 'sitebusinessdocument.profile-documents'));
                        }
                    }
                } elseif ($item_module == 'sitegroup') {
                    //GET SITEGROUP CONTENT TABLE
                    $sitegroupcontentTable = Engine_Api::_()->getDbtable('content', 'sitegroup');
                    //GET SITEGROUP CONTENT PAGES TABLE
                    $sitegroupgroupTable = Engine_Api::_()->getDbtable('contentgroups', 'sitegroup');
                    $selectsitegroupGroup = $sitegroupgroupTable->select()
                            ->from($sitegroupgroupTable->info('name'), array('contentgroup_id'))
                            ->where('name =?', 'sitegroup_index_view');
                    $contentgroups_id = $selectsitegroupGroup->query()->fetchAll();
                    foreach ($contentgroups_id as $key => $value) {
                        $sitegroupcontentTable->setDefaultInfo('document.contenttype-documents', $value['contentgroup_id'], 'Documents', 'true', '117', '{"title":"Documents","layoutsViews":["1","2"],"layoutsOrder":"2","columnWidth":"195","columnHeight":"355","documentOption":["title","owner","featured","sponsored","view","like","comment","rating","likeButton","facebook","twitter","linkedin","googleplus"],"show_content":"2","itemCount":"12","truncation":"10","descriptionTruncation":"225","nomobile":"0","name":"document.contenttype-documents"}');
                    }
                    $db->query("INSERT IGNORE INTO `engine4_core_settings` ( `name`, `value`) VALUES( 'document.leader.owner.sitegroup.group', '0');");
                    if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
                        Engine_Api::_()->sitegroup()->oninstallPackageEnableSubMOdules('sitegroupdocument');
                    }

                    $sitegroupdocumentEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitegroupdocument');

                    if ($sitegroupdocumentEnabled) {
                        $sitegroupdocumentTable = Engine_Api::_()->getDbTable('documents', 'sitegroupdocument');
                        $sitegroupdocumentTableName = $sitegroupdocumentTable->info('name');
                        $document_id = $sitegroupdocumentTable->select()
                                ->from($sitegroupdocumentTableName, 'document_id')
                                ->query()
                                ->fetchColumn();
                        if (!$document_id) {
                            $coreModuleTable->update(array('enabled' => 0), array('name = ?' => 'sitegroupdocument'));
                            Engine_Api::_()->getDbtable('content', 'core')->delete(array('name =?' => 'sitegroupdocument.profile-sitegroupdocuments'));
                            Engine_Api::_()->getDbtable('content', 'core')->delete(array('name =?' => 'sitegroupdocument.profile-documents'));
                            Engine_Api::_()->getDbtable('admincontent', 'sitegroup')->delete(array('name =?' => 'sitegroupdocument.profile-sitegroupdocuments'));
                            Engine_Api::_()->getDbtable('admincontent', 'sitegroup')->delete(array('name =?' => 'sitegroupdocument.profile-documents'));
                            Engine_Api::_()->getDbtable('content', 'sitegroup')->delete(array('name =?' => 'sitegroupdocument.profile-sitegroupdocuments'));
                            Engine_Api::_()->getDbtable('content', 'sitegroup')->delete(array('name =?' => 'sitegroupdocument.profile-documents'));
                        }
                    }

                    if (Engine_Api::_()->hasModuleBootstrap('sitemobile') && Engine_Api::_()->$item_module()->getMobileWidgetizedGroup()) {
                        //GET SITEGROUP CONTENT TABLE
                        $sitegroupcontentTable = Engine_Api::_()->getDbtable('mobileContent', 'sitegroup');
                        //GET SITEGROUP CONTENT PAGES TABLE
                        $sitegroupgroupTable = Engine_Api::_()->getDbtable('mobileContentgroups', 'sitegroup');
                        $selectsitegroupGroup = $sitegroupgroupTable->select()
                                ->from($sitegroupgroupTable->info('name'), array('mobilecontentgroup_id'))
                                ->where('name =?', 'sitegroup_index_view');
                        $contentgroups_id = $selectsitegroupGroup->query()->fetchAll();
                        foreach ($contentgroups_id as $key => $value) {
                            $sitegroupcontentTable->setDefaultInfo('document.contenttype-documents', $value['mobilecontentgroup_id'], 'Documents', 'true', '117', '{"title":"Documents","layoutsViews":["1","2"],"layoutsOrder":"2","columnWidth":"195","columnHeight":"355","documentOption":["title","owner","featured","sponsored","view","like","comment","rating","likeButton","facebook","twitter","linkedin","googleplus"],"show_content":"2","itemCount":"12","truncation":"10","descriptionTruncation":"225","nomobile":"0","name":"document.contenttype-documents"}');
                        }
                    }
                } elseif ($item_module == 'sitestore') {
                    //GET SITESTORE CONTENT TABLE
                    $sitestorecontentTable = Engine_Api::_()->getDbtable('content', 'sitestore');
                    //GET SITESTORE CONTENT STORES TABLE
                    $sitestorestoreTable = Engine_Api::_()->getDbtable('contentstores', 'sitestore');
                    $selectsitestoreStore = $sitestorestoreTable->select()
                            ->from($sitestorestoreTable->info('name'), array('contentstore_id'))
                            ->where('name =?', 'sitestore_index_view');
                    $contentstores_id = $selectsitestoreStore->query()->fetchAll();
                    foreach ($contentstores_id as $key => $value) {
                        $sitestorecontentTable->setDefaultInfo('document.contenttype-documents', $value['contentstore_id'], 'Documents', 'true', '117', '{"title":"Documents","layoutsViews":["1","2"],"layoutsOrder":"2","columnWidth":"195","columnHeight":"355","documentOption":["title","owner","featured","sponsored","view","like","comment","rating","likeButton","facebook","twitter","linkedin","googleplus"],"show_content":"2","itemCount":"12","truncation":"10","descriptionTruncation":"225","nomobile":"0","name":"document.contenttype-documents"}');
                    }
                    $db->query("INSERT IGNORE INTO `engine4_core_settings` ( `name`, `value`) VALUES( 'document.leader.owner.sitestore.store', '1');");
                    if (Engine_Api::_()->sitestore()->hasPackageEnable()) {
                        Engine_Api::_()->sitestore()->oninstallPackageEnableSubMOdules('sitestoredocument');
                    }

                    $sitestoredocumentEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitestoredocument');

                    if ($sitestoredocumentEnabled) {
                        $sitestoredocumentTable = Engine_Api::_()->getDbTable('documents', 'sitestoredocument');
                        $sitestoredocumentTableName = $sitestoredocumentTable->info('name');
                        $document_id = $sitestoredocumentTable->select()
                                ->from($sitestoredocumentTableName, 'document_id')
                                ->query()
                                ->fetchColumn();
                        if (!$document_id) {
                            $coreModuleTable->update(array('enabled' => 0), array('name = ?' => 'sitestoredocument'));
                            Engine_Api::_()->getDbtable('content', 'core')->delete(array('name =?' => 'sitestoredocument.profile-sitestoredocuments'));
                            Engine_Api::_()->getDbtable('content', 'core')->delete(array('name =?' => 'sitestoredocument.profile-documents'));
                            Engine_Api::_()->getDbtable('admincontent', 'sitestore')->delete(array('name =?' => 'sitestoredocument.profile-sitestoredocuments'));
                            Engine_Api::_()->getDbtable('admincontent', 'sitestore')->delete(array('name =?' => 'sitestoredocument.profile-documents'));
                            Engine_Api::_()->getDbtable('content', 'sitestore')->delete(array('name =?' => 'sitestoredocument.profile-sitestoredocuments'));
                            Engine_Api::_()->getDbtable('content', 'sitestore')->delete(array('name =?' => 'sitestoredocument.profile-documents'));
                        }
                    }

                    if (Engine_Api::_()->hasModuleBootstrap('sitemobile') && Engine_Api::_()->$item_module()->getMobileWidgetizedStore()) {
                        //GET SITESTORE CONTENT TABLE
                        $sitestorecontentTable = Engine_Api::_()->getDbtable('mobileContent', 'sitestore');
                        //GET SITESTORE CONTENT PAGES TABLE
                        $sitestorestoreTable = Engine_Api::_()->getDbtable('mobileContentstores', 'sitestore');
                        $selectsitestoreStore = $sitestorestoreTable->select()
                                ->from($sitestorestoreTable->info('name'), array('mobilecontentstore_id'))
                                ->where('name =?', 'sitestore_index_view');
                        $contentstores_id = $selectsitestoreStore->query()->fetchAll();
                        foreach ($contentstores_id as $key => $value) {
                            $sitestorecontentTable->setDefaultInfo('document.contenttype-documents', $value['mobilecontentstore_id'], 'Documents', 'true', '117', '{"title":"Documents","layoutsViews":["1","2"],"layoutsOrder":"2","columnWidth":"195","columnHeight":"355","documentOption":["title","owner","featured","sponsored","view","like","comment","rating","likeButton","facebook","twitter","linkedin","googleplus"],"show_content":"2","itemCount":"12","truncation":"10","descriptionTruncation":"225","nomobile":"0","name":"document.contenttype-documents"}');
                        }
                    }
                }

                $db->query('
						INSERT IGNORE INTO `engine4_authorization_permissions` 
						SELECT level_id as `level_id`, 
							"' . $item_type . '" as `type`, 
							"auth_svcreate" as `name`, 
							5 as `value`, 
							\'["registered","owner_network","owner_member_member","owner_member","owner","member","like_member"]\' as `params` 
						FROM `engine4_authorization_levels` WHERE `type` NOT IN("public");
					');
                $db->query('
						INSERT IGNORE INTO `engine4_authorization_permissions` 
						SELECT level_id as `level_id`, 
							"' . $item_type . '" as `type`, 
							"svcreate" as `name`, 
							1 as `value`, 
							NULL as `params`
						FROM `engine4_authorization_levels`;
					');

                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
					SELECT
						level_id as `level_id`,
						'$type' as `type`,
						'view' as `name`,
						2 as `value`,
						NULL as `params`
					FROM `engine4_authorization_levels` WHERE `type` IN('moderator', 'admin');");

                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
					SELECT
						level_id as `level_id`,
						'$type' as `type`,
						'view' as `name`,
						1 as `value`,
						NULL as `params`
					FROM `engine4_authorization_levels` WHERE `type` IN('user');");

                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
					SELECT
						level_id as `level_id`,
						'$type' as `type`,
						'comment' as `name`,
						2 as `value`,
						NULL as `params`
					FROM `engine4_authorization_levels` WHERE `type` IN('moderator', 'admin');");

                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
					SELECT
						level_id as `level_id`,
						'$type' as `type`,
						'comment' as `name`,
						1 as `value`,
						NULL as `params`
					FROM `engine4_authorization_levels` WHERE `type` IN('user');");

                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
					SELECT
						level_id as `level_id`,
						'$type' as `type`,
						'invite' as `name`,
						1 as `value`,
						NULL as `params`
					FROM `engine4_authorization_levels` WHERE `type` IN('moderator', 'admin');");

                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
					SELECT
						level_id as `level_id`,
						'$type' as `type`,
						'invite' as `name`,
						1 as `value`,
						NULL as `params`
					FROM `engine4_authorization_levels` WHERE `type` IN('user');");

                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions` (`level_id`, `type`, `name`, `value`, `params`) VALUES ('5', '$type', 'view', '1', NULL);");

                $feedType = $item_module . 'document_new';
                $adminfeedType = $item_module . 'document_admin_new';
                $db->query("UPDATE `engine4_activity_actiontypes` SET  `module` =  'document' WHERE  `engine4_activity_actiontypes`.`type` =  '$feedType' LIMIT 1;");
                $db->query("UPDATE `engine4_activity_actiontypes` SET  `module` =  'document' WHERE  `engine4_activity_actiontypes`.`type` =  '$adminfeedType' LIMIT 1;");
                $body = '{item:$object} created a new document:';
                $db->query("INSERT IGNORE INTO `engine4_activity_actiontypes` (`type`, `module`, `body`, `enabled`, `displayable`, `attachable`, `commentable`, `shareable`, `is_generated`) VALUES ('$adminfeedType', 'document', '$body', '1', '6', '2', '1', '1', '1');");

                $body = '{item:$subject} created a new document in the ' . $explodedArray[0] . '{item:$object}:';
                $db->query("INSERT IGNORE INTO `engine4_activity_actiontypes` (`type`, `module`, `body`, `enabled`, `displayable`, `attachable`, `commentable`, `shareable`, `is_generated`) VALUES ('$feedType', 'document', '$body', '1', '3', '2', '1', '1', '1');");
            } else if ($item_module == 'siteevent') {

                $db->query('
						INSERT IGNORE INTO `engine4_authorization_permissions` 
						SELECT level_id as `level_id`, 
							"' . $item_type . '" as `type`, 
							"auth_document" as `name`, 
							5 as `value`, 
							\'["registered","owner_network","owner_member_member","owner_member","member","leader"]\' as `params` 
						FROM `engine4_authorization_levels` WHERE `type` NOT IN("public");
					');
                $db->query('
						INSERT IGNORE INTO `engine4_authorization_permissions` 
						SELECT level_id as `level_id`, 
							"' . $item_type . '" as `type`, 
							"document" as `name`, 
							1 as `value`, 
							NULL as `params`
						FROM `engine4_authorization_levels`;
					');

                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
					SELECT
						level_id as `level_id`,
						'$type' as `type`,
						'view' as `name`,
						2 as `value`,
						NULL as `params`
					FROM `engine4_authorization_levels` WHERE `type` IN('moderator', 'admin');");

                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
					SELECT
						level_id as `level_id`,
						'$type' as `type`,
						'view' as `name`,
						1 as `value`,
						NULL as `params`
					FROM `engine4_authorization_levels` WHERE `type` IN('user');");

                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
					SELECT
						level_id as `level_id`,
						'$type' as `type`,
						'comment' as `name`,
						2 as `value`,
						NULL as `params`
					FROM `engine4_authorization_levels` WHERE `type` IN('moderator', 'admin');");

                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
					SELECT
						level_id as `level_id`,
						'$type' as `type`,
						'comment' as `name`,
						1 as `value`,
						NULL as `params`
					FROM `engine4_authorization_levels` WHERE `type` IN('user');");

                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
					SELECT
						level_id as `level_id`,
						'$type' as `type`,
						'invite' as `name`,
						1 as `value`,
						NULL as `params`
					FROM `engine4_authorization_levels` WHERE `type` IN('moderator', 'admin');");

                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
					SELECT
						level_id as `level_id`,
						'$type' as `type`,
						'invite' as `name`,
						1 as `value`,
						NULL as `params`
					FROM `engine4_authorization_levels` WHERE `type` IN('user');");

                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions` (`level_id`, `type`, `name`, `value`, `params`) VALUES ('5', '$type', 'view', '1', NULL);");
                $db->query("INSERT IGNORE INTO `engine4_core_settings` ( `name`, `value`) VALUES( 'document.leader.owner.siteevent.event', '0');");
                $page_id = $db->select()
                        ->from('engine4_core_pages', array('page_id'))
                        ->where('name =?', 'siteevent_index_view')
                        ->limit(1)
                        ->query()
                        ->fetchColumn();

                if (!empty($page_id)) {
                    $tab_id = $db->select()
                            ->from('engine4_core_content', array('content_id'))
                            ->where('page_id =?', $page_id)
                            ->where('type = ?', 'widget')
                            ->where('name = ?', 'core.container-tabs')
                            ->limit(1)
                            ->query()
                            ->fetchColumn();

                    if (!empty($tab_id)) {

                        $content_id = $db->select()
                                ->from('engine4_core_content', array('content_id'))
                                ->where('page_id =?', $page_id)
                                ->where('type = ?', 'widget')
                                ->where('name = ?', 'document.contenttype-documents')
                                ->limit(1)
                                ->query()
                                ->fetchColumn();

                        if (empty($content_id)) {
                            $db->insert('engine4_core_content', array(
                                'page_id' => $page_id,
                                'type' => 'widget',
                                'name' => 'document.contenttype-documents',
                                'parent_content_id' => $tab_id,
                                'order' => 999,
                                'params' => '{"title":"Documents","layoutsViews":["1","2"],"layoutsOrder":"2","columnWidth":"195","columnHeight":"355","documentOption":["title","owner","featured","sponsored","view","like","comment","rating","likeButton","facebook","twitter","linkedin","googleplus"],"show_content":"2","itemCount":"12","truncation":"10","descriptionTruncation":"225","nomobile":"0","name":"document.contenttype-documents"}',
                            ));
                        }
                    }
                }
                Engine_Api::_()->getDbtable('content', 'core')->delete(array('name =?' => 'siteeventdocument.documents-siteeventdocuments'));
                $feedType = $item_module . 'document_new';
                $db->query("UPDATE `engine4_activity_actiontypes` SET  `module` =  'document' WHERE  `engine4_activity_actiontypes`.`type` =  '$feedType' LIMIT 1;");
                $body = '{item:$subject} created a new document in the ' . $explodedArray[0] . '{item:$object}:';
                $db->query("INSERT IGNORE INTO `engine4_activity_actiontypes` (`type`, `module`, `body`, `enabled`, `displayable`, `attachable`, `commentable`, `shareable`, `is_generated`) VALUES ('$feedType', 'document', '$body', '1', '3', '2', '1', '1', '1');");
            } elseif ($item_module == 'group') {
                $db->query('
						INSERT IGNORE INTO `engine4_authorization_permissions` 
						SELECT level_id as `level_id`, 
							"' . $item_type . '" as `type`, 
							"gdcreate" as `name`, 
							5 as `value`, 
							\'["registered","owner_network","owner_member_member","owner_member","member","leader"]\' as `params` 
						FROM `engine4_authorization_levels` WHERE `type` NOT IN("public");
					');
                $db->query('
						INSERT IGNORE INTO `engine4_authorization_permissions` 
						SELECT level_id as `level_id`, 
							"' . $item_type . '" as `type`, 
							"gdcreate" as `name`, 
							1 as `value`, 
							NULL as `params`
						FROM `engine4_authorization_levels`;
					');

                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
					SELECT
						level_id as `level_id`,
						'$type' as `type`,
						'view' as `name`,
						2 as `value`,
						NULL as `params`
					FROM `engine4_authorization_levels` WHERE `type` IN('moderator', 'admin');");

                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
					SELECT
						level_id as `level_id`,
						'$type' as `type`,
						'view' as `name`,
						1 as `value`,
						NULL as `params`
					FROM `engine4_authorization_levels` WHERE `type` IN('user');");

                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
					SELECT
						level_id as `level_id`,
						'$type' as `type`,
						'comment' as `name`,
						2 as `value`,
						NULL as `params`
					FROM `engine4_authorization_levels` WHERE `type` IN('moderator', 'admin');");

                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
					SELECT
						level_id as `level_id`,
						'$type' as `type`,
						'comment' as `name`,
						1 as `value`,
						NULL as `params`
					FROM `engine4_authorization_levels` WHERE `type` IN('user');");

                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
					SELECT
						level_id as `level_id`,
						'$type' as `type`,
						'invite' as `name`,
						1 as `value`,
						NULL as `params`
					FROM `engine4_authorization_levels` WHERE `type` IN('moderator', 'admin');");

                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
					SELECT
						level_id as `level_id`,
						'$type' as `type`,
						'invite' as `name`,
						1 as `value`,
						NULL as `params`
					FROM `engine4_authorization_levels` WHERE `type` IN('user');");

                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions` (`level_id`, `type`, `name`, `value`, `params`) VALUES ('5', '$type', 'view', '1', NULL);");
                $db->query("INSERT IGNORE INTO `engine4_core_settings` ( `name`, `value`) VALUES( 'document.leader.owner.group', '0');");
                $page_id = $db->select()
                        ->from('engine4_core_pages', array('page_id'))
                        ->where('name =?', 'group_index_view')
                        ->limit(1)
                        ->query()
                        ->fetchColumn();

                if (!empty($page_id)) {
                    $tab_id = $db->select()
                            ->from('engine4_core_content', array('content_id'))
                            ->where('page_id =?', $page_id)
                            ->where('type = ?', 'widget')
                            ->where('name = ?', 'core.container-tabs')
                            ->limit(1)
                            ->query()
                            ->fetchColumn();

                    if (!empty($tab_id)) {

                        $content_id = $db->select()
                                ->from('engine4_core_content', array('content_id'))
                                ->where('page_id =?', $page_id)
                                ->where('type = ?', 'widget')
                                ->where('name = ?', 'document.contenttype-documents')
                                ->limit(1)
                                ->query()
                                ->fetchColumn();

                        if (empty($content_id)) {
                            $db->insert('engine4_core_content', array(
                                'page_id' => $page_id,
                                'type' => 'widget',
                                'name' => 'document.contenttype-documents',
                                'parent_content_id' => $tab_id,
                                'order' => 999,
                                'params' => '{"title":"Documents","layoutsViews":["1","2"],"layoutsOrder":"2","columnWidth":"195","columnHeight":"355","documentOption":["title","owner","featured","sponsored","view","like","comment","rating","likeButton","facebook","twitter","linkedin","googleplus"],"show_content":"2","itemCount":"12","truncation":"10","descriptionTruncation":"225","nomobile":"0","name":"document.contenttype-documents"}',
                            ));
                        }
                    }
                }
                Engine_Api::_()->getDbtable('content', 'core')->delete(array('name =?' => 'groupdocuments.profile-groupdocuments'));
                $feedType = $item_module . 'document_new';
                $db->query("UPDATE `engine4_activity_actiontypes` SET  `module` =  'document' WHERE  `engine4_activity_actiontypes`.`type` =  '$feedType' LIMIT 1;");
                $body = '{item:$subject} created a new document in the ' . $explodedArray[0] . '{item:$object}:';
                $db->query("INSERT IGNORE INTO `engine4_activity_actiontypes` (`type`, `module`, `body`, `enabled`, `displayable`, `attachable`, `commentable`, `shareable`, `is_generated`) VALUES ('$feedType', 'document', '$body', '1', '3', '2', '1', '1', '1');");
            } elseif ($item_module == 'event') {
                $db->query('
						INSERT IGNORE INTO `engine4_authorization_permissions` 
						SELECT level_id as `level_id`, 
							"' . $item_type . '" as `type`, 
							"gdcreate" as `name`, 
							5 as `value`, 
							\'["registered","owner_network","owner_member_member","owner_member","member","leader"]\' as `params` 
						FROM `engine4_authorization_levels` WHERE `type` NOT IN("public");
					');
                $db->query('
						INSERT IGNORE INTO `engine4_authorization_permissions` 
						SELECT level_id as `level_id`, 
							"' . $item_type . '" as `type`, 
							"gdcreate" as `name`, 
							1 as `value`, 
							NULL as `params`
						FROM `engine4_authorization_levels`;
					');

                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
					SELECT
						level_id as `level_id`,
						'$type' as `type`,
						'view' as `name`,
						2 as `value`,
						NULL as `params`
					FROM `engine4_authorization_levels` WHERE `type` IN('moderator', 'admin');");

                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
					SELECT
						level_id as `level_id`,
						'$type' as `type`,
						'view' as `name`,
						1 as `value`,
						NULL as `params`
					FROM `engine4_authorization_levels` WHERE `type` IN('user');");

                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
					SELECT
						level_id as `level_id`,
						'$type' as `type`,
						'comment' as `name`,
						2 as `value`,
						NULL as `params`
					FROM `engine4_authorization_levels` WHERE `type` IN('moderator', 'admin');");

                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
					SELECT
						level_id as `level_id`,
						'$type' as `type`,
						'comment' as `name`,
						1 as `value`,
						NULL as `params`
					FROM `engine4_authorization_levels` WHERE `type` IN('user');");

                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
					SELECT
						level_id as `level_id`,
						'$type' as `type`,
						'invite' as `name`,
						1 as `value`,
						NULL as `params`
					FROM `engine4_authorization_levels` WHERE `type` IN('moderator', 'admin');");

                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
					SELECT
						level_id as `level_id`,
						'$type' as `type`,
						'invite' as `name`,
						1 as `value`,
						NULL as `params`
					FROM `engine4_authorization_levels` WHERE `type` IN('user');");

                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions` (`level_id`, `type`, `name`, `value`, `params`) VALUES ('5', '$type', 'view', '1', NULL);");
                $db->query("INSERT IGNORE INTO `engine4_core_settings` ( `name`, `value`) VALUES( 'document.leader.owner.event', '0');");
                $page_id = $db->select()
                        ->from('engine4_core_pages', array('page_id'))
                        ->where('name =?', 'event_index_view')
                        ->limit(1)
                        ->query()
                        ->fetchColumn();

                if (!empty($page_id)) {
                    $tab_id = $db->select()
                            ->from('engine4_core_content', array('content_id'))
                            ->where('page_id =?', $page_id)
                            ->where('type = ?', 'widget')
                            ->where('name = ?', 'core.container-tabs')
                            ->limit(1)
                            ->query()
                            ->fetchColumn();

                    if (!empty($tab_id)) {

                        $content_id = $db->select()
                                ->from('engine4_core_content', array('content_id'))
                                ->where('page_id =?', $page_id)
                                ->where('type = ?', 'widget')
                                ->where('name = ?', 'document.contenttype-documents')
                                ->limit(1)
                                ->query()
                                ->fetchColumn();

                        if (empty($content_id)) {
                            $db->insert('engine4_core_content', array(
                                'page_id' => $page_id,
                                'type' => 'widget',
                                'name' => 'document.contenttype-documents',
                                'parent_content_id' => $tab_id,
                                'order' => 999,
                                'params' => '{"title":"Documents","layoutsViews":["1","2"],"layoutsOrder":"2","columnWidth":"195","columnHeight":"355","documentOption":["title","owner","featured","sponsored","view","like","comment","rating","likeButton","facebook","twitter","linkedin","googleplus"],"show_content":"2","itemCount":"12","truncation":"10","descriptionTruncation":"225","nomobile":"0","name":"document.contenttype-documents"}',
                            ));
                        }
                    }
                }
                Engine_Api::_()->getDbtable('content', 'core')->delete(array('name =?' => 'eventdocuments.profile-eventdocuments'));
                $feedType = $item_module . 'document_new';
                $db->query("UPDATE `engine4_activity_actiontypes` SET  `module` =  'document' WHERE  `engine4_activity_actiontypes`.`type` =  '$feedType' LIMIT 1;");
                $body = '{item:$subject} created a new document in the ' . $explodedArray[0] . '{item:$object}:';
                $db->query("INSERT IGNORE INTO `engine4_activity_actiontypes` (`type`, `module`, `body`, `enabled`, `displayable`, `attachable`, `commentable`, `shareable`, `is_generated`) VALUES ('$feedType', 'document', '$body', '1', '3', '2', '1', '1', '1');");
            } else if ($item_module == 'sitereview') {
                $type = 'sitereview_listing';
                $explodedArray = explode('_', $item_id);
                $explodedItemTypeArray = explode('_', $item_type);
                $listingTypeId = $explodedItemTypeArray[2];

                $db = Engine_Db_Table::getDefaultAdapter();

                $value = "auth_doc_listtype_$listingTypeId";

                $db->query('
						INSERT IGNORE INTO `engine4_authorization_permissions` 
						SELECT level_id as `level_id`, 
							"sitereview_listing" as `type`, 
							"' . $value . '" as `name`, 
							5 as `value`, 
							\'["registered","owner_network","owner_member_member","owner_member","owner"]\' as `params` 
						FROM `engine4_authorization_levels` WHERE `type` NOT IN("public");
					');

                $value = "doc_listtype_$listingTypeId";

                $db->query("
						INSERT IGNORE INTO `engine4_authorization_permissions` 
						SELECT 
									level_id as `level_id`, 
									'sitereview_listing' as `type`, 
									'$value' as `name`, 
									1 as `value`, 
									NULL as `params` 
						FROM `engine4_authorization_levels` WHERE `type` IN('moderator','admin','user');
					");
                $listingType = Engine_Api::_()->getItem('sitereview_listingtype', $listingTypeId);
                $titleSinLc = strtolower($listingType->title_singular);
                $body = '{item:$subject} added a new document in the ' . $titleSinLc . ' listing {item:$object}:';
                $actionType = 'sitereview_document_new_listtype_' . $listingTypeId;
                $db->query("INSERT IGNORE INTO `engine4_activity_actiontypes` (`type`, `module`, `body`, `enabled`, `displayable`, `attachable`, `commentable`, `shareable`, `is_generated`) VALUES ('$actionType', 'document','$body', '1', '3', '2', '1', '1', '1');");
                $db->query("INSERT IGNORE INTO `engine4_core_settings` ( `name`, `value`) VALUES( 'document.leader.owner.sitereview.listing. $listingTypeId', '0');");
            }
        }

        try {
            $content->enabled = !$content->enabled;
            $content->integrated = 1;
            $content->save();
            $db->commit();
        } catch (Exception $e) {
            $db->rollBack();
            throw $e;
        }
        if ($enabled == 0 && $integrated == 0 && $document_id) {
            $this->_redirect('admin/documentintegration/importdocument');
        }

        $this->_redirect('admin/documentintegration/modules');
    }

}
