<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Eventdocument
 * @copyright  Copyright 20011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Level.php 2012-01-25 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Eventdocument_Form_Admin_Settings_Level extends Authorization_Form_Admin_Level_Abstract {

  public function init() {
    parent::init();

    $this
            ->setTitle('Member Level Settings')
            ->setDescription("These settings are applied on a per member level basis. Start by selecting the member level you want to modify, then adjust the settings for that level below.");

    if (!$this->isPublic()) {

      $this->addElement('Radio', 'edcreate', array(
          'label' => 'Allow Creation of Documents in Events?',
          'description' => 'Do you want to let members of this level to create documents in event ?',
          'multiOptions' => array(
              2 => 'Yes, allow members to create documents in all events, including private ones.',
              1 => 'Yes, allow members to create documents in events.',
              0 => 'No, do not allow members to create documents in events.',
          ),
          'value' => ( $this->isModerator() ? 2 : 1 ),
      ));
      if (!$this->isModerator()) {
        unset($this->edcreate->options[2]);
      }

      $this->addElement('MultiCheckbox', 'auth_edcreate', array(
          'label' => 'Document Creation Options',
          'description' => 'Your users can choose from any of the options checked below when they decide who can create the documents in their event. If you do not check any options, everyone will be allowed to create.',
          'multiOptions' => array(
						'registered' => 'Registered Members',
						'owner_network' => 'Friends and Networks',
						'owner_member_member' => 'Friends of Friends',
						'owner_member' => 'Friends Only',
						'member' => "Event Guests Only",
						'owner' => 'Just Me'
          )
      ));
    }
  }

}