<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Eventdocument
 * @copyright  Copyright 20011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 2012-01-25 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Eventdocument_Installer extends Engine_Package_Installer_Module {

  function onPreinstall() {
    $db = $this->getDb();
    $PRODUCT_TYPE = 'eventdocument';
    $PLUGIN_TITLE = 'Eventdocument';
    $PLUGIN_VERSION = '5.4.1';
    $PLUGIN_CATEGORY = 'plugin';
    $PRODUCT_DESCRIPTION = 'Events Documents Extension Plugin';
    $_PRODUCT_FINAL_FILE = 0;
    $SocialEngineAddOns_version = '4.8.5';
    $PRODUCT_TITLE = 'Events Documents Extension Plugin';
    $file_path = APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/ilicense.php";
    $is_file = file_exists($file_path);
    if (empty($is_file)) {
      include_once APPLICATION_PATH . "/application/modules/Eventdocument/controllers/license/license3.php";
    } else {
      $select = new Zend_Db_Select($db);
      $select->from('engine4_core_modules')->where('name = ?', $PRODUCT_TYPE);
      $is_Mod = $select->query()->fetchObject();
      if (empty($is_Mod)) {
        include_once $file_path;
      }
    }

		$select = new Zend_Db_Select($db);
		$select
			->from('engine4_core_settings')
			->where('name = ?', 'eventdocument.code.share');
		$eventdocument_code_share = $select->query()->fetchObject();
		if(empty($eventdocument_code_share))
		{
			$social_share_default_code = '<div class="addthis_toolbox addthis_default_style ">
			<a class="addthis_button_preferred_1"></a>
			<a class="addthis_button_preferred_2"></a>
			<a class="addthis_button_preferred_3"></a>
			<a class="addthis_button_preferred_4"></a>
			<a class="addthis_button_preferred_5"></a>
			<a class="addthis_button_compact"></a>
			<a class="addthis_counter addthis_bubble_style"></a>
			</div>
			<script type="text/javascript">
			var addthis_config = {
								services_compact: "facebook, twitter, linkedin, google, digg, more",
								services_exclude: "print, email"
			}
			</script>
			<script type="text/javascript" src="https://s7.addthis.com/js/250/addthis_widget.js"></script>';

			$db->insert('engine4_core_settings', array(
				'name' => 'eventdocument.code.share',
				'value' => $social_share_default_code,
			));
		}

    parent::onPreinstall();
  }

  function onInstall() {
    $db = $this->getDb();
    
    $select = new Zend_Db_Select($db);
    $select->from('engine4_core_modules')
           ->where('name = ?', 'eventdocument')
           ->where('version <= ?', '4.8.8');
    $is_enabled = $select->query()->fetchObject();
    if (!empty($is_enabled)) {
        $db->query("UPDATE `engine4_eventdocument_documents` SET `thumbnail` = REPLACE(thumbnail, 'http:', 'https:') WHERE `thumbnail` Like 'http:%'");
    }    

    $db->query("UPDATE  `engine4_seaocores` SET  `is_activate` =  '1' WHERE  `engine4_seaocores`.`module_name` ='eventdocument';");

    //CHECK SOCIALENGINEADDONS PLUGIN IS INSTALL OR NOT.
    $pluginName = 'Eventdocument Plugin';
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'seaocore');
    $check_socialengineaddons = $select->query()->fetchAll();

    $baseUrl = $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getBaseUrl();
    $url_string = Zend_Controller_Front::getInstance()->getRequest()->getRequestUri();
    if ( strstr($url_string, "manage/install") ) {
      $calling_from = 'install';
    }
    else if ( strstr($url_string, "manage/query") ) {
      $calling_from = 'queary';
    }
    $explode_base_url = explode("/", $baseUrl);
    foreach ( $explode_base_url as $url_key ) {
      if ( $url_key != 'install' ) {
        $core_final_url .= $url_key . '/';
      }
    }

    if( empty($check_socialengineaddons) ) {
      // SocialEngineAddOns plugin is not install at your site.
			return $this->_error('<div class="global_form"><div><div>The SocialEngineAddOns Core Plugin is not installed on your site. Please download the latest version of this FREE plugin from your Client Area on <a href="http://www.socialengineaddons.com" target="_blank">SocialEngineAddOns</a> and install on your site before installing this plugin.</div></div></div>');
    } else if( !empty($check_socialengineaddons) && empty($check_socialengineaddons[0]['enabled']) ) {
      // Plugin not Enable at your site
      return $this->_error("<span style='color:red'>Note: You have installed the SocialEngineAddOns Core Plugin but not enabled it on your site yet. Please enabled it first before installing the
      $pluginName .</span><br/> <a href='" . 'http://' . $core_final_url . "install/manage/'>Click here</a> to enabled the SocialEngineAddOns Core Plugin.");

    } else if( $check_socialengineaddons[0]['version'] < '4.2.0' ) {
      // Please activate SocialEngineAddOns plugin
      return $this->_error('<div class="global_form"><div><div> You do not have the latest version of the SocialEngineAddOns Core Plugin. Please download the latest version of this FREE plugin from your Client Area on <a href="http://www.socialengineaddons.com" target="_blank">SocialEngineAddOns</a> and upgrade this on your site.</div></div></div>');
    }

    //CHECK THAT ADVANCED-EVENT PLUGIN IS INSTALLED OR NOT
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'advevent')
            ->where('enabled = ?', 1);
    $check_advevent = $select->query()->fetchObject();

    //CHECK THAT ADVANCED-EVENT PLUGIN IS INSTALLED OR NOT
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'ynevent')
            ->where('enabled = ?', 1);
    $check_ynevent = $select->query()->fetchObject();

		//CHECK THAT EVENT PLUGIN IS INSTALLED OR NOT
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'event')
            ->where('enabled = ?', 1);
    $check_event = $select->query()->fetchObject();
    if (!empty($check_event) || !empty($check_advevent) || !empty($check_ynevent)) {

      //CODE FOR INCREASE THE SIZE OF engine4_authorization_permissions's FIELD type
      $type_array = $db->query("SHOW COLUMNS FROM engine4_authorization_permissions LIKE 'type'")->fetch();
      if (!empty($type_array)) {
        $varchar = $type_array['Type'];
        $length_varchar = explode("(", $varchar);
        $length = explode(")", $length_varchar[1]);
        $length_type = $length[0];
        if ($length_type < 32) {
          $run_query = $db->query("ALTER TABLE `engine4_authorization_permissions` CHANGE `type` `type` VARCHAR( 32 ) CHARACTER SET latin1 COLLATE latin1_general_ci NOT NULL");
        }
      }

      $select = new Zend_Db_Select($db);
      $select
              ->from('engine4_core_menuitems')
              ->where('name = ?', 'core_sitemap_eventdocument')
              ->where('module = ?', 'eventdocument')
              ->limit(1);
      $info = $select->query()->fetch();
      if (!empty($info)) {

        $db->delete('engine4_core_menuitems', array(
            'name = ?' => 'core_sitemap_eventdocument',
            'module = ?' => 'eventdocument'
        ));
      }

      $select = new Zend_Db_Select($db);
      $select
              ->from('engine4_core_menuitems')
              ->where('name = ?', 'eventdocument_admin_main_settings')
              ->where('params = ?', '{"route":"admin_default","module":"eventdocument","controller":"settings","action":"readme"}')
              ->limit(1);
      $info = $select->query()->fetch();
      if (!empty($info)) {
        $db->update('engine4_core_menuitems', array(
            'params' => '{"route":"admin_default","module":"eventdocument","controller":"settings"}'
                ), array('name =?' => 'eventdocument_admin_main_settings'));
      }

      //START: PUT DOCUMENT TAB AUTOMATICALLY AT EVENT PROFILE PAGE
      $db = $this->getDb();
      $select = new Zend_Db_Select($db);

      $select
              ->from('engine4_core_pages')
              ->where('name = ?', 'event_profile_index')
              ->limit(1);
      $page_id = $select->query()->fetchObject()->page_id;
      if (!empty($page_id)) {

        $select = new Zend_Db_Select($db);
        $select_content = $select
                        ->from('engine4_core_content')
                        ->where('page_id = ?', $page_id)
                        ->where('type = ?', 'widget')
                        ->where('name = ?', 'eventdocument.profile-eventdocuments')
                        ->limit(1);
        $content_id = $select_content->query()->fetchObject()->content_id;
        if (empty($content_id)) {
          $select = new Zend_Db_Select($db);
          $select_container = $select
                          ->from('engine4_core_content')
                          ->where('page_id = ?', $page_id)
                          ->where('type = ?', 'container')
                          ->limit(1);
          $container_id = $select_container->query()->fetchObject()->content_id;
          if (!empty($container_id)) {
            $select = new Zend_Db_Select($db);
            $select_middle = $select
                            ->from('engine4_core_content')
                            ->where('parent_content_id = ?', $container_id)
                            ->where('type = ?', 'container')
                            ->where('name = ?', 'middle')
                            ->limit(1);
            $middle_id = $select_middle->query()->fetchObject()->content_id;
            if (!empty($middle_id)) {
              $select = new Zend_Db_Select($db);
              $select_tab = $select
                              ->from('engine4_core_content')
                              ->where('type = ?', 'widget')
                              ->where('name = ?', 'core.container-tabs')
                              ->where('page_id = ?', $page_id)
                              ->limit(1);
              $tab_id = $select_tab->query()->fetchObject()->content_id;

              $db->insert('engine4_core_content', array(
                  'page_id' => $page_id,
                  'type' => 'widget',
                  'name' => 'eventdocument.profile-eventdocuments',
                  'parent_content_id' => ($tab_id ? $tab_id : $middle_id),
                  'order' => 999,
                  'params' => '{"title":"Documents","titleCount":true}',
              ));
            }
          }
        }
      }
      //END: PUT DOCUMENT TAB AUTOMATICALLY AT EVENT PROFILE PAGE

      //START: PUT DOCUMENT TAB AUTOMATICALLY AT ADVANCED-EVENT PROFILE PAGE
      $db = $this->getDb();
      $select = new Zend_Db_Select($db);

      $select
              ->from('engine4_core_pages')
              ->where('name = ?', 'ynevent_profile_index')
              ->limit(1);
      $page_id = $select->query()->fetchObject()->page_id;
      if (!empty($page_id)) {

        $select = new Zend_Db_Select($db);
        $select_content = $select
                        ->from('engine4_core_content')
                        ->where('page_id = ?', $page_id)
                        ->where('type = ?', 'widget')
                        ->where('name = ?', 'eventdocument.profile-eventdocuments')
                        ->limit(1);
        $content_id = $select_content->query()->fetchObject()->content_id;
        if (empty($content_id)) {
          $select = new Zend_Db_Select($db);
          $select_container = $select
                          ->from('engine4_core_content')
                          ->where('page_id = ?', $page_id)
                          ->where('type = ?', 'container')
                          ->limit(1);
          $container_id = $select_container->query()->fetchObject()->content_id;
          if (!empty($container_id)) {
            $select = new Zend_Db_Select($db);
            $select_middle = $select
                            ->from('engine4_core_content')
                            ->where('parent_content_id = ?', $container_id)
                            ->where('type = ?', 'container')
                            ->where('name = ?', 'middle')
                            ->limit(1);
            $middle_id = $select_middle->query()->fetchObject()->content_id;
            if (!empty($middle_id)) {
              $select = new Zend_Db_Select($db);
              $select_tab = $select
                              ->from('engine4_core_content')
                              ->where('type = ?', 'widget')
                              ->where('name = ?', 'core.container-tabs')
                              ->where('page_id = ?', $page_id)
                              ->limit(1);
              $tab_id = $select_tab->query()->fetchObject()->content_id;

              $db->insert('engine4_core_content', array(
                  'page_id' => $page_id,
                  'type' => 'widget',
                  'name' => 'eventdocument.profile-eventdocuments',
                  'parent_content_id' => ($tab_id ? $tab_id : $middle_id),
                  'order' => 999,
                  'params' => '{"title":"Documents","titleCount":true}',
              ));
            }
          }
        }
      }
      //END: PUT DOCUMENT TAB AUTOMATICALLY AT ADVANCED-EVENT PROFILE PAGE

			$select = new Zend_Db_Select($db);
			$select
				->from('engine4_core_settings')
				->where('name = ?', 'eventdocument.code.share');
			$eventdocument_code_share = $select->query()->fetchObject();
			if(empty($eventdocument_code_share))
			{
				$social_share_default_code = '<div class="addthis_toolbox addthis_default_style ">
				<a class="addthis_button_preferred_1"></a>
				<a class="addthis_button_preferred_2"></a>
				<a class="addthis_button_preferred_3"></a>
				<a class="addthis_button_preferred_4"></a>
				<a class="addthis_button_preferred_5"></a>
				<a class="addthis_button_compact"></a>
				<a class="addthis_counter addthis_bubble_style"></a>
				</div>
				<script type="text/javascript">
				var addthis_config = {
									services_compact: "facebook, twitter, linkedin, google, digg, more",
									services_exclude: "print, email"
				}
				</script>
				<script type="text/javascript" src="https://s7.addthis.com/js/250/addthis_widget.js"></script>';

				$db->insert('engine4_core_settings', array(
					'name' => 'eventdocument.code.share',
					'value' => $social_share_default_code,
				));
			}
      
        $documentTable = $db->query('SHOW TABLES LIKE \'engine4_eventdocument_documents\'')->fetch();
        if(!empty($documentTable)) {
            $featuredIndex = $db->query("SHOW INDEX FROM `engine4_eventdocument_documents` WHERE Key_name = 'featured'")->fetch();   
            if(empty($featuredIndex)) {
              $db->query("ALTER TABLE `engine4_eventdocument_documents` ADD INDEX ( `featured` )");
            }   

            $eventIdIndex = $db->query("SHOW INDEX FROM `engine4_eventdocument_documents` WHERE Key_name = 'event_id'")->fetch();     
            if(empty($eventIdIndex)) {
              $db->query("ALTER TABLE `engine4_eventdocument_documents` ADD INDEX ( `event_id` )");
            }         

            $searchIndex = $db->query("SHOW INDEX FROM `engine4_eventdocument_documents` WHERE Key_name = 'search'")->fetch();     
            if(!empty($searchIndex)) {
              $db->query("ALTER TABLE `engine4_eventdocument_documents` DROP INDEX search");
              $db->query("ALTER TABLE `engine4_eventdocument_documents` ADD INDEX (`draft`, `search`, `status`, `approved`)");
            }      
        }      

      parent::onInstall();
    } else {
      $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();
      return $this->_error("<span style='color:red'>Note: You do not have installed the Event Plugin on your site. Please install first Event Plugin on your site before installing this Event Document Plugin.</span><br/> <a href='" . $base_url . "/manage'>Click here</a> to go Manage Packages.");
    }
  }

}
