<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Eventdocument
 * @copyright  Copyright 20011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: manifest.php 2012-01-25 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
return array(
    //Package -------------------------------------------------------------------
    'package' => array(
        'type' => 'module',
        'name' => 'eventdocument',
        'version' => '5.4.1',
        'path' => 'application/modules/Eventdocument',
        'repository' => 'null',
        'title' => 'Events Documents Extension Plugin',
        'description' => 'Add an excitingly new and useful feature : Documents, to the Events on your site. The Events - Documents Extension Plugin brings the power of Documents / Scribd iPapers to SocialEngine Events. The plugin adds a "Documents" tab to every Event. Users can upload and display Documents in Events. Additionally, they can share, print, download documents, and comment on them. Features like the iPaper document viewer, Email attachments, user controlled privacy, support for extensive document formats, SEO URLs and SEO page structure, will attract more traffic to your site.',
'author' => '<a href="http://www.socialapps.tech" style="text-decoration:underline;" target="_blank">SocialApps.tech</a>',
        'date' => 'Thursday, 25 October 2010 18:33:08 +0000',
        'copyright' => 'Copyright 20011-2012 BigStep Technologies Pvt. Ltd.',
        'actions' => array(
            'install',
            'upgrade',
            'refresh',
            'enable',
            'disable',
        ),
        'callback' => array(
            'path' => 'application/modules/Eventdocument/settings/install.php',
            'class' => 'Eventdocument_Installer',
        ),
        'directories' => array(
            'application/modules/Eventdocument',
        ),
        'files' => array(
            'application/languages/en/eventdocument.csv',
        ),
    ),
    //Hooks ---------------------------------------------------------------------
    'hooks' => array(
        array(
            'event' => 'onUserDeleteBefore',
            'resource' => 'Eventdocument_Plugin_Core',
        ),
        array(
            'event' => 'addActivity',
            'resource' => 'Eventdocument_Plugin_Core'
        ),
        array(
            'event' => 'onItemDeleteBefore',
            'resource' => 'Eventdocument_Plugin_Core'
        ),
    ),
    //Items ---------------------------------------------------------------------
    'items' => array(
        'eventdocument_document',
        'eventdocument_search',
    ),
    //Routes --------------------------------------------------------------------
    'routes' => array(
        'eventdocument_create' => array(
            'route' => 'eventdocuments/create/:event_id',
            'defaults' => array(
                'module' => 'eventdocument',
                'controller' => 'index',
                'action' => 'create'
            ),
            'reqs' => array(
                'event_id' => '\d+'
            )
        ),
        'eventdocument_delete' => array(
            'route' => 'eventdocuments/delete/:document_id/:event_id',
            'defaults' => array(
                'module' => 'eventdocument',
                'controller' => 'index',
                'action' => 'delete'
            ),
            'reqs' => array(
                'document_id' => '\d+',
                'event_id' => '\d+'
            )
        ),
        'eventdocument_publish' => array(
            'route' => 'eventdocuments/publish/:document_id',
            'defaults' => array(
                'module' => 'eventdocument',
                'controller' => 'index',
                'action' => 'publish'
            ),
            'reqs' => array(
                'document_id' => '\d+'
            )
        ),
        'eventdocument_featured' => array(
            'route' => 'eventdocuments/featured/:document_id',
            'defaults' => array(
                'module' => 'eventdocument',
                'controller' => 'index',
                'action' => 'featured'
            ),
            'reqs' => array(
                'document_id' => '\d+'
            )
        ),
        'eventdocument_approved' => array(
            'route' => 'eventdocuments/approved/:document_id',
            'defaults' => array(
                'module' => 'eventdocument',
                'controller' => 'index',
                'action' => 'approved'
            ),
            'reqs' => array(
                'document_id' => '\d+'
            )
        ),
        'eventdocument_edit' => array(
            'route' => 'eventdocuments/edit/:document_id/:event_id',
            'defaults' => array(
                'module' => 'eventdocument',
                'controller' => 'index',
                'action' => 'edit'
            )
        ),
        'eventdocument_ssl' => array(
            'route' => 'eventdocuments/ssl/*',
            'defaults' => array(
                'module' => 'eventdocument',
                'controller' => 'index',
                'action' => 'ssl'
            )
        ),
        'eventdocument_detail_view' => array(
            'route' => 'eventdocuments/:user_id/:document_id/:slug',
            'defaults' => array(
                'module' => 'eventdocument',
                'controller' => 'index',
                'action' => 'view',
                'slug' => '',
            ),
            'reqs' => array(
                'user_id' => '\d+',
                'document_id' => '\d+'
            )
        ),
        'eventdocument_admin_manage_level' => array(
            'route' => 'admin/eventdocument/level/:id',
            'defaults' => array(
                'module' => 'eventdocument',
                'controller' => 'admin-level',
                'action' => 'index',
                'level_id' => 1
            )
        ),
    )
);
