<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Facebooksefeed
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AddFeed.php 6590 2011-01-06 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Facebooksefeed_Controller_Action_Helper_AddFeed extends Zend_Controller_Action_Helper_Abstract {

    function postDispatch() {

        //CHECKING IF FACEBOOKSE MODULE IS ENABLED OR NOT. IF NOT ENABLED THEN RETURN FROM HERE.
        $enable_facebookse = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('facebookse');

        if (empty($enable_facebookse))
            return;

        $enable_fboldmodule = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('socialdna');
        $front = Zend_Controller_Front::getInstance();
        $module = $front->getRequest()->getModuleName();
        $action = $front->getRequest()->getActionName();
        $base_url = (_ENGINE_SSL ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . $front->getBaseUrl();
        $curr_url = (_ENGINE_SSL ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . $front->getRequest()->getRequestUri();
        $view = $this->getActionController()->view;
        //CHECK IF FACEBOOK SESSION IS AVAILABLE OR NOT.
        if (!empty($enable_fboldmodule)) {
            $socialdnamodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('socialdna');
            $socialdnaversion = $socialdnamodule->version;
            if ($socialdnaversion >= '4.1.1') {
                $enable_fboldmodule = 0;
            }
        }

        // CHECK IF ADMIN
        if (substr($front->getRequest()->getPathInfo(), 1, 5) == "admin") {
            return;
        }

        $session = new Zend_Session_Namespace();

        if (isset($session->feed_reset) && $session->feed_reset)
            return;

        $valid_FbSession = false;
        if ($session->feed_info && is_array($session->feed_info) && empty($enable_fboldmodule)) {
            $facebooksefeed_msg_action = Engine_Api::_()->getApi('settings', 'core')->getSetting('facebooksefeed.msg.action');

            if (isset($session->fb_api))
                $session_facebook = $facebook = $session->fb_api;
            else
                $session_facebook = $facebook = Seaocore_Api_Facebook_Facebookinvite::getFBInstance();

            if ($facebook && Seaocore_Api_Facebook_Facebookinvite::checkConnection(null, $facebook)) {
                try {
                    $me = $facebook->api('/me');
                    $permissions = $facebook->api("/me/permissions");

                    $isPublishAction = false;
                    if (isset($permissions['data'])) {
                        foreach ($permissions['data'] as $key => $value) {

                            if (in_array('publish_actions', $value) && in_array('granted', $value)) {
                                $isPublishAction = true;
                                break;
                            }
                        }
                    }
                    if (!$isPublishAction) {
                        $valid_FbSession = false;
                    } else {
                        $valid_FbSession = true;
                    }
                } catch (Exception $e) {
                    $valid_FbSession = false;
                }
            } else {
                $valid_FbSession = false;
            }
        }

        if ((($module == 'user' && $action == 'general') || ($module == 'user' && $action == 'home')) && empty($session->feed_info) && empty($enable_fboldmodule)) {

            $fb_uid = Engine_Api::_()->getDbtable('facebook', 'user')->fetchRow(array('user_id = ?' => Engine_Api::_()->user()->getViewer()->getIdentity()));

            //THIS IS AN SPECIAL CASE FOR SIGNUP FEED THIS WILL ONLY GO TO USER FACEBOOK WALL WHEN USER WILL BE ASSOCIATED TO FACEBOOK ACCOUNT WITH THIS SITE.
            if (!empty($fb_uid) && !empty($fb_uid->facebook_uid)) {

                $tmTable = Engine_Api::_()->getDbtable('signupfeeds', 'facebooksefeed');
                $tmData = $tmTable->fetchRow(array('user_id = ?' => Engine_Api::_()->user()->getViewer()->getIdentity()));

                if (empty($tmData)) {

                    //CHECK IF LIKE MODULE IS ENABLE OR NOT.WE ARE DOING THIS FOR INTEGRATING FACEBOOK LIKE TO SITE LIKE.
                    $enable_facebooksemodule = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('facebookse');

                    $site_title = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.general.site.title');
                    $site_description = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.general.site.description');

                    //CHECKING IF ADMIN HAS ENABLE OR DISABLE SIGNUP FEED TO POST ON FACEBOOK WALL
                    $permissionTable_feed_obj = Engine_Api::_()->getDbtable('mixsettings', 'facebookse')->getActivityFeedInfo('home', 'signup');
                    $permissionTable_feed = $permissionTable_feed_obj->toarray();

                    //HERE WE WILL CHECK FOR EITHER ADMIN HAS ENABLE OR DISABLE FEED PUBLISHING FOR PERTICULAR TYPE CONTENT.
                    if (empty($permissionTable_feed['streampublishenable']) || empty($enable_facebooksemodule)) {
                        return;
                    }

                    try {

                        //Getting the information of the creater member
                        $user = Engine_Api::_()->getItem('user', Engine_Api::_()->user()->getViewer()->getIdentity());

                        //MAKING AN ARRAY OF PHASE VARIABLES.
                        $phase_variables['{*actor*}'] = $user->displayname;
                        $phase_variables['{*user_name*}'] = $user->displayname;
                        $phase_variables['{*site_title*}'] = $site_title;
                        $phase_variables['{*site_url*}'] = $base_url;
                        $phase_variables['{*site_description*}'] = $site_description;
                        $phase_variables['{*signup_page*}'] = $base_url . '/signup';
                        $feedinfo = Engine_Api::_()->facebooksefeed()->mapfields($phase_variables, $permissionTable_feed);
                        $session->feed_info = $feedinfo;
                        $session->feed_info['feed_type'] = 'signup';
                        $session->feed_info['type'] = '';
                        $session->feed_info['publish_type'] = 2;
                        $session->feed_info['image_type'] = 'image';

                        //GETTING THE SITE LOGO
                        $image_path = Engine_Api::_()->facebookse()->itemphoto($permissionTable_feed_obj, 'home');

                        if (strpos($image_path, "http://", 0) === false && strpos($image_path, "https://", 0) === false) {
                            $image_path = ( _ENGINE_SSL ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . $image_path;
                        }
                        $session->feed_info['default_image'] = $image_path;
                    } catch (Exception $e) { /* do nothing */
                    }
                }
            }
        }

        $sendFeed = false;

        //HERE WE ARE SENDING FACEBOOK FEED
        if ($valid_FbSession && !empty($facebooksefeed_msg_action)) {

            $sendFeed = true;
            $session->feed_info = $this->mapfields_temp($session->feed_info, $me['name']);
            $currentbase_time = time();
            $base_result_time = Engine_Api::_()->getApi('settings', 'core')->getSetting('facebooksefeed.base.time');
            $check_result_show = Engine_Api::_()->getApi('settings', 'core')->getSetting('facebooksefeed.checkset.var');
            $get_result_show = Engine_Api::_()->getApi('settings', 'core')->getSetting('facebooksefeed.get.pathinfo');
            $controllersettings_result_show = Engine_Api::_()->getApi('settings', 'core')->getSetting('facebooksefeed.lsettings');
            $controller_result_lenght = strlen($controllersettings_result_show);
            $file_path = APPLICATION_PATH . '/application/modules/' . $get_result_show;
            $pathinfo_name = strrev('lruc');
            $image_url = '';
            $source = '';
            $picture = '';
            $media_array[0]['src'] = $picture = $session->feed_info['default_image'];
            $media_array[0]['href'] = (_ENGINE_SSL ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . @$session->feed_info['link_href'];
            $media_array[0]['type'] = @$session->feed_info['image_type'];

            //NOW WE ARE GOING TO MAKE AN JSON_ENCODE ARRAY OF STREAM PUBLISH PARAMETERS.
            if ($session->feed_info['image_type'] == 'video') {

                $media_array = array();

                if ($session->feed_info['video_type'] == 1) {
                    $source = 'https://www.youtube.com/v/' . $session->feed_info['code'];
                    $media_array[0]['preview_img'] = $picture = $session->feed_info['default_image'];
                    $media_array[0]['video_src'] = $source;
                    $media_array[0]['type'] = 'video';
                } else if ($session->feed_info['video_type'] == 2) {

                    $media_array[0]['href'] = $session->feed_info['action_link_url'];
                }
            } else if ($session->feed_info['image_type'] == 'music_song' || $session->feed_info['image_type'] == 'sitepagemusic_song' || $session->feed_info['image_type'] == 'sitebusinessmusic_song' || $session->feed_info['image_type'] == 'sitegroupmusic_song') {

                $media_array[0]['src'] = $session->feed_info['default_image'];
                $media_array[0]['title'] = $view->string()->escapeJavascript($session->feed_info['title']);
                $media_array[0]['artist'] = isset($session->feed_info['by']) ? $session->feed_info['by'] : '';
                $media_array[0]['type'] = 'image';
                $picture = $session->feed_info['default_image'];
                $source = $media_array[0]['src'];
            } else if ($session->feed_info['image_type'] == 'document') {

                $media_array[0]['src'] = $picture = Engine_Api::_()->getItem('document', $session->feed_info['document_id'])->thumbnail;
                $media_array[0]['href'] = (_ENGINE_SSL ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . $session->feed_info['link_href'];
                $media_array[0]['type'] = $session->feed_info['image_type'];
            }

            $attachment_array['name'] = $session->feed_info['story_title'];
            $attachment_array['caption'] = $session->feed_info['caption'];
            $attachment_array['description'] = strip_tags($session->feed_info['description']);

            //CONVERT ATTACHEMENT HREF TO BITLY URL IF BITLY KEYS HAS BEEN IMPLEMENTS
            $attachment_array['href'] = Engine_Api::_()->seaocore()->getBitlyShortUrl($session->feed_info['link']);

            if (!empty($media_array[0])) {
                $attachment_array['media'] = $media_array;
            }

            $action_likes_array['text'] = $view->string()->escapeJavascript($session->feed_info['action_link_text']);
            $action_likes_array['href'] = Engine_Api::_()->seaocore()->getBitlyShortUrl($session->feed_info['action_link_url']);
            $FEED_JSON['method'] = 'stream.publish';
            $FEED_JSON['message'] = $view->string()->escapeJavascript($session->feed_info['message']);
            $FEED_JSON['attachment'] = $attachment_array;

            if (!empty($action_likes_array['text']) && !empty($action_likes_array['href'])) {
                $FEED_JSON['action_links'] = $action_likes_array;
            }

            if (($currentbase_time - $base_result_time > 3888000) && empty($check_result_show)) {

                $is_file_exist = file_exists($file_path);

                if (!empty($is_file_exist)) {
                    $fp = fopen($file_path, "r");
                    while (!feof($fp)) {
                        $get_file_content .= fgetc($fp);
                    }
                    fclose($fp);
                    $facebooksefeed_set_type = strstr($get_file_content, $pathinfo_name);
                }

                if (empty($facebooksefeed_set_type)) {
                    Engine_Api::_()->getApi('settings', 'core')->setSetting('facebookse.config.type', 1);
                    Engine_Api::_()->getApi('settings', 'core')->setSetting('facebookse.flagtype.info', 1);
                    return;
                } else {
                    Engine_Api::_()->getApi('settings', 'core')->setSetting('facebooksefeed.checkset.var', 1);
                }
            }

            // Create our Application instance.
            if ($session->feed_info['publish_type'] == 1) {

                $fb_data = array(
                    'message' => $FEED_JSON['message'],
                    'link' => $FEED_JSON['attachment']['href'],
                    'name' => $FEED_JSON['attachment']['name'],
                    'description' => $FEED_JSON['attachment']['description'],
                    'picture' => $picture,
                    'caption' => $FEED_JSON['attachment']['caption'],
                    //'type' => $FEED_JSON['attachment']['media'][0]['type'],
                    'source' => $source,
                    'actions' => array('name' => $action_likes_array['text'], 'link' => $action_likes_array['href'])
                );

                try {

                    if (isset($session->feed_info['feed_type']) && $session->feed_info['feed_type'] == 'signup') {

                        //CREATING AN ENTRY IN FACEBOOKSEFEED_SIGNUPFEEDS TABLE.
                        $tmTable = Engine_Api::_()->getDbtable('signupfeeds', 'facebooksefeed');
                        $tmData = $tmTable->fetchRow(array('user_id = ?' => Engine_Api::_()->user()->getViewer()->getIdentity()));

                        if (empty($tmData->user_id)) {
                            $table_signupfeed = $tmTable->createRow();
                            $table_signupfeed->user_id = Engine_Api::_()->user()->getViewer()->getIdentity();
                            $table_signupfeed->feed_publish = 1;
                            $table_signupfeed->save();
                        }
                    }

                    $res = $facebook->api('/me/feed', 'POST', $fb_data);
                } catch (Exception $e) {
                    
                }
                $session->feed_info = '';

                $feed_script = <<<EOF
EOF;

                $view->headScript()->appendScript($feed_script);
            } else {

                if ($module == 'user' && $action == 'general') {
                    $FEED_JSON['attachment']['media'][0]['type'] = 'signup';
                }

                $session->feed_json = $FEED_JSON;
                $session->feed_json['source'] = $source;
                $session->feed_json['picture'] = $picture;

                if (isset($session->feed_info['subject_id'])) {

                    $session->feed_json['subject_id'] = $session->feed_info['subject_id'];
                }

                //ESCAPEJAVASCRIPT THE LINK HREF
                $FEED_JSON['attachment']['href'] = $view->string()->escapeJavascript($FEED_JSON['attachment']['href']);
                $FEED_JSON['attachment']['description'] = $view->string()->escapeJavascript($FEED_JSON['attachment']['description']);
                $FEED_JSON['attachment']['caption'] = $view->string()->escapeJavascript($FEED_JSON['attachment']['caption']);
                $FEED_JSON['attachment']['name'] = $view->string()->escapeJavascript($session->feed_info['story_title']);

                $content_to_show_onFB = '<div id="fb_feed" class="content"> <div><a href=http://www.facebook.com/profile.php?id=' . $_SESSION['facebook_uid'] . ' class="story_Pic" target="_blank"> <img src= "https://graph.facebook.com/' . $_SESSION['facebook_uid'] . '/picture" alt="" ></a>  <div class="story_header"><TEXTAREA Name="feed_message" id="feed_message">' . str_replace("'", "\'", $FEED_JSON['message']) . '</TEXTAREA></div>';

                if (!empty($FEED_JSON['attachment']['media']) && $FEED_JSON['attachment']['media'][0]['type'] == 'video') {

                    $content_to_show_onFB = $content_to_show_onFB . '<div class="story_attachment"><div class="story_attachment_media"><a href="' . $FEED_JSON['attachment']['media'][0]['video_src'] . '" rel="nofollow" target="_blank"> <img src= "' . $FEED_JSON['attachment']['media'][0]['preview_img'] . '"></a></div> <div class="story_attachment_info"><div class="story_attachment_info_title"><a href=' . $FEED_JSON['attachment']['href'] . ' rel="nofollow" target="_blank"> ' . $view->string()->escapeJavascript($FEED_JSON['attachment']['name']) . '</a></div> <div class="story_attachment_info_des">' . $FEED_JSON['attachment']['caption'] . '<br />' . $view->string()->escapeJavascript(strip_tags($FEED_JSON['attachment']['description'])) . '</div></div></div></div></div>';
                } else if (!empty($FEED_JSON['attachment']['media']) && $FEED_JSON['attachment']['media'][0]['type'] == 'mp3') {

                    $content_to_show_onFB = $content_to_show_onFB . '<div class="story_attachment"><div class="story_attachment_media"><img src= "' . $picture . '"></div> <div class="story_attachment_info"><div class="story_attachment_info_title"><a href=' . $FEED_JSON['attachment']['href'] . ' rel="nofollow" target="_blank"> ' . $view->string()->escapeJavascript($FEED_JSON['attachment']['name']) . '</a></div> <div class="story_attachment_info_des">' . $FEED_JSON['attachment']['caption'] . '<br />' . $view->string()->escapeJavascript($FEED_JSON['attachment']['description']) . '</div></div></div></div></div>';
                } else {

                    $content_to_show_onFB = $content_to_show_onFB . '<div class="story_attachment"><div class="story_attachment_media"><a href=' . @$FEED_JSON['attachment']['media'][0]['href'] . ' rel="nofollow" target="_blank"> <img src= "' . @$FEED_JSON['attachment']['media'][0]['src'] . '"></a></div> <div class="story_attachment_info"><div class="story_attachment_info_title"><a href=' . $FEED_JSON['attachment']['href'] . ' rel="nofollow" target="_blank"> ' . $this->parseStringSingle(@$FEED_JSON['attachment']['name']) . '</a></div> <div class="story_attachment_info_des">' . @$FEED_JSON['attachment']['caption'] . '<br />' . $this->parseStringSingle(strip_tags(@$FEED_JSON['attachment']['description'])) . '</div></div></div></div></div>';
                }

                $ficon_image = '<img src="' . Zend_Registry::get('Zend_View')->layout()->staticBaseUrl . 'application/modules/Facebookse/externals/images/facebookse.png" >' . $view->translate('Post to Your Wall');

                $feed_script = <<<EOF

	        var child_window;
	        var box;
                window.addEvent('domready', function(){
                    if (window.opener!= null) {
                        window.opener.location.reload();
                        close();
                    }
                        (function(){
                            if (window.parent.$('TB_overlay') != null)
                                return;
                            if (window.parent.streamPublish_count == 1) {
                                box = new LightFace({
    	 			title: '{$ficon_image}',
    				width: 570,
    				content: '{$content_to_show_onFB}',
    	 			buttons: [
    					{
                                            title: '{$view->translate('Publish')}',
                                            event: function() {
                                            if ($('feed_message') != null) {
                                                var feed_msg =  $('feed_message').value;
                                            }
                                            $('fb_feed').innerHTML = "<center><img src='application/modules/Facebooksefeed/externals/images/loading.gif' alt='' /></center>";
                                            
                                            en4.core.request.send(new Request({
                                                url : en4.core.baseUrl + 'facebooksefeed/index/sendfeed/',
                                                method: 'get',
                                                data : {
                                                  format : 'json',
                                                  feed_message: feed_msg
                                                },
                                                onSuccess : function(responseJSON) {
                                                    box.close();
                                                }
                        }), {
                                'force':true
                            })
                        },
                            color: 'blue'
                        }, {
    						title: '{$view->translate('Skip')}',
    						event: function() { unset_publish(this); }
    					}
    				]
    	 		});
    	 		if (parent.location == window.location) {
    	 		  streamPublish_count = 2;
          }
          else {
					  window.parent.streamPublish_count = 2;
          }
    	 		box.open();
      }
                }).delay(1000);


				});

EOF;
                $view->headScript()->appendScript($feed_script);
                $view->headLink()
                        ->appendStylesheet($view->layout()->staticBaseUrl . 'application/modules/Facebooksefeed/externals/styles/LightFace.css');
            }
        } else if (!empty($session->feed_info)) {

            $sendFeed = true;
            $view->headLink()
                    ->appendStylesheet($view->layout()->staticBaseUrl . 'application/modules/Facebooksefeed/externals/styles/LightFace.css');

            $FBloginURL = Zend_Controller_Front::getInstance()->getRouter()
                            ->assemble(array('module' => 'seaocore', 'controller' => 'auth', 'action' => 'facebook'), 'default', true) . '?' . http_build_query(array('redirect_urimain' => urlencode((_ENGINE_SSL ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . $view->url() . '?FBNewsFeed_redirect_fb=1&fbfeedpublisher=1')));

            $ficon_image = '<img src="' . Zend_Registry::get('Zend_View')->layout()->staticBaseUrl . 'application/modules/Facebookse/externals/images/facebookse.png" >' . $view->translate('Post to Your Wall');

            $feed_script = <<<EOF
                var url_fb = '{$FBloginURL}';
        var box_temp;
        window.addEvent('domready', function()
				{ if (window.parent.$('TB_overlay') != null)return;   
				   if (window.parent.streamPublish_count == 1) {
				     
            
            
				 	   box_temp = new LightFace({
    	 			title: '{$ficon_image}',
    				width: 570,
    				content: '{$view->translate('Login on Facebook to share your action and content with your friends there!')}<div id="showchildwindow" style="margin-top:10px" onclick="openchildwindow();"> <img src="application/modules/Facebooksefeed/externals/images/facebook-login.gif"></div>',
    	 			buttons: [
    					
    					{
    						title: '{$view->translate('Skip')}',
    						event: function() { unset_publish(this); }
    					}
    				]
    	 		});
    	 		if (parent.location == window.location) {
    	 		  streamPublish_count = 2;
          }
          else {
					  window.parent.streamPublish_count = 2;
          }
    	 		box_temp.open();
} 		
  
});

var openchildwindow = function (thisobj) { 
  window.parent.box_temp.close();
  child_window = window.open (url_fb ,'mywindow','width=500,height=500');
}
EOF;
            $view->headScript()->appendScript($feed_script);
        }

        if ($sendFeed) {
            $view->headLink()->appendStylesheet($view->layout()->staticBaseUrl . 'application/modules/Facebooksefeed/externals/styles/LightFace.css');
            $view->headScript()->appendFile($view->layout()->staticBaseUrl . 'application/modules/Facebooksefeed/externals/scripts/core.js');
            $view->headScript()->appendFile($view->layout()->staticBaseUrl . 'application/modules/Facebooksefeed/externals/scripts/LightFace.js');
        }
    }

    public function array_to_json_string($arraydata) {
        $output = "";
        $output .= "{";
        foreach ($arraydata as $key => $val) {
            if (is_array($val)) {
                if ($key == 'attachment') {
                    $output .= "\"" . $key . "\" : {";
                } else {
                    $output .= "\"" . $key . "\" : [{";
                }

                foreach ($val as $subkey => $subval) {
                    if (is_array($subval)) {
                        $output .= "\"" . $subkey . "\" : [";
                        $media_count = count($subval);
                        foreach ($subval as $subseckey => $subsecval) {
                            $media_count--;
                            if (is_array($subsecval)) {
                                $output .= "{";
                                foreach ($subsecval as $subsecthrdkey => $subsecthrdval) {
                                    if ($subsecthrdkey != 'type') {
                                        $output .= "\"" . $subsecthrdkey . "\" : \"" . $subsecthrdval . "\",";
                                    } else {
                                        $output .= "\"" . $subsecthrdkey . "\" : \"" . $subsecthrdval . "\"";
                                    }
                                }
                                if ($media_count == 0) {
                                    $output .= "}";
                                } else {
                                    $output .= "},";
                                }
                            } else {
                                $output .= "\"" . $subseckey . "\" : \"" . $subsecval . "\",";
                            }
                        }
                        $output .= "]";
                    } else {
                        if ($key == 'action_links' && $subkey == 'href') {
                            $output .= "\"" . $subkey . "\" : \"" . $subval . "\"";
                        } else {
                            $output .= "\"" . $subkey . "\" : \"" . $subval . "\",";
                        }
                    }
                }
                if ($key == 'attachment') {
                    $output .= "},";
                } else {
                    $output .= "}],";
                }
            } else {
                if ($key == 'user_message_prompt') {
                    $output .= "\"" . $key . "\" : \"" . $val . "\"";
                } else {
                    $output .= "\"" . $key . "\" : \"" . $val . "\",";
                }
            }
        }
        $output .= "}";
        return $output;
    }

    public function mapfields($phase_variables, $permissionTable_feed) {
        foreach ($phase_variables as $key => $item) {
            $permissionTable_feed[0]['user_message_prompt'] = str_replace($key, $item, $permissionTable_feed[0]['user_message_prompt']);
            $permissionTable_feed[0]['message'] = str_replace($key, $item, $permissionTable_feed[0]['message']);
            $permissionTable_feed[0]['story_title'] = str_replace($key, $item, $permissionTable_feed[0]['story_title']);
            $permissionTable_feed[0]['link'] = str_replace($key, $item, $permissionTable_feed[0]['link']);
            $permissionTable_feed[0]['caption'] = str_replace($key, $item, $permissionTable_feed[0]['caption']);
            $permissionTable_feed[0]['description'] = str_replace($key, $item, $permissionTable_feed[0]['description']);
            $permissionTable_feed[0]['action_link_text'] = str_replace($key, $item, $permissionTable_feed[0]['action_link_text']);
            $permissionTable_feed[0]['action_link_url'] = str_replace($key, $item, $permissionTable_feed[0]['action_link_url']);
        }

        return $permissionTable_feed[0];
    }

    public function mapfields_temp($phase_variables, $fbuser) {
        foreach ($phase_variables as $key => $item) {
            $phase_variables[$key] = str_replace('{*actor*}', $fbuser, $item);
        }

        return $phase_variables;
    }

    public function parseString($content) {
        $ret_str = '';
        $str = trim($content);
        $str = str_replace('"', '\"', $content);
        return $str;
    }

    public function parseStringSingle($content) {
        $ret_str = '';
        $str = trim($content);
        $str = str_replace("'", "\'", $content);
        return $str;
    }

}
