<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Facebooksefeed
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 6590 2011-01-06 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Facebooksefeed_Installer extends Engine_Package_Installer_Module
{
  function getFacebookseStatus() {
    $db = $this->getDb();
    $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();
    
    //CHECKING IF THE ADVANCED FACEBOOK PLUGIN IS INSTALLED OR NOT.
    $is_installed = $db->query("SELECT `name` FROM `engine4_core_modules` WHERE `name` = 'facebookse' LIMIT 1")->fetchColumn();
    
    if (empty ($is_installed)) {
      return $this->_error("<span style='color:red'>This plugin is dependent on the <a href=' http://www.socialengineaddons.com/socialengine-advanced-facebook-integration-likes-social-plugins-and-open-graph' target='_blank'>Advanced Facebook Integration / Likes, Social Plugins and Open Graph</a> Plugin, and requires that to be installed first. Please install that plugin first on your site before installing this 'Facebook Feed Stories Publisher' Plugin.</span><br/> <a href='" . $base_url . "/manage'>Click here</a> to go Manage Packages.");
      
    }
   
    //CHECKING IF THE ADVANCED FACEBOOK PLUGIN IS ENABLED OR NOT.
    $is_enabled = $db->query("SELECT `enabled` FROM `engine4_core_modules` WHERE `name` = 'facebookse' LIMIT 1")->fetchColumn();
    
    if (empty ($is_enabled)) {
      return $this->_error("<span style='color:red'>This plugin is dependent on the <a href=' http://www.socialengineaddons.com/socialengine-advanced-facebook-integration-likes-social-plugins-and-open-graph' target='_blank'>Advanced Facebook Integration / Likes, Social Plugins and Open Graph</a> Plugin, and requires that to be enabled first. Please enable that plugin first on your site before installing this 'Facebook Feed Stories Publisher' Plugin.</span><br/> <a href='" . $base_url . "/manage'>Click here</a> to go Manage Packages.");
      
    }
    $is_existname = $db->query("SELECT `name` FROM `engine4_core_settings` WHERE `name` = 'facebookse.isActivate' LIMIT 1")->fetchColumn();
    if (!empty($is_existname)) {
      $is_activated = $db->query("SELECT `value` FROM `engine4_core_settings` WHERE `name` = 'facebookse.isActivate' LIMIT 1")->fetchColumn();
      
     if (empty ($is_activated)) {
        $baseUrl = $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getBaseUrl();
        $url_string = Zend_Controller_Front::getInstance()->getRequest()->getRequestUri();
        if (strstr($url_string, "manage/install")) {
          $calling_from = 'install';
        } else if (strstr($url_string, "manage/query")) {
          $calling_from = 'queary';
        }
        $explode_base_url = explode("/", $baseUrl);
        foreach ($explode_base_url as $url_key) {
          if ($url_key != 'install') {
            $core_final_url .= $url_key . '/';
          }
        }
        return $this->_error("<span style='color:red'>This plugin is dependent on the <a href=' http://www.socialengineaddons.com/socialengine-advanced-facebook-integration-likes-social-plugins-and-open-graph' target='_blank'>Advanced Facebook Integration / Likes, Social Plugins and Open Graph</a> Plugin, and requires that to be activated first. Please activate that plugin first on your site before installing this 'Facebook News Feed, Friends, Invite and more' Plugin.</span><br/> <a href='" . 'http://' . $core_final_url . "admin/facebookse/settings/readme'>Click here</a> to go Manage Packages.");die;
      }
    }
  }
	function onPreInstall()
	{
    $status = $this->getFacebookseStatus();
    if (!empty($status)) {
      
      return;
    }
		$PRODUCT_TYPE = 'facebooksefeed';
		$PLUGIN_TITLE = 'Facebooksefeed';
		$PLUGIN_VERSION = '5.4.1';
		$PLUGIN_CATEGORY = 'plugin';
		$PRODUCT_DESCRIPTION = 'Facebooksefeed Plugin';
		$_PRODUCT_FINAL_FILE = 0;
		$_BASE_FILE_NAME = 0;
    $PRODUCT_TITLE = 'Facebook Feed Stories Publisher';
    $SocialEngineAddOns_version = '4.8.5';
    $file_path = APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/ilicense.php";
    $is_file = file_exists($file_path);
    if (empty($is_file)) {
      include_once APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/license3.php";
    } else {
			if( !empty($_PRODUCT_FINAL_FILE) ) {
				include_once APPLICATION_PATH . '/application/modules/' . $PLUGIN_TITLE . '/controllers/license/' . $_PRODUCT_FINAL_FILE;
			}
      $db = $this->getDb();
      $select = new Zend_Db_Select($db);
      $select->from('engine4_core_modules')->where('name = ?', $PRODUCT_TYPE);
      $is_Mod = $select->query()->fetchObject();
      if( empty($is_Mod) ) {
	include_once $file_path;
      }
    }
		parent::onPreInstall();
	}

 function onInstall () {
                //CHECK THAT SITEPAGE PLUGIN IS INSTALLED OR NOT
    $db     = $this->getDb();
  	$facebooksefeed_base_time = time();

    $select = new Zend_Db_Select($db);
     $select
      ->from('engine4_core_modules')
      ->where('name = ?', 'facebookse')
                        ->where('enabled = ?', 1);
    $check_facebookse = $select->query()->fetchObject();
    if(empty($check_facebookse)) {
			$base_url = Zend_Controller_Front::getInstance()->getBaseUrl();
			return $this->_error("<span style='color:red'>This plugin is dependent on the <a href=' http://www.socialengineaddons.com/socialengine-advanced-facebook-integration-likes-social-plugins-and-open-graph' target='_blank'>Advanced Facebook Integration / Likes, Social Plugins and Open Graph</a> Plugin, and requires that to be installed first. Please install that plugin first on your site before installing this 'Facebook Feed Stories Publisher' Plugin.</span><br/> <a href='" . $base_url . "/manage'>Click here</a> to go Manage Packages.");
    }

		$db->query("INSERT IGNORE INTO `engine4_core_settings` (`name`, `value`) VALUES
			('facebooksefeed.base.time', $facebooksefeed_base_time ),
			('facebooksefeed.checkset.var', 0 ),
			('facebooksefeed.timevar.limit', 3456000 ),
			('facebooksefeed.get.pathinfo', 'Facebooksefeed/controllers/license/license2.php');");

    include_once APPLICATION_PATH . '/application/modules/Facebooksefeed/controllers/license/license2.php';

		$db->query("UPDATE  `engine4_seaocores` SET  `is_activate` =  '1' WHERE  `engine4_seaocores`.`module_name` ='facebooksefeed';");
		
		
		//CHECK IF THERE ARE ANY OTHER THIRD PARTY ENTRIES IN THE FACEBOOKSE_MIXSETTINGS TABLE THEN PUT THOSE ENTRY IN FACEBOOKSEFEED TABLE.
	  $select = new Zend_Db_Select($db);
    $version = $select
            ->from('engine4_core_modules', 'version')
            ->where('name = ?', 'facebooksefeed')
            ->where('version <= ?', '4.2.3')
            ->query()
            ->fetchColumn();
    
    if (!empty($version)) {
      
      $select = new Zend_Db_Select($db);
			//for facebooksefeed types table entry in the mix settings table.
			$facebooksefeed_types_exist = $db->query("SHOW TABLES LIKE 'engine4_facebooksefeed_feedtypes'")->fetch();
			if( !empty($facebooksefeed_types_exist) ) { 
				$facebooksefeed_types = $db->query("SELECT * FROM `engine4_facebooksefeed_feedtypes`")->fetchAll();
				foreach( $facebooksefeed_types as $feedtypesetting ) { 
					$feedtype_variables = $this->getArrayVariables ($feedtypesetting['type']);		
					if (!empty($feedtype_variables)) {
						foreach ($feedtype_variables as $variable) { 
								$variable_split = explode("-", $variable);
						    if (isset($variable_split[1])) { 
										$feedtypesetting['message'] = str_replace(trim($variable_split[0]), trim($variable_split[1]), $feedtypesetting['message']);
										$feedtypesetting['story_title'] = str_replace( trim($variable_split[0]), trim($variable_split[1]), $feedtypesetting['story_title']);									
										$feedtypesetting['link'] = str_replace(trim($variable_split[0]), trim($variable_split[1]), $feedtypesetting['link']);
										$feedtypesetting['caption'] = str_replace(trim($variable_split[0]), trim($variable_split[1]), $feedtypesetting['caption']);
										$feedtypesetting['description'] = str_replace(trim($variable_split[0]), trim($variable_split[1]), $feedtypesetting['description']);
										$feedtypesetting['action_link_text'] = str_replace(trim($variable_split[0]), trim($variable_split[1]),$feedtypesetting['action_link_text']);
										$feedtypesetting['action_link_url'] = str_replace(trim($variable_split[0]), trim($variable_split[1]), $feedtypesetting['action_link_url']);								
								}
					 
						}
					
					}					
					$db->query('UPDATE `engine4_facebookse_mixsettings` SET `streampublishenable` = "' .$feedtypesetting['enable'] . '",
					`streampublish_message` = "' . $feedtypesetting['message'] . '", `streampublish_story_title` = "' . $feedtypesetting['story_title'] . '", `streampublish_link` = "' . $feedtypesetting['link'] . '", `streampublish_caption` = "' . $feedtypesetting['caption'] . '" , `streampublish_description` = "' . $feedtypesetting['description'] . '" , `streampublish_action_link_text` = "' . $feedtypesetting['action_link_text'] . '" , `streampublish_action_link_url` = "' . $feedtypesetting['action_link_url'] . '" WHERE `engine4_facebookse_mixsettings`.`activityfeed_type` = "' . $feedtypesetting['type'] . '" ;'); 
				}
			
        //$db->query('DROP TABLE `engine4_facebooksefeed_feedtypes`;');
			}
    }
    
    $signupfeedTable = $db->query('SHOW TABLES LIKE \'engine4_facebooksefeed_signupfeeds\'')->fetch();
    if (!empty($signupfeedTable)) {
			$useridIndex = $db->query("SHOW INDEX FROM `engine4_facebooksefeed_signupfeeds` WHERE Key_name = 'user_id'")->fetch();
			if (empty($useridIndex)) {
				$db->query("ALTER TABLE `engine4_facebooksefeed_signupfeeds` ADD INDEX(`user_id`)");
			}
    }
    parent::onInstall();
  }
  
  public function getArrayVariables ($feed_type) {
    $plugins_temp = str_replace('sitepage', "", $feed_type);
    if ($plugins_temp == $feed_type) { 
      $plugins_temp = str_replace('sitebusiness', "", $feed_type);
      if ($plugins_temp == $feed_type) {
        $plugins_prefix = 'sitegroup';
        $plugin_var1 = 'sitegroups';
      }
      else {
        $plugins_prefix = 'sitebusiness';
        $plugin_var1 = 'sitebusinesses';
      }
    }  
    else {
      $plugins_prefix = 'sitepage';
      $plugin_var1 = 'sitepages';
    } 
    switch ($feed_type) {
				case 'blog_new':
				  $variable = '{*actor*}, {*user_name*}, {*site_title*}, {*site_url*}, {*blogentry_title*}-{*blog_title*}, {*blogentry_url*}-{*blog_url*}, {*blogentry_desc*}-{*blog_desc*}, {*browse_blogs_url*}-{*browse_blog_url*}';
				  break;
				case 'group_create':
				  $variable = '{*actor*}, {*user_name*}, {*site_title*}, {*site_url*}, {*group_title*}, {*group_url*}, {*group_desc*}, {*browse_groups_url*}-{*browse_group_url*}';
				  break;
			  case 'event_create':
				  $variable = '{*actor*}, {*user_name*}, {*site_title*}, {*site_url*}, {*event_title*}, {*event_url*}, {*event_desc*}, {*browse_events_url*}-{*browse_event_url*}';
				  break;
			  case 'poll_new':
				   $variable = '{*actor*}, {*user_name*}, {*site_title*}, {*site_url*}, {*poll_title*}, {*poll_url*}, {*poll_desc*}, {*browse_polls_url*}-{*browse_poll_url*}';
				  break;
				case 'classified_new':
				   $variable = '{*actor*}, {*user_name*}, {*site_title*}, {*site_url*}, {*classified_title*}, {*classified_url*}, {*classified_desc*}, {*browse_classifieds_url*}-{*browse_classified_url*}';
				  break;
				case 'album_photo_new':
				   $variable = '{*actor*}, {*user_name*}, {*site_title*}, {*site_url*}, {*album_title*}, {*album_url*}, {*album_desc*}, {*browse_albums_url*}-{*browse_album_url*}';
				  break;
				case 'music_playlist_new':
				   $variable = '{*actor*}, {*user_name*}, {*site_title*}, {*site_url*}, {*music_title*}, {*music_url*}, {*music_desc*}, {*browse_music_url*}';
				  break;
				case 'document_new':
				  $variable = '{*actor*}, {*user_name*}, {*site_title*}, {*site_url*}, {*document_title*}, {*document_url*}, {*document_desc*}, {*browse_documents_url*}-{*browse_document_url*}';
				  break;
				case 'profile_photo_update':
				  $variable = '';
				  break;
				case 'video_new':
				  $variable = '{*actor*}, {*user_name*}, {*site_title*}, {*site_url*}, {*video_title*}, {*video_url*}, {*video_desc*}, {*browse_videos_url*}-{*browse_video_url*}';
				  break;
        case 'forum_topic_create':
				  $variable = '{*actor*}, {*user_name*}, {*site_title*}, {*site_url*}, {*forum_title*}, {*forum_url*}, {*forum_desc*}, {*browse_forums_url*}, {*forumtopic_title*}, {*forumtopic_url*}, {*forumtopic_desc*}, {*browse_forumtopics_url*}-{*browse_forumtopic_url*}';
				  break;
        case 'forum_topic_reply':
					$variable = '{*actor*}, {*user_name*}, {*site_title*}, {*site_url*}, {*forum_title*}, {*forum_url*}, {*forum_desc*}, {*browse_forums_url*}, {*forumtopic_title*}, {*forumtopic_url*}, {*forumtopic_desc*}, {*browse_forumtopics_url*}-{*browse_forumtopic_url*}';
				  break;
        case 'signup':
				   $variable = '';
				  break;

        case 'list_new':
				  $variable = '';
				  break;
				
				case ''. $plugins_prefix .'_new':
				  $variable = '{*actor*}, {*user_name*}, {*site_title*}, {*site_url*}, {*'. $plugins_prefix .'_title*}, {*'. $plugins_prefix .'_url*}, {*'. $plugins_prefix .'_desc*}, {*'. $plugin_var1 .'_home_url*}';
				  break;
				  
				case ''. $plugins_prefix .'event_new':
				  $variable = '{*actor*}, {*user_name*}, {*site_title*}, {*site_url*}, {*'. $plugins_prefix .'_event_title*}-{*'. $plugins_prefix .'event_title*}, {*'. $plugins_prefix .'_event_url*}-{*'. $plugins_prefix .'event_url*}, {*'. $plugins_prefix .'_event_desc*}-{*'. $plugins_prefix .'event_desc*},{*browse_'. $plugins_prefix .'_events_url*}-{*browse_'. $plugins_prefix .'events_url*}';
				  break;
				  
				case ''. $plugins_prefix .'note_new':
				  $variable = '{*actor*}, {*user_name*}, {*site_title*}, {*site_url*}, {*'. $plugins_prefix .'_note_title*}-{*'. $plugins_prefix .'note_title*}, {*'. $plugins_prefix .'_note_url*}-{*'. $plugins_prefix .'note_url*}, {*'. $plugins_prefix .'_note_desc*}-{*'. $plugins_prefix .'note_desc*}, {*browse_'. $plugins_prefix .'_notes_url*}-{*browse_'. $plugins_prefix .'notes_url*}';
				  break;

				case ''. $plugins_prefix .'review_new':
				  $variable = '{*actor*}, {*user_name*}, {*site_title*}, {*site_url*}, {*'. $plugins_prefix .'_review_title*}-{*'. $plugins_prefix .'review_title*}, {*'. $plugins_prefix .'_review_url*}-{*'. $plugins_prefix .'review_url*}, {*'. $plugins_prefix .'_review_desc*}-{*'. $plugins_prefix .'review_desc*},{*browse_'. $plugins_prefix .'_reviews_url*}-{*browse_'. $plugins_prefix .'reviews_url*}';
				  break;

				case ''. $plugins_prefix .'album_photo_new':
				  $variable = '{*actor*}, {*user_name*}, {*site_title*}, {*site_url*}, {*'. $plugins_prefix .'_album_title*}-{*'. $plugins_prefix .'album_title*}, {*'. $plugins_prefix .'_album_url*}-{*'. $plugins_prefix .'album_url*}, {*'. $plugins_prefix .'_album_desc*}-{*'. $plugins_prefix .'album_desc*},{*browse_'. $plugins_prefix .'_albums_url*}-{*browse_'. $plugins_prefix .'albums_url*}';
				  break;

				case ''. $plugins_prefix .'video_new':
				  $variable = '{*actor*}, {*user_name*}, {*site_title*}, {*site_url*}, {*'. $plugins_prefix .'_video_title*}-{*'. $plugins_prefix .'video_title*}, {*'. $plugins_prefix .'_video_url*}-{*'. $plugins_prefix .'video_url*}, {*'. $plugins_prefix .'_video_desc*}-{*'. $plugins_prefix .'video_desc*},{*browse_'. $plugins_prefix .'_videos_url*}-{*browse_'. $plugins_prefix .'videos_url*}';
				  break;

				case ''. $plugins_prefix .'poll_new':
				  $variable = '{*actor*}, {*user_name*}, {*site_title*}, {*site_url*}, {*'. $plugins_prefix .'_poll_title*}-{*'. $plugins_prefix .'poll_title*}, {*'. $plugins_prefix .'_poll_url*}-{*'. $plugins_prefix .'poll_url*}, {*'. $plugins_prefix .'_poll_desc*}-{*'. $plugins_prefix .'poll_desc*}, {*browse_'. $plugins_prefix .'_polls_url*}-{*browse_'. $plugins_prefix .'polls_url*}';
				  break;

				case ''. $plugins_prefix .'_topic_create':
				  $variable = '{*actor*}, {*user_name*}, {*site_title*}, {*site_url*}, {*'. $plugins_prefix .'_discussion_title*}-{*'. $plugins_prefix .'discussion_title*}, {*'. $plugins_prefix .'_discussion_url*}-{*'. $plugins_prefix .'discussion_url*}, {*'. $plugins_prefix .'_discussion_desc*}-{*'. $plugins_prefix .'discussion_desc*}, {*browse_'. $plugins_prefix .'_discussions_url*}-{*browse_'. $plugins_prefix .'discussions_url*}';
				  break;

				case ''. $plugins_prefix .'_topic_reply':
				  $variable = '{*actor*}, {*user_name*}, {*site_title*}, {*site_url*}, {*'. $plugins_prefix .'_discussion_title*}-{*'. $plugins_prefix .'discussion_title*}, {*'. $plugins_prefix .'_discussion_url*}-{*'. $plugins_prefix .'discussion_url*}, {*'. $plugins_prefix .'_discussion_desc*}-{*'. $plugins_prefix .'discussion_desc*}, {*browse_'. $plugins_prefix .'_discussions_url*}-{*browse_'. $plugins_prefix .'discussions_url*}';
				  break;
        
        case 'recipe_new':
				  $variable = '{*actor*}, {*user_name*}, {*site_title*}, {*site_url*}, {*recipe_title*}, {*recipe_url*}, {*recipe_desc*}, {*recipes_home_url*}-{*browse_recipes_url*}';
				  break;
        
        case ''. $plugins_prefix .'music_playlist_new':
				   $variable = '{*actor*}, {*user_name*}, {*site_title*}, {*site_url*}, {*'. $plugins_prefix .'music_title*}, {*'. $plugins_prefix .'music_url*}, {*'. $plugins_prefix .'music_desc*}, {*browse_'. $plugins_prefix .'musics_url*}-{*browse_'. $plugins_prefix .'music_url*}';
				  break;
     
				default:
					$variable = '';
			}
			
			$variable_array = explode(",", $variable);
			return $variable_array;
  
  }

}
?>
