<?php
 /**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Facebookse
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Global.php 6590 2011-01-06 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Facebooksepage_Form_Admin_Global extends Engine_Form
{
  public function init()
  {
    $this
      ->setTitle('Global Settings')
      ->setDescription("These settings affect all members in your community.");


		$this->addElement('Text', 'facebooksepage_lsettings', array(
		'label' => 'Enter License key',
		'description' => "Please enter your license key that was provided to you when you purchased this plugin. If you do not know your license key, please contact the Support Team of SocialApps.tech from the Support section of your Account Area.(Key Format: XXXXXX-XXXXXX-XXXXXX )",
		'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('facebooksepage.lsettings'),
		));

	  if( APPLICATION_ENV == 'production' ) {
	    $this->addElement('Checkbox', 'environment_mode', array(
		'label' => 'Your community is currently in "Production Mode". We recommend that you momentarily switch your site to "Development Mode" so that the CSS of this plugin renders fine as soon as the plugin is installed. After completely installing this plugin and visiting few pages of your site, you may again change the System Mode back to "Production Mode" from the Admin Panel Home. (In Production Mode, caching prevents CSS of new plugins to be rendered immediately after installation.)',
		'description' => 'System Mode',
		'value' => 1,
	    ));
	  } else {
	    $this->addElement('Hidden', 'environment_mode', array('order' => 990, 'value' => 0));
	  }

    // Add submit button
    $this->addElement('Button', 'submit_lsetting', array(
      'label' => 'Activate Your Plugin Now',
      'type' => 'submit',
      'ignore' => true
    ));

     $invite_mess = Engine_Api::_()->getApi('settings', 'core')->getSetting('fbfriend.siteinvite');
     
     $isFacebooksepageNewInstalled = Engine_Api::_()->getApi('settings', 'core')->getSetting('facebooksepage.new.install', 0);
     if (!empty($isFacebooksepageNewInstalled))
        $invite_mess = Engine_Api::_()->seaocore()->seaocoreTruncateText($invite_mess,55);   
		 	
     $invite_mess = Zend_Registry::get('Zend_Translate')->_($invite_mess);
		 $this->addElement('Textarea', 'fbfriend_siteinvite', array(
			'label' => 'Site Invitation Message',
			'description' => 'Enter the message that should go to the invited friends, when a user invites Facebook Friends to the site. (Maximum 55 characters)',
			'value'=> $invite_mess,
		       
		));     
     $this->fbfriend_siteinvite->getDecorator('Description')->setOptions(array('escape' => false,'placement' => 'PREPEND'));
    
     $Api_facebook = Engine_Api::_()->getApi('facebook_Facebookinvite', 'seaocore');
     $setting_array = array(1 => 'Yes', 0 => 'No');

    if($Api_facebook->checkAppReadPermission()) {
        
       $this->addElement('Radio', 'fb_my_facebook_link', array(
         'label' => 'My Facebook Page Link',
         'description' => "Do you want the 'My Facebook Page' link to appear in the left navigation on Member Home Page? <br />(This link will point to the 'My Facebook Page ' of the user.)",
         'multiOptions' => $setting_array,
         'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('fb.my.facebook.link', 1)

       ));
       $this->fb_my_facebook_link->getDecorator('Description')->setOptions(array('escape' => false,'placement' => 'PREPEND'));
    }

		$this->addElement('Radio', 'fb_invite_fbfriend', array(
			'label' => 'Invite Facebook Friends',
			'description' => "Do you want the 'Invite Facebook Friends' page to be there on the site?",
			'multiOptions' => $setting_array,
			'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('fb.invite.fbfriend', 1)
				
		));
    $this->fb_invite_fbfriend->getDecorator('Description')->setOptions(array('escape' => false,'placement' => 'PREPEND')); 
   
//		$this->addElement('Radio', 'fb_friends_page', array(
//			'label' => 'Facebook Friends Page',
//			'description' => "Do you want the 'Facebook Friends' page to be there on the site? (This page shows to the user his Facebook friends who are already members of the site.<br /> Note: This page requires the Facebook Integration of SocialEngine Core to be enabled.)",
//			'multiOptions' => $setting_array,
//			'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('fb.friends.page', 1)
//			
//		));
//    $this->fb_friends_page->getDecorator('Description')->setOptions(array('escape' => false,'placement' => 'PREPEND'));   
   $this->addElement('Radio', 'facebooksepage_siteenginessl', array(
			'label' => 'Website Engine SSL',
			'description' => "If your site runs on \"HTTPS\" then enable this setting. This setting is used when site user use the invite Facebook friends funtionality on your site.",
			'multiOptions' => $setting_array,
			'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('facebooksepage.siteenginessl', 0)
			
		));

    // Add submit button
    $this->addElement('Button', 'submit', array(
      'label' => 'Save Settings',
      'type' => 'submit',
      'ignore' => true
    ));
  }
}
