<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Facebookse
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: IndexController.php 6590 2011-01-06 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Facebooksepage_IndexController extends Core_Controller_Action_Standard {

    public function init() {
        $this->view->viewer_id = $viewer = Engine_Api::_()->user()->getViewer()->getIdentity();
        if (!empty($viewer)) {
            $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
                    ->getNavigation('facebookse_main');
            $ajaxContext = $this->_helper->getHelper('AjaxContext');
            $ajaxContext->addActionContext('delete', 'json');
            $enable_facebooksemodule = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('facebookse');
            if (empty($enable_facebooksemodule)) {
                $this->_helper->redirector->gotoRoute(array('action' => 'home'), 'user_general', true);
            }
        } else {
            //return $this->_helper->redirector->gotoRoute(array(), 'default', true);
        }
    }

    //FUNCTION FOR INVITING FACEBOOK FRIENDS.
    public function userfbinviteAction() {
        $this->view->isMobile = Engine_Api::_()->seaocore()->isMobile();
        $show_invitefbfriends = Engine_Api::_()->getApi('settings', 'core')->getSetting('fb.invite.fbfriend', 1);
        if (empty($show_invitefbfriends) || !Engine_Api::_()->user()->getViewer()->getIdentity()) {
            $this->_helper->redirector->gotoRoute(array('action' => 'home'), 'user_general', true);
        }
        $loginUrl = '';
        $this->view->friends_invite_temp = '';
        $this->view->friends_invite = '';
        $this->view->show_type_invitefbfriends = $show_type_invitefbfriends = Engine_Api::_()->getApi('settings', 'core')->getSetting('fb.friends.invitetype', 1);

        $sitename = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.general.site.title');
        $facebooksepage_fbinvite = Engine_Api::_()->getApi('settings', 'core')->getSetting('facebooksepage.fbinvite');


        $session = new Zend_Session_Namespace();
        $FBloginURL = Zend_Controller_Front::getInstance()->getRouter()
                        ->assemble(array('module' => 'seaocore', 'controller' => 'auth', 'action' => 'facebook'), 'default', true) . '?' . http_build_query(array('redirect_urimain' => urlencode((_ENGINE_SSL ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . $this->view->url() . '?FBNewsFeed_redirect_fb=1')));
        $facebook = Seaocore_Api_Facebook_Facebookinvite::getFBInstance();
        $fb_checkconnection = Seaocore_Api_Facebook_Facebookinvite::checkConnection(null, $facebook);
        $logged_user = null;

        // Session based API call.
        if ($facebook && !empty($facebooksepage_fbinvite) && $fb_checkconnection) {         
                try {
                    $uid = $_SESSION['facebook_uid'];
                    $fbUserInfo = $facebook->api('/' . $uid);
                    $displayname = $fbUserInfo['name'];
                    $this->view->var_fbconnect_invitef_redirect = $var_fbconnect_invitef_redirect = "http://{$_SERVER['HTTP_HOST']}" . $this->view->url(array('fbinvited' => 1), 'friends_facebooksepage_viewall') . '?fbinvited=1';

                    $friends_invite_temp = $this->view->friends_invite_temp = Seaocore_Api_Facebook_Facebookinvite::find_friends_added_thisapp();


                    $this->view->invitecode = Seaocore_Api_Facebook_Facebookinvite::getInviteCode($uid, $displayname);
                    $isFBActive = true;
                } catch (Exception $e) {
                    $isFBActive = false;
                }
 
        } else {
            $isFBActive = false;
        }

        if (!$isFBActive) {
            $fblogin_message = Zend_Registry::get('Zend_Translate')->_('You need to be logged into Facebook to see your Friends.');
            $fblogin_heading = Zend_Registry::get('Zend_Translate')->_('Invite your Facebook friends to %s');
            $fblogin_heading = sprintf($fblogin_heading, $sitename);

            $this->view->friends_invite = '<h3 style="margin-bottom:6px;">' . $fblogin_heading . '</h3><div class="white">';

            $loginUrl = $FBloginURL;
            $this->view->friends_invite .= '<a href="javascript:void(0);" onclick= "FBNewsFeed_ShowFeedDialogue_FB(\'' . $loginUrl . '\')" class="fbpage_button"><img src="' . Zend_Registry::get('Zend_View')->layout()->staticBaseUrl . 'application/modules/Facebooksepage/externals/images/facebook-login.gif"></a>' . $fblogin_message . '</div>';
        }


        if (empty($loginUrl) && empty($friends_invite_temp['showinviterpage'])) {
//      $this->view->friends_invite = '<div class="tip"><span>'  . Zend_Registry::get('Zend_Translate')->_('No such Facebook friends found.') . '</span></div>   ';
            $fbinvitebutton = Zend_Registry::get('Zend_Translate')->_('Invite your Facebook friends to %s');
            $fbinvitebutton = sprintf($fbinvitebutton, $sitename);
            $this->view->friends_invite = '<a href="javascript:void(0)" onclick="show_contacts_Facebook(1);" ><button>' . $fbinvitebutton . '</button></a>';
        }
    }

    //FUNCTION FOR SHOWING FACEBOOK FRIENDS WHO ARE SITE MEMBERS ALSO.
//    public function userfbfriendsAction() {
//        $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
//        $enable_facebooksemodule = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('facebookse');
//
//        $enable_fboldversion = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('socialdna');
//
//        $show_fbpagefriends = Engine_Api::_()->getApi('settings', 'core')->getSetting('fb.friends.page', 1);
//        if (('none' == Engine_Api::_()->getApi('settings', 'core')->core_facebook_enable && empty($enable_fboldversion)) || empty($viewer_id) || empty($show_fbpagefriends) || empty($enable_facebooksemodule)) {
//            $this->_helper->redirector->gotoRoute(array('action' => 'home'), 'user_general', true);
//        }
//
//        $session = new Zend_Session_Namespace();
//        $facebook = Seaocore_Api_Facebook_Facebookinvite::getFBInstance();
//        $FBloginURL = Zend_Controller_Front::getInstance()->getRouter()
//                        ->assemble(array('module' => 'seaocore', 'controller' => 'auth', 'action' => 'facebook'), 'default', true) . '?' . http_build_query(array('redirect_urimain' => urlencode((_ENGINE_SSL ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . $this->view->url() . '?FBNewsFeed_redirect_fb=1')));
//        $logged_user = null;
//
//        //SELECT uid1 FROM friend WHERE uid1 IN (SELECT uid2 FROM friend WHERE uid1=source_uid) AND uid2=target_uid
//        if ($facebook && Seaocore_Api_Facebook_Facebookinvite::checkConnection(null, $facebook)) {
//            $permissions = $facebook->api("/me/permissions");
//            if (Seaocore_Api_Facebook_Facebookinvite::checkPermission('user_friends', $permissions)) {
//                try {
//                    $uid = $_SESSION['facebook_uid'];
//
//                    // Create our Application instance.
//                    $fbuid_loogedinuser = $uid;
//                    $fbuid_profile_owner = $uid;
//                    $this->view->fblogin = true;
//                    $friends = array();
//                    //get user id
//                    //or you can use $uid = $fbme['id'];
//                    $fbFriends = $facebook->api('/me/friends');
//
////          $fql = "SELECT uid1 FROM friend WHERE uid1 IN (SELECT uid2 FROM friend WHERE uid1='$fbuid_loogedinuser') AND uid2='$fbuid_profile_owner'";
////          $param = array(
////              'method' => 'friends.get',
////              'query' => $fql,
////              'callback' => ''
////          );
////          $fqlResult = $facebook->api($param);
////          $friends_temp = array();
////          foreach ($fqlResult as $row_temp) {
////            $friends_temp[] = $row_temp;
////          }
////          $imlode_str = implode(', ', $friends_temp);
////
////          $fql_final = "SELECT uid FROM user WHERE uid IN ($imlode_str) AND has_added_app = 1";
////          $param = array(
////              'method' => 'friends.getappusers',
////              'query' => $fql_final,
////              'callback' => ''
////          );
////
////          try {
////            $fql_finalResult = $facebook->api($param);
////          }
////          catch (Exception $e) {
////            $this->view->fblogin = false;
////          }
//                } catch (Exception $o) {
//                    $this->view->fblogin = false;
//                }
//
//                $this->view->loginUrl = $FBloginURL;
//                if (count($fbFriends['data']) < 1) {
//                    return;
//                } else {
//                    foreach ($fbFriends['data'] as $friend_arr) {
//                        $friends_fbuids[] = $friend_arr['id'];
//                    }
//                }
//
//                $implode_friends_fbuids = implode(', ', $friends_fbuids);
//                $this->view->fbuser_ids = $implode_friends_fbuids;
//
//                //TAG WORK
//                $tmTable = Engine_Api::_()->getDbtable('users', 'user');
//                $tmName = $tmTable->info('name');
//                $rName = Engine_Api::_()->getDbtable('facebook', 'user')->info('name');
//                $select = $tmTable->select()
//                        ->setIntegrityCheck(false)
//                        ->from($tmName, array('user_id', 'username', 'photo_id', 'lastlogin_date', 'update_date', 'displayname'))
//                        ->join($rName, "$tmName.user_id = $rName.user_id", 'facebook_uid')
//                        ->where($rName . '.facebook_uid IN (' . $implode_friends_fbuids . ')')
//                        ->where($tmName . '.verified = ?', '1')
//                        ->where($tmName . '.enabled = ?', '1')
//                        ->where($tmName . '.search = ?', '1');
//                // Get paginator
//                $this->view->paginator = $paginator = Zend_Paginator::factory($select);
//
//                $paginator->setItemCountPerPage(10);
//                $paginator->setCurrentPageNumber($this->_getParam('page'));
//            } else {
//                $this->view->fblogin = false;
//                $this->view->loginUrl = $FBloginURL;
//            }
//        } else {
//            $this->view->fblogin = false;
//            $this->view->loginUrl = $FBloginURL;
//        }
//    }

    //FUNCTION WHICH IS CALLED WHEN WE HAVE TO RESET SESSION OF FACEBOOK_FEED INFO.
    function resetfbfeedAction() {
        $session = new Zend_Session_Namespace();
        unset($session->feed_info);
        exit;
    }

    public function myfacebookpageAction() {

        $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
        if (!empty($viewer_id)) {
            $this->_helper->redirector->gotoRoute(array('action' => 'userfbinvite'), 'facebooksepage_userfbinvite', true);
        } else {
            $this->_helper->redirector->gotoRoute(array('action' => 'home'), 'user_general', true);
        }

        $Api_facebook = Engine_Api::_()->getApi('facebook_Facebookinvite', 'seaocore');
        if (!$Api_facebook->checkAppReadPermission())
            $this->_helper->redirector->gotoRoute(array('action' => 'home'), 'user_general', true);
        //SHOW WIDGETS
        //SAVING THE INVITED USERS IN DATABASE INVITE TABLE. 
        $fbinvited = $this->getRequest()->get('fbinvited', 0);
        if ($fbinvited && $this->getRequest()->isPost()) {

            Seaocore_Api_Facebook_Facebookinvite::seacoreInvite($this->getRequest()->get('ids'), 'facebook');
            $var_fbconnect_invitef_redirect = (_ENGINE_SSL ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . $this->view->url(array(), 'friends_facebooksepage_viewall');
            return $this->_helper->redirector->gotoUrl($var_fbconnect_invitef_redirect, array('prependBase' => false));
        }
        $coremodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core');
        $coreversion = $coremodule->version;
        if ($coreversion < '4.1.0') {
            $this->_helper->content->render();
        } else {
            $this->_helper->content->setNoRender()->setEnabled();
        }
    }

}
