<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Facebookse
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 6590 2011-01-06 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Facebooksepage_Installer extends Engine_Package_Installer_Module {

    function getFacebookseStatus() {
        $db = $this->getDb();
        $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();

        //CHECKING IF THE ADVANCED FACEBOOK PLUGIN IS INSTALLED OR NOT.
        $is_installed = $db->query("SELECT `name` FROM `engine4_core_modules` WHERE `name` = 'facebookse' LIMIT 1")->fetchColumn();

        if (empty($is_installed)) {
            return $this->_error("<span style='color:red'>This plugin is dependent on the <a href=' http://www.socialengineaddons.com/socialengine-advanced-facebook-integration-likes-social-plugins-and-open-graph' target='_blank'>Advanced Facebook Integration / Likes, Social Plugins and Open Graph</a> Plugin, and requires that to be installed first. Please install that plugin first on your site before installing this 'Facebook News Feed, Friends, Invite and more' Plugin.</span><br/> <a href='" . $base_url . "/manage'>Click here</a> to go Manage Packages.");
            die;
        }

        //CHECKING IF THE ADVANCED FACEBOOK PLUGIN IS ENABLED OR NOT.
        $is_enabled = $db->query("SELECT `enabled` FROM `engine4_core_modules` WHERE `name` = 'facebookse' LIMIT 1")->fetchColumn();

        if (empty($is_enabled)) {
            return $this->_error("<span style='color:red'>This plugin is dependent on the <a href=' http://www.socialengineaddons.com/socialengine-advanced-facebook-integration-likes-social-plugins-and-open-graph' target='_blank'>Advanced Facebook Integration / Likes, Social Plugins and Open Graph</a> Plugin, and requires that to be enabled first. Please enable that plugin first on your site before installing this 'Facebook News Feed, Friends, Invite and more' Plugin.</span><br/> <a href='" . $base_url . "/manage'>Click here</a> to go Manage Packages.");
            die;
        }
        $is_existname = $db->query("SELECT `name` FROM `engine4_core_settings` WHERE `name` = 'facebookse.isActivate' LIMIT 1")->fetchColumn();
        if (!empty($is_existname)) {
            $is_activated = $db->query("SELECT `value` FROM `engine4_core_settings` WHERE `name` = 'facebookse.isActivate' LIMIT 1")->fetchColumn();

            if (empty($is_activated)) {
                $baseUrl = $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getBaseUrl();
                $url_string = Zend_Controller_Front::getInstance()->getRequest()->getRequestUri();
                if (strstr($url_string, "manage/install")) {
                    $calling_from = 'install';
                } else if (strstr($url_string, "manage/query")) {
                    $calling_from = 'queary';
                }
                $explode_base_url = explode("/", $baseUrl);
                foreach ($explode_base_url as $url_key) {
                    if ($url_key != 'install') {
                        $core_final_url .= $url_key . '/';
                    }
                }
                return $this->_error("<span style='color:red'>This plugin is dependent on the <a href=' http://www.socialengineaddons.com/socialengine-advanced-facebook-integration-likes-social-plugins-and-open-graph' target='_blank'>Advanced Facebook Integration / Likes, Social Plugins and Open Graph</a> Plugin, and requires that to be activated first. Please activate that plugin first on your site before installing this 'Facebook News Feed, Friends, Invite and more' Plugin.</span><br/> <a href='" . 'http://' . $core_final_url . "admin/facebookse/settings/readme'>Click here</a> to go Manage Packages.");
                die;
            }
        }
    }

    function onPreInstall() {
        $status = $this->getFacebookseStatus();
        if (!empty($status)) {

            return;
        }
        $PRODUCT_TYPE = 'facebooksepage';
        $PLUGIN_TITLE = 'Facebooksepage';
        $PLUGIN_VERSION = '5.4.1p1';
        $PLUGIN_CATEGORY = 'plugin';
        $PRODUCT_DESCRIPTION = 'Facebooksepage Plugin';
        $_PRODUCT_FINAL_FILE = 0;
        $_BASE_FILE_NAME = 0;
        $PRODUCT_TITLE = 'Facebook Friends and Inviter';
        $SocialEngineAddOns_version = '4.8.5';
        $file_path = APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/ilicense.php";
        $is_file = file_exists($file_path);
        if (empty($is_file)) {
            include_once APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/license3.php";
        } else {
            if (!empty($_PRODUCT_FINAL_FILE)) {
                include_once APPLICATION_PATH . '/application/modules/' . $PLUGIN_TITLE . '/controllers/license/' . $_PRODUCT_FINAL_FILE;
            }
            $db = $this->getDb();
            $select = new Zend_Db_Select($db);
            $select->from('engine4_core_modules')->where('name = ?', $PRODUCT_TYPE);
            $is_Mod = $select->query()->fetchObject();
            if (empty($is_Mod)) {
                include_once $file_path;
            }
        }
        parent::onPreInstall();
    }

    function onInstall() {
        //CHECK THAT SITEPAGE PLUGIN IS INSTALLED OR NOT
        $db = $this->getDb();

        $facebooksepage_base_time = time();
        $db->query("INSERT IGNORE INTO `engine4_core_settings` (`name`, `value`) VALUES
			('facebooksepage.base.time', $facebooksepage_base_time ),
			('facebooksepage.checkset.var', 0 ),  
			('facebooksepage.timevar.limit', 3456000 ),
			('facebooksepage.get.pathinfo', 'Facebooksepage/controllers/license/license2.php');");

        //CHECKING IF THE FACEBOOKSE PAGE PLUGIN IS INSTALLED OR NOT ALREADY.
        $is_installed = $db->query("SELECT `name` FROM `engine4_core_modules` WHERE `name` = 'facebooksepage' LIMIT 1")->fetchColumn();
        if (empty($is_installed)) {
            $db->query("INSERT IGNORE INTO `engine4_core_settings` (`name`, `value`) VALUES
			('facebooksepage.new.install', 1 );");
        }
        include_once APPLICATION_PATH . '/application/modules/Facebooksepage/controllers/license/license2.php';
        $db->query("UPDATE  `engine4_seaocores` SET  `is_activate` =  '1' WHERE  `engine4_seaocores`.`module_name` ='facebooksepage';");

        $db->update('engine4_core_menuitems', array('label' => "SEAO - FB Friends and Inviter"), array('name =?' => 'core_admin_main_plugins_facebooksepage'));

        $is_exists = $db->query("SELECT `name` FROM `engine4_core_menuitems` WHERE `name` = 'facebooksepage_main_myfacebookfriends' LIMIT 1")->fetchColumn();

        if (!empty($is_exists)) {
            $db->query("DELETE FROM `engine4_core_menuitems` WHERE `name` = 'facebooksepage_main_myfacebookfriends'");
        }

        //check if the plugin is installing and the facebook app is not created or if created the the app is either have read permission or not. If not then we will change the "My Facebook" label to Facebook Friends.

        parent::onInstall();
    }

    function onDisable() {
        $db = $this->getDb();
        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_menuitems')
                ->where('name = ?', 'facebooksepage_friend_home');
        $check_intro = $select->query()->fetchObject();
        if (!empty($check_intro)) {
            $db->update('engine4_core_menuitems', array(
                'module' => 'facebookse', 'plugin' => 'Facebookse_Plugin_Menus', 'params' => '{"route":"facebookse_index_settings", "icon":"application/modules/Facebookse/externals/images/facebookse.png"}'
                    ), array('name =?' => 'facebooksepage_friend_home'));
        }
        parent::onDisable();
    }

    function onEnable() {
        $db = $this->getDb();
        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_menuitems')
                ->where('name = ?', 'facebooksepage_friend_home');
        $check_intro = $select->query()->fetchObject();
        if (!empty($check_intro)) {
            $db->update('engine4_core_menuitems', array(
                'module' => 'facebooksepage', 'plugin' => 'Facebooksepage_Plugin_Menus', 'params' => '{"route":"friends_facebooksepage_viewall", "icon":"application/modules/Facebooksepage/externals/images/facebookse.png"}'
                    ), array('name =?' => 'facebooksepage_friend_home'));
        }
        parent::onEnable();
    }

}

?>