<?php

/**
 * SocialEngine
 *
 * @category   Application_Theme
 * @package    Facelight
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Customization.php 2017-12-15 00:00:00 SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Facelight_Form_Admin_Customization extends Engine_Form {

    public function init() {

        $this->setTitle(sprintf(Zend_Registry::get('Zend_Translate')->_("Theme Customization")));

        $this->addElement('Radio', 'facelight_theme_customization', array(
            'label' => 'Select Theme Color',
            'multiOptions' => array(
                0 => 'DEFAULT',
                1 => 'PINK',
                2 => 'GREEN',
                4 => 'DARK SKY BLUE',
                5 => 'VOILET',
                6 => 'ORANGE',
                7 => 'SUNFLOWER',
                8 => 'YELLOW',
                9 => 'EMERALD',
                10 => 'DARK PINK',
                3 => 'Custom Colors (Choosing this option will enable you to customize your theme according to your site.)'
            ),
            'onchange' => 'changeThemeCustomization();',
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('facelight.theme.customization', 0),
        ));


        $this->addElement('Text', 'facelight_theme_color', array(
            'decorators' => array(array('ViewScript', array(
                        'viewScript' => '_themeColor.tpl',
                        'class' => 'form element'
                    )))
        ));

        $this->addElement('Text', 'facelight_theme_button_border_color', array(
            'decorators' => array(array('ViewScript', array(
                        'viewScript' => '_themeButtonBorderColor.tpl',
                        'class' => 'form element'
                    )))
        ));

        // $this->addElement('Text', 'facelight_landingpage_signinbtn', array(
        //     'decorators' => array(array('ViewScript', array(
        //                 'viewScript' => '_themeLandingPageSigninButtonColor.tpl',
        //                 'class' => 'form element'
        //             )))
        // ));

        $this->addElement('Text', 'facelight_theme_containers_background_color', array(
            'decorators' => array(array('ViewScript', array(
                        'viewScript' => '_themeContainersBackgroundColor.tpl',
                        'class' => 'form element'
                    )))
        ));

        $this->addElement('Radio', 'facelight_theme_choose_website_image_color', array(
            'label' => 'Website\'s Body Background Image / Color',
            'description' => 'Do you want to display Background Image or Background Color in body background of your website ?',
            'multiOptions' => array(
                0 => 'Body Background Image',
                1 => 'Body Background Color'
            ),
            'onchange' => 'changeWebsiteImage(this.value);',
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('facelight.theme.choose.website.image.color', 1),
        ));

        // Get available files
        $logoOptions = Engine_Api::_()->facelight()->getImages(array('' => 'Text-only (No logo)'));

        $this->addElement('Select', 'facelight_theme_website_body_background_image', array(
            'label' => 'Website\'s Body Background Image',
            'description' => 'Choose the Website\'s Body Background Image for your website. (You can upload a new file from: "Layout" > "File & Media Manager")',
            'multiOptions' => $logoOptions,
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('facelight.theme.website.body.background.image', 0),
        ));
        $this->addElement('Text', 'facelight_theme_background_color', array(
            'decorators' => array(array('ViewScript', array(
                        'viewScript' => '_themeBackgroundColor.tpl',
                        'class' => 'form element'
                    )))
        ));

        $this->addElement('Button', 'submit', array(
            'label' => 'Submit',
            'type' => 'submit',
            'decorators' => array(
                'ViewHelper',
            ),
        ));
    }

}
