<?php

/**
 * SocialEngine
 *
 * @category   Application_Theme
 * @package    Facelight
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Menus.php 2017-12-15 00:00:00 SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Facelight_Model_DbTable_Menus extends Engine_Db_Table {
    protected $_rowClass = "Facelight_Model_Menu";
    function getAllMenus($params = array()){
        $parent = isset($params['parent']) ? $params['parent'] : 0;
        $select = $this->select()
                       ->where('parent =? ',$parent)
                       ->order('order ASC');
        if(!empty($params['enabled'])) {
            $select->where('enabled =? ',1);
        }
        if(!empty($params['link'])) {
            $select->where('link =? ','');
        }
        $menus =  $this->fetchAll($select);
        return $menus;
    }
    function deleteMenu($menu_id = 0) {
        $row    =   $this->select()
                        ->where('menu_id = ?',$menu_id)
                        ->query()->fetchObject();
        
        if(!empty($row) && empty($row->parent)){
            $this->delete(array('parent = ?' => $menu_id));
        }
        $this->delete(array('menu_id = ?' => $menu_id));

        
    }
    public function getMenuItem($menu_id =0) {
        $select = $this->select()->where('menu_id = ?',$menu_id);
        $menu = $this->fetchAll($select);
        return $menu[0];
    }
    public function setMenuIcon($icon)
    {
      if( $icon instanceof Zend_Form_Element_File ) {
        $file = $icon->getFileName();
        $fileName = $file;
      } else if( $icon instanceof Storage_Model_File ) {
        $file = $icon->temporary();
        $fileName = $icon->name;
      } else if( $icon instanceof Core_Model_Item_Abstract && !empty($icon->file_id) ) {
        $tmpRow = Engine_Api::_()->getItem('storage_file', $icon->file_id);
        $file = $tmpRow->temporary();
        $fileName = $tmpRow->name;
      } else if( is_array($icon) && !empty($icon['tmp_name']) ) {
        $file = $icon['tmp_name'];
        $fileName = $icon['name'];
      } else if( is_string($icon) && file_exists($icon) ) {
        $file = $icon;
        $fileName = $icon;
      } else {
        throw new Core_Model_Exception('invalid argument passed to setPhoto');
      }

      if( !$fileName ) {
        $fileName = basename($file);
      }

      $extension = ltrim(strrchr(basename($fileName), '.'), '.');
      $base = rtrim(substr(basename($fileName), 0, strrpos(basename($fileName), '.')), '.');
      $path = APPLICATION_PATH . DIRECTORY_SEPARATOR . 'temporary';

      // Save
      $filesTable = Engine_Api::_()->getDbtable('files', 'storage');

      // Resize image (icon)
      $iconPath = $path . DIRECTORY_SEPARATOR . $base . '_s-i.' . $extension;
      $image = Engine_Image::factory();
      $image->open($file)
        ->resize(90, 90)
        ->write($iconPath)
        ->destroy();


      // Store
      $icon = $filesTable->createSystemFile($iconPath);

      // Remove temp files
      @unlink($icon);

      return $icon->getPhotoUrl();
    }
}
