<?php

/**
 * SocialEngine
 *
 * @category   Application_Theme
 * @package    Facelight
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Shortcuts.php 2017-12-15 00:00:00 SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Facelight_Model_DbTable_Shortcuts extends Engine_Db_Table {

    public function addToShortcut($params = array()){
        if(empty($params['resource_type']) && empty($params['resource_id']) && empty($params['user_id'])){
            return;
        }
        if($this->isAdded($params)){
            return;
        }
        $this->insert($params);
    }
    public function deleteFromShortcut($params = array()){
        if(empty($params['resource_type =?']) && empty($params['resource_id =?']) && empty($params['user_id =?'])){
            return;
        }
        $this->delete($params);
    }
    public function isAdded($params = array()){
            $shortcut_id = $this->select()->from($this->info('name'),array('shortcut_id'))
                               ->where('resource_type =?',$params['resource_type'])
                               ->where('resource_id =?',$params['resource_id'])
                               ->where('user_id =?',$params['user_id'])
                               ->limit(1)
                               ->query()
                               ->fetchColumn();
            if(empty($shortcut_id)){
                return false;
            }
        return true;    
    }
    public function getUserShortcuts($viewer){
            if(empty($viewer->getIdentity())){
                return null;
            }
            $select = $this->select()
                            ->where('user_id =?',$viewer->getIdentity());
            return $this->fetchAll($select);
    }
}
