<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Facelight
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminSettingsController.php 2015-05-15 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Facelight_AdminSettingsController extends Core_Controller_Action_Admin {

    public function indexAction() {

        include APPLICATION_PATH . '/application/modules/Facelight/controllers/license/widgetSettings.php';

        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('facelight_admin_main', array(), 'facelight_admin_settings_index');

        $this->view->form = $form = new Facelight_Form_Admin_Settings();
        $this->view->isChecked = Engine_Api::_()->getApi('settings', 'core')->getSetting('facelight.navigation.drawer', 1);
        if (!$this->getRequest()->isPost())
            return;

        $tempLanguageDataArray = array();
        $tempLanguageTitleDataArray = array();
        if ($this->getRequest()->isPost()) {
            $localeMultiOptions = Engine_Api::_()->facelight()->getLanguageArray();
            $coreSettings = Engine_Api::_()->getApi('settings', 'core');
            $defaultLanguage = $coreSettings->getSetting('core.locale.locale', 'en');
            $total_allowed_languages = Count($localeMultiOptions);

            if (!empty($localeMultiOptions)) {
                foreach ($localeMultiOptions as $key => $label) {
                    $lang_name = $label;
                    if (isset($localeMultiOptions[$label])) {
                        $lang_name = $localeMultiOptions[$label];
                    }
                    if (!strstr($key, '_')) {
                        $key = $key . '_default';
                    }
                    $page_block_tagline_field = "facelight_lending_page_block_tagline_$key";
                    if ($total_allowed_languages <= 1) {
                        $page_block_tagline_field = "facelight_lending_page_block_tagline";
                    } elseif ($label == 'en' && $total_allowed_languages > 1) {
                        $page_block_tagline_field = "facelight_lending_page_block_tagline";
                    }


                    $tempLanguageTaglineDataArray[$key] = @base64_encode($_POST[$page_block_tagline_field]);
                }


                $coreSettings->setSetting('facelight.lending.page.block.tagline.languages', $tempLanguageTaglineDataArray);
            }
        }

        if (!$form->isValid($this->getRequest()->getPost()))
            return;

        $values = $form->getValues();

        // column width work ----------
        if ($values['theme_left_width'] > 300 || $values['theme_right_width'] > 300){
            $form->addError('The column width must be less 300px.');
            return;
        }
        $propertiesString = 'theme_content_columns_left_width: '. $values['theme_left_width'] .'px; theme_content_columns_right_width: '. $values['theme_right_width'] .'px;';
        $global_directory_name = APPLICATION_PATH . '/public/seaocore_themes';
        $global_settings_file = $global_directory_name . '/facelightThemeConstants.css';
        $is_file_exist = @file_exists($global_settings_file);
        if (empty($is_file_exist)) {
            if (!is_dir($global_directory_name)) {
                @mkdir($global_directory_name, 0777);
            }
        } else {
            if (!is_writable($global_settings_file)) {
                @chmod($global_settings_file, 0777);
                if (!is_writable($global_settings_file)) {
                    $form->addError('Unable to write Constant CSS file; please give the CHMOD 777 recursive permission to the directory /public/seaocore_themes/, then try again.');
                    return;
                }
            }
            $fileContent = file_get_contents($global_settings_file);
            $contentArray = explode(';', $fileContent);
            if (!empty($contentArray)) {
                $propertiesString = '';
                $leftAdded = $rightAdded = false;
                foreach ($contentArray as $properties) {
                    $propertyArray = explode(':', $properties);
                    if ($propertyArray[0] == 'theme_content_columns_left_width') {
                        $propertiesString .= 'theme_content_columns_left_width : '. $values['theme_left_width'] .'px; ';
                        $leftAdded = true;
                    } elseif ($propertyArray[0] == 'theme_content_columns_right_width') {
                        $propertiesString .= 'theme_content_columns_right_width : '. $values['theme_right_width'] .'px; ';
                        $rightAdded = true;
                    } else {
                        $propertiesString .= $properties . '; ';
                    }
                }

                if (!($rightAdded && $leftAdded))
                    $propertiesString .= 'theme_content_columns_left_width: '. $values['theme_left_width'] .'px; theme_content_columns_right_width: '. $values['theme_right_width'] .'px;';
            }
        }
        // Enter property string in the file
        @chmod($global_directory_name, 0777);
        $fh = @fopen($global_settings_file, 'w') or die('Unable to write Constant CSS file; please give the CHMOD 777 recursive permission to the directory /public/, then try again.');
        @fwrite($fh, $propertiesString);
        @fclose($fh);
        @chmod($global_settings_file, 0777);
        // column width work ----------

        // unset($values['facelight_column_width']);
        unset($values['facelight_lending_page_block_tagline']);
        foreach ($values as $key => $value) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting($key, $value);
        }
        $this->view->isChecked = Engine_Api::_()->getApi('settings', 'core')->getSetting('facelight.navigation.drawer', 1);
        $form->addNotice('Successfully Saved.');
    }

    public function faqAction() {
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('facelight_admin_main', array(), 'facelight_admin_settings_faq');
        $this->view->faq_id = $faq_id = $this->_getParam('faq', 'faq_1');
    }

    public function footerMenuAction() {
        $this->_redirect('admin/menus/index?name=facelight_footer');
    }

    public function placeHtaccessFileAction() {
        if ($this->getRequest()->isPost()) {
            $successfullyAdded = false;
            $getFileContent = '<FilesMatch ".(ttf|otf|woff)$">
    Header set Access-Control-Allow-Origin "*"
</FilesMatch>';

            $global_directory_name = APPLICATION_PATH . '/application/themes/facelight';
            $global_settings_file = $global_directory_name . '/.htaccess';
            $is_file_exist = @file_exists($global_settings_file);

            // IF FILE NOT EXIST THEN CREATE NEW .HTACCESS FILE THERE.
            if (empty($is_file_exist)) {
                if (is_dir($global_directory_name)) {
                    @mkdir($global_directory_name, 0777);

                    $fh = @fopen($global_settings_file, 'w') or die('Unable to create .htaccess file; please give the CHMOD 777 recursive permission to the directory "' . APPLICATION_PATH . '/application/themes/facelight' . '" and then try again.');
                    @fwrite($fh, $getFileContent);
                    @fclose($fh);

                    @chmod($global_settings_file, 0777);
                    $successfullyAdded = true;
                }
            } else {
                if (!is_writable($global_settings_file)) {
                    @chmod($global_settings_file, 0777);
                    if (!is_writable($global_settings_file)) {
                        $form->addError('Unable to create .htaccess file; please give the CHMOD 777 recursive permission to the directory "' . APPLICATION_PATH . '/application/themes/facelight' . '" and then try again.');
                        return;
                    }
                }
                $successfullyAdded = @file_put_contents($global_settings_file, $getFileContent);
            }

            if (!empty($successfullyAdded)) {
                $this->_forward('success', 'utility', 'core', array(
                    'smoothboxClose' => 10,
                    'parentRefresh' => 10,
                    'messages' => array('File Succesfully Created.')
                ));
            }
        }
    }

    public function placeCustomizationFileAction() {
        if ($this->getRequest()->isPost()) {
            $global_directory_name = APPLICATION_PATH . '/application/themes/facelight';
            @chmod($global_directory_name, 0777);

            if (!is_readable($global_directory_name)) {
                $this->view->error_message = "<span style='color:red'>Note: You do not have readable permission on the path below, please give 'chmod 777 recursive permission' on it to continue with the installation process : <br /> 
Path Name: <b>" . $global_directory_name . "</b></span>";
                return;
            }

            $global_settings_file = $global_directory_name . '/customization.css';
            $is_file_exist = @file_exists($global_settings_file);
            if (empty($is_file_exist)) {
                @chmod($global_directory_name, 0777);
                if (!is_writable($global_directory_name)) {
                    $this->view->error_message = "<span style='color:red'>Note: You do not have writable permission on the path below, please give 'chmod 777 recursive permission' on it to continue with the installation process : <br /> 
Path Name: " . $global_directory_name . "</span>";
                    return;
                }

                $fh = @fopen($global_settings_file, 'w');
                @fwrite($fh, '/* ADD CUSTOM STYLE */');
                @fclose($fh);

                @chmod($global_settings_file, 0777);
            }

            $this->_forward('success', 'utility', 'core', array(
                'smoothboxClose' => 10,
                'parentRefresh' => 10,
                'messages' => array('File Succesfully Created.')
            ));
        }
    }
}
