<?php

/**
 * SocialEngine
 *
 * @category   Application_Theme
 * @package    Facelight
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 2017-12-15 00:00:00 SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

$menusTable =  Engine_Api::_()->getDbtable('menus', 'facelight');
$menuCategories = $menusTable->getAllMenus( array('enabled' => 1,'link' => 1));
$homeFeedElements[] = array(
                    'Radio',
                    'showNewsFeed',
                    array(
                        'label' => "Do you want to show news feed option?",
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                );
             
if(Engine_Api::_()->hasModuleBootstrap('primemessenger') && Engine_Api::_()->primemessenger()->isPrimeMessengerActive()){
    $homeFeedElements[] = array(
                    'Radio',
                    'showPrimeMessenger',
                    array(
                        'label' => "Do you want to show prime messenger option?",
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                );
}
$menuCategoriesArray[] = 'All';
foreach ($menuCategories as $menu){
    $menuCategoriesArray[$menu->getIdentity()] = $menu->getTitle();
}
$view = Zend_Registry::get('Zend_View');
if(count($menuCategoriesArray) > 1) {
        $exploreLinksCategoryElement = array(
                        'Select',
                        'parent',
                        array(
                            'label' => 'Select Menu',
                            'multiOptions' => $menuCategoriesArray,
                        ),
                        'value' => '',
                );
} else {
    
        $exploreLinksCategoryElement = array(
                        'dummy',
                        'tip',
                        array(
                            'description' => '<div style="background-color: #E7E8B3;
    padding: 5px;">Some of the default explore links are already created for your site. You can edit / add more from <a href="'.$view->baseUrl('/admin/facelight/menus').'"  target = "_blank" >here</a> as per your requirement.</div>',
                            'decorators' => array('ViewHelper', array('Description', array('placement' => 'PREPEND', 'escape' => false))),
                        ),
                        'class' => 'tip',
                );
}
$onloadScript = " <script>
 window.addEvent('domready', function () {
      $('title-wrapper').style.display = 'none';
});


</script>";
return array(
    array(
        'title' => 'FB Clone Theme - Footer Menu',
        'description' => 'Shows the site-wide footer menu. You can edit its contents in your menu editor.',
        'category' => 'SEAO - FB Clone Theme',
        'type' => 'widget',
        'name' => 'facelight.menu-footer',
        'requirements' => array(
            'header-footer',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Radio',
                    'showCopyRight',
                    array(
                        'label' => 'Do you want to show the copyright note in the footer of your site?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1
                    )
                )
            )
        ),
    ),
    // array(
    //     'title' => 'FB Clone Theme - Main Menu',
    //     'description' => 'Shows the site-wide main menu. You can edit its contents in your menu editor.',
    //     'category' => 'SEAO - FB Clone Theme',
    //     'type' => 'widget',
    //     'name' => 'facelight.browse-menu-main',
    //     'adminForm' => array(
    //         'elements' => array(
    //             array(
    //                 'Text',
    //                 'max',
    //                 array(
    //                     'description' => "How many main menus do you want to showcase on your website?                                              The leftover menus will be shown under “More” option.",
    //                     'value' => 20
    //                 )
    //             )
    //         ))
    // ),
    array(
        'title' => 'FB Clone Theme - Search Box',
        'description' => 'Displays the Advanced Search box in the header. [Dependent on Advanced Search Plugin, if your are not having this plugin global search box will be displayed.]',
        'category' => 'SEAO - FB Clone Theme',
        'type' => 'widget',
        'name' => 'facelight.search-box',
        'adminForm' => array(
            'elements' => array(
                array(
                    'Radio',
                    'facelight_on_logged_out',
                    array(
                        'label' => 'Do you want to show this widget to non-logged-in users?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 0
                    )),
                array(
                    'Text',
                    'facelight_search_width',
                    array(
                        'label' => 'Enter width for searchbox.',
                        'value' => 240,
                    )
                ),
                array(
                    'Text',
                    'facelight_search_width',
                    array(
                        'label' => 'Enter width for searchbox.',
                        'value' => 240,
                    )
                ),
            ),
        ),
    ),
    array(
        'title' => 'FB Clone Theme - Login Form',
        'description' => 'Displays a Login form for the members who are not logged in.',
        'category' => 'SEAO - FB Clone Theme',
        'type' => 'widget',
        'name' => 'facelight.login-or-signup',
        'requirements' => array(
            'no-subject',
        ),
    ),
    array(
        'title' => 'FB Clone Theme - User Photo',
        'description' => 'Displays the logged-in member\'s photo.',
        'category' => 'SEAO - FB Clone Theme',
        'type' => 'widget',
        'name' => 'facelight.home-photo',
        'requirements' => array(
            'viewer',
        ),
        'adminForm' => array(
            'elements' => $homeFeedElements,
        ),
    ),
    array(
        'title' => 'FB Clone Theme - Signup / Login Form with Image and Tagline',
        'description' => 'Displays Signup / Login Form with Taglines.',
        'category' => 'SEAO - FB Clone Theme',
        'type' => 'widget',
        'name' => 'facelight.login-signup-tagline',
        'adminForm' => array(
            'elements' => array(
                array(
                    'MultiCheckbox',
                    'showSignupFields',
                    array(
                        'label' => "Please select the optional fields that you want to show in Sign Up form apart from mandatory fields.",
                        'multiOptions' => array(
                            'timezone' => 'Timezone',
                            'language' => 'Language [Only applicable if more than one language enabled on your website.]'
                        ),
                    //'value' => 1,
                    )
                ),
                array(
                    'Radio',
                    'show_signup_field_description',
                    array(
                        'label' => "Do you want to show signup form element description?",
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 0,
                    )
                ),
                array(
                    'Radio',
                    'showRecentLogins',
                    array(
                        'label' => "Do you want to show Recent Logins on the logout page?",
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
            ),
        ),
        'requirements' => array(
            'viewer',
        ),
    ),
    array(
        'title' => 'FB Clone Theme - Signup Button',
        'description' => 'Displays Signup Button.',
        'category' => 'SEAO - FB Clone Theme',
        'type' => 'widget',
        'name' => 'facelight.signup-button',
        'requirements' => array(
            'viewer',
        ),
    ),
    array(
        'title' => 'FB Clone Theme - Recent Logins',
        'description' => 'Displays Recent Login Users.',
        'category' => 'SEAO - FB Clone Theme',
        'type' => 'widget',
        'name' => 'facelight.list-logins',
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'max',
                    array(
                        'description' => "How many recently logged in users you want to display to make login easy? It will be browser specific.",
                        'value' => 4
                    )
                )
            )),
        'requirements' => array(
            'viewer',
        ),
    ),
    array(
        'title' => 'FB Clone Theme - Layout Scroll',
        'description' => 'This widget is used for handling multi layout scroll.',
        'category' => 'SEAO - FB Clone Theme',
        'type' => 'widget',
        'name' => 'facelight.layout-scroll',
    ),
    array(
        'title' => 'FB Clone Theme - Explore Links',
        'description' => 'This widget is used for showcasing all the explore links in order to make exploring easy for you. You can add / manage these links from Manage Explore Links tab in the admin panel.',
        'category' => 'SEAO - FB Clone Theme',
        'type' => 'widget',
        'name' => 'facelight.explore-links',
        'adminForm' => array(
            'elements' => array(
                $exploreLinksCategoryElement,
                array(
                    'Integer',
                    'viewmore_limit',
                    array(
                        'label' => "View More Limit",
                        'description' => "(Enter the number after which you want to show view more option for explore sub-menus)",
                        'value' => 2
                    )
                ),
            )),
    ),
    array(
        'title' => 'FB Clone Theme - Add / Remove Shortcut Buttons',
        'description' => 'This widget is used to add/remove shortcut for the user and it will only render on content/item profile pages.',
        'category' => 'SEAO - FB Clone Theme',
        'type' => 'widget',
        'name' => 'facelight.add-to-shortcuts',
    ),
    array(
        'title' => 'FB Clone Theme - User Shortcuts',
        'description' => 'This widget is used to display the user shortcuts and manage as well.',
        'category' => 'SEAO - FB Clone Theme',
        'type' => 'widget',
        'name' => 'facelight.user-shortcuts',
    ),
    array(
        'title' => 'FB Clone Theme - Languages',
        'description' => 'This widget is used to display the languages available on site.',
        'category' => 'SEAO - FB Clone Theme',
        'type' => 'widget',
        'name' => 'facelight.language',
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'showLanguages',
                    array(
                        'description' => "Enter the number of languages which you want to showcase. The left over languages will be shown under the more option.",
                        'value' => 3
                    )
                )
            )),
    ),
    array(
    'title' => 'FB Clone Theme - Site Logo',
    'description' => 'Shows your site-wide main logo or title.  Images are uploaded via the <a href="admin/files" target="_parent">File Media Manager</a>.',
    'category' => 'SEAO - FB Clone Theme',
    'type' => 'widget',
    'name' => 'facelight.menu-logo',
    'autoEdit' => true,
    'adminForm' => 'Facelight_Form_Admin_Widget_Logo',
    'requirements' => array(
      'header-footer',
    ),
  ),
)
?>