<?php

/**
 * SocialEngine
 *
 * @category   Application_Theme
 * @package    Facelight
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-12-15 00:00:00 SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Facelight_Widget_LoginOrSignupController extends Engine_Content_Widget_Abstract {

    public function indexAction() {
        // Do not show if logged in
        if (Engine_Api::_()->user()->getViewer()->getIdentity()) {
            $this->setNoRender();
            return;
        }


        // Display form
        $form = $this->view->form = new User_Form_Login(array(
            'mode' => 'column',
        ));
        $form->setTitle(null)->setDescription(null);
        //$form->removeElement('forgot');
        // $form->removeElement('remember');
        // Facebook login
        if ('none' == Engine_Api::_()->getApi('settings', 'core')->core_facebook_enable) {
            $form->removeElement('facebook');
        }

        $this->view->noForm = false;
        if (($captcha = $form->getElement('captcha')) instanceof Zend_Form_Element_Captcha &&
                $captcha->getCaptcha() instanceof Zend_Captcha_ReCaptcha) {
            $this->view->noForm = true;
            $emailFieldName = $form->getEmailElementFieldName();
            $form->removeElement($emailFieldName);
            $form->removeElement('password');
            $form->removeElement('captcha');
            $form->removeElement('submit');

            $form->removeDisplayGroup('buttons');
        }
    }

    public function getCacheKey() {
        return false;
    }

}
