<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions 
 * @package    User Connection
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 2010-07-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Featuredcontent_Api_Core extends Core_Api_Abstract
{
  function savePhoto($photo, $featured_id, $dir_name) 
  {
    //$global_check = Engine_Api::_()->getApi('settings', 'core')->getSetting('mcard.field.cat');
    //if(!empty($global_check))
    //{
	$file = $photo->getFileName();
	$name = basename($file);
	$path = APPLICATION_PATH . DIRECTORY_SEPARATOR . 'temporary';
	$params = array(
	    'parent_type' => $dir_name,
	    'parent_id' => $featured_id
	);
    
	// Saves the image into the storage table
	$storage = Engine_Api::_()->storage();

	// Resize image (main)
	$image = Engine_Image::factory();
	$image->open($file)
	  ->resize(720, 720)
	  ->write($path.'/m_'.$name)
	  ->destroy();

	// Resize image (profile)
	$image = Engine_Image::factory();
	$image->open($file)
	  ->resize(200, 400)
	  ->write($path.'/p_'.$name)
	  ->destroy();

	// Resize image (normal)
	$image = Engine_Image::factory();
	$image->open($file)
	  ->resize(140, 160)
	  ->write($path.'/in_'.$name)
	  ->destroy();

	// Resize image (icon)
	$image = Engine_Image::factory();
	$image->open($file);

	$size = min($image->height, $image->width);
	$x = ($image->width - $size) / 2;
	$y = ($image->height - $size) / 2;

	$image->resample($x, $y, $size, $size, 48, 48)
	  ->write($path.'/is_'.$name)
	  ->destroy();

	// Store
	$iMain = $storage->create($path.'/m_'.$name, $params);
	$iProfile = $storage->create($path.'/p_'.$name, $params);
	$iIconNormal = $storage->create($path.'/in_'.$name, $params);
	$iSquare = $storage->create($path.'/is_'.$name, $params);

	$iMain->bridge($iProfile, 'thumb.profile');
	$iMain->bridge($iIconNormal, 'thumb.normal');
	$iMain->bridge($iSquare, 'thumb.icon');
	//file_id is the id assigned to the file that is saved in the memory	
	return $iProfile->file_id;
    //}
  }

   /**
   * Returns: Object of member.
   *
   * @param $path_array: Array of member ids.
   * @return Array
   */
  public function member_info($member_path_array)
	{
		$member_users_id = '';
		if(is_array($member_path_array))
		{
			foreach ($member_path_array as $row_path_array)
			{
				$member_users_id .= ',' . $row_path_array['content_id'];
			}
			$member_users_id = ltrim($member_users_id, ',');
		}
		else
		{
			$member_users_id = $member_path_array;
		}
  	// FETCH RECORD FROM member TABLE
  	$member_table  = Engine_Api::_()->getItemTable('user');     
		$select_member_table = $member_table->select()->where("user_id IN ($member_users_id)");
		$member_info_array = $member_table->fetchAll($select_member_table);
  	return $member_info_array;
	}
	
	
   /**
   * Returns: Object of blog.
   *
   * @param $path_array: Array of blog ids.
   * @return Array
   */
  public function blog_info($blog_path_array)
	{
		$blog_users_id = '';
		if(is_array($blog_path_array))
		{
			foreach ($blog_path_array as $row_path_array)
			{
				$blog_users_id .= ',' . $row_path_array['content_id'];
			}
			$blog_users_id = ltrim($blog_users_id, ',');
		}
		else {
			$blog_users_id = $blog_path_array;
		}
  	// FETCH RECORD FROM blog TABLE
  	$blog_table  = Engine_Api::_()->getItemTable('blog');     
		$select_blog_table = $blog_table->select()->where("blog_id IN ($blog_users_id)");
		$blog_info_array = $blog_table->fetchAll($select_blog_table);
  	return $blog_info_array;
	}
	
   /**
   * Returns: Object of album.
   *
   * @param $path_array: Array of album ids.
   * @return Array
   */
  public function album_info($album_path_array)
	{
		$album_users_id = '';
		if(is_array($album_path_array))
		{
		foreach ($album_path_array as $row_path_array)
		{
			$album_users_id .= ',' . $row_path_array['content_id'];
		}
		$album_users_id = ltrim($album_users_id, ',');
		}
		else {
			$album_users_id = $album_path_array;
		}
  	//FETCH RECORD FROM album TABLE
  	$album_table  = Engine_Api::_()->getItemTable('album');     
		$select_album_table = $album_table->select()->where("album_id IN ($album_users_id)");
		$album_info_array = $album_table->fetchAll($select_album_table);
  	return $album_info_array;
	}
	
	/**
   * Returns: Object of group.
   *
   * @param $path_array: Array of group ids.
   * @return Array
   */
	public function group_info($path_array)
	{
		$group_users_id = '';
		if(is_array($path_array))
		{
			foreach ($path_array as $row_path_array)
			{
				$group_users_id .= ',' . $row_path_array['content_id'];
			}
			$group_users_id = ltrim($group_users_id, ',');
		}
		else {
			$group_users_id = $path_array;
		}
		//FETCH RECORD FROM USER TABLE
		$grp_table = Engine_Api::_()->getItemTable('group');
		$select_grp_table = $grp_table->select()->where("group_id IN ($group_users_id)");
		$grp_info_array = $grp_table->fetchAll($select_grp_table);
		return $grp_info_array;
	}
	
   /**
   * Returns: Object of classified.
   *
   * @param $path_array: Array of classified ids.
   * @return Array
   */
	public function classified_info($classified_path_array)
	{
		$classified_users_id = '';
		if(is_array($classified_path_array))
		{
			foreach ($classified_path_array as $row_path_array)
			{
				$classified_users_id .= ',' . $row_path_array['content_id'];
			}
			$classified_users_id = ltrim($classified_users_id, ',');
		}
		else {
			$classified_users_id = $classified_path_array;
		}
	 //FETCH RECORD FROM classified TABLE
	 $classified_table  = Engine_Api::_()->getItemTable('classified');     
	 $select_classified_table = $classified_table->select()->where("classified_id IN ($classified_users_id)");
	 $classified_info_array = $classified_table->fetchAll($select_classified_table);
	 return $classified_info_array;
	}
	
   /**
   * Returns: Object of video.
   *
   * @param $video_path_array: Array of video ids.
   * @return Array
   */
  public function video_info($video_path_array)
	{
		$video_users_id = '';
		if(is_array($video_path_array))
		{
			foreach ($video_path_array as $row_path_array)
			{
				$video_users_id .= ',' . $row_path_array['content_id'];
			}
			$video_users_id = ltrim($video_users_id, ',');
		}
		else {
			$video_users_id = $video_path_array;
		}
  	//FETCH RECORD FROM video TABLE
  	$video_table  = Engine_Api::_()->getItemTable('video');     
		$select_video_table = $video_table->select()->where("video_id IN ($video_users_id)");
		$video_info_array = $video_table->fetchAll($select_video_table);
  	return $video_info_array;
	}
	
   /**
   * Returns: Object of event.
   *
   * @param $event_path_array: Array of event ids.
   * @return Array
   */
	//Return event information.
  public function event_info($event_path_array)
	{
		$event_users_id = '';
		if(is_array($event_path_array))
		{
			foreach ($event_path_array as $row_path_array)
			{
				$event_users_id .= ',' . $row_path_array['content_id'];
			}
			$event_users_id = ltrim($event_users_id, ',');
		}
		else {
			$event_users_id = $event_path_array;
		}
  	//FETCH RECORD FROM event TABLE
  	$event_table  = Engine_Api::_()->getItemTable('event');     
		$select_event_table = $event_table->select()->where("event_id IN ($event_users_id)");
		$event_info_array = $event_table->fetchAll($select_event_table);
  	return $event_info_array;
	}
	
 /** 
 * @param $music_path_array : music id in the form of array.
 * @return Object.
 */
  public function music_info($music_path_array)
	{
		$music_users_id = '';
		if(is_array($music_path_array))
		{
			foreach ($music_path_array as $row_path_array)
			{
				$music_users_id .= ',' . $row_path_array['content_id'];
			}
			$music_users_id = ltrim($music_users_id, ',');
		}
		else {
			$music_users_id = $music_path_array;
		}
  	//FETCH RECORD FROM music TABLE
  	$music_table  = Engine_Api::_()->getItemTable('music_playlist');     
		$select_music_table = $music_table->select()->where("playlist_id IN ($music_users_id)");
		$music_info_array = $music_table->fetchAll($select_music_table);
  	return $music_info_array;
	}
	
   /**
   * Returns: Object of poll.
   *
   * @param $path_array: Array of poll ids.
   * @return Array
   */
  public function poll_info($poll_path_array)
	{
		$poll_users_id = '';
		if(is_array($poll_path_array))
		{
			foreach ($poll_path_array as $row_path_array)
			{
				$poll_users_id .= ',' . $row_path_array['content_id'];
			}
			$poll_users_id = ltrim($poll_users_id, ',');
		}
		else {
			$poll_users_id = $poll_path_array;
		}
  	//FETCH RECORD FROM poll TABLE
  	$poll_table  = Engine_Api::_()->getItemTable('poll');     
		$select_poll_table = $poll_table->select()->where("poll_id IN ($poll_users_id)");
		$poll_info_array = $poll_table->fetchAll($select_poll_table);
  	return $poll_info_array;
	}
	
   /**
   * Returns: Object of forum.
   *
   * @param $path_array: Array of forum ids.
   * @return Array
   */
  public function forum_info($forum_path_array)
	{
		$forum_users_id = '';
		if(is_array($forum_path_array))
		{
			foreach ($forum_path_array as $row_path_array)
			{
				$forum_users_id .= ',' . $row_path_array['content_id'];
			}
			$forum_users_id = ltrim($forum_users_id, ',');
		}
		else {
			$forum_users_id = $forum_path_array;
		}
  	//FETCH RECORD FROM forum TABLE
  	$forum_table  = Engine_Api::_()->getItemTable('forum_topic');     
		$select_forum_table = $forum_table->select()->where("topic_id IN ($forum_users_id)");
		$forum_info_array = $forum_table->fetchAll($select_forum_table);
  	return $forum_info_array;
	}
	
  
  // This function call by "Group Side Widget".
	public function featured_group_side_widget()
	{
	  $group_limit = Engine_Api::_()->getApi('settings', 'core')->getSetting('featured.wid.group');
	  $featured_groups_array = array();
	  // -> Group which are not expired.
	  // -> which set to show in "Mix Side Widget" or "Group Side widget".
	  $contentTable = Engine_Api::_()->getItemTable('featured');
	  $contentname = $contentTable->info('name');
	  $content_select = $contentTable->select()
		  ->from($contentname, array('content_id'))
		  ->where('content_type = ?', 'group')
		  ->where('individual_side = ?', 1)
		  ->where("ending_date > FROM_UNIXTIME(?)", time())
		  ->order('RAND()')
		  ->limit($group_limit);
	  $fetch_content = $content_select->query()->fetchAll();
	  if(!empty($fetch_content))
	  {
		  $featured_groups_array['featured_group'] = $fetch_content;
	  }
	  
	  // Find out number of group.
	  $group_content_select = $contentTable->select()
		  ->from($contentname, array('COUNT(featured_id) AS featured_group_count'))
		  ->where('content_type = ?', 'group')
		  ->where('individual_side = ?', 1)
		  ->where("ending_date > FROM_UNIXTIME(?)", time())
		  ->group('content_type');
	  $fetch_group_count = $group_content_select->query()->fetchAll();
	  if(!empty($fetch_group_count))
	  {
	    $featured_groups_array['featured_group_limit'] = $fetch_group_count;
	  }
	  return $featured_groups_array;
	}

	public function custom_side_widget()
	{
	  $custom_limit = Engine_Api::_()->getApi('settings', 'core')->getSetting('featured.sidewid.limit');
	  $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
	  $slideshow_content = '';
	  $customTable = Engine_Api::_()->getItemTable('featured');
	  $customname = $customTable->info('name');
	  $contentdataTable = Engine_Api::_()->getItemTable('featuredcontent_contentdata');
	  $contentdataname = $contentdataTable->info('name');
	  $custom_select = $customTable->select()
	      ->setIntegrityCheck(false)
	      ->from($customname, array())
	      ->joinLeft($contentdataname, $contentdataname .".featured_id = $customname . featured_id", array('image_id', 'title'))
	      ->where('user_approved = ?', 1)
	      ->where('status = ?', 1)
	      ->where("ending_date > FROM_UNIXTIME(?)", time())
	      ->order('RAND()')
	      ->limit($custom_limit);
	  
	  $fetch_custom_entry = $custom_select->query()->fetchAll();
	  $custom_slideshow_data_array = array();
	  // Making a array which will be return, Here with the help of key, calling the object function for every modules.	
	  foreach($fetch_custom_entry as $browse_custom_data)
	  {
	    if( !empty($browse_custom_data['image_id']) ) {
	      $custom_image = $this->displayPhoto($browse_custom_data['image_id']);
	      $custom_image = $view->htmlImage($custom_image);
	    }
	    else {
	      $custom_image = $browse_custom_data['image_id'];
	    }

	    $custom_slideshow_data_array['custom_title'] = $browse_custom_data['title'];
	    $custom_slideshow_data_array['custom_image'] = $custom_image;
	    $final_custom_array[] = $custom_slideshow_data_array;
	  }
	  return $final_custom_array;	  
	}
	
	// This function call by "User Browse Page". that return mix type featured content.
	public function user_browseall_content($values = array())
	{
		$browse_content = '';
		$searchTable = Engine_Api::_()->getDbTable('search', 'core');
		$searchName = $searchTable->info('name');
		$contentTable = Engine_Api::_()->getItemTable('featured');
		$contentname = $contentTable->info('name');
		$content_select = $contentTable->select()
			->from($contentname, array('content_id', 'content_type'))
			->where('mix_side = ?', 1)
			->where("ending_date > FROM_UNIXTIME(?)", time())
			->order('featured_id DESC');
		
		// Set when "Search by Featured Name".
		if(!empty($values['featured_name']))
		{
			$content_select->where("content_title LIKE ?", '%'.$values['featured_name'].'%');
		}
		// Set when "Search by Featured Type".
		if (!empty($values['featured_type']))
		{
			$content_select->where('content_type = ?', $values['featured_type']);
		}
		$fetch_content = $content_select->query()->fetchAll();
		// Making a array which will be return, Here with the help of key, calling the object function for every modules.	
		foreach($fetch_content as $browse_featured_data)
		{
			$browse_content[$browse_featured_data['content_type'] . '_' . $browse_featured_data['content_id']] = $browse_featured_data['content_id'];
		}
		return $browse_content;
	}
	
	// This function call by "User Browse Page". that return mix type featured content for slide show.
	public function user_browseall_slideshow($values = array())
	{ 
	  $slideshow_content = '';
	  $contentTable = Engine_Api::_()->getItemTable('featured');
	  $contentname = $contentTable->info('name');
	  $contentdataTable = Engine_Api::_()->getItemTable('featuredcontent_contentdata');
	  $contentdataname = $contentdataTable->info('name');
	  $content_select = $contentTable->select()
	      ->setIntegrityCheck(false)
	      ->from($contentname, array('content_id', 'content_type', 'caption_text', 'caption_link'))
	      ->joinLeft($contentdataname, $contentdataname .".featured_id = $contentname . featured_id", array('image_id', 'description'))
	      ->where('mix_slideshow = ?', 1)
	      ->where("ending_date > FROM_UNIXTIME(?)", time())
	      ->order($contentname . '.featured_id DESC');
	  
	  // Set when "Search by Featured Name".
	  if(!empty($values['featured_name']))
	  {
	    $content_select->where($contentname . ".content_title LIKE ?", '%'.$values['featured_name'].'%');
	  }
	  // Set when "Search by Featured Type".
	  if (!empty($values['featured_type']))
	  {
	    $content_select->where($contentname . '.content_type = ?', $values['featured_type']);
	  }
	  $fetch_content = $content_select->query()->fetchAll();
	  $slideshow_content = array();
	  // Making a array which will be return, Here with the help of key, calling the object function for every modules.	
	  foreach($fetch_content as $browse_featured_data)
	  {
	    $slideshow_content['content_id'] = $browse_featured_data['content_id'];
	    $slideshow_content['content_type'] = $browse_featured_data['content_type'];
	    $slideshow_content['content_image'] = $browse_featured_data['image_id'];
	    $slideshow_content['content_description'] = $browse_featured_data['description'];
	    $slideshow_content['caption_text'] = $browse_featured_data['caption_text'];
	    $slideshow_content['caption_url'] = $browse_featured_data['caption_link'];
	    $final_featured_array[] = $slideshow_content;
	    //$slideshow_content[$browse_featured_data['content_type'] . '_' . $browse_featured_data['content_id']] = $browse_featured_data['content_id'];
	  }
	  return $final_featured_array;
	}

	// This function call by "User Browse Page". that return mix type featured content for slide show.
	public function custom_slideshow()
	{
	  $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
	  $slideshow_content = '';
	  $customTable = Engine_Api::_()->getItemTable('featured');
	  $customname = $customTable->info('name');
	  $contentdataTable = Engine_Api::_()->getItemTable('featuredcontent_contentdata');
	  $contentdataname = $contentdataTable->info('name');
	  $custom_select = $customTable->select()
	      ->setIntegrityCheck(false)
	      ->from($customname, array('caption_text', 'caption_link'))
	      ->joinLeft($contentdataname, $contentdataname .".featured_id = $customname . featured_id", array('image_id', 'description', 'title'))
	      ->where('user_approved = ?', 1)
	      ->where('status = ?', 1)
	      ->where("ending_date > FROM_UNIXTIME(?)", time())
	      ->order($customname . '.featured_id DESC');
	  
	  $fetch_custom_entry = $custom_select->query()->fetchAll();
	  $custom_slideshow_data_array = array();
	  // Making a array which will be return, Here with the help of key, calling the object function for every modules.	
	  foreach($fetch_custom_entry as $browse_custom_data)
	  {
	    if( !empty($browse_custom_data['image_id']) ) {
	      $custom_image = $this->displayPhoto($browse_custom_data['image_id']);
	      $custom_image = $view->htmlImage($custom_image);
	    }
	    else {
	      $custom_image = $browse_custom_data['image_id'];
	    }

	    $custom_slideshow_data_array['custom_title'] = $browse_custom_data['title'];
	    $custom_slideshow_data_array['custom_image'] = $custom_image;
	    $custom_slideshow_data_array['custom_description'] = $browse_custom_data['description'];
	    $custom_slideshow_data_array['custom_text'] = $browse_custom_data['caption_text'];
	    $custom_slideshow_data_array['custom_url'] = $browse_custom_data['caption_link'];
	    $final_custom_array[] = $custom_slideshow_data_array;
	  }
	  return $final_custom_array;
	}

  public function displayPhoto($id, $type = 'thumb.profile') {
    if (empty($id)) {
      return null;
    }
    $file = $this->api()->getApi('storage', 'storage')->get($id, $type);
    if (!$file) {
      return null;
    }

    // Get url of the image
    $src = $file->map();
    return $src;
  }
	
   /**
   *
   * @param $title: String which are require for truncate
   * @return string
   */
	public function truncateTitle($title)
  {
    $tmpBody = strip_tags($title);
    return ( Engine_String::strlen($tmpBody) > 15 ? Engine_String::substr($tmpBody, 0, 17) . '..' : $tmpBody );
  }
}