<?php
/**
 * SocialEngine
 *
 * @category   Application_Core
 * @package    User
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.net/license/
 * @version    $Id: Network.php 6590 2010-06-25 19:40:21Z john $
 * @author     Sami
 */

/**
 * @category   Application_Core
 * @package    User
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.net/license/
 */
class Featuredcontent_Form_Admin_Global extends Engine_Form
{
  public function init()
  {    
    $this
    ->setTitle('Global Content Settings')
    ->setDescription('Lorin Lipsum.');
    
    // Tacking the value for "Slideshow widget" limit.
    $this->addElement('Text', 'featured_slidewid_limit', array(
      'label' => 'Slideshow widget limit',
      'description' => 'Number of entries in the Slideshow widgets for the various content types.', 
      'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('featured.slidewid.limit'),
    ));

    // Tacking the value for "Slideshow widget" content ordering.
    $this->addElement('Radio', 'featured_slidewid_ordering', array(      
    'label' => 'Ordering of slideshow content',
    'discription' => '',
    'multiOptions' => array(
      1 => 'Random, the entries will show up in a random manner.',
      0 => 'Sequential, the entries will show up in sequence. Sequence can be set from the “Featured Content” section.'             
    ),
    'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('featured.slidewid.ordering'),
    ));

    // Tacking the value for "Side widget" limit.
    $this->addElement('Text', 'featured_sidewid_limit', array(
      'label' => 'Side widget limit',
      'description' => 'Number of entries in the Side widgets for the various content types.', 
      'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('featured.sidewid.limit'),
    ));

     // Tacking the value for "Slideshow widget" content ordering.
    $this->addElement('Radio', 'featured_sidewid_order', array(      
    'label' => 'Ordering of side wedget content',
    'discription' => '',
    'multiOptions' => array(
      1 => 'Random, the entries will show up in a random manner.',
      0 => 'Sequential, the entries will show up in sequence. Sequence can be set from the “Featured Content” section.'             
    ),
    'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('featured.sidewid.order'),
    ));

    $this->addElement('Radio', 'content_menu', array(      
    'label' => 'Featured link for user',
    'discription' => 'User will see the link of featured content where user can featured any content select the menu where you want to show the link.',
    'multiOptions' => array(
      2 => 'Show in Header Menue.',
      1 => 'Show in Main Menue.',
      0 => 'Show in Footer Menue.'             
    ),
    'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('content_menu'),
    ));
    
    $this->addElement('Button', 'execute', array(
      'type' => 'submit',
      'label' => 'Save Settings',
    ));    
  }
}