<?php
 /**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Featuredcontent
 * @copyright  Copyright 2009-2010 Big Step Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Slideshow.php 6590 2010-16-11 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Featuredcontent_Form_Admin_Slideshow extends Engine_Form
{
  public function init()
  {
    $this
    ->setTitle('Slideshow Settings')
    ->setDescription('Configure and customize your slideshow based on various parameters. Visit the Demo tab to see the demo of the various slideshow types. You may also preview your slideshow based on the settings chosen by you by clicking on the Preview button at the bottom of this page.');

    $this->addElement('Select', 'featuredcontent_transition1', array(
    'label' => 'Transition type',
    'multiOptions' => array(
	    'Linear' => 'Linear',
	    'Quadratic' => 'Quadratic',
	    'Cubic' => 'Cubic',
	    'Quartic' => 'Quartic',
	    'Quintic' => 'Quintic',
	    'Sinusoidal' => 'Sinusoidal',
	    'Exponential' => 'Exponential',
	    'Circular' => 'Circular',
	    'Bouncing' => 'Bouncing',
	    'Back' => 'Back',
	    'Elastic' => 'Elastic'
    ),
    'decorators' => array(array('ViewScript', array(
    'viewScript' => '_formtransition.tpl',
    'class'      => 'form element'
    )))));

    $this->addElement('Text', 'featuredcontent_width', array(
      'label' => 'Slideshow width (in pixels)',
      'description' => 'Note : Because of a change in this setting, the widths of only the slideshow pictures uploaded after saving these settings will be affected.',
      'required' => true,
      'filters' => array(
      'StripTags',
      new Engine_Filter_Censor(),
      ),
      'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('featuredcontent.width', '180'),
    ));

    $this->featuredcontent_width->getDecorator('Description')->setOption('placement', 'append');

    $this->addElement('Text', 'featuredcontent_height', array(
      'label' => 'Slideshow height (in pixels)',
      'description' => 'Note : Because of a change in this setting, the heights of only the slideshow pictures uploaded after saving these settings will be affected.',
      'required' => true,
      'filters' => array(
      'StripTags',
      new Engine_Filter_Censor(),
      ),
      'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('featuredcontent.height', '240'),
    ));

    $this->featuredcontent_height->getDecorator('Description')->setOption('placement', 'append');

    $this->addElement('Text', 'featuredcontent_duration', array(
      'label' => 'Effect duration (in millisecond)',
      'description' => 'What is the duration you want for slide effects ?',
      'required' => true,
      'filters' => array(
      'StripTags',
      new Engine_Filter_Censor(),
      ),
      'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('featuredcontent.duration', '500'),
    ));

// 		$this->addElement('Text', 'featuredcontent_size', array(
//       'label' => 'Slideshow size',
//     	'required' => true,
//       'filters' => array(
//         'StripTags',
//         new Engine_Filter_Censor(),
//     ),
//     'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('featuredcontent.size', '240'),
//     ));

    $this->addElement('Text', 'featuredcontent_interval', array(
      'label' => 'Slide interval (in millisecond)',
      'required' => true,
      'filters' => array(
      'StripTags',
      new Engine_Filter_Censor(),
      ),
      'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('featuredcontent.interval', '5000'),
    ));

    $this->addElement('Radio', 'featuredcontent_autoplay', array(
      'label' => 'Slideshow auto play',
      'multioptions' => array(
      1 => 'Yes',
      0 => 'No'
      ),
      'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('featuredcontent.autoplay', '1'), 
    ));

// 		$this->addElement('Radio', 'featuredcontent_show_link', array(
//     	'label' => 'Show link',
//     	'multioptions' => array(
//     		1 => 'Yes',
//     		0 => 'No'
//     	),
//     	'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('featuredcontent.show.link', '1'), 
//     ));

// 		$this->addElement('Radio', 'featuredcontent_image_link', array(
//     	'label' => 'Make slide as a link',
//     	'multioptions' => array(
//     		1 => 'Yes',
//     		0 => 'No'
//     	),
//     	'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('featuredcontent.image.link', '1'), 
//     ));

// 		$this->addElement('Radio', 'featuredcontent_title', array(
//     	'label' => 'Slide titles',
//     	'description' => '',
//     	'multioptions' => array(
//     		1 => 'Yes',
//     		0 => 'No'
//     	),
//     	'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('featuredcontent.title', '1'),
//     ));

// 		$this->addElement('Radio', 'featuredcontent_index_next', array(
//     	'label' => 'Show slideshow next index',
//     	'description' => '',
//     	'multioptions' => array(
//     		1 => 'Yes',
//     		0 => 'No'
//     	),
//     	'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('featuredcontent.index.next', '1'), 
//     ));

		
    $this->addElement('Radio', 'featuredcontent_author', array(
      'label' => 'Show slide creator name if have',
      'description' => '',
      'multioptions' => array(
      1 => 'Yes',
      0 => 'No'
      ),
      'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('featuredcontent.author', '1'), 
    ));

		
// 		$this->addElement('Radio', 'featuredcontent_date', array(
//     	'label' => 'Show published date if have',
//     	'description' => '',
//     	'multioptions' => array(
//     		1 => 'Yes',
//     		0 => 'No'
//     	),
//     	'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('featuredcontent.date', '1'), 
//     ));

    $this->addElement('Radio', 'featuredcontent_mode', array(
      'label' => 'Select slideshow mode',
      'description' => '',
      'multioptions' => array(
      1 => 'Horizontal',
      0 => 'Vertical'
      ),
      'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('featuredcontent.mode', '1'), 
    ));

    $this->addElement('Radio', 'featuredcontent_pagination', array(
      'label' => 'Show Slideshow Controller',
      'description' => '',
      'multioptions' => array(
      1 => 'Yes',
      0 => 'No'
      ),
      'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('featuredcontent.pagination', '1'), 
    ));



// 		$this->addElement('Radio', 'featuredcontent_text_image', array(
//     	'label' => 'Show slide with text',
//     	'description' => '',
//     	'multioptions' => array(
//     		1 => 'Yes',
//     		0 => 'No'
//     	),
//     	'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('featuredcontent.thumbnail', '1'), 
//     ));

// 		$this->addElement('Checkbox', 'featuredcontent_previous', array(
//       'label' => 'show previous link',
//       'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('featuredcontent.previous', '1'), 
//     ));

// 		$this->addElement('Checkbox', 'featuredcontent_play', array(
//       'label' => 'show play link',
//       'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('featuredcontent.play', '1'), 
//     ));

// 		$this->addElement('Checkbox', 'featuredcontent_next', array(
//       'label' => 'show next link',
//       'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('featuredcontent.next', '1'), 
//     ));

// 		$this->addElement('Checkbox', 'featuredcontent_stop', array(
//       'label' => 'show stop link',
//       'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('featuredcontent.stop', '1'), 
//     ));

// 		$this->addElement('Checkbox', 'featuredcontent_playback', array(
//       'label' => 'show playback link',
//       'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('featuredcontent.playback', '0'), 
//     ));

    $this->addElement('Radio', 'featured_slide_info', array(
      'label' => 'Show current slide number & total slides',
      'description' => '',
      'multioptions' => array(
	1 => 'Yes',
	0 => 'No'
      ),
      'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('featured.slide.info', '1'), 
    ));    

    $this->addElement('Button', 'submit', array(
    'label' => 'Save Change',
    'type' => 'submit',
    'ignore' => true,
    'decorators' => array(array('ViewScript', array(
    'viewScript' => '_formbuttons.tpl',
    'class'      => 'form element'
    )))));    
  }
}
?>