<?php
/**
 * SocialEngine
 *
 * @category   Application_Core
 * @package    User
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.net/license/
 * @version    $Id: Network.php 6590 2010-06-25 19:40:21Z john $
 * @author     Sami
 */

/**
 * @category   Application_Core
 * @package    User
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.net/license/
 */
class Featuredcontent_Form_Create extends Engine_Form
{
  public function init()
  {    
    $this
    ->setTitle('Select Featured Content')
    ->setDescription('Lorin Lipsum.');

    // Modules which are taking by us.
    $module_array = array('-- Select --', 'group', 'classified', 'video', 'blog', 'event', 'album', 'music', 'poll', 'forum');
    // Set of all modules which are enabled by siteadmin.
    $enabledModuleNames = Engine_Api::_()->getDbtable('modules', 'core')->getEnabledModuleNames();
    $enabledModuleNames[] = '-- Select --';
    $final_module_array = array_intersect($module_array, $enabledModuleNames);
    foreach ($final_module_array as $row_module_name)
    {
      if($row_module_name == '-- Select --')
      {
	      $levels_prepared[] = ucfirst($row_module_name);
      }
      else {
	      $levels_prepared[$row_module_name] = ucfirst($row_module_name);
      }
    }	   	   
    // category field
    $this->addElement('Select', 'create_feature', array(
      'label' => 'Select Module',
      'multiOptions' => $levels_prepared,
      'onchange' => 'javascript:fetchWidgetSettings(this.value);'
    ));
    
    $this->addElement('Text', 'title', array(
   		 'label' => 'Select Title',
   		 'required' => true
    ));
    
    $this->addElement('File', 'content_image', array(
	'label' => 'Upload Image',
	'description' => 'Upload image after uploading uploaded image will be show in slidshow.',
	'destination' => APPLICATION_PATH . '/public/temporary/',
	'validators' => array(
	  array('Size', false, 612000),
	  array('Extension', false, 'jpg,png,gif'),
	),
	'onchange'=>'javascript:uploadProfilePhoto();'
    ));

    $this->addElement('textarea', 'content_description', array(   
      'label' => 'Enter Description',
      'description' => "Set description for this 'Featured Content'.",
      'value' => ''
    ));

    // Add "Caption Title".
    $this->addElement('Text', 'caption_title', array(
      'label' => 'Enter caption title',
      'description' => 'Set the caption, after set this caption will show on slideshow bottom side.',
    ));

    // Add "Caption URL".
    $this->addElement('Text', 'caption_link', array(
      'label' => 'Enter caption link',
      'description' => 'Set the caption link, after set this caption, caption will redirect on this URL.',
    ));
    
   // DISPLAY STARTING DATE CALENDER.
    $starting_time = new Engine_Form_Element_CalendarDateTime('starting_time');
    $starting_time->setLabel("Starting Date");
    $starting_time->setValue(date('M d Y'));
    $this->addElement($starting_time);
    

   // DISPLAY ENDING DATE CALENDER.
    $ending_time = new Engine_Form_Element_CalendarDateTime('ending_time');
    $ending_date = mktime(0,0,0,date("m"),date("d")+1,date("Y"));
    $ending_time->setLabel("Ending Date");
    $ending_time->setValue(date('M d Y', $ending_date));
    $this->addElement($ending_time);
    
    
    // Set hidden field for "Content Id" which set in tpl file.
    $this->addElement('Hidden', 'content_id', array(
    'order' => 991,
    ));
    
    // Set hidden field for "Content Title" which set in tpl file.
    $this->addElement('Hidden', 'content_title', array(
    'order' => 992,
    ));
    
    
    $this->addElement('Button', 'execute', array(
      'type' => 'submit',
      'label' => 'Save Settings',
    ));    
  }
}