<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Blog
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.net/license/
 * @version    $Id: WidgetController.php
 * @author     Jung
 */

/**
 * @category   Application_Extensions
 * @package    Blog
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.net/license/
 */
class Featuredcontent_Form_Search extends Engine_Form
{
  public function init()
  {
    $this
      ->setAttribs(array(
        'id' => 'filter_form',
        'class' => 'global_form_box',
      ))
      ->setAction(Zend_Controller_Front::getInstance()->getRouter()->assemble(array()))
      ;
    
//    $this->addElement('Text', 'featured_name', array(
//      'label' => 'Search Featured',
//      'onchange' => 'this.form.submit();',
//    ));


    // Modules which are taking by us.
    $module_array = array('All', 'member', 'group', 'classified', 'video', 'blog', 'event', 'album', 'music', 'poll', 'forum');
    // Set of all modules which are enabled by siteadmin.
    $enabledModuleNames = Engine_Api::_()->getDbtable('modules', 'core')->getEnabledModuleNames();
    $enabledModuleNames[] = 'All';
    $enabledModuleNames[] = 'member';
   	$final_module_array = array_intersect($module_array, $enabledModuleNames);
   	foreach ($final_module_array as $row_module_name)
   	{
//   		if($row_module_name == '-- Select --')
//   		{
//   			$levels_prepared[] = ucfirst($row_module_name);
//   		}
//   		else {
   			$levels_prepared[$row_module_name] = ucfirst($row_module_name);
//  		}
   	}
    
    $this->addElement('Select', 'featured_type', array(
      'label' => 'Featured Type',
      'multiOptions' => $levels_prepared,
      'onchange' => 'this.form.submit();',
    ));


    $this->addElement('Hidden', 'page', array(
      'order' => 100
    ));

    $this->addElement('Hidden', 'tag', array(
      'order' => 101
    ));

    $this->addElement('Hidden', 'start_date', array(
      'order' => 102
    ));

    $this->addElement('Hidden', 'end_date', array(
      'order' => 103
    ));
  }
}