<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions 
 * @package    Peopleyoumayknow
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminGlobalController.php 2010-08-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Featuredcontent_AdminContentController extends Core_Controller_Action_Admin
{	
  protected $CONTENT_ENABLE = 1;
  protected $CONTENT_DISABLE = 0;
  protected $CONTENT_STATUS = 1;
  
  public function manageAction()
  {
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
    ->getNavigation('featuredcontent_admin_tab', array(), 'featuredcontent_content');
    // Show success message.
    $this->view->success_message = $success_message = $this->_getParam('featured_type');
    $page = $this->_getParam('page',1);
    $helloWorldTable = Engine_Api::_()->getItemTable('featured');
    $helloWorldSelect = $helloWorldTable->select()
    	->where('status =?', 1)
    	->order('featured_id DESC');
    $this->view->paginator = $paginator = Zend_Paginator::factory($helloWorldSelect);

    $this->view->paginator->setItemCountPerPage(10);
    $this->view->paginator->setCurrentPageNumber($page);
    if ($this->getRequest()->isPost())
    {
      $values = $this->getRequest()->getPost();
      foreach ($values as $key => $value) {
        if ($key == 'delete_' . $value)
        {
          $featured = Engine_Api::_()->getItem('featured', $value);
          $featured->delete();
        }
      }
    }
	}
	
  public function contentAction()
  {
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
    ->getNavigation('featuredcontent_admin_tab', array(), 'featuredcontent_content');

    $level_id = $this->_getParam('content_module');// GET MODULE ID.	 
    $this->view->content_type = $level_id;      	
    $this->view->form = $form = new Featuredcontent_Form_Admin_Content();      
    if (!empty($form->content_module)) {
      $this->view->content_type = $level_id;
      $form->content_module->setValue($level_id);  	
    }
    // Here remove the searching text box, and checkbox which geting value for that where that featured will show but if select "custom content" then enter title and no need for specify that where (which widget) featured content will show.
    if ( $level_id == 'Custom Content' ) {
      $form->removeElement('title');
      $form->removeElement('mix_slideshow');
      $form->removeElement('mix_side');
    }
    else {
      $form->removeElement('custom_title');
    }

    // AFTER SUBMIT FORM INSERT VALUE IN DATA BASE.
    if( $this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost()) )
    {   
      $user_id = Engine_Api::_()->user()->getViewer()->getIdentity();
      $value = $form->getValues();
      // In the case of "Custom Content" store value for custom content in "featuredcontent_custom" table.
      if( $value['content_module'] == 'Custom Content' ) {

	$contentTable1 = Engine_Api::_()->getItemTable('featured');
	$db1 = $contentTable1->getAdapter();
	$db1->beginTransaction();
	try
	{
	  $contentData1 = $contentTable1->createRow();
	  $contentData1->owner_id = $user_id;	
	  $contentData1->content_type = 'Custom';
	  $contentData1->individual_slideshow = $value['individual_slideshow'];
	  $contentData1->individual_side = $value['individual_side'];
	  $contentData1->starting_date = $value['starting_time'];	
	  $contentData1->ending_date = $value['ending_time'];
	  $contentData1->user_approved = $this->CONTENT_ENABLE;
	  $contentData1->status = $this->CONTENT_STATUS;
	  $contentData1->caption_text = $value['caption_title'];
	  $contentData1->caption_link = $value['caption_link'];
	  $contentData1->save();
	  $db1->commit();
	  // Now we are inserting in "engine4_featuredcontent_contentdata" table. Only if the user "upload any image" or "Write a description"	.
// 	  if ( !empty($value['content_image']) || !empty($value['content_description']) )
// 	  {
	    //If upload a 'Image'.
	    if( !empty($value['content_image']) ) {
	      $storage_photo_id = Engine_Api::_()->featuredcontent()->savePhoto($form->content_image, $contentData1->featured_id, 'customcontent');
	    }
	    else {
	      $storage_photo_id = null;
	    }
	    // If enter a 'Description'.
	    if( !empty($value['content_description']) ) {
	      $contentdata_description = $value['content_description'];
	    }
	    else {
	      $contentdata_description = null;
	    }
	    $contentdataTable1 = Engine_Api::_()->getItemTable('featuredcontent_contentdata');	  
	    $contentdataInsert1 = $contentdataTable1->createRow();
	    $contentdataInsert1->featured_id = $contentData1->featured_id;
	    $contentdataInsert1->image_id = $storage_photo_id;
	    $contentdataInsert1->description = $contentdata_description;
	    $contentdataInsert1->title = $value['custom_title'];
	    $contentdataInsert1->save();
	//  }
	}
	catch( Exception $e )
	{
	  $db1->rollBack();
	  throw $e;
	}
      }
      // If selected field is not "custom content" then value will store in "featuredcontent_contents" table.
      else {
	// Show error if title is not valid.
	if( empty($value['content_id']) )
	{
	  $error = $this->view->translate('Selected title is not valid.');
	  $this->view->status = false;
	  $error = Zend_Registry::get('Zend_Translate')->_($error);
	  $form->getDecorator('errors')->setOption('escape', false);
	  $form->addError($error);
	  return;
	}

	$contentTable = Engine_Api::_()->getItemTable('featured');
	$db = $contentTable->getAdapter();
	$db->beginTransaction();
	try
	{
	  $contentData = $contentTable->createRow();
	  $contentData->owner_id = $user_id;
	  $contentData->content_id = $value['content_id'];
	  $contentData->content_title = $value['content_title'];
	  $contentData->content_type = $value['content_module'];
	  $contentData->mix_slideshow = $value['mix_slideshow'];
	  $contentData->individual_slideshow = $value['individual_slideshow'];
	  $contentData->mix_side = $value['mix_side'];
	  $contentData->individual_side = $value['individual_side'];	    	
	  $contentData->starting_date = $value['starting_time'];	
	  $contentData->ending_date = $value['ending_time'];
	  $contentData->user_approved = $this->CONTENT_ENABLE;
	  $contentData->status = $this->CONTENT_STATUS;
	  $contentData->caption_text = $value['caption_title'];
	  $contentData->caption_link = $value['caption_link'];
	  $contentData->save(); 
	  $db->commit();

	  // Now we are inserting in "engine4_featuredcontent_contentdata" table. Only if the user "upload any image" or "Write a description"	.
	  if ( !empty($value['content_image']) || !empty($value['content_description']) )
	  {
	    // If upload a 'Image'.
	    if( !empty($value['content_image']) ) {
	      $storage_photo_id = Engine_Api::_()->featuredcontent()->savePhoto($form->content_image, $contentData->featured_id, 'featuredcontent');
	    }
	    else {
	      $storage_photo_id = null;
	    }
	    // If enter a 'Description'.
	    if( !empty($value['content_description']) ) {
	      $contentdata_description = $value['content_description'];
	    }
	    else {
	      $contentdata_description = null;
	    }
	    $contentdataTable = Engine_Api::_()->getItemTable('featuredcontent_contentdata');	  
	    $contentdataInsert = $contentdataTable->createRow();
	    $contentdataInsert->featured_id = $contentData->featured_id;
	    $contentdataInsert->image_id = $storage_photo_id;
	    $contentdataInsert->description = $contentdata_description;
	    $contentdataInsert->save();
	  }
	}
	catch( Exception $e )
	{
	  $db->rollBack();
	  throw $e;
	}
      }
      $this->_helper->redirector->gotoRoute(array('featured_type' => $value['content_module']), 'admin_create_featured', true);
    }
  }
}
