<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions 
 * @package    Peopleyoumayknow
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminGlobalController.php 2010-08-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Featuredcontent_AdminRequestController extends Core_Controller_Action_Admin
{
 	public function indexAction()
  {
  	$this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
    	->getNavigation('featuredcontent_admin_tab', array(), 'featuredcontent_request');
  
    $page = $this->_getParam('page',1);
    $helloWorldTable = Engine_Api::_()->getItemTable('featured');
    $helloWorldSelect = $helloWorldTable->select()
    	->where('status =?', 2)
    	->order('featured_id DESC');
    $this->view->paginator = $paginator = Zend_Paginator::factory($helloWorldSelect);
    
    $this->view->paginator->setItemCountPerPage(10);
    $this->view->paginator->setCurrentPageNumber($page);
    if ($this->getRequest()->isPost())
    {
      $values = $this->getRequest()->getPost();
      foreach ($values as $key=>$value) {
        if ($key == 'delete_' . $value)
        {        	
          //$featured = Engine_Api::_()->getItem('featured', $value);
          //$featured->delete();
          
          $owner_id = Engine_Api::_()->getItem('featured', $value)->owner_id;
				  // EMAIL WORK START FROM HERE.					  
				  $owner_email = Engine_Api::_()->getItem('user', $owner_id)->email;					 
			  	$email = Engine_Api::_()->getApi('settings', 'core')->core_mail_from;				  	
		     	Engine_Api::_()->getApi('mail', 'core')->sendSystem($owner_email, 'notify_featured_create', array(
		     			'featured_status' => 'Delete',
		     			'email' => $email,
		     			'queue' => false
		     			));
        }
      }
    }
  }
  
  public function approvedAction()
  { 
  	$this->_helper->layout->setLayout('admin-simple');	
    $featured_id = $this->_getParam('featured_id');
    $owner_id = $this->_getParam('owner_id');
    // AFTER SUBMIT FORM INSERT VALUE IN DATA BASE.
    if( $this->getRequest()->isPost() && $this->getRequest()->getPost())
    {
    	$value = $this->getRequest()->getPost();
    	$content_table = Engine_Api::_()->getDbtable('Featureds', 'featuredcontent');
			$content_table->update(
			array(
				"mix_slideshow" => $value['mix_slideshow'],
				"individual_slideshow" => $value['individual_slideshow'],
				"mix_side" => $value['mix_side'],
				"individual_side" => $value['individual_side'],
				"status" => 1
				),
				array(
      			'featured_id =?' => $featured_id,
    		)
    	);   
    	
		  // EMAIL WORK START FROM HERE.					  
		  $owner_email = Engine_Api::_()->getItem('user', $owner_id)->email;					 
	  	$email = Engine_Api::_()->getApi('settings', 'core')->core_mail_from;				  	
     	Engine_Api::_()->getApi('mail', 'core')->sendSystem($owner_email, 'notify_featured_create', array(
     			'featured_status' => 'Approved',
     			'email' => $email,
     			'queue' => false
     			));
    	 	
    	// Close the smoothbox.
      $this->_forward('success', 'utility', 'core', array(
          'smoothboxClose' => 10,
          'parentRefresh'=> 10,
          'messages' => array('')
      ));
    }
  }
  
  public function disapprovedAction()
  {  	
  	$this->_helper->layout->setLayout('admin-simple');	
    $this->view->featured_id = $featured_id = $this->_getParam('featured_id');
    $owner_id = $this->_getParam('owner_id');
    // AFTER SUBMIT FORM INSERT VALUE IN DATA BASE.
    if( $this->getRequest()->isPost() && $this->getRequest()->getPost())
    {
    	$value = $this->getRequest()->getPost();
    	$content_table = Engine_Api::_()->getDbtable('Featureds', 'featuredcontent');
			$content_table->update(
			array(
				"content_show" => $value['featured_approved'],
				"status" => 0
				),
				array(
      			'featured_id =?' => $featured_id,
    		)
    	); 
    	
		  // EMAIL WORK START FROM HERE.					  
		  $owner_email = Engine_Api::_()->getItem('user', $owner_id)->email;					 
	  	$email = Engine_Api::_()->getApi('settings', 'core')->core_mail_from;				  	
     	Engine_Api::_()->getApi('mail', 'core')->sendSystem($owner_email, 'notify_featured_create', array(
     			'featured_status' => 'Dis-Approved',
     			'email' => $email,
     			'queue' => false
     			));
    	   	
    	// Close the smoothbox.
      $this->_forward('success', 'utility', 'core', array(
          'smoothboxClose' => 10,
          'parentRefresh'=> 10,
          'messages' => array('')
      ));
    }
  }
  
  public function deleteAction()
  {
    // In smoothbox
    $this->_helper->layout->setLayout('admin-simple');
    $id = $this->_getParam('featured_id');
    $owner_id = $this->_getParam('owner_id');
    $this->view->featured_id=$id;
    // Check post
    if( $this->getRequest()->isPost())
    {
      $db = Engine_Db_Table::getDefaultAdapter();
      $db->beginTransaction();

      try
      {
        $featured = Engine_Api::_()->getItem('featured', $id);
        $featured->delete();
        $db->commit();
      }

      catch( Exception $e )
      {
        $db->rollBack();
        throw $e;
      }
      
		  // EMAIL WORK START FROM HERE.					  
		  $owner_email = Engine_Api::_()->getItem('user', $owner_id)->email;					 
	  	$email = Engine_Api::_()->getApi('settings', 'core')->core_mail_from;				  	
     	Engine_Api::_()->getApi('mail', 'core')->sendSystem($owner_email, 'notify_featured_create', array(
     			'featured_status' => 'delete',
     			'email' => $email,
     			'queue' => false
     			));
     			      
      $this->_forward('success', 'utility', 'core', array(
          'smoothboxClose' => 10,
          'parentRefresh'=> 10,
          'messages' => array('')
      ));
    }
    // Output
    $this->renderScript('admin-request/delete.tpl');
  }
}