<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Featuredcontent
 * @copyright  Copyright 2009-2010 Big Step Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminSettingsController.php 6590 2010-16-11 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Featuredcontent_AdminSlideshowsController extends Core_Controller_Action_Admin
{
  public function indexAction()
  { 
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
      	 ->getNavigation('featuredcontent_admin_tab', array(), 'featuredcontent_admin_main_slideshows');

		//GET SLIDESHOW TYPE
		$type = $this->_getParam('type');
		if(!empty($type)) {
      $slide_type = $type;
    } 
		else {
      $slide_type = Engine_Api::_()->getApi('settings', 'core')->getSetting('featuredcontent.type');
    }
 	 
		//GET BASE URL
		$base = Zend_Controller_Front::getInstance()->getBaseUrl();
		$this->view->preview_base_url = "http://".$_SERVER['HTTP_HOST'].  $base."/";

		//FORM GENERATION
    $this->view->form = $form = new Featuredcontent_Form_Admin_Slideshow();


		//IF FOR IS SUBMITTED SUCCESSFULLY
		if( $this->getRequest()->isPost()&& $form->isValid($this->getRequest()->getPost())) {
	    	
					//IF ADMIN CLICK ON SET DEFAUTL BUTTON THAN SET DEFATULT VALUES
					if(isset($_POST['default']) == 1) {
						
						$values['featuredcontent_visibility'] = 2;
						$values['featuredcontent_transition1'] = 'Linear';
						$values['featuredcontent_transition2'] = 'easeln';
						$values['featuredcontent_height'] = 240;
						$values['featuredcontent_width'] = 180;
						$values['featuredcontent_duration'] = 500;
						$values['featuredcontent_size'] = 240;
						$values['featuredcontent_interval'] = 5000;
						$values['featuredcontent_autoplay'] = 1;
						$values['featuredcontent_show_link'] = 1;
						$values['featuredcontent_image_link'] = 1;
						$values['featuredcontent_title'] = 1;
						$values['featuredcontent_author'] = 1;
						$values['featuredcontent_date'] = 1;
						$values['featuredcontent_mode'] = 1;
						$values['featuredcontent_pagination'] = 1;
						$values['featuredcontent_previous'] = 1;
						$values['featuredcontent_play'] = 1;
						$values['featuredcontent_next'] = 1;
						$values['featuredcontent_stop'] = 1;
						$values['featuredcontent_playback'] = 0;
					}
					else { //ELSE GET SELECTED VALUES
						$values = $this->getRequest()->getPost();
					}

					//POPULATE FORM
					$form->populate($values);

					//SAVE VALUES IN DATABASE
					foreach ($values as $key => $value) {
						Engine_Api::_()->getApi('settings', 'core')->setSetting($key, $value);  
					}

  	}
		
  }
  
	//ACTION FOR PREVIEW OF SLIDESHOW ON CURRENTLY SELECTED FIELDS
  public function previewAction()
  { 
  	$this->_helper->layout->setLayout('admin-simple');
  	$table   = Engine_Api::_()->getDbTable('images', 'featuredcontent');
    $select  = $table->select()
                    	 	 ->setIntegrityCheck(false)
                         ->from($table->info('name'))
												 ->order('order ASC')
												 ->order('image_id DESC');
    
    $this->view->paginator = $paginator = Zend_Paginator::factory($select);
    $this->view->total_images = $paginator->getTotalItemCount();

		if( $this->view->total_images == 0) {
			$this->view->error = 2;
			return;
		}

    if( $this->view->total_images <= 0 ) {
      return $this->setNoRender();
    }
    
    //GET 
    $this->view->duration = $_GET['duration'];

		//GET 
    $this->view->size = $_GET['size'];

		//GET 
    $this->view->interval = $_GET['interval'];

		//GET 
    $this->view->type = $_GET['type'];

		//GET 
    $this->view->transition = $_GET['transition'];

    //GET
		$autoplay = $_GET['autoplay'];
		if($autoplay) {
  		$this->view->autoplay = 'true';
		}
		else {
			$this->view->autoplay = 'false';
		}

		 //GET
		$show_link = $_GET['show_link'];
		if($show_link) {
  		$this->view->show_link = 'true';
		}
		else {
			$this->view->show_link = 'false';
		}

		 //GET
		$image_link = $_GET['image_link'];
		if($image_link) {
  		$this->view->image_link = 'true';
		}
		else {
			$this->view->image_link = 'false';
		}

		 //GET
		$title = $_GET['title'];
		if($title) {
  		$this->view->title = 'true';
		}
		else {
			$this->view->title = 'false';
		}

		 //GET
		$author = $_GET['author'];
		if($author) {
  		$this->view->author = 'true';
		}
		else {
			$this->view->author = 'false';
		}

	 //GET
		$date = $_GET['date'];
		if($date) {
  		$this->view->date = 'true';
		}
		else {
			$this->view->date = 'false';
		}

		 //GET
		$mode = $_GET['mode'];
		if($mode) {
  		$this->view->mode = 'horizontal';
		}
		else {
			$this->view->mode = 'vertical';
		}

		 //GET
		$pagination = $_GET['pagination'];
		if($pagination) {
  		$this->view->pagination = 'true';
		}
		else {
			$this->view->pagination = 'false';
		}

		 //GET
		$this->view->previous = $_GET['previous'];

		 //GET
		$this->view->play = $_GET['play'];

		 //GET
		$this->view->next = $_GET['next'];

		 //GET
		$this->view->stop = $_GET['stop'];
	
		 //GET
		$this->view->playback = $_GET['playback'];

		if($this->view->type == 'im_based') {
			
			//GET
			$thumbnail = $_GET['thumbnail'];
			if($thumbnail) {
				$this->view->thumbnail = 'true';
			}
			else {
				$this->view->thumbnail = 'false';
			}

			//GET
			$this->view->thumb_position = $_GET['thumb_position'];

		}
		else {
		 //GET
			$index_next = $_GET['index_next'];
			if($index_next) {
				$this->view->index_next = 'true';
			}
			else {
				$this->view->index_next = 'false';
			}

			$text_image = $_GET['text_image'];
			if($text_image) {
				$this->view->text_image = 'true';
			}
			else {
				$this->view->text_image = 'false';
			}

		}
  }
  
	//ACTION FOR DEMO OF SLIDESHOW
  public function demoAction()
  {
  	$this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
      	 ->getNavigation('featuredcontent_admin_tab', array(), 'featuredcontent_admin_main_demo');
    
		//GENERATE FORM
    $this->view->form = $form = new Featuredcontent_Form_Admin_Demo();
		
    $this->view->duration = 400;
    $this->view->size = 400;
    $this->view->interval = 400;
    $this->view->transition =  'Fx.Transitions.Liner.easeIn';
  	$this->view->autoplay = 'true';
		$this->view->image_link = 'true';
		$this->view->mode = 'horizontal';

		$title =   $this->_getParam('title');
		if($title) {
			$this->view->title = 'true';
		}
		else {
			$this->view->title = 'false';
		}

		$author = $this->_getParam('author');
		if($author) {
			$this->view->author = 'true';
		}
		else {
			$this->view->author = 'false';
		}
		$date = $this->_getParam('date');
		if($date) {
			$this->view->date = 'true';
		}
		else {
			$this->view->date = 'false';
		}
		$show_link = $this->_getParam('show_link');
		if($show_link) {
			$this->view->show_link = 'true';
		}
		else {
			$this->view->show_link = 'false';
		}
		$pagination = $this->_getParam('pagination');
		if($pagination) {
			$this->view->pagination = 'true';
		}
		else {
			$this->view->pagination = 'false';
		}
		$buttons = $this->_getParam('buttons');
		if($buttons) {
			$this->view->previous = 1;
			$this->view->play = 1;
			$this->view->next = 1;
			$this->view->stop = 1;
			$this->view->playback = 1;
		}
		else {
			$this->view->previous = 1;
			$this->view->play = 1;
			$this->view->next = 1;
			$this->view->stop = 1;
			$this->view->playback = 1;
		}
	

		 //GET
			$index_next = $this->_getParam('index_next');
			if($index_next) {
				$this->view->index_next = 'true';
			}
			else {
				$this->view->index_next = 'false';
			}
		
		//ADD THIS TWO VALUES IN $values ARRAY TO SHOW PREFIELD
		$values['featuredcontent_index_next'] = $this->_getParam('index_next');
		$values['featuredcontent_title'] = $title;
		$values['featuredcontent_author'] = $author;
		$values['featuredcontent_date'] = $date;
		$values['featuredcontent_show_link'] = $show_link;
		$values['featuredcontent_pagination'] = $pagination;
		$values['featuredcontent_buttons'] = $buttons;

		//POPULATE FORM
		$form->populate($values);
			
    if( $this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost()) ) {
    	$values = $form->getValues();

			//CHECK THAT WHICH TYPE OF SLIDESHOW WE HAVE TO SHOW AND THUMBNAIL IS VISIBLE OR NOT
			$type = $values['featuredcontent_type'];
			$title = $values['featuredcontent_title'];
			$author = $values['featuredcontent_author'];
			$date = $values['featuredcontent_date'];
			$show_link = $values['featuredcontent_show_link'];
			$pagination = $values['featuredcontent_pagination'];
			$buttons = $values['featuredcontent_buttons'];
			$index_next = $values['featuredcontent_index_next'];
 
			$this->_redirect('admin/featuredcontent/slideshows/demo/type/'.$type.'/title/'.$title.'/author/'.$author.'/date/'.$date.'/show_link/'.$show_link.'/pagination/'.$pagination.'/buttons/'.$buttons.'/index_next/'.$index_next);
		}
  }
}
?>