<?php

class Featuredcontent_IndexController extends Core_Controller_Action_Standard
{
	protected $_navigation;
	protected $REQUEST_PENDING = 2;
  protected $CONTENT_ENABLE = 1;
  protected $CONTENT_DISABLE = 0;
  
  public function browseAction()
  {
//  	$browse_permition = $this->_helper->requireAuth()->setAuthParams('featuredcontent', null, 'featured_view')->checkRequire();
//  	if(empty($browse_permition))
//  	{
//  		return $this->_forward('requireauth', 'error', 'core');
//  	}
		$this->_helper->content->render();
  }
  
  // This call by user manage page.
  public function manageAction()
  {
    $browse_permition = 1;//$this->_helper->requireAuth()->setAuthParams('featuredcontent', null, 'featured_view')->checkRequire();
    if(empty($browse_permition))
    {
      return $this->_forward('requireauth', 'error', 'core');
    }
    $this->view->success_message = $success_message = $this->_getParam('featured_type');
    // Set the navigation bar.
    $this->view->navigation = $this->getNavigation();
    
    $user_id = Engine_Api::_()->user()->getViewer()->getIdentity();
    $page = $this->_getParam('page',1);
    $helloWorldTable = Engine_Api::_()->getItemTable('featured');
    $helloWorldSelect = $helloWorldTable->select()
    	->where('owner_id =?', $user_id)
    	->order('featured_id DESC');
    $this->view->paginator = $paginator = Zend_Paginator::factory($helloWorldSelect);
    
    $this->view->paginator->setItemCountPerPage(10);
    $this->view->paginator->setCurrentPageNumber($page);
    if ($this->getRequest()->isPost())
    {
      $values = $this->getRequest()->getPost();
      foreach ($values as $key => $value) {
        if ($key == 'delete_' . $value)
        {
          $featured = Engine_Api::_()->getItem('featured', $value);
          $featured->delete();
        }
      }
    }
  }
  
  // This action call when user create featured content.
  public function createAction()
  {
    $create_permition = 1;//$this->_helper->requireAuth()->setAuthParams('featuredcontent', null, 'featured_create')->checkRequire();
    if(empty($create_permition))
    {
      return $this->_forward('requireauth', 'error', 'core');
    }
    // Set the navigation bar.
    $this->view->navigation = $this->getNavigation();  	
    $level_id = $this->_getParam('create_feature');// GET MODULE ID.	 
    $this->view->content_type = $level_id;      	
    $this->view->form = $form = new Featuredcontent_Form_Create();
    if (!empty($form->create_feature)) {
      $this->view->content_type = $level_id;
      $form->create_feature->setValue($level_id);  	
    }
    
    // AFTER SUBMIT FORM INSERT VALUE IN DATA BASE.
    if( $this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost()) )
    {   
      $user_id = Engine_Api::_()->user()->getViewer()->getIdentity();
      $value = $form->getValues();
      // Show error if title is not valid.
      if(empty($value['content_id']))
      {
	$error = $this->view->translate('Selected title is not valid.');
	$this->view->status = false;
	$error = Zend_Registry::get('Zend_Translate')->_($error);
	$form->getDecorator('errors')->setOption('escape', false);
	$form->addError($error);
	return;
      }
      
      $contentTable = Engine_Api::_()->getItemTable('featured');
      $db = $contentTable->getAdapter();
      $db->beginTransaction();
      try
      {
	// First we are inserting in "engine4_featuredcontent_contents" table.
	$contentData = $contentTable->createRow();
	$contentData->owner_id = $user_id;
	$contentData->content_id = $value['content_id'];
	$contentData->content_title = $value['content_title'];
	$contentData->content_type = $value['create_feature'];
	$contentData->starting_date = $value['starting_time'];	
	$contentData->ending_date = $value['ending_time'];
	$contentData->user_approved = $this->CONTENT_ENABLE;
	$contentData->status = $this->REQUEST_PENDING;
	$contentData->caption_text = $value['caption_title'];
	$contentData->cation_link = $value['caption_link'];
	$contentData->save(); 
	  
	// Now we are inserting in "engine4_featuredcontent_contentdata" table. Only if the user "upload any image" or "Write a description"	.
	if ( !empty($value['content_image']) || !empty($value['content_description']) )
	{
	  // If upload a 'Image'.
	  if( !empty($value['content_image']) ) {
	    $storage_photo_id = Engine_Api::_()->featuredcontent()->savePhoto($form->content_image, $contentData->featured_id);
	  }
	  else {
	    $storage_photo_id = null;
          }
	  // If enter a 'Description'.
	  if( !empty($value['content_description']) ) {
	    $contentdata_description = $value['content_description'];
	  }
	  else {
	    $contentdata_description = null;
          }
	  $contentdataTable = Engine_Api::_()->getItemTable('featuredcontent_contentdata');	  
	  $contentdataInsert = $contentdataTable->createRow();
	  $contentdataInsert->featured_id = $contentData->featured_id;
	  $contentdataInsert->image_id = $storage_photo_id;
	  $contentdataInsert->description = $contentdata_description;
	  $contentdataInsert->save();
	}
	
	$db->commit();	
      }
      catch( Exception $e )
      {
        $db->rollBack();
        throw $e;
      }
      $this->_helper->redirector->gotoRoute(array('featured_type' => $value['create_feature']), 'user_create_featured', true);
    }
  }
  
  // This is navigation which used by "manageAction" & "createAction" in this page.
  public function getNavigation($active = false)
  {
    if( is_null($this->_navigation) )
    {
      $navigation = $this->_navigation = new Zend_Navigation();

      if( $this->_helper->api()->user()->getViewer()->getIdentity() )
      {      	
      	if(1)//$this->_helper->requireAuth()->setAuthParams('featuredcontent', null, 'featured_view')->checkRequire())
      	{
	        $navigation->addPage(array(
	          'label' => Zend_Registry::get('Zend_Translate')->_('Browse Featured'),
	          'route' => 'default',
	          'module' => 'featuredcontent',
	          'controller' => 'index',
	          'action' => 'browse'
	        ));
      	}
      	
        $navigation->addPage(array(
          'label' => Zend_Registry::get('Zend_Translate')->_('Manage Form'),
          'route' => 'default',
          'module' => 'featuredcontent',
          'controller' => 'index',
          'action' => 'manage'
        ));
        
        if (1)//$this->_helper->requireAuth()->setAuthParams('featuredcontent', null, 'featured_create')->checkRequire())
        {
	        $navigation->addPage(array(
	          'label' => Zend_Registry::get('Zend_Translate')->_('Create Featured'),
	          'route' => 'default',
	          'module' => 'featuredcontent',
	          'controller' => 'index',
	          'action' => 'create'
	        ));
        }
      }
    }
    return $this->_navigation;
  }
  
  // This call when User/Admin click on "Approved/Dis-Approved" in manage page.
  public function approvedAction()
  {
  	$approved_permition = 1;//$this->_helper->requireAuth()->setAuthParams('featuredcontent', null, 'featured_status')->checkRequire();
  	if(empty($approved_permition))
  	{
  		return $this->_forward('requireauth', 'error', 'core');
  	}
    // In smoothbox
    $this->_helper->layout->setLayout('admin-simple');
    $approve_id = $this->_getParam('approve');
    $id = $this->_getParam('id');    
    $this->view->featured_id = $id;   
    if(!empty($approve_id))
    {
    	$this->view->title = $this->view->translate("Disabled Featured Content?");
    	$this->view->discription = $this->view->translate("Are you sure that you want to Disabled this featured content? After disabled this will not show in 'Slide Show'.");
    	$this->view->link = $this->view->translate("Disabled");
    	$this->view->status = $this->CONTENT_DISABLE;
    }
    else {
    	$this->view->title = $this->view->translate("Enabled Featured Content?");
    	$this->view->discription = $this->view->translate("Are you sure that you want to Enabled this featured content? After enabled this will show in 'Slide Show'.");
    	$this->view->link = $this->view->translate("Enabled");
    	$this->view->status = $this->CONTENT_ENABLE;
    }
    // Check post
    if( $this->getRequest()->isPost())
    {
    	$value = $this->getRequest()->getPost();
    	$content_table = Engine_Api::_()->getDbtable('Featureds', 'featuredcontent');
    	if(!empty($value['approve']))
    	{
				$content_table->update(
				array("user_approved" => 1),
					array(
	      			'featured_id =?' => $id,
	    		)
	    	);
    	}
    	else {
				$content_table->update(
				array("user_approved" => 0),
					array(
	      			'featured_id =?' => $id,
	    		)
	    	);
    	}
    	
      $this->_forward('success', 'utility', 'core', array(
	  			'smoothboxClose' => 10,
	  			'parentRefresh' => 10,
          'messages' => array('')
      ));
    }
    // Output
    $this->renderScript('index/approved.tpl');
  }
  
  // This call when User/Admin click on "Delete" in manage page.
  public function deleteAction()
  {
  	$delete_permition = 1;//$this->_helper->requireAuth()->setAuthParams('featuredcontent', null, 'featured_delete')->checkRequire();
  	if(empty($delete_permition))
  	{
  		return $this->_forward('requireauth', 'error', 'core');
  	}
    // In smoothbox
    $this->_helper->layout->setLayout('admin-simple');
    $id = $this->_getParam('featured_id');
    $owner_id = $this->_getParam('owner_id');
    $this->view->featured_id=$id;
    // Check post
    if( $this->getRequest()->getPost())
    {
      $db = Engine_Db_Table::getDefaultAdapter();
      $db->beginTransaction();

      try
      {
        $featured = Engine_Api::_()->getItem('featured', $id);        
        $featured->delete();
        $db->commit();
      }

      catch( Exception $e )
      {
        $db->rollBack();
        throw $e;
      }
      $this->_forward('success', 'utility', 'core', array(
	  			'smoothboxClose' => true,
	  			'parentRefresh' => true,
          'messages' => array('Featured content has been deleted')
      ));      
    }
  }
  
  // This function call by admin and return the content which called in AdminContent.php form.
  public function contentAction()
  {
    $user_id = Engine_Api::_()->user()->getViewer()->getIdentity();
    // This variable contain the info that from where this function is calling.
    $calling_for = $this->_getParam('calling_for');
    //$calling_for = 'user';
    // WHICH TYPE "CONTENT TYPE" SELECTED.
    $content_type = $this->_getParam('content_type');
    //$content_type = 'classified';
    // Here we are set the name of tables.
    if($content_type == 'music')
    {
	    $content_table = 'music_playlist';
    }
    else if($content_type == 'forum')
    {
	    $content_table = 'forum_topic';
    }
//     else if ($content_type == 'member')
//     {
// 	    $content_table = 'user';
//     }
    else {
	    $content_table = $content_type;
    }
    if( $this->_helper->requireUser()->checkRequire())
    {
      $viewer = Engine_Api::_()->user()->getViewer();

      // Access "forum table" becouse forum table does not contain the search field.
      if($content_type == 'forum')
      {
      	$table = Engine_Api::_()->getItemTable($content_table);
	      $select = $table->select();
      }
      else {
	      $table = Engine_Api::_()->getItemTable($content_table);
	      $select = $table->select()
	        ->where('search = ?', 1);
      }
      // In the $text which are typing by user/admin for searching.
      $text = $this->_getParam('text', $this->_getParam('text'));
 
      // If this function call by admin then he can access all record, there are no boundation for admin but if access by user then he can access which created by himself.
      if($calling_for == 'admin')
      {
	// IF "CONTENT TYPE" IS NOT "MEMBER".
	if( null !== $text && $content_type != 'member')
	{
	  $select
		  ->where('`'.$table->info('name').'`.`title` LIKE ?', '%'. $text .'%');
	  
	}
	else {
	  $select
		  ->where('`'.$table->info('name').'`.`displayname` LIKE ?', '%'. $text .'%');
	}
      }
      else {
	// IF "CONTENT TYPE" IS NOT "MEMBER".
	if( null !== $text && $content_type != 'member')
	{
	  if($content_type == 'group' || $content_type == 'event' || $content_type == 'poll' || $content_type == 'forum')
	  {
		  $select
			  //->where('user_id =?', $user_id)
			  ->where('`'.$table->info('name').'`.`title` LIKE ?', '%'. $text .'%');
	  }
	  else {
		  $select
			 // ->where('owner_id =?', $user_id)
			  ->where('`'.$table->info('name').'`.`title` LIKE ?', '%'. $text .'%');
	  }
	  
	}
	else {
	  //$select->where('`'.$table->info('name').'`.`displayname` LIKE ?', '%'. $text .'%');
	}
      }
      $data = array();      
      foreach( $table->fetchAll($select) as $content_data )
      {
      	// Show images acordin to the "Module".
      	if($content_type == 'poll' || $content_type == 'blog')
      	{
      		$content_photo = $this->view->itemPhoto($content_data->getOwner(), 'thumb.icon');
      	}
      	elseif ($content_type == 'forum')
      	{
      		$photo_obj = Engine_Api::_()->getItem('user', $content_data->user_id);
      		$content_photo = $this->view->itemPhoto($photo_obj, 'thumb.icon');
      	}
      	else if ($content_type == 'classified')
      	{
      		$content_photo = $this->view->itemPhoto($content_data, 'thumb.normal');
      	}
      	else {
      		$content_photo = $this->view->itemPhoto($content_data, 'thumb.icon');
      	}

        $data[] = array(
          'id' => $content_data->getIdentity(),
          'photo' => $content_photo,
          'label' => $content_data->getTitle(),
          'type' => $content_type,
	  'description' => $content_data->getDescription(),
        );
      }
    }
    
    if( $this->_getParam('sendNow', true) )
    {    	
      return $this->_helper->json($data);
    }
    else
    {
      $this->_helper->viewRenderer->setNoRender(true);
      $data = Zend_Json::encode($data);
      $this->getResponse()->setBody($data);
    }
  }
}
