<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Feedback
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Upload.php 2010-07-08 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Feedback_Form_Image_Upload extends Engine_Form
{
  public function init()
  {	
    $this
      ->setTitle('Add pictures to your Feedback')
      ->setDescription('Choose pictures from your computer to add to this feedback. (2MB maximum)')
      ->setAttrib('id', 'form-upload')
      ->setAttrib('class', 'global_form feedback_form_upload')
      ->setAttrib('name', 'albums_create')
      ->setAttrib('enctype','multipart/form-data')
      ->setAction(Zend_Controller_Front::getInstance()->getRouter()->assemble(array()))
      ;

    $uploadUrl = Zend_Controller_Front::getInstance()->getRouter()->assemble(array()) . '?ul=1';
    $deleteUrl = $this->getView()->url(array('module'=>'feedback', 'controller' => 'image', 'action'=>'remove'), 'default');
    $feedback_id = Engine_Api::_()->core()->hasSubject('feedback') ? Engine_Api::_()->core()->getSubject()->getIdentity() : 0;
    $this->addElement('SeaoFancyUpload', 'file', array(
      'url' =>  $uploadUrl,
      'deleteUrl' =>  $deleteUrl,
      'accept' => 'image/*',
      'data' => array(
        'responseParamId' => 'image_id',
        'vars' => array('feedback_id' => $feedback_id),
      ),
    ));

    $this->addElement('Button', 'submit', array(
      'label' => 'Save pictures',
      'type' => 'submit',
    ));
  }
}