<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Groupdocument
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 6590 2010-10-19 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Groupdocument_Plugin_Core {

  public function onItemDeleteBefore($event) {

    $payload = $event->getPayload();

    if ($payload instanceof Group_Model_Group) {

			//GET GROUP ID
      $group_id = $payload->getIdentity();

      if (!empty($group_id)) {

        //FETCH DOCUMENTS CORROSPONDING TO THAT GROUP ID
				$owner_id = 0;
        $documents = Engine_Api::_()->getItemTable('groupdocument_document')->getGroupDocuments($group_id, $owner_id);

				foreach ($documents as $document) {

					//DELETE DOCUMENT BELONGINGS
					Engine_Api::_()->groupdocument()->deleteContent($document->document_id);
				}  
      }
    }
  }

  //DELETE USERS BELONGINGS BEFORE THAT USER DELETION
  public function onUserDeleteBefore($event) {

    $payload = $event->getPayload();

    if ($payload instanceof User_Model_User) {

			//FETCH DOCUMENTS CORROSPONDING TO THAT OWNER ID
			$owner_id = $payload->getIdentity();
			$group_id = 0;
			$documents = Engine_Api::_()->getItemTable('groupdocument_document')->getGroupDocuments($group_id, $owner_id);

      foreach ($documents as $groupdocument) {

        //DELETE DOCUMENT BELONGINGS
        Engine_Api::_()->groupdocument()->deleteContent($groupdocument->document_id);
      }
    }
  }

  public function addActivity($event) {
    global $groupdocument_createactivity;
    $front = Zend_Controller_Front::getInstance();
    $module = $front->getRequest()->getModuleName();
    $controller = $front->getRequest()->getControllerName();
    $action = $front->getRequest()->getActionName();

		//DON'T SHOW THE PRIVACY OPTIONS IF NOT ACTIVATED
		$groupdocument_isActivate = Engine_Api::_()->getApi('settings', 'core')->getSetting('groupdocument.isActivate', 0);
		if(empty($groupdocument_isActivate))
			return;

    if (!empty($groupdocument_createactivity) && ($module == 'group' || $module == 'advgroup') && ($action == 'create' || $action == 'edit') && ($controller == 'index' || $controller == 'group')) {

			//GET GROUP ID
      $payload = $event->getPayload();
      $group_id = $payload['object']->group_id;

			//GET GROUP OBJECT
      $group = Engine_Api::_()->getItem('group', $group_id);

      //PROCESS PRIVACY WORK
      $auth = Engine_Api::_()->authorization()->context;

      $roles = array('officer', 'member', 'registered', 'everyone');

      $gdcreate = array_search($_POST['gdcreate'], $roles);

      $officerList = $group->getOfficerList();

      foreach ($roles as $i => $role) {
        if ($role === 'officer') {
          $role = $officerList;
        }
        $auth->setAllowed($group, $role, 'gdcreate', ($i <= $gdcreate));
      }
    }
  }
}