<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Groupdocument
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 6590 2010-10-19 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => $view->translate('Group Profile Documents'),
        'description' => $view->translate('Displays a group’s documents on its profile.'),
        'category' => $view->translate('Groups'),
        'type' => 'widget',
        'name' => 'groupdocument.profile-groupdocuments',
        'defaultParams' => array(
            'title' => $view->translate('Documents'),
        ),
    ),
    array(
        'title' => $view->translate('Group Profile Recent Documents'),
        'description' => $view->translate('Displays list of group’s recent documents. Setting for this widget available in widget settings tab of Group - Documents admin.'),
        'category' => $view->translate('Groups'),
        'type' => 'widget',
        'name' => 'groupdocument.recent-groupdocuments',
        'defaultParams' => array(
            'title' => $view->translate('Recent Group Documents'),
        ),
    ),
    array(
        'title' => $view->translate('Group Profile Popular Documents'),
        'description' => $view->translate('Displays list of group’s popular documents. Setting for this widget available in widget settings tab of Group - Documents admin.'),
        'category' => $view->translate('Groups'),
        'type' => 'widget',
        'name' => 'groupdocument.popular-groupdocuments',
        'defaultParams' => array(
            'title' => $view->translate('Popular Group Documents'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Group Profile Most Commented Documents'),
        'description' => $view->translate('Displays list of group’s most commented documents. Setting for this widget available in widget settings tab of Group - Documents admin.'),
        'category' => $view->translate('Groups'),
        'type' => 'widget',
        'name' => 'groupdocument.comment-groupdocuments',
        'defaultParams' => array(
            'title' => $view->translate('Most Commented Group Documents'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Group Profile Most Liked Documents'),
        'description' => $view->translate('Displays list of group’s most liked documents. Setting for this widget available in widget settings tab of Group - Documents admin.'),
        'category' => $view->translate('Groups'),
        'type' => 'widget',
        'name' => 'groupdocument.like-groupdocuments',
        'defaultParams' => array(
            'title' => $view->translate('Most Liked Group Documents'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Group Profile Top Rated Documents'),
        'description' => $view->translate('Displays list of group’s top rated documents. Setting for this widget available in widget settings tab of Group - Documents admin.'),
        'category' => $view->translate('Groups'),
        'type' => 'widget',
        'name' => 'groupdocument.rate-groupdocuments',
        'defaultParams' => array(
            'title' => $view->translate('Top Rated Group Documents'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Group Profile Featured Documents'),
        'description' => $view->translate('Displays list of group’s featured documents. Setting for this widget available in widget settings tab of Group - Documents admin.'),
        'category' => $view->translate('Groups'),
        'type' => 'widget',
        'name' => 'groupdocument.featurelist-groupdocuments',
        'defaultParams' => array(
            'title' => $view->translate('Featured Group Documents'),
            'titleCount' => true,
        ),
    ),
);