<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Groupdocument
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 6590 2010-10-19 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Groupdocument_Installer extends Engine_Package_Installer_Module {

  function onPreInstall() {
    $PRODUCT_TYPE = 'groupdocument';
    $PLUGIN_TITLE = 'Groupdocument';
    $PLUGIN_VERSION = '5.4.1';
    $PLUGIN_CATEGORY = 'plugin';
    $PRODUCT_DESCRIPTION = 'Groupdocument';
    $_PRODUCT_FINAL_FILE = 'license3.php';
    $_BASE_FILE_NAME = 'groupdocumentnew';
    $PRODUCT_TITLE = 'Groups Documents Extension Plugin';
    $SocialEngineAddOns_version = '4.8.5';
    $file_path = APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/ilicense.php";
    $is_file = file_exists($file_path);
    if (empty($is_file)) {
      include_once APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/license4.php";
    } else {
      if (!empty($_PRODUCT_FINAL_FILE)) {
        include_once APPLICATION_PATH . '/application/modules/' . $PLUGIN_TITLE . '/controllers/license/' . $_PRODUCT_FINAL_FILE;
      }
      $db = $this->getDb();
      $select = new Zend_Db_Select($db);
      $select->from('engine4_core_modules')->where('name = ?', $PRODUCT_TYPE);
      $is_Mod = $select->query()->fetchObject();
      if( empty($is_Mod) ) {
				include_once $file_path;
      }
    }

		$select = new Zend_Db_Select($db);
		$select
			->from('engine4_core_settings')
			->where('name = ?', 'groupdocument.code.share');
		$groupdocument_code_share = $select->query()->fetchObject();
		if(empty($groupdocument_code_share))
		{
			$social_share_default_code = '<div class="addthis_toolbox addthis_default_style ">
			<a class="addthis_button_preferred_1"></a>
			<a class="addthis_button_preferred_2"></a>
			<a class="addthis_button_preferred_3"></a>
			<a class="addthis_button_preferred_4"></a>
			<a class="addthis_button_preferred_5"></a>
			<a class="addthis_button_compact"></a>
			<a class="addthis_counter addthis_bubble_style"></a>
			</div>
			<script type="text/javascript">
			var addthis_config = {
								services_compact: "facebook, twitter, linkedin, google, digg, more",
								services_exclude: "print, email"
			}
			</script>
			<script type="text/javascript" src="https://s7.addthis.com/js/250/addthis_widget.js"></script>';

			$db->insert('engine4_core_settings', array(
				'name' => 'groupdocument.code.share',
				'value' => $social_share_default_code,
			));
		}

    parent::onPreInstall();
  }

  function onInstall() {
    $db = $this->getDb();
    
    $select = new Zend_Db_Select($db);
    $select->from('engine4_core_modules')
           ->where('name = ?', 'groupdocument')
           ->where('version <= ?', '4.8.8');
    $is_enabled = $select->query()->fetchObject();
    if (!empty($is_enabled)) {
        $db->query("UPDATE `engine4_groupdocument_documents` SET `thumbnail` = REPLACE(thumbnail, 'http:', 'https:') WHERE `thumbnail` Like 'http:%'");
    }    

    //CHECK THAT ADVANCED-GROUP PLUGIN IS INSTALLED OR NOT
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'advgroup')
            ->where('enabled = ?', 1);
    $check_advgroup = $select->query()->fetchObject();

		//CHECK THAT GROUP PLUGIN IS INSTALLED OR NOT
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'group')
            ->where('enabled = ?', 1);
    $check_group = $select->query()->fetchObject();
    if (!empty($check_group) || !empty($check_advgroup)) {

      //CODE FOR INCREASE THE SIZE OF engine4_authorization_permissions's FIELD type
      $type_array = $db->query("SHOW COLUMNS FROM engine4_authorization_permissions LIKE 'type'")->fetch();
      if (!empty($type_array)) {
        $varchar = $type_array['Type'];
        $length_varchar = explode("(", $varchar);
        $length = explode(")", $length_varchar[1]);
        $length_type = $length[0];
        if ($length_type < 32) {
          $run_query = $db->query("ALTER TABLE `engine4_authorization_permissions` CHANGE `type` `type` VARCHAR( 32 ) CHARACTER SET latin1 COLLATE latin1_general_ci NOT NULL");
        }
      }

      $select = new Zend_Db_Select($db);
      $select
              ->from('engine4_core_menuitems')
              ->where('name = ?', 'core_sitemap_groupdocument')
              ->where('module = ?', 'groupdocument')
              ->limit(1);
      $info = $select->query()->fetch();
      if (!empty($info)) {

        $db->delete('engine4_core_menuitems', array(
            'name = ?' => 'core_sitemap_groupdocument',
            'module = ?' => 'groupdocument'
        ));
      }

      $upgrade_time = time();

      $db->query("INSERT IGNORE INTO `engine4_core_settings` (`name`, `value`) VALUES ('groupdocument.upgrade.time', $upgrade_time),
			('groupdocument.myvars', 0),('groupdocument.lrucvar.word', 'lruc'), ('groupdocument.mypath','Groupdocument/controllers/license/license2.php');");

      $select = new Zend_Db_Select($db);
      $select
              ->from('engine4_core_menuitems')
              ->where('name = ?', 'groupdocument_admin_main_settings')
              ->where('params = ?', '{"route":"admin_default","module":"groupdocument","controller":"settings","action":"readme"}')
              ->limit(1);
      $info = $select->query()->fetch();
      if (!empty($info)) {
        $db->update('engine4_core_menuitems', array(
            'params' => '{"route":"admin_default","module":"groupdocument","controller":"settings"}'
                ), array('name =?' => 'groupdocument_admin_main_settings'));
      }

      $db->query("UPDATE  `engine4_seaocores` SET  `is_activate` =  '1' WHERE  `engine4_seaocores`.`module_name` ='groupdocument';");

      //START: PUT DOCUMENT TAB AUTOMATICALLY AT GROUP PROFILE PAGE
      $db = $this->getDb();
      $select = new Zend_Db_Select($db);

      $select
              ->from('engine4_core_pages')
              ->where('name = ?', 'group_profile_index')
              ->limit(1);
      $page_id = $select->query()->fetchObject()->page_id;
      if (!empty($page_id)) {

        $select = new Zend_Db_Select($db);
        $select_content = $select
                        ->from('engine4_core_content')
                        ->where('page_id = ?', $page_id)
                        ->where('type = ?', 'widget')
                        ->where('name = ?', 'groupdocument.profile-groupdocuments')
                        ->limit(1);
        $content_id = $select_content->query()->fetchObject()->content_id;
        if (empty($content_id)) {
          $select = new Zend_Db_Select($db);
          $select_container = $select
                          ->from('engine4_core_content')
                          ->where('page_id = ?', $page_id)
                          ->where('type = ?', 'container')
                          ->limit(1);
          $container_id = $select_container->query()->fetchObject()->content_id;
          if (!empty($container_id)) {
            $select = new Zend_Db_Select($db);
            $select_middle = $select
                            ->from('engine4_core_content')
                            ->where('parent_content_id = ?', $container_id)
                            ->where('type = ?', 'container')
                            ->where('name = ?', 'middle')
                            ->limit(1);
            $middle_id = $select_middle->query()->fetchObject()->content_id;
            if (!empty($middle_id)) {
              $select = new Zend_Db_Select($db);
              $select_tab = $select
                              ->from('engine4_core_content')
                              ->where('type = ?', 'widget')
                              ->where('name = ?', 'core.container-tabs')
                              ->where('page_id = ?', $page_id)
                              ->limit(1);
              $tab_id = $select_tab->query()->fetchObject()->content_id;

              $db->insert('engine4_core_content', array(
                  'page_id' => $page_id,
                  'type' => 'widget',
                  'name' => 'groupdocument.profile-groupdocuments',
                  'parent_content_id' => ($tab_id ? $tab_id : $middle_id),
                  'order' => 999,
                  'params' => '{"title":"Documents","titleCount":true}',
              ));
            }
          }
        }
      }
      //END: PUT DOCUMENT TAB AUTOMATICALLY AT GROUP PROFILE PAGE

      //START: PUT DOCUMENT TAB AUTOMATICALLY AT ADVANCED-GROUP PROFILE PAGE
      $db = $this->getDb();
      $select = new Zend_Db_Select($db);

      $select
              ->from('engine4_core_pages')
              ->where('name = ?', 'advgroup_profile_index')
              ->limit(1);
      $page_id = $select->query()->fetchObject()->page_id;
      if (!empty($page_id)) {

        $select = new Zend_Db_Select($db);
        $select_content = $select
                        ->from('engine4_core_content')
                        ->where('page_id = ?', $page_id)
                        ->where('type = ?', 'widget')
                        ->where('name = ?', 'groupdocument.profile-groupdocuments')
                        ->limit(1);
        $content_id = $select_content->query()->fetchObject()->content_id;
        if (empty($content_id)) {
          $select = new Zend_Db_Select($db);
          $select_container = $select
                          ->from('engine4_core_content')
                          ->where('page_id = ?', $page_id)
                          ->where('type = ?', 'container')
                          ->limit(1);
          $container_id = $select_container->query()->fetchObject()->content_id;
          if (!empty($container_id)) {
            $select = new Zend_Db_Select($db);
            $select_middle = $select
                            ->from('engine4_core_content')
                            ->where('parent_content_id = ?', $container_id)
                            ->where('type = ?', 'container')
                            ->where('name = ?', 'middle')
                            ->limit(1);
            $middle_id = $select_middle->query()->fetchObject()->content_id;
            if (!empty($middle_id)) {
              $select = new Zend_Db_Select($db);
              $select_tab = $select
                              ->from('engine4_core_content')
                              ->where('type = ?', 'widget')
                              ->where('name = ?', 'core.container-tabs')
                              ->where('page_id = ?', $page_id)
                              ->limit(1);
              $tab_id = $select_tab->query()->fetchObject()->content_id;

              $db->insert('engine4_core_content', array(
                  'page_id' => $page_id,
                  'type' => 'widget',
                  'name' => 'groupdocument.profile-groupdocuments',
                  'parent_content_id' => ($tab_id ? $tab_id : $middle_id),
                  'order' => 999,
                  'params' => '{"title":"Documents","titleCount":true}',
              ));
            }
          }
        }
      }
      //END: PUT DOCUMENT TAB AUTOMATICALLY AT ADVANCED-GROUP PROFILE PAGE

			$db->query('INSERT IGNORE INTO `engine4_authorization_permissions`
				SELECT
					level_id as `level_id`,
					"groupdocument_document" as `type`,
					"comment" as `name`,
					2 as `value`,
					NULL as `params`
				FROM `engine4_authorization_levels` WHERE `type` IN("moderator", "admin", "user")');

			//CHECK THAT like_count COLUMN EXIST OR NOT IN DOCUMENT TABLE
			$column_exist = $db->query("SHOW COLUMNS FROM engine4_groupdocument_documents LIKE 'like_count'")->fetch();
			$table_exist = $db->query("SHOW TABLES LIKE 'engine4_groupdocument_documents'")->fetch();
			if (empty($column_exist) && !empty($table_exist)) {
				
				//ADD review_count COLUMN TO PAGE TABLE
				$db->query("ALTER TABLE `engine4_groupdocument_documents` ADD `like_count` INT( 11 ) NOT NULL DEFAULT '0' AFTER `comment_count`");

				//FETCH PAGES
				$documents = $db->select()->from('engine4_groupdocument_documents', 'document_id')->query()->fetchAll();

				if (!empty($documents)) {
					foreach($documents as $document)
					{
						$document_id = $document['document_id'];

						if(!empty($document_id)) {

							//GET TOTAL REVIEWS CORROSPONDING TO PAGE ID
							$total_likes = $db->select()
															->from('engine4_core_likes', array('COUNT(*) AS count'))
															->where('resource_id = ?', $document_id)
															->where('resource_type = ?', 'groupdocument_document')
															->limit(1)
															->query()
															->fetchColumn();

							if(!empty($total_likes)) {
								//UPDATE TOTAL LIKES IN PAGE TABLE
								$db->update('engine4_groupdocument_documents', array('like_count' => $total_likes), array('document_id = ?' => $document_id));
							}
						}
					}
				}
			}

			$table_exist = $db->query("SHOW TABLES LIKE 'engine4_groupdocument_documents'")->fetch();
			if (!empty($table_exist)) {

				$column_exist = $db->query("SHOW COLUMNS FROM engine4_groupdocument_documents LIKE 'email_allow'")->fetch();
				if (!empty($column_exist)) {
					$db->query("ALTER TABLE `engine4_groupdocument_documents` CHANGE `email_allow` `email_allow` TINYINT( 1 ) NOT NULL DEFAULT '0'");
				}

				$column_exist = $db->query("SHOW COLUMNS FROM engine4_groupdocument_documents LIKE 'secure_allow'")->fetch();
				if (!empty($column_exist)) {
					$db->query("ALTER TABLE `engine4_groupdocument_documents` CHANGE `secure_allow` `secure_allow` TINYINT( 1 ) NOT NULL DEFAULT '0'");
				}

				$column_exist = $db->query("SHOW COLUMNS FROM engine4_groupdocument_documents LIKE 'download_allow'")->fetch();
				if (!empty($column_exist)) {
					$db->query("ALTER TABLE `engine4_groupdocument_documents` CHANGE `download_allow` `download_allow` TINYINT( 1 ) NOT NULL DEFAULT '0'");
				}

				$column_exist = $db->query("SHOW COLUMNS FROM engine4_groupdocument_documents LIKE 'groupdocument_slug'")->fetch();
				if (!empty($column_exist)){
					$db->query("ALTER TABLE `engine4_groupdocument_documents` DROP `groupdocument_slug`");
				}

				$column_exist = $db->query("SHOW COLUMNS FROM engine4_groupdocument_documents LIKE 'like_count'")->fetch();
				if (empty($column_exist)) {
					
					//ADD review_count COLUMN TO PAGE TABLE
					$db->query("ALTER TABLE `engine4_groupdocument_documents` ADD `like_count` INT( 11 ) NOT NULL DEFAULT '0' AFTER `comment_count`");

					//FETCH PAGES
					$documents = $db->select()->from('engine4_groupdocument_documents', 'document_id')->query()->fetchAll();

					if (!empty($documents)) {
						foreach($documents as $document)
						{
							$document_id = $document['document_id'];

							if(!empty($document_id)) {

								//GET TOTAL REVIEWS CORROSPONDING TO PAGE ID
								$total_likes = $db->select()
																->from('engine4_core_likes', array('COUNT(*) AS count'))
																->where('resource_id = ?', $document_id)
																->where('resource_type = ?', 'groupdocument_document')
																->limit(1)
																->query()
																->fetchColumn();

								if(!empty($total_likes)) {
									//UPDATE TOTAL LIKES IN PAGE TABLE
									$db->update('engine4_groupdocument_documents', array('like_count' => $total_likes), array('document_id = ?' => $document_id));
								}
							}
						}
					}
				}
			}

			$select = new Zend_Db_Select($db);
			$select
				->from('engine4_core_settings')
				->where('name = ?', 'groupdocument.code.share');
			$groupdocument_code_share = $select->query()->fetchObject();
			if(empty($groupdocument_code_share))
			{
				$social_share_default_code = '<div class="addthis_toolbox addthis_default_style ">
				<a class="addthis_button_preferred_1"></a>
				<a class="addthis_button_preferred_2"></a>
				<a class="addthis_button_preferred_3"></a>
				<a class="addthis_button_preferred_4"></a>
				<a class="addthis_button_preferred_5"></a>
				<a class="addthis_button_compact"></a>
				<a class="addthis_counter addthis_bubble_style"></a>
				</div>
				<script type="text/javascript">
				var addthis_config = {
									services_compact: "facebook, twitter, linkedin, google, digg, more",
									services_exclude: "print, email"
				}
				</script>
				<script type="text/javascript" src="https://s7.addthis.com/js/250/addthis_widget.js"></script>';

				$db->insert('engine4_core_settings', array(
					'name' => 'groupdocument.code.share',
					'value' => $social_share_default_code,
				));
			}
      
        $documentTable = $db->query('SHOW TABLES LIKE \'engine4_groupdocument_documents\'')->fetch();
        if(!empty($documentTable)) {
            $featuredIndex = $db->query("SHOW INDEX FROM `engine4_groupdocument_documents` WHERE Key_name = 'featured'")->fetch();   
            if(empty($featuredIndex)) {
              $db->query("ALTER TABLE `engine4_groupdocument_documents` ADD INDEX ( `featured` )");
            }   

            $groupIdIndex = $db->query("SHOW INDEX FROM `engine4_groupdocument_documents` WHERE Key_name = 'group_id'")->fetch();     
            if(empty($groupIdIndex)) {
              $db->query("ALTER TABLE `engine4_groupdocument_documents` ADD INDEX ( `group_id` )");
            }         

            $searchIndex = $db->query("SHOW INDEX FROM `engine4_groupdocument_documents` WHERE Key_name = 'search'")->fetch();     
            if(!empty($searchIndex)) {
              $db->query("ALTER TABLE `engine4_groupdocument_documents` DROP INDEX search");
              $db->query("ALTER TABLE `engine4_groupdocument_documents` ADD INDEX (`draft`, `search`, `status`, `approved`)");
            }      
        }      

      parent::onInstall();
    } else {
      $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();
      return $this->_error("<span style='color:red'>Note: You do not have installed the Group Plugin on your site. Please install first Group Plugin on your site before installing this Group Document Plugin.</span><br/> <a href='" . $base_url . "/manage'>Click here</a> to go Manage Packages.");
    }
  }

}
