<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Groupdocument
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: manifest.php 6590 2010-10-19 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
return array(
    //Package -------------------------------------------------------------------
    'package' => array(
        'type' => 'module',
        'name' => 'groupdocument',
        'version' => '5.4.1',
        'path' => 'application/modules/Groupdocument',
        'repository' => 'null',
        'title' => 'Groups Documents Extension Plugin',
        'description' => 'Add an excitingly new and useful feature : Documents, to the Groups on your site. The Groups - Documents Extension Plugin brings the power of Documents / Scribd iPapers to SocialEngine Groups. The plugin adds a "Documents" tab to every Group. Users can upload and display Documents in Groups. Additionally, they can share, print, download documents, and comment on them. Features like the iPaper document viewer, Email attachments, user controlled privacy, support for extensive document formats, SEO URLs and SEO page structure, will attract more traffic to your site.',
'author' => '<a href="http://www.socialapps.tech" style="text-decoration:underline;" target="_blank">SocialApps.tech</a>',
        'date' => 'Thursday, 25 October 2010 18:33:08 +0000',
        'copyright' => 'Copyright 2009-2010 BigStep Technologies Pvt. Ltd.',
        'actions' => array(
            'install',
            'upgrade',
            'refresh',
            'enable',
            'disable',
        ),
        'callback' => array(
            'path' => 'application/modules/Groupdocument/settings/install.php',
            'class' => 'Groupdocument_Installer',
        ),
        'directories' => array(
            'application/modules/Groupdocument',
        ),
        'files' => array(
            'application/languages/en/groupdocument.csv',
        ),
    ),
    //Hooks ---------------------------------------------------------------------
    'hooks' => array(
        array(
            'event' => 'onUserDeleteBefore',
            'resource' => 'Groupdocument_Plugin_Core',
        ),
        array(
            'event' => 'addActivity',
            'resource' => 'Groupdocument_Plugin_Core'
        ),
        array(
            'event' => 'onItemDeleteBefore',
            'resource' => 'Groupdocument_Plugin_Core'
        ),
    ),
    //Items ---------------------------------------------------------------------
    'items' => array(
        'groupdocument_document',
        'groupdocument_search',
    ),
    //Routes --------------------------------------------------------------------
    'routes' => array(
        'groupdocument_create' => array(
            'route' => 'groupdocuments/create/:group_id',
            'defaults' => array(
                'module' => 'groupdocument',
                'controller' => 'index',
                'action' => 'create'
            ),
            'reqs' => array(
                'group_id' => '\d+'
            )
        ),
        'groupdocument_delete' => array(
            'route' => 'groupdocuments/delete/:document_id/:group_id',
            'defaults' => array(
                'module' => 'groupdocument',
                'controller' => 'index',
                'action' => 'delete'
            ),
            'reqs' => array(
                'document_id' => '\d+',
                'group_id' => '\d+'
            )
        ),
        'groupdocument_publish' => array(
            'route' => 'groupdocuments/publish/:document_id',
            'defaults' => array(
                'module' => 'groupdocument',
                'controller' => 'index',
                'action' => 'publish'
            ),
            'reqs' => array(
                'document_id' => '\d+'
            )
        ),
        'groupdocument_featured' => array(
            'route' => 'groupdocuments/featured/:document_id',
            'defaults' => array(
                'module' => 'groupdocument',
                'controller' => 'index',
                'action' => 'featured'
            ),
            'reqs' => array(
                'document_id' => '\d+'
            )
        ),
        'groupdocument_approved' => array(
            'route' => 'groupdocuments/approved/:document_id',
            'defaults' => array(
                'module' => 'groupdocument',
                'controller' => 'index',
                'action' => 'approved'
            ),
            'reqs' => array(
                'document_id' => '\d+'
            )
        ),
        'groupdocument_edit' => array(
            'route' => 'groupdocuments/edit/:document_id/:group_id',
            'defaults' => array(
                'module' => 'groupdocument',
                'controller' => 'index',
                'action' => 'edit'
            )
        ),
        'groupdocument_ssl' => array(
            'route' => 'groupdocuments/ssl/*',
            'defaults' => array(
                'module' => 'groupdocument',
                'controller' => 'index',
                'action' => 'ssl'
            )
        ),
        'groupdocument_detail_view' => array(
            'route' => 'groupdocuments/:user_id/:document_id/:slug',
            'defaults' => array(
                'module' => 'groupdocument',
                'controller' => 'index',
                'action' => 'view',
                'slug' => '',
            ),
            'reqs' => array(
                'user_id' => '\d+',
                'document_id' => '\d+'
            )
        ),
        'groupdocument_admin_manage_level' => array(
            'route' => 'admin/groupdocument/level/:id',
            'defaults' => array(
                'module' => 'groupdocument',
                'controller' => 'admin-level',
                'action' => 'index',
                'level_id' => 1
            )
        ),
    )
);
