<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Groupdocument
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.tpl 6590 2010-10-19 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Groupdocument_Widget_FeaturelistGroupdocumentsController extends Engine_Content_Widget_Abstract {

  public function indexAction() {
    //GET VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();

    //GET GROUP SUBJECT
    $group = Engine_Api::_()->core()->getSubject('group');

    //SET NO RENDER IF VIEWER CAN NOT VIEW THE DOCUMENTS
    $can_view = $group->authorization()->isAllowed($viewer, 'view');
    if (empty($can_view)) {
      return $this->setNoRender();
    }

    $groupdoc_featuredlist = Zend_Registry::get('groupdocument_featuredlist');
    if (empty($groupdoc_featuredlist)) {
      return $this->setNoRender();
    }

    //CHECK THAT WIDGET IS VIEABLE OR NOT
    $show_featured = Engine_Api::_()->getApi('settings', 'core')->getSetting('groupdocument.featured', 1);
    if (empty($show_featured)) {
      return $this->setNoRender();
    }

    //FETCH DOCUMENTS
    $params = array();
    $params['group_id'] = $group->group_id;
    $params['orderby'] = 'featured DESC';
		$params['featured'] = 1;
    $params['limit'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('groupdocument.featurelist.widgets', 3);
    $this->view->paginator = Engine_Api::_()->getDbtable('documents', 'groupdocument')->widgetDocumentsData($params);

    if (Count($this->view->paginator) <= 0) {
      return $this->setNoRender();
    }
  }

}