<?php


/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Instaclone
 * @copyright  Copyright 2015-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Layout.php 2018-04-05 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Instaclone_Form_Admin_Settings_Landingpage_SlideImage extends Engine_Form
{

  public function init()
  {

    $description = sprintf(Zend_Registry::get('Zend_Translate')->_("Here you can add multiple photos which will be displayed on the Landing Page."));

    $this->setTitle("Add photos");
    $this->setDescription("$description");
    $this->loadDefaultDecorators();
    $this->getDecorator('Description')->setOption('escape', false);
    $this->setAttrib('id', 'form-upload')->setAttrib('enctype','multipart/form-data');

    // Get available files
    $this->addElement('HTMLUpload', 'file', [
        'form' => '#form-upload',
        'title' => 'Upload Photo',
        'label' => 'Upload Image',
        'multi' => true,
        'url' => $this->getView()->url(array('controller'=> 'landing-page','action'=>'image-upload'),'admin_default'),
        'accept' => 'image/*',
      ]);

    $this->addElement('Button', 'submit', array(
      'label' => 'Save',
      'type' => 'submit',
      'ignore' => true,
    ));
  }
}
?>

