<?php


/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Instaclone
 * @copyright  Copyright 2015-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Layout.php 2018-04-05 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Instaclone_Form_Admin_Settings_Sign extends Engine_Form
{

  public function init()
  {
    $description = sprintf(Zend_Registry::get('Zend_Translate')->_("Here you can manage Tagline of Sign-in and Sign-up Page."));
    $this->setTitle("Manage Tagline of Sign-in and Sign-up Page.");
    $this->setDescription("$description");
  
    $this->loadDefaultDecorators();
    $this->getDecorator('Description')->setOption('escape', false);

    $coreSettings = Engine_Api::_()->getApi('settings', 'core');
    $this->setAttrib('id', 'form-upload');

    $this->addElement('Textarea', 'instaclone_setting_tag_signup', array(
      'label' => 'Tagline on Sign-up Page',
      'description' => 'Enter the tagline text that you want to display on the Sign-up page.',
      // 'style' => 'width:350px;',
      'value' => $coreSettings->getSetting("instaclone.setting.tag.signup", "Join to see photographs and videos from your friends."),
    ));

    $this->addElement('Textarea', 'instaclone_setting_tag_signin', array(
      'label' => 'Tagline on Sign-in Page',
      'description' => 'Enter the tagline text that you want to display on the Sign-in page.',
      // 'style' => 'width:350px;',
      'value' => $coreSettings->getSetting("instaclone.setting.tag.signin", "Join to see photographs and videos from your friends."),
    ));

    $this->addElement('Button', 'submit', array(
      'label' => 'Save Changes',
      'type' => 'submit',
      'decorators' => array(
        'ViewHelper',
      ),
    ));
  }

}
?>
