<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Instaclone
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 2015-06-04 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
$headerSettings = $view->url(array('module' => 'instaclone', 'controller' => 'header'));
$landingSettings = $view->url(array('module' => 'instaclone', 'controller' => 'admin-landing-page', 'action' => 'right-layout'), 'instaclone_admin_landing_right', true);
$footerMenuSettings = $view->url(array('module' => 'instaclone', 'controller' => 'settings', 'action' => 'footer-menu'), 'admin_default', true);
$enableSitemenu= Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitemenu');

return array(
    array(
        'title' => 'Ultimate Insta Clone Theme - Footer Menu',
        'description' => 'Shows the site-wide footer menu. You can <a href = "'.$footerMenuSettings.'" target = "_blank">edit</a> its contents in your menu editor.',
        'category' => 'SEAO - Ultimate Insta Clone Theme',
        'type' => 'widget',
        'name' => 'instaclone.menu-footer',
        'requirements' => array(
            'header-footer',
        ),
    ),
    
    array(
        'title' => 'Ultimate Insta Clone Theme - Languages',
        'description' => 'This widget is used to display the languages available on site.',
        'category' => 'SEAO - Ultimate Insta Clone Theme',
        'type' => 'widget',
        'name' => 'instaclone.language',
        'adminForm' => 'Instaclone_Form_Admin_Widget_FooterMenu',
    ),
    array(
        'title' => 'Ultimate Insta Clone Theme - Landing Page Widget',
        'description' => 'You can configure its settings via Landing Page section in admin panel. Click on <a href = "'.$landingSettings.'" target = "_blank">Landing Page</a> to modify the other content for this widget.',
        'category' => 'SEAO - Ultimate Insta Clone Theme',
        'type' => 'widget',
        'name' => 'instaclone.landing-page',
        'autoEdit' => 'true'
    ),

    array(
        'title' => 'Ultimate Insta Clone Theme - Sign In and Sign Up',
        'description' => 'Displays signin signup widget.',
        'category' => 'SEAO - Ultimate Insta Clone Theme',
        'type' => 'widget',
        'name' => 'instaclone.form-banner',
        'defaultParams' => array(
          'title' => '',
        ),
        'adminForm' => 'Instaclone_Form_Admin_Widget_Banner',
        'autoEdit' => 'true',
      ),
  	array(
        'title' => 'Ultimate Insta Clone Theme - Header',
        'description' => 'Displays the header options on your site. You can edit its content in your menu editor. Click on <a href = "'.$headerSettings.'" target = "_blank">edit</a> to modify the other content for this widget.',
        'category' => 'SEAO - Ultimate Insta Clone Theme',
        'type' => 'widget',
        'name' => 'instaclone.header',
        'defaultParams' => array(
          'title' => '',
          ),
        'autoEdit' => 'true',
      ),

    array(
        'title' => 'Ultimate Insta Clone Theme - User Profile Info',
        'description' => 'Displays username, profile photo, first & last name on page.',
        'category' => 'SEAO - Ultimate Insta Clone Theme',
        'type' => 'widget',
        'name' => 'instaclone.user-profile-info',
        'defaultParams' => array(
          'title' => '',
          ),
        'autoEdit' => '',
      ),
    array(
        'title' => 'Ultimate Insta Clone Theme - Forgot password',
        'description' => 'This should be placed on forgot password page.',
        'category' => 'SEAO - Ultimate Insta Clone Theme',
        'type' => 'widget',
        'name' => 'instaclone.forgot-form-banner',
        'defaultParams' => array(
          'title' => '',
          ),
        'autoEdit' => '',
      ),

    array(
        'title' => 'Ultimate Insta Clone Theme - User Cover Photo Banner',
        'description' => 'This should be placed on member profile page along with User Cover Photo widget of User Plugin.',
        'category' => 'SEAO - Ultimate Insta Clone Theme',
        'type' => 'widget',
        'name' => 'instaclone.user-cover-photo',
        'adminForm' => 'Instaclone_Form_Admin_Widget_UserCoverPhoto',
        'defaultParams' => array(
          'title' => '',
          'user_statistics' => array("email", "friendfollow", "likes"),
          ),
        'autoEdit' => true,
      ),

  )
?>