<?php
class Livestreamingvideo_Api_Siteapi_Core extends Core_Api_Abstract 
{

  public function hasPackageEnable($isJoinee = false) {

    $isAllowed = true;
    if(!$isJoinee)
      $isAllowed = Engine_Api::_()->authorization()->isAllowed('livestreamingvideo', Engine_Api::_()->user()->getViewer(), "go_live");
    $isAafEnable = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('advancedactivity');
    $isAdvVideoEnable = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitevideo');

    return ($isAafEnable && $isAdvVideoEnable && $isAllowed && !empty(Engine_Api::_()->getApi('settings', 'core')->getSetting('livestreamingvideo.agora.app.id')) && !empty(Engine_Api::_()->getApi('settings', 'core')->getSetting('livestreamingvideo.url')) && !empty(Engine_Api::_()->getApi('settings', 'core')->getSetting('livestreamingvideo.agora.app.certificate')));
  }
    
  public function getNetwork($user) {
    if(!$user)
      return 0;

    $membershipTable = Engine_Api::_()->getDbtable('membership', 'network');
    $select = $membershipTable
                  ->select()
                  ->where('user_id= ?',$user->getIdentity());
    $network =  $membershipTable->fetchRow($select);
    if(!empty($network)){
      return $network->resource_id;
    }
    return 0;
  }

  public function getMembersOfUserNetwork($networkIds=null) {
    if(empty($networkIds))
      return ;

    $membership = Engine_Api::_()->getDbtable('membership', 'network');
    $membershipName = $membership->info('name');
    $select = $membership->select()
                        ->from($membershipName, 'user_id')
                        ->where('resource_id IN (?)',$networkIds)
                        ->where('active = ?',1);

    $members = $membership->fetchAll($select);
    return $members;
  }

  public function getRegistedUsers() {
    $table = Engine_Api::_()->getDbtable('users', 'user');
    $tableName = $table->info('name');
    $select = $table->select()
                    ->from($tableName, 'user_id')
                    ->where('verified = ?', 1)
                    ->where('approved = ?', 1)
                    ->where('enabled = ?', 1);

    $result = $table->fetchAll($select);

    return $result;
  }

  public function getFriends($user) {
    if(!$user)
      return 0;

    $table = Engine_Api::_()->getDbtable('membership', 'user');
    $tableName = $table->info('name');
    $select = $table->select()
                    ->from($tableName, 'user_id')
                    ->where('resource_id = ?', $user->getIdentity())
                    ->where('active = ?', 1)
                    ->where('user_id != ?', 0);

    $result = $table->fetchAll($select);
    return $result;
  }

  public function getAllReactions($subject) {
    $reactionIcons=array();
    if (Engine_Api::_()->getApi('Siteapi_Feed', 'advancedactivity')->isSitereactionPluginLive()) {
      if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitereaction') && Engine_Api::_()->getApi('settings', 'core')->getSetting('sitereaction.reaction.active', 1)) {
        $popularity = Engine_Api::_()->getApi('core', 'sitereaction')->getLikesReactionPopularity($subject);
        $reactionIcons = Engine_Api::_()->getApi('Siteapi_Core', 'sitereaction')->getLikesReactionIcons($popularity, 1);  
      }
    }
    return  $reactionIcons;
  }

  public function createLink($photo) {
   
    // Now try to create thumbnail
    $thumbnail = (string) @$photo;
    $thumbnail_parsed = @parse_url($photo);
    
    if ($thumbnail && $thumbnail_parsed) {
      $tmp_path = APPLICATION_PATH . '/temporary';
      $tmp_file = $tmp_path . '/' . md5($thumbnail);

      if (!is_dir($tmp_path) && !mkdir($tmp_path, 0777, true)) {
        throw new Core_Model_Exception('Unable to create tmp folder : ' . $tmp_path);
      }

      $src_fh = fopen($thumbnail, 'r');
      $tmp_fh = fopen($tmp_file, 'w');
      stream_copy_to_stream($src_fh, $tmp_fh, 1024 * 1024 * 2);
      fclose($src_fh);
      fclose($tmp_fh);

      if (($info = getimagesize($tmp_file)) && !empty($info[2])) {
        $ext = Engine_Image::image_type_to_extension($info[2]);
        // Resize image (main)
        $main_file = $tmp_path . '/thumb_m_' . md5($thumbnail) . '.' . $ext;
        $image = Engine_Image::factory();
        $image->open($tmp_file)
          ->autoRotate()
          ->resize(720, 720)
          ->write($main_file)
          ->destroy();

        $thumb_file = $tmp_path . '/thumb_' . md5($thumbnail) . '.' . $ext;

        $image = Engine_Image::factory();
        $image->open($tmp_file)
          ->resize(240, 240)
          ->write($thumb_file)
          ->destroy();
        $params = array(
            'parent_type' => 'sitevideo_video',
            'parent_id' =>1,
        );
        try {
          $MainFileRow = Engine_Api::_()->storage()->create($main_file, $params);
          $thumbFileRow = Engine_Api::_()->storage()->create($thumb_file, $params);
          $MainFileRow->bridge($thumbFileRow, 'thumb.profile');
        } catch (Exception $e) {
          @unlink($thumb_file);
          @unlink($main_file);
          throw $e;
        }
        

        @unlink($thumb_file);
        @unlink($main_file);
      }

      @unlink($tmp_file);
    }

    return $MainFileRow;
  }

  public function getUsers($params, $isAndroid = 1) {

  	if ($isAndroid) {
  		$table = Engine_Api::_()->getDbtable('gcmusers', 'siteandroidapp');
  		$column = 'registration_id';
  	} else {
  		$table = Engine_Api::_()->getDbtable('apnusers', 'siteiosapp');
  		$column = 'token';
  	}

  	$select = $table->select()
  				->from($table->info('name'), $column);
    if (isset($params['user_ids']) && $params['user_ids'])
      $select->where('user_id IN(?)', (array) $params['user_ids']);

    $result = $table->fetchAll($select);

    return array_column($result->toArray(), $column);
  }
}
?>