<?php

require_once realpath(dirname(__FILE__)) . '/sitemodule_install.php';
class Livestreamingvideo_Installer extends SiteModule_Installer
{
	protected $_deependencyVersion = array(
		'seaocore' => '5.5.0p5',
		'siteapi' => '5.5.0p1',
		'siteiosapp' => '5.5.0',
		'siteandroidapp' => '5.5.0p1',
		'advancedactivity' => '5.5.0p1',
	    'sitevideo' => '5.5.0p2'
	);

	protected $_installConfig = array(
		'sku' => 'livestreamingvideo',
	);

	function onEnable() {
		$db = $this->getDb();

		$select = new Zend_Db_Select($db);
		$select->from('engine4_core_modules', array('name', 'title'))
				->where('enabled = ?', 0);
		$moduleData = $select->query()->fetchAll();

		$subModuleArray = array("advancedactivity", "sitevideo");

		foreach ($moduleData as $moduleName) {
			if (in_array($moduleName['name'], $subModuleArray)) {
				$base_url = Zend_Controller_Front::getInstance()->getBaseUrl();
				$error_msg = Zend_Registry::get('Zend_Translate')->_("Note: Please enable the integrated '".$moduleName['title']."' before enabling the 'SEAO - Live Broadcasting / Streaming' Plugin itself.");
				echo "<div style='background-color: #E9F4FA;border-radius:7px 7px 7px 7px;float:left;overflow: hidden;padding:10px;'><div style='background:#FFFFFF;border:1px solid #D7E8F1;overflow:hidden;padding:20px;'><span style='color:red'>$error_msg</span><br/> <a href='" . $base_url . "/manage'>Click here</a> to go Manage Packages.</div></div>";
				die;
			}
		}
		parent::onEnable();
	}

    public function onInstall()
  	{
  		$db = $this->getDb();

  		$table = $db->query("SHOW TABLES LIKE 'engine4_livestreamingvideo_streams';")->fetch();

  		if (!empty($table)) {
	    	$Column = $db->query("SHOW COLUMNS FROM `engine4_livestreamingvideo_streams` LIKE 'owner_id'")->fetch();

	        if (empty($Column)) {
	        	$db->query("TRUNCATE TABLE `engine4_livestreamingvideo_streams`;");
	            $db->query("ALTER TABLE `engine4_livestreamingvideo_streams` ADD `owner_id` INT(11) NOT NULL AFTER `subject_id`;");
	            $db->query("ALTER TABLE `engine4_livestreamingvideo_streams` ADD INDEX(`start_time`);");
	            $db->query("ALTER TABLE `engine4_livestreamingvideo_streams` ADD INDEX(`title`);");
	        }
	    }

        $column = $db->query("SELECT * FROM `engine4_activity_notificationtypes` WHERE  `engine4_activity_notificationtypes`.`type` = 'live_streaming'")->fetch();

        if (!empty($column)) {
        	$db->query('UPDATE `engine4_activity_notificationtypes` SET `type` = "livestreaming_video", `body` = "{item:$subject} started a {var:$link}." WHERE `engine4_activity_notificationtypes`.`type` = "live_streaming";');
        	$db->query("UPDATE `engine4_activity_notificationsettings` SET `type` = 'livestreaming_video' WHERE `engine4_activity_notificationsettings`.`type` = 'live_streaming';");
        	$db->query("UPDATE `engine4_activity_notifications` SET `type` = 'livestreaming_video' WHERE `engine4_activity_notifications`.`type` = 'live_streaming';");
        } else {
        	$db->query('INSERT IGNORE INTO `engine4_activity_notificationtypes` (`type`, `module`, `body`, `is_request`, `handler`) VALUES ("livestreaming_video", "livestreamingvideo", "{item:$subject} started a {var:$link}.", 0, "");');
        }

    	parent::onInstall();
  	}
}

?>