<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package	Mapprofiletypeleve
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license	http://www.socialengineaddons.com/license/
 * @version	$Id: Global.php 2010-09-06 9:40:21Z SocialEngineAddOns $
 * @author 	SocialEngineAddOns
 */

class Mapprofiletypelevel_Form_Admin_Global extends Engine_Form
{
	public function init()
  {  
  	$this
  		->setTitle('Global Settings');
            
      $this->addElement('Text', 'mapprofiletypelevel_controllersettings', array(
	      'label' => 'License Key',
	      'required' => true,
	      'description' => 'Please enter your license key that was provided to you when you purchased this plugin. If you do not know your license key, please contact the Support Team of SocialEngineAddOns from the Support section of your Account Area.(Key Format: XXXXXX-XXXXXX-XXXXXX )',
	      'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('mapprofiletypelevel.controllersettings')
	    ));  
   	
    $global_settings_file = APPLICATION_PATH . '/application/settings/general.php';
    if( file_exists($global_settings_file) ) {
      $generalConfig = include $global_settings_file;
    } else {
      $generalConfig = array();
    }
		if( $generalConfig['environment_mode'] != 'development' ) {
			$this->addElement('Checkbox', 'environment_mode', array(
				'label' => 'Your community is currently in "Production Mode". We recommend that you momentarily switch your site to "Development Mode" so that the CSS of this plugin renders fine as soon as the plugin is installed. After completely installing this plugin and visiting few pages of your site, you may again change the System Mode back to "Production Mode" from the Admin Panel Home. (In Production Mode, caching prevents CSS of new plugins to be rendered immediately after installation.)',
				'description' => 'System Mode',
				'value' => 1,
			)); 
		}else {
			$this->addElement('Hidden', 'environment_mode', array('order' => 990, 'value' => 0));
		}

   // Add submit button
    $this->addElement('Button', 'submit', array(
      'label' => 'Save Changes',
      'type' => 'submit',
      'ignore' => true
    ));
  }
}
?>