<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package	Mapprofiletypeleve
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license	http://www.socialengineaddons.com/license/
 * @version	$Id: MapprofileGroup.php 2010-09-06 9:40:21Z SocialEngineAddOns $
 * @author 	SocialEngineAddOns
 */
class Mapprofiletypelevel_Form_Admin_MappingGroup extends Engine_Form
{
  public function init()
  {
			 //CHECKING IF THE CASE IS FOR EDITING.
	    $id = Zend_Controller_Front::getInstance()->getRequest()->getParam('id', null);
      if (!empty($id)) {
				$title = "Edit a Profile Type to Member Level Mapping";
      }
			else {
				$title = "Create a Profile Type to Member Level Mapping";
			}	
	    $this
	      ->setAttrib('id', 'admin-form')
	      ->setMethod('POST')
	      ->setAction($_SERVER['REQUEST_URI'])
	        ->setTitle($title)
	        ->setDescription('MAPPROFILEMEMBERLEVEL_FORM_ADMIN_MAPPROFILEMEMBERLEVEL_DESCRIPTION');
	 
	  
	    $this->addElement('Text', 'title', array(
	      'label' => 'Title',
	      'required' => true,
	      'allowEmpty' => false,
	    ));
	
	    // init description
	    $this->addElement('Text', 'description', array(
	      'label' => 'Description',
	      'value' => ''
	    ));
	
	    // Prepare user levels
	    $table = Engine_Api::_()->getDbtable('levels', 'authorization');
	    $select = $table->select();
	    $user_levels = $table->fetchAll($select);
	
	    foreach ($user_levels as $user_level) {
	      $levels_prepared[$user_level->level_id] = $user_level->getTitle();
	    }
	   
	    // Prepare Profile type
	
			// Prepare query
			if (empty($id)) {
				//WE WILL SHOW ONLY THOSE PROFILE TYPES IN DROP-DOWN WHICH HAS NOT BEEN ASSOCIATED TO ANY MEMBER LEVEL YET.
				$mapprofileTable = Engine_Api::_()->getDbtable('mapprofiletypelevels', 'mapprofiletypelevel');
				$mapname = $mapprofileTable->info('name');
				$select = $mapprofileTable->select()->from($mapname, array('profile_type_id'));
				$profiletypes_array = $select->query()->fetchAll();
		 }
	  
	    if (empty($id)) {
			  $fieldtable = Engine_Api::_()->getItemTable('option');
				$fieldselect = $fieldtable->select()
	                    ->where("field_id = ?", 1);
				//field_id = 1 for fields_name and field_id = 5 for male and female entry
				$mp_levels = $fieldtable->fetchAll($fieldselect);
				foreach ($mp_levels as $mp_level) {
					$show_option  = true;
					foreach($profiletypes_array as $value) {
						if ($mp_level->option_id == $value['profile_type_id']) {
							$show_option = false;
						}
						else {
							continue;
						}
					}
					if ($show_option) {
						$mptype_prepared[$mp_level->option_id] = $mp_level->label;
					}
				}
	     
	   	// Member profile type field
			$this->addElement('Select', 'profile_type_id', array(
						'label' => 'Profile Type',
						'multiOptions' => $mptype_prepared,
					
				));
			}
			else {
				$profile_type_id = Engine_Api::_()->getItem('mapprofiletypelevel',$id)->profile_type_id;
				$member_level_id = Engine_Api::_()->getItem('mapprofiletypelevel',$id)->member_level_id;
				$mptype_prepared[$profile_type_id] = Engine_Api::_()->getItem('option',$profile_type_id)->label;
				// Member profile type field
				$this->addElement('Select', 'profile_type_id_temp', array(
						'label' => 'Profile Type',
						'disabled' => 'disabled',	
						'multiOptions' => $mptype_prepared,
					
				));
				$this->addElement('hidden', 'profile_type_id', array(
						'value' => $profile_type_id,
						'order' => 103
					
				));
				$this->addElement('hidden', 'member_level_id_old', array(
						'value' => $member_level_id,
					   'order' => 104
				));
			}
	
	    // Member category field
	    $this->addElement('Select', 'member_level_id', array(
	        'label' => 'Member Level',
	        'multiOptions' => $levels_prepared,
	       
	    ));
	
	    
	    // Buttons
	    $this->addElement('Button', 'submit', array(
	      'label' => 'Save',
	      'type' => 'submit',
	      'ignore' => true,
	      'decorators' => array('ViewHelper')
	    ));
	
	    $this->addElement('Cancel', 'cancel', array(
	      'label' => 'cancel',
	      'link' => true,
	      'prependText' => ' or ',
	      'ignore' => true,
				'onClick' => 'parent.Smoothbox.close();',	
	      'href' => Zend_Controller_Front::getInstance()->getRouter()->assemble(array('module' => 'mapprofiletypelevel', 'controller' => 'manage', 'action' => 'index'), 'admin_default', true),
	      'decorators' => array(
	        'ViewHelper'
	      )
	    ));
	    $this->addDisplayGroup(array('submit', 'cancel'), 'buttons');
  }
}
?>