<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package	Mapprofiletypeleve
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license	http://www.socialengineaddons.com/license/
 * @version	$Id: AdminManageController.php 2010-09-06 9:40:21Z SocialEngineAddOns $
 * @author 	SocialEngineAddOns
 */
class Mapprofiletypelevel_AdminManageController extends Core_Controller_Action_Admin
{
	public function init()
  {
		$id = $this->_getParam('id', $this->_getParam('mapprofiletypelevel_id', null));
    if( $id )
    {
      $mapprofile = Engine_Api::_()->getItem('mapprofiletypelevel', $id);
      if( $mapprofile )
      {
        Engine_Api::_()->core()->setSubject($mapprofile);
      }
    }
  }
  
  //SHOWING THE LISTING OF PROFILE TYPE TO MEMBER LEVEL MAPPING.
  public function indexAction()
  {
		$this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
     ->getNavigation('mapprofiletypelevel_admin_tab', array(), 'mapprofiletypelevel_content');

    $this->view->formFilter = $formFilter = new Mapprofiletypelevel_Form_Admin_Filter();

    $page = $this->_getParam('page', 1);

    $values = array();
    if( $formFilter->isValid($this->_getAllParams()) )
    {
      $values = $formFilter->getValues();
    }
    $this->view->formValues = $values;
     
    //CHECKING IF A PROFILE TYPE DOES NOT EXIST LONGER.IF ADMIN HAS DELETED PROFILE TYPE THEN WE WILL ALSO DELETE IT FROM OUR TABLE.
		$mapprofileTable = Engine_Api::_()->getDbtable('mapprofiletypelevels', 'mapprofiletypelevel');
		$mapname = $mapprofileTable->info('name');
		$select = $mapprofileTable->select()->from($mapname, array('profile_type_id','mapprofiletypelevel_id', 'member_level_id'));
		$profiletypes_array = $select->query()->fetchAll();
    
    $fieldtable = Engine_Api::_()->getItemTable('option');
		$fieldtable_name = $fieldtable->info('name');
		$fieldselect = $fieldtable->select()->from($fieldtable_name, array('option_id'))
	                    ->where("field_id = ?", 1);
				//field_id = 1 for fields_name and field_id = 5 for male and female entry
		$mp_id_array = $fieldselect->query()->fetchAll();
    foreach ($profiletypes_array as $profile_id) {
			$profile_type_id_exist = false;
			foreach ($mp_id_array as $value) {
				if ($profile_id['profile_type_id'] == $value['option_id']) {
					$profile_type_id_exist = true;
				}
				else continue;
			}
      //CHECKING IF ADMIN HAS DELETED ANY MEMBER LEVEL THEN FROM MAPPROFILETYPELEVEL TABEL WE WILL UPDATE THAT LEVEL TO DEFAULT LEVEL.
      $obj_level_id_exists = Engine_Api::_()->getItem('authorization_level',$profile_id['member_level_id']);
			if (empty($obj_level_id_exists)) {
					//UPDATING THAT MEMBER LEVEL TO DEFAULT LEVEL.
					$mapprofileTable->update(array(
						'member_level_id' => Engine_Api::_()->getItemTable('authorization_level')->getDefaultLevel()->level_id,
					), array(
						'member_level_id = ?' => $profile_id['member_level_id'],
					));
		   }
      //deleting from mpprofiletypelevel table also.
			if (empty($profile_type_id_exist)) {
				$mapprofile = Engine_Api::_()->getItem('mapprofiletypelevel', $profile_id['mapprofiletypelevel_id']);
				$mapprofile->delete();
			}
    }
		$select = $mapprofileTable->select();
     
    // Apply params
    if( !empty($values['order']) ) {
      $select->order($values['order'] . ' ' . ( !empty($values['direction']) ? $values['direction'] : 'ASC'));
    }
    
    // Make paginator
    $this->view->paginator = $paginator = Zend_Paginator::factory($select);
    $paginator->setCurrentPageNumber($page);
		$paginator->setItemCountPerPage(100);

    // Fields
    $this->view->fields = Engine_Api::_()->fields()->getFieldsMeta("user");
  }

  //CREATING A PROFILE TYPE TO MEMBER LEVEL MAPPING.
  public function createAction()
  {
    //COUNTING TOTAL PROFILE TYPES ADMIN HAS CREATED.
    $fieldtable = Engine_Api::_()->getItemTable('option');
    $fieldselect = $fieldtable->select()
      ->setIntegrityCheck(false)
      ->from($fieldtable->info('name'), array('COUNT(*) AS count'))	
      ->where("field_id = ?", 1);

    //field_id = 1 for fields_name and field_id = 5 for male and female entry
    $mp_levels = $fieldtable->fetchAll($fieldselect)->toArray();
    $profiletype_total = $mp_levels[0]['count'];

    //NOW FINDING ASSOCIATED PROFILE TYPES.
		    
    $mapprofileTable = Engine_Api::_()->getDbtable('mapprofiletypelevels', 'mapprofiletypelevel');
    $mapname = $mapprofileTable->info('name');
    $select = $mapprofileTable->select()->from($mapname, array('profile_type_id'));
    $profiletypes_array = $select->query()->fetchAll();

    if (!empty($profiletypes_array)) {
      foreach ($profiletypes_array as $value) {
	      $assoc_profile_array[] = $value['profile_type_id'];
      }
      
      //$assocprofiletype_total = $mapprofiles_types[0]['count'];
      $assoc_profile_array = array_unique($assoc_profile_array);
      $assoc_profile_total = count($assoc_profile_array);
    }
    else {
      $assoc_profile_total = 0;
    }
    //CHECKING IF ADMIN HAS ASSOCIATED ALL THE AVAILABLE PROFILE TYPES. 
    if ($assoc_profile_total >=  $profiletype_total) {
      $this->view->message = Zend_Registry::get('Zend_Translate')->_('There are no un-mapped Profile Types left.');
    }
    else {
      $this->view->form = $form = new Mapprofiletypelevel_Form_Admin_MappingGroup();

      if( !$this->getRequest()->isPost() ) {
	return;
      }

      if( !$form->isValid($this->getRequest()->getPost()) ) {
	return;
      }
      elseif ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
	$values = $form->getValues();

	$mapprofile = $mapprofileTable->createRow();
	$mapprofile->setFromArray($values);

	$tryUpload = 'publicUploadMapType';
			$mapprofile->save();
	// Sort
	//$mapprofile->recalculateAll();
	$this->_helper->redirector->gotoRoute(array('action' => 'updatememberlevel', 'controller' => 'manage', 'profile_type_id' => $values['profile_type_id'], 'level_id' => $values['member_level_id']), 'admin_default', false);
      }
    }
  }
  
  //EDITING A PROFILE TYPE TO MEMBER LEVEL MAPPING.
  public function editAction()
  {
    if( !$this->_helper->requireSubject('mapprofiletypelevel') ) return;
			$mapprofile = Engine_Api::_()->core()->getSubject();
  
    $this->view->form = $form = new Mapprofiletypelevel_Form_Admin_MappingGroup();
    if( !$this->getRequest()->isPost() ) {
      $form->populate($mapprofile->toArray());
      return;
    }
    if( !$form->isValid($this->getRequest()->getPost()) ) {
      return;
    }
    // Process
    $table = $mapprofile->getTable();
    $db = $table->getAdapter();
    $db->beginTransaction();

    try
    {
      $values = $form->getValues();
      $originalValues = $mapprofile->toArray();
      $mapprofile->setFromArray($values);
      $mapprofile->save();
      $db->commit();
    
    }
    catch( Exception $e )
    {
      $db->rollBack();
      throw $e;
    }
      
			$this->_helper->redirector->gotoRoute(array('action' => 'updatememberlevel', 'controller' => 'manage', 'profile_type_id' => $values['profile_type_id'], 'level_id' => $values['member_level_id']), 'admin_default', false);	
		
  }
  
  //DELETING PROFILE TYPE TO MEMBER LEVEL MAPPING.
  public function deleteAction()
  {
    if( !$this->_helper->requireSubject('mapprofiletypelevel') ) return;
    
    $this->view->form = $form = new Mapprofiletypelevel_Form_Admin_Delete();
    $form->setAttrib('class', 'global_form_popup');
    $mapprofile = Engine_Api::_()->core()->getSubject();
    $form->level_id->setValue($mapprofile->member_level_id);
    if( $this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost()) )
    {
      $selected_level_id = $_POST['level_id'];
      //SETTING THE MEMBER LEVEL TO SELECTED MEMEBER LEVEL OF THOSE USER WHICH WERE COMMING IN THIS PROFILE TYPE WHICH IS NOW GOING TO DELETE.
			//FIND THE USER CORROSPONDING TO THIS PROFILE.
			$mapproifle_table = Engine_Api::_()->getItemTable('mapprofiletypelevel');
			$mapprofile_table_name = $mapproifle_table->info('name');
			$user_field_option_table = Engine_Api::_()->getItemTable('value');
			$user_field_option_name = $user_field_option_table->info('name');

			$select = $user_field_option_table->select()
				->from($user_field_option_name, array('item_id'))
				->joinInner($mapprofile_table_name, "$user_field_option_name . value = $mapprofile_table_name . profile_type_id", array())
				->where("$user_field_option_name.field_id = ?", 1)
				->where("$mapprofile_table_name.mapprofiletypelevel_id = ?", $mapprofile->mapprofiletypelevel_id);
			$profiletypes_user_array = $select->query()->fetchAll();
			//UPDATING USER TABLE.
			$userTable = Engine_Api::_()->getItemTable('user');
			foreach ($profiletypes_user_array as $value) {
				$userTable->update(array(
					'level_id' => $selected_level_id,
				), array(
					'user_id = ?' => $value['item_id'],
					'level_id != ?' => 1
				));
			}
			
			if( !$mapprofile instanceof Mapprofiletypelevel_Model_Mapprofiletypelevel )
      {
        throw new Exception('bleh');
      }

      $db = $mapprofile->getTable()->getAdapter(); 
			$db->beginTransaction();

      try
      {
        $mapprofile->delete();
        Engine_Api::_()->core()->clearSubject();

        $db->commit();
      }
      catch( Exception $e )
      {
        $db->rollBack();
        throw $e;
      }

      if( null === $this->_helper->contextSwitch->getCurrentContext() ) {
        return $this->_helper->redirector->gotoRoute(array('action' => 'index', 'id' => null));
      } else {
        $this->_forward('success', 'utility', 'core', array(
          'smoothboxClose' => true,
          'parentRefresh'=> true,
					'messages' => Array(Zend_Registry::get('Zend_Translate')->_('The mapping has been successfully deleted.'))
      ));
      }
    }
  }

 public function deleteselectedAction()
  {
    $this->view->ids = $ids = $this->_getParam('actions', $this->_getParam('ids', array()));
    $confirm = $this->_getParam('confirm', false);

    if( is_string($ids) ) {
      $ids = explode(',', $ids);
    }
    $this->view->idsString = $ids_array =  join(',', $ids);
    $this->view->count = count($ids);
    //FETCHING MEMBER LEVELS.
    $table = Engine_Api::_()->getDbtable('levels', 'authorization');
		$select = $table->select();
		$user_levels = $table->fetchAll($select);
    $profiletypes_info_array = array();
		foreach ($user_levels as $user_level) {
			$levels_prepared[$user_level->level_id] = $user_level->getTitle();
		}
		$this->view->member_levels = $levels_prepared;
    //FETCHING ALL PROFILE TYPES AND MEMBER LEVEL IDS RESPECT TO SELECTED MAPPROFILETYPELEVEL IDS.
    if (!empty($ids_array)) {
			$mapproifle_table = Engine_Api::_()->getItemTable('mapprofiletypelevel');
			$mapprofile_table_name = $mapproifle_table->info('name');
			$select = $mapproifle_table->select()
						->from($mapprofile_table_name, array('profile_type_id', 'member_level_id'))
						->where("mapprofiletypelevel_id IN ($ids_array)");
			$profiletypes_info_array = $select->query()->fetchAll();
		}
    $this->view->profile_types = $profiletypes_info_array; 
    // Save values
    if( $this->getRequest()->isPost() && $confirm == true )
    {
      $db = $mapproifle_table->getAdapter();
      $db->beginTransaction();

      try
      {
				$ids_strings = implode(",", $ids);
       
				//UPDATING THE USER MEMBER LEVEL.
				//SETTING THE MEMBER LEVEL TO SELECTED MEMEBER LEVEL OF THOSE USER WHICH WERE COMMING IN THIS PROFILE TYPE WHICH IS NOW GOING TO DELETE.
				//FIND THE USER CORROSPONDING TO THIS PROFILE.
				$user_field_option_table = Engine_Api::_()->getItemTable('value');
				$user_field_option_name = $user_field_option_table->info('name');
				$userTable = Engine_Api::_()->getItemTable('user');
				$user_name = $userTable->info('name');
				$select = $user_field_option_table->select()
					->from($user_field_option_name, array('item_id', 'value'))
					->joinInner($user_name, "$user_field_option_name . item_id = $user_name . user_id", array())
					->joinInner($mapprofile_table_name, "$user_field_option_name . value = $mapprofile_table_name . profile_type_id", array())
					->where("$user_field_option_name.field_id = ?", 1)
					->where("$mapprofile_table_name.mapprofiletypelevel_id IN ($ids_array)");
				$profiletypes_user_array = $select->query()->fetchAll();
      
				//UPDATING USER'S MEMBER LEVEL IDS IN USER TABLE..
				foreach ($profiletypes_user_array as $value) {
					$selected_level_id = $this->_getParam('level_id_' . $value['value']);
					if (!empty($selected_level_id)) {
						$userTable->update(array(
							'level_id' => $selected_level_id,
						), array(
							'user_id = ?' => $value['item_id'],
							'level_id != ?' => 1
						));
					}
				}
				foreach( $ids as $id ) {
					$mapprofile = Engine_Api::_()->getItem('mapprofiletypelevel', $id);
					if( $mapprofile instanceof mapprofiletypelevel_Model_mapprofiletypelevel ) {
						$mapprofile->delete();
					}
				}
				$db->commit();
			}
			catch( Exception $e )
			{
				$db->rollBack();
				throw $e;
			}
			return $this->_helper->redirector->gotoRoute(array('action' => 'index', 'id' => null));
    }
  }

   //SHOWING THE LIST OF USERS OF A PROFILE TYPE.
   public function mapprofileuserAction()
  {
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
     ->getNavigation('mapprofiletypelevel_admin_tab', array(), 'mapprofiletypelevel_content'); 
    $this->view->formFilter = $formFilter = new Mapprofiletypelevel_Form_Admin_Filtermpuser();
    $page = $this->_getParam('page', 1);
    $profile_type_id = $this->_getParam('profile_type');
		$member_level_id = $this->_getParam('level_id');

    $user_table = Engine_Api::_()->getItemTable('user');
    $user_Name = $user_table->info('name');
		$user_field_value_table = Engine_Api::_()->getItemTable('value');
		$user_field_value_name = $user_field_value_table->info('name');
		if (!empty($member_level_id)) {
				$this->view->member_level = Engine_Api::_()->getItem('authorization_level',$member_level_id)->getTitle();
				$select = $user_table->select()
				->from($user_Name, array('*'))
				->joinInner($user_field_value_name, "$user_Name . user_id = $user_field_value_name . item_id", array())
				->where("$user_field_value_name.value = ?", $profile_type_id)
				->where("level_id = ?", $member_level_id);
		}
		else {
			$select = $user_table->select()
				->from($user_Name, array('*'))
				->joinInner($user_field_value_name, "$user_Name . user_id = $user_field_value_name . item_id", array())
				->where("$user_field_value_name.value = ?", $profile_type_id);
		}
    // Process form
    $values = array();
    if( $formFilter->isValid($this->_getAllParams()) ) {
      $values = $formFilter->getValues();
    }

    foreach( $values as $key => $value ) {
      if( null === $value ) {
        unset($values[$key]);
      }
    }

    $values = array_merge(array(
      'order' => 'user_id',
      'order_direction' => 'DESC',
    ), $values);
    
    $this->view->assign($values);

    // Set up select info
    $select->order(( !empty($values['order']) ? $values['order'] : 'user_id' ) . ' ' . ( !empty($values['order_direction']) ? $values['order_direction'] : 'DESC' ));

    if( !empty($values['username']) )
    {
      $select->where('username LIKE ?', '%' . $values['username'] . '%');
    }

    if( !empty($values['email']) )
    {
      $select->where('email LIKE ?', '%' . $values['email'] . '%');
    }

    if( !empty($values['level_id']) )
    {
      $select->where('level_id = ?', $values['level_id'] );
    }
    
    if( isset($values['enabled']) && $values['enabled'] != -1 )
    {
      $select->where('enabled = ?', $values['enabled'] );
    }
    
    // Make paginator
    $this->view->paginator = $paginator = Zend_Paginator::factory($select);
    $this->view->paginator = $paginator->setCurrentPageNumber( $page );
    $paginator->setItemCountPerPage(100);

    $this->view->superAdminCount = count(Engine_Api::_()->user()->getSuperAdmins());
    $this->view->hideEmails = _ENGINE_ADMIN_NEUTER;
		$profile_label = Engine_Api::_()->getItem('option',$profile_type_id)->label;
    $this->view->profile_type_label = $profile_label;
		
  }

  public function updatememberlevelAction() { 
		// In smoothbox
    $this->_helper->layout->setLayout('default-simple');
    if (!$this->getRequest()->isPost()) {
			$this->view->profile_type_id = $profile_type_id =  $this->_getParam('profile_type_id', null);
			$this->view->member_level_id = $selected_level_id =  $this->_getParam('level_id', null);
			$user_infos = $this->getuserinfo ($profile_type_id,  $selected_level_id);
      $this->view->user_infos = $user_infos;
			$this->view->profile_type_label = $profile_label = Engine_Api::_()->getItem('option',$profile_type_id)->label;	
			$this->view->member_level = Engine_Api::_()->getItem('authorization_level',$selected_level_id)->getTitle();
		}

		if ($this->getRequest()->isPost()) {
       $profiletypes_user_array = explode("," , $_POST['userids']);
			if (!empty($profiletypes_user_array))	{ 
				//UPDATING USER TABLE.
				$userTable = Engine_Api::_()->getItemTable('user');
				foreach ($profiletypes_user_array as $value) {
					$userTable->update(array(
						'level_id' => $_POST['level_id'],
					), array(
						'user_id = ?' => $value,
						'level_id != ?' => 1,
				));
			}
    }
		$this->_forward('success', 'utility', 'core', array(
				'smoothboxClose' => true,
				'parentRefresh'=> true,
				'messages' => Array(Zend_Registry::get('Zend_Translate')->_('The mapping has been created successfully.'))
		));
  }
 }

  //FETCHING USER INFO OF A PROFILE TYPE.
 public function getuserinfo($profile_type_id, $member_level_id) {
	//FIND THE USER CORROSPONDING TO THIS PROFILE.
	$selected_level_id = $member_level_id;
	$user_field_option_table = Engine_Api::_()->getItemTable('value');
	$user_field_option_name = $user_field_option_table->info('name');

	$select = $user_field_option_table->select()
		->from($user_field_option_name, array('item_id'))
		->where("$user_field_option_name.field_id = ?", 1)
		->where("$user_field_option_name.value = ?", $profile_type_id);
	$profiletypes_user_array = $select->query()->fetchAll();
   
   foreach($profiletypes_user_array as $user_id) {
			$user_ids[] = $user_id['item_id'];
		}
		if (!empty($user_ids)) {
			$user_ids_array = implode(",", $user_ids);	
			$user_table = Engine_Api::_()->getItemTable('user');
			$user_name = $user_table->info('name');
			$fieldselect = $user_table->select()
										->setIntegrityCheck(false)
											->from($user_name, array(
													'COUNT(*) AS count'))	
											->where("level_id = ?", 1)
											->where("user_id IN ($user_ids_array)");
			//field_id = 1 for fields_name and field_id = 5 for male and female entry
			$mp_levels = $user_table->fetchAll($fieldselect)->toArray();
			$user_superadmin_total = $mp_levels[0]['count'];
			//MAKING USER INFO ARRAY
			$user_infos= array('userids'=> $user_ids_array,
													'total_users' => count ($user_ids),
													'total_superadmin_users' => $user_superadmin_total
												);
   }
	 else {
      $user_infos = '';
		}
		return $user_infos;
	}

 //SHOWING THE PLUGIN RELETED QUESTIONS AND ANSWERS
  public function faqAction()
  {
		$this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
     ->getNavigation('mapprofiletypelevel_admin_tab', array(), 'mapprofiletypelevel_content_faq'); 
  } 
}