<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions 
 * @package    Peopleyoumayknow
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: FriendPopups.php 2010-08-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Peopleyoumayknow_Controller_Action_Helper_FriendPopups extends Zend_Controller_Action_Helper_Abstract {

  function preDispatch() {
	$front = Zend_Controller_Front::getInstance();
	$module = $front->getRequest()->getModuleName();
	$action = $front->getRequest()->getActionName();
	$controller = $front->getRequest()->getControllerName();
	$session = new Zend_Session_Namespace();


	// Condition call for "Send Friend Request" & "Accept Friend Request".
	if ($module == 'user' && $controller == 'friends') {
	  switch ($action) {
		case 'add':
		  $isPopupEnabled = Engine_Api::_()->getApi('settings', 'core')->getSetting('pymk.send.popup', 0);
		  if (!empty($isPopupEnabled)) {
			$sending_friend_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('user_id', null);
			$session->isSendRequestPopupOpen = $sending_friend_id;
		  }
		  break;

		case 'confirm':
		  $isPopupEnabled = Engine_Api::_()->getApi('settings', 'core')->getSetting('pymk.accept.popup', 0);
		  if (!empty($isPopupEnabled)) {
			$accept_friend_req_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('user_id', null);
			$session->isAcceptRequestPopupOpen = $accept_friend_req_id;
		  }
		  break;
	  }
	}
  }

  function postDispatch() {
	$front = Zend_Controller_Front::getInstance();
	$module = $front->getRequest()->getModuleName();
	$action = $front->getRequest()->getActionName();
	$controller = $front->getRequest()->getControllerName();
	$user_id = Engine_Api::_()->user()->getViewer()->getIdentity();
	$session = new Zend_Session_Namespace();
	$curr_url = $front->getRequest()->getRequestUri();
	$session = new Zend_Session_Namespace();
	$base_url = Zend_Controller_Front::getInstance()->getBaseUrl();
	$modSuggFirstClass = '';
	$modFirstClass = '';

	// When "Loggden user" will send friend request. Then suggestion popup will open after closing the sending the "Friend Request" popup.
	if (isset($session->isSendRequestPopupOpen)) {
	  if ($module == 'core' && $action == 'success') {
		$session->isSendRequestPopupClosed = $session->isSendRequestPopupOpen;
		// $this->setSettings();
	  }
	  unset($session->isSendRequestPopupOpen);
	}

	if (isset($session->isSendRequestPopupClosed)) {
	  $isTimeout = 1;
	  $modName = 'friend';
	  $modRedirectValue = $session->isSendRequestPopupClosed;
	  $curr_url = $front->getRequest()->getRequestUri();

	  $friendObject = Engine_Api::_()->peopleyoumayknow()->add_friend_suggestion($modRedirectValue, 1, 'add_friend');
	  $isShowPopup = count($friendObject);
	  if (strpos($curr_url, 'members/friends/add/user_id/') === FALSE) {
		Engine_Api::_()->getDbtable('suggestions', 'peopleyoumayknow')->removeSuggestion('friend', $modRedirectValue, 'friend_suggestion');
		if (!empty($isShowPopup)) {
		  $contentViewPopup = 1;
		}
		unset($session->isSendRequestPopupClosed);
	  }
	}

	// When "Loggden user" will accept friend request. Then suggestion popup will open after closing the "Accept Friend Request" popup.
	if (isset($session->isAcceptRequestPopupOpen)) {
	  if ($module == 'core' && $action == 'success' && $session->isAcceptRequestPopupOpen != 'confirm') {
		$session->isAcceptRequestPopupClosed = $session->isAcceptRequestPopupOpen;
		// $this->setSettings();
	  }
	  unset($session->isAcceptRequestPopupOpen);
	}

	if (isset($session->isAcceptRequestPopupClosed)) {
	  $isTimeout = 1;
	  $modName = 'accept_request';
	  $modRedirectValue = $session->isAcceptRequestPopupClosed;
	  $modRedirectValue = $session->isAcceptRequestPopupClosed;
	  $curr_url = $front->getRequest()->getRequestUri();

	  $friendObject = Engine_Api::_()->peopleyoumayknow()->add_friend_suggestion($modRedirectValue, 1, 'accept_request');
	  $isShowPopup = count($friendObject);
	  if (strpos($curr_url, 'members/friends/confirm/user_id/') === FALSE) {
		Engine_Api::_()->getDbtable('suggestions', 'peopleyoumayknow')->removeSuggestion('friend', $modRedirectValue, 'friend_suggestion');
		if (!empty($isShowPopup)) {
		  $contentViewPopup = 1;
		}
		unset($session->isAcceptRequestPopupClosed);
	  }
	}

	if (!empty($contentCreatePopup) || (!empty($contentViewPopup) && empty($onCreatePopups) )) {
	  include_once APPLICATION_PATH . '/application/modules/Peopleyoumayknow/views/scripts/_openPopups.tpl';
	}
  }

}