<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions 
 * @package    Peopleyoumayknow
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Widgetitem.php 2010-08-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Peopleyoumayknow_Form_Admin_Widgetitem extends Engine_Form {

  public function init() {

	$this
			->setTitle('Widgets & Popups Settings')
			->setDescription('Configure the settings for the widgets and popups available with this plugin. These settings allow you to set action points for showing suggestions to users, and also configure the number of entries in the suggestion widgets.');

	$settings = Engine_Api::_()->getApi('settings', 'core');


	// Adding Settings of "Community Ads".
	$this->addElement('Dummy', 'dummy_suggest_friend_title', array('label' => 'Suggest Friend Settings'));

	$this->addElement('Text', 'pymk_fewfriend_wid', array(
		'label' => 'Suggest Friends Widget',
		'description' => "How many suggestions do you want to display in the Suggest Friends widget ? [Note: Please activate the Suggest Friends widget from the Layout Editor for this.]",
		'value' => $settings->getSetting('pymk.fewfriend.wid')
	));

	$this->addElement('Radio', 'suggest_friend_is_ajax', array(
		'label' => 'Widget Content Loading',
		'description' => 'Do you want the content of this widget to be loaded via AJAX, after the loading of main webpage content? (Enabling this can improve webpage loading speed. Disabling this would load content of this widget along with the page content.)',
		'multiOptions' => array(
			1 => 'Yes',
			0 => 'No'
		),
		'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('suggest.friend.is.ajax', 1),
	));

	// Adding Settings of "Community Ads".
	$this->addElement('Dummy', 'dummy_pymk_title', array('label' => 'People You May Know Settings'));

	//FORM FOR "FRIEND MODULE".
	$this->addElement('Text', 'sugg_friend_wid', array(
		'label' => 'People You May Know Widget',
		'description' => "How many suggestions do you want to display in the People You May Know widget ? [Note: Please activate the People You May Know widget from the Layout Editor for this.]",
		'value' => $settings->getSetting('sugg.friend.wid', $settings->getSetting('pymk.friend.wid'))
	));

	$this->addElement('Radio', 'friend_ajax_enabled', array(
		'label' => 'Widget Content Loading',
		'description' => 'Do you want the content of this widget to be loaded via AJAX, after the loading of main webpage content? (Enabling this can improve webpage loading speed. Disabling this would load content of this widget along with the page content.)',
		'multiOptions' => array(
			1 => 'Yes',
			0 => 'No'
		),
		'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('friend.ajax.enabled', 1),
	));

	$this->addElement('Select', 'friend_sugg_level', array(
		'label' => 'Max Connection Level for Friend Suggestions',
		'description' => 'Select the maximum connection level till which friend suggestions should be shown to users. (Note: Increasing the connection level also increases resource utilization for computing friend suggestions.)',
		'multiOptions' => array(
			2 => '2',
			3 => '3',
			4 => '4',
			5 => '5'
		),
		'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('friend.sugg.level', 3)
	));

	$this->addElement('Radio', 'friend_sugg_mod', array(
		'label' => 'Quality of Suggestions',
		'description' => 'Select the quality of suggestions of this suggestion type that should be shown to users. (Note: A higher quality of suggestion uses a better algorithm for computing suggestions and therefore accordingly, also uses more computation resources.)',
		'multiOptions' => array(
			2 => 'High',
			0 => 'Good'
		),
		'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('friend.sugg.mod', 0),
	));

	// Adding Settings of "Community Ads".
	$this->addElement('Dummy', 'dummy_genral_settings_title', array('label' => 'Genral Settings'));

	$this->addElement('Radio', 'friend_sugg_link', array(
		'label' => 'Suggest to Friends link',
		'description' => "Do you want to show the 'Suggest to Friends' link to users on their friends' profiles ?",
		'multiOptions' => array(
			1 => 'Yes, show this link.',
			0 => 'No, do not show this link.'
		),
		'value' => $settings->getSetting('friend.sugg.link', $settings->getSetting('friend.pymk.link'))
	));

	$this->addElement('Radio', 'pymk_send_popup', array(
		'label' => 'Suggestions popup after Add as Friend',
		'description' => 'Do you want the suggestions popup to be shown to a user after Adding of a Friend ? [This popup enables the user to suggest the newly added friend to his/her other friends, so that they may also add him/her.]',
		'multiOptions' => array(
			1 => 'Yes, show this suggestions popup.',
			0 => 'No, do not show this suggestions popup.'
		),
		'value' => $settings->getSetting('pymk.send.popup')
	));

	$this->addElement('Radio', 'pymk_accept_popup', array(
		'label' => 'Suggestions popup after Accepting a Friend Request',
		'description' => 'Do you want the suggestions popup to be shown to a user after Accepting a Friend Request ? [This popup suggests to a user other friends of the added friend, and allows the user to add them as a friend.]',
		'multiOptions' => array(
			1 => 'Yes, show this suggestions popup.',
			0 => 'No, do not show this suggestions popup.'
		),
		'value' => $settings->getSetting('pymk.accept.popup')
	));

	$this->addElement('Button', 'submit', array(
		'label' => 'Save Settings',
		'type' => 'submit',
		'ignore' => true
	));
  }

}
?>