<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions 
 * @package    Peopleyoumayknow
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 2010-08-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Peopleyoumayknow_Plugin_Core
{
  public function onUserDeleteBefore($event)
  {
  	$payload = $event->getPayload();
		$user_id = $payload['user_id'];// User id which are delete self or by admin.
		// Delete from "suggestions" table.
		$suggestion_table = Engine_Api::_()->getItemTable('suggestion');
		$suggestion_name = $suggestion_table->info('name');
		// Delete all suggestion which user have. 
		$sugg_select_owner = $suggestion_table->select()
			->from($suggestion_name, array('suggestion_id'))
			->where('owner_id = ?', $user_id);
		$sugg_owner = $sugg_select_owner->query()->fetchAll();
		// User does not have any suggestion.
		if(empty($sugg_owner))
		{
			$sugg_owner = array(0);
		}
		// Delete all suggestion which user sent.
		$sugg_select_sender = $suggestion_table->select()
			->from($suggestion_name, array('suggestion_id'))
			->where('sender_id = ?', $user_id);
		$sugg_sender = $sugg_select_sender->query()->fetchAll();
		// If user does not send any suggestion.
		if(empty($sugg_sender))
		{
			$sugg_sender = array(0);
		}
		$sugg_id_array = (array_merge($sugg_owner, $sugg_sender));
		// Delete one by one all entry which user sent or recieved.
		foreach($sugg_id_array as $row_suggestion)
		{
			// Value would be 0 if no data return.
			if($row_suggestion != 0)
			{
				$sugg_table_select = Engine_Api::_()->getItem('suggestion', $row_suggestion['suggestion_id']);
				if($sugg_table_select->entity == 'photo') 
				{
					// Delete from "Suggestion_Album" table.
					Engine_Api::_()->getItem('suggestion_album', $sugg_table_select->suggestion_id)->delete();
					// Delete from "Suggestion" table.
					Engine_Api::_()->getItem('suggestion', $sugg_table_select->suggestion_id)->delete();
					// Delete from "Notification_Activity" table.
					Engine_Api::_()->getDbtable('notifications', 'activity')->delete(array('object_id = ?' => $sugg_table_select->suggestion_id, 'object_type = ?' => 'suggestion'));
				}
				else {
					// Delete from "Suggestion" table.
					Engine_Api::_()->getItem('suggestion', $sugg_table_select->suggestion_id)->delete();
					// Delete from "Notification_Activity" table.
					Engine_Api::_()->getDbtable('notifications', 'activity')->delete(array('object_id = ?' => $sugg_table_select->suggestion_id, 'object_type = ?' => 'suggestion'));
				}
			}
		}
		
		// Delete all entry from "suggestion_rejected" table.
		$reject_table = Engine_Api::_()->getItemTable('rejected');
		$reject_name = $reject_table->info('name');
		$select_reject = $reject_table->select()
			->from($reject_name, array('rejected_id'))
			->where('owner_id = ?', $user_id);
		$sugg_reject = $select_reject->query()->fetchAll();
		if(!empty($sugg_reject))
		{
			foreach ($sugg_reject as $row_reject)
			{				
				Engine_Api::_()->getItem('rejected', $row_reject['rejected_id'])->delete();
			}
		}
  }
}