<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions 
 * @package    Peopleyoumayknow
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Menus.php 2010-08-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Peopleyoumayknow_Plugin_Menus {

  public function onMenuInitialize_PeopleyoumayknowHome($row) {
    $show_link = Engine_Api::_()->getApi('Invite', 'Seaocore')->canInvite();
    if (empty($show_link))
      return;
    $viewer = Engine_Api::_()->user()->getViewer();
    $user_id = Engine_Api::_()->user()->getViewer()->getIdentity();
    if ($viewer->getIdentity()) {
      return array(
          'label' => $row->label,
          'icon' => $row->params['icon'],
          'route' => 'peopleyoumayknow_friend_viewall'
      );
    }
    return false;
  }

  public function onMenuInitialize_PeopleyoumayknowProfile($row) {
    $show_link = Engine_Api::_()->getApi('Invite', 'Seaocore')->canInvite();
    if (empty($show_link))
      return;
    $viewer = Engine_Api::_()->user()->getViewer();
    $subject = Engine_Api::_()->core()->getSubject();
    if ($subject->authorization()->isAllowed($viewer, 'edit')) {
      return array(
          'label' => $row->label,
          'icon' => $row->params['icon'],
          'route' => 'peopleyoumayknow_friend_viewall'
      );
    }
  }

  // SHOWING LINK ON "MEMBER PROFILE PAGE".
  public function onMenuInitialize_MemberPymkFriend($row) {
	$settings = Engine_Api::_()->getApi('settings', 'core');
	$sugg_check = $settings->getSetting('friend.sugg.link', $settings->getSetting('friend.pymk.link'));
	if (!empty($sugg_check)) {
	  $viewer = Engine_Api::_()->user()->getViewer();
	  $subject = Engine_Api::_()->core()->getSubject();
	  $isMember = Engine_Api::_()->getApi('coreFun', 'peopleyoumayknow')->isMember($subject->getIdentity());
	  $user = Engine_Api::_()->getItem('user', $viewer->getIdentity());
	  if ($subject->membership()->isMember($user)) {
		// If "Loggden user" have only one friend and loggden user viewing his friend profile the "Suggest to Friend" link should not be show.
		if (empty($viewer->member_count) || (($viewer->member_count < 2) && !empty($isMember))) {
		  return;
		}
		return array(
			'label' => $row->label,
			'class' => 'smoothbox',
			'icon' => $row->params['icon'],
			'route' => 'default',
			'params' => array(
				'module' => 'peopleyoumayknow',
				'controller' => 'index',
				'action' => 'switch-popup',
				'modName' => 'friend',
				'modContentId' => $subject->getIdentity(),
				'modError' => 1,
				'format' => 'smoothbox',
			),
		);
	  }
	}
  }

}