<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitepage
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Menus.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Peopleyoumayknow_Plugin_Sitemobile {

    protected $_pagesTable;
    protected $_contentTable;

    //DELETE USERS BELONGINGS BEFORE THAT USER DELETION
    public function onRenderLayoutMobileSMDefault($event) {
        $view = $event->getPayload();
        if (!($view instanceof Zend_View_Interface)) {
            return;
        }
        $view->headScriptSM()
                ->appendFile($view->layout()->staticBaseUrl . 'application/modules/Peopleyoumayknow/externals/scripts/friends_mobile.js');
    }

    public function onIntegrated() {

        $this->_pagesTable = Engine_Api::_()->getApi('modules', 'sitemobile')->_pagesTable;
        $this->_contentTable = Engine_Api::_()->getApi('modules', 'sitemobile')->_contentTable;
        //Suggestion page
        $this->addPymkHomeContent();
        $this->addPymkSeeAllPage();
    }

    public function addPymkHomeContent() {
        // install content areas

        $db = Engine_Db_Table::getDefaultAdapter();
        $select = new Zend_Db_Select($db);

        // profile page
        $select
                ->from($this->_pagesTable)
                ->where('name = ?', 'user_index_home')
                ->limit(1);
        $page_id = $select->query()->fetchObject()->page_id;

        // Check if it's already been placed
        $select = new Zend_Db_Select($db);
        $select
                ->from($this->_contentTable)
                ->where('page_id = ?', $page_id)
                ->where('type = ?', 'widget')
                ->where('name = ?', 'Peopleyoumayknow.suggestion-friend')
        ;
        $info = $select->query()->fetch();

        if (empty($info)) {

            // container_id (will always be there)
            $select = new Zend_Db_Select($db);
            $select
                    ->from($this->_contentTable)
                    ->where('page_id = ?', $page_id)
                    ->where('type = ?', 'container')
                    ->limit(1);
            $container_id = $select->query()->fetchObject()->content_id;

            // middle_id (will always be there)
            $select = new Zend_Db_Select($db);
            $select
                    ->from($this->_contentTable)
                    ->where('parent_content_id = ?', $container_id)
                    ->where('type = ?', 'container')
                    ->where('name = ?', 'middle')
                    ->limit(1);
            $middle_id = $select->query()->fetchObject()->content_id;

            $db->insert($this->_contentTable, array(
                'page_id' => $page_id,
                'type' => 'widget',
                'name' => 'Peopleyoumayknow.suggestion-friend',
                'parent_content_id' => $middle_id,
                'order' => 4,
                'params' => '{"title":"People you may know","getWidLimit":"3","friendMaxLimit":"100","suggestionView":"grid","carouselView":"1"}',
                'module' => 'peopleyoumayknow'
            ));
        }
    }

    public function addPymkSeeAllPage() {
        $db = Engine_Db_Table::getDefaultAdapter();

        $page_id = Engine_Api::_()->getApi('modules', 'sitemobile')->getPageId('peopleyoumayknow_index_index');
        // insert if it doesn't exist yet
        if (!$page_id) {
            // Insert page
            $db->insert($this->_pagesTable, array(
                'name' => 'peopleyoumayknow_index_index',
                'displayname' => 'People You May Know - See All Page',
                'title' => 'People You May Know See All Page',
                'description' => 'This page displays the list of all suggestions.',
                'custom' => 0,
            ));
            $page_id = $db->lastInsertId();

            // Insert main
            $db->insert($this->_contentTable, array(
                'type' => 'container',
                'name' => 'main',
                'page_id' => $page_id,
                'order' => 1,
            ));
            $main_id = $db->lastInsertId();

            // Insert main-middle
            $db->insert($this->_contentTable, array(
                'type' => 'container',
                'name' => 'middle',
                'page_id' => $page_id,
                'parent_content_id' => $main_id,
            ));
            $main_middle_id = $db->lastInsertId();

            // Insert Advance search
            $db->insert($this->_contentTable, array(
                'type' => 'widget',
                'name' => 'sitemobile.sitemobile-advancedsearch',
                'page_id' => $page_id,
                'parent_content_id' => $main_middle_id,
                'params' => '{"search":"2","title":"","nomobile":"0","name":"sitemobile.sitemobile-advancedsearch"}',
                'order' => 1,
                'module' => 'sitemobile'
            ));

            // Insert content
            $db->insert($this->_contentTable, array(
                'type' => 'widget',
                'name' => 'core.content',
                'page_id' => $page_id,
                'parent_content_id' => $main_middle_id,
                'order' => 2,
            ));
        }
    }

}
