<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions 
 * @package    Peopleyoumayknow
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 2010-08-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Peopleyoumayknow_Installer extends Engine_Package_Installer_Module {

  function onPreInstall() {
	$PRODUCT_TYPE = 'peopleyoumayknow';
	$PLUGIN_TITLE = 'Peopleyoumayknow';
	$PLUGIN_VERSION = '5.4.1';
	$PLUGIN_CATEGORY = 'plugin';
	$PRODUCT_DESCRIPTION = 'Peopleyoumayknow';
	$_PRODUCT_FINAL_FILE = 'license3.php';
	$_BASE_FILE_NAME = 'peopleyoumayknownew';
	$PRODUCT_TITLE = 'Peopleyoumayknownew Plugin';
	$SocialEngineAddOns_version = '4.8.5';
	$file_path = APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/ilicense.php";
	$is_file = file_exists($file_path);
	if (empty($is_file)) {
	  include_once APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/license4.php";
	} else {
	  if (!empty($_PRODUCT_FINAL_FILE)) {
		include_once APPLICATION_PATH . '/application/modules/' . $PLUGIN_TITLE . '/controllers/license/' . $_PRODUCT_FINAL_FILE;
	  }
	  $db = $this->getDb();
	  $select = new Zend_Db_Select($db);
	  $select->from('engine4_core_modules')->where('name = ?', $PRODUCT_TYPE);
	  $is_Mod = $select->query()->fetchObject();
	  if( empty($is_Mod) ) {
	    include_once $file_path;
	  }
	}
	parent::onPreInstall();
  }

  function onInstall() {
	$db = $this->getDb();
  
  
    // ADD INDEXING IN engine4_suggestion_rejected Table
    $table = $db->query('SHOW TABLES LIKE \'engine4_suggestion_rejected\'')->fetch();
    if (!empty($table)) {
			$getIndex = $db->query("SHOW INDEX FROM `engine4_suggestion_rejected` WHERE Key_name = 'entity'")->fetch();
			if (empty($getIndex)) {
				$db->query("ALTER TABLE `engine4_suggestion_rejected` ADD INDEX ( `entity` , `entity_id` )");
			}
    }
    
    // ADD INDEXING IN engine4_suggestion_rejected Table
    $table = $db->query('SHOW TABLES LIKE \'engine4_suggestion_rejected\'')->fetch();
    if (!empty($table)) {
			$getIndex = $db->query("SHOW INDEX FROM `engine4_suggestion_rejected` WHERE Key_name = 'owner_id'")->fetch();
			if (empty($getIndex)) {
				$db->query("ALTER TABLE `engine4_suggestion_rejected` ADD INDEX ( `owner_id` )");
			}
    }
    
    // ADD INDEXING IN engine4_suggestion_suggestions Table
    $table = $db->query('SHOW TABLES LIKE \'engine4_suggestion_suggestions\'')->fetch();
    if (!empty($table)) {
			$getIndex = $db->query("SHOW INDEX FROM `engine4_suggestion_suggestions` WHERE Key_name = 'owner_id'")->fetch();
			if (empty($getIndex)) {
				$db->query("ALTER TABLE `engine4_suggestion_suggestions` ADD INDEX (`owner_id`)");
			}
    }
    
    // ADD INDEXING IN engine4_suggestion_suggestions Table
    $table = $db->query('SHOW TABLES LIKE \'engine4_suggestion_suggestions\'')->fetch();
    if (!empty($table)) {
			$getIndex = $db->query("SHOW INDEX FROM `engine4_suggestion_suggestions` WHERE Key_name = 'entity'")->fetch();
			if (empty($getIndex)) {
				$db->query("ALTER TABLE `engine4_suggestion_suggestions` ADD INDEX ( `entity` , `entity_id` )");
			}
    }

	$select = new Zend_Db_Select($db);
	$select
			->from('engine4_core_settings',array('value'))
            ->where('name = ?', 'suggestion.show.webmail');
    $inviteModules = $select->query()->fetchColumn();
	if (!empty($inviteModules)) {
      $webmail_values = unserialize($inviteModules);
      //IF FACEBOOK_MAIL DOES NOT EXIST IN TABLE THEN INSERT THIS 
      if (!in_array('facebook_mail', $webmail_values)) {
          $webmail_values[] = 'facebook_mail';
      }
      //IF WINDOWLIVE_MAIL DOES NOT EXIST IN TABLE THEN INSERT THIS  
      if (!in_array('linkedin_mail', $webmail_values)) {
          $webmail_values[] = 'linkedin_mail';
      }
      
       //IF TWITTER MAIL DOES NOT EXIST IN TABLE THEN INSERT THIS  
      if (!in_array('twitter_mail', $webmail_values)) {
          $webmail_values[] = 'twitter_mail';
      }    
      $webmail_values = serialize($webmail_values);
      
      $db->query("UPDATE `engine4_core_settings` SET `value` = '$webmail_values' WHERE `engine4_core_settings`.`name` = 'suggestion.show.webmail' LIMIT 1;");
    }
    else {
  
      $db->query('INSERT IGNORE INTO `engine4_core_settings` (`name`, `value`) VALUES
        ("suggestion.show.webmail", \'a:7:{i:0;s:5:"gmail";i:1;s:5:"yahoo";i:2;s:11:"window_mail";i:3;s:3:"aol";i:4;s:13:"facebook_mail";i:5;s:13:"linkedin_mail";i:6;s:12:"twitter_mail";}\'),
        ("suggestion.friend.select", 1),
        ("suggestion.friend.notify", 1),
        ("suggestion.people.info", 1);'
      );
    }
    
    //MAKING A COLOMN IN THE INVITE TABLE
    
    $type_array = $db->query("SHOW COLUMNS FROM `engine4_invites` LIKE 'social_profileid'")->fetch();
    if (empty($type_array)) {
      $run_query = $db->query("ALTER TABLE `engine4_invites` ADD `social_profileid` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL AFTER `new_user_id` ");
    }

	// Check in module table that "suggestion" plugin should be disable.
	$select = new Zend_Db_Select($db);
	$select
			->from('engine4_core_modules')
			->where('name = ?', 'suggestion')
			->where('enabled = ?', '1');
	$page_id_temp = $select->query()->fetchObject();
	if (!empty($page_id_temp)) {
	  $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();
	  return $this->_error('<span style="color:red">Note: You already have the "Suggestions / Recommendations" module/plugin installed on your site. Please disable the "Suggestions / Recommendations" module/plugin and then install this plugin.</span><br/> <a href="' . $base_url . '/manage">Click here</a> to go Manage Packages.');
	}

	  // Update "friend_suggestion" notification type.
	  $select = new Zend_Db_Select($db);
	  $select
			  ->from('engine4_activity_notificationtypes')
			  ->where('type = ?', 'friend_suggestion');
	  $page_id_temp = $select->query()->fetchObject();
	  if (!empty($page_id_temp)) {
		$db->update('engine4_activity_notificationtypes', array(
			'module' => 'peopleyoumayknow',
			'handler' => 'peopleyoumayknow.widget.sugg'
				), array('type =?' => 'friend_suggestion'));
	  }

	  // Update "friend_request" notification type.
	  $select = new Zend_Db_Select($db);
	  $select
			  ->from('engine4_activity_notificationtypes')
			  ->where('type = ?', 'friend_request');
	  $page_id_temp = $select->query()->fetchObject();
	  if (!empty($page_id_temp)) {
		$db->update('engine4_activity_notificationtypes', array(
			'handler' => 'peopleyoumayknow.widget.friend'
				), array('type =?' => 'friend_request'));
	  }

	  // Update "friend_request" notification type.
	  $select = new Zend_Db_Select($db);
	  $select
			  ->from('engine4_activity_notificationtypes')
			  ->where('type = ?', 'friend_follow_request');
	  $page_id_temp = $select->query()->fetchObject();
	  if (!empty($page_id_temp)) {
		$db->update('engine4_activity_notificationtypes', array(
			'handler' => 'peopleyoumayknow.widget.friend'
				), array('type =?' => 'friend_follow_request'));
	  }

	  $select = new Zend_Db_Select($db);
	  $select
			  ->from('engine4_core_mailtemplates')
			  ->where('type = ?', 'notify_friend_suggestion');
	  $page_id_temp = $select->query()->fetchObject();
	  if (empty($page_id_temp)) {
		$db->insert('engine4_core_mailtemplates', array(
			'type' => 'notify_friend_suggestion',
			'module' => 'peopleyoumayknow',
			'vars' => '[suggestion_sender], [suggestion_entity], [email], [link]',
		));
	  } else {
		$db->update('engine4_core_mailtemplates', array('vars' => '[suggestion_sender], [suggestion_entity], [email], [link]', 'module' => 'peopleyoumayknow'), array('type =?' => 'notify_friend_suggestion'));
	  }

	$db->query("UPDATE  `engine4_seaocores` SET  `is_activate` =  '1' WHERE  `engine4_seaocores`.`module_name` ='peopleyoumayknow';");

	parent::onInstall();
  }

  function onDisable() {
	$db = $this->getDb();
	$db->delete('engine4_suggestion_suggestions');
	$db->delete('engine4_activity_notifications', array('object_type = ?' => 'suggestion'));

	$db->update('engine4_activity_notificationtypes', array(
		'handler' => 'user.friends.request-friend'
			), array('type =?' => 'friend_request'));

	$db->update('engine4_activity_notificationtypes', array(
		'handler' => 'user.friends.request-follow'
			), array('type =?' => 'friend_follow_request'));

	$db->delete('engine4_user_signup', array('class = ?' => 'Peopleyoumayknow_Plugin_Signup_Invite'));
	parent::onDisable();
  }

  function onEnable() {
	$db = $this->getDb();

	$select = new Zend_Db_Select($db);
	$select
			->from('engine4_core_settings')
			->where('name = ?', 'peopleyoumayknow.signup.invite');
	$page_id_temp = $select->query()->fetchObject()->value;
  
  $isQueryExist = $db->query("SELECT * FROM `engine4_user_signup` WHERE `class` LIKE 'Peopleyoumayknow_Plugin_Signup_Invite' LIMIT 1")->fetch();
  if(empty($isQueryExist)){
    $db->query('INSERT INTO `engine4_user_signup` (`class`, `order`, `enable`)VALUES 
      ("Peopleyoumayknow_Plugin_Signup_Invite", "5", "' . $page_id_temp . '");
    ');
  }

	// Check that "Suggestion" plugin should be disable..
	$select = new Zend_Db_Select($db);
	$select
			->from('engine4_core_modules')
			->where('name = ?', 'suggestion')
			->where('enabled =?', 1);
	$page_id_temp = $select->query()->fetchObject();
	if (!empty($page_id_temp)) {
	  $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();
	  echo '<span style="color:red">Note: You already have the "Suggestion" module/plugin enabled. Please disable the "Suggestion" module/plugin before enable this plugin.</span> <br/> <a href="' . $base_url . '/manage">Click here</a> to go Manage Packages.';
	  die;
	} else {

	  // Update "friend_suggestion" notification type.
	  $select = new Zend_Db_Select($db);
	  $select
			  ->from('engine4_activity_notificationtypes')
			  ->where('type = ?', 'friend_suggestion');
	  $page_id_temp = $select->query()->fetchObject();
	  if (!empty($page_id_temp)) {
		$db->update('engine4_activity_notificationtypes', array(
			'module' => 'peopleyoumayknow',
			'handler' => 'peopleyoumayknow.widget.sugg'
				), array('type =?' => 'friend_suggestion'));
	  }

	  // Update "friend_request" notification type.
	  $select = new Zend_Db_Select($db);
	  $select
			  ->from('engine4_activity_notificationtypes')
			  ->where('type = ?', 'friend_request');
	  $page_id_temp = $select->query()->fetchObject();
	  if (!empty($page_id_temp)) {
		$db->update('engine4_activity_notificationtypes', array(
			'handler' => 'peopleyoumayknow.widget.friend'
				), array('type =?' => 'friend_request'));
	  }

	  // Update "friend_request" notification type.
	  $select = new Zend_Db_Select($db);
	  $select
			  ->from('engine4_activity_notificationtypes')
			  ->where('type = ?', 'friend_follow_request');
	  $page_id_temp = $select->query()->fetchObject();
	  if (!empty($page_id_temp)) {
		$db->update('engine4_activity_notificationtypes', array(
			'handler' => 'peopleyoumayknow.widget.friend'
				), array('type =?' => 'friend_follow_request'));
	  }

	  $select = new Zend_Db_Select($db);
	  $select
			  ->from('engine4_core_mailtemplates')
			  ->where('type = ?', 'notify_friend_suggestion');
	  $page_id_temp = $select->query()->fetchObject();
	  if (empty($page_id_temp)) {
		$db->insert('engine4_core_mailtemplates', array(
			'type' => 'notify_friend_suggestion',
			'module' => 'peopleyoumayknow',
			'vars' => '[suggestion_sender], [suggestion_entity], [email], [link]',
		));
	  } else {
		$db->update('engine4_core_mailtemplates', array('vars' => '[suggestion_sender], [suggestion_entity], [email], [link]', 'module' => 'peopleyoumayknow'), array('type =?' => 'notify_friend_suggestion'));
	  }
	}
	parent::onEnable();
  }

  //SITEMOBILE CODE TO CALL MY.SQL ON POST INSTALL
    public function onPostInstall() {
        $moduleName = 'peopleyoumayknow';
        $db = $this->getDb();
        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_modules')
                ->where('name = ?', 'sitemobile')
                ->where('enabled = ?', 1);
        $is_sitemobile_object = $select->query()->fetchObject();
        if (!empty($is_sitemobile_object)) {
            $db->query("INSERT IGNORE INTO `engine4_sitemobile_modules` (`name`, `visibility`) VALUES
('$moduleName','1')");
            $select = new Zend_Db_Select($db);
            $select
                    ->from('engine4_sitemobile_modules')
                    ->where('name = ?', $moduleName)
                    ->where('integrated = ?', 0);
            $is_sitemobile_object = $select->query()->fetchObject();
            if ($is_sitemobile_object) {
                $actionName = Zend_Controller_Front::getInstance()->getRequest()->getActionName();
                $controllerName = Zend_Controller_Front::getInstance()->getRequest()->getControllerName();
                if ($controllerName == 'manage' && $actionName == 'install') {
                    $view = new Zend_View();
                    $baseUrl = (!empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
                    $redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
                    $redirector->gotoUrl($baseUrl . 'admin/sitemobile/module/enable-mobile/enable_mobile/1/name/' . $moduleName . '/integrated/0/redirect/install');
                }
            }
        }
    }
}
?>