<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    PrimeMessenger
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    Block.php 2017-06-12 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

 require_once APPLICATION_PATH . '/application/libraries/prime-messenger-client/vendor/autoload.php';
use PrimeMessenger\Primemessenger\Client;

class Primemessenger_Controller_Action_Helper_PrimeMessengers extends Zend_Controller_Action_Helper_Abstract
{

	function preDispatch()
	{
		// Intialize PrimeMessenger client
        Client::$apiKey = Engine_Api::_()->getApi('settings', 'core')->getSetting('primemessenger.apikey');
        Client::$subdomain = Engine_Api::_()->getApi('settings', 'core')->getSetting('primemessenger.subdomain');

        // Overwrite Memebership and Block classes
        $isPrimeMessengerActive = Engine_Api::_()->primemessenger()->isPrimeMessengerActive();
        $isPrimeMessengerMigrated = Engine_Api::_()->primemessenger()->hasMigrated();

        if (!$isPrimeMessengerActive && !$isPrimeMessengerMigrated) {
            return;
        }

        $loader = Engine_Loader::getInstance();
        $membershipClassName = 'Primemessenger_Model_DbTable_Membership';
        $blockClassName = 'Primemessenger_Model_DbTable_Block';
        $conversationsClassName = 'Primemessenger_Model_DbTable_Conversations';
        $notificationsClassName = 'Primemessenger_Model_DbTable_Notifications';
        Engine_Loader::loadClass($membershipClassName);
        Engine_Loader::loadClass($blockClassName);
        Engine_Loader::loadClass($conversationsClassName);
        Engine_Loader::loadClass($notificationsClassName);
        if (method_exists($loader, 'setComponent')) {
            $loader->setComponent('User_Model_DbTable_Membership', new $membershipClassName());
            $loader->setComponent('User_Model_DbTable_Block', new $blockClassName());
            $loader->setComponent('Messages_Model_DbTable_Conversations', new $conversationsClassName());
            $loader->setComponent('Activity_Model_DbTable_Notifications', new $notificationsClassName());
        }
	}
}