<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    PrimeMessenger
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    Block.php 2017-06-12 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
use PrimeMessenger\Primemessenger\User;

class Primemessenger_Model_DbTable_Block extends User_Model_DbTable_Block {

    protected $_name = 'user_block';

    /**
     * Inserts a new row.
     *
     * @param  array  $data  Column-value pairs.
     * @return mixed         The primary key of the row inserted.
     */
    public function insert(array $data) {
        $response = parent::insert($data);

        // Block user in PrimeMessenger as well
        try {
            $user = new User($data['user_id']);
            $user->blockUsers(["userId" => (string) $data['blocked_user_id']]);
        } catch (Exception $e) {
        }

        return $response;
    }

    /**
     * Deletes existing rows.
     *
     * @param  array|string $where SQL WHERE clause(s).
     * @return int          The number of rows deleted.
     */
    public function delete($where) {
        $response = parent::delete($where);

        // Unblock users in PrimeMessenger as well
        try {
            $user = new User($where['user_id = ?']);
            $user->unblockUsers(["userId" => (string) $where['blocked_user_id = ?']]);
        } catch (Exception $e) {
        }

        return $response;
    }
}
