<?php

/**
 * SocialEngine
 *
 * @category   Application_Core
 * @package    PrimeMessenger
 * @copyright  Copyright 2017-2018 Webligo Developments
 * @license    http://www.socialengine.com/license/
 * @version    $Id: Membership.php 10088 2017-06-12 13:34:37Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
use PrimeMessenger\Primemessenger\User;

class Primemessenger_Model_DbTable_Membership extends User_Model_DbTable_Membership {

    protected $_name = 'user_membership';

    public function removeMember(Core_Model_Item_Abstract $resource, User_Model_User $user) {
        parent::removeMember($resource, $user);
        $userId = $user->user_id;

        // Remove membership in PrimeMessenger as well
        try {
            $user = new User($user->user_id);
            $user->removeFriend(["userId" => (string) $resource->user_id]);
        } catch (Exception $e) {
        }

        return $this;
    }

    public function setResourceApproved(Core_Model_Item_Abstract $resource, User_Model_User $user) {
        parent::setResourceApproved($resource, $user);
        
        $username = $user->getTitle();
        // Add membership in PrimeMessenger as well
        $userId = $user->user_id;
        try {
            $user = new User($user->user_id);
            $user->addFriend(["userId" => (string) $resource->user_id]);
        } catch (Exception $e) {
        }
        
        return $this;
    }

    public function removeAllUserFriendship(User_Model_User $user) {
        parent::removeAllUserFriendship($user);
  }

}
