<?php

/**
 * SocialEngine
 *
 * @category   Application_Core
 * @package    PrimeMessenger
 * @copyright  Copyright 2017-2018 Webligo Developments
 * @license    http://www.socialengine.com/license/
 * @version    $Id: Notifications.php 10088 2017-06-12 13:34:37Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Primemessenger_Model_DbTable_Notifications extends Activity_Model_DbTable_Notifications
{
  protected $_name = 'activity_notifications';

  /**
   * Add a notification
   *
   * @param User_Model_User $user The user to receive the notification
   * @param Core_Model_Item_Abstract $subject The item responsible for causing the notification
   * @param Core_Model_Item_Abstract $object Bleh
   * @param string $type
   * @param array $params
   * @return Activity_Model_Notification
   */
  public function addNotification(User_Model_User $user, Core_Model_Item_Abstract $subject,
          Core_Model_Item_Abstract $object, $type, array $params = null)
  {
    if ($type == 'message_new') {
      return;
    }
    return parent::addNotification($user, $subject, $object, $type, $params);
  }
}
