<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Primemessenger
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    AdminSettingsController.php 2017-06-30 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class PrimeMessenger_TokenController extends Core_Controller_Action_Standard {

    public function init() {

    }

    public function indexAction() {

    }

    public function verifyAction() {
        if( !$this->getRequest()->isPost() )
        {
            $this->respondWithError(405,"Method Not Allowed");
        }
        
        $reqParams = $this->getRequest()->getPost();

        if(!$reqParams['token']){
            $this->respondWithError(400,"token is required");
        }
        if(!$reqParams['userId']){
            $this->respondWithError(400,"userId is required");
        }
        
        $token = Engine_Api::_()->getDbTable('ClientServerTokens','primemessenger')->getByUserId($reqParams['token'],$reqParams['userId']);
        
        if($token){
           Engine_Api::_()->getDbTable('ClientServerTokens','primemessenger')->deleteToken($token['token'],$token['user_id']);
            $this->respondWithSuccess($token);
        }
        else{
            $this->respondWithError(401,"Unauthorized");
        }
    }
    
    public function sendResponse() {
        ob_clean();
       $data = Zend_Json::encode($this->view);
        $this->getResponse()->setBody($data);
        $this->getResponse()->sendResponse();
        exit;
    }
    
    public function respondWithError($statusCode, $message=null, $type = null) {
        $this->view->status_code = $statusCode;
        $this->view->error = true;
        $this->view->error_code = $statusCode;
        $this->view->message = $message;
        $this->sendResponse();
    }

    public function respondWithSuccess($body) {
        $this->view->status_code = 200;
        if (isset($body)) {
            $this->view->body = $body;
        } else {
            $this->view->body = '';
        }
        $this->sendResponse();
    }
}