<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Primemessenger
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    ChatMessages.php 2017-06-30 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class PrimeMessenger_Migrate_Chat_ChatMessages extends PrimeMessenger_Migrate_DbAbstract {

  protected $_fromTable = 'engine4_chat_messages';
  protected $_warningMessage = array();
  protected $_priority = 900;
  protected $_jsonFileName = 'chat-messages';

  protected function _initPre() {
    $this->_fromTable = $this->getFromPrefix() . 'chat_messages';
  }

  protected function _translateRow(array $data , array &$jsonData) {
    
    if(!$this->isRoomExist($data)){
       return;
    }

    // If Message have no body then not migrate..
    if(!$data['body']){
           return;
    }

    $recipients = $this->getRecieptents($data);
    $newData = array();
    $newData['messageId'] = $data['message_id'];
    $newData['roomId'] = $data['room_id'];
    $newData['body'] = $data['body'];
    $newData['ownerId'] = $data['user_id'];
    $newData['createdAt'] = $data['date'];
    $newData['recipients'] = array_values(array_filter($recipients));
    $newData['attachmentType'] = 'text';
    $newData['attachmentData'] = [];
    $jsonData[] =  $newData;
  }

  public function getRecieptents($data) {
    $recipients = array();
    $levelIds = [1,2];

    $messRecipients = $this->getFromDb()->select()
            ->from($this->getfromPrefix() . 'chat_messages', 'user_id')
            ->where('room_id = (?)', $data['room_id'])
            ->distinct()
            ->query()
            ->fetchAll(Zend_Db::FETCH_COLUMN);

    $adminIds = $this->getFromDb()->select()
                ->from($this->getfromPrefix() . 'users', 'user_id')
                ->where('level_id IN (?)', $levelIds)
                ->order('level_id ASC')
                ->query()
                ->fetchAll(Zend_Db::FETCH_COLUMN);

    $recipients = array_unique(array_merge($adminIds, $messRecipients));
    return $recipients;
  }

  public function isRoomExist($data) {
    $roomId = $this->getFromDb()->select()
            ->from($this->getfromPrefix() . 'chat_rooms', 'room_id')
            ->where('room_id = (?)', $data['room_id'])
            ->query()
            ->fetchColumn();
    $isRoomExist = $roomId ? true : false;
    return $isRoomExist;
  }
}
