<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Primemessenger
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    CometChatRooms.php 2017-06-30 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class PrimeMessenger_Migrate_CometChat_CometChatRooms extends PrimeMessenger_Migrate_DbAbstract {

    protected $_fromTable = 'cometchat';
    protected $_warningMessage = array();
    protected $_priority = 600;
    protected $_jsonFileName = 'chat-rooms';
    protected $_initialRoomId = null;
    protected $_nextRoomId = null;
    protected $_prevdata = [];

    protected function _initPre() {
        $this->_fromTable = 'cometchat';
        $this->_initialRoomId = $this->getFromDb()->select()
                ->from('cometchat_chatrooms', 'id')
                ->order('id DESC')
                ->query()
                ->fetchColumn()+1;
        
    }

    protected function _translateRow(array $data, array &$jsonData) {
        
        $members = array_values(array_filter([$data['to'] , $data['from']]));
        if($this->checkRoomExist($members)){
            return; 
        }
        
        $this->_nextRoomId = !$this->_nextRoomId ? $this->_initialRoomId  : $this->_nextRoomId+1;
        $result = $this->getFromDb()->select()
                ->from('cometchat', array('id' ,'sent'))
                ->where('cometchat.from IN (?)', $members)
                ->where('cometchat.to IN (?)', $members)
                ->where("message NOT LIKE ?", '%javascript:jqcc%')
                ->where("message NOT LIKE ?", '%CC^CONTROL%')
                ->where("message NOT LIKE ?", '<img%>')
                ->order('id DESC')
                ->query()
                ->fetchAll();
        
        // $timeZone = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.locale.timezone');
        // date_default_timezone_set("$timeZone");
        
        // Date is everytime updated date due to previous sql
        $updatedAt = date('Y-m-d H:i:s',$result[0]['sent']);
        
        $newData = array();             
        $newData['roomId'] = $this->_nextRoomId;
        $newData['memberCount'] = 2;
        $newData['ownerId'] = $data['from'];
        $newData['resourceType'] = 'user';
        $newData['members'] = $members;
        $newData['createdAt'] = date('Y-m-d H:i:s',$data['sent']);
        $newData['updatedAt'] = $updatedAt;

        $this->setPreviousData($newData);
        $jsonData[] =  $newData;
    }
    
    public function setPreviousData($newData){
       $_prevdata = $this->_prevdata;
       array_push($_prevdata , $newData);
       $this->_prevdata = $_prevdata;
       return $this->_prevdata;
    }
    
   public function getLastChatRoomMessageId(){

      $lastChatRoomsMessageId = $this->getFromDb()->select()
                ->from('cometchat_chatroommessages', 'id')
                ->order('id DESC')
                ->query()
                ->fetchColumn();
      
      $lastChatRoomsMessageId = $lastChatRoomsMessageId ? $lastChatRoomsMessageId : 0;
      return $lastChatRoomsMessageId;
   }
    
   public function checkRoomExist($members){
       $_prevdataContainer = $this->_prevdata;
       foreach($_prevdataContainer as $_prevdata){
         $isRoomExist = $this->array_equal($members , $_prevdata['members']);
         if($isRoomExist){
           return true;
         }
       }
       return false;
   }
   
   public function array_equal($a, $b, $strict=false) {
    if (count($a) !== count($b)) {
        return false;
    }
    sort($a);
    sort($b);
    return ($strict && $a === $b) || $a == $b;
  }

}