<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Recipe
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: ChangePhoto.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Recipe_Form_ChangePhoto extends Engine_Form {

  public function init() {

    //GET RECIPE ID
    $recipe_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('recipe_id', null);

    //GET RECIPE ITEM
    $recipe = Engine_Api::_()->getItem('recipe', $recipe_id);

    $this
            ->setTitle("Edit Recipe's Profile Picture")
            ->setAttrib('enctype', 'multipart/form-data')
            ->setAction(Zend_Controller_Front::getInstance()->getRouter()->assemble(array()))
            ->setAttrib('name', 'EditPhoto');

    $this->addElement('Image', 'current', array(
        'label' => 'Current Photo',
        'ignore' => true,
        'decorators' => array(array('ViewScript', array(
                    'viewScript' => '_formEditImage.tpl',
                    'class' => 'form element',
                    'testing' => 'testing'
            )))
    ));
    Engine_Form::addDefaultDecorators($this->current);

    $this->addElement('File', 'Filedata', array(
        'label' => 'Choose New Photo',
        'destination' => APPLICATION_PATH . '/public/temporary/',
        'validators' => array(
            array('Extension', false, 'jpg,jpeg,png,gif'),
        ),
        'onchange' => 'javascript:uploadPhoto();'
    ));

    $this->addElement('Hidden', 'coordinates', array(
        'filters' => array(
            'HtmlEntities',
        )
    ));

    //GET VIEW
    $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
    $url = $view->url(array('recipe_id' => $recipe_id), 'recipe_removephoto', true);
    $recipe = Engine_Api::_()->getItem('recipe', $recipe_id);
    if ($recipe->photo_id != 0) {

      // Element: done
      $this->addElement('Button', 'remove', array(
	'label' => 'Remove Photo',
	'onclick' => "removePhotoRecipe('$url');",
	'decorators' => array(
	  'ViewHelper',
	),
      ));

      $url = $view->url(array('recipe_id' => $recipe_id,'user_id'=> $recipe->owner_id, 'slug'=> $recipe->getSlug()), 'recipe_entry_view', true);
      
      // Element: skip
      $this->addElement('Cancel', 'cancel', array(
	'label' => 'cancel',
	'prependText' => ' or ',
	'link' => true,
	'onclick' => "removePhotoRecipe('$url');",
	'decorators' => array(
	  'ViewHelper',
	),
      ));

      // DisplayGroup: buttons
      $this->addDisplayGroup(array('remove', 'cancel'), 'buttons', array());
  }
}

}

?>