<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Recipe
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Search.php 6590 2010-12-31 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Recipe_Form_Search extends Fields_Form_Search {

  protected $_fieldType = 'recipe';

  public function init() {
    parent::init();
    $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
    $this->loadDefaultDecorators();

    $this
        ->setAttribs(array(
                'id' => 'filter_form',
                'class' => 'recipes_browse_filters field_search_criteria',
                'method' => 'get'
        ))
        //->setAction($view->url(array('action' => 'index'), 'recipe_general', true))
        ->getDecorator('HtmlTag')
        ->setOption('class', 'browserecipes_criteria recipes_browse_filters');


    // Add custom elements
    $this->getAdditionalOptionsElement();
  }

  public function getAdditionalOptionsElement() {
    $i = -5000;
    $category = Zend_Controller_Front::getInstance()->getRequest()->getParam('category_id', null);
    $subcategory = Zend_Controller_Front::getInstance()->getRequest()->getParam('subcategory_id', null);
    $categoryname = Zend_Controller_Front::getInstance()->getRequest()->getParam('categoryname', null);
    $subcategoryname = Zend_Controller_Front::getInstance()->getRequest()->getParam('subcategoryname', null);
    $this->addElement('Hidden', 'page', array(
            'order' => $i--,
    ));

    $this->addElement('Hidden', 'tag', array(
            'order' => $i--,
    ));

    $this->addElement('Hidden', 'start_date', array(
            'order' => $i--,
    ));

    $this->addElement('Hidden', 'end_date', array(
            'order' => $i--,
    ));
    $this->addElement('Hidden', 'city', array(
            'order' => $i--,
    ));

    $this->addElement('Select', 'orderby', array(
            'label' => 'Browse By',
            'multiOptions' => array(
                    '' => "",
                    'creation_date' => 'Most Recent',
                    'view_count' => 'Most Viewed',
                    'title' => "Alphabatic",
            ),
            'onchange' => 'searchRecipes();',
            'order' => $i--,
            'decorators' => array(
                    'ViewHelper',
                    array('Label', array('tag' => 'span')),
                    array('HtmlTag', array('tag' => 'li'))
            ),
    ));
    $show_multiOptions = array();
    $show_multiOptions["1"] = 'Everyone\'s Posts';
    $show_multiOptions["2"] = 'Only My Friends\' Posts';
    $value_deault = 1;
    $enableNetwork = Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.network', 0);
    if (empty($enableNetwork)) {
      $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
      $networkMembershipTable = Engine_Api::_()->getDbtable('membership', 'network');
      $viewerNetwork = $networkMembershipTable->fetchRow(array('user_id = ?' => $viewer_id));

      if (!empty($viewerNetwork)) {
        $show_multiOptions["3"] = 'Only My Networks';
        $browseDefaulNetwork = Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.default.show', 0);

        if (!isset($_GET['show']) && !empty($browseDefaulNetwork)) {
          $value_deault = 3;
        } elseif (isset($_GET['show'])) {
          $value_deault = $_GET['show'];
        }
      }
    }

    $this->addElement('Select', 'show', array(
            'label' => 'Show',
            'multiOptions' => $show_multiOptions,
            'onchange' => 'searchRecipes();',
            'order' => $i--,
            'decorators' => array(
                    'ViewHelper',
                    array('Label', array('tag' => 'span')),
                    array('HtmlTag', array('tag' => 'li'))
            ),
            'value' => $value_deault,
    ));

    if( $recipe_closeicon = Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.closeicon')) {
    $this->addElement('Select', 'closed', array(
            'label' => 'Status',
            'multiOptions' => array(
                    '' => 'All Recipes',
                    '0' => 'Only Open Recipes',
                    '1' => 'Only Closed Recipes',
            ),
            'onchange' => 'searchRecipes();',
            'order' => $i--,
            'decorators' => array(
                    'ViewHelper',
                    array('Label', array('tag' => 'span')),
                    array('HtmlTag', array('tag' => 'li'))
            ),
    ));

   }
//    $this->addElement('Select', 'category', array(
//            'label' => 'Category',
//            'multiOptions' => array(
//                    '0' => 'All Categories',
//            ),
//            'onchange' => 'searchRecipes();',
//            'order' => $i--,
//            'decorators' => array(
//                    'ViewHelper',
//                    array('Label', array('tag' => 'span')),
//                    array('HtmlTag', array('tag' => 'li'))
//            ),
//    ));



    $this->addElement('Hidden', 'category', array(
            'value' => $category,
            'order' => $i--,
    ));

    $this->addElement('Hidden', 'subcategory', array(
            'value' => $subcategory,
            'order' => $i--,
    ));

    $this->addElement('Hidden', 'categoryname', array(
            'value' => $categoryname,
            'order' => $i--,
    ));

    $this->addElement('Hidden', 'subcategoryname', array(
            'value' => $subcategoryname,
            'order' => $i--,
    ));

    $this->addElement('Text', 'search', array(
            'label' => 'Name / Keyword',
            'order' => $i--,
            'decorators' => array(
                    'ViewHelper',
                    array('Label', array('tag' => 'span')),
                    array('HtmlTag', array('tag' => 'li'))
            ),
    ));

    $recipe_fields = Zend_Registry::get('recipe_fields');
    if (empty($recipe_fields)) {
      exit();
    }

    $enable = Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.proximitysearch', 1);
    if (!empty($enable)) {
      $fields = Engine_Api::_()->getApi('core', 'fields')->getFieldsMeta($this->_fieldType);
      foreach ($fields as $field) {
        if (!$field->search || !$field->alias) {
          continue;
        }

        $key = $field->alias;

        $params = $field->getElementParams($this->_fieldType, array('required' => false));

        if ($field->type == 'location') {
          $flage = Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.proximity.search.kilometer', 0);
          if ($flage) {
            $locationLable = "Within Kilometers";
            $locationOption = array(
                    '0' => '',
                    '1' => '1 Kilometer',
                    '2' => '2 Kilometers',
                    '5' => '5 Kilometers',
                    '10' => '10 Kilometers',
                    '20' => '20 Kilometers',
                    '50' => '50 Kilometers',
                    '100' => '100 Kilometers',
                    '250' => '250 Kilometers',
                    '500' => '500 Kilometers',
                    '750' => '750 Kilometers',
                    '1000' => '1000 Kilometers',
            );
          } else {
            $locationLable = "Within Miles";
            $locationOption = array(
                    '0' => '',
                    '1' => '1 Mile',
                    '2' => '2 Miles',
                    '5' => '5 Miles',
                    '10' => '10 Miles',
                    '20' => '20 Miles',
                    '50' => '50 Miles',
                    '100' => '100 Miles',
                    '250' => '250 Miles',
                    '500' => '500 Miles',
                    '750' => '750 Miles',
                    '1000' => '1000 Miles',
            );
          }
          $this->addElement('Select', 'locationmiles', array(
                  'label' => $locationLable,
                  'multiOptions' => $locationOption,
                  'order' => 9999999,
                  'decorators' => array(
                          'ViewHelper',
                          array('Label', array('tag' => 'span')),
                          array('HtmlTag', array('tag' => 'li'))
                  ),
          ));
        }

        //  $element = $this->getElement($key);
      }
    }
    $this->addElement('Checkbox', 'has_photo', array(
            'label' => 'Only Recipes With Photos',
            'order' => 10000000,
            'decorators' => array(
                    'ViewHelper',
                    array('Label', array('placement' => 'APPEND', 'tag' => 'label')),
                    array('HtmlTag', array('tag' => 'li'))
            ),
    ));

    $this->addElement('Button', 'done', array(
            'label' => 'Search',
            'onclick' => 'searchRecipes();',
            'ignore' => true,
            'order' => 10000001,
            'decorators' => array(
                    'ViewHelper',
                    //array('Label', array('tag' => 'span')),
                    array('HtmlTag', array('tag' => 'li'))
            ),
    ));
  }

}
?>