<?php
 /**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Recipe
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Topic.php 6590 2010-12-31 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Recipe_Model_Topic extends Core_Model_Item_Abstract
{
  protected $_parent_type = 'recipe';

  protected $_owner_type = 'user';

  protected $_children_types = array('recipe_post');
  
  public function getHref($params = array())
  {
    $params = array_merge(array(
      'route' => 'recipe_extended',
      'controller' => 'topic',
      'action' => 'view',
      'recipe_id' => $this->recipe_id,
      'topic_id' => $this->getIdentity(),
    ), $params);
    $route = @$params['route'];
    unset($params['route']);
    return Zend_Controller_Front::getInstance()->getRouter()->assemble($params, $route, true);
  }

  public function getDescription()
  {
    $firstPost = $this->getFirstPost();
    return ( null != $firstPost ? Engine_String::substr($firstPost->body, 0, 255) : '' );
  }
  
  public function getParentRecipe()
  {
    return Engine_Api::_()->getItem('recipe', $this->recipe_id);
  }

  public function getFirstPost()
  {
    $table = Engine_Api::_()->getDbtable('posts', 'recipe');
    $select = $table->select()
										->where('topic_id = ?', $this->getIdentity())
										->order('post_id ASC')
										->limit(1);
    return $table->fetchRow($select);
  }

  public function getLastPost()
  {
    $table = Engine_Api::_()->getItemTable('recipe_post');
    $select = $table->select()
										->where('topic_id = ?', $this->getIdentity())
										->order('post_id DESC')
										->limit(1);

    return $table->fetchRow($select);
  }

  public function getLastPoster()
  {
    return Engine_Api::_()->getItem('user', $this->lastposter_id);
  }

  public function getAuthorizationItem()
  {
    return $this->getParent('recipe');
  }

  // Internal hooks
  protected function _insert()
  {
    if( $this->_disableHooks ) return;
    
    if( !$this->recipe_id )
    {
      throw new Exception('Cannot create topic without recipe_id');
    }

    /*
    $this->getParentGroup()->setFromArray(array(

    ))->save();
    */

    parent::_insert();
  }

  protected function _delete()
  {
    if( $this->_disableHooks ) return;
    
    // Delete all child posts
    $postTable = Engine_Api::_()->getItemTable('recipe_post');
    $postSelect = $postTable->select()->where('topic_id = ?', $this->getIdentity());
    foreach( $postTable->fetchAll($postSelect) as $recipePost ) {
      $recipePost->disableHooks()->delete();
    }
    
    parent::_delete();
  }
}