<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Recipe
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Menus.php 6590 2010-12-31 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Recipe_Plugin_Menus {

  public function canCreateRecipes() {

    // Must be logged in
    $viewer = Engine_Api::_()->user()->getViewer();
    if (!$viewer || !$viewer->getIdentity()) {
      return false;
    }

    // Must be able to create Recipes
    if (!Engine_Api::_()->authorization()->isAllowed('recipe', $viewer, 'create')) {
      return false;
    }
    return true;
  }

  public function canViewRecipes() {
    $check_result_show = Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.check.var');
    $base_result_time = Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.base.time');
    $get_result_show = Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.get.path');
    $recipe_time_var = Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.time.var');
    $controllersettings_result_show = Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.lsettings');
    $currentbase_time = time();
    $controller_result_lenght = strlen($controllersettings_result_show);

    if (($currentbase_time - $base_result_time > $recipe_time_var) && empty($check_result_show)) {
      if ($controller_result_lenght != 20) {
        Engine_Api::_()->getApi('settings', 'core')->setSetting('isrecipe.attempt', 1);
        Engine_Api::_()->getApi('settings', 'core')->setSetting('recipe.flag.info', 1);
        return false;
      } else {
        Engine_Api::_()->getApi('settings', 'core')->setSetting('recipe.check.var', 1);
      }
    }
    $viewer = Engine_Api::_()->user()->getViewer();
    // Must be able to view Recipes
    if (!Engine_Api::_()->authorization()->isAllowed('recipe', $viewer, 'view')) {
      return false;
    }
    return true;
  }

  public function onMenuInitialize_RecipeGutterShare($row) {
    if (!Engine_Api::_()->core()->hasSubject()) {
      return false;
    }
    $viewer = Engine_Api::_()->user()->getViewer();
    $recipe = Engine_Api::_()->core()->getSubject('recipe');

    if (!$recipe->authorization()->isAllowed($viewer, 'edit')) {
      return false;
    }
    // Modify params
    $params = $row->params;
    $params['params']['recipe_id'] = $recipe->getIdentity();
    $params['params']['format'] = 'smoothbox';
    return $params;
  }

  public function onMenuInitialize_RecipeGutterEdit($row) {
    if (!Engine_Api::_()->core()->hasSubject()) {
      return false;
    }

    $viewer = Engine_Api::_()->user()->getViewer();
    $recipe = Engine_Api::_()->core()->getSubject('recipe');

    if (!$recipe->authorization()->isAllowed($viewer, 'edit')) {
      return false;
    }

    // Modify params
    $params = $row->params;
    $params['params']['recipe_id'] = $recipe->getIdentity();
    return $params;
  }

  public function onMenuInitialize_RecipeGutterEditoverview($row) {
    if (!Engine_Api::_()->core()->hasSubject()) {
      return false;
    }

    $viewer = Engine_Api::_()->user()->getViewer();
    $recipe = Engine_Api::_()->core()->getSubject('recipe');

    if (!$recipe->authorization()->isAllowed($viewer, 'edit')) {
      return false;
    }
    
    //Check for member level setings base of Listing Owner.
//     if (!Engine_Api::_()->recipe()->allowOverviewOfOwner($recipe->getOwner())) {
//       return false;
//     }
    
    // Modify params
    $params = $row->params;
    $params['params']['recipe_id'] = $recipe->getIdentity();
    return $params;
  }

  public function onMenuInitialize_RecipeGutterEditstyle($row) {

    if (!Engine_Api::_()->core()->hasSubject()) {
      return false;
    }
    $viewer = Engine_Api::_()->user()->getViewer();
    $recipe = Engine_Api::_()->core()->getSubject('recipe');

    if (!$recipe->authorization()->isAllowed($viewer, 'edit')) {
      return false;
    }
    // Modify params
    $params = $row->params;
    $params['params']['recipe_id'] = $recipe->getIdentity();
    return $params;
  }

  public function onMenuInitialize_RecipeGutterChangephoto($row) {
    if (!Engine_Api::_()->core()->hasSubject()) {
      return false;
    }

    $viewer = Engine_Api::_()->user()->getViewer();
    $recipe = Engine_Api::_()->core()->getSubject('recipe');

    if (!$recipe->authorization()->isAllowed($viewer, 'edit')) {
      return false;
    }

    // Modify params
    $params = $row->params;
    $params['params']['recipe_id'] = $recipe->getIdentity();
    return $params;
  }

}