<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Recipe
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminSettingsController.php 6590 2010-12-31 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Recipe_AdminSettingsController extends Core_Controller_Action_Admin {

  public function indexAction() {

    $mod_form_content = array('recipe_location', 'recipe_report', 'recipe_share', 'recipe_socialshare', 'recipe_rating', 'recipe_printer', 'recipe_tellafriend', 'recipe_captcha_post', 'recipe_proximitysearch', 'recipe_checkcomment_widgets', 'recipe_sponsored_image', 'recipe_sponsored_color', 'recipe_feature_image', 'recipe_featured_color', 'recipe_page', 'recipe_proximity_search_kilometer', 'recipe_title_turncation', 'recipe_requried_description', 'recipe_status_show', 'recipe_title_turncationsponsored', 'submit', "recipe_browseorder","recipe_closeicon","recipe_start_end_month", "recipe_network", "recipe_default_show", "recipe_map_sponsored", "recipe_map_city", "recipe_map_zoom","recipe_code_share", "recipe_description_allow");
    $oldLocation = Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.map.city', "World");
		$this->view->isModsSupport = Engine_Api::_()->recipe()->isModulesSupport();
    
    $pluginName = 'recipe';
    if (!empty($_POST[$pluginName . '_lsettings']))
      $_POST[$pluginName . '_lsettings'] = @trim($_POST[$pluginName . '_lsettings']);
    
    include_once APPLICATION_PATH . '/application/modules/Recipe/controllers/license/license1.php';
    $newLocation = Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.map.city', "World");
    $this->setDefaultMapCenterPoint($oldLocation, $newLocation);
  }

  public function categoriesAction() {

    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
            ->getNavigation('recipe_admin_main', array(), 'recipe_admin_main_categories');

    $this->view->categories = Engine_Api::_()->recipe()->getCategories();
  }

  public function addCategoryAction() {

    // In smoothbox
    $this->_helper->layout->setLayout('admin-simple');

    // Generate and assign form
    $form = $this->view->form = new Recipe_Form_Admin_Category();
    $form->setAction($this->getFrontController()->getRouter()->assemble(array()));

    // Check post
    if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {

      // we will add the category
      $values = $form->getValues();

      $db = Engine_Db_Table::getDefaultAdapter();
      $db->beginTransaction();

      try {
        // add category to the database
        // Transaction
        $table = Engine_Api::_()->getDbtable('categories', 'recipe');

        // insert the recipe category entry into the database
        $row = $table->createRow();
        $row->user_id = 1;
        $row->category_name = $values["label"];
        $row->save();

        // change the category of all the recipes using that category
        $db->commit();
      } catch (Exception $e) {
        $db->rollBack();
        throw $e;
      }
      $this->_forward('success', 'utility', 'core', array(
              'smoothboxClose' => 10,
              'parentRefresh' => 10,
              'messages' => array('')
      ));
    }

    // Output
    $this->renderScript('admin-settings/form.tpl');
  }

  public function deleteCategoryAction() {

    // In smoothbox
    $this->_helper->layout->setLayout('admin-simple');
    $id = $this->_getParam('id');
    $this->view->recipe_id = $id;

    // Check post
    if ($this->getRequest()->isPost()) {

      $db = Engine_Db_Table::getDefaultAdapter();
      $db->beginTransaction();

      try {
        // go through logs and see which recipe used this category and set it to ZERO
        $recipeTable = Engine_Api::_()->getDbtable('recipes', 'recipe');
        $select = $recipeTable->select()->where('category_id = ?', $id);
        $recipes = $recipeTable->fetchAll($select);

        // create permissions
        foreach ($recipes as $recipe) {

          //this is not working
          $recipe->category_id = 0;
          $recipe->save();
        }
        $row = Engine_Api::_()->recipe()->getCategory($id);

        // delete the recipe category in the database
        $row->delete();

        $db->commit();
      } catch (Exception $e) {
        $db->rollBack();
        throw $e;
      }
      $this->_forward('success', 'utility', 'core', array(
              'smoothboxClose' => 10,
              'parentRefresh' => 10,
              'messages' => array('')
      ));
    }

    // Output
    $this->renderScript('admin-settings/delete.tpl');
  }

  public function editCategoryAction() {

    // In smoothbox
    $this->_helper->layout->setLayout('admin-simple');
    $form = $this->view->form = new Recipe_Form_Admin_Category();
    $form->setAction($this->getFrontController()->getRouter()->assemble(array()));

    // Check post
    if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {

      // Ok, we're good to add field
      $values = $form->getValues();
      $db = Engine_Db_Table::getDefaultAdapter();
      $db->beginTransaction();

      try {
        // edit category in the database
        // Transaction
        $row = Engine_Api::_()->recipe()->getCategory($values["id"]);
        $row->category_name = $values["label"];
        $row->save();
        $db->commit();
      } catch (Exception $e) {
        $db->rollBack();
        throw $e;
      }
      $this->_forward('success', 'utility', 'core', array(
              'smoothboxClose' => 10,
              'parentRefresh' => 10,
              'messages' => array('')
      ));
    }

    // Must have an id
    if (!($id = $this->_getParam('id'))) {
      throw new Zend_Exception('No identifier specified');
    }

    // Generate and assign form
    $category = Engine_Api::_()->recipe()->getCategory($id);
    $form->setField($category);

    // Output
    $this->renderScript('admin-settings/form.tpl');
  }

  public function faqAction() {

    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
            ->getNavigation('recipe_admin_main', array(), 'recipe_admin_main_faq');
  }

  public function recipecategoriesAction() {

    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
            ->getNavigation('recipe_admin_main', array(), 'recipe_admin_main_recipecategories');
    if (isset($_POST['task'])) {
      $task = $_POST['task'];
    } elseif (isset($_GET['task'])) {
      $task = $_GET['task'];
    } else {
      $task = "main";
    }

    $table = Engine_Api::_()->getDbTable('categories', 'recipe');
    $classfied_tableName = $table->info('name');

    if ($task == "savecat") {

      $cat_id = $_GET['cat_id'];
      $cat_title = $this->parseString($_GET['cat_title']);
      $cat_dependency = $_GET['cat_dependency'];

      if ($cat_title == "") {

        if ($cat_id != "new") {

          $select = $table->select()->from($classfied_tableName, 'category_id')->where('cat_dependency = ?', $cat_id);
          $category_ids = $table->fetchAll($select);

          foreach ($category_ids->toarray() as $value) {
            $sub_cats[] = $value['category_id'];
          }
          if (!empty($sub_cats)) {
            $string = $cat_id . ', ' . implode(", ", $sub_cats);
          } else {
            $string = $cat_id;
          }

          if ($cat_dependency == 0) {

            $select = $table->select()->from($classfied_tableName)->where('cat_dependency = ?', $cat_id);
            $row_ids = $table->fetchAll($select);

            foreach ($row_ids->toarray() as $values1) {
              $table->delete(array('cat_dependency = ?' => $values1[cat_dependency], 'category_id = ?' => $values1[category_id]));
            }
            $table->delete(array('category_id = ?' => $cat_id));
          } else {
            $table->delete(array('category_id = ?' => $cat_id, 'cat_dependency = ?' => $cat_dependency));
          }
        }

        // SEND AJAX CONFIRMATION
        echo "<html><head><meta http-equiv='Content-Type' content='text/html; charset=UTF-8'><script type='text/javascript'>";
        echo "window.parent.removecat('$cat_id');";
        echo "</script></head><body></body></html>";
        exit();

        // SAVE CHANGES
      } else {

        if ($cat_id == 'new') {

          $select = $table->select()->from($classfied_tableName, 'max(cat_order) AS cat_order');
          $row_info = $table->fetchRow($select);
          $cat_order = $row_info['cat_order'] + 1;
          $row = $table->createRow();
          $row->user_id = 1;
          $row->category_name = $cat_title;
          $row->cat_order = $cat_order;
          $row->cat_dependency = $cat_dependency;
          $newcat_id = $row->save();
        } else {
          $table->update(array('category_name' => $cat_title), array('category_id = ?' => $cat_id));
          $newcat_id = $cat_id;
        }

        // SEND AJAX CONFIRMATION
        echo "<html><head><meta http-equiv='Content-Type' content='text/html; charset=UTF-8'><script type='text/javascript'>";
        echo "window.parent.savecat_result('$cat_id', '$newcat_id', '$cat_title', '$cat_dependency');";
        echo "</script></head><body></body></html>";
        exit();
      }
    } elseif ($task == "changeorder") {

      $recipeorder = $_GET['recipeorder'];
      $divId = $_GET['divId'];
      $recipe = explode(",", $recipeorder);
      // RESORT CATEGORIES
      if ($divId == "categories") {

        for ($i = 0; $i < count($recipe); $i++) {
          $cat_id = substr($recipe[$i], 4);
          $table->update(array('cat_order' => $i + 1), array('category_id = ?' => $cat_id));
        }
      } elseif (substr($divId, 0, 7) == "subcats") {
        for ($i = 0; $i < count($recipe); $i++) {
          $cat_id = substr($recipe[$i], 4);
          $table->update(array('cat_order' => $i + 1), array('category_id = ?' => $cat_id));
        }
      }
    }
    $cateTable = Engine_Api::_()->getDbtable('categories', 'recipe');
    $cateName = $cateTable->info('name');

    $table = Engine_Api::_()->getDbtable('recipes', 'recipe');
    $rName = $table->info('name');

    $select = $cateTable->select()->setIntegrityCheck(false)
            ->from($cateName)
            ->joinLeft($rName, $rName . '.category_id = ' . $cateName . '.category_id', array('count(' . $rName . '.category_id ) as count'))
            ->where($cateName . '.cat_dependency = 0')
            ->group($cateName . '.category_id')
            ->order('cat_order');

    $categories = array();
    $category_info = $cateTable->fetchAll($select);

    foreach ($category_info->toarray() as $value) {

      $sub_cat_array = array();
      $sub_cat = $cateTable->select()->setIntegrityCheck(false)
              ->from($cateName)
              ->joinLeft($rName, $rName . '.subcategory_id = ' . $cateName . '.category_id', array('count(' . $rName . '.subcategory_id ) as count'))
              ->where($cateName . '.cat_dependency = ' . $value['category_id'])
              ->group($cateName . '.category_id')
              ->order('cat_order');

      $category_info2 = $cateTable->fetchAll($sub_cat);

      foreach ($category_info2->toarray() as $result_info) {

        $tmp_array = array('sub_cat_id' => $result_info['category_id'],
                'sub_cat_name' => $result_info['category_name'],
                'count' => $result_info['count'],
                'order' => $result_info['cat_order']);
        $sub_cat_array[] = $tmp_array;
      }

      $category_array = array('category_id' => $value['category_id'],
              'category_name' => $value['category_name'],
              'order' => $value['cat_order'],
              'count' => $value['count'],
              'sub_categories' => $sub_cat_array);
      $categories[] = $category_array;
    }
    include_once APPLICATION_PATH . '/application/modules/Recipe/controllers/license/license2.php';
  }

  public function readmeAction() {

  }

  public function statisticAction() {
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
            ->getNavigation('recipe_admin_main', array(), 'recipe_admin_main_statistic');
    //Get the total recipe
    $table = Engine_Api::_()->getDbtable('recipes', 'recipe');
    $recipe_tablename = $table->info('name');
    $select = $table->select()->from($recipe_tablename, 'count(*) AS totalrecipe');
    $totalrecipes = $table->fetchRow($select)->toarray();
    $this->view->totalRecipe = $totalrecipes['totalrecipe'];

    //Get the total Publish recipe
    $select = $table->select()->from($recipe_tablename, 'count(*) AS totalpublish')->where('draft =?', 1);
    $totalPublishrecipes = $table->fetchRow($select)->toarray();
    $this->view->totalPublish = $totalPublishrecipes['totalpublish'];


    //Get the total Drafted recipe
    $select = $table->select()->from($recipe_tablename, 'count(*) AS totaldrafted')->where('draft =?', 0);
    $totalDraftedrecipes = $table->fetchRow($select)->toarray();
    $this->view->totalDrafted = $totalDraftedrecipes['totaldrafted'];


    //Get the total Closed recipe
    $select = $table->select()->from($recipe_tablename, 'count(*) AS totalclosed')->where('closed =?', 1);
    $totalClosedrecipes = $table->fetchRow($select)->toarray();
    $this->view->totalClosed = $totalClosedrecipes['totalclosed'];

    //Get the total Open recipe
    $select = $table->select()->from($recipe_tablename, 'count(*) AS totalopen')->where('closed =?', 0);
    $totalOpenrecipes = $table->fetchRow($select)->toarray();
    $this->view->totalOpen = $totalOpenrecipes['totalopen'];

    //Get the total Approve recipe
    $select = $table->select()->from($recipe_tablename, 'count(*) AS totalapproved')->where('approved =?', 1);
    $totalapprovedrecipes = $table->fetchRow($select)->toarray();
    $this->view->totalapproved = $totalapprovedrecipes['totalapproved'];

    //Get the total DisApprove recipe
    $select = $table->select()->from($recipe_tablename, 'count(*) AS totaldisapproved')->where('approved =?', 0);
    $totalapprovedrecipes = $table->fetchRow($select)->toarray();
    $this->view->totaldisapproved = $totalapprovedrecipes['totaldisapproved'];

    //Get the total Featured recipe
    $select = $table->select()->from($recipe_tablename, 'count(*) AS totalfeatured')->where('featured =?', 1);
    $totalfeaturedrecipes = $table->fetchRow($select)->toarray();
    $this->view->totalfeatured = $totalfeaturedrecipes['totalfeatured'];

    //Get the total Sponsored recipe
    $select = $table->select()->from($recipe_tablename, 'count(*) AS totalsponsored')->where('sponsored =?', 1);
    $totalsponsoredrecipes = $table->fetchRow($select)->toarray();
    $this->view->totalsponsored = $totalsponsoredrecipes['totalsponsored'];

    //Get the total Reviews on the recipe
    $reviewtable = Engine_Api::_()->getDbtable('reviews', 'recipe');
    $review_tablename = $reviewtable->info('name');
    $reviewselect = $reviewtable->select()->from($review_tablename, 'count(*) AS totalreview');
    $totalreviewrecipes = $reviewtable->fetchRow($reviewselect)->toarray();
    $this->view->totalreview = $totalreviewrecipes['totalreview'];

    //Get the total Discussion on the recipe
    $discussiontable = Engine_Api::_()->getDbtable('topics', 'recipe');
    $discussion_tablename = $discussiontable->info('name');
    $discussionselect = $discussiontable->select()->from($discussion_tablename, 'count(*) AS totaldiscussion');
    $totaldiscussionrecipes = $discussiontable->fetchRow($discussionselect)->toarray();
    $this->view->totaldiscussion = $totaldiscussionrecipes['totaldiscussion'];

    //Get the total Post on the recipe
    $discussionposttable = Engine_Api::_()->getDbtable('posts', 'recipe');
    $discussionpost_tablename = $discussionposttable->info('name');
    $discussionpostselect = $discussionposttable->select()->from($discussionpost_tablename, 'count(*) AS totalpost');
    $totaldiscussionpostrecipes = $discussionposttable->fetchRow($discussionpostselect)->toarray();
    $this->view->totaldiscussionpost = $totaldiscussionpostrecipes['totalpost'];

    include_once APPLICATION_PATH . '/application/modules/Recipe/controllers/license/license2.php';

    //Get the total Photos on the recipe
    $phototable = Engine_Api::_()->getDbtable('photos', 'recipe');
    $photo_tablename = $phototable->info('name');
    $photoselect = $phototable->select()->from($photo_tablename, 'count(*) AS totalphoto');
    $totalphotorecipes = $phototable->fetchRow($photoselect)->toarray();
    $this->view->totalphotopost = $totalphotorecipes['totalphoto'];

    //Get the total Video on the recipe
    $videotable = Engine_Api::_()->getDbtable('clasfvideos', 'recipe');
    $video_tablename = $videotable->info('name');
    $videoselect = $videotable->select()->from($video_tablename, 'count(*) AS totalvideo');
    $totalvideorecipes = $videotable->fetchRow($videoselect)->toarray();
    $this->view->totalvideopost = $totalvideorecipes['totalvideo'];

    //Get the total Comments on the recipe
    $commentselect = $table->select()->from($recipe_tablename, 'sum(comment_count) AS totalcomments');
    $totalcommentrecipes = $table->fetchRow($commentselect)->toarray();
    $this->view->totalcommentpost = $totalcommentrecipes['totalcomments'];
  }

  public function parseString($content) {
    $ret_str = '';
    $str = trim($content);
    $str = str_replace("'", "\'", $content);
    return $str;
  }

	//ACTION FOR SET THE DEFAULT MAP CENTER POINT  
  public function setDefaultMapCenterPoint($oldLocation, $newLocation) {

    if ($oldLocation !== $newLocation && $newLocation !== "World" && $newLocation !== "world") {
        $locationResults = Engine_Api::_()->getApi('geoLocation', 'seaocore')->getLatLong(array('location' => $newLocation, 'module' => 'Recipes'));
        if(!empty($locationResults['latitude']) && !empty($locationResults['longitude'])) {
            $latitude = $locationResults['latitude'];
            $longitude = $locationResults['longitude'];
        }

      Engine_Api::_()->getApi('settings', 'core')->setSetting('recipe.map.latitude', $latitude);
      Engine_Api::_()->getApi('settings', 'core')->setSetting('recipe.map.longitude', $longitude);
    }
  }

}