<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Recipe
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminViewrecipeController.php 6590 2010-12-31 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Recipe_AdminViewrecipeController extends Core_Controller_Action_Admin {

  // view recipe recipe
  public function indexAction() {

    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
            ->getNavigation('recipe_admin_main', array(), 'recipe_admin_main_viewrecipe');

    $this->view->formFilter = $formFilter = new Recipe_Form_Admin_Manage_Filter();

    $page = $this->_getParam('page', 1);

    $tableUser = Engine_Api::_()->getItemTable('user')->info('name');

    $table = Engine_Api::_()->getDbtable('recipes', 'recipe');
    $rName = $table->info('name');
    $select = $table->select()
            ->setIntegrityCheck(false)
            ->from($rName)
            ->joinLeft($tableUser, "$rName.owner_id = $tableUser.user_id", 'username');

    $values = array();

    if ($formFilter->isValid($this->_getAllParams())) {
      $values = $formFilter->getValues();
    }
    foreach ($values as $key => $value) {

      if (null == $value) {
        unset($values[$key]);
      }
    }

    // searching
    $this->view->owner = '';
    $this->view->title = '';
    $this->view->sponsored = '';
    $this->view->approved = '';
    $this->view->featured = '';
    $this->view->status = '';
    $this->view->recipebrowse = '';
    $this->view->category_id = '';
    $this->view->subcategory_id = '';

    if (isset($_POST['search'])) {

      if (!empty($_POST['owner'])) {
        $this->view->owner = $_POST['owner'];
        $select->where($tableUser . '.username  LIKE ?', '%' . $_POST['owner'] . '%');
      }
      if (!empty($_POST['title'])) {
        $this->view->title = $_POST['title'];
        $select->where($rName . '.title  LIKE ?', '%' . $_POST['title'] . '%');
      }
      if (!empty($_POST['sponsored'])) {
        $this->view->sponsored = $_POST['sponsored'];
        $_POST['sponsored']--;

        $select->where($rName . '.sponsored = ? ', $_POST['sponsored']);
      }
      if (!empty($_POST['approved'])) {
        $this->view->approved = $_POST['approved'];
        $_POST['approved']--;
        $select->where($rName . '.approved = ? ', $_POST['approved']);
      }
      if (!empty($_POST['featured'])) {
        $this->view->featured = $_POST['featured'];
        $_POST['featured']--;
        $select->where($rName . '.featured = ? ', $_POST['featured']);
      }
      if (!empty($_POST['status'])) {
        $this->view->status = $_POST['status'];
        $_POST['status']--;
        $select->where($rName . '.closed = ? ', $_POST['status']);
      }
      if (!empty($_POST['recipebrowse'])) {
        $this->view->recipebrowse = $_POST['recipebrowse'];
        $_POST['recipebrowse']--;
        if ($_POST['recipebrowse'] == 0) {
          $select->order($rName . '.view_count DESC');
        } else {
          $select->order($rName . '.creation_date DESC');
        }
      }
      if (!empty($_POST['category_id']) && empty($_POST['subcategory_id'])) {
        $this->view->category_id = $_POST['category_id'];
        // $_POST['recipebrowse']--;
        $select->where($rName . '.category_id = ? ', $_POST['category_id']);
      } elseif (!empty($_POST['category_id']) && !empty($_POST['subcategory_id'])) {
        $this->view->category_id = $_POST['category_id'];
        $subcategory_id = $this->view->subcategory_id = $_POST['subcategory_id'];
        $table = Engine_Api::_()->getDbtable('categories', 'recipe');
        $categoriesName = $table->info('name');
        $selectcategory = $table->select()->from($categoriesName, 'category_name')
                ->where("(category_id = $subcategory_id)");
        $row = $table->fetchRow($selectcategory);
        if (!empty($row->category_name)) {
          $this->view->subcategory_name = $row->category_name;
        }

        $select->where($rName . '.category_id = ? ', $_POST['category_id'])
            ->where($rName . '.subcategory_id = ? ', $_POST['subcategory_id']);
      }
    }

    $values = array_merge(array(
                'order' => 'recipe_id',
                'order_direction' => 'DESC',
            ), $values);

    $this->view->assign($values);

    $select->order((!empty($values['order']) ? $values['order'] : 'recipe_id' ) . ' ' . (!empty($values['order_direction']) ? $values['order_direction'] : 'DESC' ));

    //MAKE PAGINATOR
    $this->view->paginator = $paginator = Zend_Paginator::factory($select);
    $this->view->paginator->setItemCountPerPage(20);
    $this->view->paginator = $paginator->setCurrentPageNumber($page);
  }

  // view perticular recipe details
  public function detailAction() {

    $id = $this->_getParam('id');

    // Rating enable /disable
    $this->view->ratngShow = $ratingShow = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.rating', 1);

    // set the view in detail.tpl
    $this->view->recipeDetail = Engine_Api::_()->getItem('recipe', (int) $id); //$detail;
  }

  public function multiDeleteAction() {

    //SET SCRIBD API AND SECREAT KEY
    if ($this->getRequest()->isPost()) {
      $values = $this->getRequest()->getPost();

      foreach ($values as $key => $value) {
        if ($key == 'delete_' . $value) {
          //DELETE RECIPES FROM DATABASE
          Engine_Api::_()->getItem('recipe', (int) $value)->deleteRecipe();
        }
      }
    }
    return $this->_helper->redirector->gotoRoute(array('action' => 'index'));
  }

}