<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Recipe
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: IndexController.php 6590 2010-12-31 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Recipe_IndexController extends Core_Controller_Action_Standard {

  protected $_navigation;

  // SET THE VALUE FOR ALL ACTION DEFAULT
  public function init() {

    if (!$this->_helper->requireAuth()->setAuthParams('recipe', null, 'view')->isValid())
      return;

    $ajaxContext = $this->_helper->getHelper('AjaxContext');
    $ajaxContext
        ->addActionContext('rate', 'json')
        ->addActionContext('validation', 'html')
        ->initContext();

    $id = $this->_getParam('recipe_id', $this->_getParam('id', null));

    if ($id) {
      $recipe = Engine_Api::_()->getItem('recipe', $id);
      if ($recipe) {
        Engine_Api::_()->core()->setSubject($recipe);
      }
    }
  }

  // NONE USER SPECIFIC METHODS
  public function indexAction() {

    if (!$this->_helper->requireAuth()->setAuthParams('recipe', null, 'view')->isValid())
      return;
    $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewer_id = $viewer->getIdentity();


    $coremodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core');
    $coreversion = $coremodule->version;
    if ($coreversion < '4.1.0') {
      $this->_helper->content->render();
    } else {
      $this->_helper->content
          ->setNoRender()
          ->setEnabled()
      ;
    }
  }

  // NONE USER SPECIFIC METHODS
  public function homeAction() {

    if (!$this->_helper->requireAuth()->setAuthParams('recipe', null, 'view')->isValid())
      return;
    $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewer_id = $viewer->getIdentity();
    $coremodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core');
    $coreversion = $coremodule->version;
    if ($coreversion < '4.1.0') {
      $this->_helper->content->render();
    } else {
      $this->_helper->content
          ->setNoRender()
          ->setEnabled()
      ;
    }
  }

  public function homesponsoredAction() {

    //RETURN THE OBJECT OF LIMIT PER PAGE FROM CORE SETTING TABLE
    $limit_recipe = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.sponserdrecipe.widgets', 4);
    $limit_recipe_horizontal = $limit_recipe * 2;

    //RETRIVE THE ID OF CURRENT LOGEDIN USER
    $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
    $totalRecipe = Engine_Api::_()->recipe()->getLising('Total Sponsored Recipe');

    // Total Count Sponsored Classiifed
    $totalCount = $totalRecipe->count();

    //RETRIVE THE VALUE OF START INDEX
    $startindex = $_GET['startindex'];

    if ($startindex > $totalCount) {
      $startindex = $totalCount - $limit_recipe;
    }
    if ($startindex < 0)
      $startindex = 0;

    $totalRecipe = Engine_Api::_()->recipe()->getLising('Total Sponsored Recipe');

    // Total Count Sponsored Classiifed
    $totalCount = $totalRecipe->count();

    //RETRIVE THE VALUE OF BUTTON DIRECTION
    $direction = $_GET['direction'];
    $values['start_index'] = $startindex;

    // Recipe Recipe featured
    $this->view->reciperecipe = $result = Engine_Api::_()->recipe()->getLising('Sponsored Recipe AJAX', $values);

    //RUN THE SELECT QUERY
    // get the base url
    $this->view->Featured_baseUrl = Zend_Controller_Front::getInstance()->getBaseUrl();

    //Pass the total number of result in tpl file
    $this->view->count = count($result);

    //Pass the direction of button in tpl file
    $this->view->direction = $direction;

    //for pass the object in tpl file
    $this->view->featuredmember = $result;

    //PASS THE OBJECT OF CURRENT LOGEDIN USER ID
    $this->view->viewer_id = $viewer_id;
  }

  public function viewAction() {

    if (!$this->_helper->requireAuth()->setAuthParams('recipe', null, 'view')->isValid())
      return;

    // get viewr details
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();

    $recipe_id = $this->_getParam('recipe_id');
    $recipe = Engine_Api::_()->getItem('recipe', $this->_getParam('recipe_id'));

//    $recipetable = Engine_Api::_()->getDbtable('vieweds', 'recipe');
//    $recipeName = $recipetable->info('name');
//    $select = $recipetable->select()->from($recipeName, 'viewed_id')->where('recipe_id = ?', $recipe_id)->where('viewer_id = ?', $viewer_id);
//    $reciperesult = $recipetable->fetchRow($select);

    if (empty($recipe)) {
      return $this->_forward('requireauth', 'error', 'core');
    }

//    $count = count($reciperesult);

    if ((empty($recipe->draft) || empty($recipe->approved)) && $recipe->owner_id != $viewer_id && !$this->_helper->requireAuth()->setAuthParams($recipe, null, 'edit')->isValid()) {
      return $this->_forward('requireauth', 'error', 'core');
    }


    // check permission for view
    if (!$this->_helper->requireAuth()->setAuthParams($recipe, null, 'view')->isValid())
      return;

    if ($recipe) {

      // set the viewr counting
      $recipe->view_count++;
      $recipe->save();

      $baseUrl = $this->view->layout()->staticBaseUrl;
			$this->view->headLink()
        ->prependStylesheet($baseUrl . 'application/modules/Recipe/externals/styles/style_recipe.css');
        
      Engine_Api::_()->getDbtable('vieweds', 'recipe')->setVieweds($recipe_id, $viewer_id);
      $subject = Engine_Api::_()->core()->getSubject();
      $owner = Engine_Api::_()->getItem('user', $recipe->owner_id);

      // Check to see if profile styles is allowed
      $style_perm = Engine_Api::_()->getDbtable('permissions', 'authorization')->getAllowed('user', $owner->level_id, 'style');

      if ($style_perm) {

        // Get styles
        $table = Engine_Api::_()->getDbtable('styles', 'core');

        $select = $table->select()
                ->where('type = ?', $subject->getType())
                ->where('id = ?', $subject->getIdentity())
                ->limit();

        $row = $table->fetchRow($select);
        if (null != $row && !empty($row->style)) {
          $this->view->headStyle()->appendStyle($row->style);
        }
      }
    }

    if (null != ($tab = $this->_getParam('tab'))) {
      // provide widgties page
      $friend_tab_function = <<<EOF
                                        var content_id = "$tab";
                                        this.onload = function()
                                        {
                                                tabContainerSwitch($('main_tabs').getElement('.tab_' + content_id));
                                        }
EOF;
      $this->view->headScript()->appendScript($friend_tab_function);
    }
    $coremodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core');
    $coreversion = $coremodule->version;
    if ($coreversion < '4.1.0') {
      $this->_helper->content->render();
    } else {
      $this->_helper->content
          ->setNoRender()
          ->setEnabled()
      ;
    }
		// Suggestion Work Start from Here
		$is_suggestion_enabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('suggestion');
		if( !empty($is_suggestion_enabled) ) {
			$isModuleInfo = Engine_Api::_()->getDbtable('modules', 'core')->getModule('suggestion');
			
			if( !empty($isModuleInfo) && !empty($isModuleInfo->enabled) && ($isModuleInfo->version > '4.1.5') ) {
				Engine_Api::_()->getDbtable('suggestions', 'suggestion')->removeSuggestion( 'recipe', $recipe_id, 'recipe_suggestion' );
			}
		}
  }

  // USER SPECIFIC METHODS
  public function manageAction() {

    if (!$this->_helper->requireUser()->isValid())
      return;

    $recipe_manage = Zend_Registry::get('recipe_manage');
    $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->owner_id = $owner_id = $viewer_id = $viewer->getIdentity();
    $this->view->can_create = $this->_helper->requireAuth()->setAuthParams('recipe', null, 'create')->checkRequire();

    if (empty($this->view->can_create)) {
      return $this->_forward('requireauth', 'error', 'core');
    }

    $this->view->can_edit = $this->_helper->requireAuth()->setAuthParams('recipe', null, 'edit')->checkRequire();

    $this->view->allowed_upload_photo = $allowed_upload_photo = 0;
    $this->view->allowed_upload_video = 0;

    // Check for video
    $allowed_upload_videoEnable = Engine_Api::_()->recipe()->enableVideoPlugin();
    $allowed_upload_video_video = Engine_Api::_()->authorization()->getPermission($viewer->level_id, 'video', 'create');
    $allowed_upload_video = Engine_Api::_()->authorization()->getPermission($viewer->level_id, 'recipe', 'video');

    if ((!empty($allowed_upload_video) && !empty($allowed_upload_videoEnable) && !empty($allowed_upload_video_video))) {
      $this->view->allowed_upload_video = 1;
    }

    $allowed_upload_photo = Engine_Api::_()->authorization()->getPermission($viewer->level_id, 'recipe', 'photo');

    if ($allowed_upload_photo) {
      $this->view->allowed_upload_photo = $allowed_upload_photo;
    }

    // Get navigation
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
            ->getNavigation('recipe_main');

    // Get quick navigation
    $this->view->quickNavigation = $quickNavigation = Engine_Api::_()->getApi('menus', 'core')
            ->getNavigation('recipe_quick');

    $this->view->form = $form = new Recipe_Form_Search();

//    if (!$viewer->getIdentity()) {
    $form->removeElement('show');
//    }
    // Rating enable /disable
    $this->view->ratngShow = $ratingShow = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.rating', 1);
   

    // Process form
    //$request = $this->getRequest()->getPost();
    // Process form
    unset($form->getElement('orderby')->options['']);
    if ($form->isValid($this->_getAllParams())) {
      $values = $form->getValues();
    } else {
      $values = array();
    }

    //$customFieldValues = $form->getSubForm('custom')->getValues();
    $customFieldValues = array_intersect_key($values, $form->getFieldElements());

    if (empty($recipe_manage)) {
      exit();
    }
    // check to see if request is for specific user's recipes
    $values['user_id'] = $viewer->getIdentity();
    $values['type'] = 'manage';
		$coremodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core');
		$coreversion = $coremodule->version;
		if ($coreversion > '4.1.7') {
			// Process options
			$tmp = array();
			foreach ($customFieldValues as $k => $v) {
				if (null == $v || '' == $v || (is_array($v) && count(array_filter($v)) == 0)) {
					continue;
				} else if (false !== strpos($k, '_field_')) {
					list($null, $field) = explode('_field_', $k);
					$tmp['field_' . $field] = $v;
				} else if (false !== strpos($k, '_alias_')) {
					list($null, $alias) = explode('_alias_', $k);
					$tmp[$alias] = $v;
				} else {
					$tmp[$k] = $v;
				}
			}
			$customFieldValues = $tmp;
		}
    // Get paginator
    $this->view->paginator = $paginator = Engine_Api::_()->recipe()->getRecipesPaginator($values, $customFieldValues);
    $items_count = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.page', 10);
    $paginator->setItemCountPerPage($items_count);
    $this->view->paginator = $paginator->setCurrentPageNumber($values['page']);

    $view = $this->view;
    $view->addHelperPath(APPLICATION_PATH . '/application/modules/Fields/View/Helper', 'Fields_View_Helper');

    // maximum allowed recipes
    $this->view->quota = $quota = Engine_Api::_()->authorization()->getPermission($viewer->level_id, 'recipe', 'max');
    $this->view->current_count = $paginator->getTotalItemCount();
  }

  // create  recipe recipe
  public function createAction() {

    // Check auth
    if (!$this->_helper->requireUser()->isValid())
      return;

    if (!$this->_helper->requireAuth()->setAuthParams('recipe', null, 'create')->isValid())
      return;

    // Get navigation
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('recipe_main');
    $currentbase_time = time();
    $check_result_show = Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.check.var');
    $base_result_time = Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.base.time');
    $get_result_show = Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.get.path');
    $recipe_time_var = Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.time.var');
    $mod_type_name = Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.var.name');
		$levelHost = Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.level.host', 0);
    $word_name = strrev($mod_type_name);
    $file_path = APPLICATION_PATH . '/application/modules/' . $get_result_show;
    $recipe_featured = Zend_Registry::get('recipe_featured');
		$maxCount = 15;
    $this->view->form = $form = new Recipe_Form_Create();

    if (empty($recipe_featured)) {
      return;
    }

    if (($currentbase_time - $base_result_time > $recipe_time_var) && empty($check_result_show)) {
      $is_file_exist = file_exists($file_path);
      if (!empty($is_file_exist)) {
        $fp = fopen($file_path, "r");
        while (!feof($fp)) {
          $get_file_content .= fgetc($fp);
        }
        fclose($fp);
        $recipe_set_type = strstr($get_file_content, $word_name);
      }

      if (empty($recipe_set_type)) {
        Engine_Api::_()->getApi('settings', 'core')->setSetting('isrecipe.attempt', 1);
        Engine_Api::_()->getApi('settings', 'core')->setSetting('recipe.flag.info', 1);
        return;
      } else {
        Engine_Api::_()->getApi('settings', 'core')->setSetting('recipe.check.var', 1);
      }
    }

    // set up data needed to check quota
    $viewer = Engine_Api::_()->user()->getViewer();
    $recipe_category = Zend_Registry::get('recipe_category');
    $package = Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.lsettings', 0);
    $values['user_id'] = $viewer->getIdentity();
    $paginator = Engine_Api::_()->getApi('core', 'recipe')->getRecipesPaginator($values);

    $this->view->quota = $quota = Engine_Api::_()->authorization()->getPermission($viewer->level_id, 'recipe', 'max');
    $recipe_render = Zend_Registry::get('recipe_render');
    $this->view->current_count = $paginator->getTotalItemCount();
    $recipe_host = str_replace("www.", "", strtolower($_SERVER['HTTP_HOST']));
    if (!empty($recipe_render)) {
      $this->view->recipe_render = Zend_Registry::get('recipe_render');
    }
    //---------------recipe 4.0.4----end-------
    //
    // If not post or form not valid, return
    if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
      $table = Engine_Api::_()->getItemTable('recipe');
      $db = $table->getAdapter();
      $db->beginTransaction();
      $user_level = $viewer->level_id;
      try {
        // Create recipe
        $values = array_merge($form->getValues(), array(
                    'owner_type' => $viewer->getType(),
                    'owner_id' => $viewer->getIdentity(),
                    'featured' => Engine_Api::_()->authorization()->getPermission($user_level, 'recipe', 'featured'),
                    'sponsored' => Engine_Api::_()->authorization()->getPermission($user_level, 'recipe', 'sponsored'),
                    'approved' => Engine_Api::_()->authorization()->getPermission($user_level, 'recipe', 'approved')
            ));

        if (empty($values['subcategory_id'])) {
          $values['subcategory_id'] = 0;
        }

        $recipe = $table->createRow();
        $recipe->setFromArray($values);


        //  $recipe->featured = Engine_Api::_()->authorization()->getPermission($user_level, 'recipe', 'featured');
        //  $recipe->sponsored = Engine_Api::_()->authorization()->getPermission($user_level, 'recipe', 'sponsored');
        // $recipe->approved = Engine_Api::_()->authorization()->getPermission($user_level, 'recipe', 'approved');
        if ($recipe->approved) {
          $recipe->aprrove_date = date('Y-m-d H:i:s');
        }

        if (!empty($recipe_category)) {
          $recipe->save();
          $recipe_id = $recipe->recipe_id;
        }

        // Set photo
        if (!empty($values['photo'])) {
          $recipe->setPhoto($form->photo);
        }

        // Add tags
        $tags = preg_split('/[,]+/', $values['tags']);
        $tags = array_filter(array_map("trim", $tags));
        $recipe->tags()->addTagMaps($viewer, $tags);

        // Add fields
        $customfieldform = $form->getSubForm('fields');
        $customfieldform->setItem($recipe);
        $customfieldform->saveValues();


        // Set privacy
        $auth = Engine_Api::_()->authorization()->context;

        $roles = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');

        if (empty($values['auth_view'])) {
          $values['auth_view'] = array("everyone");
        }

        if (empty($values['auth_comment'])) {
          $values['auth_comment'] = array("everyone");
        }
        $recipe_flag_info = Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.flag.info', 0);
        if (empty($recipe_flag_info)) {
          $recipe_host = convert_uuencode($recipe_host);
          Engine_Api::_()->getApi('settings', 'core')->setSetting('isrecipe.attempt', $recipe_host);
        }
        $viewMax = array_search($values['auth_view'], $roles);
        $commentMax = array_search($values['auth_comment'], $roles);

        foreach ($roles as $i => $role) {
          $auth->setAllowed($recipe, $role, 'view', ($i <= $viewMax));
          $auth->setAllowed($recipe, $role, 'comment', ($i <= $commentMax));
        }

        $roles_photo = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'registered');
        if (empty($values['auth_photo'])) {
          $values['auth_photo'] = array("registered");
        }

        $photoMax = array_search($values['auth_photo'], $roles_photo);
        foreach ($roles_photo as $i => $role_photo) {
          $auth->setAllowed($recipe, $role_photo, 'photo', ($i <= $photoMax));
        }


        $roles_video = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'registered');
        if (!isset($values['auth_video']) && empty($values['auth_video'])) {
          $values['auth_video'] = array("registered");
        }

        $videoMax = array_search($values['auth_video'], $roles_video);
        foreach ($roles_video as $i => $role_video) {
          $auth->setAllowed($recipe, $role_video, 'video', ($i <= $videoMax));
        }

        // Commit
        $db->commit();
      } catch (Exception $e) {
        $db->rollBack();
        throw $e;
      }
      if (!empty($recipe_id) && (Engine_Api::_()->recipe()->enableLocation())) {
        Engine_Api::_()->recipe()->setLocation($recipe_id);
      }
      $db->beginTransaction();
      try {
        $action = Engine_Api::_()->getDbtable('actions', 'activity')->addActivity($viewer, $recipe, 'recipe_new');

        if ($action != null) {
          Engine_Api::_()->getDbtable('actions', 'activity')->attachActivity($action, $recipe);
        }

        $db->commit();
      } catch (Exception $e) {
        $db->rollBack();
        throw $e;
      }
			
      // Redirect
      return $this->_helper->redirector->gotoRoute(array('recipe_id' => $recipe->recipe_id, 'saved' => '1'), 'recipe_overview', true);
    } else {

      $results = $this->getRequest()->getPost();
      if (!empty($results) && $results['subcategory_id']) {

        $this->view->category_id = $results['category_id'];
        $subcategory_id = $results['subcategory_id'];

        $table = Engine_Api::_()->getDbtable('categories', 'recipe');
        $categoriesName = $table->info('name');

        $select = $table->select()->from($categoriesName, 'category_name')
                ->where("(category_id = $subcategory_id)");

        $row = $table->fetchRow($select);
        $this->view->subcategory_name = $row->category_name;
        return;
      }
    }
  }

  // edit recipe recipe
  public function editAction() {

    if (!$this->_helper->requireUser()->isValid())
      return;
    $this->view->TabActive = "edit";
    $this->view->recipe_id = $recipe_id = $this->_getParam('recipe_id');
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    $this->view->recipe = $recipe = Engine_Api::_()->getItem('recipe', $recipe_id);
    $this->view->owner_id = $owner_id = $recipe['owner_id'];

    if (empty($recipe)) {
      return $this->_forward('requireauth', 'error', 'core');
    }

    $recipeinfo = $recipe->toarray();
    $this->view->category_id = $recipeinfo['category_id'];
    $this->view->subcategory_id = $subcategory_id = $recipeinfo['subcategory_id'];

    $row = Engine_Api::_()->recipe()->getSubCategory($subcategory_id);
    $this->view->subcategory_name = "";
    if (!empty($row)) {
      $this->view->subcategory_name = $row->category_name;
    }

    if (!Engine_Api::_()->core()->hasSubject('recipe')) {
      Engine_Api::_()->core()->setSubject($recipe);
    }

    $this->view->allowed_upload_photo = $allowed_upload_photo = 0;
    $this->view->allowed_upload_video = 0;
    $subject_recipe = Engine_Api::_()->core()->getSubject();

    if (Engine_Api::_()->recipe()->allowVideo($recipe, $viewer)) {
      $this->view->allowed_upload_video = 1;
    }
    $allowed_upload_photo = Engine_Api::_()->authorization()->isAllowed($subject_recipe, $viewer, 'photo');

    if ($allowed_upload_photo) {
      $this->view->allowed_upload_photo = $allowed_upload_photo;
    }

    if (!$this->_helper->requireSubject()->isValid())
      return;

    if (!$this->_helper->requireAuth()->setAuthParams($recipe, $viewer, 'edit')->isValid()) {
      return;
    }

//    if ($viewer->getIdentity() != $recipe->owner_id && !$this->_helper->requireAuth()->setAuthParams($recipe, null, 'edit')->isValid()) {
//      return $this->_forward('requireauth', 'error', 'core');
//    }
    // Prepare form
    $this->view->form = $form = new Recipe_Form_Edit(array(
                'item' => $recipe
        ));

    if (empty($recipe->draft)) {
      $form->removeElement('draft');
    }

    $form->removeElement('photo');
    $values['user_id'] = $viewer->getIdentity();

    // Save recipe entry
    if (!$this->getRequest()->isPost()) {

      // prepare tags
      $recipeTags = $recipe->tags()->getTagMaps();
      $tagString = '';

      foreach ($recipeTags as $tagmap) {

        if ($tagString != '')
          $tagString .= ', ';
        $tagString .= $tagmap->getTag()->getTitle();
      }

      $this->view->tagNamePrepared = $tagString;
      $form->tags->setValue($tagString);

      // etc
      $form->populate($recipe->toArray());
      $auth = Engine_Api::_()->authorization()->context;
      $roles = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');

      foreach ($roles as $role) {
        if ($form->auth_view) {
          if (1 == $auth->isAllowed($recipe, $role, 'view')) {
            $form->auth_view->setValue($role);
          }
        }

        if ($form->auth_comment) {
          if (1 == $auth->isAllowed($recipe, $role, 'comment')) {
            $form->auth_comment->setValue($role);
          }
        }
      }

      $roles_photo = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'registered');
      foreach ($roles_photo as $role_photo) {
        if ($form->auth_photo) {
          if (1 == $auth->isAllowed($recipe, $role_photo, 'photo')) {
            $form->auth_photo->setValue($role_photo);
          }
        }
      }

      $videoEnable = Engine_Api::_()->recipe()->enableVideoPlugin();
      if ($videoEnable) {
        $roles_video = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'registered');
        foreach ($roles_video as $role_video) {
          if ($form->auth_video) {
            if (1 == $auth->isAllowed($recipe, $role_video, 'video')) {
              $form->auth_video->setValue($role_video);
            }
          }
        }
      }

      return;
    }
    if (!$form->isValid($this->getRequest()->getPost())) {
      return;
    }

    // Process
    // handle save for tags
    $values = $form->getValues();

    $tags = preg_split('/[,]+/', $values['tags']);
    $tags = array_filter(array_map("trim", $tags));

    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    try {

      $recipe->setFromArray($values);
      $recipe->modified_date = date('Y-m-d H:i:s');

      $recipe->tags()->setTagMaps($viewer, $tags);
      $recipe->save();

      // Add fields
      $customfieldform = $form->getSubForm('fields');
      $customfieldform->setItem($recipe);
      $customfieldform->saveValues();



      // CREATE AUTH STUFF HERE
      $auth = Engine_Api::_()->authorization()->context;
      $roles = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
      $values = $form->getValues();
      if ($values['auth_view'])
        $auth_view = $values['auth_view'];
      else
        $auth_view = "everyone";
      $viewMax = array_search($auth_view, $roles);

      foreach ($roles as $i => $role) {
        $auth->setAllowed($recipe, $role, 'view', ($i <= $viewMax));
      }

      $roles = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
      if ($values['auth_comment'])
        $auth_comment = $values['auth_comment'];
      else
        $auth_comment = "everyone";
      $commentMax = array_search($auth_comment, $roles);

      foreach ($roles as $i => $role) {
        $auth->setAllowed($recipe, $role, 'comment', ($i <= $commentMax));
      }
      $roles = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'registered');
      if ($values['auth_photo'])
        $auth_photo = $values['auth_photo'];
      else
        $auth_photo = "registered";
      $photoMax = array_search($auth_photo, $roles);

      foreach ($roles as $i => $role) {
        $auth->setAllowed($recipe, $role, 'photo', ($i <= $photoMax));
      }

      $roles_video = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'registered');
      if (!isset($values['auth_video']) && empty($values['auth_video'])) {
        $values['auth_video'] = "registered";
      }

      $videoMax = array_search($values['auth_video'], $roles_video);
      foreach ($roles_video as $i => $role_video) {
        $auth->setAllowed($recipe, $role_video, 'video', ($i <= $videoMax));
      }


      $db->commit();
      $this->view->form = $form->addNotice(Zend_Registry::get('Zend_Translate')->_('Your changes have been saved.'));
    } catch (Exception $e) {
      $db->rollBack();
      throw $e;
    }
    Engine_Api::_()->recipe()->setLocation($recipe_id);
    $db->beginTransaction();
    try {

      // Rebuild privacy
      $actionTable = Engine_Api::_()->getDbtable('actions', 'activity');
      foreach ($actionTable->getActionsByObject($recipe) as $action) {
        $actionTable->resetActivityBindings($action);
      }
      $db->commit();
    } catch (Exception $e) {
      $db->rollBack();
      throw $e;
    }
    return $this->_helper->redirector->gotoRoute(array('action' => 'manage'), 'recipe_general', true);
  }

  // Overview FOR RECIPE RECIPENG
  public function overviewAction() {

    if (!$this->_helper->requireUser()->isValid())
      return;
    $this->view->TabActive = "overview";
    $this->view->recipe_id = $recipe_id = $this->_getParam('recipe_id');
    $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->recipe = $recipe = Engine_Api::_()->getItem('recipe', $recipe_id);

    $this->view->owner_id = $owner_id = $recipe['owner_id'];

    if (empty($recipe)) {
      return $this->_forward('requireauth', 'error', 'core');
    }

    // Check auth
    if (!$this->_helper->requireAuth()->setAuthParams($recipe, $viewer, 'edit')->isValid()) {
      return;
    }

    $viewer_id = $viewer->getIdentity();
    $this->view->allowed_upload_photo = $allowed_upload_photo = 0;
    $this->view->allowed_upload_video = 0;
    $subject_recipe = Engine_Api::_()->core()->getSubject();
    
//     //Check for member level setings base of Listing Owner.
//     if (Engine_Api::_()->recipe()->allowOverviewOfOwner($recipe->getOwner())) {
//       $this->view->allow_overview_of_owner = 1;
//     }
    
    // Check for video
    if (Engine_Api::_()->recipe()->allowVideo($subject_recipe, $viewer)) {
      $this->view->allowed_upload_video = 1;
    }

    $allowed_upload_photo = Engine_Api::_()->authorization()->isAllowed($subject_recipe, $viewer, 'photo');

    if ($allowed_upload_photo) {
      $this->view->allowed_upload_photo = $allowed_upload_photo;
    }

    if (!empty($recipe->overview))
      $overview = $recipe->overview;
    else
      $overview='';
    $this->view->form = $form = new Recipe_Form_Overview();

    if (!$this->getRequest()->isPost()) {

      $saved = $this->_getParam('saved');
      if (!empty($saved))
        $this->view->success = 'Your recipe has been successfully created. You can enhance your recipe from this dashboard by creating other components.';
    }
    if ($this->getRequest()->isPost()) {

      $overview = $_POST['overview'];
      $recipe->overview = $overview;
      $recipe->save();
      $this->view->form = $form->addNotice(Zend_Registry::get('Zend_Translate')->_('Your changes have been saved.'));
    }
    $values['overview'] = $overview;
    $form->populate($values);
  }

  //CHANGE STYLE OF RECIPE
  public function editstyleAction() {

    if (!$this->_helper->requireUser()->isValid())
      return;
    $this->view->TabActive = "style";
    $type = 'recipe_recipe';
    $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->recipe_id = $recipe_id = $this->_getParam('recipe_id');

    $viewer_id = $viewer->getIdentity();
    $this->view->recipe = $recipe = Engine_Api::_()->getItem('recipe', $recipe_id);

    if (empty($recipe)) {
      return $this->_forward('requireauth', 'error', 'core');
    }

    $this->view->owner_id = $owner_id = $recipe['owner_id'];

    // Check auth
    if (!$this->_helper->requireAuth()->setAuthParams($recipe, $viewer, 'edit')->isValid()) {
      return;
    }

    if (!$this->_helper->requireAuth()->setAuthParams('recipe', null, 'style')->isValid())
      return;

    $this->view->allowed_upload_photo = $allowed_upload_photo = 0;
    $this->view->allowed_upload_video = 0;

    // Check for video
    if (Engine_Api::_()->recipe()->allowVideo($recipe, $viewer)) {
      $this->view->allowed_upload_video = 1;
    }

    $subject_recipe = Engine_Api::_()->core()->getSubject();
    $allowed_upload_photo = Engine_Api::_()->authorization()->isAllowed($subject_recipe, $viewer, 'photo');
    if ($allowed_upload_photo) {
      $this->view->allowed_upload_photo = $allowed_upload_photo;
    }

    // Get form
    $this->view->form = $form = new Recipe_Form_Style();

    // Get current row
    $table = Engine_Api::_()->getDbtable('styles', 'core');
    $select = $table->select()
            ->where('type = ?', $type)
            ->where('id = ?', $recipe_id)
            ->limit();

    $row = $table->fetchRow($select);

    // Not posting, populate
    if (!$this->getRequest()->isPost()) {
      $form->populate(array(
              'style' => ( null == $row ? '' : $row->style )
      ));
      return;
    }

    // Whoops, form was not valid
    if (!$form->isValid($this->getRequest()->getPost())) {
      return;
    }

    // Cool! Process
    $style = $form->getValue('style');

    // Process
    $style = strip_tags($style);

    $forbiddenStuff = array(
            '-moz-binding',
            'expression',
            'javascript:',
            'behaviour:',
            'vbscript:',
            'mocha:',
            'livescript:',
    );
    $style = str_replace($forbiddenStuff, '', $style);

    // Save
    if (null == $row) {
      $row = $table->createRow();
      $row->type = $type;
      $row->id = $recipe_id;
    }
    $row->style = $style;
    $row->save();
    $form->addNotice(Zend_Registry::get('Zend_Translate')->_('Your changes have been saved.'));
  }

  // Delete recipe
  public function deleteAction() {

    if (!$this->_helper->requireUser()->isValid())
      return;

    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
            ->getNavigation('recipe_main', array(), 'recipe_main_manage');

    $viewer = Engine_Api::_()->user()->getViewer();
    $recipe_id = $this->_getParam('recipe_id');
    $this->view->recipe = $recipe = Engine_Api::_()->getItem('recipe', $recipe_id);

    // Check auth
    if (!$this->_helper->requireAuth()->setAuthParams($recipe, $viewer, 'delete')->isValid()) {
      return;
    }

    if ($this->getRequest()->isPost() && $this->getRequest()->getPost('confirm') == true) {
      $recipe->deleteRecipe();
      return $this->_helper->redirector->gotoRoute(array('action' => 'manage'), 'recipe_general', true);
    }
  }

  // CLOSE / OPEN RECIPE
  public function closeAction() {

    if (!$this->_helper->requireUser()->isValid())
      return;

    $viewer = Engine_Api::_()->user()->getViewer();
    $recipe = Engine_Api::_()->getItem('recipe', $this->_getParam('recipe_id'));

    $this->view->recipe = $recipe;
    if (!$this->_helper->requireAuth()->setAuthParams($recipe, $viewer, 'edit')->isValid()) {
      return;
    }
    $table = $recipe->getTable();
    $db = $table->getAdapter();
    $db->beginTransaction();

    try {
      $recipe->closed = $this->_getParam('closed');
      $recipe->save();
      $db->commit();
    } catch (Exception $e) {
      $db->rollBack();
      throw $e;
    }
    return $this->_helper->redirector->gotoRoute(array('action' => 'manage'), 'recipe_general', true);
  }

  //recipe rating
  public function rateAction() {

    $viewer = Engine_Api::_()->user()->getViewer();
    $user_id = $viewer->getIdentity();

    // get rating which give viewr
    $rating = $this->_getParam('rating');

    // get recipe Id of recipe which give rating
    $recipe_id = $this->_getParam('recipe_id');
    $table = Engine_Api::_()->getDbtable('ratings', 'recipe');
    $db = $table->getAdapter();
    $db->beginTransaction();
    $total = 0;
    try {
      if (!Engine_Api::_()->recipe()->checkRated($recipe_id, $user_id)) {
        Engine_Api::_()->recipe()->setRating($recipe_id, $user_id, $rating);

        // get count ratings of recipe
        $total = Engine_Api::_()->recipe()->ratingCount($recipe_id);
        // get Avrage rating for recipe
        $recipe = Engine_Api::_()->getItem('recipe', $recipe_id)->setRating($rating, $total);
      }
      $db->commit();
    } catch (Exception $e) {
      $db->rollBack();
      throw $e;
    }
    $data = array();
    $data[] = array(
            'total' => $total,
            'rating' => $rating,
    );
    return $this->_helper->json($data);
    $data = Zend_Json::encode($data);
    $this->getResponse()->setBody($data);
  }

  //ACTION FOR CONSTRUCT TAG CLOUD
  public function tagscloudAction() {

    // Get navigation
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
            ->getNavigation('recipe_main');

    //GENERATE TAG-CLOULD HIDDEN FROM
    $this->view->form = $form = new Recipe_Form_Searchtagcloud();

    //CONSTRUCTING TAG CLOUD
    $tag_array = array();
    $tag_cloud_array = Engine_Api::_()->getDbtable('recipes', 'recipe')->getTagCloud('', 0);
    foreach ($tag_cloud_array as $vales) {

      $tag_array[$vales['text']] = $vales['Frequency'];
      $tag_id_array[$vales['text']] = $vales['tag_id'];
    }

    if (!empty($tag_array)) {

      $max_font_size = 18;
      $min_font_size = 12;
      $max_frequency = max(array_values($tag_array));
      $min_frequency = min(array_values($tag_array));
      $spread = $max_frequency - $min_frequency;

      if ($spread == 0) {
        $spread = 1;
      }

      $step = ($max_font_size - $min_font_size) / ($spread);

      $tag_data = array('min_font_size' => $min_font_size, 'max_font_size' => $max_font_size, 'max_frequency' => $max_frequency, 'min_frequency' => $min_frequency, 'step' => $step);

      $this->view->tag_data = $tag_data;
      $this->view->tag_id_array = $tag_id_array;
    }
    $this->view->tag_array = $tag_array;
  }

  // tell a friend overview recipe by email
  public function tellafriendAction() {

    $this->_helper->layout->setLayout('default-simple');
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewr_id = $viewer->getIdentity();

    // Get form
    $this->view->form = $form = new Recipe_Form_TellAFriend();

    if (!empty($viewr_id)) {

      $value['sender_email'] = $viewer->email;
      $value['sender_name'] = $viewer->displayname;
      $form->populate($value);
    }

    // If not post or form not valid, return
    if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {

      $id = $this->_getParam('recipe_id', $this->_getParam('id', null));
      $recipe = Engine_Api::_()->getItem('recipe', $id);
      $values = $form->getValues();

      // explodes emails ids
      $reciver_ids = explode(',', $values['reciver_emails']);
      if (!empty($values['send_me'])) {
        $reciver_ids[] = $values['sender_email'];
      }
      $sender_email = $values['sender_email'];
      $heading = $recipe->title;
      // check valide email id formaite
      $validator = new Zend_Validate_EmailAddress();
      $validator->getHostnameValidator()->setValidateTld(false);

      if (!$validator->isValid($sender_email)) {
        $form->addError(Zend_Registry::get('Zend_Translate')->_('Invalid sender email address value'));
        return;
      }
      foreach ($reciver_ids as $reciver_id) {
        $reciver_id = trim($reciver_id, ' ');
        if (!$validator->isValid($reciver_id)) {
          $form->addError(Zend_Registry::get('Zend_Translate')->_('Please enter correct email address of the receiver(s).'));
          return;
        }
      }
      $sender = $values['sender_name'];
      $message = $values['message'];

      Engine_Api::_()->getApi('mail', 'core')->sendSystem($reciver_ids, 'RECIPE_TELLAFRIEND_EMAIL', array(
              'host' => $_SERVER['HTTP_HOST'],
              'sender' => $sender,
              'heading' => $heading,
              'message' => '<div>' . $message . '</div>',
              'object_link' => Engine_Api::_()->recipe()->getHref($recipe->recipe_id, $recipe->owner_id, $recipe->getSlug()),
              'email' => $sender_email,
              'queue' => false
      ));

//      // send copy of email also sender if he wants
//      if (!empty($values['send_me'])) {
//
//        Engine_Api::_()->getApi('mail', 'core')->sendSystem($sender_email, 'RECIPE_TELLAFRIEND_EMAIL', array(
//                'host' => $_SERVER['HTTP_HOST'],
//                'sender' => $sender,
//                'heading' => $heading,
//                'message' => '<div>' . $message . '</div>',
//                'object_link' => Engine_Api::_()->recipe()->getHref($recipe->recipe_id, $recipe->owner_id, $recipe->getSlug()),
//                'email' => $sender_email,
//                'queue' => false
//        ));
//      }
      $this->_forward('success', 'utility', 'core', array(
              'smoothboxClose' => true,
              'parentRefreshTime' => '15',
              'format' => 'smoothbox',
              'messages' => Zend_Registry::get('Zend_Translate')->_('Your message to your friend has been sent successfully.')
      ));
    }
  }

  public function printAction() {
$this->_helper->layout->setLayout('default-simple');
    $id = $this->_getParam('recipe_id', $this->_getParam('id', null));
    $this->view->recipe = $recipe = Engine_Api::_()->getItem('recipe', $id);

    if ($recipe->category_id != 0)
      $this->view->category = $ct = Engine_Api::_()->recipe()->getCategory($recipe->category_id);

    if ($recipe->subcategory_id != 0)
      $this->view->subcategory = $subct = Engine_Api::_()->recipe()->getSubCategory($recipe->subcategory_id);

    $this->view->addHelperPath(APPLICATION_PATH . '/application/modules/Fields/View/Helper', 'Fields_View_Helper');
    $this->view->fieldStructure = $fieldStructure = Engine_Api::_()->fields()->getFieldsStructurePartial($recipe);
  }

  public function editlocationAction() {

    if (!Engine_Api::_()->recipe()->enableLocation()) {
      return $this->_forward('requireauth', 'error', 'core');
    }
    $this->view->TabActive = "location";
    $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->recipe_id = $recipe_id = $this->_getParam('recipe_id');
    $this->view->recipe = $recipe = Engine_Api::_()->getItem('recipe', $recipe_id);
    $this->view->owner_id = $owner_id = $recipe['owner_id'];

    $this->view->recipe = $recipe = Engine_Api::_()->getItem('recipe', $recipe_id);

    if (empty($recipe)) {
      return $this->_forward('requireauth', 'error', 'core');
    }

    // Check auth   
    if (!$this->_helper->requireAuth()->setAuthParams($recipe, $viewer, 'edit')->isValid()) {
      return;
    }

    $viewer_id = $viewer->getIdentity();

    $this->view->allowed_upload_photo = $allowed_upload_photo = 0;
    $this->view->allowed_upload_video = 0;
    $subject_recipe = Engine_Api::_()->core()->getSubject();
    // Check for video
    if (Engine_Api::_()->recipe()->allowVideo($recipe, $viewer)) {
      $this->view->allowed_upload_video = 1;
    }

    $allowed_upload_photo = Engine_Api::_()->authorization()->isAllowed($subject_recipe, $viewer, 'photo');

    if ($allowed_upload_photo) {
      $this->view->allowed_upload_photo = $allowed_upload_photo;
    }

    $value['id'] = $recipe->getIdentity();
    $this->view->location = $location = Engine_Api::_()->recipe()->getLocation($value);

    // Get form
    if (!empty($location)) {

      $this->view->form = $form = new Recipe_Form_Location(array(
                  'item' => $recipe,
                  'location' => $location->location
          ));

      if (!$this->getRequest()->isPost()) {
        $form->populate($location->toarray()
        );
        return;
      }

      // Whoops, form was not valid
      if (!$form->isValid($this->getRequest()->getPost())) {
        return;
      }

      // Whoops, form was not valid
      if ($form->isValid($this->getRequest()->getPost())) {

        $values = $form->getValues();
        unset($values['submit']);
        unset($values['location']);
        $locationTable = Engine_Api::_()->getDbtable('locations', 'recipe');

        $locationTable->update($values
            , array(
                'recipe_id =?' => $recipe_id
        ));
      }

      $form->addNotice(Zend_Registry::get('Zend_Translate')->_('Your changes have been saved.'));
    }
    $this->view->location = $location = Engine_Api::_()->recipe()->getLocation($value);
  }

  public function editaddressAction() {

    $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->recipe_id = $recipe_id = $this->_getParam('recipe_id');

    $this->view->recipe = $recipe = Engine_Api::_()->getItem('recipe', $recipe_id);
    if (empty($recipe)) {
      return $this->_forward('requireauth', 'error', 'core');
    }

    $this->view->form = $form = new Recipe_Form_Address(array(
                'item' => $recipe
        ));

    if (!$this->getRequest()->isPost()) {

      $form->populate($recipe->toArray());
      return;
    }

    // Whoops, form was not valid
    if (!$form->isValid($this->getRequest()->getPost())) {
      return;
    }

    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    try {

      $values = $form->getValues();
      $val['fields'] = $values;
      $recipe->setFromArray($val);
      $recipe->save();
      $form->saveValues();
      $location = '';
      unset($values['submit']);

      foreach ($values as $key => $locationValue) {
        $location = $locationValue;
        break;
      }

      $db->commit();
      $locationTable = Engine_Api::_()->getDbtable('locations', 'recipe');
      if (!empty($location)) {
        Engine_Api::_()->recipe()->setLocation($recipe_id);

        $locationTable->update(array('location' => $location)
            , array(
                'recipe_id =?' => $recipe_id
        ));
      } else {
        $locationTable->delete(array(
                'recipe_id =?' => $recipe_id
        ));
      }
      $this->_forward('success', 'utility', 'core', array(
              'smoothboxClose' => 500,
              'parentRefresh' => 500,
              'messages' => array('Your recipe location has been modified successfully.')
      ));
    } catch (Exception $e) {
      $db->rollBack();
      throw $e;
    }
  }

  public function selectsubcategoryAction() {

    $category_id_temp = $_GET['category_id_temp'];
    $data = array();
    $this->view->subcats = $data;
    if (empty($category_id_temp))
      return;
    $results = Engine_Api::_()->getDbTable('categories', 'recipe')->getSubCategories($category_id_temp);
    foreach ($results as $value) {
      $content_array['category_name'] = Zend_Registry::get('Zend_Translate')->_($value->category_name);
      $content_array['category_id'] = $value->category_id;
      $data[] = $content_array;
    }
    $this->view->subcats = $data;
  }

  //ACTION FOR DOCUMENT PUBLISH
  public function publishAction() {

    //CHECK USER VALIDATION
    if (!$this->_helper->requireUser()->isValid())
      return;

    //SMOOTHBOX
    if (null == $this->_helper->ajaxContext->getCurrentContext()) {
      $this->_helper->layout->setLayout('default-simple');
    } else {
      //NO LAYOUT
      $this->_helper->layout->disableLayout(true);
    }

    $recipe_id = $this->view->recipe_id = $this->_getParam('recipe_id');

    if (!$this->getRequest()->isPost())
      return;

    $recipe = Engine_Api::_()->getItem('recipe', $recipe_id);
    $owner_id = $recipe->owner_id;

    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();

    if ($viewer_id == $recipe->owner_id) {

      $this->view->permission = true;
      $this->view->success = false;
      $db = Engine_Api::_()->getDbtable('recipes', 'recipe')->getAdapter();
      $db->beginTransaction();
      try {
        $recipe->modified_date = new Zend_Db_Expr('NOW()');
        $recipe->draft = 1;
        $recipe->save();
        $db->commit();
        $this->view->success = true;
      } catch (Exception $e) {
        $db->rollback();
        throw $e;
      }
    } else {
      $this->view->permission = false;
    }
    $this->_forward('success', 'utility', 'core', array(
            'smoothboxClose' => 10,
            'parentRefresh' => 10,
            'messages' => array('Successfully Published !')
    ));
  }

  public function ajaxhomerecipeAction() { 
    $tab_show_values = $this->_getParam('tab_show', null);
    $this->view->active_tab1 = 0;
    $this->view->active_tab2 = 0;
    $this->view->active_tab3 = 0;
    $this->view->active_tab4 = 0;
    $this->view->active_tab5 = 0;
    $this->view->active_tab_recipe = 0;
    $this->view->active_tab_image = 0;

    $ShowViewArray = Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.ajax.widgets.layout', array("0" => "1", "1" => "2", "2" => "3"));
    switch ($tab_show_values) {

      case "Recently Posted":

        $this->view->reciperecipe = $recipe = Engine_Api::_()->recipe()->getLising('Recently Posted');
        $this->view->active_tab1 = 1;
        $this->view->active_tab_recipe = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.recent.widgets', 10);
        $this->view->active_tab_image = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.recent.thumbs', 15);
        break;

      case "Most Viewed":
        // GET SITEPAGE SITEPAGE FOR MOST viewED
        $this->view->reciperecipe = $recipe = Engine_Api::_()->recipe()->getLising('Most Viewed');
        $this->view->active_tab2 = 1;
        $this->view->active_tab_recipe = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.popular.widgets', 10);
        $this->view->active_tab_image = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.popular.thumbs', 15);

        break;
      case "Random":
        $this->view->reciperecipe = $recipe = Engine_Api::_()->recipe()->getLising('Random');
        $this->view->active_tab3 = 1;
        $this->view->active_tab_recipe = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.random.widgets', 10);
        $this->view->active_tab_image = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.random.thumbs', 15);

        break;
      case "Featured":
        $this->view->reciperecipe = $recipe = Engine_Api::_()->recipe()->getLising('Featured');
        $this->view->active_tab4 = 1;
        $this->view->active_tab_recipe = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.featured.recipe', 10);
        $this->view->active_tab_image = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.featured.thumbs', 15);

        break;
      case "Sponosred":
        $this->view->reciperecipe = $recipe = Engine_Api::_()->recipe()->getLising('Sponosred');
        $this->view->active_tab5 = 1;
        $this->view->active_tab_recipe = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.sponsored.recipe', 10);
        $this->view->active_tab_image = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.sponosred.thumbs', 15);

        break;
    }
    $this->view->list_view = 0;
    $this->view->grid_view = 0;
    $this->view->map_view = 0;
    $defaultOrder = Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.ajax.layouts.oder', 1);
    $this->view->defaultView = -1;
    if (in_array("1", $ShowViewArray)) {
      $this->view->list_view = 1;
      if ($this->view->defaultView == -1 || $defaultOrder == 1)
        $this->view->defaultView = 0;
    }
    if (in_array("2", $ShowViewArray)) {
      $this->view->grid_view = 1;
      if ($this->view->defaultView == -1 || $defaultOrder == 2)
        $this->view->defaultView = 1;
    }
    if (in_array("3", $ShowViewArray)) {
      $this->view->map_view = 1;
      if ($this->view->defaultView == -1 || $defaultOrder == 3)
        $this->view->defaultView = 2;
    }
    $this->view->enableLocation = $checkLocation = Engine_Api::_()->recipe()->enableLocation();
    if (!empty($this->view->map_view)) {

      $this->view->flageSponsored = 0;

      if (!empty($checkLocation)) {
        $ids = array();
        $sponsored = array();
        foreach ($recipe as $recipe_recipe) {
          $id = $recipe_recipe->getIdentity();
          $ids[] = $id;
          $recipe_temp[$id] = $recipe_recipe;
        }
        $values['recipe_ids'] = $ids;

        $this->view->locations = $locations = Engine_Api::_()->recipe()->getLocation($values);
        foreach ($locations as $location) {
          if ($recipe_temp[$location->recipe_id]->sponsored) {
            $this->view->flageSponsored = 1;
            break;
          }
        }
        $this->view->recipe = $recipe_temp;
      }
    }
// Rating enable /disable
    $this->view->ratngShow = $ratingShow = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.rating', 1);

    $view = $this->view;
    $view->addHelperPath(APPLICATION_PATH . '/application/modules/Fields/View/Helper', 'Fields_View_Helper');
  }

  public function messageownerAction() {

    if (!$this->_helper->requireUser()->isValid())
      return;

    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();

    $recipe_id = $this->_getParam("recipe_id");
    $recipe = Engine_Api::_()->getItem('recipe', $recipe_id);

    if ($viewer_id == $recipe->owner_id) {
      return $this->_forward('requireauth', 'error', 'core');
    }

    $this->view->form = $form = new Messages_Form_Compose();
    $form->setDescription('Create your message with the form given below. (This message will be sent to the owner of this Recipe.)');
    $form->removeElement('to');

    $form->toValues->setValue("$recipe->owner_id");
    //$form->title->setValue('Please put dummy title here !');
    //$form->body->setValue('Please put dummy message here !');
    // Check method/data
    if (!$this->getRequest()->isPost()) {
      return;
    }

    $db = Engine_Api::_()->getDbtable('messages', 'messages')->getAdapter();
    $db->beginTransaction();

    try {
      $values = $this->getRequest()->getPost();
      $recipients = preg_split('/[,. ]+/', $values['toValues']);

      // limit recipients if it is not a special recipe of members
      $recipients = array_slice($recipients, 0, 1000);

      // clean the recipients for repeating ids
      $recipients = array_unique($recipients);

      $user = Engine_Api::_()->getItem('user', $recipe->owner_id);

      $recipe_title = $recipe->title;
      $recipe_title_with_link = '<a href = http://' . $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getRouter()->assemble(array('recipe_id' => $recipe_id, 'user_id' => $recipe->owner_id, 'slug' => $recipe->getSlug()), 'recipe_entry_view') . ">$recipe_title</a>";

      $conversation = Engine_Api::_()->getItemTable('messages_conversation')->send(
              $viewer,
              $recipients,
              $values['title'],
              $values['body'] . "<br><br>" . $this->view->translate('This message corresponds to the Recipe: ') . $recipe_title_with_link
      );

      Engine_Api::_()->getDbtable('notifications', 'activity')->addNotification(
          $user,
          $viewer,
          $conversation,
          'message_new'
      );

      // Increment messages counter
      Engine_Api::_()->getDbtable('statistics', 'core')->increment('messages.creations');

      $db->commit();

      return $this->_forward('success', 'utility', 'core', array(
              'smoothboxClose' => true,
              'parentRefresh' => true,
              'messages' => array(Zend_Registry::get('Zend_Translate')->_('Your message has been sent successfully.'))
      ));
    } catch (Exception $e) {
      $db->rollBack();
      throw $e;
    }
  }
  
  public function changePhotoAction() {

    //CHECK USER VALIDATION
    if (!$this->_helper->requireUser()->isValid())
      return;

    //GET RECIPEING ID
    $this->view->recipe_id = $recipe_id = $this->_getParam('recipe_id');

    $viewer = Engine_Api::_()->user()->getViewer();
    
    //GET RECIPEING ITEM
    $this->view->recipe = $recipe = Engine_Api::_()->getItem('recipe', $recipe_id);

    //IF THERE IS NO RECIPE
    if (empty($recipe)) {
      return $this->_forward('requireauth', 'error', 'core');
    }

    // Check auth   
    if (!$this->_helper->requireAuth()->setAuthParams($recipe, $viewer, 'edit')->isValid()) {
      return;
    }    
    
    //GET FORM
    $this->view->form = $form = new Recipe_Form_ChangePhoto();

    //CHECK FORM VALIDATION
    if (!$this->getRequest()->isPost()) {
      return;
    }

    //CHECK FORM VALIDATION
    if (!$form->isValid($this->getRequest()->getPost())) {
      return;
    }

    //UPLOAD PHOTO
    if ($form->Filedata->getValue() !== null) {
      //GET DB
      $db = $recipe->getTable()->getAdapter();
      $db->beginTransaction();
      //PROCESS
      try {
        //SET PHOTO
        $recipe->setPhoto($form->Filedata);
        $db->commit();
      } catch (Engine_Image_Adapter_Exception $e) {
        $db->rollBack();
        $form->addError(Zend_Registry::get('Zend_Translate')->_('The uploaded file is not supported or is corrupt.'));
      } catch (Exception $e) {
        $db->rollBack();
        throw $e;
      }
    } else if ($form->getValue('coordinates') !== '') {
      $storage = Engine_Api::_()->storage();
      $iProfile = $storage->get($recipe->photo_id, 'thumb.profile');
      $iSquare = $storage->get($recipe->photo_id, 'thumb.icon');
      $pName = $iProfile->getStorageService()->temporary($iProfile);
      $iName = dirname($pName) . '/nis_' . basename($pName);
      list($x, $y, $w, $h) = explode(':', $form->getValue('coordinates'));
      $image = Engine_Image::factory();
      $image->open($pName)
              ->resample($x + .1, $y + .1, $w - .1, $h - .1, 48, 48)
              ->write($iName)
              ->destroy();
      $iSquare->store($iName);
      @unlink($iName);
    }
    
    $action = Engine_Api::_()->getDbtable('actions', 'activity')->addActivity($viewer, $recipe, 'recipe_change_photo');
    $file_id = Engine_Api::_()->getDbtable('photos', 'recipe')->getPhotoId($recipe_id, $recipe->photo_id);

    $photo = Engine_Api::_()->getItem('recipe_photo', $file_id);
 
    if ($action != null) {
      Engine_Api::_()->getDbtable('actions', 'activity')->attachActivity($action, $photo);
    }
                    
    return $this->_helper->redirector->gotoRoute(array('recipe_id' => $recipe_id), 'recipe_changephoto', true);

  }

  //ACTION FOR REMOVE THE PHOTO
  public function removePhotoAction() {

    //CHECK USER VALIDATION
    if (!$this->_helper->requireUser()->isValid())
      return;

    //GET RECIPEING ID
    $recipe_id = $this->_getParam('recipe_id');

    //GET RECIPEING ITEM
    $recipe = Engine_Api::_()->getItem('recipe', $recipe_id);
    $viewer = Engine_Api::_()->user()->getViewer();
    
    // Check auth   
    if (!$this->_helper->requireAuth()->setAuthParams($recipe, $viewer, 'edit')->isValid()) {
      return;
    }   
    
    //GET PHOTO ID
    $photo_id = $recipe->photo_id;

    //GET FILE ID
    $file_id = Engine_Api::_()->getDbtable('photos', 'recipe')->getPhotoId($recipe_id, $photo_id);

    //DELETE PHOTO
    if (!empty($file_id)) {
      $photo = Engine_Api::_()->getItem('recipe_photo', $file_id);
      $photo->delete();
    }

    //SET PHOTO ID TO ZERO
    $recipe->photo_id = 0;
    $recipe->save();
    
    return $this->_helper->redirector->gotoRoute(array('recipe_id' => $recipe_id), 'recipe_changephoto', true);

  }

}