<?php
	$contentTable = Engine_Api::_()->getDbtable('content', 'core');
	$contentTableName = $contentTable->info('name');
	$pageTable = Engine_Api::_()->getDbtable('pages', 'core');
	$pageTableName = $pageTable->info('name');


	// Make a Widgitized Page (recipe_index_home) & widgets.

	$selectPage  = $pageTable->select()
		->from($pageTableName, array('page_id'))
		->where('name =?', 'recipe_index_home')
		->limit(1);
	$fetchPageId = $selectPage->query()->fetchAll();
	if( empty($fetchPageId) ) {
		$pageCreate = $pageTable->createRow();
		$pageCreate->name = 'recipe_index_home';
		$pageCreate->displayname = 'Recipes Home';
		$pageCreate->title = 'Recipes Home';
		$pageCreate->description = 'This is the recipe home page.';
		$pageCreate->custom = 1;
		$pageCreate->save();
		$page_id = $pageCreate->page_id;

		// Insert Main Container.
		$mainContainer = $contentTable->createRow();
		$mainContainer->page_id = $page_id;
		$mainContainer->type = 'container';
		$mainContainer->name = 'main';
		$mainContainer->order = 2;
		$mainContainer->save();
		$container_id = $mainContainer->content_id;

		// Insert Main-Middle Container.
		$mainMiddleContainer = $contentTable->createRow();
		$mainMiddleContainer->page_id = $page_id;
		$mainMiddleContainer->type = 'container';
		$mainMiddleContainer->name = 'middle';
		$mainMiddleContainer->parent_content_id = $container_id;
		$mainMiddleContainer->order = 6;
		$mainMiddleContainer->save();
		$middle_id = $mainMiddleContainer->content_id;


		// Insert Main-Left Container.
		$mainLeftContainer = $contentTable->createRow();
		$mainLeftContainer->page_id = $page_id;
		$mainLeftContainer->type = 'container';
		$mainLeftContainer->name = 'left';
		$mainLeftContainer->parent_content_id = $container_id;
		$mainLeftContainer->order = 4;
		$mainLeftContainer->save();
		$left_id = $mainLeftContainer->content_id;

		// Insert Main-Right Container.
		$mainRightContainer = $contentTable->createRow();
		$mainRightContainer->page_id = $page_id;
		$mainRightContainer->type = 'container';
		$mainRightContainer->name = 'right';
		$mainRightContainer->parent_content_id = $container_id;
		$mainRightContainer->order = 5;
		$mainRightContainer->save();
		$right_id = $mainRightContainer->content_id;

		//Insert Top Container.
		$topContainer = $contentTable->createRow();
		$topContainer->page_id = $page_id;
		$topContainer->type = 'container';
		$topContainer->name = 'top';
		$topContainer->order = 1;
		$topContainer->save();
		$top_id = $topContainer->content_id;

		//Insert Top-Middle Container.
		$topMiddleContainer = $contentTable->createRow();
		$topMiddleContainer->page_id = $page_id;
		$topMiddleContainer->type = 'container';
		$topMiddleContainer->name = 'middle';
		$topMiddleContainer->parent_content_id = $top_id;
		$topMiddleContainer->order = 1;
		$topMiddleContainer->save();
		$top_middle_id = $topMiddleContainer->content_id;

		$selectWidgetId  = $contentTable->select()
			->from($contentTableName, array('content_id'))					
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'recipe.browsenevigation-recipe')
			->where('parent_content_id = ?', $top_middle_id)
			->limit(1);
		$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
		if ( empty($fetchWidgetContentId) ) {
			$contentWidget = $contentTable->createRow();
			$contentWidget->page_id = $page_id;
			$contentWidget->type = 'widget';
			$contentWidget->name = 'recipe.browsenevigation-recipe';
			$contentWidget->parent_content_id = $top_middle_id;
			$contentWidget->order = 1;
			$contentWidget->params = '{"title":"","titleCount":"true"}';
			$contentWidget->save();
		}

		$selectWidgetId  = $contentTable->select()
			->from($contentTableName, array('content_id'))					
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'recipe.zerorecipe-recipe')
			->where('parent_content_id = ?', $middle_id)
			->limit(1);
		$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
		if ( empty($fetchWidgetContentId) ) {
			$contentWidget = $contentTable->createRow();
			$contentWidget->page_id = $page_id;
			$contentWidget->type = 'widget';
			$contentWidget->name = 'recipe.zerorecipe-recipe';
			$contentWidget->parent_content_id = $middle_id;
			$contentWidget->order = 2;
			$contentWidget->params = '{"title":"","titleCount":"true"}';
			$contentWidget->save();
		}

		$selectWidgetId  = $contentTable->select()
			->from($contentTableName, array('content_id'))					
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'recipe.slideshow-recipe')
			->where('parent_content_id = ?', $middle_id)
			->limit(1);
		$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
		if ( empty($fetchWidgetContentId) ) {
			$contentWidget = $contentTable->createRow();
			$contentWidget->page_id = $page_id;
			$contentWidget->type = 'widget';
			$contentWidget->name = 'recipe.slideshow-recipe';
			$contentWidget->parent_content_id = $middle_id;
			$contentWidget->order = 3;
			$contentWidget->params = '{"title":"Featured Recipes","titleCount":"true"}';
			$contentWidget->save();
		}

		$selectWidgetId  = $contentTable->select()
			->from($contentTableName, array('content_id'))					
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'recipe.categories')
			->where('parent_content_id = ?', $middle_id)
			->limit(1);
		$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
		if ( empty($fetchWidgetContentId) ) {
			$contentWidget = $contentTable->createRow();
			$contentWidget->page_id = $page_id;
			$contentWidget->type = 'widget';
			$contentWidget->name = 'recipe.categories';
			$contentWidget->parent_content_id = $middle_id;
			$contentWidget->order = 4;
			$contentWidget->params = '{"title":"Categories","titleCount":"true"}';
			$contentWidget->save();
		}


		$selectWidgetId = $contentTable->select()
			->from($contentTableName, array('content_id'))
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'recipe.recently-popular-random-recipe')
			->where('parent_content_id = ?', $middle_id)
			->limit(1);
			$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
			if (empty($fetchWidgetContentId)) {
				$contentWidget = $contentTable->createRow();
				$contentWidget->page_id = $page_id;
				$contentWidget->type = 'widget';
				$contentWidget->name = 'recipe.recently-popular-random-recipe';
				$contentWidget->parent_content_id = $middle_id;
				$contentWidget->order = 5;
				$contentWidget->params = '{"title":"","titleCount":""}';
				$contentWidget->save();
			}

		$selectWidgetId  = $contentTable->select()
			->from($contentTableName, array('content_id'))					
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'recipe.search-recipe')
			->where('parent_content_id = ?', $right_id)
			->limit(1);
		$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
		if ( empty($fetchWidgetContentId) ) {
			$contentWidget = $contentTable->createRow();
			$contentWidget->page_id = $page_id;
			$contentWidget->type = 'widget';
			$contentWidget->name = 'recipe.search-recipe';
			$contentWidget->parent_content_id = $right_id;
			$contentWidget->order = 9;
			$contentWidget->params = '{"title":"","titleCount":"true"}';
			$contentWidget->save();
		}

		$selectWidgetId  = $contentTable->select()
			->from($contentTableName, array('content_id'))					
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'recipe.newrecipe-recipe')
			->where('parent_content_id = ?', $right_id)
			->limit(1);
		$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
		if ( empty($fetchWidgetContentId) ) {
			$contentWidget = $contentTable->createRow();
			$contentWidget->page_id = $page_id;
			$contentWidget->type = 'widget';
			$contentWidget->name = 'recipe.newrecipe-recipe';
			$contentWidget->parent_content_id = $right_id;
			$contentWidget->order = 10;
			$contentWidget->params = '{"title":"","titleCount":"true"}';
			$contentWidget->save();
		}

		$selectWidgetId  = $contentTable->select()
			->from($contentTableName, array('content_id'))					
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'recipe.sponsored-recipe')
			->where('parent_content_id = ?', $right_id)
			->limit(1);
		$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
		if ( empty($fetchWidgetContentId) ) {
			$contentWidget = $contentTable->createRow();
			$contentWidget->page_id = $page_id;
			$contentWidget->type = 'widget';
			$contentWidget->name = 'recipe.sponsored-recipe';
			$contentWidget->parent_content_id = $right_id;
			$contentWidget->order = 11;
			$contentWidget->params = '{"title":"Sponsored Recipes","titleCount":"true"}';
			$contentWidget->save();
		}

		$selectWidgetId  = $contentTable->select()
			->from($contentTableName, array('content_id'))					
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'recipe.tagcloud-recipe')
			->where('parent_content_id = ?', $right_id)
			->limit(1);
		$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
		if ( empty($fetchWidgetContentId) ) {
			$contentWidget = $contentTable->createRow();
			$contentWidget->page_id = $page_id;
			$contentWidget->type = 'widget';
			$contentWidget->name = 'recipe.tagcloud-recipe';
			$contentWidget->parent_content_id = $right_id;
			$contentWidget->order = 12;
			$contentWidget->params = '{"title":"","titleCount":"true"}';
			$contentWidget->save();
		}

		$selectWidgetId  = $contentTable->select()
			->from($contentTableName, array('content_id'))					
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'recipe.mostdiscussion-recipe')
			->where('parent_content_id = ?', $right_id)
			->limit(1);
		$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
		if ( empty($fetchWidgetContentId) ) {
			$contentWidget = $contentTable->createRow();
			$contentWidget->page_id = $page_id;
			$contentWidget->type = 'widget';
			$contentWidget->name = 'recipe.mostdiscussion-recipe';
			$contentWidget->parent_content_id = $right_id;
			$contentWidget->order = 14;
			$contentWidget->params = '{"title":"Most Discussed Recipes","titleCount":"true"}';
			$contentWidget->save();
		}

		$selectWidgetId  = $contentTable->select()
			->from($contentTableName, array('content_id'))					
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'recipe.mostrated-recipe')
			->where('parent_content_id = ?', $left_id)
			->limit(1);
		$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
		if ( empty($fetchWidgetContentId) ) {
			$contentWidget = $contentTable->createRow();
			$contentWidget->page_id = $page_id;
			$contentWidget->type = 'widget';
			$contentWidget->name = 'recipe.mostrated-recipe';
			$contentWidget->parent_content_id = $left_id;
			$contentWidget->order = 15;
			$contentWidget->params = '{"title":"Top Rated Recipes","titleCount":"true"}';
			$contentWidget->save();
		}

		$selectWidgetId  = $contentTable->select()
			->from($contentTableName, array('content_id'))					
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'recipe.mostlikes-recipe')
			->where('parent_content_id = ?', $left_id)
			->limit(1);
		$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
		if ( empty($fetchWidgetContentId) ) {
			$contentWidget = $contentTable->createRow();
			$contentWidget->page_id = $page_id;
			$contentWidget->type = 'widget';
			$contentWidget->name = 'recipe.mostlikes-recipe';
			$contentWidget->parent_content_id = $left_id;
			$contentWidget->order = 16;
			$contentWidget->params = '{"title":"Most Liked Recipes","titleCount":"true"}';
			$contentWidget->save();
		}

		$selectWidgetId  = $contentTable->select()
			->from($contentTableName, array('content_id'))					
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'recipe.mostcommented-recipe')
			->where('parent_content_id = ?', $left_id)
			->limit(1);
		$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
		if ( empty($fetchWidgetContentId) ) {
			$contentWidget = $contentTable->createRow();
			$contentWidget->page_id = $page_id;
			$contentWidget->type = 'widget';
			$contentWidget->name = 'recipe.mostcommented-recipe';
			$contentWidget->parent_content_id = $left_id;
			$contentWidget->order = 17;
			$contentWidget->params = '{"title":"Most Commented Recipes","titleCount":"true"}';
			$contentWidget->save();
		}

		$selectWidgetId  = $contentTable->select()
			->from($contentTableName, array('content_id'))					
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'recipe.item-recipe')
			->where('parent_content_id = ?', $left_id)
			->limit(1);
		$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
		if ( empty($fetchWidgetContentId) ) {
			$contentWidget = $contentTable->createRow();
			$contentWidget->page_id = $page_id;
			$contentWidget->type = 'widget';
			$contentWidget->name = 'recipe.item-recipe';
			$contentWidget->parent_content_id = $left_id;
			$contentWidget->order = 18;
			$contentWidget->params = '{"title":"Recipe of the day","titleCount":"true"}';
			$contentWidget->save();
		}

		$selectWidgetId  = $contentTable->select()
			->from($contentTableName, array('content_id'))					
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'recipe.recentview-recipe')
			->where('parent_content_id = ?', $left_id)
			->limit(1);
		$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
		if ( empty($fetchWidgetContentId) ) {
			$contentWidget = $contentTable->createRow();
			$contentWidget->page_id = $page_id;
			$contentWidget->type = 'widget';
			$contentWidget->name = 'recipe.recentview-recipe';
			$contentWidget->parent_content_id = $left_id;
			$contentWidget->order = 19;
			$contentWidget->params = '{"title":"Recently Viewed","titleCount":"true"}';
			$contentWidget->save();
		}

		$selectWidgetId  = $contentTable->select()
			->from($contentTableName, array('content_id'))					
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'recipe.recentfriend-recipe')
			->where('parent_content_id = ?', $left_id)
			->limit(1);
		$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
		if ( empty($fetchWidgetContentId) ) {
			$contentWidget = $contentTable->createRow();
			$contentWidget->page_id = $page_id;
			$contentWidget->type = 'widget';
			$contentWidget->name = 'recipe.recentfriend-recipe';
			$contentWidget->parent_content_id = $left_id;
			$contentWidget->order = 20;
			$contentWidget->params = '{"title":"Recently Viewed By Friends","titleCount":"true"}';
			$contentWidget->save();
		}
    $selectWidgetId  = $contentTable->select()
			->from($contentTableName, array('content_id'))
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'recipe.season-recipe')
			->where('parent_content_id = ?', $left_id)
			->limit(1);
		$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
		if ( empty($fetchWidgetContentId) ) {
			$contentWidget = $contentTable->createRow();
			$contentWidget->page_id = $page_id;
			$contentWidget->type = 'widget';
			$contentWidget->name = 'recipe.season-recipe';
			$contentWidget->parent_content_id = $left_id;
			$contentWidget->order = 20;
			$contentWidget->params = '{"title":"Season Recipes","titleCount":"true"}';
			$contentWidget->save();
		}
	}

	// Make a Widgitized Page (recipe_index_index) & widgets.

	$selectPage  = $pageTable->select()
	->from($pageTableName, array('page_id'))
	->where('name =?', 'recipe_index_index')
	->limit(1);
	$page_id = $selectPage->query()->fetchAll();
	if( empty($page_id) ) {
	$pageCreate = $pageTable->createRow();
	$pageCreate->name = 'recipe_index_index';
	$pageCreate->displayname = 'Browse Recipes';
	$pageCreate->title = 'Browse Recipes';
	$pageCreate->description = 'This is the recipe browse page.';
	$pageCreate->custom = 1;
	$pageCreate->save();
	$page_id = $pageCreate->page_id;

	// Insert Main Container.
	$mainContainer = $contentTable->createRow();
	$mainContainer->page_id = $page_id;
	$mainContainer->type = 'container';
	$mainContainer->name = 'main';
	$mainContainer->order = 2;
	$mainContainer->save();
	$container_id = $mainContainer->content_id;

	// Insert Main-Middle Container.
	$mainMiddleContainer = $contentTable->createRow();
	$mainMiddleContainer->page_id = $page_id;
	$mainMiddleContainer->type = 'container';
	$mainMiddleContainer->name = 'middle';
	$mainMiddleContainer->parent_content_id = $container_id;
	$mainMiddleContainer->order = 6;
	$mainMiddleContainer->save();
	$middle_id = $mainMiddleContainer->content_id;

	// Insert Main-Right Container.
	$mainRightContainer = $contentTable->createRow();
	$mainRightContainer->page_id = $page_id;
	$mainRightContainer->type = 'container';
	$mainRightContainer->name = 'right';
	$mainRightContainer->parent_content_id = $container_id;
	$mainRightContainer->order = 5;
	$mainRightContainer->save();
	$right_id = $mainRightContainer->content_id;

	//Insert Top Container.
	$topContainer = $contentTable->createRow();
	$topContainer->page_id = $page_id;
	$topContainer->type = 'container';
	$topContainer->name = 'top';
	$topContainer->order = 1;
	$topContainer->save();
	$top_id = $topContainer->content_id;

	//Insert Top-Middle Container.
	$topMiddleContainer = $contentTable->createRow();
	$topMiddleContainer->page_id = $page_id;
	$topMiddleContainer->type = 'container';
	$topMiddleContainer->name = 'middle';
	$topMiddleContainer->parent_content_id = $top_id;
	$topMiddleContainer->order = 6;
	$topMiddleContainer->save();
	$top_middle_id = $topMiddleContainer->content_id;

	$selectWidgetId  = $contentTable->select()
	->from($contentTableName, array('content_id'))					
	->where('page_id =?', $page_id)
	->where('type = ?', 'widget')
	->where('name = ?', 'recipe.browsenevigation-recipe')
	->where('parent_content_id = ?', $top_middle_id)
	->limit(1);
	$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
	if ( empty($fetchWidgetContentId) ) {
	$contentWidget = $contentTable->createRow();
	$contentWidget->page_id = $page_id;
	$contentWidget->type = 'widget';
	$contentWidget->name = 'recipe.browsenevigation-recipe';
	$contentWidget->parent_content_id = $top_middle_id;
	$contentWidget->order = 1;
	$contentWidget->params = '{"title":"","titleCount":"true"}';
	$contentWidget->save();
	}

	$selectWidgetId  = $contentTable->select()
	->from($contentTableName, array('content_id'))					
	->where('page_id =?', $page_id)
	->where('type = ?', 'widget')
	->where('name = ?', 'recipe.recipes-recipe')
	->where('parent_content_id = ?', $middle_id)
	->limit(1);
	$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
	if ( empty($fetchWidgetContentId) ) {
	$contentWidget = $contentTable->createRow();
	$contentWidget->page_id = $page_id;
	$contentWidget->type = 'widget';
	$contentWidget->name = 'recipe.recipes-recipe';
	$contentWidget->parent_content_id = $middle_id;
	$contentWidget->order = 2;
	$contentWidget->params = '{"title":"","titleCount":"true"}';
	$contentWidget->save();
	}

	$selectWidgetId  = $contentTable->select()
	->from($contentTableName, array('content_id'))					
	->where('page_id =?', $page_id)
	->where('type = ?', 'widget')
	->where('name = ?', 'recipe.categories-recipe')
	->where('parent_content_id = ?', $right_id)
	->limit(1);
	$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
	if ( empty($fetchWidgetContentId) ) {
	$contentWidget = $contentTable->createRow();
	$contentWidget->page_id = $page_id;
	$contentWidget->type = 'widget';
	$contentWidget->name = 'recipe.categories-recipe';
	$contentWidget->parent_content_id = $right_id;
	$contentWidget->order = 3;
	$contentWidget->params = '{"title":"Categories","titleCount":"true"}';
	$contentWidget->save();
	}

	$selectWidgetId  = $contentTable->select()
	->from($contentTableName, array('content_id'))					
	->where('page_id =?', $page_id)
	->where('type = ?', 'widget')
	->where('name = ?', 'recipe.search-recipe')
	->where('parent_content_id = ?', $right_id)
	->limit(1);
	$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
	if ( empty($fetchWidgetContentId) ) {
	$contentWidget = $contentTable->createRow();
	$contentWidget->page_id = $page_id;
	$contentWidget->type = 'widget';
	$contentWidget->name = 'recipe.search-recipe';
	$contentWidget->parent_content_id = $right_id;
	$contentWidget->order = 4;
	$contentWidget->params = '{"title":"","titleCount":"true"}';
	$contentWidget->save();
	}

	$selectWidgetId  = $contentTable->select()
	->from($contentTableName, array('content_id'))					
	->where('page_id =?', $page_id)
	->where('type = ?', 'widget')
	->where('name = ?', 'recipe.newrecipe-recipe')
	->where('parent_content_id = ?', $right_id)
	->limit(1);
	$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
	if ( empty($fetchWidgetContentId) ) {
	$contentWidget = $contentTable->createRow();
	$contentWidget->page_id = $page_id;
	$contentWidget->type = 'widget';
	$contentWidget->name = 'recipe.newrecipe-recipe';
	$contentWidget->parent_content_id = $right_id;
	$contentWidget->order = 5;
	$contentWidget->params = '{"title":"","titleCount":"true"}';
	$contentWidget->save();
	}

	$selectWidgetId  = $contentTable->select()
	->from($contentTableName, array('content_id'))					
	->where('page_id =?', $page_id)
	->where('type = ?', 'widget')
	->where('name = ?', 'recipe.mostrated-recipe')
	->where('parent_content_id = ?', $right_id)
	->limit(1);
	$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
	if ( empty($fetchWidgetContentId) ) {
	$contentWidget = $contentTable->createRow();
	$contentWidget->page_id = $page_id;
	$contentWidget->type = 'widget';
	$contentWidget->name = 'recipe.mostrated-recipe';
	$contentWidget->parent_content_id = $right_id;
	$contentWidget->order = 6;
	$contentWidget->params = '{"title":"Top Rated Recipes","titleCount":"true"}';
	$contentWidget->save();
	}

	$selectWidgetId  = $contentTable->select()
	->from($contentTableName, array('content_id'))					
	->where('page_id =?', $page_id)
	->where('type = ?', 'widget')
	->where('name = ?', 'recipe.tagcloud-recipe')
	->where('parent_content_id = ?', $right_id)
	->limit(1);
	$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
	if ( empty($fetchWidgetContentId) ) {
	$contentWidget = $contentTable->createRow();
	$contentWidget->page_id = $page_id;
	$contentWidget->type = 'widget';
	$contentWidget->name = 'recipe.tagcloud-recipe';
	$contentWidget->parent_content_id = $right_id;
	$contentWidget->order = 7;
	$contentWidget->params = '{"title":"","titleCount":"true"}';
	$contentWidget->save();
	}
	}

	// Make a Widgitized Page (recipe_index_view) & widgets.

	$selectPage  = $pageTable->select()
		->from($pageTableName, array('page_id'))
		->where('name =?', 'recipe_index_view')
		->limit(1);
	$page_id = $selectPage->query()->fetchAll();
	if( empty($page_id) ) {
		$pageCreate = $pageTable->createRow();
		$pageCreate->name = 'recipe_index_view';
		$pageCreate->displayname = 'Recipe Profile';
		$pageCreate->title = 'Recipe Profile';
		$pageCreate->description = 'This is the recipe view  page.';
		$pageCreate->custom = 1;
		$pageCreate->save();
		$page_id = $pageCreate->page_id;

		// Insert Main Container.
		$mainContainer = $contentTable->createRow();
		$mainContainer->page_id = $page_id;
		$mainContainer->type = 'container';
		$mainContainer->name = 'main';
		$mainContainer->order = 2;
		$mainContainer->save();
		$container_id = $mainContainer->content_id;

		// Insert Main-Middle Container.
		$mainMiddleContainer = $contentTable->createRow();
		$mainMiddleContainer->page_id = $page_id;
		$mainMiddleContainer->type = 'container';
		$mainMiddleContainer->name = 'middle';
		$mainMiddleContainer->parent_content_id = $container_id;
		$mainMiddleContainer->order = 6;
		$mainMiddleContainer->save();
		$middle_id = $mainMiddleContainer->content_id;

		// Insert Main-Left Container.
		$mainLeftContainer = $contentTable->createRow();
		$mainLeftContainer->page_id = $page_id;
		$mainLeftContainer->type = 'container';
		$mainLeftContainer->name = 'left';
		$mainLeftContainer->parent_content_id = $container_id;
		$mainLeftContainer->order = 4;
		$mainLeftContainer->save();
		$left_id = $mainLeftContainer->content_id;

		// Insert Main-Middle-Tab Container.
		$middleTabContainer = $contentTable->createRow();
		$middleTabContainer->page_id = $page_id;
		$middleTabContainer->type = 'widget';
		$middleTabContainer->name = 'core.container-tabs';
		$middleTabContainer->parent_content_id = $middle_id;
		$middleTabContainer->order = 7;
		$middleTabContainer->params = '{"max":"6"}';
		$middleTabContainer->save();
		$middle_tab = $middleTabContainer->content_id;

		$selectWidgetId  = $contentTable->select()
			->from($contentTableName, array('content_id'))					
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'recipe.title-recipe')
			->where('parent_content_id = ?', $middle_id)
			->limit(1);
		$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
		if ( empty($fetchWidgetContentId) ) {
			$contentWidget = $contentTable->createRow();
			$contentWidget->page_id = $page_id;
			$contentWidget->type = 'widget';
			$contentWidget->name = 'recipe.title-recipe';
			$contentWidget->parent_content_id = $middle_id;
			$contentWidget->order = 1;
			$contentWidget->params = '{"title":"","titleCount":"true"}';
			$contentWidget->save();
		}

		$selectWidgetId  = $contentTable->select()
			->from($contentTableName, array('content_id'))					
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'seaocore.like-button')
			->where('parent_content_id = ?', $middle_id)
			->limit(1);
		$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
		if ( empty($fetchWidgetContentId) ) {
			$contentWidget = $contentTable->createRow();
			$contentWidget->page_id = $page_id;
			$contentWidget->type = 'widget';
			$contentWidget->name = 'seaocore.like-button';
			$contentWidget->parent_content_id = $middle_id;
			$contentWidget->order = 2;
			$contentWidget->params = '{"title":"","titleCount":"true"}';
			$contentWidget->save();
		}

		$selectWidgetId  = $contentTable->select()
			->from($contentTableName, array('content_id'))					
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'recipe.mainphoto-recipe')
			->where('parent_content_id = ?', $left_id)
			->limit(1);
		$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
		if ( empty($fetchWidgetContentId) ) {
			$contentWidget = $contentTable->createRow();
			$contentWidget->page_id = $page_id;
			$contentWidget->type = 'widget';
			$contentWidget->name = 'recipe.mainphoto-recipe';
			$contentWidget->parent_content_id = $left_id;
			$contentWidget->order = 10;
			$contentWidget->params = '{"title":"","titleCount":"true"}';
			$contentWidget->save();
		}

		$selectWidgetId  = $contentTable->select()
			->from($contentTableName, array('content_id'))					
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'recipe.options-recipe')
			->where('parent_content_id = ?', $left_id)
			->limit(1);
		$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
		if ( empty($fetchWidgetContentId) ) {
			$contentWidget = $contentTable->createRow();
			$contentWidget->page_id = $page_id;
			$contentWidget->type = 'widget';
			$contentWidget->name = 'recipe.options-recipe';
			$contentWidget->parent_content_id = $left_id;
			$contentWidget->order = 11;
			$contentWidget->params = '{"title":"","titleCount":"true"}';
			$contentWidget->save();
		}

		$selectWidgetId  = $contentTable->select()
			->from($contentTableName, array('content_id'))					
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'recipe.write-page')
			->where('parent_content_id = ?', $left_id)
			->limit(1);
		$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
		if ( empty($fetchWidgetContentId) ) {
			$contentWidget = $contentTable->createRow();
			$contentWidget->page_id = $page_id;
			$contentWidget->type = 'widget';
			$contentWidget->name = 'recipe.write-page';
			$contentWidget->parent_content_id = $left_id;
			$contentWidget->order = 12;
			$contentWidget->params = '{"title":"","titleCount":"true"}';
			$contentWidget->save();
		}

		$selectWidgetId  = $contentTable->select()
			->from($contentTableName, array('content_id'))					
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'recipe.information-recipe')
			->where('parent_content_id = ?', $left_id)
			->limit(1);
		$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
		if ( empty($fetchWidgetContentId) ) {
			$contentWidget = $contentTable->createRow();
			$contentWidget->page_id = $page_id;
			$contentWidget->type = 'widget';
			$contentWidget->name = 'recipe.information-recipe';
			$contentWidget->parent_content_id = $left_id;
			$contentWidget->order = 13;
			$contentWidget->params = '{"title":"Information","titleCount":"true"}';
			$contentWidget->save();
		}

		$selectWidgetId  = $contentTable->select()
			->from($contentTableName, array('content_id'))					
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'seaocore.people-like')
			->where('parent_content_id = ?', $left_id)
			->limit(1);
		$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
		if ( empty($fetchWidgetContentId) ) {
			$contentWidget = $contentTable->createRow();
			$contentWidget->page_id = $page_id;
			$contentWidget->type = 'widget';
			$contentWidget->name = 'seaocore.people-like';
			$contentWidget->parent_content_id = $left_id;
			$contentWidget->order = 14;
			$contentWidget->save();
		}

		$selectWidgetId  = $contentTable->select()
			->from($contentTableName, array('content_id'))					
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'recipe.ratings-recipe')
			->where('parent_content_id = ?', $left_id)
			->limit(1);
		$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
		if ( empty($fetchWidgetContentId) ) {
			$contentWidget = $contentTable->createRow();
			$contentWidget->page_id = $page_id;
			$contentWidget->type = 'widget';
			$contentWidget->name = 'recipe.ratings-recipe';
			$contentWidget->parent_content_id = $left_id;
			$contentWidget->order = 15;
			$contentWidget->params = '{"title":"Rating","titleCount":"true"}';
			$contentWidget->save();
		}

		$selectWidgetId  = $contentTable->select()
			->from($contentTableName, array('content_id'))					
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'recipe.suggestedrecipe-recipe')
			->where('parent_content_id = ?', $left_id)
			->limit(1);
		$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
		if ( empty($fetchWidgetContentId) ) {
			$contentWidget = $contentTable->createRow();
			$contentWidget->page_id = $page_id;
			$contentWidget->type = 'widget';
			$contentWidget->name = 'recipe.suggestedrecipe-recipe';
			$contentWidget->parent_content_id = $left_id;
			$contentWidget->order = 16;
			$contentWidget->params = '{"title":"You May Also Like","titleCount":"true"}';
			$contentWidget->save();
		}

		$selectWidgetId  = $contentTable->select()
			->from($contentTableName, array('content_id'))					
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'recipe.userrecipe-recipe')
			->where('parent_content_id = ?', $left_id)
			->limit(1);
		$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
		if ( empty($fetchWidgetContentId) ) {
			$contentWidget = $contentTable->createRow();
			$contentWidget->page_id = $page_id;
			$contentWidget->type = 'widget';
			$contentWidget->name = 'recipe.userrecipe-recipe';
			$contentWidget->parent_content_id = $left_id;
			$contentWidget->order = 17;
			$contentWidget->params = '{"title":"","titleCount":"true"}';
			$contentWidget->save();
		}

		$selectWidgetId  = $contentTable->select()
			->from($contentTableName, array('content_id'))					
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'recipe.socialshare-recipe')
			->where('parent_content_id = ?', $left_id)
			->limit(1);
		$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
		if ( empty($fetchWidgetContentId) ) {

			$social_share_default_code = '{"title":"Social Share","titleCount":true,"code":"<div class=\"addthis_toolbox addthis_default_style \">\r\n<a class=\"addthis_button_preferred_1\"><\/a>\r\n<a class=\"addthis_button_preferred_2\"><\/a>\r\n<a class=\"addthis_button_preferred_3\"><\/a>\r\n<a class=\"addthis_button_preferred_4\"><\/a>\r\n<a class=\"addthis_button_preferred_5\"><\/a>\r\n<a class=\"addthis_button_compact\"><\/a>\r\n<a class=\"addthis_counter addthis_bubble_style\"><\/a>\r\n<\/div>\r\n<script type=\"text\/javascript\">\r\nvar addthis_config = {\r\n          services_compact: \"facebook, twitter, linkedin, google, digg, more\",\r\n          services_exclude: \"print, email\"\r\n}\r\n<\/script>\r\n<script type=\"text\/javascript\" src=\"http:\/\/s7.addthis.com\/js\/250\/addthis_widget.js\"><\/script>","nomobile":"","name":"recipe.socialshare-recipe"}';

			$contentWidget = $contentTable->createRow();
			$contentWidget->page_id = $page_id;
			$contentWidget->type = 'widget';
			$contentWidget->name = 'recipe.socialshare-recipe';
			$contentWidget->parent_content_id = $left_id;
			$contentWidget->order = 18;
			$contentWidget->params = $social_share_default_code;
			$contentWidget->save();
		}

		$selectWidgetId  = $contentTable->select()
			->from($contentTableName, array('content_id'))					
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'activity.feed')
			->where('parent_content_id = ?', $middle_tab)
			->limit(1);
		$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
		if ( empty($fetchWidgetContentId) ) {
			$contentWidget = $contentTable->createRow();
			$contentWidget->page_id = $page_id;
			$contentWidget->type = 'widget';
			$contentWidget->name = 'activity.feed';
			$contentWidget->parent_content_id = $middle_tab;
			$contentWidget->order = 1;
			$contentWidget->params = '{"title":"Updates","titleCount":"true"}';
			$contentWidget->save();
		}

		$selectWidgetId  = $contentTable->select()
			->from($contentTableName, array('content_id'))					
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'recipe.info-recipe')
			->where('parent_content_id = ?', $middle_tab)
			->limit(1);
		$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
		if ( empty($fetchWidgetContentId) ) {
			$contentWidget = $contentTable->createRow();
			$contentWidget->page_id = $page_id;
			$contentWidget->type = 'widget';
			$contentWidget->name = 'recipe.info-recipe';
			$contentWidget->parent_content_id = $middle_tab;
			$contentWidget->order = 2;
			$contentWidget->params = '{"title":"Info","titleCount":"true"}';
			$contentWidget->save();
		}

		$selectWidgetId  = $contentTable->select()
			->from($contentTableName, array('content_id'))					
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'recipe.overview-recipe')
			->where('parent_content_id = ?', $middle_tab)
			->limit(1);
		$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
		if ( empty($fetchWidgetContentId) ) {
			$contentWidget = $contentTable->createRow();
			$contentWidget->page_id = $page_id;
			$contentWidget->type = 'widget';
			$contentWidget->name = 'recipe.overview-recipe';
			$contentWidget->parent_content_id = $middle_tab;
			$contentWidget->order = 3;
			$contentWidget->params = '{"title":"Overview","titleCount":"true"}';
			$contentWidget->save();
		}

		$selectWidgetId  = $contentTable->select()
			->from($contentTableName, array('content_id'))					
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'recipe.location-recipe')
			->where('parent_content_id = ?', $middle_tab)
			->limit(1);
		$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
		if ( empty($fetchWidgetContentId) ) {
			$contentWidget = $contentTable->createRow();
			$contentWidget->page_id = $page_id;
			$contentWidget->type = 'widget';
			$contentWidget->name = 'recipe.location-recipe';
			$contentWidget->parent_content_id = $middle_tab;
			$contentWidget->order = 4;
			$contentWidget->params = '{"title":"Map","titleCount":"true"}';
			$contentWidget->save();
		}

		$selectWidgetId  = $contentTable->select()
			->from($contentTableName, array('content_id'))					
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'recipe.photos-recipe')
			->where('parent_content_id = ?', $middle_tab)
			->limit(1);
		$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
		if ( empty($fetchWidgetContentId) ) {
			$contentWidget = $contentTable->createRow();
			$contentWidget->page_id = $page_id;
			$contentWidget->type = 'widget';
			$contentWidget->name = 'recipe.photos-recipe';
			$contentWidget->parent_content_id = $middle_tab;
			$contentWidget->order = 5;
			$contentWidget->params = '{"title":"Photos","titleCount":"true"}';
			$contentWidget->save();
		}

		$selectWidgetId  = $contentTable->select()
			->from($contentTableName, array('content_id'))					
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'recipe.video-recipe')
			->where('parent_content_id = ?', $middle_tab)
			->limit(1);
		$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
		if ( empty($fetchWidgetContentId) ) {
			$contentWidget = $contentTable->createRow();
			$contentWidget->page_id = $page_id;
			$contentWidget->type = 'widget';
			$contentWidget->name = 'recipe.video-recipe';
			$contentWidget->parent_content_id = $middle_tab;
			$contentWidget->order = 6;
			$contentWidget->params = '{"title":"Videos","titleCount":"true"}';
			$contentWidget->save();
		}

		$selectWidgetId  = $contentTable->select()
			->from($contentTableName, array('content_id'))					
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'recipe.review-recipe')
			->where('parent_content_id = ?', $middle_tab)
			->limit(1);
		$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
		if ( empty($fetchWidgetContentId) ) {
			$contentWidget = $contentTable->createRow();
			$contentWidget->page_id = $page_id;
			$contentWidget->type = 'widget';
			$contentWidget->name = 'recipe.review-recipe';
			$contentWidget->parent_content_id = $middle_tab;
			$contentWidget->order = 8;
			$contentWidget->params = '{"title":"Reviews","titleCount":"true"}';
			$contentWidget->save();
		}

		$selectWidgetId  = $contentTable->select()
			->from($contentTableName, array('content_id'))					
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'recipe.discussion-recipe')
			->where('parent_content_id = ?', $middle_tab)
			->limit(1);
		$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
		if ( empty($fetchWidgetContentId) ) {
			$contentWidget = $contentTable->createRow();
			$contentWidget->page_id = $page_id;
			$contentWidget->type = 'widget';
			$contentWidget->name = 'recipe.discussion-recipe';
			$contentWidget->parent_content_id = $middle_tab;
			$contentWidget->order = 9;
			$contentWidget->params = '{"title":"Discussions","titleCount":"true"}';
			$contentWidget->save();
		}

		$selectWidgetId  = $contentTable->select()
			->from($contentTableName, array('content_id'))					
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'core.profile-links')
			->where('parent_content_id = ?', $middle_tab)
			->limit(1);
		$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
		if ( empty($fetchWidgetContentId) ) {
			$contentWidget = $contentTable->createRow();
			$contentWidget->page_id = $page_id;
			$contentWidget->type = 'widget';
			$contentWidget->name = 'core.profile-links';
			$contentWidget->parent_content_id = $middle_tab;
			$contentWidget->order = 10;
			$contentWidget->params = '{"title":"Links","titleCount":"true"}';
			$contentWidget->save();
		}
	}


	// Widgets: Member profile page.
	$selectPage  = $pageTable->select()
		->from($pageTableName, array('page_id'))
		->where('name =?', 'user_profile_index')
		->limit(1);
	$page_id = $selectPage->query()->fetchAll();
	if( !empty($page_id) ) {
		$page_id = $page_id[0]['page_id'];
		$selectWidgetId  = $contentTable->select()
			->from($contentTableName, array('content_id'))					
			->where('page_id =?', $page_id)
			->where('type = ?', 'widget')
			->where('name = ?', 'core.container-tabs')
			->limit(1);
		$fetchWidgetContentId = $selectWidgetId->query()->fetchAll();								
		if ( !empty($fetchWidgetContentId) ) {
			$tab_id = $fetchWidgetContentId[0]['content_id'];
			$contentWidget = $contentTable->createRow();
			$contentWidget->page_id = $page_id;
			$contentWidget->type = 'widget';
			$contentWidget->name = 'recipe.profile-recipe';
			$contentWidget->parent_content_id = $tab_id;
			$contentWidget->order = 999;
			$contentWidget->params = '{"title":"Recipes","titleCount":true}';
			$contentWidget->save();
		}
	}
?>