<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Recipe
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 6590 2010-12-31 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;

return array(
    array(
        'title' => $view->translate('Recipe Overview'),
        'description' => $view->translate('This widget forms the Overview tab on the Recipe Profile page and displays the overview of the recipe, which the owner has created using the editor in recipe dashboard. It should be placed in the Tabbed Blocks area of the Recipe Profile page.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.overview-recipe',
        'defaultParams' => array(
            'title' => 'Overview',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Recipe Archives'),
        'description' => $view->translate('Displays the month-wise archives for the recipes posted on your site.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.archives-recipe',
        'defaultParams' => array(
            'title' => 'Archives',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Navigation Tabs'),
        'description' => $view->translate('Displays the Navigation tabs recipes having links of Recipes Home, Browse Recipes, etc. This widget should be placed at the top of Recipes Home and Browse Recipes pages.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.browsenevigation-recipe',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Categories and Sub-categories (sidebar)'),
        'description' => $view->translate('Displays the Categories and Sub-categories of recipes. This is shows categories and their sub-categories in an expandable form.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.categories-recipe',
        'defaultParams' => array(
            'title' => 'Categories',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Categories and Sub-categories'),
        'description' => $view->translate('Displays the recipes categories and sub-categories in an attractive grid-like form along with the numbers of recipes in them.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.categories',
        'defaultParams' => array(
            'title' => 'Categories',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Profile Recipes'),
        'description' => $view->translate('Displays a member\'s recipes on their profile.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.profile-recipe',
        'defaultParams' => array(
            'title' => 'Recipes',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Featured Recipes Slideshow'),
        'description' => $view->translate('Displays the Featured Recipes in the form of an attractive Slideshow with interactive controls. The setting of this widget can be done in the widget settings section of this plugin.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.slideshow-recipe',
        'defaultParams' => array(
            'title' => 'Featured Recipes',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Recipe Social Share Buttons'),
        'description' => $view->translate("Contains Social Sharing buttons and enables users to easily share Recipes on their favorite Social Networks. This widget should be placed on the Recipe View Page. You can customize the code for social sharing buttons from Global Settings of this plugin by adding your own code generated from: <a href='http://www.addthis.com' target='_blank'>http://www.addthis.com</a>"),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.socialshare-recipe',
        'defaultParams' => array(
            'title' => $view->translate('Social Share'),
            'titleCount' => true,
        ),
        'requirements' => array(
            'subject' => 'recipe',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Hidden',
                    'nomobile',
                    array(
                        'label' => '',
                    )
                ),
            ),
        ),
    ),
    array(
        'title' => $view->translate('Recipe Reviews'),
        'description' => $view->translate('This widget forms the Reviews tab on the Recipe Profile page and displays the reviews given to a recipe by the users. Users can also write a review through this widget. It should be placed in the Tabbed Blocks area of the Recipe Profile page.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.review-recipe',
        'defaultParams' => array(
            'title' => 'Reviews',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Recipe Title'),
        'description' => $view->translate('Displays the Title of the recipe. This widget should be placed on the Recipe Profile Page, in the middle column at the top.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.title-recipe',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Recipe Info'),
        'description' => $view->translate('This widget forms the Info tab on the Recipe Profile page and displays the information of the recipe. It should be placed in the Tabbed Blocks area of the Recipe Profile page.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.info-recipe',
        'defaultParams' => array(
            'title' => 'Info',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Information Recipe'),
        'description' => $view->translate('Displays the owner, category, tags, views and other information about a recipe. This widget should be placed on the Recipe Profile page in the left column.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.information-recipe',
        'defaultParams' => array(
            'title' => 'Information',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Recipe Cover Photo '),
        'description' => $view->translate('Displays the main cover photo of a recipe. This widget must be placed on the Recipe Profile page at the top of left column.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.mainphoto-recipe',
        'defaultParams' => array(
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Recipe Map'),
        'description' => $view->translate('This widget forms the Map tab on the Recipe Profile page. It displays the map showing the recipe position as well as the location details of the recipe. It should be placed in the Tabbed Blocks area of the Recipe Profile page.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.location-recipe',
        'defaultParams' => array(
            'title' => 'Map',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Recipe Options'),
        'description' => $view->translate('Displays the various action link options to users viewing a recipe. This widget should be placed on the Recipe Profile page in the left column, below the recipe profile photo.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.options-recipe',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Owner Recipe Tags'),
        'description' => $view->translate('Displays all the tags chosen by the recipe owner for his recipes. This widget should be placed on the Recipe Profile page.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.tags-recipe',
        'defaultParams' => array(
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Recipe Photos'),
        'description' => $view->translate('This widget forms the Photos tab on the Recipe Profile page and displays the photos of the recipe. It should be placed in the Tabbed Blocks area of the Recipe Profile page.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.photos-recipe',
        'defaultParams' => array(
            'title' => 'Photos',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Recipe Videos'),
        'description' => $view->translate('This widget forms the Videos tab on the Recipe Profile page and displays the videos of the recipe. It should be placed in the Tabbed Blocks area of the Recipe Profile page.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.video-recipe',
        'defaultParams' => array(
            'title' => 'Videos',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Recipe Rating'),
        'description' => $view->translate('Displays the overall rating given to a recipe by other users. Users can also rate the recipe using this widget.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.ratings-recipe',
        'defaultParams' => array(
            'title' => 'Ratings',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Post a New Recipe'),
        'description' => $view->translate('Displays the link to Post a New Recipe.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.newrecipe-recipe',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Most Commented Recipes'),
        'description' => $view->translate('Displays the recipes having the most number of comments. The setting of this widget can be done in the widget settings section of this plugin.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.mostcommented-recipe',
        'defaultParams' => array(
            'title' => 'Most Commented Recipes',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Most Liked Recipes'),
        'description' => $view->translate('Displays the recipes that have been Liked by most number of users. The setting of this widget can be done in the widget settings section of this plugin.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.mostlikes-recipe',
        'defaultParams' => array(
            'title' => 'Most Liked Recipes',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Popular Locations'),
        'description' => $view->translate('Displays the popular locations of recipes. The setting of this widget can be done in the widget settings section of this plugin.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.popularlocation-recipe',
        'defaultParams' => array(
            'title' => 'Popular Locations',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Popular Recipe Tags'),
        'description' => $view->translate('Shows popular tags with frequency.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.tagcloud-recipe',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Owner Recipes'),
        'description' => $view->translate('Displays the other recipes of a recipe owner. This widget should be placed on the Recipe Profile Page.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.userrecipe-recipe',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('About Recipe'),
        'description' => $view->translate('Displays the About Us information for recipes. This widget should be placed on the Recipe Profile page.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.write-page',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Recent Recipes'),
        'description' => $view->translate('Displays a recipe of recently posted recipes.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.recentlyposted-recipe',
        'defaultParams' => array(
            'title' => 'Recent',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Popular Recipes'),
        'description' => $view->translate('Displays the popular recipes on the site. The setting of this widget can be done in the widget settings section of this plugin.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.mostviewed-recipe',
        'defaultParams' => array(
            'title' => 'Most Popular',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Browse Recipes'),
        'description' => $view->translate('Displays a recipe of all the recipes on site. This widget should be placed on the Browse Recipes page.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.recipes-recipe',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
            'layouts_views' => array("0" => "1", "1" => "2", "2" => "3"),
            'layouts_oder' => 1,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'MultiCheckbox',
                    'layouts_views',
                    array(
                        'label' => 'Choose the view types that you want to be available for recipes on the recipes home and browse recipes.',
                        'multiOptions' => array("1" => "List View", "2" => "Grid View", "3" => "Map View")
                    ),
                ),
                array(
                    'Radio',
                    'layouts_oder',
                    array(
                        'label' => 'Select a default view type for recipe.',
                        'multiOptions' => array("1" => "List View", "2" => "Grid View", "3" => "Map View")
                    )
                ),
                array(
                    'Select',
                    'show_content',
                    array(
                        'label' => 'What do you want for view more content?',
                        'description' => '',
                        'multiOptions' => array(
                            '1' => 'Pagination',
                            '2' => 'Show View More Link at Bottom',
                            '3' => 'Auto Load Recipes on Scrolling Down'),
                        'value' => 2,
                    )
                ),
            ),
        ),
    ),
    array(
        'title' => $view->translate('Top Rated Recipes'),
        'description' => $view->translate('Displays the top rated recipes on the site.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.mostrated-recipe',
        'defaultParams' => array(
            'title' => 'Top Rated Recipes',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Search Recipes form'),
        'description' => $view->translate('Displays the form for searching recipes.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.search-recipe',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Random Recipes'),
        'description' => $view->translate('Displays a recipe of recipes randomly.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.random-recipe',
        'defaultParams' => array(
            'title' => 'Random',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Sponsored Recipes Carousel'),
        'description' => $view->translate('This widget contains an attractive AJAX based carousel, showcasing the sponsored recipes on the site. The setting of this widget can be done in the widget settings section of this plugin.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.sponsored-recipe',
        'defaultParams' => array(
            'title' => 'Sponsored Recipes',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Recipe of the Day'),
        'description' => $view->translate('Displays the Recipe of the Day as selected by the Admin from the widget settings section of this plugin.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.item-recipe',
        'defaultParams' => array(
            'title' => 'Recipe of the Day',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Recently Viewed Recipes'),
        'description' => $view->translate('Displays the recently viewed recipes on the site. The setting of this widget can be done in the widget settings section of this plugin.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.recentview-recipe',
        'defaultParams' => array(
            'title' => 'Recently Viewed',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Recently Viewed By Friends'),
        'description' => $view->translate('Displays the recipes that have been recently viewed by friends on the site. The setting of this widget can be done in the widget settings section of this plugin.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.recentfriend-recipe',
        'defaultParams' => array(
            'title' => 'Recently Viewed By Friends',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Message for Zero Recipes'),
        'description' => $view->translate('This widget should be placed in the top of the middle column of Recipes Home page.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.zerorecipe-recipe',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Close Recipe Message'),
        'description' => $view->translate('If any close lisings,then show msg.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.closerecipe-recipe',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Like Button for Recipes'),
        'description' => $view->translate('This is the Like Button to be placed on the Recipe Profile Page. The best place to put this widget is right above the Tabbed Blocks on the Recipe Profile page. If you have the Likes Plugin and Widgets from SocialEngineAddOns installed on your site, then you may replace this button widget with the Like Button for Recipes widget of that plugin.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'seaocore.like-button',
        'defaultParams' => array(
            'title' => '',
        ),
    ),
    array(
        'title' => $view->translate('You May Also Like'),
        'description' => $view->translate('Displays the other recipes that a user may like, based on the recipe being currently viewed. This widget should be placed on the Recipe Profile Page.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.suggestedrecipe-recipe',
        'defaultParams' => array(
            'title' => $view->translate('You May Also Like'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Recipe Discussions'),
        'description' => $view->translate('This widget forms the Discussions tab on the Recipe Profile page and displays the discussions of the recipe. It should be placed in the Tabbed Blocks area of the Recipe Profile page.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.discussion-recipe',
        'defaultParams' => array(
            'title' => 'Discussions',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Recipe Likes'),
        'description' => $view->translate('Displays that which all users have liked a recipe. This widget should be placed on the Recipe Profile Page.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'seaocore.people-like',
    ),
    array(
        'title' => $view->translate('Most Discussed Recipes'),
        'description' => $view->translate('Displays the recipes having the most number of discussions. The setting of this widget can be done in the widget settings section of this plugin.'),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.mostdiscussion-recipe',
        'defaultParams' => array(
            'title' => 'Most Discussed Recipe',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Ajax based main Recipes Home widget'),
        'description' => $view->translate("Contains multiple Ajax based tabs showing Recently Posted, Popular, Random, Featured and Sponsored Recipes. Settings of this widget are available in the Widget Settings section."),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.recently-popular-random-recipe',
        'defaultParams' => array(
            'title' => "",
            'titleCount' => "",
        ),
    ),
    array(
        'title' => $view->translate("Season's Recipes"),
        'description' => $view->translate("This widget shows the recipes for the current season based on the current month."),
        'category' => $view->translate('Recipes'),
        'type' => 'widget',
        'name' => 'recipe.season-recipe',
        'defaultParams' => array(
            'title' => "Season's Recipes",
            'titleCount' => "",
        ),
    ),
        )
?>