<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Recipe
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: manifest.php 6590 2010-12-31 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
return array(
    'package' =>
    array(
        'type' => 'module',
        'name' => 'recipe',
        'version' => '5.6.0',
        'path' => 'application/modules/Recipe',
        'title' => 'Recipe',
        'description' => 'Recipes Plugin',
      'author' => '<a href="http://www.socialapps.tech" style="text-decoration:underline;" target="_blank">SocialApps.tech</a>',
        'actions' => array(
            'install',
            'upgrade',
            'refresh',
            'enable',
            'disable',
        ),
        'callback' => array(
            'path' => 'application/modules/Recipe/settings/install.php',
            'class' => 'Recipe_Installer',
        ),
        'directories' => array(
            'application/modules/Recipe',
        ),
        'files' => array(
            'application/languages/en/recipe.csv',
        ),
    ),
// Hooks ---------------------------------------------------------------------
    'hooks' => array(
        array(
            // 'event' => 'addActivity',
            'event' => 'onRenderLayoutDefault',
            'resource' => 'Recipe_Plugin_Core'
        ),
        array(
            'event' => 'onStatistics',
            'resource' => 'Recipe_Plugin_Core'
        ),
        array(
            'event' => 'onUserDeleteBefore',
            'resource' => 'Recipe_Plugin_Core',
        ),
    ),
// Items ---------------------------------------------------------------------
    'items' => array(
        'recipe_clasfvideo',
        'recipe',
        'recipe_recipe',
        'recipe_album',
        'recipe_photo',
        'recipe_reviews',
        'recipe_vieweds',
        'recipe_review',
        'recipe_itemofthedays',
        'recipe_topic',
        'recipe_post'
    ),
// Route--------------------------------------------------------------------
    'routes' => array(
        'recipe_extended' => array(
            'route' => 'recipeitems/:controller/:action/*',
            'defaults' => array(
                'module' => 'recipe',
                'controller' => 'index',
                'action' => 'home',
            ),
            'reqs' => array(
                'controller' => '\D+',
                'action' => '\D+',
            )
        ),
        'recipe_general' => array(
            'route' => 'recipeitems/:action/*',
            'defaults' => array(
                'module' => 'recipe',
                'controller' => 'index',
                'action' => 'home',
            ),
            'reqs' => array(
                'action' => '(home|index|manage|create)',
            ),
        ),
        // Public
        'recipe_photo_extended' => array(
            'route' => 'recipeitem/photo/:action/*',
            'defaults' => array(
                'module' => 'recipe',
                'controller' => 'photo',
                'action' => 'edit',
            ),
            'reqs' => array(
                'action' => '\D+',
            )
        ),
        'recipe_review_load' => array(
            'route' => 'recipeitem/review/:action/*',
            'defaults' => array(
                'module' => 'recipe',
                'controller' => 'review',
                'action' => 'create',
            ),
            'reqs' => array(
                'action' => '\D+',
            )
        ),
        'recipe_video_load' => array(
            'route' => 'recipeitem/preview/:recipe_id/*',
            'defaults' => array(
                'module' => 'recipe',
                'controller' => 'video',
                'action' => 'load',
                'recipe_id' => '0',
            ),
            'reqs' => array(
            )
        ),
        'recipe_entry_view' => array(
            'route' => 'recipeitems/:user_id/:recipe_id/:slug/*',
            'defaults' => array(
                'module' => 'recipe',
                'controller' => 'index',
                'action' => 'view',
                'slug' => '',
            ),
            'reqs' => array(
                'user_id' => '\d+',
                'recipe_id' => '\d+'
            )
        ),
        'recipe_messageowner' => array(
            'route' => 'recipeitems/messageowner/:recipe_id/*',
            'defaults' => array(
                'module' => 'recipe',
                'controller' => 'index',
                'action' => 'messageowner'
            ),
            'reqs' => array(
                'recipe_id' => '\d+'
            )
        ),
        // User
        'recipe_tellafriend' => array(
            'route' => 'recipeitems/tellafriend/:id',
            'defaults' => array(
                'module' => 'recipe',
                'controller' => 'index',
                'action' => 'tellafriend',
                'id' => 0,
            )
        ),
        // User
        'recipe_print' => array(
            'route' => 'recipeitems/print/:id',
            'defaults' => array(
                'module' => 'recipe',
                'controller' => 'index',
                'action' => 'print',
                'id' => 0,
            )
        ),
        'recipe_delete' => array(
            'route' => 'recipeitems/delete/:recipe_id',
            'defaults' => array(
                'module' => 'recipe',
                'controller' => 'index',
                'action' => 'delete'
            )
        ),
        'recipe_publish' => array(
            'route' => 'recipeitems/publish/:recipe_id',
            'defaults' => array(
                'module' => 'recipe',
                'controller' => 'index',
                'action' => 'publish'
            ),
            'reqs' => array(
                'recipe_id' => '\d+'
            )
        ),
        'recipe_close' => array(
            'route' => 'recipeitem/close/:recipe_id/:closed',
            'defaults' => array(
                'module' => 'recipe',
                'controller' => 'index',
                'action' => 'close'
            )
        ),
        'recipe_edit' => array(
            'route' => 'recipeitems/edit/:recipe_id/*',
            'defaults' => array(
                'module' => 'recipe',
                'controller' => 'index',
                'action' => 'edit',
                'recipe_id' => '0',
            )
        ),
        'recipe_overview' => array(
            'route' => 'recipeitems/overview/:recipe_id/*',
            'defaults' => array(
                'module' => 'recipe',
                'controller' => 'index',
                'action' => 'overview',
                'recipe_id' => '0',
            )
        ),
        'recipe_editstyle' => array(
            'route' => 'recipeitems/editstyle/:recipe_id/*',
            'defaults' => array(
                'module' => 'recipe',
                'controller' => 'index',
                'action' => 'editstyle',
                'recipe_id' => '0',
            )
        ),
        'recipe_editlocation' => array(
            'route' => 'recipeitems/editlocation/:recipe_id/*',
            'defaults' => array(
                'module' => 'recipe',
                'controller' => 'index',
                'action' => 'editlocation',
                'recipe_id' => '0',
            )
        ),
        'recipe_editaddress' => array(
            'route' => 'recipeitems/editaddress/:recipe_id/*',
            'defaults' => array(
                'module' => 'recipe',
                'controller' => 'index',
                'action' => 'editaddress',
                'recipe_id' => '0',
            )
        ),
        'recipe_renew' => array(
            'route' => 'recipeitems/renew/:id/*',
            'defaults' => array(
                'module' => 'recipe',
                'controller' => 'index',
                'action' => 'renew',
            )
        ),
        'recipe_photoupload' => array(
            'route' => 'recipeitem/album/:recipe_id/*',
            'defaults' => array(
                'module' => 'recipe',
                'controller' => 'album',
                'action' => 'view',
                'recipe_id' => '0',
            )
        ),
        'recipe_photoalbumupload' => array(
            'route' => 'recipeitems/photo/:recipe_id/*',
            'defaults' => array(
                'module' => 'recipe',
                'controller' => 'photo',
                'action' => 'upload',
                'recipe_id' => '0',
            )
        ),
        'recipe_specific' => array(
            'route' => 'recipeitems/album/:action/:recipe_id/*',
            'defaults' => array(
                'module' => 'recipe',
                'controller' => 'album',
                'action' => 'editphotos'
            ),
            'reqs' => array(
                'action' => '(compose-upload|delete|edit|editphotos|upload|view)',
            ),
        ),
        'recipe_videospecific' => array(
            'route' => 'recipeitems/videoedit/:action/:recipe_id/*',
            'defaults' => array(
                'module' => 'recipe',
                'controller' => 'videoedit',
                'action' => 'edit'
            ),
            'reqs' => array(
                'action' => '(compose-upload|delete|edit|editphotos|upload|view)',
            ),
        ),
        'video_upload' => array(
            'route' => 'recipeitem/video/:recipe_id/*',
            'defaults' => array(
                'module' => 'recipe',
                'controller' => 'video',
                'action' => 'index',
                'recipe_id' => '0',
            ),
            'reqs' => array(
            //'action' => '[^(level)]'
            )
        ),
        'recipe_image_specific' => array(
            'route' => 'recipeitem/photo/view/*',
            'defaults' => array(
                'module' => 'recipe',
                'controller' => 'photo',
                'action' => 'view'
            ),
            'reqs' => array(
                'action' => '(view|remove)',
            ),
        ),
        // User
        'recipe_widget' => array(
            'route' => 'admin/recipeitem/widgets',
            'defaults' => array(
                'module' => 'recipe',
                'controller' => 'admin-widgets',
                'action' => 'index',
            )
        ),
        // User
        'recipe_itemofday' => array(
            'route' => 'admin/recipeitem/items/day/:page/*',
            'defaults' => array(
                'module' => 'recipe',
                'controller' => 'admin-items',
                'action' => 'day',
                'page' => 1
            )
        ),
        'recipe_tags' => array(
            'route' => 'recipeitems/tagscloud/:page/*',
            'defaults' => array(
                'module' => 'recipe',
                'controller' => 'index',
                'action' => 'tagscloud',
                'page' => 1
            )
        ),
        'recipe_sharing' => array(
            'route' => 'activity/index/share/type/recipeitem/id/:recipe_id/*',
            'defaults' => array(
                'module' => 'activity',
                'controller' => 'index',
                'action' => 'share',
                'type' => 'recipe'
            )
        ),
        'recipe_general_category' => array(
            'route' => 'recipeitems/:category_id/:categoryname',
            'defaults' => array(
                'module' => 'recipe',
                'controller' => 'index',
                'action' => 'index',
            ),
            'reqs' => array(
                'category_id' => '\d+',
            ),
        ),
        'recipe_searchbox' => array(
            'route' => 'recipeitems/searchbox/:recipe_id/*',
            'defaults' => array(
                'module' => 'recipe',
                'controller' => 'index',
                'action' => 'searchbox'
            )
        ),
        'recipe_general_subcategory' => array(
            'route' => 'recipeitems/:category_id/:categoryname/:subcategory_id/:subcategoryname',
            'defaults' => array(
                'module' => 'recipe',
                'controller' => 'index',
                'action' => 'index',
            ),
            'reqs' => array(
                'category_id' => '\d+',
                'subcategory_id' => '\d+',
            ),
        ),
        'recipe_ajaxhomerecipe' => array(
            'route' => 'recipeitems/recipehomelist/',
            'defaults' => array(
                'module' => 'recipe',
                'controller' => 'index',
                'action' => 'ajaxhomerecipe'
            )
        ),
        'recipe_changephoto' => array(
            'route' => 'recipeitems/change-photo/:recipe_id/*',
            'defaults' => array(
                'module' => 'recipe',
                'controller' => 'index',
                'action' => 'change-photo',
                'recipe_id' => '0',
            )
        ),
        'recipe_removephoto' => array(
            'route' => 'recipeitems/remove-photo/:recipe_id/*',
            'defaults' => array(
                'module' => 'recipe',
                'controller' => 'index',
                'action' => 'remove-photo',
                'recipe_id' => '0',
            )
        ),
    ),
);
?>
