<?php
 /**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Recipe
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2010-12-31 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
 
class Recipe_Widget_ArchivesRecipeController extends Engine_Content_Widget_Abstract {

  public function indexAction() {

    // Don't render this if not authorized
    $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
    // get Archive recipe of recipe user
		$archiveRecipe = Engine_Api::_()->recipe()->getArchiveRecipe();
		// call to handleArchiveRecipe action of same controoler
		$this->view->archive_recipe = $this->_handleArchiveRecipe($archiveRecipe);
   
    if (!(count($this->view->archive_recipe) > 0)) {
      return $this->setNoRender();
    }
  }

  //handleArchiveRecipe action
  protected function _handleArchiveRecipe($results)
  {
    $localeObject = Zend_Registry::get('Locale');

    $recipe_dates = array();
    foreach ($results as $result)
      $recipe_dates[] = strtotime($result->creation_date);

    // GEN ARCHIVE recipe
    $time = time();
    $archive_recipe = array();

    foreach( $recipe_dates as $recipe_date )
    {
      $ltime = localtime($recipe_date, TRUE);
      $ltime["tm_mon"] = $ltime["tm_mon"] + 1;
      $ltime["tm_year"] = $ltime["tm_year"] + 1900;

      // LESS THAN A YEAR AGO - MONTHS
      if( $recipe_date+31536000>$time )
      {
        $date_start = mktime(0, 0, 0, $ltime["tm_mon"], 1, $ltime["tm_year"]);
        $date_end = mktime(0, 0, 0, $ltime["tm_mon"]+1, 1, $ltime["tm_year"]);
        $label = date('F Y', $recipe_date);
        $type = 'month';
   
      }

      // MORE THAN A YEAR AGO - YEARS
      else
      {
        $date_start = mktime(0, 0, 0, 1, 1, $ltime["tm_year"]);
        $date_end = mktime(0, 0, 0, 1, 1, $ltime["tm_year"]+1);
        //$label = date('Y', $recipe_date);
        $type = 'year';

        $dateObject = new Zend_Date($recipe_date);
        $format = $localeObject->getTranslation('yyyy', 'dateitem', $localeObject);
        if( !$format ) {
          $format = $localeObject->getTranslation('y', 'dateitem', $localeObject);
        }
        $label = $dateObject->toString($format, $localeObject);
      }

      if( !isset($archive_recipe[$date_start]) )
      {
        $archive_recipe[$date_start] = array(
          'type' => $type,
          'label' => $label,
          'date_start' => $date_start,
          'date_end' => $date_end,
          'count' => 1
        );
      }
      else
      {
        $archive_recipe[$date_start]['count']++;
      }
    }   
    //krsort($archive_recipe);
    return $archive_recipe;
  }
}