<?php
 /**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Recipe
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2010-12-31 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Recipe_Widget_DiscussionRecipeController extends Engine_Content_Widget_Abstract
{
  protected $_childCount;
  
  public function indexAction()
  {
    // Don't render this if not authorized
    $viewer = Engine_Api::_()->user()->getViewer();
    if( !Engine_Api::_()->core()->hasSubject() ) {
      return $this->setNoRender();
    }
    // Get subject and check auth
    $subject = Engine_Api::_()->core()->getSubject('recipe');
    if( !$subject->authorization()->isAllowed($viewer, 'view') ) {
      return $this->setNoRender();
    }
    // Get paginator
    $table = Engine_Api::_()->getItemTable('recipe_topic');
    $select = $table->select()
										->where('recipe_id = ?', Engine_Api::_()->core()->getSubject()->getIdentity())
										->order('sticky DESC')
										->order('modified_date DESC');

    $this->view->paginator = $paginator = Zend_Paginator::factory($select);

    // Do not render if nothing to show and not viewer
    if( $paginator->getTotalItemCount() <= 0 && !$viewer->getIdentity() ) {
      return $this->setNoRender();
    }

    $this->view->canPost = Engine_Api::_()->authorization()->isAllowed($subject, $viewer, 'comment');

		if($paginator->getTotalItemCount() <= 0 && empty($this->view->canPost)) {
			return $this->setNoRender();
		}

    // Add count to title if configured
    if( $this->_getParam('titleCount', false) && $paginator->getTotalItemCount() > 0 ) {
      $this->_childCount = $paginator->getTotalItemCount();
    }
  }

  public function getChildCount()
  {
    return $this->_childCount;
  }
}