<?php
 /**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Recipe
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2010-12-31 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Recipe_Widget_PhotosRecipeController extends Engine_Content_Widget_Abstract {

  protected $_childCount;

  public function indexAction() {

    // Don't render this if not authorized
    $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();

    if (!Engine_Api::_()->core()->hasSubject()) {
      return $this->setNoRender();
    }
    // Get subject and check auth
    $recipe = Engine_Api::_()->core()->getSubject('recipe');
   
    $this->view->allowed_upload_photo = 0;
    $subject_recipe = Engine_Api::_()->core()->getSubject();
    $allowed_upload_photo = Engine_Api::_()->authorization()->isAllowed($subject_recipe, $viewer, 'photo');
    
    if ($allowed_upload_photo) {
      $this->view->allowed_upload_photo = $allowed_upload_photo;
    }

    if (!empty($viewer_id)) {
      // get user level
      $this->view->user_level = $user_level = Engine_Api::_()->user()->getViewer()->level_id;
    }
    // get allubm for recipe
    $this->view->album = $album = $recipe->getSingletonAlbum();
    $this->view->paginator = $paginator = $album->getCollectiblesPaginator();
    $this->view->total_images = $paginator->count();

    if (empty($this->view->allowed_upload_photo) && empty($this->view->total_images)) {
      return $this->setNoRender();
    }
  
    // ser current page number
    $paginator->setCurrentPageNumber($this->_getParam('page'));

    // set image per page
    $paginator->setItemCountPerPage(20);

    // Add count to title if configured
    if ($this->_getParam('titleCount', false) && $paginator->getTotalItemCount() > 0) {
      $this->_childCount = $paginator->getTotalItemCount();
    }
    $this->view->recipe = $recipe;
  }

  public function getChildCount() {
    return $this->_childCount;
  }
}