<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Recipe
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2010-12-31 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Recipe_Widget_VideoRecipeController extends Engine_Content_Widget_Abstract {

  protected $_childCount;

  public function indexAction() {

    // Don't render this if not authorized
    $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
    if (!Engine_Api::_()->core()->hasSubject()) {
      return $this->setNoRender();
    }

    // get viewr_id for viewr
    $this->view->viewer_id = $viewer_id = $viewer->getIdentity();

    // Get subject and check auth
    $recipe = Engine_Api::_()->core()->getSubject('recipe');
    $this->view->owner_id = $owner_id = $recipe['owner_id'];

    if ($recipe) {
      $owner = Engine_Api::_()->getItem('user', $recipe->owner_id);
    }

    if (empty($viewer_id))
      $user_level = 0;
    else
      $user_level = $viewer->level_id;

    // Check for video
    $this->view->allowed_upload_video = 0;
    $allowed_upload_videoEnable = Engine_Api::_()->recipe()->enableVideoPlugin();
    if (!$allowed_upload_videoEnable) {
      return $this->setNoRender();
    }

    if (!empty($viewer_id) && Engine_Api::_()->recipe()->allowVideo($recipe, $viewer)) {
      $this->view->allowed_upload_video = 1;
    }

    $video = array();

    // retrive the video_id which is related to recipe
    $select = Engine_Api::_()->getDbTable('clasfvideos', 'recipe')->getRecipeViewVideosSQl($recipe->recipe_id);
    $paginator = Zend_Paginator::factory($select);

    // ser current page number
    $paginator->setCurrentPageNumber($this->_getParam('page'));

    // set image per page
    $paginator->setItemCountPerPage(10);
    $video = $paginator;
    $counter = $paginator->getTotalItemCount();

    if (empty($this->view->allowed_upload_video) && empty($counter)) {
      return $this->setNoRender();
    }
    $this->view->video = $video;
    $this->view->recipe = $recipe;
    // Add count to title if configured
    if ($this->_getParam('titleCount', false) && $counter > 0) {
      $this->_childCount = $counter;
    }
    $this->view->sitevideoviewEnable = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitevideoview');
  }

  public function getChildCount() {
    return $this->_childCount;
  }

}