<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteapi
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    IndexController.php 2015-09-17 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Red5pro_IndexController extends Siteapi_Controller_Action_Standard {

    public function init()
    {
        
    }

    /*
    * Start the broadcast
    */
    public function startBroadcastAction()
    {

        Engine_Api::_()->getApi('Core', 'siteapi')->setTranslate();
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();

        if(!$viewer_id)
            $this->respondWithError("unauthorized","Please Login to Broadcast");

        $subject_type = $this->_getParam ( "subject_type", null );
        $subject_id = $this->_getParam ( "subject_id", null );
        $stream_name = $this->_getParam ( "stream_name", null );
        $title = $this->_getParam ( "title", "This is a New Video From BroadCast" );
        $isAdvancedVideoEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitevideo');


        if($isAdvancedVideoEnabled && $subject_type!="siteevent_event"){
            $subject_type = "sitevideo_video";
        }

        $description = $this->_getParam ( "description", "This is a New Video From BroadCast" );
        
        if (!$subject_type || !$stream_name || !$title)
            $this->respondWithValidationError ( 'parameter_missing', 'Name or Title missing' );

        $streamTable = Engine_Api::_()->getDbtable( 'streams', 'red5pro' );

        $db = $streamTable->getAdapter();
        $db->beginTransaction ();
        
        try {


            // if($subject_type=="siteevent_event"){
            //     $videoDbTable = Engine_Api::_()->getDbtable('videos', 'siteevent');
            //     $newVideo = $videoDbTable->createRow();
            //     $newVideo->status = 0;
            //     $newVideo->title = $title;
            //     $newVideo->event_id = $subject_id;
            //     $newVideo->status = 0;
            //     $newVideo->description = $description;
            //     $newVideo->search = 1;
            //     $newVideo->owner_id = $viewer_id;
            //     $newVideo->type = "upload";
            //     $newVideo->code = "flv";
            //     $newVideo->save();
            // }
            // else{
                $videoDbTable = Engine_Api::_()->getDbtable('videos', 'sitevideo');
                $newVideo = $videoDbTable->createRow();
                $newVideo->status = 0;
                $newVideo->title = $title;
                $newVideo->status = 1;
                $newVideo->description = $description;
                $newVideo->search = 1;
                $newVideo->owner_type = "user";
                $newVideo->owner_id = $viewer_id;
                $newVideo->type = "upload";
                $newVideo->code = "flv";
                $newVideo->synchronized = 1;
                $newVideo->save();
            // }

            // CREATE AUTH STUFF HERE
            $auth = Engine_Api::_()->authorization()->context;
            $roles = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
            if (isset($_GET['auth_view']))
                $auth_view = $values['auth_view'];
            else
                $auth_view = "everyone";
            $viewMax = array_search($auth_view, $roles);
            foreach ($roles as $i => $role) {
                $auth->setAllowed($newVideo, $role, 'view', ($i <= $viewMax));
            }

            $roles = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');

            if (isset($values['auth_comment']))
                $auth_comment = $values['auth_comment'];
            else
                $auth_comment = "everyone";

            $commentMax = array_search($auth_comment, $roles);
            foreach ($roles as $i => $role) {
                $auth->setAllowed($newVideo, $role, 'comment', ($i <= $commentMax));
            }


            $video_id = $newVideo->getIdentity();            

            // Create New Stream
            $streamTable = Engine_Api::_()->getDbtable ( "streams", "red5pro" );
            $newStream = $streamTable->createRow();
            $newStream->name = $stream_name;
            $newStream->subject_type = $subject_type;
            $newStream->start_time = date ( 'Y-m-d H:i:s' );
            $newStream->title = $title;
            $newStream->video_id = $video_id;
            $newStream->description = $description;

            $newStream->subject_id = $subject_id ? $subject_id : $video_id;
            $newStream->save();

            if($subject_type=="siteevent_event"){
                $siteevent = Engine_Api::_()->getItem("siteevent_event" , $subject_id);
                $notificationsTable = Engine_Api::_()->getDbtable ( 'notifications', 'activity' );
                $select = $siteevent->membership()->getMembersObjectSelect();
                $members = Engine_Api::_()->getDbTable('users', 'user')->fetchAll($select);
                foreach ($members as $member) {
                    $row = $notificationsTable->createRow();
                    $row->user_id = $member->getIdentity();
                    $row->subject_type = $viewer->getType();
                    $row->subject_id = $viewer->getIdentity();
                    $row->type = "live_broadcast";
                    $row->object_type = $subject_type;
                    $row->object_id = $subject_id ? $subject_id : $video_id ;
                    $row->params = Zend_Json::encode( array (
                            'stream_name' => $stream_name ,
                             'main_subject_type' => $subject_type,
                            'main_subject_id' => $newStream->subject_id,
                            "video_type" => $newVideo->getType(),
                            "video_id" => $video_id,
                    ) );
                    $row->date = date( 'Y-m-d H:i:s' );
                    $row->save();
                }
            }
            else{
                $select = $viewer->membership()->getMembersOfSelect();
                $friends = Zend_Paginator::factory($select);
                $notificationsTable = Engine_Api::_ ()->getDbtable ( 'notifications', 'activity' );
                foreach ( $friends as $friend ) {
                    $row = $notificationsTable->createRow();
                    $row->user_id = $friend->resource_id;
                    $row->subject_type = $viewer->getType();
                    $row->subject_id = $viewer->getIdentity();
                    $row->type = "live_broadcast";
                    $row->object_type = $subject_type;
                    $row->object_id = $subject_id ? $subject_id : $video_id ;
                    $row->params = Zend_Json::encode ( array (
                            'stream_name' => $stream_name ,
                             'main_subject_type' => $subject_type,
                            'main_subject_id' => $newStream->subject_id,
                    ) );
                    $row->date = date( 'Y-m-d H:i:s' );
                    $row->save();
                }
            }
            
            $db->commit();
            
            $this->respondWithSuccess(array('video_id' => $newStream->video_id , "video_type" => $newVideo->getType(),'subject_type' => $subject_type , 'subject_id' => $newStream->subject_id));
        } catch ( Exception $e ) {
            $db->rollBack ();
            $this->respondWithError( 'internal_server_error', $e->getMessage() );
        }
    }

    public function stopBroadcastAction()
    {
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();
        $stream_name = $this->_getParam("stream_name","");
        $values = array();

        if(!$stream_name)
            $this->respondWithValidationError('parameter_missing' , 'stream_name missing');
        
        $streamTable = Engine_Api::_()->getDbtable('streams' , 'red5pro');
        $stream = $streamTable->getstream($stream_name);

        if(!$stream)
            $this->respondWithError("no_record");

        if($stream->end_time != null)
            $this->respondWithError("unauthorized","Broadcast Already finished");


        $path = "/usr/local/red5pro/webapps/live/streams/".$stream_name.".flv";

        chmod( "/usr/local/red5pro/webapps/live/streams/" , 0777 );

        if(!file_exists($path)){
            $this->respondWithValidationError("unauthorized" , "file does not exists");
        }

        $params = array(
            'name' => $path,
            'owner_type' => 'user',
            'owner_id' => $viewer->getIdentity()
        );


        if($stream->subject_type=='video' || $stream->subject_type == 'siteevent_event')
        {
            $params['parent_id'] = $viewer_id;
            $params['parent_type'] = "user";
            $params["type"] = "video";
        }
        else if($stream->subject_type=='sitevideo_video'){
            $params['parent_id'] = $viewer_id;
            $params['parent_type'] = "user";
            $params["type"] = "sitevideo_video";
        }

        $moduleName = explode("_", $stream->subject_type);
        $moduleName = $moduleName[0];


        // if($stream->subject_type == "sitevideo_video")
            $moduleName = "sitevideo";

        $videoDbTable = Engine_Api::_()->getDbTable("videos" , $moduleName);

        $db = $streamTable->getAdapter();
        $db->beginTransaction();
        try
        {

            $file = Engine_Api::_()->storage()->create($path, $params);

            $stream->end_time = date('Y-m-d H:i:s');
            $stream->save();

            // Get Video Object
            $video = Engine_Api::_()->getItem("sitevideo_video" , $stream->video_id);
            $video->code = 'flv';
            $video->type = "upload";
            $video->status = 0;
            $video->rotation = 90;

            //if($moduleName!="siteevent")
                $video->synchronized = 1;
            $video->file_id = $file->getIdentity();
            $video->save();

            // // CREATE AUTH STUFF HERE
            // $auth = Engine_Api::_()->authorization()->context;
            // $roles = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
            // $auth_view = "everyone";
            
            // $viewMax = array_search($auth_view, $roles);
            // foreach ($roles as $i => $role) {
            //     $auth->setAllowed($video, $role, 'view', true);                
            // }

            // $roles = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
            // $auth_comment = "everyone";
            // $commentMax = array_search($auth_comment, $roles);
            // foreach ($roles as $i => $role) {
            //     $auth->setAllowed($video, $role, 'comment', true);
            // }

            $stream->video_id = $video->getIdentity();
            $stream->save();
            // echo $file->storage_path;
            // die;

            $db->commit();


            // if($moduleName=="siteevent"){
            //     Engine_Api::_()->getDbtable('jobs', 'core')->addJob('sitevideo_encode', array(
            //          'video_id' => $video->getIdentity(),
            //          'type' => 'mp4',
            //     ));
            // }
            // else{
                Engine_Api::_()->getDbtable('jobs', 'core')->addJob('sitevideo_encode', array(
                     'video_id' => $video->getIdentity(),
                     'type' => 'mp4',
                ));
            // }

            // $this->_execute($stream);
            
            $this->respondWithSuccess(array('video_id' => $stream->video_id , 'subject_type' => $stream->subject_type));

        }
        catch(Exception $e)
        {
            $db->rollBack();
            $this->respondWithError('internal_server_error', $e->getMessage());
        }

    }

    public function getVideoURL($video, $autoplay = true) {
        // YouTube
        if ($video->type == 1 || $video->type == 'youtube') {
            return 'www.youtube.com/embed/' . $video->code . '?wmode=opaque' . ($autoplay ? "&autoplay=1" : "");
        } elseif ($video->type == 2 || $video->type == 'vimeo') { // Vimeo
            return 'player.vimeo.com/video/' . $video->code . '?title=0&amp;byline=0&amp;portrait=0&amp;wmode=opaque' . ($autoplay ? "&amp;autoplay=1" : "");
        } elseif ($video->type == 3 || $video->type == 'upload') { // Uploded Videos
            $staticBaseUrl = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.static.baseurl', null);

            $getHost = Engine_Api::_()->getApi('Core', 'siteapi')->getHost();
            $getDefaultStorageId = Engine_Api::_()->getDbtable('services', 'storage')->getDefaultServiceIdentity();
            $getDefaultStorageType = Engine_Api::_()->getDbtable('services', 'storage')->getService($getDefaultStorageId)->getType();

            $host = '';
            if ($getDefaultStorageType == 'local')
                $host = !empty($staticBaseUrl) ? $staticBaseUrl : $getHost;

            $video_location = Engine_Api::_()->storage()->get($video->file_id, $video->getType())->getHref();

            return $host . $video_location;
        }
    }

    /**
     * Handle thumbnail
     *
     * @return array
     */
    private function _handleThumbnail($type, $code = null) {
        switch ($type) {
            //youtube
            case "1":
                //https://i.ytimg.com/vi/Y75eFjjgAEc/default.jpg
                return "https://i.ytimg.com/vi/$code/default.jpg";
            //vimeo
            case "2":
                //thumbnail_medium
                $data = simplexml_load_file("http://vimeo.com/api/v2/video/" . $code . ".xml");
                $thumbnail = $data->video->thumbnail_medium;
                return $thumbnail;
        }
    }

    /**
     * Retrieves information and returns title and description.
     *
     * @return array
     */
    //FUNCTION FOR RETREVES INFORMATION AND RETURES TITLE AND DESCRIPTION
    private function _handleInformation($type, $code) {
        switch ($type) {

            //YOUTUBE
            case "1":
                $key = Engine_Api::_()->getApi('settings', 'core')->getSetting('video.youtube.apikey');
                $data = file_get_contents('https://www.googleapis.com/youtube/v3/videos?part=snippet,contentDetails&id=' . $code . '&key=' . $key);
                if (empty($data)) {
                    return;
                }
                $data = Zend_Json::decode($data);
                $information = array();
                $youtube_video = $data['items'][0];
                $information['title'] = $youtube_video['snippet']['title'];
                $information['description'] = $youtube_video['snippet']['description'];
                $information['duration'] = Engine_Date::convertISO8601IntoSeconds($youtube_video['contentDetails']['duration']);
                return $information;

            //VIMEO
            case "2":
                //MEDIUM THUMBNAIL
                $data = simplexml_load_file("http://vimeo.com/api/v2/video/" . $code . ".xml");
                $thumbnail = $data->video->thumbnail_medium;
                $information = array();
                $information['title'] = $data->video->title;
                $information['description'] = $data->video->description;
                $information['duration'] = $data->video->duration;
                //http://img.youtube.com/vi/Y75eFjjgAEc/default.jpg
                return $information;
        }
    }

    public function viewBroadcastAction()
    {
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();
        $stream_name = $this->_getParam("stream_name", null);
        $values = array();

        if(!$stream_name)
            $this->respondWithValidationError('parameter_missing' , 'stream_name missing');
        
        $streamTable = Engine_Api::_()->getDbtable('streams' , 'red5pro');
        $stream = $streamTable->getstream($stream_name);
        $subject = Engine_Api::_()->getItem($stream->subject_type , $stream->subject_id);
        if(!$subject)
            $this->respondWithError("no_record");

        if($stream->end_time == null){
            $this->respondWithValidationError('unauthorized' , 'The stream is broadcasting');
        }
        
        
        if($stream->subject_type=='video')
            $this->_forward('view' , 'index' , 'video' , array('video_id' => $stream->video_id) );
        else if($stream->subject_type=="sitevideo_video")
            $this->_forward('view', 'index', 'sitevideo', array('video_id' => $stream->video_id));

    }
    
    public function deleteBroadcastAction()
    {
        $stream_name = $this->_getParam("stream_name","");

        if(!$stream_name)
            $this->respondWithValidationError('parameter_missing' , 'stream_name missing');
        
        $streamTable = Engine_Api::_()->getDbtable('streams' , 'red5pro');
        $stream = $streamTable->getstream($stream_name);

        if(!$stream)
            $this->respondWithError("no_record");

        if($stream->delete())
            $this->successResponseNoContent("no_content");
        else
            $this->respondWithError("unauthorized","Some Problem Occured");
    }

    public function deleteAction()
    {
        $sql = "delete from engine4_red5pro_streams";
        $streamTable = Engine_Api::_()->getDbtable('streams' , 'red5pro');
        $db = $streamTable->getAdapter();
        $db->query($sql);
        $this->successResponseNoContent("no_content");
    }

    protected function _execute($stream) {
        Engine_Api::_()->getApi('Core', 'siteapi')->setTranslate();
        // Get job and params
        // No video id?
        if (!($video_id = $stream->video_id)) {
            // $this->_setState('failed', 'No video identity provided.');
            // $this->_setWasIdle();
            return;
        }

        // Get video object
        $video = Engine_Api::_()->getItem('sitevideo_video', $video_id);
        if (!$video || !($video instanceof Sitevideo_Model_Video)) {
            // $this->_setState('failed', 'Video is missing.');
            // $this->_setWasIdle();
            return;
        }

        $video->status =0;
        $video->save();

        // Check video status
        // if (0 != $video->status) {
        //     // $this->_setState('failed', 'Video has already been encoded, or has already failed encoding.');
        //     // $this->_setWasIdle();
        //     return;
        // }

        // $type = $video->type;
        $type = "mp4";

        // Process
        try {
            $this->_process($video, $type);
            $this->_setIsComplete(true);
        } catch (Exception $e) {
            $this->respondWithError("unauthorized" , $e->getMessage());
            // $this->_setState('failed', 'Exception: ' . $e->getMessage());

            // Attempt to set video state to failed
            try {
                if (1 != $video->status) {
                    $video->status = 3;
                    $video->save();
                }
            } catch (Exception $e) {
                $this->_addMessage($e->getMessage());
            }
        }
    }

    public function _addMessage($message){
        echo $message;
        echo "<br>";
    }

    public function _setIsComplete($status){
        return true;
    }

    private function getFFMPEGPath() {set_time_limit(0);
        // Check we can execute
        if (!function_exists('shell_exec')) {
            throw new Sitevideo_Model_Exception('Unable to execute shell commands using shell_exec(); the function is disabled.');
        }

        if (!function_exists('exec')) {
            throw new Sitevideo_Model_Exception('Unable to execute shell commands using exec(); the function is disabled.');
        }
        $coreSettings = Engine_Api::_()->getApi('settings', 'core');

        // Make sure FFMPEG path is set
        $ffmpeg_path = $coreSettings->getSetting('sitevideo.ffmpeg.path', $coreSettings->getSetting('sitevideo.ffmpeg.path', ''));
        if (!$ffmpeg_path) {
            throw new Sitevideo_Model_Exception('Ffmpeg not configured');
        }

        // Make sure FFMPEG can be run
        if (!@file_exists($ffmpeg_path) || !@is_executable($ffmpeg_path)) {
            $output = null;
            $return = null;
            exec($ffmpeg_path . ' -version', $output, $return);

            if ($return > 0) {
                throw new Sitevideo_Model_Exception('Ffmpeg found, but is not executable');
            }
        }

        return $ffmpeg_path;
    }

    private function getTmpDir() {
        // Check the video temporary directory
        $tmpDir = APPLICATION_PATH . DIRECTORY_SEPARATOR . 'temporary' .
                DIRECTORY_SEPARATOR . 'sitevideo';

        if (!is_dir($tmpDir) && !mkdir($tmpDir, 0777, true)) {
            throw new Sitevideo_Model_Exception('Video temporary directory did not exist and could not be created.');
        }

        if (!is_writable($tmpDir)) {
            throw new Sitevideo_Model_Exception('Video temporary directory is not writable.');
        }

        return $tmpDir;
    }

    private function getVideo($video) {
        // Get the video object
        if (is_numeric($video)) {
            $video = Engine_Api::_()->getItem('sitevideo_video', $video);
        }

        if (!($video instanceof Sitevideo_Model_Video)) {
            throw new Sitevideo_Model_Exception('Argument was not a valid video');
        }

        return $video;
    }

    private function getStorageObject($video) {
        // Pull video from storage system for encoding
        $storageObject = Engine_Api::_()->getItem('storage_file', $video->file_id);

        if (!$storageObject) {
            throw new Sitevideo_Model_Exception('Video storage file was missing');
        }

        return $storageObject;
    }

    private function getOriginalPath($storageObject) {
        $originalPath = $storageObject->temporary();

        if (!file_exists($originalPath)) {
            throw new Sitevideo_Model_Exception('Could not pull to temporary file');
        }

        return $originalPath;
    }

    private function getVideoFilters($video, $width, $height) {
        $filters = "scale=$width:$height";

        if ($video->rotation > 0) {
            $filters = "pad='max(iw,ih*($width/$height))':ow/($width/$height):(ow-iw)/2:(oh-ih)/2,$filters";

            if ($video->rotation == 180)
                $filters = "hflip,vflip,$filters";
            else {
                $transpose = array(90 => 1, 270 => 2);

                if (empty($transpose[$video->rotation]))
                    throw new Sitevideo_Model_Exception('Invalid rotation value');

                $filters = "transpose=${transpose[$video->rotation]},$filters";
            }
        }

        return $filters;
    }

    private function conversionSucceeded($video, $videoOutput, $outputPath) {
        $success = true;

        // Unsupported format
        if (preg_match('/Unknown format/i', $videoOutput) ||
                preg_match('/Unsupported codec/i', $videoOutput) ||
                preg_match('/patch welcome/i', $videoOutput) ||
                preg_match('/Audio encoding failed/i', $videoOutput) ||
                !is_file($outputPath) ||
                filesize($outputPath) <= 0) {
            $success = false;
            $video->status = 3;
        }

        // This is for audio files
        else if (preg_match('/video:0kB/i', $videoOutput)) {
            $success = false;
            $video->status = 5;
        }

        return $success;
    }

    private function notifyOwner($video, $owner) {
        Engine_Api::_()->getApi('Core', 'siteapi')->setTranslate();
        $translate = Zend_Registry::get('Zend_Translate');
        $language = !empty($owner->language) && $owner->language != 'auto' ? $owner->language : null;

        $notificationMessage = '';
        $exceptionMessage = 'Unknown encoding error.';

        if ($video->status == 3) {
            $exceptionMessage = 'Video format is not supported by FFMPEG.';
            $notificationMessage = 'Video conversion failed. Video format is not supported by FFMPEG. Please try %1$sagain%2$s.';
        } else if ($video->status == 5) {
            $exceptionMessage = 'Audio-only files are not supported.';
            $notificationMessage = 'Video conversion failed. Audio files are not supported. Please try %1$sagain%2$s.';
        } else if ($video->status == 7) {
            $notificationMessage = 'Video conversion failed. You may be over the site upload limit.  Try %1$suploading%2$s a smaller file, or delete some files to free up space.';
        }

        $notificationMessage = $translate->translate(sprintf($notificationMessage, '', ''), $language);

        Engine_Api::_()->getDbtable('notifications', 'activity')
                ->addNotification($owner, $owner, $video, 'sitevideo_processed_failed', array(
                    'message' => $notificationMessage,
                    'message_link' => Zend_Controller_Front::getInstance()->getRouter()->assemble(array('action' => 'manage'), 'sitevideo_general', true),
        ));

        return $exceptionMessage;

    }

    private function getDuration($videoOutput) {
        $duration = 0;

        if (preg_match('/Duration:\s+(.*?)[.]/i', $videoOutput, $matches)) {
            list($hours, $minutes, $seconds) = preg_split('[:]', $matches[1]);
            $duration = ceil($seconds + ($minutes * 60) + ($hours * 3600));
        }

        return $duration;
    }

    private function generateMainThumbnail($outputPath, $output, $thumb_splice, $thumbPath, $log) {
        set_time_limit(0);
        error_reporting(E_ALL);
        ini_set("display_errors", true);
        $ffmpeg_path = $this->getFFMPEGPath();

        // Thumbnail process command
        $thumbCommand = $ffmpeg_path . ' '
                . '-i ' . escapeshellarg($outputPath) . ' '
                . '-f image2' . ' '
                . '-ss ' . $thumb_splice . ' '
                . '-vframes 1' . ' '
                . '-v 2' . ' '
                . '-y ' . escapeshellarg($thumbPath) . ' '
                . '2>&1';

        // Process thumbnail
        $thumbOutput = $output .
                $thumbCommand . PHP_EOL .
                shell_exec($thumbCommand);

        // Log thumb output
        if ($log) {
            $log->log($thumbOutput, Zend_Log::INFO);
        }

        // Check output message for success
        $thumbSuccess = true;
        if (preg_match('/video:0kB/i', $thumbOutput)) {
            $thumbSuccess = false;
        }
        $mainHeight = Engine_Api::_()->getApi('settings', 'core')->getSetting('main.video.height', 1600);
        $mainWidth = Engine_Api::_()->getApi('settings', 'core')->getSetting('main.video.height', 1600);
        // Resize thumbnail
        if ($thumbSuccess) {
            try {
                $image = Engine_Image::factory();
                $image->open($thumbPath)
                        ->resize($mainHeight, $mainWidth)
                        ->write($thumbPath)
                        ->destroy();
            } catch (Exception $e) {
                $this->_addMessage((string) $e->__toString());
                $thumbSuccess = false;
            }
        }

        return $thumbSuccess;
    }

    private function buildVideoCmd($video, $width, $height, $type, $originalPath, $outputPath, $compatibilityMode = false) {
        $ffmpeg_path = $this->getFFMPEGPath();

        $videoCommand = $ffmpeg_path . ' '
                . '-i ' . escapeshellarg($originalPath) . ' '
                . '-ab 64k' . ' '
                . '-ar 44100' . ' '
                . '-qscale 5' . ' '
                . '-r 25' . ' ';

        if ($type == 'mp4')
            $videoCommand .= '-vcodec libx264' . ' '
                    . '-acodec aac' . ' '
                    . '-strict experimental' . ' '
                    . '-preset veryfast' . ' '
                    . '-f mp4' . ' '
            ;
        else
            $videoCommand .= '-vcodec flv -f flv ';

        if ($compatibilityMode) {
            $videoCommand .= "-s ${width}x${height}" . ' ';
        } else {
            $filters = $this->getVideoFilters($video, $width, $height);
            $videoCommand .= '-vf "' . $filters . '" ';
        }

        $videoCommand .=
                '-y ' . escapeshellarg($outputPath) . ' '
                . '2>&1';

        return $videoCommand;
    }

    protected function _process($video, $type, $compatibilityMode = false) {
        $tmpDir = $this->getTmpDir();
        $video = $this->getVideo($video);

        // Update to encoding status
        $video->status = 2;
        $video->type = 'upload';
        $video->save();

        // Prepare information
        $owner = $video->getOwner();

        // Pull video from storage system for encoding
        $storageObject = $this->getStorageObject($video);
        $originalPath = $this->getOriginalPath($storageObject);

        $outputPath = $tmpDir . DIRECTORY_SEPARATOR . $video->getIdentity() . '_vconverted.mp4';
        $thumbPath = $tmpDir . DIRECTORY_SEPARATOR . $video->getIdentity() . '_vnormalthumb.jpg';

        $thumbNormalLargePath = $tmpDir . DIRECTORY_SEPARATOR . $video->getIdentity() . '_vnormallargethumb.jpg';
        $thumbMainPath = $tmpDir . DIRECTORY_SEPARATOR . $video->getIdentity() . '_vmainthumb.jpg';
        $width = 480;
        $height = 386;

        $videoCommand = $this->buildVideoCmd($video, $width, $height, $type, $originalPath, $outputPath, $compatibilityMode);

        // Prepare output header
        $output = PHP_EOL;
        $output .= $originalPath . PHP_EOL;
        $output .= $outputPath . PHP_EOL;
        $output .= $thumbPath . PHP_EOL;        

        // Prepare logger
        $log = new Zend_Log();
        $log->addWriter(new Zend_Log_Writer_Stream(APPLICATION_PATH . '/temporary/log/sitevideo.log'));

        // Execute video encode command
        $videoOutput = $output .
                $videoCommand . PHP_EOL .
                shell_exec($videoCommand);

        // Log
        if ($log) {
            $log->log($videoOutput, Zend_Log::INFO);
        }

        // Check for failure
        $success = $this->conversionSucceeded($video, $videoOutput, $outputPath);

        // Failure
        if (!$success) {
            if (!$compatibilityMode) {
                $this->_process($video, true);
                return;
            }

            $exceptionMessage = '';

            $db = $video->getTable()->getAdapter();
            $db->beginTransaction();

            try {
                $video->save();
                //$exceptionMessage = $this->notifyOwner($video, $owner);
                $db->commit();
            } catch (Exception $e) {
                $videoOutput .= PHP_EOL . $e->__toString() . PHP_EOL;

                if ($log) {
                    $log->write($e->__toString(), Zend_Log::ERR);
                }

                $db->rollBack();
            }

            // Write to additional log in dev
            if (APPLICATION_ENV == 'development') {
                file_put_contents($tmpDir . '/' . $video->video_id . '.txt', $videoOutput);
            }

            throw new Sitevideo_Model_Exception($exceptionMessage);
        }

        // Success
        else {
            // Get duration of the video to caculate where to get the thumbnail
            $duration = $this->getDuration($videoOutput);

            // Log duration
            if ($log) {
                $log->log('Duration: ' . $duration, Zend_Log::INFO);
            }

            // Fetch where to take the thumbnail
            $thumb_splice = $duration / 2;

            $thumbMainSuccess = $this->generateMainThumbnail($outputPath, $output, $thumb_splice, $thumbMainPath, $log);

            // Save video and thumbnail to storage system
            $params = array(
                'parent_id' => $video->getIdentity(),
                'parent_type' => $video->getType(),
                'user_id' => $video->owner_id
            );

            $db = $video->getTable()->getAdapter();
            $db->beginTransaction();

            try {
                $storageObject->setFromArray($params);
                $storageObject->store($outputPath);

                if ($thumbMainSuccess) {
                    $thumbMainSuccessRow = Engine_Api::_()->storage()->create($thumbMainPath, array_merge($params, array('type' => 'thumb.main')));
                }

                $thumbPath = $tmpDir . DIRECTORY_SEPARATOR . $video->getIdentity() . '_vnormalthumb.jpg';

                $thumbNormalLargePath = $tmpDir . DIRECTORY_SEPARATOR . $video->getIdentity() . '_vnormallargethumb.jpg';

                $image = Engine_Image::factory();
                $image->open($thumbMainPath)
                        ->resize(720, 720)
                        ->write($thumbNormalLargePath)
                        ->destroy();

                $image = Engine_Image::factory();
                $image->open($thumbMainPath)
                        ->resize(375, 375)
                        ->write($thumbPath)
                        ->destroy();
                Engine_Api::_()->storage()->create($thumbNormalLargePath, array_merge($params, array('type' => 'thumb.large')));
                $thumbNormalSuccessRow = Engine_Api::_()->storage()->create($thumbPath, array_merge($params, array('type' => 'thumb.normal')));

                $db->commit();
            } catch (Exception $e) {
                $db->rollBack();

                // delete the files from temp dir
                // unlink($originalPath);
                // unlink($outputPath);

                if ($thumbSuccess) {
                    // unlink($thumbPath);
                }

                $video->status = 7;
                $video->save();

                // $this->notifyOwner($video, $owner);

                // throw $e; // throw
            }

            // Video processing was a success!
            // Save the information
            if ($thumbMainSuccess) {
                $video->photo_id = $thumbMainSuccessRow->file_id;
            }

            $video->duration = $duration;
            $video->status = 1;
            $video->save();

            // delete the files from temp dir
            // unlink($originalPath);
            // unlink($outputPath);
            // unlink($thumbPath);
            // unlink($thumbMainPath);
            // unlink($thumbNormalLargePath);
            // insert action in a separate transaction if video status is a success
            $actionsTable = Engine_Api::_()->getDbtable('actions', 'activity');
            $db = $actionsTable->getAdapter();
            $db->beginTransaction();

            try {
                // new action
                $chanel = $video->getChannelModel();
                $actionType = $chanel ? 'sitevideo_channel_video_new' : 'sitevideo_video_new';
                $actionObject = $chanel ? $chanel : $video;
                $action = $actionsTable->addActivity($owner, $actionObject, $actionType);

                if ($action) {
                    $actionsTable->attachActivity($action, $video);
                }

                // notify the owner
                Engine_Api::_()->getDbtable('notifications', 'activity')
                        ->addNotification($owner, $owner, $video, 'sitevideo_processed');

                $db->commit();
            } catch (Exception $e) {
                $db->rollBack();
                throw $e; // throw
            }
        }
    }
}
