<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitepushnotification
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Sendnotifications.php 6590 2016-3-3 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteandroidapp_Plugin_Task_Sendnotifications extends Core_Plugin_Task_Abstract {
    public function execute(){
	$this->_sendNotification();
	
	// We didn't do anything
            $this->_setWasIdle();
    }
    
    private function _sendNotification(){
	$notificationTable = Engine_Api::_()->getDbtable('schedulednotifications', 'siteandroidapp');
	$db = $notificationTable->getAdapter();
	$db->beginTransaction();

	try{
	    $timezone = Engine_Api::_()->getApi('settings', 'core')->core_locale_timezone;
        date_default_timezone_set($timezone);
	    
	// Select a single notification item
        $notificationSelect = $notificationTable->select()
                ->where('scheduled_time <= ?',date('Y-m-d H:i:s'));
        $results = $notificationTable->fetchAll($notificationSelect);
        if(empty($results) || count($results) < 1)
            return;
        foreach($results as $notificationRow)
        {
            
	 $user = Engine_Api::_()->getItem('user', $notificationRow->user_id);
	 if(empty($user)){
                $notificationRow->delete();
                continue;
            }
            
        $tokenArray[] = $notificationRow->registration_token;
	$params=array();
	$params['message'] = $notificationRow->body;
	$params['title'] = $notificationRow->title;
	$scheduled_time = $notificationRow->scheduled_time;
        $notificationRow->delete();

        }
        $db->commit();

	$plugin = Engine_Api::_()->loadClass('Siteandroidapp_Plugin_Pushnotification');
	$plugin->sendAdminBaseAndroidNotification($tokenArray,$params);
           $this->sendPushnotificationConfirmationMial($scheduled_time);
	} 
	catch (Exception $ex) {
	}
    }

public function sendPushnotificationConfirmationMial($scheduled_time) {
        // the signup notification is emailed to the first SuperAdmin by default
        $notificationTable = Engine_Api::_()->getDbtable('schedulednotifications', 'siteandroidapp');
        $users_table = Engine_Api::_()->getDbtable('users', 'user');
        $users_select = $users_table->select()
                ->where('level_id = ?', 1)
                ->where('enabled >= ?', 1);
        $super_admin = $users_table->fetchRow($users_select);
        // Select a single notification item
        $notificationSelect = $notificationTable->select()
                ->where('scheduled_time <= ?', date('Y-m-d H:i:s'))
                ->limit(1);
        $notificationRow = $notificationTable->fetchRow($notificationSelect);
        if (empty($notificationRow)) {
           $mailAdminParams = array(
                        'host' => $_SERVER['HTTP_HOST'],
                        'email' => $super_admin->email,
                        'date' => date("F j, Y, g:i a"),
                        'recipient_title' => $super_admin->displayname,
                        'object_title' => $super_admin->displayname,
                        'object_link' => $super_admin->getHref(),
                        'nofification_time'=>$scheduled_time,
                        'member_name'=>$super_admin->displayname
                    );
           
           try {
                Engine_Api::_()->getApi('mail', 'core')->sendSystem($super_admin, 'siteapi_admin_androidpushnotification', $mailAdminParams);
            } catch (Exception $e) {
                // Silence exception
            }
        }
    }
    
}