<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteautoaction
 * @copyright  Copyright 2014-2015 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminActionController.php 2014-08-06 00:00:00 SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteautoaction_AdminActionController extends Core_Controller_Action_Admin
{
    public function createAction()
    {
        $params = $this->_getAllParams();
        if(!empty($params['isAjax']))
        $this->view->isAjax = $params['isAjax'];
        else
        $this->view->isAjax = '';
        if(!empty($params['selectedResource']))
        $this->view->selectedResource = $params['selectedResource'];
        else
        $this->view->selectedResource = '';
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
            ->getNavigation('siteautoaction_admin_main', array(), 'siteautoaction_admin_main_action');

        $allResourceTypes = Engine_Api::_()->siteautoaction()->getResourceTypes(Engine_Api::_()->getApi('search', 'core')->getAvailableTypes());

        $indexCompleted = array_search('ITEM_TYPE_FORUM_POST', $allResourceTypes);
        unset($allResourceTypes[$indexCompleted]);
        $indexCompleted = array_search('ITEM_TYPE_FORUM_TOPIC', $allResourceTypes);
        unset($allResourceTypes[$indexCompleted]); 

        $skippedResourceTypes = Engine_Api::_()->siteautoaction()->getResourceTypes(
            (array) Engine_Api::_()->getApi('settings', 'core')->getSetting('siteautoaction.resource')
        );
        $availableResourceTypes = array_diff($allResourceTypes, $skippedResourceTypes);
        $this->view->resourceTypes = $availableResourceTypes;
        if(!empty($params['search']))
        $this->view->search = $params['search'];
        else
        $this->view->search = '';
        if(!empty($params['resource_type']))
        $resource_type = $params['resource_type'];
        else
        $resource_type = '';
        $this->view->form = $form = new Siteautoaction_Form_Admin_Create();
        $form->addElement('hidden', 'resource_type', array(
            'value' => $resource_type,
            'order' => 9998
        ));
        $form->addElement('hidden', 'search', array(
            'value' => $this->view->search,
            'order' => 9999
        ));
        // Add actions
        $actions = $this->getActionTpyes($resource_type);
        $form->action_type->setMultiOptions($actions);
        $resourceName = array('siteevent_event' => 'siteevent_event', 'sitegroup_group' => 'sitegroup_group', 'sitepage_page' => 'sitepage_page', 'event' => 'event', 'group' => 'group', 'user' => 'user');
        $customOption = array(
                    1 => "Yes, enable automatic membership. Selecting this, the target users will become members of the content for which auto-action is being created without any notice/request sent to them irrespective of the permission settings done for that content by the content owner.",
                    2 => "No, do not enable automatic membership. Selecting this, a request will be sent automatically from the target users to the content for which auto-action is being created for being a member of the content. User will be a member of the content only when the content owner approves that request.Please note that selecting this option can load the content owner with load of notifications and requests."
                );
        if(array_key_exists($resource_type, $resourceName)) {
             $form->action_join->setMultiOptions($customOption);
        }
        else {
            $display = $form->getElement('action_join');
            $display->setLabel("");
        }

        $struct = Engine_Api::_()->fields()->getFieldsStructureFull('user');
        foreach ($struct as $fskey => $map) {
            $fieldKey = $map->getKey();
            if($fieldKey)
                break;
        }
        $form->getElement($fieldKey)->setRequired(true)->setAllowEmpty(false);
        // Add resources
        $resourceIds = Engine_Api::_()->getDbTable('actions','siteautoaction')
            ->getResourceIds(array_merge($params, array('limit' => 10)));
        $form->resource_ids->setMultiOptions($resourceIds);

        if ($this->view->isAjax) {
            $this->_helper->layout->setLayout('admin-ajax');
            $this->view->isEmptyOptions = empty($resourceIds);
            return;
        }
        $form->resource_ids->setRegisterInArrayValidator(false);

        if ( !$this->getRequest()->isPost() || !$form->isValid($this->getRequest()->getPost())) {
            return;
        }
        if ($form->actionExists()) {
            return $form->addError('Selected action already exists.');
        }
        
        $form->saveValues();
        return $this->_helper->redirector->gotoRoute(array(
            'module' => 'siteautoaction',
            'controller' => 'action',
            'action' => 'manage',
            'selectedResource' => $params['resource_type']
        ), 'admin_default', true);
    }

    public function manageAction()
    {
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
            ->getNavigation('siteautoaction_admin_main', array(), 'siteautoaction_admin_main_action');
            
        $allResourceTypes = Engine_Api::_()->siteautoaction()->getResourceTypes(Engine_Api::_()->getApi('search', 'core')->getAvailableTypes());

        $indexCompleted = array_search('ITEM_TYPE_FORUM_POST', $allResourceTypes);
        unset($allResourceTypes[$indexCompleted]);
        $indexCompleted = array_search('ITEM_TYPE_FORUM_TOPIC', $allResourceTypes);
        unset($allResourceTypes[$indexCompleted]);

        $skippedResourceTypes = Engine_Api::_()->siteautoaction()->getResourceTypes(
            (array) Engine_Api::_()->getApi('settings', 'core')->getSetting('siteautoaction.resource')
        );
        $availableResourceTypes = array_diff($allResourceTypes, $skippedResourceTypes);

        $this->view->resourceTypes = $availableResourceTypes;

        $this->view->selectedResource = $params['resource_type'] = $this->_getParam('selectedResource', key($this->view->resourceTypes));

        $params['order'] = 'action_id DESC';
        $this->view->search = $params['search'] = $this->_getParam('search');
        $this->view->actions = $paginator = Engine_Api::_()->getDbTable('actions','siteautoaction')
            ->getActions($params);
        if (empty($paginator)) {
            return;
        }

        $paginator->setItemCountPerPage(10);
        $paginator->setCurrentPageNumber((int) $this->_getParam('page', 1));
    }

    public function deleteAction()
    {
        $actionId = $this->_getParam('id');
        if (empty($actionId)) {
            return;
        }

        // In smoothbox
        $this->_helper->layout->setLayout('default-simple');

        $this->view->form = $form = new Siteautoaction_Form_Admin_Delete();

        if( !$this->getRequest()->isPost() ) {
            $this->view->status = false;
            $this->view->error = Zend_Registry::get('Zend_Translate')->_('Invalid request method');
            return;
        }
        if( !$form->isValid($this->getRequest()->getPost()) ) {
            return;
        }

        try {
            Engine_Api::_()->getDbTable('actionOptions','siteautoaction')->delete(array(
                'action_id = ?' => $actionId
            ));
            Engine_Api::_()->getDbTable('actions','siteautoaction')->delete(array(
                'action_id = ?' => $actionId
            ));
        } catch (Exception $ex) {
            throw $ex;
        }

        return $this->_forward('success', 'utility', 'core', array(
            'parentRedirect' => Zend_Controller_Front::getInstance()->getRouter()->assemble(array(
                'module' => 'siteautoaction',
                'controller' => 'action',
                'action' => 'manage',
                'selectedResource' => $this->_getParam('selectedResource')
            ), 'admin_default', true),
            'messages' => [Zend_Registry::get('Zend_Translate')->_('Your action has been deleted.')]
        ));
    }

    public function toggleEnableAction()
    {
        $actionId = $this->_getParam('id');
        if (empty($actionId)) {
            return;
        }

        try {
            $actionTable = Engine_Api::_()->getDbTable('actions','siteautoaction');
            $select = $actionTable->select()->where('action_id = ?', $actionId);
            $action = $actionTable->fetchRow($select);
            $action->enabled = !$action->enabled;
            $action->save();
        } catch (Exception $ex) {
            throw $ex;
        }

        return $this->_helper->redirector->gotoRoute(array(
            'module' => 'siteautoaction',
            'controller' => 'action',
            'action' => 'manage',
            'selectedResource' => $this->_getParam('selectedResource')
            ), 'admin_default', true);
    }

	//ACTION FOR GET THE SEARCH RESULT BASED ON CORE SEARCH TABLE
  public function getSearchContentAction()
  {
    $data = array();
    //GET SEARCHABLE TEXT FROM GLOBAL SEARCH BOX
    $text = $this->_getParam('text', null);
    $resourceType = $this->_getParam('resource_type', null);
    if( !empty($text) && $resourceType ) {
      $limit = $this->_getParam('limit', 10);

      $table = Engine_Api::_()->getDbTable('actions', 'siteautoaction');
      $select = $table->getSelect(
          $text, $resourceType
        )->limit($limit);
      $items = $select->getTable()->fetchAll($select);
      $data = array();
      $i = 0;
      foreach( $items as $item ) {
        $type = $item->type;
        if( !Engine_Api::_()->hasItemType($type) ) {
          continue;
        }
        $item = $this->view->item($type, $item->id);
        if( empty($item) ) {
          continue;
        }
        $i++;
        $resourceTitle = $item->getShortType();
        if( $type == 'user' ) {
          $resourceTitle = 'member';
        }
        $iType = $this->view->translate(ucfirst($resourceTitle));
        if( is_array($iType) && isset($iType[0]) ) {
          $iType = $iType[0];
        }
        $data[] = array(
          'label' => $item->getTitle(),
          'type' => $iType,
          'photo' => $this->view->itemPhoto($item, 'thumb.icon'),
          'item_url' => $item->getHref(),
          //	'total_count' => $count,
          'count' => $i
        );
      }

      if( empty($data) ) {
        $data[] = array(
          'label' => $this->view->translate('No result found for "%s".', $text),
          'type' => 'no_resuld_found',
          'item_url' => 'no_resuld_found',
          'search_text' => $text,
        );
      }
      //	$data[$count]['total_count'] = $count;
    }


    return $this->_helper->json($data);
  }

  private function getActionTpyes($resourceType)
    {
        $actions = array();
        if (empty($resourceType)) {
            return $actions;
        }
        if (Engine_Api::_()->hasModuleBootstrap('siteshortcut')) {
            $shortcutTypes = Engine_Api::_()->getDbtable('shortcuttypes', 'siteshortcut')
                ->getEnableShortcutTypes();
            foreach ($shortcutTypes as $shortcutType) {
                if (stripos($shortcutType->type, $resourceType)) {
                    $actions['bookmark'] = 'Add to bookmark';
                    break;
                }
            }
        }
        $itemClass = Engine_Api::_()->getItemClass(strpos($resourceType, 'sitereview_listing') !== false ? 'sitereview_listing' : $resourceType);
        if($itemClass == "Sitemusic_Model_Pl") {
            $itemClass = "Sitemusic_Model_Playlist";
        }
        if ($itemClass === 'User_Model_User') {
            $actions['like'] = 'Like User';
            Zend_Loader::loadClass($itemClass);
            $user = new $itemClass(array());
            if (!$user->membership()->isUserApprovalRequired() && !$user->membership()->isReciprocal()) {
                $actions['join'] = 'Follow User';
                return $actions;
            }
            // $actions['follow'] = 'Follow User';
            $actions['join'] = 'Add to friend';
            return $actions;
        }

        $resource = Engine_Api::_()->siteautoaction()->getResourceTypes((array) $resourceType);
        if ($itemClass === 'Blog_Model_Blog') {
            $actions['subscribe'] = 'Subscribe ' . Zend_Registry::get('Zend_Translate')->_($resource[$resourceType]);
        }
        if($itemClass!='Sitestore_Model_Store') {
            if (method_exists($itemClass, 'membership')) {
                $actions['join'] = 'Join ' . Zend_Registry::get('Zend_Translate')->_($resource[$resourceType]);
            }
        }
        if (method_exists($itemClass, 'likes')) {
            $actions['like'] = 'Like ' . Zend_Registry::get('Zend_Translate')->_($resource[$resourceType]);
        }
        if (method_exists($itemClass, 'customAutoAction')) {
            $actions['custom'] = 'Custom Auto Action ' . Zend_Registry::get('Zend_Translate')->_($resource[$resourceType]);
        }
        
        $followModules = Engine_Api::_()->siteautoaction()->getFollowItems();
        if (in_array($resourceType, $followModules)) {
            $actions['follow'] = 'Follow ' . Zend_Registry::get('Zend_Translate')->_($resource[$resourceType]);
        }

        return $actions;
    }
    
    
}
