<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteautoaction
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    AdminSettingsController.php 2015-09-17 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteautoaction_AdminSettingsController extends Core_Controller_Action_Admin
{
    public function indexAction()
    {
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
            ->getNavigation('siteautoaction_admin_main', array(), 'siteautoaction_admin_main_settings');
        $this->view->form = $form = new Siteautoaction_Form_Admin_Settings_Global();

        if (!$this->getRequest()->isPost() || !$form->isValid($this->getRequest()->getPost())) {
            return;
        }

        $values = $form->getValues();
        $settings = Engine_Api::_()->getApi('settings', 'core');

        // Save settings
        foreach ($values as $key => $value) {
            if($settings->hasSetting($key)) {
                $settings->removeSetting($key);
            }

            $settings->setSetting($key, $value);
        }
        $form->addNotice('Your changes have been saved.');
    }

    public function faqAction() {
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('siteautoaction_admin_main', array(), 'siteautoaction_admin_main_faq');

        $this->view->show = $this->_getParam('show');
    }
}
