<?php

class Siteautologin_AdminManageController extends Core_Controller_Action_Admin
{
  public function indexAction()
  {

    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteautologin_admin_main', array(), 'siteautologin_admin_main_manage');

    $this->view->paginator = Engine_Api::_()->getDbtable('users', 'siteautologin')->getPaginator(array(
      'limit' => 30,
      'page' => $this->_getParam('page', 1)
    ));
  }

  public function addAction()
  {

    $this->_helper->layout->setLayout('admin-simple');

    //Render Form
    $this->view->form = $form = new Siteautologin_Form_Admin_Add();


    if( !$this->getRequest()->isPost() || !$form->isValid($this->getRequest()->getPost()) ) {
      return;
    }

    $values = $form->getValues();
    if( !$values["user_id"] ) {

      $form->addError("You have not chosen a user from the auto suggest box. Please choose the site user from auto suggest box below.");
      return;
    }
    $table = Engine_Api::_()->getDbtable('users', 'siteautologin');
    if( $table->hasUserAdded($values["user_id"]) ) {
      $form->addError("This user has already been added as test user, please choose any other user.");
      return;
    }
    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    try {
      $row = $table->createRow();
      $row->setFromArray($values);
      $row->save();
      $db->commit();
    } catch( Exception $e ) {
      $db->rollBack();
      throw $e;
    }
    $this->_forward('success', 'utility', 'core', array(
      'smoothboxClose' => 10,
      'parentRefresh' => 10,
      'messages' => array('You have successfully added test user!')
    ));
  }

  public function deleteAction()
  {

    $this->renderScript('admin-manage/delete.tpl');
    if( !$this->getRequest()->isPost() ) {
      return;
    }
    Engine_Api::_()->getDbtable('users', 'siteautologin')->delete(array('id =?' => $this->_getParam('id')));
    $this->_forward('success', 'utility', 'core', array(
      'smoothboxClose' => 10,
      'parentRefresh' => 10,
      'messages' => array('You have successfully removed test user.')
    ));
  }

  public function multiDeleteAction()
  {
    if( $this->getRequest()->isPost() ) {
      $values = $this->getRequest()->getPost();
      foreach( $values as $key => $value ) {
        if( $key == 'delete_' . $value ) {
          Engine_Api::_()->getDbtable('users', 'siteautologin')->delete(array('id =?' => (int) $value));
        }
      }
    }
    $this->_redirect('admin/siteautologin/manage');
  }

  public function enabledAction()
  {

    $id = $this->_getParam('id');
    if( !empty($id) ) {
      $item = Engine_Api::_()->getItem('siteautologin_user', $id);
      if( $item ) {
        $item->enabled = !$item->enabled;
        $item->save();
      }
    }
    $this->_redirect('admin/siteautologin/manage');
  }

  public function orderAction()
  {

    if( !$this->getRequest()->isPost() ) {
      return;
    }

    $table = Engine_Api::_()->getDbtable('users', 'siteautologin');
    $results = $table->fetchAll($table->select());
    foreach( $results as $row ) {
      $order = $this->getRequest()->getParam('order_' . $row->id);
      $row->order = $order ? $order : 999;
      $row->save();
    }
    return;
  }

  public function suggestUsersAction()
  {

    $sesdata = array();
    $users_table = Engine_Api::_()->getDbtable('users', 'user');
    $select = $users_table->select()
        ->where('level_id != ?', 1)
        ->where('displayname  LIKE ? or username LIKE ?', '%' . $this->_getParam('text') . '%')
        ->order('displayname ASC')->limit('40');
    $users = $users_table->fetchAll($select);

    foreach( $users as $user ) {
      $user_icon_photo = $this->view->itemPhoto($user, 'thumb.icon');
      $sesdata[] = array(
        'id' => $user->user_id,
        'label' => $user->getTitle(),
        'photo' => $user_icon_photo
      );
    }
    return $this->_helper->json($sesdata);
  }

}
