<?php

class Siteautologin_IndexController extends Core_Controller_Action_Standard
{
  public function autoLoginAction()
  {
    if( !$this->getRequest()->isPost() ) {
      if( null === $this->_helper->contextSwitch->getCurrentContext() ) {
        return $this->_helper->redirector->gotoRoute(array(), 'default', true);
      }
      $this->view->status = false;
      $this->view->error = true;
      return;
    }
    $id = $this->_getParam('id');
    $testuser = Engine_Api::_()->getItem('siteautologin_user', $id);
    if( $testuser && $testuser->getUser() && $testuser->getUser()->level_id != 1 ) {
      $user = $testuser->getUser();
      // Run pre login hook
      $event = Engine_Hooks_Dispatcher::getInstance()->callEvent('onUserLoginBefore', $user);
      // Login
      Zend_Auth::getInstance()->getStorage()->write($user->getIdentity());
      // Get ip address
      $db = Engine_Db_Table::getDefaultAdapter();
      $ipObj = new Engine_IP();
      $ipExpr = new Zend_Db_Expr($db->quoteInto('UNHEX(?)', bin2hex($ipObj->toBinary())));
      // Register login
      $loginTable = Engine_Api::_()->getDbtable('logins', 'user');
      $loginTable->insert(array(
        'user_id' => $user->getIdentity(),
        'email' => $user->email,
        'ip' => $ipExpr,
        'timestamp' => new Zend_Db_Expr('NOW()'),
        'state' => 'success',
        'active' => true,
      ));
      // Run post login hook
      $event = Engine_Hooks_Dispatcher::getInstance()->callEvent('onUserLoginAfter', $user);
      // Redirect
      if( null === $this->_helper->contextSwitch->getCurrentContext() ) {
        return $this->_helper->redirector->gotoRoute(array(), 'default', true);
      } else {
        $this->view->status = true;
        return;
      }
    }
  }

}
