<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Allure
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Add.php 2015-06-04 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebanner_Form_Admin_Slideshow_SlideAdd extends Engine_Form
{

  protected $_formInitParams = array(
    'background_type' => 'color',
  );

  public function setInitParams($params = array())
  {
    $this->_formInitParams = $params;
    return $this;
  }

  public function init()
  {

    $this->setTitle("Add New Slide")
      ->setAttribs(array('id' => 'sitebanner_slide_form'))
      ->setDescription('Create a new slide for this slideshow.')
      ->setAttrib('enctype', 'multipart/form-data');

    $client = new Zend_Http_Client();
    $client->setConfig(array('timeout' => 6000, 'adapter' => 'Zend_Http_Client_Adapter_Curl'))
      ->setUri('https://www.googleapis.com/webfonts/v1/webfonts?key=AIzaSyB8n5LK2n_9aUoqKulzWrkcltkTbqGhyXY');
    $response = $client->request()->getBody();
    $data = !empty($response) ? Zend_Json::decode($response) : array();
    $googleFontFamilies = array('' => 'Default');
    foreach( $data['items'] as $item ) {
      $googleFontFamilies['"' . $item["family"] . '"'] = $item['family'];
    }
    $this->addElement('Select', 'background_type', array(
      'label' => 'Slide Type',
      'description' => "Select the type of slide you want to create?",
      'multiOptions' => array(
        'color' => 'Background Color',
        'gradient' => 'Gradient Color',
        'image' => 'Background Image',
      ),
      'onchange' => "changeBackgroundType(this.value)",
    ));

    $this->addElement('Text', 'background_color', array(
      'label' => 'Slide Background Color',
      'decorators' => array(array('ViewScript', array(
            'viewScript' => '_formColorElement.tpl',
            'class' => '',
            'name' => 'background_color',
            'label' => 'Slide Background Color',
            'value' => $this->_formInitParams['background_type'] == 'color' && isset($this->_formInitParams['background']) ? $this->_formInitParams['background'] : '#000000',
          ))),
    ));
    $this->addElement('Text', 'background_gradient', array(
      'label' => 'Slide Gradient Color',
      'filters' => array(
        //new Engine_Filter_HtmlSpecialChars(),
        'StripTags',
        new Engine_Filter_Censor(),
        new Engine_Filter_StringLength(array('max' => '100')),
      ),
    ));

    $this->addElement('file', 'background_image', array(
      'label' => 'Slide Image',
      'accept' => 'image/*',
    ));
    $this->background_image->addValidator('Extension', false, 'jpg,png,gif,jpeg')
      ->setTransferAdapter('Http');
    

		$this->addElement('Dummy', 'slide_heading', array(
			'label' => 'Slide Heading',
		));
    // Init name
    $this->addElement('Text', 'title', array(
      'label' => 'Heading Text',
      'description' => "You can give a heading to your slide.",
      'maxlength' => '100',
      'allowEmpty' => false,
      'required' => true,
      'filters' => array(
        //new Engine_Filter_HtmlSpecialChars(),
        'StripTags',
        new Engine_Filter_Censor(),
        new Engine_Filter_StringLength(array('max' => '100')),
      ),
    ));
    $this->addElement('Text', 'style_heading_color', array(
      'label' => 'Heading Font Color',
      'decorators' => array(array('ViewScript', array(
            'viewScript' => '_formColorElement.tpl',
            'class' => '',
            'name' => 'style_heading_color',
            'value' => isset($this->_formInitParams['style_heading_color']) ? $this->_formInitParams['style_heading_color'] : '#FFFFFF',
            'label' => 'Heading Font Color',
          ))),
    ));
    $this->addElement('Text', 'style_heading_font_size', array(
      'label' => 'Heading Font Size(in pixels)',
      'filters' => array(
        //new Engine_Filter_HtmlSpecialChars(),
        'StripTags',
        new Engine_Filter_Censor(),
      ),
      'value' => '',
    ));
    $this->addElement('Select', 'style_heading_font_family', array(
      'label' => 'Heading Font Family',
      'description' => ' Choose the font family for the Heading.',
      'allowEmpty' => true,
      'required' => false,
      'multiOptions' => $googleFontFamilies,
    ));
   
    $this->addElement('Dummy', 'slide_tagline', array(
			'label' => 'Slide Tagline',
		));
    $this->addElement('Text', 'tagline', array(
      'label' => 'Tagline Text',
      'description' => "You can provide a tagline to your slide.",
      'maxlength' => '256',
      'filters' => array(
        //new Engine_Filter_HtmlSpecialChars(),
        'StripTags',
        new Engine_Filter_Censor(),
        new Engine_Filter_StringLength(array('max' => '256')),
      ),
    ));
    $this->addElement('Select', 'params_tagline_typing', array(
      'label' => ' Tagline in typing style',
      'description' => "Do you want to display the tagline in typing style?",
      'multiOptions' => array(
        '1' => 'Yes',
        '0' => 'No',
      ),
      'value' => 0,
    ));

    $this->addElement('Text', 'style_tagline_color', array(
      'label' => 'Tagline Font Color',
      'decorators' => array(array('ViewScript', array(
            'viewScript' => '_formColorElement.tpl',
            'class' => '',
            'name' => 'style_tagline_color',
            'value' => isset($this->_formInitParams['style_tagline_color']) ? $this->_formInitParams['style_tagline_color'] : '#FFFFFF',
            'label' => 'Tagline Font Color',
          ))),
    ));
    $this->addElement('Text', 'style_tagline_font_size', array(
      'label' => 'Tagline Font Size(in pixels)',
      'filters' => array(
        //new Engine_Filter_HtmlSpecialChars(),
        'StripTags',
        new Engine_Filter_Censor(),
      ),
    ));
    $this->addElement('Select', 'style_tagline_font_family', array(
      'label' => 'Tagline Font Family',
      'description' => ' Choose the font family for the Tagline.',
      'allowEmpty' => true,
      'required' => false,
      'multiOptions' => $googleFontFamilies,
    ));
    $this->addElement('Dummy', 'slide_body', array(
			'label' => 'Slide Description',
		));
    $this->addElement('Textarea', 'body', array(
      'label' => 'Description Text',
      'description' => "You can provide a description to your slide.",
      'maxlength' => '1024',
      'filters' => array(
        //new Engine_Filter_HtmlSpecialChars(),
        'StripTags',
        new Engine_Filter_Censor(),
        new Engine_Filter_StringLength(array('max' => '1024')),
      ),
    ));
    $this->addElement('Text', 'style_body_color', array(
      'label' => 'Description Font Color',
      'decorators' => array(array('ViewScript', array(
            'viewScript' => '_formColorElement.tpl',
            'class' => '',
            'name' => 'style_body_color',
            'value' => isset($this->_formInitParams['style_body_color']) ? $this->_formInitParams['style_body_color'] : '#FFFFFF',
            'label' => 'Description Font Color',
          ))),
    ));
    $this->addElement('Text', 'style_body_font_size', array(
      'label' => 'Description Font Size(in pixels)',
      'filters' => array(
        //new Engine_Filter_HtmlSpecialChars(),
        'StripTags',
        new Engine_Filter_Censor(),
      ),
    ));
    $this->addElement('Select', 'style_body_font_family', array(
      'label' => 'Description Font Family',
      'description' => ' Choose the font family for the Description.',
      'allowEmpty' => true,
      'required' => false,
      'multiOptions' => $googleFontFamilies,
    ));
    $this->addElement('Dummy', 'slide_photo', array(
			'label' => 'Slide Front Image',
		));

    $this->addElement('file', 'photo', array(
      'label' => 'Front Image',
      'accept' => 'image/*',
    ));
    $this->photo->addValidator('Extension', false, 'jpg,png,gif,jpeg')->setTransferAdapter('Http');
    $this->addElement('Select', 'params_photo_position', array(
      'label' => 'Front Image Position',
      'description' => "Select the position of the front image.",
      'multiOptions' => array(
        'top' => 'Top Center (Before Heading)',
        'center' => 'Center (Before CTA buttons)',
        'left' => 'Left',
        'right' => 'Right',
      ),
    ));

    $this->addElement('Select', 'params_photo_frame', array(
      'label' => 'Front Image Frame',
      'description' => "Select the frame for the front image?",
      'multiOptions' => array(
        '' => 'None',
        '_frame_desktop _frame_l_desktop' => 'Light Desktop',
        '_frame_lp _frame_l_lp' => 'Light Laptop',
        '_frame_ipad _frame_l_ipad' => 'Light Ipad',
        '_frame_mob _frame_l_mob' => 'Light Mobile',
        '_frame_desktop _frame_d_desktop' => 'Dark Desktop',
        '_frame_lp _frame_d_lp' => 'Dark Laptop',
        '_frame_ipad _frame_d_ipad' => 'Dark Ipad',
        '_frame_mob _frame_d_mob' => 'Dark Mobile',
      ),
      'value' => '',
    ));
    $this->addElement('Text', 'style_photo_width', array(
      'label' => 'Front Image Max Width',
      'description' => '[example: if you want to add "100px" then enter “100” only]',
      'filters' => array(
        new Engine_Filter_HtmlSpecialChars(),
        'StripTags',
      ),
    ));
    $this->addElement('Text', 'style_photo_height', array(
      'label' => 'Front Image Max Height',
      'description' => '[example: if you want to add "100px" then enter “100” only]',
      'filters' => array(
        new Engine_Filter_HtmlSpecialChars(),
        'StripTags',
      ),
    ));
    $this->addElement('Text', 'style_photo_rotate', array(
      'label' => 'Front Image Rotate',
      'description' => 'By how many degrees the image should be rotated [example: if you want to rotate by "60 deg" then enter only 60.]',
      'maxlength' => '100',
      'filters' => array(
        new Engine_Filter_HtmlSpecialChars(),
        'StripTags',
      ),
      'value' => 0,
    ));
    $this->addElement('Select', 'params_photo_floating', array(
      'label' => 'Front Image Floating',
      'description' => 'Do you want the front image to keep floating? (Note: If you choose horizontal floating, then recommended value for image’s aspect ratio is 1:n. Similarly, in case of vertical floating, recommended value for image’s aspect ratio is n:1 [n is a positive integer, the value of "n" should be kept atleast "2" for showing floating effect]',
      'multiOptions' => array(
        '2' => 'Yes, float horizontally.',
        '1' => 'Yes, float vertically.',
        '0' => 'No',
      ),
      'value' => 0,
    ));

    $this->addElement('Select', 'params_content_alignment', array(
      'label' => 'Text and Buttons Alignment',
      'description' => "Select the alignment for text and button?",
      'multiOptions' => array(
        'left' => 'Left Alignment',
        'center' => 'Center Alignment',
        'right' => 'Right Alignment',
      ),
      'value' => 'center',
    ));

    $this->addElement('Text', 'style_overlay_color', array(
      'label' => 'Slide Overlay Color',
      'description' => "Choose the color for showing slide overlay effect.",
      'decorators' => array(array('ViewScript', array(
            'viewScript' => '_formColorElement.tpl',
            'class' => '',
            'name' => 'style_overlay_color',
            'value' => isset($this->_formInitParams['style_overlay_color']) ? $this->_formInitParams['style_overlay_color'] : '',
            'label' => 'Slide Overlay Color',
          ))),
    ));
    $this->addElement('Text', 'style_overlay_opacity', array(
      'label' => 'Opacity of Overlay',
      'description' => 'Please enter a value between 0 to 1, e.g. “0.10”.',
      'filters' => array(
        //new Engine_Filter_HtmlSpecialChars(),
        'StripTags',
        new Engine_Filter_Censor(),
      ),
    ));
    $this->addCTAButtons();

    //PREPARE LEVELS
    $levels = Engine_Api::_()->getDbtable('levels', 'authorization')->fetchAll();
    $levelKey = array();
    foreach( $levels as $level ) {
      $levels_prepared[$level->getIdentity()] = $level->getTitle();
      $levelKey[] = $level->getIdentity();
    }
    reset($levels_prepared);

    $this->addElement('MultiCheckbox', 'params_show_level', array(
      'label' => 'Member Levels',
      'description' => 'Select the member levels to which this slide should be visible. To show the slide to all the member levels, leave the options unselected.',
      'multiOptions' => $levels_prepared,
    ));

    //PREPARE NETWORKS
    $networks = Engine_Api::_()->getDbtable('networks', 'network')->fetchAll();
    $networkKey = array();
    if( count($networks) > 0 ) {
      foreach( $networks as $network ) {
        $networks_prepared[$network->getIdentity()] = $network->getTitle();
        $networkKey[] = $network->getIdentity();
      }
      reset($networks_prepared);

      $this->addElement('MultiCheckbox', 'params_show_networks', array(
        'label' => 'Networks',
        'description' => 'Select the networks to which this slide should be visible. To show the slide to all the networks, leave the options unselected.',
        'multiOptions' => $networks_prepared,
      ));
    }

    // Element: style
    $this->addElement('Textarea', 'params_slide_custom_style', array(
      'label' => 'Custom Slide Styles',
      'description' => 'You can change the colors, fonts, and styles of your slide by adding CSS code below. The contents of the text area below will be output between <style> tags on your slide.',
    ));

    $this->addElement('Select', 'enabled', array(
      'label' => 'Enabled',
      'description' => "Do you want to enable this slide?",
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No',
      ),
    ));
    $this->addElement('Button', 'submit', array(
      'label' => 'Save Changes',
      'type' => 'submit',
      'ignore' => true,
    ));
  }

  public function addCTAButtons()
  {
    $this->addElement('Dummy', 'cta_buttons_heading', array(
      'label' => 'Call To Action (CTA) Buttons:',
      'description' => 'These buttons will redirect users to the linked URLs. Please fill the below details for displaying the CTA buttons on the slides.',
    ));

    for( $i = 1; $i < 4; $i++ ) {
      $name = 'cta_' . $i;
      $params = isset($this->_formInitParams[$name]) ? $this->_formInitParams[$name] : array();
      $subform = new Sitebanner_Form_Admin_Slideshow_SlideCTA(array('elementsBelongTo' => $name, 'number' => $i, 'params' => $params, 'fontIconsList' => $this->getFontIcons()));
      $this->addSubForm($subform, $name);
    }
  }

  private function getFontIcons()
  { 
    $lists = array();
    try {
      $icons_file = APPLICATION_PATH . "/externals/font-awesome/css/font-awesome.min.css";
      $parsed_file = file_get_contents($icons_file);
      preg_match_all("/fa\-([a-zA-z0-9\-]+[^\:\.\,\s\{\>])/", $parsed_file, $matches);
      $exclude_icons = array("fa-lg", "fa-2x", "fa-500px", "fa-3x", "fa-4x", "fa-5x", "fa-ul", "fa-li", "fa-fw", "fa-border", "fa-pulse", "fa-rotate-90", "fa-rotate-180", "fa-rotate-270", "fa-spin", "fa-flip-horizontal", "fa-flip-vertical", "fa-stack", "fa-stack-1x", "fa-stack-2x", "fa-inverse");
      $icons = $this->removeUselessFonts($matches[0], $exclude_icons);
      if( $icons ) {
        sort($icons);
        $lists[] = '';
        foreach( $icons as $icon ) {
          $lists[trim($icon)] = $icon;
        };
      }
    } catch( Exception $e ) {
      
    }
    return $lists;
  }

  private function removeUselessFonts($array, $element)
  {
    return (is_array($element)) ? array_values(array_diff($array, $element)) : array_values(array_diff($array, array($element)));
  }

}