<?php

/**
 * SocialEngine
 *
 * @category   Application_Core
 * @package    Core
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 * @author     Jung
 */

/**
 * @category   Application_Core
 * @package    Core
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 */
class Sitebanner_Form_Admin_Widget_Banners extends Core_Form_Admin_Widget_Standard {

	public function init() {
		parent::init();

		// Set form attributes
		$this
			->setTitle('Ultimate Banner Slideshow')
			->setDescription('Displays Slideshow.')
		;

		$menuMultiOption = array('' => '');
		$table = Engine_Api::_()->getDbTable('slideshows', 'sitebanner');

		$select = $table->select()->where("enabled = ?", 1)->query()
			->fetchAll();
		foreach ($select as $menu) {
			$menuMultiOption[$menu['slideshow_id']] = $menu['title'];
		}
		$this->addElement('Select', 'slideshow_id', array(
			'label' => 'Please select the slideshow to be shown.',
			'multiOptions' => $menuMultiOption,
			'escape' => false,
			'allowEmpty' => false,
			'required' => true,
		));
		$this->addElement('Select', 'display_order', array(
			'label' => 'Select order to display slides.',
			'multiOptions' => array(
				'admin_order' => 'In Admin Order',
				'random' => 'Randomly',
			),
			'escape' => false,
			'allowEmpty' => false,
			'required' => true,
		));
		$this->addElement('Text', 'slideDelay', array(
			'label' => 'Enter Transition Delay Time (in sec) for each slide.',
			'escape' => false,
			'allowEmpty' => false,
			'required' => true,
			'value' => 10,
		));
		$this->addElement('Select', 'navigations', array(
			'label' => 'Show Previous & Next Buttons in the slideshow?',
			'multiOptions' => array(
				'1' => 'Yes',
				'0' => 'No',
			),
			'value' => 1,
		));
		$this->addElement('Select', 'navigationsPost', array(
			'label' => 'Choose placement of Previous & Next buttons.',
			'multiOptions' => array(
				'middle' => 'Across the slides',
				'left_bottom' => 'Bottom right',
			),
			'value' => 'middle',
		));
		$this->addElement('Select', 'full_width', array(
			'label' => 'Show slideshow in full width of the screen?',
			'multiOptions' => array(
				'1' => 'Yes',
				'0' => 'No',
			),
			'value' => '0',
		));

		$this->addElement('Select', 'showHeader', array(
			'label' => 'Show header inside the banner?',
			'multiOptions' => array(
				'2' => 'Yes, show Website Header.',
				'1' => 'Yes, show Inbuild Header.',
				'0' => 'No',
			),
			'value' => '0',
		));
		$this->addElement('Text', 'bannerHeight', array(
			'label' => 'Slideshow Height(in pixels)',
			'escape' => false,
			'allowEmpty' => false,
			'required' => true,
			'value' => 400,
		));
		$this->addElement('Text', 'bannerHeightMobile', array(
			'label' => 'Slideshow Height For Small Devices(in pixels)',
			'escape' => false,
			'allowEmpty' => false,
			'required' => true,
			'value' => 400,
		));
		$this->addElement('Hidden', 'nomobile', array('order' => 808000));
		$this->addElement('Hidden', 'title', array('order' => 808070));
	}

}