<?php

/**
 * SocialEngine
 *
 * @category   Application_Core
 * @package    Core
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 * @version    $Id: MenuItems.php 9747 2012-07-26 02:08:08Z john $
 * @author     John
 */

/**
 * @category   Application_Core
 * @package    Core
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 */
class Sitebanner_Model_DbTable_Slideshows extends Engine_Db_Table
{

  protected $_name = 'sitebanner_slideshow';
  protected $_serializedColumns = array('params');
  protected $_rowClass = "Sitebanner_Model_Slideshow";

  /**
   * Get paginator for slideshows
   *
   * @param array
   * @return Zend_Paginator
   */
  public function getSlideshowsPaginator($params = array())
  {
    $paginator = Zend_Paginator::factory($this->getSlideshowsSelect());
    if( !empty($params['page']) ) {
      $paginator->setCurrentPageNumber($params['page']);
    }
    if( !empty($params['limit']) ) {
      $paginator->setItemCountPerPage($params['limit']);
    }
    return $paginator;
  }

  /**
   * Gets a select object for the slideshows entries
   *
   * @return Zend_Db_Table_Select
   */
  public function getSlideshowsSelect()
  {
    $select = $this->select();
    return $select;
  }

  public function getSlideshow($id)
  {
    $select = $this->getSlideshowsSelect()->where('slideshow_id = ?', $id);
    return $this->fetchRow($select);
  }

}