<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Classified
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 * @version    $Id: Classified.php 9747 2012-07-26 02:08:08Z john $
 * @author     Jung
 */

/**
 * @category   Application_Extensions
 * @package    Classified
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 */
class Sitebanner_Model_Slideshow extends Core_Model_Item_Abstract
{

  // Properties
  protected $_parent_type = null;
  protected $_searchTriggers = array();
  protected $_parent_is_owner = false;

  /**
   * Disable internal hooks?
   * @var boolean
   */
  protected $_disableHooks = true;

  public function count()
  {
    $slideTable = Engine_Api::_()->getDbtable('slides', 'sitebanner');
    return $slideTable->select()
        ->from($slideTable, new Zend_Db_Expr('COUNT(slide_id)'))
        ->where('slideshow_id = ?', $this->slideshow_id)
        ->limit(1)
        ->query()
        ->fetchColumn();
  }

  public function getSlides($params = array())
  {
    $slideTable = Engine_Api::_()->getDbtable('slides', 'sitebanner');
    $select = $slideTable->select()
      ->where('slideshow_id = ?', $this->slideshow_id);
    if( !empty($params['order']) ) {
      $select->order($params['order']);
    } else {
      $select->order('order ASC');
    }

    if( !empty($params['limit']) ) {
      $select->limit($params['limit']);
    }
    $select->where('enabled = ?', 1);
    return $slideTable->fetchAll($select);
  }

  public function getAllSlides()
  {
    $slideTable = Engine_Api::_()->getDbtable('slides', 'sitebanner');
    $select = $slideTable->select()
      ->where('slideshow_id = ?', $this->slideshow_id)
      ->order('order ASC');
    return $slideTable->fetchAll($select);
  }

  protected function _postDelete()
  {
    $slideTable = Engine_Api::_()->getDbtable('slides', 'sitebanner');
    $slideSelect = $slideTable->select()
      ->where('slideshow_id = ?', $this->getIdentity())
    ;
    foreach( $slideTable->fetchAll($slideSelect) as $slide ) {
      try {
        $slide->delete();
      } catch( Exception $e ) {
        // Silence
      }
    }

    parent::_postDelete();
  }

}