<?php

class Sitebanner_Widget_BannersController extends Engine_Content_Widget_Abstract
{

  public function indexAction()
  {
    $this->view->slideshow_id = $slideshowId = $this->_getParam('slideshow_id', 1);
    $slideshow = Engine_Api::_()->getDbtable('slideshows', 'sitebanner')->getSlideshow($slideshowId);

    if( !$slideshow || !$slideshow->enabled ) {
      return $this->setNoRender();
    }

    $this->view->params = $params = array_merge(array(
      'full_width' => 0,
      'showHeader' => 0,
      'navigations' => 1,
      'navigationsPost' => 'middle',
      'slideDelay' => 10,
      'bannerHeight' => '400',
      'bannerHeightMobile' => '400',
      ), $this->_getAllParams());
    $this->view->content_id = $this->_getParam('content_id', $this->view->identity);
    $this->view->slideshow = $slideshow;
    $slidesParams = array(
      'order' => $params['display_order'] == 'admin_order' ? 'order ASC' : 'RAND()',
    );
    $this->view->slides = $slides = $this->fillterSlides($slideshow->getSlides($slidesParams));
    if( count($slides) == 0 ) {
      return $this->setNoRender();
    }

    //Google Font Work
    $fontFamilies = array();
    foreach( $slides as $slide ) {
      if( !empty($slide->params['style_heading_font_family']) ) {
        $fontFamilies[] = str_replace('"', '', $slide->params['style_heading_font_family']);
      }
      if( !empty($slide->params['style_tagline_font_family']) ) {
        $fontFamilies[] = str_replace('"', '', $slide->params['style_tagline_font_family']);
      }
      if( !empty($slide->params['style_body_font_family']) ) {
        $fontFamilies[] = str_replace('"', '', $slide->params['style_body_font_family']);
      }
    }
    if( !empty($fontFamilies) ) {
      $this->view->headLink()->appendStylesheet('https://fonts.googleapis.com/css?family=' . join('|', array_unique($fontFamilies)));
    }
  }

  public function getCacheKey()
  {
    //return true;
  }

  private function fillterSlides($slides)
  {
    $newSlides = array();
    $viewer = Engine_Api::_()->user()->getViewer();
    $levelId = $viewer && $viewer->getIdentity() ? $viewer->level_id : Engine_Api::_()->getDbtable('levels', 'authorization')->getPublicLevel()->getIdentity();
    $networkIds = array();
    if( $viewer && $viewer->getIdentity() ) {
      $networkTable = Engine_Api::_()->getDbtable('membership', 'network');
      $networkIds = $networkTable->getMembershipsOfIds($viewer);
    }

    foreach( $slides as $slide ) {
      if( !empty($slide->params['params_show_level']) && !in_array($levelId, $slide->params['params_show_level']) ) {
        continue;
      }

      if( !empty($slide->params['params_show_networks']) && empty(array_intersect($networkIds, $slide->params['params_show_networks'])) ) {
        continue;
      }
      $newSlides[] = $slide;
    }
    return $newSlides;
  }

}