<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Adsettings.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class sitebusiness_Form_Admin_Adsettings extends Engine_Form {

  public function init() {

    $enable_ads = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('communityad');
    if (!$enable_ads) {
      $this->addElement('Dummy', 'note', array(
          'description' => '<div class="tip"><span>' . sprintf(Zend_Registry::get('Zend_Translate')->_('This plugin provides deep integration for advertising using the "%1$sAdvertisements / Community Ads Plugin%2$s". Please install and enable this plugin to configure settings for the various ad positions and widgets available. If you do not have this plugin yet, click here to view its details and purchase it: %1$shttp://www.socialengineaddons.com/socialengine-advertisements-community-ads-plugin%2$s.'), '<a href="http://www.socialengineaddons.com/socialengine-advertisements-community-ads-plugin" target="_blank">', '</a>') . '</span></div>',
          'decorators' => array(
              'ViewHelper', array(
                  'description', array('placement' => 'APPEND', 'escape' => false)
          ))
      ));
    }

    $enable_ads = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('communityad');
    if ($enable_ads) {
      $this
              ->setTitle('Ad Settings')
              ->setDescription('This plugin provides seamless integration with the "Advertisements / Community Ads Plugin". Attractive advertising can be done using the many available, well designed ad positions in this plugin. Below, you can configure the settings for the various ad positions and widgets.');
      $this->addElement('Radio', 'sitebusiness_adpreview', array(
          'label' => 'Sample Ad Widget',
           'description' => sprintf(Zend_Registry::get('Zend_Translate')->_('Do you want to show a Sample Ad of a Business on its profile in the Info widget? (This widget will only be visible to business admins and will tempt them to create an Ad for their Business. Click %s to preview this widget.)'), '<a href="javascript:void(0);" onclick="parent.Smoothbox.open(\'application/modules/Sitebusiness/externals/images/ad_preview.png\');"></a>'),
          'multiOptions' => array(
              1 => 'Yes',
              0 => 'No'
          ),
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adpreview', 1),
      ));
      $this->sitebusiness_adpreview->addDecorator('Description', array('placement' => Zend_Form_Decorator_Abstract::PREPEND, 'escape' => false));

      $this->addElement('Radio', 'sitebusiness_adcreatelink', array(
          'label' => 'Advertise your Business Widget',
          'description' => sprintf(Zend_Registry::get('Zend_Translate')->_('Do you want to show the Advertise your Business widget on Business Profile in the Info widget? (This widget will only be visible to business admins and it displays a catchy phrase to tempt them to create an Ad for their Business. It also has a link to Create an Ad. Click %s to preview this widget.)'), '<a href="javascript:void(0);" onclick="parent.Smoothbox.open(\'application/modules/Sitebusiness/externals/images/ad_content.png\');">here</a>'),
          'multiOptions' => array(
              1 => 'Yes',
              0 => 'No'
          ),
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adcreatelink', 1),
      ));
      $this->sitebusiness_adcreatelink->addDecorator('Description', array('placement' => Zend_Form_Decorator_Abstract::PREPEND, 'escape' => false));

      $this->addElement('Radio', 'sitebusiness_communityads', array(
          'label' => 'Community Ads in this plugin',
          'description' => 'Do you want to show community ads in the various positions available in this plugin? (Below, you will be able to choose for every individual position. If you do not want to show ads in a particular position, then please enter the value "0" for it below.). If you have enabled Packages for Businesses from Global Settings, then for each package, you can configure if community ads display should be enabled on their Businesses (You can use this to give extra privileges to Businesses of special / paid packages by making them free of ads display.).',
          'multiOptions' => array(
              1 => 'Yes',
              0 => 'No'
          ),
          'onclick' => 'showads(this.value)',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.communityads', 1),
      ));

//       if ((Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessalbum') || Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessnote')) && Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('communityad')) {
//         $lightbox_photos = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessalbum.photolightbox.show', 1);
//         if (!empty($lightbox_photos)) {
//           $this->addElement('Radio', 'sitebusiness_lightboxads', array(
//               'label' => 'Ads in Photos Lightbox',
//               'description' => 'Do you want to show ads in ajax lightbox for viewing photos of albums of businesses?',
//               'multiOptions' => array(
//                   1 => 'Yes',
//                   0 => 'No'
//               ),
//               'onclick' => 'showlightboxads(this.value)',
//               'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.lightboxads', 1),
//           ));
// 
//           $this->addElement('Radio', 'sitebusiness_adtype', array(
//               'label' => 'Type of Ads in Photos Lightbox',
//               'description' => 'Select the type of ads you want to show in the ajax lightbox for viewing photos of albums of businesses.',
//               'multiOptions' => array(
//                   3 => 'All',
//                   2 => 'Sponsored Ads',
//                   1 => 'Featured Ads',
//                   0 => 'Both Sponsored and Featured Ads'
//               ),
//               'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adtype', 3),
//           ));
//         }
//       }

      $this->addElement('Text', 'sitebusiness_admylikes', array(
          'label' => 'Businesses I Like Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown in business i like business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.admylikes', 3),
      ));
    }

    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessnote') && Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('communityad')) {
      $this->addElement('Text', 'sitebusiness_adnotewidget', array(
          'label' => 'Business Profile Notes Widget',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown in business profile notes widget?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adnotewidget', 3),
      ));

      $this->addElement('Text', 'sitebusiness_adnoteview', array(
          'label' => 'Business Notes View Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business note\'s view business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adnoteview', 3),
      ));

      $this->addElement('Text', 'sitebusiness_adnotebrowse', array(
          'label' => 'Business Notes Browse Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business note\'s browse business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adnotebrowse', 3),
      ));

      $this->addElement('Text', 'sitebusiness_adnotecreate', array(
          'label' => 'Business Note\'s Create Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business note\'s create business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adnotecreate', 3),
      ));

      $this->addElement('Text', 'sitebusiness_adnoteedit', array(
          'label' => 'Business Note\'s Edit Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business note\'s edit business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adnoteedit', 3),
      ));

      $this->addElement('Text', 'sitebusiness_adnotedelete', array(
          'label' => 'Business Note\'s Delete Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business note\'s delete business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adnotedelete', 1),
      ));


      $this->addElement('Text', 'sitebusiness_adnoteaddphoto', array(
          'label' => 'Business Note\'s Add Photos Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business note\'s add photos business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adnoteaddphoto', 1),
      ));

      $this->addElement('Text', 'sitebusiness_adnoteeditphoto', array(
          'label' => 'Business Note\'s Edit Photo Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business note\'s edit photo business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adnoteeditphoto', 5),
      ));

      $this->addElement('Text', 'sitebusiness_adnotesuccess', array(
          'label' => 'Business Note\'s Creation Success Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business note\'s creation success business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adnotesuccess', 1),
      ));
    }

    if ((Engine_Api::_()->hasModuleBootstrap('siteevent') && Engine_Api::_()->getDbtable('modules', 'siteevent')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'sitebusiness_business', 'item_module' => 'sitebusiness'))) && Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('communityad')) {
      $this->addElement('Text', 'sitebusiness_adeventwidget', array(
          'label' => 'Business Profile Events Widget',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown in business profile events widget?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adeventwidget', 3),
      ));

      $this->addElement('Text', 'sitebusiness_adeventview', array(
          'label' => 'Business Event\'s View Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business event\'s view business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adeventview', 2),
      ));

      $this->addElement('Text', 'sitebusiness_adeventbrowse', array(
          'label' => 'Business Event\'s Browse Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business event\'s browse business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adeventbrowse', 2),
      ));

      $this->addElement('Text', 'sitebusiness_adeventcreate', array(
          'label' => 'Business Event\'s Create Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business event\'s create business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adeventcreate', 2),
      ));

      $this->addElement('Text', 'sitebusiness_adeventedit', array(
          'label' => 'Business Event\'s Edit Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business event\'s edit business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adeventedit', 2),
      ));

      $this->addElement('Text', 'sitebusiness_adeventdelete', array(
          'label' => 'Business Event\'s Delete Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business event\'s delete business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adeventdelete', 1),
      ));
        $this->addElement('Text', 'sitebusiness_adeventaddphoto', array(
          'label' => 'Business Event\'s Add Photos Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business event\'s add photos business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adeventaddphoto', 1),
      ));

      $this->addElement('Text', 'sitebusiness_adeventeditphoto', array(
          'label' => 'Business Event\'s Edit Photo Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business event\'s edit photo business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adeventeditphoto', 5),
      ));
    }

    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessalbum') && Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('communityad')) {
      $this->addElement('Text', 'sitebusiness_adalbumwidget', array(
          'label' => 'Business Profile Albums Widget',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown in business profile albums widget?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adalbumwidget', 3),
      ));

      $this->addElement('Text', 'sitebusiness_adalbumview', array(
          'label' => 'Business Album\'s Browse Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business album\'s browse business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adalbumview', 3),
      ));

      $this->addElement('Text', 'sitebusiness_adalbumbrowse', array(
          'label' => 'Business Album\'s View Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business album\'s view business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adalbumbrowse', 3),
      )); 

      $this->addElement('Text', 'sitebusiness_adalbumcreate', array(
          'label' => 'Business Album\'s Create Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business album\'s create business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adalbumcreate', 2),
      ));

      $this->addElement('Text', 'sitebusiness_adalbumeditphoto', array(
          'label' => 'Business Album\'s Edit Photos Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business album\'s edit photos business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adalbumeditphoto', 3),
      ));
    }

    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessdiscussion') && Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('communityad')) {
      $this->addElement('Text', 'sitebusiness_addicussionwidget', array(
          'label' => 'Business Profile Discussions Widget',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown in business profile discussions widget?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.addicussionwidget', 3),
      ));

      $this->addElement('Text', 'sitebusiness_addiscussionview', array(
          'label' => 'Business Discussion\'s View Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business dicussion\'s view business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.addiscussionview', 2),
      ));

      $this->addElement('Text', 'sitebusiness_addiscussioncreate', array(
          'label' => 'Business Discussion\'s Create Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business dicussion\'s create business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.addiscussioncreate', 2),
      ));

      $this->addElement('Text', 'sitebusiness_addiscussionreply', array(
          'label' => 'Business Discussion\'s Post Reply Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a dicussion\'s post reply business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.addiscussionreply', 2),
      ));
    }

    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessdocument') && Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('communityad')) {
      $this->addElement('Text', 'sitebusiness_addocumentwidget', array(
          'label' => 'Business Profile Documents Widget',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown in business profile documents widget?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.addocumentwidget', 3),
      ));

      $this->addElement('Text', 'sitebusiness_addocumentview', array(
          'label' => 'Business Document\'s View Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a Business document\'s view business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.addocumentview', 2),
      ));

      $this->addElement('Text', 'sitebusiness_addocumentbrowse', array(
          'label' => 'Business Document\'s Browse Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a Business document\'s browse business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.addocumentbrowse', 2),
      ));

      $this->addElement('Text', 'sitebusiness_addocumentcreate', array(
          'label' => 'Business Document\'s Create Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a Business document\'s create business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.addocumentcreate', 4),
      ));

      $this->addElement('Text', 'sitebusiness_addocumentedit', array(
          'label' => 'Business Document\'s Edit Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a Business document\'s edit business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.addocumentedit', 4),
      ));

      $this->addElement('Text', 'sitebusiness_addocumentdelete', array(
          'label' => 'Business Document\'s Delete Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a Business document\'s delete business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.addocumentdelete', 1),
      ));
    }

    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessvideo') && Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('communityad')) {
      $this->addElement('Text', 'sitebusiness_advideowidget', array(
          'label' => 'Business Profile Videos Widget',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown in business profile videos widget?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.advideowidget', 3),
      ));

      $this->addElement('Text', 'sitebusiness_advideoview', array(
          'label' => 'Business Video\'s View Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business video\'s view business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.advideoview', 2),
      ));

      $this->addElement('Text', 'sitebusiness_advideobrowse', array(
          'label' => 'Business Video\'s Browse Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business video\'s browse business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.advideobrowse', 2),
      ));

      $this->addElement('Text', 'sitebusiness_advideocreate', array(
          'label' => 'Business Video\'s Create Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business video\'s create business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.advideocreate', 2),
      ));

      $this->addElement('Text', 'sitebusiness_advideoedit', array(
          'label' => 'Business Video\'s Edit Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business video\'s edit business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.advideoedit', 2),
      ));

      $this->addElement('Text', 'sitebusiness_advideodelete', array(
          'label' => 'Business Video\'s Delete Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business video\'s delete business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.advideodelete', 1),
      ));
    }

    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinesspoll') && Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('communityad')) {
      $this->addElement('Text', 'sitebusiness_adpollwidget', array(
          'label' => 'Business Profile Polls Widget',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown in business profile polls widget?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adpollwidget', 3),
      ));

      $this->addElement('Text', 'sitebusiness_adpollview', array(
          'label' => 'Business Poll\'s View Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business poll\'s view business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adpollview', 2),
      ));

      $this->addElement('Text', 'sitebusiness_adpollbrowse', array(
          'label' => 'Business Poll\'s Browse Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business poll\'s browse business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adpollbrowse', 2),
      ));

      $this->addElement('Text', 'sitebusiness_adpollcreate', array(
          'label' => 'Business Poll\'s Create Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business poll\'s create business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adpollcreate', 2),
      ));

      $this->addElement('Text', 'sitebusiness_adpolldelete', array(
          'label' => 'Business Poll\'s Delete Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business poll\'s delete business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adpolldelete', 1),
      ));
    }

    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember') && Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('communityad')) {
      $this->addElement('Text', 'sitebusiness_admemberwidget', array(
          'label' => 'Business Profile Members Widget',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown in business profile members widget?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.admemberwidget', 3),
      ));
      $this->addElement('Text', 'sitebusiness_admemberbrowse', array(
          'label' => 'Business Members Browse Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business member\'s browse business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.admemberbrowse', 3),
      ));
    }

    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessreview') && Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('communityad')) {
      $this->addElement('Text', 'sitebusiness_adreviewwidget', array(
          'label' => 'Business Profile Reviews Widget',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown in business profile reviews widget?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adreviewwidget', 3),
      ));

      $this->addElement('Text', 'sitebusiness_adreviewcreate', array(
          'label' => 'Business Review\'s Create Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business review\'s create business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adreviewcreate', 2),
      ));

      $this->addElement('Text', 'sitebusiness_adreviewedit', array(
          'label' => 'Business Review\'s Edit Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business review\'s edit business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adreviewedit', 2),
      ));

      $this->addElement('Text', 'sitebusiness_adreviewdelete', array(
          'label' => 'Business Review\'s Delete Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business review\'s delete business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adreviewdelete', 1),
      ));

      $this->addElement('Text', 'sitebusiness_adreviewview', array(
          'label' => 'Business Reviews Browse Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business review\'s browse business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adreviewview', 2),
      ));

      $this->addElement('Text', 'sitebusiness_adreviewbrowse', array(
          'label' => 'Business Reviews View Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business review\'s view business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adreviewbrowse', 2),
      ));  

    }

    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessoffer') && Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('communityad')) {
      $this->addElement('Text', 'sitebusiness_adofferwidget', array(
          'label' => 'Business Profile Offers Widget',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown in business profile offers widget?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adofferwidget', 3),
      ));

      $this->addElement('Text', 'sitebusiness_adofferbusiness', array(
          'label' => 'Business Offers Browse Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on business offers browse business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adofferbusiness', 2),
      ));

      $this->addElement('Text', 'sitebusiness_adofferlist', array(
          'label' => 'Business Offers List Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on business offers list business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adofferlist', 2),
      ));
    }

    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessform') && Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('communityad')) {
      $this->addElement('Text', 'sitebusiness_adformwidget', array(
          'label' => 'Business Profile Form Widget',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown in business profile form widget?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adformwidget', 3),
      ));

      $this->addElement('Text', 'sitebusiness_adformcreate', array(
          'label' => 'Form Add Question Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on form\'s add question business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adformcreate', 3),
      ));
    }

    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessinvite') && Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('communityad')) {
      $this->addElement('Text', 'sitebusiness_adinvite', array(
          'label' => 'Invite Friends Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on invite friends business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adinvite', 1),
      ));
    }

    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessbadge') && Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('communityad')) {
      $this->addElement('Text', 'sitebusiness_adbadgeview', array(
          'label' => 'Badges View Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a badge\'s view business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adbadgeview', 2),
      ));
    }

    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('communityad')) {
      $this->addElement('Text', 'sitebusiness_adlocationwidget', array(
          'label' => 'Business Profile Map Widget',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown in business profile map widget?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adlocationwidget', 3),
      ));

      $this->addElement('Text', 'sitebusiness_adoverviewwidget', array(
          'label' => 'Business Profile Overview Widget',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown in business profile overview widget?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adoverviewwidget', 0),
      ));

      $this->addElement('Text', 'sitebusiness_adinfowidget', array(
          'label' => 'Business Profile Info Widget',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown in business profile info widget?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adinfowidget', 3),
      ));

      $this->addElement('Text', 'sitebusiness_adclaimview', array(
          'label' => 'Claim Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on claim business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adclaimview', 2),
      ));

      $this->addElement('Text', 'sitebusiness_adtagview', array(
          'label' => 'Browse Tags Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on browse tags business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adtagview', 1),
      ));
    }

    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmusic') && Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('communityad')) {
      $this->addElement('Text', 'sitebusiness_admusicwidget', array(
          'label' => 'Business Profile Music Widget',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown in business profile music widget?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.admusicwidget', 3),
      ));

      $this->addElement('Text', 'sitebusiness_admusicview', array(
          'label' => 'Business Music View Page',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business music view business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.admusicview', 3),
      ));

      $this->addElement('Text', 'sitebusiness_admusicbrowse', array(
          'label' => 'Business Music Browse Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business music browse business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.admusicbrowse', 3),
      ));

      $this->addElement('Text', 'sitebusiness_admusiccreate', array(
          'label' => 'Business Music Create Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business music create business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.admusiccreate', 3),
      ));

      $this->addElement('Text', 'sitebusiness_admusicedit', array(
          'label' => 'Business Music Edit Business',
          'maxlenght' => 3,
          'description' => 'How many ads will be shown on a business music edit business?',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.admusicedit', 3),
      ));
    }

	  //START FOR INRAGRATION WORK WITH OTHER PLUGIN.
    $sitebusinessintegrationModEnabled = Engine_Api::_()->getDbtable('modules',
     'core')->isModuleEnabled('sitebusinessintegration');
    if(!empty($sitebusinessintegrationModEnabled)&& Engine_Api::_()->getDbtable('modules',
      'core')->isModuleEnabled('communityad')) {
			$mixSettingsResults = Engine_Api::_()->getDbtable( 'mixsettings' , 'sitebusinessintegration'
	    )->getIntegrationItems();
			foreach($mixSettingsResults as $modNameValue) {

// 				if(strstr($modNameValue['resource_type'], 'sitereview_listing')) {
// 					$item_title = 'Products';
// 				} else {
// 					$item_title = $modNameValue["item_title"];
// 				}
        $item_title = $modNameValue["item_title"];
				$this->addElement('Text', "sitebusiness_ad_" . $modNameValue['resource_type']. '_' .$modNameValue['listingtype_id'], array(
					'label' => "Business Profile " . $item_title . " Widget",
					'maxlenght' => 3,
					'description' => "How many ads will be shown in business profile " .  $item_title . "   widget?",
					'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting("sitebusiness.ad." . $modNameValue['resource_type'].".".$modNameValue['listingtype_id'] , 3),
				));
			}
	  }
    //END FOR INRAGRATION WORK WITH OTHER PLUGIN.
	  
	  //START AD WORK FOR TWITTER
    $sitebusinesstwitterModEnabled = Engine_Api::_()->getDbtable('modules',
     'core')->isModuleEnabled('sitebusinesstwitter');
		if(!empty($sitebusinesstwitterModEnabled)&& Engine_Api::_()->getDbtable('modules',
				'core')->isModuleEnabled('communityad')) {
			$this->addElement('Text', 'sitebusiness_adtwitterwidget', array(
					'label' => 'Business Profile Twitter Widget',
					'maxlenght' => 3,
					'description' => 'How many ads will be shown in business profile twitter widget?',
					'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adtwitterwidget', 3),
			));
		}
		//END AD WORK FOR TWITTER

    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('communityad')) {
      $this->addElement('Button', 'submit', array(
          'label' => 'Save Changes',
          'type' => 'submit',
          'ignore' => true
      ));
    }
  }

}

?>