<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Takeaction.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusiness_Form_Admin_Takeaction extends Engine_Form {

  public function init() {

    $business_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('business_id', null);
    $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
    $url = $view->url(array('business_url' => Engine_Api::_()->sitebusiness()->getBusinessUrl($business_id)), 'sitebusiness_entry_view', true);
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    $sitebusiness_title = "<a href='$url' target='_blank'>$sitebusiness->title</a>";

    $this->setMethod('post');
    $this->setTitle("Take an Action")
            ->setDescription("Please take an appropriate action for this business:" . $sitebusiness_title);

    $this->addElement('Button', 'submit', array(
        'label' => 'Save',
        'type' => 'submit',
        'ignore' => true,
        'decorators' => array('ViewHelper')
    ));

    $this->addDisplayGroup(array('submit', 'cancel'), 'buttons');
    $button_group = $this->getDisplayGroup('buttons');
  }

}

?>