<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Widget.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class sitebusiness_Form_Admin_Widget extends Engine_Form {

  public function init() {
    $this
            ->setTitle('General Settings')
            ->setDescription('Configure the general settings for various widgets available with this plugin.');

    // VALUE FOR FEATURE business IN SLIDESHOW
    $this->addElement('Text', 'sitebusiness_feature_widgets', array(
        'label' => 'Featured Businesses Slideshow
 Widget',
        'maxlength' => '3',
        'description' => 'How many directory items / businesses will be shown in the featured businesses slideshow widget? Note that out of all the featured businesses, these many businesses will be picked up randomly to be shown in the slideshow (value can not be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.feature.widgets', 10),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    // VALUE FOR SPONSORED business IN Carousel
    $this->addElement('Text', 'sitebusiness_sponserdsitebusiness_widgets', array(
        'label' => 'Sponsored Businesses Carousel Widget',
        'maxlength' => '3',
        'description' => 'How many directory items / businesses will be shown in one view of the sponsored businesses carousel widget? Note that this carousel is AJAX based and users will be able to browse through all the sponsored businesses (value can not be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.sponserdsitebusiness.widgets', 4),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));
    // VALUE FOR Sponsored Interval
    $this->addElement('Text', 'sitebusiness_sponsored_interval', array(
        'label' => 'Sponsored Carousel Speed',
        'allowEmpty' => false,
        'required' => true,
        'maxlength' => '3',
        'description' => 'What maximum Carousel Speed should be applied to the sponsored widget?',
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.sponsored.interval', 300),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    // VALUE FOR TRUNCATION
    $this->addElement('Text', 'sitebusiness_title_truncationsponsored', array(
        'label' => 'Title Truncation Limit For Sponsored Items Widget',
        'allowEmpty' => false,
        'maxlength' => '3',
        'required' => true,
        'description' => 'What maximum limit should be applied to the number of characters in the titles of items in the Sponsored widgets? (Enter a number between 1 and 999. Titles having more characters than this limit will be truncated. Complete titles will be shown on mouseover.)',
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.title.truncationsponsored', 18),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    // VALUE FOR MOSTCOMMENT
    $this->addElement('Text', 'sitebusiness_comment_widgets', array(
        'label' => 'Most Commented Businesses Widget',
        'maxlength' => '3',
        'description' => 'How many directory items / businesses will be shown in the most commented businesses widget (value can not be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.comment.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    // VALUE FOR MOSTLIKE
    $this->addElement('Text', 'sitebusiness_likes_widgets', array(
        'label' => 'Most Liked Businesses Widget',
        'maxlength' => '3',
        'description' => 'How many directory items / businesses will be shown in the most liked businesses widget (value can not be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.likes.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    // VALUE FOR USER business BUSINESS
    $this->addElement('Text', 'sitebusiness_usersitebusiness_widgets', array(
        'label' => 'Business Profile Owner Businesses Widget',
        'maxlength' => '3',
        'description' => 'How many directory items / businesses will be shown in the business profile owner businesses widget (value can not be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.usersitebusiness.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    // VALUE FOR AJAX LAYOUT
    $this->addElement('MultiCheckbox', 'sitebusiness_ajax_widgets_layout', array(
        'description' => 'Choose the view types that you want to be available for businesses on the businesses home and browse businesses.',
        'label' => 'Views on Businesses Home and Browse Businesses',
        'multiOptions' => array("1" => "List View", "2" => "Grid View", "3" => "Map View"),
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.ajax.widgets.layout', array("0" => "1", "1" => "2", "2" => "3")),
    ));

    // VALUE FOR AJAX LAYOUT ORDER
    $this->addElement('Radio', 'sitebusiness_ajax_layouts_oder', array(
        'description' => 'Select a default view type for Directory Items / Businesses on the Businesses Home Widget and Browse Businesses.',
        'label' => 'Default View on Businesses Home Widget and Browse Businesses',
        'multiOptions' => array("1" => "List View", "2" => "Grid View", "3" => "Map View"),
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.ajax.layouts.oder', 1),
    ));

    // VALUE FOR LIST SHOW IN AJAX WIDGETS
    $this->addElement('MultiCheckbox', 'sitebusiness_ajax_widgets_list', array(
        'description' => 'Choose the ajax tabs that you want to be there in the Main Businesses Home Widget.',
        'label' => 'Ajax Tabs of Main Businesses Home Widget',
        // 'required' => true,
        'multiOptions' => array("1" => "Recent", "2" => "Most Popular", "3" => "Random", "4" => "Featured", "5" => "Sponsored"),
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.ajax.widgets.list', array("0" => "1", "1" => "2", "2" => "3", "3" => "4", "4" => '5')),
    ));


    // VALUE FOR POPULAR IN SITEBUSINESS VIEW
    $this->addElement('Text', 'sitebusiness_popular_widgets', array(
        'label' => 'Popular Businesses Widget',
        'maxlength' => '3',
        'description' => 'How many directory items / businesses will be shown in the popular businesses widget (value can not be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.popular.widgets', 10),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    // VALUE FOR POPULAR IN GRID VIEW
    $this->addElement('Text', 'sitebusiness_popular_thumbs', array(
        'label' => 'Popular Businesses Widget Grid View',
        'maxlength' => '3',
        'description' => 'How many directory items / businesses will be shown in the popular businesses widget in image view (value can not be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.popular.thumbs', 15),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    // VALUE FOR RECENT IN SITEBUSINESS VIEW
    $this->addElement('Text', 'sitebusiness_recent_widgets', array(
        'label' => 'Recent Businesses Widget',
        'maxlength' => '3',
        'description' => 'How many directory items / businesses will be shown in the recent businesses widget (value can not be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.recent.widgets', 10),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    // VALUE FOR RECENT IN GRID VIEW
    $this->addElement('Text', 'sitebusiness_recent_thumbs', array(
        'label' => 'Recent Businesses Widget Grid View',
        'maxlength' => '3',
        'description' => 'How many directory items / businesses will be shown in the recent businesses widget in image view (value can not be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.recent.thumbs', 15),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    // VALUE FOR RANDOM IN SITEBUSINESS VIEW
    $this->addElement('Text', 'sitebusiness_random_widgets', array(
        'label' => 'Random Businesses Widget',
        'maxlength' => '3',
        'description' => 'How many directory items / businesses will be shown in the random businesses widget (value can not be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.random.widgets', 10),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    // VALUE FOR RANDOM IN GRID VIEW
    $this->addElement('Text', 'sitebusiness_random_thumbs', array(
        'label' => 'Random Businesses Widget Grid View',
        'maxlength' => '3',
        'description' => 'How many directory items / businesses will be shown in the random businesses widget in image view (value can not be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.random.thumbs', 15),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));


    // VALUE FOR FETURED IN SITEBUSINESS VIEW
    $this->addElement('Text', 'sitebusiness_featured_list', array(
        'label' => 'Featured Businesses Widget',
        'maxlength' => '3',
        'description' => 'How many directory items / businesses will be shown in the featured businesses widget (value can not be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.featured.list', 10),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    // VALUE FOR FETURED IN GRID VIEW
    $this->addElement('Text', 'sitebusiness_featured_thumbs', array(
        'label' => 'Featured Businesses  Widget Grid View',
        'maxlength' => '3',
        'description' => 'How many directory items / businesses will be shown in the featured businesses widget in image view (value can not be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.featured.thumbs', 15),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    // VALUE FOR SPONSORED IN SITEBUSINESS VIEW
    $this->addElement('Text', 'sitebusiness_sponsored_list', array(
        'label' => 'Sponsored Businesses Widget',
        'maxlength' => '3',
        'description' => 'How many directory items / businesses will be shown in the sponsored businesses widget (value can not be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.sponsored.list', 10),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    // VALUE FOR SPONSORED IN GRID VIEW
    $this->addElement('Text', 'sitebusiness_sponosred_thumbs', array(
        'label' => 'Sponsored Businesses Widget Grid View',
        'maxlength' => '3',
        'description' => 'How many directory items / businesses will be shown in the sponsored businesses widget in image view (value can not be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.sponosred.thumbs', 15),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));
    $this->addElement('Text', 'sitebusiness_favourite_businesses', array(
        'label' => 'Favourites businesses Widget',
        'maxlength' => '3',
        'description' => 'How many directory items / businesses will be shown in the Favourites Businesses widget (value can not be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.favourite.businesses', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));


    // VALUE FOR RANDOM IN GRID VIEW
    $this->addElement('Text', 'sitebusiness_suggest_sitebusinesses', array(
        'label' => 'You May Also Like Widget',
        'maxlength' => '3',
        'description' => 'How many directory items / businesses will be shown in the you may also like widget (value can not be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.suggest.sitebusinesses', 5),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    // VALUE FOR RANDOM IN GRID VIEW
    $this->addElement('Text', 'sitebusiness_recently_view', array(
        'label' => 'Recently Viewed Businesses Widget',
        'maxlength' => '3',
        'description' => 'How many directory items / businesses will be shown in the recently viewed businesses widget in image view (value can not be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.recently.view', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    // VALUE FOR RANDOM IN GRID VIEW
    $this->addElement('Text', 'sitebusiness_recentlyfriend_view', array(
        'label' => 'Recently Viewed By Friends Widget',
        'maxlength' => '3',
        'description' => 'How many directory items / businesses will be shown in the recently viewed by friends widget (value can not be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.recentlyfriend_view', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));
    // VALUE FOR RANDOM IN GRID VIEW
    $this->addElement('Text', 'sitebusiness_businesslike_view', array(
        'label' => 'Business Profile Likes Widget',
        'maxlength' => '3',
        'description' => 'How many users will be shown in the business profile likes widget (value can not be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.businesslike.view', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    // VALUE FOR Discusion IN SITEBUSINESS VIEW
    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessdiscussion')) {
      $this->addElement('Text', 'sitebusiness_mostdiscussed_widgets', array(
          'label' => 'Most Discussed Businesses Widget',
          'maxlength' => '3',
          'description' => 'How many directory items / businesses will be shown in the most discussed Businesses widget (value can not be empty or zero) ?',
          'required' => true,
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.mostdiscussed.widgets', 3),
          'validators' => array(
              array('Int', true),
              array('GreaterThan', true, array(0)),
          ),
      ));
    }

    $this->addElement('Text', 'sitebusiness_popular_locations', array(
        'label' => 'Popular Locations Widget',
        'maxlength' => '3',
        'description' => 'How many locations will be shown in the popular locations widget (value can not be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.popular.locations', 10),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));


    $this->addElement('Button', 'submit', array(
        'label' => 'Save Changes',
        'type' => 'submit',
        'ignore' => true
    ));
  }

}

?>