<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Overview.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusiness_Form_Overview extends Engine_Form {

  public $_error = array();

  public function init() {
    $this->setTitle('Edit Business Overview')
        ->setDescription('Overview enables you to create a rich profile for your Business using the editor below. Compose the overview and click "Save Overview" to save it.')
        ->setAttrib('name', 'sitebusinesses_overview');
    $upload_url = "";
    $business_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('business_id', null);
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'spcreate');
    if (!empty($isManageAdmin)) {
      $upload_url = Zend_Controller_Front::getInstance()->getRouter()->assemble(array('action' => "upload-photo", 'business_id' => $business_id), 'sitebusiness_dashboard', true);
    }
    // Overview
    $this->addElement('TinyMce', 'body', array(
            'label' => '',
//             'required' => true,
            'allowEmpty' => false,
            'attribs' => array('rows' => 180, 'cols' => 350, 'style' => 'width:740px; max-width:740px;height:858px;'),

            'editorOptions' => Engine_Api::_()->seaocore()->tinymceEditorOptions($upload_url),
             'filters' => array(new Engine_Filter_Censor()),
    ));

    $this->addElement('Button', 'save', array(
            'label' => 'Save Overview',
            'type' => 'submit',
    ));
  }

}
?>