<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Create.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusiness_Form_Post_Create extends Engine_Form {

  public function init() {

    $topic_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('topic_id', null);
    $this
            ->setTitle('Reply')
            ->setDescription('Post your reply to this topic below.')
            ->setAction(
                    Zend_Controller_Front::getInstance()->getRouter()
                    ->assemble(array('action' => 'post', 'controller' => 'topic', 'tab' => Zend_Controller_Front::getInstance()->getRequest()->getParam('tab', null)), 'sitebusiness_extended', true)
    );

    if (!Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.tinymceditor', 1)) {
      $this->addElement('Textarea', 'body', array(
          'label' => 'Body',
          'allowEmpty' => false,
          'required' => true,
          'filters' => array(
              'StripTags',
              new Engine_Filter_Censor(),
              new Engine_Filter_HtmlSpecialChars(),
          ),
      ));
    } else {
      $upload_url = "";
      $business_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('business_id', null);
      $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
      $sitebusinessalbumEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessalbum');
      $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'spcreate');
      if ($sitebusinessalbumEnabled && (!empty($isManageAdmin) || Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit'))) {
        $upload_url = Zend_Controller_Front::getInstance()->getRouter()->assemble(array('action' => "upload-photo", 'business_id' => $business_id, 'special' => 'discussions'), 'sitebusiness_dashboard', true);
      }
      /* Some time overview is not work so use body
       */
      // Overview
      $this->addElement('TinyMce', 'body', array(
          'label' => '',
          'required' => true,
          'allowEmpty' => false,
          'attribs' => array('rows' => 180, 'cols' => 350, 'style' => 'width:740px; max-width:740px;height:858px;'),

          'editorOptions' => Engine_Api::_()->seaocore()->tinymceEditorOptions($upload_url),
          'filters' => array(
              new Engine_Filter_Censor(),
              new Engine_Filter_Html(array('AllowedTags' => "strong, b, em, i, u, strike, sub, sup, p, div, pre, address, h1, h2, h3, h4, h5, h6, span, ol, li, ul, a, img, embed, br, hr, iframe"))),
      ));
    }

    $this->addElement('Checkbox', 'watch', array(
        'label' => 'Send me notifications when other members reply to this topic.',
        'value' => '1',
    ));

    $this->addElement('Button', 'submit', array(
        'label' => 'Post Reply',
        'ignore' => true,
        'type' => 'submit',
        'decorators' => array(
            'ViewHelper',
        ),
    ));

    $this->addElement('Hidden', 'topic_id', array(
        'order' => '920',
        'value' => $topic_id,
        'filters' => array(
            'Int'
        )
    ));

    $this->addElement('Hidden', 'ref',array('order' => 900,));
  }

}

?>