<?php

/**
 * SocialEngine

 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Writes.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusiness_Model_DbTable_Mobileadmincontent extends Engine_Db_Table
{

  protected $_serializedColumns = array('params');

  /**
   * Gets name
   *
   * @param int $tab_main
   * @return name
   */
  public function getCurrentTabName($tab_main = null)
  {
    if( empty($tab_main) ) {
      return;
    }
    $current_tab_name = $this->select()
      ->from($this->info('name'), array('name'))
      ->where('mobileadmincontent_id = ?', $tab_main)
      ->query()
      ->fetchColumn();
    return $current_tab_name;
  }

  /**
   * Gets content_id, name
   *
   * @param int $contentbusiness_id
   * @param int $name
   * @return content_id, name
   */
  public function getContentByWidgetName($name, $business_id)
  {
    $select = $this->select()->from($this->info('name'), array('mobileadmincontent_id', 'name'))
      ->where('name =?', $name)
      ->where('business_id = ?', $business_id)
      ->limit(1);
    return $this->fetchAll($select)->toarray();
  }

  /**
   * Gets content_id
   *
   * @param int $contentbusiness_id
   * @return $params
   */
  public function getContentId($mobilecontentbusiness_id, $sitebusiness)
  {
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    if( !empty($viewer_id) ) {
      $level_id = $viewer->level_id;
    } else {
      $level_id = 0;
    }
    $itemAlbumCount = 10;
    $itemPhotoCount = 100;
    $select = $this->select();
    $select_content = $select
      ->from($this->info('name'))
      ->where('business_id = ?', $mobilecontentbusiness_id)
      ->where('type = ?', 'container')
      ->where('name = ?', 'main')
      ->limit(1);
    $content = $select_content->query()->fetchAll();
    if( !empty($content) ) {
      $select = $this->select();
      $select_container = $select
        ->from($this->info('name'), array('mobileadmincontent_id'))
        ->where('business_id = ?', $mobilecontentbusiness_id)
        ->where('type = ?', 'container')
        ->where('name = ?', 'middle')
        ->where("name NOT IN ('	sitebusiness.title-sitebusiness', 'seaocore.like-button', 'sitebusiness.photorecent-sitebusiness')")
        ->limit(1);
      $container = $select_container->query()->fetchAll();
      if( !empty($container) ) {
        $select = $this->select();
        $container_id = $container[0]['mobileadmincontent_id'];
        $select_middle = $select
          ->from($this->info('name'))
          ->where('parent_content_id = ?', $container_id)
          ->where('type = ?', 'widget')
          ->where('name = ?', 'sitemobile.container-tabs-columns')
          ->where('business_id = ?', $mobilecontentbusiness_id)
          ->limit(1);
        $middle = $select_middle->query()->fetchAll();
        if( !empty($middle) ) {
          $mobilecontent_id = $middle[0]['mobileadmincontent_id'];
        } else {
          $mobilecontent_id = $container_id;
        }
      }
    }

    if( !empty($mobilecontent_id) ) {
      $select = $this->select();
      $select_middle = $select
        ->from($this->info('name'), array('mobileadmincontent_id', 'name', 'params'))
        ->where('parent_content_id = ?', $content_id)
        ->where('type = ?', 'widget')
        ->where("name NOT IN ('sitebusiness.title-sitebusiness', 'seaocore.like-button', 'sitebusiness.photorecent-sitebusiness', 'Facebookse.facebookse-sitebusinessprofilelike', 'sitebusiness.thumbphoto-sitebusiness')")
        ->where('business_id = ?', $mobilecontentbusiness_id)
        ->order('order')
      ;

      $select = $this->select();
      $select_photo = $select
        ->from($this->info('name'), array('params'))
        ->where('parent_content_id = ?', $mobilecontent_id)
        ->where('type = ?', 'widget')
        ->where('name = ?', 'sitebusiness.photos-sitebusiness')->where('business_id = ?', $mobilecontentbusiness_id)
        ->order('mobileadmincontent_id ASC');

      $middlePhoto = $select_photo->query()->fetchColumn();
      if( !empty($middlePhoto) ) {
        $photoParamsDecodedArray = Zend_Json_Decoder::decode($middlePhoto);
        if( isset($photoParamsDecodedArray['itemCount']) && !empty($photoParamsDecodedArray) ) {
          $itemAlbumCount = $photoParamsDecodedArray['itemCount'];
        }
        if( isset($photoParamsDecodedArray['itemCount_photo']) && !empty($photoParamsDecodedArray) ) {
          $itemPhotoCount = $photoParamsDecodedArray['itemCount_photo'];
        }
      }
      $middle = $select_middle->query()->fetchAll();
      $editpermission = '';
      $isManageAdmin = '';
      $content_ids = '';
      $content_names = '';
      $resource_type_integration = 0;
      $ads_display_integration = 0;
      $flag = false;
      foreach( $middle as $value ) {
        $content_name = $value['name'];
        switch( $content_name ) {
          case 'sitebusiness.overview-sitebusiness':
            if( !empty($sitebusiness) ) {
              $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'overview');
              if( !empty($isManageAdmin) ) {
                $editpermission = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
                if( !empty($editpermission) && empty($sitebusiness->overview) ) {
                  $flag = true;
                } elseif( empty($editpermission) && empty($sitebusiness->overview) ) {
                  $flag = false;
                } elseif( !empty($editpermission) && !empty($sitebusiness->overview) ) {
                  $flag = true;
                } elseif( empty($editpermission) && !empty($sitebusiness->overview) ) {
                  $flag = true;
                }
              }
            }
            break;
          case 'sitebusiness.location-sitebusiness':
            if( !empty($sitebusiness) ) {
              $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'map');
              if( !empty($isManageAdmin) ) {
                $value['id'] = $sitebusiness->getIdentity();
                $location = Engine_Api::_()->getDbtable('locations', 'sitebusiness')->getLocation($value);
                if( !empty($location) ) {
                  $flag = true;
                }
              }
            }
            break;
          case 'core.html-block':
            $flag = true;
            break;
          case 'activity.feed':
            $flag = true;
            break;
          case 'seaocore.feed':
            $flag = true;
            break;
          case 'advancedactivity.home-feeds':
            $flag = true;
            break;
          case 'sitebusiness.info-sitebusiness':
            $flag = true;
            break;
          case 'core.profile-links':
            $flag = true;
            break;
          case 'sitebusinessnote.profile-sitebusinessnotes':
            if( Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessnote') ) {
              if( Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
                if( Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessnote") == 1 ) {
                  $flag = true;
                }
              } else {
                $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'sncreate');
                if( !empty($isBusinessOwnerAllow) ) {
                  $flag = true;
                }
              }
              //TOTAL NOTES
              $noteCount = Engine_Api::_()->sitebusiness()->getTotalCount($sitebusiness->business_id, 'sitebusinessnote', 'notes');
              $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'sncreate');
              if( !empty($isManageAdmin) || !empty($noteCount) ) {
                $flag = true;
              } else {
                $flag = false;
              }
            }
            break;
          case 'sitebusinessevent.profile-sitebusinessevents':
            if( Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessevent') ) {
              if( Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
                if( Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessevent") == 1 ) {
                  $flag = true;
                }
              } else {
                $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'secreate');
                if( !empty($isBusinessOwnerAllow) ) {
                  $flag = true;
                }
              }
              //TOTAL EVENTS
              $eventCount = Engine_Api::_()->sitebusiness()->getTotalCount($sitebusiness->business_id, 'sitebusinessevent', 'events');
              $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'secreate');
              if( !empty($isManageAdmin) || !empty($eventCount) ) {
                $flag = true;
              } else {
                $flag = false;
              }
            }
            break;
          case 'siteevent.contenttype-events':
            if( Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('siteevent') ) {
              if( Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
                if( Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessevent") == 1 ) {
                  $flag = true;
                }
              } else {
                $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'secreate');
                if( !empty($isBusinessOwnerAllow) ) {
                  $flag = true;
                }
              }
              //TOTAL EVENTS
              $eventCount = Engine_Api::_()->sitebusiness()->getTotalCount($sitebusiness->business_id, 'siteevent', 'events');
              $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'secreate');
              if( !empty($isManageAdmin) || !empty($eventCount) ) {
                $flag = true;
              } else {
                $flag = false;
              }
            }
            break;
          case 'document.contenttype-documents':
            if( Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('document') ) {
              if( Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
                if( Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessdocument") == 1 ) {
                  $flag = true;
                }
              } else {
                $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'sdcreate');
                if( !empty($isBusinessOwnerAllow) ) {
                  $flag = true;
                }
              }
              //TOTAL videoS
              $documentCount = Engine_Api::_()->sitebusiness()->getTotalCount($sitebusiness->business_id, 'document', 'documents');
              $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'sdcreate');
              if( !empty($isManageAdmin) || !empty($documentCount) ) {
                $flag = true;
              } else {
                $flag = false;
              }
            }
            break;
          case 'sitevideo.contenttype-videos':
            if( Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitevideo') ) {
              if( Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
                if( Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessvideo") == 1 ) {
                  $flag = true;
                }
              } else {
                $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'svcreate');
                if( !empty($isBusinessOwnerAllow) ) {
                  $flag = true;
                }
              }
              //TOTAL videoS
              $videoCount = Engine_Api::_()->sitebusiness()->getTotalCount($sitebusiness->business_id, 'sitevideo', 'videos');
              $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'svcreate');
              if( !empty($isManageAdmin) || !empty($videoCount) ) {
                $flag = true;
              } else {
                $flag = false;
              }
            }
            break;
          case 'sitebusiness.discussion-sitebusiness':
            if( Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessdiscussion') ) {
              if( Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
                if( Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessdiscussion") == 1 ) {
                  $flag = true;
                }
              } else {
                $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'sdicreate');
                if( !empty($isBusinessOwnerAllow) ) {
                  $flag = true;
                }
              }
              //TOTAL TOPICS
              $topicCount = Engine_Api::_()->sitebusiness()->getTotalCount($sitebusiness->business_id, 'sitebusiness', 'topics');
              $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'sdicreate');
              if( !empty($isManageAdmin) || !empty($topicCount) ) {
                $flag = true;
              } else {
                $flag = false;
              }
            }
            break;
          case 'sitebusiness.photos-sitebusiness':
            if( Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessalbum') ) {
              if( Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
                if( Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessalbum") == 1 ) {
                  $flag = true;
                }
              } else {
                $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'spcreate');
                if( !empty($isBusinessOwnerAllow) ) {
                  $flag = true;
                }
              }
              //TOTAL ALBUMS
              $albumCount = Engine_Api::_()->sitebusiness()->getTotalCount($sitebusiness->business_id, 'sitebusiness', 'albums');
              $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'spcreate');
              if( !empty($isManageAdmin) || !empty($albumCount) ) {
                $flag = true;
              } else {
                $flag = false;
              }
            }
            break;
          case 'sitebusinessmusic.profile-sitebusinessmusic':
            if( Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmusic') ) {
              if( Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
                if( Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessmusic") == 1 ) {
                  $flag = true;
                }
              } else {
                $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'smcreate');
                if( !empty($isBusinessOwnerAllow) ) {
                  $flag = true;
                }
              }
              //TOTAL PLAYLISTS
              $musicCount = Engine_Api::_()->sitebusiness()->getTotalCount($sitebusiness->business_id, 'sitebusinessmusic', 'playlists');
              $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'smcreate');
              if( !empty($isManageAdmin) || !empty($musicCount) ) {
                $flag = true;
              } else {
                $flag = false;
              }
            }
            break;

          case 'sitebusinessmember.profile-sitebusinessmembers':
            if( Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember') ) {
              if( Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
                if( Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessmember") == 1 ) {
                  $flag = true;
                }
              } else {
                $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'smecreate');
                if( !empty($isBusinessOwnerAllow) ) {
                  $flag = true;
                }
              }
              //TOTAL PLAYLISTS
              $memberCount = Engine_Api::_()->sitebusiness()->getTotalCount($sitebusiness->business_id, 'sitebusinessm', 'membership');
              $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'smecreate');
              if( !empty($isManageAdmin) || !empty($memberCount) ) {
                $flag = true;
              } else {
                $flag = false;
              }
            }
            break;

          case 'sitebusinessdocument.profile-sitebusinessdocuments':
            if( Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessdocument') ) {
              if( Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
                if( Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessdocument") == 1 ) {
                  $flag = true;
                }
              } else {
                $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'sdcreate');
                if( !empty($isBusinessOwnerAllow) ) {
                  $flag = true;
                }
              }
              //TOTAL DOCUMENTS
              $documentCount = Engine_Api::_()->sitebusiness()->getTotalCount($sitebusiness->business_id, 'sitebusinessdocument', 'documents');
              $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'sdcreate');
              if( !empty($isManageAdmin) || !empty($documentCount) ) {
                $flag = true;
              } else {
                $flag = false;
              }
            }
            break;
          case 'sitebusinessreview.profile-sitebusinessreviews':
            if( Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessreview') ) {
              //TOTAL REVIEW
              $reviewCount = Engine_Api::_()->sitebusiness()->getTotalCount($sitebusiness->business_id, 'sitebusinessreview', 'reviews');
              $level_allow = Engine_Api::_()->authorization()->getPermission($level_id, 'sitebusinessreview_review', 'create');
              if( !empty($level_allow) || !empty($reviewCount) ) {
                $flag = true;
              } else {
                $flag = false;
              }
            }
            break;
          case 'sitebusinessvideo.profile-sitebusinessvideos':
            if( Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessvideo') ) {
              if( Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
                if( Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessvideo") == 1 ) {
                  $flag = true;
                }
              } else {
                $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'svcreate');
                if( !empty($isBusinessOwnerAllow) ) {
                  $flag = true;
                }
              }
              //TOTAL VIDEO
              $videoCount = Engine_Api::_()->sitebusiness()->getTotalCount($sitebusiness->business_id, 'sitebusinessvideo', 'videos');
              $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'svcreate');
              if( !empty($isManageAdmin) || !empty($videoCount) ) {
                $flag = true;
              } else {
                $flag = false;
              }
            }
            break;
          case 'sitebusinesspoll.profile-sitebusinesspolls':
            if( Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinesspoll') ) {
              if( Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
                if( Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinesspoll") == 1 ) {
                  $flag = true;
                }
              } else {
                $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'splcreate');
                if( !empty($isBusinessOwnerAllow) ) {
                  $flag = true;
                }
              }
              //TOTAL POLL
              $pollCount = Engine_Api::_()->sitebusiness()->getTotalCount($sitebusiness->business_id, 'sitebusinesspoll', 'polls');
              $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'splcreate');
              if( !empty($isManageAdmin) || !empty($pollCount) ) {
                $flag = true;
              } else {
                $flag = false;
              }
            }
            break;
          case 'sitebusinessoffer.profile-sitebusinessoffers':
            if( Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessoffer') ) {
              if( Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
                if( Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessoffer") == 1 ) {
                  $flag = true;
                }
              } else {
                $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'offer');
                if( !empty($isBusinessOwnerAllow) ) {
                  $flag = true;
                }
              }
              //TOTAL OFFERS
              $can_edit = 1;
              $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
              if( empty($isManageAdmin) ) {
                $can_edit = 0;
              }

              $can_offer = 1;
              $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'offer');

              if( empty($isManageAdmin) ) {
                $can_offer = 0;
              }

              $can_create_offer = '';

              //OFFER CREATION AUTHENTICATION CHECK
              if( $can_edit == 1 && $can_offer == 1 ) {
                $can_create_offer = 1;
              }

              //TOTAL OFFER
              $offerCount = Engine_Api::_()->sitebusiness()->getTotalCount($sitebusiness->business_id, 'sitebusinessoffer', 'offers');
              if( !empty($can_create_offer) || !empty($offerCount) ) {
                $flag = true;
              } else {
                $flag = false;
              }
            }
            break;
          case 'sitebusinessform.sitebusiness-viewform':
            if( Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessform') ) {
              if( Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
                if( Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessform") == 1 ) {
                  $flag = true;
                }
              } else {
                $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'form');
                if( !empty($isBusinessOwnerAllow) ) {
                  $flag = true;
                }
              }
            }
            break;
          case 'sitebusinessintegration.profile-items':
            if( Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessintegration') ) {
              $content_params = $value['params'];
              $paramsDecodedArray = Zend_Json_Decoder::decode($content_params);
              $resource_type_integration = $paramsDecodedArray['resource_type'];
              $ads_display_integration = Engine_Api::_()->getApi('settings', 'core')->getSetting("sitebusiness.ad.$resource_type_integration", 3);

              //PACKAGE BASE AND MEMBER LEVEL SETTINGS PRIYACY START
              if( Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
                if( Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", $resource_type_integration) ) {
                  $flag = true;
                }
              } else {
                $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, $resource_type_integration);
                if( !empty($isBusinessOwnerAllow) ) {
                  $flag = true;
                }
              }
              //PACKAGE BASE AND MEMBER LEVEL SETTINGS PRIYACY END
            }
            break;
          case 'sitebusinesstwitter.feeds-sitebusinesstwitter':
            if( Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinesstwitter') ) {
              $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'twitter');
              if( !empty($isManageAdmin) ) {
                $flag = true;
              }
            }
            break;
          case 'sitecrowdfunding.contenttype-projects':
            if( Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitecrowdfunding') ) {
              if( Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
                if( Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitecrowdfunding") == 1 ) {
                  $flag = true;
                }
              } else {
                $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'sprcreate');
                if( !empty($isBusinessOwnerAllow) ) {
                  $flag = true;
                }
              }
              //TOTAL PROJECTS
              $projectCount = Engine_Api::_()->sitebusiness()->getTotalCount($sitebusiness->business_id, 'sitecrowdfunding', 'projects');
              $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'sprcreate');
              if( !empty($isManageAdmin) || !empty($projectCount) ) {
                $flag = true;
              } else {
                $flag = false;
              }
            }
            break;
          case 'sitemusic.contenttype-music':
            if( Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitemusic') ) {
              if( Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
                if( Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitemusic") == 1 ) {
                  $flag = true;
                }
              } else {
                $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'samcreate');
                if( !empty($isBusinessOwnerAllow) ) {
                  $flag = true;
                }
              }
              //TOTAL Album
              $musicAlbumCount = Engine_Api::_()->sitebusiness()->getTotalCount($sitebusiness->business_id, 'sitemusic', 'music');
              $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'samcreate');
              if( !empty($isManageAdmin) || !empty($musicAlbumCount) ) {
                $flag = true;
              } else {
                $flag = false;
              }
            }
            break;
        }

        if( !empty($flag) ) {
          $content_ids = $value['mobileadmincontent_id'];
          $content_names = $value['name'];
          break;
        }
      }
    }

    return array('mobilecontent_id' => $content_ids, 'content_name' => $content_names, 'itemAlbumCount' => $itemAlbumCount, 'itemPhotoCount' => $itemPhotoCount, 'resource_type_integration' => $resource_type_integration, 'ads_display_integration' => $ads_display_integration);
  }

  /**
   * Gets content_id, name
   *
   * @param int $contentbusiness_id
   * @return content_id, name
   */
  public function getContentInformation($business_id)
  {
    $select = $this->select()->from($this->info('name'), array('mobileadmincontent_id', 'name'))
        ->where("name IN ('sitebusiness.info-sitebusiness', 'seaocore.feed', 'advancedactivity.home-feeds','activity.feed', 'sitebusiness.location-sitebusiness', 'core.profile-links', 'core.html-block')")
        ->where('business_id = ?', $business_id)->order('mobileadmincontent_id ASC');

    return $this->fetchAll($select);
  }

  public function prepareContentArea($content, $current = null)
  {

    //GET PARENT CONTENT ID
    $parent_content_id = null;
    if( null !== $current ) {
      $parent_content_id = $current->mobileadmincontent_id;
    }

    //GET CHILDREN
    $children = $content->getRowsMatching('parent_content_id', $parent_content_id);
    if( empty($children) && null === $parent_content_id ) {
      $children = $content->getRowsMatching('parent_content_id', 0);
    }

    //GET STRUCT
    $struct = array();
    foreach( $children as $child ) {
      $elStruct = $this->createElementParams($child);
      $elStruct['elements'] = $this->prepareContentArea($content, $child);
      $struct[] = $elStruct;
    }

    return $struct;
  }

  public function createElementParams($row)
  {

    $data = array(
      'identity' => $row->mobileadmincontent_id,
      'type' => $row->type,
      'name' => $row->name,
      'order' => $row->order,
    );
    $params = (array) $row->params;
    if( isset($params['title']) )
      $data['title'] = $params['title'];
    $data['params'] = $params;
    return $data;
  }

  /**
   * Gets content id,parama,name
   *
   * @param int $contentbusiness_id
   * @return content id,parama,name
   */
  public function getContents($mobilecontentbusiness_id)
  {

    $selectBusinessAdmin = $this->select()
      ->from($this->info('name'), array('mobileadmincontent_id', 'params', 'name'))
      ->where('business_id =?', $mobilecontentbusiness_id)
      ->where("name IN ('sitebusiness.overview-sitebusiness', 'sitebusiness.photos-sitebusiness', 'sitebusiness.discussion-sitebusiness', 'sitebusinessnote.profile-sitebusinessnotes', 'sitebusinesspoll.profile-sitebusinesspolls', 'sitebusinessevent.profile-sitebusinessevents', 'sitebusinessvideo.profile-sitebusinessvideos', 'sitebusinessoffer.profile-sitebusinessoffers', 'sitebusinessreview.profile-sitebusinessreviews', 'sitebusinessdocument.profile-sitebusinessdocuments', 'sitebusinessform.sitebusiness-viewform','sitebusiness.info-sitebusiness', 'seaocore.feed','advancedactivity.home-feeds', 'activity.feed', 'sitebusiness.location-sitebusiness', 'core.profile-links', 'sitebusinessmusic.profile-sitebusinessmusic', 'sitebusinessmember.profile-sitebusinessmembers', 'sitebusinessintegration.profile-items','sitebusinesstwitter.feeds-sitebusinesstwitter', 'siteevent.contenttype-events', 'sitevideo.contenttype-videos','sitecrowdfunding.contenttype-projects','sitemusic.contenttype-music')");
    return $this->fetchAll($selectBusinessAdmin);
  }

  /**
   * Set profile business default widget in admin content table
   *
   * @param string $name
   * @param string $contentbusiness_id
   * @param string $title
   * @param string $titleCount
   * @param string $order
   */
  public function setAdminDefaultInfo($name = null, $business_id, $title = null, $titleCount = null, $order = null, $params = null)
  {
    $db = Engine_Db_Table::getDefaultAdapter();
    if( !empty($name) ) {
      $select = $this->select();
      $select_content = $select
        ->from($this->info('name'))
        ->where('business_id = ?', $business_id)
        ->where('type = ?', 'widget')
        ->where('name = ?', $name)
        ->limit(1);
      $content = $select_content->query()->fetchAll();
      if( empty($content) ) {
        $select = $this->select();
        $select_container = $select
          ->from($this->info('name'), array('mobileadmincontent_id'))
          ->where('business_id = ?', $business_id)
          ->where('type = ?', 'container')
          ->limit(1);
        $container = $select_container->query()->fetchAll();
        if( !empty($container) ) {
          $container_id = $container[0]['mobileadmincontent_id'];

          $select = $this->select();
          $select_middle = $select
            ->from($this->info('name'))
            ->where('parent_content_id = ?', $container_id)
            ->where('type = ?', 'container')
            ->where('name = ?', 'middle')
            ->limit(1);
          $middle = $select_middle->query()->fetchAll();
          if( !empty($middle) ) {
            $middle_id = $middle[0]['mobileadmincontent_id'];

            $select = $this->select();
            $select_tab = $select
              ->from($this->info('name'))
              ->where('type = ?', 'widget')
              ->where('name = ?', 'sitemobile.container-tabs-columns')
              ->where('business_id = ?', $business_id)
              ->limit(1);
            $tab = $select_tab->query()->fetchAll();
            if( !empty($tab) ) {
              $tab_id = $tab[0]['mobileadmincontent_id'];
            }

            if( $name != 'sitebusinessintegration.profile-items' ) {
              $contentWidget = $this->createRow();
              $contentWidget->business_id = $business_id;
              $contentWidget->type = 'widget';
              $contentWidget->name = $name;
              $contentWidget->parent_content_id = ($tab_id ? $tab_id : $middle_id);
              $contentWidget->order = $order;
              if( $params ) {
                $contentWidget->params = $params;
              } else {
                $contentWidget->params = '{"title":"' . $title . '" , "titleCount":' . $titleCount . '}';
              }
              $contentWidget->save();
            } else {
              $select = new Zend_Db_Select($db);
              $select
                ->from('engine4_core_modules')
                ->where('name = ?', 'sitereview');
              $check_list = $select->query()->fetchObject();
              if( !empty($check_list) ) {
                $results = Engine_Api::_()->getDbtable('mixsettings', 'sitebusinessintegration')->getIntegrationItems();

                foreach( $results as $value ) {
                  $item_title = $value['item_title'];
                  $resource_type = $value['resource_type'] . '_' . $value['listingtype_id'];

                  // Check if it's already been placed
                  $select = new Zend_Db_Select($db);
                  $select
                    ->from('engine4_sitebusiness_mobileadmincontent')
                    ->where('parent_content_id = ?', $tab_id)
                    ->where('type = ?', 'widget')
                    ->where('name = ?', 'sitebusinessintegration.profile-items')
                    ->where('params = ?', '{"title":"' . $item_title . '","resource_type":"' . $resource_type . '","nomobile":"0","name":"sitebusinessintegration.profile-items"}');
                  $info = $select->query()->fetch();
                  if( empty($info) ) {

                    // tab on profile
                    $db->insert('engine4_sitebusiness_mobileadmincontent', array(
                      'business_id' => $business_id,
                      'type' => 'widget',
                      'name' => 'sitebusinessintegration.profile-items',
                      'parent_content_id' => $tab_id,
                      'order' => 999,
                      'params' => '{"title":"' . $item_title . '","resource_type":"' . $resource_type . '","nomobile":"0","name":"sitebusinessintegration.profile-items"}',
                    ));
                  }
                  //}
                }
              }

              $this->settabbusinessintwidget('document', '{"title":"Documents","resource_type":"document_0","nomobile":"0","name":"sitebusinessintegration.profile-items"}', $tab_id, $business_id);
              $this->settabbusinessintwidget('sitefaq', '{"title":"FAQs","resource_type":"sitefaq_faq_0","nomobile":"0","name":"sitebusinessintegration.profile-items"}', $tab_id, $business_id);

              $this->settabbusinessintwidget('sitegroup', '{"title":"Groups","resource_type":"sitegroup_group_0","nomobile":"0","name":"sitebusinessintegration.profile-items"}', $tab_id, $business_id);

              $this->settabbusinessintwidget('sitepage', '{"title":"Pages","resource_type":"sitepage_page_0","nomobile":"0","name":"sitepageintegration.profile-items"}', $tab_id, $business_id);

              $this->settabbusinessintwidget('list', '{"title":"Listings","resource_type":"list_listing_0","nomobile":"0","name":"sitebusinessintegration.profile-items"}', $tab_id, $business_id);

              $this->settabbusinessintwidget('folder', '{"title":"Folders","resource_type":"folder_0","nomobile":"0","name":"sitebusinessintegration.profile-items"}', $tab_id, $business_id);

              $this->settabbusinessintwidget('quiz', '{"title":"Quiz","resource_type":"quiz_0","nomobile":"0","name":"sitebusinessintegration.profile-items"}', $tab_id, $business_id);

              $this->settabbusinessintwidget('sitestoreproduct', '{"title":"Products","resource_type":"sitestoreproduct_product_0","nomobile":"0","name":"sitebusinessintegration.profile-items"}', $tab_id, $business_id);
            }
          }
        }
      }
    }
  }

  public function settabbusinessintwidget($module_name, $params, $middle_id, $business_id)
  {

    $db = Engine_Db_Table::getDefaultAdapter();

    $select = new Zend_Db_Select($db);
    $select
      ->from('engine4_core_modules')
      ->where('name = ?', $module_name);
    $module_enable = $select->query()->fetchObject();

    if( !empty($module_enable) ) {

      $results = Engine_Api::_()->getDbtable('mixsettings', 'sitebusinessintegration')->getIntegrationItems();

      foreach( $results as $value ) {
        $select = new Zend_Db_Select($db);
        $select
          ->from('engine4_sitebusiness_mobileadmincontent')
          ->where('parent_content_id = ?', $middle_id)
          ->where('type = ?', 'widget')
          ->where('name = ?', 'sitebusinessintegration.profile-items')
          ->where('params = ?', $params);
        $info = $select->query()->fetch();

        if( empty($info) ) {

          // tab on profile
          $db->insert('engine4_sitebusiness_mobileadmincontent', array(
            'business_id' => $business_id,
            'type' => 'widget',
            'name' => 'sitebusinessintegration.profile-items',
            'parent_content_id' => $middle_id,
            'order' => 999,
            'params' => $params,
          ));
        }
      }
    }
  }

}
