<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusiness_Plugin_Core extends Zend_Controller_Plugin_Abstract {

    public function routeShutdown(Zend_Controller_Request_Abstract $request) {

        if (substr($request->getPathInfo(), 1, 5) == "admin") {
            $module = $request->getModuleName();
            $controller = $request->getControllerName();
            $action = $request->getActionName();
            if ($module == 'core' && $controller == 'admin-content' && $action == 'index') {
                $sitebusinessLayoutCreate = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.layoutcreate');
                if (!empty($sitebusinessLayoutCreate)) {
                    $business_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('page', null);
                    if (!empty($business_id)) {
                        $corebusinessTable = Engine_Api::_()->getDbtable('pages', 'core');
                        $corebusinessTableName = $corebusinessTable->info('name');
                        $select = $corebusinessTable->select()
                                ->from($corebusinessTableName)
                                ->where('page_id' . ' = ?', $business_id)
                                ->where('name' . ' = ?', 'sitebusiness_index_view')
                                ->limit(1);
                        $corebusinessTableInfo = $corebusinessTable->fetchRow($select);
                    }
                    if (!empty($corebusinessTableInfo)) {
                        $redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
                        $redirector->gotoRoute(array('module' => 'sitebusiness', 'controller' => 'layout', 'action' => 'layout', 'business' => $business_id), 'admin_default', false);
                    }
                }
            }
        }

        //CHECK IF ADMIN
        if (substr($request->getPathInfo(), 1, 5) == "admin") {
            return;
        }


        $module = $request->getModuleName();
        $controller = $request->getControllerName();
        $action = $request->getActionName();

// SITEBUSINESSURL WORK START
        $sitebusinessUrlEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessurl');
        if (!empty($sitebusinessUrlEnabled) && (($module == 'sitebusiness' && ($controller == 'index' || $controller == 'mobi') && $action == 'view') || ($module == 'core'))) {
            $front = Zend_Controller_Front::getInstance();

            // GET THE URL OF BUSINESS
            $urlO = $request->getRequestUri();
            $businessurl = '';

            // GET THE ROUTE BY WHICH BUSINESS WILL BE OPEN IF SHORTEN BUSINESSURL IS DISABLED
            $routeStartS = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.manifestUrlS', "businessitem");

            // GET THE BASE URL
            $base_url = $front->getBaseUrl();

            // MAKE A STRING OF BASEUL WITH ROUTESTART
            $string_url = $base_url . '/' . $routeStartS . '/';

            // FIND OUT THE POSITION OF ROUTESTART IF EXIST
            $pos_routestart = strpos($urlO, $string_url);
            if ($pos_routestart === false) {
                $index_routestart = 0;
                $businessurlArray = explode($base_url . '/', $urlO);
                $mainBusinessurl = strstr($businessurlArray[1], '/');

                // CHECK BASEDIRECTORY IS EXIST OR NOT
                if (empty($mainBusinessurl)) {
                    if (isset($businessurlArray[1])) {
                        $businessurl = $businessurlArray[1];
                    }
                } else {
                    $businessurl = $mainBusinessurl;
                }
            } else {
                $index_routestart = 1;
                $businessurlArray = explode($string_url, $urlO);
                $final_url = $businessurlArray[1];
                $mainBusinessurl = explode('/', $final_url);
                if (isset($mainBusinessurl[1]))
                    $businessurl = $mainBusinessurl[1];
            }

            // GET THE BUSINESS LIKES AFTER WHICH SHORTEN BUSINESSURL WILL BE WORK 
            $business_likes = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.likelimit.forurlblock', "5");
            $params_array = array();
            if ($front->getBaseUrl() == '' && empty($index_routestart)) {
                $params_array = $businessurlArray;
                $params_array[0] = NULL;
                array_shift($params_array);
            } else {
                $params_array = explode('/', $businessurlArray[1]);
            }

            if (!empty($index_routestart)) {
                if (isset($params_array['1']))
                    $businessurl = $params_array['1'];
            }
            else {
                $businessurl = $params_array['0'];
            }

            $businessurl = explode('?', $businessurl);
            $businessurl = $businessurl[0];

            // MAKE THE OBJECT OF SITEBUSINESS
            $sitebusinessObject = Engine_Api::_()->getItem('sitebusiness_business', Engine_Api::_()->sitebusiness()->getBusinessId($businessurl));

            $bannedBusinessurlsTable = Engine_Api::_()->getDbtable('BannedPageurls', 'seaocore');

            // GET THE ARRAY OF BANNED BUSINESSURLS
            $urlArray = $bannedBusinessurlsTable->select()->from($bannedBusinessurlsTable, 'word')
                            ->where('word = ?', $businessurl)
                            ->query()->fetchColumn();
            $change_url = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.change.url', 1);
            if (empty($urlArray) && (!empty($change_url)) && !empty($sitebusinessObject) && ($sitebusinessObject->like_count >= $business_likes)) {
                if ((!empty($index_routestart))) {
                    $redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
                    unset($params_array[0]);
                    $redirector->gotoUrl(implode("/", $params_array));
                }
                $request->setModuleName('sitebusiness');
                $request->setControllerName('index');
                $request->setActionName('view');
                $request->setParam("business_url", $businessurl);
                $count = count($params_array);
                for ($i = 1; $i <= $count; $i++) {
                    if (array_key_exists($i, $params_array)) {
                        $j = $i + 1;
                        if (isset($params_array[$i]) && isset($params_array[$j]) && !empty($params_array[$i])) {
                            $request->setParam($params_array[$i], $params_array[$j]);
                        }
                    }
                }
                if (!Engine_API::_()->seaocore()->checkSitemobileMode('fullsite-mode')) {
                    $sr_response = Engine_Api::_()->sitemobile()->setupRequest($request);
                }
            }
        }

        // SITEBUSINESSURL WORK END
        if (!Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('mobi'))
            return;

        $mobile = $request->getParam("mobile");
        $session = new Zend_Session_Namespace('mobile');

        if ($mobile == "1") {
            $mobile = true;
            $session->mobile = true;
        } elseif ($mobile == "0") {
            $mobile = false;
            $session->mobile = false;
        } else {
            if (isset($session->mobile)) {
                $mobile = $session->mobile;
            } else {
                //CHECK TO SEE IF MOBILE
                if (Engine_Api::_()->mobi()->isMobile()) {
                    $mobile = true;
                    $session->mobile = true;
                } else {
                    $mobile = false;
                    $session->mobile = false;
                }
            }
        }

        if (!$mobile) {
            return;
        }
        $module = $request->getModuleName();
        $controller = $request->getControllerName();
        $action = $request->getActionName();
        if ($module == "sitebusiness") {
            if ($controller == "index" && $action == "home") {
                $request->setControllerName('mobi');
                $request->setActionName('home');
            }

            if ($controller == "index" && $action == "index") {
                $request->setControllerName('mobi');
                $request->setActionName('index');
            }

            if ($controller == "index" && $action == "view") {

                $request->setControllerName('mobi');
                $request->setActionName('view');
            }

            if ($controller == "index" && $action == "map") {
                $request->setControllerName('index');
                $request->setActionName('mobilemap');
            }
        }

        //CREATE LAYOUT
        $layout = Zend_Layout::startMvc();

        //SET OPTIONS
        $layout->setViewBasePath(APPLICATION_PATH . "/application/modules/Mobi/layouts", 'Core_Layout_View')
                ->setViewSuffix('tpl')
                ->setLayout(null);
    }

    public function onRenderLayoutDefault($event) {

        $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
        $front = Zend_Controller_Front::getInstance();
        $module = $front->getRequest()->getModuleName();
        $controller = $front->getRequest()->getControllerName();
        $action = $front->getRequest()->getActionName();
        $membercategory_ids = '';
        $sitebusiness_layout_setting = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.layout.setting', 1);
        $sitebusiness_hide_left_container = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.hide.left.container', 0);
        $sitebusiness_slding_effect = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.slding.effect', 1);
        $show_option = 1;
        if ($module == "sitebusiness") {
            if ($controller == "index" && $action == "index") {
                $siteinfo = $view->layout()->siteinfo;
                if (Zend_Controller_Front::getInstance()->getRequest()->getParam('categoryname', null)) {
                    $siteinfo['keywords'] = Zend_Controller_Front::getInstance()->getRequest()->getParam('categoryname', null);
                }
                if (Zend_Controller_Front::getInstance()->getRequest()->getParam('subcategoryname', null)) {
                    $siteinfo['keywords'] .= ',' . Zend_Controller_Front::getInstance()->getRequest()->getParam('subcategoryname', null);
                }

                if (!empty($_GET['location'])) {
                    if (Zend_Controller_Front::getInstance()->getRequest()->getParam('location', null)) {
                        $siteinfo['keywords'] .= ',';
                    }
                    $siteinfo['keywords'] .= $_GET['location'];
                }
                $view->layout()->siteinfo = $siteinfo;
            }

            $category_name = "";
            $subcategory_name = "";
            if (Zend_Controller_Front::getInstance()->getRequest()->getParam('business_id', null)) {
                $currentbusinessid = Zend_Controller_Front::getInstance()->getRequest()->getParam('business_id', null);
                $sitebusinessObject = Engine_Api::_()->getItem('sitebusiness_business', $currentbusinessid);
                $siteinfo = $view->layout()->siteinfo;
                $row = Engine_Api::_()->getDbTable('categories', 'sitebusiness')->getCategory($sitebusinessObject->category_id);
                if (!empty($row->category_name)) {
                    $category_name = $row->category_name;
                    $siteinfo['keywords'] = $category_name;
                }
                $row = Engine_Api::_()->getDbTable('categories', 'sitebusiness')->getCategory($sitebusinessObject->subcategory_id);
                if (!empty($row->category_name)) {
                    $subcategory_name = $row->category_name;
                    $siteinfo['keywords'] .= ',' . $subcategory_name;
                }

                if (!empty($sitebusinessObject->location)) {
                    $siteinfo['keywords'] .= ',' . $sitebusinessObject->location;
                }
                $view->layout()->siteinfo = $siteinfo;
            }
            if ($controller == "index" && $action == "view") {
                if (Zend_Controller_Front::getInstance()->getRequest()->getParam('business_url', null)) {
                    $currenttabid = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab', 0);
                    $business_url = Zend_Controller_Front::getInstance()->getRequest()->getParam('business_url', null);
                    $contentinformation = 0;
                    $view = $event->getPayload();
                    $id = Engine_Api::_()->sitebusiness()->getBusinessId($business_url);
                    $sitebusiness_title = '';
                    if (!empty($id)) {
                        $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $id);
                        $sitebusiness_title = Engine_Api::_()->sitebusiness()->parseString($sitebusiness->title);
                        $sitebusiness_title = $view->string()->escapeJavascript($sitebusiness_title);
                    }

                    $content_id = 0;
                    $content_id3 = 0;
                    $tab_id = 0;
                    $tab_id3 = 0;
                    $tab_id4 = 0;
                    $widgetinformation = 0;
                    $tempcontent_name = "";
                    $tempcontent_id = 0;
                    $newtabid = 0;
                    $itemAlbumCount = 10;
                    $itemPhotoCount = 100;
                    if (Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.layoutcreate', 0) && !empty($sitebusiness)) {

                        $row = Engine_Api::_()->getDbtable('contentbusinesses', 'sitebusiness')->getContentBusinessId($id);
                        if ($row !== null) {
                            $contentbusiness_id = $row->contentbusiness_id;
                            $siteinfo = $view->layout()->siteinfo;
                            $siteinfo['description'] = $row->description;
                            $siteinfo['keywords'] = $row->keywords;
                            $view->layout()->siteinfo = $siteinfo;
                            $rowinfo = Engine_Api::_()->getDbtable('content', 'sitebusiness')->getContentInformation($contentbusiness_id);

                            if (!empty($rowinfo)) {
                                foreach ($rowinfo as $key => $value) {
                                    if ($value->name == 'advancedactivity.home-feeds') {
                                        $content_id = $tab_id = $value->content_id;
                                        if (empty($currenttabid)) {
                                            $currenttabid = $content_id;
                                        }
                                    } elseif ($value->name == 'seaocore.feed') {
                                        $content_id = $tab_id = $value->content_id;
                                        if (empty($currenttabid)) {
                                            $currenttabid = $content_id;
                                        }
                                    } elseif ($value->name == 'activity.feed') {
                                        $content_id = $tab_id = $value->content_id;
                                        if (empty($currenttabid)) {
                                            $currenttabid = $content_id;
                                        }
                                    } else if ($value->name == 'core.profile-links') {
                                        $content_id3 = $tab_id3 = $value->content_id;
                                        if (empty($currenttabid)) {
                                            $currenttabid = $content_id3;
                                        }
                                    } else if ($value->name == 'core.html-block') {
                                        $content_id4 = $tab_id4 = $value->content_id;
                                        if (empty($currenttabid)) {
                                            $currenttabid = $content_id4;
                                        }
                                    }
                                }
                            }
                            if (!empty($contentbusiness_id)) {
                                $contentinfo = Engine_Api::_()->getDbtable('content', 'sitebusiness')->getContentByWidgetName('core.container-tabs', $contentbusiness_id);
                                if (empty($contentinfo)) {
                                    $contentinformation = 0;
                                } else {
                                    $contentinformation = 1;
                                }

                                $contentwidgetinfo = Engine_Api::_()->getDbtable('content', 'sitebusiness')->getContentByWidgetName('sitebusiness.widgetlinks-sitebusiness', $contentbusiness_id);
                                if (empty($contentwidgetinfo)) {
                                    $widgetinformation = 0;
                                } else {
                                    $widgetinformation = 1;
                                }
                            }
                            $default_content_id = Engine_Api::_()->getDbtable('content', 'sitebusiness')->getContentId($contentbusiness_id, $sitebusiness);
                            $tempcontent_name = $default_content_id['content_name'];
                            $tempcontent_id = $default_content_id['content_id'];
                            if (empty($default_content_id['itemAlbumCount'])) {
                                $itemAlbumCount = 10;
                            } else {
                                $itemAlbumCount = $default_content_id['itemAlbumCount'];
                            }
                            if (empty($default_content_id['itemPhotoCount'])) {
                                $itemPhotoCount = 100;
                            } else {
                                $itemPhotoCount = $default_content_id['itemPhotoCount'];
                            }
                            if (empty($default_content_id['resource_type_integration'])) {
                                $resource_type_integration = Zend_Controller_Front::getInstance()->getRequest()->getParam('resource_type', 0);
                                $ads_display_integration = Engine_Api::_()->getApi('settings', 'core')->getSetting("sitebusiness.ad.$resource_type_integration", 3);
                            } else {
                                $resource_type_integration = $default_content_id['resource_type_integration'];
                                $ads_display_integration = $default_content_id['ads_display_integration'];
                            }

                            $newtabid = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab', $tempcontent_id);
                            $tab_main = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab', null);
                            if ($tab_main) {
                                $tempcontent_name = Engine_Api::_()->getDbtable('content', 'sitebusiness')->getCurrentTabName($tab_main);
                                $tempcontent_id = $tab_main;
                            }
                        } else {
                            $contentbusiness_id = Engine_Api::_()->sitebusiness()->getWidgetizedBusiness()->page_id;
                            $siteinfo = $view->layout()->siteinfo;
                            $siteinfo['description'] = Engine_Api::_()->sitebusiness()->getWidgetizedBusiness()->description;
                            $siteinfo['keywords'] = Engine_Api::_()->sitebusiness()->getWidgetizedBusiness()->keywords;
                            $view->layout()->siteinfo = $siteinfo;
                            $rowinfo = Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->getContentInformation($contentbusiness_id);

                            if (!empty($rowinfo)) {
                                foreach ($rowinfo as $key => $value) {
                                    if ($value->name == 'advancedactivity.home-feeds') {
                                        $content_id = $tab_id = $value->admincontent_id;
                                        if (empty($currenttabid)) {
                                            $currenttabid = $content_id;
                                        }
                                    } elseif ($value->name == 'seaocore.feed') {
                                        $content_id = $tab_id = $value->admincontent_id;
                                        if (empty($currenttabid)) {
                                            $currenttabid = $content_id;
                                        }
                                    } elseif ($value->name == 'activity.feed') {
                                        $content_id = $tab_id = $value->admincontent_id;
                                        if (empty($currenttabid)) {
                                            $currenttabid = $content_id;
                                        }
                                    } else if ($value->name == 'core.profile-links') {
                                        $content_id3 = $tab_id3 = $value->admincontent_id;
                                        if (empty($currenttabid)) {
                                            $currenttabid = $content_id3;
                                        }
                                    } else if ($value->name == 'core.html-block') {
                                        $content_id4 = $tab_id4 = $value->admincontent_id;
                                        if (empty($currenttabid)) {
                                            $currenttabid = $content_id4;
                                        }
                                    }
                                }
                            }
                            if (!empty($contentbusiness_id)) {
                                $contentinfo = Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->getContentByWidgetName('core.container-tabs', $contentbusiness_id);
                                if (empty($contentinfo)) {
                                    $contentinformation = 0;
                                } else {
                                    $contentinformation = 1;
                                }

                                $contentwidgetinfo = Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->getContentByWidgetName('sitebusiness.widgetlinks-sitebusiness', $contentbusiness_id);
                                if (empty($contentwidgetinfo)) {
                                    $widgetinformation = 0;
                                } else {
                                    $widgetinformation = 1;
                                }
                            }
                            $default_content_id = Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->getContentId($contentbusiness_id, $sitebusiness);
                            $tempcontent_name = $default_content_id['content_name'];
                            $tempcontent_id = $default_content_id['content_id'];
                            if (empty($default_content_id['itemAlbumCount'])) {
                                $itemAlbumCount = 10;
                            } else {
                                $itemAlbumCount = $default_content_id['itemAlbumCount'];
                            }
                            if (empty($default_content_id['itemPhotoCount'])) {
                                $itemPhotoCount = 100;
                            } else {
                                $itemPhotoCount = $default_content_id['itemPhotoCount'];
                            }
                            if (empty($default_content_id['resource_type_integration'])) {
                                $resource_type_integration = Zend_Controller_Front::getInstance()->getRequest()->getParam('resource_type', 0);
                                $ads_display_integration = Engine_Api::_()->getApi('settings', 'core')->getSetting("sitebusiness.ad.$resource_type_integration", 3);
                            } else {
                                $resource_type_integration = $default_content_id['resource_type_integration'];
                                $ads_display_integration = $default_content_id['ads_display_integration'];
                            }

                            $newtabid = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab', $tempcontent_id);
                            $tab_main = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab', null);
                            if ($tab_main) {
                                $tempcontent_name = Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->getCurrentTabName($tab_main);
                                $tempcontent_id = $tab_main;
                            }
                        }
                    } else {
                        $table = Engine_Api::_()->getDbtable('pages', 'core');
                        $select = $table->select()
                                ->where('name = ?', 'sitebusiness_index_view')
                                ->limit(1);
                        $row = $table->fetchRow($select);
                        if ($row !== null) {
                            $business_id = $row->page_id;
                            $table = Engine_Api::_()->getDbtable('content', 'core');
                            $select = $table->select()
                                    ->where("name IN ('sitebusiness.info-sitebusiness', 'seaocore.feed', 'advancedactivity.home-feeds', 'activity.feed', 'sitebusiness.location-sitebusiness', 'core.profile-links', 'core.html-block')")
                                    ->where('page_id = ?', $business_id)
                                    ->order('content_id ASC');
                            $rowinfo = $table->fetchAll($select);
                            if (!empty($rowinfo)) {
                                foreach ($rowinfo as $key => $value) {
                                    if ($value->name == 'advancedactivity.home-feeds') {
                                        $content_id = $tab_id = $value->content_id;
                                        if (empty($currenttabid)) {
                                            $currenttabid = $content_id;
                                        }
                                    } elseif ($value->name == 'seaocore.feed') {
                                        $content_id = $tab_id = $value->content_id;
                                        if (empty($currenttabid)) {
                                            $currenttabid = $content_id;
                                        }
                                    } elseif ($value->name == 'activity.feed') {
                                        $content_id = $tab_id = $value->content_id;
                                        if (empty($currenttabid)) {
                                            $currenttabid = $content_id;
                                        }
                                    } else if ($value->name == 'core.profile-links') {
                                        $content_id3 = $tab_id3 = $value->content_id;
                                        if (empty($currenttabid)) {
                                            $currenttabid = $content_id3;
                                        }
                                    } else if ($value->name == 'core.html-block') {
                                        $content_id4 = $tab_id4 = $value->content_id;
                                        if (empty($currenttabid)) {
                                            $currenttabid = $content_id4;
                                        }
                                    }
                                }
                            }
                        }

                        $table = Engine_Api::_()->getDbtable('content', 'core');
                        $tablename = $table->info('name');
                        if (!empty($business_id)) {
                            $selectContent = $table->select()
                                    ->from($tablename)
                                    ->where('name =?', 'core.container-tabs')
                                    ->where('page_id =?', $business_id)
                                    ->limit(1);
                            $contentinfo = $selectContent->query()->fetchAll();
                            if (empty($contentinfo)) {
                                $contentinformation = 0;
                            } else {
                                $contentinformation = 1;
                            }
                        }

                        if (!empty($business_id)) {
                            $selectContent = $table->select()
                                    ->from($tablename)
                                    ->where('name =?', 'sitebusiness.widgetlinks-sitebusiness')
                                    ->where('page_id =?', $business_id)
                                    ->limit(1);
                            $contentwidgetinfo = $selectContent->query()->fetchAll();
                            if (empty($contentwidgetinfo)) {
                                $widgetinformation = 0;
                            } else {
                                $widgetinformation = 1;
                            }
                        }

                        $selectBusiness = Engine_Api::_()->sitebusiness()->getWidgetizedBusiness();
                        if (!empty($selectBusiness)) {
                            $businessid = $selectBusiness->page_id;
                            if (!empty($businessid)) {
                                $tableCore = Engine_Api::_()->getDbtable('content', 'core');
                                $select = $tableCore->select();
                                $select_content = $select
                                        ->from($tableCore->info('name'))
                                        ->where('page_id = ?', $businessid)
                                        ->where('type = ?', 'container')
                                        ->where('name = ?', 'main')
                                        ->limit(1);
                                $content = $select_content->query()->fetchAll();
                                if (!empty($content)) {
                                    $select = $tableCore->select();
                                    $select_container = $select
                                            ->from($tableCore->info('name'), array('content_id'))
                                            ->where('page_id = ?', $businessid)
                                            ->where('type = ?', 'container')
                                            ->where('name = ?', 'middle')
                                            ->where('parent_content_id = ?', $content[0]['content_id'])
                                            ->limit(1);
                                    $container = $select_container->query()->fetchAll();
                                    if (!empty($container)) {
                                        $select = $tableCore->select();
                                        $container_id = $container[0]['content_id'];
                                        $select_middle = $select
                                                ->from($tableCore->info('name'))
                                                ->where('parent_content_id = ?', $container_id)
                                                ->where('type = ?', 'widget')
                                                ->where('name = ?', 'core.container-tabs')
                                                ->where('page_id = ?', $businessid)
                                                ->limit(1);
                                        $middle = $select_middle->query()->fetchAll();
                                        if (!empty($middle)) {
                                            $content_id = $middle[0]['content_id'];
                                        } else {
                                            $content_id = $container_id;
                                        }
                                    }
                                }

                                if (!empty($content_id) && !empty($sitebusiness)) {
                                    $select = $tableCore->select();
                                    $select_middle = $select
                                            ->from($tableCore->info('name'), array('content_id', 'name', 'params'))
                                            ->where('parent_content_id = ?', $content_id)
                                            ->where('type = ?', 'widget')
                                            ->where("name NOT IN ('sitebusiness.title-sitebusiness', 'seaocore.like-button','seaocore.seaocore-follow', 'sitebusiness.photorecent-sitebusiness', 'Facebookse.facebookse-commonlike', 'sitebusiness.thumbphoto-sitebusiness', 'sitebusiness.contactdetails-sitebusiness','sitelike.common-like-button')")
                                            ->where('page_id = ?', $businessid);

                                    $middle = $select_middle->query()->fetchAll();

                                    $itemAlbumCount = 10;
                                    $itemPhotoCount = 100;
                                    $select = $tableCore->select();
                                    $select_photo = $select
                                            ->from($tableCore->info('name'), array('params'))
                                            ->where('parent_content_id = ?', $content_id)
                                            ->where('type = ?', 'widget')
                                            ->where('name = ?', 'sitebusiness.photos-sitebusiness')
                                            ->where('page_id = ?', $businessid)
                                            ->order('order DESC');

                                    $middlePhoto = $select_photo->query()->fetchColumn();
                                    if (!empty($middlePhoto)) {
                                        $photoParamsDecodedArray = Zend_Json_Decoder::decode($middlePhoto);
                                        if (isset($photoParamsDecodedArray['itemCount']) && !empty($photoParamsDecodedArray)) {
                                            $itemAlbumCount = $photoParamsDecodedArray['itemCount'];
                                        }
                                        if (isset($photoParamsDecodedArray['itemCount_photo']) && !empty($photoParamsDecodedArray)) {
                                            $itemPhotoCount = $photoParamsDecodedArray['itemCount_photo'];
                                        }
                                    }

                                    $flag = false;
                                    $editpermission = '';
                                    $isManageAdmin = '';
                                    $resource_type_integration = Zend_Controller_Front::getInstance()->getRequest()->getParam('resource_type', 0);
                                    $ads_display_integration = Engine_Api::_()->getApi('settings', 'core')->getSetting("sitebusiness.ad.$resource_type_integration", 3);
                                    $viewer = Engine_Api::_()->user()->getViewer();
                                    $viewer_id = $viewer->getIdentity();
                                    if (!empty($viewer_id)) {
                                        $level_id = $viewer->level_id;
                                    } else {
                                        $level_id = 0;
                                    }
                                    foreach ($middle as $value) {
                                        $content_name = $value['name'];
                                        switch ($content_name) {
                                            case 'sitebusiness.overview-sitebusiness':
                                                if (!empty($sitebusiness)) {
                                                    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'overview');
                                                    if (!empty($isManageAdmin)) {
                                                        $editpermission = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
                                                        if (!empty($editpermission) && empty($sitebusiness->overview)) {
                                                            $flag = true;
                                                        } elseif (empty($editpermission) && empty($sitebusiness->overview)) {
                                                            $flag = false;
                                                        } elseif (!empty($editpermission) && !empty($sitebusiness->overview)) {
                                                            $flag = true;
                                                        } elseif (empty($editpermission) && !empty($sitebusiness->overview)) {
                                                            $flag = true;
                                                        }
                                                    }
                                                }
                                                break;
                                            case 'sitebusiness.location-sitebusiness':
                                                if (!empty($sitebusiness)) {
                                                    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'map');
                                                    if (!empty($isManageAdmin)) {
                                                        $value['id'] = $sitebusiness->getIdentity();
                                                        $location = Engine_Api::_()->getDbtable('locations', 'sitebusiness')->getLocation($value);
                                                        if (!empty($location)) {
                                                            $flag = true;
                                                        }
                                                    }
                                                }
                                                break;
                                            case 'seaocore.feed':
                                                $flag = true;
                                                break;
                                            case 'advancedactivity.home-feeds':
                                                $flag = true;
                                                break;
                                            case 'activity.feed':
                                                $flag = true;
                                                break;
                                            case 'sitebusiness.info-sitebusiness':
                                                $flag = true;
                                                break;
                                            case 'core.html-block':
                                                $flag = true;
                                                break;
                                            case 'core.profile-links':
                                                $flag = true;
                                                break;
                                            case 'sitebusinessintegration.profile-items':
                                                if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessintegration')) {
                                                    $content_params = $value['params'];
                                                    $paramsDecodedArray = Zend_Json_Decoder::decode($content_params);
                                                    $resource_type_integration = $paramsDecodedArray['resource_type'];
                                                    $ads_display_integration = Engine_Api::_()->getApi('settings', 'core')->getSetting("sitebusiness.ad.$resource_type_integration", 3);

                                                    if (Zend_Controller_Front::getInstance()->getRequest()->getParam('resource_type', 0)) {
                                                        $resource_type_integration = Zend_Controller_Front::getInstance()->getRequest()->getParam('resource_type', 0);
                                                        $ads_display_integration = Engine_Api::_()->getApi('settings', 'core')->getSetting("sitebusiness.ad.$resource_type_integration", 3);
                                                    }
                                                    //PACKAGE BASE AND MEMBER LEVEL SETTINGS PRIYACY START
                                                    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
                                                        if (Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", $resource_type_integration)) {
                                                            $flag = true;
                                                        }
                                                    } else {
                                                        $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, $resource_type_integration);
                                                        if (!empty($isBusinessOwnerAllow)) {
                                                            $flag = true;
                                                        }
                                                    }
                                                    $resource_type = $resource_type_integration;

                                                    $pieces = explode("_", $resource_type);
                                                    if ($resource_type == 'document_0' || $resource_type == 'folder_0' || $resource_type == 'quiz_0') {
                                                        $paramsIntegration['listingtype_id'] = $listingTypeId = $pieces[1];
                                                        $paramsIntegration['resource_type'] = $resource_type = $pieces[0];
                                                    } else {
                                                        $paramsIntegration['listingtype_id'] = $listingTypeId = $pieces[2];
                                                        $paramsIntegration['resource_type'] = $resource_type = $pieces[0] . '_' . $pieces[1];
                                                    }

                                                    $paramsIntegration['business_id'] = $sitebusiness->business_id;
                                                    $paginator = Engine_Api::_()->getDbtable('contents', 'sitebusinessintegration')->getResults($paramsIntegration);
                                                    if ($paginator->getTotalItemCount() <= 0) {
                                                        $flag = false;
                                                    } else {
                                                        $flag = true;
                                                    }
                                                    //PACKAGE BASE AND MEMBER LEVEL SETTINGS PRIYACY END
                                                }
                                                break;
                                            case 'sitebusinessnote.profile-sitebusinessnotes':
                                                if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessnote')) {
                                                    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
                                                        if (Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessnote") == 1) {
                                                            $flag = true;
                                                        }
                                                    } else {
                                                        $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'sncreate');
                                                        if (!empty($isBusinessOwnerAllow)) {
                                                            $flag = true;
                                                        }
                                                    }
                                                    //TOTAL NOTES
                                                    $noteCount = Engine_Api::_()->sitebusiness()->getTotalCount($sitebusiness->business_id, 'sitebusinessnote', 'notes');
                                                    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'sncreate');
                                                    if (!empty($isManageAdmin) || !empty($noteCount)) {
                                                        $flag = true;
                                                    } else {
                                                        $flag = false;
                                                    }
                                                }
                                                break;
                                            case 'sitebusinessevent.profile-sitebusinessevents':
                                                if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessevent')) {
                                                    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
                                                        if (Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessevent") == 1) {
                                                            $flag = true;
                                                        }
                                                    } else {
                                                        $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'secreate');
                                                        if (!empty($isBusinessOwnerAllow)) {
                                                            $flag = true;
                                                        }
                                                    }
                                                    //TOTAL EVENTS
                                                    $eventCount = Engine_Api::_()->sitebusiness()->getTotalCount($sitebusiness->business_id, 'sitebusinessevent', 'events');
                                                    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'secreate');
                                                    if (!empty($isManageAdmin) || !empty($eventCount)) {
                                                        $flag = true;
                                                    } else {
                                                        $flag = false;
                                                    }
                                                }
                                                break;
                                            case 'siteevent.contenttype-events':
                                                if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('siteevent')) {
                                                    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
                                                        if (Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessevent") == 1) {
                                                            $flag = true;
                                                        }
                                                    } else {
                                                        $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'secreate');
                                                        if (!empty($isBusinessOwnerAllow)) {
                                                            $flag = true;
                                                        }
                                                    }
                                                    //TOTAL EVENTS
                                                    $eventCount = Engine_Api::_()->sitebusiness()->getTotalCount($sitebusiness->business_id, 'siteevent', 'events');
                                                    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'secreate');
                                                    if (!empty($isManageAdmin) || !empty($eventCount)) {
                                                        $flag = true;
                                                    } else {
                                                        $flag = false;
                                                    }
                                                }
                                                break;
                                            case 'document.contenttype-documents':
                                                if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('document')) {
                                                    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
                                                        if (Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessdocument") == 1) {
                                                            $flag = true;
                                                        }
                                                    } else {
                                                        $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'sdcreate');
                                                        if (!empty($isBusinessOwnerAllow)) {
                                                            $flag = true;
                                                        }
                                                    }
                                                    
                                                    $documentCount = Engine_Api::_()->sitebusiness()->getTotalCount($sitebusiness->business_id, 'document', 'documents');
                                                    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'sdcreate');
                                                    if (!empty($isManageAdmin) || !empty($documentCount)) {
                                                        $flag = true;
                                                    } else {
                                                        $flag = false;
                                                    }
                                                }
                                                break;
                                            case 'sitevideo.contenttype-videos':
                                                if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitevideo')) {
                                                    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
                                                        if (Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessvideo") == 1) {
                                                            $flag = true;
                                                        }
                                                    } else {
                                                        $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'svcreate');
                                                        if (!empty($isBusinessOwnerAllow)) {
                                                            $flag = true;
                                                        }
                                                    }
                                                    //TOTAL videoS
                                                    $videoCount = Engine_Api::_()->sitebusiness()->getTotalCount($sitebusiness->business_id, 'sitevideo', 'videos');
                                                    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'svcreate');
                                                    if (!empty($isManageAdmin) || !empty($videoCount)) {
                                                        $flag = true;
                                                    } else {
                                                        $flag = false;
                                                    }
                                                }
                                                break;
                                            case 'sitebusiness.discussion-sitebusiness':
                                                if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessdiscussion')) {
                                                    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
                                                        if (Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessdiscussion") == 1) {
                                                            $flag = true;
                                                        }
                                                    } else {
                                                        $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'sdicreate');
                                                        if (!empty($isBusinessOwnerAllow)) {
                                                            $flag = true;
                                                        }
                                                    }
                                                    //TOTAL TOPICS
                                                    $topicCount = Engine_Api::_()->sitebusiness()->getTotalCount($sitebusiness->business_id, 'sitebusiness', 'topics');
                                                    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'sdicreate');
                                                    if (!empty($isManageAdmin) || !empty($topicCount)) {
                                                        $flag = true;
                                                    } else {
                                                        $flag = false;
                                                    }
                                                }
                                                break;
                                            case 'sitebusiness.photos-sitebusiness':
                                                if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessalbum')) {
                                                    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
                                                        if (Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessalbum") == 1) {
                                                            $flag = true;
                                                        }
                                                    } else {
                                                        $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'spcreate');
                                                        if (!empty($isBusinessOwnerAllow)) {
                                                            $flag = true;
                                                        }
                                                    }
                                                    //TOTAL ALBUMS
                                                    $albumCount = Engine_Api::_()->sitebusiness()->getTotalCount($sitebusiness->business_id, 'sitebusiness', 'albums');
                                                    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'spcreate');
                                                    if (!empty($isManageAdmin) || !empty($albumCount)) {
                                                        $flag = true;
                                                    } else {
                                                        $flag = false;
                                                    }
                                                }
                                                break;
                                            case 'sitebusinessmusic.profile-sitebusinessmusic':
                                                if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmusic')) {
                                                    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
                                                        if (Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessmusic") == 1) {
                                                            $flag = true;
                                                        }
                                                    } else {
                                                        $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'smcreate');
                                                        if (!empty($isBusinessOwnerAllow)) {
                                                            $flag = true;
                                                        }
                                                    }
                                                    //TOTAL PLAYLISTS
                                                    $musicCount = Engine_Api::_()->sitebusiness()->getTotalCount($sitebusiness->business_id, 'sitebusinessmusic', 'playlists');
                                                    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'smcreate');
                                                    if (!empty($isManageAdmin) || !empty($musicCount)) {
                                                        $flag = true;
                                                    } else {
                                                        $flag = false;
                                                    }
                                                }
                                                break;

                                            case 'sitebusinessmember.profile-sitebusinessmembers':
                                                if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember')) {
                                                    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
                                                        if (Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessmember") == 1) {
                                                            $flag = true;
                                                        }
                                                    } else {
                                                        $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'smecreate');
                                                        if (!empty($isBusinessOwnerAllow)) {
                                                            $flag = true;
                                                        }
                                                    }
                                                    //TOTAL PLAYLISTS
                                                    $memberCount = Engine_Api::_()->sitebusiness()->getTotalCount($sitebusiness->business_id, 'sitebusiness', 'membership');
                                                    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'smecreate');
                                                    if (!empty($isManageAdmin) || !empty($memberCount)) {
                                                        $flag = true;
                                                    } else {
                                                        $flag = false;
                                                    }
                                                }
                                                break;

                                            case 'sitebusinessdocument.profile-sitebusinessdocuments':
                                                if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessdocument')) {
                                                    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
                                                        if (Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessdocument") == 1) {
                                                            $flag = true;
                                                        }
                                                    } else {
                                                        $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'sdcreate');
                                                        if (!empty($isBusinessOwnerAllow)) {
                                                            $flag = true;
                                                        }
                                                    }
                                                    //TOTAL DOCUMENTS
                                                    $documentCount = Engine_Api::_()->sitebusiness()->getTotalCount($sitebusiness->business_id, 'sitebusinessdocument', 'documents');
                                                    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'sdcreate');
                                                    if (!empty($isManageAdmin) || !empty($documentCount)) {
                                                        $flag = true;
                                                    } else {
                                                        $flag = false;
                                                    }
                                                }
                                                break;
                                            case 'sitebusinessreview.profile-sitebusinessreviews':
                                                if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessreview')) {
                                                    //TOTAL REVIEW
                                                    $reviewCount = Engine_Api::_()->sitebusiness()->getTotalCount($sitebusiness->business_id, 'sitebusinessreview', 'reviews');
                                                    $level_allow = Engine_Api::_()->authorization()->getPermission($level_id, 'sitebusinessreview_review', 'create');
                                                    if (!empty($level_allow) || !empty($reviewCount)) {
                                                        $flag = true;
                                                    } else {
                                                        $flag = false;
                                                    }
                                                }
                                                break;
                                            case 'sitebusinessvideo.profile-sitebusinessvideos':
                                                if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessvideo')) {
                                                    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
                                                        if (Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessvideo") == 1) {
                                                            $flag = true;
                                                        }
                                                    } else {
                                                        $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'svcreate');
                                                        if (!empty($isBusinessOwnerAllow)) {
                                                            $flag = true;
                                                        }
                                                    }
                                                    //TOTAL VIDEO
                                                    $videoCount = Engine_Api::_()->sitebusiness()->getTotalCount($sitebusiness->business_id, 'sitebusinessvideo', 'videos');
                                                    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'svcreate');
                                                    if (!empty($isManageAdmin) || !empty($videoCount)) {
                                                        $flag = true;
                                                    } else {
                                                        $flag = false;
                                                    }
                                                }
                                                break;
                                            case 'sitebusinesspoll.profile-sitebusinesspolls':
                                                if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinesspoll')) {
                                                    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
                                                        if (Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinesspoll") == 1) {
                                                            $flag = true;
                                                        }
                                                    } else {
                                                        $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'splcreate');
                                                        if (!empty($isBusinessOwnerAllow)) {
                                                            $flag = true;
                                                        }
                                                    }
                                                    //TOTAL POLL
                                                    $pollCount = Engine_Api::_()->sitebusiness()->getTotalCount($sitebusiness->business_id, 'sitebusinesspoll', 'polls');
                                                    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'splcreate');
                                                    if (!empty($isManageAdmin) || !empty($pollCount)) {
                                                        $flag = true;
                                                    } else {
                                                        $flag = false;
                                                    }
                                                }
                                                break;
                                            case 'sitebusinessoffer.profile-sitebusinessoffers':
                                                if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessoffer')) {
                                                    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
                                                        if (Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessoffer") == 1) {
                                                            $flag = true;
                                                        }
                                                    } else {
                                                        $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'offer');
                                                        if (!empty($isBusinessOwnerAllow)) {
                                                            $flag = true;
                                                        }
                                                    }
                                                    //TOTAL OFFERS
                                                    $can_edit = 1;
                                                    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
                                                    if (empty($isManageAdmin)) {
                                                        $can_edit = 0;
                                                    }

                                                    $can_offer = 1;
                                                    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'offer');

                                                    if (empty($isManageAdmin)) {
                                                        $can_offer = 0;
                                                    }

                                                    $can_create_offer = '';

                                                    //OFFER CREATION AUTHENTICATION CHECK
                                                    if ($can_edit == 1 && $can_offer == 1) {
                                                        $can_create_offer = 1;
                                                    }

                                                    //TOTAL OFFER
                                                    $offerCount = Engine_Api::_()->sitebusiness()->getTotalCount($sitebusiness->business_id, 'sitebusinessoffer', 'offers');
                                                    if (!empty($can_create_offer) || !empty($offerCount)) {
                                                        $flag = true;
                                                    } else {
                                                        $flag = false;
                                                    }
                                                }
                                                break;
                                            case 'sitebusinessform.sitebusiness-viewform':
                                                if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessform')) {
                                                    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
                                                        if (Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessform") == 1) {
                                                            $flag = true;
                                                        }
                                                    } else {
                                                        $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'form');
                                                        if (!empty($isBusinessOwnerAllow)) {
                                                            $flag = true;
                                                        }
                                                    }
                                                }
                                                break;
                                            case 'sitebusinesstwitter.feeds-sitebusinesstwitter':
                                                if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinesstwitter')) {
                                                    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'twitter');
                                                    if (!empty($isManageAdmin)) {
                                                        $flag = true;
                                                    }
                                                }
                                                break;

                                            case 'sitecontentcoverphoto.content-cover-photo':
                                                $flag = true;
                                                break;
                                        }
                                        if (!empty($flag)) {
                                            $content_ids = $value['content_id'];
                                            $content_names = $value['name'];
                                            break;
                                        }
                                    }
                                }

                                $params = array('content_id' => $content_ids, 'content_name' => $content_names);

                                $tempcontent_name = $params['content_name'];
                                $tempcontent_id = $params['content_id'];

                                $newtabid = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab', $tempcontent_id);

                                //////////////////////
                                if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember')) {
                                    $select = $tableCore->select();
                                    $select_member = $select
                                            ->from($tableCore->info('name'), array('params'))
                                            ->where('content_id = ?', $newtabid)
                                            ->where('type = ?', 'widget')
                                            ->where('name = ?', 'sitebusinessmember.profile-sitebusinessmembers');
                                    $member_params = $select_member->query()->fetchColumn(); //print_R($member_params);die;
                                    if (!empty($member_params)) {
                                        $photoParamsDecodedArray = Zend_Json_Decoder::decode($member_params);
                                        if (isset($photoParamsDecodedArray['show_option']) && !empty($photoParamsDecodedArray)) {
                                            $show_option = $photoParamsDecodedArray['show_option'];
                                        } else {
                                            $show_option = 1;
                                        }
                                        if (isset($photoParamsDecodedArray['membercategory_id']) && !empty($photoParamsDecodedArray)) {
                                            $membercategory_id = $photoParamsDecodedArray['membercategory_id'];
                                            $membercategory_ids = json_encode($membercategory_id);
                                        }
                                    } else {
                                        $show_option = 1;
                                        $membercategory_ids = null;
                                    }
                                }
                                //////////

                                $tab_main = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab', null);
                                if ($tab_main) {
                                    $current_tab_name = $tableCore->select()
                                            ->from($tableCore->info('name'), array('name'))
                                            ->where('content_id = ?', $tab_main)
                                            ->query()
                                            ->fetchColumn();
                                    $tempcontent_name = $current_tab_name;
                                    $tempcontent_id = $tab_main;
                                }
                            }
                        }
                    }

                    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('communityad') && !empty($contentinfo)) {
                        $business_communityads = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.communityads', 1);
                    } else {
                        $business_communityads = 0;
                    }

                    $siteinfo = $view->layout()->siteinfo;
                    if (!empty($sitebusiness)) {
                        if ($sitebusiness->category_id) {
                            $row = Engine_Api::_()->getDbTable('categories', 'sitebusiness')->getCategory($sitebusiness->category_id);
                            if (!empty($row->category_name)) {
                                $category_name = $row->category_name;
                                $siteinfo['keywords'] = $category_name;
                            }
                            $row = Engine_Api::_()->getDbTable('categories', 'sitebusiness')->getCategory($sitebusiness->subcategory_id);
                            if (!empty($row->category_name)) {
                                $subcategory_name = $row->category_name;
                                $siteinfo['keywords'] .= ',' . $subcategory_name;
                            }
                        }
                        if (!empty($sitebusiness->location)) {
                            $siteinfo['keywords'] .= ',' . $sitebusiness->location;
                        }
                    }
                    $script = null;
                    $view->layout()->siteinfo = $siteinfo;
                    $is_ajax = Zend_Controller_Front::getInstance()->getRequest()->getParam('isajax', null);
                    if (empty($is_ajax)) {
                        $routeStartS = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.manifestUrlS', "businessitem");
                        $business_url_integration = $routeStartS . '/' . Engine_Api::_()->sitebusiness()->getBusinessUrl($sitebusiness->business_id);
                        $overview = $view->translate('Overview');
                        $form = $view->translate('Form');
                        $review = $view->translate('Reviews');
                        $document = $view->translate('Documents');
                        $offer = $view->translate('Offers');
                        $poll = $view->translate('Polls');
                        $event = $view->translate('Events');
                        $note = $view->translate('Notes');
                        $photo = $view->translate('Photos');
                        $discussion = $view->translate('Discussions');
                        $map = $view->translate('Map');
                        $link = $view->translate('Links');
                        $video = $view->translate('Videos');
                        $music = $view->translate('Music');
                        $member = $view->translate('Member');
                        $business_url = Engine_Api::_()->sitebusiness()->getBusinessUrl($sitebusiness->business_id);
                        $script = <<<EOF
      var sitebusiness_layout_setting = '$sitebusiness_layout_setting';
	    var business_communityads = '$business_communityads';
	    var contentinformation = '$contentinformation';
      var business_hide_left_container = '$sitebusiness_hide_left_container';
      var sitebusiness_slding_effect = '$sitebusiness_slding_effect';
	    var business_showtitle = 0;
	    var prev_tab_class = '';
	    if(contentinformation == 0) {
	      business_showtitle = 1;
	    }
      window.addEvent('domready', function() {
        var globalContentElement = en4.seaocore.getDomElements('content');
	    	if($('main_tabs')) {
					switch ("$tempcontent_name") {
            case 'sitebusiness.photos-sitebusiness':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {
		            ShowContent('$tempcontent_id', execute_Request_Photo, '$tempcontent_id', 'photo', 'sitebusiness', 'photos-sitebusiness', business_showtitle, 'null', photo_ads_display, business_communityad_integration, adwithoutpackage,$itemAlbumCount, $itemPhotoCount);
						  	if($(globalContentElement).getElement('.layout_sitebusiness_photos_sitebusiness')) {
									hideLeftContainer (photo_ads_display, business_communityad_integration, adwithoutpackage);
							  }

                prev_tab_id = "$newtabid";
                prev_tab_class = 'layout_sitebusiness_photos_sitebusiness';
								business_showtitle = 0;
                if($('main_tabs').getElement('.tab_layout_sitebusiness_photos_sitebusiness')) {
                  tabContainerSwitch($('main_tabs').getElement('.tab_layout_sitebusiness_photos_sitebusiness'));
                }
							}
            break;
            case 'sitebusinessvideo.profile-sitebusinessvideos':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {
		            ShowContent('$tempcontent_id', execute_Request_Video, '$tempcontent_id', 'video', 'sitebusinessvideo', 'profile-sitebusinessvideos', business_showtitle, 'null', video_ads_display, business_communityad_integration,adwithoutpackage);
						  	if($(globalContentElement).getElement('.layout_sitebusinessvideo_profile_sitebusinessvideos')) {
									hideLeftContainer (video_ads_display, business_communityad_integration, adwithoutpackage);
							  }

                prev_tab_id = "$newtabid";
                prev_tab_class = 'layout_sitebusinessvideo_profile_sitebusinessvideos';
								business_showtitle = 0;
                if($('main_tabs').getElement('.tab_layout_sitebusinessvideo_profile_sitebusinessvideos')) {
                  tabContainerSwitch($('main_tabs').getElement('.tab_layout_sitebusinessvideo_profile_sitebusinessvideos'));
                }
							}
            break;
            case 'sitebusinessnote.profile-sitebusinessnotes':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {
		            ShowContent('$tempcontent_id', execute_Request_Note, '$tempcontent_id', 'note', 'sitebusinessnote', 'profile-sitebusinessnotes', business_showtitle, 'null', note_ads_display, business_communityad_integration,adwithoutpackage);
						  	if($(globalContentElement).getElement('.layout_sitebusinessnote_profile_sitebusinessnotes')) {
									hideLeftContainer (note_ads_display, business_communityad_integration, adwithoutpackage);
							  }

                prev_tab_id = "$newtabid";
                prev_tab_class = 'layout_sitebusinessnote_profile_sitebusinessnotes';
								business_showtitle = 0;
                if($('main_tabs').getElement('.tab_layout_sitebusinessnote_profile_sitebusinessnotes')) {
                  tabContainerSwitch($('main_tabs').getElement('.tab_layout_sitebusinessnote_profile_sitebusinessnotes'));
                }
							}
            break;
            case 'sitebusinessreview.profile-sitebusinessreviews':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {
		            ShowContent('$tempcontent_id', execute_Request_Review, '$tempcontent_id', 'review', 'sitebusinessreview', 'profile-sitebusinessreviews', business_showtitle,'$business_url', review_ads_display, business_communityad_integration,adwithoutpackage);
						  	if($(globalContentElement).getElement('.layout_sitebusinessreview_profile_sitebusinessreviews')) {
									hideLeftContainer (review_ads_display, business_communityad_integration, adwithoutpackage);
							  }

                prev_tab_id = "$newtabid";
                prev_tab_class = 'layout_sitebusinessreview_profile_sitebusinessreviews';
								business_showtitle = 0;
                if($('main_tabs').getElement('.tab_layout_sitebusinessreview_profile_sitebusinessreviews')) {
                  tabContainerSwitch($('main_tabs').getElement('.tab_layout_sitebusinessreview_profile_sitebusinessreviews'));
                }
							}
            break;
            case 'sitebusinessform.sitebusiness-viewform':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {
		            ShowContent('$tempcontent_id', execute_Request_Form, '$tempcontent_id', 'form', 'sitebusinessform', 'sitebusiness-viewform', business_showtitle, '$business_url', form_ads_display, business_communityad_integration,adwithoutpackage);
						  	if($(globalContentElement).getElement('.layout_sitebusinessform_sitebusiness_viewform')) {
									hideLeftContainer (form_ads_display, business_communityad_integration, adwithoutpackage);
							  }

                prev_tab_id = "$newtabid";
                prev_tab_class = 'layout_sitebusinessform_sitebusiness_viewform';
								business_showtitle = 0;
                if($('main_tabs').getElement('.tab_layout_sitebusinessform_sitebusiness_viewform')) {
                  tabContainerSwitch($('main_tabs').getElement('.tab_layout_sitebusinessform_sitebusiness_viewform'));
                }
							}
            break;
            case 'sitebusinessdocument.profile-sitebusinessdocuments':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {
		            ShowContent('$tempcontent_id', execute_Request_Document, '$tempcontent_id', 'document', 'sitebusinessdocument', 'profile-sitebusinessdocuments', business_showtitle, 'null', document_ads_display, business_communityad_integration,adwithoutpackage);
						  	if($(globalContentElement).getElement('.layout_sitebusinessdocument_profile_sitebusinessdocuments')) {
									hideLeftContainer (document_ads_display, business_communityad_integration, adwithoutpackage);
							  }

                prev_tab_id = "$newtabid";
                prev_tab_class = 'layout_sitebusinessdocument_profile_sitebusinessdocuments';
								business_showtitle = 0;
                if($('main_tabs').getElement('.tab_layout_sitebusinessdocument_profile_sitebusinessdocuments')) {
                  tabContainerSwitch($('main_tabs').getElement('.tab_layout_sitebusinessdocument_profile_sitebusinessdocuments'));
                }
							}
            break;
            case 'sitebusinessevent.profile-sitebusinessevents':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {
		            ShowContent('$tempcontent_id', execute_Request_Event, '$tempcontent_id', 'event', 'sitebusinessevent', 'profile-sitebusinessevents', business_showtitle,'null', event_ads_display, business_communityad_integration,adwithoutpackage);
						  	if($(globalContentElement).getElement('.layout_sitebusinessevent_profile_sitebusinessevents')) {
									hideLeftContainer (event_ads_display, business_communityad_integration, adwithoutpackage);
							  }

                prev_tab_id = "$newtabid";
                prev_tab_class = 'layout_sitebusinessevent_profile_sitebusinessevents';            
								business_showtitle = 0;
                if($('main_tabs').getElement('.tab_layout_sitebusinessevent_profile_sitebusinessevents')) {
                  tabContainerSwitch($('main_tabs').getElement('.tab_layout_sitebusinessevent_profile_sitebusinessevents'));
                }
							}
            break;
            case 'siteevent.contenttype-events':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {
		            ShowContent('$tempcontent_id', execute_Request_Event, '$tempcontent_id', 'event', 'siteevent', 'contenttype-events', page_showtitle,'null', event_ads_display, page_communityad_integration,adwithoutpackage);
						  	if($(globalContentElement).getElement('.layout_siteevent_contenttype_events')) {
									hideLeftContainer (event_ads_display, page_communityad_integration, adwithoutpackage);
							  }

                prev_tab_id = "$newtabid";
                prev_tab_class = 'layout_siteevent_contenttype_events';            
								page_showtitle = 0;
                if($('main_tabs').getElement('.tab_layout_siteevent_contenttype_events')) {
                  tabContainerSwitch($('main_tabs').getElement('.tab_layout_siteevent_contenttype_events'));
                }
							}
            break;
            case 'sitebusinesspoll.profile-sitebusinesspolls':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {
		            ShowContent('$tempcontent_id', execute_Request_Poll, '$tempcontent_id', 'poll', 'sitebusinesspoll', 'profile-sitebusinesspolls', business_showtitle,'null', poll_ads_display, business_communityad_integration,adwithoutpackage);
						  	if($(globalContentElement).getElement('.layout_sitebusinesspoll_profile_sitebusinesspolls')) {
									hideLeftContainer (poll_ads_display, business_communityad_integration, adwithoutpackage);
							  }

                prev_tab_id = "$newtabid";
                prev_tab_class = 'layout_sitebusinesspoll_profile_sitebusinesspolls';            
								business_showtitle = 0;
                if($('main_tabs').getElement('.tab_layout_sitebusinesspoll_profile_sitebusinesspolls')) {
                  tabContainerSwitch($('main_tabs').getElement('.tab_layout_sitebusinesspoll_profile_sitebusinesspolls'));
                }
							}
            break;
            case 'sitebusinessmusic.profile-sitebusinessmusic':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {
		            ShowContent('$tempcontent_id', execute_Request_Music, '$tempcontent_id', 'music', 'sitebusinessmusic', 'profile-sitebusinessmusic', business_showtitle,'null', music_ads_display, business_communityad_integration,adwithoutpackage);
						  	if($(globalContentElement).getElement('.layout_sitebusinessmusic_profile_sitebusinessmusic')) {
									hideLeftContainer (music_ads_display, business_communityad_integration, adwithoutpackage);
							  }

                prev_tab_id = "$newtabid";
                prev_tab_class = 'layout_sitebusinessmusic_profile_sitebusinessmusic';            
								business_showtitle = 0;
                if($('main_tabs').getElement('.tab_layout_sitebusinessmusic_profile_sitebusinessmusic')) {
                  tabContainerSwitch($('main_tabs').getElement('.tab_layout_sitebusinessmusic_profile_sitebusinessmusic'));
                }
							}
            break;
            
            case 'sitebusinessmember.profile-sitebusinessmembers':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {
		            ShowContent('$tempcontent_id', execute_Request_Member, '$tempcontent_id', 'member', 'sitebusinessmember', 'profile-sitebusinessmembers', business_showtitle,'null', member_ads_display, business_communityad_integration,adwithoutpackage, 'null', 'null', 'null', 'null', 'null', 'null', 'null','$show_option', '$membercategory_ids', '1');
						  	if($(globalContentElement).getElement('.layout_sitebusinessmember_profile_sitebusinessmember')) {
									hideLeftContainer (member_ads_display, business_communityad_integration, adwithoutpackage);
							  }

                prev_tab_id = "$newtabid";
                prev_tab_class = 'layout_sitebusinessmember_profile_sitebusinessmember';            
								business_showtitle = 0;
                if($('main_tabs').getElement('.tab_layout_sitebusinessmember_profile_sitebusinessmember')) {
                  tabContainerSwitch($('main_tabs').getElement('.tab_layout_sitebusinessmember_profile_sitebusinessmember'));
                }
							}
            break;
            
            case 'sitebusinessoffer.profile-sitebusinessoffers':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {
		            ShowContent('$tempcontent_id', execute_Request_Offer, '$tempcontent_id', 'offer', 'sitebusinessoffer', 'profile-sitebusinessoffers', business_showtitle,'null', offer_ads_display, business_communityad_integration,adwithoutpackage);
						  	if($(globalContentElement).getElement('.layout_sitebusinessoffer_profile_sitebusinessoffers')) {
									hideLeftContainer (offer_ads_display, business_communityad_integration, adwithoutpackage);
							  }

                prev_tab_id = "$newtabid";
                prev_tab_class = 'layout_sitebusinessoffer_profile_sitebusinessoffers';
								business_showtitle = 0;
                if($('main_tabs').getElement('.tab_layout_sitebusinessoffer_profile_sitebusinessoffers')) {
                  tabContainerSwitch($('main_tabs').getElement('.tab_layout_sitebusinessoffer_profile_sitebusinessoffers'));
                }
							}
            break;
            case 'sitebusiness.discussion-sitebusiness':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {
		            ShowContent('$tempcontent_id', execute_Request_Discusssion, '$tempcontent_id', 'discussion', 'sitebusiness', 'discussion-sitebusiness', business_showtitle, 'null', discussion_ads_display, business_communityad_integration,adwithoutpackage);
						  	if($(globalContentElement).getElement('.layout_sitebusiness_discussion_sitebusiness')) {
									hideLeftContainer (discussion_ads_display, business_communityad_integration, adwithoutpackage);
							  }

                prev_tab_id = "$newtabid";
                prev_tab_class = 'layout_sitebusiness_discussion_sitebusiness';
                business_showtitle = 0;
                if($('main_tabs').getElement('.tab_layout_sitebusiness_discussion_sitebusiness')) {
                  tabContainerSwitch($('main_tabs').getElement('.tab_layout_sitebusiness_discussion_sitebusiness'));
                }
							}
            break;
            case 'sitebusiness.overview-sitebusiness':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {
                hideLeftContainer (overview_ads_display, business_communityad_integration, adwithoutpackage);
                prev_tab_id = "$newtabid";
                prev_tab_class = 'layout_sitebusiness_overview_sitebusiness';
          
                business_showtitle = 0;
                if($('main_tabs').getElement('.tab_layout_sitebusiness_overview_sitebusiness')) {
                  tabContainerSwitch($('main_tabs').getElement('.tab_layout_sitebusiness_overview_sitebusiness'));
                }
							}
            break;
            case 'core.profile-links':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {

                if($('main_tabs').getElement('.tab_layout_core_profile_links')) {
                  tabContainerSwitch($('main_tabs').getElement('.tab_layout_core_profile_links'));
                }
								business_showtitle = 0;
                prev_tab_id = "$newtabid";
                prev_tab_class = 'layout_core_profile_links';
							}
            break;
            case 'sitebusiness.location-sitebusiness':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {
      					hideLeftContainer (location_ads_display, business_communityad_integration, adwithoutpackage);

                if($('main_tabs').getElement('.tab_layout_sitebusiness_location_sitebusiness')) {
                  tabContainerSwitch($('main_tabs').getElement('.tab_layout_sitebusiness_location_sitebusiness'));
                }
								business_showtitle = 0;
                prev_tab_id = "$newtabid";
                prev_tab_class = 'layout_sitebusiness_location_sitebusiness';
							}
            break;
            case 'sitebusiness.info-sitebusiness':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {
								business_showtitle = 0;
                prev_tab_id = "$newtabid";
                prev_tab_class = 'layout_sitebusiness_info_sitebusiness';
                if($('main_tabs').getElement('.tab_layout_sitebusiness_info_sitebusiness')) {
                  tabContainerSwitch($('main_tabs').getElement('.tab_layout_sitebusiness_info_sitebusiness'));
                }
							}
            break;
          case 'sitebusinessintegration.profile-items':       
             if(is_ajax_divhide == '' && "$tab_main" == '') {
               if($newtabid == "$tempcontent_id" && $newtabid != 0) {                
                ShowContent('$tempcontent_id', execute_Request_$resource_type_integration, '$tempcontent_id', 'null', 'sitebusinessintegration', 'profile-items', business_showtitle, '$business_url_integration', $ads_display_integration, business_communityad_integration,
  adwithoutpackage, null,null,'$resource_type_integration', null, 1);
                  prev_tab_id = "$newtabid";
                  prev_tab_class = 'layout_sitebusinessintegration_profile_items';
                  if($(globalContentElement).getElement('.layout_sitebusinessintegration_profile_items')) {
                    $(globalContentElement).getElement('.layout_sitebusinessintegration_profile_items').style.display = 'block';
                  }
               }
             }
            break;
            case 'sitebusinesstwitter.feeds-sitebusinesstwitter':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {
								business_showtitle = 0;
                prev_tab_id = "$newtabid";
                prev_tab_class = 'layout_sitebusinesstwitter_feeds_sitebusinesstwitter';
                if($('main_tabs').getElement('.tab_layout_sitebusinesstwitter_feeds_sitebusinesstwitter')) {
                  tabContainerSwitch($('main_tabs').getElement('.tab_layout_sitebusinesstwitter_feeds_sitebusinesstwitter'));
                }
							}
            break;  
            case 'core.html-block':
              tabContainerSwitch($('main_tabs').getElement('.tab_layout_core_html_block'));
              break;
            case 'activity.feed':
              tabContainerSwitch($('main_tabs').getElement('.tab_layout_activity_feed'));
              break;
            case 'seaocore.feed':
              tabContainerSwitch($('main_tabs').getElement('.tab_layout_seaocore_feed'));
              break;
            case 'advancedactivity.home-feeds':
              tabContainerSwitch($('main_tabs').getElement('.tab_layout_advancedactivity_home_feeds'));
              break;
					 }
			    if($('main_tabs').getElement('.tab_$tab_id')){
			      $('main_tabs').getElement('.tab_$tab_id').addEvent('click', function() {

            if($(globalContentElement).getElement('.layout_seaocore_feed')) {
							$(globalContentElement).getElement('.layout_seaocore_feed').id = "layout_seaocore_feed";
							scrollToTopForBusiness($('layout_seaocore_feed'));
            } else if($(globalContentElement).getElement('.layout_activity_feed')) {
							$(globalContentElement).getElement('.layout_activity_feed').id = "layout_activity_feed";
							scrollToTopForBusiness($('layout_activity_feed'));
            } else if($(globalContentElement).getElement('.layout_advancedactivity_home_feeds')) {
							$(globalContentElement).getElement('.layout_advancedactivity_home_feeds').id = "layout_advancedactivity_home_feeds";
							scrollToTopForBusiness($('layout_advancedactivity_home_feeds'));
            }
			      if($('profile_status')) {
			        $('profile_status').innerHTML = "<h2>$sitebusiness_title</h2>";
            }
            if($('main_tabs').getElement('.tab_layout_activity_feed')) {
              tabContainerSwitch($('main_tabs').getElement('.tab_layout_activity_feed'));
            }

						setLeftLayoutForBusiness();
			      prev_tab_id = '$tab_id';

					});
				  }          
          
          if($('main_tabs').getElement('.tab_$tab_id3')){
			      $('main_tabs').getElement('.tab_$tab_id3').addEvent('click', function() {
            if($('main_tabs').getElement('.tab_layout_core_profile_links')) {
              tabContainerSwitch($('main_tabs').getElement('.tab_layout_core_profile_links'));
            }

			      prev_tab_id = '$tab_id3';
						setLeftLayoutForBusiness();
            });
				  }
          if($('main_tabs').getElement('.tab_$tab_id4')){
			      $('main_tabs').getElement('.tab_$tab_id4').addEvent('click', function() {
//             if($('main_tabs').getElement('.tab_layout_core_html_block')) {
//               tabContainerSwitch($('main_tabs').getElement('.tab_layout_core_html_block'));
//             }

			      prev_tab_id = '$tab_id4';
						setLeftLayoutForBusiness();
            });
				  }
				}
				else
	      {          
	       switch ("$tempcontent_name") {
            case 'sitebusiness.photos-sitebusiness':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {
                if($('profile_status')) {
		    			    $('profile_status').innerHTML = "<h2>$sitebusiness_title &raquo; $photo </h2>";
								}
								$(globalContentElement).getElement('.layout_sitebusiness_photos_sitebusiness > h3').innerHTML = "<div class='layout_simple_head'>$sitebusiness_title's  $photo</div>";
		            ShowContent('$tempcontent_id', execute_Request_Photo, '$tempcontent_id', 'photo', 'sitebusiness', 'photos-sitebusiness', business_showtitle, 'null', photo_ads_display, business_communityad_integration, adwithoutpackage,$itemAlbumCount, $itemPhotoCount);
						  	if($(globalContentElement).getElement('.layout_sitebusiness_photos_sitebusiness')) {
									$(globalContentElement).getElement('.layout_sitebusiness_photos_sitebusiness').style.display = 'block';
									prev_tab_id = "$newtabid";
									prev_tab_class = 'layout_sitebusiness_photos_sitebusiness';
							  }
							  hideWidgets();
							}
            break;
            case 'sitebusinessvideo.profile-sitebusinessvideos':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {
                if($('profile_status')) {
		    			    $('profile_status').innerHTML = "<h2>$sitebusiness_title &raquo; $video </h2>";
								}
								$(globalContentElement).getElement('.layout_sitebusinessvideo_profile_sitebusinessvideos > h3').innerHTML = "<div class='layout_simple_head'>$sitebusiness_title's  $video</div>";
		            ShowContent('$tempcontent_id', execute_Request_Video, '$tempcontent_id', 'video', 'sitebusinessvideo', 'profile-sitebusinessvideos', business_showtitle, 'null', video_ads_display, business_communityad_integration,adwithoutpackage);
						  	if($(globalContentElement).getElement('.layout_sitebusinessvideo_profile_sitebusinessvideos')) {
									$(globalContentElement).getElement('.layout_sitebusinessvideo_profile_sitebusinessvideos').style.display = 'block';
									prev_tab_id = "$newtabid";
									prev_tab_class = 'layout_sitebusinessvideo_profile_sitebusinessvideos';
							  }
								hideWidgets();
							}
            break;
            case 'sitebusinessnote.profile-sitebusinessnotes':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {
                if($('profile_status')) {
		    			    $('profile_status').innerHTML = "<h2>$sitebusiness_title &raquo; $note </h2>";
								}
								$(globalContentElement).getElement('.layout_sitebusinessnote_profile_sitebusinessnotes > h3').innerHTML = "<div class='layout_simple_head'>$sitebusiness_title's  $note</div>";
		            ShowContent('$tempcontent_id', execute_Request_Note, '$tempcontent_id', 'note', 'sitebusinessnote', 'profile-sitebusinessnotes', business_showtitle, 'null', note_ads_display, business_communityad_integration,adwithoutpackage);
						  	if($(globalContentElement).getElement('.layout_sitebusinessnote_profile_sitebusinessnotes')) {
									$(globalContentElement).getElement('.layout_sitebusinessnote_profile_sitebusinessnotes').style.display = 'block';
									prev_tab_id = "$newtabid";
									prev_tab_class = 'layout_sitebusinessnote_profile_sitebusinessnotes';
							  }
								hideWidgets();
							}
            break;
            case 'sitebusinessreview.profile-sitebusinessreviews':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {
                if($('profile_status')) {
		    			    $('profile_status').innerHTML = "<h2>$sitebusiness_title &raquo; $review </h2>";
								}
								$(globalContentElement).getElement('.layout_sitebusinessreview_profile_sitebusinessreviews > h3').innerHTML = "<div class='layout_simple_head'>$sitebusiness_title's  $review </div>";
		            ShowContent('$tempcontent_id', execute_Request_Review, '$tempcontent_id', 'review', 'sitebusinessreview', 'profile-sitebusinessreviews', business_showtitle,'null', review_ads_display, business_communityad_integration,adwithoutpackage);
						  	if($(globalContentElement).getElement('.layout_sitebusinessreview_profile_sitebusinessreviews')) {
									$(globalContentElement).getElement('.layout_sitebusinessreview_profile_sitebusinessreviews').style.display = 'block';
									prev_tab_id = "$newtabid";
									prev_tab_class = 'layout_sitebusinessreview_profile_sitebusinessreviews';
							  }
								hideWidgets();
							}
            break;
            case 'sitebusinessform.sitebusiness-viewform':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {
                if($('profile_status')) {
		    			    $('profile_status').innerHTML = "<h2>$sitebusiness_title &raquo; $form </h2>";
								}
								$(globalContentElement).getElement('.layout_sitebusinessform_sitebusiness_viewform > h3').innerHTML = "<div class='layout_simple_head'>$sitebusiness_title's  $form </div>";
		            ShowContent('$tempcontent_id', execute_Request_Form, '$tempcontent_id', 'form', 'sitebusinessform', 'sitebusiness-viewform', business_showtitle, '$business_url', form_ads_display, business_communityad_integration,adwithoutpackage);
						  	if($(globalContentElement).getElement('.layout_sitebusinessform_sitebusiness_viewform')) {
									$(globalContentElement).getElement('.layout_sitebusinessform_sitebusiness_viewform').style.display = 'block';
									prev_tab_id = "$newtabid";
									prev_tab_class = 'layout_sitebusinessform_sitebusiness_viewform';
							  }
								hideWidgets();
							}
            break;
            case 'sitebusinessdocument.profile-sitebusinessdocuments':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {
                if($('profile_status')) {
		    			    $('profile_status').innerHTML = "<h2>$sitebusiness_title &raquo; $document </h2>";
								}
								$(globalContentElement).getElement('.layout_sitebusinessdocument_profile_sitebusinessdocuments > h3').innerHTML = "<div class='layout_simple_head'>$sitebusiness_title's  $document </div>";
		            ShowContent('$tempcontent_id', execute_Request_Document, '$tempcontent_id', 'document', 'sitebusinessdocument', 'profile-sitebusinessdocuments', business_showtitle, 'null', document_ads_display, business_communityad_integration,adwithoutpackage);
						  	if($(globalContentElement).getElement('.layout_sitebusinessdocument_profile_sitebusinessdocuments')) {
									$(globalContentElement).getElement('.layout_sitebusinessdocument_profile_sitebusinessdocuments').style.display = 'block';
									prev_tab_id = "$newtabid";
									prev_tab_class = 'layout_sitebusinessdocument_profile_sitebusinessdocuments';
							  }
								hideWidgets();
							}
            break;
            case 'sitebusinessevent.profile-sitebusinessevents':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {
                if($('profile_status')) {
		    			    $('profile_status').innerHTML = "<h2>$sitebusiness_title &raquo; $event </h2>";
								}
								$(globalContentElement).getElement('.layout_sitebusinessevent_profile_sitebusinessevents > h3').innerHTML = "<div class='layout_simple_head'>$sitebusiness_title's  $event </div>";
		            ShowContent('$tempcontent_id', execute_Request_Event, '$tempcontent_id', 'event', 'sitebusinessevent', 'profile-sitebusinessevents', business_showtitle,'null', event_ads_display, business_communityad_integration,adwithoutpackage);
						  	if($(globalContentElement).getElement('.layout_sitebusinessevent_profile_sitebusinessevents')) {
									$(globalContentElement).getElement('.layout_sitebusinessevent_profile_sitebusinessevents').style.display = 'block';
									prev_tab_id = "$newtabid";
									prev_tab_class = 'layout_sitebusinessevent_profile_sitebusinessevents';
							  }
								hideWidgets();
							}
            break;
            case 'sitebusinesspoll.profile-sitebusinesspolls':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {
                if($('profile_status')) {
		    			    $('profile_status').innerHTML = "<h2>$sitebusiness_title &raquo; $poll </h2>";
								}
								$(globalContentElement).getElement('.layout_sitebusinesspoll_profile_sitebusinesspolls > h3').innerHTML = "<div class='layout_simple_head'>$sitebusiness_title's  $poll </div>";
		            ShowContent('$tempcontent_id', execute_Request_Poll, '$tempcontent_id', 'poll', 'sitebusinesspoll', 'profile-sitebusinesspolls', business_showtitle,'null', poll_ads_display, business_communityad_integration,adwithoutpackage);
						  	if($(globalContentElement).getElement('.layout_sitebusinesspoll_profile_sitebusinesspolls')) {
									$(globalContentElement).getElement('.layout_sitebusinesspoll_profile_sitebusinesspolls').style.display = 'block';
									prev_tab_id = "$newtabid";
									prev_tab_class = 'layout_sitebusinesspoll_profile_sitebusinesspolls';
							  }
								hideWidgets();
							}
            break;
            case 'sitebusinessmusic.profile-sitebusinessmusic':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {
                if($('profile_status')) {
		    			    $('profile_status').innerHTML = "<h2>$sitebusiness_title &raquo; $music </h2>";
								}
								$(globalContentElement).getElement('.layout_sitebusinessmusic_profile_sitebusinessmusic > h3').innerHTML = "<div class='layout_simple_head'>$sitebusiness_title's  $music </div>";
		            ShowContent('$tempcontent_id', execute_Request_Music, '$tempcontent_id', 'music', 'sitebusinessmusic', 'profile-sitebusinessmusic', business_showtitle,'null', music_ads_display, business_communityad_integration,adwithoutpackage);
						  	if($(globalContentElement).getElement('.layout_sitebusinessmusic_profile_sitebusinessmusic')) {
									$(globalContentElement).getElement('.layout_sitebusinessmusic_profile_sitebusinessmusic').style.display = 'block';
									prev_tab_id = "$newtabid";
									prev_tab_class = 'layout_sitebusinessmusic_profile_sitebusinessmusic';
							  }
								hideWidgets();
							}
            break;
            
            case 'sitebusinessmember.profile-sitebusinessmembers':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {
                if($('profile_status')) {
		    			    $('profile_status').innerHTML = "<h2>$sitebusiness_title &raquo; $member </h2>";
								}
								$(globalContentElement).getElement('.layout_sitebusinessmember_profile_sitebusinessmember > h3').innerHTML = "<div class='layout_simple_head'>$sitebusiness_title's  $member </div>";
		            ShowContent('$tempcontent_id', execute_Request_Member, '$tempcontent_id', 'member', 'sitebusinessmember', 'profile-sitebusinessmembers', business_showtitle,'null', member_ads_display, business_communityad_integration,adwithoutpackage,'null', 'null', 'null', 'null', 'null', 'null', 'null','$show_option', '$membercategory_ids', '1');
						  	if($(globalContentElement).getElement('.layout_sitebusinessmember_profile_sitebusinessmember')) {
									$(globalContentElement).getElement('.layout_sitebusinessmember_profile_sitebusinessmember').style.display = 'block';
									prev_tab_id = "$newtabid";
									prev_tab_class = 'layout_sitebusinessmember_profile_sitebusinessmember';
							  }
								hideWidgets();
							}
            break;
            
            
            case 'sitebusinessoffer.profile-sitebusinessoffers':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {
                if($('profile_status')) {
		    			    $('profile_status').innerHTML = "<h2>$sitebusiness_title &raquo; $offer </h2>";
								}
								$(globalContentElement).getElement('.layout_sitebusinessoffer_profile_sitebusinessoffers > h3').innerHTML = "<div class='layout_simple_head'>$sitebusiness_title's  $offer </div>";
		            ShowContent('$tempcontent_id', execute_Request_Offer, '$tempcontent_id', 'offer', 'sitebusinessoffer', 'profile-sitebusinessoffers', business_showtitle,'null', offer_ads_display, business_communityad_integration,adwithoutpackage);
						  	if($(globalContentElement).getElement('.layout_sitebusinessoffer_profile_sitebusinessoffers')) {
									$(globalContentElement).getElement('.layout_sitebusinessoffer_profile_sitebusinessoffers').style.display = 'block';
									prev_tab_id = "$newtabid";
									prev_tab_class = 'layout_sitebusinessoffer_profile_sitebusinessoffers';
							  }
								hideWidgets();
							}
            break;
            case 'sitebusiness.discussion-sitebusiness':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {
		            ShowContent('$tempcontent_id', execute_Request_Discusssion, '$tempcontent_id', 'discussion', 'sitebusiness', 'discussion-sitebusiness', business_showtitle, 'null', discussion_ads_display, business_communityad_integration,adwithoutpackage);
		            if($('profile_status')) {
		    			    $('profile_status').innerHTML = "<h2>$sitebusiness_title &raquo; $discussion </h2>";
								}
								$(globalContentElement).getElement('.layout_sitebusiness_discussion_sitebusiness > h3').innerHTML = "<div class='layout_simple_head'>$sitebusiness_title's  $discussion </div>";
						  	if($(globalContentElement).getElement('.layout_sitebusiness_discussion_sitebusiness')) {
									$(globalContentElement).getElement('.layout_sitebusiness_discussion_sitebusiness').style.display = 'block';
									prev_tab_id = "$newtabid";
									prev_tab_class = 'layout_sitebusiness_discussion_sitebusiness';
							  }
								hideWidgets();
							}
            break;
            case 'sitebusiness.overview-sitebusiness':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {

                if($('profile_status')) {
		    			    $('profile_status').innerHTML = "<h2>$sitebusiness_title &raquo; $overview </h2>";
								}
								$(globalContentElement).getElement('.layout_sitebusiness_overview_sitebusiness > h3').innerHTML = "<div class='layout_simple_head'>$sitebusiness_title's  $overview</div>";

						    if($(globalContentElement).getElement('.layout_sitebusiness_overview_sitebusiness')) {
									 $(globalContentElement).getElement('.layout_sitebusiness_overview_sitebusiness').style.display = 'block';
									 prev_tab_id = "$newtabid";
									 prev_tab_class = 'layout_sitebusiness_overview_sitebusiness';
							  }
								hideWidgetsForModule('sitebusinessoverview');
							}
            break;
            case 'core.profile-links':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {
                if($('profile_status')) {
		    			    $('profile_status').innerHTML = "<h2>$sitebusiness_title &raquo; $link </h2>";
								}
								$(globalContentElement).getElement('.layout_core_profile_links > h3').innerHTML = "<div class='layout_simple_head'>$sitebusiness_title's  $link</div>";
                hideWidgetsForModule('sitebusinesslink');
							}
            break;
            case 'sitebusiness.location-sitebusiness':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {
                if($('profile_status')) {
		    			    $('profile_status').innerHTML = "<h2>$sitebusiness_title &raquo; $map </h2>";
								}
								$(globalContentElement).getElement('.layout_sitebusiness_location_sitebusiness > h3').innerHTML = "<div class='layout_simple_head'>$sitebusiness_title's $map</div>";
						    if($(globalContentElement).getElement('.layout_sitebusiness_location_sitebusiness')) {
									 $(globalContentElement).getElement('.layout_sitebusiness_location_sitebusiness').style.display = 'block';
									 prev_tab_id = "$newtabid";
									 prev_tab_class = 'layout_sitebusiness_location_sitebusiness';
							  }
								hideWidgetsForModule('sitebusinesslocation');
							}
            break;
            case 'sitebusinessintegration.profile-items':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {                
                ShowContent('$tempcontent_id', execute_Request_$resource_type_integration, '$tempcontent_id', 'null', 'sitebusinessintegration', 'profile-items', business_showtitle, '$business_url_integration', $ads_display_integration, business_communityad_integration,
  adwithoutpackage, null,null,'$resource_type_integration', null, 1);
                  prev_tab_id = "$newtabid";
                  prev_tab_class = 'layout_sitebusinessintegration_profile_items';
                  if($(globalContentElement).getElement('.layout_sitebusinessintegration_profile_items')) {
                    $(globalContentElement).getElement('.layout_sitebusinessintegration_profile_items').style.display = 'block';
                  }
                 hideWidgetsForModule('sitebusinessintegration');
               }
            break;          
            case 'activity.feed':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {
						    hideWidgetsForModule('sitebusinessactivityfeed');

							}
            break;
           case 'seaocore.feed':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {
                hideWidgetsForModule('sitebusinesseseaocoreactivityfeed');

								if($(globalContentElement).getElement('.layout_sitebusiness_business_cover_information_sitebusiness')) { 	                            $(globalContentElement).getElement('.layout_sitebusiness_business_cover_information_sitebusiness').style.display = 'block';
								}
								if($(globalContentElement).getElement('.layout_sitecontentcoverphoto_content_cover_photo')) { 	                            $(globalContentElement).getElement('.layout_sitecontentcoverphoto_content_cover_photo').style.display = 'block';
								}
		
								if($(globalContentElement).getElement('.layout_sitebusinessmember_businesscover_photo_sitebusinessmembers')) { 	                            	$(globalContentElement).getElement('.layout_sitebusinessmember_businesscover_photo_sitebusinessmembers').style.display = 'block';
								}
						  }
            break;
           case 'advancedactivity.home-feeds':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {
                hideWidgetsForModule('sitebusinessadvancedactivityactivityfeed');
	
						  }
            break;            
            case 'sitebusiness.info-sitebusiness':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {
						    hideWidgetsForModule('sitebusinessinfo');

							}
            break;
            case 'sitebusinesstwitter.feeds-sitebusinesstwitter':
              if($newtabid == "$tempcontent_id" && $newtabid != 0) {
						    hideWidgetsForModule('sitebusinesstwitter');

							}
            break;
					}
				  if($widgetinformation == 0) {
				    if($(globalContentElement).getElement('.layout_sitebusiness_location_sitebusiness')) {
							$(globalContentElement).getElement('.layout_sitebusiness_location_sitebusiness').style.display = 'block';
						}
						if($(globalContentElement).getElement('.layout_sitebusiness_info_sitebusiness')) {
							$(globalContentElement).getElement('.layout_sitebusiness_info_sitebusiness').style.display = 'block';
						}

						if($(globalContentElement).getElement('.layout_sitebusiness_business_cover_information_sitebusiness')) { 	                            $(globalContentElement).getElement('.layout_sitebusiness_business_cover_information_sitebusiness').style.display = 'block';
					}
 							if($(globalContentElement).getElement('.layout_sitecontentcoverphoto_content_cover_photo')) { 	                            $(globalContentElement).getElement('.layout_sitecontentcoverphoto_content_cover_photo').style.display = 'block';
								}
		
						if($(globalContentElement).getElement('.layout_sitebusinessmember_businesscover_photo_sitebusinessmembers')) { 	                            $(globalContentElement).getElement('.layout_sitebusinessmember_businesscover_photo_sitebusinessmembers').style.display = 'block';
					}
						if($(globalContentElement).getElement('.layout_core_profile_links')) {
							$(globalContentElement).getElement('.layout_core_profile_links').style.display = 'block';
						}
					}

    			$$('.tab_$tab_id').addEvent('click', function() {
    			  if($('profile_status')) {
    			    $('profile_status').innerHTML = "<h2>$sitebusiness_title</h2>";
						}
						if($(globalContentElement).getElement('.layout_sitebusiness_location_sitebusiness')) {
							$(globalContentElement).getElement('.layout_sitebusiness_location_sitebusiness').style.display = 'none';
						}
            if($(globalContentElement).getElement('.layout_sitebusiness_photos_sitebusiness')) {
					    $(globalContentElement).getElement('.layout_sitebusiness_photos_sitebusiness').style.display = 'none';
            }
            if($(globalContentElement).getElement('.layout_sitebusinessvideo_profile_sitebusinessvideos')) {
					    $(globalContentElement).getElement('.layout_sitebusinessvideo_profile_sitebusinessvideos').style.display = 'none';
            }
            if($(globalContentElement).getElement('.layout_sitebusiness_discussion_sitebusiness')) {
					    $(globalContentElement).getElement('.layout_sitebusiness_discussion_sitebusiness').style.display = 'none';
            }
            if($(globalContentElement).getElement('.layout_sitebusinessoffer_profile_sitebusinessoffers')) {
					    $(globalContentElement).getElement('.layout_sitebusinessoffer_profile_sitebusinessoffers').style.display = 'none';
            }
            if($(globalContentElement).getElement('.layout_sitebusinessdocument_profile_sitebusinessdocuments')) {
					    $(globalContentElement).getElement('.layout_sitebusinessdocument_profile_sitebusinessdocuments').style.display = 'none';
            }
            if($(globalContentElement).getElement('.layout_sitebusinessreview_profile_sitebusinessreviews')) {
					    $(globalContentElement).getElement('.layout_sitebusinessreview_profile_sitebusinessreviews').style.display = 'none';
            }
            if($(globalContentElement).getElement('.layout_sitebusinesspoll_profile_sitebusinesspolls')) {
					    $(globalContentElement).getElement('.layout_sitebusinesspoll_profile_sitebusinesspolls').style.display = 'none';
            }
            if($(globalContentElement).getElement('.layout_sitebusinessnote_profile_sitebusinessnotes')) {
					    $(globalContentElement).getElement('.layout_sitebusinessnote_profile_sitebusinessnotes').style.display = 'none';
            }
            if($(globalContentElement).getElement('.layout_sitebusinessevent_profile_sitebusinessevents')) {
					    $(globalContentElement).getElement('.layout_sitebusinessevent_profile_sitebusinessevents').style.display = 'none';
            }
            if($(globalContentElement).getElement('.layout_siteevent_contenttype_events')) {
					    $(globalContentElement).getElement('.layout_siteevent_contenttype_events').style.display = 'none';
            }
            if($(globalContentElement).getElement('.layout_sitebusinessintegration_profile_items')) {					    
              $$('.layout_sitebusinessintegration_profile_items').setStyle('display', 'none');
            } 
            if($(globalContentElement).getElement('.layout_sitebusinessintegration_profile_items')) {
					    $(globalContentElement).getElement('.layout_sitebusinessintegration_profile_items').style.display = 'none';
            }
            if($(globalContentElement).getElement('.layout_sitebusinessmusic_profile_sitebusinessmusic')) {
					    $(globalContentElement).getElement('.layout_sitebusinessmusic_profile_sitebusinessmusic').style.display = 'none';
            }
      			if($(globalContentElement).getElement('.layout_sitebusinessform_sitebusiness_viewform')) {
						  $(globalContentElement).getElement('.layout_sitebusinessform_sitebusiness_viewform').style.display = 'none';
            }
						if($(globalContentElement).getElement('.layout_core_profile_links')) {
							$(globalContentElement).getElement('.layout_core_profile_links').style.display = 'none';
						}
						if($(globalContentElement).getElement('.layout_sitebusiness_info_sitebusiness')) {
							$(globalContentElement).getElement('.layout_sitebusiness_info_sitebusiness').style.display = 'none';
						}
// 						if($(globalContentElement).getElement('.layout_sitebusinesstwitter_feeds_sitebusinesstwitter')) {
// 							$(globalContentElement).getElement('.layout_sitebusinesstwitter_feeds_sitebusinesstwitter').style.display = 'none';
// 						}
						if($(globalContentElement).getElement('.layout_sitebusiness_overview_sitebusiness')) {
							$(globalContentElement).getElement('.layout_sitebusiness_overview_sitebusiness').style.display = 'none';
					  }
						if($(globalContentElement).getElement('.layout_activity_feed')) {
							$(globalContentElement).getElement('.layout_activity_feed').style.display = 'block';
						}
        	  if($(globalContentElement).getElement('.layout_seaocore_feed')) {
							$(globalContentElement).getElement('.layout_seaocore_feed').style.display = 'block';
						}
            if($(globalContentElement).getElement('.layout_advancedactivity_home_feeds')) {
							$(globalContentElement).getElement('.layout_advancedactivity_home_feeds').style.display = 'block';
						}

						setLeftLayoutForBusiness();
            if($(globalContentElement).getElement('.layout_seaocore_feed')) {
							$(globalContentElement).getElement('.layout_seaocore_feed').id = "layout_seaocore_feed";
							scrollToTopForBusiness($('layout_seaocore_feed'));
            } else if($(globalContentElement).getElement('.layout_activity_feed')) {
							$(globalContentElement).getElement('.layout_activity_feed').id = "layout_activity_feed";
							scrollToTopForBusiness($('layout_activity_feed'));
            } else if($(globalContentElement).getElement('.layout_advancedactivity_home_feeds')) {
							$(globalContentElement).getElement('.layout_advancedactivity_home_feeds').id = "layout_advancedactivity_home_feeds";
							scrollToTopForBusiness($('layout_advancedactivity_home_feeds'));
            }


//				    if ($('id_' + prev_tab_id) != null && prev_tab_id != 0 && prev_tab_id != '$tab_id') {
//				      $('id_' + prev_tab_id).style.display = "none";
//				    }
			    prev_tab_id = '$tab_id';
				 });

  			$$('.tab_$tab_id3').addEvent('click', function() {
  			  if($('profile_status')) {
  			    $('profile_status').innerHTML = "<h2>$sitebusiness_title &raquo; $link </h2>";
					}
					$(globalContentElement).getElement('.layout_core_profile_links > h3').innerHTML = "<div class='layout_simple_head'>$sitebusiness_title's $link</div>";

					if($(globalContentElement).getElement('.layout_sitebusiness_location_sitebusiness')) {
						$(globalContentElement).getElement('.layout_sitebusiness_location_sitebusiness').style.display = 'none';
					}
					if($(globalContentElement).getElement('.layout_core_profile_links')) {
						$(globalContentElement).getElement('.layout_core_profile_links').style.display = 'block';
					}
					if($(globalContentElement).getElement('.layout_sitebusiness_info_sitebusiness')) {
						$(globalContentElement).getElement('.layout_sitebusiness_info_sitebusiness').style.display = 'none';
					}

					if($(globalContentElement).getElement('.layout_activity_feed')) {
						$(globalContentElement).getElement('.layout_activity_feed').style.display = 'none';
					}
        	if($(globalContentElement).getElement('.layout_seaocore_feed')) {
						$(globalContentElement).getElement('.layout_seaocore_feed').style.display = 'none';
					}
          if($(globalContentElement).getElement('.layout_advancedactivity_home_feeds')) {
					 	$(globalContentElement).getElement('.layout_advancedactivity_home_feeds').style.display = 'none';
					}
					if($(globalContentElement).getElement('.layout_sitebusiness_overview_sitebusiness')) {
						$(globalContentElement).getElement('.layout_sitebusiness_overview_sitebusiness').style.display = 'none';
				  }
			    if ($('id_' + prev_tab_id) != null && prev_tab_id != 0 && prev_tab_id != '$tab_id3') {
			      $('id_' + prev_tab_id).style.display = "none";
			    }
		    prev_tab_id = '$tab_id3';
		 	});        
     
          
     }
	 });
// 	 window.addEvent('domready', function() {
// 
//       if($('thumb_icon')) {
// 	      if($currenttabid == 0) {
// 	       $('thumb_icon').style.display = 'none';
// 			  }
// 	    }
// 		});
EOF;
                    }
                    if ("$tempcontent_name" == 'sitebusiness.discussion-sitebusiness' || "$tempcontent_name" == 'sitebusiness.photos-sitebusiness' || "$tempcontent_name" == 'sitebusinessvideo.profile-sitebusinessvideos' || "$tempcontent_name" == 'sitebusinessnote.profile-sitebusinessnotes' || "$tempcontent_name" == 'sitebusinessreview.profile-sitebusinessreviews' || "$tempcontent_name" == 'sitebusinessform.sitebusiness-viewform' || "$tempcontent_name" == 'sitebusinessdocument.profile-sitebusinessdocuments' || "$tempcontent_name" == 'sitebusinessevent.profile-sitebusinessevents' || "$tempcontent_name" == 'sitebusinesspoll.profile-sitebusinesspolls' || "$tempcontent_name" == 'sitebusinessmusic.profile-sitebusinessmusic' || "$tempcontent_name" == 'sitebusinessmember.profile-sitebusinessmembers' || "$tempcontent_name" == 'sitebusinessoffer.profile-sitebusinessoffers' || "$tempcontent_name" == 'sitebusinesstwitter.feeds-sitebusinesstwitter' || "$tempcontent_name" == 'sitevent.contenttype-events') {
                        Engine_Api::_()->sitebusiness()->showAdWithPackage($sitebusiness);
                        $view->headScript()
                                ->appendFile($view->layout()->staticBaseUrl . 'application/modules/Sitebusiness/externals/scripts/hideWidgets.js');
                    }

                    $view->headScript()
                            ->appendFile($view->layout()->staticBaseUrl . 'application/modules/Sitebusiness/externals/scripts/hideTabs.js')
                            ->appendFile($view->layout()->staticBaseUrl . 'application/modules/Sitebusiness/externals/scripts/core.js');

                    $view->headScript()
                            ->appendScript("   var business_communityads = '$business_communityads';
	    var contentinformation = '$contentinformation';
	    var business_showtitle = 0;
	    var prev_tab_class = '';");
                    if (!empty($script)) {
                        $view->headScript()
                                ->appendScript($script);
                    }
                }
            }
        }
    }

    public function onStatistics($event) {
        $table = Engine_Api::_()->getDbTable('business', 'sitebusiness');
        $select = new Zend_Db_Select($table->getAdapter());
        $select->from($table->info('name'), 'COUNT(*) AS count');
        $event->addResponse($select->query()->fetchColumn(0), 'business');
    }

    public function onUserDeleteBefore($event) {
        $payload = $event->getPayload();

        if ($payload instanceof User_Model_User) {

            $user_id = $payload->getIdentity();

            //GET BUSINESS TABLE
            $sitebusinessTable = Engine_Api::_()->getDbtable('business', 'sitebusiness');

            Engine_Api::_()->getDbtable('claims', 'sitebusiness')->delete(array('user_id =?' => $user_id));

            Engine_Api::_()->getDbtable('listmemberclaims', 'sitebusiness')->delete(array('user_id = ?' => $user_id));

            Engine_Api::_()->getDbtable('manageadmins', 'sitebusiness')->delete(array('user_id = ?' => $user_id));

            //START ALBUM CODE
            $table = Engine_Api::_()->getItemTable('sitebusiness_photo');
            $select = $table->select()->where('user_id = ?', $user_id);
            $rows = $table->fetchAll($select);
            if (!empty($rows)) {
                foreach ($rows as $photo) {
                    $photo->delete();
                }
            }

            $table = Engine_Api::_()->getItemTable('sitebusiness_album');
            $select = $table->select()->where('owner_id = ?', $user_id);
            $rows = $table->fetchAll($select);
            if (!empty($rows)) {
                foreach ($rows as $album) {
                    $album->delete();
                }
            }
            //END ALBUM CODE
            //START DISUCSSION CODE
            $sitebusinessDiscussionEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessdiscussion');
            if ($sitebusinessDiscussionEnabled) {

                $table = Engine_Api::_()->getItemTable('sitebusiness_topic');
                $select = $table->select()->where('user_id = ?', $user_id);
                $rows = $table->fetchAll($select);
                if (!empty($rows)) {
                    foreach ($rows as $topic) {
                        $topic->delete();
                    }
                }

                $table = Engine_Api::_()->getItemTable('sitebusiness_post');
                $select = $table->select()->where('user_id = ?', $user_id);
                $rows = $table->fetchAll($select);
                if (!empty($rows)) {
                    foreach ($rows as $post) {
                        $post->delete();
                    }
                }

                Engine_Api::_()->getDbtable('topicwatches', 'sitebusiness')->delete(array('user_id = ?' => $user_id));
            }
            //END DISUCSSION CODE

            $sitebusinessSelect = $sitebusinessTable->select()->where('owner_id = ?', $user_id);

            foreach ($sitebusinessTable->fetchAll($sitebusinessSelect) as $sitebusiness) {
                Engine_Api::_()->sitebusiness()->onBusinessDelete($sitebusiness->business_id);
            }

            //LIKE COUNT DREASE FORM BUSINESS TABLE.
            $likesTable = Engine_Api::_()->getDbtable('likes', 'core');
            $likesTableSelect = $likesTable->select()->where('poster_id = ?', $payload->getIdentity())->Where('resource_type = ?', 'sitebusiness_business');
            $results = $likesTable->fetchAll($likesTableSelect);
            foreach ($results as $user) {
                $resource = Engine_Api::_()->getItem('sitebusiness_business', $user->resource_id);
                $resource->like_count--;
                $resource->save();
            }
        }
    }

    public function addActivity($event) {
        $payload = $event->getPayload();
        $subject = $payload['subject'];
        $object = $payload['object'];

        // Only for object=event
        if (strpos($payload['type'], 'like_') === false && $object instanceof Sitebusiness_Model_Business /* &&
          Engine_Api::_()->authorization()->context->isAllowed($object, 'member', 'view') */) {
            $event->addResponse(array(
                'type' => 'sitebusiness_business',
                'identity' => $object->getIdentity()
            ));
        }
    }

    public function getActivity($event) {
        // Detect viewer and subject
        $payload = $event->getPayload();
        $user = null;
        $subject = null;
        if ($payload instanceof User_Model_User) {
            $user = $payload;
        } else if (is_array($payload)) {
            if (isset($payload['for']) && $payload['for'] instanceof User_Model_User) {
                $user = $payload['for'];
            }
            if (isset($payload['about']) && $payload['about'] instanceof Core_Model_Item_Abstract) {
                $subject = $payload['about'];
            }
        }
        if (null === $user) {
            $viewer = Engine_Api::_()->user()->getViewer();
            if ($viewer->getIdentity()) {
                $user = $viewer;
            }
        }
        if (null === $subject && Engine_Api::_()->core()->hasSubject()) {
            $subject = Engine_Api::_()->core()->getSubject();
        }


        // Get like businesses
        if ($user && empty($subject)) {
            $settingsCoreApi = Engine_Api::_()->getApi('settings', 'core');
            if ($settingsCoreApi->sitebusiness_feed_type && $settingsCoreApi->sitebusiness_feed_onlyliked) {
                $data = Engine_Api::_()->sitebusiness()->getMemberLikeBusinessesOfIds($user);
                if (!empty($data) && is_array($data)) {
                    $event->addResponse(array(
                        'type' => 'sitebusiness_business',
                        'data' => $data,
                    ));
                }
            } else if (!$settingsCoreApi->sitebusiness_feed_onlyliked && Engine_Api::_()->hasModuleBootstrap('sitebusinessmember')) {
                $data = Engine_Api::_()->getDbtable('membership', 'sitebusiness')->getMembershipsOfIds($user);
                if (!empty($data) && is_array($data)) {
                    $event->addResponse(array(
                        'type' => 'sitebusiness_business',
                        'data' => $data,
                    ));
                }
            }
        } else if ($subject && ($subject->getType() == 'sitebusiness_business')) {
            $settingsCoreApi = Engine_Api::_()->getApi('settings', 'core');
            if ($settingsCoreApi->sitebusiness_feed_type || 1) {
                $event->addResponse(array(
                    'type' => 'sitebusiness_business',
                    'data' => array($subject->getIdentity()),
                ));
            }
        } else if ($subject && ($subject->getType() == 'user')) {
            if (Engine_Api::_()->hasModuleBootstrap('sitebusinessmember')) {
                $data = Engine_Api::_()->getDbtable('membership', 'sitebusiness')->getMembershipsOfIds($user);
            } else {
                $data = Engine_Api::_()->getApi('subCore', 'sitebusiness')->getMemberFeedsForBusinessOfIds($subject);
            }
            $event->addResponse(array(
                'type' => 'sitebusiness_business',
                'data' => $data,
            ));
        }
    }

    public function onActivityActionCreateAfter($event) {

        $payload = $event->getPayload();
        if ($payload->object_type == 'sitebusiness_business' && ($payload->getTypeInfo()->type == 'sitebusiness_post_self' || $payload->getTypeInfo()->type == 'sitebusiness_post') && Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('advancedactivity')) {

            $viewer = Engine_Api::_()->user()->getViewer();
            $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;

            $notidicationSettings = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.feed.type', 0);

            $business_id = $payload->getObject()->business_id;
            $user_id = $payload->getSubject()->user_id;

            $subject = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
            $owner = $subject->getOwner();

            $notifications = Engine_Api::_()->getDbtable('notifications', 'activity');

            //previous notification is delete.
            $notifications->delete(array('type =?' => "sitebusiness_notificationpost", 'object_type = ?' => "sitebusiness_business", 'object_id = ?' => $business_id, 'subject_id = ?' => $user_id));

            //GET BUSINESS TITLE
            $businesstitle = $subject->title;

            //BUSINESS URL
            $business_url = Engine_Api::_()->sitebusiness()->getBusinessUrl($subject->business_id);

            //GET BUSINESS URL
            $business_baseurl = 'http://' . $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getRouter()->assemble(array('business_url' => $business_url), 'sitebusiness_entry_view', true);

            //MAKING BUSINESS TITLE LINK
            $business_title_link = '<a href="' . $business_baseurl . '">' . $businesstitle . '</a>';

            //GET LOGGED IN USER INFORMATION
            $viewer = Engine_Api::_()->user()->getViewer();

            //Poster title and photo with link.
            $posterTitle = $viewer->getTitle();
            $posterUrl = $viewer->getHref();
            $poster_baseurl = 'http://' . $_SERVER['HTTP_HOST'] . $posterUrl;
            $poster_title_link = "<a href='$poster_baseurl' style='font-weight:bold;text-decoration:none;'>" . $posterTitle . " </a>";

            $moduletype = 'user';
            //GETTING THE USER PHOTO.
            $file = $viewer->getPhotoUrl('thumb.icon');
            if (empty($file)) {
                $photo = ( _ENGINE_SSL ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getBaseUrl() . '/application/modules/' . ucfirst($moduletype) . '/externals/images/nophoto_' . $moduletype . '_thumb_icon.png';
            } else {
                if (strpos($file, 'http') === FALSE)
                    $photo = ( _ENGINE_SSL ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . $file;
                else
                    $photo = $file;
            }
            $image = "<img src='$photo' />";

            $post_baseUrl = 'http://' . $_SERVER['HTTP_HOST'] . $payload->getHref();
            $posted_your_business = $view->translate(' posted in business: ');
            $post = $posterTitle . $posted_your_business . $businesstitle;
            $postbody = $payload->body;
            $body_content = "<table cellspacing='0' cellpadding='0' border='0' style='border-collapse:collapse;' width='90%'><tr><td style='font-size:11px;font-family:LucidaGrande,tahoma,verdana,arial,sans-serif;padding:20px;background-color:#fff;border-left:none;border-right:none;border-top:none;border-bottom:none;'><table cellspacing='0' cellpadding='0' style='border-collapse:collapse;' width='100%'><tr><td colspan='2' style='font-size:11px;font-family:LucidaGrande,tahoma,verdana,arial,sans-serif;border-bottom:1px solid #dddddd;padding-bottom:5px;'><a style='font-weight:bold;margin-bottom:10px;text-decoration:none;' href='$post_baseUrl'>" . $post . "</a></td></tr><tr><td valign='top' style='padding:10px 15px 10px 10px;'><a href='$poster_baseurl'  >" . $image . " </a></td><td valign='top' style='padding-top:10px;font-size:11px;font-family:LucidaGrande,tahoma,verdana,arial,sans-serif;width:100%;text-align:left;'><table cellspacing='0' cellpadding='0' style='border-collapse:collapse;width:100%;'><tr><td style='font-
			size:11px;font-family:LucidaGrande,tahoma,verdana,arial,sans-serif;'>" . $poster_title_link . "<br /><span style='color:#333333;margin-top:5px;display:block;'>" . $postbody . "</span></td></tr></table></td></tr></table></td></tr></table>";

            $manageTable = Engine_Api::_()->getDbtable('manageadmins', 'sitebusiness');
            $payload_body = strip_tags($payload->body);
            $payload_body = Engine_String::strlen($payload_body) > 50 ? Engine_String::substr($payload_body, 0, (53 - 3)) . '...' : $payload_body;

            //FETCH DATA
            $manageAdminsIds = $manageTable->getManageAdmin($business_id, $user_id);
            $sitebusinessmemberEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember');

            foreach ($manageAdminsIds as $value) {
                $action_notification = unserialize($value['action_notification']);
                $user_subject = Engine_Api::_()->user()->getUser($value['user_id']);
                if (empty($sitebusinessmemberEnabled)) {
                    if (!empty($value['notification']) && in_array('posted', $action_notification)) {
                        $row = $notifications->createRow();
                        $row->user_id = $user_subject->getIdentity();
                        $row->subject_type = $viewer->getType();
                        $row->subject_id = $viewer->getIdentity();
                        $row->object_type = $subject->getType();
                        $row->object_id = $subject->getIdentity();
                        $row->type = 'sitebusiness_notificationpost';
                        $row->params = null;
                        $row->date = date('Y-m-d H:i:s');
                        $row->save();
                    }

                    //EMAIL SEND TO ALL MANAGEADMINS.
                    $action_email = json_decode($value['action_email']);
                    if (!empty($value['email']) && in_array('posted', $action_email)) {
                        Engine_Api::_()->getApi('mail', 'core')->sendSystem($user_subject->email, 'SITEBUSINESS_POSTNOTIFICATION_EMAIL', array(
                            'business_title' => $businesstitle,
                            'body_content' => $body_content,
                            'post_body_body' => $payload_body,
                        ));
                    }
                }
            }

            //START SEND EMAIL TO ALL MEMBER WHO HAVE JOINED THE BUSINESS INCLUDE MANAGE ADMINS.
            if (!empty($sitebusinessmemberEnabled)) {
                $membersIds = Engine_Api::_()->getDbtable('membership', 'sitebusiness')->getJoinMembers($business_id, $viewer->getIdentity(), $viewer->getIdentity(), 0, 1);
                foreach ($membersIds as $value) {
                    $action_email = json_decode($value['action_email']);
                    $user_subject = Engine_Api::_()->user()->getUser($value['user_id']);
                    if (!empty($value['email_notification']) && $action_email->emailposted == 1) {
                        Engine_Api::_()->getApi('mail', 'core')->sendSystem($user_subject->email, 'SITEPAGE_POSTNOTIFICATION_EMAIL', array(
                            'business_title' => $businesstitle,
                            'body_content' => $body_content,
                            'post_body_body' => $payload_body,
                        ));
                    } elseif (!empty($value['email_notification']) && $action_email->emailposted == 2) {
                        $friendId = Engine_Api::_()->user()->getViewer()->membership()->getMembershipsOfIds();
                        if (in_array($value['user_id'], $friendId)) {
                            Engine_Api::_()->getApi('mail', 'core')->sendSystem($user_subject->email, 'SITEPAGE_POSTNOTIFICATION_EMAIL', array(
                                'business_title' => $businesstitle,
                                'body_content' => $body_content,
                                'post_body_body' => $payload_body,
                            ));
                        }
                    }
                }
            }
            //END SEND EMAIL TO ALL MEMBER WHO HAVE JOINED THE BUSINESS INCLUDE MANAGE ADMINS.
            //START NOTIFICATION TO ALL FOLLOWERS.
            $isBusinessAdmins = Engine_Api::_()->getDbtable('manageadmins', 'sitebusiness')->isBusinessAdmins($viewer->getIdentity(), $business_id);
            if (!empty($isBusinessAdmins)) {
                $followersIds = Engine_Api::_()->getDbTable('follows', 'seaocore')->getFollowers('sitebusiness_business', $business_id, $viewer->getIdentity());
                $notificationsTable = Engine_Api::_()->getDbtable('notifications', 'activity');
                if (!empty($followersIds)) {
                    //previous notification is delete.
                    $notificationsTable->delete(array('type =?' => "sitebusiness_notificationpost", 'object_type = ?' => "sitebusiness_business", 'object_id = ?' => $business_id, 'subject_id = ?' => $business_id, 'subject_type = ?' => 'sitebusiness_business'));
                    foreach ($followersIds as $value) {
                        $user_subject = Engine_Api::_()->user()->getUser($value['poster_id']);
                        $row = $notificationsTable->createRow();
                        $row->user_id = $user_subject->getIdentity();
                        if (!empty($notidicationSettings)) {
                            $row->subject_type = $subject->getType();
                            $row->subject_id = $subject->getIdentity();
                        } else {
                            $row->subject_type = $viewer->getType();
                            $row->subject_id = $viewer->getIdentity();
                        }
                        $row->type = "sitebusiness_notificationpost";
                        $row->object_type = $subject->getType();
                        $row->object_id = $subject->getIdentity();
                        $row->params = null;
                        $row->date = date('Y-m-d H:i:s');
                        $row->save();
                    }
                }
            }
            //END NOTIFICATION TO ALL FOLLOWERS.
        }
    }

}
