<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Dashboardmenus.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusiness_Plugin_Dashboardmenus {

  public function onMenuInitialize_SitebusinessDashboardGetstarted($row) {

    //GET BUSINESS ID AND SITEBUSINESS OBJECT
    $business_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('business_id', null);
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    if ($sitebusiness->getType() !== 'sitebusiness_business') {
      return false;
    }

    $editPrivacy = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($editPrivacy)) {
      return false;
    }

    return array(
      'label' => $row->label,
      'route' => 'sitebusiness_dashboard',
      'action' => 'get-started',
      'class' => 'ajax_dashboard_enabled',
      'params' => array(
          'business_id' => $sitebusiness->getIdentity()
      ),
    );
  }

  public function onMenuInitialize_SitebusinessDashboardEditinfo($row) {

    //GET BUSINESS ID AND SITEBUSINESS OBJECT
    $business_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('business_id', null);
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    if ($sitebusiness->getType() !== 'sitebusiness_business') {
      return false;
    }

    $editPrivacy = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($editPrivacy)) {
      return false;
    }

    return array(
        'label' => $row->label,
        'route' => 'sitebusiness_edit',
        'class' => 'ajax_dashboard_enabled',
        'params' => array(
            'business_id' => $sitebusiness->getIdentity()
        ),
    );
  }

  public function onMenuInitialize_SitebusinessDashboardProfilepicture($row) {

    //GET BUSINESS ID AND SITEBUSINESS OBJECT
    $business_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('business_id', null);
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    if ($sitebusiness->getType() !== 'sitebusiness_business') {
      return false;
    }

    $editPrivacy = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($editPrivacy)) {
      return false;
    }

    return array(
        'label' => $row->label,
        'route' => 'sitebusiness_dashboard',
        'action' => 'profile-picture',
        'class' => 'ajax_dashboard_enabled',
        'params' => array(
            'business_id' => $sitebusiness->getIdentity()
        ),
    );
  }

  public function onMenuInitialize_SitebusinessDashboardOverview($row) {

    //GET BUSINESS ID AND SITEBUSINESS OBJECT
    $business_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('business_id', null);
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    if ($sitebusiness->getType() !== 'sitebusiness_business') {
      return false;
    }

    $editPrivacy = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($editPrivacy)) {
      return false;
    }
    $overviewPrivacy = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'overview');
    if (empty($overviewPrivacy)) {
      return false;
    }
    return array(
        'label' => $row->label,
        'route' => 'sitebusiness_dashboard',
        'action' => 'overview',
        'params' => array(
            'business_id' => $sitebusiness->getIdentity()
        ),
    );
  }

  public function onMenuInitialize_SitebusinessDashboardContact($row) {

    //GET BUSINESS ID AND SITEBUSINESS OBJECT
    $business_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('business_id', null);
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    if ($sitebusiness->getType() !== 'sitebusiness_business') {
      return false;
    }

    $editPrivacy = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($editPrivacy)) {
      return false;
    }
    
    $contactPrivacy = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'contact');
    if (empty($contactPrivacy)) {
      return false;
    }
    
    $contactSpicifyFileds = 0;
    $businessOwner = Engine_Api::_()->user()->getUser($sitebusiness->owner_id);
    $view_options = (array) Engine_Api::_()->authorization()->getAdapter('levels')->getAllowed('sitebusiness_business', $businessOwner, 'contact_detail');
    $availableLabels = array('phone' => 'Phone', 'website' => 'Website', 'email' => 'Email',);
    $options_create = array_intersect_key($availableLabels, array_flip($view_options));
    if (!empty($options_create)) {
      $contactSpicifyFileds = 1;
    }
    
    if (empty($contactSpicifyFileds)) {
      return false;
    }
    
    return array(
        'label' => $row->label,
        'route' => 'sitebusiness_dashboard',
        'action' => 'contact',
        'class' => 'ajax_dashboard_enabled',
        'params' => array(
            'business_id' => $sitebusiness->getIdentity()
        ),
    );
  }

  public function onMenuInitialize_SitebusinessDashboardManagememberroles($row) {

    $sitebusinessMemberEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember');
    if (empty($sitebusinessMemberEnabled)) {
      return false;
    }
    
    if (Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessmember.category.settings', 1) == 1) {
      return false;
    }
    
    //GET BUSINESS ID AND SITEBUSINESS OBJECT
    $business_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('business_id', null);
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    if ($sitebusiness->getType() !== 'sitebusiness_business') {
      return false;
    }

    $editPrivacy = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($editPrivacy)) {
      return false;
    }

    return array(
        'label' => $row->label,
        'route' => 'sitebusiness_dashboard',
        'action' => 'manage-member-category',
        'class' => 'ajax_dashboard_enabled',
        'params' => array(
            'business_id' => $sitebusiness->getIdentity()
        ),
    );
  }

  public function onMenuInitialize_SitebusinessDashboardAnnouncements($row) {
    
    //$sitebusinessMemberEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember');
    if (!Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember')) {
      return false;
    }
    
    $businessannoucement = Engine_Api::_()->getApi('settings', 'core')->getSetting('businessmember.announcement', 1);
    if (empty($businessannoucement)) {
      return false;
    }
    
    $sitebusinessmemberGetAnnouucement = Zend_Registry::isRegistered('sitebusinessmemberGetAnnouucement') ? Zend_Registry::get('sitebusinessmemberGetAnnouucement') : null;
    if (empty($sitebusinessmemberGetAnnouucement)) {
      return false;
    }
    
    //GET BUSINESS ID AND SITEBUSINESS OBJECT
    $business_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('business_id', null);
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    if ($sitebusiness->getType() !== 'sitebusiness_business') {
      return false;
    }

    $editPrivacy = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($editPrivacy)) {
      return false;
    }
    
    $allowBusiness = Engine_Api::_()->sitebusiness()->allowInThisBusiness($sitebusiness, "sitebusinessmember", 'smecreate');
    if (empty($allowBusiness)) {
      return false;
    }

    return array(
        'label' => $row->label,
        'route' => 'sitebusiness_dashboard',
        'action' => 'announcements',
        'class' => 'ajax_dashboard_enabled',
        'params' => array(
            'business_id' => $sitebusiness->getIdentity()
        ),
    );
  }

  public function onMenuInitialize_SitebusinessDashboardAlllocation($row) {

    //GET BUSINESS ID AND SITEBUSINESS OBJECT
    $business_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('business_id', null);
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    if ($sitebusiness->getType() !== 'sitebusiness_business') {
      return false;
    }
    
    $multipleLocation = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.multiple.location', 0);
    if (empty($multipleLocation)) {
      return false;
    }
    
    $editPrivacy = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($editPrivacy)) {
      return false;
    }

    if (!Engine_Api::_()->sitebusiness()->enableLocation()) {
      return false;
    }
    
    $mapPrivacy = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'map');
    if (empty($mapPrivacy)) {
      return false;
    }
    
    return array(
        'label' => $row->label,
        'route' => 'sitebusiness_dashboard',
        'action' => 'all-location',
        'params' => array(
            'business_id' => $sitebusiness->getIdentity()
        ),
    );
  }

  public function onMenuInitialize_SitebusinessDashboardEditlocation($row) {

    //GET BUSINESS ID AND SITEBUSINESS OBJECT
    $business_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('business_id', null);
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    if ($sitebusiness->getType() !== 'sitebusiness_business') {
      return false;
    }
    
    $multipleLocation = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.multiple.location', 0);
    if (!empty($multipleLocation)) {
      return false;
    }
    
    $editPrivacy = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($editPrivacy)) {
      return false;
    }

    if (!Engine_Api::_()->sitebusiness()->enableLocation()) {
      return false;
    }
    $mapPrivacy = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'map');
    if (empty($mapPrivacy)) {
      return false;
    }
    
    return array(
        'label' => $row->label,
        'route' => 'sitebusiness_dashboard',
        'action' => 'edit-location',
        'params' => array(
            'business_id' => $sitebusiness->getIdentity()
        ),
    );
  }

  public function onMenuInitialize_SitebusinessDashboardProfiletype($row) {

    //GET BUSINESS ID AND SITEBUSINESS OBJECT
    $business_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('business_id', null);
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    if ($sitebusiness->getType() !== 'sitebusiness_business') {
      return false;
    }

    $editPrivacy = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($editPrivacy)) {
      return false;
    }
    
    $profileTypePrivacy = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'profile');
    if (empty($profileTypePrivacy)) {
      return false;
    }
    
    return array(
        'label' => $row->label,
        'route' => 'sitebusiness_dashboard',
        'action' => 'profile-type',
        'params' => array(
            'business_id' => $sitebusiness->getIdentity(),
            'profile_type' => $sitebusiness->profile_type
        ),
    );
  }

  public function onMenuInitialize_SitebusinessDashboardApps($row) {

    //GET BUSINESS ID AND SITEBUSINESS OBJECT
    $business_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('business_id', null);
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    if ($sitebusiness->getType() !== 'sitebusiness_business') {
      return false;
    }

    $editPrivacy = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($editPrivacy)) {
      return false;
    }

    if (!Engine_Api::_()->sitebusiness()->getEnabledSubModules()) {
      return false;
    }
    return array(
        'label' => $row->label,
        'route' => 'sitebusiness_dashboard',
        'action' => 'app',
        'class' => 'ajax_dashboard_enabled',
        'params' => array(
            'business_id' => $sitebusiness->getIdentity()
        ),
    );
  }

  public function onMenuInitialize_SitebusinessDashboardMarketing($row) {

    //GET BUSINESS ID AND SITEBUSINESS OBJECT
    $business_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('business_id', null);
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    if ($sitebusiness->getType() !== 'sitebusiness_business') {
      return false;
    }

    $editPrivacy = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($editPrivacy)) {
      return false;
    }

    return array(
        'label' => $row->label,
        'route' => 'sitebusiness_dashboard',
        'action' => 'marketing',
        'class' => 'ajax_dashboard_enabled',
        'params' => array(
            'business_id' => $sitebusiness->getIdentity()
        ),
    );
  }

  public function onMenuInitialize_SitebusinessDashboardNotificationsettings($row) {

    //GET BUSINESS ID AND SITEBUSINESS OBJECT
    $business_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('business_id', null);
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    if ($sitebusiness->getType() !== 'sitebusiness_business') {
      return false;
    }

    $editPrivacy = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($editPrivacy)) {
      return false;
    }

    return array(
        'label' => $row->label,
        'route' => 'sitebusiness_dashboard',
        'action' => 'notification-settings',
        'class' => 'ajax_dashboard_enabled',
        'params' => array(
            'business_id' => $sitebusiness->getIdentity()
        ),
    );
  }

  public function onMenuInitialize_SitebusinessDashboardInsights($row) {

    //GET BUSINESS ID AND SITEBUSINESS OBJECT
    $business_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('business_id', null);
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    if ($sitebusiness->getType() !== 'sitebusiness_business') {
      return false;
    }

    $editPrivacy = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($editPrivacy)) {
      return false;
    }
    
    $insightPrivacy = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'insight');
    if (empty($insightPrivacy)) {
      return false;
    }
    
    return array(
        'label' => $row->label,
        'route' => 'sitebusiness_insights',
        'params' => array(
            'business_id' => $sitebusiness->getIdentity(),
						'action' => 'index'
        ),
    );
  }

  public function onMenuInitialize_SitebusinessDashboardReports($row) {

    //GET BUSINESS ID AND SITEBUSINESS OBJECT
    $business_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('business_id', null);
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    if ($sitebusiness->getType() !== 'sitebusiness_business') {
      return false;
    }

    $editPrivacy = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($editPrivacy)) {
      return false;
    }
    
    $insightPrivacy = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'insight');
    if (empty($insightPrivacy)) {
      return false;
    }
    
    return array(
        'label' => $row->label,
        'route' => 'sitebusiness_reports',
        'params' => array(
            'business_id' => $sitebusiness->getIdentity(),
            'action'  => 'export-report',
            'active' => false
        ),
    );
  }

  public function onMenuInitialize_SitebusinessDashboardBadge($row) {

    //GET BUSINESS ID AND SITEBUSINESS OBJECT
    $business_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('business_id', null);
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    if ($sitebusiness->getType() !== 'sitebusiness_business') {
      return false;
    }

    $editPrivacy = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($editPrivacy)) {
      return false;
    }
    
    $sitebusinessBadgeEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessbadge');
    if (empty($sitebusinessBadgeEnabled)) {
      return false;
    }
    
    if (!empty($sitebusinessBadgeEnabled)) {
      $badgePrivacy = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'badge');
      if (!empty($badgePrivacy)) {
        $badgeCount = Engine_Api::_()->sitebusinessbadge()->badgeCount();
      }
    }
    if (empty($badgeCount)) {
      return false;
    }
    return array(
        'label' => $row->label,
        'route' => 'sitebusinessbadge_request',
        //	'action' => 'edit-style',
        'class' => 'ajax_dashboard_enabled',
        'params' => array(
            'business_id' => $sitebusiness->getIdentity()
        ),
    );
  }

  public function onMenuInitialize_SitebusinessDashboardManageadmins($row) {

    //GET BUSINESS ID AND SITEBUSINESS OBJECT
    $business_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('business_id', null);
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    if ($sitebusiness->getType() !== 'sitebusiness_business') {
      return false;
    }

    $editPrivacy = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($editPrivacy)) {
      return false;
    }

    if (!Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.manageadmin', 1)) {
      return false;
    }
    
    return array(
        'label' => $row->label,
        'route' => 'sitebusiness_manageadmins',
        'action' => 'index',
        'class' => 'ajax_dashboard_enabled',
        'params' => array(
            'business_id' => $sitebusiness->getIdentity()
        ),
    );
  }

  public function onMenuInitialize_SitebusinessDashboardFeaturedowners($row) {

    //GET BUSINESS ID AND SITEBUSINESS OBJECT
    $business_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('business_id', null);
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    if ($sitebusiness->getType() !== 'sitebusiness_business') {
      return false;
    }

    $editPrivacy = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($editPrivacy)) {
      return false;
    }
    
    if (!Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.manageadmin', 1)) {
      return false;
    }
    
    return array(
        'label' => $row->label,
        'route' => 'sitebusiness_dashboard',
        'action' => 'featured-owners',
        'class' => 'ajax_dashboard_enabled',
        'params' => array(
            'business_id' => $sitebusiness->getIdentity()
        ),
    );
  }

  public function onMenuInitialize_SitebusinessDashboardEditstyle($row) {

    //GET BUSINESS ID AND SITEBUSINESS OBJECT
    $business_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('business_id', null);
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    if ($sitebusiness->getType() !== 'sitebusiness_business') {
      return false;
    }

    $editPrivacy = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($editPrivacy)) {
      return false;
    }
    
    if (!Engine_Api::_()->sitebusiness()->allowStyle()) {
      return false;
    }
    
    return array(
        'label' => $row->label,
        'route' => 'sitebusiness_dashboard',
        'action' => 'edit-style',
        'class' => 'ajax_dashboard_enabled',
        'params' => array(
            'business_id' => $sitebusiness->getIdentity()
        ),
    );
  }

  public function onMenuInitialize_SitebusinessDashboardEditlayout($row) {

    //GET BUSINESS ID AND SITEBUSINESS OBJECT
    $business_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('business_id', null);
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    if ($sitebusiness->getType() !== 'sitebusiness_business') {
      return false;
    }

    $editPrivacy = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($editPrivacy)) {
      return false;
    }
    
    if (!Engine_Api::_()->getApi('settings', 'core')->sitebusiness_layoutcreate) {
      return false;
    }
    
    return array(
        'label' => $row->label,
        'route' => 'sitebusiness_layout',
        'params' => array(
            'business_id' => $sitebusiness->getIdentity()
        ),
    );
  }

  public function onMenuInitialize_SitebusinessDashboardUpdatepackages($row) {

    //GET BUSINESS ID AND SITEBUSINESS OBJECT
    $business_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('business_id', null);
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    if ($sitebusiness->getType() !== 'sitebusiness_business') {
      return false;
    }

    $editPrivacy = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($editPrivacy)) {
      return false;
    }
    
    if (!Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
      return false;
    }
    return array(
        'label' => $row->label,
        'route' => 'sitebusiness_packages',
        'action' => 'update-package',
        'class' => 'ajax_dashboard_enabled',
        'params' => array(
            'business_id' => $sitebusiness->getIdentity()
        ),
    );
  }

  public function onMenuInitialize_SitebusinessDashboardProjects($row) { 
  
      //GET BUSINESS ID AND SITEBUSINESS OBJECT
      $business_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('business_id', null);
      $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
      if ($sitebusiness->getType() !== 'sitebusiness_business') {
          return false;
      } 
      $viewer = Engine_Api::_()->user()->getViewer();
      $editPrivacy = $sitebusiness->authorization()->isAllowed($viewer, "edit");
      if (empty($editPrivacy)) {
          return false;
      } 
      $crowdfundingEnable = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitecrowdfunding'); 
      if (!($crowdfundingEnable && Engine_Api::_()->hasModuleBootstrap('sitecrowdfundingintegration') && Engine_Api::_()->getDbtable('modules', 'sitecrowdfunding')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'sitebusiness_business', 'item_module' => 'sitebusiness')))) {
          return false;
      }
      //DO NOT SHOW THE PROJECTS TAB IF ADMIN HAVE SELECTED PROJECT FOR THE BUSINESS PROFILE PAGE
      $adminSelectedProject = Engine_Api::_()->sitecrowdfunding()->adminSelectedProject('sitebusiness_index_view');
      if(!empty($adminSelectedProject)) {
          return false;
      }  
      if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
          $allowProject = Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", 'sitecrowdfunding') ? 1 : 0; 
      } else {
          //permission to create project in above modules(Not Available Yet )
          $allowProject = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'sprcreate') ? 1 : 0;
      } 
      if (empty($allowProject)) {
          return false;
      } 
      return array(
          'label' => $row->label,
          'route' => 'sitebusiness_dashboard', 
          'action' => 'choose-project',
          'class' => 'ajax_dashboard_enabled',
          'params' => array(
              'business_id' => $sitebusiness->getIdentity()
          ),
      ); 
  }

}