<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminController.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusiness_AdminController extends Core_Controller_Action_Admin {

  //ACTION FOR MAKE THE SITEBUSINESS FEATURED/UNFEATURED
  public function featuredAction() {

    $business_id = $this->_getParam('id');
    if (!empty($business_id)) {
      $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
      $sitebusiness->featured = !$sitebusiness->featured;
      $sitebusiness->save();
    }
    $this->_redirect('admin/sitebusiness/viewsitebusiness');
  }

  //ACTION FOR MAKE THE SITEBUSINESS OPEN/CLOSED
  public function opencloseAction() {

    $business_id = $this->_getParam('id');
    if (!empty($business_id)) {
      $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
      $sitebusiness->closed = !$sitebusiness->closed;
      $sitebusiness->save();
    }
    $this->_redirect('admin/sitebusiness/viewsitebusiness');
  }

  //ACTION FOR MAKE SPONSORED /UNSPONSORED
  public function sponsoredAction() {

    $business_id = $this->_getParam('id');
    if (!empty($business_id)) {
      $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
      $sitebusiness->sponsored = !$sitebusiness->sponsored;
      $sitebusiness->save();
    }
    $this->_redirect('admin/sitebusiness/viewsitebusiness');
  }

  //ACTION FOR MAKE SITEBUSINESS APPROVE/DIS-APPROVE
  public function approvedAction() {

    global $sitebusiness_is_auth;
    $business_id = $this->_getParam('id');
    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    $email = array();
    try {
      $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
      if (!empty($sitebusiness_is_auth)) {
        $sitebusiness->approved = !$sitebusiness->approved;
      }

      if (!empty($sitebusiness->approved)) {

        if (!empty($sitebusiness->pending)) {
          $sendActiveMail = 1;
          $sitebusiness->pending = 0;
        }

        if (empty($sitebusiness->aprrove_date)) {
          $sitebusiness->aprrove_date = date('Y-m-d H:i:s');
        }

        $diff_days = 0;
        $package = $sitebusiness->getPackage();
        if (($sitebusiness->expiration_date !== '2250-01-01 00:00:00' && !empty($sitebusiness->expiration_date) && $sitebusiness->expiration_date !== '0000-00-00 00:00:00') && date('Y-m-d', strtotime($sitebusiness->expiration_date)) > date('Y-m-d')) {
          $diff_days = round((strtotime($sitebusiness->expiration_date) - strtotime(date('Y-m-d H:i:s'))) / 86400);
        }


        if (($diff_days <= 0 && $sitebusiness->expiration_date !== '2250-01-01 00:00:00') || empty($sitebusiness->expiration_date) || $sitebusiness->expiration_date == '0000-00-00 00:00:00') {
          if (!$package->isFree()) {
            if ($sitebusiness->status != "active") {
              $relDate = new Zend_Date(time());
              $relDate->add((int) 1, Zend_Date::DAY);
              $sitebusiness->expiration_date = date('Y-m-d H:i:s', $relDate->toValue());
            } else {

              $expirationDate = $package->getExpirationDate();
              if (!empty($expirationDate))
                $sitebusiness->expiration_date = date('Y-m-d H:i:s', $expirationDate);
              else
                $sitebusiness->expiration_date = '2250-01-01 00:00:00';
            }
          }else {

            $expirationDate = $package->getExpirationDate();
            if (!empty($expirationDate))
              $sitebusiness->expiration_date = date('Y-m-d H:i:s', $expirationDate);
            else
              $sitebusiness->expiration_date = '2250-01-01 00:00:00';
          }
        }
        if ($sendActiveMail) {
          Engine_Api::_()->sitebusiness()->sendMail("ACTIVE", $sitebusiness->business_id);
          if (!empty($sitebusiness) && !empty($sitebusiness->draft) && empty($sitebusiness->pending)) {
            Engine_Api::_()->sitebusiness()->attachBusinessActivity($sitebusiness);
          }
        } else {
          Engine_Api::_()->sitebusiness()->sendMail("APPROVED", $sitebusiness->business_id);
        }
      } else {

        Engine_Api::_()->sitebusiness()->sendMail("DISAPPROVED", $sitebusiness->business_id);
      }
      $sitebusiness->save();
      $db->commit();
    } catch (Exception $e) {
      $db->rollBack();
      throw $e;
    }
    $this->_redirect('admin/sitebusiness/viewsitebusiness');
  }

  //ACTION FOR MAKE SITEBUSINESS APPROVE/DIS-APPROVE
  public function renewAction() {

    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
      $business_id = $this->_getParam('id');
      if ($this->getRequest()->isPost()) {
        $db = Engine_Db_Table::getDefaultAdapter();
        $db->beginTransaction();
        try {
          $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
          if (!empty($sitebusiness->approved)) {
            $package = $sitebusiness->getPackage();
            if ($sitebusiness->expiration_date !== '2250-01-01 00:00:00') {

              $expirationDate = $package->getExpirationDate();
              $expiration = $package->getExpirationDate();

              $diff_days = 0;
              if (!empty($sitebusiness->expiration_date) && $sitebusiness->expiration_date !== '0000-00-00 00:00:00') {
                $diff_days = round((strtotime($sitebusiness->expiration_date) - strtotime(date('Y-m-d H:i:s'))) / 86400);
              }
              if ($expiration) {
                $date = date('Y-m-d H:i:s', $expiration);

                if ($diff_days >= 1) {

                  $diff_days_expiry = round((strtotime($date) - strtotime(date('Y-m-d H:i:s'))) / 86400);
                  $incrmnt_date = date('d', time()) + $diff_days_expiry + $diff_days;
                  $incrmnt_date = date('Y-m-d H:i:s', mktime(date("H"), date("i"), date("s"), date("m"), $incrmnt_date));
                } else {
                  $incrmnt_date = $date;
                }

                $sitebusiness->expiration_date = $incrmnt_date;
              } else {
                $sitebusiness->expiration_date = '2250-01-01 00:00:00';
              }
            }
            if ($package->isFree())
              $sitebusiness->status = "initial";
            else
              $sitebusiness->status = "active";
          }
          $sitebusiness->search = 1;
          $sitebusiness->save();
          $db->commit();
        } catch (Exception $e) {
          $db->rollBack();
          throw $e;
        }

        $this->_forward('success', 'utility', 'core', array(
                'smoothboxClose' => 10,
                'parentRefresh' => 10,
                'messages' => array(Zend_Registry::get('Zend_Translate')->_(''))
        ));
      }
    }
    $this->renderScript('admin/renew.tpl');
  }

  //ACTION FOR DELETE THE SITEBUSINESS
  public function deleteAction() {

    $this->_helper->layout->setLayout('admin-simple');
    $this->view->business_id = $business_id = $this->_getParam('id');

    if ($this->getRequest()->isPost()) {
    
      //START SUB BUSINESS WORK
			$getSubBusinessids = Engine_Api::_()->getDbTable('business', 'sitebusiness')->getsubBusinessids($business_id);
			foreach($getSubBusinessids as $getSubBusinessid) {
				Engine_Api::_()->sitebusiness()->onBusinessDelete($getSubBusinessid['business_id']);
			}
			//END SUB BUSINESS WORK

      Engine_Api::_()->sitebusiness()->onBusinessDelete($business_id);
      $this->_forward('success', 'utility', 'core', array(
              'smoothboxClose' => 10,
              'parentRefresh' => 10,
              'messages' => array(Zend_Registry::get('Zend_Translate')->_(''))
      ));
    }
    $this->renderScript('admin/delete.tpl');
  }

  //ACTION FOR CHANGE THE OWNER OF THE BUSINESS
  public function changeOwnerAction() {

    //LAYOUT
    $this->_helper->layout->setLayout('admin-simple');

    //GET BUSINESS ID
    $this->view->business_id = $business_id = $this->_getParam('id');

    //FORM
    $form = $this->view->form = new Sitebusiness_Form_Admin_Changeowner();

    //SET ACTION
    $form->setAction($this->getFrontController()->getRouter()->assemble(array()));

    //GET SITEBUSINESS ITEM
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);

    //OLD OWNER ID
    $oldownerid = $sitebusiness->owner_id;

    //CHECK FORM VALIDATION
    if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
      //GET FORM VALUES
      $values = $form->getValues();

      //GET USER ID WHICH IS NOW NEW USER
      $changeuserid = $values['user_id'];

      //CHANGE USER TABLE
      $changed_user = Engine_Api::_()->getItem('user', $changeuserid);

      //OWNER USER TABLE
      $user = Engine_Api::_()->getItem('user', $sitebusiness->owner_id);

      //BUSINESS URL
      $business_url = Engine_Api::_()->sitebusiness()->getBusinessUrl($sitebusiness->business_id);

      //GET BUSINESS TITLE
      $businesstitle = $sitebusiness->title;

      //BUSINESS OBJECT LINK
      $businessobjectlink = $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getRouter()->assemble(array('business_url' => $business_url), 'sitebusiness_entry_view');

      //GET DB
      $db = Engine_Db_Table::getDefaultAdapter();
      $db->beginTransaction();
      try {

        //UPDATE BUSINESS TABLE
        Engine_Api::_()->getDbtable('business', 'sitebusiness')->update(array('owner_id' => $changeuserid), array('business_id = ?' => $business_id));

        //GET BUSINESS URL
        $business_baseurl = 'http://' . $_SERVER['HTTP_HOST'] .
            Zend_Controller_Front::getInstance()->getRouter()->assemble(array('business_url' => $business_url), 'sitebusiness_entry_view', true);

        //MAKING BUSINESS TITLE LINK
        $business_title_link = '<a href="' . $business_baseurl . '"  >' . $businesstitle . ' </a>';

        //GET ADMIN EMAIL
        $email = Engine_Api::_()->getApi('settings', 'core')->core_mail_from;

        //EMAIL THAT GOES TO OLD OWNER
        Engine_Api::_()->getApi('mail', 'core')->sendSystem($user->email, 'SITEBUSINESS_CHANGEOWNER_EMAIL', array(

            'business_title' => $businesstitle,
            'business_title_with_link' => $business_title_link,
            'object_link' => $business_baseurl,
            'site_contact_us_link' => 'http://' . $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getBaseUrl() . '/help/contact',
            'email' => $email,
            'queue' => true

        ));

        //EMAIL THAT GOES TO NEW OWNER
        Engine_Api::_()->getApi('mail', 'core')->sendSystem($changed_user->email, 'SITEBUSINESS_BECOMEOWNER_EMAIL', array(
            'business_title' => $businesstitle,
            'business_title_with_link' => $business_title_link,
            'object_link' => $business_baseurl,
            'site_contact_us_link' => 'http://' . $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getBaseUrl() . '/help/contact',
            'email' => $email,
            'queue' => true

        ));


		    //START FOR INRAGRATION WORK WITH OTHER PLUGIN. DELETE ACCORDING TO BUSINESS ID.
				$sitebusinessintegrationEnabled = Engine_Api::_()->getDbtable('modules',
				'core')->isModuleEnabled('sitebusinessintegration');
			  if(!empty($sitebusinessintegrationEnabled)) {
					$contentsTable = Engine_Api::_()->getDbtable('contents', 'sitebusinessintegration');
					$contentsTable->delete(array('business_id = ?' => $business_id));
				}
        //END FOR INRAGRATION WORK WITH OTHER PLUGIN.
        
				$sitebusinessmemberEnabled = Engine_Api::_()->getDbtable('modules',
				'core')->isModuleEnabled('sitebusinessmember');
				if(!empty($sitebusinessmemberEnabled)) {
					$membershipTable = Engine_Api::_()->getDbtable('membership', 'sitebusiness');
					$select = $membershipTable->select()->from($membershipTable->info('name'))->where('user_id = ?', $user->user_id)->where('resource_id = ?', $sitebusiness->business_id);
          $getRow = $membershipTable->fetchRow($select);
          
					$select = $membershipTable->select()->from($membershipTable->info('name'), 'member_id')->where('user_id = ?', $changed_user->user_id)->where('resource_id = ?', $sitebusiness->business_id);
          $getNewOwnerRow = (integer) $select->query()->fetchColumn();          
          
          if(!empty($getRow) && empty($getNewOwnerRow)) {
            $db = Engine_Db_Table::getDefaultAdapter();
            $db->beginTransaction();
            try {
              $memberShip = $membershipTable->createRow();
              $getRowArray = $getRow->toArray();
              unset($getRowArray['member_id']);
              $memberShip->setFromArray($getRowArray);
              $memberShip->user_id = $changed_user->user_id;
              $memberShip->save();
              $db->commit();
            } catch (Exception $e) {
              $db->rollBack();
              throw $e;
            }              
          }
				}             

        //UPDATE IN CONTENT BUSINESS TABLE
        Engine_Api::_()->getDbtable('contentbusinesses', 'sitebusiness')->update(array('user_id' => $changeuserid), array('business_id = ?' => $business_id));

        //UPDATE PHOTO TABLE
        Engine_Api::_()->getDbtable('photos', 'sitebusiness')->update(array('user_id' => $changeuserid), array('user_id = ?' => $oldownerid, 'business_id = ?' => $business_id));

        //UPDATE ALBUM TABLE
        Engine_Api::_()->getDbtable('albums', 'sitebusiness')->update(array('owner_id' => $changeuserid), array('owner_id = ?' => $oldownerid, 'business_id = ?' => $business_id));

        //UPDATE AND DELETE IN MANAGE ADMIN TABLE
        Engine_Api::_()->getDbtable('manageadmins', 'sitebusiness')->delete(array('user_id = ?' => $changeuserid, 'business_id = ?' => $business_id));
        Engine_Api::_()->getDbtable('manageadmins', 'sitebusiness')->update(array('user_id' => $changeuserid), array('user_id = ?' => $oldownerid, 'business_id = ?' => $business_id));

        //COMMIT
        $db->commit();
      } catch (Exception $e) {
        $db->rollBack();
        throw $e;
      }

      //SUCCESS
      $this->_forward('success', 'utility', 'core', array(
              'smoothboxClose' => 300,
              'parentRefresh' => 300,
              'messages' => array(Zend_Registry::get('Zend_Translate')->_('The business owner has been changed succesfully.'))
      ));
    }
  }

  //ACTION FOR GETTING THE LIST OF USERS
  public function getOwnerAction() {

  	//GET SITEBUSINESS ITEM
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $this->_getParam('business_id'));

    //USER TABLE
    $tableUser = Engine_Api::_()->getDbtable('users', 'user');
    $userTableName = $tableUser->info('name');
    $noncreate_owner_level = array();
    $permissionsTable = Engine_Api::_()->getDbtable('permissions', 'authorization');
    foreach (Engine_Api::_()->getDbtable('levels', 'authorization')->fetchAll() as $level) {
      $can_create = 0;
      if ($level->type != "public") {
        $can_create = Engine_Api::_()->authorization()->getPermission($level->level_id, 'sitebusiness_business', 'edit');
        if (empty($can_create)) {
          $noncreate_owner_level[] = $level->level_id;
        }
      }
    }

    //SELECT
    $select = $tableUser->select()
            ->where('displayname  LIKE ? ', '%' . $this->_getParam('text') . '%')
            ->where('user_id !=?', $sitebusiness->owner_id)
            ->order('displayname ASC')
            ->limit($this->_getParam('limit', 40));

    if (!empty($noncreate_owner_level)) {
      $str = (string) ( is_array($noncreate_owner_level) ? "'" . join("', '", $noncreate_owner_level) . "'" : $noncreate_owner_level );
      $select->where($userTableName . '.level_id not in (?)', new Zend_Db_Expr($str));
    }

    //FETCH
    $userlists = $tableUser->fetchAll($select);

    //MAKING DATA
    $data = array();
    $mode = $this->_getParam('struct');

    if ($mode == 'text') {
      foreach ($userlists as $userlist) {
        $content_photo = $this->view->itemPhoto($userlist, 'thumb.icon');
        $data[] = array(
                'id' => $userlist->user_id,
                'label' => $userlist->displayname,
                'photo' => $content_photo
        );
      }
    } else {
      foreach ($userlists as $userlist) {
        $content_photo = $this->view->itemPhoto($userlist, 'thumb.icon');
        $data[] = array(
                'id' => $userlist->user_id,
                'label' => $userlist->displayname,
                'photo' => $content_photo
        );
      }
    }

    return $this->_helper->json($data);
  }

  //ACTION FOR CHANGE THE CATEGORY OF THE BUSINESS
  public function changeCategoryAction() {

    //LAYOUT
    $this->_helper->layout->setLayout('admin-simple');

    //GET BUSINESS ID
    $this->view->business_id = $business_id = $this->_getParam('id');

    //GET SITEBUSINESS ITEM
    $this->view->sitebusiness = $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);

    //GET CATEGORY ID
    $this->view->category_id = $previous_category_id = $sitebusiness->category_id;

    //GET SUBCATEGORY
    $this->view->subcategory_id = $subcategory_id = $sitebusiness->subcategory_id;

    //GET SUBSUBCATEGORY
    $this->view->subsubcategory_id = $subsubcategory_id = $sitebusiness->subsubcategory_id;

    //GET ROW
    $row = Engine_Api::_()->getDbTable('categories', 'sitebusiness')->getCategory($subcategory_id);
    if (!empty($row->category_name)) {
      $this->view->subcategory_name = $row->category_name;
    }

    $row = Engine_Api::_()->getDbTable('categories', 'sitebusiness')->getCategory($subsubcategory_id);
    if (!empty($row->category_name)) {
      $this->view->subsubcategory_name = $row->category_name;
    }

    //FORM
    $form = $this->view->form = new Sitebusiness_Form_Admin_Changecategory();

    //POPULATE
    $value['category_id'] = $sitebusiness->category_id;
    $form->populate($value);

    //CHECK FORM VALIDATION
    if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
      $is_error = 0;
      //GET FORM VALUES
      $values = $form->getValues();
      if (empty($values['category_id'])) {
        $is_error = 1;
        $this->view->category_id = 0;
      }

      //SET ERROR
      if ($is_error == 1) {
        $error = $this->view->translate('Business Category * Please complete this field - it is required.');
        $this->view->status = false;
        $error = Zend_Registry::get('Zend_Translate')->_($error);
        $form->getDecorator('errors')->setOption('escape', false);
        $form->addError($error);
        return;
      }

      //GET DB
      $db = Engine_Db_Table::getDefaultAdapter();
      $db->beginTransaction();
      try {
        //SAVE VALUES
        $sitebusiness->category_id = $values['category_id'];
        $sitebusiness->subcategory_id = $values['subcategory_id'];
				$sitebusiness->subsubcategory_id = $values['subsubcategory_id'];
        $sitebusiness->save();
        $db->commit();

        //START SITEBUSINESSREVIEW CODE
        $sitebusinessReviewEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessreview');
        if ($sitebusinessReviewEnabled && $previous_category_id != $sitebusiness->category_id) {
          Engine_Api::_()->getDbtable('ratings', 'sitebusinessreview')->editBusinessCategory($sitebusiness->business_id, $previous_category_id, $sitebusiness->category_id);
        }
        //END SITEBUSINESSREVIEW CODE
        
        //START SITEBUSINESSMEMBER CODE
        $sitebusinessmemberEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember');
        if ($sitebusinessmemberEnabled && $previous_category_id != $sitebusiness->category_id) {
          $db->query("UPDATE `engine4_sitebusiness_membership` SET `role_id` = '0' WHERE `engine4_sitebusiness_membership`.`business_id` = ". $sitebusiness->business_id. ";");
        }
        //END SITEBUSINESSMEMBER CODE

        //PROFILE MAPPING WORK IF CATEGORY IS EDIT
        if ($previous_category_id != $sitebusiness->category_id) {
          Engine_Api::_()->getDbtable('profilemaps', 'sitebusiness')->editCategoryMapping($sitebusiness);
        }
      } catch (Exception $e) {
        $db->rollBack();
        throw $e;
      }

      //SUCCESS
      $this->_forward('success', 'utility', 'core', array(
              'smoothboxClose' => 300,
              'parentRefresh' => 300,
              'messages' => array(Zend_Registry::get('Zend_Translate')->_('The category has been changed successfully.'))
      ));
    }
  }

  //ACTION FOR DISPLAY/HIDE FIELDS OF SEARCH FORM
  public function diplayFormAction() {

    $field_id = $this->_getParam('id');
    $display = $this->_getParam('display');
    if (!empty($field_id)) {
      Engine_Api::_()->getDbTable('searchformsetting', 'seaocore')->update(array('display' => $display), array('module = ?' => 'sitebusiness', 'searchformsetting_id =?' => (int) $field_id));
    }
    $this->_redirect('admin/sitebusiness/settings/form-search');
  }

}
?>