<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminDefaultlayoutController.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusiness_AdminDefaultlayoutController extends Core_Controller_Action_Admin {

    //ACTION FOR SETTING THE DEFAULT LAYOUT
    public function indexAction() {

        //GET NAVIGATION
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitebusiness_admin_main', array(), 'sitebusiness_admin_main_layoutdefault');

        //FORM
        $this->view->form = $form = new Sitebusiness_Form_Admin_Layoutdefault();

        //FORM
        if (!Engine_Api::_()->getApi("settings", "core")->getSetting('sitebusiness.layout.coverphotoenabled', 0)) {
            $this->view->coverForm = $coverForm = new Sitebusiness_Form_Admin_CoverPhotoLayout();
        }

        //GET BUSINESS PROFILE BUSINESS INFO
        $selectBusiness = Engine_Api::_()->sitebusiness()->getWidgetizedBusiness();
        if (!empty($selectBusiness)) {
            $this->view->business_id = $selectBusiness->page_id;
        }

        //GET BUSINESS PROFILE BUSINESS INFO
        if (Engine_Api::_()->sitebusiness()->getMobileWidgetizedBusiness()) {
            $this->view->mobile_business_id = Engine_Api::_()->sitebusiness()->getMobileWidgetizedBusiness()->page_id;
        }

        //FORM VALIDATION
        if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost()) || isset($_GET['business_reload'])) {
            //GET FORM VALUES
            $values = $form->getValues();

            //GET ADMIN CONTENT TABLE
            $contentTable = Engine_Api::_()->getDbtable('admincontent', 'sitebusiness');

            //GET ADMIN CONTENT TABLE NAME
            $contentTableName = $contentTable->info('name');

            //GET SITEBUSINESS CONTENT TABLE
            $sitebusinesscontentTable = Engine_Api::_()->getDbtable('content', 'sitebusiness');

            //CORE CONTENT TABLE
            $corecontentTable = Engine_Api::_()->getDbtable('content', 'core');

            //GET SITEBUSINESS CONTENT BUSINESSS TABLE
            $sitebusinessbusinessTable = Engine_Api::_()->getDbtable('contentbusinesses', 'sitebusiness');

            //GET HIDE PROFILE WODGET TABLE
            $hideprofilewidgetsTable = Engine_Api::_()->getDbtable('hideprofilewidgets', 'sitebusiness');

            //DELETING THE OLD ENTRIES
            $hideprofilewidgets = $hideprofilewidgetsTable->select()->query()->fetchAll();
            if (!empty($hideprofilewidgets)) {
                foreach ($hideprofilewidgets as $data) {
                    $hideprofilewidgetsTable->delete(array('hideprofilewidgets_id =?' => $data['hideprofilewidgets_id']));
                }
            }
            $totalBusinesses = $sitebusinessbusinessTable->select()
                            ->from($sitebusinessbusinessTable->info('name'), array('count(*) as count'))
                            ->where('name =?', 'sitebusiness_index_view')->query()->fetchColumn();
            if (isset($_POST['sitebusiness_sitebusiness_layout_setting'])) {
                $layout_option = $_POST['sitebusiness_sitebusiness_layout_setting'];
            } else {
                $layout_option = $_GET['sitebusiness_sitebusiness_layout_setting'];
            }
            $limit = 300;
            $sitebusiness_layout_cover_photo = 1;
            if (isset($_POST['sitebusiness_layout_cover_photo'])) {
                $sitebusiness_layout_cover_photo = $_POST['sitebusiness_layout_cover_photo'];
            }

            $reload_count = round($totalBusinesses / $limit);
            $business_reload = $this->_getParam('business_reload', 1);
            $offset = ($business_reload - 1) * $limit;

            $selectsitebusinessBusiness = $sitebusinessbusinessTable->select()
                    ->from($sitebusinessbusinessTable->info('name'), array('contentbusiness_id'))
                    ->where('name =?', 'sitebusiness_index_view')
                    ->limit($limit, $offset);
            $contentbusinesses_id = $selectsitebusinessBusiness->query()->fetchAll();
            foreach ($contentbusinesses_id as $key => $value) {
                if ($value['contentbusiness_id']) {
                    $sitebusinesscontentTable->delete(array('contentbusiness_id =?' => $value['contentbusiness_id']));
                    if (empty($layout_option)) {
                        Engine_Api::_()->getDbtable('content', 'sitebusiness')->setWithoutTabLayout($value['contentbusiness_id'], $sitebusiness_layout_cover_photo);
                    } else {
                        Engine_Api::_()->getDbtable('content', 'sitebusiness')->setTabbedLayout($value['contentbusiness_id'], $sitebusiness_layout_cover_photo);
                    }
                }
            }

            if ($business_reload == 1) {
                if (!empty($layout_option)) {
                    Engine_Api::_()->getApi("settings", "core")->setSetting('sitebusiness.layout.setting', $layout_option);
                    include_once APPLICATION_PATH . '/application/modules/Sitebusiness/controllers/AdminviewbusinesswidgetController.php';
                    if (!empty($selectBusiness)) {
                        $business_id = $selectBusiness->page_id;
                        $contentTable->delete(array('business_id =?' => $business_id));
                        Engine_Api::_()->getApi('layoutcore', 'sitebusiness')->setTabbedLayoutContent($business_id, $sitebusiness_layout_cover_photo);
                    }

                    if (!empty($business_id)) {
                        //INSERT MAIN CONTAINER
                        $mainContainer = $contentTable->createRow();
                        $mainContainer->business_id = $business_id;
                        $mainContainer->type = 'container';
                        $mainContainer->name = 'main';
                        $mainContainer->order = 2;
                        $mainContainer->save();
                        $container_id = $mainContainer->admincontent_id;

                        //INSERT MAIN-MIDDLE CONTAINER
                        $mainMiddleContainer = $contentTable->createRow();
                        $mainMiddleContainer->business_id = $business_id;
                        $mainMiddleContainer->type = 'container';
                        $mainMiddleContainer->name = 'middle';
                        $mainMiddleContainer->parent_content_id = $container_id;
                        $mainMiddleContainer->order = 6;
                        $mainMiddleContainer->save();
                        $middle_id = $mainMiddleContainer->admincontent_id;

                        //INSERT MAIN-LEFT CONTAINER
                        $mainLeftContainer = $contentTable->createRow();
                        $mainLeftContainer->business_id = $business_id;
                        $mainLeftContainer->type = 'container';
                        $mainLeftContainer->name = 'right';
                        $mainLeftContainer->parent_content_id = $container_id;
                        $mainLeftContainer->order = 4;
                        $mainLeftContainer->save();
                        $left_id = $mainLeftContainer->admincontent_id;
                        $showmaxtab = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.showmore', 8);

                        //INSERT MAIN-MIDDLE TAB CONTAINER
                        $middleTabContainer = $contentTable->createRow();
                        $middleTabContainer->business_id = $business_id;
                        $middleTabContainer->type = 'widget';
                        $middleTabContainer->name = 'core.container-tabs';
                        $middleTabContainer->parent_content_id = $middle_id;
                        $middleTabContainer->order = 10;
                        $middleTabContainer->params = "{\"max\":\"$showmaxtab\"}";
                        $middleTabContainer->save();
                        $middle_tab = $middleTabContainer->admincontent_id;

                        if (empty($sitebusiness_layout_cover_photo)) {
                            Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.business-profile-breadcrumb', $middle_id, 1, '', 'true');

                            //INSERTING BUSINESS PROFILE BUSINESS COVER PHOTO WIDGET
                            if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember')) {
                                Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessmember.businesscover-photo-sitebusinessmembers', $middle_id, 2, '', 'true');
                            }

                            //INSERTING TITLE WIDGET
                            Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.title-sitebusiness', $middle_id, 4, '', 'true');

                            //INSERTING LIKE WIDGET
                            Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'seaocore.like-button', $middle_id, 5, '', 'true');

                            //INSERTING FOLLOW WIDGET
                            Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'seaocore.seaocore-follow', $middle_id, 6, '', 'true');

                            //INSERTING FACEBOOK LIKE WIDGET
                            if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('facebookse')) {
                                Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'Facebookse.facebookse-sitebusinessprofilelike', $middle_id, 7, '', 'true');
                            }

                            //INSERTING MAIN PHOTO WIDGET
                            Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.mainphoto-sitebusiness', $left_id, 10, '', 'true');
                        } else {
                            //INSERTING BUSINESS PROFILE BUSINESS COVER PHOTO WIDGET
                            Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.business-profile-breadcrumb', $middle_id, 1, '', 'true');

                            Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.business-cover-information-sitebusiness', $middle_id, 2, '', 'true');
                        }

                        //INSERTING CONTACT DETAIL WIDGET
                        Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.contactdetails-sitebusiness', $middle_id, 8, '', 'true');

                        //INSERTING OPTIONS WIDGET
                        Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.options-sitebusiness', $left_id, 11, '', 'true');

                        //INSERTING INFORMATION WIDGET
                        Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.information-sitebusiness', $left_id, 10, 'Information', 'true');

                        //INSERTING WRITE SOMETHING ABOUT WIDGET
                        Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'seaocore.people-like', $left_id, 15, '', 'true');

                        //INSERTING RATING WIDGET
                        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessreview')) {
                            Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessreview.ratings-sitebusinessreviews', $left_id, 16, 'Ratings', 'true');
                        }

                        //INSERTING BADGE WIDGET
                        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessbadge')) {
                            Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessbadge.badge-sitebusinessbadge', $left_id, 17, 'Badge', 'true');
                        }

                        //INSERTING YOU MAY ALSO LIKE WIDGET
                        Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.suggestedbusiness-sitebusiness', $left_id, 18, 'You May Also Like', 'true');

                        $social_share_default_code = '{"title":"Social Share","titleCount":true,"code":"<div class=\"addthis_toolbox addthis_default_style \">\r\n<a class=\"addthis_button_preferred_1\"><\/a>\r\n<a class=\"addthis_button_preferred_2\"><\/a>\r\n<a class=\"addthis_button_preferred_3\"><\/a>\r\n<a class=\"addthis_button_preferred_4\"><\/a>\r\n<a class=\"addthis_button_preferred_5\"><\/a>\r\n<a class=\"addthis_button_compact\"><\/a>\r\n<a class=\"addthis_counter addthis_bubble_style\"><\/a>\r\n<\/div>\r\n<script type=\"text\/javascript\">\r\nvar addthis_config = {\r\n          services_compact: \"facebook, twitter, linkedin, google, digg, more\",\r\n          services_exclude: \"print, email\"\r\n}\r\n<\/script>\r\n<script type=\"text\/javascript\" src=\"http:\/\/s7.addthis.com\/js\/250\/addthis_widget.js\"><\/script>","nomobile":"","name":"sitebusiness.socialshare-sitebusiness"}';

                        //INSERTING SOCIAL SHARE WIDGET
                        Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.socialshare-sitebusiness', $left_id, 19, 'Social Share', 'true', $social_share_default_code);

                        //INSERTING INSIGHTS WIDGET
                        Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.insights-sitebusiness', $left_id, 21, 'Insights', 'true');

                        //INSERTING FEATURED OWNER WIDGET
                        Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.featuredowner-sitebusiness', $left_id, 22, 'Owners', 'true');

                        //INSERTING ALBUM WIDGET
                        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessalbum')) {
                            Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.albums-sitebusiness', $left_id, 23, 'Albums', 'true');
                        }

                        //INSERTING BUSINESS PROFILE PLAYER WIDGET
                        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmusic')) {
                            Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessmusic.profile-player', $left_id, 24, '', 'true');
                        }

                        //INSERTING LINKED BUSINESSS WIDGET
                        Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.favourite-business', $left_id, 25, 'Linked Businesses', 'true');

                        //INSERTING ACTIVITY FEED WIDGET
                        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('advancedactivity')) {
                            $advanced_activity_params = '{"title":"Updates","advancedactivity_tabs":["aaffeed"],"nomobile":"0","name":"advancedactivity.home-feeds"}';
                            Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'advancedactivity.home-feeds', $middle_tab, 2, 'Updates', 'true', $advanced_activity_params);
                        } else {
                            Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'activity.feed', $middle_tab, 2, 'Updates', 'true');
                        }

                        //INSERTING INFORAMTION WIDGET
                        Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.info-sitebusiness', $middle_tab, 3, 'Info', 'true');

                        //INSERTING OVERVIEW WIDGET
                        Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.overview-sitebusiness', $middle_tab, 4, 'Overview', 'true');

                        //INSERTING LOCATION WIDGET
                        Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.location-sitebusiness', $middle_tab, 5, 'Map', 'true');

                        //INSERTING LINKS WIDGET
                        Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'core.profile-links', $middle_tab, 125, 'Links', 'true');

                        //INSERTING ALBUM WIDGET
                        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessalbum')) {
                            Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminDefaultInfo('sitebusiness.photos-sitebusiness', $business_id, 'Photos', 'true', '110');
                        }

                        //INSERTING VIDEO WIDGET
                        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessvideo')) {
                            Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminDefaultInfo('sitebusinessvideo.profile-sitebusinessvideos', $business_id, 'Videos', 'true', '111');
                        }

                        //INSERTING NOTE WIDGET
                        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessnote')) {
                            Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminDefaultInfo('sitebusinessnote.profile-sitebusinessnotes', $business_id, 'Notes', 'true', '112');
                        }

                        //INSERTING REVIEW WIDGET
                        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessreview')) {
                            Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminDefaultInfo('sitebusinessreview.profile-sitebusinessreviews', $business_id, 'Reviews', 'true', '113');
                        }

                        //INSERTING FORM WIDGET
                        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessform')) {
                            Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminDefaultInfo('sitebusinessform.sitebusiness-viewform', $business_id, 'Form', 'false', '114');
                        }

                        //INSERTING DOCUMENT WIDGET
                        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessdocument')) {
                            Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminDefaultInfo('sitebusinessdocument.profile-sitebusinessdocuments', $business_id, 'Documents', 'true', '115');
                        }

                        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('document')) {
                            Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminDefaultInfo('document.contenttype-documents', $business_id, 'Documents', 'true', '115');
                        }

                        //INSERTING OFFER WIDGET
                        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessoffer')) {
                            Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminDefaultInfo('sitebusinessoffer.profile-sitebusinessoffers', $business_id, 'Offers', 'true', '116');
                        }

                        //INSERTING EVENT WIDGET
                        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessevent')) {
                            Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminDefaultInfo('sitebusinessevent.profile-sitebusinessevents', $business_id, 'Events', 'true', '117');
                        }

                        //INSERTING EVENT WIDGET
                        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('siteevent')) {
                            Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminDefaultInfo('siteevent.contenttype-events', $business_id, 'Events', 'true', '117');
                        }

                        //INSERTING POLL WIDGET
                        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinesspoll')) {
                            Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminDefaultInfo('sitebusinesspoll.profile-sitebusinesspolls', $business_id, 'Polls', 'true', '118');
                        }

                        //INSERTING DISCUSSION WIDGET
                        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessdiscussion')) {
                            Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminDefaultInfo('sitebusiness.discussion-sitebusiness', $business_id, 'Discussions', 'true', '119');
                        }

                        //INSERTING MUSIC WIDGET
                        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmusic')) {
                            Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminDefaultInfo('sitebusinessmusic.profile-sitebusinessmusic', $business_id, 'Music', 'true', '120');
                        }

                        //INSERTING TWITTER WIDGET
                        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinesstwitter')) {
                            Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminDefaultInfo('sitebusinesstwitter.feeds-sitebusinesstwitter', $business_id, 'Twitter', 'true', '121');
                        }

                        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember')) {
                            Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminDefaultInfo('sitebusinessmember.profile-sitebusinessmembers', $business_id, 'Members', 'true', '122');
                            Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminDefaultInfo('sitebusinessmember.profile-sitebusinessmembers-announcements', $business_id, 'Announcements', 'true', '123');
                        }

                        //INSERTING INTEGRATION WIDGET
                        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessintegration')) {
                            Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminDefaultInfo('sitebusinessintegration.profile-items', $business_id, '', '', '999');
                        }
                        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitecrowdfunding')) {
                            Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminDefaultInfo('sitecrowdfunding.contenttype-projects', $business_id, 'Projects', 'true', '125');
                        }
                        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitemusic')) {
                            Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminDefaultInfo('sitemusic.contenttype-music', $business_id, 'Music', 'true', '126');
                        }
                    }
                } else {
                    //IF EMPTY THEN MAKE BUSINESS PROFILE BUSINESS
                    if (empty($selectBusiness)) {
                        $businessCreate = $businessTable->createRow();
                        $businessCreate->name = 'sitebusiness_index_view';
                        $businessCreate->displayname = 'Business Profile';
                        $businessCreate->title = 'Business Profile';
                        $businessCreate->description = 'This is the business view  business.';
                        $businessCreate->custom = 1;
                        $current_business_id = $businessCreate->save();
                    } else {
                        $current_business_id = $selectBusiness->page_id;
                    }

                    if (!empty($current_business_id)) {
                        $corecontentTable->delete(array('page_id =?' => $current_business_id));
                        Engine_Api::_()->getApi('layoutcore', 'sitebusiness')->setWithoutTabContent($current_business_id, $sitebusiness_layout_cover_photo);
                    }

                    if (!empty($selectBusiness)) {
                        $business_id = $selectBusiness->page_id;
                        $contentTable->delete(array('business_id =?' => $business_id));
                    }
                    //INSERT MAIN CONTAINER
                    $mainContainer = $contentTable->createRow();
                    $mainContainer->business_id = $business_id;
                    $mainContainer->type = 'container';
                    $mainContainer->name = 'main';
                    $mainContainer->order = 2;
                    $mainContainer->save();
                    $container_id = $mainContainer->admincontent_id;

                    //INSERT MAIN-MIDDLE CONTAINER.
                    $mainMiddleContainer = $contentTable->createRow();
                    $mainMiddleContainer->business_id = $business_id;
                    $mainMiddleContainer->type = 'container';
                    $mainMiddleContainer->name = 'middle';
                    $mainMiddleContainer->parent_content_id = $container_id;
                    $mainMiddleContainer->order = 6;
                    $mainMiddleContainer->save();
                    $middle_id = $mainMiddleContainer->admincontent_id;

                    //INSERT MAIN-LEFT CONTAINER.
                    $mainLeftContainer = $contentTable->createRow();
                    $mainLeftContainer->business_id = $business_id;
                    $mainLeftContainer->type = 'container';
                    $mainLeftContainer->name = 'right';
                    $mainLeftContainer->parent_content_id = $container_id;
                    $mainLeftContainer->order = 4;
                    $mainLeftContainer->save();
                    $left_id = $mainLeftContainer->admincontent_id;

                    //INSERTING TITLE WIDGET
                    if (empty($sitebusiness_layout_cover_photo)) {

                        Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.business-profile-breadcrumb', $middle_id, 1, '', 'true');

                        //INSERTING BUSINESS PROFILE BUSINESS COVER PHOTO WIDGET
                        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember')) {
                            Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessmember.businesscover-photo-sitebusinessmembers', $middle_id, 2, '', 'true');
                        }
                        Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.title-sitebusiness', $middle_id, 3, '', 'true');

                        //INSERTING LIKE WIDGET
                        Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'seaocore.like-button', $middle_id, 4, '', 'true');

                        //INSERTING FACEBOOK LIKE WIDGET
                        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('facebookse')) {
                            Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'Facebookse.facebookse-sitebusinessprofilelike', $middle_id, 5, '', 'true');
                        }

                        //INSERTING MAIN PHOTO WIDGET
                        Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.mainphoto-sitebusiness', $left_id, 10, '', 'true');
                    } else {

                        Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.business-profile-breadcrumb', $middle_id, 1, '', 'true');

                        //INSERTING BUSINESS PROFILE BUSINESS COVER PHOTO WIDGET
                        Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.business-cover-information-sitebusiness', $middle_id, 2, '', 'true');
                    }

                    //INSERTING CONTACT DETAIL WIDGET
                    Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.contactdetails-sitebusiness', $middle_id, 5, '', 'true');

                    //INSERTING ACTIVITY FEED WIDGET
                    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('advancedactivity')) {
                        $advanced_activity_params = '{"title":"Updates","advancedactivity_tabs":["aaffeed"],"nomobile":"0","name":"advancedactivity.home-feeds"}';
                        Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'advancedactivity.home-feeds', $middle_id, 6, 'Updates', 'true', $advanced_activity_params);
                    } else {
                        Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'activity.feed', $middle_id, 6, 'Updates', 'true');
                    }

                    //INSERTING INFORAMTION WIDGET
                    Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.info-sitebusiness', $middle_id, 7, 'Info', 'true');

                    //INSERTING OVERVIEW WIDGET
                    Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.overview-sitebusiness', $middle_id, 8, 'Overview', 'true');

                    //INSERTING LOCATION WIDGET
                    Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.location-sitebusiness', $middle_id, 9, 'Map', 'true');

                    //INSERTING LINKS WIDGET
                    Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'core.profile-links', $middle_id, 125, 'Links', 'true');

                    //INSERTING WIDGET LINK WIDGET
                    Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.widgetlinks-sitebusiness', $left_id, 11, '', 'true');

                    //INSERTING OPTIONS WIDGET
                    Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.options-sitebusiness', $left_id, 12, '', 'true');

                    //INSERTING WRITE SOMETHING ABOUT WIDGET
                    Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.write-business', $left_id, 13, '', 'true');

                    //INSERTING INFORMATION WIDGET
                    Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.information-sitebusiness', $left_id, 10, 'Information', 'true');

                    //INSERTING LIKE WIDGET
                    Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'seaocore.people-like', $left_id, 15, '', 'true');

                    //INSERTING RATING WIDGET
                    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessreview')) {
                        Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessreview.ratings-sitebusinessreviews', $left_id, 16, 'Ratings', 'true');
                    }

                    //INSERTING BADGE WIDGET
                    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessbadge')) {
                        Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessbadge.badge-sitebusinessbadge', $left_id, 17, 'Badge', 'true');
                    }

                    $social_share_default_code = '{"title":"Social Share","titleCount":true,"code":"<div class=\"addthis_toolbox addthis_default_style \">\r\n<a class=\"addthis_button_preferred_1\"><\/a>\r\n<a class=\"addthis_button_preferred_2\"><\/a>\r\n<a class=\"addthis_button_preferred_3\"><\/a>\r\n<a class=\"addthis_button_preferred_4\"><\/a>\r\n<a class=\"addthis_button_preferred_5\"><\/a>\r\n<a class=\"addthis_button_compact\"><\/a>\r\n<a class=\"addthis_counter addthis_bubble_style\"><\/a>\r\n<\/div>\r\n<script type=\"text\/javascript\">\r\nvar addthis_config = {\r\n          services_compact: \"facebook, twitter, linkedin, google, digg, more\",\r\n          services_exclude: \"print, email\"\r\n}\r\n<\/script>\r\n<script type=\"text\/javascript\" src=\"http:\/\/s7.addthis.com\/js\/250\/addthis_widget.js\"><\/script>","nomobile":"","name":"sitebusiness.socialshare-sitebusiness"}';

                    //INSERTING SOCIAL SHARE WIDGET
                    Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.socialshare-sitebusiness', $left_id, 19, 'Social Share', 'true', $social_share_default_code);

                    //INSERTING INSIGHTS WIDGET
                    Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.insights-sitebusiness', $left_id, 22, 'Insights', 'true');

                    //INSERTING FEATURED OWNER WIDGET
                    Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.featuredowner-sitebusiness', $left_id, 23, 'Owners', 'true');

                    //INSERTING ALBUM WIDGET
                    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessalbum')) {
                        Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.albums-sitebusiness', $left_id, 24, 'Albums');
                        Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminContentDefaultInfoWithoutTab('sitebusiness.photos-sitebusiness', $business_id, 'Photos', 'true', '110');
                    }

                    //INSERTING BUSINESS PROFILE PLAYER WIDGET
                    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmusic')) {
                        Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessmusic.profile-player', $left_id, 25, '', 'true');
                    }

                    //INSERTING LINKED BUSINESSS WIDGET
                    Engine_Api::_()->sitebusiness()->setDefaultDataWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.favourite-business', $left_id, 26, 'Linked Businesses', 'true');

                    //INSERTING VIDEO WIDGET
                    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessvideo')) {
                        Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminContentDefaultInfoWithoutTab('sitebusinessvideo.profile-sitebusinessvideos', $business_id, 'Videos', 'true', '111');
                    }

                    //INSERTING NOTE WIDGET
                    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessnote')) {
                        Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminContentDefaultInfoWithoutTab('sitebusinessnote.profile-sitebusinessnotes', $business_id, 'Notes', 'true', '112');
                    }

                    //INSERTING REVIEW WIDGET
                    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessreview')) {
                        Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminContentDefaultInfoWithoutTab('sitebusinessreview.profile-sitebusinessreviews', $business_id, 'Reviews', 'true', '113');
                    }

                    //INSERTING FORM WIDGET
                    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessform')) {
                        Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminContentDefaultInfoWithoutTab('sitebusinessform.sitebusiness-viewform', $business_id, 'Form', 'false', '114');
                    }

                    //INSERTING DOCUMENT WIDGET
                    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessdocument')) {
                        Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminContentDefaultInfoWithoutTab('sitebusinessdocument.profile-sitebusinessdocuments', $business_id, 'Documents', 'true', '115');
                    }

                     if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('document')) {
                            Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminContentDefaultInfoWithoutTab('document.contenttype-documents', $business_id, 'Documents', 'true', '115');
                        }

                    //INSERTING OFFER WIDGET
                    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessoffer')) {
                        Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminContentDefaultInfoWithoutTab('sitebusinessoffer.profile-sitebusinessoffers', $business_id, 'Offers', 'true', '116');
                    }

                    //INSERTING EVENT WIDGET
                    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessevent')) {
                        Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminContentDefaultInfoWithoutTab('sitebusinessevent.profile-sitebusinessevents', $business_id, 'Events', 'true', '117');
                    }

                    //INSERTING EVENT WIDGET
                    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('siteevent')) {
                        Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminContentDefaultInfoWithoutTab('siteevent.contenttype-events', $business_id, 'Events', 'true', '117');
                    }

                    //INSERTING POLL WIDGET
                    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinesspoll')) {
                        Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminContentDefaultInfoWithoutTab('sitebusinesspoll.profile-sitebusinesspolls', $business_id, 'Polls', 'true', '118');
                    }

                    //INSERTING DISCUSSION WIDGET
                    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessdiscussion')) {
                        Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminContentDefaultInfoWithoutTab('sitebusiness.discussion-sitebusiness', $business_id, 'Discussions', 'true', '119');
                    }

                    //INSERTING MUSIC WIDGET
                    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmusic')) {
                        Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminContentDefaultInfoWithoutTab('sitebusinessmusic.profile-sitebusinessmusic', $business_id, 'Music', 'true', '120');
                    }
                    //INSERTING TWITTER WIDGET
                    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinesstwitter')) {
                        Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminContentDefaultInfoWithoutTab('sitebusinesstwitter.feeds-sitebusinesstwitter', $business_id, 'Twitter', 'true', '121');
                    }

                    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember')) {
                        Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminContentDefaultInfoWithoutTab('sitebusinessmember.profile-sitebusinessmembers', $business_id, 'Members', 'true', '122');
                        Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminContentDefaultInfoWithoutTab('sitebusinessmember.profile-sitebusinessmembers-announcements', $business_id, 'Announcements', 'true', '123');
                    }

                    //INSERTING INTEGRATION WIDGET
                    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessintegration')) {
                        Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminContentDefaultInfoWithoutTab('sitebusinessintegration.profile-items', $business_id, '', '', '999');
                    }
                    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitecrowdfunding')) {
                        Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminContentDefaultInfoWithoutTab('sitecrowdfunding.contenttype-projects', $business_id, 'Projects', 'true', '125');
                    }
                    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitemusic')) {
                        Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminContentDefaultInfoWithoutTab('sitemusic.contenttype-music', $business_id, 'Projects', 'true', '126');
                    }
                }
            }
            Engine_Api::_()->getApi("settings", "core")->setSetting('sitebusiness.layout.setting', $layout_option);
            Engine_Api::_()->getApi("settings", "core")->setSetting('sitebusiness.layout.coverphotoenabled', 1);

            Engine_Api::_()->getApi("settings", "core")->setSetting('sitebusiness.layout.cover.photo', $sitebusiness_layout_cover_photo);
            if ($business_reload < $reload_count) {
                $business_reload++;
                $this->_redirect("admin/sitebusiness/defaultlayout/index?business_reload=$business_reload&sitebusiness_sitebusiness_layout_setting=$layout_option");
            }

            $this->_forward('success', 'utility', 'core', array(
                'smoothboxClose' => false,
                'redirect' => $this->view->url(array('module' => 'sitebusiness', 'controller' => 'defaultlayout'), 'admin_default', true),
                'messages' => array(Zend_Registry::get('Zend_Translate')->_('<div class="tip" style="margin:10px auto;width:750px;"><span>Please do not close this business or navigate to another business till you see a default layout changes completion or error message.</span></div><div>
					<center><img src="application/modules/Sitebusiness/externals/images/layout/uploading.gif" alt="" /></center>
				</div>'))
            ));
        }
    }

    //ACTION FOR SAVING THE LAYOUT
    public function savelayoutAction() {

        $this->_helper->layout->setLayout('admin-simple');
    }

    public function saveCoverBusinessLayoutAction() {


        if (Engine_Api::_()->getApi("settings", "core")->getSetting('sitebusiness.layout.coverphotoenabled', 0) && $this->getRequest()->isPost())
            return;
        $db = Engine_Db_Table::getDefaultAdapter();
        $coreContentTable = Engine_Api::_()->getDbtable('content', 'core');
        $coreContentTableName = $coreContentTable->info('name');
        $corePagesTable = Engine_Api::_()->getDbtable('pages', 'core');
        $corePagesTableName = $corePagesTable->info('name');
        $adminContentTable = Engine_Api::_()->getDbtable('admincontent', 'sitebusiness');
        $adminContentTableName = $adminContentTable->info('name');
        $businessContentTable = Engine_Api::_()->getDbtable('content', 'sitebusiness');
        $businessContentTableName = $businessContentTable->info('name');
        $coreContentBusinessID = $corePagesTable->select()->from($corePagesTableName, array('page_id'))->where('name =?', 'sitebusiness_index_view')->query()->fetchColumn();
        $adminContentId = $adminContentTable->select()->from($adminContentTableName, array('name'))->where('business_id =?', $coreContentBusinessID)->where('name =?', 'left')->where('name =?', 'right')->query()->fetchColumn();
        $sitebusinessCoverPhoto = $_POST['sitebusiness_sitebusiness_layout_coverphoto'];
        if ($_POST['sitebusiness_sitebusiness_layout_coverphoto'] == 1) {
            $current = 'right';
            $prev = 'left';
        } else {
            $current = 'left';
            $prev = 'right';
        }
        if (empty($adminContentId)) {
            $adminContentCurrentColumn = $adminContentTable->select()->from($adminContentTableName, array('name'))->where('name =?', $prev)->where('business_id =?', $coreContentBusinessID)->query()->fetchColumn();
            if ($adminContentCurrentColumn) {
                $adminContentTable->update(array('name' => $current), array('name=?' => $prev, 'business_id =?' => $coreContentBusinessID));
            }

            $adminContentTable->delete(array('name =?' => 'sitebusiness.mainphoto-sitebusiness'));
            $adminContentTable->delete(array('name =?' => 'sitebusinessmember.profile-sitebusinessmembers-announcements'));
            $adminContentTable->delete(array('name =?' => 'seaocore.like-button'));
            $adminContentTable->delete(array('name =?' => 'seaocore.seaocore-follow'));
            $adminContentTable->delete(array('name =?' => 'facebookse.facebookse-commonlike'));
            $adminContentTable->delete(array('name =?' => 'sitebusiness.title-sitebusiness'));
            $adminContentTable->delete(array('name =?' => 'sitebusiness.photorecent-sitebusiness'));
        }

        $businessContentId = $businessContentTable->select()->from($businessContentTableName, array('name'))->where('name =?', 'left')->where('name =?', 'right')->query()->fetchColumn();

        if (empty($businessContentId)) {
            $businessContentCurrentColumn = $businessContentTable->select()->from($businessContentTableName, array('name'))->where('name =?', $prev)->query()->fetchColumn();
            if ($businessContentCurrentColumn) {
                $businessContentTable->update(array('name' => $current), array('name=?' => $prev));
            }

            $businessContentTable->delete(array('name =?' => 'sitebusiness.mainphoto-sitebusiness'));
            $businessContentTable->delete(array('name =?' => 'sitebusiness.photorecent-sitebusiness'));
            $businessContentTable->delete(array('name =?' => 'sitebusinessmember.profile-sitebusinessmembers-announcements'));
            $businessContentTable->delete(array('name =?' => 'seaocore.like-button'));
            $businessContentTable->delete(array('name =?' => 'seaocore.seaocore-follow'));
            $businessContentTable->delete(array('name =?' => 'facebookse.facebookse-commonlike'));
            $businessContentTable->delete(array('name =?' => 'sitebusiness.title-sitebusiness'));
        }

        $coreContentId = $coreContentTable->select()->from($coreContentTableName, array('name'))->where('page_id =?', $coreContentBusinessID)->where('name =?', 'left')->where('name =?', 'right')->query()->fetchColumn();

        if (empty($coreContentId)) {
            $coreContentCurrentColumn = $coreContentTable->select()->from($coreContentTableName, array('name'))->where('page_id =?', $coreContentBusinessID)->where('name =?', $prev)->where('name =?', $prev)->where('page_id =?', $coreContentBusinessID)->query()->fetchColumn();
            if ($coreContentCurrentColumn) {
                $coreContentTable->update(array('name' => $current), array('name=?' => $prev, 'page_id =?' => $coreContentBusinessID));
            }

            $coreContentTable->delete(array('name =?' => 'sitebusiness.mainphoto-sitebusiness'));
            $coreContentTable->delete(array('name =?' => 'sitebusiness.photorecent-sitebusiness'));
            $coreContentTable->delete(array('name =?' => 'sitebusinessmember.profile-sitebusinessmembers-announcements'));
            $coreContentTable->delete(array('name =?' => 'seaocore.like-button'));
            $coreContentTable->delete(array('name =?' => 'seaocore.seaocore-follow'));
            $coreContentTable->delete(array('name =?' => 'facebookse.facebookse-commonlike'));
            $coreContentTable->delete(array('name =?' => 'sitebusiness.title-sitebusiness'));
        }

        Engine_Api::_()->getApi("settings", "core")->setSetting('sitebusiness.layout.coverphotoenabled', 1);
        Engine_Api::_()->getApi("settings", "core")->setSetting('sitebusiness.layout.coverphoto', $sitebusinessCoverPhoto);

        $select = new Zend_Db_Select($db);
        $select_business = $select
                ->from('engine4_core_pages', 'page_id')
                ->where('name = ?', 'sitebusiness_index_view')
                ->limit(1);
        $business = $select_business->query()->fetchAll();

        if (!empty($business)) {
            $business_id = $business[0]['page_id'];

            //INSERTING THE MEMBER WIDGET IN SITEBUSINESS_CONTENT TABLE ALSO.
            $select = new Zend_Db_Select($db);
            $contentbusiness_ids = $select->from('engine4_sitebusiness_contentbusinesses', 'contentbusiness_id')->query()->fetchAll();
            foreach ($contentbusiness_ids as $contentbusiness_id) {
                if (!empty($contentbusiness_id)) {

                    $select = new Zend_Db_Select($db);
                    $select_content = $select
                            ->from('engine4_sitebusiness_content')
                            ->where('contentbusiness_id = ?', $contentbusiness_id['contentbusiness_id'])
                            ->where('type = ?', 'widget')
                            ->where('name = ?', 'sitebusiness.business-cover-information-sitebusiness')
                            ->limit(1);
                    $content = $select_content->query()->fetchAll();
                    if (empty($content)) {
                        $select = new Zend_Db_Select($db);
                        $select_container = $select
                                ->from('engine4_sitebusiness_content', 'content_id')
                                ->where('contentbusiness_id = ?', $contentbusiness_id['contentbusiness_id'])
                                ->where('type = ?', 'container')
                                ->limit(1);
                        $container = $select_container->query()->fetchAll();
                        if (!empty($container)) {
                            $container_id = $container[0]['content_id'];
                            $select = new Zend_Db_Select($db);
                            $select_left = $select
                                    ->from('engine4_sitebusiness_content')
                                    ->where('parent_content_id = ?', $container_id)
                                    ->where('type = ?', 'container')
                                    ->where('name = ?', 'middle')
                                    ->limit(1);
                            $middle = $select_left->query()->fetchAll();
                            if (!empty($middle)) {
                                $middle_id = $middle[0]['content_id'];
                                $db->insert('engine4_sitebusiness_content', array(
                                    'contentbusiness_id' => $contentbusiness_id['contentbusiness_id'],
                                    'type' => 'widget',
                                    'name' => 'sitebusiness.business-cover-information-sitebusiness',
                                    'parent_content_id' => $middle_id,
                                    'order' => 1,
                                    'params' => '{"title":""}',
                                ));
                            }
                        }
                    }
                }
            }

            $select = new Zend_Db_Select($db);
            $select_content = $select
                    ->from('engine4_sitebusiness_admincontent')
                    ->where('business_id = ?', $business_id)
                    ->where('type = ?', 'widget')
                    ->where('name = ?', 'sitebusiness.business-cover-information-sitebusiness')
                    ->limit(1);
            $content = $select_content->query()->fetchAll();
            if (empty($content)) {
                $select = new Zend_Db_Select($db);
                $select_container = $select
                        ->from('engine4_sitebusiness_admincontent', 'admincontent_id')
                        ->where('business_id = ?', $business_id)
                        ->where('type = ?', 'container')
                        ->limit(1);
                $container = $select_container->query()->fetchAll();
                if (!empty($container)) {
                    $container_id = $container[0]['admincontent_id'];
                    $select = new Zend_Db_Select($db);
                    $select_left = $select
                            ->from('engine4_sitebusiness_admincontent')
                            ->where('parent_content_id = ?', $container_id)
                            ->where('type = ?', 'container')
                            ->where('name = ?', 'middle')
                            ->limit(1);
                    $middle = $select_left->query()->fetchAll();
                    if (!empty($middle)) {
                        $middle_id = $middle[0]['admincontent_id'];
                        $db->insert('engine4_sitebusiness_admincontent', array(
                            'business_id' => $business_id,
                            'type' => 'widget',
                            'name' => 'sitebusiness.business-cover-information-sitebusiness',
                            'parent_content_id' => $middle_id,
                            'order' => 1,
                            'params' => '{"title":""}',
                        ));
                    }
                }
            }

            $select = new Zend_Db_Select($db);
            $select_content = $select
                    ->from('engine4_core_content')
                    ->where('page_id = ?', $business_id)
                    ->where('type = ?', 'widget')
                    ->where('name = ?', 'sitebusiness.business-cover-information-sitebusiness')
                    ->limit(1);
            $content = $select_content->query()->fetchAll();
            if (empty($content)) {
                $select = new Zend_Db_Select($db);
                $select_container = $select
                        ->from('engine4_core_content', 'content_id')
                        ->where('page_id = ?', $business_id)
                        ->where('type = ?', 'container')
                        ->limit(1);
                $container = $select_container->query()->fetchAll();
                if (!empty($container)) {
                    $container_id = $container[0]['content_id'];
                    $select = new Zend_Db_Select($db);
                    $select_left = $select
                            ->from('engine4_core_content')
                            ->where('parent_content_id = ?', $container_id)
                            ->where('type = ?', 'container')
                            ->where('name = ?', 'middle')
                            ->limit(1);
                    $middle = $select_left->query()->fetchAll();
                    if (!empty($middle)) {
                        $middle_id = $middle[0]['content_id'];
                        $db->insert('engine4_core_content', array(
                            'page_id' => $business_id,
                            'type' => 'widget',
                            'name' => 'sitebusiness.business-cover-information-sitebusiness',
                            'parent_content_id' => $middle_id,
                            'order' => 1,
                            'params' => '{"title":""}',
                        ));
                    }
                }
            }
        }

        $this->_redirect("admin/sitebusiness/defaultlayout/index");
    }

    //ACTION FOR SAVING THE LAYOUT
    public function setCoverBusinessLayoutAction() {

        $this->_helper->layout->setLayout('admin-simple');
    }

}

?>