<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: IndexController.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusiness_IndexController extends Seaocore_Controller_Action_Standard
{

  protected $_navigation;

  //SET THE VALUE FOR ALL ACTION DEFAULT
  public function init()
  {

    //CHECK VIEW PRIVACY
    if( !$this->_helper->requireAuth()->setAuthParams('sitebusiness_business', null, 'view')->isValid() )
      return;

    $ajaxContext = $this->_helper->getHelper('AjaxContext');
    $ajaxContext
      ->addActionContext('rate', 'json')
      ->addActionContext('validation', 'html')
      ->initContext();

    //GET BUSINESS ID AND BUSINESS URL
    $business_url = $this->_getParam('business_url', null);
    $business_id = $this->_getParam('business_id', null);

    if( $business_url ) {
      $business_id = Engine_Api::_()->sitebusiness()->getBusinessId($business_url);
    }
    if( $business_id ) {
      $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
      if( $sitebusiness ) {
        Engine_Api::_()->core()->setSubject($sitebusiness);
      }
    }

    //FOR UPDATE EXPIRATION
    if( (Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.task.updateexpiredbusinesses') + 900) <= time() ) {
      Engine_Api::_()->sitebusiness()->updateExpiredBusinesses();
    }
  }

  //ACTION FOR SHOWING THE BUSINESS LIST
  public function indexAction()
  {

    $searchForm = new Sitebusiness_Form_Search(array('type' => 'sitebusiness_business'));
    Zend_Registry::set('Sitebusiness_Form_Search', $searchForm);

    $coremodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core');
    $coreversion = $coremodule->version;
    if( empty(Engine_Api::_()->seaocore()->checkVersion($coreversion, '4.1.0')) ) {
      $this->_helper->content->render();
    } else {
      $this->_helper->content
        ->setNoRender()
        ->setEnabled();
    }
  }

  //ACTION FOR SHOWING THE BUSINESS LIST
  public function pinboardBrowseAction()
  {

    $coremodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core');
    $coreversion = $coremodule->version;
    if( empty(Engine_Api::_()->seaocore()->checkVersion($coreversion, '4.1.0')) ) {
      $this->_helper->content->render();
    } else {
      $this->_helper->content
        ->setNoRender()
        ->setContentName("sitebusiness_index_pinboard_browse")
        ->setEnabled();
    }
  }

  //ACTION FOR SHOWING THE HOME BUSINESS
  public function homeAction()
  {

    $coremodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core');
    $coreversion = $coremodule->version;
    if( empty(Engine_Api::_()->seaocore()->checkVersion($coreversion, '4.1.0')) ) {
      $this->_helper->content->render();
    } else {
      $this->_helper->content
        ->setNoRender()
        ->setEnabled();
    }
  }

  //ACTION FOR BROWSE LOCATION BUSINESSS.
  public function mapAction()
  {

    $enableLocation = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.locationfield', 1);

    if( empty($enableLocation) ) {
      return $this->_forwardCustom('notfound', 'error', 'core');
    } else {
      $this->_helper->content->setEnabled();
    }
  }

  //ACTION FOR BROWSE LOCATION BUSINESSS.
  public function mobilemapAction()
  {

    $enableLocation = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.locationfield', 1);

    if( empty($enableLocation) ) {
      return $this->_forwardCustom('notfound', 'error', 'core');
    } else {
      $this->_helper->content->setEnabled();
    }
  }

  //ACTION FOR SHOWING SPONSERED BUSINESS AT HOME BUSINESS
  public function homeSponsoredAction()
  {

    //RETURN THE OBJECT OF LIMIT PER BUSINESS FROM CORE SETTING TABLE
    $limit_sitebusiness = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.sponserdsitebusiness.widgets', 4);

    $totalSitebusiness = Engine_Api::_()->getDbTable('business', 'sitebusiness')->getListings('Total Sponsored Sitebusiness', array(), null, null, array('business_id'));

    // Total Count Sponsored Business
    $totalCount = $totalSitebusiness->count();

    //RETRIVE THE VALUE OF START INDEX
    $startindex = $_GET['startindex'];

    if( $startindex > $totalCount ) {
      $startindex = $totalCount - $limit_sitebusiness;
    }

    if( $startindex < 0 ) {
      $startindex = 0;
    }

    //RETRIVE THE VALUE OF BUTTON DIRECTION
    $this->view->direction = $_GET['direction'];
    $values['start_index'] = $startindex;
    $values['totalbusinesses'] = $_GET['limit'];
    $values['category_id'] = $_GET['category_id'];
    $this->view->titletruncation = $_GET['titletruncation'];
    $this->view->totalbusinesses = $_GET['limit'];

    $this->view->sitebusinesses = $result = Engine_Api::_()->getDbTable('business', 'sitebusiness')->getListings('Sponsored Sitebusiness AJAX', $values, null, null, array('business_id', 'photo_id', 'owner_id', 'title', 'business_url'));

    //Pass the total number of result in tpl file
    $this->view->count = count($result);
  }

  //ACTION FOR SHOWING SPONSORED LISTINGS IN WIDGET
  public function ajaxCarouselAction()
  {

    //SEAOCORE API
    $this->view->seacore_api = Engine_Api::_()->seaocore();

    //RETURN THE OBJECT OF LIMIT PER BUSINESS FROM CORE SETTING TABLE
    $this->view->sponserdSitebusinessesCount = $limit_sitebusiness = $_GET['curnt_limit'];
    $limit_sitebusiness_horizontal = $limit_sitebusiness * 2;

    $values = array();
    $values = $this->_getAllParams();

    //GET COUNT
    $totalCount = $_GET['total'];

    //RETRIVE THE VALUE OF START INDEX
    $startindex = $_GET['startindex'];

    if( $startindex > $totalCount ) {
      $startindex = $totalCount - $limit_sitebusiness;
    }

    if( $startindex < 0 ) {
      $startindex = 0;
    }

    $this->view->sponsoredIcon = $this->_getParam('sponsoredIcon', 1);
    //$this->view->showOptions = $this->_getParam('showOptions', array("category", "rating", "review"));
    $this->view->featuredIcon = $this->_getParam('featuredIcon', 1);
    //RETRIVE THE VALUE OF BUTTON DIRECTION
    $this->view->direction = $_GET['direction'];
    $values['start_index'] = $startindex;
    $sitebusinessTable = Engine_Api::_()->getDbTable('business', 'sitebusiness');
    $this->view->totalItemsInSlide = $values['limit'] = $limit_sitebusiness_horizontal;
    $this->view->popularity = $values['popularity'] = $this->_getParam('popularity', 'business_id');
    $this->view->fea_spo = $fea_spo = $this->_getParam('fea_spo', null);
    if( $fea_spo == 'featured' ) {
      $values['featured'] = 1;
    } elseif( $fea_spo == 'sponsored' ) {
      $values['sponsored'] = 1;
    } elseif( $fea_spo == 'fea_spo' ) {
      $values['sponsored'] = 1;
      $values['featured'] = 1;
    }

    //GET LISTINGS
    $this->view->sitebusinesses = $sitebusinessTable->getListing('', $values);
    $this->view->count = count($this->view->sitebusinesses);
    $this->view->vertical = $_GET['vertical'];
    $this->view->ratingType = $this->_getParam('ratingType', 'rating');
    $this->view->title_truncation = $this->_getParam('title_truncation', 50);
    $this->view->blockHeight = $this->_getParam('blockHeight', 245);
    $this->view->blockWidth = $this->_getParam('blockWidth', 150);
    $this->view->statistics = Zend_Json_Decoder::decode($this->_getParam('statistics'));
  }

  //ACTION FOR BUSINESS PROFILE BUSINESS
  public function viewAction()
  {

    if( !Engine_Api::_()->core()->hasSubject('sitebusiness_business') )
      return $this->_forwardCustom('notfound', 'error', 'core');

    //VIEWER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewer_id = $viewer->getIdentity();

    //GET SUBJECT AND BUSINESS ID
    $this->view->sitebusiness = $sitebusiness = Engine_Api::_()->core()->getSubject('sitebusiness_business');

    $levelHost = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.level.createhost', 0);
    $package = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.lsettings', 0);

    //Start business member work for privacy.
    $this->view->sitebusinessMemberEnabled = $sitebusinessMemberEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember');
    if( !empty($sitebusinessMemberEnabled) ) {
      $this->view->member_approval = $sitebusiness->member_approval;
      $this->view->hasMembers = Engine_Api::_()->getDbTable('membership', 'sitebusiness')->hasMembers($viewer_id, $sitebusiness->business_id);

      //START MANAGE-ADMIN CHECK
      $this->view->viewPrivacy = $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'view');
      if( empty($isManageAdmin) ) {
        if( !$sitebusiness->isViewableByNetwork() ) {
          return $this->_forwardCustom('requireauth', 'error', 'core');
        } else {
          return;
        }
      }

      //BUSINESS VIEW AUTHORIZATION
      if( !Engine_Api::_()->sitebusiness()->canViewBusiness($sitebusiness) ) {
        return;
      }
    } else {
      //START MANAGE-ADMIN CHECK
      $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'view');
      if( empty($isManageAdmin) ) {
        return $this->_forwardCustom('requireauth', 'error', 'core');
      }

      //BUSINESS VIEW AUTHORIZATION
      if( !Engine_Api::_()->sitebusiness()->canViewBusiness($sitebusiness) ) {
        return $this->_forwardCustom('requireauth', 'error', 'core');
      }
    }
    //End business member work for privacy.

    $LevelHost = $this->checkLevelHost($levelHost, 'sitebusiness');

    //INCREMENT IN NUMBER OF VIEWS
    $PackagesHost = $this->checkPackageHost($package);

    if( ($PackagesHost != $LevelHost) && ($sitebusiness->view_count % 20 == $maxView) ) {
      Engine_Api::_()->sitebusiness()->setDisabledType();
      Engine_Api::_()->getItemtable('sitebusiness_package')->setEnabledPackages();
    }

    $edit_layout_setting = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.layoutcreate', 0);

    //OPEN TAB IN NEW PAGE
    if( !$edit_layout_setting && $this->renderWidgetCustom() )
      return;

    //OPEN TAB IN NEW PAGE
    if( $edit_layout_setting && $this->renderUserWidgetCustom() )
      return;

    $this->view->can_edit_overview = $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'overview');

    $this->view->headLink()
      ->appendStylesheet($this->view->layout()->staticBaseUrl . 'application/modules/Sitebusiness/externals/styles/style_sitebusiness_profile.css');

    $commonCss = Engine_Api::_()->getApi('settings', 'core')->getSetting('seaocore.common.css');
    $pageEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitepage');
    $groupEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitegroup');


    if( $commonCss && $pageEnabled && $groupEnabled ) {
      $this->view->headLink()->appendStylesheet($this->view->layout()->staticBaseUrl . 'application/modules/Sitepage/externals/styles/common_style_page_business_group.css');
    } elseif( $commonCss && $pageEnabled ) {
      $this->view->headLink()->appendStylesheet($this->view->layout()->staticBaseUrl . 'application/modules/Sitepage/externals/styles/common_style_page_business.css');
    } elseif( $commonCss && $groupEnabled ) {
      $this->view->headLink()->appendStylesheet($this->view->layout()->staticBaseUrl . 'application/modules/Sitebusiness/externals/styles/common_style_business_group.css');
    } else {
      $this->view->headLink()->appendStylesheet($this->view->layout()->staticBaseUrl . 'application/modules/Sitebusiness/externals/styles/style_sitebusiness.css');
    }

    if( !$sitebusiness->all_post && !Engine_Api::_()->sitebusiness()->isBusinessOwner($sitebusiness) ) {
      $this->view->headStyle()->appendStyle(".activity-post-container{
    display:none;
    }");
      $this->view->headStyle()->appendStyle(".adv_post_container_box{
    display:none;
    }");
    }
    if( Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessalbum') ) {
      $this->view->headLink()
        ->appendStylesheet($this->view->layout()->staticBaseUrl . 'application/modules/Sitebusinessalbum/externals/styles/style_sitebusinessalbum.css'
      );
    }

    //CALL FUNCTION FOR INCRESING THE MEMORY LIMIT
    $this->setPhpIniMemorySize();
    $maxView = 19;

    $businessStatistics = <<<EOF
       en4.core.runonce.add(function(){
        en4.sitebusiness.businessStatistics("$sitebusiness->business_id");
       });
EOF;
    $this->view->headScript()->appendScript($businessStatistics);

    $style = $sitebusiness->getBusinessStyle();
    if( !empty($style) ) {
      $this->view->headStyle()->appendStyle($style);
    }

    if( null !== ($tab = $this->_getParam('tab')) ) {
      //PROVIDE WIDGETISE BUSINESSS
      $businessprofile_tab_function = <<<EOF
                                        var content_id = "$tab";
                                        this.onload = function()
                                        {
      																		if(window.tabContainerSwitch)
      																		{
                                              tabContainerSwitch($('main_tabs').getElement('.tab_' + content_id));
																					}
                                        }
EOF;
      $this->view->headScript()->appendScript($businessprofile_tab_function);
    }

    $isPWAMode = method_exists(Engine_API::_()->seaocore(), 'isSitePWAMode') && Engine_API::_()->seaocore()->isSitePWAMode();
    if(!$isPWAMode && !empty($edit_layout_setting)  ) {
      $showHideHeaderFooter = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.show.hide.header.footer', 'default');
      if( $showHideHeaderFooter == 'default-simple' ) {
        $this->_helper->layout->setLayout('default-simple');
      }
      $cont = Engine_Content::getInstance();

      if( Engine_API::_()->seaocore()->checkSitemobileMode('fullsite-mode') ) {
        $storage = Engine_Api::_()->getDbtable('contentbusinesses', 'sitebusiness');
      } else {
        $storage = Engine_Api::_()->getDbtable('mobileContentbusinesses', 'sitebusiness');
      }

      $cont->setStorage($storage);
      $this->view->sitemain = $this->view->content('sitebusiness_index_view');
      $cont = Engine_Content::getInstance();
      $storage = Engine_Api::_()->getDbtable('pages', 'core');
      $cont->setStorage($storage);
    } else {
      $viewPrivacy = empty($isManageAdmin) && !empty($sitebusinessMemberEnabled) && empty($this->view->hasMembers);
      if( !$viewPrivacy ) {
        $this->_helper->content->setNoRender()->setEnabled();
      } else {
        $this->view->sitemain = $this->view->content('sitebusiness_index_view');
        $cont = Engine_Content::getInstance();
        $storage = Engine_Api::_()->getDbtable('pages', 'core');
        $cont->setStorage($storage);
      }
    }

    // Start: Suggestion work.
    $is_moduleEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('suggestion');
    // Here we are delete this poll suggestion if viewer have.
    if( !empty($is_moduleEnabled) ) {
      Engine_Api::_()->getApi('suggestion', 'sitebusiness')->deleteSuggestion($viewer->getIdentity(), 'sitebusiness', $sitebusiness->business_id, 'business_suggestion');
    }
    // End: Suggestion work.
    //NAVIGATION WORK FOR FOOTER.(DO NOT DISPLAY NAVIGATION IN FOOTER ON VIEW BUSINESS.)
    if( !Engine_API::_()->seaocore()->checkSitemobileMode('fullsite-mode') ) {
      if( !Zend_Registry::isRegistered('sitemobileNavigationName') ) {
        Zend_Registry::set('sitemobileNavigationName', 'setNoRender');
      }
    }
    if( Engine_Api::_()->seaocore()->isSitemobileApp() ) {
      Zend_Registry::set('setFixedCreationFormBack', 'Back');
    }
  }

  //ACTINO FOR MANAGING MY BUSINESSS
  public function manageAction()
  {

    //USER VALDIATION
    if( !$this->_helper->requireUser()->isValid() )
      return;

    $this->view->autoContentLoad = $isappajax = $this->_getParam('isappajax', 0);
    $sitebusiness_manage = Zend_Registry::isRegistered('sitebusiness_manage') ? Zend_Registry::get('sitebusiness_manage') : null;

    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();

    //BUSINESS CREATION PRIVACY
    $this->view->can_create = $this->_helper->requireAuth()->setAuthParams('sitebusiness_business', null, 'create')->checkRequire();

    if( empty($this->view->can_create) ) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }
    if( !Engine_API::_()->seaocore()->checkSitemobileMode('fullsite-mode') ) {
      $this->view->can_edit = $this->_helper->requireAuth()->setAuthParams('sitebusiness_business', null, 'edit')->checkRequire();
      $this->view->enablePrice = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.price.field', 1);
      $this->view->enableLocation = $checkLocation = Engine_Api::_()->sitebusiness()->enableLocation();
      $this->view->can_delete = $this->_helper->requireAuth()->setAuthParams('sitebusiness_business', null, 'delete')->checkRequire();

      Engine_Api::_()->getDbtable('businessstatistics', 'sitebusiness')->setViews();

      //GET VIEWER CLAIMS
      $claim_id = Engine_Api::_()->getDbtable('claims', 'sitebusiness')->getViewerClaims($viewer_id);

      //CLAIM IS ENABLED OR NOT
      $canClaim = Engine_Api::_()->authorization()->getPermission($viewer->level_id, 'sitebusiness_business', 'claim');

      $this->view->showClaimLink = 0;
      if( !empty($claim_id) && !empty($canClaim) ) {
        $this->view->showClaimLink = 1;
      }

      //NAVIGATION
      $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
        ->getNavigation('sitebusiness_main');

      //QUICK NAVIGATION
      $this->view->quickNavigation = $quickNavigation = Engine_Api::_()->getApi('menus', 'core')
        ->getNavigation('sitebusiness_quick');

      //FORM GENERATION
      $this->view->form = $form = new Sitebusiness_Form_Managesearch(array(
        'type' => 'sitebusiness_business'
      ));

      $form->removeElement('show');

      //SITEBUSINESS-REVIEW IS ENABLED OR NOT
      $this->view->ratngShow = $ratingShow = (int) Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessreview');

      //CHECK THAT WE HAVE TO SHOW MANAGE ADMIN LINK OR NOTE
      $adminbusinesses = Engine_Api::_()->getDbtable('manageadmins', 'sitebusiness')->getManageAdminBusinesses($viewer_id);

      //GET STUFF
      $manageadmin_ids = array();
      foreach( $adminbusinesses as $adminbusiness ) {
        $manageadmin_ids[] = $adminbusiness->business_id;
      }
      $manageadmin_values = array();
      $manageadmin_values['adminbusinesses'] = $manageadmin_ids;
      $manageadmin_values['orderby'] = 'creation_date';
      $manageadmin_data = Engine_Api::_()->sitebusiness()->getSitebusinessesPaginator($manageadmin_values, null);
      $this->view->manageadmin_count = $manageadmin_data->getTotalItemCount();

//    if(Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember')) {
//        $onlymember = Engine_Api::_()->getDbtable('membership', 'sitebusiness')->getJoinBusinesses($viewer->getIdentity(), 'onlymember');
//
//        $onlymemberids = array();
//        foreach ($onlymember as $onlymembers) {
//          $onlymemberids[] = $onlymembers->business_id;
//        }
//        if (!empty($onlymemberids)) {
//            $values['adminjoinedbusinesses'] = array_merge($onlymemberids, $manageadmin_values['adminbusinesses']);
//        }
//    } else {
      $values['adminjoinedbusinesses'] = $manageadmin_values['adminbusinesses'];
      //  }
      //END CHECK THAT WE HAVE TO SHOW MANAGE ADMIN LINK OR NOTE
      //PROCESS FORM
      $request = $this->getRequest()->getPost();

      //PROCESS FORM
      if( $form->isValid($this->_getAllParams()) ) {
        $values = $form->getValues();
        if( $values['subcategory_id'] == 0 ) {
          $values['subsubcategory_id'] = 0;
          $values['subsubcategory'] = 0;
        }
      } else {
        $values = array();
      }

      if( empty($sitebusiness_manage) ) {
        return;
      }

      //CHECK TO SEE IF REQUEST IS FOR SPECIFIC USER'S BUSINESSS
      // $values['user_id'] = $viewer->getIdentity();
      $values['type'] = 'manage';
      $values['type_location'] = 'manage';
      $this->view->formValues = $values;

      //GET PAGINATOR
      $this->view->paginator = $paginator = Engine_Api::_()->sitebusiness()->getSitebusinessesPaginator($values, null);
      $items_count = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.business', 10);


      $paginator->setItemCountPerPage($items_count);
      $this->view->paginator = $paginator->setCurrentPageNumber($values['page']);

      $this->view->page = $values['page'] ? $values['page'] : 1;
      $this->view->totalPages = ceil(($paginator->getTotalItemCount()) / $items_count);

      //MAXIMUM ALLOWED BUSINESSS
      //WE HAVE IMPORT BUSINESSS FUNCTIONALITY, WE DONT WANT TO SHOW BUSINESS LIMIT ALERT MESSAGE TO SUPERADMIN SO WE ARE SETTING $this->view->quota = 0;
      $this->view->quota = 0;
      if( $viewer->level_id != 1 ) {
        $this->view->quota = Engine_Api::_()->authorization()->getPermission($viewer->level_id, 'sitebusiness_business', 'max');
      }
      $this->view->current_count = $paginator->getTotalItemCount();
      $this->view->category_id = $values['category_id'];
      $this->view->subcategory_id = $values['subcategory_id'];
      $this->view->subsubcategory_id = $values['subsubcategory_id'];

      //if (!Engine_API::_()->seaocore()->checkSitemobileMode('fullsite-mode')) {
      $coremodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core');
      $coreversion = $coremodule->version;
      if( !$isappajax ) {
        if( empty(Engine_Api::_()->seaocore()->checkVersion($coreversion, '4.1.0')) ) {
          $this->_helper->content->render();
        } else {
          $this->_helper->content
            //->setNoRender()
            ->setEnabled();
        }
      }
      //}
    } else {
      $coremodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core');
      $coreversion = $coremodule->version;
      if( !$isappajax ) {
        if( empty(Engine_Api::_()->seaocore()->checkVersion($coreversion, '4.1.0')) ) {
          $this->_helper->content->render();
        } else {
          $this->_helper->content
            ->setNoRender()
            ->setEnabled();
        }
      }
    }
  }

  // create  sitebusiness sitebusiness
  public function createAction()
  {

    //USER VALIDATION
    if( !$this->_helper->requireUser()->isValid() )
      return;

    $this->view->quick = $quick = $this->_getParam('seaoSmoothbox', false);
    if( !$quick ) {
      //RENDER PAGE
      $this->_helper->content
        //->setNoRender()
        ->setEnabled()
      ;
    }

    if( Engine_Api::_()->getApi('settings', 'core')->hasSetting('sitebusiness.createFormFields') ) {
      $settings = Engine_Api::_()->getApi('settings', 'core');
      $createFormFields = $settings->getSetting('sitebusiness.createFormFields');
      if( !$this->_getParam('seaoSmoothbox', false) && !empty($createFormFields) && in_array('showHideAdvancedOptions', $createFormFields) ) {
        $this->view->quick = $quick = 1;
      }
    }

    //SITEMOBILE_MODULE_NOT_SUPPORT_DESC_FOR_SOMEBUSINESSES
    if( !Engine_API::_()->seaocore()->checkSitemobileMode('fullsite-mode') ) {
      Engine_API::_()->sitemobile()->setupRequestError();
    } else {
      $this->_helper->content->setEnabled();
    }

    //BUSINESS CREATE PRIVACY
    if( !$this->_helper->requireAuth()->setAuthParams('sitebusiness_business', null, 'create')->isValid() )
      return;
    $package_id = 0;
    $viewer = Engine_Api::_()->user()->getViewer();
    global $sitebusiness_is_approved;
    $sitebusinessHostName = str_replace('www.', '', @strtolower($_SERVER['HTTP_HOST']));
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitebusiness_main', array(), 'sitebusiness_main_create');
    $getPackageAuth = Engine_Api::_()->sitebusiness()->getPackageAuthInfo('sitebusiness');

    $levelHost = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.level.createhost', 0);
    $package = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.lsettings', 0);
    $LevelHost = $this->checkLevelHost($levelHost, 'sitebusiness');
    $PackagesHost = $this->checkPackageHost($package);
    $sub_status_table = Engine_Api::_()->getDbTable('businessstatistics', 'sitebusiness');

    if( Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
      //REDIRECT
      $package_id = $this->_getParam('id');
      if( empty($package_id) ) {
        return $this->_forwardCustom('notfound', 'error', 'core');
      }
      $this->view->package = $package = Engine_Api::_()->getItemTable('sitebusiness_package')->fetchRow(array('package_id = ?' => $package_id, 'enabled = ?' => '1'));
      if( empty($this->view->package) ) {
        return $this->_forwardCustom('notfound', 'error', 'core');
      }

      if( !empty($package->level_id) && !in_array($viewer->level_id, explode(",", $package->level_id)) ) {
        return $this->_forwardCustom('notfound', 'error', 'core');
      }
    } else {
      $package_id = Engine_Api::_()->getItemtable('sitebusiness_package')->fetchRow(array('defaultpackage = ?' => 1))->package_id;
    }

    $maxCount = 10;
    $table = Engine_Api::_()->getDbtable('business', 'sitebusiness');
    $tablename = $table->info('name');
    $select = $table->select()->from($tablename, array('count(*) as count'));
    $results = $table->fetchRow($select);
    if( ($PackagesHost != $LevelHost) && ($results->count > $maxCount) ) {
      Engine_Api::_()->sitebusiness()->setDisabledType();
      Engine_Api::_()->getItemtable('sitebusiness_package')->setEnabledPackages();
    }
    $sitebusiness_featured = Zend_Registry::isRegistered('sitebusiness_featured') ? Zend_Registry::get('sitebusiness_featured') : null;
    $manageadminsTable = Engine_Api::_()->getDbtable('manageadmins', 'sitebusiness');
    $row = $manageadminsTable->createRow();

    //FORM VALIDATION
    $this->view->form = $form = new Sitebusiness_Form_Create(array("packageId" => $package_id, "owner" => $viewer, 'quick' => $quick));
    $this->view->sitebusinessUrlEnabled = $sitebusinessUrlEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessurl');

    $this->view->show_url = $show_url = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.showurl.column', 1);
    if( !empty($sitebusinessUrlEnabled) && empty($show_url) ) {
      $form->removeElement('business_url');
      $form->removeElement('business_url_msg');
    }
    if( empty($sitebusiness_featured) ) {
      return;
    }

    $isHost = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.isHost', 0);
    if( empty($isHost) ) {
      Engine_Api::_()->getApi('settings', 'core')->setSetting('sitebusiness.viewbusiness.sett', convert_uuencode($sitebusinessHostName));
    }

    //SET UP DATA NEEDED TO CHECK QUOTA

    $sitebusiness_category = Zend_Registry::isRegistered('sitebusiness_category') ? Zend_Registry::get('sitebusiness_category') : null;
    $values['user_id'] = $viewer->getIdentity();
    // $paginator = Engine_Api::_()->getApi('core', 'sitebusiness')->getSitebusinessesPaginator($values);
    $count = Engine_Api::_()->getDbtable('business', 'sitebusiness')->countUserBusinesses($values);
    $this->view->quota = $quota = Engine_Api::_()->authorization()->getPermission($viewer->level_id, 'sitebusiness_business', 'max');

    $sitebusiness_render = Zend_Registry::isRegistered('sitebusiness_render') ? Zend_Registry::get('sitebusiness_render') : null;
    $this->view->current_count = $count;

    if( !empty($sitebusiness_render) ) {
      $this->view->sitebusiness_render = $sitebusiness_render;
    }

    //IF NOT POST OR FORM NOT VALID, RETURN
    if( $this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost()) ) {
      $table = Engine_Api::_()->getItemTable('sitebusiness_business');
      $db = $table->getAdapter();
      $db->beginTransaction();

      try {
        // Create sitebusiness
        $values = array_merge($form->getValues(), array(
          'owner_id' => $viewer->getIdentity(),
          'package_id' => $package_id
        ));

        $is_error = 0;
        if( isset($values['category_id']) && empty($values['category_id']) ) {
          $is_error = 1;
        }
        if( empty($values['subcategory_id']) ) {
          $values['subcategory_id'] = 0;
        }
        if( empty($values['subsubcategory_id']) ) {
          $values['subsubcategory_id'] = 0;
        }

        //SET ERROR MESSAGE
        if( $is_error == 1 ) {
          $this->view->status = false;
          $error = Zend_Registry::get('Zend_Translate')->_('Business Category * Please complete this field - it is required.');
          $form->getDecorator('errors')->setOption('escape', false);
          $form->addError($error);
          return;
        }
        $sitebusiness = $table->createRow();

        if( Engine_Api::_()->getApi('subCore', 'sitebusiness')->businessBaseNetworkEnable() ) {
          if( isset($values['networks_privacy']) && !empty($values['networks_privacy']) ) {
            if( in_array(0, $values['networks_privacy']) ) {
              $values['networks_privacy'] = new Zend_Db_Expr('NULL');
            } else {
              $values['networks_privacy'] = (string) ( is_array($values['networks_privacy']) ? join(",", $values['networks_privacy']) : $netowrkIds );
            }
          }
        }
        if( !empty($sitebusinessUrlEnabled) ) {
          if( empty($show_url) ) {
            $resultBusinessTable = $table->select()->where('title =?', $values['title'])->from($table, 'title')
                ->query()->fetchAll(Zend_Db::FETCH_COLUMN);
            $count_index = count($resultBusinessTable);
            $resultBusinessUrl = $table->select()->where('business_url =?', $values['title'])->from($table, 'business_url')
                ->query()->fetchAll(Zend_Db::FETCH_COLUMN);
            $count_index_url = count($resultBusinessUrl);
          }
          $urlArray = Engine_Api::_()->sitebusiness()->getBannedUrls();
          if( !empty($show_url) ) {
            if( in_array(strtolower($values['business_url']), $urlArray) ) {
              $form->addError(Zend_Registry::get('Zend_Translate')->_('Sorry, this URL has been restricted by our automated system. Please choose a different URL.'));
              return;
            }
          } elseif( !empty($sitebusinessUrlEnabled) ) {
            $lastbusiness_id = $table->select()
              ->from($table->info('name'), array('business_id'))->order('business_id DESC')
              ->query()
              ->fetchColumn();
            $values['business_url'] = trim(preg_replace('/-+/', '-', preg_replace('/[^a-z0-9-]+/i', '-', strtolower($values['title']))), '-');
            if( !empty($count_index) || !empty($count_index_url) ) {
              $lastbusiness_id = $lastbusiness_id + 1;
              $values['business_url'] = $values['business_url'] . '-' . $lastbusiness_id;
            } else {
              $values['business_url'] = $values['business_url'];
            }
            if( in_array(strtolower($values['business_url']), $urlArray) ) {

              $form->addError(Zend_Registry::get('Zend_Translate')->_('Sorry, this Business Title has been restricted by our automated system. Please choose a different Title.', array('escape' => false)));
              return;
            }
          }
        }
        $sitebusiness->setFromArray($values);


        $user_level = $viewer->level_id;
        if( !Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
          $sitebusiness->featured = Engine_Api::_()->authorization()->getPermission($user_level, 'sitebusiness_business', 'featured');
          $sitebusiness->sponsored = Engine_Api::_()->authorization()->getPermission($user_level, 'sitebusiness_business', 'sponsored');
          $sitebusiness->approved = Engine_Api::_()->authorization()->getPermission($user_level, 'sitebusiness_business', 'approved');
        } else {
          $sitebusiness->featured = $package->featured;
          $sitebusiness->sponsored = $package->sponsored;
          if( $package->isFree() && !empty($sitebusiness_is_approved) && !empty($getPackageAuth) ) {
            $sitebusiness->approved = $package->approved;
          } else {
            $sitebusiness->approved = 0;
          }
        }

        if( !empty($sitebusiness->approved) ) {
          $sitebusiness->pending = 0;
          $sitebusiness->aprrove_date = date('Y-m-d H:i:s');

          if( Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
            $expirationDate = $package->getExpirationDate();
            if( !empty($expirationDate) )
              $sitebusiness->expiration_date = date('Y-m-d H:i:s', $expirationDate);
            else
              $sitebusiness->expiration_date = '2250-01-01 00:00:00';
          }
          else {
            $sitebusiness->expiration_date = '2250-01-01 00:00:00';
          }
        }
        if( !empty($sitebusiness_category) ) {
          $sitebusiness->save();
          $business_id = $sitebusiness->business_id;
        }

        if( !empty($sitebusiness->approved) ) {
          Engine_Api::_()->sitebusiness()->sendMail("ACTIVE", $sitebusiness->business_id);
        } else {
          Engine_Api::_()->sitebusiness()->sendMail("APPROVAL_PENDING", $sitebusiness->business_id);
        }

        $manageadminsTable = Engine_Api::_()->getDbtable('manageadmins', 'sitebusiness');
        $row = $manageadminsTable->createRow();
        $row->user_id = $sitebusiness->owner_id;
        $row->business_id = $sitebusiness->business_id;
        $row->save();

        //START PROFILE MAPS WORK
        Engine_Api::_()->getDbtable('profilemaps', 'sitebusiness')->profileMapping($sitebusiness);


        $business_id = $sitebusiness->business_id;
        if( !empty($sitebusinessUrlEnabled) && empty($show_url) ) {
          $values['business_url'] = trim(preg_replace('/-+/', '-', preg_replace('/[^a-z0-9-]+/i', '-', strtolower($values['title']))), '-');
          if( !empty($count_index) || !empty($count_index_url) ) {
            $values['business_url'] = $values['business_url'] . '-' . $business_id;
            $table->update(array('business_url' => $values['business_url']), array('business_id = ?' => $business_id));
          } else {
            $values['business_url'] = $values['business_url'];
            $table->update(array('business_url' => $values['business_url']), array('business_id = ?' => $business_id));
          }
        }

        $sitebusinessFormEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessform');
        if( $sitebusinessFormEnabled ) {
          $tablecontent = Engine_Api::_()->getDbtable('content', 'core');
          $params = $tablecontent->select()
              ->from($tablecontent->info('name'), 'params')
              ->where('name = ?', 'sitebusinessform.sitebusiness-viewform')
              ->query()->fetchColumn();
          $decodedParam = !empty($params) ? Zend_Json::decode($params) : array();
          $tabName = $decodedParam['title'];
          if( empty($tabName) )
            $tabName = 'Form';
          $sitebusinessformtable = Engine_Api::_()->getDbtable('sitebusinessforms', 'sitebusinessform');
          $optionid = Engine_Api::_()->getDbtable('businessquetions', 'sitebusinessform');
          $table_option = Engine_Api::_()->fields()->getTable('sitebusinessform', 'options');
          $sitebusinessform = $table_option->createRow();
          $sitebusinessform->setFromArray($values);
          $sitebusinessform->label = $values['title'];
          $sitebusinessform->field_id = 1;
          $option_id = $sitebusinessform->save();
          $optionids = $optionid->createRow();
          $optionids->option_id = $option_id;
          $optionids->business_id = $business_id;
          $optionids->save();
          $sitebusinessforms = $sitebusinessformtable->createRow();
          if( isset($sitebusinessforms->offer_tab_name) )
            $sitebusinessforms->offer_tab_name = $tabName;
          $sitebusinessforms->description = 'Please leave your feedback below and enter your contact details.';
          $sitebusinessforms->business_id = $business_id;
          $sitebusinessforms->save();
        }
        //SET PHOTO
        if( !empty($values['photo']) ) {
          $sitebusiness->setPhoto($form->photo);
          $sitebusinessinfo = $sitebusiness->toarray();
          $albumTable = Engine_Api::_()->getDbtable('albums', 'sitebusiness');
          $album_id = $albumTable->update(array('photo_id' => $sitebusinessinfo['photo_id'], 'owner_id' => $sitebusinessinfo['owner_id']), array('business_id = ?' => $sitebusinessinfo['business_id']));
        } else {
          $sitebusinessinfo = $sitebusiness->toarray();
          $albumTable = Engine_Api::_()->getDbtable('albums', 'sitebusiness');
          $album_id = $albumTable->insert(array(
            'photo_id' => 0,
            'owner_id' => $sitebusinessinfo['owner_id'],
            'business_id' => $sitebusinessinfo['business_id'],
            'title' => $sitebusinessinfo['title'],
            'creation_date' => $sitebusinessinfo['creation_date'],
            'modified_date' => $sitebusinessinfo['modified_date']));
        }

        //ADD TAGS
        $tags = preg_split('/[,]+/', $values['tags']);
        $tags = array_filter(array_map("trim", $tags));
        $sitebusiness->tags()->addTagMaps($viewer, $tags);

        if( !empty($business_id) ) {
          $sitebusiness->setLocation();
        }

        // Set privacy
        $auth = Engine_Api::_()->authorization()->context;

        //get the business admin list.
        $ownerList = $sitebusiness->getBusinessOwnerList();

        $sitebusinessmemberEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember');
        if( !empty($sitebusinessmemberEnabled) ) {
          $roles = array('owner', 'member', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
        } else {
          $roles = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
        }


        if( !isset($values['auth_view']) || empty($values['auth_view']) ) {
          $values['auth_view'] = "everyone";
        }

        if( !isset($values['auth_comment']) || empty($values['auth_comment']) ) {
          $values['auth_comment'] = "everyone";
        }

        $viewMax = array_search($values['auth_view'], $roles);
        $commentMax = array_search($values['auth_comment'], $roles);

        foreach( $roles as $i => $role ) {
          $auth->setAllowed($sitebusiness, $role, 'view', ($i <= $viewMax));
          $auth->setAllowed($sitebusiness, $role, 'comment', ($i <= $commentMax));
          $auth->setAllowed($sitebusiness, $role, 'print', 1);
          $auth->setAllowed($sitebusiness, $role, 'tfriend', 1);
          $auth->setAllowed($sitebusiness, $role, 'overview', 1);
          $auth->setAllowed($sitebusiness, $role, 'map', 1);
          $auth->setAllowed($sitebusiness, $role, 'insight', 1);
          $auth->setAllowed($sitebusiness, $role, 'layout', 1);
          $auth->setAllowed($sitebusiness, $role, 'contact', 1);
          $auth->setAllowed($sitebusiness, $role, 'form', 1);
          $auth->setAllowed($sitebusiness, $role, 'offer', 1);
          $auth->setAllowed($sitebusiness, $role, 'invite', 1);
        }

        $sitebusinessmemberEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember');
        if( !empty($sitebusinessmemberEnabled) ) {
          $roles = array('owner', 'like_member', 'member', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
        } else {
          $roles = array('owner', 'like_member', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
        }

        //START WORK FOR SUB BUSINESS.
        if( empty($values['auth_sspcreate']) ) {
          $values['auth_sspcreate'] = "owner";
        }

        $createMax = array_search($values['auth_sspcreate'], $roles);
        foreach( $roles as $i => $role ) {
          if( $role === 'like_member' ) {
            $role = $ownerList;
          }
          $auth->setAllowed($sitebusiness, $role, 'sspcreate', ($i <= $createMax));
        }
        //END WORK FOR SUBBUSINESS
        //START SITEBUSINESSDISCUSSION PLUGIN WORK
        $sitebusinessdiscussionEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessdiscussion');
        if( $sitebusinessdiscussionEnabled ) {
          //START DISCUSSION PRIVACY WORK
          if( empty($values['sdicreate']) ) {
            $values['sdicreate'] = "registered";
          }

          $createMax = array_search($values['sdicreate'], $roles);
          foreach( $roles as $i => $role ) {
            if( $role === 'like_member' ) {
              $role = $ownerList;
            }
            $auth->setAllowed($sitebusiness, $role, 'sdicreate', ($i <= $createMax));
          }
          //END DISCUSSION PRIVACY WORK
        }
        //END SITEBUSINESSDISCUSSION PLUGIN WORK
        //START SITEBUSINESSALBUM PLUGIN WORK
        $sitebusinessalbumEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessalbum');
        if( $sitebusinessalbumEnabled ) {
          //START PHOTO PRIVACY WORK
          if( empty($values['spcreate']) ) {
            $values['spcreate'] = "registered";
          }

          $createMax = array_search($values['spcreate'], $roles);
          foreach( $roles as $i => $role ) {
            if( $role === 'like_member' ) {
              $role = $ownerList;
            }
            $auth->setAllowed($sitebusiness, $role, 'spcreate', ($i <= $createMax));
          }
          //END PHOTO PRIVACY WORK
        }
        //END SITEBUSINESSALBUM PLUGIN WORK
        //START SITEBUSINESSDOCUMENT PLUGIN WORK
        $sitebusinessDocumentEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessdocument');
        if( $sitebusinessDocumentEnabled || (Engine_Api::_()->hasModuleBootstrap('document') && Engine_Api::_()->getDbtable('modules', 'document')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'sitebusiness_business', 'item_module' => 'sitebusiness'))) ) {
          $sitebusinessmemberEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember');
          if( !empty($sitebusinessmemberEnabled) ) {
            $roles = array('owner', 'like_member', 'member', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
          } else {
            $roles = array('owner', 'like_member', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
          }

          if( empty($values['sdcreate']) ) {
            $values['sdcreate'] = "registered";
          }

          $createMax = array_search($values['sdcreate'], $roles);
          foreach( $roles as $i => $role ) {
            if( $role === 'like_member' ) {
              $role = $ownerList;
            }
            $auth->setAllowed($sitebusiness, $role, 'sdcreate', ($i <= $createMax));
          }
        }
        //END SITEBUSINESSDOCUMENT PLUGIN WORK
        //START SITEBUSINESSVIDEO PLUGIN WORK
        $sitebusinessVideoEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessvideo');
        if( $sitebusinessVideoEnabled || (Engine_Api::_()->hasModuleBootstrap('sitevideo') && Engine_Api::_()->getDbtable('modules', 'sitevideo')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'sitebusiness_business', 'item_module' => 'sitebusiness'))) ) {
          if( empty($values['svcreate']) ) {
            $values['svcreate'] = "registered";
          }

          $createMax = array_search($values['svcreate'], $roles);
          foreach( $roles as $i => $role ) {
            if( $role === 'like_member' ) {
              $role = $ownerList;
            }
            $auth->setAllowed($sitebusiness, $role, 'svcreate', ($i <= $createMax));
          }
        }
        //END SITEBUSINESSVIDEO PLUGIN WORK
        //START SITECROWDFUNDING PLUGIN WORK
        $sitecrowdfundingEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitecrowdfunding');
        if( $sitecrowdfundingEnabled && (Engine_Api::_()->hasModuleBootstrap('sitecrowdfundingintegration') && Engine_Api::_()->getDbtable('modules', 'sitecrowdfunding')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'sitebusiness_business', 'item_module' => 'sitebusiness'))) ) {
          if( empty($values['sprcreate']) ) {
            $values['sprcreate'] = "registered";
          }

          $createMax = array_search($values['sprcreate'], $roles);
          foreach( $roles as $i => $role ) {
            if( $role === 'like_member' ) {
              $role = $ownerList;
            }
            $auth->setAllowed($sitebusiness, $role, 'sprcreate', ($i <= $createMax));
          }
        }
        //END SITECROWDFUNDING PLUGIN WORK
        //START SITEMUSIC PLUGIN WORK
        $sitecrowdfundingEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitemusic');
        if( $sitemusicEnabled && (Engine_Api::_()->hasModuleBootstrap('sitemusic') && Engine_Api::_()->getDbtable('modules', 'sitemusic')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'sitebusiness_business', 'item_module' => 'sitebusiness'))) ) {
          if( empty($values['samcreate']) ) {
            $values['samcreate'] = "registered";
          }

          $createMax = array_search($values['samcreate'], $roles);
          foreach( $roles as $i => $role ) {
            if( $role === 'like_member' ) {
              $role = $ownerList;
            }
            $auth->setAllowed($sitebusiness, $role, 'samcreate', ($i <= $createMax));
          }
        }
        //END SITEMUSIC PLUGIN WORK
        //START SITEBUSINESSPOLL PLUGIN WORK
        $sitebusinessPollEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinesspoll');
        if( $sitebusinessPollEnabled ) {
          if( empty($values['splcreate']) ) {
            $values['splcreate'] = "registered";
          }

          $createMax = array_search($values['splcreate'], $roles);
          foreach( $roles as $i => $role ) {
            if( $role === 'like_member' ) {
              $role = $ownerList;
            }
            $auth->setAllowed($sitebusiness, $role, 'splcreate', ($i <= $createMax));
          }
        }
        //END SITEBUSINESSPOLL PLUGIN WORK
        //START SITEBUSINESSNOTE PLUGIN WORK
        $sitebusinessNoteEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessnote');
        if( $sitebusinessNoteEnabled ) {
          if( empty($values['sncreate']) ) {
            $values['sncreate'] = "registered";
          }

          $createMax = array_search($values['sncreate'], $roles);
          foreach( $roles as $i => $role ) {
            if( $role === 'like_member' ) {
              $role = $ownerList;
            }
            $auth->setAllowed($sitebusiness, $role, 'sncreate', ($i <= $createMax));
          }
        }
        //END SITEBUSINESSNOTE PLUGIN WORK
        //START SITEBUSINESSMUSIC PLUGIN WORK
        $sitebusinessMusicEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmusic');
        if( $sitebusinessMusicEnabled ) {
          if( empty($values['smcreate']) ) {
            $values['smcreate'] = "registered";
          }

          $createMax = array_search($values['smcreate'], $roles);
          foreach( $roles as $i => $role ) {
            if( $role === 'like_member' ) {
              $role = $ownerList;
            }
            $auth->setAllowed($sitebusiness, $role, 'smcreate', ($i <= $createMax));
          }
        }
        //END SITEBUSINESSMUSIC PLUGIN WORK
        //START SITEBUSINESSEVENT PLUGIN WORK
        $sitebusinesseventEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember');
        if( $sitebusinesseventEnabled || (Engine_Api::_()->hasModuleBootstrap('siteevent') && Engine_Api::_()->getDbtable('modules', 'siteevent')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'sitebusiness_business', 'item_module' => 'sitebusiness'))) ) {
          if( empty($values['secreate']) ) {
            $values['secreate'] = "registered";
          }

          $createMax = array_search($values['secreate'], $roles);
          foreach( $roles as $i => $role ) {
            if( $role === 'like_member' ) {
              $role = $ownerList;
            }
            $auth->setAllowed($sitebusiness, $role, 'secreate', ($i <= $createMax));
          }
        }
        //END SITEBUSINESSEVENT PLUGIN WORK
        //START SITEBUSINESSMEMBER PLUGIN WORK
        $sitebusinessMemberEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember');
        if( $sitebusinessMemberEnabled ) {
          $membersTable = Engine_Api::_()->getDbtable('membership', 'sitebusiness');
          $row = $membersTable->createRow();
          $row->resource_id = $sitebusiness->business_id;
          $row->business_id = $sitebusiness->business_id;
          $row->user_id = $sitebusiness->owner_id;
          $row->notification = '0';
          $row->save();
          Engine_Api::_()->sitebusiness()->updateMemberCount($sitebusiness);
          $sitebusiness->save();
        }
        $memberInvite = Engine_Api::_()->getApi('settings', 'core')->getSetting('businessmember.invite.option', 1);
        $member_approval = Engine_Api::_()->getApi('settings', 'core')->getSetting('businessmember.member.approval.option', 1);
        if( empty($memberInvite) ) {
          $memberInviteOption = Engine_Api::_()->getApi('settings', 'core')->getSetting('businessmember.invite.automatically', 1);
          $sitebusiness->member_invite = $memberInviteOption;
          $sitebusiness->save();
        }
        if( empty($member_approval) ) {
          $member_approvalOption = Engine_Api::_()->getApi('settings', 'core')->getSetting('businessmember.member.approval.automatically', 1);
          $sitebusiness->member_approval = $member_approvalOption;
          $sitebusiness->save();
        }
        //END SITEBUSINESSMEMBER PLUGIN WORK
        //INTERGRATION EXTENAION ISSUE.
        //START BUSINESS INTEGRATION WORK
        $page_id = $this->_getParam('page_id');
        if( !empty($page_id) ) {
          $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
          $moduleEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitepageintegration');
          if( !empty($moduleEnabled) ) {
            $contentsTable = Engine_Api::_()->getDbtable('contents', 'sitepageintegration');
            $row = $contentsTable->createRow();
            $row->owner_id = $viewer_id;
            $row->resource_owner_id = $sitebusiness->owner_id;
            $row->page_id = $page_id;
            $row->resource_type = 'sitebusiness_business';
            $row->resource_id = $sitebusiness->business_id;
            $row->save();
          }
        }
        //END BUSINESS INTEGRATION WORK
        //START GROUP INTEGRATION WORK
        $group_id = $this->_getParam('group_id');
        if( !empty($group_id) ) {
          $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
          $moduleEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitegroupintegration');
          if( !empty($moduleEnabled) ) {
            $contentsTable = Engine_Api::_()->getDbtable('contents', 'sitegroupintegration');
            $row = $contentsTable->createRow();
            $row->owner_id = $viewer_id;
            $row->resource_owner_id = $sitebusiness->owner_id;
            $row->group_id = $group_id;
            $row->resource_type = 'sitebusiness_business';
            $row->resource_id = $sitebusiness->business_id;
            $row->save();
          }
        }
        //END GROUP INTEGRATION WORK
        //START STORE INTEGRATION WORK
        $store_id = $this->_getParam('store_id');
        if( !empty($store_id) ) {
          $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
          $moduleEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitestoreintegration');
          if( !empty($moduleEnabled) ) {
            $contentsTable = Engine_Api::_()->getDbtable('contents', 'sitestoreintegration');
            $row = $contentsTable->createRow();
            $row->owner_id = $viewer_id;
            $row->resource_owner_id = $sitebusiness->owner_id;
            $row->store_id = $store_id;
            $row->resource_type = 'sitebusiness_business';
            $row->resource_id = $sitebusiness->business_id;
            $row->save();
          }
        }
        //END STORE INTEGRATION WORK
        //END INTERGRATION EXTENAION WORK
        //START SUB BUSINESS WORK
        $parent_id = $this->_getParam('parent_id');
        if( !empty($parent_id) ) {
          $sitebusiness->subbusiness = 1;
          $sitebusiness->parent_id = $parent_id;
          $sitebusiness->save();
        }
        //END  SUB BUSINESS WORK
        //CUSTOM FIELD WORK
        if( Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.profile.fields', 1) ) {
          $customfieldform = $form->getSubForm('fields');
          $customfieldform->setItem($sitebusiness);
          $customfieldform->saveValues();
        }

        //START DEFAULT EMAIL TO SUPERADMIN WHEN ANYONE CREATE BUSINESSES.
        $emails = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.defaultbusinesscreate.email', Engine_API::_()->seaocore()->getSuperAdminEmailAddress());
        if( !empty($emails) ) {
          $emails = explode(",", $emails);
          $host = $_SERVER['HTTP_HOST'];
          $newVar = _ENGINE_SSL ? 'https://' : 'http://';
          $object_link = $newVar . $host . $sitebusiness->getHref();
          $viewerGetTitle = $viewer->getTitle();
          $sender_link = '<a href=' . $newVar . $host . $viewer->getHref() . ">$viewerGetTitle</a>";
          foreach( $emails as $email ) {
            $email = trim($email);
            Engine_Api::_()->getApi('mail', 'core')->sendSystem($email, 'SITEBUSINESS_BUSINESS_CREATION', array(
              'sender' => $sender_link,
              'object_link' => $object_link,
              'object_title' => $sitebusiness->getTitle(),
              'object_description' => $sitebusiness->getDescription(),
              'queue' => true
            ));
          }
        }
        //END DEFAULT EMAIL TO SUPERADMIN WHEN ANYONE CREATE BUSINESSES.
        // Commit
        $db->commit();
      } catch( Exception $e ) {
        $db->rollBack();
        throw $e;
      }
      if( !empty($sitebusiness) && !empty($sitebusiness->draft) && empty($sitebusiness->pending) ) {
        Engine_Api::_()->sitebusiness()->attachBusinessActivity($sitebusiness);


        //START AUTOMATICALLY LIKE THE BUSINESS WHEN MEMBER CREATE A BUSINESS.
        $autoLike = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.automatically.like', 1);
        if( !empty($autoLike) ) {
          Engine_Api::_()->sitebusiness()->autoLike($sitebusiness->business_id, 'sitebusiness_business');
        }
        //END AUTOMATICALLY LIKE THE BUSINESS WHEN MEMBER CREATE A BUSINESS.
        //SENDING ACTIVITY FEED TO FACEBOOK.
        $enable_Facebooksefeed = $enable_fboldversion = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('facebooksefeed');
        if( !empty($enable_Facebooksefeed) ) {

          $sitebusiness_array = array();
          $sitebusiness_array['type'] = 'sitebusiness_new';
          $sitebusiness_array['object'] = $sitebusiness;

          Engine_Api::_()->facebooksefeed()->sendFacebookFeed($sitebusiness_array);
        }
      }
      //EXTRACTING CURRENT ADMIN SETTINGS FOR THIS VIEW BUSINESS.
      $businessAdminTable = Engine_Api::_()->getDbtable('pages', 'core');
      $businessAdminTableName = $businessAdminTable->info('name');
      $selectBusinessAdmin = $businessAdminTable->select()
        ->setIntegrityCheck(false)
        ->from($businessAdminTableName)
        ->where('name = ?', 'sitebusiness_index_view');
      $businessAdminresult = $businessAdminTable->fetchRow($selectBusinessAdmin);

      //NOW INSERTING THE ROW IN BUSINESS TABLE
      $businessTable = Engine_Api::_()->getDbtable('contentbusinesses', 'sitebusiness');

      //CREATE NEW BUSINESS
//       $businessObject = $businessTable->createRow();
//       $businessObject->displayname = ( null !== ($name = $values['title']) ? $name : 'Untitled' );
//       $businessObject->title = ( null !== ($name = $values['title']) ? $name : 'Untitled' );
//       $businessObject->description = $values['body'];
//       $businessObject->name = "sitebusiness_index_view";
//       $businessObject->url = $businessAdminresult->url;
//       $businessObject->custom = $businessAdminresult->custom;
//       $businessObject->fragment = $businessAdminresult->fragment;
//       $businessObject->keywords = $businessAdminresult->keywords;
//       $businessObject->layout = $businessAdminresult->layout;
//       $businessObject->view_count = $businessAdminresult->view_count;
//       $businessObject->user_id = $values['owner_id'];
//       $businessObject->business_id = $sitebusiness->business_id;
//       $contentBusinessId = $businessObject->save();
//
//       //NOW FETCHING BUSINESS CONTENT DEFAULT SETTING INFORMATION FROM CORE CONTENT TABLE FOR THIS BUSINESS.
//       //NOW INSERTING DEFAULT BUSINESS CONTENT SETTINGS IN OUR CONTENT TABLE
//       $layout = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.layoutcreate', 0);
//       $sitebusiness_layout_cover_photo = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.layout.cover.photo', 1);
//       if (!$layout) {
//         Engine_Api::_()->getDbtable('content', 'sitebusiness')->setContentDefault($contentBusinessId, $sitebusiness_layout_cover_photo);
//       } else {
//         Engine_Api::_()->getApi('layoutcore', 'sitebusiness')->setContentDefaultLayout($contentBusinessId, $sitebusiness_layout_cover_photo);
//       }
      //REDIRECT
      return $this->_helper->redirector->gotoRoute(array('action' => 'get-started', 'business_id' => $sitebusiness->business_id, 'saved' => '1'), 'sitebusiness_dashboard', true);
    } /* else {
      $results = $this->getRequest()->getPost();
      if (!empty($results) && isset($results['subcategory_id'])) {
      $this->view->category_id = $results['category_id'];
      if (!empty($results['subcategory_id'])) {
      $this->view->subcategory_name = Engine_Api::_()->getDbtable('categories', 'sitebusiness')->getCategory($results['subcategory_id'])->category_name;
      }
      return;
      }
      } */
  }

  //ACTION FOR BUSINESS EDI
  public function editAction()
  {

    //USER VALDIATION
    if( !$this->_helper->requireUser()->isValid() )
      return;

    //SITEMOBILE_MODULE_NOT_SUPPORT_DESC_FOR_SOMEBUSINESSES
    if( !Engine_API::_()->seaocore()->checkSitemobileMode('fullsite-mode') ) {
      Engine_API::_()->sitemobile()->setupRequestError();
    } else {
      $this->_helper->content->setEnabled();
    }

    //GET NAVIGATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sitebusiness_main');

    $sitebusinessmemberEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember');
    $this->view->business_id = $business_id = $this->_getParam('business_id');
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    $this->view->sitebusinesses_view_menu = 1;
    $getPackageAuth = Engine_Api::_()->sitebusiness()->getPackageAuthInfo('sitebusiness');
    $this->view->sitebusiness = $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    $previous_category_id = $sitebusiness->category_id;
    //$previous_location = $sitebusiness->location;

    $ownerList = $sitebusiness->getBusinessOwnerList();

    if( empty($sitebusiness) ) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if( empty($isManageAdmin) ) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }
    //END MANAGE-ADMIN CHECK
    $this->view->owner_id = $owner_id = $sitebusiness->owner_id;
    $user_subject = Engine_Api::_()->user()->getUser($owner_id);

    //FORM GENERATION
    $this->view->form = $form = new Sitebusiness_Form_Edit(array('item' => $sitebusiness, "packageId" => $sitebusiness->package_id, "owner" => $user_subject));
    $this->view->show_url = $show_url = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.showurl.column', 1);
    $this->view->edit_url = $edit_url = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.edit.url', 0);
    $this->view->sitebusinessurlenabled = $sitebusinessUrlEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessurl');
    if( !empty($sitebusinessUrlEnabled) && empty($show_url) ) {
      $form->removeElement('business_url');
      $form->removeElement('business_url_msg');
    }
    $this->view->is_ajax = $this->_getParam('is_ajax', '');
    if( !empty($sitebusiness->draft) ) {
      $form->removeElement('draft');
    }
    $form->removeElement('photo');

    $this->view->category_id = $sitebusiness->category_id;
    $subcategory_id = $this->view->subcategory_id = $sitebusiness->subcategory_id;
    $this->view->subsubcategory_id = $sitebusiness->subsubcategory_id;
    $row = Engine_Api::_()->getDbTable('categories', 'sitebusiness')->getCategory($subcategory_id);
    if( !empty($row->category_name) ) {
      $this->view->subcategory_name = $row->category_name;
    }

    $sitebusinessFormEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessform');
    if( $sitebusinessFormEnabled ) {
      $quetion = Engine_Api::_()->getDbtable('businessquetions', 'sitebusinessform');
      $select_quetion = $quetion->select()->where('business_id = ?', $business_id);
      $result_quetion = $quetion->fetchRow($select_quetion);
      $this->view->option_id = $result_quetion->option_id;
    }

    $values['user_id'] = $viewer_id;

    //SAVE SITEBUSINESS ENTRY
    if( !$this->getRequest()->isPost() ) {

      // prepare tags
      $sitebusinessTags = $sitebusiness->tags()->getTagMaps();
      $tagString = '';

      foreach( $sitebusinessTags as $tagmap ) {

        if( $tagString !== '' )
          $tagString .= ', ';
        $tagString .= $tagmap->getTag()->getTitle();
      }

      $this->view->tagNamePrepared = $tagString;
      $form->tags->setValue($tagString);

      // etc
      $form->populate($sitebusiness->toArray());
      $auth = Engine_Api::_()->authorization()->context;
      $sitebusinessmemberEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember');
      if( !empty($sitebusinessmemberEnabled) ) {
        $roles = array('owner', 'like_member', 'member', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
      } else {
        $roles = array('owner', 'like_member', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
      }

      foreach( $roles as $roleString ) {
        $role = $roleString;

        if( $form->auth_view && 1 == $auth->isAllowed($sitebusiness, $role, 'view') ) {
          $form->auth_view->setValue($roleString);
        }

        if( $form->auth_comment && 1 == $auth->isAllowed($sitebusiness, $role, 'comment') ) {
          $form->auth_comment->setValue($roleString);
        }

        if( $role == 'everyone' )
          continue;

        if( $role === 'like_member' ) {
          $role = $ownerList;
        }

        //Here we change isAllowed function for like privacy work only for populate.
        $sitebusinessAllow = Engine_Api::_()->getApi('allow', 'sitebusiness');
        if( $form->auth_sspcreate && 1 == $sitebusinessAllow->isAllowed($sitebusiness, $role, 'sspcreate') ) {
          $form->auth_sspcreate->setValue($roleString);
        }
        // PHOTO PRIVACY WORK
        if( $form->spcreate && 1 == $sitebusinessAllow->isAllowed($sitebusiness, $role, 'spcreate') ) {
          $form->spcreate->setValue($roleString);
        }
        // DISCUSSION PRIVACY WORK
        if( $form->sdicreate && 1 == $sitebusinessAllow->isAllowed($sitebusiness, $role, 'sdicreate') ) {
          $form->sdicreate->setValue($roleString);
        }
        //SITEBUSINESSDOCUMENT PRIVACY WORK
        if( $form->sdcreate && 1 == $sitebusinessAllow->isAllowed($sitebusiness, $role, 'sdcreate') ) {
          $form->sdcreate->setValue($roleString);
        }
        // SITEBUSINESSVIDEO PRIVACY WORK
        if( $form->svcreate && 1 == $sitebusinessAllow->isAllowed($sitebusiness, $role, 'svcreate') ) {
          $form->svcreate->setValue($roleString);
        }
        //START SITEBUSINESSPOLL PRIVACY WORK
        if( $form->splcreate && 1 == $sitebusinessAllow->isAllowed($sitebusiness, $role, 'splcreate') ) {
          $form->splcreate->setValue($roleString);
        }
        //START SITEBUSINESSNOTE PRIVACY WORK
        if( $form->sncreate && 1 == $sitebusinessAllow->isAllowed($sitebusiness, $role, 'sncreate') ) {
          $form->sncreate->setValue($roleString);
        }
        //START SITEBUSINESSMUSIC PRIVACY WORK
        if( $form->smcreate && 1 == $sitebusinessAllow->isAllowed($sitebusiness, $role, 'smcreate') ) {
          $form->smcreate->setValue($roleString);
        }
        //START SITEBUSINESSEVENT PRIVACY WORK
        if( $form->secreate && 1 == $sitebusinessAllow->isAllowed($sitebusiness, $role, 'secreate') ) {
          $form->secreate->setValue($roleString);
        }
      }

      if( Engine_Api::_()->getApi('subCore', 'sitebusiness')->businessBaseNetworkEnable() ) {
        if( !empty($sitebusiness->networks_privacy) ) {
          $form->networks_privacy->setValue(explode(',', $sitebusiness->networks_privacy));
        } else {
          $form->networks_privacy->setValue(array(0));
        }
      }
      return;
    }
    if( !$form->isValid($this->getRequest()->getPost()) ) {
      $values['category_id'] = $this->view->category_id = $sitebusiness->category_id;
      $values['subcategory_id'] = $this->view->subcategory_id = $sitebusiness->subcategory_id;
      $values['subsubcategory_id'] = $this->view->subsubcategory_id = $sitebusiness->subsubcategory_id;
      $form->populate($values);
      return;
    }

    // handle save for tags
    $values = $form->getValues($values);
    if( !empty($sitebusinessUrlEnabled) && !empty($show_url) && !empty($edit_url) ) {
      $change_url = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.change.url', 1);
      $urlArray = Engine_Api::_()->sitebusiness()->getBannedUrls();
      $sitebusinessTable = Engine_Api::_()->getDbtable('business', 'sitebusiness');
      $selectTable = $sitebusinessTable->select()->where('business_id != ?', $business_id)
        ->where('business_url = ?', $values['business_url']);
      $resultSitebusinessTable = $sitebusinessTable->fetchAll($selectTable);
      if( count($resultSitebusinessTable) || (in_array(strtolower($values['business_url']), $urlArray)) && (!empty($change_url)) ) {
        $form->addError(Zend_Registry::get('Zend_Translate')->_('This URL has been restricted by our automated system. Please choose another URL.'));
        return;
      }
    } elseif( !empty($sitebusinessUrlEnabled) && empty($show_url) ) {
      $urlArray = Engine_Api::_()->sitebusiness()->getBannedUrls();
      $table = Engine_Api::_()->getDbtable('business', 'sitebusiness');
      $resultBusinessTable = $table->select()->where('title =?', $values['title'])->from($table, 'title')
          ->query()->fetchAll(Zend_Db::FETCH_COLUMN);
      $count_index = count($resultBusinessTable);
      $resultBusinessUrl = $table->select()->where('business_url =?', $values['title'])->from($table, 'business_url')
          ->query()->fetchAll(Zend_Db::FETCH_COLUMN);
      $count_index_url = count($resultBusinessUrl);

      if( empty($count_index) ) {
        $values['business_url'] = trim(preg_replace('/-+/', '-', preg_replace('/[^a-z0-9-]+/i', '-', strtolower($values['title']))), '-');
        if( !empty($count_index) || !empty($count_index_url) ) {
          $values['business_url'] = $values['business_url'] . '-' . $business_id;
        } else {
          $values['business_url'] = $values['business_url'];
        }
        if( in_array(($values['business_url']), $urlArray) ) {

          $form->addError(Zend_Registry::get('Zend_Translate')->_('This Business title has been blocked by our automated system. Please choose another title.', array('escape' => false)));
          return;
        }
      }
    }

    $is_error = 0;
    Engine_Api::_()->getItemtable('sitebusiness_package')->setPackages();
    if( !Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.category.edit', 0) && !empty($sitebusiness->category_id) ) {
      $values['category_id'] = $this->view->category_id = $sitebusiness->category_id;
      $values['subcategory_id'] = $this->view->subcategory_id = $sitebusiness->subcategory_id;
      $values['subsubcategory_id'] = $this->view->subsubcategory_id = $sitebusiness->subsubcategory_id;
      $form->populate($values);
    }
    if( Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.category.edit', 0) ) {
      if( isset($values['category_id']) && empty($values['category_id']) ) {
        $is_error = 1;
        $this->view->category_id = 0;
        $this->view->subsubcategory_id = 0;
        $this->view->subcategory_id = 0;
      }
    }

    if( !Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.category.edit', 0) ) {
      if( isset($values['category_id']) && empty($values['category_id']) ) {
        $is_error = 1;
        $this->view->category_id = 0;
        $this->view->subsubcategory_id = 0;
        $this->view->subcategory_id = 0;
      }
    }

    //set error message
    if( $is_error == 1 ) {
      $this->view->status = false;
      $error = Zend_Registry::get('Zend_Translate')->_('Business Category * Please complete this field - it is required.');
      $form->getDecorator('errors')->setOption('escape', false);
      $form->addError($error);
      return;
    }

    if( $sitebusinessFormEnabled ) {
      $sitebusinessform_form = Engine_Api::_()->getDbtable('sitebusinessforms', 'sitebusinessform');
      $quetion = Engine_Api::_()->getDbtable('businessquetions', 'sitebusinessform');
      $select_quetion = $quetion->select()->where('business_id = ?', $business_id);
      $result_quetion = $quetion->fetchRow($select_quetion);
      $this->view->option_id = $result_quetion->option_id;
      $table_option = Engine_Api::_()->fields()->getTable('sitebusinessform', 'options');
      $table_option->update(array('label' => $values['title']), array('option_id = ?' => $result_quetion->option_id));
    }

    $tags = preg_split('/[,]+/', $values['tags']);
    $tags = array_filter(array_map("trim", $tags));

    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    try {
      if( Engine_Api::_()->getApi('subCore', 'sitebusiness')->businessBaseNetworkEnable() ) {

        if( isset($values['networks_privacy']) && !empty($values['networks_privacy']) ) {
          if( in_array(0, $values['networks_privacy']) ) {
            $values['networks_privacy'] = new Zend_Db_Expr('NULL');
            $form->networks_privacy->setValue(array(0));
          } else {
            $values['networks_privacy'] = (string) ( is_array($values['networks_privacy']) ? join(",", $values['networks_privacy']) : $netowrkIds );
          }
        }
      }
      $sitebusiness->setFromArray($values);
      $sitebusiness->modified_date = date('Y-m-d H:i:s');

      $sitebusiness->tags()->setTagMaps($viewer, $tags);
      $sitebusiness->save();

      $location = $sitebusiness->location;

//       if ($previous_location && (empty($previous_location) || ($location !== $previous_location))) {
//         $locationTable = Engine_Api::_()->getDbtable('locations', 'sitebusiness');
//         $locationTable->delete(array('business_id =?' => $business_id, 'location =?' => $previous_location));
//       }
//
//       if (!empty($location) && $location !== $previous_location) {
//         $sitebusiness->setLocation();
//       }


      /* else {
        $locationTable->delete(arr ay(
        'business_id =?' => $business_id
        ));
        } */
      //CREATE AUTH STUFF HERE
      $auth = Engine_Api::_()->authorization()->context;
      $sitebusinessmemberEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember');
      if( !empty($sitebusinessmemberEnabled) ) {
        $roles = array('owner', 'member', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
      } else {
        $roles = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
      }

      $oldViewPrivacy = 'owner';
      foreach( $roles as $role ) {
        if( 1 == $auth->isAllowed($sitebusiness, $role, 'view') ) {
          $oldViewPrivacy = $role;
        }
      }

      $values = $form->getValues();
      if( $values['auth_view'] )
        $auth_view = $values['auth_view'];
      else
        $auth_view = "everyone";
      $viewMax = array_search($auth_view, $roles);

      foreach( $roles as $i => $role ) {
        $auth->setAllowed($sitebusiness, $role, 'view', ($i <= $viewMax));
      }

      $sitebusinessmemberEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember');
      if( !empty($sitebusinessmemberEnabled) ) {
        $roles = array('owner', 'member', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
      } else {
        $roles = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
      }

      if( $values['auth_comment'] )
        $auth_comment = $values['auth_comment'];
      else
        $auth_comment = "everyone";
      $commentMax = array_search($auth_comment, $roles);

      foreach( $roles as $i => $role ) {
        $auth->setAllowed($sitebusiness, $role, 'comment', ($i <= $commentMax));
      }

      $sitebusinessmemberEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember');
      if( !empty($sitebusinessmemberEnabled) ) {
        $roles = array('owner', 'like_member', 'member', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
      } else {
        $roles = array('owner', 'like_member', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
      }

      //START WORK FOR SUB BUSINESS.
      if( $values['auth_sspcreate'] )
        $subbusiness = $values['auth_sspcreate'];
      else
        $subbusiness = "owner";
      $subbusinessMax = array_search($subbusiness, $roles);

      foreach( $roles as $i => $role ) {
        if( $role === 'like_member' ) {
          $role = $ownerList;
        }
        $auth->setAllowed($sitebusiness, $role, 'sspcreate', ($i <= $subbusinessMax));
      }
      //END WORK FOR SUBBUSINESS
      //START DISCUSSION PRIVACY WORK
      $sitebusinessdiscussionEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessdiscussion');
      if( $sitebusinessdiscussionEnabled ) {
        if( $values['sdicreate'] )
          $photo = $values['sdicreate'];
        else
          $photo = "registered";
        $photoMax = array_search($photo, $roles);

        foreach( $roles as $i => $role ) {
          if( $role === 'like_member' ) {
            $role = $ownerList;
          }
          $auth->setAllowed($sitebusiness, $role, 'sdicreate', ($i <= $photoMax));
        }
      }
      //END DISCUSSION PRIVACY WORK
      //START PHOTO PRIVACY WORK
      $sitebusinessalbumEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessalbum');
      if( $sitebusinessalbumEnabled ) {
        if( $values['spcreate'] )
          $photo = $values['spcreate'];
        else
          $photo = "registered";
        $photoMax = array_search($photo, $roles);

        foreach( $roles as $i => $role ) {
          if( $role === 'like_member' ) {
            $role = $ownerList;
          }
          $auth->setAllowed($sitebusiness, $role, 'spcreate', ($i <= $photoMax));
        }
      }
      //END PHOTO PRIVACY WORK
      //START SITEBUSINESSDOCUMENT WORK
      $sitebusinessDocumentEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessdocument');
      if( $sitebusinessDocumentEnabled || (Engine_Api::_()->hasModuleBootstrap('document') && Engine_Api::_()->getDbtable('modules', 'document')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'sitebusiness_business', 'item_module' => 'sitebusiness'))) ) {

        if( $values['sdcreate'] )
          $sdcreate = $values['sdcreate'];
        else
          $sdcreate = "registered";

        $sdcreateMax = array_search($sdcreate, $roles);

        foreach( $roles as $i => $role ) {
          if( $role === 'like_member' ) {
            $role = $ownerList;
          }
          $auth->setAllowed($sitebusiness, $role, 'sdcreate', ($i <= $sdcreateMax));
        }
      }
      //END SITEBUSINESSDOCUMENT WORK
      //
            //START SITECROWDFUNDING WORK
      $sitecrowdfundingEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitecrowdfunding');
      if( $sitecrowdfundingEnabled && (Engine_Api::_()->hasModuleBootstrap('sitecrowdfundingintegration') && Engine_Api::_()->getDbtable('modules', 'sitecrowdfunding')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'sitebusiness_business', 'item_module' => 'sitebusiness'))) ) {
        if( $values['sprcreate'] )
          $sprcreate = $values['sprcreate'];
        else
          $sprcreate = "registered";
        $sprcreateMax = array_search($sprcreate, $roles);

        foreach( $roles as $i => $role ) {
          if( $role === 'like_member' ) {
            $role = $ownerList;
          }
          $auth->setAllowed($sitebusiness, $role, 'sprcreate', ($i <= $sprcreateMax));
        }
      }
      //END SITECROWDFUNDING WORK
      //START SITEMUSIC WORK
      $sitemusicEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitemusic');
      if( $sitemusicEnabled && (Engine_Api::_()->hasModuleBootstrap('sitemusic') && Engine_Api::_()->getDbtable('modules', 'sitemusic')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'sitebusiness_business', 'item_module' => 'sitebusiness'))) ) {
        if( $values['samcreate'] )
          $samcreate = $values['samcreate'];
        else
          $samcreate = "registered";
        $samcreateMax = array_search($samcreate, $roles);

        foreach( $roles as $i => $role ) {
          if( $role === 'like_member' ) {
            $role = $ownerList;
          }
          $auth->setAllowed($sitebusiness, $role, 'samcreate', ($i <= $sprcreateMax));
        }
      }
      //END SITEMUSIC WORK
      //START SITEBUSINESSVIDEO WORK
      $sitebusinessvideoEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessvideo');
      if( $sitebusinessvideoEnabled || (Engine_Api::_()->hasModuleBootstrap('sitevideo') && Engine_Api::_()->getDbtable('modules', 'sitevideo')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'sitebusiness_business', 'item_module' => 'sitebusiness'))) ) {
        if( $values['svcreate'] )
          $svcreate = $values['svcreate'];
        else
          $svcreate = "registered";
        $svcreateMax = array_search($svcreate, $roles);

        foreach( $roles as $i => $role ) {
          if( $role === 'like_member' ) {
            $role = $ownerList;
          }
          $auth->setAllowed($sitebusiness, $role, 'svcreate', ($i <= $svcreateMax));
        }
      }
      //END SITEBUSINESSVIDEO WORK
      //START SITEBUSINESSPOLL WORK
      $sitebusinessPollEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinesspoll');
      if( $sitebusinessPollEnabled ) {
        if( $values['splcreate'] )
          $splcreate = $values['splcreate'];
        else
          $splcreate = "registered";
        $splcreateMax = array_search($splcreate, $roles);

        foreach( $roles as $i => $role ) {
          if( $role === 'like_member' ) {
            $role = $ownerList;
          }
          $auth->setAllowed($sitebusiness, $role, 'splcreate', ($i <= $splcreateMax));
        }
      }
      //END SITEBUSINESSPOLL WORK
      //START SITEBUSINESSNOTE WORK
      $sitebusinessNoteEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessnote');
      if( $sitebusinessNoteEnabled ) {
        $sitebusinessmemberEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember');
        if( !empty($sitebusinessmemberEnabled) ) {
          $roles = array('owner', 'like_member', 'member', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
        } else {
          $roles = array('owner', 'like_member', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
        }
        if( $values['sncreate'] )
          $sncreate = $values['sncreate'];
        else
          $sncreate = "registered";
        $sncreateMax = array_search($sncreate, $roles);

        foreach( $roles as $i => $role ) {
          if( $role === 'like_member' ) {
            $role = $ownerList;
          }
          $auth->setAllowed($sitebusiness, $role, 'sncreate', ($i <= $sncreateMax));
        }
      }
      //END SITEBUSINESSNOTE WORK
      //START SITEBUSINESSMUSIC WORK
      $sitebusinessMusicEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmusic');
      if( $sitebusinessMusicEnabled ) {
        $sitebusinessmemberEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember');
        if( !empty($sitebusinessmemberEnabled) ) {
          $roles = array('owner', 'like_member', 'member', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
        } else {
          $roles = array('owner', 'like_member', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
        }

        if( $values['smcreate'] )
          $smcreate = $values['smcreate'];
        else
          $smcreate = "registered";
        $smcreateMax = array_search($smcreate, $roles);

        foreach( $roles as $i => $role ) {
          if( $role === 'like_member' ) {
            $role = $ownerList;
          }
          $auth->setAllowed($sitebusiness, $role, 'smcreate', ($i <= $smcreateMax));
        }
      }
      //END SITEBUSINESSNOTE WORK
      //START SITEBUSINESSEVENT WORK
      $sitebusinesseventEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessevent');
      if( $sitebusinesseventEnabled || (Engine_Api::_()->hasModuleBootstrap('siteevent') && Engine_Api::_()->getDbtable('modules', 'siteevent')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'sitebusiness_business', 'item_module' => 'sitebusiness'))) ) {
        $sitebusinessmemberEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember');
        if( !empty($sitebusinessmemberEnabled) ) {
          $roles = array('owner', 'like_member', 'member', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
        } else {
          $roles = array('owner', 'like_member', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
        }
        if( $values['secreate'] )
          $secreate = $values['secreate'];
        else
          $secreate = "registered";
        $secreateMax = array_search($secreate, $roles);

        foreach( $roles as $i => $role ) {
          if( $role === 'like_member' ) {
            $role = $ownerList;
          }
          $auth->setAllowed($sitebusiness, $role, 'secreate', ($i <= $secreateMax));
        }
      }
      //END SITEBUSINESSEVENT WORK
      //START SITEBUSINESSREVIEW CODE
      $sitebusinessReviewEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessreview');
      if( $sitebusinessReviewEnabled && $previous_category_id != $sitebusiness->category_id ) {
        Engine_Api::_()->getDbtable('ratings', 'sitebusinessreview')->editBusinessCategory($sitebusiness->business_id, $previous_category_id, $sitebusiness->category_id);
      }
      //END SITEBUSINESSREVIEW CODE
      //START SITEBUSINESSMEMBER CODE
      $sitebusinessmemberEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember');
      if( $sitebusinessmemberEnabled && $previous_category_id != $sitebusiness->category_id ) {
        $db->query("UPDATE `engine4_sitebusiness_membership` SET `role_id` = '0' WHERE `engine4_sitebusiness_membership`.`business_id` = " . $sitebusiness->business_id . ";");
      }
      //END SITEBUSINESSMEMBER CODE
      //START PROFILE MAPPING WORK IF CATEGORY IS EDIT
      if( $previous_category_id != $sitebusiness->category_id ) {
        Engine_Api::_()->getDbtable('profilemaps', 'sitebusiness')->editCategoryMapping($sitebusiness);
      }

      //END PROFILE MAPPING WORK IF CATEGORY IS EDIT
      //INSERT ACTIVITY IF BUSINESS IS JUST GETTING PUBLISHED
      $action = Engine_Api::_()->getDbtable('actions', 'activity')->getActionsByObject($sitebusiness);
      if( count($action->toArray()) <= 0 && isset($values['draft']) && $values['draft'] == '1' && empty($sitebusiness->pending) ) {
        Engine_Api::_()->sitebusiness()->attachBusinessActivity($sitebusiness);
      }
      $db->commit();

      if( !Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.category.edit', 0) && !empty($sitebusiness->category_id) ) {

        $this->view->category_id = $sitebusiness->category_id;
        $this->view->subcategory_id = $subcategory_id = $sitebusiness->subcategory_id;
        $table = Engine_Api::_()->getDbtable('categories', 'sitebusiness');
        $categoriesName = $table->info('name');

        $select = $table->select()->from($categoriesName, 'category_name')
          ->where("(category_id = $subcategory_id)");

        $row = $table->fetchRow($select);
        if( !empty($row->category_name) ) {
          $this->view->subcategory_name = $row->category_name;
        }
        $form->getElement('category_id')
          ->setIgnore(true)
          ->setAttrib('disable', true)
          ->clearValidators()
          ->setRequired(false)
          ->setAllowEmpty(true)
        ;
      } else {
        $this->view->category_id = $sitebusiness->category_id;
        $this->view->subcategory_id = $subcategory_id = $sitebusiness->subcategory_id;
        $this->view->subsubcategory_id = $subsubcategory_id = $sitebusiness->subsubcategory_id;
        $table = Engine_Api::_()->getDbtable('categories', 'sitebusiness');
        $categoriesName = $table->info('name');
        $select = $table->select()->from($categoriesName, 'category_name')
          ->where("(category_id = $subcategory_id)");

        $row = $table->fetchRow($select);
        if( !empty($row->category_name) ) {
          $this->view->subcategory_name = $row->category_name;
        }
      }
      $this->view->form = $form->addNotice(Zend_Registry::get('Zend_Translate')->_('Your changes have been saved.'));
    } catch( Exception $e ) {
      $db->rollBack();
      throw $e;
    }

    $db->beginTransaction();
    try {

      // REBUILD ACTION PRIVACY ONLY IF OBJECT'S VIEW PRIVACY HAS CHANGED
      if ($oldViewPrivacy !== $values['auth_view']) {
        $actionTable = Engine_Api::_()->getDbtable('actions', 'activity');
        foreach( $actionTable->getActionsByObject($sitebusiness) as $action ) {
          $actionTable->resetActivityBindings($action);
        }
      }

      $db->commit();
    } catch( Exception $e ) {
      $db->rollBack();
      throw $e;
    }
  }

  //ACTION FOR DELETING BUSINESS
  public function deleteAction()
  {

    //USER VALIDATION
    if( !$this->_helper->requireUser()->isValid() )
      return;

    //NAVIGATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sitebusiness_main', array(), 'sitebusiness_main_manage');

    //GET BUSINESS ID AND OBJECT
    $business_id = $this->_getParam('business_id');
    $this->view->sitebusiness = $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'delete');
    if( empty($isManageAdmin) ) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }
    //END MANAGE-ADMIN CHECK

    if( $this->getRequest()->isPost() && $this->getRequest()->getPost('confirm') == true ) {

      //START SUB BUSINESS WORK
      $getSubBusinessids = Engine_Api::_()->getDbTable('business', 'sitebusiness')->getsubBusinessids($business_id);
      foreach( $getSubBusinessids as $getSubBusinessid ) {
        Engine_Api::_()->sitebusiness()->onBusinessDelete($getSubBusinessid['business_id']);
      }
      //END SUB BUSINESS WORK

      Engine_Api::_()->sitebusiness()->onBusinessDelete($business_id);
      return $this->_helper->redirector->gotoRoute(array('action' => 'manage'), 'sitebusiness_general', true);
    }
  }

  //ACTION: CLOSE / OPEN BUSINESS
  public function closeAction()
  {

    //USER VALIDATION
    if( !$this->_helper->requireUser()->isValid() )
      return;

    //GET BUSINESS OBJECT
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $this->_getParam('business_id'));

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if( empty($isManageAdmin) ) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }
    //END MANAGE-ADMIN CHECK

    $sitebusiness->closed = $this->_getParam('closed');
    $sitebusiness->save();

    $check = $this->_getParam('check');
    if( !empty($check) ) {
      return $this->_helper->redirector->gotoRoute(array('action' => 'my-businesses'), 'sitebusiness_manageadmins', true);
    } else {
      return $this->_helper->redirector->gotoRoute(array('action' => 'manage'), 'sitebusiness_general', true);
    }
  }

  //ACTION FOR CONSTRUCT TAG CLOUD
  public function tagsCloudAction()
  {

    //GET NAVIGATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sitebusiness_main');

    //GENERATE TAG-CLOULD HIDDEN FROM
    $this->view->form = $form = new Sitebusiness_Form_Searchtagcloud();
    $category_id = $this->_getParam('category_id', 0);

    //CONSTRUCTING TAG CLOUD
    $tag_array = array();
    $tag_cloud_array = Engine_Api::_()->getDbtable('business', 'sitebusiness')->getTagCloud('', $category_id, 0);
    $tag_id_array = array();
    foreach( $tag_cloud_array as $vales ) {
      $tag_array[$vales['text']] = $vales['Frequency'];
      $tag_id_array[$vales['text']] = $vales['tag_id'];
    }

    if( !empty($tag_array) ) {
      $max_font_size = 18;
      $min_font_size = 12;
      $max_frequency = max(array_values($tag_array));
      $min_frequency = min(array_values($tag_array));
      $spread = $max_frequency - $min_frequency;

      if( $spread == 0 ) {
        $spread = 1;
      }

      $step = ($max_font_size - $min_font_size) / ($spread);

      $tag_data = array('min_font_size' => $min_font_size, 'max_font_size' => $max_font_size, 'max_frequency' => $max_frequency, 'min_frequency' => $min_frequency, 'step' => $step);

      $this->view->tag_data = $tag_data;
      $this->view->tag_id_array = $tag_id_array;
    }
    $this->view->tag_array = $tag_array;
  }

  //ACTION FOR FETCHING SUB-CATEGORY
  public function subcategoryAction()
  {

    $category_id_temp = Zend_Controller_Front::getInstance()->getRequest()->getParam('category_id_temp');
    $row = Engine_Api::_()->getDbTable('categories', 'sitebusiness')->getCategory($category_id_temp);
    if( !empty($row->category_name) ) {
      $categoryname = Engine_Api::_()->getDbTable('categories', 'sitebusiness')->getCategorySlug($row->category_name);
    }
    $data = array();
    $this->view->subcats = $data;
    if( empty($category_id_temp) )
      return;
    $results = Engine_Api::_()->getDbTable('categories', 'sitebusiness')->getSubCategories($category_id_temp);
    foreach( $results as $value ) {
      $content_array = array();
      $content_array['category_name'] = Zend_Registry::get('Zend_Translate')->_($value->category_name);
      $content_array['category_id'] = $value->category_id;
      $content_array['categoryname_temp'] = $categoryname;
      $data[] = $content_array;
    }
    $this->view->subcats = $data;
  }

  //ACTION FOR BUSINESS PUBLISH
  public function publishAction()
  {

    //CHECK USER VALIDATION
    if( !$this->_helper->requireUser()->isValid() )
      return;

    //SMOOTHBOX
    if( null == $this->_helper->ajaxContext->getCurrentContext() ) {
      $this->_helper->layout->setLayout('default-simple');
    } else {
      //NO LAYOUT
      $this->_helper->layout->disableLayout(true);
    }

    $business_id = $this->view->business_id = $this->_getParam('business_id');

    if( !$this->getRequest()->isPost() )
      return;

    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if( empty($isManageAdmin) ) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }
    //END MANAGE-ADMIN CHECK

    $this->view->permission = true;
    $this->view->success = false;
    $db = Engine_Api::_()->getDbtable('business', 'sitebusiness')->getAdapter();
    $db->beginTransaction();
    if( !empty($_POST['search']) )
      $search = 1;
    else
      $search = 0;
    try {
      $sitebusiness->modified_date = new Zend_Db_Expr('NOW()');
      $sitebusiness->draft = 1;
      $sitebusiness->search = $search;
      $sitebusiness->save();
      $db->commit();
      if( !empty($sitebusiness->draft) && empty($sitebusiness->pending) ) {
        Engine_Api::_()->sitebusiness()->attachBusinessActivity($sitebusiness);
      }
      $this->view->success = true;
    } catch( Exception $e ) {
      $db->rollback();
      throw $e;
    }

    $this->_forwardCustom('success', 'utility', 'core', array(
      'smoothboxClose' => 10,
      'parentRefresh' => 10,
      'messages' => array(Zend_Registry::get('Zend_Translate')->_('Successfully Published !'))
    ));
  }

  //ACTION FOR BUSINESS URL VALIDATION AT BUSINESS CREATION TIME
  public function businessurlvalidationAction()
  {

    $business_url = $this->_getParam('business_url');
    $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
    $sitebusinessUrlEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessurl');
    if( !empty($sitebusinessUrlEnabled) ) {
      $urlArray = Engine_Api::_()->sitebusiness()->getBannedUrls();
    }
    if( empty($business_url) ) {
      echo Zend_Json::encode(array('success' => 0, 'error_msg' => '<span style="color:red;"><img src="' . $view->layout()->staticBaseUrl . 'application/modules/Sitebusiness/externals/images/cross.png"/>URL not valid.</span>'));
      exit();
    }

    $url_lenght = strlen($business_url);
    if( $url_lenght < 3 ) {
      $error_msg1 = Zend_Registry::get('Zend_Translate')->_("URL component should be atleast 3 characters long.");
      echo Zend_Json::encode(array('success' => 0, 'error_msg' => "<span style='color:red;'><img src='" . $view->layout()->staticBaseUrl . "application/modules/Sitebusiness/externals/images/cross.png'/>$error_msg1</span>"));
      exit();
    } elseif( $url_lenght > 255 ) {
      $error_msg2 = Zend_Registry::get('Zend_Translate')->_("URL component should be maximum 255 characters long.");
      echo Zend_Json::encode(array('success' => 0, 'error_msg' => "<span style='color:red;'><img src='" . $view->layout()->staticBaseUrl . "application/modules/Sitebusiness/externals/images/cross.png'/>$error_msg2</span>"));
      exit();
    }

    $change_url = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.change.url', 1);
    $check_url = $this->_getParam('check_url');
    if( !empty($check_url) ) {
      $businessId = $this->_getParam('business_id');
      $business_id = Engine_Api::_()->sitebusiness()->getBusinessId($business_url, $businessId);
    } else {
      $business_id = Engine_Api::_()->sitebusiness()->getBusinessId($business_url);
    }
    if( !empty($sitebusinessUrlEnabled) ) {
      if( !empty($business_id) || (in_array(strtolower($business_url), $urlArray)) ) {
        $error_msg3 = Zend_Registry::get('Zend_Translate')->_("URL not available.");
        echo Zend_Json::encode(array('success' => 0, 'error_msg' => "<span style='color:red;'><img src='" . $view->layout()->staticBaseUrl . "application/modules/Sitebusiness/externals/images/cross.png'/>$error_msg3</span>"));
        exit();
      }
    } else {
      if( !empty($business_id) ) {
        $error_msg3 = Zend_Registry::get('Zend_Translate')->_("URL not available.");
        echo Zend_Json::encode(array('success' => 0, 'error_msg' => "<span style='color:red;'><img src='" . $view->layout()->staticBaseUrl . "application/modules/Sitebusiness/externals/images/cross.png'/>$error_msg3</span>"));
        exit();
      }
    }



    if( !preg_match("/^[a-zA-Z0-9-_]+$/", $business_url) ) {
      $error_msg4 = Zend_Registry::get('Zend_Translate')->_("URL component can contain alphabets, numbers, underscores & dashes only.");
      echo Zend_Json::encode(array('success' => 0, 'error_msg' => "<span style='color:red;'><img src='" . $view->layout()->staticBaseUrl . "application/modules/Sitebusiness/externals/images/cross.png'/>$error_msg4</span>"));
      exit();
    } else {
      $error_msg5 = Zend_Registry::get('Zend_Translate')->_("URL Available!");
      echo Zend_Json::encode(array('success' => 1, 'success_msg' => "<span style='color:green;'><img src='" . $view->layout()->staticBaseUrl . "application/modules/Sitebusiness/externals/images/tick.png'/>$error_msg5</span>"));
      exit();
    }
  }

  //ACITON FOR LISTING BUSINESSS AT HOME BUSINESS
  public function ajaxHomeListAction()
  {
    $params = array();
    $this->view->category_id = $category_id = $params['category_id'] = $this->_getParam('category_id', 0);
    $tab_show_values = $this->_getParam('tab_show', null);
    $this->view->list_view = $this->_getParam('list_view', 0);
    $this->view->grid_view = $this->_getParam('grid_view', 0);
    $this->view->map_view = $this->_getParam('map_view', 0);
    $this->view->defaultView = $this->_getParam('defaultView', 0);
    $this->view->active_tab_list = $list_limit = $this->_getParam('list_limit', 0);
    $this->view->active_tab_image = $grid_limit = $this->_getParam('grid_limit', 0);
    $this->view->columnHeight = $this->_getParam('columnHeight', 350);
    $this->view->columnWidth = $this->_getParam('columnWidth', 188);
    $this->view->showfeaturedLable = $this->_getParam('showfeaturedLable', 1);
    $this->view->showsponsoredLable = $this->_getParam('showsponsoredLable', 1);
    $this->view->showlocation = $this->_getParam('showlocation', 1);
    $this->view->showprice = $this->_getParam('showprice', 1);
    $this->view->showpostedBy = $this->_getParam('showpostedBy', 1);
    $this->view->showdate = $this->_getParam('showdate', 1);
    $this->view->turncation = $this->_getParam('turncation', 15);
    $this->view->showlikebutton = $this->_getParam('turncation', 15);
    $this->view->listview_turncation = $this->_getParam('listview_turncation', 15);
    $this->view->showlikebutton = $this->_getParam('showlikebutton', 1);

    $this->view->detactLocation = $params['detactLocation'] = $this->_getParam('detactLocation', 0);
    if( $this->view->detactLocation ) {
      $this->view->defaultLocationDistance = $params['defaultLocationDistance'] = $this->_getParam('defaultLocationDistance', 1000);
      $this->view->latitude = $params['latitude'] = $this->_getParam('latitude', 0);
      $this->view->longitude = $params['longitude'] = $this->_getParam('longitude', 0);
    }

    $this->view->statistics = Zend_Json_Decoder::decode($this->_getParam('statistics'));
    $params['limit'] = $limit = $list_limit > $grid_limit ? $list_limit : $grid_limit;

    $columnsArray = array('business_id', 'title', 'business_url', 'owner_id', 'category_id', 'photo_id', 'price', 'location', 'creation_date', 'featured', 'sponsored', 'view_count', 'comment_count', 'like_count', 'follow_count');
    if( Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember') ) {
      $columnsArray[] = 'member_count';
    }
    $columnsArray[] = 'member_title';

    if( Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessreview') ) {
      $columnsArray[] = 'review_count';
      $columnsArray[] = 'rating';
    }

    $this->view->sitebusinessesitebusiness = $sitebusiness = Engine_Api::_()->getDbTable('business', 'sitebusiness')->getListings($tab_show_values, $params, null, null, $columnsArray);

    $this->view->enablePrice = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.price.field', 1);

    $this->view->enableLocation = $checkLocation = Engine_Api::_()->sitebusiness()->enableLocation();
    if( !empty($this->view->map_view) ) {

      $this->view->flageSponsored = 0;

      if( !empty($checkLocation) ) {
        $ids = array();
        $sponsored = array();
        foreach( $sitebusiness as $sitebusiness_business ) {
          $id = $sitebusiness_business->getIdentity();
          $ids[] = $id;
          $sitebusiness_temp[$id] = $sitebusiness_business;
        }
        $values['business_ids'] = $ids;

        $this->view->locations = $locations = Engine_Api::_()->getDbtable('locations', 'sitebusiness')->getLocation($values);
        foreach( $locations as $location ) {
          if( $sitebusiness_temp[$location->business_id]->sponsored ) {
            $this->view->flageSponsored = 1;
            break;
          }
        }
        $this->view->sitebusiness = $sitebusiness_temp;
      }
    }
    // Rating enable /disable
    $this->view->ratngShow = $ratingShow = (int) Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessreview');

    $view = $this->view;
    $view->addHelperPath(APPLICATION_PATH . '/application/modules/Fields/View/Helper', 'Fields_View_Helper');
  }

  public function checkLevelHost($object, $itemType)
  {
    $length = 7;
    $encodeorder = 0;
    $obj_length = strlen($object);
    if( $length > $obj_length )
      $length = $obj_length;
    for( $i = 0; $i < $length; $i++ ) {
      $encodeorder += ord($object[$i]);
    }
    $req_mode = $encodeorder % strlen($itemType);
    $encodeorder += ord($itemType[$req_mode]);
    $isEnabled = Engine_Api::_()->sitebusiness()->isEnabled();
    if( empty($isEnabled) ) {
      return 0;
    } else {
      return $encodeorder;
    }
  }

  public function checkPackageHost($strKey)
  {
    $str = explode("-", $strKey);
    $str = $str[2];
    $char_array = array();
    for( $i = 0; $i < 6; $i++ )
      $char_array[] = $str[$i];
    $key = array();
    foreach( $char_array as $value ) {
      $v_a = ord($value);
      if( $v_a > 47 && $v_a < 58 )
        continue;
      $possition = 0;
      $possition = $v_a % 10;
      if( $possition > 5 )
        $possition -= 4;
      $key[] = $char_array[$possition];
    }
    $isEnabled = Engine_Api::_()->sitebusiness()->isEnabled();
    if( empty($isEnabled) ) {
      return 0;
    } else {
      return $getStr = implode($key);
    }
  }

  public function setPhpIniMemorySize()
  {
    $memory_size = ini_get('memory_limit');
    $memory_Size_int_array = explode("M", $memory_size);
    $memory_Size_int = $memory_Size_int_array[0];
    if( $memory_Size_int <= 32 )
      ini_set('memory_limit', '64M');
  }

  //ACTION FOR GETTING THE BUSINESSS WHICH BUSINESSS CAN BE SEARCH
  public function getSearchBusinessesAction()
  {

    $usersitebusinesses = Engine_Api::_()->getDbtable('business', 'sitebusiness')->getDayItems($this->_getParam('text'), $this->_getParam('limit', 10), $this->_getParam('category_id'));
    $data = array();
    $mode = $this->_getParam('struct');
    $count = count($usersitebusinesses);
    if( $mode == 'text' ) {
      $i = 0;
      foreach( $usersitebusinesses as $usersitebusiness ) {
        $business_url = $this->view->url(array('business_url' => Engine_Api::_()->sitebusiness()->getBusinessUrl($usersitebusiness->business_id)), 'sitebusiness_entry_view', true);
        $i++;
        $content_photo = $this->view->itemPhoto($usersitebusiness, 'thumb.icon');
        $data[] = array(
          'id' => $usersitebusiness->business_id,
          'label' => $usersitebusiness->title,
          'photo' => $content_photo,
          'business_url' => $business_url,
          'total_count' => $count,
          'count' => $i
        );
      }
    } else {
      $i = 0;
      foreach( $usersitebusinesses as $usersitebusiness ) {
        $business_url = $this->view->url(array('business_url' => Engine_Api::_()->sitebusiness()->getBusinessUrl($usersitebusiness->business_id)), 'sitebusiness_entry_view', true);
        $content_photo = $this->view->itemPhoto($usersitebusiness, 'thumb.icon');
        $i++;
        $data[] = array(
          'id' => $usersitebusiness->business_id,
          'label' => $usersitebusiness->title,
          'photo' => $content_photo,
          'business_url' => $business_url,
          'total_count' => $count,
          'count' => $i
        );
      }
    }
    if( !empty($data) && $i >= 1 ) {
      if( $data[--$i]['count'] == $count ) {
        $data[$count]['id'] = 'stopevent';
        $data[$count]['label'] = $this->_getParam('text');
        $data[$count]['business_url'] = 'seeMoreLink';
        $data[$count]['total_count'] = $count;
      }
    }
    return $this->_helper->json($data);
  }

  //ACTION FOR FETCHING SUB-CATEGORY
  public function subsubcategoryAction()
  {

    $subcategory_id_temp = Zend_Controller_Front::getInstance()->getRequest()->getParam('subcategory_id_temp');

    $row = Engine_Api::_()->getDbTable('categories', 'sitebusiness')->getCategory($subcategory_id_temp);
    if( !empty($row->category_name) ) {
      $categoryname = Engine_Api::_()->getDbTable('categories', 'sitebusiness')->getCategorySlug($row->category_name);
    }
    $data = array();
    $this->view->subsubcats = $data;
    if( empty($subcategory_id_temp) )
      return;

    $results = Engine_Api::_()->getDbTable('categories', 'sitebusiness')->getSubCategories($subcategory_id_temp);

    foreach( $results as $value ) {
      $content_array = array();
      $content_array['category_name'] = Zend_Registry::get('Zend_Translate')->_($value->category_name);
      $content_array['category_id'] = $value->category_id;
      $content_array['categoryname_temp'] = $categoryname;
      $data[] = $content_array;
    }
    $this->view->subsubcats = $data;
  }

  //ACTION FOR SHOWING LOCAITON IN MAP WITH GET DIRECTION
  public function viewMapAction()
  {

    $this->_helper->layout->setLayout('default-simple');
    $value['id'] = $this->_getParam('id');
    if( !$this->_getParam('id') )
      return $this->_forwardCustom('notfound', 'error', 'core');

    $locationTable = Engine_Api::_()->getDbtable('locations', 'sitebusiness');
    $select = $locationTable->select();
    $select->where('business_id = ?', $value['id']);
    $item = $locationTable->fetchRow($select);

    $params = (array) $item->toArray();
    if( is_array($params) ) {
      $this->view->checkin = $params;
    } else {
      return $this->_forwardCustom('notfound', 'error', 'core');
    }
  }

  protected function renderUserWidgetCustom()
  {
    if( !Engine_Api::_()->seaocore()->isSitemobileApp() )
      return;
    $content_id = $this->_getParam('tab');
    //  $params = $this->_getAllParams();
    // Render by content row
    if( null !== $content_id ) {
      $view = $this->_getParam('view');
      $show_container = $this->_getParam('container', true);
      $contentTable = Engine_Api::_()->getDbtable('mobileContent', 'sitebusiness');
      $row = $contentTable->find($content_id)->current();

      if( null !== $row ) {
        // Build full structure from children
        $mobilecontentpage_id = $row->mobilecontentbusiness_id;
        $pageTable = Engine_Api::_()->getDbtable('mobileContentbusinesses', 'sitebusiness');
        $content = $contentTable->fetchAll($contentTable->select()->where('mobilecontentbusiness_id = ?', $mobilecontentpage_id));
        $structure = $pageTable->createElementParams($row);
        $children = $pageTable->prepareContentArea($content, $row);
        if( !empty($children) ) {
          $structure['elements'] = $children;
        }
        $structure['request'] = $this->getRequest();
        $structure['action'] = $view;
        if( $this->getContainerContent($structure, $show_container) )
          return true;
      } else {
        $contentTable = Engine_Api::_()->getDbtable('mobileadmincontent', 'sitebusiness');
        $row = $contentTable->find($content_id)->current();
        $business_id = Engine_Api::_()->sitebusiness()->getMobileWidgetizedBusiness()->page_id;
        $content = $contentTable->fetchAll($contentTable->select()->where('business_id = ?', $business_id));
        $structure = $contentTable->createElementParams($row);
        $children = $contentTable->prepareContentArea($content, $row);
        if( !empty($children) ) {
          $structure['elements'] = $children;
        }
        $structure['request'] = $this->getRequest();
        $structure['action'] = $view;
        if( $this->getContainerContent($structure, $show_container) )
          return true;
      }
    }
  }

}
