<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: IndexController.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusiness_ManageadminController extends Seaocore_Controller_Action_Standard {

	//ACTION FOR SHOWING BUSINESSS FOR WHICH I AM ADMIN
	public function myBusinessesAction() {

    //USER VALIDATION
		if (!$this->_helper->requireUser()->isValid())
			return;

    //MANAGE ADMIN IS ALLOWED OR NOT BY ADMIN
		$manageAdminEnabled = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.manageadmin', 1);
		if (empty($manageAdminEnabled)) {
			return $this->_forwardCustom('requireauth', 'error', 'core');
		}

    //GETTING THE VIEWER AND VIEWER ID AND PASS VALUE .TPL FILE.
		$viewer = Engine_Api::_()->user()->getViewer();
		$this->view->owner_id = $viewer_id = $viewer->getIdentity();

    //CHEKC FOR MEMBER LEVEL SETTINGS FOR EDIT AND DELETE AND CREATE.
		$this->view->can_create = $this->_helper->requireAuth()->setAuthParams('sitebusiness_business', null, 'create')->checkRequire();
		$this->view->can_edit = $this->_helper->requireAuth()->setAuthParams('sitebusiness_business', null, 'edit')->checkRequire();
		$this->view->can_delete = $this->_helper->requireAuth()->setAuthParams('sitebusiness_business', null, 'delete')->checkRequire();

		$this->view->enablePrice = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.price.field', 1);
		$this->view->enableLocation = $checkLocation = Engine_Api::_()->sitebusiness()->enableLocation();

		//GET NAVIGATION
		$this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitebusiness_main', array(), 'sitebusiness_main_manage');

		//GET QUICK NAVIGATION
		$this->view->quickNavigation = $quickNavigation = Engine_Api::_()->getApi('menus', 'core')
						->getNavigation('sitebusiness_quick');

		$this->view->form = $form = new Sitebusiness_Form_Myadminbusinesses();

		//PROCESS FORM
		$values = array();
		if ($form->isValid($this->_getAllParams())) {
			$values = $form->getValues();
		}

		//RATING ENABLE / DISABLE
		$this->view->ratngShow = $ratingShow = (int) Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessreview');

		//GET BUSINESSS
		$adminbusinesses = Engine_Api::_()->getDbtable('manageadmins', 'sitebusiness')->getManageAdminBusinesses($viewer_id);

		//GET STUFF
		$ids = array();
		foreach ($adminbusinesses as $adminbusiness) {
			$ids[] = $adminbusiness->business_id;
		}
		$values['adminbusinesses'] = $ids;
		$values['orderby'] = 'creation_date';
		
    //$values['notIncludeSelfBusinesses'] = $viewer_id;

		//GET PAGINATOR.
		$this->view->paginator = $paginator = Engine_Api::_()->sitebusiness()->getSitebusinessesPaginator($values, null);
		$items_count = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.business', 10);

		$paginator->setItemCountPerPage($items_count);
		$this->view->paginator = $paginator->setCurrentPageNumber($values['page']);

		$this->view->addHelperPath(APPLICATION_PATH . '/application/modules/Fields/View/Helper', 'Fields_View_Helper');

		//MAXIMUN ALLOWED BUSINESSS.
		$this->view->quota = Engine_Api::_()->authorization()->getPermission($viewer->level_id, 'sitebusiness_business', 'max');
		$this->view->current_count = $paginator->getTotalItemCount();

    if(Engine_Api::_()->seaocore()->isSitemobileApp()) {  
      //SET SCROLLING PARAMETTER FOR AUTO LOADING.
      if (!Zend_Registry::isRegistered('scrollAutoloading')) {      
        Zend_Registry::set('scrollAutoloading', array('scrollingType' => 'up'));
      }
    }
    $this->view->autoContentLoad = $isappajax = $this->_getParam('isappajax', false);
    $this->view->page = $this->_getParam('page', 1);
    $this->view->totalCount = $paginator->getTotalItemCount();
    $this->view->totalPages = ceil(($this->view->totalCount) /$items_count);
    if (!$isappajax) {
      $this->_helper->content/*->setNoRender()*/->setEnabled();
    }
  }

  //MANAGE ADMINS ACTION FOR THE BUSINESSS.
  public function indexAction() {

    //CHECK PERMISSION FOR VIEW.
    if (!$this->_helper->requireUser()->isValid())
      return;

    //GET NAVIGATION.
		$this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
            ->getNavigation('sitebusiness_main');

    $this->view->sitebusinesses_view_menu = 11;

    //GETTING THE VIEWER AND VIEWER ID.
    $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewer->getIdentity();

    //GETTING THE OBJECT AND BUSINESS ID.
    $this->view->business_id = $business_id = $this->_getParam('business_id', null);
    $this->view->sitebusiness = $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    $this->view->owner_id = $sitebusiness->owner_id;
    $this->view->is_ajax = $this->_getParam('is_ajax', '');

    //EDIT PRIVACY
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');

    $manageAdminAllowed = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.manageadmin', 1);
    if (empty($isManageAdmin) || empty($manageAdminAllowed)) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }

		$manageadminsTable = Engine_Api::_()->getDbtable('manageadmins', 'sitebusiness');

		//FETCH DATA
    $this->view->manageHistories = $manageadminsTable->getManageAdminUser($business_id);

    if ($this->getRequest()->isPost()) {

      $values = $this->getRequest()->getPost();
      $selected_user_id = $values['user_id'];
      
      if(empty($selected_user_id))
          return;      

      $row = $manageadminsTable->createRow();
      $row->user_id = $selected_user_id;
      $row->business_id = $business_id;
      $row->save();

			//START SITEBUSINESSMEMBER PLUGIN WORK
			$sitebusinessMemberEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember');
			
			if ($sitebusinessMemberEnabled) {
				$membersTable = Engine_Api::_()->getDbtable('membership', 'sitebusiness');
				$membersTableName = $membersTable->info('name');
				
				$select = $membersTable->select()
								->from($membersTableName)
								->where('user_id = ?', $selected_user_id)
								->where($membersTableName . '.resource_id = ?', $business_id);
				$select = $membersTable->fetchRow($select);
				
				if(empty($select)) {
					$row = $membersTable->createRow();
					$row->resource_id = $business_id;
					$row->business_id = $business_id;
					$row->user_id = $selected_user_id;
					$row->save();
				}
			}
			//END SITEBUSINESSMEMBER PLUGIN WORK

      $newManageAdmin = Engine_Api::_()->getItem('user', $selected_user_id);

      $sitebusiness_title = $sitebusiness->title;
      $business_title_with_link = '<a href = http://' . $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getRouter()->assemble(array('business_url' => Engine_Api::_()->sitebusiness()->getBusinessUrl($business_id)), 'sitebusiness_entry_view') . ">$sitebusiness_title</a>";

      $host = $_SERVER['HTTP_HOST'];
      $business_url = $host . Zend_Controller_Front::getInstance()->getRouter()->assemble(array('business_url' => Engine_Api::_()->sitebusiness()->getBusinessUrl($business_id)), 'sitebusiness_entry_view');

      Engine_Api::_()->getApi('mail', 'core')->sendSystem($newManageAdmin->email, 'SITEBUSINESS_MANAGEADMIN_EMAIL', array(
              'business_title_with_link' => $business_title_with_link,
              'sender' => $viewer->toString(),
              'business_url' => $business_url,
              'queue' => true
      ));

      $notifyApi = Engine_Api::_()->getDbtable('notifications', 'activity');
      $notifyApi->addNotification($newManageAdmin, $viewer, $sitebusiness, 'sitebusiness_manageadmin');

      //INCREMENT MESSAGE COUNTER.
      Engine_Api::_()->getDbtable('statistics', 'core')->increment('messages.creations');
    }
  }

	//ACTINO FOR USER AUTO-SUGGEST LIST
  public function manageAutoSuggestAction() {

    //USER VALIDATION
    if (!$this->_helper->requireUser()->isValid())
      return;

    //GETTING THE BUSINESS ID.
    $business_id = $this->_getParam('business_id', $this->_getParam('id', null));

		//FETCH DATA
		$user_idarray = Engine_Api::_()->getDbtable('manageadmins', 'sitebusiness')->linkedBusinesses($business_id);

    $user_id_array = '';
    if (!empty($user_idarray)) {
      foreach ($user_idarray as $key => $user_ids) {
        $user_id_array = $user_ids['user_id'] . ',' . $user_id_array;
      }
    }
    $user_id_array = $user_id_array . '0';
    $noncreate_owner_level = array();
    $permissionsTable = Engine_Api::_()->getDbtable('permissions', 'authorization');
    foreach (Engine_Api::_()->getDbtable('levels', 'authorization')->fetchAll() as $level) {
      $can_create = 0;
      if ($level->type != "public") {
        $can_create = Engine_Api::_()->authorization()->getPermission($level->level_id, 'sitebusiness_business', 'create');
        if (empty($can_create)) {
          $noncreate_owner_level[] = $level->level_id;
        }
      }
    }

    $usertable = Engine_Api::_()->getDbtable('users', 'user');
    $userTableName = $usertable->info('name');
    $select = $usertable->select()
            ->where('displayname  LIKE ? ', '%' . $this->_getParam('text') . '%')
            ->where($userTableName . '.user_id NOT IN (' . $user_id_array . ')')
            ->order('displayname ASC')
            ->limit($this->_getParam('limit', 40));

    if (!empty($noncreate_owner_level)) {
      $str = (string) ( is_array($noncreate_owner_level) ? "'" . join("', '", $noncreate_owner_level) . "'" : $noncreate_owner_level );
      $select->where($userTableName . '.level_id not in (?)', new Zend_Db_Expr($str));
    }

    //FETCH ALL RESULT.
    $userlists = $usertable->fetchAll($select);
    $data = array();

		foreach ($userlists as $userlist) {
			$content_photo = $this->view->itemPhoto($userlist, 'thumb.icon');
			$data[] = array(
							'id' => $userlist->user_id,
							'label' => $userlist->displayname,
							'photo' => $content_photo
						);
    }

    if ($this->_getParam('sendNow', true)) {

      //RETURN TO THE RETRIVE RESULT.
      return $this->_helper->json($data);
    } else {
      $this->_helper->viewRenderer->setNoRender(true);
      $data = Zend_Json::encode($data);
      $this->getResponse()->setBody($data);
    }
  }

  //THIS ACTION FOR DELETE MANAGE ADMIN AND CALLING FROM THE CORE.JS FILE.
  public function deleteAction() {

    $manageadmin_id = (int) $this->_getParam('managedelete_id');
    $owner_id = (int) $this->_getParam('owner_id');
    $business_id = (int) $this->_getParam('business_id');
    $manageAdmintable = Engine_Api::_()->getDbtable('manageadmins', 'sitebusiness');
    $manageAdmintable->delete(array('manageadmin_id = ?' => $manageadmin_id));

		//START SITEBUISNESSMEMBER PLUGIN WORK
		$sitebusinessMemberEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember');
		if ($sitebusinessMemberEnabled) {
 			$membersTable = Engine_Api::_()->getDbtable('membership', 'sitebusiness');
//       $membersTable->delete(array('resource_id = ?' => $page_id, 'user_id = ?' => $owner_id));
      //$manageAdmintable = Engine_Api::_()->getDbtable('manageadmins', 'sitebusiness');
      $membersTable->delete(array('business_id = ?' => $business_id, 'user_id = ?' => $owner_id));
		}
		//END SITEBUISNESSMEMBER PLUGIN WORK

    //STAR WORK SITEBUSINESS INTREGRATION.
		$sitebusinessintegrationEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessintegration');
    if(!empty($sitebusinessintegrationEnabled)) {
			$contentsTable = Engine_Api::_()->getDbtable('contents', 'sitebusinessintegration');
			$contentsTable->delete(array('resource_owner_id = ?' => $owner_id, 'business_id = ?' => $business_id ));
    }
    //END WORK OF SITEBUSINESS INTREGRATION.
  }

	//ACTION FOR FEATURED ADMIN
  public function listAction() {

		//SET LAYOUT
    $this->_helper->layout->setLayout('default-simple');

    //GET BUSINESS ID AND BUSINESS OBJECT
    $business_id = $this->_getParam('business_id', null);
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);

    //EDIT PRIVACY
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($isManageAdmin)) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }

    $manageTable = Engine_Api::_()->getDbtable('manageadmins', 'sitebusiness');

		//FETCH DATA
    $this->view->owners = $manageTable->getManageAdmin($business_id);

    //CHECK POST
    if ($this->getRequest()->isPost()) {

      //GET VALUES FROM FORM
      $values = $this->getRequest()->getPost();
      $db = Engine_Db_Table::getDefaultAdapter();
      $db->beginTransaction();
      try {
        $manageTable->update(array('featured' => 0), array('business_id = ?' => $business_id));

        foreach ($values as $key => $value) {
          $manageTable->update(array('featured' => 1), array('user_id = ?' => $key, 'business_id = ?' => $business_id));
        }
        $db->commit();
        $this->_forwardCustom('success', 'utility', 'core', array(
                'smoothboxClose' => 500,
                'parentRedirect' => $this->_helper->url->url(array('action' => 'featured-owners', 'business_id' => $business_id), 'sitebusiness_dashboard'),
                'parentRedirectTime' => '1',
                'messages' => array(Zend_Registry::get('Zend_Translate')->_('Featured admins of your business have been updated successfully.'))
        ));
      } catch (Exception $e) {
        $db->rollBack();
        throw $e;
      }
    }
  }
}
?>