<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: manifest.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$routeStartP = "businessitems";
$routeStartS = "businessitem";
$module=null;$controller=null;$action=null;$getURL = null;
$request = Zend_Controller_Front::getInstance()->getRequest();
if (!empty($request)) {
  $module = $request->getModuleName(); // Return the current module name.
  $action = $request->getActionName();
  $controller = $request->getControllerName();
  $getURL = $request->getRequestUri();
}
if (empty($request) || !($module == "default" && ( strpos( $getURL, '/install') !== false))) {
  $routeStartP = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.manifestUrlP', "businessitems");
  $routeStartS = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.manifestUrlS', "businessitem");
}
return array(
    'package' =>
    array(
        'type' => 'module',
        'name' => 'sitebusiness',
        'version' => '5.6.1',
        'path' => 'application/modules/Sitebusiness',
        'title' => 'Directory / Businesses',
        'description' => 'Directory / Businesses',
      'author' => '<a href="http://www.socialapps.tech" style="text-decoration:underline;" target="_blank">SocialApps.tech</a>',
        'date' => 'Thursday, 05 May 2011 18:33:08 +0000',
        'copyright' => 'Copyright 2010-2011 BigStep Technologies Pvt. Ltd.',
        'actions' => array(
            'install',
            'upgrade',
            'refresh',
            'enable',
            'disable',
        ),
        'callback' => array(
            'path' => 'application/modules/Sitebusiness/settings/install.php',
            'class' => 'Sitebusiness_Installer',
        ),
        'directories' => array(
            'application/modules/Sitebusiness',
        ),
        'files' => array(
            'application/languages/en/sitebusiness.csv',
        ),
    ),
    'sitemobile_compatible' => true,
// Hooks ---------------------------------------------------------------------
    'hooks' => array(
        array(
            // 'event' => 'addActivity',
            'event' => 'onRenderLayoutDefault',
            'resource' => 'Sitebusiness_Plugin_Core'
        ),
        array(
            'event' => 'onStatistics',
            'resource' => 'Sitebusiness_Plugin_Core'
        ),
        array(
            'event' => 'onUserDeleteBefore',
            'resource' => 'Sitebusiness_Plugin_Core',
        ),
        array(
            'event' => 'getActivity',
            'resource' => 'Sitebusiness_Plugin_Core',
        ),
        array(
            'event' => 'addActivity',
            'resource' => 'Sitebusiness_Plugin_Core',
        ),
        array(
					'event' => 'onActivityActionCreateAfter',
					'resource' => 'Sitebusiness_Plugin_Core',
			  ),
// 			  array(
// 					'event' => 'onActivityCommentCreateAfter',
// 					'resource' => 'Sitebusiness_Plugin_Core',
// 			  ),
    ),
// Items ---------------------------------------------------------------------
    'items' => array(
        'sitebusiness_business',
        'sitebusiness_album',
        'sitebusiness_photo','sitebusiness_category',
        'sitebusiness_topic',
        'sitebusiness_post',
        'sitebusiness_profilemap',
        'sitebusiness_claim',
        'sitebusiness_package',
        'sitebusiness_gateway', 
        'sitebusiness_location',
        'sitebusiness_listmemberclaims',
        'sitebusiness_gateway',
        'sitebusiness_itemofthedays',
        'sitebusiness_transaction',
				'sitebusiness_import',
				'sitebusiness_membership',
				'sitebusiness_announcements','sitebusiness_announcements','sitebusiness_list',
			  'sitebusiness_membership',
				'sitebusiness_importfile'
    ),
// Route--------------------------------------------------------------------
    'routes' => array(
        'sitebusiness_extended' => array(
            'route' => $routeStartP.'/:controller/:action/*',
            'defaults' => array(
                'module' => 'sitebusiness',
                'controller' => 'index',
                'action' => 'home',
            ),
            'reqs' => array(
                'controller' => '\D+',
                'action' => '\D+',
            )
        ),
        'sitebusiness_general' => array(
            'route' => $routeStartP.'/:action/*',
            'defaults' => array(
                'module' => 'sitebusiness',
                'controller' => 'index',
                'action' => 'home',
            ),
            'reqs' => array(
                'action' => '(home|index|manage|create|subcategory|businessurlvalidation|get-search-businesses|subsubcategory|map|pinboard-browse)',
            ),
        ),

				'sitebusiness_claimbusinesses' => array(
				            'route' => $routeStartP.'/claim/:action/*',
				            'defaults' => array(
				                'module' => 'sitebusiness',
				                'controller' => 'claim',
				                'action' => 'index',
				            ),
				            'reqs' => array(
				                'action' => '(claim-business|get-businesses|terms|my-businesses|delete)',

				            ),
				        ),

			'sitebusiness_dashboard' => array(
			            'route' => $routeStartP.'/dashboard/:action/*',
			            'defaults' => array(
			                'module' => 'sitebusiness',
			                'controller' => 'dashboard',
			                //'action' => 'index',
			            ),
			            'reqs' => array(
			                'action' => '(get-started|edit-style|edit-location|overview|edit-address|profile-type|marketing|foursquare-help|contact|featured-owners|profile-picture|remove-photo|unhide-photo|app|foursquare|favourite|favourite-delete|upload-photo|wishlist|twitter|announcements|notification-settings|add-location|delete-location|all-location|manage-member-category|delete-member-category|reset-position-cover-photo|upload-cover-photo|get-albums-photos|remove-cover-photo|choose-project)',
			            ),
			        ),
			'sitebusiness_profilebusiness' => array(
			            'route' => $routeStartP.'/profilebusiness/:action/*',
			            'defaults' => array(
			                'module' => 'sitebusiness',
			                'controller' => 'profile',
			                //'action' => 'index',
			            ),
			            'reqs' => array(
			                'action' => '(message-owner|tell-a-friend|print|contact-detail|get-cover-photo|email-me)',	
			            ),
			        ),
			'sitebusiness_like' => array(
          'route' => $routeStartP.'/like/:action/*',
          'defaults' => array(
              'module' => 'sitebusiness',
              'controller' => 'like',
              //'action' => 'index',
          ),
          'reqs' => array(
              'action' => '(global-likes|like-businesses|send-update|mylikes|my-joined)',
          ),
      ),

			'sitebusiness_packages' => array(
          'route' => $routeStartP.'/package/:action/*',
          'defaults' => array(
              'module' => 'sitebusiness',
              'controller' => 'package',
              'action' => 'index',
          ),
          'reqs' => array(
              'action' => '(detail|update-package|update-confirmation|cancel)',
          ),
      ),

			'sitebusiness_manageadmins' => array(
          'route' => $routeStartP.'/manageadmin/:action/*',
          'defaults' => array(
              'module' => 'sitebusiness',
              'controller' => 'manageadmin',
              'action' => 'index',
          ),
          'reqs' => array(
              'action' => '(my-businesses|manage-auto-suggest|list|delete)',
          ),
      ),


        // Public
        'sitebusiness_entry_view' => array(
            'route' => $routeStartS.'/:business_url/*',
            'defaults' => array(
                'module' => 'sitebusiness',
                'controller' => 'index',
                'action' => 'view',
            ),
        ),
        // User

        'sitebusiness_delete' => array(
            'route' => $routeStartP.'/delete/:business_id/*',
            'defaults' => array(
                'module' => 'sitebusiness',
                'controller' => 'index',
                'action' => 'delete'
            ),
            'reqs' => array(
                'business_id' => '\d+',
            )
        ),
        'sitebusiness_publish' => array(
            'route' => $routeStartP.'/publish/:business_id/*',
            'defaults' => array(
                'module' => 'sitebusiness',
                'controller' => 'index',
                'action' => 'publish'
            ),
            'reqs' => array(
                'business_id' => '\d+'
            )
        ),
        'sitebusiness_close' => array(
            'route' => $routeStartP.'/close/:business_id/:closed/*',
            'defaults' => array(
                'module' => 'sitebusiness',
                'controller' => 'index',
                'action' => 'close'
            )
        ),
        'sitebusiness_edit' => array(
            'route' => $routeStartP.'/edit/:business_id/*',
            'defaults' => array(
                'module' => 'sitebusiness',
                'controller' => 'index',
                'action' => 'edit',
                'business_id' => '0',
            )
        ),
        'sitebusiness_session_payment' => array(
            'route' => $routeStartP.'/payment/sessionpayment/',
            'defaults' => array(
                'module' => 'sitebusiness',
                'controller' => 'package',
                'action' => 'payment',
            ),
        ),
        'sitebusiness_payment' => array(
            'route' => $routeStartP.'/payment/',
            'defaults' => array(
                'module' => 'sitebusiness',
                'controller' => 'payment',
                'action' => 'index',
            ),
        ),
        'sitebusiness_process_payment' => array(
            'route' => $routeStartP.'/payment/process',
            'defaults' => array(
                'module' => 'sitebusiness',
                'controller' => 'payment',
                'action' => 'process',
            ),
        ),
        'sitebusiness_insights' => array(
            'route' => $routeStartP.'/insights/:action/:business_id/*',
            'defaults' => array(
                'module' => 'sitebusiness',
                'controller' => 'insights',
                'action' => 'index',
                'business_id' => '0',
            )
        ),
        'sitebusiness_tags' => array(
            'route' => $routeStartP.'/tagscloud/:business/*',
            'defaults' => array(
                'module' => 'sitebusiness',
                'controller' => 'index',
                'action' => 'tags-cloud',
                'business' => 1
            )
        ),
        'sitebusiness_photoalbumupload' => array(
            'route' => $routeStartP.'/photo/:business_id/*',
            'defaults' => array(
                'module' => 'sitebusiness',
                'controller' => 'photo',
                'action' => 'upload-album',
                'business_id' => '1'
            )
        ),
        'sitebusiness_imagephoto_specific' => array(
            'route' => $routeStartP.'/photo/:action/*',
            'defaults' => array(
                'module' => 'sitebusiness',
                'controller' => 'photo',
                'action' => 'view'
            ),
            'reqs' => array(
                'action' => '(view|photo-edit|remove|make-business-profile-photo)',
            ),
        ),
        'sitebusiness_albumphoto_general' => array(
            'route' => $routeStartP.'/album/:action/*',
            'defaults' => array(
                'module' => 'sitebusiness',
                'controller' => 'album',
                'action' => 'view'
            ),
            'reqs' => array(
                'action' => '(edit|delete|edit-photos|view-album|view|album-order)',
            ),
        ),
        'sitebusiness_general_category' => array(
            'route' => $routeStartP.'/:category_id/:categoryname/*',
            'defaults' => array(
                'module' => 'sitebusiness',
                'controller' => 'index',
                'action' => 'index',
            ),
            'reqs' => array(
                'category_id' => '\d+'
            ),
        ),
        'sitebusiness_general_subcategory' => array(
            'route' => $routeStartP.'/:category_id/:categoryname/:subcategory_id/:subcategoryname/*',
            'defaults' => array(
                'module' => 'sitebusiness',
                'controller' => 'index',
                'action' => 'index',
            ),
            'reqs' => array(
                'category_id' => '\d+',
                'subcategory_id' => '\d+'

            ),
        ),

        'sitebusiness_general_subsubcategory' => array(
            'route' => $routeStartP.'/:category_id/:categoryname/:subcategory_id/:subcategoryname/:subsubcategory_id/:subsubcategoryname/*',
            'defaults' => array(
                'module' => 'sitebusiness',
                'controller' => 'index',
                'action' => 'index',
            ),
            'reqs' => array(
                'category_id' => '\d+',
                'subcategory_id' => '\d+'

            ),
         ),

        'sitebusiness_layout' => array(
            'route' => $routeStartP.'/layout/:business_id/',
            'defaults' => array(
                'module' => 'sitebusiness',
                'controller' => 'layout',
                'action' => 'layout',
            ),
            'reqs' => array(
                'business_id' => '\d+',
            )
        ),
        'sitebusiness_ajaxhomelist' => array(
            'route' => $routeStartP.'/ajaxhomelist/',
            'defaults' => array(
                'module' => 'sitebusiness',
                'controller' => 'index',
                'action' => 'ajax-home-list'
            )
        ),
        'sitebusiness_reports' => array(
            'route' => $routeStartP.'/insights/:action/:business_id/*',
            'defaults' => array(
                'module' => 'sitebusiness',
                'controller' => 'insights',
                'action' => 'export-report',
                'business_id' => '0',
            )
        ),
        'sitebusiness_webbusinessreport' => array(
            'route' => $routeStartP.'/insights/:action/:business_id/*',
            'defaults' => array(
                'module' => 'sitebusiness',
                'controller' => 'insights',
                'action' => 'export-webbusiness',
                'business_id' => '0',
            )
        ),
        'sitebusiness_homesponsored' => array(
            'route' => $routeStartP.'/homesponsored',
            'defaults' => array(
                'module' => 'sitebusiness',
                'controller' => 'index',
                'action' => 'home-sponsored'
            )
        ),
        // User
        'sitebusiness_widget' => array(
            'route' => 'admin/businessitem/widgets/*',
            'defaults' => array(
                'module' => 'sitebusiness',
                'controller' => 'admin-widgets',
                'action' => 'index',
            )
        ),
        // User
        'sitebusiness_itemofday' => array(
            'route' => 'admin/businessitem/items/day/:business/*',
            'defaults' => array(
                'module' => 'sitebusiness',
                'controller' => 'admin-items',
                'action' => 'day',
                'business' => 1
            )
        ),
				'sitebusiness_profilebusinessmobile' => array(
            'route' => $routeStartS . '/profile/:action/*',
            'defaults' => array(
                'module' => 'sitebusiness',
                'controller' => 'profile',
            ),
            'reqs' => array(
                'action' => '(upload-cover-photo|get-albums-photos|remove-cover-photo)'
            ),
        ),
        'sitebusiness_viewmap' => array(
            'route' => $routeStartS.'/index/view-map/:id',
            'defaults' => array(
                'module' => 'sitebusiness',
                'controller' => 'index',
                'action' => 'view-map'
            )
        ),
    ),
);
?>
