<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusiness_Widget_AlbumsSitebusinessController extends Engine_Content_Widget_Abstract {

  protected $_childCount;
  
  //ACTION FOR SHOWING THE RANDOM ALBUMS AND PHOTOS BY OTHERS 
  public function indexAction() {
  	
  	//HERE WE CHECKING THE SITEBUSINESS ALBUM IS ENABLED OR NOT
		$sitebusinessalbumEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessalbum');
		if (!$sitebusinessalbumEnabled) {
			return $this->setNoRender();
		}
		  	
    //DON'T RENDER IF SUNJECT IS NOT THERE
    if (!Engine_Api::_()->core()->hasSubject()) {
      return $this->setNoRender();
    }

    //GET SITEBUSINESS SUBJECT
    $this->view->sitebusiness = $sitebusiness = Engine_Api::_()->core()->getSubject('sitebusiness_business');

    //START PACKAGE WORK
    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessalbum")) {
        return $this->setNoRender();
      }
    } else {
      $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'spcreate');
      if (empty($isBusinessOwnerAllow)) {
        return $this->setNoRender();
      }
    }
    //END PACKAGE WORK

//    //START MANAGE-ADMIN CHECK
//    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'view');
//    if (empty($isManageAdmin)) {
//      return $this->setNoRender();
//    }
//    //END MANAGE-ADMIN CHECK  
    
    //SET ALBUMS PARAMS
    $paramsAlbum = array();
    $paramsAlbum['business_id'] = $sitebusiness->business_id;  

    //GET ALBUMS COUNT
    $this->view->albumcount = Engine_Api::_()->getDbtable('albums', 'sitebusiness')->getAlbumsCount($paramsAlbum);

    //GET VIEWER ID
    $this->view->viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity(); 
    
    //SET ALBUMS PARAMS
    $paramsAlbum['orderby'] = ' RAND()'; 
    $paramsAlbum['start'] = 2; 
    $paramsAlbum['getSpecialField'] = 0;
    
    //FETCH ALBUMS
		$this->view->paginator = $fecthAlbums = Engine_Api::_()->getDbtable('albums', 'sitebusiness')->getAlbums($paramsAlbum, null, array('album_id', 'photo_id', 'title', 'creation_date'));           
    
    //IF COUNT IS ZERO THEN NO RENDER
    if ($this->view->albumcount <= 0) {
      return $this->setNoRender();
    }

    //SET PHOTO PARAMS
    $paramsPhoto = array();
    $paramsPhoto['business_id'] = $sitebusiness->business_id;
    $paramsPhoto['user_id'] = $sitebusiness->owner_id;
    $paramsPhoto['album_id'] = Engine_Api::_()->getItemTable('sitebusiness_album')->getDefaultAlbum($sitebusiness->business_id)->album_id;;

    //GET TOTAL PHOTOS BY OTHERS
    $this->view->totalphotosothers = Engine_Api::_()->getDbtable('photos', 'sitebusiness')->getPhotosCount($paramsPhoto);
    
    //SET PHOTO PARAMS
    $paramsPhoto['orderby'] = 'RAND()'; 
    $paramsPhoto['start'] = 4;  
       
    //GET ALL PHOTOS
    $this->view->paginators = Engine_Api::_()->getDbtable('photos', 'sitebusiness')->getPhotos($paramsPhoto);
    
    //SEND CURRENT TAB ID TO THE TPL
    $this->view->tab_id = Engine_Api::_()->sitebusiness()->GetTabIdinfo('sitebusiness.photos-sitebusiness', $sitebusiness->business_id, Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.layoutcreate', 0));
  }

}

?>