<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusiness_Widget_ArchivesSitebusinessController extends Engine_Content_Widget_Abstract {

  public function indexAction() {

		//GET ARCHIVE SITEBUSINESS OF SITEBUSINESS USER
    $archiveSitebusiness =  Engine_Api::_()->getDbTable('business', 'sitebusiness')->getArchiveSitebusiness(null);

		//CALL TO handleArchiveSitebusiness ACTION OF SAME CONTROLLER
    $this->view->archive_sitebusiness = $this->_handleArchiveSitebusiness($archiveSitebusiness);

    if (!(count($this->view->archive_sitebusiness) > 0)) {
      return $this->setNoRender();
    }

    if (isset($_GET['start_date'])) {
      $this->view->start_date = $_GET['start_date'];
		}
  }

  //ACTION FOR handleArchiveSitebusiness
  protected function _handleArchiveSitebusiness($results) {

    $localeObject = Zend_Registry::get('Locale');
    $sitebusiness_dates = array();
    foreach ($results as $result)
      $sitebusiness_dates[] = strtotime($result->creation_date);

    //GET ARCHIVE SITEBUSINESS
    $time = time();
    $archive_sitebusiness = array();

    foreach ($sitebusiness_dates as $sitebusiness_date) {
      $ltime = localtime($sitebusiness_date, TRUE);
      $ltime["tm_mon"] = $ltime["tm_mon"] + 1;
      $ltime["tm_year"] = $ltime["tm_year"] + 1900;

      //LESS THAN A YEAR AGO - MONTHS
      if ($sitebusiness_date + 31536000 > $time) {
        $date_start = mktime(0, 0, 0, $ltime["tm_mon"], 1, $ltime["tm_year"]);
        $date_end = mktime(0, 0, 0, $ltime["tm_mon"] + 1, 1, $ltime["tm_year"]);
        $label = date('F Y', $sitebusiness_date);
        $type = 'month';
      }

      //MORE THAN A YEAR AGO - YEARS
      else {
        $date_start = mktime(0, 0, 0, 1, 1, $ltime["tm_year"]);
        $date_end = mktime(0, 0, 0, 1, 1, $ltime["tm_year"] + 1);
        $type = 'year';

        $dateObject = new Zend_Date($sitebusiness_date);
        $format = $localeObject->getTranslation('yyyy', 'dateitem', $localeObject);
        if (!$format) {
          $format = $localeObject->getTranslation('y', 'dateitem', $localeObject);
        }
        $label = $dateObject->toString($format, $localeObject);
      }

      if (!isset($archive_sitebusiness[$date_start])) {
        $archive_sitebusiness[$date_start] = array(
            'type' => $type,
            'label' => $label,
            'date_start' => $date_start,
            'date_end' => $date_end,
            'count' => 1
        );
      } else {
        $archive_sitebusiness[$date_start]['count']++;
      }
    }
    return $archive_sitebusiness;
  }
}

?>