<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:20:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusiness_Widget_BrowselocationSitebusinessController extends Engine_Content_Widget_Abstract {

  public function indexAction() {

    // Make form
    $this->view->form = $form = new Sitebusiness_Form_Locationsearch(array('type' => 'sitebusiness_business'));
    
		if(!empty($_POST)) {
			$this->view->is_ajax = $_POST['is_ajax'];
		}
		
	  if(empty($_POST['sitebusiness_location'])) {
			$this->view->locationVariable = '1';
		}
		
    if (empty($_POST['is_ajax'])) {
			$p = Zend_Controller_Front::getInstance()->getRequest()->getParams();
			$form->isValid($p);
			$values = $form->getValues();
			$customFieldValues = array_intersect_key($values, $form->getFieldElements());
			$this->view->is_ajax = $this->_getParam( 'is_ajax', 0 );
    } else {
			$values = $_POST;
			$customFieldValues = array_intersect_key($values, $form->getFieldElements());
    }

    unset($values['or']);
    $this->view->assign($values);
    $viewer = Engine_Api::_()->user()->getViewer();
    if (@$values['show'] == 2) {

      //GET AN ARRAY OF FRIEND IDS
      $friends = $viewer->membership()->getMembers();

      $ids = array();
      foreach ($friends as $friend) {
        $ids[] = $friend->user_id;
      }

      $values['users'] = $ids;
    }
    $values['type'] = 'browse';
    $values['type_location'] = 'browseLocation';
    if (isset($values['show'])) {
			if ($form->show->getValue() == 3) {
				@$values['show'] = 3;
			}
    }
    
    //$viewerId = Engine_Api::_()->user()->getViewer()->getIdentity();
    $this->view->current_business = $business = $this->_getParam( 'business' , 1 ) ;
    $this->view->current_totalbusinesses = $business * 15 ;
    $this->view->enableLocation = $checkLocation = Engine_Api::_()->sitebusiness()->enableLocation();
    $this->view->enablePrice = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.price.field', 1);

    //check for miles or street.
		if (isset($values['locationmiles']) && !empty($values['locationmiles'])) {
			if (isset($values['sitebusiness_street']) && !empty($values['sitebusiness_street'])) {
				$values['sitebusiness_location'] = $values['sitebusiness_street'] . ',';
				unset($values['sitebusiness_street']);
			}
			
			if (isset($values['sitebusiness_city']) && !empty($values['sitebusiness_city'])) {
				$values['sitebusiness_location'].= $values['sitebusiness_city'] . ',';
				unset($values['sitebusiness_city']);
			}	
			
			if (isset($values['sitebusiness_state']) && !empty($values['sitebusiness_state'])) {
				$values['sitebusiness_location'].= $values['sitebusiness_state'] . ',';
				unset($values['sitebusiness_state']);
			} 
			
			if (isset($values['sitebusiness_country']) && !empty($values['sitebusiness_country'])) {
				$values['sitebusiness_location'].= $values['sitebusiness_country'];
				unset($values['sitebusiness_country']);
			}
		}

    $result = Engine_Api::_()->sitebusiness()->getSitebusinessesSelect($values, $customFieldValues);
   	$this->view->paginator = $paginator = Zend_Paginator::factory($result); 
    $paginator->setItemCountPerPage(15);
    $this->view->paginator = $paginator->setCurrentPageNumber($business);
    $this->view->mobile = Engine_Api::_()->seaocore()->isMobile();
		if(!empty($_POST['is_ajax'])) {
			//For show location marker.
			if (!empty($checkLocation) && $paginator->getTotalItemCount() > 0) {
				$ids = array();
				$sponsored = array();
				foreach ($paginator as $sitebusiness) {
					$id = $sitebusiness->getIdentity();
					$ids[] = $id;
					$sitebusiness_temp[$id] = $sitebusiness;
				}
				$values['business_ids'] = $ids;
				$this->view->locations = $locations = Engine_Api::_()->getDbtable('locations', 'sitebusiness')->getLocation($values);
				$sitebusiness_lat = array();
				$sitebusiness_long = array();
				foreach ($locations as $location) {
					$sitebusiness_lat[] = $location->latitude;
					$sitebusiness_long[] = $location->longitude;
				}

				foreach ($locations as $location) {
					if ($sitebusiness_temp[$location->business_id]->sponsored) {
						break;
					}
				}
				$this->view->sitebusiness = $sitebusiness_temp;
			}
    }
  }
}