<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusiness_Widget_LinksSitebusinessController extends Engine_Content_Widget_Abstract {

    public function indexAction() {

        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();

        //GET VIEWER CLAIMS
        $claim_id = Engine_Api::_()->getDbtable('claims', 'sitebusiness')->getViewerClaims($viewer_id);

        //CLAIM IS ENABLED OR NOT
        $canClaim = Engine_Api::_()->authorization()->getPermission($viewer->level_id, 'sitebusiness_business', 'claim');

        $this->view->showClaimLink = 0;
        if (!empty($claim_id) && !empty($canClaim)) {
            $this->view->showClaimLink = 1;
        }

        //CHECK THAT WE HAVE TO SHOW MANAGE ADMIN LINK OR NOTE
        $adminbusinesses = Engine_Api::_()->getDbtable('manageadmins', 'sitebusiness')->getManageAdminBusinesses($viewer_id);

        //GET STUFF
        $manageadmin_ids = array();
        foreach ($adminbusinesses as $adminbusiness) {
            $manageadmin_ids[] = $adminbusiness->business_id;
        }
        $manageadmin_values = array();
        $manageadmin_values['adminbusinesses'] = $manageadmin_ids;
        $manageadmin_values['orderby'] = 'creation_date';
        $manageadmin_data = Engine_Api::_()->sitebusiness()->getSitebusinessesPaginator($manageadmin_values, null);
        $this->view->manageadmin_count = $manageadmin_data->getTotalItemCount();

        $linksValues = array("businessAdmin", "businessClaimed", "businessLiked");
        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember')) {
            $linksValues[] = "businessesJoined";
        }
        $this->view->showLinks = $this->_getParam('showLinks', array($linksValues));

        if (empty($this->view->showLinks))
            return $this->setNoRender();

        if (in_array("businessAdmin", $this->view->showLinks)) {
            $this->view->showBusinessAdmin = true;
        }

        if (in_array("businessClaimed", $this->view->showLinks)) {
            $this->view->showBusinessClaimed = true;
        }

        if (in_array("businessLiked", $this->view->showLinks)) {
            $this->view->showBusinessLiked = true;
        }

        if (in_array("businessesJoined", $this->view->showLinks)) {
            $this->view->showBusinessJoined = true;
        }
    }

}

?>