<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusiness_Widget_MostcommentedSitebusinessController extends Engine_Content_Widget_Abstract {

  public function indexAction() {

    //DONT RENDER IF DISABLE COMMENT
    if (!Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.checkcomment.widgets', 1)) {
      return $this->setNoRender();
    }

    $params =array();
    $current_time = date("Y-m-d H:i:s");
    $params['totalbusinesses'] = $this->_getParam('itemCount', 3);
    $params['category_id'] = $this->_getParam('category_id',0);
    $params['featured'] = $this->_getParam('featured',0);
    $params['sponsored'] = $this->_getParam('sponsored',0);
    $interval = $this->_getParam('interval', 'overall');

		//MAKE TIMING STRING
		if($interval == 'week') {
			$time_duration = date('Y-m-d H:i:s', strtotime('-7 days'));
			$sqlTimeStr = ".creation_date BETWEEN " . "'" . $time_duration . "'" . " AND " . "'" . $current_time . "'" ;
		}
		elseif($interval == 'month') {
			$time_duration = date('Y-m-d H:i:s', strtotime('-1 months'));
			$sqlTimeStr = ".creation_date BETWEEN " . "'" . $time_duration . "'" . " AND " . "'" . $current_time . "'" . "";
		}
		else {
			$sqlTimeStr = '';
		}
    $params['sqlTimeStr'] = $sqlTimeStr;

    //GET SITEBUSINESS SITEBUSINESS FOR MOST COMMENTED
    $this->view->sitebusinesses = Engine_Api::_()->getDbTable('business', 'sitebusiness')->getListings('Most Commented',$params,$interval, $sqlTimeStr, array('business_id', 'photo_id', 'business_url', 'title', 'owner_id', 'comment_count'));

    //DONT RENDER IF SITEBUSINESS COUNT ZERO
    if (!(count($this->view->sitebusinesses) > 0)) {
      return $this->setNoRender();
    }
  }
}

?>