<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusiness_Widget_OverviewSitebusinessController extends Engine_Content_Widget_Abstract {

  public function indexAction() {

    //DONT RENDER IF SUBJECT IS NOT SET
    if (!Engine_Api::_()->core()->hasSubject()) {
      return $this->setNoRender();
    }

    if(Engine_Api::_()->core()->getSubject()->getType() == 'sitebusiness_business') {
    	$this->view->sitebusiness = $sitebusiness = Engine_Api::_()->core()->getSubject('sitebusiness_business');
    }
    else {
      $this->view->sitebusiness = $sitebusiness = Engine_Api::_()->core()->getSubject()->getParent();
    }

    //START MANAGE-ADMIN CHECK   
    $this->view->can_edit_overview = $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'overview');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }

    $this->view->can_edit = $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');

    if (empty($this->view->can_edit) && empty($sitebusiness->overview)) {
      return $this->setNoRender();
    }
    //END MANAGE-ADMIN CHECK

		//SEND OTHER DETAIL TO TPL
    $layout = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.layoutcreate', 0);
    $this->view->widgets = Engine_Api::_()->sitebusiness()->getwidget($layout, $sitebusiness->business_id);
    $this->view->content_id = Engine_Api::_()->sitebusiness()->GetTabIdinfo('sitebusiness.overview-sitebusiness', $sitebusiness->business_id, $layout);
    $this->view->module_tabid = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab', null);
    $this->view->identity_temp = $this->view->identity;
    $this->view->showtoptitle = Engine_Api::_()->sitebusiness()->showtoptitle($layout, $sitebusiness->business_id);
  }
}

?>