<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusiness_Widget_PhotolikeSitebusinessController extends Engine_Content_Widget_Abstract {

	//ACTION FOR MOST LIKED PHOTOS ON BUSINESS PROFILE BUSINESS
  public function indexAction() {

  	//HERE WE CHECKING THE SITEBUSINESS ALBUM IS ENABLED OR NOT
		$sitebusinessalbumEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessalbum');
		if (!$sitebusinessalbumEnabled) {
			return $this->setNoRender();
		}

    //GET SITEBUSINESS SUBJECT
    $subject = Engine_Api::_()->core()->getSubject('sitebusiness_business');
    
    //GET BUSINESS ID
    $business_id = $subject->business_id;

    //PACKAGE WORK START
    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitebusiness()->allowPackageContent($subject->package_id, "modules", "sitebusinessalbum")) {
        return $this->setNoRender();
      }
    } else {
      $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($subject, 'spcreate');
      if (empty($isBusinessOwnerAllow)) {
        return $this->setNoRender();
      }
    }
    //PACKAGE WORK END    
    
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($subject, 'view');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }
    
    $this->view->is_ShowLightBox = $sitebusinessalbum_isShowLightBox = Zend_Registry::isRegistered('sitebusinessalbum_isShowLightBox') ? Zend_Registry::get('sitebusinessalbum_isShowLightBox') : null;

    if (empty($sitebusinessalbum_isShowLightBox)) {
      return $this->setNoRender();
    }   
    
    //SEARCH PARAMETER
    $params = array();
		$params['business_id'] = $business_id;
		$params['orderby'] = 'like_count DESC';
		$params['zero_count'] = 'like_count';
		$params['limit'] = $this->_getParam('itemCount', 4);
    
    $photoTable = Engine_Api::_()->getDbtable('photos', 'sitebusiness');
		$this->view->paginator = $paginator = $photoTable->widgetPhotos($params);   
    
    $this->view->count =  $photoTable->countTotalPhotos($params);
    
    if (Count($paginator) <= 0) {
      return $this->setNoRender();
    }
    
    //SHOWS PHOTOS IN THE LIGHTBOX
    //$this->view->showLightBox = Engine_Api::_()->sitebusiness()->canShowPhotoLightBox();
  }

}

?>