<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusiness_Widget_PhotosSitebusinessController extends Engine_Content_Widget_Abstract {

  protected $_childCount;

  //ACTION FOR GETTING THE ALBUMS AND PHOTOS
  public function indexAction() {

    //HERE WE CHECKING THE SITEBUSINESS ALBUM IS ENABLED OR NOT
    $sitebusinessalbumEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessalbum');
    if (!$sitebusinessalbumEnabled) {
      return $this->setNoRender();
    }
    
    //DON'T RENDER IF SUNJECT IS NOT THERE
    if (!Engine_Api::_()->core()->hasSubject()) {
      return $this->setNoRender();
    }    

    //GET HOW MANY ALBUMS DO YOU WANT SHOW ON PER BUSINESS
    $this->view->itemCount = $albums_per_business = $this->_getParam('itemCount', 10);

    //GET HOW MANY PHOTOS DO YOU WANT SHOW ON PER BUSINESS
    $this->view->itemCount_photo = $this->_getParam('itemCount_photo', 100);

    //ALBUMS ORDER
    $this->view->albums_order = $this->_getParam('albumsorder', 1);

    //GET VIEWER ID
    $this->view->viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();

    $sitebusinessalbum_hasPackageEnable = Zend_Registry::isRegistered('sitebusinessalbum_hasPackageEnable') ? Zend_Registry::get('sitebusinessalbum_hasPackageEnable') : null;

    //GET SITEBUSINESS SUBJECT
    if(Engine_Api::_()->core()->getSubject()->getType() == 'sitebusiness_business') {
    	$this->view->sitebusiness = $sitebusiness = Engine_Api::_()->core()->getSubject('sitebusiness_business');
    }
    else {
      $this->view->sitebusiness = $sitebusiness = Engine_Api::_()->core()->getSubject()->getParent();
    }
 
    //START PACKAGE WORK
    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessalbum")) {
        return $this->setNoRender();
      }
    } else {
      $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'spcreate');
      if (empty($isBusinessOwnerAllow)) {
        //return $this->setNoRender();
      }
    }
    //END PACKAGE WORK
  
    //TOTAL ALBUMS
    $albumCount = Engine_Api::_()->sitebusiness()->getTotalCount($sitebusiness->business_id, 'sitebusiness', 'albums');     
    $photoCreate = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'spcreate');
    
//    //START MANAGE-ADMIN CHECK
//    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'view');
//    if (empty($isManageAdmin)) {
//      return $this->setNoRender();
//    }

    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($isManageAdmin)) {
      $this->view->can_edit = $canEdit = 0;
    } else {
      $this->view->can_edit = $canEdit = 1;
    }

    if (empty($photoCreate) && empty($albumCount) && empty($canEdit) && !(Engine_Api::_()->sitebusiness()->showTabsWithoutContent())) {
      return $this->setNoRender();
    }

    if (empty($sitebusinessalbum_hasPackageEnable)) {
      return $this->setNoRender();
    }
    //END MANAGE-ADMIN CHECK    
    
    //GET WHICH LAYOUT IS SET BY THE ADMIN
    $layout = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.layoutcreate', 0);

    //GET THIRD TYPE LAYOUT IS SET OR NOT
    $this->view->widgets = $widgets = Engine_Api::_()->sitebusiness()->getwidget($layout, $sitebusiness->business_id);

    //GET REQUEST
    $zendRequest = Zend_Controller_Front::getInstance()->getRequest();

    //GET TAB ID
    $this->view->content_id = Engine_Api::_()->sitebusiness()->GetTabIdinfo('sitebusiness.photos-sitebusiness', $sitebusiness->business_id, $layout);

    //GET CURRENT TAB ID
    $this->view->module_tabid = $currenttabid = $zendRequest->getParam('tab', null);

    //CHECK REQUEST IS ISAJAX OR NOT
    $this->view->isajax = $isajax = $this->_getParam('isajax', null);

    //SHOW TOP TITLE
    $this->view->showtoptitle = Engine_Api::_()->sitebusiness()->showtoptitle($layout, $sitebusiness->business_id);

    //CHECK REQUEST IS AJAX OR NOT OR CURRENT TAB ID OR LAYOUT
    if (!empty($isajax) || ($currenttabid == $this->view->identity) || ($widgets == 0)) {

      $this->view->identity_temp = $zendRequest->getParam('identity_temp', $currenttabid);
      $this->view->show_content = true;

      $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'spcreate');
      if ($isManageAdmin || $canEdit) {
        $this->view->allowed_upload_photo = 1;
      } else {
        $this->view->allowed_upload_photo = 0;
      }

      //ALBUMS PER BUSINESS
      $this->view->albums_per_business = $albums_per_business = $zendRequest->getParam('itemCount', 10);

      if(empty($albums_per_business)) {
        $this->view->albums_per_business = $albums_per_business = 10;
      }

      //ALBUMS ORDER
      $this->view->albums_order = $albums_order = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessalbum.albumsorder', 1);

      //GET CURRENT BUSINESS NUMBER OF ALBUM
      $currentAlbumBusinessNumbers = $this->_getParam('business', 1);

      //SEND CURRENT BUSINESS NUMBER OF ALBUM TO THE TPL
      $this->view->currentAlbumBusinessNumbers = $currentAlbumBusinessNumbers;

      //SET ALBUMS PARAMS
      $paramsAlbum = array();
      $paramsAlbum['business_id'] = $sitebusiness->business_id;

      //GET ALBUM COUNT
      $this->view->album_count = $album_count = Engine_Api::_()->getDbtable('albums', 'sitebusiness')->getAlbumsCount($paramsAlbum);
      
      //START ALBUMS PAGINATION
      $businesses_vars = Engine_Api::_()->sitebusiness()->makeBusiness($album_count, $albums_per_business, $currentAlbumBusinessNumbers);
      $businesses_array = Array();
      for ($y = 0; $y <= $businesses_vars[2] - 1; $y++) {
        if ($y + 1 == $businesses_vars[1]) {
          $links = "1";
        } else {
          $links = "0";
        }
        $businesses_array[$y] = Array('businesses' => $y + 1,
            'links' => $links);
      }

      $this->view->businessesarray = $businesses_array;
      $this->view->maxbusinesses = $businesses_vars[2];
      $this->view->pstarts = 1;
      //END ALBUMS PAGINATION
      
      //SET ALBUMS PARAMS
      $paramsAlbum['start'] = $albums_per_business;
      $paramsAlbum['end'] = $businesses_vars[0];
      if(empty($albums_order)) {
        $paramsAlbum['orderby'] = 'album_id ASC';
      } else {
        $paramsAlbum['orderby'] = 'album_id DESC';
      }
      $paramsAlbum['getSpecialField'] = 0;

      $fecthAlbums = Engine_Api::_()->getDbtable('albums', 'sitebusiness')->getAlbums($paramsAlbum);
      if (!empty($fecthAlbums)) {
        $this->view->album = $this->view->paginator = $fecthAlbums;
      }

      //SET PHOTOS PARAMS
      $paramsPhoto = array();
      $paramsPhoto['business_id'] = $sitebusiness->business_id;
      $paramsPhoto['user_id'] = $sitebusiness->owner_id;
      $paramsPhoto['album_id'] = $this->view->default_album_id = Engine_Api::_()->getItemTable('sitebusiness_album')->getDefaultAlbum($sitebusiness->business_id)->album_id;
      
      //FETCHING ALL PHOTOS
      $this->view->total_images = $total_photo = Engine_Api::_()->getDbtable('photos', 'sitebusiness')->getPhotosCount($paramsPhoto);

      //SEND CURRENT BUSINESS NUMBER TO THE TPL
      $this->view->currentBusinessNumbers = $currentBusinessNumbers = $this->_getParam('businesses', 1);

      //SEND PHOTOS PER BUSINESS TO THE TPL
      $this->view->photos_per_business = $photos_per_business = $zendRequest->getParam('itemCount_photo', 100);

      if(empty($photos_per_business)) {
        $this->view->photos_per_business = $photos_per_business = 100;
      }

      //START PHOTOS PAGINATION
      $business_vars = Engine_Api::_()->sitebusiness()->makeBusiness($total_photo, $photos_per_business, $currentBusinessNumbers);
      $paramsPhoto['start'] = $photos_per_business;
      $paramsPhoto['end'] = $business_vars[0];
      $paramsPhoto['widgetName'] = 'Photos By Others';
      if(empty($albums_order)) {
        $paramsPhoto['photosorder'] = 'album_id ASC';
      } else {
        $paramsPhoto['photosorder'] = 'album_id DESC';
      }
      $this->view->paginators = Engine_Api::_()->getDbtable('photos', 'sitebusiness')->getPhotos($paramsPhoto);
      $business_array = Array();
      for ($x = 0; $x <= $business_vars[2] - 1; $x++) {
        if ($x + 1 == $business_vars[1]) {
          $link = "1";
        } else {
          $link = "0";
        }
        $business_array[$x] = Array('business' => $x + 1,
            'link' => $link);
      }
      $this->view->businessarray = $business_array;
      $this->view->maxbusiness = $business_vars[2];
      $this->view->pstart = 1;
      //END PHOTOS PAGINATION      
    } else {
      $this->view->show_content = false;
      $this->view->identity_temp = $this->view->identity;
    }

    //SET PHOTOS PARAMS
    $paramsPhoto = array();
    $paramsPhoto['business_id'] = $sitebusiness->business_id;

    //SET COUNT TO THE TITLE
    $this->_childCount = $this->view->locale()->toNumber(Engine_Api::_()->getDbtable('photos', 'sitebusiness')->getPhotosCount($paramsPhoto));

   // if((!$fecthAlbums) && empty($canEdit) && !Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessalbum.hide.autogenerated', 1)) {
       //return $this->setNoRender();  
   // }
    
  }

  public function getChildCount() {
    return $this->_childCount;
  }

}

?>
