<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusiness_Widget_WidgetlinksSitebusinessController extends Engine_Content_Widget_Abstract
{

  //ACTION FOR GETTING THE LINKS OF THE WIDGETS ON BUSINESS PROFILE BUSINESS (MEANS WITHOUT TAB LINKS)
  public function indexAction()
  {

    //DON'T RENDER IF SUNJECT IS NOT THERE
    if( !Engine_Api::_()->core()->hasSubject() ) {
      return $this->setNoRender();
    }

    //GET SITEBUSINESS SUBJECT
    $this->view->subject = $subject = Engine_Api::_()->core()->getSubject('sitebusiness_business');

    //GET BUSINESS ID
    $business_id = $subject->business_id;

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($subject, 'view');
    if( empty($isManageAdmin) ) {
      return $this->setNoRender();
    }
    //END MANAGE-ADMIN CHECK
    //GET CORE CONTENT TABLE
    $contentTable = Engine_Api::_()->getDbtable('content', 'core');

    //GET CORE BUSINESSES TABLE
    $businessTable = Engine_Api::_()->getDbtable('pages', 'core');

    //SELECT BUSINESS
    $selectBusiness = $businessTable->select()->from($businessTable->info('name'), array('page_id'))->where('name =?', 'sitebusiness_index_view')->limit(1);

    //GET BUSINESS INFO
    $businessInfo = $businessTable->fetchRow($selectBusiness);

    //HOW MAY LINK SHOULD BE SHOW IN THE WIDGET LINK BEFORE MORE LINK
    $this->view->linklimit = $linklimit = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.showmore', 8);

    if( !empty($businessInfo) ) {
      $selectContent = $contentTable->select()->from($contentTable->info('name'), array('page_id'))->where('name =?', 'core.container-tabs')->where('page_id =?', $businessInfo->page_id)->limit(1);
      $contentinfo = $contentTable->fetchRow($selectContent);
      if( !empty($contentinfo) && !Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.layoutcreate', 0) ) {
        return $this->setNoRender();
      }
    }
    $resource_type = "";
    //GET TAB ID
    $this->view->tab_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab', null);
    if( !Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.layoutcreate', 0) ) {
      $businessAdminContentTable = Engine_Api::_()->getDbtable('content', 'core');
      $selectBusinessAdmin = $businessAdminContentTable->select()
        ->from($businessAdminContentTable->info('name'), array('content_id', 'params', 'name'))
        ->where('page_id =?', $businessInfo->page_id)
        ->where("name IN ('sitebusiness.overview-sitebusiness', 'sitebusiness.photos-sitebusiness', 'sitebusiness.discussion-sitebusiness', 'sitebusinessnote.profile-sitebusinessnotes', 'sitebusinesspoll.profile-sitebusinesspolls', 'sitebusinessevent.profile-sitebusinessevents', 'sitebusinessvideo.profile-sitebusinessvideos', 'sitebusinessoffer.profile-sitebusinessoffers', 'sitebusinessreview.profile-sitebusinessreviews', 'sitebusinessdocument.profile-sitebusinessdocuments', 'sitebusinessform.sitebusiness-viewform','sitebusiness.info-sitebusiness', 'seaocore.feed', 'activity.feed','sitebusiness.location-sitebusiness', 'core.profile-links', 'sitebusinessmusic.profile-sitebusinessmusic', 'sitebusinessintegration.profile-items','sitebusinesstwitter.feeds-sitebusinesstwitter', 'sitebusinessmember.profile-sitebusinessmembers', 'advancedactivity.home-feeds', 'siteevent-contenttype-events', 'sitevideo-contenttype-videos', 'document-contenttype-documents' ,'sitecrowdfunding.contenttype-projects','sitemusic.contenttype-music')");
      $businessAdminresult = $businessAdminContentTable->fetchAll($selectBusinessAdmin);
      $contentWigentLinks = array();
      if( !empty($businessAdminresult) ) {
        foreach( $businessAdminresult as $key => $value ) {
          if( isset($value->params['resource_type']) ) {
            $resource_type = $value->params['resource_type'];

            if( Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessintegration') && strstr($resource_type, 'sitereview_listing') && !empty($resource_type) ) {
              $pieces = explode("_", $resource_type);
              $listingTypeId = $pieces[2];
              $count = Engine_Api::_()->getDbtable('contents', 'sitebusinessintegration')->getCountResults('sitereview_listing', $listingTypeId);
              if( $count == 0 )
                continue;
            }
          }
          $content = $this->getContentName($value->name, $value->params['title'], $resource_type);
          if( !empty($content) ) {
            $contentWigentLinks[$key]['content_id'] = $value->content_id;
            $contentWigentLinks[$key]['content_name'] = $content[0];
            $contentWigentLinks[$key]['content_class'] = $content[1];
            if( isset($content[2]) )
              $contentWigentLinks[$key]['content_resource'] = $content[2];
          }
        }

        $this->view->contentWigentLinks = $contentWigentLinks;
      }
    } else {
      $row = Engine_Api::_()->getDbtable('contentbusinesses', 'sitebusiness')->getContentBusinessId($business_id);
      if( !empty($row) ) {
        $contentbusiness_id = $row->contentbusiness_id;
        $businessAdminresult = Engine_Api::_()->getDbtable('content', 'sitebusiness')->getContents($contentbusiness_id);
      } else {
        $contentbusiness_id = Engine_Api::_()->sitebusiness()->getWidgetizedBusiness()->page_id;
        $businessAdminresult = Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->getContents($contentbusiness_id);
      }


      $contentWigentLinks = array();
      if( !empty($businessAdminresult) ) {
        foreach( $businessAdminresult as $key => $value ) {
          if( isset($value->params['resource_type']) ) {
            $resource_type = $value->params['resource_type'];
            if( Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessintegration') && strstr($resource_type, 'sitereview_listing') && !empty($resource_type) ) {
              $pieces = explode("_", $resource_type);
              $listingTypeId = $pieces[2];
              $count = Engine_Api::_()->getDbtable('contents', 'sitebusinessintegration')->getCountResults('sitereview_listing', $listingTypeId);
              if( $count == 0 )
                continue;
            }
          }
          $content = $this->getContentName($value->name, $value->params['title'], $resource_type);
          if( !empty($content) ) {
            if( isset($value->content_id) ) {
              $contentWigentLinks[$key]['content_id'] = $value->content_id;
            } else {
              $contentWigentLinks[$key]['content_id'] = $value->admincontent_id;
            }

            $contentWigentLinks[$key]['content_name'] = $content[0];
            $contentWigentLinks[$key]['content_class'] = $content[1];
            if( isset($content[2]) )
              $contentWigentLinks[$key]['content_resource'] = $content[2];
          }
        }
        $this->view->contentWigentLinks = $contentWigentLinks;
      }
    }
  }

  public function getContentName($name, $widgettitle, $resource_type)
  {
    $sitebusiness = Engine_Api::_()->core()->getSubject('sitebusiness_business');
    $business_id = $sitebusiness->business_id;
    $can_edit = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    $content_array = array();

    //GET VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    if( !empty($viewer_id) ) {
      $level_id = $viewer->level_id;
    } else {
      $level_id = 0;
    }
    switch( $name ) {
      case 'advancedactivity.home-feeds':
        $content_array = array($widgettitle, 'icon_sitebusiness_update');
        break;
      case 'seaocore.feed':
        $content_array = array($widgettitle, 'icon_sitebusiness_update');
        break;
      case 'activity.feed':
        $content_array = array($widgettitle, 'icon_sitebusiness_update');
        break;
      case 'sitebusiness.info-sitebusiness':
        $content_array = array($widgettitle, 'icon_sitebusiness_info');
        break;
      case 'core.profile-links':
        $linkTable = Engine_Api::_()->getDbtable('links', 'core');
        $linkTableresult = $linkTable->fetchAll($linkTable->select()->where('parent_id =?', $business_id))->toarray();
        if( !empty($linkTableresult) ) {
          $content_array = array($widgettitle, 'icon_sitebusiness_business_link');
        }
        break;
      case 'sitebusiness.photos-sitebusiness':
        $enable_albums = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessalbum');
        if( $enable_albums ) {

          //TOTAL ALBUMS
          $albumCount = Engine_Api::_()->sitebusiness()->getTotalCount($business_id, 'sitebusiness', 'albums');
          $photoCreate = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'spcreate');
          if( empty($photoCreate) && empty($albumCount) ) {
            break;
          }
          //PACKAGE BASE PRIYACY START
          if( Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
            if( !Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessalbum") ) {
              break;
            }
          } else {
            $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'spcreate');
            if( empty($isBusinessOwnerAllow) ) {
              break;
            }
          }
          //PACKAGE BASE PRIYACY END
          $content_array = array($widgettitle, 'icon_sitebusiness_photo_view');
        }
        break;
      case 'sitebusiness.discussion-sitebusiness':
        $enable_discussions = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessdiscussion');
        if( $enable_discussions ) {

          //TOTAL TOPICS
          $discussionsCount = Engine_Api::_()->sitebusiness()->getTotalCount($business_id, 'sitebusiness', 'topics');
          $topicComment = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'sdicreate');
          if( empty($topicComment) && empty($discussionsCount) ) {
            break;
          }

          //PACKAGE BASE PRIYACY START
          if( Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
            if( !Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessdiscussion") ) {
              break;
            }
          } else {
            $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'sdicreate');
            if( empty($isBusinessOwnerAllow) ) {
              break;
            }
          }
          //PACKAGE BASE PRIYACY END
          $content_array = array($widgettitle, 'icon_sitebusinesses_discussion');
        }
        break;
      case 'sitebusinessnote.profile-sitebusinessnotes':
        $enable_notes = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessnote');
        if( $enable_notes ) {
          //TOTAL NOTES
          $notesCount = Engine_Api::_()->sitebusiness()->getTotalCount($business_id, 'sitebusinessnote', 'notes');
          $noteCreate = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'sncreate');
          if( empty($noteCreate) && empty($notesCount) ) {
            break;
          }
          //PACKAGE BASE PRIYACY START
          if( Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
            if( !Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessnote") ) {
              break;
            }
          } else {
            $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'sncreate');
            if( empty($isBusinessOwnerAllow) ) {
              break;
            }
          }
          //PACKAGE BASE PRIYACY END
          $content_array = array($widgettitle, 'icon_sitebusinessnote_note');
        }
        break;
      case 'sitebusinessevent.profile-sitebusinessevents':
        $enable_events = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessevent');
        if( $enable_events ) {
          //TOTAL EVENTS
          $eventCount = Engine_Api::_()->sitebusiness()->getTotalCount($business_id, 'sitebusinessevent', 'events');
          $eventCreate = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'secreate');
          if( empty($eventCreate) && empty($eventCount) ) {
            break;
          }
          //PACKAGE BASE PRIYACY START
          if( Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
            if( !Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessevent") ) {
              break;
            }
          } else {
            $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'secreate');
            if( empty($isBusinessOwnerAllow) ) {
              break;
            }
          }
          //PACKAGE BASE PRIYACY END
          $content_array = array($widgettitle, 'icon_sitebusinessevent');
        }
        break;
      case 'siteevent.contenttype-events':
        $enable_events = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('siteevent');
        if( $enable_events ) {
          $eventCount = Engine_Api::_()->sitebusiness()->getTotalCount($sitebusiness->business_id, 'siteevent', 'events');
          $eventCreate = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'secreate');
          if( empty($eventCreate) && empty($eventCount) ) {
            break;
          }
          //PACKAGE BASE PRIYACY START
          if( Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
            if( !Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessevent") ) {
              break;
            }
          } else {
            $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'secreate');
            if( empty($isBusinessOwnerAllow) ) {
              break;
            }
          }
          //PACKAGE BASE PRIYACY END
          $content_array = array($widgettitle, 'icon_sitebusinessevent');
        }
        break;
      case 'sitevideo.contenttype-videos':
        if( Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitevideo') ) {
          if( Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
            if( Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessvideo") == 1 ) {
              $flag = true;
            }
          } else {
            $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'svcreate');
            if( !empty($isBusinessOwnerAllow) ) {
              $flag = true;
            }
          }
          //TOTAL videoS
          $videoCount = Engine_Api::_()->sitebusiness()->getTotalCount($sitebusiness->business_id, 'sitevideo', 'videos');
          $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'svcreate');
          if( !empty($isManageAdmin) || !empty($videoCount) ) {
            $flag = true;
          } else {
            $flag = false;
          }
        }
        break;

      case 'document.contenttype-documents':
        if( Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('document') ) {
          if( Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
            if( Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessdocument") == 1 ) {
              $flag = true;
            }
          } else {
            $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'sdcreate');
            if( !empty($isBusinessOwnerAllow) ) {
              $flag = true;
            }
          }
          $documentCount = Engine_Api::_()->sitebusiness()->getTotalCount($sitebusiness->business_id, 'document', 'documents');
          $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'sdcreate');
          if( !empty($isManageAdmin) || !empty($documentCount) ) {
            $flag = true;
          } else {
            $flag = false;
          }
        }
        break;
      case 'sitebusinesspoll.profile-sitebusinesspolls':
        $enable_polls = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinesspoll');
        if( $enable_polls ) {
          //TOTAL POLLS
          $pollCount = Engine_Api::_()->sitebusiness()->getTotalCount($business_id, 'sitebusinesspoll', 'polls');
          $pollCreate = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'splcreate');
          if( empty($pollCreate) && empty($pollCount) ) {
            break;
          }
          //PACKAGE BASE PRIYACY START
          if( Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
            if( !Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinesspoll") ) {
              break;
            }
          } else {
            $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'splcreate');
            if( empty($isBusinessOwnerAllow) ) {
              break;
            }
          }
          //PACKAGE BASE PRIYACY END
          $content_array = array($widgettitle, 'item_icon_sitebusinesspoll');
        }
        break;
      case 'sitebusinessvideo.profile-sitebusinessvideos':
        $enable_videos = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessvideo');
        if( $enable_videos ) {
          //TOTAL VIDEOS
          $videoCount = Engine_Api::_()->sitebusiness()->getTotalCount($business_id, 'sitebusinessvideo', 'videos');
          $videoCreate = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'svcreate');
          if( empty($videoCreate) && empty($videoCount) ) {
            break;
          }
          //PACKAGE BASE PRIYACY START
          if( Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
            if( !Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessvideo") ) {
              break;
            }
          } else {
            $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'svcreate');
            if( empty($isBusinessOwnerAllow) ) {
              break;
            }
          }
          //PACKAGE BASE PRIYACY END
          $content_array = array($widgettitle, 'icon_type_sitebusinessvideo');
        }
        break;
      case 'sitecrowdfunding.contenttype-projects':
        $enable_projects = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitecrowdfunding');
        if( $enable_projects ) {
          $projectCount = Engine_Api::_()->sitebusiness()->getTotalCount($sitebusiness->business_id, 'sitecrowdfunding', 'projects');
          $projectCreate = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'sprcreate');
          if( empty($projectCreate) && empty($projectCount) ) {
            break;
          }
          //PACKAGE BASE PRIYACY START
          if( Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
            if( !Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitecrowdfunding") ) {
              break;
            }
          } else {
            $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'sprcreate');
            if( empty($isBusinessOwnerAllow) ) {
              break;
            }
          }
          //PACKAGE BASE PRIYACY END
          $content_array = array($widgettitle, 'icon_sitecrowdfunding');
        }
        break;
      case 'sitemusic.contenttype-music':
        $enable_sitemusic = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitemusic');
        if( $enable_sitemusic ) {
          $musicAlbumCount = Engine_Api::_()->sitebusiness()->getTotalCount($sitebusiness->business_id, 'sitemusic', 'music');
          $musicAlbumCreate = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'samcreate');
          if( empty($musicAlbumCreate) && empty($musicAlbumCount) ) {
            break;
          }
          //PACKAGE BASE PRIYACY START
          if( Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
            if( !Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitemusic") ) {
              break;
            }
          } else {
            $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'samcreate');
            if( empty($isBusinessOwnerAllow) ) {
              break;
            }
          }
          //PACKAGE BASE PRIYACY END
          $content_array = array($widgettitle, 'icon_sitemusic');
        }
        break;
      case 'sitebusinessdocument.profile-sitebusinessdocuments':
        $enable_documents = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessdocument');
        if( $enable_documents ) {
          //TOTAL DOCUMENTS
          $documentCount = Engine_Api::_()->sitebusiness()->getTotalCount($business_id, 'sitebusinessdocument', 'documents');
          $documentCreate = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'sdcreate');
          if( empty($documentCreate) && empty($documentCount) ) {
            break;
          }
          //PACKAGE BASE PRIYACY START
          if( Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
            if( !Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessdocument") ) {
              break;
            }
          } else {
            $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'sdcreate');
            if( empty($isBusinessOwnerAllow) ) {
              break;
            }
          }
          //PACKAGE BASE PRIYACY END
          $content_array = array($widgettitle, 'item_icon_sitebusinessdocument_detail');
        }
        break;
      case 'sitebusinessreview.profile-sitebusinessreviews':
        $enable_reviews = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessreview');
        if( $enable_reviews ) {
          //TOTAL REVIEW
          $reviewCount = Engine_Api::_()->sitebusiness()->getTotalCount($business_id, 'sitebusinessreview', 'reviews');
          $level_allow = Engine_Api::_()->authorization()->getPermission($level_id, 'sitebusinessreview_review', 'create');
          if( empty($level_allow) && empty($reviewCount) ) {
            break;
          }
          $content_array = array($widgettitle, 'icon_sitebusinesses_review');
        }
        break;
      case 'sitebusiness.location-sitebusiness':
        $check_location = Engine_Api::_()->sitebusiness()->enableLocation();
        $value['id'] = $business_id;
        $location = Engine_Api::_()->getDbtable('locations', 'sitebusiness')->getLocation($value);
        $isManageAdmin = 0;
        $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'map');
        if( $check_location && $location && !empty($isManageAdmin) ) {
          $content_array = array($widgettitle, 'icon_sitebusinesses_map');
        }
        break;
      case 'sitebusiness.overview-sitebusiness':
        $isManageAdmin = 0;
        $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'overview');
        if( empty($isManageAdmin) || empty($can_edit) && empty($sitebusiness->overview) )
          break;
        $content_array = array($widgettitle, 'icon_sitebusinesses_overview');
        break;
      case 'sitebusinessform.sitebusiness-viewform':
        $enable_forms = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessform');
        if( $enable_forms ) {
          $quetion = Engine_Api::_()->getDbtable('businessquetions', 'sitebusinessform');
          $result_quetion = $quetion->fetchRow($quetion->select()->where('business_id = ?', $business_id));
          $option_id = $result_quetion->option_id;
          $itebusinessforms_table = Engine_Api::_()->getDbtable('sitebusinessforms', 'sitebusinessform');
          $select_sitebusinessform_result = $itebusinessforms_table->fetchRow($itebusinessforms_table->select()->where('business_id = ?', $business_id));
          if( !empty($option_id) ) {
            if( $select_sitebusinessform_result->status == 0 || $select_sitebusinessform_result->businessformactive == 0 ) {
              break;
            }
            //PACKAGE BASE PRIYACY START
            if( Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
              if( !Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessform") ) {
                break;
              }
            } else {
              $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'form');
              if( empty($isBusinessOwnerAllow) ) {
                break;
              }
            }
            //PACKAGE BASE PRIYACY END
            $content_array = array($widgettitle, 'icon_sitebusiness_form');
          }
        }
        break;
      case 'sitebusinessoffer.profile-sitebusinessoffers':
        $enable_offers = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessoffer');
        if( $enable_offers ) {

          $can_edit = 1;
          $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
          if( empty($isManageAdmin) ) {
            $can_edit = 0;
          }

          $can_offer = 1;
          $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'offer');

          if( empty($isManageAdmin) ) {
            $can_offer = 0;
          }
          $can_create_offer = '';

          //OFFER CREATION AUTHENTICATION CHECK
          if( $can_edit == 1 && $can_offer == 1 ) {
            $this->view->can_create_offer = $can_create_offer = 1;
          }
          //TOTAL OFFER
          $offerCount = Engine_Api::_()->sitebusiness()->getTotalCount($business_id, 'sitebusinessoffer', 'offers');
          if( empty($can_create_offer) && empty($offerCount) ) {
            break;
          }

          //PACKAGE BASE PRIYACY START
          if( Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
            if( !Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessoffer") ) {
              break;
            }
          } else {
            $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'offer');
            if( empty($isBusinessOwnerAllow) ) {
              break;
            }
          }
          //PACKAGE BASE PRIYACY END
          $content_array = array($widgettitle, 'sitebusinessoffer_type_offer');
        }
        break;
      case 'sitebusinessmusic.profile-sitebusinessmusic':
        $enable_musics = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmusic');
        if( $enable_musics ) {
          //TOTAL MUSIC
          $musicCount = Engine_Api::_()->sitebusiness()->getTotalCount($business_id, 'sitebusinessmusic', 'playlists');
          $musicCreate = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'smcreate');
          if( empty($musicCreate) && empty($musicCount) ) {
            break;
          }
          //PACKAGE BASE PRIYACY START
          if( Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
            if( !Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessmusic") ) {
              break;
            }
          } else {
            $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'smcreate');
            if( empty($isBusinessOwnerAllow) ) {
              break;
            }
          }
          //PACKAGE BASE PRIYACY END
          $content_array = array($widgettitle, 'icon_sitebusinessmusic_music');
        }
        break;
      case 'sitebusinessmember.profile-sitebusinessmembers':
        $enable_member = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember');
        if( $enable_member ) {
          //TOTAL MEMBER
          $memberCount = Engine_Api::_()->sitebusiness()->getTotalCount($business_id, 'sitebusiness', 'membership');
          $memberCreate = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'smecreate');
          if( empty($memberCreate) && empty($memberCount) ) {
            break;
          }
          //PACKAGE BASE PRIYACY START
          if( Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
            if( !Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessmember") ) {
              break;
            }
          } else {
            $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'smecreate');
            if( empty($isBusinessOwnerAllow) ) {
              break;
            }
          }
          //PACKAGE BASE PRIYACY END
          $content_array = array($widgettitle, 'icon_sitebusiness_member');
        }
        break;
      case 'sitebusinessintegration.profile-items':
        $pieces = explode("_", $resource_type);
        $resourceType = $pieces[0] . '_' . $pieces[1];
        $listingTypeId = $pieces[2];
        $enable_sitebusinessintegration = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessintegration');
        if( $enable_sitebusinessintegration ) {
          //PACKAGE BASE PRIYACY START
          if( Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
            if( !Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", $resourceType . '_' . $listingTypeId) ) {
              break;
            }
          } else {
            $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, $resourceType . '_' . $listingTypeId);
            if( empty($isBusinessOwnerAllow) ) {
              break;
            }
          }
          //PACKAGE BASE PRIYACY END
          //PACKAGE BASE PRIYACY END
          if( $resourceType == 'list_listing' ) {
            $content_array = array($widgettitle, "item_icon_list", $resourceType);
          } elseif( $resourceType == 'sitepage_page' ) {
            $content_array = array($widgettitle, "item_icon_sitepage", $resourceType);
          } else {
            $content_array = array($widgettitle, "item_icon_sitereview_listtype_$listingTypeId", $resourceType);
          }
        }
        break;

//         case 'sitebusinesstwitter.feeds-sitebusinesstwitter':
//
// 					$enable_sitebusinesstwitter = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinesstwitter');
// 					if ($enable_sitebusinesstwitter) {
// 						$isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'twitter');
// 					if (empty($isManageAdmin)) {
// 							break;
// 						}
// 						$content_array = array($widgettitle, 'icon_sitebusinessmusic_music');
// 					}
    }
    return $content_array;
  }

}

?>