<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessalbum
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Widget.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessalbum_Form_Admin_Widget extends Engine_Form {

  public function init() {

    $this
            ->setTitle('Widget Settings')
            ->setDescription('Configure the general settings for the various widgets available with this plugin.');

    $this->addElement('Text', 'sitebusiness_album', array(
        'label' => 'Business Profile Albums',
        'maxlength' => '3',
        'description' => 'How many albums will be shown in the business profile albums widget (value can not be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.album', 10),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'sitebusiness_photo', array(
        'label' => 'Photos in Business Profile Albums',
        //'maxlength' => '3',
        'description' => 'How many photos will be shown below albums in the business profile albums widget (value can not be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.photo', 100),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'sitebusiness_mostliked_photos', array(
        'label' => 'Business Profile Most Liked Photos',
        'maxlength' => '3',
        'description' => 'How many photos will be shown in the business profile most liked photos widget (value can not be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.mostliked.photos', 4),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'sitebusiness_mostcommented_photos', array(
        'label' => 'Business Profile Most Commented Photos',
        'maxlength' => '3',
        'description' => 'How many photos will be shown in the business profile most commented photos widget (value can not be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.mostcommented.photos', 4),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'sitebusiness_mostrecent_photos', array(
        'label' => 'Business Profile Photos Strip',
        'maxlength' => '3',
        'description' => 'How many photos will be shown in the business profile photos strip widget (value can not be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.mostrecent.photos', 7),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'sitebusiness_homerecentphotos_widgets', array(
        'label' => 'Recent Photos',
        'maxlength' => '3',
        'description' => 'How many photos should be shown in the recent photos widget (value cannot be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.homerecentphotos.widgets', 4),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'sitebusiness_mostpopularphotos_widgets', array(
        'label' => 'Popular Photos',
        'maxlength' => '3',
        'description' => 'How many photos should be shown in the most popular photos widget (value cannot be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.mostpopularphotos.widgets', 4),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Button', 'submit', array(
        'label' => 'Save Changes',
        'type' => 'submit',
        'ignore' => true
    ));
  }

}

?>