<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    sitebusinessevent
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: WidgetSettings.php 6590 2010-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

//START LANGUAGE WORK
Engine_Api::_()->getApi('language', 'sitebusiness')->languageChanges();
//END LANGUAGE WORK

//GET DB
$db = Zend_Db_Table_Abstract::getDefaultAdapter();

$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `custom`, `order`, `enabled`) VALUES
("sitebusinessalbum_admin_widget_settings", "sitebusinessalbum", "Widget Settings", "", \'{"route":"admin_default","module":"sitebusinessalbum","controller":"widgets"}\', "sitebusinessalbum_admin_main", "", 0, 3, 1)');

$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitebusinessalbum_admin_main_photo_featured", "sitebusinessalbum", "Featured Photos", "", \'{"route":"admin_default","module":"sitebusinessalbum","controller":"settings", "action": "featured"}\', "sitebusinessalbum_admin_main", "", 1, 0, 4)');

$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitebusinessalbum_admin_submain_general_tab", "sitebusinessalbum", "General Settings", "", \'{"route":"admin_default","module":"sitebusinessalbum","controller":"widgets", "action": "index"}\', "sitebusinessalbum_admin_submain", "", 1, 0, 1)');

$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitebusinessalbum_admin_submain_album_tab", "sitebusinessalbum", "Tabbed Albums Widget", "", \'{"route":"admin_default","module":"sitebusinessalbum","controller":"album", "action": "index"}\', "sitebusinessalbum_admin_submain", "", 1, 0, 2)');


$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitebusinessalbum_admin_submain_photo_tab", "sitebusinessalbum", "Tabbed Photos Widget", "", \'{"route":"admin_default","module":"sitebusinessalbum","controller":"photo", "action": "index"}\', "sitebusinessalbum_admin_submain", "", 1, 0, 3)');

$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitebusinessalbum_admin_submain_dayitems", "sitebusinessalbum", "Album of the Day", "", \'{"route":"admin_default","module":"sitebusinessalbum","controller":"album", "action": "manage-day-items"}\', "sitebusinessalbum_admin_submain", "", 1, 0, 4)');

$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitebusinessalbum_admin_submain_photo_items", "sitebusinessalbum", "Photo of the Day", "", \'{"route":"admin_default","module":"sitebusinessalbum","controller":"photo", "action": "photo-of-day"}\', "sitebusinessalbum_admin_submain", "", 1, 0, 5)');

//CHECK THAT SITEBUSINESS PLUGIN IS ACTIVATED OR NOT
$select = new Zend_Db_Select($db);
$select
        ->from('engine4_core_settings')
        ->where('name = ?', 'sitebusiness.is.active')
        ->limit(1);
$sitebusiness_settings = $select->query()->fetchAll();
if (!empty($sitebusiness_settings)) {
  $sitebusiness_is_active = $sitebusiness_settings[0]['value'];
} else {
  $sitebusiness_is_active = 0;
}

//CHECK THAT SITEBUSINESS PLUGIN IS INSTALLED OR NOT
$select = new Zend_Db_Select($db);
$select
        ->from('engine4_core_modules')
        ->where('name = ?', 'sitebusiness')
        ->where('enabled = ?', 1);
$check_sitebusiness = $select->query()->fetchObject();
if (!empty($check_sitebusiness) && !empty($sitebusiness_is_active)) {
  $select = new Zend_Db_Select($db);
  $select_business = $select
          ->from('engine4_core_pages', 'page_id')
          ->where('name = ?', 'sitebusiness_index_view')
          ->limit(1);
  $business = $select_business->query()->fetchAll();
  if (!empty($business)) {
    $business_id = $business[0]['page_id'];

    //INSERTING THE PHOTO WIDGET IN SITEBUSINESS_ADMIN_CONTENT TABLE ALSO.
    Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminDefaultInfo('sitebusiness.photos-sitebusiness', $business_id, 'Photos', 'true', '110');

    //INSERTING THE PHOTO WIDGET IN CORE_CONTENT TABLE ALSO.
    Engine_Api::_()->getApi('layoutcore', 'sitebusiness')->setContentDefaultInfo('sitebusiness.photos-sitebusiness', $business_id, 'Photos', 'true', '110');

    //INSERTING THE PHOTO WIDGET IN SITEBUSINESS_CONTENT TABLE ALSO.
    $select = new Zend_Db_Select($db);
    $select = $select
            ->from('engine4_sitebusiness_contentbusinesses', 'contentbusiness_id');
    $contentbusiness_ids = $select->query()->fetchAll();
    foreach ($contentbusiness_ids as $contentbusiness_id) {
      if (!empty($contentbusiness_id)) {
        $contentbusiness_id = $contentbusiness_id['contentbusiness_id'];
        Engine_Api::_()->getDbtable('content', 'sitebusiness')->setDefaultInfo('sitebusiness.photos-sitebusiness', $contentbusiness_id, 'Photos', 'true', '110');

        //INSERT THE RANDOM ALBUM WIDGET
        $select = new Zend_Db_Select($db);
        $select_content = $select
                ->from('engine4_sitebusiness_content')
                ->where('contentbusiness_id = ?', $contentbusiness_id)
                ->where('type = ?', 'widget')
                ->where('name = ?', 'sitebusiness.albums-sitebusiness')
                ->limit(1);
        $content = $select_content->query()->fetchAll();
        if (empty($content)) {
          $select = new Zend_Db_Select($db);
          $select_container = $select
                  ->from('engine4_sitebusiness_content', 'content_id')
                  ->where('contentbusiness_id = ?', $contentbusiness_id)
                  ->where('type = ?', 'container')
                  ->limit(1);
          $container = $select_container->query()->fetchAll();
          if (!empty($container)) {
            $container_id = $container[0]['content_id'];
            $select = new Zend_Db_Select($db);
            $select_left = $select
                    ->from('engine4_sitebusiness_content')
                    ->where('parent_content_id = ?', $container_id)
                    ->where('type = ?', 'container')
										->where('contentbusiness_id = ?', $contentbusiness_id)
										->where('name in (?)', array('left', 'right'))
                    ->limit(1);
            $left = $select_left->query()->fetchAll();
            if (!empty($left)) {
              $left_id = $left[0]['content_id'];
              $db->insert('engine4_sitebusiness_content', array(
                  'contentbusiness_id' => $contentbusiness_id,
                  'type' => 'widget',
                  'name' => 'sitebusiness.albums-sitebusiness',
                  'parent_content_id' => $left_id,
                  'order' => 25,
                  'params' => '{"title":"Albums","titleCount":""}',
              ));
            }
          }
        }

        //INSERT THE PHOTO STRIP WIDGET IN SITEBUSINESS CONTENT TABLE FOR USER
//         $select = new Zend_Db_Select($db);
//         $select_content = $select
//                 ->from('engine4_sitebusiness_content')
//                 ->where('contentbusiness_id = ?', $contentbusiness_id)
//                 ->where('type = ?', 'widget')
//                 ->where('name = ?', 'sitebusiness.photorecent-sitebusiness')
//                 ->limit(1);
//         $content = $select_content->query()->fetchAll();
//         if (empty($content)) {
//           $select = new Zend_Db_Select($db);
//           $select_container = $select
//                   ->from('engine4_sitebusiness_content', 'content_id')
//                   ->where('contentbusiness_id = ?', $contentbusiness_id)
//                   ->where('type = ?', 'container')
//                   ->limit(1);
//           $container = $select_container->query()->fetchAll();
//           if (!empty($container)) {
//             $container_id = $container[0]['content_id'];
//             $select = new Zend_Db_Select($db);
//             $select_middle = $select
//                     ->from('engine4_sitebusiness_content')
//                     ->where('parent_content_id = ?', $container_id)
//                     ->where('type = ?', 'container')
//                     ->where('name = ?', 'middle')
//                     ->limit(1);
//             $middle = $select_middle->query()->fetchAll();
//             if (!empty($middle)) {
//               $middle_id = $middle[0]['content_id'];
//               $db->insert('engine4_sitebusiness_content', array(
//                   'contentbusiness_id' => $contentbusiness_id,
//                   'type' => 'widget',
//                   'name' => 'sitebusiness.photorecent-sitebusiness',
//                   'parent_content_id' => $middle_id,
//                   'order' => 5,
//                   'params' => '{"title":"","titleCount":""}',
//               ));
//             }
//           }
//         }
      }
    }

    //INSERT THE RANDOM ALBUM WIDGET IN ADMIN CONTENT TABLE
    $select = new Zend_Db_Select($db);
    $select_content = $select
            ->from('engine4_sitebusiness_admincontent')
            ->where('business_id = ?', $business_id)
            ->where('type = ?', 'widget')
            ->where('name = ?', 'sitebusiness.albums-sitebusiness')
            ->limit(1);
    $content = $select_content->query()->fetchAll();
    if (empty($content)) {
      $select = new Zend_Db_Select($db);
      $select_container = $select
              ->from('engine4_sitebusiness_admincontent', 'admincontent_id')
              ->where('business_id = ?', $business_id)
              ->where('type = ?', 'container')
              ->limit(1);
      $container = $select_container->query()->fetchAll();
      if (!empty($container)) {
        $container_id = $container[0]['admincontent_id'];
        $select = new Zend_Db_Select($db);
        $select_left = $select
                ->from('engine4_sitebusiness_admincontent')
                ->where('parent_content_id = ?', $container_id)
                ->where('type = ?', 'container')
								->where('business_id = ?', $business_id)
								->where('name in (?)', array('left', 'right'))
                ->limit(1);
        $left = $select_left->query()->fetchAll();
        if (!empty($left)) {
          $left_id = $left[0]['admincontent_id'];
          $db->insert('engine4_sitebusiness_admincontent', array(
              'business_id' => $business_id,
              'type' => 'widget',
              'name' => 'sitebusiness.albums-sitebusiness',
              'parent_content_id' => $left_id,
              'order' => 25,
              'params' => '{"title":"Albums","titleCount":""}',
          ));
        }
      }
    }

    //INSERT THE PHOTO STRIP WIDGET IN ADMIN CONTENT TABLE
//     $select = new Zend_Db_Select($db);
//     $select_content = $select
//             ->from('engine4_sitebusiness_admincontent')
//             ->where('business_id = ?', $business_id)
//             ->where('type = ?', 'widget')
//             ->where('name = ?', 'sitebusiness.photorecent-sitebusiness')
//             ->limit(1);
//     $content = $select_content->query()->fetchAll();
//     if (empty($content)) {
//       $select = new Zend_Db_Select($db);
//       $select_container = $select
//               ->from('engine4_sitebusiness_admincontent', 'admincontent_id')
//               ->where('business_id = ?', $business_id)
//               ->where('type = ?', 'container')
//               ->limit(1);
//       $container = $select_container->query()->fetchAll();
//       if (!empty($container)) {
//         $container_id = $container[0]['admincontent_id'];
//         $select = new Zend_Db_Select($db);
//         $select_middle = $select
//                 ->from('engine4_sitebusiness_admincontent')
//                 ->where('parent_content_id = ?', $container_id)
//                 ->where('type = ?', 'container')
//                 ->where('name = ?', 'middle')
//                 ->limit(1);
//         $middle = $select_middle->query()->fetchAll();
//         if (!empty($middle)) {
//           $middle_id = $middle[0]['admincontent_id'];
//           $db->insert('engine4_sitebusiness_admincontent', array(
//               'business_id' => $business_id,
//               'type' => 'widget',
//               'name' => 'sitebusiness.photorecent-sitebusiness',
//               'parent_content_id' => $middle_id,
//               'order' => 5,
//               'params' => '{"title":"","titleCount":""}',
//           ));
//         }
//       }
//     }

    //INSERT THE RANDOM ALBUM WIDGET IN CORE CONTENT TABLE
    $select = new Zend_Db_Select($db);
    $select_content = $select
            ->from('engine4_core_content')
            ->where('page_id = ?', $business_id)
            ->where('type = ?', 'widget')
            ->where('name = ?', 'sitebusiness.albums-sitebusiness')
            ->limit(1);
    $content = $select_content->query()->fetchAll();
    if (empty($content)) {
      $select = new Zend_Db_Select($db);
      $select_container = $select
              ->from('engine4_core_content', 'content_id')
              ->where('page_id = ?', $business_id)
              ->where('type = ?', 'container')
              ->limit(1);
      $container = $select_container->query()->fetchAll();
      if (!empty($container)) {
        $container_id = $container[0]['content_id'];
        $select = new Zend_Db_Select($db);
        $select_left = $select
                ->from('engine4_core_content')
                ->where('parent_content_id = ?', $container_id)
                ->where('type = ?', 'container')
								->where('page_id = ?', $business_id)
								->where('name in (?)', array('left', 'right'))
                ->limit(1);
        $left = $select_left->query()->fetchAll();
        if (!empty($left)) {
          $left_id = $left[0]['content_id'];
          $db->insert('engine4_core_content', array(
              'page_id' => $business_id,
              'type' => 'widget',
              'name' => 'sitebusiness.albums-sitebusiness',
              'parent_content_id' => $left_id,
              'order' => 25,
              'params' => '{"title":"Albums","titleCount":""}',
          ));
        }
      }
    }

    //INSERT THE PHOTO STRIP WIDGET IN CORE CONTENT TABLE
//     $select = new Zend_Db_Select($db);
//     $select_content = $select
//             ->from('engine4_core_content')
//             ->where('page_id = ?', $business_id)
//             ->where('type = ?', 'widget')
//             ->where('name = ?', 'sitebusiness.photorecent-sitebusiness')
//             ->limit(1);
//     $content = $select_content->query()->fetchAll();
//     if (empty($content)) {
//       $select = new Zend_Db_Select($db);
//       $select_container = $select
//               ->from('engine4_core_content', 'content_id')
//               ->where('page_id = ?', $business_id)
//               ->where('type = ?', 'container')
//               ->limit(1);
//       $container = $select_container->query()->fetchAll();
//       if (!empty($container)) {
//         $container_id = $container[0]['content_id'];
//         $select = new Zend_Db_Select($db);
//         $select_middle = $select
//                 ->from('engine4_core_content')
//                 ->where('parent_content_id = ?', $container_id)
//                 ->where('type = ?', 'container')
//                 ->where('name = ?', 'middle')
//                 ->limit(1);
//         $middle = $select_middle->query()->fetchAll();
//         if (!empty($middle)) {
//           $middle_id = $middle[0]['content_id'];
//           $db->insert('engine4_core_content', array(
//               'page_id' => $business_id,
//               'type' => 'widget',
//               'name' => 'sitebusiness.photorecent-sitebusiness',
//               'parent_content_id' => $middle_id,
//               'order' => 5,
//               'params' => '{"title":"","titleCount":""}',
//           ));
//         }
//       }
//     }
  }
  
  
  
    
  $contentTable = Engine_Api::_()->getDbtable('content', 'core');
  $contentTableName = $contentTable->info('name');
 
  $select = new Zend_Db_Select($db);
	$select
					->from('engine4_core_modules')
					->where('name = ?', 'communityad')
					->where('enabled 	 = ?', 1)
					->limit(1);
	;
	$infomation = $select->query()->fetch();
	$select = new Zend_Db_Select($db);
	$select
					->from('engine4_core_settings')
					->where('name = ?', 'sitebusiness.communityads')
					->where('value 	 = ?', 1)
					->limit(1);
    ;
    $rowinfo = $select->query()->fetch();

  $select = new Zend_Db_Select($db);
  $select
          ->from('engine4_core_pages')
          ->where('name = ?', 'sitebusiness_album_browse')
          ->limit(1);
  ;
  $info = $select->query()->fetch();
  if ( empty($info) ) {
    $db->insert('engine4_core_pages', array(
        'name' => 'sitebusiness_album_browse',
        'displayname' => 'Browse Business albums',
        'title' => 'Business Albums List',
        'description' => 'This is the business albums.',
        'custom' => 1,
    ));
    $business_id = $db->lastInsertId('engine4_core_pages');
//INSERT MAIN CONTAINER
    $mainContainer = $contentTable->createRow();
    $mainContainer->page_id = $business_id;
    $mainContainer->type = 'container';
    $mainContainer->name = 'main';
    $mainContainer->order = 2;
    $mainContainer->save();
    $container_id = $mainContainer->content_id;

//INSERT MAIN - MIDDLE CONTAINER
    $mainMiddleContainer = $contentTable->createRow();
    $mainMiddleContainer->page_id = $business_id;
    $mainMiddleContainer->type = 'container';
    $mainMiddleContainer->name = 'middle';
    $mainMiddleContainer->parent_content_id = $container_id;
    $mainMiddleContainer->order = 6;
    $mainMiddleContainer->save();
    $middle_id = $mainMiddleContainer->content_id;

//INSERT MAIN - RIGHT CONTAINER
    $mainRightContainer = $contentTable->createRow();
    $mainRightContainer->page_id = $business_id;
    $mainRightContainer->type = 'container';
    $mainRightContainer->name = 'right';
    $mainRightContainer->parent_content_id = $container_id;
    $mainRightContainer->order = 5;
    $mainRightContainer->save();
    $right_id = $mainRightContainer->content_id;

//INSERT TOP CONTAINER
    $topContainer = $contentTable->createRow();
    $topContainer->page_id = $business_id;
    $topContainer->type = 'container';
    $topContainer->name = 'top';
    $topContainer->order = 1;
    $topContainer->save();
    $top_id = $topContainer->content_id;

//INSERT TOP- MIDDLE CONTAINER
    $topMiddleContainer = $contentTable->createRow();
    $topMiddleContainer->page_id = $business_id;
    $topMiddleContainer->type = 'container';
    $topMiddleContainer->name = 'middle';
    $topMiddleContainer->parent_content_id = $top_id;
    $topMiddleContainer->order = 6;
    $topMiddleContainer->save();
    $top_middle_id = $topMiddleContainer->content_id;

    //INSERT NAVIGATION WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.browsenevigation-sitebusiness', $top_middle_id, 1);

//INSERT ALBUM WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessalbum.sitebusiness-album', $middle_id, 2);

    //INSERT SEARCH BUSINESS ALBUM WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessalbum.search-sitebusinessalbum', $right_id, 3, "", "true");

    //INSERT RECENT BUSINESS ALBUM WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.mostrecentphotos-sitebusiness', $right_id, 4, "Recent Photos", "true");

    //INSERT SPONSORED BUSINESS ALBUM WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessalbum.sitebusiness-sponsoredalbum', $right_id, 5, "Sponsored Albums", "true");

    //INSERT MOST POUPLAR BUSINESS ALBUM WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.popularphotos-sitebusiness', $right_id, 6, "Most Popular Photos", "true");

    if ( $infomation && $rowinfo ) {
      Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.business-ads', $right_id, 7, "", "true");
    }
  }

  $select = new Zend_Db_Select($db);

  // Check if it's already been placed
  $select = new Zend_Db_Select($db);
  $select
          ->from('engine4_core_pages')
          ->where('name = ?', 'sitebusiness_album_view')
          ->limit(1);
  ;
  $info = $select->query()->fetch();

  if ( empty($info) ) {
    $db->insert('engine4_core_pages', array(
        'name' => 'sitebusiness_album_view',
        'displayname' => 'Business Album View Page',
        'title' => 'View Business Album',
        'description' => 'This is the view business for a business album.',
        'custom' => 1,
        'provides' => 'subject=sitebusinessalbum',
    ));
    $business_id = $db->lastInsertId('engine4_core_pages');

    // containers
    $db->insert('engine4_core_content', array(
        'page_id' => $business_id,
        'type' => 'container',
        'name' => 'main',
        'parent_content_id' => null,
        'order' => 1,
        'params' => '',
    ));
    $container_id = $db->lastInsertId('engine4_core_content');

    $db->insert('engine4_core_content', array(
        'page_id' => $business_id,
        'type' => 'container',
        'name' => 'right',
        'parent_content_id' => $container_id,
        'order' => 1,
        'params' => '',
    ));
    $right_id = $db->lastInsertId('engine4_core_content');

    $db->insert('engine4_core_content', array(
        'page_id' => $business_id,
        'type' => 'container',
        'name' => 'middle',
        'parent_content_id' => $container_id,
        'order' => 3,
        'params' => '',
    ));
    $middle_id = $db->lastInsertId('engine4_core_content');

    // middle column content
    $db->insert('engine4_core_content', array(
        'page_id' => $business_id,
        'type' => 'widget',
        'name' => 'sitebusinessalbum.album-content',
        'parent_content_id' => $middle_id,
        'order' => 1,
        'params' => '',
    ));

    if ( $infomation && $rowinfo ) {
      Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.business-ads', $right_id, 1, "", "true");
    }
  }  

  $select = new Zend_Db_Select($db);
	$select
	->from('engine4_core_modules')
	->where('name = ?', 'mobi')
	->where('enabled 	 = ?', 1)
	->limit(1);
	;  

	$infomation = $select->query()->fetch();
	if(!empty($infomation)) {
		$select = new Zend_Db_Select($db);
		$select
		->from('engine4_core_pages')
		->where('name = ?', 'sitebusinessalbum_mobi_view')
		->limit(1);
		;
		$info = $select->query()->fetch();
		if (empty($info)) {
			$db->insert('engine4_core_pages', array(
						'name' => 'sitebusinessalbum_mobi_view',
						'displayname' => 'Mobile Business Album Profile',
						'title' => 'Mobile Business Album Profile',
						'description' => 'This is the mobile verison of a Business album profile business.',
						'custom' => 0,
			));
			$business_id = $db->lastInsertId('engine4_core_pages');

			// containers
			$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'main',
						'parent_content_id' => null,
						'order' => 1,
						'params' => '',
			));
			$container_id = $db->lastInsertId('engine4_core_content');

			$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'right',
						'parent_content_id' => $container_id,
						'order' => 1,
						'params' => '',
			));
			$right_id = $db->lastInsertId('engine4_core_content');

			$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $container_id,
						'order' => 3,
						'params' => '',
			));
			$middle_id = $db->lastInsertId('engine4_core_content');

			// middle column content
			$db->insert('engine4_core_content', array(
					'page_id' => $business_id,
					'type' => 'widget',
					'name' => 'sitebusinessalbum.album-content',
					'parent_content_id' => $middle_id,
					'order' => 1,
					'params' => '',
			));
		}
	}

  $select = new Zend_Db_Select($db);
$select
        ->from('engine4_core_pages')
        ->where('name = ?', 'sitebusiness_album_home')
        ->limit(1);
$info = $select->query()->fetch();
if (empty($info)) {
  $db->insert('engine4_core_pages', array(
      'name' => 'sitebusiness_album_home',
      'displayname' => 'Business Albums Home',
      'title' => 'Business Albums Home',
      'description' => 'This is business album home business.',
      'custom' => 1
  ));
  $business_id = $db->lastInsertId('engine4_core_pages');

  // containers
  $db->insert('engine4_core_content', array(
      'page_id' => $business_id,
      'type' => 'container',
      'name' => 'main',
      'parent_content_id' => null,
      'order' => 2,
      'params' => '',
  ));
  $container_id = $db->lastInsertId('engine4_core_content');

  $db->insert('engine4_core_content', array(
      'page_id' => $business_id,
      'type' => 'container',
      'name' => 'right',
      'parent_content_id' => $container_id,
      'order' => 5,
      'params' => '',
  ));
  $right_id = $db->lastInsertId('engine4_core_content');

  $db->insert('engine4_core_content', array(
      'page_id' => $business_id,
      'type' => 'container',
      'name' => 'left',
      'parent_content_id' => $container_id,
      'order' => 4,
      'params' => '',
  ));
  $left_id = $db->lastInsertId('engine4_core_content');

  $db->insert('engine4_core_content', array(
      'page_id' => $business_id,
      'type' => 'container',
      'name' => 'top',
      'parent_content_id' => null,
      'order' => 1,
      'params' => '',
  ));
  $top_id = $db->lastInsertId('engine4_core_content');

  $db->insert('engine4_core_content', array(
      'page_id' => $business_id,
      'type' => 'container',
      'name' => 'middle',
      'parent_content_id' => $top_id,
      'order' => 6,
      'params' => '',
  ));
  $top_middle_id = $db->lastInsertId('engine4_core_content');

  $db->insert('engine4_core_content', array(
      'page_id' => $business_id,
      'type' => 'container',
      'name' => 'middle',
      'parent_content_id' => $container_id,
      'order' => 6,
      'params' => '',
  ));
  $middle_id = $db->lastInsertId('engine4_core_content');

// Top Middle
  $db->insert('engine4_core_content', array(
      'page_id' => $business_id,
      'type' => 'widget',
      'name' => 'sitebusiness.browsenevigation-sitebusiness',
      'parent_content_id' => $top_middle_id,
      'order' => 3,
      'params' => '',
  ));
// Left
  $db->insert('engine4_core_content', array(
      'page_id' => $business_id,
      'type' => 'widget',
      'name' => 'sitebusinessalbum.photo-of-the-day',
      'parent_content_id' => $left_id,
      'order' => 8,
      'params' => '{"title":"Photo of the Day"}',
  ));

  $db->insert('engine4_core_content', array(
      'page_id' => $business_id,
      'type' => 'widget',
      'name' => 'sitebusinessalbum.featured-photos',
      'parent_content_id' => $left_id,
      'order' => 9,
      'params' => '{"title":"Featured Photos","titleCount":"true"}',
  ));

  $db->insert('engine4_core_content', array(
      'page_id' => $business_id,
      'type' => 'widget',
      'name' => 'sitebusiness.popularphotos-sitebusiness',
      'parent_content_id' => $left_id,
      'order' => 10,
      'params' => '{"title":"Most Popular Photos","titleCount":"true"}',
  ));

  $db->insert('engine4_core_content', array(
      'page_id' => $business_id,
      'type' => 'widget',
      'name' => 'sitebusinessalbum.homephotolike-sitebusiness',
      'parent_content_id' => $left_id,
      'order' => 11,
      'params' => '{"title":"Most Liked Photos","titleCount":"true"}',
  ));

  $db->insert('engine4_core_content', array(
      'page_id' => $business_id,
      'type' => 'widget',
      'name' => 'sitebusinessalbum.homephotocomment-sitebusiness',
      'parent_content_id' => $left_id,
      'order' => 12,
      'params' => '{"title":"Most Commented Photos","titleCount":"true"}',
  ));

  // Middle
  $db->insert('engine4_core_content', array(
      'page_id' => $business_id,
      'type' => 'widget',
      'name' => 'sitebusinessalbum.featured-albums-slideshow',
      'parent_content_id' => $middle_id,
      'order' => 13,
      'params' => '{"title":"Featured Albums","titleCount":"true"}',
  ));

// Middele
  $db->insert('engine4_core_content', array(
      'page_id' => $business_id,
      'type' => 'widget',
      'name' => 'sitebusinessalbum.featured-photos-carousel',
      'parent_content_id' => $middle_id,
      'order' => 14,
      'params' => '{"title":"Featured Photos","vertical":"0", "noOfRow":"2","inOneRow":"3","interval":"250","name":"sitebusinessalbum.featured-photos-carousel"}',
  ));

  $db->insert('engine4_core_content', array(
      'page_id' => $business_id,
      'type' => 'widget',
      'name' => 'sitebusinessalbum.list-photos-tabs-view',
      'parent_content_id' => $middle_id,
      'order' => 15,
      'params' => '{"title":"Photos","margin_photo":"12"}',
  ));

  $db->insert('engine4_core_content', array(
      'page_id' => $business_id,
      'type' => 'widget',
      'name' => 'sitebusinessalbum.list-albums-tabs-view',
      'parent_content_id' => $middle_id,
      'order' => 16,
      'params' => '{"title":"Albums","margin_photo":"12"}',
  ));
  // Right Side
  $db->insert('engine4_core_content', array(
      'page_id' => $business_id,
      'type' => 'widget',
      'name' => 'sitebusinessalbum.sitebusinessalbumlist-link',
      'parent_content_id' => $right_id,
      'order' => 18,
      'params' => '',
  ));

   // Right Side
  $db->insert('engine4_core_content', array(
      'page_id' => $business_id,
      'type' => 'widget',
      'name' => 'sitebusinessalbum.search-sitebusinessalbum',
      'parent_content_id' => $right_id,
      'order' => 17,
      'params' => '',
  ));

  $db->insert('engine4_core_content', array(
      'page_id' => $business_id,
      'type' => 'widget',
      'name' => 'sitebusinessalbum.album-of-the-day',
      'parent_content_id' => $right_id,
      'order' => 19,
      'params' => '{"title":"Album of the Day"}',
  ));

  $db->insert('engine4_core_content', array(
      'page_id' => $business_id,
      'type' => 'widget',
      'name' => 'sitebusinessalbum.featured-albums',
      'parent_content_id' => $right_id,
      'order' => 20,
      'params' => '{"title":"Featured Albums","itemCountPerBusiness":4}',
  ));

  $db->insert('engine4_core_content', array(
      'page_id' => $business_id,
      'type' => 'widget',
      'name' => 'sitebusinessalbum.list-popular-albums',
      'parent_content_id' => $right_id,
      'order' => 21,
      'params' => '{"title":"Most Liked Albums","itemCountPerBusiness":"4","popularType":"like","name":"sitebusinessalbum.list-popular-albums"}',
  ));
  $db->insert('engine4_core_content', array(
      'page_id' => $business_id,
      'type' => 'widget',
      'name' => 'sitebusinessalbum.list-popular-albums',
      'parent_content_id' => $right_id,
      'order' => 22,
      'params' => '{"title":"Popular Albums","itemCountPerBusiness":"4","popularType":"view","name":"sitebusinessalbum.list-popular-albums"}',
  ));
}
}
?>