<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessalbum
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$isActive = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessalbum.isActivate', 0);
if ( empty($isActive) ) {
  return;
}

$categories = Engine_Api::_()->getDbTable('categories', 'sitebusiness')->getCategories();
if (count($categories) != 0) {
  $categories_prepared[0] = "";
  foreach ($categories as $category) {
    $categories_prepared[$category->category_id] = $category->category_name;
  }
}
$showContent_cover = array("mainPhoto" => "Business Profile Photo", "title" => "Business Title", "followButton" => "Follow Button", "likeButton" => "Like Button", "likeCount" => "Total Likes","followCount" => "Total Followers");
$showContent_option = array("mainPhoto", "title", "followButton", "likeButton", "followCount", "likeCount");
if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember')) {
	$showContent_cover['memberCount'] = 'Total Members';
	$showContent_cover['addButton'] = 'Add People Button';
	$showContent_cover['joinButton'] = 'Join Business Button';
	$showContent_cover['leaveButton'] = 'Leave Business Button';
	$showContent_option[] = 'addButton';
	$showContent_option[] = 'joinButton';
	$showContent_option[] = 'leaveButton';
	$showContent_option[] = 'memberCount';
}
$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => 'Business Profile Albums',
        'description' => 'This widget forms the Albums tab on the Business Profile and displays the albums of the Business. It also displays the photos added by the Business visitors other than the owner. It should be placed in the Tabbed Blocks area of the Business Profile.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusiness.photos-sitebusiness',
        'defaultParams' => array(
            'title' => 'Photos',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of albums to show)',
                        'value' => 10,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
               array(
                    'Text',
                    'itemCount_photo',
                    array(
                        'label' => 'Count',
                        'description' => '(number of photos to show in album)',
                        'value' => 100,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
    array(
        'title' => 'Business Profile Random Albums',
        'description' => 'Displays random albums and photos of Business on its Profile.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusiness.albums-sitebusiness',
        'defaultParams' => array(
            'title' => 'Albums',
            'titleCount' => '',
        ),
    ),
    array(
        'title' => 'Business Profile Most Commented Photos',
        'description' => 'Displays list of business’s most commented photos. This widget should be placed on the Business Profile.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusiness.photocomment-sitebusiness',
        'defaultParams' => array(
            'title' => 'Most Commented Photos',
            'titleCount' => '',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of photos to show)',
                        'value' => 4,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
    array(
        'title' => 'Business Profile Most Liked Photos',
        'description' => 'Displays list of business’s most liked photos. This widget should be placed on the Business Profile.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusiness.photolike-sitebusiness',
        'defaultParams' => array(
            'title' => 'Most Liked Photos',
            'titleCount' => '',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of photos to show)',
                        'value' => 4,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
    array(
        'title' => 'Business Profile Photos Strip',
        'description' => "Displays some photos out of all the albums of a Business in a strip. Business Admin can choose which photos to be shown in the strip by hiding the ones that should not be displayed. Hidden photos are replaced by new photos and so on. This widget should be placed on the Business Profile.",
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusiness.photorecent-sitebusiness',
        'defaultParams' => array(
            'title' => "",
            'titleCount' => "",
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of photos to show)',
                        'value' => 7,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),

    array(
        'title' => 'Recent Photos',
        'description' => 'Displays list of recent photos of businesses on the site.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.mostrecentphotos-sitebusiness',
        'defaultParams' => array(
            'title' => 'Recent Photos',
            'titleCount' => '',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of photos to show)',
                        'value' => 4,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
                    'Radio',
                    'showBusinessName',
                    array(
                        'label' => 'Do you want to show the Business name along with the photos ?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 0,
                    )
                ),
               array(
                    'Radio',
                    'showUserName',
                    array(
                        'label' => "Do you want to show the 'display name' of user who has uploaded the photo ?",
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 0,
                    )
                ),
                array(
                    'Radio',
                    'showFullPhoto',
                    array(
                        'label' => "Do you want to show large size thumbnails of photos ?",
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 0,
                    )
                ),
            ),
        ),
    ),

    array(
			'title' => 'Search Business Albums form',
			'description' => 'Displays the form for searching Business Albums on the basis of various filters. You can edit the fields to be available in this form.',
			'category' => 'Businesses',
			'type' => 'widget',
			'name' => 'sitebusinessalbum.search-sitebusinessalbum',
			'defaultParams' => array(
					'title' => '',
          'search_column' => array("0" => "1", "1" => "2", "2" => "3", "3" => "4", "4" => '5'),
					'titleCount' => true,

			),
			'adminForm' => array(
              'elements' => array(
							array(
									'MultiCheckbox',
									'search_column',
									array(
											'label' => 'Choose the fields that you want to be available in the Search Business Albums form widget.',
											'multiOptions' => array("1" => "Show","2" => "Browse By", "3" => "Business Title", "4" => "Album Title", "5" => "Business Category"),
									),
							),
					),
			)
    ),

    array(
        'title' => 'Business Albums',
        'description' => 'Displays the list of Albums from Businesses created on your community. This widget should be placed in the widgetized Business Albums business. Results from the Search Business Albums form are also shown here.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessalbum.sitebusiness-album',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of albums to show)',
                        'value' => 20,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),

    array(
        'title' => 'Sponsored Albums',
        'description' => 'Displays the Albums from Paid Businesses. You can choose the number of entries to be shown.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessalbum.sitebusiness-sponsoredalbum',
        'defaultParams' => array(
            'title' => 'Sponsored Albums',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of albums to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
						    ),
            ),
        ),
    ),

    array(
			'title' => 'Business Album View',
			'description' => "This widget should be placed on the Business Album View Page.",
      'category' => 'Businesses',
			'type' => 'widget',
			'name' => 'sitebusinessalbum.album-content',
			'defaultParams' => array(
					'title' => '',
					'titleCount' => true,
			),
			'adminForm' => array(
					'elements' => array(
							array(
									'Radio',
									'photosorder',
									array(
											'label' => 'Select the order below to display the photos on your site.',
											'multiOptions' => array(
													1 => 'Newer to older',
													0 => 'Older to newer'
											),
											'value' => 1,
									)
							),
					),
			),
	),

  array(
        'title' => 'Business’s Photo of the Day',
        'description' => 'Displays the Photo of the Day as selected by the Admin from the Photo of the Day section of Directory / Businesses - Albums Plugin.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessalbum.photo-of-the-day',
        'defaultParams' => array(
            'title' => 'Photo of the Day'
        ),
  ),

  array(
        'title' => 'Most Liked Photos',
        'description' => 'Displays list of business’s most liked photos.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessalbum.homephotolike-sitebusiness',
        'defaultParams' => array(
            'title' => 'Most Liked Photos',
            'titleCount' => '',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of photos to show)',
                        'value' => 4,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
						    ),
                array(
                    'Radio',
                    'showBusinessName',
                    array(
                        'label' => 'Do you want to show the Business name along with the photos ?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 0,
                    )
                ),
               array(
                    'Radio',
                    'showUserName',
                    array(
                        'label' => "Do you want to show the 'display name' of user who has uploaded the photo ?",
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 0,
                    )
                ),
               array(
                    'Radio',
                    'showFullPhoto',
                    array(
                        'label' => "Do you want to show large size thumbnails of photos ?",
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 0,
                    )
                ),
            ),
        ),
    ),
   
    array(
        'title' => 'Most Commented Photos',
        'description' => 'Displays list of business’s most commented photos.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessalbum.homephotocomment-sitebusiness',
        'defaultParams' => array(
            'title' => 'Most Commented Photos',
            'titleCount' => '',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of photos to show)',
                        'value' => 4,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
						    ),
                array(
                    'Radio',
                    'showBusinessName',
                    array(
                        'label' => 'Do you want to show the Business name along with the photos ?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 0,
                    )
                ),
               array(
                    'Radio',
                    'showUserName',
                    array(
                        'label' => "Do you want to show the 'display name' of user who has uploaded the photo ?",
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 0,
                    )
                ),
               array(
                    'Radio',
                    'showFullPhoto',
                    array(
                        'label' => "Do you want to show large size thumbnails of photos ?",
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 0,
                    )
                ),
            ),
        ),
    ),

    array(
        'title' => 'Most Commented Photos',
        'description' => 'Displays list of business’s most commented photos.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.homephotocomment-sitebusiness',
        'defaultParams' => array(
            'title' => 'Most Commented Photos',
            'titleCount' => '',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of photos to show)',
                        'value' => 4,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),

    array(
        'title' => 'Business’s Featured Photos',
        'description' => 'Displays Featured Photos as chosen by you. You can set the count of the number of photos to show in this widget. If the total number of photos featured are more than that count, then the photos to be displayed will be randomly picked up.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessalbum.featured-photos',
        'defaultParams' => array(
            'title' => 'Featured Photos',
            'itemCountPerBusiness' => 4,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCountPerBusiness',
                    array(
                        'label' => 'Count',
                        'description' => '(number of photos to show)',
                        'value' => 4,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
						    ),
            ),
        ),
    ),

    array(
        'title' => 'Business’s Featured Photos Carousel',
        'description' => 'This widget contains an attractive AJAX based carousel, showcasing the featured photos on the site. Multiple settings of this widget makes it highly configurable.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessalbum.featured-photos-carousel',
        'defaultParams' => array(
            'title' => 'Featured Photos',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Radio',
                    'vertical',
                    array(
                        'label' => 'Carousel Type',
                        'multiOptions' => array(
                            '0' => 'Horizontal',
                            '1' => 'Vertical',
                        ),
                        'value' => 0,
                    )
                ),
                array(
                    'Text',
                    'inOneRow',
                    array(
                        'label' => 'Photos in a Row',
                        'description' => '(number of photos to show in one row. Note: This field is applicable only when you have selected ‘Horizontal’ in ‘Carousel Type’ field.)',
                        'value' => 3,
                    )
                ),
                array(
                    'Text',
                    'noOfRow',
                    array(
                        'label' => 'Rows',
                        'description' => '(number of rows in one view)',
                        'value' => 2,
                    )
                ),
                array(
                    'Text',
                    'interval',
                    array(
                        'label' => 'Speed',
                        'description' => '(transition interval between two slides in millisecs)',
                        'value' => 250,
                    )
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
						    ),
            ),
        ),
    ),

    array(
        'title' => 'Business’s Ajax based Tabbed widget for Photos',
        'description' => ' Displays the Recent, Most Liked, Most Viewed, Most Commented and Featured Photos in separate AJAX based tabs. Settings for this widget are available in the Widget Settings section of Directory / Businesses - Albums Extension.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessalbum.list-photos-tabs-view',
        'defaultParams' => array(
            'title' => 'Photos',
            'margin_photo'=>12,
            'showViewMore'=>1
        ),
         'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'margin_photo',
                    array(
                        'label' => 'Horizontal Margin between Elements',
                        'description' => '(Horizontal margin in px between consecutive elements in this widget. You might want to change this value if the content of this widget is not coming properly on your site because of the column width in your theme.)',
                        'value' => 12,
                    )
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
						    ),
                 array(
                    'Radio',
                    'showViewMore',
                    array(
                        'label' => 'Show "View More" link',
                        'multiOptions' => array(                          
                            '1' => 'Yes',
                            '0' => 'No',
                        ),                       
                    )
                )
            ),
        ),
    ),

    array(
        'title' => 'Business’s Ajax based Tabbed widget for Albums',
        'description' => ' Displays the Recent, Most Liked, Most Viewed, Most Commented and Featured Albums in separate AJAX based tabs. Settings for this widget are available in the Widget Settings section of Directory / Businesses - Albums Extension.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessalbum.list-albums-tabs-view',
        'defaultParams' => array(
            'title' => 'Albums',
            'margin_photo'=>12,
            'showViewMore'=>1
        ),
         'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'margin_photo',
                    array(
                        'label' => 'Horizontal Margin between Elements',
                        'description' => '(Horizontal margin in px between consecutive elements in this widget. You might want to change this value if the content of this widget is not coming properly on your site because of the column width in your theme.)',
                        'value' => 12,
                    )
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
						    ),
                 array(
                  'Radio',
                  'showViewMore',
                  array(
                      'label' => 'Show "View More" link',
                      'multiOptions' => array(
                          '1' => 'Yes',
                          '0' => 'No',
                      ),
                  )
              )
            ),
        ),
    ),

    array(
        'title' => 'Business’s Featured Albums',
        'description' => 'Displays Featured Albums as chosen by you. You can set the count of the number of albums to show in this widget. If the total number of albums featured are more than that count, then the albums to be displayed will be randomly picked up.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessalbum.featured-albums',
        'defaultParams' => array(
            'title' => 'Featured Albums',
            'itemCountPerBusiness' => 4,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCountPerBusiness',
                    array(
                        'label' => 'Count',
                        'description' => '(number of albums to show)',
                        'value' => 4,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
						    ),
            ),
        ),
    ),

    array(
        'title' => 'Business’s Featured Albums Slideshow',
        'description' => 'Displays featured albums in an attractive slideshow. You can set the count of the number of albums to show in this widget. If the total number of albums featured are more than that count, then the albums to be displayed will be sequentially picked up.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessalbum.featured-albums-slideshow',
        'isPaginated' => true,
        'defaultParams' => array(
            'title' => 'Featured Albums',
            'itemCountPerBusiness' => 10,
        ),
        'adminForm' => array(
					'elements' => array(
							array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
			  ),
    ),

    array(
        'title' => 'Business’s Popular Albums',
        'description' => 'Displays most popular albums. There is a setting for the parameter for popularity such as Views, Comments and Likes.',
         'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessalbum.list-popular-albums',
        'isPaginated' => true,
        'defaultParams' => array(
            'title' => 'Popular Albums',
            'itemCountPerBusiness' => 4,
        ),
        'requirements' => array(
            'no-subject',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCountPerBusiness',
                    array(
                        'label' => 'Count',
                        'description' => '(number of albums to show)',
                        'value' => 4,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
						    ),
                array(
                    'Radio',
                    'popularType',
                    array(
                        'label' => 'Popular Type',
                        'multiOptions' => array(
                            'view' => 'Views',
                            'comment' => 'Comments',
                            'like' => 'Likes',
                        ),
                        'value' => 'comment',
                    )
                ),
            )
        ),
    ),

		array(
        'title' => 'Most Popular Photos',
        'description' => 'Displays list of most popular photos on the site.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.popularphotos-sitebusiness',
        'defaultParams' => array(
            'title' => 'Most Popular Photos',
            'titleCount' => '',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of photos to show)',
                        'value' => 4,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							  ),
                array(
                    'Radio',
                    'showBusinessName',
                    array(
                        'label' => 'Do you want to show the Business name along with the photos ?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 0,
                    )
                ),
               array(
                    'Radio',
                    'showUserName',
                    array(
                        'label' => "Do you want to show the 'display name' of user who has uploaded the photo ?",
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 0,
                    )
                ),
               array(
                    'Radio',
                    'showFullPhoto',
                    array(
                        'label' => "Do you want to show large size thumbnails of photos ?",
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 0,
                    )
                ),
            ),
        ),
    ),
    
    array(
        'title' => 'Business Albums Browse Business',
        'description' => 'Displays the link to view Business’s Albums Browse business.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessalbum.sitebusinessalbumlist-link',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
    ),

    array(
        'title' => 'Business’s Album of the Day',
        'description' => 'Displays the Album of the Day as selected by the Admin from the widget settings section of Directory / Businesses - Albums Extension.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessalbum.album-of-the-day',
        'defaultParams' => array(
            'title' => 'Album of the Day'
        ),
    ),

    array(
    'title' => 'Top Creators : Business Albums',
    'description' => 'Displays the Businesses which have the most number of Business Albums added in them. Motivates Business Admins to add more content on your website.',
    'category' => 'Businesses',
    'type' => 'widget',
    'name' => 'sitebusinessalbum.topcreators-sitebusinessalbum',
   // 'isPaginated' => true,
    'defaultParams' => array(
      'title' => 'Top Creators',
    ),
     'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of elements to show)',
										'value' => 5,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
						),
					),
        ),
    'requirements' => array(
      'subject' => 'sitebusinessalbum',
    ),
  ),



    array(
        'title' => 'Business Profile Cover Photo and Information',
        'description' => 'Displays the business cover photo with business profile photo, title and various action links that can be performed on the business from their Profile business (Like, Follow, etc.). You can choose various options from the Edit Settings of this widget. This widget should be placed on the Business Profile business.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusiness.business-cover-information-sitebusiness',
        'defaultParams' => array(
            'title' => 'Information',
            'titleCount' => true,
            'showContent' => $showContent_option
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'MultiCheckbox',
                    'showContent',
                    array(
                        'label' => 'Select the information options that you want to be available in this block.',
                        'multiOptions' => $showContent_cover,
                    ),
                ), 
                array(
                    'Text',
                    'columnHeight',
                    array(
                        'label' => 'Enter the cover photo height (in px). (Minimum 150 px required.)',
                        'value' => '300',
                    )
                ),             
            ),
        ),
    ),
)
?>