<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessalbum
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-08-026 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessalbum_Widget_FeaturedPhotosController extends Engine_Content_Widget_Abstract {

  public function indexAction() {

    $category_id = $this->_getParam('category_id',0);
    // Get paginator
    $parentTable = Engine_Api::_()->getItemTable('sitebusiness_album');
    $parentTableName = $parentTable->info('name');
    $tableBusiness = Engine_Api::_()->getDbtable('business', 'sitebusiness');
    $tableBusinessName = $tableBusiness->info('name');
    $table = Engine_Api::_()->getItemTable('sitebusiness_photo');
    $tableName = $table->info('name');
    $select = $table->select()
                    ->setIntegrityCheck(false)
                    ->from($tableName);
    if (!Engine_Api::_()->sitebusiness()->isLessThan417AlbumModule()) {
      $select->joinLeft($parentTableName, $parentTableName . '.album_id=' . $tableName . '.album_id', array('title AS album_title'));
    } else {
      $select->joinLeft($parentTableName, $parentTableName . '.album_id=' . $tableName . '.collection_id', array('title AS album_title'));
    }
    $select->joinLeft($tableBusinessName, "$tableBusinessName.business_id = $tableName.business_id", array('title AS business_title', 'photo_id as business_photo_id'));
    $select ->where($tableName . '.featured = ?', 1)
            ->order('Rand()');

    $select = $select
              ->where($tableBusinessName . '.closed = ?', '0')
              ->where($tableBusinessName . '.approved = ?', '1')
              ->where($tableBusinessName . '.declined = ?', '0')
              ->where($tableBusinessName . '.draft = ?', '1');

    if(!empty($category_id)) {
      $select->where($tableBusinessName . '.	category_id =?', $category_id);
    }
    
    if(!Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessalbum.hide.autogenerated', 1) ) {
			$select->where($parentTableName. '.default_value'.'= ?', 0);
			$select->where($parentTableName . ".type is Null");
    }     
    
    $this->view->paginator = $paginator = Zend_Paginator::factory($select);
		
    // Set item count per business and current business number
    $paginator->setItemCountPerPage($this->_getParam('itemCountPerBusiness', 4));
    $paginator->setCurrentPageNumber($this->_getParam('business', 1));


    // Do not render if nothing to show
    if (($paginator->getTotalItemCount() <= 0)) {
      return $this->setNoRender();
    }
    $this->view->showLightBox = Engine_Api::_()->sitebusiness()->canShowPhotoLightBox();
    if ($this->view->showLightBox) {
      $this->view->params = $params = array('type' => 'featured', 'count' => $paginator->getTotalItemCount(), 'title' => $this->_getParam('title', 'Featured Photos'));
    }
  }

}
?>