<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessalbum
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-08-026 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessalbum_Widget_ListPopularAlbumsController extends Engine_Content_Widget_Abstract {

  public function indexAction() {
  
    $category_id = $this->_getParam('category_id',0);
    // Should we consider views or comments popular?
    $popularType = $this->_getParam('popularType', 'comment');
    if (!in_array($popularType, array('comment', 'view', 'like'))) {
      $popularType = 'comment';
    }
    $this->view->popularType = $popularType;
    $this->view->popularCol = $popularCol = $popularType . '_count';
    //$popularAlbum = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitealbum.badgeviewer', null);
    // Get paginator
    $tableBusiness = Engine_Api::_()->getDbtable('business', 'sitebusiness');
    $tableBusinessName = $tableBusiness->info('name');
    $table = Engine_Api::_()->getItemTable('sitebusiness_album');
    $tableName = $table->info('name');
    $select = $table->select()
                    ->setIntegrityCheck(false)
                    ->from($tableName)
                    ->joinLeft($tableBusinessName, "$tableBusinessName.business_id = $tableName.business_id", array('title AS business_title', 'photo_id as business_photo_id'))
                    ->order($popularCol . ' DESC');
    $select = $select
              ->where($tableBusinessName . '.closed = ?', '0')
              ->where($tableBusinessName . '.approved = ?', '1')
              ->where($tableBusinessName . '.declined = ?', '0')
              ->where($tableBusinessName . '.draft = ?', '1');

    if(!empty($category_id)) {
      $select->where($tableBusinessName . '.	category_id =?', $category_id);
    }
    
    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
      $select->where($tableBusinessName . '.expiration_date  > ?', date("Y-m-d H:i:s"));
    }  
    
    if(!Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessalbum.hide.autogenerated', 1) ) {
			$select->where($tableName. '.default_value'.'= ?', 0);
			$select->where($tableName . ".type is Null");
    }     

    //if (!Engine_Api::_()->sitealbum()->canShowSpecialAlbum())
      //$select->where('type IS NULL');
    $this->view->paginator = $paginator = Zend_Paginator::factory($select);

    // Set item count per business and current business number
    $paginator->setItemCountPerPage($this->_getParam('itemCountPerBusiness', 4));
    $paginator->setCurrentPageNumber($this->_getParam('business', 1));

    // Do not render if nothing to show
    if (($paginator->getTotalItemCount() <= 0)) {
      return $this->setNoRender();
    }
  }

}