<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessbadge
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Badges.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessbadge_Model_DbTable_Badges extends Engine_Db_Table {

  protected $_rowClass = "Sitebusinessbadge_Model_Badge";

	/**
   * Return badge data
   *
   * @param Int business_id
   * @return Zend_Db_Table_Select
   */
	public function getBadgesData($params = array(),$totalBadges = null) {

		$badgeTableName = $this->info('name');
		$businessTable = Engine_Api::_()->getDbTable('business', 'sitebusiness');
		$businessTableName = $businessTable->info('name');
		
		if(isset($params['popular_badges']) && !empty($params['popular_badges'])) {
			$total_sitebusinessbadges = Engine_Api::_()->getApi('settings', 'core')->sitebusinessbadge_popular_widgets;

			$total_sitebusinessbadges = $params['totalbadges'];
			$select = $this->select()
											->setIntegrityCheck(false)
											->from($badgeTableName)
											->joinLeft($businessTableName, "$businessTableName.badge_id = $badgeTableName.badge_id", array('COUNT(engine4_sitebusiness_businesses.badge_id) AS Frequency'))
											->group($businessTableName . '.badge_id')
											->order('Frequency DESC')
											->order($badgeTableName . '.creation_date DESC')
											->limit($total_sitebusinessbadges);

			$select = $select
											->where($businessTableName . '.search = ?', '1')
											->where($businessTableName . '.closed = ?', '0')
											->where($businessTableName . '.approved = ?', '1')
											->where($businessTableName . '.declined = ?', '0')
											->where($businessTableName . '.draft = ?', '1');
      if (isset($params['category_id']) && !empty($params['category_id'])) {
				$select = $select->where($businessTableName . '.	category_id =?', $params['category_id']);
			}
			if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
				$select->where($businessTableName . '.expiration_date  > ?', date("Y-m-d H:i:s"));
			}

			//Start Network work
      $select = $businessTable->getNetworkBaseSql($select, array('not_groupBy' => 1));
			//End Network work

			return $this->fetchAll($select);

		}
		else {
      if (isset($params['category_id']) && !empty($params['category_id'])) {
        $select = $this->select()
                  ->setIntegrityCheck(false)
                  ->from($badgeTableName)
									->join($businessTableName, "$businessTableName.badge_id = $badgeTableName.badge_id", array())
									->where($businessTableName . '.	category_id =?', $params['category_id'])
                  ->order($badgeTableName. '.creation_date DESC');
			}
      else {
				//MAKE QUERY
				$select = $this->select()->order('creation_date DESC');
      }
      $select->limit($totalBadges);
			if(isset($params['search_code']) && !empty($params['search_code'])) {
				$select->from($badgeTableName, array('badge_id', 'title'));
			}

			//FETCH RESULTS
			return $this->fetchAll($select);
		}
  }

}
?>