<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessbadge
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$isActive = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessbadge.isActivate', 0);
if (empty($isActive)) {
  return;
}

$categories = Engine_Api::_()->getDbTable('categories', 'sitebusiness')->getCategories();
if (count($categories) != 0) {
  $categories_prepared[0] = "";
  foreach ($categories as $category) {
    $categories_prepared[$category->category_id] = $category->category_name;
  }
}

$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
	array(
			'title' => 'Most Popular Badges',
			'description' => 'Displays list of most popular badges for businesses on the site.',
			'category' => 'Businesses',
			'type' => 'widget',
			'name' => 'sitebusinessbadge.popular-sitebusinessbadge',
			'defaultParams' => array(
					'title' => 'Most Popular Badges',
					'titleCount' => true,
			),
				'adminForm' => array(
					'elements' => array(
							array(
									'Text',
									'itemCount',
									array(
											'label' => 'Count',
											'description' => '(number of badges to show)',
											'value' => 3,
											'validators' => array(
												array('Int', true),
												array('GreaterThan', true, array(0)),
											),
									),
							),
              array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
						  ),
					),
			),
	),
	array(
			'title' => 'Business Profile Badge',
			'description' => 'Displays the badge, which has been assigned to a Business, on it\'s profile.',
			'category' => 'Business Profile',
			'type' => 'widget',
			'name' => 'sitebusinessbadge.badge-sitebusinessbadge',
			'defaultParams' => array(
					'title' => 'Badge',
					'titleCount' => true,
			),
	),

	array(
			'title' => 'Business Badges',
			'description' => 'Displays a list of all the businesses badge on site. This widget should be placed on the  Businesses badge business.',
			'category' => 'Businesses',
			'type' => 'widget',
			'name' => 'sitebusinessbadge.sitebusiness-badge',
			'defaultParams' => array(
					'title' => '',
					'titleCount' => true,
			),
			'adminForm' => array(
					'elements' => array(
							array(
									'Text',
									'itemCount',
									array(
											'label' => 'Count',
											'description' => '(number of badges to show)',
											'value' => 20,
											'validators' => array(
												array('Int', true),
												array('GreaterThan', true, array(0)),
											),
									),
							),
              array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
						  ),
					),
			),
	),
)
?>