<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessdiscussion
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$isActive = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessdiscussion.isActivate', 0);
if (empty($isActive)) {
  return;
}
$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => 'Business Profile Discussions',
        'description' => 'This widget forms the Discussions tab on the Business Profile and displays the discussions of the Business. It should be placed in the Tabbed Blocks area of the Business Profile.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusiness.discussion-sitebusiness',
        'defaultParams' => array(
            'title' => 'Discussions',
            'titleCount' => true,
        ),
    ),
    
    array(
        'title' => 'Business Discussion Topic View',
        'description' => "This widget should be placed on the Business Discussion Topic View Business.",
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.discussion-content',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
			'adminForm' => array(
					'elements' => array(
							array(
									'Radio',
									'postorder',
									array(
											'label' => 'Select the order below to display the posts on your site.',
											'multiOptions' => array(
													1 => 'Newer to older',
													0 => 'Older to newer'
											),
											'value' => 0,
									)
							),
					),
			),
      
    ),    
    
    array(
        'title' => 'Business Content Profile Discussions',
        'description' => 'This widget forms the Discussions tab on the Business Content Profile and displays the discussions of the Business Content. It should be placed in the Tabbed Blocks area of the Business Content Profile.',
        'category' => 'Business Content Profile',
        'type' => 'widget',
        'name' => 'sitebusiness.profile-discussions',
        'defaultParams' => array(
            'title' => 'Discussions',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => 'Most Discussed Businesses',
        'description' => 'Displays list of Businesses having maximum number of discussions.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.mostdiscussion-sitebusiness',
        'defaultParams' => array(
            'title' => 'Most Discussed Businesses',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of businesses to show)',
                        'value' => 4,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
                    'Select',
                    'category_id',
                    array(
                        'label' => 'Category',
                        'multiOptions' => $categories_prepared,
                    )
                ),
                array(
                    'Select',
                    'featured',
                    array(
                        'label' => 'Featured',
                        'multiOptions' => array(
                            0 => '',
                            2 => 'Yes',
                            1 => 'No',
                        ),
                    )
                ),
                array(
                    'Select',
                    'sponsored',
                    array(
                        'label' => 'Sponsored',
                        'multiOptions' => array(
                            0 => '',
                            2 => 'Yes',
                            1 => 'No',
                        ),
                    )
                ),
            ),
        ),
    ),
)
?>