<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessdocument
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Widget.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessdocument_Form_Admin_Widget extends Engine_Form {

  public function init() {
    $this
            ->setTitle('Widget Settings')
            ->setDescription('Configure the general settings for the various widgets available with this plugin.');

    $this->addElement('Text', 'sitebusinessdocument_comment_widgets', array(
        'label' => 'Business Profile Most Commented Documents',
        'maxlength' => '3',
        'description' => 'How many documents should be shown in the business profile most commented documents widget (value cannot be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessdocument.comment.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'sitebusinessdocument_like_widgets', array(
        'label' => 'Business Profile Most Liked Documents',
        'maxlength' => '3',
        'description' => 'How many documents should be shown in the business profile most liked documents widget (value cannot be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessdocument.like.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'sitebusinessdocument_featurelist_widgets', array(
        'label' => 'Business Profile Featured Documents',
        'maxlength' => '3',
        'description' => 'How many documents should be shown in the business profile featured documents widget (value cannot be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessdocument.featurelist.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'sitebusinessdocument_popular_widgets', array(
        'label' => 'Business Profile Popular Documents',
        'maxlength' => '3',
        'description' => 'How many documents should be shown in the business profile popular documents widget (value cannot be empty or zero) ? [Note: Popularity here is based on the number of views.]',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessdocument.popular.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'sitebusinessdocument_rate_widgets', array(
        'label' => 'Business Profile Top Rated Documents',
        'maxlength' => '3',
        'description' => 'How many documents should be shown in the top business profile top rated documents widget (value cannot be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessdocument.rate.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'sitebusinessdocument_recent_widgets', array(
        'label' => 'Business Profile Recent Documents',
        'maxlength' => '3',
        'description' => 'How many documents should be shown in the business profile recent documents widget (value cannot be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessdocument.recent.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Button', 'submit', array(
        'label' => 'Save Changes',
        'type' => 'submit',
        'ignore' => true
    ));
  }

}
?>