<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Menus.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessdocument_Plugin_Menus {

  public function canViewDocuments() {

    if (!Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessdocument.document.show.menu', 1)) {
      return false;
    }

    $table = Engine_Api::_()->getDbtable('documents', 'sitebusinessdocument');
    $rName = $table->info('name');
    $table_businesses = Engine_Api::_()->getDbtable('business', 'sitebusiness');
    $rName_businesses = $table_businesses->info('name');
    $select = $table->select()
                    ->setIntegrityCheck(false)
                    ->from($rName_businesses, array(''))
                    ->join($rName, $rName . '.business_id = ' . $rName_businesses . '.business_id')
                    ->where($rName .'.approved = ?', 1)
										->where($rName .'.draft = ?', 0)
										->where($rName .'.status = ?', 1)
										->where($rName .'.search = ?', 1);
    $select = $select
                    ->where($rName_businesses . '.closed = ?', '0')
                    ->where($rName_businesses . '.approved = ?', '1')
                    ->where($rName_businesses . '.search = ?', '1')
                    ->where($rName_businesses . '.declined = ?', '0')
                    ->where($rName_businesses . '.draft = ?', '1');
    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
      $select->where($rName_businesses . '.expiration_date  > ?', date("Y-m-d H:i:s"));
    }
    $row = $table->fetchAll($select);
    $count = count($row);
    if (empty($count)) {
      return false;
    }
    return true;
  }

   //ADD BUSINESS DOCUMENT LISTING LINK
  public function onMenuInitialize_SitebusinessdocumentGutterBusiness() {

		//GETTING THE VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();

    //GETTING THE TAB ID
    $tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab', null);

    //GETTING THE SITEBUSINESSDOCUMENT SUBJECT
    $sitebusinessdocument = Engine_Api::_()->getItem('sitebusinessdocument_document', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'));
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $sitebusinessdocument->business_id);   

    if ($sitebusinessdocument->getType() !== 'sitebusinessdocument_document') {
      return false;
    }

   $business_url = $sitebusiness->getHref(array('tab' => $tab_selected_id));

    //RETURN BACK TO BUSINESS LINK
    return array(
        'class' => 'buttonlink  icon_sitebusinessdocument_back',
        'uri' =>  $business_url
        
    );
  }

	//ADD BUSINESS DOCUMENT PUBLISH LINK
  public function onMenuInitialize_SitebusinessdocumentGutterPublish() {

		//GETTING THE VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();    
 
    //GETTING THE TAB ID
    $tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab', null);

    //GETTING THE SITEBUSINESSDOCUMENT SUBJECT
    $sitebusinessdocument = Engine_Api::_()->getItem('sitebusinessdocument_document', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'));
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $sitebusinessdocument->business_id);   

    //START MANAGE-ADMIN CHECK
		$isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK

    if ($sitebusinessdocument->getType() !== 'sitebusinessdocument_document' || empty($viewer_id) || empty($sitebusinessdocument->draft)) {
      return false;
    }

    //USER IS ALLOWED FOR DELETE OR NOT
		if(empty($can_edit) || ($viewer_id != $sitebusinessdocument->owner_id)) {
			return false;
		}

    return array(
        'class' => 'buttonlink smoothbox icon_sitebusinessdocument_publish',
        'route' => 'sitebusinessdocument_publish',
        'params' => array(
            'document_id' => $sitebusinessdocument->getIdentity(),
						'tab' => $tab_selected_id
        ),
    );
  }

	//ADD BUSINESS DOCUMENT EDIT LINK
  public function onMenuInitialize_SitebusinessdocumentGutterEdit($row) {

		 //GETTING THE VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();    
   
    $sitebusinessdocument = Engine_Api::_()->getItem('sitebusinessdocument_document', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'));

    //GETTING THE TAB ID
    $tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab', null);

    //GETTING THE SITEPAG SUBJECT
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $sitebusinessdocument->business_id);   

    //START MANAGE-ADMIN CHECK
		$isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK

    if ($sitebusinessdocument->getType() !== 'sitebusinessdocument_document' || empty($viewer_id)) {
      return false;
    }

    //USER IS ALLOWED FOR DELETE OR NOT
		if(empty($can_edit) && ($viewer_id != $sitebusinessdocument->owner_id)) {
			return false;
		}

    return array(
        'class' => 'buttonlink icon_sitebusinessdocument_edit',
        'route' => 'sitebusinessdocument_edit',
        'params' => array(
						'document_id' => $sitebusinessdocument->getIdentity(),
						'business_id' => $sitebusinessdocument->business_id,
						'tab' => $tab_selected_id
        ),
    );
  }


//ADD BUSINESS DOCUMENT SUGGESTION LINK	
  public function onMenuInitialize_SitebusinessdocumentGutterSuggest($row) {

		$sitebusinessdocument = Engine_Api::_()->getItem('sitebusinessdocument_document', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'));

    $business_subject = Engine_Api::_()->getItem('sitebusiness_business', $sitebusinessdocument->business_id);      

		// Start: Show "Suggest to Frind" link.
    $business_flag = 0;
    $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
    $is_moduleEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusiness');
    $is_suggestion_enabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('suggestion');
    $isSupport = Engine_Api::_()->getApi('suggestion', 'sitebusiness')->isSupport();
    // Here we are delete this documemt suggestion if viewer have.

    if (!empty($is_suggestion_enabled)) {
      if (!empty($is_moduleEnabled)) {
        Engine_Api::_()->getApi('suggestion', 'sitebusiness')->deleteSuggestion($viewer_id, 'business_document', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'), 'business_document_suggestion');
      }

      $SuggVersion = Engine_Api::_()->getDbtable('modules', 'core')->getModule('suggestion')->version;
      $versionStatus = strcasecmp($SuggVersion, '4.1.7p1');
      if ($versionStatus >= 0) {
        $modContentObj = Engine_Api::_()->suggestion()->getSuggestedFriend('sitebusinessdocument', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'), 1,null);
        if (!empty($modContentObj)) {
          $contentCreatePopup = @COUNT($modContentObj);
        }
      }

      if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
        if ($business_subject->expiration_date <= date("Y-m-d H:i:s")) {
          $business_flag = 1;
        }
      }
      if (!empty($contentCreatePopup) && !empty($isSupport) && empty($business_subject->closed) && !empty($business_subject->approved) && empty($business_subject->declined) && !empty($business_subject->draft) && empty($business_flag) && !empty($viewer_id) && !empty($is_suggestion_enabled)) {
        $documentSuggLink = Engine_Api::_()->suggestion()->getModSettings('sitebusiness', 'document_sugg_link');
      }
    }
    else {
     return false;   
  
    }
 
    $sitebusinessdocument = Engine_Api::_()->getItem('sitebusinessdocument_document', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'));

    if( empty($documentSuggLink) && !empty($sitebusinessdocument->draft) && empty($sitebusinessdocument->approved) && empty($sitebusinessdocument->status) )  {
      return false;
    }
 
    // End: "Suggest to Friend" link work

   return array(
				'class' => 'buttonlink icon_business_friend_suggestion smoothbox',
				'route' => 'default',
				'params' => array(
						'module' => 'suggestion',
						'controller' => 'index',
						'action' => 'switch-popup',
						'modContentId' => $sitebusinessdocument->document_id,
						'modName' => 'business_document',
						'format' => 'smoothbox',
				),
    );
  }


//ADD DOCUMENT DELETE LINK
  public function onMenuInitialize_SitebusinessdocumentGutterDelete() {

    //GETTING THE VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();    
 
    //GETTING THE TAB ID
    $tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab', null);
    
    $sitebusinessdocument = Engine_Api::_()->getItem('sitebusinessdocument_document', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'));

    //GETTING THE SITEBUSINESS SUBJECT
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $sitebusinessdocument->business_id);   

    //START MANAGE-ADMIN CHECK
		$isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK

    if ($sitebusinessdocument->getType() !== 'sitebusinessdocument_document' || empty($viewer_id)) {
      return false;
    }

    //USER IS ALLOWED FOR DELETE OR NOT
		if(empty($can_edit) && ($viewer_id != $sitebusinessdocument->owner_id)) {
			return false;
		}

    return array(
        'class' => 'buttonlink  icon_sitebusinessdocument_delete',
        'route' => 'sitebusinessdocument_delete',
        'params' => array(
								'document_id' => $sitebusinessdocument->getIdentity(),
								'business_id' => $sitebusinessdocument->business_id,
								'tab' => $tab_selected_id
        ),
    );
  }


  //ADD DOCUMENT OF THE DAY LINK
  public function onMenuInitialize_SitebusinessdocumentGutterDocumentofday() {

    //GETTING THE VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();    
 
    //GETTING THE TAB ID
    $tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab', null);
    
    $sitebusinessdocument = Engine_Api::_()->getItem('sitebusinessdocument_document', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'));

    //GETTING THE SITEBUSINESS SUBJECT
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $sitebusinessdocument->business_id);   

    $allowView = false;
    if (!empty($viewer_id) && $viewer->level_id == 1) {
      $auth = Engine_Api::_()->authorization()->context;
      $allowView = $auth->isAllowed($sitebusiness, 'everyone', 'view') === 1 ? true : false ||$auth->isAllowed($sitebusiness, 'registered', 'view') === 1 ? true : false;
    } 

    if(empty($allowView)) {
      return false;
   }

    return array(
				'class' => 'buttonlink item_icon_sitebusinessdocument_detail smoothbox',
				'route' => 'default',
				'params' => array(
						'module' => 'sitebusinessdocument',
						'controller' => 'index',
						'action' => 'add-document-of-day',
						'document_id' => $sitebusinessdocument->document_id,
						'format' => 'smoothbox',
				),
    );
  }


  //ADD BUSINESS DOCUMENT ADD LINK
  public function onMenuInitialize_SitebusinessdocumentGutterAdd() {
   
    //GETTING THE VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();      
    $tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab', null);  
		$sitebusinessdocument = Engine_Api::_()->getItem('sitebusinessdocument_document', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'));

    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $sitebusinessdocument->business_id);  
 
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'sdcreate');
    if (empty($isManageAdmin)) {
      $can_create = 0;
    } else {
      $can_create = 1;
    }
    //END MANAGE-ADMIN CHECK

    if ($sitebusinessdocument->getType() !== 'sitebusinessdocument_document' || empty($viewer_id)) {
      return false;
    }

    //USER IS ALLOWED FOR DELETE OR NOT
		if(empty($can_create)) {
			return false;
		}

    return array(
        'class' => 'buttonlink icon_sitebusinessdocument_new',
        'route' => 'sitebusinessdocument_create',
        'params' => array(
								'business_id' => $sitebusinessdocument->business_id,
								'tab' => $tab_selected_id
        ),
    );
  }


	//ADD DOCUMENT SHARE LINK
  public function onMenuInitialize_SitebusinessdocumentGutterShare() {

		//GET VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
		$viewer_id = $viewer->getIdentity();

		//GET OBJECT
		$document_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id');
    $sitebusinessdocument = Engine_Api::_()->getItem('sitebusinessdocument_document', $document_id);

		//SHARING IS ALLOWED OR NOT
    $can_share = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessdocument.share', 1);

		//CAN SHARE OR NOT
    if (empty($sitebusinessdocument) || empty($viewer_id) || $sitebusinessdocument->draft == 1 || empty($sitebusinessdocument->approved) || $sitebusinessdocument->status != 1 || empty($can_share)) {
      return false;
    }

    return array(
        'class' => 'smoothbox buttonlink seaocore_icon_share',
        'route' => 'default',
        'params' => array(
            'module' => 'activity',
            'controller' => 'index',
            'action' => 'share',
            'type' => 'sitebusinessdocument_document',
            'id' => $sitebusinessdocument->getIdentity(),
            'format' => 'smoothbox',
        ),
    );
  }

	//ADD DOCUMENT DOWNLOAD LINK
  public function onMenuInitialize_SitebusinessdocumentGutterDownload($row) {

		//GET VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
		$viewer_id = $viewer->getIdentity();

		//GET OBJECT
		$document_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id');
    $sitebusinessdocument = Engine_Api::_()->getItem('sitebusinessdocument_document', $document_id);

		//AUTORIZATION CHECKS
    if (empty($sitebusinessdocument) || empty($viewer_id)) {
      return false;
    }

		//DOWNLOAD IS ALLOWED OR NOT FOR THIS LEVEL
		$view_download_allow = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessdocument.download.allow', 1);
		if(empty($view_download_allow) || empty($sitebusinessdocument->download_allow)) {
			return false;
		}

		//GET SCRIBD DETAIL
    $scribd_api_key = Engine_Api::_()->getApi('settings', 'core')->sitebusinessdocument_api_key;
    $scribd_secret = Engine_Api::_()->getApi('settings', 'core')->sitebusinessdocument_secret_key;
    $scribd = new Scribdsitebusiness($scribd_api_key, $scribd_secret);

    //SET SCRIBD USER ID
    $scribd->my_user_id = $sitebusinessdocument->owner_id;

		//DOCUMENT FORMAT FOR THIS LEVEL
		$download_format = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessdocument.download.format', 'pdf');
		$link = '';
		try {
			$link = $scribd->getDownloadUrl($sitebusinessdocument->doc_id, $download_format);
			$link = trim($link['download_link']);
		} catch (Exception $e) {
			$this->view->excep_message = $message = $e->getMessage();
			$this->view->excep_error = 1;
		}

		if(empty($link)) {
			return false;
		}

    return array(
        'class' => 'buttonlink icon_sitebusinessdocument_download',
				'uri' => $link,
				'target' => '_blank'
    );
  }

	//ADD DOCUMENT EMAIL LINK
  public function onMenuInitialize_SitebusinessdocumentGutterEmail($row) {

		//GET VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
		$viewer_id = $viewer->getIdentity();

		//GET OBJECT
		$document_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id');
    $sitebusinessdocument = Engine_Api::_()->getItem('sitebusinessdocument_document', $document_id);

		//AUTORIZATION CHECKS
    if (empty($sitebusinessdocument) || empty($viewer_id) || $sitebusinessdocument->status != 1) {
      return false;
    }

		//EMAIL IS ALLOWED OR NOT
		$view_email_allow = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessdocument.email.allow', 1);
		if(empty($view_email_allow) || empty($sitebusinessdocument->email_allow)) {
			return false;
		}

    return array(
        'class' => 'buttonlink smoothbox icon_sitebusinessdocuments_email',
        'route' => 'default',
        'params' => array(
            'module' => 'sitebusinessdocument',
            'controller' => 'index',
            'action' => 'email',
            'id' => $sitebusinessdocument->getIdentity(),
        ),
    );
  }


	//ADD DOCUMENT REPORT LINK
  public function onMenuInitialize_SitebusinessdocumentGutterReport() {

		//GET VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
		$viewer_id = $viewer->getIdentity();

		//GET OBJECT
		$document_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id');
    $sitebusinessdocument = Engine_Api::_()->getItem('sitebusinessdocument_document', $document_id);

		//CAN REPORT OR NOT
    if (empty($viewer_id) || empty($sitebusinessdocument)) {
      return false;
    }

		//REPORTING IS ALLOWED OR NOT
    $report = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessdocument.report', 1);
    if (empty($report)) {
      return false;
    }

    return array(
        'class' => 'smoothbox buttonlink seaocore_icon_report',
        'route' => 'default',
        'params' => array(
            'module' => 'core',
            'controller' => 'report',
            'action' => 'create',
            'subject' => $sitebusinessdocument->getGuid(),
            'format' => 'smoothbox',
        ),
    );
  }

}
?>