<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessdocument
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminController.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessdocument_AdminController extends Core_Controller_Action_Admin {

  protected $_navigation;

  //ACTION FOR MAKE BUSINESS-DOCUMENT APPROVED/DIS-APPROVED
  public function approvedAction() {
    $document_id = $this->_getParam('id');
    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    try {
      $sitebusinessdocument = Engine_Api::_()->getItem('sitebusinessdocument_document', $document_id);
      if ($sitebusinessdocument->approved == 0) {
        $sitebusinessdocument->approved = 1;
      } else {
        $sitebusinessdocument->approved = 0;
      }
      $sitebusinessdocument->save();
      $db->commit();
    } catch (Exception $e) {
      $db->rollBack();
      throw $e;
    }
    $this->_redirect('admin/sitebusinessdocument/manage');
  }

  //ACTION FOR MAKE BUSINESS-DOCUMENT APPROVED/DIS-APPROVED
  public function featuredAction() {
    $document_id = $this->_getParam('id');
    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    try {
      $sitebusinessdocument = Engine_Api::_()->getItem('sitebusinessdocument_document', $document_id);
      if ($sitebusinessdocument->featured == 0) {
        $sitebusinessdocument->featured = 1;
      } else {
        $sitebusinessdocument->featured = 0;
      }
      $sitebusinessdocument->save();
      $db->commit();
    } catch (Exception $e) {
      $db->rollBack();
      throw $e;
    }
    $this->_redirect('admin/sitebusinessdocument/manage');
  }

   //ACTION FOR MAKE BUSINESS-DOCUMENT APPROVED/DIS-APPROVED
  public function highlightedAction() {
    $document_id = $this->_getParam('id');
    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    try {
      $sitebusinessdocument = Engine_Api::_()->getItem('sitebusinessdocument_document', $document_id);
      if ($sitebusinessdocument->highlighted == 0) {
        $sitebusinessdocument->highlighted = 1;
      } else {
        $sitebusinessdocument->highlighted = 0;
      }
      $sitebusinessdocument->save();
      $db->commit();
    } catch (Exception $e) {
      $db->rollBack();
      throw $e;
    }
    $this->_redirect('admin/sitebusinessdocument/manage');
  }

  //ACTION FOR DELETE THE BUSINESS-DOCUMENT
  public function deleteAction() {
    $this->_helper->layout->setLayout('admin-simple');
    $this->view->document_id = $document_id = $this->_getParam('id');

    if ($this->getRequest()->isPost()) {
      $db = Engine_Db_Table::getDefaultAdapter();
      $db->beginTransaction();
      try {

				Engine_Api::_()->sitebusinessdocument()->deleteContent($document_id);
        $db->commit();
      } catch (Exception $e) {
        $db->rollBack();
        throw $e;
      }
      $this->_forward('success', 'utility', 'core', array(
          'smoothboxClose' => 10,
          'parentRefresh' => 10,
          'messages' => array('')
      ));
    }
    $this->renderScript('admin/delete.tpl');
  }

}
?>