<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessdocument
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessdocument_Installer extends Engine_Package_Installer_Module {

  function onPreInstall() {
    $db = $this->getDb();

    //CHECK THAT SITEBUSINESS PLUGIN IS ACTIVATED OR NOT
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_settings')
            ->where('name = ?', 'sitebusiness.is.active')
            ->limit(1);
    $sitebusiness_settings = $select->query()->fetchAll();
    if (!empty($sitebusiness_settings)) {
      $sitebusiness_is_active = $sitebusiness_settings[0]['value'];
    } else {
      $sitebusiness_is_active = 0;
    }

    //CHECK THAT SITEBUSINESS PLUGIN IS INSTALLED OR NOT
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'sitebusiness')
            ->where('enabled = ?', 1);
    $check_sitebusiness = $select->query()->fetchObject();
    if (!empty($check_sitebusiness) && !empty($sitebusiness_is_active)) {
      $PRODUCT_TYPE = 'sitebusinessdocument';
      $PLUGIN_TITLE = 'Sitebusinessdocument';
      $PLUGIN_VERSION = '5.4.1';
      $PLUGIN_CATEGORY = 'plugin';
      $PRODUCT_DESCRIPTION = 'Sitebusinessdocument Plugin';
      $PRODUCT_TITLE = 'Directory / Businesses - Documents Extension';
      $_PRODUCT_FINAL_FILE = 0;
      $sitebusiness_plugin_version = '4.8.6';
      $SocialEngineAddOns_version = '4.8.9p12';
      $file_path = APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/ilicense.php";
      $is_file = file_exists($file_path);
      if (empty($is_file)) {
        include APPLICATION_PATH . "/application/modules/Sitebusiness/controllers/license/license4.php";
      } else {
        include $file_path;
      }

      $businessTime = time();
      $db->query("INSERT IGNORE INTO `engine4_core_settings` (`name`, `value`) VALUES
			('sitebusinessdocument.basetime', $businessTime ),
			('sitebusinessdocument.isvar', 0 ),
			('sitebusinessdocument.filepath', 'Sitebusinessdocument/controllers/license/license2.php');");    
      parent::onPreInstall();
    } elseif (!empty($check_sitebusiness) && empty($sitebusiness_is_active)) {
      $baseUrl = $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getBaseUrl();
      $url_string = Zend_Controller_Front::getInstance()->getRequest()->getRequestUri();
      if (strstr($url_string, "manage/install")) {
        $calling_from = 'install';
      } else if (strstr($url_string, "manage/query")) {
        $calling_from = 'queary';
      }
      $explode_base_url = explode("/", $baseUrl);
      foreach ($explode_base_url as $url_key) {
        if ($url_key != 'install') {
          $core_final_url .= $url_key . '/';
        }
      }

      return $this->_error("<span style='color:red'>Note: You have installed the <a href='http://www.socialengineaddons.com/socialengine-directory-businesses-plugin' target='_blank'>Directory / Businesses Plugin</a> but not activated it on your site yet. Please activate it first before installing the Directory / Businesses - Documents Extension.</span><br/> <a href='" . 'http://' . $core_final_url . "admin/sitebusiness/settings/readme'>Click here</a> to activate the Directory / Businesses Plugin.");
    } else {
      $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();
      return $this->_error("<span style='color:red'>Note: You have not installed the <a href='http://www.socialengineaddons.com/socialengine-directory-businesses-plugin' target='_blank'>Directory / Businesses Plugin</a> on your site yet. Please install it first before installing the <a href='http://www.socialengineaddons.com/businessextensions/socialengine-directory-businesses-documents' target='_blank'>Directory / Businesses - Documents Extension</a>.</span><br/> <a href='" . $base_url . "/manage'>Click here</a> to go Manage Packages.");
    }
  }
  
  function onInstall() {
		$db = $this->getDb();
        
        $select = new Zend_Db_Select($db);
        $select->from('engine4_core_modules')
               ->where('name = ?', 'sitebusinessdocument')
               ->where('version <= ?', '4.8.9p2');
        $is_enabled = $select->query()->fetchObject();
        if (!empty($is_enabled)) {
            $db->query("UPDATE `engine4_sitebusinessdocument_documents` SET `thumbnail` = REPLACE(thumbnail, 'http:', 'https:') WHERE `thumbnail` Like 'http:%'");
        }        

		$db->query('UPDATE  `engine4_activity_notificationtypes` SET  `body` =  \'{item:$subject} has created a business document {item:$object}.\' WHERE  `engine4_activity_notificationtypes`.`type` =  "sitebusinessdocument_create";');
		
    //WORK FOR CORE CONTENT BUSINESSES
		$select = new Zend_Db_Select($db);

    $select->from('engine4_core_content',array('params'))
            ->where('name = ?', 'sitebusinessdocument.socialshare-sitebusinessdocuments');
		$result = $select->query()->fetchObject();
    if(!empty($result->params)) {
			$params = Zend_Json::decode($result->params);
			if(isset($params['code'])) {
				$code = $params['code'];
				$db->query("INSERT IGNORE INTO `engine4_core_settings` (`name`, `value`) VALUES
				('sitebusinessdocument.code.share','".$code. "');");
			}
    }

    $table_exist = $db->query("SHOW TABLES LIKE 'engine4_sitebusinessdocument_documents'")->fetch();
    if (!empty($table_exist)) {

      $columnExist = $db->query("SHOW COLUMNS FROM engine4_sitebusinessdocument_documents LIKE 'sitebusinessdocument_slug'")->fetch();
      if(!empty($columnExist)) {
        $db->query("ALTER TABLE `engine4_sitebusinessdocument_documents` DROP `sitebusinessdocument_slug`");
      }
    }




    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_settings')
            ->where('name = ?', 'sitebusinessdocument.is.active')
            ->limit(1);
    $sitebusinessdocument_settings = $select->query()->fetchAll();



  // WIDGET SETTING WORK
		$select = new Zend_Db_Select($db);
		$select
		->from('engine4_core_menuitems')
		->where('name = ?', 'sitebusinessdocument_admin_main_widgets')
		->limit(1);
		$info = $select->query()->fetch();
		if (empty($info) && !empty($sitebusinessdocument_settings)) {
		$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `custom`, `order`, `enabled`) VALUES
		("sitebusinessdocument_admin_main_widgets", "sitebusinessdocument", "Widget Settings", "", \'{"route":"admin_default","module":"sitebusinessdocument","controller":"widgets"}\', "sitebusinessdocument_admin_main", "", 0, 3, 1)');
		}

      //START THE WORK FOR MAKE WIDGETIZE BUSINESS OF DOCUMENTS LISTING AND DOCUMENT VIEW BUSINESS
    $select = new Zend_Db_Select($db);
		$select
						->from('engine4_core_modules')
						->where('name = ?', 'sitebusinessdocument')
						->where('version < ?', '4.2.0');
		$is_enabled = $select->query()->fetchObject();
    if(!empty($is_enabled)) {
			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_core_modules')
							->where('name = ?', 'communityad')
							->where('enabled 	 = ?', 1)
							->limit(1);
				;
			$infomation = $select->query()->fetch();
			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_core_settings')
							->where('name = ?', 'sitebusiness.communityads')
							->where('value 	 = ?', 1)
							->limit(1);
			$rowinfo = $select->query()->fetch();

			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_core_pages')
							->where('name = ?', 'sitebusinessdocument_index_browse')
							->limit(1);
			;
			$info = $select->query()->fetch();

			if ( empty($info) ) {
				$db->insert('engine4_core_pages', array(
						'name' => 'sitebusinessdocument_index_browse',
						'displayname' => 'Browse Business Documents',
						'title' => 'Business Documents',
						'description' => 'This is the business documents.',
						'custom' => 1,
				));
				$business_id = $db->lastInsertId('engine4_core_pages');

				//CONTAINERS
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'main',
						'parent_content_id' => Null,
						'order' => 2,
						'params' => '',
				));
				$container_id = $db->lastInsertId('engine4_core_content');

				//INSERT MAIN - MIDDLE CONTAINER
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $container_id,
						'order' => 6,
						'params' => '',
				));
				$middle_id = $db->lastInsertId('engine4_core_content');


				//INSERT MAIN - RIGHT CONTAINER
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'right',
						'parent_content_id' => $container_id,
						'order' => 5,
						'params' => '',
				));
				$right_id = $db->lastInsertId('engine4_core_content');


				//INSERT TOP CONTAINER
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'top',
						'parent_content_id' => Null,
						'order' => 1,
						'params' => '',
				));
				$top_id = $db->lastInsertId('engine4_core_content');


				//INSERT TOP- MIDDLE CONTAINER
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $top_id,
						'order' => 6,
						'params' => '',
				));
				$top_middle_id = $db->lastInsertId('engine4_core_content');


				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusiness.browsenevigation-sitebusiness',
						'parent_content_id' => $top_middle_id,
						'order' => 1,
						'params' => '{"title":"","titleCount":""}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessdocument.search-sitebusinessdocument',
						'parent_content_id' => $right_id,
						'order' => 3,
						'params' => '{"title":"","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessdocument.sitebusiness-document',
						'parent_content_id' => $middle_id,
						'order' => 2,
						'params' => '{"title":"","titleCount":""}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessdocument.homefeaturelist-sitebusinessdocuments',
						'parent_content_id' => $right_id,
						'order' => 4,
						'params' => '{"title":"Featured Documents","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessdocument.sitebusiness-sponsoreddocument',
						'parent_content_id' => $right_id,
						'order' => 5,
						'params' => '{"title":"Sponsored Documents","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessdocument.homecomment-sitebusinessdocuments',
						'parent_content_id' => $right_id,
						'order' => 6,
						'params' => '{"title":"Most Commented Documents","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessdocument.homepopular-sitebusinessdocuments',
						'parent_content_id' => $right_id,
						'order' => 7,
						'params' => '{"title":"Most Popular Documents","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessdocument.homelike-sitebusinessdocuments',
						'parent_content_id' => $right_id,
						'order' => 8,
						'params' => '{"title":"Most Liked Documents","titleCount":"true"}',
				));


				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessdocument.homerate-sitebusinessdocuments',
						'parent_content_id' => $right_id,
						'order' => 9,
						'params' => '{"title":"Top Rated Documents","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
							'page_id' => $business_id,
							'type' => 'widget',
							'name' => 'sitebusinessdocument.homerecent-sitebusinessdocuments',
							'parent_content_id' => $right_id,
							'order' => 10,
							'params' => '{"title":"Recent Business Documents","titleCount":"true"}',
					));

				if ( $infomation && $rowinfo ) {
					$db->insert('engine4_core_content', array(
							'page_id' => $business_id,
							'type' => 'widget',
							'name' => 'sitebusiness.business-ads',
							'parent_content_id' => $right_id,
							'order' => 11,
							'params' => '{"title":"","titleCount":""}',
					));
				}
			}

			$db = $this->getDb();
			$select = new Zend_Db_Select($db);

			// Check if it's already been placed
			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_core_pages')
							->where('name = ?', 'sitebusinessdocument_index_view')
							->limit(1);
			;
			$info = $select->query()->fetch();

			if ( empty($info) ) {
				$db->insert('engine4_core_pages', array(
						'name' => 'sitebusinessdocument_index_view',
						'displayname' => 'Business Document View Page',
						'title' => 'View Business Document',
						'description' => 'This is the view business for a business document.',
						'custom' => 1,
						'provides' => 'subject=sitebusinessdocument',
				));
				$business_id = $db->lastInsertId('engine4_core_pages');

				// containers
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'main',
						'parent_content_id' => null,
						'order' => 1,
						'params' => '',
				));
				$container_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'right',
						'parent_content_id' => $container_id,
						'order' => 1,
						'params' => '',
				));
				$right_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $container_id,
						'order' => 3,
						'params' => '',
				));
				$middle_id = $db->lastInsertId('engine4_core_content');

				// middle column content
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessdocument.document-content',
						'parent_content_id' => $middle_id,
						'order' => 1,
						'params' => '',
				));

        //BUSINESS DOCUMENT OWNER PHOTO WIDGET
      $db->insert('engine4_core_content', array(
        'page_id' => $business_id,
        'type' => 'widget',
        'name' => 'sitebusinessdocument.document-owner-photo-documents',
        'parent_content_id' => $right_id,
        'order' => 2,
        'params' => '',
      ));

			//BUSINESS DOCUMENT OPTIONS WIDGET
      $db->insert('engine4_core_content', array(
        'page_id' => $business_id,
        'type' => 'widget',
        'name' => 'sitebusinessdocument.options-documents',
        'parent_content_id' => $right_id,
        'order' => 3,
        'params' => '',
      ));

      //RECENT BUSINESS DOCUMENT
      $db->insert('engine4_core_content', array(
        'page_id' => $business_id,
        'type' => 'widget',
        'name' => 'sitebusinessdocument.viewrecent-sitebusinessdocuments',
        'parent_content_id' => $right_id,
        'order' => 4,
        'params' => '',
      ));



				if ( $infomation && $rowinfo ) {
					$db->insert('engine4_core_content', array(
							'page_id' => $business_id,
							'type' => 'widget',
							'name' => 'sitebusiness.business-ads',
							'parent_content_id' => $right_id,
							'order' => 5,
							'params' => '{"title":"","titleCount":""}',
					));
				}
			}
	
			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_core_modules')
							->where('name = ?', 'mobi')
							->where('enabled 	 = ?', 1)
							->limit(1);
			;  

			$infomation = $select->query()->fetch();
			if(!empty($infomation)) {
				$select = new Zend_Db_Select($db);
				$select
								->from('engine4_core_pages')
								->where('name = ?', 'sitebusinessdocument_mobi_view')
								->limit(1);
				;
				$info = $select->query()->fetch();
				if (empty($info)) {
					$db->insert('engine4_core_pages', array(
							'name' => 'sitebusinessdocument_mobi_view',
							'displayname' => 'Mobile Business Document Profile',
							'title' => 'Mobile Business Document Profile',
							'description' => 'This is the mobile verison of a Business document profile business.',
							'custom' => 0,
					));
					$business_id = $db->lastInsertId('engine4_core_pages');

					// containers
					$db->insert('engine4_core_content', array(
							'page_id' => $business_id,
							'type' => 'container',
							'name' => 'main',
							'parent_content_id' => null,
							'order' => 1,
							'params' => '',
					));
					$container_id = $db->lastInsertId('engine4_core_content');

					$db->insert('engine4_core_content', array(
							'page_id' => $business_id,
							'type' => 'container',
							'name' => 'right',
							'parent_content_id' => $container_id,
							'order' => 1,
							'params' => '',
					));
					$right_id = $db->lastInsertId('engine4_core_content');

					$db->insert('engine4_core_content', array(
							'page_id' => $business_id,
							'type' => 'container',
							'name' => 'middle',
							'parent_content_id' => $container_id,
							'order' => 3,
							'params' => '',
					));
					$middle_id = $db->lastInsertId('engine4_core_content');

					// middle column content
					$db->insert('engine4_core_content', array(
							'page_id' => $business_id,
							'type' => 'widget',
							'name' => 'sitebusinessdocument.document-content',
							'parent_content_id' => $middle_id,
							'order' => 1,
							'params' => '',
					));
				}
			}
    }

    $select = new Zend_Db_Select($db);
		$select
					->from('engine4_core_modules')
					->where('name = ?', 'sitebusinessdocument')
					->where('version < ?', '4.2.1');
		$is_enabled_document = $select->query()->fetchObject();
      
		if($is_enabled_document) {
			$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitebusinessdocument_admin_submain_general_tab", "sitebusinessdocument", "General Settings", "", \'{"route":"admin_default","module":"sitebusinessdocument","controller":"widgets", "action": "index"}\', "sitebusinessdocument_admin_submain", "", 1, 0, 1)');

			$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitebusinessdocument_admin_submain_document_tab", "sitebusinessdocument", "Tabbed Documents Widget", "", \'{"route":"admin_default","module":"sitebusinessdocument","controller":"settings", "action": "widget"}\', "sitebusinessdocument_admin_submain", "", 1, 0, 2)');

			$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitebusinessdocument_admin_submain_dayitems", "sitebusinessdocument", "Document of the Day", "", \'{"route":"admin_default","module":"sitebusinessdocument","controller":"settings", "action": "manage-day-items"}\', "sitebusinessdocument_admin_submain", "", 1, 0, 4)');


			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_core_pages')
							->where('name = ?', 'sitebusinessdocument_index_home')
							->limit(1);
			$info = $select->query()->fetch();
			if (empty($info)) {
				$db->insert('engine4_core_pages', array(
						'name' => 'sitebusinessdocument_index_home',
						'displayname' => 'Business Documents Home',
						'title' => 'Business Documents Home',
						'description' => 'This is business document home business.',
						'custom' => 1
				));
				$business_id = $db->lastInsertId('engine4_core_pages');

				// containers
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'main',
						'parent_content_id' => null,
						'order' => 2,
						'params' => '',
				));
				$container_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'right',
						'parent_content_id' => $container_id,
						'order' => 5,
						'params' => '',
				));
				$right_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'left',
						'parent_content_id' => $container_id,
						'order' => 4,
						'params' => '',
				));
				$left_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'top',
						'parent_content_id' => null,
						'order' => 1,
						'params' => '',
				));
				$top_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $top_id,
						'order' => 6,
						'params' => '',
				));
				$top_middle_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $container_id,
						'order' => 6,
						'params' => '',
				));
				$middle_id = $db->lastInsertId('engine4_core_content');

			// Top Middle
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusiness.browsenevigation-sitebusiness',
						'parent_content_id' => $top_middle_id,
						'order' => 3,
						'params' => '',
				));

				// Left
			
				//INSERT TOP RATED BUSINESS DOCUMENT WIDGET
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessdocument.homerate-sitebusinessdocuments',
						'parent_content_id' => $left_id,
						'order' => 14,
						'params' => '{"title":"Top Rated Documents","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessdocument.homerecent-sitebusinessdocuments',
						'parent_content_id' => $left_id,
						'order' => 13,
						'params' => '{"title":"Recent Business Documents","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessdocument.homepopular-sitebusinessdocuments',
						'parent_content_id' => $right_id,
						'order' => 20,
						'params' => '{"title":"Most Popular Documents","titleCount":"true"}',
				));

				// Middle
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessdocument.featured-documents-slideshow',
						'parent_content_id' => $middle_id,
						'order' => 15,
						'params' => '{"title":"Featured Documents","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessdocument.list-documents-tabs-view',
						'parent_content_id' => $middle_id,
						'order' => 17,
						'params' => '{"title":"Documents","margin_photo":"12"}',
				));
				// Right Side
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessdocument.sitebusinessdocumentlist-link',
						'parent_content_id' => $right_id,
						'order' => 19,
						'params' => '',
				));

				// Right Side
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessdocument.search-sitebusinessdocument',
						'parent_content_id' => $right_id,
						'order' => 18,
						'params' => '',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessdocument.document-of-the-day',
						'parent_content_id' => $left_id,
						'order' => 12,
						'params' => '{"title":"Document of the Day"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessdocument.homefeaturelist-sitebusinessdocuments',
						'parent_content_id' => $right_id,
						'order' => 21,
						'params' => '{"title":"Featured Documents","itemCountPerBusiness":3}',
				));


				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessdocument.homecomment-sitebusinessdocuments',
						'parent_content_id' => $right_id,
						'order' => 22,
						'params' => '{"title":"Most Commented Documents","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessdocument.homelike-sitebusinessdocuments',
						'parent_content_id' => $right_id,
						'order' => 23,
						'params' => '{"title":"Most Liked Documents","titleCount":"true"}',
				));
			}

			$select = new Zend_Db_Select($db);
			$select
						->from('engine4_core_content')
						->where('name = ?', 'sitebusinessdocument.featurelist-sitebusinessdocuments');
						
			$is_exit = $select->query()->fetchObject();
			if(!empty($is_exit)) {
				$db->update('engine4_core_content', array(
					'name' => 'sitebusinessdocument.highlightlist-sitebusinessdocuments',
					'params' => '{"title":"Highlighted Documents","titleCount":true}',
							), array(
					'name = ?' => 'sitebusinessdocument.featurelist-sitebusinessdocuments',
				));
			}
			
			$select = new Zend_Db_Select($db);
			$select
						->from('engine4_sitebusiness_admincontent')
						->where('name = ?', 'sitebusinessdocument.featurelist-sitebusinessdocuments');
						
			$is_exit_content = $select->query()->fetchObject();
			if(!empty($is_exit_content)) {
				$db->update('engine4_sitebusiness_admincontent', array(
					'name' => 'sitebusinessdocument.highlightlist-sitebusinessdocuments',
					'params' => '{"title":"Highlighted Documents","titleCount":true}',
							), array(
					'name = ?' => 'sitebusinessdocument.featurelist-sitebusinessdocuments',
				));
			}

			$select = new Zend_Db_Select($db);
			$select
						->from('engine4_sitebusiness_content')
						->where('name = ?', 'sitebusinessdocument.featurelist-sitebusinessdocuments');
						
			$is_exit_sitebusinesscontent = $select->query()->fetchObject();
			if(!empty($is_exit_sitebusinesscontent)) {
				$db->update('engine4_sitebusiness_content', array(
					'name' => 'sitebusinessdocument.highlightlist-sitebusinessdocuments',
					'params' => '{"title":"Highlighted Documents","titleCount":true}',
							), array(
					'name = ?' => 'sitebusinessdocument.featurelist-sitebusinessdocuments',
				));
			}

			$featuredColumn = $db->query("SHOW COLUMNS FROM engine4_sitebusinessdocument_documents LIKE 'featured'")->fetch();
      $highlightedColumn = $db->query("SHOW COLUMNS FROM engine4_sitebusinessdocument_documents LIKE 'highlighted'")->fetch();
			if (!empty($featuredColumn) && empty($highlightedColumn)) {
				$db->query("ALTER TABLE `engine4_sitebusinessdocument_documents` CHANGE `featured` `highlighted` TINYINT( 1 ) NOT NULL");
			}

			$featuredColumn = $db->query("SHOW COLUMNS FROM engine4_sitebusinessdocument_documents LIKE 'featured'")->fetch();
			if (empty($featuredColumn)) {
				$db->query("ALTER TABLE `engine4_sitebusinessdocument_documents` ADD `featured` TINYINT( 1 ) NOT NULL AFTER `highlighted`");
			}
      $db->update('engine4_core_pages', array('displayname' => 'Browse Business Documents'), array('displayname = ?' => 'Business Documents')); 
		}

		//START SOCIAL SHARE WIDGET WORK
		//CHECK PLUGIN VERSION
    $select = new Zend_Db_Select($db);
		$select
					->from('engine4_core_modules')
					->where('name = ?', 'sitebusinessdocument')
					->where('version < ?', '4.2.1');
		$is_enabled_module = $select->query()->fetchObject();

		if(!empty($is_enabled_module)) {

			$social_share_default_code = '{"title":"Social Share","titleCount":true,"code":"<div class=\"addthis_toolbox addthis_default_style \">\r\n<a class=\"addthis_button_preferred_1\"><\/a>\r\n<a class=\"addthis_button_preferred_2\"><\/a>\r\n<a class=\"addthis_button_preferred_3\"><\/a>\r\n<a class=\"addthis_button_preferred_4\"><\/a>\r\n<a class=\"addthis_button_preferred_5\"><\/a>\r\n<a class=\"addthis_button_compact\"><\/a>\r\n<a class=\"addthis_counter addthis_bubble_style\"><\/a>\r\n<\/div>\r\n<script type=\"text\/javascript\">\r\nvar addthis_config = {\r\n          services_compact: \"facebook, twitter, linkedin, google, digg, more\",\r\n          services_exclude: \"print, email\"\r\n}\r\n<\/script>\r\n<script type=\"text\/javascript\" src=\"http:\/\/s7.addthis.com\/js\/250\/addthis_widget.js\"><\/script>","nomobile":"","name":"sitebusinessdocument.socialshare-sitebusinessdocuments"}';

	  	$db->update('engine4_core_content', array('params' => $social_share_default_code,), array('name =?' => 'sitebusinessdocument.socialshare-sitebusinessdocuments'));
		}
		//END SOCIAL SHARE WIDGET WORK
		$select = new Zend_Db_Select($db);
    $select
          ->from('engine4_core_settings')
          ->where('name = ?', 'sitebusiness.feed.type');
  $info = $select->query()->fetch();
    $enable = 1;
    if (!empty($info))
      $enable = $info['value'];
    $db->query('INSERT IGNORE INTO   `engine4_activity_actiontypes` (`type`, `module`, `body`, `enabled`, `displayable`, `attachable`, `commentable`, `shareable`, `is_generated`, `is_object_thumb`) VALUES("sitebusinessdocument_admin_new", "sitebusinessdocument", "{item:$object} created a new document:", '.$enable.', 6, 2, 1, 1, 0, 1)');
    
        $categoryIdColumn = $db->query("SHOW COLUMNS FROM engine4_sitebusinessdocument_documents LIKE 'category_id'")->fetch();
    if (empty($categoryIdColumn)) {
      $db->query("ALTER TABLE `engine4_sitebusinessdocument_documents` ADD `category_id` INT( 11 )  NOT NULL DEFAULT '0';");
    }
    
    $categoryTableExist = $db->query("SHOW TABLES LIKE 'engine4_sitebusinessdocument_categories'")->fetch();
    if(empty($categoryTableExist)) {
      $db->query("
        CREATE TABLE IF NOT EXISTS `engine4_sitebusinessdocument_categories` (
          `category_id` int(11) unsigned NOT NULL auto_increment,
          `title` varchar(64) NOT NULL,
          PRIMARY KEY  (`category_id`)
        ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE utf8_unicode_ci ;
      ");
      
      $db->query("
        INSERT IGNORE INTO `engine4_sitebusinessdocument_categories` (`title`) VALUES
        ('Arts'),
        ('Business'),
        ('Conferences'),
        ('Festivals'),
        ('Food'),
        ('Fundraisers'),
        ('Galleries'),
        ('Health'),
        ('Just For Fun'),
        ('Kids'),
        ('Learning'),
        ('Literary'),
        ('Movies'),
        ('Museums'),
        ('Neighborhood'),
        ('Networking'),
        ('Nightlife'),
        ('On Campus'),
        ('Organizations'),
        ('Outdoors'),
        ('Pets'),
        ('Politics'),
        ('Sales'),
        ('Science'),
        ('Spirituality'),
        ('Sports'),
        ('Technology'),
        ('Theatre'),
        ('Other');
      ");
    }    
    
    $select = new Zend_Db_Select($db);
    $select
                ->from('engine4_core_modules')
                ->where('name = ?', 'sitebusinessdocument')
                ->where('enabled = ?', 1);    
    $is_sitebusinessdocument_object = $select->query()->fetchObject();
    if($is_sitebusinessdocument_object) {    
        $db->query('
          INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `order`) VALUES
          ("sitebusinessdocument_admin_main_categories", "sitebusinessdocument", "Categories", "", \'{"route":"admin_default","module":"sitebusinessdocument","controller":"settings","action":"categories"}\', "sitebusinessdocument_admin_main", "", 3);
        ');
    }

		$select = new Zend_Db_Select($db);
		$select
					->from('engine4_core_modules')
					->where('name = ?', 'sitemobile')
					->where('enabled = ?', 1);
		$is_sitemobile_object = $select->query()->fetchObject();
		if($is_sitemobile_object)  {
				include APPLICATION_PATH . "/application/modules/Sitebusinessdocument/controllers/license/mobileLayoutCreation.php";
		}
    
    $documentTable = $db->query('SHOW TABLES LIKE \'engine4_sitebusinessdocument_documents\'')->fetch();
    if(!empty($documentTable)) {
        $featuredIndex = $db->query("SHOW INDEX FROM `engine4_sitebusinessdocument_documents` WHERE Key_name = 'featured'")->fetch();   
        if(empty($featuredIndex)) {
          $db->query("ALTER TABLE `engine4_sitebusinessdocument_documents` ADD INDEX ( `featured` )");
        }   
 
        $highlightedIndex = $db->query("SHOW INDEX FROM `engine4_sitebusinessdocument_documents` WHERE Key_name = 'highlighted'")->fetch();     
        if(empty($highlightedIndex)) {
          $db->query("ALTER TABLE `engine4_sitebusinessdocument_documents` ADD INDEX ( `highlighted` )");
        }         

        $categoryIdIndex = $db->query("SHOW INDEX FROM `engine4_sitebusinessdocument_documents` WHERE Key_name = 'category_id'")->fetch();     
        if(empty($categoryIdIndex)) {
          $db->query("ALTER TABLE `engine4_sitebusinessdocument_documents` ADD INDEX ( `category_id` )");
        }      

        $searchIndex = $db->query("SHOW INDEX FROM `engine4_sitebusinessdocument_documents` WHERE Key_name = 'search'")->fetch();
        if(!empty($searchIndex)) {
            $db->query("ALTER TABLE `engine4_sitebusinessdocument_documents` DROP INDEX search");
            $db->query("ALTER TABLE `engine4_sitebusinessdocument_documents` ADD INDEX (`draft`, `search`, `status`, `approved`)");
        }
    }
    $this->setActivityFeeds();
    parent::onInstall();
  }

  public function onPostInstall() {

    $db = $this->getDb();
		$select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'sitemobile')
            ->where('enabled = ?', 1);
    $is_sitemobile_object = $select->query()->fetchObject();
    if(!empty($is_sitemobile_object)) {
			$db->query("INSERT IGNORE INTO `engine4_sitemobile_modules` (`name`, `visibility`) VALUES ('sitebusinessdocument','1')");
			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_sitemobile_modules')
							->where('name = ?', 'sitebusinessdocument')
							->where('integrated = ?', 0);
			$is_sitemobile_object = $select->query()->fetchObject();
      if($is_sitemobile_object)  {
				$actionName = Zend_Controller_Front::getInstance()->getRequest()->getActionName();
				$controllerName = Zend_Controller_Front::getInstance()->getRequest()->getControllerName();
				if($controllerName == 'manage' && $actionName == 'install') {
          $view = new Zend_View();
					$baseUrl = ( !empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://':'http://') .  $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
					$redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
					$redirector->gotoUrl($baseUrl . 'admin/sitemobile/module/enable-mobile/enable_mobile/1/name/sitebusinessdocument/integrated/0/redirect/install');
				} 
      }
    } 
    
    //Work for the word changes in the business plugin .csv file.
    $actionName = Zend_Controller_Front::getInstance()->getRequest()->getActionName();
    $controllerName = Zend_Controller_Front::getInstance()->getRequest()->getControllerName();
    if($controllerName == 'manage' && ($actionName == 'install' || $actionName == 'query')) {
      $view = new Zend_View();
      $baseUrl = ( !empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://':'http://') .  $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
      $redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
      if ($actionName == 'install') {
        $redirector->gotoUrl($baseUrl . 'admin/sitebusiness/settings/language/redirect/install');
      } else {
        $redirector->gotoUrl($baseUrl . 'admin/sitebusiness/settings/language/redirect/query');
      }
    }
    
  }
  
  public function setActivityFeeds() {
    $db = $this->getDb();
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'nestedcomment')
            ->where('enabled = ?', 1);
    $is_nestedcomment_object = $select->query()->fetchObject();
    if ($is_nestedcomment_object) {
        $db->query('INSERT IGNORE INTO `engine4_activity_actiontypes` (`type`, `module`, `body`, `enabled`, `displayable`, `attachable`, `commentable`, `shareable`, `is_generated`) VALUES ("nestedcomment_sitebusinessdocument_document", "sitebusinessdocument", \'{item:$subject} replied to a comment on {item:$owner}\'\'s business document {item:$object:$title}: {body:$body}\', 1, 1, 1, 1, 1, 1)');
    }
  }  
}
?>
