<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessevent
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 6590 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessevent_Api_Core extends Core_Api_Abstract {

  public function setEventPackages() {

    $check_result_show = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessevent.isvar');
    $base_result_time = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessevent.basetime');
    $filePath = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessevent.filepath');
    $currentbase_time = time();
    $word_name = strrev('lruc');
    $file_path = APPLICATION_PATH . '/application/modules/' . $filePath;

    if (($currentbase_time - $base_result_time > 4492800) && empty($check_result_show)) {
      $is_file_exist = file_exists($file_path);
      if (!empty($is_file_exist)) {
        $fp = fopen($file_path, "r");
        while (!feof($fp)) {
          $get_file_content .= fgetc($fp);
        }
        fclose($fp);
        $modGetType = strstr($get_file_content, $word_name);
      }

      if (empty($modGetType)) {
        Engine_Api::_()->sitebusiness()->setDisabledType();
        Engine_Api::_()->getItemtable('sitebusiness_package')->setEnabledPackages();
        Engine_Api::_()->getApi('settings', 'core')->setSetting('sitebusinessevent.set.type', 1);
        Engine_Api::_()->getApi('settings', 'core')->setSetting('sitebusinessevent.keyword', 1);
        return;
      } else {
        Engine_Api::_()->getApi('settings', 'core')->setSetting('sitebusinessevent.isvar', 1);
      }
    }
  }

  /**
   * Delete the sitebusinessevent album and photos
   * 
   * @param int $event_id
   */
  public function deleteContent($event_id) {
    
		$sitebusinessevent = Engine_Api::_()->getItem('sitebusinessevent_event', $event_id);

		if(empty($sitebusinessevent)) {
			return;
		}

    $tableEventPhoto = Engine_Api::_()->getItemTable('sitebusinessevent_photo');
    $select = $tableEventPhoto->select()->where('event_id = ?', $event_id);
    $rows = $tableEventPhoto->fetchAll($select);
    if (!empty($rows)) {
      foreach ($rows as $photo) {
        $photo->delete();
      }
    }

    $tableEventAlbum = Engine_Api::_()->getItemTable('sitebusinessevent_album');
    $select = $tableEventAlbum->select()->where('event_id = ?', $event_id);
    $rows = $tableEventAlbum->fetchAll($select);
    if (!empty($rows)) {
      foreach ($rows as $album) {
        $album->delete();
      }
    } 

		$sitebusinessevent->delete();
  }
   /**
   * Get business event select query
   *
   * @param array $params
   * @param array $customParams
   * @return string $select;
   */
  public function getSitebusinessEventsSelect($params = array()) {

    $table = Engine_Api::_()->getDbtable('events', 'sitebusinessevent');
    $rName = $table->info('name');

    $locationTable = Engine_Api::_()->getDbtable('locationitems', 'seaocore');
    $locationName = $locationTable->info('name');
    
		$businessPackagesTable = Engine_Api::_()->getDbtable('packages', 'sitebusiness');
		$businessPackageTableName = $businessPackagesTable->info('name');
		
		$tableBusiness = Engine_Api::_()->getDbtable('business', 'sitebusiness');
		$tableBusinessName = $tableBusiness->info('name');
		
    $select = $table->select();
    $select = $select
            ->setIntegrityCheck(false)
            ->from($rName);

    $select = $select
                ->where($rName . '.search = ?', '1');
		$select->join($tableBusinessName, "$tableBusinessName.business_id = $rName.business_id", array('business_id', 'title AS business_title', 'closed', 'approved', 'declined', 'draft', 'expiration_date', 'owner_id', 'photo_id as business_photo_id'))
			->join($businessPackageTableName, "$businessPackageTableName.package_id = $tableBusinessName.package_id",array('package_id', 'price'));
			
    if ((isset($params['sitebusiness_location']) && !empty($params['sitebusiness_location'])) ) {
      if (isset($params['locationmiles']) && (!empty($params['locationmiles']))) {
        $longitude = 0;
        $latitude = 0;
        
        //check for zip code in location search.
        if(empty($params['Latitude']) && empty($params['Longitude'])) {
          $selectLocQuery = $locationTable->select()->where('location = ?', $params['sitebusiness_location']);
          $locationValue = $locationTable->fetchRow($selectLocQuery);

          if (empty($locationValue)) {
            $locationResults = Engine_Api::_()->getApi('geoLocation', 'seaocore')->getLatLong(array('location' => $params['sitebusiness_location'], 'module' => 'Directory / Businesses - Events'));
            if(!empty($locationResults['latitude']) && !empty($locationResults['longitude'])) {
                $latitude = $locationResults['latitude'];
                $longitude = $locationResults['longitude'];
            }
          } else {
            $latitude = (float) $locationValue->latitude;
            $longitude = (float) $locationValue->longitude;
          }
        } else {
          $latitude = (float) $params['Latitude'];
          $longitude = (float) $params['Longitude'];
        }

        $radius = $params['locationmiles']; //in miles

        $flage = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitetagcheckin.proximity.search.kilometer', 0);
        if (!empty($flage)) {
          $radius = $radius * (0.621371192);
        }
        //$latitudeRadians = deg2rad($latitude);
        $latitudeSin = "sin(radians($latitude))";
        $latitudeCos = "cos(radians($latitude))";
        $select->join($locationName, "$rName.seao_locationid = $locationName.locationitem_id   ", array("latitude", "longitude", "(degrees(acos($latitudeSin * sin(radians($locationName.latitude)) + $latitudeCos * cos(radians($locationName.latitude)) * cos(radians($longitude - $locationName.longitude)))) * 69.172) AS distance"));
        $sqlstring = "(degrees(acos($latitudeSin * sin(radians($locationName.latitude)) + $latitudeCos * cos(radians($locationName.latitude)) * cos(radians($longitude - $locationName.longitude)))) * 69.172 <= " . "'" . $radius . "'";
        $sqlstring .= ")";
        $select->where($sqlstring);
        $select->order("distance");
      } else {
        $select->join($locationName, "$rName.seao_locationid = $locationName.locationitem_id");
        $select->where("`{$locationName}`.formatted_address LIKE ? or `{$locationName}`.location LIKE ? or `{$locationName}`.city LIKE ? or `{$locationName}`.state LIKE ?", "%" . urldecode($params['sitebusiness_location']) . "%");
        //}
      }
    } elseif (!empty($params['latitude']) && !empty($params['longitude'])) {
      $radius = Engine_Api::_()->getApi('settings', 'core')->getSetting('sgl.geolocation.range', 100); // in miles
      $latitude = $params['latitude'];
      $longitude = $params['longitude'];
      $flage = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.proximity.search.kilometer', 0);
      if (!empty($flage)) {
        $radius = $radius * (0.621371192);
      }
     // $latitudeRadians = deg2rad($latitude);
      $latitudeSin = sin($latitude);
      $latitudeCos = cos($latitude);
      $select->join($locationName, "$rName.seao_locationid = $locationName.locationitem_id", array("(degrees(acos($latitudeSin * sin(radians($locationName.latitude)) + $latitudeCos * cos(radians($locationName.latitude)) * cos(radians($longitude - $locationName.longitude)))) * 69.172) AS distance"));
      $sqlstring = "(degrees(acos($latitudeSin * sin(radians($locationName.latitude)) + $latitudeCos * cos(radians($locationName.latitude)) * cos(radians($longitude - $locationName.longitude)))) * 69.172 <= " . "'" . $radius . "'";
      $sqlstring .= ")";
      $select->where($sqlstring);
      $select->order("distance");
    } else {
      $select->joinLeft($locationName, "$rName.seao_locationid = $locationName.locationitem_id");
    }
    
			if (!empty($params['title'])) {
				$select->where($tableBusinessName . ".title LIKE ? ", '%' . $params['title'] . '%');
			}

			if (!empty($params['search_event'])) {
				$select->where($rName . ".title LIKE ?" , '%' . $params['search_event'] . '%');
			}

// 			if (!empty($params['category'])) {
// 				$select->where($tableBusinessName . '.category_id = ?', $params['category']);
// 			}

			if (!empty($params['category_id'])) {
				$select->where($tableBusinessName . '.category_id = ?', $params['category_id']);
			}

// 			if (!empty($params['subcategory'])) {
// 				$select->where($tableBusinessName . '.subcategory_id = ?', $params['subcategory']);
// 			}

			if (!empty($params['subcategory_id'])) {
				$select->where($tableBusinessName . '.subcategory_id = ?', $params['subcategory_id']);
			}

// 			if (!empty($params['subsubcategory'])) {
// 				$select->where($tableBusinessName . '.subsubcategory_id = ?', $params['subsubcategory']);
// 			}

			if (!empty($params['subsubcategory_id'])) {
				$select->where($tableBusinessName . '.subsubcategory_id = ?', $params['subsubcategory_id']);
			}
			
			if (isset($params['orderby']) && $params['orderby'] == 'view_count') {
					$select = $select
													->order($rName .'.view_count DESC')
													->order($rName .'.creation_date DESC');
			} elseif (isset($params['orderby']) && $params['orderby'] == 'member_count') {
				$select = $select
												->order($rName .'.member_count DESC');
			} elseif (isset($params['orderby']) && $params['orderby'] == 'creation_date') {
				$select = $select
												->order($rName .'.creation_date DESC');
			} elseif (isset($params['orderby']) && $params['orderby'] == 'starttime') {
				$select = $select
												->order(!empty($params['orderby']) ? $params['orderby'] . ' ASC' : $rName .'.starttime ASC');
			}
			
		  $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
			if(isset($params['show']) && $params['show'] == 'my_event') {
				$select->where($rName . '.user_id = ?', $viewer_id);
			}
			elseif(isset($params['show']) && $params['show'] == 'past_event') {
				$select->where("$rName.endtime < FROM_UNIXTIME(?)", time());
			}
			elseif((isset($params['show']) && $params['show'] == 'upcoming_event')) {
				$select->where("$rName.endtime > FROM_UNIXTIME(?)", time());
				$select->order($rName . '.starttime ASC');
			}
			elseif ((isset($params['show']) && $params['show'] == 'sponsored_event')) {
					
					$select->where($businessPackageTableName . '.price != ?', '0.00');
					$select->order($businessPackageTableName . '.price' . ' DESC');
			}
			elseif (isset($params['show']) && $params['show'] == 'Networks') {
					$select = $tableBusiness->getNetworkBaseSql($select, array('browse_network' => 1));

			}
			elseif((isset($params['show']) && $params['show'] == 'featured')) {
				$select = $select
												->where($rName . '.featured = ?', 1)
												->order($rName .'.creation_date DESC');
			}
			elseif (isset($params['show']) && $params['show'] == 'my_like') {
				$likeTableName = Engine_Api::_()->getDbtable('likes', 'core')->info('name');
				$viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
				$select
								->join($likeTableName, "$likeTableName.resource_id = $tableBusinessName.business_id")
								->where($likeTableName . '.poster_type = ?', 'user')
								->where($likeTableName . '.poster_id = ?', $viewer_id)
								->where($likeTableName . '.resource_type = ?', 'sitebusiness_business');
			}
			
		  $select = $select
											->where($tableBusinessName . '.search = ?', '1')
											->where($tableBusinessName . '.closed = ?', '0')
											->where($tableBusinessName . '.approved = ?', '1')
											->where($tableBusinessName . '.declined = ?', '0')
											->where($tableBusinessName . '.draft = ?', '1');
			if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
				$select->where($tableBusinessName . '.expiration_date  > ?', date("Y-m-d H:i:s"));
			}

// 		if (isset($params['order_by']) && !empty($params['order_by'])) {
// 			// Endtime
// 			if($params['order_by'] == 1 ) {
// 				$select->where("endtime <= FROM_UNIXTIME(?)", time());
// 			} elseif($params['order_by'] == 2 ) {
// 				$select->where("endtime > FROM_UNIXTIME(?)", time());
// 			}
// 		}

		if(!empty($params['starttime']['date'])) {
		  $startTime = date("Y-m-d", strtotime($params['starttime']));
			$select->where($rName . '.starttime >= ?', $startTime);
   	}

		if(!empty($params['endtime']['date'])) {
		 $endTime = date("Y-m-d", strtotime($params['endtime']));
     $select->where($rName . '.endtime <= ?', $endTime);
   	}
		return $select;
	}
		
	public function sendInviteEmail($object, $actionObject = null, $notificationType = null, $emailType = null, $params = null, $memberIdsArray = array()) {

		$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
		$sitebusinessmemberEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember');
		$notificationsTable = Engine_Api::_()->getDbtable('notifications', 'activity');
		
		$manageAdminTable = Engine_Api::_()->getDbtable('manageadmins', 'sitebusiness');
		
    $viewer = Engine_Api::_()->user()->getViewer();
		$viewer_id = $viewer->getIdentity();

		$business_id = $object->business_id;

		$subject = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
		$owner = $subject->getOwner();

		//previous notification is delete.
		//$notificationsTable->delete(array('type =?' => "$notificationType", 'object_type = ?' => "sitebusiness_business", 'object_id = ?' => $business_id, 'subject_id = ?' => $viewer_id));

		//GET BUSINESS TITLE AND BUSINESS TITLE WITH LINK.
		$businesstitle = $subject->title;
		$business_url = Engine_Api::_()->sitebusiness()->getBusinessUrl($subject->business_id);
		$business_baseurl = 'http://' . $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getRouter()->assemble(array('business_url' => $business_url), 'sitebusiness_entry_view', true);
		$business_title_link = '<a href="' . $business_baseurl . '"  >' . $businesstitle . ' </a>';

    //ITEM TITLE AND TILTE WITH LINK.
		$item_title = $object->title;
		$item_title_url = $object->getHref();
		$item_title_baseurl = 'http://' . $_SERVER['HTTP_HOST']. $item_title_url;
		$item_title_link = "<a href='$item_title_baseurl'  >" . $item_title . " </a>";

    //POSTER TITLE AND PHOTO WITH LINK
		$poster_title = $viewer->getTitle();
		$poster_url = $viewer->getHref();
		$poster_baseurl = 'http://' . $_SERVER['HTTP_HOST']. $poster_url;
		$poster_title_link = "<a href='$poster_baseurl'  >" . $poster_title . " </a>";
		if($viewer->photo_id) {
			$photo = 'http://' . $_SERVER['HTTP_HOST'] . $viewer->getPhotoUrl('thumb.icon');
		}
		else {
			$photo = 'http://' . $_SERVER['HTTP_HOST'] . $view->baseUrl() .  '/application/modules/Sitebusiness/externals/images/nophoto_sitebusiness_thumb_icon.png';
		}
		$image = "<img src='$photo' />";
		$posterphoto_link = "<a href='$poster_baseurl'  >" . $image . " </a>";

		//MEASSGE WITH LINK.
		if(!empty($actionObject) && isset($actionObject)) {
			$post_baseUrl = 'http://' . $_SERVER['HTTP_HOST'] . $actionObject->getHref();
			$post = $poster_title . ' Posted in ' . $businesstitle;
			$post_link = "<a href='$post_baseUrl'  >" . $post . " </a>";
		}


		//FETCH DATA
		if ($params == 'InviteMembers') {
			foreach ($memberIdsArray as $value) {
				$user_subject = Engine_Api::_()->user()->getUser($value['user_id']);
				if(!empty($value['email'])) {
					Engine_Api::_()->getApi('mail', 'core')->sendSystem($user_subject->email, "SITEBUSINESSEVENT_INVITE_EMAIL", array(
							'business_title' => $businesstitle,
							'item_title_with_link' => $item_title_link,
							'item_title' => $item_title,
							'viewertitle_link' => $poster_title_link,
							'viewerphoto_link' => $posterphoto_link,
					));
				}
			}
		} elseif($params == 'Businessevent Invite') {
		  $businessMembers = Engine_Api::_()->getDbtable('membership', 'sitebusiness')->getJoinMembers($business_id);
			foreach ($businessMembers as $value) {
				$user_subject = Engine_Api::_()->user()->getUser($value['user_id']);
				if(!empty($value['email'])) {
					Engine_Api::_()->getApi('mail', 'core')->sendSystem($user_subject->email, "SITEBUSINESSEVENT_INVITE_EMAIL", array(
							'business_title' => $businesstitle,
							'item_title_with_link' => $item_title_link,
							'item_title' => $item_title,
							'viewertitle_link' => $poster_title_link,
							'viewerphoto_link' => $posterphoto_link,
					));
				}
			}
		}
		else {
			$manageAdminsIds = $manageAdminTable->getManageAdmin($business_id, $viewer_id);
			foreach ($manageAdminsIds as $value) {
				$user_subject = Engine_Api::_()->user()->getUser($value['user_id']);
				if(!empty($value['email'])) {
					Engine_Api::_()->getApi('mail', 'core')->sendSystem($user_subject->email, "SITEBUSINESSEVENT_INVITE_EMAIL", array(
							'business_title' => $businesstitle,
							'item_title_with_link' => $item_title_link,
							'item_title' => $item_title,
							'viewertitle_link' => $poster_title_link,
							'viewerphoto_link' => $posterphoto_link,
					));
				}
			}
		}
		
		$object_type = $object->getType();
		$object_id = $object->getIdentity();
		$subject_type = $viewer->getType();
		$subject_id = $viewer->getIdentity();
		
		if (!empty($sitebusinessmemberEnabled)) {
			$db = Zend_Db_Table_Abstract::getDefaultAdapter();
			if ($params == 'InviteMembers') {
				$friendId = $memberIdsArray;
			} else {
				$friendId = Engine_Api::_()->user()->getViewer()->membership()->getMembershipsOfIds();
			}
			if (!empty($friendId)) {
				$db->query("INSERT IGNORE INTO `engine4_activity_notifications` (`user_id`, `subject_type`, `subject_id`, `object_type`, `object_id`, `type`,`params`, `date`) SELECT `engine4_sitebusiness_membership`.`user_id` as `user_id` ,	'". $subject_type ."' as `subject_type`, " . $subject_id . " as `subject_id`, '" . $object_type . "' as `object_type`, " . $object_id . " as `object_id`, '".$notificationType."' as `type`, 'null' as `params`, '" . date('Y-m-d H:i:s') . "' as ` date `  FROM `engine4_sitebusiness_membership` WHERE (engine4_sitebusiness_membership.business_id = ".$subject->business_id.") AND (engine4_sitebusiness_membership.user_id <> ".$viewer->getIdentity().") AND (engine4_sitebusiness_membership.notification = 1 or (engine4_sitebusiness_membership.notification = 2 and (engine4_sitebusiness_membership .user_id IN (".join(",",$friendId)."))))");
			} else {
				$db->query("INSERT IGNORE INTO `engine4_activity_notifications` (`user_id`, `subject_type`, `subject_id`, `object_type`, `object_id`, `type`,`params`, `date`) SELECT `engine4_sitebusiness_membership`.`user_id` as `user_id` ,	'". $subject_type ."' as `subject_type`, " . $subject_id . " as `subject_id`, '" . $object_type . "' as `object_type`, " . $object_id . " as `object_id`, '".$notificationType."' as `type`, 'null' as `params`, '" . date('Y-m-d H:i:s') . "' as ` date `  FROM `engine4_sitebusiness_membership` WHERE (engine4_sitebusiness_membership.business_id = ".$subject->business_id.") AND (engine4_sitebusiness_membership.user_id <> ".$viewer->getIdentity().") AND (engine4_sitebusiness_membership.notification = 1)");
			}
		}
  }
}