<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    sitebusinessevent
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Menus.php 6590 2010-10-19 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessevent_Plugin_Menus {

  //SHOWING THE EDIT LINK ON THE LEFT SITE MENU ON EVENT VIEW BUSINESS
  public function onMenuInitialize_SitebusinesseventGutterEdit($row) {
    
    //GETTING THE VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();

    //GETTING THE SITEBUSINESSEVENT SUBJECT
    $subject = Engine_Api::_()->core()->getSubject();

    //GETTING THE TAB ID
    $tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab_id', null);

    // SITEBUSINESSEVENT SUBJECT OR NOT
    if ($subject->getType() !== 'sitebusinessevent_event') {
      $error_msg1 = Zend_Registry::get('Zend_Translate')->_('Whoops, not a business event!');
      throw new Sitebusinessevent_Model_Exception($error_msg1);
    }

    //START MANAGE-ADMIN CHECK
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $subject->business_id);
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK
    
    // SUPERADMIN, EVENT OWNER AND SITEBUSINESS OWNER CAN EDIT EVENT
    if ($viewer->getIdentity() != $subject->user_id && $can_edit != 1) {
      return false;
    }

    //Return EDIT LINK
    return array(
        'label' => 'Edit_Event_Details',
        'icon' => Zend_Registry::get('Zend_View')->layout()->staticBaseUrl.'application/modules/Sitebusiness/externals/images/icons/edit.png',
        'route' => 'sitebusinessevent_specific',
        'params' => array(
            'controller' => 'index',
            'action' => 'edit',
            'event_id' => $subject->getIdentity(),
            'business_id' => $subject->business_id,
            'tab_id' => $tab_selected_id
        )
    );
  }

  //SHOWING THE CREATE LINK ON THE LEFT SITE MENU ON EVENT VIEW BUSINESS
  public function onMenuInitialize_SitebusinesseventGutterCreate($row) {
    
    //GETTING THE VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();

    //GETTING THE SITEBUSINESSEVENT SUBJECT
    $subject = Engine_Api::_()->core()->getSubject();

    //GETTING THE TAB ID
    $tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab_id', null);

    // SITEBUSINESSEVENT SUBJECT OR NOT
    if ($subject->getType() !== 'sitebusinessevent_event') {
      $error_msg2 = Zend_Registry::get('Zend_Translate')->_('Whoops, not a business event!');
      throw new Sitebusinessevent_Model_Exception($error_msg2);
    }

    //START MANAGE-ADMIN CHECK
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $subject->business_id);
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'secreate');
    if (empty($isManageAdmin)) {
      $can_create = 0;
    } else {
      $can_create = 1;
    }
    //END MANAGE-ADMIN CHECK
    
    //CHECK THE VIEWER IS BUSINESS OWNER OR NOT
    if ($can_create != 1) {
      return false;
    }

    //RETURN CREATE LINK
    return array(
        'label' => 'Create_Event',
        'icon' => Zend_Registry::get('Zend_View')->layout()->staticBaseUrl.'application/modules/Sitebusiness/externals/images/icons/sitebusinessevent_create.png',
        'route' => 'sitebusinessevent_create',
        'params' => array(
            'business_id' => $subject->business_id,
            'tab_id' => $tab_selected_id
        )
    );
  }

  //SHOWING THE MEMBER LINK ON THE LEFT SITE MENU ON EVENT VIEW BUSINESS
  public function onMenuInitialize_SitebusinesseventGutterMember() {
    
    //GETTING THE VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();

    //GETTING THE TAB ID
    $tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab_id', null);

    //GETTING THE SITEBUSINESSEVENT SUBJECT
    $subject = Engine_Api::_()->core()->getSubject();

    //GETTING THE SITEBUSINESS ITEM	
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $subject->business_id);

    //GETTING THE VIEWER Id
    $viewer_id = $viewer->getIdentity();
    if (!empty($viewer_id)) {
      $level_id = $viewer->level_id;
    } else {
      $level_id = 0;
    }

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK
    
    // SUPERADMIN, EVENT OWNER AND SITEBUSINESS OWNER CAN DELETE EVENT
    if ($viewer_id == $subject->user_id || $can_edit == 1) {
      $can_delete = 1;
    } else {
      $can_delete = 0;
    }

    //SITEBUSINESSEVENT SUBJECT OR NOT
    if ($subject->getType() !== 'sitebusinessevent_event') {
      $error_msg3 = Zend_Registry::get('Zend_Translate')->_('Whoops, not a business event!');
      throw new Sitebusinessevent_Model_Exception($error_msg3);
    }

    //SITEBUSINESSEVENT SUBJECT OR NOT
    if (!$viewer->getIdentity()) {
      return false;
    }

    $row = $subject->membership()->getRow($viewer);
    if (null === $row) {
      if ($subject->membership()->isResourceApprovalRequired()) {
        return array(
            //RETURN THE REQUEST INVITE LINK
            'label' => 'Request_Invite',
            'icon' => Zend_Registry::get('Zend_View')->layout()->staticBaseUrl.'application/modules/Sitebusiness/externals/images/icons/sitebusinessevent_join.png',
            'class' => 'smoothbox',
            'route' => 'sitebusinessevent_specific',
            'params' => array(
                'controller' => 'index',
                'action' => 'request',
                'event_id' => $subject->getIdentity(),
                'business_id' => $subject->business_id,
                'tab_id' => $tab_selected_id
            ),
        );
      } else {
        //RETURN THE JOIN EVENT LINK
        return array(
            'label' => 'Join_Event',
            'icon' => Zend_Registry::get('Zend_View')->layout()->staticBaseUrl.'application/modules/Sitebusiness/externals/images/icons/sitebusinessevent_join.png',
            'class' => 'smoothbox',
            'route' => 'sitebusinessevent_specific',
            'params' => array(
                'controller' => 'index',
                'action' => 'join',
                'event_id' => $subject->getIdentity(),
                'business_id' => $subject->business_id,
                'tab_id' => $tab_selected_id
            ),
        );
      }
    } else if ($row->active) {
      //RETURN THE LEAVE EVENT LINK
      if (!$subject->isOwner($viewer)) {
        return array(
            'label' => 'Leave_Event',
            'icon' => Zend_Registry::get('Zend_View')->layout()->staticBaseUrl.'application/modules/Sitebusiness/externals/images/icons/sitebusinessevent_leave.png',
            'class' => 'smoothbox',
            'route' => 'sitebusinessevent_specific',
            'params' => array(
                'controller' => 'index',
                'action' => 'leave',
                'event_id' => $subject->getIdentity(),
                'business_id' => $subject->business_id,
                'tab_id' => $tab_selected_id
            ),
        );
      } elseif ($can_delete) {
        //RETURN THE DELETE EVENT LINK
        return array(
            'label' => 'Delete_Event',
            'icon' => Zend_Registry::get('Zend_View')->layout()->staticBaseUrl.'application/modules/Sitebusiness/externals/images/icons/delete.png',
            'route' => 'sitebusinessevent_specific',
            'params' => array(
                'controller' => 'index',
                'action' => 'delete',
                'event_id' => $subject->getIdentity(),
                'business_id' => $subject->business_id,
                'tab_id' => $tab_selected_id
            ),
        );
      }
    } else if (!$row->resource_approved && $row->user_approved) {
      //RETURN THE CANCEL EVENT LINK
      return array(
          'label' => 'Cancel_Invite_Request',
          'icon' => Zend_Registry::get('Zend_View')->layout()->staticBaseUrl.'application/modules/Sitebusiness/externals/images/icons/sitebusinessevent_cancel.png',
          'class' => 'smoothbox',
          'route' => 'sitebusinessevent_extended',
          'params' => array(
              'controller' => 'index',
              'action' => 'cancel',
              'event_id' => $subject->getIdentity(),
              'business_id' => $subject->business_id,
              'user_id' => $viewer->getIdentity(),
              'tab_id' => $tab_selected_id
          ),
      );
    } else if (!$row->user_approved && $row->resource_approved) {
      //RETURN THE ACCEPT OR IGONRE EVENT LINK
      return array(
          array(
              'label' => 'Accept_Event_Invite',
              'icon' => Zend_Registry::get('Zend_View')->layout()->staticBaseUrl.'application/modules/Sitebusiness/externals/images/icons/sitebusinessevent_accept.png',
              'class' => 'smoothbox',
              'route' => 'sitebusinessevent_extended',
              'params' => array(
                  'controller' => 'index',
                  'action' => 'accept',
                  'event_id' => $subject->getIdentity(),
                  'business_id' => $subject->business_id,
                  'user_id' => $viewer->getIdentity(),
                  'tab_id' => $tab_selected_id,
              ),
          ), array(
              'label' => 'Ignore_Event_Invite',
              'icon' => Zend_Registry::get('Zend_View')->layout()->staticBaseUrl.'application/modules/Sitebusiness/externals/images/icons/sitebusinessevent_reject.png',
              'class' => 'smoothbox',
              'route' => 'sitebusinessevent_extended',
              'params' => array(
                  'controller' => 'index',
                  'action' => 'reject',
                  'event_id' => $subject->getIdentity(),
                  'business_id' => $subject->business_id,
                  'user_id' => $viewer->getIdentity(),
                  'tab_id' => $tab_selected_id
              ),
          )
      );
    } else {
      $error_msg4 = Zend_Registry::get('Zend_Translate')->_('An error has occurred.');
      throw new Sitebusinessevent_Model_Exception($error_msg4);
    }

    return false;
  }

  //SHOWING THE INVITE LINK ON THE LEFT SITE MENU ON EVENT VIEW BUSINESS
  public function onMenuInitialize_SitebusinesseventGutterInvite() {
    
    //GETTING THE VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();

    //GETTING THE TAB ID
    $tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab_id', null);

    //GETTING THE SITEBUSINESSEVENT SUBJECT
    $subject = Engine_Api::_()->core()->getSubject();

    // SITEBUSINESSEVENT SUBJECT OR NOT
    if ($subject->getType() !== 'sitebusinessevent_event') {
      throw new Sitebusinessevent_Model_Exception('This business event does not exist.');
    }

    //CHECK WHETHER THE PERSON HAS ALLOWES TO INVITE OTHER PEOPLE TO THEIR EVENT.
    if (!$subject->authorization()->isAllowed($viewer, 'invite')) {
      return false;
    }
    
		$businessmember = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember');
		$businessasgroup = Engine_Api::_()->getApi('settings', 'core')->getSetting( 'businessmember.businessasgroup');
		if (!empty($businessmember) && !empty($businessasgroup)) {
			return false;
		}


    //RETURN INVITE LINK
    return array(
        'label' => 'Invite_Guests',
        'icon' => Zend_Registry::get('Zend_View')->layout()->staticBaseUrl.'application/modules/Sitebusiness/externals/images/icons/invite.png',
        'class' => 'smoothbox',
        'route' => 'sitebusinessevent_specific',
        'params' => array(
            'controller' => 'index',
            'action' => 'invite',
            'event_id' => $subject->getIdentity(),
            'business_id' => $subject->business_id,
            'format' => 'smoothbox',
            'tab_id' => $tab_selected_id,
        ),
    );
  }

  public function onMenuInitialize_SitebusinesseventGutterShare() {
    
    //GETTING THE VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();

    //GETTING THE TAB ID
    $tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab_id', null);

    //GETTING THE SITEBUSINESSEVENT SUBJECT
    $subject = Engine_Api::_()->core()->getSubject();

    //SITEBUSINESSEVENT SUBJECT OR NOT
    if ($subject->getType() !== 'sitebusinessevent_event') {
      $error_msg5 = Zend_Registry::get('Zend_Translate')->_('This business event does not exist.');
      throw new Sitebusinessevent_Model_Exception($error_msg5);
    }

    //CHECK WHETHER THE PERSON IS THERE OR NOT
    if (!$viewer->getIdentity()) {
      return false;
    }

    //RETURN SHARE LINK
    return array(
        'label' => 'Share_This_Event',
        'icon' => Zend_Registry::get('Zend_View')->layout()->staticBaseUrl.'application/modules/Sitebusinessevent/externals/images/share.png',
        'class' => 'smoothbox',
        'route' => 'default',
        'params' => array(
            'module' => 'activity',
            'controller' => 'index',
            'action' => 'share',
            'type' => $subject->getType(),
            'id' => $subject->getIdentity(),
            'format' => 'smoothbox',
            'tab_id' => $tab_selected_id
        ),
    );
  }

  public function onMenuInitialize_SitebusinesseventGutterBacktobusiness() {
    
    //GETTING THE VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();

    //GETTING THE TAB ID
    $tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab_id', null);

    //GETTING THE SITEBUSINESSEVENT SUBJECT
    $subject = Engine_Api::_()->core()->getSubject();
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $subject->business_id);   
    // SITEBUSINESSEVENT SUBJECT OR NOT
    if ($subject->getType() !== 'sitebusinessevent_event') {
      $error_msg6 = Zend_Registry::get('Zend_Translate')->_('This business event does not exist.');
      throw new Sitebusinessevent_Model_Exception($error_msg6);
    }

    $business_url = $sitebusiness->getHref(array('tab' => $tab_selected_id));
   
    //RETURN BACK TO BUSINESS LINK
    return array(
        'label' => 'Back to Business',
        'icon' => Zend_Registry::get('Zend_View')->layout()->staticBaseUrl.'application/modules/Sitebusiness/externals/images/icons/back16.gif',
        'uri' =>  $business_url
        
    );
  }

  public function onMenuInitialize_SitebusinesseventGutterDay() {
    
    //GETTING THE VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();

    //GETTING THE SITEBUSINESSEVENT SUBJECT
    $subject = Engine_Api::_()->core()->getSubject();
    $allowView = false;
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $subject->business_id);
    if (($viewer->getIdentity()) && ($viewer->level_id == 1)) {
      $auth = Engine_Api::_()->authorization()->context;
      $allowView = $auth->isAllowed($sitebusiness, 'everyone', 'view') === 1 ? true : false ||$auth->isAllowed($sitebusiness, 'registered', 'view') === 1 ? true : false;
    } 
    if(empty($allowView)) {
      return false;
   }
   return array(
				'route' => 'default',
				'class' => 'smoothbox',
        'icon' => Zend_Registry::get('Zend_View')->layout()->staticBaseUrl.'application/modules/Sitebusiness/externals/images/icons/sitebusinessevent.png',
				'params' => array(
						'module' => 'sitebusinessevent',
						'controller' => 'index',
						'action' => 'add-event-of-day',
						'event_id' => $subject->event_id,
				),
    );
  }


  public function canViewEvents() {

    if (!Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessevent.event.show.menu', 1)) {
      return false;
    }

    $table = Engine_Api::_()->getDbtable('events', 'sitebusinessevent');
    $rName = $table->info('name');
    $table_businesses = Engine_Api::_()->getDbtable('business', 'sitebusiness');
    $rName_businesses = $table_businesses->info('name');
    $select = $table->select()
                    ->setIntegrityCheck(false)
                    ->from($rName_businesses, array('photo_id', 'title as sitebusiness_title'))
                    ->join($rName, $rName . '.business_id = ' . $rName_businesses . '.business_id')
                    ->where($rName .'.search = ?', 1);

    $select = $select
                    ->where($rName_businesses . '.closed = ?', '0')
                    ->where($rName_businesses . '.approved = ?', '1')
                    ->where($rName_businesses . '.search = ?', '1')
                    ->where($rName_businesses . '.declined = ?', '0')
                    ->where($rName_businesses . '.draft = ?', '1');
    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
      $select->where($rName_businesses . '.expiration_date  > ?', date("Y-m-d H:i:s"));
    }
    $row = $table->fetchAll($select);
    $count = count($row);
    if (empty($count)) {
      return false;
    }
    return true;
  }
  
  //SHOWING THE EDIT LINK ON THE LEFT SITE MENU ON EVENT VIEW BUSINESS
  public function onMenuInitialize_SitebusinesseventGutterEditlocation($row) {
    
    //GETTING THE VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();

    //GETTING THE SITEBUSINESSEVENT SUBJECT
    $subject = Engine_Api::_()->core()->getSubject();

    //GETTING THE TAB ID
    $tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab_id', null);

    // SITEBUSINESSEVENT SUBJECT OR NOT
    if ($subject->getType() !== 'sitebusinessevent_event') {
      $error_msg1 = Zend_Registry::get('Zend_Translate')->_('Whoops, not a business event!');
      throw new Sitebusinessevent_Model_Exception($error_msg1);
    }

    //START MANAGE-ADMIN CHECK
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $subject->business_id);
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK
    
    // SUPERADMIN, EVENT OWNER AND SITEBUSINESS OWNER CAN EDIT EVENT
    if ($viewer->getIdentity() != $subject->user_id && $can_edit != 1) {
      return false;
    }

    //Return EDIT LINK
    return array(
        'label' => 'Edit Location',
        'icon' => Zend_Registry::get('Zend_View')->layout()->staticBaseUrl.'application/modules/Sitebusiness/externals/images/map.png',
        'route' => 'sitebusinessevent_specific',
        'params' => array(
            'controller' => 'index',
            'action' => 'edit-location',
            'seao_locationid' => $subject->seao_locationid,
            'event_id' => $subject->getIdentity(),
            'business_id' => $subject->business_id,
            'tab_id' => $tab_selected_id
        )
    );
  }
    public function onMenuInitialize_SitebusinesseventGutterInviteMembers($row) {
    
    //GETTING THE VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    //GETTING THE TAB ID
    $tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab_id', null);

    //GETTING THE SITEBUSINESSEVENT SUBJECT
    $subject = Engine_Api::_()->core()->getSubject();
	  $business_id = $subject->business_id;
	  
    // SITEBUSINESSEVENT SUBJECT OR NOT
    if ($subject->getType() !== 'sitebusinessevent_event') {
      throw new Sitebusinessevent_Model_Exception('This business event does not exist.');
    }

		$businessmember = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember');
		if (empty($businessmember)) {
			return false;
		} else {
			$select = Engine_Api::_()->getDbTable('membership', 'sitebusiness')->hasMembers($viewer_id, $business_id);
			$businessasgroup = Engine_Api::_()->getApi('settings', 'core')->getSetting( 'businessmember.businessasgroup');
    }
    if (empty($select)) {
			return false;
    }
    if(empty($businessasgroup)) {
			return false;
    }

    //CHECK WHETHER THE PERSON HAS ALLOWES TO INVITE OTHER PEOPLE TO THEIR EVENT.
//     if (!$subject->authorization()->isAllowed($viewer, 'invite')) {
//       return false;
//     }

    // Modify params
    $params = $row->params;
    $params['params']['business_id'] = $business_id;
    $params['params']['event_id'] = $subject->getIdentity();
    return $params;
  }
  

 //PHOTO VIEW BUSINESS OPTIONS
  public function onMenuInitialize_SitebusinesseventPhotoEdit($row) {

     //GET VIEWER ID
    $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();

    $subject = Engine_Api::_()->core()->getSubject();
    //GET ALBUM ID
   $event_id = $subject->event_id;
    
    $sitebusinessevent = Engine_Api::_()->getItem('sitebusinessevent_event', $event_id);
    
    //GET BUSINESS ID
    $business_id = $sitebusinessevent->business_id;

    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
 
    //PHOTO OWNER, BUSINESS OWNER AND SUPER-ADMIN CAN EDIT PHOTO
    if ($viewer_id != $subject->user_id && $can_edit != 1) {
      return false;
    }


    return array(
        'label' => 'Edit',
        'route' => 'sitebusinessevent_photo_extended',
        'class' => 'ui-btn-action smoothbox',
        'params' => array(
          'action' => 'photo-edit',
            'photo_id' => $subject->photo_id,
            'event_id' => $event_id,
            'business_id' => $business_id,
            'tab' => Zend_Controller_Front::getInstance()->getRequest()->getParam('tab')
        )
    );
  }

  public function onMenuInitialize_SitebusinesseventPhotoDelete($row) {

     //GET VIEWER ID
    $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();

    $subject = Engine_Api::_()->core()->getSubject();
    //GET ALBUM ID
   $event_id = $subject->event_id;
    
    $sitebusinessevent = Engine_Api::_()->getItem('sitebusinessevent_event', $event_id);
    
    //GET BUSINESS ID
    $business_id = $sitebusinessevent->business_id;

    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
 
    //PHOTO OWNER, BUSINESS OWNER AND SUPER-ADMIN CAN EDIT PHOTO
    if ($viewer_id != $subject->user_id && $can_edit != 1) {
      return false;
    }
    
    return array(
        'label' => 'Delete',
        'route' => 'sitebusinessevent_photo_extended',
        'class' => 'ui-btn-danger smoothbox',
        'params' => array(
            'action' => 'remove',
            'photo_id' => $subject->photo_id,
            'event_id' => $event_id,
            'business_id' =>  $business_id,
            'owner_id' => $subject->user_id,
            'tab' => Zend_Controller_Front::getInstance()->getRequest()->getParam('tab')
        )
    );
  }

  public function onMenuInitialize_SitebusinesseventPhotoShare($row) {
    $subject = Engine_Api::_()->core()->getSubject();
    //GET VIEWER ID
    $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
    
    if(!$viewer_id){
      return false;
    }
    if (!SEA_PHOTOLIGHTBOX_SHARE) {
      return false;
    }
    return array(
        'label' => 'Share',
        'class' => 'ui-btn-action smoothbox',
        'route' => 'default',
        'params' => array(
            'module' => 'activity',
            'action' => 'share',
            'type' => $subject->getType(),
            'id' => $subject->getIdentity(),
        )
    );
  }

  public function onMenuInitialize_SitebusinesseventPhotoReport($row) {
    $subject = Engine_Api::_()->core()->getSubject();
    //GET VIEWER ID
    $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
    
    if(!$viewer_id){
      return false;
    }
    if (!SEA_PHOTOLIGHTBOX_REPORT) {
      return false;
    }
    return array(
        'label' => 'Report',
        'class' => 'ui-btn-action smoothbox',
        'route' => 'default',
        'params' => array(
            'module' => 'core',
            'controller' => 'report',
            'action' => 'create',
            'subject' => $subject->getGuid(),
        )
    );
  }
}
