<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    sitebusinessevent
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: IndexController.php 6590 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessevent_IndexController extends Seaocore_Controller_Action_Standard {

  public function init() {

    //GET BUSINESS ID
    $business_id = $this->_getParam('business_id');

    //PACKAGE BASE PRIYACY START
    if (!empty($business_id)) {
      $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
      if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
        if (!Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessevent")) {
          return $this->_forwardCustom('requireauth', 'error', 'core');
        }
      } else {
        $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'secreate');
        if (empty($isBusinessOwnerAllow)) {
          return $this->_forwardCustom('requireauth', 'error', 'core');
        }
      }
    }
    //PACKAGE BASE PRIYACY END
    else {
      if ($this->_getParam('event_id') != null) {
        $sitebusinessevent = Engine_Api::_()->getItem('sitebusinessevent_event', $this->_getParam('event_id'));
        if ($sitebusinessevent) {
          $business_id = $sitebusinessevent->business_id;
        }
      }
    }

    //GET EVENT ID
    $event_id = $this->_getParam('event_id');
    if ($event_id) {
      $sitebusinessevent = Engine_Api::_()->getItem('sitebusinessevent_event', $event_id);
      if ($sitebusinessevent) {
        Engine_Api::_()->core()->setSubject($sitebusinessevent);
      }
    }
  }

  //ACTION FOR CREATE THE EVENT
  public function createAction() {

    //CHECK USER VALIDATION
    if (!$this->_helper->requireUser->isValid())
      return;

    //GET LOGGED IN USER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();

    //BUSINESS ID
    $business_id = $this->_getParam('business_id');

    //SEND TAB ID TO TPL FILE
    $this->view->tab_selected_id = $this->_getParam('tab_id');

    //SET PARENT TYPE
    $parent_type = 'sitebusiness_business';

    $getPackageevent = Engine_Api::_()->sitebusiness()->getPackageAuthInfo('sitebusinessevent');

    //GET SITEBUSINESS ITEM
    $this->view->sitebusiness = $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'view');
    if (empty($isManageAdmin)) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }

    $sitebusinessevent_isCraete = Zend_Registry::isRegistered('sitebusinessevent_isCraete') ? Zend_Registry::get('sitebusinessevent_isCraete') : null;
    if (empty($sitebusinessevent_isCraete)) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }

    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($isManageAdmin)) {
      $this->view->can_edit = $can_edit = 0;
    } else {
      $this->view->can_edit = $can_edit = 1;
    }

    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'secreate');
    if (empty($isManageAdmin) && empty($can_edit)) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }
    //END MANAGE-ADMIN CHECK
    //GET NAVIGATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitebusiness_main');

    //SHOW EVENT CREATE FORM
    $this->view->form = $form = new Sitebusinessevent_Form_Create(array(
        'parent_type' => $parent_type,
        'parent_id' => $business_id
    ));

    if (!Engine_API::_()->seaocore()->checkSitemobileMode('fullsite-mode')) {
      $form->addElement("dummy", "dummy", array('label' => 'Main Photo', 'description' => 'Sorry, the browser you are using does not support Photo uploading. We recommend you to create an Event from your mobile / tablet without uploading a main photo for it. You can later upload the main photo from your Desktop.', 'order' => 6, 'style' => 'display:none;'));
      if (preg_match('/' . 'iPad' . '/i', $_SERVER['HTTP_USER_AGENT'])) {
        if (isset($form->photo)) {
          $form->removeElement('photo');
        }
      } else {
        if (isset($form->photo)) {
          $form->photo->setAttrib('accept', "image/*");
        }
      }
    }

    // Populate with categories
    $categories = Engine_Api::_()->getDbtable('categories', 'sitebusinessevent')->getCategoriesAssoc();
    asort($categories, SORT_LOCALE_STRING);
    $categoryOptions = array('0' => '');
    foreach ($categories as $k => $v) {
      $categoryOptions[$k] = $v;
    }
    if (sizeof($categoryOptions) <= 1) {
      $form->removeElement('category_id');
    } else {
      $form->category_id->setMultiOptions($categoryOptions);
    }

    $get_event = Engine_Api::_()->getItemTable('sitebusinessevent_event')->getEventUserType();

    $sitebusinessModHostName = str_replace('www.', '', strtolower($_SERVER['HTTP_HOST']));

    if (empty($get_event)) {
      return;
    }

    //IF NOT POST OR FORM NOT VALID, RETURN
    if ((!$this->getRequest()->isPost())) {
      return;
    }

    //IF NOT POST OR FORM NOT VALID, RETURN
    if (!$form->isValid($this->getRequest()->getPost())) {
      return;
    }

    //PROCESS
    $values = empty($getPackageevent) ? null : $form->getValues();
    if (empty($values)) {
      return $this->_helper->redirector->gotoRoute(array('business_url' => Engine_Api::_()->sitebusiness()->getBusinessUrl($business_id), 'tab' => $this->view->tab_selected_id), 'sitebusiness_entry_view', true);
    }

    $isModType = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessevent.set.type', 0);
    if (empty($isModType)) {
      Engine_Api::_()->getApi('settings', 'core')->setSetting('sitebusinessevent.keyword', convert_uuencode($sitebusinessModHostName));
    }

    //SET USER ID AND PARENT TYPE
    $values['user_id'] = $viewer->getIdentity();
    $values['parent_type'] = $parent_type;

    //CONVERT TIMES
    $oldTz = date_default_timezone_get();
    date_default_timezone_set($viewer->timezone);
    $start = strtotime($values['starttime']);
    $end = strtotime($values['endtime']);
    date_default_timezone_set($oldTz);
    $values['starttime'] = date('Y-m-d H:i:s', $start);
    $values['endtime'] = date('Y-m-d H:i:s', $end);

    //PROCESS
    $db = Engine_Api::_()->getDbTable('events', 'sitebusinessevent')->getAdapter();
    $db->beginTransaction();
    try {
      //CREATE EVENT      
      $tableEvent = Engine_Api::_()->getDbTable('events', 'sitebusinessevent');
      $sitebusinessevent = $tableEvent->createRow();
      $sitebusinessevent->setFromArray($values);
      $sitebusinessevent->save();

      //ADD OWNER AS MEMBER
      $sitebusinessevent->membership()->addMember($viewer)
              ->setUserApproved($viewer)
              ->setResourceApproved($viewer);

      //ADD OWNER RSVP
      $sitebusinessevent->membership()
              ->getMemberInfo($viewer)
              ->setFromArray(array('rsvp' => 2))
              ->save();

      //SAVE VALUES     
      $sitebusinessevent->business_id = $business_id;
      $sitebusinessevent->view_count = 1;
      $sitebusinessevent->save();

      //PROCESS PRIVACY
      $auth = Engine_Api::_()->authorization()->context;
      if(isset($values['auth_invite']))
      $auth->setAllowed($sitebusinessevent, 'member', 'invite', $values['auth_invite']);

      //COMMENT PRIVACY
      $roles = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
      $auth_view = "everyone";
      $viewMax = array_search($auth_view, $roles);
      foreach ($roles as $i => $role) {
        $auth->setAllowed($sitebusinessevent, $role, 'view', ($i <= $viewMax));
      }

      //ADD PHOTO
      if (!empty($values['photo'])) {
        $sitebusinessevent->setPhoto($form->photo);
      }

      //INSERT ACTIVITY IF EVENT IS SEARCHABLE
      if ($sitebusinessevent->search == 1) {
        $actionTable = Engine_Api::_()->getDbtable('actions', 'activity');
        $activityFeedType = null;
        if (Engine_Api::_()->sitebusiness()->isBusinessOwner($sitebusiness) && Engine_Api::_()->sitebusiness()->isFeedTypeBusinessEnable())
          $activityFeedType = 'sitebusinessevent_admin_new';
        elseif ($sitebusiness->all_post || Engine_Api::_()->sitebusiness()->isBusinessOwner($sitebusiness))
          $activityFeedType = 'sitebusinessevent_new';

        if ($activityFeedType) {
          $action = $actionTable->addActivity($viewer, $sitebusiness, $activityFeedType);
          Engine_Api::_()->getApi('subCore', 'sitebusiness')->deleteFeedStream($action);
        }
        if ($action != null) {
          $actionTable->attachActivity($action, $sitebusinessevent);
        }

        //SENDING ACTIVITY FEED TO FACEBOOK.
        $enable_Facebooksefeed = $enable_fboldversion = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('facebooksefeed');
        if (!empty($enable_Facebooksefeed)) {
          $event_array = array();
          $event_array['type'] = 'sitebusinessevent_new';
          $event_array['object'] = $sitebusinessevent;
          Engine_Api::_()->facebooksefeed()->sendFacebookFeed($event_array);
        }
      }

      if (!empty($values['all_members'])) {
        Engine_Api::_()->sitebusinessevent()->sendInviteEmail($sitebusinessevent, null, 'sitebusinessevent_invite', 'SITEBUSINESSEVENT_INVITE_EMAIL', 'Businessevent Invite');
      }

      //BUSINESS EVENT CREATE NOTIFICATION AND EMAIL WORK
      if (!empty($action)) {
				if (Engine_Api::_()->getDbtable('modules', 'core')->getModule('sitebusiness')) {
					$sitebusinessVersion = Engine_Api::_()->getDbtable('modules', 'core')->getModule('sitebusiness')->version;
					if ($sitebusinessVersion >= '4.3.0p1') {
						Engine_Api::_()->sitebusiness()->sendNotificationEmail($sitebusinessevent, $action, 'sitebusinessevent_create', 'SITEBUSINESSEVENT_CREATENOTIFICATION_EMAIL', 'Businessevent Invite');

						$isBusinessAdmins = Engine_Api::_()->getDbtable('manageadmins', 'sitebusiness')->isBusinessAdmins($viewer->getIdentity(), $business_id);
						if (!empty($isBusinessAdmins)) {

							//NOTIFICATION FOR ALL FOLLWERS.
							Engine_Api::_()->sitebusiness()->sendNotificationToFollowers($sitebusinessevent, $action, 'sitebusinessevent_create');
						}
					}
				}
      }

      //COMMIT
      $db->commit();

      //REDIRECTING TO THE EVENT VIEW BUSINESS
      return $this->_helper->redirector->gotoUrl($sitebusinessevent->getHref(), array('prependBase' => false));
    } catch (Engine_Image_Exception $e) {
      $db->rollBack();
      $form->addError(Zend_Registry::get('Zend_Translate')->_('The image you selected was too large.'));
    } catch (Exception $e) {
      $db->rollBack();
      throw $e;
    }
  }

  //ACTION FOR EDIT LOCATION
  public function editLocationAction() {

    //USER VALIDATION
    if (!$this->_helper->requireUser()->isValid())
      return;

    //GET LOGGED IN USER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();

    //SEND TAB ID TO TPL FILE
    $this->view->tab_selected_id = $this->_getParam('tab_id');

    //GET NAVIGATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitebusiness_main');

    //GET EVENT ID AND EVENT ITEM  
    $this->view->event_id = $event_id = $this->_getParam('event_id');
    $sitebusinessevent = Engine_Api::_()->getItem('sitebusinessevent_event', $event_id);

    //GET BUSINESS ID, BUSINESS OBJECT AND THEN CHECK BUSINESS VALIDATION
    $this->view->seao_locationid = $seao_locationid = $this->_getParam('seao_locationid');
    $this->view->business_id = $business_id = $this->_getParam('business_id');
    $this->view->sitebusiness = $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);

    //START MANAGE-ADMIN CHECK
    Engine_Api::_()->sitebusinessevent()->setEventPackages();
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK
    //EVENT OWNER, BUSINESS OWNER AND MANAGE ADMIN CAN EDIT EVENT
    if ($viewer->getIdentity() != $sitebusinessevent->user_id && $can_edit != 1) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }

    $value['id'] = $seao_locationid;
    $this->view->location = $location = Engine_Api::_()->getDbtable('locationitems', 'seaocore')->getLocations($value);

    //Get form
    if (!empty($location)) {

      $this->view->form = $form = new Seaocore_Form_Location(array(
          'item' => $sitebusiness,
          'location' => $location->location
      ));

      if (!$this->getRequest()->isPost()) {
        $form->populate($location->toarray()
        );
        return;
      }

      //FORM VALIDAITON
      if (!$form->isValid($this->getRequest()->getPost())) {
        return;
      }

      //FORM VALIDAITON
      if ($form->isValid($this->getRequest()->getPost())) {

        $values = $form->getValues();
        unset($values['submit']);
        unset($values['location']);

        $seLocationsTable = Engine_Api::_()->getDbtable('locationitems', 'seaocore');
// 
// 				$select = $seLocationsTable->select()->where('formatted_address LIKE ?', $values['formatted_address']);
// 				$results = $seLocationsTable->fetchRow($select);
// 
// 				if(empty($results->location_id)) {
// 					  //Accrodeing to event  location entry in the seaocore location table.
// 						$row = $seLocationsTable->createRow();
// 						$row->location = $location->location;
// 						$row->formatted_address = $values['formatted_address'];
// 						$row->latitude = $values['latitude'];
// 						$row->longitude = $values['longitude'];
// 						$row->address = $values['address'];
// 						$row->city = $values['city'];
// 						$row->zipcode = $values['zipcode'];
// 						$row->state = $values['state'];
// 						$row->country = $values['country'];
// 						$row->zoom = $values['zoom'];
// 						$row->save();
// 
// 						//event table entry of location id.
// 						$eventstable = Engine_Api::_()->getDbtable('events', 'sitebusinessevent');
// 						$eventstable->update(array('seao_locationid'=>  $row['location_id']), array('event_id =?' => $event_id));
// 				} else {
// 					//event table entry of location id.
// 					$eventstable = Engine_Api::_()->getDbtable('events', 'sitebusinessevent');
// 					$eventstable->update(array('seao_locationid'=>  $results->location_id), array('event_id =?' => $event_id));
// 				}
        $seLocationsTable->update($values, array('locationitem_id =?' => $seao_locationid));
      }
      $form->addNotice(Zend_Registry::get('Zend_Translate')->_('Your changes have been saved.'));
    }
    $this->view->location = Engine_Api::_()->getDbtable('locationitems', 'seaocore')->getLocations($value);
    //$this->view->location = Engine_Api::_()->getDbtable('locations', 'sitebusiness')->getLocation($value);
  }

  //ACTION FOR EDIT ADDRESS
  public function editAddressAction() {

    //USER VALIDATION
    if (!$this->_helper->requireUser()->isValid())
      return;

    //GET BUSINESS ID, BUSINESS OBJECT AND THEN CHECK BUSINESS VALIDATION
    $seao_locationid = $this->_getParam('seao_locationid');
    $tab_id = $this->_getParam('tab_id');
    $event_id = $this->_getParam('event_id');
    $business_id = $this->_getParam('business_id');
    $sitebusinessevent = Engine_Api::_()->getItem('sitebusinessevent_event', $event_id);

    $this->view->form = $form = new Sitebusinessevent_Form_Address(array('item' => $sitebusinessevent));

    //POPULATE FORM
    if (!$this->getRequest()->isPost()) {
      $form->populate($sitebusinessevent->toArray());
      return;
    }

    //FORM VALIDATION
    if (!$form->isValid($this->getRequest()->getPost())) {
      return;
    }

    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    try {

      $values = $form->getValues();

      $sitebusinessevent->location = $values['location'];
      if (empty($values['location'])) {
        //DELETE THE RESULT FORM THE TABLE.
        Engine_Api::_()->getDbtable('locationitems', 'seaocore')->delete(array('resource_id =?' => $event_id, 'resource_type = ?' => 'event'));
        $sitebusinessevent->seao_locationid = '0';
      }
      $sitebusinessevent->save();
      unset($values['submit']);

      if (!empty($values['location'])) {

        //DELETE THE RESULT FORM THE TABLE.
        Engine_Api::_()->getDbtable('locationitems', 'seaocore')->delete(array('resource_id =?' => $event_id, 'resource_type = ?' => 'sitebusinessevent_event'));

        $seaoLocation = Engine_Api::_()->getDbtable('locationitems', 'seaocore')->getLocationItemId($values['location'], '', 'sitebusinessevent_event', $event_id);

        //event table entry of location id.
        Engine_Api::_()->getDbtable('events', 'sitebusinessevent')->update(array('seao_locationid' => $seaoLocation), array('event_id =?' => $event_id));
      }

      $db->commit();
      $this->_forwardCustom('success', 'utility', 'core', array(
          'smoothboxClose' => 500,
          'parentRedirect' => $this->_helper->url->url(array('action' => 'edit-location', 'seao_locationid' => $seaoLocation, 'event_id' => $event_id, 'business_id' => $business_id, 'tab_id' => $tab_id), 'sitebusinessevent_specific', true),
          'parentRedirectTime' => '2',
          'format' => 'smoothbox',
          'messages' => array(Zend_Registry::get('Zend_Translate')->_('Your business event location has been modified successfully.'))
      ));
    } catch (Exception $e) {
      $db->rollBack();
      throw $e;
    }
  }

  //ACTION FOR EDIT THE EVENT
  public function editAction() {

    //CHECK USER VALIDATION
    if (!$this->_helper->requireUser()->isValid())
      return;

    //GET LOGGED IN USER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();

    //GET EVENT ID AND EVENT ITEM  
    $sitebusinessevent = Engine_Api::_()->getItem('sitebusinessevent_event', $this->getRequest()->getParam('event_id'));

    //BUSINESS ID
    $business_id = $sitebusinessevent->business_id;

    //SEND TAB ID TO TPL FILE
    $this->view->tab_selected_id = $this->_getParam('tab_id');

    //GET NAVIGATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitebusiness_main');

    //GENERATE EDIT FORM
    $this->view->form = $form = new Sitebusinessevent_Form_Edit(array('parent_type' => $sitebusinessevent->parent_type, 'parent_id' => $business_id));
   
    if (!Engine_API::_()->seaocore()->checkSitemobileMode('fullsite-mode')) {
      $form->addElement("dummy", "dummy", array('label' => 'Main Photo', 'description' => 'Sorry, the browser you are using does not support Photo uploading. We recommend you to edit an Event from your mobile / tablet without uploading a main photo for it. You can later upload the main photo from your Desktop.', 'order' => 6, 'style' => 'display:none;'));

      if (preg_match('/' . 'iPad' . '/i', $_SERVER['HTTP_USER_AGENT'])) {
        if (isset($form->photo)) {
          $form->removeElement('photo');
        }
      } else {
        if (isset($form->photo)) {
          $form->photo->setAttrib('accept', "image/*");
        }
      }
    }

    // Populate with categories
    $categories = Engine_Api::_()->getDbtable('categories', 'sitebusinessevent')->getCategoriesAssoc();
    asort($categories, SORT_LOCALE_STRING);
    $categoryOptions = array('0' => '');
    foreach ($categories as $k => $v) {
      $categoryOptions[$k] = $v;
    }
    if (sizeof($categoryOptions) <= 1) {
      $form->removeElement('category_id');
    } else {
      $form->category_id->setMultiOptions($categoryOptions);
    }

    //GET SITEBUSINESS ITEM    
    $this->view->sitebusiness = $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);

    //START MANAGE-ADMIN CHECK
    Engine_Api::_()->sitebusinessevent()->setEventPackages();
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK
    //EVENT OWNER, BUSINESS OWNER AND MANAGE ADMIN CAN EDIT EVENT
    if ($viewer->getIdentity() != $sitebusinessevent->user_id && $can_edit != 1) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }

    //IF NOT POST OR FORM NOT VALID, RETURN
    if (!$this->getRequest()->isPost()) {
      $auth = Engine_Api::_()->authorization()->context;
      $businessmember = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember');
      if (empty($businessmember)) {
				$form->auth_invite->setValue($auth->isAllowed($sitebusinessevent, 'member', 'invite'));
      }

      //POPULATE
      $form->populate($sitebusinessevent->toArray());

      //CONVERT AND RE-POPULATE TIMES
      $start = strtotime($sitebusinessevent->starttime);
      $end = strtotime($sitebusinessevent->endtime);
      $oldTz = date_default_timezone_get();
      date_default_timezone_set($viewer->timezone);
      $start = date('Y-m-d H:i:s', $start);
      $end = date('Y-m-d H:i:s', $end);
      date_default_timezone_set($oldTz);
      $form->populate(array(
          'starttime' => $start,
          'endtime' => $end,
      ));
      return;
    }

    if (!Engine_API::_()->seaocore()->checkSitemobileMode('fullsite-mode')) {
      $tempPost = $this->getRequest()->getPost();
      if (isset($tempPost['photo']))
        $form->removeElement('photo');
    }

    //IF NOT POST OR FORM NOT VALID, RETURN
    if (!$form->isValid($this->getRequest()->getPost())) {
      return;
    }

    //GET FORM VALUES
    $values = $form->getValues();

    //CONVERT TIMES
    $oldTz = date_default_timezone_get();
    date_default_timezone_set($viewer->timezone);
    $start = strtotime($values['starttime']);
    $end = strtotime($values['endtime']);
    date_default_timezone_set($oldTz);
    $values['starttime'] = date('Y-m-d H:i:s', $start);
    $values['endtime'] = date('Y-m-d H:i:s', $end);

    //PROCESS
    $db = Engine_Api::_()->getItemTable('sitebusinessevent_event')->getAdapter();
    $db->beginTransaction();

    try {
      //SET EVENT INFORMATION
      $sitebusinessevent->setFromArray($values);
      $sitebusinessevent->save();

      $auth = Engine_Api::_()->authorization()->context;
      if(isset($values['auth_invite']))
      $auth->setAllowed($sitebusinessevent, 'member', 'invite', $values['auth_invite']);

      //ADD PHOTO
      if (!empty($values['photo'])) {
        $sitebusinessevent->setPhoto($form->photo);
      }

      //COMMIT
      $db->commit();
    } catch (Engine_Image_Exception $e) {
      $db->rollBack();
      $form->addError(Zend_Registry::get('Zend_Translate')->_('The image you selected was too large.'));
    } catch (Exception $e) {
      $db->rollBack();
      throw $e;
    }

    //REDIRECTING TO THE EVENT VIEW BUSINESS
    return $this->_redirectCustom($sitebusinessevent->getHref(), array('prependBase' => false));
  }

  //ACTION FOR VIEW THE EVENT
  public function viewAction() {

    //IF SITEBUSINESSEVENT SUBJECT IS NOT THEN RETURN
    if (!$this->_helper->requireSubject('sitebusinessevent_event')->isValid())
      return;

    //GET LOGGED IN USER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();

    //GET EVENT ITEM
    $sitebusinessevent = Engine_Api::_()->getItem('sitebusinessevent_event', $this->getRequest()->getParam('event_id'));

    //GET SITEBUSINESS ITEM
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $sitebusinessevent->business_id);

    //INCLUDE CSS FILE
    $this->view->headLink()
            ->appendStylesheet($this->view->baseUrl()
                    . 'application/modules/Sitebusinessevent/externals/styles/style_sitebusinessevent.css');

		if (Engine_Api::_()->getApi('settings', 'core')->getSetting('seaocore.common.css') && (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusiness') && Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitegroup'))) {
			$this->view->headLink()->appendStylesheet($this->view->layout()->staticBaseUrl . 'application/modules/Sitebusiness/externals/styles/common_style_business_business_group.css');
		}
		elseif(Engine_Api::_()->getApi('settings', 'core')->getSetting('seaocore.common.css') && Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusiness')) {
			$this->view->headLink()->appendStylesheet($this->view->layout()->staticBaseUrl . 'application/modules/Sitepage/externals/styles/common_style_page_business.css');
		} 
		elseif(Engine_Api::_()->getApi('settings', 'core')->getSetting('seaocore.common.css') && Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitegroup')) {
			$this->view->headLink()->appendStylesheet($this->view->layout()->staticBaseUrl . 'application/modules/Sitebusiness/externals/styles/common_style_business_group.css');
		}
		else {
			$this->view->headLink()->appendStylesheet($this->view->layout()->staticBaseUrl . 'application/modules/Sitebusiness/externals/styles/style_sitebusiness.css');
		}

    //PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessevent")) {
        return $this->_forwardCustom('requireauth', 'error', 'core');
      }
    } else {
      $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'secreate');
      if (empty($isBusinessOwnerAllow)) {
        return $this->_forwardCustom('requireauth', 'error', 'core');
      }
    }
    //PACKAGE BASE PRIYACY END
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'secreate');
    if (empty($isManageAdmin)) {
      $this->view->can_create = 0;
    } else {
      $this->view->can_create = 1;
    }

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'view');
    if (empty($isManageAdmin)) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }
    //END MANAGE-ADMIN CHECK

    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK
    //CHECKING THE USER HAVE THE PERMISSION TO VIEW THE EVENT OR NOT
    if ($viewer_id != $sitebusinessevent->user_id && $can_edit != 1 && $sitebusinessevent->search != 1) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }

    //INCREMENT IN NUMBER OF VIEWS
    $owner = $sitebusinessevent->getOwner();
    if (!$owner->isSelf($viewer)) {
      $sitebusinessevent->view_count++;
    }

    //SAVE VALUES
    $sitebusinessevent->save();

    //NAVIGATION WORK FOR FOOTER.(DO NOT DISPLAY NAVIGATION IN FOOTER ON VIEW BUSINESS.)
    if (!Engine_API::_()->seaocore()->checkSitemobileMode('fullsite-mode')) {
      if (!Zend_Registry::isRegistered('sitemobileNavigationName')) {
        Zend_Registry::set('sitemobileNavigationName', 'setNoRender');
      }
    }
    
    //CHECK THE VERSION OF THE CORE MODULE
    $coremodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core');
    $coreversion = $coremodule->version;

    if ($coreversion < '4.1.0') {
      $this->_helper->content->render();
    } else {
      $this->_helper->content
              ->setNoRender()
              ->setEnabled()
      ;
    }
  }

  //ACTION FOR DELETE EVENT
  public function deleteAction() {

    //CHECK USER VALIDATION
    if (!$this->_helper->requireUser()->isValid())
      return;

    //GET LOGGED IN USER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();

    //BUSINESS ID
    $business_id = $this->_getParam('business_id');

    //SEND TAB ID TO TPL FILE
    $this->view->tab_selected_id = $this->_getParam('tab_id');

    //GET SITEBUSINESS ITEM
    $this->view->sitebusiness = $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);

    //GET NAVIGATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitebusiness_main');

    //GET EVENT ITEM
    $this->view->sitebusinessevent = $sitebusinessevent = Engine_Api::_()->getItem('sitebusinessevent_event', $this->_getParam('event_id'));

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK
    //EVENT OWNER AND BUSINESS OWNER CAN DELETE EVENT
    if ($viewer->getIdentity() != $sitebusinessevent->user_id && $can_edit != 1) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }

    //IF NOT POST OR FORM NOT VALID
    if ($this->getRequest()->isPost() && $this->getRequest()->getPost('confirm') == true) {
      //DELETE EVENT, ALBUM AND EVENT IMAGES
      Engine_Api::_()->sitebusinessevent()->deleteContent($this->_getParam('event_id'));

      //REDIRECTING TO THE SITEBUSINESS VIEW BUSINESS
      return $this->_gotoRouteCustom(array('business_url' => Engine_Api::_()->sitebusiness()->getBusinessUrl($business_id), 'tab' => $this->view->tab_selected_id), 'sitebusiness_entry_view', true);
    }
  }

  //ACTION FOR INVITE THE PEOPLE FOR EVENT
  public function inviteAction() {

    //CHECK USER VALIDATION
    if (!$this->_helper->requireUser()->isValid())
      return;

    //IF SITEBUSINESSEVENT SUBJECT IS NOT THEN RETURN
    if (!$this->_helper->requireSubject('sitebusinessevent_event')->isValid())
      return;

    //PREPARE DATA
    $viewer = Engine_Api::_()->user()->getViewer();
    $sitebusinessevent = Engine_Api::_()->core()->getSubject();
    $friends = $viewer->membership()->getMembers();

    //PREPARE FORM
    $this->view->form = $form = new Sitebusinessevent_Form_Invite();

    $count = 0;
    foreach ($friends as $friend) {
      if ($sitebusinessevent->membership()->isMember($friend, null)) {
        continue;
      }
      $multiOptions[$friend->getIdentity()] = $friend->getTitle();
      $count++;
    }
    sort($multiOptions);
    $form->users->addMultiOptions($multiOptions);
    $this->view->count = $count;

    //IF NOT POST OR FORM NOT VALID, RETURN
    if (!$this->getRequest()->isPost()) {
      return;
    }

    //IF NOT POST OR FORM NOT VALID, RETURN
    if (!$form->isValid($this->getRequest()->getPost())) {
      return;
    }

    //PROCESS
    $db = $sitebusinessevent->getTable()->getAdapter();
    $db->beginTransaction();
    try {
      $usersIds = $form->getValue('users');
      foreach ($friends as $friend) {
        if (!in_array($friend->getIdentity(), $usersIds)) {
          continue;
        }
        $sitebusinessevent->membership()->addMember($friend)->setResourceApproved($friend);

        Engine_Api::_()->getDbtable('notifications', 'activity')->addNotification($friend, $viewer, $sitebusinessevent, 'sitebusinessevent_invite');
      }
      $db->commit();
    } catch (Exception $e) {
      $db->rollBack();
      throw $e;
    }

    //SHOWING THE SUCCESS MESSAGE
    return $this->_forwardCustom('success', 'utility', 'core', array(
                'messages' => array(Zend_Registry::get('Zend_Translate')->_('Members invited.')),
                'layout' => 'default-simple',
                'parentRefresh' => 10,
                'smoothboxClose' => 10
    ));
  }

  //ACTION FOR JOIN THE EVENT
  public function joinAction() {

    //CHECK USER VALIDATION
    if (!$this->_helper->requireUser()->isValid())
      return;

    //IF SITEBUSINESSEVENT SUBJECT IS NOT THEN RETURN  
    if (!$this->_helper->requireSubject()->isValid())
      return;

    //MAKE FORM
    $this->view->form = $form = new Sitebusinessevent_Form_Join();

    //PROCESS FORM
    if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {

      //GET LOGGED IN USER INFORMATION
      $viewer = Engine_Api::_()->user()->getViewer();

      //GETTING THE SITEBUSINESSEVENT SUBJECT
      $sitebusinessevent_subject = Engine_Api::_()->core()->getSubject();

      //START: SUGGESTION WORK
      $is_suggestion_enabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('suggestion');
      if (!empty($is_suggestion_enabled)) {
        $is_moduleEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusiness');
        //HERE WE ARE DELETE THIS EVENT SUGGESTION IF VIEWER HAVE.
        if (!empty($is_moduleEnabled)) {
          Engine_Api::_()->getApi('suggestion', 'sitebusiness')->deleteSuggestion($viewer->getIdentity(), 'business_event', $sitebusinessevent_subject->event_id, 'business_event_suggestion');
        }
      }
      //END: SUGGESTION WORK
      //PROCESS
      $db = $sitebusinessevent_subject->membership()->getReceiver()->getTable()->getAdapter();
      $db->beginTransaction();
      try {
        //SAVE VALUES
        $sitebusinessevent_subject->membership()
                ->addMember($viewer)
                ->setUserApproved($viewer);

        $row = $sitebusinessevent_subject->membership()
                ->getRow($viewer);

        $row->rsvp = $form->getValue('rsvp');
        $row->save();

        //GET SITEBUSINESS ITEM
        $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $sitebusinessevent_subject->business_id);

        //MAKING THE LINK OF THE BUSINESS
//         $linked_business_title = '<a href = http://' . $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getRouter()->assemble(array('business_url' => Engine_Api::_()->sitebusiness()->getBusinessUrl($sitebusinessevent_subject->business_id)), 'sitebusiness_entry_view') . "><b>$sitebusiness->title</b></a>";
        $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
        $linked_business_title = '<b>' . $view->htmlLink($sitebusiness->getHref(), $sitebusiness->getTitle(), array('target' => '_parent')) . '</b>';
        $api = Engine_Api::_()->getDbtable('actions', 'activity');
        $action = $api->addActivity($viewer, $sitebusinessevent_subject, 'sitebusinessevent_join', null, array('linked_business_title' => $linked_business_title));

        //MAKE SURE ACTION EXISTS BEFOR ATTACHING THE EVENT TO THE ACTIVITY
        if ($action != null) {
          Engine_Api::_()->getApi('subCore', 'sitebusiness')->deleteFeedStream($action);
          Engine_Api::_()->getDbtable('actions', 'activity')->attachActivity($action, $sitebusinessevent_subject);
        }
        $db->commit();
      } catch (Exception $e) {
        $db->rollBack();
        throw $e;
      }
      //SHOWING THE SUCCESS MESSAGE
      return $this->_forwardCustom('success', 'utility', 'core', array(
                  'messages' => array(Zend_Registry::get('Zend_Translate')->_('Business event joined.')),
                  'layout' => 'default-simple',
                  'parentRefresh' => 300,
                  'smoothboxClose' => 300
      ));
    }
  }

  //ACTION FOR REQUEST FOR EVENT
  public function requestAction() {

    //CHECK USER VALIDATION
    if (!$this->_helper->requireUser()->isValid())
      return;

    //IF SITEBUSINESSEVENT SUBJECT IS NOT THEN RETURN  
    if (!$this->_helper->requireSubject()->isValid())
      return;

    //MAKE FORM
    $this->view->form = $form = new Sitebusinessevent_Form_Request();

    //PROCESS FORM
    if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
      //GET LOGGED IN USER INFORMATION
      $viewer = Engine_Api::_()->user()->getViewer();

      //GETTING THE SITEBUSINESSEVENT SUBJECT
      $sitebusinessevent_subject = Engine_Api::_()->core()->getSubject();

      //PROCESS
      $db = $sitebusinessevent_subject->membership()->getReceiver()->getTable()->getAdapter();
      $db->beginTransaction();
      try {
        //SAVE VALUES
        $sitebusinessevent_subject->membership()->addMember($viewer)->setUserApproved($viewer);
        $db->commit();
      } catch (Exception $e) {
        $db->rollBack();
        throw $e;
      }
      //SHOWING THE SUCCESS MESSAGE
      return $this->_forwardCustom('success', 'utility', 'core', array(
                  'messages' => array(Zend_Registry::get('Zend_Translate')->_('Your invite request has been sent.')),
                  'layout' => 'default-simple',
                  'parentRefresh' => 300,
                  'smoothboxClose' => 300
      ));
    }
  }

  //ACTION FOR CANCEL THE EVENT
  public function cancelAction() {

    //CHECK USER VALIDATION
    if (!$this->_helper->requireUser()->isValid())
      return;

    //IF SITEBUSINESSEVENT SUBJECT IS NOT THEN RETURN  
    if (!$this->_helper->requireSubject()->isValid())
      return;

    //MAKE FORM
    $this->view->form = $form = new Sitebusinessevent_Form_Cancel();

    //PROCESS FORM
    if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
      //GET USER ID
      $user_id = $this->getRequest()->getParam('user_id');

      //GET USER ITEM
      $user = Engine_Api::_()->getItem('user', $user_id);

      //GETTING THE SITEBUSINESSEVENT SUBJECT
      $sitebusinessevent_subject = Engine_Api::_()->core()->getSubject();

      //PROCESS
      $db = $sitebusinessevent_subject->membership()->getReceiver()->getTable()->getAdapter();
      $db->beginTransaction();
      try {
        //SAVE VALUES
        $sitebusinessevent_subject->membership()->removeMember($user);
        $db->commit();
      } catch (Exception $e) {
        $db->rollBack();
        throw $e;
      }
      //SHOWING THE SUCCESS MESSAGE
      return $this->_forwardCustom('success', 'utility', 'core', array(
                  'messages' => array(Zend_Registry::get('Zend_Translate')->_('Your invite request has been cancelled.')),
                  'layout' => 'default-simple',
                  'parentRefresh' => 300,
                  'smoothboxClose' => 300
      ));
    }
  }

  //ACTION FOR LEAVE THE EVENT
  public function leaveAction() {

    //CHECK USER VALIDATION
    if (!$this->_helper->requireUser()->isValid())
      return;

    //IF SITEBUSINESSEVENT SUBJECT IS NOT THEN RETURN    
    if (!$this->_helper->requireSubject()->isValid())
      return;

    //MAKE FORM
    $this->view->form = $form = new Sitebusinessevent_Form_Leave();

    //IF NOT POST OR FORM NOT VALID
    if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
      //GETTING THE SITEBUSINESSEVENT SUBJECT
      $sitebusinessevent_subject = Engine_Api::_()->core()->getSubject();

      //PROCESS
      $db = $sitebusinessevent_subject->membership()->getReceiver()->getTable()->getAdapter();
      $db->beginTransaction();
      try {
        //SAVE VALUES
        $sitebusinessevent_subject->membership()->removeMember(Engine_Api::_()->user()->getViewer());
        $db->commit();
      } catch (Exception $e) {
        $db->rollBack();
        throw $e;
      }
      //SHOWING THE SUCCESS MESSAGE
      return $this->_forwardCustom('success', 'utility', 'core', array(
                  'messages' => array(Zend_Registry::get('Zend_Translate')->_('Business event left.')),
                  'layout' => 'default-simple',
                  'parentRefresh' => 300,
                  'smoothboxClose' => 300
      ));
    }
  }

  //ACTION FOR ACCEPT THE EVENT REQUEST
  public function acceptAction() {

    //CHECK USER VALIDATION
    if (!$this->_helper->requireUser()->isValid())
      return;

    //IF SITEBUSINESSEVENT SUBJECT IS NOT THEN RETURN    
    if (!$this->_helper->requireSubject()->isValid())
      return;

    //MAKE FORM
    $this->view->form = $form = new Sitebusinessevent_Form_Join();

    //IF NOT POST OR FORM NOT VALID, RETURN
    if (!$this->getRequest()->isPost()) {
      $this->view->status = false;
      $this->view->error = true;
      $this->view->message = Zend_Registry::get('Zend_Translate')->_('Invalid Method');
      return;
    }

    //IF NOT POST OR FORM NOT VALID, RETURN
    if (!$form->isValid($this->getRequest()->getPost())) {
      $this->view->status = false;
      $this->view->error = true;
      $this->view->message = Zend_Registry::get('Zend_Translate')->_('Invalid Data');
      return;
    }

    //GET LOGGED IN USER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();

    //GETTING THE SITEBUSINESSEVENT SUBJECT
    $sitebusinessevent_subject = Engine_Api::_()->core()->getSubject();

    //PROCESS 
    $db = $sitebusinessevent_subject->membership()->getReceiver()->getTable()->getAdapter();
    $db->beginTransaction();

    try {
      //SAVE VALUES
      $sitebusinessevent_subject->membership()->setUserApproved($viewer);
      $row = $sitebusinessevent_subject->membership()
              ->getRow($viewer);
      $row->rsvp = $form->getValue('rsvp');
      $row->save();

      //SET THE REQUEST AS HANDLED
      $notification = Engine_Api::_()->getDbtable('notifications', 'activity')->getNotificationByObjectAndType(
              $viewer, $sitebusinessevent_subject, 'sitebusinessevent_invite');
      if ($notification) {
        $notification->mitigated = true;
        $notification->save();
      }

      //GET SITEBUSINESS ITEM
      $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $sitebusinessevent_subject->business_id);

      $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
      $linked_business_title = '<b>' . $view->htmlLink($sitebusiness->getHref(), $sitebusiness->getTitle(), array('target' => '_parent')) . '</b>';

      $api = Engine_Api::_()->getDbtable('actions', 'activity');
      $action = $api->addActivity($viewer, $sitebusinessevent_subject, 'sitebusinessevent_join', null, array('linked_business_title' => $linked_business_title));

      //MAKE SURE ACTION EXISTS BEFOR ATTACHING THE EVENT TO THE ACTIVITY
      if ($action != null) {
        Engine_Api::_()->getApi('subCore', 'sitebusiness')->deleteFeedStream($action);
        Engine_Api::_()->getDbtable('actions', 'activity')->attachActivity($action, $sitebusinessevent_subject);
      }
      $db->commit();
    } catch (Exception $e) {
      $db->rollBack();
      throw $e;
    }
    $this->view->status = true;
    $this->view->error = false;
    $this->view->message = sprintf(Zend_Registry::get('Zend_Translate')->_('You have accepted the invite to the business event %s.'), $sitebusinessevent_subject->__toString());

    //SHOWING THE SUCCESS MESSAGE
    return $this->_forwardCustom('success', 'utility', 'core', array(
                'messages' => array(Zend_Registry::get('Zend_Translate')->_('Business event invite accepted.')),
                'layout' => 'default-simple',
                'parentRefresh' => 300,
                'smoothboxClose' => 300
    ));
  }

  //ACTION FOR REJECT THE EVENT REQUEST
  public function rejectAction() {

    //CHECK USER VALIDATION
    if (!$this->_helper->requireUser()->isValid())
      return;

    //IF SITEBUSINESSEVENT SUBJECT IS NOT THEN RETURN    
    if (!$this->_helper->requireSubject()->isValid())
      return;

    //MAKE FORM
    $this->view->form = $form = new Sitebusinessevent_Form_Reject();

    //IF NOT POST OR FORM NOT VALID, RETURN
    if (!$this->getRequest()->isPost()) {
      $this->view->status = false;
      $this->view->error = true;
      $this->view->message = Zend_Registry::get('Zend_Translate')->_('Invalid Method');
      return;
    }

    //IF NOT POST OR FORM NOT VALID, RETURN
    if (!$form->isValid($this->getRequest()->getPost())) {
      $this->view->status = false;
      $this->view->error = true;
      $this->view->message = Zend_Registry::get('Zend_Translate')->_('Invalid Data');
      return;
    }

    //GET USER
    if (0 === ($user_id = (int) $this->_getParam('user_id')) ||
            null === ($user = Engine_Api::_()->getItem('user', $user_id))) {
      return $this->_helper->requireSubject->forward();
    }

    //GETTING THE SITEBUSINESSEVENT SUBJECT
    $sitebusinessevent_subject = Engine_Api::_()->core()->getSubject();

    //PROCESS
    $db = $sitebusinessevent_subject->membership()->getReceiver()->getTable()->getAdapter();
    $db->beginTransaction();
    try {
      //SAVE VALUES
      $sitebusinessevent_subject->membership()->removeMember($user);

      //SET THE REQUEST AS HANDLED
      $notification = Engine_Api::_()->getDbtable('notifications', 'activity')->getNotificationByObjectAndType(
              $user, $sitebusinessevent_subject, 'sitebusinessevent_invite');
      if ($notification) {
        $notification->mitigated = true;
        $notification->save();
      }
      $db->commit();
    } catch (Exception $e) {
      $db->rollBack();
      throw $e;
    }
    $this->view->status = true;
    $this->view->error = false;
    $this->view->message = sprintf(Zend_Registry::get('Zend_Translate')->_('You have ignored the invite to the business event %s.'), $sitebusinessevent_subject->__toString());

    //SHOWING THE SUCCESS MESSAGE
    return $this->_forwardCustom('success', 'utility', 'core', array(
                'messages' => array(Zend_Registry::get('Zend_Translate')->_('Business event invite rejected.')),
                'layout' => 'default-simple',
                'parentRefresh' => 300,
                'smoothboxClose' => 300
    ));
  }

  //ACTION FOR REMOVE THE MAMBER FROM THE EVENT
  public function removeAction() {

    //CHECK USER VALIDATION
    if (!$this->_helper->requireUser()->isValid())
      return;

    //IF SITEBUSINESSEVENT SUBJECT IS NOT THEN RETURN    
    if (!$this->_helper->requireSubject()->isValid())
      return;

    //GET USER
    if (0 === ($user_id = (int) $this->_getParam('user_id')) ||
            null === ($user = Engine_Api::_()->getItem('user', $user_id))) {
      return $this->_helper->requireSubject->forward();
    }

    //GET SITEBUSINESSEVENT SUBJECT
    $sitebusinessevent_subject = Engine_Api::_()->core()->getSubject();

    if (!$sitebusinessevent_subject->membership()->isMember($user)) {
      $erroe_msg1 = Zend_Registry::get('Zend_Translate')->_('Cannot remove a non-member');
      throw new Event_Model_Exception($erroe_msg1);
    }

    //MAKE FORM
    $this->view->form = $form = new Sitebusinessevent_Form_Remove();

    //IF NOT POST OR FORM NOT VALID
    if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
      //PROCESS
      $db = $sitebusinessevent_subject->membership()->getReceiver()->getTable()->getAdapter();
      $db->beginTransaction();
      try {
        //REMOVE MEMBERSHIP
        $sitebusinessevent_subject->membership()->removeMember($user);
        $db->commit();
      } catch (Exception $e) {
        $db->rollBack();
        throw $e;
      }
      //SHOWING THE SUCCESS MESSAGE
      return $this->_forwardCustom('success', 'utility', 'core', array(
                  'messages' => array(Zend_Registry::get('Zend_Translate')->_('Business event member removed.')),
                  'layout' => 'default-simple',
                  'parentRefresh' => 300,
                  'smoothboxClose' => 300
      ));
    }
  }

  //ACTION FOR APPROVE THE EVENT
  public function approveAction() {

    //CHECK USER VALIDATION
    if (!$this->_helper->requireUser()->isValid())
      return;

    //IF SITEBUSINESSEVENT SUBJECT IS NOT THEN RETURN    
    if (!$this->_helper->requireSubject()->isValid())
      return;

    //GET USER
    if (0 === ($user_id = (int) $this->_getParam('user_id')) ||
            null === ($user = Engine_Api::_()->getItem('user', $user_id))) {
      return $this->_helper->requireSubject->forward();
    }

    //MAKE FORM
    $this->view->form = $form = new Sitebusinessevent_Form_Approve();

    //IF NOT POST OR FORM NOT VALID
    if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
      //GET LOGGED IN USER INFORMATION
      $viewer = Engine_Api::_()->user()->getViewer();

      //GETTING THE SITEBUSINESSEVENT SUBJECT
      $sitebusinessevent_subject = Engine_Api::_()->core()->getSubject();

      //PROCESS
      $db = $sitebusinessevent_subject->membership()->getReceiver()->getTable()->getAdapter();
      $db->beginTransaction();
      try {
        //SAVE VALUES
        $sitebusinessevent_subject->membership()->setResourceApproved($user);
        Engine_Api::_()->getDbtable('notifications', 'activity')->addNotification($user, $sitebusinessevent_subject, $viewer, 'sitebusinessevent_accepted');
        $db->commit();
      } catch (Exception $e) {
        $db->rollBack();
        throw $e;
      }
      //SHOWING THE SUCCESS MESSAGE
      return $this->_forwardCustom('success', 'utility', 'core', array(
                  'messages' => array(Zend_Registry::get('Zend_Translate')->_('Business event request approved.')),
                  'layout' => 'default-simple',
                  'parentRefresh' => 300,
                  'smoothboxClose' => 300
      ));
    }
  }

  public function browseAction() {

    //CHECK VIEW PRIVACY
    if (!$this->_helper->requireAuth()->setAuthParams('sitebusiness_business', null, 'view')->isValid())
      return;

    //CHECK THE VERSION OF THE CORE MODULE
    $coremodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core');
    $coreversion = $coremodule->version;
    if ($coreversion < '4.1.0') {
      $this->_helper->content->render();
    } else {
      $this->_helper->content
              ->setNoRender()
              ->setEnabled()
      ;
    }
  }

  //ACTION FOR MAKE THE SITEBUSINESSEVENT FEATURED/UNFEATURED
  public function featuredAction() {

    //CHECK USER VALIDATION
    if (!$this->_helper->requireUser()->isValid())
      return;

    //GET EVENT ID AND OBJECT
    $event_id = $this->view->event_id = $this->_getParam('event_id');
    $sitebusinessevent = Engine_Api::_()->getItem('sitebusinessevent_event', $event_id);

    $this->view->featured = $sitebusinessevent->featured;

    //GET BUSINESS OBJECT
    $this->view->sitebusiness = $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $sitebusinessevent->business_id);

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    $this->view->canEdit = 0;
    if (!empty($isManageAdmin)) {
      $this->view->canEdit = 1;
    }
    //END MANAGE-ADMIN CHECK
    //SMOOTHBOX
    if (null === $this->_helper->ajaxContext->getCurrentContext()) {
      $this->_helper->layout->setLayout('default-simple');
    } else {//NO LAYOUT
      $this->_helper->layout->disableLayout(true);
    }

    if (!$this->getRequest()->isPost())
      return;

    //GET VIEWER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    $tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab');

    //CHECK THAT FEATURED ACTION IS ALLOWED BY ADMIN OR NOT
    //CHECK CAN MAKE FEATURED OR NOT(ONLY SITEBUSINESS EVENT CAN MAKE FEATURED/UN-FEATURED)
    if ($viewer_id == $sitebusinessevent->user_id || !empty($this->view->canEdit)) {
      $this->view->permission = true;
      $this->view->success = false;
      $db = Engine_Api::_()->getDbtable('events', 'sitebusinessevent')->getAdapter();
      $db->beginTransaction();
      try {
        if ($sitebusinessevent->featured == 0) {
          $sitebusinessevent->featured = 1;
        } else {
          $sitebusinessevent->featured = 0;
        }

        $sitebusinessevent->save();
        $db->commit();
        $this->view->success = true;
      } catch (Exception $e) {
        $db->rollback();
        throw $e;
      }
    } else {
      $this->view->permission = false;
    }

    if ($sitebusinessevent->featured) {
      $suc_msg = array(Zend_Registry::get('Zend_Translate')->_('Event successfully made featured.'));
    } else {
      $suc_msg = array(Zend_Registry::get('Zend_Translate')->_('Event successfully made un-featured.'));
    }

    $this->_forwardCustom('success', 'utility', 'core', array(
        'smoothboxClose' => 2,
        'parentRedirect' => $this->_helper->url->url(array('business_url' => Engine_Api::_()->sitebusiness()->getBusinessUrl($sitebusinessevent->business_id), 'tab' => $tab_selected_id), 'sitebusiness_entry_view', true),
        'parentRedirectTime' => '2',
        'format' => 'smoothbox',
        'messages' => $suc_msg
    ));
  }

  //ACTION FOR ADDING EVENT OF THE DAY
  public function addEventOfDayAction() {
    //FORM GENERATION
    $form = $this->view->form = new Sitebusinessevent_Form_ItemOfDayday();
    $event_id = $this->_getParam('event_id');
    // $form->setAction($this->getFrontController()->getRouter()->assemble(array()));
    //CHECK POST
    if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {

      //GET FORM VALUES
      $values = $form->getValues();

      //BEGIN TRANSACTION
      $db = Engine_Db_Table::getDefaultAdapter();
      $db->beginTransaction();
      try {

        //GET ITEM OF THE DAY TABLE
        $dayItemTime = Engine_Api::_()->getDbtable('itemofthedays', 'sitebusiness');

        //FETCH RESULT FOR resource_id
        $select = $dayItemTime->select()->where('resource_id = ?', $event_id)->where('resource_type = ?', 'sitebusinessevent_event');
        $row = $dayItemTime->fetchRow($select);

        if (empty($row)) {
          $row = $dayItemTime->createRow();
          $row->resource_id = $event_id;
        }
        $row->start_date = $values["starttime"];
        $row->end_date = $values["endtime"];
        $row->resource_type = 'sitebusinessevent_event';
        $row->save();

        $db->commit();
      } catch (Exception $e) {
        $db->rollBack();
        throw $e;
      }
      return $this->_forwardCustom('success', 'utility', 'core', array(
                  'smoothboxClose' => 10,
                  'messages' => array(Zend_Registry::get('Zend_Translate')->_('The Event of the Day has been added successfully.'))
      ));
    }
  }

  // ACTION FOR FEATURED EVENTS CAROUSEL AFTER CLICK ON BUTTON 
  public function featuredEventsCarouselAction() {
    //RETRIVE THE VALUE OF ITEM VISIBLE
    $this->view->itemsVisible = $limit = (int) $_GET['itemsVisible'];

    //RETRIVE THE VALUE OF NUMBER OF ROW
    $this->view->noOfRow = (int) $_GET['noOfRow'];
    //RETRIVE THE VALUE OF ITEM VISIBLE IN ONE ROW
    $this->view->inOneRow = (int) $_GET['inOneRow'];

    // Total Count Featured Photos
    $totalCount = (int) $_GET['totalItem'];

    //RETRIVE THE VALUE OF START INDEX
    $startindex = $_GET['startindex'] * $limit;

    if ($startindex > $totalCount) {
      $startindex = $totalCount - $limit;
    }
    if ($startindex < 0)
      $startindex = 0;

    $params = array();
    $params['category_id'] = $_GET['category_id'];
    $params['feature_events'] = 1;

    //RETRIVE THE VALUE OF BUTTON DIRECTION
    $direction = $_GET['direction'];
    $this->view->offset = $params['start_index'] = $startindex;

    //GET Featured Photos with limit * 2
    $this->view->totalItemsInSlide = $params['limit'] = $limit * 2;
    $this->view->featuredEvents = $this->view->featuredEvents = $featuredEvents = Engine_Api::_()->getDbTable('events', 'sitebusinessevent')->widgetEventsData($params);

    //Pass the total number of result in tpl file
    $this->view->count = count($featuredEvents);

    //Pass the direction of button in tpl file
    $this->view->direction = $direction;
  }

  public function homeAction() {

    //CHECK VIEW PRIVACY
    if (!$this->_helper->requireAuth()->setAuthParams('sitebusiness_business', null, 'view')->isValid())
      return;

    //CHECK THE VERSION OF THE CORE MODULE
    $coremodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core');
    $coreversion = $coremodule->version;
    if ($coreversion < '4.1.0') {
      $this->_helper->content->render();
    } else {
      $this->_helper->content
              ->setNoRender()
              ->setEnabled()
      ;
    }
  }

  //ACTION FOR BROWSE LOCATION BUSINESSS.
  public function byLocationsAction() {
    $this->_helper->content->setEnabled();
  }

  //ACTION FOR BROWSE LOCATION BUSINESSS.
  public function mobilebyLocationsAction() {
    $this->_helper->content->setEnabled();
  }

  public function inviteMembersAction() {

    //CHECK USER VALIDATION
    if (!$this->_helper->requireUser()->isValid())
      return;

    //IF SITEBUSINESSEVENT SUBJECT IS NOT THEN RETURN
    if (!$this->_helper->requireSubject('sitebusinessevent_event')->isValid())
      return;

    $business_id = $this->_getParam('business_id');
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    $event_id = $this->_getParam('event_id');
    $SUBJECT = $sitebusinessevent = Engine_Api::_()->getItem('sitebusinessevent_event', $event_id);
    $this->view->businessvent_title = $SUBJECT->title;
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    $modContentId = $this->_getParam("modContentId", null);

    $eventMembershipTable = Engine_Api::_()->getDbtable('membership', 'sitebusinessevent');
    $this->view->user_ids = $eventMembershipTable->select()
                    ->from($eventMembershipTable->info('name'), array('user_id'))
                    ->where('resource_id = ?', $event_id)
                    ->query()->fetchAll(Zend_Db::FETCH_COLUMN);

    //$this->view->modError = $modSetError = 1; //$this->_getParam("modError", 0);
    //$this->view->modItemType = $modItemType = null; //$this->_getParam("modItemType", null);
    //$this->view->notificationType = $notificationType = 0; //$this->_getParam("notificationType", 0);
    //$findFriendFunName = null; //$this->_getParam("findFriendFunName", null);
    // 	if (empty($findFriendFunName)) {
    // 	  $findFriendFunName = $notificationType;
    // 	}
    // 	if (empty($findFriendFunName)) {
    // 	  $findFriendFunName = $_GET['findFriendFunName'];
    // 	}
    //$this->view->findFriendFunName = null;
    //$mod_notify_type = null;
    //$mod_entity = $this->_getParam("entity", null);
    //$item_type = $this->_getParam("item_type", null);
// 		if (empty($mod_notify_type) && !empty($_GET['notification_type'])) {
// 			$mod_notify_type = $_GET['notification_type'];
// 		}
// 		if (empty($mod_entity) && !empty($_GET['entity'])) {
// 			$mod_entity = $_GET['entity'];
// 		}
// 		if (empty($item_type) && !empty($_GET['item_type'])) {
// 			$item_type = $_GET['item_type'];
// 		}
    //$this->view->notification_type = $mod_notify_type;
    //$this->view->entity = $mod_entity;
    //$this->view->item_type = $item_type;
    //$this->view->mod_set_error = $modSetError;
    $this->view->search_true = false;
    $entityId = array();
    if ($this->getRequest()->isPost()) {
      // Send suggestion of the friends, which loggden user select in popup.
      $userFriendArray = $this->getRequest()->getPost();
      foreach ($userFriendArray as $flag => $ownerId) {
        if (strpos($flag, 'check_') !== FALSE) {
          $entity = $userFriendArray['entity'];
          $entityId[] = $ownerId;
          $friend = Engine_Api::_()->user()->getUser($ownerId);
          $SUBJECT->membership()->addMember($friend)->setResourceApproved($friend);
        }
      }
      if (!empty($entityId)) {
        Engine_Api::_()->sitebusinessevent()->sendInviteEmail($sitebusinessevent, $action, 'sitebusinessevent_invite', 'SITEBUSINESSEVENT_INVITE_EMAIL', 'InviteMembers', $entityId);
      }

      $this->_forwardCustom('success', 'utility', 'core', array(
          'smoothboxClose' => true,
          'messages' => array($this->view->translate("Members invited."))
              )
      );
    } else {
      // Set variables for JS. when open popups.
      $this->view->modContentId = $event_id;
      //$modFunName = null;
      $modParem = 'modContentId';
      if (!empty($_GET['task'])) {
        $getTask = $_GET['task'];
      }
      if (!empty($_GET['selected_checkbox'])) {
        $getSelectCheckbox = $_GET['selected_checkbox'];
      }
      if (!empty($_GET['page'])) {
        $getBusiness = $_GET['page'];
      }
      if (!empty($_GET['searchs'])) {
        $getSearch = $_GET['searchs'];
      }
      if (!empty($_GET['show_selected'])) {
        $getShowSelected = $_GET['show_selected'];
      }
      if (!empty($_GET['action_id'])) {
        $getActionId = $_GET['action_id'];
      }
      if (!empty($_GET['selected_friend_flag'])) {
        $this->view->selectedFriendFlag = $_GET['selected_friend_flag'];
      }
      // Assign variables for resolving log error.
      if (empty($getTask)) {
        $getTask = null;
      }
      if (empty($getSelectCheckbox)) {
        $getSelectCheckbox = null;
      }
      if (empty($getBusiness)) {
        $getBusiness = null;
      }
      if (empty($getSearch)) {
        $getSearch = null;
      }
      if (empty($getShowSelected)) {
        $getShowSelected = null;
      }
      if (empty($getActionId)) {
        $getActionId = null;
      }
      $veiw = $this->openPopupContent($getTask, $getSelectCheckbox, $getBusiness, $getSearch, $getShowSelected, $getActionId, $modContentId, $modParem, $sitebusinessevent, $viewer_id);

      foreach ($veiw as $key => $value) {
        $this->view->$key = $value;
      }
    }
  }

  public function openPopupContent($getTask, $getSelectCheckbox, $getBusiness, $getSearch, $getShowSelected, $getActionId, $modId, $modParem, $sitebusinessevent, $viewer_id) {

    $business_id = $sitebusinessevent->business_id;
    $event_id = $sitebusinessevent->event_id;
    $ownerId = $sitebusinessevent->user_id;
    //THIS IS WHEN DO SOME ACTIVITY ON THE SUGGESTION BUSINESS.
    if (!empty($getTask)) {
      $view['search_true'] = true;
    }

    if (!empty($getSelectCheckbox)) {
      $view['selected_checkbox'] = $getSelectCheckbox;
      $getSelectCheckbox = trim($getSelectCheckbox, ',');
      $modStrId_array = explode(",", $getSelectCheckbox);
      $view['friends_count'] = @COUNT($modStrId_array);
    } else {
      $view['selected_checkbox'] = '';
      $view['friends_count'] = $selected_friend_count = 0;
    }

    $view['business'] = $business = !empty($getBusiness) ? $getBusiness : 1;
    $view['search'] = $search = !empty($getSearch) ? $getSearch : '';


    //IF THE REQUEST IS FOR SHOWING ONLY SELECTED FRIENDS.
    if (!empty($getShowSelected)) {
      $search = '';
      $view['show_selected'] = $selected_friend_show = 1;
      $view[$modParem] = $modId = $getActionId;
      $modId_array = $modStrId_array;
    }
    //IF THE REQUEST IS FOR SHOWING ALL FRIENDS.
    else {
      if (empty($modId)) {
        $view[$modParem] = $modId = $getActionId;
      }
      //$user_id = Engine_Api::_()->user()->getViewer()->getIdentity();
      //$sugg_popups_limit = 0;
      //  would be 'friend' only when "Add a Friend popup" & "Few friend popup"
      $view['members'] = $fetch_member_myfriend = Engine_Api::_()->getDbtable('membership', 'sitebusiness')->getJoinMembers($business_id, $viewer_id, $ownerId);

      if (!empty($business)) {
        $fetch_member_myfriend->setCurrentPageNumber($business);
      }
      $fetch_member_myfriend->setItemCountPerPage(40);

      $modId_array = array();

      foreach ($fetch_member_myfriend as $modRow) {
        $modId_array[] = $modRow['user_id'];
      }
      $view['show_selected'] = $selected_friend_show = 0;
    }
    
    	$inviteMemberArray = Engine_Api::_()->getDbtable('membership', 'sitebusinessevent')->getInvitedMembers($event_id, $viewer_id, $ownerId); 
 
		foreach ($inviteMemberArray as $inviteMember) {
			$inviteMember_array[] = $inviteMember['user_id'];
		}
		
		if($modId_array && $inviteMember_array)
			$result = array_diff($modId_array, $inviteMember_array);
			
		if($result) 
			$view['mod_combind_path'] = $result;
		elseif(empty($inviteMember_array))
			$view['mod_combind_path'] = $modId_array;


    //HERE WE ARE CHECKING IF THE REQUEST IS FOR ONLY SHOW SELECTED FRIENDS THEN WE WILL MAKE PAGINATION OF USER OBJECT OTHERWISE WE WILL SIMPLY USER FETCHALL QUERY.
    if (!empty($modId_array)) {

// 			$tempSelectedFriend = '';
// 			if (!empty($modId_array) && !empty($modStrId_array)) {
// 				foreach ($modId_array as $values) {
// 					if (in_array($values, $modStrId_array)) {
// 					$tempSelectedFriend .= ',' . $values;
// 					}
// 				}
// 			}
      //$view['tempSelectedFriend'] = $tempSelectedFriend;
			if($result) 
				$view['suggest_user_id'] = $result;
			else
				$view['suggest_user_id'] = $modId_array;

      if ($selected_friend_show) {
        $view['suggest_user'] = $view['members'] = $selected_friends = Engine_Api::_()->getDbtable('membership', 'sitebusiness')->getJoinMembers($business_id, $viewer_id, $ownerId);
        $selected_friends->setCurrentPageNumber($business);
        $selected_friends->setItemCountPerPage(100);
      } else {
        //$view['suggest_user'] = $memberArray = Engine_Api::_()->suggestion()->suggestion_users_information($modId_array, $selected_friend_show, '');
        $memberArray = Engine_Api::_()->getDbtable('membership', 'sitebusiness')->getJoinMembers($business_id, $viewer_id, $ownerId); 
        $memberArray->setCurrentPageNumber($business);
        $memberArray->setItemCountPerPage(100);

				foreach ($memberArray as $joinMember) {
					$joinMembers[] = $joinMember['user_id'];
				}

							
				if($joinMembers && $inviteMember_array)
					$result = array_diff($joinMembers, $inviteMember_array); 
					
				if($result) 
					$view['suggest_user'] = $result;
				elseif(empty($inviteMember_array))
					$view['suggest_user'] = $joinMembers;
      }
    }

    if (!empty($_GET['getArray'])) {
      $view['getArray'] = $_GET['getArray'];
    } else {
      $view['getArray'] = array();
    }
    return $view;
  }

}