<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: MobiController.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessevent_MobiController extends Core_Controller_Action_Standard {

  public function init() {
  	
    //GET BUSINESS ID
    $business_id = $this->_getParam('business_id');

    //PACKAGE BASE PRIYACY START
    if (!empty($business_id)) {
      $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
      if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
        if (!Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessevent")) {
          return $this->_forward('requireauth', 'error', 'core');
        }
      } else {
        $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'secreate');
        if (empty($isBusinessOwnerAllow)) {
          return $this->_forward('requireauth', 'error', 'core');
        }
      }
    }
    //PACKAGE BASE PRIYACY END
    else {
      if ($this->_getParam('event_id') != null) {
        $sitebusinessevent = Engine_Api::_()->getItem('sitebusinessevent_event', $this->_getParam('event_id'));
        $business_id = $sitebusinessevent->business_id;
      }
    }
    
    //GET EVENT ID
    $event_id = $this->_getParam('event_id');
    if ($event_id) {
      $sitebusinessevent = Engine_Api::_()->getItem('sitebusinessevent_event', $event_id);
      if ($sitebusinessevent) {
        Engine_Api::_()->core()->setSubject($sitebusinessevent);
      }
    }
  }

  //ACTION FOR VIEW THE EVENT
  public function viewAction() {
    
    //IF SITEBUSINESSEVENT SUBJECT IS NOT THEN RETURN
    if (!$this->_helper->requireSubject('sitebusinessevent_event')->isValid())
      return;

    //GET LOGGED IN USER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();

    //GET EVENT ITEM
    $sitebusinessevent = Engine_Api::_()->getItem('sitebusinessevent_event', $this->getRequest()->getParam('event_id'));

    //GET SITEBUSINESS ITEM
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $sitebusinessevent->business_id);

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'view');
    if (empty($isManageAdmin)) {
      return $this->_forward('requireauth', 'error', 'core');
    }
    //END MANAGE-ADMIN CHECK

    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK

    //CHECKING THE USER HAVE THE PERMISSION TO VIEW THE EVENT OR NOT
    if ($viewer_id != $sitebusinessevent->user_id && $can_edit != 1 && $sitebusinessevent->search != 1) {
      return $this->_forward('requireauth', 'error', 'core');
    }

    //INCREMENT IN NUMBER OF VIEWS
    $owner = $sitebusinessevent->getOwner();
    if (!$owner->isSelf($viewer)) {
      $sitebusinessevent->view_count++;
    }

    //SAVE VALUES
    $sitebusinessevent->save();

    //CHECK THE VERSION OF THE CORE MODULE
    $coremodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core');
    $coreversion = $coremodule->version;
    if ($coreversion < '4.1.0') {
      $this->_helper->content->render();
    } else {
      $this->_helper->content
              ->setNoRender()
              ->setEnabled()
      ;
    }
  }
  
}

?>