<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    sitebusinessevent
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 6590 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$isActive = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessevent.isActivate', 0);
if ( empty($isActive) ) {
  return;
}

$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => $view->translate('Business Profile Events'),
        'description' => $view->translate('This widget forms the Events tab on the Business Profile and displays the events of the Business. It should be placed in the Tabbed Blocks area of the Business Profile.'),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusinessevent.sitemobile-profile-sitebusinessevents',
        'defaultParams' => array(
            'title' => $view->translate('Events'),
        ),
    ),
    array(
			'title' => $view->translate('Business Event Profile Details'),
			'description' => $view->translate("Displays a Business event's details on it's profile."),
			'category' => $view->translate('Business Event Profile'),
			'type' => 'widget',
			'name' => 'sitebusinessevent.sitemobile-profile-info',
			'defaultParams' => array(
					'title' => $view->translate(''),
			),
			'adminForm' => array(
				'elements' => array(
					array(
						'Radio',
						'sitebusinesseventInfoCollapsible',
						array(
								'label' => $view->translate('Do you want users to be able to expand and collapse business event information shown in this block?'),
								//'description' => $view->translate('Do you want to show the event detail collapsible?'),
								'multiOptions' => array(
										1 => $view->translate('Yes'),
										0 => $view->translate('No')
								),
								'value' => 0,
						)
					),
					array(
						'Radio',
						'sitebusinesseventInfoCollapsibleDefault',
						array(
								'label' => $view->translate('Do you want business event details to be expanded or collapsed by default? (This setting will only work, if you have selected ‘No’ in the above setting)'),
								//'description' => $view->translate('Do you want to show the event detail collapsible?'),
								'multiOptions' => array(
										1 => $view->translate('Yes'),
										0 => $view->translate('No')
								),
								'value' => 1,
						)
					),
				),
			),
    ),
    array(
        'title' => $view->translate('Business Event Profile Rsvp'),
        'description' => $view->translate("Displays a Business event's rsvp on it's profile."),
        'category' => $view->translate('Business Event Profile'),
        'type' => 'widget',
        'name' => 'sitebusinessevent.profile-rsvp',
        'defaultParams' => array(
            'title' => '',
        ),
    ),
    array(
    'title' => 'Business Event Profile Photos',
    'description' => 'Displays a Business event\'s photos on it\'s profile.',
    'category' => $view->translate('Business Event Profile'),
    'type' => 'widget',
    'name' => 'sitebusinessevent.profile-photos',
    'isPaginated' => true,
    'defaultParams' => array(
      'title' => 'Photos',
      'titleCount' => true,
    ),
    'requirements' => array(
      'subject' => 'sitebusinessevent_event',
    ),
  ),
	array(
		'title' => $view->translate('Business Event Profile Guest Member'),
		'description' => $view->translate("Displays a Business event's guest members on it's profile."),
		'category' => $view->translate('Business Event Profile'),
		'type' => 'widget',
		'name' => 'sitebusinessevent.profile-members',
		'defaultParams' => array(
				'title' => 'Guests',
				'titleCount' => true
		),
	),
	array(
		'title' => $view->translate('Business Event Breadcrumb'),
		'description' => $view->translate("Displays breadcrumb on Business event's various businesses. "),
		'category' => $view->translate('Business Event Breadcrumb'),
		'type' => 'widget',
		'name' => 'sitebusinessevent.sitemobile-breadcrumb',
		'defaultParams' => array(
				'title' => '',
		),
	),
  array(
		'title' => $view->translate('Business Events'),
		'description' => $view->translate('Displays the list of Events from Businesses created on your community. This widget should be placed in the widgetized Business Events business. Results from the Search Business Events form are also shown here.'),
		'category' => $view->translate('Businesses'),
		'type' => 'widget',
		'name' => 'sitebusinessevent.sitebusiness-event',
		'defaultParams' => array(
				'title' => '',
				'titleCount' => true,
		),
		'adminForm' => array(
				'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => $view->translate('Count'),
										'description' => $view->translate('(number of events to show)'),
										'value' => 10,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
				),
		),
  ),
)
?>