<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessevent
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessevent_Widget_ProfileEventsController extends Engine_Content_Widget_Abstract {

  //ACTION FOR SHOWING THE UPCOMING EVENTS ON BUSINESS PROFILE BUSINESS 
  public function indexAction() {

    //DON'T RENDER IF THERE IS NO SUBJECT
    if (!Engine_Api::_()->core()->hasSubject()) {
      return $this->setNoRender();
    }

    //GET SUBJECT AND SITEBUSINESS ID
    $this->view->sitebusiness = $sitebusiness = Engine_Api::_()->core()->getSubject('sitebusiness_business');
    $sitebusinessevent_profileEvent = Zend_Registry::isRegistered('sitebusinessevent_profileEvent') ? Zend_Registry::get('sitebusinessevent_profileEvent') : null;
    $business_id = $sitebusiness->business_id;

    //PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessevent")) {
        return $this->setNoRender();
      }
    } else {
      $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'secreate');
      if (empty($isBusinessOwnerAllow)) {
        return $this->setNoRender();
      }
    }
    //PACKAGE BASE PRIYACY END
    
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'view');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }
    //END MANAGE-ADMIN CHECK
    
    //NO RENDER
    if (empty($sitebusinessevent_profileEvent)) {
      return $this->setNoRender();
    }

    //GET TAB ID
    $this->view->tab_id = Engine_Api::_()->sitebusiness()->GetTabIdinfo('sitebusinessevent.profile-sitebusinessevents', $business_id, Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.layoutcreate', 0));

    //SEARCH PARAMETER
    $params = array();
    $params['business_id'] = $business_id;
    $params['limit'] = $this->_getParam('itemCount', 3);

    //MAKE PAGINATOR
    $this->view->paginator = $paginator = Engine_Api::_()->getDbTable('events', 'sitebusinessevent')->widgetEventsData($params);

    //SET NO RENDER
    if (Count($paginator) <= 0) {
      return $this->setNoRender();
    }
  }

}

?>