<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessevent
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessevent_Widget_ProfileOptionsController extends Engine_Content_Widget_Abstract {

  //ACTION FOR SHOWING THE OPTIONS OF THE EVENT ON EVENT VIEW BUSINESS
  public function indexAction() {

    //DON'T RENDER IF THERE IS NO SUBJECT
    if (!Engine_Api::_()->core()->hasSubject()) {
      return $this->setNoRender();
    }

    $sitebusinessevent_profileOption = Zend_Registry::isRegistered('sitebusinessevent_profileOption') ? Zend_Registry::get('sitebusinessevent_profileOption') : null;

    //GET SITEBUSINESS SUBJECT
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', Engine_Api::_()->core()->getSubject('sitebusinessevent_event')->business_id);

    //PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessevent")) {
        return $this->setNoRender();
      }
    } else {
      $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'secreate');
      if (empty($isBusinessOwnerAllow)) {
        return $this->setNoRender();
      }
    }
    //PACKAGE BASE PRIYACY END     
    
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'view');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }
    //END MANAGE-ADMIN CHECK
    
    //NO RENDER
    if (empty($sitebusinessevent_profileOption)) {
      return $this->setNoRender();
    }

    //GET NAVIGATION
    $this->view->gutterNavigation = $gutterNavigation = Engine_Api::_()->getApi('menus', 'core')
            ->getNavigation('sitebusinessevent_gutter');
  }

}

?>