<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessform
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminManageController.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessform_AdminManageController extends Core_Controller_Action_Admin {

  //ACTION FOR MANAGING FORMS
  public function indexAction() {

    //CREATE NAVIGATION TABS
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
            ->getNavigation('sitebusinessform_admin_main', array(), 'sitebusinessform_admin_main_manage');

    //HIDDEN SEARCH FORM CONTAIN ORDER AND ORDER DIRECTION  
    $this->view->formFilter = $formFilter = new Sitebusinessform_Form_Admin_Manage_Filter();
    $business = $this->_getParam('page', 1);
    $table = Engine_Api::_()->getDbtable('sitebusinessforms', 'sitebusinessform');
    $table_name = $table->info('name');
    $sitebusiness_table = Engine_Api::_()->getDbtable('business', 'sitebusiness');
    $table_name1 = $sitebusiness_table->info('name');
    $select = $table->select()
            ->setIntegrityCheck(false)
            ->from($table_name)
            ->joinInner($table_name1, "$table_name.business_id = $table_name1.business_id", array('title as sitebusiness_title', 'business_id as sitebusiness_id'));

    $values = array();
    if ($formFilter->isValid($this->_getAllParams())) {
      $values = $formFilter->getValues();
    }

    foreach ($values as $key => $value) {
      if (null === $value) {
        unset($values[$key]);
      }
    }

    //FILTERING PARAMETERES
    $this->view->business_title = '';
    $this->view->business_title = '';
    $this->view->businessform_status = '';

    $values = array_merge(array(
        'order' => 'business_id',
        'order_direction' => 'DESC',
            ), $values);


    if (!empty($_POST['business_title']))
      $business_name = $_POST['business_title'];
    elseif (!empty($_GET['business_title']))
      $business_name = $_GET['business_title'];
    elseif ($this->_getParam('business_title', ''))
      $business_name = $this->_getParam('business_title', '');
    else
      $business_name = '';

    if (!empty($_POST['form_title']))
      $form_name = $_POST['form_title'];
    elseif (!empty($_GET['form_title']))
      $form_name = $_GET['form_title'];
    elseif ($this->_getParam('form_title', ''))
      $form_name = $this->_getParam('form_title', '');
    else
      $form_name = '';

    //SEARCHING
    $this->view->business_title = $values['business_title'] = $business_name;
    $this->view->form_title = $values['form_title'] = $form_name;

    if (!empty($business_name)) {
      $select->where($table_name1 . '.title  LIKE ?', '%' . $business_name . '%');
    }

    if (!empty($form_name)) {
      $select->where($table_name . '.title  LIKE ?', '%' . $form_name . '%');
    }

    if (isset($_POST['search'])) {
      if (!empty($_POST['businessform_status'])) {

        $this->view->businessform_status = $_POST['businessform_status'];
        switch ($this->view->businessform_status) {
          case 1:
            $select->where($table_name . '.status = ? ', 1);
            break;
          case 2:
            $select->where($table_name . '.status = ? ', 0);
            break;
        }
      }
    }

    $this->view->assign($values);
    $select->order((!empty($values['order']) ? $values['order'] : 'business_id' ) . ' ' . (!empty($values['order_direction']) ? $values['order_direction'] : 'DESC' ));
    include APPLICATION_PATH . '/application/modules/Sitebusinessform/controllers/license/license2.php';
  }

  //ACTION FOR DISABLING THE FORM
  public function disableFormAction() {

    //CHECK USER VALIDATION
    if (!$this->_helper->requireUser()->isValid())
      return;

    //GET BUSINESS ID
    $business_id = $this->_getParam('id');

    //GET FORM DATA
    $formTable = Engine_Api::_()->getDbtable('sitebusinessforms', 'sitebusinessform');
    $formSelect = $formTable->select()->where('business_id = ?', $business_id);
    $formSelectData = $formTable->fetchRow($formSelect);

    //GET FORM ID AND OBJECT
    $this->view->form_id = $sitebusinessform_id = $formSelectData->sitebusinessform_id;
    $sitebusinessform = Engine_Api::_()->getItem('sitebusinessform', $sitebusinessform_id);

    //SEND STATUS TO TPL
    $this->view->status = $sitebusinessform->status;

    //SMOOTHBOX
    if (null === $this->_helper->ajaxContext->getCurrentContext()) {
      $this->_helper->layout->setLayout('default-simple');
    } else {//NO LAYOUT
      $this->_helper->layout->disableLayout(true);
    }

    if (!$this->getRequest()->isPost())
      return;
    $db = Engine_Api::_()->getDbtable('sitebusinessforms', 'sitebusinessform')->getAdapter();
    $db->beginTransaction();
    try {
      if ($sitebusinessform->status == 0) {
        $sitebusinessform->status = 1;
      } else {
        $sitebusinessform->status = 0;
      }

      $sitebusinessform->save();
      $db->commit();
    } catch (Exception $e) {
      $db->rollback();
      throw $e;
    }
    $this->_forward('success', 'utility', 'core', array(
        'smoothboxClose' => 10,
        'parentRefresh' => 10,
        'messages' => array(Zend_Registry::get('Zend_Translate')->_(''))
    ));
  }

}

?>