<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessform
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessform_Installer extends Engine_Package_Installer_Module {

  function onPreInstall() {
    $db = $this->getDb();

    //CHECK THAT SITEBUSINESS PLUGIN IS ACTIVATED OR NOT
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_settings')
            ->where('name = ?', 'sitebusiness.is.active')
            ->limit(1);
    $sitebusiness_settings = $select->query()->fetchAll();
    if (!empty($sitebusiness_settings)) {
      $sitebusiness_is_active = $sitebusiness_settings[0]['value'];
    } else {
      $sitebusiness_is_active = 0;
    }

    //CHECK THAT SITEBUSINESS PLUGIN IS INSTALLED OR NOT

    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'sitebusiness')
            ->where('enabled = ?', 1);
    $check_sitebusiness = $select->query()->fetchObject();
    if (!empty($check_sitebusiness) && !empty($sitebusiness_is_active)) {
      $PRODUCT_TYPE = 'sitebusinessform';
      $PLUGIN_TITLE = 'Sitebusinessform';
      $PLUGIN_VERSION = '5.4.1';
      $PLUGIN_CATEGORY = 'plugin';
      $PRODUCT_DESCRIPTION = 'Sitebusinessform Plugin';
      $PRODUCT_TITLE = 'Directory / Businesses - Form Extension';
      $_PRODUCT_FINAL_FILE = 0;
      $sitebusiness_plugin_version = '4.8.5';
      $SocialEngineAddOns_version = '4.8.9p12';
      $file_path = APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/ilicense.php";
      $is_file = file_exists($file_path);
      if (empty($is_file)) {
        include APPLICATION_PATH . "/application/modules/Sitebusiness/controllers/license/license4.php";
      } else {
        include $file_path;
      }

      $select = new Zend_Db_Select($db);
      $select
              ->from('engine4_core_modules')
              ->where('name = ?', 'sitebusinessform');
      $check_sitebusinessform = $select->query()->fetchObject();
      if (empty($check_sitebusinessform) && !empty($sitebusiness_is_active)) {
        $db->query('DROP TABLE IF EXISTS `engine4_sitebusinessform_fields_options`;');
        $db->query('
					CREATE TABLE `engine4_sitebusinessform_fields_options` (
						`option_id` int(11) NOT NULL auto_increment,
						`field_id` int(11) NOT NULL,
						`label` varchar(255) NOT NULL,
						`order` smallint(6) NOT NULL default "999",
						PRIMARY KEY  (`option_id`),
						KEY `field_id` (`field_id`)
					) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE utf8_unicode_ci');

        $db->query('DROP TABLE IF EXISTS `engine4_sitebusinessform_sitebusinessforms`;');
        $db->query('
							CREATE TABLE IF NOT EXISTS `engine4_sitebusinessform_sitebusinessforms` (
								`sitebusinessform_id` int(11) NOT NULL AUTO_INCREMENT,
								`business_id` int(11) NOT NULL,
								`title` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT "Leave your Feedback",
								`description` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
								`status` int(2) NOT NULL DEFAULT "1",
								`businessformactive` int(2) NOT NULL DEFAULT "1",
								`activeyourname` int(2) NOT NULL DEFAULT "1",
								`activeemail` int(2) NOT NULL DEFAULT "1",
								`activeemailself` int(2) NOT NULL DEFAULT "1",
								`activemessage` int(2) NOT NULL DEFAULT "1",
								PRIMARY KEY (`sitebusinessform_id`),
                KEY `business_id` (`business_id`)
							) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;
												');

        $db->query('DROP TABLE IF EXISTS `engine4_sitebusinessform_businessquetions`;');
        $db->query('
						CREATE TABLE IF NOT EXISTS `engine4_sitebusinessform_businessquetions` (
						`businessquetion_id` int(11) NOT NULL AUTO_INCREMENT,
						`option_id` int(11) NOT NULL,
						`business_id` int(11) NOT NULL,
						PRIMARY KEY (`businessquetion_id`),
            KEY `business_id` (`business_id`)
					) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1');
      }

      $businessTime = time();
      $db->query("INSERT IGNORE INTO `engine4_core_settings` (`name`, `value`) VALUES
			('sitebusinessform.basetime', $businessTime ),
			('sitebusinessform.isvar', 0 ),
			('sitebusinessform.filepath', 'Sitebusinessform/controllers/license/license2.php');");



      $table_exist = $db->query("SHOW TABLES LIKE 'engine4_sitebusinessform_sitebusinessforms'")->fetch();
      if (!empty($table_exist)) {
        //ADD THE INDEX FROM THE "engine4_sitebusinessform_sitebusinessforms" TABLE
        $businessIdColumnIndex = $db->query("SHOW INDEX FROM `engine4_sitebusinessform_sitebusinessforms` WHERE Key_name = 'business_id'")->fetch();

        if( empty($businessIdColumnIndex)) {
          $db->query("ALTER TABLE `engine4_sitebusinessform_sitebusinessforms` ADD INDEX ( `business_id` );");
        }
      }

      $table_exist = $db->query("SHOW TABLES LIKE 'engine4_sitebusinessform_businessquetions'")->fetch();
      if (!empty($table_exist)) {
        //ADD THE INDEX FROM THE "engine4_sitebusinessform_businessquetions" TABLE
        $businessIdQuestionColumnIndex = $db->query("SHOW INDEX FROM `engine4_sitebusinessform_businessquetions` WHERE Key_name = 'business_id'")->fetch();

        if( empty($businessIdQuestionColumnIndex)) {
          $db->query("ALTER TABLE `engine4_sitebusinessform_businessquetions` ADD INDEX ( `business_id` );");
        }
      }
      parent::onPreInstall();
    } elseif (!empty($check_sitebusiness) && empty($sitebusiness_is_active)) {
      $baseUrl = $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getBaseUrl();
      $url_string = Zend_Controller_Front::getInstance()->getRequest()->getRequestUri();
      if (strstr($url_string, "manage/install")) {
        $calling_from = 'install';
      } else if (strstr($url_string, "manage/query")) {
        $calling_from = 'queary';
      }
      $explode_base_url = explode("/", $baseUrl);
      foreach ($explode_base_url as $url_key) {
        if ($url_key != 'install') {
          $core_final_url .= $url_key . '/';
        }
      }

      return $this->_error("<span style='color:red'>Note: You have installed the <a href='http://www.socialengineaddons.com/socialengine-directory-businesses-plugin' target='_blank'>Directory / Businesses Plugin</a> but not activated it on your site yet. Please activate it first before installing the Directory / Businesses - Form Extension.</span><br/> <a href='" . 'http://' . $core_final_url . "admin/sitebusiness/settings/readme'>Click here</a> to activate the Directory / Businesses Plugin.");
    } else {
      $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();
      return $this->_error("<span style='color:red'>Note: You have not installed the <a href='http://www.socialengineaddons.com/socialengine-directory-businesses-plugin' target='_blank'>Directory / Businesses Plugin</a> on your site yet. Please install it first before installing the <a href='http://www.socialengineaddons.com/businessextensions/socialengine-directory-businesses-form' target='_blank'>Directory / Businesses - Form Extension</a>.</span><br/> <a href='" . $base_url . "/manage'>Click here</a> to go Manage Packages.");
    }
  }

  function onEnable() {
    $db = $this->getDb();
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_settings')
            ->where('name = ?', 'sitebusinessform.isActivate')
            ->limit(1);

    $sitebusinessform_settings = $select->query()->fetchAll();
    if (!empty($sitebusinessform_settings)) {
      $select = new Zend_Db_Select($db);
      $select_content = $select
                      ->from('engine4_sitebusinessform_businessquetions');
      $content = $select_content->query()->fetchAll();
      if (!empty($content)) {
				$count_result = count($content);
				$business_id = '';
				$business_id.= $content[0]['business_id'];
				$i = 1;
				while ($i < $count_result) {
					$business_id.= ',' . $content[$i]['business_id'];
					$i++;
				}
				$select = new Zend_Db_Select($db);
				$select_sitebusiness = $select
												->from('engine4_sitebusiness_businesses')
												->where('engine4_sitebusiness_businesses' . '.business_id NOT IN (' . $business_id . ')');
				$sitebusiness_result = $select_sitebusiness->query()->fetchAll();
				if (!empty($sitebusiness_result)) {
					foreach ($sitebusiness_result as $key => $value) {
						$business_id = $value['business_id'];
						$values = $value ['title'];
						$db->insert('engine4_sitebusinessform_fields_options', array(
								'field_id' => 1,
								'label' => $values,
						));
						$option_id = $db->lastInsertId('engine4_sitebusinessform_fields_options');
						$select = new Zend_Db_Select($db);
						$select_content = $select
														->from('engine4_sitebusinessform_businessquetions')
														->where('business_id = ?', $business_id)
														->where('option_id = ?', $option_id)
														->limit(1);
						$content = $select_content->query()->fetchAll();
						if (empty($content)) {
							$db->insert('engine4_sitebusinessform_businessquetions', array(
									'business_id' => $business_id,
									'option_id' => $option_id,
							));
						}

						$db->insert('engine4_sitebusinessform_sitebusinessforms', array(
								'business_id' => $business_id,
						));
					}
				}
      }
    }
    

		$select = new Zend_Db_Select($db);
		$select
					->from('engine4_core_modules')
					->where('name = ?', 'sitemobile')
					->where('enabled = ?', 1);
		$is_sitemobile_object = $select->query()->fetchObject();
		if($is_sitemobile_object)  {
				include APPLICATION_PATH . "/application/modules/Sitebusinessform/controllers/license/mobileLayoutCreation.php";
		}

    parent::onEnable();
  }

  function onInstall() {

    $db = $this->getDb();
    $column_tab_exist = $db->query('SHOW COLUMNS FROM engine4_sitebusinessform_sitebusinessforms LIKE \'offer_tab_name\'')->fetch();
		if (empty($column_tab_exist)) {
			$db->query('ALTER TABLE `engine4_sitebusinessform_sitebusinessforms` ADD `offer_tab_name` VARCHAR( 32 ) NOT NULL AFTER `activemessage`');
		}
		
		$select = new Zend_Db_Select($db);
		$select
						->from('engine4_core_modules')
						->where('name = ?', 'sitebusinessform')
						->where('enabled = ?', 1);
		$is_enabled = $select->query()->fetchObject();
		
		if(!empty($is_enabled)) {
			$select = new Zend_Db_Select($db);
			$select 
							->from('engine4_core_menuitems')
							->where('name = ?', 'sitebusinessform_admin_main_fields');
			$queary_info = $select->query()->fetchAll();
			if (empty($queary_info)) {
				$db->insert('engine4_core_menuitems', array(
						'name' => 'sitebusinessform_admin_main_fields',
						'module' => 'sitebusinessform',
						'label' => 'Form Questions',
						'plugin' => '',
						'params' => '{"route":"admin_default","module":"sitebusinessform","controller":"fields","action":"index"}',
						'menu' => 'sitebusinessform_admin_main',
						'submenu' => '',
						'order' => 3,
				));
			}
		}
		parent::onInstall();
  }
  
  public function onPostInstall() {

    $db = $this->getDb();
		$select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'sitemobile')
            ->where('enabled = ?', 1);
    $is_sitemobile_object = $select->query()->fetchObject();
    if(!empty($is_sitemobile_object)) {
			$db->query("INSERT IGNORE INTO `engine4_sitemobile_modules` (`name`, `visibility`) VALUES ('sitebusinessform','1')");
			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_sitemobile_modules')
							->where('name = ?', 'sitebusinessform')
							->where('integrated = ?', 0);
			$is_sitemobile_object = $select->query()->fetchObject();
      if($is_sitemobile_object)  {
				$actionName = Zend_Controller_Front::getInstance()->getRequest()->getActionName();
				$controllerName = Zend_Controller_Front::getInstance()->getRequest()->getControllerName();
				if($controllerName == 'manage' && $actionName == 'install') {
          $view = new Zend_View();
					$baseUrl = ( !empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://':'http://') .  $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
					$redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
					$redirector->gotoUrl($baseUrl . 'admin/sitemobile/module/enable-mobile/enable_mobile/1/name/sitebusinessform/integrated/0/redirect/install');
				} 
      }
    } 
    
    //Work for the word changes in the business plugin .csv file.
    $actionName = Zend_Controller_Front::getInstance()->getRequest()->getActionName();
    $controllerName = Zend_Controller_Front::getInstance()->getRequest()->getControllerName();
    if($controllerName == 'manage' && ($actionName == 'install' || $actionName == 'query')) {
      $view = new Zend_View();
      $baseUrl = ( !empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://':'http://') .  $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
      $redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
      if ($actionName == 'install') {
        $redirector->gotoUrl($baseUrl . 'admin/sitebusiness/settings/language/redirect/install');
      } else {
        $redirector->gotoUrl($baseUrl . 'admin/sitebusiness/settings/language/redirect/query');
      }
    }
    
  }
}
?>
