<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessmember
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: manifest.php 2013-03-18 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */


$routeStart = "businessmembers";
$module = null;
$controller = null;
$action = null;
$getURL = null;
$request = Zend_Controller_Front::getInstance()->getRequest();
if (!empty($request)) {
  $module = $request->getModuleName(); // Return the current module name.
  $action = $request->getActionName();
  $controller = $request->getControllerName();
  $getURL = $request->getRequestUri();
}
if (empty($request) || !($module == "default" && ( strpos( $getURL, '/install') !== false))) {
  $routeStart = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessmember.manifestUrl', "business-members");
}
return array (
  'package' => array (
    'type' => 'module',
    'name' => 'sitebusinessmember',
    'version' => '5.4.1',
    'path' => 'application/modules/Sitebusinessmember',
    'title' => 'Directory / Businesses - Business Members Extension',
    'description' => 'Directory / Businesses - Business Members Extension',
      'author' => '<a href="http://www.socialapps.tech" style="text-decoration:underline;" target="_blank">SocialApps.tech</a>',
		'callback' => array(
			'path' => 'application/modules/Sitebusinessmember/settings/install.php',
			'class' => 'Sitebusinessmember_Installer',
    ),
    'actions' => array (
      0 => 'install',
      1 => 'upgrade',
      2 => 'refresh',
      3 => 'enable',
      4 => 'disable',
    ),
    'directories' => array (
      0 => 'application/modules/Sitebusinessmember',
    ),
    'files' =>array (
      0 => 'application/languages/en/sitebusinessmember.csv',
    ),
  ),
	// Hooks ---------------------------------------------------------------------
	'hooks' => array(
		array(
			'event' => 'onActivityActionCreateAfter',
			'resource' => 'Sitebusinessmember_Plugin_Core',
		),
	),
  // Items ---------------------------------------------------------------------
  'items' => array (
    'sitebusinessmember_roles'
  ) ,
  'sitemobile_compatible' => true,
  // Route--------------------------------------------------------------------
	'routes' => array(
		'sitebusiness_profilebusinessmember' => array(
			'route' => $routeStart.'/member/:action/*',
			'defaults' => array(
					'module' => 'sitebusinessmember',
					'controller' => 'member',
					//'action' => 'index',
			),
			'reqs' => array(
					'action' => '(join|leave|request|cancel|invite|reject|accept|invite-members|joined-more-businesses|respond)',
			),
		),

	  'sitebusinessmember_approve' => array(
			'route' => $routeStart.'/index/:action/*',
			'defaults' => array(
					'module' => 'sitebusinessmember',
					'controller' => 'index',
					//'action' => 'index',
			),
			'reqs' => array(
					'action' => '(approve|remove|featured|highlighted|reject|edit|request-member|business-join|get-item|member-join|edittitle|create-announcement|delete-announcement|edit-announcement|notification-settings)',
			),
		),
		'sitebusinessmember_browse' => array(
			'route' => $routeStart.'/browse/*',
			'defaults' => array(
				'module' => 'sitebusinessmember',
				'controller' => 'index',
				'action' => 'browse',
			),
		),
		'sitebusinessmember_home' => array(
			'route' => $routeStart.'/home/*',
			'defaults' => array(
					'module' => 'sitebusinessmember',
					'controller' => 'index',
					'action' => 'home',
			),
		),
	),
);