<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessmember
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 2013-03-18 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

$manageCategorySettings = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessmember.category.settings', 1);

if(Engine_Api::_()->core()->hasSubject('sitebusiness_business')) {
	$categories_member = Engine_Api::_()->getDbtable('roles', 'sitebusinessmember')->getRolesAssoc(Engine_Api::_()->core()->getSubject('sitebusiness_business')->business_id);
} else {
  $categories_member = Engine_Api::_()->getDbtable('roles', 'sitebusinessmember')->getSiteAdminRoles(array(), 'adminParams');
}

$categoryOptions = array();
$categoryOptions['0'] = 'Un-categorized (Display members who have not selected their membership roles.)';
if (!empty($categories_member)) {
	asort($categories_member, SORT_LOCALE_STRING);
	foreach( $categories_member as $key => $v ) {

    if(Engine_Api::_()->core()->hasSubject('sitebusiness_business')) {
			$row = Engine_Api::_()->getDbTable('categories', 'sitebusiness')->getCategory(Engine_Api::_()->core()->getSubject('sitebusiness_business')->category_id);
      $categoryOptions[$key] = $v . '  [' .  $row->category_name . ']';
    } else  {
			if ($manageCategorySettings != 1) {
				$categoryOptions['businessadminRole'] = 'Roles created by Business Admins';
			}
			$row = Engine_Api::_()->getDbTable('categories', 'sitebusiness')->getCategory($v['business_category_id']);
			$categoryOptions[$v['role_id']] = $v['role_name'] . '  [' .  $row->category_name . ']';
    }

		
	}
}

$final_array =  array(
	array(
		'title' => 'Business Profile Members',
		'description' => 'This widget form the Member tab on the Business Profile and displays the members of the Business. You can choose to display all members or members based on their Roles by using the edit settings of this widget. It should be placed in the Tabbed Blocks area of the Business Profile.',
		'category' => 'Business Profile',
		'type' => 'widget',
		'name' => 'sitebusinessmember.sitemobile-profile-sitebusinessmembers',
		'defaultParams' => array(
			'title' => 'Members',
			'titleCount' => true,
		),
	  'adminForm' => array(
			'elements' => array(
				array(
					'Radio',
					'show_option',
					array(
						'description' => 'Do you want to display members on the basis of their roles?',
						'multiOptions' => array(
						    '0' => 'Yes, display members based on their roles.',
								'1' => 'No, display all members.',	
						),'value' => 1,
					)
				),
				array(
					'MultiCheckbox',
					'roles_id',
					array(
						'description' => 'Choose the member roles which you want to display in this block.',
						'multiOptions' => $categoryOptions,
					),
				),
			),
		),
	),
	 array(
    'title' => 'Business Profile Announcements',
    'description' => 'Displays list of announcements posted by business admins for their Businesses. This widget should be placed on the Business Profile.',
    'category' => 'Business Profile',
    'type' => 'widget',
    'name' => 'sitebusinessmember.profile-sitebusinessmembers-announcements',
		'defaultParams' => array(
			'title' => 'Announcements',
			'titleCount' => true,
		),
		'adminForm' => array(
			'elements' => array(
				array(
					'Text',
					'itemCount',
					array(
							'label' => 'Count',
							'description' => '(number of announcements to show)',
							'value' => 3,
							'validators' => array(
								array('Int', true),
								array('GreaterThan', true, array(0)),
							),
					),
				),
			),
		),
  ),
	array(
		'title' => 'Business Members',
		'description' => 'Displays the list of Members from Businesses created on your community. This widget should be placed in the widgetized Business Members business. Results from the Search Business Members form are also shown here.',
		'category' => 'Businesses',
		'type' => 'widget',
		'name' => 'sitebusinessmember.sitebusiness-member',
		'defaultParams' => array(
				'title' => '',
				'titleCount' => true,
		),
		'adminForm' => array(
				'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of members to show)',
										'value' => 10,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
				),
		),
	),
);

return $final_array;