<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessmember
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2013-03-18 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessmember_Widget_ProfileSitebusinessmembersController extends Engine_Content_Widget_Abstract {

    protected $_childCount;

    public function indexAction() {

        //DONT RENDER THIS IF SUBJECT IS NOT SET
        if (!Engine_Api::_()->core()->hasSubject('sitebusiness_business')) {
            return $this->setNoRender();
        }
        $this->view->params = $params = $this->_getAllParams();
        //GET SITEBUSINESS SUBJECT
        $this->view->sitebusiness = $sitebusiness = Engine_Api::_()->core()->getSubject('sitebusiness_business');

        if (!Engine_Api::_()->sitebusiness()->allowInThisBusiness($sitebusiness, "sitebusinessmember", 'smecreate')) {
            return $this->setNoRender();
        }

//    //START MANAGE-ADMIN CHECK
//    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'view');
//    if (empty($isManageAdmin)) {
//      return $this->setNoRender();
//    }

        $rolesTable = Engine_Api::_()->getDbtable('roles', 'sitebusinessmember');

        $this->view->show_option = $show_option = $this->_getParam('show_option', 1);
        $this->view->roles_id = $roles_id = $this->_getParam('roles_id', null);
//    $isajax = $this->_getParam('isajax', null);

        $rolesParams = array();
        if ($show_option == 0) {
            $othersRoles = in_array('0', $roles_id);
            $businessAdminRoles = in_array('businessadminRole', $roles_id);

//      if ($othersRoles) {
//				if (!empty($role_id)) {
//					unset($role_id[array_search('0', $role_id)]);
//				}
//      }

            if (!empty($roles_id))
                $rolesParams = $rolesTable->getSiteAdminRoles(array("business_category_id" => $sitebusiness->category_id, 'role_ids' => $roles_id));

            if (!empty($businessAdminRoles)) {
                $businessAdminRole = $rolesTable->getBusinessadminsRoles($sitebusiness->business_id);
                $rolesParams = array_merge($rolesParams, $businessAdminRole);
            }
            if ($othersRoles) {
                $rolesParams[] = '0';
            }
            if (count($rolesParams) < 1)
                return $this->setNoRender();
        }
        //}

        $sitebusinessmemberProfile = Zend_Registry::isRegistered('sitebusinessmemberProfile') ? Zend_Registry::get('sitebusinessmemberProfile') : null;
        if (empty($sitebusinessmemberProfile)) {
            return $this->setNoRender();
        }

        //GET VIEWER INFORMATION
        $viewer = Engine_Api::_()->user()->getViewer();
        $this->view->viewer_id = $viewer_id = $viewer->getIdentity();

        $businessMemberPhraseNum = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessmember.phrase.num', null);

        $memberJoinType = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessmember.join.type', null);
        if ($memberJoinType != $businessMemberPhraseNum) {
            return $this->setNoRender();
        }

        //TOTAL members
        $memberCount = Engine_Api::_()->sitebusiness()->getTotalCount($sitebusiness->business_id, 'sitebusiness', 'membership');

        $this->view->can_edit = $can_edit = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');

        if (empty($memberCount) && empty($can_edit)) {
            return $this->setNoRender();
        }

        $membershipTable = Engine_Api::_()->getDbtable('membership', 'sitebusiness');

        $values = array();
        //END MANAGE-ADMIN CHECK
        if (!empty($rolesParams)) {
            $values['roles_id'] = $rolesParams;
        }
        $layout = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.layoutcreate', 0);
        $this->view->widgets = $widgets = Engine_Api::_()->sitebusiness()->getwidget($layout, $sitebusiness->business_id);

        $this->view->module_tabid = $currenttabid = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab', null);
        $isajax = $this->_getParam('is_ajax_load', null);
        $this->view->isajax = $isajax;
        $this->view->showtoptitle = $showtoptitle = Engine_Api::_()->sitebusiness()->showtoptitle($layout, $sitebusiness->business_id);

        if (!empty($isajax) || ($currenttabid == $this->view->identity) || ($widgets == 0)) {
            $this->view->identity_temp = Zend_Controller_Front::getInstance()->getRequest()->getParam('identity_temp', $currenttabid);
            $this->view->show_content = true;

            //GET SEARCHING PARAMETERS
            $this->view->business = $business = $this->_getParam('business', 1);
            $this->view->search = $search = $this->_getParam('search');
            $this->view->search_text = $search = $this->_getParam('search_text');
            $this->view->role_id = $role_id = $this->_getParam('role_id', 0);
            $this->view->visibility = $selectbox = $this->_getParam('visibility');
            $this->view->member_encoded = $member_encoded = (int) $this->_getParam('member_encoded', 1);

            if (!empty($search)) {
                $values['search'] = $search;
            }

            if (!empty($selectbox)) {
                $values['orderby'] = $selectbox;
            }

            $values['business_id'] = $sitebusiness->business_id;

            if (!empty($role_id)) {
                $values['roles_id'] = $role_id > 0 ? array($role_id) : array(0);
            }

            $this->view->request_count = $membershipTable->getSitebusinessmembersPaginator($values, 'request');

            //MAKE PAGINATOR
            $currentBusinessNumber = $this->_getParam('business', 1);

            $this->view->paginator = $paginator = $membershipTable->getSitebusinessmembersPaginator($values);
            //if ($paginator->getTotalItemCount() == 0) return $this->setNoRender();
            $paginator->setItemCountPerPage(24)->setCurrentPageNumber($currentBusinessNumber);

            //ADD NUMBER OF POLLS IN TAB
            if ($this->_getParam('titleCount', false) && $paginator->getTotalItemCount() > 0) {
                $this->_childCount = $paginator->getTotalItemCount();
            } else {
                if (empty($this->view->search) && empty($can_edit)) {
                    return $this->setNoRender();
                }
            }

            //CHECK IF USER IS JOIN THE BUSINESS OR NOT.
            //$friendId = $viewer->membership()->getMembershipsOfIds();
            $select = $membershipTable->hasMembers($viewer_id, $sitebusiness->business_id);
            if (!empty($select)) {
                $this->view->hasMember = 1;
            }

            $this->view->roleParamsArray = $rolesTable->rolesParams(array($sitebusiness->category_id), 0, $rolesParams, 1, $sitebusiness->business_id);
        } else {
            $this->view->show_content = false;
            $this->view->identity_temp = $this->view->identity;
            $values['business_id'] = $sitebusiness->business_id;
            $values['show_count'] = 1;

            if ($can_edit) {
                $this->view->request_count = $membershipTable->getSitebusinessmembersPaginator($values, 'request');

                $this->view->paginator = $paginator = $membershipTable->getSitebusinessmembersPaginator($values);

                if ($paginator->getTotalItemCount() > 0) {
                    $this->_childCount = $paginator->getTotalItemCount();
                }
            } else {
                $this->view->request_count = $membershipTable->getSitebusinessmembersPaginator($values, 'request');
                $this->view->paginator = $paginator = $membershipTable->getSitebusinessmembersPaginator($values);

                if ($paginator->getTotalItemCount() == 0)
                    return $this->setNoRender();

                if ($paginator->getTotalItemCount() > 0) {
                    $this->_childCount = $paginator->getTotalItemCount();
                }
            }
        }
        $this->view->user_layout = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.layoutcreate', 0);

        if ($sitebusiness->member_title && $sitebusiness->member_count > 1 && Engine_Api::_()->getApi('settings', 'core')->getSetting('businessmember.member.title', 1) && $show_option) {
            $this->getElement()->setTitle($sitebusiness->member_title);
        }
    }

    public function getChildCount() {
        return $this->_childCount;
    }

}
