<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessmember
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2013-03-18 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessmember_Widget_SitemobileProfileSitebusinessmembersController extends Engine_Content_Widget_Abstract {

  protected $_childCount;

  public function indexAction() {

    //DONT RENDER THIS IF SUBJECT IS NOT SET
    if (!Engine_Api::_()->core()->hasSubject('sitebusiness_business')) {
      return $this->setNoRender();
    }

    $this->view->params = $params = $this->_getAllParams();
    //GET SITEBUSINESS SUBJECT
    $this->view->sitebusiness = $sitebusiness = Engine_Api::_()->core()->getSubject('sitebusiness_business');
    if (!Engine_Api::_()->sitebusiness()->allowInThisBusiness($sitebusiness, "sitebusinessmember", 'smecreate')) {
      return $this->setNoRender();
    }
		//START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'view');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }

    $membershipTable = Engine_Api::_()->getDbtable('membership', 'sitebusiness');
    $rolesTable = Engine_Api::_()->getDbtable('roles', 'sitebusinessmember');

    $this->view->show_option = $show_option = $this->_getParam('show_option', 1);
    $this->view->roles_id = $roles_id = $this->_getParam('roles_id', null);
    $rolesParams = array();
    if ($show_option == 0) {
      $othersRoles = in_array('0', $roles_id);
      $businessAdminRoles = in_array('businessadminRole', $roles_id);

      if ($othersRoles) {
        unset($role_id[array_search('0', $role_id)]);
      }

      if (!empty($roles_id))
        $rolesParams = $rolesTable->getSiteAdminRoles(array("business_category_id" => $sitebusiness->category_id, 'role_ids' => $roles_id));

      if (!empty($businessAdminRoles)) {
        $businessAdminRole = $rolesTable->getBusinessadminsRoles($sitebusiness->business_id);
        $rolesParams = array_merge($rolesParams, $businessAdminRole);
      }
      if ($othersRoles) {
        $rolesParams[] = '0';
      }
      if (count($rolesParams) < 1)
        return $this->setNoRender();
    }

    $this->view->roleParamsArray = $roleParamsArray = $rolesTable->rolesParams(array($sitebusiness->category_id), 0, $rolesParams, 1);
    $memberJoinType = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessmember.join.type', null);
    $sitebusinessmemberProfile = Zend_Registry::isRegistered('sitebusinessmemberProfile') ? Zend_Registry::get('sitebusinessmemberProfile') : null;
    if (empty($sitebusinessmemberProfile)) {
      return $this->setNoRender();
    }

    //GET VIEWER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewer_id = $viewer->getIdentity();

    $businessMemberPhraseNum = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessmember.phrase.num', null);

    //GET BUSINESS ID
    $this->view->business_id = $business_id = $sitebusiness->business_id;

    if ($memberJoinType != $businessMemberPhraseNum) {
      return $this->setNoRender();
    }

    //CHECK IF USER IS JOIN THE BUSINESS OR NOT.
    $friendId = $viewer->membership()->getMembershipsOfIds();
    $select = $membershipTable->hasMembers($viewer_id, $sitebusiness->business_id);
    if (!empty($select)) {
      $this->view->hasMember = 1;
    }

    //TOTAL members
    $memberCount = Engine_Api::_()->sitebusiness()->getTotalCount($business_id, 'sitebusiness', 'membership');

    $this->view->can_edit = $can_edit = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');


    if (empty($memberCount) && empty($can_edit)) {
      return $this->setNoRender();
    }
    $values = array();
    //END MANAGE-ADMIN CHECK
    if (!empty($rolesParams)) {
      $values['roles_id'] = $rolesParams;
    }


		//GET SEARCHING PARAMETERS
		$this->view->role_id = $role_id = $this->_getParam('role_id', 0);
		$this->view->member_encoded = $member_encoded = (int) $this->_getParam('member_encoded', 1);
    $this->view->visibility = $selectbox = $this->_getParam('visibility', 'join_date');
		$values['business_id'] = $business_id;

		if (!empty($selectbox)) {
			$values['orderby'] = $selectbox;
		}

		if (!empty($role_id)) {
			$values['roles_id'] = $role_id > 0 ? array($role_id) : array(0);
		}

		$this->view->request_count = $membershipTable->getSitebusinessmembersPaginator($values, 'request');
		$this->view->paginator = $paginator = $membershipTable->getSitebusinessmembersPaginator($values);
		$this->view->paginator->setItemCountPerPage(10)->setCurrentPageNumber($this->_getParam('business', 1));
		$this->_childCount = $paginator->getTotalItemCount();
		if($sitebusiness->member_title && $sitebusiness->member_count > 1 && Engine_Api::_()->getApi('settings', 'core')->getSetting( 'businessmember.member.title' , 1) && $show_option){
				$this->getElement()->setTitle($sitebusiness->member_title);
		}
  }

  public function getChildCount() {
    return $this->_childCount;
  }

}