<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessmusic
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Widget.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessmusic_Form_Admin_Widget extends Engine_Form {

  public function init() {
    
    $this
            ->setTitle('Widget Settings')
            ->setDescription('Configure the general settings for the various widgets available with this plugin.');

    $this->addElement('Text', 'sitebusinessmusic_comment_widgets', array(
        'label' => 'Business Profile Most Commented Playlists',
        'maxlength' => '3',
        'description' => 'How many playlists will be shown in the business profile most commented playlists widget (value can not be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessmusic.comment.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'sitebusinessmusic_recent_widgets', array(
        'label' => 'Business Profile Most Recent Playlists',
        'maxlength' => '3',
        'description' => 'How many playlists should be shown in the business profile most recent playlists widget (value cannot be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessmusic.recent.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'sitebusinessmusic_like_widgets', array(
        'label' => 'Business Profile Most Liked Playlists',
        'maxlength' => '3',
        'description' => 'How many playlists should be shown in the business profile most liked playlists widget (value cannot be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessmusic.like.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'sitebusinessmusic_popular_widgets', array(
        'label' => 'Business Profile Most Popular Playlists',
        'maxlength' => '3',
        'description' => 'How many playlists should be shown in the business profile most popular playlists widget (value cannot be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessmusic.popular.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'sitebusinessmusic_homerecentmusics_widgets', array(
        'label' => 'Recent Business Playlists',
        'maxlength' => '3',
        'description' => 'How many playlists should be shown in the recent business playlists widget (value cannot be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessmusic.homerecentmusics.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));
    
    $this->addElement('Text', 'sitebusinessmusic_homepopularmusics_widgets', array(
        'label' => 'Popular Business Playlists',
        'maxlength' => '3',
        'description' => 'How many playlists should be shown in the popular business playlists widget (value cannot be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessmusic.homepopularmusics.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));
    $this->addElement('Button', 'submit', array(
        'label' => 'Save Changes',
        'type' => 'submit',
        'ignore' => true
    ));
  }

}

?>