<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessmusic
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Menus.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessmusic_Plugin_Menus {

  public function canViewMusics() {

    if (!Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessmusic.music.show.menu', 1)) {
      return false;
    }

    $table = Engine_Api::_()->getDbTable('playlists', 'sitebusinessmusic');
    $rName = $table->info('name');
    $table_businesses = Engine_Api::_()->getDbtable('business', 'sitebusiness');
    $rName_businesses = $table_businesses->info('name');
    $select = $table->select()
                    ->setIntegrityCheck(false)
                    ->from($rName_businesses, array('photo_id', 'title as sitebusiness_title'))
                    ->join($rName, $rName . '.business_id = ' . $rName_businesses . '.business_id')
                    ->where($rName . '.search = ?', '1');
    $select = $select
                    ->where($rName_businesses . '.closed = ?', '0')
                    ->where($rName_businesses . '.approved = ?', '1')
                    ->where($rName_businesses . '.search = ?', '1')
                    ->where($rName_businesses . '.declined = ?', '0')
                    ->where($rName_businesses . '.draft = ?', '1');
    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
      $select->where($rName_businesses . '.expiration_date  > ?', date("Y-m-d H:i:s"));
    }
    $row = $table->fetchAll($select);
    $count = count($row);
    if (empty($count)) {
      return false;
    }
    return true;
  }
//SITEMOBILE BUSINESS MUSIC MENUS
   public function onMenuInitialize_SitebusinessmusicAdd($row) { 
    $subject = Engine_Api::_()->core()->getSubject();

    $playlist_id = $subject->getIdentity();

    $playlist = Engine_Api::_()->getItem('sitebusinessmusic_playlist', $playlist_id);
    $business_id = $playlist->business_id;
    if (empty($playlist)) {
      return false;
    }
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'smcreate');
    if (empty($isManageAdmin)) {
      $can_create = 0;
    } else {
      $can_create = 1;
    }
    //CHECKS FOR UPLOAD MUSIC
    if (empty($can_create)) {
      return false;
    }
    return array(
        'label' => 'Upload Music',
        'route' => 'sitebusinessmusic_create',
        'class' => 'ui-btn-action',
        'params' => array(
            'business_id' => $business_id,
            'tab' => Zend_Controller_Front::getInstance()->getRequest()->getParam('tab')
        )
    );
  }
  
   public function onMenuInitialize_SitebusinessmusicEdit($row) { 
    $playlist = Engine_Api::_()->core()->getSubject('sitebusinessmusic_playlist');
    if (empty($playlist)) {
      return false;
    }

    //GET LOGGED IN USER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    $owner_id = $playlist->owner_id;
    $business_id = $playlist->business_id;

    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //CHECKS FOR EDIT PLAYLIST
    if ($owner_id != $viewer_id && empty($can_edit)) {
      return false;
    }

    return array(
        'label' => 'Edit Playlist',
        'route' => 'sitebusinessmusic_playlist_specific',
        'class' => 'ui-btn-action',
        'params' => array(
            'action' => 'edit',
            'business_id' => $business_id,
            'playlist_id' => $playlist->playlist_id,
            'slug' => $playlist->getTitle(),
            'tab' => Zend_Controller_Front::getInstance()->getRequest()->getParam('tab')
        )
    );
  }

  public function onMenuInitialize_SitebusinessmusicDelete($row) {
    $playlist = Engine_Api::_()->core()->getSubject('sitebusinessmusic_playlist');
    if (empty($playlist)) {
      return false;
    }

    //GET LOGGED IN USER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    $owner_id = $playlist->owner_id;
    $business_id = $playlist->business_id;

    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //CHECKS FOR DELETE PLAYLIST
    if ($owner_id != $viewer_id && empty($can_edit)) {
      return false;
    }
    return array(
        'label' => 'Delete Playlist',
        'route' => 'sitebusinessmusic_playlist_specific',
        'class' => 'ui-btn-danger smoothbox',
        'params' => array(
            'action' => 'delete',
            'business_id' => $business_id,
            'playlist_id' => $playlist->playlist_id,
            'slug' => $playlist->getTitle(),
            'tab' => Zend_Controller_Front::getInstance()->getRequest()->getParam('tab')
        )
    );
  }

  public function onMenuInitialize_SitebusinessmusicShare($row) {
    $playlist = Engine_Api::_()->core()->getSubject('sitebusinessmusic_playlist');
    if (empty($playlist)) {
      return false;
    }
    //GET LOGGED IN USER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    //CHECKS FOR SHARE PLAYLIST
    if (empty($viewer_id)) {
      return false;
    }

    return array(
        'label' => 'Share',
        'route'=>'default',
        'class' => 'ui-btn-action smoothbox',
        'params' => array(
            'module'=>'activity',
            'controller'=>'index',
	          'action'=>'share',
            'type'=>'sitebusinessmusic_playlist',
            'id' => $playlist->getIdentity(),
        )
    );
  }

  public function onMenuInitialize_SitebusinessmusicReport($row) {
    $playlist = Engine_Api::_()->core()->getSubject('sitebusinessmusic_playlist');
    if (empty($playlist)) {
      return false;
    }
    //GET LOGGED IN USER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    //CHECKS FOR REPORT PLAYLIST
    if (empty($viewer_id)) {
      return false;
    }

    return array(
        'label' => 'Report',
        'route' => 'default',
        'class' => 'ui-btn-action smoothbox',
        'params' => array(
            'module' => 'core',
            'controller' => 'report',
            'action' => 'create',
            'subject' => $playlist->getGuid(),
        )
    );
  }
}
?>