<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Menus.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessmusic_Plugin_Sitemobile {
  
  protected $_pagesTable;
  protected $_contentTable;

  public function onIntegrated() {
    
    $this->_pagesTable =  Engine_Api::_()->getApi('modules', 'sitemobile')->_pagesTable;
    $this->_contentTable =  Engine_Api::_()->getApi('modules', 'sitemobile')->_contentTable;
    //Business music
    $this->addSitebusinessMusicProfileContent();
    $this->addSitebusinessMusicBrowseBusiness();
    $this->addSitebusinessMusicCreateBusiness();
    $this->addSitebusinessMusicViewBusiness();
    include APPLICATION_PATH . "/application/modules/Sitebusinessmusic/controllers/license/mobileLayoutCreation.php";
  }
  //business music
  public function addSitebusinessMusicProfileContent() {

    // install content areas

    $db = Engine_Db_Table::getDefaultAdapter();
    $business_id = Engine_Api::_()->getApi('modules', 'sitemobile')->getPageId('sitebusiness_index_view');

    // Check if it's already been placed
    $select = new Zend_Db_Select($db);
    $select
            ->from($this->_contentTable)
            ->where('page_id = ?', $business_id)
            ->where('type = ?', 'widget')
            ->where('name = ?', 'sitebusinessmusic.sitemobile-profile-sitebusinessmusic')
    ;
    $info = $select->query()->fetch();

    if (empty($info)) {

      // container_id (will always be there)
      $select = new Zend_Db_Select($db);
      $select
              ->from($this->_contentTable)
              ->where('page_id = ?', $business_id)
              ->where('type = ?', 'container')
              ->limit(1);
      $container_id = $select->query()->fetchObject()->content_id;

      // middle_id (will always be there)
      $select = new Zend_Db_Select($db);
      $select
              ->from($this->_contentTable)
              ->where('parent_content_id = ?', $container_id)
              ->where('type = ?', 'container')
              ->where('name = ?', 'middle')
              ->limit(1);
      $middle_id = $select->query()->fetchObject()->content_id;

      // tab_id (tab container) may not always be there
      $select
              ->reset('where')
              ->where('type = ?', 'widget')
              ->where('name = ?', 'sitemobile.container-tabs-columns')
              ->where('page_id = ?', $business_id)
              ->limit(1);
      $tab_id = $select->query()->fetchObject();
      if ($tab_id && @$tab_id->content_id) {
        $tab_id = $tab_id->content_id;
      } else {
        $tab_id = null;
      }

      // tab on profile
      $db->insert($this->_contentTable, array(
          'page_id' => $business_id,
          'type' => 'widget',
          'name' => 'sitebusinessmusic.sitemobile-profile-sitebusinessmusic',
          'parent_content_id' => ($tab_id ? $tab_id : $middle_id),
          'order' => 1900,
          'params' => '{"title":"Music","titleCount":true}',
      ));
    }
  }

  public function addSitebusinessMusicViewBusiness() {
    $db = Engine_Db_Table::getDefaultAdapter();

    $business_id = Engine_Api::_()->getApi('modules', 'sitemobile')->getPageId('sitebusinessmusic_playlist_view');
    // insert if it doesn't exist yet
    if (!$business_id) {
      // Insert business
      $db->insert($this->_pagesTable, array(
          'name' => 'sitebusinessmusic_playlist_view',
          'displayname' => 'Directory / Businesses - Music Playlist View Page',
          'title' => 'Music Playlist View Page',
          'description' => 'This is music playlist view page.',
          'custom' => 0,
      ));
      $business_id = $db->lastInsertId();

      // Insert main
      $db->insert($this->_contentTable, array(
          'type' => 'container',
          'name' => 'main',
          'page_id' => $business_id,
      ));
      $main_id = $db->lastInsertId();

      // Insert middle
      $db->insert($this->_contentTable, array(
          'type' => 'container',
          'name' => 'middle',
          'page_id' => $business_id,
          'parent_content_id' => $main_id,
          'order' => 2,
      ));
      $middle_id = $db->lastInsertId();

      // Insert content
      $db->insert($this->_contentTable, array(
          'type' => 'widget',
          'name' => 'sitebusinessmusic.music-content',
          'page_id' => $business_id,
          'parent_content_id' => $middle_id,
          'order' => 2,
      ));
      $db->insert($this->_contentTable, array(
          'type' => 'widget',
          'name' => 'sitemobile.comments',
          'page_id' => $business_id,
          'parent_content_id' => $middle_id,
          'order' => 3,
      ));
    } 
  }

  public function addSitebusinessMusicBrowseBusiness() {
    $db = Engine_Db_Table::getDefaultAdapter();

    $business_id = Engine_Api::_()->getApi('modules', 'sitemobile')->getPageId('sitebusinessmusic_playlist_browse');

    // insert if it doesn't exist yet
    if (!$business_id) {
      // Insert business
      $db->insert($this->_pagesTable, array(
          'name' => 'sitebusinessmusic_playlist_browse',
          'displayname' => 'Directory / Businesses - Browse Music',
          'title' => 'Browse Music',
          'description' => 'This is browse music page.',
          'custom' => 0,
      ));
      $business_id = $db->lastInsertId();

      // Insert main
      $db->insert($this->_contentTable, array(
          'type' => 'container',
          'name' => 'main',
          'page_id' => $business_id,
      ));
      $main_id = $db->lastInsertId();

      // Insert middle
      $db->insert($this->_contentTable, array(
          'type' => 'container',
          'name' => 'middle',
          'page_id' => $business_id,
          'parent_content_id' => $main_id,
          'order' => 2,
      ));
      $middle_id = $db->lastInsertId();

      $db->insert($this->_contentTable, array(
          'type' => 'widget',
          'name' => 'sitemobile.sitemobile-navigation',
          'page_id' => $business_id,
          'parent_content_id' => $middle_id,
          'order' => 1,
      ));
      // Insert Advance search
      $db->insert($this->_contentTable, array(
          'type' => 'widget',
          'name' => 'sitemobile.sitemobile-advancedsearch',
          'page_id' => $business_id,
          'parent_content_id' => $middle_id,
          'params' => '{"search":"2","title":"","nomobile":"0","name":"sitemobile.sitemobile-advancedsearch"}',
          'order' => 2,
          'module' => 'sitemobile'
      ));
      // Insert content
      $db->insert($this->_contentTable, array(
          'type' => 'widget',
          'name' => 'sitebusinessmusic.sitebusiness-music',
          'page_id' => $business_id,
          'parent_content_id' => $middle_id,
          'params' => '{"itemCount":"10"}',
          'order' => 3,
      ));
    }
   
  }

  public function addSitebusinessMusicCreateBusiness() {

    $db = Engine_Db_Table::getDefaultAdapter();

    $business_id = Engine_Api::_()->getApi('modules', 'sitemobile')->getPageId('sitebusinessmusic_index_create');
    if (!$business_id) {

      // Insert business
      $db->insert($this->_pagesTable, array(
          'name' => 'sitebusinessmusic_index_create',
          'displayname' => 'Directory / Businesses - Create Music',
          'title' => 'Create new Music',
          'description' => 'This is music create page.',
          'custom' => 0,
      ));
      $business_id = $db->lastInsertId();

      // Insert main
      $db->insert($this->_contentTable, array(
          'type' => 'container',
          'name' => 'main',
          'page_id' => $business_id,
          'order' => 1,
      ));
      $main_id = $db->lastInsertId();

      // Insert main-middle
      $db->insert($this->_contentTable, array(
          'type' => 'container',
          'name' => 'middle',
          'page_id' => $business_id,
          'parent_content_id' => $main_id,
      ));
      $main_middle_id = $db->lastInsertId();

      // Insert content
      $db->insert($this->_contentTable, array(
          'type' => 'widget',
          'name' => 'core.content',
          'page_id' => $business_id,
          'parent_content_id' => $main_middle_id,
          'order' => 2,
      ));
    }
    
  }

}