<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessmusic
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content_user.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$isActive = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessmusic.isActivate', 0);
if (empty($isActive)) {
  return;
}
$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => $view->translate('Business Profile Music'),
        'description' => $view->translate('Forms the Music tab of your Business and shows music of your Business. It should be placed in the Tabbed Blocks area of the Business Profile.'),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusinessmusic.profile-sitebusinessmusic',
        'defaultParams' => array(
            'title' => $view->translate('Music'),
        ),
    ),
    array(
        'title' => $view->translate('Business Profile Most Popular Playlists'),
        'description' => $view->translate("Displays your Business's most popular playlists."),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusinessmusic.popular-sitebusinessmusic',
        'defaultParams' => array(
            'title' => $view->translate('Most Popular Playlists'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Business Profile Most Commented Playlists'),
        'description' => $view->translate("Displays your Business's most commented playlists."),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusinessmusic.comment-sitebusinessmusic',
        'defaultParams' => array(
            'title' => $view->translate('Most Commented Playlists'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Business Profile Most Recent Playlists'),
        'description' => $view->translate("Displays your Business's most recent playlists."),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusinessmusic.recent-sitebusinessmusic',
        'defaultParams' => array(
            'title' => $view->translate('Most Recent Playlists'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Business Profile Most Liked Playlists'),
        'description' => $view->translate("Displays your Business's most liked playlists."),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusinessmusic.like-sitebusinessmusic',
        'defaultParams' => array(
            'title' => $view->translate('Most Liked Playlists'),
            'titleCount' => true,
        ),
    ),
    array(
	    'title' => $view->translate('Business Profile Player'),
	    'description' => $view->translate("Displays a music player that plays the playlist that you select to be played on your Business Profile."),
	    'category' => 'Business Profile',
	    'type' => 'widget',
	    'name' => 'sitebusinessmusic.profile-player',
   ),  
)
?>