<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessmusic
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessmusic_Installer extends Engine_Package_Installer_Module {

  function onPreInstall() {
    //GET DB
    $db = $this->getDb();

    //CHECK THAT SITEBUSINESS PLUGIN IS ACTIVATED OR NOT
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_settings')
            ->where('name = ?', 'sitebusiness.is.active')
            ->limit(1);
    $sitebusiness_settings = $select->query()->fetchAll();
    if ( !empty($sitebusiness_settings) ) {
      $sitebusiness_is_active = $sitebusiness_settings[0]['value'];
    }
    else {
      $sitebusiness_is_active = 0;
    }

    //CHECK THAT SITEBUSINESS PLUGIN IS INSTALLED OR NOT
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'sitebusiness');
    $check_sitebusiness = $select->query()->fetchObject();
    //$curr_module_version = strcasecmp($check_sitebusiness->version, '4.1.6p1');
    if ( !empty($check_sitebusiness->enabled) && !empty($sitebusiness_is_active) ) {
        $PRODUCT_TYPE = 'sitebusinessmusic';
        $PLUGIN_TITLE = 'Sitebusinessmusic';
        $PLUGIN_VERSION = '5.4.1';
        $PLUGIN_CATEGORY = 'plugin';
        $PRODUCT_DESCRIPTION = 'Sitebusinessmusic Plugin';
        $businessTime = time();
        $_PRODUCT_FINAL_FILE = 0;
      $sitebusiness_plugin_version = '4.8.6';
      $SocialEngineAddOns_version = '4.10.3p6';
        $PRODUCT_TITLE = 'Directory / Businesses - Music Extension';
        $file_path = APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/ilicense.php";
        $is_file = file_exists($file_path);
        if ( empty($is_file) ) {
          include APPLICATION_PATH . "/application/modules/Sitebusiness/controllers/license/license4.php";
        }
        else {
          include $file_path;
        }
        $db->query("INSERT IGNORE INTO `engine4_core_settings` (`name`, `value`) VALUES ('sitebusinessmusic.basetime', $businessTime ), ('sitebusinessmusic.isvar', 0 );");

        parent::onPreInstall();
    }
    elseif ( !empty($check_sitebusiness) && empty($sitebusiness_is_active) ) {
      $baseUrl = $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getBaseUrl();
      $url_string = Zend_Controller_Front::getInstance()->getRequest()->getRequestUri();
      if ( strstr($url_string, "manage/install") ) {
        $calling_from = 'install';
      }
      else if ( strstr($url_string, "manage/query") ) {
        $calling_from = 'queary';
      }
      $explode_base_url = explode("/", $baseUrl);
      foreach ( $explode_base_url as $url_key ) {
        if ( $url_key != 'install' ) {
          $core_final_url .= $url_key . '/';
        }
      }
      return $this->_error("<span style='color:red'>Note: You have installed the <a href='http://www.socialengineaddons.com/socialengine-directory-businesses-plugin' target='_blank'>Directory / Businesses Plugin</a> but not activated it on your site yet. Please activate it first before installing the Directory / Businesses - Music Extension.</span><br/> <a href='" . 'http://' . $core_final_url . "admin/sitebusiness/settings/readme'>Click here</a> to activate the Directory / Businesses Plugin.");
    }
    else {
      $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();
      return $this->_error("<span style='color:red'>Note: You have not installed the <a href='http://www.socialengineaddons.com/socialengine-directory-businesses-plugin' target='_blank'>Directory / Businesses Plugin</a> on your site yet. Please install it first before installing the <a href='http://www.socialengineaddons.com/businessextensions/socialengine-directory-businesses-music' target='_blank'>Directory / Businesses - Music Extension</a>.</span><br/> <a href='" . $base_url . "/manage'>Click here</a> to go Manage Packages.");
    }
  }

  function onInstall() {
		$db = $this->getDb();
		
    $db->query('UPDATE  `engine4_activity_notificationtypes` SET  `body` =  \'{item:$subject} has created a business music {item:$object}.\' WHERE  `engine4_activity_notificationtypes`.`type` =  "sitebusinessmusic_create";');

    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_settings')
            ->where('name = ?', 'sitebusinessmusic.is.active')
            ->limit(1);
    $sitebusinessmusic_settings = $select->query()->fetchAll();

  // WIDGET SETTING WORK
		$select = new Zend_Db_Select($db);
		$select
						->from('engine4_core_menuitems')
						->where('name = ?', 'sitebusinessmusic_admin_widget_settings')
						->limit(1);
		$info = $select->query()->fetch();
		if (empty($info) && !empty($sitebusinessmusic_settings)) {
						$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `custom`, `order`, `enabled`) VALUES
						("sitebusinessmusic_admin_widget_settings", "sitebusinessmusic", "Widget Settings", "", \'{"route":"admin_default","module":"sitebusinessmusic","controller":"widgets"}\', "sitebusinessmusic_admin_main", "", 0, 3, 1)');
		}

      //START THE WORK FOR MAKE WIDGETIZE BUSINESS OF MUSIC LISTING AND MUSIC VIEW BUSINESS
    $select = new Zend_Db_Select($db);
		$select
						->from('engine4_core_modules')
						->where('name = ?', 'sitebusinessmusic')
						->where('version < ?', '4.2.0');
		$is_enabled = $select->query()->fetchObject();
    if(!empty($is_enabled)) {
			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_core_pages')
							->where('name = ?', 'sitebusinessmusic_playlist_musiclist')
							->limit(1);
			$info = $select->query()->fetch();

			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_core_pages')
							->where('name = ?', 'sitebusinessmusic_playlist_browse')
							->limit(1);
			$info_browse = $select->query()->fetch();

			if ( empty($info) && empty($info_browse) ) {
				$db->insert('engine4_core_pages', array(
						'name' => 'sitebusinessmusic_playlist_browse',
						'displayname' => 'Browse Business Music',
						'title' => 'Business Music',
						'description' => 'This is the business music.',
						'custom' => 1,
				));
				$business_id = $db->lastInsertId('engine4_core_pages');

				//CONTAINERS
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'main',
						'parent_content_id' => Null,
						'order' => 2,
						'params' => '',
				));
				$container_id = $db->lastInsertId('engine4_core_content');

				//INSERT MAIN - MIDDLE CONTAINER
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $container_id,
						'order' => 6,
						'params' => '',
				));
				$middle_id = $db->lastInsertId('engine4_core_content');


				//INSERT MAIN - RIGHT CONTAINER
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'right',
						'parent_content_id' => $container_id,
						'order' => 5,
						'params' => '',
				));
				$right_id = $db->lastInsertId('engine4_core_content');


				//INSERT TOP CONTAINER
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'top',
						'parent_content_id' => Null,
						'order' => 1,
						'params' => '',
				));
				$top_id = $db->lastInsertId('engine4_core_content');


				//INSERT TOP- MIDDLE CONTAINER
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $top_id,
						'order' => 6,
						'params' => '',
				));
				$top_middle_id = $db->lastInsertId('engine4_core_content');


				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusiness.browsenevigation-sitebusiness',
						'parent_content_id' => $top_middle_id,
						'order' => 1,
						'params' => '{"title":"","titleCount":""}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessmusic.search-sitebusinessmusic',
						'parent_content_id' => $right_id,
						'order' => 3,
						'params' => '{"title":"","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessmusic.sitebusiness-music',
						'parent_content_id' => $middle_id,
						'order' => 2,
						'params' => '{"title":"","titleCount":""}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessmusic.homecomment-sitebusinessmusic',
						'parent_content_id' => $right_id,
						'order' => 4,
						'params' => '{"title":"Most Commented Playlists","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessmusic.sitebusiness-sponsoredmusic',
						'parent_content_id' => $right_id,
						'order' => 5,
						'params' => '{"title":"Sponsored Playlists","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessmusic.homelike-sitebusinessmusic',
						'parent_content_id' => $right_id,
						'order' => 6,
						'params' => '{"title":"Most Liked Playlists","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessmusic.homerecent-sitebusinessmusic',
						'parent_content_id' => $right_id,
						'order' => 7,
						'params' => '{"title":"Recent Business Playlists","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessmusic.homepopular-sitebusinessmusic',
						'parent_content_id' => $right_id,
						'order' => 8,
						'params' => '{"title":"Popular Business Playlists","titleCount":"true"}',
				));

				$select = new Zend_Db_Select($db);
				$select
								->from('engine4_core_modules')
								->where('name = ?', 'communityad')
								->where('enabled 	 = ?', 1)
								->limit(1);
				;
				$infomation = $select->query()->fetch();
				$select = new Zend_Db_Select($db);
				$select
								->from('engine4_core_settings')
								->where('name = ?', 'sitebusiness.communityads')
								->where('value 	 = ?', 1)
								->limit(1);
				$rowinfo = $select->query()->fetch();
				if ( $infomation && $rowinfo ) {
					$db->insert('engine4_core_content', array(
							'page_id' => $business_id,
							'type' => 'widget',
							'name' => 'sitebusiness.business-ads',
							'parent_content_id' => $right_id,
							'order' => 9,
							'params' => '{"title":"","titleCount":""}',
					));
				}
			}
      else {
        $db->update('engine4_core_pages', array('name' => 'sitebusinessmusic_playlist_browse'), array('name = ?' => 'sitebusinessmusic_playlist_musiclist'));
      }

			$db = $this->getDb();
			$select = new Zend_Db_Select($db);

			// Check if it's already been placed
			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_core_pages')
							->where('name = ?', 'sitebusinessmusic_playlist_view')
							->limit(1);
			;
			$info = $select->query()->fetch();

			if ( empty($info) ) {
				$db->insert('engine4_core_pages', array(
						'name' => 'sitebusinessmusic_playlist_view',
						'displayname' => 'Business Music View Page',
						'title' => 'View Business Music',
						'description' => 'This is the view business for a business music.',
						'custom' => 1,
						'provides' => 'subject=sitebusinessmusic',
				));
				$business_id = $db->lastInsertId('engine4_core_pages');

				// containers
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'main',
						'parent_content_id' => null,
						'order' => 1,
						'params' => '',
				));
				$container_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'right',
						'parent_content_id' => $container_id,
						'order' => 1,
						'params' => '',
				));
				$right_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $container_id,
						'order' => 3,
						'params' => '',
				));
				$middle_id = $db->lastInsertId('engine4_core_content');

				// middle column content
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessmusic.music-content',
						'parent_content_id' => $middle_id,
						'order' => 1,
						'params' => '',
				));
				
					$select = new Zend_Db_Select($db);
				$select
								->from('engine4_core_modules')
								->where('name = ?', 'communityad')
								->where('enabled 	 = ?', 1)
								->limit(1);
				;
				$infomation = $select->query()->fetch();
				$select = new Zend_Db_Select($db);
				$select
								->from('engine4_core_settings')
								->where('name = ?', 'sitebusiness.communityads')
								->where('value 	 = ?', 1)
								->limit(1);
				$rowinfo = $select->query()->fetch();
				if ( $infomation && $rowinfo ) {
					$db->insert('engine4_core_content', array(
							'page_id' => $business_id,
							'type' => 'widget',
							'name' => 'sitebusiness.business-ads',
							'parent_content_id' => $right_id,
							'order' => 10,
							'params' => '{"title":"","titleCount":""}',
					));
				}

			}
				
			$select = new Zend_Db_Select($db);
			$select
			->from('engine4_core_modules')
			->where('name = ?', 'mobi')
			->where('enabled 	 = ?', 1)
			->limit(1);
			;  

			$infomation = $select->query()->fetch();
			if(!empty($infomation)) {
				$select = new Zend_Db_Select($db);
				$select
				->from('engine4_core_pages')
				->where('name = ?', 'sitebusinessmusic_mobi_view')
				->limit(1);
				;
				$info = $select->query()->fetch();
				if (empty($info)) {
					$db->insert('engine4_core_pages', array(
								'name' => 'sitebusinessmusic_mobi_view',
								'displayname' => 'Mobile Business Music Profile',
								'title' => 'Mobile Business Music Profile',
								'description' => 'This is the mobile verison of a Business music profile business.',
								'custom' => 0,
					));
					$business_id = $db->lastInsertId('engine4_core_pages');

					// containers
					$db->insert('engine4_core_content', array(
								'page_id' => $business_id,
								'type' => 'container',
								'name' => 'main',
								'parent_content_id' => null,
								'order' => 1,
								'params' => '',
					));
					$container_id = $db->lastInsertId('engine4_core_content');

					$db->insert('engine4_core_content', array(
								'page_id' => $business_id,
								'type' => 'container',
								'name' => 'right',
								'parent_content_id' => $container_id,
								'order' => 1,
								'params' => '',
					));
					$right_id = $db->lastInsertId('engine4_core_content');

					$db->insert('engine4_core_content', array(
								'page_id' => $business_id,
								'type' => 'container',
								'name' => 'middle',
								'parent_content_id' => $container_id,
								'order' => 3,
								'params' => '',
					));
					$middle_id = $db->lastInsertId('engine4_core_content');

					// middle column content
					$db->insert('engine4_core_content', array(
							'page_id' => $business_id,
							'type' => 'widget',
							'name' => 'sitebusinessmusic.music-content',
							'parent_content_id' => $middle_id,
							'order' => 1,
							'params' => '',
					));
				}
			}
    }
    
    $select = new Zend_Db_Select($db);
		$select
					->from('engine4_core_modules')
					->where('name = ?', 'sitebusinessmusic')
					->where('version < ?', '4.2.1');
		$is_enabled_music = $select->query()->fetchObject();
		if($is_enabled_music) {
      $db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitebusinessmusic_admin_submain_general_tab", "sitebusinessmusic", "General Settings", "", \'{"route":"admin_default","module":"sitebusinessmusic","controller":"widgets", "action": "index"}\', "sitebusinessmusic_admin_submain", "", 1, 0, 1)');

			$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitebusinessmusic_admin_submain_music_tab", "sitebusinessmusic", "Tabbed Musics Widget", "", \'{"route":"admin_default","module":"sitebusinessmusic","controller":"settings", "action": "widget"}\', "sitebusinessmusic_admin_submain", "", 1, 0, 2)');

			$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitebusinessmusic_admin_submain_dayitems", "sitebusinessmusic", "Music of the Day", "", \'{"route":"admin_default","module":"sitebusinessmusic","controller":"settings", "action": "manage-day-items"}\', "sitebusinessmusic_admin_submain", "", 1, 0, 4)');
			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_core_pages')
							->where('name = ?', 'sitebusinessmusic_playlist_home')
							->limit(1);
			$info = $select->query()->fetch();
			if (empty($info)) {
				$db->insert('engine4_core_pages', array(
						'name' => 'sitebusinessmusic_playlist_home',
						'displayname' => 'Business Music Home',
						'title' => 'Business Music Home',
						'description' => 'This is business music home business.',
						'custom' => 1
				));
				$business_id = $db->lastInsertId('engine4_core_pages');

				// containers
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'main',
						'parent_content_id' => null,
						'order' => 2,
						'params' => '',
				));
				$container_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'right',
						'parent_content_id' => $container_id,
						'order' => 5,
						'params' => '',
				));
				$right_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'left',
						'parent_content_id' => $container_id,
						'order' => 4,
						'params' => '',
				));
				$left_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'top',
						'parent_content_id' => null,
						'order' => 1,
						'params' => '',
				));
				$top_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $top_id,
						'order' => 6,
						'params' => '',
				));
				$top_middle_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $container_id,
						'order' => 6,
						'params' => '',
				));
				$middle_id = $db->lastInsertId('engine4_core_content');

			// Top Middle
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusiness.browsenevigation-sitebusiness',
						'parent_content_id' => $top_middle_id,
						'order' => 3,
						'params' => '',
				));

				// Left
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessmusic.homerecent-sitebusinessmusic',
						'parent_content_id' => $left_id,
						'order' => 14,
						'params' => '{"title":"Recent Business Playlists","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessmusic.homepopular-sitebusinessmusic',
						'parent_content_id' => $left_id,
						'order' => 15,
						'params' => '{"title":"Popular Business Playlists","titleCount":"true"}',
				));

			// Middele
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessmusic.featured-musics-carousel',
						'parent_content_id' => $middle_id,
						'order' => 17,
						'params' => '{"title":"Featured Playlists","vertical":"0", "noOfRow":"2","inOneRow":"3","interval":"250","name":"sitebusinessmusic.featured-musics-carousel"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessmusic.list-musics-tabs-view',
						'parent_content_id' => $middle_id,
						'order' => 18,
						'params' => '{"title":"Playlists","margin_photo":"12"}',
				));
				// Right Side
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessmusic.sitebusinessmusiclist-link',
						'parent_content_id' => $right_id,
						'order' => 20,
						'params' => '',
				));

				// Right Side
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessmusic.search-sitebusinessmusic',
						'parent_content_id' => $right_id,
						'order' => 19,
						'params' => '',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessmusic.music-of-the-day',
						'parent_content_id' => $left_id,
						'order' => 13,
						'params' => '{"title":"Playlist of the Day"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessmusic.homefeaturelist-sitebusinessmusics',
						'parent_content_id' => $right_id,
						'order' => 21,
						'params' => '{"title":"Featured Playlists","itemCountPerBusiness":3}',
				));


				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessmusic.homecomment-sitebusinessmusic',
						'parent_content_id' => $right_id,
						'order' => 22,
						'params' => '{"title":"Most Commented Playlists","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessmusic.homelike-sitebusinessmusic',
						'parent_content_id' => $right_id,
						'order' => 23,
						'params' => '{"title":"Most Liked Playlists","titleCount":"true"}',
				));
			}
      $featuredColumn = $db->query("SHOW COLUMNS FROM engine4_sitebusinessmusic_playlists LIKE 'featured'")->fetch();
			if (empty($featuredColumn)) {
				$db->query("ALTER TABLE `engine4_sitebusinessmusic_playlists` ADD `featured` TINYINT( 1 ) NOT NULL DEFAULT '0' AFTER `special`");
			}
      $db->update('engine4_core_pages', array('displayname' => 'Browse Business Music'), array('displayname = ?' => 'Business Music')); 
    }    


		//ADD THE COLUMN FROM THE "engine4_sitebusinessmusic_playlists" TABLE
		$playlistFileIdColumn = $db->query("SHOW COLUMNS FROM engine4_sitebusinessmusic_playlist_songs LIKE 'playlist_file_id'")->fetch();
		if(empty($playlistFileIdColumn)) {
			$db->query("ALTER TABLE `engine4_sitebusinessmusic_playlist_songs` ADD `playlist_file_id` INT( 11 ) NOT NULL;");
		} 

    //END THE WORK FOR MAKE WIDGETIZE BUSINESS OF MUSIC LISTING AND MUSIC VIEW BUSINESS
    $select = new Zend_Db_Select($db);
    $select
          ->from('engine4_core_settings')
          ->where('name = ?', 'sitebusiness.feed.type');
  $info = $select->query()->fetch();
    $enable = 1;
    if (!empty($info))
      $enable = $info['value'];
    $db->query('INSERT IGNORE INTO `engine4_activity_actiontypes` (`type`, `module`, `body`, `enabled`, `displayable`, `attachable`, `commentable`, `shareable`, `is_generated`, `is_object_thumb`) VALUE("sitebusinessmusic_admin_new", "sitebusinessmusic", "{item:$object} created a new playlist {var:$linked_music_title}:", ' . $enable . ', 6, 2, 1, 1, 1, 1)');

		$select = new Zend_Db_Select($db);
		$select
					->from('engine4_core_modules')
					->where('name = ?', 'sitemobile')
					->where('enabled = ?', 1);
		$is_sitemobile_object = $select->query()->fetchObject();
		if($is_sitemobile_object)  {
			include APPLICATION_PATH . "/application/modules/Sitebusinessmusic/controllers/license/mobileLayoutCreation.php";
		}

    $playlistTable = $db->query('SHOW TABLES LIKE \'engine4_sitebusinessmusic_playlists\'')->fetch();
    if(!empty($playlistTable)) {
        $featuredIndex = $db->query("SHOW INDEX FROM `engine4_sitebusinessmusic_playlists` WHERE Key_name = 'featured'")->fetch();
        if(empty($featuredIndex)) {
          $db->query("ALTER TABLE `engine4_sitebusinessmusic_playlists` ADD INDEX ( `featured` )");
        }      
    }
    $this->setActivityFeeds();
    parent::onInstall();
  }
  
   public function onPostInstall() {
 
    $db = $this->getDb();
		$select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'sitemobile')
            ->where('enabled = ?', 1);
    $is_sitemobile_object = $select->query()->fetchObject();
    if(!empty($is_sitemobile_object)) {
			$db->query("INSERT IGNORE INTO `engine4_sitemobile_modules` (`name`, `visibility`) VALUES ('sitebusinessmusic','1')");
			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_sitemobile_modules')
							->where('name = ?', 'sitebusinessmusic')
							->where('integrated = ?', 0);
			$is_sitemobile_object = $select->query()->fetchObject();
      if($is_sitemobile_object)  {
				$actionName = Zend_Controller_Front::getInstance()->getRequest()->getActionName();
				$controllerName = Zend_Controller_Front::getInstance()->getRequest()->getControllerName();
				if($controllerName == 'manage' && $actionName == 'install') {
          $view = new Zend_View();
					$baseUrl = ( !empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://':'http://') .  $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
					$redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
					$redirector->gotoUrl($baseUrl . 'admin/sitemobile/module/enable-mobile/enable_mobile/1/name/sitebusinessmusic/integrated/0/redirect/install');
				} 
      }
    } 
    
    //Work for the word changes in the business plugin .csv file.
    $actionName = Zend_Controller_Front::getInstance()->getRequest()->getActionName();
    $controllerName = Zend_Controller_Front::getInstance()->getRequest()->getControllerName();
    if($controllerName == 'manage' && ($actionName == 'install' || $actionName == 'query')) {
      $view = new Zend_View();
      $baseUrl = ( !empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://':'http://') .  $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
      $redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
      if ($actionName == 'install') {
        $redirector->gotoUrl($baseUrl . 'admin/sitebusiness/settings/language/redirect/install');
      } else {
        $redirector->gotoUrl($baseUrl . 'admin/sitebusiness/settings/language/redirect/query');
      }
    }
    
  } 

  public function setActivityFeeds() {
    $db = $this->getDb();
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'nestedcomment')
            ->where('enabled = ?', 1);
    $is_nestedcomment_object = $select->query()->fetchObject();
    if ($is_nestedcomment_object) {
        $db->query('INSERT IGNORE INTO `engine4_activity_actiontypes` (`type`, `module`, `body`, `enabled`, `displayable`, `attachable`, `commentable`, `shareable`, `is_generated`) VALUES ("nestedcomment_sitebusinessmusic_playlist", "sitebusinessmusic", \'{item:$subject} replied to a comment on {item:$owner}\'\'s business music playlist {item:$object:$title}: {body:$body}\', 1, 1, 1, 1, 1, 1)');
    }
  }  
}
?>
