<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessmusic
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: manifest.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$routeStart = "businessmusic";
$module = null;
$controller = null;
$action = null;
$getURL = null;
$request = Zend_Controller_Front::getInstance()->getRequest();
if (!empty($request)) {
  $module = $request->getModuleName(); // Return the current module name.
  $action = $request->getActionName();
  $controller = $request->getControllerName();
  $getURL = $request->getRequestUri();
}
if (empty($request) || !($module == "default" && ( strpos( $getURL, '/install') !== false))) {
  $routeStart = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessmusic.manifestUrl', "business-music");
}
return array(
    'package' =>
    array(
        'type' => 'module',
        'name' => 'sitebusinessmusic',
        'version' => '5.4.1',
        'path' => 'application/modules/Sitebusinessmusic',
        'title' => 'Directory / Businesses - Music Extension',
        'description' => 'Directory / Businesses - Music Extension',
      'author' => '<a href="http://www.socialapps.tech" style="text-decoration:underline;" target="_blank">SocialApps.tech</a>',
        'callback' => array(
            'path' => 'application/modules/Sitebusinessmusic/settings/install.php',
            'class' => 'Sitebusinessmusic_Installer',
        ),
        'actions' =>
        array(
            0 => 'install',
            1 => 'upgrade',
            2 => 'refresh',
            3 => 'enable',
            4 => 'disable',
        ),
        'directories' =>
        array(
            0 => 'application/modules/Sitebusinessmusic',
        ),
        'files' =>
        array(
            0 => 'application/languages/en/sitebusinessmusic.csv',
        ),
    ),
    'hooks' => array(
        array(
            'event' => 'onUserDeleteBefore',
            'resource' => 'Sitebusinessmusic_Plugin_Core',
        ),
        array(
            'event' => 'onItemDeleteAfter',
            'resource' => 'Sitebusinessmusic_Plugin_Core',
        ),
    ),
    // Compose -------------------------------------------------------------------
    'compose' => array(
        array('_composeMusic.tpl', 'sitebusinessmusic'),
    ),
    'composer' => array(
        'sitebusinessmusic' => array(
            'script' => array('_composeMusic.tpl', 'sitebusinessmusic'),
            'plugin' => 'Sitebusinessmusic_Plugin_Composer',
            'auth' => array('sitebusiness_business', 'smcreate'),
        ),
    ),
    'sitemobile_compatible' => true,
    // ITEMS ---------------------------------------------------------------------
    'items' => array(
        'sitebusinessmusic_playlist',
        'sitebusinessmusic_playlist_song',
    ),
    // ROUTES --------------------------------------------------------------------
    'routes' => array(
        'sitebusinessmusic_create' => array(
            'route' => $routeStart . '/create/:business_id/*',
            'defaults' => array(
                'module' => 'sitebusinessmusic',
                'controller' => 'index',
                'action' => 'create'
            ),
            'reqs' => array(
                'business_id' => '\d+'
            )
        ),
        'sitebusinessmusic_song_specific' => array(
            'route' => $routeStart . '/song/:song_id/:action/*',
            'defaults' => array(
                'module' => 'sitebusinessmusic',
                'controller' => 'song',
                'action' => 'view',
            ),
            'reqs' => array(
                'song_id' => '\d+',
                'action' => '(view|delete|rename|upload|append)',
            ),
        ),
        'sitebusinessmusic_playlist_view' => array(
            'route' => $routeStart . '/:playlist_id/:slug/*',
            'defaults' => array(
                'module' => 'sitebusinessmusic',
                'controller' => 'playlist',
                'action' => 'view',
                'slug' => '',
            ),
            'reqs' => array(
                'playlist_id' => '\d+'
            )
        ),
        'sitebusinessmusic_playlist_specific' => array(
            'route' => $routeStart . '/:playlist_id/:action/:slug/*',
            'defaults' => array(
                'module' => 'sitebusinessmusic',
                'controller' => 'playlist',
                'action' => 'view',
            ),
            'reqs' => array(
                'playlist_id' => '\d+',
                'action' => '(view|edit|delete|sort|add-song|set-profile)',
            ),
        ),
        'sitebusinessmusic_extended' => array(
            'route' => $routeStart . '/:controller/:action/*',
            'defaults' => array(
                'module' => 'sitebusinessmusic',
                'controller' => 'index',
                'action' => 'index',
            ),
            'reqs' => array(
                'controller' => '\D+',
                'action' => '\D+',
            ),
        ),
        'sitebusinessmusic_general' => array(
            'route' => $routeStart . '/:action/*',
            'defaults' => array(
                'module' => 'sitebusinessmusic',
                'controller' => 'index',
            ),
            'reqs' => array(
                'action' => '(remove-song)',
            ),
        ),
        'sitebusinessmusic_tally' => array(
            'route' => 'businessmusictally/song/:song_id/:action/*',
            'defaults' => array(
                'module' => 'sitebusinessmusic',
                'controller' => 'song',
                'action' => 'tally',
            ),
            'reqs' => array(
                'song_id' => '\d+',
            ),
        ),
        'sitebusinessmusic_browse' => array(
            'route' => $routeStart.'/browse/*',
            'defaults' => array(
                'module' => 'sitebusinessmusic',
                'controller' => 'playlist',
                'action' => 'browse',
            ),
        ),
        'sitebusinessmusic_home' => array(
            'route' => $routeStart.'/home/*',
            'defaults' => array(
                'module' => 'sitebusinessmusic',
                'controller' => 'playlist',
                'action' => 'home',
            ),
        ), 
         'sitebusinessmusic_featured' => array(
            'route' => $routeStart . '/featured/:playlist_id/*',
            'defaults' => array(
                'module' => 'sitebusinessmusic',
                'controller' => 'playlist',
                'action' => 'featured'
            ),
            'reqs' => array(
                'playlist_id' => '\d+'
            )
        ),
         'sitebusinessmusic_featuredmusic' => array(
            'route' => $routeStart .'/admin/featuredmusic/:id/*',
            'defaults' => array(
                'module' => 'sitebusinessmusic',
                'controller' => 'admin-manage',
                'action' => 'featuredmusic',
            ),
            'reqs' => array(
                'id' => '\d+'
            )
        ),
    ),
);
?>