<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    sitebusinessnote
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: WidgetSettings.php 6590 2010-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
 
//START LANGUAGE WORK
Engine_Api::_()->getApi('language', 'sitebusiness')->languageChanges();
//END LANGUAGE WORK

//GET DB
$db = Zend_Db_Table_Abstract::getDefaultAdapter();

$db->query('
  INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `order`) VALUES
  ("sitebusinessnote_admin_main_categories", "sitebusinessnote", "Categories", "", \'{"route":"admin_default","module":"sitebusinessnote","controller":"settings","action":"categories"}\', "sitebusinessnote_admin_main", "", 3);
');

//CHECK THAT SITEBUSINESS PLUGIN IS ACTIVATED OR NOT
$select = new Zend_Db_Select($db);
$select
        ->from('engine4_core_settings')
        ->where('name = ?', 'sitebusiness.is.active')
        ->limit(1);
$sitebusiness_settings = $select->query()->fetchAll();
if (!empty($sitebusiness_settings)) {
  $sitebusiness_is_active = $sitebusiness_settings[0]['value'];
} else {
  $sitebusiness_is_active = 0;
}

//CHECK THAT SITEBUSINESS PLUGIN IS INSTALLED OR NOT
$select = new Zend_Db_Select($db);
$select
        ->from('engine4_core_modules')
        ->where('name = ?', 'sitebusiness')
        ->where('enabled = ?', 1);
$check_sitebusiness = $select->query()->fetchObject();
if (!empty($check_sitebusiness) && !empty($sitebusiness_is_active)) {
  $select = new Zend_Db_Select($db);
  $select_business = $select
          ->from('engine4_core_pages', 'page_id')
          ->where('name = ?', 'sitebusiness_index_view')
          ->limit(1);
  $business = $select_business->query()->fetchAll();
  if (!empty($business)) {
    $business_id = $business[0]['page_id'];

    //INSERTING THE NOTE WIDGET IN SITEBUSINESS_ADMIN_CONTENT TABLE ALSO
    Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminDefaultInfo('sitebusinessnote.profile-sitebusinessnotes', $business_id, 'Notes', 'true', '112');

    //INSERTING THE NOTE WIDGET IN CORE_CONTENT TABLE ALSO
    Engine_Api::_()->getApi('layoutcore', 'sitebusiness')->setContentDefaultInfo('sitebusinessnote.profile-sitebusinessnotes', $business_id, 'Notes', 'true', '112');

    //INSERTING THE NOTE WIDGET IN SITEBUSINESS_CONTENT TABLE ALSO
    $select = new Zend_Db_Select($db);
    $contentbusiness_ids = $select->from('engine4_sitebusiness_contentbusinesses', 'contentbusiness_id')->query()->fetchAll();
    foreach ($contentbusiness_ids as $contentbusiness_id) {
      if (!empty($contentbusiness_id)) {
        Engine_Api::_()->getDbtable('content', 'sitebusiness')->setDefaultInfo('sitebusinessnote.profile-sitebusinessnotes', $contentbusiness_id['contentbusiness_id'], 'Notes', 'true', '112');
      }
    }
  }
  
  $select = new Zend_Db_Select($db);
	$select
					->from('engine4_core_modules')
					->where('name = ?', 'communityad')
					->where('enabled 	 = ?', 1)
					->limit(1);
	;
	$infomation = $select->query()->fetch();
	$select = new Zend_Db_Select($db);
	$select
					->from('engine4_core_settings')
					->where('name = ?', 'sitebusiness.communityads')
					->where('value 	 = ?', 1)
					->limit(1);
	;
	$rowinfo = $select->query()->fetch();
  $contentTable = Engine_Api::_()->getDbtable('content', 'core');
  $contentTableName = $contentTable->info('name');

  $select = new Zend_Db_Select($db);
  $select
          ->from('engine4_core_pages')
          ->where('name = ?', 'sitebusinessnote_index_browse')
          ->limit(1);
  ;
  $info = $select->query()->fetch();
  if ( empty($info) ) {
    $db->insert('engine4_core_pages', array(
        'name' => 'sitebusinessnote_index_browse',
        'displayname' => 'Browse Business Notes',
        'title' => 'Business Notes List',
        'description' => 'This is the business notes.',
        'custom' => 1,
    ));
    $business_id = $db->lastInsertId('engine4_core_pages');
//INSERT MAIN CONTAINER
    $mainContainer = $contentTable->createRow();
    $mainContainer->page_id = $business_id;
    $mainContainer->type = 'container';
    $mainContainer->name = 'main';
    $mainContainer->order = 2;
    $mainContainer->save();
    $container_id = $mainContainer->content_id;

//INSERT MAIN - MIDDLE CONTAINER
    $mainMiddleContainer = $contentTable->createRow();
    $mainMiddleContainer->page_id = $business_id;
    $mainMiddleContainer->type = 'container';
    $mainMiddleContainer->name = 'middle';
    $mainMiddleContainer->parent_content_id = $container_id;
    $mainMiddleContainer->order = 6;
    $mainMiddleContainer->save();
    $middle_id = $mainMiddleContainer->content_id;

//INSERT MAIN - RIGHT CONTAINER
    $mainRightContainer = $contentTable->createRow();
    $mainRightContainer->page_id = $business_id;
    $mainRightContainer->type = 'container';
    $mainRightContainer->name = 'right';
    $mainRightContainer->parent_content_id = $container_id;
    $mainRightContainer->order = 5;
    $mainRightContainer->save();
    $right_id = $mainRightContainer->content_id;

//INSERT TOP CONTAINER
    $topContainer = $contentTable->createRow();
    $topContainer->page_id = $business_id;
    $topContainer->type = 'container';
    $topContainer->name = 'top';
    $topContainer->order = 1;
    $topContainer->save();
    $top_id = $topContainer->content_id;

//INSERT TOP- MIDDLE CONTAINER
    $topMiddleContainer = $contentTable->createRow();
    $topMiddleContainer->page_id = $business_id;
    $topMiddleContainer->type = 'container';
    $topMiddleContainer->name = 'middle';
    $topMiddleContainer->parent_content_id = $top_id;
    $topMiddleContainer->order = 6;
    $topMiddleContainer->save();
    $top_middle_id = $topMiddleContainer->content_id;

    //INSERT NAVIGATION WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.browsenevigation-sitebusiness', $top_middle_id, 1);

//INSERT NOTE WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessnote.sitebusiness-note', $middle_id, 2);

    //INSERT SEARCH BUSINESS NOTE WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessnote.search-sitebusinessnote', $right_id, 3, "", "true");

    //INSERT MOST COMMENTED BUSINESS NOTE WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessnote.homecomment-sitebusinessnotes', $right_id, 4, "Most Commented Notes", "true");

    //INSERT SPONSORED BUSINESS NOTE WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessnote.sitebusiness-sponsorednote', $right_id, 5, "Sponsored Notes", "true");

    //INSERT MOST LIKED BUSINESS NOTE WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessnote.homelike-sitebusinessnotes', $right_id, 6, "Most Liked Notes", "true");

    //INSERT RECENT BUSINESS NOTE WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessnote.homerecent-sitebusinessnotes', $right_id, 7, "Recent Notes", "true");

    if ( $infomation && $rowinfo ) {
      Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.business-ads', $right_id, 10, "", "true");
    }
  }
$select = new Zend_Db_Select($db);

  // Check if it's already been placed
  $select = new Zend_Db_Select($db);
  $select
          ->from('engine4_core_pages')
          ->where('name = ?', 'sitebusinessnote_index_view')
          ->limit(1);
  ;
  $info = $select->query()->fetch();

  if ( empty($info) ) {
    $db->insert('engine4_core_pages', array(
        'name' => 'sitebusinessnote_index_view',
        'displayname' => 'Business Note View Page',
        'title' => 'View Business Note',
        'description' => 'This is the view business for a business note.',
        'custom' => 1,
        'provides' => 'subject=sitebusinessnote',
    ));
    $business_id = $db->lastInsertId('engine4_core_pages');

    // containers
    $db->insert('engine4_core_content', array(
        'page_id' => $business_id,
        'type' => 'container',
        'name' => 'main',
        'parent_content_id' => null,
        'order' => 1,
        'params' => '',
    ));
    $container_id = $db->lastInsertId('engine4_core_content');

    $db->insert('engine4_core_content', array(
        'page_id' => $business_id,
        'type' => 'container',
        'name' => 'right',
        'parent_content_id' => $container_id,
        'order' => 1,
        'params' => '',
    ));
    $right_id = $db->lastInsertId('engine4_core_content');

    $db->insert('engine4_core_content', array(
        'page_id' => $business_id,
        'type' => 'container',
        'name' => 'middle',
        'parent_content_id' => $container_id,
        'order' => 3,
        'params' => '',
    ));
    $middle_id = $db->lastInsertId('engine4_core_content');

    // middle column content
    $db->insert('engine4_core_content', array(
        'page_id' => $business_id,
        'type' => 'widget',
        'name' => 'sitebusinessnote.note-content',
        'parent_content_id' => $middle_id,
        'order' => 1,
        'params' => '',
    ));

    // right column
    $db->insert('engine4_core_content', array(
        'page_id' => $business_id,
        'type' => 'widget',
        'name' => 'sitebusinessnote.show-same-tags',
        'parent_content_id' => $right_id,
        'order' => 1,
        'params' => '{"title":"Related Notes"}',
    ));

		if ( $infomation && $rowinfo ) {
			Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.business-ads', $right_id, 10, "", "true");
    }
  }
 
  $select = new Zend_Db_Select($db);
	$select
	->from('engine4_core_modules')
	->where('name = ?', 'mobi')
	->where('enabled 	 = ?', 1)
	->limit(1);
	;  

	$infomation = $select->query()->fetch();
	if(!empty($infomation)) {
		$select = new Zend_Db_Select($db);
		$select
		->from('engine4_core_pages')
		->where('name = ?', 'sitebusinessnote_mobi_view')
		->limit(1);
		;
		$info = $select->query()->fetch();
		if (empty($info)) {
			$db->insert('engine4_core_pages', array(
						'name' => 'sitebusinessnote_mobi_view',
						'displayname' => 'Mobile Business Note Profile',
						'title' => 'Mobile Business Note Profile',
						'description' => 'This is the mobile verison of a Business note profile business.',
						'custom' => 0,
			));
			$business_id = $db->lastInsertId('engine4_core_pages');

			// containers
			$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'main',
						'parent_content_id' => null,
						'order' => 1,
						'params' => '',
			));
			$container_id = $db->lastInsertId('engine4_core_content');

			$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'right',
						'parent_content_id' => $container_id,
						'order' => 1,
						'params' => '',
			));
			$right_id = $db->lastInsertId('engine4_core_content');

			$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $container_id,
						'order' => 3,
						'params' => '',
			));
			$middle_id = $db->lastInsertId('engine4_core_content');

			// middle column content
			$db->insert('engine4_core_content', array(
					'page_id' => $business_id,
					'type' => 'widget',
					'name' => 'sitebusinessnote.note-content',
					'parent_content_id' => $middle_id,
					'order' => 1,
					'params' => '',
			));

			// right column
			$db->insert('engine4_core_content', array(
					'page_id' => $business_id,
					'type' => 'widget',
					'name' => 'sitebusinessnote.show-same-tags',
					'parent_content_id' => $right_id,
					'order' => 1,
					'params' => '{"title":"Related Notes"}',
			));
		}
	}

  $db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`)
	VALUES ("sitebusinessnote_admin_widget_settings", "sitebusinessnote", "Widget Settings", "", \'{"route":"admin_default","module":"sitebusinessnote","controller":"widgets"}\', "sitebusinessnote_admin_main", "", 1, 0, 3)');

  $db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitebusinessnote_admin_submain_general_tab", "sitebusinessnote", "General Settings", "", \'{"route":"admin_default","module":"sitebusinessnote","controller":"widgets", "action": "index"}\', "sitebusinessnote_admin_submain", "", 1, 0, 1)');

	$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitebusinessnote_admin_submain_note_tab", "sitebusinessnote", "Tabbed Notes Widget", "", \'{"route":"admin_default","module":"sitebusinessnote","controller":"settings", "action": "widget"}\', "sitebusinessnote_admin_submain", "", 1, 0, 2)');

	$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitebusinessnote_admin_submain_dayitems", "sitebusinessnote", "Note of the Day", "", \'{"route":"admin_default","module":"sitebusinessnote","controller":"settings", "action": "manage-day-items"}\', "sitebusinessnote_admin_submain", "", 1, 0, 4)');


	$select = new Zend_Db_Select($db);
	$select
					->from('engine4_core_pages')
					->where('name = ?', 'sitebusinessnote_index_home')
					->limit(1);
	$info = $select->query()->fetch();
	if (empty($info)) {
		$db->insert('engine4_core_pages', array(
				'name' => 'sitebusinessnote_index_home',
				'displayname' => 'Business Notes Home',
				'title' => 'Business Notes Home',
				'description' => 'This is business note home business.',
				'custom' => 1
		));
		$business_id = $db->lastInsertId('engine4_core_pages');

		// containers
		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'container',
				'name' => 'main',
				'parent_content_id' => null,
				'order' => 2,
				'params' => '',
		));
		$container_id = $db->lastInsertId('engine4_core_content');

		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'container',
				'name' => 'right',
				'parent_content_id' => $container_id,
				'order' => 5,
				'params' => '',
		));
		$right_id = $db->lastInsertId('engine4_core_content');

		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'container',
				'name' => 'left',
				'parent_content_id' => $container_id,
				'order' => 4,
				'params' => '',
		));
		$left_id = $db->lastInsertId('engine4_core_content');

		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'container',
				'name' => 'top',
				'parent_content_id' => null,
				'order' => 1,
				'params' => '',
		));
		$top_id = $db->lastInsertId('engine4_core_content');

		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'container',
				'name' => 'middle',
				'parent_content_id' => $top_id,
				'order' => 6,
				'params' => '',
		));
		$top_middle_id = $db->lastInsertId('engine4_core_content');

		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'container',
				'name' => 'middle',
				'parent_content_id' => $container_id,
				'order' => 6,
				'params' => '',
		));
		$middle_id = $db->lastInsertId('engine4_core_content');

	// Top Middle
		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusiness.browsenevigation-sitebusiness',
				'parent_content_id' => $top_middle_id,
				'order' => 3,
				'params' => '',
		));

		// Left
		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessnote.homerecent-sitebusinessnotes',
				'parent_content_id' => $left_id,
				'order' => 14,
				'params' => '{"title":"Recent Business Notes","titleCount":"true"}',
		));

		// Middle
		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessnote.featured-notes-slideshow',
				'parent_content_id' => $middle_id,
				'order' => 15,
				'params' => '{"title":"Featured Notes","titleCount":"true"}',
		));

		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessnote.list-notes-tabs-view',
				'parent_content_id' => $middle_id,
				'order' => 17,
				'params' => '{"title":"Notes","margin_photo":"12"}',
		));
		// Right Side
		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessnote.sitebusinessnotelist-link',
				'parent_content_id' => $right_id,
				'order' => 19,
				'params' => '',
		));

		// Right Side
		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessnote.search-sitebusinessnote',
				'parent_content_id' => $right_id,
				'order' => 18,
				'params' => '',
		));

		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessnote.note-of-the-day',
				'parent_content_id' => $left_id,
				'order' => 13,
				'params' => '{"title":"Note of the Day"}',
		));

		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessnote.homefeaturelist-sitebusinessnotes',
				'parent_content_id' => $right_id,
				'order' => 21,
				'params' => '{"title":"Featured Notes","itemCountPerBusiness":3}',
		));


		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessnote.homecomment-sitebusinessnotes',
				'parent_content_id' => $right_id,
				'order' => 22,
				'params' => '{"title":"Most Commented Notes","titleCount":"true"}',
		));

		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessnote.homelike-sitebusinessnotes',
				'parent_content_id' => $right_id,
				'order' => 23,
				'params' => '{"title":"Most Liked Notes","titleCount":"true"}',
		));
	}
}
?>