<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessnote
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessnote_Widget_LikeSitebusinessnotesController extends Engine_Content_Widget_Abstract {

  //ACTION FOR SHOWING THE MOST LIKED NOTES ON BUSINESS PROFILE BUSINESS
  public function indexAction() {
  	
    //GET SITEBUSINESS SUBJECT
    $this->view->sitebusiness_subject = $sitebusiness_subject = Engine_Api::_()->core()->getSubject('sitebusiness_business');

    $sitebusinessnote_likeContent = Zend_Registry::isRegistered('sitebusinessnote_likeContent') ? Zend_Registry::get('sitebusinessnote_likeContent') : null;

    // PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness_subject->package_id, "modules", "sitebusinessnote")) {
        return $this->setNoRender();
      }
    } else {
      $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness_subject, 'sncreate');
      if (empty($isBusinessOwnerAllow)) {
        return $this->setNoRender();
      }
    }
    // PACKAGE BASE PRIYACY START
    
    // SET NO RENDER
    $getLevelAuth = Engine_Api::_()->sitebusinessnote()->getLevelAuth();
    if (empty($getLevelAuth)) {
      return $this->setNoRender();
    }

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness_subject, 'view');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }

    // SET NO RENDER
    if (empty($sitebusinessnote_likeContent)) {
      return $this->setNoRender();
    }
    //END MANAGE-ADMIN CHECK
    
    //SEARCH PARAMETER
    $params = array();
    $params['business_id'] = $sitebusiness_subject->business_id;
    $params['orderby'] = 'like_count DESC';
    $params['profile_business_widget'] = 1;
    $params['zero_count'] = 'like_count';
    $params['limit'] = $this->_getParam('itemCount', 3);

    //MAKE PAGINATOR
    $this->view->paginator = $paginator = Engine_Api::_()->getDbTable('notes', 'sitebusinessnote')->widgetNotesData($params);

    // SET NO RENDER
    if (Count($paginator) <= 0) {
      return $this->setNoRender();
    }
  }

}

?>