<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessoffer
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$isActive = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessoffer.isActivate', 0);
if ( empty($isActive) ) {
  return;
}

$categories = Engine_Api::_()->getDbTable('categories', 'sitebusiness')->getCategories();
if (count($categories) != 0) {
  $categories_prepared[0] = "";
  foreach ($categories as $category) {
    $categories_prepared[$category->category_id] = $category->category_name;
  }
}

$popularity_options = array(
		'view_count' => 'Most Viewed',
		'like_count' => 'Most Liked',
		'comment_count' => 'Most Commented',
		'popular' => 'Most Claimed',
);

$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
$final_array = array(
    array(
        'title' => 'Business Profile Offers',
        'description' => 'This widget forms the Offers tab on the Business Profile and displays the offers of the Business. It should be placed in the Tabbed Blocks area of the Business Profile.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusinessoffer.profile-sitebusinessoffers',
        'defaultParams' => array(
            'title' => 'Offers',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => 'Latest Business Offers',
        'description' => 'Displays the latest Business Offers that have been created. You can choose the number of entries to be shown.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessoffer.sitebusiness-latestoffer',
        'defaultParams' => array(
            'title' => 'Latest Business Offers',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of offers to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							  ),
            ),
        ),
    ),
    array(
        'title' => 'Hot Business Offers',
        'description' => 'Displays Business Offers that have been marked as Hot. You can choose the number of entries to be shown',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessoffer.sitebusiness-hotoffer',
        'defaultParams' => array(
            'title' => 'Hot Business Offers',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of offers to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							  ),
            ),
        ),
    ),
    array(
        'title' => 'Business Offers',
        'description' => 'Displays the list of Offers from Businesses created on your community. This widget should be placed in the widgetized Business Offers business. Results from the Search Business Offers form are also shown here.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessoffer.sitebusiness-offer',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of offers to show)',
                        'value' => 20,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),

    array(
        'title' => 'Available Offers',
        'description' => 'Displays the Business Offers based on their ending dates, in 3 tabs: ‘This Week’, ‘This Month’ and ‘Overall’. Users can see more offers right within that widget. You can choose the number of entries to be shown.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessoffer.sitebusiness-dateoffer',
        'defaultParams' => array(
            'title' => 'Available Offers',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of offers to show)',
                        'value' => 5,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							  ),
            ),
        ),
    ),

		array(
			'title' => 'Search Business Offers form',
			'description' => 'Displays the form for searching Business Offers on the basis of various filters. You can edit the fields to be available in this form.',
			'category' => 'Businesses',
			'type' => 'widget',
			'name' => 'sitebusinessoffer.search-sitebusinessoffer',
			'defaultParams' => array(
					'title' => '',
          'search_column' => array("0" => "1", "1" => "2", "2" => "3", "3" => "4"),
					'titleCount' => true,

			),
			'adminForm' => array(
              'elements' => array(
							array(
									'MultiCheckbox',
									'search_column',
									array(
											'label' => 'Choose the fields that you want to be available in the Search Business Offers form widget.',
											'multiOptions' => array("1" => "Browse By", "2" => "Business Title", "3" => "Offer Title","4" => "Business Category","5" => "Location"),
									),
							),
					),
			)
    ),

     array(
        'title' => 'Sponsored Offers',
        'description' => 'Displays the Offers from Paid Businesses. You can choose the number of entries to be shown.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessoffer.sitebusiness-sponsoredoffer',
        'defaultParams' => array(
            'title' => 'Sponsored Offers',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of offers to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
						    ),
            ),
        ),
    ),
		array(
				'title' => 'Business Offer View',
				'description' => "This widget should be placed on the Business Offer View Page.",
				'category' => 'Businesses',
				'type' => 'widget',
				'name' => 'sitebusinessoffer.offer-content',
				'defaultParams' => array(
						'title' => '',
						'titleCount' => true,
				),
        'adminForm' => array(
            'elements' => array(
                array(
									'MultiCheckbox',
									'showLinks',
									array(
											'label' => 'Show Action Links (Note: "Suggest to Friends" link having dependency on our "Suggestions" plugin.)',
											'multiOptions' => array(
                          'add' => "Add an Offer",
                          'edit' => "Edit Offer",
                          'delete' => "Delete Offer",
                          'featured' => "Make Featured",
                          'dayOffer' => "Make Offer of the Day",
                          'suggest' => "Suggest to Friends",
                          'print' => "Print Offer",
                          'share' => "Site Share",
                          'report' => "Report",
                      ),
									)
						    ),
                array(
                    'MultiCheckbox',
                    'showContent',
                    array(
                        'label' => 'Select the information options that you want to be available in this block.',
                        'multiOptions' => array("postedBy" => "Posted on", "viewCount" => "Views", "likeCount" => "Likes", "commentCount" => "Comments"),
                    ),
                ),           
                array(
                    'Radio',
                    'commentEnabled',
                    array(
                        'label' => $view->translate('Do you want to show user comments and enable user to post comment or not?'),
                        'multiOptions' => array(
                            1 => $view->translate('Yes'),
                            0 => $view->translate('No')
                        ),
                        'value' => 1,
                    ),
                ),                
            ),
        ),           
		),

		array(
				'title' => 'Popular / Viewed / Liked Business Offers',
				'description' => 'Displays Business Offers based on the Popularity Criteria and other settings that you choose for this widget. You can place this widget multiple times on a business with different popularity criterion chosen for each placement.',
				'category' => 'Businesses',
				'type' => 'widget',
				'autoEdit' => true,
				'name' => 'sitebusinessoffer.offers-sitebusinessoffers',
				'defaultParams' => array(
						'title' => 'Offers',
						'titleCount' => true,
				),
				'adminForm' => array(
						'elements' => array(
								array(
										'Text',
										'itemCount',
										array(
											'label' => 'Count',
											'description' => '(number of Offers to show)',
											'value' => 3,
										)
								),
								array(
										'Select',
										'popularity',
										array(
												'label' => 'Popularity Criteria',
												'multiOptions' => $popularity_options,
												'value' => 'view_count',
										)
								),
								array(
										'Select',
										'category_id',
										array(
												'label' => 'Category',
												'multiOptions' => $categories_prepared,
										)
								),
						),
				),
		),

    array(
        'title' => 'Business’s Offer of the Day',
        'description' => 'Displays the Offer of the Day as selected by the Admin from the widget settings section of Directory / Businesses - Offers Extension.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessoffer.offer-of-the-day',
        'defaultParams' => array(
            'title' => 'Offer of the Day'
        ),
    ),

    array(
        'title' => 'Browse Offers',
        'description' => 'Displays the link to view Business’s Offers Browse business.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessoffer.sitebusinessofferlist-link',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
    ),

    array(
        'title' => 'Business’s Hot Offers Slideshow',
        'description' => 'Displays hot offers in an attractive slideshow. You can set the count of the number of offers to show in this widget. If the total number of offers selected as hot are more than that count, then the offers to be displayed will be sequentially picked up.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessoffer.hot-offers-slideshow',
        'isPaginated' => true,
        'defaultParams' => array(
            'title' => 'Hot Offers',
            'itemCountPerBusiness' => 10,
        ),
			'adminForm' => array(
					'elements' => array(
							array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
			),
    ),
    
    array(
        'title' => 'Business’s selling / buying Offers Slideshow',
        'description' => 'Displays selling/buying offers in an attractive slideshow. You can set the count of the number of offers to show in this widget. If the total number of offers selected as hot are more than that count, then the offers to be displayed will be sequentially picked up.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessoffer.sell-buy-offers-slideshow',
        'isPaginated' => true,
        'defaultParams' => array(
            'title' => 'Offers',
            'itemCountPerBusiness' => 10,
        ),
			'adminForm' => array(
					'elements' => array(
							array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
							array(
								'Select',
								'offer_type',
								array(
										'label' => $view->translate('Show Offer Type'),
										'multiOptions' => array("sell" => "Selling", "buy" => "Buying"),
										'value' => 'sell',
								)
            ), 
					),
			),
    ),

    array(
        'title' => 'Business’s Hot Offers Carousel',
        'description' => 'This widget contains an attractive AJAX based carousel, showcasing the hot offers on the site. Multiple settings of this widget makes it highly configurable.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessoffer.hot-offers-carousel',
        'defaultParams' => array(
            'title' => 'Hot Offers',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
										'Select',
										'category_id',
										array(
												'label' => 'Category',
												'multiOptions' => $categories_prepared,
										)
								),
                array(
                    'Radio',
                    'vertical',
                    array(
                        'label' => 'Carousel Type',
                        'multiOptions' => array(
                            '0' => 'Horizontal',
                            '1' => 'Vertical',
                        ),
                        'value' => 0,
                    )
                ),
                array(
                    'Text',
                    'inOneRow',
                    array(
                        'label' => 'Offers in a Row',
                        'description' => '(number of offers to show in one row. Note: This field is applicable only when you have selected ‘Horizontal’ in ‘Carousel Type’ field.)',
                        'value' => 3,
                    )
                ),
                array(
                    'Text',
                    'noOfRow',
                    array(
                        'label' => 'Rows',
                        'description' => '(number of rows in one view)',
                        'value' => 2,
                    )
                ),
                array(
                    'Text',
                    'interval',
                    array(
                        'label' => 'Speed',
                        'description' => '(transition interval between two slides in millisecs)',
                        'value' => 250,
                    )
                ),
            ),
        ),
    ),

    array(
        'title' => 'Business’s Ajax based Tabbed widget for Offers',
        'description' => 'Displays the Upcoming, Most Liked, Most Viewed, Most Commented, Hot and Featured Offers in separate AJAX based tabs. Settings for this widget are available in the Tabbed Offers Widget section of Directory / Businesses - Offers Extension.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessoffer.list-offers-tabs-view',
        'defaultParams' => array(
            'title' => 'Offers',
            'margin_photo'=>12,
            'showViewMore'=>1
        ),
         'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'margin_photo',
                    array(
                        'label' => 'Horizontal Margin between Elements',
                        'description' => '(Horizontal margin in px between consecutive elements in this widget. You might want to change this value if the content of this widget is not coming properly on your site because of the column width in your theme.)',
                        'value' => 12,
                    )
                ),
                 array(
                  'Radio',
                  'showViewMore',
                  array(
                      'label' => 'Show "View More" link',
                      'multiOptions' => array(
                          '1' => 'Yes',
                          '0' => 'No',
                      ),
                      'value' => 1,
                  )
              ),
              array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							)
            ),
        ),
    ),

    array(
    'title' => 'Top Creators : Business Offers',
    'description' => 'Displays the Businesses which have the most number of Business Offers added in them. Motivates Business Admins to add more content on your website.',
    'category' => 'Businesses',
    'type' => 'widget',
    'name' => 'sitebusinessoffer.topcreators-sitebusinessoffer',
   // 'isPaginated' => true,
    'defaultParams' => array(
      'title' => 'Top Creators',
    ),
     'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of elements to show)',
										'value' => 5,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						), 
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
        ),
    'requirements' => array(
      'subject' => 'sitebusinessoffer',
    ),
  ),
	);
	
  if(Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessoffer.offer.show.type', 1)) {
		$joined_array1 = array(
				array(
						'title' => 'Business Profile Selling Offers',
						'description' => 'This widget forms the Selling Offers tab on the Business Profile and displays the selling offers of the Business. It should be placed in the Tabbed Blocks area of the Business Profile.',
						'category' => 'Business Profile',
						'type' => 'widget',
						'name' => 'sitebusinessoffer.profile-selling-sitebusinessoffers',
						'defaultParams' => array(
								'title' => 'Selling Offers',
								'titleCount' => true,
						),
				),
				array(
						'title' => 'Business Profile Buying Offers',
						'description' => 'This widget forms the Buying Offers tab on the Business Profile and displays the buying offers of the Business. It should be placed in the Tabbed Blocks area of the Business Profile.',
						'category' => 'Business Profile',
						'type' => 'widget',
						'name' => 'sitebusinessoffer.profile-buying-sitebusinessoffers',
						'defaultParams' => array(
								'title' => 'Buying Offers',
								'titleCount' => true,
						),
				),
		);
  }
  
  if (!empty($joined_array1)) {
		$final_array = array_merge($final_array, $joined_array1);
  }
  return $final_array;
?>