<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessoffer
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$isActive = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessoffer.isActivate', 0);
if ( empty($isActive) ) {
  return;
}

$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => $view->translate('Business Profile Offers'),
        'description' => $view->translate('This widget forms the Offers tab on the Business Profile and displays the offers of the Business. It should be placed in the Tabbed Blocks area of the Business Profile.'),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusinessoffer.sitemobile-profile-sitebusinessoffers',
        'defaultParams' => array(
            'title' => $view->translate('Offers'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Business Offers'),
        'description' => $view->translate('Displays the list of Offers from Businesses created on your community. This widget should be placed in the widgetized Business Offers business. Results from the Search Business Offers form are also shown here.'),
        'category' => $view->translate('Businesses'),
        'type' => 'widget',
        'name' => 'sitebusinessoffer.sitebusiness-offer',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => $view->translate('Count'),
                        'description' => $view->translate('(number of offers to show)'),
                        'value' => 10,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
		array(
				'title' => $view->translate('Business Offer View'),
				'description' => $view->translate("This widget should be placed on the Business Offer View Page."),
				'category' => $view->translate('Businesses'),
				'type' => 'widget',
				'name' => 'sitebusinessoffer.offer-content',
				'defaultParams' => array(
						'title' => '',
						'titleCount' => true,
				),
		),
	)

?>