<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessoffer
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessoffer_Widget_ProfileBuyingSitebusinessoffersController extends Engine_Content_Widget_Abstract {

  protected $_childCount;

  public function indexAction() {

    //DON'T RENDER IF SUBJECT IS NOT SET
    if (!Engine_Api::_()->core()->hasSubject()) {
      return $this->setNoRender();
    }
    
    $enable_type = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessoffer.offer.show.type', 1);
    if(empty($enable_type)) {
      return $this->setNoRender();
    }
    
    $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewer_id = $viewer->getIdentity();
    
    //GET SUBJECT
    $this->view->sitebusiness = $sitebusiness = $subject = Engine_Api::_()->core()->getSubject('sitebusiness_business');

    //GET BUSINESS ID
    $business_id = $subject->business_id;

    // PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessoffer")) {
        return $this->setNoRender();
      }
    } else {
      $businessOwnerBase = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'offer');
      if (empty($businessOwnerBase)) {
        return $this->setNoRender();
      }
    }
    // PACKAGE BASE PRIYACY END
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'view');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }

    $can_edit = 1;
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
      //return $this->_forward('requireauth', 'error', 'core');
    }

    $can_offer = 1;
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'offer');
    if (empty($isManageAdmin)) {
      $can_offer = 0;
    }
    //END MANAGE-ADMIN CHECK

    $can_create_offer = '';
    //OFFER CREATION AUTHENTICATION CHECK
    if ($can_edit == 1 && $can_offer == 1) {
      $this->view->can_create_offer = $can_create_offer =  1;
    }
    //TOTAL OFFER
    $offerCount = Engine_Api::_()->sitebusiness()->getTotalCount($business_id, 'sitebusinessoffer', 'offers');     
    if (empty($can_create_offer) && empty($offerCount)) {
      return $this->setNoRender();
    }
    $var = 1;
    $this->view->paginator = $paginator = Engine_Api::_()->getItemTable('sitebusinessoffer_offer')->getSitebusinessoffersPaginator($business_id, $var,'',$can_create_offer,'buy');
    if(!empty($paginator)) {
			$count = $paginator->getTotalItemCount();
    }
    //GETTING TAB ID FROM CONTENT TABLE
    $layout = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.layoutcreate', 0);
    $this->view->widgets = $widgets = Engine_Api::_()->sitebusiness()->getwidget($layout, $business_id);
    $this->view->content_id = Engine_Api::_()->sitebusiness()->GetTabIdinfo('sitebusinessoffer.profile-buying-sitebusinessoffers', $business_id, $layout);

    $this->view->module_tabid = $currenttabid = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab', null);
    $isajax = $this->_getParam('isajax', null);
    $this->view->isajax = $isajax;
    $this->view->showtoptitle = $showtoptitle = Engine_Api::_()->sitebusiness()->showtoptitle($layout, $business_id);
    if (!empty($isajax) || ($currenttabid == $this->view->identity) || ($widgets == 0)) {
      $this->view->identity_temp = Zend_Controller_Front::getInstance()->getRequest()->getParam('identity_temp', $currenttabid);
      $this->view->show_content = true;

      //MAKE PAGINATOR
      $currentBusinessNumber = $this->_getParam('business', 1);
      $var = 1;
      $this->view->paginator = $paginator = Engine_Api::_()->getItemTable('sitebusinessoffer_offer')->getSitebusinessoffersPaginator($business_id, $var,'',$can_create_offer,'buy');
      $this->_childCount = $paginator->getTotalItemCount();
      $paginator->setItemCountPerPage(10)->setCurrentPageNumber($currentBusinessNumber);
    } else {
      $this->view->show_content = false;
      $this->view->identity_temp = $this->view->identity;
      $title_count = $this->_getParam('titleCount', false);
      $var = 1;
      $show_count = 1;
      $paginator = Engine_Api::_()->getItemTable('sitebusinessoffer_offer')->getSitebusinessoffersPaginator($subject->business_id, $var, $show_count,$can_create_offer,'buy');
      $this->_childCount = $paginator->getTotalItemCount();
    }

    // START: "SUGGEST TO FRIENDS" LINK WORK.
    $business_flag = 0;
    $is_suggestion_enabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('suggestion');
    if( !empty($is_suggestion_enabled) ) {
      $this->view->is_moduleEnabled = $is_moduleEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusiness');
		  $isModuleInfo = Engine_Api::_()->getDbtable('modules', 'core')->getModule('suggestion');
      $isSupport = Engine_Api::_()->getApi('suggestion', 'sitebusiness')->isSupport();
      // HERE WE ARE DELETE THIS POLL SUGGESTION IF VIEWER HAVE.

      if (Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.package.enable', 1)) {
	if ($sitebusiness->expiration_date <= date("Y-m-d H:i:s")) {
	  $business_flag = 1;
	}
      }

      if (!empty($viewer_id) && !empty($isSupport) && empty($sitebusiness->closed) && !empty($sitebusiness->approved) && empty($sitebusiness->declined) && !empty($sitebusiness->draft) && empty($business_flag) && !empty($is_suggestion_enabled) && ($isModuleInfo->version >= '4.1.8p2')) {
	$this->view->offerSuggLink = Engine_Api::_()->suggestion()->getModSettings('sitebusiness', 'offer_sugg_link');
      }
    }
    // END: "SUGGEST TO FRIENDS" LINE WORK.
    
    $view = $this->view;
    $view->addHelperPath(APPLICATION_PATH . '/application/modules/Fields/View/Helper', 'Fields_View_Helper');
  }

  public function getChildCount() {
    return $this->_childCount;
  }

}
?>