<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Menus.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinesspoll_Plugin_Sitemobile {

  protected $_pagesTable;
  protected $_contentTable;

  //DELETE USERS BELONGINGS BEFORE THAT USER DELETION
  public function onRenderLayoutMobileSMDefault($event) {
    $view = $event->getPayload();
    if (!($view instanceof Zend_View_Interface)) {
      return;
    }
    $view->headScriptSM()
        ->appendFile($view->layout()->staticBaseUrl . 'application/modules/Sitebusinesspoll/externals/scripts/smcore.js');
  }

  public function onIntegrated() {

    $this->_pagesTable = Engine_Api::_()->getApi('modules', 'sitemobile')->_pagesTable;
    $this->_contentTable = Engine_Api::_()->getApi('modules', 'sitemobile')->_contentTable;
    //Business poll
    $this->addSitebusinessPollProfileContent();
    $this->addSitebusinessPollCreateBusiness();
    $this->addSitebusinessPollBrowseBusiness();
    $this->addSitebusinessPollViewBusiness();
    include APPLICATION_PATH . "/application/modules/Sitebusinesspoll/controllers/license/mobileLayoutCreation.php";
  }

  //business poll
  public function addSitebusinessPollProfileContent() {


    // install content areas

    $db = Engine_Db_Table::getDefaultAdapter();
    $business_id = Engine_Api::_()->getApi('modules', 'sitemobile')->getPageId('sitebusiness_index_view');


    // sitemobile.blog-profile-blogs
    // Check if it's already been placed
    $select = new Zend_Db_Select($db);
    $select
            ->from($this->_contentTable)
            ->where('page_id = ?', $business_id)
            ->where('type = ?', 'widget')
            ->where('name = ?', 'sitebusinesspoll.sitemobile-profile-sitebusinesspolls')
    ;
    $info = $select->query()->fetch();

    if (empty($info)) {

      // container_id (will always be there)
      $select = new Zend_Db_Select($db);
      $select
              ->from($this->_contentTable)
              ->where('page_id = ?', $business_id)
              ->where('type = ?', 'container')
              ->limit(1);
      $container_id = $select->query()->fetchObject()->content_id;

      // middle_id (will always be there)
      $select = new Zend_Db_Select($db);
      $select
              ->from($this->_contentTable)
              ->where('parent_content_id = ?', $container_id)
              ->where('type = ?', 'container')
              ->where('name = ?', 'middle')
              ->limit(1);
      $middle_id = $select->query()->fetchObject()->content_id;

      // tab_id (tab container) may not always be there
      $select
              ->reset('where')
              ->where('type = ?', 'widget')
              ->where('name = ?', 'sitemobile.container-tabs-columns')
              ->where('page_id = ?', $business_id)
              ->limit(1);
      $tab_id = $select->query()->fetchObject();
      if ($tab_id && @$tab_id->content_id) {
        $tab_id = $tab_id->content_id;
      } else {
        $tab_id = null;
      }

      // tab on profile
      $db->insert($this->_contentTable, array(
          'page_id' => $business_id,
          'type' => 'widget',
          'name' => 'sitebusinesspoll.sitemobile-profile-sitebusinesspolls',
          'parent_content_id' => ($tab_id ? $tab_id : $middle_id),
          'order' => 1600,
          'params' => '{"title":"Polls","titleCount":true}',
      ));
    }
  }

  public function addSitebusinessPollViewBusiness() {
    $db = Engine_Db_Table::getDefaultAdapter();

    $business_id = Engine_Api::_()->getApi('modules', 'sitemobile')->getPageId('sitebusinesspoll_index_view');
    // insert if it doesn't exist yet
    if (!$business_id) {
      // Insert business
      $db->insert($this->_pagesTable, array(
          'name' => 'sitebusinesspoll_index_view',
          'displayname' => 'Directory / Businesses - Poll View Page',
          'title' => 'Poll View Page',
          'description' => 'This is poll view page.',
          'custom' => 0,
      ));
      $business_id = $db->lastInsertId();

      // Insert main
      $db->insert($this->_contentTable, array(
          'type' => 'container',
          'name' => 'main',
          'page_id' => $business_id,
      ));
      $main_id = $db->lastInsertId();

      // Insert middle
      $db->insert($this->_contentTable, array(
          'type' => 'container',
          'name' => 'middle',
          'page_id' => $business_id,
          'parent_content_id' => $main_id,
          'order' => 2,
      ));
      $middle_id = $db->lastInsertId();

      // Insert content
      $db->insert($this->_contentTable, array(
          'type' => 'widget',
          'name' => 'sitebusinesspoll.sitebusinesspoll-content',
          'page_id' => $business_id,
          'parent_content_id' => $middle_id,
          'order' => 2,
      ));
      $db->insert($this->_contentTable, array(
          'type' => 'widget',
          'name' => 'sitemobile.comments',
          'page_id' => $business_id,
          'parent_content_id' => $middle_id,
          'order' => 3,
      ));
    }
  }

  //Offers view business
  public function addSitebusinessPollBrowseBusiness() {
    $db = Engine_Db_Table::getDefaultAdapter();

    $business_id = Engine_Api::_()->getApi('modules', 'sitemobile')->getPageId('sitebusinesspoll_index_browse');
    // insert if it doesn't exist yet
    if (!$business_id) {
      // Insert business
      $db->insert($this->_pagesTable, array(
          'name' => 'sitebusinesspoll_index_browse',
          'displayname' => 'Directory / Businesses - Browse Poll',
          'title' => 'Browse Poll',
          'description' => 'This is poll browse page.',
          'custom' => 0,
      ));
      $business_id = $db->lastInsertId();

      // Insert main
      $db->insert($this->_contentTable, array(
          'type' => 'container',
          'name' => 'main',
          'page_id' => $business_id,
      ));
      $main_id = $db->lastInsertId();

      // Insert middle
      $db->insert($this->_contentTable, array(
          'type' => 'container',
          'name' => 'middle',
          'page_id' => $business_id,
          'parent_content_id' => $main_id,
          'order' => 2,
      ));
      $middle_id = $db->lastInsertId();

      $db->insert($this->_contentTable, array(
          'type' => 'widget',
          'name' => 'sitemobile.sitemobile-navigation',
          'page_id' => $business_id,
          'parent_content_id' => $middle_id,
          'order' => 1,
      ));
      // Insert Advance search
      $db->insert($this->_contentTable, array(
          'type' => 'widget',
          'name' => 'sitemobile.sitemobile-advancedsearch',
          'page_id' => $business_id,
          'parent_content_id' => $middle_id,
          'params' => '{"search":"2","title":"","nomobile":"0","name":"sitemobile.sitemobile-advancedsearch"}',
          'order' => 2,
          'module' => 'sitemobile'
      ));
      // Insert content
      $db->insert($this->_contentTable, array(
          'type' => 'widget',
          'name' => 'sitebusinesspoll.sitebusiness-poll',
          'page_id' => $business_id,
          'parent_content_id' => $middle_id,
          'params' => '{"itemCount":"10"}',
          'order' => 3,
      ));
    }
  }

  public function addSitebusinessPollCreateBusiness() {

    $db = Engine_Db_Table::getDefaultAdapter();

    $business_id = Engine_Api::_()->getApi('modules', 'sitemobile')->getPageId('sitebusinesspoll_index_create');
    if (!$business_id) {

      // Insert business
      $db->insert($this->_pagesTable, array(
          'name' => 'sitebusinesspoll_index_create',
          'displayname' => 'Directory / Businesses - Create Poll',
          'title' => 'Create new Poll',
          'description' => 'This is poll create page.',
          'custom' => 0,
      ));
      $business_id = $db->lastInsertId();

      // Insert main
      $db->insert($this->_contentTable, array(
          'type' => 'container',
          'name' => 'main',
          'page_id' => $business_id,
          'order' => 1,
      ));
      $main_id = $db->lastInsertId();

      // Insert main-middle
      $db->insert($this->_contentTable, array(
          'type' => 'container',
          'name' => 'middle',
          'page_id' => $business_id,
          'parent_content_id' => $main_id,
      ));
      $main_middle_id = $db->lastInsertId();

      // Insert content
      $db->insert($this->_contentTable, array(
          'type' => 'widget',
          'name' => 'core.content',
          'page_id' => $business_id,
          'parent_content_id' => $main_middle_id,
          'order' => 2,
      ));
    }
  }

}