<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinesspoll
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: IndexController.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinesspoll_IndexController extends Seaocore_Controller_Action_Standard {

  //ACTION FOR CREATING POLL
  public function createAction() {

    //CHECK USER VALIDATION
    if (!$this->_helper->requireUser()->isValid())
      return;

    //NUMBER OF OPTIONS WHICH WILL BE SHOW AT THE TIME OF POLL CREATION
    $this->view->maxOptions = $max_options = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinesspoll.maxoptions', 15);

    //GET NAVIGATION
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
            ->getNavigation('sitebusiness_main');

    $getPollCreate = Engine_Api::_()->sitebusiness()->getPackageAuthInfo('sitebusinesspoll');

    //GET LOGGED IN USER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();

    $sitebusinessPollHostName = str_replace('www.', '', strtolower($_SERVER['HTTP_HOST']));

    //GET BUSINESS ID
    $business_id = $this->_getParam('business_id');
    if (empty($business_id)) {
      return;
    }

    //GET BUSINESS OBJECT
    $this->view->sitebusiness = $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);

    //PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
      if ((!Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinesspoll")) || empty($getPollCreate)) {
        return $this->_forwardCustom('requireauth', 'error', 'core');
      }
    } else {
      $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'splcreate');
      if (empty($isBusinessOwnerAllow) || empty($getPollCreate)) {
        return $this->_forwardCustom('requireauth', 'error', 'core');
      }
    }

    //IS PICCHART ALLOW OR NOT.
    $isPieChart = Engine_Api::_()->sitebusinesspoll()->isPieChart();

    $maxLenght = Zend_Registry::isRegistered('sitebusinesspoll_maxLenght') ? Zend_Registry::get('sitebusinesspoll_maxLenght') : null;
    //PACKAGE BASE PRIYACY END
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'view');
    if (empty($isManageAdmin)) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }

    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($isManageAdmin)) {
      $this->view->can_edit = $can_edit = 0;
    } else {
      $this->view->can_edit = $can_edit = 1;
    }

    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'splcreate');
    if (empty($isManageAdmin) && empty($can_edit)) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }
    //END MANAGE-ADMIN CHECK
    //SEND TAB ID TO TPL
    $this->view->tab_selected_id = $this->_getParam('tab');

    //GENERATE FORM
    $this->view->form = $form = new Sitebusinesspoll_Form_Create();

    if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
      $translate = Zend_Registry::get('Zend_Translate');

      //CHECK OPTIONS
      $options = (array) $this->_getParam('optionsArray');
      $options = array_filter(array_map('trim', $options));
      $options = array_slice($options, 0, $max_options);
      $this->view->options = $options;
      if (empty($options) || !is_array($options) || count($options) < 2) {
        $error = Zend_Registry::get('Zend_Translate')->_('You must provide at least two possible answers.');
        return $form->addError($error);
      }
      foreach ($options as $index => $option) {
        if (strlen($option) > 80) {
          $options[$index] = Engine_String::substr($option, 0, 80);
        }
      }

      if (empty($isPieChart)) {
        return;
      }

      $isModType = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinesspoll.set.type', 0);
      if (empty($isModType)) {
        Engine_Api::_()->getApi('settings', 'core')->setSetting('sitebusinesspoll.type', convert_uuencode($sitebusinessPollHostName));
      }

      //CONNET WITH POLL TABLE
      $sitebusinesspollTable = Engine_Api::_()->getItemTable('sitebusinesspoll_poll');
      $sitebusinesspollOptionsTable = Engine_Api::_()->getDbtable('options', 'sitebusinesspoll');
      $db = $sitebusinesspollTable->getAdapter();
      $db->beginTransaction();

      //GET POSTED VALUES FROM CREATE FORM
      $values = $form->getValues();
      if ($values['end_settings'] == 1 && $values['end_time'] == 0) {
        $error = $message . $this->view->translate('Please select end-date and time from calendar !');
        $error = Zend_Registry::get('Zend_Translate')->_($error);
        $form->getDecorator('errors')->setOption('escape', false);
        $form->addError($error);
        return;
      }

      if (empty($maxLenght)) {
        return;
      }

      //POLL CREATION CODE
      try {
        $values = array_merge($form->getValues(), array(
            'owner_type' => $viewer->getType(),
            'owner_id' => $viewer_id,
                ));

        $this->view->is_error = 0;
        $this->view->excep_error = 0;

        //CREATE THE MAIN POLL
        $siteBusinessPollRow = $sitebusinesspollTable->createRow();
        $siteBusinessPollRow->setFromArray($values);
        $siteBusinessPollRow->business_id = $business_id;
        $siteBusinessPollRow->approved = 1;
        $siteBusinessPollRow->parent_type = 'sitebusiness_business';
        $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
        $siteBusinessPollRow->save();

        //CREATE OPTIONS
        $censor = new Engine_Filter_Censor();
        foreach ($options as $option) {
          $sitebusinesspollOptionsTable->insert(array(
              'poll_id' => $siteBusinessPollRow->poll_id,
              'sitebusinesspoll_option' => $censor->filter($option),
          ));
        }

        //COMMENT PRIVACY
        $auth = Engine_Api::_()->authorization()->context;
        $roles = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'everyone');
        $auth_comment = "everyone";
        $commentMax = array_search($auth_comment, $roles);
        foreach ($roles as $i => $role) {
          $auth->setAllowed($siteBusinessPollRow, $role, 'comment', ($i <= $commentMax));
        }

        //ACTIVITY FEED
        if ($siteBusinessPollRow->search == 1) {
          $actionTable = Engine_Api::_()->getDbtable('actions', 'activity');
          $activityFeedType = null;
          if (Engine_Api::_()->sitebusiness()->isBusinessOwner($sitebusiness) && Engine_Api::_()->sitebusiness()->isFeedTypeBusinessEnable())
            $activityFeedType = 'sitebusinesspoll_admin_new';
          elseif ($sitebusiness->all_post || Engine_Api::_()->sitebusiness()->isBusinessOwner($sitebusiness))
            $activityFeedType = 'sitebusinesspoll_new';
          if ($activityFeedType) {
            $action = Engine_Api::_()->getDbtable('actions', 'activity')->addActivity($viewer, $sitebusiness, $activityFeedType);
            Engine_Api::_()->getApi('subCore', 'sitebusiness')->deleteFeedStream($action);
          }
          if ($action != null) {
            Engine_Api::_()->getDbtable('actions', 'activity')->attachActivity($action, $siteBusinessPollRow);
          }

          //SENDING ACTIVITY FEED TO FACEBOOK.
          $enable_Facebooksefeed = $enable_fboldversion = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('facebooksefeed');
          if (!empty($enable_Facebooksefeed)) {

            $poll_array = array();
            $poll_array['type'] = 'sitebusinesspoll_new';
            $poll_array['object'] = $siteBusinessPollRow;

            Engine_Api::_()->facebooksefeed()->sendFacebookFeed($poll_array);
          }

					//BUSINESS POLL CREATE NOTIFICATION AND EMAIL WORK
					if(!empty($action)) {
						$sitebusinessVersion = Engine_Api::_()->getDbtable('modules', 'core')->getModule('sitebusiness')->version;
						if ($sitebusinessVersion >= '4.3.0p1') {
							Engine_Api::_()->sitebusiness()->sendNotificationEmail($siteBusinessPollRow, $action, 'sitebusinesspoll_create', 'SITEBUSINESSPOLL_CREATENOTIFICATION_EMAIL', 'Businessevent Invite');
							$isBusinessAdmins = Engine_Api::_()->getDbtable('manageadmins', 'sitebusiness')->isBusinessAdmins($viewer->getIdentity(), $business_id);
							if (!empty($isBusinessAdmins)) {
								//NOTIFICATION FOR ALL FOLLWERS.
								Engine_Api::_()->sitebusiness()->sendNotificationToFollowers($siteBusinessPollRow, $action, 'sitebusinesspoll_create');
							}
						}
					}
        }
        $db->commit();
      } catch (Exception $e) {
        $db->rollBack();
        throw $e;
      }

      //GO TO SITEBUSINESS PROFILE BUSINESS WITH SITEBUSINESS POLL SELECTED TAB
      return $this->_redirectCustom($siteBusinessPollRow->getHref(), array('prependBase' => false));
    }
  }

  //ACTION FOR VIEW THE POLL
  public function viewAction() {

    //GET LOGGED IN USER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();

    //GET POLL ITEM
    $sitebusinesspoll = Engine_Api::_()->getItem('sitebusinesspoll_poll', $this->getRequest()->getParam('poll_id'));

		if ($sitebusinesspoll) {
			Engine_Api::_()->core()->setSubject($sitebusinesspoll);
		}

    //GET SITEBUSINESS ITEM
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $sitebusinesspoll->business_id);

    //PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinesspoll")) {
        return $this->_forwardCustom('requireauth', 'error', 'core');
      }
    } else {
      $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'splcreate');
      if (empty($isBusinessOwnerAllow)) {
        return $this->_forwardCustom('requireauth', 'error', 'core');
      }
    }
    //PACKAGE BASE PRIYACY END

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'splcreate');
    if (empty($isManageAdmin)) {
      $this->view->can_create = 0;
    } else {
      $this->view->can_create = 1;
    }
    
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'view');
    if (empty($isManageAdmin)) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }
    //END MANAGE-ADMIN CHECK

    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK
    //CHECKING THE USER HAVE THE PERMISSION TO VIEW THE POLL OR NOT
    if ($sitebusinesspoll->owner_id != $viewer_id && $can_edit != 1 && ( empty($sitebusinesspoll->approved) || empty($sitebusinesspoll->search))) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }

    //NAVIGATION WORK FOR FOOTER.(DO NOT DISPLAY NAVIGATION IN FOOTER ON VIEW BUSINESS.)
    if (!Engine_API::_()->seaocore()->checkSitemobileMode('fullsite-mode')) {
         if(!Zend_Registry::isRegistered('sitemobileNavigationName')){
         Zend_Registry::set('sitemobileNavigationName','setNoRender');
         }
    }
    
   //CHECK THE VERSION OF THE CORE MODULE
    $coremodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core');
    $coreversion = $coremodule->version;
    if ($coreversion < '4.1.0') {
      $this->_helper->content->render();
    } else {
      $this->_helper->content
              ->setNoRender()
              ->setEnabled()
      ;
    }
  }

  //ACTION FOR DELETE POLL
  public function deleteAction() {

    //CHECK USER VALIDATION
    if (!$this->_helper->requireUser()->isValid())
      return;

    //GET LOGGED IN INFORMATION
    $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();

    //GET TAB ID OF POLL ON THE BUSINESS PROFILE BUSINESS
    $this->view->tab_selected_id = $tab_selected_id = $this->_getParam('tab');
    $business_id = $this->_getParam('business_id');

    //GET NAVIGATION
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
            ->getNavigation('sitebusiness_main');

    //RETURN IF BUSINESS ID IS EMPTY
    if (empty($business_id)) {
      return;
    }

    //GET SITEBUSINESS OBJECT
    $this->view->sitebusiness = $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);

    //GET BUSINESSPOLL OBJECT
    $this->view->sitebusinesspoll = $sitebusinesspoll = Engine_Api::_()->getItem('sitebusinesspoll_poll', $this->_getParam('poll_id'));

    //PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinesspoll")) {
        return $this->_forwardCustom('requireauth', 'error', 'core');
      }
    } else {
      $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'splcreate');
      if (empty($isBusinessOwnerAllow)) {
        return $this->_forwardCustom('requireauth', 'error', 'core');
      }
    }
    //PACKAGE BASE PRIYACY END
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK
    //POLL OWNER AND SITEBUSINESS OWNER CAN DELETE POLL
    if ($viewer_id != $sitebusinesspoll->owner_id && $can_edit != 1) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }

    //DELETE POLL FROM DATATBASE AND SCRIBD AFTER CONFIRMATION
    if ($this->getRequest()->isPost() && $this->getRequest()->getPost('confirm') == true) {

      //FINALLY DELETE BUSINESS POLL
      $sitebusinesspoll->delete();

			return $this->_gotoRouteCustom(array('business_url' => Engine_Api::_()->sitebusiness()->getBusinessUrl($business_id), 'tab' => $this->view->tab_selected_id), 'sitebusiness_entry_view', true);
    }
  }

  public function voteAction() {

    //CHECK USER VALIDATION
    if (!$this->_helper->requireUser()->isValid()) {
      return;
    }

    //GET SUBJECT
    $sitebusinesspoll = null;
    if (null !== ($sitebusinesspollIdentity = $this->_getParam('poll_id'))) {
      $sitebusinesspoll = Engine_Api::_()->getItem('sitebusinesspoll_poll', $sitebusinesspollIdentity);
      if (null !== $sitebusinesspoll) {
        Engine_Api::_()->core()->setSubject($sitebusinesspoll);
      }
    }

    //CHECK METHOD
    if (!$this->getRequest()->isPost()) {
      return;
    }

    //GET OPTION ID
    $this->view->option_id = $option_id = $this->_getParam('option_id');

    $getPackagepollvote = Engine_Api::_()->sitebusiness()->getPackageAuthInfo('sitebusinesspoll');

    //CAN CHANGE VOTE OR NOT
    $canChangeVote = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinesspoll.canchangevote', false);

    //GET VIEWER INFO
    $viewer = Engine_Api::_()->user()->getViewer();
    if (empty($getPackagepollvote)) {
      return;
    }

    if (!$sitebusinesspoll) {
      $this->view->success = false;
      $this->view->error = Zend_Registry::get('Zend_Translate')->_('This poll does not seem to exist anymore.');
      return;
    }

    $hashElement = $this->view->businessPollVoteHash($sitebusinesspoll)->getElement();
    if (!$hashElement->isValid($this->_getParam('token'))) {
      $this->view->success = false;
      $this->view->error = join(';', $hashElement->getMessages());
      return;
    }

    if( $sitebusinesspoll->closed ) {
      $this->view->success = false;
      $this->view->error = Zend_Registry::get('Zend_Translate')->_('This poll is closed.');
      return;
    }
    
    //CHECK FOR THE USER THAT CAN CHANGE VOTE OR NOT.
    if ($sitebusinesspoll->hasVoted($viewer) && !$canChangeVote) {
      $this->view->success = false;
      $this->view->error = Zend_Registry::get('Zend_Translate')->_('You have already voted on this poll, and are not permitted to change your vote.');
      return;
    }

    //MAKE VOTE ENTRY IN DATATBASE
    $db = Engine_Api::_()->getDbtable('polls', 'sitebusinesspoll')->getAdapter();
    $db->beginTransaction();
    try {
      $sitebusinesspoll->vote($viewer, $option_id);
      $db->commit();
    } catch (Exception $e) {
      $db->rollback();
      $this->view->success = false;
      throw $e;
    }

    $this->view->token = $this->view->businessPollVoteHash($sitebusinesspoll)->generateHash();
    $this->view->success = true;
    $sitebusinesspollOptions = array();
    foreach ($sitebusinesspoll->getOptions()->toArray() as $option) {
      $option['votesTranslated'] = $this->view->translate(array('%s vote', '%s votes', $option['votes']), $this->view->locale()->toNumber($option['votes']));
      $sitebusinesspollOptions[] = $option;
    }
    $this->view->sitebusinesspollOptions = $sitebusinesspollOptions;
    $this->view->votes_total = $sitebusinesspoll->vote_count;
  }

  public function closeAction() {
    if (!$this->_helper->requireUser()->isValid())
      return;

    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    $sitebusinesspoll = Engine_Api::_()->getItem('sitebusinesspoll_poll', $this->_getParam('poll_id'));
    $business_id = $this->_getParam('business_id');
    $tab_selected_id = $this->_getParam('tab');

    //GET SITEBUSINESS OBJECT
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);

    //PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinesspoll")) {
        return $this->_forwardCustom('requireauth', 'error', 'core');
      }
    } else {
      $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'splcreate');
      if (empty($isBusinessOwnerAllow)) {
        return $this->_forwardCustom('requireauth', 'error', 'core');
      }
    }
    //PACKAGE BASE PRIYACY END
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK
    //POLL OWNER AND SITEBUSINESS OWNER CAN DELETE POLL
    if ($viewer_id != $sitebusinesspoll->owner_id && $can_edit != 1) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }

    $sitebusinesspollTable = $sitebusinesspoll->getTable();
    $db = $sitebusinesspollTable->getAdapter();
    $db->beginTransaction();

    try {
      $sitebusinesspoll->closed = (bool) $this->_getParam('closed');
      $sitebusinesspoll->save();

      $db->commit();
    } catch (Exception $e) {
      $db->rollBack();
      throw $e;
    }
    return $this->_gotoRouteCustom(array('business_url' => Engine_Api::_()->sitebusiness()->getBusinessUrl($business_id), 'tab' => $tab_selected_id), 'sitebusiness_entry_view', true);
  }

   public function browseAction() {

   //CHECK VIEW PRIVACY
    if (!$this->_helper->requireAuth()->setAuthParams('sitebusiness_business', null, 'view')->isValid())
      return;

   //CHECK THE VERSION OF THE CORE MODULE
    $coremodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core');
    $coreversion = $coremodule->version;
    if ($coreversion < '4.1.0') {
      $this->_helper->content->render();
    } else {
      $this->_helper->content
              ->setNoRender()
              ->setEnabled()
      ;
    }
  }

}