<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinesspoll
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinesspoll_Widget_SitemobileProfileSitebusinesspollsController extends Engine_Content_Widget_Abstract {

  protected $_childCount;

  public function indexAction() {

    //DONT RENDER THIS IF SUBJECT IS NOT SET
    if (!Engine_Api::_()->core()->hasSubject()) {
      return $this->setNoRender();
    }

    //GET VIEWER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewer_id = $viewer->getIdentity();
    if (!empty($viewer_id)) {
      $this->view->level_id = $level_id = $viewer->level_id;
    } else {
      $this->view->level_id = $level_id = 0;
    }

    //GET SITEBUSINESS SUBJECT
    $this->view->sitebusiness = $sitebusiness = Engine_Api::_()->core()->getSubject('sitebusiness_business');

    //GET BUSINESS ID
    $this->view->business_id = $business_id = $sitebusiness->business_id;

    //IF PIECHART IS DISABLE THEN SET NO RENDER
    $isPieChart = Engine_Api::_()->sitebusinesspoll()->isPieChart();
    if (empty($isPieChart)) {
      return $this->setNoRender();
    }

    // PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinesspoll")) {
        return $this->setNoRender();
      }
    } else {
      $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'splcreate');
      if (empty($isBusinessOwnerAllow)) {
        return $this->setNoRender();
      }
    }
    // PACKAGE BASE PRIYACY END
    
    //TOTAL POLL
    $pollCount = Engine_Api::_()->sitebusiness()->getTotalCount($business_id, 'sitebusinesspoll', 'polls');   
    $pollCreate = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'splcreate');
           
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'view');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }

    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($isManageAdmin)) {
      $this->view->can_edit = $can_edit = 0;
    } else {
      $this->view->can_edit = $can_edit = 1;
    }

    if (empty($pollCreate) && empty($pollCount) && empty($can_edit) && !(Engine_Api::_()->sitebusiness()->showTabsWithoutContent())) {
      return $this->setNoRender();
    } 
    //END MANAGE-ADMIN CHECK

		//START MANAGE-ADMIN CHECK
		$isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'splcreate');
		if (empty($isManageAdmin) && empty($can_edit)) {
			$this->view->can_create = 0;
		} else {
			$this->view->can_create = 1;
		}
		//END MANAGE-ADMIN CHECK

		//FETCH POLLS
		$values['business_id'] = $business_id;
    $values['orderby'] = 'creation_date';
		if ($can_edit) {
			$values['show_poll'] = 0;
			$this->view->paginator = $paginator = Engine_Api::_()->getItemTable('sitebusinesspoll_poll')->getSitebusinesspollsPaginator($values);
		} else {
			$values['show_poll'] = 1;
			$values['poll_owner_id'] = $viewer_id;
			$this->view->paginator = $paginator = Engine_Api::_()->getItemTable('sitebusinesspoll_poll')->getSitebusinesspollsPaginator($values);
		}

		//10 POLLS PER BUSINESS
		$this->view->paginator->setItemCountPerPage(10)->setCurrentPageNumber($this->_getParam('business', 1));
		$this->_childCount = $paginator->getTotalItemCount();
      
  }

  public function getChildCount() {
    return $this->_childCount;
  }

}