<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    sitebusinessevent
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: WidgetSettings.php 6590 2010-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

//START LANGUAGE WORK
Engine_Api::_()->getApi('language', 'sitebusiness')->languageChanges();
//END LANGUAGE WORK

//GET DB
$db = Zend_Db_Table_Abstract::getDefaultAdapter();	
$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `order`) VALUES
("sitebusinessreview_admin_main_level", "sitebusinessreview", "Member Level Settings", "", \'{"route":"admin_default","module":"sitebusinessreview","controller":"settings","action":"level"}\', "sitebusinessreview_admin_main", "", 2)');

$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitebusinessreview_admin_main_dayitems", "sitebusinessreview", "Review of the Day", "", \'{"route":"admin_default","module":"sitebusinessreview","controller":"settings", "action": "manage-day-items"}\', "sitebusinessreview_admin_main", "", 1, 0, 3)');


//CHECK THAT SITEBUSINESS PLUGIN IS ACTIVATED OR NOT
$select = new Zend_Db_Select($db);
	$select
  ->from('engine4_core_settings')
  ->where('name = ?', 'sitebusiness.is.active')
	->limit(1);
$sitebusiness_settings = $select->query()->fetchAll();
if(!empty($sitebusiness_settings)) {
	$sitebusiness_is_active = $sitebusiness_settings[0]['value'];
}
else {
	$sitebusiness_is_active = 0;
}

//CHECK THAT SITEBUSINESS PLUGIN IS INSTALLED OR NOT
$select = new Zend_Db_Select($db);
	$select
	  ->from('engine4_core_modules')
  ->where('name = ?', 'sitebusiness')
	->where('enabled = ?', 1);
$check_sitebusiness = $select->query()->fetchObject();
if(!empty($check_sitebusiness)  && !empty($sitebusiness_is_active)) {
	$select = new Zend_Db_Select($db);
	$select_business = $select
										 ->from('engine4_core_pages', 'page_id')
										 ->where('name = ?', 'sitebusiness_index_view')
										 ->limit(1);
  $business = $select_business->query()->fetchAll();
	if(!empty($business)) {
		$business_id = $business[0]['page_id'];
		
		//INSERTING THE POLL WIDGET IN SITEBUSINESS_ADMIN_CONTENT TABLE ALSO.
		Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminDefaultInfo('sitebusinessreview.profile-sitebusinessreviews', $business_id, 'Reviews', 'true', '113');
	 
		//INSERTING THE POLL WIDGET IN CORE_CONTENT TABLE ALSO.
		Engine_Api::_()->getApi('layoutcore', 'sitebusiness')->setContentDefaultInfo('sitebusinessreview.profile-sitebusinessreviews', $business_id, 'Reviews', 'true', '113');
		
    //INSERTING THE POLL WIDGET IN SITEBUSINESS_CONTENT TABLE ALSO.
    $select = new Zend_Db_Select($db);								
		$contentbusiness_ids = $select->from('engine4_sitebusiness_contentbusinesses', 'contentbusiness_id')->query()->fetchAll();
    foreach ($contentbusiness_ids as $contentbusiness_id) {
			if(!empty($contentbusiness_id)) {
        Engine_Api::_()->getDbtable('content', 'sitebusiness')->setDefaultInfo('sitebusinessreview.profile-sitebusinessreviews', $contentbusiness_id['contentbusiness_id'], 'Reviews', 'true', '113');
        
        $select = new Zend_Db_Select($db);
		    $select_content = $select
		                 ->from('engine4_sitebusiness_content')
		                 ->where('contentbusiness_id = ?', $contentbusiness_id['contentbusiness_id'])
		                 ->where('type = ?', 'widget')
		                 ->where('name = ?', 'sitebusinessreview.ratings-sitebusinessreviews')
		                 ->limit(1);
		    $content = $select_content->query()->fetchAll();
		    if(empty($content)) {
		      $select = new Zend_Db_Select($db);
		      $select_container = $select
		                   ->from('engine4_sitebusiness_content', 'content_id')
		                   ->where('contentbusiness_id = ?', $contentbusiness_id['contentbusiness_id'])
		                   ->where('type = ?', 'container')
		                   ->limit(1);
		      $container = $select_container->query()->fetchAll();
		      if(!empty($container)) {
		        $container_id = $container[0]['content_id'];
		        $select = new Zend_Db_Select($db);
		        $select_left = $select
		                   ->from('engine4_sitebusiness_content')
		                   ->where('parent_content_id = ?', $container_id)
		                   ->where('type = ?', 'container')
												->where('contentbusiness_id = ?', $contentbusiness_id['contentbusiness_id'])
												->where('name in (?)', array('left', 'right'))
		                   ->limit(1);
		        $left = $select_left->query()->fetchAll();
		        if(!empty($left)) {
			        $left_id = $left[0]['content_id'];
			        $db->insert('engine4_sitebusiness_content', array(
			        'contentbusiness_id' => $contentbusiness_id['contentbusiness_id'],
			        'type' => 'widget',
			        'name' => 'sitebusinessreview.ratings-sitebusinessreviews',
			        'parent_content_id' => $left_id,
			        'order' => 15,
			        'params' => '{"title":"Ratings","titleCount":""}',
			        ));
		       	}
		      }
		    }       
			}
		}
		
	  $select = new Zend_Db_Select($db);
    $select_content = $select
                 ->from('engine4_sitebusiness_admincontent')
                 ->where('business_id = ?', $business_id)
                 ->where('type = ?', 'widget')
                 ->where('name = ?', 'sitebusinessreview.ratings-sitebusinessreviews')
                 ->limit(1);
    $content = $select_content->query()->fetchAll();
    if(empty($content)) {
      $select = new Zend_Db_Select($db);
      $select_container = $select
                   ->from('engine4_sitebusiness_admincontent', 'admincontent_id')
                   ->where('business_id = ?', $business_id)
                   ->where('type = ?', 'container')
                   ->limit(1);
      $container = $select_container->query()->fetchAll();
      if(!empty($container)) {
        $container_id = $container[0]['admincontent_id'];
        $select = new Zend_Db_Select($db);
        $select_left = $select
                   ->from('engine4_sitebusiness_admincontent')
                   ->where('parent_content_id = ?', $container_id)
                   ->where('type = ?', 'container')
										->where('business_id = ?', $business_id)
										->where('name in (?)', array('left', 'right'))
                   ->limit(1);
        $left = $select_left->query()->fetchAll();
        if(!empty($left)) {
	        $left_id = $left[0]['admincontent_id'];
	        $db->insert('engine4_sitebusiness_admincontent', array(
	        'business_id' => $business_id,
	        'type' => 'widget',
	        'name' => 'sitebusinessreview.ratings-sitebusinessreviews',
	        'parent_content_id' => $left_id,
	        'order' => 15,
	        'params' => '{"title":"Ratings","titleCount":""}',
	        ));
       	}
      }
    } 
    
	  $select = new Zend_Db_Select($db);
    $select_content = $select
                 ->from('engine4_core_content')
                 ->where('page_id = ?', $business_id)
                 ->where('type = ?', 'widget')
                 ->where('name = ?', 'sitebusinessreview.ratings-sitebusinessreviews')
                 ->limit(1);
    $content = $select_content->query()->fetchAll();
    if(empty($content)) {
      $select = new Zend_Db_Select($db);
      $select_container = $select
                   ->from('engine4_core_content', 'content_id')
                   ->where('page_id = ?', $business_id)
                   ->where('type = ?', 'container')
                   ->limit(1);
      $container = $select_container->query()->fetchAll();
      if(!empty($container)) {
        $container_id = $container[0]['content_id'];
        $select = new Zend_Db_Select($db);
        $select_left = $select
                   ->from('engine4_core_content')
                   ->where('parent_content_id = ?', $container_id)
                   ->where('type = ?', 'container')
										->where('page_id = ?', $business_id)
										->where('name in (?)', array('left', 'right'))
                   ->limit(1);
        $left = $select_left->query()->fetchAll();
        if(!empty($left)) {
	        $left_id = $left[0]['content_id'];
	        $db->insert('engine4_core_content', array(
	        'page_id' => $business_id,
	        'type' => 'widget',
	        'name' => 'sitebusinessreview.ratings-sitebusinessreviews',
	        'parent_content_id' => $left_id,
	        'order' => 15,
	        'params' => '{"title":"Ratings","titleCount":""}',
	        ));
       	}
      }
    }   
	}
	
	//PUT TOP RATED WIDGET AT BUSINESS HOME
  $select = new Zend_Db_Select($db);
	$select_business = $select
											 ->from('engine4_core_pages', 'page_id')
											 ->where('name = ?', 'sitebusiness_index_home')
											 ->limit(1);
  $business = $select_business->query()->fetchAll();
	if(!empty($business)) {
		$business_id = $business[0]['page_id'];
		$select = new Zend_Db_Select($db);
		$select_content = $select
														->from('engine4_core_content')
														->where('page_id = ?', $business_id)
														->where('type = ?', 'widget')
														->where('name = ?', 'sitebusinessreview.topratedbusinesses-sitebusinessreviews')
														->limit(1);
		$content = $select_content->query()->fetchAll();
		if(empty($content)) {
			$select = new Zend_Db_Select($db);
			$select_container = $select
																->from('engine4_core_content', 'content_id')
															->where('page_id = ?', $business_id)
																->where('type = ?', 'container')
																->where('name = ?', 'main')
																->limit(1);
			$container = $select_container->query()->fetchAll();
		  if(!empty($container)) {
				$container_id = $container[0]['content_id'];
				$select = new Zend_Db_Select($db);
				$select_left = $select
																->from('engine4_core_content')
															->where('parent_content_id = ?', $container_id)
																->where('type = ?', 'container')
																->where('name = ?', 'left')
																->limit(1);
				$left = $select_left->query()->fetchAll();
				if(!empty($left)) {
					$left_id = $left[0]['content_id'];
					$select = new Zend_Db_Select($db);
						$select_tab = $select
																->from('engine4_core_content')
																->where('type = ?', 'widget')
																->where('name = ?', 'core.container-tabs')
																->where('page_id = ?', $business_id)
																->limit(1);
						$tab = $select_tab->query()->fetchAll();
						if(!empty($tab)) {
							$tab_id = $tab[0]['content_id'];
					}

					$db->insert('engine4_core_content', array(
					'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessreview.topratedbusinesses-sitebusinessreviews',
						'parent_content_id' => ($left_id ? $left_id : $tab_id),
						'order' => 998,
						'params' => '{"title":"Top Rated Businesses","titleCount":"true"}',
						));
			  }
			}
		}
	}
	
	
	
	
	
	$contentTable = Engine_Api::_()->getDbtable('content', 'core');
  $contentTableName = $contentTable->info('name');
 
  $select = new Zend_Db_Select($db);
	$select
					->from('engine4_core_modules')
					->where('name = ?', 'communityad')
					->where('enabled 	 = ?', 1)
					->limit(1);
	;
	$infomation = $select->query()->fetch();
	$select = new Zend_Db_Select($db);
	$select
					->from('engine4_core_settings')
					->where('name = ?', 'sitebusiness.communityads')
					->where('value 	 = ?', 1)
					->limit(1);
    ;
    $rowinfo = $select->query()->fetch();

  $select = new Zend_Db_Select($db);
  $select
          ->from('engine4_core_pages')
          ->where('name = ?', 'sitebusinessreview_index_browse')
          ->limit(1);
  ;
  $info = $select->query()->fetch();
  if ( empty($info) ) {
    $db->insert('engine4_core_pages', array(
        'name' => 'sitebusinessreview_index_browse',
        'displayname' => 'Browse Business Reviews',
        'title' => 'Business Reviews List',
        'description' => 'This is the business reviews.',
        'custom' => 1,
    ));
    $business_id = $db->lastInsertId('engine4_core_pages');
//INSERT MAIN CONTAINER
    $mainContainer = $contentTable->createRow();
    $mainContainer->page_id = $business_id;
    $mainContainer->type = 'container';
    $mainContainer->name = 'main';
    $mainContainer->order = 2;
    $mainContainer->save();
    $container_id = $mainContainer->content_id;

//INSERT MAIN - MIDDLE CONTAINER
    $mainMiddleContainer = $contentTable->createRow();
    $mainMiddleContainer->page_id = $business_id;
    $mainMiddleContainer->type = 'container';
    $mainMiddleContainer->name = 'middle';
    $mainMiddleContainer->parent_content_id = $container_id;
    $mainMiddleContainer->order = 6;
    $mainMiddleContainer->save();
    $middle_id = $mainMiddleContainer->content_id;

//INSERT MAIN - RIGHT CONTAINER
    $mainRightContainer = $contentTable->createRow();
    $mainRightContainer->page_id = $business_id;
    $mainRightContainer->type = 'container';
    $mainRightContainer->name = 'right';
    $mainRightContainer->parent_content_id = $container_id;
    $mainRightContainer->order = 5;
    $mainRightContainer->save();
    $right_id = $mainRightContainer->content_id;

//INSERT TOP CONTAINER
    $topContainer = $contentTable->createRow();
    $topContainer->page_id = $business_id;
    $topContainer->type = 'container';
    $topContainer->name = 'top';
    $topContainer->order = 1;
    $topContainer->save();
    $top_id = $topContainer->content_id;

//INSERT TOP- MIDDLE CONTAINER
    $topMiddleContainer = $contentTable->createRow();
    $topMiddleContainer->page_id = $business_id;
    $topMiddleContainer->type = 'container';
    $topMiddleContainer->name = 'middle';
    $topMiddleContainer->parent_content_id = $top_id;
    $topMiddleContainer->order = 6;
    $topMiddleContainer->save();
    $top_middle_id = $topMiddleContainer->content_id;

    //INSERT NAVIGATION WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.browsenevigation-sitebusiness', $top_middle_id, 1);

//INSERT REVIEW WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessreview.sitebusiness-review', $middle_id, 2,"Reviews");

    //INSERT SEARCH BUSINESS REVIEW WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessreview.search-sitebusinessreview', $right_id, 3, "", "true");

    //INSERT FEATURED BUSINESS REVIEW WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessreview.featured-sitebusinessreviews', $right_id, 4, "Featured Reviews", "true");

    //INSERT MOST COMMENTED BUSINESS REVIEW WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessreview.homecomment-sitebusinessreviews', $right_id, 5, "Most Commented Reviews", "true");

    //INSERT MOST POPULAR BUSINESS REVIEW WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessreview.site-popular-reviews', $right_id, 6, "Most Popular Reviews", "true");

    //INSERT MOST LIKED BUSINESS REVIEW WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessreview.homelike-sitebusinessreviews', $right_id, 7, "Most Liked Reviews", "true");

    //INSERT TOP REVIEWER BUSINESS REVIEW WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessreview.reviewer-sitebusinessreviews', $right_id, 8, "Top Reviewers", "true");

    //INSERT TITEM OF THE DAY BUSINESS REVIEW WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessreview.review-of-the-day', $right_id, 9, "Review of the Day", "true");

    //INSERT RECENT BUSINESS REVIEW WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessreview.recent-sitebusinessreviews', $right_id, 10, "Recent Reviews", "true");

    if ( $infomation && $rowinfo ) {
      Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.business-ads', $right_id, 11, "", "true");
    }
  }

  $select = new Zend_Db_Select($db);

  // Check if it's already been placed
  $select = new Zend_Db_Select($db);
  $select
          ->from('engine4_core_pages')
          ->where('name = ?', 'sitebusinessreview_index_view')
          ->limit(1);
  ;
  $info = $select->query()->fetch();

  if ( empty($info) ) {
    $db->insert('engine4_core_pages', array(
        'name' => 'sitebusinessreview_index_view',
        'displayname' => 'Business Review View Page',
        'title' => 'View Business Review',
        'description' => 'This is the view business for a business review.',
        'custom' => 1,
        'provides' => 'subject=sitebusinessreview',
    ));
    $business_id = $db->lastInsertId('engine4_core_pages');

    // containers
    $db->insert('engine4_core_content', array(
        'page_id' => $business_id,
        'type' => 'container',
        'name' => 'main',
        'parent_content_id' => null,
        'order' => 1,
        'params' => '',
    ));
    $container_id = $db->lastInsertId('engine4_core_content');

    $db->insert('engine4_core_content', array(
        'page_id' => $business_id,
        'type' => 'container',
        'name' => 'right',
        'parent_content_id' => $container_id,
        'order' => 1,
        'params' => '',
    ));
    $right_id = $db->lastInsertId('engine4_core_content');

    $db->insert('engine4_core_content', array(
        'page_id' => $business_id,
        'type' => 'container',
        'name' => 'middle',
        'parent_content_id' => $container_id,
        'order' => 3,
        'params' => '',
    ));
    $middle_id = $db->lastInsertId('engine4_core_content');

    // middle column content
    $db->insert('engine4_core_content', array(
        'page_id' => $business_id,
        'type' => 'widget',
        'name' => 'sitebusinessreview.review-content',
        'parent_content_id' => $middle_id,
        'order' => 1,
        'params' => '',
    ));

    $db->insert('engine4_core_content', array(
        'page_id' => $business_id,
        'type' => 'widget',
        'name' => 'sitebusinessreview.sitebusiness-review-detail',
        'parent_content_id' => $right_id,
        'order' => 1,
        'params' => '{"title":"Review Details"}',
    ));

    if ( $infomation && $rowinfo ) {
      Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.business-ads', $right_id, 2, "", "true");
    }

  }

  $select = new Zend_Db_Select($db);
	$select
	->from('engine4_core_modules')
	->where('name = ?', 'mobi')
	->where('enabled 	 = ?', 1)
	->limit(1);
	;  

	$infomation = $select->query()->fetch();
	if(!empty($infomation)) {
		$select = new Zend_Db_Select($db);
		$select
		->from('engine4_core_pages')
		->where('name = ?', 'sitebusinessreview_mobi_view')
		->limit(1);
		;
		$info = $select->query()->fetch();
		if (empty($info)) {
			$db->insert('engine4_core_pages', array(
						'name' => 'sitebusinessreview_mobi_view',
						'displayname' => 'Mobile Business Review Profile',
						'title' => 'Mobile Business Review Profile',
						'description' => 'This is the mobile verison of a Business review profile business.',
						'custom' => 0,
			));
			$business_id = $db->lastInsertId('engine4_core_pages');

			// containers
			$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'main',
						'parent_content_id' => null,
						'order' => 1,
						'params' => '',
			));
			$container_id = $db->lastInsertId('engine4_core_content');

			$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'right',
						'parent_content_id' => $container_id,
						'order' => 1,
						'params' => '',
			));
			$right_id = $db->lastInsertId('engine4_core_content');

			$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $container_id,
						'order' => 3,
						'params' => '',
			));
			$middle_id = $db->lastInsertId('engine4_core_content');

			// middle column content
			$db->insert('engine4_core_content', array(
					'page_id' => $business_id,
					'type' => 'widget',
					'name' => 'sitebusinessreview.review-content',
					'parent_content_id' => $middle_id,
					'order' => 1,
					'params' => '',
			));

			$db->insert('engine4_core_content', array(
					'page_id' => $business_id,
					'type' => 'widget',
					'name' => 'sitebusinessreview.sitebusiness-review-detail',
					'parent_content_id' => $right_id,
					'order' => 1,
					'params' => '{"title":"Review Details"}',
			));
		}
	}

  $select = new Zend_Db_Select($db);
	$select
					->from('engine4_core_pages')
					->where('name = ?', 'sitebusinessreview_index_home')
					->limit(1);
	$info = $select->query()->fetch();
	if (empty($info)) {
		$db->insert('engine4_core_pages', array(
				'name' => 'sitebusinessreview_index_home',
				'displayname' => 'Business Reviews Home',
				'title' => 'Business Reviews Home',
				'description' => 'This is business review home business.',
				'custom' => 1
		));
		$business_id = $db->lastInsertId('engine4_core_pages');

		// containers
		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'container',
				'name' => 'main',
				'parent_content_id' => null,
				'order' => 2,
				'params' => '',
		));
		$container_id = $db->lastInsertId('engine4_core_content');

		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'container',
				'name' => 'right',
				'parent_content_id' => $container_id,
				'order' => 5,
				'params' => '',
		));
		$right_id = $db->lastInsertId('engine4_core_content');

		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'container',
				'name' => 'left',
				'parent_content_id' => $container_id,
				'order' => 4,
				'params' => '',
		));
		$left_id = $db->lastInsertId('engine4_core_content');

		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'container',
				'name' => 'top',
				'parent_content_id' => null,
				'order' => 1,
				'params' => '',
		));
		$top_id = $db->lastInsertId('engine4_core_content');

		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'container',
				'name' => 'middle',
				'parent_content_id' => $top_id,
				'order' => 6,
				'params' => '',
		));
		$top_middle_id = $db->lastInsertId('engine4_core_content');

		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'container',
				'name' => 'middle',
				'parent_content_id' => $container_id,
				'order' => 6,
				'params' => '',
		));
		$middle_id = $db->lastInsertId('engine4_core_content');

	// Top Middle
		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusiness.browsenevigation-sitebusiness',
				'parent_content_id' => $top_middle_id,
				'order' => 3,
				'params' => '',
		));

		// Left
		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessreview.recent-sitebusinessreviews',
				'parent_content_id' => $left_id,
				'order' => 16,
				'params' => '{"title":"Recent Reviews","titleCount":"true"}',
		));

		// Middle
		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessreview.featured-reviews-slideshow',
				'parent_content_id' => $middle_id,
				'order' => 15,
				'params' => '{"title":"Featured Reviews","titleCount":"true"}',
		));

    $db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusiness.category-businesses-sitebusiness',
				'parent_content_id' => $middle_id,
				'order' => 16,
				'params' => '{"title":"Most Reviewed this Month","titleCount":true,"itemCount":"6","businessCount":"3","popularity":"review_count","interval":"month","nomobile":"1"}',
		));


		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessreview.review-tabs',
				'parent_content_id' => $middle_id,
				'order' => 17,
				'params' => '{"title":"People\'s Reviews"}',
		));
		// Right Side
		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessreview.sitebusinessreviewlist-link',
				'parent_content_id' => $right_id,
				'order' => 19,
				'params' => '',
		));

		// Right Side
		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessreview.search-sitebusinessreview',
				'parent_content_id' => $right_id,
				'order' => 18,
				'params' => '',
		));

		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessreview.review-of-the-day',
				'parent_content_id' => $left_id,
				'order' => 13,
				'params' => '{"title":"Review of the Day"}',
		));

    $db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessreview.topratedbusinesses-sitebusinessreviews',
				'parent_content_id' => $left_id,
				'order' => 14,
				'params' => '{"title":"Top Rated Businesses","itemCountPerBusiness":3}',
		));

    $db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessreview.reviewer-sitebusinessreviews',
				'parent_content_id' => $left_id,
				'order' => 15,
				'params' => '{"title":"Top Reviewers","itemCountPerBusiness":3}',
		));

		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessreview.homecomment-sitebusinessreviews',
				'parent_content_id' => $right_id,
				'order' => 22,
				'params' => '{"title":"Most Commented Reviews","titleCount":"true"}',
		));

		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessreview.homelike-sitebusinessreviews',
				'parent_content_id' => $right_id,
				'order' => 21,
				'params' => '{"title":"Most Liked Reviews","titleCount":"true"}',
		));
	}
}

?>