<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessreview
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessreview_Installer extends Engine_Package_Installer_Module {

  function onPreInstall() {

		$db = $this->getDb();

    //CHECK THAT SITEBUSINESS PLUGIN IS ACTIVATED OR NOT
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_settings')
            ->where('name = ?', 'sitebusiness.is.active')
            ->limit(1);
    $sitebusiness_settings = $select->query()->fetchAll();
    if (!empty($sitebusiness_settings)) {
      $sitebusiness_is_active = $sitebusiness_settings[0]['value'];
    } else {
      $sitebusiness_is_active = 0;
    }

    //CHECK THAT SITEBUSINESS PLUGIN IS INSTALLED OR NOT
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'sitebusiness')
            ->where('enabled = ?', 1);
    $check_sitebusiness = $select->query()->fetchObject();
    if (!empty($check_sitebusiness) && !empty($sitebusiness_is_active)) {

			$table_exist = $db->query('SHOW TABLES LIKE \'engine4_sitebusiness_businesses\'')->fetch();
			if(!empty($table_exist)) { 
				$column_exist = $db->query('SHOW COLUMNS FROM engine4_sitebusiness_businesses LIKE \'rating\'')->fetch();
				if(empty($column_exist)) {
					$db->query('ALTER TABLE  `engine4_sitebusiness_businesses` ADD  `rating` FLOAT NOT NULL DEFAULT  "0";');
				}
			}

      $PRODUCT_TYPE = 'sitebusinessreview';
      $PLUGIN_TITLE = 'Sitebusinessreview';
      $PLUGIN_VERSION = '5.4.1';
      $PLUGIN_CATEGORY = 'plugin';
      $PRODUCT_DESCRIPTION = 'Sitebusinessreview Plugin';
      $PRODUCT_TITLE = 'Directory / Businesses - Reviews and Ratings Extension';
      $_PRODUCT_FINAL_FILE = 0;
      $sitebusiness_plugin_version = '4.8.6';
      $SocialEngineAddOns_version = '4.8.9p12';
      $file_path = APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/ilicense.php";
      $is_file = file_exists($file_path);
      if (empty($is_file)) {
        include APPLICATION_PATH . "/application/modules/Sitebusiness/controllers/license/license4.php";
      } else {
        include $file_path;
      }


      $businessTime = time();
      $db->query("INSERT IGNORE INTO `engine4_core_settings` (`name`, `value`) VALUES
			('sitebusinessreview.basetime', $businessTime ),
			('sitebusinessreview.isvar', 0 ),
			('sitebusinessreview.filepath', 'Sitebusinessreview/controllers/license/license2.php');");
      parent::onPreInstall();
    } elseif (!empty($check_sitebusiness) && empty($sitebusiness_is_active)) {
      $baseUrl = $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getBaseUrl();
      $url_string = Zend_Controller_Front::getInstance()->getRequest()->getRequestUri();
      if (strstr($url_string, "manage/install")) {
        $calling_from = 'install';
      } else if (strstr($url_string, "manage/query")) {
        $calling_from = 'queary';
      }
      $explode_base_url = explode("/", $baseUrl);
      foreach ($explode_base_url as $url_key) {
        if ($url_key != 'install') {
          $core_final_url .= $url_key . '/';
        }
      }

      return $this->_error("<span style='color:red'>Note: You have installed the <a href='http://www.socialengineaddons.com/socialengine-directory-businesses-plugin' target='_blank'>Directory / Businesses Plugin</a> but not activated it on your site yet. Please activate it first before installing the Directory / Businesses - Reviews and Ratings Extension.</span><br/> <a href='" . 'http://' . $core_final_url . "admin/sitebusiness/settings/readme'>Click here</a> to activate the Directory / Businesses Plugin.");
    } else {
      $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();
      return $this->_error("<span style='color:red'>Note: You have not installed the <a href='http://www.socialengineaddons.com/socialengine-directory-businesses-plugin' target='_blank'>Directory / Businesses Plugin</a> on your site yet. Please install it first before installing the <a href='http://www.socialengineaddons.com/businessextensions/socialengine-directory-businesses-reviews-and-ratings' target='_blank'>Directory / Businesses - Reviews and Ratings Extension</a>.</span><br/> <a href='" . $base_url . "/manage'>Click here</a> to go Manage Packages.");
    }
  }


	function onInstall() {

    $db = $this->getDb();

		//CHECK THAT review_count COLUMN EXIST OR NOT IN BUSINESS TABLE
		$column_exist = $db->query("SHOW COLUMNS FROM engine4_sitebusiness_businesses LIKE 'review_count'")->fetch();
		$table_exist = $db->query("SHOW TABLES LIKE 'engine4_sitebusinessreview_reviews'")->fetch();
		if (!empty($table_exist)) {
			if(empty($column_exist)){
				//ADD review_count COLUMN TO BUSINESS TABLE
				$db->query("ALTER TABLE `engine4_sitebusiness_businesses` ADD `review_count` INT( 11 ) NOT NULL DEFAULT '0'  AFTER `like_count`");
			}

			$featuredColumn = $db->query("SHOW COLUMNS FROM engine4_sitebusinessreview_reviews LIKE 'featured'")->fetch();
			if(empty($featuredColumn)) {
				$db->query("ALTER TABLE `engine4_sitebusinessreview_reviews` ADD `featured` TINYINT( 2 ) NOT NULL DEFAULT '0'");
			}
		}
		
		//START THE WORK FOR MAKE WIDGETIZE BUSINESS OF REVIEWS LISTING AND REVIEW VIEW BUSINESS
    $select = new Zend_Db_Select($db);
		$select
						->from('engine4_core_modules')
						->where('name = ?', 'sitebusinessreview')
						->where('version < ?', '4.2.0');
		$is_enabled = $select->query()->fetchObject();
    if(!empty($is_enabled)){
			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_core_modules')
							->where('name = ?', 'communityad')
							->where('enabled 	 = ?', 1)
							->limit(1);
				;
			$infomation = $select->query()->fetch();
			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_core_settings')
							->where('name = ?', 'sitebusiness.communityads')
							->where('value 	 = ?', 1)
							->limit(1);
			$rowinfo = $select->query()->fetch();

			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_core_pages')
							->where('name = ?', 'sitebusinessreview_index_reviewlist')
							->limit(1);
			;
			$info = $select->query()->fetch();
			
      $select = new Zend_Db_Select($db);
			$select
							->from('engine4_core_pages')
							->where('name = ?', 'sitebusinessreview_index_browse')
							->limit(1);
			;
			$info_browse = $select->query()->fetch();

			if ( empty($info) && empty($info_browse) ) {
				$db->insert('engine4_core_pages', array(
						'name' => 'sitebusinessreview_index_browse',
						'displayname' => 'Browse Business Reviews',
						'title' => 'Business Reviews',
						'description' => 'This is the business reviews.',
						'custom' => 1,
				));
				$business_id = $db->lastInsertId('engine4_core_pages');

				//CONTAINERS
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'main',
						'parent_content_id' => Null,
						'order' => 2,
						'params' => '',
				));
				$container_id = $db->lastInsertId('engine4_core_content');

				//INSERT MAIN - MIDDLE CONTAINER
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $container_id,
						'order' => 6,
						'params' => '',
				));
				$middle_id = $db->lastInsertId('engine4_core_content');


				//INSERT MAIN - RIGHT CONTAINER
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'right',
						'parent_content_id' => $container_id,
						'order' => 5,
						'params' => '',
				));
				$right_id = $db->lastInsertId('engine4_core_content');


				//INSERT TOP CONTAINER
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'top',
						'parent_content_id' => Null,
						'order' => 1,
						'params' => '',
				));
				$top_id = $db->lastInsertId('engine4_core_content');


				//INSERT TOP- MIDDLE CONTAINER
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $top_id,
						'order' => 6,
						'params' => '',
				));
				$top_middle_id = $db->lastInsertId('engine4_core_content');


				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusiness.browsenevigation-sitebusiness',
						'parent_content_id' => $top_middle_id,
						'order' => 1,
						'params' => '{"title":"","titleCount":""}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessreview.search-sitebusinessreview',
						'parent_content_id' => $right_id,
						'order' => 3,
						'params' => '{"title":"","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessreview.sitebusiness-review',
						'parent_content_id' => $middle_id,
						'order' => 2,
						'params' => '{"title":"Reviews","titleCount":""}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessreview.featured-sitebusinessreviews',
						'parent_content_id' => $right_id,
						'order' => 4,
						'params' => '{"title":"Featured Reviews","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessreview.homecomment-sitebusinessreviews',
						'parent_content_id' => $right_id,
						'order' => 5,
						'params' => '{"title":"Most Commented Reviews","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessreview.site-popular-reviews',
						'parent_content_id' => $right_id,
						'order' => 6,
						'params' => '{"title":"Most Popular Reviews","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessreview.homelike-sitebusinessreviews',
						'parent_content_id' => $right_id,
						'order' => 7,
						'params' => '{"title":"Most Liked Reviews","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessreview.reviewer-sitebusinessreviews',
						'parent_content_id' => $right_id,
						'order' => 8,
						'params' => '{"title":"Top Reviewers","titleCount":"true"}',
				));


				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessreview.review-of-the-day',
						'parent_content_id' => $right_id,
						'order' => 9,
						'params' => '{"title":"Review of the Day","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
							'page_id' => $business_id,
							'type' => 'widget',
							'name' => 'sitebusinessreview.recent-sitebusinessreviews',
							'parent_content_id' => $right_id,
							'order' => 10,
							'params' => '{"title":"Recent Reviews","titleCount":"true"}',
					));

				if ( $infomation && $rowinfo ) {
					$db->insert('engine4_core_content', array(
							'page_id' => $business_id,
							'type' => 'widget',
							'name' => 'sitebusiness.business-ads',
							'parent_content_id' => $right_id,
							'order' => 11,
							'params' => '{"title":"","titleCount":""}',
					));
				}
			}
      else {
        $db->update('engine4_core_pages', array('name' => 'sitebusinessreview_index_browse'), array('name = ?' => 'sitebusinessreview_index_reviewlist'));
      }

			$db = $this->getDb();
			$select = new Zend_Db_Select($db);

			// Check if it's already been placed
			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_core_pages')
							->where('name = ?', 'sitebusinessreview_index_view')
							->limit(1);
			;
			$info = $select->query()->fetch();

			if ( empty($info) ) {
				$db->insert('engine4_core_pages', array(
						'name' => 'sitebusinessreview_index_view',
						'displayname' => 'Business Review View Page',
						'title' => 'View Business Review',
						'description' => 'This is the view business for a business review.',
						'custom' => 1,
						'provides' => 'subject=sitebusinessreview',
				));
				$business_id = $db->lastInsertId('engine4_core_pages');

				// containers
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'main',
						'parent_content_id' => null,
						'order' => 1,
						'params' => '',
				));
				$container_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'right',
						'parent_content_id' => $container_id,
						'order' => 1,
						'params' => '',
				));
				$right_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $container_id,
						'order' => 3,
						'params' => '',
				));
				$middle_id = $db->lastInsertId('engine4_core_content');

				// middle column content
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessreview.review-content',
						'parent_content_id' => $middle_id,
						'order' => 1,
						'params' => '',
				));

				// right column
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessreview.sitebusiness-review-detail',
						'parent_content_id' => $right_id,
						'order' => 1,
						'params' => '{"title":"Review Details"}',
				));

				if ( $infomation && $rowinfo ) {
					$db->insert('engine4_core_content', array(
							'page_id' => $business_id,
							'type' => 'widget',
							'name' => 'sitebusiness.business-ads',
							'parent_content_id' => $right_id,
							'order' => 2,
							'params' => '{"title":"","titleCount":""}',
					));
				}

			}

			$select = new Zend_Db_Select($db);
			$select
			->from('engine4_core_modules')
			->where('name = ?', 'mobi')
			->where('enabled 	 = ?', 1)
			->limit(1);
			;  

			$infomation = $select->query()->fetch();
			if(!empty($infomation)) {
				$select = new Zend_Db_Select($db);
				$select
				->from('engine4_core_pages')
				->where('name = ?', 'sitebusinessreview_mobi_view')
				->limit(1);
				;
				$info = $select->query()->fetch();
				if (empty($info)) {
					$db->insert('engine4_core_pages', array(
								'name' => 'sitebusinessreview_mobi_view',
								'displayname' => 'Mobile Business Review Profile',
								'title' => 'Mobile Business Review Profile',
								'description' => 'This is the mobile verison of a Business review profile business.',
								'custom' => 0,
					));
					$business_id = $db->lastInsertId('engine4_core_pages');

					// containers
					$db->insert('engine4_core_content', array(
								'page_id' => $business_id,
								'type' => 'container',
								'name' => 'main',
								'parent_content_id' => null,
								'order' => 1,
								'params' => '',
					));
					$container_id = $db->lastInsertId('engine4_core_content');

					$db->insert('engine4_core_content', array(
								'page_id' => $business_id,
								'type' => 'container',
								'name' => 'right',
								'parent_content_id' => $container_id,
								'order' => 1,
								'params' => '',
					));
					$right_id = $db->lastInsertId('engine4_core_content');

					$db->insert('engine4_core_content', array(
								'page_id' => $business_id,
								'type' => 'container',
								'name' => 'middle',
								'parent_content_id' => $container_id,
								'order' => 3,
								'params' => '',
					));
					$middle_id = $db->lastInsertId('engine4_core_content');

					// middle column content
					$db->insert('engine4_core_content', array(
							'page_id' => $business_id,
							'type' => 'widget',
							'name' => 'sitebusinessreview.review-content',
							'parent_content_id' => $middle_id,
							'order' => 1,
							'params' => '',
					));

					$db->insert('engine4_core_content', array(
							'page_id' => $business_id,
							'type' => 'widget',
							'name' => 'sitebusinessreview.sitebusiness-review-detail',
							'parent_content_id' => $right_id,
							'order' => 1,
							'params' => '{"title":"Review Details"}',
					));
				}
			}
    }

    $select = new Zend_Db_Select($db);
		$select
						->from('engine4_core_modules')
						->where('name = ?', 'sitebusinessreview')
						->where('version < ?', '4.2.1');
		$is_enabled = $select->query()->fetchObject();
    if($is_enabled) {
			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_core_pages')
							->where('name = ?', 'sitebusinessreview_index_home')
							->limit(1);
			$info = $select->query()->fetch();
			if (empty($info)) {
				$db->insert('engine4_core_pages', array(
						'name' => 'sitebusinessreview_index_home',
						'displayname' => 'Business Reviews Home',
						'title' => 'Business Reviews Home',
						'description' => 'This is business review home business.',
						'custom' => 1
				));
				$business_id = $db->lastInsertId('engine4_core_pages');

				// containers
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'main',
						'parent_content_id' => null,
						'order' => 2,
						'params' => '',
				));
				$container_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'right',
						'parent_content_id' => $container_id,
						'order' => 5,
						'params' => '',
				));
				$right_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'left',
						'parent_content_id' => $container_id,
						'order' => 4,
						'params' => '',
				));
				$left_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'top',
						'parent_content_id' => null,
						'order' => 1,
						'params' => '',
				));
				$top_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $top_id,
						'order' => 6,
						'params' => '',
				));
				$top_middle_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $container_id,
						'order' => 6,
						'params' => '',
				));
				$middle_id = $db->lastInsertId('engine4_core_content');

			// Top Middle
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusiness.browsenevigation-sitebusiness',
						'parent_content_id' => $top_middle_id,
						'order' => 3,
						'params' => '',
				));

				// Left
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessreview.recent-sitebusinessreviews',
						'parent_content_id' => $left_id,
						'order' => 16,
						'params' => '{"title":"Recent Reviews","titleCount":"true"}',
				));

				// Middle
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessreview.featured-reviews-slideshow',
						'parent_content_id' => $middle_id,
						'order' => 15,
						'params' => '{"title":"Featured Reviews","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusiness.category-businesss-sitebusiness',
						'parent_content_id' => $middle_id,
						'order' => 16,
						'params' => '{"title":"Most Reviewed this Month","titleCount":true,"itemCount":"6","businessCount":"3","popularity":"review_count","interval":"month","nomobile":"1"}',
				));


				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessreview.review-tabs',
						'parent_content_id' => $middle_id,
						'order' => 17,
						'params' => '{"title":"People\'s Reviews"}',
				));
				// Right Side
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessreview.sitebusinessreviewlist-link',
						'parent_content_id' => $right_id,
						'order' => 19,
						'params' => '',
				));

				// Right Side
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessreview.search-sitebusinessreview',
						'parent_content_id' => $right_id,
						'order' => 18,
						'params' => '',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessreview.review-of-the-day',
						'parent_content_id' => $left_id,
						'order' => 13,
						'params' => '{"title":"Review of the Day"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessreview.topratedbusinesses-sitebusinessreviews',
						'parent_content_id' => $left_id,
						'order' => 14,
						'params' => '{"title":"Top Rated Businesses","itemCountPerBusiness":3}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessreview.reviewer-sitebusinessreviews',
						'parent_content_id' => $left_id,
						'order' => 15,
						'params' => '{"title":"Top Reviewers","itemCountPerBusiness":3}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessreview.homecomment-sitebusinessreviews',
						'parent_content_id' => $right_id,
						'order' => 22,
						'params' => '{"title":"Most Commented Reviews","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessreview.homelike-sitebusinessreviews',
						'parent_content_id' => $right_id,
						'order' => 21,
						'params' => '{"title":"Most Liked Reviews","titleCount":"true"}',
				));
			}  
      $db->update('engine4_core_pages', array('displayname' => 'Browse Business Reviews'), array('displayname = ?' => 'Business Reviews')); 
    }
    //END THE WORK FOR MAKE WIDGETIZE BUSINESS OF REVIEWS LISTING AND REVIEW VIEW BUSINESS
    

		$select = new Zend_Db_Select($db);
		$select
				->from('engine4_core_modules')
				->where('name = ?', 'sitemobile')
				->where('enabled = ?', 1);
		$is_sitemobile_object = $select->query()->fetchObject();
		if($is_sitemobile_object)  {
			include APPLICATION_PATH . "/application/modules/Sitebusinessreview/controllers/license/mobileLayoutCreation.php";
		}
		$this->setActivityFeeds();
		parent::onInstall();
	}
  public function onPostInstall() {

    $db = $this->getDb();
		$select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'sitemobile')
            ->where('enabled = ?', 1);
    $is_sitemobile_object = $select->query()->fetchObject();
    if(!empty($is_sitemobile_object)) {
			$db->query("INSERT IGNORE INTO `engine4_sitemobile_modules` (`name`, `visibility`) VALUES ('sitebusinessreview','1')");
			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_sitemobile_modules')
							->where('name = ?', 'sitebusinessreview')
							->where('integrated = ?', 0);
			$is_sitemobile_object = $select->query()->fetchObject();
      if($is_sitemobile_object)  {
				$actionName = Zend_Controller_Front::getInstance()->getRequest()->getActionName();
				$controllerName = Zend_Controller_Front::getInstance()->getRequest()->getControllerName();
				if($controllerName == 'manage' && $actionName == 'install') {
          $view = new Zend_View();
					$baseUrl = ( !empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://':'http://') .  $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
					$redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
					$redirector->gotoUrl($baseUrl . 'admin/sitemobile/module/enable-mobile/enable_mobile/1/name/sitebusinessreview/integrated/0/redirect/install');
				} 
      }
    } 
    
    //Work for the word changes in the business plugin .csv file.
    $actionName = Zend_Controller_Front::getInstance()->getRequest()->getActionName();
    $controllerName = Zend_Controller_Front::getInstance()->getRequest()->getControllerName();
    if($controllerName == 'manage' && ($actionName == 'install' || $actionName == 'query')) {
      $view = new Zend_View();
      $baseUrl = ( !empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://':'http://') .  $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
      $redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
      if ($actionName == 'install') {
        $redirector->gotoUrl($baseUrl . 'admin/sitebusiness/settings/language/redirect/install');
      } else {
        $redirector->gotoUrl($baseUrl . 'admin/sitebusiness/settings/language/redirect/query');
      }
    }
    
  }

  public function setActivityFeeds() {
    $db = $this->getDb();
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'nestedcomment')
            ->where('enabled = ?', 1);
    $is_nestedcomment_object = $select->query()->fetchObject();
    if ($is_nestedcomment_object) {
        $db->query('INSERT IGNORE INTO `engine4_activity_actiontypes` (`type`, `module`, `body`, `enabled`, `displayable`, `attachable`, `commentable`, `shareable`, `is_generated`) VALUES ("nestedcomment_sitebusinessreview_review", "sitebusinessreview", \'{item:$subject} replied to a comment on {item:$owner}\'\'s business review {item:$object:$title}: {body:$body}\', 1, 1, 1, 1, 1, 1)');
    }
  }  
  
  
}
?>
