<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessurl
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 2011-11-15 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessurl_Installer extends Engine_Package_Installer_Module {

  function onInstall() {

    //GET DB
    $db = $this->getDb();
    //CHECK THAT SITEBUSINESS PLUGIN IS ACTIVATED OR NOT
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_settings')
            ->where('name = ?', 'sitebusiness.is.active')
            ->limit(1);
    $sitebusiness_settings = $select->query()->fetchAll();
    if (!empty($sitebusiness_settings)) {
      $sitebusiness_is_active = $sitebusiness_settings[0]['value'];
    } else {
      $sitebusiness_is_active = 0;
    }
    
    //CHECK THAT SITEBUSINESS PLUGIN IS INSTALLED OR NOT
    $modsitebussiness= $db->query("SELECT * FROM  `engine4_core_modules` WHERE  `name` LIKE  'sitebusiness'")->fetch();
    
    $minimumversion='4.2.1';
    if (!empty($modsitebussiness) && !empty($modsitebussiness['version'])) {
                $isModSupport = $this->checkVersion($modsitebussiness['version'], $minimumversion);
                if (empty($isModSupport)) {
                  $check_sitebusiness_version = 0;
                } else {
                  $check_sitebusiness_version = 1;
                }
    }       

    //CHECK THAT SITEBUSINESS PLUGIN IS INSTALLED OR NOT
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'sitebusiness')
            ->where('enabled = ?', 1);
    $check_sitebusiness = $select->query()->fetchObject();
    if (!empty($check_sitebusiness) && !empty($sitebusiness_is_active) && !empty($check_sitebusiness_version)) {

      parent::onInstall();

      $seocoreBannedUrlTable = $db->query('SHOW TABLES LIKE \'engine4_seaocore_bannedpageurls\'')->fetch();
			if (empty($seocoreBannedUrlTable)) {
				$db->query("CREATE TABLE IF NOT EXISTS `engine4_seaocore_bannedpageurls` (
								`bannedpageurl_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
								`word` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
								PRIMARY KEY (`bannedpageurl_id`),
								UNIQUE KEY `word` (`word`)
							) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;");
      }
      
      $table_url_exist = $db->query('SHOW TABLES LIKE \'engine4_sitepage_bannedpageurls\'')->fetch();
      if (!empty($table_url_exist)) {
        $db->query("RENAME TABLE `engine4_sitepage_bannedpageurls` TO `engine4_seaocore_bannedpageurls` ");
      }
			$table_exist = $db->query('SHOW TABLES LIKE \'engine4_seaocore_bannedpageurls\'')->fetch();
			if (empty($table_exist)) {
				$db->query("INSERT IGNORE INTO `engine4_seaocore_bannedpageurls` (`word`) VALUES
										('sitestaticbusiness'),('static'),('music'),('polls'),('blogs'),('videos'),	('classifieds'),('albums'),('events'),	('groups'),('group'),
										('forums'),('invite'),('recipeitems'),('ads'),	('likes'),('documents'),('sitepage'),
										('sitepagepoll'),('sitepageoffer'),('sitepagevideo'),('sitepagedocument'),('sitepagenote'),
										('sitepageevent'),('sitepagemusic'),('sitepageinvite'),('sitepagereview'),('sitepagebadge'),
									  ('sitepageform'),('sitepagealbum'),('sitepagediscussion'),('sitebusiness'),
										('sitebusinesspoll'),('sitebusinessoffer'),('sitebusinessvideo'),('sitebusinessdocument'),('sitebusinessnote'),
										('sitebusinessevent'),('sitebusinessmusic'),('sitebusinessinvite'),('sitebusinessreview'),('sitebusinessbadge'),
									  ('sitebusinessform'),('sitebusinessalbum'),('sitebusinessdiscussion'),('sitegroup'),
										('sitegrouppoll'),('sitegroupoffer'),('sitegroupvideo'),('sitegroupdocument'),('sitegroupnote'),
										('sitegroupevent'),('sitegroupmusic'),('sitegroupinvite'),('sitegroupreview'),('sitegroupbadge'),
									  ('sitegroupform'),('sitegroupalbum'),('sitegroupdiscussion'),('sitestore'),
										('sitestorepoll'),('sitestoreoffer'),('sitestorevideo'),('sitestoredocument'),('sitestorenote'),
										('sitestoreevent'),('sitestoremusic'),('sitestoreinvite'),('sitestorereview'),('sitestorebadge'),
									  ('sitestoreform'),('sitestorealbum'),('sitestorediscussion'),('recipe'),('sitelike'),('suggestion'),('advanceslideshow'),('feedback'),('grouppoll'),('groupdocumnet'),('sitealbum'),('siteslideshow'),('userconnection'),('communityad'),('list'),('article'),
										('listing'),('store'),('page-videos'),('pageitem'),('pageitems'),('page-events'),('page-documents'),('page-offers'),('page-notes'),('page-invites'),('page-form'),('page-music'),
										('page-reviews'),('businessitem'),('businessitems'),('business-events'),('business-documents'),('business-offers'),('business-notes'),('business-invites'),('business-form'),('business-music'),
										('business-reviews'),('group-videos'),('groupitem'),('groupitems'),('group-events'),('group-documents'),('group-offers'),('group-notes'),('group-invites'),('group-form'),('group-music'),('group-reviews'),('store-videos'),('storeitem'),('storeitems'),('store-events'),
									  ('store-documents'),('store-offers'),('store-notes'),('store-invites'),('store-form'),('store-music'),('store-reviews'),('listingitems'),('market'),('document'),('pdf'),('pokes'),('facebook'),('album'),('photo'),('files'),('file'),('page'),
									  ('store'),('backup'),('question'),('answer'),('questions'),('answers'),('newsfeed'),('birthday'),('wall'),('profiletype'),('memberlevel'),('members'),('member'),('memberlevel'),
					          ('level'),('slideshow'),('seo'),('xml'),('cmspages'),('favoritepages'),('help'),('rss'),
										('stories'),('story'),('visits'),('points'),('vote'),('advanced'),('listingitem');");
			}
 
      //CHECK THAT SITEBUSINESS PLUGIN IS INSTALLED OR NOT
			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_core_modules')
							->where('name = ?', 'sitebusinessurl')
							->where('enabled = ?', 1);
			$check_sitebusinessurl = $select->query()->fetchObject();
      if(empty($check_sitebusinessurl)) {
				$includeModules = array("sitepage" => "sitepage","sitepagedocument" => 'Documents', "sitepageoffer" => 'Offers', "sitepageform" => "Form", "sitepagediscussion" => "Discussions", "sitepagenote" => "Notes", "sitepagealbum" => "Photos", "sitepagevideo" => "Videos", "sitepageevent" => "Events", "sitepagepoll" => "Polls", "sitepageinvite" => "Invite & Promote", "sitepagebadge" => "Badges", "sitepagelikebox" => "External Badge", "sitepagemusic" => "Music","sitegroup" => "sitegroup","sitegroupdocument" => 'Documents', "sitegroupoffer" => 'Offers', "sitegroupform" => "Form", "sitegroupdiscussion" => "Discussions", "sitegroupnote" => "Notes", "sitegroupalbum" => "Photos", "sitegroupvideo" => "Videos", "sitegroupevent" => "Events", "sitegrouppoll" => "Polls", "sitegroupinvite" => "Invite & Promote", "sitegroupbadge" => "Badges", "sitegrouplikebox" => "External Badge", "sitegroupmusic" => "Music","sitestore" => "sitestore","sitestoredocument" => 'Documents', "sitestoreoffer" => 'Offers', "sitestoreform" => "Form", "sitestorediscussion" => "Discussions","sitestorenote" => "Notes", "sitestorealbum" => "Photos", "sitestorevideo" => "Videos", "sitestoreevent" => "Events", "sitestorepoll" => "Polls", "sitestoreinvite" => "Invite & Promote", "sitestorebadge" => "Badges", "sitestorelikebox" => "External Badge", "sitestoremusic" => "Music","sitebusiness" => "sitebusiness","sitebusinessdocument" => 'Documents', "sitebusinessoffer" => 'Offers', "sitebusinessform" => "Form","sitebusinessdiscussion" => "Discussions", "sitebusinessnote" => "Notes", "sitebusinessalbum" => "Photos", "sitebusinessvideo" => "Videos", "sitebusinessevent" => "Events", "sitebusinesspoll" => "Polls", "sitebusinessinvite" => "Invite & Promote", "sitebusinessbadge" => "Badges", "sitebusinesslikebox" => "External Badge", "sitebusinessmusic" => "Music","list"=>"list");
				$select = new Zend_Db_Select($db);
				$select
								->from('engine4_core_modules','name')
								->where('enabled = ?', 1);
				$enableAllModules = $select->query()->fetchAll(Zend_Db::FETCH_COLUMN);
				$enableModules = array_intersect(array_keys($includeModules), $enableAllModules);
		
				foreach ($enableAllModules as $moduleName) {
					if(!in_array($moduleName,$enableModules)) {
						$file_path = APPLICATION_PATH . "/application/modules/" . ucfirst($moduleName) . "/settings/manifest.php";
						$contentItem = array();
						if (@file_exists($file_path)) {
							$ret = include $file_path;
							$is_exist = array();
							if (isset($ret['routes'])) {
								foreach ($ret['routes'] as $item) {
									$route = $item['route'];
									$route_array =  explode('/',$route);
									$route_url = strtolower($route_array[0]);
									
									if(!empty($route_url) && !in_array($route_url,$is_exist)) {
										$db->query("INSERT IGNORE INTO `engine4_seaocore_bannedpageurls` (`word`) VALUES ('".$route_url. "')");
									}
									$is_exist[] = $route_url;
								}
							}
						} 
					}
					else {
						if($moduleName == 'sitepage' || $moduleName == 'sitebusiness' || $moduleName == 'sitegroup' || $moduleName == 'sitestore') {
							$name = $moduleName .'.manifestUrlS';
						}
						else {
							$name = $moduleName .'.manifestUrl';
						}
						$select = new Zend_Db_Select($db);
						$select
								->from('engine4_core_settings','value')
								->where('name = ?', $name)
								->limit(1);
						$route_url = strtolower($select->query()->fetchAll(Zend_Db::FETCH_COLUMN));
						if(!empty($route_url)) {
							$db->query("INSERT IGNORE INTO `engine4_seaocore_bannedpageurls` (`bannedpageurl_id`, `word`) VALUES ('','".$route_url. "')");
						}
					}
				}
      }
    } 
   if(!empty($check_sitebusiness) && !empty($sitebusiness_is_active) && empty($check_sitebusiness_version)) {

      $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();
      return $this->_error("<span style='color:red'>Note: The version of the Directory / Businesses Plugin on your website is less than the minimum required version: ".$minimumversion.". Please download the latest version of this  plugin from your Client Area on SocialEngineAddOns and upgrade it on your website.
</span>");

    }
    elseif (!empty($check_sitebusiness) && empty($sitebusiness_is_active)) {
      $baseUrl = $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getBaseUrl();
      $url_string = Zend_Controller_Front::getInstance()->getRequest()->getRequestUri();
      if (strstr($url_string, "manage/install")) {
        $calling_from = 'install';
      } else if (strstr($url_string, "manage/query")) {
        $calling_from = 'queary';
      }
      $explode_base_url = explode("/", $baseUrl);
      foreach ($explode_base_url as $url_key) {
        if ($url_key != 'install') {
          $core_final_url .= $url_key . '/';
        }
      }

      return $this->_error("<span style='color:red'>Note: You have installed the <a href='http://www.socialengineaddons.com/socialengine-directory-businesses-plugin' target='_blank'>Directory / Businesses Plugin</a> but not activated it on your site yet. Please activate it first before installing the Directory / Businesses - Short Page URL Extension.</span><br/> <a href='" . 'http://' . $core_final_url . "admin/sitebusiness/settings/readme'>Click here</a> to activate the Directory / Businesses Plugin.");
    } elseif(empty($check_sitebusiness)) {
      $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();
      return $this->_error("<span style='color:red'>Note: You have not installed the <a href='http://www.socialengineaddons.com/socialengine-directory-businesses-plugin' target='_blank'>Directory / Businesses Plugin</a> on your site yet. Please install it first before installing the <a href='http://www.socialengineaddons.com/businessextensions/socialengine-directory-businesses-short-business-url-extension' target='_blank'>Directory / Businesses - Short Page URL Extension</a>.</span><br/> <a href='" . $base_url . "/manage'>Click here</a> to go Manage Packages.");
    }
    
    //BANNED URL WORK IF SITEREVIEW PLUGIN IS ALREADY EXIST
    $this->bannedUrlWork();    
  }
  
  //RUN THIS CODE ON FIRST TIME INSTALLATION OF BUSINESS URL PLUGIN
  function bannedUrlWork() {
    
    //GET DB
    $db = $this->getDb();

    $bannedpageurlsTableExist = $db->query('SHOW TABLES LIKE \'engine4_seaocore_bannedpageurls\'')->fetch();
    $listingtypeTableExist = $db->query('SHOW TABLES LIKE \'engine4_sitereview_listingtypes\'')->fetch();
    $select = new Zend_Db_Select($db);
    $isActivate = $select->from('engine4_core_settings', 'name')
                                    ->where('name = ?', 'sitebusinessurl.is.enable')
                                    ->where('value = ?', 1)
                                    ->query()
                                    ->fetchColumn();
    $select = new Zend_Db_Select($db);
    $select->from('engine4_core_modules', 'name')
            ->where('name = ?', 'sitebusinessurl')
            ->query()
            ->fetchcolumn();
    $isSitebusinessurlenabled = $select->query()->fetchObject();

    if (!empty($bannedpageurlsTableExist) && !empty($listingtypeTableExist) && !empty($isActivate) && !empty($isSitebusinessurlenabled)) {
      $select = new Zend_Db_Select($db);
      $select->from('engine4_sitereview_listingtypes', array('slug_singular', 'slug_plural'));
      $listingTypeDatas = $select->query()->fetchAll();
      foreach($listingTypeDatas as $listingTypeData) {
        
				$urls = array("$listingTypeData->slug_plural","$listingTypeData->slug_singular");
				
				foreach($urls as $url) {

					$bannedWordsNew = preg_split('/\s*[,\n]+\s*/', $url);
				
					$words = array_map('strtolower', array_filter(array_values($bannedWordsNew)));

          $select = new Zend_Db_Select($db);
					$data = $select->from('engine4_seaocore_bannedpageurls', 'word')
                        ->query()
                        ->fetchAll(Zend_Db::FETCH_COLUMN);
																			
					if(in_array($words[0],$data)) {
						return;
					}
          
          $words = array_map('strtolower', array_filter(array_values($words)));

          $select = new Zend_Db_Select($db);
          $data = $select
              ->from('engine4_seaocore_bannedpageurls', 'word')
              ->query()
              ->fetchAll(Zend_Db::FETCH_COLUMN);

          $newWords = array_diff($words, $data);
          foreach( $newWords as $newWord ) {
            $db->insert('engine4_seaocore_bannedpageurls', array(
              'word' => $newWord,
            ));
          }
				}        
      }
    }    
  }  
  public function onPostInstall() {
  
		//Work for the word changes in the business plugin .csv file.
		$actionName = Zend_Controller_Front::getInstance()->getRequest()->getActionName();
		$controllerName = Zend_Controller_Front::getInstance()->getRequest()->getControllerName();
		if($controllerName == 'manage' && ($actionName == 'install' || $actionName == 'query')) {
			$view = new Zend_View();
			$baseUrl = ( !empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://':'http://') .  $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
			$redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
			if ($actionName == 'install') {
				$redirector->gotoUrl($baseUrl . 'admin/sitebusiness/settings/language/redirect/install');
			} else {
				$redirector->gotoUrl($baseUrl . 'admin/sitebusiness/settings/language/redirect/query');
			}
		}
  }
    function checkVersion($databaseVersion, $checkDependancyVersion) {
        if (strcasecmp($databaseVersion, $checkDependancyVersion) == 0)
            return -1;
        $databaseVersionArr = explode(".", $databaseVersion);
        $checkDependancyVersionArr = explode('.', $checkDependancyVersion);
        $fValueCount = $count = count($databaseVersionArr);
        $sValueCount = count($checkDependancyVersionArr);
        if ($fValueCount > $sValueCount)
            $count = $sValueCount;
        for ($i = 0; $i < $count; $i++) {
            $fValue = $databaseVersionArr[$i];
            $sValue = $checkDependancyVersionArr[$i];
            if (is_numeric($fValue) && is_numeric($sValue)) {
                $result = $this->compareValues($fValue, $sValue);
                if ($result == -1) {
                    if (($i + 1) == $count) {
                        return $this->compareValues($fValueCount, $sValueCount);
                    } else
                        continue;
                }
                return $result;
            }
            elseif (is_string($fValue) && is_numeric($sValue)) {
                $fsArr = explode("p", $fValue);
                $result = $this->compareValues($fsArr[0], $sValue);
                return $result == -1 ? 1 : $result;
            } elseif (is_numeric($fValue) && is_string($sValue)) {
                $ssArr = explode("p", $sValue);
                $result = $this->compareValues($fValue, $ssArr[0]);
                return $result == -1 ? 0 : $result;
            } elseif (is_string($fValue) && is_string($sValue)) {
                $fsArr = explode("p", $fValue);
                $ssArr = explode("p", $sValue);
                $result = $this->compareValues($fsArr[0], $ssArr[0]);
                if ($result != -1)
                    return $result;
                $result = $this->compareValues($fsArr[1], $ssArr[1]);
                return $result;
            }
        }
    }

    public function compareValues($firstVal, $secondVal) {
        $num = $firstVal - $secondVal;
        return ($num > 0) ? 1 : ($num < 0 ? 0 : -1);
    }
}

?>
