<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessvideo
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Widget.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessvideo_Form_Admin_Widget extends Engine_Form {

  public function init() {
    $this
            ->setTitle('Widget Settings')
            ->setDescription('Configure the general settings for the various widgets available with this plugin.');

    $this->addElement('Text', 'sitebusinessvideo_comment_widgets', array(
        'label' => 'Business Profile Most Commented Videos',
        'maxlength' => '3',
        'description' => 'How many videos will be shown in the business profile most commented videos widget (value can not be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessvideo.comment.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'sitebusinessvideo_recent_widgets', array(
        'label' => 'Business Profile Most Recent Videos',
        'maxlength' => '3',
        'description' => 'How many videos should be shown in the business profile most recent videos widget (value cannot be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessvideo.recent.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'sitebusinessvideo_like_widgets', array(
        'label' => 'Business Profile Most Liked Videos',
        'maxlength' => '3',
        'description' => 'How many videos should be shown in the business profile most liked videos widget (value cannot be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessvideo.like.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'sitebusinessvideo_view_widgets', array(
        'label' => 'Business Profile Most Viewed Videos',
        'maxlength' => '3',
        'description' => 'How many videos will be shown in the business profile most viewed videos widget (value can not be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessvideo.view.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'sitebusinessvideo_rate_widgets', array(
        'label' => 'Business Profile Top Rated Videos',
        'maxlength' => '3',
        'description' => 'How many videos should be shown in the business profile top rated videos widget (value cannot be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessvideo.rate.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'sitebusinessvideo_featured_widgets', array(
        'label' => 'Business Profile Featured Videos',
        'maxlength' => '3',
        'description' => 'How many videos should be shown in the business profile featured videos widget (value cannot be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessvideo.featured.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'sitebusinessvideo_homerecentvideos_widgets', array(
        'label' => 'Recent Videos',
        'maxlength' => '3',
        'description' => 'How many videos should be shown in the recent videos widget (value cannot be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessvideo.homerecentvideos.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Button', 'submit', array(
        'label' => 'Save Changes',
        'type' => 'submit',
        'ignore' => true
    ));
  }

}
?>