<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessvideo
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: manifest.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$routeStart = "businessvideos";
$module = null;
$controller = null;
$action = null;
$getURL = null;
$request = Zend_Controller_Front::getInstance()->getRequest();
if (!empty($request)) {
  $module = $request->getModuleName(); // Return the current module name.
  $action = $request->getActionName();
  $controller = $request->getControllerName();
  $getURL = $request->getRequestUri();
}
if (empty($request) || !($module == "default" && ( strpos( $getURL, '/install') !== false))) {
  $routeStart = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessvideo.manifestUrl', "business-videos");
}
return array(
    // Package -------------------------------------------------------------------
    'package' => array(
        'type' => 'module',
        'name' => 'sitebusinessvideo',
        'version' => '5.6.1',
        'path' => 'application/modules/Sitebusinessvideo',
        'repository' => 'null',
        'title' => 'Directory / Businesses - Videos Extension',
        'description' => 'Directory / Businesses - Videos Extension',
      'author' => '<a href="http://www.socialapps.tech" style="text-decoration:underline;" target="_blank">SocialApps.tech</a>',
        'date' => 'Thrusday, 05 May 2011 18:33:08 +0000',
        'copyright' => 'Copyright 2010-2011 BigStep Technologies Pvt. Ltd.',
        'actions' => array(
            'install',
            'upgrade',
            'refresh',
            'enable',
            'disable',
        ),
        'callback' => array(
            'path' => 'application/modules/Sitebusinessvideo/settings/install.php',
            'class' => 'Sitebusinessvideo_Installer',
        ),
        'directories' => array(
            'application/modules/Sitebusinessvideo',
        ),
        'files' => array(
            'application/languages/en/sitebusinessvideo.csv',
        ),
    ),
    // hooks
    'hooks' => array(
        array(
            'event' => 'onUserDeleteBefore',
            'resource' => 'Sitebusinessvideo_Plugin_Core',
        )
    ),
    // Compose
    'composer' => array(
        'sitebusinessvideo' => array(
            'script' => array('_composeSitebusinessVideo.tpl', 'sitebusinessvideo'),
            'plugin' => 'Sitebusinessvideo_Plugin_Composer',
            'auth' => array('sitebusiness_business', 'svcreate'),
        ),
    ),
    'sitemobile_compatible' => true,
    // Items ---------------------------------------------------------------------
    'items' => array(
        'sitebusinessvideo_video'
    ),
    // Routes --------------------------------------------------------------------
    'routes' => array(
        'sitebusinessvideo_general' => array(
            'route' => $routeStart . '/:action/*',
            'defaults' => array(
                'module' => 'sitebusinessvideo',
                'controller' => 'index',
                'action' => 'view',
            ),
            'reqs' => array(
                'action' => '(index|create)',
            )
        ),
        'sitebusinessvideo_create' => array(
            'route' => $routeStart . '/create/:business_id/*',
            'defaults' => array(
                'module' => 'sitebusinessvideo',
                'controller' => 'index',
                'action' => 'create'
            ),
            'reqs' => array(
                'business_id' => '\d+'
            )
        ),
        'sitebusinessvideo_edit' => array(
            'route' => $routeStart . '/edit/:video_id/*',
            'defaults' => array(
                'module' => 'sitebusinessvideo',
                'controller' => 'index',
                'action' => 'edit'
            )
        ),
        'sitebusinessvideoadmin_delete' => array(
            'route' => $routeStart . '/admin/delete/:video_id/:business_id/*',
            'defaults' => array(
                'module' => 'sitebusinessvideo',
                'controller' => 'admin-manage',
                'action' => 'delete'
            ),
            'reqs' => array(
                'video_id' => '\d+',
                'business_id' => '\d+'
            )
        ),
        'sitebusinessvideo_delete' => array(
            'route' => $routeStart . '/delete/:video_id/:business_id/*',
            'defaults' => array(
                'module' => 'sitebusinessvideo',
                'controller' => 'index',
                'action' => 'delete'
            ),
            'reqs' => array(
                'video_id' => '\d+',
                'business_id' => '\d+'
            )
        ),
        'sitebusinessvideo_view' => array(
            'route' => $routeStart . '/:user_id/:video_id/:slug/*',
            'defaults' => array(
                'module' => 'sitebusinessvideo',
                'controller' => 'index',
                'action' => 'view',
                'slug' => '',
            ),
            'reqs' => array(
                'user_id' => '\d+'
            )
        ),
        'sitebusinessvideo_featured' => array(
            'route' => $routeStart . '/featured/:video_id/*',
            'defaults' => array(
                'module' => 'sitebusinessvideo',
                'controller' => 'index',
                'action' => 'featured'
            ),
            'reqs' => array(
                'video_id' => '\d+'
            )
        ),
        'sitebusinessvideo_highlighted' => array(
            'route' => $routeStart . '/highlighted/:video_id/*',
            'defaults' => array(
                'module' => 'sitebusinessvideo',
                'controller' => 'index',
                'action' => 'highlighted'
            ),
            'reqs' => array(
                'video_id' => '\d+'
            )
        ), 

         'sitebusinessvideo_browse' => array(
            'route' => $routeStart.'/browse/*',
            'defaults' => array(
                'module' => 'sitebusinessvideo',
                'controller' => 'index',
                'action' => 'browse',
            ),
        ),

         'sitebusinessvideo_home' => array(
            'route' => $routeStart.'/home/*',
            'defaults' => array(
                'module' => 'sitebusinessvideo',
                'controller' => 'index',
                'action' => 'home',
            ),
        ), 

        'sitebusinessvideo_featuredvideo' => array(
            'route' => $routeStart .'/admin/featuredvideo/:id/*',
            'defaults' => array(
                'module' => 'sitebusinessvideo',
                'controller' => 'admin-manage',
                'action' => 'featuredvideo',
            ),
            'reqs' => array(
                'id' => '\d+'
            )
        ),
        'sitebusinessvideo_highlightedvideo' => array(
            'route' => $routeStart .'/admin/highlightedvideo/:id/*',
            'defaults' => array(
                'module' => 'sitebusinessvideo',
                'controller' => 'admin-manage',
                'action' => 'highlightedvideo',
            ),
            'reqs' => array(
                'id' => '\d+'
            )
        ),

         'sitebusinessvideo_tags' => array(
            'route' => $routeStart . '/tagscloud/:business/',
            'defaults' => array(
                'module' => 'sitebusinessvideo',
                'controller' => 'index',
                'action' => 'tags-cloud',
                'business' => 1
            )
        ),
    )
)
?>
