<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessvideo
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessvideo_Widget_VideoContentController extends Seaocore_Content_Widget_Abstract {

  public function indexAction() {

     $this->_mobileAppFile = true;
     //GET VIDEO ID AND OBJECT
    $video_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('video_id', $this->_getParam('video_id', null));
    $sitebusinessvideo = Engine_Api::_()->getItem('sitebusinessvideo_video', $video_id);

    if (empty($sitebusinessvideo)) {
      return $this->setNoRender();
    }

    //GET TAB ID
    $this->view->tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab');

    $getPackagevideoView = Engine_Api::_()->sitebusiness()->getPackageAuthInfo('sitebusinessvideo');

    //GET VIEWER INFO
    $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewer_id = $viewer->getIdentity();

    //IF THIS IS SENDING A MESSAGE ID, THE USER IS BEING DIRECTED FROM A CONVERSATION
    //CHECK IF MEMBER IS PART OF THE CONVERSATION
    $message_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('message');
    $message_view = false;
    if ($message_id) {
      $conversation = Engine_Api::_()->getItem('messages_conversation', $message_id);
      if ($conversation->hasRecipient(Engine_Api::_()->user()->getViewer()))
        $message_view = true;
    }
    $this->view->message_view = $message_view;

    //SET SITEBUSINESS SUBJECT
    $this->view->sitebusiness = $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $sitebusinessvideo->business_id);

    //PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessvideo")) {
        return $this->setNoRender();
      }
    } else {
      $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'svcreate');
      if (empty($isBusinessOwnerAllow)) {
        return $this->setNoRender();
      }
    }
    //PACKAGE BASE PRIYACY END
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'svcreate');
    if (empty($isManageAdmin)) {
      $this->view->can_create = 0;
    } else {
      $this->view->can_create = 1;
    }
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'view');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }

     //MAKE HIGHLIGHTED OR NOT
    $this->view->canMakeHighlighted = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessvideo.featured', 1);

    $this->view->allowView = false;
    if (!empty($viewer_id) && $viewer->level_id == 1) {
      $auth = Engine_Api::_()->authorization()->context;
      $this->view->allowView = $auth->isAllowed($sitebusiness, 'everyone', 'view') === 1 ? true : false ||$auth->isAllowed($sitebusiness, 'registered', 'view') === 1 ? true : false;
    } 

    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'comment');
    if (empty($isManageAdmin)) {
      $this->view->can_comment = 0;
    } else {
      $this->view->can_comment = 1;
    }

    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = $this->view->can_edit = 0;
    } else {
      $can_edit = $this->view->can_edit = 1;
    }

    if ($viewer_id != $sitebusinessvideo->owner_id && $can_edit != 1 && ($sitebusinessvideo->status != 1 || $sitebusinessvideo->search != 1) || empty($getPackagevideoView)) {
      return $this->setNoRender();
    }
    //END MANAGE-ADMIN CHECK
    //GET VIDEO TAGS
    $this->view->videoTags = $sitebusinessvideo->tags()->getTagMaps();

    //CHECK IF EMBEDDING IS ALLOWED
    $can_embed = true;
    if (!Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessvideo.embeds', 1)) {
      $can_embed = false;
    } else if (isset($sitebusinessvideo->allow_embed) && !$sitebusinessvideo->allow_embed) {
      $can_embed = false;
    }
    $this->view->can_embed = $can_embed;

    $this->view->videoEmbedded = $embedded = "";

      //INCREMENT IN NUMBER OF VIEWS
      $owner = $sitebusinessvideo->getOwner();
      if (!$owner->isSelf($viewer)) {
        $sitebusinessvideo->view_count++;
      }

      $sitebusinessvideo->save();
      if ($sitebusinessvideo->type != 3) {
				$this->view->videoEmbedded = $embedded = $sitebusinessvideo->getRichContent(true);
      }

    //SET BUSINESS-VIDEO SUBJECT
    if (Engine_Api::_()->core()->hasSubject()) {
      Engine_Api::_()->core()->clearSubject();
    }
    Engine_Api::_()->core()->setSubject($sitebusinessvideo);

    //VIDEO FROM MY COMPUTER WORK
    if ($sitebusinessvideo->type == 3 && $sitebusinessvideo->status != 0) {
      $sitebusinessvideo->save();

      if (!empty($sitebusinessvideo->file_id)) {
        $storage_file = Engine_Api::_()->getItem('storage_file', $sitebusinessvideo->file_id);
        if ($storage_file) {
          $this->view->video_location = $storage_file->map();
          $this->view->video_extension = $storage_file->extension;
        }
      }
    }

    $this->view->rating_count = Engine_Api::_()->getDbTable('ratings', 'sitebusinessvideo')->ratingCount($sitebusinessvideo->getIdentity());
    $this->view->video = empty($getPackagevideoView) ? null : $sitebusinessvideo;
    $this->view->rated = Engine_Api::_()->getDbTable('ratings', 'sitebusinessvideo')->checkRated($sitebusinessvideo->getIdentity(), $viewer->getIdentity());

    //TAG WORK
    $this->view->limit_sitebusinessvideo = $total_sitebusinessvideos = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessvideo.tag.limit', 3);
    
    //VIDEO TABLE
    $videoTable = Engine_Api::_()->getDbtable('videos', 'sitebusinessvideo');

    //TOTAL VIDEO COUNT FOR THIS BUSINESS
    $this->view->count_video = $videoTable->getBusinessVideoCount($sitebusinessvideo->business_id);

    // Start: "Suggest to Friends" link work.
    $business_flag = 0;
    $is_suggestion_enabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('suggestion');
    $is_moduleEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusiness');
    $isSupport = Engine_Api::_()->getApi('suggestion', 'sitebusiness')->isSupport();
    if (!empty($is_suggestion_enabled)) {
      // Here we are delete this video suggestion if viewer have.
      if (!empty($is_moduleEnabled)) {
        Engine_Api::_()->getApi('suggestion', 'sitebusiness')->deleteSuggestion($viewer_id, 'business_video', Zend_Controller_Front::getInstance()->getRequest()->getParam('video_id'), 'business_video_suggestion');
      }

      $SuggVersion = Engine_Api::_()->getDbtable('modules', 'core')->getModule('suggestion')->version;
      $versionStatus = strcasecmp($SuggVersion, '4.1.7p1');
      if ($versionStatus >= 0) {
        $modContentObj = Engine_Api::_()->suggestion()->getSuggestedFriend('sitebusinessvideo', Zend_Controller_Front::getInstance()->getRequest()->getParam('video_id'), 1,null);
        if (!empty($modContentObj)) {
          $contentCreatePopup = @COUNT($modContentObj);
        }
      }

      if (Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.package.enable', 1)) {
        if ($sitebusiness->expiration_date <= date("Y-m-d H:i:s")) {
          $business_flag = 1;
        }
      }
      if (!empty($contentCreatePopup) && !empty($isSupport) && empty($sitebusiness->closed) && !empty($sitebusiness->approved) && empty($sitebusiness->declined) && !empty($sitebusiness->draft) && empty($business_flag) && !empty($viewer_id) && !empty($is_suggestion_enabled)) {
        $this->view->videoSuggLink = Engine_Api::_()->suggestion()->getModSettings('sitebusiness', 'video_sugg_link');
      }
      // End: "Suggest to Friends" link work.
    }
  }

}
?>