<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecitycontent
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 6590 2015-01-25 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitecitycontent_Installer extends Engine_Package_Installer_Module {

    function onPreinstall() {
        $db = $this->getDb();

        // CHECK THAT AT LEAST ONE PLUGIN SHOULD BE INSTALLED ON THE SITE.
        $getErrorMsg = $this->_isPluginsExist($db);
        if (!empty($getErrorMsg)) {
            return $this->_error($getErrorMsg);
        }

        $PRODUCT_TYPE = 'sitecitycontent';
        $PLUGIN_TITLE = 'Sitecitycontent';
        $PLUGIN_VERSION = '5.4.1';
        $PLUGIN_CATEGORY = 'plugin';
        $PRODUCT_DESCRIPTION = 'Script for configuring SocialEngine website with SocialEngineAddOns Plugins to a Location based / City specific website';
        $PRODUCT_TITLE = 'Script for configuring SocialEngine website with SocialEngineAddOns Plugins to a Location based / City specific website';
        $_PRODUCT_FINAL_FILE = 0;
        $SocialEngineAddOns_version = '4.8.7p16';
        $file_path = APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/ilicense.php";
        $is_file = file_exists($file_path);
        if (empty($is_file)) {
            include APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/license3.php";
        } else {
            $db = $this->getDb();
            $select = new Zend_Db_Select($db);
            $select->from('engine4_core_modules')->where('name = ?', $PRODUCT_TYPE);
            $is_Mod = $select->query()->fetchObject();
            if (empty($is_Mod)) {
                include_once $file_path;
            }
        }

        parent::onPreinstall();
    }

    public function onInstall() {
        
        $db = $this->getDb();
        
        $db->query("UPDATE  `engine4_seaocores` SET  `is_activate` =  '1' WHERE  `engine4_seaocores`.`module_name` ='sitecitycontent';");

        $locationTable = $db->query('SHOW TABLES LIKE \'engine4_seaocore_locationcontents\'')->fetch();
        if (empty($locationTable)) {
            $db->query("
                CREATE TABLE IF NOT EXISTS `engine4_seaocore_locationcontents` (
                  `locationcontent_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
                  `title` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
                  `location` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
                  `latitude` double NOT NULL,
                  `longitude` double NOT NULL,              
                  `status` tinyint(1) NOT NULL DEFAULT '1',
                    `formatted_address` text COLLATE utf8_unicode_ci,
                    `country` varchar(128) COLLATE utf8_unicode_ci DEFAULT NULL,
                    `state` varchar(128) COLLATE utf8_unicode_ci DEFAULT NULL,
                    `zipcode` varchar(32) COLLATE utf8_unicode_ci DEFAULT NULL,
                    `city` varchar(128) COLLATE utf8_unicode_ci DEFAULT NULL,
                    `address` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,                  
                  PRIMARY KEY (`locationcontent_id`)
                ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;      
            ");
        } else {

            $latitude = $db->query("SHOW COLUMNS FROM engine4_seaocore_locationcontents LIKE 'latitude'")->fetch();
            if (empty($latitude)) {
                $db->query("ALTER TABLE `engine4_seaocore_locationcontents` ADD `latitude` double NOT NULL");
            }

            $longitude = $db->query("SHOW COLUMNS FROM engine4_seaocore_locationcontents LIKE 'longitude'")->fetch();
            if (empty($longitude)) {
                $db->query("ALTER TABLE `engine4_seaocore_locationcontents` ADD `longitude` double NOT NULL");
            }

            $formattedAddress = $db->query("SHOW COLUMNS FROM engine4_seaocore_locationcontents LIKE 'formatted_address'")->fetch();
            if (empty($formattedAddress)) {
                $db->query("ALTER TABLE `engine4_seaocore_locationcontents` ADD `formatted_address` TEXT CHARACTER SET utf8 COLLATE utf8_unicode_ci");
            }

            $country = $db->query("SHOW COLUMNS FROM engine4_seaocore_locationcontents LIKE 'country'")->fetch();
            if (empty($country)) {
                $db->query("ALTER TABLE `engine4_seaocore_locationcontents` ADD `country` VARCHAR( 128 ) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL");
            }

            $state = $db->query("SHOW COLUMNS FROM engine4_seaocore_locationcontents LIKE 'state'")->fetch();
            if (empty($state)) {
                $db->query("ALTER TABLE `engine4_seaocore_locationcontents` ADD `state` VARCHAR( 128 ) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL");
            }

            $zipCode = $db->query("SHOW COLUMNS FROM engine4_seaocore_locationcontents LIKE 'zipcode'")->fetch();
            if (empty($zipCode)) {
                $db->query("ALTER TABLE `engine4_seaocore_locationcontents` ADD `zipcode` VARCHAR( 32 ) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL");
            }

            $city = $db->query("SHOW COLUMNS FROM engine4_seaocore_locationcontents LIKE 'city'")->fetch();
            if (empty($city)) {
                $db->query("ALTER TABLE `engine4_seaocore_locationcontents` ADD `city` VARCHAR( 128 ) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL");
            }

            $address = $db->query("SHOW COLUMNS FROM engine4_seaocore_locationcontents LIKE 'address'")->fetch();
            if (empty($address)) {
                $db->query("ALTER TABLE `engine4_seaocore_locationcontents` ADD `address` VARCHAR( 128 ) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL");
            }
        }

        parent::onInstall();
    }

    private function _isPluginsExist($db) {
        $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();

        $modArray = array(
            'sitealbum' => array(
                'title' => 'Advanced Photo Albums',
                'url' => 'http://www.socialengineaddons.com/socialengine-advanced-photo-albums-plugin'
            ),
            'siteevent' => array(
                'title' => 'Advanced Events Plugin',
                'url' => 'http://www.socialengineaddons.com/socialengine-advanced-events-plugin'
            ),
            'sitepage' => array(
                'title' => 'Directory / Pages',
                'url' => 'http://www.socialengineaddons.com/socialengine-directory-pages-plugin'
            ),
            'sitegroup' => array(
                'title' => 'Groups / Communities',
                'url' => 'http://www.socialengineaddons.com/socialengine-groups-communities-plugin'
            ),
            'sitebusiness' => array(
                'title' => 'Directory / Businesses',
                'url' => 'http://www.socialengineaddons.com/socialengine-directory-businesses-plugin'
            ),
            'sitestore' => array(
                'title' => 'Stores / Marketplace - Ecommerce',
                'url' => 'http://www.socialengineaddons.com/socialengine-stores-marketplace-ecommerce-plugin'
            ),
            'sitereview' => array(
                'title' => 'Multiple Listing Types Plugin Core (Reviews & Ratings Plugin)',
                'url' => 'http://www.socialengineaddons.com/socialengine-reviews-ratings-plugin'
            ),
        );

        $isPluginExist = false;
        $pluginNames = '';
        foreach ($modArray as $key => $value) {
            $select = new Zend_Db_Select($db);
            $select->from('engine4_core_modules')
                    ->where('name = ?', "$key")
                    ->where('enabled = ?', 1);
            $isModEnabled = $select->query()->fetchObject();
            if (!empty($isModEnabled)) {
                $isPluginExist = true;
                break;
            }

            $pluginNames .= '<a href="' . $value['url'] . '" target="_blank">' . $value['title'] . '</a><br />';
        }

        if (!empty($isPluginExist))
            return;

        $errorMsg = '<div class="tip"><span style="background-color: #da5252;color:#FFFFFF;">You have not installed any of our content modules. Please install atleast one from the below plugins first before installing the "SEAO - Location based / City specific script". <br />' . $pluginNames . '</span></div>';
        return $errorMsg;
    }

}