<?php
/**
* SocialEngine
*
* @category Application_Extensions
* @package Sitecontest
* @copyright Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
* @license http://www.socialengineaddons.com/license/
* @version 2019-08-10 9:40:21Z SocialEngineAddOns $
* @author SocialEngineAddOns
*/
 
class Sitecontest_Api_Core extends Core_Api_Abstract {

  //TO RETURN THE OBJECT USIGN NEW ITEM TYPE
  public function getSitecontest_cont($contest_id)
  {
    return Engine_Api::_()->getItem('sitecontest_contest', $contest_id);
  }

  public function getSitecontest_enty($entry_id)
  {
    return Engine_Api::_()->getItem('sitecontest_entry', $entry_id);
  }

  public function findDays($date1, $date2 = null) {

    $date1 = date('Y-m-d', strtotime($date1));
    if (empty($date2)) {
      $date2 = date('Y-m-d');
    } else {
      $date2 = date('Y-m-d', strtotime($date2));
    }
    if (strtotime($date1) < strtotime($date2)) {
      return -1;
    }
    $datetime1 = new DateTime($date1);
    $datetime2 = new DateTime($date2);
    $difference = $datetime1->diff($datetime2);
    if ($difference)
      return ($difference->days) + 1;
    return 0;
  }

  public function truncation($string, $length = null) {

    $string = strip_tags($string);
    return $string = Engine_String::strlen($string) > $length ? Engine_String::substr($string, 0, ($length - 3)) . '...' : $string;
  }

  public function getContestId($contest_url, $contestId = null)
  {
    $pageID = 0;
    if( !empty($contest_url) ) {
      $sitecontest_table = Engine_Api::_()->getItemTable('sitecontest_contest');
      $select = $sitecontest_table->select()
        ->from($sitecontest_table->info('name'), 'contest_id')
        ->where('contest_url = ?', $contest_url);

      if( !empty($contestId) ) {
        $select->where('contest_id != ?', $contestId);
      }

      $pageID = $select->limit(1)
        ->query()
        ->fetchColumn();
    }

    return $pageID;
  }
  public function getPageUrl($contest_id) {
    $pageUrl = 0;
    if( !empty($contest_id) ) {
      $sitecontest_table = Engine_Api::_()->getItemTable('sitecontest_contest');
      $pageUrl = $sitecontest_table->select()
        ->from($sitecontest_table->info('name'), 'contest_url')
        ->where('contest_id = ?', $contest_id)
        ->limit(1)
        ->query()
        ->fetchColumn();
    }
    return $pageUrl;
  }

  public function userToDbDateTime($dateparams = array(), $dateTime = 'date') {
    $viewer = Engine_Api::_()->user()->getViewer();
    $timezone = Engine_Api::_()->getApi('settings', 'core')->core_locale_timezone;
    if ($viewer->getIdentity()) {
        $timezone = $viewer->timezone;
    }
    $oldTz = date_default_timezone_get();
    date_default_timezone_set($timezone);
    if (isset($dateparams['start_datetime']))
        $dateparams['start_datetime'] = strtotime($dateparams['start_datetime']);
    if (isset($dateparams['end_datetime']))
        $dateparams['end_datetime'] = strtotime($dateparams['end_datetime']);
    if (isset($dateparams['entry_start_datetime']))
        $dateparams['entry_start_datetime'] = strtotime($dateparams['entry_start_datetime']);
    if (isset($dateparams['entry_end_datetime']))
        $dateparams['entry_end_datetime'] = strtotime($dateparams['entry_end_datetime']);
    if (isset($dateparams['vote_start_datetime']))
        $dateparams['vote_start_datetime'] = strtotime($dateparams['vote_start_datetime']);
    if (isset($dateparams['vote_end_datetime']))
        $dateparams['vote_end_datetime'] = strtotime($dateparams['vote_end_datetime']);
    if (isset($dateparams['result_datetime']))
        $dateparams['result_datetime'] = strtotime($dateparams['result_datetime']);
    date_default_timezone_set($oldTz);
    if (isset($dateparams['start_datetime']))
        $dateparams['start_datetime'] = date("Y-m-d H:i:s", $dateparams['start_datetime']);
    if (isset($dateparams['end_datetime']))
        $dateparams['end_datetime'] = date("Y-m-d H:i:s", $dateparams['end_datetime']);
    if (isset($dateparams['entry_start_datetime']))
        $dateparams['entry_start_datetime'] = date("Y-m-d H:i:s", $dateparams['entry_start_datetime']);
    if (isset($dateparams['entry_end_datetime']))
        $dateparams['entry_end_datetime'] = date("Y-m-d H:i:s", $dateparams['entry_end_datetime']);
    if (isset($dateparams['vote_start_datetime']))
        $dateparams['vote_start_datetime'] = date("Y-m-d H:i:s", $dateparams['vote_start_datetime']);
    if (isset($dateparams['vote_end_datetime']))
        $dateparams['vote_end_datetime'] = date("Y-m-d H:i:s", $dateparams['vote_end_datetime']);
    if (isset($dateparams['result_datetime']))
        $dateparams['result_datetime'] = date("Y-m-d H:i:s", $dateparams['result_datetime']);
    return $dateparams;
  }

 public function dbToUserDateTime($dateparams  = array(), $dateTime = 'date') {

    $viewer = Engine_Api::_()->user()->getViewer();
    $timezone = Engine_Api::_()->getApi('settings', 'core')->core_locale_timezone;
    if ($viewer->getIdentity()) {
      $timezone = $viewer->timezone;
    }

    if (isset($dateparams['start_datetime']))
      $dateparams['start_datetime'] = strtotime($dateparams['start_datetime']);
    if (isset($dateparams['end_datetime']))
      $dateparams['end_datetime'] = strtotime($dateparams['end_datetime']);
    if (isset($dateparams['entry_start_datetime']))
      $dateparams['entry_start_datetime'] = strtotime($dateparams['entry_start_datetime']);
    if (isset($dateparams['entry_end_datetime']))
      $dateparams['entry_end_datetime'] = strtotime($dateparams['entry_end_datetime']);
    if (isset($dateparams['vote_start_datetime']))
      $dateparams['vote_start_datetime'] = strtotime($dateparams['vote_start_datetime']);
    if (isset($dateparams['vote_end_datetime']))
      $dateparams['vote_end_datetime'] = strtotime($dateparams['vote_end_datetime']);
    if (isset($dateparams['result_datetime']))
      $dateparams['result_datetime'] = strtotime($dateparams['result_datetime']);
    $oldTz = date_default_timezone_get();
    date_default_timezone_set($timezone);
    if (isset($dateparams['start_datetime']))
      $dateparams['start_datetime'] = date("Y-m-d H:i:s", $dateparams['start_datetime']);
    if (isset($dateparams['end_datetime']))
      $dateparams['end_datetime'] = date("Y-m-d H:i:s", $dateparams['end_datetime']);
    if (isset($dateparams['entry_start_datetime']))
      $dateparams['entry_start_datetime'] = date("Y-m-d H:i:s", $dateparams['entry_start_datetime']);
    if (isset($dateparams['entry_end_datetime']))
      $dateparams['entry_end_datetime'] = date("Y-m-d H:i:s", $dateparams['entry_end_datetime']);
    if (isset($dateparams['vote_start_datetime']))
      $dateparams['vote_start_datetime'] = date("Y-m-d H:i:s", $dateparams['vote_start_datetime']);
    if (isset($dateparams['vote_end_datetime']))
      $dateparams['vote_end_datetime'] = date("Y-m-d H:i:s", $dateparams['vote_end_datetime']);
    if (isset($dateparams['result_datetime']))
      $dateparams['result_datetime'] = date("Y-m-d H:i:s", $dateparams['result_datetime']);
    date_default_timezone_set($oldTz);

    return $dateparams;
  }

	public function getSitecontestsPaginator($params = array(), $customParams = null) {
    
    $paginator = Zend_Paginator::factory($this->getSitecontestsSelect($params, $customParams));
  
    if( !empty($params['page']) ) {
      $paginator->setCurrentPageNumber($params['page']);
    }

    if( !empty($params['limit']) ) {
      $paginator->setItemCountPerPage($params['limit']);
    }
    return $paginator;
  }

  public function getSitecontestsSelect($params = array(), $customParams = null) {
    $current_date = date('Y-m-d H:i:s');

    $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();

    $table = Engine_Api::_()->getDbtable('contests', 'sitecontest');
    $rName = $table->info('name');
 	
	  $select = $table->select()->setIntegrityCheck(false);
 	

    if( isset($params['browse_contest']) && !empty($params['browse_contest']) ) {   
      $select = $table->select()
      ->order( !empty($params['orderby']) ? $params['orderby'].' DESC' : $rName.'.creation_date DESC' );
      $select = $select->from($rName);
    } else {
      $select = $select->from($rName);
    }
    
    $select = $select->where($rName . '.draft = ?', '0');
    $select->where($rName . '.approved = ?', '1');
    if( (isset($params['show']) && $params['show'] == "4" ) ) {
      $likeTableName = Engine_Api::_()->getDbtable('likes', 'core')->info('name');
      $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
      $select->setIntegrityCheck(false)
        ->join($likeTableName, "$likeTableName.resource_id = $rName.contest_id")
        ->where($likeTableName . '.poster_type = ?', 'user')
        ->where($likeTableName . '.poster_id = ?', $viewer_id)
        ->where($likeTableName . '.resource_type = ?', 'sitecontest_cont');
    }

    if( (isset($params['show']) && $params['show'] == "5" ) ) {
      $select->where($rName . '.featured = ?', 1);
    }

    if( !empty($params['users']) ) {
      $str = (string) ( is_array($params['users']) ? "'" . join("', '", $params['users']) . "'" : $params['users'] );
      $select->where($rName . '.owner_id in (?)', new Zend_Db_Expr($str));
    }

    if( empty($params['users']) && isset($params['show']) && $params['show'] == '2' ) {
      $select->where($rName . '.owner_id = ?', '0');
    }

    if(!empty($params['tag_id'])){
      $tmTable = Engine_Api::_()->getDbtable('TagMaps', 'core');
      $tmName = $tmTable->info('name');
        $select
          ->setIntegrityCheck(false)
          ->joinLeft($tmName, "$tmName.resource_id = $rName.contest_id",array('tagmap_id', 'resource_type', 'resource_id', $tmName.'.tag_id'))
          ->where($tmName . '.resource_type = ?', 'sitecontest_cont')
          ->where($tmName . '.tag_id = ?', $params['tag_id']);
    }

    $select->where("contest_id IN(?)", $this->getOnlyViewableContestsId());

    $searchTable = Engine_Api::_()->fields()->getTable('sitecontest_cont', 'search')->info('name');
    if (isset($customParams) && !empty($customParams)) {
      //PROCESS OPTIONS
      //GET SEARCH TABLE
      if (isset($customParams) && !empty($customParams)) {
        $tmp = array();
        foreach ($customParams as $k => $v) {
          if (null == $v || '' == $v || (is_array($v) && count(array_filter($v)) == 0)) {
          continue;
          } else if (false !== strpos($k, '_field_')) {
            list($null, $field) = explode('_field_', $k);
            $tmp['field_' . $field] = $v;
          } else if (false !== strpos($k, '_alias_')) {
            list($null, $alias) = explode('_alias_', $k);
            $tmp[$alias] = $v;
          } else {
            $tmp[$k] = $v;
          }
        }
        $customParams = $tmp;
        $select = $select
            ->setIntegrityCheck(false)
            ->joinLeft($searchTable, "$searchTable.item_id = $rName.contest_id", null);
        $searchParts = Engine_Api::_()->fields()->getSearchQuery('sitecontest_cont', $customParams);
        foreach ($searchParts as $k => $v) {
        $select->where("`{$searchTable}`.{$k}", $v);
        }
      }
    }

    if( isset($params['admincontests']) ) {
      $str = (string) ( is_array($params['admincontests']) ? "'" . join("', '", $params['admincontests']) . "'" : $params['admincontests'] );
      $select->where($rName . '.contest_id in (?)', new Zend_Db_Expr($str));
    }

    if( isset($params['adminjoinedcontests']) ) {
      $str = (string) ( is_array($params['adminjoinedcontests']) ? "'" . join("', '", $params['adminjoinedcontests']) . "'" : $params['adminjoinedcontests'] );
      $select->where($rName . '.contest_id in (?)', new Zend_Db_Expr($str));
    }

    if( !empty($params['user_id']) ) {
      $select->where($rName . '.user_id = ?', $params['user_id']);
    }
    if( !empty($params['contest_id']) ) {
      $select->where($rName . '.contest_id != ?', $params['contest_id']);
    }

    if( !empty($params['category_id']) ) {
      $select->where($rName . '.category_id = ?', $params['category_id']);
    }

    if( !empty($params['Media_type']) ) {
      $select->where($rName . '.media_type = ?', $params['Media_type']);
    }

    if( !empty($params['subcategory_id']) ) {
      $select->where($rName . '.subcategory_id = ?', $params['subcategory_id']);
    }

    if( !empty($params['subsubcategory_id']) ) {
      $select->where($rName . '.subsubcategory_id = ?', $params['subsubcategory_id']);
    }
    if( !empty($params['parent_type']) ) {
      $select->where($rName . '.parent_type = ?', $params['parent_type']);
    }
    if( !empty($params['parent_id']) ) {
      $select->where($rName . '.parent_id = ?', $params['parent_id']);
    }

    if(isset($params['status']) && $params['status'] == 'active') {
      $select->where("start_datetime <= ?",  $current_date);
      $select->where("end_datetime >= ?",  $current_date);
    }

    if(isset($params['status']) && $params['status'] == 'expired') {
      $select->where("end_datetime <= ?",  $current_date);
    }

    if(isset($params['status']) && $params['status'] == 'coming soon') {
      $select->where("start_datetime >= ?",  $current_date);
    }

    if( !empty($params['sort_type'])) {
      
      if( $params['sort_type'] == 'most_viewed') {
        $select->order($rName . '.view_count DESC');
      }

      if( $params['sort_type'] == 'most_commented') {
        $select->order($rName . '.comment_count DESC');
      }

      if( $params['sort_type'] == 'most_liked') {
        $select->order($rName . '.like_count DESC');
      }
    }

    //Media-base Contest Query
    if( !empty($params['sort'])) {

      if( $params['sort'] == 'featured' ) {
        $select->where($rName . '.featured = ?', 1);
      }

      if( $params['sort'] == 'sponsored' ) {
        $select->where($rName . '.sponsored = ?', 1);
      }

      if( $params['sort'] == 'verified' ) {
        $select->where($rName . '.verified = ?', 1);
      }

      if( $params['sort'] == 'hot' ) {
        $select->where($rName . '.hot = ?', 1);
      }

      if( $params['sort'] == 'featured Only' ) {
        $select->where($rName . '.featured = ?', 1);
        $select->where($rName . '.sponsored = ?', 0);
        $select->where($rName . '.hot = ?', 0);
      }

      if( $params['sort'] == 'sponsored Only' ) {
        $select->where($rName . '.featured = ?', 0);
        $select->where($rName . '.sponsored = ?', 1);
        $select->where($rName . '.hot = ?', 0);
      }

      if( $params['sort'] == 'verified Only' ) {
        $select->where($rName . '.featured = ?', 0);
        $select->where($rName . '.sponsored = ?', 0);
        $select->where($rName . '.verified = ?', 1);
        $select->where($rName . '.hot = ?', 0);
      }

      if( $params['sort'] == 'hot Only' ) {
        $select->where($rName . '.featured = ?', 0);
        $select->where($rName . '.sponsored = ?', 0);
        $select->where($rName . '.hot = ?', 1);
      }

      if( $params['sort'] == 'Featured & Sponsored' ) {
        $select->where($rName . '.featured = ?', 1);
        $select->where($rName . '.sponsored = ?', 1);
        $select->where($rName . '.hot = ?', 0);

      }

      if( $params['sort'] == 'Featured & Trending' ) {
        $select->where($rName . '.featured = ?', 1);
        $select->where($rName . '.hot = ?', 1);
        $select->where($rName . '.sponsored = ?', 0);
      }

      if( $params['sort'] == 'Sponsored & Trending' ) {
        $select->where($rName . '.featured = ?', 0);
        $select->where($rName . '.sponsored = ?', 1);
        $select->where($rName . '.hot = ?', 1);
      }

      if( $params['sort'] == 'Featured, Sponsored & Trending' ) {
        $select->where($rName . '.featured = ?', 1);
        $select->where($rName . '.sponsored = ?', 1);
        $select->where($rName . '.hot = ?', 1);
      }

      if( $params['sort'] == 'most_joined') {
        $select->order($rName . '.entry_count DESC');
      }

      if( $params['sort'] == 'most_followed') {
        $select->order($rName . '.follow_count DESC');
      }

      if( $params['sort'] == 'most_viewed') {
        $select->order($rName . '.view_count DESC');
      }

      if( $params['sort'] == 'most_commented') {
        $select->order($rName . '.comment_count DESC');
      }

      if( $params['sort'] == 'most_liked') {
        $select->order($rName . '.like_count DESC');
      }

      if( $params['sort'] == 'coming_soon' ) {
        $select->where("start_datetime >= ?",  $current_date);
      }

      if( $params['sort'] == 'active' ) {
        $select->where("start_datetime <= ?",  $current_date);
        $select->where("end_datetime >= ?",  $current_date);
      }

      if( $params['sort'] == 'ended' ) {
        $select->where("end_datetime <= ?",  $current_date);
      }
    }

    //Could we use the search indexer for this?
    if( !empty($params['searchable']) ) {
      $select->where($rName . '.search = ?', 1);
    }

    if( !empty($params['search']) ) {
      $select->where($rName . ".title LIKE  '" . '%' . $params['search'] . '%'."'");
    }

    if( !empty($params['start_date']) ) {
      $select->where($rName . ".creation_date > ?", date('Y-m-d', $params['start_date']));
    }

    if( !empty($params['end_date']) ) {
      $select->where($rName . ".creation_date < ?", date('Y-m-d', $params['end_date']));
    }

    if( (isset($_GET['alphabeticsearch']) && $_GET['alphabeticsearch'] != 'all' && $_GET['alphabeticsearch'] != '@' ) ) {
      $select->where($rName . ".title LIKE ?", $_GET['alphabeticsearch'] . '%');
    } elseif( isset($_GET['alphabeticsearch']) && ($_GET['alphabeticsearch'] == '@' && $_GET['alphabeticsearch'] != 'all') ) {
      $select->where($rName . ".title REGEXP '^[0-9]'");
    }

    if( !empty($params['type']) && empty($params['orderby']) ) {
      if( $params['type'] == 'browse' || $params['type'] == 'manage' ) {
        $order = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitecontest.browseorder', 1);
        switch( $order ) {
          case "1":
            $select->order($rName . '.creation_date DESC');
            break;
          case "2":
            $select->order($rName . '.view_count DESC');
            break;
          case "3":
            $select->order($rName . '.title');
            break;
          case "4":
            $select->order($rName . '.sponsored' . ' DESC');
            break;
          case "5":
            $select->order($rName . '.featured' . ' DESC');
            break;
          case "6":
            $select->order($rName . '.sponsored' . ' DESC');
            $select->order($rName . '.featured' . ' DESC');
            break;
          case "7":
            $select->order($rName . '.featured' . ' DESC');
            $select->order($rName . '.sponsored' . ' DESC');
            break;
        }
      }
    } else {
      if( !empty($params['orderby']) && $params['orderby'] == "title" ) {
        $select->order($rName . '.' . $params['orderby']);
      } elseif( isset($params['orderby']) && !empty($params['orderby']) )
        $select->order($rName . '.' . $params['orderby'] . ' DESC');
    }
    if( !empty($params['limit']) ) {
      $select->limit($params['limit']);
    }
    $select->order($rName . '.creation_date DESC'); 
    return $select;
  }

  public function showSelectedBrowseBy($content_id) {

    //GET CORE CONTENT TABLE
    $coreContentTable = Engine_Api::_()->getDbTable('content', 'core');
    $coreContentTableName = $coreContentTable->info('name');
    $page_id = $coreContentTable->select()
            ->from($coreContentTableName, array('page_id'))
            ->where('content_id = ?', $content_id)
            ->query()
            ->fetchColumn();

    if (empty($contest_id)) {
      return 0;
    }

    //GET DATA
    $params = $coreContentTable->select()
            ->from($coreContentTableName, array('params'))
            ->where($coreContentTableName . '.page_id = ?', $page_id)
            ->where($coreContentTableName . '.name = ?', 'sitecontest.browse-contests-sitecontest')
            ->query()
            ->fetchColumn();
    $paramsArray = $params ? Zend_Json::decode($params) : array();
    if (isset($paramsArray['orderby']) && !empty($paramsArray['orderby'])) {
      return $paramsArray['orderby'];
    } else {
      return 0;
    }
  }

  public function getHref($contest_id, $owner_id, $slug = null) {

    $contest_url = Engine_Api::_()->sitecontest()->getPageUrl($contest_id);
    $params = array_merge(array('contest_url' => $contest_url));
    $urlO = Zend_Controller_Front::getInstance()->getRouter()
      ->assemble($params, 'sitecontest_entry_view', true);

    //SITECONTEST WORK START
    $sitecontestUrlEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitecontesturl');
    if( !empty($sitecontestUrlEnabled) ) {
      $routeStartS = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitecontest.manifestUrlS', "pageitem");
      $banneUrlArray = Engine_Api::_()->sitecontest()->getBannedPageUrls();
      $page_likes = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitecontest.likelimit.forurlblock', "5");
      $change_url = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitecontest.change.url', 1);

      $sitecontestObject = Engine_Api::_()->getItem('sitecontest_contest', Engine_Api::_()->sitecontest()->getPageId($contest_url));
      $replaceStr = str_replace("/" . $routeStartS . "/", "/", $urlO);
      if( (!empty($change_url)) && ($sitecontestObject->like_count >= $page_likes) && !in_array($contest_url, $banneUrlArray) && !empty($sitecontestObject) ) {
        $urlO = $replaceStr;
      }
    }
    return $urlO;
  }

  public function getPageId($contest_url, $contestId = null) {
    $pageID = 0;
    if( !empty($contest_url) ) {
      $sitecontest_table = Engine_Api::_()->getItemTable('sitecontest_contest');
      $select = $sitecontest_table->select()
        ->from($sitecontest_table->info('name'), 'contest_id')
        ->where('contest_url = ?', $contest_url);

      if( !empty($contestId) ) {
        $select->where('contest_id != ?', $contestId);
      }

      $pageID = $select->limit(1)
        ->query()
        ->fetchColumn();
    }
    return $pageID;
  }

  public function hasJoin( $contest_id , $user_id , $user = null) {
    //GET THE VIEWER.
    $viewer = $user ? $user : Engine_Api::_()->user()->getViewer() ;
    $entryTable = Engine_Api::_()->getItemTable( 'sitecontest_entry' ) ;
    $entryTableName = $entryTable->info( 'name' ) ;
    $sub_status_select = $entryTable->select()
            ->from( $entryTableName , array ( 'entry_id','creation_date' ) )
            ->where( 'contest_id = ?' , $contest_id )
            ->where( 'user_id = ?' , $user_id )
            ->limit( 1 ) ;
    return $sub_status_select->query()->fetchAll() ;
  }
    
  public function getJuryItems($title, $limit = 10, $category_id = null) {
    //MAKE QUERY
    $userTable = Engine_Api::_()->getItemTable('user');

    $select = $userTable->select()
            ->from($userTable->info('name'), array('user_id', 'displayname', 'username', 'photo_id'));

    if (!empty($category_id)) {
      $select->where('category_id = ?', $category_id);
    }

    $select->where($userTable->info('name') . ".displayname LIKE ? " , '%' . $title . '%')
            ->order('displayname ASC')
            ->limit($limit);
    //FETCH RESULTS
    return $userTable->fetchAll($select);
  }

  public function setMetaKeywords($params = array()) {

    $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
    $siteinfo = $view->layout()->siteinfo;
    $keywords = "";

    if (isset($params['keywords'])) {
      if (!empty($keywords))
        $keywords .= ', ';
      $keywords .= $params['keywords'];
    }

    $siteinfo['keywords'] = $keywords;
    $view->layout()->siteinfo = $siteinfo;
  }

  //APROVED/ DISAPROVED EMAIL NOTIFICATION FOR CLASSIFEID
  public function aprovedEmailNotification($object, $message) {

    $user = Engine_Api::_()->getItem('user', $object->user_id);
    $mailParams = array(
          'host' => $_SERVER['HTTP_HOST'],
          'date' => time(),
          'sender_email' => $user->email,
          'sender_title' => $user->getTitle(),
          'sender_link' => $user->getHref(),
          'sender_photo' => $user->getPhotoUrl('thumb.icon'),
          'object_link' => $object->getHref(),
          'title' => $object->getTitle(),
          'status' => $message
    );
    Engine_Api::_()->getApi('mail', 'core')->sendSystem($user->email, 'SITECONTEST_APPROVED_EMAIL_NOTIFICATION',$mailParams);
  }
    
  public function sendContestCreateMail($object,$user) {

    $viewer = Engine_Api::_()->user()->getViewer();
          $mailParams = array(
            'host' => $_SERVER['HTTP_HOST'],
            'date' => time(),
            'sender_email' => $viewer->email,
            'sender_title' => $viewer->getTitle(),
            'sender_link' => $viewer->getHref(),
            'sender_photo' => $viewer->getPhotoUrl('thumb.icon'),
            'object_link' => $object->getHref(),
            'title' => $object->getTitle(),
          );
          Engine_Api::_()->getApi('mail', 'core')->sendSystem($user->email, 'MAIL_ADMIN_CONTEST_CREATE', $mailParams);
  }


  public function juryEmailNotification($user,$message) {
    $mailParams = array(
      'host' => $_SERVER['HTTP_HOST'],
      'date' => time(),
      'sender_email' => $user->email,
      'sender_title' => $user->getTitle(),
      'sender_link' => $user->getHref(),
      'sender_photo' => $user->getPhotoUrl('thumb.icon'),
      'jury_status' => $message,
    );
    Engine_Api::_()->getApi('mail', 'core')->sendSystem($user->email, 'JURY_EMAIL_NOTIFICATION', $mailParams);
  }


  public function getOnlyViewableContestsId() {

    $viewer = Engine_Api::_()->user()->getViewer();
    set_time_limit(0);
    $table = Engine_Api::_()->getItemTable('sitecontest_contest');
    $contest_select = $table->select()
            // ->where('search = ?', true)
            ->order('contest_id DESC');
    $i = 0;
    $contest_ids = array();
    foreach ($contest_select->getTable()->fetchAll($contest_select) as $contest) {
      if ($contest->isOwner($viewer) || Engine_Api::_()->authorization()->isAllowed($contest, $viewer, 'view')) {
        $contest_ids[$i++] = $contest->contest_id;
      }
    }
    if (empty($contest_ids))
      $contest_ids = array(0);

    return $contest_ids;
  }


  public function getFieldsStructureSearch($spec, $parent_field_id = null, $parent_option_id = null, $showGlobal = true, $profileTypeIds = array()) {
    $fieldsApi = Engine_Api::_()->getApi('core', 'fields');
    $type = $fieldsApi->getFieldType($spec);
    $structure = array();
    foreach ($fieldsApi->getFieldsMaps($type)->getRowsMatching('field_id', (int) $parent_field_id) as $map) {
        // Skip maps that don't match parent_option_id (if provided)
      if (null !== $parent_option_id && $map->option_id != $parent_option_id) {
        continue;
      }
      //FETCHING THE FIELDS WHICH BELONGS TO SOME SPECIFIC LISTNIG TYPE
      if ($parent_field_id == 1 && !empty($profileTypeIds) && !in_array($map->option_id, $profileTypeIds)) {
        continue;
      }
      // Get child field
      $field = $fieldsApi->getFieldsMeta($type)->getRowMatching('field_id', $map->child_id);
      if (empty($field)) {
        continue;
      }
      // Add to structure
      if ($field->search) {
        $structure[$map->getKey()] = $map;
      }
      // Get children
      if ($field->canHaveDependents()) {
        $structure += $this->getFieldsStructureSearch($spec, $map->child_id, null, $showGlobal, $profileTypeIds);
      }
    }
    return $structure;
  }

  //FUNCTION TO UPDATE THE COUNT COUNT FOR A ENTRY
  public function updateVoteCount($entry) { 
    $voteTable = Engine_Api::_()->getDbtable('votes', 'sitecontest');
    $voteTableName = $voteTable->info('name');
    $count = $voteTable->select()
      ->from($voteTableName, array('count(*) as count'))
      ->where('resource_id =?', $entry->getIdentity())
      ->where('resource_type =?', 'sitecontest_enty')
      ->where('contest_id =?', $entry->contest_id)
      ->query()
      ->fetchColumn();

    $entry->vote_count = $count;
    $entry->save();
  }

  public function congratesEmail($object,$message,$rank){
    $user = Engine_Api::_()->getItem('user', $object->user_id);
    $mailParams = array(
        'host' => $_SERVER['HTTP_HOST'],
        'date' => time(),
        'sender_email' => $user->email,
        'sender_title' => $user->getTitle(),
        'sender_link' => $user->getHref(),
        'sender_photo' => $user->getPhotoUrl('thumb.icon'),
        'object_link' => $object->getHref(),
        'entry' => $object->getTitle(),
        'congratulation_msg' => $message,
        'rank' =>$rank,
    );
    Engine_Api::_()->getApi('mail', 'core')->sendSystem($user->email, 'SITECONTEST_WINNER_EMAIL_NOTIFICATION',$mailParams);
  }

  public function resultdeclareEmail($object){
    $user = Engine_Api::_()->getItem('user', $object->user_id);

    $mailParams = array(
        'host' => $_SERVER['HTTP_HOST'],
        'date' => time(),
        'sender_email' => $user->email,
        'sender_title' => $user->getTitle(),
        'sender_link' => $user->getHref(),
        'sender_photo' => $user->getPhotoUrl('thumb.icon'),
        'object_link' => $object->getHref(),
        'title' => $object->getTitle(),
    );
    Engine_Api::_()->getApi('mail', 'core')->sendSystem($user->email, 'MAIL_ADMIN_WINNER_DECLARE',$mailParams);
  } 

}
?>