<?php
/**
* SocialEngine
*
* @category Application_Extensions
* @package Sitecontest
* @copyright Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
* @license http://www.socialengineaddons.com/license/
* @version 2019-08-10 9:40:21Z SocialEngineAddOns $
* @author SocialEngineAddOns
*/

class Sitecontest_Api_Vote extends Core_Api_Abstract
{
	
	public function hasVote( $resource_type , $resource_id , $contest_id , $user = null) {

    //GET THE VIEWER.
    $viewer = $user ? $user : Engine_Api::_()->user()->getViewer() ;
    $voteTable = Engine_Api::_()->getItemTable( 'sitecontest_vote' ) ;
    $voteTableName = $voteTable->info( 'name' ) ;
    $sub_status_select = $voteTable->select()
            ->from( $voteTableName , array ( 'vote_id','creation_date' ) )
            ->where( 'resource_type = ?' , $resource_type )
            ->where( 'resource_id = ?' , $resource_id )
            ->where( 'poster_type =?' , $viewer->getType() )
            ->where( 'poster_id =?' , $viewer->getIdentity() )
            ->order('vote_id DESC')
            ->limit( 1 ) ;
    return $sub_status_select->query()->fetchAll() ;
	}


	public function voteCount( $resource_type , $resource_id ) {

    //GET THE VIEWER (POSTER) AND RESOURCE.
    $poster = Engine_Api::_()->user()->getViewer() ;
    $resource = Engine_Api::_()->getItem( $resource_type , $resource_id ) ;
    return Engine_Api::_()->getDbtable( 'votes' , 'sitecontest' )->getVoteCount( $resource , $poster ) ;
	}
}
?>