<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecontest
 * @copyright  Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    2019-08-10 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitecontest_Form_Admin_Item extends Engine_Form {

  protected $_field;

  public function init() {
    $this->setMethod('post');
    $this->setTitle('Add a Contest of the Day')
        ->setDescription('Select a start date and end date below and the corresponding Contest from the auto-suggest Contest field. The selected Contest will be displayed as "Contest of the Day" for this duration and if more than one contests are found to be displayed in the same duration then they will be displayed randomly one at a time.');

    $label = new Zend_Form_Element_Text('title');
    $label->setLabel('Contest')
          ->addValidator('NotEmpty')
          ->setRequired(true)
          ->setAttrib('class', 'text')
          ->setAttrib('style', 'width:300px;');


    // init to
    $this->addElement('Hidden', 'resource_id', array( 'order' => 900,));

    $this->addElements(array(
        $label,
    ));

    $starttime = new Engine_Form_Element_CalendarDateTime('starttime');
    $starttime->setLabel("Start Date");
    $starttime->setAllowEmpty(false);
    $starttime->setValue(date('Y-m-d H:i:s'));
    $this->addElement($starttime);


    //Start End date work
    $endtime = new Engine_Form_Element_CalendarDateTime('endtime');
    $endtime->setLabel("End Date");
    $endtime->setAllowEmpty(false);
    $endtime->setValue(date('Y-m-d H:i:s'));
    $this->addElement($endtime);
    //End End date work

    // Buttons
    $this->addElement('Button', 'submit', array(
      'label' => 'Add Contest',
      'type' => 'submit',
      'ignore' => true,
      'decorators' => array('ViewHelper')
    ));

    // Element: cancel
    $this->addElement('Cancel', 'cancel', array(
      'label' => 'cancel',
      'link' => true,
      'prependText' => ' or ',
      'onclick' => 'javascript:parent.Smoothbox.close()',
      'decorators' => array(
          'ViewHelper',
      ),
    ));

    $this->addDisplayGroup(array('submit', 'cancel'), 'buttons');
    $button_group = $this->getDisplayGroup('buttons');
  }
}
?>

<style type="text/css">
.sitecontest_categories-autosuggest li{
    cursor: pointer;
}
</style>