<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecontest
 * @copyright  Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    2019-08-10 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitecontest_Form_Admin_Submission_Contest extends Authorization_Form_Admin_Level_Abstract
{
	public function init() {
		// My stuff
    $this
    	->setTitle('Contest Submission Settings')
    	->setDescription("The below settings are visible in the process of contest creation. ");

    	$coreSettings = Engine_Api::_()->getApi('settings', 'core');

  	$this->addElement('Select', 'sitecontest_contest_page', array(
      'label' => 'Display Creation Form using Page or Popup',
      'multiOptions' => array("0"=>"Contest Creation Popup", "1"=>"Contest Creation Page"),
        'value' => $coreSettings->getSetting('sitecontest.contest.page',1),
      'description' => 'You can enable the creation of contests via Page or Popup.',
  	));
    // $this->sitecontest_contest_page->getDecorator('Description')->setOption('placement', 'append');


  	$this->addElement('Radio', 'sitecontest_contest_prize', array(
      'label' => 'Show 1st Award',
      'description' => 'Do you want to show the first award in contest creation form ?',
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
    'value' => $coreSettings->getSetting('sitecontest.contest.prize', 1),
  	));

  	$this->addElement('Radio', 'sitecontest_contest_status', array(
      'label' => 'Show Status Options',
      'description' => 'Do you want to show the status of contests in contest creation form. ? (Draft and publish)',
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
    'value' => $coreSettings->getSetting('sitecontest.contest.status', 1),
  	));

  	$this->addElement('Radio', 'sitecontest_contest_redirection', array(
      'label' => 'Default Redirection After Contest Creation',
      'description' => 'Please select the redirection page when user creates any contest.',
      'multiOptions' => array(
        1 => 'Dashboard',
        0 => 'Contest Profile Page'
      ),
      'value' => $coreSettings->getSetting('sitecontest.contest.redirection', 1),
  	));

  	$this->addElement('Radio', 'sitecontest_contest_show_rule', array(
      'label' => 'Show Rules',
      'onclick' => 'showsetting()',
      'multiOptions' => array("1"=>"Yes","0"=>"No"),
      'value' => $coreSettings->getSetting('sitecontest.contest.show.rule',1),
      'description' => 'Do you want to allow contest owners to write rules for their contest ?',
  	));
	
 		$this->addElement('Select', 'sitecontest_contest_show_rules_imp', array(
      'label' => 'Mandatory Rules',
      'description' => 'Do you want to make rules field a mandatory field for contests?',
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => $coreSettings->getSetting('sitecontest.contest.show.rules.imp', 1),
    ));

  	// $this->sitecontest_contest_show_rules_imp->getDecorator('Description')->setOption('placement', 'append');

  	$this->addElement('Radio', 'sitecontest_contest_url', array(
      'label' => 'Edit Custom URL',
      'description' => 'Do you want to allow contest owners to edit custom url in dashboard ?',
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => $coreSettings->getSetting('sitecontest.contest.url', 1),
  	));

  	$this->addElement('Radio', 'sitecontest_contest_search', array(
      'label' => 'Contest Searchable',
      'description' => 'Do you want to make your contests searchable ?',
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => $coreSettings->getSetting('sitecontest.contest.search', 1),
  	));

  	$this->addElement('TinyMce', 'sitecontest_contest_guideline', array(
      'label' => 'Contest Guidelines',
      'description' => 'Enter Contest Guidelines here.',
      'required' => true,
      'allowEmpty' => false,
      'value' => $coreSettings->getSetting('sitecontest.contest.guideline', 'Enter Contest Guideline'),
      // 'editorOptions' => $editorOptions,
      'filters' => array(
      new Engine_Filter_Censor(),
    ),
    ));

    $this->addElement('Button', 'submit', array(
      'label' => 'Save Changes',
      'type' => 'submit',
      'ignore' => true
    ));
	}	
}
?>