<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecontest
 * @copyright  Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    2019-08-10 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitecontest_Form_Admin_Widget_Slideshow extends Engine_Form
{
  
  public function init() {
    $this->setMethod('post');
    $this->setTitle('Featured Contest Carousel');

    $this->addElement('Text', 'title', array(
      'label' => 'Title',
      'description' => '',
      'value' => ''
    ));

    $categories = Engine_Api::_()->getDbTable('categories', 'sitecontest')->getCategories('', null, 0, 0, 1,0,'cat_order');
    if (count($categories) != 0) {
      $categories_prepared[0] = "";
      foreach ($categories as $category) {
          $categories_prepared[$category->category_id] = $category->category_name;
      }
      $this->addElement('Select', 'category_id', array(
          'label' => 'Category',
          'allowEmpty' => false,
          'required' => true,
          'multiOptions' => $categories_prepared,
      ));
    }
    
    $this->addElement('Text','turncation', array(
        'label' => 'Title Truncation Limit .',
        'value' => '40',
        'validators' => array(
          array('Int', true),
          array('GreaterThan', true, array(0)),
      ),
    ));

    $this->addElement('MultiCheckbox', 'contest_item', array(
      'label' => 'Choose ',
      'description' => 'it will be shown in carousel',
      'multiOptions' => array(
        'category' => 'Category',
            'owner' => 'Owner Image',
            'host' => 'Posted By',
            'views' =>'Views',
            'comment' => 'Comments',
            'like' => 'Like',
            'follow' =>'Follow Count',
            'facebook' => 'Facebook [Social Share Link]',
            'twitter' => 'Twitter [Social Share Link]',
            'linkedin' => 'LinkedIn [Social Share Link]',
            'googleplus' => 'Google+ [Social Share Link]'
        ),
      ));

    $this->addElement('Text', 'count', array(
      'label' => 'Count',
      'description' => '(number of contest in each slide.)',
      'validators' => array(
                array('Int', true),
                new Engine_Validate_AtLeast(1),
            ),
      'value' => '2'
    ));

    $this->addElement('Select', 'show_contest', array(
      'label' => 'Show in widget',
      'multiOptions' => array(
        "featured Only"=>"Featured Only",
        "sponsored Only"=>"Sponsored Only",
        "hot Only"=>"Trending Only",
        "Featured & Sponsored"=>"Featured & Sponsored",
        "Featured & Trending"=>"Featured & Trending",
        "Sponsored & Trending"=>"Sponsored & Trending",
        "Featured, Sponsored & Trending"=>"Featured, Sponsored & Trending"),
    ));

    $this->addElement('Select', 'sort_contest', array(
      'label' => 'Popularity / Sorting Criteria',
      'multiOptions' => array(
        "most_liked"=>"Most Liked",
        "most_commented"=>"Most Commented",
        "created"=>"Recently created",
        "most_viewed"=>"Most Viewed"),
    ));
  }
}
?>