<?php 
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecontest
 * @copyright  Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    2019-08-10 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
?>
<?php
class Sitecontest_Form_Dashboard_Rule extends Engine_Form
{
  
  protected $_form_type;

  public function setform_type($flage) {
    $this->_form_type = $flage;
    return $this;
  }

  public function init() {

    if($this->_form_type == "rules"){
      $this->setTitle('Rules')
       ->setDescription('These rules will be visible to users of your website before submitting their entry for this contest.');

      $this->addElement('TinyMce', 'rules', array(
        'label' => 'Rules of the contest',
        'required' => true,
        'allowEmpty' => false,
        'filters' => array(
        new Engine_Filter_Censor()),
      ));

      $this->addElement('Button', 'submit', array(
        'label' => 'Save Rules',
        'type' => 'submit',
        'ignore' => true,
        'decorators' => array(
        'ViewHelper',
        ),
      ));
    } else if ($this->_form_type == "overview") {

      $this->setTitle('Edit Contest Overview')
         ->setDescription("Overview enables you to create a rich profile for your Contest using the editor below. Compose the overview and click 'Save Overview' to save it.");

      $this->addElement('TinyMce', 'overview', array(
        'label' => 'Overview',
        'required' => true,
        'allowEmpty' => false,
        'filters' => array(
        new Engine_Filter_Censor()),
      ));

      $this->addElement('Button', 'submit', array(
        'label' => 'Save Overview',
        'type' => 'submit',
        'ignore' => true,
        'decorators' => array(
        'ViewHelper',
        ),
      )); 
    }
  }
}
?>