<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecontest
 * @copyright  Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    2019-08-10 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitecontest_Form_Editphoto extends Engine_Form
{
  public function init() {

    $contest_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('contest_id', null);
    $sitecontest = Engine_Api::_()->getItem('sitecontest_contest', $contest_id);

    $this->setTitle("Edit Profile Picture")
        ->setAttrib('enctype', 'multipart/form-data')
        ->setAction(Zend_Controller_Front::getInstance()->getRouter()->assemble(array()))
        ->setAttrib('name', 'EditPhoto');

    $this->addElement('Image', 'current', array(
      'label' => 'Current Photo',
      'ignore' => true,
      'decorators' => array(array('ViewScript', array(
        'viewScript' => '_formEditImage.tpl',
        'class' => 'form element',
        'testing' => 'testing'
      )))
    ));
    Engine_Form::addDefaultDecorators($this->current);

    $this->addElement('File', 'Filedata', array(
      'label' => 'Choose New Photo',
      'destination' => APPLICATION_PATH . '/public/temporary/',
      'validators' => array(
          array('Extension', false, 'jpg,jpeg,png,gif'),
      ),
      'onchange' => 'javascript:uploadPhoto();'
    ));
    $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;

    $this->addElement('Hidden', 'coordinates', array(
      'order' => 999,
      'filters' => array(
          'HtmlEntities',
      )
    ));

    $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
    $url = $view->url(array('action' => 'remove-photo', 'contest_id' => $contest_id), "dashboard_default", true);
    $sitecontest = Engine_Api::_()->getItem('sitecontest_contest', $contest_id);
    if ($sitecontest->photo_id != 0) {

      $this->addElement('Button', 'remove', array(
          'label' => 'Remove Photo',
          'onclick' => "removePhotoEvent('$url');",
          'decorators' => array(
              'ViewHelper',
          ),
      ));

      $url = $view->url(array('contest_id' => $contest_id, 'slug' => $sitecontest->getSlug()), "dashboard_default", true);
      $this->addDisplayGroup(array('remove', 'cancel'), 'buttons', array());
    }
  }
}
?>