<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecontest
 * @copyright  Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    2019-08-10 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitecontest_Form_Entry extends Engine_Form {
  
  protected $_media_type;
  
  public function setmedia_type($flage) {
    $this->_media_type = $flage;
    return $this;
  }

  public function init() {

    $this->setTitle('Submit Entry')->setDescription('To join the contest, please fill the required details below. ')->setAttrib('name', 'contests_entry');

    $this->addElement('Text', 'title', array(
      'label' => 'Title',
      'allowEmpty' => false,
      'required' => true,
      'filters' => array(
        new Engine_Filter_Censor(),
        'StripTags',
        new Engine_Filter_StringLength(array('max' => '63'))
      ),
      'autofocus' => 'autofocus',
    ));

    $this->addElement('Textarea', 'description', array(
      'label' => 'Description',
      'allowEmpty' => false,
      'required' => false,
      'filters' => array(
        new Engine_Filter_Censor(),
        'StripTags',
      ),
      'autofocus' => 'autofocus',
    ));
              
     
    $this->addElement('File', 'photo', array(
        'label' => 'Main Entry Photo',
        'required' => true,
    ));
    $this->photo->addValidator('Extension', false, 'jpg,png,gif,jpeg');

    if($this->_media_type == 'video') {
      $this->addElement('HTMLUpload', 'file', [
        'title' => 'Upload Video',
        'url' => $this->getView()->url(array('controller'=> 'index','action'=>'upload'),'contest_extended'),
        'accept' => 'video/*',
      ]);
    }elseif($this->_media_type == 'music') {
      $this->addElement('HTMLUpload', 'file', [
        'title' => 'Upload Music',
        'url' => $this->getView()->url(array('controller'=> 'index','action'=>'createsong'),'contest_extended'),
        'accept' => 'audio/*',
      ]);
    }else if ($this->_media_type == 'text') {
      $this->addElement('TinyMce', 'entry_text', array(
        'label' => 'Entry for Text Contest',
        'required' => true,
        'allowEmpty' => false,
        'filters' => array(
        new Engine_Filter_Censor()),
      ));
    }

    $this->addElement('Button', 'submit', array(
      'label' => 'Submit',
      'type' => 'submit',
      'ignore' => true,
      'decorators' => array(
        'ViewHelper',
      ),
    ));

    $this->addElement('Cancel', 'cancel', array(
      'label' => 'cancel',
      'link' => true,
      'prependText' => ' or ',
      'decorators' => array(
        'ViewHelper',
      ),
    ));
    
    $this->addDisplayGroup(array('submit', 'cancel'), 'buttons', array(
      'decorators' => array(
        'FormElements',
        'DivDivDivWrapper',
      ),
    ));  
  }
}
?>