<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecontest
 * @copyright  Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    2019-08-10 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitecontest_Form_Search extends Sitecontest_Form_Searchfields{

  protected $_fieldType = 'sitecontest_cont';
  protected $_searchFormSettings;
  protected $_widgetSettings;

  public function getWidgetSettings() {
    return $this->_widgetSettings;
  }

  public function setWidgetSettings($widgetSettings) {
    $this->_widgetSettings = $widgetSettings;
    return $this;
  }

  public function init() {

    $this->setAttribs(array(
      'id' => 'filter_form',
      'class' => 'sitecontest_browse_filters field_search_criteria',
      'method' => 'GET'
    ));

    parent::init();

    $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
    $this->getMemberTypeElement();

    //GET SEARCH FORM SETTINGS
    $this->_searchFormSettings = Engine_Api::_()->getDbTable('searchformsetting', 'seaocore')->getModuleOptions('sitecontest');

    $this->getAdditionalOptionsElement();

    $this->setAction($view->url(array('action' => 'browse'), 'sitecontest_general', true));

  }

  public function getMemberTypeElement() {
    $multiOptions = array('' => ' ');
    $profileTypeFields = Engine_Api::_()->fields()->getFieldsObjectsByAlias($this->_fieldType, 'profile_type');

    if (count($profileTypeFields) !== 1 || !isset($profileTypeFields['profile_type']))
      return;
    $profileTypeField = $profileTypeFields['profile_type'];

    $options = $profileTypeField->getOptions();

    foreach ($options as $option) {
      $multiOptions[$option->option_id] = $option->label;
    }

    $this->addElement('hidden', 'profile_type', array(
        'order' => -1000001,
        'class' =>
        'field_toggle' . ' ' .
        'parent_' . 0 . ' ' .
        'option_' . 0 . ' ' .
        'field_' . $profileTypeField->field_id . ' ',
        'onchange' => 'changeFields($(this));',
        'multiOptions' => $multiOptions,
    ));
    return $this->profile_type;
  }

  public function getAdditionalOptionsElement() {

    $orderwhatWhereWithinmile = -1000;
    $i = 99980;
    $rowOrder = 50;

    $this->addElement('Hidden', 'page', array(
        'order' => $i++,
    ));

    $this->addElement('Hidden', 'tag', array(
        'order' => $i++,
    ));

    $this->addElement('Hidden', 'tag_id', array(
        'order' => $i++,
    ));

    $this->addElement('Hidden', 'category', array(
         'order' => $i++,
    ));

    $this->addElement('Hidden', 'subcategory', array(
         'order' => $i++,
    ));

    $this->addElement('Hidden', 'subsubcategory', array(
         'order' => $i++,
    ));

    $this->addElement('Hidden', 'categoryname', array(
         'order' => $i++,
    ));

    $this->addElement('Hidden', 'subcategoryname', array(
         'order' => $i++,
    ));

    $this->addElement('Hidden', 'subsubcategoryname', array(
         'order' => $i++,
    ));

    $this->addElement('Hidden', 'searchable', array(
         'order' => $i++,
         'value' => 1,
    ));

    if (!empty($this->_searchFormSettings['search']) && !empty($this->_searchFormSettings['search']['display'])) {

          $this->addElement('text','search',array(
            'label' => 'By Name',
            'order' => $this->_searchFormSettings['search']['order'],

          ));
    }
    if (!empty($this->_searchFormSettings['Media_type']) && !empty($this->_searchFormSettings['Media_type']['display'])) {
      $multiOPtionsmediaBy = array(
        '' => '',
        'text' => 'Text',
        'photo' => 'Photo',
        'video' => 'Video',
        'music' => 'Music'
      );

      $this->addElement('Select','Media_type',array(
      'label' => 'By Media Type',
      'order' => $this->_searchFormSettings['Media_type']['order'],
      'multiOptions' => $multiOPtionsmediaBy
      ));
    }
    if (!empty($this->_searchFormSettings['status']) && !empty($this->_searchFormSettings['status']['display'])) {
      $multiOPtionsstatusBy = array(
        '' => '',
        'active' => 'Active',
        'expired' => 'Ended',
        'coming soon' => 'Coming soon',
      );

      $this->addElement('Select','status',array(
      'label' => 'By Status',
      'order' => $this->_searchFormSettings['status']['order'],
      'multiOptions' => $multiOPtionsstatusBy
      ));
    }
    if (!empty($this->_searchFormSettings['orderby']) && !empty($this->_searchFormSettings['orderby']['display'])) {
      $multiOPtionsOrderBy = array(
        '' => '',
        'creation_date' => 'Recently Created',
        'view_count' => 'Most Popular',
        'like_count' => 'Most Liked',
        'comment_count' => 'Most Commented',
      );

      $this->addElement('Select', 'orderby', array(
      'label' => 'Browse By',
      'order' => $this->_searchFormSettings['orderby']['order'],
      'multiOptions' => $multiOPtionsOrderBy,
      ));
    }

    if (!empty($this->_searchFormSettings['category_id']) && !empty($this->_searchFormSettings['category_id']['display'])) {

      if (Engine_Api::_()->getApi('settings', 'core')->getSetting('sitecontest.category.enabled', 1)) {
          
          if (isset($this->_widgetSettings['showAllCategories']) && $this->_widgetSettings['showAllCategories']) {
          $table = Engine_Api::_()->getItemTable('sitecontest_category')->fetchAll()->toArray();
          }else {
            $table = Engine_Api::_()->getItemTable('sitecontest_category')->getOnlyViewableCategoryId();
          }

          $categories["0"] = null;
          foreach ($table as $key => $value) { 
          if($value['cat_dependency'] == 0 && $value['subcat_dependency'] == 0)
          $categories[$value['category_id']] = $value['category_name'];
          }
          $this->addElement('Select', 'category_id', array(
            'label' => 'Category',
            'order' => $this->_searchFormSettings['category_id']['order'],
            'multiOptions' => $categories,
            'required' => false,
            'id' => 'category_id-wrapper',
            'onchange' => "sitecontest_addOptions(this.value);showFields(this.value, 1);",
          ));  
           
          $this->addElement('Select', 'subcategory_id', array(
            'label' => 'Sub-Category',
            'order' => $this->_searchFormSettings['category_id']['order']+1,
            'RegisterInArrayValidator' => false,
            'allowEmpty' => true,
            'required' => false,
            'decorators' =>array(array('ViewScript', array(
              'viewScript' => 'application/modules/Sitecontest/views/scripts/_category.tpl',
              'formType' => 'search',
              'class' => 'form element'))),
          ));

          $this->addElement('Select', 'subsubcategory_id', array(
            'label' => '3rd level Category',
            'order' => $this->_searchFormSettings['category_id']['order']+2,
            'RegisterInArrayValidator' => false,
            'allowEmpty' => true,
            'required' => false,
            'decorators' => array(array('ViewScript', array(
              'viewScript' => 'application/modules/Sitecontest/views/scripts/_sub_category.tpl',
              'formType' => 'search',
              'class' => 'form element'))),
          ));

      }
    }

    $this->addElement('Button', 'done', array(
        'label' => 'Search',
        'onclick' => 'searchSitecontests();',
        'ignore' => true,
        'order' => 999999999,
        'decorators' => array(
            'ViewHelper',
            array('HtmlTag', array('tag' => 'div'))
        ),
    ));
  }
}

?>