<?php
/**
* SocialEngine
*
* @category Application_Extensions
* @package Sitecontest
* @copyright Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
* @license http://www.socialengineaddons.com/license/
* @version 2019-08-10 9:40:21Z SocialEngineAddOns $
* @author SocialEngineAddOns
*/
?>
<?php
class Sitecontest_Model_Contest extends Core_Model_Item_Abstract {

  protected $_type = 'sitecontest_cont';

	public function tags() {
	    return new Engine_ProxyObject($this, Engine_Api::_()->getDbtable('tags', 'core'));
	}

	public function getHref($params = array()) {
		$subject = Engine_Api::_()->getItem('sitecontest_contest', $this->contest_id);
    $params = array_merge(array(
      'route' => 'sitecontest_entry_view',
      'reset' => true,
      'contest_url' => $subject->contest_url,
        ), $params);
    $contest_url = $subject->contest_url;
    $route = $params['route'];
    $reset = $params['reset'];
    unset($params['route']);
    unset($params['reset']);
    $urlO = Zend_Controller_Front::getInstance()->getRouter()
            ->assemble($params, $route, $reset);
    return $urlO;
  }

	public function isContestSucceeded($startdatetime,$enddatetime) {
		$contestExpr = strtotime(date('Y-m-d H:i:s', strtotime($enddatetime)));
		$contestStart = strtotime(date('Y-m-d H:i:s', strtotime($startdatetime)));
		if ($contestStart <= strtotime(date('Y-m-d H:i:s')) && strtotime(date('Y-m-d H:i:s')) <= $contestExpr) {
			return true;
		} else {
			return false;
		}
	}
	public function getStatus(){
		if ($this->isContestSucceeded($this->start_datetime,$this->end_datetime)) {
        $contest_status = 'Active';
    }else{
        $contest_status = 'Ended';
    }
    $contestExpr = strtotime(date('Y-m-d H:i:s', strtotime($this->end_datetime)));
    $contestStart = strtotime(date('Y-m-d H:i:s', strtotime($this->start_datetime)));
    if ($contestStart >= strtotime(date('Y-m-d H:i:s')) && strtotime(date('Y-m-d H:i:s')) <= $contestExpr) {
        $contest_status = 'Coming Soon';
    }
  	return $contest_status;
  }
	
	public function setPhoto($photo) {
    if( $photo instanceof Zend_Form_Element_File ) {
      $file = $photo->getFileName();
    } elseif( is_array($photo) && !empty($photo['tmp_name']) ) {
      $file = $photo['tmp_name'];
    } elseif( is_string($photo) && file_exists($photo) ) {
      $file = $photo;
    } else {
      throw new Contest_Model_Exception('Invalid argument passed to setPhoto: ' . print_r($photo, 1));
    }

    $name = basename($file);
    $path = APPLICATION_PATH . DIRECTORY_SEPARATOR . 'temporary';
    $params = array(
      'parent_type' => 'sitecontest_cont',
      'parent_id' => $this->getIdentity()
    );

    // Save
    $storage = Engine_Api::_()->storage();

      // Resize image (main)
		$image = Engine_Image::factory();
		$image->open($file)
		->resize(1024, 720)
		->write($path . '/m_' . $name)
		->destroy();

		// Resize image (profile)
		$image = Engine_Image::factory();
		$image->open($file);

		$size = min($image->height, $image->width);
		$x = ($image->width - $size) / 2;
		$y = ($image->height - $size) / 2;

		$image->resample($x, $y, $size, $size, 320, 240)
		->write($path . '/p_' . $name)
		->destroy();

		// Resize image (normal)
		$image = Engine_Image::factory();
		$image->open($file);

		$size = min($image->height, $image->width);
		$x = ($image->width - $size) / 2;
		$y = ($image->height - $size) / 2;

		$image->resample($x, $y, $size, $size, 640, 480)
		->write($path . '/in_' . $name)
		->destroy();

		// Resize image (icon)
		$image = Engine_Image::factory();
		$image->open($file);

		$size = min($image->height, $image->width);
		$x = ($image->width - $size) / 2;
		$y = ($image->height - $size) / 2;

		$image->resample($x, $y, $size, $size, 36, 36)
		->write($path . '/is_' . $name)
		->destroy();

    // Store
    $iMain = $storage->create($path . '/m_' . $name, $params);
    $iProfile = $storage->create($path . '/p_' . $name, $params);
    $iIconNormal = $storage->create($path . '/in_' . $name, $params);
    $iSquare = $storage->create($path . '/is_' . $name, $params);

    $iMain->bridge($iProfile, 'thumb.profile');
    $iMain->bridge($iIconNormal, 'thumb.normal');
    $iMain->bridge($iSquare, 'thumb.icon');

    // Remove temp files
    @unlink($path . '/p_' . $name);
    @unlink($path . '/m_' . $name);
    @unlink($path . '/in_' . $name);
    @unlink($path . '/is_' . $name);

     //ADD TO ALBUM
    $viewer = Engine_Api::_()->user()->getViewer();

    $photoTable = Engine_Api::_()->getItemTable('sitecontest_photo');
    $rows = $photoTable->fetchRow($photoTable->select()->from($photoTable->info('name'), 'order')->order('order DESC')->limit(1));
    $order = 0;
    if (!empty($rows)) {
        $order = $rows->order + 1;
    }
   	$sitephotoAlbum = $this->getSingletonAlbum();
		$photoItem = $photoTable->createRow();
		$photoItem->setFromArray(array(
			'contest_id' => $this->getIdentity(),
			'album_id' => $sitephotoAlbum->getIdentity(),
			'user_id' => $viewer->getIdentity(),
			'file_id' => $iMain->getIdentity(),
			'collection_id' => $sitephotoAlbum->getIdentity(),
			'order' => $order,
        ));
        $photoItem->save();
        
    // Update row
    $this->modified_date = date('Y-m-d H:i:s');
    $this->photo_id = $photoItem->file_id;
    $this->save();

    return $this;
	}

	public function follows() {
    return new Engine_ProxyObject($this, Engine_Api::_()->getDbtable('follows', 'seaocore'));
  }

	public function getSingletonAlbum() {
    $table = Engine_Api::_()->getItemTable('sitecontest_album');
    $select = $table->select()
            ->where('contest_id = ?', $this->getIdentity())
            ->order('album_id ASC')
            ->limit(1);

    if (!empty($album_id)) {
      $select->where('album_id = ?', $album_id);
    }
    $album = $table->fetchRow($select);

    if (null === $album) {
      $album = $table->createRow();
      $album->setFromArray(array(
          'title' => $this->getTitle(),
          'contest_id' => $this->getIdentity(),
          'search' => 1,
          'view_count' => 1,
      ));
      $id = $album->save();

      // CREATE AUTH STUFF HERE
      $auth = Engine_Api::_()->authorization()->context;
      $roles = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'registered');

      $tagMax = array_search('registered', $roles);

      foreach ($roles as $i => $role) {
          $auth->setAllowed($album, $role, 'tag', ($i <= $tagMax));
      }

      //COMMENT PRIVACY
      $auth = Engine_Api::_()->authorization()->context;
      $roles = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
      $auth_comment = "everyone";
      $commentMax = array_search($auth_comment, $roles);
      foreach ($roles as $i => $role) {
          $auth->setAllowed($album, $role, 'comment', ($i <= $commentMax));
      }
    }

    return $album;
  }
  public function getPhotoUrl($type = null) {

    $module = "Sitecontest";
    $shorType = "contest";

    if (empty($this->photo_id)) {
      $type = ( $type ? str_replace('.', '_', $type) : 'main' );
      return Zend_Registry::get('Zend_View')->layout()->staticBaseUrl . 'application/modules/' . $module . '/externals/images/nophoto_' . $shorType . '_'
                . $type . '.png';
    } else {
      $file = Engine_Api::_()->getItemTable('storage_file')->getFile($this->photo_id, $type);
      if (!$file) {
          $type = ( $type ? str_replace('.', '_', $type) : 'main' );
          return Zend_Registry::get('Zend_View')->layout()->staticBaseUrl . 'application/modules/' . $module . '/externals/images/nophoto_' . $shorType . '_'
                  . $type . '.png';
      }
      return $file->map();
    }
  }
  protected function _delete() {
    		
		//Delete all backers of this project
		$backersTable = Engine_Api::_()->getItemTable('sitecontest_entry');
		$backersTable->delete(array('contest_id=?' => $this->contest_id));

		//Delete all albums & their photos of this project
		$albumsTable = Engine_Api::_()->getItemTable('sitecontest_album');
		$albumsTable->delete(array('contest_id=?' => $this->contest_id));

		$photosTable = Engine_Api::_()->getItemTable('sitecontest_photo');
		$photosTable->delete(array('contest_id=?' => $this->contest_id));

		//Delete all the rewards of this contest
		$rewardTable = Engine_Api::_()->getItemTable('sitecontest_award');
		$rewardTable->delete(array('contest_id=?' => $this->contest_id));

		// Delete other info of this project
		$otherInfoTable = Engine_Api::_()->getDbTable('otherinfo', 'sitecontest');
		$otherInfoTable->delete(array('contest_id=?' => $this->contest_id));


		// delete storage files (Project thumb)
		if (Engine_Api::_()->getItem('storage_file', $this->photo_id)) {
			Engine_Api::_()->getItem('storage_file', $this->photo_id)->remove();
		}

		// delete crowdfunding favourites
		Engine_Api::_()->getDbtable('follows', 'seaocore')->delete(array(
			'resource_id = ?' => $this->contest_id,
			'resource_type = ?' => 'sitecontest_cont',
		));
		
		parent::_delete();
	}
  public function likes() {
		return new Engine_ProxyObject($this, Engine_Api::_()->getDbtable('likes', 'core'));
	}
	public function comments() {
		return new Engine_ProxyObject($this, Engine_Api::_()->getDbtable('comments', 'core'));
	}

  public function getFollowers($object) {
    $followTable = Engine_Api::_()->getDbtable('follows', 'seaocore');
    $followName = $followTable->info('name');
    $select = $followTable->select()
        ->from($followName)
        ->where($followName . '.resource_id = ?', $object->getIdentity())
        ->where($followName . '.resource_type = ?', $object->getType());
    return $followTable->fetchAll($select);
  }

  public function sendTieMail($user,$object){
    $mailParams = array(
        'host' => $_SERVER['HTTP_HOST'],
        'date' => time(),
        'sender_email' => $user->email,
        'sender_title' => $user->getTitle(),
        'sender_link' => $user->getHref(),
        'sender_photo' => $user->getPhotoUrl('thumb.icon'),
        'object_link' => $object->getHref(),
        'title' => $object->getTitle(),
    );
    Engine_Api::_()->getApi('mail', 'core')->sendSystem($user->email, 'MAIL_ADMIN_TIE_DECLARE',$mailParams);
  }
  
}
?>