<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecontest
 * @copyright  Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    2019-08-10 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitecontest_Model_DbTable_Albums extends Engine_Db_Table {

    protected $_rowClass = 'Sitecontest_Model_Album';
    protected $_serializedColumns = array('cover_params');

    public function getSpecialAlbum(Sitecontest_Model_Contest $contest, $type) {

    if (!in_array($type, array('note', 'overview','wall', 'announcements', 'discussions','cover'))) {
      throw new Sitecontest_Model_Exception('Unknown special album type');
    }

    $contest_id = $contest->contest_id;
    $select = $this->select()
            ->where('contest_id = ?', $contest_id)
            ->where('type = ?', $type)
            ->order('album_id ASC')
            ->limit(1);
    $album = $this->fetchRow($select);

    //CREATE PHOTOS ALBUM IF IT DOESN't EXIST YET
    if (null === $album) {
      $album = $this->createRow();
      // $album->default_value = 0;
      $album->contest_id = $contest_id;
      $album->owner_id = $contest->owner_id;
      $album->title = Zend_Registry::get('Zend_Translate')->_(ucfirst($type) . ' Photos');
      $album->type = $type;
      if ($type == 'message') {
        $album->search = 0;
      } else {
        $album->search = 1;
      }
      $album->save();
    }
    return $album;
  }

}