<?php
/**
* SocialEngine
*
* @category Application_Extensions
* @package Sitecontest
* @copyright Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
* @license http://www.socialengineaddons.com/license/
* @version 2019-08-10 9:40:21Z SocialEngineAddOns $
* @author SocialEngineAddOns
*/
?>
<?php  

class Sitecontest_Model_Entry extends Core_Model_Item_Abstract
{
	protected $_type = 'sitecontest_enty';
	protected $_parent_type = 'sitecontest_contest';

	public function getAuthorizationItem() {

    return $this->getParent('sitecontest_cont');
  }

	public function tags() {
    return new Engine_ProxyObject($this, Engine_Api::_()->getDbtable('tags', 'core'));
	}
	
	public function getHref($params = array()) {
    $slug = $this->getSlug();

    $params = array_merge(array(
      'route' => 'sitecontest_view',
      'reset' => true,
      'user_id' => $this->user_id,
      'entry_id' => $this->entry_id,
      'contest_id' => $this->contest_id,
      'slug' => $slug,
    ), $params);
    $route = $params['route'];
    $reset = $params['reset'];
    unset($params['route']);
    unset($params['reset']);
    return Zend_Controller_Front::getInstance()->getRouter()
	      ->assemble($params, $route, $reset);
	}
	public function setPhoto($photo) {
    if( $photo instanceof Zend_Form_Element_File ) {
      $file = $photo->getFileName();
    } elseif( is_array($photo) && !empty($photo['tmp_name']) ) {
      $file = $photo['tmp_name'];
    } elseif( is_string($photo) && file_exists($photo) ) {
      $file = $photo;
    } else {
      throw new Entry_Model_Exception('Invalid argument passed to setPhoto: ' . print_r($photo, 1));
    }

    $name = basename($file);
    $path = APPLICATION_PATH . DIRECTORY_SEPARATOR . 'temporary';
    $params = array(
      'parent_type' => 'sitecontest_enty',
      'parent_id' => $this->getIdentity()
    );

    // Save
    $storage = Engine_Api::_()->storage();

    // Resize image (main)
    $image = Engine_Image::factory();
    $image->open($file)
      ->resize(1024, 720)
      ->write($path . '/m_' . $name)
      ->destroy();

    // Resize image (profile)
    $image = Engine_Image::factory();
    $image->open($file)
      ->resize(320, 240)
      ->write($path . '/p_' . $name)
      ->destroy();

    // Resize image (normal)
    $image = Engine_Image::factory();
    $image->open($file)
      ->resize(640, 480)
      ->write($path . '/in_' . $name)
      ->destroy();

    // Resize image (icon)
    $image = Engine_Image::factory();
    $image->open($file);

    $size = min($image->height, $image->width);
    $x = ($image->width - $size) / 2;
    $y = ($image->height - $size) / 2;

    $image->resample($x, $y, $size, $size, 36, 36)
      ->write($path . '/is_' . $name)
      ->destroy();

    // Store
    $iMain = $storage->create($path . '/m_' . $name, $params);
    $iProfile = $storage->create($path . '/p_' . $name, $params);
    $iIconNormal = $storage->create($path . '/in_' . $name, $params);
    $iSquare = $storage->create($path . '/is_' . $name, $params);

    $iMain->bridge($iProfile, 'thumb.profile');
    $iMain->bridge($iIconNormal, 'thumb.normal');
    $iMain->bridge($iSquare, 'thumb.icon');

    // Remove temp files
    @unlink($path . '/p_' . $name);
    @unlink($path . '/m_' . $name);
    @unlink($path . '/in_' . $name);
    @unlink($path . '/is_' . $name);

    $viewer = Engine_Api::_()->user()->getViewer();

    $photoTable = Engine_Api::_()->getItemTable('sitecontest_photo');
    $rows = $photoTable->fetchRow($photoTable->select()->from($photoTable->info('name'), 'order')->order('order DESC')->limit(1));
    $order = 0;
    if (!empty($rows)) {
        $order = $rows->order + 1;
    }
		$photoItem = $photoTable->createRow();
		$photoItem->setFromArray(array(
			'contest_id' => $this->getIdentity(),
			'user_id' => $viewer->getIdentity(),
			'file_id' => $iMain->getIdentity(),
			'order' => $order,
		));
    $photoItem->save();
    // Update row
    // $this->modified_date = date('Y-m-d H:i:s');
    $this->photo_id = $photoItem->file_id;
    $this->save();

	    return $this;
	}

	public function likes() {
		return new Engine_ProxyObject($this, Engine_Api::_()->getDbtable('likes', 'core'));
	}

	public function comments() {
		return new Engine_ProxyObject($this, Engine_Api::_()->getDbtable('comments', 'core'));
	}

	protected function _delete() {
		// delete storage files (Project thumb)
		if (Engine_Api::_()->getItem('storage_file', $this->photo_id)) {
			Engine_Api::_()->getItem('storage_file', $this->photo_id)->remove();
		}

		// delete contest follows
		Engine_Api::_()->getDbtable('follows', 'seaocore')->delete(array(
		'resource_id = ?' => $this->entry_id,
		'resource_type = ?' => 'sitecontest_enty',
		));
		parent::_delete();
	}
}
?>