<?php
/**
* SocialEngine
*
* @category Application_Extensions
* @package Sitecontest
* @copyright Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
* @license http://www.socialengineaddons.com/license/
* @version 2019-08-10 9:40:21Z SocialEngineAddOns $
* @author SocialEngineAddOns
*/
?>
<?php
class Sitecontest_Plugin_Menus {

	public function canViewSitecontests($row) {

		//GET VIEWER
		$viewer = Engine_Api::_()->user()->getViewer();

		//MUST BE ABLE TO VIEW EVENTS
		if (!Engine_Api::_()->authorization()->isAllowed('sitecontest_cont', $viewer, "view")) {
			return false;
		}

		return true;
	}
	public function canCreateSitecontests($row) {
		//MUST BE LOGGED IN USER
		$viewer = Engine_Api::_()->user()->getViewer();

		if (!$viewer || !$viewer->getIdentity()) {
			$creation_link = Engine_Api::_()->authorization()->isAllowed('sitecontest_cont', $viewer, "creation_link");

			if(!$creation_link) return false; 
				
		} else {
			//MUST BE ABLE TO CRETE EVENTS
			if (!Engine_Api::_()->authorization()->isAllowed('sitecontest_cont', $viewer, "create")) {
				return false;
			}
		}

		//MUST BE ABLE TO VIEW EVENTS
		if (!Engine_Api::_()->authorization()->isAllowed('sitecontest_cont', $viewer, "view")) {
				return false;
		}

		return true;
	}
	public function sitecontestGutterReport() {

		//RETURN FALSE IF SUBJECT IS NOT SET
		if (!Engine_Api::_()->core()->hasSubject('sitecontest_cont')) {
			return false;
		}

		//GET VIEWER ID
		$viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();

		if (empty($viewer_id)) {
			return false;
		}

		//GET SUBJECT
		$sitecontest = Engine_Api::_()->core()->getSubject('sitecontest_cont');
		
		return array(
			'class' => 'smoothbox buttonlink icon_sitecontests_report',
			'route' => 'default',
			'params' => array(
				'module' => 'core',
				'controller' => 'report',
				'action' => 'create',
				'route' => 'default',
				'subject' => $sitecontest->getGuid()
			),
		);
	}
	public function sitecontestGutterDelete($row) {

		//RETURN FALSE IF SUBJECT IS NOT SET
		if (!Engine_Api::_()->core()->hasSubject('sitecontest_cont')) {
				return false;
		}

		//GET VIEWER ID
		$viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();

		//GET SUBJECT
		$sitecontest = Engine_Api::_()->core()->getSubject('sitecontest_cont');

		//EVENT DELETE PRIVACY
		$can_delete = $sitecontest->authorization()->isAllowed(null, "delete");

		//AUTHORIZATION CHECK
		if (empty($can_delete) || empty($viewer_id)) {
				return false;
		}

		return array(
			'class' => 'smoothbox buttonlink seaocore_icon_delete',
			'route' => 'default',
			'params' => array(
				'module' => 'sitecontest', 
				'controller'=> 'index', 
				'action' => 'delete',
				'contest_id' => $sitecontest->getIdentity()
			),
		);
	}
	public function sitecontestGutterTfriend($row) {

		//RETURN FALSE IF SUBJECT IS NOT SET
		if (!Engine_Api::_()->core()->hasSubject('sitecontest_cont')) {
			return false;
		}

		//GET SUBJECT
		$sitecontest = Engine_Api::_()->core()->getSubject('sitecontest_cont');
		return array(
			'class' => 'smoothbox buttonlink icon_sitecontests_tellafriend',
			'route' => "sitecontest_profilepage",
			'action' => 'tell-a-friend',
			'params' => array(
				'contest_id' => $sitecontest->getIdentity(),
			),
		);
	}
	public function sitecontestGutterShare() {

		//RETURN FALSE IF SUBJECT IS NOT SET
		if (!Engine_Api::_()->core()->hasSubject('sitecontest_cont')) {
			return false;
		}

		//GET SUBJECT
		$sitecontest = Engine_Api::_()->core()->getSubject('sitecontest_cont');

		//GET VIEWER ID
		$viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();

		//RETURN IF VIEWER IS EMPTY
		if (empty($viewer_id)) {
			return false;
		}

		return array(
			'class' => 'smoothbox seao_icon_sharelink',
			'route' => 'default',
			'params' => array(
				'module' => 'activity',
				'controller' => 'index',
				'action' => 'share',
				'type' => $sitecontest->getType(),
				'id' => $sitecontest->getIdentity(),
				'format' => 'smoothbox',
			),
		);
	}
	public function sitecontestGutterEdit($row) {

		//RETURN FALSE IF SUBJECT IS NOT SET
		if (!Engine_Api::_()->core()->hasSubject('sitecontest_cont')) {
			return false;
		}

		//GET VIEWER
		$viewer = Engine_Api::_()->user()->getViewer();

		//GET EVENT SUBJECT
		$sitecontest = Engine_Api::_()->core()->getSubject('sitecontest_cont');

		//AUTHORIZATION CHECK
		if (!$sitecontest->authorization()->isAllowed($viewer, "edit")) {
			return false;
		}

		return array(
			'class' => 'buttonlink icon_sitecontest_dashboard icon_contest_edit',
			'route' => "dashboard_default",
			'action' => 'edit',
			'params' => array(
				'contest_id' => $sitecontest->getIdentity(),
			),
		);
	}
}
?>