<?php
/**
* SocialEngine
*
* @category Application_Extensions
* @package Sitecontest
* @copyright Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
* @license http://www.socialengineaddons.com/license/
* @version 2019-08-10 9:40:21Z SocialEngineAddOns $
* @author SocialEngineAddOns
*/
?>
<?php 
class Sitecontest_AdminSettingsController extends Core_Controller_Action_Admin
{
	public function indexAction() {
        $this->view->hasLanguageDirectoryPermissions = $hasLanguageDirectoryPermissions = Engine_Api::_()->getApi('language', 'sitecontest')->hasDirectoryPermissions();

        $core = Engine_Api::_()->getApi('settings', 'core');
        $contest = $core->getSetting( "sitecontest.titlesingular", "Contest");
        $contests = $core->getSetting( "sitecontest.titleplural", "Contests");
		$this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
	      ->getNavigation('sitecontest_admin_main', array(), 'sitecontest_admin_main_settings');

          //GET NAVIGATION
        $this->view->subNavigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitecontest_admin_submain_cont', array(), 'sitecontest_admin_submain_global_tab');
            
        $redirectionPrevious = $core->getSetting('sitecontest.redirection', 'index');

        $db = Zend_Db_Table_Abstract::getDefaultAdapter();
	    $this->view->form  = $form = new Sitecontest_Form_Admin_Global();
	    
	    if( $this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost()) ) {
            $values = $form->getValues();

            foreach ($values as $key => $value){
            $core->setSetting($key, $value);
            }

            if (isset($values['sitecontest_titleplural']) && $values['sitecontest_titleplural'] != $contests && isset($values['sitecontest_titlesingular']) && $values['sitecontest_titlesingular'] != $contest && !empty($hasLanguageDirectoryPermissions)) {
            $db->query('UPDATE  `engine4_core_menuitems` SET  `label` =  \''.ucfirst($values['sitecontest_titleplural']).'\' WHERE  `engine4_core_menuitems`.`name` ="core_main_sitecontest";');

            $language_pharse = array('text_contests' => '$plural$' , 'text_contest' => '$singular$');
            Engine_Api::_()->getApi('language', 'sitecontest')->setTranslateForListType($language_pharse, '', $contest, $contests);

            $language_pharse = array('text_contests' => $values['sitecontest_titleplural'] , 'text_contest' => $values['sitecontest_titlesingular']);

            Engine_Api::_()->getApi('language', 'sitecontest')->setTranslateForListType($language_pharse, '', '$singular$', '$plural$');
            }
            $redirectionNew = $core->getSetting('sitecontest.redirection', 'index');
            if($redirectionPrevious != $redirectionNew) {
                  $db->update('engine4_core_menuitems', array('params' => '{"route":"sitecontest_general","action":"'.$redirectionNew.'"}'), array('name = ?' => 'core_main_sitecontest'));
            }
            $form->addNotice('Your changes have been saved.');
	    }
	}

	public function formSearchAction() { 
        //GET NAVIGATION
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitecontest_admin_main', array(), 'sitecontest_admin_main_searchform'); 
        //GET SEARCH TABLE
        $tableSearchForm = Engine_Api::_()->getDbTable('searchformsetting', 'seaocore'); 
        //CHECK POST
        if ($this->getRequest()->isPost()) {
        //BEGIN TRANSCATION
            $db = Engine_Db_Table::getDefaultAdapter();
            $db->beginTransaction();

            $values = $_POST;
            $rowCategory = $tableSearchForm->getFieldsOptions('sitecontest', 'category_id');
            $defaultCategory = 0;
            $defaultAddition = 0;
            $count = 1;
            try {
                foreach ($values['order'] as $key => $value) {
                    $multiplyAddition = $count * 5;
                    $tableSearchForm->update(array('order' => $defaultAddition + $defaultCategory + $key + $multiplyAddition + 1), array('searchformsetting_id = ?' => (int) $value));

                    if (!empty($rowCategory) && $value == $rowCategory->searchformsetting_id) {
                        $defaultCategory = 1;
                        $defaultAddition = 10000000;
                    }
                    $count++;
                }
                $db->commit();
            } catch (Exception $e) {
                $db->rollBack();
                throw $e;
            }
        }
        $this->view->searchForm = $tableSearchForm->fetchAll($tableSearchForm->select()->where('module = ?', 'sitecontest')->order('order'));
    }

    public function diplayFormAction() {

        $field_id = $this->_getParam('id');
        $display = $this->_getParam('display');
        if (!empty($field_id)) {
            Engine_Api::_()->getDbTable('searchformsetting', 'seaocore')->update(array('display' => $display), array('module = ?' => 'sitecontest', 'searchformsetting_id = ?' => (int) $field_id));
        }
        $this->_redirect('admin/sitecontest/settings/form-search');
    }

    public function statisticAction() {

        //GET NAVIGATION
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitecontest_admin_main', array(), 'sitecontest_admin_main_statistic');

        //GET CONTEST TABLE
        $contestTable = Engine_Api::_()->getDbtable('contests', 'sitecontest');
        $contestTableName = $contestTable->info('name');

        //GET ENTRY TABLE
        $entryTable = Engine_Api::_()->getDbtable('entries', 'sitecontest');
        $entryTableName = $entryTable->info('name');

        //GET CONTEST DETAILS
        $select = $contestTable->select()->from($contestTableName, 'count(*) AS totalcontest');

        $this->view->totalsitecontest = $select->query()->fetchColumn();
        $select = $entryTable->select()->from($entryTableName, 'count(*) AS totalentry');
        $this->view->totalentry = $select->query()->fetchColumn();
        $this->view->totalwinners = $entryTable->select()->from($entryTableName, 'sum(winner) AS totalwinners')->query()->fetchColumn();
        if(empty($this->view->totalwinners)){
            $this->view->totalwinners = 0;
        }
        $select = $contestTable->select()->from($contestTableName, 'count(*) AS totalpublish')->where('draft = ?', 0);
        $this->view->totalPublish = $select->query()->fetchColumn();
        $select = $contestTable->select()->from($contestTableName, 'count(*) AS totaldrafted')->where('draft = ?', 1);
        $this->view->totalDrafted = $select->query()->fetchColumn();
        $select = $contestTable->select()->from($contestTableName, 'count(*) AS totalapproved')->where('approved = ?', 1);
        $this->view->totalapproved = $select->query()->fetchColumn();
        $select = $contestTable->select()->from($contestTableName, 'count(*) AS totalfeatured')->where('featured = ?', 1);
        $this->view->totalfeatured = $select->query()->fetchColumn();
        $select = $contestTable->select()->from($contestTableName, 'count(*) AS totalsponsored')->where('sponsored = ?', 1);
        $this->view->totalsponsored = $select->query()->fetchColumn();
        $select = $contestTable->select()->from($contestTableName, 'count(*) AS totalhot')->where('hot = ?', 1);
        $this->view->totalhot = $select->query()->fetchColumn();
        $select = $contestTable->select()->from($contestTableName, 'count(*) AS totalvarified')->where('verified = ?', 1);
        $this->view->totalvarified = $select->query()->fetchColumn();
    
    }

    public function faqAction() {
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitecontest_admin_main', array(), 'sitecontest_admin_main_faq');
        $this->view->action = 'faq';
        $this->view->faq_type = $this->_getParam('faq_type', 'general');
    }

    public function contestSubmissionAction() {
        //GET NAGIGATION
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                    ->getNavigation('sitecontest_admin_main', array(), 'sitecontest_admin_main_settings');

        $this->view->subNavigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitecontest_admin_submain_cont', array(), 'sitecontest_admin_submain_contestsubmission_tab');

        $this->view->form = $form = new Sitecontest_Form_Admin_Submission_Contest(); 

        if( $this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost()) ) {
            $values = $form->getValues();
            foreach ($values as $key => $value){
                Engine_Api::_()->getApi('settings', 'core')->setSetting($key, $value);
            }
            $form->addNotice('Your changes have been saved.');
        }
    }
}
?>