<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecontest
 * @copyright  Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    2019-08-10 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitecontest_IndexController extends Core_Controller_Action_Standard
{

	public function init()
	{  
		//AUTHORIZATION CHECK
        if (!$this->_helper->requireAuth()->setAuthParams('sitecontest_cont', null, "view")->isValid())
            return;
	}

  	public function indexAction()
  	{
		$this->_helper->content
		// ->setNoRender()
		->setEnabled();
  	}
	public function browseAction()
	{
		$this->_helper->content
		// ->setNoRender()
		->setEnabled();
	}
    public function categoriesAction() {
        $this->_helper->content
                // ->setNoRender()
                ->setEnabled();
    }
    public function winnerAction() {
        $this->_helper->content
                // ->setNoRender()
                ->setEnabled();
    }
	public function deleteAction()
	{
		if( !$this->_helper->requireUser()->isValid() ) return;
		$contest = Engine_Api::_()->getItem('sitecontest_contest', $this->getRequest()->getParam('contest_id'));
		if( !$contest ) {
		  $this->view->status = false;
		  $this->view->error = Zend_Registry::get('Zend_Translate')->_("Contest entry doesn't exist or not authorized to delete");
		  return;
		}

		if( !$this->_helper->requireAuth()->setAuthParams($contest, null, 'delete')->isValid()) return;

		// In smoothbox
		$this->_helper->layout->setLayout('default-simple');

		$this->view->form = $form = new Sitecontest_Form_Delete();


		if( !$this->getRequest()->isPost() ) {
		  $this->view->status = false;
		  $this->view->error = Zend_Registry::get('Zend_Translate')->_('Invalid request method');
		  return;
		}

		$db = $contest->getTable()->getAdapter();
		$db->beginTransaction();

		try {
		  $contest->delete();

		  $db->commit();
		} catch( Exception $e ) {
		  $db->rollBack();
		  throw $e;
		}

		$this->view->status = true;
		$this->view->message = Zend_Registry::get('Zend_Translate')->_('Your contest has been deleted.');
		return $this->_forward('success' ,'utility', 'core', array(
		  'parentRedirect' => Zend_Controller_Front::getInstance()->getRouter()->assemble(array('action' => 'manage'), 'sitecontest_general', true),
		  'messages' => Array($this->view->message)
		));
	}

	//Entry Create Action
  	public function entryAction() {

  		if( !$this->_helper->requireUser->isValid() ) return;

	    // set up data needed to check quota
        $viewer = Engine_Api::_()->user()->getViewer();
        $contest_id = $this->_getParam('contest_id');
        $values['user_id'] = $viewer->getIdentity();
        $values['contest_id'] = $contest_id;
        $paginator = Engine_Api::_()->getItemTable('sitecontest_entry')->getEntriesPaginator($values);

        $this->view->quota = $quota = '1';
        $this->view->current_count = $paginator->getTotalItemCount();

        $this->view->maxUpload = (int)(ini_get('upload_max_filesize'));
	    // Render
	    $this->_helper->content
	        //->setNoRender()
	        ->setEnabled()
	        ;
	    
	    $contest = Engine_Api::_()->getItem('sitecontest_contest', $contest_id);

	    $this->view->type = $media_type = $contest->media_type;

	   
	    $this->view->form = $form = new Sitecontest_Form_Entry(array('media_type' => $media_type));
	    
	    // Not post/invalid
	    if( !$this->getRequest()->isPost() ) {
	      return;
	    }

	    if( !$form->isValid($this->getRequest()->getPost()) ) {
	      return;
	    }
	    // Process
	    $values = $form->getValues();

	    $values['user_id'] = $viewer->getIdentity();
	    $values['contest_id'] = $contest_id;

		$table = Engine_Api::_()->getDbtable('entries', 'sitecontest'); 	
	    $db = $table->getAdapter();
	    $db->beginTransaction();

	    try {
			// Create contest
			$entry = $table->createRow();
			$entry->setFromArray($values);
			$entry->name = $viewer->displayname;
			$entry->email = $viewer->email;
			$entry->save();

	      	$contest = Engine_Api::_()->getItem('sitecontest_contest', $contest_id);
	      
		    if( isset($contest->entry_count) ) {
		      $contest->entry_count++;
		      $contest->save();
		    }
	     	// Add photo
		    if( !empty($values['photo']) ) {
				$entry->setPhoto($form->photo,'photo');
			}    
			
			$storage = Engine_Api::_()->getDbtable('files','storage');
			if($contest->media_type == 'music'){
				//Music Upload
				$store = $storage->fetchRow($storage->select()->where('name = ?', $_FILES['file']['name'])->order('creation_date DESC')->limit(1));
				if (empty($store)) {
					$form->file->setErrors(array("File 'music' was not uploaded"));
		      		return;
				}
				$songs = Engine_Api::_()->getDbTable('songs','sitecontest');
			    $contest_song = $songs->createRow();
			    $values['entry_id'] = $entry->getIdentity();
			    $values['file_id'] = $store->getIdentity();
			    $values['title'] = $store->name;
			    $contest_song->setFromArray($values);
			    $contest_song->save();
			    $entry->music_id = $contest_song->getIdentity();
				
			} elseif($contest->media_type == 'video') {
				//Video upload
				$store = $storage->fetchRow($storage->select()->where('name = ?', $_FILES['file']['name'])->order('creation_date DESC')->limit(1));
				if (empty($store)) {
					$form->file->setErrors(array("File 'video' was not uploaded"));
		      		return;
				}
				$videos = Engine_Api::_()->getDbTable('videos','sitecontest');
			    $contest_video = $videos->createRow();
			    $values['entry_id'] = $entry->getIdentity();
			    $values['file_id'] = $store->getIdentity();
			    $values['title'] = $store->name;
			    $contest_video->setFromArray($values);
			    $contest_video->save();
			    $entry->video_id = $contest_video->getIdentity();
			}

			//Activity feed
		    $action = Engine_Api::_()->getDbtable('actions', 'activity')->addActivity($viewer, $contest, 'sitecontest_entry_new');
	        if( $action ) {
	          Engine_Api::_()->getDbtable('actions', 'activity')->attachActivity($action, $entry);
	        }

	        //Send notofication to Contest Followers
	      	$owner = $entry->getOwner('user');
	      	$followers = Engine_Api::_()->getDbtable('contests', 'sitecontest')->getFollowers($contest);
	      	foreach ($followers as $follower) {
	      		$user = Engine_Api::_()->getItem('user',$follower->poster_id);
	      		Engine_Api::_()->getDbtable('notifications', 'activity')->addNotification($user, $owner, $contest, 'sitecontest_entry_new');
	      	}

	      	//Notification to Contest Owner
	      	$user = $contest->getOwner();
	      	Engine_Api::_()->getDbtable('notifications', 'activity')->addNotification($user, $owner, $contest, 'sitecontest_entry_new');

			// Set auth
			$auth = Engine_Api::_()->authorization()->context;
			// Commit
			$entry->save();
			$db->commit();
			// Redirect
			return $this->_helper->redirector->gotoRoute(array('contest_url' => $contest->contest_url), 'sitecontest_entry_view', true);

	    } catch( Exception $e ) {
	      return $this->exceptionWrapper($e, $form, $db);
	    }
  	}

  	public function ruleAction() {
  		$this->view->contest = $contest = Engine_Api::_()->getItem('sitecontest_contest', $this->getRequest()->getParam('contest_id'));
  		if(empty($contest->rules)){
  			return $this->_helper->redirector->gotoRoute(array('module' => 'sitecontest', 'action' => 'entry', 'contest_id' => $contest->getIdentity()), "Contest_specific", true);
  		}
  	}
  	//Contest Create Action
  	public function createAction() {

	    if( !$this->_helper->requireUser->isValid() ) return;

	    $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
	    // if( !$this->_helper->requireAuth()->setAuthParams('contest', null, 'create')->isValid() ) return;
	    if(!$this->_getParam('format')){
	    $this->view->guideline = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitecontest.contest.guideline');
	    }
	    //EVENT CREATION PRIVACY
        $can_create = $this->_helper->requireAuth()->setAuthParams('sitecontest_cont', null, 'create')->checkRequire();

        if (empty($can_create)) {
          return $this->_forwardCustom('requireauth', 'error', 'core');
        }

        // set up data needed to check quota
        $viewer = Engine_Api::_()->user()->getViewer();
        $values['user_id'] = $viewer->getIdentity();
        $paginator = Engine_Api::_()->getItemTable('sitecontest_contest')->getContestsPaginator($values);

        $this->view->quota = $quota = Engine_Api::_()->authorization()->getPermission($viewer->level_id, 'sitecontest_cont', 'max');
        $this->view->current_count = $paginator->getTotalItemCount();

	    // Render
	    $this->_helper->content
	        //->setNoRender()
	        ->setEnabled()
	        ;

	    $this->view->form = $form = new Sitecontest_Form_Create();
	    
	    // Not post/invalid
	    if( !$this->getRequest()->isPost() ) {
	      return;
	    }

	    if( !$form->isValid($this->getRequest()->getPost()) ) {
	      return;
	    }

	    // Process
	    $values = $form->getValues();


	    if( $values['category_id'] == '-1' ) {
	      $form->category_id->setErrors(array('Please Select any category.'));
	      return;
	    }
	   
	   	$date = $view->locale()->toDateTime(date('Y-m-d H:i:s'),array('size' => 'medium'));
	    $current_date = strtotime($date);

	    $contest_start = strtotime($values['start_datetime']);
	    $contest_end = strtotime($values['end_datetime']);
	    // check dates
	    if( $current_date >= $contest_start ) {
	      $form->start_datetime->setErrors(array('Contest Start Date should be greater or equal to current date.'));
	      return;
	    }
	    if( $contest_start >= $contest_end ) {
	      $form->end_datetime->setErrors(array('Contest Start Date should be before End Date.'));
	      return;
	    }

	    $entry_start = strtotime($values['entry_start_datetime']);
	    $entry_end = strtotime($values['entry_end_datetime']);

	    // check dates
	    if( $entry_start >= $entry_end ) {
	      $form->entry_end_datetime->setErrors(array('Entry Start Date should be before End Date.'));
	      return;
	    }
	    if( $entry_start < $contest_start ) {
	      $form->entry_start_datetime->setErrors(array('Contest Start Date should be before Entry start Date.'));
	      return;
	    }
	    if( $contest_end < $entry_end ) {
	      $form->entry_start_datetime->setErrors(array('Entry End Date should be before contest End Date.'));
	      return;
	    }
	    
	    $vote_start = strtotime($values['vote_start_datetime']);
	    $vote_end = strtotime($values['vote_end_datetime']);
	    // check dates
	    if( $vote_start >= $vote_end ) {
	      $form->vote_end_datetime->setErrors(array('Vote Start Date should be before End Date.'));
	      return;
	    }
	    if( $vote_start < $entry_start ) {
	      $form->vote_start_datetime->setErrors(array('Entry Start Date should be before Vote start Date.'));
	      return;
	    }
	    if( $contest_end < $vote_end ) {
	      $form->vote_end_datetime->setErrors(array('Vote End Date should be before Contest End Date.'));
	      return;
	    }

	    $vote_show = strtotime($values['vote_show_datetime']);
	    $result_show = strtotime($values['result_datetime']);

	    // check dates
	    if( $vote_show > 0 && $vote_show < $contest_end ) {
	      $form->start_datetime->setErrors(array('Vote show date should be After the Contest End Date.'));
	      return;
	    }

	    if( $result_show < $contest_end ) {
	      $form->result_datetime->setErrors(array('Result Announced Date should be after Contest End Date.'));
	      return;
	    }
	    $dateInfo = Engine_Api::_()->sitecontest()->userToDbDateTime($values);

	    $values['start_datetime'] = $dateInfo['start_datetime'];
	    $values['end_datetime'] = $dateInfo['end_datetime'];
	    $values['entry_start_datetime'] = $dateInfo['entry_start_datetime'];
	    $values['entry_end_datetime'] = $dateInfo['entry_end_datetime'];
	    $values['vote_start_datetime'] = $dateInfo['vote_start_datetime'];
	    $values['vote_end_datetime'] = $dateInfo['vote_end_datetime'];
	    $values['result_datetime'] = $dateInfo['result_datetime'];

		$table = Engine_Api::_()->getItemTable('sitecontest_contest');
    	$sitecontest = $table->createRow();       
        $sitecontest->setFromArray($values);
	    $auth = Engine_Api::_()->authorization()->context;
	    $roles = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');

	    foreach( $roles as $role ) {
	      if ($form->auth_view){
	        if( $auth->isAllowed($sitecontest, $role, 'view') ) {
	         $form->auth_view->setValue($role);
	        }
	      }

	      if ($form->auth_comment){
	        if( $auth->isAllowed($sitecontest, $role, 'comment') ) {
	          $form->auth_comment->setValue($role);
	        }
	      }
	    }
	    $db = $table->getAdapter();
	    $db->beginTransaction();
	    try
	    {
      	if( empty($values['auth_view']) ) {
	        $values['auth_view'] = 'everyone';
	    }
	    if( empty($values['auth_comment']) ) {
	        $values['auth_comment'] = 'everyone';
	    }
	    $values['view_privacy'] = $values['auth_view'];
	    $values['comment_privacy'] = $values['auth_comment'];
	    $values['user_id'] = $viewer->getIdentity();
	    $values['owner_id'] = $viewer->getIdentity();
        $viewer_id = $viewer->getIdentity();
	    $values['parent_type'] = $this->_getParam('parent_type', 'user');
	    $values['parent_id'] = $this->_getParam('parent_id', $viewer_id);
	    // Create contest
	    $contest = $table->createRow();
	    $contest->setFromArray($values);

	    if($values['subcategory_id'] == NULL)
		$contest['subcategory_id'] = 0;

		if($values['subsubcategory_id'] == NULL)
		$contest['subsubcategory_id'] = 0;
	    
	    $contest->save();

		//Save Award Table
    	$awards['contest_id'] = $contest->contest_id;
    	$awards['first_award_prize'] = $values['first_award_prize'];
    	$award_table = Engine_Api::_()->getDbtable('awards', 'sitecontest');
	  	$contest_award = $award_table->createRow();
	  	$contest_award->setFromArray($awards);
	    $contest_award->save();
	    // Add photo
	    if( !empty($values['photo']) ) {
	      $contest->setPhoto($form->photo);
	    }   
	   	    	
	    //SAVE CUSTOM VALUES AND PROFILE TYPE VALUE
        $customfieldform = $form->getSubForm('fields');
        $customfieldform->setItem($contest);
        $customfieldform->saveValues();
                
        $categoryIds = array();
        $categoryIds[] = $contest->category_id;
        $categoryIds[] = $contest->subcategory_id;
        $categoryIds[] = $contest->subsubcategory_id;
        $contest->profile_type = Engine_Api::_()->getDbTable('categories', 'sitecontest')->getProfileType($categoryIds, 0, 'profile_type');

	    $contest->featured = Engine_Api::_()->authorization()->getPermission($viewer->level_id, 'sitecontest_cont', "feature");
	    $contest->approved = Engine_Api::_()->authorization()->getPermission($viewer->level_id, 'sitecontest_cont', "approve");
	    $contest->sponsored = Engine_Api::_()->authorization()->getPermission($viewer->level_id, 'sitecontest_cont', "sponsored");
	    $contest->verified = Engine_Api::_()->authorization()->getPermission($viewer->level_id, 'sitecontest_cont', "verified");
	    $contest->hot = Engine_Api::_()->authorization()->getPermission($viewer->level_id, 'sitecontest_cont', "hot");

        $contest->save();
	    
		//Other_info Work
	    $tableOtherinfo = Engine_Api::_()->getDbTable('otherinfo', 'sitecontest');
        
        $row = $tableOtherinfo->getOtherinfo($contest->contest_id);
        if (empty($row))
        	Engine_Api::_()->getDbTable('otherinfo', 'sitecontest')->insert(array(
                'contest_id' => $contest->contest_id)); //COMMIT
        

	    //ADDING TAGS
        $keywords = '';
        if (isset($values['tags']) && !empty($values['tags'])) {
            $tags = preg_split('/[,]+/', $values['tags']);
                $tags = array_filter(array_map("trim", $tags));
                $contest->tags()->addTagMaps($viewer, $tags);

           foreach ($tags as $tag) {
                    $keywords .= " $tag";
            }
        }
      	$owner = $contest->getOwner('user');
      	$superadmin_id = array();
      	
      	//Send Notification To SUPERADMIN
	    $users = Engine_Api::_()->user()->getSuperAdmins();
	    foreach ($users as $user) {
		    $superadmin_id[] = $user->user_id;
		    if(!in_array($owner->getIdentity(), $superadmin_id)){
		      	Engine_Api::_()->getDbtable('notifications', 'activity')->addNotification($user, $owner, $contest, 'sitecontest_create_contest');
		    }
		    //Send mail to superadmin
		    Engine_Api::_()->sitecontest()->sendContestCreateMail($contest,$user);
	    }
		   
	    if($values['draft'] == 0 && $contest->approved) {
	    	$contest->approved_date = date('Y-m-d H:i:s');
	   		//Send notification of contest create to jury member
	        $juries = Engine_Api::_()->getDbtable('juries', 'sitecontest')->fetchAll();
	        foreach ($juries as $jury) {
	        	if(!in_array($jury->user_id, $superadmin_id)){
			        $user = Engine_Api::_()->getItem('user',$jury->user_id);
			        Engine_Api::_()->getDbtable('notifications', 'activity')->addNotification($user, $owner, $contest, 'sitecontest_create_contest');
	        	}
	        }
	   
	        //Activity feed of contest create
	        $action = Engine_Api::_()->getDbtable('actions', 'activity')->addActivity($viewer, $contest, 'sitecontest_new');
	        if( $action ) {
	          Engine_Api::_()->getDbtable('actions', 'activity')->attachActivity($action, $contest);
	        }
      	}
	    //END DEFAULT EMAIL TO SUPERADMIN WHEN ANYONE CREATE CONTESTS.

      	// Auth
		$viewMax = array_search($values['auth_view'], $roles);
		$commentMax = array_search($values['auth_comment'], $roles);

		foreach( $roles as $i => $role ) {
			$auth->setAllowed($contest, $role, 'view', ($i <= $viewMax));
			$auth->setAllowed($contest, $role, 'comment', ($i <= $commentMax));
		}

		$db->commit();

	    // Redirect
		if(!$this->_getParam('format')){
	      if (Engine_Api::_()->getApi('settings', 'core')->getSetting('sitecontest.contest.redirection', 1)) {
                  return $this->_helper->redirector->gotoRoute(array('action' => 'edit','contest_id' => $contest->contest_id,),'dashboard_default', true);
              } else {
                  return $this->_helper->redirector->gotoRoute(array('contest_url' => $contest->contest_url), 'sitecontest_entry_view', true);
              }
        } else {
        	$this->_forward('success', 'utility', 'core', array(
			'smoothboxClose' => true,
			// 'parentRefresh' => true,
			'class' => 'global_form_popup',
			'messages' => array(Zend_Registry::get('Zend_Translate')->_('Your contest is created successfully.'))));
        }
	    } catch( Exception $e ) {
	      return $this->exceptionWrapper($e, $form, $db);
	    }
    }

  	public function manageAction(){
  		if( !$this->_helper->requireUser()->isValid() ) return;

  				//EVENT CREATION PRIVACY
        $this->view->can_create = $this->_helper->requireAuth()->setAuthParams('sitecontest_cont', null, 'create')->checkRequire();

        if (empty($this->view->can_create)) {
          return $this->_forwardCustom('requireauth', 'error', 'core');
        }

  		$this->_helper->content
	        //->setNoRender()
	        ->setEnabled()
	        ;
  	}


  	public function entryviewAction(){

  		$entry_id = $this->_getParam('entry_id');
  		$viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
        $entries = Engine_Api::_()->getItem('sitecontest_entry', $entry_id);
        if($entries->user_id == $viewer_id){
        	$this->view->show =1;
        }
         //SET entries SUBJECT
        Engine_Api::_()->core()->setSubject($entries);

  		$this->_helper->content
	        //->setNoRender()
	        ->setEnabled()
	        ;
    	// view count
	    $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
        $this->view->viewer_id = $viewer_id = $viewer->getIdentity();
	    if (!$entries->getOwner()->isSelf($viewer)) {
            $entries->view_count++;
            $entries->save();
            $params = array();
            $params['resource_id'] = $entries->getIdentity();
            $params['resource_type'] = $entries->getType();
            $params['viewer_id'] = 0;
            $params['type'] = 'editor';
            //SET EVENT VIEW DETAILS
            if (!empty($viewer_id)) {
                Engine_Api::_()->getDbtable('vieweds', 'sitecontest')->setVieweds($viewer_id,$params);
            }
        }

	  	}
    public function entriesAction() {
    	if( !$this->_helper->requireUser()->isValid() ) return;
		$viewer = Engine_Api::_()->user()->getViewer();

		// Render
	    $this->_helper->content
	        //->setNoRender()
	        ->setEnabled()
	        ;

		$this->view->paginator = $paginator = Engine_Api::_()->getItemTable('sitecontest_entry')->fetchAll();
		if( $paginator && !Engine_Api::_()->core()->hasSubject() ) {
	        Engine_Api::_()->core()->setSubject($paginator);
	      }
	 
  	}

	public function categoryAction() {
        $category_id = $this->_getParam('category_id', null);
        Zend_Registry::set('sitcontestCategoryId', $category_id);

        //GET STORE OBJECT
        $pageTable = Engine_Api::_()->getDbtable('pages', 'core');
        $pageSelect = $pageTable->select()->where('name = ?', "sitecontest_index_category");
        $pageObject = $pageTable->fetchRow($pageSelect);
		// Render
  		if( !$this->_helper->requireUser()->isValid() ) return;
	    $this->_helper->content
	        //->setNoRender()
	        ->setEnabled()
	        ;

		$category = Engine_Api::_()->getItem('sitecontest_category', $category_id);
	    if( $category ) {
	      $pageObject->title = $category->category_name.' Home';
	      $pageObject->save();
	    }

	}

	public function contestviewAction() {

		$contest_url = $this->_getParam('contest_url', null);
	    $contest_id = $this->_getParam('contest_id', null);

	    if( $contest_url ) {
	      $contest_id = Engine_Api::_()->sitecontest()->getContestId($contest_url);
	    }

	    $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
	    //EVENT CREATION PRIVACY
        $this->view->can_view = $this->_helper->requireAuth()->setAuthParams('sitecontest_cont', null, 'view')->checkRequire();

        if (empty($this->view->can_view)) {
          return $this->_forwardCustom('requireauth', 'error', 'core');
        }


	    $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
	    $this->view->sitecontest = $sitecontest = Engine_Api::_()->getItem('sitecontest_contest', $contest_id);

	    if (empty($sitecontest->approved)||!empty($sitecontest->draft)) {
	    	$canView = (Engine_Api::_()->getDbtable('allow', 'authorization')->isAllowed($sitecontest, $viewer, 'edit') || $viewer->isAdminOnly());
	    	if (!$canView) {
	          return $this->_forward('notfound', 'error', 'core');
	        }
	    }

        if( !$this->_helper->requireAuth()->setAuthParams($sitecontest, $viewer, 'view')->isValid() ) {
            return;
        }


	    if( $contest_id ) {
	      if( $sitecontest && !Engine_Api::_()->core()->hasSubject() ) {
	        Engine_Api::_()->core()->setSubject($sitecontest);
	      }
	    }
	   
	    $this->_helper->content
	        //->setNoRender()
	        ->setEnabled()
	        ;
	    // view count
        $this->view->viewer_id = $viewer_id = $viewer->getIdentity();
	    if (!$sitecontest->getOwner()->isSelf($viewer)) {
            $sitecontest->view_count++;
            $sitecontest->save();
            $params = array();
            $params['resource_id'] = $sitecontest->getIdentity();
            $params['resource_type'] = $sitecontest->getType();
            $params['viewer_id'] = 0;
            $params['type'] = 'editor';
            //SET EVENT VIEW DETAILS
            if (!empty($viewer_id)) {
                Engine_Api::_()->getDbtable('vieweds', 'sitecontest')->setVieweds($viewer_id,$params);
            }
        }

        //GET KEYWORDS
        $params['keywords'] = Engine_Api::_()->getDbTable('otherinfo', 'sitecontest')->getColumnValue($contest_id, 'keywords');
        //SET META KEYWORDS
        Engine_Api::_()->sitecontest()->setMetaKeywords($params);
 	}

	
 	public function pageurlvalidationAction()
	{

	    $contest_url = $this->_getParam('contest_url');
	    $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
	    $sitecontestUrlEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitecontesturl');
	    if( !empty($sitecontestUrlEnabled) ) {
	      $urlArray = Engine_Api::_()->sitecontest()->getBannedUrls();
	    }
	    if( empty($contest_url) ) {
	      $text = Zend_Registry::get('Zend_Translate')->_("URL not valid.");
	      echo Zend_Json::encode(array('success' => 0, 'error_msg' => '<span style="color:red;"><img src="' . $view->layout()->staticBaseUrl . 'application/modules/Sitecontest/externals/images/cross.png"/>' . $text . '</span>'));
	      exit();
	    }

	    $url_lenght = strlen($contest_url);
	    if( $url_lenght < 3 ) {
	      $error_msg1 = Zend_Registry::get('Zend_Translate')->_("URL component should be atleast 3 characters long.");
	      echo Zend_Json::encode(array('success' => 0, 'error_msg' => "<span style='color:red;'><img src='" . $view->layout()->staticBaseUrl . "application/modules/Sitecontest/externals/images/cross.png'/>$error_msg1</span>"));
	      exit();
	    } elseif( $url_lenght > 255 ) {
	      $error_msg2 = Zend_Registry::get('Zend_Translate')->_("URL component should be maximum 255 characters long.");
	      echo Zend_Json::encode(array('success' => 0, 'error_msg' => "<span style='color:red;'><img src='" . $view->layout()->staticBaseUrl . "application/modules/Sitecontest/externals/images/cross.png'/>$error_msg2</span>"));
	      exit();
	    }

	    $change_url = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitecontest.change.url', 1);
	    $check_url = $this->_getParam('check_url');
	    if( !empty($check_url) ) {
	      $pageId = $this->_getParam('contest_id');
	      $contest_id = Engine_Api::_()->sitecontest()->getPageId($contest_url, $pageId);
	    } else {
	      $contest_id = Engine_Api::_()->sitecontest()->getPageId($contest_url);
	    }
	    if( !empty($sitecontestUrlEnabled) ) {
	      if( !empty($contest_id) || (in_array(strtolower($contest_url), $urlArray)) ) {
	        $error_msg3 = Zend_Registry::get('Zend_Translate')->_("URL not available.");
	        echo Zend_Json::encode(array('success' => 0, 'error_msg' => "<span style='color:red;'><img src='" . $view->layout()->staticBaseUrl . "application/modules/Sitecontest/externals/images/cross.png'/>$error_msg3</span>"));
	        exit();
	      }
	    } else {
	      if( !empty($contest_id) ) {
	        $error_msg3 = Zend_Registry::get('Zend_Translate')->_("URL not available.");
	        echo Zend_Json::encode(array('success' => 0, 'error_msg' => "<span style='color:red;'><img src='" . $view->layout()->staticBaseUrl . "application/modules/Sitecontest/externals/images/cross.png'/>$error_msg3</span>"));
	        exit();
	      }
	    }
	    if( !preg_match("/^[a-zA-Z0-9-_]+$/", $contest_url) ) {
	      $error_msg4 = Zend_Registry::get('Zend_Translate')->_("URL component can contain alphabets, numbers, underscores & dashes only.");
	      echo Zend_Json::encode(array('success' => 0, 'error_msg' => "<span style='color:red;'><img src='" . $view->layout()->staticBaseUrl . "application/modules/Sitecontest/externals/images/cross.png'/>$error_msg4</span>"));
	      exit();
	    } else {
	      $error_msg5 = Zend_Registry::get('Zend_Translate')->_("URL Available!");
	      echo Zend_Json::encode(array('success' => 1, 'success_msg' => "<span style='color:green;'><img src='" . $view->layout()->staticBaseUrl . "application/modules/Sitecontest/externals/images/tick.png'/>$error_msg5</span>"));
	      exit();
	    }
	}
	public function entrydeleteAction() {
	    $entry = Engine_Api::_()->getItem('sitecontest_entry', $this->getRequest()->getParam('entry_id'));
	    $contest = Engine_Api::_()->getItem('sitecontest_contest', $entry->contest_id);
	    $page = $this->_getParam('entrypage');
	    // if( !$this->_helper->requireAuth()->setAuthParams($contest, null, 'delete')->isValid()) return;

	    // In smoothbox
	    $this->_helper->layout->setLayout('default-simple');

	    $this->view->form = $form = new Sitecontest_Form_Deleteentry();

	    if( !$entry ) {
	      $this->view->status = false;
	      $this->view->error = Zend_Registry::get('Zend_Translate')->_("Entry entry doesn't exist or not authorized to delete");
	      return;
	    }

	    if( !$this->getRequest()->isPost() ) {
	      $this->view->status = false;
	      $this->view->error = Zend_Registry::get('Zend_Translate')->_('Invalid request method');
	      return;
	    }

	    $db = $entry->getTable()->getAdapter();
	    $db->beginTransaction();
	    try {
	      $entry->delete();
	      $contest->entry_count--;
	      $contest->save();
	      
	      $db->commit();
	    } catch( Exception $e ) {
	      $db->rollBack();
	      throw $e;
	    }

	    if(empty($page)) {	
	    	$this->_forward('success', 'utility', 'core', array(
          'smoothboxClose' => true,
          // 'parentRefresh' => true,
          'class' => 'global_form_popup',
          'messages' => array(Zend_Registry::get('Zend_Translate')->_('Your entry has been deleted successfully.'))));
	    } else {
	    		return $this->_forward('success' ,'utility', 'core', array(
	  					'parentRedirect' => Zend_Controller_Front::getInstance()->getRouter()->assemble(array('action' => 'contestview','contest_url' => $contest->contest_url), 'sitecontest_entry_view', true),
	  					'messages' => array(Zend_Registry::get('Zend_Translate')->_('Your entry has been deleted successfully.'))
						));
      }
	}

	public function tagscloudAction() {
	 	$this->_helper->content
	        //->setNoRender()
	        ->setEnabled()
	        ;
    }

   public function createsongAction()
  	{
  		$file = $_FILES['file'];
  		
  		if( is_array($file) ) {
            $filename = $file['name'];
        } else if( is_string($file) ) {
            $filename = $file;
        } else {
            throw new Exception('Invalid upload or file too large');
        }

        // Check file extension
        if( !preg_match('/\.(mp3|m4a|aac|mp4)$/iu', $filename) ) {
            throw new Exception('Invalid file type');
        }


        // upload to storage system
        $params = array(
            'type' => 'song',
            'name' => $filename,
            'parent_type' => 'sitecontest_music',
            'parent_id' => Engine_Api::_()->user()->getViewer()->getIdentity(),
            'user_id' => Engine_Api::_()->user()->getViewer()->getIdentity(),
            'extension' => substr($filename, strrpos($filename, '.') + 1),
        );
        $song = Engine_Api::_()->storage()->create($file, $params);
        $this->sendJson([
        'id' => $song->getIdentity(),
        'fileName' => $_FILES['file']['name']
      	]);
        return $song;
	}


	public function uploadAction()
  	{
  		$file = $_FILES['file'];
  		
  		if( is_array($file) ) {
            $filename = $file['name'];
        } else if( is_string($file) ) {
            $filename = $file;
        } else {
            throw new Exception('Invalid upload or file too large');
        }
        
        // Check file extension
        if( !preg_match('/\.(webm|mp4)$/iu', $filename) ) {
            throw new Exception('Invalid file type');
        }

        $params = array(
            'type' => 'video',
            'name' => $filename,
            'parent_type' => 'sitecontest_video',
            'parent_id' => Engine_Api::_()->user()->getViewer()->getIdentity(),
            'user_id' => Engine_Api::_()->user()->getViewer()->getIdentity(),
            'extension' => substr($filename, strrpos($filename, '.') + 1),
        );
        
        $video = Engine_Api::_()->storage()->create($file, $params);
        $this->sendJson([
        'id' => $video->getIdentity(),
        'fileName' => $_FILES['file']['name']
      	]);
        
        return $video;
	  }

	public function juryAction() {
		$this->_helper->content
	        //->setNoRender()
	        ->setEnabled()
	        ;
	}
	public function pinboardAction() {
		$this->_helper->content
	        //->setNoRender()
	        ->setEnabled()
	        ;
	}
}
