<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecontest
 * @copyright  Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    2019-08-10 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitecontest_ProfileController extends Seaocore_Controller_Action_Standard {
  
  	//ACTION FOR TELL TO THE FRIEND FOR THIS CONTEST
  	public function tellAFriendAction() {

  		$this->_helper->layout->setLayout('default-simple');
	
		//GET VIEWER DETAIL
		$viewer = Engine_Api::_()->user()->getViewer();
		$viewr_id = $viewer->getIdentity();

		//GET CONTEST ID AND CONTEST OBJECT
		$contest_id = $this->_getParam('contest_id', $this->_getParam('id', null));
		$sitecontest = Engine_Api::_()->getItem('sitecontest_contest', $contest_id);
		if (empty($sitecontest))
			return $this->_forwardCustom('notfound', 'error', 'core');
		//FORM GENERATION
		$this->view->form = $form = new Sitecontest_Form_TellAFriend();
 
		if (!empty($viewr_id)) {
			$value['sender_email'] = $viewer->email;
			$value['sender_name'] = $viewer->displayname;
			$form->populate($value);
		}
	
		if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
			$values = $form->getValues();
			//EDPLODES EMAIL IDS
			$reciver_ids = explode(',', $values['sitecontest_reciver_emails']);

			if (!empty($values['sitecontest_send_me'])) {
			$reciver_ids[] = $values['sitecontest_sender_email'];
			}
			$sender_email = $values['sitecontest_sender_email'];

			//CHECK VALID EMAIL ID FORMITE
			$validator = new Zend_Validate_EmailAddress();
			$validator->getHostnameValidator()->setValidateTld(false);

			if (!$validator->isValid($sender_email)) {
			$form->addError(Zend_Registry::get('Zend_Translate')->_('Invalid sender email address value'));
			return;
			}
			foreach ($reciver_ids as $reciver_id) {
			$reciver_id = trim($reciver_id, ' ');
				if (!$validator->isValid($reciver_id)) {
				  $form->addError(Zend_Registry::get('Zend_Translate')->_('Please enter correct email address of the receiver(s).'));
				  return;
				}
			}
		  $sender = $values['sitecontest_sender_name'];
		  $message = $values['sitecontest_message'];
		  $heading = ucfirst($sitecontest->getTitle());
		  foreach ($reciver_ids as $reciver_id) {
				Engine_Api::_()->getApi('mail', 'core')->sendSystem($reciver_id, 'SITECONTEST_TELLAFRIEND_EMAIL', array(
					'host' => $_SERVER['HTTP_HOST'],
					'sender_name' => $sender,
					'title' => $heading,
					'message' => '<div>' . $message . '</div>',
					'object_link' => 'http://' . $_SERVER['HTTP_HOST'] . Engine_Api::_()->sitecontest()->getHref($sitecontest->contest_id, $sitecontest->owner_id, $sitecontest->getSlug()),
					'sender_email' => $sender_email,
					'queue' => false
				));
		  	}   
			$this->_forwardCustom('success', 'utility', 'core', array(
			  'smoothboxClose' => true,
			  'parentRefresh' => false,
			  'format' => 'smoothbox',
			  'messages' => array(Zend_Registry::get('Zend_Translate')->_('Your message to your friend has been sent successfully.'))
			));
		}
  	}

	public function getCoverPhotoAction() {
		//GET GROUP ID
		$viewer = Engine_Api::_()->user()->getViewer();

		$contest_id = $this->_getParam("contest_id");
		$this->view->sitecontest = $sitecontest = Engine_Api::_()->getItem('sitecontest_contest', $contest_id);
		//START MANAGE-ADMIN CHECK
		$this->view->can_edit = $can_edit = $sitecontest->authorization()->isAllowed($viewer, "edit");
		$onlyMemberWithPhoto = $this->_getParam("onlyMemberWithPhoto", 1);
		if (empty($sitecontest->contest_cover)) {
		  return;
		}
		$tableAlbum = Engine_Api::_()->getDbtable('albums', 'sitecontest');
		$album = $tableAlbum->getSpecialAlbum($sitecontest, 'cover');
		$this->view->photo = $photo = Engine_Api::_()->getItem('sitecontest_photo', $sitecontest->contest_cover);

		$this->view->coverTop = 0;
		$this->view->coverLeft = 0;
		if ($album->cover_params && isset($album->cover_params['top'])) {
		  $this->view->coverTop = $album->cover_params['top'];
		}
	}
}