<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecontest
 * @copyright  Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    2019-08-10 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitecontest_VoteController extends Seaocore_Controller_Action_Standard
{	
	public function voteAction() {
        //GET THE VIEWER.
        $viewer = Engine_Api::_()->user()->getViewer();
        //GET THE VALUE OF RESOURCE ID AND RESOURCE TYPE AND CONTEST ID.
        $this->view->resource_id = $resource_id = $this->_getParam('resource_id');
        $this->view->resource_type = $resource_type = $this->_getParam('resource_type');
        $this->view->contest_id = $contest_id = $this->_getParam('contest_id');
        $this->view->showlikes = $showlikes = $this->_getParam('showlikes');
        //GET THE RESOURCE.
        if ($resource_type == 'member') {
            $resource = Engine_Api::_()->getItem('user', $resource_id);
        } else {
            $resource = Engine_Api::_()->getItem($resource_type, $resource_id);
        }

        //GET THE CURRENT UESRID AND SETTINGS.
        $this->view->viewer_id = $loggedin_user_id = Engine_Api::_()->user()->getViewer()->getIdentity();
        if ((empty($loggedin_user_id))) {
            return;
        }
        
        $voteTable = Engine_Api::_()->getItemTable('sitecontest_vote');
        $notify_table = Engine_Api::_()->getDbtable('notifications', 'activity');
        $db = $voteTable->getAdapter();
        $db->beginTransaction();
        try {
                $vote_id = $voteTable->addVote($resource, $viewer, $contest_id)->vote_id;
                $entry = Engine_Api::_()->getItem('sitecontest_entry',$resource_id);
                $contest = Engine_Api::_()->getItem('sitecontest_contest',$entry->contest_id);
                $user = Engine_Api::_()->getItem('user',$entry->user_id);
                if($entry->user_id != $viewer->getIdentity()) {

                    //Notofication to entry owner
                    $notify_table->addNotification($user, $viewer, $entry, 'sitecontest_vote_new');

                    //Activity feed for Vote
                    $action = Engine_Api::_()->getDbtable('actions', 'activity')->addActivity($viewer, $contest, 'sitecontest_vote_new');
                    if( $action ) {
                      Engine_Api::_()->getDbtable('actions', 'activity')->attachActivity($action, $entry);
                    }
                }

            //PASS THE Vote ID VALUE.
            $this->view->vote_id = $vote_id;
            $db->commit();
        } catch (Exception $e) {
            $db->rollBack();
            throw $e;
        }
        //HERE THE CONTENT TYPE MEANS MODULE NAME
        $num_of_contenttype = Engine_Api::_()->getApi('vote', 'sitecontest')->voteCount($resource_type, $resource_id);
        // $votes_number = $this->view->translate($this->view->locale()->toNumber($num_of_contenttype));
        if(empty($showlikes)){
            $votes_number = $this->view->translate($this->view->locale()->toNumber($num_of_contenttype));
        } else {
            $likeasvote = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitecontest.integrate.buttons');
            if($likeasvote){
                $votes_number = $this->view->translate(array('%s like', '%s likes', $num_of_contenttype), $this->view->locale()->toNumber($num_of_contenttype));
            }else {
                $votes_number = $this->view->translate(array('%s vote', '%s votes', $num_of_contenttype), $this->view->locale()->toNumber($num_of_contenttype));
            }
        }
        $this->view->num_of_vote = "<p onclick='showSmoothBox(); return false;' >" . $votes_number . "</p>";
	}
}

?>