<?php
/**
* SocialEngine
*
* @category Application_Extensions
* @package Sitecontest
* @copyright Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
* @license http://www.socialengineaddons.com/license/
* @version 2019-08-10 9:40:21Z SocialEngineAddOns $
* @author SocialEngineAddOns
*/
?>
<?php 

$routeStartP = "contests";
$routeStartS = "contest";
$module=null;$controller=null;$action=null;$getURL = null;
$request = Zend_Controller_Front::getInstance()->getRequest();
if (!empty($request)) {
	$module = $request->getModuleName(); // Return the current module name.
	$action = $request->getActionName();
	$controller = $request->getControllerName();
	$getURL = $request->getRequestUri();
}
if (empty($request) || !($module == "default" && ( strpos( $getURL, '/install') !== false))) {
	$routeStartP = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitecontest.slugplural', "contests");
	$routeStartS = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitecontest.slugsingular', "contest");
}

return array (
	'package' => 
	array (
		'type' => 'module',
		'name' => 'sitecontest',
		'version' => '5.8.0p1',
		'sku' => 'sat-sitecontest',
		'path' => 'application/modules/Sitecontest',
		'title' => 'Professional Contests Plugin',
		'description' => 'Professional Contests Plugin.',
		'author' => '<a href="http://www.socialapps.tech" style="text-decoration:underline;" target="_blank">SocialApps.tech</a>',
		'callback' => 
		array (
			'class' => 'Engine_Package_Installer_Module',
		),
		'actions' => 
		array (
			0 => 'install',
			1 => 'upgrade',
			2 => 'refresh',
			3 => 'enable',
			4 => 'disable',
		),
		'callback' => array(
			'path' => 'application/modules/Sitecontest/settings/install.php',
			'class' => 'Sitecontest_Installer',
		),
		'directories' => 
		array (
			0 => 'application/modules/Sitecontest',
		),
		'files' => 
		array (
			0 => 'application/languages/en/sitecontest.csv',
		),
	),

	'items' => array(

		'sitecontest_cont',
		'sitecontest_contest', 
		'sitecontest_photo',
		'sitecontest_entry',
		'sitecontest_enty',
		'sitecontest_category',
		'sitecontest_award',
		'sitecontest_album',
		'sitecontest_video',
		'sitecontest_mediamanage',
		'sitecontest_vote',
		'sitecontest_entryitemofthedays',
		'sitecontest_itemofthedays',
		'sitecontest_jury',
		'sitecontest_otherinfo',
		'sitecontest_song',
	),

	'hooks' => array(
		array(
			'event' => 'onSitecontestContCreateAfter',
			'resource' => 'Sitecontest_Plugin_Core',
		),
		array(
			'event' => 'onRenderLayoutDefault',
			'resource' => 'Sitecontest_Plugin_Core',
		),
		array(
			'event' => 'onUserDeleteBefore',
			'resource' => 'Sitecontest_Plugin_Core',
		),
		array(
			'event' => 'onSitecontestContDeleteBefore',
			'resource' => 'Sitecontest_Plugin_Core',
		),
	),

	'routes' => array(
		// Public
		'sitecontest_entry_view' => array(
			'route' => $routeStartS.'/:contest_url/*',
			'defaults' => array(
				'module' => 'sitecontest',
				'controller' => 'index',
				'action' => 'contestview',
			),
		),
		'contest_extended' => array(
	      'route' => $routeStartS.'/upload/:controller/:action/*',
	      'defaults' => array(
	        'module' => 'sitecontest',
	        'controller' => 'index',
	        'action' => 'upload',
	      ),
	      'reqs' => array(
			'action' => '(upload|createsong)',
			),
	    ),
		'Contest_specific' => array(
			'route' => $routeStartS.'/:action/add/:contest_id/*',
			'defaults' => array(
			'module' => 'sitecontest',
			'controller' => 'index',
			'action' => 'entry',
			),
			'reqs' => array(
			'contest_id' => '\d+',
			'action' => '(rule|entry)'
			),
		),
		
		'sitecontest_view' => array(
			'route' => $routeStartS.'/entry/:entry_id/:slug',
			'defaults' => array(
			'module' => 'sitecontest',
			'controller' => 'index',
			'action' => 'entryview',
			'slug' => '',
			),
			'reqs' => array(
			'user_id' => '\d+',
			'contest_id' => '\d+',
			'entry_id' => '\d+',
			'action' => '(entryview)',
			),
		),

		'sitecontest_general' => array(
			'route' => $routeStartP.'/:action/*',
			'defaults' => array(
				'module' => 'sitecontest',
				'controller' => 'index',
				'action' => 'index',
			),
			'reqs' => array(
				'action' => '(browse|index|manage|tagscloud|create|subcategory|photo|text|pageurlvalidation|get-search-pages|subsubcategory|map|pinboard-browse|entrymanage|categories|jury|pinboard|winner)',
			),
		),

		'sitecontest_general_category' => array(
	      'route' => $routeStartP.'/:category_id/:categoryname/*',
	      'defaults' => array(
	          'module' => 'sitecontest',
	          'controller' => 'index',
	          'action' => 'browse',
	      ),
	      'reqs' => array(
	          'category_id' => '\d+'
	      ),
	  	),

	  'sitecontest_general_subcategory' => array(
			'route' => $routeStartP.'/:category_id/:categoryname/:subcategory_id/:subcategoryname/*',
			'defaults' => array(
				'module' => 'sitecontest',
				'controller' => 'index',
				'action' => 'browse',
			),
			'reqs' => array(
				'category_id' => '\d+',
				'subcategory_id' => '\d+'
				),
			),

    	'sitecontest_general_subsubcategory' => array(
	      'route' => $routeStartP.'/:category_id/:categoryname/:subcategory_id/:subcategoryname/:subsubcategory_id/:subsubcategoryname/*',
	      'defaults' => array(
	          'module' => 'sitecontest',
	          'controller' => 'index',
	          'action' => 'browse',
	      ),
	      'reqs' => array(
	          'category_id' => '\d+',
	          'subcategory_id' => '\d+'
	      ),
	    ),

		'dashboard_default' => array(
			'route' => $routeStartP.'/dashboard/:action/:contest_id/*',
			'defaults' => array(
			'module' => 'sitecontest',
			'controller' => 'dashboard',
			'action' => 'edit',
			),
			'reqs' => array(
			'contest_id' => '\d+',
			'action' => '(edit|change-photo|remove-photo|rule|contactinfo|overview|award|metadetail|compose|entries|winner|reset-position-cover-photo|remove-cover-photo|upload-cover-photo)',
			),
		),

		'contest_category' => array(
			'route' => $routeStartP.'/:action/:category_id/:categoryname/*',
			'defaults' => array(
			'module' => 'sitecontest',
			'controller' => 'index',
			'action' => 'category',
			),
			'reqs' => array(
			'category_id' => '\d+',
			),
		),

		'sitecontest_profilepage' => array(
			'route' => $routeStartP.'/profilepage/:action/*',
			'defaults' => array(
				'module' => 'sitecontest',
				'controller' => 'profile',
				//'action' => 'index',
			),
			'reqs' => array(
				'action' => '(message-owner|tell-a-friend|print|contact-detail|get-cover-photo|email-me)',
			),
		),
	),
); 
?>