<?php
/**
* SocialEngine
*
* @category Application_Extensions
* @package Sitecontest
* @copyright Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
* @license http://www.socialengineaddons.com/license/
* @version 2019-08-10 9:40:21Z SocialEngineAddOns $
* @author SocialEngineAddOns
*/
?>
<?php
class Sitecontest_Widget_ContestcoverPhotoSitecontestController extends Engine_Content_Widget_Abstract {

  public function indexAction() {

    //DON'T RENDER IF THERE IS NO SUBJECT
    if (!Engine_Api::_()->core()->hasSubject()) {
      return $this->setNoRender();
    }

    $this->view->columnHeight = $this->_getParam('columnHeight', '300');
    $this->view->showContent = $this->_getParam('showContent', array("mainPhoto","title", "followButton", "likeButton", "joinButton","others"));
    $this->view->statistics = $this->_getParam('statistics', array("followCount", "likeCount"));
    
    //GET VIEWER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();
    
    //GET SITECONTEST SUBJECT
    $this->view->sitecontest = $sitecontest = Engine_Api::_()->core()->getSubject('sitecontest_cont');
    $this->view->photo = $photo = Engine_Api::_()->getItem('sitecontest_photo', $sitecontest->contest_cover);
    //START MANAGE-ADMIN CHECK
    $this->view->can_edit = $can_edit = $sitecontest->authorization()->isAllowed($viewer, "edit");

    //CHECK REQUEST IS ISAJAX OR NOT
    $this->view->isAjax = $isAjax = $this->_getParam('isAjax', null);
    $this->view->cover_params = array('top' => 0, 'left' => 0);
      
    if ($sitecontest->contest_cover) {
      $tableAlbum = Engine_Api::_()->getDbtable('albums', 'sitecontest');
      $album = $tableAlbum->getSpecialAlbum($sitecontest, 'cover');

      if ($album->cover_params)
        $this->view->cover_params = $album->cover_params;
    }
  }
}