<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecontest
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2014-01-02 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitecontest_Widget_OverviewSitecontestController extends Seaocore_Content_Widget_Abstract {

    public function indexAction() {

      //DONT RENDER IF SUBJECT IS NOT SET
      if (!Engine_Api::_()->core()->hasSubject('sitecontest_cont')) { 
          return $this->setNoRender();
      }

      //GET EVENT SUBJECT
      $this->view->sitecontest = $sitecontest = Engine_Api::_()->core()->getSubject('sitecontest_cont');
      $this->view->showComments = $this->_getParam('showComments', 0);

      //GET EDITOR REVIEW ID
      $params = array();
      $params['resource_id'] = $sitecontest->contest_id;
      $params['resource_type'] = $sitecontest->getType();
      $params = $this->_getAllParams();
      $this->view->params = $params;

      if (!Engine_Api::_()->getApi('settings', 'core')->getSetting('sitecontest.overview', 1)) { 
          return $this->setNoRender();
      }

      //GET VIEWER DETAIL
      $viewer = Engine_Api::_()->user()->getViewer();
      $this->view->viewer_id = $viewer_id = $viewer->getIdentity();

      $tableOtherinfo = Engine_Api::_()->getDbTable('otherinfo', 'sitecontest');
      $this->view->overview = $overview = $tableOtherinfo->getColumnValue($sitecontest->getIdentity(), 'overview');

      if (empty($overview) && !$sitecontest->authorization()->isAllowed($viewer, 'edit')) { 
          return $this->setNoRender();
      }
    }
}