<?php
/**
* SocialEngine
*
* @category   Application_Extensions
* @package    Sitecontest
* @copyright  Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
* @license    http://www.socialengineaddons.com/license/
* @version    2019-08-10 9:40:21Z SocialEngineAddOns $
* @author     SocialEngineAddOns
*/
class Sitecontest_Widget_PopularContestSitecontestController extends Engine_Content_Widget_Abstract
{

  public function indexAction() {

    $request = Zend_Controller_Front::getInstance()->getRequest();
    $params = $request->getParams(); 
    $params = array_merge($params, $this->_getAllParams());

    $viewer = Engine_Api::_()->user()->getViewer();

    $this->view->sitepage_browse = 'show';
    $ShowViewArray = $params['layouts_views'] = $this->_getParam('layouts_views', array("0" => "1", "1" => "2"));
    $this->view->is_ajax = $isAjax = $this->_getParam('isajax', 0);
    $listParams = $this->_getParam('contest_item',array('featured','sponsored','recently_created','hot','verified'));
    if ($listParams) {
      foreach ($listParams as $key => $value)
        $listParams[$key] = str_replace("ZZ", "_", $value);
    } else {
      $listParams = array();
    }
    $this->view->type = $listParams;

    $this->view->tabCount = count($listParams);
    if (empty($this->view->tabCount)) {
      return $this->setNoRender();
    }
    $this->view->type = $listParams = $this->setTabsOrder($listParams);

    //START VIEW MORE LINK AND AUTOSCROLL CONTENT WORK
    if(!empty($isAjax)) {
      $this->getElement()->removeDecorator('Title');
      $this->getElement()->removeDecorator('Container');
    }
    //END VIEW MORE LINK AND AUTOSCROLL CONTENT WORK
    $this->view->sharelink = $params['contacts'] = $this->_getParam('contacts',array('like','facebook'));
    $defaultOrder = $params['layouts_oder'] = $this->_getParam('layouts_oder', 1);
    $this->view->columnWidth = $params['columnWidth'] = $this->_getParam('columnWidth', 212);
    $this->view->showpostedBy = $params['showpostedBy'] = $this->_getParam('showpostedBy', 1);
    $this->view->columnHeight = $params['columnHeight'] = $this->_getParam('columnHeight', 270);
    $this->view->turncation = $params['turncation'] = $this->_getParam('turncation', 90);
    $this->view->list_turncation = $params['list_turncation'] = $this->_getParam('list_turncation', 90);

    $this->view->info = $info[] = $this->_getParam('contest_info',array('like','post','date','description','category','views','comment','follow'));    
    $this->view->showContent = $this->_getParam('show_content', 2);
    $this->view->limit = $limit = $this->_getParam('itemCount', 10);


    $this->view->list_view = 0;
    $this->view->grid_view = 0;
    $this->view->defaultView = -1;
    if ($ShowViewArray && in_array("1", $ShowViewArray)) {
      $this->view->list_view = 1;
      if ($this->view->defaultView == -1 || $defaultOrder == 1)
        $this->view->defaultView = 0;
    }

    if ($ShowViewArray && in_array("2", $ShowViewArray)) {
      $this->view->grid_view = 1;
      if ($this->view->defaultView == -1 || $defaultOrder == 2)
        $this->view->defaultView = 1;
    }

    
    if ($this->view->defaultView == -1) {
      return $this->setNoRender();
    }

    $customFieldValues = array();
    
    $this->view->listParams = json_encode($listParams);
    
    $params['sort'] = $this->_getParam('sort');
    if(empty($params['sort'])) {
      $params['sort'] = $listParams[0];
    }

    $this->view->params = $params;
    $this->view->browse = 1;

    $this->view->paginator = $paginator = Engine_Api::_()->sitecontest()->getSitecontestsPaginator($params, $customFieldValues);
    $paginator->setItemCountPerPage($limit);
    $items_count = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('sitecontest.contest', 10);
    $this->view->totalCount =$new= $paginator->getTotalItemCount();

  }

    public function setTabsOrder($tabs) {

        $tabsOrder['featured'] = $this->_getParam('featured_order', 1);
        $tabsOrder['sponsored'] = $this->_getParam('sponsored_order', 2);
        $tabsOrder['verified'] = $this->_getParam('verified_order', 3);
        $tabsOrder['most_viewed'] = $this->_getParam('most_viewed_order', 4);
        $tabsOrder['most_followed'] = $this->_getParam('most_followed_order', 5);
        $tabsOrder['most_joined'] = $this->_getParam('most_joined_order', 6);
        $tabsOrder['active'] = $this->_getParam('active_order', 7);
        $tabsOrder['coming_soon'] = $this->_getParam('coming_soon_order', 8);
        $tabsOrder['ended'] = $this->_getParam('ended_order', 9);
        $tabsOrder['hot'] = $this->_getParam('hot_order', 10);
        $tabsOrder['recently_created'] = $this->_getParam('recently_created_order', 11);
        $tabsOrder['most_liked'] = $this->_getParam('most_liked_order', 12);
        $tabsOrder['most_commented'] = $this->_getParam('most_commented_order', 13);

        $tempTabs = array();
        foreach ($tabs as $tab) {
          $order = $tabsOrder[$tab];
          if (isset($tempTabs[$order]))
            $order++;
          $tempTabs[$order] = $tab;
        }
        ksort($tempTabs);
        $orderTabs = array();
        $i = 0;
        foreach ($tempTabs as $tab)
          $orderTabs[$i++] = $tab;

        return $orderTabs;
    }

}
?>