<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecoupon
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Couponedit.php 6590 2012-06-24 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitecoupon_Form_Admin_Couponedit extends Sitecoupon_Form_Admin_Coupon {

  public function init() {
  
		parent::init();
		
    $this->setTitle('Edit Coupon')
         ->setDescription("Edit your coupon over here, then click 'Edit Coupon' button to edit your settings. Below, you can configure various settings for this coupon like coupon code, expiry date, discount type, discount value, etc. Please note that the parameters (Coupon Code, Discount Type, Discount Value, Restrictions, Ordered Item) cannot be edited once the coupon is used. If you wish to change these, you will have to create a new coupon with new coupon code and disable the existing one.");

    //Here, we can check coupon wiil be use at one time, if not use one time then admin can edit every things.
    $couponId = Zend_Controller_Front::getInstance()->getRequest()->getParam('coupon_id', null);

		//Check for coupon used how many time (if not used one time admin edit every things).
		$usgaeCount = Engine_Api::_()->getDbtable( 'usages' , 'sitecoupon' )->getOneTimeUsages($couponId);

    if (empty($usgaeCount)) {
		  $flag = false;
		} else {
		  $flag = true;
		}

    // Disable some elements
    $this->getElement('code')
			->setIgnore($flag)
			->setAttrib('disable', $flag)
			->clearValidators()
			->setRequired(!$flag)
			->setAllowEmpty($flag);

		// Disable some elements
    $this->getElement('discount_type')
			->setIgnore($flag)
			->setAttrib('disable', $flag)
			->clearValidators()
			->setRequired(!$flag)
			->setAllowEmpty($flag);
		
	  // Disable some elements
    $this->getElement('discount_value')
			->setIgnore($flag)
			->setAttrib('disable', $flag)
			->clearValidators()
			->setRequired(!$flag)
			->setAllowEmpty($flag);
    
    if(Engine_Api::_()->hasModuleBootstrap('sitegateway')) {
		// Disable some elements
        $this->getElement('duration')
                ->setIgnore($flag)
                ->setAttrib('disable', $flag)
                ->clearValidators()
                ->setRequired(!$flag)
                ->setAllowEmpty($flag);

         // Disable some elements
        $this->getElement('duration_in_months')
                ->setIgnore($flag)
                ->setAttrib('disable', $flag)
                ->clearValidators()
                ->setRequired(!$flag)
                ->setAllowEmpty($flag);    
    }

    $this->getElement('minimum_order')
			->clearValidators()
			->setRequired(!$flag)
			->setAllowEmpty($flag);

    $this->getElement('maximum_per_code')
			->clearValidators()
			->setRequired(!$flag)
			->setAllowEmpty($flag);

    $this->getElement('maximum_per_user')
			->clearValidators()
			->setRequired(!$flag)
			->setAllowEmpty($flag);

    $this->getElement('restriction_type')
			->setIgnore($flag)
			->setAttrib('disable', $flag)
			->clearValidators();

    $this->getElement('level_ids')
			->setIgnore($flag)
			->setAttrib('disable', $flag)
			->clearValidators();

    $this->getElement('user_ids')
			->setIgnore($flag)
			->setAttrib('disable', $flag)
			->clearValidators();

    $this->getElement('user_ids')
			->setIgnore($flag)
			->setAttrib('disable', $flag)
			->clearValidators();

    $this->getElement('package_type')
			->setIgnore($flag)
			->setAttrib('disable', $flag)
			->clearValidators()
			->setRequired(!$flag)
			->setAllowEmpty($flag);

    $this->getElement('package_name_select')
			->setIgnore($flag)
			->setAttrib('disable', $flag)
			->clearValidators();

    $this->getElement('package_ids')
			->setIgnore($flag)
			->setAttrib('disable', $flag)
			->clearValidators()
			->setAllowEmpty($flag);

    // Change the submit label
    $this->getElement('execute')->setLabel('Edit Coupon');
  }
}