<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecoupon
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Global.php 6590 2012-06-24 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitecoupon_Form_Admin_Global extends Engine_Form {

  public function init() {

    $this->setTitle('Global Settings')
        ->setDescription('These settings affect all members in your community.');

    $this->addElement('Text', 'sitecoupon_lsettings', array(
			'label' => 'Enter License key',
			'description' => "Please enter your license key that was provided to you when you purchased this plugin. If you do not know your license key, please contact the Support Team of SocialApps.tech from the Support section of your Account Area.(Key Format: XXXXXX-XXXXXX-XXXXXX )",
			'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitecoupon.lsettings'),
    ));

    if (APPLICATION_ENV == 'production') {
      $this->addElement('Checkbox', 'environment_mode', array(
          'label' => 'Your community is currently in "Production Mode". We recommend that you momentarily switch your site to "Development Mode" so that the CSS of this plugin renders fine as soon as the plugin is installed. After completely installing this plugin and visiting few pages of your site, you may again change the System Mode back to "Production Mode" from the Admin Panel Home. (In Production Mode, caching prevents CSS of new plugins to be rendered immediately after installation.)',
          'description' => 'System Mode',
          'value' => 1,
      ));
    } else {
      $this->addElement('Hidden', 'environment_mode', array('order' => 990, 'value' => 0));
    }

    // Add submit button
    $this->addElement('Button', 'submit_lsetting', array(
        'label' => 'Activate Your Plugin Now',
        'type' => 'submit',
        'ignore' => true
    ));

    $this->addElement('Radio', 'sitecoupon_link', array(
			'label' => 'Coupons Link',
			'description' => 'Select the location of the main link for Coupons.',
			'multiOptions' => array(
				3 => 'Main Navigation Menu',
				2 => 'Mini Navigation Menu',
				1 => 'Footer Menu',
				0 => 'Member Home Page Left side Navigation'
			),
			'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitecoupon.link', 3),
    ));

    $contentModule = Engine_Api::_()->getDbtable('types', 'sitecoupon')->getEnabledModules();
    $contentModuleArray = array();
    $modules_enabled = Engine_Api::_()->getApi( 'settings' , 'core' )->getSetting( 'modules.enabled' );
    
		foreach ($contentModule as $modules) { 
			$contentModuleArray[$modules['package_type']] = $modules['title'];
		}
		$contentModuleEn['modules_enabled'] = unserialize( $modules_enabled ) ;

		//VALUE FOR MODULES OPTION.
		$this->addElement( 'MultiCheckbox' , 'modules_enabled' , array (
			'description' => 'Select the product types for which you want coupons to be applicable.' ,
			'label' => 'Product Types' ,
			'multiOptions' => $contentModuleArray,
			'value' => $contentModuleEn['modules_enabled'] ,
		));
    $this->modules_enabled->addDecorator( 'Description' , array ( 'placement' => Zend_Form_Decorator_Abstract::PREPEND , 'escape' => false ) ) ;

    $this->addElement('Button', 'submit', array(
			'label' => 'Save Changes',
			'type' => 'submit',
			'ignore' => true
    ));
  }
}
?>