<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecoupon
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminManageController.php 6590 2012-06-24 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitecoupon_AdminManageController extends Core_Controller_Action_Admin {

  //ACTION FOR MANAGE COUPONS
  public function indexAction() {

    //CREATE NAVIGATION TABS
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
            ->getNavigation('sitecoupon_admin_main', array(), 'sitecoupon_admin_manage_coupon');

    $this->view->contentModule = Engine_Api::_()->getDbtable('types', 'sitecoupon')->getEnabledModules();

    //HIDDEN SEARCH FORM CONTAIN ORDER AND ORDER DIRECTION  
    $this->view->formFilter = $formFilter = new Sitecoupon_Form_Admin_Filter();
    $page = $this->_getParam('page', 1);  // PAGE ID: CONTROLL PAGINATION.

    $couponsTable = Engine_Api::_()->getItemTable('sitecoupon_coupons');
    $couponsTableName = $couponsTable->info('name');
    
    $couponsTableSelect = $couponsTable->select();

    $values = array();

    if ($formFilter->isValid($this->_getAllParams())) {
      $values = $formFilter->getValues();
    }

    foreach ($values as $key => $value) {
      if (null === $value) {
        unset($values[$key]);
      }
    }

    $this->view->code = '';
    $this->view->name = '';
    $this->view->package_type = '';
    $this->view->enabled = '';
    //$this->view->recurrence = '';
    $this->view->expirydate = '';
    $this->view->discount_type = '';
    $this->view->discount_value = '';
    $values = array_merge(array('order' => 'coupon_id', 'order_direction' => 'DESC'), $values);

    if (!empty($_POST['code'])) {
      $coupponCode = $_POST['code'];
    } elseif (!empty($_GET['code'])) {
      $coupponCode = $_GET['code'];
    } else {
      $coupponCode = '';
    }

    if (!empty($_POST['name'])) {
      $couponName = $_POST['name'];
    } elseif (!empty($_GET['name'])) {
      $couponName = $_GET['name'];
    } elseif ($this->_getParam('name', '')) {
      $couponName = $this->_getParam('name', '');
    } else {
      $couponName = '';
    }

    if (!empty($_POST['discount_value'])) {
      $discount_value = $_POST['discount_value'];
    } elseif (!empty($_GET['discount_value'])) {
      $discount_value = $_GET['discount_value'];
    } else {
      $discount_value = '';
    }

    if (!empty($_POST['expirydate'])) {
      $expirydate = $_POST['expirydate'];
    } elseif (!empty($_GET['expirydate'])) {
      $expirydate = $_GET['expirydate'];
    } else {
      $expirydate = '';
    }

    //SEARCHING
    $this->view->code = $values['code'] = $coupponCode;
    $this->view->name = $values['name'] = $couponName;
    $this->view->discount_value = $values['discount_value'] = $discount_value;
    $this->view->expirydate = $values['expirydate'] = $expirydate;

    if (!empty($couponName)) {
      $couponsTableSelect->where($couponsTableName . '.name  LIKE ?', '%' . $couponName . '%');
    }

    if (!empty($coupponCode)) {
      $couponsTableSelect->where($couponsTableName . '.code  LIKE ?', '%' . $coupponCode . '%');
    }

    if (!empty($expirydate)) {
      $couponsTableSelect->where($couponsTableName . '.expirydate  LIKE ?', '%' . $expirydate . '%');
    }

    if (!empty($discount_value)) {
      $couponsTableSelect->where($couponsTableName . '.discount_value  LIKE ?', '%' . $discount_value . '%');
    }

    if (isset($_POST['search'])) {

      if (!empty($_POST['enabled'])) {
        $this->view->enabled = $_POST['enabled'];
        $_POST['enabled']--;
        $couponsTableSelect->where($couponsTableName . '.status = ? ', $_POST['enabled']);
      }

//       if (!empty($_POST['recurrence'])) {
//         $this->view->recurrence = $_POST['recurrence'];
//         $_POST['recurrence']--;
//         $couponsTableSelect->where($couponsTableName . '.recurrence = ? ', $_POST['recurrence']);
//       }

      //CHECK FOR STATUS "ACTIVE OR EXPIRY".
      $today = date('Y-m-d');

      if (!empty($_POST['status']) && ($_POST['status'] == 2)) {
        $this->view->status = $_POST['status'];
        $couponsTableSelect->where($couponsTableName . '.expirydate >= ? ', $today);
      } elseif (!empty($_POST['status']) && ($_POST['status'] == 1)) {
        $this->view->status = $_POST['status'];
        $couponsTableSelect->where($couponsTableName . '.expirydate < ? ', $today);
      }

      //CHECK FOR STATUS "ACTIVE OR EXPIRY".
      if (!empty($_POST['discount_type']) && ($_POST['discount_type'] == 2)) {
        $this->view->discount_type = $_POST['discount_type'];
        $couponsTableSelect->where($couponsTableName . '.discount_type = ? ', 'percentage');
      } elseif (!empty($_POST['discount_type']) && ($_POST['discount_type'] == 1)) {
        $this->view->discount_type = $_POST['discount_type'];
        $couponsTableSelect->where($couponsTableName . '.discount_type = ? ', 'price');
      }

      //CHECK FOR STATUS "ACTIVE OR EXPIRY".
      if (!empty($_POST['package_type'])) {
        $this->view->package_type = $_POST['package_type'];
        $couponsTableSelect->where($couponsTableName . '.package_type = ? ', $_POST['package_type']);
      }
    }

    $this->view->formValues = array_filter($values);
    $this->view->assign($values);
    $couponsTableSelect->order((!empty($values['order']) ? $values['order'] : 'coupon_id' ) . ' ' . (!empty($values['order_direction']) ? $values['order_direction'] : 'DESC' ));

    $this->view->paginator = array();
    $this->view->paginator = Zend_Paginator::factory($couponsTableSelect);
    $this->view->paginator->setItemCountPerPage(100);
    $this->view->paginator->setCurrentPageNumber($page);
  }

  //THIS FUNCTION FOR ENEBLED / DISABLED THE COUPON.
  public function enabledCouponAction() {

    //Get coupon id.
    $coupon_id = $this->_getParam('coupon_id');
    
    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    
    $coupons = Engine_Api::_()->getItemTable('sitecoupon_coupons')->fetchRow(array('coupon_id = ?' => $coupon_id));
    
    try {
			include APPLICATION_PATH . '/application/modules/Sitecoupon/controllers/license/license2.php';
    } 
    catch (Exception $e) {
      $db->rollBack();
      throw $e;
    }
    $this->_redirect('admin/sitecoupon/manage');
  }

  //ACTION FOR MULTI DELETE COUPONS.
  public function deleteselectedAction() {
  
		if ($this->getRequest()->isPost()) {
		
			$values = $this->getRequest()->getPost();
			
			foreach ($values as $key => $value) {
				if ($key == 'delete_' . $value) {
					$couponsTable = Engine_Api::_()->getItem('sitecoupon_coupons', (int) $value);

					//START DELETE COUPON FROM 2CHECKOUT.
					$gateway = Engine_Api::_()->sitecoupon()->enabled2Checkout();
					if (!empty($gateway)) {
						$gatewayPlugin = $gateway->getGateway();

// 						if (!method_exists($gatewayPlugin, 'getService'))
// 						return;

						$gatewayPluginService = $gateway->getService();

						if (method_exists($gatewayPluginService, 'deleteCoupon')) {
							$response = $gatewayPluginService->deleteCoupon($couponsTable->code);
						}
					}
					//END DELETE COUPON FROM 2CHECKOUT.
                    
                    if(Engine_Api::_()->hasModuleBootstrap('sitegateway')) {
                        $gatewaysTable = Engine_Api::_()->getDbtable('gateways', 'payment');
                        foreach( $gatewaysTable->fetchAll(array('enabled = ?' => 1)) as $gateway ) {
                            $gatewayPlugin = $gateway->getGateway();

                            if( method_exists($gatewayPlugin, 'deleteCoupon') && substr($gateway->plugin, 0, 27) == 'Sitegateway_Plugin_Gateway_') { 
                              $gatewayPlugin->deleteCoupon($couponsTable->code);
                            }
                        }                        
                    }                    

					if (!empty($couponsTable)) {
						include APPLICATION_PATH . '/application/modules/Sitecoupon/controllers/license/license2.php';
					}
				}
			}
		}
		
		$this->_helper->redirector->gotoRoute(array('action' => 'index'));
  }

  //ACTION FOR DELETE COUPON.
  public function deleteAction() {
    $this->_helper->layout->setLayout('admin-simple');

    if ($this->getRequest()->isPost()) {
    
      $couponsTable = Engine_Api::_()->getItemTable('sitecoupon_coupons')->fetchRow(array('coupon_id = ?' => $this->_getParam('coupon_id')));

      //START DELETE COUPON FROM 2CHECKOUT.
      $gateway = Engine_Api::_()->sitecoupon()->enabled2Checkout();
      if (!empty($gateway)) {
        $gatewayPlugin = $gateway->getGateway();

// 				if (!method_exists($gatewayPlugin, 'getService'))
// 					continue;
        $gatewayPluginService = $gateway->getService();
        if (method_exists($gatewayPluginService, 'deleteCoupon')) {
          $response = $gatewayPluginService->deleteCoupon(strtoupper($couponsTable->code));
        }
      }
      //END DELETE COUPON FROM 2CHECKOUT.
      
        if(Engine_Api::_()->hasModuleBootstrap('sitegateway')) {
            $gatewaysTable = Engine_Api::_()->getDbtable('gateways', 'payment');
            foreach( $gatewaysTable->fetchAll(array('enabled = ?' => 1)) as $gateway ) {
                $gatewayPlugin = $gateway->getGateway();

                if( method_exists($gatewayPlugin, 'deleteCoupon') && substr($gateway->plugin, 0, 27) == 'Sitegateway_Plugin_Gateway_') { 
                  $gatewayPlugin->deleteCoupon($couponsTable->code);
                }
            }                        
        }           
      
      if (!empty($couponsTable)) {
				include APPLICATION_PATH . '/application/modules/Sitecoupon/controllers/license/license2.php';
      }

      $this->_forward('success', 'utility', 'core', array(
				'smoothboxClose' => 100,
				'parentRefresh' => 100,
				'messages' => array(Zend_Registry::get('Zend_Translate')->_(''))
      ));
    }
  }

  //ACTION FOR COUPON AUTO SUGGEST.
  public function getitemAction() {

    $name = $this->_getParam('name', null);
    if ($name == 'mail') {
      $lable = 'code';
    } 
//     elseif ($name == 'username') {
//       $lable = 'displayname';
//     } 
    else {
      $lable = 'name';
    }

    $coupon_code = $this->_getParam('text', null);
    $limit = $this->_getParam('limit', 40);

    $data = array();

    $coupons = Engine_Api::_()->getItemTable('sitecoupon_coupons')->getCoupons($coupon_code, $limit = 10, $name);

    foreach ($coupons as $coupon) {
      $coupon_photo = $this->view->itemPhoto($coupon, 'thumb.icon');
      $data[] = array(
				'id' => $coupon->coupon_id,
				'label' => $coupon->$lable,
				'photo' => $coupon_photo
      );
    }
    return $this->_helper->json($data);
  }

  //ACTION FOR USER AUTO SUGGEST.
  public function getusersAction() {

    $data = array();

    //GET COUPON ID.
    $couponId = $this->_getParam('couponId', null);

    $usersTable = Engine_Api::_()->getDbtable('users', 'user');
    $usersTableName = $usersTable->info('name');

    $select = $usersTable->select();

    if (!empty($couponId)) {
			$couponsResults = Engine_Api::_()->getItem('sitecoupon_coupons', $this->_getParam('couponId', null))->toArray();
			
			if ($couponsResults['restriction_type'] == 1) {
				$levels = explode(",", $couponsResults['level_ids']);
				$select->where($usersTableName . ".level_id IN (?)", (array) $levels);
			}
			elseif ($couponsResults['restriction_type'] == 2) {
				$user_idsValues = explode(",", $couponsResults['user_ids']);
				$select->where($usersTableName . ".user_id IN (?)", (array) $user_idsValues);
			}
    }

    $select->where($usersTableName.".displayname LIKE ? OR " . $usersTableName.".username LIKE ? OR " . $usersTableName.".email LIKE ?", '%' . $this->_getParam('user_ids_select') . '%')
          ->order('displayname ASC')->limit('40');

    $users = $usersTable->fetchAll($select);

    foreach ($users as $user) {
      $user_photo = $this->view->itemPhoto($user, 'thumb.icon');
      $data[] = array(
				'id' => $user->user_id,
				'label' => $user->displayname,
				'photo' => $user_photo
      );
    }

    return $this->_helper->json($data);
  }
}
?>