<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecoupon
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminUsagereportController.php 6590 2012-06-24 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitecoupon_AdminUsagereportController extends Core_Controller_Action_Admin {

  //ACTION FOR COUPON USAGES.
  public function indexAction() {

    //CREATE NAVIGATION TABS
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
          ->getNavigation('sitecoupon_admin_main', array(), 'sitecoupon_admin_usagereport_coupon');

    $this->view->contentModule = Engine_Api::_()->getDbtable('types', 'sitecoupon')->getEnabledModules();

    //HIDDEN SEARCH FORM CONTAIN ORDER AND ORDER DIRECTION  
    $this->view->formFilter = $formFilter = new Sitecoupon_Form_Admin_Filter();
    $page = $this->_getParam('page', 1);  // PAGE ID: CONTROLL PAGINATION.

    $couponsTable = Engine_Api::_()->getItemTable('sitecoupon_coupons');
    $couponsTableName = $couponsTable->info('name');

    $paymentOrderTable = Engine_Api::_()->getItemTable('payment_order');
    $paymentOrderTableName = $paymentOrderTable->info('name');

    $usagesTable = Engine_Api::_()->getItemTable('sitecoupon_usages');
    $usagesTableName = $usagesTable->info('name');

    $select = $usagesTable->select()
            ->setIntegrityCheck(false)
            ->from($usagesTableName)
            ->join($couponsTableName, "$couponsTableName.coupon_id = $usagesTableName.coupon_id")
            ->join($paymentOrderTableName, "$paymentOrderTableName.order_id = $usagesTableName.order_id");

    $values = array();
    
    if ($formFilter->isValid($this->_getAllParams())) {
      $values = $formFilter->getValues();
    }
    
    foreach ($values as $key => $value) {
      if (null === $value) {
        unset($values[$key]);
      }
    }

    $this->view->name = '';
    $this->view->package_type = '';

    $values = array_merge(array('order' => 'usage_id', 'order_direction' => 'DESC'), $values);

		include APPLICATION_PATH . '/application/modules/Sitecoupon/controllers/license/license2.php';

    if (!empty($_POST['name'])) {
      $couponName = $_POST['name'];
    } elseif (!empty($_GET['name'])) {
      $couponName = $_GET['name'];
    } elseif ($this->_getParam('name', '')) {
      $couponName = $this->_getParam('name', '');
    } else {
      $couponName = '';
    }

    //SEARCHING
    $this->view->name = $values['name'] = $couponName;
    if (!empty($couponName)) {
      $select->where($couponsTableName . '.code  LIKE ?', '%' . $couponName . '%');
    }

    if (isset($_POST['search'])) {
      if (!empty($_POST['state'])) {
        $this->view->state = $_POST['state'];
        $select->where($paymentOrderTableName . '.state = ? ', $_POST['state']);
      }

      if (!empty($_POST['package_type'])) {
        $this->view->package_type = $_POST['package_type'];
        $select->where($couponsTableName . '.package_type = ? ', $_POST['package_type']);
      }
    }

    $this->view->formValues = array_filter($values);
    $this->view->assign($values);
    $select->order((!empty($values['order']) ? $values['order'] : 'coupon_id' ) . ' ' . (!empty($values['order_direction']) ? $values['order_direction'] : 'DESC' ));

    $this->view->paginator = array();
    $this->view->paginator = Zend_Paginator::factory($select);
    $this->view->paginator->setItemCountPerPage(100);
    $this->view->paginator->setCurrentPageNumber($page);
  }

  //ACTION FOR SHOW ORDER.
  public function ordershowAction() {

    //GET THE SOURCE TYPE AND SOURCE ID.
    $itemId = $this->_getParam('source_id');
    $itemType = $this->_getParam('source_type');

    $itemTable = Engine_Api::_()->getItemTable($itemType);
    $itemTableName = $itemTable->info('name');
    
    $usagesTable = Engine_Api::_()->getItemTable('sitecoupon_usages');
    $usagesTableName = $usagesTable->info('name');
    
    $this->view->primary_id = $primary_id = current($itemTable->info("primary"));
    
    $select = $itemTable->select()
    ->setIntegrityCheck(false)
												->from($itemTableName)
												->where("$primary_id = ?", $itemId)
												->join($usagesTableName, "$usagesTableName.resource_id = $itemTableName.$primary_id", array('usage_date'));
    $this->view->itemResults = $itemTable->fetchRow($select);
  }
}