<?php 
class Sitecourse_AdminLevelController extends Core_Controller_Action_Admin
{
	public function indexAction()
	{
		$this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
		->getNavigation('sitecourse_admin_main', array(), 'sitecourse_admin_main_level');
    	// Get level id
		if( null !== ($id = $this->_getParam('id')) ) {
			$level = Engine_Api::_()->getItem('authorization_level', $id);
		} else {
			$level = Engine_Api::_()->getItemTable('authorization_level')->getDefaultLevel();
		}
		if( !$level instanceof Authorization_Model_Level ) {
			throw new Engine_Exception('missing level');
		}
		$id = $level->level_id;
        // Make form
		$this->view->form = $form = new Sitecourse_Form_Admin_Settings_Level(array(
			'public' => ( in_array($level->type, array('public')) ),
			'moderator' => ( in_array($level->type, array('admin', 'moderator')) ),
		));
		$form->level_id->setValue($id);
    	// Populate values
		$permissionsTable = Engine_Api::_()->getDbtable('permissions', 'authorization');
		$form->populate($permissionsTable->getAllowed('sitecourse_course', $id, array_keys($form->getValues())));
    	// Check post
		if( !$this->getRequest()->isPost() ) {
			return;
		}
    	// Check validitiy
		if( !$form->isValid($this->getRequest()->getPost()) ) {
			return;
		}
    	// Process
		$values = $form->getValues();
    	// Form elements with NonBoolean values
		$nonBooleanSettings = $form->nonBooleanFields();
		$db = $permissionsTable->getAdapter();
		$db->beginTransaction();
		try{
      	// Set permissions
			$permissionsTable->setAllowed('sitecourse_course', $id, $values, '', $nonBooleanSettings);
     	// Commit
			$db->commit();
		}
		catch( Exception $e ){
			$db->rollBack();
			throw $e;
		}
		$form->addNotice('Your changes have been saved.');
	}
}
?>
