<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecrowdfunding
 * @copyright  Copyright 2017-2021 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: ProjectOwnerFaq.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitecrowdfunding_Form_Admin_Settings_ProjectOwnerFaq extends Engine_Form {

    public function init() {

        $this->setTitle('FAQs for Project Owner')
                ->setDescription('Compose the list of FAQs for your members creating projects on your site. This will help your site members to understand how they can start a project and what are the various things they need to keep in mind to successfully complete a project. These FAQs will be visible listed in the Project navigation tab.')
                ->setName('faq_projectowner');
        $body = <<<EOD
                <div style="text-align: justify; width: 90%; line-height: 25px; padding: 20px;">
<ol>
<li style="font-weight: 400;"><strong>What are the things I should do before starting my project?</strong><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">You should follow below steps before starting your project:</span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">a) Make a detailed budget of your costs required to bring your idea to life. Use this to set your project&rsquo;s funding goal.</span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">b) Think thoroughly about what rewards to offer to your project&rsquo;s backers</span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">c) Have a plan to market your project so that it can reach to maximum people.</span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">d) Be active before launching your project till it reaches it&rsquo;s funding goal amount.</span><span style="font-weight: 400;"><br><br></span></li>
<li style="font-weight: 400;"><strong>What are the various steps to create a project on this website?</strong><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">a) Click on &lsquo;Start a Project&rsquo; button or link.</span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">b) Select the package with the feature set you need for your project.</span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">c) Fill the required details in the project creation form which you have gathered before starting this process.</span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">d) Go to dashboard of your project to compile overview, to configure payment gateways, to create various rewards, to add videos / photos, to set main photo / video for your project etc.</span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;"><br></span></li>
<li style="font-weight: 400;"><strong>What should I consider while setting up funding goal for my project?</strong><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">Your funding goal should be the minimum amount of funds you need to complete your project along with make and ship of rewards.</span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">Make a list of all the materials, resources, and expenses you'll need to complete your project, and the estimated costs for each. </span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">Share a breakdown of this budget in your project description to show backers you've thought things through.<br><br></span></li>
<li style="font-weight: 400;"><strong>What are the different payment gateways which I can enable for my project&rsquo;s backers?</strong><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">You can configure below payment gateways if they are enabled by the site admin:</span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">a) Stripe</span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">b) PayPal</span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">d) Mangopay</span><span style="font-weight: 400;"><br><br></span></li>
<li style="font-weight: 400;"><strong>What information should I share about my project on its profile page?</strong><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">After visiting your project page backers should have a clear sense of:</span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">a) What is your project as all about.</span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">b) How you will bring your project to life.</span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">c) How the funds collected will be used. </span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">d) The identities of the people on your team (if you have one).</span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">Also, y</span><span style="font-weight: 400;">our project page should tell your story and include an eye-catching project image or video, and some attractive rewards.</span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">The more information you share, the more you will earn your backers&rsquo; trust.</span><span style="font-weight: 400;"><br><br></span></li>
<li style="font-weight: 400;"><strong>How do I include images or other media in my project overview?</strong><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">You can include photos, links, videos etc. in your project overview via TinyMCE editor. </span><span style="font-weight: 400;">TinyMCE offers HTML formatting tools, like bold, italic, underline, ordered and unordered lists, different types of alignments, in-line placement of images and videos, etc. It allows users to edit HTML documents online. The different options can be configured at the time of integration with a project, which improves the flexibility of a project.</span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;"><br></span></li>
<li style="font-weight: 400;"><strong>What are image specifications for project pages?</strong><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">Your project image size should be 680x1400 pixels. Recommended file types are: JPG, JPEG, PNG, or GIF.</span><span style="font-weight: 400;"><br><br></span></li>
<li style="font-weight: 400;"><strong>What does estimated delivery date mean?</strong><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">The estimated delivery date for a reward is the date you expect to deliver that reward to backers. If you're offering more than one thing in a single reward tier, set your estimated delivery date to when you expect everything in the reward tier to be delivered. </span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">If you're not sure what the estimated delivery date is for a reward, take some time out to create a timeline for your project so that you have a good sense of when you'll complete it. Choose a delivery date that you feel confident about and will be working towards.</span><span style="font-weight: 400;"><br><br></span></li>
<li style="font-weight: 400;"><strong>What can be offered as a reward?</strong><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">Rewards are generally items produced by the project itself &mdash; a copy of the album, a print from the show, a limited edition of the comic, naming characters after backers, personal phone calls etc.</span><span style="font-weight: 400;"><br><br></span></li>
<li style="font-weight: 400;"><strong>Is there a way to limit the quantity of a reward?</strong><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">Yes, there is a way to limit the quantity of a reward. You can do so while creating the reward, select the &lsquo;Limit Quantity&rsquo; checkbox and enter the limit for backers who can choose this reward while backing your project.</span><span style="font-weight: 400;"><br><br></span></li>
<li style="font-weight: 400;"><strong>How do I charge shipping on my rewards?</strong><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">You can charge shipping cost for rewards selected by backers of certain places. To do so choose the location where you want to ship your reward and add the shipping charges in the textbox appearing along with it. This shipping cost will be added to the amount set for that reward when a backer selects the reward to fund your project.</span><span style="font-weight: 400;"><br><br></span></li>
<li style="font-weight: 400;"><strong>I am unable to edit my Project. What might be the reason behind it?</strong><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">You are unable to edit your project because of possible below reasons: </span>
<ul>
<li style="font-weight: 400;"><span style="font-weight: 400;">1. Published Project with at least 1 Backer: When a project is in draft mode, it is not finalized so all the details related to that project are editable. But, once a project is published and is backed by at least one backer then few fields are non editable like: Project Duration and Funding Amount.</span></li>
<li style="font-weight: 400;"><span style="font-weight: 400;">If Project Owner still wants to edit the published project then he can contact to the site admin. Site admin can take proper action in such scenario and do the needful changes.</span></li>
</ul>
</li>
<li style="font-weight: 400;"><strong>I am unable to delete my Project. What might be the reason behind it?</strong><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">You are unable to delete your project because of possible below reasons: </span>
<ul>
<li style="font-weight: 400;"><span style="font-weight: 400;">1. Project Backer&rsquo;s: When the project is funded even by a single backer.</span></li>
<li style="font-weight: 400;"><span style="font-weight: 400;">2. Member Level Settings: &lsquo;Allow Deletion of Projects?&rsquo; is disabled for the member belonging to the particular member level.</span></li>
<li style="font-weight: 400;"><span style="font-weight: 400;">If Project Owner still wants to delete the project then he can contact to the site admin. Site admin can take proper action in such scenario like: to refund the backed amount to the respective backer and delete the project.</span></li>
<li style="font-weight: 400;"><span style="font-weight: 400;">[Note: In case, no one has backed the project or the project is in draft mode, then Project Owner can delete that project.]</span></li>
</ul>
</li>
<li style="font-weight: 400;"><strong>Is it possible for a project to be funded more than the set goal amount?</strong><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">Yes, it is possible for a project to be funded more than the set goal amount or more than 100%.</span><span style="font-weight: 400;"><br><br></span></li>
<li style="font-weight: 400;"><strong>Is it possible to run a Project without creating any rewards in it? I am unable to find the link to create rewards in my Project, from where I can do the same?</strong><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">Yes, it is possible to run a Project without creating any rewards in it. There is always one option to back the project with any desired amount and that is without selecting any rewards. </span>
<ul>
<li style="font-weight: 400;"><span style="font-weight: 400;">To create rewards in a project, follow below steps:</span></li>
<li style="font-weight: 400;"><span style="font-weight: 400;">1. Open the profile page of the project.</span></li>
<li style="font-weight: 400;"><span style="font-weight: 400;">2. Now, go to the dashboard of this project.</span></li>
<li style="font-weight: 400;"><span style="font-weight: 400;">3. Click on &ldquo;Rewards&rdquo; from the options displaying on left side of the dashboard page.</span></li>
<li style="font-weight: 400;"><span style="font-weight: 400;">4. Create / edit / delete various rewards from here.</span><span style="font-weight: 400;"><br></span></li>
</ul>
</li>
<li style="font-weight: 400;"><strong>I am unable to edit / delete my reward of my Project. What might be the reason behind it?</strong><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">You are unable to edit / delete reward of your project because of possible below reasons: </span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">1. Reward Selected: Once a reward is selected by even a single backer then few fields become non editable like: Backed Amount, Estimated Delivery, Shipping Details and Reward Quantity.</span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">2. Project Completed: Once a project has reached its goal in defined set of time, rewards of these projects cannot be edited or deleted whether it has been selected any backer or not.</span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">[Note: If Project Owner still wants to edit / delete the selected reward then he can contact to the site admin. Site admin can do the needful changes.]</span><span style="font-weight: 400;"><br><br></span></li>
<li style="font-weight: 400;"><strong>If I choose a subcategory, will my project also show up in the main category?</strong><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">Yes. For example, if you have started an art based project and you put it in the Art subcategory i.e. Design, your project will appear in the both Art and Design category / sub-category.</span><span style="font-weight: 400;"><br><br></span></li>
<li style="font-weight: 400;"><strong>Can I run more than one project at once?</strong><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">Yes, you can run more than one project at once. But, we recommend you to focus on one project at a time as it requires lots of your effort, time and patience.</span><span style="font-weight: 400;"><br><br></span></li>
<li style="font-weight: 400;"><strong>Will my project go live automatically once it's approved?</strong><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">Yes, your project will be live automatically once it is approved by site admin.</span><span style="font-weight: 400;"><br><br></span></li>
<li style="font-weight: 400;"><strong>When and how should I start planning my promotion strategy?</strong><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">You should start planning as soon as you decide you want to run a project. Start by thinking through who your existing fans and contacts are and organizing their information into an actionable contact list.</span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">Choose different social media&rsquo;s and ways to promote your project. This way it will reach out to maximum people. You can also ask your friends, family members, team members etc. to spread the word about your project.</span><span style="font-weight: 400;"><br><br></span></li>
<li style="font-weight: 400;"><strong>My funding has stalled after a few days, what should I do?</strong><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">a) You can change your promotion strategy.</span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">b) Ask friends and family to share your project with their networks. Getting your project beyond your immediate supporters can only help. </span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">c) Share your project via blogs, newsletters etc.</span><span style="font-weight: 400;"><br><br></span></li>
<li style="font-weight: 400;"><strong>Where can I find my project ?</strong><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">You can find your created projects, backed / liked / favorited projects at one place, i.e. at &lsquo;My Projects&rsquo; page.</span><span style="font-weight: 400;"><br><br></span></li>
<li style="font-weight: 400;"><strong>Where can I track my project&rsquo;s progress?</strong><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">You can track your project&rsquo;s progress from &lsquo;My Projects&rsquo; page or from the project&rsquo;s profile page.</span><span style="font-weight: 400;"><br><br></span></li>
<li style="font-weight: 400;"><strong>What is my responsibility for answering questions from backers and non-backers?</strong><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">Backers: You can contact your backers from &lsquo;Backers Report&rsquo; section of the dashboard of your project. You can compose message for specific backer or all backers at once.</span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">Non-backers: The members who are interested in your project and wants to contact you before backing your project, can do so via &lsquo;Contact me&rsquo; button placed on the project profile page.</span><span style="font-weight: 400;"><br><br></span></li>
<li style="font-weight: 400;"><strong>Can I run my project again if funding is unsuccessful?</strong><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">Yes, of course! You can always try again and relaunch with a new goal, whenever you're ready. </span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">Before relaunching, we recommend taking some time to review your project to see what might be improved the next time around. </span><span style="font-weight: 400;"><br><br></span></li>
<li style="font-weight: 400;"><strong>What do I do if I miss my Estimated Delivery Date?</strong><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">The Estimated Delivery Date is intended to set expectations for backers on when they will receive rewards. Setbacks are possible with any project &mdash; creative ones especially. When the unforeseen occurs, creators are expected to post a project update explaining the situation. Sharing the story, speed bumps and all.</span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">Creators who are honest and transparent will find backers to be far more forgiving. We&rsquo;ve all felt the urge to avoid things when we feel bad about them, but leaving backers in the dark makes them assume the worst. It not only reflects badly on the project, it&rsquo;s disrespectful to the support that community has given. Regular communication is a must.</span><span style="font-weight: 400;"><br><br></span></li>
<li style="font-weight: 400;"><strong>What should I consider when I'm planning to relaunch my project?</strong><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">Each launched project is a learning experience, so if you're planning to re-launch a project that wasn't successful in reaching it's goal, just make sure you've taken stock of what worked and what didn't. Here are some common points that creators usually reexamine:</span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">a) Your project's goal and budget. </span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">b) Your supporters. Did you let your supporters know about your project? </span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">c) Your promotion plan. </span><span style="font-weight: 400;"><br><br></span></li>
<li style="font-weight: 400;"><strong>How do I communicate with backers?</strong><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">To communicate with your backers, you can post announcements in your project&rsquo;s profile page. You can also start a discussion if want any opinion of your backers.</span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;"><br></span></li>
<li style="font-weight: 400;"><strong>What information can I see about my backers?</strong><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">You can see backers name, amount funded, payment method and mode used while backing your project. </span><span style="font-weight: 400;"><br><br></span></li>
<li style="font-weight: 400;"><strong>How can I use the backer export?</strong><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">The backer export (available from your Backer Report) lets you export all your backer data into a spreadsheet where you can organize and sort the information to meet </span><span style="font-weight: 400;"><br></span><span style="font-weight: 400;">almost any need. </span><span style="font-weight: 400;"><br></span></li>
</ol>
</div>
EOD;
        $coreSettings = Engine_Api::_()->getApi('settings', 'core');
        $this->addElement('Text', "sitecrowdfunding_projectownerfaq_title", array(
            'label' => 'Title',
            'description' => 'Please enter the title below which you want to be visible to users.',
            'value' => $coreSettings->getSetting('sitecrowdfunding.projectownerfaq.title', 'FAQs for Project Owner'),
            'required' => true,
            'allowEmpty' => false,
            'filters' => array(
                'StringTrim',
            ),
        ));
        $filter = new Engine_Filter_Html();
        $this->addElement('TinyMce', 'sitecrowdfunding_projectownerfaq_body', array(
            'label' => 'Description',
            'description' => 'Click on the Fullscreen icon in the Editor to get the editor in fullscreen mode, thus enabling you to create your content better.',
            'value' => $coreSettings->getSetting('sitecrowdfunding.projectownerfaq.body', $body),
            'required' => true,
            'allowEmpty' => false,
            'attribs' => array('rows' => 180, 'cols' => 350, 'style' => 'width:740px; max-width:740px;height:858px;'),
            'editorOptions' => Engine_Api::_()->seaocore()->tinymceEditorOptions(),
            'filters' => array(new Engine_Filter_Censor(), $filter),
        ));
        $this->addElement('Checkbox', 'sitecrowdfunding_projectownerfaq_enabled', array(
            'label' => "Enable Project Owner FAQ page",
            'value' => 1
        ));
        // Element: Button Submit
        $this->addElement('Button', 'submit', array(
            'label' => 'Save',
            'type' => 'submit',
            'ignore' => true,
        ));
    }

}
