<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecoretheme
 * @copyright  Copyright 2018-2019 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: InstallController.php 6590 2018-26-01 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitedating_InstallController extends Core_Controller_Action_Standard
{

  protected $_token;

  public function init()
  {
    $this->_helper->contextSwitch->initContext();
    $settingsTable = Engine_Api::_()->getDbtable('settings', 'core');
    $settingsTable->setSetting('sitecoretheme.template.name', "sitedating");
    $row = $settingsTable->fetchRow($settingsTable->select()
        ->where('name = ?', 'sitedating.install.ssotoken'));
    $this->_token = $row ? $row->value : null;    
    $token = $this->_getParam('key', false);
    if( $token != $this->_token ) {
      exit(0);
    }
  }

  public function postInstallAction()
  {
    //VIEWER IS NULL HERE, SET VIEWER AS ADMIN
    $user = Engine_Api::_()->user()->getUser(1);
    Engine_Api::_()->user()->setViewer($user);
    ini_set('max_execution_time', 0);
    //CREATE LANDING PAGE OF DATING THEME, REST ALL PAGES ARE CREATED FROM SITECORETHEME MODULE
    Engine_Api::_()->getApi('pagelayouts', 'sitedating')->setDefaultLayout(array('sitecoretheme_landing_page_layout' => 1));
    Engine_Api::_()->getApi('pagelayouts', 'sitedating')->configureSliderWidget();
    Engine_Api::_()->getApi('pagelayouts', 'sitedating')->configureHighlightWidget();
    Engine_Api::_()->getApi('pagelayouts', 'sitedating')->configureStatsWidget();
    Engine_Api::_()->getApi('pagelayouts', 'sitedating')->configureTextBannerWidget();
    Engine_Api::_()->getApi('pagelayouts', 'sitedating')->configureContentBlocksWidget();
    Engine_Api::_()->getApi('pagelayouts', 'sitedating')->configureCtaButtonsWidget(); 
    Engine_Api::_()->getApi('pagelayouts', 'sitedating')->configureCommonSettings(); 
    Engine_Api::_()->getApi('pagelayouts', 'sitedating')->configureBannerImagesWidget();
    Engine_Api::_()->getApi('pagelayouts', 'sitedating')->updateThemeName();
    $settingsTable = Engine_Api::_()->getDbtable('settings', 'core');
    $settingsTable->delete(array('name = ?' => 'sitedating.install.ssotoken'));
    exit(0);
  }

}