<?php

/**
* SocialEngine
*
* @category   Application_Extensions
* @package    Sitemetatag
* @copyright  Copyright 2017-2021 BigStep Technologies Pvt. Ltd.
* @license    http://www.socialengineaddons.com/license/
* @version    $Id: SiteSocialMetaTag.php 2017-03-27 9:40:21Z SocialEngineAddOns $
* @author     SocialEngineAddOns
*/
class Sitedeeplinking_View_Helper_FacebookMetaTag extends Zend_View_Helper_Abstract {

    // SET META TAGS FOR WEBSITE
    public function facebookMetaTag() {
        $settings = Engine_Api::_()->getApi('settings', 'core');
$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
        // SET DOCTYPE THAT SUPPORTS OPEN GRAPH META TAGS
        $setRdfa = !($view->doctype()->isRdfa());
        if ($setRdfa) {
            $currentDoctype = $view->doctype()->getDoctype();
            $view->doctype('XHTML1_RDFA');
        }
        $request = Zend_Controller_Front::getInstance()->getRequest();
        $contentUrl = $view->absoluteUrl($request->getRequestUri());
        $androidAppname = $settings->getSetting('siteandroid.app.name');
        $androidPackageName = $settings->getSetting('siteandroidapp.package.name');
        $view->headMeta()->setProperty('al:android:url',  $contentUrl);
        $view->headMeta()->setProperty('al:android:package', $androidPackageName);
        $view->headMeta()->setProperty('al:android:app_name',$androidAppname);
        //for ios...............
        $iosappName = $settings->getSetting('siteios.app.name');
        $app_store_id = $settings->getSetting('siteios.appstore.id');
        $view->headMeta()->setProperty('al:ios:url',  $contentUrl);
        $view->headMeta()->setProperty('al:ios:app_store_id', $app_store_id);
        $view->headMeta()->setProperty('al:ios:app_name',$iosappName);
        
      
        if ($setRdfa) {
            $view->doctype($currentDoctype);
        }
    }

    
}