<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteemailverification
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Siteemailverification_Api_Core extends Core_Api_Abstract
{
  /**
   * Send email for verification
   * $params : array
   */
  public function emailVerification($params = array()) 
  {
    $siteName = Engine_Api::_()->getApi('settings','core')->core_general_site_title;
    $email = Engine_Api::_()->getApi('settings', 'core')->core_mail_from;
    $reciever_email = $params['email'];
    $view = Zend_Registry::get('Zend_View');
    $subject = "$siteName - Verify your email address";
    $message = '';
    $message .= "Thank you for signing up with us. Your security is our major concern so we request you to verify your email address by clicking on the button below:";
    $message .= "\n";
    $link = $view->absoluteUrl(Zend_Controller_Front::getInstance()->getRouter()->assemble(array(
                    'action' => 'verify-email',
                    'token' => $this->getVerifyToken($params['user_id']),
                    'verify' => $params['code']
                        ), 'verify_email', true));
    $button = "<a href=$link style='background: #619dbe;padding: 14px 18px;margin-top: 10px;display: inline-block;border-radius: 4px;color: #fff;text-decoration: none;font-weight: bold;'>Verify your email address</a>";
    $moremessage = "We appreciate your cooperation.";
    Engine_Api::_()->getApi('mail', 'core')->sendSystem($reciever_email, 'VERIFICATION_EMAIL_NOTIFICATION', array(
        'subject' => $subject,
        'message' => $message,
        'object_link' => $button,
        'moremessage' => $moremessage,
        'email' => $email,
        'queue' => false 
      )
    );
  }

  /**
   * Send email to user who will be suspended
   * $params : array
   */
  public function suspendedUsersEmail($params = array()) {
    $siteName = Engine_Api::_()->getApi('settings','core')->core_general_site_title;
    $email = Engine_Api::_()->getApi('settings', 'core')->core_mail_from;
    $reciever_email = $params['email'];
    $subject = "$siteName - Suspension Alert Email";
    $message = '';
    $message .= "Hope you are adoring the features offered by us. This is to remind you of email verification for the uninterrupted continuation of the account registered with us. Please verify your email address by simply clicking on the below button:";
    $message .= "\n";
    $view = Zend_Registry::get('Zend_View');
    $link = $view->absoluteUrl(Zend_Controller_Front::getInstance()->getRouter()->assemble(array(
                    'action' => 'verify-email',
                    'token' => $this->getVerifyToken($params['user_id']),
                    'verify' => $params['code']
                        ), 'verify_email', true));
    $button = "<a href=$link style='background: #619dbe;padding: 14px 18px;margin-top: 10px;display: inline-block;border-radius: 4px;color: #fff;text-decoration: none;font-weight: bold;'>Verify your email address</a>";
    $moremessage = "You are left with only ".$params['remaining_time']." days before your account gets suspended. We suggest you to do it as early as possible.";
    Engine_Api::_()->getApi('mail', 'core')->sendSystem($reciever_email, 'SUSPENDED_USERS_EMAIL_NOTIFICATION', array(
        'subject' => $subject,
        'message' => $message,
        'object_link' => $button,
        'moremessage' => $moremessage,
        'email' => $email,
        'queue' => false 
      )
    );
  }

  /**
   * Get the token from id
   * $userId : integer
   * @return token
   */
  public function getVerifyToken($userId) {
    return base64_encode(time() . ":" . $userId);
  }

  /**
   * Get the id from token
   * $token : alphanumeric
   * @return user id
   */
  public function getUserIdFromToken($token) {
    $decodedToken = base64_decode($token);
    $decodedToken = explode(':', $decodedToken);
    $userId = $decodedToken[1];
    return $userId;
  }

  /**
   * Suspend the users
   * $user_id : integer
   */
  public function suspendUser($user_id) {
    $user = Engine_Api::_()->getItem('user', $user_id);
    $siteemailverification_user = Engine_Api::_()->getItem('siteemailverification_user', $user_id);
    if (!empty($user) && !$siteemailverification_user->verified_email) {
      $user->enabled = 0;
      $user->save();
    }
  }

  public function countExistingUser() {
    $last_user = Engine_Api::_()->getApi('settings', 'core')->siteemailverification_last_user;
    //count the no of existing users before installation 
    $userTable = Engine_Api::_()->getDbtable('users', 'user');
    $countExistingUser = $userTable->select()
        ->from($userTable->info('name'), array('COUNT(*) AS count'))
        ->where('user_id <= ?', $last_user)
        ->where('enabled = ?', 1)
        ->query()
        ->fetchColumn();
    return $countExistingUser;
  }
}
