<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteemailverification
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    Verifications.php 2015-09-10 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteemailverification_Model_DbTable_Verifications extends Engine_Db_Table
{
	protected $_rowClass = "Siteemailverification_Model_Verification";

	public function createCode($user_id, $action = false) {
		$settings = Engine_Api::_()->getApi('settings', 'core');
    $code = md5(microtime()
      .$settings->getSetting('core.secret', 'staticSalt')
      . (string) rand(1000000, 9999999));

		$select = $this->select()
                    ->where('user_id = ?', $user_id);
                  
    $verifyData = $this->fetchRow($select);
    if ($verifyData && $verifyData->user_id) {
      $this->update(array(
        'code' => $code,
        'email_count' => ++$verifyData->email_count,
        'creation_date' => date('Y-m-d H:i:s'),
      ), array(
        'user_id = ?' => $user_id,
      ));
    } else {
    	// Insert the value for verification
    	if ($action) { 
        $this->insert(array(
          'user_id' => $user_id, 
          'code' => $code,
          'email_count' => 1,
          'creation_date' => date('Y-m-d H:i:s'),
        ));
      }
    }
    return $code;
	}
}