<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteemailverification
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteemailverification_Plugin_Core extends Zend_Controller_Plugin_Abstract 
{

  public function onUserLoginBefore($event) {
    $payload = $event->getPayload();
    $user_id = $payload['user_id'];
    $user = Engine_Api::_()->getItem('user', $user_id);
    $siteemailverification_user = Engine_Api::_()->getItem('siteemailverification_user', $user_id);
    // get settings for the existing users
    $verify_allow = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteemailverification.existing.users', 0);
    $last_user = Engine_Api::_()->getApi('settings', 'core')  ->getSetting('siteemailverification.last.user');
    // if Email Verification for Existing Users is disable then return
    if(!$verify_allow && $user->getIdentity() <= $last_user) {
        return;
      }

    if ($user && $user->enabled) {
    	$level_id = $user->level_id;

      // check the users verified their email or not before login again
    	if (!$siteemailverification_user->verified_email) {
        $suspended_duration = Engine_Api::_()->authorization()->getPermission($level_id, 'mailverification', 'suspended_time');
    		$time = $user->creation_date;
    		$time = strtotime($time)+($suspended_duration*86400);
    		if (date('Y-m-d H:i:s', $time) <= date('Y-m-d H:i:s', time())) {
          $user->enabled = 0;
          $user->save();
    		}
    	}
    }
  }

  public function onUserUpdateAfter($event) {

    $payload = $event->getPayload();
    $user_id = $payload['user_id'];
    $user = Engine_Api::_()->getItem('user', $user_id);
    $siteemailverification_user = Engine_Api::_()->getItem('siteemailverification_user', $user_id);
    $preData = $payload->getCleanData();

    if ($preData['email'] != $user->email) {
      $siteemailverification_user->verified_email = 0;
      $siteemailverification_user->save();
    }

    // IF CORE EMAIL VERIFICATION IS ENABLED AND NEW USERS WILL VERIFIY THE EMAIL, UPDATE SEAO_EMAIL_VERIFICATION FIELD
    if ($preData['verified'] == $user->verified) {
      return;
    }
    $setting = Engine_Api::_()->getApi('settings', 'core')->getSetting('user_signup_verifyemail', 0);
    if ($setting == 2 && !empty($user->verified)) {
      $email_user = Engine_Api::_()->getItem('siteemailverification_user', $user_id);
      $email_user->verified_email = 1;
      $email_user->save();
    }

  }

  public function onUserCreateAfter($event)
  {
    $payload = $event->getPayload();
    if( $payload instanceof User_Model_User ) {
      $user_id = $payload['user_id'];
      $table = Engine_Api::_()->getDbtable('users', 'siteemailverification');
      $table->insert(array(
        'user_id' => $user_id, 
        'verified_email' => 0,
      ));
    }
  }

}