<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteemailverification
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminSettingsController.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteemailverification_AdminSettingsController extends Core_Controller_Action_Admin
{
  public function indexAction()
  {
    //TABS CREATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('siteemailverification_admin_main', array(), 'siteemailverification_admin_main_settings');

    // Make Form
    $this->view->form = $form = new Siteemailverification_Form_Admin_Global();
    $values = array();

    $coreSetting = Engine_Api::_()->getApi('settings', 'core');
    $this->view->emailVerify = $coreSetting->user_signup_verifyemail;
    //Get setting of existing users
    $this->view->existing_user = $coreSetting->siteemailverification_existing_users;
    //Get auto verified setting
    $this->view->auto_verified = $coreSetting->siteemailverification_auto_verified;
    
    $this->view->countExistingUser = Engine_Api::_()->siteemailverification()->countExistingUser();

    // Insert the values of form
    if( $this->getRequest()->isPost() && $form->isValid($this->_getAllParams()) ) {
      $values = $form->getValues();
      foreach( $values as $key => $value ) {
        Engine_Api::_()->getApi('settings', 'core')->setSetting($key, $value);
      }
      $form->addNotice('Your changes have been saved.');
    }
  }

  function faqAction()
  {
    // Creation of tabs
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('siteemailverification_admin_main', array(), 'siteemailverification_admin_main_faq');
  }

  function autoVerifiedAction()
  {
    //Get last user id when plugin installed
    $coreSetting = Engine_Api::_()->getApi('settings', 'core');
    $last_user = $coreSetting->getSetting('siteemailverification.last.user');
    $this->view->id = $last_user;

    //Auto verified all existing users
    if( $this->getRequest()->isPost() ) {
      $userTable = Engine_Api::_()->getDbtable('users', 'user');
      $userTableName = $userTable->info('name');
      $select = $userTable->select()
          ->from($userTableName, 'user_id')
          ->where('user_id <= ?', $last_user)
          ->where('enabled = ?', 1)
          ->query()
          ->fetchAll();

      $emailuserTable = Engine_Api::_()->getDbtable('users', 'siteemailverification');
      $db = $emailuserTable->getAdapter();
      $db->beginTransaction();

      try {

        foreach ($select as $key => $value) {
          $emailuserTable->update(array(
            'verified_email' => 1,
          ), array(
            'user_id = ?' => $value['user_id'],
          ));
        }
        $coreSetting->setSetting('siteemailverification.auto.verified', 1);
        $db->commit();
      } catch( Exception $e ) {
        $db->rollBack();
        throw $e;
      }

      return $this->_forward('success', 'utility', 'core', array(
        'smoothboxClose' => true,
        'parentRefresh' => true,
        'format'=> 'smoothbox',
        'messages' => array('All existing users have been successfully auto verified.')
      ));
    }
  }
}

?>