<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteemailverification
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Siteemailverification_Widget_VerifyEmailController extends Engine_Content_Widget_Abstract
{
  public function indexAction()
  {
    // Don't render this if not authorized
    $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->user_id = $user_id = $viewer->getIdentity();
    
    if (!empty($user_id)) {
      $level_id = $level_id = $viewer->level_id;
    } else {
      return $this->setNoRender();
    }
    $user = Engine_Api::_()->getItem('user', $user_id);
    $level_id = $user->level_id;
    
    $this->view->email = $user->email;
    $allow_verify = Engine_Api::_()->authorization()->getPermission($level_id, 'mailverification', 'allow_verify');

    if (!$allow_verify) {
       return $this->setNoRender();
    }

    $coreSettings = Engine_Api::_()->getApi('settings', 'core');
    $emailVerify = $coreSettings->user_signup_verifyemail;
    $approved = $user->approved;

    if (!$approved) {
      return $this->setNoRender();
    }

    if($emailVerify == 2) {
      return $this->setNoRender();
    }

    $checkVerifiedUser = Engine_Api::_()->getItem('siteemailverification_user', $user_id);

    if (empty($checkVerifiedUser->verified_email)) {
      $userCreationTime = Engine_Api::_()->user()->getViewer()->creation_date;
      $pluginCreationTime = $coreSettings->siteemailverification_creation_time;
      $this->view->duration = $cookieDuration = Engine_Api::_()->authorization()->getPermission($level_id, 'mailverification', 'duration');
      if ($pluginCreationTime > $userCreationTime) {
        if (Engine_Api::_()->getApi('settings', 'core')->siteemailverification_existing_users){
          $suspendDuration = Engine_Api::_()->getApi('settings', 'core')->siteemailverification_suspended_duration;
          $duration = strtotime($pluginCreationTime)+($suspendDuration*86400);
          if (date('Y-m-d H:i:s', $duration) < date('Y-m-d H:i:s', time())) {
            Engine_Api::_()->siteemailverification()->suspendUser($user_id);
          }
        }
      } else {
        $cookieDuration = Engine_Api::_()->authorization()->getPermission($level_id, 'mailverification', 'duration');
        if ($cookieDuration > 0) {
          $suspendDuration = Engine_Api::_()->authorization()->getPermission($level_id, 'mailverification', 'suspended_time');
          $modified_date = Engine_Api::_()->user()->getViewer()->modified_date;
          if($userCreationTime == $modified_date)
            $userTime = $userCreationTime;
          else 
            $userTime = $modified_date;
          $time = strtotime($userTime)+($suspendDuration*86400);
          if (date('Y-m-d H:i:s', $time) < date('Y-m-d H:i:s', time())) {
            // code for suspended users
            Engine_Api::_()->siteemailverification()->suspendUser($user_id);
          }
        }
      }

      // Get position, text and background color of the tip 
      $this->view->textColor = $coreSettings->getSetting('siteemailverification.tip.text.color', '#ffffff');
      $this->view->backgroundColor = $coreSettings->getSetting('siteemailverification.tip.background.color', '#45b2f0');
      $this->view->buttonColor = $coreSettings->getSetting('siteemailverification.tip.button.color', '#ffffff');
      $this->view->buttonTextColor = $coreSettings->getSetting('siteemailverification.tip.button.text.color', '#333333');

      // Get the verification and re-verification text of tip
      $verificationText = $coreSettings->getSetting('siteemailverification.tip.verification.text', "Please verify your email address by clicking on the button in order to enjoy uninterrupted continuation with us.");
      if ($verificationText) {
        $this->view->verificationText = $verificationText;
      }

      $resendText = $coreSettings->getSetting('siteemailverification.tip.resend.text', "Please [resend_link:click here] if you haven't got verification email.");
      if ($resendText) {
        $chars = preg_split('[resend_link:]', $resendText, -1, PREG_SPLIT_NO_EMPTY);
        $label = explode("]", $chars[1]);
        $text = str_replace("[", "", $chars[0]);
        $this->view->resendText = array('text' => $text, 'label' => $label);
      }
      
      $this->getElement()->setTitle('');
      $defaultParams = array(
        'alignment' => 'bottom',
        'type' => 'flyin'
      );
      $this->view->params = array_merge($defaultParams, $this->_getAllParams());
    } else {
      return $this->setNoRender();
    }
  }

}