<?php

class Siteerror_Form_Admin_Global extends Engine_Form
{

  public function init()
  {

    $settings = Engine_Api::_()->getApi('settings', 'core');
    if ( !is_null($settings->getSetting('siteerror.socialsites.facebook' )))
    {
      $facebook = $settings->getSetting('siteerror.socialsites.facebook');
    } else {
      $facebook = Engine_Api::_()->siteerror()->getSocialUrl('core_social_site_facebook');
    }

    if ( !is_null($settings->getSetting( 'siteerror.socialsites.googleplus' )))
    {
      $google = $settings->getSetting('siteerror.socialsites.googleplus');
    } else {
      $google = Engine_Api::_()->siteerror()->getSocialUrl('core_social_site_googleplus');
    }

    if ( !is_null($settings->getSetting('siteerror.socialsites.twitter')))
    {
      $twitter = $settings->getSetting('siteerror.socialsites.twitter');
    } else {
      $twitter = Engine_Api::_()->siteerror()->getSocialUrl('core_social_site_twitter');
    }

    if ( !is_null($settings->getSetting('siteerror.socialsites.youtube')))
    {
      $youtube = $settings->getSetting('siteerror.socialsites.youtube');
    } else {
      $youtube = Engine_Api::_()->siteerror()->getSocialUrl('core_social_site_youtube');
    }

    if ( !is_null($settings->getSetting('siteerror.socialsites.linkedin')))
    {
      $linkedin = $settings->getSetting('siteerror.socialsites.linkedin');
    } else {
      $linkedin = Engine_Api::_()->siteerror()->getSocialUrl('core_social_site_linkedin');
    }

    $this
    ->setTitle('Global Settings')
    ->setDescription('These settings affect all members in your community.');

    $this->addElement('Heading', 'socialsites', array(
      'description' => '<h3>Social Site Links</h3>Please enter social media links below, if you want to show them on Error Pages of your site. Please note social media links will be shown only on those error pages / templates which support them.',
      'decorators' => array('ViewHelper', array('Description', array('placement' => 'PREPEND', 'escape' => false))),
    ));

    $this->addElement('Text', 'socialsites_facebook', array(
      'label' => 'Facebook',
      'description' => '',
      'value' => $facebook,
    ));
    
    $this->addElement('Text', 'socialsites_googleplus', array(
      'label' => 'Google+',
      'description' => '',
      'value' => $google,
    ));
    $this->addElement('Text', 'socialsites_twitter', array(
      'label' => 'Twitter',
      'description' => '',
      'value' => $twitter,
    ));
    $this->addElement('Text', 'socialsites_youtube', array(
      'label' => 'YouTube',
      'description' => '',
      'value' => $youtube,
    ));
    $this->addElement('Text', 'socialsites_linkedin', array(
      'label' => 'LinkedIn',
      'description' => '',
      'value' => $linkedin,
    ));

    $this->addElement('File', 'site_logo', array(
      'label' => 'Site Logo Image',
      'description' => 'Upload your website logo, if you want to display logo on Error Pages of your site. Please note that logo will be shown only on Maintenance Mode Page & Coming Soon Page.'
    ));
    $this->site_logo->addValidator('Extension', false, 'jpg,jpeg,JPG,JPEG,png,PNG,gif,GIF');

    $fileId = $settings->getSetting('siteerror.site.logo', 0);
    $photoUrl = Engine_Api::_()->siteerror()->getPhotoUrl($fileId);
    if( $photoUrl ) {
      $this->addElement('Dummy', 'custom_photo_preview', array(
        'description' => '<img src="' . $photoUrl . '" alt="" />',
        'escape' => false,
      ));
      $this->custom_photo_preview->getDecorator('Description')->setOptions(array('escape' => false));
      $this->addElement('Checkbox', 'remove_photo', array(
        'label' => 'Remove Logo.'
      ));
    }

    $this->addElement('Button', 'submit', array(
      'label' => 'Save Changes',
      'type' => 'submit',
      'ignore' => true
    ));
  }

}