<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Mobi
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 * @version    $Id: Core.php 9747 2012-07-26 02:08:08Z john $
 * @author     Charlotte
 */

/**
 * @category   Application_Extensions
 * @package    Mobi
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 */
class Siteerror_Plugin_Core extends Zend_Controller_Plugin_Abstract
{

  public function routeShutdown(Zend_Controller_Request_Abstract $request)
  {
    $front = Zend_Controller_Front::getInstance();
    if ($front->hasPlugin('Zend_Controller_Plugin_ErrorHandler')) {
      $front->getPlugin('Zend_Controller_Plugin_ErrorHandler')
        ->setErrorHandler(array('module' => 'siteerror'));
    }
    // CHECK IF ADMIN
    if( substr($request->getPathInfo(), 1, 5) == "admin" ) {
      return;
    }

    if ($request->isPost()) {
      return;
    }

    $coreSettingApi = Engine_Api::_()->getApi('settings', 'core');
    $comingsoon_enable = $coreSettingApi->getSetting('siteerror.comingsoon.enable', 0);
    $lunchDate = $coreSettingApi->getSetting('siteerror.comingsoon.launchdate');
    $viewer = Engine_Api::_()->user()->getViewer();
    if( !($viewer && $viewer->getIdentity()) && $comingsoon_enable && $lunchDate && (strtotime($lunchDate) > time()) ) {
      $controller = $request->getControllerName();
      $action = $request->getActionName();
      if( ( $action != 'contact') && $controller != 'comingsoon' ) {
        $redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
        $redirector->gotoRoute(array(), 'siteerror_comingsoon', true);
      }
    }
  }

  public function preDispatch(Zend_Controller_Request_Abstract $request)
  {
    $module = $request->getModuleName();
    $controller = $request->getControllerName();
    $action = $request->getActionName();
    // $allowActions = array('requireuser', 'requireauth', 'requiresubject', 'notfound', 'error');
    if( $module = 'core' && $controller == 'error' ) {
      $request->setModuleName('siteerror');
      $request->setModuleName('siteerror');
    }
  }

}