<?php

class Siteerror_AdminVisitorsController extends Core_Controller_Action_Admin
{

  public function indexAction()
  {
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('siteerror_admin_main', array(), 'siteerror_admin_main_comingsoon');
    $table = Engine_Api::_()->getDbtable('visitors', 'siteerror');
    $this->view->paginator = $paginator = Zend_Paginator::factory($table->select());
    $paginator->setItemCountPerPage(50);
    $paginator->setCurrentPageNumber($this->_getParam('page', 1));
  }

  public function mailAction()
  {
    $this->view->form = $form = new Core_Form_Admin_Message_Mail();
    $form->removeElement('target');
    $description = 'Using this form, you will be able to send an email out to all of your visitors.  Emails are sent out using a queue system, so they will be sent out over time.  An email will be sent to you when all emails have been sent.';
    $form
      ->setTitle('Email All Visitors')
      ->setDescription($description);


    if( !$this->getRequest()->isPost() ) {
      return;
    }

    if( !$form->isValid($this->getRequest()->getPost()) ) {
      return;
    }

    $values = $form->getValues();

    $table = Engine_Api::_()->getDbtable('visitors', 'siteerror');
    $select = new Zend_Db_Select($table->getAdapter());
    $select
      ->from($table->info('name'), 'email')
      ->where('closed = ?', 0); // Do not email disabled members

    $emails = array();
    foreach( $select->query()->fetchAll(Zend_Db::FETCH_COLUMN, 0) as $email ) {
      $emails[] = $email;
    }
    $emails = array_unique($emails);
    // temporarily enable queueing if requested
    $temporary_queueing = Engine_Api::_()->getApi('settings', 'core')->core_mail_queueing;
    if( isset($values['queueing']) && $values['queueing'] ) {
      Engine_Api::_()->getApi('settings', 'core')->core_mail_queueing = 1;
    }

    $mailApi = Engine_Api::_()->getApi('mail', 'core');

    $mail = $mailApi->create();
    $mail
      ->setFrom($values['from_address'], $values['from_name'])
      ->setSubject($values['subject'])
      ->setBodyHtml(nl2br($values['body']))
    ;

    if( !empty($values['body_text']) ) {
      $mail->setBodyText($values['body_text']);
    } else {
      $mail->setBodyText(strip_tags($values['body']));
    }

    foreach( $emails as $email ) {
      $mail->addTo($email);
    }

    $mailApi->send($mail);

    $mailComplete = $mailApi->create();
    $mailComplete
      ->addTo(Engine_Api::_()->user()->getViewer()->email)
      ->setFrom($values['from_address'], $values['from_name'])
      ->setSubject('Mailing Complete: ' . $values['subject'])
      ->setBodyHtml('Your email blast to your members has completed.  Please note that, while the emails have been
        sent to the recipients\' mail server, there may be a delay in them actually receiving the email due to
        spam filtering systems, incoming mail throttling features, and other systems beyond SocialEngine\'s control.')
    ;
    $mailApi->send($mailComplete);

    // emails have been queued (or sent); re-set queueing value to original if changed
    if( isset($values['queueing']) && $values['queueing'] ) {
      Engine_Api::_()->getApi('settings', 'core')->core_mail_queueing = $temporary_queueing;
    }

    $this->view->form = null;
    $this->view->status = true;
  }

}