<?php

class Siteerror_ComingsoonController extends Core_Controller_Action_Standard
{

  public function indexAction()
  {
    $this->_helper->layout->setLayout('default-simple');
    $this->_helper->content->setEnabled();
  }

  public function contactAction()
  {
    $this->view->form = $form = new Siteerror_Form_Comingsoon_Contact();

    if( !$this->getRequest()->isPost() ) {
      return;
    }

    if( !$form->isValid($this->getRequest()->getPost()) ) {
      return;
    }

    $values = $form->getValues();
    // the contact form is emailed to the first SuperAdmin by default
    $users_table = Engine_Api::_()->getDbtable('users', 'user');
    $users_select = $users_table->select()
      ->where('level_id = ?', 1)
      ->where('enabled >= ?', 1);
    $super_admin = $users_table->fetchRow($users_select);
    $adminEmail = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.mail.contact');
    if( !$adminEmail ) {
      $adminEmail = $super_admin->email;
    }
    $error_report = '';
    // Success! Process
    // Mail gets logged into database, so perform try/catch in this Controller
    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    try {
      $visitorsTable = Engine_Api::_()->getDbtable('visitors', 'siteerror');
      $row = $visitorsTable->createRow();
      $row->setFromArray($values);
      $row->save();
      // send email
      Engine_Api::_()->getApi('mail', 'core')->sendSystem($adminEmail, 'core_contact', array(
        'host' => $_SERVER['HTTP_HOST'],
        'email' => $adminEmail,
        'date' => time(),
        'recipient_title' => $super_admin->getTitle(),
        'recipient_link' => $super_admin->getHref(),
        'recipient_photo' => $super_admin->getPhotoUrl('thumb.icon'),
        'sender_title' => $values['name'],
        'sender_email' => $values['email'],
        'message' => $values['body'],
        'error_report' => $error_report,
      ));

      //If the above did not throw an exception, it succeeded
      $db->commit();
      $this->view->message = Zend_Registry::get('Zend_Translate')->_('Thank you for contacting us!');
      return $this->_forward('success', 'utility', 'core', array(
          'smoothboxClose' => true,
          'parentRefresh' => false,
          'messages' => array($this->view->message)
      ));
    } catch( Zend_Mail_Transport_Exception $e ) {
      $db->rollBack();
      throw $e;
    }
  }

}