<?php

/**
 * SocialEngine
 *
 * @category   Application_Core
 * @package    Core
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 * @version    $Id: ErrorController.php 9747 2012-07-26 02:08:08Z john $
 * @author     John
 */

/**
 * @category   Application_Core
 * @package    Core
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 */
class Siteerror_ErrorController extends Core_Controller_Action_Standard
{

  public function errorAction()
  {
    $error = $this->_getParam('error_handler');
    $this->view->error_code = $error_code = Engine_Api::getErrorCode(true);

    // Handle missing pages
    switch( $error->type ) {

      case Zend_Controller_Plugin_ErrorHandler::EXCEPTION_NO_CONTROLLER:
      case Zend_Controller_Plugin_ErrorHandler::EXCEPTION_NO_ACTION:

      if (Engine_Api::_()->getApi('settings', 'core')->getSetting('siteerror.pagenotfound.301redirect',0)) {
        if (!($_SERVER['HTTP_REFERER'])) {
         return $this->_helper->_redirector->gotoRoute(array('action' => 'home'), 'user_general', true);
       }
     }
     return $this->_forward('notfound');
     break;

     default:
     break;
   }

    // Log this message
   if( isset($error->exception) &&
    Zend_Registry::isRegistered('Zend_Log') &&
    ($log = Zend_Registry::get('Zend_Log')) instanceof Zend_Log ) {
      // Only log if in production or the exception is not an instance of Engine_Exception
    $e = $error->exception;
  if( 'production' === APPLICATION_ENV || !($e instanceof Engine_Exception) ) {
    $output = '';
    $output .= PHP_EOL . 'Error Code: ' . $error_code . PHP_EOL;
    $output .= $e->__toString();
    $log->log($output, Zend_Log::CRIT, array(
      'exception' => $e
    ));
  }
}

$this->view->status = false;
$this->view->errorName = get_class($error->exception);

if( APPLICATION_ENV != 'production' ) {
  if( $error->exception instanceof Exception ) {
    $this->view->error = $error->exception->__toString();
  }
} else {
  $this->view->message = Zend_Registry::get('Zend_Translate')->_('An error has occurred');
}
   // Render
  $this->_helper->content
  ->setEnabled()
  ;
}

public function notfoundAction()
{
    // 404 error -- controller or action not found
  $this->getResponse()->setRawHeader($_SERVER['SERVER_PROTOCOL'] . ' 404 Not Found');
  $this->view->status = false;
  $this->view->error = Zend_Registry::get('Zend_Translate')->_('The requested resource could not be found.');

  $static = 'jpg|gif|png|ico|flv|htm|html|php|css|js';
  $ext = pathinfo($this->getRequest()->getRequestUri(), PATHINFO_EXTENSION);
  if( in_array($ext, explode('|', $static)) ) {
    $this->getResponse()->sendHeaders();
    echo $this->view->error;
    exit;
  }
    // Render
  $this->_helper->content
  ->setEnabled()
  ;
}

public function requiresubjectAction()
{
  return $this->_forward('notfound');
}

public function requireauthAction()
{
    // 403 error -- authorization failed
  if( !$this->_helper->requireUser()->isValid() )
    return;
  $this->getResponse()->setRawHeader($_SERVER['SERVER_PROTOCOL'] . ' 403 Forbidden');
  $this->view->status = false;
  $this->view->error = Zend_Registry::get('Zend_Translate')->_('You are not authorized to access this resource.');
    // Render
  $this->_helper->content
  ->setEnabled()
  ;
}

public function requireuserAction()
{
    // 403 error -- authorization failed
  $this->getResponse()->setRawHeader($_SERVER['SERVER_PROTOCOL'] . ' 403 Forbidden');
  $this->view->status = false;
  $this->view->error = Zend_Registry::get('Zend_Translate')->_('You are not authorized to access this resource.');

    // Show the login form for them :P
  $this->view->form = $form = new User_Form_Login();

  if(Engine_Api::_()->getApi('settings', 'core')->getSetting('siteerror.requireuser.enable',1)) {
    $form->setTitle(Engine_Api::_()->getApi('settings', 'core')->getSetting('siteerror.requireuser.heading', 'This Page Requires Login'));
    $form->setDescription(Engine_Api::_()->getApi('settings', 'core')->getSetting('siteerror.requireuser.body','Please Login If You Want To View This Page!'));
    $emailElementName = $form->getEmailElementFieldName();
    $form->getElement($emailElementName)->setAttribs(array('placeholder' => 'Email Address' ));
    $form->getElement('password')->setAttribs(array('placeholder' => 'Password' ));

  }
  $form->addError('Please sign in to continue..');
  $form->return_url->setValue(Zend_Controller_Front::getInstance()->getRouter()->assemble(array()));

    // Render
  $this->_helper->content
  ->setEnabled()
  ;
}

public function requireadminAction()
{
  return $this->_forward('notfound');
}

}