<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteestore
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Curl.php 2012-10-22 9:40:21Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */
class Siteestore_Api_Curl extends Core_Api_Abstract {

  protected $_DATA;

  /**
   * RETURN THE CACHE NAME FOR THE RESPECTIVE BLOCK NAME, CACHE NAME WILL RETURN ACCORDING THE CURRENT URL.
   *
   * @return string
   */
  public function getCacheName($blockName, $cacheProductId = 0) {
    $queryStr = $str = '';
    $front = Zend_Controller_Front::getInstance();
    $requestURL = $front->getRequest()->getRequestUri();

    // Remove query string from the URL, If exist.
    if (strstr($requestURL, '?')) {
      $flagURL = explode("?", $requestURL);
      $queryStr = isset($flagURL[1]) && !empty($flagURL[1]) ? $flagURL[1] : '';
      $requestURL = isset($flagURL[1]) && !empty($flagURL[0]) ? $flagURL[0] : $requestURL;
    }

    $flagURL = explode("/", $requestURL);
    $key = @COUNT($flagURL) - 1;
    $requestURI = !empty($flagURL[$key]) ? $flagURL[$key] : '';
    $requestURI = $requestURI . $queryStr;

    // Findout only charecter in the string.
    for ($flag = 0; $flag < strlen($requestURI); $flag++) {
      $getAsciiNum = ord($requestURI[$flag]);
      if (($getAsciiNum >= 97 && $getAsciiNum <= 122) || ($getAsciiNum >= 65 && $getAsciiNum <= 90) || ($getAsciiNum >= 48 && $getAsciiNum <= 57)) {
        $str .= $requestURI[$flag];
      }
    }
    
    if( !empty($cacheProductId) ) {
      return 'se_siteestore_' . $blockName . '_' . $cacheProductId;
    }
    
    if( empty($str) ) {
      return 'se_siteestore_' . $blockName . '_' . $cacheProductId;
    }
    return 'se_siteestore_' . $blockName . '_' . $str;
  }

  /**
   * SENDING THE cURL REQUEST AND GET THE RESPECTIVE RESULT FROM IT.
   *
   * @param $params: Array of the information.
   */
  public function getCurlResponse($params) {
    // CHECK XML-RPC BRIDGE VALID OR NOT.
    $isBridge = Engine_Api::_()->getApi('Xmlrpc', 'siteestore')->isApiConnValid();
    if (empty($isBridge))
      return;

    $timeout = 0;
    $multiBlockResponce = array();
    $siteestoreApi = Engine_Api::_()->siteestore();

    $hostName = $_SERVER['HTTP_HOST'];

    $front = Zend_Controller_Front::getInstance();
    $frontendCookie = $front->getRequest()->getCookie('frontend');
    $languageCookie = $front->getRequest()->getCookie('en4_language');
    $getMagentoFlag = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteestore_manifestUrl', 'shop');
    $currlReqUrl = $front->getRequest()->getRequestUri();
    if (strstr($currlReqUrl, '?productTagName')) {
      $getTagUrlArray = @explode("?productTagName", $currlReqUrl);
      if (!empty($getTagUrlArray[1])) {
        $getTagUrlArray[1] = str_replace("+", " ", $getTagUrlArray[1]);
      }
      $currlReqUrl = @implode("?productTagName", $getTagUrlArray);
    }

    $hostName = $siteestoreApi->getHostUrl();
    $hostName = str_replace("/index.php", "", $hostName);
    $requestUrl = $hostName . "/socialengine.php";

    $viewer = Engine_Api::_()->user()->getViewer();

    $hostName = $siteestoreApi->getHost();

    $BaseUrl = $getBaseURL = $siteestoreApi->getGlobalUrls();
    $websiteId = $siteestoreApi->getWebsite('id');
    $hostType = $siteestoreApi->getSEProtocol();
    $getReqPath = '';

    $formPostValues = isset($params['postValues']) && !empty($params['postValues']) ? $params['postValues'] : $_POST;
    $userAgent = isset($_SERVER['HTTP_USER_AGENT']) && !empty($_SERVER['HTTP_USER_AGENT']) ? $_SERVER['HTTP_USER_AGENT'] : '';
    $remoteAddress = isset($_SERVER['REMOTE_ADDR']) && !empty($_SERVER['REMOTE_ADDR']) ? $_SERVER['REMOTE_ADDR'] : '';

    $multiBlockResponce = isset($params['multiBlockResponce']) && !empty($params['multiBlockResponce']) ? $params['multiBlockResponce'] : array();

    if (strstr($currlReqUrl, '?')) {
      $restrictedKeys = array('baseUrl', 'actionName', 'format', 'postValues', 'isajax', 'actionName');
      $explodeCurrlReqUrl = explode('?', $currlReqUrl);
      $getUrlParams = explode('&', $explodeCurrlReqUrl[1]);
      $keyArray = array();
      foreach ($getUrlParams as $url) {
        $mainUrl = explode('=', $url);
        if (!in_array($mainUrl[0], $restrictedKeys)) {
          $keyArray[] = $url;
        }
      }
      $keyStr = join('&', $keyArray);
      $currlReqUrl = $explodeCurrlReqUrl[0] . '?' . $keyStr;
    }

    $socilEngineBaseDir = $siteestoreApi->getSEBaseUrl();

    $BaseUrl = isset($params['baseUrl']) && !empty($params['baseUrl']) ? $params['baseUrl'] : $BaseUrl;
    $siteestoreApiPath = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteestore.api.path', '');
    $mageBridgeType = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteestore.bridge.type', 0);
    $request = isset($params['request']) && !empty($params['request']) ? $params['request'] : '';
    $action = isset($params['actionName']) && !empty($params['actionName']) ? $params['actionName'] : 'index';

    $session = new Zend_Session_Namespace();

    // FIND OUT THE REQUEST PAGE FROM THE REQUEST_URI.
    $currlReqUrl = rtrim($currlReqUrl, "/") . "/";

    if (strstr($currlReqUrl, $BaseUrl . '/index')) {
      $currl_url = str_replace($socilEngineBaseDir['path'] . "/" . $BaseUrl . "/index/", "", $currlReqUrl);
    } else if (strstr($currlReqUrl, $BaseUrl . '/cart')) {
      $getReqPath = empty($mageBridgeType) ? $siteestoreApiPath : $getReqPath;
      $currl_url = str_replace($socilEngineBaseDir['path'] . "/" . $BaseUrl . "/cart/", "", $currlReqUrl);
      $currl_url = empty($currl_url) ? 'checkout/cart/' : $currl_url;
    } else {
      $currl_url = str_replace($socilEngineBaseDir['path'] . "/" . $BaseUrl . "/", "", $currlReqUrl);
    }
    $catchName = $currl_url = rtrim($currl_url, "/");
    // SET THE SEARCHING VARIABLE FOR THE SEARCHING FROM THE MAGENTO SEARCH WIDGET.
    if (isset($_GET['search']) && !empty($_GET['search'])) {
      $currl_url = 'catalogsearch/result/?q=' . $_GET['search'];
    }

    // Find out the request page from the REQUEST_URI. If request from "My Cart" and "My Store Account" page.
    $getCatchActionName = trim($catchName, "/");
    $getRequestActionName = trim($currlReqUrl, "/");

    if ($getCatchActionName === $getRequestActionName) {
      $currl_url = str_replace($socilEngineBaseDir['path'] . "/siteestore/", "", $currlReqUrl);
      $catchName = $currl_url = rtrim($currl_url, "/");
    }

    // ADD LANGUAGE (STORE VIEW) IN URL.
    if (!empty($languageCookie)) {
      $languageFlag = $languageCookie;
    } else {
      $defaultLanguage = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.locale.locale', 'en');
      if ($defaultLanguage == 'auto')
        $defaultLanguage = 'en';

      $languageFlag = $defaultLanguage;
    }

    if (!empty($languageFlag)) {
      $languageObj = Engine_Api::_()->getItemTable('siteestore_languagemap')->getLanguage(array('language_code' => $languageFlag));

      // Support Multi Language work.
      // If language mapped then object will return.
      if (!empty($languageObj) && !empty($languageObj[0]['store_view_code'])) {
        if (strstr($currl_url, "?")) {
          $currl_url = $currl_url . '&';
        } else {
          $currl_url = $currl_url . '?';
        }
        $currl_url = $currl_url . '___store=' . $languageObj[0]['store_view_code'];
      }
    }

    // Set variable for catching.
    if (empty($catchName)) {
      $catchName = 'getHomeBlock';
    } else {
      if (strstr($catchName, "?") || strstr($catchName, "checkout") || strstr($catchName, "wishlist") || strstr($catchName, "product_compare")) {
        $catchName = false;
      } else {
        $catchName = str_replace(".", "_", $catchName);
      }
    }

    $magentoBlockSize = Zend_Registry::isRegistered('mage_block_size') ? Zend_Registry::get('mage_block_size') : null;
    if( $action === 'index' ) {
      $currentUrl = $hostType . $socilEngineBaseDir['host'] . $socilEngineBaseDir['path'] . "/" . $getBaseURL . "/";
    }else {
      $currentUrl = $hostType . $socilEngineBaseDir['host'] . $socilEngineBaseDir['path'] . "/" . $getBaseURL . "/" . $action . "/";
    }
    
    // Make the final array of the arguments.
    $curlParams = array(
        'request_uri' => $currl_url,
        'request_path' => $getReqPath,
        'form_value' => $formPostValues,
        'user_agent' => $userAgent,
        'http_host' => $hostName,
        'website' => $websiteId,
        'remote_addr' => $remoteAddress,
        'magento_session' => $frontendCookie,
        'multiBlockResponce' => $multiBlockResponce,
        'base_url' => $currentUrl
    );
    
    // GETTING THE BLOCK NAME, IF MAGENTO WIDGETS ARE NOT DISPLAYING AT MAGENTO WIDGETIZED PAGE AND ADD IT IN CURL REQUEST PARAMS.
    $block = empty($params['block']) ? 'content' : $params['block'];

    if (empty($curlParams['multiBlockResponce'])) {
      $curlParams['multiBlockResponce'] = array($block);
    }

    // SET THE CURRENT PAGE, WHICH REQUIRED IN REPLACED URL ACCORDINGLY.
    $page = isset($params['actionName']) && !empty($params['actionName']) ? $params['actionName'] : 'index';
    // $page = isset($params['actionName']) && !empty($params['actionName']) ? $params['actionName'] : 'index';


    // ENCODE THE CURL REQUEST PARAMS ARRAY FOR SENDING THE CURL REQUEST.
    $arguments_array = array('seintParams' => Zend_Json::encode($curlParams), 'tempPostField' => $formPostValues);
    
    // FOR SENDING THE MULTIDIMENSIONAL ARRAY WITH CURL POST REQUEST.
    $arguments_array = http_build_query($arguments_array);
    
    
    $REQUEST_URI = $_SERVER['REQUEST_URI'];
    $isDownloadableProductActive = false;

    if (strstr($_SERVER['REQUEST_URI'], 'downloadable/download/link/id')) {
      $pos = strpos($REQUEST_URI, 'id/');
      $REQUEST_URI = substr($REQUEST_URI, $pos);
      $explodeRequestUri = @explode("/", $REQUEST_URI);
      if (!empty($explodeRequestUri[1])) {
        $key = $explodeRequestUri[1];
      }

      $contentBody = APPLICATION_PATH . '/public/temporary/' . $key;
      $contentHeader = APPLICATION_PATH . '/public/temporary/' . $key . '_temp';
      $contentBodyCh = @fopen($contentBody, 'w');
      $contentHeaderCh = @fopen($contentHeader, 'w');
      $isDownloadableProductActive = true;
    }

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $requestUrl);
    
    // SET TIME OUT.
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
    // REQUIRED FOR HTTPS URL'S.
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
    // ENABLE THE CURL POST AND SEND THE PARAMS THROUGH POST.
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $arguments_array);
    
    if ( !empty($isDownloadableProductActive) ) {
      // NOT NEED HEADER FROM THE RESPONSE.
      curl_setopt($ch, CURLOPT_HEADER, false);
      // NOT NEED RESPONSE AS STRING.
      curl_setopt($ch, CURLOPT_RETURNTRANSFER, false);
      // NEED RESPONSE AS BINARY FORMATE.
      curl_setopt($ch, CURLOPT_BINARYTRANSFER, true);
      // RESPONSE CONTENT WILL WRITE IN FILE.
      curl_setopt($ch, CURLOPT_FILE, $contentBodyCh);
      // RESPONSE HEADER WILL WRITE IN FILE.
      curl_setopt($ch, CURLOPT_WRITEHEADER, $contentHeaderCh);
    }else {
      // INCLUDE HEADER INTO THE CURL RESPONSE.
      curl_setopt($ch, CURLOPT_HEADER, true);
      // CHANGE CURL RESPONSE INTO THE STRING.
      curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    }

    if (!empty($_COOKIE['frontend'])) {
      // SET THE FRONTEND COOKIE IN THE REQUEST.
      curl_setopt($ch, CURLOPT_COOKIE, 'frontend =' . $front->getRequest()->getCookie('frontend'));
    }

    $curlResponse = curl_exec($ch);
    
    if( !empty($isDownloadableProductActive) ) {
      @fclose($contentBodyCh);
      @fclose($contentHeaderCh);

      // GETTING THE HEADER INFORMATION FOR FETCH FILE NAME.
      $headers = @file_get_contents($contentHeader);
      $explodeArray = @explode('filename=', $headers);
      $fileName = '';
      if (!empty($explodeArray[1])) {
        $getFileName = @explode("\n", $explodeArray[1]);
        if (!empty($getFileName[0])) {
          $fileName = $getFileName[0];
        }
      }

      header('Content-Description: File Transfer');
      header('Content-Type: application/octet-stream');
      header('Content-Disposition: attachment; filename=' . basename($fileName));
      header('Content-Transfer-Encoding: binary');
      header('Expires: 0');
      header('Cache-Control: must-revalidate');
      header('Pragma: public');
      header('Content-Length: ' . filesize($contentBody), true);
      ob_clean();
      flush();
      readfile($contentBody);
      exit;
    }

    $curlStrExplode = explode('::siteestore::', $curlResponse);
    $curlHeader = !empty($curlStrExplode[0]) ? $curlStrExplode[0] : '';
    $curlBody = !empty($curlStrExplode[1]) ? $curlStrExplode[1] : '';

    if (empty($curlBody)) {
      return;
    }
    $responseHeader = $curlHeader;
    $curlInfo = curl_getinfo($ch);
    $responseBody = !empty($curlBody) ? Zend_Json::decode($curlBody) : array();
    $page = !empty($responseBody['view_page_info']) ? 'index' : $page;

    // SET THE COOKIE FOR THE LOGOUT USER.
    if (!$viewer->getIdentity()) {
      $this->_DATA = $responseHeader;
      $this->setCookies($responseHeader);
    }
    
    // REDIRECT THE SITE TO PAYMENT GETWAY, WHICH SELECTED BY CUSTOMER IN THE CHECKOUT PROCESS.
    if (strstr($_SERVER['REQUEST_URI'], '/standard/redirect/') || strstr($_SERVER['REQUEST_URI'], 'redsys/index/redirect')) {
      $responseBody = substr($curlHeader, $curlInfo['header_size']);
      echo $responseBody;
      exit();
    }

    // SET SESSION FOR KNOW, USER LOGIN OR LOGOUT IN MAGENTO ACCORDING TO RESPONSE.
    $session->isMagentoUserLogin = !empty($responseBody['isLogin']) ? $responseBody['isLogin'] : 0;

    // GETTING THE AJAX RESPONSE FROM THE MAGENTO SITE FOR THE CHECKOUT PROCESS.
    if (isset($params['payment-checkout'])) {
      $responseBody = substr($curlHeader, $curlInfo['header_size']);
      $responseBody = Zend_Json::encode(array('body' => $responseBody));
      echo $responseBody;
      exit();
    }

    // CHANGE THE URL'S ACCORDINGLY AND MAKE AN ARRAY OF THE BLOCKS HTML.
    if (!empty($curlParams['multiBlockResponce']) && !empty($magentoBlockSize) && !empty($responseBody['blocks_html'])) {
      foreach ($responseBody['blocks_html'] as $key => $values) {
        $isTopMenu = false;
        if (strstr($key, 'catalog.topnav')) {
          $page = 'index';
          $isTopMenu = true;
        }
        $values = $this->changeUrl($values, $page, $isTopMenu);
        $multiBlockResponce[$key] = $values;
      }
    }

    // SEND ACTIVITY FEED AFTER SUCCESSFULLY PURCHASED PRODUCTS FROM THE STORE.
    if (!empty($responseBody['checkout_success'])) {
      $this->sendOrderFeed($responseBody['checkout_success']);
    }

    // CHECK IF THERE ARE ANY LOCATION AVAILABLE IN THE HEADER FOR THE REDIRECTION.
    $pathArray = @explode('Location:', $responseHeader);
    if (!empty($pathArray) && !empty($pathArray[1])) {
      if (strstr($pathArray[1], "?SID")) {
        $explodePath = @explode("?SID", trim($pathArray[1]));
        $redirectLocation = $explodePath[0];
      } else {
        // Valid for "HTTP" & "HTTPS"
        if (strstr($pathArray[1], 'http')) {
          $explodePath = @explode(" ", trim($pathArray[1]));
          if (!empty($explodePath) && !empty($explodePath[0])) {
            $urlStr = @explode("/", $explodePath[0]);
            unset($urlStr[COUNT($urlStr) - 1]);
            $redirectLocation = @implode("/", $urlStr);
          }
        }
      }
    }

    if (!empty($redirectLocation)) {
      $flagActionName = $page;
      $zendRedirect = new Zend_Controller_Action_Helper_Redirector;

      if (empty($redirectLocation)) {
        return false;
      }

      // SEND ACTIVITY FEED, AFTER ADD PRODUCT TO WISHLIST.
      if (!empty($responseBody['isLogin']) && strstr($_SERVER['REDIRECT_URL'], '/wishlist/index/add/product/')) {
        $this->wishlistFeed($_SERVER['REQUEST_URI']);
      }

      if (strstr($redirectLocation, 'checkout')) {
        $flagActionName = 'index';
      } else if (strstr($redirectLocation, '/wishlist/')) {
        $flagActionName = 'account';
        $redirectLocation = str_replace("index/wishlist/", "account/wishlist/", $redirectLocation);
        $redirectLocation = str_replace("cart/wishlist/", "account/wishlist/", $redirectLocation);
      }

      // IF DELETE PRODUCTS FROM THE MY CART WIDGETS THEN REDIRECTION SHOULD BE AT HOME PAGE.
      if (strstr($_SERVER['REQUEST_URI'], 'index/checkout/cart/delete/id')) {
        $flagActionName = 'index';
      }

      // ON THE ADVANCED SEARCH PAGE, AFTER CLICK ON "Add to Compare" REDIRECTION SHOULD BE AT CURRENT PAGE NOT TO HOME PAGE.
      if (strstr($_SERVER['REQUEST_URI'], 'index/catalog/product_compare/add/product/')) {
        if( !empty($_SERVER['HTTP_REFERER']) ) {
          $redirectLocation = $_SERVER['HTTP_REFERER'];
        }
      }

      if (strstr($_SERVER['REQUEST_URI'], '/checkout/cart/delete')) {
        $flagActionName = 'cart';
      }

      $redirectLocation = $this->changeUrl($redirectLocation, $flagActionName);
      // CHANGE URL FOR COMPARE PRODUCTS.
      if (strstr($_SERVER['REQUEST_URI'], 'catalog/product_compare/index/items')) {
        $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
        $baseURL = $view->url(array(), 'siteestore', true);
        $redirectLocation = $baseURL . '/catalog/product_compare/index?includeJs=1';
      }

      if (strstr($redirectLocation, 'account/wishlist/index/configure/id')) {
        $page = 'cart';
        $redirectLocation = str_replace('account/wishlist/index/configure/id/', 'cart/wishlist/index/configure/id/', $redirectLocation);
      }

      if (strstr($_SERVER['REQUEST_URI'], 'review/product/post/id')) {
        if (!empty($responseBody['view_page_info']) && !empty($responseBody['view_page_info']['product_id'])) {
          $productItem = Engine_Api::_()->getItem('siteestore_product', $responseBody['view_page_info']['product_id']);
          if (!empty($productItem) && !empty($productItem->uri)) {
            $redirectLocation = $productItem->uri;
          }
        }
      }

      // CHANGE LOCATION: ACCORDING TO THE "MY STORE ACCOUNT" PAGE.

      if (strstr($page, 'account')) {
        if (strstr($redirectLocation, 'checkout')) {
          $redirectLocation = str_replace('account/checkout', 'checkout', $redirectLocation);
          $redirectInfo['location'] = $redirectLocation;
        } else if (strstr($_SERVER['REQUEST_URI'], '/wishlist/') && !strstr($redirectLocation, 'wishlist')) {
          $redirectInfo['action'] = 'account';
          $redirectInfo['location'] = $redirectLocation . '/wishlist';
        } else {
          $redirectInfo['action'] = 'account';
          $redirectInfo['location'] = $redirectLocation;
        }

        // Make link for share wishlist.
        if (strstr($_SERVER['REQUEST_URI'], 'wishlist/index/update/wishlist_id')) {
          $shareUrl = @explode("?", $_SERVER['REQUEST_URI']);
          if (!empty($shareUrl[0])) {
            $redirectInfo['action'] = 'account';
            $redirectInfo['location'] = str_replace('siteestore/wishlist/index/update/', $getMagentoFlag . '/account/wishlist/index/share/', $shareUrl[0]);
            ;
          }
        }

        return $redirectInfo;
      }

      // CHANGE LOCATION: IF ADD TAG FROM THE VIEW PAGE OF THE PRODUCT.
      if (strstr($_SERVER['REQUEST_URI'], '/tag/index/save/product/')) {
        $protocol = Engine_Api::_()->siteestore()->getSEProtocol();
        $socilEngineBaseDir = Engine_Api::_()->siteestore()->getSEBaseUrl();
        $hostURL = $protocol . $socilEngineBaseDir['host'] . $socilEngineBaseDir['path'] . '/' . $getMagentoFlag . '/';
        $redirectLocation = $hostURL . 'account/tag/customer';
      }

      $redirectLocation = str_replace("index/checkout/onepage", "cart/checkout/onepage", $redirectLocation);
      $redirectLocation = str_replace("index/checkout/cart", "cart/checkout/cart", $redirectLocation);

      $zendRedirect->gotoUrl($redirectLocation)->redirectAndExit();
    }

    curl_close($ch);

    if (!empty($params['multiBlockResponce'])) {
      if( !empty($responseBody['checkout_success']) ){
        $multiBlockResponce['checkout_success'] = $responseBody['checkout_success'];
      }
      if( !empty($responseBody['catch_page']) ) {
        $multiBlockResponce['catch_page'] = $responseBody['catch_page'];
      }
      if( !empty($responseBody['view_page_info']) ) {
        $multiBlockResponce['view_page_info'] = $responseBody['view_page_info'];
      }
      if( !empty($responseBody['category_page']) ) {
        $multiBlockResponce['category_page'] = $responseBody['category_page'];
      }
      if( !empty($responseBody['mageSiteinfo']) ) {
        $multiBlockResponce['mageSiteinfo'] = $responseBody['mageSiteinfo'];
      }
      if( !empty($responseBody['included_files']) ) {
        $multiBlockResponce['included_files'] = $responseBody['included_files'];
      }
      return $multiBlockResponce;
    } else if (!empty($curlParams['multiBlockResponce'])) {
      $singleBlockResponce = $multiBlockResponce[$block];
      return $singleBlockResponce;
    } else {
      return $blockData;
    }
  }

  /**
   * CHANGE THE URL ACCORDINGLY FROM THE cURL RESPONCE STRING.
   *
   * @param $str: String of the cURL responce.
   * @param $actionName: Action name [ URL will change according to the action name ].
   */
  public function changeUrl($str, $actionName, $isTopMenu = null) {
    $socilEngineBaseDir = Engine_Api::_()->siteestore()->getSEBaseUrl();
    $getSEProtocol = Engine_Api::_()->siteestore()->getSEProtocol();
    $getMagentoFlag = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteestore_manifestUrl', 'shop');
    $hostURL = $socilEngineBaseDir['host'] . $socilEngineBaseDir['path'] . '/' . $getMagentoFlag . '/';

    $magentoBaseUrl = Engine_Api::_()->siteestore()->getHostUrl();
    $magentoBaseUrl = str_replace("/index.php", "", $magentoBaseUrl);
    $magentoBaseUrlArray = explode("//", $magentoBaseUrl);
    $magentoBaseUrlStr = $magentoBaseUrlArray[1] . '/socialengine.php';
    $magentoBaseUrlIndexStr = $magentoBaseUrlArray[1] . '/index.php';

    $str = str_replace($magentoBaseUrlStr, $hostURL . $actionName, $str);
    $str = str_replace($hostURL . $actionName . '/customer/account/', $hostURL . 'account/customer/account/', $str);

    $str = str_replace($hostURL . 'account/downloadable/download/link/id', $socilEngineBaseDir['host'] . $socilEngineBaseDir['path'] . '/siteestore/downloadable/download/link/id', $str);

    $str = str_replace($hostURL . 'index/downloadable/download/link/id', $socilEngineBaseDir['host'] . $socilEngineBaseDir['path'] . '/siteestore/downloadable/download/link/id', $str);

    $str = str_replace($hostURL . 'cart/sales/order/print/', $socilEngineBaseDir['host'] . $socilEngineBaseDir['path'] . '/siteestore/sales/order/print/', $str);

    $str = str_replace($hostURL . 'cart/sales/order/view/order_id', $hostURL . 'account/sales/order/view/order_id', $str);

    $str = str_replace($hostURL . $actionName . '/catalog/product/gallery/', $socilEngineBaseDir['host'] . $socilEngineBaseDir['path'] . '/siteestore/catalog/product/gallery/', $str);

    $str = str_replace("account/wishlist/index/configure/id/", "index/wishlist/index/configure/id/", $str);

    $str = str_replace("index/wishlist/", "account/wishlist/", $str);
    $str = str_replace("account/wishlist/index/cart", "index/wishlist/index/cart", $str);

    $str = str_replace("account/review/product/list/id", "index/review/product/list/id", $str);

    $str = str_replace($hostURL . 'cart/?', $hostURL . 'index/?', $str);
    $str = str_replace("index/checkout/onepage", "cart/checkout/onepage", $str);

    $hostURL = $hostURL . $actionName;
    $str = str_replace($magentoBaseUrlIndexStr, $hostURL, $str);
    if( !empty($isTopMenu) ) {
      $str = str_replace($magentoBaseUrlArray[1], $hostURL, $str);
    }

    $str = str_replace("shops/index/catalog/product/gallery/", "siteestore/catalog/product/gallery/", $str);
    $str = str_replace("?___SID=U&", "?", $str);
    $str = str_replace("?___SID=U", "", $str);
    $str = str_replace("amp;", "", $str);
    
    if( !strstr($getSEProtocol, "https") ) {
      $str = str_replace("https://" . $socilEngineBaseDir['host'], $getSEProtocol . $socilEngineBaseDir['host'], $str);
    }

    return $str;
  }

  /**
   * LOGIN THE SocialEngine USER INTO THE MAGENTO.
   *
   * @param $arguments: Which need to be send via cURL.
   */
  public function login($arguments) {
    $postField = array('customer_login' => Zend_Json::encode($arguments));
    $magentoBaseUrl = Engine_Api::_()->siteestore()->getHostUrl();
    $magentoBaseUrl = str_replace("/index.php", "", $magentoBaseUrl);
    $requestUrl = $magentoBaseUrl . '/socialengine.php';
    $http_headers = array();
    $timeout = 0;

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $requestUrl);
    // INCLUDE HEADER INTO THE CURL RESPONSE.
    curl_setopt($ch, CURLOPT_HEADER, true);
    // CHANGE CURL RESPONSE INTO THE STRING.
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    // SET TIME OUT.
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
    // REQUIRED FOR HTTPS URL'S.
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
    // ENABLE THE CURL POST AND SEND THE PARAMS THROUGH POST.
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $postField);

    $curlResponse = curl_exec($ch);
    $curlInfo = curl_getinfo($ch);
    $responseHeader = substr($curlResponse, 0, $curlInfo['header_size']);
    $curlResponseContent = substr($curlResponse, $curlInfo['header_size']);
    $responseBody = !empty($curlResponseContent) ? Zend_Json::decode($curlResponseContent) : array();

    $this->_DATA = $curlResponse;

    curl_close($ch);
    return $responseBody;
  }

  /**
   * SET COOKIE OF THE USERS ACCORDING TO THE cURL RESPONCE.
   *
   * @param $data: Array of the information.
   */
  public function setCookies($data) {
    $session = new Zend_Session_Namespace();
    $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
    $session->mage_user_login = !empty($viewer_id) ? true : false;
    $cookieExpire = 0;

    if (empty($this->_DATA)) {
      return;
    }

    $explodeData = @explode('Set-Cookie:', $this->_DATA);
    foreach ($explodeData as $str) {
      if (strstr($str, 'frontend')) {
        $frontStr = $str;
        if (strstr($str, ';')) {
          $strArray = @explode(';', $str);
          $frontStr = $strArray[0];
        }

        if (strstr($frontStr, 'frontend')) {
          $frontArray = @explode('=', $frontStr);
          if (!empty($frontArray[0]) && !empty($frontArray[1])) {
            if(strstr($frontArray[0], "frontend_cid")){
              setcookie('frontend_cid', $frontArray[1], $cookieExpire, "/");
            }else {
              setcookie('frontend', $frontArray[1], $cookieExpire, "/");
            }
            $getMagentoHostUrl = Engine_Api::_()->siteestore()->getHostUrl();
            if( !empty($getMagentoHostUrl) ) {
              $hostName = str_replace("www.", "", strtolower($_SERVER['HTTP_HOST']));
              $getMagentoUrl = @explode($hostName, $getMagentoHostUrl);
              if( !empty($getMagentoUrl) ) {
                $getMagentoUrl = @trim($getMagentoUrl[1], '/');
                if( !empty($getMagentoUrl) ) {
                  setcookie("frontend", $frontArray[1], time() + 3600, "/semagento/magento/");
                }
              }
            }
          }
        }
      }
    }

    return true;
  }

  /**
   * SEND THE ACTIVITY FEED AFTER ADD WISHLIST.
   *
   * @param $url: URL of the request.
   */
  public function wishlistFeed($url) {
    $pos = strpos($url, 'product/');
    $getStr = substr($url, $pos);
    $getArray = explode('/', $getStr);
    if (!empty($getArray[1])) {
      $product_id = $product_str = $getArray[1];
      if (strstr($product_str, "?")) {
        $product_array = explode("?", $product_str);
        $product_id = $product_array[0];
      }

      // Add products in products table, If not exists.
      $magentoLinkTable = Engine_Api::_()->getDbTable('products', 'siteestore');
      $productInfo = Engine_Api::_()->getItem('siteestore_product', $product_id);
      if (empty($productInfo)) {
        $productResponce = Engine_Api::_()->getApi('Xmlrpc', 'siteestore')->magento_test_api_connection('socialengineint_seint.getproductinfo', array('id' => $product_id));
        $magentoLinkTable->setProducts($productResponce);
        $productInfo = Engine_Api::_()->getItem('siteestore_product', $product_id);
      }

      $product_id = $productInfo->product_id;
      $productObj = Engine_Api::_()->getItem('siteestore_product', $product_id);


      // Auth activity feed.
      $auth = Engine_Api::_()->authorization()->context;
      $roles = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
      foreach ($roles as $role) {
        $auth->setAllowed($productObj, $role, 'view', 1);
        $auth->setAllowed($productObj, $role, 'comment', 1);
      }

      // Send activity feed for wishlist.
      $action = Engine_Api::_()->getDbtable('actions', 'activity')->addActivity(Engine_Api::_()->user()->getViewer(), $productObj, 'siteestore_add_wishlist', null, array());
      if ($action) {
        Engine_Api::_()->getDbtable('actions', 'activity')->attachActivity($action, $productObj);
      }

      return;
    }
  }

  /**
   * SEND THE ACTIVITY FEED AFTER PURCHASED PRODUCTS.
   *
   */
  public function sendOrderFeed($orderInfo) {

    $viewer = Engine_Api::_()->user()->getViewer();

    foreach ($orderInfo as $orderIdsInfo) {
      $productCount = 0;
      $orderObj = $order = null;
      foreach ($orderIdsInfo['products'] as $key => $product) {
        $productCount++;
        Engine_Api::_()->getDbTable('products', 'siteestore')->setProducts($product);
        $orderProducts['products'] = $product['product_id'];
        $orderProducts['order'] = !empty($orderIdsInfo['order']) ? $orderIdsInfo['order'] : 0;
        $orderProducts['owner_id'] = $viewer->getIdentity();
        $orderProducts['quantity'] = $product['quantity'];

        Engine_Api::_()->getDbTable('orders', 'siteestore')->setOrder($orderProducts);
      }


      $order = Engine_Api::_()->getDbTable('orders', 'siteestore')->getOrder(array('order_id' => $orderIdsInfo['order']));

      if (!empty($order[0]['order_id'])) {

        $orderObj = Engine_Api::_()->getItem('siteestore_order', $order[0]['field_id']);

        // Auth activity feed.
        $auth = Engine_Api::_()->authorization()->context;
        $roles = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
        foreach ($roles as $role) {
          $auth->setAllowed($orderObj, $role, 'view', 1);
          $auth->setAllowed($orderObj, $role, 'comment', 1);
        }

        // Send activity feed.
        $action = Engine_Api::_()->getDbtable('actions', 'activity')->addActivity(Engine_Api::_()->user()->getViewer(), $orderObj, 'siteestore_new', null, array('count' => $productCount));
        if ($action) {
          Engine_Api::_()->getDbtable('actions', 'activity')->attachActivity($action, $orderObj);
        }
      }
    }
  }

}

?>
