<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteestore
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Api.php 2012-10-22 9:40:21Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */
class Siteestore_Form_Admin_Api extends Engine_Form {

  public function init() {
    $this
            ->setTitle('Magento Integration Settings');


    $this->addElement('Select', 'siteestore_hostType', array(
        'label' => "Magento Site's Protocol",
        'description' => 'Select the Web Protocol of your Magento site.',
        'onchange' => 'javascript:showStoreView(this.value);',
        'allowEmpty' => false,
        'multiOptions' => array('http' => 'HTTP', 'https' => 'HTTPS'),
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteestore.hostType', 'http')
    ));

    $this->addElement('Text', 'siteestore_api_host', array(
        'label' => 'Magento Site URL',
        'required' => true,
        'description' => 'Enter the URL of your Magento Site (Ex: www.your-magento-site.com). (Note: This is required to synchronize the data of your Magento site with this site.)',
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteestore.api.host', '')
    ));

    $this->addElement('Text', 'siteestore_api_user', array(
        'label' => 'User Name',
        'description' => 'Enter the ‘User Name’ of your Magento Site’s user. (To get the User Name (Go to Magento Admin >> System >> Web Services >> SOAP/XML-RPC - Users >> User))',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteestore.api.user', '')
    ));

    $this->addElement('Password', 'siteestore_api_pass', array(
        'label' => 'New API Key',
        'description' => 'Enter the ‘New API Key’ of your Magento Site’s user. (To get the New API Key (Go to Magento Admin >> System >> Web Services >> SOAP/XML-RPC - Users >> User))',
        'required' => false,
        'value' => ''
    ));

    $getConfKey = Engine_Api::_()->getApi('settings', 'core')->getSetting('mage.request.path', null);
    if (!empty($getConfKey)) {
      $this->addElement('Text', 'siteestore_confkey', array(
          'label' => 'Magento Extension Key',
          'style' => 'width: 30em; height: 2em;',
          'description' => '<a href="javascript:void(0)" onClick="copy()">Copy</a> and paste the below ‘Magento Extension Key’ in the “SocialEngine Integration” sub-section of “CMS” section in your Magento site’s admin panel. (To enter the Magento Extension Key (Go to Magento Admin >> CMS >> SocialEngine Integration))',
          // 'required' => true,
          'attribs' => array('readonly' => 'readonly'),
          'value' => $getConfKey
      ));
      $this->siteestore_confkey->getDecorator('Description')->setOptions(array('placement' => 'PREPEND', 'escape' => false));
    }

    // Add submit button
    $this->addElement('Button', 'save', array(
        'label' => 'Save Settings',
        'type' => 'submit',
        'ignore' => true,
        'decorators' => array('ViewHelper')
    ));
  }

}

?>
