<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteestore
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Settings.php 2012-10-22 9:40:21Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */
class Siteestore_Form_Admin_Settings extends Engine_Form {

  public function init() {
    $this
            ->setTitle('Global Settings')
            ->setDescription('These settings affect all members in your community.');

    $this->addElement('Text', 'siteestore_lsettings', array(
        'label' => 'Enter License key',
        'description' => "Please enter your license key that was provided to you when you purchased this plugin. If you do not know your license key, please contact the Support Team of SocialApps.tech from the Support section of your Account Area.(Key Format: XXXXXX-XXXXXX-XXXXXX )",
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteestore.lsettings'),
    ));

    if (APPLICATION_ENV == 'production') {
      $this->addElement('Checkbox', 'environment_mode', array(
          'label' => 'Your community is currently in "Production Mode". We recommend that you momentarily switch your site to "Development Mode" so that the CSS of this plugin renders fine as soon as the plugin is installed. After completely installing this plugin and visiting few pages of your site, you may again change the System Mode back to "Production Mode" from the Admin Panel Home. (In Production Mode, caching prevents CSS of new plugins to be rendered immediately after installation.)',
          'description' => 'System Mode',
          'value' => 1,
      ));
    } else {
      $this->addElement('Hidden', 'environment_mode', array('order' => 990, 'value' => 0));
    }

    // Add submit button
    $this->addElement('Button', 'submit_lsetting', array(
        'label' => 'Activate Your Plugin Now',
        'type' => 'submit',
        'ignore' => true
    ));

    $this->addElement('Text', 'siteestore_manifestUrl', array(
        'label' => 'Store URL alternate text for "shop"',
        'allowEmpty' => false,
        'required' => true,
        'description' => 'Please enter the text below which you want to display in place of "shop" in the URLs of this plugin.',
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteestore.manifestUrl', "shop"),
    ));

    $getConfKey = Engine_Api::_()->getApi('settings', 'core')->getSetting('mage.request.path', null);
    if (!empty($getConfKey)) {
      $this->addElement('Text', 'siteestore_confkey', array(
          'label' => 'Magento Extension Key',
          'style' => 'width: 30em; height: 2em;',
          'description' => '<a href="javascript:void(0)" onClick="copy()">Copy</a> and paste the below ‘Magento Extension Key’ in the “SocialEngine Integration” sub-section of “CMS” section in your Magento site’s admin panel. (To enter the Magento Extension Key (Go to Magento Admin >> CMS >> SocialEngine Integration))',
          'attribs' => array('readonly' => 'readonly'),
          'value' => $getConfKey
      ));
      $this->siteestore_confkey->getDecorator('Description')->setOptions(array('placement' => 'PREPEND', 'escape' => false));
    }

    $this->addElement('Button', 'submit', array(
        'label' => 'Save Changes',
        'type' => 'submit',
        'ignore' => true
    ));
  }

}

?>
