<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteestore
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Login.php 2012-10-22 9:40:21Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */
class Siteestore_Form_Login extends Engine_Form {

  public function init() {
    // Init form
    $this->setTitle('Enter Account Password');
    $this->setDescription("Please enter the password for your account on this site to proceed.");
    $this->setAttrib('id', 'user_form_login');
    $this->loadDefaultDecorators();
    $this->getDecorator('Description')->setOption('escape', false);
    $tabindex = 0;

    $password = Zend_Registry::get('Zend_Translate')->_('Password');
    $this->addElement('Password', 'password', array(
        'label' => $password,
        'required' => true,
        'allowEmpty' => false,
        'tabindex' => $tabindex++,
        'filters' => array(
            'StringTrim',
        ),
    ));

    $this->addElement('Button', 'submit', array(
        'label' => 'Go',
        'type' => 'submit',
        'ignore' => true,
        'tabindex' => $tabindex++,
    ));
  }

}
