<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteestore
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 2012-10-22 9:40:21Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */
class Siteestore_Plugin_Core {

  public function onRenderLayoutDefault($event) {
    
    /*
      Login in SocialEngine, If user logged-in in magento.
     */

    if (!empty($_COOKIE['SocialEngineLogin'])) {
      $dataString = base64_decode($_COOKIE['SocialEngineLogin']);
      $data = unserialize($dataString);

      // If there are Magento COOKIE set then login user in SocialEngine.
      if (!empty($data['email'])) {
        $userTable = Engine_Api::_()->getItemTable('user');
        $tableName = $userTable->info('name');

        $selectTable = $userTable->select()->from($tableName, array('user_id'))->where("email =?", $data['email']);
        $user = $selectTable->query()->fetch();
        if (!empty($user)) {
          $data['user_id'] = $user['user_id'];
          Zend_Auth::getInstance()->getStorage()->write($user['user_id']);
          Engine_Api::_()->siteestore()->crateUser($data);

          // Unset the COOKIE.
          setcookie("SocialEngineLogin", "", time() - 3600, "/");
          Zend_Controller_Action_HelperBroker::getStaticHelper('redirector')->gotoRoute(array(), 'default', false);
        }
      }
    }

    $session = new Zend_Session_Namespace();
    $front = Zend_Controller_Front::getInstance();
    $module = $front->getRequest()->getModuleName();
    $action = $front->getRequest()->getActionName();
    $controller = $front->getRequest()->getControllerName();
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
    
    // Update the First name and Last name in the magento site.
    if( strstr($module, 'user') && strstr($controller, 'edit') && strstr($action, 'profile') && !empty($viewer) && !empty($_POST) ) {
      $firstName = $lastName = null;
      $aliasValues = Engine_Api::_()->fields()->getFieldsValuesByAlias($viewer);
      if (!empty($aliasValues)) {
        $firstName = !empty($aliasValues['first_name']) ? $aliasValues['first_name'] : null;
        $lastName = !empty($aliasValues['last_name']) ? $aliasValues['last_name'] : null;
      }
      
      $getUsersInfo = Engine_Api::_()->getDbTable('users', 'siteestore')->getUser(array('se_user_id' => $viewer_id));
      $getUsersInfo = end($getUsersInfo);
      $customerId = !empty($getUsersInfo['mage_user_id'])? $getUsersInfo['mage_user_id']: 0;
          
      Engine_Api::_()->getApi('Xmlrpc', 'siteestore')->magento_test_api_connection('socialengineint_seint.update', array($customerId, array('firstname' => $firstName, 'lastname' => $lastName)));
    }
    
    
    // Update Email address into the Magento, If Email address changed into SocialEngine.
    if( strstr($module, 'user') && strstr($controller, 'settings') && strstr($action, 'general') && !empty($viewer) && !empty($_POST) ) {
      $getUsersInfo = Engine_Api::_()->getDbTable('users', 'siteestore')->getUser(array('se_user_id' => $viewer_id));
      $getUsersInfo = end($getUsersInfo);
      $customerId = !empty($getUsersInfo['mage_user_id'])? $getUsersInfo['mage_user_id']: 0;
      $email = $_POST['email'];
      Engine_Api::_()->getApi('Xmlrpc', 'siteestore')->magento_test_api_connection('socialengineint_seint.update', array($customerId, array('email' => $email)));
    }
    
    // Change Password for the Magento Customer, If password changed from the SocialEngine.
    if( strstr($module, 'user') && strstr($controller, 'settings') && strstr($action, 'password') && !empty($viewer) && !empty($_POST) ) {
      // Checkout the old password is correct or not.
      $userTable = Engine_Api::_()->getItemTable('user');
      $db = $userTable->getAdapter();

      // Check old password
      $salt = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.secret', 'staticSalt');
      $select = $userTable->select()
        ->from($userTable, new Zend_Db_Expr('TRUE'))
        ->where('user_id = ?', $viewer_id)
        ->where('password = ?', new Zend_Db_Expr(sprintf('MD5(CONCAT(%s, %s, salt))', $db->quote($salt), $db->quote($_POST['password']))))
        ->limit(1)
        ;
      $valid = $select
        ->query()
        ->fetchColumn()
        ;
      if( !empty($valid) ) {
        if( $_POST['passwordConfirm'] === $_POST['password'] ) {
          $getUsersInfo = Engine_Api::_()->getDbTable('users', 'siteestore')->getUser(array('se_user_id' => $viewer_id));
          $getUsersInfo = end($getUsersInfo);
          $customerId = !empty($getUsersInfo['mage_user_id'])? $getUsersInfo['mage_user_id']: 0;
          Engine_Api::_()->getApi('Xmlrpc', 'siteestore')->magento_test_api_connection('socialengineint_seint.update', array($customerId, array('password' => $_POST['password'])));
        }
      }
    }

    // If user not login in SocialEngine and login in Magento then should be logout from magento.
    if (empty($viewer_id) && !empty($session->mage_user_login)) {
      setcookie("frontend", "", time() - 3600, "/");
      $session->mage_user_login = false;
    }

    if (strstr($module, 'siteestore') && ((strstr($controller, 'index')))) {
      $view->headLink()->prependStylesheet($view->layout()->staticBaseUrl . 'application/modules/Siteestore/externals/styles/style_sestore.css');

      $hostName = Engine_Api::_()->siteestore()->getHost();
    }
  }

  // Do customer Logout from Magento side.
  public function onUserLogoutBefore($event) {
    $payload = $event->getPayload();
    $session = new Zend_Session_Namespace();

    setcookie("frontend", "", time() - 3600, "/");
    $session->mage_user_login = false;
  }

  // Delete customer from magento side with the help of XMl-RPC.
  public function onUserDeleteAfter($event) {
    $payload = $event->getPayload();
    $existUser = Engine_Api::_()->getDbtable("users", "siteestore")->existUser(array("se_user_id" => $payload['identity']));
    if (!empty($existUser)) {
      // Delete User from Magento Side.
      Engine_Api::_()->getApi('Xmlrpc', 'siteestore')->magento_test_api_connection('socialengineint_seint.delete', array($existUser["mage_user_id"]));
    }
    Engine_Api::_()->getDbtable("users", "siteestore")->deleteUser(array("se_user_id" => $payload['identity']));
  }

  public function onUserLoginAfter($event) {
    $postEmail = !empty($_POST['email'])? $_POST['email']: '';
    $postPassword = !empty($_POST['password'])? $_POST['password']: '';
    $viewer = Engine_Api::_()->user()->getViewer();
    $websiteId = Engine_Api::_()->siteestore()->getWebsite('id');

    if (empty($postEmail) || empty($postPassword) || empty($websiteId)) {
      return;
    }

    // Find out the "First Name" & "Last Name" of the login user from the fields table.
    $firstName = $lastName = null;
    $aliasValues = Engine_Api::_()->fields()->getFieldsValuesByAlias($viewer);
    if (!empty($aliasValues)) {
      $firstName = !empty($aliasValues['first_name']) ? $aliasValues['first_name'] : null;
      $lastName = !empty($aliasValues['last_name']) ? $aliasValues['last_name'] : null;
    }

    // Login user in magento through cUrl. If user not exist or user entry not correct in magento side then it return false result else return true result.
    $isCustomerExist = Engine_Api::_()->getApi('Curl', 'siteestore')->login(array("username" => $postEmail, "password" => $postPassword));
    if (empty($isCustomerExist)) {
      $email = null;
      $email = !empty($viewer->email) ? $viewer->email : null;
      if (empty($postPassword) || empty($postEmail) || empty($email) || ($postEmail != $email)) {
        return;
      }

      /*
        User not abel to login in Magento. Here we have two case:
        Case 1: May be user details ( Email or Password ) has been changed in SocialEngine.
        Case 2: May be User doing first time login and don't have account in magento.
       */

      // Check in "siteestore_users" table, If "Magento Customer Id" and "SocialEngine User Id" exist in table then we are assume "Case 1" and follow respective steps else assume "Case 2" and follow respective steps.
      $existUser = Engine_Api::_()->getDbtable("users", "siteestore")->existUser(array("se_user_id" => $viewer->getIdentity()));
      $argument = array("username" => $postEmail, "password" => $postPassword);

      // Follow Case 2.
      if (empty($existUser)) {
        // May be User doing first time loggin and don't have account in magento. So we create user as customer in magento through XML-RPC.
        $createUser = Engine_Api::_()->getApi('Xmlrpc', 'siteestore')->magento_test_api_connection('socialengineint_seint.create', array(array('firstname' => $firstName, 'lastname' => $lastName, 'email' => $postEmail, 'password' => $postPassword, 'store_id' => 1, 'website_id' => 1, 'group_id', 1)));

        if (!empty($createUser)) {
          Engine_Api::_()->getDbtable("users", "siteestore")->setUser(array("mage_user_id" => $createUser['entity_id'], "se_user_id" => $viewer->getIdentity(), "name" => $firstName . ' ' . $lastName, "website" => $websiteId, "enable" => true));
          $isCustomerExist = Engine_Api::_()->getApi('Curl', 'siteestore')->login($argument);
        }
      } else { // Follow Case 1.
        // Update the user information in "Magento" side through XML-RPC bridge.
        Engine_Api::_()->getApi('Xmlrpc', 'siteestore')->magento_test_api_connection('socialengineint_seint.update', array($existUser["mage_user_id"], array('firstname' => $firstName, 'lastname' => $lastName, 'email' => $postEmail, 'password' => $postPassword, 'store_id' => 1, 'website_id' => $websiteId, 'group_id', 1)));

        $isCustomerExist = Engine_Api::_()->getApi('Curl', 'siteestore')->login($argument);
      }
      Engine_Api::_()->getApi('Curl', 'siteestore')->setCookies($isCustomerExist);
    } else {
      $isUserExist = Engine_Api::_()->getDbtable("users", "siteestore")->getUser(array('se_user_id' => $viewer->getIdentity()));
      if (empty($isUserExist)) {
        Engine_Api::_()->getDbtable("users", "siteestore")->setUser(array("mage_user_id" => $isCustomerExist, "se_user_id" => $viewer->getIdentity(), "name" => $firstName . ' ' . $lastName, "website" => $websiteId, "enable" => true));
      }
      Engine_Api::_()->getApi('Curl', 'siteestore')->setCookies($isCustomerExist);
    }
  }

  public function onUserCreateAfter($event) {
    $payload = $event->getPayload();
    $email = $_SESSION["User_Plugin_Signup_Account"]["data"]["email"];
    $password = !empty($_SESSION["User_Plugin_Signup_Account"]["data"]["password"]) ? $_SESSION["User_Plugin_Signup_Account"]["data"]["password"] : null;
    $websiteId = Engine_Api::_()->siteestore()->getWebsite('id');

    if (empty($websiteId) || empty($password) || empty($payload) || ($email != $payload->email)) {
      return;
    }

    $firstName = $lastName = $email = null;
    $fname_id = $lname_id = false;

    // Getting the "First Name" & "Last Name" from the SocialEngine signup form.
    foreach ($_SESSION["User_Plugin_Signup_Fields"]["data"] as $key => $value) {
      $userMeta = Engine_Api::_()->fields()->getTable('user', 'meta')->getMetaById($key);
      if (strstr($userMeta->type, "first_name")) {
        $fname_id = $userMeta->field_id;
      } else if (strstr($userMeta->type, "last_name")) {
        $lname_id = $userMeta->field_id;
      }

      if (!empty($fname_id) && !empty($lname_id))
        break;
    }

    $firstName = !empty($_SESSION["User_Plugin_Signup_Fields"]["data"][$fname_id]) ? $_SESSION["User_Plugin_Signup_Fields"]["data"][$fname_id] : null;
    $lastName = !empty($_SESSION["User_Plugin_Signup_Fields"]["data"][$lname_id]) ? $_SESSION["User_Plugin_Signup_Fields"]["data"][$lname_id] : null;

    // We create user as customer in magento through XML-RPC. If customer successfully created then we login this in Magento.
    $createUser = Engine_Api::_()->getApi('Xmlrpc', 'siteestore')->magento_test_api_connection('socialengineint_seint.create', array(array('firstname' => $firstName, 'lastname' => $lastName, 'email' => $payload->email, 'password' => $password, 'store_id' => 1, 'website_id' => 1, 'group_id', 1)));

    if (!empty($createUser)) {
      // Insert in users Table.
      Engine_Api::_()->getDbtable("users", "siteestore")->setUser(array("mage_user_id" => $createUser['entity_id'], "se_user_id" => $payload->user_id, "name" => $firstName . ' ' . $lastName, "website" => $websiteId, "enable" => true));

      $argument = array("username" => $payload->email, "password" => $password);
      $isCustomerExist = Engine_Api::_()->getApi('Curl', 'siteestore')->login($argument);
      Engine_Api::_()->getApi('Curl', 'siteestore')->setCookies($isCustomerExist);
    }
  }

}
