<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteestore
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: OrderRichContent.php 2012-10-22 9:40:21Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */
class Siteestore_View_Helper_OrderRichContent extends Zend_View_Helper_Abstract {

  public function orderRichContent($id) {
    $richStr = '';
    $flag = 1;
    $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
    $orderItems = Engine_Api::_()->getDbTable('orders', 'siteestore')->getOrder(array('field_id' => $id));
    if (!empty($orderItems) && !empty($orderItems[0])) {
      $orderItems = Engine_Api::_()->getDbTable('orders', 'siteestore')->getOrder(array('order_id' => $orderItems[0]['order_id']));
    }

    if (empty($orderItems) || empty($orderItems[0]['product_id']))
      return;

    $productsCount = @COUNT($orderItems);
    foreach ($orderItems as $productId) {
      if ($flag > 3)
        break;

      $getProduct = Engine_Api::_()->getItem('siteestore_product', $productId['product_id']);

      if (empty($getProduct) || ($getProduct->status != 1))
        continue;

      $RESOURCE_TYPE = 'siteestore_product';
      $order_id = $productId['order_id'];
      $sub_title = str_replace("'", '"', $getProduct->getTitle());
      $title = '<span class="mint_pp_title">' . $view->htmlLink($getProduct->getHref(), Engine_Api::_()->siteestore()->truncateStr($getProduct->getTitle()), array('title' => $sub_title, 'class' => 'sea_add_tooltip_link', 'rel' => $RESOURCE_TYPE . ' ' . $productId['product_id'])) . '</span>';
      $price = "<span class='mint_pp_price'><strong>" . $productId['quantity'] . '</strong> x ' . $getProduct->price . "</span>";

      $photoURL = $getProduct->getPhotoUrl('thumb.profile');
      $photoURL = !empty($photoURL) ? $photoURL : 'application/modules/Siteestore/externals/images/nophoto_product_thumb_profile.png';
      $image = "<a href='" . $getProduct->uri . "' class = 'sea_add_tooltip_link' rel = '$RESOURCE_TYPE " . $productId['product_id'] . "'>" . '<span class="mint_pp_img" style="background-image:url(' . $photoURL . ');"></span>' . '</a>';

      $product = '<span class="feed_attachment_siteestore_purchased_product">' . $title . '<br>' . $price . '<br>' . $image . '</span>';
      $richStr .= $product;
      $flag++;
    }
    $richStr = rtrim($richStr, ", ");

    if ($productsCount > 3) {
      $order_id = Engine_Api::_()->siteestore()->getEncode((string) $order_id);
      $url = $view->url(array('module' => 'siteestore', 'controller' => 'index', 'action' => 'order-products', 'id' => $order_id), 'default', true);
      $richStr .= '<br /><span class="feed_attachment_siteestore_purchased_product_more"><a href="javascript:void(0)" onclick="Smoothbox.open(\'' . $url . '\');">View all Products</a></span>';
    }

    return $richStr;
  }

}
