<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteestore
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminMagentosettingsController.php 2012-10-22 9:40:21Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */
class Siteestore_AdminMagentosettingsController extends Core_Controller_Action_Admin {

  protected $_categoryArray = array();
  protected $_finalCategoryArray = array();
  protected $_ROOT_WEBSITE_ID = 1;

  public Function guidelinesAction() {
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteestore_admin_menu', array(), 'siteestore_magento_settings');

    $this->view->sub_navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteestore_admin_mage_settings', array(), 'siteestore_mage_settings_api');
  }

  // Tab: Api
  public function apiAction() {
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteestore_admin_menu', array(), 'siteestore_magento_settings');

    $this->view->sub_navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteestore_admin_mage_settings', array(), 'siteestore_mage_settings_api');

    $this->view->form = $form = new Siteestore_Form_Admin_Api();

    if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
      $values = $form->getValues();
      if (empty($values['siteestore_api_pass'])) {
        $values['siteestore_api_pass'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteestore.api.pass', '');
      }

      $getSavedHost = Engine_Api::_()->siteestore()->getHostUrl();
      if(!empty($getSavedHost)) {
        $magentoVersion = Engine_Api::_()->getApi('Xmlrpc', 'siteestore')->magento_test_api_connection('socialengineint_seint.mageversion');
        if (!empty($magentoVersion)) {
          Engine_Api::_()->getApi('settings', 'core')->setSetting('mage.version', $magentoVersion);
        }
      }

      $settings = Engine_Api::_()->getApi('settings', 'core');

      // Call only want to save configured settings. 
      if (array_key_exists('save', $_POST)) {

        if (!empty($values['siteestore_api_host'])) {
          $values['siteestore_api_host'] = str_replace("http://", "", $values['siteestore_api_host']);
          $values['siteestore_api_host'] = str_replace("https://", "", $values['siteestore_api_host']);
        }
        $values['siteestore_api_host'] = trim($values['siteestore_api_host']);
        $values['siteestore_api_user'] = trim($values['siteestore_api_user']);
        $values['siteestore_api_pass'] = trim($values['siteestore_api_pass']);
        $values['siteestore_api_host'] = trim($values['siteestore_api_host'], '/');

        // TEST CONNECTION IS CORRECT OR NOT.
        $test_connection = Engine_Api::_()->getApi('Xmlrpc', 'siteestore')->magento_test_api_connection('test_connection', $values);

        if (empty($test_connection)) {
          $form->addError('A connection could not be established with your Magento Store for integration. Please make sure that you have entered correct information.');
          return;
        }

        $requestUrl = 'http://www.socialengineaddons.com/genratemagentoextensionkey.php';
        $lkey = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteestore.lsettings', '');
        $arguments_array = array('domain' => str_replace('www.', '', strtolower($_SERVER['HTTP_HOST'])), 'api_user' => $values['siteestore_api_user'], 'api_pass' => $values['siteestore_api_pass'], 'lkey' => $lkey);
        
        if( !empty($values['siteestore_confkey']) ) {
          $arguments_array['key'] = $values['siteestore_confkey'];
        }
        
        
        include APPLICATION_PATH . '/application/modules/Siteestore/controllers/license/license2.php';

        $magentoHost = $values['siteestore_hostType'] . '://' . $values['siteestore_api_host'];
        $magentoAdminHostName = rtrim($magentoHost, "/");
        $db = Zend_Db_Table_Abstract::getDefaultAdapter();
        $db->query('UPDATE `engine4_core_menuitems` SET `params` = \'{"uri":"' . $magentoAdminHostName . '/admin","icon":"", "target":"_blank"}\' WHERE `engine4_core_menuitems`.`name` = "siteestore_mage_settings_admin" LIMIT 1 ;');

        // $form->addNotice('Your changes have been saved.');
        $this->_helper->redirector->gotoRoute(array('route' => 'admin-default'));
      }
    }
  }


  // Tab: Store Selection
  public function createStoreAction() {

    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteestore_admin_menu', array(), 'siteestore_magento_settings');

    $this->view->sub_navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteestore_admin_mage_settings', array(), 'siteestore_mage_settings_store');

    $website_id = $this->_getParam('website_id', 0);
    $this->view->form = $form = new Siteestore_Form_Admin_Store();

    // SET WEBSITE.
    $websiteArray = array("--Select Website--");
    $getWebsite = array();
    $getWebsite = Engine_Api::_()->getApi('Xmlrpc', 'siteestore')->magento_test_api_connection('socialengineint_seint.getwebsite');
    // include APPLICATION_PATH . '/application/modules/Siteestore/controllers/license/license2.php';

    if (!empty($getWebsite['error'])) {
      $form->addError("Note: You have not entered the “Magento Extension Key” on your Magento site. Please copy the correct key from “Magento Extension Key” field from “Integration Settings” sub-section of ‘Magento Integration” section of this plugin and paste in the “SocialEngine Integration” sub-section of “CMS” section in your Magento site’s admin panel.");
      $form->removeElement('mage_website');
      $form->removeElement('mage_store');
      $form->removeElement('save');
      return;
    }

    if (!empty($getWebsite) && empty($getWebsite['error'])) {
      foreach ($getWebsite as $website) {
        if (!empty($website['website_id'])) {
          $websiteArray[$website['website_id']] = $website['name'];
        }
      }
    }
    $form->mage_website->setmultiOptions($websiteArray);
    $form->mage_website->setvalue($website_id);


    // SET STORE.
    if (empty($website_id)) {
      $form->removeElement('mage_store');
      $form->removeElement('save');
    } else {
      $storeArray = array("--Select Store--");
      $getStore = Engine_Api::_()->getApi('Xmlrpc', 'siteestore')->magento_test_api_connection('socialengineint_seint.hierarchy', array($website_id));

      foreach ($getStore as $value) {
        // if ($value['website'] == $this->_ROOT_WEBSITE_ID) {
          $storeArray[$value['root_category_id']] = $value['label'];
          $valueArray[$value['root_category_id']] = $value['childs'];
        // }
      }

      $form->mage_store->setmultiOptions($storeArray);
    }
    
    $db = Zend_Db_Table_Abstract::getDefaultAdapter();
    $disabledProducts = $this->_getParam('disabledProducts', 0);
    if( !empty($disabledProducts) ) {
      $db->query("UPDATE `engine4_siteestore_products` SET `status` = '0'");
    }

    if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
      $values = $form->getValues();
      
      $websiteId = Engine_Api::_()->siteestore()->getWebsite('id');
      $numOfRecord = $db->query("SELECT COUNT(`product_id`) as num_row FROM `engine4_siteestore_products` where `status` = 1")->fetch();

      if( !empty($websiteId) && !empty($numOfRecord["num_row"]) && ($websiteId != $values['mage_website']) ) {
        $configuredWebsiteInfo = Engine_Api::_()->siteestore()->getWebsite();
        $url = $this->view->url(array('module' => 'siteestore', 'controller' => 'magentosettings', 'action' => 'create-store', 'disabledProducts' => true), 'admin_default', true);
        
        $error = 'NOTE: If you wish to change the currently integrated Magento Website from "' . $configuredWebsiteInfo['title'] . '" to some other listed in dropdown below, then you would need to first disable the existing products listed at "Manage Products" corresponding to "' . $configuredWebsiteInfo['title'] . '". Please <a href="' . $url . '">click here</a> to disable these products.';
        
        $form->addError($error);
        $form->getDecorator('Errors')->setOption('escape', false);
        return;
      }

      
      Engine_Api::_()->getApi('Xmlrpc', 'siteestore')->magento_test_api_connection('socialengineint_seint.setwebsite');

      if (empty($values['mage_website'])) {
        $error = "Website could not be empty";
        $form->addError($error);
      }

      if (empty($values['mage_store'])) {
        $error = "Please select a Store of your Magento website which should be integrated with your Ecommerce / Social Store on this site.";
        $form->addError($error);
      }

      if (empty($values['mage_website']) || empty($values['mage_store'])) {
        return;
      }

      $websiteArray = array(
          'id' => $values['mage_website'],
          'title' => $websiteArray[$values['mage_website']]
      );

      $storeArray = array(
          'id' => $values['mage_store'],
          'title' => $storeArray[$values['mage_store']]
      );

      Engine_Api::_()->getApi('settings', 'core')->setSetting('mage.website.info', @serialize($websiteArray));
      Engine_Api::_()->getApi('settings', 'core')->setSetting('mage.store.info', @serialize($storeArray));

      // Find out the categorys from the magento site through XML_RPC.
      $this->_categoryArray = Engine_Api::_()->getApi('Xmlrpc', 'siteestore')->magento_test_api_connection('socialengineint_seint.category', array($values['mage_store']));

      // Make an array of Category.
      $this->makeCategory($this->_categoryArray);

      $db = Zend_Db_Table_Abstract::getDefaultAdapter();
      $db->query("TRUNCATE TABLE `engine4_siteestore_languagemaps`");

      $this->_helper->redirector->gotoRoute(array('route' => 'admin-default', 'module' => 'siteestore', 'controller' => 'magentosettings', 'action' => 'store', 'successMsg' => true));
    }
  }
  
  
  // Tab: Store Selection
  protected function makeCategory($mainArray) {
    if (!array_key_exists($mainArray['category_id'], $this->_finalCategoryArray)) {
      $this->_finalCategoryArray[$mainArray['category_id']] = $mainArray;
    }

    foreach ($mainArray['children'] as $child_query) {
      if (!empty($child_query['children'])) {
        $this->makeCategory($child_query);
      } else {
        $this->_finalCategoryArray[$child_query['category_id']] = $child_query;
      }
    }
    return;
  }

  // Tab: Categories
  public function storeAction() {
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteestore_admin_menu', array(), 'siteestore_magento_settings');

    $this->view->sub_navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteestore_admin_mage_settings', array(), 'siteestore_mage_settings_store');

    $successMsg = $this->_getParam('successMsg', 0);
    if (!empty($successMsg)) {
      $this->view->clearCacheMsg = true;
    }

    $this->view->websiteInfo = Engine_Api::_()->siteestore()->getWebsite();
    $this->view->storeInfo = Engine_Api::_()->siteestore()->getStore();
  }

  protected function getLanguage() {
    // Languages
    $translate = Zend_Registry::get('Zend_Translate');
    $languageList = $translate->getList();

    // Prepare default langauge
    $defaultLanguage = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.locale.locale', 'en');
    if (!in_array($defaultLanguage, $languageList)) {
      if ($defaultLanguage == 'auto' && isset($languageList['en'])) {
        $defaultLanguage = 'en';
      } else {
        $defaultLanguage = null;
      }
    }

    // Prepare language name list
    $languageNameList = array();
    $languageDataList = Zend_Locale_Data::getList(null, 'language');
    $territoryDataList = Zend_Locale_Data::getList(null, 'territory');

    foreach ($languageList as $localeCode) {
      $languageNameList[$localeCode] = Engine_String::ucfirst(Zend_Locale::getTranslation($localeCode, 'language', $localeCode));
      if (empty($languageNameList[$localeCode])) {
        if (false !== strpos($localeCode, '_')) {
          list($locale, $territory) = explode('_', $localeCode);
        } else {
          $locale = $localeCode;
          $territory = null;
        }
        if (isset($territoryDataList[$territory]) && isset($languageDataList[$locale])) {
          $languageNameList[$localeCode] = $territoryDataList[$territory] . ' ' . $languageDataList[$locale];
        } else if (isset($territoryDataList[$territory])) {
          $languageNameList[$localeCode] = $territoryDataList[$territory];
        } else if (isset($languageDataList[$locale])) {
          $languageNameList[$localeCode] = $languageDataList[$locale];
        } else {
          continue;
        }
      }
    }
    $languageNameList = array_merge(array(
        $defaultLanguage => $defaultLanguage
            ), $languageNameList);

    return $languageNameList;
  }

  public function mappingAction() {
    $storeLanguage = array();
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteestore_admin_menu', array(), 'siteestore_magento_settings');

    $this->view->sub_navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteestore_admin_mage_settings', array(), 'siteestore_mage_settings_mapping');

    $this->view->languageNameList = $this->getLanguage();

    $this->view->getLanguage = $languageArray = Engine_Api::_()->getItemTable('siteestore_languagemap')->getLanguage();
    foreach ($languageArray as $language) {
      $storeLanguage[$language['language_code']] = array('id' => $language['languagemap_id'], 'title' => $language['store_view_title']);
    }
    $this->view->storeLanguage = $storeLanguage;
  }

  protected function deleteMapAction() {
    $this->view->id = $id = $this->_getParam('id', NULL);

    if ($this->getRequest()->isPost()) {
      $db = Engine_Db_Table::getDefaultAdapter();
      $db->beginTransaction();
      try {
        //GET MAPPING ITEM
        $languageTableRow = Engine_Api::_()->getItem('siteestore_languagemap', $id);

        //DELETE MAPPING
        $languageTableRow->delete();
        $db->commit();
      } catch (Exception $e) {
        $db->rollBack();
        throw $e;
      }
      $this->_forward('success', 'utility', 'core', array(
          'smoothboxClose' => 10,
          'parentRefresh' => 10,
          'messages' => array(Zend_Registry::get('Zend_Translate')->_('Mapping deleted successfully !'))
      ));
    }
  }

  protected function mapAction() {
    $language = $this->_getParam('language', NULL);
    $action = $this->_getParam('task', NULL);

    $this->_helper->layout->setLayout('admin-simple');

    //GENERATE THE FORM
    $form = $this->view->form = new Siteestore_Form_Admin_Map();

    // Getting Store View from XML-RPC.
    $websiteId = Engine_Api::_()->siteestore()->getWebsite('id');
    $storeId = Engine_Api::_()->siteestore()->getStore('id');
    $getStore = array();
    include APPLICATION_PATH . '/application/modules/Siteestore/controllers/license/license2.php';
    foreach ($getStore as $value) {
      if ($storeId == $value['root_category_id']) {
        $valueArray = $value['childs'];
        break;
      }
    }


    $data = array('');
    foreach ($valueArray as $value) {
      $data[$value['value']] = $value['label'];
    }

    $form->store_view->setmultiOptions($data);

    if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
      $values = $form->getValues();

      $param['language_code'] = $language;
      $param['store_view_code'] = $values['store_view'];
      $param['store_view_title'] = $data[$values['store_view']];

      Engine_Api::_()->getItemTable('siteestore_languagemap')->setLanguage($param);

      $this->_forward('success', 'utility', 'core', array(
          'smoothboxClose' => true,
          'parentRefresh' => true,
          'messages' => array(Zend_Registry::get('Zend_Translate')->_('This language is successfully mapped.'))
      ));
    }
  }

  public function cacheAction() {
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteestore_admin_menu', array(), 'siteestore_magento_settings');

    $this->view->sub_navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteestore_admin_mage_settings', array(), 'siteestore_mage_settings_cache');

    $this->view->form = $form = new Siteestore_Form_Admin_Cache();

    if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
      $values = $form->getValues();
      $cacheName = array();

      Engine_Api::_()->getApi('settings', 'core')->setSetting('se.siteestore.cache', $values['se_siteestore_cache']);
      if (!empty($values['clear_catch'])) {
        $cache = Zend_Registry::get('Zend_Cache');
        if ($cache instanceof Zend_Cache_Core) {
          // Find out the name of caching, which set in SocialEngine for magento.
          $cacheIds = $cache->getIds();
          foreach ($cacheIds as $values) {
            if (strstr($values, 'se_siteestore')) {
              $cacheName[] = $values;
            }
          }

          include APPLICATION_PATH . '/application/modules/Siteestore/controllers/license/license2.php';
        }
        $form->clear_catch->value = 0;
        $form->addNotice("Cache successfully deleted from your site.");
      }
    }
  }

  
  public function productSynchronizeAction() {
    ini_set('memory_limit', '2048M');
    set_time_limit(0);
    
    $getProductIds = $this->_getParam('getProductIds', array());
    if( !empty($getProductIds) ) {
      $getProductIds = explode(",", $getProductIds);
    }
    
    if ($this->getRequest()->isPost()) {
      $allowUrlFopen_Enabled = ini_get('allow_url_fopen');
      if( empty($allowUrlFopen_Enabled) ) {
        $this->view->allowUrlFopen_Enabled = true;
        return;
      }
      
      $getProductIds = Engine_Api::_()->getApi('Xmlrpc', 'siteestore')->magento_test_api_connection('socialengineint_seint.getallproducts');
      if( empty($getProductIds) ) {
        $url = $this->view->url(array('module' => 'siteestore', 'controller' => 'magentosettings', 'action' => 'manage-products', 'success_msg' => true), 'admin_default', true);
        $this->_forward('success', 'utility', 'core', array(
            'smoothboxClose' => 10,
            'parentRedirectTime' => 10,
            'parentRedirect' => $url,
            'messages' => array(Zend_Registry::get('Zend_Translate')->_('Products on your site have been successfully synchronized.'))
        ));
      }
      $getProductIds = @unserialize($getProductIds);
    }
    
    if( !empty($getProductIds) ) {
      $flag = 0;
      foreach($getProductIds as $key => $_productId) {
        unset($getProductIds[$key]);
        $productResponce = Engine_Api::_()->getApi('Xmlrpc', 'siteestore')->magento_test_api_connection('socialengineint_seint.getproductinfo', array('id' => $_productId));
        
        if(empty($productResponce))
          continue;
        
        if (empty($productResponce['sku']) && empty($productResponce['product_id'])) {
          $productResponce['status'] = 2;
          $productResponce['product_id'] = $products['product_id'];
        }

        if (empty($productResponce) && empty($productResponce['is_in_stock'])) {
          $productResponce['status'] = 0;
        }

        Engine_Api::_()->getItemTable('siteestore_product')->setProducts($productResponce);
        
        
        $flag++;
        if( $flag == 50 ) {
          $tempUrl = @implode(',', $getProductIds);
          $this->_helper->redirector->gotoRoute(array('route' => 'admin-default', 'module' => 'siteestore', 'controller' => 'magentosettings', 'action' => 'product-synchronize', 'getProductIds' => $tempUrl));
        }
        
        $url = $this->view->url(array('module' => 'siteestore', 'controller' => 'magentosettings', 'action' => 'manage-products', 'success_msg' => true), 'admin_default', true);
        $this->_forward('success', 'utility', 'core', array(
            'smoothboxClose' => 10,
            'parentRedirectTime' => 10,
            'parentRedirect' => $url,
            'messages' => array(Zend_Registry::get('Zend_Translate')->_('Products on your site have been successfully synchronized.'))
        ));
      }
    }
  }

  public function manageProductsAction() {

    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteestore_admin_menu', array(), 'siteestore_admin_products');

    $this->view->disbled_products = $disbled_products = $this->_getParam('disbled_products', 0);
    $this->view->formFilter = $formFilter = new Siteestore_Form_Admin_Manage_Products();
    $this->view->isLikeMod = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitelike');
    $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_level = $viewer->level_id;

    $page = $this->_getParam('page', 1);
    $success_msg = $this->_getParam('success_msg', 0);
    if (!empty($success_msg)) {
      $this->view->successMsg = 'Products on your site have been successfully synchronized.';
    }

    // Process form
    $values = array();
    if ($formFilter->isValid($this->_getAllParams())) {
      $values = $formFilter->getValues();
    }

    foreach ($values as $key => $value) {
      if (null === $value) {
        unset($values[$key]);
      }
    }

    $values = array_merge(array(
        'order' => 'product_id',
        'order_direction' => 'DESC',
            ), $values);

    if ($_POST['submit_button'] == 'delete') {
      foreach ($_POST as $key => $value) {
        if ($key == 'delete_' . $value) {
          Engine_Api::_()->getItem('siteestore_product', $value)->delete();
        }
      }
      $this->view->successMsg = 'Selected products on your site have been successfully deleted.';
      $this->view->productDelete = true;
    }

    $this->view->assign($values);
    $this->view->getDisabledProducts = $getDisabledProducts = Engine_Api::_()->getItemTable('siteestore_product')->getProductsPaginator($values);
    $this->view->getDisabledProductsCount = $getDisabledProductsCount = $getDisabledProducts->getTotalItemCount();

    if (!empty($disbled_products)) {
      $this->view->paginator = $getDisabledProducts;
    } else {
      $values['status'] = true;
      $this->view->paginator = Engine_Api::_()->getItemTable('siteestore_product')->getProductsPaginator($values);
    }

    $this->view->paginator->setItemCountPerPage(100);
    $this->view->paginator->setCurrentPageNumber($page);
  }

  public function enableProductAction() {
    $id = $this->_getParam('product_id', 0);
    $this->view->status = $status = $this->_getParam('status', 0);

    if ($this->getRequest()->isPost()) {
      $status = empty($status) ? true : false;
      $storeObj = Engine_Api::_()->getItemTable('siteestore_product');
      $storeObj->update(array('status' => $status), array('product_id = ?' => $id));

      $this->_forward('success', 'utility', 'core', array(
          'smoothboxClose' => 10,
          'parentRefresh' => 10,
      ));
    }
  }

}
