<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteestore
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminUsersController.php 2012-10-22 9:40:21Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */
class Siteestore_AdminUsersController extends Core_Controller_Action_Admin {

  public function indexAction() {
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteestore_admin_menu', array(), 'siteestore_magento_users');

    $this->view->formFilter = $formFilter = new Siteestore_Form_Admin_Manage_Filter();
    $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_level = $viewer->level_id;

    $page = $this->_getParam('page', 1);

    // Process form
    $values = array();
    if ($formFilter->isValid($this->_getAllParams())) {
      $values = $formFilter->getValues();
    }

    foreach ($values as $key => $value) {
      if (null === $value) {
        unset($values[$key]);
      }
    }

    $values = array_merge(array(
        'order' => 'user_id',
        'order_direction' => 'DESC',
            ), $values);

    $this->view->order = $values['order'];
    $this->view->order_direction = $values['order_direction'];

    $this->view->paginator = Engine_Api::_()->getItemTable('siteestore_user')->getUsersPaginator($values);
    $this->view->paginator->setItemCountPerPage(10);
    $this->view->paginator->setCurrentPageNumber($page);
  }

  public function enableAction() {
    $id = $this->_getParam('mage_user_id', 0);
    $value = $this->_getParam('value', 0);

    $value = empty($value) ? true : false;
    $storeObj = Engine_Api::_()->getItemTable('siteestore_user');
    $storeObj->update(array('enable' => $value), array('mage_user_id = ?' => $id));

    $this->_helper->redirector->gotoRoute(array('route' => 'admin-default', 'module' => 'siteestore', 'controller' => 'users', 'action' => 'index'));
  }

}
