<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteestore
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 2012-10-22 9:40:21Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */
class Siteestore_Installer extends Engine_Package_Installer_Module {

  function onPreinstall() {
    $db = $this->getDb();
    
    
    //CODE FOR INCREASE THE SIZE OF engine4_authorization_permissions's FIELD type
    $type_array = $db->query("SHOW COLUMNS FROM engine4_authorization_permissions LIKE 'type'")->fetch();
    if (!empty($type_array)) {
      $varchar = $type_array['Type'];
      $length_varchar = explode("(", $varchar);
      $length = explode(")", $length_varchar[1]);
      $length_type = $length[0];
      if ($length_type < 32) {
        $run_query = $db->query("ALTER TABLE `engine4_authorization_permissions` CHANGE `type` `type` VARCHAR( 32 ) CHARACTER SET latin1 COLLATE latin1_general_ci NOT NULL");
      }
    }
    
    //CODE FOR INCREASE THE SIZE OF engine4_core_menuitems FIELD label
    $type_array = $db->query("SHOW COLUMNS FROM engine4_core_menuitems LIKE 'label'")->fetch();
    if (!empty($type_array)) {
      $varchar = $type_array['Type'];
      $length_varchar = explode("(", $varchar);
      $length = explode(")", $length_varchar[1]);
      $length_type = $length[0];
      if ($length_type < 64) {
        $run_query = $db->query("ALTER TABLE `engine4_core_menuitems` CHANGE `label` `label` VARCHAR( 64 ) CHARACTER SET latin1 COLLATE latin1_general_ci NOT NULL");
      }
    }
    
    
    $PRODUCT_TYPE = 'siteestore';
    $PLUGIN_TITLE = 'Siteestore';
    $PLUGIN_VERSION = '5.4.1';
    $PLUGIN_CATEGORY = 'plugin';
    $PRODUCT_DESCRIPTION = 'E-commerce Store Plugin - SocialEngine Magento Integration';
    $_PRODUCT_FINAL_FILE = 0;
    $SocialEngineAddOns_version = '4.5.0';
    $PRODUCT_TITLE = 'E-commerce Store Plugin - SocialEngine Magento Integration';
    if (!empty($getErrorMsg)) {
      return $this->_error($getErrorMsg);
    }
    $file_path = APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/ilicense.php";
    $is_file = file_exists($file_path);

    if (empty($is_file)) {
      include_once APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/license3.php";
    } else {
      $select = new Zend_Db_Select($db);
      $select->from('engine4_core_modules')->where('name = ?', $PRODUCT_TYPE);
      $is_Mod = $select->query()->fetchObject();
      if (empty($is_Mod)) {
        include_once $file_path;
      }
    }
    parent::onPreinstall();
  }

  function onInstall() {
    $db = $this->getDb();

    $db->query("UPDATE  `engine4_seaocores` SET  `is_activate` =  '1' WHERE  `engine4_seaocores`.`module_name` ='siteestore';");

    
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'advancedactivity')
            ->where('enabled = ?', '1');
    $siteestore_temp = $select->query()->fetchObject();
    if (!empty($siteestore_temp)) {
      $db->query("INSERT IGNORE INTO `engine4_advancedactivity_contents` ( `module_name`, `filter_type`, `resource_title`, `content_tab`, `order`, `default`) VALUES
('siteestore', 'siteestore', 'Products', 1, 999, 1);");
    }

    
    
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'suggestion')
            ->where('enabled = ?', '1');
    $siteestore_temp = $select->query()->fetchObject();
    if (!empty($siteestore_temp)) {

      $select = new Zend_Db_Select($db);
      $select->from('engine4_activity_notificationtypes')->where('type = ?', 'siteestore_suggestion');
      $fetch = $select->query()->fetchObject();
      if (empty($fetch)) {
        $db->query('
INSERT IGNORE INTO `engine4_activity_notificationtypes` (`type`, `module`, `body`,`is_request`, `handler`, `default`)VALUES (
"siteestore_suggestion", "suggestion", \'{item:$subject} has suggested to you a {item:$object:product}.\', "1", "suggestion.widget.get-notify", "1" )     
');
      }

      $select = new Zend_Db_Select($db);
      $select->from('engine4_suggestion_module_settings')->where('module = ?', 'siteestore');
      $fetch = $select->query()->fetchObject();
      if (empty($fetch)) {
        $db->query('
INSERT IGNORE INTO `engine4_suggestion_module_settings` (`module`, `item_type`, `field_name`, `owner_field`, `item_title`, `button_title`, `enabled`, `notification_type`, `quality`, `link`, `popup`, `recommendation`, `default`, `settings`) VALUES
("siteestore", "siteestore_product", "product_id", "owner_id", "Product", "View this Product", 1, "siteestore_suggestion", 0, 1, 1, 1, 1, \'a:0:{}\');
');
      }

      $select = new Zend_Db_Select($db);
      $select->from('engine4_core_mailtemplates')->where('type = ?', 'notify_siteestore_suggestion');
      $fetch = $select->query()->fetchObject();
      if (empty($fetch)) {
        $db->query('
INSERT IGNORE INTO `engine4_core_mailtemplates` (`type`, `module`, `vars`)VALUES 
("notify_siteestore_suggestion", "suggestion", "[suggestion_sender], [suggestion_entity], [email], [link]"
);    
');
      }
    }

    parent::onInstall();
  }

}

?>