<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteestore
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: manifest.php 2012-10-22 9:40:21Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */
$url = 'shop';
$module=null;$controller=null;$action=null;$getURL = null;
$request = Zend_Controller_Front::getInstance()->getRequest();
if (!empty($request)) {
  $module = $request->getModuleName(); // Return the current module name.
  $action = $request->getActionName();
  $controller = $request->getControllerName();
  $getURL = $request->getRequestUri();
}
if (empty($request) || !($module == "default" && ( strpos( $getURL, '/install') !== false))) {
  $url = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteestore.manifestUrl', "shop");
}

return array(
    'package' =>
    array(
        'type' => 'module',
        'name' => 'siteestore',
        'version' => '5.4.1',
        'path' => 'application/modules/Siteestore',
        'title' => 'E-commerce Store Plugin - SocialEngine Magento Integration',
        'description' => 'E-commerce Store Plugin - SocialEngine Magento Integration',
        'author' => '<a href="http://www.socialapps.tech" style="text-decoration:underline;" target="_blank">SocialApps.tech</a>',
        'callback' =>
        array(
            'path' => 'application/modules/Siteestore/settings/install.php',
            'class' => 'Siteestore_Installer',
        ),
        'actions' =>
        array(
            0 => 'install',
            1 => 'upgrade',
            2 => 'refresh',
            3 => 'enable',
            4 => 'disable',
        ),
        'directories' =>
        array(
            0 => 'application/modules/Siteestore',
        ),
        'files' =>
        array(
            0 => 'application/languages/en/siteestore.csv',
        ),
    ),
    // Hooks ---------------------------------------------------------------------
    'hooks' => array(
        array(
            'event' => 'onUserLoginAfter',
            'resource' => 'Siteestore_Plugin_Core',
        ),
        array(
            'event' => 'onUserCreateAfter',
            'resource' => 'Siteestore_Plugin_Core',
        ),
        array(
            'event' => 'onUserDeleteAfter',
            'resource' => 'Siteestore_Plugin_Core',
        ),
        array(
            'event' => 'onUserLogoutBefore',
            'resource' => 'Siteestore_Plugin_Core'
        ),
        array(
            'event' => 'onRenderLayoutDefault',
            'resource' => 'Siteestore_Plugin_Core'
        )
    ),
    // Items ---------------------------------------------------------------------
    'items' => array(
        'siteestore_user',
        'siteestore_infopage',
        'siteestore_languagemap',
        'siteestore_faq',
        'siteestore_product',
        'siteestore_order'
    ),
    // Routes --------------------------------------------------------------------
    'routes' => array(
        'siteestore' => array(
            'route' => 'siteestore/*',
            'defaults' => array(
                'module' => 'siteestore',
                'controller' => 'index',
                'action' => 'index',
            ),
        ),
        'store_sync' => array(
          'route' => 'stors/:action/*',
          'defaults' => array(
            'module' => 'siteestore',
            'controller' => 'sync',
            'action' => 'create',
          ),
          'reqs' => array(
            'action' => '(create|update)',
          ),
        ),
        'magento_main' => array(
            'route' => $url . '/*',
            'defaults' => array(
                'module' => 'siteestore',
                'controller' => 'index',
                'action' => 'shopping',
            ),
            'reqs' => array(
            'action' => '(shopping)',
            'controller' => '(index)',    
          ),
        ),
        'siteestore_purchased_products' => array(
            'route' => $url.'/purchased-products/*',
            'defaults' => array(
                'module' => 'siteestore',
                'controller' => 'index',
                'action' => 'purchased-products',
            ),
        ),
        'magento_account' => array(
            'route' => $url . '/account/*',
            'defaults' => array(
                'module' => 'siteestore',
                'controller' => 'index',
                'action' => 'account',
            ),
        ),
//        'magento_main' => array(
//            'route' => $url . '/index/*',
//            'defaults' => array(
//                'module' => 'siteestore',
//                'controller' => 'index',
//                'action' => 'shopping',
//            )
//        ),
        'magento_checkout' => array(
            'route' => $url . '/checkout/*',
            'defaults' => array(
                'module' => 'siteestore',
                'controller' => 'index',
                'action' => 'cart',
            )
        ),
        'magento_wishlist' => array(
            'route' => $url . '/account/wishlist/*',
            'defaults' => array(
                'module' => 'siteestore',
                'controller' => 'index',
                'action' => 'account',
            )
        ),
        'magento_cart' => array(
            'route' => $url . '/cart/*',
            'defaults' => array(
                'module' => 'siteestore',
                'controller' => 'index',
                'action' => 'cart',
            )
        ),
        'magento_account_info' => array(
            'route' => 'info',
            'defaults' => array(
                'module' => 'siteestore',
                'controller' => 'index',
                'action' => 'info',
            ),
        ),
        'siteestore_help' => array(
            'route' => $url . '/help-and-learnmore/page_id/:page_id',
            'defaults' => array(
                'module' => 'siteestore',
                'controller' => 'index',
                'action' => 'help-and-learnmore',
            )
        ),
        'siteestore_help_and_learnmore' => array(
            'route' => $url . '/help-and-learnmore/*',
            'defaults' => array(
                'module' => 'siteestore',
                'controller' => 'index',
                'action' => 'help-and-learnmore',
            )
        )
    )
);
?>
