<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteestore
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2012-10-22 9:40:21Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */
class Siteestore_Widget_BlocksController extends Engine_Content_Widget_Abstract {

  public function indexAction() {

    $getUserStatus = Engine_Api::_()->siteestore()->getUserStatus();
    if (empty($getUserStatus)) {
      return $this->setNoRender();
    }

    $isApiConnValid = Engine_Api::_()->getApi('Xmlrpc', 'siteestore')->isApiConnValid();
    $isWidgetsRender = Engine_Api::_()->siteestore()->isWidgetsRender();
    $this->view->blockName = $blockName = $this->_getParam('block_name', 0);
    $shop_block_name = $this->_getParam('shop_block_name', 0);
    if ($blockName == '-1') {
      $blockName = $shop_block_name;
    }
    $this->view->getSEBaseUrl = Engine_Api::_()->siteestore()->getSEBaseUrl();
    $isRegistrySet = Zend_Registry::isRegistered('is_registry_set') ? Zend_Registry::get('is_registry_set') : null;
    $getBlock = Zend_Registry::isRegistered($blockName) ? Zend_Registry::get($blockName) : null;
    $this->view->getMagentoFlag = $getMagentoFlag = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteestore_manifestUrl', 'shop');
    $siteestore_isblock = Zend_Registry::isRegistered('mage_isblock') ? Zend_Registry::get('mage_isblock') : null;
	if( strstr($blockName, 'catalog.topnav') ) {
	  $getBlock = str_replace($getMagentoFlag . '/cart', $getMagentoFlag . '/index', $getBlock);
	  $getBlock = str_replace($getMagentoFlag . '/account', $getMagentoFlag . '/index', $getBlock);
	}
    if (strstr($blockName, 'catalog.leftnav') || strstr($blockName, 'left.newsletter')) {
      $category_page = Zend_Registry::isRegistered('category_page') ? Zend_Registry::get('category_page') : null;
      if (empty($category_page)) {
        return $this->setNoRender();
      }
    }

    if (empty($siteestore_isblock) || (strstr($blockName, 'breadcrumbs') && !empty($isRegistrySet) && empty($getBlock))) {
      return $this->setNoRender();
    }


    if ((empty($blockName) && empty($shop_block_name)) || empty($isApiConnValid) || empty($isWidgetsRender)) {
      return $this->setNoRender();
    }

//    $blockName = $blockName;
//    if ($blockName == '-1') {
//      $blockName = $shop_block_name;
//    }

    $this->view->mage_version = Engine_Api::_()->getApi('settings', 'core')->getSetting('mage.version', null);
    $this->view->isViewPage = Zend_Registry::isRegistered('siteestore_view_page') ? Zend_Registry::get('siteestore_view_page') : null;
    $this->view->mageBridgeType = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteestore.bridge.type', 0);
    $this->view->mageRequestPath = Zend_Registry::isRegistered('mage_request_path') ? Zend_Registry::get('mage_request_path') : null;
    $this->view->isViewPage_checkout = Zend_Registry::isRegistered('is_checkout_page') ? Zend_Registry::get('is_checkout_page') : null;
    $this->view->getGlobalUrl = $getBaseURL = Engine_Api::_()->siteestore()->getGlobalUrls();
    $this->view->hostType = Engine_Api::_()->siteestore()->getSEProtocol();
    $this->view->getMageProtocol = Engine_Api::_()->siteestore()->getMageProtocol();
    $front = Zend_Controller_Front::getInstance();
    $curr_url = $front->getRequest()->getRequestUri();
    $this->view->getBaseAction = 'index';
    if (strstr($curr_url, 'cart') || strstr($curr_url, 'checkout')) {
      $this->view->getBaseAction = 'cart';
    }

    $this->view->getSEBaseUrl = Engine_Api::_()->siteestore()->getSEBaseUrl();
    $this->view->magentoBaseUrl = Engine_Api::_()->siteestore()->magentoBaseUrl();
    $this->view->block = $block = $blockName;

    if (empty($getBlock) && empty($isRegistrySet)) {
      // If widgets placed outside the "Browse Page" and "View Page"
      $this->view->widgetFlag = true;
      $this->view->isAjaxEnabled = $isAjaxEnabled = $this->_getParam('getWidAjaxEnabled', 1);

      if (empty($isAjaxEnabled)) {
        $data = array(
            'block' => $block
        );
        // Sending the cURL request.
        $this->view->data = $contentBlock = Engine_Api::_()->getApi('Curl', 'siteestore')->getCurlResponse($data);
      }
    } else {
      if (!empty($getBlock)) {
        $this->view->data = $getBlock;
      } else {
        return $this->setNoRender();
      }
    }
  }

}

?>