<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteestore
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2012-10-22 9:40:21Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */
class Siteestore_Widget_GutterMenuController extends Engine_Content_Widget_Abstract {

  public function indexAction() {
    $this->view->viewer_id = $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();

    $siteestore_view_page = Zend_Registry::isRegistered('siteestore_view_page') ? Zend_Registry::get('siteestore_view_page') : null;

    $getUserStatus = Engine_Api::_()->siteestore()->getUserStatus();

    if (empty($siteestore_view_page) || empty($viewer_id) || empty($getUserStatus)) {
      return $this->setNoRender();
    }

    // Get navigation
    $this->view->gutterNavigation = $gutterNavigation = Engine_Api::_()->getApi('menus', 'core')
            ->getNavigation('siteestore_gutter');

    // LIKE PLUGIN LINK WORK
    $modulesEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitelike');
    if (!empty($modulesEnabled)) {
      $this->view->module_name = false;
      //WE CAN GET THE VIEWER ID.
      $subject = Engine_Api::_()->core()->getSubject();
      $subjectType = $subject->getType();

      //HERE WE CAN FOUND THE MODULE NAME AND MODULE IS ENABLE.
      $moduleName = Zend_Controller_Front::getInstance()->getRequest()->getModuleName();

      $mixsettingstable = Engine_Api::_()->getDbtable('mixsettings', 'sitelike');
      $sub_status_select = $mixsettingstable->fetchRow(array('resource_type = ?' => $subjectType, 'module = ?' => $moduleName, 'enabled' => 1));

      if (!empty($sub_status_select)) {
        $this->view->module_name = $sub_status_select->resource_type;
      }
    }
  }

}
