<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteestore
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2012-10-22 9:40:21Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */
class Siteestore_Widget_listPopularProductsController extends Engine_Content_Widget_Abstract {

  public function indexAction() {
    $getUserStatus = Engine_Api::_()->siteestore()->getUserStatus();
    if (empty($getUserStatus)) {
      return $this->setNoRender();
    }
    
    $isApiConnValid = Engine_Api::_()->getApi('Xmlrpc', 'siteestore')->isApiConnValid();
    $limit = $this->_getParam('itemCountPerPage', 3);
    $this->view->type = $type = $this->_getParam('popularType', 'view');

    $this->view->widget_title = $this->_getParam('tempTitle', 'Most Viewed Products');
    $this->view->title_type = $this->_getParam('titleType', 0);
    $mage_popular_products = Zend_Registry::isRegistered('mage_popular_products') ? Zend_Registry::get('mage_popular_products') : null;

    if (empty($mage_popular_products) || (empty($limit) && empty($type))) {
      return $this->setNoRender();
    }

    $productInfo = Engine_Api::_()->getItemTable('siteestore_product')->popularProducts($type, $limit);

    $this->view->getData = $productInfo;


    if (empty($productInfo)) {
      return $this->setNoRender();
    }
  }

}

?>
