<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteevent
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Join.php 6590 2014-01-02 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteevent_Form_Member_Join extends Engine_Form {

    public function init() {
        $this
                ->setTitle('Join Event')
                ->setDescription('Would you like to join this event?')
                ->setMethod('POST')
                ->setAction($_SERVER['REQUEST_URI'])
        ;
        $setting = Engine_Api::_()->getApi('core', 'siteevent');
        $rsvpLabel = $setting->getRsvpLabels();
        $rsvpMembership = $setting->getRsvpMembershipSetting();
        if($rsvpMembership){
            $multiOptions = array(
                                    '2' => $rsvpLabel[2],
                                    '1' => $rsvpLabel[1],
                                    );
        }else{
            $multiOptions = array(
                                    '2' => $rsvpLabel[2],
                                    '1' => $rsvpLabel[1],
                                    '0' => $rsvpLabel[0],
                                    );
        }

        $this->addElement('Radio', 'rsvp', array(
            'required' => true,
            'allowEmpty' => false,
            'multiOptions' => $multiOptions,
            'value' => 2,
        ));

        //$this->addElement('Hash', 'token');

        $this->addElement('Button', 'submit', array(
            'label' => 'Join Event',
            'ignore' => true,
            'decorators' => array('ViewHelper'),
            'type' => 'submit'
        ));

        $this->addElement('Cancel', 'cancel', array(
            'prependText' => ' or ',
            'label' => 'cancel',
            'link' => true,
            'href' => '',
            'onclick' => 'parent.Smoothbox.close();',
            'decorators' => array(
                'ViewHelper'
            ),
        ));

        $this->addDisplayGroup(array(
            'submit',
            'cancel'
                ), 'buttons');
    }

}