<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteevent
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Upload.php 6590 2014-01-02 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteevent_Form_Photo_Upload extends Engine_Form {

    public function init() {

        $siteevent = Engine_Api::_()->getItem('siteevent_event', Zend_Controller_Front::getInstance()->getRequest()->getParam('event_id', null));

        $this
                ->setTitle('Add New Photos')
                ->setDescription("Choose photos on your computer to add to this event. (2MB maximum).")
                ->setAttrib('id', 'form-upload')
                ->setAttrib('class', 'global_form siteevent_form_upload')
                ->setAttrib('name', 'albums_create')
                ->setAttrib('enctype', 'multipart/form-data')
                ->setAction(Zend_Controller_Front::getInstance()->getRouter()->assemble(array()));

        $siteevent = Engine_Api::_()->getItem('siteevent_event', Zend_Controller_Front::getInstance()->getRequest()->getParam('event_id', null));

        //PACKAGE BASED CHECKS
        if (Engine_Api::_()->siteevent()->hasPackageEnable()) {
            $photoCount = Engine_Api::_()->getDbTable('packages', 'siteeventpaid')->getPackageOption($siteevent->package_id, 'photo_count');
        } else {
            $photoCount = 0;
        }

        $uploadUrl = Zend_Controller_Front::getInstance()->getRouter()->assemble(array()) . '?ul=1';
        $deleteUrl = $this->getView()->url(array('module' => 'siteevent', 'controller' => 'photo', 'action' => 'remove'), 'default');
        $this->addElement('SeaoFancyUpload', 'file', array(
            'url' =>  $uploadUrl,
            'deleteUrl' =>  $deleteUrl,
            'accept' => 'image/*',
            'data' => array(
                'limitFiles' => $photoCount
            ),
        ));

        $this->addElement('Button', 'submit', array(
            'label' => 'Save Photos',
            'type' => 'submit',
        ));
    }

}