<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteeventadmincontact
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Mail.php 6590 2014-01-02 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteeventadmincontact_Form_Admin_Mail_Mail extends Engine_Form {

    public function init() {

        //GET DECORATORS
        $this->loadDefaultDecorators();

        if (!Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitemailtemplates') || !Engine_Api::_()->getApi('settings', 'core')->getSetting('sitemailtemplates.isActivate', 0)) {
            $description = sprintf(Zend_Registry::get('Zend_Translate')->_('Using this form, you will be able to send an email out to all of the Owners and Leaders of Events on your website. Emails are sent out using a queue system, so they will be sent out over time. An email will be sent to you when all emails have been sent. You can also first send out a test email to your account before sending it to your site\'s Event Owners and Leaders. To configure settings for the outgoing emails from this tool, please visit the "Email Settings" tab.<br />You can use this tool to communicate to users about tips to more effectively use Events on your website. You can also inform them about new features added to Events. SocialApps.tech is regularly releasing %1$snew extensions%2$s and enhancements and this tool can help you inform your users about them as you make these features available on your website.<br />This can be a great way to motivate users to keep their Events updated and active on your website.<br/><div class="tip"><span>To send attractive emails to your users via rich, branded, professional and impact-ful emails by using our \'%3$sEmail Templates Plugin%4$s\'. To see details, please \'%5$svisit here%6$s\'.</span></div>'), '<a href="http://www.socialapps.tech/catalog/advanced-events-extensions" target="_blank">', '</a>', "<a href='http://www.socialapps.tech/socialengine-email-templates-plugin' target='_blank'>", "</a>", "<a href='http://www.socialapps.tech/socialengine-email-templates-plugin' target='_blank'>", "</a>");
        } else {
            //GET DESCRIPTION
            $description = sprintf(Zend_Registry::get('Zend_Translate')->_("Using this form, you will be able to send an email out to all of the Owners and Leaders of Events on your website. Emails are sent out using a queue system, so they will be sent out over time. An email will be sent to you when all emails have been sent. You can also first send out a test email to your account before sending it to your site's Event Owners and Leaders. To configure settings for the outgoing emails from this tool, please visit the 'Email Settings' tab.<br />You can use this tool to communicate to users about tips to more effectively use Events on your website. You can also inform them about new features added to Events. SocialApps.tech is regularly releasing %s and enhancements and this tool can help you inform your users about them as you make these features available on your website.<br />This can be a great way to motivate users to keep their Events updated and active on your website."), '<a href="http://www.socialapps.tech/catalog/advanced-events-extensions" target="_blank">new extensions</a>');
        }

        $this->getDecorator('Description')->setOption('escape', false);

        //SET TITLE AND DESCRIPTION
        $this
                ->setTitle('Email All Event Owners and Leaders')
                ->setDescription("$description");

        //PREPARE CATEGORIES
        $categories = Engine_Api::_()->getDbTable('categories', 'siteevent')->getCategories(array('category_id', 'category_name'));
        if (count($categories) != 0) {
            $categories_prepared[0] = "All Categories";
            foreach ($categories as $category) {
                $categories_prepared[$category->category_id] = $category->category_name;
            }
        }

        $this->addElement('Multiselect', 'categories', array(
            'label' => 'Event Categories',
            'description' => 'Hold down the CTRL key to select or de-select specific Event Categories for which Owners and Leaders of corresponding Events need to be sent emails.',
            'required' => false,
            'allowEmpty' => true,
            'multiOptions' => $categories_prepared,
            'value' => 0
        ));
        $this->categories->getDecorator('Description')->setOptions(array('placement' => 'APPEND'));

        $status_prepared = array("All" => "All Events", "Draft" => "Draft Events", "Published" => "Published Events", "Open" => "Re-publish Events", "Cancel" => "Cancel Events", "Featured" => "Featured Events", "Sponsored" => "Sponsored Events", "Approved" => "Approved Events", "DisApproved" => "Dis-approved Events");

        $this->addElement('Multiselect', 'status', array(
            'label' => 'Status',
            'RegisterInArrayValidator' => false,
            'description' => 'Hold down the CTRL key to select or de-select specific Event Status for which Owners and Leaders of corresponding Events need to be sent emails.',
            'required' => false,
            'allowEmpty' => true,
            'multiOptions' => $status_prepared,
            'value' => "All"
        ));
        $this->status->getDecorator('Description')->setOptions(array('placement' => 'APPEND'));

        $start = new Engine_Form_Element_CalendarDateTime('starttime');
        $start->setLabel("Start Date");
				$start->setDescription("Select the start date of events by using the calendar icon below. [All the events beginning after this date will be selected.]");
        //$start->setAllowEmpty(TRUE);
        $this->addElement($start);

        // End time
        $end = new Engine_Form_Element_CalendarDateTime('endtime');
        $end->setLabel("End Date");
        $end->setDescription("Select the end date of events by using the calendar icon below. [All the events ending before this date will be selected.]");
       // $end->setAllowEmpty(TRUE);
        $this->addElement($end);

        // Make Network List
        $table = Engine_Api::_()->getDbtable('networks', 'network');
        $select = $table->select()
                ->from($table->info('name'), array('network_id', 'title'))
                ->order('title');
        $result = $table->fetchAll($select);

        $networksOptions = array('0' => 'Everyone');
        foreach ($result as $value) {
            $networksOptions[$value->network_id] = $value->title;
        }

        if (count($networksOptions) > 0) {
            $this->addElement('Multiselect', 'networks_privacy', array(
                'label' => 'Networks Selection',
                'description' => Zend_Registry::get('Zend_Translate')->_("Hold down the CTRL key to select or de-select specific Networks for which Owners and Leaders of corresponding Events need to be sent emails."),
                'multiOptions' => $networksOptions,
                'value' => array(0)
            ));
            $this->networks_privacy->getDecorator('Description')->setOptions(array('placement' => 'APPEND'));
        }

        $this->addElement('Text', 'subject', array(
            'label' => 'Subject:',
            'required' => true,
            'allowEmpty' => false,
        ));

        //UPLOAD PHOTO URL
        $upload_url = Zend_Controller_Front::getInstance()->getRouter()->assemble(array('module' => 'siteeventadmincontact', 'controller' => 'mails', 'action' => "upload-photo"), 'admin_default', true);

        //GET FILTER
        $filter = new Engine_Filter_Html();

        //BODY
        $this->addElement('TinyMce', 'body', array(
            'label' => 'Body',
            'required' => true,
            'allowEmpty' => false,
            'filters' => array(
                new Engine_Filter_Censor(),
                $filter,
            ),
            'editorOptions' => Engine_Api::_()->seaocore()->tinymceEditorOptions($upload_url),
        ));
        $this->body->getDecorator('Description')->setOptions(array('placement' => 'APPEND'));

        //SEND TEST EMAIL
        $this->addElement('Checkbox', 'siteevent_emailhost_setting', array(
            'label' => 'Send this email to Event Hosts (Site Member) also.',
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteevent.emailhost.setting', 1),
        ));


        //SEND TEST EMAIL
        $this->addElement('Checkbox', 'event_contactemail_demo', array(
            'label' => 'Send me a test email. Do not send emails to Event Owners and Leaders right now.',
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('event.contactemail.demo', 1),
            'description' => 'Test Email',
            'onclick' => 'showEventOption(this.checked)'
        ));

        //EMAIL ID FOR TESTING
        $this->addElement('Text', 'event_contactemail_admin', array(
            'label' => 'Email ID for Testing',
            'required' => true,
            'allowEmpty' => false,
            'validators' => array(
                array('NotEmpty', true),
                array('EmailAddress', true),
            ),
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('event.contactemail.admin', Engine_API::_()->seaocore()->getSuperAdminEmailAddress()),
        ));

        $this->event_contactemail_admin->getValidator('NotEmpty')->setMessage('Please enter a valid email address.', 'isEmpty');
        $this->event_contactemail_admin->getValidator('EmailAddress')->getHostnameValidator()->setValidateTld(false);

        //SUBMIT
        $this->addElement('Button', 'submit', array(
            'label' => 'Send Emails',
            'type' => 'submit',
            'ignore' => true,
        ));
    }

}