<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteeventdocument
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 6590 2014-01-02 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$statisticsElement = array(
    'MultiCheckbox',
    'statistics',
    array(
        'label' => 'Choose the statistics that you want to be displayed for the event document in this block.',
        'multiOptions' => array("viewCount" => "Views", "likeCount" => "Likes", "commentCount" => "Comments"),
    ),
);
return array(
    array(
        'title' => 'Event Profile Documents',
        'description' => 'Displays a event’s documents on its profile.',
        'category' => 'Advanced Events - Documents',
        'type' => 'widget',
        'name' => 'siteeventdocument.profile-siteeventdocuments',
        'defaultParams' => array(
            'title' => 'Documents',
            'loaded_by_ajax' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                $statisticsElement,
                array(
                    'Radio',
                    'loaded_by_ajax',
                    array(
                        'label' => 'Widget Content Loading',
                        'description' => 'Do you want the content of this widget to be loaded via AJAX, after the loading of main webpage content? (Enabling this can improve webpage loading speed. Disabling this would load content of this widget along with the page content.)',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
                array(
                    'Text',
                    'truncationTitle',
                    array(
                        'label' => 'Title Truncation Limit',
                        'value' => 55,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                    )
                ),
            )
        )
    ),
    array(
        'title' => 'Event Profile / Document View Page - Popular Documents',
        'description' => 'Displays event documents based on the Popularity / Sorting Criteria and other settings that you choose for this widget. You can place this widget multiple times on a page with different popularity criterion chosen for each placement.',
        'category' => 'Advanced Events - Documents',
        'type' => 'widget',
        'name' => 'siteeventdocument.documents-siteeventdocuments',
        'defaultParams' => array(
            'title' => "%s's Documents",
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'title',
                    array(
                        'label' => 'Title',
                        'description' => "Enter below the format in which you want to display the title of the widget. (Note: To display event title name, enter title as: %s's Documents.)",
                        'value' => "%s's Documents",
                    )
                ),
                array(
                    'Select',
                    'popularity',
                    array(
                        'label' => 'Popularity / Sorting Criteria',
                        'multiOptions' => array(
                            'view_count' => 'Most Viewed',
                            'like_count' => 'Most Liked',
                            'comment_count' => 'Most Commented',
                            'rating' => 'Most Rated',
                            'document_id' => 'Most Recent',
                            'modified_date' => 'Recently Updated',
                        ),
                        'value' => 'document_id',
                    )
                ),
                $statisticsElement,
                array(
                    'Text',
                    'truncationTitle',
                    array(
                        'label' => 'Title Truncation Limit',
                        'value' => 18,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                    )
                ),
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Number of documents to show',
                        'value' => 3,
                    )
                ),
            )
        )
    ),
    array(
        'title' => 'Document Viewer',
        'description' => 'Displays the document viewer for viewing document. You can select the viewer type from ‘Global Settings’ of this plugin. This widget should be placed on Document View Page',
        'category' => 'Advanced Events - Documents',
        'type' => 'widget',
        'name' => 'siteeventdocument.content-siteeventdocuments',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'requirements' => array(
            'subject' => 'siteeventdocument_document',
        ),
        'adminForm' => array(
            'elements' => array(
                $statisticsElement,
                array(
                    'Text',
                    'documentViewerHeight',
                    array(
                        'description' => 'What should be the height in pixels of the document viewer?',
                        'value' => 600,
                    )
                ),
                array(
                    'Text',
                    'documentViewerWidth',
                    array(
                        'description' => 'What should be the width in pixels of the document viewer?',
                        'value' => 730,
                    )
                ),
                array(
                    'Hidden',
                    'nomobile',
                    array(
                        'label' => '',
                        'order' => 1001
                    )
                ),
            ),
        ),
    ),
    array(
        'title' => 'Document View Page Options',
        'description' => 'Displays the various action links that can be performed on the document on document’s view page (edit, download, report, share, etc ). This widget should be placed on the Document View Page in the right column, below the Document Owner’s photo. You can manage the action links available here from the Menu Editor section by choosing Document View Page Options Menu.',
        'category' => 'Advanced Events - Documents',
        'type' => 'widget',
        'name' => 'siteeventdocument.options-siteeventdocuments',
        'requirements' => array(
            'subject' => 'siteeventdocument_document',
        ),
    ),
    array(
        'title' => 'Document Social Share Buttons',
        'description' => "Contains Social Sharing buttons and enables users to easily share Documents on their favorite Social Networks. This widget should be placed on the Document View Page. You can customize the code for social sharing buttons from Global Settings of this plugin by adding your own code generated from: <a href='http://www.addthis.com' target='_blank'>http://www.addthis.com</a>",
        'category' => 'Advanced Events - Documents',
        'type' => 'widget',
        'name' => 'siteeventdocument.socialshare-siteeventdocuments',
        'defaultParams' => array(
            'title' => 'Social Share',
            'titleCount' => true,
        ),
        'requirements' => array(
            'subject' => 'siteeventdocument_document',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Hidden',
                    'nomobile',
                    array(
                        'label' => '',
                        'order' => 1002
                    )
                ),
            ),
        ),
    ),
    array(
        'title' => 'Owner’s Photo',
        'description' => 'Displays the document owner’s photo with owner’s name. This widget should be placed in the right column of Document View Page.',
        'category' => 'Advanced Events - Documents',
        'type' => 'widget',
        'name' => 'siteeventdocument.owner-photo-siteeventdocuments',
        'requirements' => array(
            'subject' => 'siteeventdocument_document',
        ),
    ),
);
