<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteeventdocument
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: manifest.php 6590 2014-01-02 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$module = null;
$controller = null;
$action = null;
$getURL = null;
$request = Zend_Controller_Front::getInstance()->getRequest();
$routes = array();
if (!empty($request)) {
    $module = $request->getModuleName();
    $action = $request->getActionName();
    $controller = $request->getControllerName();
    $getURL = $request->getRequestUri();
}

if (empty($request) || !($module == "default" && ( strpos( $getURL, '/install') !== false))) {

    $slug_plural = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteevent.slugplural', 'event-items');

    $routes = array(
        'siteeventdocument_create' => array(
            'route' => $slug_plural . '/document/create/:event_id',
            'defaults' => array(
                'module' => 'siteeventdocument',
                'controller' => 'index',
                'action' => 'create'
            ),
            'reqs' => array(
                'event_id' => '\d+'
            )
        ),
        'siteeventdocument_specific' => array(
            'route' => $slug_plural . '/document/:action/:document_id',
            'defaults' => array(
                'module' => 'siteeventdocument',
                'controller' => 'index',
            ),
            'reqs' => array(
                'document_id' => '\d+',
                'action' => '(delete|publish|featured|edit|email)',
            )
        ),
        'siteeventdocument_ssl' => array(
            'route' => $slug_plural . '/document/ssl/*',
            'defaults' => array(
                'module' => 'siteeventdocument',
                'controller' => 'index',
                'action' => 'ssl'
            )
        ),
        'siteeventdocument_detail_view' => array(
            'route' => $slug_plural . '/document/:document_id/:slug',
            'defaults' => array(
                'module' => 'siteeventdocument',
                'controller' => 'index',
                'action' => 'view',
                'slug' => '',
            ),
            'reqs' => array(
                'document_id' => '\d+'
            )
        ),
    );
}

return array(
    //Package -------------------------------------------------------------------
    'package' => array(
        'type' => 'module',
        'name' => 'siteeventdocument',
        'version' => '5.5.0',
        'path' => 'application/modules/Siteeventdocument',
        'repository' => 'null',
        'title' => 'Advanced Events - Documents Extension',
        'description' => 'Add an excitingly new and useful feature : Documents, to the Events on your site. The Events - Documents Extension Plugin brings the power of Documents / Scribd iPapers to SocialEngine Events. The plugin adds a "Documents" tab to every Event. Users can upload and display Documents in Events. Additionally, they can share, print, download documents, and comment on them. Features like the iPaper document viewer, Email attachments, user controlled privacy, support for extensive document formats, SEO URLs and SEO page structure, will attract more traffic to your site.',
        'author' => '<a href="http://www.socialapps.tech" style="text-decoration:underline;" target="_blank">SocialApps.tech</a>',
        'date' => 'Thursday, 2014-01-02 00:00:00Z',
        'copyright' => 'Copyright 2013-2014 BigStep Technologies Pvt. Ltd.',
        'actions' => array(
            'install',
            'upgrade',
            'refresh',
            'enable',
            'disable',
        ),
        'callback' => array(
            'path' => 'application/modules/Siteeventdocument/settings/install.php',
            'class' => 'Siteeventdocument_Installer',
        ),
        'directories' => array(
            'application/modules/Siteeventdocument',
        ),
        'files' => array(
            'application/languages/en/siteeventdocument.csv',
        ),
    ),
    // Mobile / Tablet Plugin Compatible
    'sitemobile_compatible' => true,
    //Hooks ---------------------------------------------------------------------
    'hooks' => array(
        array(
            'event' => 'onUserDeleteBefore',
            'resource' => 'Siteeventdocument_Plugin_Core',
        ),
    ),
    //Items ---------------------------------------------------------------------
    'items' => array(
        'siteeventdocument_document',
        'siteeventdocument_search',
    ),
    //Routes --------------------------------------------------------------------
    'routes' => $routes,
);
