<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteeventdocument
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 6590 2014-01-02 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
return array(
    array(
        'title' => 'Event Profile Documents',
        'description' => 'Displays a event’s documents on its profile.',
        'category' => 'Advanced Events - Documents',
        'type' => 'widget',
        'name' => 'siteeventdocument.profile-siteeventdocuments',
        'defaultParams' => array(
            'title' => 'Documents',
            'loaded_by_ajax' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'truncationTitle',
                    array(
                        'label' => 'Title Truncation Limit',
                        'value' => 30,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                    )
                ),
            )
        )
    ),
    array(
        'title' => 'Document Viewer',
        'description' => 'Displays the document viewer for viewing document. You can select the viewer type from ‘Global Settings’ of this plugin. This widget should be placed on Document View Page',
        'category' => 'Advanced Events - Documents',
        'type' => 'widget',
        'name' => 'siteeventdocument.content-siteeventdocuments',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'requirements' => array(
            'subject' => 'siteeventdocument_document',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'documentViewerHeight',
                    array(
                        'description' => 'What should be the height in pixels of the document viewer?',
                        'value' => 600,
                    )
                ),
                array(
                    'Text',
                    'documentViewerWidth',
                    array(
                        'description' => 'What should be the width in pixels of the document viewer?',
                        'value' => 730,
                    )
                ),
                array(
                    'Hidden',
                    'nomobile',
                    array(
                        'label' => '',
                    )
                ),
            ),
        ),
    ),
);
