<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteeventemail
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: FinishEvent.php 6590 2014-01-02 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteeventemail_Plugin_Task_FinishEvent extends Core_Plugin_Task_Abstract {

    public function execute() {
        $current_time = date("Y-m-d H:i:s");
        $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
        $siteeventemailPostSystemType = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteeventemailpost.system.type', null);
        $siteeventemail_finish_time = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteeventemail.finish.event.options', 3600);
        $siteeventEmailGetShowViewType = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteeventemail.getshow.viewtype', null);
        $sqlTimeStr = '';
        $oldTz = date_default_timezone_get();
        date_default_timezone_set('UTC');
        $lastEmailTimeSent = '';// Engine_Api::_()->getApi('settings', 'core')->getSetting('siteeventemail.lastemailtimesent');

        switch ($siteeventemail_finish_time) {
            case 3600:
                $relDate = new Zend_Date();
                $relDate->sub((int) 1, Zend_Date::HOUR);
                $dateInterval = date("Y-m-d H:i:s", $relDate->toValue());
                $sqlTimeStr = "endtime <= '$dateInterval'";
                if (!$lastEmailTimeSent) {
                    $lastEmailTimeSent = date("Y-m-d H:i:s", (time() - 3600));
                }
                $sqlTimeStr .= " AND endtime > '$lastEmailTimeSent'";
                break;
            case 86400:
                $relDate = new Zend_Date();
                $relDate->sub((int) 1, Zend_Date::DAY);
                $dateInterval = date("Y-m-d H:i:s", $relDate->toValue());
                $sqlTimeStr = "endtime <= '$dateInterval'";
                if (!$lastEmailTimeSent) {
                    $lastEmailTimeSent = date("Y-m-d H:i:s", (time() - 86400));
                }
                $sqlTimeStr .= " AND endtime > '$lastEmailTimeSent'";
                break;
        }
        date_default_timezone_set($oldTz);
        $eventEmailHostType = str_replace('www.', '', strtolower($_SERVER['HTTP_HOST']));
        $tempEventEmailTypeInfo = @base64_encode($eventEmailHostType);
        $siteEventOccuretable = Engine_Api::_()->getDbTable('occurrences', 'siteevent');
        $siteeventOccurTableName = $siteEventOccuretable->info('name');
        $eventTable = Engine_Api::_()->getDbtable('events', 'siteevent');
        $eventTableName = $eventTable->info('name');
        $siteeventMembershipTable = Engine_Api::_()->getDbTable('membership', 'siteevent');
        $siteeventMembershipTableName = $siteeventMembershipTable->info('name');
        $siteeventOtherinfoTable = Engine_Api::_()->getDbtable('otherinfo', 'siteevent');
        $siteeventOtherinfoTableName = $siteeventOtherinfoTable->info('name');
        $select = $eventTable->select()->setIntegrityCheck(false)
                ->from($eventTableName, array('event_id', 'closed'))
                ->join($siteeventOccurTableName, $eventTableName . '.event_id = ' . $siteeventOccurTableName . '.event_id', array('starttime', 'endtime'))
                ->join($siteeventMembershipTableName, $siteeventOccurTableName . '.occurrence_id = ' . $siteeventMembershipTableName . '.occurrence_id', array('user_id', 'occurrence_id', 'rsvp', 'confirm'))
                ->join($siteeventOtherinfoTableName, $siteeventOtherinfoTableName . '.event_id = ' . $eventTableName . '.event_id')
                ->where("$siteeventMembershipTableName.rsvp=2")
                ->where("$siteeventMembershipTableName.active=1")
                ->where("$siteeventMembershipTableName.resource_approved=1")
                ->where("$siteeventMembershipTableName.user_approved=1")
                ->where("$sqlTimeStr")
                ->where($eventTableName . '.approved = ?', '1')
                ->where($eventTableName . '.draft = ?', '0')
                ->where($eventTableName . ".search = ?", 1)
                ->where($eventTableName . '.closed = ?', '0')
                ->group($eventTableName . '.event_id')
                ->group($siteeventMembershipTableName . '.user_id');

        $validator = new Zend_Validate_EmailAddress();
        $validator->getHostnameValidator()->setValidateTld(false);
        $events = $select->query()->fetchAll();
        if ($events) {
            foreach ($events as $key => $value) {
                $siteevent = Engine_Api::_()->getItem('siteevent_event', $value['event_id']);

                $user = Engine_Api::_()->getItem('user', $value['user_id']);
                $email = $user->email;

                if ($siteevent->closed)
                    continue;

                if (!$validator->isValid($email)) {
                    continue;
                }
                Zend_Registry::set('occurrence_id', $value['occurrence_id']);
                $siteeventemailFinishEvents = Zend_Registry::isRegistered('siteeventemailFinishEvents') ? Zend_Registry::get('siteeventemailFinishEvents') : null;
                if (empty($siteeventemailFinishEvents))
                    continue;

                if (!empty($email) && (!empty($siteeventEmailGetShowViewType) || empty($siteeventemailPostSystemType) || ($siteeventemailPostSystemType == $tempEventEmailTypeInfo))) {

                    $startDateObject = new Zend_Date(strtotime($value['starttime']));
                    $endDateObject = new Zend_Date(strtotime($value['endtime']));
                    $optionText = '';

                    $tz = $user->timezone;
                    $startDateObject->setTimezone($tz);
                    $endDateObject->setTimezone($tz);
                    if ($startDateObject->toString('y-MM-dd') == $endDateObject->toString('y-MM-dd')) {

                        $optionText = $view->locale()->toDateTime($startDateObject, array('timezone' => $user->timezone)) . ' ' . $view->locale()->toTime($startDateObject, array('timezone' => $user->timezone)) . ' - ' . $view->locale()->toTime($endDateObject, array('timezone' => $user->timezone));
                    } else {
                        $optionText = $view->locale()->toDateTime($startDateObject, array('timezone' => $user->timezone)) . ' - ' . $view->locale()->toDateTime($endDateObject, array('timezone' => $user->timezone));
                    }

                    if (!Engine_Api::_()->getApi('settings', 'core')->getSetting('siteevent.guestconfimation', 0)) {

                        Engine_Api::_()->getApi('mail', 'core')->sendSystem($email, "siteevent_finish_event", array(
                            'event_title' => $siteevent->getTitle(),
                            'date_time' => $optionText,
                            'venue_name' => $siteevent->venue_name,
                            'event_with_link' => 'http://' . $_SERVER['HTTP_HOST'] . $siteevent->getHref() . '/tab/' . Engine_Api::_()->siteevent()->getTabId('siteevent.user-siteevent'),
                            'event_home_with_link' => 'http://' . $_SERVER['HTTP_HOST'] . $view->baseUrl() . '/'. Engine_Api::_()->getApi('settings', 'core')->getSetting('siteevent.slugplural', 'event-items'),
                            'site_title' => Engine_Api::_()->getApi('settings', 'core')->getSetting('core.general.site.title'),
                            'email' => Engine_Api::_()->getApi('settings', 'core')->core_mail_from,
                            'queue' => false));
                    } else {
                        if (($value['confirm'] == 1) || ($value['confirm'] == 0 && $siteevent->owner_id == $user->getIdentity())) {
                            Engine_Api::_()->getApi('mail', 'core')->sendSystem($email, "siteevent_finish_rate_member", array(
                                'event_title' => $siteevent->getTitle(),
                                'date_time' => $optionText,
                                'venue_name' => $siteevent->venue_name,
                                'event_with_link' => 'http://' . $_SERVER['HTTP_HOST'] . $siteevent->getHref() . '/tab/' . Engine_Api::_()->siteevent()->getTabId('siteevent.profile-members'),
                                'event_home_with_link' => 'http://' . $_SERVER['HTTP_HOST'] . $view->baseUrl() . '/'. Engine_Api::_()->getApi('settings', 'core')->getSetting('siteevent.slugplural', 'event-items'),
                                'site_title' => Engine_Api::_()->getApi('settings', 'core')->getSetting('core.general.site.title'),
                                'email' => Engine_Api::_()->getApi('settings', 'core')->core_mail_from,
                                'queue' => false));
                        }
                    }

                    if (($value['confirm'] == 1) || ($value['confirm'] == 0 && $siteevent->owner_id == $user->getIdentity())) {
                        $notifyApi = Engine_Api::_()->getDbtable('notifications', 'activity');
                        $occurrence_id = $value['occurrence_id'];
                        $params = '{"occurrence_id":' . $occurrence_id . '}';
                        $select = $notifyApi->select()
                                ->where('user_id = ?', $user->getIdentity())
                                ->where('type = ?', 'siteevent_rate_participants')
                                ->where('object_type = ?', $siteevent->getType())
                                ->where('object_id = ?', $siteevent->getIdentity());
                        $notifications = $notifyApi->fetchAll($select);
                        foreach ($notifications as $notification) {
                            $notification = Engine_Api::_()->getItem('activity_notification', $notification['notification_id']);
                            if ($notification) {
                                $notification->delete();
                            }
                        }
                        $notifyApi->addNotification($user, $user, $siteevent, 'siteevent_rate_participants', array('occurrence_id' => $value['occurrence_id']));
                    }
                }
            } 
        }
      //  Engine_Api::_()->getApi('settings', 'core')->setSetting('siteeventemail.lastemailtimesent', $dateInterval);
    }

}
