<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteeventemail
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminMailsController.php 6590 2014-01-02 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteeventemail_AdminMailsController extends Core_Controller_Action_Admin {

    //ACTION FOR MAIL SETTINGS
    public function indexAction() {

        //GET NAVIGATION
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('siteeventemail_admin_main', array(), 'siteeventemail_admin_main_mails');

        //GET NAVIGATION
        $this->view->navigationEvent = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('siteevent_admin_main', array(), 'siteevent_admin_main_email');

        $this->view->form = $form = new Siteeventemail_Form_Admin_Email();
        $coremodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core');
        $coreversion = $coremodule->version;
        if (!($coreversion < '4.1.0')) {
            $enable_var = "processes";
        } else {
            $enable_var = "enabled";
        }
        $taskstable = Engine_Api::_()->getDbtable('tasks', 'core');
        $rtasksName = $taskstable->info('name');
        $taskstable_result = $taskstable->select()
                ->from($rtasksName, array($enable_var, 'timeout'))
                ->where('plugin = ?', 'Siteeventemail_Plugin_Task_ReminderMail')
                ->orWhere('plugin = ?', 'Siteeventemail_Plugin_Task_FinishEvent');
        $prefields = $taskstable->fetchAll($taskstable_result);

        $form->populate(array(
            'siteeventemail_reminder' => $prefields[0][$enable_var],
            'siteeventemail_finish_event' => $prefields[1][$enable_var]
        ));

        if ($this->getRequest()->isPost() && $form->isValid($this->_getAllParams())) {
            include APPLICATION_PATH . '/application/modules/Siteeventemail/controllers/license/license2.php';

            if (!empty($tempEventEmailFlag))
                $values = $form->getValues();
            else
                return;

            foreach ($values as $key => $value) {
                if (Engine_Api::_()->getApi('settings', 'core')->hasSetting($key))
                    Engine_Api::_()->getApi('settings', 'core')->removeSetting($key);
                Engine_Api::_()->getApi('settings', 'core')->setSetting($key, $value);
            }

            $tasksTable = Engine_Api::_()->getDbtable('tasks', 'core');
            $tasksTable->update(array($enable_var => $values['siteeventemail_reminder']), array('plugin = ?' => 'Siteeventemail_Plugin_Task_ReminderMail'));
            $tasksTable->update(array($enable_var => $values['siteeventemail_finish_event'], 'timeout' => $values['siteeventemail_finish_event_options']), array('plugin = ?' => 'Siteeventemail_Plugin_Task_FinishEvent'));
            $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
            // SEND TEST MAILS IF ADMIN WANTS
            if ($values['siteeventemail_demo'] == 1) {

                $reciever_email = $values['siteeventemail_admin'];
                $reciever_name = "Sample name";
                $href = ( _ENGINE_SSL ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . $view->baseUrl() . '/'. Engine_Api::_()->getApi('settings', 'core')->getSetting('siteevent.slugplural', 'event-items');
                $photo = ( _ENGINE_SSL ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . $view->layout()->staticBaseUrl . 'application/modules/Siteevent/externals/images/nophoto_event_thumb_icon.png';
                $image = "<img src='$photo' />";
                $event_title_with_photo_link = "<table cellspacing='0' cellpadding='0' style='border-collapse:collapse;' width='100%'><tr><td colspan='2' style='font-size:11px;font-family:LucidaGrande,tahoma,verdana,arial,sans-serif;border-bottom:1px solid #dddddd;padding-bottom:5px;'></td></tr><tr><td valign='top' style='padding:10px 15px 10px 10px;'><a href='$href'>" . $image . "</a></td><td valign='top' style='padding-top:10px;font-size:11px;font-family:LucidaGrande,tahoma,verdana,arial,sans-serif;width:100%;text-align:left;'></td></tr></table>";

                if ($values['siteeventemail_reminder']) {

                    $translate = Zend_Registry::get('Zend_Translate');
                    $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
                    $eventphoto_path = ( _ENGINE_SSL ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . $view->baseUrl() . '/application/modules/Siteevent/externals/images/nophoto_event_thumb_normal.png';
                    $body = '';
                    $eventUrl = ( _ENGINE_SSL ? 'https://' : 'http://' )
                            . $_SERVER['HTTP_HOST']
                            . $view->baseUrl() . '/'. Engine_Api::_()->getApi('settings', 'core')->getSetting('siteevent.slugplural', 'event-items');

                    $eventTitle = $view->translate('EVENT_NAME');
                    $hostname = $view->translate('Event Host');
                    $optionText = $view->translate('Event Date and Time');
                    $venue_name = $view->translate('Event Venue');
                    $location = $view->translate('Event Location');
                    $eventUrl_link = '';
                    $eventUrl_link .= $view->translate("Here's a little reminder of an upcoming event %s:", $eventTitle);
                    $eventUrl_link .= '<br > <table width="100%"><tr valign="top"><td style="padding-top:5px;"><div style="float:left;margin-right:15px;"><a href = ' . $eventUrl . ' target="_blank">' . '<img src="' . $eventphoto_path . '" align="left" style="width: 100px; border: 1px solid rgb(221, 221, 221); padding: 0px;"/>' . '</a></div><div style="overflow:hidden;">';
                    $event_details = '';
                    $event_details .= $translate->_('Host:') . '<b> ' . $hostname . '</b><br >' . $translate->_('Date & Time:') . '<b> ' . $optionText . '</b><br />' . $translate->_('Venue:') . '<b> ' . $venue_name . '</b><br />' . $translate->_('Location:') . '<b> ' . $location . '</b>';

                    $body .= $eventUrl_link . $event_details . '</div></td></tr><tr><td><br />';

                    $body .= $translate->_("Hope to see you soon :)") . '<br /><br />';

                    if(!Engine_Api::_()->siteevent()->isTicketBasedEvent()) {
                        $availabilityStatus = $translate->_('Yes / May be');

                        $body .= $view->translate('Your availability status: %1$s', $availabilityStatus) . '<br /><br />';

                        $changeAvailability = '<a href=" ' . $eventUrl . '?changeRsvp=2' . '">' . $translate->_("Yes") . '</a>&nbsp;&nbsp;';
                        $changeAvailability .= '&middot; <a href=" ' . $eventUrl . '?changeRsvp=3' . '">' . $translate->_("No") . '</a>&nbsp;&nbsp;';
                        $changeAvailability .= '&middot; <a href=" ' . $eventUrl . '?changeRsvp=1' . '">' . $translate->_("Maybe") . '</a>&nbsp;';
                        $body .= $view->translate('Change Availability To: %1$s', $changeAvailability) . '<br /><br />';
                    }
                    
                $tab_id = Engine_Api::_()->siteevent()->getTabId('siteevent.profile-members');
                $guestUrl = $tab_id ? $eventUrl . '/tab/' . $tab_id : $eventUrl;
                     
                if (!Engine_Api::_()->siteevent()->isTicketBasedEvent()) {
           
                    $body .= '<span style="border:1px solid #5c98b8;background-color:#79b4d4;margin-right:10px;display:inline-block;"><table cellspacing="0" cellpadding="0" style="border-collapse:collapse"><tbody><tr><td style="font-size:11px;font-family:tahoma,verdana,arial,sans-serif;padding:2px 6px 4px;border-top:1px solid #8a9cc2"><a href="' . $guestUrl . '" style="text-decoration:none;font-weight:bold;color:#fff;font-size:11px" target="_blank"> ' . $translate->_("View Guest List") . '</a></td></tr></tbody></table></span>';
                     }

                    $body .= '<span style="border:1px solid #5c98b8;background-color:#79b4d4;display:inline-block;"><table cellspacing="0" cellpadding="0" style="border-collapse:collapse"><tbody><tr><td style="font-size:11px;font-family:tahoma,verdana,arial,sans-serif;padding:2px 6px 4px;border-top:1px solid #8a9cc2"><a href="' . $eventUrl . '" style="text-decoration:none;font-weight:bold;color:#fff;font-size:11px" target="_blank"> ' . $translate->_("Go to Event") . '</a></td></tr></tbody></table></span>';
                    foreach ($values['siteeventemail_reminder_options'] as $value) {
                        if ($value == '86400') {
                            $number_of_days = 'one';
                        } elseif ($value == '172800') {
                            $number_of_days = 'two';
                        } elseif ($value == '259200') {
                            $number_of_days = 'three';
                        } elseif ($value == '604800') {
                            $number_of_days = 1;
                        } elseif ($value == '1209600') {
                            $number_of_days = 2;
                        } elseif ($value == '2592000') {
                            $number_of_days = 1;
                        }

                        Engine_Api::_()->getApi('mail', 'core')->sendSystem($reciever_email, "siteevent_reminder_$value", array(
                            'body' => $body,
                            'event_title' => $eventTitle,
                            'date_time' => $optionText,
                            'number_of_days' => $number_of_days,
                            'recipient_title' => $reciever_name,
                            'email' => Engine_Api::_()->getApi('settings', 'core')->core_mail_from,
                            'queue' => false));
                    }
                }

                if ($values['siteeventemail_finish_event']) {
                    Engine_Api::_()->getApi('mail', 'core')->sendSystem($reciever_email, "siteevent_finish_event", array(
                        'recipient_title' => $reciever_name,
                        'event_title' => 'EVENT_NAME',
                        'date_time' => 'Start Date to End Date',
                        'venue_name' => 'venue',
                        'event_with_link' => 'http://' . $_SERVER['HTTP_HOST'] . $view->baseUrl() . '/'. Engine_Api::_()->getApi('settings', 'core')->getSetting('siteevent.slugplural', 'event-items'),
                        'event_home_with_link' => 'http://' . $_SERVER['HTTP_HOST'] . $view->baseUrl() . '/'. Engine_Api::_()->getApi('settings', 'core')->getSetting('siteevent.slugplural', 'event-items'),
                        'site_title' => Engine_Api::_()->getApi('settings', 'core')->getSetting('core.general.site.title'),
                        'email' => Engine_Api::_()->getApi('settings', 'core')->core_mail_from,
                        'queue' => false));
                }
            }
            $this->_helper->redirector->gotoRoute(array('action' => 'index'));
        }
    }

}