<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteeventrepeat
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 6590 2014-01-02 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => $view->translate('Event Profile: Recurring Pattern Info'),
        'description' => $view->translate('This widget displays information about the repeating pattern of an event. Settings to enable event occurrence type, condition and event’s start and end time are available in the Edit Settings section of this widget. This widget should be placed on Advanced Events - Event Profile page.'),
        'category' => $view->translate('Advanced Events'),
        'type' => 'widget',
        'name' => 'siteeventrepeat.event-profile-repeateventdate',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'autoEdit' => true,
        'adminForm' => array(
            'elements' => array(
                array(
                    'Radio',
                    'showeventtype',
                    array(
                        'label' => 'Event Occurrence Type (Daily, Weekly, Monthly, Custom)',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
                array(
                    'Radio',
                    'showeventcondition',
                    array(
                        'label' => 'Show Event’s Occurrence Condition (for ex. Condition: “Every 2 weeks - Every Saturday & Sunday” for a Weekly Event).',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
                array(
                    'Radio',
                    'showeventtime',
                    array(
                        'label' => 'Show Start and End dates.',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
            )
        )
    ),
    array(
        'title' => $view->translate('Event Profile: Recurring Event - Occurrence Listings'),
        'description' => $view->translate('Displays Occurrence Listings of a recurring event. From the Edit Settings of this widget, you can choose to show occurrence dates, guests in each occurrence, Join Event button, etc. This widget should be placed on the Advanced events - Event Profile page.'),
        'category' => $view->translate('Advanced Events'),
        'type' => 'widget',
        'name' => 'siteeventrepeat.occurrences',
        'defaultParams' => array(
            'title' => 'Occurrences',
            'titleCount' => true,
            'loaded_by_ajax' => 1
        ),
        'autoEdit' => true,
        'adminForm' => array(
            'elements' => array(
                array(
                    'Radio',
                    'loaded_by_ajax',
                    array(
                        'label' => 'Widget Content Loading',
                        'description' => 'Do you want the content of this widget to be loaded via AJAX, after the loading of main webpage content? (Enabling this can improve webpage loading speed. Disabling this would load content of this widget along with the page content.)',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
                array(
                    'Radio',
                    'guest_pictures',
                    array(
                        'label' => 'Show Guests. [If selected, then profile picture of guests will be shown.]',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
                array(
                    'Text',
                    'guestCountActive',
                    array(
                        'label' => 'Guests to site member',
                        'description' => 'number of guests (profile picture of guests) to be shown when a site member view event.',
                        'value' => 13,
                    )
                ),
                array(
                    'Text',
                    'guestCountDeactive',
                    array(
                        'label' => 'Guests to non-logged in user',
                        'description' => 'number of guests (profile picture of guests) to be shown when a non-logged in user view event.',
                        'value' => 18,
                    )
                ),
                array(
                    'Radio',
                    'guest_count_link',
                    array(
                        'label' => 'Do you want to show "Guest List" for the guests in this block?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
                array(
                    'Radio',
                    'rsvp_dropdown',
                    array(
                        'label' => 'Do you want to allow users to change their RSVP from this block?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
                array(
                    'Radio',
                    'date_filter',
                    array(
                        'label' => 'Show "Filter by date" option.',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
                array(
                    'MultiCheckbox',
                    'profile_links',
                    array(
                        'label' => 'Choose the links that you want to be displayed for the Event Occurrence',
                        'multiOptions' => array("join" => "Join Event / Request Invite", "leave" => "Leave Event", "accept-ignore" => "Accept / Ignore Event Invite", 'invite' => 'Invite Guests', 'review' => 'Write a Review'),
                        'value' => 0,
                    )
                ),
                array(
                    'Radio',
                    'autoloading',
                    array(
                        'label' => 'Auto-Loading Event Occurrences On-scroll',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'How many occurrences do you want to display?',
                        'value' => 10,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                    )
                ),
            )
        )
    ),
);