<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteeventrepeat
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 6590 2014-01-02 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => $view->translate('Event Profile: Recurring Event - Occurrence Listings'),
        'description' => $view->translate('Displays Occurrence Listings of a recurring event. From the Edit Settings of this widget, you can choose to show occurrence dates, guests in each occurrence, Join Event button, etc. This widget should be placed on the Advanced events - Event Profile page.'),
        'category' => $view->translate('Advanced Events'),
        'type' => 'widget',
        'name' => 'siteeventrepeat.occurrences',
        'defaultParams' => array(
            'title' => 'Occurrences',
            'titleCount' => true,
        ),
        'autoEdit' => true,
        'adminForm' => array(
            'elements' => array(
                array(
                    'Radio',
                    'guest_pictures',
                    array(
                        'label' => 'Show Guests. [If selected, then profile picture of guests will be shown.]',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
                array(
                    'Text',
                    'guestCountActive',
                    array(
                        'label' => 'Guests to site member',
                        'description' => 'number of guests (profile picture of guests) to be shown when a site member view event.',
                        'value' => 13,
                    )
                ),
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'How many occurrences do you want to display?',
                        'value' => 10,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                    )
                ),
            )
        )
    ),
);