<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteeventrepeat
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2014-01-02 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteeventrepeat_Widget_EventProfileRepeateventdateController extends Seaocore_Content_Widget_Abstract {

    public function indexAction() {

        //DONT RENDER IF NOT AUTHORIZED
        if (!Engine_Api::_()->core()->hasSubject('siteevent_event')) {
            return $this->setNoRender();
        }
        $this->getElement()->removeDecorator('Title');
       // $this->getElement()->removeDecorator('Container');
        if (!Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('siteeventrepeat'))
            return $this->setNoRender();

        //THIS IS THE CASE WHEN WE RENDER THIS WIDGET FROM THE OTHER WIDGET.   
        $showrepeatinfo = $this->_getParam('showrepeatinfo', 2);
        if (!$showrepeatinfo)
            return $this->setNoRender();
        elseif ($showrepeatinfo == 1) {
            $this->view->show_eventtype = 1;
            $this->view->show_eventtime = 1;
            $this->view->show_eventcondition = 1;
        } else {
            $this->view->show_eventtype = $this->_getParam('showeventtype', 1);
            $this->view->show_eventtime = $this->_getParam('showeventtime', 1);
            $this->view->show_eventcondition = $this->_getParam('showeventcondition', 1);
        }

        $this->view->siteevent = $siteevent = Engine_Api::_()->core()->getSubject();
        $siteeventrepeatDate = Zend_Registry::isRegistered('siteeventrepeatDate') ? Zend_Registry::get('siteeventrepeatDate') : null;

        //IF THE EVENT IS NOT A REPEATING EVENT THEN DO NOT DISPLAY THIS WIDGET.
        if (empty($siteevent->repeat_params))
            return $this->setNoRender();

        //IF THE EVENT IS REPEATING EVENT BUT DO NOT HAVE MORE THEN ONE OCCURRENCES THEN ALSO DO NOT RENDER THIS WIDGET.

        $this->view->totalEventOccurrences = $totalEventOccurrences = Engine_Api::_()->getDbtable('occurrences', 'siteevent')->getOccurrenceCount($siteevent->event_id);
        if ($totalEventOccurrences <= 1)
            return $this->setNoRender();

        //GET THE EVENT FIRST OCCURRENCE STARTTIME AND ENDTIME.
        //SAVE THE OCCURRENCE ID IN THE ZEND REGISTRY.
        $occurrence_id = Zend_Registry::isRegistered('occurrence_id') ? Zend_Registry::get('occurrence_id') : null;
        if (empty($occurrence_id) || !is_numeric($occurrence_id)) {
            //GET THE NEXT UPCOMING OCCURRENCE ID
            $occurrence_id = Engine_Api::_()->getDbTable('events', 'siteevent')->getNextOccurID($siteevent->event_id);
        }
        $this->view->eventinfo = $eventInfo = Engine_Api::_()->getDbtable('occurrences', 'siteevent')->getEventDate($siteevent->event_id, $occurrence_id);
        $this->view->repeat_params = json_decode($siteevent->repeat_params);

        if (empty($siteeventrepeatDate))
            return $this->setNoRender();
    }

}
