<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteevent
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2013-04-01 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteeventrepeat_Widget_OccurrencesController extends Seaocore_Content_Widget_Abstract {

    public function indexAction() {

        //DONT RENDER IF NOT AUTHORIZED
        if (!Engine_Api::_()->core()->hasSubject('siteevent_event')) {
            return $this->setNoRender();
        }

        if (!Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('siteeventrepeat'))
            return $this->setNoRender();

        $this->view->siteevent = $siteevent = Engine_Api::_()->core()->getSubject();
        
        $this->view->subject = $siteevent;

        $this->_mobileAppFile = true;

        //IF THE EVENT IS NOT A REPEATING EVENT THEN DO NOT DISPLAY THIS WIDGET.
        if (empty($siteevent->repeat_params))
            return $this->setNoRender();

        //IF THE EVENT IS REPEATING EVENT BUT DO NOT HAVE MORE THEN ONE OCCURRENCES THEN ALSO DO NOT RENDER THIS WIDGET.

        $this->view->totalEventOccurrences = $totalEventOccurrences = Engine_Api::_()->getDbtable('occurrences', 'siteevent')->getOccurrenceCount($siteevent->event_id);
        if ($totalEventOccurrences <= 1)
            return $this->setNoRender();
        $allParams = $this->_getAllParams();
        $this->view->allParams = $allParams;
        if ($this->_getParam('loaded_by_ajax', true) && Engine_API::_()->seaocore()->checkSitemobileMode('fullsite-mode')) {
            $this->view->loaded_by_ajax = true;
            $this->view->isajax = false;
            if ($this->_getParam('is_ajax_load', false)) {
                $this->view->isajax = true;
                $this->view->loaded_by_ajax = false;
            } else {
                return;
            }
        }

        //GET EVENT FIRST OCCURRENCE START DATE AND EVENT LAST OCCURRENCE START DATE.
        $this->view->firstStartDate = $firstStartDate = Engine_Api::_()->getDbtable('occurrences', 'siteevent')->getOccurenceStartDate($siteevent->event_id);
        //$this->view->EventFirstStartDate = $firstStartDate;
        $this->view->lastStartDate = $lastStartDate = Engine_Api::_()->getDbtable('occurrences', 'siteevent')->getOccurenceStartDate($siteevent->event_id, 'DESC');
        if (strtotime($lastStartDate) > time()) {
            $nextOccurrID = Engine_Api::_()->getDbTable('events', 'siteevent')->getNextOccurID($siteevent->event_id);
            $this->view->firstStartDate = $firstStartDate = Engine_Api::_()->getDbtable('occurrences', 'siteevent')->getOccurenceStartDate($siteevent->event_id, 'ASC', $nextOccurrID);
        }

        $this->view->startCalendarDate = $this->view->firstStartDate;

//    if(isset($allParams['page']))
//      unset($allParams['page']);

        $this->view->isajax = $isajax = $this->_getParam('is_ajax_load', false);
        $this->view->page_id = $page = $this->_getParam('page', 1);
        $this->view->limit = $limit = $this->_getParam('itemCount', 10);
        $this->view->pagination = $this->_getParam('pagination', false);
        $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
        $this->view->viewer_id = $viewer_id = $viewer->getIdentity();
        $this->view->canEdit = $siteevent->authorization()->isAllowed($viewer, "edit");
        //GET USER LEVEL ID
        if (!empty($viewer_id)) {
            $this->view->level_id = $level_id = $viewer->level_id;
        } else {
            $this->view->level_id = $level_id = Engine_Api::_()->getDbtable('levels', 'authorization')->fetchRow(array('type = ?' => "public"))->level_id;
        }
        //IF ADMIN HAS ALLWOED THE SETTING FOR WRITE A REVIEW.
        //CHECK IF VIEWER IS A MEMBER OF ANY PAST EVENT.
        $isPastEventMember = $siteevent->membership()->isMemberOfPastOccurrence($viewer, true);
        $this->view->enable_WriteReview = 0;
        if (Engine_Api::_()->getApi('settings', 'core')->getSetting('siteevent.allowreview', 1) && isset($allParams['profile_links']) && in_array('review', $allParams) && $isPastEventMember) {
            $this->view->enable_WriteReview = 1;
            $identity = Engine_Api::_()->siteevent()->existWidget('siteevent_reviews', 0);
            $this->view->contentDetails = Engine_Api::_()->siteevent()->getWidgetInfo('siteevent.user-siteevent', $identity);
            $create_review = ($siteevent->owner_id == $viewer_id) ? Engine_Api::_()->getApi('settings', 'core')->getSetting('siteevent.allowownerreview', 0) : 1;
            $creationAllowOwner = 1;
            if (empty($create_review) && $siteevent->rating_users <= 0) {
                $creationAllowOwner = 0;
            }
            $this->view->seeAllReviews = $this->_getParam('seeAllReviews', 0);
            $ratingTable = Engine_Api::_()->getDbTable('ratings', 'siteevent');
            //GET REVIEW TABLE
            $reviewTable = Engine_Api::_()->getDbTable('reviews', 'siteevent');
            if ($viewer_id) {
                $params = array();
                $params['resource_id'] = $siteevent->event_id;
                $params['resource_type'] = $siteevent->getType();
                $params['viewer_id'] = $viewer_id;
                $params['type'] = 'user';
                $this->view->review_id = $hasPosted = $reviewTable->canPostReview($params);
            } else {
                $this->view->review_id = $hasPosted = 0;
            }
            $autorizationApi = Engine_Api::_()->authorization();
            if (Engine_Api::_()->siteevent()->allowReviewCreate($siteevent) && $autorizationApi->getPermission($level_id, 'siteevent_event', "review_create") && empty($hasPosted)) {
                $this->view->createAllow = 1;
            } elseif ($autorizationApi->getPermission($level_id, 'siteevent_event', "review_update") && !empty($hasPosted)) {
                $this->view->createAllow = 2;
            } else {
                $this->view->createAllow = 0;
            }
            $selectRatingTable = $ratingTable->select()
                    ->from($ratingTable->info('name'), 'rating_id')
                    ->where('resource_id = ?', $siteevent->event_id)
                    ->where('resource_type = ?', $siteevent->getType())
                    ->where('user_id = ?', $viewer_id);
            $this->view->rating_exist = $selectRatingTable->query()->fetchColumn();

            $show_rating = 0;
            if (!empty($this->view->rating_exist) && !Engine_Api::_()->getApi('settings', 'core')->getSetting('siteevent.allowreview', 1))
                $show_rating = 1;

            $creationAllow = 1;
            if (empty($this->view->createAllow) && empty($show_rating))
                $creationAllow = 0;

            if (empty($creationAllow) || empty($creationAllowOwner)) {
                $this->view->createAllow = 0;
            }

            if (empty($this->view->seeAllReviews) && (empty($creationAllow) || empty($creationAllowOwner))) {
                $this->view->enable_WriteReview = 0;
            }

            if (!Engine_Api::_()->getApi('settings', 'core')->getSetting('siteevent.reviews', 2) || Engine_Api::_()->getApi('settings', 'core')->getSetting('siteevent.reviews', 2) == 1) {
                $this->view->enable_WriteReview = 0;
            }
        }
        if ($this->view->isajax) {
            $this->getElement()->removeDecorator('Title');
            $this->getElement()->removeDecorator('Container');
        }

        $this->view->autoloading = $this->_getParam('autoloading', true);
        if ($viewer && $viewer_id)
            $this->view->guestCount = $this->_getParam('guestCountActive', 13);
        else
            $this->view->guestCount = $this->_getParam('guestCountDeactive', 18);
        if (!empty($viewer_id)) {
            $event_members = $siteevent->membership()->getMemberCount(true);
            $this->view->message_downloadlink = false;
            if ($event_members)
                $this->view->message_downloadlink = true;
        }
        $params['page'] = $page;
        $params['limit'] = $limit;
        $params['event_id'] = $siteevent->getIdentity();
        $timezone = Engine_Api::_()->getApi('settings', 'core')->core_locale_timezone;
        if ($viewer->getIdentity()) {
            $timezone = $viewer->timezone;
        }        

        if ($isajax || !Engine_API::_()->seaocore()->checkSitemobileMode('fullsite-mode')) {


            $params['firststarttime'] = $firstStartDate;
            $params['laststarttime'] = $lastStartDate;

            if ($this->_getParam('firstStartDate', false)) {
                $oldTz = date_default_timezone_get();
                date_default_timezone_set($timezone);
                $startdate = strtotime(Engine_Api::_()->siteevent()->convertDateFormat($this->_getParam('firstStartDate', false)));
                $lastDate = strtotime(Engine_Api::_()->siteevent()->convertDateFormat($this->_getParam('lastStartDate', false)));
                date_default_timezone_set($oldTz);
                $params['firststarttime'] = date("Y-m-d H:i:s", $startdate);
                $params['laststarttime'] = date("Y-m-d H:i:s", $lastDate + (24 * 3600) - 1);
                //ADDED PARAMS FOR MOBILE
                $this->view->firstStartDate = $this->_getParam('firstStartDate', false);
                $this->view->lastStartDate = $this->_getParam('lastStartDate', false);
            }
        }
        $params['order'] = 'ASC';
        
        if(!isset($params['firststarttime'])) {
            $oldTz = date_default_timezone_get();
            date_default_timezone_set($timezone);             
            $params['firststarttime'] = date('Y-m-d H:i:s', time());           
            $this->view->firstStartDate = $this->view->locale()->toDateTime(time());
            $params['laststarttime'] = isset($params['laststarttime']) ? $params['laststarttime'] : $lastStartDate;
            date_default_timezone_set($oldTz);
        }
        
        $this->view->paginator = $paginator = Engine_Api::_()->getDbTable('occurrences', 'siteevent')->getEventOccurrencesPaginator($params);
        $paginator->setItemCountPerPage($limit);
        $this->view->paginator = $paginator->setCurrentPageNumber($page);
        $this->view->totalResults = $paginator->getTotalItemCount();
        $this->view->showContent = true;

        // WORK FOR APP
        if (Engine_Api::_()->seaocore()->isSitemobileApp()) {
            if (Engine_Api::_()->sitemobile()->isApp()) {
                $this->view->page = $paginator->setCurrentPageNumber($this->_getParam('page', 1));
                $this->view->autoContentLoad = $isappajax = $this->_getParam('isappajax', false);
                $totalItemCount = $paginator->getTotalItemCount();
                $this->view->totalPages = ceil(($totalItemCount) / 12);
                $this->view->tab_selected_id = Engine_Api::_()->getDbTable('content', 'sitemobileapp')->getTabId('siteevent.profile-members');
            } else {
                $this->view->tab_selected_id = Engine_Api::_()->getDbTable('content', 'sitemobile')->getTabId('siteevent.profile-members');
            }
        }
        $siteeventApi = Engine_Api::_()->getApi('core','siteevent');
        $this->view->rsvpLabel = $siteeventApi->getRsvpLabels();
        $this->view->rsvpMembership = $siteeventApi->getRsvpMembershipSetting();
    }

}
