<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteeventsiteevent.recently-popular-random-siteevent
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 6590 2014-01-02 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteeventticket_Api_Siteapi_Core extends Core_Api_Abstract {
    public function getBuyerForm($ticketsDetail, $isCopiedDetails, $detailsToBeCopied) {
        if (_CLIENT_TYPE == 'ios' && _IOS_VERSION >= '1.5.8') {
            $isIOS = 1;
        }
        $viewer = Engine_Api::_()->user()->getViewer();
        $ticketFormvalues = array();
        $buyerDetailArray = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteeventticket.buyer.details', array('fname', 'lname', 'email'));
        $aliasValues = Engine_Api::_()->fields()->getFieldsValuesByAlias($viewer);
        if (!empty($aliasValues)) {
            $firstName = !empty($aliasValues['first_name']) ? $aliasValues['first_name'] : null;
            $lastName = !empty($aliasValues['last_name']) ? $aliasValues['last_name'] : null;
            $email = $viewer->email;
        }

        if (isset($isCopiedDetails) && !empty($isCopiedDetails) && isset($detailsToBeCopied) && !empty($detailsToBeCopied)) {
            $firstName = $detailsToBeCopied['firstName'];
            $lastName = $detailsToBeCopied['lastName'];
            $email = $detailsToBeCopied['email'];
        }
        if (in_array('fname', $buyerDetailArray)) {
            $buyerForm[] = array(
                'type' => 'Text',
                'name' => 'fname',
                'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('First Name'),
                'hasValidator' => 'true'
            );
            $buyerFormvalues['fname'] = !empty($firstName) ? $firstName : "";
        }
        if (in_array('lname', $buyerDetailArray)) {
            $buyerForm[] = array(
                'type' => 'Text',
                'name' => 'lname',
                'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Last Name'),
                'hasValidator' => 'true'
            );
            $buyerFormvalues['lname'] = !empty($lastName) ? $lastName : "";
        }
        if (in_array('email', $buyerDetailArray)) {
            $buyerForm[] = array(
                'type' => 'Text',
                'name' => 'email',
                'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Email'),
                'hasValidator' => 'true'
            );
            $buyerFormvalues['email'] = !empty($email) ? $email : "";
        }

        if (_CLIENT_TYPE == 'ios' && _IOS_VERSION >= '1.5.8') {
            $checkbox = 1;
            $buyerForm[] = array(
                'type' => 'Checkbox',
                'name' => 'isCopiedDetails',
                'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate("Copy purchaser's information for all tickets."),
                'value' => $checkbox
            );
            $buyerForm[] = array(
                'type' => 'Button',
                'name' => 'submit',
                'label' => $this->translate('Submit'),
            );
            $form['form']['buyerForm'] = $buyerForm;
            $form['formValues']['buyerFormValues'] = $buyerFormvalues;
        } else {
            $checkbox = 0;
            $form['buyerForm'] = $buyerForm;
            $form['buyerFormValues'] = $buyerFormvalues;
            $ticketForm[] = array(
                'type' => 'Checkbox',
                'name' => 'isCopiedDetails',
                'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate("Copy purchaser's information for all tickets."),
                'value' => $checkbox
            );
        }

        foreach ($ticketsDetail['ticket_column'] as $key => $row) {
            $ticket_id = $key;
            $ticketObj = Engine_Api::_()->getItem('siteeventticket_ticket', $ticket_id);
            if (isset($row[1]) && $row[1] > 0) {
                $price = $row[0];
                $quantity = $row[1];
                $ticket_info['ticket_count'] = $quantity;
                $ticket_info['ticket_id'] = $ticket_id;
                for ($i = 1; $i <= $quantity; $i++) {
                    $elementTitle = $this->translate("Ticket") . " " . $i . " - " . $ticketObj->title;
                    $description = '';
                    $ticketForm[] = array(
                        'type' => 'Dummy',
                        'name' => 'dummy_title_' . $ticket_id,
                        'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate($elementTitle),
                    );
                    if (in_array('fname', $buyerDetailArray)) {

                        if (_CLIENT_TYPE == 'ios' && _IOS_VERSION >= '1.5.8') {
                            $description = Engine_Api::_()->getApi('Core', 'siteapi')->translate($elementTitle);
                        }
                        $ticketForm[] = array(
                            'type' => 'Text',
                            'name' => 'fname_' . $ticket_id . '_' . $i,
                            'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('First Name'),
                            'description' => $description,
                            'hasValidator' => 'true'
                        );
                        if ($isCopiedDetails || $isIOS)
                            $ticketFormvalues['fname_' . $ticket_id . '_' . $i] = !empty($firstName) ? $firstName : "";
                    }
                    if (in_array('lname', $buyerDetailArray)) {
                        $ticketForm[] = array(
                            'type' => 'Text',
                            'name' => 'lname_' . $ticket_id . '_' . $i,
                            'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Last Name'),
                            'hasValidator' => 'true'
                        );
                        if ($isCopiedDetails || $isIOS)
                            $ticketFormvalues['lname_' . $ticket_id . '_' . $i] = !empty($lastName) ? $lastName : "";
                    }
                    if (in_array('email', $buyerDetailArray)) {
                        $ticketForm[] = array(
                            'type' => 'Text',
                            'name' => 'email_' . $ticket_id . '_' . $i,
                            'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Email'),
                            'hasValidator' => 'true'
                        );
                        if ($isCopiedDetails || $isIOS)
                            $ticketFormvalues['email_' . $ticket_id . '_' . $i] = !empty($email) ? $email : "";
                    }
                }
            }
            $ticket_ids[] = $ticket_info;
        }
        $form['ticketIds'] = $ticket_ids;
        if ((_IOS_VERSION && _IOS_VERSION >= '1.7.4')) {
            $form['form']['tickerHolderForm'] = $ticketForm;
            $form['formValues']['tickerHolderFormvalues'] = $ticketFormvalues;
        } else {
            $form['tickerHolderForm'] = $ticketForm;
            $form['tickerHolderFormvalues'] = $ticketFormvalues;
        }
        return $form;
    }

    //ACTION FOR APPLYING COUPON ON TICKET BUY
    public function canApplyCoupon($cart_info, $totalQuantityArray, $dynamic_subtotal, $coupon_code, $cart_event_id) {
        if (empty($coupon_code) || empty($cart_info)) {
            $response['coupon_error_msg'] = $this->translate("Please enter correct coupon code.");
            return $response;
        }
        $coupon_detail = Engine_Api::_()->getDbtable('coupons', 'siteeventticket')->getCouponInfo(array('coupon_code' => $coupon_code, 'fetchRow' => 1), array('coupon_id', 'event_id', 'ticket_ids', 'discount_type', 'discount_amount', 'start_time', 'end_time', 'end_settings', 'status', 'approved', 'coupon_code', 'min_quantity', 'min_amount'));
        $isCouponExist = @COUNT($coupon_detail);

        if (empty($isCouponExist) || empty($coupon_detail->approved) || empty($coupon_detail->status) || (date("Y-m-d H:i:s") < $coupon_detail->start_time) || ($coupon_detail->end_settings == 1 && $coupon_detail->end_time < date("Y-m-d H:i:s")) || (!empty($cart_event_id) && $coupon_detail->event_id != $cart_event_id)) {
            $response['coupon_error_msg'] = $this->translate("Please enter a different coupon code as " . $coupon_code . " is either invalid or has expired.");
            return $response;
        }

        $setCouponInfo = Engine_Api::_()->getDbtable('coupons', 'siteeventticket')->setCouponInfo();
        if (empty($setCouponInfo)) {
            $response['coupon_error_msg'] = $this->translate("Please enter a different coupon code as " . $coupon_code . " is either invalid or has expired.");
            return $response;
        }

        $cart_info = $cart_info[$coupon_detail->event_id];
        if (empty($cart_info)) {
            $response['coupon_error_msg'] = $this->translate("Please enter a different coupon code as " . $coupon_code . " is either invalid or has expired.");
            return $response;
        }

        $eventTicketIdsPrice = $cart_info['ticket_ids'];

        if (!empty($coupon_detail->ticket_ids)) {
            $mappedTicketIds = explode(',', $coupon_detail->ticket_ids);
        }

        $finalTicektIds = $intersectTicektIds = array_intersect($mappedTicketIds, $eventTicketIdsPrice);
        $successMessageTitle = '';
        foreach ($intersectTicektIds as $key => $ticket_id) {
            $ticket = Engine_Api::_()->getItem('siteeventticket_ticket', $ticket_id);

            $validTicketId = false;
            if (!empty($ticket) && $ticket->status != 'hidden' && $ticket->status != 'closed' && date("Y-m-d H:i:s") > $ticket->sell_starttime && date("Y-m-d H:i:s") < $ticket->sell_endtime) {
                $validTicketId = true;
                $successMessageTitle .= "'" . trim($ticket->getTitle()) . "',";
                $finalTicketCoupon[] = $ticket->getIdentity();
            }

            if (empty($validTicketId)) {
                unset($finalTicektIds[$key]);
            }
        }

        $successMessageTitle = rtrim($successMessageTitle, ',');

        if (Count($finalTicektIds) <= 0) {
            $response['coupon_error_msg'] = $this->translate("Please enter a different coupon code as " . $coupon_code . " is either invalid or has expired.");
            return $response;
        }

        if (!empty($coupon_detail->discount_type) && ($dynamic_subtotal - $coupon_detail->discount_amount) <= 0) {
            $response['coupon_error_msg'] = $this->translate("Discount amount is not valid for this purchasing amount.");
            return $response;
        }

        $totalAmount = $totalQuantity = 0;
        foreach ($finalTicektIds as $eventTicketId) {
            $coupon_details_array[$eventTicketId] = array('coupon_id' => $coupon_detail->coupon_id, 'coupon_amount' => $coupon_detail->discount_amount, 'event_id' => $coupon_detail->event_id, 'coupon_type' => $coupon_detail->discount_type, 'coupon_code' => $coupon_detail->coupon_code);
            $totalQuantity = $totalQuantity + $totalQuantityArray[$eventTicketId];
            $totalAmount = $totalAmount + ($totalQuantityArray[$eventTicketId] * $cart_info['unitPrice'][$eventTicketId]);
        }

        if ($totalQuantity <= 0) {
            $response['coupon_error_msg'] = $this->translate("Please buy at least one ticket to apply this coupon.");
            return $response;
        }

        if (!empty($coupon_detail->min_quantity) && $coupon_detail->min_quantity > $totalQuantity) {
            $response['coupon_error_msg'] = $this->translate("You need to purchase " . $coupon_detail->min_quantity . " ticket(s) to avail this coupon. (Applicable for " . $successMessageTitle . " )");
            return $response;
        }

        $currencyValue = $coupon_detail->min_amount;
        if (!empty($coupon_detail->min_amount) && $coupon_detail->min_amount > $totalAmount) {
            $response['coupon_error_msg'] = $this->translate("Your ticket order should be of atleast " . $currencyValue . " to avail this coupon. (Applicable for " . $successMessageTitle . ")");
            return $response;
        }

        if ($totalAmount <= 0) {
            $response['coupon_error_msg'] = $this->translate("Your ticket order should be of atleast " . $currencyValue . " to avail this coupon. (Applicable for " . $successMessageTitle . ")");
            return $response;
        }

        $response['siteeventticketCouponDetail'] = serialize($coupon_details_array);
        $cart_coupon_applied = true;
        $ticketIds = $coupon_details_array;

        if ($coupon_detail->discount_type) {
            if ($totalQuantity) {
                $response['coupon_success_msg'] = $this->translate("This coupon has been applied. (Applicable for " . $successMessageTitle . " )");
            } else {
                $response['coupon_error_msg'] = $this->translate("To avail this discount you must to purchase " . $successMessageTitle . " type ticket.");
                return $response;
            }
        } else {
            $response['coupon_success_msg'] = $this->translate("This coupon has been applied. (Applicable for " . $successMessageTitle . " )");
        }

        return $response;
    }

    public function getPriceWithCurrency($price) {
        if (empty($price)) {
            return $price;
        }

        $defaultParams = array();
        $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
        if (empty($viewer_id)) {
            $defaultParams['locale'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.locale.locale', 'auto');
        }

        $currency = Engine_Api::_()->getApi('settings', 'core')->getSetting('payment.currency', 'USD');
        $defaultParams['precision'] = 2;
        $defaultParams['symbol'] = '';
        $price = (float) $price;
        $priceStr = Zend_Registry::get('Zend_View')->locale()->toCurrency($price, $currency, $defaultParams);
        return $priceStr;
    }

    public function translate($data) {
        $data = Engine_Api::_()->getApi('Core', 'siteapi')->translate($data);
        return $data;
    }

    public function getFormattedDate($date = '') {
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();
        $tz = Engine_Api::_()->getApi('settings', 'core')->core_locale_timezone;
        if (!empty($viewer_id)) {
            $tz = $viewer->timezone;
        }
        if (isset($date) && !empty($date) && isset($tz)) {
            $startDateObject = new Zend_Date(strtotime($date));
            $startDateObject->setTimezone($tz);
            $date = $startDateObject->get('YYYY-MM-dd HH:mm:ss');
        }
        return $date;
    }

    public function getBuyerFormJsonHelper($ticketsDetail, $isCopiedDetails, $detailsTobeCopied, $values) {
        $ticket_ids = array();
        foreach ($ticketsDetail['ticket_column'] as $key => $row) {
            $ticket_id = $key;
            $ticketObj = Engine_Api::_()->getItem('siteeventticket_ticket', $ticket_id);
            if (isset($row[1]) && $row[1] > 0) {
                $price = $row[0];
                $quantity = $row[1];
                $ticket_info['ticket_count'] = $quantity;
                $ticket_info['ticket_id'] = $ticket_id;
                for ($i = 1; $i <= $quantity; $i++) {
                    $ticketFormInfo['fname_' . $ticket_id . '_' . $i]['ticket_id'] = $ticket_id;
                    $ticketFormInfo['fname_' . $ticket_id . '_' . $i]['ticket_count'] = $i;
                    $ticketFormInfo['fname_' . $ticket_id . '_' . $i]['key'] = 'fname';
                    $ticketFormInfo['lname_' . $ticket_id . '_' . $i]['ticket_id'] = $ticket_id;
                    $ticketFormInfo['lname_' . $ticket_id . '_' . $i]['ticket_count'] = $i;
                    $ticketFormInfo['lname_' . $ticket_id . '_' . $i]['key'] = 'lname';
                    $ticketFormInfo['email_' . $ticket_id . '_' . $i]['ticket_id'] = $ticket_id;
                    $ticketFormInfo['email_' . $ticket_id . '_' . $i]['ticket_count'] = $i;
                    $ticketFormInfo['email_' . $ticket_id . '_' . $i]['key'] = 'email';
                }
            }
        }

        if (isset($isCopiedDetails) && !empty($isCopiedDetails)) {
            $jsonArray['isCopiedDetails'] = 'on';

            foreach ($ticketFormInfo as $key => $info) {
                $buyerDetails[$info['ticket_id']][$info['ticket_count']]['fname'] = $values['fname'];
                $buyerDetails[$info['ticket_id']][$info['ticket_count']]['lastName'] = $values['lname'];
                $buyerDetails[$info['ticket_id']][$info['ticket_count']]['email'] = $values['email'];
            }
        } else {
            $jsonArray['isCopiedDetails'] = 'off';
            foreach ($ticketFormInfo as $key => $info) {
                $buyerDetails[$info['ticket_id']][$info['ticket_count']][$info['key']] = $values[$key];
            }
        }

        $jsonArray['buyer_detail'] = $buyerDetails;
        return json_encode($jsonArray);
    }
    
    public function getAttendees($event,$occurrence_id = null){
        $orderTable = Engine_Api::_()->getDbTable('orders', 'siteeventticket');
        $userTable = Engine_Api::_()->getItemTable('user');
        $userTableName = $userTable->info('name');
        $orderTableName = $orderTable->info('name');

        $select = $userTable->select()
                ->setIntegrityCheck(false)
                ->from($userTableName, array("user_id", "displayname", "username", 'photo_id'))
                ->join($orderTableName, "$orderTableName.user_id = $userTableName.user_id", array(""))
                ->where("$orderTableName.event_id = ?", $event->getIdentity())
                ->where("(payment_status = 'active' OR (non_payment_seller_reason = 0 && non_payment_admin_reason = 0))")
                ->where("$orderTableName.is_private_order = ?", 0)
                ->group("$orderTableName.user_id")
                ->order("$orderTableName.creation_date DESC");

        if (!empty($occurrence_id) && $occurrence_id != 'all') {
            $select->where("occurrence_id=?", $occurrence_id);
        }
        
        $paginator = Zend_Paginator::factory($select);
        return $paginator;
    }

}
