<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitefaq
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Settemplate.php 2011-08-026 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitefaq_Api_Template extends Core_Api_Abstract
{

    public function checkPageId($name = false)
    {
        if (!$name) {
            return false;
        }

        $db      = Engine_Db_Table::getDefaultAdapter();
        $select  = new Zend_Db_Select($db);
        $page_id = $select
            ->from('engine4_core_pages', 'page_id')
            ->where('name = ?', $name)
            ->query()->fetchColumn();
        return $page_id;
    }

    public function setWidgetizedpages()
    {
        $db = Engine_Db_Table::getDefaultAdapter();
        //START FAQ HOME PAGE
        $page_id = $this->checkPageId('sitefaq_index_home');

        if (!$page_id) {
            $db->insert('engine4_core_pages', array(
                'name'        => 'sitefaq_index_home',
                'displayname' => 'FAQ Home Page',
                'title'       => 'FAQ Home Page',
                'description' => 'This page lists FAQs.',
                'custom'      => 0,
            ));
            $page_id = $db->lastInsertId();

            //TOP CONTAINER
            $db->insert('engine4_core_content', array(
                'type'    => 'container',
                'name'    => 'top',
                'page_id' => $page_id,
                'order'   => 1,
            ));
            $top_container_id = $db->lastInsertId();

            //MAIN CONTAINER
            $db->insert('engine4_core_content', array(
                'type'    => 'container',
                'name'    => 'main',
                'page_id' => $page_id,
                'order'   => 2,
            ));
            $main_container_id = $db->lastInsertId();

            //INSERT TOP-MIDDLE
            $db->insert('engine4_core_content', array(
                'type'              => 'container',
                'name'              => 'middle',
                'page_id'           => $page_id,
                'parent_content_id' => $top_container_id,
            ));
            $top_middle_id = $db->lastInsertId();

            //MAIN NAVIGATION WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.navigation-sitefaqs',
                'parent_content_id' => $top_middle_id,
                'order'             => 3,
                'params'            => '',
            ));

            //MAIN-MIDDLE CONTAINER
            $db->insert('engine4_core_content', array(
                'type'              => 'container',
                'name'              => 'middle',
                'page_id'           => $page_id,
                'parent_content_id' => $main_container_id,
                'order'             => 2,
            ));
            $main_middle_id = $db->lastInsertId();

            //RIGHT CONTAINER
            $db->insert('engine4_core_content', array(
                'type'              => 'container',
                'name'              => 'right',
                'page_id'           => $page_id,
                'parent_content_id' => $main_container_id,
                'order'             => 1,
            ));
            $right_container_id = $db->lastInsertId();

            //ZERO FAQs MESSAGE WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.zero-sitefaqs',
                'parent_content_id' => $main_middle_id,
                'order'             => 10,
                'params'            => '',
            ));

            //SEARCH BOX WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.search-box-sitefaqs',
                'parent_content_id' => $main_middle_id,
                'order'             => 11,
                'params'            => '{"title":"","blur_text":"Enter a keyword or question","titleCount":"true"}',
            ));

            //CATEGORIZED FAQ WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.categories-faqs-sitefaqs',
                'parent_content_id' => $main_middle_id,
                'order'             => 12,
                'params'            => '{"title":"","titleCount":"true"}',
            ));

            //TOP RATED FAQs WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.faqs-sitefaqs',
                'parent_content_id' => $right_container_id,
                'order'             => 15,
                'params'            => '{"title":"Top Rated FAQs","popularity":"rating"}',
            ));

            //FEATURED FAQs WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.faqs-sitefaqs',
                'parent_content_id' => $right_container_id,
                'order'             => 16,
                'params'            => '{"title":"Featured FAQs","popularity":"RAND()","featured":"1"}',
            ));

            //MOST HELPFUL FAQs WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.faqs-sitefaqs',
                'parent_content_id' => $right_container_id,
                'order'             => 17,
                'params'            => '{"title":"Most Helpful FAQs","popularity":"helpful"}',
            ));

            //MOST LIKED FAQs WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.faqs-sitefaqs',
                'parent_content_id' => $right_container_id,
                'order'             => 18,
                'params'            => '{"title":"Most Liked FAQs","popularity":"like_count"}',
            ));

            //MOST RECENT FAQs WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.faqs-sitefaqs',
                'parent_content_id' => $right_container_id,
                'order'             => 19,
                'params'            => '{"title":"Most Recent FAQs","popularity":"creation_date"}',
            ));

            //POPULAR TAGS WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.tagcloud-sitefaqs',
                'parent_content_id' => $right_container_id,
                'order'             => 20,
            ));
        }

        //START FAQ BROWSE PAGE
        $page_id = $this->checkPageId('sitefaq_index_browse');

        if (!$page_id) {
            $db->insert('engine4_core_pages', array(
                'name'        => 'sitefaq_index_browse',
                'displayname' => 'FAQ Browse Page',
                'title'       => 'FAQ Browse Page',
                'description' => 'This page lists FAQs.',
                'custom'      => 0,
            ));
            $page_id = $db->lastInsertId();

            //TOP CONTAINER
            $db->insert('engine4_core_content', array(
                'type'    => 'container',
                'name'    => 'top',
                'page_id' => $page_id,
                'order'   => 1,
            ));
            $top_container_id = $db->lastInsertId();

            //MAIN CONTAINER
            $db->insert('engine4_core_content', array(
                'type'    => 'container',
                'name'    => 'main',
                'page_id' => $page_id,
                'order'   => 2,
            ));
            $main_container_id = $db->lastInsertId();

            //INSERT TOP-MIDDLE
            $db->insert('engine4_core_content', array(
                'type'              => 'container',
                'name'              => 'middle',
                'page_id'           => $page_id,
                'parent_content_id' => $top_container_id,
            ));
            $top_middle_id = $db->lastInsertId();

            //MAIN NAVIGATION WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.navigation-sitefaqs',
                'parent_content_id' => $top_middle_id,
                'order'             => 3,
                'params'            => '',
            ));

            //MAIN-MIDDLE CONTAINER
            $db->insert('engine4_core_content', array(
                'type'              => 'container',
                'name'              => 'middle',
                'page_id'           => $page_id,
                'parent_content_id' => $main_container_id,
                'order'             => 2,
            ));
            $main_middle_id = $db->lastInsertId();

            //BROWSE FAQs WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.browse-sitefaqs',
                'parent_content_id' => $main_middle_id,
                'order'             => 3,
                'params'            => '',
            ));

            //RIGHT CONTAINER
            $db->insert('engine4_core_content', array(
                'type'              => 'container',
                'name'              => 'right',
                'page_id'           => $page_id,
                'parent_content_id' => $main_container_id,
                'order'             => 1,
            ));
            $right_container_id = $db->lastInsertId();

            //SEARCH FORM WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.sidebar-categories-sitefaqs',
                'parent_content_id' => $right_container_id,
                'order'             => 14,
                'params'            => '',
            ));

            //SEARCH FORM WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.search-sitefaqs',
                'parent_content_id' => $right_container_id,
                'order'             => 15,
                'params'            => '',
            ));

            //MOST COMMENTED FAQs WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.faqs-sitefaqs',
                'parent_content_id' => $right_container_id,
                'order'             => 18,
                'params'            => '{"title":"Most Commented FAQs","popularity":"comment_count"}',
            ));

            //MOST RECENT FAQs WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.faqs-sitefaqs',
                'parent_content_id' => $right_container_id,
                'order'             => 18,
                'params'            => '{"title":"Most Recent FAQs","popularity":"creation_date"}',
            ));

            //MOST VIEWED FAQs WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.faqs-sitefaqs',
                'parent_content_id' => $right_container_id,
                'order'             => 18,
                'params'            => '{"title":"Most Viewed FAQs","popularity":"view_count"}',
            ));

            //POPULAR TAGS WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.tagcloud-sitefaqs',
                'parent_content_id' => $right_container_id,
                'order'             => 19,
            ));
        }

        //START FAQ VIEW PAGE WORK
        $info = $this->checkPageId('sitefaq_index_view');

        if (empty($info)) {
            //CREATE PAGE IF NOT EXIST
            $db->insert('engine4_core_pages', array(
                'name'        => 'sitefaq_index_view',
                'displayname' => 'FAQ View Page',
                'title'       => 'FAQ View Page',
                'description' => 'This is the FAQs view page.',
                'custom'      => 0,
                'layout'      => 'default',
            ));
            $page_id = $db->lastInsertId('engine4_core_pages');

            //MAIN CONTAINER
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'container',
                'name'              => 'main',
                'parent_content_id' => null,
                'order'             => 2,
                'params'            => '',
            ));
            $main_container_id = $db->lastInsertId('engine4_core_content');

            //RIGHT CONTAINER
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'container',
                'name'              => 'right',
                'parent_content_id' => $main_container_id,
                'order'             => 5,
                'params'            => '',
            ));
            $right_container_id = $db->lastInsertId('engine4_core_content');

            //MAIN MIDDLE CONTAINER
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'container',
                'name'              => 'middle',
                'parent_content_id' => $main_container_id,
                'order'             => 6,
                'params'            => '',
            ));
            $main_middle_container_id = $db->lastInsertId('engine4_core_content');

            //FAQ VIEWER WINDOW WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.sitefaq-view-sitefaqs',
                'parent_content_id' => $main_middle_container_id,
                'order'             => 3,
                'params'            => '',
            ));

            //FAQ COMMENT WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'core.comments',
                'parent_content_id' => $main_middle_container_id,
                'order'             => 4,
                'params'            => '{"title":"","titleCount":"true"}',
            ));

            $order = 5;

            //FAQ RATING WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.featured-view-sitefaqs',
                'parent_content_id' => $right_container_id,
                'order'             => $order++,
                'params'            => '{"title":"","titleCount":"true"}',
            ));

            //FAQ RATING WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.ratings-sitefaqs',
                'parent_content_id' => $right_container_id,
                'order'             => $order++,
                'params'            => '{"title":"","titleCount":"true"}',
            ));

            //FAQ OWNER PHOTO WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.options-sitefaqs',
                'parent_content_id' => $right_container_id,
                'order'             => $order++,
                'params'            => '',
            ));

            //FAQ INFORMATION WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.information-sitefaqs',
                'parent_content_id' => $right_container_id,
                'order'             => $order++,
                'params'            => '{"title":"","titleCount":"true"}',
            ));

            //CATEGORIES WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.sidebar-categories-view-sitefaqs',
                'parent_content_id' => $right_container_id,
                'order'             => $order++,
                'params'            => '',
            ));

            //SOCIAL SHARE BUTTONS WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.socialshare-sitefaqs',
                'parent_content_id' => $right_container_id,
                'order'             => $order++,
                'params'            => '',
            ));

            //RELATED FAQs WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.related-faqs-view-sitefaqs',
                'parent_content_id' => $right_container_id,
                'order'             => $order++,
                'params'            => '{"title":"Related FAQs","related":"tags","titleCount":"true"}',
            ));

            //SAME CATEGORIES FAQs WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.related-faqs-view-sitefaqs',
                'parent_content_id' => $right_container_id,
                'order'             => $order++,
                'params'            => '{"title":"Same Categories FAQs","related":"categories","titleCount":"true"}',
            ));

        }

        //START FAQ MANAGE PAGE WORK
        $info = $this->checkPageId('sitefaq_index_manage');

        if (empty($info)) {

            //CREATE PAGE IF NOT EXIST
            $db->insert('engine4_core_pages', array(
                'name'        => 'sitefaq_index_manage',
                'displayname' => 'FAQ Manage Page',
                'title'       => 'FAQ Manage Page',
                'description' => 'This is the manage FAQs page.',
                'custom'      => 0,
                'layout'      => 'default',
            ));
            $page_id = $db->lastInsertId('engine4_core_pages');

            //CONTAINERS
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'container',
                'name'              => 'main',
                'parent_content_id' => null,
                'order'             => 2,
                'params'            => '',
            ));
            $container_id = $db->lastInsertId('engine4_core_content');

            //INSERT MAIN - MIDDLE CONTAINER
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'container',
                'name'              => 'middle',
                'parent_content_id' => $container_id,
                'order'             => 6,
                'params'            => '',
            ));
            $middle_id = $db->lastInsertId('engine4_core_content');

            //INSERT MAIN - RIGHT CONTAINER
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'container',
                'name'              => 'right',
                'parent_content_id' => $container_id,
                'order'             => 5,
                'params'            => '',
            ));
            $right_id = $db->lastInsertId('engine4_core_content');

            //INSERT TOP CONTAINER
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'container',
                'name'              => 'top',
                'parent_content_id' => null,
                'order'             => 1,
                'params'            => '',
            ));
            $top_id = $db->lastInsertId('engine4_core_content');

            //INSERT TOP- MIDDLE CONTAINER
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'container',
                'name'              => 'middle',
                'parent_content_id' => $top_id,
                'order'             => 6,
                'params'            => '',
            ));
            $top_middle_id = $db->lastInsertId('engine4_core_content');

            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.navigation-sitefaqs',
                'parent_content_id' => $top_middle_id,
                'order'             => 3,
                'params'            => '',
            ));

            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.search-sitefaqs',
                'parent_content_id' => $right_id,
                'order'             => 3,
                'params'            => '{"title":"","titleCount":"true"}',
            ));

            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.manage-sitefaqs',
                'parent_content_id' => $middle_id,
                'order'             => 2,
                'params'            => '',
            ));
        }

        //START MOBILE FAQ HOME PAGE WORK
        $info = $this->checkPageId('sitefaq_index_mobi');

        if (empty($info)) {
            //CREATE PAGE IF NOT EXIST
            $db->insert('engine4_core_pages', array(
                'name'        => 'sitefaq_index_mobi-home',
                'displayname' => 'Mobile FAQ Home Page',
                'title'       => 'Mobile FAQ Home Page',
                'description' => 'This is the mobile FAQ home page.',
                'custom'      => 0,
                'layout'      => 'default',
            ));
            $page_id = $db->lastInsertId('engine4_core_pages');

            //MAIN CONTAINER
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'container',
                'name'              => 'main',
                'parent_content_id' => null,
                'order'             => 1,
                'params'            => '',
            ));
            $main_container_id = $db->lastInsertId('engine4_core_content');

            //MIDDLE CONTAINER
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'container',
                'name'              => 'middle',
                'parent_content_id' => $main_container_id,
                'order'             => 2,
                'params'            => '',
            ));
            $middle_container_id = $db->lastInsertId('engine4_core_content');

            //MAIN NAVIGATION WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.navigation-sitefaqs',
                'parent_content_id' => $middle_container_id,
                'order'             => 3,
                'params'            => '',
            ));

            //SEARCH BOX WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.mobi-search-box-sitefaqs',
                'parent_content_id' => $middle_container_id,
                'order'             => 4,
                'params'            => '{"title":"","titleCount":"true"}',
            ));

            //ZERO FAQs MESSAGE WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.zero-sitefaqs',
                'parent_content_id' => $middle_container_id,
                'order'             => 5,
                'params'            => '',
            ));

            //HOME FAQS WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.mobi-home-sitefaqs',
                'parent_content_id' => $middle_container_id,
                'order'             => 6,
                'params'            => '',
            ));
        }

        //START MOBILE FAQ BROWSE PAGE WORK
        $info = $this->checkPageId('sitefaq_index_mobi-browse');

        if (empty($info)) {
            //CREATE PAGE IF NOT EXIST
            $db->insert('engine4_core_pages', array(
                'name'        => 'sitefaq_index_mobi-browse',
                'displayname' => 'Mobile FAQ Browse Page',
                'title'       => 'Mobile FAQ Browse Page',
                'description' => 'This is the mobile browse FAQs page.',
                'custom'      => 0,
                'layout'      => 'default',
            ));
            $page_id = $db->lastInsertId('engine4_core_pages');

            //MAIN CONTAINER
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'container',
                'name'              => 'main',
                'parent_content_id' => null,
                'order'             => 1,
                'params'            => '',
            ));
            $main_container_id = $db->lastInsertId('engine4_core_content');

            //MIDDLE CONTAINER
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'container',
                'name'              => 'middle',
                'parent_content_id' => $main_container_id,
                'order'             => 2,
                'params'            => '',
            ));
            $middle_container_id = $db->lastInsertId('engine4_core_content');

            //MAIN NAVIGATION WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.navigation-sitefaqs',
                'parent_content_id' => $middle_container_id,
                'order'             => 3,
                'params'            => '',
            ));

            //SEARCH FORM WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.search-sitefaqs',
                'parent_content_id' => $middle_container_id,
                'order'             => 4,
                'params'            => '',
            ));

            //BROWSE FAQS WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.mobi-browse-sitefaqs',
                'parent_content_id' => $middle_container_id,
                'order'             => 5,
                'params'            => '',
            ));
        }

        //START MOBILE FAQ VIEW PAGE WORK
        $info = $this->checkPageId('sitefaq_index_mobi-view');

        if (empty($info)) {
            //CREATE PAGE IF NOT EXIST
            $db->insert('engine4_core_pages', array(
                'name'        => 'sitefaq_index_mobi-view',
                'displayname' => 'Mobile FAQ View Page',
                'title'       => 'Mobile FAQ View Page',
                'description' => 'This is the mobile view FAQ page.',
                'custom'      => 0,
                'layout'      => 'default',
            ));
            $page_id = $db->lastInsertId('engine4_core_pages');

            //MAIN CONTAINER
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'container',
                'name'              => 'main',
                'parent_content_id' => null,
                'order'             => 1,
                'params'            => '',
            ));
            $main_container_id = $db->lastInsertId('engine4_core_content');

            //MIDDLE CONTAINER
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'container',
                'name'              => 'middle',
                'parent_content_id' => $main_container_id,
                'order'             => 2,
                'params'            => '',
            ));
            $middle_container_id = $db->lastInsertId('engine4_core_content');

            //VIEW FAQS WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.sitefaq-view-sitefaqs',
                'parent_content_id' => $middle_container_id,
                'order'             => 3,
                'params'            => '',
            ));

            //FAQ COMMENT WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'core.comments',
                'parent_content_id' => $main_middle_container_id,
                'order'             => 4,
                'params'            => '{"title":"","titleCount":"true"}',
            ));
        }

        //START FAQ MANAGE PAGE WORK
        $info = $this->checkPageId('sitefaq_index_mobi-manage');

        if (empty($info)) {
            //CREATE PAGE IF NOT EXIST
            $db->insert('engine4_core_pages', array(
                'name'        => 'sitefaq_index_mobi-manage',
                'displayname' => 'Mobile FAQ Manage Page',
                'title'       => 'Mobile FAQ Manage Page',
                'description' => 'This is the mobile manage FAQs page.',
                'custom'      => 0,
                'layout'      => 'default',
            ));
            $page_id = $db->lastInsertId('engine4_core_pages');

            //MAIN CONTAINER
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'container',
                'name'              => 'main',
                'parent_content_id' => null,
                'order'             => 1,
                'params'            => '',
            ));
            $main_container_id = $db->lastInsertId('engine4_core_content');

            //MIDDLE CONTAINER
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'container',
                'name'              => 'middle',
                'parent_content_id' => $main_container_id,
                'order'             => 2,
                'params'            => '',
            ));
            $middle_container_id = $db->lastInsertId('engine4_core_content');

            //MAIN NAVIGATION WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.navigation-sitefaqs',
                'parent_content_id' => $middle_container_id,
                'order'             => 3,
                'params'            => '',
            ));

            //SEARCH FORM WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.search-sitefaqs',
                'parent_content_id' => $middle_container_id,
                'order'             => 4,
                'params'            => '',
            ));

            //BROWSE FAQS WIDGET
            $db->insert('engine4_core_content', array(
                'page_id'           => $page_id,
                'type'              => 'widget',
                'name'              => 'sitefaq.manage-sitefaqs',
                'parent_content_id' => $middle_container_id,
                'order'             => 5,
                'params'            => '',
            ));
        }
    }
}
