<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitefaq
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: TakeActionController.php 6590 2012-26-01 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitefaq_InstallController extends Core_Controller_Action_Standard
{
    protected $_token;
    public function init()
    {
        $this->_helper->contextSwitch->initContext();
        $settingsTable = Engine_Api::_()->getDbtable('settings', 'core');
        $row = $settingsTable->fetchRow($settingsTable->select()
            ->where('name = ?', 'sitefaq.install.ssotoken'));
        $this->_token = $row ? $row->value : null;
        $token        = $this->_getParam('token', false);
        if ($token != $this->_token) {
            exit(0);
        }
    }
    public function postInstallAction()
    {
        $db = Zend_Db_Table_Abstract::getDefaultAdapter();
        $isFaqRow = $db->query('SELECT * FROM `engine4_core_menuitems` WHERE `name` LIKE "core_main_sitefaq" LIMIT 1')->fetchAll();
        if (!empty($isFaqRow)) {
            $db->query('UPDATE `engine4_core_menuitems` SET `enabled` = "1" WHERE `engine4_core_menuitems`.`name` ="core_main_sitefaq" LIMIT 1 ;');
        }

        // UPLOAD CATEGORY ICONS
        Engine_Api::_()->getDbTable('categories', 'sitefaq')->iconUpload(0);

        // Create Pages and place Widgets
        Engine_Api::_()->getApi('template', 'sitefaq')->setWidgetizedpages();

        $settingsTable = Engine_Api::_()->getDbtable('settings', 'core');
        $settingsTable->delete(array('name = ?' => 'sitefaq.install.ssotoken'));
        exit();
    }
}
