<?php


/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitefbclone
 * @copyright  Copyright 2015-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Settings.php 2018-04-05 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitefbclone_Form_Admin_Settings_Configure extends Engine_Form
{

  public function init()
  {
    $coreSettings = Engine_Api::_()->getApi('settings', 'core');
    $this->setTitle(sprintf(Zend_Registry::get('Zend_Translate')->_("Configure Pages")))
    ->setDescription(sprintf(Zend_Registry::get('Zend_Translate')->_("Here you can configure pages and can create backup of pages. If you want to get the previous set up of landing page and other sections of your website, you can configure it from here.")));

    $this->addElement('Radio', 'sitefbclone_landing_page_layout', array(
      'label' => 'New Facebook Clone Landing Page',
      'description' => "Do you want the Landing Page setup of New Facebook Clone Theme? If you choose ‘Yes’ you will get the Landing Page as the default setup of New Facebook Clone Theme. If chosen ‘No’, you will get the previous setup of the Landing Page which was before the installation of New Facebook Clone Theme.",
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => $coreSettings->getSetting('sitefbclone.landing.page.layout', 1),
    ));

    $this->addElement('Radio', 'sitefbclone_header_page_layout', array(
      'label' => 'New Facebook Clone Header',
      'description' => "Do you want the Header as New Facebook Clone Theme? If you choose ‘Yes’ you will get the header as in the default setup of New Facebook Clone Theme. If chosen ‘No’, you will get the previous Header which was before the installation of New Facebook Clone Theme.",
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => $coreSettings->getSetting('sitefbclone.header.page.layout', 1),
    ));

    $this->addElement('Radio', 'sitefbclone_footer_page_layout', array(
      'label' => 'New Facebook Clone Footer',
      'description' => "Do you want Footer as New Facebook Clone Theme? If you choose ‘Yes’ you will get the Footer as in the default setup of New Facebook Clone Theme. If chosen ‘No’, you will get the previous Footer which was before the installation of New Facebook Clone Theme.",
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => $coreSettings->getSetting('sitefbclone.footer.page.layout', 1),
    ));

    $this->addElement('Radio', 'sitefbclone_login_page_layout', array(
      'label' => 'New Facebook Clone Login Page',
      'description' => "Do you want the Login page setup of New Facebook Clone Theme? If you choose ‘Yes’ you will get the Login page as the default setup of New Facebook Clone Theme. If chosen ‘No’, you will get the previous setup of the Login page which was before the installation of New Facebook Clone Theme.",
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => $coreSettings->getSetting('sitefbclone.login.page.layout', 1),
    ));

    $this->addElement('Radio', 'sitefbclone_login_required_page_layout', array(
      'label' => 'New Facebook Clone Login Required Page',
      'description' => "Do you want Login Required Page setup of New Facebook Clone Theme? If you choose ‘Yes’ you will get the Login Required Page as the default setup of New Facebook Clone Theme. If chosen ‘No’, you will get the previous setup of the Login Required Page which was before the installation of New Facebook Clone Theme.",
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => $coreSettings->getSetting('sitefbclone.login.required.page.layout', 1),
    ));

    $this->addElement('Radio', 'sitefbclone_signup_page_layout', array(
      'label' => 'New Facebook Clone Sign Up Page',
      'description' => "Do you want Sign Up Page setup of New Facebook Clone Theme? If you choose ‘Yes’ you will get the Sign Up Page as the default setup of New Facebook Clone Theme. If chosen ‘No’, you will get the previous setup of Sign Up Page which was before the installation of the New Facebook Clone Theme.",
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => $coreSettings->getSetting('sitefbclone.signup.page.layout', 1),
    )); 

    $this->addElement('Radio', 'sitefbclone_forgot_password_page_layout', array(
      'label' => 'New Facebook Clone Forgot Password Page',
      'description' => "Do you want Forgot Password Page setup of the New Facebook Clone Theme? If you choose ‘Yes’ you will get the Forgot Password Page as the default setup of New Facebook Clone Theme. If chosen ‘No’, you will get the previous setup of Forgot Password Page which was before the installation of New Facebook Clone Theme.",
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => $coreSettings->getSetting('sitefbclone.forgot.password.page.layout', 1),
    )); 

    $this->addElement('Button', 'submit', array(
      'label' => 'Save Changes',
      'type' => 'submit',
      'decorators' => array(
        'ViewHelper',
      ),
    ));
  }

}
