<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitefbclone
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Pagelayouts.php 2015-06-04 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitefbclone_Form_Admin_Settings_Global extends Engine_Form {

  protected $_bgcolor = '#f0f2f5';
  protected function setBackGroundColor($color) {
    $this->_bgcolor = $color;
    return $this;
  }

  public function init() {

    $this->setTitle('Landing Page')
    ->setDescription('Here you can manage the elements present on Landing Page.');

    $settings = Engine_Api::_()->getApi('settings', 'core');

    $sliderOptions = (array('1'=>'Background Color','2'=>'Image'));
    $imgOptions = Engine_Api::_()->sitefbclone()->getImages(array('application/modules/Sitefbclone/externals/images/landinglogo.png' => 'Default logo','' => "Text-only (No logo)"));

    $this->addElement('Select', 'sitefbclone_slider', array(
      'label' => 'Full-Width Slider',
      'description' => 'Do you want to upload an image or use any background color?',
      'multiOptions' => $sliderOptions,
      'onchange' => 'chnageSlider();',
      'value' => $settings->getSetting('sitefbclone.slider', ''),
    ));

    //COLOR VALUE FOR BACKGROUND COLOR
    $this->addElement('Text', 'sitefbclone_color', array(
      'decorators' => array(
        array('ViewScript', array(
          'viewScript' => '_formImageRainbowSearchBackground.tpl',
          'class' => 'form element'
        )))
    ));

    $this->addElement('Select', 'sitefbclone_landing_logo_image', array(
      'label' => 'Select Logo',
      'description' => 'Select the logo for your website. [Note: Logo must be uploaded prior from Admin Panel → Appearance → File & Media Manager.]',
      'multiOptions' => $imgOptions,
      'value' => $settings->getSetting('sitefbclone.landing.logo.image', ''),
    ));

    $this->addElement('Text', 'sitefbclone_tagline', array(
      'label' => 'Landing Page Left Tagline',
      'description' => 'Enter the tagline text that you want to display on the left side of the landing page.(Note : This tagline is not visible in responsive view.)',
      'value' => $settings->getSetting('sitefbclone.tagline'),
    ));

    $this->addElement('Text', 'sitefbclone_righttagline', array(
      'label' => 'Landing Page Right Tagline',
      'description' => 'Enter the tagline text that you want to display on the right side of the landing page.(Note : This tagline is not visible in responsive view.)',
      'value' => $settings->getSetting('sitefbclone.righttagline'),
    ));

    $this->addElement('Button', 'submit', array(
      'label' => 'Save Changes',
      'type' => 'submit',
      'ignore' => true
    ));
  }
}
