<?php


/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitefbclone
 * @copyright  Copyright 2015-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Layout.php 2018-04-05 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitefbclone_Form_Admin_Settings_Header extends Engine_Form
{

  public function init() 
  {
    $this->setTitle("Manage Header");
    $this->setDescription("Here you can manage settings related to header.");

    $coreSettings = Engine_Api::_()->getApi('settings', 'core');
    $isStoreproductEnable = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitestoreproduct');

    $this->addElement('Radio', 'sitefbclone_header_top_menus', array(
      'label' => 'Do you want to Show Top Menus?',
      'description' => 'Do you want to Show Top Menus? . (Note : This setting do not work in responsive view ie top menus are not visible in responsive view. )',
      'onchange' => 'topMenus(this.value);',
      'multiOptions' => array(
        'block' => 'Yes',
        'none' => 'No'
      ),
      'value' => $coreSettings->getSetting('sitefbclone.header.top.menus', 'block'),
    ));

    $this->addElement('Text', 'sitefbclone_url_1', array(
        'label' => 'URL',
        'value' => $coreSettings->getSetting('sitefbclone.url.1', '')
      )
    );

    $this->addElement('Text', 'sitefbclone_title_1', array(
        'label' => 'Text on Hover',
        'maxlength' => '120',
        'value' => $coreSettings->getSetting('sitefbclone.title.1', 'Member home page')
      )
    );
    
    $this->addElement('Text', 'sitefbclone_icon_1', array(
        'label' => 'Icon For This Menu',
        'value' => $coreSettings->getSetting('sitefbclone.icon.1', 'fas fa-home')
    ));    

    $this->addDisplayGroup(array('sitefbclone_url_1', 'sitefbclone_title_1' , 'sitefbclone_icon_1'), 'sitefbclone_first_block');

    $this->addElement('Text', 'sitefbclone_url_2', array(
        'label' => 'URL',
       'value' => $coreSettings->getSetting('sitefbclone.url.2', '')
      )
    );

    $this->addElement('Text', 'sitefbclone_title_2', array(
        'label' => 'Text on Hover',
        'maxlength' => '120',
        'value' => $coreSettings->getSetting('sitefbclone.title.2', '')
      )
    );

    $this->addElement('Text', 'sitefbclone_icon_2', array(
        'label' => 'Icon For This Menu',
        'value' => $coreSettings->getSetting('sitefbclone.icon.2')
    ));

    $this->addDisplayGroup(array('sitefbclone_url_2', 'sitefbclone_title_2', 'sitefbclone_icon_2'), 'sitefbclone_second_block');

    $this->addElement('Text', 'sitefbclone_url_3', array(
        'label' => 'URL',
        'maxlength' => '120',
       'value' => $coreSettings->getSetting('sitefbclone.url.3', '')
      )
    );

    $this->addElement('Text', 'sitefbclone_title_3', array(
        'label' => 'Text on Hover',
       'value' => $coreSettings->getSetting('sitefbclone.title.3', '')
      )
    );

    $this->addElement('Text', 'sitefbclone_icon_3', array(
        'label' => 'Icon For This Menu',
        'value' => $coreSettings->getSetting('sitefbclone.icon.3')
    ));

    $this->addDisplayGroup(array('sitefbclone_url_3', 'sitefbclone_title_3','sitefbclone_icon_3'), 'sitefbclone_third_block');

    $this->addElement('Text', 'sitefbclone_url_4', array(
        'label' => 'URL',
       'value' => $coreSettings->getSetting('sitefbclone.url.4', '')
      )
    );

    $this->addElement('Text', 'sitefbclone_title_4', array(
        'label' => 'Text on Hover',
        'maxlength' => '120',
       'value' => $coreSettings->getSetting('sitefbclone.title.4', '')
      )
    );

    $this->addElement('Text', 'sitefbclone_icon_4', array(
        'label' => 'Icon For This Menu',
        'value' => $coreSettings->getSetting('sitefbclone.icon.4')
    ));

    $this->addDisplayGroup(array('sitefbclone_url_4', 'sitefbclone_title_4','sitefbclone_icon_4'), 'sitefbclone_four_block');

    $this->addElement('Text', 'sitefbclone_url_5', array(
        'label' => 'URL',
       'value' => $coreSettings->getSetting('sitefbclone.url.5', '')
      )
    );

    $this->addElement('Text', 'sitefbclone_title_5', array(
        'label' => 'Text on Hover',
        'maxlength' => '120',
       'value' => $coreSettings->getSetting('sitefbclone.title.5', '')
      )
    );

    $this->addElement('Text', 'sitefbclone_icon_5', array(
        'label' => 'Icon For This Menu',
        'value' => $coreSettings->getSetting('sitefbclone.icon.5')
    ));

    $this->addDisplayGroup(array('sitefbclone_url_5', 'sitefbclone_title_5','sitefbclone_icon_5'), 'sitefbclone_five_block');

    $this->addElement('Radio', 'sitefbclone_header_layut_mini_menus', array(
      'label' => 'Mini Menu Display',
      'description' => 'Please select the mini menu display.',
      'multiOptions' => array(
        '0' => 'New Facebook Clone Theme Mini Menu',
        '1' => 'SocialEngine Mini Menu'
      ),
      'value' => $coreSettings->getSetting('sitefbclone.header.layut.mini.menus', '0'),
    ));

    $this->addElement('Radio', 'sitefbclone_footer_layut_mini_menus', array(
      'label' => 'Show Footer Links in Mini Menu',
      'description' => 'Do you want to Show Footer Links in Mini Menu?',
      'multiOptions' => array(
        '1' => 'Yes',
        '0' => 'No',
      ),
      'value' => $coreSettings->getSetting('sitefbclone.footer.layut.mini.menus', '1'),
    ));

    $imgOptions = Engine_Api::_()->sitefbclone()->getImages(array('application/modules/Sitefbclone/externals/images/logo.png' => 'Default logo','' => "Text-only (No logo)"));

    $this->addElement('Select', 'sitefbclone_header_logo_image', array(
      'label' => 'Logo for logged in members',
      'description' => 'Select the logo for your website. [Note: Logo must be uploaded prior from Admin Panel → Appearance → File & Media Manager.]',
      'multiOptions' => $imgOptions,
      'value' => $coreSettings->getSetting('sitefbclone.header.logo.image', ''),
    ));

    $headerOptions = array(
      'logo' => 'Site Logo',
      'mini_menu' => 'Mini Menu',
      'main_menu' => 'Main Menu ',
      'search_box' => 'Search Box',
    );

    $deafultHeaderOptions = array(
      'logo',
      'mini_menu',
      'main_menu',
      'search_box',
    );

    $this->addElement('MultiCheckbox', 'sitefbclone_header_loggedin_widgets', array(
      'label' => 'Header Elements for Logged In Members',
      'description' => 'Select the elements you want to display in header section for logged in members.',
      'multiOptions' => $headerOptions,
      'value' => $coreSettings->getSetting('sitefbclone.header.loggedin.widgets', $deafultHeaderOptions),
    ));

    $this->addElement('Button', 'submit', array(
      'label' => 'Save Changes',
      'type' => 'submit',
      'ignore' => true
    ));
  }

}
