<?php
/**
 * SocialEngine
 *
 * @category   Application_Theme
 * @package    Sitefbclone
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Menus.php 2017-12-15 00:00:00 SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitefbclone_Plugin_Core extends Zend_Controller_Plugin_Abstract {

  public function onRenderLayoutDefault($event) {

    $view = $event->getPayload();
        $view->headTranslate(array("Forgot Password?", "Login with Insta", "Login with Facebook", "Mark as Read", "Mark as Unread"));

        $floating_header = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitefbclone.floating.header', 1);
        $backgroundImage = '';
      
        if (Engine_Api::_()->getApi('settings', 'core')->getSetting('sitefbclone.theme.website.body.background.image', 0)) {
            $backgroundImage = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitefbclone.theme.website.body.background.image', 0);
        }
        $themeTable = Engine_Api::_()->getDbtable('themes', 'core');
        $active = $themeTable->select()
                ->from($themeTable->info('name'), 'active')
                ->where('name = ?', 'sitefbclone')
                ->where('active = ?', 1)
                ->query()
                ->fetchColumn();
                
        if ($active) {
          $this->_loadFontsCss($view);
            $includeThemeBasedClass = <<<EOF
                    var floating_header = '$floating_header';
                    var backgroundImage = '$backgroundImage';
        en4.core.runonce.add(function(){
        window.addEvent('domready', function() {
                setTimeout(function () {
                    if (floating_header == 0 && document.getElementsByTagName("BODY")[0]) {
                       document.getElementsByTagName("BODY")[0].addClass('sitefbclone_non_floating_header');
                    }
                    if(backgroundImage)    
                    document.getElementsByTagName("BODY")[0].setStyle('background-image', 'url("$backgroundImage")');
                }, 100);
                //if the sitefbclone theme header widget is nor present in header than add a class in header, to add some css
                if(!$('global_header').getElements('.layout_sitefbclone_header')[0]) {
                  if($('global_header').getElements('.layout_page_header')[0]) {
                    $('global_header').getElements('.layout_page_header')[0].addClass('sitefbclone_core_widgets_header');
                  }
                }
          });      
        });
EOF;
      $view->headScript()->appendScript($includeThemeBasedClass);
      $layout = $view->layout();
      $themeTable = Engine_Api::_()->getDbtable('themes', 'sitefbclone');
      $themeSelect = $themeTable->select()
        ->where('active = ?', 1)
        ->limit(1);
      $themeRow = $themeTable->fetchRow($themeSelect);
      $colorName = $themeRow->name;
      $cookieName = 'sitefbclone_seao_theme_color';
      if (!empty($_COOKIE[$cookieName])) {
        $colorName = $_COOKIE[$cookieName];
      }
      $themeName = 'sitefbclone/' . $colorName;
      $themes = array();
      foreach( $layout->themes as $key => $theme ) {
        if( $theme == 'sitefbclone' ) {
          $theme = $themeName;
        }
        $themes[$key] = $theme;
      }
      $layout->themes = $themes;
      $themesInfo = $layout->themesInfo;
      $themesInfo[$themeName] = include APPLICATION_PATH_COR . DS
        . 'themes' . DS . 'sitefbclone' . DS . $colorName . DS . 'manifest.php';
      $layout->themesInfo = $themesInfo;
      Zend_Registry::set('Themes', $themesInfo);
    }
    }

    public function onRenderLayoutDefaultSimple($event) {
        // Forward
        return $this->onRenderLayoutDefault($event, 'simple');
    }

  protected function _loadFontsCss($view)
  {
    $coreSettings = Engine_Api::_()->getApi('settings', 'core');
    $fontType = $coreSettings->getSetting('sitefbclone.fonts.selected.font', 0);
    if( $fontType == 0 ) {
      $family[] = urlencode($this->_getFontsFamilyName('body'));
      $family[] = urlencode($this->_getFontsFamilyName('heading'));
      $family[] = urlencode($this->_getFontsFamilyName('mainmenu'));
      $family[] = urlencode($this->_getFontsFamilyName('tab'));
      $query = join("|", array_unique($family));
      $view->headLink()->appendStylesheet('https://fonts.googleapis.com/css?family=' . $query);
    }
  }

  protected function _getFontsFamilyName($name) {
      $coreSettings = Engine_Api::_()->getApi('settings', 'core');
      $fonts = $coreSettings->getSetting('sitefbclone.fonts.'.$name.'.font.family.google', '"Roboto", sans-serif');
      if (empty($fonts)) {
        return 'Roboto';
      }
      $explode = (explode(',', $fonts));
      $family = trim(str_replace(array("'", '"'), '', $explode[0]));
      return $family;
    }

  public function onUserLoginAfter($event) {
        $payload = $event->getPayload();
        if (isset($_COOKIE['seaocore_list_logins_users'])) {
            setcookie('seaocore_list_logins_users', Zend_Json::encode(array_unique(array_merge(array('user_id_' . $payload->getIdentity() => $payload->getIdentity()), Zend_Json::decode($_COOKIE['seaocore_list_logins_users'])))), time() + 3600, '/');
        } else {
            setcookie('seaocore_list_logins_users', Zend_Json::encode(array('user_id_' . $payload->getIdentity() => $payload->getIdentity())), time() + 3600, '/');
        }
    }
}
