<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitefbclone
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 2015-06-04 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
require_once realpath(dirname(__FILE__)) . '/sitemodule_install.php';

class Sitefbclone_Installer extends SiteModule_Installer
{
  /* If client are used the below plugins then need to check for upgrade */ 
  protected $_installConfig = array(
    'sku' => 'sitefbclone',
  );
  public function onInstall()
  {
    $this->_createCustomizationFile("/application/themes/sitefbclone/customization.css", '/* ADD CUSTOM STYLE */');
    $this->_createCustomizationFile("/public/seaocore_themes/sitefbcloneThemeGeneralConstants.css", '/* EDIT CONSTANTS, DO NOT UPDATE IT*/');
    parent::onInstall();
  }

 public function onPostInstall()
 {
    parent::onPostInstall();
 }

  public function onEnable()
  {
    $this->hideHeaderFooterOnPages(true);
    parent::onEnable();
  }

  public function onDisable()
  {
    $this->hideHeaderFooterOnPages(false);
    parent::onDisable();
  }

  private function _createCustomizationFile($filePath, $data)
  {
    $filePath = str_replace('/', DS, $filePath);
    $realfilePath = APPLICATION_PATH . $filePath;
    $global_directory_name = dirname($realfilePath);
    $is_dir_exist = @is_dir($global_directory_name);
    if( !$is_dir_exist ) {
      mkdir($global_directory_name);
    }
    @chmod($global_directory_name, 0777);

    if( !is_readable($global_directory_name) ) {
      return $this->_error("<span style='color:red'>Note: You do not have readable permission on the path below, please give 'chmod 777 recursive permission' on it to continue with the installation process : <br /> 
  Path Name: <b>" . $global_directory_name . "</b></span>");
    }

    $is_file_exist = @file_exists($realfilePath);
    if( empty($is_file_exist) ) {
      if( !is_writable($global_directory_name) ) {
        return $this->_error("<span style='color:red'>Note: You do not have writable permission on the path below, please give 'chmod 777 recursive permission' on it to continue with the installation process : <br /> 
  Path Name: " . $global_directory_name . "</span>");
      }

      $fh = @fopen($realfilePath, 'w');
      @fwrite($fh, $data);
      @fclose($fh);

      @chmod($realfilePath, 0777);
    }
  }

  public function hideHeaderFooterOnPages($hide)
  {
    $db = $this->getDb();
    if( $hide ) {
      $db->query("UPDATE `engine4_core_pages` SET `layout` = 'default-simple' WHERE `engine4_core_pages`.`name` = 'user_signup_index';");
    } else {
      $db->query("UPDATE `engine4_core_pages` SET `layout` = 'default' WHERE `engine4_core_pages`.`name` = 'user_signup_index';");
    }
  }

}
