<?php

/**
 * SocialEngine
 *
 * @category   Application_Theme
 * @package    Sitefbclone
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-12-15 00:00:00 SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitefbclone_Widget_FbCoverProfileController extends Engine_Content_Widget_Abstract {

    public function indexAction() {

        $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
        $this->view->viewer_id = $viewer_id = $viewer->getIdentity();

         if (!Engine_Api::_()->core()->hasSubject('user')) {
          $this->view->user = $user = $viewer;
        } else {
          $this->view->user = $user = Engine_Api::_()->core()->getSubject('user');
        }

        if (!$user->getIdentity()) {
          return $this->setNoRender();
        }

        $this->view->photo = '';
        if (isset($user->coverphoto)) {
          $this->view->photo = $photo = Engine_Api::_()->getItem('storage_file', $user->coverphoto);
        }

        $this->view->level_id = 0;
        $this->view->uploadDefaultCover = 0;

        if ($viewer->getIdentity() && $viewer->level_id == 1 && $user->getOwner()->isSelf($viewer)) {
          $this->view->uploadDefaultCover = isset($params['uploadDefaultCover']) ? $params['uploadDefaultCover'] : 0;
          $this->view->level_id = isset($params['level_id']) ? $params['level_id'] : 0;
        }

        // Get themes
        $themes = $this->view->themes = Engine_Api::_()->getDbtable('themes', 'sitefbclone')->fetchAll();
        $activeTheme = $this->view->activeTheme = $themes->getRowMatching('active', 1);

        if ($this->view->uploadDefaultCover) {
          $levelsAssoc = Engine_Api::_()->getDbtable('levels', 'authorization')->getLevelsAssoc();
          $this->view->defaultCoverMessage = Zend_Registry::get('Zend_Translate')->_(sprintf(
            'Here, you can upload and set default user cover photo for ' . $levelsAssoc[$this->view->level_id] .
              '. %s to view your profile.',
            "<a href='". $viewer->getHref() . "'>Click here</a>"
          ));
        }

        $this->view->can_edit = $user->authorization()->isAllowed($viewer, 'edit') && Engine_Api::_()->authorization()
      ->isAllowed('user', $user, 'coverphotoupload');
  }

}
