<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecoretheme
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Pagelayouts.php 2015-06-04 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitefitness_Api_Pagelayouts extends Core_Api_Abstract {  
    /**
     * Get Widgetized PageId
     * @param $params
     */
    public function getWidgetizedPageId($params = array()) {
        //GET CORE CONTENT TABLE
       $tableNamePages = Engine_Api::_()->getDbtable('pages', 'core');
       $page_id = $tableNamePages->select()
       ->from($tableNamePages->info('name'), 'page_id')
       ->where('name =?', $params['name'])
       ->query()
       ->fetchColumn();
       return $page_id;
    } 
    
    public function getBackupPageId($pageName) {
        //GET CORE CONTENT TABLE
       $tableNamePages = Engine_Api::_()->getDbtable('pages', 'core');
       $page_id = $tableNamePages->select()
       ->from($tableNamePages->info('name'), 'page_id')
       ->where('name =?', $pageName)
       ->query()
       ->fetchColumn();
       return $page_id;
    }

    public function configureSliderWidget() {
      $coreSettings = Engine_Api::_()->getApi('settings', 'core');
       $imagesPath = APPLICATION_PATH . '/application/modules/Sitefitness/externals/images/slider';
       if (is_dir($imagesPath)) {
         foreach (scandir($imagesPath) as $fileName) {
           $extension = ltrim(strrchr(basename($fileName), '.'), '.');
           if (!in_array($extension, array('jpg', 'png', 'gif', 'jpeg'))) {
             continue;
          }
          $fileNumber = explode('.', $fileName)[0];
          $Filedata = array(
             'tmp_name' => $imagesPath . '/' . $fileName,
             'name' => $fileName,
          );
          $values = array('title' => "Yoga_".$fileNumber, 'enabled' => 1, 'order' => $fileNumber);
          $imagesTable = Engine_Api::_()->getDbtable('images', 'sitecoretheme');
          $db = Engine_Db_Table::getDefaultAdapter();
          $db->beginTransaction();
          try {
             $image = $imagesTable->createRow();
             $image->setFromArray($values);
             $image->save();
             $image->setPhoto($Filedata);
             $db->commit();
          } catch (Exception $e) {
             $db->rollBack();
             throw $e;
          }   
       }
    }
    //SAVE THE SETTINGS REATED TO THE IMAGE SLIDER
    $coreSettings->setSetting('sitecoretheme.landing.slider.form.type', 'user_login');
    $coreSettings->setSetting('sitecoretheme.landing.slider.frontImage.position', 'right');
    $coreSettings->setSetting('sitecoretheme.landing.slider.bannerTitle', 'YOGA IS THE FOUNDATION OF YOUTH');
    $coreSettings->setSetting('sitecoretheme.landing.slider.description1', 'Yoga is a physical, mental, and spiritual practice or discipline which originated in India.');
    $coreSettings->setSetting('sitecoretheme.landing.slider.description2', 'Yoga, an ancient but perfect science, deals with the evolution of humanity.');
    
 }

 public function configureHighlightWidget() {
   $coreSettings = Engine_Api::_()->getApi('settings', 'core');
    $highlightBlocks = array(
      '1' => array('title' => 'Balance Body & Mind', 'description' => 'To tie things back to your body and your balance yoga practice, what I recommend for modern yogis is for the focus to rest strongly on the asana practice'),
      '2' => array('title' => 'Healthy Daily Life', 'description' => 'Yoga helps you remain healthy. Yoga practice helps lower blood pressure, improves blood circulation, strengthens muscles and it helps with insomnia, particularly through relaxation.'),
      '3' => array('title' => 'Meditation Practice', 'description' => 'Yoga and meditation can have many surprising impacts on both your mental and physical health. Yoga and meditation typically go hand-in-hand and have been around for thousands of years.'),
      '4' => array('title' => 'Yoga Month Challenge', 'description' => 'A regular yoga practice for a month makes you even more energetic, active and life-changing. Engage your entire body and mind with 30 days yoga challenge to feel the change in your life.'),
      '5' => array('title' => 'Back Pain Treatment', 'description' => 'Practising yoga is more effective treatment for chronic back pain than usual care. Even if you don`t have chronic pain, yoga`s stretching exercises can improve your spinal flexibility.'),
      '6' => array('title' => 'Insomnia Buster', 'description' => 'yoga is one of the most effective approaches for getting a good night`s sleep. It helps with circulation as well as calming your body and, most importantly, your mind.'),
      '7' => array('title' => 'Fertility Aid', 'description' => 'Yoga can help with infertility in a variety of ways. Yoga may also allow for better blood flow to reproductive organs, improving organ function and improving hormone function.'),
      '8' => array('title' => 'Asthma Ease', 'description' => 'Breathing practice, known as pranayama, is an essential part of yoga, and such exercises have been shown to help ease the symptoms of asthma.'),
   );

    $highlightTable = Engine_Api::_()->getDbtable('highlights', 'sitecoretheme');
    $rows = $highlightTable->fetchAll();
    //$imagesPath = APPLICATION_PATH . '/application/modules/Sitefitness/externals/images/highlight';
    foreach ($rows as $row) {
     //  $fileName = $row->highlights_id.'.png';
     //  $fileData = array(
     //    'tmp_name' => $imagesPath . '/' .$fileName ,
     //    'name' => $fileName,
     // );

      $db = Engine_Db_Table::getDefaultAdapter();
      $db->beginTransaction();
      try { 
        $row->setFromArray($highlightBlocks[$row->highlights_id]);
        $row->save();
        //$row->setPhoto($fileData);
        $db->commit();
     } catch (Exception $e) {
        $db->rollBack();
        throw $e;
     }
  }
          //SET MIDDLE SECTION PHOTO
  $coreSettings->setSetting('sitecoretheme.landing.highlights.image', 'application/modules/Sitefitness/externals/images/highlights_middle.jpg');
}

public function configureStatsWidget() {
   $coreSettings = Engine_Api::_()->getApi('settings', 'core');
 $statCountArray = array('1' => '50', '2' => '590', '3' => '35', '4' => '19');
 $statTitleArray = array('1' => 'Years of Experience', '2' => 'Members', '3' => 'Professional Trainers', '4' => 'Classes');
 $imagesPath = APPLICATION_PATH . '/application/modules/Sitefitness/externals/images/stats';

 if (is_dir($imagesPath)) {
   foreach (scandir($imagesPath) as $fileName) {
     $extension = ltrim(strrchr(basename($fileName), '.'), '.');
     if (!in_array($extension, array('jpg', 'png', 'gif', 'jpeg'))) {
       continue;
    }
    $fileNumber = explode('.', $fileName)[0];
    $Filedata = array(
       'tmp_name' => $imagesPath . '/' . $fileName,
       'name' => $fileName,
    ); 
    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    try {  
       $file_id = $this->setPhoto($Filedata, null, 'sitecoretheme_stat');
       if($file_id) {
        $coreSettings->setSetting('sitecoretheme.landing.stats.icon'.$fileNumber, $file_id);
       }
       $coreSettings->setSetting('sitecoretheme.landing.stats.count'.$fileNumber, $statCountArray[$fileNumber]);
       $coreSettings->setSetting('sitecoretheme.landing.stats.title'.$fileNumber, $statTitleArray[$fileNumber]);
       $db->commit();
    } catch (Exception $e) {
       $db->rollBack();
       throw $e;
    }
 }
}
$coreSettings->setSetting('sitecoretheme.landing.stats.bgimage', 'application/modules/Sitefitness/externals/images/stat_background.jpg');
}


 public function configureServicesWidget() {
   $coreSettings = Engine_Api::_()->getApi('settings', 'core');
    $services = array(
      '1' => array('title' => 'Improves your flexibility', 'description' => 'Improved flexibility is one of the first and most obvious benefits of yoga. During your first class, you probably won`t be able to touch your toes, never mind do a backbend.'),
      '2' => array('title' => 'Builds muscle strength', 'description' => 'Strong muscles do more than look good. They also protect us from conditions like arthritis and back pain, and help prevent falls in elderly people.'),
      '3' => array('title' => 'Perfects your posture', 'description' => 'Your head is like a bowling ball—big, round, and heavy. When it`s balanced directly over an erect spine, it takes much less work for your neck and back muscles to support it.'),
      '4' => array('title' => 'Protects your spine', 'description' => 'Spinal disks—the shock absorbers between the vertebrae that can herniate and compress nerves crave movement. That`s the only way they get their nutrients. '),
      '5' => array('title' => 'Increases your blood flow', 'description' => 'Yoga gets your blood flowing. More specifically, the relaxation exercises you learn in yoga can help your circulation, especially in your hands and feet.'),
      '6' => array('title' => 'Ups your heart rate', 'description' => 'When you regularly get your heart rate into the aerobic range, you lower your risk of heart attack and can relieve depression. If you do it vigorously, it can boost your heart rate.'),
      '7' => array('title' => 'Regulates your adrenal glands', 'description' => 'Yoga lowers cortisol levels. If that doesn`t sound like much, consider this. The adrenal glands secrete cortisol in response to an acute crisis, which temporarily boosts immune function'),
      '8' => array('title' => 'Makes you happier', 'description' => 'Yoga practice improved depression and led to a significant increase in serotonin levels and a decrease in the levels of monoamine oxidase and cortisol.'),
      '9' => array('title' => 'Lowers blood sugar', 'description' => 'Yoga lowers blood sugar and LDL ("bad") cholesterol and boosts HDL ("good") cholesterol. Get your blood sugar levels down, and you decrease your risk of diabetic complications.'),
   );

    $highlightTable = Engine_Api::_()->getDbtable('services', 'sitecoretheme');
    $rows = $highlightTable->fetchAll();
    //$imagesPath = APPLICATION_PATH . '/application/modules/Sitefitness/externals/images/highlight';
    foreach ($rows as $row) {
     //  $fileName = $row->service_id.'.png';
     //  $fileData = array(
     //    'tmp_name' => $imagesPath . '/' .$fileName ,
     //    'name' => $fileName,
     // );

      $db = Engine_Db_Table::getDefaultAdapter();
      $db->beginTransaction();
      try { 
        $row->setFromArray($services[$row->service_id]);
        $row->save();
        //$row->setPhoto($fileData);
        $db->commit();
     } catch (Exception $e) {
        $db->rollBack();
        throw $e;
     }
  }
}

public function configureCommonSettings() {
   $coreSettings = Engine_Api::_()->getApi('settings', 'core');
   //change the footer background image
   $coreSettings->setSetting('sitecoretheme.footer.backgroundimage', 'application/modules/Sitefitness/externals/images/default_footer_bg.jpg');
   //ICON BELOW THE HEADING IN THE LANDING PAGE
   $coreSettings->setSetting('sitecoretheme.landing.heading.icon', 'f185');
   //BUTTONS STYLE
   $coreSettings->setSetting('sitecoretheme.button.design', '1');
   //HEADING STYPE
   $coreSettings->setSetting('sitecoretheme.layout.container.headding.style', '11');
   //CONTAINER STYLE
   $coreSettings->setSetting('sitecoretheme.layout.container.design', '2');
   //SAVE THE LAYOUT SETTING, THESE MAY BE DIFFRERET BASED ON THE TEMPLATE
   $fileName = 'sitecorethemeThemeGeneralConstants.css';
   $values['sitecoretheme_layout_theme_width'] =  '1200px';
   $values['sitecoretheme_layout_left_column_width'] = '250px';
   $values['sitecoretheme_layout_right_column_width'] = '250px';
   $values['sitecoretheme_layout_container_design'] = '2';
   $values['sitecoretheme_layout_container_headding_style'] = '11';
   $values['sitecoretheme_button_design'] = '1';
   $values['sitecoretheme_landing_heading_icon'] = 'f185';
   $values['sitecoretheme_layout_hide_left_column'] = 'none';
   $values['sitecoretheme_layout_hide_right_column'] = 'block';
   Engine_Api::_()->getApi('customization', 'sitecoretheme')->setConstants($values, $fileName);
}

public function configureContentBlocksWidget() {
 $params1 = '{"video_uri":"","cta_1_heading":null,"cta_1_label":"","cta_1_uri":"","cta_1_uri_target":"0","cta_2_heading":null,"cta_2_label":"","cta_2_uri":"","cta_2_uri_target":"0"}';
 $params2 = '{"video_uri":"","cta_1_heading":null,"cta_1_label":"Yoga Asanas","cta_1_uri":"#","cta_1_uri_target":"0","cta_2_heading":null,"cta_2_label":"Yoga Classes","cta_2_uri":"#","cta_2_uri_target":"0"}';
 $params3 = '{"video_uri":"https:\/\/www.youtube.com\/watch?v=fY_GXLeFbJ0","cta_1_heading":null,"cta_1_label":"","cta_1_uri":"","cta_1_uri_target":"0","cta_2_heading":null,"cta_2_label":"","cta_2_uri":"","cta_2_uri_target":"0"}';



 $body1 = 'Yoga helps to elicit the attention of your inner creativity, desires and inspiration for living with joy. Humans themselves are responsible for making your life happy and emanating that happiness to others. This art helps you in maintaining a joyful view of life even in difficult times. The straightforward yet profound wisdom found within is a distillation of knowledge garnered from countless masters and adepts of the Himalayan Tradition, made available and relatable to the modern-day student of yoga.';
 $body2 = 'With all of the bends, twists and poses that work your body into a human pretzel, yoga is certainly a form of exercise that stretches you out. Yoga can improve flexibility, increase range of motion and just make you feel longer and leaner. The point is that the brilliance of yoga is that it is for everyone because each person can find a style of yoga that fits his/her body type and his/her individual needs. A supple, flexible body is less prone to injuries because it can withstand physical stress.';
 $body3 = 'Yoga is a practice that brings together mental clarity, renewed energy, physical challenges, and also a sense of serenity. Serenity Yoga is a peaceful and compassionate environment that supports the health and wellness of our community.';
 $contentArray = array(
   '1' => array('title' => 'INSPIRATION FOR JOYFUL LIVING', 'subheading' => 'YOGA MEETS ART', 'body' => $body1, 'params' => $params1),
   '2' => array('title' => 'FLEXIBILITY IS A SECOND POWER', 'subheading' => 'POWER OF RESILIENCE', 'body' => $body2, 'params' => $params2),
   '3' => array('title' => 'SERENITY IS INSIDE YOU', 'subheading' => 'NEED OF INTERNAL PEACE', 'body' => $body3, 'params' => $params3),
);
 $imagesPath = APPLICATION_PATH . '/application/modules/Sitefitness/externals/images/blocks';
 if (is_dir($imagesPath)) {
   foreach (scandir($imagesPath) as $fileName) {
     $extension = ltrim(strrchr(basename($fileName), '.'), '.');
     if (!in_array($extension, array('jpg', 'png', 'gif', 'jpeg'))) {
       continue;
    }
    $fileNumber = explode('.', $fileName)[0];
    $Filedata = array(
       'tmp_name' => $imagesPath . '/' . $fileName,
       'name' => $fileName,
    );
    $blocksTable = Engine_Api::_()->getDbtable('blocks', 'sitecoretheme');
    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    try {
       $block = $blocksTable->createRow();
       $block->setFromArray($contentArray[$fileNumber]);
       $block->save();
       $block->setPhoto($Filedata);
       $db->commit();
    } catch (Exception $e) {
       $db->rollBack();
       throw $e;
    }
 }
}
}

public function configureVideoBannerWidget() {
   $coreSettings = Engine_Api::_()->getApi('settings', 'core');
   $coreSettings->setSetting('sitecoretheme.landing.videobanner.image', 'application/modules/Sitefitness/externals/images/video-banner.jpg');
   $coreSettings->setSetting('sitecoretheme.landing.videobanner.videoType', '1');
   $coreSettings->setSetting('sitecoretheme.landing.videobanner.videoUrl', 'https://www.youtube.com/watch?v=fY_GXLeFbJ0');
   $coreSettings->setSetting('sitecoretheme.landing.videobanner.heading', 'Center your body and mind. Stretch the possibilities.');
}

public function configureCtaButtonsWidget() {
 $coreSettings = Engine_Api::_()->getApi('settings', 'core');
 $ctaTitleArray = array('1' => 'Yoga Classes', '2' => 'Yoga Asanas', '3' => 'Inspirational Video');
 $ctaBodyArray = array('1' => 'More than 19 classes are available for you. To know more click here', '2' => 'Yoga asanas for beginners and rehearsed candidates are taught distinctively.  ', '3' => 'Checkout the video of yoga asanas for beginners.');
 for ($i=1; $i <= 3; $i++) {
  $coreSettings->setSetting('sitecoretheme.landing.cta.title'.$i, $ctaTitleArray[$i]);
  $coreSettings->setSetting('sitecoretheme.landing.cta.body'.$i, $ctaBodyArray[$i]);
 }
 $imagesPath = APPLICATION_PATH . '/application/modules/Sitefitness/externals/images';
 $fileName = 'cta-sitephoto.png';
  $Filedata = array(
     'tmp_name' => $imagesPath . '/' . $fileName,
     'name' => $fileName,
  );
 $file_id = $this->setPhoto($Filedata, null, 'sitecoretheme_ctabutton', 600);
 if($file_id) {
  $coreSettings->setSetting('sitecoretheme.landing.side-banner', $file_id);
 }
 $coreSettings->setSetting('sitecoretheme.landing.cta.style', 'style1');
 $coreSettings->setSetting('sitecoretheme.landing.cta.newtab', '1');
}


public function setPhoto($photo, $parent_id = null, $parent_type = null, $size = 64)
{
 if( $photo instanceof Zend_Form_Element_File ) {
   $file = $photo->getFileName();
} else if( is_array($photo) && !empty($photo['tmp_name']) ) {
   $file = $photo['tmp_name'];
} else if( is_string($photo) && file_exists($photo) ) {
   $file = $photo;
} else {
   throw new Engine_Exception('invalid argument passed to setPhoto');
}

$name = basename($file);
$path = APPLICATION_PATH . DIRECTORY_SEPARATOR . 'temporary';

$thumb_file = $path . '/in_' . $name;
$image = Engine_Image::factory();

$image->open($file)
->resize($size, $size)
->write($thumb_file)
->destroy();
try {
   $thumbFileRow = Engine_Api::_()->storage()->create($thumb_file, array(
     'parent_type' => $parent_type,
     'parent_id' => $parent_id
  ));
            // Remove temp file
   @unlink($thumb_file);
} catch( Exception $e ) {

}
$file_id = $thumbFileRow->file_id;
return $file_id;
}

public function getBackupOfHomePage() {

 $page_id = $this->getWidgetizedPageId(array('name' => 'core_index_index'));
 $tableNameContent = Engine_Api::_()->getDbtable('content', 'core');
 $tableNameContentName = $tableNameContent->info('name');
 $db = Engine_Db_Table::getDefaultAdapter();

        //CHECK PAGE EXIST OR NOT
 $home_backup_page_id = $this->getBackupPageId('landing_page_backup');
 if(!empty($home_backup_page_id)) {
   return;
}

        //CREATE PAGE
if (empty($home_backup_page_id)) {
   $db->query("INSERT IGNORE INTO `engine4_core_pages` ( `name`, `displayname`, `url`, `title`, `description`, `keywords`, `custom`, `fragment`, `layout`, `levels`, `provides`, `view_count`, `search`) VALUES ('landing_page_backup', 'Landing Page - Backup of Landing Page on Installation of Vertical Theme', 'landing_page_backup', 'Backup of Landing Page on Installation of Vertical Theme Plugin', '', '', '0', '0', '', NULL, NULL, '0', '0');");
}

        //GET EXISTING PAGE ID
$home_backup_page_id = $this->getBackupPageId('landing_page_backup');

$db->query("DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`page_id` = $home_backup_page_id");
        //GET MAIN CONTAINER WORK

$select = $tableNameContent->select()
->from($tableNameContentName, '*')
->where('page_id =?', $page_id)
->where('name =?', 'main')
->where('type =?', 'container');

$mainRow = $tableNameContent->fetchRow($select);

if (!empty($mainRow)) {

   $db->insert('engine4_core_content', array(
     'type' => 'container',
     'name' => 'main',
     'page_id' => $home_backup_page_id,
     'parent_content_id' => null,
     'order' => $mainRow->order,
     'params' => $mainRow->params ? json_encode($mainRow->params) : ''
  ));
   $content_id = $db->lastInsertId('engine4_core_content');

   $results = $tableNameContent->select()
   ->from($tableNameContentName, '*')
   ->where('page_id =?', $page_id)
   ->where('name in (?)', array('left', 'middle', 'right'))
   ->where('type =?', 'container')
   ->where('parent_content_id =?', $mainRow->content_id)
   ->query()
   ->fetchAll();

   foreach ($results as $values) {
     $db->insert('engine4_core_content', array(
       'type' => $values['type'],
       'name' => $values['name'],
       'page_id' => $home_backup_page_id,
       'parent_content_id' => $content_id,
       'order' => $values['order'],
       'params' => $values['params']
    ));
  }

            //LEFT CONTAINER WIDGETS
  $select = $tableNameContent->select()
  ->from($tableNameContentName, '*')
  ->where('page_id =?', $page_id)
  ->where('parent_content_id =?', $mainRow->content_id)
  ->where('name =?', 'left')
  ->where('type =?', 'container');

  $leftRow = $tableNameContent->fetchRow($select);

  if (!empty($leftRow)) {
     $results = $tableNameContent->select()
     ->from($tableNameContentName, '*')
     ->where('page_id =?', $page_id)
     ->where('parent_content_id =?', $leftRow->content_id)
     ->where('type =?', 'widget')
     ->query()
     ->fetchAll();

     $select = $tableNameContent->select()
     ->from($tableNameContentName, '*')
     ->where('page_id =?', $home_backup_page_id)
     ->where('parent_content_id =?', $content_id)
     ->where('name =?', 'left')
     ->where('type =?', 'container');

     $row = $tableNameContent->fetchRow($select);

     foreach ($results as $values) {
       $db->insert('engine4_core_content', array(
         'type' => $values['type'],
         'name' => $values['name'],
         'page_id' => $home_backup_page_id,
         'parent_content_id' => $row->content_id,
         'order' => $values['order'],
         'params' => $values['params']
      ));
    }
 }
            //END LEFT CONTAINER WIDGET
            //MIDDLE CONTAINER WIDGETS
 $select = $tableNameContent->select()
 ->from($tableNameContentName, '*')
 ->where('page_id =?', $page_id)
 ->where('parent_content_id =?', $mainRow->content_id)
 ->where('name =?', 'middle')
 ->where('type =?', 'container');

 $middleRow = $tableNameContent->fetchRow($select);

 if (!empty($middleRow)) {
  $results = $tableNameContent->select()
  ->from($tableNameContentName, '*')
  ->where('page_id =?', $page_id)
  ->where('parent_content_id =?', $middleRow->content_id)
  ->where('type =?', 'widget')
  ->query()
  ->fetchAll();

  $select = $tableNameContent->select()
  ->from($tableNameContentName, '*')
  ->where('page_id =?', $home_backup_page_id)
  ->where('parent_content_id =?', $content_id)
  ->where('name =?', 'middle')
  ->where('type =?', 'container');

  $row = $tableNameContent->fetchRow($select);

  foreach ($results as $values) {
    $db->insert('engine4_core_content', array(
      'type' => $values['type'],
      'name' => $values['name'],
      'page_id' => $home_backup_page_id,
      'parent_content_id' => $row->content_id,
      'order' => $values['order'],
      'params' => $values['params']
   ));
 }
}
            //END MIDDLE CONTAINER WIDGET
            //RIGHT CONTAINER WIDGETS
$select = $tableNameContent->select()
->from($tableNameContentName, '*')
->where('page_id =?', $page_id)
->where('parent_content_id =?', $mainRow->content_id)
->where('name =?', 'right')
->where('type =?', 'container');

$rightRow = $tableNameContent->fetchRow($select);

if (!empty($rightRow)) {
  $results = $tableNameContent->select()
  ->from($tableNameContentName, '*')
  ->where('page_id =?', $page_id)
  ->where('parent_content_id =?', $rightRow->content_id)
  ->where('type =?', 'widget')
  ->query()
  ->fetchAll();

  $select = $tableNameContent->select()
  ->from($tableNameContentName, '*')
  ->where('page_id =?', $home_backup_page_id)
  ->where('parent_content_id =?', $content_id)
  ->where('name =?', 'right')
  ->where('type =?', 'container');

  $row = $tableNameContent->fetchRow($select);

  foreach ($results as $values) {
    $db->insert('engine4_core_content', array(
      'type' => $values['type'],
      'name' => $values['name'],
      'page_id' => $home_backup_page_id,
      'parent_content_id' => $row->content_id,
      'order' => $values['order'],
      'params' => $values['params']
   ));
 }
}
            //END RIGHT CONTAINER WIDGET
}

        //TOP CONTAINER
$select = $tableNameContent->select()
->from($tableNameContentName, '*')
->where('page_id =?', $page_id)
->where('name =?', 'top')
->where('type =?', 'container');

$topRow = $tableNameContent->fetchRow($select);

if (!empty($topRow)) {

   $db->insert('engine4_core_content', array(
     'type' => 'container',
     'name' => 'top',
     'page_id' => $home_backup_page_id,
     'parent_content_id' => null,
     'order' => $topRow->order,
                //'params' => json_encode($topRow->params)
     'params' => $topRow->params ? json_encode($topRow->params) : ''
  ));
   $content_id = $db->lastInsertId('engine4_core_content');

   $results = $tableNameContent->select()
   ->from($tableNameContentName, '*')
   ->where('page_id =?', $page_id)
   ->where('name in (?)', array('left', 'middle', 'right'))
   ->where('type =?', 'container')
   ->where('parent_content_id =?', $topRow->content_id)
   ->query()
   ->fetchAll();

   foreach ($results as $values) {
     $db->insert('engine4_core_content', array(
       'type' => 'container',
       'name' => $values['name'],
       'page_id' => $home_backup_page_id,
       'parent_content_id' => $content_id,
       'order' => $values['order'],
       'params' => $values['params']
    ));
  }

            //MIDDLE CONTAINER WIDGETS
  $select = $tableNameContent->select()
  ->from($tableNameContentName, '*')
  ->where('page_id =?', $page_id)
  ->where('parent_content_id =?', $topRow->content_id)
  ->where('name =?', 'middle')
  ->where('type =?', 'container');

  $topMiddleRow = $tableNameContent->fetchRow($select);

  if (!empty($topMiddleRow)) {
     $results = $tableNameContent->select()
     ->from($tableNameContentName, '*')
     ->where('page_id =?', $page_id)
     ->where('parent_content_id =?', $topMiddleRow->content_id)
     ->where('type =?', 'widget')
     ->query()
     ->fetchAll();

     $select = $tableNameContent->select()
     ->from($tableNameContentName, '*')
     ->where('page_id =?', $home_backup_page_id)
     ->where('parent_content_id =?', $content_id)
     ->where('name =?', 'middle')
     ->where('type =?', 'container');

     $row = $tableNameContent->fetchRow($select);

     foreach ($results as $values) {
       $db->insert('engine4_core_content', array(
         'type' => $values['type'],
         'name' => $values['name'],
         'page_id' => $home_backup_page_id,
         'parent_content_id' => $row->content_id,
         'order' => $values['order'],
         'params' => $values['params']
      ));
    }
 }
            //END MIDDLE CONTAINER WIDGET
}


        //GET BOTTOM CONTAINER
$select = $tableNameContent->select()
->from($tableNameContentName, '*')
->where('page_id =?', $page_id)
->where('name =?', 'bottom')
->where('type =?', 'container');

$bottomRow = $tableNameContent->fetchRow($select);

if (!empty($bottomRow)) {

   $db->insert('engine4_core_content', array(
     'type' => 'container',
     'name' => 'bottom',
     'page_id' => $home_backup_page_id,
     'parent_content_id' => null,
     'order' => $bottomRow->order,
     'params' => $bottomRow->params ? json_encode($bottomRow->params) : ''
  ));
   $content_id = $db->lastInsertId('engine4_core_content');

   $results = $tableNameContent->select()
   ->from($tableNameContentName, '*')
   ->where('page_id =?', $page_id)
   ->where('name in (?)', array('left', 'middle', 'right'))
   ->where('type =?', 'container')
   ->where('parent_content_id =?', $bottomRow->content_id)
   ->query()
   ->fetchAll();

   foreach ($results as $values) {
     $db->insert('engine4_core_content', array(
       'type' => 'container',
       'name' => $values['name'],
       'page_id' => $home_backup_page_id,
       'parent_content_id' => $content_id,
       'order' => $values['order'],
       'params' => $values['params']
    ));
  }

            //MIDDLE CONTAINER WIDGETS
  $select = $tableNameContent->select()
  ->from($tableNameContentName, '*')
  ->where('page_id =?', $page_id)
  ->where('parent_content_id =?', $bottomRow->content_id)
  ->where('name =?', 'middle')
  ->where('type =?', 'container');

  $bottomMiddleRow = $tableNameContent->fetchRow($select);

  if (!empty($bottomMiddleRow)) {
     $results = $tableNameContent->select()
     ->from($tableNameContentName, '*')
     ->where('page_id =?', $page_id)
     ->where('parent_content_id =?', $bottomMiddleRow->content_id)
     ->where('type =?', 'widget')
     ->query()
     ->fetchAll();

     $select = $tableNameContent->select()
     ->from($tableNameContentName, '*')
     ->where('page_id =?', $home_backup_page_id)
     ->where('parent_content_id =?', $content_id)
     ->where('name =?', 'middle')
     ->where('type =?', 'container');

     $row = $tableNameContent->fetchRow($select);

     foreach ($results as $values) {
       $db->insert('engine4_core_content', array(
         'type' => $values['type'],
         'name' => $values['name'],
         'page_id' => $home_backup_page_id,
         'parent_content_id' => $row->content_id,
         'order' => $values['order'],
         'params' => $values['params']
      ));
    }
 }
            //END MIDDLE CONTAINER WIDGET
}
}

public function setDefaultLayout($obj) {
 $this->getBackupOfHomePage();
 $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
 $db = Engine_Db_Table::getDefaultAdapter();
 $page_id = $db->select()
 ->from('engine4_core_pages', 'page_id')
 ->where('name = ?', 'core_index_index')
 ->limit(1)
 ->query()
 ->fetchColumn();
 if (!empty($page_id) && !empty($obj) && !empty($obj['sitecoretheme_landing_page_layout'])) {
   $db->query("DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`page_id` = $page_id");

   $db->insert('engine4_core_content', array(
     'type' => 'container',
     'name' => 'top',
     'page_id' => $page_id,
     'order' => 1,
  ));
   $top_id = $db->lastInsertId();

   $db->insert('engine4_core_content', array(
     'type' => 'container',
     'name' => 'middle',
     'parent_content_id' => $top_id,
     'page_id' => $page_id,
     'order' => 2,
  ));
   $top_middle_id = $db->lastInsertId();

    $db->insert('engine4_core_content', array(
      'type' => 'widget',
      'name' => 'sitecoretheme.landing-page-header',
      'page_id' => $page_id,
      'parent_content_id' => $top_middle_id,
      'params' => '{"title":"","name":"sitecoretheme.landing-page-header"}',
      'order' => 3,
   ));

   $db->insert('engine4_core_content', array(
     'type' => 'widget',
     'name' => 'sitecoretheme.images',
     'page_id' => $page_id,
     'parent_content_id' => $top_middle_id,
     'params' => '{"title":""}',
     'order' => 3,
  )); 
   $db->insert('engine4_core_content', array(
     'type' => 'container',
     'name' => 'main',
     'page_id' => $page_id,
     'order' => 5,
  ));
   $main_id = $db->lastInsertId();

            // Insert main-middle
   $db->insert('engine4_core_content', array(
     'type' => 'container',
     'name' => 'middle',
     'page_id' => $page_id,
     'parent_content_id' => $main_id,
     'order' => 6,
  ));
   $main_middle_id = $db->lastInsertId();

            // Insert main-middle
   $db->insert('engine4_core_content', array(
     'type' => 'widget',
     'name' => 'sitecoretheme.highlights-block',
     'page_id' => $page_id,
     'parent_content_id' => $top_middle_id,
     'params' => '{"title":"Experience of Yoga","titleCount":true,"description":"Yoga helps you find balance, harmony and energy renewal amidst the hectic bustle of everyday pressures and deadlines. Relax & enjoy a personalized day yoga experience in our comfortable sanctuary.","nomobile":"0","name":"sitecoretheme.highlights-block"}',
     'order' => 7,
  ));

  $db->insert('engine4_core_content', array(
     'type' => 'widget',
     'name' => 'sitecoretheme.content-blocks',
     'page_id' => $page_id,
     'parent_content_id' => $top_middle_id,
     'params' => '{"viewType":"3","title":"Our Classes","description":"","itemType":"blog","sortBy":"creation_date","readMoreText":"Read More","limit":"6","nomobile":"0","name":"sitecoretheme.content-blocks"}',
     'order' => 8,
  ));

   $db->insert('engine4_core_content', array(
     'type' => 'widget',
     'name' => 'sitecoretheme.block',
     'page_id' => $page_id,
     'parent_content_id' => $top_middle_id,
     'params' => '{"name":"sitecoretheme.block","block_id":"1","photosPositions":"left","title":"","nomobile":"0"}',
     'order' => 9,
  ));

   $db->insert('engine4_core_content', array(
     'type' => 'widget',
     'name' => 'sitecoretheme.block',
     'page_id' => $page_id,
     'parent_content_id' => $top_middle_id,
     'params' => '{"name":"sitecoretheme.block","block_id":"2","photosPositions":"right","title":"","nomobile":"0"}',
     'order' => 9,
  ));

   $db->insert('engine4_core_content', array(
     'type' => 'widget',
     'name' => 'sitecoretheme.block',
     'page_id' => $page_id,
     'parent_content_id' => $top_middle_id,
     'params' => '{"name":"sitecoretheme.block","block_id":"3","photosPositions":"left","backendBorder":"0","title":"","nomobile":"0"}',
     'order' => 9,
  )); 

   $db->insert('engine4_core_content', array(
     'type' => 'widget',
     'name' => 'sitecoretheme.stats-block',
     'page_id' => $page_id,
     'parent_content_id' => $top_middle_id,
     'params' => '{"title":"","titleCount":true}',
     'order' => 10,
  )); 

   $db->insert('engine4_core_content', array(
     'type' => 'widget',
     'name' => 'sitecoretheme.text-banner',
     'page_id' => $page_id,
     'parent_content_id' => $top_middle_id,
     'params' => '{"title":"", "nomobile":"0"}',
     'order' => 11,
  )); 


   $db->insert('engine4_core_content', array(
     'type' => 'widget',
     'name' => 'sitecoretheme.heading',
     'page_id' => $page_id,
     'parent_content_id' => $top_middle_id,
     'params' => '{"name":"sitecoretheme.heading","title":"Pros Of Yoga","description":"Pros Of Yoga","nomobile":"0"}',
     'order' => 12,
  ));

  $db->insert('engine4_core_content', array(
     'type' => 'widget',
     'name' => 'sitecoretheme.our-services',
     'page_id' => $page_id,
     'parent_content_id' => $top_middle_id,
     'params' => '{"title":"","titleCount":true,"description":"","nomobile":"0"}',
     'order' => 12,
  ));

    $db->insert('engine4_core_content', array(
     'type' => 'widget',
     'name' => 'sitecoretheme.video-banner',
     'page_id' => $page_id,
     'parent_content_id' => $top_middle_id,
     'params' => '{"title":"","name":"sitecoretheme.video-banner"}',
     'order' => 13,
  )); 

  $db->insert('engine4_core_content', array(
     'type' => 'widget',
     'name' => 'sitecoretheme.static-buttons',
     'page_id' => $page_id,
     'parent_content_id' => $top_middle_id,
     'params' => '{"title":"Additional Lineaments","name":"sitecoretheme.static-buttons"}',
     'order' => 14,
  ));  

  $db->insert('engine4_core_content', array(
     'type' => 'widget',
     'name' => 'sitecoretheme.app-promotion',
     'page_id' => $page_id,
     'parent_content_id' => $top_middle_id,
     'params' => '{"title":"", "nomobile":"0"}',
     'order' => 15,
  )); 

  $db->insert('engine4_core_content', array(
     'type' => 'widget',
     'name' => 'sitecoretheme.scroll-content-menus',
     'page_id' => $page_id,
     'parent_content_id' => $top_middle_id,
     'params' => '{"title":"", "nomobile":"0"}',
     'order' => 16,
  ));
 
} 
$member_home_page_id = $this->getWidgetizedPageId(array('name' => 'user_index_home'));
$tableNameContent = Engine_Api::_()->getDbtable('content', 'core');
$tableNameContentName = $tableNameContent->info('name');
$top_content_id = $tableNameContent->select()
->from($tableNameContentName, 'content_id')
->where('page_id =?', $member_home_page_id)
->where('name =?', 'top')
->query()
->fetchColumn();
if (empty($top_content_id)) {
   $db->insert('engine4_core_content', array(
     'type' => 'container',
     'name' => 'top',
     'page_id' => $member_home_page_id,
     'parent_content_id' => null,
     'order' => 1,
     'params' => ''
  ));
   $content_id = $db->lastInsertId('engine4_core_content');
   $middle_content_id = $tableNameContent->select()
   ->from($tableNameContentName, 'content_id')
   ->where('page_id =?', $member_home_page_id)
   ->where('parent_content_id =?', $content_id)
   ->where('name =?', 'middle')
   ->query()
   ->fetchColumn();

   if (empty($middle_content_id)) {
     $db->insert('engine4_core_content', array(
       'type' => 'container',
       'name' => 'middle',
       'page_id' => $member_home_page_id,
       'parent_content_id' => $content_id,
       'order' => 2,
       'params' => ''
    ));

     $content_id = $db->lastInsertId('engine4_core_content');

     $middle_banner_id = $tableNameContent->select()
     ->from($tableNameContentName, 'content_id')
     ->where('page_id =?', $member_home_page_id)
     ->where('parent_content_id =?', $content_id)
     ->where('name =?', 'sitecoretheme.banner-images')
     ->query()
     ->fetchColumn();
     if (!$middle_banner_id) {
       $db->insert('engine4_core_content', array(
         'type' => 'widget',
         'name' => 'sitecoretheme.banner-images',
         'page_id' => $member_home_page_id,
         'parent_content_id' => $content_id,
         'order' => 1,
         'params' => '{"showBanners":"1","selectedBanners":"","width":"","height":"300","speed":"5000","order":"2","verticalHtmlTitle":"Yoga- A way of feeling relaxed and calm!","verticalHtmlDescription":"A form of meditations and disciplined life. It is a practice that originated in India but is practised widely throughout the world.","title":"","nomobile":"0","name":"sitecoretheme.banner-images"}'
      ));
    }
 }
 $db->query("UPDATE `engine4_core_content` SET  `order` =  '2' WHERE  `engine4_core_content`.`page_id` = $member_home_page_id AND `engine4_core_content`.`name` = 'main' LIMIT 1 ;");
} else {
   $middle_content_id = $tableNameContent->select()
   ->from($tableNameContentName, 'content_id')
   ->where('page_id =?', $member_home_page_id)
   ->where('parent_content_id =?', $top_content_id)
   ->where('name =?', 'middle')
   ->query()
   ->fetchColumn();

   if (!empty($middle_content_id)) {

     $middle_banner_id = $tableNameContent->select()
     ->from($tableNameContentName, 'content_id')
     ->where('page_id =?', $member_home_page_id)
     ->where('parent_content_id =?', $middle_content_id)
     ->where('name =?', 'sitecoretheme.banner-images')
     ->query()
     ->fetchColumn();

     if (!$middle_banner_id) {
       $db->insert('engine4_core_content', array(
         'type' => 'widget',
         'name' => 'sitecoretheme.banner-images',
         'page_id' => $member_home_page_id,
         'parent_content_id' => $middle_content_id,
         'order' => 1,
         'params' => '{"showBanners":"1","selectedBanners":"","width":"","height":"300","speed":"5000","order":"2","verticalHtmlTitle":"Yoga- A way of feeling relaxed and calm!","verticalHtmlDescription":"A form of meditations and disciplined life. It is a practice that originated in India but is practised widely throughout the world.","title":"","nomobile":"0","name":"sitecoretheme.banner-images"}'
      ));
    }
    $db->query("UPDATE `engine4_core_content` SET  `order` =  '2' WHERE  `engine4_core_content`.`page_id` = $member_home_page_id AND `engine4_core_content`.`name` = 'main' LIMIT 1;");

    if (Engine_Api::_()->hasModuleBootstrap('spectacular')) {
       $db->query("DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`page_id` = $member_home_page_id AND `engine4_core_content`.`name` = 'spectacular.banner-images' LIMIT 1;");
    }

    if (Engine_Api::_()->hasModuleBootstrap('captivate')) {
       $db->query("DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`page_id` = $member_home_page_id AND `engine4_core_content`.`name` = 'captivate.banner-images' LIMIT 1;");
    }
 }
}
}

}
