<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegdpr
 * @copyright  Copyright 2017-2021 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Contact.php 2018-05-10 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitegdpr_Form_Contact extends Engine_Form
{

  public function init()
  {
    $this->addElement('Text', 'first_name', array(
      'label' => 'First Name',
      'maxlength' => '64',
      'allowEmpty' => false,
      'required' => true,
      'filters' => array(
        'StripTags',
        new Engine_Filter_Censor(),
        new Engine_Filter_StringLength(array('max' => '64')),
      ),
    ));

    $this->addElement('Text', 'last_name', array(
      'label' => 'Last Name',
      'maxlength' => '64',
      'allowEmpty' => false,
      'required' => true,
      'filters' => array(
        'StripTags',
        new Engine_Filter_Censor(),
        new Engine_Filter_StringLength(array('max' => '64')),
      ),
    ));

    $this->addElement('Text', 'email', array(
      'label' => 'Email',
      'maxlength' => '64',
      'allowEmpty' => false,
      'required' => true,
      'validators' => array(
        'EmailAddress'
      )
    ));
    $this->email->getValidator('EmailAddress')->getHostnameValidator()->setValidateTld(false);

    $this->addElement('Textarea', 'message', array(
      'label' => 'Message',
      'maxlength' => '1024',
    ));

    $this->addElement('Hidden', 'form_type', array(
    ));

    $this->addElement('Button', 'submit', array(
      'label' => 'Submit',
      'type' => 'submit',
      'ignore' => true,
    ));

    $this->addElement('Cancel', 'cancel', array(
      'label' => 'cancel',
      'link' => true,
      'prependText' => ' or ',
      'onclick' => 'parent.Smoothbox.close();'
    ));
    $this->addDisplayGroup(array('submit', 'cancel'), 'buttons');
  }

}
?>

