<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegdpr
 * @copyright  Copyright 2017-2021 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: CookiesLogs.php 2018-05-10 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegdpr_Model_DbTable_CookiesLogs extends Engine_Db_Table
{

  protected $_name = 'sitegdpr_cookies_logs';
  protected $_rowClass = 'Sitegdpr_Model_CookiesLog';

  public function saveCookies($cookie)
  {
    $cookieLogId = $this->getCookieId($cookie);
    if( $cookieLogId ) {
      $item = Engine_Api::_()->getItem('sitegdpr_cookiesLog', $cookieLogId);
      if( empty($item) ) {
        return;
      } else {
        $item->last_used = date('Y-m-d H:i:s');
        $item->save();
      }
    } else {
      $db = $this->getAdapter();
      $db->beginTransaction();
      try {
        $table = $this->createRow();
        $table->cookie_name = $cookie;
        $table->last_used = date('Y-m-d H:i:s');
        $table->save();
        $db->commit();
      } catch( Exception $e ) {
        $db->rollBack();
        throw $e;
      }
    }
  }

  public function getCookieId($cookie)
  {
    $select = $this->select();
    $select->from($this->info('name'), 'cookieslog_id')->
      where('cookie_name =?', $cookie);
    $result = $select->query()->fetch();
    $cookiesLogId = $result['cookieslog_id'];
    if( $cookiesLogId ) {
      return $cookiesLogId;
    }
    return false;
  }

}
