<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegdpr
 * @copyright  Copyright 2017-2021 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 2018-05-10 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegdpr_Plugin_Core extends Zend_Controller_Plugin_Abstract
{

  function postDispatch(Zend_Controller_Request_Abstract $request)
  {
    $allCookies = $_COOKIE;
    $cookies = array_keys($allCookies);
    foreach( $cookies as $cookie ) {
      Engine_Api::_()->getDbtable('cookiesLogs', 'sitegdpr')->saveCookies($cookie);
    }
    if( empty($_SESSION['isUnapprovedCookiesSet']) ) {
      $viewer = Engine_Api::_()->user()->getViewer();

      if( !empty($viewer->getIdentity()) ) {
        $viewerId = $viewer->getIdentity();
        $UnapprovedCookies = Engine_Api::_()->getApi('core', 'sitegdpr')->UnapprovedCookies($viewerId);
      } elseif( !empty($_SESSION['privacy_preferences']) ) {
        $privacyPreferences = $_SESSION['privacy_preferences'];
        $UnapprovedCookies = Engine_Api::_()->getApi('core', 'sitegdpr')->UnapprovedCookies(0, $privacyPreferences);
      } else {
        return;
      }

      $_SESSION['UnapprovedCookies'] = $UnapprovedCookies;
      $_SESSION['isUnapprovedCookiesSet'] = true;
    }

    foreach( $_SESSION['UnapprovedCookies'] as $cookie ) {
      $cookieArr = explode('||', $cookie);
      $cookieName = trim($cookieArr[0]);
      $cookieDomain = trim($cookieArr[1]);

      if( isset($_COOKIE[$cookieName]) ) {
        if( !empty($cookieDomain) ) {
          setcookie($cookieName, "", time() - 3600, "/", $cookieDomain);
        } else {
          setcookie($cookieName, "", time() - 3600, "/");
        }
      }
    }
  }

  public function saveCookies($cookie)
  {
    $table = Engine_Api::_()->getDbtable('privacyCenterComponents', 'sitegdpr');
  }

}
