<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegdpr
 * @copyright  Copyright 2017-2021 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2018-05-10 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitegdpr_Widget_CookiesBannerController extends Engine_Content_Widget_Abstract {

    public function indexAction() {
      $coreSettings = Engine_Api::_()->getApi('settings', 'core');
      $this->view->bannerText = $coreSettings->getSetting('gdpr.cookies.general.bannerText', 'This website uses cookies to ensure you get the best experience on our website.');
      $this->view->privacyLinkText = $coreSettings->getSetting('gdpr.cookies.general.privacyLinkText', 'To learn more about our privacy policy');
      $this->view->privacyLink = $coreSettings->getSetting('gdpr.cookies.general.privacyLink', '/help/privacy');
      $this->view->privacyLinkLabel = $coreSettings->getSetting('gdpr.cookies.general.privacyLinkLabel', 'Click here');
      $this->view->agreeLabel = $coreSettings->getSetting('gdpr.cookies.general.agreeLabel', 'I Agree');
      $this->view->preferenceLabel = $coreSettings->getSetting('gdpr.cookies.general.preferenceLabel', 'Privacy Preferences');
      $this->view->bannerPostion = $coreSettings->getSetting('gdpr.bannerPostion');

      $this->view->cookiesCategories = Engine_Api::_()->getDbtable('cookiesCategories', 'sitegdpr')->getCategories(array('enabled' => 1));
      $this->view->consents = Engine_Api::_()->getDbtable('consents', 'sitegdpr')->getConsents(array('enabled' => 1));

      $this->view->preferenceSaved = false;
      if( isset($_SESSION['privacy_preferences']) ) {
        $this->view->preferenceSaved = true;
      }

      $this->view->excludedCookies = array();
      if( !empty($_SESSION['UnapprovedCookies']) ) {
        $this->view->excludedCookies = $_SESSION['UnapprovedCookies'];
      }

      $this->view->userPreferences = false;
      $this->view->viewerId = 0;
      if( !empty(Engine_Api::_()->user()->getViewer()->getIdentity()) ) {
        $this->view->viewerId = $viewerId = Engine_Api::_()->user()->getViewer()->getIdentity();
        $this->view->userPreferences = Engine_Api::_()->getDbtable('userPreferences', 'sitegdpr')->getPreferences($viewerId);
        $preferenceTable = Engine_Api::_()->getDbtable('userPreferences', 'sitegdpr');

        if( $preferenceTable->alreadyExists($viewerId) ) {
         $this->view->preferenceSaved = true;
      //   $this->view->excludedCookies = Engine_Api::_()->getApi('core', 'sitegdpr')->UnapprovedCookies($viewerId);
        } else {
          $this->view->preferenceSaved = false;
        }
      }
    }


}
