<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegifplayer
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Gifintegration.php 2017-05-15 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegifplayer_Form_Admin_Gifintegration extends Engine_Form
{
  public function init()
  {
    $productType = 'sitegifplayer';
    $this->setTitle('GIPHY Integration Setting')
      ->setDescription('These settings affect all users in your community.');

    $coreSettings = Engine_Api::_()->getApi('settings', 'core');

    $this->addElement('Text', "sitegifplayer_giphy_apikey", array(
      'label' => 'GIPHY API Key',
      'description' => "Enter the GIPHY API key. [Note: You can create GIPHY API Key from <a target='_blank' href='https://developers.giphy.com/dashboard/?create=true'>here</a>. If you already have the key, then simply get it from <a target='_blank' href='https://developers.giphy.com/dashboard'>here</a>.]",
      'allowEmpty' => false,
      'required' => true,
      'value' => $coreSettings->getSetting('sitegifplayer.giphy.apikey', ''),
    ));
    $this->getElement('sitegifplayer_giphy_apikey')->getDecorator('Description')->setOptions(array('placement' => 'PREPEND', 'escape' => false));

    $this->addElement('Radio', "sitegifplayer_giphy_search", array(
      'label' => 'Allow Importing of GIF Images',
      'description' => 'Do you want to enable importing of GIF images by members of your site? In this case, by default these images are marked as “Not Visible” in gif attachment box.',
      'multiOptions' => array(
        3 => 'Allow members to search GIF images from GIPHY. Display 25 trending GIF images followed by GIF images added by admin.',
        2 => 'Allow members to search GIF images from GIPHY. Display GIF images added by admin followed by 25 trending GIF images.',
        1 => 'Allow members to search GIF images from GIPHY.',
        0 => 'No, members are not allowed to search GIF images from GIPHY.'
      ),
      'value' => $coreSettings->getSetting('sitegifplayer.giphy.search', 3),
    ));
    $this->getElement('sitegifplayer_giphy_search')->getDecorator('Description')->setOptions(array('placement' => 'PREPEND', 'escape' => false));

    $this->addElement('Button', 'submit', array(
      'label' => 'Save Changes',
      'type' => 'submit',
      'ignore' => true
    ));
  }

}
