<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegifplayer
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Add.php 6590 2016-07-07 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegifplayer_Form_Admin_Gifphoto_Add extends Engine_Form
{
  public function init()
  {

    // Init form
    $this
      ->setTitle('Add GIF Images')
      ->setDescription('Upload GIF photo from your computer to add to gif photos collection.')
      ->setAttrib('id', 'form-upload')
      ->setAttrib('name', 'admin_gifphoto_add_more')
      ->setAttrib('enctype', 'multipart/form-data')
      ->setAttrib('class', 'global_form')
      ->setAction(Zend_Controller_Front::getInstance()->getRouter()->assemble(array()))
    ;
    $this->addElement('Text', 'title', array(
      'label' => 'Add Search Keywords',
      'autocomplete' => 'off',
      'allowEmpty' => false,
      'required' => true,
      'description' => 'Enter the keywords for the added GIF images and separate them with commas. These keywords will be used by your site members to search these GIF images on your website.',
      'filters' => array(
        'StripTags',
        new Engine_Filter_Censor(),
      ),
    ));
    $this->title->getDecorator("Description")->setOption("placement", "append");

    $this->addElement('File', 'photo', array(
      'label' => 'File Upload',
      'required' => true,
      'description' => 'Click "Browse..." to select the file you would like to upload.',
      'validators' => array(
        array('Extension', false, 'jpg,jpeg,png,gif'),
      )
    ));
    $this->photo->getDecorator("Description")->setOption("placement", "append");

    // Init submit
    $this->addElement('Button', 'submit', array(
      'label' => 'Save',
      'type' => 'submit',
      'order' => 999
    ));
  }

}
