<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegifplayer
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Gifphoto.php 6590 2016-07-07 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegifplayer_Model_Photo extends Core_Model_Item_Abstract
{

  public $search = false;
  protected $_searchTriggers = false;

  public function getSearchKeywords()
  {
    return parent::getTitle();
  }

  public function getTitle()
  {
    
  }

  public function getParent($recurseType = null)
  {
    return new User_Model_User(array());
  }

    public function getOwner($recurseType = null)
  {
    return Engine_Api::_()->user()->getViewer();
  }

  /**
   * Gets a url to the current photo representing this item. Return null if none
   * set
   *
   * @param string The photo type (null -> main, thumb, icon, etc);
   * @return string The photo url
   */
  public function getPhotoUrl($type = null, $size = 0)
  {
    $photo_id = $this->file_id;
    if( !$this->file_id && $this->code ) {
      return sprintf(Sitegifplayer_Api_Core::GIPHY_MEDIA_URL, $this->code);
    }
    if( !$photo_id ) {
      return null;
    }

    $file = Engine_Api::_()->getItemTable('storage_file')->getFile($photo_id, $type);
    if( !$file ) {
      return null;
    }

    if ($size) {
      $params = array('width' => 0, 'height' => 0 );
      if (isset($file->params) && !empty($file->params)) {
        $paramsString = $file->params;
      }
      if (isset($paramsString) && !empty($paramsString)) {
        $params = Zend_Json_Decoder::decode($paramsString);
      }
        
      return array(
        'url' => $file->map(),
        'params' => $params
      );
    }

    return $file->map();
  }

  public function setPhoto($requestFile)
  {
    if( $requestFile instanceof Zend_Form_Element_File ) {
      $file = $requestFile->getFileName();
      $fileName = $file;
    } else if( $requestFile instanceof Storage_Model_File ) {
      $file = $requestFile->temporary();
      $fileName = $requestFile->name;
    } else if( $requestFile instanceof Core_Model_Item_Abstract && !empty($requestFile->file_id) ) {
      $tmpRow = Engine_Api::_()->getItem('storage_file', $requestFile->file_id);
      $file = $tmpRow->temporary();
      $fileName = $tmpRow->name;
    } else if( is_array($requestFile) && !empty($requestFile['tmp_name']) ) {
      $file = $requestFile['tmp_name'];
      $fileName = $requestFile['name'];
    } else if( is_string($requestFile) ) {
      $file = $requestFile;
      $fileName = $requestFile;
    } else {
      throw new Core_Model_Exception('invalid argument passed to setPhoto');
    }

    if( !$fileName ) {
      $fileName = basename($file);
    }

    $extension = ltrim(strrchr(basename($fileName), '.'), '.');
    $base = rtrim(substr(basename($fileName), 0, strrpos(basename($fileName), '.')), '.');
    $path = APPLICATION_PATH . DIRECTORY_SEPARATOR . 'temporary';

    // Save
    $filesTable = Engine_Api::_()->getDbtable('files', 'storage');

    // Resize image (main)
    $bigIconPath = $path . DIRECTORY_SEPARATOR . $base . '_b-i.' . $extension;
    $image = Engine_Image::factory();
    $image->open($file)
      ->resize(520, 520)
      ->write($bigIconPath)
      ->destroy();
    // Store
    $bigIcon = $filesTable->createSystemFile($bigIconPath);
    // Remove temp files
    @unlink($bigIconPath);
    if( empty($this->title) ) {
      $this->title = trim(str_replace(array('-', '_'), ' ', preg_replace('/[0-9]+/', '', $base)));
    }
    $this->file_id = $bigIcon->getIdentity();
    $this->save();
    return $this;
  }

  public function hasInProgress()
  {
    return !$this->file_id && $this->code;
  }

}
