<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegifplayer
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 * @version    $Id: Encode.php 10216 2014-05-14 19:49:23Z andres $
 * @author     Jung
 */

/**
 * @category   Application_Extensions
 * @package    Sitegifplayer
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 */
class Sitegifplayer_Plugin_Job_Import extends Core_Plugin_Job_Abstract
{
  protected function _execute()
  {
    // Get job and params
    $job = $this->getJob();

    // No photo id?
    if( !($photo_id = $this->getParam('photo_id')) ) {
      $this->_setState('failed', 'No gif photo identity provided.');
      $this->_setWasIdle();
      return;
    }
    if( !($file = $this->getParam('file')) ) {
      $this->_setState('failed', 'No gif photo fiile provided.');
      $this->_setWasIdle();
      return;
    }

    // Get photo object
    $photo = Engine_Api::_()->getItem('sitegifplayer_photo', $photo_id);
    if( !$photo || !($photo instanceof Sitegifplayer_Model_Photo) ) {
      $this->_setState('failed', 'Sitegifplayer is missing.');
      $this->_setWasIdle();
      return;
    }

    // Check photo status
    if( $photo->file_id ) {
      $this->_setIsComplete(true);
      return;
    }
    ini_set('memory_limit', '1024M');
    // Process
    try {
      $photo->setPhoto($file);
      $this->_setIsComplete(true);
    } catch( Exception $e ) {
      $this->_setState('failed', 'Exception: ' . $e->getMessage());
    }
  }

}
