<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegifplayer
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminGifphotoController.php 6590 2016-07-07 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegifplayer_AdminGifphotoController extends Core_Controller_Action_Admin
{
  public function indexAction()
  {
    //GET NAVIGATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sitegifplayer_admin_main', array(), 'sitegifplayer_admin_main_mange_photos');

    $this->view->formFilter = $formFilter = new Sitegifplayer_Form_Admin_Gifphoto_Filter();
    $params = array();
    $requestParams = $this->_getAllParams();
    $requestParams = array_merge(array('limit' => 20), $requestParams);
    if( $formFilter->isValid($requestParams) ) {
      $params = $formFilter->getValues();
    }
    $this->view->filterValues = $params;
    $page = $this->_getParam('page', 1);
    $params = array_merge(array('limit' => 20, 'page' => $page, 'ignoreFile' => 1), $params);
    $this->view->assign($params);
    $this->view->paginator = Engine_Api::_()->getItemTable('sitegifplayer_photo')->getPaginator($params);
  }

  public function deleteAction()
  {
    //LAYOUT
    $this->_helper->layout->setLayout('admin-simple');
    $this->view->photo_id = $photo_id = $this->_getParam('photo_id');

    if( !$this->getRequest()->isPost() ) {
      return;
    }
    $values = $this->getRequest()->getPost();

    if( $values['confirm'] != $photo_id ) {
      return;
    }

    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();

    try {
      $photo = Engine_Api::_()->getItem('sitegifplayer_photo', $photo_id);
      $photo->delete();

      $db->commit();
    } catch( Exception $ex ) {
      $db->rollBack();
      throw $ex;
    }
    $this->_forward('success', 'utility', 'core', array(
      'smoothboxClose' => 10,
      'parentRefresh' => 10,
      'messages' => array(Zend_Registry::get('Zend_Translate')->_('Deleted'))
    ));
  }

  public function editAction()
  {
    //LAYOUT
    $this->_helper->layout->setLayout('admin-simple');
    $this->view->photo_id = $photo_id = $this->_getParam('photo_id');
    // Get form
    $this->view->form = $form = new Sitegifplayer_Form_Admin_Gifphoto_Edit();
    $photo = Engine_Api::_()->getItem('sitegifplayer_photo', $photo_id);
    if( !$this->getRequest()->isPost() ) {
      $form->populate($photo->toArray());
      return;
    }

    if( !$form->isValid($this->getRequest()->getPost()) ) {
      return;
    }

    // Process
    $values = $form->getValues();
    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    try {
      $photo->setFromArray($values);
      $photo->save();

      $db->commit();
    } catch( Exception $ex ) {
      $db->rollBack();
      throw $ex;
    }
    $this->_forward('success', 'utility', 'core', array(
      'smoothboxClose' => 10,
      'parentRefresh' => 10,
      'messages' => array(Zend_Registry::get('Zend_Translate')->_('Saved Changes!'))
    ));
  }

  //ACTION FOR UPDATE ORDER 
  public function updateOrderAction()
  {
    //CHECK POST
    if( $this->getRequest()->isPost() ) {
      $db = Engine_Db_Table::getDefaultAdapter();
      $db->beginTransaction();
      $values = $_POST;
      try {
        foreach( $values['order'] as $key => $value ) {
          $row = Engine_Api::_()->getItem('sitegifplayer_photo', (int) $value);
          if( !empty($row) ) {
            $row->order = $key + 1;
            $row->save();
          }
        }

        $db->commit();
        $this->_redirect('admin/sitegifplayer/gifphoto');
      } catch( Exception $e ) {
        $db->rollBack();
        throw $e;
      }
    }
  }

  public function enabledAction()
  {

    $id = $this->_getParam('photo_id');
    if( !empty($id) ) {
      $item = Engine_Api::_()->getItem('sitegifplayer_photo', $id);
      $item->enabled = !$item->enabled;
      $item->save();
    }
    $this->_redirect('admin/sitegifplayer/gifphoto');
  }

  public function multiDeleteAction()
  {

    if( $this->getRequest()->isPost() ) {
      $values = $this->getRequest()->getPost();
      foreach( $values as $key => $photo_id ) {
        if( $key == 'delete_' . $photo_id ) {
          $db = Engine_Db_Table::getDefaultAdapter();
          $db->beginTransaction();
          try {
            $photo = Engine_Api::_()->getItem('sitegifplayer_photo', $photo_id);
            $photo->delete();
            $db->commit();
          } catch( Exception $ex ) {
            $db->rollBack();
            throw $ex;
          }
        }
      }
    }
    $this->_redirect('admin/sitegifplayer/gifphoto');
  }

  public function addMoreAction()
  {
    //GET NAVIGATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sitegifplayer_admin_main', array(), 'sitegifplayer_admin_main_mange_photos');

    // Get form
    $this->view->form = $form = new Sitegifplayer_Form_Admin_Gifphoto_Add();

    if( !$this->getRequest()->isPost() ) {
      return;
    }

    if( !$form->isValid($this->getRequest()->getPost()) ) {
      return;
    }

    $table = Engine_Api::_()->getItemTable('sitegifplayer_photo');
    $db = $table->getAdapter();
    $values = $form->getValues();
    $db->beginTransaction();

    try {
      $row = $table->createRow();
      $row->setFromArray($values);
      $row->enabled = 1;
      $row->setPhoto($form->photo);
      $row->save();
      $db->commit();
    } catch( Exception $e ) {
      $db->rollBack();
      throw $e;
    }

    $this->_helper->redirector->gotoRoute(array('action' => 'index'));
  }

  public function uploadGiphyUrlAction()
  {
    $this->view->form = $form = new Sitegifplayer_Form_Admin_Gifphoto_AddGiphyImageUrl();

    // Check if post
    if( !$this->getRequest()->isPost() ) {
      $this->view->status = false;
      $this->view->error = Zend_Registry::get('Zend_Translate')->_('Not post');
      return;
    }

    if( !$form->isValid($this->getRequest()->getPost()) && !$id ) {
      $this->view->status = false;
      $this->view->error = Zend_Registry::get('Zend_Translate')->_('Invalid data');
      return;
    }

    $values = $form->getValues();
    $gifCode = '';
    $photoTable = Engine_Api::_()->getDbtable('photos', 'sitegifplayer');
    preg_match('~https?://(?|media\.giphy\.com/media/([^ /]+)/giphy\.gif|i\.giphy\.com/([^ /]+)\.gif|giphy\.com/gifs/(?:.*-)?([^ /]+))~i', $values['url'], $matches);
    if( $matches[1] ) {
      $gifCode = $matches[1];
    }
    if( empty($gifCode) ) {
      $error = Zend_Registry::get('Zend_Translate')->_("Invalid giphy url. So, you can try with different url.");
      $form->getDecorator('errors')->setOption('escape', false);
      $form->addError($error);
      return;
    }
    if( $photoTable->getByCode($gifCode) ) {
      $error = Zend_Registry::get('Zend_Translate')->_("This image is already import. So, you can try with different url.");
      $form->getDecorator('errors')->setOption('escape', false);
      $form->addError($error);
      return;
    }
    ini_set('memory_limit', '1024M');
    $db = Engine_Api::_()->getDbtable('photos', 'sitegifplayer')->getAdapter();
    $db->beginTransaction();
    try {
      $photoTable->addPhoto($values['url'], array(
        'code' => $gifCode,
        'title' => $values['title']
      ));
      $db->commit();
    } catch( Core_Model_Exception $e ) {
      $db->rollBack();
      $this->view->status = false;
      $this->view->error = $this->view->translate($e->getMessage());
      throw $e;
      return;
    } catch( Exception $e ) {
      $db->rollBack();
      $this->view->status = false;
      $this->view->error = Zend_Registry::get('Zend_Translate')->_('An error occurred.');
      throw $e;
      return;
    }

    $this->_forward('success', 'utility', 'core', array(
      'smoothboxClose' => 10,
      'parentRefresh' => 10,
      'messages' => array('GIF Images Uploaded Successfully.')
    ));
  }

  public function addGiphyImagesAction()
  {
    $this->view->form = $form = new Sitegifplayer_Form_Admin_Gifphoto_AddGiphyImages();

    // Check if post
    if( !$this->getRequest()->isPost() ) {
      $this->view->status = false;
      $this->view->error = Zend_Registry::get('Zend_Translate')->_('Not post');
      return;
    }

    if( !$form->isValid($this->getRequest()->getPost()) && !$id ) {
      $this->view->status = false;
      $this->view->error = Zend_Registry::get('Zend_Translate')->_('Invalid data');
      return;
    }

    $values = $form->getValues();
    $gifAPi = new Sitegifplayer_Service_GiphyAPI();
    $results = $gifAPi->search($values['searchKeyword'], array('limit' => $values['limit']));
    $db = Engine_Api::_()->getDbtable('photos', 'sitegifplayer')->getAdapter();
    $photoTable = Engine_Api::_()->getDbtable('photos', 'sitegifplayer');
    foreach( $results as $row ) {
      $db->beginTransaction();
      try {
        $code = $row['code'];
        if( empty($row['imgPath']) || $photoTable->getByCode($code) ) {
          continue;
        }
        $url = sprintf(Sitegifplayer_Api_Core::GIPHY_MEDIA_URL, $code);
        $photoTable->addPhoto($url, array(
          'code' => $code,
          'title' => $values['title']
          ), true);
        $db->commit();
      } catch( Core_Model_Exception $e ) {
        $db->rollBack();
        $this->view->status = false;
        $this->view->error = $this->view->translate($e->getMessage());
        throw $e;
        return;
      } catch( Exception $e ) {
        $db->rollBack();
        $this->view->status = false;
        $this->view->error = Zend_Registry::get('Zend_Translate')->_('An error occurred.');
        throw $e;
        return;
      }
    }
    $this->_forward('success', 'utility', 'core', array(
      'smoothboxClose' => 10,
      'parentRefresh' => 10,
      'messages' => array('GIF Images Uploaded Successfully.')
    ));
  }

}
