<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitereaction
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: IndexController.php 6590 2016-07-07 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegifplayer_IndexController extends Siteapi_Controller_Action_Standard {
    /*
     * @return array
     */

    public function loadGifAction() {

        $giphyImages = array();
        $settings = Engine_Api::_()->getApi('settings', 'core');
        $settings->getSetting('sitegifplayer.giphy.apikey', '');

        if ($settings->getSetting('sitegifplayer.giphy.apikey', '')) {
            $gifBrowseSetting = $settings->getSetting('sitegifplayer.giphy.search', 3);
            try {
                //Get Gif image from Giphy website...........
                Engine_Loader::loadClass('Sitegifplayer_Service_GiphyAPI');
                $gifAPi = new Sitegifplayer_Service_GiphyAPI();
                $giphyImages = $gifAPi->trending();
                //Uploaded Gif image...........
                $uploadedGif=array();
                $paginator = Engine_Api::_()->getItemTable('sitegifplayer_photo')->getPaginator(array(
            'limit' => 100,
            'enabled' => 1
        ));
                foreach ($paginator as $gif)
                {
                    $tempGiphy['imgPath'] = $gif->getPhotoUrl();
                    $tempGiphy['title'] = $gif->getSearchKeywords();
                    $tempGiphy['code'] = $gif->code;
                    $uploadedGif[] = $tempGiphy;
                }
                
                switch ($gifBrowseSetting) {
                    case 3:
                        if(count($uploadedGif) > 0)
                            $giphyImages = array_merge($giphyImages, $uploadedGif);
                        else
                            $giphyImages = $giphyImages;
                        break;
                    case 2:
                        if(count($uploadedGif) > 0)
                            $giphyImages = array_merge($uploadedGif, $giphyImages);
                        else
                            $giphyImages = $giphyImages;
                        break;
                    case 1:
                        $giphyImages = $giphyImages;
                        break;
                    case 0:
                        $giphyImages = $uploadedGif;
                        break;
                    
                }
                $response['response'] = $giphyImages;
                $this->respondWithSuccess($response, true);
            } catch (Exception $e) {
                $this->respondWithError('internal_server_error', $e->getMessage());
            }
        }
    }

    /*
     * @return array :Uploaded Gif image from admin panel
     */

    public function myGifAction() {
        //Uploaded Gif Image
        $paginator = Engine_Api::_()->getItemTable('sitegifplayer_photo')->getPaginator(array(
            'limit' => 100,
            'enabled' => 1
        ));

        $response = array();
        $response["getTotalItemCount"] = $paginator->getTotalItemCount();
        foreach ($paginator as $gif) {
            $giphyImages['imgPath'] = $gif->getPhotoUrl();
            $giphyImages['title'] = $gif->getSearchKeywords();
            $giphyImages['code'] = $gif->code;
            $response['response'][] = $giphyImages;
        }

        $this->respondWithSuccess($response, true);
    }

    /*
     * @return array : gif api key and admin settings values
     */

    public function gifSettingsAction() {
        $response = array();
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();
        if (empty($viewer_id))
            $this->respondWithError('unauthorized', 'Please login first');
        if (!empty($viewer_id))
            $id = $viewer->level_id;

        $settings = Engine_Api::_()->getApi('settings', 'core');
        $response['giphyApikey'] = $settings->getSetting('sitegifplayer.giphy.apikey', '');
        $response['giphyPlayDuration'] = $settings->getSetting('sitegifplayer.duration');
         $response['giphySearch'] = $settings->getSetting('sitegifplayer.giphy.search', 1);

        $permissionsTable = Engine_Api::_()->getDbtable('permissions', 'authorization');
        $response['allowToFeed'] = $permissionsTable->getAllowed('sitegifplayer', $id, 'allow_gif_feed');
        $response['allowTocomment'] = $permissionsTable->getAllowed('sitegifplayer', $id, 'allow_gif_comment');
       
        $this->respondWithSuccess($response, true);
    }

    public function searchAction() {
        $search = $this->_getParam('search', '');
        $response=array();
        $settings = Engine_Api::_()->getApi('settings', 'core');
        if (empty($search)) {
             $this->respondWithSuccess($response, true);
        }
        Engine_Loader::loadClass('Sitegifplayer_Service_GiphyAPI');
        $gifBrowseSetting = $settings->getSetting('sitegifplayer.giphy.search', 3);
        try {
            $gifAPi = new Sitegifplayer_Service_GiphyAPI();
            $giphyImages = $gifAPi->search($search);
             //Uploaded Gif image...........
            $uploadedGif=array();
            $paginator = Engine_Api::_()->getItemTable('sitegifplayer_photo')->getPaginator(array(
                'limit' => 100,
                'enabled' => 1,
                'search' => $search,
            ));

            foreach ($paginator as $gif)
            {
                $tempGiphy['imgPath'] = $gif->getPhotoUrl();
                $tempGiphy['title'] = $gif->getSearchKeywords();
                $tempGiphy['code'] = $gif->code;
                $uploadedGif[] = $tempGiphy;
            }
                
            switch ($gifBrowseSetting) {
                case 3:
                    if(count($uploadedGif) > 0)
                        $giphyImages = array_merge($giphyImages, $uploadedGif);
                    else
                        $giphyImages = $giphyImages;
                    break;
                case 2:
                    if(count($uploadedGif) > 0)
                        $giphyImages = array_merge($uploadedGif, $giphyImages);
                    else
                        $giphyImages = $giphyImages;
                    break;
                case 1:
                    $giphyImages = $giphyImages;
                    break;
                case 0:
                    $giphyImages = $uploadedGif;
                    break;     
            }
                
            $response['response'] = $giphyImages;
            $this->respondWithSuccess($response, true);
        } catch (Exception $e) {
            $this->respondWithError('internal_server_error', $e->getMessage());
        }
    }
}
