<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegateway
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    install.php 2015-09-10 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegifplayer_Installer extends Engine_Package_Installer_Module
{
    function onInstall() {
        if ($this->getOperation()->getOperationType() == 'upgrade') {
            $this->upgradeVersion();
        }

        parent::onInstall();
    }

    private function upgradeVersion() {
        $db = $this->getDb();
        $select = new Zend_Db_Select($db);
        $version = $select
            ->from('engine4_core_modules', 'version')
            ->where('name = ?', 'sitegifplayer')
            ->query()
            ->fetchColumn();

        if ($this->checkVersion('5.6.1', $version) == 1) {
            $select = new Zend_Db_Select($db);
            $storageData = $select->from('engine4_storage_files')->where('type like ?', '%thumb.gif-%')->query()->fetchAll();
            foreach ($storageData as $key => $files) {    
                $file_id = $files['file_id'];
                $type = 'thumb.gif-' . substr(str_replace('thumb.gif-', '', $files['type']), 0, 6);
                $db->query("UPDATE  `engine4_storage_files` SET  `engine4_storage_files`.`type` =  '$type' WHERE  `engine4_storage_files`.`file_id` = $file_id;");
            }

        }
    }

    private function checkVersion($databaseVersion, $checkDependancyVersion) {
        $f = $databaseVersion;
        $s = $checkDependancyVersion;
        if (strcasecmp($f, $s) == 0)
            return -1;

        $fArr = explode(".", $f);
        $sArr = explode('.', $s);
        if (count($fArr) <= count($sArr))
            $count = count($fArr);
        else
            $count = count($sArr);

        for ($i = 0; $i < $count; $i++) {
            $fValue = $fArr[$i];
            $sValue = $sArr[$i];
            if (is_numeric($fValue) && is_numeric($sValue)) {
                if ($fValue > $sValue)
                    return 1;
                elseif ($fValue < $sValue)
                    return 0;
                else {
                    if (($i + 1) == $count) {
                        return -1;
                    } else
                        continue;
                }
            }
            elseif (is_string($fValue) && is_numeric($sValue)) {
                $fsArr = explode("p", $fValue);

                if ($fsArr[0] > $sValue)
                    return 1;
                elseif ($fsArr[0] < $sValue)
                    return 0;
                else {
                    return 1;
                }
            } elseif (is_numeric($fValue) && is_string($sValue)) {
                $ssArr = explode("p", $sValue);

                if ($fValue > $ssArr[0])
                    return 1;
                elseif ($fValue < $ssArr[0])
                    return 0;
                else {
                    return 0;
                }
            } elseif (is_string($fValue) && is_string($sValue)) {
                $fsArr = explode("p", $fValue);
                $ssArr = explode("p", $sValue);
                if ($fsArr[0] > $ssArr[0])
                    return 1;
                elseif ($fsArr[0] < $ssArr[0])
                    return 0;
                else {
                    if ($fsArr[1] > $ssArr[1])
                        return 1;
                    elseif ($fsArr[1] < $ssArr[1])
                        return 0;
                    else {
                        return -1;
                    }
                }
            }
        }
    }
}
