<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecrowdfunding
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    IndexController.php 2015-09-17 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitecrowdfunding_ProfiletabController extends Siteapi_Controller_Action_Standard {

    public function init() {
//SET THE SUBJECT
        if (!Zend_Registry::isRegistered('Zend_Translate'))
            Engine_Api::_()->getApi('Core', 'siteapi')->setTranslate();

        Engine_Api::_()->getApi('Core', 'siteapi')->setView();
        Engine_Api::_()->getApi('Core', 'siteapi')->setLocal();


        if (0 !== ($project_id = (int) $this->_getParam('project_id')) && null !== ($project = Engine_Api::_()->getItem('sitecrowdfunding_project', $project_id)) && !Engine_Api::_()->core()->hasSubject()) {
            Engine_Api::_()->core()->setSubject($project);
            Engine_Api::_()->sitecrowdfunding()->setPaymentFlag($project_id);
        }
    }

    public function informationAction() {
        $this->validateRequestMethod();
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();

        if (!Engine_Api::_()->core()->hasSubject('sitecrowdfunding_project')) {
            $this->respondWithError("no_record");
        }
        $bodyParams=array();
        //GET PROJECT SUBJECT
        $project = Engine_Api::_()->core()->getSubject('sitecrowdfunding_project');

        $bodyParams['Basic Information']['Started By'] = $project->getOwner()->getTitle();
        $bodyParams['Basic Information']['Published On'] = date('M d, Y', strtotime($project->start_date));
        $bodyParams['Basic Information']['Funding Ends'] = date('M d, Y', strtotime($project->expiration_date));
        $bodyParams['Basic Information']['Backers'] = $project->backer_count;
        $bodyParams['Basic Information']['Likes'] = $project->like_count;
        $bodyParams['Basic Information']['Description'] = $project->description;
        $category = Engine_Api::_()->getItem('sitecrowdfunding_category', $project->category_id);
            if (!empty($category)) {
                 $bodyParams['Basic Information']['Category'] = $category->category_name;
            }
        
                    $profile_info = array();
            if (isset($project->profile_type) && !empty($project->profile_type)) {
                $profile_info = Engine_Api::_()->getApi('Siteapi_Core', 'sitecrowdfunding')->getInformation($project, 'sitecrowdfunding_project');
                if (count($profile_info) > 0)
                    $bodyParams['Profile Information'] = $profile_info;
            }

            if (isset($_REQUEST['field_order']) && !empty($_REQUEST['field_order'])) {
                foreach ($bodyParams as $key => $value) {
                    $bodyParams[$key] = Engine_Api::_()->getApi('Core', 'siteapi')->responseFormat($value);
                }
                $bodyParams = Engine_Api::_()->getApi('Core', 'siteapi')->responseFormat($bodyParams);
            }

            $this->respondWithSuccess($bodyParams);
    }

}
?>