<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupbadge
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Settings.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupbadge_Form_Admin_Settings extends Engine_Form {
 
  // IF YOU WANT TO SHOW CREATED ELEMENT ON PLUGIN ACTIVATION THEN INSERT THAT ELEMENT NAME IN THE BELOW ARRAY.
  public $_SHOWELEMENTSBEFOREACTIVATE = array(
      'submit_lsetting', 'environment_mode', 'include_in_package'
  );
  
  public function init() {
    $this
            ->setTitle('Global Settings')
            ->setDescription('These settings affect all members in your community.');

    $this->addElement('Text', 'sitegroupbadge_lsettings', array(
        'label' => 'Enter License key',
        'description' => "Please enter your license key that was provided to you when you purchased this plugin. If you do not know your license key, please contact the Support Team of SocialApps.tech from the Support section of your Account Area.(Key Format: XXXXXX-XXXXXX-XXXXXX )",
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupbadge.lsettings'),
    ));

    $global_settings_file = APPLICATION_PATH . '/application/settings/general.php';
    if (file_exists($global_settings_file)) {
      $generalConfig = include $global_settings_file;
    } else {
      $generalConfig = array();
    }

    if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
      $this->addElement('Checkbox', 'include_in_package', array(
          'label' => ' Do you want to enable badge for default package in the Groups Plugin which is created during the Group Plugin installation. (If enabled, badges will be enabled for the groups created in the default package.)',
          'description' => 'Enable badges for default Package',
          'value' => 1,
      ));
    }
    
    if ( ( !empty($generalConfig['environment_mode']) ) && ($generalConfig['environment_mode'] != 'development') ) {
      $this->addElement('Checkbox', 'environment_mode', array(
          'label' => 'Your community is currently in "Production Mode". We recommend that you momentarily switch your site to "Development Mode" so that the CSS of this plugin renders fine as soon as the plugin is installed. After completely installing this plugin and visiting few groups of your site, you may again change the System Mode back to "Production Mode" from the Admin Panel Home. (In Production Mode, caching prevents CSS of new plugins to be rendered immediately after installation.)',
          'description' => 'System Mode',
          //'value' => 1,
      ));
    } else {
      $this->addElement('Hidden', 'environment_mode', array('order' => 990, 'value' => 0));
    }

    // Add submit button
    $this->addElement('Button', 'submit_lsetting', array(
        'label' => 'Activate Your Plugin Now',
        'type' => 'submit',
        'ignore' => true
    ));
    
    $this->addElement('Radio', 'sitegroupbadge_badge_show_menu', array(
        'label' => 'Badges Link',
        'description' => 'Do you want to show the Badges link on Groups Navigation Menu? (You might want to show this if Badges from Groups are an important component on your website. This link will lead to a widgetized group listing all Group Badges, with a search form for Group Badges and multiple widgets.)',
        'multiOptions' => array(
            1 => 'Yes',
            0 => 'No'
        ),
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupbadge.badge.show.menu', 1),
    ));
    
    $this->addElement('Radio', 'sitegroupbadge_badgeprofile_widgets', array(
        'label' => 'Details On Badge',
        'description' => 'Select the details you want to show on Badges.',
        'multiOptions' => array(
            2 => 'Both Badge Title and Image',
            1 => 'Only Badge Image',
            0 => 'Only Badge Title'
        ),
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupbadge.badgeprofile.widgets', 2),
    ));

    $this->addElement('Radio', 'sitegroupbadge_seaching_bybadge', array(
        'label' => 'Badge in Search',
        'description' => 'Do you want the Badge field in the search form widget at "Groups Home" and "Browse Groups" groups?',
        'multiOptions' => array(
            1 => 'Yes',
            0 => 'No'
        ),
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupbadge.seaching.bybadge', 1),
    ));
		
			$this->addElement('Text', 'sitegroupbadge_manifestUrl', array(
        'label' => 'Group Badges URL alternate text for "group-badges"',
        'allowEmpty' => false,
        'required' => true,
        'description' => 'Please enter the text below which you want to display in place of "groupbadges" in the URLs of this plugin.',
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupbadge.manifestUrl', "group-badges"),
    ));

    $this->addElement('Button', 'submit', array(
        'label' => 'Save Changes',
        'type' => 'submit',
        'ignore' => true
    ));
  }

}
?>