<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupbadge
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupbadge_Installer extends Engine_Package_Installer_Module {

  function onPreInstall() {
    $db = $this->getDb();

    //CHECK THAT SITEGROUP PLUGIN IS ACTIVATED OR NOT
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_settings')
            ->where('name = ?', 'sitegroup.is.active')
            ->limit(1);
    $sitegroup_settings = $select->query()->fetchAll();
    if (!empty($sitegroup_settings)) {
      $sitegroup_is_active = $sitegroup_settings[0]['value'];
    } else {
      $sitegroup_is_active = 0;
    }

    //CHECK THAT SITEGROUP PLUGIN IS INSTALLED OR NOT
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'sitegroup')
            ->where('enabled = ?', 1);
    $check_sitegroup = $select->query()->fetchObject();
    if (!empty($check_sitegroup) && !empty($sitegroup_is_active)) {
      $PRODUCT_TYPE = 'sitegroupbadge';
      $PLUGIN_TITLE = 'Sitegroupbadge';
      $PLUGIN_VERSION = '5.4.1';
      $PLUGIN_CATEGORY = 'plugin';
      $PRODUCT_DESCRIPTION = 'Sitegroupbadge Plugin';
      $PRODUCT_TITLE = 'Groups - Badges Extension';
      $_PRODUCT_FINAL_FILE = 0;
      $sitegroup_plugin_version = '4.8.0'; 
      $SocialEngineAddOns_version = '4.8.9p12';
      $file_path = APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/ilicense.php";
      $is_file = file_exists($file_path);
      if (empty($is_file)) {
        include APPLICATION_PATH . "/application/modules/Sitegroup/controllers/license/license4.php";
      } else {
        include $file_path;
      }

      $groupTime = time();
      $db->query("INSERT IGNORE INTO `engine4_core_settings` (`name`, `value`) VALUES
			('sitegroupbadge.basetime', $groupTime ),
			('sitegroupbadge.isvar', 0 ),
			('sitegroupbadge.filepath', 'Sitegroupbadge/controllers/license/license2.php');");
      
      //PUT SITEGROUP BADGE WIDGET IN ADMIN CONTENT TABLE
      $select = new Zend_Db_Select($db);
      $select
              ->from('engine4_core_modules')
              ->where('name = ?', 'sitegroupbadge')
              ->where('version <= ?', '4.2.1');
      $is_enabled = $select->query()->fetchObject();
      if ( !empty($is_enabled) ) {
        $select = new Zend_Db_Select($db);
        $select_group = $select
                        ->from('engine4_core_pages', 'page_id')
                        ->where('name = ?', 'sitegroup_index_view')
                        ->limit(1);
        $group = $select_group->query()->fetchAll();
        if ( !empty($group) ) {
          $group_id = $group[0]['page_id'];
          $select = new Zend_Db_Select($db);
          $select_content = $select
                          ->from('engine4_sitegroup_admincontent')
                          ->where('group_id = ?', $group_id)
                          ->where('type = ?', 'widget')
                          ->where('name = ?', 'sitegroupbadge.badge-sitegroupbadge')
                          ->limit(1);
          $content = $select_content->query()->fetchAll();
          if ( empty($content) ) {
            $select = new Zend_Db_Select($db);
            $select_container = $select
                            ->from('engine4_sitegroup_admincontent', 'admincontent_id')
                            ->where('group_id = ?', $group_id)
                            ->where('type = ?', 'container')
                            ->limit(1);
            $container = $select_container->query()->fetchAll();
            if ( !empty($container) ) {
              $container_id = $container[0]['admincontent_id'];
              $select = new Zend_Db_Select($db);
              $select_left = $select
                              ->from('engine4_sitegroup_admincontent')
                              ->where('parent_content_id = ?', $container_id)
                              ->where('type = ?', 'container')
                              ->where('name = ?', 'left')
                              ->limit(1);
              $left = $select_left->query()->fetchAll();
              if ( !empty($left) ) {
                $left_id = $left[0]['admincontent_id'];

                $db->insert('engine4_sitegroup_admincontent', array(
                    'group_id' => $group_id,
                    'type' => 'widget',
                    'name' => 'sitegroupbadge.badge-sitegroupbadge',
                    'parent_content_id' => ($left_id),
                    'order' => 16,
                    'params' => '{"title":"Badge","titleCount":"true"}',
                ));
              }
            }
          }
        }
      }
       parent::onPreInstall();
    } elseif (!empty($check_sitegroup) && empty($sitegroup_is_active)) {
      $baseUrl = $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getBaseUrl();
      $url_string = Zend_Controller_Front::getInstance()->getRequest()->getRequestUri();
      if (strstr($url_string, "manage/install")) {
        $calling_from = 'install';
      } else if (strstr($url_string, "manage/query")) {
        $calling_from = 'queary';
      }
      $explode_base_url = explode("/", $baseUrl);
      foreach ($explode_base_url as $url_key) {
        if ($url_key != 'install') {
          $core_final_url .= $url_key . '/';
        }
      }

     return $this->_error("<span style='color:red'>Note: You have installed the <a href='http://www.socialengineaddons.com/socialengine-groups-communities-plugin' target='_blank'>Groups / Communities Plugin</a> but not activated it on your site yet. Please activate it first before installing the Groups / Communities - Badges Extension.</span><br/> <a href='" . 'http://' . $core_final_url . "admin/sitegroup/settings/readme'>Click here</a> to activate the Groups Plugin.");
    } else {
      $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();
     return $this->_error("<span style='color:red'>Note: You have not installed the <a href='http://www.socialengineaddons.com/socialengine-groups-communities-plugin' target='_blank'>Groups / Communities Plugin</a> on your site yet. Please install it first before installing the <a href='http://www.socialengineaddons.com/groupextensions/socialengine-groups-communities-badges' target='_blank'>Groups / Communities - Badges Extension</a>.</span><br/> <a href='" . $base_url . "/manage'>Click here</a> to go Manage Packages.");
    }
  }
  
	function onInstall() {

    $db = $this->getDb();

		//CHECK THAT badge_id COLUMN EXIST OR NOT IN GROUP TABLE
		$column_exist = $db->query("SHOW COLUMNS FROM engine4_sitegroup_groups LIKE 'badge_id'")->fetch();
		$table_exist = $db->query("SHOW TABLES LIKE 'engine4_sitegroupbadge_badges'")->fetch();
		if (!empty($table_exist)) {
			if(empty($column_exist)){
				//ADD badge_id COLUMN TO GROUP TABLE
				$db->query("ALTER TABLE  `engine4_sitegroup_groups` ADD  `badge_id` INT NOT NULL DEFAULT  '0'");
			}
		}
		parent::onInstall();
	}

  public function onPostInstall() {

    $db = $this->getDb();
		$select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'sitemobile')
            ->where('enabled = ?', 1);
    $is_sitemobile_object = $select->query()->fetchObject();
    if(!empty($is_sitemobile_object)) {
			$db->query("INSERT IGNORE INTO `engine4_sitemobile_modules` (`name`, `visibility`) VALUES ('sitegroupbadge','1')");
			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_sitemobile_modules')
							->where('name = ?', 'sitegroupbadge')
							->where('integrated = ?', 0);
			$is_sitemobile_object = $select->query()->fetchObject();
      if($is_sitemobile_object)  {
				$actionName = Zend_Controller_Front::getInstance()->getRequest()->getActionName();
				$controllerName = Zend_Controller_Front::getInstance()->getRequest()->getControllerName();
				if($controllerName == 'manage' && $actionName == 'install') {
          $view = new Zend_View();
					$baseUrl = ( !empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://':'http://') .  $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
					$redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
					$redirector->gotoUrl($baseUrl . 'admin/sitemobile/module/enable-mobile/enable_mobile/1/name/sitegroupbadge/integrated/0/redirect/install');
				} 
      }
    } 
    
    //Work for the word changes in the group plugin .csv file.
    $actionName = Zend_Controller_Front::getInstance()->getRequest()->getActionName();
    $controllerName = Zend_Controller_Front::getInstance()->getRequest()->getControllerName();
    if($controllerName == 'manage' && ($actionName == 'install' || $actionName == 'query')) {
      $view = new Zend_View();
      $baseUrl = ( !empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://':'http://') .  $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
      $redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
      if ($actionName == 'install') {
        $redirector->gotoUrl($baseUrl . 'admin/sitegroup/settings/language/redirect/install');
      } else {
        $redirector->gotoUrl($baseUrl . 'admin/sitegroup/settings/language/redirect/query');
      }
    }
    
  }
}
?>