<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupdocument
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$isActive = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupdocument.isActivate', 0);
if ( empty($isActive) ) {
  return;
}

$categories = Engine_Api::_()->getDbTable('categories', 'sitegroup')->getCategories();
if (count($categories) != 0) {
  $categories_prepared[0] = "";
  foreach ($categories as $category) {
    $categories_prepared[$category->category_id] = $category->category_name;
  }
}

$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => 'Group Profile Documents',
        'description' => 'This widget forms the Documents tab on the Group Profile and displays the documents of the Group. It should be placed in the Tabbed Blocks area of the Group Profile.',
        'category' => 'Group Profile',
        'type' => 'widget',
        'name' => 'sitegroupdocument.profile-sitegroupdocuments',
        'defaultParams' => array(
            'title' => 'Documents',
        ),
    ),
    array(
        'title' => 'Group Profile Recent Documents',
        'description' => 'Displays list of Group’s recent documents. This widget should be placed on Group Profile.',
        'category' => 'Group Profile',
        'type' => 'widget',
        'name' => 'sitegroupdocument.recent-sitegroupdocuments',
        'defaultParams' => array(
            'title' => 'Most Recent Documents',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of documents to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
    array(
        'title' => 'Group Profile Popular Documents',
        'description' => 'Displays list of group’s most viewed documents. This widget should be placed on Group Profile.',
        'category' => 'Group Profile',
        'type' => 'widget',
        'name' => 'sitegroupdocument.popular-sitegroupdocuments',
        'defaultParams' => array(
            'title' => 'Most Popular Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of documents to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
    array(
        'title' => 'Group Profile Most Commented Documents',
        'description' => 'Displays list of group’s most commented documents. This widget should be placed on the Group Profile.',
        'category' => 'Group Profile',
        'type' => 'widget',
        'name' => 'sitegroupdocument.comment-sitegroupdocuments',
        'defaultParams' => array(
            'title' => 'Most Commented Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of documents to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
    array(
        'title' => 'Group Profile Most Liked Documents',
        'description' => 'Displays list of group’s most liked documents. This widget should be placed on the Group Profile.',
        'category' => 'Group Profile',
        'type' => 'widget',
        'name' => 'sitegroupdocument.like-sitegroupdocuments',
        'defaultParams' => array(
            'title' => 'Most Liked Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of documents to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
    array(
        'title' => 'Group Profile Top Rated Documents',
        'description' => 'Displays list of group’s top rated documents. This widget should be placed on Group Profile.',
        'category' => 'Group Profile',
        'type' => 'widget',
        'name' => 'sitegroupdocument.rate-sitegroupdocuments',
        'defaultParams' => array(
            'title' => 'Top Rated Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of documents to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
    array(
        'title' => 'Group Profile Featured Documents',
        'description' => 'Displays list of group’s featured documents. This widget should be placed on Group Profile.',
        'category' => 'Group Profile',
        'type' => 'widget',
        'name' => 'sitegroupdocument.featurelist-sitegroupdocuments',
        'defaultParams' => array(
            'title' => 'Featured Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of documents to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),

    array(
        'title' => 'Recent Documents',
        'description' => 'Displays the recent documents of the site.',
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroupdocument.homerecent-sitegroupdocuments',
        'defaultParams' => array(
            'title' => 'Recent Documents'
        ),
         'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of documents to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
        ),
    ),
	array(
		'title' => 'Group Document Social Share Buttons Buttons',
		'description' => "Contains Social Sharing buttons and enables users to easily share Group Documents on their favorite Social Networks. This widget should be placed on the Group Document View Page. You can customize the code for social sharing buttons from Global Settings of this plugin by adding your own code generated from: <a href='http://www.addthis.com' target='_blank'>http://www.addthis.com</a>",
		'category' => 'Groups',
		'type' => 'widget',
		'name' => 'sitegroupdocument.socialshare-sitegroupdocuments',
		'defaultParams' => array(
				'title' => 'Social Share',
				'titleCount' => true,
		),
    'requirements' => array(
      'subject' => 'sitegroupdocument',
    ),
		'adminForm' => array(
			'elements' => array(
				array(
						'Hidden',
						'nomobile',
						array(
								'label' => '',
                                'order' => 1125
						)
				),
			),
		),
	),
    array(
        'title' => 'Recent Documents from Group',
        'description' => 'Displays recent Group Documents corresponding to the Group of which the document is being viewed. You can choose the number of entries to be shown. This widget should be placed on Group Document View Page.',
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroupdocument.viewrecent-sitegroupdocuments',
        'defaultParams' => array(
            'title' => ''
        ),
         'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of documents to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
					),
        ),
    ),

    array(
			'title' => 'Search Group Documents form',
			'description' => 'Displays the form for searching Group Documents on the basis of various filters. You can edit the fields to be available in this form.',
			'category' => 'Groups',
			'type' => 'widget',
			'name' => 'sitegroupdocument.search-sitegroupdocument',
			'defaultParams' => array(
					'title' => '',
          'search_column' => array("0" => "1", "1" => "2", "2" => "3", "3" => "4", "4" => '5', "5" => "6"),
					'titleCount' => true,

			),
			'adminForm' => array(
              'elements' => array(
							array(
									'MultiCheckbox',
									'search_column',
									array(
											'label' => 'Choose the fields that you want to be available in the Search Group Documents form widget.',
											'multiOptions' => array("1" => "Show","2" => "Browse By", "3" => "Group Title", "4" => "Document Title", "5" => "Group Category", "6" => "Document Category"),
									),
							),
					),
			)
    ),

     array(
        'title' => 'Group Documents',
        'description' => 'Displays the list of Documents from Groups created on your community. This widget should be placed in the widgetized Group Documents group. Results from the Search Group Documents form are also shown here.',
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroupdocument.sitegroup-document',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of documents to show)',
                        'value' => 20,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
    
    array(
        'title' => 'Sponsored Documents',
        'description' => 'Displays the Documents from Paid Groups. You can choose the number of entries to be shown.',
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroupdocument.sitegroup-sponsoreddocument',
        'defaultParams' => array(
            'title' => 'Sponsored Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of documents to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
						    ),
            ),
        ),
    ),
 
    array(
        'title' => 'Featured Documents',
        'description' => "Displays Featured Group Documents. You can mark Group Documents as Featured from the “Manage Group Documents” section in the Admin Panel of this extension. You can choose the number of entries to be shown.",
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroupdocument.homefeaturelist-sitegroupdocuments',
        'defaultParams' => array(
            'title' => 'Featured Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of documents to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
        ),
    ),
   
//     array(
//         'title' => 'Highlighted Documents',
//         'description' => "Displays Highlighted Group Documents. You can mark Group Documents as Highlighted from the “Manage Group Documents” section in the Admin Panel of this extension. You can choose the number of entries to be shown.",
//         'category' => 'Groups',
//         'type' => 'widget',
//         'name' => 'sitegroupdocument.homehighlightlist-sitegroupdocuments',
//         'defaultParams' => array(
//             'title' => 'Highlighted Documents',
//             'titleCount' => true,
//         ),
//         'adminForm' => array(
// 					'elements' => array(
// 						array(
// 								'Text',
// 								'itemCount',
// 								array(
// 										'label' => 'Count',
// 										'description' => '(number of documents to show)',
// 										'value' => 3,
// 										'validators' => array(
// 											array('Int', true),
// 											array('GreaterThan', true, array(0)),
// 										),
// 								),
// 						),
// 					),
//         ),
//     ),

    array(
        'title' => 'Most Commented Documents',
        'description' => "Displays the Most Commented Group Documents. You can choose the number of entries to be shown.",
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroupdocument.homecomment-sitegroupdocuments',
        'defaultParams' => array(
            'title' => 'Most Commented Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of documents to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
        ),
    ),
    
     array(
        'title' => 'Most Popular Documents',
        'description' => "Displays the Most Viewed Group Documents. You can choose the number of entries to be shown.",
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroupdocument.homepopular-sitegroupdocuments',
        'defaultParams' => array(
            'title' => 'Most Popular Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of documents to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
        ),
    ),
 
    array(
        'title' => 'Most Liked Documents',
        'description' => "Displays the Most Liked Group Documents. You can choose the number of entries to be shown.",
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroupdocument.homelike-sitegroupdocuments',
        'defaultParams' => array(
            'title' => 'Most Liked Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of documents to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
        ),
    ),

    array(
        'title' => 'Top Rated Documents',
        'description' => "Displays the Top Rated Group Documents. You can choose the number of entries to be shown.",
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroupdocument.homerate-sitegroupdocuments',
        'defaultParams' => array(
            'title' => 'Top Rated Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of documents to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
        ),
    ),

	array(
			'title' => 'Group Document View',
			'description' => "This widget should be placed on the Group Document View Page.",
      'category' => 'Groups',
			'type' => 'widget',
			'name' => 'sitegroupdocument.document-content',
			'defaultParams' => array(
					'title' => '',
					'titleCount' => true,
			),
	),

  array(
			'title' => 'Group Document View Options',
			'description' => 'Displays various action link options to users viewing a Group Document. This Widget should be placed on the Group Document View Page in the right column, below the Group Document\'s Owner Photo.',
			'category' => 'Groups',
			'type' => 'widget',
			'name' => 'sitegroupdocument.options-documents',
			'requirements' => array(
				'subject' => 'sitegroupdocument_document',
			),
	),

  array(
			'title' => 'Group Document\'s Owner Photo',
			'description' => 'Displays group owner\'s photo with group owner\'s name to users viewing Group Document. This widget should be placed on Group Document View Page.',
			'category' => 'Groups',
			'type' => 'widget',
			'name' => 'sitegroupdocument.document-owner-photo-documents',
			'requirements' => array(
				'subject' => 'sitegroupdocument_document',
			),
	),

  array(
        'title' => 'Document of the Day',
        'description' => 'Displays the Document of the Day as selected by the Admin from the widget settings section of Groups - Documents Extension.',
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroupdocument.document-of-the-day',
        'defaultParams' => array(
            'title' => 'Document of the Day'
        ),
    ),

     array(
        'title' => 'Group’s Featured Documents Slideshow',
        'description' => 'Displays featured documents in an attractive slideshow. You can set the count of the number of documents to show in this widget. If the total number of documents featured are more than that count, then the documents to be displayed will be sequentially picked up.',
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroupdocument.featured-documents-slideshow',
        'isPaginated' => true,
        'defaultParams' => array(
            'title' => 'Featured Documents',
            'itemCountPerGroup' => 10,
        ),
        'adminForm' => array(
					'elements' => array(
							array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
			),
    ),

    array(
        'title' => 'Group’s Featured Documents Carousel',
        'description' => 'This widget contains an attractive AJAX based carousel, showcasing the featured documents on the site. Multiple settings of this widget makes it highly configurable.',
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroupdocument.featured-documents-carousel',
        'defaultParams' => array(
            'title' => 'Featured Documents',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
										'Select',
										'category_id',
										array(
												'label' => 'Category',
												'multiOptions' => $categories_prepared,
										)
								),
                array(
                    'Radio',
                    'vertical',
                    array(
                        'label' => 'Carousel Type',
                        'multiOptions' => array(
                            '0' => 'Horizontal',
                            '1' => 'Vertical',
                        ),
                        'value' => 0,
                    )
                ),
                array(
                    'Text',
                    'inOneRow',
                    array(
                        'label' => 'Documents in a Row',
                        'description' => '(number of documents to show in one row. Note: This field is applicable only when you have selected ‘Horizontal’ in ‘Carousel Type’ field.)',
                        'value' => 3,
                    )
                ),
                array(
                    'Text',
                    'noOfRow',
                    array(
                        'label' => 'Rows',
                        'description' => '(number of rows in one view)',
                        'value' => 2,
                    )
                ),
                array(
                    'Text',
                    'interval',
                    array(
                        'label' => 'Speed',
                        'description' => '(transition interval between two slides in millisecs)',
                        'value' => 250,
                    )
                ),
            ),
        ),
    ),

    array(
        'title' => 'Group’s Ajax based Tabbed widget for Documents',
        'description' => 'Displays the Recent, Most Liked, Most Viewed, Most Commented and Featured Documents in separate AJAX based tabs. Settings for this widget are available in the Widget Settings section of Groups - Documents Extension.',
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroupdocument.list-documents-tabs-view',
        'defaultParams' => array(
            'title' => 'Documents',
            'margin_photo'=>12,
            'showViewMore'=>1
        ),
         'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'margin_photo',
                    array(
                        'label' => 'Horizontal Margin between Elements',
                        'description' => '(Horizontal margin in px between consecutive elements in this widget. You might want to change this value if the content of this widget is not coming properly on your site because of the column width in your theme.)',
                        'value' => 12,
                    )
                ),
                 array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							  ),
                 array(
                  'Radio',
                  'showViewMore',
                  array(
                      'label' => 'Show "View More" link',
                      'multiOptions' => array(
                          '1' => 'Yes',
                          '0' => 'No',
                      ),
                  )
              )
            ),
        ),
    ),
 
    array(
        'title' => 'Browse Documents',
        'description' => 'Displays the link to view Group’s Documents Browse group.',
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroupdocument.sitegroupdocumentlist-link',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
    ),

    array(
        'title' => 'Group Profile Highlighted Documents',
        'description' => "Displays list of group's highlighted documents. This widget should be placed on the Group Profile.",
        'category' => 'Group Profile',
        'type' => 'widget',
        'name' => 'sitegroupdocument.highlightlist-sitegroupdocuments',
        'defaultParams' => array(
            'title' => 'Highlighted Group Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of documents to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
					),
        ),
    ),

     array(
    'title' => 'Top Creators : Group Documents',
    'description' => 'Displays the Groups which have the most number of Group Documents added in them. Motivates Group Admins to add more content on your website.',
    'category' => 'Groups',
    'type' => 'widget',
    'name' => 'sitegroupdocument.topcreators-sitegroupdocument',
   // 'isPaginated' => true,
    'defaultParams' => array(
      'title' => 'Top Creators',
    ),
     'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of elements to show)',
										'value' => 5,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
        ),
    'requirements' => array(
      'subject' => 'sitegroupdocument',
    ),
  ),

)
?>