<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupdocument
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$isActive = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupdocument.isActivate', 0);
if ( empty($isActive) ) {
  return;
}

$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => $view->translate('Group Profile Documents'),
        'description' => $view->translate('This widget forms the Documents tab on the Group Profile and displays the documents of the Group. It should be placed in the Tabbed Blocks area of the Group Profile.'),
        'category' => $view->translate('Group Profile'),
        'type' => 'widget',
        'name' => 'sitegroupdocument.sitemobile-profile-sitegroupdocuments',
        'defaultParams' => array(
            'title' => $view->translate('Documents'),
        ),
    ),

     array(
        'title' => $view->translate('Group Documents'),
        'description' => $view->translate('Displays the list of Documents from Groups created on your community. This widget should be placed in the widgetized Group Documents group. Results from the Search Group Documents form are also shown here.'),
        'category' => $view->translate('Groups'),
        'type' => 'widget',
        'name' => 'sitegroupdocument.sitegroup-document',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => $view->translate('Count'),
                        'description' => $view->translate('(number of documents to show)'),
                        'value' => 10,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
	array(
			'title' => $view->translate('Group Document View'),
			'description' => $view->translate("This widget should be placed on the Group Document View Page."),
      'category' => $view->translate('Groups'),
			'type' => 'widget',
			'name' => 'sitegroupdocument.document-content',
			'defaultParams' => array(
					'title' => '',
					'titleCount' => true,
			),
	),
)
?>