<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    sitegroupevent
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Menus.php 6590 2010-10-19 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupevent_Plugin_Menus {

  //SHOWING THE EDIT LINK ON THE LEFT SITE MENU ON EVENT VIEW GROUP
  public function onMenuInitialize_SitegroupeventGutterEdit($row) {
    
    //GETTING THE VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();

    //GETTING THE SITEGROUPEVENT SUBJECT
    $subject = Engine_Api::_()->core()->getSubject();

    //GETTING THE TAB ID
    $tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab_id', null);

    // SITEGROUPEVENT SUBJECT OR NOT
    if ($subject->getType() !== 'sitegroupevent_event') {
      $error_msg1 = Zend_Registry::get('Zend_Translate')->_('Whoops, not a group event!');
      throw new Sitegroupevent_Model_Exception($error_msg1);
    }

    //START MANAGE-ADMIN CHECK
    $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $subject->group_id);
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK
    
    // SUPERADMIN, EVENT OWNER AND SITEGROUP OWNER CAN EDIT EVENT
    if ($viewer->getIdentity() != $subject->user_id && $can_edit != 1) {
      return false;
    }

    //Return EDIT LINK
    return array(
        'label' => 'Edit_Event_Details',
        'icon' => Zend_Registry::get('Zend_View')->layout()->staticBaseUrl.'application/modules/Sitegroup/externals/images/icons/edit.png',
        'route' => 'sitegroupevent_specific',
        'params' => array(
            'controller' => 'index',
            'action' => 'edit',
            'event_id' => $subject->getIdentity(),
            'group_id' => $subject->group_id,
            'tab_id' => $tab_selected_id
        )
    );
  }

  //SHOWING THE CREATE LINK ON THE LEFT SITE MENU ON EVENT VIEW GROUP
  public function onMenuInitialize_SitegroupeventGutterCreate($row) {
    
    //GETTING THE VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();

    //GETTING THE SITEGROUPEVENT SUBJECT
    $subject = Engine_Api::_()->core()->getSubject();

    //GETTING THE TAB ID
    $tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab_id', null);

    // SITEGROUPEVENT SUBJECT OR NOT
    if ($subject->getType() !== 'sitegroupevent_event') {
      $error_msg2 = Zend_Registry::get('Zend_Translate')->_('Whoops, not a group event!');
      throw new Sitegroupevent_Model_Exception($error_msg2);
    }

    //START MANAGE-ADMIN CHECK
    $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $subject->group_id);
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'secreate');
    if (empty($isManageAdmin)) {
      $can_create = 0;
    } else {
      $can_create = 1;
    }
    //END MANAGE-ADMIN CHECK
    
    //CHECK THE VIEWER IS GROUP OWNER OR NOT
    if ($can_create != 1) {
      return false;
    }

    //RETURN CREATE LINK
    return array(
        'label' => 'Create_Event',
        'icon' => Zend_Registry::get('Zend_View')->layout()->staticBaseUrl.'application/modules/Sitegroup/externals/images/icons/sitegroupevent_create.png',
        'route' => 'sitegroupevent_create',
        'params' => array(
            'group_id' => $subject->group_id,
            'tab_id' => $tab_selected_id
        )
    );
  }

  //SHOWING THE MEMBER LINK ON THE LEFT SITE MENU ON EVENT VIEW GROUP
  public function onMenuInitialize_SitegroupeventGutterMember() {
    
    //GETTING THE VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();

    //GETTING THE TAB ID
    $tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab_id', null);

    //GETTING THE SITEGROUPEVENT SUBJECT
    $subject = Engine_Api::_()->core()->getSubject();

    //GETTING THE SITEGROUP ITEM	
    $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $subject->group_id);

    //GETTING THE VIEWER Id
    $viewer_id = $viewer->getIdentity();
    if (!empty($viewer_id)) {
      $level_id = $viewer->level_id;
    } else {
      $level_id = 0;
    }

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK
    
    // SUPERADMIN, EVENT OWNER AND SITEGROUP OWNER CAN DELETE EVENT
    if ($viewer_id == $subject->user_id || $can_edit == 1) {
      $can_delete = 1;
    } else {
      $can_delete = 0;
    }

    //SITEGROUPEVENT SUBJECT OR NOT
    if ($subject->getType() !== 'sitegroupevent_event') {
      $error_msg3 = Zend_Registry::get('Zend_Translate')->_('Whoops, not a group event!');
      throw new Sitegroupevent_Model_Exception($error_msg3);
    }

    //SITEGROUPEVENT SUBJECT OR NOT
    if (!$viewer->getIdentity()) {
      return false;
    }

    $row = $subject->membership()->getRow($viewer);
    if (null === $row) {
      if ($subject->membership()->isResourceApprovalRequired()) {
        return array(
            //RETURN THE REQUEST INVITE LINK
            'label' => 'Request_Invite',
            'icon' => Zend_Registry::get('Zend_View')->layout()->staticBaseUrl.'application/modules/Sitegroup/externals/images/icons/sitegroupevent_join.png',
            'class' => 'smoothbox',
            'route' => 'sitegroupevent_specific',
            'params' => array(
                'controller' => 'index',
                'action' => 'request',
                'event_id' => $subject->getIdentity(),
                'group_id' => $subject->group_id,
                'tab_id' => $tab_selected_id
            ),
        );
      } else {
        //RETURN THE JOIN EVENT LINK
        return array(
            'label' => 'Join_Event',
            'icon' => Zend_Registry::get('Zend_View')->layout()->staticBaseUrl.'application/modules/Sitegroup/externals/images/icons/sitegroupevent_join.png',
            'class' => 'smoothbox',
            'route' => 'sitegroupevent_specific',
            'params' => array(
                'controller' => 'index',
                'action' => 'join',
                'event_id' => $subject->getIdentity(),
                'group_id' => $subject->group_id,
                'tab_id' => $tab_selected_id
            ),
        );
      }
    } else if ($row->active) {
      //RETURN THE LEAVE EVENT LINK
      if (!$subject->isOwner($viewer)) {
        return array(
            'label' => 'Leave_Event',
            'icon' => Zend_Registry::get('Zend_View')->layout()->staticBaseUrl.'application/modules/Sitegroup/externals/images/icons/sitegroupevent_leave.png',
            'class' => 'smoothbox',
            'route' => 'sitegroupevent_specific',
            'params' => array(
                'controller' => 'index',
                'action' => 'leave',
                'event_id' => $subject->getIdentity(),
                'group_id' => $subject->group_id,
                'tab_id' => $tab_selected_id
            ),
        );
      } elseif ($can_delete) {
        //RETURN THE DELETE EVENT LINK
        return array(
            'label' => 'Delete_Event',
            'icon' => Zend_Registry::get('Zend_View')->layout()->staticBaseUrl.'application/modules/Sitegroup/externals/images/icons/delete.png',
            'route' => 'sitegroupevent_specific',
            'params' => array(
                'controller' => 'index',
                'action' => 'delete',
                'event_id' => $subject->getIdentity(),
                'group_id' => $subject->group_id,
                'tab_id' => $tab_selected_id
            ),
        );
      }
    } else if (!$row->resource_approved && $row->user_approved) {
      //RETURN THE CANCEL EVENT LINK
      return array(
          'label' => 'Cancel_Invite_Request',
          'icon' => Zend_Registry::get('Zend_View')->layout()->staticBaseUrl.'application/modules/Sitegroup/externals/images/icons/sitegroupevent_cancel.png',
          'class' => 'smoothbox',
          'route' => 'sitegroupevent_extended',
          'params' => array(
              'controller' => 'index',
              'action' => 'cancel',
              'event_id' => $subject->getIdentity(),
              'group_id' => $subject->group_id,
              'user_id' => $viewer->getIdentity(),
              'tab_id' => $tab_selected_id
          ),
      );
    } else if (!$row->user_approved && $row->resource_approved) {
      //RETURN THE ACCEPT OR IGONRE EVENT LINK
      return array(
          array(
              'label' => 'Accept_Event_Invite',
              'icon' => Zend_Registry::get('Zend_View')->layout()->staticBaseUrl.'application/modules/Sitegroup/externals/images/icons/sitegroupevent_accept.png',
              'class' => 'smoothbox',
              'route' => 'sitegroupevent_extended',
              'params' => array(
                  'controller' => 'index',
                  'action' => 'accept',
                  'event_id' => $subject->getIdentity(),
                  'group_id' => $subject->group_id,
                  'user_id' => $viewer->getIdentity(),
                  'tab_id' => $tab_selected_id,
              ),
          ), array(
              'label' => 'Ignore_Event_Invite',
              'icon' => Zend_Registry::get('Zend_View')->layout()->staticBaseUrl.'application/modules/Sitegroup/externals/images/icons/sitegroupevent_reject.png',
              'class' => 'smoothbox',
              'route' => 'sitegroupevent_extended',
              'params' => array(
                  'controller' => 'index',
                  'action' => 'reject',
                  'event_id' => $subject->getIdentity(),
                  'group_id' => $subject->group_id,
                  'user_id' => $viewer->getIdentity(),
                  'tab_id' => $tab_selected_id
              ),
          )
      );
    } else {
      $error_msg4 = Zend_Registry::get('Zend_Translate')->_('An error has occurred.');
      throw new Sitegroupevent_Model_Exception($error_msg4);
    }

    return false;
  }

  //SHOWING THE INVITE LINK ON THE LEFT SITE MENU ON EVENT VIEW GROUP
  public function onMenuInitialize_SitegroupeventGutterInvite() {
    
    //GETTING THE VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();

    //GETTING THE TAB ID
    $tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab_id', null);

    //GETTING THE SITEGROUPEVENT SUBJECT
    $subject = Engine_Api::_()->core()->getSubject();

    // SITEGROUPEVENT SUBJECT OR NOT
    if ($subject->getType() !== 'sitegroupevent_event') {
      throw new Sitegroupevent_Model_Exception('This group event does not exist.');
    }

    //CHECK WHETHER THE PERSON HAS ALLOWES TO INVITE OTHER PEOPLE TO THEIR EVENT.
    if (!$subject->authorization()->isAllowed($viewer, 'invite')) {
      return false;
    }
    
		$groupmember = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitegroupmember');
		$groupasgroup = Engine_Api::_()->getApi('settings', 'core')->getSetting( 'groupmember.groupasgroup');
		if (!empty($groupmember) && !empty($groupasgroup)) {
			return false;
		}


    //RETURN INVITE LINK
    return array(
        'label' => 'Invite_Guests',
        'icon' => Zend_Registry::get('Zend_View')->layout()->staticBaseUrl.'application/modules/Sitegroup/externals/images/icons/invite.png',
        'class' => 'smoothbox',
        'route' => 'sitegroupevent_specific',
        'params' => array(
            'controller' => 'index',
            'action' => 'invite',
            'event_id' => $subject->getIdentity(),
            'group_id' => $subject->group_id,
            'format' => 'smoothbox',
            'tab_id' => $tab_selected_id,
        ),
    );
  }

  public function onMenuInitialize_SitegroupeventGutterShare() {
    
    //GETTING THE VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();

    //GETTING THE TAB ID
    $tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab_id', null);

    //GETTING THE SITEGROUPEVENT SUBJECT
    $subject = Engine_Api::_()->core()->getSubject();

    //SITEGROUPEVENT SUBJECT OR NOT
    if ($subject->getType() !== 'sitegroupevent_event') {
      $error_msg5 = Zend_Registry::get('Zend_Translate')->_('This group event does not exist.');
      throw new Sitegroupevent_Model_Exception($error_msg5);
    }

    //CHECK WHETHER THE PERSON IS THERE OR NOT
    if (!$viewer->getIdentity()) {
      return false;
    }

    //RETURN SHARE LINK
    return array(
        'label' => 'Share_This_Event',
        'icon' => Zend_Registry::get('Zend_View')->layout()->staticBaseUrl.'application/modules/Sitegroupevent/externals/images/share.png',
        'class' => 'smoothbox',
        'route' => 'default',
        'params' => array(
            'module' => 'activity',
            'controller' => 'index',
            'action' => 'share',
            'type' => $subject->getType(),
            'id' => $subject->getIdentity(),
            'format' => 'smoothbox',
            'tab_id' => $tab_selected_id
        ),
    );
  }

  public function onMenuInitialize_SitegroupeventGutterBacktogroup() {
    
    //GETTING THE VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();

    //GETTING THE TAB ID
    $tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab_id', null);

    //GETTING THE SITEGROUPEVENT SUBJECT
    $subject = Engine_Api::_()->core()->getSubject();
    $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $subject->group_id);   
    // SITEGROUPEVENT SUBJECT OR NOT
    if ($subject->getType() !== 'sitegroupevent_event') {
      $error_msg6 = Zend_Registry::get('Zend_Translate')->_('This group event does not exist.');
      throw new Sitegroupevent_Model_Exception($error_msg6);
    }

    $group_url = $sitegroup->getHref(array('tab' => $tab_selected_id));
   
    //RETURN BACK TO GROUP LINK
    return array(
        'label' => 'Back to Group',
        'icon' => Zend_Registry::get('Zend_View')->layout()->staticBaseUrl.'application/modules/Sitegroup/externals/images/icons/back16.gif',
        'uri' =>  $group_url
        
    );
  }

  public function onMenuInitialize_SitegroupeventGutterDay() {
    
    //GETTING THE VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();

    //GETTING THE SITEGROUPEVENT SUBJECT
    $subject = Engine_Api::_()->core()->getSubject();
    $allowView = false;
    $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $subject->group_id);
    if (($viewer->getIdentity()) && ($viewer->level_id == 1)) {
      $auth = Engine_Api::_()->authorization()->context;
      $allowView = $auth->isAllowed($sitegroup, 'everyone', 'view') === 1 ? true : false ||$auth->isAllowed($sitegroup, 'registered', 'view') === 1 ? true : false;
    } 
    if(empty($allowView)) {
      return false;
   }
   return array(
				'route' => 'default',
				'class' => 'smoothbox',
        'icon' => Zend_Registry::get('Zend_View')->layout()->staticBaseUrl.'application/modules/Sitegroup/externals/images/icons/sitegroupevent.png',
				'params' => array(
						'module' => 'sitegroupevent',
						'controller' => 'index',
						'action' => 'add-event-of-day',
						'event_id' => $subject->event_id,
				),
    );
  }


  public function canViewEvents() {

    if (!Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupevent.event.show.menu', 1)) {
      return false;
    }

    $table = Engine_Api::_()->getDbtable('events', 'sitegroupevent');
    $rName = $table->info('name');
    $table_groups = Engine_Api::_()->getDbtable('groups', 'sitegroup');
    $rName_groups = $table_groups->info('name');
    $select = $table->select()
                    ->setIntegrityCheck(false)
                    ->from($rName_groups, array('photo_id', 'title as sitegroup_title'))
                    ->join($rName, $rName . '.group_id = ' . $rName_groups . '.group_id')
                    ->where($rName .'.search = ?', 1);

    $select = $select
                    ->where($rName_groups . '.closed = ?', '0')
                    ->where($rName_groups . '.approved = ?', '1')
                    ->where($rName_groups . '.search = ?', '1')
                    ->where($rName_groups . '.declined = ?', '0')
                    ->where($rName_groups . '.draft = ?', '1');
    if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
      $select->where($rName_groups . '.expiration_date  > ?', date("Y-m-d H:i:s"));
    }
    $row = $table->fetchAll($select);
    $count = count($row);
    if (empty($count)) {
      return false;
    }
    return true;
  }
  
  //SHOWING THE EDIT LINK ON THE LEFT SITE MENU ON EVENT VIEW GROUP
  public function onMenuInitialize_SitegroupeventGutterEditlocation($row) {
    
    //GETTING THE VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();

    //GETTING THE SITEGROUPEVENT SUBJECT
    $subject = Engine_Api::_()->core()->getSubject();

    //GETTING THE TAB ID
    $tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab_id', null);

    // SITEGROUPEVENT SUBJECT OR NOT
    if ($subject->getType() !== 'sitegroupevent_event') {
      $error_msg1 = Zend_Registry::get('Zend_Translate')->_('Whoops, not a group event!');
      throw new Sitegroupevent_Model_Exception($error_msg1);
    }

    //START MANAGE-ADMIN CHECK
    $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $subject->group_id);
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK
    
    // SUPERADMIN, EVENT OWNER AND SITEGROUP OWNER CAN EDIT EVENT
    if ($viewer->getIdentity() != $subject->user_id && $can_edit != 1) {
      return false;
    }

    //Return EDIT LINK
    return array(
        'label' => 'Edit Location',
        'icon' => Zend_Registry::get('Zend_View')->layout()->staticBaseUrl.'application/modules/Sitegroup/externals/images/map.png',
        'route' => 'sitegroupevent_specific',
        'params' => array(
            'controller' => 'index',
            'action' => 'edit-location',
            'seao_locationid' => $subject->seao_locationid,
            'event_id' => $subject->getIdentity(),
            'group_id' => $subject->group_id,
            'tab_id' => $tab_selected_id
        )
    );
  }
    public function onMenuInitialize_SitegroupeventGutterInviteMembers($row) {
    
    //GETTING THE VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    //GETTING THE TAB ID
    $tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab_id', null);

    //GETTING THE SITEGROUPEVENT SUBJECT
    $subject = Engine_Api::_()->core()->getSubject();
	  $group_id = $subject->group_id;
	  
    // SITEGROUPEVENT SUBJECT OR NOT
    if ($subject->getType() !== 'sitegroupevent_event') {
      throw new Sitegroupevent_Model_Exception('This group event does not exist.');
    }

		$groupmember = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitegroupmember');
		if (empty($groupmember)) {
			return false;
		} else {
			$select = Engine_Api::_()->getDbTable('membership', 'sitegroup')->hasMembers($viewer_id, $group_id);
			$groupasgroup = Engine_Api::_()->getApi('settings', 'core')->getSetting( 'groupmember.groupasgroup');
    }
    if (empty($select)) {
			return false;
    }
    if(empty($groupasgroup)) {
			return false;
    }

    //CHECK WHETHER THE PERSON HAS ALLOWES TO INVITE OTHER PEOPLE TO THEIR EVENT.
//     if (!$subject->authorization()->isAllowed($viewer, 'invite')) {
//       return false;
//     }

    // Modify params
    $params = $row->params;
    $params['params']['group_id'] = $group_id;
    $params['params']['event_id'] = $subject->getIdentity();
    return $params;
  }
  

 //PHOTO VIEW GROUP OPTIONS
  public function onMenuInitialize_SitegroupeventPhotoEdit($row) {

     //GET VIEWER ID
    $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();

    $subject = Engine_Api::_()->core()->getSubject();
    //GET ALBUM ID
   $event_id = $subject->event_id;
    
    $sitegroupevent = Engine_Api::_()->getItem('sitegroupevent_event', $event_id);
    
    //GET GROUP ID
    $group_id = $sitegroupevent->group_id;

    $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $group_id);
    
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
 
    //PHOTO OWNER, GROUP OWNER AND SUPER-ADMIN CAN EDIT PHOTO
    if ($viewer_id != $subject->user_id && $can_edit != 1) {
      return false;
    }


    return array(
        'label' => 'Edit',
        'route' => 'sitegroupevent_photo_extended',
        'class' => 'ui-btn-action smoothbox',
        'params' => array(
          'action' => 'photo-edit',
            'photo_id' => $subject->photo_id,
            'event_id' => $event_id,
            'group_id' => $group_id,
            'tab' => Zend_Controller_Front::getInstance()->getRequest()->getParam('tab')
        )
    );
  }

  public function onMenuInitialize_SitegroupeventPhotoDelete($row) {

     //GET VIEWER ID
    $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();

    $subject = Engine_Api::_()->core()->getSubject();
    //GET ALBUM ID
   $event_id = $subject->event_id;
    
    $sitegroupevent = Engine_Api::_()->getItem('sitegroupevent_event', $event_id);
    
    //GET GROUP ID
    $group_id = $sitegroupevent->group_id;

    $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $group_id);
    
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
 
    //PHOTO OWNER, GROUP OWNER AND SUPER-ADMIN CAN EDIT PHOTO
    if ($viewer_id != $subject->user_id && $can_edit != 1) {
      return false;
    }
    
    return array(
        'label' => 'Delete',
        'route' => 'sitegroupevent_photo_extended',
        'class' => 'ui-btn-danger smoothbox',
        'params' => array(
            'action' => 'remove',
            'photo_id' => $subject->photo_id,
            'event_id' => $event_id,
            'group_id' =>  $group_id,
            'owner_id' => $subject->user_id,
            'tab' => Zend_Controller_Front::getInstance()->getRequest()->getParam('tab')
        )
    );
  }

  public function onMenuInitialize_SitegroupeventPhotoShare($row) {
    $subject = Engine_Api::_()->core()->getSubject();
    //GET VIEWER ID
    $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
    
    if(!$viewer_id){
      return false;
    }
    if (!SEA_PHOTOLIGHTBOX_SHARE) {
      return false;
    }
    return array(
        'label' => 'Share',
        'class' => 'ui-btn-action smoothbox',
        'route' => 'default',
        'params' => array(
            'module' => 'activity',
            'action' => 'share',
            'type' => $subject->getType(),
            'id' => $subject->getIdentity(),
        )
    );
  }

  public function onMenuInitialize_SitegroupeventPhotoReport($row) {
    $subject = Engine_Api::_()->core()->getSubject();
    //GET VIEWER ID
    $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
    
    if(!$viewer_id){
      return false;
    }
    if (!SEA_PHOTOLIGHTBOX_REPORT) {
      return false;
    }
    return array(
        'label' => 'Report',
        'class' => 'ui-btn-action smoothbox',
        'route' => 'default',
        'params' => array(
            'module' => 'core',
            'controller' => 'report',
            'action' => 'create',
            'subject' => $subject->getGuid(),
        )
    );
  }
}
