<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    sitegroupevent
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: WidgetsController.php 6590 2010-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupevent_WidgetController extends Core_Controller_Action_Standard {

  //ACTION FOR RSVP
  public function profileRsvpAction() {

    //MAKE FORM
    $this->view->form = new Sitegroupevent_Form_Rsvp();

    //GET THE SITEGROUPEVENT SUBJECT
    $sitegroupevent = Engine_Api::_()->core()->getSubject();

    // PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
      $group_id = $sitegroupevent->group_id;
      if (!empty($group_id)) {
        $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $group_id);
        if (!Engine_Api::_()->sitegroup()->allowPackageContent($sitegroup->package_id, "modules", "sitegroupevent")) {
          return $this->_forward('requireauth', 'error', 'core');
        }
      }
    } else {
      $group_id = $sitegroupevent->group_id;
      if (!empty($group_id)) {
        $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $group_id);
        $isGroupOwnerAllow = Engine_Api::_()->sitegroup()->isGroupOwnerAllow($sitegroup, 'secreate');
      }
      if (empty($isGroupOwnerAllow)) {
        return $this->_forward('requireauth', 'error', 'core');
      }
    }
    // PACKAGE BASE PRIYACY END
    
    // GET LOGGED IN USER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();

    // IF VIEWER IS NOT MEMBER OF EVENT, RETURN
    if (!$sitegroupevent->membership()->isMember($viewer, true)) {
      return;
    }

    //GETTING ROWS
    $row = $sitegroupevent->membership()->getRow($viewer);
    if ($row) {
      $this->view->rsvp = $row->rsvp;
    } else {
      return $this->_helper->viewRenderer->setNoRender(true);
    }

    // IF NOT POST OR FORM NOT VALID, RETURN
    if ($this->getRequest()->isPost()) {
      $option_id = $this->getRequest()->getParam('option_id');
      //SAVE RSVP
      $row->rsvp = $option_id;
      $row->save();
    }
  }

  //ACTION FOR PROFILE INFO
  public function profileInfoAction() {
  	
    // DON'T RENDER THIS IF NOT AUTHORIZED
    if (!$this->_helper->requireAuth()->setAuthParams(null, null, 'view')->isValid())
      return $this->_helper->viewRenderer->setNoRender(true);
  }

  //ACTION FOR EVENT NOTIFICATION
  public function requestSitegroupeventAction() {
  	
    $this->view->notification = $notification = $this->_getParam('notification');
  }

}

?>