<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupevent
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupevent_Widget_ProfileOptionsController extends Engine_Content_Widget_Abstract {

  //ACTION FOR SHOWING THE OPTIONS OF THE EVENT ON EVENT VIEW GROUP
  public function indexAction() {

    //DON'T RENDER IF THERE IS NO SUBJECT
    if (!Engine_Api::_()->core()->hasSubject()) {
      return $this->setNoRender();
    }

    $sitegroupevent_profileOption = Zend_Registry::isRegistered('sitegroupevent_profileOption') ? Zend_Registry::get('sitegroupevent_profileOption') : null;

    //GET SITEGROUP SUBJECT
    $sitegroup = Engine_Api::_()->getItem('sitegroup_group', Engine_Api::_()->core()->getSubject('sitegroupevent_event')->group_id);

    //PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitegroup()->allowPackageContent($sitegroup->package_id, "modules", "sitegroupevent")) {
        return $this->setNoRender();
      }
    } else {
      $isGroupOwnerAllow = Engine_Api::_()->sitegroup()->isGroupOwnerAllow($sitegroup, 'secreate');
      if (empty($isGroupOwnerAllow)) {
        return $this->setNoRender();
      }
    }
    //PACKAGE BASE PRIYACY END     
    
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'view');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }
    //END MANAGE-ADMIN CHECK
    
    //NO RENDER
    if (empty($sitegroupevent_profileOption)) {
      return $this->setNoRender();
    }

    //GET NAVIGATION
    $this->view->gutterNavigation = $gutterNavigation = Engine_Api::_()->getApi('menus', 'core')
            ->getNavigation('sitegroupevent_gutter');
  }

}

?>