<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    sitegroupevent
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: WidgetSettings.php 6590 2010-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

//START LANGUAGE WORK
Engine_Api::_()->getApi('language', 'sitegroup')->languageChanges();
//END LANGUAGE WORK
//GET DB
$db = Zend_Db_Table_Abstract::getDefaultAdapter();	

//CHECK THAT SITEGROUP PLUGIN IS ACTIVATED OR NOT
$select = new Zend_Db_Select($db);
	$select
  ->from('engine4_core_settings')
  ->where('name = ?', 'sitegroup.is.active')
	->limit(1);
$sitegroup_settings = $select->query()->fetchAll();
if(!empty($sitegroup_settings)) {
	$sitegroup_is_active = $sitegroup_settings[0]['value'];
}
else {
	$sitegroup_is_active = 0;
}

//CHECK THAT SITEGROUP PLUGIN IS INSTALLED OR NOT
$select = new Zend_Db_Select($db);
	$select
	  ->from('engine4_core_modules')
  ->where('name = ?', 'sitegroup')
	->where('enabled = ?', 1);
$check_sitegroup = $select->query()->fetchObject();
if(!empty($check_sitegroup)  && !empty($sitegroup_is_active)) {
	$select = new Zend_Db_Select($db);
	$select_group = $select
										 ->from('engine4_core_pages', 'page_id')
										 ->where('name = ?', 'sitegroup_index_view')
										 ->limit(1);
  $group = $select_group->query()->fetchAll();
	if(!empty($group)) {
		$group_id = $group[0]['page_id'];
		
		//INSERTING THE FORM WIDGET IN SITEGROUP_ADMIN_CONTENT TABLE ALSO.
		Engine_Api::_()->getDbtable('admincontent', 'sitegroup')->setAdminDefaultInfo('sitegroupform.sitegroup-viewform', $group_id, 'Form', 'true', '114');			
	 
		//INSERTING THE FORM WIDGET IN CORE_CONTENT TABLE ALSO.
		Engine_Api::_()->getApi('layoutcore', 'sitegroup')->setContentDefaultInfo('sitegroupform.sitegroup-viewform', $group_id, 'Form', 'true', '114');
		
    //INSERTING THE FORM WIDGET IN SITEGROUP_CONTENT TABLE ALSO.
    $select = new Zend_Db_Select($db);								
		$contentgroup_ids = $select->from('engine4_sitegroup_contentgroups', 'contentgroup_id')->query()->fetchAll();
    foreach ($contentgroup_ids as $contentgroup_id) {
			if(!empty($contentgroup_id)) {
        Engine_Api::_()->getDbtable('content', 'sitegroup')->setDefaultInfo('sitegroupform.sitegroup-viewform', $contentgroup_id['contentgroup_id'], 'Form', 'true', '114');
			}
		}
	}	
		
	$select = new Zend_Db_Select($db);
	$select 
					->from('engine4_core_menuitems')
					->where('name = ?', 'sitegroupform_admin_main_fields');
	$queary_info = $select->query()->fetchAll();
	if (empty($queary_info)) {
		$db->insert('engine4_core_menuitems', array(
				'name' => 'sitegroupform_admin_main_fields',
				'module' => 'sitegroupform',
				'label' => 'Form Questions',
				'plugin' => '',
				'params' => '{"route":"admin_default","module":"sitegroupform","controller":"fields","action":"index"}',
				'menu' => 'sitegroupform_admin_main',
				'submenu' => '',
				'order' => 3,
		));
	}
}  
	  
$select = new Zend_Db_Select($db);
$content = $select->from('engine4_sitegroupform_groupquetions')->query()->fetchAll();		
if(empty($content)) {
	$select = new Zend_Db_Select($db);
	$sitegroup_result = $select->from('engine4_sitegroup_groups')->query()->fetchAll();
	if(!empty($sitegroup_result)) {
		foreach ($sitegroup_result as $key => $value) {
			$group_id = $value['group_id'];
			$values = $value ['title'];
			$db->insert('engine4_sitegroupform_fields_options', array(
										'field_id' => 1,
										'label' => $values,
			));
		$option_id =  $db->lastInsertId('engine4_sitegroupform_fields_options');
		$select = new Zend_Db_Select($db);
		$select_content = $select
														->from('engine4_sitegroupform_groupquetions')
														->where('group_id = ?', $group_id)
														->where('option_id = ?', $option_id)
														->limit(1);
		$content = $select_content->query()->fetchAll();
		if( empty($content) ) {
				$db->insert('engine4_sitegroupform_groupquetions', array(
					'group_id' => $group_id,
					'option_id' => $option_id,
				));
			}

		$db->insert('engine4_sitegroupform_sitegroupforms', array(
										'group_id' => $group_id,
										));
		}
	}
}
//CODE FOR INCREASE THE SIZE OF engine4_authorization_permissions's FIELD type
$type_array = $db->query('SHOW COLUMNS FROM engine4_authorization_permissions LIKE \'type\'')->fetch();
if(!empty($type_array)) {
	$varchar = $type_array['Type'];
	$length_varchar = explode('(', $varchar);
	$length = explode(')', $length_varchar[1]);
	$length_type = $length[0];
	if($length_type < 32) 	{
		$run_query  = $db->query('ALTER TABLE `engine4_authorization_permissions` CHANGE `type` `type` VARCHAR( 32 ) CHARACTER SET latin1 COLLATE latin1_general_ci NOT NULL');
	}	
}

?>