<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegrouplikebox
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 2011-10-10 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegrouplikebox_Api_Core extends Core_Api_Abstract {

	  /**
   * Check for package is enable or not and group admin check.
   *
   * @param object $sitegroup
   * @param string $module
   * @param string $hasPackageEnable
   * @return bool $canDo
   */
  public function allowModule( $sitegroup , $module , $hasPackageEnable ) {

    // CHECK FOR PACKAGE IS ENABLE OR NOT.
    if ( $hasPackageEnable ) {
      return (bool) Engine_Api::_()->sitegroup()->allowPackageContent( $sitegroup->package_id , 'modules' , $module ) ;
    }
    else {
      $levelModules = array ( "offer" => "sitegroupoffer" , "form" => "sitegroupform" , "invite" => "sitegroupinvite" , "sdcreate" => "sitegroupdocument" , "sncreate" => "sitegroupnote" , "splcreate" => "sitegrouppoll" , "secreate" => "sitegroupevent" , "svcreate" => "sitegroupvideo" , "spcreate" => "sitegroupalbum" , "comment" => "sitegroupdiscussion" , "smcreate" => "sitegroupmusic") ;
      $search_Key = array_search( $module , $levelModules ) ;
      return (bool) Engine_Api::_()->sitegroup()->isGroupOwnerAllow( $sitegroup , $search_Key ) ;
    }
  }

	  /**
   * Get the widget name and find the order of profile widget show on the group profile group.
   *
   * @return Array $widgetSettingsArray
   */
  public function getWidgteParams() {

		//GET THE GROUP LAYOUT.
    $layout = Engine_Api::_()->getApi( 'settings' , 'core' )->getSetting( 'sitegroup.layoutcreate' ) ;

		//GET THE GROUP LAYOUT TYPE.
    $layoutType = Engine_Api::_()->getApi( 'settings' , 'core' )->getSetting( 'sitegroup.layout.setting' ) ;

    $widgetArray = array ( 'activity.feed' , 'advancedactivity.home-feeds', 'seaocore.feed' , 'sitegroup.info-sitegroup' , 'sitegroup.location-sitegroup' , 'sitegroup.discussion-sitegroup' , 'sitegroup.photos-sitegroup' , 'sitegroupevent.profile-sitegroupevents' , 'sitegrouppoll.profile-sitegrouppolls' , 'sitegroupnote.profile-sitegroupnotes' , 'sitegroupoffer.profile-sitegroupoffers' , 'sitegroupvideo.profile-sitegroupvideos' , 'sitegroupmusic.profile-sitegroupmusic' , 'sitegroupdocument.profile-sitegroupdocuments' , 'sitegroupreview.profile-sitegroupreviews' ) ;

    $widgetSettingsArray = array () ;
   if ( empty( $layout ) ) {
      if ( !empty( $layoutType ) ) {
        $groupsTable = Engine_Api::_()->getDbtable( 'pages' , 'core' ) ;
        $group_id = $groupsTable->select()
                ->from( $groupsTable->info( 'name' ) , array ( 'page_id' ) )
                ->where( "name = ?" , 'sitegroup_index_view' )
                ->query()->fetchColumn() ;

        if ( !empty( $group_id ) ) {
          $contentTable = Engine_Api::_()->getDbtable( 'content' , 'core' ) ;
          $allWidget = $contentTable->select()
                  ->from( $contentTable->info( 'name' ) , array ( 'order' , 'params' , 'name' ) )
                  ->where( "type = ?" , 'widget' )
                  ->where( "page_id = ?" , $group_id ) ;
          $contentTable = $allWidget->query()->fetchAll() ;

          foreach ( $contentTable as $key => $values ) {
            if ( !in_array( $values['name'] , $widgetArray ) ) {
              continue ;
            }
            $getTitleArray = !empty($values['params']) ? Zend_Json::decode( $values['params'] ) : array();
            $getTitle = $values['name'] ;
            if ( !empty( $getTitleArray['title'] ) ) {
              $getTitle = $getTitleArray['title'] ;
            }
            $tempArray = array ( 'name' => $values['name'] , 'title' => $getTitle ) ;
            $widgetSettingsArray[$values['order']] = $tempArray ;
          }
          ksort( $widgetSettingsArray ) ;
          return $widgetSettingsArray ;
        }
      }
      else {
        $groupsTable = Engine_Api::_()->getDbtable( 'pages' , 'core' ) ;
        $group_id = $groupsTable->select()
                ->from( $groupsTable->info( 'name' ) , array ( 'page_id' ) )
                ->where( "name = ?" , 'sitegroup_index_view' )
                ->query()->fetchColumn() ;

        if ( !empty( $group_id ) ) {
          $contentTable = Engine_Api::_()->getDbtable( 'content' , 'core' ) ;
          $allWidget = $contentTable->select()
                  ->from( $contentTable->info( 'name' ) , array ( 'order' , 'params' , 'name' ) )
                  ->where( "type = ?" , 'widget' )
                  ->where( "page_id = ?" , $group_id ) ;
          $allWidget = $allWidget->query()->fetchAll() ;

          foreach ( $allWidget as $key => $values ) {
            if ( !in_array( $values['name'] , $widgetArray ) ) {
              continue ;
            }
            $getTitleArray = !empty($values['params']) ? Zend_Json::decode( $values['params'] ) : array();
            $getTitle = $values['name'] ;
            if ( !empty( $getTitleArray['title'] ) ) {
              $getTitle = $getTitleArray['title'] ;
            }
            $tempArray = array ( 'name' => $values['name'] , 'title' => $getTitle ) ;
            $widgetSettingsArray[$values['order']] = $tempArray ;
          }
          ksort( $widgetSettingsArray ) ;
          return $widgetSettingsArray ;
        }
      }
    }
    else {
      if ( !empty( $layoutType ) ) {
        $contentgroupsTable = Engine_Api::_()->getDbtable( 'contentgroups' , 'sitegroup' ) ;
        $contentgroup_id = $contentgroupsTable->select()
                ->from( $contentgroupsTable->info( 'name' ) , array ( 'group_id' ) )
                ->where( "name = ?" , 'sitegroup_index_view' )
                ->query()->fetchColumn() ;

        if ( !empty( $contentgroup_id ) ) {
          $sitegroupcontentTable = Engine_Api::_()->getDbtable( 'content' , 'sitegroup' ) ;
          $allWidget = $sitegroupcontentTable->select()
                  ->from( $sitegroupcontentTable->info( 'name' ) , array ( 'order' , 'params' , 'name' ) )
                  ->where( "type = ?" , 'widget' )
                  ->where( "contentgroup_id = ?" , $contentgroup_id ) ;
          $contentTable = $allWidget->query()->fetchAll() ;

          foreach ( $contentTable as $key => $values ) {
            if ( !in_array( $values['name'] , $widgetArray ) ) {
              continue ;
            }
            $getTitleArray = !empty($values['params']) ? Zend_Json::decode( $values['params'] ) : array();
            $getTitle = $values['name'] ;
            if ( !empty( $getTitleArray['title'] ) ) {
              $getTitle = $getTitleArray['title'] ;
            }
            $tempArray = array ( 'name' => $values['name'] , 'title' => $getTitle ) ;
            $widgetSettingsArray[$values['order']] = $tempArray ;
          }
          ksort( $widgetSettingsArray ) ;
          return $widgetSettingsArray ;
        } else {
        $groupsTable = Engine_Api::_()->getDbtable( 'pages' , 'core' ) ;
        $group_id = $groupsTable->select()
                ->from( $groupsTable->info( 'name' ) , array ( 'page_id' ) )
                ->where( "name = ?" , 'sitegroup_index_view' )
                ->query()->fetchColumn() ;
          $sitegroupcontentTable = Engine_Api::_()->getDbtable( 'admincontent' , 'sitegroup' ) ;
          $allWidget = $sitegroupcontentTable->select()
                  ->from( $sitegroupcontentTable->info( 'name' ) , array ( 'order' , 'params' , 'name' ) )
                  ->where( "type = ?" , 'widget' )
                  ->where( "group_id = ?" , $group_id ) ;
          $contentTable = $allWidget->query()->fetchAll() ;

          foreach ( $contentTable as $key => $values ) {
            if ( !in_array( $values['name'] , $widgetArray ) ) {
              continue ;
            }
            $getTitleArray = !empty($values['params']) ? Zend_Json::decode( $values['params'] ) : array();
            $getTitle = $values['name'] ;
            if ( !empty( $getTitleArray['title'] ) ) {
              $getTitle = $getTitleArray['title'] ;
            }
            $tempArray = array ( 'name' => $values['name'] , 'title' => $getTitle ) ;
            $widgetSettingsArray[$values['order']] = $tempArray ;
          }
          ksort( $widgetSettingsArray ) ;
          return $widgetSettingsArray ;    
        }
      }
      else {
        $contentgroupsTable = Engine_Api::_()->getDbtable( 'contentgroups' , 'sitegroup' ) ;
        $group_id = $contentgroupsTable->select()
                ->from( $contentgroupsTable->info( 'name' ) , array ( 'group_id' ) )
                ->where( "name = ?" , 'sitegroup_index_view' )
                ->query()->fetchColumn() ;

        if ( !empty( $group_id ) ) {
          $sitegroupcontentTable = Engine_Api::_()->getDbtable( 'content' , 'sitegroup' ) ;
          $allWidget = $sitegroupcontentTable->select()
                  ->from( $sitegroupcontentTable->info( 'name' ) , array ( 'order' , 'params' , 'name' ) )
                  ->where( "type = ?" , 'widget' )
                  ->where( "contentgroup_id = ?" , $group_id ) ;
          $allWidget = $allWidget->query()->fetchAll() ;

          if($allWidget) {
            foreach ( $allWidget as $key => $values ) {
              if ( !in_array( $values['name'] , $widgetArray ) ) {
                continue ;
              }
              $getTitleArray = !empty($values['params']) ? Zend_Json::decode( $values['params'] ) : array();
              $getTitle = $values['name'] ;
              if ( !empty( $getTitleArray['title'] ) ) {
                $getTitle = $getTitleArray['title'] ;
              }
              $tempArray = array ( 'name' => $values['name'] , 'title' => $getTitle ) ;
              $widgetSettingsArray[$values['order']] = $tempArray ;
            }
            ksort( $widgetSettingsArray ) ;
            return $widgetSettingsArray ;
          } else {
                      $groupsTable = Engine_Api::_()->getDbtable( 'pages' , 'core' ) ;
        $group_id = $groupsTable->select()
                ->from( $groupsTable->info( 'name' ) , array ( 'page_id' ) )
                ->where( "name = ?" , 'sitegroup_index_view' )
                ->query()->fetchColumn() ;
          $sitegroupcontentTable = Engine_Api::_()->getDbtable( 'admincontent' , 'sitegroup' ) ;
          $allWidget = $sitegroupcontentTable->select()
                  ->from( $sitegroupcontentTable->info( 'name' ) , array ( 'order' , 'params' , 'name' ) )
                  ->where( "type = ?" , 'widget' )
                  ->where( "page_id = ?" , $group_id ) ;
          $contentTable = $allWidget->query()->fetchAll() ;

          foreach ( $contentTable as $key => $values ) {
            if ( !in_array( $values['name'] , $widgetArray ) ) {
              continue ;
            }
            $getTitleArray = !empty($values['params']) ? Zend_Json::decode( $values['params'] ) : array();
            $getTitle = $values['name'] ;
            if ( !empty( $getTitleArray['title'] ) ) {
              $getTitle = $getTitleArray['title'] ;
            }
            $tempArray = array ( 'name' => $values['name'] , 'title' => $getTitle ) ;
            $widgetSettingsArray[$values['order']] = $tempArray ;
          }
          ksort( $widgetSettingsArray ) ;
          return $widgetSettingsArray ; 
          }
        }
      }
    }
	}
}
?>