<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegrouplikebox
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Global.php 2011-10-10 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegrouplikebox_Form_Admin_Global extends Engine_Form {
 
  // IF YOU WANT TO SHOW CREATED ELEMENT ON PLUGIN ACTIVATION THEN INSERT THAT ELEMENT NAME IN THE BELOW ARRAY.
  public $_SHOWELEMENTSBEFOREACTIVATE = array(
      'submit_lsetting', 'environment_mode', 'include_in_package'
  );
    
  public function init() {

    $this->setTitle( 'Global Settings' )
        ->setDescription( 'These settings affect all members in your community.' ) ;

    $this->addElement( 'Text' , 'sitegrouplikebox_lsettings' , array (
      'label' => 'Enter License key' ,
      'description' => "Please enter your license key that was provided to you when you purchased this plugin. If you do not know your license key, please contact the Support Team of SocialApps.tech from the Support section of your Account Area.(Key Format: XXXXXX-XXXXXX-XXXXXX )" ,
      'value' => Engine_Api::_()->getApi( 'settings' , 'core' )->getSetting( 'sitegrouplikebox.lsettings' ) ,
        ) ) ;

    $global_settings_file = APPLICATION_PATH . '/application/settings/general.php' ;
    if ( file_exists( $global_settings_file ) ) {
      $generalConfig = include $global_settings_file ;
    }
    else {
      $generalConfig = array ( ) ;
    }

    if ( Engine_Api::_()->sitegroup()->hasPackageEnable() ) {
      $this->addElement( 'Checkbox' , 'include_in_package' , array (
        'label' => 'Enable Embeddable Badges / Like Box for the default package that was created upon installation of the "Groups Plugin" (If enabled, the External Badge App will also be available to Groups created so far under the default package).' ,
        'description' => 'Embeddable Badges / Like Box for Default Package' ,
        'value' => 1 ,
          ) ) ;
    }
    
    if ( (!empty( $generalConfig['environment_mode'] ) ) && ($generalConfig['environment_mode'] != 'development') ) {
      $this->addElement( 'Checkbox' , 'environment_mode' , array (
        'label' => 'Your community is currently in "Production Mode". We recommend that you momentarily switch your site to "Development Mode" so that the CSS of this plugin renders fine as soon as the plugin is installed. After completely installing this plugin and visiting few groups of your site, you may again change the System Mode back to "Production Mode" from the Admin Panel Home. (In Production Mode, caching prevents CSS of new plugins to be rendered immediately after installation.)' ,
        'description' => 'System Mode' ,
       // 'value' => 1 ,
          ) ) ;
    }
    else {
      $this->addElement( 'Hidden' , 'environment_mode' , array ( 'order' => 990 , 'value' => 0 ) ) ;
    }

    $this->addElement( 'Button' , 'submit_lsetting' , array (
      'label' => 'Activate Your Plugin Now' ,
      'type' => 'submit' ,
      'ignore' => true
        ) ) ;

    //VALUE FOR WIDTH.
    $this->addElement( 'Radio' , 'likebox_width' , array (
      'label' => 'Badge Width' ,
      'description' => 'Do you want Group Admins to be able to set the width of their embeddable Group Badge / Like Box?' ,
      'multiOptions' => array (
        1 => 'Yes' ,
        0 => 'No'
      ) ,
      'onclick' => 'showwidthOptions(this.value)' ,
      'value' => Engine_Api::_()->getApi( 'settings' , 'core' )->getSetting( 'likebox.width' , 1 ) ,
        ) ) ;

    //VALUE FOR DEFAULT WIDTH.
    $this->addElement( 'Text' , 'likebox_default_width' , array (
      'label' => 'Default Badge Width' ,
      'description' => 'Enter the default width of embeddable Group Badges / Like Box.' ,
      'allowEmpty' => false ,
      'required' => true ,
      'value' => Engine_Api::_()->getApi( 'settings' , 'core' )->getSetting( 'likebox.default.width' , 300 ) ,
        ) ) ;

    //VALUE FOR HEIGHT.
    $this->addElement( 'Radio' , 'likebox_hight' , array (
      'label' => 'Badge Height' ,
      'description' => 'Do you want Group Admins to be able to set the height of their embeddable Group Badge / Like Box?' ,
      'multiOptions' => array (
        1 => 'Yes' ,
        0 => 'No'
      ) ,
      'onclick' => 'showheightOptions(this.value)' ,
      'value' => Engine_Api::_()->getApi( 'settings' , 'core' )->getSetting( 'likebox.hight' , 1 ) ,
        ) ) ;

    //VALUE FOR DEFAULT HEIGHT.
    $this->addElement( 'Text' , 'likebox_default_hight' , array (
      'label' => 'Default Badge Height' ,
      'description' => 'Enter the default height of embeddable Group Badges / Like Box.' ,
      'allowEmpty' => false ,
      'required' => true ,
      'value' => Engine_Api::_()->getApi( 'settings' , 'core' )->getSetting( 'likebox.default.hight' , 660 ) ,
        ) ) ;

    //VALUE FOR COLOR SEHEME.
    $this->addElement( 'Radio' , 'likebox_colorschme' , array (
      'label' => 'Color Scheme' ,
      'description' => 'Do you want Group Admins to be able to select a color scheme for their embeddable Group Badge / Like Box? (You can configure the 2 color schemes, light and dark to match your site’s theme from the Color Schemes section.)' ,
      'multiOptions' => array (
        1 => 'Yes' ,
        0 => 'No'
      ) ,
      'onclick' => 'showcolorOptions(this.value)' ,
      'value' => Engine_Api::_()->getApi( 'settings' , 'core' )->getSetting( 'likebox.colorschme' , 1 ) ,
        ) ) ;

    //VALUE FOR COLOR SCHEME OPTION.
    $this->addElement( 'Select' , 'likebox_default_colorschme' , array (
      'label' => "Default Color Scheme" ,
      'description' => 'Select the default color scheme of embeddable Group Badges / Like Box.' ,
      'multiOptions' => array (
        "light" => "Light" ,
        "dark" => "Dark"
      ) ,
      'value' => Engine_Api::_()->getApi( 'settings' , 'core' )->getSetting( 'likebox.default.colorschme' , 'light' ) ,
        ) ) ;

    //VALUE FOR FACES.
    $this->addElement( 'Radio' , 'likebox_faces' , array (
      'label' => 'Profile Photos for Likes' ,
      'description' => 'Do you want Group Admins to be able to select whether or not to show the profile photos of users who Like their Group in their embeddable Group Badge / Like Box?' ,
      'multiOptions' => array (
        1 => 'Yes' ,
        0 => 'No'
      ) ,
      'onclick' => 'showfacesOptions(this.value)' ,
      'value' => Engine_Api::_()->getApi( 'settings' , 'core' )->getSetting( 'likebox.faces' , 1 ) ,
        ) ) ;

    //VALUE DEFAULT FACES.
    $this->addElement( 'Select' , 'likebox_default_faces' , array (
      'label' => "Default Profile Photos Display" ,
      'description' => 'Select the default visibility for profile photos of users who Like that Group in its embeddable Group Badges / Like Box.' ,
      'multiOptions' => array (
        "display" => "Display" ,
        "donotdisplay" => "Do not Display"
      ) ,
      'value' => Engine_Api::_()->getApi( 'settings' , 'core' )->getSetting( 'likebox.default.faces' , 'display' ) ,
        ) ) ;

    //VALUE FOR HEADER.
    $this->addElement( 'Radio' , 'likebox_header' , array (
      'label' => 'Badge Header' ,
      'description' => 'Do you want Group Admins to be able to select whether or not to show the badge headers on embeddable Group Badges / Like Boxes? (Badge headers contain your Site Title and link back to your website.)' ,
      'multiOptions' => array (
        1 => 'Yes' ,
        0 => 'No'
      ) ,
      'onclick' => 'showheaderOptions(this.value)' ,
      'value' => Engine_Api::_()->getApi( 'settings' , 'core' )->getSetting( 'likebox.header' , 1 ) ,
        ) ) ;

    //VALUE FOR DEFAULT HEADER.
    $this->addElement( 'Select' , 'likebox_default_header' , array (
      'label' => "Default Badge Header Display" ,
      'description' => 'Select the default visibility for badge header on embeddable Group Badges / Like Box.' ,
      'multiOptions' => array (
        "display" => "Display" ,
        "donotdisplay" => "Do not Display"
      ) ,
      'value' => Engine_Api::_()->getApi( 'settings' , 'core' )->getSetting( 'likebox.default.header' , 'display' ) ,
        ) ) ;

    //VALUE FOR BORDER COLOR.
    $this->addElement( 'Radio' , 'likebox_bordercolor' , array (
      'label' => 'Badge Border Color' ,
      'description' => 'Do you want Group Admins to be able to customize the border color for their embeddable Group Badge / Like Box? (You can set the border colors for the 2 color schemes from the Color Schemes section.)' ,
      'multiOptions' => array (
        1 => 'Yes' ,
        0 => 'No'
      ) ,
      'value' => Engine_Api::_()->getApi( 'settings' , 'core' )->getSetting( 'likebox.bordercolor' , 1 ) ,
        ) ) ;

    //VALUE LIKE BUTTON.
    $this->addElement( 'Radio' , 'likebox_likebutton' , array (
      'label' => 'Like Button' ,
      'description' => 'Do you want the Like Button to be available in the embeddable Group Badges / Like Boxes? (With the Like Button, viewers of the embeddable Group Badges / Like Box will be easily and quickly able to Like its Group.)' ,
      'multiOptions' => array (
        1 => 'Yes' ,
        0 => 'No'
      ) ,
      'value' => Engine_Api::_()->getApi( 'settings' , 'core' )->getSetting( 'likebox.likebutton' , 1 ) ,
        ) ) ;


    //VALUE FOR BADGES.
    if ( Engine_Api::_()->getDbtable( 'modules' , 'core' )->isModuleEnabled( 'sitegroupbadge' ) && (Engine_Api::_()->getApi( 'settings' , 'core' )->getSetting( 'sitegroupbadge.isActivate' , 0 )) ) {
      $this->addElement( 'Radio' , 'likebox_badge' , array (
        'label' => 'Assigned Badge' ,
        'description' => 'Do you want to display the badge assigned to Groups in their embeddable Group Badge / Like Box?' ,
        'multiOptions' => array (
          1 => 'Yes' ,
          0 => 'No'
        ) ,
        'value' => Engine_Api::_()->getApi( 'settings' , 'core' )->getSetting( 'likebox.badge' , 1 ) ,
          ) ) ;
    }


    //VALUE FOR DUMMY ELEMENTS.
    $this->addElement( 'Dummy' , 'tab_common' , array (
      'label' => 'With the next few fields, you can choose the tabs that should be available in embeddable Group Badges / Like Box. Group Admins will additionally be able to choose while creating a Group Badge whether a tab selected by you should be visible in it or not. The names and sequence of displayed tabs will be same as that on Group Profile.' ,
      'value' => '0' ,
        ) ) ;

    //VALUE FOR INFO.
    $this->addElement( 'Radio' , 'likebox_info' , array (
      'label' => 'Info Tab' ,
      'description' => 'Do you want Info Tab to be available for display in embeddable Group Badges / Like Boxes? (It will contain the same information as the Info Tab on Group Profile.)' ,
      'multiOptions' => array (
        1 => 'Yes' ,
        0 => 'No'
      ) ,
      'value' => Engine_Api::_()->getApi( 'settings' , 'core' )->getSetting( 'likebox.info' , 1 ) ,
        ) ) ;

    //VALUE FOR MAP.
    $this->addElement( 'Radio' , 'likebox_map' , array (
      'label' => 'Map Tab' ,
      'description' => 'Do you want Map Tab to be available for display in embeddable Group Badges / Like Boxes?' ,
      'multiOptions' => array (
        1 => 'Yes' ,
        0 => 'No'
      ) ,
      'value' => Engine_Api::_()->getApi( 'settings' , 'core' )->getSetting( 'likebox.map' , 1 ) ,
        ) ) ;

    // Element:modules
    //$includeModules = Engine_Api::_()->sitegroup()->getEnableSubModules() ;

    $enableSubModules = array ( ) ;
    $includeModule = array ( "sitegroupalbum" => "Photos" , "sitegrouppoll" => "Polls" , "sitegroupdocument" => 'Documents' , "sitegroupoffer" => 'Offers' , "sitegroupvideo" => "Videos" , "sitegroupevent" => "Events" , "sitegroupnote" => "Notes" , "sitegroupdiscussion" => "Discussions" , "sitegroupmusic" => "Music" , "sitegroupreview" => "Reviews & Ratings" , "sitegroupform" => "Form" , "sitegroupinvite" => "Invite & Promote" , "sitegroupbadge" => "Badges" , "sitegrouplikebox" => "External Badge" ) ;

    $enableAllModule = Engine_Api::_()->getDbtable( 'modules' , 'core' )->getEnabledModuleNames() ;
    $includeModules = array_intersect( array_keys( $includeModule ) , $enableAllModule ) ;
    foreach ( $includeModules as $module ) {
      if ( Engine_Api::_()->sitegroup()->isPluginActivate( $module ) ) {
        $enableSubModules[$module] = $includeModule[$module] ;
      }
    }

    unset( $enableSubModules['sitegrouplikebox'] ) ;
    if ( isset( $enableSubModules['sitegroupbadge'] ) )
      unset( $enableSubModules['sitegroupbadge'] ) ;
    if ( isset( $enableSubModules['sitegroupinvite'] ) )
      unset( $enableSubModules['sitegroupinvite'] ) ;
    if ( isset( $enableSubModules['sitegroupform'] ) )
      unset( $enableSubModules['sitegroupform'] ) ;

    if ( isset( $enableSubModules['sitegroupreview'] ) ) {
      unset( $enableSubModules['sitegroupreview'] ) ;
      $enableSubModules['review'] = "Reviews & Ratings" ;
    }

    $modules_sitegrouplikebox = Engine_Api::_()->getApi( 'settings' , 'core' )->getSetting( 'modules.sitegrouplikebox' ) ;
    $values['modules_sitegrouplikebox'] = unserialize( $modules_sitegrouplikebox ) ;

    if ( !empty( $enableSubModules ) ) {
      $desc_modules = Zend_Registry::get( 'Zend_Translate' )->_( "Select the Apps from which tabs should be available for display in embeddable Group Badges / Like Boxes. (The Apps that you see below are from the extensions that are installed on your website. To see the complete list of available extensions, please visit <a href='http://www.socialengineaddons.com/catalog/directory-groups-extensions' target='_blank' >here</a>.)" ) ;

      //VALUE FOR MODULES OPTION.
      $this->addElement( 'MultiCheckbox' , 'modules_sitegrouplikebox' , array (
        'description' => $desc_modules ,
        'label' => 'Tabs from Apps' ,
        'multiOptions' => $enableSubModules ,
        'value' => $values['modules_sitegrouplikebox'] ,
          ) ) ;
      $this->modules_sitegrouplikebox->addDecorator( 'Description' , array ( 'placement' => Zend_Form_Decorator_Abstract::PREPEND , 'escape' => false ) ) ;
    }

    if(Engine_Api::_()->hasModuleBootstrap('sitereview')){
           
        $listingTypes = Engine_Api::_()->getDbTable('listingtypes', 'sitereview')->getListingTypes();
        $values = Engine_Api::_()->getApi( 'settings' , 'core' )->getSetting( 'sitegrouplikebox.listing.types' ) ;
        $multiOptions = array( );
        foreach ($listingTypes as $listingType) {
            if (Engine_Api::_()->getApi( 'settings' , 'core' )->getSetting("sitereview.listing." . $listingType->listingtype_id, 0))
                    $multiOptions["$listingType->listingtype_id"] = $listingType->title_plural;
            }
            $this->addElement( 'MultiCheckbox' , 'sitegrouplikebox_listing_types' , array (
        'description' => "Select the Listing types from which tabs should be available for display in embeddable Business Badges / Like Boxes :" ,
        'label' => 'Listing types Tab' ,
        'multiOptions' =>  $multiOptions,
        'value' => $values ,
          ) ) ;
    }

    //VALUE FOR POWRED BY.
    $this->addElement( 'Radio' , 'likebox_powred' , array (
      'label' => 'Powered By' ,
      'description' => 'Do you want to display the ‘Powered By’ text and the ‘logo’ of your site in embeddable Group Badges / Like Boxes? (If yes, then you will be able to upload the logo below. These will link back to your website.)' ,
      'multiOptions' => array (
        1 => 'Yes' ,
        0 => 'No'
      ) ,
      'onclick' => 'showfileOptions(this.value)' ,
      'value' => Engine_Api::_()->getApi( 'settings' , 'core' )->getSetting( 'likebox.powred' , 1 ) ,
        ) ) ;


    //VALUE FOR TITLE OF POWERED BY.
    $this->addElement( 'Radio' , 'logo_title' , array (
      'label' => 'Logo or Title' ,
      'description' => 'For the “Powered By”, do you want to show your site’s Logo with Site Title on hover? (You can upload logo below. If you select No, then your Site Title text will be shown after Powered By)' ,
      'multiOptions' => array (
        1 => 'Yes' ,
        0 => 'No'
      ) ,
      'onclick' => 'showlogotitleOptions(this.value)' ,
      'value' => Engine_Api::_()->getApi( 'settings' , 'core' )->getSetting( 'logo.title' , 1 ) ,
        ) ) ;


    //VALUE FOR LOGO PHOTO.
    $this->addElement( 'File' , 'logo_photo' , array (
      'label' => 'Upload Logo' ,
      'description' => 'Upload the image for site Logo. (The recommended dimension is: 30 x 20 pixels.)' ,
        ) ) ;

    $this->logo_photo->addValidator( 'Extension' , false , 'jpg,png,gif,jpeg' ) ;
    $description = "<div class='tip'><span>" . Zend_Registry::get( 'Zend_Translate' )->_( "You have not uploaded an image for site logo. Please upload an image." ) . "</span></div>" ;
    $logo_photo = Engine_Api::_()->getApi( 'settings' , 'core' )->getSetting( 'logo.photo' ) ;
    if ( !empty( $logo_photo ) ) {
      $view = Zend_Registry::isRegistered( 'Zend_View' ) ? Zend_Registry::get( 'Zend_View' ) : null ;
      $photoName = $view->baseUrl() . '/public/sitegrouplikebox/logo/' . $logo_photo ;
      $description = "<img src='$photoName' />" ;
    }

    //VALUE FOR LOGO PREVIEW.
    $this->addElement( 'Dummy' , 'logo_photo_preview' , array (
      'label' => 'Logo Preview' ,
      'description' => $description ,
        ) ) ;
    $this->logo_photo_preview
        ->addDecorator( 'Description' , array ( 'placement' => Zend_Form_Decorator_Abstract::PREPEND , 'escape' => false ) ) ;

    //VALUE FOR CONTENT SHOW.
    $this->addElement( 'Text' , 'likebox_contentshow' , array (
      'label' => 'Content Count' ,
      'allowEmpty' => false ,
      'required' => true ,
      'maxlength' => '3' ,
      'description' => "For Group content from various Apps, how many content items should be shown in their tabs in embeddable Group Badges / Like Boxes? (If there are more content items of this type than the limit, then a 'View More' link will direct users to the website to view them.)" ,
      'required' => true ,
      'value' => Engine_Api::_()->getApi( 'settings' , 'core' )->getSetting( 'likebox.contentshow' , 5 ) ,
      'validators' => array (
        array ( 'Int' , true ) ,
        array ( 'GreaterThan' , true , array ( 0 ) ) ,
      ) ,
        ) ) ;

    // ADD SUBMIT BUTTON.
    $this->addElement( 'Button' , 'submit' , array (
      'label' => 'Save Changes' ,
      'type' => 'submit' ,
      'ignore' => true
        ) ) ;
  }

}