<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupmusic
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Widget.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupmusic_Form_Admin_Widget extends Engine_Form {

  public function init() {
    
    $this
            ->setTitle('Widget Settings')
            ->setDescription('Configure the general settings for the various widgets available with this plugin.');

    $this->addElement('Text', 'sitegroupmusic_comment_widgets', array(
        'label' => 'Group Profile Most Commented Playlists',
        'maxlength' => '3',
        'description' => 'How many playlists will be shown in the group profile most commented playlists widget (value can not be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupmusic.comment.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'sitegroupmusic_recent_widgets', array(
        'label' => 'Group Profile Most Recent Playlists',
        'maxlength' => '3',
        'description' => 'How many playlists should be shown in the group profile most recent playlists widget (value cannot be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupmusic.recent.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'sitegroupmusic_like_widgets', array(
        'label' => 'Group Profile Most Liked Playlists',
        'maxlength' => '3',
        'description' => 'How many playlists should be shown in the group profile most liked playlists widget (value cannot be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupmusic.like.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'sitegroupmusic_popular_widgets', array(
        'label' => 'Group Profile Most Popular Playlists',
        'maxlength' => '3',
        'description' => 'How many playlists should be shown in the group profile most popular playlists widget (value cannot be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupmusic.popular.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'sitegroupmusic_homerecentmusics_widgets', array(
        'label' => 'Recent Group Playlists',
        'maxlength' => '3',
        'description' => 'How many playlists should be shown in the recent group playlists widget (value cannot be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupmusic.homerecentmusics.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));
    
    $this->addElement('Text', 'sitegroupmusic_homepopularmusics_widgets', array(
        'label' => 'Popular Group Playlists',
        'maxlength' => '3',
        'description' => 'How many playlists should be shown in the popular group playlists widget (value cannot be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupmusic.homepopularmusics.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));
    $this->addElement('Button', 'submit', array(
        'label' => 'Save Changes',
        'type' => 'submit',
        'ignore' => true
    ));
  }

}

?>