<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupmusic
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Playlists.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupmusic_Model_DbTable_Playlists extends Engine_Db_Table {

  protected $_rowClass = 'Sitegroupmusic_Model_Playlist';

  /**
   * Gets playlist data
   *
   * @param array $params
   * @return Zend_Db_Table_Select
   */
  public function widgetMusicList($params = array(),$musicType = null) {

    $tableplaylist = $this->info('name');
    if(isset($params['profile_group_widget']) && !empty($params['profile_group_widget'])) {
      $select = $this->select()
                ->from($tableplaylist, array('playlist_id', 'group_id', 'owner_id', 'title', 'creation_date', 'view_count', 'comment_count', 'like_count', 'creation_date', 'modified_date', 'photo_id', 'play_count', 'profile','description','featured'));
			if (isset($params['group_id']) && !empty($params['group_id'])) {
				$select = $select->where($tableplaylist . '.group_id = ?', $params['group_id']);
			}
			if (isset($params['profile']) && !empty($params['profile'])) {
				$select = $select->where($this->info('name') . '.profile = ?', $params['profile']);
			}
      if (isset($params['zero_count']) && !empty($params['zero_count'])) {
				$select = $select->where($tableplaylist . '.' . $params['zero_count'] . '!= ?', 0);
			}
			
			if (isset($params['profile']) && !empty($params['profile'])) {
				$select = $select->where($this->info('name') . '.profile = ?', $params['profile']);
			}
      $select = $select->order('playlist_id DESC')
								->limit($params['limit']);
    }
    else {
			$tableGroup = Engine_Api::_()->getDbtable('groups', 'sitegroup');
			$tableGroupName = $tableGroup->info('name');
			$groupPackagesTable = Engine_Api::_()->getDbtable('packages', 'sitegroup');
			$groupPackageTableName = $groupPackagesTable->info('name');
			$select = $this->select()
											->setIntegrityCheck(false)
											->from($tableplaylist, array('playlist_id', 'group_id', 'owner_id', 'title', 'creation_date', 'view_count', 'comment_count', 'like_count', 'creation_date', 'modified_date', 'photo_id', 'play_count', 'profile','description','featured'))
											->joinLeft($tableGroupName, "$tableGroupName.group_id = $tableplaylist.group_id", array('group_id', 'title AS group_title', 'closed', 'approved', 'declined', 'draft', 'expiration_date', 'owner_id', 'photo_id as group_photo_id'))
											->join($groupPackageTableName, "$groupPackageTableName.package_id = $tableGroupName.package_id",array('package_id', 'price'))
											->where($tableplaylist . '.search = ?', '1');

			if (isset($params['zero_count']) && !empty($params['zero_count'])) {
				$select = $select->where($this->info('name') . '.' . $params['zero_count'] . '!= ?', 0);
			}

			if (isset($params['group_id']) && !empty($params['group_id'])) {
				$select = $select->where($this->info('name') . '.group_id = ?', $params['group_id']);
			}

			if (isset($params['profile']) && !empty($params['profile'])) {
				$select = $select->where($this->info('name') . '.profile = ?', $params['profile']);
			}

			if (isset($params['orderby']) && !empty($params['orderby'])) {
				$select = $select->order($this->info('name') . '.' . $params['orderby']);
			}

			if ((isset($params['orderby_second']) && !empty($params['orderby_second']))) {
				$select = $select->order($this->info('name') . '.' . $params['orderby_second']);
			}

			if (isset($params['limit']) && !empty($params['limit'])) {
				if (!isset($params['start_index']))
					$params['start_index'] = 0;
				$select->limit($params['limit'], $params['start_index']);
			}

// 			if (isset($params['recent_musics']) && !empty($params['recent_musics'])) {
// 				$select = $select->where($tableGroupName . '.search = ?', '1');
// 			}
// 		
			/*if (isset($params['comment_musics']) && !empty($params['comment_musics'])) {
				$select = $select->where($tableGroupName . '.search = ?', '1')
												->where($this->info('name') . '.comment_count != ?', 0);
			} */  

			/*if (isset($params['like_musics']) && !empty($params['like_musics'])) {
				$select = $select->where($tableGroupName . '.search = ?', '1')
												->where($this->info('name') . '.like_count != ?', 0);
			} */ 

			if (isset($params['featured']) && !empty($params['featured'])) {
				$select = $select->where($tableplaylist . '.featured = ?', '1');
			}

			if ($musicType == 'sponsored') {
					$select->where($groupPackageTableName . '.price != ?', '0.00');
					$select->order($groupPackageTableName . '.price' . ' DESC');
					$select ->limit($params['limit']);
			}
			
			if (!empty($params['title'])) {

				$select->where($tableGroupName . ".title LIKE ? ", '%' . $params['title'] . '%');
			}

			if (!empty($params['search_music'])) {

				$select->where($this->info('name') . ".title LIKE ? ", '%' . $params['search_music'] . '%');
			}

				$viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
				if(isset($params['show']) && $params['show'] == 'my_music') {
					$select->where($tableplaylist . '.owner_id = ?', $viewer_id);
				}
				elseif ((isset($params['show']) && $params['show'] == 'sponsored music') || !empty($params['sponsoredmusic'])) {
						
						$select->where($groupPackageTableName . '.price != ?', '0.00');
						$select->order($groupPackageTableName . '.price' . ' DESC');
				}
				elseif ((isset($params['show']) && $params['show'] == 'featured')) {
						
						$select->where($tableplaylist . '.featured = ?', 1);
						$select->order($tableplaylist . '.creation_date' . ' DESC');
				}
				elseif (isset($params['show']) && $params['show'] == 'Networks') {
						$select = $tableGroup->getNetworkBaseSql($select, array('browse_network' => 1));

				}
				elseif (isset($params['show']) && $params['show'] == 'my_like') {
					$likeTableName = Engine_Api::_()->getDbtable('likes', 'core')->info('name');
					$viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
					$select
								->join($likeTableName, "$likeTableName.resource_id = $tableGroupName.group_id")
								->where($likeTableName . '.poster_type = ?', 'user')
								->where($likeTableName . '.poster_id = ?', $viewer_id)
								->where($likeTableName . '.resource_type = ?', 'sitegroup_group');
				}
		
				if (isset($params['orderby_browse']) && $params['orderby_browse'] == 'view_count') {
					$select = $select
													->order($tableplaylist .'.view_count DESC')
													->order($tableplaylist .'.creation_date DESC');
				} elseif ((isset($params['orderby_browse']) && $params['orderby_browse'] == 'comment_count') || !empty($params['commentedmusic'])) {
					$select = $select
													->order($tableplaylist .'.comment_count DESC')
													->order($tableplaylist .'.creation_date DESC');
				} elseif ((isset($params['orderby_browse']) && $params['orderby_browse'] == 'like_count') || !empty($params['likedmusic'])) {
					$select = $select
													->order($tableplaylist .'.like_count DESC')
													->order($tableplaylist .'.creation_date DESC');
				} 
				elseif ((isset($params['orderby_browse']) && $params['orderby_browse'] == 'play_count') || !empty($params['popularmusic'])) {
					$select = $select
													->order($tableplaylist .'.play_count DESC')
													->order($tableplaylist .'.creation_date DESC');
				} 
			
			if (!empty($params['category'])) {
				$select->where($tableGroupName . '.category_id = ?', $params['category']);
			}

			if (!empty($params['category_id'])) {
				$select->where($tableGroupName . '.category_id = ?', $params['category_id']);
			}

			if (!empty($params['subcategory'])) {
				$select->where($tableGroupName . '.subcategory_id = ?', $params['subcategory']);
			}

			if (!empty($params['subcategory_id'])) {
				$select->where($tableGroupName . '.subcategory_id = ?', $params['subcategory_id']);
			}

			if (!empty($params['subsubcategory'])) {
				$select->where($tableGroupName . '.subsubcategory_id = ?', $params['subsubcategory']);
			}

			if (!empty($params['subsubcategory_id'])) {
				$select->where($tableGroupName . '.subsubcategory_id = ?', $params['subsubcategory_id']);
			}
			
			if (isset($params['feature_musics']) && !empty($params['feature_musics'])) {
				$select = $select->where($tableplaylist . '.featured = ?', '1');
			}

			if(empty($params['orderby_browse'])) {
				$order = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupmusic.order', 1);
				switch ($order) {
					case "1":
						$select->order($tableplaylist . '.creation_date DESC');
						break;
					case "2":
						$select->order($tableplaylist . '.title');
						break;
					case "3":
						$select->order($tableplaylist . '.featured' . ' DESC');
						break;
					case "4":
						$select->order($groupPackageTableName . '.price' . ' DESC');
						break;
					case "5":
						$select->order($tableplaylist . '.featured' . ' DESC');
						$select->order($groupPackageTableName . '.price' . ' DESC');
						break;
					case "6":
						$select->order($groupPackageTableName . '.price' . ' DESC');
						$select->order($tableplaylist . '.featured' . ' DESC');
						break;
				}
			}
			$select = $select->order('playlist_id DESC');
			$select = $select
											->where($tableGroupName . '.closed = ?', '0')
											->where($tableGroupName . '.approved = ?', '1')
											->where($tableGroupName . '.declined = ?', '0')
											->where($tableGroupName . '.draft = ?', '1');
			if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
				$select->where($tableGroupName . '.expiration_date  > ?', date("Y-m-d H:i:s"));
			}

			//Start Network work
			if (!isset($params['group_id']) || empty($params['group_id'])) {
				$select = $tableGroup->getNetworkBaseSql($select, array('not_groupBy' => 1, 'extension_group' => $tableplaylist . ".playlist_id"));
			}
			//End Network work
    }
    if(isset($params['music_content']) && !empty($params['music_content'])) {
      return Zend_Paginator::factory($select);
    }
    else {
			return $this->fetchAll($select);
    }
  }

  /**
   * Gets All playlists
   *
   * @param int $group_id
   * @return all the playlists
   */
  public function getPlaylists($group_id) {

    $playlists = $this->select()
                    ->from($this->info('name'), array('playlist_id', 'title'))
                    ->where('owner_id = ?', Engine_Api::_()->user()->getViewer()->getIdentity())
                    ->where('group_id =?', $group_id)
                    ->query()
                    ->fetchAll();

    return $playlists;
  }

  /**
   * Get playlists
   * @param array $params : contain desirable playlists info
   * @return  array of playlists
   */
  public function getPlaylistSelect($params = array()) {

    $tablePlaylistName = $this->info('name');
    $select = $this->select()->setIntegrityCheck(false);
    if (isset($params['show_count']) && $params['show_count'] == 1) {
      $select = $select->from($tablePlaylistName, array('COUNT(*) AS show_count'));
    } else {
      if (!empty($params['orderby'])) {
        if ($params['orderby'] == 'featured') {
        $select
								->where($tablePlaylistName . '.featured = ?', 1)
								->order('creation_date DESC');
				}
        else {
					$select->order($params['orderby'] . ' DESC');
        }
      }
      $select->order('creation_date DESC');
      $select = $select
                      ->from($tablePlaylistName, array('playlist_id', 'group_id', 'owner_id', 'title', 'view_count', 'comment_count', 'play_count', 'creation_date', 'modified_date', 'photo_id', 'search', 'description', 'like_count', 'profile','featured'))
                      ->group("$tablePlaylistName.playlist_id");
    }

    if (isset($params['group_id']) && !empty($params['group_id'])) {
      $select->where('`group_id` = ?', $params['group_id']);
    }
    if (isset($params['profile']) && !empty($params['profile'])) {
      $select->where('`profile` = ?', $params['profile']);
    }
    if (!empty($params['user_id']) && is_numeric($params['user_id'])) {
      $select->where('owner_id = ?', $params['user_id']);
    }

    if (!empty($params['user']) && $params['user'] instanceof User_Model_User) {
      $select->where('owner_id = ?', $params['user_id']->getIdentity());
    }

    if (!empty($params['users'])) {
      $str = (string) ( is_array($params['users']) ? "'" . join("', '", $params['users']) . "'" : $params['users'] );
      $select->where('owner_id in (?)', new Zend_Db_Expr($str));
    }

    if (!empty($params['owner_id']) && is_numeric($params['owner_id'])) {
      $select->where('owner_id = ?', $params['owner_id']);
    }

    if (!empty($params['search'])) {
      $select->where("title LIKE ? OR " . "description LIKE ?", '%' . $params['search'] . '%');
    }

    if (!empty($params['show_groupmusics']) && empty($params['search'])) {
      $select
              ->where($tablePlaylistName . ".search = ?", 1)
              ->orwhere($tablePlaylistName . ".owner_id = ?", $params['music_owner_id']);
    }

    if (!empty($params['show_groupmusics']) && (!empty($params['search']))) {
      $select->where("($tablePlaylistName.search = 1) OR ($tablePlaylistName.owner_id = " . $params['music_owner_id'] . ")");
    }

    if (isset($params['group_id']) && !empty($params['group_id'])) {
      $select->where('`group_id` = ?', $params['group_id']);
    }
    
    if (isset($params['searchable']) && !empty($params['searchable'])) {
      $select->where('`search` = ?', $params['searchable']);
    }    

    return $select;
  }

  /**
   * Get playlist detail
   *
   * @param array $params : contain desirable playlist info
   * @return  object of playlist
   */
  public function getPlaylistPaginator($params = array()) {

    $paginator = Zend_Paginator::factory($this->getPlaylistSelect($params));
    if (!empty($params['group'])) {
      $paginator->setCurrentPageNumber($params['group']);
    }
    if (!empty($params['limit'])) {
      $paginator->setItemCountPerPage($params['limit']);
    }
    return $paginator;
  }

  public function getSpecialPlaylist(Sitegroup_Model_Group $group, User_Model_User $user, $type) {
    $allowedTypes = array('profile', 'wall', 'message');
    if (!in_array($type, $allowedTypes)) {
      throw new Album_Model_Exception('Unknown special group album type');
    }
    //$typeIndex = array_search($type, $allowedTypes);

    $select = $this->select()
                    // ->where('owner_type = ?', $group->getType())
                    ->where('group_id = ?', $group->getIdentity())
                  //  ->where('owner_id = ?', $user->getIdentity())
                    ->where('special = ?', $type)
                    ->order('playlist_id ASC')
                    ->limit(1);

    $playlist = $this->fetchRow($select);

    // Create if it doesn't exist yet
    if (null === $playlist) {
      $translate = Zend_Registry::get('Zend_Translate');

      $playlist = $this->createRow();
      $playlist->group_id = $group->getIdentity();
      $playlist->owner_id = $group->owner_id;
      $playlist->special = $type;

      if ($type == 'message') {
        $playlist->title = $translate->_('_SITEGROUPMUSIC_MESSAGE_PLAYLIST');
        $playlist->search = 0;
      } else {
        $playlist->title = $translate->_('_SITEGROUPMUSIC_DEFAULT_PLAYLIST');
        $playlist->search = 1;
      }

      $playlist->save();

      // Authorizations
      if ($type != 'message') {
        $auth = Engine_Api::_()->authorization()->context;
        $auth->setAllowed($playlist, 'everyone', 'view', true);
        $auth->setAllowed($playlist, 'everyone', 'comment', true);
      }
    }

    return $playlist;
  }

  /**
   * Return music of the day
   *
   * @return Zend_Db_Table_Select
   */
  public function musicOfDay() {

    //CURRENT DATE TIME
    $date = date('Y-m-d');

    //GET ITEM OF THE DAY TABLE NAME
    $musicOfTheDayTableName = Engine_Api::_()->getDbtable('itemofthedays', 'sitegroup')->info('name');

		//GET GROUP TABLE NAME
		$groupTableName = Engine_Api::_()->getDbtable('groups', 'sitegroup')->info('name');

    //GET MUSIC TABLE NAME
    $musicTableName = $this->info('name');

    //MAKE QUERY
    $select = $this->select()
                    ->setIntegrityCheck(false)
                    ->from($musicTableName, array('playlist_id', 'title', 'group_id', 'owner_id', 'description','photo_id'))
                    ->join($musicOfTheDayTableName, $musicTableName . '.playlist_id = ' . $musicOfTheDayTableName . '.resource_id')
										->join($groupTableName, $musicTableName . '.group_id = ' . $groupTableName . '.group_id', array(''))
										->where($groupTableName.'.approved = ?', '1')
										->where($groupTableName.'.declined = ?', '0')
										->where($groupTableName.'.draft = ?', '1')
                    ->where('resource_type = ?', 'sitegroupmusic_playlist')
                    ->where('start_date <= ?', $date)
                    ->where('end_date >= ?', $date)
                    ->order('Rand()');

		//GROUP SHOULD BE AUTHORIZED
    if (Engine_Api::_()->sitegroup()->hasPackageEnable())
      $select->where($groupTableName.'.expiration_date  > ?', date("Y-m-d H:i:s"));

		//GROUP SHOULD BE AUTHORIZED
    $stusShow = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroup.status.show', 1);
    if ($stusShow == 0) {
      $select->where($groupTableName.'.closed = ?', '0');
    }

    //RETURN RESULTS
    return $this->fetchRow($select);
  }
  
  public function topcreatorData($limit = null,$category_id) {

    //MUSIC TABLE NAME
    $musicTableName = $this->info('name');

    //GROUP TABLE
    $groupTable = Engine_Api::_()->getDbtable('groups', 'sitegroup');
    $groupTableName = $groupTable->info('name');

    $select = $this->select()
                    ->setIntegrityCheck(false)
                    ->from($groupTableName, array('photo_id', 'title as sitegroup_title','group_id'))
                    ->join($musicTableName, "$groupTableName.group_id = $musicTableName.group_id", array("COUNT($groupTableName.group_id) AS item_count"))
                    ->where($groupTableName.'.approved = ?', '1')
										->where($groupTableName.'.declined = ?', '0')
										->where($groupTableName.'.draft = ?', '1')
                    ->group($musicTableName . ".group_id")
                    ->order('item_count DESC')
                    ->limit($limit);
    if (!empty($category_id)) {
      $select->where($groupTableName . '.category_id = ?', $category_id);
    }
    return $select->query()->fetchAll();
  }

}
?>