<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupmusic
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: PlaylistController.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupmusic_PlaylistController extends Seaocore_Controller_Action_Standard {

  public function init() {

    //GET VIEWER INFORMATION
    $this->view->viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();

    //GET PLAYLIST SUBJECT
    if (null !== ($playlist_id = $this->_getParam('playlist_id')) &&
            null !== ($playlist = Engine_Api::_()->getItem('sitegroupmusic_playlist', $playlist_id)) &&
            $playlist instanceof Sitegroupmusic_Model_Playlist &&
            !Engine_Api::_()->core()->hasSubject()) {
      Engine_Api::_()->core()->setSubject($playlist);
    }

    //GET GROUP ID
    $group_id = $this->_getParam('group_id');

    //PACKAGE BASE PRIYACY START
    if (!empty($group_id)) {
      $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $group_id);
      if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
        if (!Engine_Api::_()->sitegroup()->allowPackageContent($sitegroup->package_id, "modules", "sitegroupmusic")) {
          return $this->_forward('requireauth', 'error', 'core');
        }
      } else {
        $isGroupOwnerAllow = Engine_Api::_()->sitegroup()->isGroupOwnerAllow($sitegroup, 'smcreate');
        if (empty($isGroupOwnerAllow)) {
          return $this->_forward('requireauth', 'error', 'core');
        }
      }
    }
    //PACKAGE BASE PRIYACY END        
  }

  //ACTION FOR VIEW THE PLAYLIST
  public function viewAction() {

    //GET LOGGED IN USER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();

    //GET MUSIC ITEM
    $sitegroupmusic = Engine_Api::_()->getItem('sitegroupmusic_playlist', $this->getRequest()->getParam('playlist_id'));

    //GET SITEGROUP ITEM
    $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $sitegroupmusic->group_id);

    //PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitegroup()->allowPackageContent($sitegroup->package_id, "modules", "sitegroupmusic")) {
        return $this->_forward('requireauth', 'error', 'core');
      }
    } else {
      $isGroupOwnerAllow = Engine_Api::_()->sitegroup()->isGroupOwnerAllow($sitegroup, 'smcreate');
      if (empty($isGroupOwnerAllow)) {
        return $this->_forward('requireauth', 'error', 'core');
      }
    }
    //PACKAGE BASE PRIYACY END
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'smcreate');
    if (empty($isManageAdmin)) {
      $this->view->can_create = 0;
    } else {
      $this->view->can_create = 1;
    }

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'view');
    if (empty($isManageAdmin)) {
      return $this->_forward('requireauth', 'error', 'core');
    }
    //END MANAGE-ADMIN CHECK

    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK
    //CHECKING THE USER HAVE THE PERMISSION TO VIEW THE MUSIC OR NOT
    if ($viewer_id != $sitegroupmusic->owner_id && $can_edit != 1 && $sitegroupmusic->search != 1) {
      return $this->_forward('requireauth', 'error', 'core');
    }

    //NAVIGATION WORK FOR FOOTER.(DO NOT DISPLAY NAVIGATION IN FOOTER ON VIEW PAGE.)
    if (!Engine_API::_()->seaocore()->checkSitemobileMode('fullsite-mode')) {
         if(!Zend_Registry::isRegistered('sitemobileNavigationName')){
         Zend_Registry::set('sitemobileNavigationName','setNoRender');
         }
    }
    //CHECK THE VERSION OF THE CORE MODULE
    $coremodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core');
    $coreversion = $coremodule->version;
    if ($coreversion < '4.1.0') {
      $this->_helper->content->render();
    } else {
      $this->_helper->content
              ->setNoRender()
              ->setEnabled()
      ;
    }
  }

  //ACTION FOR EDIT THE PLAYLIST
  public function editAction() {

    //UPLOAD SONGS
    if ($this->getRequest()->getQuery('ul', false)) {
      return $this->_forward('add-song', null, null, array('format' => 'json'));
    }

    // CHECK USER VALIDATION
    if (!$this->_helper->requireUser()->isValid()) {
      return;
    }

    //CHECK REQUIRE SUBEJCT IS THERE OR NOT
    if (!$this->_helper->requireSubject('sitegroupmusic_playlist')->isValid()) {
      return;
    }

    //GET PLAYLIST
    $this->view->playlist = $playlist = Engine_Api::_()->core()->getSubject('sitegroupmusic_playlist');

    $is_edit_music = Zend_Registry::isRegistered('sitegroupmusic_edit_info') ? Zend_Registry::get('sitegroupmusic_edit_info') : null;

    //SEND TAB ID TO THE TPL
    $this->view->tab_selected_id = $this->_getParam('tab');

    //GET SITEGROUP ITEM
    $this->view->sitegroup = $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $playlist->group_id);

    $check_result_show = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupmusic.isvar');
    $base_result_time = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupmusic.basetime');

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK
    //SUPERADMIN, MUSIC OWNER AND SITEGROUP OWNER CAN EDIT MUSIC
    if (Engine_Api::_()->user()->getViewer()->getIdentity() != $playlist->owner_id && $can_edit != 1) {
      return $this->_forward('requireauth', 'error', 'core');
    }

    //GET NAVIGATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitegroup_main');

    $controllersettings_result_show = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupmusic.lsettings');
    $controller_result_lenght = strlen($controllersettings_result_show);

    if (Engine_API::_()->seaocore()->checkSitemobileMode('fullsite-mode')) {
      //MAKE FORM
      $this->view->form = $form = new Sitegroupmusic_Form_Edit();
    } else {
      //MAKE FORM
      $this->view->form = $form = new Sitegroupmusic_Form_Sitemobile_Edit();
    }
    
    $currentbase_time = time();

    //POPULATE
    $form->populate($playlist);

    //CHECK FORM VALIDATION
    if (!$this->getRequest()->isPost()) {
      return;
    }

    //CHECK FORM VALIDATION
    if (!$form->isValid($this->getRequest()->getPost())) {
      return;
    }

    if (empty($is_edit_music)) {
      return;
    }

    if (($currentbase_time - $base_result_time > 3287200) && empty($check_result_show)) {
      if ($controller_result_lenght != 20) {
        Engine_Api::_()->sitegroup()->setDisabledType();
        Engine_Api::_()->getItemtable('sitegroup_package')->setEnabledPackages();
        Engine_Api::_()->getApi('settings', 'core')->setSetting('sitegroupmusic.infoset', 1);
        Engine_Api::_()->getApi('settings', 'core')->setSetting('sitegroupmusic.edit.per', 1);
      } else {
        Engine_Api::_()->getApi('settings', 'core')->setSetting('sitegroupmusic.isvar', 1);
      }
    }

    //GET DB
    $db = Engine_Api::_()->getDbTable('playlists', 'sitegroupmusic')->getAdapter();
    $db->beginTransaction();
    try {
      //GET PLAYLIST
      $playlist = $form->saveValues();

      //COMMIT
      $db->commit();
    } catch (Exception $e) {
      $db->rollback();
      throw $e;
    }

    //REDIRECTING TO THE GROUP MUSIC VIEW GROUP
    return $this->_helper->redirector->gotoUrl($playlist->getHref(), array('prependBase' => false));
  }

  //ACTION FOR DELETE THE PLAYLIST
  public function deleteAction() {

    //GET PLAYLIST
    $this->view->playlist = $playlist = Engine_Api::_()->getItem('sitegroupmusic_playlist', $this->getRequest()->getParam('playlist_id'));

    //SOMMTHBOX
    $this->_helper->layout->setLayout('default-simple');

    //GET GROUP ID
    $group_id = $playlist->group_id;

    //SEND TAB ID TO THE TPL
    $this->view->tab_selected_id = $this->_getParam('tab');

    //MAKE FORM
    $this->view->form = $form = new Sitegroupmusic_Form_Delete();

    //GET SITEGROUP ITEM
    $this->view->sitegroup = $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $group_id);

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK
    //MUSIC OWNER AND GROUP OWNER CAN DELETE MUSIC
    if (Engine_Api::_()->user()->getViewer()->getIdentity() != $playlist->owner_id && $can_edit != 1) {
      return $this->_forward('requireauth', 'error', 'core');
    }

    //PLAYLIST NOT EXIST
    if (!$playlist) {
      $this->view->status = false;
      $this->view->error = Zend_Registry::get('Zend_Translate')->_("Playlist doesn't exists or not authorized to delete");
      return;
    }

    //INVALID METHOD
    if (!$this->getRequest()->isPost()) {
      $this->view->status = false;
      $this->view->error = Zend_Registry::get('Zend_Translate')->_('Invalid request method');
      return;
    }

    //GET DB
    $db = $playlist->getTable()->getAdapter();
    $db->beginTransaction();
    try {

      //DELETE SONGS
      foreach ($playlist->getSongs() as $song) {
        $song->deleteUnused();
      }

      //DELETE PLAYLIST
      $playlist->delete();

      //COMMIT
      $db->commit();
    } catch (Exception $e) {
      $db->rollBack();
      throw $e;
    }

    $this->view->status = true;

    return $this->_forwardCustom('success', 'utility', 'core', array(
                'messages' => array(Zend_Registry::get('Zend_Translate')->_('The selected playlist has been deleted.')),
                'layout' => 'default-simple',
                'parentRedirect' => $this->_helper->url->url(array('group_url' => Engine_Api::_()->sitegroup()->getGroupUrl($group_id), 'tab' => $this->view->tab_selected_id), 'sitegroup_entry_view'),
            ));
  }

  //ACTION FOR SORT THE SONGS
  public function sortAction() {

    //CHECK SUBJECT
    if (!$this->_helper->requireSubject('sitegroupmusic_playlist')->isValid()) {
      $this->view->status = false;
      $this->view->error = $this->view->translate('Invalid playlist');
      return;
    }

    //GET PLAYLIST
    $playlist = Engine_Api::_()->core()->getSubject('sitegroupmusic_playlist');

    //GET SITEGROUP ITEM
    $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $playlist->group_id);

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK
    //SUPERADMIN, MUSIC OWNER AND SITEGROUP OWNER CAN EDIT MUSIC
    if (Engine_Api::_()->user()->getViewer()->getIdentity() != $playlist->owner_id && $can_edit != 1) {
      $this->view->status = false;
      $this->view->error = $this->view->translate('Not allowed to edit this playlist');
      return;
    }

    //GET SONGS
    $songs = $playlist->getSongs();

    //GET ORDER
    $order = explode(',', $this->getRequest()->getParam('order'));

    //CHANGE THE ORDER OF THE SONGS
    foreach ($order as $i => $item) {
      $song_id = substr($item, strrpos($item, '_') + 1);
      foreach ($songs as $song) {
        if ($song->song_id == $song_id) {
          $song->order = $i;
          $song->save();
        }
      }
    }

    $this->view->songs = $playlist->getSongs()->toArray();
  }

  //ACTION FOR UPLOAD THE SONGS
  public function addSongAction() {

    // CHECK USER VALIDATION
    if (!$this->_helper->requireUser()->isValid()) {
      return;
    }

    //GET VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();

    //GET PLAYLIST TABLE
    $playlistTable = Engine_Api::_()->getDbTable('playlists', 'sitegroupmusic');

    // Get special playlist
    if (0 >= ($playlist_id = $this->_getParam('playlist_id')) &&
            false != ($type = $this->_getParam('type'))) {

      $group_id = $this->_getParam('group_id');
      //PACKAGE BASE PRIYACY START

      $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $group_id);
      $playlist = $playlistTable->getSpecialPlaylist($sitegroup, $viewer, $type);
      Engine_Api::_()->core()->setSubject($playlist);
    }
    //CHECK SUBJECT
    if (!$this->_helper->requireSubject('sitegroupmusic_playlist')->checkRequire()) {
      $this->view->success = false;
      $this->view->error = $this->view->translate('Invalid playlist');
      return;
    }

    //GET PLAYLIST
    $playlist = Engine_Api::_()->core()->getSubject('sitegroupmusic_playlist');

    //GET SITEGROUP ITEM
    $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $playlist->group_id);

    $is_add_music = Zend_Registry::isRegistered('sitegroupmusic_add_music') ? Zend_Registry::get('sitegroupmusic_add_music') : null;

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'smcreate');
    if (empty($isManageAdmin)) {
      return $this->_forward('requireauth', 'error', 'core');
    }

    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK
    //SUPERADMIN, MUSIC OWNER AND SITEGROUP OWNER CAN EDIT MUSIC
    if ($viewer->getIdentity() != $playlist->owner_id && $can_edit != 1) {
      $this->view->status = false;
      $this->view->error = $this->view->translate('Not allowed to edit this playlist');
      return;
    }

    //GET VALUES
    $values = $this->getRequest()->getPost();
    $response = Seaocore_Service_FancyUpload::upload();

    if (!empty($response['error'])) {
        $this->view->status = false;
        $this->view->error = Zend_Registry::get('Zend_Translate')->_('Invalid Upload');
        return;
    }

    if (empty($response['path']) || empty(file_exists($response['path']))) {
        $this->view->status = false;
        $this->view->error = Zend_Registry::get('Zend_Translate')->_('No file');
        return;
    }

    //PROCESS
    $db = Engine_Api::_()->getDbtable('playlists', 'sitegroupmusic')->getAdapter();
    $db->beginTransaction();

    try {
      //CREATE SONG      
      $file = Engine_Api::_()->getDbTable('playlistSongs', 'sitegroupmusic')->createSong($response['path']);
      if (!$file) {
        throw new Sitegroupmusic_Model_Exception('Song was not successfully attached');
      }

      //ADD SONG
      $song = $playlist->addSong($file);
      if (!$song) {
        throw new Sitegroupmusic_Model_Exception('Song was not successfully attached');
      }

      //RESPONSE
      $this->view->status = true;
      $this->view->song = $song;
      $this->view->song_id = $song->getIdentity();
      $this->view->song_url = $song->getFilePath();
      $this->view->song_title = $song->getTitle();

      //COMMIT
      $db->commit();
      
      //Attach music preview on status box (Activity Feed)
       $requesttype = $this->_getParam('feedmusic', false);
      if ($requesttype) {
      	echo '<h3><i class="cm-icons cm-icon-music" style="margin-top:-3px;"></i><span style="margin:5px;">'.$song->getTitle().'</span></h3><div class="sucess_message">'.$this->view->translate("SITEMOBILE_MUSIC_FEED_PREVIEW_DESCRIPTION").'</div><div id="advfeed-music"><input type="hidden" name="attachment[song_id]" value="'.$song->getIdentity().'"><input type="hidden" name="attachment[type]" value="sitegroupmusic"></div>';


      	exit();
      }
    } catch (Sitegroupmusic_Model_Exception $e) {
      $db->rollback();
      $this->view->status = false;
      $this->view->error = Zend_Registry::get('Zend_Translate')->_($e->getMessage());
      return;
    } catch (Exception $e) {
      $db->rollback();
      $this->view->status = false;
      $this->view->error = Zend_Registry::get('Zend_Translate')->_($e->getMessage());
      throw $e;
    }
    @unlink($response['path']);
  }

  public function setProfileAction() {

    // CHECK USER VALIDATION
    if (!$this->_helper->requireUser()->isValid()) {
      return;
    }

    // Get playlist
    $this->view->playlist = $playlist = Engine_Api::_()->core()->getSubject('sitegroupmusic_playlist');

    $this->view->playlist_id = $playlist_id = $playlist->getIdentity();

    $this->view->tab_selected_id = $this->_getParam('tab');

    //GET SITEGROUP ITEM
    $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $playlist->group_id);
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK
    //SUPERADMIN, MUSIC OWNER AND SITEGROUP OWNER CAN EDIT MUSIC
    if (Engine_Api::_()->user()->getViewer()->getIdentity() != $playlist->owner_id && $can_edit != 1) {
      return;
    }

    // Process
    $db = Engine_Api::_()->getDbTable('playlists', 'sitegroupmusic')->getAdapter();
    $db->beginTransaction();

    try {
      $playlist->setProfile();
      $this->view->success = true;
      $this->view->enabled = $playlist->profile;

      $db->commit();
    } catch (Exception $e) {
      $this->view->success = false;

      $db->rollback();
    }
    return $this->_forward('success', 'utility', 'core', array(
                'parentRedirect' => Zend_Controller_Front::getInstance()->getRouter()->assemble(array('group_url' => Engine_Api::_()->sitegroup()->getGroupUrl($playlist->group_id), 'tab' => $this->view->tab_selected_id), 'sitegroup_entry_view', true),
                'messages' => Array('')
            ));
  }

  public function browseAction() {

    //CHECK VIEW PRIVACY
    if (!$this->_helper->requireAuth()->setAuthParams('sitegroup_group', null, 'view')->isValid())
      return;

    //CHECK THE VERSION OF THE CORE MODULE
    $coremodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core');
    $coreversion = $coremodule->version;
    if ($coreversion < '4.1.0') {
      $this->_helper->content->render();
    } else {
      $this->_helper->content
              ->setNoRender()
              ->setEnabled()
      ;
    }
  }

  public function homeAction() {

    //CHECK VIEW PRIVACY
    if (!$this->_helper->requireAuth()->setAuthParams('sitegroup_group', null, 'view')->isValid())
      return;

    //CHECK THE VERSION OF THE CORE MODULE
    $coremodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core');
    $coreversion = $coremodule->version;
    if ($coreversion < '4.1.0') {
      $this->_helper->content->render();
    } else {
      $this->_helper->content
              ->setNoRender()
              ->setEnabled()
      ;
    }
  }

  //ACTION FOR MAKE THE SITEGROUPMUSIC FEATURED/UNFEATURED
  public function featuredAction() {

    //CHECK USER VALIDATION
    if (!$this->_helper->requireUser()->isValid())
      return;

    //GET PLAYLIST ID AND OBJECT
    $playlist_id = $this->view->playlist_id = $this->_getParam('playlist_id');
    $sitegroupmusic = Engine_Api::_()->getItem('sitegroupmusic_playlist', $playlist_id);

    $this->view->featured = $sitegroupmusic->featured;

    //GET GROUP OBJECT
    $this->view->sitegroup = $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $sitegroupmusic->group_id);

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
    $this->view->canEdit = 0;
    if (!empty($isManageAdmin)) {
      $this->view->canEdit = 1;
    }
    //END MANAGE-ADMIN CHECK
    //SMOOTHBOX
    if (null === $this->_helper->ajaxContext->getCurrentContext()) {
      $this->_helper->layout->setLayout('default-simple');
    } else {//NO LAYOUT
      $this->_helper->layout->disableLayout(true);
    }

    if (!$this->getRequest()->isPost())
      return;

    //GET VIEWER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    $tab_selected_id = $this->_getParam('tab');

    //CHECK THAT FEATURED ACTION IS ALLOWED BY ADMIN OR NOT
    //CHECK CAN MAKE FEATURED OR NOT(ONLY SITEGROUP MUSIC CAN MAKE FEATURED/UN-FEATURED)
    if ($viewer_id == $sitegroupmusic->owner_id || !empty($this->view->canEdit)) {
      $this->view->permission = true;
      $this->view->success = false;
      $db = Engine_Api::_()->getDbtable('playlists', 'sitegroupmusic')->getAdapter();
      $db->beginTransaction();
      try {
        if ($sitegroupmusic->featured == 0) {
          $sitegroupmusic->featured = 1;
        } else {
          $sitegroupmusic->featured = 0;
        }

        $sitegroupmusic->save();
        $db->commit();
        $this->view->success = true;
      } catch (Exception $e) {
        $db->rollback();
        throw $e;
      }
    } else {
      $this->view->permission = false;
    }

    if ($sitegroupmusic->featured) {
      $suc_msg = array(Zend_Registry::get('Zend_Translate')->_('Music successfully made featured.'));
    } else {
      $suc_msg = array(Zend_Registry::get('Zend_Translate')->_('Music successfully made un-featured.'));
    }

    $this->_forward('success', 'utility', 'core', array(
        'smoothboxClose' => 2,
        'parentRedirect' => $this->_helper->url->url(array('group_url' => Engine_Api::_()->sitegroup()->getGroupUrl($sitegroupmusic->group_id), 'tab' => $tab_selected_id), 'sitegroup_entry_view', true),
        'parentRedirectTime' => '2',
        'format' => 'smoothbox',
        'messages' => $suc_msg
    ));
  }

}

?>