<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupmusic
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http:// www.socialengineaddons.com/license/
 * @version    $Id: widgetSettings.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

//START LANGUAGE WORK
Engine_Api::_()->getApi('language', 'sitegroup')->languageChanges();
//END LANGUAGE WORK

//GET DB
$db = Zend_Db_Table_Abstract::getDefaultAdapter();

//CHECK THAT SITEGROUP PLUGIN IS ACTIVATED OR NOT
$select = new Zend_Db_Select($db);
$select
        ->from('engine4_core_settings')
        ->where('name = ?', 'sitegroup.is.active')
        ->limit(1);
$sitegroup_settings = $select->query()->fetchAll();
if (!empty($sitegroup_settings)) {
  $sitegroup_is_active = $sitegroup_settings[0]['value'];
} else {
  $sitegroup_is_active = 0;
}

//CHECK THAT SITEGROUP PLUGIN IS INSTALLED OR NOT
$select = new Zend_Db_Select($db);
$select
        ->from('engine4_core_modules')
        ->where('name = ?', 'sitegroup')
        ->where('enabled = ?', 1);
$check_sitegroup = $select->query()->fetchObject();
if (!empty($check_sitegroup) && !empty($sitegroup_is_active)) {
  $select = new Zend_Db_Select($db);
  $select_group = $select->from('engine4_core_pages', 'page_id')->where('name = ?', 'sitegroup_index_view')->limit(1);
  $group = $select_group->query()->fetchAll();
  if (!empty($group)) {
    $group_id = $group[0]['page_id'];

    //INSERTING THE MUSIC WIDGET IN SITEGROUP_ADMIN_CONTENT TABLE ALSO.
    Engine_Api::_()->getDbtable('admincontent', 'sitegroup')->setAdminDefaultInfo('sitegroupmusic.profile-sitegroupmusic', $group_id, 'Music', 'true', '120');

    //INSERTING THE MUSIC WIDGET IN CORE_CONTENT TABLE ALSO.
    Engine_Api::_()->getApi('layoutcore', 'sitegroup')->setContentDefaultInfo('sitegroupmusic.profile-sitegroupmusic', $group_id, 'Music', 'true', '120');

    //INSERTING THE MUSIC WIDGET IN SITEGROUP_CONTENT TABLE ALSO.
    $select = new Zend_Db_Select($db);
    $contentgroup_ids = $select->from('engine4_sitegroup_contentgroups', 'contentgroup_id')->query()->fetchAll();
    foreach ($contentgroup_ids as $contentgroup_id) {
      if (!empty($contentgroup_id)) {
        Engine_Api::_()->getDbtable('content', 'sitegroup')->setDefaultInfo('sitegroupmusic.profile-sitegroupmusic', $contentgroup_id['contentgroup_id'], 'Music', 'true', '120');
        //INSERT THE GROUP PROFILE PLAYER WIDGET
        $select = new Zend_Db_Select($db);
        $select_content = $select
                ->from('engine4_sitegroup_content')
                ->where('contentgroup_id = ?', $contentgroup_id['contentgroup_id'])
                ->where('type = ?', 'widget')
                ->where('name = ?', 'sitegroupmusic.profile-player')
                ->limit(1);
        $content = $select_content->query()->fetchAll();
        if (empty($content)) {
          $select = new Zend_Db_Select($db);
          $select_container = $select
                  ->from('engine4_sitegroup_content', 'content_id')
                  ->where('contentgroup_id = ?', $contentgroup_id['contentgroup_id'])
                  ->where('type = ?', 'container')
                  ->limit(1);
          $container = $select_container->query()->fetchAll();
          if (!empty($container)) {
            $container_id = $container[0]['content_id'];
            $select = new Zend_Db_Select($db);
            $select_left = $select
                    ->from('engine4_sitegroup_content')
                    ->where('parent_content_id = ?', $container_id)
                    ->where('type = ?', 'container')
										->where('contentgroup_id = ?', $contentgroup_id['contentgroup_id'])
										->where('name in (?)', array('left', 'right'))
                    ->limit(1);
            $left = $select_left->query()->fetchAll();
            if (!empty($left)) {
              $left_id = $left[0]['content_id'];
              $db->insert('engine4_sitegroup_content', array(
                  'contentgroup_id' => $contentgroup_id['contentgroup_id'],
                  'type' => 'widget',
                  'name' => 'sitegroupmusic.profile-player',
                  'parent_content_id' => $left_id,
                  'order' => 26,
                  'params' => '{"title":"","titleCount":""}',
              ));
            }
          }
        }
      }
    }
    //INSERT THE GROUP PROFILE PLAYER WIDGET
    $select = new Zend_Db_Select($db);
    $select_content = $select
            ->from('engine4_core_content')
            ->where('page_id = ?', $group_id)
            ->where('type = ?', 'widget')
            ->where('name = ?', 'sitegroupmusic.profile-player')
            ->limit(1);
    $content = $select_content->query()->fetchAll();
    if (empty($content)) {
      $select = new Zend_Db_Select($db);
      $select_container = $select
              ->from('engine4_core_content', 'content_id')
              ->where('page_id = ?', $group_id)
              ->where('type = ?', 'container')
              ->limit(1);
      $container = $select_container->query()->fetchAll();
      if (!empty($container)) {
        $container_id = $container[0]['content_id'];
        $select = new Zend_Db_Select($db);
        $select_left = $select
                ->from('engine4_core_content')
                ->where('parent_content_id = ?', $container_id)
                ->where('type = ?', 'container')
								->where('page_id = ?',$group_id)
								->where('name in (?)', array('left', 'right'))
                ->limit(1);
        $left = $select_left->query()->fetchAll();
        if (!empty($left)) {
          $left_id = $left[0]['content_id'];
          $db->insert('engine4_core_content', array(
              'page_id' => $group_id,
              'type' => 'widget',
              'name' => 'sitegroupmusic.profile-player',
              'parent_content_id' => $left_id,
              'order' => 26,
              'params' => '{"title":"","titleCount":""}',
          ));
        }
      }
    }  
    //INSERT THE GROUP PROFILE PLAYER WIDGET
    $select = new Zend_Db_Select($db);
    $select_content = $select
            ->from('engine4_sitegroup_admincontent')
            ->where('group_id = ?', $group_id)
            ->where('type = ?', 'widget')
            ->where('name = ?', 'sitegroupmusic.profile-player')
            ->limit(1);
    $content = $select_content->query()->fetchAll();
    if (empty($content)) {
      $select = new Zend_Db_Select($db);
      $select_container = $select
              ->from('engine4_sitegroup_admincontent', 'admincontent_id')
              ->where('group_id = ?', $group_id)
              ->where('type = ?', 'container')
              ->limit(1);
      $container = $select_container->query()->fetchAll();
      if (!empty($container)) {
        $container_id = $container[0]['admincontent_id'];
        $select = new Zend_Db_Select($db);
        $select_left = $select
                ->from('engine4_sitegroup_admincontent')
                ->where('parent_content_id = ?', $container_id)
                ->where('type = ?', 'container')
								->where('group_id = ?',$group_id)
								->where('name in (?)', array('left', 'right'))
                ->limit(1);
        $left = $select_left->query()->fetchAll();
        if (!empty($left)) {
          $left_id = $left[0]['admincontent_id'];
          $db->insert('engine4_sitegroup_admincontent', array(
              'group_id' => $group_id,
              'type' => 'widget',
              'name' => 'sitegroupmusic.profile-player',
              'parent_content_id' => $left_id,
              'order' => 26,
              'params' => '{"title":"","titleCount":""}',
          ));
        }
      }
    }      
  }
  
  $contentTable = Engine_Api::_()->getDbtable('content', 'core');
  $contentTableName = $contentTable->info('name');

  $select = new Zend_Db_Select($db);
  $select
          ->from('engine4_core_pages')
          ->where('name = ?', 'sitegroupmusic_playlist_browse')
          ->limit(1);
  ;
  $info = $select->query()->fetch();
  if ( empty($info) ) {
    $db->insert('engine4_core_pages', array(
        'name' => 'sitegroupmusic_playlist_browse',
        'displayname' => 'Browse Group music',
        'title' => 'Group Music List',
        'description' => 'This is the group music.',
        'custom' => 1,
    ));
    $group_id = $db->lastInsertId('engine4_core_pages');
//INSERT MAIN CONTAINER
    $mainContainer = $contentTable->createRow();
    $mainContainer->page_id = $group_id;
    $mainContainer->type = 'container';
    $mainContainer->name = 'main';
    $mainContainer->order = 2;
    $mainContainer->save();
    $container_id = $mainContainer->content_id;

//INSERT MAIN - MIDDLE CONTAINER
    $mainMiddleContainer = $contentTable->createRow();
    $mainMiddleContainer->page_id = $group_id;
    $mainMiddleContainer->type = 'container';
    $mainMiddleContainer->name = 'middle';
    $mainMiddleContainer->parent_content_id = $container_id;
    $mainMiddleContainer->order = 6;
    $mainMiddleContainer->save();
    $middle_id = $mainMiddleContainer->content_id;

//INSERT MAIN - RIGHT CONTAINER
    $mainRightContainer = $contentTable->createRow();
    $mainRightContainer->page_id = $group_id;
    $mainRightContainer->type = 'container';
    $mainRightContainer->name = 'right';
    $mainRightContainer->parent_content_id = $container_id;
    $mainRightContainer->order = 5;
    $mainRightContainer->save();
    $right_id = $mainRightContainer->content_id;

//INSERT TOP CONTAINER
    $topContainer = $contentTable->createRow();
    $topContainer->page_id = $group_id;
    $topContainer->type = 'container';
    $topContainer->name = 'top';
    $topContainer->order = 1;
    $topContainer->save();
    $top_id = $topContainer->content_id;

//INSERT TOP- MIDDLE CONTAINER
    $topMiddleContainer = $contentTable->createRow();
    $topMiddleContainer->page_id = $group_id;
    $topMiddleContainer->type = 'container';
    $topMiddleContainer->name = 'middle';
    $topMiddleContainer->parent_content_id = $top_id;
    $topMiddleContainer->order = 6;
    $topMiddleContainer->save();
    $top_middle_id = $topMiddleContainer->content_id;

    //INSERT NAVIGATION WIDGET
    Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroup.browsenevigation-sitegroup', $top_middle_id, 1);

//INSERT MUSIC WIDGET
    Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroupmusic.sitegroup-music', $middle_id, 2);

    //INSERT SEARCH GROUP MUSIC WIDGET
    Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroupmusic.search-sitegroupmusic', $right_id, 3, "", "true");

    //INSERT MOST COMMENTED GROUP MUSIC WIDGET
    Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroupmusic.homecomment-sitegroupmusic', $right_id, 4, "Most Commented Playlists", "true");

    //INSERT SPONSORED GROUP MUSIC WIDGET
    Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroupmusic.sitegroup-sponsoredmusic', $right_id, 5, "Sponsored Playlists", "true");

    //INSERT MOST LIKED GROUP MUSIC WIDGET
    Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroupmusic.homelike-sitegroupmusic', $right_id, 6, "Most Liked Playlists", "true");

    //INSERT RECENT GROUP MUSIC WIDGET
    Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroupmusic.homerecent-sitegroupmusic', $right_id, 7, "Recent Group Playlists", "true");

   //INSERT POPULAR GROUP MUSIC WIDGET
    Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroupmusic.homepopular-sitegroupmusic', $right_id, 8, "Popular Group Playlists", "true");

    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'communityad')
            ->where('enabled 	 = ?', 1)
            ->limit(1);
    ;
    $infomation = $select->query()->fetch();
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_settings')
            ->where('name = ?', 'sitegroup.communityads')
            ->where('value 	 = ?', 1)
            ->limit(1);
    ;
    $rowinfo = $select->query()->fetch();
    if ( $infomation && $rowinfo ) {
      Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroup.group-ads', $right_id, 10, "", "true");
    }
  }

  $select = new Zend_Db_Select($db);

  // Check if it's already been placed
  $select = new Zend_Db_Select($db);
  $select
          ->from('engine4_core_pages')
          ->where('name = ?', 'sitegroupmusic_playlist_view')
          ->limit(1);
  ;
  $info = $select->query()->fetch();

  if ( empty($info) ) {
    $db->insert('engine4_core_pages', array(
        'name' => 'sitegroupmusic_playlist_view',
        'displayname' => 'Group Music View Page',
        'title' => 'View Group Music',
        'description' => 'This is the view group for a group music.',
        'custom' => 1,
        'provides' => 'subject=sitegroupmusic',
    ));
    $group_id = $db->lastInsertId('engine4_core_pages');

   // containers
    $db->insert('engine4_core_content', array(
        'page_id' => $group_id,
        'type' => 'container',
        'name' => 'main',
        'parent_content_id' => null,
        'order' => 1,
        'params' => '',
    ));
    $container_id = $db->lastInsertId('engine4_core_content');

    $db->insert('engine4_core_content', array(
        'page_id' => $group_id,
        'type' => 'container',
        'name' => 'right',
        'parent_content_id' => $container_id,
        'order' => 1,
        'params' => '',
    ));
    $right_id = $db->lastInsertId('engine4_core_content');

    $db->insert('engine4_core_content', array(
        'page_id' => $group_id,
        'type' => 'container',
        'name' => 'middle',
        'parent_content_id' => $container_id,
        'order' => 3,
        'params' => '',
    ));
    $middle_id = $db->lastInsertId('engine4_core_content');

    // middle column content
    $db->insert('engine4_core_content', array(
        'page_id' => $group_id,
        'type' => 'widget',
        'name' => 'sitegroupmusic.music-content',
        'parent_content_id' => $middle_id,
        'order' => 1,
        'params' => '',
    ));
    if ( $infomation && $rowinfo ) {
      Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroup.group-ads', $right_id, 1, "", "true");
    }
  }

  $select = new Zend_Db_Select($db);
	$select
	->from('engine4_core_modules')
	->where('name = ?', 'mobi')
	->where('enabled 	 = ?', 1)
	->limit(1);
	;  

	$infomation = $select->query()->fetch();
	if(!empty($infomation)) {
		$select = new Zend_Db_Select($db);
		$select
		->from('engine4_core_pages')
		->where('name = ?', 'sitegroupmusic_mobi_view')
		->limit(1);
		;
		$info = $select->query()->fetch();
		if (empty($info)) {
			$db->insert('engine4_core_pages', array(
						'name' => 'sitegroupmusic_mobi_view',
						'displayname' => 'Mobile Group Music Profile',
						'title' => 'Mobile Group Music Profile',
						'description' => 'This is the mobile verison of a Group music profile group.',
						'custom' => 0,
			));
			$group_id = $db->lastInsertId('engine4_core_pages');

			// containers
			$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'container',
						'name' => 'main',
						'parent_content_id' => null,
						'order' => 1,
						'params' => '',
			));
			$container_id = $db->lastInsertId('engine4_core_content');

			$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'container',
						'name' => 'right',
						'parent_content_id' => $container_id,
						'order' => 1,
						'params' => '',
			));
			$right_id = $db->lastInsertId('engine4_core_content');

			$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $container_id,
						'order' => 3,
						'params' => '',
			));
			$middle_id = $db->lastInsertId('engine4_core_content');

			// middle column content
			$db->insert('engine4_core_content', array(
					'page_id' => $group_id,
					'type' => 'widget',
					'name' => 'sitegroupmusic.music-content',
					'parent_content_id' => $middle_id,
					'order' => 1,
					'params' => '',
			));
		}
	}

  $db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`)
	VALUES ("sitegroupmusic_admin_widget_settings", "sitegroupmusic", "Widget Settings", "", \'{"route":"admin_default","module":"sitegroupmusic","controller":"widgets"}\', "sitegroupmusic_admin_main", "", 1, 0, 3)');

  $db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitegroupmusic_admin_submain_general_tab", "sitegroupmusic", "General Settings", "", \'{"route":"admin_default","module":"sitegroupmusic","controller":"widgets", "action": "index"}\', "sitegroupmusic_admin_submain", "", 1, 0, 1)');

	$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitegroupmusic_admin_submain_music_tab", "sitegroupmusic", "Tabbed Musics Widget", "", \'{"route":"admin_default","module":"sitegroupmusic","controller":"settings", "action": "widget"}\', "sitegroupmusic_admin_submain", "", 1, 0, 2)');

	$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitegroupmusic_admin_submain_dayitems", "sitegroupmusic", "Music of the Day", "", \'{"route":"admin_default","module":"sitegroupmusic","controller":"settings", "action": "manage-day-items"}\', "sitegroupmusic_admin_submain", "", 1, 0, 4)');


	$select = new Zend_Db_Select($db);
	$select
					->from('engine4_core_pages')
					->where('name = ?', 'sitegroupmusic_playlist_home')
					->limit(1);
	$info = $select->query()->fetch();
	if (empty($info)) {
		$db->insert('engine4_core_pages', array(
				'name' => 'sitegroupmusic_playlist_home',
				'displayname' => 'Group Music Home',
				'title' => 'Group Music Home',
				'description' => 'This is group music home group.',
				'custom' => 1
		));
		$group_id = $db->lastInsertId('engine4_core_pages');

		// containers
		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'container',
				'name' => 'main',
				'parent_content_id' => null,
				'order' => 2,
				'params' => '',
		));
		$container_id = $db->lastInsertId('engine4_core_content');

		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'container',
				'name' => 'right',
				'parent_content_id' => $container_id,
				'order' => 5,
				'params' => '',
		));
		$right_id = $db->lastInsertId('engine4_core_content');

		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'container',
				'name' => 'left',
				'parent_content_id' => $container_id,
				'order' => 4,
				'params' => '',
		));
		$left_id = $db->lastInsertId('engine4_core_content');

		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'container',
				'name' => 'top',
				'parent_content_id' => null,
				'order' => 1,
				'params' => '',
		));
		$top_id = $db->lastInsertId('engine4_core_content');

		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'container',
				'name' => 'middle',
				'parent_content_id' => $top_id,
				'order' => 6,
				'params' => '',
		));
		$top_middle_id = $db->lastInsertId('engine4_core_content');

		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'container',
				'name' => 'middle',
				'parent_content_id' => $container_id,
				'order' => 6,
				'params' => '',
		));
		$middle_id = $db->lastInsertId('engine4_core_content');

	// Top Middle
		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'widget',
				'name' => 'sitegroup.browsenevigation-sitegroup',
				'parent_content_id' => $top_middle_id,
				'order' => 3,
				'params' => '',
		));

		// Left
		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'widget',
				'name' => 'sitegroupmusic.homerecent-sitegroupmusic',
				'parent_content_id' => $left_id,
				'order' => 14,
				'params' => '{"title":"Recent Group Playlists","titleCount":"true"}',
		));

    $db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'widget',
				'name' => 'sitegroupmusic.homepopular-sitegroupmusic',
				'parent_content_id' => $left_id,
				'order' => 15,
				'params' => '{"title":"Popular Group Playlists","titleCount":"true"}',
		));

	// Middele
		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'widget',
				'name' => 'sitegroupmusic.featured-musics-carousel',
				'parent_content_id' => $middle_id,
				'order' => 17,
				'params' => '{"title":"Featured Playlists","vertical":"0", "noOfRow":"2","inOneRow":"3","interval":"250","name":"sitegroupmusic.featured-musics-carousel"}',
		));

		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'widget',
				'name' => 'sitegroupmusic.list-musics-tabs-view',
				'parent_content_id' => $middle_id,
				'order' => 18,
				'params' => '{"title":"Playlists","margin_photo":"12"}',
		));
		// Right Side
		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'widget',
				'name' => 'sitegroupmusic.sitegroupmusiclist-link',
				'parent_content_id' => $right_id,
				'order' => 20,
				'params' => '',
		));

		// Right Side
		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'widget',
				'name' => 'sitegroupmusic.search-sitegroupmusic',
				'parent_content_id' => $right_id,
				'order' => 19,
				'params' => '',
		));

		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'widget',
				'name' => 'sitegroupmusic.music-of-the-day',
				'parent_content_id' => $left_id,
				'order' => 13,
				'params' => '{"title":"Playlist of the Day"}',
		));

		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'widget',
				'name' => 'sitegroupmusic.homefeaturelist-sitegroupmusics',
				'parent_content_id' => $right_id,
				'order' => 21,
				'params' => '{"title":"Featured Playlists","itemCountPerGroup":3}',
		));


		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'widget',
				'name' => 'sitegroupmusic.homecomment-sitegroupmusic',
				'parent_content_id' => $right_id,
				'order' => 22,
				'params' => '{"title":"Most Commented Playlists","titleCount":"true"}',
		));

		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'widget',
				'name' => 'sitegroupmusic.homelike-sitegroupmusic',
				'parent_content_id' => $right_id,
				'order' => 23,
				'params' => '{"title":"Most Liked Playlists","titleCount":"true"}',
		));
	}
}
?>