<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupmusic
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content_user.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$isActive = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupmusic.isActivate', 0);
if (empty($isActive)) {
  return;
}
$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => $view->translate('Group Profile Music'),
        'description' => $view->translate('Forms the Music tab of your Group and shows music of your Group. It should be placed in the Tabbed Blocks area of the Group Profile.'),
        'category' => $view->translate('Group Profile'),
        'type' => 'widget',
        'name' => 'sitegroupmusic.profile-sitegroupmusic',
        'defaultParams' => array(
            'title' => $view->translate('Music'),
        ),
    ),
    array(
        'title' => $view->translate('Group Profile Most Popular Playlists'),
        'description' => $view->translate("Displays your Group's most popular playlists."),
        'category' => $view->translate('Group Profile'),
        'type' => 'widget',
        'name' => 'sitegroupmusic.popular-sitegroupmusic',
        'defaultParams' => array(
            'title' => $view->translate('Most Popular Playlists'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Group Profile Most Commented Playlists'),
        'description' => $view->translate("Displays your Group's most commented playlists."),
        'category' => $view->translate('Group Profile'),
        'type' => 'widget',
        'name' => 'sitegroupmusic.comment-sitegroupmusic',
        'defaultParams' => array(
            'title' => $view->translate('Most Commented Playlists'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Group Profile Most Recent Playlists'),
        'description' => $view->translate("Displays your Group's most recent playlists."),
        'category' => $view->translate('Group Profile'),
        'type' => 'widget',
        'name' => 'sitegroupmusic.recent-sitegroupmusic',
        'defaultParams' => array(
            'title' => $view->translate('Most Recent Playlists'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Group Profile Most Liked Playlists'),
        'description' => $view->translate("Displays your Group's most liked playlists."),
        'category' => $view->translate('Group Profile'),
        'type' => 'widget',
        'name' => 'sitegroupmusic.like-sitegroupmusic',
        'defaultParams' => array(
            'title' => $view->translate('Most Liked Playlists'),
            'titleCount' => true,
        ),
    ),
    array(
	    'title' => $view->translate('Group Profile Player'),
	    'description' => $view->translate("Displays a music player that plays the playlist that you select to be played on your Group Profile."),
	    'category' => 'Group Profile',
	    'type' => 'widget',
	    'name' => 'sitegroupmusic.profile-player',
   ),  
)
?>