<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupnote
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: IndexController.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupnote_IndexController extends Seaocore_Controller_Action_Standard {

  public function init() {

    //GET GROUP ID
    $group_id = $this->_getParam('group_id');

    //PACKAGE BASE PRIYACY START
    if (!empty($group_id)) {
      $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $group_id);
      if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
        if (!Engine_Api::_()->sitegroup()->allowPackageContent($sitegroup->package_id, "modules", "sitegroupnote")) {
          return $this->_forwardCustom('requireauth', 'error', 'core');
        }
      } else {
        $isGroupOwnerAllow = Engine_Api::_()->sitegroup()->isGroupOwnerAllow($sitegroup, 'sncreate');
        if (empty($isGroupOwnerAllow)) {
          return $this->_forwardCustom('requireauth', 'error', 'core');
        }
      }
    }
    //PACKAGE BASE PRIYACY END    
    else {
      if ($this->_getParam('note_id') != null) {
        $sitegroupnote = Engine_Api::_()->getItem('sitegroupnote_note', $this->_getParam('note_id'));
        $group_id = $sitegroupnote->group_id;
      }
    }

    //GET NOTE ID
    $note_id = $this->_getParam('note_id');
    if ($note_id) {
      $sitegroupnote = Engine_Api::_()->getItem('sitegroupnote_note', $note_id);
      if ($sitegroupnote) {
        Engine_Api::_()->core()->setSubject($sitegroupnote);
      }
    }
  }

  //ACTION FOR CREATE THE NEW NOTE
  public function createAction() {

    //CHECK USER VALIDATION
    if (!$this->_helper->requireUser()->isValid())
      return;

    //GET LOGGED IN USER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();

    //GROUP ID 
    $group_id = $this->_getParam('group_id');

    //SEND TAB TO TPL FILE
    $this->view->tab_selected_id = $this->_getParam('tab');

    //GET SITEGROUP ITEM
    $this->view->sitegroup = $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $group_id);

    $sitegroupnote_viewPer = Zend_Registry::isRegistered('sitegroupnote_viewPer') ? Zend_Registry::get('sitegroupnote_viewPer') : null;
    $getPackageNoteCreate = Engine_Api::_()->sitegroup()->getPackageAuthInfo('sitegroupnote');

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'view');
    if (empty($isManageAdmin) || empty($getPackageNoteCreate)) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }

    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
    if (empty($isManageAdmin)) {
      $this->view->can_edit = $can_edit = 0;
    } else {
      $this->view->can_edit = $can_edit = 1;
    }
 
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'sncreate');
    if (empty($isManageAdmin) && empty($can_edit)) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }
    //END MANAGE-ADMIN CHECK
    //CHECKING THE HOSTNAME
    $sitegroupModHostName = str_replace('www.', '', strtolower($_SERVER['HTTP_HOST']));
    if (empty($sitegroupnote_viewPer)) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }

    //GET NAVIGATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitegroup_main');

    //SHOW NOTE CREATE FORM
    $this->view->form = $form = new Sitegroupnote_Form_Create();
    
    if (!Engine_API::_()->seaocore()->checkSitemobileMode('fullsite-mode')) {
			$form->addElement("dummy", "dummy", array('label' => 'Main Photo', 'description' => 'Sorry, the browser you are using does not support Photo uploading. We recommend you to create a Note from your mobile / tablet without uploading a main photo for it. You can later upload the main photo from your Desktop.', 'order' => 6, 'style' => 'display:none;'));
			if (preg_match('/' . 'iPad' . '/i', $_SERVER['HTTP_USER_AGENT'])) {
				if (isset($form->photo)){
					$form->removeElement('photo');
				}	
			} else {
         if (isset($form->photo)){
           $form->photo->setAttrib('accept', "image/*");
         }
      }
    }

    // Populate with categories
    $categories = Engine_Api::_()->getDbtable('categories', 'sitegroupnote')->getCategoriesAssoc();
    asort($categories, SORT_LOCALE_STRING);
    $categoryOptions = array('0' => '');
    foreach ($categories as $k => $v) {
      $categoryOptions[$k] = $v;
    }
    if (sizeof($categoryOptions) <= 1) {
      $form->removeElement('category_id');
    } else {
      $form->category_id->setMultiOptions($categoryOptions);
    }    

    //CHECKING THE TYPE OF THE NOTE
    $get_note_type = Engine_Api::_()->getItemTable('sitegroupnote_note')->getNoteType();
    $isModType = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupnote.set.type', 0);
    if (empty($isModType)) {
      Engine_Api::_()->getApi('settings', 'core')->setSetting('sitegroupnote.draft.type', convert_uuencode($sitegroupModHostName));
    }

    //CHECK FORM VALIDATION
    if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
      //CONNECT WITH NOTE TABLE
      $tableNote = Engine_Api::_()->getItemTable('sitegroupnote_note');
      $db = $tableNote->getAdapter();
      $db->beginTransaction();
      try {
        //GET POSTED VALUES FROM CREATE FORM
        $values = array_merge($form->getValues(), array(
            'owner_id' => $viewer->getIdentity(),
            'group_id' => $group_id,
            'parent_type' => 'sitegroup_group',
            'view_count' => 1
                ));

        if (empty($get_note_type)) {
          return;
        }

        //CREATE THE NOTE
        $sitegroupnote = $tableNote->createRow();
        $sitegroupnote->setFromArray($values);
        $sitegroupnote->body = $_POST['body'];
        $sitegroupnote->save();

        //COMMENT PRIVACY
        $auth = Engine_Api::_()->authorization()->context;
        $roles = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
        $commentMax = array_search("everyone", $roles);
        foreach ($roles as $i => $role) {
          $auth->setAllowed($sitegroupnote, $role, 'comment', ($i <= $commentMax));
        }

        //CHECKING THE PHOTO FIELD EMPTY OR NOT.
        if (!empty($values['photo'])) {
          $sitegroupnote->setPhoto($form->photo);
          $sitegroupnote->total_photos++;
          $sitegroupnote->save();
        }

        //CHECKING THE TAG FIELD EMPTY OR NOT.
        if (!empty($values['tags'])) {
          $sitegroupnote->tags()->addTagMaps($viewer, preg_split('/[,]+/', $values['tags']));
        }

        //INSERT ACTIVITY IF NOTE IS PUBLISHED
        if (isset($values['draft']) && $values['draft'] == 0 && $values['search'] == 1) {
          $actionTable = Engine_Api::_()->getDbtable('actions', 'activity');
          $activityFeedType = null;
          if (Engine_Api::_()->sitegroup()->isGroupOwner($sitegroup) && Engine_Api::_()->sitegroup()->isFeedTypeGroupEnable())
            $activityFeedType = 'sitegroupnote_admin_new';
          elseif ($sitegroup->all_post || Engine_Api::_()->sitegroup()->isGroupOwner($sitegroup))
            $activityFeedType = 'sitegroupnote_new';
          if ($activityFeedType) {
            $action = $actionTable->addActivity($viewer, $sitegroup, $activityFeedType);
            Engine_Api::_()->getApi('subCore', 'sitegroup')->deleteFeedStream($action);
          }
          //MAKE SURE ACTION EXISTS BEFOR ATTACHING THE NOTE TO THE ACTIVITY
          if ($action != null) {
            $actionTable->attachActivity($action, $sitegroupnote);
          }

          //SENDING ACTIVITY FEED TO FACEBOOK.
          $enable_Facebooksefeed = $enable_fboldversion = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('facebooksefeed');
          if (!empty($enable_Facebooksefeed)) {
            $note_array = array();
            $note_array['type'] = 'sitegroupnote_new';
            $note_array['object'] = $sitegroupnote;
            Engine_Api::_()->facebooksefeed()->sendFacebookFeed($note_array);
          }

					
					//GROUP NOTE CREATE NOTIFICATION AND EMAIL WORK
					if(!empty($action)) {
						$sitegroupVersion = Engine_Api::_()->getDbtable('modules', 'core')->getModule('sitegroup')->version;
						if ($sitegroupVersion >= '4.3.0p1') {
							Engine_Api::_()->sitegroup()->sendNotificationEmail($sitegroupnote, $action, 'sitegroupnote_create', 'SITEGROUPNOTE_CREATENOTIFICATION_EMAIL', 'Groupevent Invite');
							
							$isGroupAdmins = Engine_Api::_()->getDbtable('manageadmins', 'sitegroup')->isGroupAdmins($viewer->getIdentity(), $group_id);
							if (!empty($isGroupAdmins)) {

								//NOTIFICATION FOR ALL FOLLWERS.
								Engine_Api::_()->sitegroup()->sendNotificationToFollowers($sitegroupnote, $action, 'sitegroupnote_create');
							}
						}
					}
        }

        $db->commit();
      } catch (Exception $e) {
        $db->rollBack();
        throw $e;
      }

      //CHECKING IF IMAGE UPLOAD IS ALLOWED OR NOT.IF ALLOWED THEN RETURN TO THE PHOTO SUCCESS GROUP AND IF THE IMAGE ALLOWED IS NOT TRUE THEN WE REDIRECTING TO THE NOTE VIEW GROUP.
      if (Engine_Api::_()->getApi('settings', 'core')->sitegroupnote_allow_image) {
        return $this->_helper->redirector->gotoRoute(array('action' => 'success', 'note_id' => $sitegroupnote->note_id, 'tab' => $this->view->tab_selected_id), 'sitegroupnote_specific', true);
      } else {
        return $this->_helper->redirector->gotoUrl($sitegroupnote->getHref(), array('prependBase' => false));
      }
    }
  }

  //ACTION FOR SHOWING THE ADD PHOTO FORM
  public function successAction() {

    //CHECK USER VALIDATION
    if (!$this->_helper->requireUser()->isValid())
      return;

    //GET THE ITEM OF SITEGROUPNOTE
    $this->view->sitegroupnote = $sitegroupnote = Engine_Api::_()->getItem('sitegroupnote_note', $this->_getParam('note_id'));

    //CHECKING WHETHER THE USER HAVE THE PERMISSION OR NOT.
    if (Engine_Api::_()->user()->getViewer()->getIdentity() != $sitegroupnote->owner_id) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }

    //GET NAVIGATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitegroup_main');

    //GROUP ID
    $group_id = $sitegroupnote->group_id;

    //SEND TAB TO TPL FILE
    $this->view->tab_selected_id = $this->_getParam('tab');

    //GET SITEGROUP ITEM
    $this->view->sitegroup = $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $group_id);

    //IF FORM IS POSTED SUCCESSFULLY THEN WE REDIRECT IT.
    if ($this->getRequest()->isPost() && $this->getRequest()->getPost('confirm') == true) {
      if (Engine_API::_()->seaocore()->checkSitemobileMode('fullsite-mode')) {
				return $this->_gotoRouteCustom(array('note_id' => $sitegroupnote->note_id, 'tab' => $this->view->tab_selected_id), 'sitegroupnote_photoupload', true);
      } else {
				return $this->_gotoRouteCustom(array('note_id' => $sitegroupnote->note_id, 'tab' => $this->view->tab_selected_id), 'sitegroupnote_sitemobilephotoupload', true);
      }
    }
  }

  //ACTION FOR EDIT THE NOTE
  public function editAction() {

    //CHECK USER VALIDATION
    if (!$this->_helper->requireUser()->isValid())
      return;

    //GET LOGGED IN USER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();

    //SEND TAB ID TO TPL FILE
    $this->view->tab_selected_id = $this->_getParam('tab');

    //NOTE ITEM
    $sitegroupnote = Engine_Api::_()->getItem('sitegroupnote_note', $this->_getParam('note_id'));
    $getPackageNoteEdit = Engine_Api::_()->sitegroup()->getPackageAuthInfo('sitegroupnote');

    //GROUP ID
    $group_id = $sitegroupnote->group_id;

    //GET NAVIGATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitegroup_main');

    //GENERATE EDIT FORM
    $this->view->form = $form = new Sitegroupnote_Form_Edit(array('item' => $sitegroupnote));

    if (!Engine_API::_()->seaocore()->checkSitemobileMode('fullsite-mode')) {
			$form->addElement("dummy", "dummy", array('label' => 'Main Photo', 'description' => 'Sorry, the browser you are using does not support Photo uploading. We recommend you to edit a Note from your mobile / tablet without uploading a main photo for it. You can later upload the main photo from your Desktop.', 'order' => 7, 'style' => 'display:none;'));
			if (preg_match('/' . 'iPad' . '/i', $_SERVER['HTTP_USER_AGENT'])) {
				if (isset($form->photo)){
					$form->removeElement('photo');
				}	
			} else {
         if (isset($form->photo)){
           $form->photo->setAttrib('accept', "image/*");
         }
      }
    }

    //GET SITEGROUP ITEM
    $this->view->sitegroup = $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $group_id);

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK
    //SUPERADMIN, NOTE OWNER AND SITEGROUP OWNER CAN EDIT VIDEO
    if ($viewer->getIdentity() != $sitegroupnote->owner_id && $can_edit != 1) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }

    //IF NOTE IN PUBLISHED STAT THAN REMOVE ELEMENT
    if ($sitegroupnote->draft == "0") {
      $form->removeElement('draft');
    }

    //REMOVING THE PHOTO ELEMENT FROM THE FORM
    $form->removeElement('photo');

    //PREPARE TAGS
    $sitegroupTags = $sitegroupnote->tags()->getTagMaps();
    $tagString = '';
    foreach ($sitegroupTags as $tagmap) {
      if ($tagString !== '') {
        $tagString .= ', ';
      }
      $tagString .= $tagmap->getTag()->getTitle();
    }
    $form->tags->setValue($tagString);

    //IF NOT POST OR FORM NOT VALID, RETURN
    if (!$this->getRequest()->isPost()) {
      $form->populate($sitegroupnote->toArray());
      return;
    }

    //IF NOT POST OR FORM NOT VALID, RETURN
    if (!$form->isValid($this->getRequest()->getPost())) {
      return;
    }

    //GETTING THE FORM VALUES
    $values = empty($getPackageNoteEdit) ? null : $form->getValues();
    if (empty($values)) {
      return;
    }

    //PROCESS
    Engine_Api::_()->sitegroupnote()->setNotePackages();
    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    try {
      //SAVE NOTE DETAIL
      $sitegroupnote->setFromArray($values);
      $sitegroupnote->body = $_POST['body'];
      $sitegroupnote->modified_date = date('Y-m-d H:i:s');
      $sitegroupnote->tags()->setTagMaps($viewer, preg_split('/[,]+/', $values['tags']));
      $sitegroupnote->save();

      //INSERT NEW ACTIVITY IF NOTE IS JUST GETTING PUBLISHED
      $action = Engine_Api::_()->getDbtable('actions', 'activity')->getActionsByObject($sitegroupnote);
      if (count($action->toArray()) <= 0 && isset($values['draft'])) {
        if ($values['draft'] == 0 && $sitegroupnote->search == 1) {
          $actionTable = Engine_Api::_()->getDbtable('actions', 'activity');
          $activityFeedType = null;
          if (Engine_Api::_()->sitegroup()->isGroupOwner($sitegroup) && Engine_Api::_()->sitegroup()->isFeedTypeGroupEnable())
            $activityFeedType = 'sitegroupnote_admin_new';
          elseif ($sitegroup->all_post || Engine_Api::_()->sitegroup()->isGroupOwner($sitegroup))
            $activityFeedType = 'sitegroupnote_new';
          if ($activityFeedType) {
            $action = $actionTable->addActivity($viewer, $sitegroup, $activityFeedType);
            Engine_Api::_()->getApi('subCore', 'sitegroup')->deleteFeedStream($action);
          }
          //MAKE SURE ACTION EXISTS BEFOR ATTACHING THE NOTE TO THE ACTIVITY
          if ($action != null) {
            $actionTable->attachActivity($action, $sitegroupnote);
          }
        }
      }
      $db->commit();
    } catch (Exception $e) {
      $db->rollBack();
      throw $e;
    }

    //REDIRECTING TO THE NOTE VIEW GROUP
    return $this->_redirectCustom($sitegroupnote->getHref(), array('prependBase' => false));
  }

  //ACTION FOR DELETE NOTES
  public function deleteAction() {

    //CHECK USER VALIDATION
    if (!$this->_helper->requireUser()->isValid())
      return;

    //GROUP ID
    $group_id = $this->_getParam('group_id');

    //SEND TAB TO TPL FILE
    $this->view->tab_selected_id = $this->_getParam('tab');

    //GET NAVIGATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitegroup_main');

    //GET NOTE ITEM
    $this->view->sitegroupnote = $sitegroupnote = Engine_Api::_()->getItem('sitegroupnote_note', $this->_getParam('note_id'));

    //GET SITEGROUP ITEM
    $this->view->sitegroup = $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $group_id);

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK
    //NOTE OWNER AND GROUP OWNER CAN DELETE VIDEO
    if (Engine_Api::_()->user()->getViewer()->getIdentity() != $sitegroupnote->owner_id && $can_edit != 1) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }

    //IF NOT POST OR FORM NOT VALID
    if ($this->getRequest()->isPost() && $this->getRequest()->getPost('confirm') == true) {

      //DELETE NOTE ALBUM AND VIDEO PHOTOS
      Engine_Api::_()->sitegroupnote()->deleteContent($this->_getParam('note_id'));

      //AFTER DELETING THE NOTE WE REDIRECT ON SITEGROUP VIEW GROUP
      return $this->_gotoRouteCustom(array('group_url' => Engine_Api::_()->sitegroup()->getGroupUrl($group_id), 'tab' => $this->view->tab_selected_id), 'sitegroup_entry_view', true);
    }
  }

  //ACTION FOR VIEW THE NOTE
  public function viewAction() {

     //IF SITEGROUPNOTE SUBJECT IS NOT THEN RETURN
    if (!$this->_helper->requireSubject('sitegroupnote_note')->isValid())
      return;

    //GET LOGGED IN USER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();

    //GET NOTE ITEM
    $sitegroupnote = Engine_Api::_()->getItem('sitegroupnote_note', $this->getRequest()->getParam('note_id'));

    //GET SITEGROUP ITEM
    $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $sitegroupnote->group_id);

    //PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitegroup()->allowPackageContent($sitegroup->package_id, "modules", "sitegroupnote")) {
        return $this->_forwardCustom('requireauth', 'error', 'core');
      }
    } else {
      $isGroupOwnerAllow = Engine_Api::_()->sitegroup()->isGroupOwnerAllow($sitegroup, 'sncreate');
      if (empty($isGroupOwnerAllow)) {
        return $this->_forwardCustom('requireauth', 'error', 'core');
      }
    }
    //PACKAGE BASE PRIYACY END

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'sncreate');
    if (empty($isManageAdmin)) {
      $this->view->can_create = 0;
    } else {
      $this->view->can_create = 1;
    }
    
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'view');
    if (empty($isManageAdmin)) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }
    //END MANAGE-ADMIN CHECK

    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK
    //CHECKING THE USER HAVE THE PERMISSION TO VIEW THE NOTE OR NOT
    if ($viewer_id != $sitegroupnote->owner_id && $can_edit != 1 && $sitegroupnote->search != 1) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }   

    //NAVIGATION WORK FOR FOOTER.(DO NOT DISPLAY NAVIGATION IN FOOTER ON VIEW PAGE.)
    if (!Engine_API::_()->seaocore()->checkSitemobileMode('fullsite-mode')) {
         if(!Zend_Registry::isRegistered('sitemobileNavigationName')){
         Zend_Registry::set('sitemobileNavigationName','setNoRender');
         }
    }
    
    //CHECK THE VERSION OF THE CORE MODULE
    $coremodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core');
    $coreversion = $coremodule->version;
    if ($coreversion < '4.1.0') {
      $this->_helper->content->render();
    } else {
      $this->_helper->content
              ->setNoRender()
              ->setEnabled()
      ;
    }
  }

  //ACTION FOR NOTE PUBLISH
  public function publishAction() {

    //CHECK USER VALIDATION
    if (!$this->_helper->requireUser()->isValid())
      return;

    //GET LOGGED IN USER INFORMATION
    $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();

    //SMOOTHBOX
    if (null === $this->_helper->ajaxContext->getCurrentContext()) {
      $this->_helper->layout->setLayout('default-simple');
    } else {//NO LAYOUT
      $this->_helper->layout->disableLayout(true);
    }

    //SEND TAB AND NOTE ID TO TPL FILE
    $this->view->tab_selected_id = $this->_getParam('tab');
    $note_id = $this->view->note_id = $this->_getParam('note_id');

    //IF NOT POST OR FORM NOT VALID, RETURN
    if (!$this->getRequest()->isPost())
      return;

    //GET NOTE ITEM
    $sitegroupnote = Engine_Api::_()->getItem('sitegroupnote_note', $note_id);

    //GROUP ID
    $group_id = $sitegroupnote->group_id;

    //GET SITEGROUP ITEM
    $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $group_id);

    //START MANAGE-ADMIN CHECK    
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK
    //SUPERADMIN, NOTE OWNER AND SITEGROUP OWNER CAN PUBLISH NOTE
    if ($viewer_id != $sitegroupnote->owner_id && $can_edit != 1) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }

    //SUPERADMIN, VIDEO OWNER AND SITEGROUP OWNER CAN PUBLISH VIDEO
    if ($viewer_id == $sitegroupnote->owner_id || $can_edit == 1) {
      $this->view->permission = true;
      $this->view->success = false;
      $db = Engine_Api::_()->getDbtable('notes', 'sitegroupnote')->getAdapter();
      $db->beginTransaction();
      try {
        $sitegroupnote->modified_date = new Zend_Db_Expr('NOW()');
        $sitegroupnote->draft = 0;
        $sitegroupnote->save();
        $db->commit();
        $this->view->success = true;
      } catch (Exception $e) {
        $db->rollback();
        throw $e;
      }

      //ADD ACTIVITY ONLY IF NOTES IS PUBLISHED
      if ($sitegroupnote->draft == 0) {
        $api = Engine_Api::_()->getDbtable('actions', 'activity');
        $activityFeedType = null;
        $creator = Engine_Api::_()->getItem('user', $sitegroupnote->owner_id);
        if (Engine_Api::_()->sitegroup()->isGroupOwner($sitegroup) && Engine_Api::_()->sitegroup()->isFeedTypeGroupEnable())
          $activityFeedType = 'sitegroupnote_admin_new';
        elseif ($sitegroup->all_post || Engine_Api::_()->sitegroup()->isGroupOwner($sitegroup))
          $activityFeedType = 'sitegroupnote_new';

        if ($activityFeedType) {
          $action = $api->addActivity($creator, $sitegroup, $activityFeedType);
          Engine_Api::_()->getApi('subCore', 'sitegroup')->deleteFeedStream($action);
        }
        //MAKE SURE ACTION EXISTS BEFORE ATTACHING THE NOTES TO THE ACTIVITY
        if ($action != null) {
          $api->attachActivity($action, $sitegroupnote);
          $sitegroupnote->save();
        }
      }
    } else {
      $this->view->permission = false;
    }

    $this->_forwardCustom('success', 'utility', 'core', array(
        'smoothboxClose' => 2,
        'parentRedirect' => $this->_helper->url->url(array('group_url' => Engine_Api::_()->sitegroup()->getGroupUrl($group_id), 'tab' => $this->view->tab_selected_id), 'sitegroup_entry_view'),
        'parentRedirectTime' => '2',
        'format' => 'smoothbox',
        'messages' => array(Zend_Registry::get('Zend_Translate')->_('Successfully Published !')
            )));
  }

  //ACTION FOR UPLOADING THE NOTE PHOTOS FROM THE EDITOR
  public function uploadPhotoAction() {

    //CHECK USER VALIDATION
    if (!$this->_helper->requireUser()->isValid())
      return;

    //LAYOUT
    $this->_helper->layout->disableLayout();
    if (!$this->_helper->requireUser()->checkRequire()) {
      $this->view->status = false;
      $this->view->error = Zend_Registry::get('Zend_Translate')->_('Max file size limit exceeded (probably).');
      return;
    }

    //GROUP ID
    $group_id = $this->_getParam('group_id');
    $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $group_id);

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'spcreate');
    if (empty($isManageAdmin)) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }
    //END MANAGE-ADMIN CHECK
    //IF NOT POST OR FORM NOT VALID, RETURN
    if (!$this->getRequest()->isPost()) {
      $this->view->status = false;
      $this->view->error = Zend_Registry::get('Zend_Translate')->_('Invalid request method');
      return;
    }

    //IF NOT POST OR FORM NOT VALID, RETURN
     $fileName = Engine_Api::_()->seaocore()->tinymceEditorPhotoUploadedFileName();
    if (!isset($_FILES[$fileName]) || !is_uploaded_file($_FILES[$fileName]['tmp_name'])) {
      $this->view->status = false;
      $this->view->error = Zend_Registry::get('Zend_Translate')->_('Invalid Upload');
      return;
    }

    //PROCESS
    $db = Engine_Api::_()->getDbtable('photos', 'sitegroup')->getAdapter();
    $db->beginTransaction();
    try {
      //CREATE PHOTO
      $tablePhoto = Engine_Api::_()->getDbtable('photos', 'sitegroup');
      $photo = $tablePhoto->createRow();
      $photo->setFromArray(array(
          'user_id' => Engine_Api::_()->user()->getViewer()->getIdentity(),
          'group_id' => $group_id
      ));
      $photo->save();
      $photo->setPhoto($_FILES[$fileName]);

      $this->view->status = true;
      $this->view->name = $_FILES[$fileName]['name'];
      $this->view->photo_id = $photo->photo_id;
      $this->view->photo_url = $photo->getPhotoUrl();

      $album = Engine_Api::_()->getDbtable('albums', 'sitegroup')->getSpecialAlbum($sitegroup, 'note');

      //SET GROUP PHOTO PARAMS
      $paramsPhoto = array();
      $paramsPhoto['group_id'] = $group_id;
      $paramsPhoto['album_id'] = $album->album_id;
      $paramsPhoto['order'] = 'order ASC';
      $paramsPhoto['start'] = 1;
      $paramsPhoto['end'] = 1;

      //FETCHING PHOTOS
      $fecthPhotos = Engine_Api::_()->getDbtable('photos', 'sitegroup')->getphotos($paramsPhoto)->toarray();

      $photo->collection_id = $album->album_id;
      $photo->album_id = $album->album_id;
      $order = 0;
      if (!empty($fecthPhotos)) {
        $order = $fecthPhotos[0]['order'] + 1;
      }
      $photo->order = $order;
      $photo->save();

      if (!$album->photo_id) {
        $album->photo_id = $photo->getIdentity();
        $album->save();
      }
      $db->commit();
    } catch (Exception $e) {
      $db->rollBack();
      $this->view->status = false;
      $this->view->error = Zend_Registry::get('Zend_Translate')->_('An error occurred.');
      return;
    }
  }

  public function browseAction() {
   
    //CHECK VIEW PRIVACY
    if (!$this->_helper->requireAuth()->setAuthParams('sitegroup_group', null, 'view')->isValid())
      return;

    //CHECK THE VERSION OF THE CORE MODULE
    $coremodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core');
    $coreversion = $coremodule->version;
    if ($coreversion < '4.1.0') {
      $this->_helper->content->render();
    } else {
      $this->_helper->content
              ->setNoRender()
              ->setEnabled()
      ;
    }
  }

  //ACTION FOR CONSTRUCT TAG CLOUD
  public function tagsCloudAction() {

    //GET NAVIGATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
            ->getNavigation('sitegroup_main');

    //GENERATE TAG-CLOULD HIDDEN FROM
    $this->view->form = $form = new Sitegroup_Form_Searchtagcloud();

    //CONSTRUCTING TAG CLOUD
    $tag_array = array();
    $tag_cloud_array = Engine_Api::_()->getDbtable('notes', 'sitegroupnote')->getTagCloud('', 0);
    $tag_id_array = array();
    foreach ($tag_cloud_array as $vales) {
      $tag_array[$vales['text']] = $vales['Frequency'];
      $tag_id_array[$vales['text']] = $vales['tag_id'];
    }

    if (!empty($tag_array)) {
      $max_font_size = 18;
      $min_font_size = 12;
      $max_frequency = max(array_values($tag_array));
      $min_frequency = min(array_values($tag_array));
      $spread = $max_frequency - $min_frequency;

      if ($spread == 0) {
        $spread = 1;
      }

      $step = ($max_font_size - $min_font_size) / ($spread);

      $tag_data = array('min_font_size' => $min_font_size, 'max_font_size' => $max_font_size, 'max_frequency' => $max_frequency, 'min_frequency' => $min_frequency, 'step' => $step);

      $this->view->tag_data = $tag_data;
      $this->view->tag_id_array = $tag_id_array;
    }
    $this->view->tag_array = $tag_array;
  }

   //ACTION FOR MAKE THE SITEGROUPNOTE FEATURED/UNFEATURED
  public function featuredAction() {

    //CHECK USER VALIDATION
    if (!$this->_helper->requireUser()->isValid())
      return;

    //GET NOTE ID AND OBJECT
    $note_id = $this->view->note_id = $this->_getParam('note_id');
    $sitegroupnote = Engine_Api::_()->getItem('sitegroupnote_note', $note_id);

    $this->view->featured = $sitegroupnote->featured;

    //GET GROUP OBJECT
    $this->view->sitegroup = $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $sitegroupnote->group_id);

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
    $this->view->canEdit = 0;
    if (!empty($isManageAdmin)) {
      $this->view->canEdit = 1;
    }
    //END MANAGE-ADMIN CHECK
    //SMOOTHBOX
    if (null === $this->_helper->ajaxContext->getCurrentContext()) {
      $this->_helper->layout->setLayout('default-simple');
    } else {//NO LAYOUT
      $this->_helper->layout->disableLayout(true);
    }

    if (!$this->getRequest()->isPost())
      return;

    //GET VIEWER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    $tab_selected_id = $this->_getParam('tab');

    //CHECK THAT FEATURED ACTION IS ALLOWED BY ADMIN OR NOT
    //CHECK CAN MAKE FEATURED OR NOT(ONLY SITEGROUP NOTE CAN MAKE FEATURED/UN-FEATURED)
    if ($viewer_id == $sitegroupnote->owner_id || !empty($this->view->canEdit)) {
      $this->view->permission = true;
      $this->view->success = false;
      $db = Engine_Api::_()->getDbtable('notes', 'sitegroupnote')->getAdapter();
      $db->beginTransaction();
      try {
        if ($sitegroupnote->featured == 0) {
          $sitegroupnote->featured = 1;
        } else {
          $sitegroupnote->featured = 0;
        }

        $sitegroupnote->save();
        $db->commit();
        $this->view->success = true;
      } catch (Exception $e) {
        $db->rollback();
        throw $e;
      }
    } else {
      $this->view->permission = false;
    }

    if ($sitegroupnote->featured) {
      $suc_msg = array(Zend_Registry::get('Zend_Translate')->_('Note successfully made featured.'));
    } else {
      $suc_msg = array(Zend_Registry::get('Zend_Translate')->_('Note successfully made un-featured.'));
    }

    $this->_forwardCustom('success', 'utility', 'core', array(
        'smoothboxClose' => 2,
        'parentRedirect' => $this->_helper->url->url(array('group_url' => Engine_Api::_()->sitegroup()->getGroupUrl($sitegroupnote->group_id), 'tab' => $tab_selected_id), 'sitegroup_entry_view', true),
        'parentRedirectTime' => '2',
        'format' => 'smoothbox',
        'messages' => $suc_msg
    ));
  }

  //ACTION FOR ADDING NOTE OF THE DAY
  public function addNoteOfDayAction() {
    //FORM GENERATION
    $form = $this->view->form = new Sitegroupnote_Form_ItemOfDayday();
    $note_id = $this->_getParam('note_id');
   // $form->setAction($this->getFrontController()->getRouter()->assemble(array()));
    //CHECK POST
    if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {

      //GET FORM VALUES
      $values = $form->getValues();

      //BEGIN TRANSACTION
      $db = Engine_Db_Table::getDefaultAdapter();
      $db->beginTransaction();
      try {

        //GET ITEM OF THE DAY TABLE
        $dayItemTime = Engine_Api::_()->getDbtable('itemofthedays', 'sitegroup');

				//FETCH RESULT FOR resource_id
        $select = $dayItemTime->select()->where('resource_id = ?', $note_id)->where('resource_type = ?', 'sitegroupnote_note');
        $row = $dayItemTime->fetchRow($select);

        if (empty($row)) {
          $row = $dayItemTime->createRow();
          $row->resource_id = $note_id;
        }
        $row->start_date = $values["starttime"];
        $row->end_date = $values["endtime"];
				$row->resource_type = 'sitegroupnote_note';
        $row->save();

        $db->commit();
      } catch (Exception $e) {
        $db->rollBack();
        throw $e;
      }
      return $this->_forwardCustom('success', 'utility', 'core', array(
                  'smoothboxClose' => 10,
                  'messages' => array(Zend_Registry::get('Zend_Translate')->_('The Note of the Day has been added successfully.'))
              ));
    }
  }

  // ACTION FOR FEATURED NOTES CAROUSEL AFTER CLICK ON BUTTON 
  public function featuredNotesCarouselAction() {
    //RETRIVE THE VALUE OF ITEM VISIBLE
    $this->view->itemsVisible = $limit = (int) $_GET['itemsVisible'];

    //RETRIVE THE VALUE OF NUMBER OF ROW
    $this->view->noOfRow = (int) $_GET['noOfRow'];
    //RETRIVE THE VALUE OF ITEM VISIBLE IN ONE ROW
    $this->view->inOneRow = (int) $_GET['inOneRow'];

    // Total Count Featured Photos
    $totalCount = (int) $_GET['totalItem'];

    //RETRIVE THE VALUE OF START INDEX
    $startindex = $_GET['startindex'] * $limit;

    if ($startindex > $totalCount) {
      $startindex = $totalCount - $limit;
    }
    if ($startindex < 0)
      $startindex = 0;

    $params = array();
    $params['category_id'] = $_GET['category_id'];
    $params['zero_count'] = 'featured';

    //RETRIVE THE VALUE OF BUTTON DIRECTION
    $direction = $_GET['direction'];
    $this->view->offset = $params['start_index'] = $startindex;

    //GET Featured Photos with limit * 2
    $this->view->totalItemsInSlide = $params['limit'] = $limit * 2;
    $this->view->featuredNotes = $this->view->featuredNotes = $featuredNotes = Engine_Api::_()->getDbTable('notes', 'sitegroupnote')->widgetNotesData($params);

    //Pass the total number of result in tpl file
    $this->view->count = count($featuredNotes);

    //Pass the direction of button in tpl file
    $this->view->direction = $direction;
  }

   public function homeAction() {
 
    //CHECK VIEW PRIVACY
    if (!$this->_helper->requireAuth()->setAuthParams('sitegroup_group', null, 'view')->isValid())
      return;

     //CHECK THE VERSION OF THE CORE MODULE
    $coremodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core');
    $coreversion = $coremodule->version;
    if ($coreversion < '4.1.0') {
      $this->_helper->content->render();
    } else { 
      $this->_helper->content
              ->setNoRender()
              ->setEnabled()
      ;
    }

  }
}

?>