<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupnote
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: manifest.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$routeStart = "groupmusic";
$module=null;$controller=null;$action=null;$getURL = null;
$request = Zend_Controller_Front::getInstance()->getRequest();
if (!empty($request)) {
  $module = $request->getModuleName(); // Return the current module name.
  $action = $request->getActionName();
  $controller = $request->getControllerName();
  $getURL = $request->getRequestUri();
}
if (empty($request) || !($module == "default" && ( strpos( $getURL, '/install') !== false))) {
  $routeStart = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupnote.manifestUrl', "group-notes");
}
return array(
    'package' =>
    array(
        'type' => 'module',
        'name' => 'sitegroupnote',
        'version' => '5.4.1p1',
        'path' => 'application/modules/Sitegroupnote',
        'title' => 'Groups / Communities - Notes Extension',
        'description' => 'Groups / Communities - Notes Extension',
      'author' => '<a href="http://www.socialapps.tech" style="text-decoration:underline;" target="_blank">SocialApps.tech</a>',
        'date' => 'Thrusday, 05 May 2011 18:33:08 +0000',
        'copyright' => 'Copyright 2010-2011 BigStep Technologies Pvt. Ltd.',
        'callback' => array(
            'path' => 'application/modules/Sitegroupnote/settings/install.php',
            'class' => 'Sitegroupnote_Installer',
        ),
        'actions' =>
        array(
            0 => 'install',
            1 => 'upgrade',
            2 => 'refresh',
            3 => 'enable',
            4 => 'disable',
        ),
        'directories' =>
        array(
            0 => 'application/modules/Sitegroupnote',
        ),
        'files' =>
        array(
            0 => 'application/languages/en/sitegroupnote.csv',
        ),
    ),
    'hooks' => array(
        array(
            'event' => 'onUserDeleteBefore',
            'resource' => 'Sitegroupnote_Plugin_Core',
        ),
//         array(
//             // 'event' => 'addActivity',
//             'event' => 'onRenderLayoutDefault',
//             'resource' => 'Sitegroupnote_Plugin_Core'
//         ),
    ),
    'items' => array(
        'sitegroupnote_note',
        'sitegroupnote_photo',
        'sitegroupnote_album',
    ),
    'sitemobile_compatible' => true,
    // ROUTES --------------------------------------------------------------------
    'routes' => array(
        'sitegroupnote_specific' => array(
            'route' => $routeStart . '/:action/:note_id/*',
            'defaults' => array(
                'module' => 'sitegroupnote',
                'controller' => 'index',
                'action' => 'index',
            ),
            'reqs' => array(
                'note_id' => '\d+',
                'action' => '(delete|edit|close|success)',
            ),
        ),
        'sitegroupnote_detail_view' => array(
            'route' => $routeStart . '/:user_id/:note_id/:slug/*',
            'defaults' => array(
                'module' => 'sitegroupnote',
                'controller' => 'index',
                'action' => 'view',
                'slug' => '',
            ),
            'reqs' => array(
                'user_id' => '\d+',
                'note_id' => '\d+'
            )
        ),
        'sitegroupnote_uploadphoto' => array(
            'route' => $routeStart . '/uploadphoto/*',
            'defaults' => array(
                'module' => 'sitegroupnote',
                'controller' => 'index',
                'action' => 'upload-photo',
            ),
        ),
        'sitegroupnote_create' => array(
            'route' => $routeStart . '/create/:group_id/*',
            'defaults' => array(
                'module' => 'sitegroupnote',
                'controller' => 'index',
                'action' => 'create'
            ),
            'reqs' => array(
                'group_id' => '\d+'
            )
        ),
        'sitegroupnoteadmin_delete' => array(
            'route' => $routeStart . '/admin-manage/delete/:id/*',
            'defaults' => array(
                'module' => 'sitegroupnote',
                'controller' => 'admin-manage',
                'action' => 'delete'
            ),
            'reqs' => array(
                'id' => '\d+'
            )
        ),
        'sitegroupnote_edit' => array(
            'route' => $routeStart . '/edit/:note_id/:group_id/*',
            'defaults' => array(
                'module' => 'sitegroupnote',
                'controller' => 'index',
                'action' => 'edit'
            ),
        ),
        'sitegroupnote_editphoto' => array(
            'route' => $routeStart . '/edit-photo/:note_id/:group_id/*',
            'defaults' => array(
                'module' => 'sitegroupnote',
                'controller' => 'photo',
                'action' => 'edit-photo'
            ),
        ),
        'sitegroupnote_publish' => array(
            'route' => $routeStart . '/publish/:note_id/*',
            'defaults' => array(
                'module' => 'sitegroupnote',
                'controller' => 'index',
                'action' => 'publish'
            ),
            'reqs' => array(
                'group_id' => '\d+'
            )
        ),
        'sitegroupnote_delete' => array(
            'route' => $routeStart . '/delete/:note_id/:group_id/*',
            'defaults' => array(
                'module' => 'sitegroupnote',
                'controller' => 'index',
                'action' => 'delete'
            ),
            'reqs' => array(
                'note_id' => '\d+',
                'group_id' => '\d+'
            )
        ),
        'sitegroupnote_image_specific' => array(
            'route' => $routeStart . '/photo/view/:owner_id/:album_id/:photo_id/*',
            'defaults' => array(
                'module' => 'sitegroupnote',
                'controller' => 'photo',
                'action' => 'view'
            ),
            'reqs' => array(
                'action' => '(view|upload)',
            ),
        ),
        'sitegroupnote_removeimage' => array(
            'route' => $routeStart . '/photo/remove/:note_id/:photo_id/*',
            'defaults' => array(
                'module' => 'sitegroupnote',
                'controller' => 'photo',
                'action' => 'remove',
            ),
        ),
        'sitegroupnote_photoedit' => array(
            'route' => $routeStart . '/photo-edit/:photo_id/:group_id/*',
            'defaults' => array(
                'module' => 'sitegroupnote',
                'controller' => 'photo',
                'action' => 'photo-edit'
            ),
        ),
        'sitegroupnote_photoupload' => array(
            'route' => $routeStart . '/photo/upload/:note_id/*',
            'defaults' => array(
                'module' => 'sitegroupnote',
                'controller' => 'photo',
                'action' => 'upload'
            ),
        ),
        'sitegroupnote_browse' => array(
            'route' => $routeStart . '/browse/*',
            'defaults' => array(
                'module' => 'sitegroupnote',
                'controller' => 'index',
                'action' => 'browse',
            )
        ),
        'sitegroupnote_tags' => array(
            'route' => $routeStart . '/tagscloud/:group/',
            'defaults' => array(
                'module' => 'sitegroupnote',
                'controller' => 'index',
                'action' => 'tags-cloud',
                'group' => 1
            )
        ),
        'sitegroupnote_home' => array(
            'route' => $routeStart.'/home/*',
            'defaults' => array(
                'module' => 'sitegroupnote',
                'controller' => 'index',
                'action' => 'home',
            ),
        ), 

         'sitegroupnote_featured' => array(
            'route' => $routeStart . '/featured/:note_id/*',
            'defaults' => array(
                'module' => 'sitegroupnote',
                'controller' => 'index',
                'action' => 'featured'
            ),
            'reqs' => array(
                'note_id' => '\d+'
            )
        ),

         'sitegroupnote_featurednote' => array(
            'route' => $routeStart .'/admin/featurednote/:id/*',
            'defaults' => array(
                'module' => 'sitegroupnote',
                'controller' => 'admin-manage',
                'action' => 'featurednote',
            ),
            'reqs' => array(
                'id' => '\d+'
            )
        ),
        'sitegroupnote_sitemobilephotoupload' => array(
            'route' => $routeStart . '/photo/upload-sitemobile-photo/:note_id/*',
            'defaults' => array(
                'module' => 'sitegroupnote',
                'controller' => 'photo',
               'action' => 'upload-sitemobile-photo'
            ),
        ),
    ),
);
?>