<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupnote
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupnote_Widget_LikeSitegroupnotesController extends Engine_Content_Widget_Abstract {

  //ACTION FOR SHOWING THE MOST LIKED NOTES ON GROUP PROFILE GROUP
  public function indexAction() {
  	
    //GET SITEGROUP SUBJECT
    $this->view->sitegroup_subject = $sitegroup_subject = Engine_Api::_()->core()->getSubject('sitegroup_group');

    $sitegroupnote_likeContent = Zend_Registry::isRegistered('sitegroupnote_likeContent') ? Zend_Registry::get('sitegroupnote_likeContent') : null;

    // PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitegroup()->allowPackageContent($sitegroup_subject->package_id, "modules", "sitegroupnote")) {
        return $this->setNoRender();
      }
    } else {
      $isGroupOwnerAllow = Engine_Api::_()->sitegroup()->isGroupOwnerAllow($sitegroup_subject, 'sncreate');
      if (empty($isGroupOwnerAllow)) {
        return $this->setNoRender();
      }
    }
    // PACKAGE BASE PRIYACY START
    
    // SET NO RENDER
    $getLevelAuth = Engine_Api::_()->sitegroupnote()->getLevelAuth();
    if (empty($getLevelAuth)) {
      return $this->setNoRender();
    }

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup_subject, 'view');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }

    // SET NO RENDER
    if (empty($sitegroupnote_likeContent)) {
      return $this->setNoRender();
    }
    //END MANAGE-ADMIN CHECK
    
    //SEARCH PARAMETER
    $params = array();
    $params['group_id'] = $sitegroup_subject->group_id;
    $params['orderby'] = 'like_count DESC';
    $params['profile_group_widget'] = 1;
    $params['zero_count'] = 'like_count';
    $params['limit'] = $this->_getParam('itemCount', 3);

    //MAKE PAGINATOR
    $this->view->paginator = $paginator = Engine_Api::_()->getDbTable('notes', 'sitegroupnote')->widgetNotesData($params);

    // SET NO RENDER
    if (Count($paginator) <= 0) {
      return $this->setNoRender();
    }
  }

}

?>