<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupnote
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupnote_Widget_SitemobileProfileSitegroupnotesController extends Engine_Content_Widget_Abstract {

  protected $_childCount;

  //ACTION FOR SHOWING NOTES ON GROUP PROFILE GROUP
  public function indexAction() {
  	
    //GET VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();

    //SET NO RENDER IF NO SUBJECT
    if (!Engine_Api::_()->core()->hasSubject()) {
      return $this->setNoRender();
    }

    //GET VIEWER INFORMATION
    $this->view->viewer_id = $viewer_id = $viewer->getIdentity();

    //GETTING LEVEL
    if (!empty($viewer_id)) {
      $level_id = $this->view->level_id = $viewer->level_id;
    } else {
      $level_id = $this->view->level_id = 0;
    }

    //GET SUBJECT AND GROUP ID AND GROUP OWNER ID
    $this->view->sitegroupSubject = $sitegroupSubject = Engine_Api::_()->core()->getSubject('sitegroup_group');
    $group_id = $sitegroupSubject->group_id;

    //PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitegroup()->allowPackageContent($sitegroupSubject->package_id, "modules", "sitegroupnote")) {
        return $this->setNoRender();
      }
    } else {
      $isGroupOwnerAllow = Engine_Api::_()->sitegroup()->isGroupOwnerAllow($sitegroupSubject, 'sncreate');
      if (empty($isGroupOwnerAllow)) {
        return $this->setNoRender();
      }
    }
    //PACKAGE BASE PRIYACY END
    
    //TOTAL NOTE
    $noteCount = Engine_Api::_()->sitegroup()->getTotalCount($group_id, 'sitegroupnote', 'notes'); 
    $noteCreate = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroupSubject, 'sncreate');
            
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroupSubject, 'view');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }

    $this->view->allowView = false;
    if (!empty($viewer_id) && $viewer->level_id == 1) {
      $this->view->allowView = true;
    } 

    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroupSubject, 'edit');
    if (empty($isManageAdmin)) {
      $this->view->can_edit = $can_edit = 0;
    } else {
      $this->view->can_edit = $can_edit = 1;
    }
   
    if (empty($noteCreate) && empty($noteCount) && empty($can_edit) && !(Engine_Api::_()->sitegroup()->showTabsWithoutContent())) {
      return $this->setNoRender();
    }
    //END MANAGE-ADMIN CHECK

		//MAKING THE SEACHING PARAMATER ARRAY
		$values = array();
		
		//START MANAGE-ADMIN CHECK
		$isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroupSubject, 'sncreate');
		if (empty($isManageAdmin) && empty($can_edit)) {
			$this->view->can_create = 0;
		} else {
			$this->view->can_create = 1;
		}
		//END MANAGE-ADMIN CHECK
		
		//FETCH NOTES
		$values['group_id'] = $group_id;
    $values['orderby'] = 'creation_date';
		if ($can_edit == 1) {
			$values['show_groupnotes'] = 0;
			$this->view->paginator = $paginator = Engine_Api::_()->getDbTable('notes', 'sitegroupnote')->getSitegroupnotesPaginator($values);
		} else {
			$values['show_groupnotes'] = 1;
			$values['note_owner_id'] = $viewer_id;
			$this->view->paginator = $paginator = Engine_Api::_()->getDbTable('notes', 'sitegroupnote')->getSitegroupnotesPaginator($values);
		}

		$this->view->paginator->setItemCountPerPage(10)->setCurrentPageNumber($this->_getParam('group', 1));
    $this->_childCount = $paginator->getTotalItemCount();
  }

  //RETURN THE COUNT OF THE NOTE
  public function getChildCount() {
    return $this->_childCount;
  }

}