<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupoffer
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: IndexController.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupoffer_IndexController extends Seaocore_Controller_Action_Standard {

    protected $_session;

    //ACTION FOR MANAGING OFFERS
    public function indexAction() {

        // CHECK USER VALIDATION
        if (!$this->_helper->requireUser()->isValid())
            return;

        //GET NAVIAGATION
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitegroup_main');

        $this->view->viewer = Engine_Api::_()->user()->getViewer();

        //GET GROUP ID AND GROUP OBJECT
        $group_id = $this->_getParam('group_id');
        $this->view->sitegroup = $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $group_id);

        // PACKAGE BASE PRIYACY START
        if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
            if (!Engine_Api::_()->sitegroup()->allowPackageContent($sitegroup->package_id, "modules", "sitegroupoffer")) {
                return $this->_forwardCustom('requireauth', 'error', 'core');
            }
        } else {
            $isGroupOwnerAllow = Engine_Api::_()->sitegroup()->isGroupOwnerAllow($sitegroup, 'offer');
            if (empty($isGroupOwnerAllow)) {
                return $this->_forwardCustom('requireauth', 'error', 'core');
            }
        }
        // PACKAGE BASE PRIYACY END
        //START MANAGE-ADMIN CHECK
        $can_edit = 1;
        $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
        if (empty($isManageAdmin)) {
            $can_edit = 0;
            return $this->_forwardCustom('requireauth', 'error', 'core');
        }

        $can_offer = 1;
        $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'offer');
        if (empty($isManageAdmin)) {
            $can_offer = 0;
            return $this->_forwardCustom('requireauth', 'error', 'core');
        }
        //END MANAGE-ADMIN CHECK
        //OFFER CREATION AUTHENTICATION CHECK
        if ($can_edit == 1 && $can_offer == 1) {
            $this->view->can_create_offer = 1;
        }

        //SEND TAB ID TO TPL
        $this->view->tab_selected_id = $this->_getParam('tab', null);

        //MAKE PAGINATOR
        $currentGroupNumber = $this->_getParam('group', 1);
        $this->view->paginator = $paginator = Engine_Api::_()->getItemTable('sitegroupoffer_offer')->getSitegroupoffersPaginator($group_id);
        if (!empty($paginator)) {
            $paginator->setItemCountPerPage(50)->setCurrentPageNumber($currentGroupNumber);
        }
        $this->view->count = count($paginator);
    }

    //ACTION FOR CREATE OFFER
    public function createAction() {

        // CHECK USER VALIDATION
        if (!$this->_helper->requireUser()->isValid())
            return;

        $session = new Zend_Session_Namespace();
        if (isset($session->image_path)) {
            unset($session->image_path);
            // IF ANY IMAGE IS CREATE, IT WILL REMOVE THERE
            if (isset($session->photoName_Temp)) {
                unset($session->photoName_Temp);
            }
        }

        //GET LOGGED IN USER INFORMATION
        $viewer = Engine_Api::_()->user()->getViewer();

        //GET NAVIGATION
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitegroup_main');

        //GET GROUP ID AND GROUP OBJECT
        $group_id = $this->_getParam('group_id');
        $this->view->sitegroup = $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $group_id);
        $this->view->offer_group = $offer_group = $this->_getParam('group_offer');
        $this->view->group_offer = $offer_group = $this->_getParam('group_offer');

        // PACKAGE BASE PRIYACY START
        if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
            if (!Engine_Api::_()->sitegroup()->allowPackageContent($sitegroup->package_id, "modules", "sitegroupoffer")) {
                return $this->_forwardCustom('requireauth', 'error', 'core');
            }
        } else {
            $isGroupOwnerAllow = Engine_Api::_()->sitegroup()->isGroupOwnerAllow($sitegroup, 'offer');
            if (empty($isGroupOwnerAllow)) {
                return $this->_forwardCustom('requireauth', 'error', 'core');
            }
        }
        // PACKAGE BASE PRIYACY END
        //START MANAGE-ADMIN CHECK
        $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
        if (empty($isManageAdmin)) {
            return $this->_forwardCustom('requireauth', 'error', 'core');
        }

        if (empty($isManageAdmin)) {
            $this->view->can_edit = $can_edit = 0;
        } else {
            $this->view->can_edit = $can_edit = 1;
        }

        $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'offer');
        if (empty($isManageAdmin)) {
            return $this->_forwardCustom('requireauth', 'error', 'core');
        }
        //END MANAGE-ADMIN CHECK

        $sitegroupoffer_getInfo = Zend_Registry::isRegistered('sitegroupoffer_getInfo') ? Zend_Registry::get('sitegroupoffer_getInfo') : null;
        if (empty($sitegroupoffer_getInfo)) {
            return $this->_forwardCustom('requireauth', 'error', 'core');
        }

        $sitegroupModHostName = str_replace('www.', '', strtolower($_SERVER['HTTP_HOST']));

        $getPackageOffer = Engine_Api::_()->sitegroup()->getPackageAuthInfo('sitegroupoffer');
        $group_offer = Engine_Api::_()->getItemtable('sitegroupoffer_offer')->getOfferList();
        $this->view->tab_selected_id = $this->_getParam('tab');

        //FORM GENERATION
        if (Engine_API::_()->seaocore()->checkSitemobileMode('fullsite-mode')) {
            $this->view->form = $form = new Sitegroupoffer_Form_Create();
        } else {
            $this->view->form = $form = new Sitegroupoffer_Form_SitemobileCreate();
        }

        if (!Engine_API::_()->seaocore()->checkSitemobileMode('fullsite-mode')) {
            $form->addElement("dummy", "dummy", array('label' => 'Offer Picture', 'description' => 'Sorry, the browser you are using does not support Photo uploading. We recommend you to create an Offer from your mobile / tablet without uploading a main photo for it. You can later upload the offer picture from your Desktop.', 'order' => 4, 'style' => 'display:none;'));

            if (isset($form->photo))
                $form->photo->setAttrib('accept', "image/*");
        }
        if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
            if (empty($group_offer)) {
                return;
            }
            $isModType = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupoffer.set.type', 0);
            if (empty($isModType)) {
                Engine_Api::_()->getApi('settings', 'core')->setSetting('sitegroupoffer.offer.type', convert_uuencode($sitegroupModHostName));
            }

            $sitegroupoffersTable = Engine_Api::_()->getDbtable('offers', 'sitegroupoffer');
            $db = $sitegroupoffersTable->getAdapter();
            $db->beginTransaction();

            //GET POSTED VALUES FROM CREATE FORM
            $values = empty($getPackageOffer) ? null : $form->getValues();
            if (empty($values)) {
                return;
            }

            if ($values['claim_count'] == 0) {
                $values['claim_count'] = -1;
            }

            if ($values['end_settings'] == 0) {
                $values['end_time'] = '0000-00-00 00:00:00';
            }
            try {

                //CREATE OFFER
                $sitegroupofferRow = $sitegroupoffersTable->createRow();
                $sitegroupofferRow->setFromArray($values);
                $sitegroupofferRow->claim_count = $values['claim_count'];
                $sitegroupofferRow->group_id = $group_id;
                $sitegroupofferRow->owner_id = $viewer->getIdentity();
                $sitegroupofferRow->save();
                $db->commit();

                //ADD PHOTO
                if (!empty($values['photo'])) {
                    $sitegroupofferRow->setPhoto($form->photo);
                }

                $customfieldform = $form->getSubForm('fields');
                $customfieldform->setItem($sitegroupofferRow);
                $customfieldform->saveValues();

                $activityFeedType = null;
                if (Engine_Api::_()->sitegroup()->isFeedTypeGroupEnable())
                    $activityFeedType = 'sitegroupoffer_admin_new';
                else
                    $activityFeedType = 'sitegroupoffer_new';
                if ($activityFeedType) {
                    $action = Engine_Api::_()->getDbtable('actions', 'activity')->addActivity($viewer, $sitegroup, $activityFeedType);
                    Engine_Api::_()->getApi('subCore', 'sitegroup')->deleteFeedStream($action);
                }

                if ($action != null) {
                    Engine_Api::_()->getDbtable('actions', 'activity')->attachActivity($action, $sitegroupofferRow);
                }


                //COMMENT PRIVACY
                $auth = Engine_Api::_()->authorization()->context;
                $roles = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
                $auth_comment = "everyone";
                $commentMax = array_search($auth_comment, $roles);
                foreach ($roles as $i => $role) {
                    $auth->setAllowed($sitegroupofferRow, $role, 'comment', ($i <= $commentMax));
                }

                //SENDING ACTIVITY FEED TO FACEBOOK.
                $enable_Facebooksefeed = $enable_fboldversion = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('facebooksefeed');
                if (!empty($enable_Facebooksefeed)) {

                    $offer_array = array();
                    $offer_array['type'] = 'sitegroupoffer_new';
                    $offer_array['object'] = $sitegroupofferRow;

                    Engine_Api::_()->facebooksefeed()->sendFacebookFeed($offer_array);
                }

                //GROUP OFFER CREATE NOTIFICATION AND EMAIL WORK
                if (!empty($action)) {
                    $sitegroupVersion = Engine_Api::_()->getDbtable('modules', 'core')->getModule('sitegroup')->version;
                    if ($sitegroupVersion >= '4.3.0p1') {
                        Engine_Api::_()->sitegroup()->sendNotificationEmail($sitegroupofferRow, $action, 'sitegroupoffer_create', 'SITEGROUPOFFER_CREATENOTIFICATION_EMAIL', 'Groupevent Invite');

                        $isGroupAdmins = Engine_Api::_()->getDbtable('manageadmins', 'sitegroup')->isGroupAdmins($viewer->getIdentity(), $group_id);
                        if (!empty($isGroupAdmins)) {
                            //NOTIFICATION FOR ALL FOLLWERS.
                            Engine_Api::_()->sitegroup()->sendNotificationToFollowers($sitegroupofferRow, $action, 'sitegroupoffer_create');
                        }
                    }
                }
            } catch (Exception $e) {
                $db->rollBack();
                throw $e;
            }

            if (!empty($offer_group)) {
                return $this->_gotoRouteCustom(array('action' => 'index'));
            } else {
                return $this->_redirectCustom($sitegroupofferRow->getHref(), array('prependBase' => false));
            }
        }
    }

    //ACTION FOR EDIT OFFER
    public function editAction() {

        // CHECK USER VALIDATION
        if (!$this->_helper->requireUser()->isValid())
            return;

        $this->view->offer_group = $offer_group = $this->_getParam('offer_group');
        $this->view->tab_selected_id = $this->_getParam('tab');

        //GET OFFER OBJECT
        $this->view->sitegroupoffer = $sitegroupoffers = Engine_Api::_()->getItem('sitegroupoffer_offer', $this->_getParam('offer_id'));

        //GET GROUP OBJECT
        $this->view->sitegroup = $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $sitegroupoffers->group_id);

        //GET NAVIGATION
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitegroup_main');

        //PACKAGE BASE PRIYACY START
        if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
            if (!Engine_Api::_()->sitegroup()->allowPackageContent($sitegroup->package_id, "modules", "sitegroupoffer")) {
                return $this->_forwardCustom('requireauth', 'error', 'core');
            }
        } else {
            $isGroupOwnerAllow = Engine_Api::_()->sitegroup()->isGroupOwnerAllow($sitegroup, 'offer');
            if (empty($isGroupOwnerAllow)) {
                return $this->_forwardCustom('requireauth', 'error', 'core');
            }
        }
        //PACKAGE BASE PRIYACY END
        //START MANAGE-ADMIN CHECK
        $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
        if (empty($isManageAdmin)) {
            return $this->_forwardCustom('requireauth', 'error', 'core');
        }

        $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'offer');
        if (empty($isManageAdmin)) {
            return $this->_forwardCustom('requireauth', 'error', 'core');
        }
        //END MANAGE-ADMIN CHECK
        //FORM GENERATION
        $this->view->form = $form = new Sitegroupoffer_Form_Edit(array('item' => $sitegroupoffers));

        if (!Engine_API::_()->seaocore()->checkSitemobileMode('fullsite-mode')) {
            $form->addElement("dummy", "dummy", array('label' => 'Offer Picture', 'description' => 'Sorry, the browser you are using does not support Photo uploading. We recommend you to edit an Offer from your mobile / tablet without uploading a main photo for it. You can later upload the offer picture from your Desktop.', 'order' => 4, 'style' => 'display:none;'));

            if (preg_match('/' . 'iPad' . '/i', $_SERVER['HTTP_USER_AGENT'])) {
                if (isset($form->photo)) {
                    $form->removeElement('photo');
                }
            } else {
                if (isset($form->photo)) {
                    $form->photo->setAttrib('accept', "image/*");
                }
            }
        }

        $date = (string) date('Y-m-d');
        $sitegroupoffers->end_time = $sitegroupoffers->end_time;

        if ($sitegroupoffers->claim_count == 0) {
            $form->getElement('claim_count')
                    ->setIgnore(true)
                    ->setAttrib('disable', true)
                    ->clearValidators()
                    ->setRequired(false)
                    ->setAllowEmpty(true)
            ;
        }

        //SHOW PRE-FIELD FORM
        if ($sitegroupoffers->claim_count == -1) {
            $sitegroupoffers->claim_count = 0;
        }

        if ($sitegroupoffers->end_settings == 0) {
            $date = (string) date('Y-m-d');
            $sitegroupoffers->end_time = $date . ' 00:00:00';
        }
        $form->populate($sitegroupoffers->toArray());

        //IF NOT POST OR FORM NOT VALID THAN RETURN
        if (!$this->getRequest()->isPost()) {
            $form->populate($sitegroupoffers->toArray());
            return;
        }

        //IF NOT POST OR FORM NOT VALID THAN RETURN
        if (!$form->isValid($this->getRequest()->getPost())) {
            return;
        }

        //GET FORM VALUES
        $values = $form->getValues();

        if (isset($values['claim_count']) && $values['claim_count'] == 0) {
            $values['claim_count'] = -1;
        }

        if ($values['end_settings'] == 0) {
            $values['end_time'] = '0000-00-00 00:00:00';
        }
        Engine_Api::_()->sitegroupoffer()->setOfferPackages();

        $db = Engine_Db_Table::getDefaultAdapter();
        $db->beginTransaction();
        try {
            $sitegroupoffers->setFromArray($values);
            $sitegroupoffers->save();
            if (!empty($values['photo'])) {
                $sitegroupoffers->setPhoto($form->photo);
            }

            $customfieldform = $form->getSubForm('fields');
            $customfieldform->setItem($sitegroupoffers);
            $customfieldform->saveValues();

            $db->commit();
        } catch (Exception $e) {
            $db->rollBack();
            throw $e;
        }
        if (!empty($offer_group)) {
            $this->_forwardCustom('success', 'utility', 'core', array(
                'smoothboxClose' => true,
                'parentRefresh' => true,
                'format' => 'smoothbox',
                'messages' => Zend_Registry::get('Zend_Translate')->_('Your offer has been edit successfully.')
            ));
        } else {
            return $this->_redirectCustom($sitegroupoffers->getHref(), array('prependBase' => false));
        }
    }

    //ACTION FOR DELETE OFFER
    public function deleteAction() {

        // CHECK USER VALIDATION
        if (!$this->_helper->requireUser()->isValid())
            return;
        $this->view->offer_group = $offer_group = $this->_getParam('offer_group');
        $this->view->tab_selected_id = $tab_selected_id = $this->_getParam('tab');

        //GET OFFER ID AND OFFER OBJECT
        $this->view->offer_id = $offer_id = $this->_getParam('offer_id');
        $sitegroupoffers = Engine_Api::_()->getItem('sitegroupoffer_offer', $offer_id);

        //GET GROUP OBJECT
        $this->view->sitegroup = $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $sitegroupoffers->group_id);

        //GET NAVIGATION
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitegroup_main');

        // PACKAGE BASE PRIYACY START
        if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
            if (!Engine_Api::_()->sitegroup()->allowPackageContent($sitegroup->package_id, "modules", "sitegroupoffer")) {
                return $this->_forwardCustom('requireauth', 'error', 'core');
            }
        } else {
            $isGroupOwnerAllow = Engine_Api::_()->sitegroup()->isGroupOwnerAllow($sitegroup, 'offer');
            if (empty($isGroupOwnerAllow)) {
                return $this->_forwardCustom('requireauth', 'error', 'core');
            }
        }
        // PACKAGE BASE PRIYACY END
        //START MANAGE-ADMIN CHECK
        $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
        if (empty($isManageAdmin)) {
            return $this->_forwardCustom('requireauth', 'error', 'core');
        }

        $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'offer');
        if (empty($isManageAdmin)) {
            return $this->_forwardCustom('requireauth', 'error', 'core');
        }
        //END MANAGE-ADMIN CHECK

        if ($this->getRequest()->isPost()) {
            $db = Engine_Db_Table::getDefaultAdapter();
            $db->beginTransaction();
            try {

                Engine_Api::_()->sitegroupoffer()->deleteContent($sitegroupoffers->offer_id);
                $db->commit();
            } catch (Exception $e) {
                $db->rollBack();
                throw $e;
            }
            if (!empty($offer_group)) {
                $this->_forwardCustom('success', 'utility', 'core', array(
                    'smoothboxClose' => 300,
                    'parentRefresh' => 300,
                    'messages' => array('Your offer has been deleted successfully.')
                ));
            } else {
                return $this->_gotoRouteCustom(array('group_url' => Engine_Api::_()->sitegroup()->getGroupUrl($sitegroupoffers->group_id), 'tab' => $tab_selected_id), 'sitegroup_entry_view', true);
            }
        }
    }

    public function stickyAction() {

        // CHECK USER VALIDATION
        if (!$this->_helper->requireUser()->isValid())
            return;

        //GET GROUP ID AND GROUP OBJECT
        $group_id = $this->_getParam('group_id');
        $offer_id = $this->_getParam('offer_id');
        $offer_group = $this->_getParam('offer_group');
        $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $group_id);
        $sitegroupoffer = Engine_Api::_()->getItem('sitegroupoffer_offer', $offer_id);
        $this->view->sticky = $sitegroupoffer->sticky;
        //PACKAGE BASE PRIYACY START
        if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
            if (!Engine_Api::_()->sitegroup()->allowPackageContent($sitegroup->package_id, "modules", "sitegroupoffer")) {
                return $this->_forwardCustom('requireauth', 'error', 'core');
            }
        } else {
            $isGroupOwnerAllow = Engine_Api::_()->sitegroup()->isGroupOwnerAllow($sitegroup, 'offer');
            if (empty($isGroupOwnerAllow)) {
                return $this->_forwardCustom('requireauth', 'error', 'core');
            }
        }
        //PACKAGE BASE PRIYACY END
        //START MANAGE-ADMIN CHECK
        $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
        if (empty($isManageAdmin)) {
            return $this->_forwardCustom('requireauth', 'error', 'core');
        }

        $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'offer');
        if (empty($isManageAdmin)) {
            return $this->_forwardCustom('requireauth', 'error', 'core');
        }
        //END MANAGE-ADMIN CHECK
        //POST DATA
        if ($this->getRequest()->isPost()) {

            Engine_Api::_()->getDbtable('offers', 'sitegroupoffer')->makeSticky($offer_id, $group_id);
            if (!empty($offer_group)) {
                $this->_forwardCustom('success', 'utility', 'core', array(
                    'smoothboxClose' => 10,
                    'parentRefresh' => 10,
                    'messages' => array('')
                ));
            } else {
                $this->_forwardCustom('success', 'utility', 'core', array(
                    'smoothboxClose' => 10,
                    'parentRedirect' => $this->_helper->url->url(array('group_url' => Engine_Api::_()->sitegroup()->getGroupUrl($group_id), 'tab' => $this->_getParam('tab')), 'sitegroup_entry_view', true),
                    'parentRedirectTime' => '2',
                    'messages' => array('')
                ));
            }
        }
    }

    public function browseAction() {

        //CHECK VIEW PRIVACY
        if (!$this->_helper->requireAuth()->setAuthParams('sitegroup_group', null, 'view')->isValid())
            return;

        //CHECK THE VERSION OF THE CORE MODULE
        $coremodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core');
        $coreversion = $coremodule->version;
        if ($coreversion < '4.1.0') {
            $this->_helper->content->render();
        } else {
            $this->_helper->content
                    ->setNoRender()
                    ->setEnabled()
            ;
        }
    }

    //ACTION FOR PRINTING THE OFFER
    public function printAction() {

        $this->_helper->layout->setLayout('default-simple');

        //GET OFFER ID AND OFFER OBJECT
        $offer_id = $this->_getParam('offer_id', null);
        $this->view->sitegroup = Engine_Api::_()->getItem('sitegroup_group', $this->_getParam('group_id', null));
        $this->view->sitegroupoffer = Engine_Api::_()->getItem('sitegroupoffer_offer', $offer_id);
        if (empty($offer_id))
            return $this->_forwardCustom('notfound', 'error', 'core');
    }

    //ACTION FOR PRINTING THE OFFER
    public function previewAction() {

        $session = new Zend_Session_Namespace();
        if (isset($session->image_path)) {
            $this->view->image_path = $session->image_path;
        } else {
            $this->view->image_path = Zend_Registry::get('Zend_View')->layout()->staticBaseUrl . 'application/modules/Sitegroupoffer/externals/images/offer_thumb.png';
        }
    }

    public function uploadAction() {

        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender(true);

        $file = $_FILES["photo"]["tmp_name"];
        $file1 = $_FILES["photo"]["name"];

        $name = basename($file1);

        $path = APPLICATION_PATH . DIRECTORY_SEPARATOR . 'public/sitegroupoffer_offer';

        $storage = Engine_Api::_()->storage();

        //RESIZE IMAGE (MAIN)
        $image = Engine_Image::factory();
        $image->open($file);
        //IMAGE WIDTH
        $dstW = $image->width;
        // IMAGE HIGHT
        $dstH = $image->height;

        $size = min($image->height, $image->width);
        $x = ($image->width - $size) / 2;
        $y = ($image->height - $size) / 2;

        $image->resample($x, $y, $size, $size, 48, 48)
                ->write($path . '/' . $name)
                ->destroy();

        $photoName = $this->view->baseUrl() . '/public/sitegroupoffer_offer/' . $name;

        $session = new Zend_Session_Namespace();
        $session->image_path = $photoName;
        $session->photoName_Temp = $path . '/' . $name;

        @chmod($this->_session->photoName_Temp, 0777);
    }

    //ACTION FOR VIEW OFFER
    public function viewAction() {

        //IF SITEGROUPOFFER SUBJECT IS NOT THEN RETURN
//     if (!$this->_helper->requireSubject('sitegroupoffer_offer')->isValid())
//       return;

        $sitegroupoffer = Engine_Api::_()->getItem('sitegroupoffer_offer', $this->getRequest()->getParam('offer_id'));
        if ($sitegroupoffer) {
            Engine_Api::_()->core()->setSubject($sitegroupoffer);
        }

        //GET LOGGED IN USER INFORMATION
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();

        //GET OFFER ITEM
        $sitegroupoffer = Engine_Api::_()->getItem('sitegroupoffer_offer', $this->getRequest()->getParam('offer_id'));

        //GET SITEGROUP ITEM
        $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $sitegroupoffer->group_id);


        //START MANAGE-ADMIN CHECK
        $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'view');
        if (empty($isManageAdmin)) {
            return $this->_forwardCustom('requireauth', 'error', 'core');
        }
        //END MANAGE-ADMIN CHECK

        $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
        if (empty($isManageAdmin)) {
            $can_edit = 0;
        } else {
            $can_edit = 1;
        }

        $can_offer = 1;
        $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'offer');
        if (empty($isManageAdmin)) {
            $can_offer = 0;
        }

        $can_create_offer = '';
        //OFFER CREATION AUTHENTICATION CHECK
        if ($can_edit == 1 && $can_offer == 1) {
            $this->view->can_create_offer = $can_create_offer = 1;
        }

        //END MANAGE-ADMIN CHECK
        //CHECKING THE USER HAVE THE PERMISSION TO VIEW THE OFFER OR NOT
//     if ($viewer_id != $sitegroupoffer->owner_id && $can_edit != 1 && ($sitegroupoffer->search != 1 || $sitegroupoffer->status != 1)) {
//       return $this->_forwardCustom('requireauth', 'error', 'core');
//     }
        //NAVIGATION WORK FOR FOOTER.(DO NOT DISPLAY NAVIGATION IN FOOTER ON VIEW PAGE.)
        if (!Engine_API::_()->seaocore()->checkSitemobileMode('fullsite-mode')) {
            if (!Zend_Registry::isRegistered('sitemobileNavigationName')) {
                Zend_Registry::set('sitemobileNavigationName', 'setNoRender');
            }
        }
        if (Engine_Api::_()->seaocore()->isSitemobileApp()) {
            Zend_Registry::set('setFixedCreationFormBack', 'Back');
        }
        //CHECK THE VERSION OF THE CORE MODULE
        $coremodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core');
        $coreversion = $coremodule->version;
        if ($coreversion < '4.1.0') {
            $this->_helper->content->render();
        } else {
            $this->_helper->content
                    ->setNoRender()
                    ->setEnabled()
            ;
        }
    }

    //ACTION FOR SEND CLAIM OFFER MAIL
    public function getofferAction() {

        $param = $this->_getParam('param');
        $request_url = $this->_getParam('request_url');
        $return_url = $this->_getParam('return_url');
        $front = Zend_Controller_Front::getInstance();
        $base_url = $front->getBaseUrl();

        // CHECK USER VALIDATION
        if (!$this->_helper->requireUser()->isValid()) {
            $host = (!empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"])) ? "https://" : "http://";
            if ($base_url == '') {
                $URL_Home = $host . $_SERVER['HTTP_HOST'] . '/login';
            } else {
                $URL_Home = $host . $_SERVER['HTTP_HOST'] . '/' . $request_url . '/login';
            }
            if (empty($param)) {
                return $this->_helper->redirector->gotoUrl($URL_Home, array('prependBase' => false));
            } else {
                return $this->_helper->redirector->gotoUrl($URL_Home . '?return_url=' . urlencode($return_url), array('prependBase' => false));
            }
        }

        $offer_id = $this->_getParam('id');
        //GET OFFER OBJECT
        $sitegroupoffer = Engine_Api::_()->getItem('sitegroupoffer_offer', $offer_id);
        $sitegroupObject = Engine_Api::_()->getItem('sitegroup_group', $sitegroupoffer->group_id);

        $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroupObject, 'view');
        if (empty($isManageAdmin)) {
            $this->view->private_message = 1;
        } else {
            //GET LOGGED IN USER INFORMATION
            $viewer = Engine_Api::_()->user()->getViewer();

            $claim_value = Engine_Api::_()->getDbTable('claims', 'sitegroupoffer')->getClaimValue($viewer->getIdentity(), $offer_id, $sitegroupoffer->group_id);

            $this->view->offer_id = $offer_id;

            if (!empty($claim_value)) {
                $this->renderScript('index/resendoffer.tpl');
            } else {

                //GET THE TAB ID OF OFFER ON GROUP PROFILE
                $layout = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroup.layoutcreate', 0);
                $offer_tab_id = Engine_Api::_()->sitegroup()->GetTabIdinfo('sitegroupoffer.profile-sitegroupoffers', $sitegroupoffer->group_id, $layout);

                //GROUP URL
                $group_url = Engine_Api::_()->sitegroup()->getGroupUrl($sitegroupObject->group_id);

                $data['grouphome_offer'] = $this->view->htmlLink('http://' . $_SERVER['HTTP_HOST'] .
                        Zend_Controller_Front::getInstance()->getRouter()->assemble(array(), 'sitegroupoffer_home', true), $this->view->translate('View More Offers'), array('style' => 'color:#3b5998;text-decoration:none;margin-left:10px;', 'target' => '_blank'));
                if ($sitegroupObject->photo_id) {
                    $data['group_photo_path'] = $sitegroupObject->getPhotoUrl('thumb.icon');
                } else {
                    $data['group_photo_path'] = 'application/modules/Sitegroup/externals/images/nophoto_sitegroup_thumb_icon.png';
                }

                $data['share_offer'] = $this->view->htmlLink('http://' . $_SERVER['HTTP_HOST'] .
                        Zend_Controller_Front::getInstance()->getRouter()->assemble(array('user_id' => $sitegroupoffer->owner_id, 'offer_id' => $sitegroupoffer->offer_id, 'tab' => $offer_tab_id, 'slug' => $sitegroupoffer->getOfferSlug($sitegroupoffer->title), 'share_offer' => 1), 'sitegroupoffer_view', true), $this->view->translate('Share Offer'), array('style' => 'text-decoration:none;font-weight:bold;color:#fff;font-size:11px;', 'target' => '_blank'));

                $data['like_group'] = $this->view->htmlLink('http://' . $_SERVER['HTTP_HOST'] .
                        Zend_Controller_Front::getInstance()->getRouter()->assemble(array('group_url' => $group_url), 'sitegroup_entry_view', true), $this->view->translate('Like') . ' ' . $sitegroupObject->getTitle(), array('style' => 'color:#3b5998;text-decoration:none;margin-right:10px;margin-left:10px;', 'target' => '_blank'));

                $this->view->group_title = $this->view->htmlLink('http://' . $_SERVER['HTTP_HOST'] .
                        Zend_Controller_Front::getInstance()->getRouter()->assemble(array('group_url' => $group_url), 'sitegroup_entry_view', true), $sitegroupObject->getTitle(), array('target' => '_blank'));

                $data['group_title'] = $this->view->htmlLink('http://' . $_SERVER['HTTP_HOST'] .
                        Zend_Controller_Front::getInstance()->getRouter()->assemble(array('group_url' => $group_url), 'sitegroup_entry_view', true), $sitegroupObject->getTitle(), array('target' => '_blank', 'style' => 'color:#3b5998;text-decoration:none;'));

                if ($sitegroupoffer->photo_id) {
                    $data['offer_photo_path'] = $sitegroupoffer->getPhotoUrl('thumb.icon');
                } else {
                    $data['offer_photo_path'] = 'application/modules/Sitegroupoffer/externals/images/offer_thumb.png';
                }

                $data['site_title'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.general.site.title', 1);

                $data['offer_title'] = $this->view->htmlLink('http://' . $_SERVER['HTTP_HOST'] .
                        Zend_Controller_Front::getInstance()->getRouter()->assemble(array('user_id' => $sitegroupoffer->owner_id, 'offer_id' => $sitegroupoffer->offer_id, 'tab' => $offer_tab_id, 'slug' => $sitegroupoffer->getOfferSlug($sitegroupoffer->title)), 'sitegroupoffer_view', true), $sitegroupoffer->title, array('style' => 'color:#3b5998;text-decoration:none;'));

                $data['coupon_code'] = $sitegroupoffer->coupon_code;
                $data['offer_url'] = $sitegroupoffer->url;
                $data['offer_description'] = $sitegroupoffer->description;
                $data['offer_time'] = gmdate('M d, Y', strtotime($sitegroupoffer->end_time));
                $data['offer_time_setting'] = $sitegroupoffer->end_settings;
                $data['claim_owner_name'] = Engine_Api::_()->user()->getViewer()->username;
                $data['enable_mailtemplate'] = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitemailtemplates');

                // INITIALIZE THE STRING TO BE SEND IN THE CLAIM MAIL
                $template_header = "";
                $template_footer = "";
                $string = '';
                $string = $this->view->groupoffermail($data);

                $sitegroupofferClaimTable = Engine_Api::_()->getDbTable('claims', 'sitegroupoffer');

                $db = Engine_Db_Table::getDefaultAdapter();
                $db->beginTransaction();
                try {

                    //CREATE CLAIM FOR OFFER
                    $sitegroupofferRow = $sitegroupofferClaimTable->createRow();
                    $sitegroupofferRow->owner_id = $viewer->getIdentity();
                    $sitegroupofferRow->group_id = $sitegroupoffer->group_id;
                    $sitegroupofferRow->offer_id = $sitegroupoffer->offer_id;
                    $sitegroupofferRow->claim_value = 1;
                    $sitegroupofferRow->save();

                    $action = Engine_Api::_()->getDbtable('actions', 'activity')->addActivity($viewer, $sitegroupoffer, 'sitegroupoffer_home');

                    if ($action != null) {
                        Engine_Api::_()->getDbtable('actions', 'activity')->attachActivity($action, $sitegroupoffer);
                    }

                    $db->commit();
                } catch (Exception $e) {
                    $db->rollBack();
                    throw $e;
                }

                $subject = $this->view->translate('Your ') . $data['site_title'] . $this->view->translate(' offer from ') . $sitegroupObject->title;

                // SEND MAIL CLAIM OFFER
                $email = Engine_Api::_()->user()->getViewer()->email;
                $email_admin = Engine_Api::_()->getApi('settings', 'core')->core_mail_from;
                Engine_Api::_()->getApi('mail', 'core')->sendSystem($email, 'offer_claim', array(
                    'subject' => $subject,
                    'template_header' => $template_header,
                    'message' => $string,
                    'template_footer' => $template_footer,
                    'email' => $email_admin,
                    'queue' => false));

                $today = date("Y-m-d H:i:s");

                if ($sitegroupoffer->claim_count > 0) {
                    $sitegroupoffer->claim_count--;
                }
                $sitegroupoffer->claimed++;
                $sitegroupoffer->save();
                $claim_count = $sitegroupoffer->claim_count;
                $offer_id = $sitegroupoffer->offer_id;

                if (($claim_count == 0) && $sitegroupoffer->end_settings == 1 && $sitegroupoffer->end_time < $today) {
                    $sitegroupofferClaimTable->deleteClaimOffers($offer_id);
                }
            }
        }
    }

    //ACTION FOR RESEND OFFER CLAIM MAIL
    public function resendofferAction() {

        $this->view->offer_id = $offer_id = $this->_getParam('id');
        //GET OFFER OBJECT
        $sitegroupoffer = Engine_Api::_()->getItem('sitegroupoffer_offer', $offer_id);

        $sitegroupObject = Engine_Api::_()->getItem('sitegroup_group', $sitegroupoffer->group_id);

        $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroupObject, 'view');
        if (empty($isManageAdmin)) {
            $this->view->private_message = 1;
        }
    }

    public function sendofferAction() {

        $this->_helper->layout->setLayout('default-simple');
        $this->view->offer_id = $offer_id = $this->_getParam('id');

        $data = array();

        //GET OFFER OBJECT
        $sitegroupoffer = Engine_Api::_()->getItem('sitegroupoffer_offer', $offer_id);

        //GET THE TAB ID OF OFFER FOR GROUP PROFILE
        $layout = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroup.layoutcreate', 0);
        $offer_tab_id = Engine_Api::_()->sitegroup()->GetTabIdinfo('sitegroupoffer.profile-sitegroupoffers', $sitegroupoffer->group_id, $layout);

        $sitegroupObject = Engine_Api::_()->getItem('sitegroup_group', $sitegroupoffer->group_id);

        //GROUP URL
        $group_url = Engine_Api::_()->sitegroup()->getGroupUrl($sitegroupObject->group_id);

        $data['grouphome_offer'] = $this->view->htmlLink('http://' . $_SERVER['HTTP_HOST'] .
                Zend_Controller_Front::getInstance()->getRouter()->assemble(array(), 'sitegroupoffer_home', true), $this->view->translate('View More Offers'), array('style' => 'color:#3b5998;text-decoration:none;margin-left:10px; ', 'target' => '_blank'));

        $data['share_offer'] = $this->view->htmlLink('http://' . $_SERVER['HTTP_HOST'] .
                Zend_Controller_Front::getInstance()->getRouter()->assemble(array('user_id' => $sitegroupoffer->owner_id, 'offer_id' => $sitegroupoffer->offer_id, 'tab' => $offer_tab_id, 'slug' => $sitegroupoffer->getOfferSlug($sitegroupoffer->title), 'share_offer' => 1), 'sitegroupoffer_view', true), $this->view->translate('Share Offer'), array('style' => 'text-decoration:none;font-weight:bold;color:#fff;font-size:11px;', 'target' => '_blank'));

        $data['like_group'] = $this->view->htmlLink('http://' . $_SERVER['HTTP_HOST'] .
                Zend_Controller_Front::getInstance()->getRouter()->assemble(array('group_url' => $group_url), 'sitegroup_entry_view', true), $this->view->translate('Like') . ' ' . $sitegroupObject->getTitle(), array('style' => 'color:#3b5998;text-decoration:none;margin-right:10px;margin-left:10px;', 'target' => '_blank'));

        if ($sitegroupObject->photo_id) {
            $data['group_photo_path'] = $sitegroupObject->getPhotoUrl('thumb.icon');
        } else {
            $data['group_photo_path'] = 'application/modules/Sitegroup/externals/images/nophoto_sitegroup_thumb_icon.png';
        }

        $data['group_title'] = $this->view->htmlLink('http://' . $_SERVER['HTTP_HOST'] .
                Zend_Controller_Front::getInstance()->getRouter()->assemble(array('group_url' => $group_url), 'sitegroup_entry_view', true), $sitegroupObject->getTitle(), array('style' => 'color:#3b5998;text-decoration:none;'));

        if ($sitegroupoffer->photo_id) {
            $data['offer_photo_path'] = $sitegroupoffer->getPhotoUrl('thumb.icon');
        } else {
            $data['offer_photo_path'] = 'application/modules/Sitegroupoffer/externals/images/offer_thumb.png';
        }

        $data['site_title'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.general.site.title', 1);

        $data['offer_title'] = $this->view->htmlLink('http://' . $_SERVER['HTTP_HOST'] .
                Zend_Controller_Front::getInstance()->getRouter()->assemble(array('user_id' => $sitegroupoffer->owner_id, 'offer_id' => $sitegroupoffer->offer_id, 'tab' => $offer_tab_id, 'slug' => $sitegroupoffer->getOfferSlug($sitegroupoffer->title)), 'sitegroupoffer_view', true), $sitegroupoffer->title, array('style' => 'color:#3b5998;text-decoration:none;'));
        $data['coupon_code'] = $sitegroupoffer->coupon_code;
        $data['offer_url'] = $sitegroupoffer->url;
        $data['offer_description'] = $sitegroupoffer->description;
        $data['offer_time'] = gmdate('M d, Y', strtotime($sitegroupoffer->end_time));
        $data['offer_time_setting'] = $sitegroupoffer->end_settings;
        $data['claim_owner_name'] = Engine_Api::_()->user()->getViewer()->username;
        $data['enable_mailtemplate'] = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitemailtemplates');

        //INITIALIZE THE STRING TO BE SEND IN THE CLAIM MAIL
        $template_header = "";
        $template_footer = "";
        $string = '';
        $string = $this->view->groupoffermail($data);

        $this->view->group_title = $sitegroupObject->title;

        $subject = $this->view->translate('Your ') . $data['site_title'] . $this->view->translate(' offer from ') . $sitegroupObject->title;

        // SEND MAIL CLAIM OFFER
        $email = Engine_Api::_()->user()->getViewer()->email;
        $email_admin = Engine_Api::_()->getApi('settings', 'core')->core_mail_from;
        Engine_Api::_()->getApi('mail', 'core')->sendSystem($email, 'offer_claim', array(
            'subject' => $subject,
            'template_header' => $template_header,
            'message' => $string,
            'template_footer' => $template_footer,
            'email' => $email_admin,
            'queue' => false));
    }

    // ACTION FOR FEATURED NOTES CAROUSEL AFTER CLICK ON BUTTON 
    public function hotOffersCarouselAction() {
        //RETRIVE THE VALUE OF ITEM VISIBLE
        $this->view->itemsVisible = $limit = (int) $_GET['itemsVisible'];

        $this->view->viewer = Engine_Api::_()->user()->getViewer();
        $this->view->viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();

        //RETRIVE THE VALUE OF NUMBER OF ROW
        $this->view->noOfRow = (int) $_GET['noOfRow'];
        //RETRIVE THE VALUE OF ITEM VISIBLE IN ONE ROW
        $this->view->inOneRow = (int) $_GET['inOneRow'];

        // Total Count Featured Photos
        $totalCount = (int) $_GET['totalItem'];

        //RETRIVE THE VALUE OF START INDEX
        $startindex = $_GET['startindex'] * $limit;

        if ($startindex > $totalCount) {
            $startindex = $totalCount - $limit;
        }
        if ($startindex < 0)
            $startindex = 0;

        $params = array();
        $params['category_id'] = $_GET['category_id'];
        $hotOffer = 1;
        $params['offertype'] = 'hotoffer';

        //RETRIVE THE VALUE OF BUTTON DIRECTION
        $direction = $_GET['direction'];
        $this->view->offset = $params['start_index'] = $startindex;

        //GET Featured Photos with limit * 2
        $this->view->totalItemsInSlide = $params['limit'] = $limit * 2;
        $this->view->hotOffers = $this->view->hotOffers = $hotOffers = Engine_Api::_()->getDbTable('offers', 'sitegroupoffer')->getOffers($hotOffer, $params);

        //Pass the total number of result in tpl file
        $this->view->count = count($hotOffers);

        //Pass the direction of button in tpl file
        $this->view->direction = $direction;
    }

    public function homeAction() {

        //CHECK VIEW PRIVACY
        if (!$this->_helper->requireAuth()->setAuthParams('sitegroup_group', null, 'view')->isValid())
            return;

        //CHECK THE VERSION OF THE CORE MODULE
        $coremodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core');
        $coreversion = $coremodule->version;
        if ($coreversion < '4.1.0') {
            $this->_helper->content->render();
        } else {
            $this->_helper->content
                    ->setNoRender()
                    ->setEnabled()
            ;
        }
    }

    //ACTION FOR ADDING OFFER OF THE DAY
    public function addOfferOfDayAction() {
        //FORM GENERATION
        $form = $this->view->form = new Sitegroupoffer_Form_ItemOfDayday();
        $offer_id = $this->_getParam('offer_id');
        // $form->setAction($this->getFrontController()->getRouter()->assemble(array()));
        //CHECK POST
        if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {

            //GET FORM VALUES
            $values = $form->getValues();

            //BEGIN TRANSACTION
            $db = Engine_Db_Table::getDefaultAdapter();
            $db->beginTransaction();
            try {

                //GET ITEM OF THE DAY TABLE
                $dayItemTime = Engine_Api::_()->getDbtable('itemofthedays', 'sitegroup');

                //FETCH RESULT FOR resource_id
                $select = $dayItemTime->select()->where('resource_id = ?', $offer_id)->where('resource_type = ?', 'sitegroupoffer_offer');
                $row = $dayItemTime->fetchRow($select);

                if (empty($row)) {
                    $row = $dayItemTime->createRow();
                    $row->resource_id = $offer_id;
                }
                $row->start_date = $values["starttime"];
                $row->end_date = $values["endtime"];
                $row->resource_type = 'sitegroupoffer_offer';
                $row->save();

                $db->commit();
            } catch (Exception $e) {
                $db->rollBack();
                throw $e;
            }
            return $this->_forwardCustom('success', 'utility', 'core', array(
                        'smoothboxClose' => 10,
                        'messages' => array(Zend_Registry::get('Zend_Translate')->_('The Offer of the Day has been added successfully.'))
            ));
        }
    }

}

?>