<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    sitegroupoffer
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: WidgetSettings.php 6590 2010-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
//START LANGUAGE WORK
Engine_Api::_()->getApi('language', 'sitegroup')->languageChanges();
//END LANGUAGE WORK 
//GET DB
$db = Zend_Db_Table_Abstract::getDefaultAdapter();	

//CHECK THAT SITEGROUP PLUGIN IS ACTIVATED OR NOT
$select = new Zend_Db_Select($db);
	$select
  ->from('engine4_core_settings')
  ->where('name = ?', 'sitegroup.is.active')
	->limit(1);
$sitegroup_settings = $select->query()->fetchAll();
if(!empty($sitegroup_settings)) {
	$sitegroup_is_active = $sitegroup_settings[0]['value'];
}
else {
	$sitegroup_is_active = 0;
}

//CHECK THAT SITEGROUP PLUGIN IS INSTALLED OR NOT
$select = new Zend_Db_Select($db);
	$select
	  ->from('engine4_core_modules')
  ->where('name = ?', 'sitegroup')
	->where('enabled = ?', 1);
$check_sitegroup = $select->query()->fetchObject();
if(!empty($check_sitegroup)  && !empty($sitegroup_is_active)) {
	//PUT SITEGROUP OFFER TAB AT SITEGROUP PROFILE GROUP
	$select = new Zend_Db_Select($db);
	$select_group = $select
											 ->from('engine4_core_pages', 'page_id')
											 ->where('name = ?', 'sitegroup_index_view')
											 ->limit(1);
  $group = $select_group->query()->fetchAll();
	if(!empty($group)) {
		$group_id = $group[0]['page_id'];
		//INSERTING THE DOCUMENT WIDGET IN SITEGROUP_ADMIN_CONTENT TABLE ALSO.
		Engine_Api::_()->getDbtable('admincontent', 'sitegroup')->setAdminDefaultInfo('sitegroupoffer.profile-sitegroupoffers', $group_id, 'Offers', 'true', '116');
	 
		//INSERTING THE DOCUMENT WIDGET IN CORE_CONTENT TABLE ALSO.
		Engine_Api::_()->getApi('layoutcore', 'sitegroup')->setContentDefaultInfo('sitegroupoffer.profile-sitegroupoffers', $group_id, 'Offers', 'true', '116');
		
    //INSERTING THE DOCUMENT WIDGET IN SITEGROUP_CONTENT TABLE ALSO.
    $select = new Zend_Db_Select($db);								
		$contentgroup_ids = $select->from('engine4_sitegroup_contentgroups', 'contentgroup_id')->query()->fetchAll();
    foreach ($contentgroup_ids as $contentgroup_id) {
			if(!empty($contentgroup_id)) {
        Engine_Api::_()->getDbtable('content', 'sitegroup')->setDefaultInfo('sitegroupoffer.profile-sitegroupoffers', $contentgroup_id['contentgroup_id'], 'Offers', 'true', '116');
			}
		}
	}

	//PUT TOP RATED WIDGET AT GROUP HOME
	$select = new Zend_Db_Select($db);
	$select_group = $select
											 ->from('engine4_core_pages', 'page_id')
											 ->where('name = ?', 'sitegroup_index_home')
											 ->limit(1);
  $group = $select_group->query()->fetchAll();
	if(!empty($group)) {
		$group_id = $group[0]['page_id'];
		$select = new Zend_Db_Select($db);
		$select_content = $select
														->from('engine4_core_content')
														->where('page_id = ?', $group_id)
														->where('type = ?', 'widget')
														->where('name = ?', 'sitegroupoffer.sitegroup-hotoffer')
														->limit(1);
		$content = $select_content->query()->fetchAll();
		if(empty($content)) {
			$select = new Zend_Db_Select($db);
			$select_container = $select
																->from('engine4_core_content', 'content_id')
																->where('page_id = ?', $group_id)
																->where('type = ?', 'container')
																->where('name = ?', 'main')
																->limit(1);
			$container = $select_container->query()->fetchAll();
			if(!empty($container)) {
				$container_id = $container[0]['content_id'];

				$select = new Zend_Db_Select($db);
				$select_left = $select
																->from('engine4_core_content')
																->where('parent_content_id = ?', $container_id)
																->where('type = ?', 'container')
																->where('name = ?', 'left')
																->limit(1);
				$left = $select_left->query()->fetchAll();
				if(!empty($left)) {
					$left_id = $left[0]['content_id'];
					$select = new Zend_Db_Select($db);
					$select_tab = $select
																->from('engine4_core_content')
																->where('type = ?', 'widget')
																->where('name = ?', 'core.container-tabs')
																->where('page_id = ?', $group_id)
																->limit(1);
					$tab = $select_tab->query()->fetchAll();
					if(!empty($tab)) {
						$tab_id = $tab[0]['content_id'];
					}

					$db->insert('engine4_core_content', array(
					'page_id' => $group_id,
					'type' => 'widget',
					'name' => 'sitegroupoffer.sitegroup-hotoffer',
					'parent_content_id' => ($left_id ? $left_id : $tab_id),
					'order' => 999,
					'params' => '{"title":"Hot Group Offers","titleCount":"true"}',
					));
				}
			}
		}
	}
	$contentTable = Engine_Api::_()->getDbtable('content', 'core');
  $contentTableName = $contentTable->info('name');

//   $select = new Zend_Db_Select($db);
//   $select
// 					->from('engine4_core_modules')
// 					->where('name = ?', 'communityad')
// 					->where('enabled 	 = ?', 1)
// 					->limit(1);
// 	$infomation = $select->query()->fetch();
// 	$select = new Zend_Db_Select($db);
// 	$select
// 					->from('engine4_core_settings')
// 					->where('name = ?', 'sitegroup.communityads')
// 					->where('value 	 = ?', 1)
// 					->limit(1);
// 	$rowinfo = $select->query()->fetch();
// 
//   $select = new Zend_Db_Select($db);
//   $select
//           ->from('engine4_core_pages')
//           ->where('name = ?', 'sitegroupoffer_index_browse')
//           ->limit(1);
//   $info = $select->query()->fetch();
//   if ( empty($info) ) {
//     $db->insert('engine4_core_pages', array(
//         'name' => 'sitegroupoffer_index_browse',
//         'displayname' => 'Group Offers',
//         'title' => 'Group Offers List',
//         'description' => 'This is the group offers.',
//         'custom' => 1,
//     ));
//     $group_id = $db->lastInsertId('engine4_core_pages');
// //INSERT MAIN CONTAINER
//     $mainContainer = $contentTable->createRow();
//     $mainContainer->page_id = $group_id;
//     $mainContainer->type = 'container';
//     $mainContainer->name = 'main';
//     $mainContainer->order = 2;
//     $mainContainer->save();
//     $container_id = $mainContainer->content_id;
// 
// //INSERT MAIN - MIDDLE CONTAINER
//     $mainMiddleContainer = $contentTable->createRow();
//     $mainMiddleContainer->page_id = $group_id;
//     $mainMiddleContainer->type = 'container';
//     $mainMiddleContainer->name = 'middle';
//     $mainMiddleContainer->parent_content_id = $container_id;
//     $mainMiddleContainer->order = 6;
//     $mainMiddleContainer->save();
//     $middle_id = $mainMiddleContainer->content_id;
// 
// //INSERT MAIN - RIGHT CONTAINER
//     $mainRightContainer = $contentTable->createRow();
//     $mainRightContainer->page_id = $group_id;
//     $mainRightContainer->type = 'container';
//     $mainRightContainer->name = 'right';
//     $mainRightContainer->parent_content_id = $container_id;
//     $mainRightContainer->order = 5;
//     $mainRightContainer->save();
//     $right_id = $mainRightContainer->content_id;
// 
// //INSERT TOP CONTAINER
//     $topContainer = $contentTable->createRow();
//     $topContainer->page_id = $group_id;
//     $topContainer->type = 'container';
//     $topContainer->name = 'top';
//     $topContainer->order = 1;
//     $topContainer->save();
//     $top_id = $topContainer->content_id;
// 
// //INSERT TOP- MIDDLE CONTAINER
//     $topMiddleContainer = $contentTable->createRow();
//     $topMiddleContainer->page_id = $group_id;
//     $topMiddleContainer->type = 'container';
//     $topMiddleContainer->name = 'middle';
//     $topMiddleContainer->parent_content_id = $top_id;
//     $topMiddleContainer->order = 6;
//     $topMiddleContainer->save();
//     $top_middle_id = $topMiddleContainer->content_id;
// 
//     //INSERT NAVIGATION WIDGET
//     Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroup.browsenevigation-sitegroup', $top_middle_id, 1);
// 
// //INSERT OFFER WIDGET
//     Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroupoffer.sitegroup-offer', $middle_id, 2);
// 
//     //INSERT SEARCH GROUP OFFER WIDGET
//     Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroupoffer.search-sitegroupoffer', $right_id, 3, "", "true");
// 
//     //INSERT HOT GROUP OFFER WIDGET
//     Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroupoffer.sitegroup-hotoffer', $right_id, 4, "Hot Group Offers", "true");
// 
//     //INSERT LATEST GROUP OFFER WIDGET
//     Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroupoffer.sitegroup-latestoffer', $right_id, 5, "Latest Group Offers", "true");
//   
//    //INSERT SPONSORED GROUP OFFER WIDGET
//     Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroupoffer.sitegroup-sponsoredoffer', $right_id, 6, "Sponsored Offers", "true");
// 
//     //INSERT AVAILABLE GROUP OFFER WIDGET
//     Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroupoffer.sitegroup-dateoffer', $right_id, 7, "Available Offers", "true");
// 
//     if ( $infomation && $rowinfo ) {
// 
//       //INSERT GROUP ADA WIDGET
//       Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroup.group-ads', $right_id, 7, "", "true");
//     }
//   }
//   // Check if it's already been placed
// 	$select = new Zend_Db_Select($db);
// 	$select
// 					->from('engine4_core_pages')
// 					->where('name = ?', 'sitegroupoffer_index_view')
// 					->limit(1);
// 
// 	$info = $select->query()->fetch();
// 
// 	if ( empty($info) ) {
// 		$db->insert('engine4_core_pages', array(
// 				'name' => 'sitegroupoffer_index_view',
// 				'displayname' => 'Group Offer View Page',
// 				'title' => 'View Group Offer',
// 				'description' => 'This is the view group for a group offer.',
// 				'custom' => 1,
// 				'provides' => 'subject=sitegroupoffer',
// 		));
// 		$group_id = $db->lastInsertId('engine4_core_pages');
// 
// 		// containers
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $group_id,
// 				'type' => 'container',
// 				'name' => 'main',
// 				'parent_content_id' => null,
// 				'order' => 1,
// 				'params' => '',
// 		));
// 		$container_id = $db->lastInsertId('engine4_core_content');
// 
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $group_id,
// 				'type' => 'container',
// 				'name' => 'right',
// 				'parent_content_id' => $container_id,
// 				'order' => 1,
// 				'params' => '',
// 		));
// 		$right_id = $db->lastInsertId('engine4_core_content');
// 
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $group_id,
// 				'type' => 'container',
// 				'name' => 'middle',
// 				'parent_content_id' => $container_id,
// 				'order' => 3,
// 				'params' => '',
// 		));
// 		$middle_id = $db->lastInsertId('engine4_core_content');
// 
// 		// middle column content
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $group_id,
// 				'type' => 'widget',
// 				'name' => 'sitegroupoffer.offer-content',
// 				'parent_content_id' => $middle_id,
// 				'order' => 1,
// 				'params' => '',
// 		));
// 
//     if ( !empty($infomation)  && !empty($rowinfo) ) {
//       Engine_Api::_()->sitegroup()->setDefaultDataWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroup.group-ads', $right_id, 4, "", "true");
//     }
// 
// 	}

  $db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitegroupoffer_admin_main_offer_tab", "sitegroupoffer", "Tabbed Offers Widget", "", \'{"route":"admin_default","module":"sitegroupoffer","controller":"settings", "action": "widget"}\', "sitegroupoffer_admin_main", "", 1, 0, 3)');

	$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitegroupoffer_admin_main_dayitems", "sitegroupoffer", "Offer of the Day", "", \'{"route":"admin_default","module":"sitegroupoffer","controller":"settings", "action": "manage-day-items"}\', "sitegroupoffer_admin_main", "", 1, 0, 4)');

// 	$select = new Zend_Db_Select($db);
// 	$select
// 					->from('engine4_core_pages')
// 					->where('name = ?', 'sitegroupoffer_index_home')
// 					->limit(1);
// 	$info = $select->query()->fetch();
// 	if (empty($info)) {
// 		$db->insert('engine4_core_pages', array(
// 				'name' => 'sitegroupoffer_index_home',
// 				'displayname' => 'Group Offers Home',
// 				'title' => 'Group Offers Home',
// 				'description' => 'This is group offer home group.',
// 				'custom' => 1
// 		));
// 		$group_id = $db->lastInsertId('engine4_core_pages');
// 
// 		// containers
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $group_id,
// 				'type' => 'container',
// 				'name' => 'main',
// 				'parent_content_id' => null,
// 				'order' => 2,
// 				'params' => '',
// 		));
// 		$container_id = $db->lastInsertId('engine4_core_content');
// 
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $group_id,
// 				'type' => 'container',
// 				'name' => 'right',
// 				'parent_content_id' => $container_id,
// 				'order' => 5,
// 				'params' => '',
// 		));
// 		$right_id = $db->lastInsertId('engine4_core_content');
// 
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $group_id,
// 				'type' => 'container',
// 				'name' => 'left',
// 				'parent_content_id' => $container_id,
// 				'order' => 4,
// 				'params' => '',
// 		));
// 		$left_id = $db->lastInsertId('engine4_core_content');
// 
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $group_id,
// 				'type' => 'container',
// 				'name' => 'top',
// 				'parent_content_id' => null,
// 				'order' => 1,
// 				'params' => '',
// 		));
// 		$top_id = $db->lastInsertId('engine4_core_content');
// 
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $group_id,
// 				'type' => 'container',
// 				'name' => 'middle',
// 				'parent_content_id' => $top_id,
// 				'order' => 6,
// 				'params' => '',
// 		));
// 		$top_middle_id = $db->lastInsertId('engine4_core_content');
// 
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $group_id,
// 				'type' => 'container',
// 				'name' => 'middle',
// 				'parent_content_id' => $container_id,
// 				'order' => 6,
// 				'params' => '',
// 		));
// 		$middle_id = $db->lastInsertId('engine4_core_content');
// 
// 	// Top Middle
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $group_id,
// 				'type' => 'widget',
// 				'name' => 'sitegroup.browsenevigation-sitegroup',
// 				'parent_content_id' => $top_middle_id,
// 				'order' => 3,
// 				'params' => '',
// 		));
// 
// 		// Left
// 	
// 		//INSERT TOP RATED GROUP OFFER WIDGET
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $group_id,
// 				'type' => 'widget',
// 				'name' => 'sitegroupoffer.offers-sitegroupoffers',
// 				'parent_content_id' => $left_id,
// 				'order' => 13,
// 				'params' => '{"title":"Most Popular Offers","popularity":"popular","titleCount":"true"}',
// 		));
// 
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $group_id,
// 				'type' => 'widget',
// 				'name' => 'sitegroupoffer.offers-sitegroupoffers',
// 				'parent_content_id' => $left_id,
// 				'order' => 14,
// 				'params' => '{"title":"Most Viewed Offers","popularity":"view_count","titleCount":"true"}',
// 		));
// 
// 	// Middele
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $group_id,
// 				'type' => 'widget',
// 				'name' => 'sitegroupoffer.hot-offers-slideshow',
// 				'parent_content_id' => $middle_id,
// 				'order' => 16,
// 				'params' => '{"title":"Hot Offers","vertical":"0", "noOfRow":"2","inOneRow":"3","interval":"250","name":"sitegroupoffer.hot-offers-slideshow"}',
// 		));
// 
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $group_id,
// 				'type' => 'widget',
// 				'name' => 'sitegroupoffer.list-offers-tabs-view',
// 				'parent_content_id' => $middle_id,
// 				'order' => 17,
// 				'params' => '{"title":"Offers","margin_photo":"12"}',
// 		));
// 		// Right Side
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $group_id,
// 				'type' => 'widget',
// 				'name' => 'sitegroupoffer.sitegroupofferlist-link',
// 				'parent_content_id' => $right_id,
// 				'order' => 19,
// 				'params' => '',
// 		));
// 
// 		// Right Side
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $group_id,
// 				'type' => 'widget',
// 				'name' => 'sitegroupoffer.search-sitegroupoffer',
// 				'parent_content_id' => $right_id,
// 				'order' => 18,
// 				'params' => '',
// 		));
// 
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $group_id,
// 				'type' => 'widget',
// 				'name' => 'sitegroupoffer.offer-of-the-day',
// 				'parent_content_id' => $left_id,
// 				'order' => 12,
// 				'params' => '{"title":"Offer of the Day"}',
// 		));
// 
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $group_id,
// 				'type' => 'widget',
// 				'name' => 'sitegroupoffer.offers-sitegroupoffers',
// 				'parent_content_id' => $right_id,
// 				'order' => 22,
// 				'params' => '{"title":"Most Commented Offers","popularity":"comment_count","titleCount":"true"}',
// 		));
// 
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $group_id,
// 				'type' => 'widget',
// 				'name' => 'sitegroupoffer.offers-sitegroupoffers',
// 				'parent_content_id' => $right_id,
// 				'order' => 23,
// 				'params' => '{"title":"Most Liked Offers","popularity":"like_count","titleCount":"true"}',
// 		));
// 		
//     //INSERT HOT GROUP OFFER WIDGET
//     Engine_Api::_()->sitegroup()->setDefaultDataWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroupoffer.sitegroup-hotoffer', $left_id, 15, "Hot Group Offers", "true");
// 
//     //INSERT LATEST GROUP OFFER WIDGET
//     Engine_Api::_()->sitegroup()->setDefaultDataWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroupoffer.sitegroup-latestoffer', $left_id, 16, "Latest Group Offers", "true");
// 	}
        
        $db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `order`) VALUES("sitegroupoffer_admin_main_fields", "sitegroupoffer", "Offer Questions", "", \'{"route":"admin_default","module":"sitegroupoffer","controller":"fields"}\', "sitegroupoffer_admin_main", "", 4)');
}

?>