<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupoffer
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$isActive = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupoffer.isActivate', 0);
if ( empty($isActive) ) {
  return;
}

$categories = Engine_Api::_()->getDbTable('categories', 'sitegroup')->getCategories();
if (count($categories) != 0) {
  $categories_prepared[0] = "";
  foreach ($categories as $category) {
    $categories_prepared[$category->category_id] = $category->category_name;
  }
}

$popularity_options = array(
		'view_count' => 'Most Viewed',
		'like_count' => 'Most Liked',
		'comment_count' => 'Most Commented',
		'popular' => 'Most Claimed',
);

$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => 'Group Profile Offers',
        'description' => 'This widget forms the Offers tab on the Group Profile and displays the offers of the Group. It should be placed in the Tabbed Blocks area of the Group Profile.',
        'category' => 'Group Profile',
        'type' => 'widget',
        'name' => 'sitegroupoffer.profile-sitegroupoffers',
        'defaultParams' => array(
            'title' => 'Offers',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => 'Latest Group Offers',
        'description' => 'Displays the latest Group Offers that have been created. You can choose the number of entries to be shown.',
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroupoffer.sitegroup-latestoffer',
        'defaultParams' => array(
            'title' => 'Latest Group Offers',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of offers to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							  ),
            ),
        ),
    ),
    array(
        'title' => 'Hot Group Offers',
        'description' => 'Displays Group Offers that have been marked as Hot. You can choose the number of entries to be shown',
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroupoffer.sitegroup-hotoffer',
        'defaultParams' => array(
            'title' => 'Hot Group Offers',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of offers to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							  ),
            ),
        ),
    ),
    array(
        'title' => 'Group Offers',
        'description' => 'Displays the list of Offers from Groups created on your community. This widget should be placed in the widgetized Group Offers group. Results from the Search Group Offers form are also shown here.',
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroupoffer.sitegroup-offer',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of offers to show)',
                        'value' => 20,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),

    array(
        'title' => 'Available Offers',
        'description' => 'Displays the Group Offers based on their ending dates, in 3 tabs: ‘This Week’, ‘This Month’ and ‘Overall’. Users can see more offers right within that widget. You can choose the number of entries to be shown.',
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroupoffer.sitegroup-dateoffer',
        'defaultParams' => array(
            'title' => 'Available Offers',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of offers to show)',
                        'value' => 5,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							  ),
            ),
        ),
    ),

		array(
			'title' => 'Search Group Offers form',
			'description' => 'Displays the form for searching Group Offers on the basis of various filters. You can edit the fields to be available in this form.',
			'category' => 'Groups',
			'type' => 'widget',
			'name' => 'sitegroupoffer.search-sitegroupoffer',
			'defaultParams' => array(
					'title' => '',
          'search_column' => array("0" => "1", "1" => "2", "2" => "3", "3" => "4"),
					'titleCount' => true,

			),
			'adminForm' => array(
              'elements' => array(
							array(
									'MultiCheckbox',
									'search_column',
									array(
											'label' => 'Choose the fields that you want to be available in the Search Group Offers form widget.',
											'multiOptions' => array("1" => "Browse By", "2" => "Group Title", "3" => "Offer Title","4" => "Group Category","5" => "Location"),
									),
							),
					),
			)
    ),

     array(
        'title' => 'Sponsored Offers',
        'description' => 'Displays the Offers from Paid Groups. You can choose the number of entries to be shown.',
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroupoffer.sitegroup-sponsoredoffer',
        'defaultParams' => array(
            'title' => 'Sponsored Offers',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of offers to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
						    ),
            ),
        ),
    ),
		array(
				'title' => 'Group Offer View',
				'description' => "This widget should be placed on the Group Offer View Page.",
				'category' => 'Groups',
				'type' => 'widget',
				'name' => 'sitegroupoffer.offer-content',
				'defaultParams' => array(
						'title' => '',
						'titleCount' => true,
				),
        'adminForm' => array(
            'elements' => array(
                array(
									'MultiCheckbox',
									'showLinks',
									array(
											'label' => 'Show Action Links (Note: "Suggest to Friends" link having dependency on our "Suggestions" plugin.)',
											'multiOptions' => array(
                          'add' => "Add an Offer",
                          'edit' => "Edit Offer",
                          'delete' => "Delete Offer",
                          'featured' => "Make Featured",
                          'dayOffer' => "Make Offer of the Day",
                          'suggest' => "Suggest to Friends",
                          'print' => "Print Offer",
                          'share' => "Site Share",
                          'report' => "Report",
                      ),
									)
						    ),
                array(
                    'MultiCheckbox',
                    'showContent',
                    array(
                        'label' => 'Select the information options that you want to be available in this block.',
                        'multiOptions' => array("postedBy" => "Posted on", "viewCount" => "Views", "likeCount" => "Likes", "commentCount" => "Comments"),
                    ),
                ),           
                array(
                    'Radio',
                    'commentEnabled',
                    array(
                        'label' => $view->translate('Do you want to show user comments and enable user to post comment or not?'),
                        'multiOptions' => array(
                            1 => $view->translate('Yes'),
                            0 => $view->translate('No')
                        ),
                        'value' => 1,
                    ),
                ),                
            ),
        ),          
		),

		array(
				'title' => 'Popular / Viewed / Liked Group Offers',
				'description' => 'Displays Group Offers based on the Popularity Criteria and other settings that you choose for this widget. You can place this widget multiple times on a group with different popularity criterion chosen for each placement.',
				'category' => 'Groups',
				'type' => 'widget',
				'autoEdit' => true,
				'name' => 'sitegroupoffer.offers-sitegroupoffers',
				'defaultParams' => array(
						'title' => 'Offers',
						'titleCount' => true,
				),
				'adminForm' => array(
						'elements' => array(
								array(
										'Text',
										'itemCount',
										array(
											'label' => 'Count',
											'description' => '(number of Offers to show)',
											'value' => 3,
										)
								),
								array(
										'Select',
										'popularity',
										array(
												'label' => 'Popularity Criteria',
												'multiOptions' => $popularity_options,
												'value' => 'view_count',
										)
								),
								array(
										'Select',
										'category_id',
										array(
												'label' => 'Category',
												'multiOptions' => $categories_prepared,
										)
								),
						),
				),
		),

    array(
        'title' => 'Group’s Offer of the Day',
        'description' => 'Displays the Offer of the Day as selected by the Admin from the widget settings section of Groups - Offers Extension.',
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroupoffer.offer-of-the-day',
        'defaultParams' => array(
            'title' => 'Offer of the Day'
        ),
    ),

    array(
        'title' => 'Browse Offers',
        'description' => 'Displays the link to view Group’s Offers Browse group.',
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroupoffer.sitegroupofferlist-link',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
    ),

    array(
        'title' => 'Group’s Hot Offers Slideshow',
        'description' => 'Displays hot offers in an attractive slideshow. You can set the count of the number of offers to show in this widget. If the total number of offers selected as hot are more than that count, then the offers to be displayed will be sequentially picked up.',
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroupoffer.hot-offers-slideshow',
        'isPaginated' => true,
        'defaultParams' => array(
            'title' => 'Hot Offers',
            'itemCountPerGroup' => 10,
        ),
			'adminForm' => array(
					'elements' => array(
							array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
			),
    ),

    array(
        'title' => 'Group’s Hot Offers Carousel',
        'description' => 'This widget contains an attractive AJAX based carousel, showcasing the hot offers on the site. Multiple settings of this widget makes it highly configurable.',
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroupoffer.hot-offers-carousel',
        'defaultParams' => array(
            'title' => 'Hot Offers',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
										'Select',
										'category_id',
										array(
												'label' => 'Category',
												'multiOptions' => $categories_prepared,
										)
								),
                array(
                    'Radio',
                    'vertical',
                    array(
                        'label' => 'Carousel Type',
                        'multiOptions' => array(
                            '0' => 'Horizontal',
                            '1' => 'Vertical',
                        ),
                        'value' => 0,
                    )
                ),
                array(
                    'Text',
                    'inOneRow',
                    array(
                        'label' => 'Offers in a Row',
                        'description' => '(number of offers to show in one row. Note: This field is applicable only when you have selected ‘Horizontal’ in ‘Carousel Type’ field.)',
                        'value' => 3,
                    )
                ),
                array(
                    'Text',
                    'noOfRow',
                    array(
                        'label' => 'Rows',
                        'description' => '(number of rows in one view)',
                        'value' => 2,
                    )
                ),
                array(
                    'Text',
                    'interval',
                    array(
                        'label' => 'Speed',
                        'description' => '(transition interval between two slides in millisecs)',
                        'value' => 250,
                    )
                ),
            ),
        ),
    ),

    array(
        'title' => 'Group’s Ajax based Tabbed widget for Offers',
        'description' => 'Displays the Upcoming, Most Liked, Most Viewed, Most Commented, Hot and Featured Offers in separate AJAX based tabs. Settings for this widget are available in the Tabbed Offers Widget section of Groups - Offers Extension.',
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroupoffer.list-offers-tabs-view',
        'defaultParams' => array(
            'title' => 'Offers',
            'margin_photo'=>12,
            'showViewMore'=>1
        ),
         'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'margin_photo',
                    array(
                        'label' => 'Horizontal Margin between Elements',
                        'description' => '(Horizontal margin in px between consecutive elements in this widget. You might want to change this value if the content of this widget is not coming properly on your site because of the column width in your theme.)',
                        'value' => 12,
                    )
                ),
                 array(
                  'Radio',
                  'showViewMore',
                  array(
                      'label' => 'Show "View More" link',
                      'multiOptions' => array(
                          '1' => 'Yes',
                          '0' => 'No',
                      ),
                      'value' => 1,
                  )
              ),
              array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							)
            ),
        ),
    ),

    array(
    'title' => 'Top Creators : Group Offers',
    'description' => 'Displays the Groups which have the most number of Group Offers added in them. Motivates Group Admins to add more content on your website.',
    'category' => 'Groups',
    'type' => 'widget',
    'name' => 'sitegroupoffer.topcreators-sitegroupoffer',
   // 'isPaginated' => true,
    'defaultParams' => array(
      'title' => 'Top Creators',
    ),
     'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of elements to show)',
										'value' => 5,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						), 
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
        ),
    'requirements' => array(
      'subject' => 'sitegroupoffer',
    ),
  ),

	)

?>