<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupoffer
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: manifest.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$routeStart = "groupoffer";
$module=null;$controller=null;$action=null;$getURL = null;
$request = Zend_Controller_Front::getInstance()->getRequest();
if (!empty($request)) {
  $module = $request->getModuleName(); // Return the current module name.
  $action = $request->getActionName();
  $controller = $request->getControllerName();
  $getURL = $request->getRequestUri();
}
if (empty($request) || !($module == "default" && ( strpos( $getURL, '/install') !== false))) {
  $routeStart = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupoffer.manifestUrl', "group-offers");
}
return array(
    'package' =>
    array(
        'type' => 'module',
        'name' => 'sitegroupoffer',
        'version' => '5.4.1',
        'path' => 'application/modules/Sitegroupoffer',
        'title' => 'Groups / Communities - Offers Extension',
        'description' => 'Groups / Communities - Offers Extension',
      'author' => '<a href="http://www.socialapps.tech" style="text-decoration:underline;" target="_blank">SocialApps.tech</a>',
        'date' => 'Thrusday, 05 May 2011 18:33:08 +0000',
        'copyright' => 'Copyright 2010-2011 BigStep Technologies Pvt. Ltd.',
        'actions' =>
        array(
            0 => 'install',
            1 => 'upgrade',
            2 => 'refresh',
            3 => 'enable',
            4 => 'disable',
        ),
        'callback' =>
        array(
            'path' => 'application/modules/Sitegroupoffer/settings/install.php',
            'class' => 'Sitegroupoffer_Installer',
        ),
        'directories' =>
        array(
            0 => 'application/modules/Sitegroupoffer',
        ),
        'files' =>
        array(
            0 => 'application/languages/en/sitegroupoffer.csv',
        ),
    ),
    'hooks' => array(
        array(
            'event' => 'onUserDeleteBefore',
            'resource' => 'Sitegroupoffer_Plugin_Core',
        ),
    ),
    // Items ---------------------------------------------------------------------
    'items' => array(
        'sitegroupoffer_offer',
        'sitegroupoffer_photo',
        'sitegroupoffer_claim',
        'sitegroupoffer_album'
    ),
    'sitemobile_compatible' => true,
    // Route--------------------------------------------------------------------
    'routes' => array(
        'sitegroupoffer_general' => array(
            'route' => $routeStart.'/:action/*',
            'defaults' => array(
                'module' => 'sitegroupoffer',
                'controller' => 'index',
                'action' => 'index',
            ),
            'reqs' => array(
                'action' => '(index|create|edit|delete|sticky|print|getoffer|resendoffer)',
            ),
        ),
        'sitegroupoffer_hotoffer' => array(
            'route' => $routeStart.'/hotoffer/:id/*',
            'defaults' => array(
                'module' => 'sitegroupoffer',
                'controller' => 'admin',
                'action' => 'hotoffer',
            ),
            'reqs' => array(
                'id' => '\d+'
            )
        ),
        'sitegroupoffer_view' => array(
            'route' => $routeStart . '/:user_id/:offer_id/:slug/*',
            'defaults' => array(
                'module' => 'sitegroupoffer',
                'controller' => 'index',
                'action' => 'view',
                'slug' => '',
            ),
            'reqs' => array(
                'user_id' => '\d+'
            )
        ),
        'sitegroupoffer_details' => array(
            'route' => $routeStart.'/detail/:id/*',
            'defaults' => array(
                'module' => 'sitegroupoffer',
                'controller' => 'admin',
                'action' => 'detail',
            ),
            'reqs' => array(
                'id' => '\d+'
            )
        ),
        'sitegroupoffer_home' => array(
            'route' => $routeStart.'/home/*',
            'defaults' => array(
                'module' => 'sitegroupoffer',
                'controller' => 'index',
                'action' => 'home',
            ),
        ),
        'sitegroupoffer_delete' => array(
            'route' => $routeStart.'/delete/:id/*',
            'defaults' => array(
                'module' => 'sitegroupoffer',
                'controller' => 'admin',
                'action' => 'delete',
            ),
            'reqs' => array(
                'id' => '\d+'
            )
        ),
        'sitegroupoffer_browse' => array(
            'route' => $routeStart.'/browse/*',
            'defaults' => array(
                'module' => 'sitegroupoffer',
                'controller' => 'index',
                'action' => 'browse',
            ),
        ),
    ),
);
?>