<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupoffer
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupoffer_Widget_ProfileSitegroupoffersController extends Engine_Content_Widget_Abstract {

  protected $_childCount;

  public function indexAction() {

    //DON'T RENDER IF SUBJECT IS NOT SET
    if (!Engine_Api::_()->core()->hasSubject()) {
      return $this->setNoRender();
    }

    $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewer_id = $viewer->getIdentity();

    //GET SUBJECT
    $this->view->sitegroup = $sitegroup = Engine_Api::_()->core()->getSubject('sitegroup_group');

    // PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitegroup()->allowPackageContent($sitegroup->package_id, "modules", "sitegroupoffer")) {
        return $this->setNoRender();
      }
    } else {
      $groupOwnerBase = Engine_Api::_()->sitegroup()->isGroupOwnerAllow($sitegroup, 'offer');
      if (empty($groupOwnerBase)) {
        return $this->setNoRender();
      }
    }
    // PACKAGE BASE PRIYACY END     
    
//    //START MANAGE-ADMIN CHECK
//    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'view');
//    if (empty($isManageAdmin)) {
//      return $this->setNoRender();
//    }

    $can_edit = 1;
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
      //return $this->_forward('requireauth', 'error', 'core');
    }

    $can_offer = 1;
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'offer');
    if (empty($isManageAdmin)) {
      $can_offer = 0;
    }
    //END MANAGE-ADMIN CHECK

    $can_create_offer = '';
    //OFFER CREATION AUTHENTICATION CHECK
    if ($can_edit == 1 && $can_offer == 1) {
      $this->view->can_create_offer = $can_create_offer =  1;
    }

    //TOTAL OFFER
    $offerCount = Engine_Api::_()->sitegroup()->getTotalCount($sitegroup->group_id, 'sitegroupoffer', 'offers');     
    if (empty($can_create_offer) && empty($offerCount) && !(Engine_Api::_()->sitegroup()->showTabsWithoutContent())) {
      return $this->setNoRender();
    }       
    
    $var = 1;
//    $this->view->paginator = $paginator = Engine_Api::_()->getItemTable('sitegroupoffer_offer')->getSitegroupoffersPaginator($sitegroup->group_id, $var,'',$can_create_offer);
//    if(!empty($paginator)) {
//			$count = $paginator->getTotalItemCount();
//    }
    
    //GETTING TAB ID FROM CONTENT TABLE
    $layout = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroup.layoutcreate', 0);
    $this->view->widgets = $widgets = Engine_Api::_()->sitegroup()->getwidget($layout, $sitegroup->group_id);
    $this->view->content_id = Engine_Api::_()->sitegroup()->GetTabIdinfo('sitegroupoffer.profile-sitegroupoffers', $sitegroup->group_id, $layout);

    $this->view->module_tabid = $currenttabid = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab', null);
    $isajax = $this->_getParam('isajax', null);
    $this->view->isajax = $isajax;
    $this->view->showtoptitle = $showtoptitle = Engine_Api::_()->sitegroup()->showtoptitle($layout, $sitegroup->group_id);
    if (!empty($isajax) || ($currenttabid == $this->view->identity) || ($widgets == 0)) {
      $this->view->identity_temp = Zend_Controller_Front::getInstance()->getRequest()->getParam('identity_temp', $currenttabid);
      $this->view->show_content = true;

      //MAKE PAGINATOR
      $currentGroupNumber = $this->_getParam('group', 1);
      $var = 1;
      $this->view->paginator = $paginator = Engine_Api::_()->getItemTable('sitegroupoffer_offer')->getSitegroupoffersPaginator($sitegroup->group_id, $var,'',$can_create_offer);
      $this->_childCount = $paginator->getTotalItemCount();
      $paginator->setItemCountPerPage(10)->setCurrentPageNumber($currentGroupNumber);
    } else {
      $this->view->show_content = false;
      $this->view->identity_temp = $this->view->identity;
      $var = 1;
      $show_count = 1;
      $this->view->paginator = $paginator = Engine_Api::_()->getItemTable('sitegroupoffer_offer')->getSitegroupoffersPaginator($sitegroup->group_id, $var, $show_count,$can_create_offer);
      $this->_childCount = $paginator->getTotalItemCount();
    }

    // START: "SUGGEST TO FRIENDS" LINK WORK.
    $group_flag = 0;
    $is_suggestion_enabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('suggestion');
    $this->view->is_moduleEnabled = $is_moduleEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitegroup');
		$isModuleInfo = Engine_Api::_()->getDbtable('modules', 'core')->getModule('suggestion');
    $isSupport = Engine_Api::_()->getApi('suggestion', 'sitegroup')->isSupport();
		
    // HERE WE ARE DELETE THIS POLL SUGGESTION IF VIEWER HAVE.

    if (Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroup.package.enable', 1)) {
      if ($sitegroup->expiration_date <= date("Y-m-d H:i:s")) {
        $group_flag = 1;
      }
    }

    if (!empty($viewer_id) && !empty($isSupport) && empty($sitegroup->closed) && !empty($sitegroup->approved) && empty($sitegroup->declined) && !empty($sitegroup->draft) && empty($group_flag) && !empty($is_suggestion_enabled) && ($isModuleInfo->version >= '4.1.7p2')) {
      $this->view->offerSuggLink = Engine_Api::_()->suggestion()->getModSettings('sitegroup', 'offer_sugg_link');
    }
    // END: "SUGGEST TO FRIENDS" LINE WORK.
  }

  public function getChildCount() {
    return $this->_childCount;
  }

}
?>