<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegrouppoll
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: IndexController.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegrouppoll_IndexController extends Seaocore_Controller_Action_Standard {

  //ACTION FOR CREATING POLL
  public function createAction() {

    //CHECK USER VALIDATION
    if (!$this->_helper->requireUser()->isValid())
      return;

    //NUMBER OF OPTIONS WHICH WILL BE SHOW AT THE TIME OF POLL CREATION
    $this->view->maxOptions = $max_options = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegrouppoll.maxoptions', 15);

    //GET NAVIGATION
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
            ->getNavigation('sitegroup_main');

    $getPollCreate = Engine_Api::_()->sitegroup()->getPackageAuthInfo('sitegrouppoll');

    //GET LOGGED IN USER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();

    $sitegroupPollHostName = str_replace('www.', '', strtolower($_SERVER['HTTP_HOST']));

    //GET GROUP ID
    $group_id = $this->_getParam('group_id');
    if (empty($group_id)) {
      return;
    }

    //GET GROUP OBJECT
    $this->view->sitegroup = $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $group_id);

    //PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
      if ((!Engine_Api::_()->sitegroup()->allowPackageContent($sitegroup->package_id, "modules", "sitegrouppoll")) || empty($getPollCreate)) {
        return $this->_forwardCustom('requireauth', 'error', 'core');
      }
    } else {
      $isGroupOwnerAllow = Engine_Api::_()->sitegroup()->isGroupOwnerAllow($sitegroup, 'splcreate');
      if (empty($isGroupOwnerAllow) || empty($getPollCreate)) {
        return $this->_forwardCustom('requireauth', 'error', 'core');
      }
    }

    //IS PICCHART ALLOW OR NOT.
    $isPieChart = Engine_Api::_()->sitegrouppoll()->isPieChart();

    $maxLenght = Zend_Registry::isRegistered('sitegrouppoll_maxLenght') ? Zend_Registry::get('sitegrouppoll_maxLenght') : null;
    //PACKAGE BASE PRIYACY END
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'view');
    if (empty($isManageAdmin)) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }

    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
    if (empty($isManageAdmin)) {
      $this->view->can_edit = $can_edit = 0;
    } else {
      $this->view->can_edit = $can_edit = 1;
    }

    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'splcreate');
    if (empty($isManageAdmin) && empty($can_edit)) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }
    //END MANAGE-ADMIN CHECK
    //SEND TAB ID TO TPL
    $this->view->tab_selected_id = $this->_getParam('tab');

    //GENERATE FORM
    $this->view->form = $form = new Sitegrouppoll_Form_Create();

    if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
      $translate = Zend_Registry::get('Zend_Translate');

      //CHECK OPTIONS
      $options = (array) $this->_getParam('optionsArray');
      $options = array_filter(array_map('trim', $options));
      $options = array_slice($options, 0, $max_options);
      $this->view->options = $options;
      if (empty($options) || !is_array($options) || count($options) < 2) {
        $error = Zend_Registry::get('Zend_Translate')->_('You must provide at least two possible answers.');
        return $form->addError($error);
      }
      foreach ($options as $index => $option) {
        if (strlen($option) > 80) {
          $options[$index] = Engine_String::substr($option, 0, 80);
        }
      }

      if (empty($isPieChart)) {
        return;
      }

      $isModType = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegrouppoll.set.type', 0);
      if (empty($isModType)) {
        Engine_Api::_()->getApi('settings', 'core')->setSetting('sitegrouppoll.type', convert_uuencode($sitegroupPollHostName));
      }

      //CONNET WITH POLL TABLE
      $sitegrouppollTable = Engine_Api::_()->getItemTable('sitegrouppoll_poll');
      $sitegrouppollOptionsTable = Engine_Api::_()->getDbtable('options', 'sitegrouppoll');
      $db = $sitegrouppollTable->getAdapter();
      $db->beginTransaction();

      //GET POSTED VALUES FROM CREATE FORM
      $values = $form->getValues();
      if ($values['end_settings'] == 1 && $values['end_time'] == 0) {
        $error = $message . $this->view->translate('Please select end-date and time from calendar !');
        $error = Zend_Registry::get('Zend_Translate')->_($error);
        $form->getDecorator('errors')->setOption('escape', false);
        $form->addError($error);
        return;
      }

      if (empty($maxLenght)) {
        return;
      }

      //POLL CREATION CODE
      try {
        $values = array_merge($form->getValues(), array(
            'owner_type' => $viewer->getType(),
            'owner_id' => $viewer_id,
                ));

        $this->view->is_error = 0;
        $this->view->excep_error = 0;

        //CREATE THE MAIN POLL
        $siteGroupPollRow = $sitegrouppollTable->createRow();
        $siteGroupPollRow->setFromArray($values);
        $siteGroupPollRow->group_id = $group_id;
        $siteGroupPollRow->approved = 1;
        $siteGroupPollRow->parent_type = 'sitegroup_group';
        $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $group_id);
        $siteGroupPollRow->save();

        //CREATE OPTIONS
        $censor = new Engine_Filter_Censor();
        foreach ($options as $option) {
          $sitegrouppollOptionsTable->insert(array(
              'poll_id' => $siteGroupPollRow->poll_id,
              'sitegrouppoll_option' => $censor->filter($option),
          ));
        }

        //COMMENT PRIVACY
        $auth = Engine_Api::_()->authorization()->context;
        $roles = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'everyone');
        $auth_comment = "everyone";
        $commentMax = array_search($auth_comment, $roles);
        foreach ($roles as $i => $role) {
          $auth->setAllowed($siteGroupPollRow, $role, 'comment', ($i <= $commentMax));
        }

        //ACTIVITY FEED
        if ($siteGroupPollRow->search == 1) {
          $actionTable = Engine_Api::_()->getDbtable('actions', 'activity');
          $activityFeedType = null;
          if (Engine_Api::_()->sitegroup()->isGroupOwner($sitegroup) && Engine_Api::_()->sitegroup()->isFeedTypeGroupEnable())
            $activityFeedType = 'sitegrouppoll_admin_new';
          elseif ($sitegroup->all_post || Engine_Api::_()->sitegroup()->isGroupOwner($sitegroup))
            $activityFeedType = 'sitegrouppoll_new';
          if ($activityFeedType) {
            $action = Engine_Api::_()->getDbtable('actions', 'activity')->addActivity($viewer, $sitegroup, $activityFeedType);
            Engine_Api::_()->getApi('subCore', 'sitegroup')->deleteFeedStream($action);
          }
          if ($action != null) {
            Engine_Api::_()->getDbtable('actions', 'activity')->attachActivity($action, $siteGroupPollRow);
          }

          //SENDING ACTIVITY FEED TO FACEBOOK.
          $enable_Facebooksefeed = $enable_fboldversion = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('facebooksefeed');
          if (!empty($enable_Facebooksefeed)) {

            $poll_array = array();
            $poll_array['type'] = 'sitegrouppoll_new';
            $poll_array['object'] = $siteGroupPollRow;

            Engine_Api::_()->facebooksefeed()->sendFacebookFeed($poll_array);
          }

					//GROUP POLL CREATE NOTIFICATION AND EMAIL WORK
					if(!empty($action)) {
						$sitegroupVersion = Engine_Api::_()->getDbtable('modules', 'core')->getModule('sitegroup')->version;
						if ($sitegroupVersion >= '4.3.0p1') {
							Engine_Api::_()->sitegroup()->sendNotificationEmail($siteGroupPollRow, $action, 'sitegrouppoll_create', 'SITEGROUPPOLL_CREATENOTIFICATION_EMAIL', 'Groupevent Invite');
							$isGroupAdmins = Engine_Api::_()->getDbtable('manageadmins', 'sitegroup')->isGroupAdmins($viewer->getIdentity(), $group_id);
							if (!empty($isGroupAdmins)) {
								//NOTIFICATION FOR ALL FOLLWERS.
								Engine_Api::_()->sitegroup()->sendNotificationToFollowers($siteGroupPollRow, $action, 'sitegrouppoll_create');
							}
						}
					}
        }
        $db->commit();
      } catch (Exception $e) {
        $db->rollBack();
        throw $e;
      }

      //GO TO SITEGROUP PROFILE GROUP WITH SITEGROUP POLL SELECTED TAB
      return $this->_redirectCustom($siteGroupPollRow->getHref(), array('prependBase' => false));
    }
  }

  //ACTION FOR VIEW THE POLL
  public function viewAction() {

    //GET LOGGED IN USER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();

    //GET POLL ITEM
    $sitegrouppoll = Engine_Api::_()->getItem('sitegrouppoll_poll', $this->getRequest()->getParam('poll_id'));

		if ($sitegrouppoll) {
			Engine_Api::_()->core()->setSubject($sitegrouppoll);
		}

    //GET SITEGROUP ITEM
    $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $sitegrouppoll->group_id);

    //PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitegroup()->allowPackageContent($sitegroup->package_id, "modules", "sitegrouppoll")) {
        return $this->_forwardCustom('requireauth', 'error', 'core');
      }
    } else {
      $isGroupOwnerAllow = Engine_Api::_()->sitegroup()->isGroupOwnerAllow($sitegroup, 'splcreate');
      if (empty($isGroupOwnerAllow)) {
        return $this->_forwardCustom('requireauth', 'error', 'core');
      }
    }
    //PACKAGE BASE PRIYACY END

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'splcreate');
    if (empty($isManageAdmin)) {
      $this->view->can_create = 0;
    } else {
      $this->view->can_create = 1;
    }
    
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'view');
    if (empty($isManageAdmin)) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }
    //END MANAGE-ADMIN CHECK

    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK
    //CHECKING THE USER HAVE THE PERMISSION TO VIEW THE POLL OR NOT
    if ($sitegrouppoll->owner_id != $viewer_id && $can_edit != 1 && ( empty($sitegrouppoll->approved) || empty($sitegrouppoll->search))) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }

    //NAVIGATION WORK FOR FOOTER.(DO NOT DISPLAY NAVIGATION IN FOOTER ON VIEW PAGE.)
    if (!Engine_API::_()->seaocore()->checkSitemobileMode('fullsite-mode')) {
         if(!Zend_Registry::isRegistered('sitemobileNavigationName')){
         Zend_Registry::set('sitemobileNavigationName','setNoRender');
         }
    }
   //CHECK THE VERSION OF THE CORE MODULE
    $coremodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core');
    $coreversion = $coremodule->version;
    if ($coreversion < '4.1.0') {
      $this->_helper->content->render();
    } else {
      $this->_helper->content
              ->setNoRender()
              ->setEnabled()
      ;
    }
  }

  //ACTION FOR DELETE POLL
  public function deleteAction() {

    //CHECK USER VALIDATION
    if (!$this->_helper->requireUser()->isValid())
      return;

    //GET LOGGED IN INFORMATION
    $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();

    //GET TAB ID OF POLL ON THE GROUP PROFILE GROUP
    $this->view->tab_selected_id = $tab_selected_id = $this->_getParam('tab');
    $group_id = $this->_getParam('group_id');

    //GET NAVIGATION
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
            ->getNavigation('sitegroup_main');

    //RETURN IF GROUP ID IS EMPTY
    if (empty($group_id)) {
      return;
    }

    //GET SITEGROUP OBJECT
    $this->view->sitegroup = $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $group_id);

    //GET GROUPPOLL OBJECT
    $this->view->sitegrouppoll = $sitegrouppoll = Engine_Api::_()->getItem('sitegrouppoll_poll', $this->_getParam('poll_id'));

    //PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitegroup()->allowPackageContent($sitegroup->package_id, "modules", "sitegrouppoll")) {
        return $this->_forwardCustom('requireauth', 'error', 'core');
      }
    } else {
      $isGroupOwnerAllow = Engine_Api::_()->sitegroup()->isGroupOwnerAllow($sitegroup, 'splcreate');
      if (empty($isGroupOwnerAllow)) {
        return $this->_forwardCustom('requireauth', 'error', 'core');
      }
    }
    //PACKAGE BASE PRIYACY END
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK
    //POLL OWNER AND SITEGROUP OWNER CAN DELETE POLL
    if ($viewer_id != $sitegrouppoll->owner_id && $can_edit != 1) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }

    //DELETE POLL FROM DATATBASE AND SCRIBD AFTER CONFIRMATION
    if ($this->getRequest()->isPost() && $this->getRequest()->getPost('confirm') == true) {

      //FINALLY DELETE GROUP POLL
      $sitegrouppoll->delete();

			return $this->_gotoRouteCustom(array('group_url' => Engine_Api::_()->sitegroup()->getGroupUrl($group_id), 'tab' => $this->view->tab_selected_id), 'sitegroup_entry_view', true);
    }
  }

  public function voteAction() {

    //CHECK USER VALIDATION
    if (!$this->_helper->requireUser()->isValid()) {
      return;
    }

    //GET SUBJECT
    $sitegrouppoll = null;
    if (null !== ($sitegrouppollIdentity = $this->_getParam('poll_id'))) {
      $sitegrouppoll = Engine_Api::_()->getItem('sitegrouppoll_poll', $sitegrouppollIdentity);
      if (null !== $sitegrouppoll) {
        Engine_Api::_()->core()->setSubject($sitegrouppoll);
      }
    }

    //CHECK METHOD
    if (!$this->getRequest()->isPost()) {
      return;
    }

    //GET OPTION ID
    $this->view->option_id = $option_id = $this->_getParam('option_id');

    $getPackagepollvote = Engine_Api::_()->sitegroup()->getPackageAuthInfo('sitegrouppoll');

    //CAN CHANGE VOTE OR NOT
    $canChangeVote = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegrouppoll.canchangevote', false);

    //GET VIEWER INFO
    $viewer = Engine_Api::_()->user()->getViewer();
    if (empty($getPackagepollvote)) {
      return;
    }

    if (!$sitegrouppoll) {
      $this->view->success = false;
      $this->view->error = Zend_Registry::get('Zend_Translate')->_('This poll does not seem to exist anymore.');
      return;
    }
    
    $hashElement = $this->view->groupPollVoteHash($sitegrouppoll)->getElement();
    if (!$hashElement->isValid($this->_getParam('token'))) {
      $this->view->success = false;
      $this->view->error = join(';', $hashElement->getMessages());
      return;
    }

    if( $sitegrouppoll->closed ) {
      $this->view->success = false;
      $this->view->error = Zend_Registry::get('Zend_Translate')->_('This poll is closed.');
      return;
    }

    //CHECK FOR THE USER THAT CAN CHANGE VOTE OR NOT.
    if ($sitegrouppoll->hasVoted($viewer) && !$canChangeVote) {
      $this->view->success = false;
      $this->view->error = Zend_Registry::get('Zend_Translate')->_('You have already voted on this poll, and are not permitted to change your vote.');
      return;
    }

    //MAKE VOTE ENTRY IN DATATBASE
    $db = Engine_Api::_()->getDbtable('polls', 'sitegrouppoll')->getAdapter();
    $db->beginTransaction();
    try {
      $sitegrouppoll->vote($viewer, $option_id);
      $db->commit();
    } catch (Exception $e) {
      $db->rollback();
      $this->view->success = false;
      throw $e;
    }

    $this->view->token = $this->view->groupPollVoteHash($sitegrouppoll)->generateHash();
    $this->view->success = true;
    $sitegrouppollOptions = array();
    foreach ($sitegrouppoll->getOptions()->toArray() as $option) {
      $option['votesTranslated'] = $this->view->translate(array('%s vote', '%s votes', $option['votes']), $this->view->locale()->toNumber($option['votes']));
      $sitegrouppollOptions[] = $option;
    }
    $this->view->sitegrouppollOptions = $sitegrouppollOptions;
    $this->view->votes_total = $sitegrouppoll->vote_count;
  }

  public function closeAction() {
    if (!$this->_helper->requireUser()->isValid())
      return;

    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    $sitegrouppoll = Engine_Api::_()->getItem('sitegrouppoll_poll', $this->_getParam('poll_id'));
    $group_id = $this->_getParam('group_id');
    $tab_selected_id = $this->_getParam('tab');

    //GET SITEGROUP OBJECT
    $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $group_id);

    //PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitegroup()->allowPackageContent($sitegroup->package_id, "modules", "sitegrouppoll")) {
        return $this->_forwardCustom('requireauth', 'error', 'core');
      }
    } else {
      $isGroupOwnerAllow = Engine_Api::_()->sitegroup()->isGroupOwnerAllow($sitegroup, 'splcreate');
      if (empty($isGroupOwnerAllow)) {
        return $this->_forwardCustom('requireauth', 'error', 'core');
      }
    }
    //PACKAGE BASE PRIYACY END
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK
    //POLL OWNER AND SITEGROUP OWNER CAN DELETE POLL
    if ($viewer_id != $sitegrouppoll->owner_id && $can_edit != 1) {
      return $this->_forwardCustom('requireauth', 'error', 'core');
    }

    $sitegrouppollTable = $sitegrouppoll->getTable();
    $db = $sitegrouppollTable->getAdapter();
    $db->beginTransaction();

    try {
      $sitegrouppoll->closed = (bool) $this->_getParam('closed');
      $sitegrouppoll->save();

      $db->commit();
    } catch (Exception $e) {
      $db->rollBack();
      throw $e;
    }
    return $this->_gotoRouteCustom(array('group_url' => Engine_Api::_()->sitegroup()->getGroupUrl($group_id), 'tab' => $tab_selected_id), 'sitegroup_entry_view', true);
  }

   public function browseAction() {

   //CHECK VIEW PRIVACY
    if (!$this->_helper->requireAuth()->setAuthParams('sitegroup_group', null, 'view')->isValid())
      return;

   //CHECK THE VERSION OF THE CORE MODULE
    $coremodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core');
    $coreversion = $coremodule->version;
    if ($coreversion < '4.1.0') {
      $this->_helper->content->render();
    } else {
      $this->_helper->content
              ->setNoRender()
              ->setEnabled()
      ;
    }
  }

}