<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegrouppoll
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$isActive = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegrouppoll.isActivate', 0);
if (empty($isActive)) {
  return;
}

$categories = Engine_Api::_()->getDbTable('categories', 'sitegroup')->getCategories();
if (count($categories) != 0) {
  $categories_prepared[0] = "";
  foreach ($categories as $category) {
    $categories_prepared[$category->category_id] = $category->category_name;
  }
}

$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => 'Group Profile Polls',
        'description' => 'This widget forms the Polls tab on the Group Profile and displays the polls of the Group. It should be placed in the Tabbed Blocks area of the Group Profile.',
        'category' => 'Group Profile',
        'type' => 'widget',
        'name' => 'sitegrouppoll.profile-sitegrouppolls',
        'defaultParams' => array(
            'title' => 'Polls',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => 'Group Profile Most Commented Polls',
        'description' => 'Displays list of a Group\'s most commented polls. This widget should be placed on the Group Profile.',
        'category' => 'Group Profile',
        'type' => 'widget',
        'name' => 'sitegrouppoll.comment-sitegrouppolls',
        'defaultParams' => array(
            'title' => 'Most Commented Polls',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of polls to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
					),
        ),
    ),
    array(
        'title' => 'Group Profile Most Viewed Polls',
        'description' => 'Displays list of a Group\'s most viewed polls. This widget should be placed on the Group Profile.',
        'category' => 'Group Profile',
        'type' => 'widget',
        'name' => 'sitegrouppoll.view-sitegrouppolls',
        'defaultParams' => array(
            'title' => 'Most Viewed Polls',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of polls to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
					),
        ),
    ),
    array(
        'title' => 'Group Profile Most Voted Polls',
        'description' => 'Displays list of a Group\'s most voted polls. This widget should be placed on the Group Profile.',
        'category' => 'Group Profile',
        'type' => 'widget',
        'name' => 'sitegrouppoll.vote-sitegrouppolls',
        'defaultParams' => array(
            'title' => 'Most Voted Polls',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of polls to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
					),
        ),
    ),
    array(
        'title' => 'Group Profile Most Recent Polls',
        'description' => 'Displays list of a group\'s most recent polls. This widget should be placed on the Group Profile.',
        'category' => 'Group Profile',
        'type' => 'widget',
        'name' => 'sitegrouppoll.recent-sitegrouppolls',
        'defaultParams' => array(
            'title' => 'Most Recent Polls',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of polls to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
					),
        ),
    ),
    array(
        'title' => 'Group Profile Most Liked Polls',
        'description' => 'Displays list of a group\'s most liked polls. This widget should be placed on the Group Profile.',
        'category' => 'Group Profile',
        'type' => 'widget',
        'name' => 'sitegrouppoll.like-sitegrouppolls',
        'defaultParams' => array(
            'title' => 'Most Liked Polls',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of polls to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
					),
        ),
    ),

    array(
        'title' => 'Most Commented Polls',
        'description' => "Displays the Most Commented Group Polls. You can choose the number of entries to be shown.",
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegrouppoll.homecomment-sitegrouppolls',
        'defaultParams' => array(
            'title' => 'Most Commented Polls',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of polls to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							  ),
            ),
        ),
    ),
 
    array(
        'title' => 'Most Voted Polls',
        'description' => "Displays list of Group's most voted polls.",
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegrouppoll.homevote-sitegrouppolls',
        'defaultParams' => array(
            'title' => 'Most Voted Polls',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of polls to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							  ),
            ),
        ),
    ),

    array(
        'title' => 'Most Viewed Polls',
        'description' => "Displays the Most Viewed Group Polls. You can choose the number of entries to be shown.",
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegrouppoll.homeview-sitegrouppolls',
        'defaultParams' => array(
            'title' => 'Most Viewed Polls',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of polls to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							  ),
            ),
        ),
    ),

    array(
        'title' => 'Most Liked Polls',
        'description' => "Displays the Most Liked Group Polls. You can choose the number of entries to be shown.",
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegrouppoll.homelike-sitegrouppolls',
        'defaultParams' => array(
            'title' => 'Most Liked Polls',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of polls to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
						  ),
					),
        ),
    ),

    array(
        'title' => 'Recent Polls',
        'description' => 'Displays the recent polls of the site.',
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegrouppoll.homerecent-sitegrouppolls',
        'defaultParams' => array(
            'title' => 'Recent Polls'
        ),
         'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of polls to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
					    ),
					),
        ),
    ),

    array(
			'title' => 'Search Group Polls form',
			'description' => 'Displays the form for searching Group Polls on the basis of various filters. You can edit the fields to be available in this form.',
			'category' => 'Groups',
			'type' => 'widget',
			'name' => 'sitegrouppoll.search-sitegrouppoll',
			'defaultParams' => array(
					'title' => '',
          'search_column' => array("0" => "1", "1" => "2", "2" => "3", "3" => "4", "4" => '5'),
					'titleCount' => true,

			),
			'adminForm' => array(
              'elements' => array(
							array(
									'MultiCheckbox',
									'search_column',
									array(
											'label' => 'Choose the fields that you want to be available in the Search Group Polls form widget.',
											'multiOptions' => array("1" => "Show","2" => "Browse By", "3" => "Group Title", "4" => "Poll Keywords", "5" => "Group Category"),
									),
							),
					),
			)
    ),

    array(
        'title' => 'Group Polls',
        'description' => 'Displays a list of all the groups poll on site. This widget should be placed on the  Groups poll group.',
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegrouppoll.sitegroup-poll',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of polls to show)',
                        'value' => 20,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),

    array(
        'title' => 'Sponsored Polls',
        'description' => 'Displays the Polls from Paid Groups. You can choose the number of entries to be shown.',
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegrouppoll.sitegroup-sponsoredpoll',
        'defaultParams' => array(
            'title' => 'Sponsored Polls',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of polls to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							  ),
            ),
        ),
    ),

    array(
			'title' => 'Group Poll View',
			'description' => "This widget should be placed on the Group Poll View Page.",
      'category' => 'Groups',
			'type' => 'widget',
			'name' => 'sitegrouppoll.sitegrouppoll-content',
			'defaultParams' => array(
					'title' => '',
					'titleCount' => true,
			),
	),

  array(
    'title' => 'Top Creators : Group Polls',
    'description' => 'Displays the Groups which have the most number of Group Polls added in them. Motivates Group Admins to add more content on your website.',
    'category' => 'Groups',
    'type' => 'widget',
    'name' => 'sitegrouppoll.topcreators-sitegrouppoll',
   // 'isPaginated' => true,
    'defaultParams' => array(
      'title' => 'Top Creators',
    ),
     'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of elements to show)',
										'value' => 5,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
						),
					),
        ),
    'requirements' => array(
      'subject' => 'sitegrouppoll',
    ),
  ),
)
?>