<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegrouppoll
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegrouppoll_Widget_SitegrouppollContentController extends Seaocore_Content_Widget_Abstract {

  public function indexAction() {

     //GET LOGGED IN USER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewer_id = $viewer->getIdentity();

    //GET THE TAB ID OF POLL ON GROUP PROFILE GROUP
    $this->view->tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab');
    //GET GROUPPOLL MODEL
    $this->view->sitegrouppoll = $sitegrouppoll = Engine_Api::_()->core()->getSubject('sitegrouppoll_poll');
    if (empty($sitegrouppoll)) {
      return $this->setNoRender();
    }

    //GET THE GROUP ID
    $this->view->group_id = $group_id = $sitegrouppoll->group_id;

    //GET SITEGROUP OBJECT
    $this->view->sitegroup = $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $group_id);

    //PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitegroup()->allowPackageContent($sitegroup->package_id, "modules", "sitegrouppoll")) {
        return $this->setNoRender();
      }
    } else {
      $isGroupOwnerAllow = Engine_Api::_()->sitegroup()->isGroupOwnerAllow($sitegroup, 'splcreate');
      if (empty($isGroupOwnerAllow)) {
        return $this->setNoRender();
      }
    }
    // PACKAGE BASE PRIYACY END
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'splcreate');
    if (empty($isManageAdmin)) {
      $this->view->can_create = 0;
    } else {
      $this->view->can_create = 1;
    }

    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'view');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }

    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'comment');
    if (empty($isManageAdmin)) {
      $this->view->can_comment = 0;
    } else {
      $this->view->can_comment = 1;
    }

    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
    if (empty($isManageAdmin)) {
      $this->view->can_edit = $can_edit = 0;
    } else {
      $this->view->can_edit = $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK
    //DIS-APPROVED POLL WILL BE VISIBLE ONLY TO POLL-OWNER, SITEGROUP-OWNER AND MANAGE-ADMIN
    if ($sitegrouppoll->owner_id != $viewer_id && $can_edit != 1 && ( empty($sitegrouppoll->approved) || empty($sitegrouppoll->search))) {
      return $this->setNoRender();
    }

    //WHO CAN VOTE
    if (!empty($viewer_id) && $sitegrouppoll->approved == 1 && $sitegrouppoll->search == 1) {
      $this->view->can_vote = $can_vote = 1;
    } else {
      $this->view->can_vote = $can_vote = 0;
    }
    $getPackagepollview = Engine_Api::_()->sitegroup()->getPackageAuthInfo('sitegrouppoll');

    //GET OWNER INFORMATION
    Engine_Api::_()->sitegrouppoll()->setPollPackages();
    $owner = $sitegrouppoll->getOwner();

    //REPORT CODE
//     if (!empty($viewer_id)) {
//       $report = $sitegrouppoll;
//       if (!empty($report)) {
//         Engine_Api::_()->core()->setSubject($report);
//       }
// //       if (!$this->_helper->requireSubject()->isValid())
// //         return;
//     }

    $this->view->sitegrouppollOptions = empty($getPackagepollview) ? null : $sitegrouppoll->getOptions();
    $this->view->hasVoted = $sitegrouppoll->viewerVoted();
    $this->view->showPieChart = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegrouppoll.showPieChart', false);
    $this->view->canVote = $can_vote;
    $this->view->canChangeVote = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegrouppoll.canchangevote', false);

    //INCREMENT IN NUMBER OF VIEWS
    if (!$owner->isSelf($viewer)) {
      $sitegrouppoll->views++;
    }

    $sitegrouppoll->save();

    // START: "SUGGEST TO FRIENDS" LINK WORK.
    $group_flag = 0;
    $is_suggestion_enabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('suggestion');
    $is_moduleEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitegroup');
    $isSupport = Engine_Api::_()->getApi('suggestion', 'sitegroup')->isSupport();
    if (!empty($is_suggestion_enabled)) {
      // HERE WE ARE DELETE THIS POLL SUGGESTION IF VIEWER HAVE.
      if (!empty($is_moduleEnabled)) {
        Engine_Api::_()->getApi('suggestion', 'sitegroup')->deleteSuggestion($viewer_id, 'group_poll', Zend_Controller_Front::getInstance()->getRequest()->getParam('poll_id'), 'group_poll_suggestion');
      }

      $SuggVersion = Engine_Api::_()->getDbtable('modules', 'core')->getModule('suggestion')->version;
      $versionStatus = strcasecmp($SuggVersion, '4.1.7p1');
      if ($versionStatus >= 0) {
        $modContentObj = Engine_Api::_()->suggestion()->getSuggestedFriend('sitegrouppoll', Zend_Controller_Front::getInstance()->getRequest()->getParam('poll_id'), 1,null);
        if (!empty($modContentObj)) {
          $contentCreatePopup = @COUNT($modContentObj);
        }
      }

      if (Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroup.package.enable', 1)) {
        if ($sitegroup->expiration_date <= date("Y-m-d H:i:s")) {
          $group_flag = 1;
        }
      }
      if (!empty($contentCreatePopup) && !empty($isSupport) && empty($sitegroup->closed) && !empty($sitegroup->approved) && empty($sitegroup->declined) && !empty($sitegroup->draft) && empty($group_flag) && !empty($viewer_id) && !empty($is_suggestion_enabled)) {
        $this->view->pollSuggLink = Engine_Api::_()->suggestion()->getModSettings('sitegroup', 'poll_sugg_link');
      }
    }
    // END: "SUGGEST TO FRIENDS" LINE WORK.
  }

}
?>