<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteapi
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    FormValidation.php 2015-09-17 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupreview_Api_Siteapi_FormValidators extends Siteapi_Api_Validators {

    /**
     * Review form validators
     * 
     * @param type $widgetSettingsReviews
     * @return array
     */
    public function getReviewCreateFormValidators($widgetSettingsReviews) {

        $getItemPage = $widgetSettingsReviews['item'];
        $sitegroupreview_proscons = $widgetSettingsReviews['settingsReview']['sitegroupreview_proscons'];
        $sitegroupreview_limit_proscons = $widgetSettingsReviews['settingsReview']['sitegroupreview_limit_proscons'];
        $sitegroupreview_recommend = $widgetSettingsReviews['settingsReview']['sitegroupreview_recommend'];
        if ($sitegroupreview_proscons) {
            if ($sitegroupreview_limit_proscons) {
                $formValidators['pros'] = array(
                    'allowEmpty' => false,
                    'maxlength' => $widgetSettingsReviews['sitegroupreview_limit_proscons'],
                    'required' => true,
                    'filters' => array(
                        'StripTags',
                        new Engine_Filter_Censor(),
                        new Engine_Filter_HtmlSpecialChars(),
                        new Engine_Filter_EnableLinks(),
                    ),
                );
            } else {
                $formValidators['pros'] = array(
                    'allowEmpty' => false,
                    'required' => true,
                    'filters' => array(
                        'StripTags',
                        new Engine_Filter_Censor(),
                        new Engine_Filter_HtmlSpecialChars(),
                        new Engine_Filter_EnableLinks(),
                    ),
                );
            }
            if ($sitegroupreview_limit_proscons) {
                $formValidators['cons'] = array(
                    'allowEmpty' => false,
                    'maxlength' => $widgetSettingsReviews['sitegroupreview_limit_proscons'],
                    'required' => true,
                    'filters' => array(
                        'StripTags',
                        new Engine_Filter_Censor(),
                        new Engine_Filter_HtmlSpecialChars(),
                        new Engine_Filter_EnableLinks(),
                    ),
                );
            } else {
                $formValidators['cons'] = array(
                    'allowEmpty' => false,
                    'required' => true,
                    'filters' => array(
                        'StripTags',
                        new Engine_Filter_Censor(),
                        new Engine_Filter_HtmlSpecialChars(),
                        new Engine_Filter_EnableLinks(),
                    ),
                );
            }
        }
        $formValidators['title'] = array(
            'required' => true,
            'filters' => array(
                'StripTags',
                new Engine_Filter_Censor(),
                new Engine_Filter_HtmlSpecialChars(),
                new Engine_Filter_EnableLinks(),
            ),
        );

        $formValidators['review_rate_0'] = array(
            'required' => true,
        );

        return $formValidators;
    }

    /*
     * Comment validation form
     *
     * @return array
     */

    public function getcommentValidation() {
        $formValidators['body'] = array(
            'required' => true,
        );

        return $formValidators;
    }

}
