<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupreview
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Menus.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupreview_Plugin_Menus {

  public function canViewReviews() {

    if (!Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupreview.review.show.menu', 1)) {
      return false;
    }

    $table = Engine_Api::_()->getDbtable('reviews', 'sitegroupreview');
    $rName = $table->info('name');
    $table_groups = Engine_Api::_()->getDbtable('groups', 'sitegroup');
    $rName_groups = $table_groups->info('name');
    $select = $table->select()
                    ->setIntegrityCheck(false)
                    ->from($rName_groups, array('photo_id', 'title as sitegroup_title'))
                    ->join($rName, $rName . '.group_id = ' . $rName_groups . '.group_id');
                    
    $select = $select
                    ->where($rName_groups . '.closed = ?', '0')
                    ->where($rName_groups . '.approved = ?', '1')
                    ->where($rName_groups . '.search = ?', '1')
                    ->where($rName_groups . '.declined = ?', '0')
                    ->where($rName_groups . '.draft = ?', '1');
    if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
      $select->where($rName_groups . '.expiration_date  > ?', date("Y-m-d H:i:s"));
    }
    $row = $table->fetchAll($select);
    $count = count($row);
    if (empty($count)) {
      return false;
    }
    return true;
  }


  //SITEMOBILE GROUP REVIEW MENUS
  public function onMenuInitialize_SitegroupreviewEdit($row) {
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();

    $sitegroupreview = $this->getSitegroupReviewObject();
    if (empty($sitegroupreview)) {
      return false;
    }
    //GROUP ID
    $group_id = $sitegroupreview->group_id;

    $owner_id = $sitegroupreview->owner_id;

    //CHECKS FOR EDIT
    if ($viewer_id != $owner_id) {
      return false;
    }

    return array(
        'label' => 'Edit Review',
        'route' => 'sitegroupreview_edit',
        'class' => 'ui-btn-action',
        'params' => array(
            'review_id' => $sitegroupreview->getIdentity(),
            'group_id' => $group_id,
            'tab' => Zend_Controller_Front::getInstance()->getRequest()->getParam('tab')
        )
    );
  }

  public function onMenuInitialize_SitegroupreviewDelete($row) {
    $subject = Engine_Api::_()->core()->getSubject();
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();

    $sitegroupreview = $this->getSitegroupReviewObject();
    if (empty($sitegroupreview)) {
      return false;
    }
    //GROUP ID
    $group_id = $sitegroupreview->group_id;

    $owner_id = $sitegroupreview->owner_id;
    $viewer->level_id;

    //CHECK FOR DELETE
    if ($viewer_id != $owner_id && $viewer->level_id != 1) {
      return false;
    }

    return array(
        'label' => 'Delete Review',
        'route' => 'sitegroupreview_delete',
        'class' => 'ui-btn-danger smoothbox',
        'params' => array(
            'review_id' => $sitegroupreview->getIdentity(),
            'group_id' => $group_id,
            'tab' => Zend_Controller_Front::getInstance()->getRequest()->getParam('tab')
        )
    );
  }

  public function onMenuInitialize_SitegroupreviewReport($row) {
    $subject = Engine_Api::_()->core()->getSubject();
    $viewer = Engine_Api::_()->user()->getViewer();
    $review_report = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupreview.report', 1);
    $viewer_id = $viewer->getIdentity();

    //CHECK FOR REPORT
    if ($review_report != 1 || empty($viewer_id)) {
      return false;
    }

    return array(
        'label' => 'Report',
        'route' => 'default',
        'class' => 'ui-btn-action smoothbox',
        'params' => array(
            'module' => 'core',
            'controller' => 'report',
            'action' => 'create',
            'subject' => $subject->getGuid(),
        // 'format' => 'smoothbox'
        )
    );
  }

  public function getSitegroupReviewObject() {
    $subject = Engine_Api::_()->core()->getSubject();
    //GET REVIEW ID
    $review_id = $subject->getIdentity();
    //GET REVIEW ITEM
    $sitegroupreview = Engine_Api::_()->getItem('sitegroupreview_review', $review_id);
    //ASK
    if (empty($sitegroupreview)) {
      return false;
    }
    return $sitegroupreview;
  }
}
?>