<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupvideo
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Widget.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupvideo_Form_Admin_Widget extends Engine_Form {

  public function init() {
    $this
            ->setTitle('Widget Settings')
            ->setDescription('Configure the general settings for the various widgets available with this plugin.');

    $this->addElement('Text', 'sitegroupvideo_comment_widgets', array(
        'label' => 'Group Profile Most Commented Videos',
        'maxlength' => '3',
        'description' => 'How many videos will be shown in the group profile most commented videos widget (value can not be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupvideo.comment.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'sitegroupvideo_recent_widgets', array(
        'label' => 'Group Profile Most Recent Videos',
        'maxlength' => '3',
        'description' => 'How many videos should be shown in the group profile most recent videos widget (value cannot be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupvideo.recent.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'sitegroupvideo_like_widgets', array(
        'label' => 'Group Profile Most Liked Videos',
        'maxlength' => '3',
        'description' => 'How many videos should be shown in the group profile most liked videos widget (value cannot be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupvideo.like.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'sitegroupvideo_view_widgets', array(
        'label' => 'Group Profile Most Viewed Videos',
        'maxlength' => '3',
        'description' => 'How many videos will be shown in the group profile most viewed videos widget (value can not be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupvideo.view.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'sitegroupvideo_rate_widgets', array(
        'label' => 'Group Profile Top Rated Videos',
        'maxlength' => '3',
        'description' => 'How many videos should be shown in the group profile top rated videos widget (value cannot be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupvideo.rate.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'sitegroupvideo_featured_widgets', array(
        'label' => 'Group Profile Featured Videos',
        'maxlength' => '3',
        'description' => 'How many videos should be shown in the group profile featured videos widget (value cannot be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupvideo.featured.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'sitegroupvideo_homerecentvideos_widgets', array(
        'label' => 'Recent Videos',
        'maxlength' => '3',
        'description' => 'How many videos should be shown in the recent videos widget (value cannot be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupvideo.homerecentvideos.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Button', 'submit', array(
        'label' => 'Save Changes',
        'type' => 'submit',
        'ignore' => true
    ));
  }

}
?>