<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    sitegroupevent
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: WidgetSettings.php 6590 2010-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

//START LANGUAGE WORK
Engine_Api::_()->getApi('language', 'sitegroup')->languageChanges();
//END LANGUAGE WORK

//GET DB
$db = Zend_Db_Table_Abstract::getDefaultAdapter();	

//CHECK THAT SITEGROUP PLUGIN IS ACTIVATED OR NOT
$select = new Zend_Db_Select($db);
	$select
  ->from('engine4_core_settings')
  ->where('name = ?', 'sitegroup.is.active')
	->limit(1);
$sitegroup_settings = $select->query()->fetchAll();
if(!empty($sitegroup_settings)) {
	$sitegroup_is_active = $sitegroup_settings[0]['value'];
}
else {
	$sitegroup_is_active = 0;
}

//CHECK THAT SITEGROUP PLUGIN IS INSTALLED OR NOT
$select = new Zend_Db_Select($db);
	$select
	  ->from('engine4_core_modules')
  ->where('name = ?', 'sitegroup')
	->where('enabled = ?', 1);
$check_sitegroup = $select->query()->fetchObject();
if(!empty($check_sitegroup)  && !empty($sitegroup_is_active)) {
	$select = new Zend_Db_Select($db);
	$select_group = $select
										 ->from('engine4_core_pages', 'page_id')
										 ->where('name = ?', 'sitegroup_index_view')
										 ->limit(1);
  $group = $select_group->query()->fetchAll();
	if(!empty($group)) {
		$group_id = $group[0]['page_id'];
		
		//INSERTING THE VIDEO WIDGET IN SITEGROUP_ADMIN_CONTENT TABLE ALSO.
		Engine_Api::_()->getDbtable('admincontent', 'sitegroup')->setAdminDefaultInfo('sitegroupvideo.profile-sitegroupvideos', $group_id, 'Videos', 'true', '111');
	 
		//INSERTING THE VIDEO WIDGET IN CORE_CONTENT TABLE ALSO.
		Engine_Api::_()->getApi('layoutcore', 'sitegroup')->setContentDefaultInfo('sitegroupvideo.profile-sitegroupvideos', $group_id, 'Videos', 'true', '111');
		
    //INSERTING THE VIDEO WIDGET IN SITEGROUP_CONTENT TABLE ALSO.
    $select = new Zend_Db_Select($db);								
		$contentgroup_ids = $select->from('engine4_sitegroup_contentgroups', 'contentgroup_id')->query()->fetchAll();
    foreach ($contentgroup_ids as $contentgroup_id) {
			if(!empty($contentgroup_id)) {
        Engine_Api::_()->getDbtable('content', 'sitegroup')->setDefaultInfo('sitegroupvideo.profile-sitegroupvideos', $contentgroup_id['contentgroup_id'], 'Videos', 'true', '111');
			}
		}
	}

	
	
	
  $contentTable = Engine_Api::_()->getDbtable('content', 'core');
  $contentTableName = $contentTable->info('name');
 
  $select = new Zend_Db_Select($db);
	$select
					->from('engine4_core_modules')
					->where('name = ?', 'communityad')
					->where('enabled 	 = ?', 1)
					->limit(1);
	;
	$infomation = $select->query()->fetch();
	$select = new Zend_Db_Select($db);
	$select
					->from('engine4_core_settings')
					->where('name = ?', 'sitegroup.communityads')
					->where('value 	 = ?', 1)
					->limit(1);
    ;
  $rowinfo = $select->query()->fetch();

  $select = new Zend_Db_Select($db);
  $select
          ->from('engine4_core_pages')
          ->where('name = ?', 'sitegroupvideo_index_browse')
          ->limit(1);
  ;
  $info = $select->query()->fetch();
  if ( empty($info) ) {
    $db->insert('engine4_core_pages', array(
        'name' => 'sitegroupvideo_index_browse',
        'displayname' => 'Browse Group videos',
        'title' => 'Group Videos List',
        'description' => 'This is the group videos.',
        'custom' => 1,
    ));
    $group_id = $db->lastInsertId('engine4_core_pages');
//INSERT MAIN CONTAINER
    $mainContainer = $contentTable->createRow();
    $mainContainer->page_id = $group_id;
    $mainContainer->type = 'container';
    $mainContainer->name = 'main';
    $mainContainer->order = 2;
    $mainContainer->save();
    $container_id = $mainContainer->content_id;

//INSERT MAIN - MIDDLE CONTAINER
    $mainMiddleContainer = $contentTable->createRow();
    $mainMiddleContainer->page_id = $group_id;
    $mainMiddleContainer->type = 'container';
    $mainMiddleContainer->name = 'middle';
    $mainMiddleContainer->parent_content_id = $container_id;
    $mainMiddleContainer->order = 6;
    $mainMiddleContainer->save();
    $middle_id = $mainMiddleContainer->content_id;

//INSERT MAIN - RIGHT CONTAINER
    $mainRightContainer = $contentTable->createRow();
    $mainRightContainer->page_id = $group_id;
    $mainRightContainer->type = 'container';
    $mainRightContainer->name = 'right';
    $mainRightContainer->parent_content_id = $container_id;
    $mainRightContainer->order = 5;
    $mainRightContainer->save();
    $right_id = $mainRightContainer->content_id;

//INSERT TOP CONTAINER
    $topContainer = $contentTable->createRow();
    $topContainer->page_id = $group_id;
    $topContainer->type = 'container';
    $topContainer->name = 'top';
    $topContainer->order = 1;
    $topContainer->save();
    $top_id = $topContainer->content_id;

//INSERT TOP- MIDDLE CONTAINER
    $topMiddleContainer = $contentTable->createRow();
    $topMiddleContainer->page_id = $group_id;
    $topMiddleContainer->type = 'container';
    $topMiddleContainer->name = 'middle';
    $topMiddleContainer->parent_content_id = $top_id;
    $topMiddleContainer->order = 6;
    $topMiddleContainer->save();
    $top_middle_id = $topMiddleContainer->content_id;

    //INSERT NAVIGATION WIDGET
    Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroup.browsenevigation-sitegroup', $top_middle_id, 1);

//INSERT VIDEO WIDGET
    Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroupvideo.sitegroup-video', $middle_id, 2);

    //INSERT SEARCH GROUP VIDEO WIDGET
    Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroupvideo.search-sitegroupvideo', $right_id, 3, "", "true");

    //INSERT FEATURED GROUP VIDEO WIDGET
    Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroupvideo.homefeaturelist-sitegroupvideos', $right_id, 4, "Featured Videos", "true");

    //INSERT SPONSORED GROUP VIDEO WIDGET
    Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroupvideo.sitegroup-sponsoredvideo', $right_id, 5, "Sponsored Videos", "true");

    //INSERT MOST COMMENTED GROUP VIDEO WIDGET
    Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroupvideo.homecomment-sitegroupvideos', $right_id, 6, "Most Commented Videos", "true");

    //INSERT MOST VIEWED GROUP VIDEO WIDGET
    Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroupvideo.homeview-sitegroupvideos', $right_id, 7, "Most Viewed Videos", "true");

    //INSERT MOST LIKED GROUP VIDEO WIDGET
    Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroupvideo.homelike-sitegroupvideos', $right_id, 8, "Most Liked Videos", "true");

    //INSERT TOP RATED GROUP VIDEO WIDGET
    Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroupvideo.homerate-sitegroupvideos', $right_id, 9, "Top Rated Videos", "true");

    //INSERT RECENT GROUP VIDEO WIDGET
    Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroupvideo.homerecent-sitegroupvideos', $right_id, 10, "Recent Videos", "true");

    if ( !empty($infomation)  && !empty($rowinfo) ) {
      Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroup.group-ads', $right_id, 11, "", "true");
    }
  }

  $select = new Zend_Db_Select($db);

  // Check if it's already been placed
  $select = new Zend_Db_Select($db);
  $select
          ->from('engine4_core_pages')
          ->where('name = ?', 'sitegroupvideo_index_view')
          ->limit(1);
  ;
  $info = $select->query()->fetch();

  if ( empty($info) ) {
    $db->insert('engine4_core_pages', array(
        'name' => 'sitegroupvideo_index_view',
        'displayname' => 'Group Video View Page',
        'title' => 'View Group Video',
        'description' => 'This is the view group for a group video.',
        'custom' => 1,
        'provides' => 'subject=sitegroupvideo',
    ));
    $group_id = $db->lastInsertId('engine4_core_pages');

    // containers
    $db->insert('engine4_core_content', array(
        'page_id' => $group_id,
        'type' => 'container',
        'name' => 'main',
        'parent_content_id' => null,
        'order' => 1,
        'params' => '',
    ));
    $container_id = $db->lastInsertId('engine4_core_content');

    $db->insert('engine4_core_content', array(
        'page_id' => $group_id,
        'type' => 'container',
        'name' => 'right',
        'parent_content_id' => $container_id,
        'order' => 1,
        'params' => '',
    ));
    $right_id = $db->lastInsertId('engine4_core_content');

    $db->insert('engine4_core_content', array(
        'page_id' => $group_id,
        'type' => 'container',
        'name' => 'middle',
        'parent_content_id' => $container_id,
        'order' => 3,
        'params' => '',
    ));
    $middle_id = $db->lastInsertId('engine4_core_content');

    // middle column content
    $db->insert('engine4_core_content', array(
        'page_id' => $group_id,
        'type' => 'widget',
        'name' => 'sitegroupvideo.video-content',
        'parent_content_id' => $middle_id,
        'order' => 1,
        'params' => '',
    ));

    // right column
    $db->insert('engine4_core_content', array(
        'page_id' => $group_id,
        'type' => 'widget',
        'name' => 'sitegroupvideo.show-same-tags',
        'parent_content_id' => $right_id,
        'order' => 1,
        'params' => '{"title":"Similar Videos"}',
    ));

    $db->insert('engine4_core_content', array(
        'page_id' => $group_id,
        'type' => 'widget',
        'name' => 'sitegroupvideo.show-also-liked',
        'parent_content_id' => $right_id,
        'order' => 2,
        'params' => '{"title":"People Also Liked"}',
    ));

    $db->insert('engine4_core_content', array(
        'page_id' => $group_id,
        'type' => 'widget',
        'name' => 'sitegroupvideo.show-same-poster',
        'parent_content_id' => $right_id,
        'order' => 3,
        'params' => '{"title":"Other Videos From Group"}',
    ));

    if ( !empty($infomation)  && !empty($rowinfo) ) {
      Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroup.group-ads', $right_id, 4, "", "true");
    }

  }

  $select = new Zend_Db_Select($db);
	$select
					->from('engine4_core_modules')
					->where('name = ?', 'mobi')
					->where('enabled 	 = ?', 1)
					->limit(1);
	;  

	$infomation = $select->query()->fetch();
	if(!empty($infomation)) {
		$select = new Zend_Db_Select($db);
		$select
						->from('engine4_core_pages')
						->where('name = ?', 'sitegroupvideo_mobi_view')
						->limit(1);
		;
		$info = $select->query()->fetch();
		if (empty($info)) {
			$db->insert('engine4_core_pages', array(
					'name' => 'sitegroupvideo_mobi_view',
					'displayname' => 'Mobile Group Video Profile',
					'title' => 'Mobile Group Video Profile',
					'description' => 'This is the mobile verison of a Group video profile group.',
					'custom' => 0,
			));
			$group_id = $db->lastInsertId('engine4_core_pages');

			// containers
			$db->insert('engine4_core_content', array(
					'page_id' => $group_id,
					'type' => 'container',
					'name' => 'main',
					'parent_content_id' => null,
					'order' => 1,
					'params' => '',
			));
			$container_id = $db->lastInsertId('engine4_core_content');

			$db->insert('engine4_core_content', array(
					'page_id' => $group_id,
					'type' => 'container',
					'name' => 'right',
					'parent_content_id' => $container_id,
					'order' => 1,
					'params' => '',
			));
			$right_id = $db->lastInsertId('engine4_core_content');

			$db->insert('engine4_core_content', array(
					'page_id' => $group_id,
					'type' => 'container',
					'name' => 'middle',
					'parent_content_id' => $container_id,
					'order' => 3,
					'params' => '',
			));
			$middle_id = $db->lastInsertId('engine4_core_content');

			// middle column content
			$db->insert('engine4_core_content', array(
					'page_id' => $group_id,
					'type' => 'widget',
					'name' => 'sitegroupvideo.video-content',
					'parent_content_id' => $middle_id,
					'order' => 1,
					'params' => '',
			));

			// right column
			$db->insert('engine4_core_content', array(
					'page_id' => $group_id,
					'type' => 'widget',
					'name' => 'sitegroupvideo.show-same-tags',
					'parent_content_id' => $right_id,
					'order' => 1,
					'params' => '{"title":"Similar Videos"}',
			));

			$db->insert('engine4_core_content', array(
					'page_id' => $group_id,
					'type' => 'widget',
					'name' => 'sitegroupvideo.show-also-liked',
					'parent_content_id' => $right_id,
					'order' => 2,
					'params' => '{"title":"People Also Liked"}',
			));

			$db->insert('engine4_core_content', array(
					'page_id' => $group_id,
					'type' => 'widget',
					'name' => 'sitegroupvideo.show-same-poster',
					'parent_content_id' => $right_id,
					'order' => 3,
					'params' => '{"title":"From the same Member"}',
			));

		}
	}

  $db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`)
	VALUES ("sitegroupvideo_admin_widget_settings", "sitegroupvideo", "Widget Settings", "", \'{"route":"admin_default","module":"sitegroupvideo","controller":"widgets"}\', "sitegroupvideo_admin_main", "", 1, 0, 3)');

  $db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitegroupvideo_admin_submain_general_tab", "sitegroupvideo", "General Settings", "", \'{"route":"admin_default","module":"sitegroupvideo","controller":"widgets", "action": "index"}\', "sitegroupvideo_admin_submain", "", 1, 0, 1)');

	$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitegroupvideo_admin_submain_video_tab", "sitegroupvideo", "Tabbed Videos Widget", "", \'{"route":"admin_default","module":"sitegroupvideo","controller":"settings", "action": "widget"}\', "sitegroupvideo_admin_submain", "", 1, 0, 2)');

	$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitegroupvideo_admin_submain_dayitems", "sitegroupvideo", "Video of the Day", "", \'{"route":"admin_default","module":"sitegroupvideo","controller":"settings", "action": "manage-day-items"}\', "sitegroupvideo_admin_submain", "", 1, 0, 4)');


	$select = new Zend_Db_Select($db);
	$select
					->from('engine4_core_pages')
					->where('name = ?', 'sitegroupvideo_index_home')
					->limit(1);
	$info = $select->query()->fetch();
	if (empty($info)) {
		$db->insert('engine4_core_pages', array(
				'name' => 'sitegroupvideo_index_home',
				'displayname' => 'Group Videos Home',
				'title' => 'Group Videos Home',
				'description' => 'This is group video home group.',
				'custom' => 1
		));
		$group_id = $db->lastInsertId('engine4_core_pages');

		// containers
		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'container',
				'name' => 'main',
				'parent_content_id' => null,
				'order' => 2,
				'params' => '',
		));
		$container_id = $db->lastInsertId('engine4_core_content');

		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'container',
				'name' => 'right',
				'parent_content_id' => $container_id,
				'order' => 5,
				'params' => '',
		));
		$right_id = $db->lastInsertId('engine4_core_content');

		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'container',
				'name' => 'left',
				'parent_content_id' => $container_id,
				'order' => 4,
				'params' => '',
		));
		$left_id = $db->lastInsertId('engine4_core_content');

		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'container',
				'name' => 'top',
				'parent_content_id' => null,
				'order' => 1,
				'params' => '',
		));
		$top_id = $db->lastInsertId('engine4_core_content');

		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'container',
				'name' => 'middle',
				'parent_content_id' => $top_id,
				'order' => 6,
				'params' => '',
		));
		$top_middle_id = $db->lastInsertId('engine4_core_content');

		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'container',
				'name' => 'middle',
				'parent_content_id' => $container_id,
				'order' => 6,
				'params' => '',
		));
		$middle_id = $db->lastInsertId('engine4_core_content');

	// Top Middle
		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'widget',
				'name' => 'sitegroup.browsenevigation-sitegroup',
				'parent_content_id' => $top_middle_id,
				'order' => 3,
				'params' => '',
		));

		// Left
	
		//INSERT TOP RATED GROUP VIDEO WIDGET
		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'widget',
				'name' => 'sitegroupvideo.homerate-sitegroupvideos',
				'parent_content_id' => $left_id,
				'order' => 13,
				'params' => '{"title":"Top Rated Videos","titleCount":"true"}',
		));

		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'widget',
				'name' => 'sitegroupvideo.homerecent-sitegroupvideos',
				'parent_content_id' => $left_id,
				'order' => 14,
				'params' => '{"title":"Recent Videos","titleCount":"true"}',
		));

		//INSERT MOST VIEWED GROUP VIDEO WIDGET
			Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroupvideo.homeview-sitegroupvideos', $right_id, 20, "Most Viewed Videos", "true");

	// Middele
		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'widget',
				'name' => 'sitegroupvideo.featured-videos-carousel',
				'parent_content_id' => $middle_id,
				'order' => 16,
				'params' => '{"title":"Featured Videos","vertical":"0", "noOfRow":"2","inOneRow":"3","interval":"250","name":"sitegroupvideo.featured-videos-carousel"}',
		));

		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'widget',
				'name' => 'sitegroupvideo.list-videos-tabs-view',
				'parent_content_id' => $middle_id,
				'order' => 17,
				'params' => '{"title":"Videos","margin_photo":"12"}',
		));
		// Right Side
		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'widget',
				'name' => 'sitegroupvideo.sitegroupvideolist-link',
				'parent_content_id' => $right_id,
				'order' => 19,
				'params' => '',
		));

		// Right Side
		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'widget',
				'name' => 'sitegroupvideo.search-sitegroupvideo',
				'parent_content_id' => $right_id,
				'order' => 18,
				'params' => '',
		));

		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'widget',
				'name' => 'sitegroupvideo.video-of-the-day',
				'parent_content_id' => $left_id,
				'order' => 12,
				'params' => '{"title":"Video of the Day"}',
		));

		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'widget',
				'name' => 'sitegroupvideo.homefeaturelist-sitegroupvideos',
				'parent_content_id' => $right_id,
				'order' => 21,
				'params' => '{"title":"Featured Videos","itemCountPerGroup":3}',
		));


		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'widget',
				'name' => 'sitegroupvideo.homecomment-sitegroupvideos',
				'parent_content_id' => $right_id,
				'order' => 22,
				'params' => '{"title":"Most Commented Videos","titleCount":"true"}',
		));

		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'widget',
				'name' => 'sitegroupvideo.homelike-sitegroupvideos',
				'parent_content_id' => $right_id,
				'order' => 23,
				'params' => '{"title":"Most Liked Videos","titleCount":"true"}',
		));
	}	
	
	
	
	
}

?>