<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupvideo
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-08-026 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupvideo_Widget_ListVideosTabsViewController extends Engine_Content_Widget_Abstract {

  public function indexAction() {

    $this->view->is_ajax = $is_ajax = $this->_getParam('isajax', '');
    if ($this->view->is_ajax) {
      $this->getElement()->removeDecorator('Title');
      $this->getElement()->removeDecorator('Container');
    }
    $this->view->category_id = $category_id = $this->_getParam('category_id', 0);
    $this->view->showViewMore = $this->_getParam('showViewMore', 1);
    if (empty($is_ajax)) {
      $this->view->tabs = $tabs = Engine_Api::_()->getItemTable('seaocore_tab')->getTabs(array('module' => 'sitegroupvideo', 'type' => 'videos', 'enabled' => 1));
      $count_tabs = count($tabs);
      if (empty($count_tabs)) {
        return $this->setNoRender();
      }
      $activeTabName = $tabs[0]['name'];
    }
    $this->view->marginPhoto = $this->_getParam('margin_photo', 12);
    $table = Engine_Api::_()->getItemTable('sitegroupvideo_video');
    $tableName = $table->info('name');
    $tableGroup = Engine_Api::_()->getDbtable('groups', 'sitegroup');
    $tableGroupName = $tableGroup->info('name');
    $select = $table->select()
            ->setIntegrityCheck(false)
            ->from($tableName)
            ->joinLeft($tableGroupName, "$tableGroupName.group_id = $tableName.group_id", array('title AS group_title', 'photo_id as group_photo_id'));

    $select = $select
            ->where($tableGroupName . '.closed = ?', '0')
            ->where($tableGroupName . '.approved = ?', '1')
            ->where($tableGroupName . '.declined = ?', '0')
            ->where($tableGroupName . '.search = ?', '1')
            ->where($tableGroupName . '.draft = ?', '1');
    if (!empty($category_id)) {
      $select = $select->where($tableGroupName . '.	category_id =?', $category_id);
    }
    if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
      $select->where($tableGroupName . '.expiration_date  > ?', date("Y-m-d H:i:s"));
    }

    $paramTabName = $this->_getParam('tabName', '');

    if (!empty($paramTabName))
      $activeTabName = $paramTabName;

    $activeTab = Engine_Api::_()->getItemTable('seaocore_tab')->getTabs(array('module' => 'sitegroupvideo', 'type' => 'videos', 'enabled' => 1, 'name' => $activeTabName));
    $this->view->activTab = $activTab = $activeTab['0'];

    switch ($activTab->name) {
      case 'recent_groupvideos':
        break;
      case 'liked_groupvideos':
        $select->order($tableName . '.like_count DESC');
        break;
      case 'viewed_groupvideos':
        $select->order($tableName . '.view_count DESC');
        break;
      case 'commented_groupvideos':
        $select->order($tableName . '.comment_count DESC');
        break;
      case 'featured_groupvideos':
        $select->where($tableName . '.featured = ?', 1);
        $select->order('Rand()');
        break;
      case 'random_groupvideos':
        $select->order('Rand()');
        break;
    }

    if ($activTab->name != 'featured_groupvideos' && $activTab->name != 'random_groupvideos') {
      $select->order('creation_date DESC');
    }

    $this->view->paginator = $paginator = Zend_Paginator::factory($select);
    $paginator->setItemCountPerPage($activTab->limit);
    $paginator->setCurrentPageNumber($this->_getParam('group', 1));
    $this->view->count = $paginator->getTotalItemCount();
  }

}

?>
