<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitehomepagevideo
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Create.php 2011-10-22 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitehomepagevideo_Form_Admin_Slideshows_Create extends Engine_Form {

    public function init() {

        $this
                ->setTitle('Create New Slideshow')
                ->setDescription("Create a new Slideshow here. Below you will also be able to configure and customize your slideshow based on various parameters.");

        $this->addElement('Radio', 'slideshow_type', array(
            'label' => 'Slideshow Type',
            'description' => 'Select the type of slideshow that you want to create.',
            'multioptions' => array(
                1 => 'Only Videos',
                0 => 'Only Photos',
                2 => 'Both Videos & Photos'
            ),
            'value' => 1,
        ));

        $this->addElement('Text', 'title', array(
            'label' => 'Slideshow Name',
            'description' => 'Enter the name of this Slideshow. This name is only for your indicative purpose, and will not be displayed to users.',
            'required' => 'true',
            'maxLength' => 128,
            'filters' => array(
                'StripTags',
                new Engine_Filter_Censor(),
        )));

        $this->addElement('Text', 'delay', array(
            'label' => 'Delay (in millisecond)',
            'description' => 'Specify the required delay between the slides.',
            'filters' => array(
                'StripTags',
                new Engine_Filter_Censor(),
            ),
            'value' => 2000,
        ));

        $this->addElement('Button', 'submit', array(
            'type' => 'submit',
            'ignore' => true,
            'label' => 'Save Settings',
        ));
    }

}
