<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitehomepagevideo
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Layout.php 2015-05-15 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitehomepagevideo_Form_Admin_Videos_Layout extends Engine_Form {

    protected $_field;

    public function init() {
        $coreSettings = Engine_Api::_()->getApi('settings', 'core');
        $this->setTitle('Layout Settings')
                ->setDescription('Below, you can configure the landing page layout for your website.');

        $page_id = Engine_Api::_()->sitehomepagevideo()->getBackupHomePageId();

        if (!$page_id) {
            $this->addElement('Radio', 'sitehomepagevideo_landing_page_layout', array(
                'label' => 'Change Landing Page Layout',
                'description' => 'Do you want to place "Home Page Background Videos & Photos" widget on the landing page of your website? If selected "Yes" a background videos & photos will get displayed at the top of the landing page of your website. [Note: You will see the default video getting displayed after enabling this setting, which you can easily replace with your videos & photos from "Manage Background Slideshows" section in this plugin.]',
                'multiOptions' => array(
                    1 => 'Yes',
                    0 => 'No'
                ),
                'value' => $coreSettings->getSetting('sitehomepagevideo.landing.page.layout', 0)
            ));
        } else {
            $this->loadDefaultDecorators();
            $this->setTitle('Layout Settings')
                    ->setDescription('Below, you can configure the landing page layout for your website.<br /><div class="tip"><span >It might be that some of your Landing Page settings had disappeared while setting up this plugin. So, we have taken a backup of your landing page. Please <a href="admin/content?page=' . $page_id . '" target="_blank">click here</a> to check your all previous settings of landing page before changing your landing page layout.</span></div>');
            $this->getDecorator('Description')->setOption('escape', false);

            $this->addElement('Radio', 'sitehomepagevideo_landing_page_layout', array(
                'label' => 'Change Landing Page Layout',
                'description' => 'Do you want to place "Home Page Background Videos & Photos" widget on the landing page of your website? If selected "Yes" a background videos & photos will get displayed at the top of the landing page of your website. [Note: You will see the default video getting displayed after enabling this setting, which you can easily replace with your videos & photos from "Manage Background Slideshows" section in this plugin.]',
                'multiOptions' => array(
                    1 => 'Yes',
                    0 => 'No'
                ),
                'value' => $coreSettings->getSetting('sitehomepagevideo.landing.page.layout', 0)
            ));
        }

        //WORK FOR MULTILANGUAGES END
        $this->addElement('Button', 'submit', array(
            'label' => 'Save Changes',
            'type' => 'submit',
            'ignore' => true
        ));
    }

}
