<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitehomepagevideo
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Content.php 2015-05-15 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitehomepagevideo_Form_Admin_Widget_Content extends Engine_Form {

    public function init() {

        $this
                ->setAttrib('id', 'form-upload');

        
        $this->addElement('Radio', 'columnHeightWidth', array(
            'label' => "Do you want to play videos slideshow in full height and width? [This setting only works for videos slideshows, and if this setting is enabled, all the other widgets placed on this page will not be rendered, so it is recommended that please remove those widgets. Also, below settings like: 'Do you want to play videos & photos slideshows according to screen's height ?' and  ‘Enter the height of Landing Page Videos & Photos' will not be applicable.]",
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => 0
        ));

        $this->addElement('Radio', 'videoScreenHeight', array(
            'label' => "Do you want to play videos & photos slideshows according to screen's height ? [This setting only works for either videos slideshows or photos slideshows type (will not work for both videos & photos slideshows type), and if this setting is enabled, below setting ‘Enter the height of Landing Page Videos & Photos' will not be applicable.]",
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => 1
        ));

        $this->addElement('Radio', 'showStartViewing', array(
            'label' => "Do you want to enable 'Start Exploring' button on videos? [This setting is only applicable if you have enabled 'Do you want to play videos slideshows according to screen's height ?' setting as well as enabled Sign In / Sign Up form on videos and photos.]",
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => 1
        ));

        $this->addElement('Text', 'columnHeight', array(
            'label' => "Enter the height for Landing Page Videos & Photos.",
            'value' => '600'
        ));

        $this->addElement('Text', 'columnWidth', array(
            'label' => 'Enter width for the Landing Page Videos & Photos. (If left blank banners will have 100% width)',
            'value' => '',
        ));

        $listSlides = Engine_Api::_()->getItemTable('sitehomepagevideo_slideshow')->getSlides(array('enabled' => 1));
        $listArray = array();
        foreach ($listSlides->toArray() as $listSlide) {
            $listArray[$listSlide['slideshow_id']] = $listSlide['title'];
        }

        $this->addElement('Radio', 'selectedSlides', array(
            'multiOptions' => $listArray,
            'label' => 'Select the slideshow that you want to play on this page. [you can upload new videos & photos and manage existing ones from the "Manage Background Slideshows" tab available in admin of Home Page Background Videos & Photos Plugin.]',
            'value' => 1,
        ));

        $this->addElement('Radio', 'showNextLink', array(
            'label' => "Do you want to show Next and Previous button, in case you have uploaded more than one videos & photos?",
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => 0,
        ));

        // Get available files
        $logoOptions = Engine_Api::_()->sitehomepagevideo()->getImages(array('' => 'Text-only (No logo)'));

        $this->addElement('Radio', 'showLogo', array(
            'label' => "Do you want to display your website's logo on the top-left side of the videos & photos slideshows playing area?",
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => 1,
            'onclick' => 'showLogoOptions()'
        ));

        $this->addElement('Select', 'logo', array(
            'label' => 'Choose the site logo file (you can upload a new file from: "Layout" > "File & Media Manager")',
            'multiOptions' => $logoOptions,
        ));

        $this->addElement('Radio', 'sitehomepagevideoSignupLoginLink', array(
            // 'label' => 'Sign In and Sign Up Link',
            'label' => "Do you want to show Sign In and Sign Up links in the top header area?",
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => 1,
        ));

        $this->addElement('Radio', 'sitehomepagevideoBrowseMenus', array(
            // 'label' => 'Browse Menus',
            'label' => "Do you want to show the 'Browse' dropdown in the header? [If enabled, all the main menu links of your website will show up in the 'Browse' dropdown.]",
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => 1,
            'onclick' => 'showBrowseMenusOptions()'
        ));

        $this->addElement('Text', 'max', array(
            'label' => "How many menus do you want to show under the 'Browse' drop-down?",
            'value' => 20
        ));

        $this->addElement('Radio', 'sitehomepagevideoFirstImprotantLink', array(
            //'label' => 'First Important link',
            'label' => "Do you want to show a button in the header area to display an important link of your website? [Configure the Title and URL for this button below.]",
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => 1,
            'onclick' => 'showFirstLinksOptions()'
        ));

        $this->addElement('Text', 'sitehomepagevideoFirstTitle', array(
            'label' => 'Header Button Title',
            'style' => 'width:350px;',
            'value' => 'Important Title & Link'
        ));

        $this->addElement('Text', 'sitehomepagevideoFirstUrl', array(
            'label' => 'Header Button URL',
            'style' => 'width:350px;',
            'value' => '#'
        ));

        $this->addElement('Text', 'sitehomepagevideoHtmlTitle', array(
            'label' => 'Enter the title that you want to display, layered above the background videos and photos.',
            'value' => 'BRING PEOPLE TOGETHER',
            'style' => 'width:350px;',
        ));

        $this->addElement('Text', 'sitehomepagevideoHtmlDescription', array(
            'label' => 'Enter the description that you want to display, layered above the background videos and photos.',
            'value' => 'Create an event. Sell tickets online.',
            'style' => 'width:350px;',
        ));

        $this->addElement('Radio', 'sitehomepagevideoTitleColor', array(
            'label' => 'Select the color for the last word of above entered title that displayed above the background videos & photos slideshows.',
            'multiOptions' => array(
                1 => 'White Color',
                0 => 'Theme Color'
            ),
            'value' => 1
        ));

        $this->addElement('Radio', 'sitehomepagevideoHowItWorks', array(
            'label' => 'Do you want to display an action button like "Get Started", "How It Works", etc, layered above the background videos and photos? (You can configure this button from the administration of "Home Page Background Videos & Photos", and can also configure the slide-down content that comes after clicking of this button.)',
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' =>0
        ));

        $this->addElement('Radio', 'sitehomepagevideoSignupLoginButton', array(
            'label' => "Do you want to show the Sign In and Sign Up buttons on this videos and photos playing area? [If enabled, they will get displayed at the bottom of the videos and photos playing area.]",
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => 0,
        ));

        if (Engine_Api::_()->hasModuleBootstrap('sitecitycontent') && Engine_Api::_()->hasModuleBootstrap('siteadvsearch')) {
            if (Engine_Api::_()->hasModuleBootstrap('sitealbum') && Engine_Api::_()->hasModuleBootstrap('siteevent')) {
                $this->addElement('Radio', 'sitehomepagevideoSearchBox', array(
                    'label' => 'Select the Sign In and Sign Up form or search option that you want to display on videos and photos.',
                    'multiOptions' => array(
                        4 => 'Show Sign In / Sign Up Form  [Note: If you enabled this option, buttons like: Get Started / How it Works, Sign In and Sign Up will not be displayed on videos and photos.]',
                        3 => 'Advanced Photos Albums Search (from "<a target=\'_blank\' href=\'http://www.socialengineaddons.com/socialengine-advanced-photo-albums-plugin\'>Advanced Photo Albums Plugin</a>")',
                        2 => 'Advanced Events Search (from "<a target=\'_blank\' href=\'http://www.socialengineaddons.com/socialengine-advanced-events-plugin\'>Advanced Events Plugin</a>")',
                        1 => 'Advanced Search [Dependent on "<a target=\'_blank\' href=\'http://www.socialengineaddons.com/socialengine-advanced-search-plugin\'>Advanced Search Plugin</a>"] / Global Search',
                        0 => 'None'
                    ),
                    'escape' => false,
                    'value' => 4,
                ));
            } else if (Engine_Api::_()->hasModuleBootstrap('siteevent')) {
                $this->addElement('Radio', 'sitehomepagevideoSearchBox', array(
                    'label' => 'Select the Sign In and Sign Up form or search option that you want to display on videos and photos.',
                    'multiOptions' => array(
                        4 => 'Show Sign In / Sign Up Form  [Note: If you enabled this option, buttons like: Get Started / How it Works, Sign In and Sign Up will not be displayed on videos and photos.]',
                        2 => 'Advanced Events Search (from "<a target=\'_blank\' href=\'http://www.socialengineaddons.com/socialengine-advanced-events-plugin\'>Advanced Events Plugin</a>")',
                        1 => 'Advanced Search [Dependent on "<a target=\'_blank\' href=\'http://www.socialengineaddons.com/socialengine-advanced-search-plugin\'>Advanced Search Plugin</a>"] / Global Search',
                        0 => 'None'
                    ),
                    'escape' => false,
                    'value' => 4,
                ));
            } else if (Engine_Api::_()->hasModuleBootstrap('sitealbum')) {
                $this->addElement('Radio', 'sitehomepagevideoSearchBox', array(
                    'label' => 'Select the Sign In and Sign Up form or search option that you want to display on videos and photos.',
                    'multiOptions' => array(
                        4 => 'Show Sign In / Sign Up Form  [Note: If you enabled this option, buttons like: Get Started / How it Works, Sign In and Sign Up will not be displayed on videos and photos.]',
                        3 => 'Advanced Photos Albums Search (from "<a target=\'_blank\' href=\'http://www.socialengineaddons.com/socialengine-advanced-photo-albums-plugin\'>Advanced Photo Albums Plugin</a>")',
                        1 => 'Advanced Search [Dependent on "<a target=\'_blank\' href=\'http://www.socialengineaddons.com/socialengine-advanced-search-plugin\'>Advanced Search Plugin</a>"] / Global Search',
                        0 => 'None'
                    ),
                    'escape' => false,
                    'value' => 4,
                ));
            } else {
                $this->addElement('Radio', 'sitehomepagevideoSearchBox', array(
                    'label' => 'Select the Sign In and Sign Up form or search option that you want to display on videos and photos.',
                    'multiOptions' => array(
                        4 => 'Show Sign In / Sign Up Form  [Note: If you enabled this option, buttons like: Get Started / How it Works, Sign In and Sign Up will not be displayed on videos and photos.]',
                        1 => 'Advanced Search [Dependent on "<a target=\'_blank\' href=\'http://www.socialengineaddons.com/socialengine-advanced-search-plugin\'>Advanced Search Plugin</a>"] / Global Search',
                        0 => 'None'
                    ),
                    'escape' => false,
                    'value' => 4,
                ));
            }

            $this->addElement('Radio', 'showLocationBasedContent', array(
                'label' => 'Show results based on the location, saved in user’s browser cookie.',
                'multiOptions' => array(
                    1 => 'Yes',
                    0 => 'No'
                ),
                'value' => 0,
            ));

            $this->addElement('Radio', 'showLocationSearch', array(
                'label' => 'Do you want to enable location based searching?',
                'multiOptions' => array(
                    1 => 'Yes',
                    0 => 'No'
                ),
                'value' => 0,
            ));
        } else {

            if (Engine_Api::_()->hasModuleBootstrap('siteevent') && Engine_Api::_()->hasModuleBootstrap('sitealbum')) {
                $this->addElement('Radio', 'sitehomepagevideoSearchBox', array(
                    'label' => 'Select the Sign In and Sign Up form or search option that you want to display on videos and photos.',
                    'multiOptions' => array(
                        4 => 'Show Sign In / Sign Up Form  [Note: If you enabled this option, buttons like: Get Started / How it Works, Sign In and Sign Up will not be displayed on videos and photos.]',
                        3 => 'Advanced Photos Albums Search (from "<a target=\'_blank\' href=\'http://www.socialengineaddons.com/socialengine-advanced-photo-albums-plugin\'>Advanced Photo Albums Plugin</a>")',
                        2 => 'Advanced Events Search (from "<a target=\'_blank\' href=\'http://www.socialengineaddons.com/socialengine-advanced-events-plugin\'>Advanced Events Plugin</a>")',
                        1 => 'Advanced Search [Dependent on "<a target=\'_blank\' href=\'http://www.socialengineaddons.com/socialengine-advanced-search-plugin\'>Advanced Search Plugin</a>"] / Global Search',
                        0 => 'None'
                    ),
                    'escape' => false,
                    'value' => 4,
                ));
            } elseif (Engine_Api::_()->hasModuleBootstrap('siteevent')) {
                $this->addElement('Radio', 'sitehomepagevideoSearchBox', array(
                    'label' => 'Select the Sign In and Sign Up form or search option that you want to display on videos and photos.',
                    'multiOptions' => array(
                        4 => 'Show Sign In / Sign Up Form  [Note: If you enabled this option, buttons like: Get Started / How it Works, Sign In and Sign Up will not be displayed on videos and photos.]',
                        2 => 'Advanced Events Search (from "<a target=\'_blank\' href=\'http://www.socialengineaddons.com/socialengine-advanced-events-plugin\'>Advanced Events Plugin</a>")',
                        1 => 'Advanced Search [Dependent on "<a target=\'_blank\' href=\'http://www.socialengineaddons.com/socialengine-advanced-search-plugin\'>Advanced Search Plugin</a>"] / Global Search',
                        0 => 'None'
                    ),
                    'escape' => false,
                    'value' => 4,
                ));
            } elseif (Engine_Api::_()->hasModuleBootstrap('sitealbum')) {
                $this->addElement('Radio', 'sitehomepagevideoSearchBox', array(
                    'label' => 'Select the Sign In and Sign Up form or search option that you want to display on videos and photos.',
                    'multiOptions' => array(
                        4 => 'Show Sign In / Sign Up Form  [Note: If you enabled this option, buttons like: Get Started / How it Works, Sign In and Sign Up will not be displayed on videos and photos.]',
                        3 => 'Advanced Photos Albums Search (from "<a target=\'_blank\' href=\'http://www.socialengineaddons.com/socialengine-advanced-photo-albums-plugin\'>Advanced Photo Albums Plugin</a>")',
                        1 => 'Advanced Search [Dependent on "<a target=\'_blank\' href=\'http://www.socialengineaddons.com/socialengine-advanced-search-plugin\'>Advanced Search Plugin</a>"] / Global Search',
                        0 => 'None'
                    ),
                    'escape' => false,
                    'value' => 4,
                ));
            } else {
                $this->addElement('Radio', 'sitehomepagevideoSearchBox', array(
                    'label' => 'Select the Sign In and Sign Up form or search option that you want to display on videos and photos.',
                    'multiOptions' => array(
                        4 => 'Show Sign In / Sign Up Form  [Note: If you enabled this option, buttons like: Get Started / How it Works, Sign In and Sign Up will not be displayed on videos and photos.]',
                        1 => 'Advanced Search [Dependent on "<a target=\'_blank\' href=\'http://www.socialengineaddons.com/socialengine-advanced-search-plugin\'>Advanced Search Plugin</a>"] / Global Search',
                        0 => 'None'
                    ),
                    'escape' => false,
                    'value' => 4,
                ));
            }
        }

        $this->addElement('MultiCheckbox', 'showSignupFields', array(
            'label' => "Please select the optional fields that you want to show in Sign Up form apart from mandatory fields.",
            'multiOptions' => array(
                'timezone' => 'Timezone',
                'language' => 'Language [Only applicable if more than one language enabled on your website.]'
            )
        ));

        $this->addElement('Radio', 'showTagLine', array(
            'label' => "Do you want to display Sign In and Sign Up form Icons and Taglines?",
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => 1
        ));

        $this->addElement('Radio', 'showLeftRightSignupButton', array(
            'label' => "Select the position of Sign In and Sign Up form. [This setting is only applicable if you have enabled 'Do you want to display Sign In and Sign Up form Icons and Taglines?' setting.]",
            'multiOptions' => array(
                1 => 'Left',
                0 => 'Right'
            ),
            'value' => 0
        ));

        $this->addElement('Radio', 'playVideoSound', array(
            'label' => "Do you want to enable sound in videos?",
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => 0,
        ));

        $this->addElement('hidden', 'nomobile', array(
             'order' => 900,
            'label' => ''
        ));
    }

}
?>
<script type="text/javascript">
    var form = document.getElementById("form-upload");
    window.addEvent('domready', function () {
        showFirstLinksOptions();
        showLogoOptions();
        showBrowseMenusOptions();
    });

    function showBrowseMenusOptions() {
        if (form.elements["sitehomepagevideoBrowseMenus"].value == 1) {
            $('max-wrapper').style.display = 'block';
        } else {
            $('max-wrapper').style.display = 'none';
        }
    }

    function showLogoOptions() {
        if (form.elements["showLogo"].value == 1) {
            $('logo-wrapper').style.display = 'block';
        } else {
            $('logo-wrapper').style.display = 'none';
        }
    }
    function showFirstLinksOptions() {
        if (form.elements["sitehomepagevideoFirstImprotantLink"].value == 1) {
            $('sitehomepagevideoFirstTitle-wrapper').style.display = 'block';
            $('sitehomepagevideoFirstUrl-wrapper').style.display = 'block';
        } else {
            $('sitehomepagevideoFirstTitle-wrapper').style.display = 'none';
            $('sitehomepagevideoFirstUrl-wrapper').style.display = 'none';
        }
    }
</script>