<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitehomepagevideo
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Slideshows.php 2011-10-22 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitehomepagevideo_Model_DbTable_Slideshows extends Engine_Db_Table {

    protected $_rowClass = 'Sitehomepagevideo_Model_Slideshow';

    /**
     * Get Slides
     * @param $params : array()
     * @param $columns : array()
     * @return Slides
     */
    public function getSlides($params = array(), $columns = array()) {

        $tableName = $this->info('name');
        $select = $this->select();

        if (!empty($columns)) {
            $select->from($tableName, $columns);
        }

        if (isset($params['enabled'])) {
            $select->where('enabled = ?', $params['enabled']);
        }

        if (isset($params['selectedSlides'])) {
            $select->where('slideshow_id' . ' in (?)', new Zend_Db_Expr(trim(implode(',', $params['selectedSlides']), ',')));
        }

        return $this->fetchAll($select);
    }

}
