<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitehomepagevideo
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Videos.php 2015-05-15 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitehomepagevideo_Model_DbTable_Videos extends Engine_Db_Table {

    protected $_name = 'sitehomepagevideo_videos';
    protected $_rowClass = "Sitehomepagevideo_Model_Video";

    /**
     * Get Videos
     * @param $params : array()
     * @param $columns : array()
     * @return videos
     */
    public function getVideos($params = array(), $columns = array()) {
        $slideshow_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('slideshow_id');

        $tableName = $this->info('name');
        $select = $this->select();

        if (!empty($columns)) {
            $select->from($tableName, $columns);
        }

        if (isset($params['enabled'])) {
            $select->where('enabled = ?', $params['enabled']);
        }

        if (isset($params['type'])) {
            $select->where('type = ?', $params['type']);
        }
        if (isset($params['selectedSlides'])) {
            $select->where('slideshow_id' . ' =?', $params['selectedSlides']);
        }

        if ($slideshow_id) {
            $select->where('slideshow_id = ?', $slideshow_id);
        }

        $select->order("order ASC");

        return $this->fetchAll($select);
    }

    public function getTitleMatch($title) {
        $title = $this->select()->from($this->info('name'), 'title')->where('title = ?', $title)->query()->fetchColumn();

        return $title ? $title : false;
    }

    /**
     * Return number of slides
     *
     * @param int $slideshow_id
     * @return number of slides
     */
    public function getTotalSlides($slideshow_id) {
        //GET NUMBER OF SLIDES
        $totalSlides = $this->select()
                ->from($this->info('name'), array('COUNT(*) AS count'))
                ->where('slideshow_id = ?', $slideshow_id)
                ->where('enabled = ?', 1)
                ->query()
                ->fetchColumn();

        //RETURN NUMBER OF SLIDES
        return $totalSlides;
    }

}
