<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitehomepagevideo
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 2015-05-15 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitehomepagevideo_Installer extends Engine_Package_Installer_Module {

    function onPreinstall() {
        $db = $this->getDb();

        $PRODUCT_TYPE = 'sitehomepagevideo';
        $PLUGIN_TITLE = 'Sitehomepagevideo';
        $PLUGIN_VERSION = '5.9.1';
        $PLUGIN_CATEGORY = 'plugin';
        $PRODUCT_DESCRIPTION = 'Home Page Background Videos & Photos';
        $PRODUCT_TITLE = 'Home Page Background Videos & Photos';
        $_PRODUCT_FINAL_FILE = 0;
        $SocialEngineAddOns_version = '4.9.4p13';
        $getErrorMsg = $this->_getVersion();
        if (!empty($getErrorMsg)) {
            return $this->_error($getErrorMsg);
        }
        $file_path = APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/ilicense.php";
        $is_file = @file_exists($file_path);
        if (empty($is_file)) {
            include APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/license3.php";
        } else {
            $db = $this->getDb();
            $select = new Zend_Db_Select($db);
            $select->from('engine4_core_modules')->where('name = ?', $PRODUCT_TYPE);
            $is_Mod = $select->query()->fetchObject();
            if (empty($is_Mod)) {
                include_once $file_path;
            }
        }

        parent::onPreinstall();
    }

    public function onInstall() {
        $db = $this->getDb();
        $db->query("UPDATE  `engine4_seaocores` SET  `is_activate` =  '1' WHERE  `engine4_seaocores`.`module_name` ='sitehomepagevideo';");
        $db->query("DELETE FROM `engine4_core_jobtypes` WHERE `engine4_core_jobtypes`.`type` = 'sitehomepagevideo_video_encode' LIMIT 1");

        $db->query("UPDATE  `engine4_core_modules` SET  `title` =  'Home Page Background Videos & Photos' WHERE  `engine4_core_modules`.`name` =  'sitehomepagevideo' LIMIT 1 ;");

        $db->query("UPDATE  `engine4_core_menuitems` SET  `label` =  'SEAO - Home Page Background Videos & Photos' WHERE  `engine4_core_menuitems`.`name` =  'sitehomepagevideo_admin_settings' LIMIT 1 ;");

        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_modules')
                ->where('name = ?', 'sitehomepagevideo');
        $is_sitehomepagevideo_object = $select->query()->fetchObject();

        if (!empty($is_sitehomepagevideo_object)) {
            $db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitehomepagevideo_admin_main_manage_slideshows", "sitehomepagevideo", "Manage Background Slideshows", NULL, \'{"route":"admin_default","module":"sitehomepagevideo","controller":"slideshows", "action":"manage"}\', "sitehomepagevideo_admin_main", NULL, "1", "0", "3");');
        }

        $db->query("UPDATE  `engine4_core_menuitems` SET  `enabled` =  '0' WHERE  `engine4_core_menuitems`.`name` ='sitehomepagevideo_admin_submain_manage_tab' LIMIT 1 ;");

        $table_exist = $db->query("SHOW TABLES LIKE 'engine4_sitehomepagevideo_slideshows'")->fetch();
        if (empty($table_exist)) {
            $db->query("CREATE TABLE IF NOT EXISTS `engine4_sitehomepagevideo_slideshows` (
  `slideshow_id` int(5) NOT NULL AUTO_INCREMENT,
  `slideshow_type` tinyint(1) NOT NULL DEFAULT '1',
  `owner_id` int(11) NOT NULL,
  `owner_type` varchar(128) COLLATE utf8_unicode_ci NOT NULL,
  `delay` int(5) NOT NULL DEFAULT '2000',
  `title` varchar(64) COLLATE utf8_unicode_ci NOT NULL,
  `enabled` tinyint(1) NOT NULL,
  PRIMARY KEY (`slideshow_id`),
  KEY `owner_type` (`owner_type`,`owner_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;");

            $db->query("INSERT IGNORE INTO `engine4_sitehomepagevideo_slideshows` (`slideshow_id`, `slideshow_type`, `owner_id`, `owner_type`, `delay`, `title`, `enabled`) VALUES
(1, 1, 1, 'user', 2000, 'Landing Page Background Videos', 1);");
        }

        $table_exist = $db->query("SHOW TABLES LIKE 'engine4_sitehomepagevideo_videos'")->fetch();
        if (!empty($table_exist)) {
            $action_slideshow_id_field = $db->query("SHOW COLUMNS FROM engine4_sitehomepagevideo_videos LIKE 'slideshow_id'")->fetch();
            if (empty($action_slideshow_id_field)) {

                $db->query("ALTER TABLE  `engine4_sitehomepagevideo_videos` ADD  `slideshow_id` INT( 11 ) NOT NULL;");

                $db->query("UPDATE  `engine4_sitehomepagevideo_videos` SET  `slideshow_id` =  '1'");
            }
        }

        //WORK FOR CORE CONTENT PAGES
        $select = new Zend_Db_Select($db);
        $select->from('engine4_core_content', array('params', 'content_id'))->where('name = ?', 'sitehomepagevideo.videos');
        $widgets = $select->query()->fetchAll();
        foreach ($widgets as $widget) {
            $widget_params = json_decode($widget['params']);
            if (!isset($widget_params->selectedSlides)) {
                $widget_params->selectedSlides = '1';
                $db->update('engine4_core_content', array('params' => json_encode($widget_params)), array('content_id = ?' => $widget['content_id'], 'name = ?' => 'sitehomepagevideo.videos'));
            }
        }

        parent::onInstall();
    }

    private function _getVersion() {

        $db = $this->getDb();

        $errorMsg = '';
        $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();

        $modArray = array(
            'sitemenu' => '4.8.9'
        );

        $finalModules = array();
        foreach ($modArray as $key => $value) {
            $select = new Zend_Db_Select($db);
            $select->from('engine4_core_modules')
                    ->where('name = ?', "$key")
                    ->where('enabled = ?', 1);
            $isModEnabled = $select->query()->fetchObject();
            if (!empty($isModEnabled)) {
                $select = new Zend_Db_Select($db);
                $select->from('engine4_core_modules', array('title', 'version'))
                        ->where('name = ?', "$key")
                        ->where('enabled = ?', 1);
                $getModVersion = $select->query()->fetchObject();
                $running_version = $getModVersion->version;
                $product_version = $value;
                $shouldUpgrade = false;
                if (!empty($running_version) && !empty($product_version)) {
                    $temp_running_verion_2 = $temp_product_verion_2 = 0;
                    if (strstr($product_version, "p")) {
                        $temp_starting_product_version_array = @explode("p", $product_version);
                        $temp_product_verion_1 = $temp_starting_product_version_array[0];
                        $temp_product_verion_2 = $temp_starting_product_version_array[1];
                    } else {
                        $temp_product_verion_1 = $product_version;
                    }
                    $temp_product_verion_1 = @str_replace(".", "", $temp_product_verion_1);


                    if (strstr($running_version, "p")) {
                        $temp_starting_running_version_array = @explode("p", $running_version);
                        $temp_running_verion_1 = $temp_starting_running_version_array[0];
                        $temp_running_verion_2 = $temp_starting_running_version_array[1];
                    } else {
                        $temp_running_verion_1 = $running_version;
                    }
                    $temp_running_verion_1 = @str_replace(".", "", $temp_running_verion_1);


                    if (($temp_running_verion_1 < $temp_product_verion_1) || (($temp_running_verion_1 == $temp_product_verion_1) && ($temp_running_verion_2 < $temp_product_verion_2))) {
                        $shouldUpgrade = true;
                    }
                }

                if (!empty($shouldUpgrade)) {
                    $finalModules[$key] = $getModVersion->title;
                }
            }
        }

        foreach ($finalModules as $modArray) {
            $errorMsg .= '<div class="tip"><span style="background-color: #da5252;color:#FFFFFF;">Note: You do not have the latest version of the "' . $modArray . '". Please upgrade "' . $modArray . '" on your website to the latest version available in your SocialEngineAddOns Client Area to enable its integration with "' . $modArray . '".<br/> Please <a class="" href="' . $base_url . '/manage">Click here</a> to go Manage Packages.</span></div>';
        }

        return $errorMsg;
    }

    public function onPostInstall() {
        $db = $this->getDb();

        $isMod = $db->query("SELECT * FROM  `engine4_core_modules` WHERE  `name` LIKE  'sitehomepagevideo'")->fetch();
        if (!empty($isMod) && !empty($isMod['version'])) {
            $isModSupport = $this->checkVersion($isMod['version'], '4.8.9p3');
            if (empty($isModSupport)) {
                $view = new Zend_View();
                $baseUrl = (!empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
                $redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
                $redirector->gotoUrl($baseUrl . 'admin/sitehomepagevideo/settings/encode-and-default');
            }
        }
    }

    function checkVersion($databaseVersion, $checkDependancyVersion) {
        if (strcasecmp($databaseVersion, $checkDependancyVersion) == 0)
            return -1;
        $databaseVersionArr = explode(".", $databaseVersion);
        $checkDependancyVersionArr = explode('.', $checkDependancyVersion);
        $fValueCount = $count = count($databaseVersionArr);
        $sValueCount = count($checkDependancyVersionArr);
        if ($fValueCount > $sValueCount)
            $count = $sValueCount;
        for ($i = 0; $i < $count; $i++) {
            $fValue = $databaseVersionArr[$i];
            $sValue = $checkDependancyVersionArr[$i];
            if (is_numeric($fValue) && is_numeric($sValue)) {
                $result = $this->compareValues($fValue, $sValue);
                if ($result == -1) {
                    if (($i + 1) == $count) {
                        return $this->compareValues($fValueCount, $sValueCount);
                    } else
                        continue;
                }
                return $result;
            }
            elseif (is_string($fValue) && is_numeric($sValue)) {
                $fsArr = explode("p", $fValue);
                $result = $this->compareValues($fsArr[0], $sValue);
                return $result == -1 ? 1 : $result;
            } elseif (is_numeric($fValue) && is_string($sValue)) {
                $ssArr = explode("p", $sValue);
                $result = $this->compareValues($fValue, $ssArr[0]);
                return $result == -1 ? 0 : $result;
            } elseif (is_string($fValue) && is_string($sValue)) {
                $fsArr = explode("p", $fValue);
                $ssArr = explode("p", $sValue);
                $result = $this->compareValues($fsArr[0], $ssArr[0]);
                if ($result != -1)
                    return $result;
                $result = $this->compareValues($fsArr[1], $ssArr[1]);
                return $result;
            }
        }
    }

    public function compareValues($firstVal, $secondVal) {
        $num = $firstVal - $secondVal;
        return ($num > 0) ? 1 : ($num < 0 ? 0 : -1);
    }

}
