<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteandroidapp
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    Settings.php 2015-10-01 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteiosapp_Form_Admin_Error extends Engine_Form {
    public function init() {

        $this->setTitle('Error Page Content')
                ->setDescription('Here you can decide how the error page in your app will look like.');

        $localeMultiOptions = Engine_Api::_()->siteapi()->getLanguageArray();
        $coreSettings = Engine_Api::_()->getApi('settings', 'core');
        $defaultLanguage = $coreSettings->getSetting('core.locale.locale', 'en');
        $total_allowed_languages = COUNT($localeMultiOptions);
        if (!empty($localeMultiOptions)) {
            foreach ($localeMultiOptions as $key => $label) {
                $lang_name = $label;
                if (isset($localeMultiOptions[$label]))
                    $lang_name = $localeMultiOptions[$label];

                $page_block_field = "siteiosapp_error_title_$key";
                $page_desc_field = "siteiosapp_error_description_$key";

                $this->addElement('Text', $page_block_field, array(
                    'label' => 'Title for ' . $lang_name,
                    'required' => true,
                    'allowEmpty' => false,
                ));

                $this->addElement('Text', $page_desc_field, array(
                    'label' => 'Description for ' . $lang_name,
                    'required' => true,
                    'allowEmpty' => false,
                    'value' => 'Something went wrong, try one of these instead.'
                ));
            }
        }

        $this->addElement('File', 'siteandroidapp_error_image', array(
            'label' => 'Error Page Image',
            'required' => true,
            'allowEmpty' => false,
             'validators' => array(
                        array('Extension', false, 'png, gif, jpg')
                    )
        ));

        $this->addElement('Button', 'submit', array(
            'label' => 'Save Changes',
            'type' => 'submit',
            'ignore' => true,
            'order' => 500,
        ));
    }

}
