<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteiosapp
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    Settings.php 2015-10-01 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteiosapp_Form_Admin_Settings extends Engine_Form {

    // IF YOU WANT TO SHOW CREATED ELEMENT ON PLUGIN ACTIVATION THEN INSERT THAT ELEMENT NAME IN THE BELOW ARRAY.
    public $_SHOWELEMENTSBEFOREACTIVATE = array(
        "environment_mode",
        "submit_lsetting"
    );

    public function init() {
        $settings = Engine_Api::_()->getApi('settings', 'core');
        $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
        $URL = $view->baseUrl() . "/admin/files";
        $click = '<a href="' . $URL . '" target="_blank">file manager</a>';
        $customBlocks = sprintf("The below chosen Apple APN certificate will be used to send push notifications from your server. The SocialEngineAddOns Support Team will upload the appropriate certificate from %s at the time of app building, and will choose it from below. [Note: Please do not change this value unless you are sure of it. This field is for the SocialEngineAddOns Support Team that will build your app.]", $click);
        $imageExtensions = array('pem');
        $it = new DirectoryIterator(APPLICATION_PATH . '/public/admin/');
        $apnPath = $settings->getSetting('siteiosapp.apple.server.apn.key', '');
        $tempApn = @explode("public/admin/", $apnPath);
        if (!empty($tempApn[1]))
            $apnVal = "public/admin/" . $tempApn[1];
        else
            $apnVal = "";
        foreach ($it as $file) {
            if ($file->isDot() || !$file->isFile())
                continue;
            $basename = basename($file->getFilename());
            if (!($pos = strrpos($basename, '.')))
                continue;
            $ext = strtolower(ltrim(substr($basename, $pos), '.'));
            if (!in_array($ext, $imageExtensions))
                continue;
            $logoOptions['public/admin/' . $basename] = $basename;
        }
        if (empty($logoOptions))
            $logoOptions['new'] = "no pem file";
        $this->setTitle('Global Settings')
                ->setDescription('These settings affect all members in your community.');
        $coreSettingsApi = Engine_Api::_()->getApi('settings', 'core');
        // ELEMENT FOR LICENSE KEY
        $this->addElement('Text', 'siteiosapp_lsettings', array(
            'label' => 'Enter License key',
            'description' => "Please enter your license key that was provided to you when you purchased this plugin. If you do not know your license key, please contact the Support Team of SocialApps.tech from the Support section of your Account Area.(Key Format: XXXXXX-XXXXXX-XXXXXX )",
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteiosapp.lsettings'),
        ));
        if (APPLICATION_ENV == 'production') {
            $this->addElement('Checkbox', 'environment_mode', array(
                'label' => 'Your community is currently in "Production Mode". We recommend that you momentarily switch your site to "Development Mode" so that the CSS of this plugin renders fine as soon as the plugin is installed. After completely installing this plugin and visiting few stores of your site, you may again change the System Mode back to "Production Mode" from the Admin Panel Home. (In Production Mode, caching prevents CSS of new plugins to be rendered immediately after installation.)',
                'description' => 'System Mode',
                'value' => 1,
            ));
        } else {
            $this->addElement('Hidden', 'environment_mode', array('order' => 990, 'value' => 0));
        }
        $this->addElement('Button', 'submit_lsetting', array(
            'label' => 'Activate Your Plugin Now',
            'type' => 'submit',
            'ignore' => true
        ));
        if (isset($_REQUEST['updateCertificate']) && !empty($_REQUEST['updateCertificate'])) {
            $this->addElement('Select', 'apple_server_apn_key', array(
                'label' => 'Apple APN Server Certificate',
                'description' => $customBlocks,
                'multiOptions' => $logoOptions,
                'value' => $apnVal,
            ));
            $this->getElement('apple_server_apn_key')->getDecorator('Description')->setOptions(array('placement' => 'PREPEND', 'escape' => false));
            $this->addElement('Password', 'password', array(
                'label' => 'APN Certificate Password',
                'description' => 'The SocialEngineAddOns Support Team will set this password for you at the time of app building. [Note: Please do not change this value unless you are sure of it. This field is for the SocialEngineAddOns Support Team that will build your app.]',
                'required' => true,
                'allowEmpty' => false,
                'values' => $settings->getSetting('siteiosapp.password', '')
            ));
            $this->addElement('Radio', 'siteiosapp_apn_mode', array(
                'label' => 'Select Push Notification Mode',
                'description' => 'Select the push notifiction mode. The SocialEngineAddOns Support Team will set this password for you at the time of app building. [Note: Please do not change the password value]',
                'multiOptions' => array(
                    1 => 'Production',
                    0 => 'Development'
                ),
                'value' => $settings->getSetting('siteiosapp_apn_mode', 1)
            ));
        }

        $this->addElement('Text', 'siteiosapp_shared_secret', array(
            'label' => "iTune's Shared Secret Key",
            'description' => "To see how to get your iTunes's shared secret key, please see the video <a href='https://youtu.be/oMqn4ZSRbrY' target='_blank'>here</a>.",
            'required' => true,
            'allowEmpty' => false,
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteiosapp.shared.secret')
        ));
        $this->getElement('siteiosapp_shared_secret')->getDecorator('Description')->setEscape(false);
        
                $linkApiKey = '<a href="http://developer.android.com/google/gcm/gs.html" class="buttonlink icon_help" target="_blank"></a>';
        $this->addElement('Text', 'siteiosapp_google_server_api_key', array(
            'label' => 'iOS Google API Key',
            'description' => "This API key will be used for push notifications. If you've already created iOS project in <a href='https://console.developers.google.com' target='_blank'>Google Account</a>, then <a href='https://youtu.be/wK95X4RLVYw' target='_blank'>click here</a> to see steps to create API key for your app. If you haven't yet created your iOS project, then <a href='https://youtu.be/0PNvUN9YfZY' target='_blank'>click here</a> for the steps to create API key.",
            'required' => true,
            'allowEmpty' => true,
            'style' => 'width: 300px',
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting("siteiosapp.google.server.api.key")
        ));
        $this->getElement('siteiosapp_google_server_api_key')->getDecorator('Description')->setEscape(false);

        $this->addElement('Radio', 'siteiosapp_current_mode', array(
            'label' => 'In-App Purchase Environment',
            'description' => "Choose In-App Purchase environment from below, by default your app will remain in sandbox mode (test mode), so to enable payments through live accounts, please choose Production mode. [Note: App should be in sandbox mode, if your app has been sent for iTune's approval.]",
            'required' => true,
            'allowEmpty' => false,
            'multiOptions' => array(
                0 => 'Production Mode',
                1 => 'Sandbox Mode',
            ),
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteiosapp.current.mode', 1)
        ));
        $this->getElement('siteiosapp_current_mode')->getDecorator('Description')->setEscape(false);

        $this->addElement('Radio', 'browse_as_guest', array(
            'label' => 'Enable Browse As Guest',
            'description' => 'Do you want to allow "Non-Logged In" users(guests) to browse your app? If disabled, only "Logged In" members will be able to use/browse your app.',
            'required' => true,
            'allowEmpty' => false,
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteiosapp.browse.guest', 1)
        ));
        $this->getElement('browse_as_guest')->getDecorator('Description')->setEscape(false);

        $this->addElement('Radio', 'app_tour', array(
            'label' => 'Enable App Tour?',
            'description' => 'App Tour highlight important Action Buttons like Search, Location etc. in the app, enabling first time app users to understand the App easily. Have a look at reference <a href="application/modules/Siteiosapp/externals/images/app_tour.PNG" target="_blank"> image</a>.',
            'required' => true,
            'allowEmpty' => false,
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting("siteiosapp.app.tour", 1)
        ));
        $this->getElement('app_tour')->getDecorator('Description')->setEscape(false);

        $this->addElement('Radio', 'siteios_member_view', array(
            'label' => 'Member Page Default View',
            'description' => 'Select the Default View Type for Members Page.',
            'multiOptions' => array(
                1 => 'List View',
                0 => 'Map View'
            ),
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting("ios.member.view", 1)
        ));
        $this->getElement('siteios_member_view')->getDecorator('Description')->setEscape(false);

        $this->addElement('Radio', 'ios_popup_enable', array(
            'label' => 'Enable Pop-up',
            'description' => 'Enabled Pop-up for App Upgrade.',
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting("ios.popup.enable", 0),
            'onchange' => 'popupenableType()'
        ));
        $this->getElement('ios_popup_enable')->getDecorator('Description')->setEscape(false);

        $this->addElement('Radio', 'siteiosapp_force_upgrade', array(
            'label' => 'Force Upgrade',
            'description' => 'When users with your app version lower than the required, they will see a pop-up to upgrade the app as they open you app. There will be no way for a user to access/browse the app without upgrading.',
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting("siteiosapp.force.upgrade", 0)
        ));
        
        $this->addElement('Text', 'siteiosapp_version_upgrade', array(
            'label' => "App Version",
            'description' => "Users using lower App version than the selected one will be shown a popup.",
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteiosapp.version.upgrade')
        ));
        $this->getElement('siteiosapp_version_upgrade')->getDecorator('Description')->setEscape(false);


        $this->addElement('Textarea', 'siteiosapp_version_description', array(
            'label' => 'Description',
            'description' => '',
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteiosapp.version.description')
        ));


                 //Video Quality settings.........
        $this->addElement('Radio', 'siteios_video_quality', array(
            'label' => 'Quality of Recorded Video',
            'description' => 'You can now Shoot a Video while uploading video from Status Box and Video creation form. Select the quality of video recording in App. [Note: 10 seconds of video recorded with Low Quality takes 1 MB and takes 15 MB size when created with High Quality.]',
            'required' => true,
            'allowEmpty' => false,
            'multiOptions' => array(
                0 => 'Low (Suggested)',
                1 => 'High',
            ),
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting("siteios.video.quality", 0)
        ));

        $this->getElement('siteios_video_quality')->getDecorator('Description')->setEscape(false);

        
        $this->addElement('Radio', 'siteapi_app_mode_ios', array(
            'label' => 'Debug Mode',
            'description' => 'Would you like to set the application mode to test.<br /> <b>Note:-</b> In the test mode you can easily debug your released app also.',
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'onchange' => '(this.value == 1) ? $("siteapi_test_device_id_ios-wrapper").show() : $("siteapi_test_device_id_ios-wrapper").hide()',
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteapi.app.mode.ios', 0),
        ));
        $this->siteapi_app_mode_ios->getDecorator('Description')->setOptions(array('placement' => 'PREPEND', 'escape' => false));

        $this->addElement('Text', 'siteapi_test_device_id_ios', array(
            'label' => "Email ID",
            'description' => "To write the application logs please enter the email id from which you are testing.",
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteapi.test.device.id.ios')
        ));

        $this->addElement('Button', 'submit', array(
            'label' => 'Save Changes',
            'type' => 'submit',
            'ignore' => true,
            'order' => 500,
        ));
    }

}
