<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteandroidapp
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Schedulednotifications.php 6590 2016-3-3 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteiosapp_Model_DbTable_Schedulednotifications extends Engine_Db_Table {

    public function getScheduledNotificationsSelect($params = array()) {
        $table = Engine_Api::_()->getDbtable('schedulednotifications', 'siteiosapp');
        $rName = $table->info('name');

        $select = $table->select()
                ->order(!empty($params['orderby']) ? $params['orderby'] . ' ASC' : $rName . '.creation_date DESC' )
                ->where($rName . '.scheduled_time > ?', date('Y-m-d H:i:s'));

        return $select;
    }

    public function getScheduledNotificationsPaginator($params = array()) {
        $paginator = Zend_Paginator::factory($this->getScheduledNotificationsSelect($params));
        if (!empty($params['page'])) {
            $paginator->setCurrentPageNumber($params['page']);
        }
        if (!empty($params['limit'])) {
            $paginator->setItemCountPerPage($params['limit']);
        }

        if (empty($params['limit'])) {
            $page = 50;
            $paginator->setItemCountPerPage($page);
        }

        return $paginator;
    }

    public function getUnsentNotifications() {
        $timezone = Engine_Api::_()->getApi('settings', 'core')->core_locale_timezone;
        date_default_timezone_set($timezone);
        $rName = $this->info('name');
        $select = $this->select()
                ->where($rName . '.status = ?', '00')
                ->where($rName . '.scheduled_time <= ?', date('Y-m-d H:i:s'))
                ->query();
        $data = array();
        $data = $select->fetchAll();

        return $data;
    }

    public function setStatus($status, $message_id) {
        $this->update(array('status' => $status), array('`message_id` = ? ' => $message_id));
    }

}
