<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteiosapp
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    AdminAppBuilderController.php 2015-10-01 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteiosapp_AdminAppBuilderController extends Core_Controller_Action_Admin {

    protected $_getAPPBuilderBaseURL = 'public/app-builder';
    protected $_getAPPBuilderSettingsFileName = 'settings.php';
    protected $_getAPPBuilderTarFileName = 'app-builder.tar';
    protected $_tarFileSize = 0;
    protected $_directoryName = 'app-builder';
    protected $_tabOneError = 0;
    protected $_tabTwoError = 0;
    protected $_requiredFormImages;
    protected $_enabledTabsArray = array(
        1 => 'siteiosapp_admin_general_settings',
        2 => 'siteiosapp_admin_graphic_assets',
        3 => 'siteiosapp_admin_dashboard_setting',
        5 => 'siteiosapp_admin_language_assets',
        6 => 'siteiosapp_admin_advertising',
        7 => 'siteiosapp_admin_download',
        8 => 'siteiosapp_admin_people',
    );
    protected $_advertisingEnabledTabsArray = array(
        1 => 'siteiosapp_admin_advertising_type',
        2 => 'siteiosapp_admin_advertising_modules',
    );
    protected $_dynamicImages = array(
        'splash_portrait_2',
        'splash_portrait_3',
        'splash_portrait_4',
        'splash_portrait_6',
        'splash_portrait_7',
        'splash_portrait_8',
        'splash_portrait_9',
        'splash_portrait_10',
        'splash_portrait_11',
        'splash_portrait_12',
        'splash_portrait_13'
    );
    protected $_graphicEnabledTabsArray = array(
        1 => 'siteiosapp_admin_graphic',
        2 => 'siteiosapp_admin_splash',
        3 => 'siteiosapp_admin_slideshow',
    );
    protected $_formFields = array(
        'ios_developer_account_details' => array(
            'ios_developer_account_details_credentials',
            'apple_ios_developer_login_email',
            'apple_ios_developer_login_password',
            'publish_app',
            'phone_udid'
        ),
        'app_color_code' => array(
            'app_header_color',
            'navigation_text_color',
            'button_color',
        ),
        'graphic_assets' => array(
            'normal_font',
            'bold_font',
            'image_upload_type',
        ),
        'app_details' => array(
            'package_name',
            'team_id',
            'team_name',
            'bundle_display_name',
            'title',
            'description',
            'default_language',
            'keywords',
            'category',
            'primary_category',
            'secondary_category',
            'rating',
            'firebase_google_services'
        ),
        'contact_details' => array(
            'first_name',
            'last_name',
            'email_contact_details',
            'phone',
            'address',
            'city',
            'state',
            'zip_code',
            'country',
            'support_url',
            'marketing_url',
            'privacy_url',
            'copyright',
        ),
        'app_default_settings' => array(
            'siteapi_validate_ssl',
            'api_consumer_key',
            'api_consumer_secret',
            'screenshot_modules',
            'enable_background_service',
            'isshow_app_name',
            'enable_primemessenger',
            'channelize_version',
            'commit_chat_package',
            'showcase_app',
            'map_key',
            'giphy_api_key',
            'api_key',
            'paid_subscription',
        ),
        'social_website_details' => array(
            'facebook_app_id',
            'facebook_app_display_name',
            'facebook_access_permission',
            'google_app_id',
            'apple_app_id'
        ),
        'live_broadcast_settings' => array(
            'enable_broadcast',
            //'agora_id',
            //'agora_server_url',
            
        ),
        'slideshow_first_slide' => array(
            'slideshow_slide_1_title',
            'slideshow_slide_1_description',
            'slideshow_slide_image_1_1',
            'slideshow_slide_image_1_2',
            'slideshow_slide_image_1_3',
        ),
        'slideshow_second_slide' => array(
            'slideshow_slide_2_title',
            'slideshow_slide_2_description',
            'slideshow_slide_image_2_1',
            'slideshow_slide_image_2_2',
            'slideshow_slide_image_2_3',
        ),
        'slideshow_third_slide' => array(
            'slideshow_slide_3_title',
            'slideshow_slide_3_description',
            'slideshow_slide_image_3_1',
            'slideshow_slide_image_3_2',
            'slideshow_slide_image_3_3',
        ),
        'secondController_dummy' => array(
            'secondController',
            'secondControllermenuname',
            'secondControllerImage1',
            'secondControllerUrl',
            'secondControllerImage2',
            'secondControllerImage3',
            'globalViewType',
            'globalBrowseType',
        ),
        'thirdController_dummy' => array(
            'thirdController',
            'thirdControllermenuname',
            'thirdControllerUrl',
            'thirdControllerImage1',
            'thirdControllerImage2',
            'thirdControllerImage3',
            'globalViewType1',
            'globalBrowseType1',
        ),
        'fourthController_dummy' => array(
            'fourthController',
            'fourthControllermenuname',
            'fourthControllerUrl',
            'fourthControllerImage1',
            'fourthControllerImage2',
            'fourthControllerImage3',
            'globalViewType2',
            'globalBrowseType2',
        ),
        'slideshow_first_plain_slide' => array(
            'slideshow_color_background_1',
            'slideshow_color_text_1',
            'slideshow_slide_plain_1_title',
            'slideshow_slide_plain_1_description',
            'slideshow_slide_plain_image_1_1',
        ),
        'slideshow_second_plain_slide' => array(
            'slideshow_color_background_2',
            'slideshow_color_text_2',
            'slideshow_slide_plain_2_title',
            'slideshow_slide_plain_2_description',
            'slideshow_slide_plain_image_1_2',
        ),
        'slideshow_third_plain_slide' => array(
            'slideshow_color_background_3',
            'slideshow_color_text_3',
            'slideshow_slide_plain_3_title',
            'slideshow_slide_plain_3_description',
            'slideshow_slide_plain_image_1_3',
        ),
        'slideshow_four_plain_slide' => array(
            'slideshow_color_background_4',
            'slideshow_color_text_4',
            'slideshow_slide_plain_4_title',
            'slideshow_slide_plain_4_description',
            'slideshow_slide_plain_image_1_4',
        ),
        'slideshow_five_plain_slide' => array(
            'slideshow_color_background_5',
            'slideshow_color_text_5',
            'slideshow_slide_plain_5_title',
            'slideshow_slide_plain_5_description',
            'slideshow_slide_plain_image_1_5',
        ),
        'slideshow_six_plain_slide' => array(
            'slideshow_color_background_6',
            'slideshow_color_text_6',
            'slideshow_slide_plain_6_title',
            'slideshow_slide_plain_6_description',
            'slideshow_slide_plain_image_1_6',
        ),
        'slideshow_seven_plain_slide' => array(
            'slideshow_color_background_7',
            'slideshow_color_text_7',
            'slideshow_slide_plain_7_title',
            'slideshow_slide_plain_7_description',
            'slideshow_slide_plain_image_1_7',
        ),
        'app_icon' => array(
            'large_app_icon',
            'notification_icon_large',
            'app_icon_21',
            'app_icon_1',
            'app_icon_2',
            'app_icon_3',
            'app_icon_4',
            'app_icon_5',
            'app_icon_6',
            'app_icon_7',
            'app_icon_8',
            'app_icon_9',
            'app_icon_16',
            'app_icon_10',
            'app_icon_11',
            'app_icon_12',
            'app_icon_13',
            'app_icon_14',
            'app_icon_17',
            'app_icon_15',
        ),
        'splash_screen' => array(
            'welcome_image_type',
            'animation_time',
        ),
        'splash_screen_portrait' => array(
            'splash_portrait_2',
            'splash_portrait_3',
            'splash_portrait_6',
            'splash_portrait_7',
            'splash_portrait_4',
            'splash_portrait_8',
            'splash_portrait_9',
            'splash_portrait_10',
            'splash_portrait_11',
            'splash_portrait_12',
            'splash_portrait_13'
        )
    );
    protected $_hidequickImages1 = array(
        'app_icon_1',
        'app_icon_2',
        'app_icon_3',
        'app_icon_4',
        'app_icon_5',
        'app_icon_6',
        'app_icon_7',
        'app_icon_8',
        'app_icon_9',
        'app_icon_10',
        'app_icon_11',
        'app_icon_12',
        'app_icon_13',
        'app_icon_14',
        'app_icon_15',
        'app_icon_16',
        'app_icon_17',
        'app_icon_21',
    );
    protected $_displayquickImages2 = array(
        'large_app_icon',
        'splash_portrait_2',
        'splash_portrait_3',
        'splash_portrait_6',
        'splash_portrait_7',
        'splash_portrait_4',
        'splash_portrait_8',
        'splash_portrait_9',
        'splash_portrait_10',
        'splash_portrait_11',
        'splash_portrait_12',
        'splash_portrait_13'
    );
    protected $_displayquickImages4 = array(
        'slideshow_slide_image_1_3',
        'slideshow_slide_image_2_3',
        'slideshow_slide_image_3_3',
        'slideshow_slide_plain_image_1_1',
        'slideshow_slide_plain_image_1_2',
        'slideshow_slide_plain_image_1_3',
        'slideshow_slide_plain_image_1_4',
        'slideshow_slide_plain_image_1_5',
        'slideshow_slide_plain_image_1_6',
        'slideshow_slide_plain_image_1_7',
    );
    protected $_hidequickImages4 = array(
        'slideshow_slide_image_1_1',
        'slideshow_slide_image_1_2',
    );
    protected $_displayquickImages3 = array(
        'secondControllerImage3',
        'thirdControllerImage3',
        'fourthControllerImage3'
    );
    protected $_hidequickImages3 = array(
        'secondControllerImage1',
        'secondControllerImage2',
        'thirdControllerImage1',
        'thirdControllerImage2',
        'fourthControllerImage1',
        'fourthControllerImage2',
    );
    protected $_EnabledModules = array(
        'advancedactivity',
        'album',
        'blog',
        'classified',
        'event',
        'forum',
        'group',
        'music',
        'poll',
        'video',
        'siteevent',
        'sitevideo',
        'sitegroup',
        'sitepage',
        'sitereview'
    );
    protected $_requiredFormFields = array(
        'ios_developer_account_details_credentials',
        'title',
        'bundle_display_name',
        'keywords',
        'category',
        'rating',
        'description',
        'default_language',
        'first_name',
        'last_name',
        'email_contact_details',
        'phone',
        'address',
        'city',
        'state',
        'zip_code',
        'support_url',
        'copyright',
        'api_key',
        'siteapi_validate_ssl',
        'normal_font',
        'bold_font',
    );
    protected $_getAPPImageDetailsForUpload = array(
        'large_app_icon' => array(
            'title' => 'Large App Icon (1024 x 1024)',
            'width' => 1024,
            'height' => 1024,
            'directoryName' => 'Large_App_Icon',
            'fileName' => 'Hi-res icon 1024 x 1024'
        ),
        'app_icon_1' => array(
            'title' => 'APP Icon (29 x 29)',
            'width' => 29,
            'height' => 29,
            'directoryName' => 'App_Icons',
            'fileName' => 'icon 29 x 29'
        ),
        'app_icon_2' => array(
            'title' => 'APP Icon (40 x 40)',
            'width' => 40,
            'height' => 40,
            'directoryName' => 'App_Icons',
            'fileName' => 'icon 40 x 40'
        ),
        'app_icon_3' => array(
            'title' => 'APP Icon (50 x 50)',
            'width' => 50,
            'height' => 50,
            'directoryName' => 'App_Icons',
            'fileName' => 'icon 50 x 50'
        ),
        'app_icon_4' => array(
            'title' => 'APP Icon (57 x 57)',
            'width' => 57,
            'height' => 57,
            'directoryName' => 'App_Icons',
            'fileName' => 'icon 57 x 57'
        ),
        'app_icon_5' => array(
            'title' => 'APP Icon (58 x 58)',
            'width' => 58,
            'height' => 58,
            'directoryName' => 'App_Icons',
            'fileName' => 'icon 58 x 58'
        ),
        'app_icon_6' => array(
            'title' => 'APP Icon (60 x 60)',
            'width' => 60,
            'height' => 60,
            'directoryName' => 'App_Icons',
            'fileName' => 'icon 60 x 60'
        ),
        'app_icon_7' => array(
            'title' => 'APP Icon (72 x 72)',
            'width' => 72,
            'height' => 72,
            'directoryName' => 'App_Icons',
            'fileName' => 'icon 72 x 72'
        ),
        'app_icon_8' => array(
            'title' => 'APP Icon (76 x 76)',
            'width' => 76,
            'height' => 76,
            'directoryName' => 'App_Icons',
            'fileName' => 'icon 76 x 76'
        ),
        'app_icon_9' => array(
            'title' => 'APP Icon (80 x 80)',
            'width' => 80,
            'height' => 80,
            'directoryName' => 'App_Icons',
            'fileName' => 'icon 80 x 80'
        ),
        'app_icon_16' => array(
            'title' => 'APP Icon (87 x 87)',
            'width' => 87,
            'height' => 87,
            'directoryName' => 'App_Icons',
            'fileName' => 'icon 87 x 87'
        ),
        'app_icon_10' => array(
            'title' => 'APP Icon (100 x 100)',
            'width' => 100,
            'height' => 100,
            'directoryName' => 'App_Icons',
            'fileName' => 'icon 100 x 100'
        ),
        'app_icon_11' => array(
            'title' => 'APP Icon (114 x 114)',
            'width' => 114,
            'height' => 114,
            'directoryName' => 'App_Icons',
            'fileName' => 'icon 114 x 114'
        ),
        'app_icon_12' => array(
            'title' => 'APP Icon (120 x 120)',
            'width' => 120,
            'height' => 120,
            'directoryName' => 'App_Icons',
            'fileName' => 'icon 120 x 120'
        ),
        'app_icon_13' => array(
            'title' => 'APP Icon (144 x 144)',
            'width' => 144,
            'height' => 144,
            'directoryName' => 'App_Icons',
            'fileName' => 'icon 144 x 144'
        ),
        'app_icon_14' => array(
            'title' => 'APP Icon (152 x 152)',
            'width' => 152,
            'height' => 152,
            'directoryName' => 'App_Icons',
            'fileName' => 'icon 152 x 152'
        ),
        'app_icon_15' => array(
            'title' => 'APP Icon (180 x 180)',
            'width' => 180,
            'height' => 180,
            'directoryName' => 'App_Icons',
            'fileName' => 'icon 180 x 180'
        ),
        'notification_icon_large' => array(
            'title' => 'Notification APP Icon (512 x 512)',
            'width' => 512,
            'height' => 512,
            'directoryName' => 'App_Icons',
            'fileName' => 'Notification icon 512 x 512'
        ),
        'app_icon_21' => array(
            'title' => 'APP Icon (20 x 20)',
            'width' => 20,
            'height' => 20,
            'directoryName' => 'App_Icons',
            'fileName' => 'icon 20 x 20'
        ),
        'app_icon_17' => array(
            'title' => 'APP Icon (167 x 167)',
            'width' => 167,
            'height' => 167,
            'directoryName' => 'App_Icons',
            'fileName' => 'icon 167 x 167'
        ),
        'splash_portrait_2' => array(
            'title' => 'Splash Portrait Image (640 x 960)',
            'width' => 640,
            'height' => 960,
            'directoryName' => 'Splash_Screen_Images/Iphone/Portrait',
            'fileName' => 'screen 640 x 960'
        ),
        'splash_portrait_3' => array(
            'title' => 'Splash Portrait Image (640 x 1136)',
            'width' => 640,
            'height' => 1136,
            'directoryName' => 'Splash_Screen_Images/Iphone/Portrait',
            'fileName' => 'screen 640 x 1136'
        ),
        'splash_portrait_4' => array(
            'title' => 'Splash Portrait Image (768 x 1024)',
            'width' => 768,
            'height' => 1024,
            'directoryName' => 'Splash_Screen_Images/Ipad/Portrait',
            'fileName' => 'screen 768 x 1024'
        ),
        'splash_portrait_6' => array(
            'title' => 'Splash Portrait Image (750 x 1334)',
            'width' => 750,
            'height' => 1334,
            'directoryName' => 'Splash_Screen_Images/Ipad/Portrait',
            'fileName' => 'screen 750 x 1334'
        ),
        'splash_portrait_7' => array(
            'title' => 'Splash Portrait Image (1242 x 2208)',
            'width' => 1242,
            'height' => 2208,
            'directoryName' => 'Splash_Screen_Images/Ipad/Portrait',
            'fileName' => 'screen 1242 x 2208'
        ),
        'splash_portrait_8' => array(
            'title' => 'Splash Portrait Image (1125 x 2436)',
            'width' => 1125,
            'height' => 2436,
            'directoryName' => 'Splash_Screen_Images/Ipad/Portrait',
            'fileName' => 'screen 1125 x 2436'
        ),
        'splash_portrait_9' => array(
            'title' => 'Splash Portrait Image (1242 x 2688)',
            'width' => 1242,
            'height' => 2688,
            'directoryName' => 'Splash_Screen_Images/Ipad/Portrait',
            'fileName' => 'screen 1242 x 2688'
        ),
        'splash_portrait_10' => array(
            'title' => 'Splash Portrait Image (1170 x 2532)',
            'width' => 1170,
            'height' => 2532,
            'directoryName' => 'Splash_Screen_Images/Ipad/Portrait',
            'fileName' => 'screen 1170 x 2532'
        ),
        'splash_portrait_11' => array(
            'title' => 'Splash Portrait Image (828 x 1792)',
            'width' => 828,
            'height' => 1792,
            'directoryName' => 'Splash_Screen_Images/Ipad/Portrait',
            'fileName' => 'screen 828 x 1792'
        ),
        'splash_portrait_12' => array(
            'title' => 'Splash Portrait Image (1284 x 2778)',
            'width' => 1284,
            'height' => 2778,
            'directoryName' => 'Splash_Screen_Images/Ipad/Portrait',
            'fileName' => 'screen 1284 x 2778'
        ),
        'splash_portrait_13' => array(
            'title' => 'Splash Portrait Image (1080 x 2340)',
            'width' => 1080,
            'height' => 2340,
            'directoryName' => 'Splash_Screen_Images/Ipad/Portrait',
            'fileName' => 'screen 1080 x 2340'
        ),
        'slideshow_slide_image_1_1' => array(
            'title' => 'Slideshow - First Slide (640 x 1136)',
            'width' => 640,
            'height' => 1136,
            'directoryName' => 'Slideshow_Images/Small_Images_Mobile 640 x 1136',
            'fileName' => 'first'
        ),
        'slideshow_slide_image_1_2' => array(
            'title' => 'Slideshow - First Slide (750 x 1334)',
            'width' => 750,
            'height' => 1334,
            'directoryName' => 'Slideshow_Images/Medium_Images_Tablet 750 x 1334',
            'fileName' => 'first'
        ),
        'slideshow_slide_image_1_3' => array(
            'title' => 'Slideshow - First Slide (1242 x 2208)',
            'width' => 1242,
            'height' => 2208,
            'directoryName' => 'Slideshow_Images/Big_Images_Tablet 1242 x 2208',
            'fileName' => 'first'
        ),
        'slideshow_slide_image_2_1' => array(
            'title' => 'Slideshow - Second Slide (640 x 1136)',
            'width' => 640,
            'height' => 1136,
            'directoryName' => 'Slideshow_Images/Small_Images_Mobile 640 x 1136',
            'fileName' => 'second'
        ),
        'slideshow_slide_image_2_2' => array(
            'title' => 'Slideshow - Second Slide (750 x 1334)',
            'width' => 750,
            'height' => 1334,
            'directoryName' => 'Slideshow_Images/Medium_Images_Tablet 750 x 1334',
            'fileName' => 'second'
        ),
        'slideshow_slide_image_2_3' => array(
            'title' => 'Slideshow - Second Slide (1242 x 2208)',
            'width' => 1242,
            'height' => 2208,
            'directoryName' => 'Slideshow_Images/Big_Images_Tablet 1242 x 2208',
            'fileName' => 'second'
        ),
        'slideshow_slide_image_3_1' => array(
            'title' => 'Slideshow - Third Slide (640 x 1136)',
            'width' => 640,
            'height' => 1136,
            'directoryName' => 'Slideshow_Images/Small_Images_Mobile 640 x 1136',
            'fileName' => 'third'
        ),
        'slideshow_slide_image_3_2' => array(
            'title' => 'Slideshow - Third Slide (750 x 1334)',
            'width' => 750,
            'height' => 1334,
            'directoryName' => 'Slideshow_Images/Medium_Images_Tablet 750 x 1334',
            'fileName' => 'third'
        ),
        'slideshow_slide_image_3_3' => array(
            'title' => 'Slideshow - Third Slide (1242 x 2208)',
            'width' => 1242,
            'height' => 2208,
            'directoryName' => 'Slideshow_Images/Big_Images_Tablet 1242 x 2208',
            'fileName' => 'third'
        ),
        'slideshow_slide_plain_image_1_1' => array(
            'title' => 'Slideshow - First Slide (512 x 512)',
            'width' => 512,
            'height' => 512,
            'directoryName' => 'Slideshow_Images/Plain_Slideshow 512 x 512',
            'fileName' => 'first'
        ),
        'slideshow_slide_plain_image_1_2' => array(
            'title' => 'Slideshow - Second Slide (512 x 512)',
            'width' => 512,
            'height' => 512,
            'directoryName' => 'Slideshow_Images/Plain_Slideshow 512 x 512',
            'fileName' => 'second'
        ),
        'slideshow_slide_plain_image_1_3' => array(
            'title' => 'Slideshow - Third Slide (512 x 512)',
            'width' => 512,
            'height' => 512,
            'directoryName' => 'Slideshow_Images/Plain_Slideshow 512 x 512',
            'fileName' => 'third'
        ),
        'slideshow_slide_plain_image_1_4' => array(
            'title' => 'Slideshow - Fourth Slide (512 x 512)',
            'width' => 512,
            'height' => 512,
            'directoryName' => 'Slideshow_Images/Plain_Slideshow 512 x 512',
            'fileName' => 'four'
        ),
        'slideshow_slide_plain_image_1_5' => array(
            'title' => 'Slideshow - Fifth Slide (512 x 512)',
            'width' => 512,
            'height' => 512,
            'directoryName' => 'Slideshow_Images/Plain_Slideshow 512 x 512',
            'fileName' => 'five'
        ),
        'slideshow_slide_plain_image_1_6' => array(
            'title' => 'Slideshow - Sixth Slide (512 x 512)',
            'width' => 512,
            'height' => 512,
            'directoryName' => 'Slideshow_Images/Plain_Slideshow 512 x 512',
            'fileName' => 'six'
        ),
        'slideshow_slide_plain_image_1_7' => array(
            'title' => 'Slideshow - Seventh Slide (512 x 512)',
            'width' => 512,
            'height' => 512,
            'directoryName' => 'Slideshow_Images/Plain_Slideshow 512 x 512',
            'fileName' => 'seven'
        ),
        'secondControllerImage1' => array(
            'title' => 'Second tab icon 18 x 18',
            'width' => 18,
            'height' => 18,
            'directoryName' => 'App_Icons',
            'fileName' => 'second tab 18 x 18'
        ),
        'secondControllerImage2' => array(
            'title' => 'Second tab icon 36 x 36',
            'width' => 36,
            'height' => 36,
            'directoryName' => 'App_Icons',
            'fileName' => 'second tab 36 x 36'
        ),
        'secondControllerImage3' => array(
            'title' => 'Second tab icon 54 x 54',
            'width' => 54,
            'height' => 54,
            'directoryName' => 'App_Icons',
            'fileName' => 'second tab 54 x 54'
        ),
        'thirdControllerImage1' => array(
            'title' => 'third tab icon 18 x 18',
            'width' => 18,
            'height' => 18,
            'directoryName' => 'App_Icons',
            'fileName' => 'third tab 18 x 18'
        ),
        'thirdControllerImage2' => array(
            'title' => 'third tab icon 36 x 36',
            'width' => 36,
            'height' => 36,
            'directoryName' => 'App_Icons',
            'fileName' => 'third tab 36 x 36'
        ),
        'thirdControllerImage3' => array(
            'title' => 'third tab icon 54 x 54',
            'width' => 54,
            'height' => 54,
            'directoryName' => 'App_Icons',
            'fileName' => 'third tab 54 x 54'
        ),
        'fourthControllerImage1' => array(
            'title' => 'fourth tab icon 18 x 18',
            'width' => 18,
            'height' => 18,
            'directoryName' => 'App_Icons',
            'fileName' => 'fourth tab 18 x 18'
        ),
        'fourthControllerImage2' => array(
            'title' => 'fourth tab icon 36 x 36',
            'width' => 36,
            'height' => 36,
            'directoryName' => 'App_Icons',
            'fileName' => 'fourth tab 36 x 36'
        ),
        'fourthControllerImage3' => array(
            'title' => 'fourth tab icon 54 x 54',
            'width' => 54,
            'height' => 54,
            'directoryName' => 'App_Icons',
            'fileName' => 'fourth tab 54 x 54'
        ),
    );

    public function init() {
        $getWebsiteName = str_replace('www.', '', strtolower($_SERVER['HTTP_HOST']));
        $websiteStr = str_replace(".", "-", $getWebsiteName);
        $this->_directoryName = 'ios-' . $websiteStr . '-app-builder';
        $this->_getAPPBuilderTarFileName = $this->_directoryName . '.tar';
        $this->_getAPPBuilderBaseURL = 'public/' . $this->_directoryName;
        $tempImageArray = $this->_getAPPImageDetailsForUpload;

        unset($tempImageArray['slideshow_slide_image_2_2']);
        unset($tempImageArray['slideshow_slide_image_2_1']);
        unset($tempImageArray['slideshow_slide_image_2_3']);
        unset($tempImageArray['slideshow_slide_image_3_2']);
        unset($tempImageArray['slideshow_slide_image_3_1']);
        unset($tempImageArray['slideshow_slide_image_3_3']);
        
        $this->_requiredFormImages = array_keys($tempImageArray);
        $this->view->enabledTabs = $this->_enabledTabsArray;
        $this->view->currentTab = $currentTab = $this->_getParam('tab', 1);
        $this->getFormFields($currentTab);
        $this->view->tabOneErrorDisplay = $this->_tabOneError;
        $this->view->tabTwoErrorDisplay = $this->_tabTwoError;
        $this->view->subTabError = $this->_subTabError;
    }

    public function indexAction() {
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteiosapp_admin_main', array(), 'siteiosapp_admin_app_create');
    }

    public function languageIndexAction() {
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteiosapp_admin_main', array(), 'siteiosapp_admin_app_create');

        $enabledTab = $this->_getParam('tab', 1);
        $this->view->doWeHaveLatestVersion = $this->_getParam('doWeHaveLatestVersion', '');
        $this->view->subnavigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteiosapp_admin_appsetup_main', array(), $this->_enabledTabsArray[$enabledTab]);

        $translate = Zend_Registry::get('Zend_Translate');

        // Prepare language list
        $this->view->languageList = $languageList = $translate->getList();

        //Get available language file.
        foreach ($this->_getAPPLanguageDetailsForUpload() as $key => $values) {
            @chmod(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $values['directoryName'] . '/' . $values['fileName'] . '.strings', 0777);
            if (@file_exists(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $values['directoryName'] . '/' . $values['fileName'] . '.strings'))
                $getDefaultAvailableLanguages[$key] = $values;
            elseif (@file_exists(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $values['directoryName'] . '/' . $values['fileName'] . '.csv'))
                $getDefaultAvailableCSVLanguages[$key] = $values;
        }
        $this->view->getAPPLanguageDetailsForUpload = !empty($getDefaultAvailableLanguages) ? $getDefaultAvailableLanguages : array();
        $this->view->getAPPCSVLanguageDetailsForUpload = !empty($getDefaultAvailableCSVLanguages) ? $getDefaultAvailableCSVLanguages : array();

        // Prepare default langauge
        $defaultLanguage = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.locale.locale', 'en');
        if (!in_array($defaultLanguage, $languageList)) {
            if ($defaultLanguage == 'auto' && isset($languageList['en'])) {
                $defaultLanguage = 'en';
            } else {
                $defaultLanguage = null;
            }
        }
        $this->view->defaultLanguage = $defaultLanguage;

        // Init default locale
        $localeObject = Zend_Registry::get('Locale');

        $languages = Zend_Locale::getTranslationList('language', $localeObject);
        $territories = Zend_Locale::getTranslationList('territory', $localeObject);

        $localeMultiOptions = array();
        foreach (/* array_keys(Zend_Locale::getLocaleList()) */ $languageList as $key) {
            $languageName = null;
            if (!empty($languages[$key])) {
                $languageName = $languages[$key];
            } else {
                $tmpLocale = new Zend_Locale($key);
                $region = $tmpLocale->getRegion();
                $language = $tmpLocale->getLanguage();
                if (!empty($languages[$language]) && !empty($territories[$region])) {
                    $languageName = $languages[$language] . ' (' . $territories[$region] . ')';
                }
            }

            if ($languageName) {
                $localeMultiOptions[$key] = $languageName . ' [' . $key . ']';
            } else {
                $localeMultiOptions[$key] = $this->view->translate('Unknown') . ' [' . $key . ']';
            }
        }
        $localeMultiOptions = array_merge(array(
            $defaultLanguage => $defaultLanguage
                ), $localeMultiOptions);
        $this->view->languageNameList = $localeMultiOptions;
    }

    public function languageDeleteAction() {
        $this->_helper->layout->setLayout('admin-simple');
        $this->view->locale = $defaultLocale = $this->_getParam('locale');
        $languageList = Zend_Locale_Data::getList('en', 'language');
        $territoryList = Zend_Locale_Data::getList('en', 'territory');
        $localeCode = $this->_getParam('locale', null);
        if (empty($localeCode))
            return;
        if (FALSE !== strpos($localeCode, '_')) {
            list($locale, $territory) = explode('_', $localeCode);
        } else {
            $locale = $localeCode;
            $territory = null;
        }

        $languagePack = $languageList[$locale];
        if ($territory && !empty($territoryList[$territory]))
            $languagePack .= " ({$territoryList[$territory]})";
        $languagePack .= "  [$localeCode]";
        $this->view->languagePack = $languagePack;

        if ($this->getRequest()->isPost()) {
            // Delete existing string file.
            if (!empty($localeCode) && file_exists(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . 'Languages_App/' . $defaultLocale . '_language_ios_mobileapp.strings'))
                @unlink(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . 'Languages_App/' . $defaultLocale . '_language_ios_mobileapp.strings');

            // Delete existing csv file.
            if (!empty($localeCode) && file_exists(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . 'Languages_App/' . $defaultLocale . '_language_ios_mobileapp.csv'))
                @unlink(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . 'Languages_App/' . $defaultLocale . '_language_ios_mobileapp.csv');

            $this->_forward('success', 'utility', 'core', array(
                'smoothboxClose' => 10,
                'parentRefresh' => 10,
                'messages' => array(Zend_Registry::get('Zend_Translate')->_('Deleted Successfully!'))
            ));
        }
    }

    public function editGoogleAdModulesAction() {
        $key = $this->_getParam('key');
        $getAPPBuilderParentPath = APPLICATION_PATH . DIRECTORY_SEPARATOR
                . $this->_getAPPBuilderBaseURL;

        $getAPPBuilderSettingsFilePath = $getAPPBuilderParentPath . DIRECTORY_SEPARATOR
                . $this->_getAPPBuilderSettingsFileName;

        if (@file_exists($getAPPBuilderSettingsFilePath))
            include $getAPPBuilderSettingsFilePath;

        $this->view->form = $form = new Siteiosapp_Form_Admin_AppBuilder_GoogleAds_Edit();
        if (isset($appBuilderParams) && !empty($appBuilderParams) && isset($appBuilderParams['Ads'][$key]) && !empty($appBuilderParams['Ads'][$key]))
            $form->populate($appBuilderParams['Ads'][$key]);

        if(Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitead'))
            $communityPluginEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitead');
        else
            $communityPluginEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('communityad');

        $storyPluginEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled("communityadsponsored");

        if ($appBuilderParams['adv_type'] == 0) {
            $adMultiOptions[0] = 'Google Ads';
        } else {
            $adMultiOptions[1] = 'Facebook Ads';
        }
        if ($communityPluginEnabled) {
            $adMultiOptions[2] = 'Community Ads';
        }
        if ($storyPluginEnabled && strstr($key, 'advancedactivity')) {
            $adMultiOptions[4] = 'Sponsered Stories';
        }

        $form->getElement('module_ad_type')->setMultiOptions($adMultiOptions);
        if ($this->getRequest()->isPost()) {
            $formError = array();
            $values = $this->getRequest()->getPost();

            if ($values['google_ad_show_after'] < 5) {
                $this->_forward('success', 'utility', 'core', array(
                    'smoothboxClose' => 10000,
                    'messages' => array(Zend_Registry::get('Zend_Translate')->_('Show add after : should not be less than 5'))
                ));
                return;
            }

            if (!empty($values)) {
                unset($values['submit']);
                $values['enabled_google_ad'] = (boolean) $values['enabled_google_ad'];
                $values['google_ad_show_after'] = (int) $values['google_ad_show_after'];
                $appBuilderParams['Ads'][$key] = $values;
            }

            if (!empty($appBuilderParams)) {
                $file_contents = "<?php ";
                $file_contents .= '$appBuilderParams = ';
                $file_contents .= var_export($appBuilderParams, true);
                $file_contents .= " ?>";

                @file_put_contents($getAPPBuilderSettingsFilePath, $file_contents);
                $successMessage = 'Your changes have been saved successfully. Now please download the "tar file" and follow the given instructions, to get started with your APP creation.';
            }

            $this->_forward('success', 'utility', 'core', array(
                'smoothboxClose' => 300,
                'parentRefresh' => 300,
                'messages' => array(Zend_Registry::get('Zend_Translate')->_('successfully saved'))
            ));
        }
    }

    public function statusAction() {
        $key = $this->_getParam('key');
        $getAPPBuilderParentPath = APPLICATION_PATH . DIRECTORY_SEPARATOR
                . $this->_getAPPBuilderBaseURL;

        $getAPPBuilderSettingsFilePath = $getAPPBuilderParentPath . DIRECTORY_SEPARATOR
                . $this->_getAPPBuilderSettingsFileName;

        if (@file_exists($getAPPBuilderSettingsFilePath))
            include $getAPPBuilderSettingsFilePath;

        if (isset($appBuilderParams) && !empty($appBuilderParams) && isset($appBuilderParams['Ads'][$key]) && !empty($appBuilderParams['Ads'][$key])) {
            $appBuilderParams['Ads'][$key]['enabled_google_ad'] = !$appBuilderParams['Ads'][$key]['enabled_google_ad'];
        } else {
            $appBuilderParams['Ads'][$key]['google_ad_show_after'] = 8;
            $appBuilderParams['Ads'][$key]['enabled_google_ad'] = true;
        }

        if (!empty($appBuilderParams)) {
            $file_contents = "<?php ";
            $file_contents .= '$appBuilderParams = ';
            $file_contents .= var_export($appBuilderParams, true);
            $file_contents .= " ?>";

            @file_put_contents($getAPPBuilderSettingsFilePath, $file_contents);
            $successMessage = 'Your changes have been saved successfully. Now please download the "tar file" and follow the given instructions, to get started with your APP creation.';
        }

        $this->_forward('success', 'utility', 'core', array(
            'smoothboxClose' => true,
            'parentRefresh' => true,
        ));
    }

    public function languageEditAction() {
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteiosapp_admin_main', array(), 'siteiosapp_admin_app_create');
        $this->view->subnavigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteiosapp_admin_appsetup_main', array(), $this->_enabledTabsArray[5]);

        $this->view->isFileExist = false;
        $this->view->locale = $locale = $this->_getParam('locale');
        $this->view->page = $page = $this->_getParam('page');
        $translation = $this->_getParam('translation', 0);
        $show = $this->_getParam('show', null);
        $search = $this->_getParam('search', null);
        $translate = Zend_Registry::get('Zend_Translate');

        // Get existing language array.
        $getAPPLanguageDetailsForUpload = $this->_getAPPLanguageDetailsForUpload();

        $defaultTargetStringURL = APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $getAPPLanguageDetailsForUpload[$locale]['directoryName'] . '/' . $getAPPLanguageDetailsForUpload[$locale]['fileName'] . '.strings';
        // Convert CSV to Strings
        if (isset($getAPPLanguageDetailsForUpload[$locale]) &&
                isset($getAPPLanguageDetailsForUpload[$locale]['fileName']) &&
                file_exists(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $getAPPLanguageDetailsForUpload[$locale]['directoryName'] . '/' . $getAPPLanguageDetailsForUpload[$locale]['fileName'] . '.csv') &&
                !file_exists($defaultTargetStringURL)) {
            $this->_modifyExistingLanguageStrings(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $getAPPLanguageDetailsForUpload[$locale]['directoryName'] . '/' . $getAPPLanguageDetailsForUpload[$locale]['fileName'] . '.csv', $defaultTargetStringURL);
        }

        if (isset($getAPPLanguageDetailsForUpload[$locale]) &&
                isset($getAPPLanguageDetailsForUpload[$locale]['fileName']) &&
                @file_exists($defaultTargetStringURL)) {
            $this->view->isFileExist = true;
            @chmod($defaultTargetStringURL, 0777);

            $getExistingLanguageArray = $this->_ExplodeStringsToArray($defaultTargetStringURL);
        }
        $path = APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $getAPPLanguageDetailsForUpload[$locale]['directoryName'] . '/' . $getAPPLanguageDetailsForUpload[$locale]['fileName'] . '.strings';
        // Process filter form
        $this->view->filterForm = $filterForm = new Core_Form_Admin_Language_Filter();
        // Get default language array.
        if (@file_exists(APPLICATION_PATH . DIRECTORY_SEPARATOR . '/application/modules/Siteiosapp/settings/Localizable.strings')) {
            $getDefaultLanguageArray = $this->_ExplodeStringsToArray(APPLICATION_PATH . DIRECTORY_SEPARATOR . '/application/modules/Siteiosapp/settings/Localizable.strings');

            if (!empty($translation) && Engine_Api::_()->hasModuleBootstrap('sitetranslator') && $locale != 'en' && !file_exists($path)) {
                $variables = $this->_csv_to_array(APPLICATION_PATH . "/application/modules/Sitetranslator/settings/variables.csv");
                $responseData = Engine_Api::_()->sitetranslator()->getTranslatedBaseMessage($getDefaultLanguageArray, $locale, $variables);
                if ($responseData['responseCode'] != 200) {
                    $filterForm->addError('Fetching translation failed! Server response code:' . $responseData['responseCode'] . '<br /> Error description: ' . $responseData['responseData']['error']['errors'][0]['message']);
                } else {
                    $getDefaultTranslatedLanguageArray = $responseData['responseData'];
                }
            }
        }

        $filterForm->isValid($this->_getAllParams());
        $filterValues = $filterForm->getValues();
        extract($filterValues); // search, show
        // Make query
        $filterValues = array_filter($filterValues);
        $this->view->values = $filterValues;
        $this->view->query = ( empty($filterValues) ? '' : '?' . http_build_query($filterValues) );

        // Query plural system for max and sample space
//        $sample = array();
//        $max = 0;
//        for ($i = 0; $i <= 1000; $i++) {
//            $form = Zend_Translate_Plural::getPlural($i, $locale);
//            $max = max($max, $form);
//            if (@count($sample[$form]) < 3) {
//                $sample[$form][] = $i;
//            }
//        }
//        $pluralFormCount = ( $max + 1 );
//        $this->view->pluralFormSample = $sample;
        // Build the fancy array
        $baseMessages = $getDefaultLanguageArray;
        $resultantMessages = array();
        $missing = 0;
        $index = 0;
        $missingLanguageCount = 0;
        foreach ($baseMessages as $key => $value) {
            // Build
            $composite = array(
                'uid' => ++$index,
                'key' => $key,
                'original' => $value
            );

            if (!empty($getExistingLanguageArray) &&
                    !isset($getExistingLanguageArray[$key]))
                $missingLanguageCount++;


            if (($show === 'missing') &&
                    !empty($getExistingLanguageArray) &&
                    isset($getExistingLanguageArray[$key]))
                continue;

            if ($show === 'translated' &&
                    !isset($getExistingLanguageArray[$key]))
                continue;

//            $composite['plural'] = $isPlural = (bool) is_array($value);

            $composite['current'] = (!empty($getExistingLanguageArray) && isset($getExistingLanguageArray[$key]) && !empty($getExistingLanguageArray[$key])) ? $getExistingLanguageArray[$key] : (!empty($getDefaultTranslatedLanguageArray[$key]) ? $getDefaultTranslatedLanguageArray[$key] : $value);

//            $composite['pluralFormCount'] = !empty($isPlural) ? COUNT($value) : 2;
//            // filters, plurals, and missing, oh my.
//            if (isset($currentMessages[$key])) {
//                if ('missing' == $show) {
//                    continue;
//                }
//                if (is_array($value) && !is_array($currentMessages[$key])) {
//                    $composite['current'] = array($currentMessages[$key]);
//                } else if (!is_array($value) && is_array($currentMessages[$key])) {
//                    $composite['current'] = current($currentMessages[$key]);
//                } else {
//                    $composite['current'] = $currentMessages[$key];
//                }
//            } else {
//                if ('translated' == $show) {
//                    continue;
//                }
//                if (is_array($value)) {
//                    $composite['current'] = array();
//                } else {
//                    $composite['current'] = '';
//                }
//                $missing++;
//            }
            // Do search
            if ($search && !$this->_searchArrayRecursive($search, $composite)) {
                continue;
            }
            // Add
            $resultantMessages[] = $composite;
        }

        $this->view->missingLanguageCount = $missingLanguageCount;

        // Build the paginator
        $this->view->paginator = $paginator = Zend_Paginator::factory($resultantMessages);
        $paginator->setItemCountPerPage(50);
        $paginator->setCurrentPageNumber($page);


        // Process form POST
        if ($this->getRequest()->isPost()) {
            $keys = $this->_getParam('keys');
            $values = $this->_getParam('values');

            if (isset($getAPPLanguageDetailsForUpload[$locale]) &&
                    isset($getAPPLanguageDetailsForUpload[$locale]['fileName']) &&
                    !file_exists($path)) {
                if (!copy(APPLICATION_PATH . DIRECTORY_SEPARATOR . '/application/modules/Siteiosapp/settings/Localizable.strings', $path)) {
                    
                }
            }

            /*
             * 1) Check if language available then overright the value. [Singular and Plural]
             * 
             * 2) If language not available then need to add that language in the bottom of the file. [Singular and Plural]
             */


            $explodeStringsToArray = !empty($getDefaultTranslatedLanguageArray) ? $getDefaultTranslatedLanguageArray : $this->_ExplodeStringsToArray($path, 1);
            //$valuesArray = $explodeStringsToArray; //$explodeStringsToArray['values'];
            $valuesArray = $explodeStringsToArray['values'] ? $explodeStringsToArray['values'] : $explodeStringsToArray;
            $pluralsKeyArray = $this->_ExplodeStringsToArray(APPLICATION_PATH . DIRECTORY_SEPARATOR . '/application/modules/Siteiosapp/settings/Localizable.strings', 1);
            $pluralsKeyArray = $pluralsKeyArray['pluralsKey'];
            foreach ($keys as $key => $value) {
                // For Singular
                if (!is_array($value))
                    $valuesArray[$value] = $values[$key];
                else
                    $valuesArray[$value[0]] = $values[$key];
            }

            // Set the plurals key.
            foreach ($valuesArray as $key => $value) {
                if (is_array($value)) {
                    $tempValuesArray = array();
                    foreach ($value as $tempKey => $tempValue) {
                        if (isset($pluralsKeyArray[$key][$tempKey]) && !empty($pluralsKeyArray[$key][$tempKey]))
                            $tempValuesArray[$pluralsKeyArray[$key][$tempKey]] = $tempValue;
                    }

                    if (!empty($tempValuesArray))
                        $valuesArray[$key] = $tempValuesArray;
                }
            }


            // Set the languages
            $this->_setArrayToStrings($path, $valuesArray);
            return $this->_redirect($this->view->url(array('module' => 'siteiosapp', 'controller' => 'app-builder', 'action' => 'create', 'tab' => 5), 'admin_default', false), array('prependBase' => false));


//            @chmod($path, 0777);
//            $myfile = @fopen($path, "r") or die("Unable to open " . $path . " file!");
//            // Output one line until end-of-file
//            while (!feof($myfile)) {
//                $rowContent = @fgets($myfile);
//                if (strstr($rowContent, $search)) {
//                    $tempArray[] = $value;
//                } else {
//                    if (!empty($rowContent))
//                        $tempArray[] = $rowContent;
//                }
//            }
//            @fclose($myfile);
//            // Try to write to a file
//            $targetFile = APPLICATION_PATH . '/application/languages/' . $locale . '/custom.csv';
//            if (!file_exists($targetFile)) {
//                touch($targetFile);
//                chmod($targetFile, 0777);
//            }
//
//            $writer = new Engine_Translate_Writer_Csv($targetFile);
//            $writer->setTranslations($combined);
//            $writer->write();
//
//            // flush cached language vars
//            @Zend_Registry::get('Zend_Cache')->clean();
//
//            // redirect to this same page to get the new values
//            return $this->_redirect($_SERVER['REQUEST_URI'], array('prependBase' => false));
        }
    }

    public function createAction() {
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteiosapp_admin_main', array(), 'siteiosapp_admin_app_create');

        $enabledTab = $this->_getParam('tab', 1);
        $this->view->subnavigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteiosapp_admin_appsetup_main', array(), $this->_enabledTabsArray[$enabledTab]);

        $this->view->doWeHaveLatestVersion = $doWeHaveLatestVersion = $this->_doWeHaveLatestVersion();

        if ($enabledTab == 5) {
            return $this->_forward('language-index', 'admin-app-builder', 'siteiosapp', array(
                        'tab' => $enabledTab,
                        'doWeHaveLatestVersion' => $doWeHaveLatestVersion
            ));
        }
        $this->view->formFields = $this->_formFields;
        if ($enabledTab == 6) {
            $enableAdvertisementModule = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitead');
            $this->view->subTab = $subTab = $this->_getParam('subTab', 1);
            $this->view->subsubnavigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteiosapp_admin_advertising', array(), $this->_advertisingEnabledTabsArray[$subTab]);
            if ($enableAdvertisementModule) {
                $multiOptions = array();
                $modules = Engine_Api::_()->getDbtable('modules', 'core')->getEnabledModuleNames();
                $enabledModules = array_intersect($this->_EnabledModules, $modules);
                foreach ($enabledModules as $module) {
                    $multiOptions[$module] = Engine_Api::_()->getDbTable('integrated', 'seaocore')->getModuleTitle($module);
                }

                $this->view->getEnabledModules = $multiOptions;
            } else {
                $this->view->errorMessage = $this->view->translate("Note: Please enable Advertisements, Community Ads & Marketing Campaigns Plugin by SocialApps.tech, so that Advertisement functions properly.");
            }
        } else if ($enabledTab == 2) {
            $this->view->subTab = $subTab = $this->_getParam('subTab', 1);
            $this->view->subsubnavigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteiosapp_admin_graphic_assets', array(), $this->_graphicEnabledTabsArray[$subTab]);
        }

        $this->view->tab = $enabledTab;

        $dontShowDownloadLink = false;
        $downloadTar = $this->_getParam('downloadTar', false);
        if (isset($downloadTar) && !empty($downloadTar))
            $this->view->downloadTar = true;

        // To check maximum file upload size.
        $upload_max_filesize = (int) @str_replace('M', '', @ini_get("upload_max_filesize"));
        if (isset($upload_max_filesize) &&
                !empty($upload_max_filesize) &&
                isset($this->_tarFileSize) &&
                !empty($this->_tarFileSize) &&
                $this->_tarFileSize > $upload_max_filesize
        ) {
            $this->view->showDownloadTip = true;
            $this->view->tarFileSize = $this->_tarFileSize;
            $this->view->upload_max_filesize = $upload_max_filesize;
        }

        $this->view->package = $package = $this->_getParam('package', null);
        $clientId = $this->_getParam('clientId', null);
        $clientEmail = $this->_getParam('email', null);

        // Validate subscription plane.
        if (empty($package)) {
            $getAvailableSubscriptionPlane = $this->validateSubscriptionPlane();
            if (is_array($getAvailableSubscriptionPlane)) {
                $getUserInfo = $getAvailableSubscriptionPlane[0];
                 unset($getUserInfo['email']);
                 unset($getUserInfo['clientId']);
                 $this->view->getUserInfo = $getUserInfo;
                if (COUNT($getUserInfo['subscriptionPlane']) == 1) {
                    $this->_helper->redirector->gotoRoute(array(
                        'package' => $getUserInfo['subscriptionPlane'][0],
                        'clientId' => $getUserInfo['clientId'],
                        'email' => $getUserInfo['email']
                    ));
                    return;
                }
            } else if (strstr($getAvailableSubscriptionPlane, 'error')) {
                $this->view->errorMessage = @str_replace("error::", "", $getAvailableSubscriptionPlane);
            }
        }

        // Set the app builder settings file url.
        $getAPPBuilderParentPath = APPLICATION_PATH . DIRECTORY_SEPARATOR
                . $this->_getAPPBuilderBaseURL;

        $getAPPBuilderSettingsFilePath = $getAPPBuilderParentPath . DIRECTORY_SEPARATOR
                . $this->_getAPPBuilderSettingsFileName;

        if (@file_exists($getAPPBuilderSettingsFilePath))
            include $getAPPBuilderSettingsFilePath;

        $this->view->form = $form = new Siteiosapp_Form_Admin_AppBuilder_Settings(array('doWeHaveLatestVersion' => $doWeHaveLatestVersion, 'enabledTabName' => $this->_enabledTabsArray[$enabledTab]));

        // Populate form
        if (!empty($_POST)) {
            $form->populate($_POST);
        } elseif (isset($appBuilderParams) && !empty($appBuilderParams)) {
            $this->view->appBuilderParams = $appBuilderParams; // Deepak
            $form->populate($appBuilderParams);
            $enableLivestreamingModule = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('livestreamingvideo');
            if($enableLivestreamingModule)
            {
                if ($form->getElement('agora_app_id'))
                    $form->agora_app_id->setValue(Engine_Api::_()->getApi('settings', 'core')->getSetting('livestreamingvideo.agora.app.id', ''));
                if ($form->getElement('live_stream_url'))
                    $form->live_stream_url->setValue(Engine_Api::_()->getApi('settings', 'core')->getSetting('livestreamingvideo.url', ''));
             }
        }

        // Set description for uploaded images.
        foreach ($this->_getAPPImageDetailsForUpload as $key => $values) {
            $imageType = '.png';
            if (in_array($key, $this->_dynamicImages) && isset($appBuilderParams['welcome_image_type']) && empty($appBuilderParams['welcome_image_type']))
                $imageType = '.gif';

            if (@file_exists(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $values['directoryName'] . '/' . $values['fileName'] . $imageType)) {

                $baseUrl = Zend_Controller_Front::getInstance()->getBaseUrl();
                $baseUrl = @trim($baseUrl, "/");
                $getHost = _ENGINE_SSL ? 'https://' . $_SERVER['HTTP_HOST'] . DIRECTORY_SEPARATOR . $baseUrl : 'http://' . $_SERVER['HTTP_HOST'] . DIRECTORY_SEPARATOR . $baseUrl;
                $getHost = @trim($getHost, "/");
                $getHost = str_replace("index.php/", "", $getHost);

                if ($imageType == '.gif') {
                    $filePath = $getHost . DIRECTORY_SEPARATOR
                            . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR
                            . $values['directoryName'] . DIRECTORY_SEPARATOR
                            . $values['fileName']
                            . '.gif';
                } else {
                    $filePath = $getHost . DIRECTORY_SEPARATOR
                            . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR
                            . $values['directoryName'] . DIRECTORY_SEPARATOR
                            . $values['fileName']
                            . '.png';
                }

                $tempWidth = $values['width'];
                $tempHeight = $values['height'];
                if (($values['width'] > 500)) {
                    $tempWidth = $values['width'] - 300;
                    $tempHeight = $values['height'] - 300;
                }
                $updatedFilePath = $filePath . '?imageversion=' . time();
                $description = "<a id='" . $key . "-show-hover' class='image-hover' href='" . $updatedFilePath . "' target='_blank'  ><i class='fa fa-picture-o'></i></a><img id='" . $key . "-hover' src='" . $updatedFilePath . "' '>";

                if (isset($form->$key)) {
                    $form->$key->setDescription($description);

                    $form->$key->getDecorator('Description')->setOptions(array('placement' => 'APPEND', 'escape' => false));
                }
            } else if (in_array($key, $this->_requiredFormImages)) {
                $dontShowDownloadLink = true;
            }
        }

        if (empty($dontShowDownloadLink)) {
            if (!empty($this->tabOneErrorDisplay) || $this->tabTwoErrorDisplay) {
                $dontShowDownloadLink = true;
            }
        }

        $this->view->requiredFormFields = array_merge($this->_requiredFormFields, $this->_requiredFormImages);
        $this->view->dynamicImages = $this->_dynamicImages;
        $this->view->quickImage = $imageUploadProcess = isset($appBuilderParams['image_upload_type']) ? $appBuilderParams['image_upload_type'] : 1;

        if (!empty($dontShowDownloadLink)) {
            if (empty($doWeHaveLatestVersion) && isset($form->download_text))
                $form->download_text->setLabel('<div class="seaocore_tip"><span>If you are unable to see "Download .tar" link, this means you have not filled all the form sections completely. Please check all the form sections and complete them as required.</span></div>');

            if (isset($form->download_tar)) {
                $form->removeElement('ios_app_rejection_confirmation');
                $form->removeElement('download_tar');
            }
        }
        
        
        if (@file_exists(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR .  '/' . 'GoogleService-Info.plist')) {
            $baseUrl = Zend_Controller_Front::getInstance()->getBaseUrl();
            $baseUrl = @trim($baseUrl, "/");
            $getHost = _ENGINE_SSL ? 'https://' . $_SERVER['HTTP_HOST'] . DIRECTORY_SEPARATOR . $baseUrl : 'http://' . $_SERVER['HTTP_HOST'] . DIRECTORY_SEPARATOR . $baseUrl;
            $getHost = @trim($getHost, "/");
            $getHost = str_replace("index.php/", "", $getHost);

            $filePath = $getHost . DIRECTORY_SEPARATOR
                    . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR
                    .  DIRECTORY_SEPARATOR
                    . 'GoogleService-Info.plist';
            $description = "This file is required for Push Notifications. To check uploaded file. Please <a href='" . $filePath . "' target='_blank'>click here</a>.";
            if (isset($form->firebase_google_services)) {
                $form->firebase_google_services->setDescription($description);
                $form->firebase_google_services->getDecorator('Description')->setOptions(array('placement' => 'PREPEND', 'escape' => false));
            }
        }
        

        $errors = array();
        if ($this->getRequest()->isPost()) {
            if ($package == 'pro') {
                $values = $this->getRequest()->getPost();

                if (isset($values['publish_app']) && empty($values['publish_app'])) {
                    $this->view->requiredFormFields = $this->_requiredFormFields = array_merge(array('phone_udid'), $this->_requiredFormFields);
                }

                $requireFieldsPro = array(
                    'apple_ios_developer_login_email',
                    'apple_ios_developer_login_password',
                );
                $this->_requiredFormFields = array_merge($requireFieldsPro, $this->_requiredFormFields);
            }
            $this->_requiredFormFields = array_diff($this->_requiredFormFields, array('ios_developer_account_details_credentials'));
            $this->_requiredFormFields = array_diff($this->_requiredFormFields, array('api_key'));
            $this->_requiredFormFields = array_merge(array('api_consumer_key', 'api_consumer_secret'), $this->_requiredFormFields);

            $this->_requiredFormFields = array_diff($this->_requiredFormFields, array('category'));
            $this->_requiredFormFields = array_merge(array('primary_category'), $this->_requiredFormFields);

            $formError = array();

            if (!empty($appBuilderParams))
                $values = array_merge($appBuilderParams, $values);
            
             $agoraKey = Engine_Api::_()->getApi('Core', 'siteiosapp')->getAgoraKey();
            if(!empty($agoraKey))
            {
                $values['agora_app_id'] = $agoraKey;
            }

            $primemessengerPublicKey = Engine_Api::_()->getApi('settings', 'core')->getSetting('primemessenger.publickey');
            if(!empty($primemessengerPublicKey))
            {   
                $values['pm_public_key'] = $primemessengerPublicKey;
            }
            
            if($values['live_stream_url']){
                 Engine_Api::_()->getApi('settings', 'core')->setSetting('livestreamingvideo_url', $values['live_stream_url']);
            }

            if (($enabledTab == 7) && (!isset($values['ios_app_rejection_confirmation']) || empty($values['ios_app_rejection_confirmation'])))
                $formError[] = "Common App Rejections - Field  is required";


            foreach ($this->_requiredFormFields as $element) {
                if (!isset($form->$element))
                    continue;

                if (!isset($values[$element]))
                    $formError[$element] = $form->$element->getLabel() . " - Field  is required";

                //Checks to manage UI of form
                if (($element == 'apple_ios_developer_login_email' || $element == 'apple_ios_developer_login_password') && empty($values[$element])) {
                    $formError['ios_developer_account_details_credentials'] = "iTunes account login details - Field  is required";
                }

                if (($element == 'apple_ios_developer_login_email' || $element == 'email_contact_details') && !empty($values[$element])) {

                    // Validate emails
                    $validate = new Zend_Validate_EmailAddress();

                    if (!$validate->isValid(trim($values[$element]))) {
                        $formError['apple_ios_developer_login_email'] = "iTunes account login details - Enter a valid Email Id";
                    }
                }

                if (in_array($element, array('siteapi_validate_ssl'))) {
                    if (!isset($values[$element]))
                        $formError['siteapi_validate_ssl'] = $form->$element->getLabel() . " - Field  is required";
                }else if (empty($values[$element])) {
                    $label = $form->$element->getLabel();

                    if (empty($form->$element->getLabel())) {
                        $elementName = str_replace("_", " ", $form->$element->getName());
                        $elementName = ucwords($elementName);
                        $formError[$element] = $elementName . " - Field  is required";
                    } else {
                        $formError[$element] = $form->$element->getLabel() . " - Field  is required";
                    }
                }

                if ($element == 'title' && !empty($values[$element])) {
                    $strLen = Engine_String::strlen($values[$element]);
                    $maxLength = 100;
                    if ($strLen >= $maxLength) {
                        $formError['title'] = $form->$element->getLabel() . " - Title should be less than 100 single-byte characters";
                    }
                }

                if ($element == 'description' && !empty($values[$element])) {
                    $strLen = Engine_String::strlen($values[$element]);
                    $maxLength = 4000;
                    if ($strLen >= $maxLength) {
                        $formError['description'] = $form->$element->getLabel() . " - Description should be less than 4000 single-byte characters";
                    }
                }
            }

            if (isset($values['small_font_size']) && !empty($values['small_font_size'])) {
                $element = "small_font_size";
                $smallFontSize = (double) $values['small_font_size'];
                if (empty($smallFontSize)) {
                    $formError['small_font_size'] = $form->$element->getLabel() . ' - Please enter a valid integer';
                }
            }

            if (isset($values['normal_font_size']) && !empty($values['normal_font_size'])) {
                $element = "normal_font_size";
                $normalFontSize = (double) $values['normal_font_size'];
                if (empty($normalFontSize)) {
                    $formError['normal_font_size'] = $form->$element->getLabel() . ' - Please enter a valid integer';
                }
            }

            if (isset($values['medium_font_size']) && !empty($values['medium_font_size'])) {
                $element = "medium_font_size";
                $mediumFontSize = (double) $values['medium_font_size'];
                if (empty($mediumFontSize)) {
                    $formError['medium_font_size'] = $form->$element->getLabel() . ' - Please enter a valid integer';
                }
            }

            if (isset($values['large_font_size']) && !empty($values['large_font_size'])) {
                $element = "large_font_size";
                $largeFontSize = (double) $values['large_font_size'];
                if (empty($largeFontSize)) {
                    $formError['large_font_size'] = $form->$element->getLabel() . ' - Please enter a valid integer';
                }
            }

            if (isset($values['rating']) && !empty($values['rating'])) {
                $getRating = $values['rating'];
                $getRating = (int) @str_replace("+", "", $getRating);
                if (empty($getRating)) {
                    $formError['rating'] = 'Please enter the correct Rating.';
                }

                if ($getRating < 12) {
                    if (Engine_Api::_()->getApi('settings', 'core')->getSetting('video.youtube.apikey')) {
                        $formError['rating'] = 'YouTube enabled on your website, rating should be atleast 12+';
                    }
                }
            }
            
                    if (isset($_FILES['firebase_google_services']["tmp_name"]) && !empty($_FILES['firebase_google_services']["tmp_name"])) {
                $firebaseFileName = APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . 'GoogleService-Info.plist';
                $jsonFileType = @pathinfo($firebaseFileName, PATHINFO_EXTENSION);
                if ($jsonFileType != "plist") {
                    $errors[] = 'Google Services File : Sorry, only json files are allowed.';
                }
                $isFileUpload = @move_uploaded_file($_FILES['firebase_google_services']["tmp_name"], APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . 'GoogleService-Info.plist');
                @chmod($firebaseFileName, 0777);
            }

            if (!@file_exists(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . '/' . 'GoogleService-Info.plist')) {
                $formError['firebase_google_services'] = 'Google Services File - File  is required';
            }

            if (isset($values['package_name']) && !empty($values['package_name'])) {
                $explodeArray = explode(".", $values['package_name']);
                if (COUNT($explodeArray) != 3) {
                    $formError['package_name'] = 'Please enter the correct App ID.';
                }
            }
            $this->createAPPBuilderDefaultDirectory();

            if (isset($values['facebook_app_id']) && !empty($values['facebook_app_id'])) {
                $isSocialDNAEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('socialdna');
                if (!empty($isSocialDNAEnabled)) {
                    $values['facebook_app_id'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('socialdna.facebook_api_key', null);
                    $values['facebook_app_secret'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('socialdna.facebook_secret', null);
                } else {
                    $values['facebook_app_id'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.facebook.appid', null);
                    $values['facebook_app_secret'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.facebook.secret', null);
                }

                if (empty($values['facebook_app_id']) || empty($values['facebook_app_secret']))
                    $formError['facebook_access_permission'] = 'Facebook Api or Secret not found. Please configure it from "Facebook Settings" page.';
            }else {
                $values['facebook_app_secret'] = $values['facebook_app_id'] = "";
            }

            $isSocialLoginEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitelogin');
            if ($isSocialLoginEnabled) {
                if (isset($values['google_app_id']) && !empty($values['google_app_id'])) {
                    
                    $values['google_app_id'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitelogin.google.clientId', null);
                    $values['google_app_secret'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitelogin.google.clientSecret', null);

                    if (empty($values['google_app_id']) || empty($values['google_app_secret']))
                        $formError['google_app_id'] = 'Google Client Id or Secret not found. Please configure it from "Social Integrations" page of Social Login and Signup Plugin.';
                } else {
                    $values['google_app_secret'] = $values['google_app_id'] = "";
                }
            } else {
                $values['google_app_secret'] = $values['google_app_id'] = "";
            }

            if (isset($values['apple_app_id']) && !empty($values['apple_app_id']))
                $values['apple_app_id'] = 1;
            else
                $values['apple_app_id'] = 0;

            if (!empty($package))
                $values['package'] = $package;

            if (!empty($clientId))
                $values['clientId'] = $clientId;

            if (!empty($clientEmail))
                $values['email'] = $clientEmail;

            $getHost = (isset($values['siteapi_validate_ssl']) && !empty($values['siteapi_validate_ssl'])) ? 'https://' . $_SERVER['HTTP_HOST'] : 'http://' . $_SERVER['HTTP_HOST'];
            $siteHost = $this->view->url(array(), 'home', false);
            $values['api_calling_url'] = $getHost . $siteHost . 'api/rest/';
            $splashImagesType = isset($values['welcome_image_type']) ? $values['welcome_image_type'] : 1;

            // Validate consumer key
            $consumerTable = Engine_Api::_()->getDbtable('consumers', 'siteapi');
            $select = $consumerTable->getSelect(array('key' => $values['api_consumer_key'], 'secret' => $values['api_consumer_secret']));
            $getRow = $consumerTable->fetchRow($select);
            if (empty($getRow))
                $formError['api_key'] = 'Please enter correct `API Consumer Key` and `API Consumer Secret`.';

            if (!empty($formError) && $enabledTab == 1) {
                $this->view->formError = $formError;
                $this->_subTabError[] = array('ios_developer_account_details_credentials');
                return $form->addErrors($formError);
            }

//Start Primemessenger Code
            if ($enabledTab == 1 && isset($values['enable_primemessenger']) && !empty($values['enable_primemessenger'])) {
                $channelizeVersion = $values['channelize_version'];
                $messengerDetails = $this->savePrimemessengerFiles($channelizeVersion);
                if (!empty($messengerDetails) && is_array($messengerDetails)) {
                    $values = array_merge($values, $messengerDetails);
                }
            }
            //End Primemessenger Work

            try {
                // Set the values in settings file.
                if ((is_file($getAPPBuilderSettingsFilePath) && is_writable($getAPPBuilderSettingsFilePath)) ||
                        (is_dir(dirname($getAPPBuilderSettingsFilePath)) && is_writable(dirname($getAPPBuilderSettingsFilePath)))) {

                    if (!empty($values)) {

                        if ($enabledTab == '3') {
                            $app_dashboard_menu_setting = $values['app_dashboard_menu_setting'];
                            if ($app_dashboard_menu_setting) {
                                $menusTable = Engine_Api::_()->getDbtable('menus', 'siteiosapp');
                                if(empty($values['default_dashboard']))
                                {
                                    $select = $menusTable->select()
                                            ->from($menusTable->info('name'), array('menu_id', 'module', 'name', 'dashboard_label', 'params'))
                                    ->where("menu_id = ?", $values['secondController']);
                                
                                }
                                else
                                {
                                    $select = $menusTable->select()
                                            ->from($menusTable->info('name'), array('menu_id', 'module', 'name', 'dashboard_label', 'params'))
                                    ->where("name = ?", 'core_mini_friend_request');
                                }

                                $result = $select->query()->fetchALL();

                                if (!empty($result)) {
                                    $values['secondControllerName'] = $result[0]['dashboard_label'];
                                    $values['secondController'] = $result[0]['menu_id'];
                                    $values['secondControllermenuname'] = $result[0]['name'];

                                    if ($result[0]['module'] == 'sitereview') {
                                        $params = unserialize($result[0]['params']);
                                        $values['secondControllerListingTypeId'] = $params['listingtype_id'];
                                    } elseif (isset($values['secondControllerListingTypeId']))
                                        unset($values['secondControllerListingTypeId']);
                                }

                                // For Third Controller
                                 if(empty($values['default_dashboard']))
                                {
                                    $select = $menusTable->select()
                                            ->from($menusTable->info('name'), array('menu_id', 'module', 'name', 'dashboard_label', 'params'))
                                            ->where("menu_id = ?", $values['thirdController']);
                                }
                                else
                                {
                                    $select = $menusTable->select()
                                            ->from($menusTable->info('name'), array('menu_id', 'module', 'name', 'dashboard_label', 'params'))
                                            ->where("name = ?", 'core_mini_messages');
                                }

                                $result = $select->query()->fetchALL();

                                if (!empty($result)) {
                                    $values['thirdControllerName'] = $result[0]['dashboard_label'];
                                    $values['thirdController'] = $result[0]['menu_id'];
                                    $values['thirdControllermenuname'] = $result[0]['name'];

                                    if ($result[0]['module'] == 'sitereview') {
                                        $params = unserialize($result[0]['params']);
                                        $values['thirdControllerListingTypeId'] = $params['listingtype_id'];
                                    } elseif (isset($values['thirdControllerListingTypeId']))
                                        unset($values['thirdControllerListingTypeId']);
                                }

                                 if(empty($values['default_dashboard']))
                                {
                                    $select = $menusTable->select()
                                            ->from($menusTable->info('name'), array('menu_id', 'module', 'name', 'dashboard_label', 'params'))
                                            ->where("menu_id = ?", $values['fourthController']);
                                }
                                else
                                {
                                    $select = $menusTable->select()
                                            ->from($menusTable->info('name'), array('menu_id', 'module', 'name', 'dashboard_label', 'params'))
                                            ->where("name = ?", 'core_mini_notification');
                                }
                                

                                $result = $select->query()->fetchALL();

                                if (!empty($result)) {
                                    $values['fourthControllerName'] = $result[0]['dashboard_label'];
                                    $values['fourthController'] = $result[0]['menu_id'];
                                    $values['fourthControllermenuname'] = $result[0]['name'];

                                    if ($result[0]['module'] == 'sitereview') {
                                        $params = unserialize($result[0]['params']);
                                        $values['fourthControllerListingTypeId'] = $params['listingtype_id'];
                                    } elseif ($values['fourthControllerListingTypeId'])
                                        unset($values['fourthControllerListingTypeId']);
                                }
                            }
                        }

                        if($appBuilderParams['slide_show_type'] == 1)
                        {       
                            $getAPPBuilderParentPath = APPLICATION_PATH . DIRECTORY_SEPARATOR
                . $this->_getAPPBuilderBaseURL; 

                            $imageFolderPath = $getAPPBuilderParentPath.'/Slideshow_Images/Big_Images_Tablet 1242 x 2208/';
                    
               
                            $files = glob($imageFolderPath . '*.*');

                            if ( $files !== false )
                            {
                                $total_count = count( $files );
                                $values['total_slideshow_images'] = $total_count;
                            }
                            else
                            {
                                $values['total_slideshow_images'] = 0;
                            }
                        }
                        $file_contents = "<?php ";
                        $file_contents .= '$appBuilderParams = ';
                        $file_contents .= var_export($values, true);
                        $file_contents .= " ?>";
                        @file_put_contents($getAPPBuilderSettingsFilePath, $file_contents);
                        $successMessage = 'Your changes have been saved successfully. Now please download the "tar file" and follow the given instructions, to get started with your APP creation.';
                    }
                } else {
                    return $form->addError('Unable to configure this setting due to the file ' . $getAPPBuilderSettingsFilePath . ' not having the correct permissions. Please CHMOD (change the permissions of) that file to 666, then try again.');
                }

                $controllerDefaultImage = isset($values["default_dashboard"]) ? $values["default_dashboard"] : 1;
                $slideshowType = $appBuilderParams['slide_show_type'];

                if (isset($imageUploadProcess) && !empty($imageUploadProcess)) {
                    $errors = $this->uploadMainImageBeforeQuick($splashImagesType, $enabledTab, $subTab, $app_dashboard_menu_setting, $controllerDefaultImage, $slideshowType);
                    if (empty($errors)) {
                        $errors = $this->uploadImageQuick($splashImagesType, $enabledTab, $subTab);
                    } else {
                        // Display errors
                        if ($enabledTab == 2) {
                            $this->view->formError = $errors;
                            return $form->addErrors($errors);
                        }
                        return;
                    }
                }

                // Upload the selected image
                foreach ($this->_getAPPImageDetailsForUpload as $key => $values) {
                    // If image not uploaded by siteadministrator then check, is that image already uploaded? IF not then through error message.
                    if (empty($_FILES[$key]["tmp_name"])) {
                        if (in_array($key, $this->_dynamicImages) && isset($splashImagesType) && empty($splashImagesType)) {
                            if (@file_exists(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $values['directoryName'] . '/' . $values['fileName'] . '.gif')) {
                                continue;
                            }
                        } else {
                            if (@file_exists(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $values['directoryName'] . '/' . $values['fileName'] . '.png'))
                                continue;
                        }

                        $continueOrShowError = $this->getImageError($enabledTab, $subTab, $key, $app_dashboard_menu_setting, $controllerDefaultImage, $slideshowType);

                        if (empty($continueOrShowError))
                            continue;

                        $errors[$key] = $values['title'] . ': Image not found.';
                        continue;
                    }

                    // In case: IF image uploaded by siteadministrator.
                    if (isset($_FILES[$key]) && !empty($_FILES[$key])) {
                        // Validate: file type
                        $check = @getimagesize($_FILES[$key]["tmp_name"]);
                        if ($check === false) {
                            $errors[$key] = $values['title'] . ': File is not an image.';
                            continue;
                        }

                        // Validate: image extension
                        $target_file = @basename($_FILES[$key]["name"]);
                        $imageFileType = @pathinfo($target_file, PATHINFO_EXTENSION);

                        //GIF Images Work Start
                        if (in_array($key, $this->_dynamicImages) && isset($splashImagesType) && empty($splashImagesType)) {
                            if ($imageFileType != "gif") {
                                $errors[$key] = $values['title'] . ': You have selected GIF image type for splash screen, so please choose GIF files.';
                                continue;
                            }
                        } else {
                            if (in_array($key, $this->_dynamicImages) && $imageFileType != "png") {
                                $errors[$key] = $values['title'] . ': You have selected PNG image type for splash screen, so please choose PNG files.';
                                continue;
                            } else if ($imageFileType != "png") {
                                $errors[$key] = $values['title'] . ': Sorry, only PNG files are allowed.';
                                continue;
                            }
                        }
                        //GIF Images Work End
                        // Validate: image width and height

                        if (($check[0] !== $values['width']) && ($check[1] !== $values['height'])) {
                            $errors[$key] = $values['title'] . ': Please upload ' . $values['width'] . ' x ' . $values['height'] . ' pixels image.';
                            continue;
                        }

                        // Validate file size
                        // 1MB => 1000000BYTES
                        if ($_FILES[$key]["size"] > 1000000) {
                            $errors[$key] = $values['title'] . ': The uploaded file size has been increased, please upload the image(s) less then 1MB';
                            continue;
                        }

                        // Validate: authrization permission
                        $isImageUpload = @move_uploaded_file($_FILES[$key]["tmp_name"], APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $values['directoryName'] . '/' . $values['fileName'] . '.' . $imageFileType);
                        if (empty($isImageUpload)) {
                            $errors[$key] = $values['title'] . ': Not able to upload image. Please give 777 permission to /public/' . $this->_directoryName . ' directory.';
                            continue;
                        }
                    }
                }

                // Details for language File to be uploaded
                $getLanguagesFiles = $this->_getAPPLanguageDetailsForUpload();

                // Upload the selected languages
                foreach ($getLanguagesFiles as $key => $values) {

                    // In case: IF language file is uploaded by siteadministrator.
                    if (isset($_FILES[$key]["tmp_name"]) && !empty($_FILES[$key]["tmp_name"])) {

                        // Validate: language fle extension
                        $target_file = @basename($_FILES[$key]["name"]);
                        $languageFileType = @pathinfo($target_file, PATHINFO_EXTENSION);
                        if ($languageFileType != "csv") {
                            $errors[] = $values['title'] . ': Sorry, only CSV files are allowed.';
                            continue;
                        }

                        $isLanguageUpload = @move_uploaded_file($_FILES[$key]["tmp_name"], APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $values['directoryName'] . '/' . $values['fileName'] . '.' . $languageFileType);

                        if (empty($isLanguageUpload)) {
                            $errors[$key] = $values['title'] . ': Not able to upload language file. Please give 777 permission to /public/' . $this->_directoryName . ' directory.';
                            continue;
                        }
                    }
                }
            } catch (Exception $ex) {
                throw $ex;
            }

            // Display errors
            if (!empty($errors)) {
                if ($enabledTab == 2 || $enabledTab == 3) {
                    $this->view->formError = $errors;
                    return $form->addErrors($errors);
                }

                return;
            } else if ($enabledTab == 8) {
                $this->_helper->redirector->gotoRoute(array('tab' => 7));
                return;
            } else if ($enabledTab == 3) {
                $this->_helper->redirector->gotoRoute(array('tab' => 5));
                return;
            } else if ($enabledTab == 6 && isset($subTab) && !empty($subTab) && $subTab == 1) {
                $this->_helper->redirector->gotoRoute(array('tab' => $enabledTab, 'subTab' => ++$subTab));
                return;
            } else if ($enabledTab == 2 && isset($subTab) && !empty($subTab) && ($subTab == 1 || $subTab == 2)) {
                $this->_helper->redirector->gotoRoute(array('tab' => $enabledTab, 'subTab' => ++$subTab));
                return;
            } else if ($enabledTab == 2 && isset($subTab) && !empty($subTab) && ($subTab == 3)) {
                $this->_helper->redirector->gotoRoute(array('tab' => ++$enabledTab));
                return;
            } else {
                if ($enabledTab < 5) {
                    $this->_helper->redirector->gotoRoute(array('tab' => ++$enabledTab));
                    return;
                }
            }
        }

        if (!empty($successMessage))
            $form->addNotice($successMessage);
    }

    public function downloadAction() {
        $this->view->package = $this->_getParam('package', false);
        $this->view->clientId = $this->_getParam('clientId', false);
        $this->view->email = $this->_getParam('email', false);

        if (!$_POST)
            return;

        $this->view->redirectToCreateForm = true;
    }

    public function downloadTarAction() {
        if (!class_exists('DOMDocument', false))
            return $form->addError('Bad PHP version.');

        $createZipSuccessfully = $this->createZip(APPLICATION_PATH . '/public/' . $this->_directoryName . '/');

        if (!empty($createZipSuccessfully)) {
            $path = $tarFilePath = APPLICATION_PATH . DIRECTORY_SEPARATOR
                    . 'public' . DIRECTORY_SEPARATOR
                    . $this->_getAPPBuilderTarFileName;

            if (file_exists($path) && is_file($path)) {
                // Kill zend's ob
                while (ob_get_level() > 0) {
                    ob_end_clean();
                }

                $this->_tarFileSize = filesize($path);
                $this->_tarFileSize = $this->_formatBytes($this->_tarFileSize);
                $this->_tarFileSize = (int) @ceil($this->_tarFileSize);

                header("Content-Disposition: attachment; filename=" . urlencode(basename($path)), true);
                header("Content-Transfer-Encoding: Binary", true);
                header("Content-Type: application/force-download", true);
                header("Content-Type: application/octet-stream", true);
                header("Content-Type: application/download", true);
                header("Content-Description: File Transfer", true);
                header("Content-Length: " . filesize($path), true);
                flush();

                $fp = fopen($path, "r");
                while (!feof($fp)) {
                    echo fread($fp, 65536);
                    flush();
                }
                fclose($fp);
            }
            exit();
        }
    }

    /*
     * app rejection faq
     */
    public function appRejectionFaqAction() {
        
    }

    /*
     * creates a compressed tar file  
     */
    protected function createZip() {
        $uploadToTar = APPLICATION_PATH . DIRECTORY_SEPARATOR
                . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR;

        $tarFileParentPath = APPLICATION_PATH . DIRECTORY_SEPARATOR
                . 'public' . DIRECTORY_SEPARATOR;

        $tarFilePath = $tarFileParentPath . $this->_getAPPBuilderTarFileName;

        // Create the root directory, If not exist.        
        $is_dir = @is_dir($tarFileParentPath);
        if (empty($is_dir))
            @mkdir($tarFileParentPath);

        @chmod($tarFileParentPath, 0777);
        @chmod($uploadToTar, 0777);
        @chmod($tarFilePath, 0777);

        // Create the archive
        $zip = new Archive_Tar($tarFilePath);

        // Remove uploaded tar file first.
        @unlink($tarFilePath);

        $getArray = APPLICATION_PATH . '/public/' . $this->_directoryName . '/';

        // Add content into tar file.
        $zip->addModify(array($uploadToTar), '', APPLICATION_PATH . '/public/');
        @chmod($tarFilePath, 0777);

        //check to make sure the file exists
        return file_exists($tarFilePath);
    }

    /*
     * End point to validate website authorization.
     */
    protected function validateSubscriptionPlane() {
        $apiURL = 'https://www.socialengineaddons.com/check-subscriptions-endpoint';
        $website = str_replace('www.', '', strtolower($_SERVER['HTTP_HOST']));
        $tempAdminMenuPost = array(
            'websites' => serialize(
                    array(
                        $website
                    )
            )
        );

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $apiURL);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $tempAdminMenuPost);
        ob_start();
        curl_exec($ch);
        curl_close($ch);
        $getCurlResponse = ob_get_contents();
        ob_end_clean();

        if (strstr($getCurlResponse, 'error::'))
            return $getCurlResponse;

        $getCurlResponse = unserialize($getCurlResponse);

        $getResult = $enabledPlan = array();
        if (isset($getCurlResponse[$website])) {
            $getWebsitePlans = $getCurlResponse[$website];
            foreach ($getWebsitePlans as $planObj) {

                if (($planObj->title == 'Mobile Pro Plan') || ($planObj->title == 'Mobile Apps Plan') || ($planObj->title == 'Premium Plan') || ($planObj->title == 'Mobile Apps - Product Support and App Upgrade Support'))
                    $enabledPlan[] = 'pro';

                if ($planObj->title == 'Mobile Starter Plan')
                    $enabledPlan[] = 'starter';


                if (empty($getResult) && (($planObj->title == 'Mobile Pro Plan') || ($planObj->title == 'Mobile Apps - Product Support and App Upgrade Support') || ($planObj->title == 'Mobile Apps Plan') || ($planObj->title == 'Premium Plan') || ($planObj->title == 'Mobile Starter Plan'))) {
                    $getResult['clientId'] = $planObj->uid;
                    $getResult['email'] = $planObj->mail;
                }
            }

            if (!empty($getResult) && !empty($enabledPlan))
                $getResult['subscriptionPlane'] = $enabledPlan;
        }

        if (!empty($getResult))
            return array($getResult);
        else
            return 'error::There are problem to get your subscription plan record. Please configure your Mobile Apps Subscription Plan from the <a href="https://www.socialengineaddons.com/page/steps-follow-before-filing-support-ticket-mobile-apps-setup" target="_blank">"Subscriptions / Recurring Fees"</a> section of your SocialEngineAddOns Client Area. You can login from here to configure your subscription. If you still have any problem then contact to SocialEngineAddOns support team.';
    }

    /*
     * Create blank directory in case, if not exist on server.
     */
    protected function createAPPBuilderDefaultDirectory() {
        $getAPPBuilderParentPath = APPLICATION_PATH . DIRECTORY_SEPARATOR
                . $this->_getAPPBuilderBaseURL;

        if (!@is_dir($getAPPBuilderParentPath))
            @mkdir($getAPPBuilderParentPath);

        @chmod($getAPPBuilderParentPath, 0777);

        if (!@is_dir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'App_Icons')) {
            @mkdir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'App_Icons');
            @chmod($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'App_Icons', 0777);
        }

        if (!@is_dir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Large_App_Icon')) {
            @mkdir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Large_App_Icon');
            @chmod($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Large_App_Icon', 0777);
        }

        if (!@is_dir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Splash_Screen_Images')) {
            @mkdir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Splash_Screen_Images');
            @chmod($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Splash_Screen_Images', 0777);
        }

        if (!@is_dir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Splash_Screen_Images' . DIRECTORY_SEPARATOR . 'Iphone')) {
            @mkdir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Splash_Screen_Images' . DIRECTORY_SEPARATOR . 'Iphone');
            @chmod($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Splash_Screen_Images' . DIRECTORY_SEPARATOR . 'Iphone', 0777);
        }

        if (!@is_dir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Splash_Screen_Images' . DIRECTORY_SEPARATOR . 'Ipad')) {
            @mkdir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Splash_Screen_Images' . DIRECTORY_SEPARATOR . 'Ipad');
            @chmod($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Splash_Screen_Images' . DIRECTORY_SEPARATOR . 'Ipad', 0777);
        }

        if (!@is_dir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Splash_Screen_Images' . DIRECTORY_SEPARATOR . 'Iphone' . DIRECTORY_SEPARATOR . 'Landscape')) {
            @mkdir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Splash_Screen_Images' . DIRECTORY_SEPARATOR . 'Iphone' . DIRECTORY_SEPARATOR . 'Landscape');
            @chmod($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Splash_Screen_Images' . DIRECTORY_SEPARATOR . 'Iphone' . DIRECTORY_SEPARATOR . 'Landscape', 0777);
        }

        if (!@is_dir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Splash_Screen_Images' . DIRECTORY_SEPARATOR . 'Iphone' . DIRECTORY_SEPARATOR . 'Portrait')) {
            @mkdir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Splash_Screen_Images' . DIRECTORY_SEPARATOR . 'Iphone' . DIRECTORY_SEPARATOR . 'Portrait');
            @chmod($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Splash_Screen_Images' . DIRECTORY_SEPARATOR . 'Iphone' . DIRECTORY_SEPARATOR . 'Portrait', 0777);
        }

        if (!@is_dir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Splash_Screen_Images' . DIRECTORY_SEPARATOR . 'Ipad' . DIRECTORY_SEPARATOR . 'Landscape')) {
            @mkdir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Splash_Screen_Images' . DIRECTORY_SEPARATOR . 'Ipad' . DIRECTORY_SEPARATOR . 'Landscape');
            @chmod($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Splash_Screen_Images' . DIRECTORY_SEPARATOR . 'Ipad' . DIRECTORY_SEPARATOR . 'Landscape', 0777);
        }

        if (!@is_dir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Splash_Screen_Images' . DIRECTORY_SEPARATOR . 'Ipad' . DIRECTORY_SEPARATOR . 'Portrait')) {
            @mkdir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Splash_Screen_Images' . DIRECTORY_SEPARATOR . 'Ipad' . DIRECTORY_SEPARATOR . 'Portrait');
            @chmod($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Splash_Screen_Images' . DIRECTORY_SEPARATOR . 'Ipad' . DIRECTORY_SEPARATOR . 'Portrait', 0777);
        }

        if (!@is_dir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Slideshow_Images')) {
            @mkdir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Slideshow_Images');
            @chmod($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Slideshow_Images', 0777);
        }

        if (!@is_dir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Slideshow_Images' . DIRECTORY_SEPARATOR . 'Big_Images_Tablet 1242 x 2208')) {
            @mkdir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Slideshow_Images' . DIRECTORY_SEPARATOR . 'Big_Images_Tablet 1242 x 2208');
            @chmod($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Slideshow_Images' . DIRECTORY_SEPARATOR . 'Big_Images_Tablet 1242 x 2208', 0777);
        }

        if (!@is_dir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Slideshow_Images' . DIRECTORY_SEPARATOR . 'Medium_Images_Tablet 750 x 1334')) {
            @mkdir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Slideshow_Images' . DIRECTORY_SEPARATOR . 'Medium_Images_Tablet 750 x 1334');
            @chmod($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Slideshow_Images' . DIRECTORY_SEPARATOR . 'Medium_Images_Tablet 750 x 1334', 0777);
        }

        if (!@is_dir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Slideshow_Images' . DIRECTORY_SEPARATOR . 'Plain_Slideshow 512 x 512')) {
            @mkdir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Slideshow_Images' . DIRECTORY_SEPARATOR . 'Plain_Slideshow 512 x 512');
            @chmod($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Slideshow_Images' . DIRECTORY_SEPARATOR . 'Plain_Slideshow 512 x 512', 0777);
        }

        if (!@is_dir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Slideshow_Images' . DIRECTORY_SEPARATOR . 'Small_Images_Mobile 640 x 1136')) {
            @mkdir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Slideshow_Images' . DIRECTORY_SEPARATOR . 'Small_Images_Mobile 640 x 1136');
            @chmod($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Slideshow_Images' . DIRECTORY_SEPARATOR . 'Small_Images_Mobile 640 x 1136', 0777);
        }

        if (!@is_dir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Languages_App')) {
            @mkdir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Languages_App');
            @chmod($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Languages_App', 0777);
        }

        // Create settings file.
        $ourFileName = $getAPPBuilderParentPath . DIRECTORY_SEPARATOR . "settings.php";
        if (!is_file($ourFileName)) {
            $ourFileHandle = @fopen($ourFileName, 'w');
            @fclose($ourFileHandle);
            @chmod($ourFileName, 0777);
        }

        return;
    }

    /*
     * Get default available languages.
     */
    private function _getAPPLanguageDetailsForUpload() {
        $getLanguages = Engine_Api::_()->getApi('Core', 'siteapi')->getLanguages(true);
        if (isset($getLanguages)) {
            $languageArray = array();
            foreach ($getLanguages as $key => $label) {
                $languageArray[$key] = array(
                    'title' => 'Upload Language File For: [' . $label . ']',
                    'directoryName' => 'Languages_App',
                    'fileName' => $key . '_language_ios_mobileapp'
                );
            }
        }

        return $languageArray;
    }

    private function _formatBytes($size, $precision = 2) {
        $base = log($size, 1024);
        $suffixes = array('');

        return round(pow(1024, $base - floor($base)), $precision) . $suffixes[floor($base)];
    }

    private function _doWeHaveLatestVersion() {
        $errorInPlugins = array();
        $pluginsArray = array(
            'seaocore' => 'seaddons-core',
            'siteapi' => 'siteapi',
            'siteiosapp' => 'sitemobileiosapp',
            'siteandroidapp' => 'sitemobileandroidapp',
            'advancedactivity' => 'advancedactivity',
            'sitetagcheckin' => 'sitetagcheckin'
        );

        if ($_COOKIE['getMobileDependentModulesList']) {
            $tempValues = unserialize($_COOKIE['getMobileDependentModulesList']);
        } else {
            $rss = Zend_Feed::import('http://www.socialengineaddons.com/plugins/feed');
            $channel = array(
                'title' => $rss->title(),
                'link' => $rss->link(),
                'description' => $rss->description(),
                'items' => array()
            );
            $tempValues = $flagArray = array();
            foreach ($rss as $item) {
                if (in_array($item->ptype(), $pluginsArray)) {
                    $flagArray['productType'] = $item->ptype();
                    $flagArray['availableVersion'] = $item->version();
                    $flagArray['title'] = $item->title();
                    $tempValues[] = $flagArray;
                }
            }

            $cookieData = @serialize($tempValues);
            setcookie("getMobileDependentModulesList", $cookieData, time() + 86400);
        }

        foreach ($tempValues as $values) {
            if (in_array($values['productType'], $pluginsArray)) {
                $flipedArray = array_flip($pluginsArray);
                if (!Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled($flipedArray[$values['productType']]))
                    continue;

                $getModVersion = Engine_Api::_()->getDbtable('modules', 'core')->getModule($flipedArray[$values['productType']]);
                $isModSupport = $this->_checkVersion($getModVersion->version, $values['availableVersion']);
                if (!empty($isModSupport)) {
                    $errorInPlugins[] = $values['title'];
                }
            }
        }

        return $errorInPlugins;
    }

    private function _checkVersion($databaseVersion, $checkDependancyVersion) {
        $running_version = $databaseVersion;
        $product_version = $checkDependancyVersion;
        $shouldUpgrade = false;
        if (!empty($running_version) && !empty($product_version)) {
            $temp_running_verion_2 = $temp_product_verion_2 = 0;
            if (strstr($product_version, "p")) {
                $temp_starting_product_version_array = @explode("p", $product_version);
                $temp_product_verion_1 = $temp_starting_product_version_array[0];
                $temp_product_verion_2 = $temp_starting_product_version_array[1];
            } else {
                $temp_product_verion_1 = $product_version;
            }
            $temp_product_verion_1 = @str_replace(".", "", $temp_product_verion_1);


            if (strstr($running_version, "p")) {
                $temp_starting_running_version_array = @explode("p", $running_version);
                $temp_running_verion_1 = $temp_starting_running_version_array[0];
                $temp_running_verion_2 = $temp_starting_running_version_array[1];
            } else {
                $temp_running_verion_1 = $running_version;
            }
            $temp_running_verion_1 = @str_replace(".", "", $temp_running_verion_1);


            if (($temp_running_verion_1 < $temp_product_verion_1) || (($temp_running_verion_1 == $temp_product_verion_1) && ($temp_running_verion_2 < $temp_product_verion_2))) {
                $shouldUpgrade = true;
            }
        }
        return $shouldUpgrade;
    }

    /*
     * Explode existing string file to array
     */
    private function _ExplodeStringsToArray($path, $getPluralKeys = false) {
        @chmod($path, 0777);
        $myfile = @fopen($path, "r") or die("Unable to open " . $path . " file!");
        while (!feof($myfile)) {
            $flagStr = '';
            $flagStrArray = array();
            $rowContent = @fgets($myfile);
            if (!empty($rowContent)) {
                for ($flag = 1; $flag < strlen($rowContent) - 3; $flag++) {
                    $flagStr .= $rowContent[$flag];
                }

                // Replace string for different pattern.
                $flagStr = @str_replace('" = "', '::=::', $flagStr);
                $flagStr = @str_replace('"= "', '::=::', $flagStr);
                $flagStr = @str_replace('" ="', '::=::', $flagStr);
                $flagStr = @str_replace('"="', '::=::', $flagStr);

                $flagStrArray = @explode("::=::", $flagStr);
                $flagStrArray[1] = @str_replace('"', '', $flagStrArray[1]);
                if (!empty($flagStrArray) && !empty($flagStrArray[0]) && !empty($flagStrArray[1]))
                    $tempArray[(string) $flagStrArray[0]] = (string) $flagStrArray[1];
            }
        }
        @fclose($myfile);

        if (!empty($tempArray))
            return $tempArray;
    }

    /*
     * Set array to string
     */
    protected function _setArrayToStrings($path, $values) {
        $explodeDefaultStringsToArray = $this->_ExplodeStringsToArray(APPLICATION_PATH . '/application/modules/Siteiosapp/settings/Localizable.strings');

//        $content = '<resources>';
        $flagStringArray = array();
        foreach ($values as $key => $value) {
            // Key's if not exist in newly added "Localizable.strings" file then not include it now.
            if (!array_key_exists($key, $explodeDefaultStringsToArray))
                continue;

            $flagStringArray[$key] = '"' . $key . '" = "' . $value . '";';
        }

        $content .= @implode("\n", $flagStringArray);
        // Remove unwanted space and blank lines from the string.
        $content = @preg_replace("/(^[\r\n]*|[\r\n]+)[\s\t]*[\r\n]+/", "\n", $content);
//        $content = str_replace("><", ">\n<", $content);

        if (@file_exists($path)) {
            @chmod($path, 0777);
            if (is_writable($path)) {
                if (!empty($content)) {
                    $fh = fopen($path, 'w') or die("can't open file");
                    @fwrite($fh, $content);
                    @fclose($fh);
                }
            }
        }

        return;
    }

    /*
     * Function to convert csv file to Strings File
     */
    private function _modifyExistingLanguageStrings($fromFilePath, $destinationPath = null) {
        @chmod($fromFilePath, 0777);
        @chmod($destinationPath, 0777);

        if (@file_exists($fromFilePath)) {
            if (($handle = @fopen($fromFilePath, "r")) !== FALSE) {
                while (($data = fgetcsv($handle, 100000, ";")) !== FALSE) {
                    $count = COUNT($data);

                    // Check for comments, blank line and empty string
                    if (!isset($data[0]) || empty($data[0]) || $count < 2 || $data[0] == '#')
                        continue;

                    if ($count == 2)
                        $dataArray[$data[0]] = (string) $data[1];
                }
            }

            // Ceate destination file, If not exist.
            if (!file_exists($destinationPath)) {
                @fopen($destinationPath, "w");
                @fclose($myfile);
                @chmod($destinationPath, 0777);
            }

            // Write in newly created string file.
            if (!empty($dataArray))
                $this->_setArrayToStrings($destinationPath, $dataArray);

            @chmod($destinationPath, 0777);
        }

        return;
    }

    protected function _searchArrayRecursive($searchStr, $searchValue) {
        $found = false;
        if (is_array($searchValue)) {
            foreach ($searchValue as $key => $value) {
                if (is_string($value) && stripos($value, $searchStr) !== false) {
                    $found = true;
                    break;
                } else if (is_array($value)) {
                    if ($this->_searchArrayRecursive($searchStr, $value)) {
                        $found = true;
                        break;
                    }
                }
            }
        }

        return $found;
    }

    public function getmoduleAction() {
        $menusTable = Engine_Api::_()->getDbtable('menus', 'siteiosapp');
        $select = $menusTable->select()
                ->from($menusTable->info('name'), array('menu_id', 'name', 'module', 'url'))
                ->where("status = ?", 1);

        $result = $select->query()->fetchALL();
        $data = array();
        foreach ($result as $row => $value)
            $data[$value['menu_id']] = array('module' => $value['module'], 'url' => $value['url'], 'name' => $value['name']);

        echo Zend_Json_Encoder::encode($data);
        die;
    }

    public function savePrimemessengerFiles($channelizeVersion = 0) {
        $apiKey = Engine_Api::_()->getApi('settings', 'core')->getSetting('primemessenger.apikey', '');
        $messengerDetails = array();
       
        if(empty($channelizeVersion))
            $apiURL = 'https://api.channelize.io/v1/settings';
        else
            $apiURL = 'https://api.channelize.io/v2/settings';

        $website = str_replace('www.', '', $apiURL);
        $auth = 'Basic ' . base64_encode($apiKey);
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $website);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array(
            "authorization: $auth",
        ));
        ob_start();
        curl_exec($ch);
        curl_close($ch);
        $getCurlResponse = ob_get_contents();
        ob_end_clean();
        $getCurlArray = Zend_Json_Decoder::decode($getCurlResponse);

        if (empty($getCurlResponse) || strstr($getCurlResponse, 'error::'))
            return;

        //Save Setting File
        if (isset($getCurlArray['pushNotificationSettings']['firebase']['iosConfigFileUrl']) && !empty($getCurlArray['pushNotificationSettings']['firebase']['iosConfigFileUrl'])) {
            $temp_doc_file = APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . 'Primemessenger';
            //$content = file_get_contents($getCurlArray['pushNotificationSettings']['iosConfigFileUrl']);
            $content = $this->getPrimemessengerContent($getCurlArray['pushNotificationSettings']['firebase']['iosConfigFileUrl']);
            if (isset($content) && !empty($content)) {
                if (!is_dir($temp_doc_file))
                    mkdir($temp_doc_file, 0777, true);
                $fileName = $temp_doc_file . '/' . 'GoogleService-Info.plist';
                file_put_contents($fileName, $content);
            }
        }

        //Save Language Files
        if (isset($getCurlArray['languages']) && !empty($getCurlArray['languages'])) {
            foreach ($getCurlArray['languages'] as $files) {
                if (isset($files['filePaths']['ios']) && !empty($files['filePaths']['ios'])) {
                    $temp_doc_file = APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . 'Primemessenger/Languages_App';
                    if (!is_dir($temp_doc_file)) {
                        mkdir($temp_doc_file, 0777, true);
                    }
                    //$content = file_get_contents($files['filePaths']['ios']);
                    $content = $this->getPrimemessengerContent($files['filePaths']['ios']);
                    if (isset($content) && !empty($content)) {
                        $fileName = $temp_doc_file . '/' . $files['code'] . '_language_ios_mobileapp.strings';
                        file_put_contents($fileName, $content);
                    }
                }
            }
        }

        if (isset($getCurlArray['apiUrl']) && !empty($getCurlArray['apiUrl'])) {
            $messengerDetails['apiUrl'] = $getCurlArray['apiUrl'];
        }

        if (isset($getCurlArray['mqttUrl']) && !empty($getCurlArray['mqttUrl'])) {
            $messengerDetails['mqttUrl'] = $getCurlArray['mqttUrl'];
        }

        $apiKey = Engine_Api::_()->getApi('settings', 'core')->getSetting('primemessenger.apikey', '');
        if (isset($apiKey) && !empty($apiKey)) {
            $messengerDetails['apiKey'] = $apiKey;
        }

        return $messengerDetails;
    
    }
    
    public function uploadMainImageBeforeQuick($splashImagesType, $tab, $subTab = 0, $app_dashboard_menu_setting, $controllerDefaultImage, $slideshowType) {
        foreach ($this->_getAPPImageDetailsForUpload as $key => $values) {

            if (!in_array($key, $this->_displayquickImages2) && $subTab == 2)
                continue;

            if (!in_array($key, $this->_displayquickImages3) && $tab == 3)
                continue;

            if (!in_array($key, $this->_displayquickImages4) && $subTab == 3)
                continue;


            if (empty($_FILES[$key]["tmp_name"])) {
                if (in_array($key, $this->_dynamicImages) && isset($splashImagesType) && empty($splashImagesType)) {
                    if (@file_exists(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $values['directoryName'] . '/' . $values['fileName'] . '.gif')) {
                        continue;
                    }
                } else {
                    if (@file_exists(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $values['directoryName'] . '/' . $values['fileName'] . '.png'))
                        continue;
                }
                $continueOrShowError = $this->getImageError($enabledTab, $subTab, $key, $app_dashboard_menu_setting, $controllerDefaultImage, $slideshowType);

                if (empty($continueOrShowError))
                    continue;

                $errors[$key] = $values['title'] . ': Image not found.';
                continue;
            }


            // In case: IF image uploaded by siteadministrator.
            if (isset($_FILES[$key]["tmp_name"]) && !empty($_FILES[$key]["tmp_name"])) {
                // Validate: file type
                $check = @getimagesize($_FILES[$key]["tmp_name"]);

                if ($check === false) {
                    $errors[$key] = $values['title'] . ': File is not an image.';
                    continue;
                }

                // Validate: image extension
                $target_file = @basename($_FILES[$key]["name"]);
                $imageFileType = @pathinfo($target_file, PATHINFO_EXTENSION);

                //GIF Images Work Start
                if (in_array($key, $this->_dynamicImages) && isset($splashImagesType) && empty($splashImagesType)) {
                    if ($imageFileType != "gif") {
                        $errors[$key] = $values['title'] . ': You have selected GIF image type for splash screen, so please choose GIF files.';
                        continue;
                    }
                } else {
                    if (in_array($key, $this->_dynamicImages) && $imageFileType != "png") {
                        $errors[$key] = $values['title'] . ': You have selected PNG image type for splash screen, so please choose PNG files.';
                        continue;
                    } else if ($imageFileType != "png") {
                        $errors[$key] = $values['title'] . ': Sorry, only PNG files are allowed.';
                        continue;
                    }
                }
                //GIF Images Work End
                // Validate: image width and height
                if (($check[0] !== $values['width']) && ($check[1] !== $values['height'])) {
                    $errors[$key] = $values['title'] . ': Please upload ' . $values['width'] . ' x ' . $values['height'] . ' pixels image.';
                    continue;
                }

                // Validate file size
                // 1MB => 1000000BYTES
                if ($_FILES[$key]["size"] > 1000000) {
                    $errors[$key] = $values['title'] . ': The uploaded file size has been increased, please upload the image(s) less then 1MB';
                    continue;
                }
                // Validate: authrization permission
                $isImageUpload = @move_uploaded_file($_FILES[$key]["tmp_name"], APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $values['directoryName'] . '/' . $values['fileName'] . '.' . $imageFileType);
                if (empty($isImageUpload)) {
                    $errors[$key] = $values['title'] . ': Not able to upload image. Please give 777 permission to /public/' . $this->_directoryName . ' directory.';
                    continue;
                }
            }
        }
        return $errors;
    }

    public function uploadImageQuick($splashImagesType, $tab, $subTab) {
        foreach ($this->_getAPPImageDetailsForUpload as $key => $values) {

            $imageToBeCreatedTo = $key;
            if ($tab == 2 && $subTab == 2)
                $imageToBeCreatedFrom = $key = $this->getMatchingImageTabTwo($key);
            else if ($tab == 2 && $subTab == 3)
                $imageToBeCreatedFrom = $key = $this->getMatchingImageTabFive($key);
            else if ($tab == 3)
                $imageToBeCreatedFrom = $key = $this->getMatchingImageTabFour($key);

            $values = $this->_getAPPImageDetailsForUpload[$key];
            if (empty($imageToBeCreatedFrom))
                continue;

            if (($tab != 2) && ($tab != 4) && ($tab != 3))
                continue;
            $imageUploaded = 0;
            if (in_array($imageToBeCreatedFrom, $this->_dynamicImages) && isset($splashImagesType) && empty($splashImagesType)) {
                if (@file_exists(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $values['directoryName'] . '/' . $values['fileName'] . '.gif')) {
                    $imageUploaded = APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $values['directoryName'] . '/' . $values['fileName'] . '.gif';
                }
            } else {

                if (@file_exists(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $values['directoryName'] . '/' . $values['fileName'] . '.png'))
                    $imageUploaded = APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $values['directoryName'] . '/' . $values['fileName'] . '.png';
            }


            if (isset($imageUploaded) && !empty($imageUploaded)) {
                @chmod($imageUploaded, 0777);

                // Validate: file type
                $check = @getimagesize($imageUploaded);
                if ($check === false) {
                    $errors[$key] = $values['title'] . ': File is not an image.';
                    continue;
                }

                // Validate: image extension
                $target_file = @basename($imageUploaded);
                $imageFileType = @pathinfo($target_file, PATHINFO_EXTENSION);
                //GIF Images Work Start
                if (in_array($key, $this->_dynamicImages) && isset($splashImagesType) && empty($splashImagesType)) {
                    if ($imageFileType != "gif") {
                        $errors[$key] = $values['title'] . ': You have selected GIF image type for splash screen, so please choose GIF files.';
                        continue;
                    }
                } else {
                    if (in_array($key, $this->_dynamicImages) && $imageFileType != "png") {
                        $errors[$key] = $values['title'] . ': You have selected PNG image type for splash screen, so please choose PNG files.';
                        continue;
                    } else if ($imageFileType != "png") {
                        $errors[$key] = $values['title'] . ': Sorry, only PNG files are allowed.';
                        continue;
                    }
                }
                //GIF Images Work End
                // Validate: image width and height
                if (($check[0] !== $values['width']) && ($check[1] !== $values['height'])) {
                    $errors[$key] = $values['title'] . ': Please upload ' . $values['width'] . ' x ' . $values['height'] . ' pixels image.';
                    continue;
                }

                // Validate file size
                // 1MB => 1000000BYTES
                if ($imageUploaded > 1000000) {
                    $errors[$key] = $values['title'] . ': The uploaded file size has been increased, please upload the image(s) less then 1MB';
                    continue;
                }

                $imagetoBeCreatedWidth = $this->_getAPPImageDetailsForUpload[$imageToBeCreatedTo]['width'];
                $imagetoBeCreatedHeight = $this->_getAPPImageDetailsForUpload[$imageToBeCreatedTo]['height'];
                $imagetoBeCreated = $this->_getAPPImageDetailsForUpload[$imageToBeCreatedTo];
                $this->uploadQuickImage($imageUploaded, $imagetoBeCreated, $imagetoBeCreatedWidth, $imagetoBeCreatedHeight, $imageFileType);
            }
        }

        return $errors;
    }

    public function getMatchingImageTabTwo($key) {
        $value = '';
        switch ($key) {
            case 'app_icon_1':
            case 'app_icon_2':
            case 'app_icon_3':
            case 'app_icon_4':
            case 'app_icon_5':
            case 'app_icon_6':
            case 'app_icon_7':
            case 'app_icon_8':
            case 'app_icon_9':
            case 'app_icon_10':
            case 'app_icon_11':
            case 'app_icon_12':
            case 'app_icon_13':
            case 'app_icon_14':
            case 'app_icon_15':
            case 'app_icon_16':
            case 'app_icon_17':
            case 'app_icon_21':
                $value = 'large_app_icon';
                break;
        }
        return $value;
    }

    public function getMatchingImageTabFour($key) {
        $value = '';
        switch ($key) {
            case 'secondControllerImage1':
            case 'secondControllerImage2':
                $value = 'secondControllerImage3';
                break;
            case 'thirdControllerImage1':
            case 'thirdControllerImage2':
                $value = 'thirdControllerImage3';
                break;
            case 'fourthControllerImage1':
            case 'fourthControllerImage2':
                $value = 'fourthControllerImage3';
                break;
        }
        return $value;
    }

    public function getMatchingImageTabFive($key) {
        $value = '';
        switch ($key) {
            case 'slideshow_slide_image_1_1':
            case 'slideshow_slide_image_1_2':
                $value = 'slideshow_slide_image_1_3';
                break;
            case 'slideshow_slide_image_2_1':
            case 'slideshow_slide_image_2_2':
                $value = 'slideshow_slide_image_2_3';
                break;
            case 'slideshow_slide_image_3_1':
            case 'slideshow_slide_image_3_2':
                $value = 'slideshow_slide_image_3_3';
                break;
        }

        return $value;
    }

    public function uploadQuickImage($fromDestination, $values, $imagetoBeCreatedWidth, $imagetoBeCreatedHeight, $imageFileType) {
        $tempfromLocation = APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $values['directoryName'] . '/' . $values['fileName'] . '.' . $imageFileType;

        $image = Engine_Image::factory();
        $image->open($fromDestination);

        $width = $image->width;
        $height = $image->height;

        $newwidth = $values['width'];
        $newHeight = $values['height'];
        if ($width != $newwidth || $height != $newHeight) {
            $image->resize($newwidth, $newHeight)
                    ->write($tempfromLocation)
                    ->destroy();
        }

        if (!is_file($tempfromLocation)) {
            echo 'error::There are no source (' . $fromDestination . ') file available.';
            die;
        }

        @chmod($tempfromLocation, 0777);
        @chmod($temptoLocation, 0777);
    }

    public function getFormFields($currentTab) {
        $getAPPBuilderParentPath = APPLICATION_PATH . DIRECTORY_SEPARATOR
                . $this->_getAPPBuilderBaseURL;

        $getAPPBuilderSettingsFilePath = $getAPPBuilderParentPath . DIRECTORY_SEPARATOR
                . $this->_getAPPBuilderSettingsFileName;

        if (@file_exists($getAPPBuilderSettingsFilePath))
            include $getAPPBuilderSettingsFilePath;

        $this->_tabTwoError = 0;
        $this->_tabOneError = 0;
        $tabOne = array(
            'title',
            'bundle_display_name',
            'keywords',
            'primary_category',
            'rating',
            'description',
            'default_language',
            'first_name',
            'last_name',
            'email_contact_details',
            'phone',
            'address',
            'city',
            'state',
            'zip_code',
            'support_url',
            'copyright',
            'api_consumer_key',
            'api_consumer_secret',
            'siteapi_validate_ssl',
            'apple_ios_developer_login_email',
            'apple_ios_developer_login_password'
        );

        if (isset($appBuilderParams['publish_app']) && empty($appBuilderParams['publish_app'])) {
            $tabOne = array_merge(array('phone_udid'), $tabOne);
        }

        $tabTwo = array(
            'app_header_color',
            'navigation_text_color',
            'button_color',
            'app_button_color',
            'normal_font',
            'bold_font',
        );

        if ($currentTab >= 1) {
            foreach ($tabOne as $param) {
                if ($param == 'siteapi_validate_ssl') {
                    if (!isset($appBuilderParams[$param])) {
                        $this->_tabOneError = 1;
                        $this->_subTabError[] = $this->getExactTabError($param);
                    }
                } else if (!isset($appBuilderParams[$param]) || empty($appBuilderParams[$param])) {
                    $this->_tabOneError = 1;
                    $this->_subTabError[] = $this->getExactTabError($param);
                }
            }
        }
        if ($currentTab >= 2) {

            if (!isset($appBuilderParams['default_dashboard']) || (isset($appBuilderParams['default_dashboard']) && !empty($appBuilderParams['default_dashboard']))) {
                unset($this->_getAPPImageDetailsForUpload['secondControllerImage1']);
                unset($this->_getAPPImageDetailsForUpload['secondControllerImage2']);
                unset($this->_getAPPImageDetailsForUpload['secondControllerImage3']);
                unset($this->_getAPPImageDetailsForUpload['thirdControllerImage1']);
                unset($this->_getAPPImageDetailsForUpload['thirdControllerImage2']);
                unset($this->_getAPPImageDetailsForUpload['thirdControllerImage3']);
                unset($this->_getAPPImageDetailsForUpload['fourthControllerImage1']);
                unset($this->_getAPPImageDetailsForUpload['fourthControllerImage2']);
                unset($this->_getAPPImageDetailsForUpload['fourthControllerImage3']);
            }
            
             //If slid show type is one 
            if (!empty($appBuilderParams['slide_show_type'])) {
                unset($this->_getAPPImageDetailsForUpload['slideshow_slide_plain_image_1_1']);
                unset($this->_getAPPImageDetailsForUpload['slideshow_slide_plain_image_1_2']);
                unset($this->_getAPPImageDetailsForUpload['slideshow_slide_plain_image_1_3']);
                unset($this->_getAPPImageDetailsForUpload['slideshow_slide_plain_image_1_4']);
                unset($this->_getAPPImageDetailsForUpload['slideshow_slide_plain_image_1_5']);
                unset($this->_getAPPImageDetailsForUpload['slideshow_slide_plain_image_1_6']);
                unset($this->_getAPPImageDetailsForUpload['slideshow_slide_plain_image_1_7']);
            }
            elseif(isset($appBuilderParams['slide_show_type'])){
                unset($this->_getAPPImageDetailsForUpload['slideshow_slide_image_1_1']);
                unset($this->_getAPPImageDetailsForUpload['slideshow_slide_image_1_2']);
                unset($this->_getAPPImageDetailsForUpload['slideshow_slide_image_1_3']);
                
            }

            // Set description for uploaded images.
            foreach ($this->_getAPPImageDetailsForUpload as $key => $values) {
                $imageType = '.png';
                if (in_array($key, $this->_dynamicImages) && isset($appBuilderParams['welcome_image_type']) && empty($appBuilderParams['welcome_image_type']))
                    $imageType = '.gif';

                if (@file_exists(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $values['directoryName'] . '/' . $values['fileName'] . $imageType)) {
                    if (!isset($this->_tabTwoError) || empty($this->_tabTwoError))
                        $this->_tabTwoError = 0;
                } else if (in_array($key, $this->_requiredFormImages)) {
                    if(($this->getExactTabError($key) == 'slideshow_four_plain_slide') || ($this->getExactTabError($key) == 'slideshow_five_plain_slide') || ($this->getExactTabError($key) == 'slideshow_six_plain_slide') || ($this->getExactTabError($key) == 'slideshow_seven_plain_slide') ){
                        $this->_tabTwoError = 0;
                        
                    }
                    else{
                        if(!strstr($key, "ControllerImage"))
                        $this->_tabTwoError = 1;
                        $this->_subTabError[] = $this->getExactTabError($key);
                    }
                }
            }

            foreach ($tabTwo as $param) {
                if (!isset($appBuilderParams[$param]) || empty($appBuilderParams[$param])) {
                    if ($param == 'app_button_color')
                        continue;
                    $this->_tabTwoError = 1;
                    $this->_subTabError[] = $this->getExactTabError($param);
                }
            }
        }

        $this->view->tabOneErrorDisplay = $this->_tabOneError;
        $this->view->tabTwoErrorDisplay = $this->_tabTwoError;
        $this->view->subTabError = $this->_subTabError;
    }

    public function getExactTabError($param) {
        $extra = array('apple_ios_developer_login_email',
            'apple_ios_developer_login_password');

        foreach ($this->_formFields as $tab => $keys) {
            if (in_array($param, $extra)) {
                return 'ios_developer_account_details';
            }
            if (in_array($param, $keys)) {
                return $tab;
            }
        }
        return 0;
    }

    public function packageurlvalidationAction() {
        $package_url = $this->_getParam('package_name');
        $response = Engine_Api::_()->getApi('core', 'siteiosapp')->getPackageNameFile(0, $package_url);
        echo $response;
        exit();
    }

    public function getImageError($enabledTab, $subTab = 0, $key, $app_dashboard_menu_setting, $controllerDefault, $slideshowType) {
        if (empty($subTab))
            $subTab = 1;
        if (($enabledTab != 2) && ($enabledTab != 3))
            return 0;

        // Conditions for images error in diffrent tabs.
        if (($enabledTab != 2 || $subTab != 2) && (in_array($key, array('large_app_icon', 'app_icon_1', 'notification_icon_large', 'app_icon_2', 'app_icon_3', 'app_icon_4', 'app_icon_5', 'app_icon_6', 'app_icon_7', 'app_icon_8', 'app_icon_9', 'app_icon_10', 'app_icon_11', 'app_icon_12', 'app_icon_13', 'app_icon_14', 'app_icon_15', 'app_icon_16', 'app_icon_21', 'app_icon_17', 'splash_portrait_2', 'splash_portrait_3', 'splash_portrait_4', 'splash_portrait_5', 'splash_portrait_6', 'splash_portrait_7', 'splash_portrait_8', 'splash_portrait_9', 'splash_portrait_10', 'splash_portrait_11', 'splash_portrait_12', 'splash_portrait_13'))))
            return 0;

        // Tabs menu work 
        if (($enabledTab == 3) && (empty($app_dashboard_menu_setting) || $app_dashboard_menu_setting == 0))
            return 0;

        if (($enabledTab != 3) && (in_array($key, array('secondControllerImage1', 'secondControllerImage2', 'secondControllerImage3', 'thirdControllerImage1', 'thirdControllerImage2', 'thirdControllerImage3', 'fourthControllerImage1', 'fourthControllerImage2', 'fourthControllerImage3'))))
            return 0;

        if (($enabledTab == 3) && isset($controllerDefault) && !empty($controllerDefault) && in_array($key, array('secondControllerImage1', 'secondControllerImage2', 'secondControllerImage3')))
            return 0;

        if (($enabledTab == 3) && isset($controllerDefault) && !empty($controllerDefault) && in_array($key, array('thirdControllerImage1', 'thirdControllerImage2', 'thirdControllerImage3')))
            return 0;

        if (($enabledTab == 3) && isset($controllerDefault) && !empty($controllerDefault) && in_array($key, array('fourthControllerImage1', 'fourthControllerImage2', 'fourthControllerImage3')))
            return 0;

        // Tabs menu work ends

        if (isset($slideshowType) && !empty($slideshowType)) {
            if ((($enabledTab != 2) || ($subTab != 3)) && (in_array($key, array('slideshow_slide_image_1_1', 'slideshow_slide_image_1_2'))))
                return 0;

              if (in_array($key, array('slideshow_slide_image_2_1', 'slideshow_slide_image_2_2', 'slideshow_slide_image_3_1', 'slideshow_slide_image_3_2','slideshow_slide_image_2_3','slideshow_slide_image_3_3')))
                return 0;
            if (in_array($key, array('slideshow_slide_plain_image_1_1', 'slideshow_slide_plain_image_1_2', 'slideshow_slide_plain_image_1_3', 'slideshow_slide_plain_image_1_4', 'slideshow_slide_plain_image_1_5', 'slideshow_slide_plain_image_1_6', 'slideshow_slide_plain_image_1_7')))
                return 0;
        }
        else {
            if ((($enabledTab != 2) || ($subTab != 3)) && (in_array($key, array('slideshow_slide_plain_image_1_1'))))
                return 0;

            if (in_array($key, array('slideshow_slide_plain_image_1_2', 'slideshow_slide_plain_image_1_3', 'slideshow_slide_plain_image_1_4', 'slideshow_slide_plain_image_1_5', 'slideshow_slide_plain_image_1_6', 'slideshow_slide_plain_image_1_7')))
                return 0;

             if (in_array($key, array('slideshow_slide_image_1_1', 'slideshow_slide_image_1_2', 'slideshow_slide_image_2_1', 'slideshow_slide_image_2_2', 'slideshow_slide_image_3_1', 'slideshow_slide_image_3_2','slideshow_slide_image_2_3','slideshow_slide_image_3_3')))
                return 0;
        }

        return 1;
    }
    
    public function getPrimemessengerContent($apiUrl =null, $apiKey=null)
    {
       if(empty($apiUrl))
           return ;
        
        $website = $apiUrl;
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $website);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        
        ob_start();
        curl_exec($ch);
        curl_close($ch);
        $content = ob_get_contents();
        ob_end_clean();
        return $content;
    }

}
