<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteiosapp
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    AdminSettingsController.php 2015-10-01 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteiosapp_AdminSettingsController extends Core_Controller_Action_Admin {

    public function __call($method, $params) {
        /*
         * YOU MAY DISPLAY ANY ERROR MESSAGE USING FORM OBJECT.
         * YOU MAY EXECUTE ANY SCRIPT, WHICH YOU WANT TO EXECUTE ON FORM SUBMIT.
         * REMEMBER:
         *    RETURN TRUE: IF YOU DO NOT WANT TO STOP EXECUTION.
         *    RETURN FALSE: IF YOU WANT TO STOP EXECUTION.
         */

        if (!empty($method) && $method == 'Siteiosapp_Form_Admin_Settings') {
            
        }
        return true;
    }

    public function indexAction() {
        $urlMismatch = $this->_checkAPIUrl();
        $this->view->urlMisMatchError = 0;

        if (empty($urlMismatch))
            $this->view->urlMisMatchError = 1;

        if (isset($_POST['siteiosapp_shared_secret'])) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting('siteiosapp.shared.secret', $_POST['siteiosapp_shared_secret']);
        }

        if (isset($_POST['browse_as_guest'])) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting('siteiosapp.browse.guest', $_POST['browse_as_guest']);
        }

        if (isset($_POST['siteiosapp_current_mode'])) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting('siteiosapp.current.mode', $_POST['siteiosapp_current_mode']);
        }

        if (isset($_POST['siteapi_test_device_id_ios'])) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting('siteapi.test.device.id.ios', $_POST['siteapi_test_device_id_ios']);
        }

        if (isset($_POST['siteios_member_view'])) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting('ios.member.view', $_POST['siteios_member_view']);
        }

        if (isset($_POST['siteiosapp_app_name'])) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting('siteiosapp.app.name', $_POST['siteiosapp_app_name']);
        }


        if (isset($_POST['siteios_autodetect_enable'])) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting('siteios.autodetect.enable', $_POST['siteios_autodetect_enable']);
        }

        if (isset($_POST['siteios_change_location'])) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting('siteios.change.location', $_POST['siteios_change_location']);
        }
        
        if (isset($_POST['ios_enable_location'])) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting('ios.enable.location', $_POST['ios_enable_location']);
        }
        
        if (isset($_POST['app_tour'])) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting('siteiosapp.app.tour', $_POST['app_tour']);
        }
        
        if (isset($_POST['siteios_video_quality'])) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting('siteios.video.quality', $_POST['siteios_video_quality']);
        }
        
                //ios version settings.........
        if (isset($_POST['ios_popup_enable'])) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting('ios.popup.enable', $_POST['ios_popup_enable']);
        }
        if (isset($_POST['ios_version_description'])) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting('ios.version.description', $_POST['ios_version_description']);
        }
        if (isset($_POST['ios_version_upgrade'])) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting('ios.version.upgrade', $_POST['ios_version_upgrade']);
        }

        //ios version settings.........
        if (isset($_POST['ios_popup_enable'])) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting('ios.popup.enable', $_POST['ios_popup_enable']);
        }
        if (isset($_POST['siteiosapp_version_description'])) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting('siteiosapp.version.description', $_POST['siteiosapp_version_description']);
        }
        if (isset($_POST['siteiosapp_version_upgrade'])) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting('siteiosapp.version.upgrade', $_POST['siteiosapp_version_upgrade']);
        }
                
        if (isset($_POST['siteiosapp_force_upgrade'])) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting('siteiosapp.force.upgrade', $_POST['siteiosapp_force_upgrade']);
        }
        
        if (isset($_POST['siteiosapp_google_server_api_key'])) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting('siteiosapp.google.server.api.key', $_POST['siteiosapp_google_server_api_key']);
        }

        if (isset($_POST['ios_enable_location'])) {
            $defaultValue = !empty($_POST['ios_enable_location']) ? true : false;
            $db = Engine_Db_Table::getDefaultAdapter();
            $select = new Zend_Db_Select($db);
            $isLanguageRowExist = $select->from('engine4_siteiosapp_menus')
                    ->where('name = ?', "seaocore_location")
                    ->limit(1)
                    ->query()
                    ->fetchColumn();
            if (!empty($isLanguageRowExist))
                $db->query("UPDATE `engine4_siteiosapp_menus` SET `status` = '" . $defaultValue . "' WHERE `engine4_siteiosapp_menus`.`name` = 'seaocore_location' LIMIT 1 ;");
        }

        if (isset($_POST['siteapi_test_device_id_ios']) && ($_POST['siteapi_test_device_id_ios'] != Engine_Api::_()->getApi('settings', 'core')->getSetting('siteapi.test.device.id.ios', false))) {
            $this->clearLogs();
        }

        if (empty($_POST['siteapi_app_mode_ios'])) {
            $this->clearLogs();
        }

        if (isset($_POST['siteapi_app_mode_ios'])) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting('siteapi_app_mode_ios', $_POST['siteapi_app_mode_ios']);
        }

        if (isset($_POST['siteapi_test_device_id_ios'])) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting('siteapi.test.device.id.ios', $_POST['siteapi_test_device_id_ios']);
        }

        $settings = Engine_Api::_()->getApi('settings', 'core');
        if (!isset($_REQUEST['updateCertificate']) || empty($_REQUEST['updateCertificate'])) {
            $imageExtensions = array('pem');
            $it = new DirectoryIterator(APPLICATION_PATH . '/public/admin/');
            $apnPath = $settings->getSetting('siteiosapp.apple.server.apn.key', '');
            $tempApn = @explode("public/admin/", $apnPath);
            if (!empty($tempApn[1]))
                $apnVal = "public/admin/" . $tempApn[1];
            else
                $apnVal = "";
            $_POST["apple_server_apn_key"] = $apnVal;
            $_POST["password"] = $settings->getSetting('siteiosapp.password', '');
            $_POST["siteiosapp_apn_mode"] = $settings->getSetting('siteiosapp_apn_mode', 1);
        }

        include_once APPLICATION_PATH . '/application/modules/Siteiosapp/controllers/license/license1.php';
        $pluginTitle = array();
        $sitemobile = Engine_Api::_()->getDbtable('modules', 'core')->getModule('sitemobile');
        if (isset($sitemobile) && !empty($sitemobile)) {
            $pluginTitle[] = $sitemobile->title;
        }

        $mobi = Engine_Api::_()->getDbtable('modules', 'core')->getModule('mobi');
        if (isset($mobi) && !empty($mobi)) {
            $pluginTitle[] = $mobi->title;
        }

        $mobi = Engine_Api::_()->getDbtable('modules', 'core')->getModule('mobi');
        if (isset($mobi) && !empty($mobi)) {
            $pluginTitle[] = $mobi->title;
        }

        $this->view->pluginTitle = $pluginTitle;
    }

    public function faqAction() {
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteiosapp_admin_main', array(), 'siteiosapp_admin_faq');
    }

    public function readmeAction() {
        
    }

    /*
     * Delete the old exist iOS app from app dashboard.
     */

    public function deleteExistingAppAction() {
        $this->_helper->layout->setLayout('admin-simple');

        if ($this->getRequest()->isPost()) {
            Engine_Api::_()->getApi('core', 'siteiosapp')->validatePreviousMobileAPP();

            $this->_forward('success', 'utility', 'core', array(
                'smoothboxClose' => 10,
                'parentRefresh' => 10,
                'messages' => array(Zend_Registry::get('Zend_Translate')->_('Deleted Successfully!'))
            ));
        }
    }

    /*
     * Error Page Layout Function.
     */

    public function errorPageAction() {
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteiosapp_admin_main', array(), 'siteiosapp_admin_error_page');
        $this->view->form = $form = new Siteiosapp_Form_Admin_Error();
        $formValues = Engine_Api::_()->getApi('settings', 'core')->getSetting("siteiosapp_error_params");
        $values = @unserialize($formValues);
        if (!empty($values))
            $form->populate($values);

        if ($this->getRequest()->isPost()) {
            $values = $this->getRequest()->getPost();
            unset($values['submit']);

            if (isset($_FILES['siteiosapp_error_image']["tmp_name"]) && !empty($_FILES['siteiosapp_error_image']["tmp_name"])) {
                $target_file = @basename($_FILES['siteiosapp_error_image']["name"]);
                $imageFileType = @pathinfo($target_file, PATHINFO_EXTENSION);
                $fileName = APPLICATION_PATH . DIRECTORY_SEPARATOR . 'admin/public/' . 'siteiosapp_error_image.' . $imageFileType;
                $isFileUpload = move_uploaded_file($_FILES['siteiosapp_error_image']["tmp_name"], $fileName);
                @chmod($fileName, 0777);

                if ($isFileUpload) {
                    $values['siteiosapp_error_image'] = $fileName;
                }
            }


            $value = @serialize($values);
            Engine_Api::_()->getApi('settings', 'core')->setSetting("siteiosapp_error_params", $value);
            return $this->_helper->redirector->gotoRoute(array('action' => 'error-page'));
        }
    }
    
    
        /*
     * Location  Layout Function.
     */

    public function mapLocationAction() {
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteiosapp_admin_main', array(), 'siteiosapp_admin_map_location');
        $this->view->form = $form = new Siteiosapp_Form_Admin_Maplocation();

        $formValues = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteiosapp.maplocation', '1');
        $values = @unserialize($formValues);
        if (!empty($values))
            $form->populate($values);

        if ($this->getRequest()->isPost()) {
            unset($values['submit']);
            $enableModule['siteiosapp_maplocation'] = $_POST['siteiosapp_maplocation'];
            $enableModule = @serialize($enableModule);
            Engine_Api::_()->getApi('settings', 'core')->setSetting("siteiosapp.maplocation", $enableModule);

        if (isset($_POST['siteios_autodetect_enable'])) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting('siteios.autodetect.enable', $_POST['siteios_autodetect_enable']);
        }

        if (isset($_POST['siteios_change_location'])) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting('siteios.change.location', $_POST['siteios_change_location']);
        }
        
        if (isset($_POST['ios_enable_location'])) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting('ios.enable.location', $_POST['ios_enable_location']);
        }

        if (isset($_POST['ios_enable_location'])) {
            $defaultValue = !empty($_POST['ios_enable_location']) ? true : false;
            $db = Engine_Db_Table::getDefaultAdapter();
            $select = new Zend_Db_Select($db);
            $isLanguageRowExist = $select->from('engine4_siteiosapp_menus')
                    ->where('name = ?', "seaocore_location")
                    ->limit(1)
                    ->query()
                    ->fetchColumn();
            if (!empty($isLanguageRowExist))
                $db->query("UPDATE `engine4_siteiosapp_menus` SET `status` = '" . $defaultValue . "' WHERE `engine4_siteiosapp_menus`.`name` = 'seaocore_location' LIMIT 1 ;");
        }

            $form->addNotice('Your changes have been saved.');
            return $this->_helper->redirector->gotoRoute(array('action' => 'map-location'));
        }
    }

    public function clearLogs() {
        $filepath = APPLICATION_PATH_TMP . DS . 'log' . DS . 'Seao-iOS.log';
        if (($fh = fopen($filepath, 'w'))) {
            ftruncate($fh, 0);
            fclose($fh);
        }
        return true;
    }

    private function _checkAPIUrl() {
        $getHost = $_SERVER['HTTP_HOST'];
        $getHost = str_replace('www.', '', $getHost);
        $getHost = str_replace(".", "-", $getHost);
        $parentDirectoryPath = 'public/ios-' . $getHost . '-app-builder';
        $coreDirectoryPath = APPLICATION_PATH . '/' . $parentDirectoryPath;

        if (!is_dir($coreDirectoryPath))
            return 1;

        include $coreDirectoryPath . '/settings.php';

        if (empty($appBuilderParams))
            return 1;

        $getHost = (isset($appBuilderParams['siteapi_validate_ssl']) && !empty($appBuilderParams['siteapi_validate_ssl'])) ? 'https://' . $_SERVER['HTTP_HOST'] : 'http://' . $_SERVER['HTTP_HOST'];
        $siteHost = $this->view->url(array(), 'home', false);
        $currentUrl = $getHost . $siteHost . 'api/rest/';

        if (empty(strcmp($currentUrl, $appBuilderParams['api_calling_url'])))
            return 1;

        return 0;
    }

}
