<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitelazyload
 * @copyright  Copyright 2018-2019 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Global.php 2018-12-05 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitelazyload_Form_Admin_Global extends Engine_Form
{
  public function init()
  {
    $coreSettings = Engine_Api::_()->getApi('settings', 'core');
    $this
      ->setTitle('Global Settings')
      ->setDescription('These settings affect all members in your community.');

      $this->addElement('Radio', 'sitelazyload_mode', array(
            'label' => 'Lazyload Mode',
            'description' => 'Select the mode for lazyload functionality.',
            'multiOptions' => array(
                'testmode' => 'Test Mode',
                'enable' => 'Enable',
                'disable' => 'Disable'
            ),
            'value' => $coreSettings->getSetting('sitelazyload.mode', 'enable'),
            'onchange' => 'showEmailOption(this)',
        ));

      $this->addElement('Text', 'sitelazyload_email', array(
        'label' => 'Email ID',
        'description' => 'Please enter the Test Email Id.',
        'allowEmpty' => FALSE,
        'validators' => array(
          array('NotEmpty', true),
        ),
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting("sitelazyload.email", "email"),
      ));

    // Add submit button
    $this->addElement('Button', 'submit', array(
      'label' => 'Save Changes',
      'type' => 'submit',
      'ignore' => true
    ));
  }
}