<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitelazyload
 * @copyright  Copyright 2018-2019 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 2018-12-05 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitelazyload_Plugin_Core extends Zend_Controller_Plugin_Abstract
{
  public function routeShutdown(Zend_Controller_Request_Abstract $request)
  {
    // CHECK IF ADMIN
    if( substr($request->getPathInfo(), 1, 5) == "admin" ) {
      return;
    }

    // DO NOT REGISTER HELPERS IF SETTING IS DISABLED
    $settings = Engine_Api::_()->getApi('settings','core');
    $mode = $settings->getSetting('sitelazyload.mode', 'enable');
    if ($mode == 'disable') {
      return;
    }

    if ($mode == 'testmode') {
      $viewer = Engine_Api::_()->user()->getViewer();
      $email = $settings->getSetting('sitelazyload.email');
      if (!$viewer || !$viewer->getIdentity()) {
        return;
      }
      if ($viewer->email != $email) {
        return;
      }
    }
    $this->_loadViewHelperPath();
  }

  protected function _loadViewHelperPath()
  {
    $viewRenderer = Zend_Controller_Action_HelperBroker::getStaticHelper('viewRenderer');
    $view = $viewRenderer->view;
    if( is_null($view) ) {
      return $this;
    }

    $path = APPLICATION_PATH . '/application/modules/Sitelazyload/View/Helper/';
    $prefix = 'Sitelazyload_View_Helper_';
    $view->addHelperPath($path, $prefix);
    $view->registerHelper((new Sitelazyload_View_Helper_ItemPhoto), 'itemPhoto');
    $view->registerHelper((new Sitelazyload_View_Helper_ItemBackgroundPhoto), 'itemBackgroundPhoto');
    $view->headScript()->prependFile(Zend_Registry::get('StaticBaseUrl') .
      'application/modules/Sitelazyload/externals/scripts/lazyload.min.js');
    return $this;
  }

}