<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitelinkedin
 * @copyright  Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Footertemplates.php 2019-08-28 15:11:20Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitelinkedin_Form_Admin_Footertemplates extends Engine_Form {

  public function init() {


    $coreSettings = Engine_Api::_()->getApi('settings', 'core');
    $this->setTitle("Manage Landing Page Footer");
    $this->setDescription("Here, you can manage settings related to footer.");

    $logoBackgroundOptions = Engine_Api::_()->sitelinkedin()->getImages(array('application/modules/Sitelinkedin/externals/images/default_footer_bg.png' => 'Default Image'));
    $logoOptions = Engine_Api::_()->sitelinkedin()->getImages(array('' => 'Text-only (No logo)'));
    $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
    



//		$this->addElement('Select', 'sitelinkedin_footer_backgroundimage', array(
//			'description' => 'Select background image for footer of your website.',
//			'label' => 'Footer Background Image',
//			'multiOptions' => $logoBackgroundOptions,
//			'value' => $coreSettings->getSetting('sitelinkedin.footer.backgroundimage', 'application/modules/Sitelinkedin/externals/images/default_footer_bg.png'),
//		));


    $this->addElement('Radio', 'sitelinkedin_footer_show_logo', array(
      'description' => 'Do you want to show website’s logo in footer?',
      'label' => 'Show Logo in Footer',
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No',
      ),
      'onclick' => 'showFooterLogo(this.value);',
      'value' => $coreSettings->getSetting('sitelinkedin.footer.show.logo', 1),
    ));


    $this->addElement('Select', 'sitelinkedin_footer_select_logo', array(
      'description' => 'Select your website’s logo to be placed in the footer.',
      'label' => 'Footer Logo',
      'multiOptions' => $logoOptions,
      'value' => $coreSettings->getSetting('sitelinkedin.footer.select.logo'),
    ));


		$this->addElement('Radio', 'sitelinkedin_fotter_sociallinks', array(
      'description' => 'Do you want to display social website links? To edit the social links, edit "Social Site Links Menu" from Menu Editor.',
      'label' => 'Social Website Links',
      'multiOptions' => array(
        1 => 'Yes ',
        0 => 'No',
      ),
      'value' => $coreSettings->getSetting('sitelinkedin.fotter.sociallinks', 1),
    ));


//		$this->addElement('Radio', 'sitelinkedin_fotter_subscribeus', array(
//			'description' => 'Do you want to display "Subscribe Us" form?',
//			'label' => 'Subscribe Us',
//			'multiOptions' => array(
//				1 => 'Yes ',
//				0 => 'No',
//			),
//			'value' => $coreSettings->getSetting('sitelinkedin.fotter.subscribeus', 1),
//		));
    $this->addElement('Button', 'submit', array(
      'label' => 'Save Changes',
      'type' => 'submit',
      'decorators' => array(
        'ViewHelper',
      ),
    ));
  }

}
