<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitelinkedin
 * @copyright  Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Layout.php 2019-08-28 15:11:20Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitelinkedin_Form_Admin_Settings_Layout extends Engine_Form {

  public function init() {
    $this->setTitle("Layout Settings");
    $this->setDescription("Here you can manage the layout of this theme.");

    $coreSettings = Engine_Api::_()->getApi('settings', 'core');

    $this->addElement('Text', 'sitelinkedin_layout_theme_width', array(
      'label' => 'Theme Width',
      'description' => 'Enter total width of theme [Note: Minimum width should be - 1188px]',
      'required' => true,
      'value' => $coreSettings->getSetting('sitelinkedin.layout.theme.width', '1188'),
    ));

    $this->addElement('Text', 'sitelinkedin_layout_left_column_width', array(
      'label' => 'Left Column Width',
      'description' => 'Enter width for left column [Note: Width should be in range from 200 - 300 px. Width of center column will be set after deducting the width of left and right column.]',
      'required' => true,
      'allowEmpty' => false,
      'value' => $coreSettings->getSetting('sitelinkedin.layout.left.column.width', '216'),
    ));

    $this->addElement('Text', 'sitelinkedin_layout_right_column_width', array(
      'label' => 'Right Column Width',
      'description' => 'Enter width for right column [Note: Width should be in range from 200 - 300 px. Width of center column will be set after deducting the width of left and right column.]',
      'required' => true,
      'allowEmpty' => false,
      'value' => $coreSettings->getSetting('sitelinkedin.layout.right.column.width', '300'),
    ));

    $this->addElement('Radio', 'sitelinkedin_layout_hide_left_column', array(
      'label' => 'Hide Left Column in Mobile Device',
      'description' => 'Do you want to hide left column in Mobile devices?',
      'multiOptions' => array(
        'none' => 'Yes',
        'block' => 'No'
      ),
      'value' => $coreSettings->getSetting('sitelinkedin.layout.hide.left.column', 'none'),
    ));

    $this->addElement('Radio', 'sitelinkedin_layout_hide_right_column', array(
      'label' => 'Hide Right Column in Mobile Device',
      'description' => 'Do you want to hide right column in Mobile devices?',
      'multiOptions' => array(
        'none' => 'Yes',
        'block' => 'No'
      ),
      'value' => $coreSettings->getSetting('sitelinkedin.layout.hide.right.column', 'block'),
    ));
    $this->addElement('Button', 'submit', array(
      'label' => 'Save Changes',
      'type' => 'submit',
      'ignore' => true
    ));
  }

}
