<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitelinkedin
 * @copyright  Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 2019-08-28 15:11:20Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitelinkedin_Plugin_Core extends Zend_Controller_Plugin_Abstract {

  public function onRenderLayoutDefault($event) {

    $view = $event->getPayload();
    $view->headTranslate(array("Forgot Password?", "Login with Twitter", "Login with Facebook", "Mark as Read", "Mark as Unread"));


    $themeTable = Engine_Api::_()->getDbtable('themes', 'core');
    $active = $themeTable->select()
      ->from($themeTable->info('name'), 'active')
      ->where('name = ?', 'sitelinkedin')
      ->where('active = ?', 1)
      ->query()
      ->fetchColumn()
    ;
    if ($active) {
      $this->_loadFontsCss($view);
      $layout = $view->layout();
      $themeTable = Engine_Api::_()->getDbtable('themes', 'sitelinkedin');
      $themeSelect = $themeTable->select()
        ->where('active = ?', 1)
        ->limit(1);
      $themeRow = $themeTable->fetchRow($themeSelect);
      $colorName = $themeRow->name;
      $cookieName = 'sitelinkedin_seao_theme_color';
      if (!empty($_COOKIE[$cookieName])) {
        $colorName = $_COOKIE[$cookieName];
      }
      $themeName = 'sitelinkedin/' . $colorName;
      $themes = array();
      foreach ($layout->themes as $key => $theme) {
        if ($theme == 'sitelinkedin') {
          $theme = $themeName;
        }
        $themes[$key] = $theme;
      }
      $layout->themes = $themes;
      $themesInfo = $layout->themesInfo;
      $themesInfo[$themeName] = include APPLICATION_PATH_COR . DS
        . 'themes' . DS . 'sitelinkedin' . DS . $colorName . DS . 'manifest.php';
      $layout->themesInfo = $themesInfo;
      Zend_Registry::set('Themes', $themesInfo);
    }
  }

  public function onRenderLayoutDefaultSimple($event) {
    // Forward
    return $this->onRenderLayoutDefault($event, 'simple');
  }

  protected function _loadFontsCss($view) {

    $view->headLink()->appendStylesheet('https://fonts.googleapis.com/css?family=Open+Sans:300,400,600');
  }

  protected function _getFontsFamilyName($name) {
    $coreSettings = Engine_Api::_()->getApi('settings', 'core');
    $fonts = $coreSettings->getSetting('sitelinkedin.fonts.' . $name . '.font.family.google', '"Open Sans", sans-serif');
    if (empty($fonts)) {
      return '"Open Sans", sans-serif';
    }
    $explode = (explode(',', $fonts));
    $family = trim(str_replace(array("'", '"'), '', $explode[0]));
    return $family;
  }

}
