<?php 
 /**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitelinkedin
 * @copyright  Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminLayoutController.php 2019-08-28 15:11:20Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitelinkedin_AdminLayoutController extends Core_Controller_Action_Admin
{

  public function indexAction()
  {
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitelinkedin_admin_main', array(), 'sitelinkedin_admin_theme_custom');
    $this->view->subNavigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitelinkedin_admin_theme_custom', array(), 'sitelinkedin_admin_layout_index');

    //MAKE FORM
    $this->view->form = $form = new Sitelinkedin_Form_Admin_Settings_Layout();


    if( !$this->getRequest()->isPost() )
      return;

    if( !$form->isValid($this->getRequest()->getPost()) ) {
      return;
    }


    $values = $form->getValues();

    $fileName = 'sitelinkedinThemeGeneralConstants.css';
    $valuesWithPx = $values;
    $valuesWithPx['sitelinkedin_layout_theme_width'] = $valuesWithPx['sitelinkedin_layout_theme_width'].'px';
    $valuesWithPx['sitelinkedin_layout_left_column_width'] = $valuesWithPx['sitelinkedin_layout_left_column_width'].'px';
    $valuesWithPx['sitelinkedin_layout_right_column_width'] = $valuesWithPx['sitelinkedin_layout_right_column_width'].'px';
    $successfullySaved = Engine_Api::_()->getApi('customization', 'sitelinkedin')->setConstants($valuesWithPx, $fileName);

    foreach( $values as $key => $value ) {
        Engine_Api::_()->getApi('settings', 'core')->setSetting($key, $value);
    }

    if( !empty($successfullySaved) ) {
      Core_Model_DbTable_Themes::clearScaffoldCache();

      $form->addNotice('Changes successfully saved. If changes not reflect to frontend then please change the mode to Development.');
    }
  }

}