<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitelinkedin
 * @copyright  Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminSettingsController.php 2019-08-28 15:11:20Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitelinkedin_AdminSettingsController extends Core_Controller_Action_Admin {

//  public function indexAction() {
//    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
//      ->getNavigation('sitelinkedin_admin_main', array(), 'sitelinkedin_admin_settings_index');
//    $this->view->form = $form = new Sitelinkedin_Form_Admin_Settings_Global();
//
//    if ($this->getRequest()->isPost() && $form->isValid($this->_getAllParams())) {
//      $values = $form->getValues();
//
//      foreach ($values as $key => $value) {
//        Engine_Api::_()->getApi('settings', 'core')->setSetting($key, $value);
//      }
//      $form->addNotice('Your changes have been saved.');
//    }
//  }

  public function footerAction() {
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sitelinkedin_admin_main', array(), 'sitelinkedin_admin_settings_footer');



    $this->view->form = $form = new Sitelinkedin_Form_Admin_Footertemplates();

    if (!$this->getRequest()->isPost())
      return;

    if (!$form->isValid($this->getRequest()->getPost()))
      return;

    $coreSettings = Engine_Api::_()->getApi('settings', 'core');
    $values = $form->getValues();

    foreach ($values as $key => $value) {
      if ($coreSettings->hasSetting($key, $value)) {
        $coreSettings->removeSetting($key);
      }
      if ($value == null) {
        continue;
      }
      $coreSettings->setSetting($key, $value);
    }

    $form->addNotice('Your changes have been saved.');
  }

//
//  public function configurePagesAction() {
//    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
//      ->getNavigation('sitelinkedin_admin_main', array(), 'sitelinkedin_admin_configure_pages');
//
//
//    $this->view->form = $form = new Sitelinkedin_Form_Admin_Settings_Configure();
//
//    if ($this->getRequest()->isPost() && $form->isValid($this->_getAllParams())) {
//      $values = $form->getValues();
//
//      foreach ($values as $key => $value) {
//        Engine_Api::_()->getApi('settings', 'core')->setSetting($key, $value);
//      }
//      $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
//      $URL = $view->baseUrl() . '/admin/content';
//
//      $settingsTable = Engine_Api::_()->getDbtable('settings', 'core');
//      $row = $settingsTable->fetchRow($settingsTable->select()
//          ->where('name = ?', 'sitelinkedin.template.name'));
//      $template = $row ? $row->value : null;
//      $module = 'sitelinkedin';
//      if ($template) {
//        $module = $template;
//      }
//
//      if ($values['sitelinkedin_landing_page_layout']) {
//        Engine_Api::_()->getApi('pagelayouts', $module)->setDefaultLayout($values);
//      } else {
//        Engine_Api::_()->getApi('pagelayouts', 'sitelinkedin')->restorePageBackup(array('pageUrl' => 'landing_page_backup', 'name' => 'core_index_index'));
//      }
//
//      if ($values['sitelinkedin_header_page_layout']) {
//        Engine_Api::_()->getApi('pagelayouts', 'sitelinkedin')->setHeaderLayout($values);
//      } else {
//        Engine_Api::_()->getApi('pagelayouts', 'sitelinkedin')->restorePageBackup(array('pageUrl' => 'header_backup', 'name' => 'header'));
//      }
//
//      if ($values['sitelinkedin_footer_page_layout']) {
//        Engine_Api::_()->getApi('pagelayouts', 'sitelinkedin')->setFooterLayout($values);
//      } else {
//        Engine_Api::_()->getApi('pagelayouts', 'sitelinkedin')->restorePageBackup(array('pageUrl' => 'footer_backup', 'name' => 'footer'));
//      }
//
//      if ($values['sitelinkedin_login_page_layout']) {
//        Engine_Api::_()->getApi('pagelayouts', 'sitelinkedin')->setSignInPageLayout($values);
//      } else {
//        Engine_Api::_()->getApi('pagelayouts', 'sitelinkedin')->restorePageBackup(array('pageUrl' => 'user_auth_login_backup', 'name' => 'user_auth_login'));
//      }
//
//      if ($values['sitelinkedin_login_required_page_layout']) {
//        Engine_Api::_()->getApi('pagelayouts', 'sitelinkedin')->setSignInRequiredPageLayout($values);
//      } else {
//        Engine_Api::_()->getApi('pagelayouts', 'sitelinkedin')->restorePageBackup(array('pageUrl' => 'core_error_requireuser_backup', 'name' => 'core_error_requireuser'));
//      }
//
//      if ($values['sitelinkedin_signup_page_layout']) {
//        Engine_Api::_()->getApi('pagelayouts', 'sitelinkedin')->setSignUpPageLayout($values);
//      } else {
//        Engine_Api::_()->getApi('pagelayouts', 'sitelinkedin')->restorePageBackup(array('pageUrl' => 'user_signup_index_backup', 'name' => 'user_signup_index'));
//      }
//      $form->addNotice('Your changes have been saved. Please check your pages layout from <a href="' . $URL . '" target="_blank">here</a>.');
//    }
//  }

  public function activateAction() {
    //CHANGE LAYOUT OF HEADER,FOOTER,SIGNIN,SIGNUP AND LANDING PAGE
    Engine_Api::_()->getApi('pagelayouts', 'sitelinkedin')->setDefaultLayout(array('sitelinkedin_landing_page_layout' => 1));
    Engine_Api::_()->getApi('pagelayouts', 'sitelinkedin')->setHeaderLayout(array('sitelinkedin_header_page_layout' => 1));
    Engine_Api::_()->getApi('pagelayouts', 'sitelinkedin')->setFooterLayout(array('sitelinkedin_footer_page_layout' => 1));
    Engine_Api::_()->getApi('pagelayouts', 'sitelinkedin')->setSignInPageLayout(array('sitelinkedin_login_page_layout' => 1));
    Engine_Api::_()->getApi('pagelayouts', 'sitelinkedin')->setSignInRequiredPageLayout(array('sitelinkedin_login_required_page_layout' => 1));
    Engine_Api::_()->getApi('pagelayouts', 'sitelinkedin')->setSignUpPageLayout(array('sitelinkedin_signup_page_layout' => 1));

    $redirect = $this->_getParam('redirect', false);
    if ($redirect == 'install') {
      $this->_redirect('install/manage');
    } elseif ($redirect == 'query') {
      $this->_redirect('install/manage/complete');
    }
  }

  public function signinPopupAction() {
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sitelinkedin_admin_main', array(), 'sitelinkedin_admin_settings_signin_popup');

    $this->view->form = $form = new Sitelinkedin_Form_Admin_Settings_SigninPopup();

    if ($this->getRequest()->isPost() && $form->isValid($this->_getAllParams())) {
      $values = $form->getValues();

      foreach ($values as $key => $value) {
        Engine_Api::_()->getApi('settings', 'core')->setSetting($key, $value);
      }
      $form->addNotice('Your changes have been saved.');
    }
  }

  public function faqAction() {
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sitelinkedin_admin_main', array(), 'sitelinkedin_admin_settings_faq');
    $this->view->faq_id = $faq_id = $this->_getParam('faq', 'faq_1');
  }

  public function footerMenuAction() {
    $this->_redirect('admin/menus/index?name=sitelinkedin_footer');
  }

//  public function placeHtaccessFileAction()
//  {
//    if( $this->getRequest()->isPost() ) {
//      $successfullyAdded = false;
//      $getFileContent = '<FilesMatch ".(ttf|otf|woff)$">
//    Header set Access-Control-Allow-Origin "*"
//</FilesMatch>';
//
//      $global_directory_name = APPLICATION_PATH . '/application/themes/sitelinkedin';
//      $global_settings_file = $global_directory_name . '/.htaccess';
//      $is_file_exist = @file_exists($global_settings_file);
//
//      // IF FILE NOT EXIST THEN CREATE NEW .HTACCESS FILE THERE.
//      if( empty($is_file_exist) ) {
//        if( is_dir($global_directory_name) ) {
//          @mkdir($global_directory_name, 0777);
//
//          $fh = @fopen($global_settings_file, 'w') or die('Unable to create .htaccess file; please give the CHMOD 777 recursive permission to the directory "' . APPLICATION_PATH . '/application/themes/sitelinkedin' . '" and then try again.');
//          @fwrite($fh, $getFileContent);
//          @fclose($fh);
//
//          @chmod($global_settings_file, 0777);
//          $successfullyAdded = true;
//        }
//      } else {
//        if( !is_writable($global_settings_file) ) {
//          @chmod($global_settings_file, 0777);
//          if( !is_writable($global_settings_file) ) {
//            $form->addError('Unable to create .htaccess file; please give the CHMOD 777 recursive permission to the directory "' . APPLICATION_PATH . '/application/themes/sitelinkedin' . '" and then try again.');
//            return;
//          }
//        }
//        $successfullyAdded = @file_put_contents($global_settings_file, $getFileContent);
//      }
//
//      if( !empty($successfullyAdded) ) {
//        $this->_forward('success', 'utility', 'core', array(
//          'smoothboxClose' => 10,
//          'parentRefresh' => 10,
//          'messages' => array('File Succesfully Created.')
//        ));
//      }
//    }
//  }
//
//  public function placeCustomizationFileAction()
//  {
//    if( $this->getRequest()->isPost() ) {
//      $global_directory_name = APPLICATION_PATH . '/application/themes/sitelinkedin';
//      @chmod($global_directory_name, 0777);
//
//      if( !is_readable($global_directory_name) ) {
//        $this->view->error_message = "<span style='color:red'>Note: You do not have readable permission on the path below, please give 'chmod 777 recursive permission' on it to continue with the installation process : <br /> 
//Path Name: <b>" . $global_directory_name . "</b></span>";
//        return;
//      }
//
//      $global_settings_file = $global_directory_name . '/customization.css';
//      $is_file_exist = @file_exists($global_settings_file);
//      if( empty($is_file_exist) ) {
//        @chmod($global_directory_name, 0777);
//        if( !is_writable($global_directory_name) ) {
//          $this->view->error_message = "<span style='color:red'>Note: You do not have writable permission on the path below, please give 'chmod 777 recursive permission' on it to continue with the installation process : <br /> 
//Path Name: " . $global_directory_name . "</span>";
//          return;
//        }
//
//        $fh = @fopen($global_settings_file, 'w');
//        @fwrite($fh, '/* ADD CUSTOM STYLE */');
//        @fclose($fh);
//
//        @chmod($global_settings_file, 0777);
//      }
//
//      $this->_forward('success', 'utility', 'core', array(
//        'smoothboxClose' => 10,
//        'parentRefresh' => 10,
//        'messages' => array('File Succesfully Created.')
//      ));
//    }
//  }



  public function customCssAction() {
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitelinkedin_admin_main', array(), 'sitelinkedin_admin_theme_custom');
    $this->view->subNavigation = $subNavigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitelinkedin_admin_theme_custom', array(), 'sitelinkedin_admin_settings_custom_css');
    $filePath = APPLICATION_PATH . '/application/themes/sitelinkedin/customization.css';
    $isFileExist = @file_exists($filePath);

    $this->view->message = '';
    $this->view->sucess = false;

    if (empty($isFileExist)) {
      $fh = @fopen($filePath, 'w') or die('Unable to write customization CSS file; please give the CHMOD 777 recursive permission to the directory /application/themes/sitelinkedin/, then try again.');
      @fclose($fh);
    } elseif (!is_writable($filePath)) {
      @chmod($filePath, 0777);
      if (!is_writable($filePath)) {
        $this->view->message = 'Unable to write customization CSS file; please give the CHMOD 777 recursive permission to the directory /application/themes/sitelinkedin/, then try again.';
        return;
      }
    }

    $this->view->fileContent = file_get_contents($filePath);

    // Check method/data
    if (!$this->getRequest()->isPost()) {
      return;
    }

    if (!isset($_POST['sitelinkedin_custom_css'])) {
      return;
    }

    if (@file_put_contents($filePath, $_POST['sitelinkedin_custom_css'])) {
      @chmod($filePath, 0777);
      $this->view->message = 'Your changes have been saved.';
      $this->view->sucess = true;
    }
    $this->view->fileContent = $_POST['sitelinkedin_custom_css'];
  }

}
