<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitelinkedin
 * @copyright  Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: InstallController.php 2019-08-28 15:11:20Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitelinkedin_InstallController extends Core_Controller_Action_Standard {

  protected $_token;

  public function init() {
    $this->_helper->contextSwitch->initContext();
    $settingsTable = Engine_Api::_()->getDbtable('settings', 'core');
    $row = $settingsTable->fetchRow($settingsTable->select()
        ->where('name = ?', 'sitelinkedin.install.ssotoken'));
    $this->_token = $row ? $row->value : null;
    $token = $this->_getParam('key', false);
    if ($token != $this->_token) {
      exit(0);
    }
  }

  public function postInstallAction() {
    //CHANGE LAYOUT OF HEADER,FOOTER,SIGNIN,SIGNUP page
    Engine_Api::_()->getApi('pagelayouts', 'sitelinkedin')->setHeaderLayout(array('sitelinkedin_header_page_layout' => 1));
    Engine_Api::_()->getApi('pagelayouts', 'sitelinkedin')->setFooterLayout(array('sitelinkedin_footer_page_layout' => 1));
    Engine_Api::_()->getApi('pagelayouts', 'sitelinkedin')->setDefaultLayout(array('sitelinkedin_landing_page_layout' => 1));

    //    Engine_Api::_()->getApi('pagelayouts', 'sitelinkedin')->setSignInPageLayout(array('sitelinkedin_login_page_layout' => 1));
//    Engine_Api::_()->getApi('pagelayouts', 'sitelinkedin')->setSignInRequiredPageLayout(array('sitelinkedin_login_required_page_layout' => 1));
//    Engine_Api::_()->getApi('pagelayouts', 'sitelinkedin')->setSignUpPageLayout(array('sitelinkedin_signup_page_layout' => 1));
    $settingsTable = Engine_Api::_()->getDbtable('settings', 'core');
    $settingsTable->delete(array('name = ?' => 'sitelinkedin.install.ssotoken'));
    exit(0);
  }

}
