<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitelinkedin
 * @copyright  Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2019-08-28 15:11:20Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitelinkedin_Widget_ContentBannerController extends Seaocore_Content_Widget_Abstract {

  //protected $_childCount;
  public function indexAction() {
    $this->view->title = $this->_getParam('heading') ?: "Welcome to the social world of professionals";
    $this->view->imageSrc = Engine_Api::_()->core()->getFileUrl($this->_getParam('image') ?: "application/modules/Sitelinkedin/externals/images/bannerimg.png");
    $require_check = Engine_Api::_()->getApi('settings', 'core')->core_general_search;
    $this->view->allowToSearch = !(!$require_check && !Zend_Controller_Action_HelperBroker::getStaticHelper('RequireUser')->checkRequire() );
    $searchApi = Engine_Api::_()->getApi('search', 'core');
    $availableTypes = $searchApi->getAvailableTypes();
    $options = array();
    $isSiteadvsearchEnable = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('siteadvsearch');
    if (!$isSiteadvsearchEnable && is_array($availableTypes) && count($availableTypes) > 0) {
      $options = array('' => 'All');
      foreach ($availableTypes as $index => $type) {
        $options[$type] = strtoupper('ITEM_TYPE_' . $type);
      }
    } else if ($isSiteadvsearchEnable) {
      $defaultContents = Engine_Api::_()->getDbtable('contents', 'siteadvsearch')->getContentTypes(4);
      $options = array('' => 'All');
      foreach ($defaultContents as $contentType) {
        if (!empty($contentType->listingtype_id) && !Engine_Api::_()->siteadvsearch()->canViewItemType($contentType->resource_type, $contentType->listingtype_id)) {
          continue;
        }
        $options[$contentType->resource_type] = $contentType->resource_title;
      }
    }

    $this->view->searchOptions = $options;
  }

}
