<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitelinkedin
 * @copyright  Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2019-08-28 15:11:20Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitelinkedin_Widget_ContentFooterController extends Seaocore_Content_Widget_Abstract {

  //protected $_childCount;
  public function indexAction() {

    $coreSettings = Engine_Api::_()->getApi('settings', 'core');
    $this->view->selectFooterLogo = '';
    if($coreSettings->getSetting('sitelinkedin.footer.select.logo')){
        $this->view->selectFooterLogo = Engine_Api::_()->core()->getFileUrl($coreSettings->getSetting('sitelinkedin.footer.select.logo'));    
    }
    $this->view->showFooterLogo = $coreSettings->getSetting('sitelinkedin.footer.show.logo', 1);

    $this->view->footerSocialLinkNavigation = $coreSettings->getSetting('sitelinkedin.fotter.sociallinks', 1) ? Engine_Api::_()->getApi('menus', 'core')->getNavigation('core_social_sites') : null;

    $languagePath = APPLICATION_PATH . '/application/languages';
    $this->view->navigation_menus = Engine_Api::_()
      ->getApi('menus', 'core')
      ->getNavigation('core_footer');

    // Languages
    $translate = Zend_Registry::get('Zend_Translate');
    $languageList = $translate->getList();

    // Prepare default langauge
    $defaultLanguage = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.locale.locale', 'en');
    if ($defaultLanguage == 'auto') {
      $defaultLanguage = 'en';
    }

    // Init default locale
    $localeObject = Zend_Registry::get('Locale');
    $languages = Zend_Locale::getTranslationList('language', $localeObject);
    $territories = Zend_Locale::getTranslationList('territory', $localeObject);

    $localeMultiOptions = array();
    foreach ($languageList as $key) {
      $dir = $languagePath . '/' . $key;
      if (!is_dir($dir)) {
        continue;
      }

      $languageName = null;
      if (!empty($languages[$key])) {
        $languageName = $languages[$key];
      } else {
        $tmpLocale = new Zend_Locale($key);
        $region = $tmpLocale->getRegion();
        $language = $tmpLocale->getLanguage();
        if (!empty($languages[$language]) && !empty($territories[$region])) {
          $languageName = $languages[$language] . ' (' . $territories[$region] . ')';
        }
      }

      if ($languageName) {
        $localeMultiOptions[$key] = $languageName . '';
      }
    }

    if (!isset($localeMultiOptions[$this->view->defaultLanguage])) {
      $defaultLanguage = 'en';
    }

    $this->view->defaultLanguage = $defaultLanguage;
    $this->view->languageNameList = $localeMultiOptions;

    // Get affiliate code
    $this->view->affiliateCode = Engine_Api::_()->getDbtable('settings', 'core')->core_affiliate_code;

    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation("sitelinkedin_footer");
    $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewer->getIdentity();
    $coreVersion = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core')->version;
    $this->view->checkVersion = Engine_Api::_()->seaocore()->checkVersion($coreVersion, '5.3.0');
  }

}
