<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitelinkedin
 * @copyright  Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2019-08-28 15:11:20Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitelinkedin_Widget_headerController extends Engine_Content_Widget_Abstract {

  public function indexAction() {
    if (Zend_Registry::isRegistered('Sitelinkedin_Widget_LandingPageHeader_Render')) {
      return $this->setNoRender();
    }
    $request = Zend_Controller_Front::getInstance()->getRequest();
    $pageIdentity = join('-', array(
      $request->getModuleName(),
      $request->getControllerName(),
      $request->getActionName()
    ));

    $coreSettings = Engine_Api::_()->getApi('settings', 'core');
    $deafultHeaderOptions = array(
      'logo',
      'mini_menu',
      'main_menu',
      'search_box',
    );
    $viewer = Engine_Api::_()->user()->getViewer();
    $logoPath = $coreSettings->getSetting('sitelinkedin.header.logo.image', '');
    $this->view->logoParams = array('logo' => $logoPath);
    if (!$viewer->getIdentity() && $pageIdentity === 'core-index-index') {
      $this->view->displayWidgets = $coreSettings->getSetting('sitelinkedin.header.landing.widgets', array('logo', 'mini_menu'));
      $this->view->logoParams['logo'] = $coreSettings->getSetting('sitelinkedin.header.landing.logo.image', $logoPath);
    } else {
      $this->view->displayWidgets = $viewer && $viewer->getIdentity() ? $coreSettings->getSetting('sitelinkedin.header.loggedin.widgets', $deafultHeaderOptions) : $coreSettings->getSetting('sitelinkedin.header.loggedout.widgets', $deafultHeaderOptions);
    }
    $this->view->displayWidgets = array_diff($this->view->displayWidgets, array('none'));
    if (empty($this->view->displayWidgets)) {
      return $this->setNoRender();
    }
    $this->view->showMenu = true;
    $this->view->headerStyle = $coreSettings->getSetting('sitelinkedin.header.style', '2');

    $this->view->isSitemenuEnable = $isSitemenuEnable = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitemenu');




    $this->view->fixedMenu = $fixedMenu = $coreSettings->getSetting('sitelinkedin.header.menu.fixed', 0);
    $this->view->headerClass = 'sitelinkedin_fullheader_fixed';
    $location = $coreSettings->getSetting('sitelinkedin.header.display.location', 0);
    $showIcons = 0; //$coreSettings->getSetting('sitelinkedin.header.minimenu.design', 1);
    $this->view->miniMenuParams = array(
      'enable_login_lightbox' => 0,
      'enable_signup_lightbox' => 0,
      'changeMyLocation' => $location,
      'show_icon' => $showIcons,
      'show_icons' => $showIcons,
      'sitemenu_show_icon' => $showIcons,
      'show_in_mini_options' => 6, //IN CASE OF 6 ADV MENU SEARCH BAR WILL NOT BE SHOWN IN HEADER
      'sitemenu_show_in_mini_options' => 1000,
      'location_box_width' => ''
    );
    $this->view->signupLoginPopup = $coreSettings->getSetting('sitelinkedin.signin.popup.enable', 1);
    $this->view->popupVisibilty = $coreSettings->getSetting('sitelinkedin.signin.popup.visibility', 0);
    $this->view->popupClosable = $coreSettings->getSetting('sitelinkedin.signin.popup.close', 1);
    $this->view->autoShowPopup = $coreSettings->getSetting('sitelinkedin.signin.popup.display', 1);

    $this->view->menuPosition = $coreSettings->getSetting('sitelinkedin.header.menu.position', 1);
    $desktopMenuCount = $coreSettings->getSetting('sitelinkedin.header.desktop.totalmenu', 6);
    $this->view->fixedMenu = $fixedMenu = $coreSettings->getSetting('sitelinkedin.header.menu.fixed', 0);
    if ($isSitemenuEnable && $coreSettings->getSetting('sitelinkedin.header.sitemainmenu.enable', 1)) {
      $truncationLimit = 200;
      $showCart = $coreSettings->getSetting('sitelinkedin.header.display.cart', 1);
      $location = $coreSettings->getSetting('sitelinkedin.header.display.location', 0);
      $showIcons = $coreSettings->getSetting('sitelinkedin.header.minimenu.design', 1);
//      if ($this->view->headerStyle == 3) {
//        $this->view->fixedMenu = $fixedMenu = $coreSettings->getSetting('sitelinkedin.header.sitemenu.fixed', 0);
//        $this->view->headerClass = ($fixedMenu == 2) ? 'sitelinkedin_fullheader_fixed' : ($fixedMenu == 1 ? 'sitelinkedin_topheader_fixed' : '');
//      }
      $this->view->menuParams = array(
        'sitemenu_on_logged_out' => 1,
        'sitemenu_totalmenu' => $desktopMenuCount,
        'sitemenu_truncation_limit_content' => $truncationLimit,
        'sitemenu_truncation_limit_category' => $truncationLimit,
        'sitemenu_show_cart' => $showCart,
        'sitemenu_is_fixed' => 1,
        'pannelPositions' => 'right',
        'sitemenu_show_link_icon' => $coreSettings->getSetting('sitelinkedin.header.menu.icon', 1), // $this->_getParam('sitemenu_show_link_icon', 0)
        'pannelType' => ($coreSettings->getSetting('sitelinkedin.header.menu.style', 'slide') == 'slide' ? 'fitpage' : 'overlay'),
      );
    }
  }

}
