<?php

class Sitelivestreaming_Api_Core extends Core_Api_Abstract
{
  public function hasPackageEnable($isJoinee = false) {

    $isAllowed = true;
    if(!$isJoinee)
      $isAllowed = Engine_Api::_()->authorization()->isAllowed('livestreamingvideo', Engine_Api::_()->user()->getViewer(), "go_live");

    $isAafEnable = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('advancedactivity');
    $isAdvVideoEnable = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitevideo');

    return ($isAafEnable && $isAdvVideoEnable && $isAllowed && !empty(Engine_Api::_()->getApi('settings', 'core')->getSetting('livestreamingvideo.agora.app.id')) && !empty(Engine_Api::_()->getApi('settings', 'core')->getSetting('livestreamingvideo.url')) && !empty(Engine_Api::_()->getApi('settings', 'core')->getSetting('livestreamingvideo.agora.app.certificate')));
  }

  public function getNetwork($user)
  {
    if(!$user)
      return 0;

    $membershipTable = Engine_Api::_()->getDbtable('membership', 'network');
    $select = $membershipTable
                  ->select()
                  ->where('user_id= ?',$user->getIdentity());
    $network =  $membershipTable->fetchRow($select);
    if(!empty($network)){
      return $network->resource_id;
    }
    return 0;
  }

  public function getMembersOfUserNetwork($networkIds=null)
  {
    if(empty($networkIds))
      return ;

    $membership = Engine_Api::_()->getDbtable('membership', 'network');
    $membershipName = $membership->info('name');
    $select = $membership->select()
                        ->from($membershipName, 'user_id')
                        ->where('resource_id IN (?)',$networkIds)
                        ->where('active = ?',1);

    $members = $membership->fetchAll($select);
    return $members;
  }

  public function getRegistedUsers()
  {
    $table = Engine_Api::_()->getDbtable('users', 'user');
    $tableName = $table->info('name');
    $select = $table->select()
                    ->from($tableName, 'user_id')
                    ->where('verified = ?', 1)
                    ->where('approved = ?', 1)
                    ->where('enabled = ?', 1);

    $result = $table->fetchAll($select);

    return $result;
  }

  public function getFriends($user)
  {
    if(!$user)
      return 0;

    $table = Engine_Api::_()->getDbtable('membership', 'user');
    $tableName = $table->info('name');
    $select = $table->select()
                    ->from($tableName, 'user_id')
                    ->where('resource_id = ?', $user->getIdentity())
                    ->where('active = ?', 1)
                    ->where('user_id != ?', 0);

    $result = $table->fetchAll($select);
    return $result;
  }

  public function getPhotoUrl($fileId)
  {
    if (empty($fileId)){
      return;
    }
    $file = Engine_Api::_()->getDbtable('files', 'storage')->getFile($fileId);
    return $file ? $file->getHref() : '';
  }

  public function setPhoto($photo, $isSmall = false)
  {

    if( $photo instanceof Zend_Form_Element_File ) {
      $file = $photo->getFileName();
      $fileName = $file;
    } else if( is_array($photo) && !empty($photo['tmp_name']) ) {
      $file = $photo['tmp_name'];
      $fileName = $photo['name'];
    } else if( is_string($photo) && file_exists($photo) ) {
      $file = $photo;
      $fileName = $photo;
    } else {
      return;
    }

    if( !$file ) {
      return;
    }
    if( !$fileName ) {
      $fileName = basename($file);
    }

    $extension = ltrim(strrchr(basename($fileName), '.'), '.');
    $base = rtrim(substr(basename($fileName), 0, strrpos(basename($fileName), '.')), '.');
    $path = APPLICATION_PATH . DIRECTORY_SEPARATOR . 'temporary';

    // Save
    $filesTable = Engine_Api::_()->getDbtable('files', 'storage');

    $size = $isSmall ? 500 : 500;
    // Resize image (main)
    $bigBannerPath = $path . DIRECTORY_SEPARATOR . $base . '_b-i.' . $extension;
    $image = Engine_Image::factory();
    $image->open($file)
          ->resize($size, $size)
          ->write($bigBannerPath)
          ->destroy();

    // Store
    $bigBanner = $filesTable->createSystemFile($bigBannerPath);
    // Remove temp files
    @unlink($bigBannerPath);
    return $bigBanner->getIdentity();
  }
}
?>