<?php

class Sitelivestreaming_Model_DbTable_Streams extends Engine_Db_Table {

    protected $_name = 'livestreamingvideo_streams';
    protected $_rowClass = 'Sitelivestreaming_Model_Stream';

	public function getstream($name)
	{
		if(!$name)
			return;

		$select = $this->select()->where('name = ?', $name );
		return $this->fetchRow($select);
	}

	public function getStreamByToken($token)
	{
		if (!$token)
			return;

		$select = $this->select()->where('token = ?', $token);

		return $this->fetchRow($select);
	}

	public function getCountOfStreams($owner_id)
	{
		if (!$owner_id)
			return;

		$select = $this->select()->where('owner_id = ?', $owner_id);

		return count($this->fetchAll($select));
	}

	public function isUserBroadcasting($owner_id)
	{
		return $this->select()->from($this, new Zend_Db_Expr('COUNT(stream_id)'))
					->where('owner_id = ?', $owner_id)
					->where('end_time > NOW()')
					->order('stream_id ASC')
					->limit(1)
					->query()
					->fetchColumn();
	}

	public function stopActiveStreams($owner_id)
	{
		if (!$owner_id)
			return;

		$this->update(array('end_time' => new Zend_Db_Expr('NOW()')), array(
			'owner_id = ?' => $owner_id,
			'end_time > ?' => new Zend_Db_Expr('NOW()')));
	}
}
?>