<?php
class Sitelivestreaming_Plugin_Core extends Zend_Controller_Plugin_Abstract
{

    public function onUserDeleteBefore($event)
    {
        $payload = $event->getPayload();
        if( $payload instanceof User_Model_User ) {
            $streamTable = Engine_Api::_()->getDbTable('streams' , 'sitelivestreaming');
            $streamSelect = $streamTable->select()->where('owner_id = ?', $payload->getIdentity());
            foreach( $streamTable->fetchAll($streamSelect) as $stream ) {
                $stream->delete();
            }
        }
    }

    public function preDispatch(Zend_Controller_Request_Abstract $request)
    {
            $module = strtolower($request->getModuleName());
            $layout = Zend_Layout::getMvcInstance();

            // CHECK IF ADMIN
            if(substr($request->getPathInfo(), 1, 5) == "admin") {
                return;
            }
            // change default layout file for sitelivestreaming module only
            if ($layout->getMvcEnabled() && $module === 'sitelivestreaming')
            {
                $layout->setLayoutPath(APPLICATION_PATH . '/application/modules/' . 'Sitelivestreaming/layouts/scripts/');
                $layout->setLayout('default');
            }
    }
}
?>