<?php
class Sitelivestreaming_AdminSettingsController extends Core_Controller_Action_Admin {

    public function indexAction()
    {
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitelivestreaming_admin_main', array(), 'sitelivestreaming_admin_main_settings');

        $this->view->form  = $form = new Sitelivestreaming_Form_Admin_Global();

        if( !$this->getRequest()->isPost() ) {
            return;
        }
        if( !$form->isValid($this->getRequest()->getPost()) ) {
            return;
        }
        $values = $form->getValues();

        if( !empty($values['livestreamingvideo_background_photo']) && empty($values['remove_photo']) ) {
            $values['livestreamingvideo_background_photo'] = Engine_Api::_()->sitelivestreaming()->setPhoto($form->livestreamingvideo_background_photo);
        }

        if( !empty($values['livestreamingvideo_join_photo']) && empty($values['remove_join_photo']) ) {
            $values['livestreamingvideo_join_photo'] = Engine_Api::_()->sitelivestreaming()->setPhoto($form->livestreamingvideo_join_photo);
        }

        if( empty($values['livestreamingvideo_background_photo']) ) {
            unset($values['livestreamingvideo_background_photo']);
        }
        if( !empty($values['remove_photo']) ) {
            $values['livestreamingvideo_background_photo'] = 0;
        }

        if( isset($values['remove_photo']) ) {
            unset($values['remove_photo']);
        }
        if( empty($values['livestreamingvideo_join_photo']) ) {
            unset($values['livestreamingvideo_join_photo']);
        }
        if( !empty($values['remove_join_photo']) ) {
            $values['livestreamingvideo_join_photo'] = 0;
        }

        if( isset($values['remove_join_photo']) ) {
            unset($values['remove_join_photo']);
        }
        foreach ($values as $key => $value) {
            if( !is_null($value) ) {
                Engine_Api::_()->getApi('settings', 'core')->setSetting($key, $value);
            } else {
                Engine_Api::_()->getApi('settings', 'core')->setSetting($key, '');
            }
        }
        $this->view->form = $form = new Sitelivestreaming_Form_Admin_Global();
        $form->addNotice('Your changes have been saved.');
    }

    public function reportAction()
    {
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitelivestreaming_admin_main', array(), 'sitelivestreaming_admin_main_report');

        //FORM GENERATION
        $this->view->formFilter = $formFilter = new Sitelivestreaming_Form_Admin_Filter();

        $page = $this->_getParam('page',1);

        //GET USER TABLE NAME
        $tableUserName = Engine_Api::_()->getItemTable('user')->info('name');

        $getStreamTable = Engine_Api::_()->getDbtable('streams', 'sitelivestreaming');
        $streamTableName = $getStreamTable->info('name');
        //MAKE QUERY
        $select = $getStreamTable->select()->setIntegrityCheck(false)
                        ->from($streamTableName)
                        ->joinLeft($tableUserName, "$streamTableName.owner_id = $tableUserName.user_id", array('displayname', 'level_id'));

        $values = array();
        if ($formFilter->isValid($this->_getAllParams())) {
            $values = $formFilter->getValues();
        }

        foreach ($values as $key => $value) {
            if (null == $value)
                unset($values[$key]);
        }

        $values = array_merge(array(
            'order' => 'stream_id',
            'order_direction' => 'DESC',
        ), $values);

        if( !empty($values['displayname']) ) {
            $select->where('displayname LIKE ?', '%' . $values['displayname'] . '%');
        }

        if( !empty($values['title']) ) {
            $select->where('title LIKE ?', '%' . $values['title'] . '%');
        }

        if( !empty($values['level_id']) ) {
            $select->where('level_id = ?', $values['level_id']);
        }

        $select->order((!empty($values['order']) ? $values['order'] : 'stream_id' ) . ' ' . (!empty($values['order_direction']) ? $values['order_direction'] : 'DESC' ));

        $this->view->formValues = array_filter($values);
        $this->view->assign($values);

        $this->view->paginator = Zend_Paginator::factory($select);
        $this->view->paginator->setItemCountPerPage(20);
        $this->view->paginator->setCurrentPageNumber($page);
    }

    public function faqsAction()
    {
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitelivestreaming_admin_main', array(), 'sitelivestreaming_admin_main_faqs');
    }
}
?>