<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemagento
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Sponsoredproducts.php 6590 2017-06-22 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemagento_Form_Admin_Widget_Sponsoredproducts extends Engine_Form {

    public function init() {

        $this->setMethod('post');
        $this->setTitle('Sponsored Products')
                ->setDescription('Displays sponsored products as selected by you from the auto-suggest box below.');


        //SHOW PREFIELD START AND END DATETIME
        $httpReferer = $_SERVER['HTTP_REFERER'];
        $params = $toValues = $toValuesArray = array();
        $toValuesString = '';
        if (!empty($httpReferer) && strstr($httpReferer, '?page=')) {
            $httpRefererArray = explode('?page=', $httpReferer);
            $page_id = (int) $httpRefererArray['1'];
        } elseif (!empty($httpReferer) && strstr($httpReferer, 'admin/content') && !strstr($httpReferer, 'admin/content?')) {
            $page_id = 3; //FOR HOME PAGE
        }

        if (!empty($page_id) && is_numeric($page_id)) {

            //GET CONTENT TABLE
            $tableContent = Engine_Api::_()->getDbtable('content', 'core');
            $tableContentName = $tableContent->info('name');

            //GET CONTENT
            $params = $tableContent->select()
                    ->from($tableContentName, array('params'))
                    ->where('page_id = ?', $page_id)
                    ->where('name = ?', 'sitemagento.sponsored-products')
                    ->query()
                    ->fetchColumn();

            if (!empty($params)) {
                $params = Zend_Json_Decoder::decode($params);
            }
        }
        $this->addElement('Hidden', 'toValues', array(
            'label' => '',
            'order' => 1,
            'filters' => array(
                'HtmlEntities'
            ),
        ));
        Engine_Form::addDefaultDecorators($this->toValues);

        $this->addElement('Text', 'product_ids', array(
            'autocomplete' => 'off',
            'decorators' => array(array('ViewScript', array(
                        'viewScript' => '/application/modules/Sitemagento/views/scripts/admin-settings/add-sponsored-products.tpl',
                        'thisObject' => $this,
                        'class' => 'form element')))
        ));
        Engine_Form::addDefaultDecorators($this->product_ids);


        $this->addElement(
                'MultiCheckbox', 'viewTypeOptions', array(
            'label' => 'Select view type to display products.',
            'multiOptions' => array(
                'gridView' => 'Grid View',
                'listView' => 'List View'
            )
                )
        );
        $this->addElement(
                'Select', 'viewType', array(
            'label' => 'Default View type',
            'multiOptions' => array(
                'gridView' => 'Grid View',
                'listView' => 'List View'
            ),
            'value' => 'listView',
                )
        );
        $this->addElement(
                'Select', 'productViewPage', array(
            'label' => 'What you want to open Product view page on same page or new page',
            'multiOptions' => array(
                '0' => 'Same Page',
                '1' => 'New Page'
            ),
            'value' => 0,
                )
        );
        $this->addElement(
                'Text', 'titleTruncation', array(
            'label' => 'Define Product Title truncation limit.',
            'value' => 30,
            'validators' => array(
                array('Int', true),
                array('GreaterThan', true, array(0)),
            ),
                )
        );
    }

}
