<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemagento
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Orderdetails.php 2017-06-22 9:40:21Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */
class Sitemagento_Model_DbTable_Orderdetails extends Engine_Db_Table {

    protected $_name = 'sitemagento_orderdetails';
    protected $_rowClass = 'Sitemagento_Model_Orderdetail';

    public function setOrderdetails($item) {
        $row = $this->createRow();
        $row->order_id = $item['order_id'];
        $row->product_id = $item['product_id'];
        $row->total_incl_tax = $item['total_incl_tax'];
        $row->price = $item['price'];
        $row->quantity = (int)$item['quantity'];
        Engine_Api::_()->getDbTable('products', 'sitemagento')->setProduct($item);
        $row->save();
        return true;
    }

    /**
     * GET THE ORDER DETAILS FROM THE TABLE.
     *
     * @param $data: Array of the information, which need to be filter from the table.
     * @return: array
     */
    public function getOrderDetails($data) {
        $table = $this->info('name');
        $select = $this->select();

        if (!empty($data)) {
            foreach ($data as $key => $value) {
                $select->where('`' . $key . '`=?', $value);
            }
        }
        $fetchArray = $select->query()->fetchAll();
        return $fetchArray;
    }

}
