<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemagento
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Orders.php 2017-06-22 9:40:21Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */
class Sitemagento_Model_DbTable_Orders extends Engine_Db_Table {

    protected $_name = 'sitemagento_orders';
    protected $_rowClass = 'Sitemagento_Model_Order';

    /**
     * SET THE ORDER INTO THE TABLE.
     *
     * @param $data: Array of the information, which need to be insert into the table.
     * @return
     */
    public function setOrder($order) {
        $row = $this->createRow();
        $row->order_id = $order['order_id'];
        $row->owner_id = $order['owner_id'];
        $row->quantity = (int)$order['quantity'];
        $row->grand_total = $order['grand_total'];
        $row->sub_total = $order['sub_total'];
        $row->shipping_amount = $order['shipping_amount'];
        $row->currency = $order['currency'];
        $row->save();
        $items = $order['items'];
        foreach ($items as $item) {
            Engine_Api::_()->getDbTable('orderdetails', 'sitemagento')->setOrderdetails($item);
        }
        return true;
    }

}
