<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemagento
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Orders.php 2017-06-22 9:40:21Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */
class Sitemagento_Model_DbTable_Wishlists extends Engine_Db_Table {

    protected $_name = 'sitemagento_wishlists';
    protected $_rowClass = 'Sitemagento_Model_Wishlist';

    /**
     * SET THE ORDER INTO THE TABLE.
     *
     * @param $data: Array of the information, which need to be insert into the table.
     * @return
     */
    public function setWishlist($wishlist) {
        $wishlistObj = $this->getWishlistById($wishlist['wishlist_item_id']);
        if (!empty($wishlistObj)) {
            return $wishlistObj->getIdentity();
        }
        $row = $this->createRow();
        $row->wishlist_id = $wishlist['wishlist_item_id'];
        $row->product_id = $wishlist['product_id'];
        $row->price = $wishlist['price'];
        $row->min_price = $wishlist['min_price'];
        $row->max_price = $wishlist['max_price'];
        $row->currency = $wishlist['currency'];
        $row->type_id = $wishlist['type_id'];
        $row->save();
        Engine_Api::_()->getDbTable('products', 'sitemagento')->setProduct($wishlist);
        return $row->getIdentity();
    }

    public function getWishlistById($wishlistId) {
        return Engine_Api::_()->getItem('sitemagento_wishlist', $wishlistId);
    }

}
