<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemagento
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 2017-06-22 9:40:21Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */
class Sitemagento_Plugin_Core {

    protected $_session;

    public function __construct() {
        $this->_session = new Zend_Session_Namespace('Sitemagento_Flag');
    }

    public function onRenderLayoutDefault($event) {

        $host = Engine_Api::_()->sitemagento()->getMagentoHostUrl();
        $session = new Zend_Session_Namespace();
        $front = Zend_Controller_Front::getInstance();
        $reqFormat = $front->getRequest()->getParam('format');
        if ($front->getRequest()->isXmlHttpRequest() || $reqFormat == 'smoothbox') {
            return;
        }
        $module = $front->getRequest()->getModuleName();
        $action = $front->getRequest()->getActionName();
        $controller = $front->getRequest()->getControllerName();
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();
        $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;

        if (isset($this->_session->_flag)) {
            $flag = $this->_session->_flag;
            $this->_session->unsetAll();
            $url = $host . '/seint/general?data=' . $flag;
            echo "<img src='$url' style='display:none;' />";
        }

        if (!empty($_COOKIE['se_flag'])) {
            $dataString = base64_decode($_COOKIE['se_flag']);
            $data = unserialize($dataString);
            if ($data['type'] == 'login' && !empty($data['email'])) {
                $userTable = Engine_Api::_()->getItemTable('user');
                $tableName = $userTable->info('name');

                $selectTable = $userTable->select()->from($tableName, array('user_id'))->where("email =?", $data['email']);
                $user = $selectTable->query()->fetch();
                if (!empty($user)) {
                    $data['user_id'] = $user['user_id'];
                    Zend_Auth::getInstance()->getStorage()->write($user['user_id']);
                    Engine_Api::_()->sitemagento()->createUser($data);
                    // Unset the COOKIE.
                    setcookie("se_flag", "", time() - 3600, "/");
                    Zend_Controller_Action_HelperBroker::getStaticHelper('redirector')->gotoRoute(array(), 'default', false);
                }
            } elseif ($data['type'] == 'logout') {
                setcookie('se_flag', "", time() - 3600, "/");
                if (!empty($viewer_id)) {
                    $redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
                    $redirector->gotoRoute(array('module' => 'user', 'action' => 'logout', 'controller' => 'auth'), 'user_logout', true);
                }
            }
        }
        // Update the First name, Last name and email id in the magento site.
        if (((strstr($module, 'user') && strstr($controller, 'edit') && strstr($action, 'profile')) || (strstr($module, 'user') && strstr($controller, 'settings') && strstr($action, 'general'))) && !empty($viewer) && !empty($_POST)) {
            $firstName = $lastName = null;
            $aliasValues = Engine_Api::_()->fields()->getFieldsValuesByAlias($viewer);
            if (!empty($aliasValues)) {
                $firstName = !empty($aliasValues['first_name']) ? $aliasValues['first_name'] : null;
                $lastName = !empty($aliasValues['last_name']) ? $aliasValues['last_name'] : null;
            }
            $getUsersInfo = Engine_Api::_()->getDbTable('users', 'sitemagento')->getUser(array('se_user_id' => $viewer_id));
            $getUsersInfo = end($getUsersInfo);
            $customerId = !empty($getUsersInfo['mage_user_id']) ? $getUsersInfo['mage_user_id'] : 0;
            $params = array(
                'apiType' => 'createCustomer',
                'method' => 'PUT',
                'parameters' => array(
                    'customer' => array(
                        "id" => $customerId,
                        "email" => $viewer->email,
                        "firstname" => $firstName,
                        "lastname" => $lastName,
                        "storeId" => 1,
                        "websiteId" => 1
                    )
                ),
                'otherparameters' => array(
                    'id' => $customerId
                )
            );
            $response = Engine_Api::_()->getApi('Request', 'sitemagento')->client_api_connect($params);
            if ($response['is_error'] == false && !empty($response['response_output'])) {
                Engine_Api::_()->getDbtable("users", "sitemagento")->update(array("mage_user_id" => $customerId, "name" => $firstName . ' ' . $lastName, "enable" => true), array('se_user_id =?' => $viewer->getIdentity()));
            }
        }
        // Change Password for the Magento Customer, If password changed from the SocialEngine.
        if (strstr($module, 'user') && strstr($controller, 'settings') && strstr($action, 'password') && !empty($viewer) && !empty($_POST)) {

            // Checkout the old password is correct or not.
            $userTable = Engine_Api::_()->getItemTable('user');
            $db = $userTable->getAdapter();

            // Check old password
            $salt = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.secret', 'staticSalt');
            $select = $userTable->select()
                    ->from($userTable, new Zend_Db_Expr('TRUE'))
                    ->where('user_id = ?', $viewer_id)
                    ->where('password = ?', new Zend_Db_Expr(sprintf('MD5(CONCAT(%s, %s, salt))', $db->quote($salt), $db->quote($_POST['password']))))
                    ->limit(1)
            ;
            $valid = $select
                    ->query()
                    ->fetchColumn()
            ;
            if (!empty($valid)) {
                if ($_POST['passwordConfirm'] === $_POST['password']) {
                    $getUsersInfo = Engine_Api::_()->getDbTable('users', 'sitemagento')->getUser(array('se_user_id' => $viewer_id));
                    $getUsersInfo = end($getUsersInfo);
                    $customerId = !empty($getUsersInfo['mage_user_id']) ? $getUsersInfo['mage_user_id'] : 0;
                    $params = array(
                        'apiType' => 'changePassword',
                        'method' => 'PUT',
                        'parameters' => array(
                            'email' => $viewer->email,
                            'currentPassword' => $_POST['oldPassword'],
                            'newPassword' => $_POST['password']
                        )
                    );
                    $response = Engine_Api::_()->getApi('Request', 'sitemagento')->client_api_connect($params);
                }
            }
        }

// If user not login in SocialEngine and login in Magento then should be logout from magento.
        if (empty($viewer_id)) {
            $data = array();
            $data['type'] = 'logout';
            $dataString = serialize($data);
            $dataString = base64_encode($dataString);
            $this->_session->_flag = $dataString;
        }
        if (!empty($viewer_id)) {
            $seuser = Engine_Api::_()->getDbtable("users", "sitemagento")->getUser(array('se_user_id' => $viewer_id));
            $seuser = end($seuser);
            if ($seuser) {
                $data = array();
                $data['type'] = 'login';
                $data['id'] = $seuser['mage_user_id'];
                $dataString = serialize($data);
                $dataString = base64_encode($dataString);
                $this->_session->_flag = $dataString;
            }
        }
        if (!Engine_Api::_()->hasModuleBootstrap('sitemenu')) {
            $cartInfo = Engine_Api::_()->sitemagento()->getCartInfo();
            //Calling cart related js
            $cartItems = array();
            $itemsQty = 0;
            $totalSubtoal = 0;
            $currencyCode = $checkoutUrl = '';
            if (is_array($cartInfo) && count($cartInfo) > 0) {
                $cartItems = $cartInfo['items'];
                $itemsQty = $cartInfo['items_qty'];
                $currencyCode = $cartInfo['base_currency_symbol'];
                $totalSubtoal = $cartInfo['base_subtotal'];
                $checkoutUrl = $cartInfo['checkout_url'];
            }
            $selectedOption = json_encode($cartItems);
            $shoppingUrl = Engine_Api::_()->sitemagento()->getMagentoHostUrl();
            $script = <<<EOF
            var sitemagentoSelectListHandler;
        
            en4.core.runonce.add(function() { 
            try {
              sitemagentoSelectListHandler = new SitemagentoSelectListHandler({
                'ALL_CART_ITEMS' : '{$selectedOption}',
                'TOTAL_QUANTITY' : {$itemsQty},
                'SUBTOTAL' : '{$totalSubtoal}',
                'CURRENCYCODE' : '{$currencyCode}',
                'CHECKOUT_URL' : '{$checkoutUrl}',
                'SHOPPING_URL' : '{$shoppingUrl}',
                    
              });
 
              sitemagentoSelectListHandler.start();  
            } catch( e ) {
               console.log(e);
            }
        });

        en4.core.runonce.add(function(){
          new SEAOMooVerticalScroll('core_menu_scroll_outer', 'core_menu_scroll_inner', {});
        });
EOF;
            $view->headScript()
                    ->appendFile($view->layout()->staticBaseUrl . 'application/modules/Sitemagento/externals/scripts/cart.js')
                    ->appendScript($script);
            $view->headScript()->appendFile($view->layout()->staticBaseUrl . 'application/modules/Seaocore/externals/scripts/seaomooscroll/SEAOMooVerticalScroll.js');
        }
    }

// Do customer Logout from Magento side.
    public function onUserLogoutBefore($event) {
        $payload = $event->getPayload();
        $existUser = Engine_Api::_()->getDbtable("users", "sitemagento")->existUser(array("se_user_id" => $payload->getIdentity()));
        if ($existUser) {
            $data = array();
            $data['type'] = 'logout';
            $dataString = serialize($data);
            $dataString = base64_encode($dataString);
            $url = $host . '/seint/general?data=' . $dataString;
            echo "<img src='$url' style='display:none;' />";
        }
    }

    public function onUserCreateAfter($event) {
        $payload = $event->getPayload();
        $email = $_SESSION["User_Plugin_Signup_Account"]["data"]["email"];
        $password = !empty($_SESSION["User_Plugin_Signup_Account"]["data"]["password"]) ? $_SESSION["User_Plugin_Signup_Account"]["data"]["password"] : null;
//$websiteId = Engine_Api::_()->siteestore()->getWebsite('id');

        if (empty($password) || empty($payload) || ($email != $payload->email)) {
            return;
        }

        $firstName = $lastName = $email = null;
        $fname_id = $lname_id = false;

// Getting the "First Name" & "Last Name" from the SocialEngine signup form.
        foreach ($_SESSION["User_Plugin_Signup_Fields"]["data"] as $key => $value) {
            $userMeta = Engine_Api::_()->fields()->getTable('user', 'meta')->getMetaById($key);
            if (strstr($userMeta->type, "first_name")) {
                $fname_id = $userMeta->field_id;
            } else if (strstr($userMeta->type, "last_name")) {
                $lname_id = $userMeta->field_id;
            }

            if (!empty($fname_id) && !empty($lname_id))
                break;
        }
        $firstName = !empty($_SESSION["User_Plugin_Signup_Fields"]["data"][$fname_id]) ? $_SESSION["User_Plugin_Signup_Fields"]["data"][$fname_id] : null;
        $lastName = !empty($_SESSION["User_Plugin_Signup_Fields"]["data"][$lname_id]) ? $_SESSION["User_Plugin_Signup_Fields"]["data"][$lname_id] : null;
        $params = array(
            'apiType' => 'createCustomer',
            'parameters' => array(
                'customer' => array(
                    "email" => $payload->email,
                    "firstname" => $firstName,
                    "lastname" => $lastName,
                    "storeId" => 1,
                    "websiteId" => 1
                ),
                "password" => $password
            )
        );
        $response = Engine_Api::_()->getApi('Request', 'sitemagento')->client_api_connect($params);
        if ($response['is_error'] == false && !empty($response['response_output'])) {
            $createUser = $response['response_output'];
// Insert in users Table.
            Engine_Api::_()->getDbtable("users", "sitemagento")->setUser(array("mage_user_id" => $createUser['id'], "se_user_id" => $payload->user_id, "name" => $firstName . ' ' . $lastName, "enable" => true));
            $data = array();
            $data['type'] = 'login';
            $data['id'] = $createUser['id'];
            $dataString = serialize($data);
            $dataString = base64_encode($dataString);
            $this->_session->_flag = $dataString;
        }
    }

    public function onUserLoginAfter($event) {
        $viewer = Engine_Api::_()->user()->getViewer();
        $postEmail = !empty($_POST['email']) ? $_POST['email'] : $viewer->email;
        $postPassword = !empty($_POST['password']) ? $_POST['password'] : '';
        if (empty($postEmail) || empty($postPassword)) {
            return;
        }

// Find out the "First Name" & "Last Name" of the login user from the fields table.
        $firstName = $lastName = null;
        $aliasValues = Engine_Api::_()->fields()->getFieldsValuesByAlias($viewer);
        if (!empty($aliasValues)) {
            $firstName = !empty($aliasValues['first_name']) ? $aliasValues['first_name'] : null;
            $lastName = !empty($aliasValues['last_name']) ? $aliasValues['last_name'] : null;
        }
        $name = $viewer->getTitle();
        $namep = explode(' ', $name);
        $fname = $namep[0];
        $lname = isset($namep[1]) ? $namep[1] : $namep[0];

        if (empty($firstName) && empty($lastName)) {
            $firstName = $fname;
            $lastName = $lname;
        } elseif (empty($firstName) && !empty($lastName)) {
            $firstName = $fname;
        } elseif (!empty($firstName) && empty($lastName)) {
            $lastName = $lname;
        }
// Login user in magento through cUrl. If user not exist or user entry not correct in magento side then it return false result else return true result.
        $params = array(
            'apiType' => 'authenticateCustomer',
            'method' => 'get',
            'parameters' => array(
                'email' => $postEmail,
                "password" => $postPassword
            )
        );
        $customerId = 0;
        $response = Engine_Api::_()->getApi('Request', 'sitemagento')->client_api_connect($params);
        $customer = $response['response_output'];
        if ($response['is_error'] == true || empty($response['response_output'])) {
            $email = null;
            $email = !empty($viewer->email) ? $viewer->email : null;
            if (empty($postPassword) || empty($postEmail) || empty($email)) {
                return;
            }

            /*
              User not able to login in Magento. Here we have two case:
              Case 1: May be user details ( Email or Password ) has been changed in SocialEngine.
              Case 2: May be User doing first time login and don't have account in magento.
             */

// Check in "sitemagento_users" table, If "Magento Customer Id" and "SocialEngine User Id" exist in table then we are assume "Case 1" and follow respective steps else assume "Case 2" and follow respective steps.
            $existUser = Engine_Api::_()->getDbtable("users", "sitemagento")->existUser(array("se_user_id" => $viewer->getIdentity()));
// Follow Case 2.
            if (empty($existUser)) {

// May be User doing first time loggin and don't have account in magento. So we create user as customer in magento through XML-RPC.
                $params = array(
                    'apiType' => 'createCustomer',
                    'parameters' => array(
                        'customer' => array(
                            "email" => $postEmail,
                            "firstname" => $firstName,
                            "lastname" => $lastName,
                            "storeId" => 1,
                            "websiteId" => 1
                        ),
                        "password" => $postPassword
                    )
                );
                $response = Engine_Api::_()->getApi('Request', 'sitemagento')->client_api_connect($params);
                $customer = $response['response_output'];
                if ($response['is_error'] == false && !empty($response['response_output'])) {
                    $customerId = $customer['id'];
                    Engine_Api::_()->getDbtable("users", "sitemagento")->setUser(array("mage_user_id" => $customer['id'], "se_user_id" => $viewer->getIdentity(), "name" => $firstName . ' ' . $lastName, "enable" => true));
                }
            } else { // Follow Case 1.
// Update the user information in "Magento" side through XML-RPC bridge.
                $params = array(
                    'apiType' => 'createCustomer',
                    'method' => 'PUT',
                    'parameters' => array(
                        'customer' => array(
                            "id" => $existUser["mage_user_id"],
                            "email" => $postEmail,
                            "firstname" => $firstName,
                            "lastname" => $lastName,
                            "storeId" => 1,
                            "websiteId" => 1
                        ),
                        "password" => $password
                    ),
                    'otherparameters' => array(
                        'id' => $existUser["mage_user_id"]
                    )
                );
                $response = Engine_Api::_()->getApi('Request', 'sitemagento')->client_api_connect($params);
                $customerId = $existUser["mage_user_id"];
                if ($response['is_error'] == false && !empty($response['response_output'])) {
                    Engine_Api::_()->getDbtable("users", "sitemagento")->update(array("mage_user_id" => $existUser["mage_user_id"], "se_user_id" => $viewer->getIdentity(), "name" => $firstName . ' ' . $lastName, "enable" => true), array('se_user_id =?' => $viewer->getIdentity()));
                }
            }
        } else {
            $customerId = $customer['id'];
            $isUserExist = Engine_Api::_()->getDbtable("users", "sitemagento")->getUser(array('se_user_id' => $viewer->getIdentity()));
            if (empty($isUserExist)) {
                Engine_Api::_()->getDbtable("users", "sitemagento")->setUser(array("mage_user_id" => $customer['id'], "se_user_id" => $viewer->getIdentity(), "name" => $firstName . ' ' . $lastName, "enable" => true));
            } else {
                Engine_Api::_()->getDbtable("users", "sitemagento")->update(array("mage_user_id" => $customer['id'], "se_user_id" => $viewer->getIdentity(), "name" => $firstName . ' ' . $lastName, "enable" => true), array('se_user_id =?' => $viewer->getIdentity()));
            }
        }
//Now need to do login into Magento site
        if (!empty($customerId)) {
            $data = array();
            $data['type'] = 'login';
            $data['id'] = $customerId;
            $dataString = serialize($data);
            $dataString = base64_encode($dataString);
            $this->_session->_flag = $dataString;
        }
    }

// Delete customer from magento side with the help of XMl-RPC.
    public function onUserDeleteAfter($event) {
        $payload = $event->getPayload();
        $existUser = Engine_Api::_()->getDbtable("users", "sitemagento")->existUser(array("se_user_id" => $payload['identity']));
        if (!empty($existUser)) {
// Delete User from Magento Side.
            $params = array(
                'apiType' => 'deleteCustomer',
                'method' => 'DELETE',
                'otherparameters' => array(
                    'id' => $existUser["mage_user_id"]
                )
            );
            $response = Engine_Api::_()->getApi('Request', 'sitemagento')->client_api_connect($params);
        }
        Engine_Api::_()->getDbtable("users", "sitemagento")->deleteUser(array("se_user_id" => $payload['identity']));
    }

}
