<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemagento
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: PurchaseRichContent.php 2017-06-22 9:40:21Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */
class Sitemagento_View_Helper_PurchaseRichContent extends Zend_View_Helper_Abstract {

    public function purchaseRichContent($id) {
        $richStr = '';
        $flag = 0;
        $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
        $order = Engine_Api::_()->getItem('sitemagento_order', $id);

        if (empty($order)) {
            return;
        }
        $orderItems = Engine_Api::_()->getDbTable('orderdetails', 'sitemagento')->getOrderDetails(array('order_id' => $order->order_id));

        if (empty($orderItems) || empty($orderItems[0]['product_id']))
            return;
        $productsCount = @COUNT($orderItems);
        $maxItem = 4;
        foreach ($orderItems as $item) {

            $moreClassName = '';
            if ($flag >= $maxItem) {
                $moreClassName = 'sitemagento_more_items product_info_order_' . $id;
            }
            $product = Engine_Api::_()->getItem('sitemagento_product', $item['product_id']);
            if (empty($product)) {
                continue;
            }
            $RESOURCE_TYPE = 'sitemagento_product';
            $order_id = $item['order_id'];
            $sub_title = str_replace("'", '"', $product->getTitle());
            $title = '<span class="mint_pp_title"> ' . $view->htmlLink($product->url, Engine_Api::_()->sitemagento()->truncateStr($product->getTitle(),23), array('title' => $sub_title, 'target' => '_blank', 'class' => 'sea_add_tooltip_link', 'rel' => $RESOURCE_TYPE . ' ' . $item['product_id'])) . '</span>';
            $price = "<span class='mint_pp_qty'>Quantity: " . (int) $item['quantity'] . '</span><span class="mint_pp_price"> ' . $order->currency . number_format($item['price'], 2, '.', ',') . "</span>";
            $imagePath = $view->layout()->staticBaseUrl . "application/modules/Sitemagento/externals/images/default.png";
            $photoURL = $product->image_url;
            $photoURL = !empty($photoURL) ? $photoURL : $imagePath;
            $image = "<div class='feeds_image'><a href='" . $product->url . "' target='_blank' class = 'sea_add_tooltip_link' rel = '$RESOURCE_TYPE " . $item['product_id'] . "'>" . '<img class="mint_pp_img" src="' . $photoURL . '" />' . '</a></div>';
            $viewMore = "";
            if ($productsCount > $maxItem && $maxItem == $flag + 1) {
                $viewMore = "<span id='view-more' class='view_more_$id' onclick='showMoreOrderItems($id)' >+" . (count($orderItems) - $maxItem) . "</span>";
            }
            $product = '<div  class="product_info ' . $moreClassName . '" >' . $image . '<div class="feeds_content">' . $title . '' . $price . $viewMore . '</div></div>';

            $richStr .= $product;

            $flag++;
        } 
        $richStr = rtrim($richStr, ", ");
        $script = <<<EOF
   <script>         
   function showMoreOrderItems(orderId){
            $$('.product_info_order_'+orderId).removeClass('sitemagento_more_items')
            $$('.view_more_'+orderId).hide();
   }            
                </script>
EOF;
        return $richStr . $script;
    }

}
