<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemagento
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminSettingsController.php 2017-06-22 9:40:21Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */
class Sitemagento_AdminSettingsController extends Core_Controller_Action_Admin {

    public function indexAction() {
        include APPLICATION_PATH . '/application/modules/Sitemagento/controllers/license/license1.php';
    }

    public function faqAction() {
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitemagento_admin_main', array(), 'sitemagento_admin_main_faq');
    }

    public function readmeAction() {
        
    }

    public function getProductWidgetParamsAction() {
        $content_id = isset($_GET['content_id']) ? $_GET['content_id'] : 0;
        $toValues = $toValuesArray = array();
        $params = array();
        $toValuesString = '';
        if ($content_id) {

            //GET CONTENT TABLE
            $tableContent = Engine_Api::_()->getDbtable('content', 'core');
            $tableContentName = $tableContent->info('name');
            //GET CONTENT
            $params = $tableContent->select()
                    ->from($tableContentName, array('params'))
                    ->where('content_id = ?', $content_id)
                    // ->where('name = ?', 'sitemagento.sponsored-products')
                    ->query()
                    ->fetchColumn();

            if (!empty($params)) {
                $params = Zend_Json_Decoder::decode($params);
                if (isset($params['toValues']) && !empty($params['toValues'])) {
                    $toValues = $params['toValues'];
                    if (!empty($toValues)) {
                        $toValues = explode(',', $toValues);
                        $toValues = array_unique($toValues);
                        $toValuesString = implode(',', $toValues);
                        $toValuesArray = array();
                        $prIds = array();
                        foreach ($toValues as $key => $id) {
                            $prIds[] = $id;
                        }
                        $packet = array(
                            'apiType' => 'getProductsPrice',
                            'method' => 'POST',
                            'parameters' => array(
                                'productIds' => $prIds
                            )
                        );
                        $response = Engine_Api::_()->getApi('Request', 'sitemagento')->client_api_connect($packet);
                        if ($response['is_error'] == false && !empty($response['response_output'])) {
                            $prds = $response['response_output'];
                            $k = 0;
                            foreach ($prds as $key => $p) {
                                if (!empty($p['product_id'])) {
                                    $toValuesArray[$k]['id'] = $p['product_id'];
                                    $toValuesArray[$k]['title'] = $p['name'];
                                    $vid[] = $p['product_id'];
                                    $k++;
                                }
                            }
                        }
                        $toValuesString = implode(',', $vid);
                    }
                }
            }
        }
        $this->view->toValuesArray = $toValuesArray;
        $this->view->toValuesString = $toValuesString;
    }

    public function getProductsAction() {
        $data = array();
        $text = $this->_getParam('text');
        $sreachCriteria = array(
            'searchCriteria[sortOrders][0][field]' => 'name',
            'searchCriteria[sortOrders][0][direction]' => 'ASC',
            'searchCriteria[pageSize]' => 25,
            'searchCriteria[filterGroups][0][filters][0][field]' => 'name',
            'searchCriteria[filterGroups][0][filters][0][value]' => '%' . $text . '%',
            'searchCriteria[filterGroups][0][filters][0][conditionType]' => 'like',
            'searchCriteria[filterGroups][1][filters][0][field]' => 'type_id',
            'searchCriteria[filterGroups][1][filters][0][value]' => 'virtual',
            'searchCriteria[filterGroups][1][filters][0][conditionType]' => 'neq',
            'searchCriteria[filterGroups][3][filters][0][field]' => 'status',
            'searchCriteria[filterGroups][3][filters][0][value]' => 1,
            'searchCriteria[filterGroups][3][filters][0][conditionType]' => 'eq',
            'searchCriteria[filterGroups][4][filters][0][field]' => 'visibility',
            'searchCriteria[filterGroups][4][filters][0][value]' => 1,
            'searchCriteria[filterGroups][4][filters][0][conditionType]' => 'neq',
        );
        $packet = array(
            'apiType' => 'getProducts',
            'method' => 'GET',
            'queryParameters' => $sreachCriteria
        );
        $response = Engine_Api::_()->getApi('Request', 'sitemagento')->client_api_connect($packet);
        if ($response['is_error'] == false && !empty($response['response_output']) && !empty($response['response_output']['total_count']) && ($response['response_output']['total_count']) > 0) {
            $items = $response['response_output']['items'];
            foreach ($items as $item) {
                $images = Engine_Api::_()->sitemagento()->getImages($item);
                $imageUrl = Engine_Api::_()->sitemagento()->checkProductImage($images);
                $imageUrl = !empty($imageUrl) ? $imageUrl : $this->view->layout()->staticBaseUrl . "application/modules/Sitemagento/externals/images/default.png";
                $image = "<img src='$imageUrl' >";
                $data[] = array(
                    'id' => $item['id'],
                    'label' => $item['name'],
                    'photo' => $image
                );
            }
        }

        return $this->_helper->json($data);
    }

}
