<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemagento
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: FeedController.php 2017-06-22 9:40:21Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */
class Sitemagento_FeedController extends Core_Controller_Action_Standard {
    /*
     * This action used to make purchase feed in Socialengine when purchase is completed on Magento.
     */

    public function purchaseFeedAction() {

        if (empty($_GET['orders_info'])) {
            exit();
        }
        $settings = Engine_Api::_()->getApi('settings', 'core');
        if ($settings->getSetting('sitemagento.purchase.feed', 1) == 0) {
            exit();
        }
        $ordersInfo = $_GET['orders_info'];
        $ordersInfo = base64_decode($ordersInfo);
        $ordersInfo = unserialize($ordersInfo);

        if (empty($ordersInfo) || empty($ordersInfo['email']) || empty($ordersInfo['orders'])) {
            exit();
        }

        $orders = $ordersInfo['orders'];
        $customerEmail = $ordersInfo['email'];
        $userTable = Engine_Api::_()->getItemTable('user');
        $tableName = $userTable->info('name');
        $sitemagentoPurchaseFeed = Zend_Registry::isRegistered('sitemagentoPurchaseFeed') ? Zend_Registry::get('sitemagentoPurchaseFeed') : null;

        // Create user in SocialEngine.
        $selectTable = $userTable->select()->from($tableName, array('user_id'))->where("email =?", $customerEmail);
        $user = $selectTable->query()->fetch();
        if (empty($user)) {
            exit();
        }
        if (empty($sitemagentoPurchaseFeed))
            exit();
        $viewer = Engine_Api::_()->getItem('user', $user['user_id']);
        foreach ($orders as $order) {
            $order['owner_id'] = $viewer->getIdentity();
            Engine_Api::_()->getDbTable('orders', 'sitemagento')->setOrder($order);
            $orderObj = Engine_Api::_()->getItem('sitemagento_order', $order['order_id']);

            // Auth activity feed.
            $auth = Engine_Api::_()->authorization()->context;
            $roles = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
            foreach ($roles as $role) {
                $auth->setAllowed($orderObj, $role, 'view', 1);
                $auth->setAllowed($orderObj, $role, 'comment', 1);
            }
            // Send activity feed.
            $action = Engine_Api::_()->getDbtable('actions', 'activity')->addActivity($viewer, $orderObj, 'sitemagento_purchase', null, array('count' => (int) $order['quantity']));
            if ($action) {
                Engine_Api::_()->getDbtable('actions', 'activity')->attachActivity($action, $orderObj);
            }
        }
    }

    public function wishlistFeedAction() {

        if (empty($_GET['products_info'])) {
            exit();
        }

        $settings = Engine_Api::_()->getApi('settings', 'core');
        if ($settings->getSetting('sitemagento.wishlist.feed', 1) == 0) {
            exit();
        }

        $productsInfo = $_GET['products_info'];

        $productsInfo = base64_decode($productsInfo);
        $productsInfo = unserialize($productsInfo);

        if (empty($productsInfo) || empty($productsInfo['email']) || empty($productsInfo['product_id'])) {
            exit();
        }

        $customerEmail = $productsInfo['email'];
        $product = $productsInfo;
        $userTable = Engine_Api::_()->getItemTable('user');
        $tableName = $userTable->info('name');
        $sitemagentoWishlistFeed = Zend_Registry::isRegistered('sitemagentoWishlistFeed') ? Zend_Registry::get('sitemagentoWishlistFeed') : null;

        // Create user in SocialEngine.
        $selectTable = $userTable->select()->from($tableName, array('user_id'))->where("email =?", $customerEmail);
        $user = $selectTable->query()->fetch();
        if (empty($user)) {
            exit();
        }
        if (empty($sitemagentoWishlistFeed))
            exit();
        $viewer = Engine_Api::_()->getItem('user', $user['user_id']);
        $product['owner_id'] = $viewer->getIdentity();
        $wishlistId = Engine_Api::_()->getDbTable('wishlists', 'sitemagento')->setWishlist($product);
        $wishlistObj = Engine_Api::_()->getItem('sitemagento_wishlist', $wishlistId);

        // Auth activity feed.
        $auth = Engine_Api::_()->authorization()->context;
        $roles = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
        foreach ($roles as $role) {
            $auth->setAllowed($wishlistObj, $role, 'view', 1);
            $auth->setAllowed($wishlistObj, $role, 'comment', 1);
        }
        Engine_Api::_()->getDbtable('actions', 'activity')->removeActivities($viewer, $wishlistObj, 'sitemagento_add_wishlist');
        // Send activity feed.
        $action = Engine_Api::_()->getDbtable('actions', 'activity')->addActivity($viewer, $wishlistObj, 'sitemagento_add_wishlist', null, array());
        if ($action) {
            Engine_Api::_()->getDbtable('actions', 'activity')->attachActivity($action, $wishlistObj);
        }
    }

}
