<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemagento
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: IndexController.php 2017-06-22 9:40:21Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */
class Sitemagento_IndexController extends Core_Controller_Action_Standard {

    public function getMagentoCartProductsAction() {
        $cartInfo = Engine_Api::_()->sitemagento()->getCartInfo();
        $this->view->cartItems = array();
        $this->view->totalQuantity = $this->view->subtotal = 0;
        $this->view->checkoutUrl = $this->view->currencyCode = '';
        if (is_array($cartInfo) && count($cartInfo) > 0) {
            $this->view->cartItems = $cartInfo['items'];
            $this->view->totalQuantity = $cartInfo['items_qty'];
            $this->view->currencyCode = $cartInfo['base_currency_symbol'];
            $this->view->subtotal = $cartInfo['base_subtotal'];
            $this->view->checkoutUrl = $cartInfo['checkout_url'];
        }
    }

    /*
     * Set the cookie
     */

    public function setCookieAction() {
        $data = $_GET['data'];
        setcookie('se_flag', $data, 0, '/');
        exit();
    }

    public function setQuoteCookieAction() {
        $data = $_GET['data'];
        setcookie('quote_id', $data, 0, '/');
        exit();
    }

    public function unsetQuoteCookieAction() {
        setcookie('quote_id', '', time() - 5000, '/');
        exit();
    }

    /*
     * Add item to Wishlist
     */

    public function addWishlistAction() {
        $productId = $this->_getParam('product_id');
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();
        $getUsersInfo = Engine_Api::_()->getDbTable('users', 'sitemagento')->getUser(array('se_user_id' => $viewer_id));
        $getUsersInfo = end($getUsersInfo);
        $customerId = !empty($getUsersInfo['mage_user_id']) ? $getUsersInfo['mage_user_id'] : 0;

        $packet = array(
            'apiType' => 'addItemWishlist',
            'method' => 'POST',
            'parameters' => array(
                'customerId' => $customerId,
                'productId' => $productId,
            )
        );
        $response = Engine_Api::_()->getApi('Request', 'sitemagento')->client_api_connect($packet);
        $data = array();
        $data['message'] = 'Item added to wishlist.';
        if ($response['is_error'] == true) {
            $data['message'] = $responseData['error_message'];
        }
        return $this->_helper->json($data);
    }

}
