<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemagento
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 6590 2017-06-22 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
$params = array(
    'apiType' => 'getCategories',
    'method' => 'GET',
    'queryParameters' => array(
        'rootCategoryId' => 1
    )
);
$response = Engine_Api::_()->getApi('Request', 'sitemagento')->client_api_connect($params);
$productViewPageElement = array(
    'Select',
    'productViewPage',
    array(
        'label' => 'What you want to open Product view page on same page or new page',
        'multiOptions' => array(
            '0' => 'Same Page',
            '1' => 'New Page'
        ),
        'value' => 0
    )
);
$categoriesData = array('0' => 'Select Category');
$jsonCategories = '';
if ($response['is_error'] == false && !empty($response['response_output']) && isset($response['response_output']['children_data']) && count($response['response_output']['children_data']) > 0) {
    $categories = $response['response_output']['children_data'];
    foreach ($categories as $category) {
        $categoriesData[$category['id']] = $category['name'];
    }
}
$hiddenCatElement = array(
    'Text',
    'hidden_category_id',
    array('order' => 999
        ));

$hiddenSubCatElement = array(
    'Text',
    'hidden_subcategory_id',
    array('order' => 998
        ));
$hiddenSubSubCatElement = array(
    'Text',
    'hidden_subsubcategory_id',
    array('order' => 997
        ));
$categoryElement = array(
    'Select',
    'category_id',
    array(
        'label' => 'Category',
        'multiOptions' => $categoriesData,
        'RegisterInArrayValidator' => false,
        'onchange' => 'addOptions(this.value,"subcategory_id",0);setHiddenValues("category_id");'
        ));
$subCategoryElement = array(
    'Select',
    'subcategory_id',
    array(
        'RegisterInArrayValidator' => false,
        'decorators' => array(array('ViewScript', array(
                    'viewScript' => 'application/modules/Sitemagento/views/scripts/_category.tpl',
                    'class' => 'form element')))
        ));
return array(
    array(
        'title' => 'New / Best Selling products',
        'description' => 'This widget displays New / Best Seller Products on Magento eCommerce Store.',
        'category' => 'SocialEngine Magento Integration',
        'type' => 'widget',
        'autoEdit' => true,
        'name' => 'sitemagento.featured-catalogs',
        'defaultParams' => array(
            'title' => 'Catalog',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Select',
                    'type',
                    array(
                        'label' => 'Content Type',
                        'multiOptions' => array(
                            'best_seller' => 'Best Sellers',
                            'new' => 'New Products',
                        ),
                        'value' => 'new',
                    )
                ),
                $categoryElement,
                $subCategoryElement,
                $hiddenCatElement,
                $hiddenSubCatElement,
                $hiddenSubSubCatElement,
                array(
                    'MultiCheckbox',
                    'viewTypeOptions',
                    array(
                        'label' => 'Select view type to display products.',
                        'multiOptions' => array(
                            'gridView' => 'Grid View',
                            'listView' => 'List View'
                        ),
                    )
                ),
                array(
                    'Select',
                    'viewType',
                    array(
                        'label' => 'Default View type',
                        'multiOptions' => array(
                            'gridView' => 'Grid View',
                            'listView' => 'List View'
                        ),
                        'value' => 'listView',
                    )
                ),
                $productViewPageElement,
                array(
                    'Text',
                    'buttonTitle',
                    array(
                        'label' => 'What you want to call ‘View More’ products?',
                        'value' => 'Go to Store',
                    )
                ),
                array(
                    'Text',
                    'buttonLink',
                    array(
                        'label' => 'Where page you want to open on clicking ‘View More’ ? (Note: Please enter complete url for ex. http://www.your-magento-site.com/ )',
                        'value' => '',
                    )
                ),
                array(
                    'Text',
                    'titleTruncation',
                    array(
                        'label' => 'Define Product Title truncation limit.',
                        'value' => 30,
                    ),
                    'validators' => array(
                        array('Int', true),
                    ),
                ),
                array(
                    'Text',
                    'count',
                    array(
                        'label' => 'Count',
                        'description' => 'How many products you want to show in widget?',
                        'value' => 10,
                    )
                ),
            )
        ),
    ),
    array(
        'title' => 'New / Best Selling products carousel',
        'description' => 'This widget displays New / Best Seller Products carousel on Magento eCommerce Store.',
        'category' => 'SocialEngine Magento Integration',
        'type' => 'widget',
        'autoEdit' => true,
        'name' => 'sitemagento.featured-catalogs-carousel',
        'defaultParams' => array(
            'title' => 'Catalog',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Select',
                    'type',
                    array(
                        'label' => 'Content Type',
                        'multiOptions' => array(
                            'best_seller' => 'Best Sellers',
                            'new' => 'New Products',
                        ),
                        'value' => 'new',
                    )
                ),
                $categoryElement,
                $subCategoryElement,
                $hiddenCatElement,
                $hiddenSubCatElement,
                $hiddenSubSubCatElement,
                array(
                    'Text',
                    'productWidth',
                    array(
                        'label' => 'Enter the width of each product.',
                        'value' => 150,
                    )
                ),
                array(
                    'Text',
                    'productHeight',
                    array(
                        'label' => 'Enter the height of each product.',
                        'value' => 150,
                    )
                ),
                $productViewPageElement,
                array(
                    'Radio',
                    'showPagination',
                    array(
                        'label' => 'Do you want to show next / previous pagination?',
                        'multiOptions' => array(1 => 'Yes', 0 => 'No'),
                        'value' => '1',
                    )
                ),
                array(
                    'Text',
                    'interval',
                    array(
                        'label' => 'Speed',
                        'description' => '(Transition interval between two slides in millisecs)',
                        'value' => 3500,
                    )
                ),
                array(
                    'Text',
                    'buttonTitle',
                    array(
                        'label' => 'What you want to call ‘View More’ products?',
                        'value' => 'View All',
                    )
                ),
                array(
                    'Text',
                    'buttonLink',
                    array(
                        'label' => 'Where page you want to open on clicking ‘View More’ ? (Note: Please enter complete url for ex. http://www.your-magento-site.com/ )',
                        'value' => '',
                    )
                ),
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Enter number of products in a Row',
                        'value' => 5,
                    )
                ),
                array(
                    'Text',
                    'count',
                    array(
                        'label' => 'Count',
                        'description' => 'How many products you want to show in widget?',
                        'value' => 25,
                    )
                ),
                array(
                    'Text',
                    'titleTruncation',
                    array(
                        'label' => 'Define Product Title truncation limit.',
                        'value' => 30,
                    ),
                    'validators' => array(
                        array('Int', true),
                    ),
                ),
            )
        ),
    ),
    array(
        'title' => 'Product Category Navigation Bar',
        'description' => 'Displays different categories in this block. You can configure various settings for this widget from the Edit section.',
        'category' => 'SocialEngine Magento Integration',
        'type' => 'widget',
        'name' => 'sitemagento.categories-navigation',
        'autoEdit' => true,
        'adminForm' => array(
            'elements' => array(
                $categoryElement,
                $subCategoryElement,
                $hiddenCatElement,
                $hiddenSubCatElement,
                $hiddenSubSubCatElement,
                array(
                    'Radio',
                    'viewDisplayHR',
                    array(
                        'label' => 'Select the placement position of the navigation bar',
                        'multiOptions' => array(
                            1 => 'Horizontal',
                            0 => 'Vertical'
                        ),
                        'value' => 1,
                    )
                ),
            ))
    ),
    array(
        'title' => 'Sponsored Products',
        'description' => 'This widget is used to Place Sponsored products',
        'category' => 'SocialEngine Magento Integration',
        'type' => 'widget',
        'autoEdit' => true,
        'name' => 'sitemagento.sponsored-products',
        'adminForm' => 'Sitemagento_Form_Admin_Widget_Sponsoredproducts',
        'defaultParams' => array(
            'title' => 'Sponsored Products',
        ),
    ),
    array(
        'title' => 'Sponsored Products middle',
        'description' => 'This widget is used to Place Sponsored products on the middle',
        'category' => 'SocialEngine Magento Integration',
        'type' => 'widget',
        'autoEdit' => true,
        'name' => 'sitemagento.sponsored-products-middle',
        'adminForm' => 'Sitemagento_Form_Admin_Widget_SponsoredProductsMiddle',
        'defaultParams' => array(
            'title' => 'Sponsored Products Middle',
        ),
    ),
    array(
        'title' => 'Sponsored Products Carousel',
        'description' => 'This widget is used to Place Sponsored products in Carousel',
        'category' => 'SocialEngine Magento Integration',
        'type' => 'widget',
        'autoEdit' => true,
        'name' => 'sitemagento.sponsored-products-carousel',
        'adminForm' => 'Sitemagento_Form_Admin_Widget_SponsoredProductsCarousel',
        'defaultParams' => array(
            'title' => 'Sponsored Products Carousel',
        ),
    )
);
