<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemagento
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 2015-06-04 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemagento_Installer extends Engine_Package_Installer_Module {

    public function onPreinstall() {
        $PRODUCT_TYPE = 'sitemagento';
        $PLUGIN_TITLE = 'Sitemagento';
        $PLUGIN_VERSION = '5.5.0';
        $PLUGIN_CATEGORY = 'plugin';
        $PRODUCT_DESCRIPTION = 'SocialEngine Magento Integration Plugin';
        $PRODUCT_TITLE = 'SocialEngine Magento Integration Plugin';
        $_PRODUCT_FINAL_FILE = 0;
        $SocialEngineAddOns_version = '4.8.12';
        $file_path = APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/ilicense.php";
        $is_file = @file_exists($file_path);
        if (empty($is_file)) {
            include APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/license3.php";
        } else {
            $db = $this->getDb();
            $select = new Zend_Db_Select($db);
            $select->from('engine4_core_modules')->where('name = ?', $PRODUCT_TYPE);
            $is_Mod = $select->query()->fetchObject();
            if (empty($is_Mod))
                include_once $file_path;
        }

        parent::onPreinstall();
    }

    function onInstall() {
        $db = $this->getDb();
        $db->query("UPDATE  `engine4_seaocores` SET  `is_activate` =  '1' WHERE  `engine4_seaocores`.`module_name` ='sitemagento';");
        if ($this->isModuleEnabled('sitemenu')) {
            $db->query("INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `order`) VALUES('sitemenu_mini_magentocart', 'sitemagento', 'Cart', 'Sitemenu_Plugin_Menus', '', 'core_mini', '', 2);");
        }
        if ($this->isModuleEnabled('siteadvsearch')) {
            $engine4siteadvsearchTable = $db->query("SHOW TABLES LIKE 'engine4_siteadvsearch_contents'")->fetch();
            if ($engine4siteadvsearchTable) {
                $select = new Zend_Db_Select($db);
                $select
                        ->from('engine4_siteadvsearch_contents')
                        ->where('resource_type = ?', 'sitemagento');
                $sitemagento_isActivate_object = $select->query()->fetchObject();
                if (!$sitemagento_isActivate_object) {
                    $db->query("INSERT IGNORE INTO `engine4_siteadvsearch_contents` ( `module_name`, `resource_type`, `resource_title`, `listingtype_id`, `widgetize`, `content_tab`, `main_search`, `order`, `file_id`, `default`, `enabled`) VALUES ( 'sitemagento', 'sitemagento', 'Stores', '0', '1', '1', '1', '999', '', '1', '1');");
                }
            }
        }
        $this->setHomePageWidget();
        parent::onInstall();
    }

    public function setHomePageWidget() {
        $db = $this->getDb();
        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_pages')
                ->where('name = ?', 'user_index_home')
                ->limit(1);
        $page_id = $select->query()->fetchObject()->page_id;
        if (!empty($page_id)) {
            $select = new Zend_Db_Select($db);
            $select_content = $select
                    ->from('engine4_core_content')
                    ->where('page_id = ?', $page_id)
                    ->where('type = ?', 'widget')
                    ->where('name = ?', 'sitemagento.featured-catalogs')
                    ->limit(1);
            if(!empty($select_content->query()->fetchObject())){
                $content_id = $select_content->query()->fetchObject()->content_id;
            }
            if (empty($content_id)) {
                $select = new Zend_Db_Select($db);
                $select_right = $select
                        ->from('engine4_core_content')
                        ->where('page_id = ?', $page_id)
                        ->where('type = ?', 'container')
                        ->where('name = ?', 'right')
                        ->limit(1);
                $right_id = $select_right->query()->fetchObject()->content_id;
                if (!empty($right_id)) {
                    $select = new Zend_Db_Select($db);
                    $db->insert('engine4_core_content', array(
                        'page_id' => $page_id,
                        'type' => 'widget',
                        'name' => 'sitemagento.featured-catalogs',
                        'parent_content_id' => $right_id,
                        'order' => 5,
                        'params' => '{"title":"New Products","titleCount":true,"type":"new","category_id":"0","viewTypeOptions":["gridView","listView"],"viewType":"listView","buttonTitle":"Go to Store","buttonLink":"","titleTruncation":"25","count":"10","nomobile":"0","name":"sitemagento.featured-catalogs"}',
                    ));
                }
                $select = new Zend_Db_Select($db);
                $select_left = $select
                        ->from('engine4_core_content')
                        ->where('page_id = ?', $page_id)
                        ->where('type = ?', 'container')
                        ->where('name = ?', 'left')
                        ->limit(1);
                $left_id = $select_left->query()->fetchObject()->content_id;
                if (!empty($left_id)) {
                    $select = new Zend_Db_Select($db);
                    $db->insert('engine4_core_content', array(
                        'page_id' => $page_id,
                        'type' => 'widget',
                        'name' => 'sitemagento.featured-catalogs',
                        'parent_content_id' => $left_id,
                        'order' => 5,
                        'params' => '{"title":"Best Seller","titleCount":true,"type":"best_seller","category_id":"0","viewTypeOptions":["gridView","listView"],"viewType":"listView","buttonTitle":"Go to Store","buttonLink":"","titleTruncation":"25","count":"10","nomobile":"0","name":"sitemagento.featured-catalogs"}',
                    ));
                }
            }
        }
    }

    public function onEnable() {

        $db = $this->getDb();
        if ($this->isModuleEnabled('sitemenu')) {
            $db->query("INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `order`) VALUES('sitemenu_mini_magentocart', 'sitemagento', 'Cart', 'Sitemenu_Plugin_Menus', '', 'core_mini', '', 2);");
            $db->query("UPDATE `engine4_core_menuitems` SET enabled =1 WHERE name='sitemenu_mini_magentocart' and module='sitemagento';");
        }
        parent::onEnable();
    }

    public function onDisable() {
        $db = $this->getDb();
        if ($this->isModuleEnabled('sitemenu')) {
            $db->query("UPDATE `engine4_core_menuitems` SET enabled =0 WHERE name='sitemenu_mini_magentocart' and module='sitemagento';");
        }
        parent::onDisable();
    }

    public function isModuleEnabled($moduleName) {
        $db = $this->getDb();
        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_modules')
                ->where('name = ?', $moduleName)
                ->where('enabled = ?', 1);
        $is_module_object = $select->query()->fetchObject();
        if ($is_module_object)
            return true;
        return false;
    }

}
