<?php

return array(
    'package' =>
    array(
        'type' => 'module',
        'name' => 'sitemagento',
        'version' => '5.5.0',
        'path' => 'application/modules/Sitemagento',
        'title' => 'SocialEngine Magento Integration',
        'description' => 'Make your Followers / Friends buyers with SocialEngine Magento Integration Plugin',
        'author' => '<a href="http://www.socialapps.tech" style="text-decoration:underline;" target="_blank">SocialApps.tech</a>',
        'callback' =>
        array(
            'path' => 'application/modules/Sitemagento/settings/install.php',
            'class' => 'Sitemagento_Installer',
        ),
        'actions' =>
        array(
            0 => 'install',
            1 => 'upgrade',
            2 => 'refresh',
            3 => 'enable',
            4 => 'disable',
        ),
        'directories' =>
        array(
            0 => 'application/modules/Sitemagento',
        ),
    ),
    // Hooks ---------------------------------------------------------------------
    'hooks' => array(
        array(
            'event' => 'onRenderLayoutDefault',
            'resource' => 'Sitemagento_Plugin_Core'
        ),
        array(
            'event' => 'onUserCreateAfter',
            'resource' => 'Sitemagento_Plugin_Core'
        ),
        array(
            'event' => 'onUserLoginAfter',
            'resource' => 'Sitemagento_Plugin_Core'
        ),
        array(
            'event' => 'onUserDeleteAfter',
            'resource' => 'Sitemagento_Plugin_Core'
        ),
        array(
            'event' => 'onUserLogoutBefore',
            'resource' => 'Sitemagento_Plugin_Core'
        ),
    ),
    // Items ---------------------------------------------------------------------
    'items' => array(
        'sitemagento_user',
        'sitemagento_order',
        'sitemagento_product',
        'sitemagento_wishlist'
    ),
// Routes --------------------------------------------------------------------
    'routes' => array(
        'user_sync' => array(
            'route' => 'usersync/:action/*',
            'defaults' => array(
                'module' => 'sitemagento',
                'controller' => 'sync',
                'action' => 'create',
            ),
            'reqs' => array(
                'action' => '(create|update)',
            ),
        ),
        'user_feed' => array(
            'route' => 'feed/:action/*',
            'defaults' => array(
                'module' => 'sitemagento',
                'controller' => 'feed',
                'action' => 'purchase-feed',
            ),
            'reqs' => array(
                'action' => '(purchase-feed|wishlist-feed)',
            ),
        ),
        'sitemagento_cart' => array(
            'route' => 'cart/:action/*',
            'defaults' => array(
                'module' => 'sitemagento',
                'controller' => 'index',
                'action' => 'index',
            ),
            'reqs' => array(
                'action' => '(get-magento-cart-products)',
            ),
        ),
        'sitemagento_cookie' => array(
            'route' => 'cookie/:action/*',
            'defaults' => array(
                'module' => 'sitemagento',
                'controller' => 'index',
                'action' => 'set-cookie',
            ),
            'reqs' => array(
                'action' => '(set-cookie|set-quote-cookie|unset-quote-cookie)',
            ),
        ),
    ),
);
?>