<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemagento
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2017-06-22 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemagento_Widget_FeaturedCatalogsCarouselController extends Engine_Content_Widget_Abstract {

    public function indexAction() {

        $param = array();
        $this->view->host = $host = Engine_Api::_()->sitemagento()->getMagentoHostUrl();
        $this->view->category_id = $category_id = $this->_getParam('category_id');
        $this->view->subcategory_id = $subcategory_id = $this->_getParam('subcategory_id');
        $this->view->subsubcategory_id = $subsubcategory_id = $this->_getParam('hidden_subsubcategory_id');

        $this->view->type = $type = $this->_getParam('type', 'new');
        $this->view->buttonTitle = $param['buttonTitle'] = $this->_getParam('buttonTitle', 'Go to Store');
        $this->view->buttonLink = $param['buttonLink'] = $this->_getParam('buttonLink', $host);
        $this->view->titleTruncation = $param['titleTruncation'] = $this->_getParam('titleTruncation', 30);
        $this->view->count = $pageSize = $this->_getParam('count', 25);
        $this->view->rowCount = $this->_getParam('itemCount', 5);
        $this->view->interval = $this->_getParam('interval', 3500);
        $this->view->productWidth = $this->_getParam('productWidth', 150);
        $this->view->productHeight = $this->_getParam('productHeight', 150);
        $this->view->showPagination = $this->_getParam('showPagination', 1);
        $this->view->productViewPage = $this->_getParam('productViewPage', 0);
        $catalogImagePath = $host . Engine_Api::_()->sitemagento()->getCatalogImageUrl();
        $element = $this->getElement();
        $widgetTitle = $this->view->heading = $element->getTitle();
        if (!empty($widgetTitle)) {
            $element->setTitle("");
        }
        $cid = 0;
        if (!empty($subsubcategory_id)) {
            $cid = $subsubcategory_id;
        } elseif (!empty($subcategory_id)) {
            $cid = $subcategory_id;
        } elseif (!empty($category_id)) {
            $cid = $category_id;
        }
        //Find the products from magento site
        switch ($type) {
            case 'new' :
                $searchCri = array(
                    'searchCriteria[sortOrders][0][field]' => 'created_at',
                    'searchCriteria[sortOrders][0][direction]' => 'DESC',
                    'searchCriteria[pageSize]' => $pageSize,
                    'searchCriteria[filterGroups][0][filters][0][field]' => 'type_id',
                    'searchCriteria[filterGroups][0][filters][0][value]' => 'virtual',
                    'searchCriteria[filterGroups][0][filters][0][conditionType]' => 'neq',
                    'searchCriteria[filterGroups][1][filters][0][field]' => 'visibility',
                    'searchCriteria[filterGroups][1][filters][0][value]' => 1,
                    'searchCriteria[filterGroups][1][filters][0][conditionType]' => 'neq',
                    'searchCriteria[filterGroups][3][filters][0][field]' => 'status',
                    'searchCriteria[filterGroups][3][filters][0][value]' => 1,
                    'searchCriteria[filterGroups][3][filters][0][conditionType]' => 'eq',
                );
                if (!empty($cid)) {
                    $searchCri = array_merge($searchCri, array(
                        'searchCriteria[filterGroups][2][filters][0][field]' => 'category_id',
                        'searchCriteria[filterGroups][2][filters][0][value]' => $cid,
                        'searchCriteria[filterGroups][2][filters][0][conditionType]' => 'eq'
                    ));
                }

                $packet = array(
                    'apiType' => 'getProducts',
                    'method' => 'GET',
                    'queryParameters' => $searchCri
                );
                break;
            case 'best_seller' :
                $packet = array(
                    'apiType' => 'getBestSellers',
                    'method' => 'GET',
                    'parameters' => array(
                        'pageSize' => $pageSize,
                        'categoryId' => $cid
                    )
                );
                break;
        }

        $response = Engine_Api::_()->getApi('Request', 'sitemagento')->client_api_connect($packet);
        $products = array();
        if ($response['is_error'] == false && !empty($response['response_output'])) {
            $products = $response['response_output'];
            if ($type == 'new') {
                $products = array();
                if (isset($response['response_output']['items']) && count($response['response_output']['items']) > 0) {
                    $productsArray = $response['response_output']['items'];

                    $prIds = array();
                    $products = array();
                    foreach ($productsArray as $product) {
                        $prIds[] = $product['id'];
                        $products[$product['id']] = $product;
                    }

                    $packet = array(
                        'apiType' => 'getProductsPrice',
                        'method' => 'POST',
                        'parameters' => array(
                            'productIds' => $prIds
                        )
                    );
                    $response = Engine_Api::_()->getApi('Request', 'sitemagento')->client_api_connect($packet);
                    if ($response['is_error'] == false && !empty($response['response_output'])) {
                        $prds = $response['response_output'];
                        foreach ($prds as $p) {
                            $products[$p['product_id']]['product_id'] = $p['product_id'];
                            $products[$p['product_id']]['url'] = $p['url'];
                            $products[$p['product_id']]['avg_rating'] = $p['avg_rating'];
                            $products[$p['product_id']]['price_1'] = $p['price'];
                            $products[$p['product_id']]['min_price'] = $p['min_price'];
                            $products[$p['product_id']]['max_price'] = $p['max_price'];
                            if (!isset($products[$p['product_id']]['price'])) {
                                $products[$p['product_id']]['price'] = 0.00;
                            }
                        }
                    }
                }
            }
        }

        if (empty($products) || count($products) == 0) {
            return $this->setNoRender();
        }

        //Get Currency
        $this->view->currencySymbol = '';
        $packet = array(
            'apiType' => 'getCurrency',
            'method' => 'GET',
        );

        $response = Engine_Api::_()->getApi('Request', 'sitemagento')->client_api_connect($packet);
        if ($response['is_error'] == false && !empty($response['response_output']['base_currency_symbol'])) {
            $this->view->currencySymbol = $response['response_output']['base_currency_symbol'];
        }

        $this->view->items = array();
        foreach ($products as $product) {
            $imagePath = '';
            $images = array();
            $product_id = $product['product_id'];
            $rating = $product['avg_rating'];
            if (!empty($product['product'])) {
                $productName = $product['product']['name'];
                $typeId = $product['product']['type_id'];
                $price1 = null;
                $minPrice = null;
                $maxPrice = null;

                if (!empty($product['product']['image']) && $product['product']['image'] != 'no_selection') {
                    $images[] = $catalogImagePath . $product['product']['image'];
                }
                if (!empty($product['product']['small_image']) && $product['product']['small_image'] != 'no_selection') {
                    $images[] = $catalogImagePath . $product['product']['small_image'];
                }
                if (!empty($product['product']['thumbnail']) && $product['product']['thumbnail'] != 'no_selection') {
                    $images[] = $catalogImagePath . $product['product']['thumbnail'];
                }
                if (!empty($product['product']['swatch_image']) && $product['product']['swatch_image'] != 'no_selection') {
                    $images[] = $catalogImagePath . $product['product']['swatch_image'];
                }
                $url = $product['product_url'];
            } else {
                $productName = $product['name'];
                $typeId = $product['type_id'];
                $price1 = $product['price_1'];
                $minPrice = $product['min_price'];
                $maxPrice = $product['max_price'];
                $url = $product['url'];
                $attributes = array();
                foreach ($product['custom_attributes'] as $cattirbute) {
                    $attributes[$cattirbute['attribute_code']] = $cattirbute['value'];
                }
                if (!empty($attributes['image']) && $attributes['image'] != 'no_selection') {
                    $images[] = $catalogImagePath . $attributes['image'];
                }
                if (!empty($attributes['small_image']) && $attributes['small_image'] != 'no_selection') {
                    $images[] = $catalogImagePath . $attributes['small_image'];
                }
                if (!empty($attributes['thumbnail']) && $attributes['thumbnail'] != 'no_selection') {
                    $images[] = $catalogImagePath . $attributes['thumbnail'];
                }
                if (!empty($attributes['swatch_image']) && $attributes['swatch_image'] != 'no_selection') {
                    $images[] = $catalogImagePath . $attributes['swatch_image'];
                }
            }
            $imagePath = $this->view->layout()->staticBaseUrl . "application/modules/Sitemagento/externals/images/default.png";
            foreach ($images as $image) {
                $imageArray = @getimagesize($image);
                if (is_array($imageArray) && count($imageArray) > 0) {
                    $imagePath = $image;
                    break;
                }
            }
            $price = Engine_Api::_()->sitemagento()->getProductPrice($product);
            $item = array();
            $item['id'] = $product_id;
            $item['imagePath'] = $imagePath;
            $item['price'] = $price;
            $item['name'] = $productName;
            $item['url'] = $url;
            $item['type_id'] = $typeId;
            $item['price1'] = $price1;
            $item['min_price'] = $minPrice;
            $item['max_price'] = $maxPrice;
            $item['avg_rating'] = $rating;
            $this->view->items[] = $item;
        }
    }

}
