<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemagento
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2017-06-22 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemagento_Widget_SponsoredProductsCarouselController extends Engine_Content_Widget_Abstract {

    public function indexAction() {

        $this->view->viewType = $this->_getParam('viewType', 'listView');
        $this->view->host = $host = Engine_Api::_()->sitemagento()->getMagentoHostUrl();
        $this->view->viewTypeOptions = $this->_getParam('viewTypeOptions', array('gridView', 'listView'));
        $this->view->rowCount = $this->_getParam('itemCount', 5);
        $this->view->interval = $this->_getParam('interval', 3500);
        $this->view->productWidth = $this->_getParam('productWidth', 150);
        $this->view->productHeight = $this->_getParam('productHeight', 150);
        $this->view->showPagination = $this->_getParam('showPagination', 1);
        $this->view->titleTruncation = $this->_getParam('titleTruncation', 30);
        $this->view->buttonTitle = $param['buttonTitle'] = $this->_getParam('buttonTitle', 'Go to Store');
        $this->view->buttonLink = $param['buttonLink'] = $this->_getParam('buttonLink', $host);
        $productIds = $this->_getParam('toValues', '');
        $this->view->productViewPage = $this->_getParam('productViewPage', 0);
        $element = $this->getElement();
        $widgetTitle = $this->view->heading = $element->getTitle();
        if (!empty($widgetTitle)) {
            $element->setTitle("");
        }
        if (empty($this->view->viewTypeOptions) || count($this->view->viewTypeOptions) == 1) {
            $this->view->viewTypeOptions = array($this->view->viewType);
        }
        if (empty($productIds)) {
            return $this->setNoRender();
        }
        $productIds = explode(',', $productIds);
        $productIds = array_unique($productIds);

        $prIds = array();
        foreach ($productIds as $productId) {
            $prIds[] = $productId;
        }
        $packet = array(
            'apiType' => 'getProductsPrice',
            'method' => 'POST',
            'parameters' => array(
                'productIds' => $prIds
            )
        );
        $products = array();
        $response = Engine_Api::_()->getApi('Request', 'sitemagento')->client_api_connect($packet);

        if ($response['is_error'] == false && !empty($response['response_output'])) {
            $prds = $response['response_output'];
            foreach ($prds as $key => $p) {
                if (empty($p['product_id'])) {
                    continue;
                }
                $imageUrl = Engine_Api::_()->sitemagento()->checkProductImage($p['image_url']);
                if (empty($imageUrl)) {
                    $imageUrl = $this->view->layout()->staticBaseUrl . "application/modules/Sitemagento/externals/images/default.png";
                }
                $pid = $p['product_id'];
                $products[$pid]['id'] = $pid;
                $products[$pid]['name'] = $p['name'];
                $products[$pid]['url'] = $p['url'];
                $products[$pid]['avg_rating'] = $p['avg_rating'];
                $products[$pid]['price'] = $p['price'];
                $products[$pid]['min_price'] = $p['min_price'];
                $products[$pid]['max_price'] = $p['max_price'];
                $products[$pid]['currency_symbol'] = $p['currency_symbol'];
                $products[$pid]['image_url'] = $imageUrl;
                $products[$pid]['type_id'] = $p['type_id'];
            }
        }

        $this->view->products = $products;
    }

}
