<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemailtemplates
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: GetContent.php 6590 2012-26-01 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemailtemplates_View_Helper_TinyMCE extends Zend_View_Helper_Abstract {

  /**
   * Assembles action string
   * 
   * @return string
   */
  protected $_version;

  public function tinyMCE() {
    if (!$this->_version) {
      $coremodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core');
      $this->_version = $coremodule->version;
    }
    return $this;
  }

  public function addJSForTinyMCE($onlyPath = false) {
    if ($onlyPath)
      return $this->view->baseUrl() . '/externals/tinymce/tinymce.min.js';
    $this->view->headScript()->appendFile($this->view->baseUrl() . '/externals/tinymce/tinymce.min.js');
  }

  public function renderTinyMCE($params = array()) {
    if( Zend_Registry::isRegistered('Locale') ) {
      $locale = Zend_Registry::get('Locale');
      if( method_exists($locale, '__toString') ) {
        $locale = $locale->__toString();
      } else {
        $locale = (string) $locale;
      }
      $localeData = Zend_Locale_Data::getList($locale, 'layout');
      $directionality = ( @$localeData['characters'] == 'right-to-left' ? 'rtl' : 'ltr' );

      $params['language'] = $locale;
      $params['directionality'] = $directionality;
    }
    if( !isset($params['upload_url']) ) {
      $params['upload_url'] = '';
    }

    $uploadPlugin = '';
    $plugins = 'directionality,advlist,autolink,lists,link,image,charmap,print,preview,hr,anchor,'
        . 'pagebreak,searchreplace,wordcount,visualblocks,visualchars,code,fullscreen,insertdatetime,'
        . 'media,nonbreaking,save,table,contextmenu,directionality,emoticons,paste,textcolor';
    if( !empty($params['upload_url']) ) {
      $plugins .= ',jbimages';
      $uploadPlugin = 'jbimages,';
    }

    $plugins .= ',imagetools,colorpicker,autosave';
    
    return 'tinymce.init({
      mode: "exact",
      forced_root_block: false,
      force_p_newlines: false,
      elements : ' . $params['element_id'] . ',
      plugins: "' . $plugins . '",
      theme: "modern",
      menubar: true,
      statusbar: false,
      toolbar1: "ltr,rtl,undo,redo,removeformat,pastetext,|,code,link,media,image,' . $uploadPlugin . 'emoticons,|,bullist,numlist,|,print,preview,fullscreen",
      toolbar2: "fontselect,fontsizeselect,bold,italic,underline,strikethrough,forecolor,backcolor,|,alignleft,aligncenter,alignright,alignjustify,|,outdent,indent,blockquote",
      toolbar3: "",
      element_format: "html",
      height: "225px",
      convert_urls: false,
      language: "' . $params['language'] . '",
      directionality: "' . $params['directionality'] . '",
      upload_url: "' . $params['upload_url'] . '",
      image_advtab: true
    });';
  }

  public function renderUploadPhotoResultTinyMCE($params = array()) {
    return $this->view->partial(
                    'tinymce/upload-photo.tpl', 'sitemailtemplates', $params);
  }

}