<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemulticurrency
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Currencies.php 2011-08-026 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemulticurrency_Model_DbTable_Currencyrates extends Engine_Db_Table {

    protected $_rowClass = 'Sitemulticurrency_Model_Currencyrate';

    //IT PROVIDES THE APPLIED CONVERSION RATE STORED IN DATABASE
    public function getConversionRate($from, $to) {
        $tableName = $this->info('name');
        $select = $this->select()
                ->from($tableName, 'applied_rate')
                ->where($tableName . '.code = ?', $to);
        $data = $this->fetchRow($select);
        $toCodeRate = $data->applied_rate;

        $select1 = $this->select()
                ->from($tableName, 'applied_rate')
                ->where($tableName . '.code = ?', $from);
        $data1 = $this->fetchRow($select1);
        $fromCodeRate = $data1->applied_rate;

        $conversionRate = $toCodeRate / $fromCodeRate;
        return $conversionRate;
    }

    public function getAllowedCurrencies($withName = null) {

        $localeObject = Zend_Registry::get('Locale');
        $coreSettings = Engine_Api::_()->getApi('settings', 'core');

        $alreadyAllowed = (array) $coreSettings->getSetting('sitemulticurrency.allowed.currency', $coreSettings->getSetting('payment.currency', 'USD'));
        $multiOptionsWithName = array();
        $multiOptionsWithCode = array();
        foreach ($alreadyAllowed as $key => $value) {
            $multiOptionsWithCode[$value] = $value;
            $fullname = Zend_Locale_Data::getContent($localeObject, 'nametocurrency', $value);
            if (empty($fullname))
                $fullname = $value;
            $multiOptionsWithName[$value] = $fullname;
        }
        if (!empty($withName)) {
            return $multiOptionsWithName;
        }
        return $multiOptionsWithCode;
    }

    //GIVES THE ALL CURRENCY CODES STORED IN DATABASE
    public function getCurrencyCodes() {

        $currencyTableName = $this->info('name');
        $select = $this->select()
                ->from($currencyTableName, 'code');

        $result = $select->query()->fetchAll(Zend_Db::FETCH_COLUMN);

        return $result;
    }

}
