<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemulticurrency
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Modules.php 6590 2016-3-3 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemulticurrency_Model_DbTable_Modules extends Engine_Db_Table {

    protected $_name = 'sitemulticurrency_modules';
    protected $_rowClass = 'Sitemulticurrency_Model_Module';


     public function getIntegratedModules($params = array()) {

        $coreModuleTable = Engine_Api::_()->getDbtable('modules', 'core');
        $moduleTableName = $this->info('name');
        $coreModuleTableName = $coreModuleTable->info('name');
        $select = $this->select()->setIntegrityCheck(false)
                ->from($moduleTableName, array('*'))

                ->join($coreModuleTableName, $coreModuleTableName . '.name = ' . $moduleTableName . '.item_module', array())
                ->where($coreModuleTableName . '.enabled =?', 1);

        $results = $this->fetchAll($select)->toArray();

        if (empty($results)) {
            return false;
        }
        return $results;
    }

    public function isModuleEnable($item_module) {

        $enable = $this->select()
                        ->from($this->info('name'), 'enabled')
                        ->where('item_module =?', $item_module) 
                        ->query()->fetchColumn();

        if (empty($enable))
            return false;
        return true;
    }



}

?>