<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemulticurrency
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 2013-09-02 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemulticurrency_Plugin_Core extends Zend_Controller_Plugin_Abstract {

    public function onRenderLayoutDefault($event) {

        $view = $event->getPayload();
        $coreSettings = Engine_Api::_()->getApi('settings', 'core');
        $localeObject = Zend_Registry::get('Locale');
        $baseCurrency = $coreSettings->getSetting('payment.currency', 'USD');
        $alreadyAllowed = array();
        $alreadyAllowed = $coreSettings->getSetting('sitemulticurrency.allowed.currency', $baseCurrency);
        if (count($alreadyAllowed) == 1)
            $alreadyAllowed = array($alreadyAllowed);

        $allowedCurrencySymbols = array();
        foreach($alreadyAllowed as $key => $curr) {
          $symbl = Zend_Locale_Data::getContent($localeObject, 'currencysymbol', $curr);
          if(empty($symbl))  
              $symbl = $curr;
           
          if($curr == 'INR')
              $symbl = '₹'; 

            $allowedCurrencySymbols[$key] =  $symbl;
        }

        $allowedCurrencySymbols = json_encode($allowedCurrencySymbols);



        //CONVERT IT IN JSON FORMAT ARRAY CANNOT BE PASS IN SCRIPT 
        $multiOptions = json_encode($alreadyAllowed);

        //COUNTRY  ARRAY
        $allowedCurr = Engine_Api::_()->getDbTable('currencyrates', 'sitemulticurrency')->getAllowedCurrencies();



        $currencyRegion = Zend_Locale_Data::getList(null, 'currencytoregion');
        $countryCode = array();
        foreach ($allowedCurr as $key => $value) {
            foreach ($currencyRegion as $key1 => $value1) {
                if ($value1 == $value)
                    $countryCode[$key1] = $value;
            }
        }
        $countryCode = json_encode($countryCode);
        $currencyViewSetting = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitemulticurrency.currency.information', 'currencySymbol');
        $imageBaseUrl = $view->layout()->staticBaseUrl . 'application/modules/Sitemulticurrency/externals/images/currency/';
        $selectedCountry = Engine_Api::_()->sitemulticurrency()->getSelectedCountry();

        
         $countryNames = Zend_Locale::getTranslationList('territory', $localeObject);
        //REPLACED THIS NAME WITH THIS IT CAUSES ERROR due to (')
        $countryNames['YD'] = 'People`s Democratic Republic of Yemen';

        $countryNames = json_encode($countryNames);


        //IF COOKIE IS SET THEN FETCH FROM COOKIE OTHERWISE DEFAULT DISPLAY CURRENCY
        $selectedOption = Engine_Api::_()->sitemulticurrency()->getSelectedCurrency();
        $selectedCurrencySymbol = Zend_Locale_Data::getContent($localeObject, 'currencysymbol', $selectedOption);
        if(empty($selectedCurrencySymbol))
          $selectedCurrencySymbol = $selectedOption;

        if($selectedOption == 'INR')
              $selectedCurrencySymbol = '₹'; 

        $isMulticurrencyEnable = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitemulticurrency');
        $enabled = $coreSettings->getSetting('sitemulticurrency.enabled', 1);
        $currencyInHeader = $coreSettings->getSetting('sitemulticurrency.headermenu.enabled', 1);

        if (!empty($isMulticurrencyEnable) && !empty($enabled) && !empty($currencyInHeader) && count($allowedCurr) > 1) { 

            $script = <<<EOF
            var sitemulticurrencySelectListHandler;
        
            en4.core.runonce.add(function() { 
            try {
              sitemulticurrencySelectListHandler = new SitemulticurrencySelectListHandler({
                'SELECTED_CURRENCY' : '{$selectedOption}',
                'ALL_ALLOWED_CURRENCY' :'{$multiOptions}',
                'ALL_ALLOWED_COUNTRY' :'{$countryCode}',
                'CURRENCY_VIEW_SETTING' :'{$currencyViewSetting}',
                'IMAGE_BASE_URL' :'{$imageBaseUrl}',
                'SELECTED_COUNTRY' :'{$selectedCountry}', 
                'COUNTRY_NAMES' :'{$countryNames}',
                'SELECTED_CURRENCY_SYMBOL' :'{$selectedCurrencySymbol}',
                'ALLOWED_CURRENCY_SYMBOLS' :'{$allowedCurrencySymbols}',     
              });
 
              sitemulticurrencySelectListHandler.start();  
            } catch( e ) {
               console.log(e);
            }
        });

        en4.core.runonce.add(function(){
          new SEAOMooVerticalScroll('core_menu_scroll_outer', 'core_menu_scroll_inner', {});
        });
EOF;

            $view->headScript()->appendFile($view->layout()->staticBaseUrl . 'application/modules/Seaocore/externals/scripts/seaomooscroll/SEAOMooVerticalScroll.js'); 
            $view->headScript()
                    ->appendFile($view->layout()->staticBaseUrl . 'application/modules/Sitemulticurrency/externals/scripts/currencylist.js')
                    ->appendScript($script);
        }

        $front = Zend_Controller_Front::getInstance();
        $module = $front->getRequest()->getModuleName();
        $controller = $front->getRequest()->getControllerName();
        $action = $front->getRequest()->getActionName();
        if ($isMulticurrencyEnable) {
            if (($module == 'user' && $controller == 'signup' && $action == 'index') || ($module == 'payment' && $controller == 'subscription' && $action == 'choose')) {

                $onloadChangeCurrency = <<<EOF
              window.addEvent('domready', function()
              {
                if($('package_id-wrapper')){
                  Object.each($$('.package-label'),function(obj,index){
                    if(typeof obj !='function'){
                    data = obj.innerHTML ;
                    if(data){
                    obj.innerHTML = data.substring(0,data.lastIndexOf('('));
                    }
                  }
                  });
                 
                  new Request.JSON({
                      url : en4.core.baseUrl + 'sitemulticurrency/index/index',
                      data : {
                        format : 'json',
                        action:'signup'
                      },
                      onSuccess : function(responseJSON, responseHTML) {
                       //  $$('.package-label').show();
                        Object.each(responseJSON,function(value,ind){
                          if($('package_id-'+ind)){
                            $('package_id-'+ind).getNext().set('Text',value);
                          }
                        });
                      }
                  }).send();
              }
              });
EOF;
                $view->headScript()->appendScript($onloadChangeCurrency);
            } elseif (($controller == 'subscription' || $controller == 'payment') && $action == 'gateway') {
                $onloadChangeCurrency = <<<EOF
            window.addEvent('domready', function()
              {
              if($$('.form-description')[0] && $$('.form-description')[0].getNext()){
                          $$('.form-description')[0].getNext().set('Text','');
                 }

                  new Request.JSON({
                      url : en4.core.baseUrl + 'sitemulticurrency/index/get-package-price',
                      data : {
                        format : 'json',
                      },
                      onRequest : function(){

                       },
                      onSuccess : function(responseJSON, responseHTML) {
                        if($$('.form-description')[0] && $$('.form-description')[0].getNext()){
                      $$('.form-description')[0].getNext().set('Text',responseJSON.detail);
                    }
                      }
                  }).send();
              });
EOF;
                $view->headScript()->appendScript($onloadChangeCurrency);
            }
        }
        $view->headScript()
                ->appendFile($view->layout()->staticBaseUrl . 'application/modules/Sitemulticurrency/externals/scripts/core.js');
    }

}
