<?php

class Sitemulticurrency_IndexController extends Siteapi_Controller_Action_Standard {

    //ACTION TO LIST THE ALL ALLOWED CURRECNIES IN SITEMENU ICON CLICK
     public function init() {
        if (!Zend_Registry::isRegistered('Zend_Translate'))
            Engine_Api::_()->getApi('Core', 'siteapi')->setTranslate();

        Engine_Api::_()->getApi('Core', 'siteapi')->setView();
        Engine_Api::_()->getApi('Core', 'siteapi')->setLocal();
     }
     
    public function currencyAction() {
            $coreSettings = Engine_Api::_()->getApi('settings', 'core');
            $getHost = Engine_Api::_()->getApi('Core', 'siteapi')->getHost();
            $baseUrl = Zend_Controller_Front::getInstance()->getBaseUrl();
            $baseUrl = @trim($baseUrl, "/");
            $viewer = Engine_Api::_()->user()->getViewer();
            $viewer_id = $viewer->getIdentity();
            $local = ($viewer_id) ? $viewer->locale : 'auto';
            $localeObject = new Zend_Locale($local);
            $allowedCurr= Engine_Api::_()->getDbTable('currencyrates', 'sitemulticurrency')->getAllowedCurrencies();


            $baseCurrencyGlobalRate = 1;
            $infoTosShow = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitemulticurrency.currency.information', 'currencySymbol');
            $baseCurrency = Engine_Api::_()->getApi('settings', 'core')->getSetting('payment.currency', 'USD');
            $defaultCurrency = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitemulticurrency.default.display.currency', $baseCurrency);
            $response = array();
             
             //$response['defaultCurrency'] = $defaultCurrency;
            $response['isSymbol'] = $infoTosShow;
            try{
                $currencyTable = Engine_Api::_()->getDbtable('currencyrates', 'sitemulticurrency');
                $currencyTableName = $currencyTable->info('name');

                             // work for Base currency 
            $baseCurrency = $coreSettings->getSetting('payment.currency', 'USD');

             //CREATED SELECT FOR RATES TABLE
            $select = $currencyTable->select()
                    ->from($currencyTableName);

            $result = $select->query()->fetchAll(Zend_Db::FETCH_COLUMN);
            $noOfRows = count($result);
            $baseCurrencyGlobalRate = 1; //API WE DOWNLOAD THE RATES FOR USD
            if($noOfRows) {
                $currencyRow = $currencyTable->fetchRow(array('code = ?' => $baseCurrency));
                $baseCurrencyGlobalRate = $currencyRow->global_rate;
            }
                $defaultCurr = $currencyTable->select()->where('code = ?', $defaultCurrency);
                $defaultCurrencyObj = $currencyTable->fetchRow($defaultCurr);
                $globalDefaultRate = round($defaultCurrencyObj->global_rate/$baseCurrencyGlobalRate, 4);
                $appliedDefaultRate = round($defaultCurrencyObj->applied_rate/$baseCurrencyGlobalRate, 4);
                $defaultCurrencyArray = array();
            
                $defaultCurrencyArray['code'] = $defaultCurrencyObj->code;
                $defaultCurrencyArray['globalRate'] = $globalDefaultRate;
                $defaultCurrencyArray['appliedRate'] = $appliedDefaultRate;
                $response['defaultCurrencyDetail'] = $defaultCurrencyArray;
                $response['isSymbol'] = $infoTosShow;
                if ($infoTosShow == 'currencySymbol'){
                    $selectedCurrency = Engine_Api::_()->sitemulticurrency()->getSelectedCurrency();
                    foreach ($allowedCurr as $code){
                     $currencyArray=array();
                     $symbol = Zend_Locale_Data::getContent($localeObject, 'currencysymbol', $code);
                     if (empty($symbol)) 
                         $symbol = $code;
                     if ($code == 'INR') 
                         $symbol = '₹'; 
                     
                     $name = Zend_Locale_Data::getContent($localeObject, 'nametocurrency', $code);
                    $currencyArray['title'] = $name;
                     
                    $select = $currencyTable->select()
                              ->where('code =? ', $code);
                    $item = $currencyTable->fetchRow($select);
                    $globalRate = round($item->global_rate/$baseCurrencyGlobalRate, 4);
                    $appliedRate = round($item->applied_rate/$baseCurrencyGlobalRate, 4);
                    $currencyArray['currency_name'] = $this->translate('( ' . $symbol . ' )');
                    $currencyArray['code'] = $item->code;
                    $currencyArray['symbol'] =$symbol;
                    $currencyArray['globalRate'] = $globalRate;
                    $currencyArray['appliedRate'] = $appliedRate;
                    
                    $response['response'][] = $currencyArray;

                 }
             }
             else{
                    $selectedCurrency = Engine_Api::_()->sitemulticurrency()->getSelectedCountry(true);
                    $currencyRegion = Zend_Locale_Data::getList(null, 'currencytoregion');
                    $countryCode = array();
                    foreach ($allowedCurr as $key => $value) {
                        foreach ($currencyRegion as $key1 => $value1) {
                            if ($value1 == $value)
                                $countryCode[$key1] = $value;
                        }
                    }
                    foreach ($countryCode as $country => $currency){
                        $countryName = Zend_Locale_Data::getContent($localeObject, 'country', $country);
                         $select = $currencyTable->select()
                              ->where('code =? ', $currency);
                    $item = $currencyTable->fetchRow($select);
                    $globalRate = round($item->global_rate/$baseCurrencyGlobalRate, 4);
                    $appliedRate = round($item->applied_rate/$baseCurrencyGlobalRate, 4);
                    $currencyArray['currency_name'] = $this->translate($countryName);
                    $currencyArray['code'] = $item->code;
                    $currencyArray['countryCode'] = $country;
                    $currencyArray['symbol'] =$getHost.'/'.$baseUrl.'/application/modules/Sitemulticurrency/externals/images/currency/' . $country . '.png';
                    $currencyArray['globalRate'] = $globalRate;
                    $currencyArray['appliedRate'] = $appliedRate;
            
                    $response['response'][] = $currencyArray;
            
                         
                    }
                }
        } catch (Exception $ex) {
             $this->respondWithValidationError('internal_server_error', $ex->getMessage());
        }
        $this->respondWithSuccess($response);
    }
    
        //ACTION FOR MANAGE CURRENCY RATES 
    public function manageRatesAction() {
        
        $getHost = Engine_Api::_()->getApi('Core', 'siteapi')->getHost();
        $baseUrl = Zend_Controller_Front::getInstance()->getBaseUrl();
        $baseUrl = @trim($baseUrl, "/");
       // $viewer = Engine_Api::_()->user()->getViewer();
        //$viewer_id = $viewer->getIdentity();
        //$local = ($viewer_id) ? $viewer->locale : 'auto';
        //$localeObject = new Zend_Locale($local);
        $coreSettings = Engine_Api::_()->getApi('settings', 'core');
        $currencyTable = Engine_Api::_()->getDbtable('currencyrates', 'sitemulticurrency');
        $currencyTableName = $currencyTable->info('name');
        $baseCurrency = $coreSettings->getSetting('payment.currency', 'USD');
        $baseCurrencyGlobalRate = 1; //API WE DOWNLOAD THE RATES FOR USD
        $infoTosShow = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitemulticurrency.currency.information', 'currencySymbol');
        //ALLOWED CURRENCIES FOR THE USER SIDE
        $alreadyAllowed = $coreSettings->getSetting('sitemulticurrency.allowed.currency', $baseCurrency);
        
//        $table = Engine_Api::_()->getDbtable('modules', 'sitemulticurrency');
//        $select = $table->select()->where('item_module =?', $moduleName);
//        $content = $table->fetchRow($select);
        
        $baseCurrency = Engine_Api::_()->getApi('settings', 'core')->getSetting('payment.currency', 'USD');
        $defaultCurrency = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitemulticurrency.default.display.currency', $baseCurrency);
        $allowedCurr= Engine_Api::_()->getDbTable('currencyrates', 'sitemulticurrency')->getAllowedCurrencies();
        $currencyRegion = Zend_Locale_Data::getList(null, 'currencytoregion');
        $countryCode = array();
        foreach ($allowedCurr as $key => $value) {
            foreach ($currencyRegion as $key1 => $value1) {
                if ($value1 == $value)
                    $countryCode[$key1] = $value;
            }
        }
        
                    
        //CREATED SELECT FOR RATES TABLE
        $select = $currencyTable->select()
                ->from($currencyTableName);
        
        //SEARCH BY CURRECNY NAME AND CODE
        $searchParam['code'] = $this->_getParam('code');
        $searchParam['name'] = $this->_getParam('name');

            if (!empty($searchParam['code']))
                $select->where($currencyTableName . '.code  LIKE ?', '%' . $searchParam['code'] . '%');
            if (!empty($searchParam['name']))
                $select->where($currencyTableName . '.currency_name  LIKE ?', '%' . $searchParam['name'] . '%');
       

        //FETCH ONLY ALLOWED CURRENCIES RATE
        $select->where($currencyTableName . '.code IN(?)', $alreadyAllowed);

        $paginator = Zend_Paginator::factory($select);
        $totalItem = $paginator->getTotalItemCount();
        $paginator->setItemCountPerPage($paginator->getTotalItemCount());
        $paginator->setCurrentPageNumber(1);
        $response=array();
        $response['totalItemCount'] = $totalItem;
        foreach($paginator as $item){
             $currencyArray=array(); 
             $globalRate = round($item->global_rate/$baseCurrencyGlobalRate, 4);
             $appliedRate = round($item->applied_rate/$baseCurrencyGlobalRate, 4);
             //DO NOT SHOW BASE CURRENCY IN LIST 
//            if($item->code == $baseCurrency)
//              continue;
          $countryC= array_search($item->code,$countryCode);
            //GET CURRENCY SYMBOL 
            $localeObject = Zend_Registry::get('Locale');  
            $currency = $item->code;
            $symbol = Zend_Locale_Data::getContent($localeObject, 'currencysymbol', $currency); 
            if(empty($symbol))
               $symbol = $currency;
            //RUPEES SYMBOL NOT AVAILABLE IN ZEND LIBRARY
            if($currency == 'INR')
               $symbol = '₹';  
             $globalRate = round($item->global_rate/$baseCurrencyGlobalRate, 4);
             $appliedRate = round($item->applied_rate/$baseCurrencyGlobalRate, 4);
            $currencyArray['currency_name'] = $item->currency_name;
            $currencyArray['code'] = $item->code;
            $currencyArray['symbol'] = $infoTosShow == 'currencySymbol' ? $symbol:$getHost.'/'.$baseUrl.'/application/modules/Sitemulticurrency/externals/images/currency/' . $countryC . '.png';
            $currencyArray['globalRate'] = $globalRate;
            $currencyArray['appliedRate'] = $appliedRate;
            
            $response['response'][] = $currencyArray;
         }
          $response['defaultCurrency'] = $defaultCurrency;
           $response['isSymbol'] = $infoTosShow;
         $this->respondWithSuccess($response);
    }

}
