<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Genre.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Api_genre extends Core_Api_Abstract
{

  public function getNavigation($module)
  {
    $params = Zend_Controller_Front::getInstance()->getRequest()->getParams();
    $activeItem = null;
    if( isset($params['subcategory_id']) ) {
      $activeItem = $params['subcategory_id'];
    }
    $pages = $this->getCategoryParams($module, $activeItem);
    $navigation = new Zend_Navigation();
    $navigation->addPages($pages);
    return $navigation;
  }

  public function getCategoryParams($module, $activeItem = null)
  {
    $category = $this->getCategory($module);
    $pages = array();
    $count = 0;

    foreach( $category as $row ) {
      $page = null;
      $page['label'] = $row->getTitle();
      // Add type for URI
      $page['type'] = 'uri';
      $page['uri'] = $row->getHref();

      // Set page as active, if necessary
      if( null !== $activeItem && $activeItem == $row->songcategory_id ) {
        $page['active'] = true;
      }

      // Maintain category item order
      if( isset($row->order) ) {
        $page['order'] = $row->order;
      } else {
        $page['order'] = $count;
        $count++;
      }


      $pages[] = $page;
    }

    return $pages;
  }

  public function getCategory($module)
  {

    $songCategoryTable = Engine_Api::_()->getDbtable('songcategories', $module);
    $genereType = $songCategoryTable->getCategoriesAssoc();
    if( $genereType ) {
      $select = $songCategoryTable->select();
      $select->where('cat_dependency = ?', 1);
    }
    return (Zend_Paginator::factory($select));
  }

}
