<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Label.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Api_Label
{

  public function getLabel($params = array())
  {
    $labelTable = Engine_Api::_()->getDbtable('labels', 'sitemusic');
    $lName = $labelTable->info('name');
    $labelMap = Engine_Api::_()->getDbtable('labelMaps', 'sitemusic');
    $lmName = $labelMap->info('name');
    $db = Zend_Db_Table::getDefaultAdapter();
    $select = $db->select();
    $select->from($lmName, array($lName . '.label_name'));
    $select->join($lName, "$lName.label_id = $lmName.label_id", array($lmName . '.label_id', $lmName . '.label_map_id', $lName . '.params'));
    $select->where($lmName . '.resource_type = ?', $params['resource_type'])
      ->where('displayable = ?', 1)
      ->where($lmName . '.resource_id = ?', $params['resource_id']);
    $select->order('label_order ASC');
    if( !isset($params['displayAll']) ) {
      $select->limit(2);
    }
    return $select->query()->fetchAll();
  }

  public function setLabel($params = array())
  {
    $table = Engine_Api::_()->getDbtable('labelMaps', 'sitemusic');
    $select = $table->select()->from('engine4_sitemusic_label_map', 'label_map_id');
    $select->where('label_id = ?', $params['label_id'])
      ->where('resource_id = ?', $params['resource_id'])
      ->where('resource_type = ?', $params['resource_type']);
    $labelMapId = $select->query()->fetchColumn();
    if( empty($labelMapId) ) {
      $db = $table->getAdapter();
      $db->beginTransaction();
      // Update row
      try {
        $label = $table->createRow();
        $label->label_id = $params['label_id'];
        $label->resource_id = $params['resource_id'];
        $label->resource_type = $params['resource_type'];
        $label->save();
        $db->commit();
      } catch( Exception $e ) {
        $db->rollBack();
        throw $e;
      }
    }
  }

  public function getLabelColor($labelId, $type = null)
  {
    $label = Engine_Api::_()->getItem('sitemusic_label', $labelId);
    if( empty($label) ) {
      return;
    }

    if( $label->params ) {
      $params = $label->params;
      $params = Zend_Json_Decoder::decode($params);
      if( !empty($params[$type]) ) {
        return $params[$type];
      }
    }
  }

  public function labelCount($labelId, $resourceType)
  {
    $labelTable = Engine_Api::_()->getDbtable('labels', 'sitemusic');
    $lName = $labelTable->info('name');
    $labelMap = Engine_Api::_()->getDbtable('labelMaps', 'sitemusic');
    $lmName = $labelMap->info('name');
    $db = Zend_Db_Table::getDefaultAdapter();
    $select = $db->select();
    $select->from($lmName, array('count(*) as totalLabel'));
    $select->join($lName, "$lName.label_id = $lmName.label_id", array('label_name'));
    $select->where($lmName . '.resource_type = ?', $resourceType);
    $select->where($lmName . '.label_id = ?', $labelId);
    $select->group($lmName . '.label_id');
    $result = $select->query()->fetch();
    return $result;
  }

}
