<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Artistform.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Form_Admin_Artistform extends Engine_Form
{

  protected $_field;

  public function init()
  {
    $this
      ->setMethod('post')
      ->setAttrib('class', 'global_form')
    ;


//    $label = new Zend_Form_Element_Text('label');
//    $label->setLabel('Artist Name')
//      ->addValidator('NotEmpty')
//      ->setRequired(true)
//      ->setAttrib('class', 'text');
//
    $id = new Zend_Form_Element_Hidden('id');

    $this->addElement('hidden', 'id', array('order' =>'999'));
//
//
//    $this->addElements(array(
//      //$type,
//      $label,
//      $id
//    ));

        // Init name
    $this->addElement('Text', 'label', array(
      'label' => 'Artist Name',
      'required' => true,
      'maxlength' => '63',
      'filters' => array(
        //new Engine_Filter_HtmlSpecialChars(),
        new Engine_Filter_Censor(),
        new Engine_Filter_StringLength(array('max' => '63')),
      )
    ));

    $this->addElement('File', 'profilephoto', array(
      'label' => 'Choose Profile Photo',
    ));
    $this->profilephoto->addValidator('Extension', false, 'jpg,png,gif,jpeg');

    $this->addElement('File', 'coverphoto', array(
      'label' => 'Choose Cover Photo',
    ));
    $this->coverphoto->addValidator('Extension', false, 'jpg,png,gif,jpeg');


    $this->addElement('Textarea', 'description', array(
      'label' => 'Description',
      'allowEmpty' => false,
      'required' => true,
      'filters' => array(
        new Engine_Filter_Censor(),
        'StripTags',
        new Engine_Filter_StringLength(array('max' => '63'))
      ),
      'autofocus' => 'autofocus',
    ));

    // Buttons
    $this->addElement('Button', 'submit', array(
      'label' => 'Add Artist',
      'type' => 'submit',
      'ignore' => true,
      'decorators' => array('ViewHelper')
    ));

    $this->addElement('Cancel', 'cancel', array(
      'label' => 'cancel',
      'link' => true,
      'prependText' => ' or ',
      'href' => '',
      'onClick' => 'javascript:parent.Smoothbox.close();',
      'decorators' => array(
        'ViewHelper'
      )
    ));
    $this->addDisplayGroup(array('submit', 'cancel'), 'buttons');
    $button_group = $this->getDisplayGroup('buttons');
  }

  public function setField($artist)
  {
    $this->_field = $artist;
    $this->label->setValue($artist->title);
    $this->id->setValue($artist->artist_id);
    $this->description->setValue($artist->description);
    $this->submit->setLabel('Edit');
  }

}
