<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Global.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Form_Admin_Global_Playlist extends Engine_Form
{

  public function init()
  {
    $this
      ->setTitle('Playlist Settings')
      ->setDescription('These settings will affect all the member levels of your community.');


    $settings = Engine_Api::_()->getApi('settings', 'core');

    $this->addElement('Radio', 'sitemusic_enable_playlist', array(
      'label' => 'Allow Playlists',
      'description' => 'Do you want to allow members to create playlists?',
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No',
      ),
      'value' => $settings->getSetting('sitemusic.enable.playlist', 1),
    ));

    $this->addElement('Radio', 'sitemusic_enable_playlistfavourite', array(
      'label' => 'Favourite',
      'description' => 'Do you want to enable favourite feature for playlists?',
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No',
      ),
      'value' => $settings->getSetting('sitemusic.enable.playlistfavourite', 1),
    ));

    $this->addElement('Radio', 'sitemusic_enable_playlistshare', array(
      'label' => 'Share',
      'description' => 'Do you want to enable share option for playlists?',
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No',
      ),
      'value' => $settings->getSetting('sitemusic.enable.playlistshare', 1),
    ));

    $this->addElement('Radio', 'sitemusic_enable_playlistreport', array(
      'label' => 'Report',
      'description' => 'Do you want to enable report option?',
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No',
      ),
      'value' => $settings->getSetting('sitemusic.enable.playlistreport', 1),
    ));

    $this->addElement('Radio', 'sitemusic_enable_playlistrating', array(
      'label' => 'Rating',
      'description' => 'Do you want to enable rating feature for playlists?',
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No',
      ),
      'onclick' => 'showUpdateratingSetting(this.value)',
      'value' => $settings->getSetting('sitemusic.enable.playlistrating', 1),
    ));

    $this->addElement('Radio', 'sitemusicplaylistrating_update', array(
      'label' => 'Allow Updating of Rating?',
      'description' => "Do you want to let members to update their rating for playlists?",
      'MultiOptions' => array('1' => 'Yes', '0' => 'No'),
      'value' => $settings->getSetting('sitemusicplaylistrating.update', 1),
    ));

    $this->addElement('Radio', 'sitemusic_own_playlistrating', array(
      'label' => 'Allow Rate to own playlists?',
      'description' => "Do you want to let members to rate their own playlists?",
      'MultiOptions' => array('1' => 'Yes', '0' => 'No'),
      'value' => $settings->getSetting('sitemusic.own.playlistrating', 1),
    ));

    // Get available files
    $coverPhotoOptions = Engine_Api::_()->sitemusic()->getImages(array('' => ''));

    $this->addElement('Select', 'sitemusic_playlistcoverPhoto', array(
      'label' => 'Default Cover Photo',
      'description' => 'Select the default cover photo to be displayed on Playlist profile page. This photo will be visible to users as cover photo if they don’t upload any it themselves. (Note: You can upload the photo from: "Appearance" > "File & Media Manager".)',
      'multiOptions' => $coverPhotoOptions,
      'value' => $settings->getSetting('sitemusic.playlistcoverPhoto'),
    ));

    // Add submit button
    $this->addElement('Button', 'submit', array(
      'label' => 'Save Changes',
      'type' => 'submit',
      'ignore' => true
    ));
  }

}
