<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Labelcategory.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Form_Admin_Labelcategory extends Engine_Form
{

  protected $_field;

  public function init()
  {
    $this
      ->setMethod('post')
      ->setTitle('Add New Label')
      ->setAttrib('class', 'global_form_box')
    ;



//    $label = new Zend_Form_Element_Text('label_name');
//    $label->setLabel('Label Name')
//      ->addValidator('NotEmpty')
//      ->setRequired(true)
//      ->setAttrib('class', 'text');
//
//    $id = new Zend_Form_Element_Hidden('id');

    $this->addElement('Text', 'label_name', array(
      'label' => 'Label Name (10 Characters)',
      'maxlength' => '10',
      'required' => true,
      'filters' => array(
        //new Engine_Filter_HtmlSpecialChars(),
        new Engine_Filter_Censor(),
        new Engine_Filter_StringLength(array('max' => '63')),
      ),
    ));


//    $order = new Zend_Form_Element_Text('label_order');
//    $order->setLabel('Label Order')
//      ->setDescription('Enter only numeric value')
//      ->addValidator('NotEmpty')
//      ->setRequired(true)
//      ->setAttrib('class', 'text');
//
//    $this->addElements(array(
//      //$type,
//      $label,
//      $id,
//      $order
//    ));


    $this->addElement('Text', 'sitemusic_label_text_color', array(
      'decorators' => array(array('ViewScript', array(
            'viewScript' => 'application/modules/Sitemusic/views/scripts/form-image-rainbow/_formImagerainbow1.tpl',
            'class' => 'form element',
          )))
    ));

    $this->addElement('Text', 'sitemusic_label_color', array(
      'decorators' => array(array('ViewScript', array(
            'viewScript' => 'application/modules/Sitemusic/views/scripts/form-image-rainbow/_formImagerainbow.tpl',
            'class' => 'form element',
          )))
    ));

    // Buttons
    $this->addElement('Button', 'submit', array(
      'label' => 'Add',
      'type' => 'submit',
      'ignore' => true,
      'decorators' => array('ViewHelper')
    ));

    $this->addElement('Cancel', 'cancel', array(
      'label' => 'cancel',
      'link' => true,
      'prependText' => ' or ',
      'href' => '',
      'onClick' => 'javascript:parent.Smoothbox.close();',
      'decorators' => array(
        'ViewHelper'
      )
    ));
    $this->addDisplayGroup(array('submit', 'cancel'), 'buttons');
    $button_group = $this->getDisplayGroup('buttons');
  }

  public function setField($category)
  {
    $this->_field = $category;
    $this->label->setValue($category->label_name);
    $this->id->setValue($category->label_id);
    $this->submit->setLabel('Edit');
  }

}
