<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AssingLabel.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Form_Admin_Manage_AssignLabel extends Engine_Form
{

  protected $_field;

  public function init()
  {
    $url = null;
    if( isset($this->_attribs['url']) ) {
    $url = $this->_attribs['url'];
    }
    $this
      ->setMethod('post')
      ->setAttrib('class', 'global_form_box')
    ;

    $this->setTitle('Assign Label');
    $table = Engine_Api::_()->getDbtable('labels', 'sitemusic');
    $labelType = $table->getCategoriesAssoc();

    if( !empty($labelType) ) {
      $this->addElement('MultiCheckbox', 'label', array(
        'multiOptions' => $labelType,
      ));

      $this->addElement('Button', 'submit', array(
        'label' => 'Assign Label',
        'type' => 'submit',
        'ignore' => true,
        'decorators' => array('ViewHelper')
      ));
    } else {
      echo "You have not created any label yet. Please " .$url. " to create new label.";
    }
    $this->addElement('Cancel', 'cancel', array(
      'label' => 'cancel',
      'link' => true,
      'prependText' => ' or ',
      'href' => '',
      'onClick' => 'javascript:parent.Smoothbox.close();',
      'decorators' => array(
        'ViewHelper'
      )
    ));
    $this->addDisplayGroup(array('submit', 'cancel'), 'buttons');
    $button_group = $this->getDisplayGroup('buttons');
  }

}
