<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Album.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Form_Admin_Widget_ContentType extends Engine_Form
{

  public function init()
  {
    parent::init();

    $this->addElement('Text', 'gridViewWidth', array(
      'label' => 'Column Width for Grid View.',
      'value' => '167',
    ));

    $this->addElement('Text', 'gridViewHeight', array(
      'label' => 'Column height for Grid View Image.',
    ));

    $coreApi = Engine_Api::_()->getApi('core', 'sitemusic');
    $albumOptions = $coreApi->getAlbumOptions();
    $albumViewOptions = $coreApi->getAlbumListViewOptions();

    $this->addElement('MultiCheckbox', 'showOptions', array(
      'label' => 'Choose the option that you want to be available for the music albums in this block.',
      'multiOptions' => $albumOptions
    ));

    $this->addElement('MultiCheckbox', 'showSongOptions', array(
      'label' => 'Choose the option that you want to be available for the songs displaying in list view/card view of music albums in this block.',
      'multiOptions' => $albumViewOptions
    ));

    $this->addElement('Text', 'gridTitleTruncationLimit', array(
      'label' => 'Title Truncation Limit',
      'value' => '100',
      'validators' => array(
        array('Int', true),
        array('GreaterThan', true, array(0))),
    ));

    $this->addElement('Text', 'limit', array(
      'label' => 'Count',
      'description' => '(number of items to show)',
      'value' => 5,
    ));
  }

}

?>