<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: ArtistOfTheDay.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Form_Admin_Widget_Item_ArtistOfTheDay extends Core_Form_Admin_Widget_Standard
{

  public function init()
  {
    parent::init();

    // Set form attributes
    $this
      ->setTitle('Special Artists');

    $this->addElement('Text', 'item_title', array(
      'label' => 'Member',
      'decorators' => array(array('ViewScript', array(
            'viewScript' => '/application/modules/Sitemusic/views/scripts/widget-settings/pic-of-day-artist.tpl',
            'class' => 'form element')))
    ));

    $this->addElement('text', 'artist_id', array());
    $this->addElement('hidden', 'itemIds', array('value' => ''));

    $this->addElement('Text', 'titleTruncationLimit', array(
      'label' => 'Title Truncation Limit',
      'value' => '100',
      'validators' => array(
        array('Int', true),
        array('GreaterThan', true, array(0))),
    ));

    // Start time
    $start = new Engine_Form_Element_CalendarDateTime('starttime');
    $start->setLabel("Start Time");
    $start->setAllowEmpty(true);
    $this->addElement($start);

    // End time
    $end = new Engine_Form_Element_CalendarDateTime('endtime');
    $end->setLabel("End Time");
    $end->setAllowEmpty(true);
    $this->addElement($end);

    $this->addElement('Text', 'limit', array(
      'label' => 'Count',
      'description' => '(number of items to show)',
      'value' => 5,
    ));
  }

}
