<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Recent.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Form_Admin_Widget_Recent extends Core_Form_Admin_Widget_Standard
{

  public function init()
  {
    parent::init();

    // Set form attributes
    $this
      ->setTitle('Display List Recent')
      ->setDescription('List Recent');

    $entities = Engine_Api::_()->getDbtable('entities', 'sitemusic')->getEntity();
    if( !empty($entities) ) {
      $this->addElement('Select', 'listType', array(
        'label' => 'List Type',
        'multiOptions' => $entities,
        'value' => 'album',
        'allowEmpty' => false,
        'required' => true,
        'validators' => array(
          array('NotEmpty', true),
        )
      ));
    }

    $this->addElement('Radio', 'recentType', array(
      'label' => 'Recent Type',
      'multiOptions' => array(
        'creation' => 'Creation Date',
        'modified' => 'Modified Date',
      ),
      'value' => 'creation',
    ));

    $this->addElement('Text', 'itemCountPerPage', array(
      'label' => 'Count',
      'description' => '(number of item to show)',
      'value' => 4,
    ));
  }

}
