<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: SongGeneral.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Form_Admin_Widget_RecentlyPlayed extends Core_Form_Admin_Widget_Standard
{

  public function init()
  {
    parent::init();

    $this->addElement('Text', 'titleTruncationLimit', array(
      'label' => 'Title Truncation Limit',
      'value' => '100',
      'validators' => array(
        array('Int', true),
        array('GreaterThan', true, array(0))),
    ));

    $song = Engine_Api::_()->getDbtable('playlistSongs', 'sitemusic');
    $songOptions = $song->getMinInfoViewOptions();
    $extraOption = array();
    $extraOption = array('playAll' => "Play All", 'clearAll' => "Clear All");
    $songOptions = $songOptions + $extraOption;
    $this->addElement('MultiCheckbox', 'showOptions', array(
      'label' => 'Choose the options that you want to be available for the songs in this block.',
      'multiOptions' => $songOptions
    ));

    $this->addElement('Text', 'limit', array(
      'label' => 'Count',
      'description' => '(number of items to show)',
      'value' => 5,
    ));
  }

}

?>