<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Song.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Form_Admin_Widget_Related_Song extends Sitemusic_Form_Admin_Widget_Script_Song
{

  public function init()
  {
    parent::init();

    $this->addElement('Text', 'thumbnailTitleTruncationLimit', array(
      'label' => 'Title truncation limit for Thumbnail View.',
      'value' => '100',
      'validators' => array(
        array('Int', true),
        array('GreaterThan', true, array(0))),
    ));

    $this->addElement('Select', 'relatedType', array(
      'label' => 'Genre',
      'multiOptions' => array(
        "album" => "songs from the same album",
        "owner" => "songs from the same owner",
        "artist" => "songs from the same artist",
        "genre" => "songs from the same genre",
      ),
    ));

    $this->addElement('Text', 'limit', array(
      'label' => 'Count',
      'description' => '(number of items to show)',
      'value' => 5,
    ));
  }

}

?>
