<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: ArtistGeneral.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Form_Admin_Widget_Browse_Artist extends Core_Form_Admin_Widget_Standard
{

  public function init()
  {
    parent::init();


    $artistOptions = Engine_Api::_()->getApi('core', 'sitemusic')->getArtistOptions();
    $this->addElement('MultiCheckbox', 'showOptions', array(
      'label' => 'Choose the option that you want to be available for the block.',
      'multiOptions' => $artistOptions
    ));

    $labelTable = Engine_Api::_()->getDbtable('labels', 'sitemusic');
    $labelType = $labelTable->getCategoriesAssoc();
    $labelOption = array("all" => "All");
    if( !empty($labelType) ) {
      $labelOption = $labelOption + $labelType;
      $this->addElement('Select', 'label_category', array(
        'label' => 'Label Category',
        'multiOptions' => $labelOption,
      ));
    }

    $this->addElement('MultiCheckbox', 'artist_layout_views', array(
      'label' => 'Choose the view types for artist that you want to be available for the widget.',
      'required' => true,
      'multiOptions' => array(
        "gridZZZview" => "Grid View",
        "thumbnailZZZview" => "Thumbnail View"
      ),
      'onclick' => 'onLayoutSelect()',
    ));

    $this->addElement('Radio', 'artistDefaultLayout', array(
      'label' => 'Choose the default view types for artist that you want to be available for the widget.',
      'multiOptions' => array(
        "gridZZZview" => "Grid View",
        "thumbnailZZZview" => "Thumbnail View"
      ),
      'value' => "gridZZZview",
    ));

    $this->addElement('Text', 'gridViewWidth', array(
      'label' => 'Column Width For Grid View.',
      'value' => '167',
    ));

    $this->addElement('Text', 'titleTruncationLimit', array(
      'label' => 'Title Truncation Limit',
      'value' => '100',
      'validators' => array(
        array('Int', true),
        array('GreaterThan', true, array(0))),
    ));

    $this->addElement('Text', 'gridTitleTruncationLimit', array(
      'label' => 'Title Truncation Limit in Grid View',
      'value' => '100',
      'validators' => array(
        array('Int', true),
        array('GreaterThan', true, array(0))),
    ));

//    $this->addElement('Text', 'gridViewHeight', array(
//      'label' => 'Column Height For Grid View.',
//      'value' => '328',
//    ));

    $this->addElement('Radio', 'default_sort', array(
      'label' => 'Default ordering in browse artist',
      'multiOptions' => array(
        'creationDate' => 'All artist in decending order of upload time',
        'alphabetic' => 'All artist in alphabetic order'),
      'value' => 'ascending_order'
    ));

    $this->addElement('Radio', 'showViewMore', array(
      'label' => 'Show view more',
      'description' => '',
      'multiOptions' => array(
        '1' => 'Yes',
        '0' => 'No'),
      'value' => 1,
    ));


    $this->addElement('Text', 'limit', array(
      'label' => 'Count',
      'description' => '(number of item to show)',
      'value' => 5,
    ));
  }

}
?>
<script>
  en4.core.runonce.add(function () {
    onLayoutSelect();

  });
  function onLayoutSelect()
  {
    if ($('artist_layout_views-gridZZZview').checked) {
      $('artistDefaultLayout-gridZZZview').disabled = false;
    } else {
      $('artistDefaultLayout-gridZZZview').disabled = true;
    }
    if ($('artist_layout_views-thumbnailZZZview').checked) {
      $('artistDefaultLayout-thumbnailZZZview').disabled = false;
    } else {
      $('artistDefaultLayout-thumbnailZZZview').disabled = true;
    }
  }
</script>