<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: SongGeneral.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Form_Admin_Widget_User_Song extends Sitemusic_Form_Admin_Widget_Script_Song
{

  public function init()
  {
    parent::init();

    $this->addElement('Text', 'titleTruncationLimit', array(
      'label' => 'Title Truncation Limit',
      'value' => '100',
      'validators' => array(
        array('Int', true),
        array('GreaterThan', true, array(0))),
    ));

    $this->addElement('Text', 'limit', array(
      'label' => 'Count',
      'description' => '(number of items to show)',
      'value' => 5,
    ));
  }

}
?>
<script>
  en4.core.runonce.add(function () {
    window.setTimeout(onLayoutSelect, 1000);
  });

  function onLayoutSelect()
  {
    var listView = $('song_layout_views-listZZZview');
    var gridView = $('song_layout_views-gridZZZview');
    var thumbnailView = $('song_layout_views-thumbnailZZZview');

    if ($('song_layout_views-listZZZview').checked) {
      $('songDefaultLayout-listZZZview').disabled = false;
    } else {
      $('songDefaultLayout-listZZZview').disabled = true;
    }
    if ($('song_layout_views-gridZZZview').checked) {
      $('songDefaultLayout-gridZZZview').disabled = false;
    } else {
      $('songDefaultLayout-gridZZZview').disabled = true;
    }
    if ($('song_layout_views-thumbnailZZZview').checked) {
      $('songDefaultLayout-thumbnailZZZview').disabled = false;
    } else {
      $('songDefaultLayout-thumbnailZZZview').disabled = true;
    }

    if (!(listView.checked) && !(gridView.checked) && !(thumbnailView.checked)) {
      $('showOptions-songLike').parentElement.style.display = 'block';
      $('showOptions-songShare').parentElement.style.display = 'block';
    }

    if (listView.checked) {
      $('showOptions-songLike').parentElement.style.display = 'block';
      $('showOptions-songShare').parentElement.style.display = 'block';
    }

    if (thumbnailView.checked && !(listView.checked)) {
      $('showOptions-songLike').parentElement.style.display = 'none';
      $('showOptions-songShare').parentElement.style.display = 'none';
    }

    if (gridView.checked && !(listView.checked)) {
      $('showOptions-songLike').parentElement.style.display = 'block';
      $('showOptions-songShare').parentElement.style.display = 'none';
    }
  }
</script>