<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: UserFavourite.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Form_Admin_Widget_UserFavourite extends Core_Form_Admin_Widget_Standard
{

  public function init()
  {
    parent::init();

    $entities = Engine_Api::_()->getDbtable('entities', 'sitemusic')->getEntity();
    if( !empty($entities) ) {
      $this->addElement('MultiCheckbox', 'ajaxTabs', array(
        'label' => 'Select the music entities which you want to display in this block.',
        'multiOptions' => $entities,
        'onchange' => 'javascript:onTypeChange();'
      ));
    }

    $this->addElement('MultiCheckbox', 'album_layout_views', array(
      'label' => 'Choose the view types for album that you want to be available for the widget.',
      'required' => true,
      'multiOptions' => array(
        "listZZZview" => "Player View",
        "gridZZZview" => "Grid View",
        "cardZZZview" => "Card View",
        "thumbnailZZZview" => "Thumbnail View",
      ),
      'onclick' => 'onTypeChange()'
    ));

    $this->addElement('MultiCheckbox', 'playlist_layout_views', array(
      'label' => 'Choose the view types for playlist that you want to be available for the widget.',
      'required' => true,
      'multiOptions' => array(
        "listZZZview" => "Player View",
        "cardZZZview" => "Card View",
        "gridZZZview" => "Grid View",
        "thumbnailZZZview" => "Thumbnail View"
      ),
      'onclick' => 'onTypeChange()'
    ));


    $this->addElement('MultiCheckbox', 'song_layout_views', array(
      'label' => 'Choose the view types for song that you want to be available for the widget.',
      'required' => true,
      'multiOptions' => array(
        "listZZZview" => "List View",
        "gridZZZview" => "Grid View",
        "thumbnailZZZview" => "Thumbnail View",
      ),
      'onclick' => 'onTypeChange()'
    ));

    $this->addElement('Radio', 'albumDefaultLayout', array(
      'label' => 'Choose the default view types for album that you want to be available for the widget.',
      'multiOptions' => array(
        "listZZZview" => "Player View",
        "gridZZZview" => "Grid View",
        "cardZZZview" => "Card View",
        "thumbnailZZZview" => "Thumbnail View",
      )
    ));

    $this->addElement('Radio', 'playlistDefaultLayout', array(
      'label' => 'Choose the default view types for playlist that you want to be available for the widget.',
      'multiOptions' => array(
        "listZZZview" => "Player View",
        "cardZZZview" => "Card View",
        "gridZZZview" => "Grid View",
        "thumbnailZZZview" => "Thumbnail View"
      ),
      'value' => 'list_view',
    ));

    $this->addElement('Radio', 'songDefaultLayout', array(
      'label' => 'Choose the default view types for song that you want to be available for the widget.',
      'multiOptions' => array(
        "listZZZview" => "List View",
        "gridZZZview" => "Grid View",
        "thumbnailZZZview" => "Thumbnail View",
      )
    ));



    $this->addElement('Text', 'gridViewWidth', array(
      'label' => 'Column width For Grid View.',
      'value' => '180',
    ));

    $this->addElement('Text', 'gridViewHeight', array(
      'label' => 'Column height for Grid View Image.',
    ));

//    $this->addElement('Text', 'gridViewHeight', array(
//      'label' => 'Column Height For Grid View.',
//      'value' => '328',
//    ));

    $this->addElement('Text', 'cardViewWidth', array(
      'label' => 'Column Width For Card View.',
      'value' => '180',
    ));

    $this->addElement('Text', 'cardViewHeight', array(
      'label' => 'Column Height For Card View.',
      'value' => '328',
    ));

    $this->addElement('Text', 'Album', array(
      'label' => 'Album Tab (order)',
      'value' => 1,
    ));

    $this->addElement('Text', 'Playlist', array(
      'label' => 'Playlist Tab (order)',
      'value' => 2,
    ));

    $this->addElement('Text', 'Song', array(
      'label' => 'Song Tab (order)',
      'value' => 3,
    ));

    $this->addElement('Text', 'Artist', array(
      'label' => 'Artist Tab (order)',
      'value' => 4,
    ));

    $this->addElement('Text', 'limit', array(
      'label' => 'Count',
      'description' => '(number of item to show)',
      'value' => 5,
    ));

    $this->addElement('Text', 'listTitleTruncationLimit', array(
      'label' => 'Title truncation limit for Player View and List View.',
      'value' => '100',
      'validators' => array(
        array('Int', true),
        array('GreaterThan', true, array(0))),
    ));

    $this->addElement('Text', 'cardTitleTruncationLimit', array(
      'label' => 'Title truncation limit for Card View.',
      'value' => '100',
      'validators' => array(
        array('Int', true),
        array('GreaterThan', true, array(0))),
    ));

    $this->addElement('Text', 'gridTitleTruncationLimit', array(
      'label' => 'Title truncation limit for Grid View.',
      'value' => '100',
      'validators' => array(
        array('Int', true),
        array('GreaterThan', true, array(0))),
    ));

    $this->addElement('Text', 'thumbnailTitleTruncationLimit', array(
      'label' => 'Title truncation limit for Thumbnail View.',
      'value' => '100',
      'validators' => array(
        array('Int', true),
        array('GreaterThan', true, array(0))),
    ));

    $this->addElement('Text', 'limit', array(
      'label' => 'Count',
      'description' => '(number of items to show)',
      'value' => 5,
    ));
  }

}
?>
<script type="text/javascript">

  en4.core.runonce.add(function () {
    setTimeout(onTypeChange, 1000);
  });

  function onTypeChange()
  {
    if ($('ajaxTabs-album').checked) {
      //    $('genre_id-wrapper').style.display = 'none';
//      $('playlist_layout_views-wrapper').style.display = 'none';
//      $('song_layout_views-wrapper').style.display = 'none';
//      $('playlistDefaultLayout-wrapper').style.display = 'none';
//      $('songDefaultLayout-wrapper').style.display = 'none';

      //    $('album_category-wrapper').style.display = 'block';
      $('album_layout_views-wrapper').style.display = 'block';
      $('albumDefaultLayout-wrapper').style.display = 'block';
      $('gridViewWidth-wrapper').style.display = 'block';
      $('cardViewWidth-wrapper').style.display = 'block';
      $('cardViewHeight-wrapper').style.display = 'block';
      $('Album-wrapper').style.display = 'block';

      if ($('album_layout_views-listZZZview').checked) {
        $('albumDefaultLayout-listZZZview').disabled = false;
      } else {
        $('albumDefaultLayout-listZZZview').disabled = true;
      }
      if ($('album_layout_views-gridZZZview').checked) {
        $('albumDefaultLayout-gridZZZview').disabled = false;
      } else {
        $('albumDefaultLayout-gridZZZview').disabled = true;
      }
      if ($('album_layout_views-cardZZZview').checked) {
        $('albumDefaultLayout-cardZZZview').disabled = false;
      } else {
        $('albumDefaultLayout-cardZZZview').disabled = true;
      }
      if ($('album_layout_views-thumbnailZZZview').checked) {
        $('albumDefaultLayout-thumbnailZZZview').disabled = false;
      } else {
        $('albumDefaultLayout-thumbnailZZZview').disabled = true;
      }

    } else {
      $('album_layout_views-wrapper').style.display = 'none';
      $('albumDefaultLayout-wrapper').style.display = 'none';
      $('Album-wrapper').style.display = 'none';
    }
    if ($('ajaxTabs-playlist').checked) {
      if ($('playlist_layout_views-listZZZview').checked) {
        $('playlistDefaultLayout-listZZZview').disabled = false;
      } else {
        $('playlistDefaultLayout-listZZZview').disabled = true;
      }
      if ($('playlist_layout_views-gridZZZview').checked) {
        $('playlistDefaultLayout-gridZZZview').disabled = false;
      } else {
        $('playlistDefaultLayout-gridZZZview').disabled = true;
      }
      if ($('playlist_layout_views-cardZZZview').checked) {
        $('playlistDefaultLayout-cardZZZview').disabled = false;
      } else {
        $('playlistDefaultLayout-cardZZZview').disabled = true;
      }
      if ($('playlist_layout_views-thumbnailZZZview').checked) {
        $('playlistDefaultLayout-thumbnailZZZview').disabled = false;
      } else {
        $('playlistDefaultLayout-thumbnailZZZview').disabled = true;
      }

      $('playlistDefaultLayout-wrapper').style.display = 'block';
      $('playlist_layout_views-wrapper').style.display = 'block';
      $('cardViewWidth-wrapper').style.display = 'block';
      $('cardViewHeight-wrapper').style.display = 'block';
      $('Playlist-wrapper').style.display = 'block';
    } else {
      $('playlistDefaultLayout-wrapper').style.display = 'none';
      $('playlist_layout_views-wrapper').style.display = 'none';
      $('Playlist-wrapper').style.display = 'none';
    }
    if (($('ajaxTabs-album').checked) === false && ($('ajaxTabs-playlist').checked) === false) {
      $('cardViewWidth-wrapper').style.display = 'none';
      $('cardViewHeight-wrapper').style.display = 'none';
    }
    if (($('ajaxTabs-artist').checked) === false && ($('ajaxTabs-album').checked) === false && ($('ajaxTabs-song').checked) === false) {
      $('gridViewWidth-wrapper').style.display = 'none';
    }
    if ($('ajaxTabs-song').checked) {
      if ($('song_layout_views-listZZZview').checked) {
        $('songDefaultLayout-listZZZview').disabled = false;
      } else {
        $('songDefaultLayout-listZZZview').disabled = true;
      }
      if ($('song_layout_views-gridZZZview').checked) {
        $('songDefaultLayout-gridZZZview').disabled = false;
      } else {
        $('songDefaultLayout-gridZZZview').disabled = true;
      }
      if ($('song_layout_views-thumbnailZZZview').checked) {
        $('songDefaultLayout-thumbnailZZZview').disabled = false;
      } else {
        $('songDefaultLayout-thumbnailZZZview').disabled = true;
      }

      $('songDefaultLayout-wrapper').style.display = 'block';
      $('song_layout_views-wrapper').style.display = 'block';
      $('gridViewWidth-wrapper').style.display = 'block';
      $('Song-wrapper').style.display = 'block';
    } else {
      $('songDefaultLayout-wrapper').style.display = 'none';
      $('song_layout_views-wrapper').style.display = 'none';
      $('Song-wrapper').style.display = 'none';
    }
//
    if ($('ajaxTabs-artist').checked) {
      $('gridViewWidth-wrapper').style.display = 'block';
      $('Artist-wrapper').style.display = 'block';
    } else {
      $('Artist-wrapper').style.display = 'none';
    }
  }
</script>