<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: UserFavourite.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Form_Admin_Widget_UserFollowing extends Core_Form_Admin_Widget_Standard
{

  public function init()
  {
    parent::init();

    $entities = Engine_Api::_()->getDbtable('entities', 'sitemusic')->getEntity();
    if( !empty($entities) ) {
      $this->addElement('MultiCheckbox', 'ajaxTabs', array(
        'label' => 'Select the music entities which you want to display in this block.',
        'multiOptions' => array(
          'album' => 'Music Albums',
          'user' => 'Users',
          'artist' => 'Artists'),
        'onchange' => 'javascript:onTypeChange();'
      ));
    }

    $this->addElement('MultiCheckbox', 'album_layout_views', array(
      'label' => 'Choose the view types for album that you want to be available for the widget.',
      'required' => true,
      'multiOptions' => array(
        "listZZZview" => "Player View",
        "gridZZZview" => "Grid View",
        "cardZZZview" => "Card View",
        "thumbnailZZZview" => "Thumbnail View",
      ),
      'onclick' => 'onTypeChange()'
    ));

    $this->addElement('Radio', 'album_default_views', array(
      'label' => 'Choose the default view types for album that you want to be available for the widget.',
      'multiOptions' => array(
        "listZZZview" => "Player View",
        "gridZZZview" => "Grid View",
        "cardZZZview" => "Card View"
      ),
      'value' => 'listZZZview',
    ));

    $this->addElement('Text', 'Album', array(
      'label' => 'Album Tab (order)',
      'value' => 1,
    ));

    $this->addElement('Text', 'Artist', array(
      'label' => 'Artist Tab (order)',
      'value' => 2,
    ));

    $this->addElement('Text', 'User', array(
      'label' => 'User Tab (order)',
      'value' => 3,
    ));

    $this->addElement('Text', 'limit', array(
      'label' => 'Count',
      'description' => '(number of items to show)',
      'value' => 5,
    ));
  }

}
?>
<script type="text/javascript">

  en4.core.runonce.add(function () {
    setTimeout(onTypeChange, 1000);
  });

  function onTypeChange()
  {
    if ($('ajaxTabs-album').checked) {
      $('album_layout_views-wrapper').style.display = 'block';
      $('album_default_views-wrapper').style.display = 'block';
//      $('gridViewWidth-wrapper').style.display = 'block';
//      $('gridViewHeight-wrapper').style.display = 'block';
//      $('cardViewWidth-wrapper').style.display = 'block';
//      $('cardViewHeight-wrapper').style.display = 'block';
      $('Album-wrapper').style.display = 'block';
    } else {
      $('album_layout_views-wrapper').style.display = 'none';
      $('album_default_views-wrapper').style.display = 'none';
      $('Album-wrapper').style.display = 'none';
//      $('cardViewWidth-wrapper').style.display = 'none';
//      $('cardViewHeight-wrapper').style.display = 'none';
    }
//    if (($('ajaxTabs-artist').checked) === false && ($('ajaxTabs-album').checked) === false) {
//      $('gridViewWidth-wrapper').style.display = 'none';
//      $('gridViewHeight-wrapper').style.display = 'none';
//    }
    if ($('ajaxTabs-artist').checked) {
//      $('gridViewWidth-wrapper').style.display = 'block';
//      $('gridViewHeight-wrapper').style.display = 'block';
      $('Artist-wrapper').style.display = 'block';
    } else {
      $('Artist-wrapper').style.display = 'none';
    }
    if ($('ajaxTabs-user').checked) {
      $('User-wrapper').style.display = 'block';
    } else {
      $('User-wrapper').style.display = 'none';
    }
  }
</script>