<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: info.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Form_Search extends Engine_Form
{

  public function init()
  {
    $this
      ->setAttribs(array(
        'id' => 'filter_form',
        'class' => 'global_form_box',
      ))
      ->setAction(Zend_Controller_Front::getInstance()->getRouter()->assemble(array()))
      ->setMethod('GET')
    ;

    parent::init();

    $this->addElement('Text', 'search', array(
      'label' => 'Search Music',
      'placeholder' => 'Start typing…'
    ));
    $entities = Engine_Api::_()->getDbtable('entities', 'sitemusic')->getEntity();
    if( !empty($entities) ) {
      $this->addElement('Select', 'type', array(
        'label' => 'Music Entity',
        'multiOptions' => $entities,
        'onchange' => 'javascript:onTypeChange(this.value);',
      ));
    }

    $this->addElement('Select', 'songShowOptions', array(
      'label' => 'Songs',
      'multiOptions' => array(
        '1' => "In My Music Albums",
        '2' => "Uploaded by me in my Music Album",
        '3' => "Uploaded by Others in my Music Album",
        '4' => "Uploaded by me in Other’s Music Album",
        '5' => "Pending for my Approval",
        '6' => "Waiting for Approval",
        '7' => "My All Songs",
        '8' => "All Songs"
      ),
    ));

    $this->addElement('Select', 'show', array(
      'label' => 'Show',
      'multiOptions' => array(
        '1' => 'Everyone',
        '2' => 'By Friends',
        '3' => 'By Me',
      ),
    ));

    $songCategoryTable = Engine_Api::_()->getDbtable('songcategories', 'sitemusic');
    $genereType = $songCategoryTable->getCategoriesAssoc();
    if( !empty($genereType) ) {
      $subType = $songCategoryTable->getSubCategoriesAssoc($genereType);
    }
    $genreOption = array("all" => "All Genre");
    if( !empty($subType) ) {
      $genreOption = $genreOption+$subType;
      $this->addElement('Select', 'genreId', array(
        'label' => 'Genre',
        'multiOptions' => $genreOption,
      ));
    }

    $albumCategoryTable = Engine_Api::_()->getDbtable('albumcategories', 'sitemusic');
    $albumType = $albumCategoryTable->getCategoriesAssoc();
    $albumOption = array("all" => "All Categories");
    if( !empty($albumType) ) {
      $albumOption = $albumOption + $albumType;
      $this->addElement('Select', 'albumcategory_id', array(
        'label' => 'Album Category',
        'multiOptions' => $albumOption,
      ));
    }

    $labelTable = Engine_Api::_()->getDbtable('labels', 'sitemusic');
    $labelType = $labelTable->getCategoriesAssoc();
    $labelOption = array("" => "Labels");
    if( !empty($labelType) ) {
      $labelOption = $labelOption + $labelType;
    }

//    $this->addElement('Select', 'labelType', array(
//      'label' => 'Label',
//      'placeholder' => 'Labels',
//      'multiOptions' => $labelOption,
//      'decorators' => array(
//        'ViewHelper',
//        array('Label', array('tag' => null, 'placement' => 'PREPEND')),
//        array('HtmlTag', array('tag' => 'div')),
//      ),
//    ));

    $sortMultioptions = array(
      'liked' => 'Most Liked ',
      'popular' => 'Most Popular',
      'recent' => 'Most Recent',
      'downloaded' => 'Most Downloaded',
      'favourite' => 'Most Favourite',
    );

    if( !(Engine_Api::_()->getApi('settings', 'core')->getSetting('sitemusic_enable_download', 1)) ) {
      unset($sortMultioptions['downloaded']);
    }
    $this->addElement('Select', 'sort', array(
      'label' => 'Browse By',
      'multiOptions' => $sortMultioptions,
    ));

    $this->addElement('Hidden', 'user');

    $this->addElement('Button', 'find', array(
      'type' => 'submit',
      'label' => 'Search',
      'ignore' => true,
      'order' => 10000001,
    ));
  }

}
