<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    Songcategory.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Model_Songcategory extends Core_Model_Item_Abstract
{

  protected $_searchTriggers = false;

  public function getTitle($inflect = false)
  {
    if( $inflect ) {
      return ucwords($this->category_name);
    } else {
      return $this->category_name;
    }
  }

  public function getHref($params = array())
  {

    if( $this->cat_dependency ) {
      $type = 'subcategory';
      $params['genre_id'] = $this->songcategory_id;
      $params['genre_name'] = $this->category_name;
    } else {
      $params['genre_id'] = $this->songcategory_id;
      $params['genre_name'] = $this->category_name;
    }
    
    $params = array_merge(array(
      'route' => "sitemusic_general",
      'controller' => "songs",
      'action' => "index",
      'reset' => true,
      ), $params);
    $route = $params['route'];
    $reset = $params['reset'];
    unset($params['route']);
    unset($params['reset']);
    return Zend_Controller_Front::getInstance()->getRouter()
        ->assemble($params, $route, $reset);
  }

  /**
   * Set category icon
   *
   */
  public function setPhoto($photo)
  {

    if( $photo instanceof Zend_Form_Element_File ) {
      $file = $photo->getFileName();
    } else if( is_array($photo) && !empty($photo['tmp_name']) ) {
      $file = $photo['tmp_name'];
    } else if( is_string($photo) && file_exists($photo) ) {
      $file = $photo;
    } else {
      return;
    }

    if( empty($file) )
      return;

    //GET PHOTO DETAILS
    $name = basename($file);
    $path = APPLICATION_PATH . DIRECTORY_SEPARATOR . 'temporary';
    $mainName = $path . '/' . $name;

    //GET VIEWER ID
    $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
    $photo_params = array(
      'parent_id' => $this->songcategory_id,
      'parent_type' => "sitemusic_category",
    );

    //RESIZE IMAGE WORK
    $image = Engine_Image::factory();
    $image->open($file);
    $image->open($file)
      ->resample(0, 0, $image->width, $image->height, $image->width, $image->height)
      ->write($mainName)
      ->destroy();

    try {
      $photoFile = Engine_Api::_()->storage()->create($mainName, $photo_params);
    } catch( Exception $e ) {
      if( $e->getCode() == Storage_Api_Storage::SPACE_LIMIT_REACHED_CODE ) {
        echo $e->getMessage();
        exit();
      }
    }

    return $photoFile;
  }

  public function isRelatedItemExist()
  {
    $table = Engine_Api::_()->getDbtable('playlistSongs', 'sitemusic');
    $select = $table->select();
    $select->from($table->info('name'), array('count(*) as totalSongs'));
    $select->where('genre_id = ?', $this->getIdentity());
    $result = $select->query()->fetch();
    if( $result['totalSongs'] ) {
      return true;
    } else {
      return false;
    }
  }

}
