<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: menus.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Plugin_Menus
{

  public function canCreateAlbums()
  {
    // Must be logged in
    $viewer = Engine_Api::_()->user()->getViewer();
    if( !$viewer || !$viewer->getIdentity() ) {
      return false;
    }

    // Must be able to create playlists
    if( !Engine_Api::_()->authorization()->isAllowed('sitemusic_pl', $viewer, 'create') ) {
      return false;
    }

    return true;
  }

  public function canViewPlaylists()
  {
    $viewer = Engine_Api::_()->user()->getViewer();

    // Must be able to view playlists
    if( !Engine_Api::_()->authorization()->isAllowed('sitemusic_userpl', $viewer, 'view') ) {
      return false;
    }

    return true;
  }

  public function canViewArtists()
  {
    $viewer = Engine_Api::_()->user()->getViewer();

    // Must be able to view playlists
    if( !Engine_Api::_()->authorization()->isAllowed('sitemusic_artist', $viewer, 'view') ) {
      return false;
    }

    return true;
  }

  public function onMenuInitialize_SitemusicMainMymusic($row)
  {
    $viewer = Engine_Api::_()->user()->getViewer();
    if( !$viewer || !$viewer->getIdentity() ) {
      return false;
    }
    if( !Engine_Api::_()->authorization()->isAllowed('sitemusic_pl', $viewer, 'view') ) {
      return false;
    }
    return true;
  }

}
