<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    AdminManageController.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_AdminManageController extends Core_Controller_Action_Admin
{

  public function init()
  {
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sm_admin_main', array(), 'sm_admin_main_manage');
  }

  public function indexAction()
  {
    $this->view->subnavigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sm_admin_manage', array(), 'sm_admin_manage_album');
    $this->view->formFilter = $formFilter = new Sitemusic_Form_Admin_Manage_Filter();
//    $formFilter->removeElement('artist');
    $formFilter->removeElement('item_title');
    $formFilter->removeElement('artist_id');
    $formFilter->removeElement('genreId');
    $params = $this->_getAllParams();

    $values = array();
    $values = array_merge($values, $params);

    // others plugin integration work
    if( isset($params['contentType']) ) {
      $parentType = $params['contentType'];
    }
    $this->view->page = $page = $this->_getParam('page', 1);
    if( $formFilter->isValid($this->_getAllParams()) ) {
      $values = $formFilter->getValues();
      $values['type'] = 'sitemusic_pl';
      $values['admin'] = 1;
      $values = array_merge(array('order' => 'title', 'order_direction' => 'DESC'), $values);
      $this->view->assign($values);
      $this->view->formValues = $values;

      $name = Engine_Db_Table::getDefaultAdapter();

      if( !empty($values['ownerName']) ) {
        $query = $name->select()
          ->from('engine4_users')
          ->where('displayname LIKE ?', "%{$values['ownerName']}%");

        foreach( $query->query()->fetchAll() as $q ) {
          $userId = $q['user_id'];
        }
        if( $userId ) {
          $values['owner_id'] = $userId;
        } else {
          $values['owner_id'] = 0;
        }
      }

      $uri = Zend_Controller_Front::getInstance()->getRequest()->getRequestUri();
      $str = substr($uri, strpos($uri, '?'));
      // for checking search is clicked
      $find = strpos($str, 'execute');
      if( $find ) {
        $this->view->str = $str;
      }
      $table = Engine_Api::_()->getDbTable('playlists', 'sitemusic');
      if( !isset($values['parent_type']) && !empty($parentType) ) {
        $values['parent_type'] = $parentType;
      }
      $paginator = $table->getPaginator($values);
    }
    //Make paginator
    if( !empty($paginator) ) {
      $this->view->paginator = $paginator;
      $this->view->paginator->setItemCountPerPage(20);
      $paginator->setCurrentPageNumber($this->_getParam('page', 1));
    }

    if( $this->getRequest()->isPost() ) {
      $values = $this->getRequest()->getPost();
      foreach( $values as $key => $value ) {
        if( $key == 'delete_' . $value ) {
          $playlist = Engine_Api::_()->getItem('sitemusic_pl', $value);
          if( $playlist ) {
            $playlist->delete();
          }
        }
      }
    }
  }

  public function manageSongAction()
  {
    $this->view->subnavigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sm_admin_manage', array(), 'sm_admin_manage_song');
    $this->view->formFilter = $formFilter = new Sitemusic_Form_Admin_Manage_Filter();
    $formFilter->removeElement('albumType');
    $formFilter->removeElement('parent_type');
    $this->view->page = $page = $this->_getParam('page', 1);
    if( $formFilter->isValid($this->_getAllParams()) ) {
      $values = $formFilter->getValues();
      $values = array_merge(array('order' => 'title', 'order_direction' => 'DESC'), $values);
      $values['artist'] = $values['artist_id'];
      $values['type'] = 'sitemusic_playlist_song';
      $values['notCheckApprove'] = true;
      $this->view->assign($values);
      $this->view->formValues = $values;
      $label = Engine_Api::_()->getDbtable('labelMaps', 'sitemusic');
      $name = Engine_Db_Table::getDefaultAdapter();

      if( !empty($values['ownerName']) ) {
        $query = $name->select()
          ->from('engine4_users')
          ->where('displayname LIKE ?', "%{$values['ownerName']}%");

        foreach( $query->query()->fetchAll() as $q ) {
          $userId = $q['user_id'];
        }
        if( $userId ) {
          $values['owner_id'] = $userId;
        } else {
          $values['owner_id'] = 0;
        }
      }

      $uri = Zend_Controller_Front::getInstance()->getRequest()->getRequestUri();
      $str = substr($uri, strpos($uri, '?'));
      // for checking search is clicked
      $find = strpos($str, 'execute');
      if( $find ) {
        $this->view->str = $str;
      }
      $table = Engine_Api::_()->getDbTable('playlistSongs', 'sitemusic');
      $paginator = $table->getPaginator($values);
    }
    //Make paginator
    if( !empty($paginator) ) {
      $this->view->paginator = $paginator;
      $this->view->paginator->setItemCountPerPage(20);
      $paginator->setCurrentPageNumber($this->_getParam('page', 1));
    }

    if( $this->getRequest()->isPost() ) {
      $values = $this->getRequest()->getPost();
      foreach( $values as $key => $value ) {
        if( $key == 'delete_' . $value ) {
          $playlistSong = Engine_Api::_()->getItem('sitemusic_playlist_song', $value);
          if( $playlistSong ) {
            $playlistSong->delete();
          }
        }
      }
    }
  }

  public function managePlaylistAction()
  {
    $this->view->subnavigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sm_admin_manage', array(), 'sm_admin_manage_playlist');
    $this->view->formFilter = $formFilter = new Sitemusic_Form_Admin_Manage_Filter();
    $isPlaylistEnable = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitemusic.enable.playlist', 1);
    if( !$isPlaylistEnable ) {
      $this->view->playlistNotEnable = true;
    }

    $formFilter->removeElement('item_title');
    $formFilter->removeElement('artist_id');
    $formFilter->removeElement('genreId');
    $formFilter->removeElement('albumType');
    $formFilter->removeElement('parent_type');
    $this->view->page = $page = $this->_getParam('page', 1);
    if( $formFilter->isValid($this->_getAllParams()) ) {
      $values = $formFilter->getValues();
      $values['type'] = 'sitemusic_userpl';
      $values = array_merge(array('order' => 'title', 'order_direction' => 'DESC'), $values);
      $this->view->assign($values);
      $this->view->formValues = $values;

      $label = Engine_Api::_()->getDbtable('labelMaps', 'sitemusic');
      $name = Engine_Db_Table::getDefaultAdapter();

      if( !empty($values['ownerName']) ) {
        $query = $name->select()
          ->from('engine4_users')
          ->where('displayname LIKE ?', "%{$values['ownerName']}%");

        foreach( $query->query()->fetchAll() as $q ) {
          $userId = $q['user_id'];
        }
        if( $userId ) {
          $values['owner_id'] = $userId;
        } else {
          $values['owner_id'] = 0;
        }
      }
      $uri = Zend_Controller_Front::getInstance()->getRequest()->getRequestUri();
      $str = substr($uri, strpos($uri, '?'));
      // for checking search is clicked
      $find = strpos($str, 'execute');
      if( $find ) {
        $this->view->str = $str;
      }
      $table = Engine_Api::_()->getDbTable('userPlaylists', 'sitemusic');
      $paginator = $table->getPaginator($values);
    }
    //Make paginator
    if( !empty($paginator) ) {
      $this->view->paginator = $paginator;
      $paginator->setItemCountPerPage(20);
      $paginator->setCurrentPageNumber($this->_getParam('page', 1));
    }

    if( $this->getRequest()->isPost() ) {
      $values = $this->getRequest()->getPost();
      foreach( $values as $key => $value ) {
        if( $key == 'delete_' . $value ) {
          $userPlaylist = Engine_Api::_()->getItem('sitemusic_userpl', $value);
          if( $userPlaylist ) {
            $userPlaylist->delete();
          }
        }
      }
    }
  }

  public function assignLabelAction()
  {
    // In smoothbox
    $this->_helper->layout->setLayout('admin-simple');
    $id = $this->_getParam('id');
    $type = $this->_getParam('resource_type');

    $url = $this->view->htmlLink(array('route' => 'admin_default', 'module' => 'sitemusic', 'controller' => 'settings', 'action' => 'add-Labelcategory'), 'click here');
    // Generate and assign form
    $form = $this->view->form = new Sitemusic_Form_Admin_Manage_AssignLabel(array('url' => $url));
    $form->setAction($this->view->url(array()));

    // Check post
    if( !$this->getRequest()->isPost() ) {
      $this->renderScript('admin-settings/form.tpl');
      return;
    }
    if( !$form->isValid($this->getRequest()->getPost()) ) {
      $this->renderScript('admin-settings/form.tpl');
      return;
    }
    $params = array();
    $params['resource_id'] = $id;
    $params['resource_type'] = $type;
    // Process
    $values = $form->getValues();
    $viewer = Engine_Api::_()->user()->getViewer();
    $label = Engine_Api::_()->getApi('label', 'sitemusic');

    // Update row

    foreach( $values['label'] as $labelId ) {
      $params['label_id'] = $labelId;
      $label->setLabel($params);
    }


    return $this->_forward('success', 'utility', 'core', array(
        'smoothboxClose' => 10,
        'parentRefresh' => 10,
        'messages' => array('')
    ));
  }

  public function editLabelAction()
  {
    // In smoothbox
    $this->_helper->layout->setLayout('admin-simple');
    $labelInfo = array();
    $labelInfo['resource_type'] = $this->_getParam('resource_type');
    $labelInfo['resource_id'] = $this->_getParam('resource_id');
    $sLabelId = $this->_getParam('label_id');
    $labelIds = Zend_Json::decode($sLabelId);
    $label['label'] = $labelIds;
    $table = Engine_Api::_()->getDbtable('labelMaps', 'sitemusic');
    $form = $this->view->form = new Sitemusic_Form_Admin_Manage_AssignLabel();
    if( isset($labelIds) && !empty($labelIds) ) {
      $form->populate(array('label' => $labelIds));
    }
    $labelApi = Engine_Api::_()->getApi('label', 'sitemusic');
    $form->setAction($this->getFrontController()->getRouter()->assemble(array()));

    if( !$this->getRequest()->isPost() ) {
      // Output
      $this->renderScript('admin-settings/form.tpl');
      return;
    }

    if( !$form->isValid($this->getRequest()->getPost()) ) {
      // Output
      $this->renderScript('admin-settings/form.tpl');
      return;
    }
    // Process
    $values = $form->getValues();
    $labelInfo['label_id'] = $values['label'];

//    $labelIds = array(1,2);
//    print_r($labelIds);
//    echo "<br>";
//    $values['label'] = array(2,3);
//    print_r($values['label']);

    $result = array_intersect($labelIds, $values['label']);
    $diffResult2 = array_diff($values['label'], $result);
//    echo "<br>";
//    echo "*****";
//    echo "<br>";
//    print_r($diffResult2);
//    echo "****";
//    print_r($result);
//    die;

     if( !empty($diffResult2) ) {
        foreach( $diffResult2 as $result2 ) {
          $labelInfo['label_id'] = $result2;
          $labelApi->setLabel($labelInfo);
        }
      }

    if( !empty($result) ) {
      $diffResult1 = array_diff($labelIds, $result);
      if( !empty($diffResult1) ) {
        foreach( $diffResult1 as $result1 ) {
          $table->delete(array('label_id = ?' => $result1, 'resource_type = ?' => $labelInfo['resource_type'], 'resource_id = ?' => $labelInfo['resource_id']));
        }
      }
    } else {
      foreach( $labelIds as $labelId ) {
        $table->delete(array('label_id = ?' => $labelId, 'resource_type = ?' => $labelInfo['resource_type'], 'resource_id = ?' => $labelInfo['resource_id']));
      }
    }

    return $this->_forward('success', 'utility', 'core', array(
        'smoothboxClose' => 10,
        'parentRefresh' => 10,
        'messages' => array('')
    ));
  }

  public function approvedAction()
  {
    $viewer = Engine_Api::_()->user()->getViewer();
    $id = $this->_getParam('id');
    $approve = $this->_getParam('approve');
    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    try {
      $albumItem = Engine_Api::_()->getItem('sitemusic_pl', $id);
      if( empty($albumItem) ) {
        return;
      }
      $owner = $albumItem->getOwner();
      $albumItem->approved = $approve;
      Engine_Api::_()->getDbtable('playlistSongs', 'sitemusic')->update(array('approved' => $approve), array('playlist_id = ?' => $id));
      $albumItem->save();
      if( $approve ) {
        Engine_Api::_()->getDbtable('notifications', 'activity')->addNotification($owner, $viewer, $albumItem, 'approved_sitemusic_playlist');
      } else {
         Engine_Api::_()->getDbtable('notifications', 'activity')->delete(array('type = ?' => 'approved_sitemusic_playlist', 'subject_id = ?' => $viewer->getIdentity(), 'subject_type = ?' => $viewer->getType(), 'object_type = ?' => 'sitemusic_pl', 'object_id = ?' => $albumItem->getIdentity()));
      }
      $db->commit();
    } catch( Exception $e ) {
      $db->rollBack();
      throw $e;
    }
    $this->_redirect('admin/sitemusic/manage');
  }

  public function deleteAction()
  {
    // In smoothbox
    $this->_helper->layout->setLayout('admin-simple');
    $id = $this->_getParam('id');
    $type = $this->_getParam('resource_type');
    $this->view->playlist_id = $id;
    if( $type == 'sitemusic_userpl' ) {
      $entity = 'sitemusic_userpl';
      $fileName = 'delete-playlist.tpl';
    } elseif( $type == 'sitemusic_playlist_song' ) {
      $entity = 'sitemusic_playlist_song';
      $fileName = 'delete-song.tpl';
    } else {
      $entity = 'sitemusic_pl';
      $fileName = 'delete-album.tpl';
    }
    // Check post
    if( $this->getRequest()->isPost() ) {
      $db = Engine_Db_Table::getDefaultAdapter();
      $db->beginTransaction();

      try {
        $table = Engine_Api::_()->getItem($entity, $id);
        // delete the playlist into the database
        $table->delete();
        $db->commit();
      } catch( Exception $e ) {
        $db->rollBack();
        throw $e;
      }

      $this->_forward('success', 'utility', 'core', array(
        'smoothboxClose' => 10,
        'parentRefresh' => 10,
        'messages' => array('')
      ));
    }

    // Output
    $this->renderScript('admin-manage/' . $fileName);
  }

  public function allAssignLabelAction()
  {
    if( !$this->_helper->requireUser()->isValid() ) {
      $this->view->success = false;
      $this->view->error = $this->view->translate('You must be logged in.');
      return;
    }
    $label = Engine_Api::_()->getApi('label', 'sitemusic');
    $params['resource_type'] = $this->_getParam('resource_type');
    $params['resource_id'] = $this->_getParam('resource_id');
    $params['displayAll'] = true;
    $labelInfo = $label->getLabel($params);
    if( !empty($labelInfo) && isset($labelInfo) ) {
      $this->view->labels = $labelInfo;
    } else {
      return;
    }
  }

}
