<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Install.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$allEntities = Engine_Api::_()->getDbtable('entities', 'sitemusic')->getEntity();
$entities = array(
  'Select',
  'entity_type',
  array(
    'label' => 'Select music entity type?',
    'multiOptions' => $allEntities,
    'value' => '0'
  )
);

$genreDisplayOption = array(
  'Radio',
  'genreDisplayOption',
  array(
    'label' => 'Select Genre Diplay Type?',
    'multiOptions' => array('firstLevel' => 'First Level',
      'lastLevel' => 'Last Level'),
    'value' => 'lastLevel',
  )
);

$thumbnailTruncation = array(
  'Text',
  'thumbnailTitleTruncationLimit',
  array(
    'label' => 'Title truncation limit for Thumbnail View.',
    'value' => '50'
  )
);

$songMultiOptions = Engine_Api::_()->getApi('core', 'sitemusic')->getSongOptions();

$songOptions = array(
  'MultiCheckbox',
  'showOptions',
  array(
    'label' => 'Choose the view types for song that you want to be available for the widget.',
    'multiOptions' => $songMultiOptions
  )
);

$defaultLayout = array(
  'MultiCheckbox',
  'songDefaultLayout',
  array(
    'label' => 'Choose the dafault view types for song that you want to be available for the widget.',
    'multiOptions' => array(
      "listZZZview" => "List View",
      "thumbnailZZZview" => "Thumbnail View",
    ),
  )
);

return array(
  array(
    'title' => 'Advanced Music Navigation Tabs',
    'description' => 'Displays the navigation tabs with links of Music Home, Songs, Albums, Playlists etc. This widget should be placed at the top of Advanced Music pages.',
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.browse-menu',
    'requirements' => array(
      'no-subject',
    ),
    'defaultParams' => array(
    ),
    'adminForm' => array(
      'elements' => array(
      ),
    ),
  ),
  array(
    'title' => 'Manage Music Navigation Tabs',
    'description' => 'Displays navigation tabs to manage music entities (music album, song, playlist, artist) on ‘Advanced Music - Manage Music Page’.',
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.mymusic-menu',
    'requirements' => array(
      'no-subject',
    ),
  ),
  array(
    'title' => 'Search Form',
    'description' => 'Displays the form for searching music entities (music album, song, playlist, artist) on the basis of various fields and filters. This widget also enables users to alphabetically filter the music entities on your site by clicking on the desired alphabet.',
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.browse-search',
    'requirements' => array(
      'no-subject',
    ),
  ),
  array(
    'title' => 'Manage Music Search Form',
    'description' => 'Displays the form for searching music entities (music album, song, playlist, artist) on the basis of various fields and filters on manage music page.',
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.mymusic-search',
    'requirements' => array(
      'no-subject',
    ),
  ),
  array(
    'title' => 'Music Album / Song / Playlist / Artist Profile: Breadcrumb',
    'description' => 'Display breadcrumb of the music entities based on their type: music album / song / playlist / artist on their respective profile pages.',
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.browse-breadcrumb',
    'requirements' => array(
      'no-subject',
    ),
  ),
  array(
    'title' => 'Browse Music Albums',
    'description' => 'Displays a list of all the music albums on your site. This widget should be placed on the ‘Advanced Music - Browse Music Albums Page’.',
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.album-browse',
    'requirements' => array(
      'title' => 'ALBUMS',
    ),
    'adminForm' => 'Sitemusic_Form_Admin_Widget_Browse_Album'
  ),
  array(
    'title' => 'Browse Playlists',
    'description' => 'Displays a list of all the song playlists on your site. This widget should be placed on the ‘Advanced Music - Browse Playlists Page’.',
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.playlist-browse',
    'requirements' => array(
      'title' => 'PLAYLISTS',
    ),
    'adminForm' => 'Sitemusic_Form_Admin_Widget_Browse_Playlist'
  ),
  array(
    'title' => 'Browse Songs',
    'description' => 'Displays a list of all the songs on your site. This widget should be placed on the ‘Advanced Music - Browse Songs Page’.',
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.song-browse',
    'requirements' => array(
      'title' => 'SONGS',
    ),
    'adminForm' => 'Sitemusic_Form_Admin_Widget_Browse_Song'
  ),
  array(
    'title' => 'Browse Artists',
    'description' => 'Displays a list of all the artists on your site. This widget should be placed on the ‘Advanced Music - Browse Artists Page’.',
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.artist-browse',
    'requirements' => array(
      'title' => 'ARTISTS',
    ),
    'adminForm' => 'Sitemusic_Form_Admin_Widget_Browse_Artist'
  ),
  array(
    'title' => 'Songs Genre Carousel',
    'description' => 'This widget contains an attractive carousel showcasing various genres of songs.',
    'category' => 'Advanced Music',
    'isPaginated' => true,
    'type' => 'widget',
    'name' => 'sitemusic.genre-categories',
    'requirements' => array(
      'no-subject',
    ),
    'adminForm' => array(
      'elements' => array(
        $genreDisplayOption
      ),
    ),
  ),
  array(
    'title' => 'Music Album Categories Carousel',
    'description' => 'This widget contains an attractive carousel showcasing various categories of music albums.',
    'category' => 'Advanced Music',
    'isPaginated' => true,
    'type' => 'widget',
    'name' => 'sitemusic.album-categories',
    'requirements' => array(
      'no-subject',
    ),
  ),
  array(
    'title' => 'Music Album Categories / Songs Genre: Grid View',
    'description' => 'Displays music album categories and songs genre / sub-genre in grid view.',
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.categories',
    'requirements' => array(
      'no-subject',
    ),
    'adminForm' => 'Sitemusic_Form_Admin_Widget_Category'
  ),
  array(
    'title' => 'Category Based Music Album Carousel',
    'description' => 'This widget contains an carousel showcasing the music albums based on categories present on your site. You can place this widget multiple times on a page with different category chosen for each placement.',
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.categorized-album',
    'requirements' => array(
      'no-subject',
    ),
    'adminForm' => 'Sitemusic_Form_Admin_Widget_CategorizedAlbum'
  ),
  array(
    'title' => 'My Favourites',
    'description' => "Displays a list of music entities (music album, song, playlist, artist) marked as favourite by user.",
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.user-favourite',
    'autoEdit' => true,
    'defaultParams' => array(
    ),
    'requirements' => array(
      'no-subject',
    ),
    'adminForm' => 'Sitemusic_Form_Admin_Widget_UserFavourite'
  ),
  array(
    'title' => 'My Likes',
    'description' => "Displays a list of music entities (music album, song, playlist, artist) liked by user.",
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.user-liked',
    'autoEdit' => true,
    'defaultParams' => array(
    ),
    'requirements' => array(
      'no-subject',
    ),
    'adminForm' => 'Sitemusic_Form_Admin_Widget_UserFavourite'
  ),
  array(
    'title' => 'My Rated',
    'description' => "Displays a list of music entities (music album, artist, music album owner) which a user has rated.",
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.user-rated',
    'autoEdit' => true,
    'defaultParams' => array(
    ),
    'requirements' => array(
      'no-subject',
    ),
    'adminForm' => 'Sitemusic_Form_Admin_Widget_UserFavourite'
  ),
  array(
    'title' => 'My Followed List',
    'description' => 'Displays a list of music entities (music album, artist, music album owner) followed by user.',
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.user-following',
    'autoEdit' => true,
    'defaultParams' => array(),
    'requirements' => array(
      'no-subject',
    ),
    'adminForm' => 'Sitemusic_Form_Admin_Widget_UserFollowing'
  ),
  array(
    'title' => 'My Music Albums',
    'description' => 'Displays a list of user’s music albums.',
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.user-album',
    'autoEdit' => true,
    'defaultParams' => array(),
    'requirements' => array(
      'no-subject',
    ),
    'adminForm' => 'Sitemusic_Form_Admin_Widget_User_Album'
  ),
  array(
    'title' => 'My Playlists',
    'description' => 'Displays a list of user’s playlists.',
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.user-playlist',
    'autoEdit' => true,
    'defaultParams' => array(),
    'requirements' => array(
      'no-subject',
    ),
    'adminForm' => 'Sitemusic_Form_Admin_Widget_User_Playlist'
  ),
  array(
    'title' => 'My Songs',
    'description' => 'Displays a list of songs added by user.',
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.user-song',
    'autoEdit' => true,
    'defaultParams' => array(),
    'requirements' => array(
      'no-subject',
    ),
    'adminForm' => 'Sitemusic_Form_Admin_Widget_User_Song'
  ),
  array(
    'title' => 'My Artists',
    'description' => 'Displays a list of artists added by user while adding songs in music albums.',
    'category' => 'Advanced Music',
    'isPaginated' => true,
    'type' => 'widget',
    'name' => 'sitemusic.user-artist',
    'autoEdit' => true,
    'defaultParams' => array(),
    'requirements' => array(
      'no-subject',
    ),
    'adminForm' => array(
      'elements' => array(
      ),
    ),
  ),
  array(
    'title' => 'Ajax based Widget for Music Album',
    'description' => "Contains multiple Ajax based tabs showing Trending, Latest, Most Liked, Most Popular, Most Favourite, Most Downloaded, Most Followed and Most Rated music albums in a block in separate ajax based tabs. You can configure various settings for this widget from the Edit section of this widget.",
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.album-general',
    'autoEdit' => true,
    'requirements' => array(
      'no-subject',
    ),
    'adminForm' => 'Sitemusic_Form_Admin_Widget_AlbumGeneral'
  ),
  array(
    'title' => 'Ajax based Widget for Song',
    'description' => "Contains multiple Ajax based tabs showing Trending, Latest, Most Liked, Most Popular, Most Favourite, Most Downloaded, Most Followed, Most Rated and Most Played songs in a block in separate ajax based tabs. You can configure various settings for this widget from the Edit section of this widget.",
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.song-general',
    'autoEdit' => true,
    'requirements' => array(
      'no-subject',
    ),
    'adminForm' => 'Sitemusic_Form_Admin_Widget_SongGeneral'
  ),
  array(
    'title' => 'Ajax based Widget for Playlist',
    'description' => "Contains multiple Ajax based tabs showing Trending, Latest, Most Liked, Most Popular, Most Favourite and Most Rated playlists in a block in separate ajax based tabs. You can configure various settings for this widget from the Edit section of this widget.",
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.playlist-general',
    'autoEdit' => true,
    'requirements' => array(
      'no-subject',
    ),
    'adminForm' => 'Sitemusic_Form_Admin_Widget_PlaylistGeneral'
  ),
  array(
    'title' => 'Ajax based Widget for Artist',
    'description' => "Contains multiple Ajax based tabs showing Trending, Latest, Most Liked, Most Popular, Most Favourite, Most Followed, and Most Rated artists in a block in separate ajax based tabs. You can configure various settings for this widget from the Edit section of this widget.",
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.artist-general',
    'autoEdit' => true,
    'requirements' => array(
      'no-subject',
    ),
    'adminForm' => 'Sitemusic_Form_Admin_Widget_ArtistGeneral'
  ),
  array(
    'title' => 'Trending Music Albums / Artists / Playlists / Songs Carousel',
    'description' => "Displays music entities (music album, song, playlist, artist) in an attractive carousel which are trending on your site. You can place this widget multiple times on a page with different music entity chosen for each placement.",
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.trending-carousel',
    'autoEdit' => true,
    'requirements' => array(
      'no-subject',
    ),
    'adminForm' => 'Sitemusic_Form_Admin_Widget_Carousel_Trending'
  ),
  array(
    'title' => 'New Arrived Music Albums / Playlists / Songs Carousel',
    'description' => "Displays music entities (music album, song, playlist) in an attractive carousel which are newly added by the site members. You can place this widget multiple times on a page with different music entity chosen for each placement.",
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.recent-carousel',
    'autoEdit' => true,
    'requirements' => array(
      'no-subject',
    ),
    'adminForm' => 'Sitemusic_Form_Admin_Widget_Carousel_Recent'
  ),
  array(
    'title' => 'Most Popular Music Albums / Artists / Playlists / Songs Carousel',
    'description' => "Displays music entities (music album, song, playlist, artist) in an attractive carousel which are popular on your site. You can place this widget multiple times on a page with different music entity chosen for each placement.",
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.most-popular-carousel',
    'autoEdit' => true,
    'requirements' => array(
      'no-subject',
    ),
    'adminForm' => 'Sitemusic_Form_Admin_Widget_Carousel_Popular'
  ),
  array(
    'title' => 'Most Favourite Music Albums / Artists / Playlists / Songs Carousel',
    'description' => "Displays music entities (music album, song, playlist, artist) in an attractive carousel which are marked as favourite by most of the site members. You can place this widget multiple times on a page with different music entity chosen for each placement.",
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.most-favourite-carousel',
    'autoEdit' => true,
    'requirements' => array(
      'no-subject',
    ),
    'adminForm' => 'Sitemusic_Form_Admin_Widget_Carousel_CarouselWidget'
  ),
  array(
    'title' => 'Music Album Categories Slideshow',
    'description' => "Displays the music album categories with background image in a slideshow.",
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.album-category-slideshow',
    'autoEdit' => true,
    'requirements' => array(
      'no-subject',
    ),
    'adminForm' => 'Sitemusic_Form_Admin_Widget_AlbumCategorySlideshow'
  ),
  array(
    'title' => 'Songs Genre Slideshow',
    'description' => "Displays the songs genre with background image in a slideshow.",
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.genre-slideshow',
    'autoEdit' => true,
    'requirements' => array(
      'no-subject',
    ),
    'adminForm' => 'Sitemusic_Form_Admin_Widget_GenreSlideshow'
  ),
  array(
    'title' => 'Entity (Music Albums, Playlists, Artists) Profile: Info',
    'description' => "This widget forms the Info tab on the profile pages of music albums, playlists and artists to showcase the complete information related to the entity. This widget should be placed in the tabbed block area of the widgetized page.",
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.entity-info',
    'autoEdit' => true,
    'requirements' => array(
      'no-subject',
    ),
    'defaultParams' => array(
      'title' => 'Info',
    ),
    'adminForm' => array(
      'elements' => array(
        $entities
      ),
    ),
  ),

  array(
    'title' => 'Song Profile: Lyrics',
    'description' => "This widget forms the Lyrics tab on the song profile page to display the lyrics of the song. This widget should be placed in the tabbed block area of the widgetized page.",
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.lyrics',
    'autoEdit' => false,
    'requirements' => array(
      'no-subject',
    ),
    'defaultParams' => array(
      'title' => 'Info',
    ),
  ),
  array(
    'title' => 'Entity (Music Albums, Playlists, Artists) Profile: Tracks',
    'description' => "This widget forms the Tracks tab on the profile pages of music albums, playlists and artists to list down the tracks / songs. This widget should be placed in the tabbed block area of the widgetized page.",
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.entity-tracks',
    'autoEdit' => true,
    'requirements' => array(
      'no-subject',
    ),
    'defaultParams' => array(
      'title' => 'Tracks',
    ),
    'adminForm' => 'Sitemusic_Form_Admin_Widget_Tracks',
  ),
  array(
    'title' => 'Advanced Music Cover Photo',
    'description' => "Displays the information related to music entities (music album, song, playlist, artist). You can choose various options from the Edit Settings of this widget.",
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.item-cover-photo',
    'autoEdit' => true,
    'requirements' => array(
      'no-subject',
    ),
    'defaultParams' => array(),
    'adminForm' => 'Sitemusic_Form_Admin_Widget_CoverPhoto',
  ),
  array(
    'title' => 'Recently Played Songs: History',
    'description' => "This widget lists down the history of recently played songs in new view type. [Note: Place this widget in main column of the widgetized page.]",
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.recently-played',
    'autoEdit' => true,
    'requirements' => array(
      'no-subject',
    ),
    'defaultParams' => array(
      'title' => 'Recently Played',
    ),
    'adminForm' => 'Sitemusic_Form_Admin_Widget_RecentlyPlayed',
  ),
  array(
    'title' => 'Recently Played Songs: Thumbnail View',
    'description' => "This widget lists down the recently played songs in thumbnail view. [Note: Place this widget in left / right column of the widgetized page.]",
    'isPaginated' => true,
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.side-recently-played',
    'autoEdit' => true,
    'requirements' => array(
      'no-subject',
    ),
    'defaultParams' => array(
      'title' => 'Recently Played',
    ),
    'adminForm' => array(
      'elements' => array(
        $thumbnailTruncation
      ),
    ),
  ),
  array(
    'title' => 'Special Music Albums',
    'description' => "Displays few music albums on your site as Special Music Albums. You can choose these music albums by editing the settings of this widget. This widget should be placed in the left / right sidebar of the widgetized page.",
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.item-album',
    'autoEdit' => true,
    'requirements' => array(
      'no-subject',
    ),
    'defaultParams' => array(
      'title' => 'Album Of The Day',
    ),
    'adminForm' => 'Sitemusic_Form_Admin_Widget_Item_AlbumOfTheDay',
  ),
  array(
    'title' => 'Special Playlists',
    'description' => "Displays few playlists on your site as Special Playlists. You can choose these playlists by editing the settings of this widget. This widget should be placed in the left / right sidebar of the widgetized page.",
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.item-playlist',
    'autoEdit' => true,
    'requirements' => array(
      'no-subject',
    ),
    'defaultParams' => array(
      'title' => 'Playlist Of The Day',
    ),
    'adminForm' => 'Sitemusic_Form_Admin_Widget_Item_PlaylistOfTheDay',
  ),
  array(
    'title' => 'Special Songs',
    'description' => "Displays few songs on your site as Special Songs. You can choose these songs by editing the settings of this widget. This widget should be placed in the left / right sidebar of the widgetized page.",
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.item-song',
    'autoEdit' => true,
    'requirements' => array(
      'no-subject',
    ),
    'defaultParams' => array(
      'title' => 'Song Of The Day',
    ),
    'adminForm' => 'Sitemusic_Form_Admin_Widget_Item_SongOfTheDay',
  ),
  array(
    'title' => 'Special Artists',
    'description' => "Displays few artists on your site as Special Artists. You can choose these special artists by editing the settings of this widget. This widget should be placed in the left / right sidebar of the widgetized page.",
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.item-artist',
    'autoEdit' => true,
    'requirements' => array(
      'no-subject',
    ),
    'defaultParams' => array(
      'title' => 'Artist Of The Day',
    ),
    'adminForm' => 'Sitemusic_Form_Admin_Widget_Item_ArtistOfTheDay',
  ),
  array(
    'title' => 'Advanced Music Player',
    'description' => "Displays music player to play songs. This widget should be placed in the footer section of the website",
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.music-player',
    'requirements' => array(
      'no-subject',
    ),
    'defaultParams' => array(
    ),
    'adminForm' => 'Sitemusic_Form_Admin_Widget_MusicPlayer',
  ),
  array(
    'title' => 'Related Songs',
    'description' => "Displays songs related to same owner or same category as selected in this widget.[Note: This widget should be placed on Song Profile Page.]",
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.related-song',
    'requirements' => array(
      'no-subject',
    ),
    'defaultParams' => array(
      'title' => 'You may also like',
    ),
    'adminForm' => 'Sitemusic_Form_Admin_Widget_Related_Song',
  ),
  array(
    'title' => 'Related Music Albums',
    'description' => "Displays music albums related to same owner or same category as selected in this widget[Note: This widget should be placed on Music Album Profile Page.].",
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.related-album',
    'requirements' => array(
      'no-subject',
    ),
    'defaultParams' => array(
      'title' => 'You may also like',
    ),
    'adminForm' => 'Sitemusic_Form_Admin_Widget_Related_Album',
  ),
  array(
    'title' => 'Related Playlists',
    'description' => "Displays playlists related to same owner.[Note: This widget should be placed on Playlist Profile Page.]",
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.related-playlist',
    'requirements' => array(
      'no-subject',
    ),
    'defaultParams' => array(
      'title' => 'You may also like',
    ),
    'adminForm' => 'Sitemusic_Form_Admin_Widget_Related_Playlist',
  ),
  array(
    'title' => 'share and report',
    'description' => "share and report.",
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.share-and-report',
    'requirements' => array(
      'no-subject',
    ),
    'defaultParams' => array(
      'title' => '',
    ),
  ),
  array(
    'title' => 'Content Type: Profile Music Albums',
    'description' => "Displays a list of Music Albums in the content currently being viewed. You can manage the content types for which Music Albums owners will be able to manage Music Albums from the Manage Modules section of this plugin. This widget should be placed on content's Profile page.",
    'category' => 'Advanced Music',
    'type' => 'widget',
    'name' => 'sitemusic.contenttype-music',
    'requirements' => array(
      'no-subject',
    ),
    'defaultParams' => array(
      'title' => '',
    ),
    'adminForm' => 'Sitemusic_Form_Admin_Widget_ContentType'
  ),
  )
?>