<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Widget_ArtistBrowseController extends Engine_Content_Widget_Abstract
{

  public function indexAction()
  {
    $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewerId = $viewer->getIdentity();
    $artistTable = Engine_Api::_()->getDbTable('artists', 'sitemusic');
    $limit = $this->_getParam('limit', 5);
    $this->view->formFilter = $formFilter = new Sitemusic_Form_Search();
    if( $formFilter->isValid($this->_getAllParams()) ) {
      $values = $formFilter->getValues();
    } else {
      $values = array();
    }
    $this->view->enableStatsCountOnZero = Engine_Api::_()->sitemusic()->enableStatsCountOnZero();
    $this->view->enableArtistFavourite = $enableArtistFavourite = Engine_Api::_()->sitemusic()->enableArtistFavourite();
    $this->view->enableArtistRating = $enableRating = Engine_Api::_()->sitemusic()->enableArtistRating();
    $this->view->enableArtistShare = $enableShare = Engine_Api::_()->sitemusic()->enableArtistShare();
    $paramValue = Zend_Controller_Front::getInstance()->getRequest()->getParams();
    $this->view->value = $paramValue;
    if( !isset($paramValue['page']) ) {
      $page = 1;
    } else {
      $page = $paramValue['page'];
    }

    if( isset($paramValue['search']) ) {
      $values['search'] = $paramValue['search'];
    }
    if( isset($paramValue['alphabet']) ) {
      $values['alphabet'] = $paramValue['alphabet'];
      $values['search'] = null;
    }
    $showOptions = $params['showOptions'] = $this->_getParam('showOptions');
    $values['labelType'] = $this->_getParam('label_category');
    $values['type'] = 'sitemusic_artist';
    $this->view->artistShowOptions = $showOptions;
    $this->view->gridViewWidth = $this->_getParam('gridViewWidth', '180');
    $this->view->gridViewHeight = $this->_getParam('gridViewHeight', '290');
    $artistLayoutViews = $params['artist_layout_views'] = $this->_getParam('artist_layout_views', array("grid_view"));
    foreach( $artistLayoutViews as $key => $value )
      $artistLayoutViews[$key] = str_replace("ZZZ", "_", $value);
    sort($artistLayoutViews);
    $this->view->artist_layout_views = $artistLayoutViews;

    $this->view->artistDefaultLayout = $artistDefaultLayout = str_replace("ZZZ", "_", $this->_getParam('artistDefaultLayout', 'grid_view'));
    if( count($artistLayoutViews) == 1 ) {
      $this->view->artistDefaultLayout = $artistDefaultLayout = $artistLayoutViews[0];
    }
    $this->view->thumbnail_title_truncation = $this->_getParam('thumbnailTitleTruncationLimit', 20);
    $this->view->grid_title_truncation = $this->_getParam('gridTitleTruncationLimit', 20);
    $values['sort'] = $this->_getParam('default_sort', 'creationDate');
    $this->view->message = 'There is no artist created yet.';
// Show

    $viewer = Engine_Api::_()->user()->getViewer();
    if( @$values['show'] == 2 && $viewer->getIdentity() ) {
// Get an array of friend ids
      $values['users'] = $viewer->membership()->getMembershipsOfIds();
    } elseif( $values['show'] == 3 ) {
      $values['only_my'] = $viewer->getIdentity();
    }
    unset($values['show']);

    $element = $this->getElement();
    $widgetTitle = $this->view->heading = $element->getTitle();
    if( !empty($widgetTitle) ) {
      $element->setTitle("");
    } else {
      $this->view->heading = "";
    }
// Get paginator
    $this->view->paginator = $paginator = $artistTable->getPaginator($values);
    $this->view->totalCount = $paginator->getTotalItemCount();
    $paginator->setItemCountPerPage($limit);

    $this->view->paginator = $paginator->setCurrentPageNumber($page);
  }

}
