<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteevent
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2014-01-02 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Widget_ArtistGeneralController extends Engine_Content_Widget_Abstract
{

  public function indexAction()
  {
    $enableArtist = Engine_Api::_()->sitemusic()->isArtistEnabled();
    if( !$enableArtist ) {
      return $this->setNoRender();
    }
    $params['limit'] = $limit = $this->_getParam('limit', 5);
    $this->view->is_ajax_load = true;
    $this->view->is_ajax = $isAjax = $this->_getParam('is_ajax', 0);
    $this->view->params = $params = $this->_getAllParams();
    $this->view->showViewMore = $this->_getParam('showViewMore', 1);
    if( $isAjax ) {
      $element = $this->getElement();
      $widgetTitle = $element->getTitle();
      $element->setTitle('');
    }
    if( $this->_getParam('randomNum') ) {
      $this->view->randomNumber = $this->_getParam('randomNum');
    } else {
      $this->view->randomNumber = $params['randomNum'] = rand();
    }
    $this->view->thumbnail_title_truncation = $this->_getParam('thumbnailTitleTruncationLimit', 20);
    $this->view->grid_title_truncation = $this->_getParam('gridTitleTruncationLimit', 20);
    $this->view->enableStatsCountOnZero = Engine_Api::_()->sitemusic()->enableStatsCountOnZero();
    $this->view->enableArtistFavourite = $enableArtistFavourite = Engine_Api::_()->sitemusic()->enableArtistFavourite();
    $this->view->enableArtistRating = $enableRating = Engine_Api::_()->sitemusic()->enableArtistRating();
    $this->view->enableArtistShare = $enableShare = Engine_Api::_()->sitemusic()->enableArtistShare();
    if( empty($isAjax) ) {
      $showTabArray = $params['ajaxTabs'] = $this->_getParam('ajaxTabs', array("Most Favourite", "Trending", "Most_Popular", "Most_Liked"));
      foreach( $showTabArray as $key => $value )
        $showTabArray[$key] = str_replace("ZZZ", "_", $value);
      $this->view->tabs = $showTabArray = $this->setTabsOrder($showTabArray);
      $this->view->tabCount = count($showTabArray);
      if( empty($this->view->tabCount) ) {
        return $this->setNoRender();
      }
    }
    $showOptions = $params['showOptions'] = $this->_getParam('showOptions');
    $values['labelType'] = $this->_getParam('label_category');
    $values['type'] = 'sitemusic_artist';
    $this->view->artistShowOptions = $showOptions;
    $this->view->gridViewWidth = $this->_getParam('gridViewWidth', '180');
    $this->view->gridViewHeight = $this->_getParam('gridViewHeight', '290');
    $artistLayoutViews = $params['artist_layout_views'] = $this->_getParam('artist_layout_views', array('grid_view'));
    foreach( $artistLayoutViews as $key => $value )
      $artistLayoutViews[$key] = str_replace("ZZZ", "_", $value);
    sort($artistLayoutViews);
    $this->view->artist_layout_views = $artistLayoutViews;

    $paramsContentType = $this->_getParam('content_type', null);
    $this->view->content_type = $paramsContentType = $paramsContentType ? $paramsContentType : $showTabArray[0];

    $info = array();
    $info['content_type'] = $paramsContentType;
    $info['trending_type'] = $Trendingtype = $this->_getParam('trendingType', 'like');
    $info['trending_sort'] = $creationDate = $this->_getParam('trendingSort');
    $info['popular_type'] = $popularSort = $this->_getParam('popularType', 'like_count');

    if( $paramsContentType == 'Trending' ) {
      $this->view->message = 'There is no trending artist yet';
    } elseif( $paramsContentType == 'Most_Popular' ) {
      $this->view->message = 'There is no most-popular artist yet';
    } elseif( $paramsContentType == 'Most_Liked' ) {
      $this->view->message = 'There is no most-liked artist yet';
    } elseif( $paramsContentType == 'Most_Favourite' ) {
      $this->view->message = 'There is no most-favourite artist yet';
    } elseif( $paramsContentType == 'Most_Followed' ) {
      $this->view->message = 'There is no most-followed artist yet';
    } elseif( $paramsContentType == 'Most_Rated' ) {
      $this->view->message = 'There is no most-rated artist yet';
    }

    $this->view->artistDefaultLayout = $artistDefaultLayout = str_replace("ZZZ", "_", $this->_getParam('artistDefaultLayout', 'grid_view'));
    // in case default layout is other from available layouts
    if( count($artistLayoutViews) == 1 ) {
      $this->view->artistDefaultLayout = $artistDefaultLayout = $artistLayoutViews[0];
    }
    $this->view->viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewerId = Engine_Api::_()->user()->getViewer()->getIdentity();
    $this->view->gridViewWidth = $this->_getParam('gridViewWidth', '180');
    $this->view->gridViewHeight = $this->_getParam('gridViewHeight', '290');
    $this->view->cardViewWidth = $this->_getParam('cardViewWidth', '371');
    $this->view->cardViewHeight = $this->_getParam('cardViewHeight', '402');
    $this->view->showViewMore = $this->_getParam('showViewMore', 1);
    $this->view->params = $params;
    $paginator = Engine_Api::_()->getApi('generalWidget', 'sitemusic')->getGeneralPaginator('Artist', $info);
    $this->view->totalCount = $paginator->getTotalItemCount();
    $paginator->setItemCountPerPage($limit);
    if( !isset($params['page']) ) {
      $params['page'] = 1;
    }
    $this->view->paginator = $paginator->setCurrentPageNumber($params['page']);
    $this->view->paginator = $paginator;
    if( $paginator->getTotalItemCount() <= 0 && $artistDefaultLayout == 'thumbnail_view' ) {
      return $this->setNoRender();
    }
  }

  public function setTabsOrder($tabs)
  {

    $tabsOrder['Trending'] = $this->_getParam('Trending', 1);
    $tabsOrder['Most_Popular'] = $this->_getParam('MostZZZPopular', 2);
    $tabsOrder['Most_Liked'] = $this->_getParam('MostZZZLiked', 3);
    $tabsOrder['Most_Favourite'] = $this->_getParam('MostZZZFavourite', 4);
    $tabsOrder['Most_Downloaded'] = $this->_getParam('MostZZZDownloaded', 5);
    $tabsOrder['Most_Followed'] = $this->_getParam('MostZZZFollowed', 6);
    $tempTabs = array();
    foreach( $tabs as $tab ) {
      $order = $tabsOrder[$tab];
      if( isset($tempTabs[$order]) )
        $order++;
      $tempTabs[$order] = $tab;
    }
    ksort($tempTabs);
    $orderTabs = array();
    $i = 0;
    foreach( $tempTabs as $tab )
      $orderTabs[$i++] = $tab;
    return $orderTabs;
  }

}
