<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Widget_CategorizedAlbumController extends Engine_Content_Widget_Abstract
{

  public function indexAction()
  {
    $playlistTable = Engine_Api::_()->getDbTable('playlists', 'sitemusic');
    $pName = $playlistTable->info('name');
    $playlistSongTable = Engine_Api::_()->getDbTable('playlistSongs', 'sitemusic');
    $psName = $playlistSongTable->info('name');
    $select = $playlistTable->select()->from($pName);

    $values['albumcategory_id'] = $categoryId = $this->_getParam('albumCategoryId');
    $values['labelType'] = $this->_getParam('label_category');

    if( $categoryId ) {
      $select->where('category_id = ?', $categoryId);
    } else {
      $select->order('RAND()');
    }
    $select->setIntegrityCheck(false);
    $select->join($psName, "$pName.playlist_id = $psName.playlist_id", '');
    $select->where($pName . '.approved = ?', 1);

    if( Engine_Api::_()->getApi('core', 'sitemusic')->enableContentBasedPrivacy() ) {
      $param = array('search' => 1);
      //privacy related work
     $select = Engine_Api::_()->getApi('generalWidget', 'sitemusic')->getItemsSelect($select, $param, $pName);
    }

    $select->where($psName . '.status = ?', 1);
    $select->distinct(true);

    $this->view->enableAlbumFavourite = $enableAlbumFavourite = Engine_Api::_()->sitemusic()->enableAlbumFavourite();
    $this->view->isAlbumShareEnable = $enableAlbumShare = Engine_Api::_()->sitemusic()->enableAlbumShare();
    $this->view->isRatingEnable = $enableAlbumRating = Engine_Api::_()->sitemusic()->enableAlbumRating();

    $this->view->paginator = $paginator = Zend_Paginator::factory($select);
    // Set item count per page and current page number
    //  $paginator->setItemCountPerPage($this->_getParam('limit', 10));
    $paginator->setCurrentPageNumber($this->_getParam('page', 1));
    $this->view->enableStatsCountOnZero = Engine_Api::_()->sitemusic()->enableStatsCountOnZero();
    $showOptions = $this->_getParam('showOptions');
    $this->view->albumShowOptions = array('All');
    $this->view->album_layout_views = $albumLayoutViews = array('grid_view');
    $this->view->albumDefaultLayout = $albumDefaultLayout = str_replace("ZZZ", "_", $this->_getParam('albumDefaultLayout', 'grid_view'));
    $this->view->data = $paginator;
    $this->view->params = array();
    // Hide if nothing to show
    if( $paginator->getTotalItemCount() <= 0 ) {
      return $this->setNoRender();
    }
  }

}
