<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecrowdfunding
 * @copyright  Copyright 2017-2021 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Widget_ContenttypeMusicController extends Engine_Content_Widget_Abstract
{

  protected $_childCount;

  public function indexAction()
  {
    //DONT RENDER IF SUBJECT IS NOT SET
    if( !Engine_Api::_()->core()->hasSubject() ) {
      return $this->setNoRender();
    }

    //GET VIEWER DETAILS
    $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewer->getIdentity();
    $params = $this->_getAllParams();
    //GET PROJECT SUBJECT
    $subject = Engine_Api::_()->core()->getSubject();
    $this->view->moduleName = $moduleName = strtolower($subject->getModuleName());
    $this->view->getShortType = $getShortType = ucfirst($subject->getShortType());

    if( !(Engine_Api::_()->getDbtable('modules', 'sitemusic')->getIntegratedModules(array('enabled' => 1, 'item_type' => $subject->getType(), 'resource_module' => strtolower($subject->getModuleName()), 'checked' => 'enabled'))) )
      return $this->setNoRender();

    $this->view->canCreate = $canCreate = Engine_Api::_()->authorization()->isAllowed('sitemusic_pl', null, 'create');

//    $sitecrowdfundingProjectContentType = Zend_Registry::isRegistered('sitecrowdfundingProjectContentType') ? Zend_Registry::get('sitecrowdfundingProjectContentType') : null;
    $this->view->parent_type = $params['parent_type'] = $subject->getType();
    $this->view->parent_id = $params['parent_id'] = $subject->getIdentity();
    // for edit and delete
    $this->view->mymusic = true;
    $this->view->enableStatsCountOnZero = Engine_Api::_()->sitemusic()->enableStatsCountOnZero();

    $this->view->gridViewWidth = $this->_getParam('gridViewWidth');
    $this->view->gridViewHeight = $this->_getParam('gridViewHeight');
    $this->view->grid_title_truncation = $this->_getParam('gridTitleTruncationLimit', 25);

    if( $moduleName == 'sitepage' || $moduleName == 'sitebusiness' || $moduleName == 'sitegroup' ) {
      $this->view->canEdit = Engine_Api::_()->sitemusic()->isEditPrivacy($subject->getType(), $subject->getIdentity(), $subject);
      $this->view->canDelete = Engine_Api::_()->sitemusic()->canDeletePrivacy($subject->getType(), $subject->getIdentity(), $subject);

      $this->view->user_layout = $layout = Engine_Api::_()->getApi('settings', 'core')->getSetting($moduleName . '.layoutcreate', 0);
      $isModuleOwnerAllow = 'is' . $getShortType . 'OwnerAllow';
      try {
        $this->_childCount = $this->view->projectCount = Engine_Api::_()->$moduleName()->getTotalCount($subject->getIdentity(), 'sitemusic', 'playlists');
      } catch( Exception $e ) {
        echo $e->getMessage();
        die;
      }
      //START PACKAGE WORK
      if( Engine_Api::_()->$moduleName()->hasPackageEnable() ) {

        if( !Engine_Api::_()->$moduleName()->allowPackageContent($subject->package_id, "modules", 'sitemusic') ) {
          return $this->setNoRender();
        }
      } else {
        //permission to create project in above modules(Not Available Yet )
        $isOwnerAllow = Engine_Api::_()->$moduleName()->$isModuleOwnerAllow($subject, 'samcreate');

        if( empty($isOwnerAllow) ) {
          return $this->setNoRender();
        }
      }
      //END PACKAGE WORK

      $this->view->canCreate = $canCreate = Engine_Api::_()->$moduleName()->isManageAdmin($subject, 'samcreate');

      //START MANAGE-ADMIN CHECK
      $isManageAdmin = Engine_Api::_()->$moduleName()->isManageAdmin($subject, 'view');
      if( empty($isManageAdmin) ) {
        return $this->setNoRender();
      }

      $isManageAdmin = Engine_Api::_()->$moduleName()->isManageAdmin($subject, 'edit');

      if( empty($isManageAdmin) ) {
        $this->view->canEdit = $canEdit = 0;
      } else {
        $this->view->canEdit = $canEdit = 1;
      }

      if( empty($canCreate) && empty($this->view->projectCount) && empty($canEdit) && !(Engine_Api::_()->$moduleName()->showTabsWithoutContent()) ) {
        return $this->setNoRender();
      }
    }

    if( isset($params['page']) && !empty($params['page']) )
      $this->view->page = $page = $params['page'];
    else
      $this->view->page = $page = 1;

    $this->view->widgetPath = 'widget/index/mod/sitecrowdfunding/name/contenttype-projects';
    $params['id'] = $this->_getParam('id', null);
    $this->view->gridViewWidth = $params['gridViewWidth'] = $this->_getParam('projectWidth', 150);
    $this->view->gridViewHeight = $params['gridViewHeight'] = $this->_getParam('projectHeight', 150);
//    $this->view->projectOption = $params['projectOption'] = $this->_getParam('projectOption');
//    if( empty($this->view->projectOption) || !is_array($this->view->projectOption) ) {
//      $this->view->projectOption = $params['projectOption'] = array();
//    }
    $this->view->albumShowOptions = array('All');
    $albumLayoutViews = array("grid_view");
    $this->view->album_layout_views = $albumLayoutViews;
    $this->view->albumDefaultLayout = $albumDefaultLayout = "grid_view";
    $this->view->showContent = $params['show_content'] = $this->_getParam('show_content', 2);
    $this->view->itemCountPerPage = $params['itemCountPerPage'] = $this->_getParam('itemCountPerPage', 10);
    $this->view->is_ajax = $params['is_ajax'] = $this->_getParam('is_ajax', false);
//    if( empty($this->view->projectOption) || !is_array($this->view->projectOption) ) {
//      $this->view->projectOption = $params['projectOption'] = array();
//    }
    $params['title'] = '';
    $this->view->params = $params;
    $paginator = $this->view->paginator = Engine_Api::_()->getDbTable('playlists', 'sitemusic')->getPaginator($params);
    $this->view->totalCount = $paginator->getTotalItemCount();
    $paginator->setItemCountPerPage($params['itemCountPerPage']);
    $paginator->setCurrentPageNumber($page);

    $this->view->list_title_truncation = $this->_getParam('listTitleTruncationLimit', 25);
    $this->view->grid_title_truncation = $this->_getParam('gridTitleTruncationLimit', 25);
    $this->view->card_title_truncation = $this->_getParam('cardTitleTruncationLimit', 25);
    $this->view->thumbnail_title_truncation = $this->_getParam('thumbnailTitleTruncationLimit', 20);

    $this->view->descriptionTruncation = $params['descriptionTruncation'] = $this->_getParam('descriptionTruncation', 50);
    //ADD COUNT TO TITLE
    if( $this->view->totalCount > 0 ) {
      $this->_childCount = $this->view->totalCount;
    }
  }

  public function getChildCount()
  {
    return $this->_childCount;
  }

}
