<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemember
 * @copyright  Copyright 2014-2015 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2014-07-20 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Widget_ItemAlbumController extends Engine_Content_Widget_Abstract
{

  public function indexAction()
  {
    $albumIdsAsString = $this->_getParam('itemIds');

    if( is_string($albumIdsAsString) ) {
      $albumIds = explode(' ', $albumIdsAsString);
    }
    if( !isset($albumIds) && empty($albumIds) ) {
      return $this->setNoRender();
    }
    $values['albumIds'] = $albumIds;
    $playlistTable = Engine_Api::_()->getDbTable('playlists', 'sitemusic');
    $this->view->paginator = $paginator = $playlistTable->getPaginator($values);
    $this->view->enableStatsCountOnZero = Engine_Api::_()->sitemusic()->enableStatsCountOnZero();
    //for display all stats
    $this->view->albumShowOptions = array('All');

    $this->view->enableFavourite = $enableFavourite = Engine_Api::_()->sitemusic()->enableFavourite();
    $this->view->isAlbumShareEnable = $enableAlbumShare = Engine_Api::_()->sitemusic()->enableAlbumShare();

    $this->view->title_truncation = $this->_getParam('titleTruncationLimit', 20);
    $startTime = $this->_getParam('starttime');
    $endTime = $this->_getParam('endtime');
    $currentTime = date('Y-m-d H:i:s');

    if( $startTime!= 0 && $endTime!=0 ) {
      if( ($currentTime < $startTime) || ( $currentTime > $endTime) ) {
        return $this->setNoRender();
      }
    }

    if( $paginator->getTotalItemCount() <= 0 ) {
      return $this->setNoRender();
    }
  }

}
