<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemember
 * @copyright  Copyright 2014-2015 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2014-07-20 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Widget_ItemArtistController extends Engine_Content_Widget_Abstract
{

  public function indexAction()
  {
    $artistIdsAsString = $this->_getParam('itemIds');

    if( is_string($artistIdsAsString) ) {
      $artistIds = explode(' ', $artistIdsAsString);
    }

    if( !isset($artistIds) && empty($artistIds) ) {
      return $this->setNoRender();
    }
    $values['artistIds'] = $artistIds;

    $artistTable = Engine_Api::_()->getDbTable('artists', 'sitemusic');

    $enableArtist = Engine_Api::_()->sitemusic()->isArtistEnabled();

    if( !$enableArtist ) {
      return $this->setNoRender();
    }

    $this->view->viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewerId = Engine_Api::_()->user()->getViewer()->getIdentity();
    $this->view->paginator = $paginator = $artistTable->getPaginator($values);
    $this->view->enableStatsCountOnZero = Engine_Api::_()->sitemusic()->enableStatsCountOnZero();
    $this->view->enableArtistFavourite = $enableArtistFavourite = Engine_Api::_()->sitemusic()->enableArtistFavourite();
    $this->view->enableArtistRating = $enableRating = Engine_Api::_()->sitemusic()->enableArtistRating();
    $this->view->enableArtistShare = $enableShare = Engine_Api::_()->sitemusic()->enableArtistShare();

    //for display all stats
    $this->view->artistShowOptions = array('All');

    $this->view->title_truncation = $this->_getParam('titleTruncationLimit', 20);
    $startTime = $this->_getParam('starttime');
    $endTime = $this->_getParam('endtime');
    $currentTime = date('Y-m-d H:i:s');

    if( $startTime != 0 && $endTime != 0 ) {
      if( ($currentTime < $startTime) || ( $currentTime > $endTime) ) {
        return $this->setNoRender();
      }
    }

    if( $paginator->getTotalItemCount() <= 0 ) {
      return $this->setNoRender();
    }
  }

}
