<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Widget_MostFavouriteCarouselController extends Engine_Content_Widget_Abstract
{

  public function indexAction()
  {
    $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewerId = Engine_Api::_()->user()->getViewer()->getIdentity();
    $params['limit'] = $limit = $this->_getParam('limit', 5);
    $this->view->is_ajax_load = true;
    $this->view->is_ajax = $isAjax = $this->_getParam('is_ajax', 0);
    $this->view->params = $params = $this->_getAllParams();
    $this->view->showViewMore = $this->_getParam('showViewMore', 1);
    if( $isAjax ) {
      $element = $this->getElement();
      $widgetTitle = $element->getTitle();
      $element->setTitle('');
    }
    $showTabArray = $params['ajaxTabs'] = $this->_getParam('ajaxTabs', array("Album", "Playlist", "Song", "Artist"));
    foreach( $showTabArray as $key => $value )
      $showTabArray[$key] = ucfirst($value);
    $enablePlaylist = Engine_Api::_()->sitemusic()->isPlaylistEnabled();
    if( !$enablePlaylist ) {
      $keyIndex = array_search('Playlist', $showTabArray);
      if( $keyIndex !== false ) {
        $this->checkShowTab($showTabArray);
        unset($showTabArray[$keyIndex]);
      }
    }

    $enableArtist = Engine_Api::_()->sitemusic()->isArtistEnabled();
    if( !$enableArtist ) {
      $keyIndex = array_search('Artist', $showTabArray);

      if( $keyIndex !== false ) {
        $this->checkShowTab($showTabArray);
        unset($showTabArray[$keyIndex]);
      }
    }
    if( $viewerId ) {
      $this->view->enableArtist = $enableArtist = Engine_Api::_()->sitemusic()->isArtistEnabled();
      $this->view->enablePlaylist = $enablePlaylist = Engine_Api::_()->sitemusic()->isPlaylistEnabled();
    }

    $this->view->enableAlbumFavourite = $enableAlbumFavourite = Engine_Api::_()->sitemusic()->enableAlbumFavourite();
    $this->view->isRatingEnable = $enableAlbumRating = Engine_Api::_()->sitemusic()->enableAlbumRating();
    $this->view->isAlbumShareEnable = $enableAlbumShare = Engine_Api::_()->sitemusic()->enableAlbumShare();

    $this->view->enableSongFavourite = $enableFavourite = Engine_Api::_()->sitemusic()->enableSongFavourite();
    $this->view->enableSongRating = $enableRating = Engine_Api::_()->sitemusic()->enableSongRating();
    $this->view->enableSongShare = $enableShare = Engine_Api::_()->sitemusic()->enableSongShare();

    $this->view->enablePlaylistFavourite = $enablePlaylistFavourite = Engine_Api::_()->sitemusic()->enablePlaylistFavourite();
    $this->view->enablePlaylistRating = $enableRating = Engine_Api::_()->sitemusic()->enablePlaylistRating();
    $this->view->enablePlaylistShare = $enableShare = Engine_Api::_()->sitemusic()->enablePlaylistShare();

    $this->view->enableArtistFavourite = $enableArtistFavourite = Engine_Api::_()->sitemusic()->enableArtistFavourite();
    $this->view->enableArtistRating = $enableRating = Engine_Api::_()->sitemusic()->enableArtistRating();
    $this->view->enableArtistShare = $enableShare = Engine_Api::_()->sitemusic()->enableArtistShare();

    $this->view->tabs = $showTabArray = $this->setTabsOrder($showTabArray);
    $this->view->tabCount = count($showTabArray);
    $songShowOptions = $this->_getParam('songShowOptions', array('All'));
    $this->view->songShowOptions = $songShowOptions;
    $albumShowOptions = $this->_getParam('albumShowOptions', array('All'));
    $this->view->albumShowOptions = $albumShowOptions;
    $artistShowOptions = $this->_getParam('artistShowOptions', array('All'));
    $this->view->artistShowOptions = $artistShowOptions;
    $playlistShowOptions = $this->_getParam('playlistShowOptions', array('All'));
    $this->view->playlistShowOptions = $playlistShowOptions;

    $this->view->artist_layout_views = $artistLayoutViews = array('grid_view');
    $this->view->artistDefaultLayout = $artistDefaultLayout = str_replace("ZZZ", "_", $this->_getParam('artistDefaultLayout', 'grid_view'));

    $paramsEntityType = $this->_getParam('entity_type', null);
    $this->view->entity_type = $paramsEntityType = $paramsEntityType ? $paramsEntityType : ( isset($showTabArray[0]) ? $showTabArray[0] : '');
    $this->view->params = $params;
    if( empty($this->view->tabCount) ) {
      return $this->setNoRender();
    }
    $this->view->gridViewHeight = $this->_getParam('carouselHeight', 200);
    $this->view->autoPlay = $this->_getParam('autoPlay', 0);
    $this->view->seeAll = $this->_getParam('seeAll', 1);
    $this->view->slideItemlimitM = $this->_getParam('slideItemlimitM', 2);
    $this->view->slideItemlimitT = $this->_getParam('slideItemlimitT', 2);
    $this->view->slideItemlimit = $this->_getParam('slideItemlimit', 3);
    $this->view->grid_title_truncation = $this->_getParam('gridTitleTruncationLimit', 20);
    $info['labelType'] = $this->_getParam('label_category');
    $info['content_type'] = 'Most_Favourite';
    $paginator = Engine_Api::_()->getApi('generalWidget', 'sitemusic')->getGeneralPaginator($paramsEntityType, $info);
    $this->view->album_layout_views = array('grid_view');
    $this->view->albumDefaultLayout = 'grid_view';
    $this->view->song_layout_views = array('grid_view');
    $this->view->songDefaultLayout = 'grid_view';
    $this->view->playlist_layout_views = array('grid_view');
    $this->view->playlistDefaultLayout = 'grid_view';

    $this->view->totalCount = $paginator->getTotalItemCount();
    $paginator->setItemCountPerPage($limit);
    if( !isset($params['page']) ) {
      $params['page'] = 1;
    }
    $paginator->setCurrentPageNumber($params['page']);
    $this->view->paginator = $paginator;
    //  }
  }

  public function setTabsOrder($tabs)
  {
    $tabsOrder['Album'] = $this->_getParam('Album', 1);
    $tabsOrder['Playlist'] = $this->_getParam('Playlist', 2);
    $tabsOrder['Song'] = $this->_getParam('Song', 3);
    $tabsOrder['Artist'] = $this->_getParam('Artist', 4);
    $tempTabs = array();
    foreach( $tabs as $tab ) {
      $order = $tabsOrder[$tab];
      if( isset($tempTabs[$order]) )
        $order++;
      $tempTabs[$order] = $tab;
    }
    //die;
    ksort($tempTabs);
    $orderTabs = array();
    $i = 0;
    foreach( $tempTabs as $tab )
      $orderTabs[$i++] = $tab;
    return $orderTabs;
  }

  public function checkShowTab($tabs)
  {
    // in case when on tab exist and that are disable;
    if( count($tabs) == 1 ) {
      return $this->setNoRender();
    }
  }

}
