<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteevent
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2014-01-02 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Widget_PlaylistGeneralController extends Engine_Content_Widget_Abstract
{

  public function indexAction()
  {
    $params['limit'] = $limit = $this->_getParam('limit', 5);
    $this->view->is_ajax_load = true;
    $this->view->is_ajax = $isAjax = $this->_getParam('is_ajax', 0);
    $this->view->params = $params = $this->_getAllParams();
    $this->view->showViewMore = $this->_getParam('showViewMore', 1);
    $this->view->enableStatsCountOnZero = Engine_Api::_()->sitemusic()->enableStatsCountOnZero();
    if( $isAjax ) {
      $element = $this->getElement();
      $widgetTitle = $element->getTitle();
      $element->setTitle('');
    }
    if( empty($isAjax) ) {
      $showTabArray = $params['ajaxTabs'] = $this->_getParam('ajaxTabs', array("Trending", "Latest", "Most_Popular", "Most_Liked"));
      foreach( $showTabArray as $key => $value )
        $showTabArray[$key] = str_replace("ZZZ", "_", $value);
      $this->view->tabs = $showTabArray = $this->setTabsOrder($showTabArray);
      $this->view->tabCount = count($showTabArray);
      if( empty($this->view->tabCount) ) {
        return $this->setNoRender();
      }
    }
    if( $this->_getParam('randomNum') ) {
      $this->view->randomNumber = $this->_getParam('randomNum');
    } else {
      $this->view->randomNumber = $params['randomNum'] = rand();
    }
    $this->view->list_title_truncation = $this->_getParam('listTitleTruncationLimit', 25);
    $this->view->grid_title_truncation = $this->_getParam('gridTitleTruncationLimit', 25);
    $this->view->card_title_truncation = $this->_getParam('cardTitleTruncationLimit', 25);
    $this->view->thumbnail_title_truncation = $this->_getParam('thumbnailTitleTruncationLimit', 20);

    $this->view->enablePlaylistFavourite = $enablePlaylistFavourite = Engine_Api::_()->sitemusic()->enablePlaylistFavourite();
    $this->view->enablePlaylistRating = $enableRating = Engine_Api::_()->sitemusic()->enablePlaylistRating();
        $this->view->enablePlaylistShare  = $enableShare = Engine_Api::_()->sitemusic()->enablePlaylistShare();
    $showOptions = $params['showOptions'] = $this->_getParam('showOptions');
    $showViewOptions = $params['showOptions'] = $this->_getParam('showSongOptions');
    if( isset($showViewOptions) && !empty($showViewOptions) ) {
      $options = array_merge($showViewOptions, $showOptions);
    } else {
      $options = $showOptions;
    }
    $values['labelType'] = $this->_getParam('label_category');
    $values['type'] = 'sitemusic_userpl';
    $this->view->playlistShowOptions = $options;
    $playlistLayoutViews = $params['playlist_layout_views'] = $this->_getParam('playlist_layout_views', array("list_view", "grid_view"));
    foreach( $playlistLayoutViews as $key => $value )
      $playlistLayoutViews[$key] = str_replace("ZZZ", "_", $value);
    sort($playlistLayoutViews);
    $this->view->playlist_layout_views = $playlistLayoutViews;

    $paramsContentType = $this->_getParam('content_type', null);
    $this->view->content_type = $paramsContentType = $paramsContentType ? $paramsContentType : $showTabArray[0];

    $info = array();
    $info['content_type'] = $paramsContentType;
    $info['trending_type'] = $Trendingtype = $this->_getParam('trendingType', 'like');
    $info['trending_sort'] = $creationDate = $this->_getParam('trendingSort');
    $info['latest_sort'] = $latestSort = $this->_getParam('latestSort', 'creation_date');
    $info['popular_type'] = $popularSort = $this->_getParam('popularType', 'like_count');

    if( $paramsContentType == 'Trending' ) {
      $this->view->message = 'There is no trending playlist yet';
    } elseif( $paramsContentType == 'Latest' ) {
      $this->view->message = 'There is no latest playlist yet';
    } elseif( $paramsContentType == 'Most_Popular' ) {
      $this->view->message = 'There is no most-popular playlist yet';
    } elseif( $paramsContentType == 'Most_Liked' ) {
      $this->view->message = 'There is no most-liked playlist yet';
    } elseif( $paramsContentType == 'Most_Favourite' ) {
      $this->view->message = 'There is no most-favourite playlist yet';
    } elseif( $paramsContentType == 'Most_Downloaded' ) {
      $this->view->message = 'There is no most-downloaded playlist yet';
    } elseif( $paramsContentType == 'Most_Rated' ) {
      $this->view->message = 'There is no most-rated song yet';
    }

    $this->view->playlistDefaultLayout = $playlistDefaultLayout = str_replace("ZZZ", "_", $this->_getParam('playlistDefaultLayout', 'list_view'));
    if( count($playlistLayoutViews) == 1 ) {
      $this->view->playlistDefaultLayout = $playlistDefaultLayout = $playlistLayoutViews[0];
    }
    $this->view->viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewerId = Engine_Api::_()->user()->getViewer()->getIdentity();
    $this->view->gridViewWidth = $this->_getParam('gridViewWidth', '180');
    $this->view->gridViewHeight = $this->_getParam('gridViewHeight', '290');
    $this->view->cardViewWidth = $this->_getParam('cardViewWidth', '371');
    $this->view->cardViewHeight = $this->_getParam('cardViewHeight', '402');
    $this->view->showViewMore = $this->_getParam('showViewMore', 1);
    $this->view->params = $params;

    $paginator = Engine_Api::_()->getApi('generalWidget', 'sitemusic')->getGeneralPaginator('Playlist', $info);
    $this->view->totalCount = $paginator->getTotalItemCount();
    $paginator->setItemCountPerPage($limit);
    if( !isset($params['page']) ) {
      $params['page'] = 1;
    }
    $this->view->paginator = $paginator->setCurrentPageNumber($params['page']);
    $this->view->paginator = $paginator;

    if( $paginator->getTotalItemCount() <= 0 && $playlistDefaultLayout == 'thumbnail_view' ) {
      return $this->setNoRender();
    }
  }

  public function setTabsOrder($tabs)
  {
    $tabsOrder['Trending'] = $this->_getParam('Trending', 1);
    $tabsOrder['Latest'] = $this->_getParam('Latest', 2);
    $tabsOrder['Most_Popular'] = $this->_getParam('MostZZZPopular', 3);
    $tabsOrder['Most_Liked'] = $this->_getParam('MostZZZLiked', 4);
    $tabsOrder['Most_Favourite'] = $this->_getParam('MostZZZFavourite', 5);
    $tabsOrder['Most_Downloaded'] = $this->_getParam('MostZZZDownloaded', 6);
    $tempTabs = array();
    foreach( $tabs as $tab ) {
      $order = $tabsOrder[$tab];
      if( isset($tempTabs[$order]) )
        $order++;
      $tempTabs[$order] = $tab;
    }
    ksort($tempTabs);
    $orderTabs = array();
    $i = 0;
    foreach( $tempTabs as $tab )
      $orderTabs[$i++] = $tab;
    return $orderTabs;
  }

}
