<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Widget_RelatedSongController extends Engine_Content_Widget_Abstract
{

  public function indexAction()
  {
    $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewerId = $viewer->getIdentity();
    $limit = $this->_getParam('limit', 5);
    $relatedType = $this->_getParam('relatedType', 'owner');
    $params = Zend_Controller_Front::getInstance()->getRequest()->getParams();
    $song = Engine_Api::_()->getItem('sitemusic_playlist_song', $params['item_id']);
    $songTable = Engine_Api::_()->getItemTable('sitemusic_playlist_song');

    if( empty($song) ) {
      return $this->setNoRender();
    }

    $this->view->enableSongFavourite = $enableFavourite = Engine_Api::_()->sitemusic()->enableSongFavourite();
    $this->view->enableSongRating = $enableRating = Engine_Api::_()->sitemusic()->enableSongRating();
    $this->view->enableSongShare = $enableShare = Engine_Api::_()->sitemusic()->enableSongShare();

    $this->view->thumbnail_title_truncation = $this->_getParam('thumbnailTitleTruncationLimit', 50);
    $this->view->enableStatsCountOnZero = Engine_Api::_()->sitemusic()->enableStatsCountOnZero();
    $songId = $song->playlist_id;
    $ownerId = $song->getOwner()->getIdentity();
    $artists = $song->getArtist();
    $artistIds = array();
    foreach( $artists as $artist ) {
      $artistIds[] = $artist['artist_id'];
    }

    if( isset($artistIds) && !empty($artistIds) ) {
      $songIds = array();
      $songArtistTable = Engine_Api::_()->getItemTable('sitemusic_songartist');
      $rows = $songArtistTable->select()->where('artist_id IN(?)', $artistIds)->query()->fetchAll();
      foreach( $rows as $row ) {
        $songIds[] = $row['song_id'];
      }
    }


    $select = $song->select();
    $select->where('song_id != ?', $song->getIdentity());
    if( $relatedType == 'song' ) {
      $select->where('playlist_id = ?', $songId);
    } elseif( $relatedType == 'owner' ) {
      $select->where('playlist_id = ?', $ownerId);
    } elseif( $relatedType == 'artist' ) {
      $songArtistTable = Engine_Api::_()->getItemTable('sitemusic_songartist');
      $saName = $songArtistTable->info('name');
      $sName = $songTable->info('name');
      $select = $song->select();
      $select->where('song_id IN (?)', $songIds);
    } elseif( $relatedType == 'genre' ) {
      if( $song->genre_id ) {
        $select->where('genre_id = ?', $song->genre_id );
      } else {
        return $this->setNoRender();
      }
    }
    $this->view->songShowOptions = array('All');
    $this->view->song_layout_views = $songLayoutViews = array('thumbnail_view');
    $this->view->songDefaultLayout = $songDefaultLayout = str_replace("ZZZ", "_", $this->_getParam('songDefaultLayout', 'thumbnail_view'));

// Get paginator
    $this->view->paginator = $paginator = Zend_Paginator::factory($select);
    $paginator->setItemCountPerPage($limit);

    if( count($this->view->paginator) <= 0 ) {
      return $this->setNoRender();
    }
  }

}
