<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Widget_ShareAndReportController extends Engine_Content_Widget_Abstract
{

  public function indexAction()
  {
    $this->view->isShareEnable = $enableShare = Engine_Api::_()->sitemusic()->enableShare();
    $report = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitemusic.enable.report', 1);

    if( !$enableShare && !$report ) {
      return $this->setNoRender();
    }

    $itemId = null;
    $this->view->itemId = $itemId = $this->_getParam('item_id');
    $values = Zend_Controller_Front::getInstance()->getRequest()->getParams();
    if( isset($values['item_id']) ) {
      $itemId = $values['item_id'];
    }
    $coreApi = Engine_Api::_()->getApi('settings', 'core');
    $resourceType = '';
    if( $values['controller'] == 'playlists' ) {
      $resourceType = 'sitemusic_userpl';
      $entityId = 'userplaylist_id';
      $this->view->isReportEnable = $isReportEnable = $coreApi->getSetting('sitemusic.enable.playlistreport', 1);
      $this->view->isShareEnable = $isShareEnable = $coreApi->getSetting('sitemusic.enable.playlistshare', 1);
      $this->ifBothNotEnabled($isReportEnable, $isShareEnable);
    } elseif( $values['controller'] == 'songs' ) {
      $entityId = 'song_id';
      $resourceType = 'sitemusic_playlist_song';
      $this->view->isReportEnable = $isReportEnable = $coreApi->getSetting('sitemusic.enable.songreport', 1);
      $this->view->isShareEnable = $isShareEnable = $coreApi->getSetting('sitemusic.enable.songshare', 1);
      $this->ifBothNotEnabled($isReportEnable, $isShareEnable);
    } elseif( $values['controller'] == 'artists' ) {
      $entityId = 'artist_id';
      $resourceType = 'sitemusic_artist';
      $this->view->isReportEnable = $isReportEnable = $coreApi->getSetting('sitemusic.enable.artistreport', 1);
      $this->view->isShareEnable = $isShareEnable = $coreApi->getSetting('sitemusic.enable.artistshare', 1);
      $this->ifBothNotEnabled($isReportEnable, $isShareEnable);
    } elseif( $values['controller'] == 'albums' ) {
      $entityId = 'playlist_id';
      $resourceType = 'sitemusic_pl';
      $this->view->isReportEnable = $isReportEnable = $coreApi->getSetting('sitemusic.enable.albumreport', 1);
      $this->view->isShareEnable = $isShareEnable = $coreApi->getSetting('sitemusic.enable.albumshare', 1);
      $this->ifBothNotEnabled($isReportEnable, $isShareEnable);
    }
    $this->view->enableStatsCountOnZero = Engine_Api::_()->sitemusic()->enableStatsCountOnZero();
    $this->view->item = $item = Engine_Api::_()->getItem($resourceType, $itemId);

    if( empty($item) ) {
      return $this->setNoRender();
    }
  }

  protected function ifBothNotEnabled($isReportEnable, $isShareEnable)
  {
    if( !$isReportEnable && !$isShareEnable ) {
      return $this->setNoRender();
    }
  }

}
