<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Widget_UserArtistController extends Engine_Content_Widget_Abstract
{

  public function indexAction()
  {
    $values = array();
    $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
    $values['creater_id'] = $this->view->viewer_id = $viewerId = $viewer->getIdentity();
    $this->view->enableArtist = $enableArtist = Engine_Api::_()->sitemusic()->isArtistEnabled();

    if( !$enableArtist ) {
      return $this->setNoRender();
    }

    $this->view->gridViewWidth = $this->_getParam('gridViewWidth', '167');
    $this->view->gridViewHeight = $this->_getParam('gridViewHeight', '290');

    $this->view->artistShowOptions = array('All');
    $param = Zend_Controller_Front::getInstance()->getRequest()->getParams();
    $this->view->enableStatsCountOnZero = Engine_Api::_()->sitemusic()->enableStatsCountOnZero();
    $this->view->enablePlaylist = $enablePlaylist = Engine_Api::_()->sitemusic()->isPlaylistEnabled();
    $this->view->enableArtistFavourite = $enableArtistFavourite = Engine_Api::_()->sitemusic()->enableArtistFavourite();
    $this->view->enableArtistRating = $enableRating = Engine_Api::_()->sitemusic()->enableArtistRating();
    $this->view->enableArtistShare = $enableShare = Engine_Api::_()->sitemusic()->enableArtistShare();
    $paramValue = Zend_Controller_Front::getInstance()->getRequest()->getParams();
    $this->view->value = $paramValue;
    if( isset($paramValue['page']) ) {
      $page = $paramValue['page'];
    } else {
      $page = 1;
    }

    //for search
    if( !empty($param['search']) ) {
      $values['search'] = $param['search'];
    }
    if( !empty($param['sort']) ) {
      $values['sort'] = $param['sort'];
    }

    // get approve/disapprove both artist
    $values['notCheckApprove'] = true;
    $artist = Engine_Api::_()->getDbtable('artists', 'sitemusic');

// Get paginator
    $this->view->paginator = $paginator = $artist->getPaginator($values);
    $limit = $this->_getParam('itemCountPerPage', 5);
    $paginator->setItemCountPerPage($limit);
    $this->view->paginator = $paginator->setCurrentPageNumber($page);
    $this->view->paginator = $paginator;
  }

}
