<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Widget_UserFollowingController extends Engine_Content_Widget_Abstract
{

  public function indexAction()
  {
    $params['limit'] = $limit = $this->_getParam('limit', 5);
    $this->view->is_ajax_load = true;
    $this->view->is_ajax = $isAjax = $this->_getParam('is_ajax', 0);
    $this->view->params = $params = $this->_getAllParams();
    $this->view->showViewMore = $this->_getParam('showViewMore', 1);
    if( empty($isAjax) ) {
      $showTabArray = $params['ajaxTabs'] = $this->_getParam('ajaxTabs', array("Album", "Artist", "User"));

      $upperTabs = array();
      foreach( $showTabArray as $tab ) {
        $upperTabs[] = ucfirst($tab);
      }
      $this->view->tabs = $showTabArray = $this->setTabsOrder($upperTabs);


      $enableArtist = Engine_Api::_()->sitemusic()->isArtistEnabled();
      if( !$enableArtist ) {
        $keyIndex = array_search('Artist', $showTabArray);

        if( $keyIndex !== false ) {
          $this->checkShowTab($showTabArray);
          unset($showTabArray[$keyIndex]);
        }
      }

      $enablePlaylist = Engine_Api::_()->sitemusic()->isPlaylistEnabled();
      if( !$enablePlaylist ) {
        $keyIndex = array_search('Playlist', $showTabArray);
        if( $keyIndex !== false ) {
          $this->checkShowTab($showTabArray);
          unset($showTabArray[$keyIndex]);
        }
      }

      $this->view->tabs = $showTabArray;
      $this->view->tabCount = count($showTabArray);
      if( empty($this->view->tabCount) ) {
        return $this->setNoRender();
      }
    }
    $this->view->gridViewWidth = $this->_getParam('gridViewWidth', 180);
    $this->view->gridViewHeight = $this->_getParam('gridViewHeight');

    $this->view->list_title_truncation = $this->_getParam('listTitleTruncationLimit', 50);
    $this->view->grid_title_truncation = $this->_getParam('gridTitleTruncationLimit', 50);
    $this->view->card_title_truncation = $this->_getParam('cardTitleTruncationLimit', 50);
    $this->view->thumbnail_title_truncation = $this->_getParam('thumbnailTitleTruncationLimit', 50);


    $this->view->albumShowOptions = array('All');
    $this->view->artistShowOptions = array('All');

    $this->view->enableStatsCountOnZero = Engine_Api::_()->sitemusic()->enableStatsCountOnZero();
    $this->view->enablePlaylist = $enablePlaylist = Engine_Api::_()->sitemusic()->isPlaylistEnabled();
    $this->view->enableAlbumFavourite = $enableAlbumFavourite = Engine_Api::_()->sitemusic()->enableAlbumFavourite();
    $this->view->isRatingEnable = $enableAlbumRating = Engine_Api::_()->sitemusic()->enableAlbumRating();
    $this->view->isAlbumShareEnable = $enableAlbumShare = Engine_Api::_()->sitemusic()->enableAlbumShare();

    $this->view->enableSongFavourite = $enableFavourite = Engine_Api::_()->sitemusic()->enableSongFavourite();
    $this->view->enableSongRating = $enableRating = Engine_Api::_()->sitemusic()->enableSongRating();
    $this->view->enableSongShare = $enableShare = Engine_Api::_()->sitemusic()->enableSongShare();

    $this->view->enablePlaylistFavourite = $enablePlaylistFavourite = Engine_Api::_()->sitemusic()->enablePlaylistFavourite();
    $this->view->enablePlaylistRating = $enableRating = Engine_Api::_()->sitemusic()->enablePlaylistRating();
    $this->view->enablePlaylistShare = $enableShare = Engine_Api::_()->sitemusic()->enablePlaylistShare();

    $this->view->enableArtistFavourite = $enableArtistFavourite = Engine_Api::_()->sitemusic()->enableArtistFavourite();
    $this->view->enableArtistRating = $enableRating = Engine_Api::_()->sitemusic()->enableArtistRating();
    $this->view->enableArtistShare = $enableShare = Engine_Api::_()->sitemusic()->enableArtistShare();


    $paramsEntityType = $this->_getParam('entity_type', null);
    $this->view->entity_type = $paramsEntityType = $paramsEntityType ? $paramsEntityType : $showTabArray[0];
    $albumLayoutViews = $params['album_layout_views'] = $this->_getParam('album_layout_views', array("list_view", "grid_view", "card_view"));
    foreach( $albumLayoutViews as $key => $value )
      $albumLayoutViews[$key] = str_replace("ZZZ", "_", $value);
    if( is_array($albumLayoutViews) ) {
      sort($albumLayoutViews);
    }
    $this->view->album_layout_views = $albumLayoutViews;
    $this->view->albumDefaultLayout = str_replace("ZZZ", "_", $this->_getParam('defaultOrder', 'list_view'));
    $this->view->viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewerId = Engine_Api::_()->user()->getViewer()->getIdentity();
    $this->view->params = $params;

    $this->view->artist_layout_views = $artistLayoutViews = array('grid_view');
    $this->view->artistDefaultLayout = $artistDefaultLayout = str_replace("ZZZ", "_", $this->_getParam('artistDefaultLayout', 'grid_view'));

    $allParam = Zend_Controller_Front::getInstance()->getRequest()->getParams();
    if( !isset($allParam['page']) ) {
      $page = 1;
    } else {
      $page = $allParam['page'];
    }
    if( $this->_getParam('randomNum') ) {
      $this->view->randomNumber = $this->_getParam('randomNum');
    } else {
      $this->view->randomNumber = $params['randomNum'] = rand();
    }
    $paginator = Engine_Api::_()->getApi('following', 'sitemusic')->getFollowing($paramsEntityType);
    $this->view->totalCount = $paginator->getTotalItemCount();
    $paginator->setItemCountPerPage($limit);
    $this->view->paginator = $paginator->setCurrentPageNumber($page);
    $this->view->paginator = $paginator;
  }

  public function setTabsOrder($tabs)
  {

    $tabsOrder['Album'] = $this->_getParam('Album', 1);
    $tabsOrder['Artist'] = $this->_getParam('Artist', 2);
    $tabsOrder['User'] = $this->_getParam('User', 3);

    $tempTabs = array();
    foreach( $tabs as $tab ) {
      $order = $tabsOrder[$tab];
      if( isset($tempTabs[$order]) )
        $order++;
      $tempTabs[$order] = $tab;
    }
    ksort($tempTabs);
    $orderTabs = array();
    $i = 0;
    foreach( $tempTabs as $tab )
      $orderTabs[$i++] = $tab;
    return $orderTabs;
  }

  public function checkShowTab($tabs)
  {
    // in case when on tab exist and that are disable;
    if( count($tabs) == 1 ) {
      return $this->setNoRender();
    }
  }

}
