<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Widget_UserProfileAlbumController extends Engine_Content_Widget_Abstract
{

  public function indexAction()
  {
    $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewerId = $viewer->getIdentity();
    $limit = $this->_getParam('limit', 5);

    $allParam = Zend_Controller_Front::getInstance()->getRequest()->getParams();
    $this->view->value = $allParam;
    if( !isset($allParam['page']) ) {
      $page = 1;
    } else {
      $page = $allParam['page'];
    }
    $this->view->randomNumber = $randomNum = rand();
    $this->view->enableStatsCountOnZero = Engine_Api::_()->sitemusic()->enableStatsCountOnZero();
    $this->view->enablePlaylist = $enablePlaylist = Engine_Api::_()->sitemusic()->isPlaylistEnabled();
    $this->view->enableFavourite = $enableFavourite = Engine_Api::_()->sitemusic()->enableFavourite();



    //WHO WILL BE THE PARENT OF MUSIC ALBUM CREATED THROUGH THE OTHER MODULES
    $albumOwnerSetting = Engine_Api::_()->getApi('settings', 'core')->getSetting("sitemusic.playlist.leader.owner.$parent_type", 1);
    $showOptions = $params['showOptions'] = $this->_getParam('showOptions');
    $showViewOptions = $params['showOptions'] = $this->_getParam('showSongOptions');
    if( isset($showViewOptions) && !empty($showViewOptions) ) {
      $options = array_merge($showViewOptions, $showOptions);
    } else {
      $options = $showOptions;
    }
    $this->view->albumShowOptions = $options;
    $this->view->gridViewWidth = $this->_getParam('gridViewWidth', '167');
    $this->view->gridViewHeight = $this->_getParam('gridViewHeight', '290');
    $this->view->cardViewWidth = $this->_getParam('cardViewWidth', '371');
    $this->view->cardViewHeight = $this->_getParam('cardViewHeight', '402');

    $albumLayoutViews = $params['album_layout_views'] = $this->_getParam('album_layout_views', array("list_view", "grid_view", "card_view"));
    foreach( $albumLayoutViews as $key => $value )
      $albumLayoutViews[$key] = str_replace("ZZZ", "_", $value);
    $this->view->album_layout_views = $albumLayoutViews;
    $this->view->tabCount = count($albumLayoutViews);

    $this->view->albumDefaultLayout = $albumDefaultLayout = str_replace("ZZZ", "_", $this->_getParam('albumDefaultLayout', 'list_view'));
    if( count($albumLayoutViews) == 1 ) {
      $this->view->albumDefaultLayout = $albumDefaultLayout = $albumLayoutViews[0];
    }
    $this->view->list_title_truncation = $this->_getParam('listTitleTruncationLimit', 50);
    $this->view->grid_title_truncation = $this->_getParam('gridTitleTruncationLimit', 50);
    $this->view->card_title_truncation = $this->_getParam('cardTitleTruncationLimit', 50);
    $this->view->thumbnail_title_truncation = $this->_getParam('thumbnailTitleTruncationLimit', 50);

    $this->view->showViewMore = $this->_getParam('showViewMore', 1);
    $this->view->gridViewWidth = $this->_getParam('gridViewWidth',167);
    $this->view->gridViewHeight = $this->_getParam('gridViewHeight',140);

    $playlistTable = Engine_Api::_()->getDbTable('playlists', 'sitemusic');
    $select = $playlistTable->select()->where('owner_id =?', $viewerId);
// Get paginator
    Zend_Paginator::factory($select);
    $this->view->paginator = $paginator = Zend_Paginator::factory($select);
    $this->view->totalCount = $paginator->getTotalItemCount();
    $paginator->setItemCountPerPage($limit);
    $this->view->params = array('page' => $page);
    $this->view->paginator = $paginator->setCurrentPageNumber($page);

    // Do not render if nothing to show
    if( $paginator->getTotalItemCount() <= 0 ) {
      return $this->setNoRender();
    }
  }

}
