<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Widget_UserSongController extends Engine_Content_Widget_Abstract
{

  public function indexAction()
  {
    $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewerId = $viewer->getIdentity();
    $this->view->enableArtist = $enableArtist = Engine_Api::_()->sitemusic()->isArtistEnabled();
    $param = Zend_Controller_Front::getInstance()->getRequest()->getParams();
    $this->view->enablePlaylist = $enablePlaylist = Engine_Api::_()->sitemusic()->isPlaylistEnabled();
    $this->view->enableSongFavourite = $enableFavourite = Engine_Api::_()->sitemusic()->enableSongFavourite();
    $this->view->enableSongFavourite = $enableFavourite = Engine_Api::_()->sitemusic()->enableSongFavourite();
    $this->view->enableSongRating = $enableRating = Engine_Api::_()->sitemusic()->enableSongRating();
    $this->view->enableSongShare = $enableShare = Engine_Api::_()->sitemusic()->enableSongShare();
    $this->view->enableStatsCountOnZero = Engine_Api::_()->sitemusic()->enableStatsCountOnZero();
    $album = Engine_Api::_()->getDbtable('playlists', 'sitemusic');
    $select = $album->select()->from($album->info('name'), 'playlist_id');
    $select->where('owner_id = ?', $viewerId);
    $albumIds = $select->query()->fetchAll();
    $ownerAlbumIds = array();

    if( !empty($albumIds) && isset($albumIds) ) {
      foreach( $albumIds as $albumId ) {
        $ownerAlbumIds[] = $albumId['playlist_id'];
      }
    }
    $values['viewerId'] = $viewerId;

    if( isset($param['search']) ) {
      $values['search'] = $param['search'];
    }
    if( isset($param['sort']) ) {
      $values['sort'] = $param['sort'];
    }
    if( isset($param['songShowOptions']) ) {
      $this->view->message = 'Nobody has upload any song under this category.';
      $values['songShowOptions'] = $param['songShowOptions'];
    } else {
      // for mysongs in myalbum or others album
      $values['songShowOptions'] = 8;
      $this->view->message = 'You have not uploaded any song yet.';
    }
    $showOptions = $params['showOptions'] = $this->_getParam('showOptions');
    $values['sort'] = $this->_getParam('default_sort');
    $values['labelType'] = $this->_getParam('label_category');
    $values['type'] = 'sitemusic_playlist_song';

    $values['notCheckApprove'] = $this->view->mymusic = 1;
    $psTable = Engine_Api::_()->getDbTable('playlistSongs', 'sitemusic');

    if( isset($ownerAlbumIds) && !empty($ownerAlbumIds) ) {
      $values['albumIds'] = $ownerAlbumIds;
      // Get paginator
      $select = $psTable->select();
      $select->where('approved = ?', 0);
      $select->where('owner_id != ?', $viewerId);
      $select->where('playlist_id IN(?)', $ownerAlbumIds);

      $needApproval = $select->query()->fetchAll();

      if( $needApproval ) {
        $this->view->approvalCount = $approvalCount = count($needApproval);
      }
    }
//if album ids blank than we set special character for preventing unwanted results for search.
    if( !isset($values['albumIds']) && empty($values['albumIds']) ) {
      $values['albumIds'] = '@@';
    }
    $this->view->paginator = $paginator = $psTable->getPaginator($values);
    if( empty($page) ) {
      $page = 1;
    }
    $limit = $this->_getParam('limit', 5);
    try {
      $paginator->setItemCountPerPage($limit);
    } catch( Exception $e ) {
      echo $e->getMessage();
      die;
    }

    if( isset($param['page']) ) {
      $page = $param['page'];
    } else {
      $page = 1;
    }
    $this->view->paginator = $paginator->setCurrentPageNumber($page);
    $this->view->paginator = $paginator;
  }

}
