<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenews
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Settemplate.php 2011-08-026 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenews_Api_Settemplate extends Core_Api_Abstract {

    public function getDb() {
        return $db = Engine_Db_Table::getDefaultAdapter();
    }

    public function checkPageId($name = false) {

        if (!$name)
            return false;

        $db = Engine_Db_Table::getDefaultAdapter();
        $select = new Zend_Db_Select($db);
        $page_id = $select
                        ->from('engine4_core_pages', 'page_id')
                        ->where('name = ?', $name)
                        ->query()->fetchColumn();

        return $page_id;
    }

    public function deletePageAndContent($page_id) {

        $db = Engine_Db_Table::getDefaultAdapter();
        $db->query("DELETE FROM `engine4_core_pages` WHERE `engine4_core_pages`.`page_id` = $page_id");
        $db->query("DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`page_id` = $page_id");
    }

    public function getCurrentActivateTheme($default = false) {

        if ($default == null)
            return $this->setLayoutAccordingToTheme();

        if (isset($_POST['sitenews_setlayyoutpages']) && $_POST['sitenews_setlayyoutpages'] == 1) {
            return 1;
        } else if (isset($_POST['sitenews_setlayyoutpages']) && $_POST['sitenews_setlayyoutpages'] == 3) {
            return 3;
        } else if (isset($_POST['sitenews_setlayyoutpages']) && $_POST['sitenews_setlayyoutpages'] == 2) {
            return 2;
        }

        return false;
    }

    public function setLayoutAccordingToTheme() {
        $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
        $theme = '';
        $themeArray = $view->layout()->themes;
        if (isset($themeArray[0])) {
            $theme = $view->layout()->themes[0];
        }
        $file = APPLICATION_PATH . '/application/themes/' . $theme . '/constants.css';
        $width = Engine_Api::_()->seaocore()->getValueOfCssVariables($file, 'theme_content_width');
        if ($width >= 1200) {
            $setLayout = 3;
        } else if (1100 > $width) {
            $setLayout = 1;
        } else if (1100 >= $width && 1200 > $width) {
            $setLayout = 2;
        }

        return $setLayout;
    }

    function _columnExist($table, $column) {
        $db = Engine_Db_Table::getDefaultAdapter();

        $columnName = $db->query("
        SHOW COLUMNS FROM `$table`
           LIKE '$column'")->fetch();
        if (!empty($columnName))
            return true;
        return false;
    }

    public function addNewsHomePage($reset, $default = null) {
        $db = $this->getDb();
        $page_id = $this->checkPageId('sitenews_news_index');
        if ($page_id && $reset) {
            $this->deletePageAndContent($page_id);
            $page_id = false;
        }

        if (!$page_id) {
            if ($this->getCurrentActivateTheme($default) == 3) {
                // Insert page
                $db->insert('engine4_core_pages', array(
                    'name' => 'sitenews_news_index',
                    'displayname' => 'News - News Home Page',
                    'title' => 'News Home Page',
                    'description' => 'This is the home page.',
                    'custom' => 0,
                ));
                $page_id = $db->lastInsertId();

                // Insert top
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'top',
                    'page_id' => $page_id,
                    'order' => 1,
                ));
                $top_id = $db->lastInsertId();

                // Insert main
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'main',
                    'page_id' => $page_id,
                    'order' => 2,
                ));
                $main_id = $db->lastInsertId();

                // Insert top-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_id,
                    'order' => 6,
                ));
                $top_middle_id = $db->lastInsertId();

                // Insert main-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_id,
                    'order' => 6,
                ));
                $main_middle_id = $db->lastInsertId();

                // Insert main-right
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'right',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_id,
                    'order' => 5,
                ));
                $main_right_id = $db->lastInsertId();

                // Insert menu
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.browse-menu',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_middle_id,
                    'order' => 3,
                ));

                //Insert News Banner
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.news-banner',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_middle_id,
                    'order' => 4,
                    'params' => '{"newsOption":["title", "creationDate","view","like","comment","favourite","facebook","twitter","linkedin","googleplus"],"category_id":"0","subcategory_id":null,"hidden_category_id":"","hidden_subcategory_id":"","hidden_subsubcategory_id":"","rss":"0","bannerHeight":"400","imageSpace":"5","popularType":"featured","title":"","nomobile":"0","name":"sitenews.news-banner"}'
                ));

                //Insert Breaking
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.breaking-news-sitenews',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_middle_id,
                    'order' => 5,
                    'params' => '{"heading":"Breaking News","scrollamount":"7","title":"","nomobile":"0","name":"sitenews.breaking-news-sitenews"}'
                ));

                //Insert Home grid list view
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.news-with-categories-slideshow',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_middle_id,
                    'order' => 8,
                    'params' => '{"title":"Business News","newsOption":["title","description", "creationDate","view","like","comment","favourite","facebook","twitter","linkedin","googleplus"],"categoryids":["1","2","3","4","6","8","11","13","14"],"rss":"0","categoryAtTop":"1","viewType":null,"titleTruncation":"100","descriptionTruncation":"50","categoryCountInSingleRow":"9","nomobile":"0","name":"sitenews.news-with-categories-slideshow"}'
                ));

                //Insert Home grid list view again
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.news-main-ajax-home-sitenews',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_middle_id,
                    'order' => 9,
                    'params' => '{"title":"","viewType":["gridZZZview","listZZZview"],"defaultViewType":"gridZZZview","newsOption":["title","view","like","comment","favourite","facebook","twitter","linkedin","googleplus"],"ajaxTabs":["featured","sponsored","recent","mostZZZviewed"],"category_id":"0","subcategory_id":null,"hidden_category_id":"","hidden_subcategory_id":"","hidden_subsubcategory_id":"","rss":"0","listViewWithPhoto":"1","gridViewHeight":"200","gridViewWidth":"281","listDescription":"1","showViewMore":"1","gridItemCountPerPage":"9","listItemCountPerPage":"9","titleTruncationGridNNewsView":"60","titleTruncation":"100","descriptionTruncation":"600","most_viewed_order":"2","recent_order":"1","sponsored_order":"4","featured_order":"5","detactLocation":"0","defaultLocationDistance":"1000","loaded_by_ajax":"1","nomobile":"0","name":"sitenews.news-main-ajax-home-sitenews"}'
                ));

                //Insert Trending News
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.trending-news-sitenews',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_right_id,
                    'order' => 14,
                    'params' => '{"categoryids":["1","2","3","4"],"itemCount":"5","popularType":"creation","titleTruncation":"50","refreshTimeout":"12","detactLocation":"0","defaultLocationDistance":"1000","title":"Trending News","nomobile":"0","name":"sitenews.trending-news-sitenews"}'
                ));

                //Insert News Tags
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.tagcloud-sitenews-news',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_right_id,
                    'order' => 15,
                    'params' => '{"title":"Popular Tags","titleCount":true,"orderingType":"1","itemCount":"25","loaded_by_ajax":"1","nomobile":"0","name":"sitenews.tagcloud-sitenews-news"}'
                ));

                //Insert News Tags
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.news-recently-view-random-sitenews',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_right_id,
                    'order' => 16,
                    'params' => '{"title":"Around the World","itemCountPerPage":4,"viewTypes":["gridZZZview"],"defaultViewType":"gridZZZview","category_id":"2","subcategory_id":"0","hidden_news_category_id":"2","hidden_news_subcategory_id":"0","hidden_news_subsubcategory_id":"0","rss":"0","showNews":"all_feeds","popularType":"random","showPhotosInJustifiedView":"0","rowHeight":"205","maxRowHeight":"0","margin":"0","lastRow":"nojustify","listViewWithPhoto":"1","newsOption":["title","creationDate","view","like","comment","location","favourite","facebook","twitter","linkedin","googleplus"],"listDescription":"0","gridViewHeight":"190","gridViewWidth":"213","titleTruncation":"40","descriptionTruncation":"100","detactLocation":"0","gridItemCountPerPage":"3","listItemCountPerPage":"9","showViewMore":"0","nomobile":"0","name":"sitenews.news-recently-view-random-sitenews"}'
                ));
            } else if ($this->getCurrentActivateTheme($default) == 2) {
                // Insert page
                $db->insert('engine4_core_pages', array(
                    'name' => 'sitenews_news_index',
                    'displayname' => 'News - News Home Page',
                    'title' => 'News Home Page',
                    'description' => 'This is the home page.',
                    'custom' => 0,
                ));
                $page_id = $db->lastInsertId();

                // Insert top
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'top',
                    'page_id' => $page_id,
                    'order' => 1,
                ));
                $top_id = $db->lastInsertId();

                // Insert main
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'main',
                    'page_id' => $page_id,
                    'order' => 2,
                ));
                $main_id = $db->lastInsertId();

                // Insert top-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_id,
                    'order' => 6,
                ));
                $top_middle_id = $db->lastInsertId();

                // Insert main-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_id,
                    'order' => 6,
                ));
                $main_middle_id = $db->lastInsertId();

                // Insert main-right
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'right',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_id,
                    'order' => 5,
                ));
                $main_right_id = $db->lastInsertId();

                // Insert menu
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.browse-menu',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_middle_id,
                    'order' => 3,
                ));

                //Insert News Banner
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.news-banner',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_middle_id,
                    'order' => 4,
                    'params' => '{"newsOption":["title", "creationDate","view","like","comment","favourite","facebook","twitter","linkedin","googleplus"],"category_id":"0","subcategory_id":null,"hidden_category_id":"","hidden_subcategory_id":"","hidden_subsubcategory_id":"","rss":"0","bannerHeight":"350","imageSpace":"7","popularType":"featured","refreshTimeout":"9","title":"News Banner","nomobile":"0","name":"sitenews.news-banner"}'
                ));

                //Insert Breaking
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.breaking-news-sitenews',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_middle_id,
                    'order' => 5,
                    'params' => '{"heading":"Breaking News","scrollamount":"10","title":"","nomobile":"0","name":"sitenews.breaking-news-sitenews"}'
                ));

                //Insert Home grid list view
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.news-with-categories-slideshow',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_middle_id,
                    'order' => 8,
                    'params' => '{"title":"News Updates","newsOption":["title","description","creationDate","view","like","comment","favourite","facebook","twitter","linkedin","googleplus"],"categoryids":["1","2","3","4","8","10","12","13","16"],"rss":"0","categoryAtTop":"1","viewType":null,"titleTruncation":"90","descriptionTruncation":"125","categoryCountInSingleRow":"8","nomobile":"0","name":"sitenews.news-with-categories-slideshow"}'
                ));

                //Insert Home grid list view again
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.news-main-ajax-home-sitenews',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_middle_id,
                    'order' => 9,
                    'params' => '{"title":"","viewType":["gridZZZview","listZZZview"],"defaultViewType":"gridZZZview","newsOption":["title","like","comment","favourite","facebook","twitter","linkedin","googleplus"],"ajaxTabs":["featured","sponsored","recent","mostZZZviewed"],"category_id":"0","subcategory_id":null,"hidden_category_id":"","hidden_subcategory_id":"","hidden_subsubcategory_id":"","rss":"0","listViewWithPhoto":"1","gridViewHeight":"200","gridViewWidth":"261","listDescription":"1","showViewMore":"1","gridItemCountPerPage":"9","listItemCountPerPage":"9","titleTruncationGridNNewsView":"45","titleTruncation":"200","descriptionTruncation":"500","most_viewed_order":"2","recent_order":"1","sponsored_order":"4","featured_order":"5","detactLocation":"0","defaultLocationDistance":"1000","loaded_by_ajax":"1","nomobile":"0","name":"sitenews.news-main-ajax-home-sitenews"}'
                ));

                //Insert Trending News
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.trending-news-sitenews',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_right_id,
                    'order' => 14,
                    'params' => '{"categoryids":["1","2","3","4"],"itemCount":"5","popularType":"creation","titleTruncation":"40","refreshTimeout":"12","detactLocation":"0","defaultLocationDistance":"1000","title":"Trending...","nomobile":"0","name":"sitenews.trending-news-sitenews"}'
                ));

                //Insert News Tags
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.tagcloud-sitenews-news',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_right_id,
                    'order' => 15,
                    'params' => '{"title":"Popular News Tags","titleCount":true,"orderingType":"1","itemCount":"25","loaded_by_ajax":"1","nomobile":"0","name":"sitenews.tagcloud-sitenews-news"}'
                ));

                //Insert News Tags
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.news-recently-view-random-sitenews',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_right_id,
                    'order' => 16,
                    'params' => '{"title":"Around the World","itemCountPerPage":4,"viewTypes":["gridZZZview"],"defaultViewType":"gridZZZview","category_id":"4","subcategory_id":"0","hidden_news_category_id":"4","hidden_news_subcategory_id":"0","hidden_news_subsubcategory_id":"0","rss":"0","showNews":"all_feeds","popularType":"random","showPhotosInJustifiedView":"0","rowHeight":"205","maxRowHeight":"0","margin":"0","lastRow":"nojustify","listViewWithPhoto":"1","newsOption":["title","creationDate","view","like","comment","location","favourite","facebook","twitter","linkedin"],"listDescription":"1","gridViewHeight":"200","gridViewWidth":"193","titleTruncation":"36","descriptionTruncation":"100","detactLocation":"0","gridItemCountPerPage":"3","listItemCountPerPage":"9","showViewMore":"0","nomobile":"0","name":"sitenews.news-recently-view-random-sitenews"}'
                ));
            } else if ($this->getCurrentActivateTheme($default) == 1) {
                // Insert page
                $db->insert('engine4_core_pages', array(
                    'name' => 'sitenews_news_index',
                    'displayname' => 'News - News Home Page',
                    'title' => 'News Home Page',
                    'description' => 'This is the home page.',
                    'custom' => 0,
                ));
                $page_id = $db->lastInsertId();

                // Insert top
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'top',
                    'page_id' => $page_id,
                    'order' => 1,
                ));
                $top_id = $db->lastInsertId();

                // Insert main
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'main',
                    'page_id' => $page_id,
                    'order' => 2,
                ));
                $main_id = $db->lastInsertId();

                // Insert top-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_id,
                    'order' => 6,
                ));
                $top_middle_id = $db->lastInsertId();

                // Insert main-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_id,
                    'order' => 6,
                ));
                $main_middle_id = $db->lastInsertId();

                // Insert main-right
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'right',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_id,
                    'order' => 5,
                ));
                $main_right_id = $db->lastInsertId();

                // Insert menu
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.browse-menu',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_middle_id,
                    'order' => 3,
                ));

                //Insert News Banner
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.news-banner',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_middle_id,
                    'order' => 4,
                    'params' => '{"newsOption":["title", "creationDate","view","like","comment","favourite","facebook","twitter","linkedin","googleplus"],"category_id":"0","subcategory_id":null,"hidden_category_id":"","hidden_subcategory_id":"","hidden_subsubcategory_id":"","rss":"0","bannerHeight":"300","imageSpace":"3","popularType":"mostRecent","title":"","nomobile":"0","name":"sitenews.news-banner"}'
                ));

                //Insert Breaking
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.breaking-news-sitenews',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_middle_id,
                    'order' => 5,
                    'params' => '{"heading":"Breaking News","scrollamount":"10","direction":"left","marqueeheight":"29","title":"","nomobile":"0","name":"sitenews.breaking-news-sitenews"}'
                ));

                //Insert Home grid list view
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.news-with-categories-slideshow',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_middle_id,
                    'order' => 8,
                    'params' => '{"title":"News Updates","newsOption":["title","description","creationDate","description","like","comment","favourite","facebook","twitter","linkedin","googleplus"],"categoryids":["1", "2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17"],"rss":"0","categoryAtTop":"1","viewType":null,"titleTruncation":"75","descriptionTruncation":"100","categoryCountInSingleRow":"7","nomobile":"0","name":"sitenews.news-with-categories-slideshow"}'
                ));

                //Insert Home grid list view again
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.news-main-ajax-home-sitenews',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_middle_id,
                    'order' => 9,
                    'params' => '{"title":"","viewType":["gridZZZview","listZZZview"],"defaultViewType":"gridZZZview","newsOption":["title","view","like","comment","favourite","facebook","twitter","linkedin","googleplus"],"ajaxTabs":["featured","sponsored","recent","mostZZZviewed"],"category_id":"0","subcategory_id":null,"hidden_category_id":"","hidden_subcategory_id":"","hidden_subsubcategory_id":"","rss":"0","listViewWithPhoto":"1","gridViewHeight":"190","gridViewWidth":"224","listDescription":"1","showViewMore":"1","gridItemCountPerPage":"9","listItemCountPerPage":"9","titleTruncationGridNNewsView":"60","titleTruncation":"50","descriptionTruncation":"500","most_viewed_order":"2","recent_order":"1","sponsored_order":"4","featured_order":"5","detactLocation":"0","defaultLocationDistance":"1000","loaded_by_ajax":"1","nomobile":"0","name":"sitenews.news-main-ajax-home-sitenews"}'
                ));

                //Insert Trending News
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.trending-news-sitenews',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_right_id,
                    'order' => 14,
                    'params' => '{"categoryids":["1", "2", "3","4"],"itemCount":"5","popularType":"creation","titleTruncation":"33","refreshTimeout":"12","detactLocation":"0","defaultLocationDistance":"1000","title":"Trending...","nomobile":"0","name":"sitenews.trending-news-sitenews"}'
                ));

                //Insert News Tags
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.tagcloud-sitenews-news',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_right_id,
                    'order' => 15,
                    'params' => '{"title":"Popular Tags","titleCount":true,"orderingType":"1","itemCount":"25","loaded_by_ajax":"1","nomobile":"0","name":"sitenews.tagcloud-sitenews-news"}'
                ));

                //Insert News Tags
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.news-recently-view-random-sitenews',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_right_id,
                    'order' => 16,
                    'params' => '{"title":"Around the World","itemCountPerPage":4,"viewTypes":["gridZZZview"],"defaultViewType":"gridZZZview","category_id":"0","subcategory_id":null,"hidden_news_category_id":"","hidden_news_subcategory_id":"","hidden_news_subsubcategory_id":"","rss":"0","showNews":"all_feeds","popularType":"random","showPhotosInJustifiedView":"0","rowHeight":"205","maxRowHeight":"0","margin":"0","lastRow":"nojustify","listViewWithPhoto":"1","newsOption":["title","creationDate","view","like","comment","favourite","facebook","twitter","linkedin"],"listDescription":"1","gridViewHeight":"170","gridViewWidth":"164","titleTruncation":"32","descriptionTruncation":"100","detactLocation":"0","gridItemCountPerPage":"3","listItemCountPerPage":"9","showViewMore":"0","nomobile":"0","name":"sitenews.news-recently-view-random-sitenews"}'
                ));
            }
        }
    }

    public function addNewsBrowsePage($reset, $default = null) {
        $db = $this->getDb();
        $page_id = $this->checkPageId('sitenews_news_browse');
        if ($page_id && $reset) {
            $this->deletePageAndContent($page_id);
            $page_id = false;
        }

        if (!$page_id) {

            if ($this->getCurrentActivateTheme($default) == 3) {
                // Insert page
                $db->insert('engine4_core_pages', array(
                    'name' => 'sitenews_news_browse',
                    'displayname' => 'News - News Browse Page',
                    'title' => 'News Browse Page',
                    'description' => 'This page lets you browse all the news created by the users.',
                    'custom' => 0,
                ));
                $page_id = $db->lastInsertId();

                // Insert top
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'top',
                    'page_id' => $page_id,
                    'order' => 1,
                ));
                $top_id = $db->lastInsertId();

                // Insert main
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'main',
                    'page_id' => $page_id,
                    'order' => 2,
                ));
                $main_id = $db->lastInsertId();

                // Insert top-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_id,
                    'order' => 6,
                ));
                $top_middle_id = $db->lastInsertId();

                // Insert main-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_id,
                    'order' => 6,
                ));
                $main_middle_id = $db->lastInsertId();

                // Insert main-right
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'right',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_id,
                    'order' => 5,
                ));
                $main_right_id = $db->lastInsertId();

                // Insert menu
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.browse-menu',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_middle_id,
                    'order' => 3,
                ));

                // Insert Breaking News
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.breaking-news-sitenews',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_middle_id,
                    'order' => 4,
                    'params' => '{"heading":"Breaking News","scrollamount":"7","title":"","nomobile":"0","name":"sitenews.breaking-news-sitenews"}'
                ));

                //Insert Popular News carousel
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.browse-news-sitenews',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_middle_id,
                    'order' => 9,
                    'params' => '{"title":"","titleCount":true,"viewType":["gridView","listView"],"defaultViewType":"gridView","newsOption":["title","view","like","comment","favourite","facebook","twitter","linkedin","googleplus"],"category_id":"0","subcategoryids":null,"hidden_category_id":"","hidden_subcategory_id":"","hidden_subsubcategory_id":"","rss":"0","gridViewHeight":"200","gridViewWidth":"282","showPhotosInJustifiedView":"0","rowHeight":"205","maxRowHeight":"300","margin":"30","lastRow":"nojustify","orderby":"creationDate","show_content":"2","titleTruncation":"60","descriptionTruncation":"600","detactLocation":"0","defaultLocationDistance":"1000","listDescription":"1","itemCountPerPage":"9","nomobile":"0","name":"sitenews.browse-news-sitenews"}'
                ));

                //Insert Search widget
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.search-news-sitenews',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_right_id,
                    'order' => 12,
                    'params' => '{"title":"SEARCH","titleCount":true,"viewType":"vertical","showAllCategories":"1","locationDetection":"1","nomobile":"0","name":"sitenews.search-news-sitenews"}'
                ));

                //Insert Search widget
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.tagcloud-sitenews-news',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_right_id,
                    'order' => 13,
                    'params' => '{"title":"Popular Tags (%s)","titleCount":true}'
                ));
            } else if ($this->getCurrentActivateTheme($default) == 2) {
                // Insert page
                $db->insert('engine4_core_pages', array(
                    'name' => 'sitenews_news_browse',
                    'displayname' => 'News - News Browse Page',
                    'title' => 'News Browse Page',
                    'description' => 'This page lets you browse all the news created by the users.',
                    'custom' => 0,
                ));
                $page_id = $db->lastInsertId();

                // Insert top
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'top',
                    'page_id' => $page_id,
                    'order' => 1,
                ));
                $top_id = $db->lastInsertId();

                // Insert main
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'main',
                    'page_id' => $page_id,
                    'order' => 2,
                ));
                $main_id = $db->lastInsertId();

                // Insert top-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_id,
                    'order' => 6,
                ));
                $top_middle_id = $db->lastInsertId();

                // Insert main-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_id,
                    'order' => 6,
                ));
                $main_middle_id = $db->lastInsertId();

                // Insert main-right
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'right',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_id,
                    'order' => 5,
                ));
                $main_right_id = $db->lastInsertId();

                // Insert menu
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.browse-menu',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_middle_id,
                    'order' => 3,
                ));

                // Insert Breaking News
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.breaking-news-sitenews',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_middle_id,
                    'order' => 4,
                    'params' => '{"heading":"Breaking News","scrollamount":"10","direction":"left","marqueeheight":"29","title":"","nomobile":"0","name":"sitenews.breaking-news-sitenews"}'
                ));

                //Insert Popular News carousel
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.browse-news-sitenews',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_middle_id,
                    'order' => 9,
                    'params' => '{"title":"","titleCount":true,"viewType":["gridView","listView"],"defaultViewType":"gridView","newsOption":["title","view","like","comment","favourite","facebook","twitter","linkedin","googleplus"],"category_id":"0","subcategoryids":null,"hidden_category_id":"","hidden_subcategory_id":"0","hidden_subsubcategory_id":"0","rss":"0","gridViewHeight":"200","gridViewWidth":"261","showPhotosInJustifiedView":"0","rowHeight":"199","maxRowHeight":"300","margin":"5","lastRow":"nojustify","orderby":"creationDate","show_content":"2","titleTruncation":"55","descriptionTruncation":"500","detactLocation":"0","defaultLocationDistance":"1000","listDescription":"1","itemCountPerPage":"9","nomobile":"0","name":"sitenews.browse-news-sitenews"}'
                ));

                //Insert Search widget
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.search-news-sitenews',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_right_id,
                    'order' => 12,
                    'params' => '{"title":"SEARCH","titleCount":true,"viewType":"vertical","showAllCategories":"1","locationDetection":"1","nomobile":"0","name":"sitenews.search-news-sitenews"}'
                ));

                //Insert Search widget
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.tagcloud-sitenews-news',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_right_id,
                    'order' => 13,
                    'params' => '{"title":"Popular Tags","titleCount":true,"orderingType":"1","itemCount":"25","loaded_by_ajax":"1","nomobile":"0","name":"sitenews.tagcloud-sitenews-news"}'
                ));
            } else if ($this->getCurrentActivateTheme($default) == 1) {
                // Insert page
                $db->insert('engine4_core_pages', array(
                    'name' => 'sitenews_news_browse',
                    'displayname' => 'News - News Browse Page',
                    'title' => 'News Browse Page',
                    'description' => 'This page lets you browse all the news created by the users.',
                    'custom' => 0,
                ));
                $page_id = $db->lastInsertId();

                // Insert top
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'top',
                    'page_id' => $page_id,
                    'order' => 1,
                ));
                $top_id = $db->lastInsertId();

                // Insert main
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'main',
                    'page_id' => $page_id,
                    'order' => 2,
                ));
                $main_id = $db->lastInsertId();

                // Insert top-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_id,
                    'order' => 6,
                ));
                $top_middle_id = $db->lastInsertId();

                // Insert main-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_id,
                    'order' => 6,
                ));
                $main_middle_id = $db->lastInsertId();

                // Insert main-right
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'right',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_id,
                    'order' => 5,
                ));
                $main_right_id = $db->lastInsertId();

                // Insert menu
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.browse-menu',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_middle_id,
                    'order' => 3,
                ));

                // Insert Breaking News
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.breaking-news-sitenews',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_middle_id,
                    'order' => 4,
                    'params' => '{"heading":"Breaking News","scrollamount":"10","direction":"left","marqueeheight":"29","title":"","nomobile":"0","name":"sitenews.breaking-news-sitenews"}'
                ));

                //Insert Popular News carousel
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.browse-news-sitenews',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_middle_id,
                    'order' => 9,
                    'params' => '{"title":"","titleCount":true,"viewType":["gridView","listView"],"defaultViewType":"gridView","newsOption":["title","view","like","comment","favourite","facebook","twitter","linkedin","googleplus"],"category_id":"0","subcategoryids":null,"hidden_category_id":"","hidden_subcategory_id":"","hidden_subsubcategory_id":"","rss":"0","gridViewHeight":"190","gridViewWidth":"224","showPhotosInJustifiedView":"0","rowHeight":"205","maxRowHeight":"300","margin":"30","lastRow":"nojustify","orderby":"creationDate","show_content":"2","titleTruncation":"50","descriptionTruncation":"450","detactLocation":"0","defaultLocationDistance":"1000","listDescription":"1","itemCountPerPage":"9","nomobile":"0","name":"sitenews.browse-news-sitenews"}'
                ));

                //Insert Search widget
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.search-news-sitenews',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_right_id,
                    'order' => 12,
                    'params' => '{"title":"SEARCH","titleCount":true,"viewType":"vertical","showAllCategories":"1","locationDetection":"1","nomobile":"0","name":"sitenews.search-news-sitenews"}'
                ));

                //Insert Search widget
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.tagcloud-sitenews-news',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_right_id,
                    'order' => 13,
                    'params' => '{"title":"Popular Tags (%s)","titleCount":true,"orderingType":"1","itemCount":"25","loaded_by_ajax":"1","nomobile":"0","name":"sitenews.tagcloud-sitenews-news"}'
                ));
            }
        }
    }

    public function addNewsManagePage($reset, $default = null) {
        $db = $this->getDb();
        $page_id = $this->checkPageId('sitenews_news_manage');
        if ($page_id && $reset) {
            $this->deletePageAndContent($page_id);
            $page_id = false;
        }

        if (!$page_id) {

            if ($this->getCurrentActivateTheme($default) == 3) {
                // Insert page
                $db->insert('engine4_core_pages', array(
                    'name' => 'sitenews_news_manage',
                    'displayname' => 'News - News Manage Page',
                    'title' => 'News Manage Page',
                    'description' => 'This page lets you manage all the published and non-published news created by you.',
                    'custom' => 0,
                ));
                $page_id = $db->lastInsertId();

                // Insert top
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'top',
                    'page_id' => $page_id,
                    'order' => 1,
                ));
                $top_id = $db->lastInsertId();

                // Insert main
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'main',
                    'page_id' => $page_id,
                    'order' => 2,
                ));
                $main_id = $db->lastInsertId();

                // Insert top-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_id,
                    'order' => 3,
                ));
                $top_middle_id = $db->lastInsertId();

                // Insert main-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_id,
                    'order' => 4,
                ));
                $main_middle_id = $db->lastInsertId();

                // Insert menu
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.browse-menu',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_middle_id,
                    'order' => 1,
                ));

                //Insert My NEws widget
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.my-news',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_middle_id,
                    'order' => 1,
                    'params' => '{"title":"","itemCountPerPage":"9","topNavigationLink":["news","rss","createNews","createRss"],"newsNavigationLink":["news","liked","favourite"],"viewType":["gridView","listView"],"newsOption":["title","creationDate","view","location","like","comment","favourite","facebook","twitter","linkedin","googleplus"],"searchButton":"1","defaultViewType":"gridView","gridViewWidth":"337","gridViewHeight":"200","listViewWidth":"150","listViewHeight":"328","listDescription":"1","show_content":"2","orderby":"creation_date","titleTruncation":"110","titleTruncationGridNNewsView":"80","descriptionTruncation":"600","nomobile":"0","name":"sitenews.my-news"}'
                ));
            } else if ($this->getCurrentActivateTheme($default) == 2) {
                // Insert page
                $db->insert('engine4_core_pages', array(
                    'name' => 'sitenews_news_manage',
                    'displayname' => 'News - News Manage Page',
                    'title' => 'News Manage Page',
                    'description' => 'This page lets you manage all the published and non-published news created by you.',
                    'custom' => 0,
                ));
                $page_id = $db->lastInsertId();

                // Insert top
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'top',
                    'page_id' => $page_id,
                    'order' => 1,
                ));
                $top_id = $db->lastInsertId();

                // Insert main
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'main',
                    'page_id' => $page_id,
                    'order' => 2,
                ));
                $main_id = $db->lastInsertId();

                // Insert top-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_id,
                    'order' => 3,
                ));
                $top_middle_id = $db->lastInsertId();

                // Insert main-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_id,
                    'order' => 4,
                ));
                $main_middle_id = $db->lastInsertId();

                // Insert menu
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.browse-menu',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_middle_id,
                    'order' => 1,
                ));

                //Insert My NEws widget
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.my-news',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_middle_id,
                    'order' => 1,
                    'params' => '{"title":"","itemCountPerPage":"9","topNavigationLink":["news","rss","createNews","createRss"],"newsNavigationLink":["news","liked","favourite"],"viewType":["gridView","listView"],"newsOption":["title","creationDate","view","location","like","comment","favourite","facebook","twitter","linkedin","googleplus"],"searchButton":"1","defaultViewType":"gridView","gridViewWidth":"337","gridViewHeight":"200","listViewWidth":"150","listViewHeight":"328","listDescription":"1","show_content":"2","orderby":"creation_date","titleTruncation":"110","titleTruncationGridNNewsView":"80","descriptionTruncation":"600","nomobile":"0","name":"sitenews.my-news"}'
                ));
            } else if ($this->getCurrentActivateTheme($default) == 1) {
                // Insert page
                $db->insert('engine4_core_pages', array(
                    'name' => 'sitenews_news_manage',
                    'displayname' => 'News - News Manage Page',
                    'title' => 'News Manage Page',
                    'description' => 'This page lets you manage all the published and non-published news created by you.',
                    'custom' => 0,
                ));
                $page_id = $db->lastInsertId();

                // Insert top
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'top',
                    'page_id' => $page_id,
                    'order' => 1,
                ));
                $top_id = $db->lastInsertId();

                // Insert main
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'main',
                    'page_id' => $page_id,
                    'order' => 2,
                ));
                $main_id = $db->lastInsertId();

                // Insert top-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_id,
                    'order' => 3,
                ));
                $top_middle_id = $db->lastInsertId();

                // Insert main-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_id,
                    'order' => 4,
                ));
                $main_middle_id = $db->lastInsertId();

                // Insert menu
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.browse-menu',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_middle_id,
                    'order' => 1,
                ));

                //Insert My NEws widget
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.my-news',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_middle_id,
                    'order' => 1,
                    'params' => '{"title":"","itemCountPerPage":"9","topNavigationLink":["news","rss","createNews","createRss"],"newsNavigationLink":["news","liked","favourite"],"viewType":["gridView","listView"],"newsOption":["title","creationDate","view","location","like","comment","favourite","facebook","twitter","linkedin","googleplus"],"searchButton":"1","defaultViewType":"gridView","gridViewWidth":"290","gridViewHeight":"200","listViewWidth":"250","listViewHeight":"328","listDescription":"1","show_content":"2","orderby":"creation_date","titleTruncation":"70","titleTruncationGridNNewsView":"70","descriptionTruncation":"500","nomobile":"0","name":"sitenews.my-news"}'
                ));
            }
        }
    }

    public function addRssViewPage($reset, $default = null) {
        $db = $this->getDb();
        $page_id = $this->checkPageId('sitenews_index_rss-view');
        if ($page_id && $reset) {
            $this->deletePageAndContent($page_id);
            $page_id = false;
        }

        if (!$page_id) {

            if ($this->getCurrentActivateTheme($default) == 3) {
                // Insert page
                $db->insert('engine4_core_pages', array(
                    'name' => 'sitenews_index_rss-view',
                    'displayname' => 'News - RSS View Page',
                    'title' => 'RSS View Page',
                    'description' => 'This page lets you view the selected RSS created by you.',
                    'custom' => 0,
                ));
                $page_id = $db->lastInsertId();

                // Insert top
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'top',
                    'page_id' => $page_id,
                    'order' => 1,
                ));
                $top_id = $db->lastInsertId();

                // Insert main
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'main',
                    'page_id' => $page_id,
                    'order' => 2,
                ));
                $main_id = $db->lastInsertId();

                // Insert top-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_id,
                    'order' => 3,
                ));
                $top_middle_id = $db->lastInsertId();

                // Insert main-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_id,
                    'order' => 4,
                ));
                $main_middle_id = $db->lastInsertId();

                // Insert menu
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.browse-menu',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_middle_id,
                    'order' => 1,
                ));

                //Insert Content widget
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.rss-news',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_middle_id,
                    'order' => 1,
                    'params' => '{"title":"","itemCountPerPage":"9","newsNavigationLink":["news"],"viewType":["gridView","listView"],"newsOption":["title","creationDate","view","location","like","comment","favourite","facebook","twitter","linkedin","googleplus"],"defaultViewType":"gridView","searchButton":"1","gridViewWidth":"253","subscribeRss":"1","show_content":"2","listDescription":"1","titleTruncation":"55","descriptionTruncation":"100","nomobile":"0","name":"sitenews.rss-news"}'
                ));
            } else if ($this->getCurrentActivateTheme($default) == 2) {
                // Insert page
                $db->insert('engine4_core_pages', array(
                    'name' => 'sitenews_index_rss-view',
                    'displayname' => 'News - RSS View Page',
                    'title' => 'RSS View Page',
                    'description' => 'This page lets you view the selected RSS created by you.',
                    'custom' => 0,
                ));
                $page_id = $db->lastInsertId();

                // Insert top
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'top',
                    'page_id' => $page_id,
                    'order' => 1,
                ));
                $top_id = $db->lastInsertId();

                // Insert main
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'main',
                    'page_id' => $page_id,
                    'order' => 2,
                ));
                $main_id = $db->lastInsertId();

                // Insert top-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_id,
                    'order' => 3,
                ));
                $top_middle_id = $db->lastInsertId();

                // Insert main-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_id,
                    'order' => 4,
                ));
                $main_middle_id = $db->lastInsertId();

                // Insert menu
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.browse-menu',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_middle_id,
                    'order' => 1,
                ));

                //Insert Content widget
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.rss-news',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_middle_id,
                    'order' => 1,
                    'params' => '{"title":"","itemCountPerPage":"9","newsNavigationLink":["news"],"viewType":["gridView","listView"],"newsOption":["title","creationDate","view","location","like","comment","favourite","facebook","twitter","linkedin","googleplus"],"defaultViewType":"gridView","searchButton":"1","gridViewWidth":"253","subscribeRss":"1","show_content":"2","listDescription":"1","titleTruncation":"55","descriptionTruncation":"100","nomobile":"0","name":"sitenews.rss-news"}'
                ));
            } else if ($this->getCurrentActivateTheme($default) == 1) {
                // Insert page
                $db->insert('engine4_core_pages', array(
                    'name' => 'sitenews_index_rss-view',
                    'displayname' => 'News - RSS View Page',
                    'title' => 'RSS View Page',
                    'description' => 'This page lets you view the selected RSS created by you.',
                    'custom' => 0,
                ));
                $page_id = $db->lastInsertId();

                // Insert top
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'top',
                    'page_id' => $page_id,
                    'order' => 1,
                ));
                $top_id = $db->lastInsertId();

                // Insert main
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'main',
                    'page_id' => $page_id,
                    'order' => 2,
                ));
                $main_id = $db->lastInsertId();

                // Insert top-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_id,
                    'order' => 3,
                ));
                $top_middle_id = $db->lastInsertId();

                // Insert main-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_id,
                    'order' => 4,
                ));
                $main_middle_id = $db->lastInsertId();

                // Insert menu
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.browse-menu',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_middle_id,
                    'order' => 1,
                ));

                //Insert Content widget
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.rss-news',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_middle_id,
                    'order' => 1,
                    'params' => '{"title":"","itemCountPerPage":"9","newsNavigationLink":["news"],"viewType":["gridView","listView"],"newsOption":["title","creationDate","view","location","like","comment","favourite","facebook","twitter","linkedin","googleplus"],"defaultViewType":"gridView","searchButton":"1","gridViewHeight":"200", "gridViewWidth":"269", "subscribeRss":"1","show_content":"2","listDescription":"1","titleTruncation":"22","descriptionTruncation":"100","nomobile":"0","name":"sitenews.rss-news"}'
                ));
            }
        }
    }

    public function addNewsPinboardPage($reset, $default = null) {
        $db = $this->getDb();
        $page_id = $this->checkPageId('sitenews_news_pinboard');
        if ($page_id && $reset) {
            $this->deletePageAndContent($page_id);
            $page_id = false;
        }

        if (!$page_id) {

            if ($this->getCurrentActivateTheme($default) == 3) {
                // Insert page
                $db->insert('engine4_core_pages', array(
                    'name' => 'sitenews_news_pinboard',
                    'displayname' => 'News - News Pinboard View Page',
                    'title' => 'News Pinboard View Page',
                    'description' => 'This page lets you view the published news in attractive pinboard view.',
                    'custom' => 0,
                ));
                $page_id = $db->lastInsertId();

                // Insert top
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'top',
                    'page_id' => $page_id,
                    'order' => 1,
                ));
                $top_id = $db->lastInsertId();

                // Insert main
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'main',
                    'page_id' => $page_id,
                    'order' => 2,
                ));
                $main_id = $db->lastInsertId();

                // Insert top-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_id,
                    'order' => 3,
                ));
                $top_middle_id = $db->lastInsertId();

                // Insert main-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_id,
                    'order' => 4,
                ));
                $main_middle_id = $db->lastInsertId();

                // Insert menu
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.browse-menu',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_middle_id,
                    'order' => 1,
                ));

                //Insert News Pinboard widget
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.pinboard-browse-news-sitenews',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_middle_id,
                    'order' => 1,
                    'params' => '{"title":"","titleCount":true,"newsOption":"","view_count":"1","interval":"overall","category_id":"0","subcategory_id":null,"hidden_news_category_id":"","hidden_news_subcategory_id":"","hidden_news_subsubcategory_id":"","rss":"0","userComment":"1","autoload":"0","defaultLoadingImage":"1","itemWidth":"292","withoutStretch":"0","itemCountPerPage":"9","show_buttons":["comment","like","favourite","facebook","twitter","pinit","googleplus"],"titleTruncation":"55","descriptionTruncation":"300","detactLocation":"0","defaultLocationDistance":"1000","truncationLocation":"30","nomobile":"0","name":"sitenews.pinboard-browse-news-sitenews"}'
                ));
            } else if ($this->getCurrentActivateTheme($default) == 2) {
                // Insert page
                $db->insert('engine4_core_pages', array(
                    'name' => 'sitenews_news_pinboard',
                    'displayname' => 'News - News Pinboard View Page',
                    'title' => 'News Pinboard View Page',
                    'description' => 'This page lets you view the published news in attractive pinboard view.',
                    'custom' => 0,
                ));
                $page_id = $db->lastInsertId();

                // Insert top
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'top',
                    'page_id' => $page_id,
                    'order' => 1,
                ));
                $top_id = $db->lastInsertId();

                // Insert main
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'main',
                    'page_id' => $page_id,
                    'order' => 2,
                ));
                $main_id = $db->lastInsertId();

                // Insert top-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_id,
                    'order' => 3,
                ));
                $top_middle_id = $db->lastInsertId();

                // Insert main-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_id,
                    'order' => 4,
                ));
                $main_middle_id = $db->lastInsertId();

                // Insert menu
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.browse-menu',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_middle_id,
                    'order' => 1,
                ));

                //Insert News Pinboard widget
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.pinboard-browse-news-sitenews',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_middle_id,
                    'order' => 1,
                    'params' => '{"title":"","titleCount":true,"newsOption":"","view_count":"1","interval":"overall","category_id":"0","subcategory_id":null,"hidden_news_category_id":"","hidden_news_subcategory_id":"","hidden_news_subsubcategory_id":"","rss":"0","userComment":"1","autoload":"0","defaultLoadingImage":"1","itemWidth":"269","withoutStretch":"1","itemCountPerPage":"9","show_buttons":["comment","like","favourite","facebook","twitter","pinit","googleplus"],"titleTruncation":"55","descriptionTruncation":"300","detactLocation":"0","defaultLocationDistance":"1000","truncationLocation":"28","nomobile":"0","name":"sitenews.pinboard-browse-news-sitenews"}'
                ));
            } else if ($this->getCurrentActivateTheme($default) == 1) {
                // Insert page
                $db->insert('engine4_core_pages', array(
                    'name' => 'sitenews_news_pinboard',
                    'displayname' => 'News - News Pinboard View Page',
                    'title' => 'News Pinboard View Page',
                    'description' => 'This page lets you view the published news in attractive pinboard view.',
                    'custom' => 0,
                ));
                $page_id = $db->lastInsertId();

                // Insert top
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'top',
                    'page_id' => $page_id,
                    'order' => 1,
                ));
                $top_id = $db->lastInsertId();

                // Insert main
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'main',
                    'page_id' => $page_id,
                    'order' => 2,
                ));
                $main_id = $db->lastInsertId();

                // Insert top-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_id,
                    'order' => 3,
                ));
                $top_middle_id = $db->lastInsertId();

                // Insert main-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_id,
                    'order' => 4,
                ));
                $main_middle_id = $db->lastInsertId();

                // Insert menu
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.browse-menu',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_middle_id,
                    'order' => 1,
                ));

                //Insert News Pinboard widget
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.pinboard-browse-news-sitenews',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_middle_id,
                    'order' => 1,
                    'params' => '{"title":"","titleCount":true,"newsOption":"","view_count":"1","interval":"overall","category_id":"0","subcategory_id":null,"hidden_news_category_id":"","hidden_news_subcategory_id":"","hidden_news_subsubcategory_id":"","rss":"0","userComment":"1","autoload":"1","defaultLoadingImage":"1","itemWidth":"309","withoutStretch":"0","itemCountPerPage":"9","show_buttons":["comment","like","favourite","facebook","twitter","pinit","googleplus"],"titleTruncation":"22","descriptionTruncation":"200","detactLocation":"0","defaultLocationDistance":"1000","truncationLocation":"35","nomobile":"0","name":"sitenews.pinboard-browse-news-sitenews"}'
                ));
            }
        }
    }

    public function addNewsMapPage($reset, $default = null) {
        $db = $this->getDb();

        $page_id = $this->checkPageId('sitenews_news_map');
        if ($page_id && $reset) {
            $this->deletePageAndContent($page_id);
            $page_id = false;
        }

        if (!$page_id) {

            if ($this->getCurrentActivateTheme($default) == 3) {
                // Insert page
                $db->insert('engine4_core_pages', array(
                    'name' => 'sitenews_news_map',
                    'displayname' => 'News - Browse News Location Page',
                    'title' => 'Browse News Location Page',
                    'description' => 'This page lets you view the published news via their locations with the google map.',
                    'custom' => 0,
                ));
                $page_id = $db->lastInsertId();

                // Insert top
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'top',
                    'page_id' => $page_id,
                    'order' => 1,
                ));
                $top_id = $db->lastInsertId();

                // Insert main
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'main',
                    'page_id' => $page_id,
                    'order' => 2,
                ));
                $main_id = $db->lastInsertId();

                // Insert top-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_id,
                    'order' => 3,
                ));
                $top_middle_id = $db->lastInsertId();

                // Insert main-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_id,
                    'order' => 4,
                ));
                $main_middle_id = $db->lastInsertId();

                // Insert menu
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.browse-menu',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_middle_id,
                    'order' => 1,
                ));

                //Insert News Pinboard widget
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.browselocation-sitenews',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_middle_id,
                    'order' => 1,
                    'params' => '{"title":"","titleCount":true,"showAllCategories":"1","locationDetection":"1","newsOption":["title","owner","creationDate","view","like","comment","location","rating","favourite","facebook","twitter","linkedin","googleplus"],"nomobile":"0","name":"sitenews.browselocation-sitenews"}'
                ));
            } else if ($this->getCurrentActivateTheme($default) == 2) {
                // Insert page
                $db->insert('engine4_core_pages', array(
                    'name' => 'sitenews_news_map',
                    'displayname' => 'News - Browse News Location Page',
                    'title' => 'Browse News Location Page',
                    'description' => 'This page lets you view the published news via their locations with the google map.',
                    'custom' => 0,
                ));
                $page_id = $db->lastInsertId();

                // Insert top
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'top',
                    'page_id' => $page_id,
                    'order' => 1,
                ));
                $top_id = $db->lastInsertId();

                // Insert main
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'main',
                    'page_id' => $page_id,
                    'order' => 2,
                ));
                $main_id = $db->lastInsertId();

                // Insert top-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_id,
                    'order' => 3,
                ));
                $top_middle_id = $db->lastInsertId();

                // Insert main-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_id,
                    'order' => 4,
                ));
                $main_middle_id = $db->lastInsertId();

                // Insert menu
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.browse-menu',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_middle_id,
                    'order' => 1,
                ));

                //Insert News Pinboard widget
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.browselocation-sitenews',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_middle_id,
                    'order' => 1,
                    'params' => '{"title":"Latest News","titleCount":true,"showAllCategories":"1","locationDetection":"1","newsOption":["title","creationDate","view","like","comment","location","favourite","facebook","twitter","linkedin","googleplus"],"nomobile":"0","name":"sitenews.browselocation-sitenews"}'
                ));
            } else if ($this->getCurrentActivateTheme($default) == 1) {
                // Insert page
                $db->insert('engine4_core_pages', array(
                    'name' => 'sitenews_news_map',
                    'displayname' => 'News - Browse News Location Page',
                    'title' => 'Browse News Location Page',
                    'description' => 'This page lets you view the published news via their locations with the google map.',
                    'custom' => 0,
                ));
                $page_id = $db->lastInsertId();

                // Insert top
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'top',
                    'page_id' => $page_id,
                    'order' => 1,
                ));
                $top_id = $db->lastInsertId();

                // Insert main
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'main',
                    'page_id' => $page_id,
                    'order' => 2,
                ));
                $main_id = $db->lastInsertId();

                // Insert top-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_id,
                    'order' => 3,
                ));
                $top_middle_id = $db->lastInsertId();

                // Insert main-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_id,
                    'order' => 4,
                ));
                $main_middle_id = $db->lastInsertId();

                // Insert menu
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.browse-menu',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_middle_id,
                    'order' => 1,
                ));

                //Insert News Pinboard widget
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.browselocation-sitenews',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_middle_id,
                    'order' => 1,
                    'params' => '{"title":"","titleCount":true,"showAllCategories":"1","locationDetection":"1","newsOption":["title","creationDate","view","like","comment","location","favourite","facebook","twitter","linkedin","googleplus"],"nomobile":"0","name":"sitenews.browselocation-sitenews"}'
                ));
            }
        }
    }

    public function addNewsListPage($reset, $default = null) {
        $db = $this->getDb();

        $page_id = $this->checkPageId('sitenews_news_list');
        if ($page_id && $reset) {
            $this->deletePageAndContent($page_id);
            $page_id = false;
        }

        if (!$page_id) {

            // Insert page
            $db->insert('engine4_core_pages', array(
                'name' => 'sitenews_news_list',
                'displayname' => 'News - News List Page',
                'title' => 'List News',
                'description' => '',
                'custom' => 0,
            ));
            $page_id = $db->lastInsertId();

            // Insert top
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'top',
                'page_id' => $page_id,
                'order' => 1,
            ));
            $top_id = $db->lastInsertId();

            // Insert main
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'main',
                'page_id' => $page_id,
                'order' => 2,
            ));
            $main_id = $db->lastInsertId();

            // Insert top-middle
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'middle',
                'page_id' => $page_id,
                'parent_content_id' => $top_id,
                'order' => 3,
            ));
            $top_middle_id = $db->lastInsertId();

            // Insert main-middle
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'middle',
                'page_id' => $page_id,
                'parent_content_id' => $main_id,
                'order' => 4,
            ));
            $main_middle_id = $db->lastInsertId();

            // Insert menu
            $db->insert('engine4_core_content', array(
                'type' => 'widget',
                'name' => 'sitenews.browse-menu',
                'page_id' => $page_id,
                'parent_content_id' => $top_middle_id,
                'order' => 1,
            ));

            //Insert News Pinboard widget
            $db->insert('engine4_core_content', array(
                'type' => 'widget',
                'name' => 'sitenews.news-recently-view-random-sitenews',
                'page_id' => $page_id,
                'parent_content_id' => $main_middle_id,
                'order' => 1,
                'params' => '{"title":"","itemCountPerPage":"","category_id":"0","subcategory_id":null,"hidden_news_category_id":"","hidden_news_subcategory_id":"","hidden_news_subsubcategory_id":"","rss":"0","viewType":"","defaultViewType":"listView","ajaxTabs":["mostZZZrecent","mostZZZliked","mostZZZviewed","mostZZZcommented","mostZZZfavourites","random"],"newsOption":["title","owner","creationDate","view","like","comment","location","favourite","facebook","twitter","linkedin","googleplus"],"gridViewHeight":"200","gridViewWidth":"250","newsTitleTruncation":"22","detactLocation":"0","popularType":"comment","interval":"overall","gridItemCountPerPage":"9","listItemCountPerPage":"9","titleTruncation":"22","titleTruncationGridNNewsView":"22","descriptionTruncation":"200","loaded_by_ajax":"1","showViewMore":"1","nomobile":"0","name":"sitenews.news-recently-view-random-sitenews"}'
            ));
        }
    }

    public function addNewsTagcloudPage($reset, $default = null) {
        $db = $this->getDb();

        $page_id = $this->checkPageId('sitenews_news_tagscloud');
        if ($page_id && $reset) {
            $this->deletePageAndContent($page_id);
            $page_id = false;
        }

        if (!$page_id) {

            // Insert page
            $db->insert('engine4_core_pages', array(
                'name' => 'sitenews_news_tagscloud',
                'displayname' => 'News - News Tags Page',
                'title' => 'News Tagcloud',
                'description' => '',
                'custom' => 0,
            ));
            $page_id = $db->lastInsertId();

            // Insert top
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'top',
                'page_id' => $page_id,
                'order' => 1,
            ));
            $top_id = $db->lastInsertId();

            // Insert main
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'main',
                'page_id' => $page_id,
                'order' => 2,
            ));
            $main_id = $db->lastInsertId();

            // Insert top-middle
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'middle',
                'page_id' => $page_id,
                'parent_content_id' => $top_id,
                'order' => 3,
            ));
            $top_middle_id = $db->lastInsertId();

            // Insert main-middle
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'middle',
                'page_id' => $page_id,
                'parent_content_id' => $main_id,
                'order' => 4,
            ));
            $main_middle_id = $db->lastInsertId();

            // Insert menu
            $db->insert('engine4_core_content', array(
                'type' => 'widget',
                'name' => 'sitenews.browse-menu',
                'page_id' => $page_id,
                'parent_content_id' => $top_middle_id,
                'order' => 1,
            ));

            //Insert News Tagcloud widget
            $db->insert('engine4_core_content', array(
                'type' => 'widget',
                'name' => 'sitenews.tagcloud-sitenews-news',
                'page_id' => $page_id,
                'parent_content_id' => $main_middle_id,
                'order' => 1,
                'params' => '{"title":"Popular Tags","titleCount":true,"orderingType":"1","itemCount":"0","loaded_by_ajax":"1","nomobile":"0","name":"sitenews.tagcloud-sitenews-news"}'
            ));
        }
    }

    public function addRssManagePage($reset, $default = null) {
        $db = $this->getDb();

        $page_id = $this->checkPageId('sitenews_index_manage');
        if ($page_id && $reset) {
            $this->deletePageAndContent($page_id);
            $page_id = false;
        }

        if (!$page_id) {

            if ($this->getCurrentActivateTheme($default) == 3) {
                // Insert page
                $db->insert('engine4_core_pages', array(
                    'name' => 'sitenews_index_manage',
                    'displayname' => 'News - RSS Manage Page',
                    'title' => 'RSS Manage Page',
                    'description' => 'This page lets you manage all the published and non-published RSS created by you.',
                    'custom' => 0,
                ));
                $page_id = $db->lastInsertId();

                // Insert top
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'top',
                    'page_id' => $page_id,
                    'order' => 1,
                ));
                $top_id = $db->lastInsertId();

                // Insert main
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'main',
                    'page_id' => $page_id,
                    'order' => 2,
                ));
                $main_id = $db->lastInsertId();

                // Insert top-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_id,
                    'order' => 3,
                ));
                $top_middle_id = $db->lastInsertId();

                // Insert main-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_id,
                    'order' => 4,
                ));
                $main_middle_id = $db->lastInsertId();

                // Insert menu
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.browse-menu',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_middle_id,
                    'order' => 1,
                ));

                //Insert My Rss widget
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.my-rss',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_middle_id,
                    'order' => 1,
                    'params' => '{"title":"","titleCount":true,"topNavigationLink":["news","rss","createNews","createRss"],"rssNavigationLink":["rss","subscribed"],"viewType":["gridView","listView"],"rssOption":["title","numberOfFeeds","subscribe","rssUrl","creatonDate","category","published"],"defaultViewType":"listView","searchButton":"1","gridViewWidth":"268","show_content":"2","itemCountPerPage":"9","titleTruncation":"20","nomobile":"0","name":"sitenews.my-rss"}'
                ));
            } else if ($this->getCurrentActivateTheme($default) == 2) {
                // Insert page
                $db->insert('engine4_core_pages', array(
                    'name' => 'sitenews_index_manage',
                    'displayname' => 'News - RSS Manage Page',
                    'title' => 'RSS Manage Page',
                    'description' => 'This page lets you manage all the published and non-published RSS created by you.',
                    'custom' => 0,
                ));
                $page_id = $db->lastInsertId();

                // Insert top
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'top',
                    'page_id' => $page_id,
                    'order' => 1,
                ));
                $top_id = $db->lastInsertId();

                // Insert main
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'main',
                    'page_id' => $page_id,
                    'order' => 2,
                ));
                $main_id = $db->lastInsertId();

                // Insert top-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_id,
                    'order' => 3,
                ));
                $top_middle_id = $db->lastInsertId();

                // Insert main-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_id,
                    'order' => 4,
                ));
                $main_middle_id = $db->lastInsertId();

                // Insert menu
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.browse-menu',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_middle_id,
                    'order' => 1,
                ));

                //Insert My Rss widget
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.my-rss',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_middle_id,
                    'order' => 1,
                    'params' => '{"title":"","titleCount":true,"topNavigationLink":["news","rss","createNews","createRss"],"rssNavigationLink":["rss","subscribed"],"viewType":["listView"],"rssOption":["title","numberOfFeeds","subscribe","rssUrl","creatonDate","category","published"],"defaultViewType":"listView","searchButton":"1","gridViewWidth":"337","show_content":"2","itemCountPerPage":"9","titleTruncation":"20","nomobile":"0","name":"sitenews.my-rss"}'
                ));
            } else if ($this->getCurrentActivateTheme($default) == 1) {
                // Insert page
                $db->insert('engine4_core_pages', array(
                    'name' => 'sitenews_index_manage',
                    'displayname' => 'News - RSS Manage Page',
                    'title' => 'RSS Manage Page',
                    'description' => 'This page lets you manage all the published and non-published RSS created by you.',
                    'custom' => 0,
                ));
                $page_id = $db->lastInsertId();

                // Insert top
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'top',
                    'page_id' => $page_id,
                    'order' => 1,
                ));
                $top_id = $db->lastInsertId();

                // Insert main
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'main',
                    'page_id' => $page_id,
                    'order' => 2,
                ));
                $main_id = $db->lastInsertId();

                // Insert top-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_id,
                    'order' => 3,
                ));
                $top_middle_id = $db->lastInsertId();

                // Insert main-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_id,
                    'order' => 4,
                ));
                $main_middle_id = $db->lastInsertId();

                // Insert menu
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.browse-menu',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_middle_id,
                    'order' => 1,
                ));

                //Insert My Rss widget
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.my-rss',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_middle_id,
                    'order' => 1,
                    'params' => '{"title":"","titleCount":true,"topNavigationLink":["news","rss","createNews","createRss"],"rssNavigationLink":["rss","subscribed"],"viewType":["listView"],"rssOption":["title","numberOfFeeds","subscribe","rssUrl","creatonDate","category","published"],"defaultViewType":"listView","searchButton":"1","gridViewWidth":"290","show_content":"2","itemCountPerPage":"9","titleTruncation":"20","nomobile":"0","name":"sitenews.my-rss"}'
                ));
            }
        }
    }

    public function addCategoryPage($reset, $default = null) {
        $db = $this->getDb();

        $page_id = $this->checkPageId('sitenews_news_categories');
        if ($page_id && $reset) {
            $this->deletePageAndContent($page_id);
            $page_id = false;
        }

        if (!$page_id) {

            if ($this->getCurrentActivateTheme($default) == 3) {
                // Insert page
                $db->insert('engine4_core_pages', array(
                    'name' => 'sitenews_news_categories',
                    'displayname' => 'News - Categories Home Page',
                    'title' => 'News Categories Home Page',
                    'description' => 'This is news categories home page.',
                    'custom' => 0,
                ));
                $page_id = $db->lastInsertId();

                // Insert top
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'top',
                    'page_id' => $page_id,
                    'order' => 1,
                ));
                $top_id = $db->lastInsertId();

                // Insert top-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_id,
                    'order' => 3,
                ));
                $top_middle_id = $db->lastInsertId();

                // Insert main
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'main',
                    'page_id' => $page_id,
                    'order' => 2,
                ));
                $main_id = $db->lastInsertId();

                // Insert top-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_id,
                    'order' => 2,
                ));
                $main_middle_id = $db->lastInsertId();

                // Insert menu
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.browse-menu',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_middle_id,
                    'order' => 3,
                ));

                //Insert Content
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.news-categorybanner-slideshow',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_middle_id,
                    'order' => 4,
                    'params' => '{"title":"","logo":"","height":"555","categoryHeight":"400","fullWidth":"1","category_id":["1","2","3","4","5","6","7","8","9","10","11","12","13","14","15"],"showExplore":"1","titleTruncation":"50","titleNewsTruncation":"100","newsCount":"6","nomobile":"","name":"sitenews.news-categorybanner-slideshow"}'
                ));

                //Insert Content
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.categories-withicon-grid-view',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_middle_id,
                    'order' => 1,
                    'params' => '{"title":"","titleCount":true,"orderBy":"cat_order","showAllCategories":"1","columnWidth":"217","columnHeight":"190","showIcon":"1","nomobile":"0","name":"sitenews.categories-withicon-grid-view"}'
                ));

                //Insert Content
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.popular-news-carousel',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_middle_id,
                    'order' => 2,
                    'params' => '{"title":"Recent News","category_id":"0","subcategory_id":null,"hidden_news_category_id":"","hidden_news_subcategory_id":"","hidden_news_subsubcategory_id":"","rss":"0","showNews":"all_feeds","newsOption":["title","creationDate","view","like","comment","favourite","facebook","twitter","linkedin","googleplus"],"showPagination":"1","carouselType":"horizontal","newsWidth":"1171","itemWidth":"0","newsHeight":"250","itemCount":"5","popularType":"viewCount","interval":"3500","titleTruncation":"45","nomobile":"0","name":"sitenews.popular-news-carousel"}'
                ));
            } elseif ($this->getCurrentActivateTheme($default) == 2) {
                // Insert page
                $db->insert('engine4_core_pages', array(
                    'name' => 'sitenews_news_categories',
                    'displayname' => 'News - Categories Home Page',
                    'title' => 'News Categories Home Page',
                    'description' => 'This is news categories home page.',
                    'custom' => 0,
                ));
                $page_id = $db->lastInsertId();

                // Insert top
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'top',
                    'page_id' => $page_id,
                    'order' => 1,
                ));
                $top_id = $db->lastInsertId();

                // Insert top-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_id,
                    'order' => 3,
                ));
                $top_middle_id = $db->lastInsertId();

                // Insert main
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'main',
                    'page_id' => $page_id,
                    'order' => 2,
                ));
                $main_id = $db->lastInsertId();

                // Insert top-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_id,
                    'order' => 2,
                ));
                $main_middle_id = $db->lastInsertId();

                // Insert menu
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.browse-menu',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_middle_id,
                    'order' => 3,
                ));

                //Insert Content
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.news-categorybanner-slideshow',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_middle_id,
                    'order' => 4,
                    'params' => '{"title":"","logo":"","height":"555","categoryHeight":"400","fullWidth":"0","category_id":["1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17"],"showExplore":"1","titleTruncation":"100","titleNewsTruncation":"100","newsCount":"5","nomobile":"","name":"sitenews.news-categorybanner-slideshow"}'
                ));

                //Insert Content
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.categories-withicon-grid-view',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_middle_id,
                    'order' => 1,
                    'params' => '{"title":"Categories in Grid View","titleCount":true,"orderBy":"cat_order","showAllCategories":"1","columnWidth":"199","columnHeight":"195","showIcon":"1","nomobile":"0","name":"sitenews.categories-withicon-grid-view"}'
                ));

                //Insert Content
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.popular-news-carousel',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_middle_id,
                    'order' => 2,
                    'params' => '{"title":"Recent News","category_id":"0","subcategory_id":null,"hidden_news_category_id":"","hidden_news_subcategory_id":"","hidden_news_subsubcategory_id":"","rss":"0","showNews":"all_feeds","newsOption":["title","creationDate","view","like","comment","favourite","facebook","twitter","linkedin","googleplus"],"showPagination":"1","carouselType":"horizontal","newsWidth":"1083","itemWidth":"0","newsHeight":"250","itemCount":"5","popularType":"featured","interval":"3500","titleTruncation":"42","nomobile":"0","name":"sitenews.popular-news-carousel"}'
                ));
            } else if ($this->getCurrentActivateTheme($default) == 1) {
                // Insert page
                $db->insert('engine4_core_pages', array(
                    'name' => 'sitenews_news_categories',
                    'displayname' => 'News - Categories Home Page',
                    'title' => 'News Categories Home Page',
                    'description' => 'This is news categories home page.',
                    'custom' => 0,
                ));
                $page_id = $db->lastInsertId();

                // Insert top
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'top',
                    'page_id' => $page_id,
                    'order' => 1,
                ));
                $top_id = $db->lastInsertId();

                // Insert top-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_id,
                    'order' => 3,
                ));
                $top_middle_id = $db->lastInsertId();

                // Insert main
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'main',
                    'page_id' => $page_id,
                    'order' => 2,
                ));
                $main_id = $db->lastInsertId();

                // Insert top-middle
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_id,
                    'order' => 2,
                ));
                $main_middle_id = $db->lastInsertId();

                // Insert menu
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.browse-menu',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_middle_id,
                    'order' => 3,
                ));

                //Insert Content
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.news-categorybanner-slideshow',
                    'page_id' => $page_id,
                    'parent_content_id' => $top_middle_id,
                    'order' => 4,
                    'params' => '{"title":"","logo":"","height":"555","categoryHeight":"400","fullWidth":"0","category_id":["1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17"],"showExplore":"1","titleTruncation":"100","titleNewsTruncation":"60","newsCount":"4","nomobile":"","name":"sitenews.news-categorybanner-slideshow"}'
                ));

                //Insert Content
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.categories-withicon-grid-view',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_middle_id,
                    'order' => 1,
                    'params' => '{"title":"","titleCount":true,"orderBy":"cat_order","showAllCategories":"1","columnWidth":"169","columnHeight":"150","showIcon":"1","nomobile":"0","name":"sitenews.categories-withicon-grid-view"}'
                ));

                //Insert Content
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitenews.popular-news-carousel',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_middle_id,
                    'order' => 2,
                    'params' => '{"title":"Recent News","category_id":"0","subcategory_id":null,"hidden_news_category_id":"","hidden_news_subcategory_id":"","hidden_news_subsubcategory_id":"","rss":"0","showNews":"all_feeds","newsOption":["title","creationDate","view","like","comment","favourite","facebook","twitter","linkedin","googleplus"],"showPagination":"1","carouselType":"horizontal","newsWidth":"930","itemWidth":"0","newsHeight":"200","itemCount":"5","popularType":"featured","interval":"3500","titleTruncation":"30","nomobile":"0","name":"sitenews.popular-news-carousel"}'
                ));
            }
        }
    }

    public function addNewsCreatePage($reset, $default = null) {
        $db = $this->getDb();
        $page_id = $this->checkPageId('sitenews_news_create');
        if ($page_id && $reset) {
            $this->deletePageAndContent($page_id);
            $page_id = false;
        }

        if (!$page_id) {

            // Insert page
            $db->insert('engine4_core_pages', array(
                'name' => 'sitenews_news_create',
                'displayname' => 'News - News Create Page',
                'title' => 'News Create Page',
                'description' => 'This page lets you create new news and publish accordingly.',
                'custom' => 0,
            ));
            $page_id = $db->lastInsertId();

            // Insert top
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'top',
                'page_id' => $page_id,
                'order' => 1,
            ));
            $top_id = $db->lastInsertId();

            // Insert main
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'main',
                'page_id' => $page_id,
                'order' => 2,
            ));
            $main_id = $db->lastInsertId();

            // Insert top-middle
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'middle',
                'page_id' => $page_id,
                'parent_content_id' => $top_id,
                'order' => 6,
            ));
            $top_middle_id = $db->lastInsertId();

            // Insert main-middle
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'middle',
                'page_id' => $page_id,
                'parent_content_id' => $main_id,
                'order' => 6,
            ));
            $main_middle_id = $db->lastInsertId();

            // Insert menu
            $db->insert('engine4_core_content', array(
                'type' => 'widget',
                'name' => 'sitenews.browse-menu',
                'page_id' => $page_id,
                'parent_content_id' => $top_middle_id,
                'order' => 3,
            ));

            //Insert Content
            $db->insert('engine4_core_content', array(
                'type' => 'widget',
                'name' => 'core.content',
                'page_id' => $page_id,
                'parent_content_id' => $main_middle_id,
                'order' => 6,
                'params' => ''
            ));
        }
    }

    public function addNewsEditPage($reset, $default = null) {
        $db = $this->getDb();
        $page_id = $this->checkPageId('sitenews_news_edit');
        if ($page_id && $reset) {
            $this->deletePageAndContent($page_id);
            $page_id = false;
        }

        if (!$page_id) {

            // Insert page
            $db->insert('engine4_core_pages', array(
                'name' => 'sitenews_news_edit',
                'displayname' => 'News - News Edit Page',
                'title' => 'News Edit Page',
                'description' => 'This page lets you edit news and publish accordingly.',
                'custom' => 0,
            ));
            $page_id = $db->lastInsertId();

            // Insert top
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'top',
                'page_id' => $page_id,
                'order' => 1,
            ));
            $top_id = $db->lastInsertId();

            // Insert main
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'main',
                'page_id' => $page_id,
                'order' => 2,
            ));
            $main_id = $db->lastInsertId();

            // Insert top-middle
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'middle',
                'page_id' => $page_id,
                'parent_content_id' => $top_id,
                'order' => 6,
            ));
            $top_middle_id = $db->lastInsertId();

            // Insert main-middle
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'middle',
                'page_id' => $page_id,
                'parent_content_id' => $main_id,
                'order' => 6,
            ));
            $main_middle_id = $db->lastInsertId();

            // Insert menu
            $db->insert('engine4_core_content', array(
                'type' => 'widget',
                'name' => 'sitenews.browse-menu',
                'page_id' => $page_id,
                'parent_content_id' => $top_middle_id,
                'order' => 3,
            ));

            //Insert Content
            $db->insert('engine4_core_content', array(
                'type' => 'widget',
                'name' => 'core.content',
                'page_id' => $page_id,
                'parent_content_id' => $main_middle_id,
                'order' => 6,
                'params' => ''
            ));
        }
    }

    public function addRssCreatePage($reset, $default = null) {
        $db = $this->getDb();

        $page_id = $this->checkPageId('sitenews_index_feed');
        if ($page_id && $reset) {
            $this->deletePageAndContent($page_id);
            $page_id = false;
        }

        if (!$page_id) {

            // Insert page
            $db->insert('engine4_core_pages', array(
                'name' => 'sitenews_index_feed',
                'displayname' => 'News - RSS Create Page',
                'title' => 'RSS Create Page',
                'description' => 'This page lets you add a new RSS and publish accordingly.',
                'custom' => 0,
            ));
            $page_id = $db->lastInsertId();

            // Insert top
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'top',
                'page_id' => $page_id,
                'order' => 1,
            ));
            $top_id = $db->lastInsertId();

            // Insert main
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'main',
                'page_id' => $page_id,
                'order' => 2,
            ));
            $main_id = $db->lastInsertId();

            // Insert top-middle
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'middle',
                'page_id' => $page_id,
                'parent_content_id' => $top_id,
                'order' => 6,
            ));
            $top_middle_id = $db->lastInsertId();

            // Insert main-middle
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'middle',
                'page_id' => $page_id,
                'parent_content_id' => $main_id,
                'order' => 6,
            ));
            $main_middle_id = $db->lastInsertId();

            // Insert menu
            $db->insert('engine4_core_content', array(
                'type' => 'widget',
                'name' => 'sitenews.browse-menu',
                'page_id' => $page_id,
                'parent_content_id' => $top_middle_id,
                'order' => 3,
            ));

            //Insert Content
            $db->insert('engine4_core_content', array(
                'type' => 'widget',
                'name' => 'core.content',
                'page_id' => $page_id,
                'parent_content_id' => $main_middle_id,
                'order' => 6,
                'params' => ''
            ));
        }
    }

    public function addRssEditPage($reset, $default = null) {
        $db = $this->getDb();

        $page_id = $this->checkPageId('sitenews_index_edit');
        if ($page_id && $reset) {
            $this->deletePageAndContent($page_id);
            $page_id = false;
        }

        if (!$page_id) {

            // Insert page
            $db->insert('engine4_core_pages', array(
                'name' => 'sitenews_index_edit',
                'displayname' => 'News - RSS Edit Page',
                'title' => 'RSS Edit Page',
                'description' => 'This page lets you edit the RSS and publish accordingly.',
                'custom' => 0,
            ));
            $page_id = $db->lastInsertId();

            // Insert top
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'top',
                'page_id' => $page_id,
                'order' => 1,
            ));
            $top_id = $db->lastInsertId();

            // Insert main
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'main',
                'page_id' => $page_id,
                'order' => 2,
            ));
            $main_id = $db->lastInsertId();

            // Insert top-middle
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'middle',
                'page_id' => $page_id,
                'parent_content_id' => $top_id,
                'order' => 6,
            ));
            $top_middle_id = $db->lastInsertId();

            // Insert main-middle
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'middle',
                'page_id' => $page_id,
                'parent_content_id' => $main_id,
                'order' => 6,
            ));
            $main_middle_id = $db->lastInsertId();

            // Insert menu
            $db->insert('engine4_core_content', array(
                'type' => 'widget',
                'name' => 'sitenews.browse-menu',
                'page_id' => $page_id,
                'parent_content_id' => $top_middle_id,
                'order' => 3,
            ));

            //Insert Content
            $db->insert('engine4_core_content', array(
                'type' => 'widget',
                'name' => 'core.content',
                'page_id' => $page_id,
                'parent_content_id' => $main_middle_id,
                'order' => 6,
                'params' => ''
            ));
        }
    }

    public function addRssListPage($reset, $default = null) {
        $db = $this->getDb();

        $page_id = $this->checkPageId('sitenews_index_list-rss');
        if ($page_id && $reset) {
            $this->deletePageAndContent($page_id);
            $page_id = false;
        }

        if (!$page_id) {

            // Insert page
            $db->insert('engine4_core_pages', array(
                'name' => 'sitenews_index_list-rss',
                'displayname' => 'News - RSS List Page',
                'title' => 'RSS List Page',
                'description' => 'This page lists all the RSS added on website.',
                'custom' => 0,
            ));
            $page_id = $db->lastInsertId();

            // Insert top
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'top',
                'page_id' => $page_id,
                'order' => 1,
            ));
            $top_id = $db->lastInsertId();

            // Insert main
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'main',
                'page_id' => $page_id,
                'order' => 2,
            ));
            $main_id = $db->lastInsertId();

            // Insert top-middle
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'middle',
                'page_id' => $page_id,
                'parent_content_id' => $top_id,
                'order' => 3,
            ));
            $top_middle_id = $db->lastInsertId();

            // Insert main-middle
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'middle',
                'page_id' => $page_id,
                'parent_content_id' => $main_id,
                'order' => 4,
            ));
            $main_middle_id = $db->lastInsertId();

            // Insert menu
            $db->insert('engine4_core_content', array(
                'type' => 'widget',
                'name' => 'sitenews.browse-menu',
                'page_id' => $page_id,
                'parent_content_id' => $top_middle_id,
                'order' => 1,
            ));

            //Insert My RSS widget
            $db->insert('engine4_core_content', array(
                'type' => 'widget',
                'name' => 'sitenews.list-rss-sitenews',
                'page_id' => $page_id,
                'parent_content_id' => $main_middle_id,
                'order' => 1,
                'params' => '{"rss_ids":"","toValues":"","titleTruncation":"22","subscribeRss":"1","showAll":"true","viewAllLink":"1","title":"Rss Feeds","nomobile":"0","name":"sitenews.list-rss-sitenews"}'
            ));
        }
    }

    public function addNewsViewPage($reset, $default = null) {
        $db = $this->getDb();
        $page_id = $this->checkPageId('sitenews_news_view');
        if ($page_id && $reset) {
            $this->deletePageAndContent($page_id);
            $page_id = false;
        }

        if (!$page_id) {

            // Insert page
            $db->insert('engine4_core_pages', array(
                'name' => 'sitenews_news_view',
                'displayname' => 'News - News View Page',
                'title' => 'News View Page',
                'description' => 'This page lets you view the selected news created by anyone.',
                'custom' => 0,
            ));
            $page_id = $db->lastInsertId();

            // Insert top
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'top',
                'page_id' => $page_id,
                'order' => 1,
            ));
            $top_id = $db->lastInsertId();

            // Insert main
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'main',
                'page_id' => $page_id,
                'order' => 2,
            ));
            $main_id = $db->lastInsertId();

            // Insert top-middle
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'middle',
                'page_id' => $page_id,
                'parent_content_id' => $top_id,
                'order' => 6,
            ));
            $top_middle_id = $db->lastInsertId();

            // Insert main-middle
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'middle',
                'page_id' => $page_id,
                'parent_content_id' => $main_id,
                'order' => 6,
            ));
            $main_middle_id = $db->lastInsertId();

            // Insert main-right
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'right',
                'page_id' => $page_id,
                'parent_content_id' => $main_id,
                'order' => 5,
            ));
            $main_right_id = $db->lastInsertId();

            //Insert Content widget
            $db->insert('engine4_core_content', array(
                'type' => 'widget',
                'name' => 'sitenews.profile-breadcrumb',
                'page_id' => $page_id,
                'parent_content_id' => $top_middle_id,
                'order' => 3,
                'params' => ''
            ));

            //Insert Content widget
            $db->insert('engine4_core_content', array(
                'type' => 'widget',
                'name' => 'core.content',
                'page_id' => $page_id,
                'parent_content_id' => $main_middle_id,
                'order' => 6,
                'params' => ''
            ));

            $select = new Zend_Db_Select($db);
            $select
                    ->from('engine4_core_modules')
                    ->where('name = ?', 'nestedcomment')
                    ->where('enabled = ?', 1);
            $is_nestedcomment_object = $select->query()->fetchObject();

            if ($is_nestedcomment_object) {
                //Insert Comments widget
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'nestedcomment.comments',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_middle_id,
                    'order' => 7,
                    'params' => '{"title":"","taggingContent":["friends","event","group","list","siteevent","sitegroup","sitepage","sitestore"],"showComposerOptions":["addLink","addPhoto","addSmilies"],"showAsNested":"1","showAsLike":"1","showDislikeUsers":"1","showLikeWithoutIcon":"1","showLikeWithoutIconInReplies":"1","commentsorder":"1","nestedcomment_comment_public":"0","loaded_by_ajax":"1","nomobile":"0","name":"nestedcomment.comments"}'
                ));
            } else {
                //Insert Comments widget
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'core.comments',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_middle_id,
                    'order' => 7,
                    'params' => '{"title":"Comments"}'
                ));
            }

            //Insert Trending News
            $db->insert('engine4_core_content', array(
                'type' => 'widget',
                'name' => 'sitenews.trending-news-sitenews',
                'page_id' => $page_id,
                'parent_content_id' => $main_right_id,
                'order' => 9,
                'params' => '{"categoryids":["1","2","3","4"],"itemCount":"5","popularType":"creation","titleTruncation":"50","refreshTimeout":"12","detactLocation":"0","defaultLocationDistance":"1000","title":"Trending News","nomobile":"0","name":"sitenews.trending-news-sitenews"}'
            ));


            //Insert News Tags
            $db->insert('engine4_core_content', array(
                'type' => 'widget',
                'name' => 'sitenews.news-recently-view-random-sitenews',
                'page_id' => $page_id,
                'parent_content_id' => $main_right_id,
                'order' => 10,
                'params' => '{"title":"Around the World","itemCountPerPage":4,"viewTypes":["gridZZZview"],"defaultViewType":"gridZZZview","category_id":"1","subcategory_id":"0","hidden_news_category_id":"2","hidden_news_subcategory_id":"0","hidden_news_subsubcategory_id":"0","rss":"0","showNews":"all_feeds","popularType":"random","showPhotosInJustifiedView":"0","rowHeight":"205","maxRowHeight":"0","margin":"0","lastRow":"nojustify","listViewWithPhoto":"1","newsOption":["title","creationDate","view","like","comment","location","favourite","facebook","twitter","linkedin","googleplus"],"listDescription":"0","gridViewHeight":"190","gridViewWidth":"213","titleTruncation":"40","descriptionTruncation":"100","detactLocation":"0","gridItemCountPerPage":"3","listItemCountPerPage":"9","showViewMore":"0","nomobile":"0","name":"sitenews.news-recently-view-random-sitenews"}'
            ));
        }
    }

}
