<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenews
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Template.php 2011-08-026 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenews_Form_Admin_Template extends Engine_Form {

    public function init() {

        $this->setTitle('Layout Template Settings')
                ->setDescription('You can choose from the following widgetized pages to reset it\'s present settings to the default settings of the plugin.')
                ->setAttrib('name', 'template');
        $coreSettings = Engine_Api::_()->getApi('settings', 'core');
        $templateApi = Engine_Api::_()->getApi('settemplate', 'sitenews');
        $getCurrentThemeSetting = $templateApi->setLayoutAccordingToTheme();

        $recommendSmall = '[Select this if your activated theme width size is greater than or equal to 950px and less than 1100px.]';
        $recommendMedium = '[Select this if your activated theme width size is greater than or equal to 1100px and less than 1200px.]';
        $recommendFull = '[Select this if your activated theme width size is greater than or equal to 1200px.]';
        if ($getCurrentThemeSetting == 1) {
            $recommendSmall = ' <b class="sitenews_bold">*</b><b>Recommended</b> [Select this if your activated theme width size is greater than or equal to 950px and less than 1100px.]';
        } else if ($getCurrentThemeSetting == 2) {
            $recommendMedium = ' <b class="sitenews_bold">*</b><b>Recommended</b> [Select this if your activated theme width size is greater than or equal to 1100px and less than 1200px.]';
        } else if ($getCurrentThemeSetting == 3) {
            $recommendFull = ' <b class="sitenews_bold">*</b><b>Recommended</b> [Select this if your activated theme width size is greater than or equal to 1200px.]';
        }

        $this->addElement('Radio', 'sitenews_setlayyoutpages', array(
            'label' => 'Set Pages',
            'description' => '<br />[<b>Note:</b> The above selected width setting will be applicable to all the widgetized pages mentioned below.]',
            'multiOptions' => array(
                1 => '<b>Small Width</b> ' . $recommendSmall,
                2 => '<b>Medium Width</b> ' . $recommendMedium,
                3 => '<b>Full Width</b> ' . $recommendFull,
            ),
            'escape' => false,
            'value' => $coreSettings->getSetting('sitenews.setlayyoutpages', $getCurrentThemeSetting)
        ));
        $this->sitenews_setlayyoutpages->getDecorator('Description')->setOptions(array('placement' => 'APPEND', 'escape' => false));
        $pages = array(
            'selectAll' => 'Select All',
            'addNewsHomePage' => 'News - News Home Page',
            'addNewsBrowsePage' => 'News - News Browse Page',
            'addNewsPinboardPage' => 'News - News Pinboard Page',
            'addNewsMapPage' => 'News - News Map Page',
            'addNewsListPage' => 'News - News List Page',
            'addNewsCreatePage' => 'News - News Create Page',
            'addNewsEditPage' => 'News - News Edit Page',
            'addNewsManagePage' => 'News - News Manage Page',
            'addNewsViewPage' => 'News - News View Page',
            'addRssCreatePage' => 'News - RSS Create Page',
            'addRssViewPage' => 'News - RSS View Page',
            'addRssManagePage' => 'News - RSS Manage Page',
            'addRssListPage' => 'News - RSS List Page',
            'addRssEditPage' => 'News - RSS Edit Page',
            'addNewsTagcloudPage' => 'News - News Tag Cloud Page',
            'addCategoryPage' => 'News - News Category Page',
        );
        $values = $coreSettings->getSetting('sitenews.pagestemplate');
        $selectedCount = count($values);
        if($selectedCount == 15){

            array_push($values,'selectAll');
        }

        $this->addElement('MultiCheckbox', 'sitenews_pagestemplate', array(
            'label' => 'Widgetized Pages',
            'multiOptions' => $pages,
            'onclick' => 'selectAll(this.value)',
            'escape' => false,
            'value' => $values,
        ));

        $this->addElement('Button', 'save', array(
            'label' => 'Save Changes',
            'type' => 'submit',
            'ignore' => true
        ));
    }

}
