<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenews
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Specialnews.php 2017-01-01 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenews_Form_Admin_Widget_Specialnews extends Engine_Form {

    public function init() {

        $this->setMethod('post');
        $this->setTitle('News of the day');

        //SHOW PREFIELD START AND END DATETIME
        $httpReferer = $_SERVER['HTTP_REFERER'];
        $params = $toValues = $toValuesArray = array();
        $toValuesString = '';
        if (!empty($httpReferer) && strstr($httpReferer, '?page=')) {
            $httpRefererArray = explode('?page=', $httpReferer);
            $page_id = (int) $httpRefererArray['1'];
        } elseif (!empty($httpReferer) && strstr($httpReferer, 'admin/content') && !strstr($httpReferer, 'admin/content?')) {
            $page_id = 3; //FOR HOME PAGE
        }

        if (!empty($page_id) && is_numeric($page_id)) {

            //GET CONTENT TABLE
            $tableContent = Engine_Api::_()->getDbtable('content', 'core');
            $tableContentName = $tableContent->info('name');

            //GET CONTENT
            $params = $tableContent->select()
                    ->from($tableContentName, array('params'))
                    ->where('page_id = ?', $page_id)
                    ->where('name = ?', 'sitenews.special-news')
                    ->query()
                    ->fetchColumn();

            if (!empty($params)) {
                $params = Zend_Json_Decoder::decode($params);
            }
        }

        $this->addElement('Text', 'news_ids', array(
            'autocomplete' => 'off',
            'decorators' => array(array('ViewScript', array(
                        'viewScript' => '/application/modules/Sitenews/views/scripts/admin-settings/add-special-news.tpl',
                        'thisObject' => $this,
                        'class' => 'form element')))
        ));
        Engine_Form::addDefaultDecorators($this->news_ids);

        $this->addElement('Hidden', 'toValues', array(
            'label' => '',
            'order' => 1000,
            'filters' => array(
                'HtmlEntities'
            ),
        ));
        Engine_Form::addDefaultDecorators($this->toValues);

        $this->addElement(
                'Text', 'columnWidth', array(
            'label' => 'Enter the width of the photo for the block.',
            'value' => '269',
                )
        );
        $this->addElement(
                'Text', 'columnHeight', array(
            'label' => 'Enter the height of the photo for the block.',
            'value' => '200',
                )
        );

        $this->addElement(
                'MultiCheckbox', 'newsInfo', array(
            'label' => 'Choose the options that you want to display for the News in this block.',
            'multiOptions' => array_merge(array(
                'title' => 'News Title',
                'owner' => 'Owner',
                'provider' => 'RSS Provider',
                'creationDate' => 'Creation Date',
                'view' => 'Views',
                'like' => 'Likes',
                'comment' => 'Comments',
                'location' => 'Location',
                'favourite' => 'Favourite',
                'facebook' => 'Facebook [Social Share Link]',
                'twitter' => 'Twitter [Social Share Link]',
                'linkedin' => 'LinkedIn [Social Share Link]',
                'googleplus' => 'Google+ [Social Share Link]'
                    )
            )
                )
        );

        $this->addElement(
                'Text', 'titleTruncation', array(
            'label' => 'Title Tuncation limit.',
            'value' => 16,
            'validators' => array(
                array('Int', true),
                array('GreaterThan', true, array(0)),
            ),
                )
        );

        // Start time
        $start = new Engine_Form_Element_CalendarDateTime('starttime');
        $start->setLabel("Start Time");
        $start->setAllowEmpty(false);
        $this->addElement($start);

        // End time
        $end = new Engine_Form_Element_CalendarDateTime('endtime');
        $end->setLabel("End Time");
        $end->setAllowEmpty(false);
        $this->addElement($end);

        if (isset($params['starttime']) && !empty($params['starttime'])) {
            $start->setValue($params['starttime']);
        }

        if (isset($params['endtime']) && !empty($params['endtime'])) {
            $end->setValue($params['endtime']);
        }
    }

}
