<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenews
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Album.php 2017-01-01 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenews_Model_Album extends Core_Model_Item_Collection {

    protected $_searchTriggers = false;
    protected $_modifiedTriggers = false;
    protected $_parent_type = 'sitenews_rss';
    protected $_owner_type = 'user';
    protected $_children_types = array('sitenews_photo');
    protected $_collectible_type = 'sitenews_photo';

    /**
     * Gets an absolute URL to the page to view this item
     *
     * @return string
     */
    public function getHref($params = array()) {

        return $this->getOwner()->getHref($params);
    }

    public function getAuthorizationItem() {

        return $this->getParent('sitenews_rss');
    }

    protected function _delete() {

        //DELTE ALL CHILD POST
        $photoTable = Engine_Api::_()->getItemTable('sitenews_photo');
        $photoSelect = $photoTable->select()->where('album_id = ?', $this->getIdentity());
        foreach ($photoTable->fetchAll($photoSelect) as $sitenewsPhoto) {
            $sitenewsPhoto->delete();
        }
        parent::_delete();
    }

}
