<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenews
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Locations.php 2017-01-01 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenews_Model_DbTable_Locations extends Engine_Db_Table {

    protected $_rowClass = "Sitenews_Model_Location";

    /**
     * Get location
     *
     * @param array $params
     * @return object
     */
    public function getLocation($params = array()) {

        if (Engine_Api::_()->getApi('settings', 'core')->getSetting('sitenews.location', 1)) {

            $locationName = $this->info('name');

            $select = $this->select();
            if (isset($params['id'])) {
                $select->where('news_id = ?', $params['id']);
                return $this->fetchRow($select);
            }

            if (isset($params['news_ids'])) {
                $select->where('news_id IN (?)', (array) $params['news_ids']);
                return $this->fetchAll($select);
            }
        }
    }

}
