<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenews
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: GetRichContent.php 6590 2012-26-01 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenews_View_Helper_GetRichContent extends Advancedactivity_View_Helper_GetRichContent {
    /**
     * Assembles action string
     *
     * @return string
     */
    public function getRichContent($item, $feedSettings = array()) {
        if (!$item || $item->getType() != 'sitenews_news') {
            return parent::getRichContent($item);
        }

        $newsSize = array();
        $newsSize['thumb.normal'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('normal.news.width', 375);
        $newsSize['thumb.large'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('normallarge.news.width', 720);
        $newsSize['thumb.main'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('main.news.height', 1600);
        $newsSize['width'] = 400;
        $thumbnailType = Engine_Api::_()->getApi('core', 'sitenews')->findThumbnailType($newsSize, $newsSize['width']);
        $session = new Zend_Session_Namespace('mobile');
        $mobile = $session->mobile;
        $view = false;
        $params = array();

        $item = Engine_Api::_()->getItem('sitenews_news', $item->news_id);

        // $view == false means that this rich content is requested from the activity feed
        if ($view == false) {

            
            // prepare the thumbnail
            if ($item->file_id) {
                $thumb = Zend_Registry::get('Zend_View')->itemPhoto($item, $thumbnailType, null);             
                $addOverlay = '<span class="news_overlay"></span>';
            } else {
                $thumb = '<img alt="" src="' . Zend_Registry::get('StaticBaseUrl') . 'application/modules/Sitenews/externals/images/news_default.png">';
                $addOverlay = '';
            }

            if (!$mobile) {
                $thumb = '<a class="Sitenews_thumb" id="news_thumb_' . $item->news_id . '" style="" href="' . $item->getHref() . '">
                  <div class="sitenews_thumb_wrapper sitenews_thumb_viewer">'. $addOverlay . $thumb . '</div>
                  </a>';
            } else {
                $thumb = '<a class="Sitenews_thumb" id="news_thumb_' . $item->news_id . '" class="news_thumb" href="' . $item->getHref() . '">
                  <div class="sitenews_thumb_wrapper sitenews_thumb_viewer">' . $addOverlay . $thumb . '</div>
                  </a>';
            }

            // prepare title and description
            $title = "<div class='feed_item_link_title'><a class='sea_add_tooltip_link feed_news_title' rel= \"" . $item->getType() . ' ' . $item->getIdentity() . "\" href='" . $item->getHref($params) . "' >$item->title</a></div>";
            $tmpBody = strip_tags($item->description);
            $description = "<div class='sitenews_desc'>" . (Engine_String::strlen($tmpBody) > 255 ? Engine_String::substr($tmpBody, 0, 255) . '...' : $tmpBody) . "</div>";

            $newsEmbedded = $thumb . '<div class="news_info">' . $title . $description . '</div>';
        }

        return $newsEmbedded;
    }

}
