<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenews
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: RssInfo.php 2017-01-01 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenews_View_Helper_RssInfo extends Zend_View_Helper_Abstract {

    public function rssInfo($subject, $subjectInfo, $params = array()) {

        $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
        $statistics = '';

        if (!empty($subject) && !empty($subjectInfo) && in_array('like', $subjectInfo)) {
            $statistics .= $view->translate(array('%s like', '%s likes', $subject->like_count), $view->locale()->toNumber($subject->like_count)) . ', ';
        }

        if (!empty($subjectInfo) && in_array('comment', $subjectInfo)) {
            $statistics .= $view->translate(array('%s comment', '%s comments', $subject->comment_count), $view->locale()->toNumber($subject->comment_count)) . ', ';
        }
        if (!empty($subjectInfo) && in_array('numberOfFeeds', $subjectInfo)) {
            $statistics .= $view->translate(array('%s news', '%s news', $subject->feeds_count), $view->locale()->toNumber($subject->comment_count)) . ', ';
        }
        $statistics = trim($statistics);
        $statistics = rtrim($statistics, ',');
        if (!empty($statistics)) {
            echo '<div class="seao_listings_stats"><i class="seao_icon_strip seao_icon seao_icon_stats" title="' . $view->translate("Statistics") . '"></i><div class="o_hidden">' . $statistics . '</div></div>';
        }

        if (!empty($subjectInfo) && in_array('creationDate', $subjectInfo)) {
            echo '<div class="seao_listings_stats"><i class="seao_icon_strip seao_icon seao_icon_time" title="' . $view->translate("Creation Date") . '"></i><div class="o_hidden">' . $view->timestamp($subject->creation_date) . '</div></div>';
        }
?>
        <?php

    }

}
