<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenews
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 2017-01-01 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$topNavigationLink = array(
    'news' => 'News',
    'rss' => 'RSS',
    'createNews' => 'Add News',
    'createRss' => 'Add RSS'
);
if (!Engine_Api::_()->getApi('settings', 'core')->getSetting('sitenews.rss.allow', 1)) {
    $topNavigationLink = array(
        'news' => 'News',
        'createNews' => 'Add News',
    );
}

$newsViewOption = array(
    'title' => 'News Title',
    'owner' => 'Owner',
    'lightbox' => 'Open in Lightbox Link',
    'share' => 'Share',
    'suggest' => 'Suggest to Friends',
    'like' => 'Like ',
    'dislike' => 'Dislike',
    'favourite' => 'Favourite',
    'comment' => 'Comment',
    'view' => 'View counts',
    'report' => 'Report',
    'hashtags' => 'Hashtags'
);

$rssTempOtherInfoElement = array(
    "ownerName" => "Owner Name",
    "creationDate" => "Creation Date",
    "viewCount" => "Views",
    "likeCount" => "Likes",
    "commentCount" => "Comments",
    "location" => "Location",
    "directionLink" => "Open Get Direction popup on clicking location. (Dependent on Location)"
);

$newsTempOtherInfoElement = array(
    "ownerName" => "Like / Comment Strip",
    "creationDate" => "Creation Date",
    "viewCount" => "Views",
    "likeCount" => "Likes",
    "commentCount" => "Comments",
);

$popularTypeArray = array(
    'creation' => 'Recently Created',
    'modified' => 'Recently Updated',
    'view' => 'Most Viewed',
    'like' => 'Most Liked',
    'comment' => 'Most Commented',
);

$rssPopularTypeArray = array(
    'creation' => 'Recently Created',
    'modified' => 'Recently Updated',
    'like' => 'Most Liked',
    'comment' => 'Most Commented',
);

$myrssArray = array("creationDate" => "Creation Date",
    "viewCount" => "Views",
    "likeCount" => "Likes",
    "commentCount" => "Comments",
    "location" => "Location",
    "directionLink" => "Open Get Direction popup on clicking location. (Dependent on Location)");

$mynewsArray = array("creationDate" => "Creation Date",
    "viewCount" => "Views",
    "likeCount" => "Likes",
    "commentCount" => "Comments",
    "location" => "Location",
    "directionLink" => "Open Get Direction popup on clicking location. (Dependent on Location)");

$rssViewPageOptions = array('title' => 'RSS Title', 'owner' => 'RSS Owner', 'description' => 'Description', 'updateddate' => 'Updation Date', 'likeButton' => 'Like Button', 'editmenus' => 'Edit Menus');

if (Engine_Api::_()->getApi('settings', 'core')->getSetting('sitenews.subscriptions.enabled', 1)) {
    $newsViewOption = array_merge($newsViewOption, array('subscribe' => 'Subscribe'));
}

$informationOptions = array("totalFeeds" => "Total News", "creationDate" => "Creation Date", "updateDate" => "Updation Date", "likeCount" => "Likes", "commentCount" => "Comments", "socialShare" => "Social Share", "description" => "Description");

if (Engine_Api::_()->getApi('settings', 'core')->getSetting('sitenews.tags.enabled', 1)) {
    $informationOptions = array_merge($informationOptions, array("tags" => "Tags"));
    $rssViewPageOptions = array_merge($rssViewPageOptions, array("tags" => "Tags"));
}

if (Engine_Api::_()->getApi('settings', 'core')->getSetting('sitenews.category.enabled', 1)) {
    $informationOptions = array_merge($informationOptions, array("categoryLink" => "Category"));
    $rssViewPageOptions = array_merge($rssViewPageOptions, array('categoryLink' => "Category"));
    $rssTempOtherInfoElement = array_merge($rssTempOtherInfoElement, array("categoryLink" => "Category"));
    $myrssArray = array_merge($myrssArray, array("categoryLink" => "Category"));
}

$rssElement = array(
    'MultiCheckbox',
    'rssInfo',
    array(
        'label' => 'Choose the options that you want to display for the RSS in this block.',
        'multiOptions' => array_merge($rssTempOtherInfoElement, array("rssTitle" => "RSS Title", "totalFeeds" => "Total News Count", "facebook" => "Facebook", "twitter" => "Twitter", "linkedin" => "LinkedIn", "google" => "Google +"))
    ),
);

$newsElement = array(
    'MultiCheckbox',
    'newsInfo',
    array(
        'label' => 'Choose the options that you want to display for the News in this block.',
        'multiOptions' => array_merge($newsTempOtherInfoElement, array("newsTitle" => "News Title", "rssTitle" => "RSS Title"))
    ),
);

$showViewMoreContent = array(
    'Select',
    'show_content',
    array(
        'label' => 'What do you want for view more content?',
        'description' => '',
        'multiOptions' => array(
            '1' => 'Pagination',
            '2' => 'Show View More Link at Bottom',
            '3' => 'Auto Load Channels on Scrolling Down'),
        'value' => 2,
    )
);
$truncationLocationElement = array(
    'Text',
    'truncationLocation',
    array(
        'label' => 'Truncation limit of location (Depend on Location)',
        'value' => 35,
    )
);

$rssTitleTruncation = array(
    'Text',
    'rssTitleTruncation',
    array(
        'label' => 'Truncation limit for RSS title.',
        'value' => 22,
    ),
    'validators' => array(
        array('Int', true),
        array('GreaterThan', true, array(0)),
    ),
);

$newsTitleTruncation = array(
    'Text',
    'newsTitleTruncation',
    array(
        'label' => 'Truncation limit for news title.',
        'value' => 22,
    ),
    'validators' => array(
        array('Int', true),
        array('GreaterThan', true, array(0)),
    ),
);

$detactLocationElement = array(
    'Select',
    'detactLocation',
    array(
        'label' => 'Do you want to display News based on user\'s current location ?',
        'multiOptions' => array(
            1 => 'Yes',
            0 => 'No'
        ),
        'value' => '0'
    )
);

$rssInfoOnHoverElement = array(
    'Radio',
    'infoOnHover',
    array(
        'label' => 'Do you want to show the RSS information on mouse hover?',
        'multiOptions' => array(
            1 => 'Yes',
            0 => 'No'
        ),
        'value' => '1'
    )
);

if (Engine_Api::_()->getApi('settings', 'core')->getSetting('sitenews.news.proximity.search.kilometer', 0)) {
    $locationDescription = "Choose the kilometers within which news will be displayed. (This setting will only work, if you have chosen 'Yes' in the above setting.)";
    $locationLableS = "Kilometer";
    $locationLable = "Kilometers";
} else {
    $locationDescription = "Choose the miles within which News will be displayed. (This setting will only work, if you have chosen 'Yes' in the above setting.)";
    $locationLableS = "Mile";
    $locationLable = "Miles";
}

$defaultLocationDistanceElement = array(
    'Select',
    'defaultLocationDistance',
    array(
        'label' => $locationDescription,
        'multiOptions' => array(
            '0' => '',
            '1' => '1 ' . $locationLableS,
            '2' => '2 ' . $locationLable,
            '5' => '5 ' . $locationLable,
            '10' => '10 ' . $locationLable,
            '20' => '20 ' . $locationLable,
            '50' => '50 ' . $locationLable,
            '100' => '100 ' . $locationLable,
            '250' => '250 ' . $locationLable,
            '500' => '500 ' . $locationLable,
            '750' => '750 ' . $locationLable,
            '1000' => '1000 ' . $locationLable,
        ),
        'value' => '1000'
    )
);

$categories = Engine_Api::_()->getDbtable('categories', 'sitenews')->getCategories(array('fetchColumns' => array('category_id', 'category_name'), 'sponsored' => 0, 'cat_depandancy' => 1));

$rssTable = Engine_Api::_()->getDbtable('rss', 'sitenews');
$select = $rssTable->select()
        ->from($rssTable->info('name'), array('rss_id', 'title'));
$rssList = $rssTable->fetchAll($select);
if (!Engine_Api::_()->getApi('settings', 'core')->getSetting('sitenews.rss.alow', 1)) {
    $rssListElement = array();
} else {
    $rss_prepared = array();
    if (count($rssList) > 0) {
        $rss_prepared[0] = "";
        foreach ($rssList as $value) {
            $rss_prepared[$value->rss_id] = $value->title;
        }
        $rssListElement = array(
            'select',
            'rss',
            array(
                'label' => 'Select the RSS for the News that you want to display.',
                'multiOptions' => $rss_prepared,
                'RegisterInArrayValidator' => false,
            )
        );
    }
}


if (!Engine_Api::_()->getApi('settings', 'core')->getSetting('sitenews.category.enabled', 1)) {
    $categoryElement = array();
    $multi_categories_prepared = array();
    $subCategoryElement = array();
} else {
    $categories_prepared = array();
    $multi_categories_prepared = array();
    $categories_with_news = array();
    if (count($categories) != 0) {
        $categories_prepared[0] = "";

        foreach ($categories as $category) {
            $multi_categories_prepared[$category->category_id] = $categories_prepared[$category->category_id] = $category->category_name;
        }
        $newsTable = Engine_Api::_()->getDbtable('news', 'sitenews');
        foreach ($categories as $category) {
            $newsItems = $newsTable->fetchAll(array('category_id' => $category->category_id, 'published' => 1))->toArray();
            if ($category && $category->getUsedCount() > 0 && !empty($newsItems)) {
                $categories_with_news[$category->category_id] = $category->category_name;
            }
        }

        $categoryElement = array(
            'Select',
            'category_id',
            array(
                'label' => 'Select the category of the News that you want to display.',
                'multiOptions' => $categories_prepared,
                'RegisterInArrayValidator' => false,
                'onchange' => 'addOptions(this.value, "cat_dependency", "subcategory_id", 0); setHiddenValues("category_id")'
        ));

        //for multi select in categories
        $categoriesElement = array(
            'MultiCheckbox',
            'categoryids',
            array(
                'label' => 'Choose categories [Only 8 will be visible from the selected categories]',
                'multiOptions' => $multi_categories_prepared,
                'RegisterInArrayValidator' => false,
                'onchange' => 'addOptions(this.value, "cat_dependency", "subcategory_id", 0); setHiddenValues("category_id")'
        ));

        //for categories which have news
        $categoriesHavingNewsElement = array(
            'MultiCheckbox',
            'categoryids',
            array(
                'label' => 'Categories',
                'multiOptions' => $categories_with_news,
                'RegisterInArrayValidator' => false,
                'onchange' => 'addOptions(this.value, "cat_dependency", "subcategory_id", 0); setHiddenValues("category_id")'
        ));

        $subCategoryElement = array(
            'Select',
            'subcategory_id',
            array(
                'RegisterInArrayValidator' => false,
                'decorators' => array(array('ViewScript', array(
                            'viewScript' => 'application/modules/Sitenews/views/scripts/_category.tpl',
                            'class' => 'form element')))
        ));

        $subCategoriesElement = array(
            'Multiselect',
            'subcategoryids',
            array(
                'RegisterInArrayValidator' => false,
                'decorators' => array(array('ViewScript', array(
                            'viewScript' => 'application/modules/Sitenews/views/scripts/_category.tpl',
                            'class' => 'form element')))
        ));
    }
}
$hiddenCatElement = array(
    'Hidden',
    'hidden_category_id',
    array('order' => 999
        ));

$hiddenSubCatElement = array(
    'Hidden',
    'hidden_subcategory_id',
    array('order' => 998
        ));
$hiddenSubSubCatElement = array(
    'Hidden',
    'hidden_subsubcategory_id',
    array('order' => 997
        ));

$newsCategories = Engine_Api::_()->getDbtable('categories', 'sitenews')->getCategories(array('fetchColumns' => array('category_id', 'category_name'), 'sponsored' => 0, 'cat_depandancy' => 1));
$newsSubCategoryElement = array();
$newsCategoryElement = array();
if (!Engine_Api::_()->getApi('settings', 'core')->getSetting('sitenews.category.enabled', 1)) {
    $newsCategoryElement = array();
    $newsSubCategoryElement = array();
} else {
    $news_categories_prepared = array();
    if (count($newsCategories) != 0) {
        $news_categories_prepared[0] = "";
        foreach ($newsCategories as $category) {
            $news_categories_prepared[$category->category_id] = $category->category_name;
        }

        $newsCategoryElement = array(
            'Select',
            'category_id',
            array(
                'label' => 'Category',
                'multiOptions' => $news_categories_prepared,
                'RegisterInArrayValidator' => false,
                'onchange' => 'addNewsOptions(this.value, "cat_dependency", "subcategory_id", 0); setNewsHiddenValues("category_id")'
        ));

        $newsSubCategoryElement = array(
            'Select',
            'subcategory_id',
            array(
                'RegisterInArrayValidator' => false,
                'decorators' => array(array('ViewScript', array(
                            'viewScript' => 'application/modules/Sitenews/views/scripts/_newsCategory.tpl',
                            'class' => 'form element')))
        ));
    }
}
$hiddenNewsCatElement = array(
    'Hidden',
    'hidden_news_category_id',
    array('order' => 996
        ));

$hiddenNewsSubCatElement = array(
    'Hidden',
    'hidden_news_subcategory_id',
    array('order' => 995
        ));
$hiddenNewsSubSubCatElement = array(
    'Hidden',
    'hidden_news_subsubcategory_id',
    array('order' => 994
        ));

$rowHeight = array(
    'Text',
    'rowHeight',
    array(
        'label' => 'Enter the row height of each News block (in pixels). [This row height uses as a base height to create the justified view. The resulting rows height could be slightly lesser than your entered row height.]',
        'value' => 205,
    )
);
$maxRowHeight = array(
    'Text',
    'maxRowHeight',
    array(
        'label' => 'Enter the max row height of each News block (in pixels). [This is the maximum row height to be allowed to create justified view. The resulting rows height could be higher / lesser than your entered maximum row height to fit any news within limit.]',
        'value' => 0,
    )
);
$margin = array(
    'Text',
    'margin',
    array(
        'label' => 'Enter the margin between two News block, both vertically and horizontally (in pixels).',
        'value' => 0,
    )
);
$lastRow = array(
    'Radio',
    'lastRow',
    array(
        'label' => 'Choose the option to justify the last row if the last row may not have enough News to fill the entire width.',
        'multiOptions' => array(
            'nojustify' => 'No Justify',
            'justify' => 'Justify',
            'hide' => 'Hide'
        ),
        'value' => 'nojustify',
    )
);

return array(
    // sub-category widget
    array(
        'title' => 'News Categories: Displays Categories / Sub-categories in Grid View',
        'description' => 'Displays categories and sub-categories in grid view on “News Categories Home” page.',
        'category' => 'News',
        'type' => 'widget',
        'autoEdit' => true,
        'name' => 'sitenews.news-categories-grid-view',
        'defaultParams' => array(
            'title' => 'Categories',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Radio',
                    'orderBy',
                    array(
                        'label' => 'Default Ordering of Categories in Grid View.',
                        'multiOptions' => array(
                            'categoryName' => 'Category Name',
                            'catOrder' => 'Category Order according to creation'
                        ),
                        'value' => 'catOrder',
                    )
                ),
                array(
                    'Radio',
                    'showAllCategories',
                    array(
                        'label' => 'Do you want all the categories, sub-categories to be shown to the users even if they have 0 videos in them?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 0,
                    )
                ),
                array(
                    'Text',
                    'showSubCategoriesCount',
                    array(
                        'label' => 'Show number of sub-categories to be shown on mouseover on a category respectively.',
                        'value' => '5',
                        'maxlength' => 1
                    )
                ),
                array(
                    'Radio',
                    'showCount',
                    array(
                        'label' => 'Show channel count along with the sub-category name.',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 0,
                    )
                ),
                array(
                    'Text',
                    'columnWidth',
                    array(
                        'label' => 'Column width for Grid View.',
                        'value' => '234',
                    )
                ),
                array(
                    'Text',
                    'columnHeight',
                    array(
                        'label' => 'Column height for Grid View.',
                        'value' => '216',
                    )
                ),
            )
        ),
    ),
    //Popular news widget
    array(
        'title' => 'Popular News',
        'description' => 'Displays News based on the Popularity / Sorting Criteria and other settings that you have chosen for this widget. You can place this widget multiple times on a page with different popularity criterion chosen for each placement. This widget should be placed in the left / right side bar on the respective widgetized page.',
        'category' => 'News',
        'type' => 'widget',
        // 'autoEdit' => true,
        'name' => 'sitenews.news-recently-view-random-sitenews',
        //'isPaginated' => true,
        'defaultParams' => array(
            'title' => 'Popular News',
            'itemCountPerPage' => 4,
            "viewTypes" => array("gridZZZview", "listZZZview"),
            "defaultViewType" => "gridZZZview",
        ),
        'requirements' => array(
            'no-subject',
        ),
        'adminForm' => array(
            'elements' => array(
                $newsCategoryElement,
                $newsSubCategoryElement,
                $hiddenNewsCatElement,
                $hiddenNewsSubCatElement,
                $hiddenNewsSubSubCatElement,
                $rssListElement,
              
                array(
                    'MultiCheckbox',
                    'viewTypes',
                    array(
                        'label' => 'Select the view type for News',
                        'multiOptions' => array(
                            'gridZZZview' => 'Grid view',
                            'listZZZview' => 'List view',
                        ),
                    )
                ),
                array(
                    'Select',
                    'defaultViewType',
                    array(
                        'label' => 'Choose a default view type.',
                        'multiOptions' => array(
                            'gridZZZview' => 'Grid view',
                            'listZZZview' => 'List view',
                        ),
                        'value' => 'gridZZZview',
                    )
                ),
                array(
                    'Select',
                    'popularType',
                    array(
                        'label' => 'Popularity / Sorting Criteria',
                        'multiOptions' => array_merge($popularTypeArray, array('random' => 'Random')),
                        'value' => 'random',
                    )
                ),
//                array(
//                    'Radio',
//                    'titleInsideGrid',
//                    array(
//                        'label' => 'Do you want to show the news title inside the grid view by default?',
//                        'multiOptions' => array(
//                            1 => 'Yes',
//                            0 => 'No',
//                        ),
//                        'value' => 0
//                    )
//                ),
                $rowHeight,
                $maxRowHeight,
                $margin,
                $lastRow,
                array(
                    'Radio',
                    'listViewWithPhoto',
                    array(
                        'label' => 'Do you want to show photo for News in list view ?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No',
                        ),
                        'value' => 1
                    )
                ),
                array(
                    'MultiCheckbox',
                    'newsOption',
                    array(
                        'label' => 'Choose the options that you want to display for the News in this block.',
                        'multiOptions' => array(
                            'title' => 'News Title',
                            'provider' => 'RSS Provider',
                            'owner' => 'Owner',
                            'creationDate' => 'Creation Date',
                            'view' => 'Views',
                            'like' => 'Likes',
                            'comment' => 'Comments',
                            'location' => 'Location',
                            'favourite' => 'Favourite',
                            'facebook' => 'Facebook [Social Share Link]',
                            'twitter' => 'Twitter [Social Share Link]',
                            'linkedin' => 'LinkedIn [Social Share Link]',
                            'googleplus' => 'Google+ [Social Share Link]'
                        ),
                    )
                ),
                array(
                    'Radio',
                    'listDescription',
                    array(
                        'label' => 'Show description in List view?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => '1',
                    )
                ),
//                array(
//                    'Radio',
//                    'gridDescription',
//                    array(
//                        'label' => 'Show description in Grid view?',
//                        'multiOptions' => array(
//                            1 => 'Yes',
//                            0 => 'No'
//                        ),
//                        'value' => '0',
//                    )
//                ),
                array(
                    'Text',
                    'gridViewHeight',
                    array(
                        'label' => 'News photo height for Grid View.',
                        'value' => 200,
                    ),
                    'validators' => array(
                        array('Int', true),
                        array('GreaterThan', true, array(0)),
                    ),
                ),
                array(
                    'Text',
                    'gridViewWidth',
                    array(
                        'label' => 'News photo width for Grid View.',
                        'value' => 250,
                    ),
                    'validators' => array(
                        array('Int', true),
                        array('GreaterThan', true, array(0)),
                    ),
                ),
                array(
                    'Text',
                    'titleTruncation',
                    array(
                        'label' => 'Truncation limit for News title',
                        'value' => 22,
                    ),
                    'validators' => array(
                        array('Int', true),
                    ),
                ),
                array(
                    'Text',
                    'descriptionTruncation',
                    array(
                        'label' => 'Description truncation limit',
                        'value' => 100,
                    ),
                    'validators' => array(
                        array('Int', true),
                    ),
                ),
                $detactLocationElement,
                array(
                    'Text',
                    'gridItemCountPerPage',
                    array(
                        'label' => 'Count',
                        'description' => '(Number of items to show in grid view)',
                        'value' => 12,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        )
                    ),
                ),
                array(
                    'Text',
                    'listItemCountPerPage',
                    array(
                        'label' => 'Count',
                        'description' => '(Number of items to show in list view)',
                        'value' => 12,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        )
                    ),
                ),
                array(
                    'Radio',
                    'showViewMore',
                    array(
                        'label' => 'Show "View More".',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => '1',
                    )
                ),
            )
        ),
    ),
    //Browse News-Pinboard widget
    array(
        'title' => 'Browse News: Pinboard View',
        'description' => 'Displays a list of all the News on your site in attractive Pinboard View. You can also display News based on user’s current location by using the Edit section of this widget. It is recommended to place this widget on “Browse News Pinboard Page”.',
        'category' => 'News',
        'type' => 'widget',
        'autoEdit' => true,
        'name' => 'sitenews.pinboard-browse-news-sitenews',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
            'newsOption' => array('title', 'owner', 'creationDate', 'view', 'like', 'comment', 'favourite', 'facebook', 'twitter', 'linkedin', 'googleplus'),
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Radio',
                    'view_count',
                    array(
                        'label' => 'Do you want to show the News on the basis of Maximum Views ?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => '1'
                    ),
                ),
//                array(
//                    'Select',
//                    'interval',
//                    array(
//                        'label' => 'Popularity Duration (This duration will be applicable to these Popularity / Sorting Criteria: Most Liked, Most Commented and Recently Posted.)',
//                        'multiOptions' => array('week' => '1 Week', 'month' => '1 Month', 'overall' => 'Overall'),
//                        'value' => 'overall',
//                    )
//                ),
                $newsCategoryElement,
                $newsSubCategoryElement,
                $hiddenNewsCatElement,
                $hiddenNewsSubCatElement,
                $hiddenNewsSubSubCatElement,
                $rssListElement,
                array(
                    'Radio',
                    'userComment',
                    array(
                        'label' => 'Do you want to show user comments and enable the user to post a comment or not ?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => '1'
                    ),
                ),
                array(
                    'radio',
                    'autoload',
                    array(
                        'label' => 'Do you want to enable auto-loading of old pinboard items when users scroll down to the bottom of this page?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => '1'
                    )
                ),
                array(
                    'radio',
                    'defaultLoadingImage',
                    array(
                        'label' => 'Do you want to show a Loading image when this widget renders on a page?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1
                    )
                ),
                array(
                    'Text',
                    'itemWidth',
                    array(
                        'label' => 'One Item Width',
                        'description' => 'Enter the width for each pinboard item.',
                        'value' => 237,
                    )
                ),
                array(
                    'Radio',
                    'withoutStretch',
                    array(
                        'label' => 'Do you want to display the images without stretching them to the width of each pinboard item?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => '0',
                    )
                ),
                array(
                    'Text',
                    'itemCountPerPage',
                    array(
                        'label' => 'Count',
                        'description' => '(Number of News to show)',
                        'value' => 12,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        )
                    ),
                ),
//                array(
//                    'Text',
//                    'autoload_count',
//                    array(
//                        'label' => 'Auto-loading count',
//                        'description' => 'Enter the number of times that auto-loading of old pinboard items should occur on scrolling down. (Select 0 if you do not want such a restriction and want auto-loading to occur always. Because of auto-loading on-scroll, users are not able to click on links in footer; this setting has been created to avoid this.)',
//                        'value' => 0,
//                    )
//                ),
                array(
                    'MultiCheckbox',
                    'show_buttons',
                    array(
                        'label' => 'Choose the buttons that you want to be available for the News displayed in this block.',
                        'multiOptions' =>
                        array(
                            "comment" => "Comment",
                            "like" => "Like / Unlike",
                            'favourite' => 'Favourite',
                            'facebook' => 'Facebook',
                            'twitter' => 'Twitter',
                            'pinit' => 'Pin it',
                            'googleplus' => 'Google+'
                        )
                    ),
                ),
                array(
                    'MultiCheckbox',
                    'newsOption',
                    array(
                        'label' => 'Choose the action links that you want to be available for the News displayed in this block.',
                        'multiOptions' =>
                        array(
                            'title' => 'News Title',
                            'provider' => 'RSS Provider',
                            'owner' => 'Owner',
                        )
                    ),
                ),
                array(
                    'Text',
                    'titleTruncation',
                    array(
                        'label' => 'Truncation limit for News title',
                        'value' => 22,
                    ),
                    'validators' => array(
                        array('Int', true),
                    ),
                ),
                array(
                    'Text',
                    'descriptionTruncation',
                    array(
                        'label' => 'Enter the truncation limit for the News Description. (If you want to hide the description, then enter \'0\'.)',
                        'value' => 200,
                    ),
                    'validators' => array(
                        array('Int', true),
                    ),
                ),
                $detactLocationElement,
                $defaultLocationDistanceElement,
                $truncationLocationElement,
            ))
    ),
    //Home Grid List View widget
    array(
        'title' => 'Ajax based Category News',
        'description' => 'Contains multiple Ajax based tabs showing different categories News in a block via separate ajax based tabs. You can configure various settings for this widget from the Edit settings.',
        'category' => 'News',
        'type' => 'widget',
        'autoEdit' => true,
        'name' => 'sitenews.news-with-categories-slideshow',
        'defaultParams' => array(
            'title' => '',
            "newsOption" => array("title", "owner", "like", "comment", "favourite", "facebook", "twitter", "linkedin", "googleplus")
        ),
        'adminForm' => array(
            'elements' => array(
                $categoriesElement,
                $rssListElement,
                array(
                    'Radio',
                    'categoryAtTop',
                    array(
                        'label' => 'Do you want to show category tab at the top of the slideshow ?',
                        'multiOptions' => array(
                            '1' => 'Yes',
                            '0' => 'No',
                        ),
                        'value' => 1,
                    )
                ),
                array(
                    'Radio',
                    'viewType',
                // array(
                //     'label' => 'Do you want to show a small photo with the news in List view ?',
                //     'multiOptions' => array(
                //         'list' => 'List View',
                //         'listWithPhoto' => 'List View with Small Image',
                //     ),
                //     'value' => 'listWithPhoto'
                // )
                ),
                // array(
                //     'Radio',
                //     'viewDescription',
                //     array(
                //         'label' => 'Do you want to show description for News item ?',
                //         'multiOptions' => array(
                //             1 => 'Yes',
                //             0 => 'No',
                //         ),
                //         'value' => 1
                //     )
                // ),
//                array(
//                    'Text',
//                    'itemCount',
//                    array(
//                        'label' => 'Enter number of news you want to show in this widget',
//                        'value' => 7,
//                    )
//                ),
                array(
                    'MultiCheckbox',
                    'newsOption',
                    array(
                        'label' => 'Choose the options that you want to display for the News.',
                        'multiOptions' => array(
                               'title' => 'News Title',
                            'provider' => 'RSS Provider',
                            'owner' => 'Owner',
                            'description' => 'Description',
                            'creationDate' => 'Creation Date',
                            'view' => 'Views',
                            'like' => 'Likes',
                            'comment' => 'Comments',
                            'favourite' => 'Favourites',
                            'facebook' => 'Facebook [Social Share Link]',
                            'twitter' => 'Twitter [Social Share Link]',
                            'linkedin' => 'LinkedIn [Social Share Link]',
                            'googleplus' => 'Google+ [Social Share Link]'
                        ),
                    )
                ),
                array(
                    'Select',
                    'popularType',
                    array(
                        'label' => 'Popularity Criteria',
                        'multiOptions' => array(
                            'featured' => 'Featured',
                            'sponsored' => 'Sponsored',
                            'breaking_news' => 'Breaking News',
                            'mostRecent' => 'Most Recent'
                        ),
                        'value' => 'featured',
                    )
                ),                
//                array(
//                    'Text',
//                    'slideshow_height',
//                    array(
//                        'label' => 'Enter the height of the Box (in pixels).',
//                        'value' => 350,
//                    ),
//                    'validators' => array(
//                        array('Int', true),
//                        array('GreaterThan', true, array(0)),
//                    ),
//                ),
//                array(
//                    'Text',
//                    'slideshow_width',
//                    array(
//                        'label' => 'Enter the width of the Box (in pixels).',
//                        'value' => 1000,
//                    ),
//                    'validators' => array(
//                        array('Int', true),
//                        array('GreaterThan', true, array(0)),
//                    ),
//                ),
                array(
                    'Text',
                    'titleTruncation',
                    array(
                        'label' => 'Enter the title truncation limit for News',
                        'value' => 22,
                    ),
                    'validators' => array(
                        array('Int', true),
                    ),
                ),
                array(
                    'Text',
                    'descriptionTruncation',
                    array(
                        'label' => 'Enter the Description truncation limit for News',
                        'value' => 100,
                    ),
                    'validators' => array(
                        array('Int', true),
                    ),
                ),
//                array(
//                    'Text',
//                    'categoryCountInSingleRow',
//                    array(
//                        'label' => 'Enter how many categories to be visible in Category Menu.',
//                        'value' => 8,
//                    ),
//                    'validators' => array(
//                        array('Int', true),
//                    ),
//                ),
            ),
        ),
    ),
    array(
        'title' => 'Search Form - News',
        'description' => 'Displays the form for searching News on the basis of various fields and filters.',
        'category' => 'News',
        'type' => 'widget',
        'autoEdit' => true,
        'name' => 'sitenews.search-news-sitenews',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Radio',
                    'viewType',
                    array(
                        'label' => 'Show Search Form',
                        'multiOptions' => array(
                            'horizontal' => 'Horizontal',
                            'vertical' => 'Vertical',
                        ),
                        'value' => 'vertical'
                    )
                ),
                array(
                    'Radio',
                    'showAllCategories',
                    array(
                        'label' => 'Do you want all the categories, sub-categories and 3rd level categories to be shown to the users even if they have 0 News in them?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
                // array(
                //     'Radio',
                //     'locationDetection',
                //     array(
                //         'label' => "Allow browser to detect user's current location.",
                //         'multiOptions' => array(
                //             1 => 'Yes',
                //             0 => 'No'
                //         ),
                //         'value' => 1,
                //     )
                // ),
            ),
        ),
    ),
    // Browse news widget
    array(
        'title' => 'Browse News',
        'description' => 'Displays a list of all the News present on your website. This widget should be placed on "Browse News Page".',
        'category' => 'News',
        'type' => 'widget',
        'autoEdit' => true,
        'name' => 'sitenews.browse-news-sitenews',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
            "viewType" => array("gridView", "listView"),
            "defaultViewType" => "gridView",
            "newsOption" => array("title", "owner", "like", "comment", "favourite", "facebook", "twitter", "linkedin", "googleplus")
        ),
        'adminForm' => array(
            'elements' => array(
                $categoryElement,
                $subCategoriesElement,
                $hiddenCatElement,
                $hiddenSubCatElement,
                $hiddenSubSubCatElement,
                $rssListElement,
                array(
                    'MultiCheckbox',
                    'viewType',
                    array(
                        'label' => 'Select the view type for News',
                        'multiOptions' => array(
                            'gridView' => 'Grid view',
                            'listView' => 'List view',
                        ),
                    )
                ),
                array(
                    'Select',
                    'defaultViewType',
                    array(
                        'label' => 'Choose a default view type.',
                        'multiOptions' => array(
                            'gridView' => 'Grid view',
                            'listView' => 'List view',
                        ),
                        'value' => 'gridView',
                    )
                ),
                
                array(
                    'Text',
                    'gridViewHeight',
                    array(
                        'label' => 'News photo height for Grid View.',
                        'value' => 200,
                    ),
                    'validators' => array(
                        array('Int', true),
                        array('GreaterThan', true, array(0)),
                    ),
                ),
                array(
                    'Text',
                    'gridViewWidth',
                    array(
                        'label' => 'News photo width for Grid View.',
                        'value' => 250,
                    ),
                    'validators' => array(
                        array('Int', true),
                        array('GreaterThan', true, array(0)),
                    ),
                ),
                array(
                    'MultiCheckbox',
                    'newsOption',
                    array(
                        'label' => 'Choose the options that you want to display for the News in this block.',
                        'multiOptions' => array(
                            'title' => 'News Title',
                            'provider' => 'RSS Provider',
                            'owner' => 'Owner',
                            'view' => 'Views',
                            'like' => 'Likes',
                            'comment' => 'Comments',
                            'favourite' => 'Favourites',
                            'facebook' => 'Facebook [Social Share Link]',
                            'twitter' => 'Twitter [Social Share Link]',
                            'linkedin' => 'LinkedIn [Social Share Link]',
                            'googleplus' => 'Google+ [Social Share Link]'
                        ),
                    )
                ),
                $rowHeight,
                $maxRowHeight,
                $margin,
                $lastRow,

                array(
                    'Radio',
                    'orderby',
                    array(
                        'label' => 'Default ordering in Browse News. (Note: Selecting multiple ordering will make your page load slower.)',
                        'multiOptions' => array(
                            'creationDate' => 'All News in descending order of fetching date.',
                            'viewCount' => 'All News in descending order of views.',
                            'title' => 'All News in alphabetical order.',
                            'featured' => 'Featured News followed by others in descending order of fetching date.',
                            'featuredView' => 'Featured News followed by others in descending order of  views.',
                        ),
                        'value' => 'creationDate'
                    )
                ),
                array(
                    'Select',
                    'show_content',
                    array(
                        'label' => 'What do you want for view more content?',
                        'multiOptions' => array(
                            '1' => 'Pagination',
                            '2' => 'Show View More Link at Bottom',
                            '3' => 'Auto Load photos on Scrolling Down'),
                        'value' => 2,
                    )
                ),
                
                array(
                    'Text',
                    'titleTruncation',
                    array(
                        'label' => 'Truncation limit for News Title',
                        'value' => 22,
                    ),
                    'validators' => array(
                        array('Int', true),
                    ),
                ),
                array(
                    'Radio',
                    'listDescription',
                    array(
                        'label' => 'Show description in List view?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => '1',
                    )
                ),
                array(
                    'Text',
                    'descriptionTruncation',
                    array(
                        'label' => 'Truncation limit for News description  ',
                        'value' => 100,
                    ),
                    'validators' => array(
                        array('Int', true),
                    ),
                ),
                $detactLocationElement,
                $defaultLocationDistanceElement,
                array(
                    'Text',
                    'itemCountPerPage',
                    array(
                        'label' => 'Count',
                        'description' => '(Number of news items to show)',
                        'value' => 12,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        )
                    ),
                ),
            ))
    ),
    array(
        'title' => 'News Category Navigation Bar',
        'description' => 'Displays different categories in this block. You can configure various settings for this widget from the Edit section.',
        'category' => 'News',
        'type' => 'widget',
        'name' => 'sitenews.news-categories-navigation',
        'autoEdit' => true,
        'adminForm' => array(
            'elements' => array(
                array(
                    'Radio',
                    'orderBy',
                    array(
                        'label' => 'Default ordering of Categories in Grid View.',
                        'multiOptions' => array(
                            'categoryName' => 'Category Name',
                            'catOrder' => 'Category Order according to creation'
                        ),
                        'value' => 'catOrder',
                    )
                ),
                array(
                    'Radio',
                    'viewDisplayHR',
                    array(
                        'label' => 'Select the placement position of the navigation bar',
                        'multiOptions' => array(
                            1 => 'Horizontal',
                            0 => 'Vertical'
                        ),
                        'value' => 0,
                    )
                ),
            ))
    ),
    //News Banner
    array(
        'title' => 'News Banner',
        'description' => 'Displays News on the banner based on filters such as category, RSS, popularity sorting criteria. You can place this widget anywhere on the site, we recommended "News Home Page". [Note: Only 5 News will be displayed in this widget. These News will be selected on the basis of chosen options from below settings.]',
        'category' => 'News',
        'type' => 'widget',
        'name' => 'sitenews.news-banner',
        'autoEdit' => true,
        'adminForm' => array(
            'elements' => array(
                $categoryElement,
                $subCategoryElement,
                $hiddenCatElement,
                $hiddenSubCatElement,
                $hiddenSubSubCatElement,
                $rssListElement,
                array(
                    'Text',
                    'bannerHeight',
                    array(
                        'label' => 'Enter the height of the banner.',
                        'value' => '350',
                    )
                ),
//                array(
//                    'Text',
//                    'bannerWidth',
//                    array(
//                        'label' => 'Enter the width of the banner.',
//                        'value' => '323',
//                    )
//                ),
                array(
                    'Text',
                    'imageSpace',
                    array(
                        'label' => 'Enter space between each image.',
                        'value' => '5',
                    )
                ),
                array(
                    'Select',
                    'popularType',
                    array(
                        'label' => 'Popularity Criteria',
                        'multiOptions' => array(
                            'featured' => 'Featured',
                            'sponsored' => 'Sponsored',
                            'breaking_news' => 'Breaking News',
                            'mostRecent' => 'Most Recent'
                        ),
                        'value' => 'featured',
                    )
                ),
                array(
                    'MultiCheckbox',
                    'newsOption',
                    array(
                        'label' => 'Choose the options that you want to display for the News in this block.',
                        'multiOptions' => array(
                            'creationDate' => 'Creation Date',
                            'view' => 'Views',
                            'like' => 'Likes',
                            'comment' => 'Comments',
                            'favourite' => 'Favourite',
                            'facebook' => 'Facebook [Social Share Link]',
                            'twitter' => 'Twitter [Social Share Link]',
                            'linkedin' => 'LinkedIn [Social Share Link]',
                            'googleplus' => 'Google+ [Social Share Link]'
                        ),
                    )
                ),
                array(
                    'Text',
                    'titleTruncation',
                    array(
                        'label' => 'Enter the title truncation limit for News',
                        'value' => 22,
                    ),
                    'validators' => array(
                        array('Int', true),
                    ),
                ),
            ))
    ),
    //List Rss
    array(
        'title' => 'RSS Feeds List',
        'description' => 'Displays a list of all RSS present on your website. You can place this widget anywhere on the site.',
        'category' => 'News',
        'type' => 'widget',
        'name' => 'sitenews.list-rss-sitenews',
        'autoEdit' => true,
        'adminForm' => 'Sitenews_Form_Admin_Widget_Listrss'
    ),
    //Popular news carousel widget 
    array(
        'title' => 'Popular News Carousel',
        'description' => 'This widget contains an attractive AJAX based carousel, showcasing the News on your site. You can show featured, sponsored News in this widget from the Edit section of this widget. You can place this widget multiple times on a page with different criterion chosen for each placement.',
        'category' => 'News',
        'type' => 'widget',
        'autoEdit' => true,
        'name' => 'sitenews.popular-news-carousel',
        'defaultParams' => array(
            'title' => '',
        ),
        'adminForm' => array(
            'elements' => array(
                $newsCategoryElement,
                $newsSubCategoryElement,
                $hiddenNewsCatElement,
                $hiddenNewsSubCatElement,
                $hiddenNewsSubSubCatElement,
                $rssListElement,
                array(
                    'Select',
                    'showNews',
                    array(
                        'label' => 'Show News',
                        'multiOptions' => array(
                            '' => '',
                            //  'video_feeds' => 'Only Videos',
                            'image_feeds' => 'Only Images',
                            'all_feeds' => 'All News',
                        ),
                        'value' => 'all_feeds',
                    )
                ),
                array(
                    'MultiCheckbox',
                    'newsOption',
                    array(
                        'label' => 'Choose the options that you want to display for the News in this block.',
                        'multiOptions' => array(
                            'title' => 'News Title',
                            'owner' => 'Owner',
                            'provider' => 'RSS Provider',
                            'creationDate' => 'Creation Date',
                            'view' => 'Views',
                            'like' => 'Likes',
                            'comment' => 'Comments',
                            'favourite' => 'Favourite',
                            'facebook' => 'Facebook [Social Share Link]',
                            'twitter' => 'Twitter [Social Share Link]',
                            'linkedin' => 'LinkedIn [Social Share Link]',
                            'googleplus' => 'Google+ [Social Share Link]'
                        ),
                    )
                ),
                array(
                    'Radio',
                    'showPagination',
                    array(
                        'label' => 'Do you want to show next / previous pagination?',
                        'multiOptions' => array(1 => 'Yes', 0 => 'No'),
                        'value' => '1',
                    )
                ),
                array(
                    'Radio',
                    'carouselType',
                    array(
                        'label' => 'Carousel Type',
                        'multiOptions' => array('horizontal' => 'Horizontal', 'vertical' => 'Vertical'),
                        'value' => 'horizontal',
                    )
                ),
                array(
                    'Text',
                    'newsWidth',
                    array(
                        'label' => 'Enter the width of each carousel Container.',
                        'value' => 915,
                    )
                ),
                array(
                    'Text',
                    'itemWidth',
                    array(
                        'label' => 'Enter the width of each slideshow Item.',
                        'description' => 'Leave 0, if you do not want to add space between items.',
                        'value' => 0,
                    )
                ),
                array(
                    'Text',
                    'newsHeight',
                    array(
                        'label' => 'Enter the height of each carousel item.',
                        'value' => 150,
                    )
                ),
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Enter number of News to be displayed in a row.',
                        'value' => 7,
                    )
                ),
                array(
                    'Select',
                    'popularType',
                    array(
                        'label' => 'Popularity  Criteria',
                        'multiOptions' => array(
                            'featured' => 'Featured',
                            'sponsored' => 'Sponsored',
                            'featuredSponsored' => 'Featured & Sponsored',
                            'viewCount' => 'News with Maximum views',
                        ),
                        'value' => 'featured',
                    )
                ),
                array(
                    'Text',
                    'interval',
                    array(
                        'label' => 'Speed',
                        'description' => '(Transition interval between two slides in millisecs)',
                        'value' => 3500,
                    )
                ),
                array(
                    'Text',
                    'titleTruncation',
                    array(
                        'label' => 'Enter the title truncation limit for News',
                        'value' => 22,
                    ),
                    'validators' => array(
                        array('Int', true),
                    ),
                ),
            ),
        ),
    ),
    // Trending news widget 
    array(
        'title' => 'Trending News Sidebar',
        'description' => 'Displays trending news based on most shares, most viewed and most commented in this block. You can configure various settings from the Edit section of this widget.',
        'category' => 'News',
        'type' => 'widget',
        'name' => 'sitenews.trending-news-sitenews',
        'autoEdit' => true,
        'adminForm' => array(
            'elements' => array(
                $categoriesHavingNewsElement,
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Enter the number of News you want to show in a category',
                        'value' => 5,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        )
                    ),
                ),
                array(
                    'Select',
                    'popularType',
                    array(
                        'label' => 'Trending News Criteria',
                        'multiOptions' => array_merge($popularTypeArray, array('share' => 'Most Shared')),
                        'value' => 'random',
                    )
                ),
                array(
                    'Text',
                    'titleTruncation',
                    array(
                        'label' => 'Enter the title truncation limit for News',
                        'value' => 22,
                    ),
                    'validators' => array(
                        array('Int', true),
                    ),
                ),
                array(
                    'Text',
                    'refreshTimeout',
                    array(
                        'label' => 'Refresh the news in seconds',
                        'value' => 12,
                    ),
                    'validators' => array(
                        array('Int', true),
                    ),
                ),
                $detactLocationElement,
                $defaultLocationDistanceElement,
            ))
    ),
    //location widget 
    array(
        'title' => 'Browse News by Location',
        'description' => "Displays the form for searching News corresponding to a location and on the basis of various filters. Also, displays a list of all the News having location entered corresponding to them on the site. This widget must be placed on \"Browse News Location\" page.",
        'category' => 'News',
        'type' => 'widget',
        'name' => 'sitenews.browselocation-sitenews',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Radio',
                    'showAllCategories',
                    array(
                        'label' => 'Do you want all the categories, sub-categories and 3rd level categories to be shown to the users even if they have 0 news in them?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
                // array(
                //     'Radio',
                //     'locationDetection',
                //     array(
                //         'label' => "Allow browser to detect user's current location.",
                //         'multiOptions' => array(
                //             1 => 'Yes',
                //             0 => 'No'
                //         ),
                //         'value' => 1,
                //     )
                // ),
                array(
                    'MultiCheckbox',
                    'newsOption',
                    array(
                        'label' => 'Choose the options that you want to display for the News in this block.',
                        'multiOptions' => array(
                            'title' => 'News Title',
                            'owner' => 'Owner',
                            'provider' => 'RSS Provider',
                            'creationDate' => 'Creation Date',
                            'view' => 'Views',
                            'like' => 'Likes',
                            'comment' => 'Comments',
                            'location' => 'Location',
                            'favourite' => 'Favourite',
                            'facebook' => 'Facebook [Social Share Link]',
                            'twitter' => 'Twitter [Social Share Link]',
                            'linkedin' => 'LinkedIn [Social Share Link]',
                            'googleplus' => 'Google+ [Social Share Link]'
                        ),
                    )
                ),
            ),
        ),
    ),
    //news carousel widget 
    array(
        'title' => 'News Carousel',
        'description' => 'This widget contains an attractive AJAX based carousel, showcasing the News on your site. You can show featured, sponsored News in this widget from the Edit section of this widget. You can place this widget multiple times on a page with different criterion chosen for each placement.',
        'category' => 'News',
        'type' => 'widget',
        'autoEdit' => true,
        'name' => 'sitenews.news-carousel',
        'defaultParams' => array(
            'title' => '',
        ),
        'adminForm' => array(
            'elements' => array(
                $newsCategoryElement,
                $newsSubCategoryElement,
                $hiddenNewsCatElement,
                $hiddenNewsSubCatElement,
                $hiddenNewsSubSubCatElement,
                $rssListElement,
                array(
                    'MultiCheckbox',
                    'newsOption',
                    array(
                        'label' => 'Choose the options that you want to display for the News in this block.',
                        'multiOptions' => array(
                            'title' => 'News Title',
                            'provider' => 'RSS Provider',
                            'owner' => 'Owner',
                            'creationDate' => 'Creation Date',
                            'view' => 'Views',
                            'like' => 'Likes',
                            'comment' => 'Comments',
                            'favourite' => 'Favourite',
                            'facebook' => 'Facebook [Social Share Link]',
                            'twitter' => 'Twitter [Social Share Link]',
                            'linkedin' => 'LinkedIn [Social Share Link]',
                            'googleplus' => 'Google+ [Social Share Link]'
                        ),
                    )
                ),
                array(
                    'Radio',
                    'showPagination',
                    array(
                        'label' => 'Do you want to show next / previous pagination?',
                        'multiOptions' => array(1 => 'Yes', 0 => 'No'),
                        'value' => '1',
                    )
                ),
                array(
                    'Text',
                    'newsWidth',
                    array(
                        'label' => 'Enter the width of each slideshow item.',
                        'value' => 150,
                    )
                ),
                array(
                    'Text',
                    'newsHeight',
                    array(
                        'label' => 'Enter the height of each slideshow item.',
                        'value' => 150,
                    )
                ),
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Enter number of news to be displayed in a Row.',
                        'description' => '[Items displaying in the first block will always be less than 3 items of what you have entered here, so we recommend you to enter +3 items count of what you want to display. E.g.- If you want to display 7 items in the first block then, enter 10 counts here. The second block will display the same entered item counts.]',
                        'value' => 7,
                    )
                ),
                array(
                    'Select',
                    'popularType',
                    array(
                        'label' => 'Popularity  Criteria',
                        'multiOptions' => array(
                            'featured' => 'Featured',
                            'sponsored' => 'Sponsored',
                            'breaking_news' => 'Breaking News',
                            'featuredNsponsored' => 'Featured & Sponsored',
                            'view' => 'News with Maximum views',
                        ),
                        'value' => 'featured',
                    )
                ),
                array(
                    'Text',
                    'interval',
                    array(
                        'label' => 'Speed',
                        'description' => '(Transition interval between two slides in millisecs)',
                        'value' => 3500,
                    )
                ),
            ),
        ),
    ),
    //Breaking News widget
    array(
        'title' => 'Breaking News',
        'description' => "This widget contains list of all the News which are marked as 'Breaking' by the admin from the 'Manage News' section in the admin panel of this plugin. You can place this widget anywhere on the page, we recommended 'News Home Page'.",
        'category' => 'News',
        'type' => 'widget',
        'autoEdit' => true,
        'name' => 'sitenews.breaking-news-sitenews',
        'adminForm' => array(
            'elements' => array(
                array(
                    'text',
                    'heading',
                    array(
                        'label' => 'Heading for the News.',
                        'value' => 'Breaking News',
                    )
                ),
                array(
                    'text',
                    'scrollamount',
                    array(
                        'label' => 'Enter the scroll speed of floating text (in milliseconds).',
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                        'value' => '10',
                    )
                ),
            )
        )
    ),
    //Video Feeds widget
//    array(
//        'title' => 'Top Videos',
//        'description' => "This widget contains list of all the news that contains videos inside them. You can place this widget anywhere on the page.",
//        'category' => 'News',
//        'type' => 'widget',
//        'autoEdit' => true,
//        'name' => 'sitenews.top-videos-sitenews',
//        'adminForm' => array(
//            'elements' => array(
//                $categoryElement,
//                $subCategoryElement,
//                $hiddenCatElement,
//                $hiddenSubCatElement,
//                $hiddenSubSubCatElement,
//                $rssListElement,
//                array(
//                    'radio',
//                    'otherThumbnails',
//                    array(
//                        'label' => 'Do you want to show thumbnails of other videos?',
//                        'multiOptions' => array(
//                            1 => 'Yes',
//                            0 => 'No'
//                        ),
//                        'value' => 1,
//                    )
//                ),
//                array(
//                    'radio',
//                    'viewAllLink',
//                    array(
//                        'label' => 'Show View All link?',
//                        'multiOptions' => array(
//                            1 => 'Yes',
//                            0 => 'No'
//                        ),
//                        'value' => 1,
//                    )
//                ),
//                array(
//                    'text',
//                    'titleTruncation',
//                    array(
//                        'label' => 'Title Truncation limit',
//                        'validators' => array(
//                            array('Int', true),
//                            array('GreaterThan', true, array(0)),
//                        ),
//                        'value' => 22,
//                    )
//                ),
//            )
//        )
//    ),
    array(
        'title' => 'Ajax based Main News Home',
        'description' => "Contains multiple Ajax based tabs showing Recently Posted, Most Viewed, Featured, Sponsored News in a block via separate ajax based tabs. You can configure various settings for this widget from the Edit settings.",
        'category' => 'News',
        'type' => 'widget',
        'autoEdit' => true,
        'name' => 'sitenews.news-main-ajax-home-sitenews',
        'defaultParams' => array(
            'title' => "",
            "viewType" => array("gridZZZview", "listZZZview"),
            "defaultViewType" => "gridZZZview",
            'newsOption' => array("title", "owner", "like", "comment", "favourite", "facebook", "twitter", "linkedin", "googleplus"),
            'ajaxTabs' => array('featured', 'sponsored', 'recent', 'mostZZZviewed')
        ),
        'adminForm' => array(
            'elements' => array(
                $categoryElement,
                $subCategoryElement,
                $hiddenCatElement,
                $hiddenSubCatElement,
                $hiddenSubSubCatElement,
                $rssListElement,
                array(
                    'MultiCheckbox',
                    'viewType',
                    array(
                        'label' => 'Choose the view type for News',
                        'multiOptions' => array(
                            'gridZZZview' => 'Grid view',
                            'listZZZview' => 'List view',
                        ),
                    )
                ),
                array(
                    'Select',
                    'defaultViewType',
                    array(
                        'label' => 'Select a default view type for News',
                        'multiOptions' => array(
                            'gridZZZview' => 'Grid view',
                            'listZZZview' => 'List view',
                        ),
                        'value' => 'gridZZZview',
                    )
                ),
//                array(
//                    'Radio',
//                    'titleInsideGrid',
//                    array(
//                        'label' => 'Do you want to show the news title inside the grid by default?',
//                        'multiOptions' => array(
//                            1 => 'Yes',
//                            0 => 'No',
//                        ),
//                        'value' => 0
//                    )
//                ),
                array(
                    'Radio',
                    'listViewWithPhoto',
                    array(
                        'label' => 'Do you want to show photo for News in list view ?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No',
                        ),
                        'value' => 1
                    )
                ),
                array(
                    'Text',
                    'gridViewHeight',
                    array(
                        'label' => 'News photo height for Grid View.',
                        'value' => 200,
                    ),
                    'validators' => array(
                        array('Int', true),
                        array('GreaterThan', true, array(0)),
                    ),
                ),
                array(
                    'Text',
                    'gridViewWidth',
                    array(
                        'label' => 'News photo width for Grid View.',
                        'value' => 250,
                    ),
                    'validators' => array(
                        array('Int', true),
                        array('GreaterThan', true, array(0)),
                    ),
                ),
                array(
                    'MultiCheckbox',
                    'newsOption',
                    array(
                        'label' => 'Choose the options that you want to display for the News in this block.',
                        'multiOptions' => array(
                            'title' => 'News Title',
                            'provider' => 'RSS Provider',
                            'owner' => 'Owner',
                            'view' => 'Views',
                            'like' => 'Likes',
                            'comment' => 'Comments',
                            'favourite' => 'Favourites',
                            'location' => 'Location',
                            'facebook' => 'Facebook [Social Share Link]',
                            'twitter' => 'Twitter [Social Share Link]',
                            'linkedin' => 'LinkedIn [Social Share Link]',
                            'googleplus' => 'Google+ [Social Share Link]'
                        ),
                    )
                ),
                array(
                    'Radio',
                    'listDescription',
                    array(
                        'label' => 'Show short description in List view?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => '1',
                    )
                ),
//                array(
//                    'Radio',
//                    'gridDescription',
//                    array(
//                        'label' => 'Show description in Grid view?',
//                        'multiOptions' => array(
//                            1 => 'Yes',
//                            0 => 'No'
//                        ),
//                        'value' => '0',
//                    )
//                ),
                array(
                    'MultiCheckbox',
                    'ajaxTabs',
                    array(
                        'label' => 'Select the tabs that you want to be available in this block.',
                        'multiOptions' => array(
                            "featured" => "Featured",
                            "sponsored" => "Sponsored",
                            "recent" => "Recent",
                            "mostZZZviewed" => "Most Viewed"
                        )
                    )
                ),
                array(
                    'Text',
                    'most_viewed_order',
                    array(
                        'label' => 'Most View Tab Order',
                        'value' => 5,
                    ),
                    'validators' => array(
                        array('Int', true),
                    ),
                ),
                array(
                    'Text',
                    'recent_order',
                    array(
                        'label' => 'Recent Tab Order',
                        'value' => 4,
                    ),
                    'validators' => array(
                        array('Int', true),
                    ),
                ),
                array(
                    'Text',
                    'sponsored_order',
                    array(
                        'label' => 'Sponsored Tab Order',
                        'value' => 2,
                    ),
                    'validators' => array(
                        array('Int', true),
                    ),
                ),
                array(
                    'Text',
                    'featured_order',
                    array(
                        'label' => 'Featured Tab Order',
                        'value' => 1,
                    ),
                    'validators' => array(
                        array('Int', true),
                    ),
                ),
                array(
                    'Radio',
                    'showViewMore',
                    array(
                        'label' => 'Show "View More".',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => '1',
                    )
                ),
                array(
                    'Text',
                    'gridItemCountPerPage',
                    array(
                        'label' => 'Count',
                        'description' => '(Enter the Number of items to be displayed in grid view)',
                        'value' => 12,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        )
                    ),
                ),
                array(
                    'Text',
                    'listItemCountPerPage',
                    array(
                        'label' => 'Count',
                        'description' => '(Enter the Number of items to be displayed in list view)',
                        'value' => 12,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        )
                    ),
                ),
                array(
                    'Text',
                    'titleTruncationGridNNewsView',
                    array(
                        'label' => 'Title truncation limit in Grid View',
                        'value' => 22,
                    ),
                    'validators' => array(
                        array('Int', true),
                    ),
                ),
                array(
                    'Text',
                    'titleTruncation',
                    array(
                        'label' => 'Title truncation limit in List View',
                        'value' => 22,
                    ),
                    'validators' => array(
                        array('Int', true),
                    ),
                ),
                array(
                    'Text',
                    'descriptionTruncation',
                    array(
                        'label' => 'Description truncation limit in List View',
                        'value' => 100,
                    ),
                    'validators' => array(
                        array('Int', true),
                    ),
                ),
                $detactLocationElement,
                $defaultLocationDistanceElement,
                array(
                    'Radio',
                    'loaded_by_ajax',
                    array(
                        'label' => 'Widget Content Loading',
                        'description' => 'Do you want the content of this widget to be loaded via AJAX, after the loading of main webpage content? (Enabling this can improve webpage loading speed. Disabling this would load content of this widget along with the page content.)',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
            )
        ),
    ),
//    array(
//        'title' => 'Search Form - RSS',
//        'description' => 'Displays the form for searching RSS on the basis of various fields and filters.',
//        'category' => 'News',
//        'type' => 'widget',
//        'autoEdit' => true,
//        'name' => 'sitenews.search-sitenews',
//        'defaultParams' => array(
//            'title' => '',
//            'titleCount' => true,
//        ),
//        'adminForm' => array(
//            'elements' => array(
//                array(
//                    'Radio',
//                    'viewType',
//                    array(
//                        'label' => 'Show Search Form',
//                        'multiOptions' => array(
//                            'horizontal' => 'Horizontal',
//                            'vertical' => 'Vertical',
//                        ),
//                        'value' => 'vertical'
//                    )
//                ),
//                array(
//                    'Radio',
//                    'showAllCategories',
//                    array(
//                        'label' => 'Do you want all the categories, sub-categories and 3rd level categories to be shown to the users even if they have 0 rss in them?',
//                        'multiOptions' => array(
//                            1 => 'Yes',
//                            0 => 'No'
//                        ),
//                        'value' => 1,
//                    )
//                ),),
//        ),
//    ),
    array(
        'title' => 'My News',
        'description' => 'Displays all the news created by the user.',
        'category' => 'News',
        'type' => 'widget',
        'name' => 'sitenews.my-news',
        'requirements' => array(
            'no-subject',
        ),
        'defaultParams' => array(
            'title' => 'My News',
            'itemCountPerPage' => 12,
            'topNavigationLink' => array('news', 'rss', 'createNews', 'createRss'),
            'newsNavigationLink' => array('news', 'liked', 'favourite'),
            'viewType' => array('gridView', 'listView'),
            'newsOption' => array('title', 'creationDate', 'view', 'like', 'comment', 'favourite', 'facebook', 'twitter', 'linkedin', 'googleplus'),
        ),
        'adminForm' => 'Sitenews_Form_Admin_Widget_Content',
        'autoEdit' => true
    ),
    //RSS view page
    array(
        'title' => 'RSS View',
        'description' => 'Displays all the news of a RSS.',
        'category' => 'News',
        'type' => 'widget',
        'name' => 'sitenews.rss-news',
        'requirements' => array(
            'no-subject',
        ),
        'defaultParams' => array(
            'title' => 'RSS View',
            'itemCountPerPage' => 12,
            'newsNavigationLink' => array('news'),
            'viewType' => array('gridView', 'listView'),
            'newsOption' => array('title', 'creationDate', 'view', 'like', 'comment', 'favourite', 'facebook', 'twitter', 'linkedin', 'googleplus'),
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'MultiCheckbox',
                    'viewType',
                    array(
                        'label' => 'Select the view type for RSS',
                        'multiOptions' => array(
                            'gridView' => 'Grid view',
                            'listView' => 'List view',
                        ),
                    )
                ),
                array(
                    'Select',
                    'defaultViewType',
                    array(
                        'label' => 'Select a default view type for RSS',
                        'multiOptions' => array(
                            'gridView' => 'Grid view',
                            'listView' => 'List view',
                        ),
                        'value' => 'gridView',
                    )
                ),
                array(
                    'Radio',
                    'searchButton',
                    array(
                        'label' => 'Do you want to show search for RSS in this block ?',
                        'multiOptions' => array(
                            '1' => 'Yes',
                            '0' => 'No',
                        ),
                        'value' => 1,
                    )
                ),
                array(
                    'Text',
                    'gridViewWidth',
                    array(
                        'label' => 'Column width for Grid View.',
                        'value' => 324,
                    ),
                    'validators' => array(
                        array('Int', true),
                        array('GreaterThan', true, array(0)),
                    ),
                ),
                array(
                    'MultiCheckbox',
                    'newsOption',
                    array(
                        'label' => 'Choose the options that you want to display for the RSS in this block.',
                        'multiOptions' => array(
                            'title' => 'News Title',
                            'creationDate' => 'Creation Date',
                            'view' => 'Views',
                            'location' => 'Location',
                            'description' => 'Description',
                            'like' => 'Likes',
                            'comment' => 'Comments',
                            'favourite' => 'Favourite',
                            'facebook' => 'Facebook [Social Share Link]',
                            'twitter' => 'Twitter [Social Share Link]',
                            'linkedin' => 'LinkedIn [Social Share Link]',
                            'googleplus' => 'Google+ [Social Share Link]'
                        ),
                    )
                ),
                array(
                    'Radio',
                    'subscribeRss',
                    array(
                        'label' => 'Do you want to show subscribe feature for RSS ?',
                        'multiOptions' => array(
                            '1' => 'Yes',
                            '0' => 'No',
                        ),
                        'value' => 1,
                    )
                ),
                array(
                    'Select',
                    'show_content',
                    array(
                        'label' => 'What do you want for view more content?',
                        'multiOptions' => array(
                            '2' => 'Show View More Link at Bottom',
                            '3' => 'Auto Load Content on Scrolling Down'),
                        'value' => 2,
                    )
                ),
                array(
                    'Text',
                    'itemCountPerPage',
                    array(
                        'label' => 'Count',
                        'description' => '(Number of items to show)',
                        'value' => 12,
                    ),
                    'validators' => array(
                        array('Int', true),
                    ),
                ),
                array(
                    'Radio',
                    'listDescription',
                    array(
                        'label' => 'Show description in List view?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => '1',
                    )
                ),
//                array(
//                    'Radio',
//                    'gridDescription',
//                    array(
//                        'label' => 'Show description in Grid view?',
//                        'multiOptions' => array(
//                            1 => 'Yes',
//                            0 => 'No'
//                        ),
//                        'value' => '0',
//                    )
//                ),
                array(
                    'Text',
                    'titleTruncationGridNNewsView',
                    array(
                        'label' => 'Title truncation limit',
                        'value' => 22,
                    ),
                    'validators' => array(
                        array('Int', true),
                    ),
                ),
                array(
                    'Text',
                    'descriptionTruncation',
                    array(
                        'label' => 'Description truncation limit',
                        'value' => 100,
                    ),
                    'validators' => array(
                        array('Int', true),
                    ),
                ),
            )
        ),
        'autoEdit' => true
    ),
    // News of the day
    array(
        'title' => 'News of the day',
        'description' => 'Displays news as the news of the day (Special News). You can choose the news to be shown as special news in this widget by editing the settings of this widget. This widget should be placed in the left / right side bar on the respective widgetized page.',
        'category' => 'News',
        'type' => 'widget',
        'autoEdit' => true,
        'name' => 'sitenews.special-news',
        'adminForm' => 'Sitenews_Form_Admin_Widget_Specialnews',
        'defaultParams' => array(
            'title' => 'News of the day',
        ),
    ),
    array(
        'title' => 'My RSS',
        'description' => 'Displays all the RSS added by the user.',
        'category' => 'News',
        'type' => 'widget',
        'autoEdit' => true,
        'name' => 'sitenews.my-rss',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
            "topNavigationLink" => array("news", "rss", "createNews", "createRss"),
            "rssNavigationLink" => array("rss", "subscribed"),
            "viewType" => array("gridView", "listView"),
            "rssOption" => array("title", "numberOfFeeds", "subscribe")
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'MultiCheckbox',
                    'topNavigationLink',
                    array(
                        'label' => 'Choose the action links that you want to display in this block.',
                        'multiOptions' => $topNavigationLink,
                    )
                ),
                array(
                    'MultiCheckbox',
                    'rssNavigationLink',
                    array(
                        'label' => 'Choose the RSS navigation links that you want to display for the RSS on this page.',
                        'multiOptions' => array(
                            'rss' => 'RSS',
                            'subscribed' => 'Subscribed',
                        ),
                    )
                ),
                array(
                    'MultiCheckbox',
                    'viewType',
                    array(
                        'label' => 'Select the view type for RSS',
                        'multiOptions' => array(
                            'gridView' => 'Grid view',
                            'listView' => 'List view',
                        ),
                    )
                ),
                array(
                    'Select',
                    'defaultViewType',
                    array(
                        'label' => 'Select a default view type for RSS',
                        'multiOptions' => array(
                            'gridView' => 'Grid view',
                            'listView' => 'List view',
                        ),
                        'value' => 'gridView',
                    )
                ),
                array(
                    'Radio',
                    'searchButton',
                    array(
                        'label' => 'Do you want to show search for RSS in this block ?',
                        'multiOptions' => array(
                            '1' => 'Yes',
                            '0' => 'No',
                        ),
                        'value' => 1,
                    )
                ),
                array(
                    'Text',
                    'gridViewWidth',
                    array(
                        'label' => 'Column width for Grid View.',
                        'value' => 324,
                    ),
                    'validators' => array(
                        array('Int', true),
                        array('GreaterThan', true, array(0)),
                    ),
                ),
//                array(
//                    'Text',
//                    'gridViewHeight',
//                    array(
//                        'label' => 'Column height for Grid View.',
//                        'value' => 328,
//                    ),
//                    'validators' => array(
//                        array('Int', true),
//                        array('GreaterThan', true, array(0)),
//                    ),
//                ),
//                array(
//                    'Text',
//                    'listViewWidth',
//                    array(
//                        'label' => 'Column width for List View.',
//                        'value' => 324,
//                    ),
//                    'validators' => array(
//                        array('Int', true),
//                        array('GreaterThan', true, array(0)),
//                    ),
//                ),
//                array(
//                    'Text',
//                    'listViewHeight',
//                    array(
//                        'label' => 'Column height for List View.',
//                        'value' => 328,
//                    ),
//                    'validators' => array(
//                        array('Int', true),
//                        array('GreaterThan', true, array(0)),
//                    ),
//                ),
                array(
                    'MultiCheckbox',
                    'rssOption',
                    array(
                        'label' => 'Choose the options that you want to display for the RSS in this block.',
                        'multiOptions' => array(
                            'title' => 'RSS Title',
                            'rssUrl' => 'RSS Url',
                            'published' => 'Status',
                            'subscribe' => 'Subscribe',
                            'category' => 'Category',
                            'numberOfFeeds' => 'Number of news',
                            'creatonDate' => 'Creation Date',
                        ),
                    )
                ),
                array(
                    'Select',
                    'show_content',
                    array(
                        'label' => 'What do you want for view more content?',
                        'multiOptions' => array(
                            '2' => 'Show View More Link at Bottom',
                            '3' => 'Auto Load Content on Scrolling Down'),
                        'value' => 2,
                    )
                ),
                array(
                    'Text',
                    'itemCountPerPage',
                    array(
                        'label' => 'Count',
                        'description' => '(Number of items to show)',
                        'value' => 12,
                    ),
                    'validators' => array(
                        array('Int', true),
                    ),
                ),
                array(
                    'Text',
                    'titleTruncation',
                    array(
                        'label' => 'Title truncation limit',
                        'value' => 22,
                    ),
                    'validators' => array(
                        array('Int', true),
                    ),
                ),
//                array(
//                    'Text',
//                    'descriptionTruncation',
//                    array(
//                        'label' => 'Description truncation limit',
//                        'value' => 200,
//                    ),
//                    'validators' => array(
//                        array('Int', true),
//                    ),
//                ),
            )
        )
    ),
    array(
        'title' => 'News Navigation Tabs',
        'description' => 'Displays the Navigation tabs with links of News Home, Browse News, My News, News Categories etc. This widget should be placed at the top of any widgetized page.',
        'category' => 'News',
        'type' => 'widget',
        'name' => 'sitenews.browse-menu',
        'requirements' => array(
            'no-subject',
        ),
    ),
    array(
        'title' => 'Popular News Tags',
        'description' => "Displays popular tags. You can choose to display tags based on their frequency / alphabets from the Edit Settings of this widget. This widget should be placed in the left / right side bar on the 'News - News View' / 'News - Browse News' / 'News - News Home' pages.",
        'category' => 'News',
        'type' => 'widget',
        'autoEdit' => true,
        'name' => 'sitenews.tagcloud-sitenews-news',
        'defaultParams' => array(
            'title' => 'Popular Tags',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'title',
                    array(
                        'label' => 'Title',
                        'value' => 'Popular Tags',
                    )
                ),
                array(
                    'Radio',
                    'orderingType',
                    array(
                        'label' => 'Do you want to show popular News tags in alphabetical order ?',
                        'multiOptions' => array(
                            '1' => 'Yes',
                            '0' => 'No'
                        ),
                        'value' => '1',
                    )
                ),
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(Number of tags to show. Enter 0 for displaying all tags.)',
                        'value' => 25,
                    )
                ),
                array(
                    'Radio',
                    'loaded_by_ajax',
                    array(
                        'label' => 'Widget Content Loading',
                        'description' => 'Do you want the content of this widget to be loaded via AJAX, after the loading of main webpage content? (Enabling this can improve webpage loading speed. Disabling this would load content of this widget along with the page content.)',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
            ),
        ),
    ),
    array(
        'title' => 'Popular RSS Tags',
        'description' => "Displays popular tags. You can choose to display tags based on their frequency / alphabets from the Edit section of this widget. This widget should be placed in the left / right side bar on the â€œNews - Rss Viewâ€? / â€œNews - Browse Rssâ€? / â€œNews - Rss Homeâ€? page.",
        'category' => 'News',
        'type' => 'widget',
        'autoEdit' => true,
        'name' => 'sitenews.tagcloud-sitenews-rss',
        'defaultParams' => array(
            'title' => 'Popular Tags',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'title',
                    array(
                        'label' => 'Title',
                        'value' => 'Popular Tags ',
                    )
                ),
                array(
                    'Radio',
                    'orderingType',
                    array(
                        'label' => 'Do you want to show popular RSS tags in alphabetical order?',
                        'multiOptions' => array(
                            '1' => 'Yes',
                            '0' => 'No'
                        ),
                        'value' => '1',
                    )
                ),
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(Number of tags to show. Enter 0 for displaying all tags.)',
                        'value' => 25,
                    )
                ),
                array(
                    'Radio',
                    'loaded_by_ajax',
                    array(
                        'label' => 'Widget Content Loading',
                        'description' => 'Do you want the content of this widget to be loaded via AJAX, after the loading of main webpage content? (Enabling this can improve webpage loading speed. Disabling this would load content of this widget along with the page content.)',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
            ),
        ),
    ),
    array(
        'title' => 'News Categories: Displays Categories in Grid View with Icons',
        'description' => 'Displays News categories with icons in grid view on News Categories Home page.',
        'category' => 'News',
        'type' => 'widget',
        'autoEdit' => true,
        'name' => 'sitenews.categories-withicon-grid-view',
        'defaultParams' => array(
            'title' => 'Categories',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Radio',
                    'orderBy',
                    array(
                        'label' => 'Default ordering of Categories in Grid View.',
                        'multiOptions' => array(
                            'categoryName' => 'Category Name',
                            'catOrder' => 'Category Order according to creation'
                        ),
                        'value' => 'catOrder',
                    )
                ),
                array(
                    'Radio',
                    'showAllCategories',
                    array(
                        'label' => 'Do you want all the categories to be shown to the users even if they have 0 News in them ?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 0,
                    )
                ),
                array(
                    'Text',
                    'columnWidth',
                    array(
                        'label' => 'Column width for Grid View.',
                        'value' => '234',
                    )
                ),
                array(
                    'Text',
                    'columnHeight',
                    array(
                        'label' => 'Column height for Grid View.',
                        'value' => '216',
                    )
                ),
                array(
                    'Radio',
                    'showIcon',
                    array(
                        'label' => 'Do you want to show categories icon ?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
            )
        ),
    ),
    array(
        'title' => 'News Profile: Breadcrumb',
        'description' => 'Displays breadcrumb of the news based on the categories. This widget should be placed on the News - News View page.',
        'category' => 'News',
        'type' => 'widget',
        'name' => 'sitenews.profile-breadcrumb',
        'adminForm' => array(
            'elements' => array(
            ),
        ),
    ),
    array(
        'title' => 'News Categories: Displays Category with Background Image Slideshow',
        'description' => "Displays the news categories with background image in a slideshow. This widget should be placed on the  “News Categories Home” page.",
        'category' => 'News',
        'type' => 'widget',
        'autoEdit' => true,
        'name' => 'sitenews.news-categorybanner-slideshow',
        'defaultParams' => array(
            'title' => '',
        ),
        'adminForm' => 'Sitenews_Form_Admin_Widget_NewsCategorieBannerContentSlideshow',
        'autoEdit' => true
    )
);

