<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenews
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 2017-01-01 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenews_Installer extends Engine_Package_Installer_Module {

    public function onPreinstall() {
        $PRODUCT_TYPE = 'sitenews';
        $PLUGIN_TITLE = 'Sitenews';
        $PLUGIN_VERSION = '5.8.0p3';
        $PLUGIN_CATEGORY = 'plugin';
        $PRODUCT_DESCRIPTION = 'News / RSS Importer and Aggregator Plugin';
        $PRODUCT_TITLE = 'News / RSS Importer and Aggregator Plugin';
        $_PRODUCT_FINAL_FILE = 0;
        $SocialEngineAddOns_version = '4.8.13p4';

        $file_path = APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/ilicense.php";
        $is_file = @file_exists($file_path);
        if (empty($is_file)) {
            include APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/license3.php";
        } else {
            $db = $this->getDb();
            $select = new Zend_Db_Select($db);
            $select->from('engine4_core_modules')->where('name = ?', $PRODUCT_TYPE);
            $is_Mod = $select->query()->fetchObject();
            if (empty($is_Mod))
                include_once $file_path;
        }
                
        parent::onPreinstall();
    }

    public function onInstall() {
        try {
            $db = $this->getDb();
            $db->query('DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`name` = "sitenews_admin_main_settings_news"');
            try {
                
                $db->query("CREATE TABLE IF NOT EXISTS `engine4_seaocore_searchformsetting` (
                    `searchformsetting_id` int(11) NOT NULL AUTO_INCREMENT,
                    `module` varchar(64) COLLATE utf8_unicode_ci NOT NULL,
                    `name` varchar(64) COLLATE utf8_unicode_ci NOT NULL,
                    `display` tinyint(1) NOT NULL DEFAULT '1',
                    `order` int(11) NOT NULL DEFAULT '0',
                    `label` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
                    PRIMARY KEY(`searchformsetting_id`),
                    UNIQUE KEY `module` (`module`,`name`)
                    );"
                );

                $this->createSearchformSettings();
            } catch (Exception $e) {
                die('Exception ' . $e);
            }
            $db->query("CREATE TABLE IF NOT EXISTS `engine4_seaocore_favourites` (
                `favourite_id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT,
                `resource_type` varchar(32) CHARACTER SET latin1 COLLATE latin1_general_ci NOT NULL,
                `resource_id` int(11) UNSIGNED NOT NULL,
                `poster_type` varchar(32) CHARACTER SET latin1 COLLATE latin1_general_ci NOT NULL,
                `poster_id` int(11) UNSIGNED NOT NULL,
                `creation_date` datetime NOT NULL,
                PRIMARY KEY(`favourite_id`)
                );"
            );

            //facebookse integration
            $facebookse = $db->select()
                    ->from('engine4_core_modules')
                    ->where('name = ?', 'facebookse')
                    ->limit(1)
                    ->query()
                    ->fetchColumn();

            if (!empty($facebookse)) {

                $isModExist = $db->query("SELECT * FROM `engine4_facebookse_mixsettings` WHERE `module` LIKE 'sitenews' LIMIT 1")->fetch();
                if (empty($isModExist)) {
                    $db->query("INSERT INTO `engine4_facebookse_mixsettings` (`module`, `module_name`, `resource_type`, `resource_id`, `owner_field`, `module_title`, `module_description`, `enable`, `send_button`, `like_type`, `like_faces`, `like_width`, `like_font`, `like_color`, `layout_style`, `opengraph_enable`, `title`, `photo_id`, `description`, `types`, `fbadmin_appid`, `commentbox_enable`, `commentbox_privacy`, `commentbox_width`, `commentbox_color`, `module_enable`, `default`, `activityfeed_type`, `streampublish_message`, `streampublish_story_title`, `streampublish_link`, `streampublish_caption`, `streampublish_description`, `streampublish_action_link_text`, `streampublish_action_link_url`, `streampublishenable`, `activityfeedtype_text`, `action_type`, `object_type`, `like_commentbox`, `fbbutton_liketext`, `fbbutton_unliketext`, `show_customicon`, `fbbutton_likeicon`, `fbbutton_unlikeicon`) VALUES ('sitenews', 'News', 'sitenews_news', 'news_id', 'owner_id', 'title', 'description', 1, 1, 'like', 0, 450, '', '', 'standard', 0, '', 0, '', '', 1, 1, 1, 450, 'light', 1, 1, 'sitenews_news_new', 'View News!', '{*sitenews_title*}', '{*sitenews_url*}', '{*actor*} created a News on {*site_title*}: {*site_url*}.', '{*sitenews_desc*}', 'View News', '{*sitenews_url*}', 1, 'Creating a News', 'og.likes', 'object', 1, 'Like', 'Unlike', 1, '', '');");
                }
            }

            //suggestion integration
            $pluginInstalled = $db->select()
                    ->from('engine4_core_modules')
                    ->where('name = ?', 'suggestion')
                    ->limit(1)
                    ->query()
                    ->fetchColumn();
            if ($pluginInstalled) {
                $table_exist = $db->query("SHOW TABLES LIKE 'engine4_suggestion_module_settings'")->fetch();
                if ($table_exist) {
                    $entryExists = $db->select()
                            ->from('engine4_suggestion_module_settings')
                            ->where('module = ?', 'sitenews')
                            ->limit(1)
                            ->query()
                            ->fetchColumn();
                    if (empty($entryExists)) {
                        $db->query("INSERT IGNORE INTO `engine4_suggestion_module_settings` (`module`, `item_type`, `field_name`, `owner_field`, `item_title`, `button_title`, `enabled`, `notification_type`, `quality`, `link`, `popup`, `recommendation`, `default`, `settings`) VALUES ('sitenews', 'sitenews_news', 'news_id', 'owner_id', 'News', 'Read this News', 1, 'sitenews_suggestion', 1, 1, 0, 0, 1, 'a:1:{s:7:\"default\";i:1;}');");
                    }
                }
            }
            //communityad integration
            $select = new Zend_Db_Select($db);
            $select
                    ->from('engine4_core_modules')
                    ->where('name = ?', 'communityad');
            $is_sitenews_object = $select->query()->fetchObject();
            if (!empty($is_sitenews_object)) {
                $entryExists = $db->select()
                        ->from('engine4_communityad_modules')
                        ->where('module_name = ?', 'sitenews')
                        ->limit(1)
                        ->query()
                        ->fetchColumn();
                if (empty($entryExists)) {
                    $db->query("INSERT IGNORE INTO `engine4_communityad_modules` (`module_name`, `module_title`, `table_name`, `title_field`, `body_field`, `owner_field`, `is_delete`, `displayable`) VALUES ('sitenews', 'News', 'sitenews_news', 'title', 'description', 'owner_id', '1', '7');");
                }
            }

            //siteadvsearch integration
            $select = new Zend_Db_Select($db);
            $select
                    ->from('engine4_core_modules')
                    ->where('name = ?', 'siteadvsearch');
            $isModuleInstalled = $select->query()->fetchObject();
            if ($isModuleInstalled) {
                $engine4siteadvsearchTable = $db->query("SHOW TABLES LIKE 'engine4_siteadvsearch_contents'")->fetch();
                if ($engine4siteadvsearchTable) {
                    $entryExists = $db->select()
                            ->from('engine4_siteadvsearch_contents')
                            ->where('module_name = ?', 'sitenews')
                            ->limit(1)
                            ->query()
                            ->fetchColumn();
                    if (empty($entryExists)) {

                        $db->query("INSERT IGNORE INTO `engine4_siteadvsearch_contents` (`module_name`, `resource_type`, `resource_title`,  `widgetize`, `content_tab`, `main_search`, `order`, `file_id`, `default`, `enabled`) VALUES ('sitenews', 'sitenews_news', 'News', '0', '0', '1', '999', '0', '1', '1');");

                        $this->setAdvsearchLayout();
                    }
                }
            }

            // advancedactivity entry
            $table_page_exist = $db->query('SHOW TABLES LIKE "engine4_advancedactivity_contents"')->fetch();
            if (!empty($table_page_exist)) {
                $entryExists = $db->select()
                        ->from('engine4_advancedactivity_contents')
                        ->where('module_name = ?', 'sitenews')
                        ->limit(1)
                        ->query()
                        ->fetchColumn();
                if (empty($entryExists)) {
                    $db->query("INSERT IGNORE INTO `engine4_advancedactivity_contents` ( `module_name`, `filter_type`, `resource_title`, `content_tab`, `order`, `default`) VALUES
('sitenews', 'sitenews', 'News', 1, 7, 1)");
                }
            }

            $table_exist = $db->query('SHOW TABLES LIKE "engine4_advancedactivity_customtypes"')->fetch();
            if (!empty($table_exist)) {
                $entryExists = $db->select()
                        ->from('engine4_advancedactivity_customtypes')
                        ->where('module_name = ?', 'sitenews')
                        ->limit(1)
                        ->query()
                        ->fetchColumn();
                if (empty($entryExists)) {
                    $db->query("INSERT IGNORE INTO `engine4_advancedactivity_customtypes` ( `module_name`, `resource_type`, `resource_title`, `enabled`, `order`, `default`) VALUES
('sitenews', 'sitenews_news', 'News', 1, 12, 1)");
                }
            }

            //sitelike integration
            $sitelike = $db->select()
                    ->from('engine4_core_modules')
                    ->where('name = ?', 'sitelike')
                    ->limit(1)
                    ->query()
                    ->fetchColumn();

            if (!empty($sitelike)) {
                $table_exist = $db->query('SHOW TABLES LIKE "engine4_sitelike_mixsettings"')->fetch();
                if (!empty($table_exist)) {
                    $isModExist = $db->query("SELECT * FROM `engine4_sitelike_mixsettings` WHERE `module` LIKE 'sitenews' LIMIT 1")->fetch();
                    if (empty($isModExist)) {
                        $db->query("INSERT IGNORE INTO `engine4_sitelike_mixsettings` (`module`, `resource_type`, `resource_id`, `item_title`, `title_items`, `value`, `default`, `enabled`) VALUES ('sitenews', 'sitenews_news', 'news_id', 'News', 'News', 1, 0, 1);");
                    }
                }
            }

            //sitehashtag integration
            $sitehashtag = $db->select()
                    ->from('engine4_core_modules')
                    ->where('name = ?', 'sitehashtag')
                    ->limit(1)
                    ->query()
                    ->fetchColumn();

            if (!empty($sitehashtag)) {
                $isModExist = $db->query("SELECT * FROM `engine4_sitehashtag_contents` WHERE `module_name` LIKE 'sitenews' LIMIT 1")->fetch();
                if (empty($isModExist)) {
                    $db->query('INSERT IGNORE INTO `engine4_sitehashtag_contents` (`module_name`, `resource_type`, `enabled`) VALUES ("sitenews", "sitenews", 1);');
                }
            }

            //nestedcomment integration
            $select = new Zend_Db_Select($db);
            $select
                    ->from('engine4_core_modules')
                    ->where('name = ?', 'nestedcomment');
            $is_sitenews_object = $select->query()->fetchObject();
            if ($is_sitenews_object) {
                $db->query("INSERT IGNORE INTO `engine4_nestedcomment_modules` (`module`, `resource_type`, `enabled`) 
VALUES ('sitenews', 'sitenews_news', 0)");
                $db->query('INSERT IGNORE INTO `engine4_activity_actiontypes` (`type`, `module`, `body`, `enabled`, `displayable`, `attachable`, `commentable`, `shareable`, `is_generated`) VALUES ("nestedcomment_sitenews_news", "sitenews", \'{item:$subject} replied to a comment on {item:$owner}\'\'s news {item:$object:$title}: {body:$body}\', 1, 1, 1, 1, 1, 1)');
                $db->query('INSERT IGNORE INTO `engine4_activity_notificationtypes` (`type`, `module`, `body`, `is_request`, `handler`) VALUES ("sitenews_activityreply", "sitenews", \'{item:$subject} has replied on {var:$eventname}.\', 0, "");');
            }

            parent::onInstall();
        } catch (Exception $e) {
            echo $e;
            die;
        }
    }

    public function onEnable() {
        $db = $this->getDb();
        $db->query("UPDATE `engine4_core_modules` SET `enabled` = 1 WHERE name = 'sitenews'; ");
        $db->query("UPDATE `engine4_core_menuitems` SET `enabled` = 1 WHERE name = 'core_main_news'; ");
        parent::onEnable();
    }

    public function onDisable() {
        $db = $this->getDb();
        $db->query("UPDATE `engine4_core_modules` SET `enabled` = 0 WHERE name = 'sitenews'; ");
        $db->query("UPDATE `engine4_core_menuitems` SET `enabled` = 0 WHERE name = 'core_main_news'; ");
        parent::onDisable();
    }

    protected function _columnExist($table, $column) {
        $db = $this->getDb();

        $columnName = $db->query("
        SHOW COLUMNS FROM `$table`
           LIKE '$column'")->fetch();
        if (!empty($columnName))
            return true;
        return false;
    }

    protected function createSearchformSettings() {
        $db = $this->getDb();
        $db->query("INSERT IGNORE INTO `engine4_seaocore_searchformsetting` (`module`, `name`, `display`, `order`, `label`) VALUES 
            ('sitenews_rss', 'search', 1, 5, 'Name / Keyword'),
            ('sitenews_rss', 'view', 1, 10, 'View'),
            ('sitenews_rss', 'orderby', 1, 15, 'Browse By'),
            ('sitenews_rss', 'category_id', 1, 20, 'Category'),
            ('sitenews_news', 'search', 1, 5, 'Name / Keyword'),
            ('sitenews_news', 'rss', 1, 8, 'RSS Feed'),
            ('sitenews_news', 'view', 1, 12, 'View'),
            ('sitenews_news', 'type', 1, 20, 'Type'),
            ('sitenews_news', 'orderby', 1, 30, 'Browse By'),
            ('sitenews_news', 'location', 1, 40, 'Location'),
            ('sitenews_news', 'proximity', 1, 50, 'Proximity Search'),
            ('sitenews_news', 'street', 1, 60, 'Street'),
            ('sitenews_news', 'city', 1, 70, 'City'),
            ('sitenews_news', 'state', 1, 80, 'State'),
            ('sitenews_news', 'country', 1, 90, 'Country'),
            ('sitenews_news', 'category_id', 1, 100, 'Category');");
    }

    protected function setAdvsearchLayout() {
        $db = $this->getDb();
        //Make the layout work for Sitenews

        $containerCount = 0;
        $widgetCount = 0;
        $page_id = $db->select()
                ->from('engine4_core_pages', 'page_id')
                ->where('name = ?', 'siteadvsearch_index_browse-page_sitenews_news')
                ->limit(1)
                ->query()
                ->fetchColumn();
        if (!$page_id) {
            $db->insert('engine4_core_pages', array(
                'name' => 'siteadvsearch_index_browse-page_sitenews_news',
                'displayname' => 'Advanced Search - SEAO - News',
                'title' => '',
                'description' => '',
                'custom' => 0,
            ));
            $page_id = $db->lastInsertId();

            //TOP CONTAINER
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'top',
                'page_id' => $page_id,
                'order' => $containerCount++,
            ));
            $top_container_id = $db->lastInsertId();

            //MAIN CONTAINER
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'main',
                'page_id' => $page_id,
                'order' => $containerCount++,
            ));
            $main_container_id = $db->lastInsertId();

            //INSERT TOP-MIDDLE
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'middle',
                'page_id' => $page_id,
                'parent_content_id' => $top_container_id,
                'order' => $containerCount++,
            ));
            $top_middle_id = $db->lastInsertId();

            //RIGHT CONTAINER
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'right',
                'page_id' => $page_id,
                'parent_content_id' => $main_container_id,
                'order' => $containerCount++,
            ));
            $right_container_id = $db->lastInsertId();

            //MAIN-MIDDLE CONTAINER
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'middle',
                'page_id' => $page_id,
                'parent_content_id' => $main_container_id,
                'order' => $containerCount++,
            ));
            $main_middle_id = $db->lastInsertId();

            $db->insert('engine4_core_content', array(
                'page_id' => $page_id,
                'type' => 'widget',
                'name' => 'sitenews.search-news-sitenews',
                'parent_content_id' => $right_container_id,
                'order' => $widgetCount++,
                'params' => '{"title":"SEARCH","titleCount":true,"viewType":"vertical","showAllCategories":"1","locationDetection":"1","nomobile":"0","name":"sitenews.search-news-sitenews"}',
            ));

            $db->insert('engine4_core_content', array(
                'page_id' => $page_id,
                'type' => 'widget',
                'name' => 'sitenews.browse-news-sitenews',
                'parent_content_id' => $main_middle_id,
                'order' => $widgetCount++,
                'params' => '{"title":"","titleCount":true,"viewType":["gridView","listView"],"defaultViewType":"gridView","newsOption":["title","provider"],"categoryids":null,"subcategoryids":null,"hidden_category_id":"","hidden_subcategory_id":"","hidden_subsubcategory_id":"","rss":"0","gridViewHeight":"200","gridViewWidth":"250","titleInsideGrid":"1","showPhotosInJustifiedView":"0","rowHeight":"205","maxRowHeight":"300","margin":"30","lastRow":"justify","descriptionInsideGrid":"0","orderby":"creationDate","show_content":"2","titleTruncation":"22","descriptionTruncation":"100","detactLocation":"0","defaultLocationDistance":"1000","listDescription":"1","gridDescription":"0","itemCountPerPage":"6","nomobile":"0","name":"sitenews.browse-news-sitenews"}',
            ));
        }
    }

}
