<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenews
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-01-01 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenews_Widget_BrowselocationSitenewsController extends Engine_Content_Widget_Abstract {

    public function indexAction() {

        $sitenews_browse_location = Zend_Registry::isRegistered('sitenews_browse_location') ? Zend_Registry::get('sitenews_browse_location') : null;
        if(empty($sitenews_browse_location))
            return $this->setNoRender();

        $this->view->addHelperPath(APPLICATION_PATH . '/application/modules/Sitenews/View/Helper', 'Sitenews_View_Helper');
        $request = Zend_Controller_Front::getInstance()->getRequest();
        $this->view->viewType = $this->_getParam('viewType', 'vertical');
        $this->view->advancedSearch = $this->_getParam('advancedSearch', 0);
        $this->view->showAllCategories = $this->_getParam('showAllCategories', 1);
        $this->view->locationDetection = $this->_getParam('locationDetection', 0);
        $sitenewsBrowseLocation = Zend_Registry::isRegistered('sitenewsBrowseLocation') ? Zend_Registry::get('sitenewsBrowseLocation') : null;
        $this->view->newsOption = $this->_getParam('newsOption', array('title', 'owner', 'provider', 'creationDate', 'view', 'like', 'comment', 'location'));
        $widgetSettings = array(
            'advancedSearch' => $this->view->advancedSearch,
            'showAllCategories' => $this->view->showAllCategories,
            'locationDetection' => $this->view->locationDetection,
        );
        // Make form
        $this->view->form = $form = new Sitenews_Form_Locationsearch(array('widgetSettings' => $widgetSettings));

        if (!empty($_POST)) {
            $this->view->is_ajax = $_POST['is_ajax'];
        }

        if ($this->view->is_ajax) {
            $this->getElement()->removeDecorator('Title');
            $this->getElement()->removeDecorator('Container');
        }

        $front = Zend_Controller_Front::getInstance();
        $module = $front->getRequest()->getModuleName();
        $action = $front->getRequest()->getActionName();
        $controller = $front->getRequest()->getControllerName();
        if (!($module == 'sitenews' && $controller == 'news' && $action == 'map') && empty($this->view->is_ajax)) {
            return $this->setNoRender();
        }

        if (empty($_POST['location'])) {
            $this->view->locationVariable = '1';
        }

        if (empty($_POST['is_ajax'])) {
            $values = $form->getValues();
            $this->view->is_ajax = $this->_getParam('is_ajax', 0);
        } else {
            $values = $_POST;
            $form->isValid($values);
            $parms = $form->getValues();
            $values = array_merge($values, $parms);
        }

        unset($values['or']);

        $this->view->assign($values);

        $viewer = Engine_Api::_()->user()->getViewer();

        if (!empty($params['view_view']) && $params['view_view'] == 1) {
            //GET AN ARRAY OF FRIEND IDS
            $friends = $viewer->membership()->getMembers();
            $ids = array();
            foreach ($friends as $friend) {
                $ids[] = $friend->user_id;
            }
            $params['users'] = $ids;
        }

        $request = Zend_Controller_Front::getInstance()->getRequest();

        $values['type'] = 'browse';
        $values['type_location'] = 'browseLocation';
        $this->view->truncationLocation = $this->_getParam('truncationLocation', 35);

        if (isset($values['show'])) {
            if ($form->show->getValue() == 3) {
                @$values['show'] = 3;
            }
        }

        if ($request->getParam('page'))
            $this->view->current_page = $page = $request->getParam('page');
        else
            $this->view->current_page = $page = $this->_getParam('page', 1);
        $form->page->setValue($page);
        $this->view->enableLocation = $checkLocation = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitenews.news.location', 0);

        if (isset($values['locationmiles']) && !empty($values['locationmiles'])) {

            if (isset($values['news_street']) && !empty($values['news_street'])) {
                $values['location'] = $values['news_street'] . ',';
                unset($values['news_street']);
            }

            if (isset($values['news_city']) && !empty($values['news_city'])) {
                $values['location'].= $values['news_city'] . ',';
                unset($values['news_city']);
            }

            if (isset($values['news_state']) && !empty($values['news_state'])) {
                $values['location'].= $values['news_state'] . ',';
                unset($values['news_state']);
            }

            if (isset($values['news_country']) && !empty($values['news_country'])) {
                $values['location'].= $values['news_country'];
                unset($values['news_country']);
            }
        }

        $values['orderby'] = $orderBy = $request->getParam('orderby', null);

        if (empty($orderBy)) {
            $orderby = $this->_getParam('orderby', 'creation_date');
            if ($orderby == 'creationDate')
                $values['orderby'] = 'creation_date';
            else
                $values['orderby'] = $orderby;
        }

        $result = Engine_Api::_()->getDbtable('news', 'sitenews')->getNewsSelect($values, $customFieldValues);

        $this->view->paginator = $paginator = Zend_Paginator::factory($result);
        $paginator->setItemCountPerPage(5);
        $this->view->paginator = $paginator->setCurrentPageNumber($page);
        $this->view->totalresults = $paginator->getTotalItemCount();
        $this->view->mobile = Engine_Api::_()->seaocore()->isMobile();
        $this->view->flageSponsored = 0;

        if (!empty($checkLocation) && $paginator->getTotalItemCount() > 0) {

            $ids = array();
            foreach ($paginator as $news) {
                $id = $news->getIdentity();
                $ids[] = $id;
                $news_temp[$id] = $news;
            }
            $values['news_ids'] = $ids;
            $this->view->locations = $locations = Engine_Api::_()->getDbtable('locations', 'sitenews')->getLocation($values);
            foreach ($locations as $location) {
                if ($news_temp[$location->news_id]->sponsored) {
                    $this->view->flageSponsored = 1;
                    break;
                }
            }

            $this->view->list = $news_temp;
        } else {
            $this->view->enableLocation = 0;
        }

        $this->view->isViewMoreButton = false;
        $this->view->titleTruncation = 100;
        $this->view->descriptionTruncation = 100;
        $this->view->message = "No News have been added yet.";
        $this->view->widgetPath = 'widget/index/mod/sitenews/name/browselocation-sitenews';
    }

}
