<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenews
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-01-01 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenews_Widget_ListRssSitenewsController extends Engine_Content_Widget_Abstract {

    public function indexAction() {

        $sitenews_list_rss = Zend_Registry::isRegistered('sitenews_list_rss') ? Zend_Registry::get('sitenews_list_rss') : null;
        if(empty($sitenews_list_rss))
            return $this->setNoRender();

        if (!Engine_Api::_()->getApi('settings', 'core')->getSetting('sitenews.rss.allow', 1)) {

            return $this->setNoRender();
        }
        
        $viewer = Engine_Api::_()->user()->getViewer();
        $memberLevelAllow = Engine_Api::_()->authorization()->isAllowed('sitenews_rss', $viewer, 'view');
        if(!$memberLevelAllow){
            return $this->setNoRender();
        }

        $this->view->addHelperPath(APPLICATION_PATH . '/application/modules/Sitenews/View/Helper', 'Sitenews_View_Helper');
        $params = array();

        if (isset($params['page']) && !empty($params['page']))
            $page = $params['page'];
        else
            $page = $this->_getParam('page', 1);

        $this->view->titleTruncation = $titleTruncation = $this->_getParam('titleTruncation', 22);
        $subscribeRss = $this->_getParam('subscribeRss', 1);
        if ($subscribeRss) {
            $this->view->rssOption = $rssOption = array('subscribe');
        }
        $this->view->showViewMore = $params['showViewMore'] = $this->_getParam('showViewMore', 'Yes');
        $this->view->itemCount = $params['itemCount'] = $this->_getParam('itemCount', 12);
        $this->view->paginator = $paginator = Engine_Api::_()->getDbtable('rss', 'sitenews')->getRssPaginator($params);
        $this->view->params = $params;
        $this->view->totalCount = $count = $paginator->getTotalItemCount();

        if ($paginator->getTotalItemCount() <= 0)
            return $this->setNoRender();
        if($params['itemCount'] == 0) {
            $paginator->setItemCountPerPage($count);
        } else {
            $paginator->setItemCountPerPage($params['itemCount']);
        }
        $paginator->setCurrentPageNumber($page);
    }

}
