<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenews
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-01-01 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenews_Widget_MyLikednewsSitenewsController extends Seaocore_Content_Widget_Abstract {

    public function indexAction() {
        
        $sitenews_my_liked = Zend_Registry::isRegistered('sitenews_my_liked') ? Zend_Registry::get('sitenews_my_liked') : null;
        if(empty($sitenews_my_liked))
            return $this->setNoRender();

        $this->view->addHelperPath(APPLICATION_PATH . '/application/modules/Sitenews/View/Helper', 'Sitenews_View_Helper');
        $viewer = Engine_Api::_()->user()->getViewer();

        if (!$viewer->getIdentity()) {
            return $this->setNoRender();
        }

        $params = Zend_Controller_Front::getInstance()->getRequest()->getParams();

        //FIND THE PAGE NUMBER
        if (isset($params['page']) && !empty($params['page']))
            $this->view->page = $page = $params['page'];
        else
            $this->view->page = $page = 1;
        // ASSIGNING THE PARAMETER
        $this->view->is_ajax_load = $this->_getParam('loaded_by_ajax', false);
        $this->view->viewFormat = $params['viewFormat'] = $this->_getParam('viewFormat', 'newsView');
        $this->view->is_ajax = $this->_getParam('is_ajax', '');
        $this->view->showContent = $params['show_content'] = $this->_getParam('show_content', 2);
        $params['itemCountPerPage'] = $this->_getParam('itemCountPerPage', 12);
        $this->view->order = $params['order'] = $this->_getParam('order');
        $params['owner'] = Engine_Api::_()->user()->getViewer();
        $params['owner_id'] = Engine_Api::_()->user()->getViewer()->getIdentity();
        $this->view->newsViewWidth = $params['newsViewWidth'] = $this->_getParam('newsViewWidth', 150);
        $this->view->newsViewHeight = $params['newsViewHeight'] = $this->_getParam('newsViewHeight', 150);
        $this->view->gridViewWidth = $params['gridViewWidth'] = $this->_getParam('gridViewWidth', 250);
        $this->view->gridViewHeight = $params['gridViewHeight'] = $this->_getParam('gridViewHeight', 200);
        $this->view->newsViewThumbnailType = $params['newsViewThumbnailType'] = $this->_getParam('newsViewThumbnailType', 'thumb.normal');
        $this->view->gridViewThumbnailType = $params['gridViewThumbnailType'] = $this->_getParam('gridViewThumbnailType', 'thumb.normal');
        $this->view->titleTruncationListView = $this->view->titleTruncation = $params['titleTruncation'] = $this->_getParam('titleTruncation', 22);
        $this->view->titleTruncationGridNNewsView = $params['titleTruncationGridNNewsView'] = $this->_getParam('titleTruncationGridNNewsView', 22);
        $this->view->descriptionTruncation = $params['descriptionTruncation'] = $this->_getParam('descriptionTruncation', 200);
        $this->view->newsOption = $params['newsOption'] = $this->_getParam('newsOption', array());
        $this->view->listDescription = $params['listDescription'] = $this->_getParam('listDescription', 1);
        $this->view->gridDescription = $params['gridDescription'] = $this->_getParam('gridDescription', 0);
        $this->view->isViewMoreButton = true;
        $this->view->id = $params['idenity'] = $this->_getParam('identity');
        $viewer_id = $this->view->viewerId = $viewer->getIdentity();
        $level_id = Engine_Api::_()->user()->getViewer()->level_id;
        $this->view->can_create = Engine_Api::_()->authorization()->getPermission($level_id, 'sitenews_news', 'create');

        if (is_null($this->view->newsOption)) {
            $this->view->newsOption = array();
        }

        $this->view->newsoOptionWithOwner = array_merge($params['newsOption'], array('owner'));
        $params['newsOption'] = $this->view->newsOptionWithOwner;
        $this->view->showEditDeleteOption = false;
        $this->view->widgetPath = 'widget/index/mod/sitenews/name/my-likednews-sitenews';
        $this->view->message = 'You have not liked any News.';
        $this->view->widgetName = 'my-likednews';

        if (isset($params['search']) && !empty($params['search']))
            $this->view->message = 'No liked News found in search criteria.';

        $this->view->params = $params;
        $params['paginator'] = 1;

        $params['myNews'] = true;
        $paginator = $this->view->paginator = Engine_Api::_()->getDbTable('news', 'sitenews')->getLikedNewsPaginator($params);

        //FIND TOTAL NO. OF RECORDS
        $this->view->totalCount = $paginator->getTotalItemCount();

        //SET THE NO. OF RECORDS PER PAGE
        $paginator->setItemCountPerPage($params['itemCountPerPage']);

        //SET THE CURRENT PAGE NO.
        $paginator->setCurrentPageNumber($page);
    }

}
