<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenews
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-01-01 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenews_Widget_MyNewsController extends Seaocore_Content_Widget_Abstract {

    protected $_childCount;

    public function indexAction() {
        
        $sitenews_my_news = Zend_Registry::isRegistered('sitenews_my_news') ? Zend_Registry::get('sitenews_my_news') : null;
        if(empty($sitenews_my_news))
            return $this->setNoRender();

        $this->view->addHelperPath(APPLICATION_PATH . '/application/modules/Sitenews/View/Helper', 'Sitenews_View_Helper');

        if (Engine_Api::_()->core()->hasSubject('user') && Engine_Api::_()->core()->getSubject('user')) {
            $viewer = Engine_Api::_()->core()->getSubject('user');
        } else
            $viewer = Engine_Api::_()->user()->getViewer();

        if (!$viewer->getIdentity()) {

            return $this->setNoRender();
        }

        $request = Zend_Controller_Front::getInstance()->getRequest();
        $params = $request->getParams();
        $this->view->defaultViewType = $params['defaultViewType'] = $this->_getParam('defaultViewType', 'newsView');
        $this->view->feedsDefaultViewType = $params['feedsDefaultViewType'] = $this->_getParam('feedsDefaultViewType', 'gridView');

        if (!isset($params['viewFormat']))
            $this->view->viewFormat = $params['viewFormat'] = $params['defaultViewType'];
        else
            $this->view->viewFormat = $params['viewFormat'];

        $page = $this->_getParam('page', 1);
        $sitenewsNewsList = Zend_Registry::isRegistered('sitenewsNewsList') ? Zend_Registry::get('sitenewsNewsList') : null;

        $this->view->topNavigationLink = $params['topNavigationLink'] = $this->_getParam('topNavigationLink', array('news', 'rss', 'createNews', 'createRss'));

        $this->view->newsNavigationLink = $params['newsNavigationLink'] = $this->_getParam('newsNavigationLink', array('news', 'liked', 'favourite'));

        $this->view->viewType = $params['viewType'] = $this->_getParam('viewType', array('newsView', 'gridView', 'listView'));

        $this->view->searchButton = $params['searchButton'] = $this->_getParam('searchButton', 1);
        $this->view->newsViewWidth = $params['newsViewWidth'] = $this->_getParam('newsViewWidth', 150);
        $this->view->newsViewHeight = $params['newsViewHeight'] = $this->_getParam('newsViewHeight', 150);
        $this->view->gridViewWidth = $params['gridViewWidth'] = $this->_getParam('gridViewWidth', 250);
        $this->view->gridViewHeight = $params['gridViewHeight'] = $this->_getParam('gridViewHeight', 200);
        $this->view->feedsGridViewWidth = $params['feedsGridViewWidth'] = $this->_getParam('feedsGridViewWidth', 150);
        $this->view->feedsGridViewHeight = $params['feedsGridViewHeight'] = $this->_getParam('feedsGridViewHeight', 150);
        $this->view->newsOption = $params['newsOption'] = $this->_getParam('newsOption', array('title', 'owner', 'creationDate', 'view', 'like', 'comment', 'favourite', 'location', 'facebook', 'twitter', 'linkedin', 'googleplus'));
        $this->view->listDescription = $params['listDescription'] = $this->_getParam('listDescription', 1);
        $this->view->gridDescription = $params['gridDescription'] = $this->_getParam('gridDescription', 0);
        $this->view->showContent = $params['show_content'] = $this->_getParam('show_content', 2);
        $this->view->titleTruncationListView = $this->view->titleTruncation = $params['titleTruncation'] = $this->_getParam('titleTruncation', 22);
        $this->view->titleTruncationGridNNewsView = $params['titleTruncationGridNNewsView'] = $this->_getParam('titleTruncationGridNNewsView', 22);
        $this->view->descriptionTruncation = $params['descriptionTruncation'] = $this->_getParam('descriptionTruncation', 200);
        $this->view->itemCountPerPage = $params['itemCountPerPage'] = $this->_getParam('itemCountPerPage', 12);
        $this->view->orderby = $params['orderby'] = $this->_getParam('orderby');
        $this->view->controllerName = $params['controller'];
        $this->view->actionName = $params['action'];
        $this->view->memberLevelRssView = Engine_Api::_()->authorization()->getPermission($viewer->level_id, 'sitenews_rss','view');

        if (isset($params['is_ajax']))
            $this->view->is_ajax = $params['is_ajax'];
        else
            $this->view->is_ajax = $params['is_ajax'] = false;

        if (empty($this->view->topNavigationLink) || !is_array($this->view->topNavigationLink))
            $this->view->topNavigationLink = $params['topNavigationLink'] = array();

        if (empty($this->view->newsOption) || !is_array($this->view->newsOption))
            $this->view->newsOption = $params['newsOption'] = array();

        if (empty($this->view->newsNavigationLink) || !is_array($this->view->newsNavigationLink))
            $this->view->newsNavigationLink = $params['newsNavigationLink'] = array();

        if (count($this->view->newsNavigationLink) <= 0)
            return $this->setNoRender();

        if (empty($this->view->viewType) || !is_array($this->view->viewType))
            $this->view->viewType = $params['viewType'] = array();

        $this->view->tab = $request->getParam('tab', null);
        $this->view->canUploadNews = Engine_Api::_()->authorization()->isAllowed('sitenews_news', $viewer, 'create');
        $this->view->canCreateRss = Engine_Api::_()->authorization()->isAllowed('sitenews_rss', $viewer, 'create');
        $this->view->feedViewType = $params['feedViewType'] = $this->_getParam('feedsViewType', array('gridView', 'listView'));
        $this->view->newsShowLinkCount = $params['newsShowLinkCount'] = $this->_getParam('newsShowLinkCount', 3);
        $this->view->feedOrder = $params['feedOrder'] = $this->_getParam('feedOrder', 'publish_date');
        $this->view->feedNewsOrder = $params['feedNewsOrder'] = $this->_getParam('feedNewsOrder', 'creation_date');
//        $this->view->showPlayAllOption = $params['showPlayAllOption'] = $this->_getParam('showPlayAllOption', 1);
        $this->view->watchlaterOrder = $params['watchlaterOrder'] = $this->_getParam('watchlaterOrder', 'creation_date');
        $this->view->widgetPath = 'widget/index/mod/sitenews/name/my-news';
        $this->view->message = 'You have not added any News.';

        if (isset($params['search']) && !empty($params['search']))
            $this->view->message = 'No News found in this search criteria.';

        if (empty($this->view->feedsViewType))
            $this->view->feedsViewType = array();

        $this->view->isViewMoreButton = true;
        $this->view->showEditDeleteOption = true;
        $this->view->id = $params['id'] = $this->_getParam('identity');
        $newsSize = array();
        $newsSize['thumb.normal'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('normal.news.width', 375);
        $newsSize['thumb.large'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('normallarge.news.width', 720);
        $newsSize['thumb.main'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('main.news.height', 1600);
        $newsSize['width'] = $this->view->newsViewWidth;
        $thumbnailType = Engine_Api::_()->getApi('core', 'sitenews')->findThumbnailType($newsSize, $this->view->newsViewWidth);

        $this->view->newsViewThumbnailType = $params['newsViewThumbnailType'] = $thumbnailType;
        $newsSize['width'] = $this->view->gridViewWidth;
        $thumbnailType = Engine_Api::_()->getApi('core', 'sitenews')->findThumbnailType($newsSize, $this->view->gridViewWidth);
        $this->view->gridViewThumbnailType = $params['gridViewThumbnailType'] = $thumbnailType;
        $params['user'] = $viewer->getType();
        $params['user_id'] = $viewer->getIdentity();
        $this->view->params = $params;
        //FIND THE NEWS MODELS
        $params['myNews'] = true;
        $paginator = $this->view->paginator = Engine_Api::_()->getDbTable('news', 'sitenews')->getNewsPaginator($params);
        //FIND TOTAL NO. OF RECORDS
        $this->_childCount = $paginator->getTotalItemCount();
    }

    public function getChildCount() {
        return $this->_childCount;
    }

}
