<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenews
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-01-01 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenews_Widget_NewsMainAjaxHomeSitenewsController extends Seaocore_Content_Widget_Abstract {

    public function indexAction() {

        $sitenews_main_ajax_home = Zend_Registry::isRegistered('sitenews_main_ajax_home') ? Zend_Registry::get('sitenews_main_ajax_home') : null;
        if(empty($sitenews_main_ajax_home))
            return $this->setNoRender();

        $this->view->addHelperPath(APPLICATION_PATH . '/application/modules/Sitenews/View/Helper', 'Sitenews_View_Helper');
        $request = Zend_Controller_Front::getInstance()->getRequest();
        $params = $request->getParams();
        $this->view->defaultViewType = $params['defaultViewType'] = $this->_getParam('defaultViewType', 'gridZZZview');

        if (!isset($params['viewFormat']))
            $params['viewFormat'] = $params['defaultViewType'];

        $this->view->viewFormat = str_replace("ZZZ", "_", $params['viewFormat']);
        $page = $this->_getParam('page', 1);
        $layouts_views = $params['viewType'] = $this->_getParam('viewType', array('gridZZZview', 'listZZZview'));

        if ($layouts_views) {
            foreach ($layouts_views as $key => $value)
                $layouts_views[$key] = str_replace("ZZZ", "_", $value);
        }

        $this->view->viewType = $layouts_views;
        $this->view->listViewWidth = $params['listViewWidth'] = $this->_getParam('listViewWidth', 324);
        $this->view->listViewHeight = $params['listViewHeight'] = $this->_getParam('listViewHeight', 328);
        $this->view->gridViewWidth = $params['gridViewWidth'] = $this->_getParam('gridViewWidth', 250);
        $this->view->gridViewHeight = $params['gridViewHeight'] = $this->_getParam('gridViewHeight', 200);
        $this->view->newsOption = $params['newsOption'] = $this->_getParam('newsOption');
        $this->view->listDescription = $params['listDescription'] = $this->_getParam('listDescription', 1);
        $this->view->gridDescription = $params['gridDescription'] = $this->_getParam('gridDescription', 0);
        //$this->view->titleInsideGrid = $params['titleInsideGrid'] = $this->_getParam('titleInsideGrid');
        $this->view->listViewWithPhoto = $params['listViewWithPhoto'] = $this->_getParam('listViewWithPhoto');
        $this->view->gridViewCountPerPage = $params['gridItemCountPerPage'] = $this->_getParam('gridItemCountPerPage', 12);

        $this->view->listViewCountPerPage = $params['listItemCountPerPage'] = $this->_getParam('listItemCountPerPage', 12);
        $this->view->titleTruncation = $params['titleTruncation'] = $this->_getParam('titleTruncation', 22);
        $this->view->titleTruncationGridNNewsView = $params['titleTruncationGridNNewsView'] = $this->_getParam('titleTruncationGridNNewsView', 100);
        $this->view->descriptionTruncation = $params['descriptionTruncation'] = $this->_getParam('descriptionTruncation', 100);
        $this->view->showContent = $params['show_content'] = 2;
        $this->view->widgetPath = 'widget/index/mod/sitenews/name/news-main-ajax-home';
        $this->view->isViewMoreButton = false;
        $this->view->showViewMore = $this->_getParam('showViewMore', false);
        $this->view->is_ajax_load = !$this->_getParam('loaded_by_ajax', true);
        $this->view->truncationLocation = $this->_getParam('truncationLocation', 22);
        $this->view->listViewWithPhoto = $this->_getParam('listViewWithPhoto', 22);

        // loction code
        $this->view->detactLocation = $params['detactLocation'] = $this->_getParam('detactLocation', 0);
        if (!$this->view->detactLocation)
            $params['location'] = "";

        if ($this->view->detactLocation && Engine_Api::_()->getApi('settings', 'core')->getSetting('sitenews.news.location', 0)) {

            $this->view->defaultLocationDistance = $params['defaultLocationDistance'] = $this->_getParam('defaultLocationDistance', 1000);
            $this->view->latitude = $params['latitude'] = $this->_getParam('latitude', 0);
            $this->view->longitude = $params['longitude'] = $this->_getParam('longitude', 0);

            if (empty($this->view->latitude) && empty($this->view->longitude)) {
                $cookieLocation = Engine_Api::_()->seaocore()->getMyLocationDetailsCookie();
                $this->view->latitude = $params['latitude'] = $cookieLocation['latitude'];
                $this->view->longitude = $params['longitude'] = $cookieLocation['longitude'];
            }
        }

        if (empty($this->view->newsOption) || !is_array($this->view->newsOption)) {
            $this->view->newsOption = $params['newsOption'] = array();
        }

        $showTabArray = $params['ajaxTabs'] = $this->_getParam('ajaxTabs', array('featured', 'sponsored', 'recent', 'mostZZZviewed'));

        if ($showTabArray) {
            foreach ($showTabArray as $key => $value)
                $showTabArray[$key] = str_replace("ZZZ", "_", $value);
        } else {
            $showTabArray = array();
        }

        if (empty($this->view->viewType) || count($this->view->viewType) == 0) {
            $this->view->viewType = array($this->view->viewFormat);
        } else if (!in_array($this->view->viewFormat, $this->view->viewType)) {
            $this->view->viewFormat = $this->view->viewType[0];
        }

        $this->view->is_ajax_load = true;
        if ($this->_getParam('is_ajax_load', false)) {
            $this->view->is_ajax_load = true;
            if (!$this->_getParam('detactLocation', 0) || $this->_getParam('contentpage', 1) > 1)
                $this->getElement()->removeDecorator('Title');
            $this->getElement()->removeDecorator('Container');
        } else {

            if ($this->_getParam('detactLocation', 0))
                $this->getElement()->removeDecorator('Title');

            $this->view->is_ajax_load = !$this->_getParam('loaded_by_ajax', true);
        }

        $this->view->is_ajax = $isAjax = $this->_getParam('is_ajax', 0);

        $this->view->tabCount = count($showTabArray);

        if (empty($this->view->tabCount)) {
            return $this->setNoRender();
        }

        $this->view->heading = "";
        if (count($showTabArray) == 1) {
            $element = $this->getElement();
            $widgetTitle = $this->view->heading = $element->getTitle();
            if (!empty($widgetTitle)) {
                $element->setTitle("");
            } else {
                $this->view->heading = "";
            }
        }

        $order['most_viewed'] = $this->_getParam('most_viewed_order', '5');
        $order['recent'] = $this->_getParam('recent_order', '4');
        //$order['yesterday'] = $this->_getParam('yesterday_order', '3');
        $order['sponsored'] = $this->_getParam('sponsored_order', '2');
        $order['featured'] = $this->_getParam('featured_order', '1');

        $this->view->tabs = $showTabArray = $this->setTabsOrder($showTabArray, $order);
        $this->view->default_tabs = $showTabArray[0];

        if (!isset($params['category_id'])) {
            $params['category_id'] = 0;
        }

        if (!isset($params['subcategory_id']))
            $params['subcategory_id'] = 0;

        if (!isset($params['subsubcategory_id']))
            $params['subsubcategory_id'] = 0;

        if (empty($params['category_id'])) {
            $this->view->category_id = $params['category_id'] = $this->_getParam('category_id');
            $params['subcategory_id'] = $this->_getParam('subcategory_id');
            $params['subsubcategory_id'] = $this->_getParam('subsubcategory_id');
        }

        $newsSize = array();
        $newsSize['thumb.normal'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('normal.news.width', 375);
        $newsSize['thumb.large'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('normallarge.news.width', 720);
        $newsSize['thumb.main'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('main.news.height', 1600);
//        $newsSize['width'] = $this->view->newsViewWidth;
//        $thumbnailType = Engine_Api::_()->getApi('core', 'sitenews')->findThumbnailType($newsSize, $this->view->newsViewWidth);
//        $this->view->newsViewThumbnailType = $params['newsViewThumbnailType'] = $thumbnailType;
        $newsSize['width'] = $this->view->gridViewWidth;
        $thumbnailType = Engine_Api::_()->getApi('core', 'sitenews')->findThumbnailType($newsSize, $this->view->gridViewWidth);
        $this->view->gridViewThumbnailType = $params['gridViewThumbnailType'] = $thumbnailType;
        $filter = "";
        $this->view->message = 'Nobody has added a News yet.';
        $orderby = 'creationDate';

        // switch ($paramsContentType) {
        //     case 'featured' :
        //         $filter = 'featured';
        //         $orderby = 'creationDate';
        //         $this->view->message = 'No featured News found.';
        //         break;
        //     case 'sponsored' :
        //         $filter = 'sponsored';
        //         $orderby = 'creationDate';
        //         $this->view->message = 'No sponsored News found.';
        //         break;
        //     case 'mostViewed' :
        //         $orderby = 'viewCount';
        //         $this->view->message = 'Nobody has added a News yet.';
        //         break;

        //     case 'recent' :
        //         $orderby = 'creationDate';
        //         $this->view->message = 'Nobody has added a News yet.';
        //         break;
        //     default :
        //         $orderby = 'creationDate';
        // }
        $orderby = 'creationDate';
        $params['orderby'] = $orderby;
        $params['filter'] = $filter;
        $requestedAllParams = $this->_getAllParams();

        if (isset($requestedAllParams['hidden_news_category_id']) && !empty($requestedAllParams['hidden_news_category_id'])) {
            $this->view->category_id = $params['category_id'] = $this->_getParam('hidden_news_category_id');
            $this->view->subcategory_id = $params['subcategory_id'] = $this->_getParam('hidden_news_subcategory_id');
            $this->view->subsubcategory_id = $params['subsubcategory_id'] = $this->_getParam('hidden_news_subsubcategory_id');
        }

        $this->view->params = $params;

        if (!$this->view->is_ajax_load)
            return;

        $this->currentTab = $currentTab = $request->getParam('current_tab', 'recent');
        
        if (!in_array($currentTab, array('recent', 'most_viewed'))) {

            $params['filter'] = $currentTab;
            
        } else {

            if ($currentTab == 'most_viewed') {

                $params['orderBy'] = array('view_desc');
            }
        }

        $paginatorListView = $this->view->paginatorListView = Engine_Api::_()->getDbTable('news', 'sitenews')->getNewsPaginator($params);
        $paginatorGridView = $this->view->paginatorGridView = Engine_Api::_()->getDbTable('news', 'sitenews')->getNewsPaginator($params);
        $this->view->totalCount = $totalCount = $paginatorGridView->getTotalItemCount();
        $gridViewCountPerPage = $params['gridItemCountPerPage'];
        $listViewCountPerPage = $params['listItemCountPerPage'];
        $paginatorListView->setItemCountPerPage($listViewCountPerPage);
        $paginatorGridView->setItemCountPerPage($gridViewCountPerPage);
        $paginatorListView->setCurrentPageNumber($page);
        $paginatorGridView->setCurrentPageNumber($page);
    }

    public function setTabsOrder($tabs, $tabsOrder) {

        $tempTabs = array();
        foreach ($tabs as $tab) {
            $order = $tabsOrder[$tab];
            if (isset($tempTabs[$order]))
                $order++;
            $tempTabs[$order] = $tab;
        }
        ksort($tempTabs);
        $orderTabs = array();
        $i = 0;
        foreach ($tempTabs as $tab)
            $orderTabs[$i++] = $tab;

        return $orderTabs;
    }

}
