<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenews
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-01-01 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenews_Widget_NewsRecentlyViewRandomSitenewsController extends Seaocore_Content_Widget_Abstract {

    public function indexAction() {
        
        $sitenews_recent_random = Zend_Registry::isRegistered('sitenews_recent_random') ? Zend_Registry::get('sitenews_recent_random') : null;
        if(empty($sitenews_recent_random))
            return $this->setNoRender();
        $this->view->addHelperPath(APPLICATION_PATH . '/application/modules/Sitenews/View/Helper', 'Sitenews_View_Helper');
        $request = Zend_Controller_Front::getInstance()->getRequest();
        $params = $request->getParams();
        $this->view->defaultViewType = $params['defaultViewType'] = $this->_getParam('defaultViewType', 'grid_view');

        if (!isset($params['viewFormat']))
            $params['viewFormat'] = $params['defaultViewType'];

        $this->view->viewFormat = str_replace("ZZZ", "_", $params['viewFormat']);
        $page = $this->_getParam('page', 1);
        $layouts_views = $params['viewTypes'] = $this->_getParam('viewTypes', array('grid_view', 'list_view'));
        foreach ($layouts_views as $key => $value)
            $layouts_views[$key] = str_replace("ZZZ", "_", $value);

        $this->view->viewType = $layouts_views;
        $params['rss'] = $this->_getParam('rss');
        $this->view->showPhotosInJustifiedView = $params['showPhotosInJustifiedView'] = $this->_getParam('showPhotosInJustifiedView', 0);
        $this->view->maxRowHeight = $params['maxRowHeight'] = $this->_getParam('maxRowHeight', 0);
        $this->view->rowHeight = $params['rowHeight'] = $this->_getParam('rowHeight', 205);
        $this->view->margin = $params['margin'] = $this->_getParam('margin', 0);
        $this->view->lastRow = $params['lastRow'] = $this->_getParam('lastRow', 'nojustify');
        $sitenewsNewsList = Zend_Registry::isRegistered('sitenewsNewsList') ? Zend_Registry::get('sitenewsNewsList') : null;
        $this->view->gridViewWidth = $params['gridViewWidth'] = $this->_getParam('gridViewWidth', 250);
        $this->view->gridViewHeight = $params['gridViewHeight'] = $this->_getParam('gridViewHeight', 200);
        $this->view->newsOption = $params['newsOption'] = $this->_getParam('newsOption', array());
        $this->view->listDescription = $this->_getParam('listDescription', 1);
        $this->view->gridDescription = $this->_getParam('gridDescription', 0);
        $this->view->newsViewCountPerPage = $params['newsItemCountPerPage'] = $this->_getParam('itemCountPerPage', 12);
        $this->view->gridViewCountPerPage = $params['gridItemCountPerPage'] = $this->_getParam('gridItemCountPerPage', 12);

        $this->view->listViewCountPerPage = $params['listItemCountPerPage'] = $this->_getParam('listItemCountPerPage', 12);
        $this->view->titleTruncation = $params['titleTruncation'] = $this->_getParam('titleTruncation', 22);
        $this->view->titleTruncationGridNNewsView = $params['titleTruncationGridNNewsView'] = $this->_getParam('titleTruncationGridNewsView', 22);
        $this->view->descriptionTruncation = $params['descriptionTruncation'] = $this->_getParam('descriptionTruncation', 200);
        $this->view->showContent = $params['show_content'] = 2;
        $this->view->showEditDeleteOption = false;
        $this->view->listViewWithPhoto = $this->_getParam('listViewWithPhoto', 1);

        $this->view->descriptionInsideGrid = $this->_getParam('descriptionInsideGrid', 0);
        $this->view->showNews = $params['showNews'] = $this->_getParam('showNews', 'all_feeds');

        $this->view->widgetPath = 'widget/index/mod/sitenews/name/news-recently-view-random-sitenews';

        if (empty($this->view->newsOption) || !is_array($this->view->newsOption)) {
            $this->view->newsOption = $params['newsOption'] = array();
        }

        $this->view->isViewMoreButton = false;
        $this->view->showViewMore = $this->_getParam('showViewMore', false);
        $this->view->is_ajax_load = !$this->_getParam('loaded_by_ajax', true);
        $this->view->popularType = $params['popularType'] = $this->_getParam('popularType');


        if (empty($this->view->viewType) || count($this->view->viewType) == 0) {
            $this->view->viewType = array($this->view->viewFormat);
        } else if (!in_array($this->view->viewFormat, $this->view->viewType)) {
            $this->view->viewFormat = $this->view->viewType[0];
        }

        switch ($params['popularType']) {
            case 'view':
                $params['orderby'] = 'view_count';
                $filter = $params['showNews'];
                break;
            case 'comment':
                $filter = $params['showNews'];
                $params['orderby'] = 'comment_count';
                break;
            case 'like':
                $filter = $params['showNews'];
                $params['orderby'] = 'like_count';
                break;
            case 'creation':
                $filter = $params['showNews'];
                $params['orderby'] = 'creation_date';
                break;
            case 'modified':
                $filter = $params['showNews'];
                $params['orderby'] = 'modified_date';
                break;
            case 'random':
                $filter = $params['showNews'];
                $params['orderby'] = 'random';
                break;
        }

        $this->view->is_ajax_load = true;

        if ($this->_getParam('is_ajax_load', false)) {
            $this->view->is_ajax_load = true;

            if (!$this->_getParam('detactLocation', 0) || $this->_getParam('contentpage', 1) > 1)
                $this->getElement()->removeDecorator('Title');

            $this->getElement()->removeDecorator('Container');
        } else {

            if ($this->_getParam('detactLocation', 0))
                $this->getElement()->removeDecorator('Title');

            $this->view->is_ajax_load = !$this->_getParam('loaded_by_ajax', true);
        }

        $this->view->is_ajax = $isAjax = $this->_getParam('is_ajax', 0);
        $this->view->heading = "";
        if (!isset($params['category_id']))
            $params['category_id'] = 0;

        if (!isset($params['subcategory_id']))
            $params['subcategory_id'] = 0;

        if (!isset($params['subsubcategory_id']))
            $params['subsubcategory_id'] = 0;

        if (empty($params['category_id'])) {
            $this->view->category_id = $params['category_id'] = $this->_getParam('category_id');
            $params['subcategory_id'] = $this->_getParam('subcategory_id');
            $params['subsubcategory_id'] = $this->_getParam('subsubcategory_id');
        }

        $newsSize = array();
        $newsSize['thumb.normal'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('normal.news.width', 375);
        $newsSize['thumb.large'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('normallarge.news.width', 720);
        $newsSize['thumb.main'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('main.news.height', 1600);
        $newsSize['width'] = $this->view->videoViewWidth;
        $thumbnailType = Engine_Api::_()->getApi('core', 'sitenews')->findThumbnailType($newsSize, $this->view->newsViewWidth);
        $this->view->newsViewThumbnailType = $params['newsViewThumbnailType'] = $thumbnailType;
        $videoSize['width'] = $this->view->gridViewWidth;
        $thumbnailType = Engine_Api::_()->getApi('core', 'sitenews')->findThumbnailType($newsSize, $this->view->gridViewWidth);
        $this->view->gridViewThumbnailType = $params['gridViewThumbnailType'] = $thumbnailType;
        $filter = "";
        $this->view->message = 'Nobody has added a News yet.';

        // switch ($paramsContentType) {
        //     case 'most_recent' :
        //         $orderby = 'creationDate';
        //         break;
        //     case 'most_liked' :
        //         $orderby = 'likeCount';
        //         $filter = 'like_count';
        //         $this->view->message = 'Nobody has liked any News yet.';
        //         break;
        //     case 'most_viewed' :
        //         $orderby = 'viewCount';
        //         $filter = 'view_count';
        //         $this->view->message = 'Nobody has viewed any News yet.';
        //         break;
        //     case 'most_commented' :
        //         $orderby = 'commentCount';
        //         $filter = 'comment_count';
        //         $this->view->message = 'Nobody has commented on any News yet.';
        //         break;

        //     case 'most_favourites' :
        //         $orderby = 'favouriteCount';
        //         $this->view->message = 'Nobody has favourited any News yet.';
        //         break;
        //     case 'random' :
        //         $orderby = 'random';
        //         break;
        //     default :
        //         $orderby = 'creation_date';
        // }
        $orderby = 'creation_date';
        $params['orderby'] = $orderby;
        $params['filter'] = $filter;
        $requestedAllParams = $this->_getAllParams();

        if (isset($requestedAllParams['hidden_news_category_id']) && !empty($requestedAllParams['hidden_news_category_id'])) {
            $this->view->category_id = $params['category_id'] = $this->_getParam('hidden_news_category_id');
            $this->view->subcategory_id = $params['subcategory_id'] = $this->_getParam('hidden_news_subcategory_id');
            $this->view->subsubcategory_id = $params['subsubcategory_id'] = $this->_getParam('hidden_news_subsubcategory_id');
        }

        $request = Zend_Controller_Front::getInstance()->getRequest();
        $params['newsType'] = $contentType = $request->getParam('newsType', null);
        if (empty($contentType)) {
            $params['newsType'] = $params['newsType'] = $this->_getParam('newsType', 'All');
        }
        $this->view->newsType = $params['newsType'];
        $this->view->params = $params;

        $paginatorListView = $this->view->paginatorListView = Engine_Api::_()->getDbTable('news', 'sitenews')->getNewsPaginator($params);
        $paginatorGridView = $this->view->paginatorGridView = Engine_Api::_()->getDbTable('news', 'sitenews')->getNewsPaginator($params);
        $this->view->totalCount = $totalCount = $paginatorGridView->getTotalItemCount();
        if ($totalCount <= 0) {
            return $this->setNoRender();
        }
        $gridViewCountPerPage = $params['gridItemCountPerPage'];
        $listViewCountPerPage = $params['listItemCountPerPage'];
        $paginatorListView->setItemCountPerPage($listViewCountPerPage);
        $paginatorGridView->setItemCountPerPage($gridViewCountPerPage);
        $paginatorListView->setCurrentPageNumber($page);
        $paginatorGridView->setCurrentPageNumber($page);
    }

}
