<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenews
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-01-01 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenews_Widget_PopularNewsCarouselController extends Engine_Content_Widget_Abstract {

    public function indexAction() {
        
        $sitenews_popular_news_carousel = Zend_Registry::isRegistered('sitenews_popular_news_carousel') ? Zend_Registry::get('sitenews_popular_news_carousel') : null;
        if(empty($sitenews_popular_news_carousel))
            return $this->setNoRender();

        $this->view->addHelperPath(APPLICATION_PATH . '/application/modules/Sitenews/View/Helper', 'Sitenews_View_Helper');
        $param = array();
        $this->view->category_id = $param['category_id'] = $this->_getParam('category_id');
        $this->view->subcategory_id = $param['subcategory_id'] = $this->_getParam('subcategory_id', 0);
        $this->view->showPagination = $param['showPagination'] = $this->_getParam('showPagination', 1);
        $this->view->interval = $param['interval'] = $this->_getParam('interval', 3500);
        $this->view->itemWidth = $param['itemWidth'] = $this->_getParam('itemWidth', 150);
        $this->view->newsWidth = $param['newsWidth'] = $this->_getParam('newsWidth', 0);
        $this->view->newsHeight = $param['newsHeight'] = $this->_getParam('newsHeight', 200);
        $this->view->titleTruncation = $param['titleTruncation'] = $this->_getParam('titleTruncation', 22);
        $this->view->newsOption = $param['newsOption'] = $this->_getParam('newsOption');
        $this->view->orderby = $param['orderby'] = $this->_getParam('popularType', 'creationDate');
        $this->view->showNewsType = $param['showNewsType'] = $this->_getParam('popularType', 'creationDate');
        $this->view->rowLimit = $param['rowLimit'] = $this->_getParam('itemCount', 7);
        $this->view->limit = $param['limit'] = $this->_getParam('itemCountPerPage', 50);
        $this->view->rss = $param['rss'] = $this->_getParam('rss', 0);
        $this->view->showNews = $param['showNews'] = $this->_getParam('showNews', 'all_feeds');
        $this->view->showLink = $this->_getParam('showLink', 1);
        $this->view->carouselType = $this->_getParam('carouselType', 'horizontal');

        if (empty($this->view->newsOption) || !is_array($this->view->newsOption)) {
            $this->view->newsOption = $param['newsOption'] = array();
        }

        $this->view->params = $param;
        $element = $this->getElement();
        $widgetTitle = $element->getTitle();
        if (empty($widgetTitle))
            $widgetTitle = "";
        $link = "";
        if (empty($this->view->category_id)) {
            $this->view->category = $category = Engine_Api::_()->getItem('sitenews_category', $this->view->category_id);
            if ($this->view->category)
                $link = $this->view->htmlLink($this->view->category->getHref(), " + " . $this->view->translate('See all %s news', $this->view->category->getTitle()));
        }
        else {
            $link = $this->view->htmlLink(array('route' => 'sitenews_news_general', 'action' => 'browse'), " + " . $this->view->translate('See all news'));
        }

        if ($this->view->showLink == 1)
            $element->setTitle(sprintf($widgetTitle . " " . $link));

        // List List featured
        $this->view->news = $paginator = Engine_Api::_()->getDbTable('news', 'sitenews')->newsBySettings($param);
        if ($paginator->getTotalItemCount() <= 0) {
            return $this->setNoRender();
        }

        $paginator->setItemCountPerPage($param['limit']);
        $this->view->totalCount = $count = $paginator->getTotalItemCount();
        $newsSize = array();
        $newsSize['thumb.normal'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('normal.news.width', 375);
        $newsSize['thumb.large'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('normallarge.news.width', 720);
        $newsSize['thumb.main'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('main.news.height', 1600);
        $newsSize['width'] = $this->view->newsWidth;
        $this->view->thumbnailType = Engine_Api::_()->getApi('core', 'sitenews')->findThumbnailType($newsSize, $this->view->newsWidth);
    }

}
