<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenews
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-01-01 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenews_Widget_RssNewsSitenewsController extends Seaocore_Content_Widget_Abstract {

    public function indexAction() {
        
        $sitenews_rss_news_sitenews = Zend_Registry::isRegistered('sitenews_rss_news_sitenews') ? Zend_Registry::get('sitenews_rss_news_sitenews') : null;
        if(empty($sitenews_rss_news_sitenews))
            return $this->setNoRender();

        $this->view->addHelperPath(APPLICATION_PATH . '/application/modules/Sitenews/View/Helper', 'Sitenews_View_Helper');
        if (Engine_Api::_()->core()->hasSubject('user') && Engine_Api::_()->core()->getSubject('user')) {
            $viewer = Engine_Api::_()->core()->getSubject('user');
            $this->view->showEditDeleteOption = false;
        } else
            $viewer = Engine_Api::_()->user()->getViewer();

        $params = Zend_Controller_Front::getInstance()->getRequest()->getParams();

        //FIND THE PAGE NUMBER
        if (isset($params['page']) && !empty($params['page']))
            $this->view->page = $page = $params['page'];
        else
            $this->view->page = $page = 1;

        // ASSIGNING THE PARAMETER
        $this->view->is_ajax_load = $this->_getParam('loaded_by_ajax', false);
        $this->view->viewFormat = $params['viewFormat'] = $this->_getParam('viewFormat', 'gridView');
        $this->view->is_ajax = $this->_getParam('is_ajax', '');
        $this->view->rss = $params['rss'] = $this->_getParam('rss');
        $this->view->showContent = $params['show_content'] = $this->_getParam('show_content', 2);

        $params['itemCountPerPage'] = $this->_getParam('itemCountPerPage', 12);
        $this->view->orderby = $params['orderby'] = $this->_getParam('orderby');
        $this->view->newsOption = $params['newsOption'] = $this->_getParam('newsOption');
        $this->view->listDescription = $params['listDescription'] = $this->_getParam('listDescription', 1);
        $this->view->gridDescription = $params['gridDescription'] = $this->_getParam('gridDescription', 0);
        $this->view->gridViewWidth = $params['gridViewWidth'] = $this->_getParam('gridViewWidth', 250);
        $this->view->gridViewHeight = $params['gridViewHeight'] = $this->_getParam('gridViewHeight', 200);
        $sitenewsNewsList = Zend_Registry::isRegistered('sitenewsNewsList') ? Zend_Registry::get('sitenewsNewsList') : null;
        $this->view->listViewWidth = $params['listViewWidth'] = $this->_getParam('listViewWidth', 150);
        $this->view->listViewHeight = $params['listViewHeight'] = $this->_getParam('listViewHeight', 150);
        $this->view->newsViewThumbnailType = $params['newsViewThumbnailType'] = $this->_getParam('newsViewThumbnailType', 'thumb.normal');
        $this->view->gridViewThumbnailType = $params['gridViewThumbnailType'] = $this->_getParam('gridViewThumbnailType', 'thumb.normal');
        $this->view->titleTruncationListView = $this->view->titleTruncation = $params['titleTruncation'] = $this->_getParam('titleTruncation', 22);
        $this->view->titleTruncationGridNNewsView = $params['titleTruncationGridNNewsView'] = $this->_getParam('titleTruncationGridNNewsView', 22);
        $this->view->descriptionTruncation = $params['descriptionTruncation'] = $this->_getParam('descriptionTruncation', 200);
        $this->view->widgetPath = 'widget/index/mod/sitenews/name/news-sitenews';
        $this->view->subscribeRss = $params['subscribeRss'] = $this->_getParam('subscribeRss', 1);
        $this->view->message = 'You do not have any News in this RSS.';
        $this->view->newNewsRss = 'true';

        $level_id = Engine_Api::_()->user()->getViewer()->getIdentity() ? Engine_Api::_()->user()->getViewer()->level_id : 0;
        $this->view->can_create = Engine_Api::_()->authorization()->getPermission($level_id, 'sitenews_news', 'create');

        if (isset($params['search']) && !empty($params['search']))
            $this->view->message = 'No News found in this search criteria.';

        $this->view->isViewMoreButton = true;
        $this->view->id = $params['idenity'] = $this->_getParam('identity');

        if (is_null($this->view->newsOption)) {
            $this->view->newsOption = array();
            $params['newsOption'] = array();
        }

        $this->view->params = $params;
        $params['paginator'] = 1;
        //FIND THE News MODELS
        $paginator = $this->view->paginator = Engine_Api::_()->getDbTable('news', 'sitenews')->getNewsPaginator($params);
        //FIND TOTAL NO. OF RECORDS
        $this->view->totalCount = $paginator->getTotalItemCount();
        //SET THE NO. OF RECORDS PER PAGE
        $paginator->setItemCountPerPage($params['itemCountPerPage']);
        //SET THE CURRENT PAGE NO.
        $paginator->setCurrentPageNumber($page);
    }

}
