<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenews
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-01-01 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenews_Widget_TrendingNewsSitenewsController extends Engine_Content_Widget_Abstract {

    public function indexAction() {

        $sitenews_trending_news = Zend_Registry::isRegistered('sitenews_trending_news') ? Zend_Registry::get('sitenews_trending_news') : null;
        if(empty($sitenews_trending_news))
            return $this->setNoRender();

        $this->view->addHelperPath(APPLICATION_PATH . '/application/modules/Sitenews/View/Helper', 'Sitenews_View_Helper');

        $coreApi = Engine_Api::_()->getApi('settings', 'core');
        $value['cat_depandancy'] = 0;
        $this->view->categories = $categories = $this->_getParam('categoryids');
        if (empty($categories)) {
            return $this->setNoRender();
        }

        $totalNews = Engine_Api::_()->getDbtable('news', 'sitenews')->getNewsCount();

        if ($totalNews == 0)
            return $this->setNoRender();

        foreach ($categories as $item) {
            $category = Engine_Api::_()->getItem('sitenews_category', $item);
            if ($category && $category->getUsedCount() > 0) {
                $firstCategory = $category->category_id;
                break;
            }
        }

        $this->view->firstCategory = $firstCategory;
        $this->view->category_id = $param['category_id'] = $category_id = $this->_getParam('category_id', $firstCategory);
        $this->view->storage = Engine_Api::_()->storage();
        $this->view->titleTruncation = $param['titleTruncation'] = $this->_getParam('titleTruncation', 22);
        $this->view->truncationLocation = $param['truncationLocation'] = $this->_getParam('truncationLocation', 35);
        $sitenewsNewsList = Zend_Registry::isRegistered('sitenewsNewsList') ? Zend_Registry::get('sitenewsNewsList') : null;
        $refreshTimeout = $this->_getParam('refreshTimeout', 12);
        $this->view->refreshTimeout = $refreshTimeout * 1000;

        $this->view->detactLocation = $param['detactLocation'] = $this->_getParam('detactLocation', 0);
        $this->view->itemCount = $param['limit'] = $this->_getParam('itemCount', 5);
        $this->view->popularType = $param['popularType'] = $this->_getParam('popularType', 'comment');
        $news_url = $this->view->url(array('action' => 'browse'), "sitenews_news_general", true);
        $this->view->titleLink = $this->_getParam('titleLink', '<a href="' . $news_url . '">Explore All »</a>');
        $this->view->titleLinkPosition = $this->_getParam('titleLinkPosition', 'top');
        $this->view->showCategoriesAs = $this->_getParam('showCategoriesAs', 'title');

        switch ($param['popularType']) {
            case 'view':
                $param['orderby'] = 'viewCount';
                break;
            case 'comment':
                $param['orderby'] = 'commentCount';
                break;
            case 'like':
                $param['orderby'] = 'likeCount';
                break;
            case 'creation':
                $param['orderby'] = 'creationDate';
                break;
            case 'modified':
                $param['orderby'] = 'modifiedDate';
                break;
            case 'share':
                $param['orderby'] = 'shared';
                break;
        }
        $this->view->params = $param;

        $this->view->paginator = $paginator = Engine_Api::_()->getDbTable('news', 'sitenews')->getNewsPaginator($param);

        try {
            // Set item count per page and current page number
            $paginator->setItemCountPerPage($this->_getParam('itemCount', 4));
            $paginator->setCurrentPageNumber($this->_getParam('page', 1));
        } catch (Exception $e) {
            echo $e;
            die;
        }
    }

}
