<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenewsletter
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: categories.tpl 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitenewsletter_Form_Admin_Category extends Engine_Form
{
  protected $_field;

  public function init()
  {
    $this
      ->setMethod('post')
      ->setAttrib('class', 'global_form_box')
      ->setTitle('Add Newsletter Type')
      ;

    $this->addElement('Text', 'category_name', array(
      'label' => 'Name',
      'required' => true
    ));

    $this->addElement('Radio', 'auto', array(
      'label' => 'Do you want this type to be auto-subscribed for the new users?',
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => 0,
    ));

    $this->addElement('Radio', 'subscribe_eusers', array(
      'label' => 'Do you want the existing users to subscribe to newsletters of this type automatically?',
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => 0,
    ));

    $this->addElement('Radio', 'subscribe_gusers', array(
      'label' => 'Do you want the guest users to subscribe to newsletters of this type automatically?',
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => 0,
    ));

    $this->addElement('Radio', 'visibility', array(
      'label' => 'Do you want to hide this type from user end?',
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => 0,
    ));

    $this->addElement('Radio', 'enabled', array(
      'label' => 'Do you want to enable this type?',
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => 1,
    ));
    
    // Buttons
    $this->addElement('Button', 'submit', array(
      'label' => 'Add',
      'type' => 'submit',
      'ignore' => true,
      'decorators' => array('ViewHelper')
    ));

    $this->addElement('Cancel', 'cancel', array(
      'label' => 'cancel',
      'link' => true,
      'prependText' => ' or ',
      'href' => '',
      'onClick'=> 'javascript:parent.Smoothbox.close();',
      'decorators' => array(
        'ViewHelper'
      )
    ));
    $this->addDisplayGroup(array('submit', 'cancel'), 'buttons');
    $button_group = $this->getDisplayGroup('buttons');


  }

  public function setField($category)
  {
    $this->_field = $category;

    // Set up elements
    $this->setTitle('Edit Newsletter Type');
    $this->category_name->setValue($category->category_name);
    $this->auto->setValue($category->auto);
    $this->removeElement('subscribe_eusers');
    $this->removeElement('subscribe_gusers');
    $this->visibility->setValue($category->visibility);
    $this->enabled->setLabel('Do you want to enable the selected type?');
    $this->enabled->setValue($category->enabled);
    $this->submit->setLabel('Edit');

    // @todo add the rest of the parameters
  }
}