<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenewsletter
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Global.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenewsletter_Form_Admin_Global extends Engine_Form 
{
  public function init() {

    $coreSettings = Engine_Api::_()->getApi('settings', 'core');
    $this
        ->setTitle('Global Settings')
        ->setDescription('These settings affect all members in your community.');

    $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;

    $this->addElement('Text', 'sitenewsletter_test_email', array(
      'label' => 'Test Email IDs',
      'description' => 'Enter the email Ids of test users to send newsletter for testing. Multiple emails can be added separated by commas.',
      'value' => $coreSettings->getSetting('sitenewsletter_test_email', '')
    ));

    //VALUE FOR CAPTCHA
    $this->addElement('Radio', 'sitenewsletter_test_mode', array(
      'label' => 'Enable Test Mode',
      'description' => 'Do you want to enable test mode? No option will be shown at front end to subscribe to newsletters while test mode is enabled.',
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No',
      ),
      'value' => $coreSettings->getSetting('sitenewsletter.test.mode', 0)
    ));

    //VALUE FOR CAPTCHA
    $this->addElement('Radio', 'sitenewsletter_email_verification', array(
      'label' => 'Subscriber’s Email Verification',
      'description' => 'Do you want the subscribers to verify by email that if they want to receive newsletters in their mailboxes.',
      'multiOptions' => array(
        2 => 'All',
        1 => 'Only for site members',
        0 => 'None',
      ),
      'value' => $coreSettings->getSetting('sitenewsletter.email.verification', 0)
    ));

    $this->addElement('Button', 'submit', array(
      'label' => 'Save Changes',
      'type' => 'submit',
      'ignore' => true
    ));
  }
}
