<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenewsletter
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Subscriber.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitenewsletter_Form_Admin_Subscriber_Add extends Engine_Form
{
  public function init()
  {
    $this
      ->setMethod('post')
      ->setAttrib('enctype', 'multipart/form-data')
      ->setAttrib('class', 'global_form_box')
      ->setTitle('Add Subscribers')
      ;

    $this->addElement('Radio', 'type', array(
      'label' => 'Which users do you want to be auto subscribed to the newsletters of the types you select below.',
      'multiOptions' => array(
        'guest' => 'Guest Users',
        'member' => 'Existing Users',
        'list' => 'Import Users'
      ),
      'value' => 'guest',
      'onchange' => 'addSubscribers(this.value);'
    ));

    $this->addElement('Text', 'email', array(
      'label' => 'Email',
    ));

    $this->addElement('Text', 'emailid', array(
      'label' => 'Email',
    ));

    $categoryTable = Engine_Api::_()->getDbtable('categories', 'sitenewsletter');
    // Get all enabled categories to display at user end
    $availableLabels = $categoryTable->getAllEnabledCategories();

    $this->addElement('MultiCheckbox', "category_id", array(
      'label' => 'Types of Newsletters',
      'multiOptions' => $availableLabels,
      'required' => true
    ));

    //SITE LOGO
    $this->addElement('File', 'filename', array(
      'label' => 'Import File (Only csv format allowed.)',
    ));
        
    $this->filename->addValidator('Extension', false, 'csv,CSV');

    $this->addElement('Hidden', 'resource_id', array(
        'order' => 9999,
    ));
    // Buttons
    $this->addElement('Button', 'submit', array(
        'label' => 'Add',
        'type' => 'submit',
        'ignore' => true,
        'decorators' => array('ViewHelper')
    ));

    // Element: cancel
    $this->addElement('Cancel', 'cancel', array(
        'label' => 'cancel',
        'link' => true,
        'prependText' => ' or ',
        'onclick' => 'javascript:parent.Smoothbox.close()',
        'decorators' => array(
            'ViewHelper',
        ),
    ));

    $this->addDisplayGroup(array('submit', 'cancel'), 'buttons');
    $button_group = $this->getDisplayGroup('buttons');
  }
}