<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenewsletter
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: categories.tpl 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitenewsletter_Form_FetchCategories extends Engine_Form
{
  public function init()
  {
    $this
      ->setMethod('post')
      ->setAttrib('class', 'global_form_box')
      ->setAttrib('id', 'sitenewsletter_fetch_categories')
      ;

    $categoryTable = Engine_Api::_()->getDbtable('categories', 'sitenewsletter');

    // Get all enabled categories to display at user end
    $availableLabels = $categoryTable->getEnabledCategories();
    
    // Get all the anabled and auto subscribe categories at user end 
    $roles = $categoryTable->fetchAutoSubscribedCategories();

    // Categories 
    $this->addElement('MultiCheckbox', "categories", array(
      'multiOptions' => $availableLabels,
      'value' => $roles
    ));
    
    // Buttons
    $this->addElement('Button', 'submit', array(
      'label' => 'Submit',
      'type' => 'submit',
      'ignore' => true,
      'decorators' => array('ViewHelper')
    ));

    // $this->addElement('Cancel', 'cancel', array(
    //   'label' => 'cancel',
    //   'link' => true,
    //   'prependText' => ' or ',
    //   'href' => '',
    //   'onClick'=> 'javascript:parent.Smoothbox.close();',
    //   'decorators' => array(
    //     'ViewHelper'
    //   )
    // ));
    $this->addDisplayGroup(array('submit'), 'buttons');
    $button_group = $this->getDisplayGroup('buttons');

    $this->setAction(Zend_Controller_Front::getInstance()->getRouter()->assemble(array('module' => 'sitenewsletter', 'controller' => 'subscribe','action' => 'update-category'), 'default', true));
  }
}