<?php
/**
 * SocialEngine
 *
 * @category   Application_Core
 * @package    User
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 * @version    $Id: Password.php 9747 2012-07-26 02:08:08Z john $
 * @author     Steve
 */

/**
 * @category   Application_Core
 * @package    User
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 */
class Sitenewsletter_Form_Settings_Categories extends Engine_Form
{
  protected $_item;

  public function setItem($item)
  {
    $this->_item = $item;
  }

  public function getItem()
  {
    return $this->_item;
  }

  public function init()
  {
    // @todo fix form CSS/decorators
    // @todo replace fake values with real values
    $this->setTitle('Update Subscribed Newsletter Types')
    ->setDescription('If you want, you can update the types of newsletters for which you are subscribed from below.')
      ->setAction(Zend_Controller_Front::getInstance()->getRouter()->assemble(array()))
      ;

    $categoryTable = Engine_Api::_()->getDbtable('categories', 'sitenewsletter');
    
    // Get all enabled categories to display at user end
    $availableLabels = $categoryTable->getEnabledCategories();
    
    // Get all the anabled and auto subscribe categories at user end 
    $subscribed = Engine_Api::_()->getDbtable('subscribecategories', 'sitenewsletter')->getSubscribedCategories($this->getItem());

    // Categories 
    $this->addElement('MultiCheckbox', "categories", array(
      'label' => 'Newsletter Types',
      'multiOptions' => $availableLabels,
      'value' => $subscribed
    ));
    
    // Init submit
    $this->addElement('Button', 'submit', array(
      'label' => 'Update',
      'type' => 'submit',
      'ignore' => true
    ));

    // Set default action
    $this->setAction(Zend_Controller_Front::getInstance()->getRouter()->assemble(array()));
  }
}
