<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenewsletter
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenewsletter_Plugin_Core extends Zend_Controller_Plugin_Abstract 
{

  public function onUserSignupAfter($event) {
    $payload = $event->getPayload();
    $user_id = $payload['user_id'];

    // get the auto subscribe categories for new users
    $category = Engine_Api::_()->getDbtable('categories', 'sitenewsletter');
    $tableName = $category->info('name');
    $select = $category->select()
      ->from($tableName, array('category_id'))
      ->where('auto = ?', 1)
      ->query();
    $categories = $select->fetchAll();

    $subscriptionTable = Engine_Api::_()->getDbtable('subscribers', 'sitenewsletter');
    $subscribeCategories = Engine_Api::_()->getDbtable('subscribecategories', 'sitenewsletter');
    if ($categories) {
      // insert the value in subscribe
      $subscriptionTable->insert(array(
        'resource_id' => $user_id, 
        'resource_type' => 'member',
        'creation_date' => date('Y-m-d H:i:s'),
      ));
      $subscriber_id = $subscriptionTable->getAdapter()->lastInsertId();

      // insert the value of subscribe category
      foreach ($categories as $key => $value) {
        $id = $value['category_id'];
        $subscribeCategories->insert(array(
          'subscriber_id' => $subscriber_id, 
          'category_id' => $id,
        ));
      }
    }

    // Remove the user from guest if he/she signup
    $user = Engine_Api::_()->getItem('user', $user_id);
    $email = $user->email;

    $guestTable = Engine_Api::_()->getDbtable('guestusers', 'sitenewsletter');
    $guestRow = $guestTable->fetchRow($guestTable->select()->from($guestTable->info('name'), 'user_id')->where('email = ?', $email));
    if ($guestRow) {
      $guestuser_id = $guestRow->user_id;

      $db = $subscriptionTable->getAdapter();
      $db->beginTransaction();
      try {
        $subscriptionTable->update(array('resource_id' => $user_id, 'resource_type' => 'member'), array('`resource_id` = ?' => $guestuser_id, '`resource_type` = ?' => 'guest'));
        $guestTable->delete(array('user_id = ?' => $guestuser_id));
        $db->commit();
      } catch( Exception $e ) {
        $db->rollBack();
        throw $e;
      }
    }

  }

  // DELETE SUBSCRIBE ROWS ON USER DELETION
  public function onUserDeleteBefore($event) {
    $payload = $event->getPayload();
    if ($payload instanceof User_Model_User) {
      $table = Engine_Api::_()->getDbtable('subscribers', 'sitenewsletter');
      $select = $table->select()
      ->where('resource_id = ?', $payload->getIdentity())
      ->where('resource_type = ?', 'member');

      foreach ($table->fetchAll($select) as $row) {
        $row->delete();
      }
    }
  }

}