<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenewsletter
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminLayoutController.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenewsletter_AdminLayoutController extends Core_Controller_Action_Admin
{
  const IMAGE_WIDTH = 200;
  const IMAGE_HEIGHT = 200;
  public function indexAction()
  {
    // Get navigation
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sitenewsletter_admin_main', array(), 'sitenewsletter_admin_main_layout');

    $this->view->subNavigation = $subNavigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitenewsletter_admin_main_layout', array(), 'sitenewsletter_admin_main_layout_layout');

    $this->view->form  = $form = new Sitenewsletter_Form_Admin_Layout();
    $this->view->option = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitenewsletter_header_background', 1);
    $this->view->footerIcon = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitenewsletter_footer_icon', 0);
    $this->view->headersite = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitenewsletter_header_site', 0);
    // check form data is valid or not
    if( $this->getRequest()->isPost() && $form->isValid($this->_getAllParams()) )
    {
      $values = $form->getValues();

      if( !empty($values['sitenewsletter_site_header_logo']) ) {
        $photoFile = Engine_Api::_()->sitenewsletter()->setPhoto($form->sitenewsletter_site_header_logo);
        $photo = 'sitenewsletter_site_header_logo';
        Engine_Api::_()->sitenewsletter()->deletePreviousFile($photo);
        // Save the photo id of uploaded image from Storage files table in the core settings table
        Engine_Api::_()->getApi('settings', 'core')->setSetting('sitenewsletter_site_header_logo', $photoFile->file_id);

        // Unset teh value from array
        unset($values['sitenewsletter_site_header_logo']);
      } else if (!empty($values['sitenewsletter_header_site'] && empty($values['sitenewsletter_site_header_logo']))){
        $form->addError($this->view->translate("Site Logo *  Please complete this field - it is required."));
          return;
      }

      if (empty($values['sitenewsletter_header_background'])) {
        if (empty($values['sitenewsletter_header_bgimage'])) {
          $form->addError($this->view->translate("Header Background Image *  Please complete this field - it is required."));
          return;
        }
        if( !empty($values['sitenewsletter_header_bgimage']) ) {
          $photoBGFile = Engine_Api::_()->sitenewsletter()->setPhoto($form->sitenewsletter_header_bgimage);
          $photo = 'sitenewsletter_header_bgimage';
          Engine_Api::_()->sitenewsletter()->deletePreviousFile($photo);
          // Save the photo id of uploaded image from Storage files table in the core settings table
          Engine_Api::_()->getApi('settings', 'core')->setSetting('sitenewsletter_header_bgimage', $photoBGFile->file_id);

          // unset the value from array
          unset($values['sitenewsletter_header_bgimage']);
        }
      }
      unset($values['sitenewsletter_header_bgimage']);

      if (!empty($values['sitenewsletter_header_background'])) {
        unset($values['sitenewsletter_header_bgimage']);
      }

      if( !empty($values['sitenewsletter_site_logo_icon']) && $values['sitenewsletter_footer_icon']) {
        $photoIconFile = Engine_Api::_()->sitenewsletter()->setPhoto($form->sitenewsletter_site_logo_icon);
        $photo = 'sitenewsletter_site_logo_icon';
        Engine_Api::_()->sitenewsletter()->deletePreviousFile($photo);
        // Save the photo id of uploaded image from Storage files table in the core settings table
        Engine_Api::_()->getApi('settings', 'core')->setSetting('sitenewsletter_site_logo_icon', $photoIconFile->file_id);

        // unset the value from array
        unset($values['sitenewsletter_site_logo_icon']);
      } else {
        unset($values['sitenewsletter_site_logo_icon']);
      }

      unset($values['headersettings']);
      unset($values['footersettings']);
      if (!$values['sitenewsletter_header_site'])
        unset($values['sitenewsletter_site_header_logo']);
      unset($values['sitenewsletter_header_menu']);
      unset($values['sitenewsletter_footer_menu']);
      
      foreach ($values as $key => $value){
        Engine_Api::_()->getApi('settings', 'core')->setSetting($key, $value);
      }
      $form->addNotice('Your changes have been saved.');
    }
  }

  public function getWidgetAction() 
  {
    $id = 23;
    $table = Engine_Api::_()->getItem('sitenewsletter_template', $id);
    $widgetName = array();
    $content_ids = Zend_Json::decode($table->content_ids);
    foreach ($content_ids as $content_id) {
      $contentTable = Engine_Api::_()->getDbtable('content', 'core');
      $select = $contentTable->select()
        ->where('content_id = ?', $content_id);
      $content = $contentTable->fetchRow($select);
      array_push($widgetName, $content->name);
    }
    $this->view->widgets = $widgetName;
  }

  public function layoutAction() 
  {
    // Get navigation
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sitenewsletter_admin_main', array(), 'sitenewsletter_admin_main_layout');

    $this->view->subNavigation = $subNavigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitenewsletter_admin_main_layout', array(), 'sitenewsletter_admin_main_layout_layoutdefault');

    // Get page param
    $template = $this->_getParam('template', 'newsletter_default_template');
    $templateTable = Engine_Api::_()->getDbtable('templates', 'sitenewsletter');
    $contentTable = Engine_Api::_()->getDbtable('content', 'sitenewsletter');
   
    // Get current page
    $this->view->templateObject = $templateObject = $templateTable->fetchRow($templateTable->select()->where('name = ?', $template)->orWhere('template_id = ?', $template));
    if( null === $templateObject ) {
      $template = 'newsletter_default_template';
      $templateObject = $templateTable->fetchRow($templateTable->select()->where('name = ?', $template));
      if( null === $templateObject ) {
        throw new Engine_Exception('Default Newsletter Template is missing');
      }
    }
    $this->view->template = $template;
    
    $this->view->templateObject = $templateObject;

    // Make page form
    $this->view->templateForm = $templateForm = new Sitenewsletter_Form_Admin_Template_Page();
  
    $templateForm->populate($templateObject->toArray());

    // Get page list
    $templateSelect = $templateTable->select()
        ->order('fragment DESC')
        ->order('custom ASC')
        ->order('displayname ASC');
    $templateList = $templateTable->fetchAll($templateSelect);
    $templateListAssoc = array(
      'fragment' => array(),
      'main' => array(),
      'mobile' => array(),
      'custom' => array()
    );
    foreach( $templateList as $templateRow ) {
      if( false !== stripos($templateRow->displayname, 'mobile') ) {
        $templateListAssoc['mobile'][] = $templateRow;
      } else if( $templateRow->fragment ) {
        $templateListAssoc['fragment'][] = $templateRow;
      } else if( $templateRow->custom ) {
        $templateListAssoc['custom'][] = $templateRow;
      } else {
        $templateListAssoc['main'][] = $templateRow;
      }
    }
    $this->view->templateListAssoc = $templateListAssoc;
    $this->view->templateList = $templateList;
    
    // Get available content blocks
    $contentAreas = $this->buildCategorizedContentAreas($this->getContentAreas());
    if( !$this->_getParam('show-all', true) ) { // @todo change default to false when ready to roll out
      $contentAreas = $this->filterContentAreasByRequirements($contentAreas, $pageObject->provides);
    }

    $this->view->contentAreas = $contentAreas;

    // Re-index by name
    $contentByName = array();
    foreach( $contentAreas as $category => $categoryAreas ) {
      foreach( $categoryAreas as $info ) {
        $contentByName[$info['name']] = $info;
      }
    }
    $this->view->contentByName = $contentByName;

    // Get registered content areas
    $contentRowset = $contentTable->fetchAll($contentTable->select()->where('template_id = ?', $templateObject->template_id));
    $contentStructure = $templateTable->prepareContentArea($contentRowset);

    // Validate structure
    // Note: do not validate for header or footer
    $error = false;
    if( substr($templateObject->name, 0, 6) !== 'header' && substr($templateObject->name, 0, 6) !== 'footer' ) {
      foreach( $contentStructure as &$info1 ) {
        if( !in_array($info1['name'], array('top', 'bottom', 'main')) || $info1['type'] != 'container' ) {
          $error = true;
          break;
        }
        foreach( $info1['elements'] as &$info2 ) {
          if( !in_array($info2['name'], array('left', 'middle', 'right')) || $info1['type'] != 'container' ) {
            $error = true;
            break;
          }
        }
        // Re order second-level elements
        usort($info1['elements'], array($this, '_reorderContentStructure'));
      }
    }

    if( $error ) {
      throw new Exception('page failed validation check');
    }

    // Assign structure
    $this->view->contentRowset = $contentRowset;
    $this->view->contentStructure = $contentStructure;
  }

  public function getContentAreas()
  {
    $contentAreas = array();

    // From modules

    $modules = Zend_Controller_Front::getInstance()->getControllerDirectory();
    $allowedModule = array('core', 'sitenewsletter');
    $allowedWidget = array('core.html-block', 'core.rich-text-block', 'core.content', 'sitenewsletter.list-popular-items', 'sitenewsletter.template-footer', 'sitenewsletter.template-header', 'sitenewsletter.track-link');
    foreach( $modules as $module => $path ) {
      if (in_array($module, $allowedModule)) {
        $contentManifestFile = dirname($path) . '/settings/content.php';
        if( !file_exists($contentManifestFile) ) continue;
        $ret = include $contentManifestFile;
        $widgetnames = array_column($ret, 'name');

        foreach ($widgetnames as $value) {
          if (in_array($value, $allowedWidget)) {
            $key = array_search($value, $widgetnames);
            $contentAreas = array_merge($contentAreas, array($ret[$key]));
          }
        }
      }
    }

    return $contentAreas;
  }

  public function buildCategorizedContentAreas($contentAreas)
  {
    $categorized = array();
    foreach( $contentAreas as $config ) {
      // Check some stuff
      if( !empty($config['requireItemType']) ) {
        if( is_string($config['requireItemType']) && !Engine_Api::_()->hasItemType($config['requireItemType']) ) {
          $config['disabled'] = true;
        } else if( is_array($config['requireItemType']) ) {
          $tmp = array_map(array(Engine_Api::_(), 'hasItemType'), $config['requireItemType']);
          $config['disabled'] = !(array_sum($tmp) == count($config['requireItemType']));
        }
      }

      // Add to category
      $category = ( isset($config['category']) ? $config['category'] : 'Uncategorized' );
      $categorized[$category][] = $config;
    }

    // Sort categories
    uksort($categorized, array($this, '_sortCategories'));

    // Sort items in categories
    foreach( $categorized as $category => &$items ) {
      usort($items, array($this, '_sortCategoryItems'));
    }

    return $categorized;
  }

  public function filterContentAreasByRequirements($contentAreas, $provides)
  {
    // Process provides
    if( is_string($provides) ) {
      $providedFeatures = explode(';', $provides);
      $provides = array();
      foreach( $providedFeatures as $providedFeature ) {
        if( false === strpos($providedFeature, '=') ) {
          $provides[$providedFeature] = true;
        } else {
          list($feature, $value) = explode('=', $providedFeature);
          if( false === strpos($value, ',') ) {
            $provides[$feature] = $value;
          } else {
            $provides[$feature] = explode(',', $value);
          }
        }
      }
    } else if( !is_array($provides) ) {
      $provides = array();
    }

    // Process content areas
    $filteredContentAreas = array();
    foreach( $contentAreas as $category => $categoryWidgets ) {
      foreach( $categoryWidgets as $widget ) {
        $pass = true;
        // Requirements
        if( !empty($widget['requirements']) && is_array($widget['requirements']) ) {
          foreach( $widget['requirements'] as $k => $v ) {
            if( is_numeric($k) ) {
              $req = $v;
              $value = null;
            } else {
              $req = $k;
              $value = $v;
            }
            // Note: will continue if missing any of the requirements
            switch( $req ) {
              case 'viewer':
                if( isset($provides['no-viewer']) ) {
                  $pass = false;
                }
                break;
              case 'no-viewer':
                if( isset($provides['viewer']) ) {
                  $pass = false;
                }
                break;
              case 'subject':
                if( !isset($provides['subject']) /*||
                    isset($provides['no-subject'])*/ ) {
                  $pass = false;
                } else if( is_string($value) ) {
                  if( is_string($provides['subject']) &&
                      $provides['subject'] == $value ) {
                    
                  } else if( is_array($provides['subject']) &&
                      in_array($value, $provides['subject']) ) {
                    
                  } else {
                    $pass = false;
                  }
                } else if( is_array($value) ) {
                  if( count(array_intersect($value, (array) $provides['subject'])) <= 0 ) {
                    $pass = false;
                  }
                }
                break;
              case 'no-subject':
                if( isset($provides['subject']) /*||
                    !isset($provides['no-subject'])*/ ) {
                  $pass = false;
                }
                // @todo subject blacklist?
                break;
              case 'header-footer';
                if( !isset($provides['header-footer']) ) {
                  $pass = false;
                }
                break;
            }
          }
        }
        // Add to areas
        if( $pass ) {
          $filteredContentAreas[$category][] = $widget;
        }
      }
    }

    return $filteredContentAreas;
  }

  protected function _sortCategories($a, $b)
  {
    if( $a == 'Core' ) return -1;
    if( $b == 'Core' ) return 1;
    return strcmp($a, $b);
  }

  protected function _sortCategoryItems($a, $b)
  {
    if( !empty($a['special']) ) return -1;
    if( !empty($b['special']) ) return 1;
    return strcmp($a['title'], $b['title']);
  }

  protected function _reorderContentStructure($a, $b)
  {
    $sample = array('left', 'middle', 'right');
    $av = $a['name'];
    $bv = $b['name'];
    $ai = array_search($av, $sample);
    $bi = array_search($bv, $sample);
    if( $ai === false && $bi === false ) return 0;
    if( $ai === false ) return -1;
    if( $bi === false ) return 1;
    $r = ( $ai == $bi ? 0 : ($ai < $bi ? -1 : 1) );
    return $r;
  }

  
  public function saveAction() {
    $template_id = $this->_getParam('template_id');

    $this->_pageTable = Engine_Api::_()->getDbtable('pages', 'sitenewsletter');
    // $searchTable = Engine_Api::_()->getDbtable('search', 'core');
    $templateObject = $this->_pageTable->fetchRow($this->_pageTable->select()->where('name = ?', $template_id)->orWhere('template_id = ?', $template_id));

    $form = new Sitenewsletter_Form_Admin_Template_Page();

    $form->populate($templateObject->toArray());

    if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
      $values = $form->getValues();
      unset($values['template_id']);

      // @todo add provides no-viewer or viewer based on whether the public level is selected?

      $templateObject->setFromArray($values);
      $templateObject->save();

      $form->addNotice($this->view->translate('Your changes have been saved.'));
    }

    $this->getResponse()->setBody($form->render($this->view));
    $this->_helper->layout->disableLayout(true);
    $this->_helper->viewRenderer->setNoRender(true);
    return;
  }

  public function updateAction()
  {
    $templateTable = Engine_Api::_()->getDbtable('templates', 'sitenewsletter');
    $contentTable = Engine_Api::_()->getDbtable('content', 'sitenewsletter');
    $db = $templateTable->getAdapter();
    $db->beginTransaction();

    try {

      // Get page
      $template = $this->_getParam('template');
      $templateObject = $templateTable->fetchRow($templateTable->select()->where('name = ?', $template)->orWhere('template_id = ?', $template));
      if( null === $templateObject ) {
        throw new Engine_Exception('Page is missing');
      }

      // Update layout
      if( null !== ($newLayout = $this->_getParam('layout')) ) {
        $templateObject->layout = $newLayout;
        $templateObject->save();
      }

      // Get registered content areas
      $contentRowset = $contentTable->fetchAll($contentTable->select()->where('template_id = ?', $templateObject->template_id));

      // Get structure
      $strucure = $this->_getParam('structure');
      if( is_string($strucure) ) {
        $strucure = Zend_Json::decode(trim($strucure, '()'));
      }
      if( !is_array($strucure) ) {
        throw new Engine_Exception('Structure is not an array or valid json structure');
      }

      // Diff
      $orderIndex = 1;
      $newRowsByTmpId = array();
      $existingRowsByContentId = array();

      foreach( $strucure as $element ) {

        // Get info
        $content_id = @$element['identity'];
        $tmp_content_id = @$element['tmp_identity'];
        $parent_id = @$element['parent_identity'];
        $tmp_parent_id = @$element['parent_tmp_identity'];

        $newOrder = $orderIndex++;

        // Sanity
        if( empty($content_id) && empty($tmp_content_id) ) {
          throw new Exception('content id and tmp content id both empty');
        }

        // Get existing content row (if any)
        $contentRow = null;
        if( !empty($content_id) ) {
          $contentRow = $contentRowset->getRowMatching('content_id', $content_id);
          if( null === $contentRow ) {
            throw new Exception('content row missing');
          }
        }

        // Get existing parent row (if any)
        $parentContentRow = null;
        if( !empty($parent_id) ) {
          $parentContentRow = $contentRowset->getRowMatching('content_id', $parent_id);
        } else if( !empty($tmp_parent_id) ) {
          $parentContentRow = @$newRowsByTmpId[$tmp_parent_id];
        }

        // Existing row
        if( !empty($contentRow) && is_object($contentRow) ) {
          $existingRowsByContentId[$content_id] = $contentRow;

          // Update row
          if( !empty($parentContentRow) ) {
            $contentRow->parent_content_id = $parentContentRow->content_id;
          }
          if( empty($contentRow->parent_content_id) ) {
            $contentRow->parent_content_id = new Zend_Db_Expr('NULL');
          }

          // Set params
          if( isset($element['params']) && is_array($element['params']) ) {
            $contentRow->params = $element['params'];
          }

          if( $contentRow->type == 'container' ) {
            $newOrder = array_search($contentRow->name, array('top', 'main', 'bottom', 'left', 'right', 'middle')) + 1;
          }

          $contentRow->order = $newOrder;
          $contentRow->save();
        }

        // New row
        else
        {
          if( empty($element['type']) || empty($element['name']) ) {
            throw new Exception('missing name and/or type info');
          }

          if( $element['type'] == 'container' ) {
            $newOrder = array_search($element['name'], array('top', 'main', 'bottom', 'left', 'right', 'middle')) + 1;
          }

          $contentRow = $contentTable->createRow();
          $contentRow->template_id = $templateObject->template_id;
          $contentRow->order = $newOrder;
          $contentRow->type = $element['type'];
          $contentRow->name = $element['name'];

          // Set parent content
          if( !empty($parentContentRow) ) {
            $contentRow->parent_content_id = $parentContentRow->content_id;
          }
          if( empty($contentRow->parent_content_id) ) {
            $contentRow->parent_content_id = new Zend_Db_Expr('NULL');
          }
          
          // Set params
          if( isset($element['params']) && is_array($element['params']) ) {
            $contentRow->params = $element['params'];
          }

          $contentRow->save();

          $newRowsByTmpId[$tmp_content_id] = $contentRow;
        }
      }

      // Delete rows that were not present in data sent back
      $deletedRowIds = array();
      foreach( $contentRowset as $contentRow ) {
        if( empty($existingRowsByContentId[$contentRow->content_id]) ) {
          $deletedRowIds[] = $contentRow->content_id;
          $contentRow->delete();
        }
      }
      $this->view->deleted = $deletedRowIds;

      // Send back new content info
      $newData = array();
      foreach( $newRowsByTmpId as $tmp_id => $newRow ) {
        $newData[$tmp_id] = $templateTable->createElementParams($newRow);
      }
      $this->view->newIds = $newData;

      $this->view->status = true;
      $this->view->error = false;

      $db->commit();

    } catch( Exception $e ) {
      $db->rollBack();
      $this->view->status = false;
      $this->view->error = true;
    }
  }

  public function createAction()
  {
    
    // Check if Duplicating
    $old_template_id = $this->_getParam('duplicate');
        
    // Get page param
    $template = $this->_getParam('template');
    $templateTable = Engine_Api::_()->getDbtable('templates', 'sitenewsletter');
    $contentTable = Engine_Api::_()->getDbtable('content', 'sitenewsletter');

    // Make new page
    if( ($template == 'new' || $template === null) && $this->getRequest()->isPost() ) {
      $templateObject = $templateTable->createRow();
      $templateObject->displayname = ( null !== ($name = $this->_getParam('name')) ? $name : 'Untitled' );
      $templateObject->provides = 'no-subject';
      $templateObject->save();
      $new_template_id = $templateObject->template_id;
      
      if( $old_template_id != 'null') {
                
        $db = Engine_Db_Table::getDefaultAdapter();
        $old_template_content = $db->select()
            ->from('engine4_sitenewsletter_content')
            ->where('`template_id` = ?', $old_template_id)
            ->order(array('type', 'content_id'))
            ->query()
            ->fetchAll();
        
        $content_count = count($old_template_content);
        for($i = 0; $i < $content_count; $i++){
          $contentRow = $contentTable->createRow();
          $contentRow->template_id = $new_template_id;
          $contentRow->type = $old_template_content[$i]['type'];
          $contentRow->name = $old_template_content[$i]['name'];
          if( $old_template_content[$i]['parent_content_id'] != null ) {
            $contentRow->parent_content_id = $content_id_array[$old_template_content[$i]['parent_content_id']];            
          }
          else{
            $contentRow->parent_content_id = $old_template_content[$i]['parent_content_id'];
          }
          $contentRow->order = $old_template_content[$i]['order'];
          $contentRow->params = $old_template_content[$i]['params'];
          $contentRow->attribs = $old_template_content[$i]['attribs'];
          $contentRow->save();
          $content_id_array[$old_template_content[$i]['content_id']] = $contentRow->content_id;
        }        
      }
      else{
        // Create Empty Content Rows
        $contentRow = $contentTable->createRow();
        $contentRow->type = 'container';
        $contentRow->name = 'main';
        $contentRow->template_id = $templateObject->template_id;
        // explicitly setting parent_content_id to null to prevent pages
        // to pass validation check after being created
        $contentRow->parent_content_id = NULL;
        $contentRow->save();

        $contentRow2 = $contentTable->createRow();
        $contentRow2->type = 'container';
        $contentRow2->name = 'middle';
        $contentRow2->template_id = $templateObject->template_id;
        $contentRow2->parent_content_id = $contentRow->content_id;
        $contentRow2->save();

        $contentRow3 = $contentTable->createRow();
        $contentRow3->type = 'widget';
        $contentRow3->name = 'core.content';
        $contentRow3->template_id = $templateObject->template_id;
        $contentRow3->parent_content_id = $contentRow2->content_id;
        $contentRow3->save();
      }
    }

    if( $templateObject ) {
      return $this->_redirectCustom($this->view->url(array('action' => 'layout')).'?template='.$templateObject->template_id);
    } else {
      return $this->_redirectCustom($this->view->url(array('action' => 'layout')));
    }
  }

  public function deleteAction()
  {
    $template_id = $this->_getParam('template');

    if( !$this->getRequest()->isPost() ) {
      $this->view->status = false;
      $this->view->error = 'Invalid method';
      return;
    }

    $templateTable = Engine_Api::_()->getDbtable('templates', 'sitenewsletter');
    $template = $templateTable->find($template_id)->current();

    if( null === $template ) {
      $this->view->status = false;
      $this->view->error = 'Page not found';
      return;
    }

    if( !$template->custom ) {
      $this->view->status = false;
      $this->view->error = 'Cannot delete non-custom pages';
      return;
    }

    $templateTable->deleteTemplate($template);

    $this->view->status = true;
  }



  public function widgetAction()
  {
    // Render by widget name
    $mod = $this->_getParam('mod');
    $name = $this->_getParam('name');
    if( null === $name ) {
      throw new Exception('no widget found with name: ' . $name);
    }
    if( null !== $mod ) {
      $name = $mod . '.' . $name;
    }

    $contentInfoRaw = $this->getContentAreas();
    $contentInfo = array();
    foreach( $contentInfoRaw as $info ) {
      $contentInfo[$info['name']] = $info;
    }

    // It has a form specified in content manifest
    if( !empty($contentInfo[$name]['adminForm']) ) {

      if( is_string($contentInfo[$name]['adminForm']) ) { // Core_Form_Admin_Widget_*
        $formClass = $contentInfo[$name]['adminForm'];
        Engine_Loader::loadClass($formClass);
        $this->view->form = $form = new $formClass();
      } else if( is_array($contentInfo[$name]['adminForm']) ) {
        $this->view->form = $form = new Engine_Form($contentInfo[$name]['adminForm']);
      } else {
        throw new Core_Model_Exception('Unable to load admin form class');
      }

      // Try to set title if missing
      if( !$form->getTitle() ) {
        $form->setTitle('Editing: ' . $contentInfo[$name]['title']);
      }

      // Try to set description if missing
      if( !$form->getDescription() ) {
        $form->setDescription('placeholder');
      }

      $form->setAttrib('class', 'global_form_popup ' . $form->getAttrib('class'));

      // Add title element
      if( !$form->getElement('title') ) {
        $form->addElement('Text', 'title', array(
          'label' => 'Title',
          'order' => -100,
        ));
      }
      
      // Add mobile element?
      if( !$form->getElement('nomobile') ) {
        $form->addElement('Select', 'nomobile', array(
          'label' => 'Hide on mobile site?',
          'order' => 100000 - 5,
          'multiOptions' => array(
            '1' => 'Yes, do not display on mobile site.',
            '0' => 'No, display on mobile site.',
          ),
          'value' => '0',
        ));
      }


      if( !empty($contentInfo[$name]['isPaginated']) && !$form->getElement('itemCountPerPage') ) {
        $form->addElement('Text', 'itemCountPerPage', array(
          'label' => 'Count',
          'description' => '(number of items to show)',
          'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
          ),
          'order' => 1000000 - 1,
        ));
      }

      // Add submit button
      if( !$form->getElement('submit') && !$form->getElement('execute') ) {
        $form->addElement('Button', 'execute', array(
          'label' => 'Save Changes',
          'type' => 'submit',
          'ignore' => true,
          'decorators' => array(
            'ViewHelper',
          ),
          'order' => 1000000,
        ));
      }

      // Add name
      $form->addElement('Hidden', 'name', array(
        'value' => $name,
        'order' => 1000010,
      ));

      if( !$form->getElement('cancel') ) {
        $form->addElement('Cancel', 'cancel', array(
          'label' => 'cancel',
          'link' => true,
          'prependText' => ' or ',
          'onclick' => 'parent.Smoothbox.close();',
          'ignore' => true,
          'decorators' => array(
            'ViewHelper',
          ),
          'order' => 1000001,
        ));
      }

      if( !$form->getDisplayGroup('buttons') ) {
        $submitName = ( $form->getElement('execute') ? 'execute' : 'submit' );
        $form->addDisplayGroup(array(
          $submitName,
          'cancel',
        ), 'buttons', array(
          'order' => 1000002,
        ));
      }

      // Force method and action
      $form->setMethod('post')
        ->setAction($_SERVER['REQUEST_URI']);

      if( $this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost()) ) {
        $this->view->values = $form->getValues();
        $this->view->form = null;
      }
      
      return;
    }

    // Try to render admin page
    if( !empty($contentInfo[$name]) ) {
      try {
        $structure = array(
          'type' => 'widget',
          'name' => $name,
          'request' => $this->getRequest(),
          'action' => 'admin',
          'throwExceptions' => true,
        );

        // Create element (with structure)
        $element = new Engine_Content_Element_Container(array(
          'elements' => array($structure),
          'decorators' => array(
            'Children'
          )
        ));

        $content = $element->render();

        $this->getResponse()->setBody($content);

        $this->_helper->viewRenderer->setNoRender(true);
        return;
      } catch( Exception $e ) {
        
      }
    }

    // Just render default editing form
    $this->view->form = $form = new Engine_Form(array(
      'title' => $contentInfo[$name]['title'],
      'description' => 'placeholder',
      'method' => 'post',
      'action' => $_SERVER['REQUEST_URI'],
      'class' => 'global_form_popup',
      'elements' => array(
        array(
          'Text',
          'title',
          array(
            'label' => 'Title',
          )
        ),
        array(
          'Button',
          'submit',
          array(
            'label' => 'Save',
            'type' => 'submit',
            'decorators' => array('ViewHelper'),
            'ignore' => true,
            'order' => 1501,
          )
        ),
        array(
          'Hidden',
          'name',
          array(
            'value' => $name,
          )
        ),
        array(
          'Cancel',
          'cancel',
          array(
            'label' => 'cancel',
            'link' => true,
            'prependText' => ' or ',
            'onclick' => 'parent.Smoothbox.close();',
            'ignore' => true,
            'decorators' => array('ViewHelper'),
            'order' => 1502,
          )
        )
      ),
      'displaygroups' => array(
        'buttons' => array(
          'name' => 'buttons',
          'elements' => array(
            'submit',
            'cancel',
          ),
          'options' => array(
            'order' => 1500,
          )
        )
      )
    ));

    if( !empty($contentInfo[$name]['isPaginated']) ) {
      $form->addElement('Text', 'itemCountPerPage', array(
        'label' => 'Count',
        'description' => '(number of items to show)',
        'validators' => array(
          array('Int', true),
          array('GreaterThan', true, array(0)),
        )
      ));
    }

    if( $this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost()) ) {
      $this->view->values = $form->getValues();
      $this->view->form = null;
    } else {
      $form->populate($this->_getAllParams());
    }
  }
}