<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenewsletter
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminManageController.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenewsletter_AdminManageController extends Core_Controller_Action_Admin
{
  public function indexAction()
  {
    // Get navigation
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sitenewsletter_admin_main', array(), 'sitenewsletter_admin_main_manage');

    $order = $this->_getParam('order');
    $id = $this->_getParam('id');
    $page = $this->_getParam('page', 1);
    //MAKE FORM
    $this->view->formFilter = $formFilter = new Sitenewsletter_Form_Admin_Manage_Filter();

    if ($formFilter->isValid($this->_getAllParams())) {
      $values = $formFilter->getValues();
    }

    foreach ($values as $key => $value) {
      if (null === $value) {
        unset($values[$key]);
      }
    }

    $subscribeTable = Engine_Api::_()->getDbtable('subscribers', 'sitenewsletter');
    $subscribeTableName = $subscribeTable->info('name');

    //GET USER TABLE NAME
    $tableUserName = Engine_Api::_()->getItemTable('user')->info('name');

    //GET GUESTUSER TABLE
    $tableGuestUserName = Engine_Api::_()->getDbtable('guestusers', 'sitenewsletter')->info('name');

    // GET SUBSCRIBE CATEGORIES TABLE
    $tableSubCateName = Engine_Api::_()->getDbtable('subscribecategories', 'sitenewsletter')->info('name');

    $select = $subscribeTable->select();
    //MAKE QUERY
    $select = $subscribeTable->select()
            ->setIntegrityCheck(false)
            ->from($subscribeTable)
            ->joinLeft($tableUserName, "$subscribeTableName.resource_type = 'member' AND $subscribeTableName.resource_id = $tableUserName.user_id", array('level_id', 'email'))
            ->joinLeft($tableGuestUserName, "$subscribeTableName.resource_type = 'guest' AND $subscribeTableName.resource_id = $tableGuestUserName.user_id", array('email as emailid', 'level_id as levelid'))
            ->joinLeft($tableSubCateName, "$subscribeTableName.subscriber_id = $tableSubCateName.subscriber_id", 'category_id')
            ->group("$subscribeTableName.subscriber_id");

    $select->order(( !empty($id) ? $id : 'subscriber_id' ) . ' ' . ( !empty($order) ? $order : 'DESC' ));

    if( !empty($values['email']) ) {
      $email = $values['email'];
      $select->where("$tableUserName.email  LIKE '%$email%' OR $tableGuestUserName.email  LIKE '%$email%'");
    }
    if( !empty($values['level_id']) ) {
      $select->where($tableGuestUserName.'.level_id = '. $values['level_id'] . ' or ' .$tableUserName.'.level_id =  ' .$values['level_id']);
    }
    if( !empty($values['category_id']) ) {
      $select->where($tableSubCateName.'.category_id = ?', $values['category_id'] );
    }

    $this->view->assign($values);

    $valuesCopy = array_filter($values);
    // MAKE PAGINATOR
    $this->view->paginator = $paginator = Zend_Paginator::factory($select);
    $this->view->paginator = $paginator->setItemCountPerPage(10);
    $this->view->paginator = $paginator->setCurrentPageNumber($this->_getParam('page', 1));
    $this->view->formValues = $valuesCopy;
    $this->view->order = $order;
  }

  public function deleteSubscriberAction()
  {
    // In smoothbox
    $this->_helper->layout->setLayout('admin-simple');
    $subscriber_id = $this->_getParam('id');
    $this->view->subscriber_id = $subscriber_id;
    $subscription = Engine_Api::_()->getItem('sitenewsletter_subscriber', $subscriber_id);
    $user_id = $subscription->resource_id;
    $type = $subscription->resource_type;
    $subscribeCategoriesTable = Engine_Api::_()->getDbtable('subscribecategories', 'sitenewsletter');
    $selectData = $subscribeCategoriesTable->select()
        ->from($subscribeCategoriesTable->info('name'), 'subscribecategory_id')
        ->where('subscriber_id = ?', $subscriber_id)
        ->query()
        ->fetchAll();

    if( !$this->getRequest()->isPost() ) {
      return;
    }
    
    // Process
    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    
    try {

      foreach ($selectData as $subscategory_id) {
        $subscribecategory = Engine_Api::_()->getItem('sitenewsletter_subscribecategory', $subscategory_id['subscribecategory_id']);
        $subscribecategory->delete();
      }
      if ($type == 'guest') {
        Engine_Api::_()->getItem('sitenewsletter_guestuser', $user_id)->delete();
      }
      $subscription->delete(); 
      $db->commit();
    } catch( Exception $e ) {
      $db->rollBack();
      throw $e;
    }
    
    return $this->_forward('success', 'utility', 'core', array(
      'smoothboxClose' => 10,
      'parentRefresh'=> 10,
      'messages' => array('')
    ));
  }

  public function deleteselectedAction()
  {
    $this->view->ids = $ids = $this->_getParam('ids');
    $count = explode(",", $ids);
    $this->view->count = count($count);
    if( $this->getRequest()->isPost() ) {
      $ids_array = explode(",", $ids);
      foreach( $ids_array as $id ) {
        $subscriber = Engine_Api::_()->getItem('sitenewsletter_subscriber', $id);
        $user_id = $subscriber->resource_id;
        $type = $subscriber->resource_type;

        $subscribeCategoriesTable = Engine_Api::_()->getDbtable('subscribecategories', 'sitenewsletter');

         $subscribeCategoriesData = $subscribeCategoriesTable->select()
          ->from($subscribeCategoriesTable->info('name'), 'subscribecategory_id')
          ->where('subscriber_id = ?', $id)
          ->query()
          ->fetchAll();

        $db = Engine_Db_Table::getDefaultAdapter();
        $db->beginTransaction();
        
        try {

          foreach ($subscribeCategoriesData as $subscategory_id) {
            $subscribecategory = Engine_Api::_()->getItem('sitenewsletter_subscribecategory', $subscategory_id['subscribecategory_id']);
            $subscribecategory->delete();
          }
          if ($type == 'guest') {
            Engine_Api::_()->getItem('sitenewsletter_guestuser', $user_id)->delete();
          }
          $subscriber->delete();  
          $db->commit();
        } catch( Exception $e ) {
          $db->rollBack();
          throw $e;
        }
      }
      $this->_forward('success', 'utility', 'core', array(
        'smoothboxClose' => 10,
        'parentRefresh' => 10,
        'messages' => array('')
      ));
    }
  }

  public function addSubscriberAction()
  {
    //SET LAYOUT
    $this->_helper->layout->setLayout('admin-simple');

    //FORM GENERATION
    $form = $this->view->form = new Sitenewsletter_Form_Admin_Subscriber_Add();
    //CHECK POSTy
    if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {

      if ($_POST['type'] != 'list') {
        if ($_POST['type'] == 'guest')
          $email = $_POST['emailid'];
        else
          $email = $_POST['email'];
          if( empty($email) ) {
            $form->addError($this->view->translate("Please complete this field - it is required."));
            return;
          }

        if( !empty($email) ) {
          $regexp = "/^[a-z0-9]+([a-z0-9_\+\\.-]+)*@([a-z0-9]+([\.-][a-z0-9]+)*)+\\.[a-z]{2,}$/i";
          if( !(bool) preg_match($regexp, $email) ) {
            $form->addError($this->view->translate('Email * Please enter correct email id.'));
            return;
          }
        }
      }

      //GET FORM VALUES
      $values = $form->getValues();

      //BEGIN TRANSACTION
      $db = Engine_Db_Table::getDefaultAdapter();
      $db->beginTransaction();

      if ($values['type'] == 'list') {

        //MAKE SURE THAT FILE EXTENSION SHOULD NOT DIFFER FROM ALLOWED TYPE
        $ext = str_replace(".", "", strrchr($_FILES['filename']['name'], "."));
        if (!in_array($ext, array('csv', 'CSV'))) {
          $error = $this->view->translate("Invalid file extension. Only 'csv' extension is allowed.");
          $error = Zend_Registry::get('Zend_Translate')->_($error);
          $form->getDecorator('errors')->setOption('escape', false);
          $form->addError($error);
          return;
        }

        //START READING DATA FROM CSV FILE
        $temp_name = $_FILES['filename']['tmp_name']; 
        $pos = strrpos($temp_name, "/");
        $substring = substr($temp_name, 0,$pos+1);
        $fname = $substring.$_FILES['filename']['name'];
        
        @chmod($fname, 0777);
        $fp = fopen($fname, "r");
        if ((!$fp)) {
          echo "$fname File opening error";
          exit;
        }
        while ($buffer = fgets($fp, 10000)) {
          $explode_array[] = explode(',', $buffer);
        }

        foreach ($explode_array[0] as $emails => $email) {
          $table = Engine_Api::_()->getDbtable('users', 'user');
          $row = $table->fetchRow($table->select()->from($table->info('name'), 'user_id')->where('email = ?', $email));
          if (isset($row->user_id)) {
            $type = 'member';
            $user_id = $row->user_id;
          }

          $guest = Engine_Api::_()->getDbtable('guestusers', 'sitenewsletter');
          $guestRow = $guest->fetchRow($guest->select()->from($guest->info('name'), 'user_id')->where('email = ?', $email));
          if (isset($guestRow->user_id)) {
            $type = 'guest';
            $user_id = $guestRow->user_id;
          }
          try {
            if (!isset($user_id)) {
              $authorizationTable = Engine_Api::_()->getItemTable('authorization_level');
              $authorization = $authorizationTable->fetchRow(array('type = ?' => 'public', 'flag = ?' => 'public'));
              if (!empty($authorization))
                $level_id = $authorization->level_id;
              $guest->insert(array(
                'email' => $email,
                'level_id' => $level_id,
                'creation_date' => date('Y-m-d H:i:s'),
              ));
              $type = 'guest';
            }

            $subscriber = Engine_Api::_()->getDbtable('subscribers', 'sitenewsletter');
            if (isset($user_id)) {
              $data = $subscriber->fetchRow($subscriber->select()->from($subscriber->info('name'), 'subscriber_id')->where('resource_id = ?', $user_id)->where('resource_type = ?', $type));
              $subscriber_id = $data->subscriber_id;
            } else {
              $user_id = $guest->getAdapter()->lastInsertId();
              $subscriber->insert(array(
                'resource_id' => $user_id,
                'resource_type' => $type,
                'creation_date' => date('Y-m-d H:i:s'),
              ));
              $subscriber_id = $subscriber->getAdapter()->lastInsertId();
            }

            if ($subscriber_id) {
              $subscribeCategories = Engine_Api::_()->getDbtable('subscribecategories', 'sitenewsletter');
              foreach ($values['category_id'] as $category_id) {
                $alreadySubscribed = $subscribeCategories->fetchRow($subscribeCategories->select()->from($subscribeCategories->info('name'), 'subscribecategory_id')->where('subscriber_id = ?', $subscriber_id)->where('category_id = ?', $category_id));
                if (isset($alreadySubscribed->subscribecategory_id))
                  continue;
                // insert the value for subscribe categories
                $subscategory = $subscribeCategories->createRow();
                $subscategory->subscriber_id = $subscriber_id;
                $subscategory->category_id = $category_id;
                $subscategory->save();
              }
            }
            unset($user_id);
            unset($subscriber_id);
            $db->commit();
          } catch (Exception $e) {
            $db->rollBack();
            throw $e;
          }
        }

        $message = 'Subscribed Successfully!!!';
      } else {
        if ($values['emailid']) 
          $email = $values['emailid'];
        else 
          $email = $values['email'];
        $guestUser = Engine_Api::_()->getDbtable('guestusers', 'sitenewsletter');
        $isGuest = $guestUser->isGuestuser($email);

        if ($isGuest) {
          $guest = $guestUser->fetchRow($guestUser->select()->from($guestUser->info('name'), 'user_id')->where('email = ?', $email));
          $user_id = $guest->user_id;
          $type = 'guest';
        } else {
          $userTable = Engine_Api::_()->getDbtable('users', 'user');
          $userRow = $userTable->fetchRow($userTable->select()->from($userTable->info('name'), 'user_id')->where('email = ?', $email));
          if (isset($userRow->user_id)) {
            $type = 'member';
            $user_id = $userRow->user_id;
          }
        }

        if (!empty($user_id)) {
          $subscriptionTable = Engine_Api::_()->getDbtable('subscribers', 'sitenewsletter');
          $isSubscribed = $subscriptionTable->isSubscribed($user_id, $type);
        }

        if( isset($isSubscribed) && $isSubscribed ) {
          $message = 'Already subscribed!!!';
        } else {
            try {
              $subscriber = Engine_Api::_()->getDbtable('subscribers', 'sitenewsletter');
              // IF USER IS GUEST
              if ($values['type'] == 'guest') {
                $authorizationTable = Engine_Api::_()->getItemTable('authorization_level');
                $authorization = $authorizationTable->fetchRow(array('type = ?' => 'public', 'flag = ?' => 'public'));
                if (!empty($authorization))
                  $level_id = $authorization->level_id;

                //IF NOT THEN INSERT THE VALUES AND SUBSCRIBE GUEST USER
                $guestUser->insert(array(
                  'email' => $values['emailid'],
                  'level_id' => $level_id,
                  'creation_date' => date('Y-m-d H:i:s'),
                ));
                $guest_id = $guestUser->getAdapter()->lastInsertId();

                if ($guest_id) {
                  $subscriber->insert(array(
                    'resource_id' => $guest_id,
                    'resource_type' => $values['type'],
                    'creation_date' => date('Y-m-d H:i:s'),
                  ));
                  $subscriber_id = $subscriber->getAdapter()->lastInsertId();
                  $message = "Subscribed Successfully!!!";
                }
              } else {

                  // IF NOT THEN INSERT
                  $subscriber->insert(array(
                    'resource_id' => $values['resource_id'],
                    'resource_type' => $values['type'],
                    'creation_date' => date('Y-m-d H:i:s'),
                  ));
                  $subscriber_id = $subscriber->getAdapter()->lastInsertId();

                  $message = "Subscribed Successfully!!!";
              }

              if (!empty($subscriber_id)) {
                $subscribeCategories = Engine_Api::_()->getDbtable('subscribecategories', 'sitenewsletter');
                foreach ($values['category_id'] as $category_id) {
                  // insert the value for subscribe categories
                  $subscategory = $subscribeCategories->createRow();
                  $subscategory->subscriber_id = $subscriber_id;
                  $subscategory->category_id = $category_id;
                  $subscategory->save();
                }
              }

              $db->commit();
            } catch (Exception $e) {
              $db->rollBack();
              throw $e;
            }
          
        }
      }
      
      return $this->_forward('success', 'utility', 'core', array(
        'smoothboxClose' => 1000,
        'parentRefresh' => 10,
        'messages' => array($message),
      ));
    }
  }

  //ACTION FOR EMAIL 
  public function getEmailAction() {
    $title = $this->_getParam('text', null);
    $limit = $this->_getParam('limit', 40);
    $enabled = $this->_getParam('enabled');
    $userTable = Engine_Api::_()->getDbtable('users', 'user');
    $userName = $userTable->info('name');

    $data = array();
    $select = $userTable->select()
            ->setIntegrityCheck(false)
            ->from($userName)
            ->where('enabled = ?', $enabled)
            ->where("email LIKE '%$title%'")
            ->limit($limit)
            ->order('creation_date DESC');

    $users = $userTable->fetchAll($select);

    foreach ($users as $user) {
      $content_photo = $this->view->itemPhoto($user, 'thumb.normal');
      $data[] = array(
          'id' => $user->user_id,
          'label' => $user->email,
          'photo' => $content_photo
      );
    }
    return $this->_helper->json($data);
  }

  public function editSubscriberAction()
  {
    // In smoothbox
    $this->_helper->layout->setLayout('admin-simple');
    $subscriber_id = $this->_getParam('id');
    $this->view->subscriber_id = $subscriber_id;
    $subscribersTable = Engine_Api::_()->getDbtable('subscribers', 'sitenewsletter');
    $subscriber = $subscribersTable->find($subscriber_id)->current();
    
    if( !$subscriber ) {
      return $this->_forward('success', 'utility', 'core', array(
        'smoothboxClose' => 10,
        'parentRefresh'=> 10,
        'messages' => array('')
      ));
    } else {
      $subscriber_id = $subscriber->getIdentity();
    }
    
    $params = $subscriber->toArray();
    $form = $this->view->form = new Sitenewsletter_Form_Admin_Subscriber_Edit(array('item' => $subscriber));
    $form->setAction($this->getFrontController()->getRouter()->assemble(array()));

    if( !$this->getRequest()->isPost() ) {
      return;
    }

    if( !$form->isValid($this->getRequest()->getPost()) ) {
      return;
    }

    // Process
    $values = $form->getValues();
    $type = $subscriber->resource_type;
    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();

    try {

      $subscriber = Engine_Api::_()->getDbtable('subscribers', 'sitenewsletter');

      // IF USER IS GUEST
      if ($type == 'guest') {
        $guestUser = Engine_Api::_()->getDbtable('guestusers', 'sitenewsletter');
        $isGuest = $guestUser->isGuestuser($values['emailid']);

        if ($isGuest) {
          $guest = $guestUser->fetchRow($guestUser->select()->from($guestUser->info('name'), 'user_id')->where('email = ?', $values['emailid']));
              $guest_id = $guest->user_id;
        }

        if (isset($guest_id)) {
          $subscribed = $subscriber->isSubscribed($guest_id, $type);
              
          if ($subscribed) {
            $sub = $subscriber->fetchRow($subscriber->select()->from($subscriber->info('name'), 'subscriber_id')->where('resource_id = ?', $guest_id)->where('resource_type = ?', $type));
                $subscriber_id = $sub->subscriber_id;
          }
        }
      } else {
        // IF USER IS SITE MEMBER
        $user = Engine_Api::_()->getDbtable('users', 'user');
        $resource_id = $user->fetchRow($user->select()->from($user->info('name'), 'user_id')->where('email = ?', $values['emailid']));

        $isSubscribed = $subscriber->isSubscribed($resource_id, $type);

        // CHECK USER ALREADY SUBSCRIBED OR NOT
        if ($isSubscribed) {
          $sub = $subscriber->fetchRow($subscriber->select()->from($subscriber->info('name'), 'subscriber_id')->where('resource_id = ?', $resource_id)->where('resource_type = ?', $type));
              
          $subscriber_id = $sub->subscriber_id;
        }
      }

      if ($subscriber_id) {
        $subscribeCategories = Engine_Api::_()->getDbtable('subscribecategories', 'sitenewsletter');
        $select = $subscribeCategories->select()
            ->from($subscribeCategories->info('name'), 'subscribecategory_id')
            ->where('subscriber_id = ?', $subscriber_id)
            ->query()
            ->fetchAll();

        foreach ($select as $key => $value) {
          $subscribeCategory = Engine_Api::_()->getItem('sitenewsletter_subscribecategory', $value['subscribecategory_id']);
          $subscribeCategory->delete();
        }

        foreach ($values['category_id'] as $category_id) {
          // insert the value for subscribe categories
          $subscategory = $subscribeCategories->createRow();
          $subscategory->subscriber_id = $subscriber_id;
          $subscategory->category_id = $category_id;
          $subscategory->save();
        }
      }
      $db->commit();
    } catch (Exception $e) {
      $db->rollBack();
      throw $e;
    }
    return $this->_forward('success', 'utility', 'core', array(
      'smoothboxClose' => 10,
      'parentRefresh'=> 10,
      'messages' => array('')
    ));
  }
}