<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenewsletter
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminStatisticsController.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitenewsletter_AdminStatisticsController extends Core_Controller_Action_Admin
{
  public function indexAction()
  {
  	$this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitenewsletter_admin_main', array(), 'sitenewsletter_admin_main_statistics');

    $campaigns = Engine_Api::_()->getDbTable('campaigns', 'sitenewsletter');
    $multiOptions = $campaigns->getCampaigns();
    //FILTER FORM
    if (count($multiOptions) <= 1) {
      $multiOptions = array();
    }
    $this->view->options = $multiOptions;
    $this->view->formFilter = $formFilter = new Sitenewsletter_Form_Admin_Statistics_Filter();
    $formFilter->id->setMultiOptions($multiOptions);


  }
  public function chartDataAction()
  {
  // Disable layout and viewrenderer
    $this->_helper->layout->disableLayout();
    $this->_helper->viewRenderer->setNoRender(true);

    // Get params
    $id = $this->_getParam('id');

    $statsTable = Engine_Api::_()->getDbtable('statistics', 'sitenewsletter');

    if ($id != 'global') {
    // Get data
      $prefix = Engine_Api::_()->getItem('sitenewsletter_campaign', $id)->subject;
      $statsSelect = $statsTable->select()
        ->where('campaign_id = ?', $id)
        ->order('date ASC')
        ;
    } else {
      $prefix = 'Overall statistics of all the campaigns';
      $statsSelect = $statsTable->select()
        ->from($statsTable->info('name'), array('sent' => 'SUM(`sent`)', 'viewed' => 'SUM(`viewed`)', 'referred' => 'SUM(`referred`)', 'date'))
        ->group('date')
        ->order('date ASC')
        ;
    }
    $rawData = $statsTable->fetchAll($statsSelect);

    // Now create data structure
    $dataLabels = array();
    $dataLabels[] = ['Date', 'Sent', 'Viewed', 'Visited link'];
    
    foreach( $rawData->toArray() as $rawDatum => $data ) {
      $date = $this->view->locale()->toDate($data['date']);
      $sent = (int) $data['sent'];
      $viewed = (int) $data['viewed'];
      $referred = (int) $data['referred'];
      $dataLabels[] = [$date, $sent, $viewed, $referred];
    }

    $translate = Zend_Registry::get('Zend_Translate');
    $title = $prefix;

    $this->view->title = $title;
    $this->view->data = $dataLabels;
  }

  public function referCountAction() 
  {
    $campaign_id = $this->_getParam('id');
    $forward = $this->_getParam('forward');
    $email = $this->_getParam('mail');

    if ($email) {
      $statsHisTable = Engine_Api::_()->getDbtable('statisticshistory', 'sitenewsletter');
      $refer = $statsHisTable->select()
        ->from($statsHisTable->info('name'), 'refer')
        ->where('campaign_id = ?', $campaign_id)
        ->where('email = ?', $email)
        ->query()
        ->fetchColumn();

      if (empty($refer)) {
        $statsHisTable->update(array('refer' => 1), array('`email` =  ?' => $email, '`campaign_id` = ?' => $campaign_id));
        $statsTable = Engine_Api::_()->getDbtable('statistics', 'sitenewsletter');
        $statsSelect = $statsTable->select()
          ->where('campaign_id = ?', $campaign_id)
          ->where('date = ?', date('Y-m-d'));
        $rawData = $statsTable->fetchAll($statsSelect);
        $db = $statsTable->getAdapter();
        $db->beginTransaction();
        try {
          $data = $rawData->toArray();
          $statsTable->update(array('referred' => ++$data[0]['referred'],), array('`statistics_id` = ?' => $data[0]['statistics_id'],));
          // }
          $db->commit();
        } catch( Exception $e ) {
          $db->rollBack();
          throw $e;
        }
      }
    }

    header("location: $forward");
    exit();    
  }
}