<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenewsletter
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: SubscribeController.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenewsletter_SubscribeController extends Core_Controller_Action_Standard
{
  public function indexAction()
  {
    $request = Zend_Controller_Front::getInstance()->getRequest();
    $email = $request->getParam('email');
    if( empty($email) ) {
      $this->view->resp = false;
      $this->view->msg = 'Please enter valid email address.';
      return;
    }

    $user_id = 0;
    $viewer = Engine_Api::_()->user()->getViewer();
    if (!empty($viewer->level_id)) {
      $user_id = $viewer->getIdentity();
      $type = 'member';
      // Subscribed user details insert into table
      
    } else {
      $guestuserTable = Engine_Api::_()->getDbtable('guestusers', 'sitenewsletter');
      $guestRow = $guestuserTable->fetchRow($guestuserTable->select()->from($guestuserTable->info('name'), 'user_id')->where('email = ?', $email));
      if ($guestRow) {
        $user_id = $guestRow->user_id;
        $type = 'guest';
      } else {
        $table = Engine_Api::_()->getDbtable('users', 'user');
        $row = $table->fetchRow($table->select()->from($table->info('name'), 'user_id')->where('email = ?', $email));
        if (isset($row->user_id)) {
          $type = 'member';
          $user_id = $row->user_id;
        }
      }
    }

    if ($user_id) {
      $subscriptionTable = Engine_Api::_()->getDbtable('subscribers', 'sitenewsletter');
      if( $subscriptionTable->isSubscribed($user_id, $type) ) {
        $this->view->resp = false;
        $this->view->msg = 'You have been already subscribed.';
        return;
      }
    } else {
      if (!empty($viewer->level_id)) {
        $user_id = $viewer->getIdentity();
        $type = 'member';
      } else {
        $type = 'guest';
      }
    }

    $verification = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitenewsletter.email.verification', 0);

    if (($verification == 1 && $type == 'member') || ($verification == 2 && ($type == 'guest' || $type == 'member'))) {
      $siteName = Engine_Api::_()->getApi('settings','core')->core_general_site_title;
      $emailid = Engine_Api::_()->getApi('settings', 'core')->core_mail_from;
      $reciever_email = $email;
      $view = Zend_Registry::get('Zend_View');
      $link = $view->absoluteUrl(Zend_Controller_Front::getInstance()->getRouter()->assemble(array(
                    'action' => 'confirm',
                    'token' => base64_encode(time() . ":" . $email),
                    'type' => $type
                        ), 'confirm', true));
      $button = "<a href=$link style='background: #619dbe;padding: 14px 18px;display: inline-block;border-radius: 4px;color: #fff;text-decoration: none;font-weight: bold;'>Confirm Subscription</a>";

      $sent = Engine_Api::_()->getApi('mail', 'core')->sendSystem($reciever_email, 'NEWSLETTER_SUBSCRIBE_EMAIL_NOTIFICATION', array(
          'sitename' => $siteName,
          'button' => $button,
          'email' => $emailid,
          'queue' => false 
        )
      );
      if($sent) {
        $this->view->resp = true;
        $this->view->msg = '<div style="margin:5px 10px 0 0;"><center>Please check your email to activate your subscription!</center></div><br /> <center> <button  onclick="javascript:blankTextField();">ok</button> </center>';
        return;
      }
    } else {
      $session = new Zend_Session_Namespace('confirmsubscribers');
      $session->email = $email;
      $session->type = $type;

      $this->view->resp = true;
      $this->view->msg = $this->view->url(array('action' => 'confirm', 'controller' => 'subscribe'),'default');
      return;
    }
  }

  public function confirmAction() {
    // Get session values
    $session = new Zend_Session_Namespace('confirmsubscribers');
    if ($session->email) {
      $email = $session->email;
      $type = $session->type;
    }
    if ($this->_getParam('type', null)) {
      $type = $this->_getParam('type', null);
      $token = $this->_getParam('token', null);
    }
    // Get verify user
    if (isset($token)) {
      $decodedToken = base64_decode($token);
      $decodedToken = explode(':', $decodedToken);
      $email = $decodedToken[1];
    }

    $user_id = 0;
    $viewer = Engine_Api::_()->user()->getViewer();
    if (!empty($viewer->level_id)) {
      $user_id = $viewer->getIdentity();
      $type = 'member';
      // Subscribed user details insert into table
      
    } else {
      $guestuserTable = Engine_Api::_()->getDbtable('guestusers', 'sitenewsletter');
      $guestRow = $guestuserTable->fetchRow($guestuserTable->select()->from($guestuserTable->info('name'), 'user_id')->where('email = ?', $email));
      if ($guestRow) {
        $user_id = $guestRow->user_id;
        $type = 'guest';
      } else {
        $table = Engine_Api::_()->getDbtable('users', 'user');
        $row = $table->fetchRow($table->select()->from($table->info('name'), 'user_id')->where('email = ?', $email));
        if (isset($row->user_id)) {
          $type = 'member';
          $user_id = $row->user_id;
        }
      }
    }
    
    if ($user_id) {
      $subscriptionTable = Engine_Api::_()->getDbtable('subscribers', 'sitenewsletter');
      if( $subscriptionTable->isSubscribed($user_id, $type) ) {
        $this->view->resp = false;
        $this->view->msg = 'You have been already subscribed.';
        return;
      }
    }

    $session->unsetAll();
    // Create session
    $session = new Zend_Session_Namespace('subscribers');
    $session->email = $email;

    if (isset($token)) {
      $this->view->resp = true;
    } else {
      $this->_forward('update-category', null, null, array('format' => 'smoothbox'));
    }
  }

  public function updateCategoryAction()
  {
    $this->_helper->layout->setLayout('default-simple');
    // Get session values
    $session = new Zend_Session_Namespace('subscribers');
    $email = $session->email;
    
    $categoryTable = Engine_Api::_()->getDbtable('categories', 'sitenewsletter');
    $this->view->categories = $categoryTable->getEnabledCategories();

    if (count($this->view->categories) > 1) { 
      // Generate form
      $this->view->form = $form = new Sitenewsletter_Form_FetchCategories();
      // Check post
      if( !$this->getRequest()->isPost() ) {
        return;
      }

      if( !$form->isValid($this->getRequest()->getPost()) ) {
        return;
      }
      if (empty($_POST['categories'])) {
        $form->addError($this->view->translate("Please complete this field - it is required."));
        return;
      }
      // Get values from form
      $values = $form->getValues();
    } else {
      if(empty($this->view->categories)) {
        $hideCategories = $categoryTable->getHideEnabledCategories();
        $values['categories'] = array_keys($hideCategories);
      } else {
        $values['categories'] = array_keys($this->view->categories);
      }
    }

    $viewer = Engine_Api::_()->user()->getViewer();

    if (!empty($viewer->level_id)) {
      $user_id = $viewer->getIdentity();
      $type = 'member';
    } else {

      // Check the guest user already exist or not 
      $guestuserTable = Engine_Api::_()->getDbtable('guestusers', 'sitenewsletter');
      if (!$guestuserTable->isGuestUser($email)) {

        $authorizationTable = Engine_Api::_()->getItemTable('authorization_level');
        $authorization = $authorizationTable->fetchRow(array('type = ?' => 'public', 'flag = ?' => 'public'));
        if (!empty($authorization))
          $level_id = $authorization->level_id;
        // If guest user is not exist then insert the value in database
        $db = $guestuserTable->getAdapter();
        $db->beginTransaction();
        try
        {
          $insertedId = $guestuserTable->insert(array(
            'email' => $email, 
            'level_id' => $level_id,
            'creation_date' => date('Y-m-d H:i:s'),
          ));
          // Commit
          $db->commit();
        }

        catch( Exception $e )
        {
          $db->rollBack();
          throw $e;
        }
        $user_id = $insertedId;
        $type = 'guest';
      } else {
        // If already exist then get user_id
        $guestRow = $guestuserTable->fetchRow($guestuserTable->select()->from($guestuserTable->info('name'), 'user_id')->where('email = ?', $email));
        $user_id = $guestRow->user_id;
        $type = 'guest';
      }
    }

    $categoryTable = Engine_Api::_()->getDbtable('categories', 'sitenewsletter');
    if ($type == 'guest') {
      $select = $categoryTable->select()
        ->from($categoryTable->info('name'), 'category_id')
        ->where('visibility = ?', 1)
        ->where('subscribe_gusers = ?', 1);
      $categories = $select->query()->fetchAll();
    } else {
      $select = $categoryTable->select()
        ->from($categoryTable->info('name'), 'category_id')
        ->where('visibility = ?', 1)
        ->where('subscribe_eusers = ?', 1);
      $categories = $select->query()->fetchAll();
    }

    if (!empty($categories) && count($categories)>0) {
      foreach ($categories as $category => $c_id) {
        array_push($values['categories'], $c_id['category_id']);
      }
    }

    // Subscribed user details insert into table
    $subscriptionTable = Engine_Api::_()->getDbtable('subscribers', 'sitenewsletter');

    $subscriptionTable->insert(array(
      'resource_id' => $user_id, 
      'resource_type' => $type,
    ));
    $subscription_id = $subscriptionTable->getAdapter()->lastInsertId();

    // Insert the subscriber categories
    $subscribeCategories = Engine_Api::_()->getDbtable('subscribecategories', 'sitenewsletter');
    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    try {
      foreach ($values['categories'] as $key => $value) {
        $subscribeCategories->insert(array(
          'subscriber_id' => $subscription_id, 
          'category_id' => $value,
        ));
      }
      $db->commit();
    } catch (Exception $e) {
      $db->rollBack();
      throw $e;
    }

    // unset of the session values
    $session->unsetAll();

    return $this->_forward('success' ,'utility', 'core', array(
      'smoothboxClose' => 2000,
      'format'=> 'smoothbox',
      'parentRedirect' => Zend_Controller_Front::getInstance()->getRouter()->assemble(array(), 'default', true),        
      'messages' => Array('Thank you for subscribing to our newsletter!')
    ));
  }

  public function unsubscribeAction()
  {
    $token = $this->_getParam('token');

    // Get verify user
    if ($token) {
      $decodedToken = base64_decode($token);
      $decodedToken = explode(':', $decodedToken);
      $email = $decodedToken[1];
    }

    $userTable = Engine_Api::_()->getDbtable('users', 'user');
    $isUser = $userTable->fetchRow($userTable->select()->where('email = ?', $email));

    $guestuserTable = Engine_Api::_()->getDbtable('guestusers', 'sitenewsletter');
    $isGuestUser = $guestuserTable->fetchRow($guestuserTable->select()->where('email = ?', $email));

    if ($isUser && $isUser->getIdentity()) {
      $userId = $isUser->getIdentity();
      $type = 'member';
    }

    if ($isGuestUser && $isGuestUser->getIdentity()) {
      $userId = $isGuestUser->getIdentity();
      $type = 'guest';
    }

    //Get subscribed user exists or not 
    $subscriberTable = Engine_Api::_()->getDbtable('subscribers', 'sitenewsletter');
    $subscriber = $subscriberTable->fetchRow($subscriberTable->select()->where('resource_id = ?', $userId)->where('resource_type = ?', $type));

    if( !$subscriber || !$subscriber->getIdentity() ) {
      $this->view->status = false;
      $this->view->msg = $this->view->translate('You have been already unsubscribed.');
      return;
    }
    $this->view->user_id = $userId;
    $this->view->type = $type;
    $this->view->status = true;
  }

  public function unsubscribeCategoryAction() {
    $user_id = $this->_getParam('id', null);
    $type = $this->_getParam('type', null);

    //Get subscribed user exists or not 
    $subscriberTable = Engine_Api::_()->getDbtable('subscribers', 'sitenewsletter');
    $subscriber = $subscriberTable->fetchRow($subscriberTable->select()->where('resource_id = ?', $user_id)->where('resource_type = ?', $type));

    // Get susbcribed categories for subscribed user exists or not
    $subscribeCategoriesTable = Engine_Api::_()->getDbtable('subscribecategories', 'sitenewsletter');
    $subscribedCat = $subscribeCategoriesTable->select()->where('subscriber_id = ?', $subscriber->subscriber_id)->query()->fetchAll();

    $categoryTable = Engine_Api::_()->getDbtable('categories', 'sitenewsletter');

    if (count($subscribedCat) > 1) {
      //Get Subscribed Categories
      $options = $categoryTable->getAllEnabledCategories();

      // Generate form
      $this->view->form = $form = new Sitenewsletter_Form_FetchCategories();
      $form->categories->setMultiOptions($options);
      $form->categories->setValue('');
      $form->setAction($this->getFrontController()->getRouter()->assemble(array('module' => 'sitenewsletter', 'controller'=> 'subscribe', 'action' => 'unsubscribe-category')));

      // Check post
      if( !$this->getRequest()->isPost() ) {
        return;
      }

      if( !$form->isValid($this->getRequest()->getPost()) ) {
        return;
      }

      if (empty($_POST['categories'])) {
        $form->addError($this->view->translate("Please complete this field - it is required."));
        return;
      }
    
      // Get values from form
      $values = $form->getValues();
    } else {
      $values['categories'][] = $subscribedCat[0]['category_id'];
    }
    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    try {
      foreach ($values['categories'] as $categories => $categoryId) {
        $subscribeCategoriesTable->delete(array(
          'category_id = ?' => $categoryId,
          'subscriber_id = ?' => $subscriber->getIdentity(),
        ));
      }

      $subscribeCategories = $subscribeCategoriesTable->select()->where('subscriber_id = ?', $subscriber->getIdentity())->query()->fetchAll();
      if (empty($subscribeCategories)) {

        Engine_Api::_()->getItem('sitenewsletter_subscriber', $subscriber->getIdentity())->delete();

        if ($type == 'guest') {
          Engine_Api::_()->getItem('sitenewsletter_guestuser', $user_id)->delete();
        }
      }
      $db->commit();
    } catch (Exception $e) {
      $db->rollBack();
      throw $e;
    }
    return $this->_forward('success' ,'utility', 'core', array(
      'smoothboxClose' => 3000,
      'format'=> 'smoothbox',
      'parentRedirect' => Zend_Controller_Front::getInstance()->getRouter()->assemble(array(), 'default', true),        
      'messages' => Array('Your have been successfully unsubscribed.')
    ));
  }

}