<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenewsletter
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitenewsletter_Installer extends Engine_Package_Installer_Module
{
  function onInstall() {
    parent::onInstall();

    $this->placeWidget();
    $this->placeHeaderWidget();
    $this->placeFooterWidget();
    $this->placeContentWidget('newsletter_default_template', 'Default Template', 18, '#000000',  16, '#000000', '#000000');
    $this->placeContentWidget('newsletter_default_template1', 'Default Template 1', 18, '#000000',  16, '#000000', '#FFFFFF');
    $this->_updateCategoriesPage();
    
  }

  public function placeWidget() {
    $db = $this->getDb();

    // PLACE SCHEMA MARKUP WIDGET
    $select = new Zend_Db_Select($db);
    $select
      ->from('engine4_core_pages')
      ->where('name = ?', 'footer')
      ->limit(1);
    $info = $select->query()->fetch();

    if (empty($info)) 
      return false;

    $page_id = $info['page_id'];
    $select = new Zend_Db_Select($db);
    $select->from('engine4_core_content')
      ->where('name = ?', 'sitenewsletter.newsletter-subscribe')
      ->where('page_id = ?', $page_id)
      ->where('type = ?', 'widget')
      ->limit(1);
    $info = $select->query()->fetch();

    if (!empty($info)) 
      return false;

    $select = new Zend_Db_Select($db);
    $select
      ->from('engine4_core_content')
      ->where('name = ?', 'main')
      ->where('page_id = ?', $page_id)
      ->where('type = ?', 'container')
      ->limit(1);
    $info = $select->query()->fetch();

    if ($info) {
      $container_id = $info['content_id'];
      // Insert content
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitenewsletter.newsletter-subscribe',
        'page_id' => $page_id,
        'parent_content_id' => $container_id,
        'order' => 10,
      ));
    }
  }

  public function placeHeaderWidget() {
    $db = $this->getDb();

    // PLACE SCHEMA MARKUP WIDGET
    $select = new Zend_Db_Select($db);
    $select
      ->from('engine4_sitenewsletter_templates')
      ->where('name = ?', 'header')
      ->limit(1);
    $info = $select->query()->fetch();

    if (empty($info)) 
      return false;

    $template_id = $info['template_id'];
    $select = new Zend_Db_Select($db);
    $select->from('engine4_sitenewsletter_content')
      ->where('name = ?', 'sitenewsletter.template-header')
      ->where('template_id = ?', $template_id)
      ->where('type = ?', 'widget')
      ->limit(1);
    $info = $select->query()->fetch();

    if (!empty($info)) 
      return false;

    $select = new Zend_Db_Select($db);
    $select
      ->from('engine4_sitenewsletter_content')
      ->where('name = ?', 'main')
      ->where('template_id = ?', $template_id)
      ->where('type = ?', 'container')
      ->limit(1);
    $info = $select->query()->fetch();

    if ($info) {
      $container_id = $info['content_id'];
      // Insert content
      $db->insert('engine4_sitenewsletter_content', array(
        'type' => 'widget',
        'name' => 'sitenewsletter.template-header',
        'template_id' => $template_id,
        'parent_content_id' => $container_id,
        'order' => 2,
      ));
    }
  }

  public function placeFooterWidget() {
    $db = $this->getDb();

    // PLACE SCHEMA MARKUP WIDGET
    $select = new Zend_Db_Select($db);
    $select
      ->from('engine4_sitenewsletter_templates')
      ->where('name = ?', 'footer')
      ->limit(1);
    $info = $select->query()->fetch();

    if (empty($info)) 
      return false;

    $template_id = $info['template_id'];
    $select = new Zend_Db_Select($db);
    $select->from('engine4_sitenewsletter_content')
      ->where('name = ?', 'sitenewsletter.template-footer')
      ->where('template_id = ?', $template_id)
      ->where('type = ?', 'widget')
      ->limit(1);
    $info = $select->query()->fetch();

    if (!empty($info)) 
      return false;

    $select = new Zend_Db_Select($db);
    $select
      ->from('engine4_sitenewsletter_content')
      ->where('name = ?', 'main')
      ->where('template_id = ?', $template_id)
      ->where('type = ?', 'container')
      ->limit(1);
    $info = $select->query()->fetch();

    if ($info) {
      $container_id = $info['content_id'];
      // Insert content
      $db->insert('engine4_sitenewsletter_content', array(
        'type' => 'widget',
        'name' => 'sitenewsletter.template-footer',
        'template_id' => $template_id,
        'parent_content_id' => $container_id,
        'order' => 2,
      ));
    }
  }

  public function placeContentWidget($widgetname, $displayname, $fontsize, $fontcolor,  $body_fontsize, $body_fontcolor, $body_bgcolor) {
    $db = $this->getDb();

    // profile page
    $pageId = $db->select()
      ->from('engine4_sitenewsletter_templates', 'template_id')
      ->where('name = ?', $widgetname)
      ->limit(1)
      ->query()
      ->fetchColumn();

    if( !$pageId ) {
      // Insert page
      $db->insert('engine4_sitenewsletter_templates', array(
        'name' => $widgetname,
        'displayname' => $displayname,
        'provides' => 'no-viewer;no-subject',
        'custom' => 0,
      ));
      $pageId = $db->lastInsertId();

      // Insert main
      $db->insert('engine4_sitenewsletter_content', array(
        'type' => 'container',
        'name' => 'main',
        'template_id' => $pageId,
      ));
      $mainId = $db->lastInsertId();

      // Insert middle
      $db->insert('engine4_sitenewsletter_content', array(
        'type' => 'container',
        'name' => 'middle',
        'template_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 2,
      ));
      $middleId = $db->lastInsertId();

      // Insert content
      $db->insert('engine4_sitenewsletter_content', array(
        'type' => 'widget',
        'name' => 'core.content',
        'template_id' => $pageId,
        'parent_content_id' => $middleId,
        'order' => 1,
      ));

      if ($widgetname == 'newsletter_default_template1') {
        // Insert list content widget
        $db->insert('engine4_sitenewsletter_content', array(
          'type' => 'widget',
          'name' => 'sitenewsletter.list-popular-items',
          'template_id' => $pageId,
          'parent_content_id' => $middleId,
          'order' => 2,
          'params' => '{"title":"","itemCount":"3","type":"","popularType":"random","interval":"overall","titleTruncation":"100","nomobile":"0","name":"sitenewsletter.list-popular-items"}',
        ));

        $db->insert('engine4_sitenewsletter_content', array(
          'type' => 'widget',
          'name' => 'core.rich-text-block',
          'template_id' => $pageId,
          'parent_content_id' => $middleId,
          'order' => 3,
          'params' => '{"title":"","adminTitle":"","data":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec justo libero, tristique vel orci eu, aliquet imperdiet dolor. Mauris leo risus, pellentesque at ligula eu, interdum blandit odio.<\/p>","name":"core.rich-text-block","nomobile":"0"}',
        ));

        $db->insert('engine4_sitenewsletter_campaigns', array(
          'subject' => 'Test Campaign A',
          'type' => 'draft',
          'category_id' => '["1"]',
          'template_id' => $pageId,
          'body' => '<div style="width: 100%; margin-top: 10px; padding: 15px 20px; box-sizing: border-box;"><p style="font-family: arial,sans-serif; font-size: 15px; margin-top: 0; line-height: 21px; color: #000;">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam consequat urna ante, ut auctor erat efficitur a. Suspendisse eleifend vestibulum tristique. Nam commodo elementum eros</p><img style="width: 100%;" src="https://karisimbipartners.com/wp-content/uploads/2018/07/company-conference-conference-room-1181435-1.jpg"><div style="padding: 0px 0px 0px;"><p style="font-family: arial,sans-serif; font-size: 15px; margin-top: 15px; line-height: 21px; color: #000;">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam consequat urna ante, ut auctor erat efficitur a. Suspendisse eleifend vestibulum tristique. Nam commodo elementum eros</p></div></div>',
          'target_user' => 'all',
          'status' => 'drafted',
          'creation_date' => 'NOW()',
        ));
      }

      $db->query("INSERT IGNORE INTO `engine4_sitenewsletter_templateslayouts` (`template_id`,  `fontsize`, `fontcolor`,`body_fontsize`, `body_fontcolor`, `body_bgcolor`) VALUES ($pageId,  $fontsize, '$fontcolor',  $body_fontsize, '$body_fontcolor', '$body_bgcolor');");
    }
  }

  protected function _updateCategoriesPage()
  {
    $db = $this->getDb();

    // profile page
    $pageId = $db->select()
      ->from('engine4_core_pages', 'page_id')
      ->where('name = ?', 'sitenewsletter_settings_update-categories')
      ->limit(1)
      ->query()
      ->fetchColumn();

    if( !$pageId ) {

      // Insert page
      $db->insert('engine4_core_pages', array(
        'name' => 'sitenewsletter_settings_update-categories',
        'displayname' => 'Newsletter Update Categories Page',
        'title' => 'Update Categories',
        'description' => 'This page is the newsletter update categories page.',
        'custom' => 0,
      ));
      $pageId = $db->lastInsertId();

      // Insert top
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'top',
        'page_id' => $pageId,
        'order' => 1,
      ));
      $topId = $db->lastInsertId();

      // Insert main
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'main',
        'page_id' => $pageId,
        'order' => 2,
      ));
      $mainId = $db->lastInsertId();

      // Insert top-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $topId,
      ));
      $topMiddleId = $db->lastInsertId();

      // Insert main-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 2,
      ));
      $mainMiddleId = $db->lastInsertId();

      // Insert menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'user.settings-menu',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 1,
      ));

      // Insert content
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'core.content',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 1,
      ));
    }
  }
}
?>
