<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenewsletter
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitenewsletter_Widget_NewsletterSubscribeController extends Engine_Content_Widget_Abstract
{
  public function indexAction()
  {
  	$viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    //GET LEVEL ID
    $level_id = 0;
    if (!empty($viewer_id)) {
      $level_id = $viewer->level_id;
      $subscriptionTable = Engine_Api::_()->getDbtable('subscribers', 'sitenewsletter');
      $type = 'member';
      if( $subscriptionTable->isSubscribed($viewer_id, $type) ) {
        return $this->setNoRender();
      }
    } else {
      $authorizationTable = Engine_Api::_()->getItemTable('authorization_level');
      $authorization = $authorizationTable->fetchRow(array('type = ?' => 'public', 'flag = ?' => 'public'));
      if (!empty($authorization))
        $level_id = $authorization->level_id;
    }


    // If don't allow any member level for subscription
    $allow_subscribe = Engine_Api::_()->authorization()->getPermission($level_id, 'sitenewsletter', 'allow_subscribe');

    if (!$allow_subscribe) {
    	return $this->setNoRender();
    }

    // If test mode is enabled
    if (Engine_Api::_()->getApi('settings', 'core')->getSetting('sitenewsletter.test.mode', '0')) {
      return $this->setNoRender();
    }

    $this->view->viewerEmail = '';
    if( isset($viewer->email) ) {
      $this->view->viewerEmail = $viewer->email;
    }
  }
}