<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenewsletter
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitenewsletter_Widget_TemplateFooterController extends Engine_Content_Widget_Abstract
{
  public function indexAction()
  {
  	$this->view->navigation = $navigation = Engine_Api::_()
      ->getApi('menus', 'core')
      ->getNavigation('newsletter_footer');

    $this->view->logo = $this->getPhotoUrl();

  	$coreSettings = Engine_Api::_()->getApi('settings', 'core');
    $this->view->footer = $coreSettings->getSetting('sitenewsletter.footer.enable', 1);

    $this->view->footerIcon = $coreSettings->getSetting('sitenewsletter.footer.icon', 0);

    $this->view->color = $coreSettings->getSetting('sitenewsletter.footer.color', '#000000');
  	$this->view->bgcolor = $coreSettings->getSetting('sitenewsletter.footer.bgcolor', '#ada5a5');

    $this->view->socialNavigation = $socialNavigation = Engine_Api::_()
      ->getApi('menus', 'core')
      ->getNavigation('core_social_sites');
    $this->view->sociallinks = $coreSettings->getSetting('sitenewsletter.sociallinks.enable', 0);
    
  }

  public function getCacheKey()
  {
    return 'core_social_sites';
  }

  public function getPhotoUrl($type = null)
  {
    $coreSettings = Engine_Api::_()->getApi('settings', 'core');
    $file_id = $coreSettings->getSetting('sitenewsletter.site.logo.icon');
    if( empty($file_id) ) {
      return "no file id";
    }

    $file = Engine_Api::_()->getItemTable('storage_file')->getFile($file_id, $type);
    if( !$file ) {
      return "no file";
    }
    return $file->map();
  }
}