<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitepage
 * @copyright  Copyright 2017-2021 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: ProjectPayments.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */ 

class Sitepage_Plugin_Job_PageNotifications extends Core_Plugin_Job_Abstract {

    protected function _execute() {
        // Get job and params
        $job = $this->getJob();
        set_time_limit(0);
         // Process

        if (!($members = $this->getParam('members'))) {
            $this->_setState('failed', 'No members provided.');
            $this->_setWasIdle();
            return;
        }

        try {
            $subject = Engine_Api::_()->getItem('sitepage_page', $this->getParam('page_id'));
            $owner = $subject->getOwner();
            $viewer = Engine_Api::_()->getItem('user', $this->getParam('viewer_id'));
            $notificationsTable = Engine_Api::_()->getDbtable('notifications', 'activity');
            foreach (($members) as $value) {
                $user_subject = Engine_Api::_()->getItem('user', $value['poster_id']);
                if (!empty($this->getParam('notidicationSettings'))) {
                    $notify_subject = $subject;
                } else {
                    $notify_subject = $viewer;
                }

                $notificationsTable->addNotification($user_subject, $notify_subject, $subject, "sitepage_notificationpost");
            }
            $this->_setIsComplete(true);
        } catch (Exception $e) {
            $this->_setState('failed', 'Exception: ' . $e->getMessage());
        }
    }
}