<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitepageevent
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Upload.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitepageevent_Form_Photo_Upload extends Engine_Form {

  public function init() {
    
    $this
            ->setTitle('Add New Photos')
            ->setDescription('Choose photos on your computer to add to this event. (2MB maximum)')
            ->setAttrib('id', 'form-upload')
            ->setAttrib('class', 'global_form sitepageevent_form_upload')
            ->setAttrib('name', 'albums_create')
            ->setAttrib('enctype', 'multipart/form-data')
            ->setAction(Zend_Controller_Front::getInstance()->getRouter()->assemble(array()));

    $uploadUrl = Zend_Controller_Front::getInstance()->getRouter()->assemble(array()) . '?ul=1';
    $deleteUrl = $this->getView()->url(Array('module' => 'sitepageevent', 'controller' => 'photo', 'action' => 'remove'), 'default');
    $subject = Zend_Controller_Front::getInstance()->getRequest()->getParam('subject');
    $event_id = $subject ? Engine_Api::_()->getItemByGuid($subject)->getIdentity() : 0;
    $vars = array(
        'photoremove' => 1,
        'event_id' => $event_id,
    );
    $this->addElement('SeaoFancyUpload', 'file', array(
        'url' =>  $uploadUrl,
        'deleteUrl' =>  $deleteUrl,
        'accept' => 'image/*',
        'data' => array(
            'vars' => $vars
        )
    ));

    $this->addElement('Button', 'submit', array(
        'label' => 'Save Photos',
        'type' => 'submit',
    ));
  }

}

?>