<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitepagemember
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 2013-03-18 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
?>
<?php
class Sitepagefeature_Installer extends Engine_Package_Installer_Module
{
    function onInstall() {

    //GET DB
        $db = $this->getDb();
    //CHECK THAT SITEPAGE PLUGIN IS ACTIVATED OR NOT
        $select = new Zend_Db_Select($db);
        $select
        ->from('engine4_core_settings')
        ->where('name = ?', 'sitepage.is.active')
        ->limit(1);
        $sitepage_settings = $select->query()->fetchAll();
        if (!empty($sitepage_settings)) {
          $sitepage_is_active = $sitepage_settings[0]['value'];
      } else {
          $sitepage_is_active = 0;
      }

    //CHECK THAT SITEPAGE PLUGIN IS INSTALLED OR NOT
      $modsitepageurl= $db->query("SELECT * FROM  `engine4_core_modules` WHERE  `name` LIKE  'sitepage'")->fetch();
      $minimumversion='4.10.3p29';
      if (!empty($modsitepageurl) && !empty($modsitepageurl['version'])) {
        $isModSupport = $this->checkVersion($modsitepageurl['version'], $minimumversion);
        if (empty($isModSupport)) {
          $check_sitepage_version = 0;
      } else {
          $check_sitepage_version = 1;
      }
  }    

    //CHECK THAT SITEPAGE PLUGIN IS INSTALLED OR NOT
    $select = new Zend_Db_Select($db);
    $select
    ->from('engine4_core_modules')
    ->where('name = ?', 'sitepage')
    ->where('enabled = ?', 1);
    $check_sitepage = $select->query()->fetchObject();
    if (!empty($check_sitepage) && !empty($sitepage_is_active) && !empty($check_sitepage_version)) {
        parent::onInstall();
    }
    if(!empty($check_sitepage) && !empty($sitepage_is_active) && empty($check_sitepage_version)) {

      $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();
      return $this->_error("<span style='color:red'>Note: The version of the Directory / Pages Plugin on your website is less than the minimum required version: ".$minimumversion.". Please download the latest version of this  plugin from your Client Area on SocialEngineAddOns and upgrade it on your website.
</span>");

    }
    elseif (!empty($check_sitepage) && empty($sitepage_is_active)) {
      $baseUrl = $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getBaseUrl();
      $url_string = Zend_Controller_Front::getInstance()->getRequest()->getRequestUri();
      if (strstr($url_string, "manage/install")) {
        $calling_from = 'install';
      } else if (strstr($url_string, "manage/query")) {
        $calling_from = 'queary';
      }
      $explode_base_url = explode("/", $baseUrl);
      foreach ($explode_base_url as $url_key) {
        if ($url_key != 'install') {
          $core_final_url .= $url_key . '/';
        }
      }

      return $this->_error("<span style='color:red'>Note: You have installed the <a href='http://www.socialengineaddons.com/socialengine-directory-pages-plugin' target='_blank'>Directory / Pages Plugin</a> but not activated it on your site yet. Please activate it first before installing the Directory / Pages - Feature Extension.</span><br/> <a href='" . 'http://' . $core_final_url . "admin/sitepage/settings/readme'>Click here</a> to activate the Directory / Pages Plugin.");
    }
    elseif (empty($check_sitepage)) {
      $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();
      return $this->_error("<span style='color:red'>Note: You have not installed the <a href='http://www.socialengineaddons.com/socialengine-directory-pages-plugin' target='_blank'>Directory / Pages Plugin</a> on your site yet. Please install it first before installing the <a href='http://www.socialengineaddons.com/pageextensions/socialengine-directory-pages-feature-extension' target='_blank'>Directory / Pages - Feature Extension</a>.</span><br/> <a href='" . $base_url . "/manage'>Click here</a> to go Manage Packages.");
    }
}

    /*
    if first > second => 1
    if first = second => -1
    if first < second => 0
     */
    private function checkVersion($databaseVersion, $checkDependancyVersion)
    {
        $f = $databaseVersion;
        $s = $checkDependancyVersion;
        if (strcasecmp($f, $s) == 0) {
            return -1;
        }

        $fArr = explode(".", $f);
        $sArr = explode('.', $s);
        if (count($fArr) <= count($sArr)) {
            $count = count($fArr);
        } else {
            $count = count($sArr);
        }

        for ($i = 0; $i < $count; $i++) {
            $fValue = $fArr[$i];
            $sValue = $sArr[$i];
            if (is_numeric($fValue) && is_numeric($sValue)) {
                if ($fValue > $sValue) {
                    return 1;
                } elseif ($fValue < $sValue) {
                    return 0;
                } else {
                    if (($i + 1) == $count) {
                        return -1;
                    } else {
                        continue;
                    }

                }
            } elseif (is_string($fValue) && is_numeric($sValue)) {
                $fsArr = explode("p", $fValue);

                if ($fsArr[0] > $sValue) {
                    return 1;
                } elseif ($fsArr[0] < $sValue) {
                    return 0;
                } else {
                    return 1;
                }
            } elseif (is_numeric($fValue) && is_string($sValue)) {
                $ssArr = explode("p", $sValue);

                if ($fValue > $ssArr[0]) {
                    return 1;
                } elseif ($fValue < $ssArr[0]) {
                    return 0;
                } else {
                    return 0;
                }
            } elseif (is_string($fValue) && is_string($sValue)) {
                $fsArr = explode("p", $fValue);
                $ssArr = explode("p", $sValue);
                if ($fsArr[0] > $ssArr[0]) {
                    return 1;
                } elseif ($fsArr[0] < $ssArr[0]) {
                    return 0;
                } else {
                    if ($fsArr[1] > $ssArr[1]) {
                        return 1;
                    } elseif ($fsArr[1] < $ssArr[1]) {
                        return 0;
                    } else {
                        return -1;
                    }
                }
            }
        }
    }
}