<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitepagetwitter
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminSettingscontroller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitepagetwitter_AdminSettingsController extends Core_Controller_Action_Admin {

  public function indexAction() {
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
            ->getNavigation('sitepagetwitter_admin_main', array(), 'sitepagetwitter_admin_main_settings');

    $this->view->form = $form = new Sitepagetwitter_Form_Admin_Global();
    $description = Zend_Registry::get('Zend_Translate')->_("You can now enable Pages on your website to display their Twitter updates on their profile, thus providing your users an additional tool for increasing engagement on their Pages. Page Admins will be able to enable this and mention their Twitter username from the 'Marketing' section of Page Dashboard. Availability of this functionality to Pages can also be made selective based on Packages.The field below enables you to enter a customized Twitter Profile Widget code based on your requirements, and to match your site's theme.");
    if (Engine_Api::_()->sitepage()->hasPackageEnable()) {
      $upload_url = Zend_Controller_Front::getInstance()->getRouter()->assemble(array('module' => 'sitepage', 'controller' => 'package', 'action' => "index"), 'admin_default', true);
      $description .= sprintf(Zend_Registry::get('Zend_Translate')->_("<div class='tip'><span>Please make sure that you have enabled display of Twitter Updates for Page Packages on your site and placed the Twitter Updates widget on Page Profile from Layout Editor. %1sClick here%2s to enable display of Twitter Updates for Page Packages.</span></div>"), "<a href='$upload_url' target='_blank'>", '</a>');
      $form->setDescription($description);
      $form->getDecorator('Description')->setOption('escape', false);
    } else {
      $form->setDescription($description);
    }

    if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
      $values = $form->getValues();
      $twitter_code = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitepagetwitter.feeds.code');
      if (empty($twitter_code)) {

        $db = Engine_Db_Table::getDefaultAdapter();
        //PUT SITEPAGE TWITTER WIDGET IN ADMIN CONTENT TABLE
        $select = new Zend_Db_Select($db);
        $select_page = $select
                ->from('engine4_core_pages', 'page_id')
                ->where('name = ?', 'sitepage_index_view')
                ->limit(1);
        $page = $select_page->query()->fetchAll();
        if (!empty($page)) {
          $page_id = $page[0]['page_id'];
          $select = new Zend_Db_Select($db);
          $select_content = $select
                  ->from('engine4_sitepage_admincontent')
                  ->where('page_id = ?', $page_id)
                  ->where('type = ?', 'widget')
                  ->where('name = ?', 'sitepagetwitter.feeds-sitepagetwitter')
                  ->limit(1);
          $content = $select_content->query()->fetchAll();
          if (empty($content)) {
            $select = new Zend_Db_Select($db);
            $select_container = $select
                    ->from('engine4_sitepage_admincontent', 'admincontent_id')
                    ->where('page_id = ?', $page_id)
                    ->where('type = ?', 'container')
                    ->limit(1);
            $container = $select_container->query()->fetchAll();
            if (!empty($container)) {
              $container_id = $container[0]['admincontent_id'];
              $select = new Zend_Db_Select($db);
              $select_middle = $select
                      ->from('engine4_sitepage_admincontent')
                      ->where('parent_content_id = ?', $container_id)
                      ->where('type = ?', 'container')
                      ->where('name = ?', 'middle')
                      ->limit(1);
              $middle = $select_middle->query()->fetchAll();
              if (!empty($middle)) {
                $middle_id = $middle[0]['admincontent_id'];
                $select = new Zend_Db_Select($db);
                $select_tab = $select
                        ->from('engine4_sitepage_admincontent')
                        ->where('type = ?', 'widget')
                        ->where('name = ?', 'core.container-tabs')
                        ->where('page_id = ?', $page_id)
                        ->limit(1);
                $tab = $select_tab->query()->fetchAll();
                $tab_id = 0;
                if (!empty($tab)) {
                  $tab_id = $tab[0]['admincontent_id'];
                } else {
                  $tab_id = $middle_id;
                }

                $db->insert('engine4_sitepage_admincontent', array(
                    'page_id' => $page_id,
                    'type' => 'widget',
                    'name' => 'sitepagetwitter.feeds-sitepagetwitter',
                    'parent_content_id' => $tab_id,
                    'order' => 121,
                    'params' => '{"title":“Tweets”,"titleCount":true}',
                ));
              }
            }
          }

          $select = new Zend_Db_Select($db);
          $select_content = $select
                  ->from('engine4_core_content')
                  ->where('page_id = ?', $page_id)
                  ->where('type = ?', 'widget')
                  ->where('name = ?', 'sitepagetwitter.feeds-sitepagetwitter')
                  ->limit(1);
          $content = $select_content->query()->fetchAll();
          if (empty($content)) {
            $select = new Zend_Db_Select($db);
            $select_container = $select
                    ->from('engine4_core_content', 'content_id')
                    ->where('page_id = ?', $page_id)
                    ->where('type = ?', 'container')
                    ->limit(1);
            $container = $select_container->query()->fetchAll();
            if (!empty($container)) {
              $container_id = $container[0]['content_id'];
              $select = new Zend_Db_Select($db);
              $select_middle = $select
                      ->from('engine4_core_content')
                      ->where('parent_content_id = ?', $container_id)
                      ->where('type = ?', 'container')
                      ->where('name = ?', 'middle')
                      ->limit(1);
              $middle = $select_middle->query()->fetchAll();
              if (!empty($middle)) {
                $middle_id = $middle[0]['content_id'];
                $select = new Zend_Db_Select($db);
                $select_tab = $select
                        ->from('engine4_core_content')
                        ->where('type = ?', 'widget')
                        ->where('name = ?', 'core.container-tabs')
                        ->where('page_id = ?', $page_id)
                        ->limit(1);
                $tab = $select_tab->query()->fetchAll();
                $tab_id = 0;
                if (!empty($tab)) {
                  $tab_id = $tab[0]['content_id'];
                } else {
                  $tab_id = $middle_id;
                }

                $db->insert('engine4_core_content', array(
                    'page_id' => $page_id,
                    'type' => 'widget',
                    'name' => 'sitepagetwitter.feeds-sitepagetwitter',
                    'parent_content_id' => $tab_id,
                    'order' => 121,
                    'params' => '{"title":“Tweets”,"titleCount":true}',
                ));
              }
            }
          }

          //PUT SITEPAGE TWITTER WIDGET IN USER CONTENT TABLE
          $select = new Zend_Db_Select($db);
          $select = $select
                  ->from('engine4_sitepage_contentpages', 'contentpage_id');

          $contentpage_ids = $select->query()->fetchAll();
          foreach ($contentpage_ids as $contentpage_id) {
            if (!empty($contentpage_id)) {
              $page_id = $contentpage_id['contentpage_id'];
              $select = new Zend_Db_Select($db);
              $select_content = $select
                      ->from('engine4_sitepage_content')
                      ->where('contentpage_id = ?', $page_id)
                      ->where('type = ?', 'widget')
                      ->where('name = ?', 'sitepagetwitter.feeds-sitepagetwitter')
                      ->limit(1);
              $content = $select_content->query()->fetchAll();
              if (empty($content)) {
                $select = new Zend_Db_Select($db);
                $select_container = $select
                        ->from('engine4_sitepage_content', 'content_id')
                        ->where('contentpage_id = ?', $page_id)
                        ->where('type = ?', 'container')
                        ->limit(1);
                $container = $select_container->query()->fetchAll();
                if (!empty($container)) {
                  $container_id = $container[0]['content_id'];
                  $select = new Zend_Db_Select($db);
                  $select_middle = $select
                          ->from('engine4_sitepage_content')
                          ->where('parent_content_id = ?', $container_id)
                          ->where('type = ?', 'container')
                          ->where('name = ?', 'middle')
                          ->limit(1);
                  $middle = $select_middle->query()->fetchAll();
                  if (!empty($middle)) {
                    $middle_id = $middle[0]['content_id'];
                    $select = new Zend_Db_Select($db);
                    $select_tab = $select
                            ->from('engine4_sitepage_content')
                            ->where('type = ?', 'widget')
                            ->where('name = ?', 'core.container-tabs')
                            ->where('contentpage_id = ?', $page_id)
                            ->limit(1);
                    $tab = $select_tab->query()->fetchAll();
                    if (!empty($tab)) {
                      $tab_id = $tab[0]['content_id'];
                    }
                    $db->insert('engine4_sitepage_content', array(
                        'contentpage_id' => $page_id,
                        'type' => 'widget',
                        'name' => 'sitepagetwitter.feeds-sitepagetwitter',
                        'parent_content_id' => ($tab_id ? $tab_id : $middle_id),
                        'order' => 121,
                        'params' => '{"title":“Tweets”,"titleCount":true}',
                    ));
                  }
                }
              }
            }
          }
        }
      }

      foreach ($values as $key => $value) {
        Engine_Api::_()->getApi('settings', 'core')->setSetting($key, $value);
      }
      $form->addNotice('Your changes have been saved.');
    }
  }

  public function faqAction() {
    //TABS CREATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
            ->getNavigation('sitepagetwitter_admin_main', array(), 'sitepagetwitter_admin_main_faq');


  }

}

?>