<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitepagetwitter
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 2011-11-15 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitepagetwitter_Installer extends Engine_Package_Installer_Module {

  function onInstall() {

    //GET DB
    $db = $this->getDb();
    //CHECK THAT SITEPAGE PLUGIN IS ACTIVATED OR NOT
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_settings')
            ->where('name = ?', 'sitepage.is.active')
            ->limit(1);
    $sitepage_settings = $select->query()->fetchAll();
    if (!empty($sitepage_settings)) {
      $sitepage_is_active = $sitepage_settings[0]['value'];
    } else {
      $sitepage_is_active = 0;
    }

    //CHECK THAT SITEPAGE PLUGIN IS INSTALLED OR NOT
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'sitepage')
            ->where('version >= ?', '4.2.1')
            ->where('enabled = ?', 1);
    $check_sitepage_version = $select->query()->fetchObject();
    if(!empty($check_sitepage_version)) {
      $check_sitepage_version = 1;
    }
    else {
      $check_sitepage_version = 0;
    }

    //CHECK THAT SITEPAGE PLUGIN IS INSTALLED OR NOT
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'sitepage')
            ->where('enabled = ?', 1);
    $check_sitepage = $select->query()->fetchObject();
    if (!empty($check_sitepage) && !empty($sitepage_is_active) && !empty($check_sitepage_version)) {
			//ADD NEW COLUMN IN engine4_sitepage_imports TABLE
			$table_exist = $db->query("SHOW TABLES LIKE 'engine4_sitepage_pages'")->fetch();
			if (!empty($table_exist)) {

				$column_exist = $db->query("SHOW COLUMNS FROM engine4_sitepage_pages LIKE 'twitter_user_name'")->fetch();
				if (empty($column_exist)) {
					$db->query("ALTER TABLE `engine4_sitepage_pages` ADD `twitter_user_name` VARCHAR( 32 ) NOT NULL");
				}
			}

			//ADD NEW COLUMN IN engine4_sitepage_imports TABLE
			$table_exist = $db->query("SHOW TABLES LIKE 'engine4_sitepage_packages'")->fetch();
			if (!empty($table_exist)) {

				$column_exist = $db->query("SHOW COLUMNS FROM engine4_sitepage_packages LIKE 'twitter'")->fetch();
				if (empty($column_exist)) {
					$db->query("ALTER TABLE `engine4_sitepage_packages` ADD `twitter` TINYINT( 1 ) NOT NULL DEFAULT '0'");
				}
			}
			
      parent::onInstall();
    } 
		if(!empty($check_sitepage) && !empty($sitepage_is_active) && empty($check_sitepage_version)) {
			$base_url = Zend_Controller_Front::getInstance()->getBaseUrl();
			return $this->_error("<span style='color:red'>Note: The version of the Directory / Pages Plugin on your website is less than the minimum required version: 4.2.1. Please download the latest version of this  plugin from your Client Area on SocialEngineAddOns and upgrade it on your website.
</span>");
		}
		elseif (!empty($check_sitepage) && empty($sitepage_is_active)) {
		$baseUrl = $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getBaseUrl();
		$url_string = Zend_Controller_Front::getInstance()->getRequest()->getRequestUri();
		if (strstr($url_string, "manage/install")) {
			$calling_from = 'install';
		} else if (strstr($url_string, "manage/query")) {
			$calling_from = 'queary';
		}
		$explode_base_url = explode("/", $baseUrl);
		foreach ($explode_base_url as $url_key) {
			if ($url_key != 'install') {
				$core_final_url .= $url_key . '/';
			}
		}

      return $this->_error("<span style='color:red'>Note: You have installed the Page Plugin but not activated it on your site yet. Please activate it first before installing the Directory / Pages - Twitter Extension.</span><br/> <a href='" . 'http://' . $core_final_url . "admin/sitepage/settings/readme'>Click here</a> to activate the Page Plugin.");
    } elseif(empty($check_sitepage)) {
      $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();
      return $this->_error("<span style='color:red'>Note: You have not installed the Page Plugin on your site yet. Please install it first before installing the Directory / Pages - Twitter Extension.</span><br/> <a href='" . $base_url . "/manage'>Click here</a> to go Manage Packages.");
    }
  }

}

?>