<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitepagewishlist
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Pages.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitepagewishlist_Model_DbTable_Pages extends Engine_Db_Table {

  protected $_rowClass = 'Sitepagewishlist_Model_Page';

	public function wishlistPages($wishlist_id) {

		//RETURN IF WISHLIST ID IS EMPTY
		if(empty($wishlist_id)) {
			return;
		}

		//GET WISHLIST PAGE TABLE NAME
		$wishlistPageTableName = $this->info('name');

		//MAKE QUERY
		$select = $this->select()
									->where('wishlist_id = ?', $wishlist_id);

		//RETURN RESULTS
		return $this->fetchAll($select);
	}

	public function pageWishlists($page_id) {

		//RETURN IF PAGE ID IS EMPTY
		if(empty($page_id)) {
			return;
		}

		//GET WISHLIST PAGE TABLE NAME
		$wishlistPageTableName = $this->info('name');

		//MAKE QUERY
    $select = $this->select()
									->from($wishlistPageTableName, 'wishlist_id')
									->where('page_id = ?', $page_id);

		//RETURN RESULTS
    return $this->fetchAll($select);
	}

  /**
   * Return wishlists count
   *
   * @param int $page_id 
   * @return wishlists count
   * */
	public function wishlistCount($page_id) {

		//ATLEAST ONE WISHLIST SHOULD BE BELONGS TO THAT PAGE FOR WISHLIST DASHBOARD TAB
    $wishlistCount = $this->select()
                    ->from($this->info('name'), array('COUNT(*) AS count'))
                    ->where('page_id = ?', $page_id)
                    ->query()
                    ->fetchColumn();

		if(empty($wishlistCount)) {
			return 0;
		}

		//CHECK WISHLISTS VIEW AUTHORIZATION
		$level_id = Engine_Api::_()->user()->getViewer()->level_id;
    $wishlistCount = Engine_Api::_()->authorization()->getPermission($level_id, 'sitepagewishlist_wishlist', 'view');

		//RETURN WISHLIST COUNT
		return $wishlistCount;
	}

}
?>