<?php

class Sitepoll_Api_Core extends Core_Api_Abstract
{
  /**
   * Get status of poll
   * $params object $poll
   * @return string
   * */
  public function getPollStatus($poll)
  {
    $translate = Zend_Registry::get('Zend_Translate');
    if( !empty($poll->declined) ) {
      return "<span style='color: red;'>" . $translate->translate("Declined") . "</span>";
    }

    if( !empty($poll->approve_date==null) ) {
      return $translate->translate("Approval Pending");
    }
    if( !empty($poll->approved) ) {
      if(!empty($poll->status=='Expired'))
      {
        return $translate->translate("Closed");
      }
      else{
        return $translate->translate("Approved");
      }
    }
    if( empty($poll->approved) ) {
      return $translate->translate("Dis-Approved");
    }

    return "Approved";
  }

  /**
   * Get expiration date of the poll before aproval
   * $params object $poll
   * @return string
   * */
  public function getPollExpire($poll)
  {
    $translate = Zend_Registry::get('Zend_Translate');
    if($poll->draft==0)
    {
      return $translate->translate("1 day after approval");
    }
    if($poll->draft==1)
    {
      return $translate->translate("3 days after approval");
    }
    if($poll->draft==2)
    {
      return $translate->translate("7 days after approval");
    }
    if($poll->draft==3)
    {
      return $translate->translate("2 weeks after approval");
    }
  }

  /**
   * Set truncation limit on the poll 
   * @return string
   * */
  public function truncation($string, $length = null)
  {
    $string = strip_tags($string);
    return $string = Engine_String::strlen($string) > $length ? Engine_String::substr($string, 0, ($length - 3)) . '...' : $string;
  }
}
