<?php

class Sitepoll_Model_DbTable_Categories extends Core_Model_Item_DbTable_Abstract{
    protected $_rowClass = 'Sitepoll_Model_Category';
    
  public function getCategoriesAssoc(){
    $stmt = $this->select()
                 ->from($this, array('category_id', 'category_name', 'cat_order'))
                 ->order('cat_order ASC')
                 ->query();
    $data = array();
    $data[-1]='';
    foreach( $stmt->fetchAll() as $category ) {
      $data[$category['category_id']] = $category['category_name'];
    }
    return $data;
  }

  public function getCategory($category_id) {

    if (empty($category_id)) {
      return;
    }

    if (!array_key_exists($category_id, $this->_categories)) {
      $this->_categories[$category_id] = $this->find($category_id)->current();
    }
    return $this->_categories[$category_id];
  }

  public function getCategorySlug($categoryname){
    $slug = $categoryname;

    return Engine_Api::_()->seaocore()->getSlug($slug, 225);
  }

  public function CheckAllReadyExist($insertname){
      $pollTable = Engine_Api::_()->getItemTable('sitepoll_category');

      return $pollTable->select()
          ->from($this, new Zend_Db_Expr('COUNT(category_id)'))
          ->where('category_name = ?', $insertname)
          ->query()
          ->fetchColumn();
  }

  public function getCategoriesDetails($arrayLevels) {

    $categories = $this->getCategoriesHavingNoChield($arrayLevels);

    $categories_prepared = array();
    foreach ($categories as $category) {
      $categoryArray = array();
      if ($category->cat_dependency == 0 && $category->subcat_dependency == 0) {
        $categoryArray['category_id'] = $category->category_id;
        $categoryArray['categoryname'] = $category->category_name;
      } elseif ($category->cat_dependency != 0 && $category->subcat_dependency == 0) {
        $categoryMain = Engine_Api::_()->getItem('sitepage_category', $category->cat_dependency);
        $categoryArray['category_id'] = $categoryMain->category_id;
        $categoryArray['categoryname'] = $categoryMain->category_name;
      } elseif ($category->cat_dependency != 0 && $category->subcat_dependency != 0) {
        $categorySub = Engine_Api::_()->getItem('sitepage_category', $category->cat_dependency);
        $categoryMain = Engine_Api::_()->getItem('sitepage_category', $categorySub->cat_dependency);
        $categoryArray['category_id'] = $categoryMain->category_id;
        $categoryArray['categoryname'] = $categoryMain->category_name;
      }

      $categories_prepared[$category->category_id] = $categoryArray;
    }

    //RETURN DATA
    return $categories_prepared;
  }

  public function getCategories($home_page_display = 0) {
    $tableCategory = Engine_Api::_()->getDbtable('categories', 'sitepoll');
    $cateName = $tableCategory->info('name');
    $select = $tableCategory->select();
    if (!empty($home_page_display)) {
        $table = Engine_Api::_()->getDbtable('polls', 'sitepoll');
        $rName = $table->info('name');
        $select->setIntegrityCheck(false)
               ->from($cateName)
               ->joinLeft($rName, $rName . '.category_id = ' . $cateName . '.category_id', array('count(' . $rName . '.category_id ) as count'))
               ->group($cateName . '.category_id')
               ->order('cat_order ASC');
        }
        return Zend_Paginator::factory($select);
    }

    /**
   * @param category id
   * @return all categories where category id is not equal to param
   */

  public function getRemainingCategory($category_id){
    $stmt = $this->select()->from($this)
    ->where("category_id != ?",$category_id)->order('cat_order ASC')->query();
    return $stmt->fetchAll();
  }
  
  /**
   * @param category title
   * @return whether title present already or not
   * 
   */
  public function categoryPresent($title){
    $stmt = $this->select()->from($this)
    			 ->where("category_name = ?",$title)->query();
    $result = $stmt->fetch();

    return $result;
  }
}
