<?php

class Sitepoll_Plugin_Menus{

  public function canCreateSitepolls(){

        // Must be logged in
    $viewer = Engine_Api::_()->user()->getViewer();
    if( !$viewer || !$viewer->getIdentity() ) {
      return false;
    }

        // Must be able to create polls
    if( !Engine_Api::_()->authorization()->isAllowed('sitepoll_poll', $viewer, 'create') ) {
      return false;
    }

    if( !Engine_Api::_()->authorization()->isAllowed('sitepoll_poll', $viewer, 'view') ) {
      return false;
    }
    return true;
  }

  public function canMySitepolls() {
    $viewer = Engine_Api::_()->user()->getViewer();
    if( !$viewer || !$viewer->getIdentity() ) {
      return false;
    }
    if( !Engine_Api::_()->authorization()->isAllowed('sitepoll_poll', $viewer, 'view') ) {
      return false;
    }
    return true;
  }

  public function canViewSitepolls(){
    $viewer = Engine_Api::_()->user()->getViewer();

        // Must be able to view polls
    if( !Engine_Api::_()->authorization()->isAllowed('sitepoll_poll', $viewer, 'view') ) {
      return false;
    }

    return true;
  }

  public function onMenuInitialize_SitepollGutterShare($row){

    $viewer = Engine_Api::_()->user()->getViewer();
    if( !$viewer->getIdentity() ) {
      return false;
    }

    if( !Engine_Api::_()->core()->hasSubject() ) {
      return false;
    }

    $subject = Engine_Api::_()->core()->getSubject();
    if( !($subject instanceof Sitepoll_Model_Sitepoll) ) {
      return false;
    }

        // Modify params
    $params = $row->params;
    $params['params']['type'] = $subject->getType();
    $params['params']['id'] = $subject->getIdentity();
    $params['params']['format'] = 'smoothbox';
    return $params;
  }

  public function onMenuInitialize_SitepollGutterReport($row){

    $viewer = Engine_Api::_()->user()->getViewer();
    if( !$viewer->getIdentity() ) {
      return false;
    }

    if( !Engine_Api::_()->core()->hasSubject() ) {
      return false;
    }

    $subject = Engine_Api::_()->core()->getSubject();
    if( ($subject instanceof Sitepoll_Model_Sitepoll) &&
      $subject->owner_id == $viewer->getIdentity() ) {
      return false;
    } else if( $subject instanceof User_Model_User &&
      $subject->getIdentity() == $viewer->getIdentity() ) {
      return false;
    }

    // Modify params
    $subject = Engine_Api::_()->core()->getSubject();
    $params = $row->params;
    $params['params']['subject'] = $subject->getGuid();
    return $params;
  }

  public function onMenuInitialize_SitpollGutterCreate($row){

    $viewer = Engine_Api::_()->user()->getViewer();
    $request = Zend_Controller_Front::getInstance()->getRequest();
    $owner = Engine_Api::_()->getItem('user', $request->getParam('user_id'));

    if( $viewer->getIdentity() != $owner->getIdentity() ) {
      return false;
    }

    if( !Engine_Api::_()->authorization()->isAllowed('sitepoll_poll', $viewer, 'create') ) {
      return false;
    }

    return true;
  }

  public function onMenuInitialize_SitepollGutterEdit($row){

    if( !Engine_Api::_()->core()->hasSubject() ) {
      return false;
    }

    $viewer = Engine_Api::_()->user()->getViewer();
    $poll = Engine_Api::_()->core()->getSubject('sitepoll_poll');

    if( !$poll->authorization()->isAllowed($viewer, 'edit') ) {
      return false;
    }

      // Modify params
    $params = $row->params;
    $params['params']['poll_id'] = $poll->getIdentity();
    return $params;
  }

  public function onMenuInitialize_SitepollGutterDelete($row){

    if( !Engine_Api::_()->core()->hasSubject() ) {
      return false;
    }

    $viewer = Engine_Api::_()->user()->getViewer();
    $poll = Engine_Api::_()->core()->getSubject('sitepoll_poll');

    if( !$poll->authorization()->isAllowed($viewer, 'delete') ) {
      return false;
    }

      // Modify params
    $params = $row->params;
    $params['params']['poll_id'] = $poll->getIdentity();
    return $params;
  }
}
