<?php
/**
* SocialEngine
*
* @category Application_Extensions
* @package Sitepoll
* @copyright Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
* @license http://www.socialengineaddons.com/license/
* @version 2019-08-10 9:40:21Z SocialEngineAddOns $
* @author SocialEngineAddOns
*/
class Sitepoll_AdminImportpollController extends Core_Controller_Action_Admin 
{
    //ACTION FOR SHOWING IMPORT INSTRUCTIONS
    public function indexAction() {
        //INCREASE THE MEMORY ALLOCATION SIZE AND INFINITE SET TIME OUT
        ini_set('memory_limit', '2048M');
        set_time_limit(0);
        ini_set('upload_max_filesize', '100M');
        ini_set('post_max_size', '100M');
        ini_set('max_input_time', 600);
        ini_set('max_execution_time', 600);
        $coreModuleTable = Engine_Api::_()->getDbtable('modules', 'core');

        include APPLICATION_PATH . '/application/modules/Sitepoll/controllers/license/license.php';

        //GET NAVIGATION
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
        ->getNavigation('sitepoll_admin_main', array(), 'sitepoll_admin_main_import');

        //START CODE FOR CREATING THE POLLToReviewImport.log FILE
        if (!file_exists(APPLICATION_PATH . '/temporary/log/Import_Polls_To_Ultimate_Polls.log')) {
            $log = new Zend_Log();
            try {
                $log->addWriter(new Zend_Log_Writer_Stream(APPLICATION_PATH . '/temporary/log/Import_Polls_To_Ultimate_Polls.log'));
            } catch (Exception $e) {
                //CHECK DIRECTORY
                if (!@is_dir(APPLICATION_PATH . '/temporary/log') && @mkdir(APPLICATION_PATH . '/temporary/log', 0777, true)) {
                    $log->addWriter(new Zend_Log_Writer_Stream(APPLICATION_PATH . '/temporary/log/Import_Polls_To_Ultimate_Polls.log'));
                } else {
                    //Silence ...
                    if (APPLICATION_ENV !== 'production') {
                        $log->log($e->__toString(), Zend_Log::CRIT);
                    } else {
                        //MAKE SURE LOGGING DOESN'T CAUSE EXCEPTIONS
                        $log->addWriter(new Zend_Log_Writer_Null());
                    }
                }
            }
        }

        //GIVE WRITE PERMISSION IF FILE EXIST
        if (file_exists(APPLICATION_PATH . '/temporary/log/Import_Polls_To_Ultimate_Polls.log')) {
            @chmod(APPLICATION_PATH . '/temporary/log/Import_Polls_To_Ultimate_Polls.log', 0777);
        }
        //END CODE FOR CREATING THE Import_Polls_To_Ultimate_Polls.log FILE 
        
        //IMPORT ALL THE CORE POLLS IN SITEPOLL PLUGIN
        //GET SITEPOLL TABLE
        $sitepollTable = Engine_Api::_()->getDbTable('polls', 'sitepoll');
        $sitepollTableName = $sitepollTable->info('name');

        //GET POLL STREAM  TABLE
        $streamTable = Engine_Api::_()->getDbTable('stream', 'activity');

        //GET POLL CONVERSATION  TABLE
        $conversationTable = Engine_Api::_()->getDbtable('conversations', 'messages');

        //GET POLL ATTACHMENT  TABLE
        $attachmentsTable = Engine_Api::_()->getDbtable('attachments', 'activity');
        $attachmentsTableName = $attachmentsTable->info('name');

        //GET SITEPOLL OPTION TABLE
        $sitepollOptionTable = Engine_Api::_()->getDbtable('options', 'sitepoll');
        $sitepollOptionTableName= $sitepollOptionTable->info('name');

        //GET SITEPOLL VOTE TABLE
        $sitepollVoteTable =Engine_Api::_()->getDbtable('votes', 'sitepoll');
        $sitepollVoteTableName=$sitepollVoteTable->info('name');

        //GET SITEPOLL REPORT TABLE
        $sitepollReportTable=Engine_Api::_()->getDbtable('reports', 'sitepoll');
        $sitepollReportTableName=$sitepollReportTable->info('name');

        //GET STORAGE TABLE
        $storageTable = Engine_Api::_()->getDbtable('files', 'storage');

        //GET CORE LIKE TABLES
        $likeTable = Engine_Api::_()->getDbtable('likes', 'core');
        $likeTableName = $likeTable->info('name');

        //GET CORE COMMENT TABLES
        $commentTable = Engine_Api::_()->getDbtable('comments', 'core');
        $commentTableName = $commentTable->info('name');

        //GET TAGMAPS TABLE
        $tagmapsTable = Engine_Api::_()->getDbtable('TagMaps', 'core');
        $tagmapsTableName = $tagmapsTable->info('name');

        //GET STYLE TABLES
        $stylesTable = Engine_Api::_()->getDbtable('styles', 'core');
        $stylesTableName = $stylesTable->info('name');

        //GET ACTIONS TABLE
        $actionsTable = Engine_Api::_()->getDbtable('actions', 'activity');
        $actionsTableName = $actionsTable->info('name');
        //$organizersTable = Engine_Api::_()->getDbtable('organizers', 'siteevent');

        $this->view->first_poll_id = $first_poll_id = 0;
        $this->view->last_poll_id = $last_poll_id = 0;

        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('poll')) 
        {
            //GET POLL TABLES 
            $pollTable = Engine_Api::_()->getDbTable('polls', 'poll');
            $pollTableName = $pollTable->info('name');

            //GET POLL OPTIONS TABLE
            $pollOptionTable=Engine_Api::_()->getDbtable('options', 'poll');
            $pollOptionTableName=$pollOptionTable->info('name');

            //GET POLL VOTES TABLE
            $pollVoteTable=Engine_Api::_()->getDbtable('votes', 'poll');
            $pollVoteTableName=$pollVoteTable->info('name');

            //ADD NEW COLUMN IN POLL TABLE
            $db = Engine_Db_Table::getDefaultAdapter();
            $is_poll_import = $db->query("SHOW COLUMNS FROM engine4_poll_polls LIKE 'is_poll_import'")->fetch();
            if (empty($is_poll_import)) {
                $run_query = $db->query("ALTER TABLE `engine4_poll_polls` ADD is_poll_import TINYINT( 2 ) NOT NULL DEFAULT '0'");
            }

            //START IF IMPORTING IS BREAKED BY SOME REASON
            $selectPolls = $pollTable->select()
                                     ->from($pollTableName, 'poll_id')
                                     ->where('is_poll_import != ?', 1)
                                     ->order('poll_id ASC');

            $pollDatas = $pollTable->fetchAll($selectPolls);

            $this->view->repeatTypePolls = 0;
            if (!empty($pollDatas)) {
                $flag_first_poll_id = 1;

                foreach ($pollDatas as $pollData) {
                    if ($flag_first_poll_id == 1) {
                        $this->view->first_poll_id = $first_poll_id = $pollData->poll_id;
                    }
                    $flag_first_poll_id++;
                    $this->view->last_poll_id = $last_poll_id = $pollData->poll_id;
                }

                if (isset($_GET['poll_assigned_previous_id'])) 
                {
                    $this->view->poll_assigned_previous_id = $poll_assigned_previous_id = $_GET['poll_assigned_previous_id'];
                } else {
                    $this->view->poll_assigned_previous_id = $poll_assigned_previous_id = $first_poll_id;
                }
            }
            
            //START IMPORTING IF REQUESTED
            if (isset($_GET['start_import']) && $_GET['start_import'] == 1 && $_GET['module'] == 'poll') {

                //ACTIVITY FEED IMPORT
                $activity_poll = $this->_getParam('activity_poll');

                //START POLL IMPORTING
                $selectPolls = $pollTable->select()
                                         ->where('poll_id >= ?', $poll_assigned_previous_id)
                                         ->from($pollTableName, 'poll_id')
                                         ->where('is_poll_import != ?', 1)
                                         ->order('poll_id ASC');
                $pollDatas = $pollTable->fetchAll($selectPolls);
                $pollDatasToArray = $pollDatas->toArray();
                $selectAllPolls = $pollTable->select()
                                            ->where('poll_id >= ?', $poll_assigned_previous_id)
                                            ->from($pollTableName)
                                            ->where('is_poll_import != ?', 1)
                                            ->order('poll_id ASC');
                $pollAllDatas = $pollTable->fetchAll($selectAllPolls);
                $AllpollDatasToArray = $pollAllDatas->toArray();
                $next_import_count = 0;
                if (!empty($pollDatasToArray)) {
                    foreach ($pollDatas as $pollData) {
                        $poll_id = $pollData->poll_id;
                        $pollOptionSelect = $pollOptionTable->fetchAll(array('poll_id=?'=>$poll_id));

                        $pollVoteSelect = $pollVoteTable->fetchAll(array('poll_id=?'=>$poll_id));
                        $db = Engine_Db_Table::getDefaultAdapter();
                        $db->beginTransaction();
                        try {
                            if (!empty($poll_id)) {
                                $poll = Engine_Api::_()->getItem('poll', $poll_id);
                                $sitepoll = $sitepollTable->createRow();
                                $sitepoll->title = $poll->title;
                                $sitepoll->description = $poll->description;
                                $sitepoll->user_id = $poll->user_id;
                                $sitepoll->parent_type = $poll->parent_type;
                                $sitepoll->parent_id = $poll->parent_id;

                                //END FETCH LIST CATEGORY AND SUB-CATEGORY
                                $sitepoll->creation_date = $poll->creation_date;
                                $sitepoll->modified_date = $poll->creation_date;
                                $sitepoll->view_count = 1;
                                if ($poll->view_count > 0) {
                                    $sitepoll->view_count = $poll->view_count;
                                }
                                $sitepoll->search = $poll->search;
                                $sitepoll->is_closed=$poll->closed;
                                $sitepoll->comment_count=$poll->comment_count;
                                $sitepoll->like_count=$poll->like_count;
                                $sitepoll->vote_count=$poll->vote_count;
                                $sitepoll->approved = 1;
                                $sitepoll->featured = 0;
                                $sitepoll->sponsored = 0;
                                $sitepoll->auth_type=0;
                                $sitepoll->auth_style='pie chart';
                                $sitepoll->auth_type_name='Text';
                                $sitepoll->category_id=10;
                                $sitepoll->draft=3;

                                if($poll->closed==1) {
                                    $sitepoll->approve_date = $poll->creation_date;
                                    $sitepoll->start_datetime= $poll->creation_date;
                                    $sitepoll->end_datetime=date('Y-m-d H:i:s');
                                    $sitepoll->status='Expire';
                                }else {
                                    $sitepoll->end_datetime=date('Y-m-d H:i:s', strtotime("+14 day"));
                                    $sitepoll->status='Active';
                                    $sitepoll->approve_date = $poll->creation_date;
                                    $sitepoll->start_datetime= $poll->creation_date;
                                }
                                if (!empty($poll->photo_id)) {
                                    $pollPhotoData = $poll->photo_id;
                                    if (!empty($pollPhotoData)) {
                                                $storageData = $storageTable->fetchRow(array('file_id = ?' => $pollPhotoData));
                                        if (!empty($storageData) && !empty($storageData->storage_path)){
                                                    if (is_string($storageData->storage_path) && file_exists($storageData->storage_path))
                                                        $sitepoll->setPhoto($storageData->storage_path);
                                        }
                                    }
                                }
                                $sitepoll->save();

                                $poll->is_poll_import = 1;
                                $poll->save();

                                $values = array();

                                //START FETCH PRIVACY
                                $auth = Engine_Api::_()->authorization()->context;
                                
                                //START VIEW PRIVACY
                                $rolespolls = array('owner', 'member', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
                                foreach ($rolespolls as $rolespoll) {
                                    if ($auth->isAllowed($poll, $rolespoll, 'view')) {
                                        $values['auth_view'] = $rolespoll;
                                    }
                                }
                                $viewMax = array_search($values['auth_view'], $rolespolls);
                                $rolesSitepolls = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
                                foreach ($rolesSitepolls as $i => $rolesSitepoll) {
                                    if ($rolesSitepoll === 'everyone') {
                                        $rolesSitepoll = 'everyone';
                                    }
                                    $auth->setAllowed($sitepoll, $rolesSitepoll, 'view', ($i <= $viewMax));
                                }
                                //END VIEW PRIVACY
                                //START COMMENT PRIVACY
                                $rolespolls = array('owner', 'member', 'owner_member', 'owner_member_member', 'owner_network', 'registered');
                                foreach ($rolespolls as $rolespoll) {
                                    if ($auth->isAllowed($poll, $rolespoll, 'comment')) {
                                        $values['auth_comment'] = $rolespoll;
                                    }
                                }
                                $commentMax = array_search($values['auth_comment'], $rolespolls);
                                $rolesSitepolls = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
                                foreach ($rolesSitepolls as $i => $rolesSitepoll) {
                                    if ($rolesSitepoll === 'everyone') {
                                        $rolesSitepoll = 'everyone';
                                    }
                                    $auth->setAllowed($sitepoll, $rolesSitepoll, 'comment', ($i <= $commentMax));
                                }

                                // END OF COMMENT PRIVACY
                                //START POST PRIVACY
                                if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('advancedactivity')) {
                                    $rolesSitepolls = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
                                    $postMax = array_search("member", $rolesSitepolls);
                                    foreach ($rolesSitepolls as $i => $rolesSitepoll) {
                                        if ($rolesSitepoll === 'everyone') {
                                            $rolesSiteevent = 'everyone';
                                        }
                                        $auth->setAllowed($sitepoll, $rolesSitepoll, 'post', ($i <= $postMax));
                                    }
                                }
    							//END POST PRIVACY

                                $auth->setAllowed($sitepoll, $poll->user_id, 'edit', 1);
                                $auth->setAllowed($sitepoll, $poll->user_id, 'delete', 1);

                                //GENERATE ACITIVITY FEED
                                if ($activity_poll) {
                                    //START FETCH ACTIONS
                                    $selectActionId = $actionsTable->select()
                                                                   ->from($actionsTableName, 'action_id')
                                                                   ->where('object_type = ?', 'poll')
                                                                   ->where('object_id = ?', $poll_id)
                                                                   ->where('type =?', 'poll_new')
                                                                   ->query()
                                                                   ->fetchColumn();
                                    if ($selectActionId) {
                                        $action = Engine_Api::_()->getItem('activity_action', $selectActionId);
                                        $action->type = 'sitepoll_new';
                                        $action->object_id = $sitepoll->getIdentity();
                                        $action->object_type = $sitepoll->getType();
                                        $action->save();
                                        $actionsTable->resetActivityBindings($action);
                                    }
                                    //END FETCH ACTIONS
                                    //START FETCH ACTIONS
                                    $selectActionId = $actionsTable->select()
                                                                ->from($actionsTableName, 'action_id')
                                                                ->where('object_type = ?', 'poll')
                                                                ->where('object_id = ?', $poll_id)
                                                                ->where('type =?', 'post');
                                    $selectActionIds = $actionsTable->fetchAll($selectActionId);
                                    if ($selectActionIds) {
                                        foreach ($selectActionIds as $selectActionId) {
                                            $action = Engine_Api::_()->getItem('activity_action', $selectActionId['action_id']);
                                            $action->type = 'sitepoll_post';
                                            $action->object_id = $sitepoll->getIdentity();
                                            $action->object_type = $sitepoll->getType();
                                            $action->save();
                                            $actionsTable->resetActivityBindings($action);
                                        }
                                    }
                                    //END FETCH ACTIONS
                                    //START FETCH ACTIONS
                                    $selectActionId = $actionsTable->select()
                                                                   ->from($actionsTableName, 'action_id')
                                                                   ->where('object_type = ?', 'poll')
                                                                   ->where('object_id = ?', $poll_id)
                                                                   ->where('type =?', 'sitetagcheckin_post');
                                    $selectActionIds = $actionsTable->fetchAll($selectActionId);
                                    if ($selectActionIds) {
                                        foreach ($selectActionIds as $selectActionId) {
                                            $action = Engine_Api::_()->getItem('activity_action', $selectActionId['action_id']);
                                            $action->type = 'sitetagcheckin_post';
                                            $action->object_id = $sitepoll->getIdentity();
                                            $action->object_type = $sitepoll->getType();
                                            $action->save();
                                            $actionsTable->resetActivityBindings($action);
                                        }
                                    }
                                    //END FETCH ACTIONS
                                    //START FETCH ACTIONS
                                    $selectActionId = $actionsTable->select()
                                                                   ->from($actionsTableName, 'action_id')
                                                                   ->where('object_type = ?', 'poll')
                                                                   ->where('object_id = ?', $poll_id)
                                                                   ->where('type =?', 'like_poll');
                                    $selectActionIds = $actionsTable->fetchAll($selectActionId);
                                    if ($selectActionIds) {
                                        foreach ($selectActionIds as $selectActionId) {
                                            $action = Engine_Api::_()->getItem('activity_action', $selectActionId['action_id']);
                                            $action->type = 'like_sitepoll_poll';
                                            $action->object_id = $sitepoll->getIdentity();
                                            $action->object_type = $sitepoll->getType();
                                            $action->save();
                                            $actionsTable->resetActivityBindings($action);
                                        }
                                    }
                                        //END FETCH ACTIONS
                                        //UPDATE POLL TYPE 
                                    $attachmentsTable->update(array('type' => $sitepoll->getType(), 'id' => $sitepoll->getIdentity()), array('type = ?' => 'poll', 'id =?' => $poll_id));

                                    $conversationTable->update(array('resource_type' => $sitepoll->getType(), 'resource_id' => $sitepoll->getIdentity()), array('resource_type = ?' => 'poll', 'resource_id =?' => $poll_id));
                                }

                                //START FETCH LIKES
                                $selectLike = $likeTable->select()
                                                        ->from($likeTableName, 'like_id')
                                                        ->where('resource_type = ?', 'poll')
                                                        ->where('resource_id = ?', $poll_id);
                                $selectLikeDatas = $likeTable->fetchAll($selectLike);
                                foreach ($selectLikeDatas as $selectLikeData) {
                                    $like = Engine_Api::_()->getItem('core_like', $selectLikeData->like_id);
                                    $newLikeEntry = $likeTable->createRow();
                                    $newLikeEntry->resource_type = 'sitepoll_poll';
                                    $newLikeEntry->resource_id = $sitepoll->getIdentity();
                                    $newLikeEntry->poster_type = 'user';
                                    $newLikeEntry->poster_id = $like->poster_id;
                                    $newLikeEntry->creation_date = $like->creation_date;
                                    $newLikeEntry->save();
                                }
                                //END FETCH LIKES

                                // DATA ENTRY IN OPTION TABLE
                                $data=$pollOptionSelect->toArray();
                                $options_id=array();
                                $old_option_id=array();
                                $new_option_id=array();
                                if(!empty($data)) {
                                    foreach($data as $optiondata) {
                                        $option = $sitepollOptionTable->createRow();
                                        $option->poll_id=$sitepoll->poll_id;
                                        $option->poll_option= $optiondata['poll_option'];
                                        $option->votes=$optiondata['votes'];
                                        $option->save();
                                        $old_option_id[]=$optiondata['poll_option_id'];
                                        $options_id[]=$option->option_id;
                                    }

                                    foreach($options_id as $key=>$option_id) {
                                        $new_option_id[$old_option_id[$key]]=$option_id;  
                                    }
                                }
                                // END OF DATA ENTRY IN OPTION TABLE

                                //DATA ENTRY IN VOTES TABLE
                                $votesDatas=$pollVoteSelect->toArray();
                                if(!empty($votesDatas)) { 
                                    foreach($votesDatas as $voteData) {
                                        $vote = $sitepollVoteTable->createRow();
                                        $vote->poll_id=$sitepoll->poll_id;
                                        $vote->user_id=$voteData['user_id'];
                                        $vote->option_id=$new_option_id[$voteData['poll_option_id']];
                                        $vote->creation_date=$voteData['creation_date'];
                                        $vote->modified_date=$voteData['modified_date'];
                                        $vote->save();
                                    }
                                }
                                // END OF DATA ENTRY IN VOTE TABLE

                                //START STYLES
                                $selectStyles = $stylesTable->select()
                                                            ->from($stylesTableName, 'style')
                                                            ->where('type = ?', 'poll')
                                                            ->where('id = ?', $poll_id);
                                $selectStyleDatas = $stylesTable->fetchRow($selectStyles);
                                if (!empty($selectStyleDatas)) {
                                    $selectSitepollStyles = $stylesTable->select()
                                                                        ->from($stylesTableName, 'style')
                                                                        ->where('type = ?', 'sitepoll_poll')
                                                                        ->where('id = ?', $sitepoll->getIdentity());
                                    $selectSitepollStyleDatas = $stylesTable->fetchRow($selectSitepollStyles);
                                    if (empty($selectSitepollStyleDatas)) {
                                            //CREATE
                                        $stylesTable->insert(array(
                                            'type' => 'sitepoll_poll',
                                            'id' => $sitepoll->getIdentity(),
                                            'style' => $selectStyleDatas->style
                                        ));
                                    }
                                }
                                    //END STYLES
                                    //START UPDATE TOTAL LIKES IN SITEPOLL TABLE
                                $selectLikeCount = $likeTable->select()
                                            ->from($likeTableName, array('COUNT(*) AS like_count'))
                                            ->where('resource_type = ?', 'poll')
                                            ->where('resource_id = ?', $poll_id);
                                $selectLikeCounts = $likeTable->fetchAll($selectLikeCount);
                                if (!empty($selectLikeCounts)) {
                                    $selectLikeCounts = $selectLikeCounts->toArray();
                                    $sitepoll->like_count = $selectLikeCounts[0]['like_count'];
                                    $sitepoll->save();
                                }
                                    //END UPDATE TOTAL LIKES IN SITEPOLL TABLES

                                if ($activity_poll) {
                                    $selectActionId = $actionsTable->select()
                                                                    ->from($actionsTableName, 'action_id')
                                                                    ->where('object_type = ?', 'poll')
                                                                    ->where('object_id = ?', $poll_id)
                                                                    ->where('type =?', 'poll_photo_upload')
                                                                    ->query()
                                                                    ->fetchColumn();
                                    if ($selectActionId) {
                                        $action = Engine_Api::_()->getItem('activity_action', $selectActionId);
                                        $action->type = 'sitepoll_photo_upload';
                                        $action->object_id = $sitepoll->getIdentity();
                                        $action->object_type = $sitepoll->getType();
                                        $action->params = array_merge($action->params, array('title' => $sitepoll->getTitle()));
                                        $action->save();
                                        $actionsTable->resetActivityBindings($action);
                                    }
                                }
                            }

                                //CREATE LOG ENTRY IN LOG FILE
                            if (file_exists(APPLICATION_PATH . '/temporary/log/Import_Polls_To_Ultimate_Polls.log')) {
                                $myFile = APPLICATION_PATH . '/temporary/log/Import_Polls_To_Ultimate_Polls.log';
                                $error = Zend_Registry::get('Zend_Translate')->_("can't open file");
                                $fh = fopen($myFile, 'a') or die($error);
                                $current_time = date('D, d M Y H:i:s T');
                                $sitepoll_title = $sitepoll->title;
                                $stringData = $this->view->translate('Poll with ID ') . $poll_id . $this->view->translate(' is successfully imported into a Advanced Poll with ID ') . $sitepoll->poll_id . $this->view->translate(' at ') . $current_time . $this->view->translate(". Title of that Poll is '") . $sitepoll_title . "'.\n\n";
                                fwrite($fh, $stringData);
                                fclose($fh);
                            }

                            $db->commit();
                            $this->view->poll_assigned_previous_id = $poll_id;
                        } catch (Exception $e) {
                            $db->rollback();
                            throw($e);
                        }
                        if ($next_import_count >= 100) {
                            $this->_redirect("admin/sitepoll/importpoll/index?start_import=1&module=poll&recall=1&activity_poll=$activity_poll");
                        }
                    }
                } else {
                    if ($_GET['recall']) {
                        echo json_encode(array('success' => 1));
                        exit();
                    }
                }
        }
    } 

}

    public function importDocuments($poll, $sitepoll, $activity_poll = 0) {

        $db = Engine_Db_Table::getDefaultAdapter();
            //GET ACTIONS TABLE
        $actionsTable = Engine_Api::_()->getDbtable('actions', 'activity');
        $actionsTableName = $actionsTable->info('name');
            //GET EVENT ATTACHMENT  TABLE
        $attachmentsTable = Engine_Api::_()->getDbtable('attachments', 'activity');
        $attachmentsTableName = $attachmentsTable->info('name');
            //GET STORAGE TABLE
        $storageTable = Engine_Api::_()->getDbtable('files', 'storage');
        $storageTableName = $storageTable->info('name');
    }
}




