<?php
/**
* SocialEngine
*
* @category Application_Extensions
* @package Sitepoll
* @copyright Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
* @license http://www.socialengineaddons.com/license/
* @version 2019-08-10 9:40:21Z SocialEngineAddOns $
* @author SocialEngineAddOns
*/
class Sitepoll_ReportController extends Core_Controller_Action_Standard 
{
  public function createAction() {

    $subject = null;

      //GET THE VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
    $subject_guid = $this->_getParam('subject', null);
    $explode=explode('_', $subject_guid);
    if ($subject_guid) {
      $subject = Engine_Api::_()->getItemByGuid($subject_guid);
    }

    $this->view->form = $form = new Sitepoll_Form_Report();
    $form->populate($this->_getAllParams());

    if (!$this->getRequest()->isPost()) {
      return;
    }
    if (!$form->isValid($this->getRequest()->getPost())) {
      return;
    }


      // PROCESS
    $table = Engine_Api::_()->getItemTable('sitepoll_report');
    $db = $table->getAdapter();
    $db->beginTransaction();

    $poll = Engine_Api::_()->getItem('sitepoll_poll', $explode[2]);
    try {
      $values = $form->getValues();
      $report = $table->createRow();
      $report->setFromArray(array_merge($form->getValues(), array(
        'reason'=>$values['category'],
        'poll_title'=>$poll['title'],
        'poll_id' => $subject->getIdentity(),
        'user_id' => $viewer->getIdentity(),
      )));
      $report->save();
      $db->commit();
    } catch (Exception $e) {
      $db->rollBack();
      throw $e;
    }

      // CLOSE SMOTTHBOX
    $currentContext = $this->_helper->contextSwitch->getCurrentContext();
    if( null === $currentContext ) {
      return $this->_helper->redirector->gotoRoute(array(), 'default', true);
    } else if( 'smoothbox' === $currentContext ) {
      return $this->_forward('success', 'utility', 'core', array(
        'messages' => $this->view->translate('Your report has been submitted.'),
        'smoothboxClose' => true,
        'parentRefresh' => false,
      ));
    }
  }
}
