<?php

$categories = Engine_Api::_()->getDbTable('categories', 'sitepoll')->getCategoriesAssoc();
return array(
    array(
        'title' => 'Navigation Tabs',
        'description' => 'This widget displays the navigation tabs for ‘Ultimate Polls Plugin’ having links of browse polls, my polls, create new polls.',
        'category' => 'Ultimate Polls Plugin',
        'type' => 'widget',
        'name' => 'sitepoll.browse-menu',
        'requirements' => array(
          'no-subject',
      ),
    ),
    array(
    'title' => 'Poll Profile: Breadcrumb',
    'description' => 'Displays breadcrumb of the poll based on the categories. This widget should be placed on the Ultimate Polls - Poll View page.',
    'category' => 'Ultimate Polls Plugin',
    'type' => 'widget',
    'name' => 'sitepoll.poll-profile-breadcrumb',
    'requirements' => array(
          'no-subject',
    ),
  ),
    array(
        'title' => 'Poll Owner’s Photo',
        'description' => 'Display a profile photo of poll owner on the poll view page',
        'category' => 'Ultimate Polls Plugin',
        'type' => 'widget',
        'name' => 'sitepoll.poll-owner-photo',
        'requirements' => array(
          'no-subject',
      ),
    ),
    array(
        'title' => 'Create New Poll',
        'description' => 'Displays a button ‘Create New Poll’ to create a poll on your website.',
        'category' => 'Ultimate Polls Plugin',
        'type' => 'widget',
        'name' => 'sitepoll.browse-menu-quick',
        'requirements' => array(
          'no-subject',
      ),
    ),
    array(
        'title' => 'Search Polls form',
        'description' => 'Displays the form for searching Polls on the basis of various fields & filters.',
        'category' => 'Ultimate Polls Plugin',
        'type' => 'widget',
        'name' => 'sitepoll.browse-search',
        'requirements' => array(
          'no-subject',
      ),
        'adminForm' => array(
          'elements' => array(
            array(
              'Radio',
              'recentType',
              array(
                'label' => 'Show Search Form',
                'multiOptions' => array(
                  'horizontal' => 'Horizontal',
                  'vertical' => 'Vertical',
              ),
                'value' => 'vertical',
            )
          ),
        )
      ),
    ),
    array(
        'title' => 'Category Navigation Bar',
        'description' => 'Display categories in this block. You can configure various settings from this widget from the edit settings.',
        'category' => 'Ultimate Polls Plugin',
        'type' => 'widget',
        'name' => 'sitepoll.categories-polls',
        'defaultParams' => array(
            'title' => 'Categories',
            'titleCount' => true,
        ),
    ),
    array(
    'title' => 'Trending Polls',
    'description' => 'Displays Trending Polls based on the criteria of most voted, most viewed, featured, sponsored, etc. In this block, you can configure various settings from the edit section of this widget.',
    'category' => 'Ultimate Polls Plugin',
    'type' => 'widget',
    'name' => 'sitepoll.trending-sitepoll',
    'defaultParams' => array(
      'itemCount' => 3,
      'sitepoll_item' => array('owner','host','date','like','vote'),
      'columnHeight' => 328,
      'show_sitepoll' => 'featured',
      'sort_sitepoll' => 'vote_count',
    ),
    'adminForm' => array(
      'elements' => array(
        array(
            'Text',
            'itemCount',
            array(
                'label' => 'Count',
                'description' => '(number of polls to show)',
                'value' => 3,
                'validators' => array(
                    array('Int', true),
                    array('GreaterThan', true, array(0)),
                ),
            ),
        ),
        array(
            'MultiCheckbox',
            'sitepoll_item',
            array(
                'label' => 'Choose the options that you want to display for the Polls in this widget.',
                'multiOptions' => array(
                    'owner' => 'Poll Photo',
                    'host' => 'Posted By',
                    'date' => 'Creation Date',
                    'category' =>'Category',
                    'views' =>'Views',
                    'comment' => 'Comments',
                    'like' => 'Likes',
                    'vote' =>'Votes'
                ),
            )
        ),
        array(
            'Text',
            'columnHeight',
            array(
                'label' => 'Column Height',
                'value' => '328',
                'validators' => array(
                    array('Int', true),
                    array('GreaterThan', true, array(0)),
                ),
            )
        ),
        array(
            'Select',
            'show_sitepoll',
            array(
              'label' => 'Show Polls',
              'multiOptions' => array(
                "featured"=>"Featured Only",
                "sponsored"=>"Sponsored Only"),
            ),
        ),
        array(
            'Select',
            'sort_sitepoll',
            array(
              'label' => 'Trending Poll Criteria',
              'multiOptions' => array(
                "like_count"=>"Most Liked",
                "comment_count"=>"Most Commented",
                "creation_date"=>"Recently created",
                "view_count"=>"Most Viewed",
                "vote_count"=>"Most Voted"),
            ),
        ),
      ),
    ),
  ),
    array(
        'title' => 'Ultimate Polls: Profile Polls',
        'description' => 'Displays a member\'s polls on their profile.',
        'category' => 'Ultimate Polls Plugin',
        'type' => 'widget',
        'name' => 'sitepoll.profile-polls',
        'defaultParams' => array(
          'title' => 'Polls',
          'titleCount' => true,
      ),
        'requirements' => array(
          'subject' => 'user',
      ),
        'adminForm' => array(
          'elements' => array(

            array(
                'MultiCheckbox',
                'showoptions',
                array(
                    'label' => 'Choose the options that you want to be displayed for the polls in this block”',
                    'multiOptions' => array('votecount'=>'Vote','creation_date'=>'Created On','likecount'=>'Likes','viewcount'=>'Views','commentcount'=>'Comments'),
                    //'value' =>array("viewcount","likecount","commentcount","votecount","creation_date",),
                ),
            ),
            array(
                'Text',
                'itemCount',
                array(
                    'label' => 'Count',
                    'description' => '(number of Polls to show)',
                    'value' => 12,
                )
            ),
            array(
                'Text',
                'truncationDescription',
                array(
                    'label' => "Enter the truncation limit for the Poll Description.",
                    'value' => 250,
                )
            ),
            array(
                'Text',
                'truncationTitle',
                array(
                    'label' => "Enter the truncation limit for the Poll Title.",
                    'value' => 100,
                )
            ),
        ),
      )
    ),

    array(
        'title' => 'Browse Polls',
        'description' => 'Displays a list of all the polls on your site. This widget should be placed on the Ultimate Polls-Poll Browse Page.',
        'category' => 'Ultimate Polls Plugin',
        'type' => 'widget',
        'name' => 'sitepoll.polls-sitepoll',
        'requirements' => array(
          'no-subject',
      ),
        'adminForm' => array(
          'elements' => array(
            array(
                'MultiCheckbox',
                'layouts_views',
                array(
                    'label' => 'Choose the view types that you want to be available for polls on the my polls and browse polls.',
                    'multiOptions' => array("1" => "List View", "2" => "Grid View"),
                    //'value'=>array("1","2"),
                ),
            ),
            array(
                'MultiCheckbox',
                'showoptions',
                array(
                    'label' => 'Choose the options that you want to be displayed for the polls in this block”',
                    'multiOptions' => array('votecount'=>'Vote','owner'=>'Created By','creation'=>'Created On','feature'=>'Featured','sponsored'=>'Sponsored','likecount'=>'Likes','viewcount'=>'Views','commentcount'=>'Comments'),
                    
                ),
            ),
            array(
                    'Text',
                    'columnWidth',
                    array(
                        'label' => 'Column Width For Grid View.',
                        'value' => '272',
                    )   
                ),
                array(
                    'Text',
                    'columnHeight',
                    array(
                        'label' => 'Column Height For Grid View.',
                        'value' => '370',
                    )
                ),
            array(
                'Radio',
                'defaultordering',
                array(
                    'label' => 'Default ordering in Browse Polls.',
                    'multiOptions' => array(
                        1 => 'All polls in ascending order of start time.',
                        0 => 'All polls in descending order of views.',
                        2 => 'All polls in alphabetical order.',
                        3 => 'Sponsored polls followed by others in ascending order of start time.',
                        4 => 'Featured polls followed by others in ascending order of start time.',
                        5 => 'Sponsored & Featured polls followed by Sponsored polls followed by Featured polls followed by others in ascending order of start time.',
                        6 => 'Featured & Sponsored polls followed by Featured polls followed by Sponsored polls followed by others in ascending order of start time.'
                    ),
                    'value' => '1',
                )
            ),
            array(
                'Text',
                'itemCount',
                array(
                    'label' => 'Count',
                    'description' => '(number of Polls to show)',
                    'value' => 12,
                )
            ),
            array(
                'Text',
                'truncationDescription',
                array(
                    'label' => "Enter the truncation limit for the Poll Description.",
                    'value' => 250,
                )
            ),
            array(
                'Text',
                'truncationTitle',
                array(
                    'label' => "Enter the truncation limit for the Poll Title.",
                    'value' => 100,
                )
            ),
        ),
      )

    ),
    array(
        'title' => 'My Polls: User’s Polls',
        'description' => 'Displays a list of all the polls created by a user on the site. This widget should be placed on Ultimate Polls - My Polls page.',
        'category' =>'Ultimate Polls Plugin',
        'type' => 'widget',
        'name' => 'sitepoll.polls-manage',
        'requirements' => array(
          'no-subject',
      ),        'adminForm' => array(
          'elements' => array(
                array(
                    'Text',
                    'columnWidth',
                    array(
                        'label' => 'Column Width For Grid View.',
                        'value' => '270',
                    )
                ),
                array(
                    'Text',
                    'columnHeight',
                    array(
                        'label' => 'Column Height For Grid View.',
                        'value' => '380',
                    )
                ),
            ),
      )
    ),
    array(
        'title' => 'Poll Duration',
        'description' => "Displays status of the poll. This widget should be placed on Poll View page.",
        'category' => 'Ultimate Polls Plugin',
        'type' => 'widget',
        'name' => 'sitepoll.poll-status',
        'defaultParams' => array(
            'title' => '',
        ),
    ),
    array(
        'title' => 'Popular Poll Tags',
        'description' => 'Displays popular tags. You can choose to display tags based on their frequency / alphabets from the Edit Settings of this widget. This widget should be placed on the "Ultimate Polls - Poll View" / "Ultimate Polls - Browse Polls" / "Ultimate Polls - My Polls pages."',
        'category' => 'Ultimate Polls Plugin',
        'type' => 'widget',
        'name' => 'sitepoll.tagcloud-sitepoll',
        'adminForm' => array(
            'elements' => array(
                array(
                    'Radio',
                    'postedby',
                    array(
                        'label' => 'Do you want to show popular polls tags in alphabetical order?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => '1',
                    )
                ),
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of tags to show)',
                        'value' => 12,
                    )
                ),
            )
        ),
    ),
    array(
        'title' => 'Ultimate Polls: Popular Polls',
        'description' => 'Displays a list of popular polls.',
        'category' => 'Ultimate Polls Plugin',
        'type' => 'widget',
        'name' => 'sitepoll.list-popular-polls',
        'defaultParams' => array(
          'title' => 'Popular Polls',
      ),
        'requirements' => array(
          'no-subject',
      ),
        'adminForm' => array(
          'elements' => array(
             array(
              'Radio',
              'popularType',
              array(
                'label' => 'Popularity / Sorting Criteria',
                'multiOptions' => array(
                  'vote' => 'Votes',
                  'view' => 'Views',
                  'comment' => 'Comments',
                  'like' => 'Likes',
              ),
                'value' => 'vote',
            )
          ),   
             array(
                'Text',
                'truncationTitle',
                array(
                    'label' => "Enter the truncation limit for the Poll Title.",
                    'value' => 100,
                )
            ),
             array(
                'Text',
                'itemCount',
                array(
                    'label' => 'Count',
                    'description' => '(number of Polls to show)',
                    'value' => 3,
                )
            ),
         )
      ),
    ),
    array(
        'title' => 'Ultimate Polls: Recent Polls',
        'description' => 'Displays a list of polls recently viewed by users',
        'category' => 'Ultimate Polls Plugin',
        'type' => 'widget',
        'name' => 'sitepoll.list-recent-polls',
        'defaultParams' => array(
          'title' => 'Recent Polls',
    ),
        'requirements' => array(
          'no-subject',
    ),
        'adminForm' => array(
          'elements' => array(
            array(
                'Select',
                'category_id',
                array(
                    'label' => 'Category',
                    'multiOptions' => $categories,
                )
            ),
            array(
                'Text',
                'truncationDescription',
                array(
                    'label' => "Enter the truncation limit for the Poll Description.",
                    'value' => 250,
                )
            ),
            array(
                'Text',
                'truncationTitle',
                array(
                    'label' => "Enter the truncation limit for the Poll Title.",
                    'value' => 100,
                )
            ),
            array(
              'MultiCheckbox',
              'recentType',
              array(
                'label' => 'Choose the options that you want to be displayed for the polls in this block”',
                'multiOptions' => array(
                  'creation' => 'Creation Date',
                  'vote' => 'Votes',
                  'view' => 'Views',
                  'comment' => 'Comments',
                  'likes' => 'Likes',
                  'sponsored'=>'Sponsered Label',
                  'featured' => 'Featured Label',
                  'owner' => 'Created By',
                ),
                //'value' => array("view","owner","creation","featured","sponsored","likes","comment","vote"),
              )
            ),
            array(
                'Text',
                'itemCount',
                array(
                    'label' => 'Count',
                    'description' => '(number of Polls to show)',
                    'value' => 3,
                )
            ),
        )
      ),
    ),
)
?>
