<?php
/**
* SocialEngine
*
* @category Application_Extensions
* @package Sitepoll
* @copyright Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
* @license http://www.socialengineaddons.com/license/
* @version 2019-08-10 9:40:21Z SocialEngineAddOns $
* @author SocialEngineAddOns
*/
class Sitepoll_Widget_ListPopularPollsController extends Engine_Content_Widget_Abstract{
    public function indexAction(){
        // Should we consider views or comments popular?
        $popularType = $this->_getParam('popularType');
        if( !in_array($popularType, array('comment', 'view', 'vote','like')) ) {
            $popularType = 'vote';
        }
        $this->view->popularType = $popularType;
        $this->view->popularCol = $popularCol = $popularType . '_count';
        $params = array('search' => true);
        // Get paginator
        $table = Engine_Api::_()->getItemTable('sitepoll_poll');
        $select = $table->getItemsSelect($params);
        $select-> where('approved = ?', '1');
        $select-> where('declined = ?', '0');
        $select->order($popularCol . ' DESC');

        $select = Engine_Api::_()->network()->getNetworkSelect($table->info('name'), $select, 'user_id');

        $authorisedSelect = $table->getAuthorisedSelect($select);
        $this->view->paginator = $paginator = Zend_Paginator::factory($authorisedSelect);

        // Set item count per page and current page number
        $paginator->setItemCountPerPage($this->_getParam('itemCount', 5));
        $paginator->setCurrentPageNumber($this->_getParam('page', 1));

        // Hide if nothing to show
        if( $paginator->getTotalItemCount() <= 0 ) {
            return $this->setNoRender();
        }
        $this->view->truncationTitle = $this->_getParam('truncationTitle', 100);
        $this->view->viewAll = $params['viewAll'] = $this->_getParam('viewAll', 1);
    }
}
