<?php
/**
* SocialEngine
*
* @category Application_Extensions
* @package Sitepoll
* @copyright Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
* @license http://www.socialengineaddons.com/license/
* @version 2019-08-10 9:40:21Z SocialEngineAddOns $
* @author SocialEngineAddOns
*/
class Sitepoll_Widget_ListRecentPollsController extends Engine_Content_Widget_Abstract{
    public function indexAction(){
        // Should we consider creation or modified recent?
        $recentType = $this->_getParam('recentType', 'creation');
        if( !in_array($recentType, array('creation', 'modified')) ) {
            $recentType = 'creation';
        }
        $this->view->recentType = $recentType;
        $this->view->recentCol = $recentCol = $recentType . '_date';
        $params = array('search' => true);
        $this->view->category_id = $cat_id = $this->_getParam('category_id',0);
        // Get paginator
        $table = Engine_Api::_()->getItemTable('sitepoll_poll');
        $select = $table->getItemsSelect($params);
        //print_r($cat_id); die;
        if( $recentType == 'creation' ) {
            $select-> where('approved = ?', '1');
            $select-> where('declined = ?', '0');
            if(!empty($cat_id))
                $select->where('category_id=?',$cat_id);
            $select->order('poll_id DESC');
        } else {
            $select-> where('approved = ?', '1');
            $select-> where('declined = ?', '0');
            if(!empty($cat_id))
                $select->where('category_id=?',$cat_id);
            $select->order($recentCol . ' DESC');
        }

        $select = Engine_Api::_()->network()->getNetworkSelect($table->info('name'), $select, 'user_id');

        $authorisedSelect = $table->getAuthorisedSelect($select);
        $this->view->paginator = $paginator = Zend_Paginator::factory($authorisedSelect);

        // Set item count per page and current page number
        $paginator->setItemCountPerPage($this->_getParam('itemCount', 3));
        $paginator->setCurrentPageNumber($this->_getParam('page', 1));

        // Hide if nothing to show
        if( $paginator->getTotalItemCount() <= 0 ) {
            return $this->setNoRender();
        }
        $this->view->info = $params['recentType'] = $this->_getParam('recentType',array('creation','vote','view','comment','likes','sponsored','featured','owner'));
        $this->view->truncationDescription = $this->_getParam('truncationDescription', 250);
        $this->view->truncationTitle = $this->_getParam('truncationTitle', 100);
    }
}
