<?php
/**
* SocialEngine
*
* @category Application_Extensions
* @package Sitepoll
* @copyright Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
* @license http://www.socialengineaddons.com/license/
* @version 2019-08-10 9:40:21Z SocialEngineAddOns $
* @author SocialEngineAddOns
*/
class Sitepoll_Widget_ProfilePollsController extends Engine_Content_Widget_Abstract{
  protected $_childCount;
  
  public function indexAction()
  {
    // Don't render this if not authorized
    $viewer = Engine_Api::_()->user()->getViewer();
    if( !Engine_Api::_()->core()->hasSubject() ) {
      return $this->setNoRender();
    }

    // Get subject and check auth
    $subject = Engine_Api::_()->core()->getSubject();
    if( !$subject->authorization()->isAllowed($viewer, 'view') ) {
      return $this->setNoRender();
    }

    $this->view->params = $this->_getAllParams();
    $order=$this->_getParam('defaultordering', 1);
    // Get paginator
    $profile_owner_id = $subject->getIdentity();
    $this->view->paginator = $paginator = Engine_Api::_()->getItemTable('sitepoll_poll')->getPollsPaginator(array(
      'user_id' => $profile_owner_id,
      'sort' => "creation_date",
    ));
    $info=$this->view->info = $params['showoptions'] = $this->_getParam('showoptions',array('votecount','created_on','likecount','viewcount','commentcount'));
    $this->view->truncationDescription = $this->_getParam('truncationDescription', 100);
    $this->view->truncationTitle = $this->_getParam('truncationTitle', 100);
    $this->view->params = $params;
    // Set item count per page and current page number
    $paginator->setItemCountPerPage($this->_getParam('itemCount', 12));
    $paginator->setCurrentPageNumber($this->_getParam('page', 1));
    
    // Do not render if nothing to show
    if( $paginator->getTotalItemCount() <= 0 ) {
      return $this->setNoRender();
    }

    // Add count to title if configured
    if( $this->_getParam('titleCount', false) && $paginator->getTotalItemCount() > 0 ) {
      $this->_childCount = $paginator->getTotalItemCount();
    }
  }

  public function getChildCount()
  {
    return $this->_childCount;
  }
}
