<?php

class Sitepushnotification_Api_Core extends Core_Api_Abstract {

    public function getBaseUrl() {
        $application_path = APPLICATION_PATH;
        $arr = explode('/', $application_path);
        unset($arr[count($arr) - 1]);
        $baseurl = implode("/", $arr);

        return $baseurl;
    }

    public function dateTimeToString($datetime) {
        // Date
        $array = explode('/', $datetime['date']);
     
        $param['date'][0] = $array[2];
        $param['date'][1] = $array[1];
        $param['date'][2] = $array[0];
        $param['date'] = implode('-', $param['date']);
        unset($datetime['date']);

        // Time 
        if ($datetime['ampm'] == 'PM') {
            $datetime['hour'] = 12 + (int) $datetime['hour'];
        }
        if ((int) $datetime['hour'] < 10) {
            $datetime['hour'] = '0' . $datetime['hour'];
        }
        if ((int) $datetime['minute'] < 10) {
            $datetime['minute'] = '0' . $datetime['minute'];
        }
        unset($datetime['ampm']);
        $datetime['sec'] = '00';

        $param['time'] = implode(':', $datetime);
        return implode(" ", $param);
    }

    public function translateType($type) {
        switch ($type) {
            case 'non_loggedin':
                return 'Non Logged in Subscribers';
                break;

            case 'registered':
                return 'All Subscribed Subscribers';
                break;

            case 'member_level':
                return 'Member Levels';
                break;

            case 'network':
                return 'Networks';
                break;

            case 'specific_user':
                return 'Specific Subscribers';
                break;
        }
    }

    public function setPhoto($photo) {
        $valid_thumb = true;
        if ($photo instanceof Zend_Form_Element_File) {
            $file = $photo->getFileName();
            $fileName = $file;
        } else if ($photo instanceof Storage_Model_File) {
            $file = $photo->temporary();
            $fileName = $photo->name;
        } else if ($photo instanceof Core_Model_Item_Abstract && !empty($photo->file_id)) {
            $tmpRow = Engine_Api::_()->getItem('storage_file', $photo->file_id);
            $file = $tmpRow->temporary();
            $fileName = $tmpRow->name;
        } else if (is_array($photo) && !empty($photo['tmp_name'])) {
            $file = $photo['tmp_name'];
            $fileName = $photo['name'];
        } else {
            $file = $photo;
            $fileName = $photo;
            if (@GetImageSize($fileName)) {
                $valid_thumb = true;
            } else {
                $valid_thumb = false;
            }
        }
        if (empty($fileName))
            return;
        if (!$fileName) {
            $fileName = basename($file);
        }

        $params = array(
            'parent_type' => 'sitepushnotification_schedulednotifications',
            'name' => $fileName,
        );

        $thumbnail_parsed = @parse_url($fileName);
        $ext = ltrim(strrchr($fileName, '.'), '.');
        if (isset($thumbnail_parsed['path'])) {
            $ext = ltrim(strrchr($thumbnail_parsed['path'], '.'), '.');
        }
        if ($valid_thumb && $fileName && $ext && $thumbnail_parsed && in_array($ext, array('jpg', 'jpeg', 'gif', 'png'))) {

            $file = APPLICATION_PATH . '/temporary/logo_' . md5($fileName) . '.' . $ext;
            $mainPath = APPLICATION_PATH . '/temporary/logo_' . md5($fileName) . '_m.' . $ext;

            $src_fh = fopen($fileName, 'r');
            $tmp_fh = fopen($file, 'w');
            stream_copy_to_stream($src_fh, $tmp_fh, 1024 * 1024 * 30);

            // Resize image (main)
            if (file_exists($file)) {
                $image = Engine_Image::factory();
                $image->open($file)
                        ->resize(100, 100)
                        ->write($mainPath)
                        ->destroy();
            }

            $filesTable = Engine_Api::_()->getDbtable('files', 'storage');

            // Store
            $iMain = $filesTable->createFile($mainPath, $params);
            $iMain->bridge($iMain, 'logo');

            // Remove temp files
            @unlink($mainPath);

            $photo_id = $iMain->getIdentity();
        }
        return $photo_id;
    }

    public function setPushImage($photo_id) {

        $photoUrl = Engine_Api::_()->getApi('core', 'sitepushnotification')->getBaseUrl() . Engine_Api::_()->storage()->get($photo_id)->getPhotoUrl();
        $dummyArray = explode("?", $photoUrl);
        $photoUrl = $dummyArray[0];
        $extension = Engine_Api::_()->storage()->get($photo_id)->extension;
        $basePath = APPLICATION_PATH . DIRECTORY_SEPARATOR . 'temporary';

        // Resize image in diffrent sizes
        $name_icon128 = "icon_128x128." . $extension;
        $icon128 = $basePath . $name_icon128;
        $image = Engine_Image::factory();
        $image->open($photoUrl)
                ->resize(128, 128)
                ->write($icon128)
                ->destroy();

        $name_icon128x = "icon_128x128@2x." . $extension;
        $icon128x = $basePath . $name_icon128x;
        $image = Engine_Image::factory();
        $image->open($photoUrl)
                ->resize(156, 156)
                ->write($icon128x)
                ->destroy();

        $name_icon16 = "icon_16x16." . $extension;
        $icon16 = $basePath . $name_icon16;
        $image = Engine_Image::factory();
        $image->open($photoUrl)
                ->resize(16, 16)
                ->write($icon16)
                ->destroy();

        $name_icon16x = "icon_16x16@2x." . $extension;
        $icon16x = $basePath . $name_icon16x;
        $image = Engine_Image::factory();
        $image->open($photoUrl)
                ->resize(32, 32)
                ->write($icon16x)
                ->destroy();

        $name_icon32 = "icon_32x32." . $extension;
        $icon32 = $basePath . $name_icon32;
        $image = Engine_Image::factory();
        $image->open($photoUrl)
                ->resize(32, 32)
                ->write($icon32)
                ->destroy();

        $name_icon32x = "icon_32x32@2x." . $extension;
        $icon32x = $basePath . $name_icon32x;
        $image = Engine_Image::factory();
        $image->open($photoUrl)
                ->resize(64, 64)
                ->write($icon32x)
                ->destroy();

        $params = array(
            'parent_type' => 'sitepushnotification_pushimages',
        );

        $filesTable = Engine_Api::_()->getDbtable('files', 'storage');

        // Store
        $params['name'] = $name_icon128;
        $iicon128 = $filesTable->createFile($icon128, $params);

        $params['name'] = $name_icon128x;
        $iicon128x = $filesTable->createFile($icon128x, $params);

        $params['name'] = $name_icon16;
        $iicon16 = $filesTable->createFile($icon16, $params);

        $params['name'] = $name_icon16x;
        $iicon16x = $filesTable->createFile($icon16x, $params);

        $params['name'] = $name_icon32;
        $iicon32 = $filesTable->createFile($icon32, $params);

        $params['name'] = $name_icon32x;
        $iicon32x = $filesTable->createFile($icon32x, $params);

        $ids['icon128'] = $iicon128->getIdentity();
        $ids['icon128x'] = $iicon128x->getIdentity();
        $ids['icon16'] = $iicon16->getIdentity();
        $ids['icon16x'] = $iicon16x->getIdentity();
        $ids['icon32'] = $iicon32->getIdentity();
        $ids['icon32x'] = $iicon32x->getIdentity();

        // Remove temp files
        @unlink($icon128);
        @unlink($icon128x);
        @unlink($icon16);
        @unlink($icon16x);
        @unlink($icon32);
        @unlink($icon32x);

        return $ids;
    }

    public function getIconSet() {
        $ids['icon_16x16.'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitepushnotification.icon16', 0);
        $ids['icon_16x16@2x.'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitepushnotification.icon16x', 0);
        $ids['icon_32x32.'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitepushnotification.icon32', 0);
        $ids['icon_32x32@2x.'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitepushnotification.icon32x', 0);
        $ids['icon_128x128.'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitepushnotification.icon128', 0);
        $ids['icon_128x128@2x.'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitepushnotification.icon128x', 0);

        $basePath = "icon.iconset/";

        foreach ($ids as $key => $value) {
            if (empty($value) || $value == 0 || $value == null) {
                return 0;
            }

            $photoUrl = Engine_Api::_()->getApi('core', 'sitepushnotification')->getBaseUrl() . Engine_Api::_()->storage()->get($value)->getPhotoUrl();
            $dummyArray = explode("?", $photoUrl);
            $photoUrl = $dummyArray[0];
            $extension = Engine_Api::_()->storage()->get($value)->extension;

            $params[$basePath . $key . $extension] = $photoUrl;
        }

        return $params;
    }

    public function sendNow($params) {
        // Counter to check delivery status of notifications
        $counter = 'default';
        $data['title'] = $params['title'];
        $data['body'] = $params['body'];
        $data['tag'] = (string) rand(0, 100000);

        if ($params['url'] == '' || !isset($params['url'])) {
            $data['url'] = $this->getBaseHost();
        } else
            $data['url'] = $params['url'];

        $front = Zend_Controller_Front::getInstance();
        if ($params['logo'] != 0) {
            $data['logo'] = Engine_Api::_()->storage()->get($params['logo'], '')->getPhotoUrl();
        } else
            $data['logo'] = $front->getBaseUrl() . '/application/modules/Sitepushnotification/externals/images/default.jpg';

        $data['logo'] = $this->getPhotoUrl($data['logo']);
        $userDbTable = Engine_Api::_()->getDbtable('users', 'sitepushnotification');
        //  Getting users data to send notifications
        if ($params['send_to'] == 'registered') {
            $users = $userDbTable->getRegisteredUsers();
        } elseif ($params['send_to'] == 'network') {
            if (empty($params['network'])) {
                $form->addError('please select atleast one Network - it is required');
                return;
            }
            $users = $userDbTable->getNetworkBasedUsers($params['users_data']);
        } elseif ($params['send_to'] == 'member_level') {
            if (empty($params['member_level'])) {
                $form->addError('please select atleast one Member Level - it is required');
                return;
            }

            $users = $userDbTable->getLevelBasedUsers($params['users_data']);
        } elseif ($params['send_to'] == 'specific_user') {
            if (empty($params['toValues'])) {
                $form->addError('please enter atleast one user name - it is required');
                return;
            }

            $users = Engine_Api::_()->getDbtable('users', 'sitepushnotification')->getSpecificUsers($params['users_data']);
        } elseif ($params['send_to'] == 'non_loggedin') {
            $users = $userDbTable->getUnregisteredUsers();
        }

        $plugin = Engine_Api::_()->loadClass('Sitepushnotification_Plugin_Pushnotification');
        $counter = 1;
        foreach ($users as $user) {
            $userData = array();
            $userData['browser'] = $user['browser'];
            $userData['uid'] = $user['uid'];
            $userData['device_id'] = $user['device_id'];
            $userPushSetting = $this->getUserPushSetting($userData['uid']);
            if ($userPushSetting != '1')
                continue;

            $udata = array_merge($data, $userData);
            // Sending admin created notifications
            $status = $plugin->sendAdminBasedNotification($udata);
            $udata['status'] = $status['sent'];
            // Insterting notifications and their status to notification table
            if ($status['sent'] == 200)
                $udata['delivered'] = 1;
            else if ($status['sent'] == 400) {
                $udata['delivered'] = 0;
                $udata['error'] = $status['error'];
                $counter = 0;
            }
            $this->saveNotificationData($udata);
        }
        return $counter;
    }

    public function saveNotificationData($data) {
        $payload['title'] = $data['title'];
        $payload['body'] = $data['body'];
        $payload['url'] = $data['url'];
        $payload['tag'] = $data['tag'];
        $payload['logo'] = $data['logo'];
        $data['payload'] = json_encode($payload);
        $data['creation_date'] = date("Y-m-d H:i:s");
        $notificationsTable = Engine_Api::_()->getDbtable('notifications', 'sitepushnotification');
        $db = $notificationsTable->getAdapter();
        $db->beginTransaction();

        try {
            $notification = $notificationsTable->createRow();
            $notification->setFromArray($data);
            $notification->save();
            $db->commit();
        } catch (Exception $e) {
            $db->rollBack();
            throw $e;
        }
    }

    public function updateNotificationData($notification_id, $delivered, $errorMessage = '') {
        $notificationsTable = Engine_Api::_()->getDbtable('notifications', 'sitepushnotification');
        $notificationsTable->update(array('delivered' => $delivered, 'error' => $errorMessage), array('`notification_id` = ? ' => $notification_id));
    }

    public function getUserPushSetting($user_id) {
        if ($user_id == null || $user_id == 0)
            return 1;

        $table = Engine_Api::_()->getDbtable('notificationSettings', 'activity');

        $select = $table->select()
                ->where('`type` = ?', 'sitepushnotification_subscribe')
                ->where('`user_id` = ?', $user_id);

        $row = $table->fetchRow($select);

        if (!$row)
            return 1;

        return 0;
    }

    public function getErrorMessage($code) {
        switch ($code) {
            case 'MissingRegistration':
                $message = 'Missing Registration Token';
                break;
            case 'InvalidRegistration':
                $message = 'Invalid Registration Token';
                break;
            case 'NotRegistered':
                $message = 'Unregistered Device';
                break;
            case 'InvalidPackageName':
                $message = 'Invalid Package Name';
                break;
            case 'MismatchSenderId':
                $message = 'Mismatched Sender';
                break;
            case 'MessageTooBig':
                $message = 'Message Too Big';
                break;
            case 'InvalidDataKey':
                $message = 'Invalid Data Key';
                break;
            case 'InvalidTtl':
                $message = 'Invalid Time to Live';
                break;
            case 'Unavailable':
                $message = 'Timeout';
                break;
            case 'InternalServerError':
                $message = 'Internal Server Error';
                break;
            case 'DeviceMessageRateExceeded':
                $message = 'Device Message Rate Exceeded';
                break;
            case 'TopicsMessageRateExceeded':
                $message = 'Topics Message Rate Exceeded';
                break;
            default :
                $message = $code;
        }
        return $message;
    }

    public function getStatus($status) {
        $_status = 'N/A';
        switch ($status) {
            case 1:
                $_status = 'Sent';
                break;

            case 0:
                $_status = 'Failed';
                break;
        }
        return $_status;
    }

    public function getBaseHost() {
        $mode = ($this->isSSL()) ? 'https' : 'http';
        return "$mode://" . $_SERVER['SERVER_NAME'] . _ENGINE_R_BASE;
    }

    function isSSL() {
        $scheme = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitepushnotification.protocol');
        if (is_null($scheme)) {
            $scheme = ($this->getScheme()) == 'https' ? '' : '1';
        }
        if ($scheme == '1') {
            return false;
        }
        return true;
    }

    function getScheme() {
        switch (true) {
            case (isset($_SERVER['HTTPS']) && ($_SERVER['HTTPS'] == 'on' || $_SERVER['HTTPS'] === true)):
            case (isset($_SERVER['HTTP_SCHEME']) && ($_SERVER['HTTP_SCHEME'] == 'https')):
            case (isset($_SERVER['SERVER_PORT']) && ($_SERVER['SERVER_PORT'] == 443)):
                $scheme = 'https';
                break;
            default:
                $scheme = 'http';
        }
        return $scheme;
    }

    function getPhotoUrl($imageUrl) {
        $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
        $parseUrl = parse_url($imageUrl);
        if (!(isset($parseUrl['scheme']) && ($parseUrl['scheme'] == 'https' || $parseUrl['scheme'] == 'http'))) {
            $imageUrl = $view->serverUrl() . $imageUrl;
        }
        return $imageUrl;
    }

    function getUserTitleColumn() {
        $user = Engine_Api::_()->getItemTable('user')->fetchRow();
        $column = 'email';
        if (isset($user->displayname) && '' !== trim($user->displayname)) {
            $column = 'displayname';
        } else if (isset($user->username) && '' !== trim($user->username)) {
            $column = 'username';
        } else if (isset($user->email) && '' !== trim($user->email)) {
            $column = 'email';
        }
        return $column;
    }

    public function isTokenValid($device_id = null) {
        if ($device_id == null) 
            return null; 

        $plugin = Engine_Api::_()->loadClass('Sitepushnotification_Plugin_Pushnotification');
        $GOOGLE_API_KEY = $plugin->canSendNotification(true);
        $data = '{  "data": {
                        "title": "This is a test notification.",
                        "icon" : "https://demo.socialengineaddons.com/firebase/default.jpg"
                      },
                    "dry_run" : true,
                    "to" : "'.$device_id.'" }';

        $headers = array('Content-Type:application/json','Authorization: key='.$GOOGLE_API_KEY);
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($ch, CURLOPT_URL, "https://fcm.googleapis.com/fcm/send");
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        // curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_POSTFIELDS,$data);
        $returnValue = curl_exec($ch);
        curl_close($ch);

        $response = json_decode($returnValue);

        if ($response->failure == '1' && $response->results[0]->error == 'NotRegistered')
            return false;
        else
            return true;
    }
}
