<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitepushnotification
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Welcome.php 6590 2016-3-3 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitepushnotification_Form_Admin_Welcome extends Engine_Form {

    // IF YOU WANT TO SHOW CREATED ELEMENT ON PLUGIN ACTIVATION THEN INSERT THAT ELEMENT NAME IN THE BELOW ARRAY.
    public $_SHOWELEMENTSBEFOREACTIVATE = array(
        "submit_lsetting", "environment_mode"
    );

    public function init() {

        $productType = 'sitepushnotification';
        // Set time zone
        $timezone = Engine_Api::_()->getApi('settings', 'core')->core_locale_timezone;
        date_default_timezone_set($timezone);

        $this
                ->setTitle('Welcome Notification Settings')
                ->setDescription('Configure the settings for the welcome push notification that a subscriber will recieve when they first subscribed for the push notifications.');

        // Fetch already included logo
        $logoId = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitepushnotification.welcome.logo', '');
        $logoValue = "";
        if ($logoId) {
            $url = Engine_Api::_()->storage()->get($logoId, '')->getPhotoUrl();
            $urlArr = explode("/", $url);
            $logo_name = explode("?c=", $urlArr[count($urlArr) - 1]);
            $logoValue = "[ Uploaded file " . $logo_name[0] . " ] &nbsp;&nbsp;<img src='$url' width=70px height=70px />";
        }

        // Form field for setting notification subscription method for users
//        $this->addElement('Checkbox', 'sitepushnotification_welcome_enabled', array(
//            'description' => 'Enable Welcome Push Notification',
//            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitepushnotification.welcome.enabled', '1'),
//        ));
        $this->addElement('Select', 'sitepushnotification_welcome_enabled', array(
            'label' => 'Welcome Push Notification',
            'description' => 'Do you want to enable Welcome Push Notification ?',
            'multiOptions' => array(
                1 => "Yes",
                '' => "No",
            ),
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitepushnotification.welcome.enabled', '1'),
        ));

        $this->addElement('Text', 'sitepushnotification_welcome_title', array(
            'label' => 'Notification Title',
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitepushnotification.welcome.title', ''),
        ));

        $this->addElement('Textarea', 'sitepushnotification_welcome_body', array(
            'label' => 'Notification Message',
            'description' => 'Enter message which will be displayed in welcome push notification to your subscribers.',
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitepushnotification.welcome.body', ''),
        ));

        // Form field for setting logo of  welcome notification
        $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
        $baseURL = $view->baseUrl();
        $icon_url = $baseURL . '/application/modules/Sitepushnotification/externals/images/Global_Setting_Screenshot.png';
        $icon_view = '<a href="' . $icon_url . '" title="View Screenshot" class="sitepushnotification_icon_view" target="_blank"></a>';
        $this->addElement('File', 'sitepushnotification_welcome_logo', array(
            'label' => 'Select Logo',
            'description' => '',
            'description' => ' Upload the logo you want to be displayed in the welcome push notification.<br> [Note: If your site is not SSL secure then, the logo you have sent us via filing a support ticket will be displayed in the notification. To change the logo in future you need to file us a support ticket again with the same details and new logo.]. ' . $icon_view . ' <br><br>' . $logoValue,
            'value' => 0
        ));
        $this->sitepushnotification_welcome_logo->addValidator('Extension', false, 'jpg,png,gif,jpeg,JPG,PNG,GIF,JPEG');
        $this->sitepushnotification_welcome_logo->getDecorator('Description')->setOption('escape', false);

        // Form field for setting url of notifications
        $urlProtocolValue = "http://";
        $redirectingUrl = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitepushnotification.welcome.url', '');
        if (strpos($redirectingUrl, "https://") === 0) {
            $urlProtocolValue = 'https://';
            $redirectingUrl = str_replace("https://", "", $redirectingUrl);
        }
        else if (strpos($redirectingUrl, "https://") === false)
            $redirectingUrl = str_replace("http://", "", $redirectingUrl);

        $this->addElement('Select', 'urlprotocol', array(
            'label' => 'Redirecting URL',
            'description' => '',
            'multiOptions' => array('http://' => 'http://', 'https://' => "https://"),
            'value' => $urlProtocolValue,
        ));
        $this->addElement('Text', 'sitepushnotification_welcome_url', array(
            'error_msg' => 'Enter the prorper URL',
            'value' => $redirectingUrl,
        ));
        $this->sitepushnotification_welcome_url->addValidator('Regex', false, '/^(https?:\/\/)?([\da-z\.-]+)\.([a-z\.]{2,6})([\/\w \.-]*)*\/?$/');
        $this->sitepushnotification_welcome_url->getDecorator('Description')->setOption('escape', false);

        $this->addElement('Button', 'submit', array(
            'label' => 'Save Changes',
            'type' => 'submit',
            'ignore' => true
        ));
    }

}
