<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Mobi
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 * @version    $Id: Core.php 9747 2012-07-26 02:08:08Z john $
 * @author     Charlotte
 */

/**
 * @category   Application_Extensions
 * @package    Mobi
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 */
class Sitepushnotification_Plugin_Core extends Zend_Controller_Plugin_Abstract
{

  public function onRenderLayoutDefault($event)
  {

    if( !Engine_Api::_()->getApi('core', 'sitepushnotification')->isSSL() ) {
      return;
    }
    //Start work for responsive theme/media query
    $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
    $config = strip_tags(file_get_contents(APPLICATION_PATH . '/application/modules/Sitepushnotification/views/scripts/config.tpl'));
    if( !Engine_Api::_()->seaocore()->isSitePWAMode() ) {
      $view->headLink(array(
        'rel' => 'manifest',
        'href' => $view->baseUrl('/application/modules/Sitepushnotification/externals/manifest.json')
        ), 'PREPEND');
    }
    $view->headScript()->appendFile($view->layout()->staticBaseUrl . 'application/modules/Sitepushnotification/externals/scripts/pushSDK.js');
    $view->headScript()->appendFile("https://www.gstatic.com/firebasejs/3.6.2/firebase.js");
    $view->headScript()->appendScript($config);
  }

  public function onRenderLayoutMobileDefault($event)
  {
    // Forward
    return $this->onRenderLayoutDefault($event);
  }

}