<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitepushnotification
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminManageController.php 6590 2016-3-3 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitepushnotification_AdminManageController extends Core_Controller_Action_Admin {

    public function init() {
        parent::init();

        // Set time zone
        $timezone = Engine_Api::_()->getApi('settings', 'core')->core_locale_timezone;
        date_default_timezone_set($timezone);
    }

    public function usersAction() {
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('spn_admin_main', array(), 'spn_admin_main_manageusers');
        $page = $this->_getParam('page', 1);
        $this->view->users = Engine_Api::_()->getItemTable('sitepushnotification_user')->getNotificationUsersPaginator(array('orderby' => 'subscription_id',));
        $this->view->users->setItemCountPerPage(50);
        $this->view->users->setCurrentPageNumber($page);
    }

    public function sentNotificationsAction() {
        // main menu
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('spn_admin_main', array(), 'spn_admin_main_managenotifications');
        // sub menu
        $this->view->subnavigation = $subnavigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('spn_admin_main_managenotifications', array(), 'spn_admin_main_managenotifications_sent');
        $form = new Sitepushnotification_Form_Admin_Search;
        $this->view->form = $form;
        if (!$this->getRequest()->isPost()) {
            // fetch notifications from the sent notifications table
            $page = $this->_getParam('page', 1);
            $this->view->notification = Engine_Api::_()->getItemTable('sitepushnotification_notification')->getNotificationsPaginator(array('orderby' => 'notification_id',));
            $this->view->notification->setItemCountPerPage(50);
            $this->view->notification->setCurrentPageNumber($page);
            return;
        }

        // Get notifications table
        $notificationsTable = Engine_Api::_()->getDbtable('notifications', 'sitepushnotification');
        $notificationsTableName = $notificationsTable->info('name');

        // Make query
        $select = $notificationsTable->select();
        $select->where('notification_id !=0');

        $params = Zend_Controller_Front::getInstance()->getRequest()->getParams();

        if (isset($params['delete'])) {
            foreach ($params as $key => $value) {
                if ($key == 'delete_' . $value) {
                    Engine_Api::_()->getDbtable('notifications', 'sitepushnotification')->deleteByPushId($value);
                }
            }
        } else {
            // Make query
            if (null != $this->_getParam('toValues')) {
                $users = str_replace(',', ' OR ', $this->_getParam('toValues'));
                $select->where($notificationsTableName . '.uid = ' . $users);
            }
            if ($this->_getParam('delivered') != 'all_notifications') {
                $delivered = $this->_getParam('delivered');
                if ($delivered == 'unsent_notifications')
                    $select->where($notificationsTableName . '.delivered = 0');
                if ($delivered == 'sent_notifications')
                    $select->where($notificationsTableName . '.delivered = 1');
            }
            if ($this->_getParam('usertype') != 'all_notifications') {
                $usertype = $this->_getParam('usertype');
                if ($usertype == 'logged_in')
                    $select->where($notificationsTableName . '.uid != 0');
                if ($usertype == 'non_loggedin')
                    $select->where($notificationsTableName . '.uid = 0');
            }

            $min_time = $this->_getParam('min_time');
            $min_time['hour'] = '0';
            $min_time['minute'] = '0';
            $min_time['ampm'] = 'AM';
            $min_time = Engine_Api::_()->getApi('core', 'sitepushnotification')->dateTimeToString($min_time);

            $max_time = $this->_getParam('max_time');
            $max_time['hour'] = '0';
            $max_time['minute'] = '0';
            $max_time['ampm'] = 'AM';
            $max_time = Engine_Api::_()->getApi('core', 'sitepushnotification')->dateTimeToString($max_time);

            $select->where('creation_date > ? ', $min_time);
            $select->where('creation_date < ? ', $max_time);
        }
        $select->order('notification_id DESC');

        // fetch notifications from the sent notifications table
        $page = $this->_getParam('page', 1);
        $this->view->notification = $paginator = Zend_Paginator::factory($select);
        $this->view->notification->setItemCountPerPage(50);
        $this->view->notification->setCurrentPageNumber($page);

        $form->reset();
        // $form->getElement('toValues')->setValue($this->_getParam('toValues'));
        $form->getElement('usertype')->setValue($this->_getParam('usertype'));
        $form->getElement('delivered')->setValue($this->_getParam('delivered'));
        $form->getElement('min_time')->setValue($this->_getParam('min_time'));
        $form->getElement('max_time')->setValue($this->_getParam('max_time'));
        return;
    }

    public function scheduledNotificationsAction() {
        // main menu
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('spn_admin_main', array(), 'spn_admin_main_managenotifications');
        // sub menu
        $this->view->subnavigation = $subnavigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('spn_admin_main_managenotifications', array(), 'spn_admin_main_managenotifications_scheduled');

        // fetch notifications from the scheduled notifications table
        $page = $this->_getParam('page', 1);
        $this->view->schedulednotification = Engine_Api::_()->getItemTable('sitepushnotification_schedulednotification')->getScheduledNotificationsPaginator(array('orderby' => 'message_id'));
        $this->view->schedulednotification->setItemCountPerPage(50);
        $this->view->schedulednotification->setCurrentPageNumber($page);
    }

    public function notificationDetailsAction() {
        $this->_helper->layout->setLayout('admin-simple');
        $notification_id = $this->_getParam('notification_id');
    }

    public function resendNotificationAction() {
        $this->_helper->layout->setLayout('admin-simple');
        $this->view->notification_id = $this->_getParam('notification_id');

        if (!$this->getRequest()->isPost()) {
            return;
        }

        $notification_id = $this->_getParam('confirm');

        $notificationsTable = Engine_Api::_()->getDbtable('notifications', 'sitepushnotification');
        $notification = $notificationsTable->find($notification_id)->current();

        $payload = json_decode($notification->payload);
        $data['body'] = $payload->body;
        $data['title'] = $payload->title;
        $data['tag'] = $payload->tag;
        $data['url'] = $payload->url;
        $data['logo'] = $payload->logo;

        $data['browser'] = $notification->browser;
        $data['uid'] = $notification->uid;
        $data['device_id'] = $notification->device_id;

        $status = Engine_Api::_()->loadClass('Sitepushnotification_Plugin_Pushnotification')->sendAdminBasedNotification($data);
        $data['status'] = $status['sent'];
        $errorMessage ="";

        if ($status['sent'] == 200)
            $data['delivered'] = 1;
        else if ($status['sent'] == 400) {
            $data['delivered'] = 0;
            $errorMessage = $status['error'];
        }
        Engine_Api::_()->getApi('core', 'sitepushnotification')->updateNotificationData($notification_id, $data['delivered'],$errorMessage);

        return $this->_forward('success', 'utility', 'core', array(
                    'smoothboxClose' => 10,
                    'parentRefresh' => 10,
                    'messages' => array('')
        ));
    }

    public function deleteNotificationAction() {
        $this->_helper->layout->setLayout('admin-simple');
        $this->view->message_id = $this->_getParam('message_id');

        if (!$this->getRequest()->isPost()) {
            return;
        }

        $id = $this->_getParam('confirm');
        $usersTable = Engine_Api::_()->getDbtable('schedulednotifications', 'sitepushnotification');
        $user = $usersTable->find($id)->current();

        $db = $usersTable->getAdapter();
        $db->beginTransaction();

        try {
            $user->delete();
            $db->commit();
        } catch (Exception $e) {
            $db->rollBack();
            throw $e;
        }
        return $this->_forward('success', 'utility', 'core', array(
                    'smoothboxClose' => 10,
                    'parentRefresh' => 10,
                    'messages' => array('')
        ));
    }

    public function deleteSentNotificationAction() {
        $this->_helper->layout->setLayout('admin-simple');
        $this->view->notification_id = $this->_getParam('notification_id');

        if (!$this->getRequest()->isPost()) {
            return;
        }

        $id = $this->_getParam('confirm');
        $table = Engine_Api::_()->getDbtable('notifications', 'sitepushnotification');
        $notification = $table->find($id)->current();

        $db = $table->getAdapter();
        $db->beginTransaction();

        try {
            $notification->delete();
            $db->commit();
        } catch (Exception $e) {
            $db->rollBack();
            throw $e;
        }
        return $this->_forward('success', 'utility', 'core', array(
                    'smoothboxClose' => 10,
                    'parentRefresh' => 10,
                    'messages' => array('')
        ));
    }

    public function editNotificationAction() {
        $this->_helper->layout->setLayout('admin-simple');

        $form = new Sitepushnotification_Form_Admin_Create;

        $form->removeElement('submit');

        $form->addElement('Button', 'submit', array(
            'order' => 13,
            'label' => 'Save',
            'type' => 'submit'));

        $form->addElement('Hidden', 'message_id', array(
            'label' => 'Redirecting URL',
            'description' => 'Enter the URL you want to redirect to when user clicks on the notification',
            'value' => $this->_getParam('message_id'),
        ));

        $notificationData = Engine_Api::_()->getItem('sitepushnotification_schedulednotification', $this->_getParam('message_id'));
        $form->populate($notificationData->toArray());
        $form->setTitle('Edit Push Notification');
        $form->setDescription('Using this form, you will be able to send a push notification out to your subscribers by choosing robust targeting options for who should receive your push notification based on "Member Levels" and "Networks", depending on which of these are being used on your site. You can also choose to send push notification to particular subscribers by choosing their names from the auto-suggest box. You can also schedule them on later date, to be sent.
            <br><br>
          Note: The push notification title and message should both be short and crisp. Also, the push notification will only be sent to those who have allowed push notifications for their browsers.');

        $this->view->form = $form;

        if (!$this->getRequest()->isPost()) {
            return;
        }

        if (!$form->isValid($this->getRequest()->getPost())) {
            $this->renderScript('admin-settings/form.tpl');
            return;
        }

        $params = $form->getValues();

        $notificationsTable = Engine_Api::_()->getDbtable('schedulednotifications', 'sitepushnotification');
        $notification = $notificationsTable->find($params['message_id'])->current();

        $db = $notificationsTable->getAdapter();
        $db->beginTransaction();

        try {
            $notification->setFromArray($params);
            $notification->save();
            $db->commit();
        } catch (Exception $e) {
            $db->rollBack();
            throw $e;
        }

        return $this->_forward('success', 'utility', 'core', array(
                    'smoothboxClose' => 10,
                    'parentRefresh' => 10,
                    'messages' => array('')
        ));
    }

    public function unsubscribeUserAction() {
        $this->_helper->layout->setLayout('admin-simple');
        $this->view->subscription_id = $this->_getParam('subscription_id');

        if (!$this->getRequest()->isPost()) {
            return;
        }

        $id = $this->_getParam('confirm');
        $usersTable = Engine_Api::_()->getDbtable('users', 'sitepushnotification');
        $user = $usersTable->find($id)->current();

        $db = $usersTable->getAdapter();
        $db->beginTransaction();

        try {
            $user->delete();
            $db->commit();
        } catch (Exception $e) {
            $db->rollBack();
            throw $e;
        }
        return $this->_forward('success', 'utility', 'core', array(
                    'smoothboxClose' => 10,
                    'parentRefresh' => 10,
                    'messages' => array('')
        ));
    }

    public function deleteselectedAction()
    {

      $this->view->ids = $ids = $this->_getParam('ids');
      $count = explode(",", $ids);
      $this->view->count = count($count);
      if( $this->getRequest()->isPost() ) {
        $ids_array = explode(",", $ids);

        foreach ($ids_array as $value) {
          Engine_Api::_()->getDbtable('notifications', 'sitepushnotification')->deleteByPushId($value);
        }

        $this->_forward('success', 'utility', 'core', array(
          'smoothboxClose' => 10,
          'parentRefresh' => 10,
          'messages' => array('')
        ));
      }
    }

}
