<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitepushnotification
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 6590 2016-3-3 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitepushnotification_Installer extends Engine_Package_Installer_Module {

    function onInstall() {
        $db = $this->getDb();

        $this->removeAlreadyPlacedWidget();
        $isFacelightEnabled = $this->checkFacelightTheme();

        if (!$isFacelightEnabled) {
                //START: PUT SUBSCRIPTION WIDGET AUTOMATICALLY AT FOOTER
                $select = new Zend_Db_Select($db);
                $select->from('engine4_core_pages')
                        ->where('name = ?', 'footer')
                        ->limit(1);
                $page_id = $select->query()->fetchObject()->page_id;
                if (!empty($page_id)) {
                    $select = new Zend_Db_Select($db);
                    $select_content = $select
                            ->from('engine4_core_content')
                            ->where('page_id = ?', $page_id)
                            ->where('type = ?', 'widget')
                            ->where('name = ?', 'sitepushnotification.push-subscription')
                            ->limit(1);

                    if(!empty($select_content->query()->fetchObject())){
                        $content_id = $select_content->query()->fetchObject()->content_id;
                    }
                    if (empty($content_id)) {
                        $select = new Zend_Db_Select($db);
                        $select_top = $select
                                ->from('engine4_core_content')
                                ->where('page_id = ?', $page_id)
                                ->where('type = ?', 'container')
                                ->where('name = ?', 'main')
                                ->limit(1);
                        $top_id = $select_top->query()->fetchObject()->content_id;
                        if (!empty($top_id)) {
                            $select = new Zend_Db_Select($db);
                            $db->insert('engine4_core_content', array(
                                'page_id' => $page_id,
                                'type' => 'widget',
                                'name' => 'sitepushnotification.push-subscription',
                                'parent_content_id' => $top_id,
                                'order' => 0,
                                'params' => '',
                            ));
                        }
                    }
                }

                // POPUP WIDGET
                $select = new Zend_Db_Select($db);
                $select->from('engine4_core_pages')
                        ->where('name = ?', 'footer')
                        ->limit(1);
                $page_id = $select->query()->fetchObject()->page_id;
                if (!empty($page_id)) {
                    $select = new Zend_Db_Select($db);
                    $select_content = $select
                            ->from('engine4_core_content')
                            ->where('page_id = ?', $page_id)
                            ->where('type = ?', 'widget')
                            ->where('name = ?', 'sitepushnotification.push-notification-popup')
                            ->limit(1);
                    if(!empty($select_content->query()->fetchObject())){
                        $content_id = $select_content->query()->fetchObject()->content_id;
                    }
                    if (empty($content_id)) {
                        $select = new Zend_Db_Select($db);
                        $select_top = $select
                                ->from('engine4_core_content')
                                ->where('page_id = ?', $page_id)
                                ->where('type = ?', 'container')
                                ->where('name = ?', 'main')
                                ->limit(1);
                        $top_id = $select_top->query()->fetchObject()->content_id;
                        if (!empty($top_id)) {
                            $select = new Zend_Db_Select($db);
                            $db->insert('engine4_core_content', array(
                                'page_id' => $page_id,
                                'type' => 'widget',
                                'name' => 'sitepushnotification.push-notification-popup',
                                'parent_content_id' => $top_id,
                                'order' => 0,
                                'params' => '',
                            ));
                        }
                    }
                }
                
                // CHECK IF THERE IS WIDGET PLACED IN THE LANDING PAGE
                $select = new Zend_Db_Select($db);
                $select->from('engine4_core_pages')
                        ->where('name = ?', 'core_index_index')
                        ->limit(1);
                $page_id = $select->query()->fetchObject()->page_id;
                if (!empty($page_id)) {
                    $layout = $select->query()->fetchObject()->layout;
                    if ($layout == 'default-simple') {
                        $select = new Zend_Db_Select($db);
                        $select_content = $select
                                ->from('engine4_core_content')
                                ->where('page_id = ?', $page_id)
                                ->where('type = ?', 'widget')
                                ->where('name = ?', 'sitepushnotification.push-subscription')
                                ->limit(1);
                        $content_id = $select_content->query()->fetchObject()->content_id;
                        if (empty($content_id)) {
                            $select = new Zend_Db_Select($db);
                            $select_top = $select
                                    ->from('engine4_core_content')
                                    ->where('page_id = ?', $page_id)
                                    ->where('type = ?', 'container')
                                    ->where('name IN(?)', array('left','middle','right'))
                                    ->limit(1);
                            $top_id = $select_top->query()->fetchObject()->content_id;
                            if (!empty($top_id)) {
                                $select = new Zend_Db_Select($db);
                                $db->insert('engine4_core_content', array(
                                    'page_id' => $page_id,
                                    'type' => 'widget',
                                    'name' => 'sitepushnotification.push-subscription',
                                    'parent_content_id' => $top_id,
                                    'order' => 0,
                                    'params' => '',
                                ));
                            }
                        }

                        $select = new Zend_Db_Select($db);
                        $select_content = $select
                                ->from('engine4_core_content')
                                ->where('page_id = ?', $page_id)
                                ->where('type = ?', 'widget')
                                ->where('name = ?', 'sitepushnotification.push-notification-popup')
                                ->limit(1);
                        $content_id = $select_content->query()->fetchObject()->content_id;
                        if (empty($content_id)) {
                            $select = new Zend_Db_Select($db);
                            $select_top = $select
                                    ->from('engine4_core_content')
                                    ->where('page_id = ?', $page_id)
                                    ->where('type = ?', 'container')
                                    ->where('name IN(?)', array('left','middle','right'))
                                    ->limit(1);
                            $top_id = $select_top->query()->fetchObject()->content_id;
                            if (!empty($top_id)) {
                                $select = new Zend_Db_Select($db);
                                $db->insert('engine4_core_content', array(
                                    'page_id' => $page_id,
                                    'type' => 'widget',
                                    'name' => 'sitepushnotification.push-notification-popup',
                                    'parent_content_id' => $top_id,
                                    'order' => 0,
                                    'params' => '',
                                ));
                            }
                        }
                    }
                }
        }


        //ENTER THE ERROR COLUMN IN THE NOTIFICATIONS TABLE
        $notificationsTableExists = $this->isTableExist('engine4_sitepushnotification_notifications');

        if ($notificationsTableExists) {
            $errorColumnExists = $this->isColumnExist('engine4_sitepushnotification_notifications','error');
            if (!$errorColumnExists) {
                $db->query("ALTER TABLE `engine4_sitepushnotification_notifications` ADD `error` text;");
            }
            $pushIdColumnExists = $this->isColumnExist('engine4_sitepushnotification_notifications','push_id');
            if ($pushIdColumnExists) {
                $db->query("ALTER TABLE `engine4_sitepushnotification_notifications` CHANGE `push_id` `notification_id` INT(11) NOT NULL AUTO_INCREMENT;");
            }
        }

        // $db->query("UPDATE `engine4_core_menuitems` SET `label` = 'Send Push Notification' , `order`= '2' where name='spn_admin_main_createnotification' and module='sitepushnotification';");
        // $db->query("UPDATE `engine4_core_menuitems` SET `order`= '3' where name='spn_admin_main_managenotifications' and module='sitepushnotification';");
        // $db->query("UPDATE `engine4_core_menuitems` SET `label` = 'Manage Subscribers',`order`= '4' where name='spn_admin_main_manageusers' and module='sitepushnotification';");

        // Update menuitems name ----
        $db->query("UPDATE `engine4_core_menuitems` SET `name` = 'spn_admin_main_settings' WHERE name='sitepushnotification_admin_main_settings' AND module='sitepushnotification';");
        $db->query("UPDATE `engine4_core_menuitems` SET `name` = 'spn_admin_main_createnotification' WHERE name='sitepushnotification_admin_main_createnotification' AND module='sitepushnotification';");
        $db->query("UPDATE `engine4_core_menuitems` SET `name` = 'spn_admin_main_managenotifications' WHERE name='sitepushnotification_admin_main_managenotifications' AND module='sitepushnotification';");
        $db->query("UPDATE `engine4_core_menuitems` SET `name` = 'spn_admin_main_manageusers' WHERE name='sitepushnotification_admin_main_manageusers' AND module='sitepushnotification';");
        $db->query("UPDATE `engine4_core_menuitems` SET `name` = 'spn_admin_main_httpsbenefits' WHERE name='sitepushnotification_admin_main_httpsbenefits' AND module='sitepushnotification';");
        $db->query("UPDATE `engine4_core_menuitems` SET `name` = 'spn_admin_main_settings_general' WHERE name='sitepushnotification_admin_main_settings_general' AND module='sitepushnotification';");
        $db->query("UPDATE `engine4_core_menuitems` SET `name` = 'spn_admin_main_settings_fcm' WHERE name='sitepushnotification_admin_main_settings_fcm' AND module='sitepushnotification';");
        $db->query("UPDATE `engine4_core_menuitems` SET `name` = 'spn_admin_main_settings_welcome' WHERE name='sitepushnotification_admin_main_settings_welcome' AND module='sitepushnotification';");
        $db->query("UPDATE `engine4_core_menuitems` SET `name` = 'spn_admin_main_managenotifications_sent' WHERE name='sitepushnotification_admin_main_managenotifications_sent' AND module='sitepushnotification';");
        $db->query("UPDATE `engine4_core_menuitems` SET `name` = 'spn_admin_main_managenotifications_scheduled' WHERE name='sitepushnotification_admin_main_managenotifications_scheduled' AND module='sitepushnotification';");
        
        // Update menuitems parent menu name ----
        $db->query("UPDATE `engine4_core_menuitems` SET `menu` = 'spn_admin_main_settings' where menu='sitepushnotification_admin_main_settings' and module='sitepushnotification';");
        $db->query("UPDATE `engine4_core_menuitems` SET `menu` = 'spn_admin_main' where menu='sitepushnotification_admin_main' and module='sitepushnotification';");
        $db->query("UPDATE `engine4_core_menuitems` SET `menu` = 'spn_admin_main_managenotifications' where menu='sitepushnotification_admin_main_managenotifications' and module='sitepushnotification';");

        parent::onInstall();
    }

    public function isTableExist($tableName) {
        $db = $this->getDb();
        $result = $db->query('SHOW TABLES LIKE \'' . $tableName . '\'')->fetch();
        if (empty($result)) {
            return false;
        }
        return true;
    }

    function isColumnExist($table, $column) {
        $db = $this->getDb();

        $columnName = $db->query("
        SHOW COLUMNS FROM `$table`
           LIKE '$column'")->fetch();
        if (!empty($columnName))
            return true;
        return false;
    }

    function removeAlreadyPlacedWidget() {
        $db = $this->getDb();

        // remove from member home page
        $select = new Zend_Db_Select($db);
        $select->from('engine4_core_pages')
            ->where('name = ?', 'user_index_home')
            ->limit(1);
        $page_id = $select->query()->fetchObject()->page_id;

        if (!empty($page_id)) {
            $db->delete('engine4_core_content', array(
                'page_id = ?' =>  $page_id,
                'type = ?' => 'widget',
                'name = ?'=>'sitepushnotification.push-subscription',
            ));
        }

        // remove from landing page
        $select = new Zend_Db_Select($db);
        $select->from('engine4_core_pages')
            ->where('name = ?', 'core_index_index')
            ->limit(1);
        $page_id = $select->query()->fetchObject()->page_id;

        if (!empty($page_id)) {
            $db->delete('engine4_core_content', array(
                'page_id = ?' =>  $page_id,
                'type = ?' => 'widget',
                'name = ?' => 'sitepushnotification.push-subscription',
            ));
        }
    }

    function checkFacelightTheme() {

        $db = $this->getDb();

        // Set widget in case facelight theme is enabled
        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_modules')
                ->where('name = ?', 'facelight') 
                ->where('enabled = ?', 1);
        $isfacelightmoduleenabled = $select->query()->fetchObject();

        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_themes')
                ->where('name = ?', 'facelight') 
                ->where('active = ?', 1);
        $isfacelightthemeenabled = $select->query()->fetchObject();

        if (!empty($isfacelightmoduleenabled) && !empty($isfacelightthemeenabled)) {
            //START: PUT SUBSCRIPTION WIDGET AUTOMATICALLY AT FOOTER
            $select = new Zend_Db_Select($db);
            $select->from('engine4_core_pages')
                    ->where('name = ?', 'facelight_dashboard_panel')
                    ->limit(1);
            $page_id = $select->query()->fetchObject()->page_id;
            if (!empty($page_id)) {
                $select = new Zend_Db_Select($db);
                $select_content = $select
                        ->from('engine4_core_content')
                        ->where('page_id = ?', $page_id)
                        ->where('type = ?', 'widget')
                        ->where('name = ?', 'sitepushnotification.push-subscription')
                        ->limit(1);
                $content_id = $select_content->query()->fetchObject()->content_id;
                if (empty($content_id)) {
                    $select = new Zend_Db_Select($db);
                    $select_top = $select
                            ->from('engine4_core_content')
                            ->where('page_id = ?', $page_id)
                            ->where('type = ?', 'container')
                            ->where('name = ?', 'middle')
                            ->limit(1);
                    $top_id = $select_top->query()->fetchObject()->content_id;
                    if (!empty($top_id)) {
                        $select = new Zend_Db_Select($db);
                        $db->insert('engine4_core_content', array(
                            'page_id' => $page_id,
                            'type' => 'widget',
                            'name' => 'sitepushnotification.push-subscription',
                            'parent_content_id' => $top_id,
                            'order' => 0,
                            'params' => '',
                        ));
                    }
                }
            }

            // POPUP WIDGET
            $select = new Zend_Db_Select($db);
            $select->from('engine4_core_pages')
                    ->where('name = ?', 'facelight_dashboard_panel')
                    ->limit(1);
            $page_id = $select->query()->fetchObject()->page_id;
            if (!empty($page_id)) {
                $select = new Zend_Db_Select($db);
                $select_content = $select
                        ->from('engine4_core_content')
                        ->where('page_id = ?', $page_id)
                        ->where('type = ?', 'widget')
                        ->where('name = ?', 'sitepushnotification.push-notification-popup')
                        ->limit(1);
                $content_id = $select_content->query()->fetchObject()->content_id;
                if (empty($content_id)) {
                    $select = new Zend_Db_Select($db);
                    $select_top = $select
                            ->from('engine4_core_content')
                            ->where('page_id = ?', $page_id)
                            ->where('type = ?', 'container')
                            ->where('name = ?', 'middle')
                            ->limit(1);
                    $top_id = $select_top->query()->fetchObject()->content_id;
                    if (!empty($top_id)) {
                        $select = new Zend_Db_Select($db);
                        $db->insert('engine4_core_content', array(
                            'page_id' => $page_id,
                            'type' => 'widget',
                            'name' => 'sitepushnotification.push-notification-popup',
                            'parent_content_id' => $top_id,
                            'order' => 0,
                            'params' => '',
                        ));
                    }
                }
            }
            return true;
        } else  {
            return false;
        }
    }

}
