<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitepushnotification
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: manifest.php 6590 2016-3-3 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
return array(
    'package' =>
    array(
        'type' => 'module',
        'name' => 'sitepushnotification',
        'sku' => 'seao-sitepushnotification',
        'version' => '5.7.1',
        'path' => 'application/modules/Sitepushnotification',
        'title' => 'Browser Push Notifications',
        'description' => 'Push Notifications allows to get prior information without getting in touch with the content, saving lots of time as it does not require to re-check the real time updates now and then. It is a very useful tool to converts your visitors into your website users and increase effective engagements with your users on your community websites.',
        'author' => '<a href="http://www.socialapps.tech" style="text-decoration:underline;" target="_blank">SocialApps.tech</a>',
        'callback' =>
        array(
            'path' => 'application/modules/Sitepushnotification/settings/install.php',
            'class' => 'Sitepushnotification_Installer',
        ),
        'actions' =>
        array(
            0 => 'install',
            1 => 'upgrade',
            2 => 'refresh',
            3 => 'enable',
            4 => 'disable',
        ),
        'dependencies' => array(
          array(
            'type' => 'module',
            'name' => 'core',
            'minVersion' => '4.10.3',
          ),
        ),
        'directories' =>
        array(
            0 => 'application/modules/Sitepushnotification',
            1 => 'application/libraries/Zend/WebPush',
            2 => 'application/libraries/Zend/WebPush/Message',
            3 => 'application/libraries/WebPushAPNS',
        ),
        'files' =>
        array(
            0 => 'application/languages/en/sitepushnotification.csv',
            1 => 'firebase-messaging-sw.js',
        ),
    ),
    'items' => array(
        'sitepushnotification_user',
        'sitepushnotification_notification',
        'sitepushnotification_schedulednotification',
        'sitepushnotification_setting'
    ),
    'hooks' => array(
      array(
        'event' => 'onActivityNotificationCreateAfter',
        'resource' => 'Sitepushnotification_Plugin_Pushnotification',
      ),
      array(
        'event' => 'onRenderLayoutDefault',
        'resource' => 'Sitepushnotification_Plugin_Core'
      ),
      array(
        'event' => 'onRenderLayoutMobileDefault',
        'resource' => 'Sitepushnotification_Plugin_Core',
      ),
    ),
);
?>