<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitequicksignup
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: SignupController.php 2017-03-16 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitequicksignup_Api_Siteapi_Core extends User_Api_Core  {
    private $_profileFieldsArray = array();
    private $_validateSearchProfileFields = false;
    // protected $_signupForm;
    // protected $_signupForm;
    public static $_tabIndex = 100;
    /**
     * Get the "User Signup" form.
     * 
     * @return array
     */

    public function getSignupForm() {
        if(Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitequicksignup'))
        {   
            $enableOtp = Engine_Api::_()->getApi('Siteapi_Core', 'user')->hasEnableOtp();
            if($enableOtp)
                $accountForm['isOTPEnabled'] = 1;
            if (_CLIENT_TYPE && (_CLIENT_TYPE == 'ios') && Engine_Api::_()->getApi('settings', 'core')->getSetting('sitequicksignup.subscription.enabled', 1) ) {
                $accountForm['subscription'] = $this->_getChooseSubscriptionForm();
                $accountForm['isSubscriptionEnabled'] = true;

            }
            $settings = Engine_Api::_()->getApi('settings', 'core');
            $accountForm['layoutType'] = 2;
            $formTitle = $settings->getSetting('sitequicksignup.title', 'Create Account');
            if($settings->getSetting('sitequicksignup.allow.title'))
                $accountForm['formTitle'] =$formTitle;
            $formDescription = $settings->getSetting('sitequicksignup.description', '');
            if(!empty($formDescription) && $settings->getSetting('sitequicksignup.allow.description'))   {
                $accountForm['formDescription'] = $formDescription;
            } 

            $accountForm['photo_field'] = $settings->getSetting('sitequicksignup.photo.upload');

            $isEmailVerificationEnable = Engine_Api::_()->getApi('settings', 'core')->getSetting('user.signup.verifyemail', 0);
            $accountForm['isEmailVerificationEnable'] = 0;
            if (($isEmailVerificationEnable == 2) && ($isEmailVerificationEnable == 3))
                $accountForm['isEmailVerificationEnable'] = 1;

            $accountForm['form'] = $this->_getSignupAccountForm();
            $accountForm['fields'] = $this->_getUserProfileFields();
        }
        else {
            
            $accountForm = Engine_Api::_()->getApi('Siteapi_Core','user')->getSignupForm();

            
            
        }
        
        return $accountForm;
    }
    
    public function  _getSignupAccountForm() {
        $enableOtp = Engine_Api::_()->getApi('Siteapi_Core', 'user')->hasEnableOtp();
        $accountForm = array();
        $settings = Engine_Api::_()->getApi('settings', 'core');

        if (_CLIENT_TYPE && (_CLIENT_TYPE == 'android') && Engine_Api::_()->getApi('settings', 'core')->getSetting('sitequicksignup.subscription.enabled', 1) ) {
        $accountForm = $this->_getChooseSubscriptionForm();

        }
        // Profile type
        $profileFields = $this->getProfileTypes();
        if (!empty($profileFields)) {
            $this->_profileFieldsArray = $profileFields;
            if (COUNT($profileFields) > 1) {
                $accountForm[] = array(
                    'type' => 'Select',
                    'name' => 'profile_type',
                    'leftDrawable' => 'setting',
                    'hasSubForm' => true,
                    'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Profile Type'),
                    'multiOptions' => $profileFields,
                    'hasValidator' => true
                );
            }
            else
                $accountForm = $this->_getUserProfileFields($accountForm);
        }
        $emailFieldName = 'email';
        if($enableOtp)  {
        $showBothPhoneAndEmail = $settings->getSetting('siteotpverifier.singupShowBothPhoneAndEmail', 1);
        $countrycodes = Engine_Api::_()->getApi('core', 'siteotpverifier')->countryCode();
        $countrycodes = array_keys($countrycodes);
        $countrycodes = array_combine($countrycodes, $countrycodes);
        $reqphoneno = !empty($showBothPhoneAndEmail) && $settings->getSetting('siteotpverifier.singupRequirePhone', 1);
        if (!empty($showBothPhoneAndEmail)) {
            // Element: email
            $accountForm[] = array(
                'type' => 'Text',
                'name' => $emailFieldName,
                'leftDrawable' => 'email',
                'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Email Address'),
                'hasValidator' => true
            );

            ksort($countrycodes);
            $accountForm[] = array(
                'type' => 'select',
                'name' => 'country_code',
                'leftDrawable' => 'web',
                'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Country Code'),
                'multiOptions' => $countrycodes,
                'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteotpverifier.defaultCountry', '+1'),
            );

            $accountForm[] = array(
                'type' => 'Text',
                'name' => 'phoneno',
                'leftDrawable' => 'phone',
                'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Phone Number'),
                'description' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitequicksignup.field.description', 1) ? Engine_Api::_()->getApi('Core', 'siteapi')->translate('Enter phone no with country code.') : '',
                'hasValidator' => !empty($reqphoneno) ? true : false
            );
        } else {
                ksort($countrycodes);
                $accountForm[] = array(
                    'type' => 'select',
                    'name' => 'country_code',
                    'leftDrawable' => 'web',
                    'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Country Code'),
                    'multiOptions' => $countrycodes,
                    'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteotpverifier.defaultCountry', '+1'),
                    
                );
                $emailFieldName = 'emailaddress';
                $accountForm[] = array(
                    'type' => 'Text',
                    'name' => $emailFieldName,
                    'leftDrawable' => 'email',
                    'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Email or Mobile Number'),
                   
                    'hasValidator' => true
                );
            }
        } else {
        $accountForm[]= array(
            'name' => $emailFieldName,
            'type' => 'Text',
            'hasValidator' => true,
            'leftDrawable' => 'email',
            'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Email Address'),
           
        );
    }
    if (!empty($_REQUEST['email'])) {
            $position = $this->_getFieldPositionByName($accountForm, $emailFieldName);
            $accountForm[$position]['value'] = $_REQUEST['email']; 
    }
        if (Engine_Api::_()->getApi('settings', 'core')->getSetting('sitequicksignup.confirm.email', 0)) {
            $accountForm[] = array(
                'name' => "emailconf",
                'type' => "Text",
                'leftDrawable' => 'email',
                'label' => 'Email Again',
                'hasValidator' => true,
                'description' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitequicksignup.field.description', 1) ? 'Enter your email again for confirmation.' : '',
                
            );
        }
        if ($settings->getSetting('user.signup.inviteonly') > 0) {
            $accountForm[] = array(
                'name' => 'code',
                'type' => 'Text',
                'label' => 'Invite Code',
                'leftDrawable' => 'default',
                'hasValidator'
            );
        }
      
        if ($settings->getSetting('sitequicksignup.signup.random', 0) == 0 && empty($_REQUEST['facebook_uid']) && empty($_REQUEST['twitter_uid']) && empty($_REQUEST['apple_id']) && empty($_REQUEST['google_id']))    {
            $accountForm[]= array(
                'name' => 'password',
                'type' => 'Password',
                'leftDrawable' => 'key',
                'textVisibility' => 1,
                'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Password'),
                'description' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitequicksignup.field.description', 1) ? 'Passwords must be at least 6 characters in length.' : '',
                'hasValidator' => true,
               
            );
            if (Engine_Api::_()->getApi('settings', 'core')->getSetting('sitequicksignup.confirm.password', 1)) {
                // Element: passconf
                $accountForm[] = array(
                    'label' => 'Password Again',
                    'name' => 'passconf',
                    'leftDrawable' => 'key',
                    'textVisibility' => 1,
                    'type' => 'Password',
                    'hasValidator' => true,
                    'description' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitequicksignup.field.description', 1) ? 'Enter your password again for confirmation.' : '',
                    'required' => true,
                    'allowEmpty' => false
                );
            }
        }
        
        if ($settings->getSetting('user.signup.username', 1) > 0) {
            $accountForm[]= array(
                'name' => 'username',
                'type' => 'Text',
                'hasValidator' => true,
                'leftDrawable' => 'user',
                'label' => 'Profile Address',
                'description' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitequicksignup.field.description', 1) ? $description : '',
                'hasValidator' => true
            );
        }
         if (Engine_Api::_()->getApi('settings', 'core')->getSetting('sitequicksignup.timezone', 0)) {

            $accountForm[] = array(
                'type' => 'Select',
                'name' => 'timezone',
                'leftDrawable' => 'timer',
                'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Timezone'), 

                'multiOptions' => array(
                    'US/Pacific' => '(UTC-8) Pacific Time (US & Canada)',
                    'US/Mountain' => '(UTC-7) Mountain Time (US & Canada)',
                    'US/Central' => '(UTC-6) Central Time (US & Canada)',
                    'US/Eastern' => '(UTC-5) Eastern Time (US & Canada)',
                    'America/Halifax' => '(UTC-4)  Atlantic Time (Canada)',
                    'America/Anchorage' => '(UTC-9)  Alaska (US & Canada)',
                    'Pacific/Honolulu' => '(UTC-10) Hawaii (US)',
                    'Pacific/Samoa' => '(UTC-11) Midway Island, Samoa',
                    'Etc/GMT-12' => '(UTC-12) Eniwetok, Kwajalein',
                    'Canada/Newfoundland' => '(UTC-3:30) Canada/Newfoundland',
                    'America/Buenos_Aires' => '(UTC-3) Brasilia, Buenos Aires, Georgetown',
                    'Atlantic/South_Georgia' => '(UTC-2) Mid-Atlantic',
                    'Atlantic/Azores' => '(UTC-1) Azores, Cape Verde Is.',
                    'Europe/London' => 'Greenwich Mean Time (Lisbon, London)',
                    'Europe/Berlin' => '(UTC+1) Amsterdam, Berlin, Paris, Rome, Madrid',
                    'Europe/Athens' => '(UTC+2) Athens, Helsinki, Istanbul, Cairo, E. Europe',
                    'Europe/Moscow' => '(UTC+3) Baghdad, Kuwait, Nairobi, Moscow',
                    'Iran' => '(UTC+3:30) Tehran',
                    'Asia/Dubai' => '(UTC+4) Abu Dhabi, Kazan, Muscat',
                    'Asia/Kabul' => '(UTC+4:30) Kabul',
                    'Asia/Yekaterinburg' => '(UTC+5) Islamabad, Karachi, Tashkent',
                    'Asia/Calcutta' => '(UTC+5:30) Bombay, Calcutta, New Delhi',
                    'Asia/Katmandu' => '(UTC+5:45) Nepal',
                    'Asia/Omsk' => '(UTC+6) Almaty, Dhaka',
                    'Indian/Cocos' => '(UTC+6:30) Cocos Islands, Yangon',
                    'Asia/Krasnoyarsk' => '(UTC+7) Bangkok, Jakarta, Hanoi',
                    'Asia/Hong_Kong' => '(UTC+8) Beijing, Hong Kong, Singapore, Taipei',
                    'Asia/Tokyo' => '(UTC+9) Tokyo, Osaka, Sapporto, Seoul, Yakutsk',
                    'Australia/Adelaide' => '(UTC+9:30) Adelaide, Darwin',
                    'Australia/Sydney' => '(UTC+10) Brisbane, Melbourne, Sydney, Guam',
                    'Asia/Magadan' => '(UTC+11) Magadan, Solomon Is., New Caledonia',
                    'Pacific/Auckland' => '(UTC+12) Fiji, Kamchatka, Marshall Is., Wellington',
                ),
                'hasValidator' => true
        );

            if (!empty($_REQUEST['timezone'])) {
                $position = $this->_getFieldPositionByName($accountForm, 'timezone');
                $accountForm[$position]['value'] = $_REQUEST['timezone']; 
            }
        }
        // Element: Languages
        $translate = Zend_Registry::get('Zend_Translate');
        $languageList = $translate->getList();
        $defaultLanguage = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.locale.locale', 'en');
        if (!in_array($defaultLanguage, $languageList)) {

            if ($defaultLanguage == 'auto' && isset($languageList['en'])) {
                $defaultLanguage = 'en';

            } else {
                $defaultLanguage = null;
            }
        }

        $languageNameList = array();
        foreach ($languageList as $localeCode) {
            $languageNameList[$localeCode] = Zend_Locale::getTranslation($localeCode, 'language', $localeCode);

            if (empty($languageNameList[$localeCode])) {

                list($locale, $territory) = explode('_', $localeCode);
               $temp_language = "{$territoryDataList[$territory]} {$languageDataList[$locale]}";
               if(trim($temp_language))
                 $languageNameList[$localeCode] = $temp_language;
             else
                 unset($languageNameList[$localeCode]);
            }
        }
       
        $languageNameList = array_merge(array(
            $defaultLanguage => $defaultLanguage
                ), $languageNameList);
        
        if (count($languageNameList) > 1 && Engine_Api::_()->getApi('settings', 'core')->getSetting('sitequicksignup.language', 1)) {

            $accountForm[] = array(
                'type' => 'Select',
                'name' => 'language',
                'leftDrawable' => 'default',
                'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Language'),
                'multiOptions' => $languageNameList,
                'hasValidator' => true
                
            );
        }
        

        $require_photo = $settings->getSetting('sitequicksignup.photo.upload', 'optional');
        if(_CLIENT_TYPE && (_CLIENT_TYPE == 'ios') && !empty( $require_photo )) {
            if ($require_photo == 'optional')
                $accountForm[] = array(
                        'type' => 'File',
                        'name' => 'photo',
                        'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Add Your Photo'),
                        'hasValidator' => false
                );
            elseif ($require_photo == 'required')
                $accountForm[] = array(
                    'type' => 'File',
                    'name' => 'photo',
                    'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Add Your Photo'),
                    'hasValidator' => true
                );
        }
               // Element: terms
        if ($settings->getSetting('user.signup.terms', 1) == 1) {
            if(_CLIENT_TYPE && (_CLIENT_TYPE == 'ios')){
                $accountForm[] = array(
                    'type' => 'Checkbox',
                    'name' => 'terms',
                    'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('I have read and agree to the terms of service.'),
                    'description' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('I have read and agree to the terms of service.'),
                    'hasValidator' => true
                );
            }


            if (_CLIENT_TYPE && ((_CLIENT_TYPE == 'ios' && _IOS_VERSION > '1.5.5') || (_CLIENT_TYPE == 'android' && _ANDROID_VERSION >= '1.7.1'))) {
                $getHost = Engine_Api::_()->getApi('Core', 'siteapi')->getHost();
                $baseParentUrl = Zend_Controller_Front::getInstance()->getBaseUrl();
                $baseParentUrl = @trim($baseParentUrl, "/");
                $table = (_CLIENT_TYPE === 'ios') ? Engine_Api::_()->getDbtable('menus', 'siteiosapp') : Engine_Api::_()->getDbtable('menus', 'siteandroidapp');
                $select = $table->select()
                        ->where('status = ?', 1)
                        ->where('name = ?', 'terms_of_service')
                        ->limit(1);

                $menu = $table->fetchRow($select);

                if (($menu->name == 'terms_of_service')) {
                    if (empty($menu->url))
                        $url = (!empty($baseParentUrl)) ? $getHost . DIRECTORY_SEPARATOR . $baseParentUrl . DIRECTORY_SEPARATOR . 'help/terms' : $getHost . DIRECTORY_SEPARATOR . 'help/terms';
                    else
                        $url = $menu->url;
                }

                if (isset($url) && !empty($url)) {
                    $accountForm[] = array(
                        'type' => 'Dummy',
                        'name' => 'terms_url',
                        'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Click here to read the terms of service.'),
                        'url' => $url
                    );
                }
            }
        }
        return $accountForm;
    }

    public function getProfileTypes($profileFields = array()) {
        $topStructure = Engine_Api::_()->fields()->getFieldStructureTop('user');
        if (count($topStructure) == 1 && $topStructure[0]->getChild()->type == 'profile_type') {
            $profileTypeField = $topStructure[0]->getChild();
            $options = $profileTypeField->getOptions();

            $options = $profileTypeField->getElementParams('user');
            if (isset($options['options']['multiOptions']) && !empty($options['options']['multiOptions']) && is_array($options['options']['multiOptions'])) {
                // Make exist profile fields array.         
                foreach ($options['options']['multiOptions'] as $key => $value) {
                    if (!empty($key)) {
                        $profileFields[$key] = $value;
                    }
                }
            }
        }
        return $profileFields;
    }

    private function _getUserProfileFields($fieldsForm = array(), $display = false) {
        // Set the translations for zend library.
        if (!Zend_Registry::isRegistered('Zend_Translate'))
            Engine_Api::_()->getApi('Core', 'siteapi')->setTranslate();

        foreach ($this->_profileFieldsArray as $option_id => $prfileFieldTitle) {
            if (!empty($option_id)) {

                $mapData = Engine_Api::_()->getApi('core', 'fields')->getFieldsMaps('user');
                $getRowsMatching = $mapData->getRowsMatching('option_id', $option_id);

                $fieldArray = array();
                $getFieldInfo = Engine_Api::_()->fields()->getFieldInfo();
                $getHeadingName = '';
                foreach ($getRowsMatching as $map) {
                    $meta = $map->getChild();
                    $type = $meta->type;

                    if (!empty($type) && ($type == 'heading')) {
                        $getHeadingName = $meta->label;
                        continue;
                    }

                    if (isset($display) && !empty($display) && $display) {
                        if (!isset($meta->display) || empty($meta->display))
                            continue;
                    }
                    else {
                        if (!isset($meta->show) || empty($meta->show))
                            continue;

                        if (!empty($this->_validateSearchProfileFields) && (!isset($meta->search) || empty($meta->search)))
                            continue;
                    }

                    $fieldForm = $getMultiOptions = array();
                    $key = $map->getKey();
                    // Findout respective form element field array.
                    if (isset($getFieldInfo['fields'][$type]) && !empty($getFieldInfo['fields'][$type])) {
                        $getFormFieldTypeArray = $getFieldInfo['fields'][$type];

                        // In case of Generic profile fields.
                        if (isset($getFormFieldTypeArray['category']) && ($getFormFieldTypeArray['category'] == 'generic')) {
                            // If multiOption enabled then perpare the multiOption array.
                            if (($type == 'select') || ($type == 'radio') || (isset($getFormFieldTypeArray['multi']) && !empty($getFormFieldTypeArray['multi']))) {
                                $getOptions = $meta->getOptions();
                                if (!empty($getOptions)) {
                                    if (!isset($meta->required) || empty($meta->required)) {
                                        $getMultiOptions[''] = '';
                                    }
                                    foreach ($getOptions as $option) {
                                        $getMultiOptions[$option->option_id] = $option->label;
                                    }
                                }
                            }
                            // Prepare Generic form.
                            $fieldForm['type'] = ucfirst($type);
                            if ($fieldForm['type'] == 'Multiselect') {
                                $fieldForm['type'] = "MultiCheckbox";
                            }
                            $fieldForm['name'] = $key . '_alias_' . $meta->alias;
                            $fieldForm['label'] = (isset($meta->label) && !empty($meta->label)) ? Engine_Api::_()->getApi('Core', 'siteapi')->translate($meta->label) : '';
                            if(($meta->alias == 'first_name')||($meta->alias == 'last_name'))
                            {   if(isset($_REQUEST[$meta->alias]))
                                    $fieldForm['value'] = $_REQUEST[$meta->alias];
                            }
                            $fieldForm['description'] = (isset($meta->description) && !empty($meta->description)) ? $meta->description : '';                
                            $fieldForm['leftDrawable'] = "default";

                            // Add multiOption, If available.
                            if (!empty($getMultiOptions)) {
                                $fieldForm['multiOptions'] = Engine_Api::_()->getApi('Core', 'siteapi')->translate($getMultiOptions);
                            }

                            // Add validator, If available.
                            if (isset($meta->required) && !empty($meta->required))
                                $fieldForm['hasValidator'] = true;

                            if (isset($fieldForm['name']) && !empty($fieldForm['name']) && strstr($fieldForm['name'], 'birthdate')){
                                $fieldForm['format'] = 'date(d-m-Y)';
                                if(isset($_REQUEST['birthdate']))
                                    $fieldForm['value'] = $_REQUEST['birthdate'];
                                $fieldForm['layoutType'] = 2;
                                $fieldForm['leftDrawable'] = "cake";
                            }

                            if (COUNT($this->_profileFieldsArray) > 1) {
                                if ($fieldForm['type'] == 'Multi_checkbox') {
                                    $fieldForm['type'] = 'MultiCheckbox';
                                }
                                 $fieldsForm["profile_type_".$option_id][]= $fieldForm;
                            } else {
                                if ($fieldForm['type'] == 'Multi_checkbox') {
                                    $fieldForm['type'] = 'MultiCheckbox';
                                }
                                $fieldsForm[]= $fieldForm;
                            }
                        } else if (isset($getFormFieldTypeArray['category']) && ($getFormFieldTypeArray['category'] == 'specific') && !empty($getFormFieldTypeArray['base'])) { // In case of Specific profile fields.
                            // Prepare Specific form.
                            $fieldForm['type'] = ucfirst($getFormFieldTypeArray['base']);
                            $fieldForm['name'] = $key . '_alias_' . $meta->alias;
                            $fieldForm['label'] = (isset($meta->label) && !empty($meta->label)) ? Engine_Api::_()->getApi('Core', 'siteapi')->translate($meta->label) : '';
                            if($meta->alias)
                                $fieldForm['leftDrawable'] = $meta->alias;
                            else
                                $fieldForm['leftDrawable'] = "default";
                            if(($meta->alias == 'first_name')||($meta->alias == 'last_name'))
                            {   if(isset($_REQUEST[$meta->alias]))
                                    $fieldForm['value'] = $_REQUEST[$meta->alias];
                                $fieldForm['leftDrawable'] = "user";
                            }
                            $fieldForm['description'] = (isset($meta->description) && !empty($meta->description)) ? Engine_Api::_()->getApi('Core', 'siteapi')->translate($meta->description) : '';

                            // Add multiOption, If available.
                            if ($getFormFieldTypeArray['base'] == 'select') {
                                $getOptions = $meta->getOptions();
                                // if (!isset($meta->required) || empty($meta->required)) {
                                //     $getMultiOptions[''] = '';
                                // }
                                foreach ($getOptions as $option) {
                                    $getMultiOptions[$option->option_id] = $option->label;
                                }

                                if(isset($_REQUEST['gender']))
                                    $fieldForm['value'] = $_REQUEST['gender'];
                                $fieldForm['leftDrawable'] = "gender";
                                $fieldForm['multiOptions'] = Engine_Api::_()->getApi('Core', 'siteapi')->translate($getMultiOptions);
                            }
                            if (isset($getFormFieldTypeArray['helper']) && !empty($getFormFieldTypeArray['helper']) && $getFormFieldTypeArray['helper'] == 'fieldOptions') {
                                $fieldForm['multiOptions'] = Engine_Api::_()->getApi('Core', 'siteapi')->translate($getFormFieldTypeArray['multiOptions']);
                            }
                            if (isset($getFormFieldTypeArray['helper']) && !empty($getFormFieldTypeArray['helper']) && $getFormFieldTypeArray['helper'] == 'fieldCountry') {

                                Engine_Api::_()->getApi('Core', 'siteapi')->setLocal();
                                // $locale = Zend_Registry::get('Zend_Translate')->getLocale();       
                                $locale = Engine_Api::_()->getApi('Core', 'siteapi')->getLocal();
                                try {
                                    $countries = Zend_Locale::getTranslationList('territory', $locale, 2);
                                    asort($countries);
                                    $fieldForm['multiOptions'] = $countries;
                                } catch (Exception $ex) {
                                    
                                }
                            }
                            // Add validator, If available.
                            if (isset($meta->required) && !empty($meta->required))
                                $fieldForm['hasValidator'] = true;

                            if (isset($fieldForm['name']) && !empty($fieldForm['name']) && strstr($fieldForm['name'], 'birthdate')){
                                $fieldForm['format'] = 'date(d-m-Y)';
                                if(isset($_REQUEST['birthdate']))
                                    $fieldForm['value'] = $_REQUEST['birthdate'];
                                $fieldForm['layoutType'] = 2;
                                $fieldForm['leftDrawable'] = "cake";
                            }
                            if (COUNT($this->_profileFieldsArray) > 1) {
                                if ($fieldForm['type'] == 'Multi_checkbox') {
                                    $fieldForm['type'] = 'MultiCheckbox';
                                }
                                $fieldsForm["profile_type_".$option_id][]= $fieldForm;
                            } else {
                                if ($fieldForm['type'] == 'Multi_checkbox') {
                                    $fieldForm['type'] = 'MultiCheckbox';
                                }
                                $fieldsForm[]= $fieldForm;
                            }
                        }
                    }                   
                }
            }
        }
        return $fieldsForm;
    }

    private function _getChooseSubscriptionForm() {
        $settings = Engine_Api::_()->getApi('settings', 'core');
        Engine_Api::_()->getApi('Core', 'siteapi')->setView();
        $showForm = 0;

        $stepTable = Engine_Api::_()->getDbtable('signup', 'sitequicksignup');
        $sitesubscriptionModuleEnable = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitesubscription');

        if($sitesubscriptionModuleEnable){
            $subscriptionClass = "Sitesubscription_Plugin_Signup_Subscription";
        }
        else{
            $subscriptionClass = "Payment_Plugin_Signup_Subscription";
        }
        $stepSelect = $stepTable->select()->where('class = ?', $subscriptionClass);
        $row = $stepTable->fetchRow($stepSelect);
        $enableSubscription = $row->enable;
        // Get available subscriptions
        $packagesTable = Engine_Api::_()->getDbtable('packages', 'payment');
        $packagesSelect = $packagesTable
                ->select()
                ->from($packagesTable)
                ->where('enabled = ?', true)
                ->where('signup = ?', true);

        ;
        $multiOptions = array();
        $packagesObj = $packagesTable->fetchAll($packagesSelect);
        $package_count = count($packagesObj);
       
        if ((count($packagesObj) > 0) && isset($enableSubscription) && !empty($enableSubscription)) {
            $showForm = 1;
        } elseif ((Engine_Api::_()->getDbtable('gateways', 'payment')->getEnabledGatewayCount() > 0 && Engine_Api::_()->getDbtable('packages', 'payment')->getEnabledNonFreePackageCount() > 0)) {
            $showForm = 1;
        }
        if(!empty($sitesubscriptionModuleEnable))
            $templateInfo = Engine_Api::_()->getApi('core','sitesubscription')->getTemplateData();
        try {   //@todo getLocal in $package->getPackageDescription()
            foreach ($packagesObj as $package) {
                $userCurrency = Engine_Api::_()->getApi('settings', 'core')->getSetting('payment.currency', 'USD');
                $pacakageDescription = ($package->isFree()) ? "(" . Engine_Api::_()->getApi('Core', 'siteapi')->translate("Free") . ")" : "";

                if ($package_count == 1 && $package->isFree())
                    continue;
                $multiOptions[$package->package_id]['label'] = Engine_Api::_()->getApi('Core', 'siteapi')->translate($package->title) . $pacakageDescription;
                $multiOptions[$package->package_id]['description'] = (string) $package->description;

                if (isset($package->price) && !empty($package->price) && $package->price > 0) {
                    $multiOptions[$package->package_id]['price'] = (string) $userCurrency.(int) $package->price;
                    $multiOptions[$package->package_id]['description'] = (string) $package->description;
                } else {
                    $multiOptions[$package->package_id]['price'] = $package->price;
                }
                $multiOptions[$package->package_id]['currency'] = (string) $userCurrency;

                // trial fields work start
                $package_type = ($package->isFree()) ? 'free' : 'paid';
                $multiOptions[$package->package_id]['type'] = !empty($sitesubscriptionModuleEnable) && !empty($package->trial_duration) ? 'trial' : $package_type;
                if($package_type != 'free'){
                    $multiOptions[$package->package_id]['recurrence'] = $package->recurrence ;
                    $multiOptions[$package->package_id]['recurrence_type'] = $package->recurrence_type ;
                }
                if($sitesubscriptionModuleEnable){
                    $multiOptions[$package->package_id]['trial_duration'] = $package->trial_duration ;
                    $featuresRowData = Engine_Api::_()->getDbTable('fields','sitesubscription')->getFields($templateInfo['structureType']);
                    
                    foreach ($featuresRowData as $feature) {
                        $valueRowData = Engine_Api::_()->getDbTable('values','sitesubscription')->getFieldValues($feature['field_id']);
                        foreach($valueRowData as $key1 => $value1){
                            if($value1['value'] == null)
                                continue;
                            if($value1['package_id'] == $package->package_id)
                            {   
                                $multiOptions[$package->package_id]['trialfields'][] = $value1['value'] ;
                            }
                        }
                    }
                }
                // trial fields work end
            }
        } catch (Exception $e) {
        }

        // Element: package_id
        if (count($multiOptions) > 0 && isset($showForm) && !empty($showForm)) {
            $packageForm[] = array(
                'type' => 'Radio',
                'name' => 'package_id',
                'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Choose Plan'),
                'layoutType' => 2,
                'leftDrawable' => 'dollar',
                'multiOptions' => $multiOptions,
                'hasValidator' => 'true'
            );
        }
        return $packageForm;
    }

    private function _getFieldPositionByName($formArray, $fieldName) {

        foreach ($formArray as $position => $field) {
            if ($field['name'] == $fieldName) {
                return $position;
            }
        }
    }

    public function createLink(Core_Model_Item_Abstract $owner,$url)
    {   // Now try to create thumbnail
        $thumbnail = (string) @$url;
        $thumbnail_parsed = @parse_url($thumbnail);
        
        $params = array(
            'parent_type' => $owner->getType(),
            'parent_id' => $owner->getIdentity(),
            'user_id' => $owner->getIdentity(),
        );

        if ($thumbnail && $thumbnail_parsed) {
            $tmp_path = APPLICATION_PATH . '/temporary/link';
            $tmp_file = $tmp_path . '/' . md5($thumbnail);

            if (!is_dir($tmp_path) && !mkdir($tmp_path, 0777, true)) {
                throw new Core_Model_Exception('Unable to create tmp link folder : ' . $tmp_path);
            }
            $src_fh = fopen($thumbnail, 'r');
            $tmp_fh = fopen($tmp_file, 'w');
            stream_copy_to_stream($src_fh, $tmp_fh, 1024 * 1024 * 2);
            fclose($src_fh);
            fclose($tmp_fh);

            if (($info = getimagesize($tmp_file)) && !empty($info[2])) {
                $ext = Engine_Image::image_type_to_extension($info[2]);
                // Resize image (main)
                $main_file = $tmp_path . '/thumb_m_' . md5($thumbnail) . '.' . $ext;
                $image = Engine_Image::factory();
                $image->open($tmp_file)
                    ->autoRotate()
                    ->resize(720, 720)
                    ->write($main_file)
                    ->destroy();

                $thumb_file = $tmp_path . '/thumb_' . md5($thumbnail) . '.' . $ext;

                $image = Engine_Image::factory();
                $image->open($tmp_file)
                    ->resize(240, 240)
                    ->write($thumb_file)
                    ->destroy();

                $params = array(
                    'parent_type' => $owner->getType(),
                    'parent_id' => $owner->getIdentity(),
                    'user_id' => $owner->getIdentity(),
                );
                try {
                    $MainFileRow = Engine_Api::_()->storage()->create($main_file, $params);
                    $thumbFileRow = Engine_Api::_()->storage()->create($thumb_file, $params);
                    $MainFileRow->bridge($thumbFileRow, 'thumb.profile');
                } catch (Exception $e) {
                    @unlink($thumb_file);
                    @unlink($main_file);
                    throw $e;
                }
                $owner->photo_id = $MainFileRow->file_id;
                $owner->save();
                @unlink($thumb_file);
                @unlink($main_file);
            }
            @unlink($tmp_file);
        }
        return $owner;
    }
}
