<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitequicksignup
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: TakeActionController.php 6590 2012-26-01 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitequicksignup_InstallController extends Core_Controller_Action_Standard
{
  protected $_token;
  public function init()
  {
    $this->_helper->contextSwitch->initContext();
    $this->_token = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitequicksignup.install.ssotoken', null);
    $token = $this->_getParam('token', false);
    if( $token != $this->_token ) {
      exit(0);
    }
  }
  public function postInstallAction()
  {
    $tableNameContent = Engine_Api::_()->getDbtable('content', 'core');
    $header_page_id = Engine_Api::_()->sitequicksignup()->getWidgetizedPageId(array('name' => 'header'));
    $main_content_id = $tableNameContent->select()
        ->from($tableNameContent->info('name'), 'content_id')
        ->where('name =?', 'main')
        ->where('page_id =?', $header_page_id)
        ->query()
        ->fetchColumn();

    if (!empty($main_content_id)) {
      $content_id = $tableNameContent->select()
        ->from($tableNameContent->info('name'), 'content_id')
        ->where('name =?', 'core.html-block')
        ->where('page_id =?', $header_page_id)
        ->where('params like (?)', '%jQuery.noConflict()%')->query()
        ->fetchColumn();

      if (!$content_id) {
        $tableNameContent->insert(array(
          'type' => 'widget',
          'name' => 'core.html-block',
          'page_id' => $header_page_id,
          'parent_content_id' => $main_content_id,
          'order' => 1,
          'params' => '{"title":"","data":"<script type=\"text\/javascript\"> \r\nif(typeof(window.jQuery) !=  \"undefined\") {\r\njQuery.noConflict();\r\n}\r\n<\/script>","nomobile":"0","name":"core.html-block"}'
        ));
      }
    }

    Engine_Api::_()->getApi('settings', 'core')->removeSetting('sitequicksignup.install.ssotoken');
    exit();
  }
}