<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitequicksignup
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 2017-03-16 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
require_once realpath(dirname(__FILE__)) . '/sitemodule_install.php';

class Sitequicksignup_Installer extends SiteModule_Installer {

    function onInstall() {
        $this->placeWidgets();
        parent::onInstall();
    }

    public function placeWidgets() {
    $db = $this->getDb();

    // PLACE SCHEMA MARKUP WIDGET
    $select = new Zend_Db_Select($db);
    $select
      ->from('engine4_core_pages')
      ->where('name = ?', 'footer')
      ->limit(1);
    $info = $select->query()->fetch();

    $page_id = $info['page_id'];
    $select = new Zend_Db_Select($db);
    $isCoreSignupPopupWidgetExist = $select->from('engine4_core_content')
      ->where('engine4_core_content.name = ?', 'user.login-or-signup-popup')
      ->where('engine4_core_content.page_id = ?', $page_id)
      ->where('engine4_core_content.type = ?', 'widget')
      ->limit(1)->query()->fetchColumn();

    $select = new Zend_Db_Select($db);
    $isQuickSignupPopupWidgetExist = $select->from('engine4_core_content')
      ->where('engine4_core_content.name = ?', 'sitequicksignup.login-or-signup-popup')
      ->where('engine4_core_content.page_id = ?', $page_id)
      ->where('engine4_core_content.type = ?', 'widget')
      ->limit(1)->query()->fetchColumn();

    if (!empty($isCoreSignupPopupWidgetExist) && empty($isQuickSignupPopupWidgetExist)) {
      $db->query("UPDATE `engine4_core_content` SET `name` = 'sitequicksignup.login-or-signup-popup' WHERE `name` = 'user.login-or-signup-popup' LIMIT 1");
    }
  }
}

?>
