<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitereviewpaidlisting
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Packages.php 2014-05-19 5:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitereviewpaidlisting_Model_DbTable_Packages extends Engine_Db_Table {

  protected $_rowClass = 'Sitereviewpaidlisting_Model_Package';

  public function getEnabledPackage($listingtype_id = 0) {
    
    $viewerID = Engine_Api::_()->user()->getViewer()->getIdentity();
    if ($viewerID == 0)
      $level_id = 0;
    else {
      $user = Engine_Api::_()->user()->getViewer();
      $level_id = $user->level_id;
    }
  
    $user_level = $level_id;
    $start_one = "'" . $user_level . "'";
    $start = "'" . $user_level . ",%'";
    $middile = "'%," . $user_level . ",%'";
    $end = "'%," . $user_level . "'";
   
    $select = $this->select()
            ->from($this, array('price', 'enabled', 'package_id'))
            ->where("level_id = 0 or level_id LIKE $start_one or level_id LIKE $start or level_id LIKE $middile or level_id LIKE $end ")
            ->where('listingtype_id = ?', $listingtype_id)
            ->where('enabled = 1');
    return $result = $this->fetchRow($select);
  }

  public function getDisabledPackage($listingtype_id = 0) {
    return $disabledPackageCount = $this->select()
            ->from($this, new Zend_Db_Expr('COUNT(*)'))
            ->where('listingtype_id = ?', $listingtype_id)
            ->where('enabled = 0')
            ->query()
            ->fetchColumn();
  }

  public function getTotalPackage($listingtype_id = 0, $enabled = 0) {
    $select = $this->select()
            ->from($this, new Zend_Db_Expr('COUNT(*)'))
            ->where('listingtype_id = ?', $listingtype_id);
    
    if(!empty($enabled)) { 
        $select->where('enabled = ?', 1);
    }
     
    return $select->query()->fetchColumn();
  }

  public function getEnabledNonFreePackageCount() {
    return $this->select()
                    ->from($this, new Zend_Db_Expr('COUNT(*)'))
                    ->where('enabled = ?', 1)
                    ->where('price > ?', 0)
                    ->query()
                    ->fetchColumn();
  }

  public function getPackagesSql($user = 0, $listingtype_id = null, $paginator = 0) {

    if (empty($user))
      $level_id = 0;
    else {
      $user = Engine_Api::_()->user()->getViewer();
      $level_id = $user->level_id;
    }
  
    $user_level = $level_id;
    $start_one = "'" . $user_level . "'";
    $start = "'" . $user_level . ",%'";
    $middile = "'%," . $user_level . ",%'";
    $end = "'%," . $user_level . "'";

    $select = $this->select()
            ->where("level_id = 0 or level_id LIKE $start_one or level_id LIKE $start or level_id LIKE $middile or level_id LIKE $end ")
            ->order('order')
            ->order('package_id DESC')
            ->where('listingtype_id = ?', $listingtype_id)
            ->where('enabled=1');
   
    if (!empty($paginator))
      return $select;
    else
      return $paginator = Zend_Paginator::factory($select);
  }

  public function getPackageResult($sitereview, $listingtype_id) {

    $packages_select = $this->getPackagesSql($sitereview->getOwner(), $listingtype_id, '1')
            ->where("update_list = ?", 1)
            ->where("enabled = ?", 1);
            //->where("package_id <> ?", $sitereview->package_id);
    return $paginator = Zend_Paginator::factory($packages_select);
  }

  /**
   * Get Package Count
   *
   * @param int $listingtype_id
   * @return $countPackage
   */
  public function getPackageCount($listingTypeId = null, $allpackage = 0) {

    $user = Engine_Api::_()->user()->getViewer();
    if (!isset($user->level_id))
      return 0;

    $user_level = $user->level_id;
    $start_one = "'" . $user_level . "'";
    $start = "'" . $user_level . ",%'";
    $middile = "'%," . $user_level . ",%'";
    $end = "'%," . $user_level . "'";
    $select = $this->select()
            ->from($this->info('name'), array('COUNT(' . $this->info('name') . '.listingtype_id)'))
            ->where('listingtype_id = ?', $listingTypeId);
    if (empty($allpackage))
      $select->where('enabled = ?', 1);
    return $countPackage = $select->where("level_id = 0 or level_id LIKE $start_one or level_id LIKE $start or level_id LIKE $middile or level_id LIKE $end ")
            ->query()
            ->fetchColumn();
  }

  public function getPackageOption($package_id = null, $option = null) {

    return $packageOption = $this->select()
            ->from($this->info('name'), array($option))
            ->where('package_id = ?', $package_id)
            ->query()
            ->fetchColumn();
  }

}