<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitereviewpaidlisting
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: PackageController.php 2014-05-19 5:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitereviewpaidlisting_PackageController extends Core_Controller_Action_Standard {

  protected $_listingType;

  //COMMON ACTION WHICH CALL BEFORE EVERY ACTION OF THIS CONTROLLER
  public function init() {
    //SET LISTING TYPE ID AND OBJECT
    $listingtype_id = $this->_getParam('listingtype_id', null);
    $sitereviewIsPackageInfo = Zend_Registry::isRegistered('sitereviewIsPackageInfo') ?  Zend_Registry::get('sitereviewIsPackageInfo') : null;
    if ($listingtype_id != -1 && !empty($listingtype_id)) {
      $isPackageEnabled = Engine_Api::_()->sitereview()->isPackageEnabled($listingtype_id);
      if(empty($isPackageEnabled)){
        return $this->_forward('notfound', 'error', 'core');
      }
      
      Engine_Api::_()->sitereview()->setListingTypeInRegistry($listingtype_id);
      $this->_listingType = Zend_Registry::get('listingtypeArray' . $listingtype_id);

      //AUTHORIZATION CHECK
      if ($this->_getParam('action', null) != 'categories')
        if (!$this->_helper->requireAuth()->setAuthParams('sitereview_listing', null, "view_listtype_$listingtype_id")->isValid())
          return;
    }
    
    if(empty($sitereviewIsPackageInfo)) {
       return $this->_forward('notfound', 'error', 'core');
    }
  }

  //ACTION FOR SHOW PACKAGES
  public function indexAction() {

    $package_show = $this->_getParam('package', 0);

    //GET LISTING TYPE ID
    $listingtype_id = $this->_listingType->listingtype_id;

    //SEND LISTING TYPE TITLE TO TPL
    $this->view->title = $this->_listingType->title_plural;

    if ($package_show == 1) {
      
      //USER VALIDATON
      if (!$this->_helper->requireUser()->isValid())
        return;

      //LISTING CREATION PRIVACY
      if (!$this->_helper->requireAuth()->setAuthParams('sitereview_listing', null, "create_listtype_$listingtype_id")->isValid())
        return;

      $packageCount = Engine_Api::_()->getDbTable('packages', 'sitereviewpaidlisting')->getPackageCount($listingtype_id);

      if (!Engine_Api::_()->sitereviewpaidlisting()->hasPackageEnable()) {
        //REDIRECT
        return $this->_helper->redirector->gotoRoute(array('action' => 'create'), "sitereview_general_listtype_$listingtype_id", true);
      }

      if ($packageCount == 1) {
        $package = Engine_Api::_()->getDbTable('packages', 'sitereviewpaidlisting')->getEnabledPackage($listingtype_id);
        if (($package->price == '0.00'))
          return $this->_helper->redirector->gotoRoute(array('action' => 'create', 'id' => $package->package_id), "sitereview_general_listtype_$listingtype_id", true);
      }
    }

    $this->_helper->content
            ->setContentName("sitereviewpaidlisting_package_index_listtype_$listingtype_id")
            ->setNoRender()
            ->setEnabled();
  }

  //ACTION FOR PACKAGE DETAIL
  public function detailAction() {

    //USER VALIDATON
    if (!$this->_helper->requireUser()->isValid())
      return;

    $this->view->listingtype_id = $listingtype_id = $this->_listingType->listingtype_id;
    $this->view->listing_singular_uc = ucfirst($this->_listingType->title_singular);
    $this->view->allow_review = $this->_listingType->reviews;
    $this->view->overview = $this->_listingType->overview;
    $this->view->wishlist = $this->_listingType->wishlist;
    $this->view->location = $this->_listingType->location;
    $this->view->package_description = $this->_listingType->package_description;

    $this->view->viewer = Engine_Api::_()->user()->getViewer();

    //LISTING CREATION PRIVACY
    if (!$this->_helper->requireAuth()->setAuthParams('sitereview_listing', null, "create_listtype_$listingtype_id")->isValid())
      return;

    $id = $this->_getParam('id');
    if (empty($id)) {
      return $this->_forward('notfound', 'error', 'core');
    }
    $this->view->package = Engine_Api::_()->getItem('sitereviewpaidlisting_package', $id);
  }

  //ACTION FOR PACKAGE UPDATION
  public function updatePackageAction() {

    //USER VALIDATON
    if (!$this->_helper->requireUser()->isValid())
      return;

    //PACKAGE ENABLE VALIDATION
    if (!Engine_Api::_()->sitereviewpaidlisting()->hasPackageEnable()) {
      return $this->_forward('notfound', 'error', 'core');
    }
    
    $sitereviewUpdatePackageId = Zend_Registry::isRegistered('sitereviewUpdatePackageId') ?  Zend_Registry::get('sitereviewUpdatePackageId') : null;
    if(empty($sitereviewUpdatePackageId)){
      return $this->_forward('notfound', 'error', 'core');
    }

    $this->view->listing_singular_lc = lcfirst($this->_listingType->title_singular);
    $this->view->allow_review = $this->_listingType->reviews;
    $this->view->package_view = $this->_listingType->package_view;
    $this->view->overview = $this->_listingType->overview;
    $this->view->wishlist = $this->_listingType->wishlist;
    $this->view->location = $this->_listingType->location;
    $this->view->package_description = $this->_listingType->package_description;

    $this->view->viewer = Engine_Api::_()->user()->getViewer();
    $this->view->TabActive = "package";
    $this->view->sitereviews_view_menu = 16;

    //GET LISTING TYPE ID
    $this->view->listingtype_id = $listingtype_id = $this->_listingType->listingtype_id;

    $this->view->listing_singular_uc = ucfirst($this->_listingType->title_singular);
    $this->view->show_editor = $this->_listingType->show_editor;

    //GET LISTING ID LISTING OBJECT AND THEN CHECK VALIDATIONS
    $this->view->listing_id = $listing_id = $this->_getParam('listing_id');
    if (empty($listing_id)) {
      return $this->_forward('notfound', 'error', 'core');
    }

    $this->view->sitereview = $sitereview = Engine_Api::_()->getItem('sitereview_listing', $listing_id);
    if (empty($sitereview)) {
      return $this->_forward('notfound', 'error', 'core');
    }

    $viewer = Engine_Api::_()->user()->getViewer();
    if (!$this->_helper->requireAuth()->setAuthParams($sitereview, $viewer, "edit_listtype_$listingtype_id")->isValid()) {
      return;
    }

    $this->view->package = Engine_Api::_()->getItem('sitereviewpaidlisting_package', $sitereview->package_id);
    $paginator = Engine_Api::_()->getDbTable('packages', 'sitereviewpaidlisting')->getPackageResult($sitereview, $listingtype_id);
    $this->view->paginator = $paginator->setCurrentPageNumber($this->_getParam('page'));

    //GET NAVIGATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation("sitereview_main_listtype_$listingtype_id");
    $this->view->is_ajax = $this->_getParam('is_ajax', '');
  }

  //ACTION FOR PACKAGE UPGRADE CONFIRMATION
  public function updateConfirmationAction() {

    //USER VALIDATION
    if (!$this->_helper->requireUser()->isValid())
      return;

    //PACKAGE ENABLE VALIDATION
    if (!Engine_Api::_()->sitereviewpaidlisting()->hasPackageEnable()) {
      return $this->_forward('notfound', 'error', 'core');
    }

    $this->view->listing_singular_lc = lcfirst($this->_listingType->title_singular);
    $this->view->listing_singular_uc = ucfirst($this->_listingType->title_singular);

    //GET LISTING ID, LISTING OBJECT AND THEN CHECK VALIDATIONS
    $this->view->listing_id = $listing_id = $this->_getParam('listing_id');
    if (empty($listing_id)) {
      return $this->_forward('notfound', 'error', 'core');
    }
    $this->view->sitereview = $sitereview = Engine_Api::_()->getItem('sitereview_listing', $listing_id);
    if (empty($sitereview)) {
      return $this->_forward('notfound', 'error', 'core');
    }

    $this->view->package_id = $this->_getParam('package_id');
    $package_chnage = Engine_Api::_()->getItem('sitereviewpaidlisting_package', $this->view->package_id);

    if (empty($package_chnage) || !$package_chnage->enabled || (!empty($package_chnage->level_id) && !in_array($sitereview->getOwner()->level_id, explode(",", $package_chnage->level_id)))) {
      return $this->_forward('notfound', 'error', 'core');
    }

    // CUSTOM WORK
    $packageQuota = $package_chnage->max_listing;
    $this->view->hasMaxListings = !empty($packageQuota) && $package_chnage->getListingCount() >= $packageQuota;
    if ($this->view->hasMaxListings) {
      return ;
    }
    // CUSTOM WORK

    if ($this->getRequest()->getPost()) {

      if (!empty($_POST['package_id'])) {
        $table = $sitereview->getTable();
        $db = $table->getAdapter();
        $db->beginTransaction();

        try {
          $is_upgrade_package = true;
          //APPLIED CHECKS BECAUSE CANCEL SHOULD NOT BE CALLED IF ALREADY CANCELLED 
          if($sitereview->status == 'active'){
          $sitereview->cancel($is_upgrade_package);
          }
          $sitereview->package_id = $_POST['package_id'];
          $package = Engine_Api::_()->getItem('sitereviewpaidlisting_package', $sitereview->package_id);

          $sitereview->featured = $package->featured;
          $sitereview->sponsored = $package->sponsored;
          $sitereview->pending = 1;
          $sitereview->expiration_date = new Zend_Db_Expr('NULL');
          $sitereview->status = 'initial';
          if (($package->isFree())) {
            $sitereview->approved = $package->approved;
          } else {
            $sitereview->approved = 0;
          }

          if (!empty($sitereview->approved)) {
            $sitereview->pending = 0;
            $expirationDate = $package->getExpirationDate();
            if (!empty($expirationDate))
              $sitereview->expiration_date = date('Y-m-d H:i:s', $expirationDate);
            else
              $sitereview->expiration_date = '2250-01-01 00:00:00';

            if (empty($sitereview->approved_date)) {
              $sitereview->approved_date = date('Y-m-d H:i:s');
              if ($sitereview->draft == 0 && $sitereview->search && time() >= strtotime($sitereview->creation_date)) {
                $action = Engine_Api::_()->getDbtable('actions', 'activity')->addActivity($sitereview->getOwner(), $sitereview, 'sitereview_new_listtype_' . $listingtype_id);
                if ($action != null) {
                  Engine_Api::_()->getDbtable('actions', 'activity')->attachActivity($action, $sitereview);
                }
              }
            }
          }
          $sitereview->save();
          $db->commit();
        } catch (Exception $e) {
          $db->rollBack();
          throw $e;
        }
      }
      $this->_forward('success', 'utility', 'core', array(
          'smoothboxClose' => true,
          'format' => 'smoothbox',
          'parentRedirect' => $this->view->url(array('action' => 'update-package', 'listing_id' => $sitereview->listing_id), "sitereview_package_listtype_$sitereview->listingtype_id", true),
          'parentRedirectTime' => 15,
          'messages' => array(Zend_Registry::get('Zend_Translate')->_('The package for your Listing has been successfully changed.'))
      ));
    }
  }

  //ACTION FOR PACKAGE PAYMENT
  public function paymentAction() {

    //USER VALIDATION
    if (!$this->_helper->requireUser()->isValid())
      return;

    $this->view->listingtype_id = $listingtype_id = $this->_listingType->listingtype_id;
    $this->view->listing_singular_lc = strtolower($this->_listingType->title_singular);
    $this->view->listing_plural_lc = strtolower($this->_listingType->title_plural);
    $this->view->show_editor = $this->_listingType->show_editor;    

    //GET LISTING ID, LISTING OBJECT AND THEN CHECK VALIDATIONS
     if (Engine_API::_()->seaocore()->checkSitemobileMode('fullsite-mode'))
            $listing_id = $_POST['listing_id_session'];
     else
            $listing_id = $this->_getParam('listing_id');
    if (empty($listing_id)) {
      return $this->_forward('notfound', 'error', 'core');
    }
    $isPackageEnabled = Engine_Api::_()->sitereview()->isPackageEnabled($listing_id);
    if(empty($isPackageEnabled)){
      return $this->_forward('notfound', 'error', 'core');
    }
    $this->view->sitereview = $sitereview = Engine_Api::_()->getItem('sitereview_listing', $listing_id);
    if (empty($sitereview)) {
      return $this->_forward('notfound', 'error', 'core');
    }

    $package = Engine_Api::_()->getItem('sitereviewpaidlisting_package', $sitereview->package_id);

    if ((!$package->isFree())) {
      $session = new Zend_Session_Namespace('Payment_Sitereview');
      $session->listing_id = $listing_id;

      return $this->_helper->redirector->gotoRoute(array(), "sitereview_payment_$listingtype_id", true);
    } else {
      return $this->_helper->redirector->gotoRoute(array('action' => 'manage'), "sitereview_general_listtype_$listingtype_id", true);
    }
  }
  
  //ACTION FOR PACKAGE CANCEL
  public function cancelAction(){
    if( !($package_id = $this->_getParam('package_id')) ||
        !($package = Engine_Api::_()->getItem('sitereviewpaidlisting_package', $package_id)) ) {
      return $this->_helper->redirector->gotoRoute(array('action' => 'index', 'package_id' => null));
    }

    $this->view->package_id = $package_id;
    $listing_id = $this->_getParam('listing_id');

    $this->view->form = $form = new Sitereviewpaidlisting_Form_Package_Cancel();

    if( !$this->getRequest()->isPost() ) {
      return;
    }
    if( !$form->isValid($this->getRequest()->getPost()) ) {
      return;
    }

    // Try to cancel
    $this->view->form = null;
    try {
      Engine_Api::_()->getItem('sitereview_listing', $listing_id)->cancel();
      $this->view->status = true;
    } catch( Exception $e ) {
      $this->view->status = false;
      $this->view->error = $e->getMessage();
    }
  }

}