<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitereviewpaidlisting
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 2014-05-19 5:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitereviewpaidlisting_Installer extends Engine_Package_Installer_Module {

  function onPreinstall() {

    $db = $this->getDb();

//CHECK THAT SITEPAGE PLUGIN IS ACTIVATED OR NOT
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_settings')
            ->where('name = ?', 'sitereview.isActivate')
            ->limit(1);
    $sitereview_settings = $select->query()->fetchAll();
    $sitereview_is_active = !empty($sitereview_settings) ? $sitereview_settings[0]['value'] : 0;

//CHECK THAT Reviews & Ratings Plugin IS INSTALLED OR NOT
    $select = new Zend_Db_Select($db);
    $isSitereviewEnabled = $select
            ->from('engine4_core_modules', 'enabled')
            ->where('name = ?', 'sitereview')
            ->where('enabled = ?', 1)
            ->query()
            ->fetchColumn()
    ;

    if (empty($isSitereviewEnabled)) {
      $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();

      return $this->_error("<span style='color:red'>Note: You have not installed the '<a href='http://www.socialengineaddons.com/socialengine-reviews-ratings-plugin' target='_blank'>Multiple Listing Types Plugin Core (Reviews & Ratings Plugin)</a>' on your site yet. Please install it first before installing the 'Multiple Listing Types - Paid Listings Extension'. <a href='" . $base_url . "/manage'>Click here</a> to go to Manage Packages.</span>");
    } else {
      if (empty($sitereview_is_active)) {
        $core_final_url = '';
        $baseUrl = $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getBaseUrl();
        $explode_base_url = explode("/", $baseUrl);
        foreach ($explode_base_url as $url_key) {
          if ($url_key != 'install') {
            $core_final_url .= $url_key . '/';
          }
        }
        return $this->_error("<span style='color:red'>Note: You have installed the 'Multiple Listing Types Plugin Core (Reviews & Ratings Plugin)' but not activated it on your site yet. Please activate it first before installing the 'Multiple Listing Types - Paid Listings Extension'.</span> <a href='" . 'http://' . $core_final_url . "admin/sitereview/settings/readme'>Click here</a> to activate the 'Multiple Listing Types Plugin Core (Reviews & Ratings Plugin)'.");
      }
      
      $getErrorMsg = $this->_getVersion();
      if (!empty($getErrorMsg)) {
        return $this->_error($getErrorMsg);
      }
      
      $PRODUCT_TYPE = 'sitereviewpaidlisting';
      $PLUGIN_TITLE = 'Sitereviewpaidlisting';
      $PLUGIN_VERSION = '5.8.0';
      $PLUGIN_CATEGORY = 'plugin';
      $PRODUCT_DESCRIPTION = 'Multiple Listing Types - Paid Listings Extension';
      $_PRODUCT_FINAL_FILE = 0;
      $SocialEngineAddOns_version = '4.8.9p12';
      $PRODUCT_TITLE = 'Multiple Listing Types - Paid Listings Extension';

      $file_path = APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/ilicense.php";
      $is_file = file_exists($file_path);

      if (empty($is_file)) {
        include_once APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/license3.php";
      } else {
        $select = new Zend_Db_Select($db);
        $select->from('engine4_core_modules')->where('name = ?', $PRODUCT_TYPE);
        $is_Mod = $select->query()->fetchObject();
        if (empty($is_Mod)) {
          include_once $file_path;
        }
      }
    }
    parent::onPreinstall();
  }

  function onInstall() {

    $db = $this->getDb();
    
    $db->query("UPDATE  `engine4_seaocores` SET  `is_activate` =  '1' WHERE  `engine4_seaocores`.`module_name` ='sitereviewpaidlisting';");

    $sitereview_status_column = $db->query("SHOW COLUMNS FROM engine4_sitereview_listings LIKE 'status'")->fetch();
    if (empty($sitereview_status_column)) {
      $db->query("ALTER TABLE `engine4_sitereview_listings` ADD `status` ENUM( 'initial', 'trial', 'pending', 'active', 'cancelled', 'expired', 'overdue', 'refunded' ) NOT NULL DEFAULT 'initial' AFTER `end_date`");
    }

    $sitereview_pending_column = $db->query("SHOW COLUMNS FROM engine4_sitereview_listings LIKE 'pending'")->fetch();
    if (empty($sitereview_pending_column)) {
      $db->query("ALTER TABLE `engine4_sitereview_listings` ADD `pending` TINYINT( 1 ) NOT NULL DEFAULT '1' AFTER `status`");
    }

    $sitereview_package_id_column = $db->query("SHOW COLUMNS FROM engine4_sitereview_listings LIKE 'package_id'")->fetch();
    if (empty($sitereview_package_id_column)) {
      $db->query("ALTER TABLE `engine4_sitereview_listings` ADD `package_id` INT( 11 ) NOT NULL AFTER `listingtype_id`");
    }

    $sitereview_expiration_date_column = $db->query("SHOW COLUMNS FROM engine4_sitereview_listings LIKE 'expiration_date'")->fetch();
    if (empty($sitereview_expiration_date_column)) {
      $db->query("ALTER TABLE `engine4_sitereview_listings` ADD `expiration_date` DATETIME NULL DEFAULT '2250-01-01 00:00:00' AFTER `modified_date`");
    }

    $sitereview_payment_date_column = $db->query("SHOW COLUMNS FROM engine4_sitereview_listings LIKE 'payment_date'")->fetch();
    if (empty($sitereview_payment_date_column)) {
      $db->query("ALTER TABLE `engine4_sitereview_listings` ADD `payment_date` DATETIME NULL DEFAULT NULL AFTER `expiration_date`");
    }

    $sitereview_gateway_id_column = $db->query("SHOW COLUMNS FROM engine4_sitereview_otherinfo LIKE 'gateway_id'")->fetch();
    if (empty($sitereview_gateway_id_column)) {
      $db->query("ALTER TABLE `engine4_sitereview_otherinfo` ADD `gateway_id` INT( 10 ) NULL DEFAULT NULL");
    }

    $sitereview_gateway_profile_id_column = $db->query("SHOW COLUMNS FROM engine4_sitereview_otherinfo LIKE 'gateway_profile_id'")->fetch();
    if (empty($sitereview_gateway_profile_id_column)) {
      $db->query("ALTER TABLE `engine4_sitereview_otherinfo` ADD `gateway_profile_id` VARCHAR( 128 ) NULL DEFAULT NULL");
    }

    $sitereview_package_column = $db->query("SHOW COLUMNS FROM engine4_sitereview_listingtypes LIKE 'package'")->fetch();
    if (empty($sitereview_package_column)) {
      $db->query("ALTER TABLE `engine4_sitereview_listingtypes` ADD `package` TINYINT( 1 ) NOT NULL DEFAULT '0' AFTER `listingtype_id`");
    }

    $sitereview_package_ui_column = $db->query("SHOW COLUMNS FROM engine4_sitereview_listingtypes LIKE 'package_view'")->fetch();
    if (empty($sitereview_package_ui_column)) {
      $db->query("ALTER TABLE `engine4_sitereview_listingtypes` ADD `package_view` TINYINT( 1 ) NOT NULL AFTER `package`");
    }

    $sitereview_package_description_column = $db->query("SHOW COLUMNS FROM engine4_sitereview_listingtypes LIKE 'package_description'")->fetch();
    if (empty($sitereview_package_description_column)) {
      $db->query("ALTER TABLE `engine4_sitereview_listingtypes` ADD `package_description` TINYINT( 1 ) NOT NULL AFTER `package_view`");
    }
    
    $select = new Zend_Db_Select($db);
    $select
                ->from('engine4_core_modules')
                ->where('name = ?', 'sitemobile')
                ->where('enabled = ?', 1);
    $is_sitemobile_object = $select->query()->fetchObject();
    if ($is_sitemobile_object) {
            $listingTypess = $db->select()
                    ->from('engine4_sitereview_listingtypes', array('listingtype_id', 'title_singular', 'title_plural'))
                    ->where('package = ?', 1)
                    ->query()
                    ->fetchAll();
            foreach ($listingTypess as $listingType) {
                $listingTypeId = $listingType['listingtype_id'];
                $titleSinUc = ucfirst($listingType['title_singular']);
                $titlePluUc = ucfirst($listingType['title_plural']);
                $titleSinUpper = strtoupper($listingType['title_singular']);
                $titleSinLc = strtolower($listingType['title_singular']);
                $titlePluLc = strtolower($listingType['title_plural']);
                $listingTypeTable = 'engine4_sitereview_listingtypes';
                $package = $db->select()
                        ->from($listingTypeTable, array('package'))
                        ->where('listingtype_id = ?', $listingTypeId)
                        ->query()
                        ->fetchColumn();
                if ($package) {
                    $db->query("INSERT IGNORE INTO `engine4_sitemobile_menus` (`name`, `type`, `title`) VALUES
('sitereview_package_listtype_$listingTypeId', 'standard', 'Multiple Listing Types - $titlePluUc Quick Navigation Menu')      
");

                    $db->query("INSERT IGNORE INTO `engine4_sitemobile_navigation` (`name`, `menu`, `subject_type`) VALUES
('sitereview_package_listtype_$listingTypeId', 'sitereview_package_listtype_$listingTypeId', '')      
");


                    $db->query("INSERT IGNORE INTO `engine4_sitemobile_menus` (`name`, `type`, `title`) VALUES
('sitereview_package_listtype_$listingTypeId', 'standard', 'Multiple Listing Types - $titlePluUc Quick Navigation Menu')      
");

                    $db->query("INSERT IGNORE INTO `engine4_sitemobile_navigation` (`name`, `menu`, `subject_type`) VALUES
('sitereview_package_listtype_$listingTypeId', 'sitereview_package_listtype_$listingTypeId', '')      
");

                    $this->freePackageCreate($listingTypeId, $titleSinUpper, $titleSinLc, $titlePluUc, 'engine4_sitemobile_pages', 'engine4_sitemobile_content');
                    $this->createPackageNavigation($listingTypeId, 'engine4_sitemobile_pages', 'engine4_sitemobile_content');
                    $this->freePackageCreate($listingTypeId, $titleSinUpper, $titleSinLc, $titlePluUc, 'engine4_sitemobile_tablet_pages', 'engine4_sitemobile_tablet_content');
                    $this->createPackageNavigation($listingTypeId, 'engine4_sitemobile_tablet_pages', 'engine4_sitemobile_tablet_content');

                    $select_sitemobileapp = new Zend_Db_Select($db);
                    $select_sitemobileapp
                            ->from('engine4_core_modules')
                            ->where('name = ?', 'sitemobileapp')
                            ->where('enabled = ?', 1);
                    $is_sitemobileapp_object = $select_sitemobileapp->query()->fetchObject();
                    if ($is_sitemobileapp_object) {
                        $this->freePackageCreate($listingTypeId, $titleSinUpper, $titleSinLc, $titlePluUc, 'engine4_sitemobileapp_pages', 'engine4_sitemobileapp_content');
                        $this->createPackageNavigation($listingTypeId, 'engine4_sitemobileapp_pages', 'engine4_sitemobileapp_content');
                        $this->freePackageCreate($listingTypeId, $titleSinUpper, $titleSinLc, $titlePluUc, 'engine4_sitemobileapp_tablet_pages', 'engine4_sitemobileapp_tablet_content');
                        $this->createPackageNavigation($listingTypeId, 'engine4_sitemobileapp_tablet_pages', 'engine4_sitemobileapp_tablet_content');
                    }
                }
            }
    }


    $sitereview_package_column = $db->query("SHOW COLUMNS FROM engine4_sitereviewpaidlisting_packages LIKE 'max_listing'")->fetch();
    if (empty($sitereview_package_column)) {
      $db->query("ALTER TABLE `engine4_sitereviewpaidlisting_packages` ADD `max_listing` int( 11 ) NOT NULL DEFAULT '0' ");
    }
    
    parent::onInstall();
  }

  function onPostInstall() {

    $db = $this->getDb();

    $packageCreation = 1;
    $this->_setPackageId($packageCreation);

    $db->query("UPDATE `engine4_core_menuitems` SET `order` = '35' WHERE `engine4_core_menuitems`.`name` ='sitereview_admin_main_review' LIMIT 1;
");
    $db->query("UPDATE `engine4_core_menuitems` SET `order` = '30' WHERE `engine4_core_menuitems`.`name` ='sitereview_admin_main_manage' LIMIT 1 ;
");
    
    $db = $this->getDb();
    $select = new Zend_Db_Select($db);
    $select->from('engine4_sitereview_listingtypes', array('package', 'listingtype_id'))->where('package =?', 1);
    $listingTypes = $select->query()->fetchAll();

    foreach ($listingTypes as $listingType) {
      $listing_type_id = $listingType['listingtype_id'];
      $db->query("UPDATE `engine4_sitereview_listingtypes` SET `expiry` = '0' WHERE `listingtype_id` ='$listing_type_id' LIMIT 1 ;
");
    }
  }

  protected function _setPackageId($packageCreation) {

    //START WORK FOR DEFAULT FREE PACKAGE INTO LISTINGTYPE WHICH IS ALREADY CREATED
    $db = $this->getDb();
    $select = new Zend_Db_Select($db);
    $select->from('engine4_sitereview_listingtypes', array('listingtype_id','title_plural'));
    $listingTypes = $select->query()->fetchAll();

    foreach ($listingTypes as $listingType) {
      $listing_type_id = $listingType['listingtype_id'];
      $titlePluUc = ucfirst($listingType['title_plural']);

      if (!empty($packageCreation)) {
        $isFreePackageExist = $db->select()
                ->from('engine4_sitereviewpaidlisting_packages', 'listingtype_id')
                ->where("listingtype_id = ?", $listing_type_id)
                ->limit(1)
                ->query()
                ->fetchColumn();
        if (empty($isFreePackageExist)) {
          $db->query("INSERT IGNORE INTO `engine4_sitereviewpaidlisting_packages` (`listingtype_id`, `title`, `description`, `level_id`, `price`, `recurrence`, `recurrence_type`, `duration`, `duration_type`, `sponsored`, `featured`, `overview`, `map`, `video`, `video_count`, `photo`, `photo_count`, `wishlist`, `user_review`, `approved`, `enabled`, `defaultpackage`, `renew`, `renew_before`, `profile`, `profilefields`, `order`, `update_list`) VALUES
($listing_type_id, 'Free Listing Package', 'This is a free listing package. One does not need to pay for creating a listing of this package.', '0', '0.00', 0, 'forever', 0, 'forever', 0, 0, 1, 1, 1, 0, 1, 0, 1, 1, 1, 1, 1, 1, 0, 1, NULL, 0, 1);
");
        }
      }

      $select = new Zend_Db_Select($db);
      $select->from('engine4_sitereview_listings', array('package_id', 'listing_id', 'approved'));
      $listings = $select->where("listingtype_id = ?", $listing_type_id)->query()->fetchAll();
      foreach ($listings as $listing) {
        $package_id = $listing['package_id'];
        $approvedId = $listing['approved'];
        $listing_id = $listing['listing_id'];
        $currentPackageId = $db->select()
                ->from('engine4_sitereviewpaidlisting_packages', 'package_id')
                ->where("listingtype_id = ?", $listing_type_id)
                ->order('package_id ASC')
                ->limit(1)
                ->query()
                ->fetchColumn();
        if (empty($package_id)) {
          $db->query("UPDATE `engine4_sitereview_listings` SET `package_id` = '$currentPackageId' WHERE `engine4_sitereview_listings`.`listingtype_id` = '$listing_type_id' AND `engine4_sitereview_listings`.`listing_id` = '$listing_id' LIMIT 1;
");
          if (!empty($approvedId)) {
            $db->query("UPDATE `engine4_sitereview_listings` SET `pending` = 0 WHERE `engine4_sitereview_listings`.`listingtype_id` = '$listing_type_id' AND `engine4_sitereview_listings`.`listing_id` = '$listing_id' LIMIT 1;
");
          }
        }
      }
    }
    //END DEFAULT PACKAGE WORK
  }

  function onDisable() {

    $db = $this->getDb();
    $db->query("UPDATE `engine4_core_menuitems` SET `order` = '30' WHERE `engine4_core_menuitems`.`name` ='sitereview_admin_main_review' LIMIT 1;
");
    $db->query("UPDATE `engine4_core_menuitems` SET `order` = '35' WHERE `engine4_core_menuitems`.`name` ='sitereview_admin_main_manage' LIMIT 1 ;
");

    parent::onDisable();
  }

  function onEnable() {

    $db = $this->getDb();
    $packageCreation = 0;
    $this->_setPackageId($packageCreation);
    $db->query("UPDATE `engine4_core_menuitems` SET `order` = '35' WHERE `engine4_core_menuitems`.`name` ='sitereview_admin_main_review' LIMIT 1;
");
    $db->query("UPDATE `engine4_core_menuitems` SET `order` = '30' WHERE `engine4_core_menuitems`.`name` ='sitereview_admin_main_manage' LIMIT 1 ;
");

    parent::onEnable();
  }
  
  private function _getVersion() {
  
    $db = $this->getDb();

    $errorMsg = '';
    $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();

    $modArray = array(
      'sitereview' => '4.8.3',
      'sitereviewlistingtype' => '4.8.3'
    );
    
    $finalModules = array();
    foreach ($modArray as $key => $value) {
    		$select = new Zend_Db_Select($db);
		$select->from('engine4_core_modules')
					->where('name = ?', "$key")
					->where('enabled = ?', 1);
		$isModEnabled = $select->query()->fetchObject();
			if (!empty($isModEnabled)) {
				$select = new Zend_Db_Select($db);
				$select->from('engine4_core_modules',array('title', 'version'))
					->where('name = ?', "$key")
					->where('enabled = ?', 1);
				$getModVersion = $select->query()->fetchObject();

				$isModSupport = $this->checkVersion($getModVersion->version, $value);
				if (empty($isModSupport)) {
					$finalModules[$key] = $getModVersion->title;
				}
			}
    }

    foreach ($finalModules as $modArray) {
      $errorMsg .= '<div class="tip"><span style="background-color: #da5252;color:#FFFFFF;">Note: You do not have the latest version of the "' . $modArray . '". Please upgrade "' . $modArray . '" on your website to the latest version available in your SocialEngineAddOns Client Area to enable its integration with "'.$modArray.'".<br/> Please <a class="" href="' . $base_url . '/manage">Click here</a> to go Manage Packages.</span></div>';

    }

    return $errorMsg;
  }
     private function checkVersion($databaseVersion, $checkDependancyVersion) {
        $f = $databaseVersion;
        $s = $checkDependancyVersion;
        if (strcasecmp($f, $s) == 0)
            return -1;

        $fArr = explode(".", $f);
        $sArr = explode('.', $s);
        if (count($fArr) <= count($sArr))
            $count = count($fArr);
        else
            $count = count($sArr);

        for ($i = 0; $i < $count; $i++) {
            $fValue = $fArr[$i];
            $sValue = $sArr[$i];
            if (is_numeric($fValue) && is_numeric($sValue)) {
                if ($fValue > $sValue)
                    return 1;
                elseif ($fValue < $sValue)
                    return 0;
                else {
                    if (($i + 1) == $count) {
                        return -1;
                    } else
                        continue;
                }
            }
            elseif (is_string($fValue) && is_numeric($sValue)) {
                $fsArr = explode("p", $fValue);

                if ($fsArr[0] > $sValue)
                    return 1;
                elseif ($fsArr[0] < $sValue)
                    return 0;
                else {
                    return 1;
                }
            } elseif (is_numeric($fValue) && is_string($sValue)) {
                $ssArr = explode("p", $sValue);

                if ($fValue > $ssArr[0])
                    return 1;
                elseif ($fValue < $ssArr[0])
                    return 0;
                else {
                    return 0;
                }
            } elseif (is_string($fValue) && is_string($sValue)) {
                $fsArr = explode("p", $fValue);
                $ssArr = explode("p", $sValue);
                if ($fsArr[0] > $ssArr[0])
                    return 1;
                elseif ($fsArr[0] < $ssArr[0])
                    return 0;
                else {
                    if ($fsArr[1] > $ssArr[1])
                        return 1;
                    elseif ($fsArr[1] < $ssArr[1])
                        return 0;
                    else {
                        return -1;
                    }
                }
            }
        }
    } 
  public function freePackageCreate($listingTypeId,$titleSinUpper,$titleSinLc,$titlePluUc, $pageTable, $contentTable) {
      
    global $sitereviewPackageInfo;
    $listingTypeId = $listingTypeId;
    $titleSinUpper = $titleSinUpper;
    $titleSinLc = $titleSinLc;
    $titlePluUc = $titlePluUc;

    //GET DATABASE
    $db = $this->getDb();

      //PACKAGE CREATE PAGE CREATION
      $page_id = $db->select()
              ->from($pageTable, 'page_id')
              ->where('name = ?', "sitereviewpaidlisting_package_index_listtype_$listingTypeId")
              ->limit(1)
              ->query()
              ->fetchColumn();
      if (empty($page_id)) {

        $containerCount = 0;

        //CREATE PAGE
        $db->insert($pageTable, array(
            'name' => "sitereviewpaidlisting_package_index_listtype_$listingTypeId",
            'displayname' => 'Multiple Listing Types - Packages for ' . $titlePluUc,
            'title' => 'Packages for '.$titlePluUc,
            'description' => 'This is the Packages page for '.$titleSinLc.'.',
            'custom' => 0,
        ));
        $page_id = $db->lastInsertId();

        //TOP CONTAINER
        $db->insert($contentTable, array(
            'type' => 'container',
            'name' => 'top',
            'page_id' => $page_id,
            'order' => $containerCount++,
        ));
        $top_container_id = $db->lastInsertId();

        //MAIN CONTAINER
        $db->insert($contentTable, array(
            'type' => 'container',
            'name' => 'main',
            'page_id' => $page_id,
            'order' => $containerCount++,
        ));
        $main_container_id = $db->lastInsertId();

        //INSERT TOP-MIDDLE
        $db->insert($contentTable, array(
            'type' => 'container',
            'name' => 'middle',
            'page_id' => $page_id,
            'parent_content_id' => $top_container_id,
            'order' => $containerCount++,
        ));
        $top_middle_id = $db->lastInsertId();

        //MAIN-MIDDLE CONTAINER
        $db->insert($contentTable, array(
            'type' => 'container',
            'name' => 'middle',
            'page_id' => $page_id,
            'parent_content_id' => $main_container_id,
            'order' => $containerCount++,
        ));
        $main_middle_id = $db->lastInsertId();

        $db->insert($contentTable, array(
            'page_id' => $page_id,
            'type' => 'widget',
            'name' => 'sitereview.navigation-sitereview',
            'parent_content_id' => $top_middle_id,
            'params' => '',
        ));

        $db->insert($contentTable, array(
            'type' => 'widget',
            'name' => 'sitereviewpaidlisting.list-packages',
            'page_id' => $page_id,
            'parent_content_id' => $main_middle_id,
            'params' => '{"listingtype_id":"' . $listingTypeId . '"}',
            'order' => 1,
        ));
      }
    }
  
    
     public function createPackageNavigation($listingTypeId, $pageTable, $contentTable) {
         $db = $this->getDb();
         $menuItemsTableName = 'engine4_sitemobile_menuitems';
         $menuItemsId = $db->select()
                ->from($menuItemsTableName, array('id'))
                ->where('name = ? ', "sitereviewpackage_listtype_$listingTypeId")
                ->query()
                ->fetchColumn();
    if (empty($menuItemsId)) {
                $db->query("INSERT IGNORE INTO `engine4_sitemobile_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `enable_mobile`, `enable_tablet`, `submenu`, `order`) VALUES
('sitereviewpackage_listtype_$listingTypeId', 'sitereviewpaidlisting', 'Packages', 'Sitereviewpaidlisting_Plugin_Menus::canViewPackages', '{\"route\":\"sitereview_all_package_listtype_".$listingTypeId."\",\"action\":\"index\",\"listingtype_id\":\"$listingTypeId\"}', 'sitereview_package_listtype_$listingTypeId',1,1,'',6)      
");
    }
  }
  

}