<?php

class Sitesetup_AdminDemoController extends Core_Controller_Action_Admin {

    protected $_httpHost;
    protected $_moduleArray;
    protected $_replaceSkuNames; 
    
    public function init() 
    {   
        $this->_httpHost = Engine_Api::_()->getApi('settings', 'core')->getSetting('demo.host.name');
        $siteLink = Engine_Api::_()->sitesetup()->getSiteName();
        //DEMO NAME AND CLIENT'S SITE NAME SHOULD NOT BE NULL, THIS WILL CREATE PROBLEM IN THE URL REPLACEMENT
        if(empty($this->_httpHost) || empty($siteLink)) {
            die("Demo name or target site name is coming null, please check and proceed further");
        }
        $this->_moduleArray = array('bigstep', 'sitemobile', 'sitemobileapp', 'sitemobileandroidapp', 'sitemobileiosapp', 'communityad', 'communityadsponsored', 'document', 'documentintegration', 'eventdocument', 'groupdocument', 'poll', 'siteeventdocument', 'sitepagedocument', 'sitebusinessdocument', 'sitegroupdocument', 'siteestore', 'dbbackup', 'grouppoll', 'suggestion', 'userconnection', 'blog', 'classified', 'event', 'group', 'music', 'poll', 'feedback', 'sitecoupon', 'facebookse', 'facebooksefeed', 'facebooksepage', 'nestedcomment', 'siterecaptcha', 'sitenews', 'advancedslideshow');
        $this->_replaceSkuNames = array('feedbacks' => 'feedback', 'seaddons-core' => 'seaocore', 'sponsoredstories' => 'communityadsponsored', 'documentsv4' => 'document', 'groupdocumentsv4' => 'groupdocument', 'backup' => 'dbbackup', 'like' => 'sitelike', 'contactpageowners' => 'sitepageadmincontact', 'sitepageshorturl' => 'sitepageurl', 'Siteeventadmincontact' => 'siteeventadmincontact');
    }

    //RETURN THE CURRENT INSTALLED VERSION OF A MODULE 
    public function getVersion($name) 
    {
        $table = Engine_Api::_()->getDbtable('modules', 'core');
        $version = $table->select()->from($table->info('name'), 'version')->where('name = ?', $name)->limit(1)->query()->fetchColumn();
        return $version;
    } 
    //ACTION TO EXECUTE THE STORAGE SERVICE CHANGE RELATED QUERY
    public function storageServiceAction() 
    {
        $this->_helper->content->setNoRender();
        $db = Engine_Db_Table::getDefaultAdapter();
        //KEEP ONLY LOCAL SERVICE AS STORAGE SERVICE
        $db->query('UPDATE `engine4_storage_files` SET `service_id` = "1" WHERE `engine4_storage_files`.`service_id` != "1";'); 
        $db->query('DELETE FROM `engine4_storage_services` WHERE `engine4_storage_services`.`service_id` != "1";');   
        $db->query('UPDATE `engine4_storage_services` SET `default` = "1" WHERE `engine4_storage_services`.`service_id` = "1";');   
    }

    //STORE THE USER'S SEAO ACCOUNT DETAILS AND TOKEN IN THE SESSION OR IN FILE
    public function saveSeaoAuthTokenAction()
    {
        $seaoToken = $this->getParam('token');
        $seaoID = $this->getParam('id');
        $seaoName = $this->getParam('name');
        if( empty($seaoToken) ) {
            return $this->_helper->json(array('status' => 0));
        }
        $session = new Zend_Session_Namespace('SEAOSITE_UserAuth');
        $session->setExpirationSeconds(86400 * 1); // 86400*1;
        $session->token = $seaoToken;
        $session->userId = $seaoID;
        $session->userName = $seaoName;
        return $this->_helper->json(array('status' => 1));
    }

    public function logoutAction()
    {
        $redirectUrl = $this->_getParam('redirectUrl'); 
        $session = new Zend_Session_Namespace('SEAOSITE_UserAuth');
        if(!empty($session->token)) { 
            Zend_Session::namespaceUnset('SEAOSITE_UserAuth');
        }
        return $this->_helper->redirector->gotoUrl(urldecode($redirectUrl), array('prependBase' => false));
    }

    public function indexAction() 
    {  
        // Zend_Feed required DOMDocument
        // @todo add to sanity check
        if (!class_exists('DOMDocument', false)) {
            $this->view->badPhpVersion = true;
            return;
        }
        $viewer = Engine_Api::_()->user()->getViewer();
        if (empty($viewer) || empty($viewer->level_id) || ($viewer->level_id != 1)) {
            return;
        }
        $this->view->seaoDetailsForm = $seaoDetailsForm = new Sitesetup_Form_Admin_SeaoAuth();
        $this->view->redirectUrl = Zend_Controller_Front::getInstance()->getRequest()->getRequestUri();
        $this->view->seaoDetailsSession = false;
        $this->view->session = $session = new Zend_Session_Namespace('SEAOSITE_UserAuth');
        if( empty($session->token) ) {
          return;
        }
        $this->view->seaoDetailsSession = true;

        $getDefaultStorageId = Engine_Api::_()->getDbtable('services', 'storage')->getDefaultServiceIdentity();
        $getDefaultStorageType = Engine_Api::_()->getDbtable('services', 'storage')->getService($getDefaultStorageId)->getType();
        $hasNonLocalStorageRow = Engine_Api::_()->getDbtable('files', 'storage')->select()->where('`service_id` != ?', 1)->limit(1)->query()->fetch();
        $this->view->storageLocal = false;
        if($getDefaultStorageType == 'local' && empty($hasNonLocalStorageRow)) {
            $this->view->storageLocal = true;
        }

        $usertable = Engine_Api::_()->getDbtable('users', 'user');
        $this->view->totalUsers = $usertable->select()
                        ->from($usertable->info('name'), array('count(*) as count'))
                        ->query()->fetchColumn();
        //FETCH THE PURCHASED PLUGIN LIST
        $service = new Sitesetup_Service_Curl();
        $service->setURl('https://www.socialengineaddons.com/licenses/products');
        $purchasedPlugins = $service->post(array('u' => $this->view->serverUrl(), 'token' => $session->token)); 
        //HERE KEY WILL BE REPLACED BY THE RESPECTIVE VALUE  
        foreach ($this->_replaceSkuNames as $findSku => $replaceSku) {
          if(isset($purchasedPlugins[$findSku])) {
            $purchasedPlugins[$replaceSku] = $purchasedPlugins[$findSku];
            unset($purchasedPlugins[$findSku]);
          }
        } 
        //VALID PLUGINS MEANS THOSE HAVE LICENSE KEY, DO NOT TAKE THE MODULE WHICH DO NOT HAVE LICENSE
        $validPurchasedPlugins = array();
        foreach ($purchasedPlugins as $name => $pluginInfo) {
          if(!empty($pluginInfo['license'])) {
            $validPurchasedPlugins[$name] = $pluginInfo['title'];
          }
        }
       
        $contentModuleArray = Engine_Api::_()->sitesetup()->getModulesArray();
        //REMOVE SOME MODULES FROM LIST, WHICH ARE ALREADY DEFINED IN REMOVAL MODULE LIST, DO NOT SHOW TO USER
        foreach ($contentModuleArray as $key => $value) {
            if(in_array($key, $this->_moduleArray)) {
                unset($contentModuleArray[$key]);
            }
        } 
        //SOME DEMOS TABLE HAVE THE lsetting ENTRY SAVED RELATED SITEREACTION, SITEHASHTAG, SITETAGCHECKIN, birthdaymail AND THESE CREATE PROBLEM AND GETS DELETED FROM SCRIPT SO WE ARE REMOVING THESE IN ANY CASE
        unset($contentModuleArray['sitehashtag'], $contentModuleArray['sitereaction'], $contentModuleArray['sitetagcheckin'],  $contentModuleArray['birthdayemail']);
        //DO NOT REMOVE THESE MODULES THESE CREATE PROBLEM IN PLUGIN, so remove from array
        unset($contentModuleArray['album'], $contentModuleArray['forum'], $contentModuleArray['video'], $contentModuleArray['poke']); 
        $moduleArrayDisabledMarked = Engine_Api::_()->sitesetup()->getModulesArrayDisabledMarked($contentModuleArray);
        $commonPlugins = array_intersect_key($contentModuleArray, $validPurchasedPlugins);
        $notPurchasedPlugins = array_keys(array_diff_key($contentModuleArray, $commonPlugins));  
        
        //DO NOT KEEP THE SITESTORE EXTENSIONS SELECTED IF SITESTORE IS NOT IN THE REMOVAL PLUGINS LIST
        if( !in_array('sitestore', $notPurchasedPlugins) ) {
            $temp = array_flip($notPurchasedPlugins);
            unset($temp['sitestoreproduct'], $temp['sitestoreadmincontact'], $temp['sitestorealbum'], $temp['sitestoreform'], $temp['sitestoreinvite'], $temp['sitestorelikebox'], $temp['sitestoreoffer'], $temp['sitestorereview'], $temp['sitestoreurl'], $temp['sitestorevideo']);
            $notPurchasedPlugins = array_flip($temp);
        }
        
        $isSitemenuInstalled = Engine_Api::_()->hasModuleBootstrap('sitemenu');
        $advancedMenuEnabled = (!$isSitemenuInstalled && Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitemenu')) ? false : true ;

        $this->view->form = $form = new Sitesetup_Form_Admin_Demo(array('advancedMenuEnabled' => $advancedMenuEnabled, 'moduleArrayDisabledMarked' => $moduleArrayDisabledMarked, 'notPurchasedPlugins' => $notPurchasedPlugins, 'hostName' => $this->_httpHost)); 
 
        if (!$this->getRequest()->isPost()) {
            return;
        }
        if (!$form->isValid($this->getRequest()->getPost())) {
            return;
        }

        $values = $form->getValues();  

        // Verify password
        if (!empty($values['sitesetup_admin_password'])) {
            if ($values['sitesetup_admin_password'] != $values['sitesetup_admin_password_confirm']) {
                $form->addError('Passwords did not match.');
                return;
            }
            if (strlen($values['sitesetup_admin_password']) < 4) {
                $form->addError('Password must be at least four (4) characters.');
                return;
            }
            //PASSWORD CHANGED FOR THE ADMIN USER
            $admin = Engine_Api::_()->getItem('user', 1);
            $admin->password = $values['sitesetup_admin_password'];
            $admin->save();
            // Hash password
            $changedPassword = md5(Engine_Api::_()->getApi('settings', 'core')->getSetting('core.secret', 'staticSalt') . $values['sitesetup_admin_password']);
            Engine_Api::_()->getApi('settings', 'core')->core_admin_password = $changedPassword;  
            unset($values['sitesetup_admin_password_confirm']);
        } else {
            unset($values['sitesetup_admin_password']);
            unset($values['sitesetup_admin_password_confirm']);
        } 
        if($advancedMenuEnabled && empty($values['sitesetup_advanced_menu'])) {
            //SITEMENU DELETION CODE for submenus
            $table = Engine_Api::_()->getDbtable('menuItems', 'core');
            $select = $table->select()->from($table->info('name'), array('id', 'name'))
            ->where('menu = ?', "core_main")
            ->where('params LIKE ?', "%\"root_id\":%");
            $menus = $table->fetchAll($select);
            $doNotDeleteMenus =  array("custom_3205", "core_main_sitevideo", "custom_802", "custom_3564", "custom_3565", "core_main_siteforum");

            $menuIds = array();
            foreach ($menus as $key => $value) {
                $params = $table->select()
                ->from($table->info('name'), array('params'))
                ->where("id = ?", $value->id)
                ->query()
                ->fetchColumn();
                $paramsArray  = json_decode($params, true); 

                if(!in_array($value->name, $doNotDeleteMenus)) {
                    if(isset($paramsArray['root_id']) && !empty($paramsArray['root_id'])) {
                        //DELETED THE MENUS COMING IN THE DROPDOWN
                        $table->delete(array("id = ?" => $value->id));
                    }
                } else {
                    if(isset($paramsArray['root_id']) && !empty($paramsArray['root_id'])) {
                        $paramsArray['root_id'] = 0;
                    }
                    if(isset($paramsArray['menu_item_view_type']) && !empty($paramsArray['menu_item_view_type'])) {
                        $paramsArray['menu_item_view_type'] = 0;
                    }
                    if(isset($paramsArray['nav_menu']) && !empty($paramsArray['nav_menu'])) {
                        $paramsArray['nav_menu'] = "";
                    }
                    $jsonParams = json_encode($paramsArray);
                    $table->update(array("params" => $jsonParams), array("id = ?" => $value->id));
                } 
            }
        }

        set_time_limit(0);
        $disabledModulesArray = Engine_Api::_()->sitesetup()->getDisabledModulesArray();
        $removalModulesArray = !empty($values['modules_name']) ? $values['modules_name'] : array();
        $removalModulesArray = array_merge($this->_moduleArray, $removalModulesArray);
        $removalModulesArray = array_merge($removalModulesArray, $disabledModulesArray);

        // $removalModulesArray = array_merge($removalModulesArray, $notPurchasedPlugins);

        $notDeletedFiles = array();
        Engine_API::_()->sitesetup()->getLog()->log('Removal Module Array: ' . print_r($removalModulesArray, true), Zend_Log::INFO); 
        Engine_API::_()->sitesetup()->getLog()->log('Not Purchased Module Array: ' . print_r($notPurchasedPlugins, true), Zend_Log::INFO);

        // prepare database queries to clean the database
        $databaseInfoArray = include APPLICATION_PATH . '/application/settings/database.php';
        $database = $databaseInfoArray['params']['dbname'];
        $values['database'] = $database;
        //CALLING FUNCTION FROM COMMON QUERY.
        $string = $this->makeSqlQuery($values);
        $oldData = $this->_httpHost; 
        $siteLink = Engine_Api::_()->sitesetup()->getSiteName();

        $db = Engine_Db_Table::getDefaultAdapter();

        $conn = $db->getConnection();
        
        $notExecutedQueries = '';
        $queriesArray = explode(';', $string);
        foreach ($queriesArray as $value) {
            if(!empty($value) && !mysqli_query($conn, $value)) {
                 $notExecutedQueries .= $value.";";
            }
        } 
        Engine_API::_()->sitesetup()->getLog()->log('Not Executed SQL Queries: ' . print_r($notExecutedQueries, true), Zend_Log::INFO);
        //REPLACE THE URL WITH LATEST URL IN THE ALL TABLES OF DATABASE
        $query = "SELECT CONCAT( 'update ', table_name , ' set ', column_name, ' = replace(', column_name,', ''{$oldData}'', ''{$siteLink}'');' ) AS statement FROM information_schema.columns WHERE table_schema = '{$database}'";
        $result = mysqli_query($conn,$query);
        while ($row = mysqli_fetch_row($result)) {
            mysqli_query($conn,$row[0]);
        }

        // delete the files that are not useful or need to to be removed

        $index = 0;
        //DELETE THE FILES AND DIRECTORIES OF SELECTED MODULES
        foreach ($removalModulesArray as $module) { 

            $manifestArray = include APPLICATION_PATH . '/application/modules/'.ucfirst($module).'/settings/manifest.php';
            $directories = $manifestArray['package']['directories'];
            $files = $manifestArray['package']['files'];
            if(!empty($directories)) {
                foreach ($directories  as $directory) {
                    try{
                        $directoryPath = APPLICATION_PATH .'/'.$directory;
                        if(strpos($directoryPath, "Zend") !== false || strpos($directoryPath, "Engine") !== false) {
                            continue;
                        }
                        @chmod($directoryPath, 0777);
                        shell_exec('rm -rf '. $directoryPath);
                        if(file_exists($directoryPath)) {
                            $notDeletedFiles[++$index] = $directoryPath;  
                        }
                    } catch (Exception $e) {
                        if(file_exists($directoryPath)) {
                            $notDeletedFiles[++$index] = $directoryPath;  
                        }
                    }
                }
            }
            if(!empty($files)) {
                foreach ($files  as $file) { 
                    try{
                        $filePath = APPLICATION_PATH .'/'. $file;
                        if(strpos($filePath, "Zend") !== false || strpos($filePath, "Engine") !== false) {
                            continue;
                        }
                        @chmod($filePath, 0777);
                        shell_exec('rm -f '. $filePath);
                        if(file_exists($filePath)) {
                            $notDeletedFiles[++$index] = $filePath;  
                        }
                    } catch (Exception $e) {
                        if(file_exists($filePath)) {
                            $notDeletedFiles[++$index] = $filePath;  
                        }
                    }
                } 
            }
            // $version = $this->getVersion($module);
            //DELETE THE PACKAGE FILE ALSO
             
            try{
                $jsonFilePath = APPLICATION_PATH . '/application/packages/module-'.$module.'-*';
                @chmod($jsonFilePath, 0777);
                shell_exec('rm -f '. $jsonFilePath);
                Engine_API::_()->sitesetup()->getLog()->log('delete json file : ' . print_r('rm -f '. $jsonFilePath, true), Zend_Log::INFO);
                if(file_exists($jsonFilePath)) {
                    $notDeletedFiles[++$index] = $jsonFilePath;  
                }
            } catch (Exception $e) {
                if(file_exists($jsonFilePath)) {
                    $notDeletedFiles[++$index] = $jsonFilePath;  
                }
            } 
           
            //DELETE THE LANGUAGE FILES AVAILABELE FOR THE MODULES
            //TOTAL LOCALE AVAILABLE IN SITE FOR LANGUAGES
            $availableLocale = scandir(APPLICATION_PATH . '/application/languages');
            if(!empty($availableLocale)) {
                foreach ($availableLocale as $locale) {
                    try {
                        $langFilePath = APPLICATION_PATH . '/application/languages/'.$locale.'/'.$module.'.csv';
                        @chmod($langFilePath, 0777);
                        shell_exec('rm -f '. $langFilePath);
                        if(file_exists($langFilePath)) {
                            $notDeletedFiles[++$index] = $langFilePath;  
                        }
                    } catch(Exception $e) {
                        if(file_exists($langFilePath)) {
                            $notDeletedFiles[++$index] = $langFilePath;  
                        }
                    }
                }
            }
            
            //DELETE THE CONTENT FROM PUBLIC FOLDER RELATED TO THE SELECTED MODULES
            $availableFolder = scandir(APPLICATION_PATH . '/public');
            foreach ($availableFolder as $folderName) {
                if(strpos($folderName, $module) !== false) {
                    if(substr($folderName, 0, strlen($module)) == $module) {
                        try {
                            $moduleFolder = APPLICATION_PATH . '/public/'.$folderName;
                            @chmod($moduleFolder, 0777);
                            shell_exec('rm -rf '. $moduleFolder);
                            if(file_exists($moduleFolder)) {
                                $notDeletedFiles[++$index] = $moduleFolder;  
                            }
                        } catch(Exception $e) {
                            if(file_exists($moduleFolder)) {
                                $notDeletedFiles[++$index] = $moduleFolder;  
                            }
                        }
                    }
                } 
            }
        }
        Engine_API::_()->sitesetup()->getLog()->log('Not Deleted Files: ' . print_r($notDeletedFiles, true), Zend_Log::INFO); 

        //DELETE THE SITESETUP MODULE AND USERDELETION CONTROLLER FROM SEAOOCORE
        $sitesetupModulePath = APPLICATION_PATH .'/application/modules/Sitesetup';
        @chmod($sitesetupModulePath, 0777);
        shell_exec('rm -rf '. $sitesetupModulePath);
        if(file_exists($sitesetupModulePath)) {
            Engine_API::_()->sitesetup()->getLog()->log('Not Deleted Files: ' . print_r($sitesetupModulePath, true), Zend_Log::INFO);
        } else {
            //IF SITESETUP MODULE'S CODE IS DELETED THAN DELETE THE CORE_MODULES ENTRY ALSO
            $db->query('DELETE FROM `engine4_core_modules` WHERE `engine4_core_modules`.`name` = "sitesetup"');
        }
        $sitesetupVersion = $this->getVersion($module);
        $jsonFilePath = APPLICATION_PATH . '/application/packages/module-sitesetup-'.$sitesetupVersion.'.json';
        @chmod($jsonFilePath, 0777);
        shell_exec('rm -f '. $jsonFilePath);  
        if(file_exists($jsonFilePath)) {
            Engine_API::_()->sitesetup()->getLog()->log('Not Deleted Files: ' . print_r($jsonFilePath, true), Zend_Log::INFO);
        }
        //REDIRECTION TO CHECK THE MODULE STILL EXIST OR HAS BEEN DELETED
        return $this->_helper->redirector->gotoRoute(array("module" => "sitesetup", "controller" => "demo"), "admin_default", true);
    }

    public function makeSqlQuery($params = array()) {

        $notInclude = array('activity', 'authorization', 'announcement', 'messages', 'core', 'fields', 'invite', 'network', 'payment', 'storage', 'user', 'bigstep', 'sitecore');
        $moduleTable = Engine_Api::_()->getDbTable('modules', 'core');
        $moduleTableName = $moduleTable->info('name');
        $select = $moduleTable->select()
                ->from($moduleTableName, array('name'))
                ->where($moduleTableName . '.name not in(?)', $notInclude)
                ->where($moduleTableName . '.enabled = ?', 1);

        $contentModule = $select->query()->fetchAll();
        foreach ($contentModule as $modules) {
            $installedModuleArray[$modules['name']] = $modules['name'];
        }

        $db = Engine_Db_Table::getDefaultAdapter();
        $siteLink = Engine_Api::_()->sitesetup()->getSiteName();
        $replace_url = $siteLink;
        $siteTitle = $params['site_title'];
        $database = $params['database'];
 
        $final_query = '';
        $randomTriggerAccessKey = str_shuffle("xadBLL6Fpdd8tDgO"); 
        $final_query .= '
UPDATE  `engine4_users` SET  `email` =  "' . $params['site_admin_email'] . '" WHERE  `engine4_users`.`user_id` ="1" OR `engine4_users`.`level_id` ="1" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "' . $siteTitle . '" WHERE `engine4_core_settings`.`name` = "core.general.site.title" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "' . $siteTitle . '" WHERE `engine4_core_settings`.`name` = "core.site.title" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "' . $params['site_description'] . '" WHERE `engine4_core_settings`.`name` = "core.general.site.description" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "' . $params['site_admin_email'] . '" WHERE `engine4_core_settings`.`name` = "core.mail.contact" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "no-reply@' . $siteLink . '" WHERE `engine4_core_settings`.`name` = "core.mail.from" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "' . $randomTriggerAccessKey . '" WHERE `engine4_core_settings`.`name` = "core.tasks.key" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "'.$params['google_location_key'].'" WHERE `engine4_core_settings`.`name` = "seaocore.google.map.key";
DELETE FROM `engine4_core_tagmaps` WHERE `tag_id` NOT IN(SELECT `tag_id` from `engine4_core_tags`);



TRUNCATE TABLE `engine4_announcement_announcements`;
TRUNCATE TABLE `engine4_core_reports`;
TRUNCATE TABLE `engine4_core_bannedemails`;
TRUNCATE TABLE `engine4_core_bannedips`;
TRUNCATE TABLE `engine4_core_bannedusernames`;
TRUNCATE TABLE `engine4_user_logins`;
TRUNCATE TABLE `engine4_core_jobs`;
TRUNCATE TABLE `engine4_chat_bans`;
TRUNCATE TABLE `engine4_core_adcampaigns`;
TRUNCATE TABLE `engine4_core_statistics`;
TRUNCATE TABLE `engine4_core_referrers`;
TRUNCATE TABLE `engine4_payment_transactions`;
TRUNCATE TABLE `engine4_activity_notifications`;
TRUNCATE TABLE `engine4_core_session`;
TRUNCATE TABLE `engine4_user_facebook`;
TRUNCATE TABLE `engine4_user_twitter`;
TRUNCATE TABLE `engine4_user_verify`;
TRUNCATE TABLE `engine4_payment_gateways`;
TRUNCATE engine4_messages_conversations;
TRUNCATE engine4_messages_messages;
TRUNCATE engine4_messages_recipients;
TRUNCATE engine4_activity_stream;
TRUNCATE engine4_activity_attachments;
TRUNCATE engine4_activity_comments;
TRUNCATE engine4_activity_likes;
TRUNCATE engine4_core_adphotos;
TRUNCATE engine4_core_ads;
TRUNCATE engine4_core_bannedwords;
TRUNCATE engine4_core_links;
TRUNCATE engine4_core_processes;
TRUNCATE engine4_user_block;
TRUNCATE engine4_user_online;
TRUNCATE engine4_seaocore_locations;
TRUNCATE engine4_seaocore_locationcontents;
TRUNCATE engine4_invites;
TRUNCATE engine4_activity_actionsettings;
TRUNCATE engine4_core_styles;';
if(count($db->query("SHOW TABLES LIKE 'engine4_userconnection_setting';")->fetchAll()) > 0) {
    $final_query .= 'TRUNCATE engine4_userconnection_setting;'; 
}
if(count($db->query("SHOW TABLES LIKE 'engine4_seaocore_integratedtype';")->fetchAll()) > 0) {
    $final_query .= 'TRUNCATE engine4_seaocore_integratedtype;'; 
} 
//SPECIFIC QUERY ADDITION FROM THE RESPECTED DEMOS
switch ($this->_httpHost) {
    case 'demo.socialapps.tech':
        $final_query = Engine_Api::_()->sitesetup()->demoSocialengineaddons($final_query, $siteTitle); 
        break;
    case 'demo.videos.socialengineaddons.com':
        $final_query = Engine_Api::_()->sitesetup()->demoVideosSocialengineaddons($final_query); 
        break;
    case 'demo.sell-tickets.socialapps.tech':
        $final_query = Engine_Api::_()->sitesetup()->demoSellTicketsSocialengineaddons($final_query); 
        break;
    case 'demo.photoalbums.socialengineaddons.com':
        $final_query = Engine_Api::_()->sitesetup()->demoPhotoalbumsSocialengineaddons($final_query); 
        break;
    case 'demo.crowdfunding.socialapps.tech':
        $final_query = Engine_Api::_()->sitesetup()->demoCrowdfundingSocialengineaddons($final_query); 
        break;
    case 'mobiledemo.socialengineaddons.com':
        $final_query = Engine_Api::_()->sitesetup()->demoMobiledemoSocialengineaddons($final_query);  
        break; 
    case 'demo.facelight.socialapps.tech':
        $final_query = Engine_Api::_()->sitesetup()->demoFacelightSocialengineaddons($final_query);  
        break;
    case 'demo.socialmedia.socialapps.tech':
        $final_query = Engine_Api::_()->sitesetup()->demoSocialMedia($final_query);  
        break;
    case 'demo.contests.socialapps.tech':
        $final_query = Engine_Api::_()->sitesetup()->demoContest($final_query);  
        break;
    case 'demo.contests.socialapps.tech':
            $final_query = Engine_Api::_()->sitesetup()->demoTwitter($final_query);  
            break;
    default: 
        break;
} 
  
$final_query .= '

UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "from.address" LIMIT 1; 
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "facebooksefeed.fbstore" LIMIT 1; 
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "facebooksepage.fbcallback" LIMIT 1; 
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "facebookse.fbappid" LIMIT 1; 
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "facebookse.config.type" LIMIT 1;  
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "fbadmin.userid" LIMIT 1; 
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.iframely.host" LIMIT 1; 
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.viglink.subid" LIMIT 1; 
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.viglink.code" LIMIT 1;  
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.general.social.code" LIMIT 1; 
UPDATE `engine4_core_settings` SET `value` = NOW() WHERE `engine4_core_settings`.`name` = "core.site.creation" LIMIT 1;  

UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.general.staticBaseUrl" LIMIT 1; 
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "bitly.apikey" LIMIT 1; 
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "bitly.secretkey" LIMIT 1;  

UPDATE `engine4_core_settings` SET `value` = "curl" WHERE `engine4_core_settings`.`name` = "core.tasks.mode" LIMIT 1;
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.spam.siterecaptcha.secret.key" LIMIT 1; 
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.spam.siterecaptcha.site.key" LIMIT 1; 
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.spam.siterecaptcha.replace.files.0" LIMIT 1;
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.spam.siterecaptcha.replace.files.1" LIMIT 1; 
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.spam.siterecaptcha.replace.files.2" LIMIT 1; 
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.spam.siterecaptcha.replace.files.3" LIMIT 1; 
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.spam.siterecaptcha.replace.files.4" LIMIT 1; 
UPDATE `engine4_core_settings` SET `value` = "https://twitter.com" WHERE `engine4_core_settings`.`name` = "captivate.twitter.url" LIMIT 1;
UPDATE `engine4_core_settings` SET `value` = "https://youtube.com" WHERE `engine4_core_settings`.`name` = "captivate.youtube.url" LIMIT 1;
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "captivate.footer.select.logo" LIMIT 1;
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.static.baseurl" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.analytics.code" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.general.site.keywords" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.general.analytics" LIMIT 1 ;
'; 

$final_query = $this->updateRecaptchaKeys($params, $final_query);
$final_query = $this->updateJanrainKeys($params, $final_query);
$final_query = $this->updateTwitterKeys($params, $final_query);
$final_query = $this->updateFacebookKeys($params, $final_query);
$final_query = $this->updateWindowliveKeys($params, $final_query);   
       
$final_query .= '
DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`name` = "core.html-block";
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "birthdayemail.admin" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "event.contactemail.admin" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "siteeventemail.admin" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "testemail.admin" LIMIT 1;
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "document.secret.key";
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "eventdocument.secret.key";
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "groupdocument.secret.key";
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "siteeventdocument.secret.key";
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "sitegroupdocument.secret.key";
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "sitepagedocument.secret.key";
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "document.api.key";
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "eventdocument.api.key";
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "groupdocument.api.key";
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "siteeventdocument.api.key";
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "sitegroupdocument.api.key";
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "sitepagedocument.api.key";
UPDATE `engine4_core_settings` SET `value` = "csv" WHERE `engine4_core_settings`.`name` = "core.translate.adapter" LIMIT 1 ;
UPDATE `engine4_core_themes` SET `active` = "0" WHERE `engine4_core_themes`.`name` ="demotheme" LIMIT 1 ;


INSERT INTO `engine4_payment_gateways` (`title`, `description`, `enabled`, `plugin`, `config`, `test_mode`) VALUES
("2Checkout", NULL, 0, "Payment_Plugin_Gateway_2Checkout", NULL, 0),
("PayPal", NULL, 0, "Payment_Plugin_Gateway_PayPal", NULL, 0),
("Testing", NULL, 0, "Payment_Plugin_Gateway_Testing", NULL, 1);
DELETE FROM `engine4_core_content` WHERE `name` LIKE "%bigstep.%";
UPDATE `engine4_core_content` SET params = REPLACE(params, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE params LIKE "%'.$this->_httpHost.'%";
UPDATE `engine4_core_content` SET params = REPLACE(params, "SocialEngineAddOns.com", "' . $replace_url . '") WHERE params LIKE "%SocialEngineAddOns.com%";
UPDATE `engine4_core_content` SET params = REPLACE(params, "socialengineaddons.com", "' . $replace_url . '") WHERE params LIKE "%socialengineaddons.com%";
UPDATE `engine4_core_content` SET params = REPLACE(params, "SocialEngineAddOns", "' . $siteTitle . '") WHERE params LIKE "%SocialEngineAddOns%"; 
UPDATE `engine4_core_content` SET params = REPLACE(params, "socialengineaddons", "' . $siteTitle . '") WHERE params LIKE "%socialengineaddons%"; 
UPDATE `engine4_core_links` SET uri = REPLACE(uri, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE uri LIKE "%'.$this->_httpHost.'%";
UPDATE `engine4_core_links` SET title = REPLACE(title, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE title LIKE "%'.$this->_httpHost.'%";
UPDATE `engine4_core_links` SET description = REPLACE(description, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE description LIKE "%'.$this->_httpHost.'%";
UPDATE `engine4_core_settings` SET value = REPLACE(value, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE value LIKE "%'.$this->_httpHost.'%" AND name NOT IN ("demo.host.name");
UPDATE `engine4_core_settings` SET value = REPLACE(value, "SocialEngineAddOns.com", "' . $replace_url . '") WHERE value LIKE "%SocialEngineAddOns.com%" AND name NOT IN ("demo.host.name");
UPDATE `engine4_core_settings` SET value = REPLACE(value, "socialengineaddons.com", "' . $replace_url . '") WHERE value LIKE "%socialengineaddons.com%" AND name NOT IN ("demo.host.name");
UPDATE `engine4_core_settings` SET value = REPLACE(value, "SocialEngineAddOns", "' . $siteTitle . '") WHERE value LIKE "%SocialEngineAddOns%" AND name NOT IN ("demo.host.name");
UPDATE `engine4_core_settings` SET value = REPLACE(value, "socialengineaddons", "' . $siteTitle . '") WHERE value LIKE "%socialengineaddons%" AND name NOT IN ("demo.host.name");
UPDATE `engine4_core_search` SET description = REPLACE(description, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE description LIKE "%'.$this->_httpHost.'%";
UPDATE `engine4_core_search` SET description = REPLACE(description, "SocialEngineAddOns.com", "' . $replace_url . '") WHERE description LIKE "%SocialEngineAddOns.com%";
UPDATE `engine4_core_search` SET description = REPLACE(description, "socialengineaddons.com", "' . $replace_url . '") WHERE description LIKE "%socialengineaddons.com%";
UPDATE `engine4_core_mailtemplates` SET email_signature_en = REPLACE(email_signature_en, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE email_signature_en LIKE "%'.$this->_httpHost.'%";
UPDATE `engine4_core_mailtemplates` SET email_signature_en = REPLACE(email_signature_en, "socialengineaddons.com", "' . $replace_url . '") WHERE email_signature_en LIKE "%socialengineaddons.com%";
UPDATE `engine4_core_mailtemplates` SET email_signature_en = REPLACE(email_signature_en, "SocialEngineAddOns", "' . $siteTitle . '") WHERE email_signature_en LIKE "%SocialEngineAddOns%";
UPDATE `engine4_core_status` SET body = REPLACE(body, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE body LIKE "%'.$this->_httpHost.'%";
UPDATE `engine4_core_status` SET body = REPLACE(body, "SocialEngineAddOns.com", "' . $replace_url . '") WHERE body LIKE "%SocialEngineAddOns.com%";
UPDATE `engine4_core_status` SET body = REPLACE(body, "socialengineaddons.com", "' . $replace_url . '") WHERE body LIKE "%socialengineaddons.com%";
UPDATE `engine4_core_mailtemplates` SET email_signature_en = REPLACE(email_signature_en, "socialengineaddons", "' . $siteTitle . '") WHERE email_signature_en LIKE "%socialengineaddons%";
UPDATE `engine4_core_search` SET title = REPLACE(title, "socialengineaddons", "' . $siteTitle . '") WHERE title LIKE "%socialengineaddons%";
UPDATE `engine4_core_search` SET description = REPLACE(description, "socialengineaddons", "' . $siteTitle . '") WHERE description LIKE "%socialengineaddons%";
UPDATE `engine4_core_status` SET body = REPLACE(body, "socialengineaddons", "' . $siteTitle . '") WHERE body LIKE "%socialengineaddons%";
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` IN ("backup.navi.auth", "sitestaticpage.navi.auth", "grouppoll.navi.auth","siteestore.navi.auth","suggestion.navi.auth","userconnection.navi.auth","feedback.navi.auth","facebookse.navi.auth","facebooksefeed.navi.auth","facebooksepage.navi.auth","nestedcomment.navi.auth","documentsv4.navi.auth","eventdocument.navi.auth","groupdocument.navi.auth","sitegroupdocument.navi.auth", "sitepagedocument.navi.auth", "eventdocument.isActivate", "sitegroupdocument.isActivate", "sitepagedocument.isActivate", "sitestaticpage.isActivate", "grouppoll.isActivate", "siteestore.isActivate", "feedback.isActivate", "sitecoupon.isActivate", "nestedcomment.isActivate");

DELETE FROM `engine4_core_modules` WHERE `engine4_core_modules`.`name` = "communityad" LIMIT 1;
DELETE FROM `engine4_core_modules` WHERE `engine4_core_modules`.`name` = "communityadsponsored" LIMIT 1;
DELETE FROM `engine4_core_modules` WHERE `engine4_core_modules`.`name` = "sitemobile" LIMIT 1;
DELETE FROM `engine4_core_modules` WHERE `engine4_core_modules`.`name` = "sitemobileapp" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "sitemobile.isActivate" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "document.isActivate" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "sitemobile.navi.auth" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "sitemobile.lsettings" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "sitemobileapp.isActivate" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "sitemobileapp.navi.auth" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "sitemobileapp.lsettings" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "communityad.isActivate" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "communityad.navi.auth" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "communityad.lsettings" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "communityadsponsored.isActivate" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "communityadsponsored.navi.auth" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "communityadsponsored.lsettings" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "sitevideo.youtube.apikey" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "video.youtube.apikey" LIMIT 1;
UPDATE `engine4_core_modules` SET `enabled` = "0" WHERE `engine4_core_modules`.`name` = "mobi" LIMIT 1 ;
DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`name` = "seaocore.layout-width";

';

        //start update query for user table.
        $usertable = Engine_Api::_()->getDbtable('users', 'user');
        $select = $usertable->select()->from($usertable->info('name'), 'email')->where('email LIKE ?', '%seaddons.com%');
        $usersitepages = $usertable->fetchAll($select);
        foreach ($usersitepages->toarray() as $email) {
            $replace_email = '@' . $siteLink;
            $email = $email['email'];
            $emails = str_replace('@seaddons.com', $replace_email, $email);
            $final_query .= 'UPDATE `engine4_users` SET `email` = "' . $emails . '" WHERE `engine4_users`.`email` = "' . $email . '";';
        }
        //END UPDATE QUERY FOR USER TABLE.
        //UPDATE demo.socialapps.tech AND SOCIALENGINEADDONS.COM TO SITE URL.
        if (in_array('advancedslideshow', $installedModuleArray)) {
            $replace_url = $siteLink;
            $final_query .= 'UPDATE `engine4_advancedslideshow_images` SET `url` = REPLACE(url, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE `url` LIKE "%'.$this->_httpHost.'%";';
            $final_query .= 'UPDATE `engine4_advancedslideshow_images` SET `url` = REPLACE(url, "socialengineaddons.com", "' . $replace_url . '") WHERE `url` LIKE "%socialengineaddons.com%";';
            $final_query .= 'UPDATE `engine4_advancedslideshow_images` SET `slide_html` = REPLACE(slide_html, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE `slide_html` LIKE "%'.$this->_httpHost.'%";';
            $final_query .= 'UPDATE `engine4_advancedslideshow_images` SET `slide_html` = REPLACE(slide_html, "socialengineaddons.com", "' . $replace_url . '") WHERE `slide_html` LIKE "%socialengineaddons.com%";';
            $final_query .= 'UPDATE `engine4_advancedslideshow_images` SET caption = REPLACE(caption, "socialengineaddons", "' . $siteTitle . '") WHERE caption LIKE "%socialengineaddons%";'; 
        }

        if (in_array('sitestore', $installedModuleArray)) {
            $final_query .= 'UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "sitestore.checkout.fixed.text.value" LIMIT 1 ;';
            $final_query .= 'UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "sitestore.defaultpagecreate.email" LIMIT 1 ;';
            $final_query .= 'UPDATE `engine4_core_settings` SET `value` = "'.$this->_httpHost.'" WHERE `engine4_core_settings`.`name` = "sitestore.level.createhost" LIMIT 1 ;';
        }

        //start update query for user table.
        if (in_array('sitestoreproduct', $installedModuleArray)) { 
            $final_query .= 'UPDATE `engine4_sitestoreproduct_order_addresses` SET email = REPLACE(email, "bigsteptech.com", "'.$siteLink.'") WHERE email LIKE "%bigsteptech.com%"';
            $final_query .= 'UPDATE `engine4_sitestoreproduct_order_addresses` SET email = REPLACE(email, "seaddons.com", "'.$siteLink.'") WHERE email LIKE "%seaddons.com%"'; 
            //END UPDATE QUERY FOR USER TABLE.

            $final_query .= 'UPDATE `engine4_sitestoreproduct_addresses` SET `email` = "" WHERE `engine4_sitestoreproduct_addresses`.`email` LIKE "%bigsteptech.com%";';
            $final_query .= 'UPDATE `engine4_sitestoreproduct_gateways` SET `email` = "" WHERE `engine4_sitestoreproduct_gateways`.`email` LIKE "%bigsteptech.com%";';
            $final_query .= 'UPDATE `engine4_sitestoreproduct_notify_emails` SET `buyer_email` = "" WHERE `engine4_sitestoreproduct_notify_emails`.`buyer_email` LIKE "%bigsteptech.com%";';
            $final_query .= 'UPDATE `engine4_sitestoreproduct_order_addresses` SET `email` = "" WHERE `engine4_sitestoreproduct_order_addresses`.`email` LIKE "%bigsteptech.com%";';
            $final_query .= 'UPDATE `engine4_sitestoreproduct_startuppages` SET description = REPLACE(description, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE description LIKE "%'.$this->_httpHost.'%";';
            $final_query .= 'UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "sitestoreproduct.defaultproductcreate.email" LIMIT 1 ;';  
        }

        //start custom pages delete.
        // $corepagesTable = Engine_Api::_()->getDbtable('pages', 'core');
        // $select = $corepagesTable->select()->from($corepagesTable->info('name'), 'page_id')->where('url != ?', '0');
        // $results = $corepagesTable->fetchAll($select);
        // foreach ($results->toarray() as $page_id) {
        //     $final_query .= 'DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`page_id` = "' . $page_id['page_id'] . '";';
        //     $final_query .= 'DELETE FROM `engine4_core_pages` WHERE `engine4_core_pages`.`page_id` = "' . $page_id['page_id'] . '";';
        // }
        //end delete costom pages delete. 

        if (in_array('sitepagenote', $installedModuleArray)) {
            $final_query .= 'UPDATE `engine4_sitepagenote_notes` SET body = REPLACE(body, "socialengineaddons.com", "' . $replace_url . '") WHERE body LIKE "%socialengineaddons.com%";'; 
        }

        if (in_array('sitestoreoffer', $installedModuleArray)) {
            $final_query .= 'UPDATE `engine4_sitestoreoffer_offers` SET url = REPLACE(url, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE url LIKE "%'.$this->_httpHost.'%";'; 
        }
        
        if (in_array('feedback', $installedModuleArray)) {
            $final_query .= 'UPDATE `engine4_feedbacks` SET `anonymous_email` = "" WHERE `engine4_feedbacks`.`anonymous_email` LIKE "%bigsteptech.com%";';
            $final_query .= 'UPDATE `engine4_feedbacks` SET anonymous_email = REPLACE(anonymous_email, "socialengineaddons.com", "' . $replace_url . '") WHERE anonymous_email LIKE "%socialengineaddons.com%";';
        }

        if (in_array('sitemailtemplates', $installedModuleArray)) {
            $final_query .= 'UPDATE `engine4_sitemailtemplates_templates` SET `testemail_admin` = "" WHERE `engine4_sitemailtemplates_templates`.`testemail_admin` LIKE "%bigsteptech.com%";'; 
            $final_query .= 'UPDATE `engine4_core_settings` SET `value` = "' . $siteTitle . '" WHERE `engine4_core_settings`.`name` = "sitemailtemplates.site.title" LIMIT 1 ;';
        }

        if (in_array('album', $installedModuleArray)) {
            $final_query .= 'UPDATE `engine4_album_categories` SET banner_url = REPLACE(banner_url, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE banner_url LIKE "%'.$this->_httpHost.'%";'; 
        }

        if (in_array('forum', $installedModuleArray)) {
            $final_query .= 'UPDATE `engine4_forum_posts` SET body = REPLACE(body, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE body LIKE "%'.$this->_httpHost.'%";'; 
            $final_query .= 'UPDATE `engine4_forum_topics` SET description = REPLACE(description, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE description LIKE "%'.$this->_httpHost.'%";';
        }

        if (in_array('sitestaticpage', $installedModuleArray)) {
            $final_query .= 'UPDATE `engine4_sitestaticpage_pages` SET body = REPLACE(body, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE body LIKE "%'.$this->_httpHost.'%";';
            $final_query .= 'UPDATE `engine4_sitestaticpage_page_fields_options` SET `email` = "" WHERE `engine4_sitestaticpage_page_fields_options`.`email` LIKE "%bigsteptech.com%";';
            $final_query .= 'UPDATE `engine4_sitestaticpage_page_fields_options` SET email = REPLACE(email, "niranjan@bigsteptech.com", "") WHERE email LIKE "%niranjan@bigsteptech.com%";';
        }  

        if (in_array('suggestion', $installedModuleArray)) { 
            $final_query .= 'UPDATE `engine4_suggestion_introductions` SET content = REPLACE(content, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE content LIKE "%'.$this->_httpHost.'%";';
            $final_query .= 'DELETE FROM `engine4_user_signup` WHERE `engine4_user_signup`.`class` = "Suggestion_Plugin_Signup_Invite" LIMIT 1;';
        }

        if (in_array('facebookse', $installedModuleArray)) { 
            $final_query .= 'UPDATE `engine4_facebookse_mixsettings` SET title = REPLACE(title, "socialengineaddons", "' . $siteTitle . '") WHERE title LIKE "%socialengineaddons%";';
            $final_query .= 'UPDATE `engine4_facebookse_mixsettings` SET description = REPLACE(description, "socialengineaddons", "' . $siteTitle . '") WHERE description LIKE "%socialengineaddons%";';
        }

        if (in_array('sitereview', $installedModuleArray) && in_array('sitereviewlistingtype', $installedModuleArray)) {
            
        }

        if (in_array('sitefaq', $installedModuleArray)) { 
            $final_query .= 'UPDATE `engine4_sitefaq_questions` SET title = REPLACE(title, "socialengineaddons", "' . $siteTitle . '") WHERE title LIKE "%socialengineaddons%";';
            $final_query .= 'UPDATE `engine4_sitefaq_questions` SET `anonymous_email` = "" WHERE `engine4_sitefaq_questions`.`anonymous_email` LIKE "%bigsteptech.com%";';
            $final_query .= 'UPDATE `engine4_sitefaq_categories` SET category_name = REPLACE(category_name, "socialengineaddons", "' . $siteTitle . '") WHERE category_name LIKE "%socialengineaddons%";';
        }

        if (in_array('sitevideo', $installedModuleArray)) {
            $final_query .= 'DELETE FROM `engine4_core_settings` WHERE `name` LIKE "sitevideo.lending.block.%";';
        }

        if (in_array('siteevent', $installedModuleArray)) { 
            $final_query .= 'UPDATE `engine4_siteevent_organizers` SET twitter_url = REPLACE(twitter_url, "socialengineaddons", "' . $siteTitle . '") WHERE twitter_url LIKE "%socialengineaddons%";';
            $final_query .= 'UPDATE `engine4_siteevent_organizers` SET facebook_url = REPLACE(facebook_url, "socialengineaddons", "' . $siteTitle . '") WHERE facebook_url LIKE "%socialengineaddons%";';
            $final_query .= 'UPDATE `engine4_siteevent_organizers` SET web_url = REPLACE(web_url, "socialengineaddons.com", "' . $replace_url . '") WHERE web_url LIKE "%socialengineaddons.com%";'; 
            $final_query .= 'UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "siteevent.contact" LIMIT 1 ;';
            $final_query .= 'UPDATE `engine4_siteevent_categories` SET `banner_url` = REPLACE(banner_url, "'.$this->_httpHost.'", "' . $siteLink . '") WHERE `banner_url` LIKE "%'.$this->_httpHost.'%";';
        } 

        if (in_array('sitemobile', $installedModuleArray)) {
            $final_query .= 'UPDATE `engine4_sitemobile_menuitems` SET `params` = REPLACE(params, "'.$this->_httpHost.'", "' . $siteLink . '") WHERE `params` LIKE "%'.$this->_httpHost.'%";';
            $final_query .= 'UPDATE `engine4_sitemobile_menuitems` SET params = REPLACE(params, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE params LIKE "%'.$this->_httpHost.'%";'; 
        }

        if (in_array('sitereview', $installedModuleArray)) {
            $final_query .= 'UPDATE `engine4_sitereview_categories` SET `banner_url` = REPLACE(banner_url, "'.$this->_httpHost.'", "' . $siteLink . '") WHERE `banner_url` LIKE "%'.$this->_httpHost.'%";';
            $final_query .= 'UPDATE `engine4_sitereview_priceinfo` SET `url` = REPLACE(url, "'.$this->_httpHost.'", "' . $siteLink . '") WHERE `url` LIKE "%'.$this->_httpHost.'%";';
            $final_query .= 'UPDATE `engine4_sitereview_otherinfo` SET `overview` = REPLACE(overview, "'.$this->_httpHost.'", "' . $siteLink . '") WHERE `overview` LIKE "%'.$this->_httpHost.'%";';
            $final_query .= 'UPDATE `engine4_sitereview_reviews` SET `anonymous_email` = "" WHERE `engine4_sitereview_reviews`.`anonymous_email` LIKE "%bigsteptech.com%";';
            $final_query .= 'UPDATE `engine4_sitereview_listings` SET body = REPLACE(body, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE body LIKE "%'.$this->_httpHost.'%";';
            $final_query .= 'UPDATE `engine4_sitereview_posts` SET body = REPLACE(body, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE body LIKE "%'.$this->_httpHost.'%";';
            $final_query .= 'UPDATE `engine4_sitereview_priceinfo` SET title = REPLACE(title, "socialengineaddons", "' . $siteTitle . '") WHERE title LIKE "%socialengineaddons%";';  
            $final_query .= 'UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "sitereview.contact" LIMIT 1 ;';
        }  
        
        if (in_array('sitepage', $installedModuleArray)) {
            $final_query .= 'UPDATE `engine4_core_settings` SET `value` = "' . $siteTitle . '" WHERE `engine4_core_settings`.`name` = "sitepage.site.title" LIMIT 1 ;';
            $final_query .= 'UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "sitepage.admin" LIMIT 1 ;';
            $final_query .= 'UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "sitepage.googleapikey" LIMIT 1 ;
                DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "sitepage.defaultpagecreate.email" LIMIT 1;';
        }
        if (in_array('sitepageoffer', $installedModuleArray)) {
            $final_query .= 'UPDATE `engine4_sitepageoffer_offers` SET `url` = REPLACE(url, "'.$this->_httpHost.'", "' . $siteLink . '") WHERE `url` LIKE "%'.$this->_httpHost.'%";';
        }
        if (in_array('sitepushnotification', $installedModuleArray)) {
            $final_query .= 'UPDATE `engine4_core_settings` SET `value` = "' . $siteTitle . '" WHERE `engine4_core_settings`.`name` = "sitepushnotification.title" LIMIT 1 ;';
            $final_query .= 'UPDATE `engine4_core_settings` SET `value` = "' . $siteTitle . '" WHERE `engine4_core_settings`.`name` = "sitepushnotification.subdomain" LIMIT 1 ;';
        }
        if (in_array('siteseo', $installedModuleArray)) {
            $final_query .= 'UPDATE `engine4_core_settings` SET `value` = "' . $this->_httpHost . '" WHERE `engine4_core_settings`.`name` = "siteseo.schema.alternate.name" LIMIT 1 ;';
            $final_query .= 'UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "siteseo.google.service.account.key" LIMIT 1 ;';
            $final_query .= 'UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "siteseo.schema.alternate.name" LIMIT 1 ;';
            $final_query .= 'UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "siteseo.schema.logo" LIMIT 1 ;';
            $final_query .= 'UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "siteseo.schema.social.facebook" LIMIT 1 ;';
        }

        if (in_array('birthdayemail', $installedModuleArray)) {
            $final_query .= 'UPDATE `engine4_core_settings` SET `value` = "' . $siteTitle . '" WHERE `engine4_core_settings`.`name` = "birthdayemail.site.title" LIMIT 1 ;';
        }
        if (in_array('siteeventinvite', $installedModuleArray)) {
            $final_query .= 'UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "siteeventinvitefriends.google.api" LIMIT 1 ;';
        }
        if (in_array('siteslideshow', $installedModuleArray)) {
            $final_query .= 'UPDATE `engine4_core_settings` SET `value` = "' . $this->_httpHost . '" WHERE `engine4_core_settings`.`name` = "siteslideshow.modulename" LIMIT 1 ;';
        }
        if (in_array('sitegroup', $installedModuleArray)) {
            $final_query .= 'UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "sitegroup.defaultgroupcreate.email" LIMIT 1 ;';
            $final_query .= 'UPDATE `engine4_core_settings` SET `value` = "'.$this->_httpHost.'" WHERE `engine4_core_settings`.`name` = "sitegroup.level.createhost" LIMIT 1 ;';
            $final_query .= 'UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "sitegroup.request.listtype" LIMIT 1 ;';
        }

        if (in_array('siteotpverifier', $installedModuleArray)) {
            $final_query .= '
            UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "siteotpverifier.amazon.clientId" LIMIT 1; 
            UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "siteotpverifier.amazon.clientSecret" LIMIT 1;'; 
        }
        if (in_array('sitelogin', $installedModuleArray)) {  
            $final_query = $this->updateYahooKeys($params, $final_query);
            $final_query = $this->updateVkKeys($params, $final_query);
            $final_query = $this->updatePinterestKeys($params, $final_query);
            $final_query = $this->updateOutlookKeys($params, $final_query);
            $final_query = $this->updateLinkedinKeys($params, $final_query);
            $final_query = $this->updateInstagramKeys($params, $final_query);
            $final_query = $this->updateGoogleClientKeys($params, $final_query);
            $final_query = $this->updateFlickrKeys($params, $final_query);  
        } 

        //GREETINGS TABLE HAS THE HTML SAVED IN BODY WITH OUR DEMO URL, TO REMOVE THAT WE'LL RE-CREATE THE GREETINGS
        if (in_array('advancedactivity', $installedModuleArray)) {
            if(count($db->query("SHOW TABLES LIKE 'engine4_advancedactivity_greetings';")->fetchAll()) > 0) {
                $db->query("TRUNCATE engine4_advancedactivity_greetings;");
            } 
            if(count($db->query("SHOW TABLES LIKE 'engine4_advancedactivity_banners';")->fetchAll()) > 0) {
                $db->query("TRUNCATE engine4_advancedactivity_banners;");
            }
            //CREATION OF BANNERS AND GREETINGS AGAIN
            include APPLICATION_PATH.'/application/modules/Advancedactivity/settings/ActivationSettings.php';   
            $objectAdvancedactivity = new Advancedactivity_ActivationSettings();
            $objectAdvancedactivity->createDefaultBannerAndGreeting();
        }

        $final_query .= 'UPDATE `engine4_core_menuitems` SET `params` = REPLACE(params, "'.$this->_httpHost.'", "' . $siteLink . '") WHERE `params` LIKE "%'.$this->_httpHost.'%";'; 

        //HERE WE HAVE TO DROP WHICH MODULE ALL TABLE WHICH WE DO NOT WANT TO SETUP AT HIS SITE.
        $table_name = array();
        $disabledModulesArray = Engine_Api::_()->sitesetup()->getDisabledModulesArray();
        $removalModulesArray = !empty($params['modules_name']) ? $params['modules_name'] : array(); 
        $removalModulesArray = array_merge($this->_moduleArray, $removalModulesArray); 
        $removalModulesArray = array_merge($removalModulesArray, $disabledModulesArray); 

        //DO NOT REMOVE THESE MODULES THESE CREATE PROBLEM IN PLUGIN
        if (($key = array_search('album', $removalModulesArray)) !== false) {
            unset($removalModulesArray[$key]);
        }
        if (($key = array_search('forum', $removalModulesArray)) !== false) {
            unset($removalModulesArray[$key]);
        }
        if (($key = array_search('video', $removalModulesArray)) !== false) {
            unset($removalModulesArray[$key]);
        }
        if (($key = array_search('poke', $removalModulesArray)) !== false) {
            unset($removalModulesArray[$key]);
        }

        //IF THE SITAPGE IS SELECTED THAN TAKE IT'S EXTENSIONS ALSO
        if (in_array('sitepage', $removalModulesArray)) {
            $removalModulesArray = array_merge($removalModulesArray, array('sitepagealbum','sitepagebadge','sitepagediscussion','sitepageevent','sitepageform','sitepageintegration','sitepageinvite','sitepagelikebox','sitepagemember','sitepagemusic','sitepagenote','sitepageoffer','sitepagepoll','sitepagereview','sitepageurl','sitepagevid'));
        }
        if (in_array('sitegroup', $removalModulesArray)) {
            $removalModulesArray = array_merge($removalModulesArray, array("sitegroupadmincontact","sitegroupalbum","sitegroupbadge","sitegroupdiscussion","sitegroupevent","sitegroupform","sitegroupintegration","sitegroupinvite","sitegrouplikebox","sitegroupmember","sitegroupmusic","sitegroupnote","sitegroupoffer","sitegrouppoll","sitegroupreview","sitegroupurl","sitegroupvideo"));
        }
        if (in_array('sitestore', $removalModulesArray)) {
            $removalModulesArray = array_merge($removalModulesArray, array("sitestoreadmincontact","sitestorealbum","sitestoreform","sitestoreinvite","sitestorelikebox","sitestoreoffer","sitestoreproduct","sitestorereview","sitestoreurl","sitestorevideo")); 
        } 
        if (in_array('siteevent', $removalModulesArray)) {
            $removalModulesArray = array_merge($removalModulesArray, array("siteeventadmincontact","siteeventemail","siteeventinvite","siteeventpaid","siteeventrepeat","siteeventticket")); 
        }
        if (in_array('sitereview', $removalModulesArray)) {
            $removalModulesArray = array_merge($removalModulesArray, array("sitereviewlistingtype","sitereviewpaidlisting")); 
        }
        if (in_array('sitevideo', $removalModulesArray)) {
            $removalModulesArray = array_merge($removalModulesArray, array("sitevideointegration")); 
        }
        if (in_array('document', $removalModulesArray)) {
            $removalModulesArray = array_merge($removalModulesArray, array("documentintegration")); 
        }

        //add above same work for the business plugin and other dependant plugins also

        if (in_array('sitelogin', $removalModulesArray)) {
            $final_query .= 'UPDATE `engine4_user_signup` SET `class` = "User_Plugin_Signup_Fields" WHERE `class` = "Sitelogin_Plugin_Signup_Fields"; ';
            $final_query .= 'UPDATE `engine4_user_signup` SET `class` = "User_Plugin_Signup_Photo" WHERE `class` = "Sitelogin_Plugin_Signup_Photo"; ';  
        }

        if (in_array('siteotpverifier', $removalModulesArray)) {
            $final_query .= '
            DELETE FROM `engine4_user_signup` WHERE `engine4_user_signup`.`class` = "Siteotpverifier_Plugin_Signup_Otpverify";'; 
        }
        if (in_array('peopleyoumayknow', $removalModulesArray)) {
            $final_query .= '
            DELETE FROM `engine4_user_signup` WHERE `engine4_user_signup`.`class` = "Peopleyoumayknow_Plugin_Signup_Invite";'; 
        }

        if (in_array('sitesubscription', $removalModulesArray)) { 
            $final_query .= 'UPDATE `engine4_user_signup` SET `class` = "User_Plugin_Signup_Fields" WHERE `class` = "Sitesubscription_Plugin_Signup_Fields"; ';
            $final_query .= 'UPDATE `engine4_user_signup` SET `class` = "Payment_Plugin_Signup_Subscription" WHERE `class` = "Sitesubscription_Plugin_Signup_Subscription"; ';
        }

        foreach ($removalModulesArray as $module) { 
            $tables_array = $db->query("SHOW tables like '%engine4_" . $module . "_%'")->fetchAll();
            foreach ($tables_array as $table) {
                $temp = "Tables_in_" . $database . " (%engine4_" . $module . "_%)";
                $table_name = $table[$temp];
                if (!empty($table_name)) {
                    $table_exist = $db->query("SHOW TABLES LIKE '$table_name'")->fetch();
                    if (!empty($table_exist)) {
                        $final_query .= "DROP TABLE IF EXISTS `$table_name`;";
                    }
                }
            } 
            //We have deleted the all modules which do not want to installed on the site.
            $final_query .= 'DELETE FROM `engine4_core_modules` WHERE `engine4_core_modules`.`name` = "' . $module . '" LIMIT 1;';
            $final_query .= 'DELETE FROM `engine4_activity_notificationtypes` WHERE `engine4_activity_notificationtypes`.`module` = "' . $module . '";';
            $final_query .= 'DELETE FROM `engine4_seaocores` WHERE `engine4_seaocores`.`module_name` = "' . $module . '";';
            $final_query .= 'DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`name` LIKE "' . $module . '.%";';
            $final_query .= 'DELETE FROM `engine4_seaocore_searchformsetting` WHERE `engine4_seaocore_searchformsetting`.`module` LIKE "' . $module . '.%";';
            $final_query .= 'DELETE FROM `engine4_seaocore_favourites` WHERE `engine4_seaocore_favourites`.`resource_type` LIKE "' . $module . '.%";';
            $final_query .= 'DELETE FROM `engine4_seaocore_follows` WHERE `engine4_seaocore_follows`.`resource_type` LIKE "' . $module . '.%";';
            if(count($db->query("SHOW TABLES LIKE 'engine4_seaocore_integrated';")->fetchAll()) > 0) {
                $final_query .= 'DELETE FROM `engine4_seaocore_integrated` WHERE `engine4_seaocore_integrated`.`item_module` LIKE "' . $module . '.%";'; 
            }
            $final_query .= 'DELETE FROM `engine4_seaocore_invites` WHERE `engine4_seaocore_invites`.`resource_type` LIKE "' . $module . '.%";';
            $final_query .= 'DELETE FROM `engine4_seaocore_locationitems` WHERE `engine4_seaocore_locationitems`.`resource_type` LIKE "' . $module . '.%";';
            $final_query .= 'DELETE FROM `engine4_seaocore_tabs` WHERE `engine4_seaocore_tabs`.`module` = "' . $module . '";';
            $final_query .= 'DELETE FROM `engine4_core_tasks` WHERE `engine4_core_tasks`.`module` = "' . $module . '";';
            $final_query .= 'DELETE FROM `engine4_core_jobtypes` WHERE `engine4_core_jobtypes`.`module` = "' . $module . '";';
             
            //delete page from 'engine4_core_pages' table.
            $moduleNew = $module . "_";
            $pagesArray = $db->query("SELECT * FROM `engine4_core_pages` WHERE `name` LIKE '$moduleNew%'")->fetchAll();
            foreach ($pagesArray as $page) {
                $pageName = $page['name'];
                $final_query .= 'DELETE FROM `engine4_core_pages` WHERE `engine4_core_pages`.`name` = "' . $pageName . '";';
            }

            //delete settings from 'engine4_core_settings' table.
            $settingsArray = $db->query("SELECT * FROM `engine4_core_settings` WHERE `name` LIKE '$module%'")->fetchAll();
            foreach ($settingsArray as $table) {
                $name = $table['name'];
                $final_query .= 'DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "' . $name . '";';
            }

            //delete page from 'engine4_core_menuitems' table.
            $menusArray = $db->query("SELECT * FROM `engine4_core_menuitems` WHERE `module` LIKE '$module%'")->fetchAll();
            foreach ($menusArray as $menu) {
                $moduleName = $menu['module'];
                $final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`module` = "' . $moduleName . '";';
            } 
            
            $final_query .= 'DELETE FROM `engine4_core_comments` WHERE `engine4_core_comments`.`resource_type` = "' . $module . '" OR `engine4_core_comments`.`resource_type` LIKE "' . $moduleNew . '%";';
            $final_query .= 'DELETE FROM `engine4_core_likes` WHERE `engine4_core_likes`.`resource_type` = "' . $module . '" OR `engine4_core_likes`.`resource_type` LIKE "' . $moduleNew . '%";';
            $final_query .= 'DELETE FROM `engine4_core_styles` WHERE `engine4_core_styles`.`type` = "' . $module . '" OR `engine4_core_styles`.`type` LIKE "' . $moduleNew . '%";';
            $final_query .= 'DELETE FROM `engine4_core_search` WHERE `engine4_core_search`.`type` = "' . $module . '" OR `engine4_core_search`.`type` LIKE "' . $moduleNew . '%";';
            $final_query .= 'DELETE FROM `engine4_core_tagmaps` WHERE `engine4_core_tagmaps`.`resource_type` = "' . $module . '" OR `engine4_core_tagmaps`.`resource_type` LIKE "' . $moduleNew . '%";';
            $final_query .= 'DELETE FROM `engine4_storage_files` WHERE `engine4_storage_files`.`parent_type` = "' . $module . '" OR `engine4_storage_files`.`parent_type` LIKE "' . $moduleNew . '%";';
            $final_query .= 'DELETE FROM `engine4_activity_actiontypes` WHERE `engine4_activity_actiontypes`.`module` = "' . $module . '";';
            $final_query .= 'DELETE FROM `engine4_activity_actiontypes` WHERE `engine4_activity_actiontypes`.`type` LIKE "' . $moduleNew . '%";';
            $final_query .= 'DELETE FROM `engine4_authorization_allow` WHERE `engine4_authorization_allow`.`resource_type` = "' . $module . '" OR `engine4_authorization_allow`.`resource_type` LIKE "' . $moduleNew . '%";';
            $final_query .= 'DELETE FROM `engine4_authorization_permissions` WHERE `engine4_authorization_permissions`.`type` = "' . $module . '" OR `engine4_authorization_permissions`.`type` LIKE "' . $moduleNew . '%";';
        }
        $final_query = trim($final_query);
        return $final_query;
    } 

    private function updateRecaptchaKeys($params, $final_query) 
    {
        $enable = 0;
        $final_query .= '
        UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.spam.recaptchapublic" LIMIT 1; 
        UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.spam.recaptchaprivate" LIMIT 1;
        UPDATE `engine4_core_settings` SET `value` = "'.$enable.'" WHERE `engine4_core_settings`.`name` = "core.spam.recaptchaenabled" LIMIT 1;';
        return $final_query;
    }

    private function updateFacebookKeys($params, $final_query) 
    {  
        $final_query .= '
        UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.facebook.appid" LIMIT 1 ;
        UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.facebook.secret" LIMIT 1 ;
        UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.facebook.key" LIMIT 1;';
        $final_query .= '
        UPDATE `engine4_core_settings` SET `value` = "none" WHERE `engine4_core_settings`.`name` = "core.facebook.enable" LIMIT 1;
        UPDATE `engine4_core_settings` SET `value` = "none" WHERE `engine4_core_settings`.`name` = "facebook.enable" LIMIT 1;';
       
        return $final_query;
    }

    private function updateTwitterKeys($params, $final_query) 
    {   
        $final_query .= '
        UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.twitter.key" LIMIT 1 ;
        UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.twitter.secret" LIMIT 1 ;';
        $final_query .= '
        UPDATE `engine4_core_settings` SET `value` = "none" WHERE `engine4_core_settings`.`name` = "core.twitter.enable" LIMIT 1;
        UPDATE `engine4_core_settings` SET `value` = "none" WHERE `engine4_core_settings`.`name` = "twitter.enable" LIMIT 1;';
      
        return $final_query;
    }
    private function updateJanrainKeys($params, $final_query) 
    {  
        $final_query .= '
            UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.janrain.domain" LIMIT 1;
            UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.janrain.key" LIMIT 1; 
            UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.janrain.id" LIMIT 1;';
        return $final_query;
    }
    private function updateWindowliveKeys($params, $final_query) 
    {   
        $final_query .= '
        UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "windowlive.apikey" LIMIT 1;  
        UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "windowlive.secretkey" LIMIT 1;
        UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "windowlive.policyurl" LIMIT 1;';
        return $final_query;
    }
    private function updateYahooKeys($params, $final_query) 
    {    
        $final_query .= '
        UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "sitelogin.yahoo.clientId" LIMIT 1;  
        UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "sitelogin.yahoo.clientSecret" LIMIT 1;
        UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "yahoo.apikey" LIMIT 1;  
        UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "yahoo.secretkey" LIMIT 1;';
        return $final_query;
    }
    private function updateVkKeys($params, $final_query) 
    {   
        $final_query .= '
        UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "sitelogin.vk.clientSecret" LIMIT 1;  
        UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "sitelogin.vk.clientId" LIMIT 1;';
        return $final_query;
    }

    private function updatePinterestKeys($params, $final_query) 
    {   
        $final_query .= '
        UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "sitelogin.pinterest.clientSecret" LIMIT 1;  
        UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "sitelogin.pinterest.clientId" LIMIT 1;';
        return $final_query;
    }

    private function updateOutlookKeys($params, $final_query) 
    {   
        $final_query .= '
        UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "sitelogin.outlook.clientSecret" LIMIT 1;  
        UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "sitelogin.outlook.clientId" LIMIT 1;';
        return $final_query;
    }

    private function updateLinkedinKeys($params, $final_query) 
    {    
        $final_query .= '
        UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "sitelogin.linkedin.clientSecret" LIMIT 1;  
        UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "sitelogin.linkedin.clientId" LIMIT 1;
        UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "linkedin.secretkey" LIMIT 1;  
        UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "linkedin.apikey" LIMIT 1;';
        $final_query .= 'UPDATE `engine4_core_settings` SET `value` = "0" WHERE `engine4_core_settings`.`name` = "linkedin.enable" LIMIT 1;';
        return $final_query;  
    }
    private function updateInstagramKeys($params, $final_query) 
    {   
        $final_query .= '
        UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "sitelogin.instagram.clientSecret" LIMIT 1;  
        UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "sitelogin.instagram.clientId" LIMIT 1;
        UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "instagram.secretkey" LIMIT 1; 
        UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "instagram.apikey" LIMIT 1;';
        return $final_query;
    }

    private function updateGoogleClientKeys($params, $final_query) 
    {    
        $final_query .= '
        UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "sitelogin.google.clientSecret" LIMIT 1;  
        UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "sitelogin.google.clientId" LIMIT 1;';
        return $final_query;
    }

    private function updateFlickrKeys($params, $final_query) 
    {   
        $final_query .= '
        UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "sitelogin.flickr.clientSecret" LIMIT 1;  
        UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "sitelogin.flickr.clientId" LIMIT 1;';
        return $final_query;
    }

} 
 