<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteshortcut
 * @copyright  Copyright 2017-2021 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Shortcuttype.php 2017-02-24 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteshortcut_Form_Admin_Manage_Shortcuttype extends Engine_Form
{

  public function init()
  {

    $this
      ->setTitle('Add New Automatic Shortcut Type')
      ->setDescription('Using the below form, add a new automatic shortcut type for which shortcuts will be created.');
    $notInclude = array('activity', 'user', 'sitebackup', 'advancedactivity', 'sitelike', 'sitepageoffer', 'sitepagebadge', 'featuredcontent', 'sitepagediscussion', 'sitepagelikebox', 'mobi', 'advancedslideshow', 'birthday', 'birthdayemail', 'communityad', 'dbbackup', 'facebookse', 'facebooksefeed', 'facebooksepage', 'feedback', 'groupdocument', 'grouppoll', 'mapprofiletypelevel', 'mcard', 'poke', 'sitepageinvite', 'siteslideshow', 'seaocore', 'suggestion', 'userconnection', 'sitepageform', 'sitepageadmincontact', 'sitepagealbum', 'sitebusinessbadge', 'sitebusinessoffer', 'sitebusinessdiscussion', 'sitebusinesslikebox', 'sitebusinessinvite', 'sitebusinessform', 'sitebusinessadmincontact', 'classified', 'document', 'forum', 'poll', 'list', 'music', 'recipe', 'sitepagenote', 'sitepagevideo', 'sitepagepoll', 'sitepagemusic', 'sitepageevent', 'sitepagereview', 'sitepagedocument', 'sitepageurl', 'sitepageintegration', 'sitebusinessalbum', 'sitebusinessevent', 'sitebusinessreview', 'sitebusinessdocument', 'sitebusinessurl', 'sitebusinessnote', 'sitebusinessvideo', 'sitebusinesspoll', 'sitebusinessmusic', 'communityadsponsored', 'sitestore', 'sitevideoview', 'sitegroupoffer', 'sitegroupbadge', 'sitegroupdiscussion', 'sitegrouplikebox', 'sitegroupinvite', 'sitegroupform', 'sitegroupalbum', 'sitegroupadmincontact', 'sitegroupnote', 'sitegroupnote', 'sitegroupvideo', 'sitegrouppoll', 'sitegroupmusic', 'sitegroupevent', 'sitegroupreview', 'sitegroupdocument', 'sitegroupurl', 'sitegroupintegration', 'sitegroupmember', 'sitestoreoffer', 'sitestorebadge', 'sitestorediscussion', 'sitestorelikebox', 'sitestoreinvite', 'sitestoreform', 'sitestoreadmincontact', 'sitestorenote', 'sitestore', 'sitestorenote', 'sitestorevideo', 'sitestorepoll', 'sitestoremusic', 'sitestorealbum', 'sitestoreevent', 'sitestorereview', 'sitestoredocument', 'sitestoreurl', 'sitestoreintegration', 'sitestoremember', 'sitepagemember', 'sitemobile', 'siteusercoverphoto', 'sitemobileapp', 'sitemailtemplates', 'sitehashtag', 'sitenews', 'siteshortcut', 'siteminify', 'sitereviewlistingtype');


    $module_table = Engine_Api::_()->getDbTable('modules', 'core');
    $moduleName = $module_table->info('name');
    $select = $module_table->select()
      ->from($moduleName, array('name', 'title'))
      ->where($moduleName . '.type =?', 'extra')
      ->where($moduleName . '.name not in(?)', $notInclude)
      ->where($moduleName . '.enabled =?', 1);
    $contentModuloe = $select->query()->fetchAll();
    $contentModuloeArray = array();
    if( !empty($contentModuloe) ) {
      $contentModuloeArray[] = '';
      foreach( $contentModuloe as $modules ) {
        $contentModuloeArray[$modules['name']] = $modules['title'] . " ";
      }
    }

    if( !empty($contentModuloeArray) ) {
      $this->addElement('Select', 'module_name', array(
        'label' => 'Module',
        'allowEmpty' => false,
        'onchange' => 'setModuleName(this.value)',
        'multiOptions' => $contentModuloeArray,
      ));
    } else {
      //VALUE FOR LOGO PREVIEW.
      $description = "<div class='tip'><span>" . Zend_Registry::get('Zend_Translate')->_("There are currently no new content modules that could be added for “Shortcut Type”.") . "</span></div>";
      $this->addElement('Dummy', 'module', array(
        'description' => $description,
      ));
      $this->module->addDecorator('Description', array('placement' =>
        Zend_Form_Decorator_Abstract::PREPEND, 'escape' => false));
    }

    $module_name = Zend_Controller_Front::getInstance()->getRequest()->getParam('module_name', null);
    if( !in_array($moduleName, array_keys($contentModuloeArray)) ) {
      $module_name = null;
    }
    $contentItem = array();
    if( !empty($module_name) ) {
      $this->module_name->setValue($module_name);
      if( $module_name == 'sitereview' ) {
        $listTypes = Engine_Api::_()->getDbTable('listingtypes', 'sitereview')->getListingTypesArray();
        $contentItem = array_combine(
          array_map(function($k) {
            return 'sitereview_listingtype_' . $k;
          }, array_keys($listTypes)), $listTypes
        );
      } else {
        $contentItem = $this->getContentItem($module_name);
      }
      if( empty($contentItem) ) {
        $description = "<div class='tip'><span>" . Zend_Registry::get('Zend_Translate')->_("For this module not difine any item in manifest file.") . "</span></div>";
        $this->addElement('Dummy', 'dummy_title', array(
          'description' => $description,
        ));
        $this->dummy_title->addDecorator('Description', array('placement' =>
          Zend_Form_Decorator_Abstract::PREPEND, 'escape' => false));
      }
    }
    if( !empty($contentItem) ) {
      $this->addElement('Select', 'type', array(
        'label' => 'Item Type (Resource Type)',
        'description' => "Please select the item type for the above selected module which you want to integrate with this shortcut type.",
        'required' => true,
        'multiOptions' => $contentItem,
      ));

      $this->addElement('Text', 'title', array(
        'label' => 'Shortcut Caption',
        'description' => 'Enter the caption which you want to display to the users along with the automatic shortcuts of this type.',
        'required' => true
      ));
      $privacy_options = array('owner' => 'Who\'s Owner', 'admin' => 'Who\'s Admin', 'member' => 'Who\'s Members');
      $this->addElement('Select', 'shortcut_allow', array(
        'label' => 'Content Included',
        'description' => "Which type of content can be shown in this automatic shortcut type?",
        'required' => true,
        'multiOptions' => $privacy_options,
      ));

      $this->addElement('Checkbox', 'enabled', array(
        'description' => 'Enable',
        'label' => 'Enable this automatic shortcut type to be a part of user shortcut links.',
        'value' => 1
      ));
      // Element: execute
      $this->addElement('Button', 'execute', array(
        'label' => 'Submit',
        'type' => 'submit',
        'ignore' => true,
        'decorators' => array('ViewHelper'),
      ));

      // Element: cancel
      $this->addElement('Cancel', 'cancel', array(
        'label' => 'cancel',
        'prependText' => ' or ',
        'ignore' => true,
        'link' => true,
        'href' => Zend_Controller_Front::getInstance()->getRouter()->assemble(array('action' => 'index')),
        'decorators' => array('ViewHelper'),
      ));

      // DisplayGroup: buttons
      $this->addDisplayGroup(array('execute', 'cancel'), 'buttons', array(
        'decorators' => array(
          'FormElements',
          'DivDivDivWrapper',
        )
      ));
    } else {
      // Element: cancel
//      $this->addElement('Cancel', 'cancel', array(
//        'label' => 'cancel',
//        'ignore' => true,
//        'link' => true,
//        'href' => Zend_Controller_Front::getInstance()->getRouter()->assemble(array('action' => 'index')),
//      ));
    }
  }

  public function getContentItem($moduleName)
  {
    $file_path = APPLICATION_PATH . "/application/modules/" . ucfirst($moduleName) . "/settings/manifest.php";
    $contentItem = array();
    if( @file_exists($file_path) ) {
      $ret = include $file_path;
      if( !empty($ret['items']) ) {
        foreach( $ret['items'] as $item ) {
          if( strpos($item, '_category') > 0 || strpos($item, '_list_item') > 0 ) {
            continue;
          }
          $contentItem[$item] = $item . " ";
        }
      }
    }
    return $contentItem;
  }

}
?>
