<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteshortcut
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Global.php 2017-03-28 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteshortcut_Form_Admin_Settings_Global extends Engine_Form
{
  public function init()
  {

    $this->setTitle('Global Settings')
      ->setDescription('These settings affect all members in your community.')
      ->setName('siteshortcut_global_settings');

    $settings = Engine_Api::_()->getApi('settings', 'core');

    $this->addElement('Radio', 'siteshortcut_heading_enabled', array(
      'label' => 'Caption',
      'description' => 'Do you want to showcase the caption [e.g: Blog(s), Event(s), Group(s)] with all the listed shortcuts?',
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => $settings->getSetting('siteshortcut.heading.enabled', 1),
    ));

    $this->addElement('Text', 'siteshortcut_item_max', array(
      'label' => 'Maximum Items for Each Shortcut Type',
      'description' => "Enter the maximum number of items you want to showcase for each shortcut type.",
      'value' => $settings->getSetting('siteshortcut.item.max', 10),
    ));

    $this->addElement('Text', 'siteshortcut_item_defalutshow', array(
      'label' => 'View More',
      'description' => "After how many shortcut links do you want to show the 'View More' option?",
      'value' => $settings->getSetting('siteshortcut.item.defalutshow', 5),
    ));

    $this->addElement('Button', 'save', array(
      'label' => 'Save Changes',
      'type' => 'submit',
      'ignore' => true
    ));
  }

}
