<?php

/**
 * SocialEngine
 *
 * @category   Application_Theme
 * @package    Siteshortcut
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-12-15 00:00:00 SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteshortcut_Widget_AddToShortcutsController extends Engine_Content_Widget_Abstract
{
  public function indexAction()
  {
    // Must be logged in
    $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
    if( !$viewer || !$viewer->getIdentity() ) {
      return $this->setNoRender();
    }
    if( !Engine_Api::_()->core()->hasSubject() ) {
      return $this->setNoRender();
    }
    if( !Engine_Api::_()->authorization()->isAllowed('siteshortcut', null, 'add') ) {
      return $this->setNoRender();
    }
    $this->view->subject = $subject = Engine_Api::_()->core()->getSubject();
    $isAdded = Engine_Api::_()->getDbTable('shortcuts', 'siteshortcut')->isAdded(array(
      'resource_type' => $subject->getType(),
      'resource_id' => $subject->getIdentity(),
      'user_id' => $viewer->getIdentity()
    ));
    if( $isAdded ) {
      $this->view->shortcutUrl = 'siteshortcut/index/remove-from-shortcut';
      $this->view->shortcut_button_title = 'Remove From Shortcuts';
    } else {
      $this->view->shortcutUrl = 'siteshortcut/index/add-to-shortcut';
      $this->view->shortcut_button_title = 'Add To Shortcuts';
    }
  }

}
