<?php
 /**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteslideshow
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Global.php 6590 2010-08-31 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteslideshow_Form_Admin_Global extends Engine_Form
{
  public function init()
  {
    $this
    ->setTitle('Global Settings')
    ->setDescription('These settings affect all members in your community.');
    
   	$this->addElement('Text', 'siteslideshow_controllersettings', array(
      'label' => 'Enter License key',
      'description' => "Please enter your license key that was provided to you when you purchased this plugin. If you do not know your license key, please contact the Support Team of SocialEngineAddOns from the Support section of your Account Area.(Key Format: XXXXXX-XXXXXX-XXXXXX )",
      'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteslideshow.controllersettings'),
    ));

      if( APPLICATION_ENV == 'production' ) {
			$this->addElement('Checkbox', 'environment_mode', array(
				'label' => 'Your community is currently in "Production Mode". We recommend that you momentarily switch your site to "Development Mode" so that the CSS of this plugin renders fine as soon as the plugin is installed. After completely installing this plugin and visiting few pages of your site, you may again change the System Mode back to "Production Mode" from the Admin Panel Home. (In Production Mode, caching prevents CSS of new plugins to be rendered immediately after installation.)',
				'description' => 'System Mode',
				'value' => 1,
			)); 
		}else {
			$this->addElement('Hidden', 'environment_mode', array('order' => 990, 'value' => 0));
		}

		$this->addElement('Button', 'submit_lsetting', array(
			'label' => 'Activate Your Plugin Now',
			'type' => 'submit',
			'ignore' => true
		));

    $this->addElement('Radio', 'siteslideshow_visibility', array(
      'label' => 'Slideshow visibility',
      'description' => 'Who do you want to show the slideshow to ?',
      'multiOptions' => array(
        2 => 'Everyone can view the slideshow',
        1 => 'Only members can view the slideshow',
        0 => 'Only non logged-in visitors can view the slideshow'
      ),
      'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteslideshow.visibility', 2),
    ));

		$this->addElement('Radio', 'siteslideshow_slide_resize', array(
      'label' => 'Image Resizing',
      'description' => 'Do you want the slideshow images uploaded by you to be resized to the slideshow dimensions? (Resizing an image might decrease its quality. If you select "No" over here, then you should ensure that you upload images matching slideshow dimensions. Note that a change in this setting will only apply to images uploaded henceforth.)',
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteslideshow.slide.resize', 1),
    ));
    
    $this->addElement('Button', 'submit', array(
      'label' => 'Save Settings',
      'type' => 'submit',
      'ignore' => true,
    ));    
	}
}
?>