<?php
 /**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteslideshow
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Slideshow.php 6590 2010-08-31 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteslideshow_Form_Admin_Slideshow extends Engine_Form
{
  public function init()
  {
			$this
			->setTitle('Slideshow Settings')
			->setDescription('Configure and customize your slideshow based on various parameters. Visit the Demo tab to see the demo of the various slideshow types. You may also preview your slideshow based on the settings chosen by you by clicking on the Preview button at the bottom of this page.');

			$this->addElement('Select', 'siteslideshow_type', array(
				'label' => 'Slideshow type',
				'onchange' => 'javascript:slidetype(this.value);',
				'multiOptions' => array(
					'fadd' => 'Fading',
					'flom'   => 'Curtain / Blind',
					'zndp'   => 'Zooming & Panning',
					'push'   => 'Push',
					'flas'   => 'Flash',
					'fold'   => 'Fold'
				),
			));

			$this->addElement('Select', 'siteslideshow_transition1', array(
				'label' => 'Transition type',
				'multiOptions' => array(
				'linear' => 'Linear',
				'Quad' => 'Quadratic',
				'Cubic' => 'Cubic',
				'Quart' => 'Quartic',
				'Quint' => 'Quintic',
				'Sine' => 'Sinusoidal',
				'Expo' => 'Exponential',
				'Circ' => 'Circular',
				'Bounce' => 'Bouncing',
				'Back' => 'Back',
				'Elastic' => 'Elastic'
				),
				'decorators' => array(array('ViewScript', array(
					'viewScript' => '_formtransition.tpl',
					'class'      => 'form element'
				)))
			));

			$this->addElement('Text', 'siteslideshow_width', array(
				'label' => 'Slideshow width (in pixels)',
				'description' => 'Note : Because of a change in this setting, the widths of only the slideshow pictures uploaded after saving these settings will be affected.Please note that this setting will be applied during the slideshow picture upload only if "Image Resizing" has been enabled from "Global Settings".',
				'required' => true,
				'filters' => array(
					'StripTags',
					new Engine_Filter_Censor(),
			),
			'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteslideshow.width', '523'),
			));
			$this->siteslideshow_width->getDecorator('Description')->setOption('placement', 'append');
			
			$this->addElement('Text', 'siteslideshow_height', array(
				'label' => 'Slideshow height (in pixels)',
				'description' => 'Note : Because of a change in this setting, the heights of only the slideshow pictures uploaded after saving these settings will be affected.Please note that this setting will be applied during the slideshow picture upload only if "Image Resizing" has been enabled from "Global Settings".',
				'required' => true,
				'filters' => array(
					'StripTags',
					new Engine_Filter_Censor(),
			),
			'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteslideshow.height', '250'),
			));
			$this->siteslideshow_height->getDecorator('Description')->setOption('placement', 'append');

			$this->addElement('Radio', 'siteslideshow_target', array(
				'label' => 'Slide URLs Window',
				'description' => 'Open URLs of slides in new window',
				'multioptions' => array(
					1 => 'Yes',
					0 => 'No'
				),
				'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteslideshow.target', '0'), 
			));


			$this->addElement('Text', 'siteslideshow_blinds', array(
				'label' => 'Number of blinds between transitions',
				'required' => true,
				'filters' => array(
					'StripTags',
					new Engine_Filter_Censor(),
			),
			'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteslideshow.blinds', '24'),
			));

			$this->addElement('Text', 'siteslideshow_interval', array(
				'label' => 'Slideshow interval',
				'required' => true,
				'filters' => array(
					'StripTags',
					new Engine_Filter_Censor(),
			),
			'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteslideshow.interval', '8000'),
			));
			
			$this->addElement('Radio', 'siteslideshow_progressbar', array(
				'label' => 'Show progressbar',
				'multioptions' => array(
					1 => 'Yes',
					0 => 'No'
				),
				'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteslideshow.progressbar', '1'), 
			));

			$this->addElement('Text', 'siteslideshow_delay', array(
				'label' => 'Delay (in millisecond)',
				'description' => 'What is the delay you want between slide changes ?',
				'filters' => array(
					'StripTags',
					new Engine_Filter_Censor(),
			),
			'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteslideshow.delay', '2000'),
			));
			
			$this->addElement('Text', 'siteslideshow_duration', array(
				'label' => 'Effect duration (in millisecond)',
				'description' => 'What is the duration you want for slide effects ?',
				'filters' => array(
					'StripTags',
					new Engine_Filter_Censor(),
			),
			'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteslideshow.duration', '750'),
			));
			
			$this->addElement('Radio', 'siteslideshow_overlap', array(
				'label' => 'Overlapping of slides',
				'description' => 'Do you want slides to overlap between transitions ? [Note : Non-overlapping means the first slide should transition out before the second transitions in.]',
				'multioptions' => array(
					1 => 'Yes, the slides should overlap between transitions',
					0 => 'No, the slides should not overlap between transitions'
				),
				'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteslideshow.overlap', '1'), 
			));

			$this->addElement('Radio', 'siteslideshow_random', array(
				'label' => 'Sequential or Random slideshow',
				'description' => 'Do you want the slides in the slideshow to appear in a sequential order, or randomly ? [Note : In case of random order, we suggest that you display the thumbnails for the slideshow as well.]',
				'multioptions' => array(
					0 => 'Yes, show the slides in sequential order.',
					1 => 'No, show the slides in random order.'
				),
				'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteslideshow.random', '0'), 
			));

			$this->addElement('Text', 'siteslideshow_start_index', array(
				'label' => 'Slideshow starting index',
				'description' => 'From which slide do you want the slideshow to begin ? [Note : Enter 0 for first, 1 for second, and so on.]',
				'required' => true,
				'filters' => array(
					'StripTags',
					new Engine_Filter_Censor(),
			),
			'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteslideshow.start.index', '0'),
			));

			$this->addElement('Radio', 'siteslideshow_title', array(
				'label' => 'Slide titles',
				'description' => 'Do you want to use the slide captions as slide title attributes ? [Note : Title attributes are the text that come upon mouseover on a slide.]',
				'multioptions' => array(
					1 => 'Yes, use the caption text for title attribute',
					0 => 'No, do not use the caption text for title attribute'
				),
				'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteslideshow.title', '1'), 
			));

			$this->addElement('Radio', 'siteslideshow_caption', array(
				'label' => 'Captions',
				'description' => 'Do you want to show captions on the slides ?',
				'multioptions' => array(
					1 => 'Yes, show captions on the slides',
					0 => 'No, do not show captions on the slides'
				),
				'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteslideshow.caption', '1'), 
			));

			$this->addElement('Radio', 'siteslideshow_position_caption', array(
				'label' => 'Caption Positions',
				'description' => 'Choose the position for the captions on the slides.',
				'multioptions' => array(
					0 => 'Top of the slides',
					1 => 'Bottom of the slides'
				),
				'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteslideshow.position.caption', '1'), 
			));

			$this->addElement('Text', 'siteslideshow_colorback_caption', array(
				'decorators' => array(array('ViewScript', array(
					'viewScript' => '_formImagerainbow6.tpl',
					'class'      => 'form element'
				)))
			));

			$this->addElement('Radio', 'siteslideshow_controller', array(
				'label' => 'Slideshow Controller',
				'description' => 'Do you want to show the slideshow controller on the slides ? [Note : The slideshow controller has options like pause/play, forward, next, etc. The controller is only visible upon mouseover on the slideshow.]',
				'multioptions' => array(
					1 => 'Yes, show the controller',
					0 => 'No, do not show the controller'
				),
				'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteslideshow.controller', '1'),
			));
			
			$this->addElement('Radio', 'siteslideshow_thumb', array(
				'label' => 'Slide thumbnails',
				'description' => 'Do you want to show thumbnails for the slides ?',
				'multioptions' => array(
					1 => 'Yes, show thumbnails for the slides',
					0 => 'No, do not show thumbnails for the slides'
				),
				'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteslideshow.thumb', '1'), 
			));

			$this->addElement('Text', 'siteslideshow_backcolor', array(
				'decorators' => array(array('ViewScript', array(
					'viewScript' => '_formImagerainbow3.tpl',
					'class'      => 'form element'
				)))
			));

			$this->addElement('Text', 'siteslideshow_bordactive', array(
				'decorators' => array(array('ViewScript', array(
					'viewScript' => '_formImagerainbow5.tpl',
					'class'      => 'form element'
				)))
			));

			$this->addElement('Text', 'siteslideshow_bordcolor', array(
				'decorators' => array(array('ViewScript', array(
					'viewScript' => '_formImagerainbow4.tpl',
					'class'      => 'form element'
				)))
			));
					
			$this->addElement('Text', 'siteslideshow_color1', array(
				'decorators' => array(array('ViewScript', array(
					'viewScript' => '_formImagerainbow1.tpl',
					'class'      => 'form element'
				)))
			));
	
			$this->addElement('Text', 'siteslideshow_color2', array(
				'decorators' => array(array('ViewScript', array(
					'viewScript' => '_formImagerainbow2.tpl',
					'class'      => 'form element'
				)))
			));

			$this->addElement('Button', 'submit', array(
				'type' => 'submit',
				'ignore' => true,
				'decorators' => array(array('ViewScript', array(
					'viewScript' => '_formbuttons.tpl',
					'class'      => 'form element'
				)))
			));    
		}
	}
?>