<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteslideshow
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminManageController.php 6590 2010-08-31 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteslideshow_AdminManageController extends Core_Controller_Action_Admin
{
  public function indexAction()
  {
		$this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
         ->getNavigation('siteslideshow_admin_main', array(), 'siteslideshow_admin_main_manage');

		//GET MODEL FROM engine4_siteslideshows TABLE
    $this->view->siteslideshow = $siteslideshow = Engine_Api::_()->getItem('siteslideshow', 5);
  
    $table   = Engine_Api::_()->getDbTable('images', 'siteslideshow');
    $select  = $table->select()
										 ->setIntegrityCheck(false)
                     ->from($table->info('name'))
										 ->order('order ASC')
										 ->order('image_id DESC');
    
    $this->view->paginator = $paginator = Zend_Paginator::factory($select);
		$this->view->total_images = $paginator->getTotalItemCount();
		$paginator->setItemCountPerPage(100);
    $page = $this->_getParam('page',1);
    $paginator->setCurrentPageNumber($page);
  }

	//ACTION FOR EDIT CAPTION AND URL
  public function editAction()
  { 
		$this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
         ->getNavigation('siteslideshow_admin_main', array(), 'siteslideshow_admin_main_manage');

    $form = $this->view->form = new Siteslideshow_Form_Admin_Manage_Edit();

		$image = Engine_Api::_()->getItem('siteslideshow_image',
		$this->_getParam('id'));
    $stat['url'] = $image->url;
		$stat['caption'] = $image->caption;
    if( $this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost()) ) {
      $values = $form->getValues();
			$db = Engine_Db_Table::getDefaultAdapter();
			$db->beginTransaction();

			//EDIT IMAGE DETAIL
			$image->setFromArray($values);
			$image->save();
			$db->commit();
			return $this->_helper->redirector->gotoRoute(array('action' => 'index'));
    }
    if( !($id = $this->_getParam('id')) ) {
     	die('No identifier specified');
    }
    $form->setField($stat);
  }

  //ACTION FOR MAKE SLIDE ENABLE/DIS-ABLE
  public function enabledAction() {
    //GET IMAGE ID
    $image_id = $this->_getParam('image_id');
    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    try {

      //GET SLIDE OBJECT
      $slide = Engine_Api::_()->getItem('siteslideshow_image', $image_id);
      if ($slide->enabled == 0) {
        $slide->enabled = 1;
      } else {
        $slide->enabled = 0;
      }
      $slide->save();
      $db->commit();
    } catch (Exception $e) {
      $db->rollBack();
      throw $e;
    }
    return $this->_helper->redirector->gotoRoute(array('action' => 'index'));
  }
  
	//ACTION FOR DELETE IMAGES AND ALSO FOR SAVE IMAGE ORDER
	public function multiDeleteAction()
  {
		if($this->getRequest()->isPost()) {
      $values = $this->getRequest()->getPost();

		//IF ADMIN CLICK ON DELETE SELECTED BUTTON
		if(!empty($values['delete'])) {
			foreach ($values as $key=>$value) {
				if ($key == 'delete_' . $value) {
					$image = Engine_Api::_()->getItem('siteslideshow_image', (int)$value);	
		      $image->delete();
		      }
		    }

				$table   = Engine_Api::_()->getDbTable('images', 'siteslideshow');
				$select  = $table->select()
												 ->setIntegrityCheck(false)
												 ->from($table->info('name'));
				$paginator = Zend_Paginator::factory($select);
				$total_images = $paginator->getTotalItemCount();

				$start_index = Engine_Api::_()->getApi('settings', 'core')->siteslideshow_start_index;

				if($start_index > $total_images-1) {
					if($total_images != 0 )
						$values['siteslideshow_start_index'] = $total_images-1;
					else
						$values['siteslideshow_start_index'] = 0;

        	foreach ($values as $key => $value) {
						Engine_Api::_()->getApi('settings', 'core')->setSetting($key, $value);  
					}
				}
    	}
			else { //IF ADMIN CLICK ON SAVE ORDER BUTTON
				foreach ($values['image_id'] as $key=>$value) {
		    	$image = Engine_Api::_()->getItem('siteslideshow_image', (int)$value);
		      $image->order  = $key+1;
		      $image->save();
		    } 
			}
		}
    return $this->_helper->redirector->gotoRoute(array('action' => 'index'));
  }
}
?>