<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitestorealbum
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-08-026 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitestorealbum_Widget_FeaturedAlbumsSlideshowController extends Engine_Content_Widget_Abstract {

  public function indexAction() {
  
    $category_id = $this->_getParam('category_id',0);
    // List of featured album
    $table = Engine_Api::_()->getItemTable('sitestore_album');


    $tableName = $table->info('name');
    $tableStore = Engine_Api::_()->getDbtable('stores', 'sitestore');
    $tableStoreName = $tableStore->info('name');
    $select = $table->select()
                    ->setIntegrityCheck(false)
                    ->from($tableName)
                    ->joinLeft($tableStoreName, "$tableStoreName.store_id = $tableName.store_id", array('title AS store_title', 'photo_id as store_photo_id'))
                    ->where($tableName.".featured = ?", 1);
    $select = $select
              ->where($tableStoreName . '.closed = ?', '0')
              ->where($tableStoreName . '.approved = ?', '1')
              ->where($tableStoreName . '.declined = ?', '0')
              ->where($tableStoreName . '.draft = ?', '1');
              
    if(!empty($category_id)) {
      $select->where($tableStoreName . '.	category_id =?', $category_id);
    }
    
    if (Engine_Api::_()->sitestore()->hasPackageEnable()) {
      $select->where($tableStoreName . '.expiration_date  > ?', date("Y-m-d H:i:s"));
    }  

    if(!Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestorealbum.hide.autogenerated', 1) ) {
			$select->where($tableName. '.default_value'.'= ?', 0);
			$select->where($tableName . ".type is Null");
    } 
    
    $limit = $this->_getParam('itemCountPerStore', 10);
    $select->limit($limit);
    $this->view->show_slideshow_object = $this->view->featuredAlbums = $featuredAlbums = $table->fetchAll($select);
    // Count Featured Albums
    $this->view->num_of_slideshow = count($featuredAlbums);
    // Number of the result.
    if (empty($this->view->num_of_slideshow)) {
      return $this->setNoRender();
    }
  }

}
?>