<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitestoredocument
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminSettingsController.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
include_once APPLICATION_PATH . '/application/modules/Sitestoredocument/Api/Scribdsitestore.php';

class Sitestoredocument_AdminSettingsController extends Core_Controller_Action_Admin {

    //ACTION FOR GLOBAL SETTINGS
    public function indexAction() {
        if ($this->getRequest()->isPost()) {
            $sitestoreKeyVeri = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestore.lsettings', null);
            if (!empty($sitestoreKeyVeri)) {
                Engine_Api::_()->getApi('settings', 'core')->setSetting('sitestore.lsettings', trim($sitestoreKeyVeri));
            }
            if ($_POST['sitestoredocument_lsettings']) {
                $_POST['sitestoredocument_lsettings'] = trim($_POST['sitestoredocument_lsettings']);
            }

            if (isset($_POST['sitestoredocument_api_key']) && !empty($_POST['sitestoredocument_api_key'])) {
                $_POST['sitestoredocument_api_key'] = trim($_POST['sitestoredocument_api_key']);
            }

            if (isset($_POST['sitestoredocument_secret_key']) && !empty($_POST['sitestoredocument_secret_key'])) {
                $_POST['sitestoredocument_secret_key'] = trim($_POST['sitestoredocument_secret_key']);
            }
        }

        $this->view->navigationStore = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitestore_admin_main', array(), 'sitestore_document_admin_main_settings');
        $this->view->navigationSubStore = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitestore_document_admin_main', array(), 'sitestoredocument_admin_sub_settings');
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitestoredocument_admin_main', array(), 'sitestoredocument_admin_main_settings');
        $this->view->form = $form = new Sitestoredocument_Form_Admin_Global();

        if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
            $values = $form->getValues();

            if (!empty($values)) {
                $scribd_check_error_message = $this->checkscribd($values, $navi_auth_value);
                if (!empty($scribd_check_error_message)) {
                    $error_message = Zend_Registry::get('Zend_Translate')->_($scribd_check_error_message);
                    $form->addError($error_message);
                    return;
                }
            }

            if (Engine_Api::_()->sitestore()->hasPackageEnable() && isset($values['include_in_package']) && !empty($values['include_in_package'])) {
                Engine_Api::_()->sitestore()->oninstallPackageEnableSubMOdules('sitestoredocument');
            }
            Engine_Api::_()->getApi('settings', 'core')->setSetting('sitestoredocument_api_key', $values['sitestoredocument_api_key']);
            Engine_Api::_()->getApi('settings', 'core')->setSetting('sitestoredocument_secret_key', $values['sitestoredocument_secret_key']);
        }

        //_SITESTOREDOCUMENT_VISIBILITY_SECURE_IPAPER_MESSAGE
        //WE ARE SHOWING THIS MESSAGE BECAUSE 'Make iPaper Store documents secure. Do not allow embedding on other sites.' AND 'Public on Scribd.com' BOTH SETTINGS CAN'T COME TOGATHER. BOTH CONFLICTING STATEMENT. 
    }

    //CHECK SCRIBD API AND SECERET KEY
    public function checkscribd($values, $is_active) {

        //GET SCRIBD DETAIL
        $api_key = $values['sitestoredocument_api_key'];
        $secreat_key = $values['sitestoredocument_secret_key'];

        $this->scribdsitestore = new Scribdsitestore($api_key, $secreat_key);

        try {
            $result = $this->scribdsitestore->getList();
            if (empty($is_active)) {
                return;
            }
        } catch (Exception $e) {
            $is_error = 1;
            $code = $e->getCode();
            if ($code == 401) {
                $message = $e->getMessage();
                $error = $message . $this->view->translate(': Api key is not correct');
                $error = Zend_Registry::get('Zend_Translate')->_($error);

                return $error;
            }
        }

        //CHECK FOR VALID FILE SIZE
        if (!empty($is_active)) {
            $is_error = 0;
            $filesize = (int) ini_get('upload_max_filesize') * 1024;
            $show_description = Zend_Registry::get('Zend_Translate')->_("Please enter the valid Store document file size. Valid values are from 1 KB to $filesize KB.");
            if (!is_numeric($values['sitestoredocument_filesize']) || $values['sitestoredocument_filesize'] < 1 || $values['sitestoredocument_filesize'] > $filesize) {
                $is_error = 1;
            }

            if ($is_error == 1) {
                $error = $message . $this->view->translate("$show_description");
                $error = Zend_Registry::get('Zend_Translate')->_($error);
                return $error;
            }
        }
    }

    //ACTION FOR WIDGET SETTINGS
    public function widgetAction() {
        $this->view->navigationStore = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitestore_admin_main', array(), 'sitestore_document_admin_main_settings');
        $this->view->navigationSubStore = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitestore_document_admin_main', array(), 'sitestoredocument_admin_sub_settings');
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitestoredocument_admin_main', array(), 'sitestoredocument_admin_main_widgets');
        $this->view->subNavigation = $subNavigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitestoredocument_admin_submain', array(), 'sitestoredocument_admin_submain_document_tab');
        $this->view->tabs = Engine_Api::_()->getItemTable('seaocore_tab')->getTabs(array('module' => 'sitestoredocument', 'type' => 'documents'));
    }

    //ACTION FOR DOCUMENT OF THE DAY
    public function manageDayItemsAction() {

        $this->view->navigationStore = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitestore_admin_main', array(), 'sitestore_document_admin_main_settings');
        $this->view->navigationSubStore = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitestore_document_admin_main', array(), 'sitestoredocument_admin_sub_settings');
        //TAB CREATION
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitestoredocument_admin_main', array(), 'sitestoredocument_admin_main_widgets');
        $this->view->subNavigation = $subNavigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitestoredocument_admin_submain', array(), 'sitestoredocument_admin_submain_dayitems');

        //FORM GENERATION
        $this->view->formFilter = $formFilter = new Sitestoredocument_Form_Admin_Manage_Filter();
        $store = $this->_getParam('page', 1);

        $values = array();
        if ($formFilter->isValid($this->_getAllParams())) {
            $values = $formFilter->getValues();
        }

        $values = array_merge(array(
            'order' => 'start_date',
            'order_direction' => 'DESC',
                ), $values);

        $this->view->assign($values);

        $this->view->documentOfDaysList = $documentOfDay = Engine_Api::_()->getDbtable('itemofthedays', 'sitestore')->getItemOfDayList($values, 'document_id', 'sitestoredocument_document');
        $documentOfDay->setItemCountPerPage(50);
        $documentOfDay->setCurrentPageNumber($store);
    }

    //ACTION FOR ADDING DOCUMENT OF THE DAY
    public function addDocumentOfDayAction() {

        //SET LAYOUT
        $this->_helper->layout->setLayout('admin-simple');

        //FORM GENERATION
        $form = $this->view->form = new Sitestoredocument_Form_Admin_ItemOfDayday();
        $form->setAction($this->getFrontController()->getRouter()->assemble(array()));
        $form->setTitle('Add an Document of the Day')
                ->setDescription('Select a start date and end date below and the corresponding Document from the auto-suggest Document field. The selected Document will be displayed as "Document of the Day" for this duration and if more than one documents are found to be displayed in the same duration then they will be dispalyed randomly one at a time.');
        $form->getElement('title')->setLabel('Document Name');

        //CHECK POST
        if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {

            //GET FORM VALUES
            $values = $form->getValues();

            //BEGIN TRANSACTION
            $db = Engine_Db_Table::getDefaultAdapter();
            $db->beginTransaction();
            try {

                //GET ITEM OF THE DAY TABLE
                $dayItemTime = Engine_Api::_()->getDbtable('itemofthedays', 'sitestore');

                //FETCH RESULT FOR resource_id
                $select = $dayItemTime->select()->where('resource_id = ?', $values["resource_id"])->where('resource_type = ?', 'sitestoredocument_document');
                $row = $dayItemTime->fetchRow($select);

                if (empty($row)) {
                    $row = $dayItemTime->createRow();
                    $row->resource_id = $values["resource_id"];
                }
                $row->start_date = $values["starttime"];
                $row->end_date = $values["endtime"];
                $row->resource_type = 'sitestoredocument_document';
                $row->save();

                $db->commit();
            } catch (Exception $e) {
                $db->rollBack();
                throw $e;
            }
            return $this->_forward('success', 'utility', 'core', array(
                        'smoothboxClose' => 10,
                        'parentRefresh' => 10,
                        'messages' => array(Zend_Registry::get('Zend_Translate')->_('The Document of the Day has been added successfully.'))
            ));
        }
    }

    //ACTION FOR DOCUMENT SUGGESTION DROP-DOWN
    public function getDocumentAction() {
        $title = $this->_getParam('text', null);
        $limit = $this->_getParam('limit', 40);
        $storeTable = Engine_Api::_()->getDbtable('stores', 'sitestore');
        $storeTableName = $storeTable->info('name');
        $allowTable = Engine_Api::_()->getDbtable('allow', 'authorization');
        $allowName = $allowTable->info('name');
        $documentTable = Engine_Api::_()->getDbtable('documents', 'sitestoredocument');
        $documentName = $documentTable->info('name');
        $data = array();
        $select = $documentTable->select()
                ->setIntegrityCheck(false)
                ->from($documentName)
                ->join($storeTableName, $storeTableName . '.store_id = ' . $documentName . '.store_id', array('title AS store_title', 'photo_id as store_photo_id'))
                ->join($allowName, $allowName . '.resource_id = ' . $storeTableName . '.store_id', array('resource_type', 'role'))
                ->where($allowName . '.resource_type = ?', 'sitestore_store')
                ->where($allowName . '.role = ?', 'registered')
                ->where($allowName . '.action = ?', 'view')
                ->where($documentName . '.search = ?', 1)
                ->where($documentName . '.sitestoredocument_title  LIKE ? ', '%' . $title . '%')
                ->limit($limit)
                ->order($documentName . '.creation_date DESC');
        $select = $select
                ->where($storeTableName . '.closed = ?', '0')
                ->where($storeTableName . '.approved = ?', '1')
                ->where($storeTableName . '.declined = ?', '0')
                ->where($storeTableName . '.draft = ?', '1');
        if (Engine_Api::_()->sitestore()->hasPackageEnable()) {
            $select->where($storeTableName . '.expiration_date  > ?', date("Y-m-d H:i:s"));
        }
        $documents = $documentTable->fetchAll($select);

        foreach ($documents as $document) {
            //SSL WORK
            if (!empty($_SERVER["HTTPS"]) && 'on' == strtolower($_SERVER["HTTPS"])) {
                $manifest_path = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestoredocument.manifestUrl', "store-documents");
                $thumbnail = $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getBaseUrl() . '/' . $manifest_path . "/ssl?url=" . urlencode($document->thumbnail);
            } else {
                $thumbnail = $document->thumbnail;
            }
            $content_photo = $this->view->htmlLink($document->getHref(), '<img height = "50px", src="' . $thumbnail . '" class="thumb_icon" />');

            $data[] = array(
                'id' => $document->document_id,
                'label' => $document->sitestoredocument_title,
                'photo' => $content_photo
            );
        }
        return $this->_helper->json($data);
    }

    //ACTION FOR DELETE DOCUMENT OF DAY ENTRY
    public function deleteDocumentOfDayAction() {
        $this->view->id = $this->_getParam('id');
        if ($this->getRequest()->isPost()) {
            Engine_Api::_()->getDbtable('itemofthedays', 'sitestore')->delete(array('itemoftheday_id =?' => $this->_getParam('id')));
            return $this->_forward('success', 'utility', 'core', array(
                        'smoothboxClose' => 10,
                        'parentRefresh' => 10,
                        'messages' => array(Zend_Registry::get('Zend_Translate')->_(''))
            ));
        }
        $this->renderScript('admin-settings/delete.tpl');
    }

    //ACTION FOR MULTI DELETE DOCUMENT ENTRIES
    public function multiDeleteDocumentAction() {
        if ($this->getRequest()->isPost()) {
            $values = $this->getRequest()->getPost();
            foreach ($values as $key => $value) {
                if ($key == 'delete_' . $value) {

                    $sitestoreitemofthedays = Engine_Api::_()->getItem('sitestore_itemofthedays', (int) $value);
                    if (!empty($sitestoreitemofthedays)) {
                        $sitestoreitemofthedays->delete();
                    }
                }
            }
        }
        return $this->_helper->redirector->gotoRoute(array('action' => 'manage-day-items'));
    }

    // ACTION FOR CHANGE SETTINGS OF TABBED DOCUMENT WIDZET TAB
    public function editTabAction() {
        //FORM GENERATION
        $this->view->form = $form = new Sitestoredocument_Form_Admin_EditTab();
        $id = $this->_getParam('tab_id');

        $tab = Engine_Api::_()->getItem('seaocore_tab', $id);
        //CHECK POST
        if (!$this->getRequest()->isPost()) {
            $values = $tab->toarray();
            $form->populate($values);
            return;
        }
        if (!$form->isValid($this->getRequest()->getPost())) {
            return;
        }

        $values = $form->getValues();
        $db = Engine_Db_Table::getDefaultAdapter();
        $db->beginTransaction();
        try {
            $tab->setFromArray($values);
            $tab->save();
            $db->commit();
            return $this->_forward('success', 'utility', 'core', array(
                        'smoothboxClose' => 10,
                        'parentRefresh' => 10,
                        'messages' => array(Zend_Registry::get('Zend_Translate')->_('Edit Tab Settings Sucessfully.'))
            ));
        } catch (Exception $e) {
            $db->rollBack();
            throw $e;
        }
    }

    //ACTION FOR UPDATE ORDER  OF DOCUMENTS WIDGTS TAB
    public function updateOrderAction() {
        //CHECK POST
        if ($this->getRequest()->isPost()) {
            $db = Engine_Db_Table::getDefaultAdapter();
            $db->beginTransaction();
            $values = $_POST;
            try {
                foreach ($values['order'] as $key => $value) {
                    $tab = Engine_Api::_()->getItem('seaocore_tab', (int) $value);
                    if (!empty($tab)) {
                        $tab->order = $key + 1;
                        $tab->save();
                    }
                }
                $db->commit();
                $this->_helper->redirector->gotoRoute(array('action' => 'widget'));
            } catch (Exception $e) {
                $db->rollBack();
                throw $e;
            }
        }
    }

    //ACTION FOR MAKE TAB ENABLE/DISABLE
    public function enabledAction() {
        $id = $this->_getParam('tab_id');
        $db = Engine_Db_Table::getDefaultAdapter();
        $db->beginTransaction();
        $tab = Engine_Api::_()->getItem('seaocore_tab', $id);
        try {
            $tab->enabled = !$tab->enabled;
            $tab->save();
            $db->commit();
        } catch (Exception $e) {
            $db->rollBack();
            throw $e;
        }
        $this->_redirect('admin/sitestoredocument/settings/widget');
    }

    public function categoriesAction() {
        $this->view->navigationStore = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitestore_admin_main', array(), 'sitestore_document_admin_main_settings');
        $this->view->navigationSubStore = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitestore_document_admin_main', array(), 'sitestoredocument_admin_sub_settings');
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitestoredocument_admin_main', array(), 'sitestoredocument_admin_main_categories');

        include APPLICATION_PATH . '/application/modules/Sitestoredocument/controllers/license/license2.php';
    }

    public function addCategoryAction() {
        // In smoothbox
        $this->_helper->layout->setLayout('admin-simple');

        // Generate and assign form
        $form = $this->view->form = new Sitestoredocument_Form_Admin_Category();
        $form->setAction($this->view->url());

        // Check post
        if (!$this->getRequest()->isPost()) {
            $this->renderScript('admin-settings/form.tpl');
            return;
        }

        if (!$form->isValid($this->getRequest()->getPost())) {
            $this->renderScript('admin-settings/form.tpl');
            return;
        }

        // Process
        $values = $form->getValues();

        $categoryTable = Engine_Api::_()->getDbtable('categories', 'sitestoredocument');
        $db = $categoryTable->getAdapter();
        $db->beginTransaction();

        try {
            $categoryTable->insert(array(
                'title' => $values['label'],
            ));

            $db->commit();
        } catch (Exception $e) {
            $db->rollBack();
            throw $e;
        }

        return $this->_forward('success', 'utility', 'core', array(
                    'smoothboxClose' => 10,
                    'parentRefresh' => 10,
                    'messages' => array('')
        ));
    }

    public function deleteCategoryAction() {
        // In smoothbox
        $this->_helper->layout->setLayout('admin-simple');
        $id = $this->_getParam('id');
        $this->view->document_id = $id;
        $categoryTable = Engine_Api::_()->getDbtable('categories', 'sitestoredocument');
        $documentTable = Engine_Api::_()->getDbtable('documents', 'sitestoredocument');
        $category = $categoryTable->find($id)->current();

        // Check post
        if (!$this->getRequest()->isPost()) {
            $this->renderScript('admin-settings/delete-category.tpl');
            return;
        }

        // Process
        $db = $categoryTable->getAdapter();
        $db->beginTransaction();

        try {
            $category->delete();

            $documentTable->update(array(
                'category_id' => 0,
                    ), array(
                'category_id = ?' => $category->getIdentity(),
            ));

            $db->commit();
        } catch (Exception $e) {
            $db->rollBack();
            throw $e;
        }

        return $this->_forward('success', 'utility', 'core', array(
                    'smoothboxClose' => 10,
                    'parentRefresh' => 10,
                    'messages' => array('')
        ));
    }

    public function editCategoryAction() {
        // In smoothbox
        $this->_helper->layout->setLayout('admin-simple');
        $id = $this->_getParam('id');
        $this->view->document_id = $id;
        $categoryTable = Engine_Api::_()->getDbtable('categories', 'sitestoredocument');
        $category = $categoryTable->find($id)->current();

        // Generate and assign form
        $form = $this->view->form = new Sitestoredocument_Form_Admin_Category();
        $form->setAction($this->view->url());
        $form->setField($category);

        // Check post
        if (!$this->getRequest()->isPost()) {
            $this->renderScript('admin-settings/form.tpl');
            return;
        }

        if (!$form->isValid($this->getRequest()->getPost())) {
            $this->renderScript('admin-settings/form.tpl');
            return;
        }

        // Ok, we're good to add field
        $values = $form->getValues();

        $db = $categoryTable->getAdapter();
        $db->beginTransaction();

        try {
            $category->title = $values['label'];
            $category->save();

            $db->commit();
        } catch (Exception $e) {
            $db->rollBack();
            throw $e;
        }

        return $this->_forward('success', 'utility', 'core', array(
                    'smoothboxClose' => 10,
                    'parentRefresh' => 10,
                    'messages' => array('')
        ));
    }
}

?>
