<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    sitestoredocument
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: WidgetSettings.php 6590 2010-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
//START LANGUAGE WORK
Engine_Api::_()->getApi('language', 'sitestore')->languageChanges();
//END LANGUAGE WORK
//GET DB
$db = Zend_Db_Table_Abstract::getDefaultAdapter();

$select = new Zend_Db_Select($db);
$select
        ->from('engine4_core_menuitems', array('id'))
        ->where('name = ?', 'sitestore_main_document');
$is_exist = $select->query()->fetchObject();
if (empty($is_exist->id)) {
  $db->insert('engine4_core_menuitems', array(
      'name' => 'sitestore_main_document',
      'module' => 'sitestoredocument',
      'label' => 'Documents',
      'plugin' => 'Sitestoredocument_Plugin_Menus::canViewDocuments',
      'params' => '{"route":"sitestoredocument_home","action":"home"}',
      'menu' => 'sitestore_main',
      'submenu' => '',
      'enabled' => 1,
      'custom' => 0,
      'order' => 999,
  ));
}

$db->query('
  INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `order`) VALUES
  ("sitestoredocument_admin_main_categories", "sitestoredocument", "Categories", "", \'{"route":"admin_default","module":"sitestoredocument","controller":"settings","action":"categories"}\', "sitestoredocument_admin_main", "", 3);
');

$db->query('
INSERT IGNORE INTO `engine4_authorization_permissions`
  SELECT
    level_id as `level_id`,
    "sitestoredocument_document" as `type`,
    "edit" as `name`,
    2 as `value`,
    NULL as `params`
  FROM `engine4_authorization_levels` WHERE `type` IN("moderator", "admin");
');

$db->query('
INSERT IGNORE INTO `engine4_authorization_permissions`
  SELECT
    level_id as `level_id`,
    "sitestoredocument_document" as `type`,
    "edit" as `name`,
    1 as `value`,
    NULL as `params`
  FROM `engine4_authorization_levels` WHERE `type` IN("user");
');

$db->query('
INSERT IGNORE INTO `engine4_core_menuitems` ( `name` , `module` , `label` , `plugin` , `params` , `menu` , `submenu` , `enabled` , `custom`,`order` )VALUES
("sitestoredocument_gutter_store", "sitestoredocument", "Back to Store", "Sitestoredocument_Plugin_Menus", "", "sitestoredocument_gutter", "", 1, 0, 0),
("sitestoredocument_gutter_publish", "sitestoredocument", "Publish Document", "Sitestoredocument_Plugin_Menus", "", "sitestoredocument_gutter", "", 1, 0, 1),
("sitestoredocument_gutter_add", "sitestoredocument", "Add Document", "Sitestoredocument_Plugin_Menus", "", "sitestoredocument_gutter", "", 1, 0, 2),
("sitestoredocument_gutter_edit", "sitestoredocument", "Edit Document", "Sitestoredocument_Plugin_Menus", "", "sitestoredocument_gutter", "", 1, 0, 3),
("sitestoredocument_gutter_share", "sitestoredocument", "Share Document", "Sitestoredocument_Plugin_Menus", "", "sitestoredocument_gutter", "", 1, 0, 4),
("sitestoredocument_gutter_download", "sitestoredocument", "Download Document", "Sitestoredocument_Plugin_Menus", "", "sitestoredocument_gutter", "", 1, 0, 5),
("sitestoredocument_gutter_email", "sitestoredocument", "Email Document", "Sitestoredocument_Plugin_Menus", "", "sitestoredocument_gutter", "", 1, 0, 6),
("sitestoredocument_gutter_documentofday", "sitestoredocument", "Make Document of the Day", "Sitestoredocument_Plugin_Menus", "", "sitestoredocument_gutter", "", 1, 0, 7),
("sitestoredocument_gutter_suggest", "sitestoredocument", "Suggest to Friends", "Sitestoredocument_Plugin_Menus", "", "sitestoredocument_gutter", "", 1, 0, 8),
("sitestoredocument_gutter_report", "sitestoredocument", "Report Document", "Sitestoredocument_Plugin_Menus", "", "sitestoredocument_gutter", "", 1, 0, 9),
("sitestoredocument_gutter_delete", "sitestoredocument", "Delete Document", "Sitestoredocument_Plugin_Menus", "", "sitestoredocument_gutter", "", 1, 0, 10);
');

$db->query('
INSERT IGNORE INTO `engine4_core_menus` (`name`, `type`, `title`, `order`) VALUES
("sitestoredocument_gutter", "standard", "Store Document View Page Options Menu", 999);
');

$db->query('
INSERT IGNORE INTO `engine4_seaocore_tabs` (`module` ,`type` ,`name` ,`title` ,`enabled` ,`order` ,`limit`)VALUES
("sitestoredocument", "documents", "recent_storedocuments", "Recent", "1", "1", "24"),
("sitestoredocument", "documents", "liked_storedocuments", "Most Liked", "1", "2", "24"),
("sitestoredocument", "documents", "viewed_storedocuments", "Most Viewed", "1", "3", "24"),
("sitestoredocument", "documents", "commented_storedocuments", "Most Commented", "0", "4", "24"),
("sitestoredocument", "documents", "featured_storedocuments", "Featured", "0", "5", "24"),
("sitestoredocument", "documents", "random_storedocuments", "Random", "0", "6", "24");
');

$db->query('
INSERT IGNORE INTO `engine4_activity_notificationtypes` (`type`, `module`, `body`, `is_request`, `handler`) VALUES
("sitestoredocument_create", "sitestoredocument", \'{item:$subject} has created a store document {var:$eventname}.\', 0, "");
');

$db->query('
INSERT IGNORE INTO `engine4_core_mailtemplates` (`type`, `module`, `vars`) VALUES
("SITESTOREDOCUMENT_CREATENOTIFICATION_EMAIL", "sitestoredocument", "[host],[email],[recipient_title],[subject],[message],[template_header],[site_title],[template_footer]"); 
');

$db->query('
INSERT IGNORE INTO `engine4_sitestoredocument_categories` (`title`) VALUES
("Arts"),
("Store"),
("Conferences"),
("Festivals"),
("Food"),
("Fundraisers"),
("Galleries"),
("Health"),
("Just For Fun"),
("Kids"),
("Learning"),
("Literary"),
("Movies"),
("Museums"),
("Neighborhood"),
("Networking"),
("Nightlife"),
("On Campus"),
("Organizations"),
("Outdoors"),
("Pets"),
("Politics"),
("Sales"),
("Science"),
("Spirituality"),
("Sports"),
("Technology"),
("Theatre"),
("Other");
');

// ============================ ON INSTALL CODE =======================================
//WORK FOR CORE CONTENT STORES
$select = new Zend_Db_Select($db);

$select->from('engine4_core_content', array('params'))
        ->where('name = ?', 'sitestoredocument.socialshare-sitestoredocuments');
$result = $select->query()->fetchObject();
if (!empty($result->params)) {
  $params = Zend_Json::decode($result->params);
  if (isset($params['code'])) {
    $code = $params['code'];
    $db->query("INSERT IGNORE INTO `engine4_core_settings` (`name`, `value`) VALUES
				('sitestoredocument.code.share','" . $code . "');");
  }
}

$table_exist = $db->query("SHOW TABLES LIKE 'engine4_sitestoredocument_documents'")->fetch();
if (!empty($table_exist)) {

  $columnExist = $db->query("SHOW COLUMNS FROM engine4_sitestoredocument_documents LIKE 'sitestoredocument_slug'")->fetch();
  if (!empty($columnExist)) {
    $db->query("ALTER TABLE `engine4_sitestoredocument_documents` DROP `sitestoredocument_slug`");
  }
}

$select = new Zend_Db_Select($db);
$select
        ->from('engine4_core_settings')
        ->where('name = ?', 'sitestoredocument.is.active')
        ->limit(1);
$sitestoredocument_settings = $select->query()->fetchAll();

// WIDGET SETTING WORK
$select = new Zend_Db_Select($db);
$select
        ->from('engine4_core_menuitems')
        ->where('name = ?', 'sitestoredocument_admin_main_widgets')
        ->limit(1);
$info = $select->query()->fetch();
if (empty($info) && !empty($sitestoredocument_settings)) {
  $db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `custom`, `order`, `enabled`) VALUES
		("sitestoredocument_admin_main_widgets", "sitestoredocument", "Widget Settings", "", \'{"route":"admin_default","module":"sitestoredocument","controller":"widgets"}\', "sitestoredocument_admin_main", "", 0, 3, 1)');
}

//START THE WORK FOR MAKE WIDGETIZE STORE OF DOCUMENTS LISTING AND DOCUMENT VIEW STORE
$select = new Zend_Db_Select($db);
$select
        ->from('engine4_core_modules')
        ->where('name = ?', 'sitestoredocument')
        ->where('version < ?', '4.2.0');
$is_enabled = $select->query()->fetchObject();
if (!empty($is_enabled)) {
  $select = new Zend_Db_Select($db);
  $select
          ->from('engine4_core_modules')
          ->where('name = ?', 'communityad')
          ->where('enabled 	 = ?', 1)
          ->limit(1);
  $infomation = $select->query()->fetch();

  $select = new Zend_Db_Select($db);
  $select
          ->from('engine4_core_settings')
          ->where('name = ?', 'sitestore.communityads')
          ->where('value 	 = ?', 1)
          ->limit(1);
  $rowinfo = $select->query()->fetch();

// 			$select = new Zend_Db_Select($db);
// 			$select
// 							->from('engine4_core_pages')
// 							->where('name = ?', 'sitestoredocument_index_browse')
// 							->limit(1);
// 			;
// 			$info = $select->query()->fetch();
// 
// 			if ( empty($info) ) {
// 				$db->insert('engine4_core_pages', array(
// 						'name' => 'sitestoredocument_index_browse',
// 						'displayname' => 'Browse Store Documents',
// 						'title' => 'Store Documents',
// 						'description' => 'This is the store documents.',
// 						'custom' => 1,
// 				));
// 				$store_id = $db->lastInsertId('engine4_core_pages');
// 
// 				//CONTAINERS
// 				$db->insert('engine4_core_content', array(
// 						'page_id' => $store_id,
// 						'type' => 'container',
// 						'name' => 'main',
// 						'parent_content_id' => Null,
// 						'order' => 2,
// 						'params' => '',
// 				));
// 				$container_id = $db->lastInsertId('engine4_core_content');
// 
// 				//INSERT MAIN - MIDDLE CONTAINER
// 				$db->insert('engine4_core_content', array(
// 						'page_id' => $store_id,
// 						'type' => 'container',
// 						'name' => 'middle',
// 						'parent_content_id' => $container_id,
// 						'order' => 6,
// 						'params' => '',
// 				));
// 				$middle_id = $db->lastInsertId('engine4_core_content');
// 
// 
// 				//INSERT MAIN - RIGHT CONTAINER
// 				$db->insert('engine4_core_content', array(
// 						'page_id' => $store_id,
// 						'type' => 'container',
// 						'name' => 'right',
// 						'parent_content_id' => $container_id,
// 						'order' => 5,
// 						'params' => '',
// 				));
// 				$right_id = $db->lastInsertId('engine4_core_content');
// 
// 
// 				//INSERT TOP CONTAINER
// 				$db->insert('engine4_core_content', array(
// 						'page_id' => $store_id,
// 						'type' => 'container',
// 						'name' => 'top',
// 						'parent_content_id' => Null,
// 						'order' => 1,
// 						'params' => '',
// 				));
// 				$top_id = $db->lastInsertId('engine4_core_content');
// 
// 
// 				//INSERT TOP- MIDDLE CONTAINER
// 				$db->insert('engine4_core_content', array(
// 						'page_id' => $store_id,
// 						'type' => 'container',
// 						'name' => 'middle',
// 						'parent_content_id' => $top_id,
// 						'order' => 6,
// 						'params' => '',
// 				));
// 				$top_middle_id = $db->lastInsertId('engine4_core_content');
// 
// 
// 				$db->insert('engine4_core_content', array(
// 						'page_id' => $store_id,
// 						'type' => 'widget',
// 						'name' => 'sitestore.browsenevigation-sitestore',
// 						'parent_content_id' => $top_middle_id,
// 						'order' => 1,
// 						'params' => '{"title":"","titleCount":""}',
// 				));
// 
// 				$db->insert('engine4_core_content', array(
// 						'page_id' => $store_id,
// 						'type' => 'widget',
// 						'name' => 'sitestoredocument.search-sitestoredocument',
// 						'parent_content_id' => $right_id,
// 						'order' => 3,
// 						'params' => '{"title":"","titleCount":"true"}',
// 				));
// 
// 				$db->insert('engine4_core_content', array(
// 						'page_id' => $store_id,
// 						'type' => 'widget',
// 						'name' => 'sitestoredocument.sitestore-document',
// 						'parent_content_id' => $middle_id,
// 						'order' => 2,
// 						'params' => '{"title":"","titleCount":""}',
// 				));
// 
// 				$db->insert('engine4_core_content', array(
// 						'page_id' => $store_id,
// 						'type' => 'widget',
// 						'name' => 'sitestoredocument.homefeaturelist-sitestoredocuments',
// 						'parent_content_id' => $right_id,
// 						'order' => 4,
// 						'params' => '{"title":"Featured Documents","titleCount":"true"}',
// 				));
// 
// 				$db->insert('engine4_core_content', array(
// 						'page_id' => $store_id,
// 						'type' => 'widget',
// 						'name' => 'sitestoredocument.sitestore-sponsoreddocument',
// 						'parent_content_id' => $right_id,
// 						'order' => 5,
// 						'params' => '{"title":"Sponsored Documents","titleCount":"true"}',
// 				));
// 
// 				$db->insert('engine4_core_content', array(
// 						'page_id' => $store_id,
// 						'type' => 'widget',
// 						'name' => 'sitestoredocument.homecomment-sitestoredocuments',
// 						'parent_content_id' => $right_id,
// 						'order' => 6,
// 						'params' => '{"title":"Most Commented Documents","titleCount":"true"}',
// 				));
// 
// 				$db->insert('engine4_core_content', array(
// 						'page_id' => $store_id,
// 						'type' => 'widget',
// 						'name' => 'sitestoredocument.homepopular-sitestoredocuments',
// 						'parent_content_id' => $right_id,
// 						'order' => 7,
// 						'params' => '{"title":"Most Popular Documents","titleCount":"true"}',
// 				));
// 
// 				$db->insert('engine4_core_content', array(
// 						'page_id' => $store_id,
// 						'type' => 'widget',
// 						'name' => 'sitestoredocument.homelike-sitestoredocuments',
// 						'parent_content_id' => $right_id,
// 						'order' => 8,
// 						'params' => '{"title":"Most Liked Documents","titleCount":"true"}',
// 				));
// 
// 
// 				$db->insert('engine4_core_content', array(
// 						'page_id' => $store_id,
// 						'type' => 'widget',
// 						'name' => 'sitestoredocument.homerate-sitestoredocuments',
// 						'parent_content_id' => $right_id,
// 						'order' => 9,
// 						'params' => '{"title":"Top Rated Documents","titleCount":"true"}',
// 				));
// 
// 				$db->insert('engine4_core_content', array(
// 							'page_id' => $store_id,
// 							'type' => 'widget',
// 							'name' => 'sitestoredocument.homerecent-sitestoredocuments',
// 							'parent_content_id' => $right_id,
// 							'order' => 10,
// 							'params' => '{"title":"Recent Store Documents","titleCount":"true"}',
// 					));
// 
// 				if ( $infomation && $rowinfo ) {
// 					$db->insert('engine4_core_content', array(
// 							'page_id' => $store_id,
// 							'type' => 'widget',
// 							'name' => 'sitestore.store-ads',
// 							'parent_content_id' => $right_id,
// 							'order' => 11,
// 							'params' => '{"title":"","titleCount":""}',
// 					));
// 				}
// 			}
}


$select = new Zend_Db_Select($db);

// Check if it's already been placed
$select = new Zend_Db_Select($db);
$select
        ->from('engine4_core_pages')
        ->where('name = ?', 'sitestoredocument_index_view')
        ->limit(1);
;
$info = $select->query()->fetch();

if (empty($info)) {
  $db->insert('engine4_core_pages', array(
      'name' => 'sitestoredocument_index_view',
      'displayname' => 'Store Document View Page',
      'title' => 'View Store Document',
      'description' => 'This is the view store for a store document.',
      'custom' => 1,
      'provides' => 'subject=sitestoredocument',
  ));
  $store_id = $db->lastInsertId('engine4_core_pages');

  // containers
  $db->insert('engine4_core_content', array(
      'page_id' => $store_id,
      'type' => 'container',
      'name' => 'main',
      'parent_content_id' => null,
      'order' => 1,
      'params' => '',
  ));
  $container_id = $db->lastInsertId('engine4_core_content');

  $db->insert('engine4_core_content', array(
      'page_id' => $store_id,
      'type' => 'container',
      'name' => 'right',
      'parent_content_id' => $container_id,
      'order' => 1,
      'params' => '',
  ));
  $right_id = $db->lastInsertId('engine4_core_content');

  $db->insert('engine4_core_content', array(
      'page_id' => $store_id,
      'type' => 'container',
      'name' => 'middle',
      'parent_content_id' => $container_id,
      'order' => 3,
      'params' => '',
  ));
  $middle_id = $db->lastInsertId('engine4_core_content');

  // middle column content
  $db->insert('engine4_core_content', array(
      'page_id' => $store_id,
      'type' => 'widget',
      'name' => 'sitestoredocument.document-content',
      'parent_content_id' => $middle_id,
      'order' => 1,
      'params' => '',
  ));

  //STORE DOCUMENT OWNER PHOTO WIDGET
  $db->insert('engine4_core_content', array(
      'page_id' => $store_id,
      'type' => 'widget',
      'name' => 'sitestoredocument.document-owner-photo-documents',
      'parent_content_id' => $right_id,
      'order' => 2,
      'params' => '',
  ));

  //STORE DOCUMENT OPTIONS WIDGET
  $db->insert('engine4_core_content', array(
      'page_id' => $store_id,
      'type' => 'widget',
      'name' => 'sitestoredocument.options-documents',
      'parent_content_id' => $right_id,
      'order' => 3,
      'params' => '',
  ));

  //RECENT STORE DOCUMENT
  $db->insert('engine4_core_content', array(
      'page_id' => $store_id,
      'type' => 'widget',
      'name' => 'sitestoredocument.viewrecent-sitestoredocuments',
      'parent_content_id' => $right_id,
      'order' => 4,
      'params' => '',
  ));



  if ($infomation && $rowinfo) {
    $db->insert('engine4_core_content', array(
        'page_id' => $store_id,
        'type' => 'widget',
        'name' => 'sitestore.store-ads',
        'parent_content_id' => $right_id,
        'order' => 5,
        'params' => '{"title":"","titleCount":""}',
    ));
  }
}

$select = new Zend_Db_Select($db);
$select
        ->from('engine4_core_modules')
        ->where('name = ?', 'mobi')
        ->where('enabled 	 = ?', 1)
        ->limit(1);
$infomation = $select->query()->fetch();

if (!empty($infomation)) {
  $select = new Zend_Db_Select($db);
  $select
          ->from('engine4_core_pages')
          ->where('name = ?', 'sitestoredocument_mobi_view')
          ->limit(1);

  $info = $select->query()->fetch();
  if (empty($info)) {
    $db->insert('engine4_core_pages', array(
        'name' => 'sitestoredocument_mobi_view',
        'displayname' => 'Mobile Store Document Profile',
        'title' => 'Mobile Store Document Profile',
        'description' => 'This is the mobile verison of a Store document profile store.',
        'custom' => 0,
    ));
    $store_id = $db->lastInsertId('engine4_core_pages');

    // containers
    $db->insert('engine4_core_content', array(
        'page_id' => $store_id,
        'type' => 'container',
        'name' => 'main',
        'parent_content_id' => null,
        'order' => 1,
        'params' => '',
    ));
    $container_id = $db->lastInsertId('engine4_core_content');

    $db->insert('engine4_core_content', array(
        'page_id' => $store_id,
        'type' => 'container',
        'name' => 'right',
        'parent_content_id' => $container_id,
        'order' => 1,
        'params' => '',
    ));
    $right_id = $db->lastInsertId('engine4_core_content');

    $db->insert('engine4_core_content', array(
        'page_id' => $store_id,
        'type' => 'container',
        'name' => 'middle',
        'parent_content_id' => $container_id,
        'order' => 3,
        'params' => '',
    ));
    $middle_id = $db->lastInsertId('engine4_core_content');

    // middle column content
    $db->insert('engine4_core_content', array(
        'page_id' => $store_id,
        'type' => 'widget',
        'name' => 'sitestoredocument.document-content',
        'parent_content_id' => $middle_id,
        'order' => 1,
        'params' => '',
    ));
  }
}



//     $select = new Zend_Db_Select($db);
// 		$select
// 					->from('engine4_core_modules')
// 					->where('name = ?', 'sitestoredocument')
// 					->where('version < ?', '4.2.1');
// 		$is_enabled_document = $select->query()->fetchObject();
//       
// 		if($is_enabled_document) {
//$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitestoredocument_admin_submain_general_tab", "sitestoredocument", "General Settings", "", \'{"route":"admin_default","module":"sitestoredocument","controller":"widgets", "action": "index"}\', "sitestoredocument_admin_submain", "", 1, 0, 1)');
//$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitestoredocument_admin_submain_document_tab", "sitestoredocument", "Tabbed Documents Widget", "", \'{"route":"admin_default","module":"sitestoredocument","controller":"settings", "action": "widget"}\', "sitestoredocument_admin_submain", "", 1, 0, 2)');
//$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitestoredocument_admin_submain_dayitems", "sitestoredocument", "Document of the Day", "", \'{"route":"admin_default","module":"sitestoredocument","controller":"settings", "action": "manage-day-items"}\', "sitestoredocument_admin_submain", "", 1, 0, 4)');
// 			$select = new Zend_Db_Select($db);
// 			$select
// 						->from('engine4_core_content')
// 						->where('name = ?', 'sitestoredocument.featurelist-sitestoredocuments');
// 						
// 			$is_exit = $select->query()->fetchObject();
// 			if(!empty($is_exit)) {
// 				$db->update('engine4_core_content', array(
// 					'name' => 'sitestoredocument.highlightlist-sitestoredocuments',
// 					'params' => '{"title":"Highlighted Documents","titleCount":true}',
// 							), array(
// 					'name = ?' => 'sitestoredocument.featurelist-sitestoredocuments',
// 				));
// 			}
// 			
// 			$select = new Zend_Db_Select($db);
// 			$select
// 						->from('engine4_sitestore_admincontent')
// 						->where('name = ?', 'sitestoredocument.featurelist-sitestoredocuments');
// 						
// 			$is_exit_content = $select->query()->fetchObject();
// 			if(!empty($is_exit_content)) {
// 				$db->update('engine4_sitestore_admincontent', array(
// 					'name' => 'sitestoredocument.highlightlist-sitestoredocuments',
// 					'params' => '{"title":"Highlighted Documents","titleCount":true}',
// 							), array(
// 					'name = ?' => 'sitestoredocument.featurelist-sitestoredocuments',
// 				));
// 			}
// 
// 			$select = new Zend_Db_Select($db);
// 			$select
// 						->from('engine4_sitestore_content')
// 						->where('name = ?', 'sitestoredocument.featurelist-sitestoredocuments');
// 						
// 			$is_exit_sitestorecontent = $select->query()->fetchObject();
// 			if(!empty($is_exit_sitestorecontent)) {
// 				$db->update('engine4_sitestore_content', array(
// 					'name' => 'sitestoredocument.highlightlist-sitestoredocuments',
// 					'params' => '{"title":"Highlighted Documents","titleCount":true}',
// 							), array(
// 					'name = ?' => 'sitestoredocument.featurelist-sitestoredocuments',
// 				));
// 			}
// 			$featuredColumn = $db->query("SHOW COLUMNS FROM engine4_sitestoredocument_documents LIKE 'featured'")->fetch();
//       $highlightedColumn = $db->query("SHOW COLUMNS FROM engine4_sitestoredocument_documents LIKE 'highlighted'")->fetch();
// 			if (!empty($featuredColumn) && empty($highlightedColumn)) {
// 				$db->query("ALTER TABLE `engine4_sitestoredocument_documents` CHANGE `featured` `highlighted` TINYINT( 1 ) NOT NULL");
// 			}
// 
// 			$featuredColumn = $db->query("SHOW COLUMNS FROM engine4_sitestoredocument_documents LIKE 'featured'")->fetch();
// 			if (empty($featuredColumn)) {
// 				$db->query("ALTER TABLE `engine4_sitestoredocument_documents` ADD `featured` TINYINT( 1 ) NOT NULL AFTER `highlighted`");
// 			}
//       $db->update('engine4_core_pages', array('displayname' => 'Browse Store Documents'), array('displayname = ?' => 'Store Documents')); 
//}
//START SOCIAL SHARE WIDGET WORK
//CHECK PLUGIN VERSION
//     $select = new Zend_Db_Select($db);
// 		$select
// 					->from('engine4_core_modules')
// 					->where('name = ?', 'sitestoredocument')
// 					->where('version < ?', '4.2.1');
// 		$is_enabled_module = $select->query()->fetchObject();
// 
// 		if(!empty($is_enabled_module)) {
// 
// 			$social_share_default_code = '{"title":"Social Share","titleCount":true,"code":"<div class=\"addthis_toolbox addthis_default_style \">\r\n<a class=\"addthis_button_preferred_1\"><\/a>\r\n<a class=\"addthis_button_preferred_2\"><\/a>\r\n<a class=\"addthis_button_preferred_3\"><\/a>\r\n<a class=\"addthis_button_preferred_4\"><\/a>\r\n<a class=\"addthis_button_preferred_5\"><\/a>\r\n<a class=\"addthis_button_compact\"><\/a>\r\n<a class=\"addthis_counter addthis_bubble_style\"><\/a>\r\n<\/div>\r\n<script type=\"text\/javascript\">\r\nvar addthis_config = {\r\n          services_compact: \"facebook, twitter, linkedin, google, digg, more\",\r\n          services_exclude: \"print, email\"\r\n}\r\n<\/script>\r\n<script type=\"text\/javascript\" src=\"http:\/\/s7.addthis.com\/js\/250\/addthis_widget.js\"><\/script>","nomobile":"","name":"sitestoredocument.socialshare-sitestoredocuments"}';
// 
// 	  	$db->update('engine4_core_content', array('params' => $social_share_default_code,), array('name =?' => 'sitestoredocument.socialshare-sitestoredocuments'));
// 		}
//END SOCIAL SHARE WIDGET WORK

$select = new Zend_Db_Select($db);
$select
        ->from('engine4_core_settings')
        ->where('name = ?', 'sitestore.feed.type');
$info = $select->query()->fetch();
$enable = 1;
if (!empty($info))
  $enable = $info['value'];
$db->query('INSERT IGNORE INTO   `engine4_activity_actiontypes` (`type`, `module`, `body`, `enabled`, `displayable`, `attachable`, `commentable`, `shareable`, `is_generated`, `is_object_thumb`) VALUES("sitestoredocument_admin_new", "sitestoredocument", "{item:$object} created a new document:", ' . $enable . ', 6, 2, 1, 1, 0, 1)');

$categoryIdColumn = $db->query("SHOW COLUMNS FROM engine4_sitestoredocument_documents LIKE 'category_id'")->fetch();
if (empty($categoryIdColumn)) {
  $db->query("ALTER TABLE `engine4_sitestoredocument_documents` ADD `category_id` INT( 11 )  NOT NULL DEFAULT '0';");
}

$categoryTableExist = $db->query("SHOW TABLES LIKE 'engine4_sitestoredocument_categories'")->fetch();
if (empty($categoryTableExist)) {
  $db->query("
        CREATE TABLE IF NOT EXISTS `engine4_sitestoredocument_categories` (
          `category_id` int(11) unsigned NOT NULL auto_increment,
          `title` varchar(64) NOT NULL,
          PRIMARY KEY  (`category_id`)
        ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE utf8_unicode_ci ;
      ");

//       $db->query("
//         INSERT IGNORE INTO `engine4_sitestoredocument_categories` (`title`) VALUES
//         ('Arts'),
//         ('Store'),
//         ('Conferences'),
//         ('Festivals'),
//         ('Food'),
//         ('Fundraisers'),
//         ('Galleries'),
//         ('Health'),
//         ('Just For Fun'),
//         ('Kids'),
//         ('Learning'),
//         ('Literary'),
//         ('Movies'),
//         ('Museums'),
//         ('Neighborhood'),
//         ('Networking'),
//         ('Nightlife'),
//         ('On Campus'),
//         ('Organizations'),
//         ('Outdoors'),
//         ('Pets'),
//         ('Politics'),
//         ('Sales'),
//         ('Science'),
//         ('Spirituality'),
//         ('Sports'),
//         ('Technology'),
//         ('Theatre'),
//         ('Other');
//       ");
}

//     $select = new Zend_Db_Select($db);
//     $select
//                 ->from('engine4_core_modules')
//                 ->where('name = ?', 'sitestoredocument')
//                 ->where('enabled = ?', 1);    
//     $is_sitestoredocument_object = $select->query()->fetchObject();
//     if($is_sitestoredocument_object) {    
//         $db->query('
//           INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `order`) VALUES
//           ("sitestoredocument_admin_main_categories", "sitestoredocument", "Categories", "", \'{"route":"admin_default","module":"sitestoredocument","controller":"settings","action":"categories"}\', "sitestoredocument_admin_main", "", 3);
//         ');
//     }
// 		$select = new Zend_Db_Select($db);
// 		$select
// 					->from('engine4_core_modules')
// 					->where('name = ?', 'sitemobile')
// 					->where('enabled = ?', 1);
// 		$is_sitemobile_object = $select->query()->fetchObject();
// 		if($is_sitemobile_object)  {
// 				include APPLICATION_PATH . "/application/modules/Sitestoredocument/controllers/license/mobileLayoutCreation.php";
// 		}
// ====================================================================================
//CHECK THAT SITESTORE PLUGIN IS ACTIVATED OR NOT
$select = new Zend_Db_Select($db);
$select
        ->from('engine4_core_settings')
        ->where('name = ?', 'sitestore.is.active')
        ->limit(1);
$sitestore_settings = $select->query()->fetchAll();
if (!empty($sitestore_settings)) {
  $sitestore_is_active = $sitestore_settings[0]['value'];
} else {
  $sitestore_is_active = 0;
}

//CHECK THAT SITESTORE PLUGIN IS INSTALLED OR NOT
$select = new Zend_Db_Select($db);
$select
        ->from('engine4_core_modules')
        ->where('name = ?', 'sitestore')
        ->where('enabled = ?', 1);
$check_sitestore = $select->query()->fetchObject();
if (!empty($check_sitestore) && !empty($sitestore_is_active)) {
  $select = new Zend_Db_Select($db);
  $select_store = $select
          ->from('engine4_core_pages', 'page_id')
          ->where('name = ?', 'sitestore_index_view')
          ->limit(1);
  $store = $select_store->query()->fetchAll();
  if (!empty($store)) {
    $store_id = $store[0]['page_id'];

    //INSERTING THE DOCUMENT WIDGET IN SITESTORE_ADMIN_CONTENT TABLE ALSO.
    Engine_Api::_()->getDbtable('admincontent', 'sitestore')->setAdminDefaultInfo('sitestoredocument.profile-sitestoredocuments', $store_id, 'Documents', 'true', '115');

    //INSERTING THE DOCUMENT WIDGET IN CORE_CONTENT TABLE ALSO.
    Engine_Api::_()->getApi('layoutcore', 'sitestore')->setContentDefaultInfo('sitestoredocument.profile-sitestoredocuments', $store_id, 'Documents', 'true', '115');

    //INSERTING THE DOCUMENT WIDGET IN SITESTORE_CONTENT TABLE ALSO.
    $select = new Zend_Db_Select($db);
    $contentstore_ids = $select->from('engine4_sitestore_contentstores', 'contentstore_id')->query()->fetchAll();
    foreach ($contentstore_ids as $contentstore_id) {
      if (!empty($contentstore_id)) {
        Engine_Api::_()->getDbtable('content', 'sitestore')->setDefaultInfo('sitestoredocument.profile-sitestoredocuments', $contentstore_id['contentstore_id'], 'Documents', 'true', '115');
      }
    }
  }

// 	$contentTable = Engine_Api::_()->getDbtable('content', 'core');
//   $contentTableName = $contentTable->info('name');

  $db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `custom`, `order`, `enabled`) VALUES
		("sitestoredocument_admin_main_widgets", "sitestoredocument", "Widget Settings", "", \'{"route":"admin_default","module":"sitestoredocument","controller":"widgets"}\', "sitestoredocument_admin_main", "", 0, 3, 1)');

  $db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitestoredocument_admin_submain_general_tab", "sitestoredocument", "General Settings", "", \'{"route":"admin_default","module":"sitestoredocument","controller":"widgets", "action": "index"}\', "sitestoredocument_admin_submain", "", 1, 0, 1)');

  $db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitestoredocument_admin_submain_document_tab", "sitestoredocument", "Tabbed Documents Widget", "", \'{"route":"admin_default","module":"sitestoredocument","controller":"settings", "action": "widget"}\', "sitestoredocument_admin_submain", "", 1, 0, 2)');

  $db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitestoredocument_admin_submain_dayitems", "sitestoredocument", "Document of the Day", "", \'{"route":"admin_default","module":"sitestoredocument","controller":"settings", "action": "manage-day-items"}\', "sitestoredocument_admin_submain", "", 1, 0, 4)');


// 	$select = new Zend_Db_Select($db);
// 	$select
// 					->from('engine4_core_pages')
// 					->where('name = ?', 'sitestoredocument_index_home')
// 					->limit(1);
// 	$info = $select->query()->fetch();
// 	if (empty($info)) {
// 		$db->insert('engine4_core_pages', array(
// 				'name' => 'sitestoredocument_index_home',
// 				'displayname' => 'Store Documents Home',
// 				'title' => 'Store Documents Home',
// 				'description' => 'This is store document home store.',
// 				'custom' => 1
// 		));
// 		$store_id = $db->lastInsertId('engine4_core_pages');
// 
// 		// containers
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $store_id,
// 				'type' => 'container',
// 				'name' => 'main',
// 				'parent_content_id' => null,
// 				'order' => 2,
// 				'params' => '',
// 		));
// 		$container_id = $db->lastInsertId('engine4_core_content');
// 
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $store_id,
// 				'type' => 'container',
// 				'name' => 'right',
// 				'parent_content_id' => $container_id,
// 				'order' => 5,
// 				'params' => '',
// 		));
// 		$right_id = $db->lastInsertId('engine4_core_content');
// 
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $store_id,
// 				'type' => 'container',
// 				'name' => 'left',
// 				'parent_content_id' => $container_id,
// 				'order' => 4,
// 				'params' => '',
// 		));
// 		$left_id = $db->lastInsertId('engine4_core_content');
// 
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $store_id,
// 				'type' => 'container',
// 				'name' => 'top',
// 				'parent_content_id' => null,
// 				'order' => 1,
// 				'params' => '',
// 		));
// 		$top_id = $db->lastInsertId('engine4_core_content');
// 
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $store_id,
// 				'type' => 'container',
// 				'name' => 'middle',
// 				'parent_content_id' => $top_id,
// 				'order' => 6,
// 				'params' => '',
// 		));
// 		$top_middle_id = $db->lastInsertId('engine4_core_content');
// 
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $store_id,
// 				'type' => 'container',
// 				'name' => 'middle',
// 				'parent_content_id' => $container_id,
// 				'order' => 6,
// 				'params' => '',
// 		));
// 		$middle_id = $db->lastInsertId('engine4_core_content');
// 
// 	// Top Middle
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $store_id,
// 				'type' => 'widget',
// 				'name' => 'sitestore.browsenevigation-sitestore',
// 				'parent_content_id' => $top_middle_id,
// 				'order' => 3,
// 				'params' => '',
// 		));
// 
// 		// Left
// 	
// 		//INSERT TOP RATED STORE DOCUMENT WIDGET
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $store_id,
// 				'type' => 'widget',
// 				'name' => 'sitestoredocument.homerate-sitestoredocuments',
// 				'parent_content_id' => $left_id,
// 				'order' => 14,
// 				'params' => '{"title":"Top Rated Documents","titleCount":"true"}',
// 		));
// 
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $store_id,
// 				'type' => 'widget',
// 				'name' => 'sitestoredocument.homerecent-sitestoredocuments',
// 				'parent_content_id' => $left_id,
// 				'order' => 13,
// 				'params' => '{"title":"Recent Store Documents","titleCount":"true"}',
// 		));
// 
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $store_id,
// 				'type' => 'widget',
// 				'name' => 'sitestoredocument.homepopular-sitestoredocuments',
// 				'parent_content_id' => $right_id,
// 				'order' => 20,
// 				'params' => '{"title":"Most Popular Documents","titleCount":"true"}',
// 		));
// 
// 		// Middle
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $store_id,
// 				'type' => 'widget',
// 				'name' => 'sitestoredocument.featured-documents-slideshow',
// 				'parent_content_id' => $middle_id,
// 				'order' => 15,
// 				'params' => '{"title":"Featured Documents","titleCount":"true"}',
// 		));
// 
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $store_id,
// 				'type' => 'widget',
// 				'name' => 'sitestoredocument.list-documents-tabs-view',
// 				'parent_content_id' => $middle_id,
// 				'order' => 17,
// 				'params' => '{"title":"Documents","margin_photo":"12"}',
// 		));
// 		// Right Side
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $store_id,
// 				'type' => 'widget',
// 				'name' => 'sitestoredocument.sitestoredocumentlist-link',
// 				'parent_content_id' => $right_id,
// 				'order' => 19,
// 				'params' => '',
// 		));
// 
// 		// Right Side
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $store_id,
// 				'type' => 'widget',
// 				'name' => 'sitestoredocument.search-sitestoredocument',
// 				'parent_content_id' => $right_id,
// 				'order' => 18,
// 				'params' => '',
// 		));
// 
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $store_id,
// 				'type' => 'widget',
// 				'name' => 'sitestoredocument.document-of-the-day',
// 				'parent_content_id' => $left_id,
// 				'order' => 12,
// 				'params' => '{"title":"Document of the Day"}',
// 		));
// 
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $store_id,
// 				'type' => 'widget',
// 				'name' => 'sitestoredocument.homefeaturelist-sitestoredocuments',
// 				'parent_content_id' => $right_id,
// 				'order' => 21,
// 				'params' => '{"title":"Featured Documents","itemCountPerStore":3}',
// 		));
// 
// 
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $store_id,
// 				'type' => 'widget',
// 				'name' => 'sitestoredocument.homecomment-sitestoredocuments',
// 				'parent_content_id' => $right_id,
// 				'order' => 22,
// 				'params' => '{"title":"Most Commented Documents","titleCount":"true"}',
// 		));
// 
// 		$db->insert('engine4_core_content', array(
// 				'page_id' => $store_id,
// 				'type' => 'widget',
// 				'name' => 'sitestoredocument.homelike-sitestoredocuments',
// 				'parent_content_id' => $right_id,
// 				'order' => 23,
// 				'params' => '{"title":"Most Liked Documents","titleCount":"true"}',
// 		));
// 	}
// 	$select = new Zend_Db_Select($db);
// 	$select
// 				->from('engine4_core_content')
// 				->where('name = ?', 'sitestoredocument.featurelist-sitestoredocuments');
// 				
// 	$is_exit = $select->query()->fetchObject();
// 	if(!empty($is_exit)) {
// 		$db->update('engine4_core_content', array(
// 			'name' => 'sitestoredocument.highlightlist-sitestoredocuments',
// 			'params' => '{"title":"Highlighted Documents","titleCount":true}',
// 					), array(
// 			'name = ?' => 'sitestoredocument.featurelist-sitestoredocuments',
// 		));
// 	}
// 	
// 	$select = new Zend_Db_Select($db);
// 	$select
// 				->from('engine4_sitestore_admincontent')
// 				->where('name = ?', 'sitestoredocument.featurelist-sitestoredocuments');
// 				
// 	$is_exit_content = $select->query()->fetchObject();
// 	if(!empty($is_exit_content)) {
// 		$db->update('engine4_core_content', array(
// 			'name' => 'sitestoredocument.highlightlist-sitestoredocuments',
// 			'params' => '{"title":"Highlighted Documents","titleCount":true}',
// 					), array(
// 			'name = ?' => 'sitestoredocument.featurelist-sitestoredocuments',
// 		));
// 	}
// 
// 	$select = new Zend_Db_Select($db);
// 	$select
// 				->from('engine4_sitestore_content')
// 				->where('name = ?', 'sitestoredocument.featurelist-sitestoredocuments');
// 				
// 	$is_exit_sitestorecontent = $select->query()->fetchObject();
// 	if(!empty($is_exit_sitestorecontent)) {
// 		$db->update('engine4_core_content', array(
// 			'name' => 'sitestoredocument.highlightlist-sitestoredocuments',
// 			'params' => '{"title":"Highlighted Documents","titleCount":true}',
// 					), array(
// 			'name = ?' => 'sitestoredocument.featurelist-sitestoredocuments',
// 		));
// 	}
}
?>