<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitestoredocument
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: manifest.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$routeStart = "storedocuments";
$module=null;$controller=null;$action=null;$getURL = null;
$request = Zend_Controller_Front::getInstance()->getRequest();
if (!empty($request)) {
  $module = $request->getModuleName(); // Return the current module name.
  $action = $request->getActionName();
  $controller = $request->getControllerName();
  $getURL = $request->getRequestUri();
}
if (empty($request) || !($module == "default" && ( strpos( $getURL, '/install') !== false))) {
  $routeStart = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestoredocument.manifestUrl', "store-documents");
}
return array(
    // Package -------------------------------------------------------------------
    'package' => array(
        'type' => 'module',
        'name' => 'sitestoredocument',
        'version' => '-',
        'path' => 'application/modules/Sitestoredocument',
        'repository' => 'null',
        'title' => '<i><span style="color:#999999">Stores / Marketplace - Documents Extension</span></i>',
        'description' => '<i><span style="color:#999999">Stores / Marketplace - Documents Extension</span></i>',
      'author' => '<a href="http://www.socialapps.tech" style="text-decoration:underline;" target="_blank">SocialApps.tech</a>',
        'date' => 'Thrusday, 05 May 2011 18:33:08 +0000',
        'copyright' => 'Copyright 2010-2011 BigStep Technologies Pvt. Ltd.',
        'actions' => array(
            'install',
            'upgrade',
            'refresh',
            'enable',
            'disable',
        ),
        'callback' => array(
            'path' => 'application/modules/Sitestoredocument/settings/install.php',
            'class' => 'Sitestoredocument_Installer',
        ),
        'directories' => array(
            'application/modules/Sitestoredocument',
        ),
        'files' => array(
            'application/languages/en/sitestoredocument.csv',
        ),
    ),
    //'sitemobile_compatible' => true,
    // Hooks ---------------------------------------------------------------------
    'hooks' => array(
        array(
            'event' => 'onUserDeleteBefore',
            'resource' => 'Sitestoredocument_Plugin_Core',
        ),
//        array(
//       'event' => 'onRenderLayoutMobileSMDefault',
//       'resource' => 'Sitestoredocument_Plugin_Sitemobile',
//     ),
    ),
    // Items ---------------------------------------------------------------------
    'items' => array(
        'sitestoredocument_document',
        'sitestoredocument_search',
    ),
    // Routes --------------------------------------------------------------------
    'routes' => array(
        'sitestoredocument_general' => array(
            'route' => $routeStart.'/upload/:action/*',
            'defaults' => array(
                'module' => 'sitestoredocument',
                'controller' => 'index',
                'action' => 'upload-photo',
            ),
            'reqs' => array(
                'action' => '(upload-photo)',
            ),
        ),
        'sitestoredocument_create' => array(
            'route' => $routeStart.'/create/:store_id/*',
            'defaults' => array(
                'module' => 'sitestoredocument',
                'controller' => 'index',
                'action' => 'create'
            ),
            'reqs' => array(
                'store_id' => '\d+'
            )
        ),
        'sitestoredocument_delete' => array(
            'route' => $routeStart.'/delete/:document_id/:store_id/*',
            'defaults' => array(
                'module' => 'sitestoredocument',
                'controller' => 'index',
                'action' => 'delete'
            ),
            'reqs' => array(
                'document_id' => '\d+',
                'store_id' => '\d+'
            )
        ),
        'sitestoredocument_publish' => array(
            'route' => $routeStart.'/publish/:document_id/*',
            'defaults' => array(
                'module' => 'sitestoredocument',
                'controller' => 'index',
                'action' => 'publish'
            ),
            'reqs' => array(
                'document_id' => '\d+'
            )
        ),
        'sitestoredocument_featured' => array(
            'route' => $routeStart.'/featured/:document_id/*',
            'defaults' => array(
                'module' => 'sitestoredocument',
                'controller' => 'index',
                'action' => 'featured'
            ),
            'reqs' => array(
                'document_id' => '\d+'
            )
        ),
         'sitestoredocument_highlighted' => array(
            'route' => $routeStart.'/highlighted/:document_id/*',
            'defaults' => array(
                'module' => 'sitestoredocument',
                'controller' => 'index',
                'action' => 'highlighted'
            ),
            'reqs' => array(
                'document_id' => '\d+'
            )
        ),
        'sitestoredocument_approved' => array(
            'route' => $routeStart.'/approved/:document_id',
            'defaults' => array(
                'module' => 'sitestoredocument',
                'controller' => 'index',
                'action' => 'approved'
            ),
            'reqs' => array(
                'document_id' => '\d+'
            )
        ),
        'sitestoredocument_edit' => array(
            'route' => $routeStart.'/edit/:document_id/:store_id/*',
            'defaults' => array(
                'module' => 'sitestoredocument',
                'controller' => 'index',
                'action' => 'edit'
            )
        ),
        'sitestoredocument_ssl' => array(
            'route' => $routeStart.'/ssl/*',
            'defaults' => array(
                'module' => 'sitestoredocument',
                'controller' => 'index',
                'action' => 'ssl'
            )
        ),
        'sitestoredocument_detail_view' => array(
            'route' => $routeStart.'/:user_id/:document_id/:slug/*',
            'defaults' => array(
                'module' => 'sitestoredocument',
                'controller' => 'index',
                'action' => 'view',
                'slug' => '',
            ),
            'reqs' => array(
                'user_id' => '\d+',
                'document_id' => '\d+'
            )
        ),

        'sitestoredocument_browse' => array(
            'route' => $routeStart.'/browse/*',
            'defaults' => array(
                'module' => 'sitestoredocument',
                'controller' => 'index',
                'action' => 'browse',
            ),
        ),

        'sitestoredocument_home' => array(
            'route' => $routeStart.'/home/*',
            'defaults' => array(
                'module' => 'sitestoredocument',
                'controller' => 'index',
                'action' => 'home',
            ),
        ), 
    )
)
?>