<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitestoredocument
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$isActive = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestoredocument.isActivate', 0);
if ( empty($isActive) ) {
  return;
}

$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => $view->translate('Store Profile Documents'),
        'description' => $view->translate('This widget forms the Documents tab on the Store Profile and displays the documents of the Store. It should be placed in the Tabbed Blocks area of the Store Profile.'),
        'category' => $view->translate('Store Profile'),
        'type' => 'widget',
        'name' => 'sitestoredocument.sitemobile-profile-sitestoredocuments',
        'defaultParams' => array(
            'title' => $view->translate('Documents'),
        ),
    ),

     array(
        'title' => $view->translate('Store Documents'),
        'description' => $view->translate('Displays the list of Documents from Stores created on your community. This widget should be placed in the widgetized Store Documents store. Results from the Search Store Documents form are also shown here.'),
        'category' => $view->translate('Stores'),
        'type' => 'widget',
        'name' => 'sitestoredocument.sitestore-document',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => $view->translate('Count'),
                        'description' => $view->translate('(number of documents to show)'),
                        'value' => 10,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
	array(
			'title' => $view->translate('Store Document View'),
			'description' => $view->translate("This widget should be placed on the Store Document View Store."),
      'category' => $view->translate('Stores'),
			'type' => 'widget',
			'name' => 'sitestoredocument.document-content',
			'defaultParams' => array(
					'title' => '',
					'titleCount' => true,
			),
	),
)
?>