<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitestoreintegration
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Integration.php 2012-31-12 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitestoreintegration_Form_Admin_Integration extends Engine_Form {

  public function init() {

		$sitepageEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitepage');
		$sitereviewEnabled = Engine_Api::_()->getDbtable( 'modules' , 'core' )->isModuleEnabled('sitereview') ;
		$sitereviewlistingtypeEnabled = Engine_Api::_()->getDbtable( 'modules' , 'core' )->isModuleEnabled('sitereviewlistingtype') ;
		$listEnabled = Engine_Api::_()->getDbtable( 'modules' , 'core' )->isModuleEnabled('list');
		
		if (!empty($sitepageEnabled) && (!empty($sitereviewEnabled) || !empty($listEnabled))) {
			$Description = "This widget displays listings / pages added from a selected content module, which you can choose from the settings of this widget, to the Store currently being viewed. You can place this widget multiple times on Store Profile page with different content modules chosen for each placement. It is recommended to place this widget in the Tabbed Blocks area of the Store Profile page.";
		} elseif (!empty($sitereviewEnabled) || !empty($listEnabled)) {
			$Description = "This widget displays listings added from a selected content module, which you can choose from the settings of this widget, to the Store currently being viewed. You can place this widget multiple times on Store Profile page with different content modules chosen for each placement. It is recommended to place this widget in the Tabbed Blocks area of the Store Profile page.";
		} elseif($sitepageEnabled) {
			$Description = "This widget displays pages added from a selected content module, which you can choose from the settings of this widget, to the Store currently being viewed. You can place this widget multiple times on Store Profile page with different content modules chosen for each placement. It is recommended to place this widget in the Tabbed Blocks area of the Store Profile page.";
		}
	
    $this->setMethod('post');
    $this->setTitle('Store Profile Listings (selected content)')
					->setDescription("$Description");
					
		$modNameValues = array();
		
    $mixSettingsResults = Engine_Api::_()->getDbtable('mixsettings', 'sitestoreintegration')->getIntegrationItems();

		foreach($mixSettingsResults as $modNameValue) {
		
			if(empty($modNameValue["listingtype_id"])) {
				$modNameValue["listingtype_id"] = 0;
			}

			$modNameValues[$modNameValue["resource_type"] . '_' .  $modNameValue["listingtype_id"]] = $modNameValue["item_title"];
		}
		
		if  (isset($modNameValue))
			$modNameValues = array_merge(array(""), $modNameValues);

		if (!empty($modNameValues)) {
			$this->addElement('Select', 'resource_type', array(
			'label' => 'Select the content',
			'multiOptions' => $modNameValues
			));
			
			$this->addElement('Text', 'title_truncation', array(
					'label' => 'Title Truncation Limit',
					'value' => 70,
			));
			
			$this->addElement( 'Radio' , 'show_posted_date' , array (
				'label' => 'Do you want “Posted By” and “Posted Date” information options to be available in this block?',
				'multiOptions' => array (
					1 => 'Yes' ,
					0 => 'No'
				) ,
				'value' => 0,
			)) ;
		}
		else {
		  $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
			$URL = $view->baseUrl() . "/admin/sitestoreintegration/settings";
      $click = '<a href="' . $URL . '" target="_blank">Click here</a>';
	    $description = sprintf("Note: You have not enabled adding of listings / pages from any content module to Directory Items / Stores. To enable adding of listings / pages, please %s",  $click);
			$description = "<div class='tip'><span>" . $description . "</span></div>" ;
			$this->addElement( 'Dummy' , 'resource_type' , array (
			'description' => $description ,
			) ) ;
			$this->resource_type->addDecorator( 'Description' , array ( 'placement' => Zend_Form_Decorator_Abstract::PREPEND , 'escape' => false ) ) ;
		}
  }
}