<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitestoreintegration
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminSettingsController.php 2012-31-12 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitestoreintegration_AdminSettingsController extends Core_Controller_Action_Admin {

    public function indexAction() {

        //START GROUP / COMMUNITIES PLUGIN INTEGRATION.
        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitegroup')) {
            $this->pluginIntegration('sitestore_group_integration', 'Groups', 'sitegroup_group_0', 'sitegroup', 'group_id');
        }
        //END GROUP / COMMUNITIES PLUGIN INTEGRATION.
        //START BUSINESS PLUGIN INTEGRATION.
        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusiness')) {
            $this->pluginIntegration('sitestore_business_integration', 'Businesses', 'sitebusiness_business_0', 'sitebusiness', 'business_id');
        }
        //END BUSINESS PLUGIN INTEGRATION.
        //START PAGES PLUGIN INTEGRATION.
        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitepage')) {
            $this->pluginIntegration('sitestore_page_integration', 'Pages', 'sitepage_page_0', 'sitepage', 'page_id');
        }
        //END PAGES PLUGIN INTEGRATION.
        //START DOCUMENT PLUGIN INTEGRATION.
        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('document')) {
            $this->pluginIntegration('sitestore_document_integration', 'Documents', 'document_0', 'document', 'document_id');
        }
        //END DOCUMENT PLUGIN INTEGRATION.
        //START LISTINGS PLUGIN INTEGRATION.
        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('list')) {
            $this->pluginIntegration('sitestore_list_integration', 'Listings', 'list_listing_0', 'list', 'listing_id');
        }
        //END LISTINGS PLUGIN INTEGRATION.
        
        $this->view->navigationStore = Engine_Api::_()->getApi('menus', 'core')
            ->getNavigation('sitestore_admin_main', array(), 'sitestore_admin_main_settings');

        //GET NAVIGATION
        $this->view->navigationStoreGlobal = Engine_Api::_()->getApi('menus', 'core')
            ->getNavigation('sitestore_admin_main_settings', array(), 'sitestore_admin_main_global_integration');

        $this->view->form = $form = new Sitestoreintegration_Form_Admin_Global();

        if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost()) || isset($_GET['store_reload'])) {

            $values = $form->getValues();

            //BEGIN TRANSACTION
            $db = Engine_Db_Table::getDefaultAdapter();
            $db->beginTransaction();
            $coreTable = Engine_Api::_()->getDbtable('pages', 'core');
            $coreTableName = $coreTable->info('name');
            $coreContentTable = Engine_Api::_()->getDbtable('content', 'core');
            $coreContentTableName = $coreContentTable->info('name');
            $adminContentTable = Engine_Api::_()->getDbtable('admincontent', 'sitestore');
            $adminContentTableName = $adminContentTable->info('name');
            $contentStoreTable = Engine_Api::_()->getDbtable('contentstores', 'sitestore');
            $contentStoreTableName = $contentStoreTable->info('name');
            $contentSitestoreTable = Engine_Api::_()->getDbtable('content', 'sitestore');
            $contentSitestoreTableName = $contentSitestoreTable->info('name');
            try {
                foreach ($values as $key => $value) {
                    if (strstr($key, 'sitestore_sitereview_listing') && !empty($value)) {
                        $pieces = explode('_', $key);
                        $listingTypeId = $pieces[3];
                        $resource_type = 'sitereview_listing';

                        $itemTitle = Engine_Api::_()->getDbtable('listingtypes', 'sitereview')->getListingTypeColumn($listingTypeId, 'title_singular');

                        $db->query('INSERT IGNORE INTO `engine4_sitestoreintegration_mixsettings` (`module`, `resource_type`, `resource_id`, `item_title`, `enabled`) VALUES ("sitereview", "sitereview_listing_' . $listingTypeId . '", "listing_id", "' . $itemTitle . '", 0);');

                        $db->query('UPDATE `engine4_sitestoreintegration_mixsettings` SET `enabled` = "' . $value . '" WHERE `engine4_sitestoreintegration_mixsettings`.`resource_type` = "sitereview_listing_' . $listingTypeId . '" and `engine4_sitestoreintegration_mixsettings`.`module` = "sitereview";');

                        $this->setDefaultData($coreTable, $coreTableName, $coreContentTable, $coreContentTableName, 'page_id', 'content_id', null, 'sitereview', '{"title":"' . $itemTitle . '","resource_type":"sitereview_listing_' . $listingTypeId . '","nomobile":"0","name":"sitestoreintegration.profile-items"}', 'page_id');

                        $this->setDefaultData($coreTable, $coreTableName, $adminContentTable, $adminContentTableName, 'page_id', 'admincontent_id', null, 'sitereview', '{"title":"' . $itemTitle . '","resource_type":"sitereview_listing_' . $listingTypeId . '","nomobile":"0","name":"sitestoreintegration.profile-items"}', 'store_id');

                        foreach ($results as $value) {
                            $this->setDefaultData($contentStoreTable, $contentStoreTableName, $contentSitestoreTable, $contentSitestoreTableName, 'contentstore_id', 'content_id', $value['store_id'], 'sitereview', '{"title":"' . $itemTitle . '","resource_type":"sitereview_listing_' . $listingTypeId . '","nomobile":"0","name":"sitestoreintegration.profile-items"}', 'contentstore_id');
                        }
                    } else if (strstr($key, 'sitestore_sitereview_listing')) {
                        $pieces = explode('_', $key);
                        $listingTypeId = $pieces[3];

                        $itemTitle = Engine_Api::_()->getDbtable('listingtypes', 'sitereview')->getListingTypeColumn($listingTypeId, 'title_singular');

                        $db->query('INSERT IGNORE INTO `engine4_sitestoreintegration_mixsettings` (`module`, `resource_type`, `resource_id`, `item_title`, `enabled`) VALUES ("sitereview", "sitereview_listing_' . $listingTypeId . '", "listing_id", "' . $itemTitle . '", 0);');

                        $db->query('UPDATE `engine4_sitestoreintegration_mixsettings` SET `enabled` = "' . $value . '" WHERE `engine4_sitestoreintegration_mixsettings`.`resource_type` = "sitereview_listing_' . $listingTypeId . '" and `engine4_sitestoreintegration_mixsettings`.`module` = "sitereview";');
                    }
                }

                // Okay, save
                foreach ($values as $key => $value) {
                    if ($value != '') {
                        Engine_Api::_()->getApi('settings', 'core')->setSetting($key, $value);
                    }
                }
                $db->commit();

                if ($store_reload < $reload_count) {
                    $store_reload++;
                    $this->_redirect('admin/sitestoreintegration/settings/index?store_reload=' . $store_reload);
                }
            } catch (Exception $e) {
                $db->rollBack();
                throw $e;
            }

            return $this->_helper->redirector->gotoRoute(array('action' => 'index'));
        }
    }

    public function setDefaultData($storeTable, $storeTableName, $coreContentTable, $coreContentTableName, $storeId, $content_id, $forStore = null, $module, $params, $store_id = null, $resourceType = null) {
        $db = Engine_Db_Table::getDefaultAdapter();

        $select = $storeTable->select()
                ->from($storeTableName, array($storeId))
                ->where('name = ?', 'sitestore_index_view');

        if (!empty($forStore)) {
            $select->where("$storeId = ?", $forStore);
        } /* else if(!empty($forStore) && !empty($store_id)) {
          $select->where("$store_id = ?", $forStore);
          } */

        $getStoreId = $select->query()->fetchColumn();

        // @Make an condition
        if (!empty($getStoreId)) {
            $getContainerId = $coreContentTable->select()
                    ->from($coreContentTableName, array($content_id))
                    ->where('type = ?', 'container')
                    ->where("$store_id = ?", $getStoreId)
                    ->where('name = ?', 'main')
                    ->query()
                    ->fetchColumn();
            if (!empty($getContainerId)) {
                $getMiddleContentId = $coreContentTable->select()
                        ->from($coreContentTableName, array($content_id))
                        ->where('type = ?', 'container')
                        ->where("parent_content_id = ?", $getContainerId)
                        ->where('name = ?', 'middle')
                        ->query()
                        ->fetchColumn();

                if (!empty($getMiddleContentId)) {
                    $getCoreContainerContentId = $coreContentTable->select()
                            ->from($coreContentTableName, array($content_id))
                            ->where('type = ?', 'widget')
                            ->where("$store_id = ?", $getStoreId)
                            ->where('name = ?', 'core.container-tabs')
                            ->query()
                            ->fetchColumn();
                    $select = new Zend_Db_Select($db);
                    $select
                            ->from('engine4_core_modules')
                            ->where('name = ?', $module);
                    $check_list = $select->query()->fetchObject();

                    if (!empty($check_list)) {
                        if (!empty($getCoreContainerContentId)) {
                            $contentStoreId = $coreContentTable->select()
                                    ->from($coreContentTableName, array($content_id))
                                    ->where('parent_content_id = ?', $getCoreContainerContentId)
                                    ->where('name = ?', 'sitestoreintegration.profile-items')
                                    ->where('type = ?', 'widget')
                                    ->where('params LIKE ?', '%' . $params . '%')
                                    ->query()
                                    ->fetchColumn();

                            if (empty($contentStoreId)) {
                                //INSERT MAIN-MIDDLE CONTAINER
                                $insertMainItem = $coreContentTable->createRow();
                                $insertMainItem->$store_id = $getStoreId;
                                $insertMainItem->type = 'widget';
                                $insertMainItem->name = 'sitestoreintegration.profile-items';
                                $insertMainItem->parent_content_id = $getCoreContainerContentId;
                                $insertMainItem->order = 999;
                                $insertMainItem->params = $params;
                                $insertMainItem->save();
                            }
                        } else {
                            $contentStoreId = $coreContentTable->select()
                                    ->from($coreContentTableName, array($content_id))
                                    ->where('parent_content_id = ?', $getMiddleContentId)
                                    ->where('name = ?', 'sitestoreintegration.profile-items')
                                    ->where('type = ?', 'widget')
                                    ->where('params LIKE ?', '%' . $params . '%')
                                    ->query()
                                    ->fetchColumn();

                            if (empty($contentStoreId)) {
                                //INSERT MAIN-MIDDLE CONTAINER
                                $insertMainItem = $coreContentTable->createRow();
                                $insertMainItem->$store_id = $getStoreId;
                                $insertMainItem->type = 'widget';
                                $insertMainItem->name = 'sitestoreintegration.profile-items';
                                $insertMainItem->parent_content_id = $getMiddleContentId;
                                $insertMainItem->order = 999;
                                $insertMainItem->params = $params;
                                $insertMainItem->save();
                            }
                        }
                    }
                }
            }
        }
    }
    
    public function pluginIntegration($globalFormValue, $titleName, $resourceType, $moduleName, $resource_id) {

        $coreTable = Engine_Api::_()->getDbtable('pages', 'core');
        $coreTableName = $coreTable->info('name');
        $coreContentTable = Engine_Api::_()->getDbtable('content', 'core');
        $coreContentTableName = $coreContentTable->info('name');
        $adminContentTable = Engine_Api::_()->getDbtable('admincontent', 'sitestore');
        $adminContentTableName = $adminContentTable->info('name');
        $contentStoreTable = Engine_Api::_()->getDbtable('contentstores', 'sitestore');
        $contentStoreTableName = $contentStoreTable->info('name');
        $contentSitestoreTable = Engine_Api::_()->getDbtable('content', 'sitestore');
        $contentSitestoreTableName = $contentSitestoreTable->info('name');
        $db = Engine_Db_Table::getDefaultAdapter();


        if (isset($_POST["$globalFormValue"]) && $_POST["$globalFormValue"] == '0') {
            $db->query("UPDATE `engine4_sitestoreintegration_mixsettings` SET `enabled` = '0' WHERE `engine4_sitestoreintegration_mixsettings`.`resource_type` = '$resourceType' LIMIT 1 ;");
        } else {

            $this->setDefaultData($coreTable, $coreTableName, $coreContentTable, $coreContentTableName, 'page_id', 'content_id', null, "$moduleName", '{"title":"' . $titleName . '","resource_type":"' . $resourceType . '","nomobile":"0","name":"sitestoreintegration.profile-items"}', 'page_id');

            $this->setDefaultData($coreTable, $coreTableName, $adminContentTable, $adminContentTableName, 'page_id', 'admincontent_id', null, "$moduleName", '{"title":"' . $titleName . '","resource_type":"' . $resourceType . '","nomobile":"0","name":"sitestoreintegration.profile-items"}', 'store_id');

            $totalStores = $contentStoreTable->select()
                            ->from($contentStoreTableName, array('count(*) as count'))
                            ->where('name =?', 'sitestore_index_view')->query()->fetchColumn();

            $limit = 1000;
            $reload_count = round($totalStores / $limit);
            $store_reload = $this->_getParam('store_reload', 1);
            $offset = ($store_reload - 1) * $limit;

            //store profile store
            $select = new Zend_Db_Select($db);
            $select
                    ->from('engine4_sitestore_contentstores', array('store_id'))
                    ->where('name = ?', 'sitestore_index_view')
                    ->limit($limit, $offset);
            $results = $select->query()->fetchAll();

            foreach ($results as $result) {
                $this->setDefaultData($contentStoreTable, $contentStoreTableName, $contentSitestoreTable, $contentSitestoreTableName, 'contentstore_id', 'content_id', $result['store_id'], "$moduleName", '{"title":"' . $titleName . '","resource_type":"' . $resourceType . '","nomobile":"0","name":"sitestoreintegration.profile-items"}', 'contentstore_id');
            }

            if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled($moduleName)) {
                $db->query("INSERT IGNORE INTO `engine4_sitestoreintegration_mixsettings` (`module`, `resource_type`, `resource_id`, `item_title`, `enabled`) VALUES ('$moduleName', '$resourceType', '$resource_id', '$titleName', 1);");
            }

            $db->query("UPDATE `engine4_sitestoreintegration_mixsettings` SET `enabled` = '1' WHERE `engine4_sitestoreintegration_mixsettings`.`resource_type` = '$resourceType' LIMIT 1 ;");
        }
    }

}