<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitestoreintegration
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2012-31-12 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitestoreintegration_Widget_ProfileItemsController extends Seaocore_Content_Widget_Abstract {

  protected $_childCount;

  public function indexAction() {

    //DON'T RENDER IF SUBJECT IS NOT SET
    if (!Engine_Api::_()->core()->hasSubject()) {
      return $this->setNoRender();
    }

    $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->title_truncation = $this->_getParam('title_truncation', 70);
    $this->view->show_posted_date = $this->_getParam('show_posted_date', 0);

    //GET THE RESOURCE TYPE.
    $this->view->resource_type = $resource_type = $this->_getParam('resource_type', null);
    
    if (empty($resource_type)) {
      return $this->setNoRender();
    }
    
    $pieces = explode("_", $resource_type);
    if ($resource_type == 'document_0' || $resource_type == 'folder_0' || $resource_type == 'quiz_0') {
      $listingTypeId = $pieces[1];
      $resource_type = $pieces[0];
    } else { 
      $listingTypeId = $pieces[2];
      $resource_type = $pieces[0] . '_' . $pieces[1];
    }

    $sub_status_select = Engine_Api::_()->getDbtable('mixsettings', 'sitestoreintegration')->fetchRow(array('resource_type = ?' => $resource_type . '_' . $listingTypeId, 'enabled = ?' => 1));
    if (empty($sub_status_select)) {
      return $this->setNoRender();
    }

    //GET SUBJECT AND STORE ID.
    $this->view->sitestore = $sitestore = Engine_Api::_()->core()->getSubject('sitestore_store');
    $this->view->store_id = $store_id = $sitestore->store_id;
    $this->view->listingTypeId = $listingTypeId;
    
    if (Engine_API::_()->seaocore()->checkSitemobileMode('fullsite-mode')) {
			$Params = Engine_Api::_()->sitestoreintegration()->integrationParams($resource_type, $listingTypeId, $store_id);
			$this->view->createPrivacy =  $Params['create_privacy'] ;

			if($resource_type == 'list_listing') {
				//RATING IS ENABLED OR NOT
				$this->view->ratngShow = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('list.rating', 1);
			} elseif($resource_type == 'sitereview_listing') {
				$this->view->listingType = Engine_Api::_()->getItem('sitereview_listingtype', $listingTypeId);
			}
      $this->view->mixSettingsResults = $mixSettingsResults = Engine_Api::_()->getDbtable('mixsettings', 'sitestoreintegration')->getIntegrationItems();
    }


    //CHECK FOR MANAGE ADMIN
    $isManageAdmin = Engine_Api::_()->sitestore()->isManageAdmin($sitestore, 'edit');
    if (empty($isManageAdmin)) {
      $this->view->can_edit = $can_edit = 0;
    } else {
      $this->view->can_edit = $can_edit = 1;
    }

    //PACKAGE BASE AND MEMBER LEVEL SETTINGS PRIYACY START
    $sitestoreintegrationStoreOwner = Zend_Registry::isRegistered('sitestoreintegrationPageOwner') ? Zend_Registry::get('sitestoreintegrationPageOwner') : null;
    if (Engine_Api::_()->sitestore()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitestore()->allowPackageContent($sitestore->package_id, "modules", $resource_type. '_' . $listingTypeId)) {
        return $this->setNoRender();
      }
    } else {
      $isStoreOwnerAllow = Engine_Api::_()->sitestore()->isStoreOwnerAllow($sitestore, $resource_type . '_' . $listingTypeId);
      if (empty($isStoreOwnerAllow)) {
        return $this->setNoRender();
      }
    }

    if (empty($sitestoreintegrationStoreOwner)) {
      return $this->setNoRender();
    }
    //PACKAGE BASE AND MEMBER LEVEL SETTINGS PRIYACY END
    if (Engine_API::_()->seaocore()->checkSitemobileMode('fullsite-mode')) {
      //GET LAYOUT
      $layout = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestore.layoutcreate', 0);

      //GET THE THIRD TYPE LAYOUT
      $this->view->widgets = $widgets = Engine_Api::_()->sitestore()->getwidget($layout, $store_id);
      //SHOWING THE TOP TITLE IN CASE OF NON TABBED LAYOUT
      $this->view->showtoptitle = Engine_Api::_()->sitestore()->showtoptitle($layout, $sitestore->store_id);
      //GET THE CURRENT TAB ID
      $this->view->module_tabid = $currenttabid = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab', null);



      //$this->view->content_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab', null);

      if (Zend_Controller_Front::getInstance()->getRequest()->getParam('resource_type', null)) {
        $this->view->content_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab', null);
        $this->view->change_url = 1;
      } else {
        $this->view->content_id = Engine_Api::_()->sitestore()->getTabIdInfoIntegration('sitestoreintegration.profile-items', $store_id, $layout);
        $this->view->change_url = 0;
      }
      //REQUEST TYPE IS AJAX OR NOT
      $this->view->isajax = $isajax = $this->_getParam('isajax', null);
      if (!empty($isajax)) {
        $this->getElement()->removeDecorator('Title');
        $this->getElement()->removeDecorator('Container');
        //$this->getElement()->removeDecorator('Class');
      }
    } else {
      $this->view->resource_type = $resource_type = $this->_getParam('resource_type', null);
      $currenttabid = $this->view->identity;
    }

    //SHOWING THE NOTES
    if (!empty($isajax) || ($currenttabid == $this->view->identity ) || ($widgets == 0)) {

      $this->view->search = $search = $this->_getParam('search');
      $this->view->selectbox = $selectbox = $this->_getParam('selectbox');
      if (!empty($selectbox)) {
        $params['orderby'] = $selectbox;
      } /* else {
        $params['orderby'] = 'creation_date';
        } */

      if (!empty($search)) {
        $params['search'] = $search;
      }

      //GET THE TAB ID
      $this->view->identity_temp = Zend_Controller_Front::getInstance()->getRequest()->getParam('identity_temp', $currenttabid);

      $this->view->show_content = true;

      $this->view->resource_type = $resource_type = Zend_Controller_Front::getInstance()->getRequest()->getParam('resource_type', $resource_type);
      $this->view->title_truncation = Zend_Controller_Front::getInstance()->getRequest()->getParam('title_truncation', 70);
      $this->view->show_posted_date = Zend_Controller_Front::getInstance()->getRequest()->getParam('show_posted_date', 0);


      $pieces = explode("_", $resource_type);
      if ($resource_type == 'document_0' || $resource_type == 'folder_0' || $resource_type == 'quiz_0') {
        $this->view->listingTypeId = $params['listingtype_id'] = $listingTypeId = $pieces[1];
        $params['resource_type'] = $resource_type = $pieces[0];
      }	else {
        $this->view->listingTypeId = $params['listingtype_id'] = $listingTypeId = $pieces[2];
        $params['resource_type'] = $resource_type = $pieces[0] . '_' . $pieces[1];
      }

      $params['store_id'] = $store_id;

      $this->view->contentResults = $paginator = Engine_Api::_()->getDbtable('contents', 'sitestoreintegration')->getResults($params);

      //ADD COUNT TO TITLE IF CONFIGURED
      if ($paginator->getTotalItemCount() > 0) {
        $this->_childCount = $paginator->getTotalItemCount();
      }
      $paginator->setItemCountPerPage('300');
    } else {

      $count = 0;
      //SHOWING THE CONTENT NOT BY THE AJAX
      $this->view->show_content = false;

      //GET THE TAB ID
      $this->view->identity_temp = $this->view->identity;
      $params['resource_type'] = $resource_type;
      $params['listingtype_id'] = $listingTypeId;
      $params['store_id'] = $store_id;

      $paginator = Engine_Api::_()->getDbtable('contents', 'sitestoreintegration')->getResults($params);

      //ADD COUNT TO TITLE IF CONFIGURED
      if ($paginator->getTotalItemCount() > 0) {
        $this->_childCount = $paginator->getTotalItemCount();
      }

      // Do not render if nothing to show
      if ($paginator->getTotalItemCount() <= 0) {
        return $this->setNoRender();
      }
    }
  }

  public function getChildCount() {
    return $this->_childCount;
  }

}