<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitestorereservation
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Global.php 2014-03-24 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitestorereservation_Form_Admin_Global extends Engine_Form {

  protected $_directPayment;
  
  public function setDirectPayment($id) {
    $this->_directPayment = $id;
    return $this;
  }
  
  public function init() {

    $this->setTitle('Services')
         ->setDescription('Below, you can manage various services settings. These settings affect all members in your community.');

    $settings = Engine_Api::_()->getApi('settings', 'core');
    
    $this->addElement('Radio', 'sitestorereservation_store_as_service', array(
        'label' => 'Stores / Marketplace plugin as a services',
        'description' => 'Do you want to use "Stores / Marketplace plugin" as a services?',
        'multiOptions' => array(
            1 => 'Yes',
            0 => 'No'
        ),
        'value' => $settings->getSetting('sitestorereservation.store.as.service', 0),
    ));
      
    $this->addElement('Radio', 'sitestorereservation_productinventory', array(
        'label' => 'Virtual Product Inventory',
        'description' => 'Do you want to allow product inventory for virtual product?',
        'multiOptions' => array(
            1 => 'Yes',
            0 => 'No'
        ),
        'value' => $settings->getSetting('sitestorereservation.productinventory', 1),
    ));

    $this->addElement('Radio', 'sitestorereservation_dateselector', array(
        'label' => 'Virtual Product Options',
        'description' => 'Do you want to enable date selector option for virtual product?',
        'multiOptions' => array(
            1 => 'Yes',
            0 => 'No'
        ),
        'value' => $settings->getSetting('sitestorereservation.dateselector', 0),
    ));

    $this->addElement('MultiCheckbox', 'sitestorereservation_pricerange', array(
        'label' => 'Virtual Product Price Range',
        'description' => 'Choose the price range you want to show with virtual product price.',
        'multiOptions' => array(
            'fixed' => 'Fixed',
            'per_hour' => 'Per Hour',
            'per_day' => 'Per Day',
            'weekly' => 'Weekly',
            'monthly' => 'Monthly',
            'yearly' => 'Yearly',

        ),
        'value' => unserialize($settings->getSetting('sitestorereservation.pricerange', 'a:6:{i:0;s:5:"fixed";i:1;s:8:"per_hour";i:2;s:7:"per_day";i:3;s:6:"weekly";i:4;s:7:"monthly";i:5;s:6:"yearly";}')),
    ));
    
    $this->addElement('Radio', 'sitestorereservation_quantitybox', array(
        'label' => 'Quantity Box',
        'description' => 'Do you want to show quantity text box on virtual product profile page?',
        'multiOptions' => array(
            1 => 'Yes',
            0 => 'No'
        ),
        'value' => $settings->getSetting('sitestorereservation.quantitybox', 0),
    ));
    
    $this->addElement('Radio', 'sitestorereservation_loggedoutviewercheckout', array(
        'label' => 'Checkout for logged-out viewer',
        'description' => 'Do you want to allow logged-out viewer to checkout? (If set to yes, logged-out viewer will not be able to pay remaining amount in case of downpayment.)',
        'multiOptions' => array(
            1 => 'Yes',
            0 => 'No'
        ),
        'value' => $settings->getSetting('sitestorereservation.loggedoutviewercheckout', 1),
    ));
    
    $this->addElement('Radio', 'sitestorereservation_downpayment', array(
        'label' => 'Downpayment',
        'description' => 'Do you want to enable downpayment functionality?',
        'multiOptions' => array(
            1 => 'Yes',
            0 => 'No'
        ),
        'onclick' => 'downPaymentOptions(this.value)',
        'value' => $settings->getSetting('sitestorereservation.downpayment', 1),
    ));
//    $paymentGateway = array('2checkout' => '2Checkout', 'paypal' => 'Paypal', 'cheque' => 'By Cheque', 'cod' => 'Cash on Delivery');
//    if( empty($this->_directPayment) )
//      $paymentGateway = array('paypal' => 'Paypal', 'cheque' => 'By Cheque', 'cod' => 'Cash on Delivery');
//    else
      $paymentGateway = array('paypal' => 'Paypal', 'cheque' => 'By Cheque', 'cod' => 'Cash on Delivery');
    
    if( empty($this->_directPayment) ) {
      $this->addElement('Text', 'sitestorereservation_downpaymentvalue', array(
          'label' => 'Downpayment Value (%)',
          'description' => 'Enter the value of the downpayment. (Do not add any symbol. For 10% downpayment value, enter downpayment value as 10. You can only enter downpayment percentage between 1 and 100.)',
          'validators' => array(
                array('Float', true),
                array('Between', true, array('min' => 1, 'max' => 100, 'inclusive' => true)),
            ),
          'value' => $settings->getSetting('sitestorereservation.downpaymentvalue', 1),
      ));
    }
    
    //PAYMENT GATEWAY FOR DOWN PAYMENT
    $this->addElement('MultiCheckbox', 'sitestorereservation_defaultpaymentgateway', array(
        'label' => 'Payment Gateways for Downpayment',
        'description' => "Select the payment gateway to be available for downpayment.",
        'allowEmpty' => false,
        'required' => true,
        'multiOptions' => $paymentGateway,
        'value' => unserialize($settings->getSetting('sitestorereservation.defaultpaymentgateway', serialize(array('paypal', 'cheque', 'cod')))),
    ));
    
    //PAYMENT GATEWAY AFTER DOWN PAYMENT
    $this->addElement('MultiCheckbox', 'sitestorereservation_remainingpaymentgateway', array(
        'label' => 'Payment Gateways for Remaining Payment',
        'description' => "Select the payment gateway to be available for remaining payment after downpayment.",
        'allowEmpty' => false,
        'required' => true,
        'multiOptions' => $paymentGateway,
        'value' => unserialize($settings->getSetting('sitestorereservation.remainingpaymentgateway', serialize(array('paypal', 'cheque', 'cod')))),
    ));
    
    $this->addElement('Button', 'submit', array(
          'label' => 'Save Changes',
          'type' => 'submit',
          'ignore' => true,
          'order' => 500,
      ));
  }
}