<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitestorereservation
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: IndexController.php 2014-03-24 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitestorereservation_IndexController extends Core_Controller_Action_Standard
{
  public function indexAction()
  {

  }
  
  public function productBookingAction()
  {
    $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->product_id = $product_id = $this->_getParam('product_id', null);
    $this->view->sitestoreproduct = $sitestoreproduct = Engine_Api::_()->getItem('sitestoreproduct_product', $product_id);
    $this->view->sitestore = $sitestore = Engine_Api::_()->getItem('sitestore_store', $sitestoreproduct->store_id);
    
    //SELECTED TAB
    $this->view->TabActive = "productbooking";
    $this->view->prev_next = $this->_getParam('prev_next', 'prev');
    $this->view->isajax = $isajax = $this->_getParam('is_ajax', false);
    $date = $this->_getParam('date_current', null);
    if (empty($date)) {
        $date = time();
    }
    
    $this->view->date_current = $date = mktime(23, 59, 59, date("m", $date), 1, date("Y", $date));
    $this->view->date_next = $date_next = mktime(23,59, 59, date("m", $date) + 1, 1, date("Y", $date));
    $this->view->date_last = $date_last = mktime(23, 59, 59, date("m", $date) - 1, 1, date("Y", $date));
    $first_day_of_month = date("w", $date);
    $this->view->noOfDays = $days_in_month = date('t', $date);
    $this->view->first_day_of_month = $first_day_of_month;

    //GET THE LAST DAY OF THE MONTH
    $this->view->last_day_of_month = $last_day_of_month = ($first_day_of_month - 1) + $days_in_month;

    //GET THE TOTAL NUMBER OF CELLS TO BE DISPLAYED IN THE CALENDER TABLE
    $this->view->total_cells = $total_cells = 35;

    //GET CURRENT MONTH THAT HAS TO BE DISPLAYED
    $this->view->current_month = $current_month = date("m", $date);

    //GET THE TEXT OF THE CURRENT MONTH
    $this->view->current_month_text = $this->view->locale()->toDate($date, array('format' => 'MMMM'));

    //GET THE YEAR OF THE CURRENT MONTHS		
    $this->view->current_year =  date("Y", $date);

    $billingOrderProducts = Engine_Api::_()->getDbTable('orderProducts', 'sitestoreproduct')->getBillingOrderProducts($product_id);

    //RE-ARRANGE THE RESULTS ACCORDING TO MONTH DAYS.
    $monthEventResults_Temp = array();
    $oldTz = date_default_timezone_get();
    foreach ($billingOrderProducts as $item) {
      if( !empty($item->order_product_info) ) {
        $order_product_info = unserialize($item->order_product_info); 
        if( $order_product_info['calendarDate'] ) {
          $start = strtotime($order_product_info['calendarDate']['starttime']);
          $userSelectedDateMonth = date("m", $start);
          if( $userSelectedDateMonth == $current_month ) {
            date_default_timezone_set($viewer->timezone);
            $day = date("j", $start);
            date_default_timezone_set($oldTz);
            $monthEventResults_Temp [$day][] = $item;
          }
        }
      }
    }
    $this->view->billingOrderProducts = $monthEventResults_Temp;
  }
}
