<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitestories
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Genral.php 6590 2012-26-01 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitestories_Form_Admin_Manage_Global extends Engine_Form {

  public function init() {
    $this
            ->setTitle('Global Settings')
            ->setDescription('These settings are for Stories available in your community and will affect all members in your community.');

    $settings = Engine_Api::_()->getApi('settings', 'core');
    
    $this->addElement('Radio', 'sitestories_enable_stories', array(
       'label' => 'Enable Stories',
        'description' => 'Do you want to enable stories ?',
        'multiOptions' => array(
            1 => 'Yes',
            0 => 'No'
        ),
        'value' => $settings->getSetting('sitestories.enable.stories', 0),
    ));
    
    $this->addElement('Text', 'sitestories_max_allowed_days', array(
               'label' => 'Stories Expiry Time',
               'description' => 'You can decide number of days after which the Stories uploaded by App Users should automatically disappear.',
               
               'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestories_max_allowed_days', 1),
          
              'validators' => array(
                array('Int', true),
              ),
    ));
    
    $this->addElement('Text', 'sitestories_lsettings', array(
            'label' => 'Enter License key For USER Stories Plugin',
            'description' => "Please enter your license key that was provided to you when you purchased this plugin. If you do not know your license key, please contact the Support Team of SocialApps.tech from the Support section of your Account Area.(Key Format: XXXXXX-XXXXXX-XXXXXX )",
            'value' => $settings->getSetting('sitestories.lsettings'),
        ));
    // Add submit button
    $this->addElement('Button', 'submit', array(
               'label' => 'Save Changes',
               'type' => 'submit',
               'ignore' => true
           ));
  }
}

?>