<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

class Sitestories_Model_DbTable_Muteusers extends Engine_Db_Table {

    protected $_name = 'sitestories_muteusers';
    protected $_rowClass = 'Sitestories_Model_Muteuser';

    //Returns all User 
    public function getMuteUserStories($paginator = null) {
        $viewer = Engine_Api::_()->user()->getViewer();
        $storyTable = Engine_Api::_()->getDbtable('stories', 'sitestories');
        $sName = $storyTable->info('name');
        $mName = $this->info('name');
        $currentDate = date('Y-m-d H:i:s');
        $muteIds = $this->getMuteUserIds();
        $storyids = $this->getStoryids();
        $days = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestories_max_allowed_days', 1);
        $pastDate = date('Y-m-d H:i:s', strtotime('-' . $days . ' day', strtotime($currentDate)));
        $select = $storyTable->select()
                ->where('create_date >= ?', $pastDate)
                ->where("owner_id IN ($muteIds)")
                ->where('story_id IN(?)', $storyids)
                ->group("owner_id")
                ->order("create_date DESC");

        if (empty($paginator))
            return Zend_Paginator::factory($select);
        else {
            return $storyTable->fetchAll($select);
        }
    }

    //Return all user Ids
    public function getMuteUserIds() {
        $muteIds = 0;
        $viewer = Engine_Api::_()->user()->getViewer();
        $muteUserTableName = $this->info('name');
        $select = $this->select()
                ->from($muteUserTableName, array('muted_user_id'))
                ->where('user_id = ?', $viewer->getIdentity())
        ;

        $result = $this->fetchAll($select);
        foreach ($result as $row) {
            $muteIds = $muteIds . ',' . $row['muted_user_id'];
        }
        $str = $this->getTrimStr($muteIds);
        return $str;
    }

    public function getMuteUserCount() {
        $viewer = Engine_Api::_()->user()->getViewer();
        $muteUserTableName = $this->info('name');
        $select = $this->select()
                ->from($muteUserTableName, array('muted_user_id'))
                ->where('user_id = ?', $viewer->getIdentity());

        $result = $this->fetchAll($select);
        return count($result);
    }

    //Mute user
    public function muteUser($params) {
        $viewer = Engine_Api::_()->user()->getViewer();
        //check if user all ready muted...
        $select = $this->select()
                ->where('muted_user_id = ?', $params['muted_user_id'])
                 ->where('user_id = ?', $params['user_id']);

        $result = $this->fetchRow($select);
        if ($result)
            return false;
        $muteuser = $this->createRow();
        $muteuser->setFromArray($params);
        $muteuser->save();
        return $muteuser;
    }

    //Unmute user 
    public function unMuteUser($params = array()) {
        if (empty($params))
            return false;
        $muteUserTableName = $this->info('name');
        $viewer = Engine_Api::_()->user()->getViewer();
        $this->delete(array(
            'muted_user_id = ?' => $params['muted_user_id'],
            'user_id = ?' => $viewer->getIdentity()
        ));
    }

    public function isMuteStoryByUser($story = null) {
        $viewer = Engine_Api::_()->user()->getViewer();
        $select = $this->select()
                ->where('muted_user_id = ?', $story->owner_id)
                ->where('user_id=?', $viewer->getIdentity())
                ->limit(1);
        $result = $this->fetchRow($select);
        if (!empty($result))
            return 1;
        else
            return 0;
    }

    public function getStoryids($ids = array(), $subject = array()) {

        $muteIds = Engine_Api::_()->getDbtable('muteusers', 'sitestories')->getMuteUserIds();
        $currentDate = date('Y-m-d H:i:s');
        $days = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestories_max_allowed_days', 1);
        $pastDate = date('Y-m-d H:i:s', strtotime('-' . $days . ' day', strtotime($currentDate)));

        $table = Engine_Api::_()->getDbtable('stories', 'sitestories');
        $result = $table->select()
                        ->from($table->info('name'), array('story_id', 'owner_id'))
                        ->where("owner_id IN ($muteIds)")
                        ->where('create_date >= ?', $pastDate)
                        ->order("create_date DESC")
                        ->query()->fetchAll();
        $ownerids = array();
        $storyids = array();
        $storyids[] = 0;
        foreach ($result as $value) {
            if (!in_array($value['owner_id'], $ownerids)) {
                $storyids[] = $value['story_id'];
                $ownerids[] = $value['owner_id'];
            }
        }
        return $storyids;
    }

    public function getTrimStr($str) {
        $str = trim($str, ',');
        if (empty($str)) {
            return 0;
        } else {
            $str = trim($str, ",");
            return $str;
        }
    }

}

?>