<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Advancedactivity
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminSettingsController.php 6590 2012-26-01 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitestories_AdminReportController extends Core_Controller_Action_Admin {

    public function indexAction() {
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
        ->getNavigation('sitestories_admin_main', array(), 'sitestories_admin_main_report');
      
        $sortingColumnName = $this->_getParam('idSorting', 0);
        $page = $this->_getParam('page', 1); // Page id: Controll pagination.
        if ($this->getRequest()->isPost()) {
            $values = $this->getRequest()->getPost();
            if (!empty($values)) {
                foreach ($values as $key => $value) {
                    if ($key == 'delete_' . $value) {
                        Engine_Api::_()->getDbtable('reports', 'sitestories')->update(array('is_cancel' => 1), array('report_id =?' => $value));
                    }
                }
            }
        }
        $this->view->success_message = $successMessages = $this->_getParam('form_status'); // Status that success message would be show or not.
        $reportTable = Engine_Api::_()->getDbtable('reports','sitestories');
        $reportName = $reportTable->info('name');
        $userTable = Engine_Api::_()->getItemTable('user');
        $userName = $userTable->info('name');
        $storiesTable = Engine_Api::_()->getDbtable('stories','sitestories');
        $storiesName = $storiesTable->info('name');

        $reportSelect = $reportTable->select()
                ->setIntegrityCheck(false)
                ->from($userName, array('displayname'))
                ->join($reportName, "$userName.user_id = $reportName.user_id")
                ->join($storiesName,"$reportName.story_id = $storiesName.story_id")
                ->where($reportName . '.is_cancel =?', 0)
                ->where($storiesName . '.enable =?', 1);

        if (empty($sortingColumnName)) {
            $reportSelect->order($ad_cancel_name . '.report_id DESC');
            $this->view->id_orderby = 0;
        } else {
            $reportSelect->order($ad_cancel_name . '.report_id ASC');
            $this->view->id_orderby = 1;
        }
       
        $this->view->paginator = Zend_Paginator::factory($reportSelect);
        $this->view->paginator->setItemCountPerPage(10);
        $this->view->paginator->setCurrentPageNumber($page);
    
        
    }

    public function deletereportsAction() {
        $pagesetting_id = $this->_getParam('reportId');
        $this->view->pagesetting_id = $pagesetting_id;
        // Check post
        if ($this->getRequest()->isPost()) {
            Engine_Api::_()->getDbtable('reports', 'sitestories')->update(array('is_cancel' => 1), array('report_id =?' => $pagesetting_id));
            $this->_forward('success', 'utility', 'core', array(
                'smoothboxClose' => 10,
                'parentRefresh' => 10,
                'messages' => array($this->view->translate('Report deleted Successsfully.'))
            ));
        }
    }

    public function viewAction()
    {
        
        $story_id = $this->_getParam('story_id');
        $story = Engine_Api::_()->getItem('sitestories_story', $story_id);
        $this->view->story = $story;
    }

    public function deletestoryAction(){
        $story_id = $this->_getParam('story_id');
        $this->view->story_id = $story_id;
        // Check post
        if ($this->getRequest()->isPost()) {
            Engine_Api::_()->getDbtable('stories', 'sitestories')->update(array('enable' => 0), array('story_id =?' => $story_id));
            $this->_forward('success', 'utility', 'core', array(
                'smoothboxClose' => 10,
                'parentRefresh' => 10,
                'messages' => array($this->view->translate('Story deleted Successsfully.'))
            ));
        }
    }

}