<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitelogin
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 6590 2017-03-07 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitestories_Installer extends Engine_Package_Installer_Module
{ 
   public function onPreInstall()
      {  
          $this->onInstall();
        parent::onPreInstall();
      }

    public function onInstall()
    {   $this->_createStoriesTableQueries();
        $this->_moveAdvancedactivityStoryTable();
        $this->_moveAdvancedactivityViewerTable();
        $this->_moveAdvancedactivityMutestoryTable();
        $this->_moveAdvancedactivityMuteuserTable();
        parent::onInstall();
    }

    protected function _moveAdvancedactivityStoryTable()
    {
        $db = $this->getDb();
        $table_advancedactivitystories_exist = $db->query('SHOW TABLES LIKE "engine4_advancedactivity_stories"')->fetch();
        if(empty($table_advancedactivitystories_exist))  {
          return;
        }
        $currentDate = date('Y-m-d H:i:s');
        $days = 1;
        $pastDate = date('Y-m-d H:i:s', strtotime('-' . $days . ' day', strtotime($currentDate)));
        $stories = $db->query("SELECT * FROM  `engine4_advancedactivity_stories` WHERE  `create_date` > '". $pastDate ."'")->fetchAll();
      
        foreach($stories as $story) {
          $db->query("INSERT INTO `engine4_sitestories_stories` (`story_id`, `owner_id`, `owner_type`, `photo_id`, `file_id`, `code`, `rotation`, `duration`, `create_date`, `expiry_date`, `privacy`, `view_count`, `comment_count`, `mute_story`) VALUES (NULL, '". $story->owner_id ."','". $story->owner_type ."','". $story->photo_id ."','". $story->file_id ."','". $story->code ."','". $story->rotation ."','". $story->duration ."','". $story->create_date ."','". $story->expiry_date ."','". $story->privacy ."','". $story->view_count ."','". $story->comment_count ."','". $story->mute_story ."')");
        }
        $db->query("DROP TABLE `engine4_advancedactivity_stories`");
    }

    protected function _moveAdvancedactivityViewerTable()
    {
        $db = $this->getDb();
        $table_advancedactivitystories_exist = $db->query('SHOW TABLES LIKE "engine4_advancedactivity_storyviewer"')->fetch();
        if(empty($table_advancedactivitystories_exist))  {
          return;
        }
        $viewers = $db->query("SELECT * FROM  `engine4_advancedactivity_storyviewer`")->fetchAll();

        foreach($viewers as $viewer)  {
          $db->query("INSERT INTO `engine4_sitestories_storyviewer` (`viewer_id`, `subject_id`, `subject_type`, `object_id`, `object_type`) VALUES (NULL, '". $viewer->subject_id ."','". $viewer->subject_type ."','". $viewer->object_id ."','". $viewer->object_type ."')");
        }
        $db->query("DROP TABLE `engine4_advancedactivity_storyviewer`");
    }

    protected function _moveAdvancedactivityMutestoryTable()
    {
        $db = $this->getDb();
        $table_page_exist = $db->query('SHOW TABLES LIKE "engine4_advancedactivity_mutestories"')->fetch();
        if(!empty($table_page_exist))
        {
          $db->query("DROP TABLE `engine4_advancedactivity_mutestories`");
        }
    }

    protected function _moveAdvancedactivityMuteuserTable()
    {
        $db = $this->getDb();
        $table_advancedactivitystories_exist = $db->query('SHOW TABLES LIKE "engine4_advancedactivity_muteusers"')->fetch();
        if(empty($table_advancedactivitystories_exist))  {
          return;
        }
        $muteusers = $db->query("SELECT * FROM  `engine4_advancedactivity_muteusers`")->fetchAll();
        foreach($muteusers as $muteuser)  {
          $db->query("INSERT INTO `engine4_sitestories_muteusers` (`muteuser_id`, `user_id`, `muted_user_id`) VALUES (NULL,'". $muteuser->user_id ."','". $muteuser->muted_user_id . "')");
        }
        $db->query("DROP TABLE `engine4_advancedactivity_muteusers`");
    }

    protected function _createStoriesTableQueries()  {
        $db = $this->getDb();
        $db->query("
            CREATE TABLE IF NOT EXISTS `engine4_sitestories_stories` (
              `story_id` int(11) NOT NULL AUTO_INCREMENT PRIMARY KEY,
              `owner_id` int(11) NOT NULL,
              `owner_type` varchar(24) NOT NULL,
              `photo_id` int(11) NOT NULL,
              `file_id` int(11) NOT NULL,
              `code` varchar(255) NOT NULL,
              `rotation` varchar(255) NOT NULL,
              `duration` int(11) NOT NULL,
              `create_date` datetime NOT NULL,
              `expiry_date` datetime NOT NULL,
              `privacy` varchar(24) NOT NULL,
              `description` blob DEFAULT NULL,
              `view_count` int(11) NOT NULL,
              `comment_count` int(11) NOT NULL,
              `mute_story` int(11) NOT NULL,
              `enable` int(11) NOT NULL DEFAULT '1'
  
        ) ;");

        $db->query("
            CREATE TABLE IF NOT EXISTS `engine4_sitestories_muteusers` (
                        `muteuser_id` int(11) NOT NULL AUTO_INCREMENT,
                         `user_id` int(11) UNSIGNED NOT NULL,
                         `muted_user_id` int(11) UNSIGNED NOT NULL,
                         PRIMARY KEY (`muteuser_id`)
            ) ENGINE=InnoDB DEFAULT CHARSET=latin1;");

        $db->query("
            CREATE TABLE IF NOT EXISTS `engine4_sitestories_storyviewer` (
            `viewer_id` int(11) NOT NULL AUTO_INCREMENT,
            `subject_id` int(11) NOT NULL,
            `subject_type` varchar(24) NOT NULL,
            `object_id` int(11) NOT NULL,
            `object_type` varchar(24) NOT NULL,
              PRIMARY KEY (`viewer_id`)
            ) ENGINE=InnoDB DEFAULT CHARSET=latin1;");

        $db->query("
            CREATE TABLE IF NOT EXISTS `engine4_sitestories_mutestories` (
            `mutestory_id` int(11) NOT NULL AUTO_INCREMENT,
            `story_id` int(11) NOT NULL,
            `user_id` int(11) NOT NULL,
            `create_date` datetime NOT NULL,
              PRIMARY KEY (`mutestory_id`)
        ) ENGINE=InnoDB DEFAULT CHARSET=latin1;");

        $db->query("
            CREATE TABLE IF NOT EXISTS `engine4_sitestories_banners` (
            `banner_id` int(11) NOT NULL AUTO_INCREMENT PRIMARY KEY,
            `startdate` date NOT NULL,
            `enddate` date NOT NULL,
            `file_id` int(11) NOT NULL,
            `enabled` tinyint(4) NOT NULL,
            `color` varchar(30) DEFAULT NULL,
            `background_color` varchar(30) DEFAULT NULL,
            `gradient` varchar(200) DEFAULT NULL,
            `order` tinyint(4) NOT NULL,
            `highlighted` tinyint(4) NOT NULL
          ) ENGINE=InnoDB  DEFAULT CHARSET=latin1;");

        $db->query("
            CREATE TABLE IF NOT EXISTS `engine4_sitestories_userprivacy` (
            `userprivacy_id` int(11) NOT NULL AUTO_INCREMENT PRIMARY KEY,
            `user_id` int(11) NOT NULL,
            `privacy_status` varchar(30) NOT NULL,
            `params` text NOT NULL
          )ENGINE=InnoDB  DEFAULT CHARSET=latin1;");

        $db->query("
            CREATE TABLE IF NOT EXISTS `engine4_sitestories_reports` (
            `report_id` int(11) NOT NULL AUTO_INCREMENT PRIMARY KEY,
            `user_id` int(11) NOT NULL,
            `report_type` varchar(30) NOT NULL,
            `report_description` text NOT NULL,
            `story_id` int NOT NULL,
            `is_cancel` int NOT NULL,
            `creation_date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP
          )ENGINE=InnoDB  DEFAULT CHARSET=latin1;");

        $db->query("
            CREATE TABLE IF NOT EXISTS `engine4_sitestories_replies` (
            `replies_id` int(11) NOT NULL AUTO_INCREMENT PRIMARY KEY,
            `story_id` int(11) NOT NULL,
            `conversation_id` int(11) NOT NULL,
            `created_date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP
          ) ENGINE=InnoDB DEFAULT CHARSET=latin1;");

        $db = $this->getDb();
        $select = new Zend_Db_Select($db);
        $check_sitestories = $select
                ->from('engine4_core_modules', 'version')
                ->where('name = ?', 'sitestories')
                ->where('enabled = ?', 1)
                ->query()
                ->fetchcolumn();
        $check_sitestories = $select->query()->fetchObject();
        if (!empty($this->checkVersion($check_sitestories, '5.3.1'))) {
            //ADD NEW COLUMN IN engine4_sitepage_imports TABLE
            $table_exist = $db->query("SHOW TABLES LIKE 'engine4_sitestories_stories'")->fetch();
            if (!empty($table_exist)) {

                $column_exist = $db->query("SHOW COLUMNS FROM engine4_sitestories_stories LIKE 'type'")->fetch();
                if (empty($column_exist)) {
                    $db->query("ALTER TABLE `engine4_sitestories_stories` ADD `type` VARCHAR(20) NOT NULL AFTER `owner_type`");
                }

                $params_column_exist = $db->query("SHOW COLUMNS FROM engine4_sitestories_stories LIKE 'params'")->fetch();
                if (empty($column_exist)) {
                    $db->query("ALTER TABLE `engine4_sitestories_stories` ADD `params` TEXT NOT NULL AFTER `file_id`");
                }
            }
        }

        $db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `order`) VALUES
          ("core_admin_main_plugins_stories", "sitestories", "SEAO - User Stories", "", \'{"route":"admin_default","module":"sitestories","controller":"settings"}\', "core_admin_main_plugins", "", 999);');
        $db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `order`) VALUES
          ("sitestories_admin_main_manage", "sitestories", "Manage Stories", "", \'{"route":"admin_default","module":"sitestories","controller":"manage"}\', "sitestories_admin_main", "", 1);');
        $db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `order`) VALUES ("sitestories_admin_main_report", "sitestories", "Abuse Reports", "", \'{"route":"admin_default","module":"sitestories","controller":"report"}\', "sitestories_admin_main", "", 2);');

        $db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `order`) VALUES
          ("sitestories_admin_main_settings", "sitestories", "Global Settings", "", \'{"route":"admin_default","module":"sitestories","controller":"settings"}\', "sitestories_admin_main", "", 0);');
    }

    public function onPostInstall() {
        $view = new Zend_View();
        $baseUrl = (!empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
        $redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
        $redirector->gotoUrl($baseUrl . 'admin/sitestories/settings/upgrade-settings/redirect/install');
        // parent::onPostInstall();
    }

    private function checkVersion($databaseVersion, $checkDependancyVersion)
    {
      $f = $databaseVersion;
      $s = $checkDependancyVersion;
      if( strcasecmp($f, $s) == 0 )
        return -1;

      $fArr = explode(".", $f);
      $sArr = explode('.', $s);
      if( count($fArr) <= count($sArr) )
        $count = count($fArr);
      else
        $count = count($sArr);

      for( $i = 0; $i < $count; $i++ ) {
        $fValue = $fArr[$i];
        $sValue = $sArr[$i];
        if( is_numeric($fValue) && is_numeric($sValue) ) {
          if( $fValue > $sValue )
            return 1;
          elseif( $fValue < $sValue )
            return 0;
          else {
            if( ($i + 1) == $count ) {
              return -1;
            } else
              continue;
          }
        }
        elseif( is_string($fValue) && is_numeric($sValue) ) {
          $fsArr = explode("p", $fValue);

          if( $fsArr[0] > $sValue )
            return 1;
          elseif( $fsArr[0] < $sValue )
            return 0;
          else {
            return 1;
          }
        } elseif( is_numeric($fValue) && is_string($sValue) ) {
          $ssArr = explode("p", $sValue);

          if( $fValue > $ssArr[0] )
            return 1;
          elseif( $fValue < $ssArr[0] )
            return 0;
          else {
            return 0;
          }
        } elseif( is_string($fValue) && is_string($sValue) ) {
          $fsArr = explode("p", $fValue);
          $ssArr = explode("p", $sValue);
          if( $fsArr[0] > $ssArr[0] )
            return 1;
          elseif( $fsArr[0] < $ssArr[0] )
            return 0;
          else {
            if( $fsArr[1] > $ssArr[1] )
              return 1;
            elseif( $fsArr[1] < $ssArr[1] )
              return 0;
            else {
              return -1;
            }
          }
        }
      }
    }
  }