<?php 
class Sitestoriesweb_Api_Core extends Core_Api_Abstract {

    public function getUserStoryArray($user_id) {
        $table = Engine_Api::_()->getDbtable('stories', 'sitestoriesweb');
        $results = $table->getUserStory($user_id);
        $browseStory = array();
        foreach ($results as $story) {
            $browseStory = $story->toArray();
            $browseStory["total_stories"] = Engine_Api::_()->getDbtable('stories', 'sitestoriesweb')->getTotalStoryCount($story->owner_id);
            $browseStory["owner_title"] = $story->getOwner()->getTitle();
            $response[] = $browseStory;
        }
        return $response;
    }

    // function  Convert base 64 file into temparory file. 
	public function base64ToTempFile($base64){
		//GET VIEWER
	    $viewer = Engine_Api::_()->user()->getViewer();
	    $viewer_id = $viewer->getIdentity();
		if(empty($base64)){
			return;
		}
        $path = APPLICATION_PATH . DIRECTORY_SEPARATOR . 'temporary';
    	$image_array_1 = explode(";", $base64);
	    $image_array_2 = explode(",", $image_array_1[1]);
	    $data = base64_decode($image_array_2[1]);
	    $imageName = $viewer_id . '_' . time() . '.png';
	    $tempImage = $path . DIRECTORY_SEPARATOR . $imageName;
	    file_put_contents($tempImage, $data);
	    return $tempImage;
	}

    // function  Convert  file into temparory file. 
    public function filetoTempFile($file){
        $path = APPLICATION_PATH . DIRECTORY_SEPARATOR . 'temporary';
        $fileName = $file['name'];
        $tempFile = $path . DIRECTORY_SEPARATOR . $fileName;
        move_uploaded_file($file['tmp_name'], $tempFile);  
        return $tempFile;   
    }

	public function setPhoto($photo, $values, $setRow = true) {
        if ($photo instanceof Zend_Form_Element_File) {
            $file = $photo->getFileName();
        } else if (is_array($photo) && !empty($photo['tmp_name'])) {
            $file = $photo['tmp_name'];
        } else if (is_string($photo) && file_exists($photo)) {
            $file = $photo;
        } else {
            throw new Banner_Model_Exception('invalid argument passed to setPhoto');
        }
        $imageName = basename($file);
        $path = APPLICATION_PATH . DIRECTORY_SEPARATOR . 'temporary';

        $params = array(
            'parent_type' => $values->getType(),
            'parent_id' => $values->getIdentity(),
        );

        // Save
        $storage = Engine_Api::_()->storage();

        // Resize image (main)
        $image = Engine_Image::factory();
        $image->open($file)
        ->resize(720, 750)
        ->write($path . '/m_' . $imageName)
        ->destroy();

        // Resize image (icon)
        $image = Engine_Image::factory();
        $image->open($file);

        $size = min($image->height, $image->width);
        $x = ($image->width - $size) / 2;
        $y = ($image->height - $size) / 2;

        $image->resample($x, $y, $size, $size, 48, 48)
        ->write($path . '/is_' . $imageName)
        ->destroy();

        // Store
        $iMain = $storage->create($path . '/m_' . $imageName, $params);
        $iSquare = $storage->create($path . '/is_' . $imageName, $params);

        $iMain->bridge($iSquare, 'thumb.icon');

        // Remove temp files
        @unlink($path . '/m_' . $imageName);
        @unlink($path . '/is_' . $imageName);

        // Update row
        if (!empty($setRow)) {
            $values->photo_id = $iMain->getIdentity();
            $values->save();
        }

        return $values;
    }

    // Notifications are only sent when the user has a privacy friends or custom
    public function notifyUsers($user , $story){
        if(!$story instanceof Sitestoriesweb_Model_Story || !$user instanceof User_Model_User ) 
            return;
        $privacy = Engine_Api::_()->getDbtable('userprivacies','sitestoriesweb')->getUserPrivacy($user->getIdentity());
        switch ($privacy->privacy_status) {
            case 'everyone':
                return;
                break;
            case 'friends':
                $select = $user->membership()->getMembersOfSelect();
                $friends = $paginator = Zend_Paginator::factory($select);
                $ids = array();
                foreach( $friends as $friend ) {
                  $ids[] = $friend->resource_id;
                }
                $membersIdsChunk = array_chunk($ids, 2000);
                foreach ($membersIdsChunk as  $members) {
                    Engine_Api::_()->getDbtable('jobs', 'core')->addJob('sitestoriesweb_user_notifications', array('members' => $members, 'story_id' => $story->story_id, 'viewer_id' => $user->getIdentity()));
                }
                break;
            
            case 'custom':
                if(empty($privacy->params))
                    return;
                $ids = explode(',', $privacy->params);
                $membersIdsChunk = array_chunk($ids, 2000);
                foreach ($membersIdsChunk as  $members) {
                    Engine_Api::_()->getDbtable('jobs', 'core')->addJob('sitestoriesweb_user_notifications', array('members' => $members, 'story_id' => $story->story_id, 'viewer_id' => $user->getIdentity()));
                }
                break;
            default:
                return;
                break;
        }
    }

    public function truncation($string, $length = null) {
        if (empty($length)) {
          $length = 16;
        }
        $string = strip_tags($string);
        return Engine_String::strlen($string) > $length ? Engine_String::substr($string, 0, ($length - 3)) . '...' : $string;
    }

    public function getUserList($user){
        $select = $user->membership()->getMembersOfSelect();
        $friends = $paginator = Zend_Paginator::factory($select);
        $ids = array();
        foreach( $friends as $friend ) {
          $ids[] = $friend->resource_id;
        }
        
        $table = Engine_Api::_()->getDbtable('stories','sitestoriesweb');
        $customFields = 1;
        $stories = $table->storiesForUser($user,$customFields); 
        if(empty($stories))
            return;
        $storiesArr = $stories->toArray();
        foreach ($storiesArr as $k => $story) {
            //Manage stories according to privacy.
            if($story['privacy'] == 'custom'){
                $userPrivacy = Engine_Api::_()->getDbtable('userprivacies','sitestoriesweb')->getUserPrivacy($story['owner_id']);
                if(!in_array($user->getIdentity(), explode(',', $userPrivacy->params))){
                    unset($storiesArr[$k]);
                    continue;
                }
            }elseif($story['privacy'] == 'friends' && !in_array($story['owner_id'], $ids)){
                unset($storiesArr[$k]);
                continue;
            }

            $storyCounter = $this->getViewerCount($story['owner_id'],$user->getIdentity());
            $storiesArr[$k]['story_count']= $storyCounter['totalStoriesCount'];
            $storiesArr[$k]['unviewed_count'] = $storyCounter['unviewedCount'];
            
            $date = new DateTime(date('Y-m-d H:i:s'), new DateTimeZone('UTC'));
            $currentDate = $date->format('Y-m-d H:i:s');
            $t1 = strtotime($currentDate);
            $t2 = strtotime($story['maxCreateDate']);
            $diff = $t1 - $t2;
            $hours = $diff / ( 60 * 60 );
            $mins = $diff / 60;
            $storiesArr[$k]['hours'] = (int) $hours;
            $storiesArr[$k]['mins'] = (int) $mins;
            $storiesArr[$k]['create_date'] = $story['maxCreateDate'];
        }
        return $storiesArr;
    }

    public function getWidgetStories($user){

        $select = $user->membership()->getMembersOfSelect();
        $friends = $paginator = Zend_Paginator::factory($select);
        $ids = array();
        foreach( $friends as $friend ) {
          $ids[] = $friend->resource_id;
        }
        $table = Engine_Api::_()->getDbtable('stories','sitestoriesweb');
        $customFields = 0;
        $stories = $table->storiesForUser($user,$customFields);  
        if(empty($stories))
            return;
        $storiesArr = array();
        $storiesArr['stories'] = $stories->toArray();
        
        foreach ($storiesArr['stories'] as $k => $story) {
            //Manage stories who's privacy is custom.
            if($story['privacy'] == 'custom'){
                 $userPrivacy= Engine_Api::_()->getDbtable('userprivacies','sitestoriesweb')->getUserPrivacy($story['owner_id']);
                if(!in_array($user->getIdentity(), explode(',', $userPrivacy->params))){
                    unset($storiesArr['stories'][$k]);
                    continue;
                }
            }elseif($story['privacy'] == 'friends' && !in_array($story['owner_id'], $ids)){
                unset($storiesArr['stories'][$k]);
                continue;
            }
        }
        $viewerresults = $table->getyourStory($user->getIdentity(),0,1);
        if(!empty($viewerresults))
            $storiesArr['my_story'] = $viewerresults->toArray();
        return $storiesArr;
    }

    public function getUserStoryCount($user_id){
        $days = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestories_max_allowed_days', 1);
        $table = Engine_Api::_()->getDbtable('stories','sitestoriesweb');
        return $table->select()
        ->from($table->info('name'), new Zend_Db_Expr('COUNT(*)'))
        ->where('owner_id = ?',$user_id)
        ->where('create_date >= now() - INTERVAL '.$days.' DAY')
        ->where('expiry_date >= now()')
        ->query()->fetchColumn(0);         
    }

    // function retunrs total stories of $storyUserID and  count of stories which are not viewed by viewer. 
    public function getViewerCount($storyUserId,$viewerUserId){
        $response = array('totalStoriesCount' => 0,'unviewedCount' => 0);
        $totalStories = Engine_Api::_()->getDbTable('stories','sitestoriesweb')->getUserStoryList($storyUserId);
        if(empty($totalStories)){
            return $response;
        }
        $response['totalStoriesCount'] = count($totalStories);
        $unviewedCounter = count($totalStories);
        $viewerTable = Engine_Api::_()->getDbtable('viewers','sitestoriesweb');
        foreach ($totalStories as  $story) {
            $viewerSelect = $viewerTable->select()->from($viewerTable->info('name'),'viewer_id')->where('subject_id = ?',$viewerUserId)->where('object_id = ?',$story->story_id)->limit(1);
            if($viewerTable->fetchRow($viewerSelect))
                $unviewedCounter--;
        }
        $response['unviewedCount'] = $unviewedCounter;
        return $response;
    }

    public function createAlbumObject($story_img,$privacy = 'everyone'){
        if($privacy != 'everyone')
            $privacy = 'owner_member';
        
        // Get album
        $viewer = Engine_Api::_()->user()->getViewer();
        $table = Engine_Api::_()->getDbtable('albums', 'album');
        $db = $table->getAdapter();
        $db->beginTransaction();

        try {
            $type = 'wall';
            
            $album = $table->getSpecialAlbum($viewer, $type);
            $photoTable = Engine_Api::_()->getDbtable('photos', 'album');
            $photo = $photoTable->createRow();
            $photo->setFromArray([
                'owner_type' => 'user',
                'owner_id' => Engine_Api::_()->user()->getViewer()->getIdentity()
            ]);
            $photo->save();
            $photo->setPhoto($story_img);
            $photo->order = $photo->photo_id;
            $photo->album_id = $album->album_id;
            $photo->save();
            if (!$album->photo_id) {
                $album->photo_id = $photo->getIdentity();
                $album->save();
            }
            // Authorizations
            $auth = Engine_Api::_()->authorization()->context;
            $auth->setAllowed($photo, $privacy, 'view', true);
            $auth->setAllowed($photo, $privacy, 'comment', true);
            
            $db->commit();
            return $photo;
            
        } catch (Exception $e) {
            throw $e;
        }
    }

    public function createVideoObject($file,$sitevideo,$privacy = 'everyone'){

        if($privacy != 'everyone')
            $privacy = 'owner_member';
        
        $viewer = Engine_Api::_()->user()->getViewer();
        $values['owner_id'] = $viewer->getIdentity();
        
        $parent_type = 'user';
        $parent_id = $viewer->getIdentity();
        $params = array(
            'owner_type' => $parent_type,
            'owner_id' => $parent_id
        );
        if($sitevideo){
            $tempFile = $this->filetoTempFile($file['filedata']);
            $video = Engine_Api::_()->sitevideo()->createVideo($params, $tempFile, $values);
        }else{
            $video = Engine_Api::_()->video()->createVideo($params, $file['filedata']['name'], $values);
        }

        // echo "<pre>"; print_r($file); die;
        $values['auth_view'] = $privacy;
        $values['view_privacy'] = $values['auth_view'];
        $values['parent_type'] = $parent_type;
        $values['parent_id'] =  $parent_id;
        // sets up title and owner_id now just incase members switch page as soon as upload is completed
        $video->title = $file['filedata']['name'];
        $video->description = $file['filedata']['name'];
        $video->owner_id = $viewer->getIdentity();
        $video->setFromArray($values);
        $video->save();

        $auth = Engine_Api::_()->authorization()->context;
        $roles = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');
        $authView = $values['auth_view'];
        $viewMax = array_search($authView, $roles);
        foreach ($roles as $i => $role) {
            $auth->setAllowed($video, $role, 'view', ($i <= $viewMax));
        }
        $authComment = $privacy;
        $commentMax = array_search($authComment, $roles);
        foreach ($roles as $i=>$role) {
            $auth->setAllowed($video, $role, 'comment', ($i <= $commentMax));
        }
        $video->save();
    }

    function file_upload_max_size() {
        static $max_size = -1;

        if ($max_size < 0) {
            $post_max_size = $this->parse_size(ini_get('post_max_size'));
            if ($post_max_size > 0) {
                $max_size = $post_max_size;
            }
            // zero, which indicates no limit.
            $upload_max = $this->parse_size(ini_get('upload_max_filesize'));
            if ($upload_max > 0 && $upload_max < $max_size) {
                $max_size = $upload_max;
            }
        }
      return $max_size;
    }

    function parse_size($size) {
        $unit = preg_replace('/[^bkmgtpezy]/i', '', $size);
        $size = preg_replace('/[^0-9\.]/', '', $size);
        if ($unit) {
            return round($size * pow(1024, stripos('bkmgtpezy', $unit[0])));
        }
        else {
            return round($size);
        }
    }
}
?>