<?php

class Sitestoriesweb_Form_Admin_Manage_Global extends Engine_Form {

  public function init() {
    $this
    ->setTitle('Global Settings')
    ->setDescription('These settings are for Stories available in your community and will affect all members in your community.');

    $settings = Engine_Api::_()->getApi('settings', 'core');
    
    $this->addElement('Radio', 'sitestories_enable_stories', array(
       'label' => 'Enable Stories',
        'description' => 'Do you want to enable stories ? This setting will sync with User Stories Plugin for Apps as well, if it is installed on your website.',
        'multiOptions' => array(
          1 => 'Yes',
          0 => 'No'
        ),
        'value' => $settings->getSetting('sitestories.enable.stories', 1),
    ));
    
    $this->addElement('Text', 'sitestories_max_allowed_days', array(
      'label' => 'Stories Expiry Time',
      'description' => 'You can decide the number of days after which the stories uploaded by users should automatically disappear.',
      'value' => $settings->getSetting('sitestories.max.allowed.days', 1),
      'validators' => array(
        array('Int', true),
      ),
    ));

    $this->addElement('Radio', 'sitestories_story_layout', array(
       'label' => 'Stories Layout',
        'description' => 'Please select the layout for stories.This setting is applicable on web only.',
        'multiOptions' => array(
          0 => 'Rectangular Layout (Facebook Look)',
          1 => 'Circular Layout (Instagram Look)',
        ),
        'value' => $settings->getSetting('sitestories.story.layout', 0),
    ));

    $this->addElement('Text', 'sitestories_story_count', array(
      'label' => "Story Count",
      'allowEmpty' => false,
      'required' => true,
      'description' => "Please enter no. of story you want to be visible with Browse Stories Widget.",
      'filters' => array(
        new Engine_Filter_Censor()
      ),
      'validators' => array(
              array('Int', true),
              new Engine_Validate_AtLeast(1),
      ),
      'value' => $settings->getSetting('sitestories.story.count', 4),
    ));
    
    // Add submit button
    $this->addElement('Button', 'submit', array(
      'label' => 'Save Changes',
      'type' => 'submit',
      'ignore' => true
    ));
  }
}

?>