<?php


class Sitestoriesweb_Model_DbTable_Notifications extends Activity_Model_DbTable_Notifications {

    protected $_name = 'activity_notifications';

    public function addNotification(User_Model_User $user, Core_Model_Item_Abstract $subject,
          Core_Model_Item_Abstract $object, $type, array $params = null)
    {
      // Donot send notification if user is blocked
      if ($subject instanceof User_Model_User && ($user->isBlocked($subject) || $subject->isBlocked($user))) {
          return;
      }
      // We may want to check later if a request exists of the same type already
      $row = $this->createRow();
      $row->user_id = $user->getIdentity();
      $row->subject_type = $subject->getType();
      $row->subject_id = $subject->getIdentity();
      $row->object_type = $object->getType();
      $row->object_id = $object->getIdentity();
      $row->type = $type;
      $row->params = $params;
      $row->date = date('Y-m-d H:i:s');
      $row->save();

      return $row;

    }
}

?>