<?php

class Sitestoriesweb_Plugin_Core extends Zend_Controller_Plugin_Abstract
{
	//Delete all story
    public function onUserDeleteAfter($event)
    {
        $payload = $event->getPayload();
        $user_id = $payload['identity'];
        if(empty($user_id))
            return;
        if(!Engine_Api::_()->hasModuleBootstrap('sitestories') && !Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled("sitestories")){
            $storyTable = Engine_Api::_()->getDbtable('stories', 'sitestoriesweb');
            $storyTable->delete(array(
                'owner_id = ?' => $user_id,
            ));
        }
        //Delete Deleted User Replies
        $this->deleteUserReply($user_id);

        //Remove Deleted user from viewer.
        $this->updateViewer($user_id);
        
        //Remove report of deleted User.
        Engine_Api::_()->getDbtable('reports', 'sitestoriesweb')->delete(array('user_id = ?' => $user_id));

        //Remove Privacy of deleted User
        Engine_Api::_()->getDbtable('userprivacies', 'sitestoriesweb')->delete(array('user_id = ?' => $user_id));

        //Remove Muted Users of deleted User
        Engine_Api::_()->getDbtable('muteusers', 'sitestoriesweb')->delete(array('user_id = ?' => $user_id));

        //Remove Deleted user from mute list.
    }

    private function updateViewer($user_id){
        $viewerTable = Engine_Api::_()->getDbtable('viewers', 'sitestoriesweb');
        $select = $viewerTable->select()->where('subject_id = ?', $user_id);
        $viewers = $viewerTable->fetchAll($select);
        foreach ($viewers as  $storyViewer) {
            $story = Engine_Api::_()->getItem('sitestoriesweb_story',$storyViewer->object_id);
            if(!empty($story)){
                $story->view_count -= 1;
                $story->save();
            }
            $storyViewer->delete();
        }
    }

    private function deleteUserReply($user_id){
        $conTable = Engine_Api::_()->getItemTable('messages_conversation');
        $conTableName = $conTable->info('name');
        $rTable = Engine_Api::_()->getDbtable('replies', 'sitestoriesweb');
        $rTableName = $rTable->info('name');
        $select = $rTable->select()
            ->from($rTableName)
            ->join($conTableName, $conTableName . '.conversation_id = ' . $rTableName . '.conversation_id', null)
            ->where('user_id = ?', $user_id);

        $allReplies = $rTable->fetchAll($select);
        foreach ($allReplies as $reply) {
            $reply->delete();
        }
    }

    public function onItemDeleteBefore($event){
        $item = $event->getPayload();
        if ($item instanceof Sitestoriesweb_Model_Story) {
            //delete viewers.
            Engine_Api::_()->getDbtable('viewers', 'sitestoriesweb')->delete(array('object_id = ?' => $item->getIdentity()));
            //delete reports.
            Engine_Api::_()->getDbtable('reports', 'sitestoriesweb')->delete(array('story_id = ?' => $item->getIdentity()));
            //delete replies
            $this->deleteReplies($item->getIdentity());
            
            
        }
    }

    private function deleteReplies($story_id){
        $rTable = Engine_Api::_()->getDbtable('replies', 'sitestoriesweb');
        $repliesSelect = $rTable->select()->where('story_id = ?',$story_id);
        $allReplies = $rTable->fetchAll($repliesSelect);
        foreach ($allReplies as $reply) {
            $this->deleteConvo($reply->conversation_id);
            $reply->delete();
        }
        //delete reply
        // $rTable->delete(array('story_id = ?' => $item->getIdentity()));
    }

    private function deleteConvo($message_id){
        $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
        $db = Engine_Api::_()->getDbtable('messages', 'messages')->getAdapter();
        $db->beginTransaction();
        try {
          $recipients = Engine_Api::_()->getItem('messages_conversation', $message_id)->getRecipientsInfo();
          foreach ($recipients as $r) {
            if ($viewer_id == $r->user_id) {
                $r->inbox_deleted = true;
                $r->outbox_deleted = true;
                $r->save();
            }
          }
          $db->commit();
        } catch (Exception $e) {
          $db->rollback();
        }
    }
}
?>