<?php


class Sitestoriesweb_Plugin_Job_UserNotifications extends Core_Plugin_Job_Abstract {

    protected function _execute() {
        // Get job and params
        $job = $this->getJob();
        set_time_limit(0);
         // Process

        if (!($members = $this->getParam('members'))) {
            $this->_setState('failed', 'No members provided.');
            $this->_setWasIdle();
            return;
        }

        try {
            $subject = Engine_Api::_()->getItem('sitestoriesweb_story', $this->getParam('story_id'));
            $owner = $subject->getOwner();
            $viewer = Engine_Api::_()->getItem('user', $this->getParam('viewer_id'));
            $notificationsTable = Engine_Api::_()->getDbtable('notifications', 'sitestoriesweb');
            $url =  Zend_Registry::get('Zend_View')->url(array('owner_id' => $viewer->getIdentity()), 'stories_view', true);
            $link = '<a href="'.$url.'"> new Story</a>';
            foreach (($members) as $member) {
                $user_subject = Engine_Api::_()->getItem('user', $member);
                $notify_subject = $subject;
                $notificationsTable->addNotification($user_subject, $owner, $subject, "sitestoriesweb_notificationpost",array('link' => $link));
            }
            $this->_setIsComplete(true);
        } catch (Exception $e) {
            $this->_setState('failed', 'Exception: ' . $e->getMessage());
        }
    }
}
?>