<?php

class Sitestoriesweb_IndexController extends Core_Controller_Action_Standard
{
    public function getUserStoriesAction()
    {
        $user_id = $this->_getParam('id');
        $next_user = $this->_getParam('next_user',0);
        $user = Engine_Api::_()->getItem('user',$user_id);
        $this->view->user = $user;

        $this->view->next_user = $next_user;
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();
        $this->view->viewer = $viewer;
        //check user privacy

        if(!empty($user_id)){
            //check user privacy
            $this->view->canView = $canView= Engine_Api::_()->getDbtable('userprivacies','sitestoriesweb')->checkUserViewPrivacy($user,$viewer);
            $this->view->totalStories = Engine_Api::_()->getDbtable('stories', 'sitestoriesweb')->getTotalStoryCount($user_id);
            $this->view->userStory = $userStory = Engine_Api::_()->sitestoriesweb()->getUserStoryArray($user_id);
            $permissionsTable = Engine_Api::_()->getDbtable('permissions', 'authorization');
            $messgeAuth = $permissionsTable->getAllowed('messages', Engine_Api::_()->user()->getViewer()->level_id, 'auth');
            $isAllowMessaging = 0;
            switch ($messgeAuth) {
                case 'everyone':
                    $isAllowMessaging = 1;
                    break;
                case 'friends':
                    $select = $user->membership()->getMembersOfSelect();
                    $friends = $paginator = Zend_Paginator::factory($select);
                    $ids = array();
                    foreach( $friends as $friend ) {
                      $ids[] = $friend->resource_id;
                    }
                    if(in_array($viewer->getIdentity(), $ids)){
                        $isAllowMessaging = 1;
                    }
                    break;
                default:
                    $isAllowMessaging = 0;
                    break;
            }
            $this->view->isAllowMessaging = $isAllowMessaging;
            
        }
    }

    private function _isViewerStory($story, $viewer) {
        try {
            $table = Engine_Api::_()->getDbtable('viewers', 'sitestoriesweb');
            $row = $table->select()
                ->where('subject_id =?', $viewer->getIdentity())
                ->where('object_id = ?', $story->getIdentity())
                ->query()
                ->fetchAll();
            $rowCount = count($row);
            if ($rowCount > 0) {
                return 1;
            } else
                return 0;
        } catch (Exception $ex) {
            
        }
    }

    public function viewerCountAction() {
        
        $table = Engine_Api::_()->getDbtable('stories', 'sitestoriesweb');
        $viewer = Engine_Api::_()->user()->getViewer();
        if (Engine_Api::_()->core()->hasSubject())
            $story = Engine_Api::_()->core()->getSubject();

        if (empty($story)) {
            $story = Engine_Api::_()->getItem('sitestoriesweb_story', $this->getRequest()->getParam('story_id'));
            if(empty($story))
                return;
        }


        if (!$story->isOwner($viewer)) {
            $isViewed = $this->_isViewerStory($story, $viewer);
            if (!$isViewed) {
                $story->view_count++;
                $story->save();
                $this->_addViewerDetails($story, $viewer);
            }
        }
    }

    private function _addViewerDetails($story, $viewer) {
        if (empty($story) || empty($viewer)) {
            return;
        }
        $db = Engine_Api::_()->getDbtable('viewers', 'sitestoriesweb')->getAdapter();
        $db->beginTransaction();
        try {
            $table = Engine_Api::_()->getDbtable('viewers', 'sitestoriesweb');
            $row = $table->select()
                ->where('subject_id =?', $viewer->getIdentity())
                ->where('object_id = ?', $story->getIdentity())
                ->query()
                ->fetchAll();
            $rowCount = count($row);
            if ($rowCount == 0) {
                $values['subject_id'] = $viewer->getIdentity();
                $values['subject_type'] = $viewer->getType();
                $values['object_id'] = $story->getIdentity();
                $values['object_type'] = $story->getType();
                $row = $table->createRow();
                $row->setFromArray($values);
                $row->save();
                $db->commit();
            }
        } catch (Exception $ex) {
            $db->rollBack();
            
        }
    }

    public function deleteAction() {
        
        // Validate request methods
        $viewer = Engine_Api::_()->user()->getViewer();
        $story = Engine_Api::_()->getItem('sitestoriesweb_story', $this->getRequest()->getParam('story_id'));
        $this->view->story = $story;
        $this->view->is_video = $this->_getParam('video',0);
        
        // In smoothbox
        $this->_helper->layout->setLayout('default-simple');

        $this->view->form = $form = new Sitestoriesweb_Form_Delete();

        if( !$story ) {
            return $this->_forward('success', 'utility', 'core', array(
            'messages' => array(Zend_Registry::get('Zend_Translate')->_('Story entry doesn\'t exist or not authorized to delete')),
            'layout' => 'default-simple',
            'smoothboxClose' => 3000,));
        }

        if( !$this->getRequest()->isPost() ) {
            $this->view->status = false;
            $this->view->error = Zend_Registry::get('Zend_Translate')->_('Invalid request method');
            return;
        }

        $db = $story->getTable()->getAdapter();
        $db->beginTransaction();
        try {   
            if (Engine_Api::_()->getItem('storage_file', $story->file_id))
                Engine_Api::_()->getItem('storage_file', $story->file_id)->remove();

            if (Engine_Api::_()->getItem('storage_file', $story->photo_id) && $story->photo_id)
                Engine_Api::_()->getItem('storage_file', $story->photo_id)->remove();

            Engine_Api::_()->getDbtable('viewers', 'sitestoriesweb')->delete(array(
                'object_id = ?' => $story->story_id,
            ));

            $story->delete();
            $db->commit();
        } catch (Exception $ex) {
            $db->rollBack();
            return $this->_forward('success', 'utility', 'core', array(
            'messages' => $ex->getMessage(),
            'layout' => 'default-simple',
            'smoothboxClose' => 3000,));
        }

        $this->view->status = true;
        $this->view->message = Zend_Registry::get('Zend_Translate')->_('Your Story has been deleted.');
        

        return $this->_forward('success', 'utility', 'core', array(
        // 'smoothboxClose' => true,
        'parentRefresh' => true,
        'messages' => array($this->view->message),
        'layout' => 'default-simple',
        'smoothboxClose' => 3000,));
    }

    public function storyViewerListAction(){

        $this->view->canView = 1;
        if(empty($_POST)){
            $this->view->canView = 0;
            return;
        }
        $story_id = $this->_getParam('story_id');
        if(empty($story_id)){
            $this->view->canView = 0;
            return;
        }

        $story = Engine_Api::_()->getItem('sitestoriesweb_story',$story_id);
        $user = Engine_Api::_()->user()->getViewer();
        if($user->getIdentity() != $story->owner_id){
            $this->view->canView = 0;
            return ;
        }

        $viewers = Engine_Api::_()->getItemTable('sitestoriesweb_Viewer')->getStoryViewers($story_id);
        $this->view->viewers = $viewers;
    }

    // Mute User 
    public function muteStoryAction() {
        try {
            $params = array();

            $story_id = $this->_getParam('story_id');
            $next_user_id = $this->_getParam('next_user',0);
            if (empty($story_id)) {
                return $this->_forward('success', 'utility', 'core', array(
                'messages' => array(Zend_Registry::get('Zend_Translate')->_('No Record.')),
                'layout' => 'default-simple',
                'smoothboxClose' => 3000,));
            }

            $story = Engine_Api::_()->getItem('sitestoriesweb_story',$story_id);
            $viewer = Engine_Api::_()->user()->getViewer();
            
            $is_mute = $this->_getParam('is_mute', 0);
            
            $muteusersTable = Engine_Api::_()->getDbtable('muteusers', 'sitestoriesweb');
            $db = $muteusersTable->getAdapter();
            $db->beginTransaction();

            if (empty($story)) {
                return $this->_forward('success', 'utility', 'core', array(
                'messages' => array(Zend_Registry::get('Zend_Translate')->_('No Record.')),
                'layout' => 'default-simple',
                'smoothboxClose' => 3000,));
            }

            $params['muted_user_id'] = $story->owner_id;
            $params['user_id'] = $viewer->getIdentity();

            if (!empty($is_mute)) {
                $muteusersTable->muteUser($params);
            } else {
                $muteusersTable->unMuteUser($params);
            }

            $db->commit();
            if($next_user_id)
                $url = $this->view->url(array('action' => 'index','owner_id' => $next_user_id), 'stories_view', true);
            else
                $url = $this->view->url(array('action' => 'index'), 'stories_view', true);
            return $this->_forward('success', 'utility', 'core', array(
            'parentRedirect' => $url,
            'layout' => 'default-simple',
            'messages' => array(Zend_Registry::get('Zend_Translate')->_('You have muted this user\'s stories')),
            ));
        } catch (Exception $ex) {
            $db->rollBack();
            return $this->_forward('success', 'utility', 'core', array(
            'messages' => $ex->getMessage(),
            'layout' => 'default-simple',
            'smoothboxClose' => 3000,));
        }
    }

    public function muteUsersListAction(){
        // In smoothbox
        $this->_helper->layout->setLayout('default-simple');
        $viewer = Engine_Api::_()->user()->getViewer();
        $muteusersTable = Engine_Api::_()->getDbtable('muteusers', 'sitestoriesweb');
        $mutedUserList = $muteusersTable->getMuteUserIds();
        $userTable = Engine_Api::_()->getDbtable('users','user');
        $select = $userTable->select()->where('user_id IN ('.$mutedUserList.')');
        $mutedUsers = $userTable->fetchAll($select);
        $this->view->mutedUsers = $mutedUsers;
    }

    //Perform Mute and Unmute
    public function muteUserAction(){
        $response = array('status' => 400, 'messages'=> '');
        $params = array();
        $muted_user_id = $this->_getParam('user_id');
        if(empty($muted_user_id)){
            $response['messages'] = 'User Not Found!!';
            echo $this->_helper->json($response); exit(0);
        }
        $viewer = Engine_Api::_()->user()->getViewer();

        $is_mute = $this->_getParam('is_mute',0);
        $muteusersTable = Engine_Api::_()->getDbtable('muteusers', 'sitestoriesweb');
        $db = $muteusersTable->getAdapter();
        $db->beginTransaction();
        try{
            $params['muted_user_id'] = $muted_user_id;
            $params['user_id'] = $viewer->getIdentity();

            if (!empty($is_mute)) {
                $muteusersTable->muteUser($params);
            } else {
                $muteusersTable->unMuteUser($params);
            }

            $db->commit();
            $response['status'] = 200;

        }catch(Exception $ex){
            $db->rollBack();
            $response['messages'] = $ex->getMessage();
        }
        echo $this->_helper->json($response); exit(0);
    }

    public function reportStoryAction(){
        $this->_helper->layout->setLayout('default-simple');
        $story_id = $this->_getParam('story_id');
        $this->view->is_video = $this->_getParam('video',0);
        if(empty($story_id)){
            return $this->_forward('success', 'utility', 'core', array(
                'messages' => array(Zend_Registry::get('Zend_Translate')->_('No Story Found!!')),
                'layout' => 'default-simple',
                'smoothboxClose' => 3000,
            ));
        }
        $this->view->story_id = $story_id;
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();
        if(!$viewer_id){
            return $this->_forward('success', 'utility', 'core', array(
                'messages' => array(Zend_Registry::get('Zend_Translate')->_('Something went wrong!! Please try again later')),
                'layout' => 'default-simple',
                'smoothboxClose' => 1500,
            ));
            echo "<script> ";
            if($this->view->is_video)
                echo " setTimeout(function(){ parent.playVideo('".$story_id."'); }, 1500); ";
            else
                echo " setTimeout(function(){ parent.play('".$story_id."'); }, 1500); ";
            echo "</script>";
            return; 
        }

        $isAllReadyReported = Engine_Api::_()->getDbtable('reports','sitestoriesweb')->isAllReadyReported($viewer_id,$story_id);
        if($isAllReadyReported){
            $this->_forward('success', 'utility', 'core', array(
                'messages' => array(Zend_Registry::get('Zend_Translate')->_('You have already report this story.')),
                'layout' => 'default-simple',
                'smoothboxClose' => 1500,
            ));  
            echo "<script> ";
            if($this->view->is_video)
                echo " setTimeout(function(){ parent.playVideo('".$story_id."'); }, 1500); ";
            else
                echo " setTimeout(function(){ parent.play('".$story_id."'); }, 1500); ";
            echo "</script>";
            return; 
        }

        $this->view->form = $form = new Sitestoriesweb_Form_Report();
        if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
            $values = $form->getValues();
            if(empty($values['report_type'])){
                $form->addError('Please select Report Type');
                return;
            }

            $reportsTable = Engine_Api::_()->getDbtable('reports','sitestoriesweb');
            $db = $reportsTable->getAdapter();
            $db->beginTransaction();
            try{
                $row = $reportsTable->createRow();
                $row->user_id = $viewer_id;
                $row->setFromArray($values);
                $row->story_id = $story_id;
                $row->save();
                $db->commit();
            }catch(Exception $ex){
                $db->rollBack();

            }
            $this->_forward('success', 'utility', 'core', array(
                'messages' => array(Zend_Registry::get('Zend_Translate')->_('Thanks for taking time to report.')),
                'layout' => 'default-simple',
                'smoothboxClose' => 1500,
            ));
            echo "<script> ";
            if($this->view->is_video)
                echo " setTimeout(function(){ parent.playVideo('".$story_id."'); }, 1500); ";
            else
                echo " setTimeout(function(){ parent.play('".$story_id."'); }, 1500); ";
            echo "</script>";
            return; 

        }
    }
}
?>