<?php
class Sitestoriesweb_MessageController extends Core_Controller_Action_Standard
{
  public function composeAction() {

  	$response = array('status' => 400, 'message' => '');
	$viewer = Engine_Api::_()->user()->getViewer();
	$recipients = $this->_getParam('to');
	$recipientItem = Engine_Api::_()->getItem('user',$recipients);
	$attachment = null;

	$recipientName['name'] = $recipientItem->displayname;
	$title = 'Replied on your story';
	$body = $this->_getParam('message');
	$story_id = $this->_getParam('story_id');
	//PROCESS.
	$db = Engine_Api::_()->getDbtable('messages', 'messages')->getAdapter();
	$db->beginTransaction();

	try {
		$conversation = Engine_Api::_()->getItemTable('messages_conversation')->send($viewer, $recipientItem, $title, $body, $attachment);
	  //Increment messages counter
		Engine_Api::_()->getDbtable('statistics', 'core')->increment('messages.creations');

		$replyTable = Engine_Api::_()->getDbtable('replies','sitestoriesweb');
		$row = $replyTable->createRow();
		$row->conversation_id = $conversation->conversation_id;
		$row->story_id = $story_id;
		$row->save();
		$db->commit();

		$response['status'] = 200;
		$response['message'] = Zend_Registry::get('Zend_Translate')->_('Your message has been sent successfully.');
		echo $this->_helper->json($response); exit(0);
	} 
	catch (Exception $e) {
		$db->rollBack();
		$response['status'] = 404;
		$response['message'] = $e->getMessage();
		echo $this->_helper->json($response); exit(0);
	}
  }


  public function viewAction(){

  	$viewer = Engine_Api::_()->user()->getViewer();
  	$convTable= Engine_Api::_()->getItemTable('messages_conversation');
  	$convName= $convTable->info('name'); 
  	$select = $convTable->getInboxSelect($viewer);
  	$countSelect = $select;
  	$replyName = Engine_Api::_()->getDbtable('replies', 'sitestoriesweb')->info('name');
  	$page = $this->_getParam('page',1);
  	$this->view->story_id = $this->_getParam('story_id',0);
  	$this->view->is_video = $this->_getParam('video',0);
  	$this->view->primeMessenger = 0;
  	if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('primemessenger') && Engine_Api::_()->primemessenger()->isPrimeMessengerActive()){
  		$this->view->primeMessenger = 1;
  	}
  	
  	$select
  	->join($replyName, "`{$replyName}`.`conversation_id` = `{$convName}`.`conversation_id`", null)
  	->where("`{$replyName}`.`story_id` = ?", $this->_getParam('story_id',0))
	->group("$convName.conversation_id");

	$paginator = Zend_Paginator::factory($select);
	
	$items_per_page = '10';
	$paginator->setItemCountPerPage($items_per_page);
	$paginator->setCurrentPageNumber($page);
   	
    $this->view->paginator = $paginator; 
  }
}
?>