<?php

class Sitestoriesweb_StoriesController extends Core_Controller_Action_Standard
{
  public function indexAction()
  {
    //ONLY LOGGED IN USER CAN VIEW
    if (!$this->_helper->requireUser()->isValid())
        return;

    //USER CAN VIEW ONLY WHEN PLUGIN IS ACTIVE
    $settings = Engine_Api::_()->getApi('settings', 'core');
    $isPluginActive= $settings->getSetting('sitestories.enable.stories', 0);
    if(!$isPluginActive){
      return $this->_forward('requireauth', 'error', 'core');
    }

    $owner_id = $this->_getParam('owner_id');
    $this->view->showOwnerStory = $owner_id;
    $this->view->isInvalidOwner = 1;
    if(empty($owner_id))
      $this->view->isInvalidOwner = 0;
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    $this->view->viewer = $viewer;
    $this->view->viewer_id = $viewer_id;
    $storiesList = Engine_Api::_()->sitestoriesweb()->getUserList($viewer);
    $this->view->storiesList = $storiesList;
    $this->view->ownStory = Engine_Api::_()->getDbtable('stories','sitestoriesweb')->getUserStory($viewer_id);
    $this->view->ownStoryCount = count($this->view->ownStory);
    
    if($this->view->ownStoryCount && $owner_id == $viewer_id)
      $this->view->isInvalidOwner = 0;

    if($this->view->isInvalidOwner){
      foreach ($storiesList as  $story) {
        if($story['owner_id'] == $owner_id){
          $this->view->isInvalidOwner = 0;
          break;
        }
      }
    }
  }

  public function createAction(){

    //ONLY LOGGED IN USER CAN CREATE
    if (!$this->_helper->requireUser()->isValid())
        return;

    //USER CAN CREATE ONLY WHEN PLUGIN IS ACTIVE
    $settings = Engine_Api::_()->getApi('settings', 'core');
    $isPluginActive= $settings->getSetting('sitestories.enable.stories', 0);
    if(!$isPluginActive){
      return $this->_forward('requireauth', 'error', 'core');
    }

  	//GET VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    $this->view->viewer = $viewer;
    $this->view->max_upload_size = Engine_Api::_()->sitestoriesweb()->file_upload_max_size();
    if($this->getRequest()->isPost()){
      $response =  array('status' => 404, 'message' => '');
      $params = array();
      $type = $this->_getParam('type','');
      $media_text = $this->_getParam('media_text','');
      $media_rgb = $this->_getParam('media_rgb','');
      $feed = $this->_getParam('feed',0);
      if($type == 'image'){
        $photo = $this->_getParam('image'); 
        
        //Prepare Raw data for Image
        if(empty($photo)){
          $response['status'] = 403;
          $response['message'] = Zend_Registry::get('Zend_Translate')->_('Image is not Found. Please add Image');
          echo $this->_helper->json($response); exit(0);
        }
        //Get Temp Image. //Don't forget to unlink this temp file. 
        $tempImage  = Engine_Api::_()->sitestoriesweb()->base64ToTempFile($photo);
      }
      elseif($type == 'text'){
        $backgroundImage = $this->_getParam('background_file');
        $color = $this->_getParam('color');
        $backgroundColor = $this->_getParam('backgroundColor');
        $fileId = $this->_getParam('file_id',0);
        if(empty($backgroundImage)){
          $response['status'] = 403;
          $response['message'] = Zend_Registry::get('Zend_Translate')->_('Background is not Found. Please select Background');
          echo $this->_helper->json($response); exit(0);
        }
        $params['background'] = $backgroundImage; 
        $params['color'] = $color;
        $params['background-color'] = $backgroundColor;
        $params['file_id'] = $fileId;
      }elseif(isset($_REQUEST['type']) && $_REQUEST['type'] == 'video'){
        $type = $_REQUEST['type'];
        $media_text = $_REQUEST['media_text'];
        $feed = $_REQUEST['feed'];
      }
      
      if(!empty($media_rgb))
        $params['rgb'] = $media_rgb;

      $values = array('description' => $media_text,'type' => $type, 'params' => Zend_Json::encode($params));
      $values = @array_merge($values, array(
                  'owner_type' => $viewer->getType(),
                  'owner_id' => $viewer->getIdentity(),
      ));
      if(isset($_REQUEST['duration']) && !empty($_REQUEST['duration']))
        $values['duration'] =  $_REQUEST['duration'];
      $date = new DateTime(date('Y-m-d H:i:s'), new DateTimeZone('UTC'));
      $createDate = $date->format('Y-m-d H:i:s');
      $days = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestories_max_allowed_days', 1);
      $pastDate = date('Y-m-d H:i:s', strtotime('+' . $days . ' day', strtotime($createDate)));
      $expiryDate = $pastDate;
      $values['create_date'] = $createDate;
      $values['expiry_date'] = $expiryDate;
      $privacyStatus = Engine_Api::_()->getDbtable('userprivacies', 'sitestoriesweb')->getUserStoryPrivacyStatus($viewer_id);
      $db = Engine_Api::_()->getDbtable('stories', 'sitestoriesweb')->getAdapter();
      $db->beginTransaction();
      try {
        $table = Engine_Api::_()->getDbtable('stories', 'sitestoriesweb');
        $story = $table->createRow();
        $story->setFromArray($values);
        $story->privacy = $privacyStatus;
        $story->save();
        if($type == 'video'){
          $illegal_extensions = array('php', 'pl', 'cgi', 'html', 'htm', 'txt');
          if (!in_array(pathinfo($_FILES['filedata']['name'], PATHINFO_EXTENSION), $illegal_extensions)) {
            if ($_FILES['filedata'] instanceof Storage_Model_File) {
                $params['file_id'] = $_FILES['filedata']->getIdentity();
            } else {
                // create video item
                $file_ext = pathinfo($_FILES['filedata']['name']);
                $file_ext = $file_ext['extension'];
                $story->code = $file_ext;
                $story->save();

                // Channel video in temporary storage object for ffmpeg to handle
                $storage = Engine_Api::_()->getItemTable('storage_file');
                $storageObject = $storage->createFile($_FILES['filedata'], array(
                    'parent_id' => $story->getIdentity(),
                    'parent_type' => $story->getType(),
                    'user_id' => $story->owner_id,
                ));
                $story->file_id = $storageObject->file_id;
                $story->save();
            }

            $videoThumb = $this->_getParam('thumb'); 
            //Get Temp Image. //Don't forget to unlink this temp file. 
            $thumbImage  = Engine_Api::_()->sitestoriesweb()->base64ToTempFile($videoThumb);
            $story = Engine_Api::_()->sitestoriesweb()->setPhoto($thumbImage, $story);
            
        } else {
          $response['status'] = 403;
          $response['message'] = Zend_Registry::get('Zend_Translate')->_('invalid_upload');
          echo $this->_helper->json($response); exit(0);
          
        }

      }elseif($type == 'image'){
          $story = Engine_Api::_()->sitestoriesweb()->setPhoto($tempImage, $story);
      }
      $story->save();

      //Add Activity
      if($feed){
        $privacy = $story->privacy;
        if($privacy != 'everyone')
          $privacy = 'friends';
        if($type == 'image' && Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('album')){
          $action = Engine_Api::_()->getDbtable('actions', 'activity')->addActivity($viewer, $viewer, 'post_self', $media_text, array('count' => 1,'privacy' => $privacy));
          $photoObj = Engine_Api::_()->sitestoriesweb()->createAlbumObject($tempImage,$story->privacy);
          Engine_Api::_()->getDbtable('actions', 'activity')->attachActivity($action,$photoObj);  
            @unlink($tempImage);
        }elseif ($type == 'video') {
          if(Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitevideo') && Engine_Api::_()->getApi('settings', 'core')->sitevideo_ffmpeg_path)
            Engine_Api::_()->sitestoriesweb()->createVideoObject($_FILES,1,$story->privacy);
          elseif(Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('video') && Engine_Api::_()->getApi('settings', 'core')->video_ffmpeg_path)
            Engine_Api::_()->sitestoriesweb()->createVideoObject($_FILES,0,$story->privacy);
        }
        elseif($type == 'text'){
          $params = array(
            0 => '[]',
            'feed-banner' => array(
              'image' => str_replace('"', '', $params['background']),
              'color' => $params['color'],
              'background-color' => $params['background-color'],
              'privacy' => $privacy
            ), 
            'privacy' => $privacy
          );

           $action = Engine_Api::_()->getDbtable('actions', 'activity')->addActivity($viewer, $viewer, 'status', $media_text, $params);
        }
      }
      
      $db->commit();
      
      }catch(Exception $e){
        $db->rollback();
        $response['status'] = 401;
        $response['message'] = $e->getMessage();
        echo $this->_helper->json($response); exit(0);
      }
      
      //Send notification
      Engine_Api::_()->sitestoriesweb()->notifyUsers($viewer,$story);
      
      $response['status'] = 200;
      $response['message'] = 'success';
      echo $this->_helper->json($response); exit(0);
    }
  }

  public function storiesPrivacyAction(){

    //ONLY LOGGED IN USER CAN CREATE
    if (!$this->_helper->requireUser()->isValid())
        return;

    //USER CAN CREATE ONLY WHEN PLUGIN IS ACTIVE
    $settings = Engine_Api::_()->getApi('settings', 'core');
    $isPluginActive= $settings->getSetting('sitestories.enable.stories', 0);
    if(!$isPluginActive){
      return $this->_forward('requireauth', 'error', 'core');
    }

    //GET VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    $this->view->viewer = $viewer;

    //GET USER CURRUNT PRIVACY
    $privacyTable = Engine_Api::_()->getDbtable('userprivacies', 'sitestoriesweb');
    $privacyData = $privacyTable->getUserPrivacy($viewer_id);
    $this->view->privacyData = $privacyData;
    $this->view->privacy_status = $privacyData->privacy_status; 
    
    // PREPARE FORM
    $this->view->form = $form = new Sitestoriesweb_Form_Stories_Privacy(array(
        'privacy' => $privacyData->privacy_status
    ));

    $customUser = $privacyData->params;
    if(!empty($customUser) ){
      $customUser = $privacyData->getCustomUsers();
    }
    if(!empty($customUser))
      $this->view->isPopulated = 1;
    else
      $this->view->isPopulated = 0;

    $this->view->customUser  = $customUser;

    // If not post or form not valid, return
    if( !$this->getRequest()->isPost() ) {
        return;
    }

    if( !$form->isValid($this->getRequest()->getPost()) ) {
        return;
    }

    $formValues = $form->getValues();
    
    //update array
    $updateArray = array(
      "privacy_status" => $formValues['stories_privacy']
    );
    
    if($formValues['stories_privacy'] == 'custom'){
      $updateArray['params'] = $formValues['toValues'];
      if(empty($formValues['toValues'])){
        $form->addError(Zend_Registry::get('Zend_Translate')->_("The custom privacy setting needs to include one or more people."));
        $this->view->custom = 1;
        return;
      }
    }

    $currentDate = date('Y-m-d H:i:s');
    $days = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestories_max_allowed_days', 1);
    $pastDate = date('Y-m-d H:i:s', strtotime('-' . $days . ' day', strtotime($currentDate)));
    
    
    // Process
    $db = $privacyTable->getAdapter();
    $db->beginTransaction();
    try{
      //Update User Privacy
      $privacyTable->update($updateArray, array("user_id =?" => $viewer_id));
      Engine_Api::_()->getDbtable('stories','sitestoriesweb')->update(array('privacy' => $formValues['stories_privacy']),array("enable = ?" => 1,"owner_id = ?" => $viewer_id, "create_date >= ?" => $pastDate));
      $db->commit();
      return $this->_forward('success', 'utility', 'core', array(
      'layout' => 'default-simple',
      'smoothboxClose' => 1,));

    }catch(Exception $ex){
      $db->rollback();
      throw $ex;
    }
  }

  public function getMembersAction() {
    $search_text = $this->_getParam('search', $this->_getParam('value'));
    $limit = $this->_getParam('limit', 40);
    $params = $this->_getParam('customUsers','');

    //GET VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    
    if(empty($params)){
      //GET USER CURRUNT PRIVACY
      $privacyTable = Engine_Api::_()->getDbtable('userprivacies', 'sitestoriesweb');
      $privacyData = $privacyTable->getUserPrivacy($viewer_id);
      $params = $privacyData->params;
    }
    $data = array();

    $moduleContents = Engine_Api::_()->getDbtable('stories','sitestoriesweb')->getUsers($search_text, $params ,$limit = 10);

    foreach ($moduleContents as $moduleContent) {

        $content_photo = $this->view->itemPhoto($moduleContent, 'thumb.icon');

        $data[] = array(
            'id' => $moduleContent->user_id,
            'label' => $moduleContent->displayname,
            'photo' => $content_photo,
            'email' => $moduleContent->email,
        );
    }
    return $this->_helper->json($data);
  }

  public function removeCustomIdsAction(){
    $user_id = $this->_getParam('custId');
    if(empty($user_id))
      return;

    //GET VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    
    //GET USER CURRUNT PRIVACY
    $privacyTable = Engine_Api::_()->getDbtable('userprivacies', 'sitestoriesweb');
    $privacyData = $privacyTable->getUserPrivacy($viewer_id);
    $customUsers = $privacyData->params;
    $arr = explode(',', $customUsers);
    $getKey = array_search($user_id, $arr);
    unset($arr[$getKey]);
    $updatedCustomUsers = implode(",", $arr);
    $privacyData->params = $updatedCustomUsers;
    $privacyData->save();
    return;
  }

}
?>