<?php
require_once realpath(dirname(__FILE__)) . '/seaocore_install.php';

class Sitestoriesweb_Installer extends Sitecore_License_Installer
{	
  protected $_deependencyVersion = array(
      'seaocore' => '4.10.5p8',
      'sitestories' => '5.3.2',
  );

  protected $_installConfig = array(
    'sku' => 'sitestoriesweb',
  );
  
	public function onInstall()
  	{  
      $this->_createStoriesTableQueries();
        $this->_moveAdvancedactivityStoryTable();
    		$this->_moveAdvancedactivityViewerTable();
    		$this->_moveAdvancedactivityMutestoryTable();
    		$this->_moveAdvancedactivityMuteuserTable();
        $this->_manageWidget();
    		parent::onInstall();
  	}

  	protected function _moveAdvancedactivityStoryTable()
  	{
    		$db = $this->getDb();
        $table_advancedactivitystories_exist = $db->query('SHOW TABLES LIKE "engine4_advancedactivity_stories"')->fetch();
        if(empty($table_advancedactivitystories_exist))  {
          return;
        }
    		$currentDate = date('Y-m-d H:i:s');
    		$days = 1;
    		$pastDate = date('Y-m-d H:i:s', strtotime('-' . $days . ' day', strtotime($currentDate)));
    		$stories = $db->query("SELECT * FROM  `engine4_advancedactivity_stories` WHERE  `create_date` > '". $pastDate ."'")->fetchAll();
    	
		    foreach($stories as $story)	{
    			$db->query("INSERT INTO `engine4_sitestories_stories` (`story_id`, `owner_id`, `owner_type`, `photo_id`, `file_id`, `code`, `rotation`, `duration`, `create_date`, `expiry_date`, `privacy`, `view_count`, `comment_count`, `mute_story`) VALUES (NULL, '". $story->owner_id ."','". $story->owner_type ."','". $story->photo_id ."','". $story->file_id ."','". $story->code ."','". $story->rotation ."','". $story->duration ."','". $story->create_date ."','". $story->expiry_date ."','". $story->privacy ."','". $story->view_count ."','". $story->comment_count ."','". $story->mute_story ."')");
    		}
      	$db->query("DROP TABLE `engine4_advancedactivity_stories`");
    }

  	protected function _moveAdvancedactivityViewerTable()
    {
      	$db = $this->getDb();
        $table_advancedactivitystories_exist = $db->query('SHOW TABLES LIKE "engine4_advancedactivity_storyviewer"')->fetch();
        if(empty($table_advancedactivitystories_exist))  {
          return;
        }
      	$viewers = $db->query("SELECT * FROM  `engine4_advancedactivity_storyviewer`")->fetchAll();

      	foreach($viewers as $viewer)  {
        	$db->query("INSERT INTO `engine4_sitestories_storyviewer` (`viewer_id`, `subject_id`, `subject_type`, `object_id`, `object_type`) VALUES (NULL, '". $viewer->subject_id ."','". $viewer->subject_type ."','". $viewer->object_id ."','". $viewer->object_type ."')");
      	}
        $db->query("DROP TABLE `engine4_advancedactivity_storyviewer`");
    }

    protected function _moveAdvancedactivityMutestoryTable()
    {
      	$db = $this->getDb();
      	$table_page_exist = $db->query('SHOW TABLES LIKE "engine4_advancedactivity_mutestories"')->fetch();
        if(!empty($table_page_exist))
        {
      		$db->query("DROP TABLE `engine4_advancedactivity_mutestories`");
        }
    }

    protected function _moveAdvancedactivityMuteuserTable()
    {
      	$db = $this->getDb();
        $table_advancedactivitystories_exist = $db->query('SHOW TABLES LIKE "engine4_advancedactivity_muteusers"')->fetch();
        if(empty($table_advancedactivitystories_exist))  {
          return;
        }
      	$muteusers = $db->query("SELECT * FROM  `engine4_advancedactivity_muteusers`")->fetchAll();
      	foreach($muteusers as $muteuser)  {
        	$db->query("INSERT INTO `engine4_sitestories_muteusers` (`muteuser_id`, `user_id`, `muted_user_id`) VALUES (NULL,'". $muteuser->user_id ."','". $muteuser->muted_user_id . "')");
      	}
        $db->query("DROP TABLE `engine4_advancedactivity_muteusers`");
    }

    protected function _createStoriesTableQueries()  {
      $db = $this->getDb();
      $db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `order`) VALUES ("core_admin_main_plugins_storiesweb", "sitestoriesweb", "Web User Stories Plugin", "", \'{"route":"admin_default","module":"sitestoriesweb","controller":"settings"}\', "core_admin_main_plugins", "", 999);');
      $db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `order`) VALUES ("sitestoriesweb_admin_main_manage", "sitestoriesweb", "Manage Stories", "", \'{"route":"admin_default","module":"sitestoriesweb","controller":"manage"}\', "sitestoriesweb_admin_main", "", 1);');
      $db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `order`) VALUES ("sitestoriesweb_admin_main_settings", "sitestoriesweb", "Global Settings", "", \'{"route":"admin_default","module":"sitestoriesweb","controller":"settings"}\', "sitestoriesweb_admin_main", "", 0);');
      $db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `order`) VALUES ("sitestoriesweb_admin_main_report", "sitestoriesweb", "Abuse Reports", "", \'{"route":"admin_default","module":"sitestoriesweb","controller":"report"}\', "sitestoriesweb_admin_main", "", 2);');
      $db->query("CREATE TABLE IF NOT EXISTS `engine4_sitestories_stories` (
        `story_id` int(11) NOT NULL AUTO_INCREMENT PRIMARY KEY,
        `owner_id` int(11) NOT NULL,
        `owner_type` varchar(24) NOT NULL,
        `photo_id` int(11) NOT NULL,
        `file_id` int(11) NOT NULL,
        `code` varchar(255) NOT NULL,
        `rotation` varchar(255) NOT NULL,
        `duration` int(11) NOT NULL,
        `create_date` datetime NOT NULL,
        `expiry_date` datetime NOT NULL,
        `privacy` varchar(24) NOT NULL,
        `description` blob DEFAULT NULL,
        `view_count` int(11) NOT NULL,
        `comment_count` int(11) NOT NULL,
        `mute_story` int(11) NOT NULL,
        `enable` int(11) NOT NULL DEFAULT '1'
        
      ) ;");

      //ADD NEW COLUMN IN engine4_sitepage_imports TABLE
      $table_exist = $db->query("SHOW TABLES LIKE 'engine4_sitestories_stories'")->fetch();
      if (!empty($table_exist)) {

          $column_exist = $db->query("SHOW COLUMNS FROM engine4_sitestories_stories LIKE 'type'")->fetch();
          if (empty($column_exist)) {
              $db->query("ALTER TABLE `engine4_sitestories_stories` ADD `type` VARCHAR(20) NOT NULL AFTER `owner_type`");
          }

          $params_column_exist = $db->query("SHOW COLUMNS FROM engine4_sitestories_stories LIKE 'params'")->fetch();
          if (empty($column_exist)) {
              $db->query("ALTER TABLE `engine4_sitestories_stories` ADD `params` TEXT NOT NULL AFTER `file_id`");
          }
      }

      $table_exist1 = $db->query("SHOW TABLES LIKE 'engine4_core_settings'")->fetch();

      if (!empty($table_exist1)) {

          $column_exist1 = $db->query("SELECT * FROM `engine4_core_settings` WHERE `name` LIKE '%sitestories.enable.stories%'")->fetch();
          if (empty($column_exist1)) {
              $db->query("INSERT INTO `engine4_core_settings` ( `name`, `value`) VALUES ('sitestories.enable.stories',1)");
          }else{
            $db->query("UPDATE `engine4_core_settings` SET `value` = '1' WHERE `engine4_core_settings`.`name` = 'sitestories.enable.stories'");
          }
      }

        
    }

    protected function _manageWidget(){
      $db = $this->getDb();
      $page_id = $db->select()
        ->from('engine4_core_pages', array('page_id'))
        ->where('name = ?', 'user_index_home')
        ->limit(1)
        ->query()
        ->fetchColumn();
        if (!empty($page_id)) {
           $fetchMainContentId = $db->select()
           ->from('engine4_core_content', array('content_id'))
           ->where('page_id =?', $page_id)
           ->where('type = ?', 'container')
           ->where('name =?', 'main')
           ->limit(1)
           ->query()
           ->fetchColumn();
           if (!empty($fetchMainContentId)) {
            $mainContentId = $fetchMainContentId;
            $fetchRightContentId = $db->select()
            ->from('engine4_core_content', array('content_id'))
            ->where('page_id =?', $page_id)
            ->where('type = ?', 'container')
            ->where('name = ?', 'middle')
            ->where('parent_content_id = ?', $mainContentId)
            ->limit(1)
            ->query()
            ->fetchColumn();
            if (!empty($fetchRightContentId)) {
              $rightContentId = $fetchRightContentId;
              $selectWidgetId = $db->select()
              ->from('engine4_core_content', array('content_id'))
              ->where('page_id =?', $page_id)
              ->where('type = ?', 'widget')
              ->where('name = ?', 'sitestoriesweb.browse-stories')
              ->where('parent_content_id = ?', $rightContentId)
              ->limit(1)
              ->query()
              ->fetchColumn();
              if (empty($selectWidgetId)) {
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitestoriesweb.browse-stories',
                    'page_id' => $page_id,
                    'order' => 1,
                    'parent_content_id' => $rightContentId,
                    // 'params' => '{"title":"Want more Customers?","titleCount":"true"}',
                ));
              }
            }              
          }         

        }
    }

    public function onPostInstall() {
        $view = new Zend_View();
        $baseUrl = (!empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
        $redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
        $redirector->gotoUrl($baseUrl . 'admin/sitestoriesweb/settings/upgrade-settings/redirect/install');
        // parent::onPostInstall();
      }


    
  }

?>