<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitesubscription
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Layouts.php 6590 2017-03-07 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitesubscription_Model_DbTable_Layouts extends Engine_Db_Table
{
	protected $_rowClass = 'Sitesubscription_Model_Layout';

	public function getLayoutStructureType($layout_id) {
		$row = $this->select()->where('`layout_id` = ?',$layout_id)->query()->fetch();
		return $row['structure_type'];
	}

	public function getLayouts()
	{
		$rows = $this->select()
					->query()
					->fetchAll();

		return $rows;
	}

	public function getLayout($id)
	{
		$rows = $this->select()->where('`layout_id` = ?',$id)->query()->fetch();
		return $rows;
	}

	public function createLayout($params = null)
	{
		if (empty($params)) 
			return null;

		$layouts = $this->createRow();

		$db = $this->getAdapter();
        $db->beginTransaction();

        try {
            $layout = $this->createRow();
            $layout->setFromArray($params);
            $layout->save();
            $db->commit();
        } catch( Exception $e ) {
          $db->rollBack();
          throw $e;
        }

        return $layout->getIdentity();
	}
}