<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitesubscription
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Profiletypemapping.php 6590 2017-03-07 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitesubscription_Model_DbTable_Profiletypemapping extends Engine_Db_Table
{
	protected $_rowClass = 'Sitesubscription_Model_Profiletypemapping';
	
	public function setValues($values = null)
	{
		if ($values == null) 
			return;

		$mapping = $this->createRow();
		$mapping->setFromArray($values);
		$mapping->save();
	}

	public function updateValues($values = null)
	{
		if ($values == null) 
			return false;
		
		$this->update(array(
				'option_id' => $values['option_id'])
			,array(
				'package_id = ?' => $values['package_id'])
			);

		return true;
	}


	public function getMappedPackages()
	{
		$select = $this->select()
					->query()
					->fetchAll();

		return $select;
	}

	public function getProfileMap($package_id = null) 
	{
		if ($package_id == null) 
			return; 

		$map = $this->select()
			->where('package_id = ?',$package_id)
			->query()
			->fetch();

		if (empty($map))
			return '0';
		
		return $map['option_id'];
	}

	public function updateProfileType($values) {
      $topStructure = Engine_Api::_()->fields()->getFieldStructureTop('user');
      if( count($topStructure) ==  1 && $topStructure[0]->getChild()->type ==  'profile_type' ) {
        $profileTypeField = $topStructure[0]->getChild();
      }

      if (empty($values['subscribers']))
        return '1';

      $db = Engine_Db_Table::getDefaultAdapter();
      $db->beginTransaction();
      try {
        foreach ($values['subscribers'] as $user_id) {
          // delete the old profile type data
          $user = Engine_Api::_()->user()->getUser($user_id);
          $status = Engine_Api::_()->fields()->removeItemValues($user);
          // update the profile type to the new mapped type
          
          $user_field_value = $db->insert('engine4_user_fields_values', array('item_id' => $user_id, 'index' => '0','field_id' => $profileTypeField->field_id,'value' => $values['option_id']));
        }
        $db->commit();
      }
      catch (Exception $e) {
        $db->rollBack();
        return '0';
      }
      
      return '1';
    }
}