<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitesubscription
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminLayoutController.php 6590 2017-03-07 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitesubscription_AdminLayoutController extends Core_Controller_Action_Admin
{
    // Action for admin side subscription-fields page. Sets data values for template form.
	public function subscriptionFieldsAction()
	{
        
        include_once APPLICATION_PATH .'/application/modules/Sitesubscription/controllers/license/license2.php';
        if(empty($sitesubscription_subscription_fields) || empty($subscription_fields)){
            
            $this->_helper->content->setNoRender();
            return;
        }
        		
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitesubscription_admin_main', array(), 'sitesubscription_admin_manage_layout');

        $this->view->subNavigation = $subNavigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitesubscription_admin_manage_layout', array(), 'sitesubscription_admin_manage_layout_fields');

        $templateData = Engine_Api::_()->getApi('core','sitesubscription')->getTemplateData();
                
        foreach ($templateData['featuresRowData'] as $value) {
          $features[$value['field_id']]['order'] = $value['feature_order'];
          $features[$value['field_id']]['label'] = $value['feature_label'];
        }

        // unset disabled packages from package order
        foreach ($templateData['packageOrder'] as $package_id => $order) {
            if (!$templateData['packages'][$package_id]['enabled']) {
                unset($templateData['packageOrder'][$package_id]);
            }
        }

        $this->view->isFeatureEnabled = $templateData['isFeatureEnabled'];
        $this->view->structureType = $templateData['structureType'];
        $this->view->packages = $templateData['packages'];
        $this->view->packageOrder = $templateData['packageOrder'];
        $this->view->features = $features;
        $this->view->fieldValues = $templateData['fieldValues']; 

        if (!$this->getRequest()->isPost()) {
            return;
        }

        $params = $_POST;
        $status = $this->setFieldValues($params);

        return $this->_helper->redirector->gotoRoute(array('action' => 'subscription-fields'));
	}

    // Action for admin side subscription-templates page. Displays various default and admin-created templates to choose from.
	public function subscriptionTemplatesAction()
	{
        include_once APPLICATION_PATH .'/application/modules/Sitesubscription/controllers/license/license2.php';
        if(empty($sitesubscription_subscription_templates) || empty($subscription_templates)){
            
            $this->_helper->content->setNoRender();
            return;
        }

        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitesubscription_admin_main', array(), 'sitesubscription_admin_manage_layout');

        $this->view->subNavigation = $subNavigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitesubscription_admin_manage_layout', array(), 'sitesubscription_admin_manage_layout_templates');

        $this->view->templates = $templates = Engine_Api::_()->getDbtable('templates','sitesubscription')->getTemplates();
	}

    // Action for deleting feature data rows. Nested in admin-side subscription-fields page. 
    public function deleteFieldAction()
    {
        $this->_helper->layout->setLayout('admin-simple');
        $this->view->field_id =  $this->_getParam('field_id');

        if( !$this->getRequest()->isPost() ) {
          return;
        }

        $id =  $this->_getParam('field_id');

        // Delete Entries from fields table
        $fieldTable = Engine_Api::_()->getDbtable('fields','sitesubscription');
        $field = $fieldTable->find($id)->current();

        $db = $fieldTable->getAdapter();
        $db->beginTransaction();

        try {
            $field->delete();
            $db->commit();
        } catch( Exception $e ) {
          $db->rollBack();
          throw $e;
        }

        // Delete entries from values table
        Engine_Api::_()->getDbtable('values','sitesubscription')->deleteFieldValues($id);

        return $this->_forward('success', 'utility', 'core', array(
          'smoothboxClose' => 10,
          'parentRefresh'=> 10,
          'messages' => array('')
        ));
    }

    // Action for admin side add-template page. Lets admin create a new template using any basic layout templates.
    public function addTemplateAction()
    {
        include_once APPLICATION_PATH .'/application/modules/Sitesubscription/controllers/license/license2.php';
        if(empty($sitesubscription_add_template) || empty($add_template)){
            
            $this->_helper->content->setNoRender();
            return;
        }
                
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitesubscription_admin_main', array(), 'sitesubscription_admin_manage_layout');

        $this->view->subNavigation = $subNavigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitesubscription_admin_manage_layout', array(), 'sitesubscription_admin_manage_layout_templates');
        
        $layout = ($this->_getParam('layout_id') !== null) ? $this->_getParam('layout_id') : $this->_getParam('layout');

        $isAjaxRequest = $this->_getParam('ajax');
        $this->view->form = $form = new Sitesubscription_Form_Admin_Addtemplate(array('layoutId' => $layout, ));

        if (!empty($isAjaxRequest)) {
            $this->view->form = $form = new Sitesubscription_Form_Admin_Addtemplate(array('layoutId' => $layout, ));
            return;
        }

        if( !$this->getRequest()->isPost() ) {
          return;
        }
        if (!$form->isValid($this->getRequest()->getPost())) {
            $filledData = $form->getValues();
            $form->populate($filledData);
            foreach ($filledData as $key => $value) {
              if ($form->$key->getDecorator('ViewScript'))
                $form->$key->getDecorator('ViewScript')->setOption('value',str_replace("#", "", $value));
            }
            return;
        }


        $formData = $form->getValues();

        // Set image url in form fields
        if (isset($formData['tick_image']) && $formData['tick_image'] != '0') {
            $logo_id = $this->setPhoto($form->tick_image);
            $formData['tick_image'] = Engine_Api::_()->storage()->get($logo_id)->getPhotoUrl();
        } else
            $formData['tick_image'] = 'application/modules/Sitesubscription/externals/images/tick_image.png';

        if (isset($formData['cross_image']) && $formData['cross_image'] != '0') {
            $logo_id = $this->setPhoto($form->cross_image);
            $formData['cross_image'] = Engine_Api::_()->storage()->get($logo_id)->getPhotoUrl();
        } else
            $formData['cross_image'] = 'application/modules/Sitesubscription/externals/images/cross_image.png';

        if (isset($formData['bestchoice_image']) && $formData['bestchoice_image'] != '0') {
            $logo_id = $this->setPhoto($form->bestchoice_image);
            $formData['bestchoice_image'] = Engine_Api::_()->storage()->get($logo_id)->getPhotoUrl();
        } else
            $formData['bestchoice_image'] = 'application/modules/Sitesubscription/externals/images/bestchoice_image.png';

        $params['template_name'] = $formData['template_name'];
        $params['layout'] = $formData['layout'];

        $fieldsJSON = Engine_Api::_()->getDbtable('templates','sitesubscription')->getFieldsJSON($params['layout']);

        $fieldsJSON = json_decode($fieldsJSON,true);

        foreach ($fieldsJSON as $key => $value) {
            $fieldsJSON[$key]['value'] = str_replace("#", "", $formData[$key]);
        }

        $params['template_values'] = json_encode($fieldsJSON);
        Engine_Api::_()->getDbtable('templates','sitesubscription')->createTemplate($params);

        $this->_helper->redirector->gotoRoute(array('module' => 'sitesubscription', 'controller' => 'layout', 'action' => 'subscription-templates'), '', true);
    }

    // Action for deleting templates created by admin. Nested in admin-side subscription-templates page.
    public function deleteTemplateAction()
    {
        $this->_helper->layout->setLayout('admin-simple');
        $this->view->template_id =  $this->_getParam('template_id');

        if( !$this->getRequest()->isPost() ) {
          return;
        }

        $id =  $this->_getParam('template_id');

        // Delete Entries from template table
        $fieldTable = Engine_Api::_()->getDbtable('templates','sitesubscription');
        $field = $fieldTable->find($id)->current();

        $db = $fieldTable->getAdapter();
        $db->beginTransaction();

        try {
            $field->delete();
            $db->commit();
        } catch( Exception $e ) {
          $db->rollBack();
          throw $e;
        }

        return $this->_forward('success', 'utility', 'core', array(
          'smoothboxClose' => 10,
          'parentRefresh'=> 10,
          'messages' => array('')
        ));
    }

    // Action for activating a selected template. Nested in admin-side subscription-templates page.
    public function activateTemplateAction()
    {
        $this->_helper->layout->setLayout('admin-simple');
        $this->view->template_id =  $this->_getParam('template_id');

        if( !$this->getRequest()->isPost() ) {
          return;
        }

        $id =  $this->_getParam('template_id');

        // Activate the choosen template
        $fieldTable = Engine_Api::_()->getDbtable('templates','sitesubscription')->activateTemplate($id);

        return $this->_forward('success', 'utility', 'core', array(
          'smoothboxClose' => 10,
          'parentRefresh'=> 10,
          'messages' => array('')
        ));
    }

    // Action for admin side edit-template page. Lets admin edit the created templates.
    public function editTemplateAction()
    {
        include_once APPLICATION_PATH .'/application/modules/Sitesubscription/controllers/license/license2.php';
        if(empty($sitesubscription_edit_template) || empty($edit_template)){
            
            $this->_helper->content->setNoRender();
            return;
        }

        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitesubscription_admin_main', array(), 'sitesubscription_admin_manage_layout');

        $this->view->subNavigation = $subNavigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitesubscription_admin_manage_layout', array(), 'sitesubscription_admin_manage_layout_templates');
                
        $id = $this->_getParam('template_id');
        // Make form
        $this->view->form = $form = new Sitesubscription_Form_Admin_Addtemplate(array('templateId' => $id));
        $this->view->template_id = $id;

        if( !$this->getRequest()->isPost() ) {
          return;
        }
        if (!$form->isValid($this->getRequest()->getPost())) {
            $filledData = $form->getValues();
            $form->populate($filledData);
            foreach ($filledData as $key => $value) {
              if ($form->$key->getDecorator('ViewScript'))
                $form->$key->getDecorator('ViewScript')->setOption('value',str_replace("#", "", $value));
            }
            return;
        }

        $formData = $form->getValues();

        // Set image url in form fields
        if (isset($formData['tick_image']) && $formData['tick_image'] != '0') {
            $logo_id = $this->setPhoto($form->tick_image);
            $formData['tick_image'] = Engine_Api::_()->storage()->get($logo_id)->getPhotoUrl();
        } else
            $formData['tick_image'] = 'application/modules/Sitesubscription/externals/images/tick_image.png';

        if (isset($formData['cross_image']) && $formData['cross_image'] != '0') {
            $logo_id = $this->setPhoto($form->cross_image);
            $formData['cross_image'] = Engine_Api::_()->storage()->get($logo_id)->getPhotoUrl();
        } else
            $formData['cross_image'] = 'application/modules/Sitesubscription/externals/images/cross_image.png';

        if (isset($formData['bestchoice_image']) && $formData['bestchoice_image'] != '0') {
            $logo_id = $this->setPhoto($form->bestchoice_image);
            $formData['bestchoice_image'] = Engine_Api::_()->storage()->get($logo_id)->getPhotoUrl();
        } else
            $formData['bestchoice_image'] = 'application/modules/Sitesubscription/externals/images/bestchoice_image.png';

        $fieldsJSON = Engine_Api::_()->getDbtable('templates','sitesubscription')->getFieldsJSON($id,0);
        $fieldsJSON = json_decode($fieldsJSON,true);

        foreach ($fieldsJSON as $key => $value) 
            $fieldsJSON[$key]['value'] = str_replace("#", "", $formData[$key]);

        $params['template_id'] = $id;
        $params['template_values'] = json_encode($fieldsJSON);
        Engine_Api::_()->getDbtable('templates','sitesubscription')->setValues($params);

        // Repopulate form with updated values
        $templateData = Engine_Api::_()->getDbtable('templates','sitesubscription')->getTemplate($id);
        $fieldsJSON = json_decode($templateData['template_values'],true);
        foreach ($fieldsJSON as $key => $value) {
          $form->$key->setValue[$value['value']];
          if ($form->$key->getDecorator('ViewScript'))
            $form->$key->getDecorator('ViewScript')->setOption('value',$value['value']);
        }
        $this->view->form = $form;
    }

    // Action for previewing the current edited data-fields or styles. Nested in admin-side subscription-fields, edit-templates, create-template page.
    public function previewAction()
    {
        // Make form
        $this->view->form = $form = new Sitesubscription_Form_Signup_Subscription();

        $this->view->formError = 0;

        $previewType = $this->getParam('previewtype');
        $template_id = $this->getParam('template_id');
        
        $baseFolder = APPLICATION_PATH . '/public/sitesubscription/';
        if(!is_writable($baseFolder)){

            mkdir($baseFolder);
        }

        $fileUrl = $baseFolder.trim($previewType).'-data.json';

        if (!is_writable($fileUrl)) {
            $this->view->formError = 1;
            return;
        }

        $content = json_decode(file_get_contents($fileUrl),true);

        if ($previewType == 'fields' && !empty($content)) {

          $flag = $content['structure'];
          $templateData = Engine_Api::_()->getApi('core','sitesubscription')->getTemplateData();
          unset($content['structure']);
          $newContent = $this->getSortedValues($content);

          foreach ($newContent as $key => $value) {
            $temp1 = explode("_", $key);
            if ($temp1[2] === 'name') {
              $temp2[$temp1[0]]['field_id'] = $temp1[0];
              $temp2[$temp1[0]]['label'] = $value;
            } else if ($temp1[2] === 'selectbox' && $flag == '1') {
              if ($value === 'textbox')
                $fieldValues[$temp1[0]][$temp1[1]] = $newContent[$temp1[0]."_".$temp1[1]."_textbox"];
              else
                $fieldValues[$temp1[0]][$temp1[1]] = $value;
            } else if ($temp1[2] === 'textbox' && $flag == '0' ) {
                $fieldValues[$temp1[0]][$temp1[1]] = $value;
            }
          }

          if ($templateData['structureType'] === 'type2' && $temp2 == null) {
            foreach ($fieldValues as $key => $value) 
              $temp2[$key]= array('field_id' => $key, 'label' => null);
          }

          foreach ($temp2 as $value) 
            $features[] = $value;

          $templateData['features']  = $features;
          $templateData['fieldValues'] = $fieldValues;
          
        } else if ($previewType == 'styles' && !empty($content)) {
          $row = Engine_Api::_()->getDbtable('templates','sitesubscription')->getTemplate($template_id);
          if (empty($row))
            return 'Cannot display preview for this template';

          $templateData = Engine_Api::_()->getApi('core','sitesubscription')->getTemplateData($template_id);
          foreach ($content as $key => $value) 
            $temp[$key]['value'] = $value;
          $templateData['templateStyle'] = $temp;
          $templateData['layout_id'] = $row['layout'];
        }

        $this->view->form->setTitle('');
        $this->view->form->setAction('');
        $this->view->form->setDescription('');
        $this->view->templateData = $templateData;
        $this->view->layout_id = $templateData['layout_id'];
        

        if (!$this->getRequest()->isPost()) {
            return;
        }
        
        return $this->_forward('success', 'utility', 'core', array(
          'smoothboxClose' => 5,
          'parentRefresh' => false,
          'format'=> 'smoothbox',
        ));
    }

    // Action for writing the Json file. Called via ajax-request on preview.
    public function writePreviewFileAction() 
    {
        $content = $this->getParam('content');
        $content = str_replace("#", "", $content);
        $previewType = $this->getParam('previewtype');
        $data = array('return' => 0, 'message' => 'Writing file failed.');
        $baseFolder = APPLICATION_PATH . '/public/sitesubscription/';
        if(!is_writable($baseFolder)){

            mkdir($baseFolder);
        }

        $fileUrl = $baseFolder.trim($previewType).'-data.json';

        $handle = fopen($fileUrl, 'w');
        $status = fwrite($handle,$content);
        fclose($handle);

        if (!$handle) 
            $data['message'] = 'Error occured while fetching file. Check file permissions of '.APPLICATION_PATH.'/public folder .';
        else if (!$status) 
            $data['message'] = 'Error occured while writing file.Check file permissions of '.APPLICATION_PATH.'/public folder.';
        else
            $data = array('return' => 1, 'message' => 'Preview file successfuly written.');

        return $this->_helper->json($data);
    }

    public function manageLayoutsAction()
    {
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitesubscription_admin_main', array(), 'sitesubscription_admin_manage_layout');

        $this->view->subNavigation = $subNavigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitesubscription_admin_manage_layout', array(), 'sitesubscription_admin_manage_layout_layouts');

        $this->view->layouts = $layouts = Engine_Api::_()->getDbtable('layouts','sitesubscription')->getLayouts();
    }

    public function addLayoutAction()
    {
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitesubscription_admin_main', array(), 'sitesubscription_admin_manage_layout');

        $this->view->subNavigation = $subNavigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitesubscription_admin_manage_layout', array(), 'sitesubscription_admin_manage_layout_layouts');

        $layout = $this->_getParam('layout_id') ? $this->_getParam('layout_id') : $this->_getParam('layout');

        $this->view->form = $form = new Sitesubscription_Form_Admin_Addlayout();

        if( !$this->getRequest()->isPost() ) {
          return;
        }
        if (!$form->isValid($this->getRequest()->getPost())) {
            $filledData = $form->getValues();
            $form->populate($filledData);
            foreach ($filledData as $key => $value) {
              if ($form->$key->getDecorator('ViewScript'))
                $form->$key->getDecorator('ViewScript')->setOption('value',$value);
            }
            return;
        }

        $formValues = $form->getValues();

        $baseLayout = Engine_Api::_()->getDbtable('layouts','sitesubscription')->getLayout($formValues['layout']);

        $newLayout['layout_name'] = $formValues['layout_name'];
        $newLayout['structure_type'] = $baseLayout['structure_type'];

        // insert data in layouts table
        $newLayoutId = Engine_Api::_()->getDbtable('layouts','sitesubscription')->createLayout($newLayout);

        // Create template file
        $folderPath = APPLICATION_PATH."/application/modules/Sitesubscription/views/scripts/layouts/";
        if (!is_writable($folderPath)) 
            $form->addNotice('Unable to create layout. '.$folderPath.' is not writable. Assign permissions to folder and then continue.');

        // Get file data
        $templateFileData = file_get_contents($folderPath.'_plansTemplate_'.$formValues['layout'].'.tpl');

        // Save file
        $handle = fopen($folderPath.'_plansTemplate_'.trim($newLayoutId).'.tpl','w+');
        fwrite($handle,$templateFileData);
        fclose($handle);
        chmod($folderPath.'_plansTemplate_'.trim($newLayoutId).'.tpl', 0777);

        // insert data in templates table
        $baseLayoutTemplate = Engine_Api::_()->getDbtable('templates','sitesubscription')->getBaseTemplate($formValues['layout']);

        $newLayoutTemplate['template_name'] = $formValues['layout_name'].' - Template';
        $newLayoutTemplate['template_values'] = $baseLayoutTemplate['template_values'];
        $newLayoutTemplate['layout'] = $newLayoutId;
        $newLayoutTemplate['default'] = 1;

        Engine_Api::_()->getDbtable('templates','sitesubscription')->createTemplate($newLayoutTemplate);

        $form->addNotice('Layout Created Successfully.<br> File Path: /application/modules/Sitesubscription/views/scripts/layouts/_plansTemplate_'.trim($newLayoutId).'.tpl');
        $form->reset();
    }

    public function deleteLayoutAction()
    {
        $this->_helper->layout->setLayout('admin-simple');
        $this->view->layout_id =  $this->_getParam('layout_id');

        if( !$this->getRequest()->isPost() ) {
          return;
        }

        $id = $this->_getParam('layout_id');

        // Delete Entries from layouts table
        $layoutsTable = Engine_Api::_()->getDbtable('layouts','sitesubscription');
        $db = $layoutsTable->getAdapter();
        $db->beginTransaction();

        try {
            $layoutsTable->delete(array('layout_id = ?' => $id));
            $db->commit();
        } catch( Exception $e ) {
          $db->rollBack();
          throw $e;
        }

        // Delete entries from templates table
        $templatesTable = Engine_Api::_()->getDbtable('templates','sitesubscription');
        $db = $templatesTable->getAdapter();
        $db->beginTransaction();

        try {
            $templatesTable->delete(array('layout = ?' => $id));
            $db->commit();
        } catch( Exception $e ) {
          $db->rollBack();
          throw $e;
        }

        // Remove files
        $filePath = APPLICATION_PATH."/application/modules/Sitesubscription/views/scripts/layouts/_plansTemplate_".$id.".tpl";
        if (!is_writable($filePath)) {
            echo "<div class='tip'><span><?php echo $this->translate('There was an error in file deletion. Required permissions are not assigned to layout file.'); ?></span></div>";
        } else
            unlink($filePath);
        

        return $this->_forward('success', 'utility', 'core', array(
          'smoothboxClose' => 10,
          'parentRefresh'=> 10,
          'messages' => array('')
        ));
    } 


    public function setFieldValues($params)
    {
      $structure_type = ($params['structure'] == 0) ? '2' : '1';
      unset($params['structure']);
      unset($params['save']);

      $sorted_arr = $this->sortFormValues($params);

      $field_arr = $sorted_arr['fields'];
      $values_arr = $sorted_arr['values'];
      $new_fields_arr = $sorted_arr['new'];

      $status1 = Engine_Api::_()->getDbTable('fields','sitesubscription')->updateFields($field_arr);
      $status2= Engine_Api::_()->getDbTable('values','sitesubscription')->updateValues($values_arr);
      $status3 = $this->addNewFeature($new_fields_arr,$structure_type);

      return true;
    }

    public function addNewFeature($new_fields_arr,$structure_type) 
    {
     if (empty($new_fields_arr)) 
       return;

     foreach ($new_fields_arr as $field => $values) {
       $field_id = Engine_Api::_()->getDbTable('fields','sitesubscription')->addNewField(array(
         'feature_label' =>  $values['name'],
         'structure_type' => 'type'.$structure_type,
         ));

       unset($new_fields_arr[$field]['name']);
       $setValue[$field_id] = $new_fields_arr[$field];
       $status = Engine_Api::_()->getDbTable('values','sitesubscription')->updateValues($setValue);
     }
    }

    public function sortFormValues($params)
    {
      $values_arr = array();

      foreach ($params as $key => $value) {
        $arr = explode("_", $key);

        if (strpos($key, 'new') === 0) {
          if( $arr[1] == 'field' )
            $new_fields_arr[$arr[0]]['name'] = $value; 
          else if ( $value == 'textbox' )
            $new_fields_arr[$arr[0]][$arr[1]] = $this->convertFromMarkdownFormat($params[$arr[0].'_'.$arr[1].'_textbox']);
          else
            $new_fields_arr[$arr[0]][$arr[1]] = $this->convertFromMarkdownFormat($value);
          continue;
        }

        if ( $arr[1] == 'field' )
          $fields_arr[$arr[0]] = $value;
        else if ( $value == 'textbox' )
          $values_arr[$arr[0]][$arr[1]] = $this->convertFromMarkdownFormat($params[$arr[0].'_'.$arr[1].'_textbox']);
        else
          $values_arr[$arr[0]][$arr[1]] = $this->convertFromMarkdownFormat($value); 
      }

      $return_arr['fields'] = $fields_arr;
      $return_arr['values'] = $values_arr;
      $return_arr['new'] = $new_fields_arr;
     
      return $return_arr;
    }

    public function convertFromMarkdownFormat($string = null)
    {
      if (empty($string)) 
        return "";

      $markdown_array = array("**" => "\*\*","~~" => "\~\~","__" => "__");

      foreach ($markdown_array as $markdown => $replacement) {
        $count = substr_count($string,$markdown);
        if ($count > 0) 
          for ($i=1; $i <= $count ; $i++) { 
            $string = preg_replace("/".$replacement."/", $this->getTag($markdown,$i), $string ,1);
          }
      }
      return $string;
    }

    public function getTag($markdown,$pos)
    {
      switch ($markdown) {
        case '**':
          $tag = "b>";
          break;

        case '~~':
          $tag = "i>";
          break;

        case '__':
          $tag = "strike>";
          break;
        
        default:
          break;
      }

      if ( ((int)$pos%2) == 0)
        $tag = '</'.$tag;
      else
        $tag = '<'.$tag;

      return $tag;
    }


    public function convertToMarkdownFormat($string = null)
    {
      if (empty($string)) 
        return "";

      $tags_array = array("**"=> array("<b>","<\/b>"),"~~" => array("<i>","<\/i>"), "__" => array("<strike>","<\/strike>"));
      foreach ($tags_array as $key => $value) {
        $string = preg_replace("/(".$value[0]."|".$value[1].")/i", $key, $string);
      }

      return $string;
    }


    public function setPhoto($photo)
    {
       $valid_thumb = true;
        if ($photo instanceof Zend_Form_Element_File) {
            $file = $photo->getFileName();
            $fileName = $file;
        } else if ($photo instanceof Storage_Model_File) {
            $file = $photo->temporary();
            $fileName = $photo->name;
        } else if ($photo instanceof Core_Model_Item_Abstract && !empty($photo->file_id)) {
            $tmpRow = Engine_Api::_()->getItem('storage_file', $photo->file_id);
            $file = $tmpRow->temporary();
            $fileName = $tmpRow->name;
        } else if (is_array($photo) && !empty($photo['tmp_name'])) {
            $file = $photo['tmp_name'];
            $fileName = $photo['name'];
        } else {
            $file = $photo;
            $fileName = $photo;
            if (@GetImageSize($fileName)) {
                $valid_thumb = true;
            } else {
                $valid_thumb = false;
            }
        }
        if(empty($fileName))
            return;
        if (!$fileName) {
            $fileName = basename($file);
        }

        $params = array(
            'parent_type' => 'sitesubscription_templates',
            // 'parent_id' => $this->getIdentity(),
            // 'user_id' => $this->owner_id,
            'name' => $fileName,
        );

        $thumbnail_parsed = @parse_url($fileName);
        $ext = ltrim(strrchr($fileName, '.'), '.');
        if (isset($thumbnail_parsed['path'])) {
            $ext = ltrim(strrchr($thumbnail_parsed['path'], '.'), '.');
        }
        if ($valid_thumb && $fileName && $ext && $thumbnail_parsed && in_array($ext, array('jpg', 'jpeg', 'gif', 'png'))) {

            $file = APPLICATION_PATH . '/temporary/logo_' . md5($fileName) . '.' . $ext;
            $mainPath = APPLICATION_PATH . '/temporary/logo_' . md5($fileName) . '_m.' . $ext;

            $src_fh = fopen($fileName, 'r');
            $tmp_fh = fopen($file, 'w');
            stream_copy_to_stream($src_fh, $tmp_fh, 1024 * 1024 * 30);

            // Resize image (main)
            if (file_exists($file)) {
                $image = Engine_Image::factory();
                $image->open($file)
                        ->resize(100, 100)
                        ->write($mainPath)
                        ->destroy();
            }

            $filesTable = Engine_Api::_()->getDbtable('files', 'storage');

            // Store
            $iMain = $filesTable->createFile($mainPath, $params);
            $iMain->bridge($iMain, 'logo');

            // Remove temp files
            @unlink($mainPath);

            $photo_id =  $iMain->getIdentity();
        }
        return $photo_id;
    }

    public function getSortedValues($content = null)
    {
      if ($content == null) 
        return;

      $pseudo_ids = $this->getSortedIds(array_keys($content));

      if ($pseudo_ids == null) 
        return $content;

      foreach ($content as $key => $value) {
        $temp = explode('_', $key);

        if (strpos($temp[0], 'new') === 0)
          $temp[0] = $pseudo_ids[$temp[0]];

        $new_key = implode('_', $temp);
        $new_content[$new_key] = $value;
      }

      return $new_content;
    }

    public function getSortedIds($array = null) {
      if (empty($array)) 
        return null;

      foreach ($array as $id) {
        $temp = explode('_', $id);

        if (strpos($temp[0], 'new') !== 0)
          $id_array[] = $temp[0];
        else if (strpos($temp[0], 'new') === 0)
          $newIdsArray[] = $temp[0];
      }

      $max_id = max($id_array);
      $uniqueNewIds = array_unique($newIdsArray);

      foreach ($uniqueNewIds as $value) {
        $pseudo_ids[$value] = ++$max_id;
      }
      
      return $pseudo_ids;
    }
}