<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitesubscription
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminSettingsController.php 6590 2017-03-07 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitesubscription_AdminSettingsController extends Core_Controller_Action_Admin
{
    
    public function readmeAction(){
        return $this->_helper->redirector->gotoRoute(array('action' => 'index'));
    }

    // Action for admin-side global setting page.
    public function indexAction()
    {

        include APPLICATION_PATH . '/application/modules/Sitesubscription/controllers/license/license1.php'; 
    }

    // Action for admin-side reminder email page.
    public function reminderEmailAction()
    {
        include_once APPLICATION_PATH .'/application/modules/Sitesubscription/controllers/license/license2.php';
        if(empty($sitesubscription_reminder_email) || empty($reminder_email)){
            
            $this->_helper->content->setNoRender();
            return;
        }
                
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitesubscription_admin_main', array(), 'sitesubscription_admin_settings_email');

        $this->view->form = $form = new Sitesubscription_Form_Admin_Reminderemail();

        if ( !$this->getRequest()->isPost()) {
            return;
        }
        
        if( !$form->isValid($this->getRequest()->getPost()) ) {
          return;
        }

        $values = $_POST;
        $site_title = $_SERVER['HTTP_HOST'];

        $values['sitesubscription_expired_mail_duration'] = json_encode($values['sitesubscription_expired_mail_duration']);
        // $values['sitesubscription_mail_send_after'] = json_encode($values['sitesubscription_mail_send_after']);

        if ($values['sitesubscription_enable_testemail'] != 1) 
            $values['sitesubscription_testemail'] = '';
        elseif ($values['sitesubscription_enable_testemail'] == 1 && !empty($values['sitesubscription_testemail']))
            Engine_Api::_()->getApi('mail', 'core')->sendSystem($values['sitesubscription_testemail'], 'subscription_test', array(
            'site_title' => $site_title,
            'queue' => false ));

        $settingsTable = Engine_Api::_()->getDbtable('settings', 'core');
        foreach ($values as $key => $value) {
            $settingsTable->setSetting($key, $value);
        }

        if ($values['sitesubscription_enable_testemail'] == 1  && !empty($values['sitesubscription_testemail']))
        $form->addNotice('Test email has been sent to the email id provided by you.');
    }
}