<?php

class Siteteam_Model_DbTable_Teams extends Engine_Db_Table
{

  protected $_serializedColumns = array('params');
  protected $_rowClass = "Siteteam_Model_Team";

  /**
   * Get paginator for teams
   *
   * @param array
   * @return Zend_Paginator
   */
  public function getTeamsPaginator($params = array())
  {
    $paginator = Zend_Paginator::factory($this->getTeamsSelect($params));
    if( !empty($params['page']) ) {
      $paginator->setCurrentPageNumber($params['page']);
    }
    if( !empty($params['limit']) ) {
      $paginator->setItemCountPerPage($params['limit']);
    }
    return $paginator;
  }

  /**
   * Gets a select object for the teams entries
   *
   * @return Zend_Db_Table_Select
   */
  public function getTeamsSelect($params = array())
  {
    $select = $this->select();
    $select->order('order ASC');
    if( !empty($params['designation_id']) ) {
      $select->where($this->info('name') . '.designation_id = ?', $params['designation_id']);
    }
    if( isset($params['enabled']) ) {
      $select->where($this->info('name') . '.enabled = ?', $params['enabled']);
    }
    
    return $select;
  }

  public function getTeam($id)
  {
    $select = $this->getTeamsSelect()->where('team_id = ?', $id);
    return $this->fetchRow($select);
  }

  public function getTeamId($params = array())
  {

    return $this->select()
        ->from($this->info('name'), array('team_id'))
        ->where('user_id =?', $params['user_id'])
        ->query()
        ->fetchColumn();
  }

}