<?php

class Siteteam_Model_Team extends Core_Model_Item_Abstract
{

  // Properties
  protected $_parent_type = null;
  protected $_searchTriggers = array();
  protected $_parent_is_owner = false;
  protected $designation = false;

  /**
   * Disable internal hooks?
   * @var boolean
   */
  protected $_disableHooks = true;

  public function getTitle()
  {
    $user = $this->getUser();
    return $user ? $user->getTitle() : $this->name;
  }

  public function getHref($params = array())
  {

    $user = $this->getUser();
    return $user ? $user->getHref($params) : '';
  }

  public function getUser()
  {
    if( !$this->user_id ) {
      return;
    }
    return Engine_Api::_()->getItem('user', $this->user_id);
  }

  public function getDesignation()
  {
    if( $this->designation == false && $this->designation_id ) {
      $this->designation = Engine_Api::_()->getDbtable('designations', 'siteteam')->find($this->designation_id)->current();
    }
    return $this->designation;
  }

  public function getPhotoUrl($type = NULL)
  {

    $photo_id = $this->photo_id;
    if( empty($photo_id) ) {
      $path = Zend_Registry::get('Zend_View')->baseUrl() . '/' . 'application/modules/Siteteam/externals/images/nophoto_team_thumb_profile.png';
      return $path;
    } elseif( $photo_id ) {
      $file = Engine_Api::_()->getItemTable('storage_file')->getFile($this->photo_id, '');
      return $file->map();
    }
  }

  public function getDescription()
  {
    return $this->body;
  }

  public function setPhoto($photo)
  {
    if( $photo instanceof Zend_Form_Element_File ) {
      $file = $photo->getFileName();
      $fileName = $file;
    } elseif( is_array($photo) && !empty($photo['tmp_name']) ) {
      $file = $photo['tmp_name'];
      $fileName = $photo['name'];
    } elseif( is_string($photo) && file_exists($photo) ) {
      $file = $photo;
      $fileName = $photo;
    } else {
      throw new Core_Model_Exception('invalid argument passed to setPhoto');
    }

    if( !$fileName ) {
      $fileName = basename($file);
    }

    $extension = ltrim(strrchr(basename($fileName), '.'), '.');
    $base = rtrim(substr(basename($fileName), 0, strrpos(basename($fileName), '.')), '.');
    $path = APPLICATION_PATH . DIRECTORY_SEPARATOR . 'temporary';

    $params = array(
      'parent_type' => 'siteteam_team',
      'parent_id' => $this->getIdentity(),
      'name' => $fileName,
    );

    // Save
    $filesTable = Engine_Api::_()->getDbtable('files', 'storage');

    // Resize image (main)
    $mainPath = $path . DIRECTORY_SEPARATOR . $base . '_m.' . $extension;
    $image = Engine_Image::factory();
    $image->open($file)
      ->write($mainPath)
      ->destroy();
    // Store
    $iMain = $filesTable->createSystemFile($mainPath);

    // Remove temp files
    @unlink($mainPath);
    $this->photo_id = $iMain->file_id;
    $this->save();
    return $this;
  }

}