<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitetheme
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 2013-11-22 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitetheme_Api_Core extends Core_Api_Abstract {
  
  /**
   * Truncat the string
   * @param string $string : string which turncate
   * @param int $length : length of string after it turncate default 16
   * @return string
   */
  public function truncation($string, $length = 16) {
    $string = strip_tags($string);
    return Engine_String::strlen($string) > $length ? Engine_String::substr($string, 0, ($length - 3)) . '...' : $string;
  }
  
  public function markMessageReadUnread($conversation_id, $is_read = false)
  {
    if( empty($is_read) )
      Engine_Api::_()->getDbtable('recipients', 'messages')->update(array('inbox_read' => 0), array('conversation_id =?' => $conversation_id));
    else
      Engine_Api::_()->getDbtable('recipients', 'messages')->update(array('inbox_read' => 1), array('conversation_id =?' => $conversation_id));
  }
  
  public function isThemeActivate($themeName){
    $table = Engine_Api::_()->getDbtable('themes', 'core');
    $name = $table->info('name');

    return $table->select()
                ->from($name, array('theme_id'))
                ->where('name = ?', $themeName)
                ->where('active = ?', 1)
                ->query()
                ->fetchAll();
  }

  public function getOldVersionImages($default){
        // Get available files
        $imgOptions = $default;
        $imageExtensions = array('gif', 'jpg', 'jpeg', 'png');

        $it = new DirectoryIterator(APPLICATION_PATH . '/public/admin/');
        foreach ($it as $file) {
            if ($file->isDot() || !$file->isFile())
                continue;
            $basename = basename($file->getFilename());
            if (!($pos = strrpos($basename, '.')))
                continue;
            $ext = strtolower(ltrim(substr($basename, $pos), '.'));
            if (!in_array($ext, $imageExtensions))
                continue;
            $imgOptions['public/admin/' . $basename] = $basename;
        }
        return $imgOptions;
    }


    public function getNewVersionImages($default){
        $params = array();
        $params['extension'] = array('gif', 'jpg', 'jpeg', 'png');
        $filesTable = Engine_Api::_()->getDbTable('files','core');
        $select = $filesTable->getFiles($params);
        $fileData = $filesTable->fetchAll($select);
        $imgOptions = $default;
        foreach ($fileData as $key => $value) {
            $imgOptions[$value->storage_path] =  $value->name;
        }
        return $imgOptions;
    }

    public function getImages($first = array(0 => 'No Image')){
        $coreVersion = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core')->version;
        $checkVersion = Engine_Api::_()->seaocore()->checkVersion($coreVersion, '5.0.0p1');
        // changes in calling of function on the basis of core version
        if($checkVersion) {
          return $this->getNewVersionImages($first);
        } else {
          return $this->getOldVersionImages($first);
        }
    }
  
}