<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitetheme
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Customization.php 2013-11-22 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitetheme_Form_Admin_Customization extends Engine_Form {

  public function init() {

    $this->setTitle( sprintf( Zend_Registry::get( 'Zend_Translate' )->_( "Theme Customization" ) ) );

    // Get available files
//    $logoOptions = array( '' => 'Default Background' );
    $logoOptions = Engine_Api::_()->sitetheme()->getImages(array());

    $this->addElement( 'Radio', 'theme_customization', array(
        'label' => 'Select Theme Color',
        'multiOptions' => array(
            0 => 'DEFAULT',
            1 => 'BLUE',
            2 => 'GREEN',
            4 => 'RED',
            5 => 'ORANGE',
            6 => 'LIGHTPINK',
            7 => 'LIME',
            8 => 'DARKBLUE',
            9 => 'YELLOW',
            10 => 'VOILET',
            3 => 'Custom Colors (Choosing this option will enable you to customize your theme according to your site.)'
        ),
        'onchange' => 'changeThemeCustomization();',
        'value' => Engine_Api::_()->getApi( 'settings', 'core' )->getSetting( 'theme.customization', 0 ),
    ) );


    $this->addElement( 'Text', 'sitetheme_theme_color', array(
        'decorators' => array( array( 'ViewScript', array(
                    'viewScript' => '_themeColor.tpl',
                    'class' => 'form element'
                ) ) )
    ) );
    
    $this->addElement( 'Text', 'sitetheme_background_color', array(
        'decorators' => array( array( 'ViewScript', array(
                    'viewScript' => '_formThemeBackground.tpl',
                    'class' => 'form element'
                ) ) )
    ) );

    $this->addElement( 'Text', 'sitetheme_main_menu_hover_color', array(
        'decorators' => array( array( 'ViewScript', array(
                    'viewScript' => '_themeMainMenuHoverColor.tpl',
                    'class' => 'form element'
                ) ) )
    ) );

    $this->addElement( 'Text', 'sitetheme_links_color', array(
        'decorators' => array( array( 'ViewScript', array(
                    'viewScript' => '_themeLinksColor.tpl',
                    'class' => 'form element'
                ) ) )
    ) );

		
		$this->addElement('Dummy', 'dummy_theme_background_image', array(
            'decorators' => array(array('ViewScript', array(
                        'viewScript' => '_formElementsHeading.tpl',
                        'heading' => 'Other Settings',
                        'class' => 'form element'
                    ))),
        ));


    $this->addElement( 'Radio', 'need_sitetheme_background', array(
        'label' => 'Theme Background Image',
        'description' => 'Do you want to apply a background image to your theme? [If enabled, you will be able to choose background image for your theme from the below dropdown.]<br /> [Recommendation: The uploaded image will repeat in the background, so you are recommended to upload a texture based image.]',
        'multiOptions' => array(
            1 => 'Yes',
            0 => 'No'
        ),
        'onchange' => 'needThemeBackground()',
        'value' => Engine_Api::_()->getApi( 'settings', 'core' )->getSetting( 'need.sitetheme.background', 0 ),
    ) );
    $this->need_sitetheme_background->getDecorator('Description')->setOption('escape', false);
    
    
    $this->addElement( 'Select', 'sitetheme_background_image', array(
        'label' => 'Background Image',
        'description' => 'You need to upload the images under ‘File & Media Manager’ for making it available in the below dropdown [Note: Only .jpg, .jpeg and .png file type will be visible in the below dropdown.]',
        'multiOptions' => $logoOptions,
        'value' => Engine_Api::_()->getApi( 'settings', 'core' )->getSetting( 'sitetheme.background.image', '' ),
    ) );    


    $this->addElement( 'Button', 'submit', array(
        'label' => 'Submit',
        'type' => 'submit',
        'decorators' => array(
            'ViewHelper',
        ),
    ) );
  }

}