<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitetheme
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Searchbox.php 2013-11-22 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitetheme_Form_Searchbox extends Engine_Form {

  protected $_isMainMenu;
  
  public function setIsMainMenu($id) {
    $this->_isMainMenu = $id;
    return $this;
  }
  
  public function init() {
    
    $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
    
    if( empty($this->_isMainMenu) ) {
      $formId = 'miniMenuProductSearchForm';
      $searchContainerId = 'miniMenuProductSearch';
      $placeHolderContent = $view->translate('Search Products...');
    }else {
      $formId = 'mainMenuProductSearchForm';
      $searchContainerId = 'mainMenuProductSearch';
      $placeHolderContent = $view->translate('Search...');
    }

    $this->setAttribs(array(
        'id' => $formId,
        'method' => 'GET',
    ));
    $this->setAction($view->url(array('action' => 'index'), "sitestoreproduct_general", true))->getDecorator('HtmlTag');

    $this->addElement('Text', $searchContainerId, array(
        'label' => '',
        'placeholder' => $placeHolderContent,
        'autocomplete' => 'off',
        'style' => "width:300px;",
        ));

//    $this->addElement('Hidden', 'product_id', array());

      $this->addElement('Button', 'submitButton', array(
          'label' => 'Search',
          'type' => 'submit',
          'ignore' => true,
          'onClick' => 'doSearching(this)',
      ));      
  }
}