<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitetheme
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 2013-11-22 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitetheme_Plugin_Core extends Zend_Controller_Plugin_Abstract {

    public function onRenderLayoutDefault($event) {
      
      $view = $event->getPayload();
      $view->headTranslate(array("Forgot Password?", "Login with Twitter", "Login with Facebook", "Mark as Read", "Mark as Unread"));

        $isActivate = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitetheme.isActivate', null);
        if (!empty($isActivate)) {
            $view = $event->getPayload();

        $view->headLink()->appendStylesheet((_ENGINE_SSL ? 'https://' : 'http://') .'fonts.googleapis.com/css?family=Roboto+Condensed')
												 ->appendStylesheet((_ENGINE_SSL ? 'https://' : 'http://') .'fonts.googleapis.com/css?family=Merriweather+Sans');

                     
            $view->headScript()
                    ->appendFile($view->layout()->staticBaseUrl . 'application/modules/Sitetheme/externals/scripts/core.js');


            $view->headScript()
                    ->appendFile($view->layout()->staticBaseUrl . 'externals/autocompleter/Observer.js')
                    ->appendFile($view->layout()->staticBaseUrl . 'externals/autocompleter/Autocompleter.js')
                    ->appendFile($view->layout()->staticBaseUrl . 'externals/autocompleter/Autocompleter.Local.js')
                    ->appendFile($view->layout()->staticBaseUrl . 'externals/autocompleter/Autocompleter.Request.js');

//    $view->headScript()
//      ->appendFile($view->layout()->staticBaseUrl . 'application/modules/Sitestoreproduct/externals/scripts/sitestoreproduct_zoom.js');
            //GET VIEWER ID
            $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();

            if (empty($viewer_id)) {
                $script = <<<EOF
          isUserLogin = false;
EOF;
            } else {
                $script = <<<EOF
          isUserLogin = true;
EOF;
            }

            $view->headScript()->appendScript($script);
        }
    }

}