<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitetheme
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminCustomizationController.php 2013-11-22 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitetheme_AdminCustomizationController extends Core_Controller_Action_Admin {

  private function _getCustomCSS( $values ) {
    $returnTheme = null;
    if ( !empty( $values ) && isset( $values['theme_customization'] ) ) {
      switch ( $values['theme_customization'] ) {
        case 0: // DEFAULT THEME
          $returnTheme .= 'theme_color: #3eaacd; theme_hover_color :#2a83a3; theme_topbar_color:#292929;theme_background_color:#fff; ';
          break;

        case 1: // BLUE COLOR BASED THEME
          $returnTheme .= 'theme_color: #005da4; theme_hover_color :#004B85; theme_topbar_color:#000000;theme_background_color:#e7e7e7; ';
          break;

        case 2: // GREEN COLOR BASED THEME
          $returnTheme .= 'theme_color: #038c7e; theme_hover_color :#007165; theme_topbar_color:#000000;theme_background_color:#eaeaea; ';
          break;

        case 4: // RED COLOR BASED THEME
          $returnTheme .= 'theme_color: #ff0000; theme_hover_color :#C60000; theme_topbar_color:#000000;theme_background_color:#f7f7f7; ';
          break;

        case 5: // ORANGE COLOR BASED THEME
          $returnTheme .= 'theme_color: #ec6901; theme_hover_color :#bc5300; theme_topbar_color:#181818;theme_background_color:#eeeeee; ';
          break;

        case 6: // LIGHTPINK COLOR BASED THEME
          $returnTheme .= 'theme_color: #e63c61; theme_hover_color :#d90f3a; theme_topbar_color:#1a1a1a;theme_background_color:#f7f7f7; ';
          break;

        case 7: // LIME COLOR BASED THEME
          $returnTheme .= 'theme_color: #b0bf0a; theme_hover_color :#909d00; theme_topbar_color:#000000;theme_background_color:#fff; ';
          break;

        case 8: // DARK BLUE COLOR BASED THEME
          $returnTheme .= 'theme_color: #005387; theme_hover_color :#062451; theme_topbar_color:#0a3151;theme_background_color:#f7f5ee; ';
          break;

        case 9: // YELLOW COLOR BASED THEME
          $returnTheme .= 'theme_color: #d49c00; theme_hover_color :#ad7f00; theme_topbar_color:#000000;theme_background_color:#fff; ';
          break;

        case 10: // VIOLET COLOR BASED THEME
          $returnTheme .= 'theme_color: #9351a6; theme_hover_color :#7c3490; theme_topbar_color:#1c1c1c;theme_background_color:#dcdcdc; ';
          break;

        case 3: // CUSTOM COLOR BASED THEME
          $returnTheme .= 'theme_color: ' . $values['sitetheme_theme_color'] . '; theme_hover_color :' . $values['sitetheme_main_menu_hover_color'] . '; theme_topbar_color: ' . $values['sitetheme_links_color'] . '; theme_background_color:' . $values['sitetheme_background_color'] . '; ';
          break;
      }
    }
    
    if ( !empty( $values['need_sitetheme_background'] ) ) {
      if ( !empty( $values['sitetheme_background_image'] ) )
        $returnTheme .= "theme_background_image: url(../../../" . $values['sitetheme_background_image'] . ");";
    }

    return $returnTheme;
  }

  public function indexAction() {
    $this->view->navigation = Engine_Api::_()->getApi( 'menus', 'core' )
            ->getNavigation( 'sitetheme_admin_main', array( ), 'sitetheme_admin_theme_customization' );

    $this->view->form = $form = new Sitetheme_Form_Admin_Customization();

    if ( !$this->getRequest()->isPost() )
      return;

    if ( !$form->isValid( $this->getRequest()->getPost() ) )
      return;

    $values = $form->getValues();

    $getCustomCSS = $this->_getCustomCSS( $values );
    $global_directory_name = APPLICATION_PATH . '/public/seaocore_themes';
    $global_settings_file = $global_directory_name . '/sitethemeThemeConstants.css';
    $is_file_exist = @file_exists( $global_settings_file );
    if ( empty( $is_file_exist ) ) {
      if ( !is_dir( $global_directory_name ) ) {
        @mkdir( $global_directory_name, 0777 );
      }
      @chmod( $global_directory_name, 0777 );

      $fh = @fopen( $global_settings_file, 'w' ) or die( 'Unable to write Constant CSS file; please give the CHMOD 777 recursive permission to the directory /public/, then try again.' );
      @fwrite( $fh, $getCustomCSS );
      @fclose( $fh );

      @chmod( $global_settings_file, 0777 );
      $successfullyAdded = true;
    } else {
      if ( !is_writable( $global_settings_file ) ) {
        @chmod( $global_settings_file, 0777 );
        if ( !is_writable( $global_settings_file ) ) {
          $form->addError( 'Unable to write Constant CSS file; please give the CHMOD 777 recursive permission to the directory /public/seaocore_themes/, then try again.' );
          return;
        }
      }
      $successfullyAdded = @file_put_contents( $global_settings_file, $getCustomCSS );
    }

    unset( $values['dummy_theme_background_color'] );

    foreach ( $values as $key => $value ) {
      if ( isset( $value ) )
        Engine_Api::_()->getApi( 'settings', 'core' )->setSetting( $key, $value );
    }

    if ( !empty( $successfullyAdded ) ) {
      Core_Model_DbTable_Themes::clearScaffoldCache();

      $form->addNotice( 'Changes successfully saved. If changes not reflect to frontend then please change the mode to Development.' );
    }
  }

}
