<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitetheme
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 2013-11-22 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
$URL = $view->baseUrl() . "/admin/files";
$click = '<a href="' . $URL . '" target="_blank">over here</a>';

$isSiteadvsearchModuleEnable = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('siteadvsearch');
if (!empty($isSiteadvsearchModuleEnable)) {
  $isAdvancedSearchElement = array(
      'Radio',
      'adv_search_box',
      array(
          'label' => "Do you want to display 'Advanced Search Box' on scroll in this widget?",
          'multiOptions' => array(
              1 => 'Yes',
              0 => 'No',
          ),
          'value' => 1,
      )
  );
}  else {
  $isAdvancedSearchElement = array();
}


$final_array = array(
	 array(
      'title' => 'Shopping Hub - Social Links',
      'description' => sprintf('Enter details for social links. (Upload small icons for social links %s. The ideal dimensions of these icons are: 32 X 32 px. (Once you upload a new icon at the link mentioned, then reedit this widget to see them in the icon drop-downs below.) If you do not want to show your social link to any website, then simply leave the corresponding URL field empty.)', $click),
      'category' => 'Shopping Hub - a Social Commerce Theme',
      'type' => 'widget',
      'name' => 'sitetheme.social-links',
      'adminForm' => 'Sitetheme_Form_SocialLinks', 
        ),
    array(
        'title' => 'Shopping Hub - Mini Navigation Menu',
        'description' => 'Shows the site-wide mini menu. You can edit its contents in your menu editor.',
        'category' => 'Shopping Hub - a Social Commerce Theme',
        'type' => 'widget',
        'name' => 'sitetheme.menu-mini',
        'requirements' => array(
            'header-footer',
        ),
            'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'no_of_updates',
                    array(
                        'label' => 'Count',
                        'description' => 'No. of Friend Requests, Messages and Notifications to show.',
                        'value' => 10
                    )
                ),
                array(
                    'Radio',
                    'sitetheme_enable_signup_lightbox',
                    array(
                        'label' => 'Enabled lightbox for Sign Up?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'Value' => 1
                    )
                ),
            )
        )
    ),
    array(
    'title' => 'Shopping Hub - Footer Menu',
    'description' => 'Shows the site-wide footer menu. You can edit its contents in your menu editor.',
    'category' => 'Shopping Hub - a Social Commerce Theme',
    'type' => 'widget',
    'name' => 'sitetheme.menu-footer',
    'requirements' => array(
      'header-footer',
    ),
  ),array(
    'title' => 'Shopping Hub - Auto-suggest search for Products',
    'description' => 'Displays auto-suggest search box for Products. As user types, Products will be displayed in an auto-suggest box.',
    'category' => 'Shopping Hub - a Social Commerce Theme',
    'type' => 'widget',
    'name' => 'sitetheme.searchbox-sitestoreproduct',
    'adminForm' => array(
        'elements' => array(
            array(
                'Radio',
                'productSearch',
                array(
                    'label' => 'Search for Products',
                    'description' => "Do you want to display only products in the search results?",
                    'multiOptions' => array('1' => 'Yes, display only products.', '0' => 'No, display all results.'),
                    'value' => 1
                )
            ),
        )
    )
  ),
	array(
    'title' => 'Shopping Hub - Store Features Highlighting Block',
    'description' => 'Shopping Hub - Store Features Highlighting Block',
    'category' => 'Shopping Hub - a Social Commerce Theme',
    'type' => 'widget',
    'name' => 'sitetheme.footer-badges',
  ),
    array(
        'title' => 'Shopping Hub - Main Navigation Menu',
        'description' => 'Shows the site-wide main menu. You can edit its contents in your menu editor.',
        'category' => 'Shopping Hub - a Social Commerce Theme',
        'type' => 'widget',
        'name' => 'sitetheme.menu-main',
        'requirements' => array(
            'header-footer',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'no_of_category',
                    array(
                        'label' => 'How many categories you want to show?',
                        'description' => 'Enter 0 for display all categories.',
                        'value' => 5
                    )
                ),
                array(
                    'Radio',
                    'more_link',
                    array(
                        'label' => "Do you want to display 'More' link in this widget?",
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No',
                        ),
                        'value' => 1,
                    )
                ),
                array(
                    'Radio',
                    'apps_link',
                    array(
                        'label' => "Do you want to display 'Apps' link in this widget?",
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No',
                        ),
                        'value' => 1,
                    )
                ),
                $isAdvancedSearchElement
            )
        )
    ),
);

return $final_array;
