<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitetheme
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 2013-11-22 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitetheme_Installer extends Engine_Package_Installer_Module {

  function onPreInstall() {
    $db = $this->getDb();

    $getErrorMsg = $this->getVersion();
    if ( !empty($getErrorMsg) ) {
      return $this->_error($getErrorMsg);
    }

    //CHECK THAT SITESTORE PLUGIN IS ACTIVATED OR NOT
    $select = new Zend_Db_Select($db);
    $sitestore_settings = $select->from('engine4_core_settings')
                    ->where('name = ?', 'sitestore.is.active')
                    ->limit(1)->query()->fetchAll();

    if ( !empty($sitestore_settings) ) {
      $sitestore_is_active = $sitestore_settings[0]['value'];
    } else {
      $sitestore_is_active = 0;
    }

    //CHECK THAT SITESTORE PLUGIN IS INSTALLED OR NOT
    $select = new Zend_Db_Select($db);
    $check_sitestore = $select->from('engine4_core_modules')
                    ->where('name = ?', 'sitestore')
                    ->where('enabled = ?', 1)
                    ->query()->fetchObject();

    if ( !empty($check_sitestore) && !empty($sitestore_is_active) ) {
      $PRODUCT_TYPE = 'sitetheme';
      $PLUGIN_TITLE = 'Sitetheme';
      $PLUGIN_VERSION = '5.9.0';
      $PLUGIN_CATEGORY = 'plugin';
      $PRODUCT_DESCRIPTION = 'Shopping Hub - a Social Commerce Theme';
      $_PRODUCT_FINAL_FILE = 0;
      $SocialEngineAddOns_version = '4.8.9p12';
      $PRODUCT_TITLE = 'Shopping Hub - a Social Commerce Theme';
      $file_path = APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/ilicense.php";
      $is_file = @file_exists($file_path);

      if ( empty($is_file) ) {
        include APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/license3.php";
      } else {
        $select = new Zend_Db_Select($db);
        $select->from('engine4_core_modules')->where('name = ?', $PRODUCT_TYPE);
        $is_Mod = $select->query()->fetchObject();
        if ( empty($is_Mod) ) {
          include_once $file_path;
        }
      }
      parent::onPreInstall();
    } elseif ( !empty($check_sitestore) && empty($sitestore_is_active) ) {
      $baseUrl = $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getBaseUrl();
      $url_string = Zend_Controller_Front::getInstance()->getRequest()->getRequestUri();
      if ( strstr($url_string, "manage/install") ) {
        $calling_from = 'install';
      } else if ( strstr($url_string, "manage/query") ) {
        $calling_from = 'queary';
      }
      $explode_base_url = explode("/", $baseUrl);
      foreach ( $explode_base_url as $url_key ) {
        if ( $url_key != 'install' ) {
          $core_final_url .= $url_key . '/';
        }
      }

      return $this->_error("<span style='color:red'>Note: You have installed the <a href='http://www.socialengineaddons.com/socialengine-stores-marketplace-ecommerce-plugin' target='_blank'>Stores / Marketplace - Ecommerce Plugin</a> but not activated it on your site yet. Please activate it first before installing the Shopping Hub - a Social Commerce Theme.</span><br/> <a href='" . 'http://' . $core_final_url . "admin/sitestore/settings/readme'>Click here</a> to activate the Stores / Marketplace - Ecommerce Plugin.");
    } else {
      $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();
      return $this->_error("<span style='color:red'>Note: You have not installed the <a href='http://www.socialengineaddons.com/socialengine-stores-marketplace-ecommerce-plugin' target='_blank'>Stores / Marketplace - Ecommerce Plugin</a> on your site yet. Please install it first before installing the Shopping Hub - a Social Commerce Theme.</span><br/> <a href='" . $base_url . "/manage'>Click here</a> to go Manage Packages.");
    }
  }

  public function onInstall() {
    $db = $this->getDb();

    // Create `customization.css` file in `application/themes/shoppinghub` directory.
    $this->_createCustomizationFileInTheme("shoppinghub");

    //CHECK THAT SITESTORE PLUGIN IS ACTIVATED OR NOT
    $select = new Zend_Db_Select($db);
    $isSitethemeActive = $select->from('engine4_core_settings')
                    ->where('name = ?', 'sitetheme.isActivate')
                    ->limit(1)->query()->fetchAll();
    if ( !empty($isSitethemeActive) ) {
      $db->query('
          INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES  
          ("sitetheme_admin_theme_customization", "sitetheme", "Theme Customization", "", \'{"route":"admin_default","module":"sitetheme","controller":"customization"}\', "sitetheme_admin_main", "", 1, 0, 2);
          ');
    }

    $global_directory_name = APPLICATION_PATH . '/public/seaocore_themes';
    $global_settings_file = $global_directory_name . '/sitethemeThemeConstants.css';
    $is_file_exist = @file_exists($global_settings_file);
    if ( empty($is_file_exist) ) {
      if ( !is_dir($global_directory_name) ) {
        @mkdir($global_directory_name, 0777);
      }
      @chmod($global_directory_name, 0777);

      $fh = @fopen($global_settings_file, 'w');
      @fwrite($fh, '');
      @fclose($fh);

      @chmod($global_settings_file, 0777);
    }

    $db->query("UPDATE  `engine4_seaocores` SET  `is_activate` =  '1' WHERE  `engine4_seaocores`.`module_name` ='sitetheme';");

    // ADD SHOW COLUMN IN NOTIFICATION TABLE
    $isNotificationTableExist = $db->query("SHOW TABLES LIKE 'engine4_activity_notifications'")->fetch();
    if ( !empty($isNotificationTableExist) ) {
      $column_exist = $db->query("SHOW COLUMNS FROM engine4_activity_notifications LIKE 'show'")->fetch();
      if ( empty($column_exist) ) {
        $db->query("ALTER TABLE `engine4_activity_notifications` ADD `show` TINYINT( 1 ) NOT NULL DEFAULT '0'");
      }
    }

    // ADD VIEW COLUMN IN MESSAGE TABLE
    $isMessageTableExist = $db->query("SHOW TABLES LIKE 'engine4_messages_recipients'")->fetch();
    if ( !empty($isMessageTableExist) ) {
      $column_exist = $db->query("SHOW COLUMNS FROM engine4_messages_recipients LIKE 'inbox_view'")->fetch();
      if ( empty($column_exist) ) {
        $db->query("ALTER TABLE `engine4_messages_recipients` ADD `inbox_view` TINYINT( 1 ) NOT NULL DEFAULT '0'");
      }
    }


    // INSERT STYLE TIPS LINK IN FOOTER MENU
    // IS SITEREVIEW PLUGIN ENABLE
    $isSitereviewModuleEnable = $db->select()
            ->from('engine4_core_modules', 'name')
            ->where('name = ?', 'sitereview')
            ->where('enabled = ?', '1')
            ->limit(1)
            ->query()
            ->fetchColumn();

    if ( !empty($isSitereviewModuleEnable) ) {
      $isBlogListingTypeModuleEnable = $db->select()
              ->from('engine4_sitereview_listingtypes')
              ->where('title_plural LIKE ?', 'Blogs')
              ->where('visible = ?', '1')
              ->limit(1)
              ->query()
              ->fetch();

      if ( !empty($isBlogListingTypeModuleEnable) ) {
        $db->query("INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ('sitetheme_footer_styletips', 'sitetheme', 'Style Tips', 'Sitetheme_Plugin_Menus::canViewSitereviews', '{\"listingtype_id\":\"$isBlogListingTypeModuleEnable->listingtype_id\"}', 'sitetheme_footer', NULL, '1', '0', '13')");
      }
    } else {
      $isBlogModuleEnable = $db->select()
              ->from('engine4_core_modules', 'name')
              ->where('name = ?', 'blog')
              ->where('enabled = ?', '1')
              ->limit(1)
              ->query()
              ->fetchColumn();

      if ( !empty($isBlogModuleEnable) ) {
        $db->query("INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ('sitetheme_footer_styletips', 'sitetheme', 'Style Tips', 'Sitetheme_Plugin_Menus::canViewBlogs', '', 'sitetheme_footer', NULL, '1', '0', '13')");
      }
    }

    parent::onInstall();
  }

  private function _createCustomizationFileInTheme($themeName) {
    $global_directory_name = APPLICATION_PATH . '/application/themes/' . $themeName;
    @chmod($global_directory_name, 0777);

    if ( !is_readable($global_directory_name) ) {
      return $this->_error("<span style='color:red'>Note: You do not have readable permission on the path below, please give 'chmod 777 recursive permission' on it to continue with the installation process : <br /> 
    Path Name: <b>" . $global_directory_name . "</b></span>");
    }

    $global_settings_file = $global_directory_name . '/customization.css';
    $is_file_exist = @file_exists($global_settings_file);
    if ( empty($is_file_exist) ) {
      @chmod($global_directory_name, 0777);
      if ( !is_writable($global_directory_name) ) {
        return $this->_error("<span style='color:red'>Note: You do not have writable permission on the path below, please give 'chmod 777 recursive permission' on it to continue with the installation process : <br /> 
    Path Name: " . $global_directory_name . "</span>");
      }

      $fh = @fopen($global_settings_file, 'w');
      @fwrite($fh, '/* ADD CUSTOM STYLE */');
      @fclose($fh);

      @chmod($global_settings_file, 0777);
    }
  }

  function onEnable() {
    $db = $this->getDb();

    // REPLACE CORE MINI AND MAIN MENU BY SITETHEME MINI AND MAIN MENU
    $headerPageId = $db->select()
            ->from('engine4_core_pages', 'page_id')
            ->where('name = ?', 'header')
            ->limit(1)
            ->query()
            ->fetchColumn();

    if ( !empty($headerPageId) ) {
      $isSitethemeMiniMenuExist = $db->select()
              ->from('engine4_core_content', 'content_id')
              ->where('page_id = ?', $headerPageId)
              ->where('name = ?', 'sitetheme.menu-mini')
              ->limit(1)
              ->query()
              ->fetchColumn();

      if ( empty($isSitethemeMiniMenuExist) )
        $db->query("UPDATE `engine4_core_content` SET `name` = 'sitetheme.menu-mini' WHERE `engine4_core_content`.`name` = 'core.menu-mini' LIMIT 1 ");

      $isSitethemeMainMenuExist = $db->select()
              ->from('engine4_core_content', 'content_id')
              ->where('page_id = ?', $headerPageId)
              ->where('name = ?', 'sitetheme.menu-main')
              ->limit(1)
              ->query()
              ->fetchColumn();

      if ( empty($isSitethemeMainMenuExist) )
        $db->query("UPDATE `engine4_core_content` SET `name` = 'sitetheme.menu-main' WHERE `engine4_core_content`.`name` = 'core.menu-main' LIMIT 1 ");
    }

    // ADD SITETHEME FOOTER MENU
    $footerPageId = $db->select()
            ->from('engine4_core_pages', 'page_id')
            ->where('name = ?', 'footer')
            ->limit(1)
            ->query()
            ->fetchColumn();

    if ( !empty($footerPageId) ) {
      $isSitethemeFooterMenuExist = $db->select()
              ->from('engine4_core_content', 'content_id')
              ->where('page_id = ?', $footerPageId)
              ->where('name = ?', 'sitetheme.menu-footer')
              ->limit(1)
              ->query()
              ->fetchColumn();

      if ( empty($isSitethemeFooterMenuExist) ) {
        $parentContentId = $db->select()
                ->from('engine4_core_content', 'content_id')
                ->where('page_id = ?', $footerPageId)
                ->where('name = ?', 'main')
                ->where('type =?', 'container')
                ->limit(1)
                ->query()
                ->fetchColumn();

        if ( !empty($parentContentId) ) {
          $db->insert('engine4_core_content', array(
              'page_id' => $footerPageId,
              'type' => 'widget',
              'name' => 'sitetheme.menu-footer',
              'parent_content_id' => $parentContentId,
              'order' => 1,
              'params' => '',
              'attribs' => 'sitetheme_main'
          ));
        }
      }

      // ---------------------------------

      $isSitethemeSocialLinksExist = $db->select()
              ->from('engine4_core_content', 'content_id')
              ->where('page_id = ?', $footerPageId)
              ->where('name = ?', 'sitetheme.social-links')
              ->limit(1)
              ->query()
              ->fetchColumn();

      if ( empty($isSitethemeSocialLinksExist) ) {
        $parentContentId = $db->select()
                ->from('engine4_core_content', 'content_id')
                ->where('page_id = ?', $footerPageId)
                ->where('name = ?', 'main')
                ->where('type =?', 'container')
                ->limit(1)
                ->query()
                ->fetchColumn();

        if ( !empty($parentContentId) ) {
          $db->insert('engine4_core_content', array(
              'page_id' => $footerPageId,
              'type' => 'widget',
              'name' => 'sitetheme.social-links',
              'parent_content_id' => $parentContentId,
              'order' => 3,
              'params' => '{"facebook":null,"facebook_url":"http:\/\/www.facebook.com\/","facebook_default_icon":"application\/modules\/Sitetheme\/externals\/images\/facebook.png","facebook_hover_icon":"application\/modules\/Sitetheme\/externals\/images\/overfacebook.png","facebook_title":"Like us on Facebook","pinterest":null,"pinterest_url":"https:\/\/www.pinterest.com\/","pinterest_default_icon":"application\/modules\/Sitetheme\/externals\/images\/pinterest.png","pinterest_hover_icon":"application\/modules\/Sitetheme\/externals\/images\/overpinterest.png","pinterest_title":"Pinterest","twitter":null,"twitter_url":"https:\/\/www.twitter.com\/","twitter_default_icon":"application\/modules\/Sitetheme\/externals\/images\/twitter.png","twitter_hover_icon":"application\/modules\/Sitetheme\/externals\/images\/overtwitter.png","twitter_title":"Follow us on Twitter","youtube":null,"youtube_url":"http:\/\/www.youtube.com\/","youtube_default_icon":"application\/modules\/Sitetheme\/externals\/images\/youtube.png","youtube_hover_icon":"application\/modules\/Sitetheme\/externals\/images\/overyoutube.png","youtube_title":"Youtube","linkedin":null,"linkedin_url":"https:\/\/www.linkedin.com\/","linkedin_default_icon":"application\/modules\/Sitetheme\/externals\/images\/linkedin.png","linkedin_hover_icon":"application\/modules\/Sitetheme\/externals\/images\/overlinkedin.png","linkedin_title":"LinkedIn","title":"","nomobile":"0","name":"sitetheme.social-links"}'                            
          ));
        }
      }
    }

    parent::onEnable();
  }

  function onDisable() {
    $db = $this->getDb();

    // REPLACE SITETHEME MINI AND MAIN MENU BY CORE MINI AND MAIN MENU
    $headerPageId = $db->select()
            ->from('engine4_core_pages', 'page_id')
            ->where('name = ?', 'header')
            ->limit(1)
            ->query()
            ->fetchColumn();

    if ( !empty($headerPageId) ) {
      $isCoreMiniMenuExist = $db->select()
              ->from('engine4_core_content', 'content_id')
              ->where('page_id = ?', $headerPageId)
              ->where('name = ?', 'core.menu-mini')
              ->limit(1)
              ->query()
              ->fetchColumn();

      if ( empty($isCoreMiniMenuExist) )
        $db->query("UPDATE `engine4_core_content` SET `name` = 'core.menu-mini' WHERE `engine4_core_content`.`name` = 'sitetheme.menu-mini' LIMIT 1 ");

      $isCoreMainMenuExist = $db->select()
              ->from('engine4_core_content', 'content_id')
              ->where('page_id = ?', $headerPageId)
              ->where('name = ?', 'core.menu-main')
              ->limit(1)
              ->query()
              ->fetchColumn();

      if ( empty($isCoreMainMenuExist) )
        $db->query("UPDATE `engine4_core_content` SET `name` = 'core.menu-main' WHERE `engine4_core_content`.`name` = 'sitetheme.menu-main' LIMIT 1 ");
    }

    // REMOVE SITETHEME FOOTER MENU
    $footerPageId = $db->select()
            ->from('engine4_core_pages', 'page_id')
            ->where('name = ?', 'footer')
            ->limit(1)
            ->query()
            ->fetchColumn();

    if ( !empty($footerPageId) ) {
      $parentContentId = $db->select()
              ->from('engine4_core_content', 'content_id')
              ->where('page_id = ?', $footerPageId)
              ->where('name = ?', 'main')
              ->where('type =?', 'container')
              ->limit(1)
              ->query()
              ->fetchColumn();

      if ( !empty($parentContentId) ) {
        $isSitethemeFooterMenuExist = $db->select()
                ->from('engine4_core_content', 'content_id')
                ->where('page_id = ?', $footerPageId)
                ->where('name = ?', 'sitetheme.menu-footer')
                ->limit(1)
                ->query()
                ->fetchColumn();

        if ( !empty($isSitethemeFooterMenuExist) ) {
          $db->query("DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`name` = 'sitetheme.menu-footer' AND `engine4_core_content`.`parent_content_id` = $parentContentId  AND `engine4_core_content`.`page_id` = $footerPageId  AND `engine4_core_content`.`type` = 'widget' LIMIT 1");
        }

        $isSitethemeSocialLinksExist = $db->select()
                ->from('engine4_core_content', 'content_id')
                ->where('page_id = ?', $footerPageId)
                ->where('name = ?', 'sitetheme.social-links')
                ->limit(1)
                ->query()
                ->fetchColumn();

        if ( !empty($isSitethemeSocialLinksExist) ) {
          $db->query("DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`name` = 'sitetheme.social-links' AND `engine4_core_content`.`parent_content_id` = $parentContentId  AND `engine4_core_content`.`page_id` = $footerPageId  AND `engine4_core_content`.`type` = 'widget' LIMIT 1");
        }
      }
    }

    // ENABLE PRIVACY FOOTER MENU OF CORE
    $isCoreFooterMenuExist = $db->select()
            ->from('engine4_core_menuitems', 'name')
            ->where('name = ?', 'core_footer_privacy')
            ->where('menu = ?', 'core_footer')
            ->limit(1)
            ->query()
            ->fetchColumn();

    if ( !empty($isCoreFooterMenuExist) ) {
      $db->query("UPDATE `engine4_core_menuitems` SET `enabled` = '1' WHERE `engine4_core_menuitems`.`name` ='core_footer_privacy' LIMIT 1 ;");
    }

    // ENABLE TERMS OF SERVICE FOOTER MENU OF CORE
    $isCoreTermsMenuExist = $db->select()
            ->from('engine4_core_menuitems', 'name')
            ->where('name = ?', 'core_footer_terms')
            ->where('menu = ?', 'core_footer')
            ->limit(1)
            ->query()
            ->fetchColumn();

    if ( !empty($isCoreTermsMenuExist) ) {
      $db->query("UPDATE `engine4_core_menuitems` SET `enabled` = '1' WHERE `engine4_core_menuitems`.`name` ='core_footer_terms' LIMIT 1 ;");
    }

    parent::onDisable();
  }

  private function getVersion() {

    $db = $this->getDb();

    $errorMsg = '';
    $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();

    $modArray = array(
        'sitestore' => '4.8.3',
    );

    $finalModules = array();
    foreach ( $modArray as $key => $value ) {
      $select = new Zend_Db_Select($db);
      $select->from('engine4_core_modules')
              ->where('name = ?', "$key")
              ->where('enabled = ?', 1);
      $isModEnabled = $select->query()->fetchObject();
      if ( !empty($isModEnabled) ) {
        $select = new Zend_Db_Select($db);
        $select->from('engine4_core_modules', array('title', 'version'))
                ->where('name = ?', "$key")
                ->where('enabled = ?', 1);
        $getModVersion = $select->query()->fetchObject();

        $isModSupport = $this->checkVersion($getModVersion->version, $value);
        if (empty($isModSupport)) {
          $finalModules[] = $getModVersion->title;
        }
      }
    }

    foreach ( $finalModules as $modArray ) {
      $errorMsg .= '<div class="tip"><span style="background-color: #da5252;color:#FFFFFF;">Note: You do not have the latest version of the "' . $modArray . '". Please upgrade "' . $modArray . '" on your website to the latest version available in your SocialEngineAddOns Client Area to enable its integration with "Shopping Hub - a Social Commerce Theme".<br/> Please <a class="" href="' . $base_url . '/manage">Click here</a> to go Manage Packages.</span></div>';
    }

    return $errorMsg;
  }
    private function checkVersion($databaseVersion, $checkDependancyVersion) {
        $f = $databaseVersion;
        $s = $checkDependancyVersion;
        if (strcasecmp($f, $s) == 0)
            return -1;

        $fArr = explode(".", $f);
        $sArr = explode('.', $s);
        if (count($fArr) <= count($sArr))
            $count = count($fArr);
        else
            $count = count($sArr);

        for ($i = 0; $i < $count; $i++) {
            $fValue = $fArr[$i];
            $sValue = $sArr[$i];
            if (is_numeric($fValue) && is_numeric($sValue)) {
                if ($fValue > $sValue)
                    return 1;
                elseif ($fValue < $sValue)
                    return 0;
                else {
                    if (($i + 1) == $count) {
                        return -1;
                    } else
                        continue;
                }
            }
            elseif (is_string($fValue) && is_numeric($sValue)) {
                $fsArr = explode("p", $fValue);

                if ($fsArr[0] > $sValue)
                    return 1;
                elseif ($fsArr[0] < $sValue)
                    return 0;
                else {
                    return 1;
                }
            } elseif (is_numeric($fValue) && is_string($sValue)) {
                $ssArr = explode("p", $sValue);

                if ($fValue > $ssArr[0])
                    return 1;
                elseif ($fValue < $ssArr[0])
                    return 0;
                else {
                    return 0;
                }
            } elseif (is_string($fValue) && is_string($sValue)) {
                $fsArr = explode("p", $fValue);
                $ssArr = explode("p", $sValue);
                if ($fsArr[0] > $ssArr[0])
                    return 1;
                elseif ($fsArr[0] < $ssArr[0])
                    return 0;
                else {
                    if ($fsArr[1] > $ssArr[1])
                        return 1;
                    elseif ($fsArr[1] < $ssArr[1])
                        return 0;
                    else {
                        return -1;
                    }
                }
            }
        }
    }
}