<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitetheme
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2013-11-22 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitetheme_Widget_MenuMainController extends Engine_Content_Widget_Abstract {

  public function indexAction() {
    
    $this->view->parentCategory = Engine_Api::_()->getApi('menus', 'core')->getNavigation("sitetheme_main");

    $this->view->sitestoreproductEnable = $sitestoreproductEnable = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitestoreproduct');
    $this->view->menuTypeId = Engine_Api::_()->getApi('settings', 'core')->getSetting("sitetheme.menutype.id");    

    if( !empty($sitestoreproductEnable) )
      $this->view->update_cart_notification = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestoreproduct.cart.update', 1);
    
    $this->view->noOfMenus = $this->_getParam('no_of_category', 5);
    $this->view->moreLink = $this->_getParam('more_link', 1);
    $this->view->appsLink = $this->_getParam('apps_link', 1);
    $temp_search_type = $this->_getParam('adv_search_box', 1);
    
    //WORK FOR ADVANCED SEARCH PLUGIN
    if(Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('siteadvsearch') && !empty($temp_search_type)){
      $temp_search_type = 1;
    }else{
      $temp_search_type = 0;
    }
    $this->view->adv_search_box = $temp_search_type;
		
    if( !empty($this->view->appsLink) )
    {
      $this->view->navigation = $navigation = Engine_Api::_()
        ->getApi('menus', 'core')
        ->getNavigation('core_main');

      $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
      $require_check = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.general.browse', 1);
      if(!$require_check && !$viewer->getIdentity()){
        $navigation->removePage($navigation->findOneBy('route','user_general'));
      }
    }
    
    if ($this->view->viewDisplay) {
      $element = $this->getElement();
      $this->view->widgetTitle = $element->getTitle();
      $element->setTitle('');
    }

    $params = array();

    $this->view->sitethemeDisplayable = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitetheme.displayable', null);
    $this->view->isSitethemeMenusTabs = Engine_Api::_()->sitestore()->isSitethemeMenusTabs();
    $sitetheme_main_menu = Zend_Registry::isRegistered('sitetheme_main_menu') ? Zend_Registry::get('sitetheme_main_menu') : null;
    $beforeNavigation = $this->_getParam('beforeNavigation', 0);    
    if ($beforeNavigation || empty($sitetheme_main_menu)) {
      return $this->setNoRender();
    }

    //GET PRODUCT CATEGORY TABLE
    $this->view->tableCategory = $tableCategory = Engine_Api::_()->getDbTable('categories', 'sitestoreproduct');
    
    if( empty($category_id) ) {
      $categoriesArray = array();
      $categories = $tableCategory->getCategories(null, 0, 0, 1);
      foreach ($categories as $category) {
          $subcategoriesArray = $this->getSubCategory($category->category_id);
          $categoriesArray[$category->category_id] = array(
              'category' => $category,
              'subcategories' => $subcategoriesArray,
          );
      }    

     $this->view->categoriesArray = $categoriesArray;
    }else {
      $subcategoriesArray = $this->getSubCategory($category_id);
      $this->view->categoriesArray = $subcategoriesArray;
    }
        

    $this->view->requestAllParams = $requestAllParams = Zend_Controller_Front::getInstance()->getRequest()->getParams();
  }
  
  protected function getSubCategory($category_id) {
    $tableCategory = Engine_Api::_()->getDbTable('categories', 'sitestoreproduct');
        $subcategoriesArray = array();
        $subcategories = $tableCategory->getSubCategories($category_id);
        foreach ($subcategories as $subcategory) {
          $subsubcatgories = $tableCategory->getSubCategories($subcategory->category_id);
          $ssb_cat_count = count($subsubcatgories);
          if (empty($ssb_cat_count)) {
            $subsubcatgories = array();
          }
          $subcategoriesArray[$subcategory->category_id] = array(
              'subcategory' => $subcategory,
              'subsubcatgories' => $subsubcatgories
          );
        }
        return $subcategoriesArray;
}

}

