<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitetour
 * @copyright  Copyright 20007-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @author     SocialEngineAddOns
 */
class Sitetour_Controller_Action_Helper_ContentPageName extends Zend_Controller_Action_Helper_Abstract
{
  function postDispatch()
  {
    $contentHelper = Zend_Controller_Action_HelperBroker::getStaticHelper('Content');
    if( Zend_Registry::isRegistered('sitetour_content_name') && Zend_Registry::get('sitetour_content_name', false) ) {
      return;
    }
    if( $contentHelper->getEnabled() && Engine_Api::_()->getApi('settings', 'core')->getSetting('sitetour.enabled', 1) ) {
      $pageName = $contentHelper->getContentName();
      Zend_Registry::set('sitetour_content_name', $contentHelper->getContentName());
      $tour = Engine_Api::_()->getItemTable('sitetour_tour')->getTourByPageName($pageName);
      if( !empty($tour) && !empty($tour->enabled) ) {
        $content = Engine_Content::getInstance();
        if( get_class($content->getStorage()) === 'Core_Model_DbTable_Pages' ) {
          // Set storage
          $contentTable = Engine_Api::_()->getDbtable('pages', 'sitetour');
          $content->setStorage($contentTable);
        }
      }
    } else {
      Zend_Registry::set('sitetour_content_name', false);
    }
  }

}
