<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitetour
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Tour.php 6590 2016-07-07 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitetour_Model_Tour extends Core_Model_Item_Abstract
{

  protected $_searchTriggers = false;

  public function getTitle()
  {
    $page = $this->getPage();
    return $page ? ($page->displayname) : 'Page Deleted ';
  }

  public function getPage()
  {
    $pageTable = Engine_Api::_()->getItemTable('core_page');
    $select = $pageTable->select()->where('name = ?', $this->page_name)->orWhere('page_id = ?', $this->page_name);
    return $pageTable->fetchRow($select);
  }

  public function getSteps($params = array())
  {
    $stepTable = Engine_Api::_()->getItemTable('sitetour_step');
    $select = $stepTable->select()
      ->where('tour_id = ?', $this->tour_id)
      ->order('order ASC');
    if (!empty($params['enabled'])) {
      $select->where('enabled = ?', $params['enabled']);
    }
    return $stepTable->fetchAll($select);
  }
}
