<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitetutorial
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Level.php 6590 2012-18-05 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitetutorial_Form_Admin_Settings_Level extends Authorization_Form_Admin_Level_Abstract
{
  public function init()
  {
		parent::init();

		$this
			->setTitle('Member Level Settings')
			->setDescription("These settings are applied on a per member level basis. Start by selecting the member level you want to modify, then adjust the settings for that level below.");

		if( !$this->isPublic() ) {

			$this->addElement( 'Dummy' , 'dummy_sitetutorial_creation' , array ('label' => 'Creation Settings'));

			$this->addElement('Radio', 'create', array(
				'label' => 'Allow Creation of Tutorials',
				'description' => 'Should users of this Member Level be able to create Tutorials?',
				'multiOptions' => array(
					1 => 'Yes',
					0 => 'No'
				),
				'value' => ( $this->isModerator() ? 1 : 0 ),
			));

      $this->addElement('Radio', 'edit', array(
        'label' => 'Allow Editing of Tutorials?',
        'description' => 'Should users of this Member Level be able to edit Tutorials?',
        'multiOptions' => array(
          2 => 'Yes, allow members to edit everyone\'s Tutorials.',
          1 => 'Yes, allow  members to edit their own Tutorials.',
          0 => 'No, do not allow Tutorials to be edited.',
        ),
        'value' => ( $this->isModerator() ? 2 : 1 ),
      ));
      if( !$this->isModerator() ) {
        unset($this->edit->options[2]);
      }

      $this->addElement('Radio', 'delete', array(
        'label' => 'Allow Deletion of Tutorials?',
        'description' => 'Should users of this Member Level be able to delete Tutorials?',
        'multiOptions' => array(
          2 => 'Yes, allow members to delete everyone\'s Tutorials.',
          1 => 'Yes, allow  members to delete their own Tutorials.',
          0 => 'No, do not allow Tutorials to be deleted.',
        ),
        'value' => ( $this->isModerator() ? 2 : 1 ),
      ));
      if( !$this->isModerator() ) {
        unset($this->delete->options[2]);
      }

			$this->addElement('Radio', 'memberlevels', array(
				'label' => 'Member Level Options',
				'description' => "Should users of this Member Level be able to choose for each of their Tutorials, the Member Levels to whom their Tutorials should be visible? If enabled, the option for this will appear on the 'Create New Tutorial’ and ‘Edit Tutorial’ pages. If you select ‘No’ over here, then users of all Member Levels will be able to view Tutorials from this Member Level.",
				'multiOptions' => array(
					1 => 'Yes',
					0 => 'No'
				),
				'value' => ( $this->isModerator() ? 1 : 0 ),
			));

			$this->addElement('Radio', 'profiletypes', array(
				'label' => 'Profile Type Options',
				'description' => "Should users of this Member Level be able to choose for each of their Tutorials, the Profile Types to whom their Tutorials should be visible? If enabled, the option for this will appear on the 'Create New Tutorial’ and ‘Edit Tutorial’ pages. If you select ‘No’ over here, then users of all Profile Types will be able to view Tutorials from this Member Level.",
				'multiOptions' => array(
					1 => 'Yes',
					0 => 'No'
				),
				'value' => ( $this->isModerator() ? 1 : 0 ),
			));

			$this->addElement('Radio', 'networks', array(
				'label' => 'Network Options',
				'description' => "Should users of this Member Level be able to choose for each of their Tutorials, the Networks to whom their Tutorials should be visible? If enabled, the option for this will appear on the 'Create New Tutorial’ and ‘Edit Tutorial’ pages. If you select ‘No’ over here, then users of all Networks will be able to view Tutorials from this Member Level.",
				'multiOptions' => array(
					1 => 'Yes',
					0 => 'No'
				),
				'value' => 1,
			));

			$this->addElement('Radio', 'approved', array(
				'label' => 'Auto-Approve Tutorials',
				'description' => 'Auto-Approve Tutorials created by users of this Member Level? These Tutorials will not need admin moderation approval before going live.',
				'multiOptions' => array(
					1 => 'Yes',
					0 => 'No'
				),
				'value' => ( $this->isModerator() ? 1 : 0 ),
			));
		}

    $this->addElement( 'Dummy' , 'dummy_sitetutorial_general' , array ('label' => 'General Settings'));

		$this->addElement('Radio', 'view', array(
			'label' => 'Allow Viewing of Tutorials?',
			'description' => 'Should users of this Member Level be able to view Tutorials?',
			'multiOptions' => array(
				2 => 'Yes, allow viewing of all Tutorials, even private ones.',
				1 => 'Yes, allow viewing of Tutorials.',
				0 => 'No, do not allow Tutorials to be viewed.',
			),
			'value' => ( $this->isModerator() ? 2 : 1 ),
		));
		if( !$this->isModerator() ) {
			unset($this->view->options[2]);
		}

		$this->addElement('Radio', 'question', array(
			'label' => 'Allow Asking Questions',
			'description' => 'Should users of this Member Level be able to Ask Questions from you?',
			'multiOptions' => array(
				1 => 'Yes',
				0 => 'No'
			),
			'value' => 1,
		));

		if($this->isPublic()) {
			$this->addElement('Radio', 'helpful', array(
				'label' => 'Display Voting Options for Tutorials',
				'description' => 'Should users of this Member Level be able to view the voting options for Tutorials? (If you select ‘Yes’ over here, then users of this Member Level will be able to mark Tutorials as Helpful / Not Helpful. In case of Public Members, they will be redirected to sign-in page, when they try to vote on an Tutorial.)',
				'multiOptions' => array(
					1 => 'Yes',
					0 => 'No'
				),
				'value' => 1,
			));
		}

		if( !$this->isPublic() ) {

			$this->addElement('Radio', 'rating', array(
				'label' => 'Allow Rating of Tutorials',
				'description' => 'Should users of this Member Level be able to give rating to Tutorials?',
				'multiOptions' => array(
					1 => 'Yes',
					0 => 'No'
				),
				'value' => 1,
			));

			$this->addElement('Radio', 'helpful', array(
				'label' => 'Allow Marking Tutorials Helpful',
				'description' => 'Should users of this Member Level be able to mark Tutorials as helpful?',
				'multiOptions' => array(
					1 => 'Yes',
					0 => 'No'
				),
				'value' => 1,
			));

			$this->addElement('Radio', 'comment', array(
				'label' => 'Allow Commenting on Tutorials',
				'description' => 'Should users of this Member Level be able to comment on Tutorials?',
				'multiOptions' => array(
					1 => 'Yes',
					0 => 'No'
				),
				'value' => 1,
			));

			$this->addElement('Radio', 'share', array(
				'label' => 'Allow Sharing of Tutorials',
				'description' => 'Should users of this Member Level be able to share Tutorials?',
				'multiOptions' => array(
					1 => 'Yes',
					0 => 'No'
				),
				'value' => 1,
			));
		}
  }

}