<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitetutorial
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminFieldsController.php 6590 2012-18-05 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitetutorial_AdminFieldsController extends Fields_Controller_AdminAbstract
{
  protected $_fieldType = 'sitetutorial_tutorial';

  protected $_requireProfileType = false;

	//ACTION FOR MANAGING CUSTOM FIELDS
  public function indexAction()
  {
		//GET NAVIGATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sitetutorial_admin_main', array(), 'sitetutorial_admin_main_fields');

    parent::indexAction();
  }

	//ACTION FOR CREATING NEW FIELDS
  public function fieldCreateAction(){

	include APPLICATION_PATH . '/application/modules/Sitetutorial/controllers/license/license2.php';

		//FORM GENERATION
    $form = $this->view->form;

    if($form){
      $form->setTitle('Add Tutorials Question');

      $display = $form->getElement('display');
      $display->setLabel('Show on Tutorials page?');
      $display->setOptions(array('multiOptions' => array(
          1 => 'Show on Tutorials page',
          0 => 'Hide on Tutorials page'
        )));

      $search = $form->getElement('search');
      $search->setLabel('Show on the search options?');
      $search->setOptions(array('multiOptions' => array(
          0 => 'Hide on the search options',
          1 => 'Show on the search options'
        )));
    }
  }

	//ACTION FOR EDIT CREATED FIELDS
  public function fieldEditAction(){

    parent::fieldEditAction();

    //FORM GENERATION
    $form = $this->view->form;

    if($form){
      $form->setTitle('Edit Tutorial Question');

      $display = $form->getElement('display');
      $display->setLabel('Show on Tutorials page?');
      $display->setOptions(array('multiOptions' => array(
          1 => 'Show on Tutorials page',
          0 => 'Hide on Tutorials page'
        )));

      $search = $form->getElement('search');
      $search->setLabel('Show on the search options?');
      $search->setOptions(array('multiOptions' => array(
          0 => 'Hide on the search options',
          1 => 'Show on the search options'
        )));
    }
  }

}