<?php 
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitetutorial
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 6590 2012-18-05 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

	$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
	$category_sitetutorials_multioptions = array(
			'view_count' => $view->translate('Views'),
			'like_count' => $view->translate('Likes'),
			'comment_count' => $view->translate('Comments'),
	);

	$popularity_options = array(
			'view_count' => $view->translate('Most Viewed'),
			'like_count' => $view->translate('Most Liked'),
			'comment_count' => $view->translate('Most Commented'),
			'rating' => $view->translate('Most Rated'),
			'creation_date' => $view->translate('Most Recent'),
			'modified_date' => $view->translate('Recently Updated'),
			'helpful' => $view->translate('Most Helpful'),
			'weight' => $view->translate('Most Weighted'),
			'RAND()' => $view->translate('Random'),
	);

	$categories = Engine_Api::_()->getDbTable('categories', 'sitetutorial')->getCategories(null);
	$categories_prepared = array();
	if (count($categories) != 0) {
		$categories_prepared[0] = "";
		foreach ($categories as $category) {
			$categories_prepared[$category->category_id] = $category->category_name;
		}
	}

	return array(

		array(
			'title' => $view->translate('Navigation Tabs'),
			'description' => $view->translate('Displays the Navigation tabs: Tutorials having links of Tutorial Home, Browse Tutorials, etc. This widget should be placed at the top of Tutorial Home Page, Tutorial Browse Page and Tutorial Manage Page.'),
			'category' => $view->translate('Tutorials'),
			'type' => 'widget',
			'name' => 'sitetutorial.navigation-sitetutorials',
		),

		array(
			'title' => $view->translate('Add Tutorial'),
			'description' => $view->translate('Displays a `Add Tutorial` link.( Create link will be visible if user level is allowed to add Tutorials )'),
			'category' => $view->translate('Tutorials'),
			'type' => 'widget',
			'name' => 'sitetutorial.create-sitetutorials',
		),

		array(
			'title' => $view->translate('Browse Tutorials'),
			'description' => $view->translate('Displays a list of all the Tutorials on site. This widget should be placed on the Tutorial Browse Page.'),
			'category' => $view->translate('Tutorials'),
			'type' => 'widget',
			'name' => 'sitetutorial.browse-sitetutorials',
			'defaultParams' => array(
				'title' => '',
				'titleCount' => true,
				'orderby' => 'tutorial_id'
			),
			'adminForm' => array(
					'elements' => array(
						array(
								'Radio',
								'linked',
								array(
										'label' => $view->translate("Do you want the Title of Tutorial to be a link? (Note: If you select ‘Yes’ over here, then Tutorial will not be expanded / hide when clicked and will redirect users to the Tutorial View Page.)"),
										'multiOptions' => array(
												1 => 'Yes',
												0 => 'No'
										),
										'value' => 0,
								)
						),
						array(
								'Radio',
								'print',
								array(
										'label' => $view->translate('Show print option.'),
										'multiOptions' => array(
												1 => 'Yes',
												0 => 'No'
										),
										'value' => 1,
								)
						),
						array(
								'Radio',
								'statisticsRating',
								array(
										'label' => $view->translate('Show Rating.'),
										'multiOptions' => array(
												1 => 'Yes',
												0 => 'No'
										),
										'value' => 1,
								)
						),
						array(
								'Radio',
								'statisticsHelpful',
								array(
										'label' => $view->translate('Show Helpful Statistics.'),
										'multiOptions' => array(
												1 => 'Yes',
												0 => 'No'
										),
										'value' => 1,
								)
						),
						array(
								'Radio',
								'statisticsComment',
								array(
										'label' => $view->translate('Show Like & Comment Statistics.'),
										'multiOptions' => array(
												1 => 'Yes',
												0 => 'No'
										),
										'value' => 1,
								)
						),
						array(
								'Radio',
								'statisticsView',
								array(
										'label' => $view->translate('Show Views Statistics.'),
										'multiOptions' => array(
												1 => 'Yes',
												0 => 'No'
										),
										'value' => 1,
								)
						),
						array(
								'Text',
								'itemCount',
								array(
										'label' => $view->translate('Count'),
										'description' => $view->translate('(number of Tutorials to show)'),
										'value' => 20,
								)
						),
						array(
								'Text',
								'truncation',
								array(
									'label' => $view->translate('Enter the maximum limit (between 1 and 999) to be applied to the number of characters in the description of Tutorials. (If you do not want to truncate the description, then enter 0 below.)'),
									'value' => 0,
									'validators' => array(
										array('Int', true),
									),
								)
						),
						array(
								'Radio',
								'scrollButton',
								array(
										'label' => $view->translate('Scroll to Top Button'),
										'description' => $view->translate("Do you want the 'Scroll to Top' button to be displayed for this block? (As a user scrolls down to see more Tutorials from this widget, the 'Scroll to Top' button will be shown in the bottom-right side of the screen, enabling user to easily move to the top.)"),
										'multiOptions' => array(
												1 => 'Yes',
												0 => 'No'
										),
										'value' => 1,
								)
						),
						array(
								'Hidden',
								'nomobile',
								array(
										'label' => '',
										'order' => 1001
								)
						),
					),
				),
		),

		array(
			'title' => $view->translate('Manage Tutorials'),
			'description' => $view->translate('Displays to users a list of all the Tutorials created by them. This widget should be placed on the Tutorial Manage Page.'),
			'category' => $view->translate('Tutorials'),
			'type' => 'widget',
			'name' => 'sitetutorial.manage-sitetutorials',
			'defaultParams' => array(
				'title' => '',
				'titleCount' => true,
				'orderby' => 'tutorial_id'
			),
			'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => $view->translate('Count'),
										'description' => $view->translate('(number of Tutorials to show)'),
										'value' => 20,
								)
						),
						array(
								'Radio',
								'update',
								array(
										'label' => 'Show last updated date.',
										'multiOptions' => array(
												'1' => 'Yes',
												'0' => 'No',
										),
										'value' => 1,
								)
						),
						array(
								'Radio',
								'statisticsRating',
								array(
										'label' => $view->translate('Show Rating.'),
										'multiOptions' => array(
												1 => 'Yes',
												0 => 'No'
										),
										'value' => 1,
								)
						),
						array(
								'Radio',
								'statisticsHelpful',
								array(
										'label' => $view->translate('Show Helpful Statistics.'),
										'multiOptions' => array(
												1 => 'Yes',
												0 => 'No'
										),
										'value' => 1,
								)
						),
						array(
								'Radio',
								'statisticsComment',
								array(
										'label' => $view->translate('Show Like & Comment Statistics.'),
										'multiOptions' => array(
												1 => 'Yes',
												0 => 'No'
										),
										'value' => 1,
								)
						),
						array(
								'Radio',
								'statisticsView',
								array(
										'label' => $view->translate('Show Views Statistics.'),
										'multiOptions' => array(
												1 => 'Yes',
												0 => 'No'
										),
										'value' => 1,
								)
						),
						array(
								'Hidden',
								'nomobile',
								array(
										'label' => '',
										'order' => 1002
								)
						),
					),
				),
		),

		array(
			'title' => $view->translate('Popular Tutorial Tags'),
			'description' => $view->translate('Shows popular tags with frequency.'),
			'category' => $view->translate('Tutorials'),
			'type' => 'widget',
			'name' => 'sitetutorial.tagcloud-sitetutorials',
			'defaultParams' => array(
				'title' => '',
				'titleCount' => true,
			),
			'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => $view->translate('Count'),
										'description' => $view->translate('(number of tags to show)'),
										'value' => 100,
								)
						),
						array(
								'Hidden',
								'nomobile',
								array(
										'label' => '',
										'order' => 1003
								)
						),
					),
				),
		),

		array(
			'title' => $view->translate('Mobile Browse Tutorials'),
			'description' => $view->translate('Displays a list of all the Tutorials on site. This widget should be placed on the Mobile Tutorial Browse Page.'),
			'category' => $view->translate('Tutorials'),
			'type' => 'widget',
			'name' => 'sitetutorial.mobi-browse-sitetutorials',
			'defaultParams' => array(
				'title' => '',
				'titleCount' => true,
				'orderby' => 'tutorial_id'
			),
			'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => $view->translate('Count'),
										'description' => $view->translate('(number of Tutorials to show)'),
										'value' => 20,
								)
						),
						array(
								'Radio',
								'statisticsRating',
								array(
										'label' => $view->translate('Show Rating.'),
										'multiOptions' => array(
												1 => 'Yes',
												0 => 'No'
										),
										'value' => 1,
								)
						),
						array(
								'Radio',
								'statisticsHelpful',
								array(
										'label' => $view->translate('Show Helpful Statistics.'),
										'multiOptions' => array(
												1 => 'Yes',
												0 => 'No'
										),
										'value' => 1,
								)
						),
						array(
								'Radio',
								'statisticsComment',
								array(
										'label' => $view->translate('Show Like & Comment Statistics.'),
										'multiOptions' => array(
												1 => 'Yes',
												0 => 'No'
										),
										'value' => 1,
								)
						),
						array(
								'Radio',
								'statisticsView',
								array(
										'label' => $view->translate('Show Views Statistics.'),
										'multiOptions' => array(
												1 => 'Yes',
												0 => 'No'
										),
										'value' => 1,
								)
						),
						array(
								'Text',
								'truncation',
								array(
									'label' => $view->translate('Enter the maximum limit (between 1 and 999) to be applied to the number of characters in the description of Tutorials. (If you do not want to truncate the description, then enter 0 below.)'),
									'value' => 0,
									'validators' => array(
										array('Int', true),
									),
								)
						),
						array(
								'Hidden',
								'nomobile',
								array(
										'label' => '',
										'order' => 1004
								)
						),
					),
				),
		),

		array(
			'title' => $view->translate('Search Tutorials form'),
			'description' => $view->translate('Displays the form for searching Tutorials on the basis of various fields and filters. Settings for this form can be configured from the Search Form Settings section.'),
			'category' => $view->translate('Tutorials'),
			'type' => 'widget',
			'name' => 'sitetutorial.search-sitetutorials',
		),

		array(
				'title' => $view->translate('Tutorial View Page Options'),
				'description' => $view->translate('Displays the various action links that can be performed on the Tutorials from their View page (edit, delete, share, etc.). This widget should be placed on the Tutorial View Page. You can manage the Action Links available in this widget from the Menu Editor section by choosing Tutorial View Page Options Menu.'),
				'category' => $view->translate('Tutorials'),
				'type' => 'widget',
				'name' => 'sitetutorial.options-sitetutorials',
				'requirements' => array(
					'subject' => 'sitetutorial_tutorial',
				),
		),

		array(
					'title' => $view->translate('Tutorial Rating'),
					'description' => $view->translate('Displays the overall rating given to an Tutorial by other users. If enabled from Admin Panel, users can also rate the Tutorial using this widget. This widget should be placed on Tutorial View page.'),
					'category' => $view->translate('Tutorials'),
					'type' => 'widget',
					'name' => 'sitetutorial.ratings-sitetutorials',
					'defaultParams' => array(
									'title' => $view->translate('Ratings'),
									'titleCount' => true,
					),
		),

		array(
			'title' => $view->translate('Tutorials: Auto-suggest Search'),
			'description' => $view->translate('Displays auto-suggest search box for Tutorials. As user types, Tutorials will be displayed in an auto-suggest box.'),
			'category' => $view->translate('Tutorials'),
			'type' => 'widget',
			'name' => 'sitetutorial.search-box-sitetutorials',
			'defaultParams' => array(
				'title' => '',
				'titleCount' => true,
			),
			'adminForm' => array(
				'elements' => array(
						array(
								'Radio',
								'heading',
								array(
										'label' => 'Do you want to show Heading?',
										'multiOptions' => array(
												'1' => 'Yes',
												'0' => 'No',
										),
										'value' => 1,
								)
						),
						array(
								'Text',
								'blur_text',
								array(
										'description' => $view->translate('Enter the text to be shown in the search box.'),
										'value' => $view->translate('Enter a keyword or question'),
								)
						),
						array(
								'Radio',
								'privacy',
								array(
										'label' => $view->translate('Do you want to display private Tutorials also in the search results?'),
										'multiOptions' => array(
												1 => "Yes",
												0 => "No"
										),
										'value' => 1,
								)
						),
					),
				),
		),

		array(
			'title' => $view->translate('Mobile Search Tutorials'),
			'description' => $view->translate('Displays search box for Tutorials. This widget should be placed on Mobile Tutorial Home Page.'),
			'category' => $view->translate('Tutorials'),
			'type' => 'widget',
			'name' => 'sitetutorial.mobi-search-box-sitetutorials',
			'defaultParams' => array(
				'title' => '',
				'titleCount' => true,
			),
			'adminForm' => array(
				'elements' => array(
						array(
								'Radio',
								'heading',
								array(
										'label' => 'Do you want to show Heading?',
										'multiOptions' => array(
												'1' => 'Yes',
												'0' => 'No',
										),
										'value' => 1,
								)
						),
					),
				),
		),

		array(
			'title' => $view->translate('Tutorial View'),
			'description' => $view->translate('Displays the main Tutorial. This widget should be placed on the Tutorial View Page.'),
			'category' => $view->translate('Tutorials'),
			'type' => 'widget',
			'name' => 'sitetutorial.sitetutorial-view-sitetutorials',
			'defaultParams' => array(
				'title' => '',
				'titleCount' => true,
			),
			'requirements' => array(
				'subject' => 'sitetutorial_tutorial',
			),
			'adminForm' => array(
					'elements' => array(
						array(
								'Radio',
								'statisticsHelpful',
								array(
										'label' => $view->translate('Show Helpful Statistics.'),
										'multiOptions' => array(
												1 => 'Yes',
												0 => 'No'
										),
										'value' => 1,
								)
						),
						array(
								'Hidden',
								'nomobile',
								array(
										'label' => '',
										'order' => 1005
								)
						),
					),
				),
		),

		array(
				'title' => $view->translate('Categories Hierarchy for Tutorials (sidebar)'),
				'description' => $view->translate('Displays the Categories, Sub-categories and 3<sup>rd</sup> Level-categories of Tutorials in an expandable form. Clicking on them will redirect the viewer to the list of Tutorials created in that category.'),
				'category' => $view->translate('Tutorials'),
				'type' => 'widget',
				'name' => 'sitetutorial.sidebar-categories-sitetutorials',
				'defaultParams' => array(
						'title' => $view->translate('Categories'),
						'titleCount' => true,
				),
		),

		array(
				'title' => $view->translate('Categories Hierarchy for Tutorials (View Page: sidebar)'),
				'description' => $view->translate('Displays all the Categories, Sub-categories and 3rd Level-categories associated with the current Tutorial being viewed in an expandable form. Clicking on them will redirect the viewer to the list of Tutorials created in that category. This widget should be placed on the Tutorial View Page.'),
				'category' => $view->translate('Tutorials'),
				'type' => 'widget',
				'name' => 'sitetutorial.sidebar-categories-view-sitetutorials',
				'defaultParams' => array(
						'title' => '',
						'titleCount' => true,
				),
		),

		array(
				'title' => $view->translate('Message for No Tutorials'),
				'description' => $view->translate('Displays a message to users when there are no Tutorials. This widget should be placed in the top of the middle column of Tutorial Home page.'),
				'category' => $view->translate('Tutorials'),
				'type' => 'widget',
				'name' => 'sitetutorial.zero-sitetutorials',
		),

		array(
				'title' => $view->translate('Owner’s Photo'),
				'description' => $view->translate('Displays the Tutorial owner’s photo with owner’s name. This widget should be placed in the right column of Tutorial View Page.'),
				'category' => $view->translate('Tutorials'),
				'type' => 'widget',
				'name' => 'sitetutorial.sitetutorial-owner-photo-sitetutorials',
				'requirements' => array(
					'subject' => 'sitetutorial_tutorial',
				),
		),

		array(
				'title' => $view->translate('Tutorial Information'),
				'description' => $view->translate('Displays the owner, category, tags, views and other information about an Tutorial. This widget should be placed on the Tutorial View page in the right column.'),
				'category' => $view->translate('Tutorials'),
				'type' => 'widget',
				'name' => 'sitetutorial.information-sitetutorials',
				'defaultParams' => array(
								'title' => 'Information',
								'titleCount' => true,
				),
				'requirements' => array(
					'subject' => 'sitetutorial_tutorial',
				),
				'adminForm' => array(
				'elements' => array(
						array(
								'Radio',
								'posted',
								array(
										'label' => 'Show Posted By.',
										'multiOptions' => array(
												'1' => 'Yes',
												'0' => 'No',
										),
										'value' => 0,
								)
						),
						array(
								'Radio',
								'owner_photo',
								array(
										'label' => 'Do you want to show Tutorial owner’s photo in ‘Posted By’?',
										'multiOptions' => array(
												'1' => 'Yes',
												'0' => 'No',
										),
										'value' => 0,
								)
						),
						array(
								'Radio',
								'update',
								array(
										'label' => 'Show last updated date.',
										'multiOptions' => array(
												'1' => 'Yes',
												'0' => 'No',
										),
										'value' => 1,
								)
						),
						array(
								'Radio',
								'statisticsView',
								array(
										'label' => $view->translate('Show Views Statistics.'),
										'multiOptions' => array(
												1 => 'Yes',
												0 => 'No'
										),
										'value' => 1,
								)
						),
						array(
								'Radio',
								'created',
								array(
										'label' => 'Show created date.',
										'multiOptions' => array(
												'1' => 'Yes',
												'0' => 'No',
										),
										'value' => 0,
								)
						),
						array(
								'Radio',
								'tags',
								array(
										'label' => 'Show topics covered (tags).',
										'multiOptions' => array(
												'1' => 'Yes',
												'0' => 'No',
										),
										'value' => 1,
								)
						),
					),
				),
		),

		array(
			'title' => $view->translate('Tutorial Social Share Buttons'),
			'description' => $view->translate("Contains Social Sharing buttons and enables users to easily share Tutorials on their favorite Social Networks. This widget should be placed on the Tutorial View Page. You can customize the code for social sharing buttons from Global Settings of this plugin by adding your own code generated from: <a href='http://www.addthis.com' target='_blank'>http://www.addthis.com</a>"),
			'category' => $view->translate('Tutorials'),
			'type' => 'widget',
			'name' => 'sitetutorial.socialshare-sitetutorials',
			'defaultParams' => array(
					'title' => $view->translate('Social Share'),
					'titleCount' => true,
			),
			'requirements' => array(
				'subject' => 'sitetutorial_tutorial',
			),
			'adminForm' => array(
				'elements' => array(
					array(
							'Hidden',
							'nomobile',
							array(
									'label' => '',
									'order' => 1006
							)
					),
				),
			),
		),

		array(
			'title' => $view->translate('Related Tutorials'),
			'description' => $view->translate('Displays a list of Tutorials related to the Tutorial currently being viewed. This widget should be placed on Tutorial View Page. The related Tutorials are shown based on the tags and top-level category of the Tutorial being viewed.'),
			'category' => $view->translate('Tutorials'),
			'type' => 'widget',
			'name' => 'sitetutorial.related-tutorials-view-sitetutorials',
			'defaultParams' => array(
				'title' => $view->translate('Related Tutorials'),
				'titleCount' => true,
			),
			'adminForm' => array(
					'elements' => array(
						array(
								'Radio',
								'related',
								array(
										'label' => $view->translate('Choose which all Tutorials should be displayed here as Tutorials related to the current Tutorial.'),
										'multiOptions' => array(
												'tags' => "Tutorials having same tag.(Note: 'Tags Field' should be enabled from Global Settings.)",
												'categories' => 'Tutorials associated with same `Categories`.'
										),
										'value' => 'categories',
								)
						),
						array(
								'Radio',
								'statisticsRating',
								array(
										'label' => $view->translate('Show Rating.'),
										'multiOptions' => array(
												1 => 'Yes',
												0 => 'No'
										),
										'value' => 1,
								)
						),
						array(
								'Radio',
								'statisticsComment',
								array(
										'label' => $view->translate('Show Like & Comment Statistics.'),
										'multiOptions' => array(
												1 => 'Yes',
												0 => 'No'
										),
										'value' => 1,
								)
						),
						array(
								'Radio',
								'statisticsView',
								array(
										'label' => $view->translate('Show Views Statistics.'),
										'multiOptions' => array(
												1 => 'Yes',
												0 => 'No'
										),
										'value' => 1,
								)
						),
						array(
								'Text',
								'truncation',
								array(
									'label' => $view->translate('Title Truncation Limit'),
									'value' => 26,
									'validators' => array(
										array('Int', true),
										array('GreaterThan', true, array(0)),
									),
								)
						),
						array(
								'Text',
								'itemCount',
								array(
										'label' => $view->translate('Count'),
										'description' => $view->translate('(number of Tutorials to show)'),
										'value' => 3,
								)
						),
						array(
								'Radio',
								'privacy',
								array(
										'label' => $view->translate('Do you want to display private Tutorials also?'),
										'multiOptions' => array(
												1 => "Yes",
												0 => "No"
										),
										'value' => 1,
								)
						),
						array(
								'Hidden',
								'nomobile',
								array(
										'label' => '',
										'order' => 1007
								)
						),
					),
				),
		),

		array(
				'title' => $view->translate('Popular / Recent / Random Tutorials'),
				'description' => $view->translate('Displays Tutorials based on the Popularity Criteria and other settings that you choose for this widget. You can place this widget multiple times on a page with different popularity criterion chosen for each placement.'),
				'category' => $view->translate('Tutorials'),
				'type' => 'widget',
				'autoEdit' => true,
				'name' => 'sitetutorial.tutorials-sitetutorials',
				'defaultParams' => array(
						'title' => $view->translate('Tutorials'),
						'titleCount' => true,
				),
				'adminForm' => array(
						'elements' => array(
								array(
										'Text',
										'itemCount',
										array(
											'label' => $view->translate('Count'),
											'description' => $view->translate('(number of Tutorials to show)'),
											'value' => 3,
										)
								),
								array(
										'Select',
										'popularity',
										array(
												'label' => $view->translate('Popularity Criteria'),
												'multiOptions' => $popularity_options,
												'value' => 'view_count',
										)
								),
								array(
										'Select',
										'interval',
										array(
												'label' => $view->translate('Popularity Duration (This duration will be applicable to these Popularity Criteria:  Most Liked, Most Commented and Most Recent.)'),
												'multiOptions' => array('week' => '1 Week', 'month' => '1 Month', 'overall' => 'Overall'),
												'value' => 'overall',
										)
								),
								array(
										'Select',
										'category_id',
										array(
												'label' => $view->translate('Category'),
												'multiOptions' => $categories_prepared,
										)
								),
								array(
										'Radio',
										'featured',
										array(
												'label' => $view->translate('Show only Featured Tutorials.'),
												'multiOptions' => array(
														1 => 'Yes',
														0 => 'No'
												),
												'value' => 0,
										)
								),
								array(
										'Radio',
										'statisticsRating',
										array(
												'label' => $view->translate('Show Rating.'),
												'multiOptions' => array(
														1 => 'Yes',
														0 => 'No'
												),
												'value' => 1,
										)
								),
								array(
										'Radio',
										'statisticsHelpful',
										array(
												'label' => $view->translate('Show Helpful Statistics.'),
												'multiOptions' => array(
														1 => 'Yes',
														0 => 'No'
												),
												'value' => 1,
										)
								),
								array(
										'Radio',
										'statisticsComment',
										array(
												'label' => $view->translate('Show Like & Comment Statistics.'),
												'multiOptions' => array(
														1 => 'Yes',
														0 => 'No'
												),
												'value' => 1,
										)
								),
								array(
										'Radio',
										'statisticsView',
										array(
												'label' => $view->translate('Show Views Statistics.'),
												'multiOptions' => array(
														1 => 'Yes',
														0 => 'No'
												),
												'value' => 1,
										)
								),
								array(
										'Radio',
										'column',
										array(
												'label' => $view->translate('Choose column for this widget.'),
												'multiOptions' => array(
														1 => 'Right Coumn / Left Column',
														0 => 'Middel Column'
												),
												'value' => 1,
										)
								),
								array(
										'Radio',
										'privacy',
										array(
												'label' => $view->translate('Do you want to display private Tutorials also?'),
												'multiOptions' => array(
														1 => "Yes",
														0 => "No"
												),
												'value' => 1,
										)
								),
								array(
										'Radio',
										'viewAll',
										array(
												'label' => $view->translate("Show 'View All' link"),
												'multiOptions' => array(
														1 => "Yes",
														0 => "No"
												),
												'value' => 1,
										)
								),
								array(
										'Text',
										'truncation',
										array(
											'label' => $view->translate('Title Truncation Limit'),
											'value' => 26,
											'validators' => array(
												array('Int', true),
												array('GreaterThan', true, array(0)),
											),
										)
								),
						),
				),
		),

		array(
				'title' => $view->translate('Categories Hierarchy for Tutorials'),
				'description' => $view->translate('Displays the Categories, Sub-categories and 3<sup>rd</sup> Level-categories of Tutorials in an expandable form. Clicking on them will redirect the viewer to the list of Tutorials created in that category. Multiple settings are available to customize this widget. This widget should be placed on the Tutorial Home Page.'),
				'category' => $view->translate('Tutorials'),
				'type' => 'widget',
				'autoEdit' => true,
				'name' => 'sitetutorial.categories-tutorials-sitetutorials',
				'defaultParams' => array(
						'title' => $view->translate(''),
						'titleCount' => true,
				),
			'adminForm' => array(
					'elements' => array(
						array(
								'Radio',
								'show',
								array(
										'label' => $view->translate('Choose what to show in this widget along with Categories and Sub-categories.'),
										'multiOptions' => array(
												3 => 'Tutorials of subcategories (Collapsed View)',
												2 => 'Tutorials of subcategories (Expanded View)',
												1 => '3rd Level Categories',
												0 => 'Only Categories and Sub-categories'
										),
										'value' => 2,
								)
						),
						array(
								'Radio',
								'show_count',
								array(
										'label' => $view->translate('Show Tutorials Count along with Categories and Sub-categories.'),
										'multiOptions' => array(
												1 => 'Yes',
												0 => 'No'
										),
										'value' => 1,
								)
						),
						array(
								'Text',
								'tutorial_limit',
								array(
									'label' => $view->translate('Enter number of Tutorials to be shown for each sub-category. This setting will only work if you choose to show Tutorials from the setting above.'),
									'value' => 5,
									'validators' => array(
										array('Int', true),
										array('GreaterThan', true, array(0)),
									),
								)
						),
						array(
								'Text',
								'truncation',
								array(
									'label' => $view->translate('Title Truncation Limit'),
									'value' => 50,
									'validators' => array(
										array('Int', true),
										array('GreaterThan', true, array(0)),
									),
								)
						),
						array(
								'Hidden',
								'nomobile',
								array(
										'label' => '',
										'order' => 1008
								)
						),
					),
				),
		),

		array(
				'title' => $view->translate('Mobile Categories Hierarchy for Tutorials'),
				'description' => $view->translate('Displays the Categories, Sub-categories and 3rd Level-categories of Tutorials in a grid form. Clicking on them will redirect the viewer to the list of Tutorials created in that category.'),
				'category' => $view->translate('Tutorials'),
				'type' => 'widget',
				'autoEdit' => true,
				'name' => 'sitetutorial.mobi-home-sitetutorials',
				'defaultParams' => array(
						'title' => $view->translate(''),
						'titleCount' => true,
				),
			'adminForm' => array(
					'elements' => array(
						array(
								'Hidden',
								'nomobile',
								array(
										'label' => '',
										'order' => 1009
								)
						),
					),
				),
		),
		
		array(
	    'title' => $view->translate('Tutorial Featured Label'),
	    'description' => $view->translate("Displays the 'FEATURED' Label for the Featured Tutorials marked by you from the 'Manage Tutorials' section in the Admin Panel. This widget should be placed on the Tutorial View Page."),
	    'category' => $view->translate('Tutorials'),
	    'type' => 'widget',
	    'name' => 'sitetutorial.featured-view-sitetutorials',
			'adminForm' => 'Sitetutorial_Form_Admin_Widget_Rainbow',
				'requirements' => array(
					'subject' => 'sitetutorial_tutorial',
				),
	    'defaultParams' => array(
	      'title' => '',
	      'titleCount' => true,
	    ),
	  ),
	);