<?php 
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitetutorial
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: manifest.php 6590 2012-18-05 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

//START WORK RELATED TO CUSTOMIZE URLs
$routeStartP = "tutorials";
$routeStartS = "tutorial";
$module=null;$controller=null;$action=null;$getURL = null;
$request = Zend_Controller_Front::getInstance()->getRequest();
if (!empty($request)) {
  $module = $request->getModuleName();
  $action = $request->getActionName();
  $controller = $request->getControllerName();
  $getURL = $request->getRequestUri();
}
if (empty($request) || !($module == "default" && ( strpos( $getURL, '/install') !== false))) {
  $routeStartP = Engine_Api::_()->getApi('settings', 'core')->getSetting('tutorial.manifestUrlP', "tutorials");
  $routeStartS = Engine_Api::_()->getApi('settings', 'core')->getSetting('tutorial.manifestUrlS', "tutorial");
}
//END WORK RELATED TO CUSTOMIZE URLs

return array (
  'package' => 
  array (
    'type' => 'module',
    'name' => 'sitetutorial',
    'version' => '5.4.1',
    'path' => 'application/modules/Sitetutorial',
    'title' => 'Tutorials Plugin',
    'description' => 'Tutorials Plugin',
'author' => '<a href="http://www.socialapps.tech" style="text-decoration:underline;" target="_blank">SocialApps.tech</a>',
    'callback' => array(
      'path' => 'application/modules/Sitetutorial/settings/install.php',
      'class' => 'Sitetutorial_Installer',
    ),
    'actions' => 
    array (
      0 => 'install',
      1 => 'upgrade',
      2 => 'refresh',
      3 => 'enable',
      4 => 'disable',
    ),
    'directories' => 
    array (
      0 => 'application/modules/Sitetutorial',
    ),
    'files' => 
    array (
      0 => 'application/languages/en/sitetutorial.csv',
    )
	),
  // Hooks ---------------------------------------------------------------------
  'hooks' => array(
    array(
      'event' => 'onUserDeleteBefore',
      'resource' => 'Sitetutorial_Plugin_Core',
    ),
		array(
				'event' => 'onRenderLayoutDefault',
				'resource' => 'Sitetutorial_Plugin_Core'
		),
  ),
	//Items ---------------------------------------------------------------------
	'items' => array(
			'sitetutorial_tutorial',
			'sitetutorial_question',
			'sitetutorial_category',
      'sitetutorial_option'
	),
	// Route--------------------------------------------------------------------
    'routes' => array(
        'sitetutorial_general' => array(
            'route' => $routeStartP . '/:action/*',
            'defaults' => array(
                'module' => 'sitetutorial',
                'controller' => 'index',
                'action' => 'home',
            ),
            'reqs' => array(
                'action' => '(home|browse|create|manage|question|print|tagscloud|mobi-home|mobi-browse|upload-photo)',
            ),
        ),
				'sitetutorial_specific' => array(
					'route' => $routeStartS . '/:action/:tutorial_id/*',
					'defaults' => array(
							'module' => 'sitetutorial',
							'controller' => 'index',
						'action' => 'view',
					),
					'reqs' => array(
						'action' => '(edit|publish|delete|print-view)',
						'tutorial_id' => '\d+',
					)
				),
				'sitetutorial_category' => array(
						'route' => $routeStartS . '/category/:action/*',
						'defaults' => array(
								'module' => 'sitetutorial',
								'controller' => 'index',
								'action' => 'sub-category',
						),
						'reqs' => array(
								'action' => '(sub-category|subsub-category)',
						),
				),
        'sitetutorial_view' => array(
            'route' => $routeStartS . '/view/:tutorial_id/:category_id/:subcategory_id/:subsubcategory_id/:slug/*',
            'defaults' => array(
                'module' => 'sitetutorial',
                'controller' => 'index',
                'action' => 'view',
								'category_id' => 0,
								'subcategory_id' => 0,
								'subsubcategory_id' => 0,
                'slug' => '',
            ),
            'reqs' => array(
                'tutorial_id' => '\d+'
            )
        ),
        'sitetutorial_general_category' => array(
            'route' => $routeStartP . '/browse/:category/:categoryname/*',
            'defaults' => array(
                'module' => 'sitetutorial',
                'controller' => 'index',
                'action' => 'browse',
            ),
            'reqs' => array(
                'category' => '\d+'           
            ),
        ),
        'sitetutorial_general_subcategory' => array(
            'route' => $routeStartP . '/browse/:category/:categoryname/:subcategory/:subcategoryname/*',
            'defaults' => array(
                'module' => 'sitetutorial',
                'controller' => 'index',
                'action' => 'browse',
            ),
            'reqs' => array(
                'category' => '\d+',
                'subcategory' => '\d+'
           
            ),
         ),
        'sitetutorial_general_subsubcategory' => array(
            'route' => $routeStartP . '/browse/:category/:categoryname/:subcategory/:subcategoryname/:subsubcategory/:subsubcategoryname/*',
            'defaults' => array(
                'module' => 'sitetutorial',
                'controller' => 'index',
                'action' => 'browse',
            ),
            'reqs' => array(
                'category' => '\d+',
                'subcategory' => '\d+',
								'subsubcategory' => '\d+'
            ),
         ),
			)
);
