<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    siteuserexport
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Templates.php 6590 2012-26-01 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteuserexport_Model_DbTable_Templates extends Engine_Db_Table {

	protected $_serializedColumns = array('fields');

	public function getTemplates($option_id = null, $spec = null) {

		if (empty($spec) && empty($option_id)) {
			$getProfileTypes = Engine_Api::_()->getApi('Core', 'siteuserexport')->getProfileTypes();
			if (!empty($getProfileTypes)) {
				reset($getProfileTypes);
				$option_id = key($getProfileTypes);
			}
		}

		$select = $this->select()
			->from($this->info('name'), array('template_id', 'template_lable'));
		if (!empty($option_id)) {
			$select->where('option_id = ?', $option_id);
		}

		$select->query();
		$templates = $this->fetchAll($select);

		$templatesArray = array();

		foreach ($templates->toArray() as $value) {
			$templatesArray[$value['template_id']] = $value['template_lable'];
		}

		return $templatesArray;
	}

	public function getTemplatefields($templateId) {

		if (!empty($templateId)) {
			$select = $this->select()
				->where('template_id = ?', $templateId);

			$fields = $this->fetchAll($select);
			$data = array();

			foreach ($fields as $value) {
				$data = $value->toArray()['fields'];
				$option_id = $value->toArray()['option_id'];
			}

			$fields = Engine_Api::_()->getApi('Core', 'siteuserexport')->getFields($option_id);

			$finalData = array();
			$finalData = array_intersect_key($data, $fields);
			$finalData['option_id'] = $option_id;

			return $finalData;

		}
	}

}
