<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteuserimport
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 * @version    $Id: Create.php 10168 2014-04-17 16:29:36Z andres $
 * @author     Jung
 */

/**
 * @category   Application_Extensions
 * @package    Siteuserimport
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 */
class Siteuserimport_Form_Admin_Addnewuserinformation extends Engine_Form
{
	protected $_profileType ;
	protected $_email ;
	protected $_memberLevel ;
	protected $_emailAntispamEnabled = true;

	public $_item;
	public $_topLevelId;
	public $_topLevelValue;
	public $_processedValues = array();	
	public $_isCreation = false;
	public $_hasPrivacy = false;
	public $_privacyValues = array();
	public $_controllerName;
	public static $getProfilePhoto = false;
	public static $getCoverPhoto = false;
	public static $getFileId ;
	public function setControllerName( $name )
	{
		$this->_controllerName = $name ;
	}
  public function getControllerName()
  {
  		return $this->_controllerName ;
  }
	public function setProfileType($params) 
	{  
	  $this->_profileType = $params;
	}
	public function setMemberLevel($params) 
	{  
	  $this->_memberLevel = $params;
	}
	public function setEmail($params) 
	{  
	  $this->_email = $params;
	}
	public function init()
	{
	    $tabIndex = 1;
	    $settings = Engine_Api::_()->getApi('settings', 'core');
	    // Init form
	    $this->setTitle('Add Single Member')
	    	 ->setDescription("Create a single member for different profile types available on your website by filling below form.");
	    $this->setAttrib('id', 'addadmin_single_user');
	
	    // Get available subscriptions
	    $packagesTable = Engine_Api::_()->getDbtable('packages', 'payment');
	    $packagesSelect = $packagesTable->select()->from( $packagesTable )->where( 'enabled = ?', true );
	    $multiOptionsPayment = array();
	    $getFreePackage = $packagesTable->fetchAll($packagesSelect);
	    if( count( $getFreePackage ) >0 ) {
		    foreach( $getFreePackage as $package ) {
		      $multiOptionsPayment[$package->package_id] = $package->title
		        . ' (' . $package->getPackageDescription() . ')'
		        ;
		    }
	      $this->addElement('Radio', 'package_id', array(
	        'label' => 'Choose Subscription Plan:',
	        'required' => true,
	        'description'  => 'Please select a subscription plan from the list below. We suggest you select a free plan to add new members, so that those members are never disabled.',
	        'allowEmpty' => false,
	        'multiOptions' => $multiOptionsPayment,
	      ));
	      $this->package_id->getDecorator('Description')->setOptions(array('placement'  => 'APPEND'));
	      $this->package_id->setOrder( -1001);
	    }

	    // Element: profile_type
	    $topStructure = Engine_Api::_()->fields()->getFieldStructureTop('user');
	    if( count($topStructure) ==  1 && $topStructure[0]->getChild()->type ==  'profile_type' ) {
	      $profileTypeField = $topStructure[0]->getChild();
	      $options = $profileTypeField->getOptions();
	      

	      if( count($options) > 1 ) {
	        $options = $profileTypeField->getElementParams('user');
	       
	        unset($options[ 'options' ][ 'order' ]);
	        unset($options[ 'options' ][ 'multiOptions' ][ '0' ]);
	        $this->addElement('Select', 'profile_type', array_merge($options[ 'options' ], array(
	              'required'  => true,
	              'allowEmpty'  => false,
	              'tabindex'  => 1, //$tabIndex++,
	              'value' => $this->_profileType,
	              'onchange' =>'showHint(this.value)',
	           )));
	        $selectElement = $this->getElement('profile_type');
	        $selectElement->removeMultiOption('');  

	      } else if( count($options) ==  1 ) {
	        $this->addElement('Hidden', 'profile_type', array(
	          'value'  => $options[0]->option_id,
	          'order' => 6788, 
	       ));
	      }
	    }
	  	$this->profile_type->setOrder( -1000 );

	    // Element: email
	    $emailElement = $this->addEmailElement(array(
	      'label'  => 'Email Address',
	      'description'  => 'Add an email address for user.',
	      'required'  => true,
	      'allowEmpty'  => false,
	      'style'  => array('display:block;border: 1px solid #dfdfdf;
	      		background-color: #fff;
			    color: #999;
			    border: 1px solid #dfdfdf;
			    padding: 5px;
			    font-size: 13px !important;
			    resize: none;
			    box-sizing: border-box;'),
	      'validators'  => array(
	        array('NotEmpty', true),
	        array('EmailAddress', true),
	        array('Db_NoRecordExists', true, array(Engine_Db_Table::getTablePrefix() . 'users', 'email'))
	     ),
	      'filters'  => array(
	        'StringTrim'
	     ),
	      // fancy stuff
	      'inputType'  => 'email',
	      'autofocus'  => 'autofocus',
	      'tabindex'  => 2,//$tabIndex++,
	   ));
	    $emailElement = $this->getElement('email');
	  //  $emailElement->getDecorator('style')->setOptions(array('display'  => 'block'));
	    $emailElement->getDecorator('Description')->setOptions(array('placement'  => 'APPEND'));
	    $emailElement->getValidator('NotEmpty')->setMessage('Please enter a valid email address.', 'isEmpty');
	    $emailElement->getValidator('Db_NoRecordExists')->setMessage('Someone has already registered this email address, please use another one.', 'recordFound');
	    $emailElement->getValidator('EmailAddress')->getHostnameValidator()->setValidateTld(false);
	    // Add banned email validator
	    $bannedEmailValidator = new Engine_Validate_Callback(array($this, 'checkBannedEmail'), $emailElement);
	    $bannedEmailValidator->setMessage("This email address is not available, please use another one.");
	    $emailElement->addValidator($bannedEmailValidator);
	    $this->email->setOrder( -999 );
	    // Element: password
	      $this->addElement('Password', 'password', array(
	        'label'  => 'Password',
	        'description'  => 'Passwords must be at least 6 characters in length.',
	        'required'  => true,
	        'allowEmpty'  => false,
	        // 'order'  =>999,
	        'validators'  => array(
	          array('NotEmpty', true),
	          array('StringLength', false, array(6, 32)),
	       ),
	        'tabindex'  => 3,//$tabIndex++,
	     ));
	      $this->password->getDecorator('Description')->setOptions(array('placement'  => 'APPEND'));
	      $this->password->getValidator('NotEmpty')->setMessage('Please enter a valid password.', 'isEmpty');

	      // Element: passconf
	      $this->addElement('Password', 'passconf', array(
	        'label'  => 'Password Again',
	        'description'  => 'Enter your password again for confirmation.',
	        'required'  => true,
	        'allowEmpty'  => false,
	        //  'order'  =>3,
	        'validators'  => array(
	          array('NotEmpty', true),
	       ),
	        'tabindex'  => 4,//$tabIndex++,
	     ));
	      $this->passconf->getDecorator('Description')->setOptions(array('placement'  => 'APPEND'));
	      $this->passconf->getValidator('NotEmpty')->setMessage('Please make sure the "password" and "password again" fields match.', 'isEmpty');

	      $specialValidator = new Engine_Validate_Callback(array($this, 'checkPasswordConfirm'), $this->password);
	      $specialValidator->setMessage('Password did not match', 'invalid');
	      $this->passconf->addValidator($specialValidator);
	       $this->password->setOrder( -998 );
        $this->passconf->setOrder( -997 );


	        if( $settings->getSetting('user.signup.username', 1) > 0 ) {
	      $description = Zend_Registry::get('Zend_Translate')
	          ->_('This will be the end of your profile link, for example: <br /> ' .
	              '<span id = "profile_address">http://%s</span>');
	      $description = sprintf($description, $_SERVER[ 'HTTP_HOST' ]
	          . Zend_Controller_Front::getInstance()->getRouter()
	          ->assemble(array('id'  => 'yourname'), 'user_profile'));

	      $this->addElement('Text', 'username', array(
	        'label'  => 'Profile Address',
	        'description'  => $description,
	        'required'  => true,
	        //  'order'  => 4,
	        'allowEmpty'  => false,
	        'validators'  => array(
	          array('NotEmpty', true),
	          array('Alnum', true),
	          array('StringLength', true, array(4, 64)),
	          array('Regex', true, array('/^[a-z][a-z0-9]*$/i')),
	          array('Db_NoRecordExists', true, array(Engine_Db_Table::getTablePrefix() . 'users', 'username'))
	       ),
	        'tabindex'  => 5,// $tabIndex++,
	     ));
	      $this->username->getDecorator('Description')->setOptions(array('style'=>'overflow-x:auto;max-width:435px', 'placement'  => 'APPEND', 'escape'  => false));
	      $this->username->getValidator('NotEmpty')->setMessage('Please enter a valid profile address.', 'isEmpty');
	      $this->username->getValidator('Db_NoRecordExists')->setMessage('Someone has already picked this profile address, please use another one.', 'recordFound');
	      $this->username->getValidator('Regex')->setMessage('Profile addresses must start with a letter.', 'regexNotMatch');
	      $this->username->getValidator('Alnum')->setMessage('Profile addresses must be alphanumeric.', 'notAlnum');
	      $this->username->setOrder( -996 );
	      // Add banned username validator
	      $bannedUsernameValidator = new Engine_Validate_Callback(array($this, 'checkBannedUsername'), $this->username);
	      $bannedUsernameValidator->setMessage("This profile address is not available, please use another one.");
	      $this->username->addValidator($bannedUsernameValidator);
	    }
	    
	 	//Add dynamic field of the user.
		$profileId = $this->_profileType;
	    //Add users belong to this.
	    $this->adduserprofilevalue($profileId);

	    // Element: timezone
	    $this->addElement('Select', 'timezone', array(
	      'label'  => 'Timezone',
	      'value'  => $settings->getSetting('core.locale.timezone'),
	      'multiOptions'  => array(
	        'US/Pacific'  => '(UTC-8) Pacific Time (US & Canada)',
	        'US/Mountain'  => '(UTC-7) Mountain Time (US & Canada)',
	        'US/Central'  => '(UTC-6) Central Time (US & Canada)',
	        'US/Eastern'  => '(UTC-5) Eastern Time (US & Canada)',
	        'America/Halifax'  => '(UTC-4)  Atlantic Time (Canada)',
	        'America/Anchorage'  => '(UTC-9)  Alaska (US & Canada)',
	        'Pacific/Honolulu'  => '(UTC-10) Hawaii (US)',
	        'Pacific/Samoa'  => '(UTC-11) Midway Island, Samoa',
	        'Etc/GMT-12'  => '(UTC-12) Eniwetok, Kwajalein',
	        'Canada/Newfoundland'  => '(UTC-3:30) Canada/Newfoundland',
	        'America/Buenos_Aires'  => '(UTC-3) Brasilia, Buenos Aires, Georgetown',
	        'Atlantic/South_Georgia'  => '(UTC-2) Mid-Atlantic',
	        'Atlantic/Azores'  => '(UTC-1) Azores, Cape Verde Is.',
	        'Europe/London'  => 'Greenwich Mean Time (Lisbon, London)',
	        'Europe/Berlin'  => '(UTC+1) Amsterdam, Berlin, Paris, Rome, Madrid',
	        'Europe/Athens'  => '(UTC+2) Athens, Helsinki, Istanbul, Cairo, E. Europe',
	        'Europe/Moscow'  => '(UTC+3) Baghdad, Kuwait, Nairobi, Moscow',
	        'Iran'  => '(UTC+3:30) Tehran',
	        'Asia/Dubai'  => '(UTC+4) Abu Dhabi, Kazan, Muscat',
	        'Asia/Kabul'  => '(UTC+4:30) Kabul',
	        'Asia/Yekaterinburg'  => '(UTC+5) Islamabad, Karachi, Tashkent',
	        'Asia/Calcutta'  => '(UTC+5:30) Bombay, Calcutta, New Delhi',
	        'Asia/Katmandu'  => '(UTC+5:45) Nepal',
	        'Asia/Omsk'  => '(UTC+6) Almaty, Dhaka',
	        'Indian/Cocos'  => '(UTC+6:30) Cocos Islands, Yangon',
	        'Asia/Krasnoyarsk'  => '(UTC+7) Bangkok, Jakarta, Hanoi',
	        'Asia/Hong_Kong'  => '(UTC+8) Beijing, Hong Kong, Singapore, Taipei',
	        'Asia/Tokyo'  => '(UTC+9) Tokyo, Osaka, Sapporto, Seoul, Yakutsk',
	        'Australia/Adelaide'  => '(UTC+9:30) Adelaide, Darwin',
	        'Australia/Sydney'  => '(UTC+10) Brisbane, Melbourne, Sydney, Guam',
	        'Asia/Magadan'  => '(UTC+11) Magadan, Solomon Is., New Caledonia',
	        'Pacific/Auckland'  => '(UTC+12) Fiji, Kamchatka, Marshall Is., Wellington',
	     ),
	      'tabindex'  => 198,//$tabIndex++,
	   ));
	    $this->timezone->getDecorator('Description')->setOptions(array('placement'  => 'APPEND'));

	    // Element: language
	    // Languages
	    $translate = Zend_Registry::get('Zend_Translate');
	    $languageList = $translate->getList();

	    // Prepare default langauge
	    $defaultLanguage = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.locale.locale', 'en');
	    if( !in_array($defaultLanguage, $languageList) ) {
	      if( $defaultLanguage ==  'auto' && isset($languageList[ 'en' ]) ) {
	        $defaultLanguage = 'en';
	      } else {
	        $defaultLanguage = null;
	      }
	    }

	    // Prepare language name list
	    $localeObject = Zend_Registry::get('Locale');
	    $languageNameList = array();
	    $languageDataList = Zend_Locale_Data::getList($localeObject, 'language');
	    $territoryDataList = Zend_Locale_Data::getList($localeObject, 'territory');

	    foreach( $languageList as $localeCode ) {
	      $languageNameList[$localeCode] = Zend_Locale::getTranslation($localeCode, 'language', $localeCode);
	      if( empty($languageNameList[$localeCode]) ) {
	        list($locale, $territory) = explode('_', $localeCode);
	        $languageNameList[$localeCode] = "{$territoryDataList[$territory]} {$languageDataList[$locale]}";
	      }
	    }
	    $languageNameList = array_merge(array(
	      $defaultLanguage  => $defaultLanguage
	   ), $languageNameList);

	    if(count($languageNameList)>1){
	      $this->addElement('Select', 'language', array(
	        'label'  => 'Language',
	        //  'order'  => 6,
	        'multiOptions'  => $languageNameList,
	        'tabindex'  => 199,//$tabIndex++,
	     ));
	      $this->language->getDecorator('Description')->setOptions(array('placement'  => 'APPEND'));
	      	$this->language->setOrder( 997 );
	    }
	    else{
	      $this->addElement('Hidden', 'language', array(
	      	//  'order'  => 7,
	        'value'  => current((array)$languageNameList),
	        'order' => 6789, 
	     ));
	      $this->language->setOrder( 997 );
	    }
		//Add a user photo here.
		$this->addElement('File', 'profile_photo', array(
		      'label'  => 'User Profile Photo',
		      'autocomplete'  => 'on',
		      'description'  => 'Please add a photo of user here to display as his profile picture.',
		      'filters'  => array(
		        new Engine_Filter_Censor(),
		       ),
		    //  'required'  =>true,
			   	//'value' =>  $this->_member_level,
			   	'allowEmpty'  =>true,
			   	'tabindex'  =>200,//$tabIndex++,
		     ));
		$this->profile_photo->getDecorator("Description")->setOption("placement", "append");
	    $this->profile_photo->addValidator('Extension', false, 'jpg,png,gif,jpeg,JPG,PNG,GIF,JPEG');
	    $this->profile_photo->setOrder( 998 );

    	// Add selection of use type
	    $addCheckBox = $this->addElement('multiCheckbox', 'multiCheckbox',array(
		   	'label'  => 'Verification',
		   	'autocomplete'  => 'on',
		   	'multiOptions'  => array(
		   		'approved'  => 'Approved',
		   		'verified'  => 'Verified',
		   		'enabled'  => 'Enabled',
		   	),
		   	'tabindex'  =>201, //$tabIndex++,
		   	)); 

	    //Element member level
	    $table1 = Engine_Api::_()->getDbtable('levels', 'authorization');
		    $db1 = $table1->getAdapter();
		    $sqlquery = $table1->select()
		         ->from($table1->info('name'))
		         ->where('type != ?', 'public');
	        $userIdIs =  $table1->fetchAll($sqlquery)->toArray();
	        $memberLevels = array();
	        foreach($userIdIs as $key  => $values)
	        {
	        	$profilekey = $values[ 'level_id' ];
	        	$memberLevels[$profilekey] = $values[ 'title' ];
	        }
	    $memberLevel = $this->addElement('Select', 'member_level',array(
	   	'label'  => 'Select Member Level',
	   	'value' => $this->_memberLevel,
	   	'autocomplete'  => 'on',
	   	'multiOptions'  => $memberLevels,
	   	'Description'  => 'Enter level of member for which you want to create account.',
	   	'required'  =>true,
	   	'tabindex'  =>202,//$tabIndex++,
	   	'onchange' =>'showVarifeyOnMemberLevel(this.value)',
	   	)); 
	 	$this->member_level->getDecorator('Description')->setOption('placement', 'append');





	    //Add a cover photo here. if Content Profiles - Cover Photo, Banner & Site Branding Plugin is installed.
	    //Get if site have cover photo plugin here
	    $siteusercoverphoto = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('siteusercoverphoto');
	    if(  $siteusercoverphoto == true )
	    {
	    	$this->addElement('File', 'cover_photo', array(
	      	  'label'  => 'User Cover Photo',
		      'autocomplete'  => 'on',
		      'description'  => 'Please add a cover photo of user here to display as his cover.',
		      'filters'  => array(
		        new Engine_Filter_Censor(),
		       ),
		   //   'required'  =>true,
			   	//'value' =>  $this->_member_level,
			   	'allowEmpty'  =>false,
			   	'tabindex'  =>203, //$tabIndex++,
		     ));
		    $this->cover_photo->getDecorator("Description")->setOption("placement", "append");
	    	$this->cover_photo->addValidator('Extension', false, 'jpg,png,gif,jpeg,JPG,PNG,GIF,JPEG');
	    	$this->cover_photo->setOrder( 1001 );       
    	}



	    // Show varified Icon on Image if plugin and permission is installed init.
	    $siteverify = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('siteverify');
	    if( $siteverify == true )
	    {

	    	$addCheckBox = $this->addElement('radio', 'sitevarify',array(
			   	'label'  => 'Verified Icon',
			   	'autocomplete'  => 'on',
			   	'description'  => 'Do you want to show verified icon on Member Profile.',
			   	'multiOptions'  => array(
			   		'1'  => 'Yes',
			   		'0'  => 'No',
			   	),
			   	'tabindex'  =>204, //$tabIndex++,
			));
			$this->sitevarify->setOrder( 1002 );
	    		
    	}
    	$this->addElement('Button', 'submit', array(
      		'label'  => 'Save',
      		'onclick' => 'hideFormNotice()',
      		'type'  => 'submit',
      		'tabindex'  =>206,
      		'order'  => 10000,
   		));

        $this->timezone->setOrder( 996 );
        $this->multiCheckbox->setOrder( 999 );
        $this->member_level->setOrder( 1000 );

	}

	public function adduserprofilevalue($profileId)
  	{
		$this->_topLevelValue = $profileId;
		$profileTypeField = $this->getProfileTypeField();
		$this->_topLevelId = $profileTypeField->field_id;
		$this
    	->setIsCreation(true)
    	->setItem(Engine_Api::_()->user()->getUser(null));
    	$this->generate();
	}

  public function addEmailElement($attributes = array())
  {
    $emailFieldName = 'email';//$this->getEmailElementFieldName();
    $attributes = array_merge(array(
        'required'  => true,
        'allowEmpty'  => false,
        'filters'  => array(
            'StringTrim',
       ),
        'validators'  => array(
            'EmailAddress'
       ),
        // Fancy stuff
        'inputType'  => 'email',
        'class'  => 'text',
     ), $attributes);

     $this->addElement('Text', $emailFieldName, $attributes);
    return $this->{$emailFieldName};
  }



  public function render(Zend_View_Interface $view = null)
  {
   
    return parent::render($view);
  }

  public function isEmailAntispamEnabled()
  {
    return $this->_emailAntispamEnabled;
  }

    // Element: username as profile address.
    public function getProfileTypeField() {
    $topStructure = Engine_Api::_()->fields()->getFieldStructureTop('user');

    if( count($topStructure) ==  1 && $topStructure[0]->getChild()->type ==  'profile_type' ) {
      return $topStructure[0]->getChild();
    }
  }

  public function checkPasswordConfirm($value, $passwordElement)
  {
    return ( $value ==  $passwordElement->getValue() );
  }

  public function checkBannedEmail($value, $emailElement)
  {
    $bannedEmailsTable = Engine_Api::_()->getDbtable('BannedEmails', 'core');
    return !$bannedEmailsTable->isEmailBanned($value);
  }

  public function checkBannedUsername($value, $usernameElement)
  {
    $bannedUsernamesTable = Engine_Api::_()->getDbtable('BannedUsernames', 'core');
    return !$bannedUsernamesTable->isUsernameBanned($value);
  }


  // Add custom element paths?
  public function __construct($options = null)
  {
    Engine_FOrm::enableForm($this);
    self::enableForm($this);

    parent::__construct($options);
  }

  public static function enableForm(Zend_Form $form)
  {
    $form
      ->addPrefixPath('Fields_Form_Element', APPLICATION_PATH . '/application/modules/Fields/Form/Element', 'element');
  }
  

  /* General */

  public function getItem()
  {
    return $this->_item;
  }

  public function setItem(Core_Model_Item_Abstract $item)
  {
    $this->_item = $item;
    return $this;
  }


  public function setTopLevelId($id)
  {
    $this->_topLevelId = $id;
    return $this;
  }

  public function getTopLevelId()
  {
    return $this->_topLevelId;
  }

  public function setTopLevelValue($val)
  {
    $this->_topLevelValue = $val;
    return $this;
  }

  public function getTopLevelValue()
  {
    return $this->_topLevelValue;
  }

  public function setIsCreation($flag = true)
  {
    $this->_isCreation = (bool) $flag;
    return $this;
  }

  public function setProcessedValues($values)
  {
    $this->_processedValues = $values;
    $this->_setFieldValues($values);
    return $this;
  }

  public function getProcessedValues()
  {
    return $this->_processedValues;
  }
  
  public function setHasPrivacy($flag = false)
  {
    $this->_hasPrivacy = (bool) $flag;
    return $this;
  }
  
  public function setPrivacyValues($privacyValues)
  {
    $this->_privacyValues = (array) $privacyValues;
    return $this;
  }

  public function getFieldMeta()
  {
    return Engine_Api::_()->fields()->getFieldsMeta($this->getItem());
  }

  public function getFieldStructure()
  {
    // Let's allow fallback for no profile type (for now at least)
    if( !$this->_topLevelId || !$this->_topLevelValue ) {
      $this->_topLevelId = null;
      $this->_topLevelValue = null;
    }
    return Engine_Api::_()->fields()->getFieldsStructureFull($this->getItem(), $this->_topLevelId, $this->_topLevelValue);
  }

  // Main
  public function generate()
  {
    $struct = $this->getFieldStructure();
    $orderIndex = 0;
    $tabIndex = 6;

    foreach( $struct as $fskey  => $map )
    {
      $field = $map->getChild();

      // Skip fields hidden on signup
      if( isset($field->show) && !$field->show && $this->_isCreation ) {
        continue;
      }
      
      // Add field and load options if necessary
      $params = $field->getElementParams($this->getItem());

      //$key = 'field_' . $field->field_id;
      $key = $map->getKey();
      
      // If value set in processed values, set in element
      if( !empty($this->_processedValues[$field->field_id]) )
      {
        $params[ 'options' ][ 'value' ] = $this->_processedValues[$field->field_id];
      }

      if( !@is_array($params[ 'options' ][ 'attribs' ]) ) {
        $params[ 'options' ][ 'attribs' ] = array();
      }
      
      // Heading
      if( $params[ 'type' ] ==  'Heading' )
      {
        $params[ 'options' ][ 'value' ] = Zend_Registry::get('Zend_Translate')->_($params[ 'options' ][ 'label' ]);
        unset($params[ 'options' ][ 'label' ]);
      }

      // Order
      // @todo this might cause problems, however it will prevent multiple orders causing elements to not show up
      $params[ 'options' ][ 'order' ] = $orderIndex++;
      
      $inflectedType = Engine_Api::_()->fields()->inflectFieldType($params[ 'type' ]);
      unset($params[ 'options' ][ 'alias' ]);
      unset($params[ 'options' ][ 'publish' ]);
      $this->addElement($inflectedType, $key, $params[ 'options' ]);

      $element = $this->getElement($key);

      if( method_exists($element, 'setFieldMeta') ) {
        $element->setFieldMeta($field);
      }
      
      // Set attributes for hiding/showing fields using javscript
      $classes = 'field_container field_'.$map->child_id.' option_'.$map->option_id.' parent_'.$map->field_id;
      $element->setAttrib('class', $classes);

      //
      if( $field->canHaveDependents() ) {
        $element->setAttrib('onchange', 'changeFields(this)');
      }

      // Set custom error message
      if( $field->error ) {
        $element->addErrorMessage($field->error);
      }


      if( $params[ 'type' ] !=  'Heading' )
      {
      	$element->setAttrib('tabIndex', $tabIndex++);

      }
      if( $field->isHeading() ) {
        $element->removeDecorator('Label')
          ->removeDecorator('HtmlTag')
          ->getDecorator('HtmlTag2')->setOption('class', 'form-wrapper-heading');
      }
    }
  }

 
  public function _setFieldValues($values)
  {
    // Iterate over elements and apply the values
    foreach( $this->getElements() as $key  => $element ) {
      if( count(explode('_', $key)) ==  3 ) {
        list($parent_id, $option_id, $field_id) = explode('_', $key);
        if( isset($values[$field_id]) ) {
          $element->setValue($values[$field_id]);
        }
      }
    }
  }

  /* These are hacks to existing form methods */

    public function isValidStatic($data )
    {
        if (!is_array($data)) {
            // require_once 'Zend/Form/Exception.php';
            throw new Zend_Form_Exception(__METHOD__ . ' expects an array');
        }
        $translator = $this->getTranslator();
        $valid      = true;
        $eBelongTo  = null;

        if ($this->isArray()) {
            $eBelongTo = $this->getElementsBelongTo();
            $data = $this->_dissolveArrayValue($data, $eBelongTo);
        }
        $context = $data;
        foreach ($this->getElements() as $key => $element) {
        	
        	
        	if ( ! preg_match( '/[^0-9_]/', $key ) )
            {
            	continue ;
            } else if( $this->_controllerName == 'bulkInsertionAction' && $key == 'profile_photo' ) {
            	

            	if( $this::$getProfilePhoto == true && $data[ 'profile_photo' ] != null || $data['profile_photo'] != '') {
            			
            			$archiveProfilePhoto = APPLICATION_PATH . "/public/siteuserimport" . DIRECTORY_SEPARATOR ."fileimport_".$this::$getFileId. DIRECTORY_SEPARATOR . "profile_photo/";
            			$getSubDirInfo = array();
            			if( is_dir($archiveProfilePhoto) ) {
            				$getSubDirInfo = scandir($archiveProfilePhoto) ;
            			}
            			
            			$getExtractFileName = '';
						foreach ($getSubDirInfo as $dirKey => $subDir ) {
							# code...
							
						    if ( $subDir === '.' or $subDir === '..') continue;

						    if (is_dir($archiveProfilePhoto . $subDir )) {
						        $getExtractFileName = $archiveProfilePhoto  . $subDir  ;
						        break ;
						    }
						}
						if( ! file_exists( $getExtractFileName ) ) {
							$this->profile_photo->addErrorMessage('No photo Zip file has been uploaded. Leave image textbox area empty or upload the Zip file of photos. ' );
							$valid = false ;
							continue ;
						}
						$getExtractFileName = $getExtractFileName .'/'.$data['profile_photo'] ;
						
						if( preg_match( '/.jpg$|.png$|.gif$|.jpeg$|.JPG$|.PNG$|.GIF$|.JPEG$/', $data['profile_photo'])) {
							// Check File type
							
								
							if(  file_exists( $getExtractFileName) ) {	
								$valid = true ;
							} else {
								$valid = false ;
							$this->profile_photo->addErrorMessage('Profile photo with this name is not available' );
								
							
							}

						} else {
							$valid = false ;
							$this->profile_photo->addErrorMessage('Extension of Profile photo is invalid.' );
						}
            		} else {
            			$valid = true ;
            		}
            		continue;
            } else if( $this->_controllerName == 'bulkInsertionAction' && $key == 'cover_photo' ) {
            	
            		if( $this::$getCoverPhoto == true && $data[ 'cover_photo' ] != null || $data['cover_photo'] != '') {
            			
            			$archiveCoverPhoto = APPLICATION_PATH . "/public/siteuserimport" . DIRECTORY_SEPARATOR ."fileimport_".$this::$getFileId. DIRECTORY_SEPARATOR . "cover_photo/"; 
            			$getSubDirInfo = array();
            			if( is_dir($archiveCoverPhoto) ) {
            				$getSubDirInfo = scandir($archiveCoverPhoto) ;
            			}
            			$getExtractFileName = '';
						foreach ($getSubDirInfo as $dirKey => $subDir ) {
							# code...
							
						    if ( $subDir === '.' or $subDir === '..') continue;

						    if (is_dir($archiveCoverPhoto . $subDir )) {
						        $getExtractFileName = $archiveCoverPhoto  . $subDir  ;
						
						        break ;
						    }
						}
						
						if( ! file_exists( $getExtractFileName ) ) {
							$valid = false ;
							$this->cover_photo->addErrorMessage('No photo Zip file has been uploaded. Leave image textbox area empty or upload the Zip file of photos.');
							continue ;
						}
						$getExtractFileName = $getExtractFileName.'/'.$data['cover_photo'] ;


						if( preg_match( '/.jpg$|.png$|.gif$|.jpeg$|.JPG$|.PNG$|.GIF$|.JPEG$/', $data['cover_photo'] ) ) {
						if(file_exists( $getExtractFileName )) {
						// Check File type

							$valid = true ;
						} else {
							$vaild = false;

							
							$this->cover_photo->addErrorMessage('Cover photo with this name is not available' );
						
						}

						} else {
							$vaild = false;
							$this->cover_photo->addErrorMessage('Extension of Cover photo is invalid.' );
						}
            		} else {
            			$valid = true ;
            		}
            		continue;
            }
            if (null !== $translator && $this->hasTranslator()
                    && !$element->hasTranslator()) {
                $element->setTranslator($translator);
            }
            $check = $data;
            if (($belongsTo = $element->getBelongsTo()) !== $eBelongTo) {
                $check = $this->_dissolveArrayValue($data, $belongsTo);
            }
            if (!isset($check[$key])) {
            	
            	

                $valid = $element->isValid(null, $context) && $valid;
            } else {
            	
                $valid = $element->isValid($check[$key], $context) && $valid;
                $data = $this->_dissolveArrayUnsetKey($data, $belongsTo, $key);
            }
          
        }
        foreach ($this->getSubForms() as $key => $form) {
            if (null !== $translator && $this->hasTranslator()
                    && !$form->hasTranslator()) {
                $form->setTranslator($translator);
            }
            if (isset($data[$key]) && !$form->isArray()) {
                $valid = $form->isValid($data[$key]) && $valid;
            } else {
                $valid = $form->isValid($data) && $valid;
            }
           
        }

        $this->_errorsExist = !$valid;

        // If manually flagged as an error, return invalid status
        if ($this->_errorsForced) {
            return false;
        }
       
        return $valid;
    }







  public function isValid($data )
  {
  
    $isValid = $this->isValidStatic($data);
   
    if (!is_array($data)) {
      require_once 'Zend/Form/Exception.php';
      throw new Zend_Form_Exception(__CLASS__ . '::' . __METHOD__ . ' expects an array');
    }
    $translator = $this->getTranslator();
    $valid      = true;

    if ($this->isArray()) {
      $data = $this->_dissolveArrayValue($data, $this->getElementsBelongTo());
    }

    // Changing this part
    $structure = $this->getFieldStructure();
    $selected = array();
    if( !empty($this->_topLevelId) ) $selected[$this->_topLevelId] = $this->_topLevelValue;

    foreach ($this->getElements() as $key  => $element) {
      $element->setTranslator($translator);

      $parts = explode('_', $key);


      if ( preg_match( '/[^0-9_]/', $key ) )
	  {
	  	continue ;
	  }
      // if( count($parts) !== 3 ) {
      //   continue;
      // }
      
      list($parent_id, $option_id, $field_id) = $parts;
      //if( !is_numeric($field_id) ) continue;

      $fieldObject = $structure[$key];
      
      // All top level fields are always shown
      if( !empty($parent_id) ) {
        
        $parent_field_id = $parent_id;
        $option_id = $option_id;
        
        // Field has already been stored, or parent does not have option
        // specified, <del>or field is a heading</del>
        if( isset($selected[$field_id]) || empty($selected[$parent_field_id]) /* || !isset($data[$key])*/ ) {
          $element->setIgnore(true);
          continue;
        }

        // Parent option doesn't match
        if( is_scalar($selected[$parent_field_id]) && $selected[$parent_field_id] !=  $option_id ) {
          $element->setIgnore(true);
          continue;
        } else if( is_array($selected[$parent_field_id]) && !in_array($option_id, $selected[$parent_field_id]) ) {
          $element->setIgnore(true);
          continue;
        }
      }

      // This field is being used
      if( isset($data[$key]) )
      {
        $selected[$field_id] = $data[$key];
      }

      if( $element instanceof Engine_Form_Element_Heading )
      {
        $element->setIgnore(true);
      }
      else if( !isset($data[$key]) )
      {
        $valid = $element->isValid(null, $data) && $valid;
      }
      else
      {
        $valid = $element->isValid($data[$key], $data) && $valid;
      }



    


    }
    $this->_processedValues = $selected;
    // Done changing

    foreach ($this->getSubForms() as $key  => $form) {
      $form->setTranslator($translator);
      if (isset($data[$key])) {
        $valid = $form->isValid($data[$key]) && $valid;
      } else {
        $valid = $form->isValid($data) && $valid;
      }
    }

    $this->_errorsExist = !$valid;
    return ($valid && $isValid);
  }

}