<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteuserimport
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Import.php 6590 2013-04-01 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteuserimport_Form_Admin_Import extends Engine_Form {

  public function init() {

    $this->setTitle('Import a File')
    ->setDescription("Add a CSV file to import Users’ details corresponding to the entries in it, and then click on ‘Submit’ button. [Note: Choose the correct ‘Profile Type’ for which you are importing Users’ details through CSV file.]")
    ->setAttrib('enctype', 'multipart/form-data')
    ->setAction(Zend_Controller_Front::getInstance()->getRouter()->assemble(array()));


        // Element: profile_type
        $topStructure = Engine_Api::_()->fields()->getFieldStructureTop('user');
        if( count($topStructure) ==  1 && $topStructure[0]->getChild()->type ==  'profile_type' ) {
          $profileTypeField = $topStructure[0]->getChild();
          $options = $profileTypeField->getOptions();
          

          if( count($options) > 1 ) {
            $options = $profileTypeField->getElementParams('user');
           
            unset($options[ 'options' ][ 'order' ]);
            unset($options[ 'options' ][ 'multiOptions' ][ '0' ]);
            $this->addElement('Select', 'profile_type', array_merge($options[ 'options' ], array(
                  'required'  => true,
                  'allowEmpty'  => false,
                  'tabindex'  => 1, //$tabIndex++,
                  'value' => $this->_profileType,
                  'onchange' =>'showHint(this.value)',
               )));
            $selectElement = $this->getElement('profile_type');
            $selectElement->removeMultiOption('');  

          } else if( count($options) ==  1 ) {
            $this->addElement('Hidden', 'profile_type', array(
              'value'  => $options[0]->option_id,
              'order' => 10001,
           ));
          }
        }




    $this->addElement('File', 'filename', array(
        'label' => 'Import File',
        'required' => true,
    ));
    $this->filename->addValidator('Extension', false, 'csv,CSV');
    $this->filename->getDecorator('Description')->setOption('placement', 'append');

    $this->addElement('Radio', 'import_seperate', array(
        'label' => 'File Columns Separator',
        'description' => 'Select a separator from below which you are using for the columns of the CSV file.',
        'required' => true,
        'allowEmpty' => false,
        'multiOptions' => array(
            1 => "Pipe ('|')",
            0 => "Comma (',')"
        ),
    ));
    $this->import_seperate->getDecorator('Description')->setOptions(array('style'=>'color:#000 !important;margin-top:42px'));

    $this->addElement('Button', 'submit', array(
        'label' => 'Submit',
        'type' => 'submit',
        'onclick' => "javascript:showLightbox()",
        'decorators' => array(
            'ViewHelper',
        ),
    ));

    $this->addElement('Cancel', 'cancel', array(
        'label' => 'cancel',
        'link' => true,
        'prependText' => ' or ',
        'onclick' => "javascript:parent.Smoothbox.close()",
        'decorators' => array(
            'ViewHelper',
        ),
    ));

    $this->addDisplayGroup(array(
        'submit',
        'cancel',
            ), 'buttons', array(
        'decorators' => array(
            'FormElements',
            'DivDivDivWrapper'
        ),
    ));
  }

}