<?php
/**
 * SocialEngine
 *
 * @category   Application_Core
 * @package    Siteuserimport
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 * @version    $Id: AdminManageController.php 9919 2013-02-16 00:46:04Z matthew $
 * @author     John
 * @category   Application_Core
 * @package    Siteuserimport
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 */
class Siteuserimport_AdminIndexController extends Core_Controller_Action_Admin
{
  
public function makeCsvDefaultUserData( $columnDefaultCsvFile, $getFormValues, $keysFieldStructure, $params)
{

    $tableMember = Engine_Api::_()->getDbtable('levels', 'authorization');

    $sqlquery = $tableMember->select()
         ->from($tableMember->info('name'))
         ->where( 'level_id =?', $params['member_level'] );
    $userIdIs =  $tableMember->fetchRow($sqlquery)->toArray();

    // Read data from default csv file Here.
    $defaultCsvFilePath = realpath(APPLICATION_PATH . "/public/siteuserimport/default_user/default_user_csv_file.csv");
    @chmod($defaultCsvFilePath, 0777);
    $defaultfile = fopen( $defaultCsvFilePath , "r");
    if ((!$defaultfile)) {
      echo "$defaultCsvFilePath File opening error";
      exit;
    }

    $getDefaultUserIndex = 0;
    while ( $buffer = fgets($defaultfile, 10000)) {
      if( $getDefaultUserIndex < 1 ) {
        $explodeArray = explode('|', $buffer);
        $getDefaultUserIndex++;
        continue ;
      }
      $defaultCsvFiledata[] = explode('|', $buffer);
    }
    
    // get data of that field for which form value is set.
    $getDefaultCsvData = array();
    foreach ($getFormValues as $getKeyFormValue => $getvalueFormValues) {
      if( in_array( $getKeyFormValue , $columnDefaultCsvFile )) {
          $getDefaultCsvData[ $getKeyFormValue ] = $getvalueFormValues ;
      }
    }
  
    // Create Structure of First line in download file. As well as store its key for further process.
    $keyDownloadCsvFile = array();
    $i = 0;
    foreach ($keysFieldStructure  as $setKeyDownloadFile => $setValueDownloadFile ) {
      if( $setKeyDownloadFile == 'profile_type' || $setKeyDownloadFile == 'submit') {
        continue;
      }
      $keyDownloadCsvFile[ $setKeyDownloadFile ] = $i ;
      $i++;
    }
  
    $csvFileColumnNameString = '';
    foreach ($keysFieldStructure as $keyField => $keyFieldValue ) {

      // Add column heading in the text field 
      if( $keyField == 'profile_type' || $keyField == 'submit' ) {
        continue ;
      } else if( $keyField == 'package_id') {
          $csvFileColumnNameString =  '[' . $keyFieldValue['label'] . ']' 
                                      . '[' . $keyFieldValue['required'] . ':  '
                                      . $keyFieldValue['valueTimes'] . ']' 
                                      . '[' . $keyFieldValue['type'] . ']' ;

          // Set options here.
          $csvFileColumnNameString = $csvFileColumnNameString . '(' ;
          foreach ($keyFieldValue['optionStore'] as $valuePackageOption ) {
            # code...
            $csvFileColumnNameString = $csvFileColumnNameString . explode( '(', $valuePackageOption )[0] . ':';
          }
          $csvFileColumnNameString = $csvFileColumnNameString . ')' ;
      } else if( $keyField == 'email' ) {
          $csvFileColumnNameString = $csvFileColumnNameString . '|'
                                      . '[' . $keyFieldValue['label'] . ']' 
                                      . '[' . $keyFieldValue['required'] . ':  '
                                      . $keyFieldValue['valueTimes'] . ']' 
                                      . '[' . $keyFieldValue['type'] . ']' ;
      } else if( $keyField == 'password' || $keyField == 'passconf' || $keyField == 'username' ) {

          $csvFileColumnNameString = $csvFileColumnNameString . '|' 
                                      . '[' . $keyFieldValue['label'] . ']' 
                                      . '[' . $keyFieldValue['required'] . ': '
                                      . $keyFieldValue['valueTimes'] . ']' 
                                      . '[' . $keyFieldValue['type'] . ']' ;

      } else if( $keyField == 'timezone' || $keyField == 'profile_photo' || $keyField == 'multiCheckbox' || $keyField == 'member_level' || $keyField == 'cover_photo' || $keyField == 'sitevarify' ) {
          $csvFileColumnNameString = $csvFileColumnNameString . '|' 
                                      . '[' . $keyFieldValue['label'] . '][' ;
          if(  array_key_exists( 'required', $keyFieldValue )) {
              $csvFileColumnNameString = $csvFileColumnNameString . $keyFieldValue['required'] . ': ' ;
          }
              $csvFileColumnNameString = $csvFileColumnNameString 
                                      . $keyFieldValue['valueTimes'] . ']' 
                                      . '[' . $keyFieldValue['type'] . ']' ;
      } else if( preg_match('/[0-9]+_[0-9]+_[0-9]+$/', $keyField ) ) {
        // Create String for remaining Dynamic element Remaining Dynamic element.
        $getStringKeyField = '|[' . $keyFieldValue['label'] . ']' . '[' ;
        // If field is required then 
        if( array_key_exists('required', $keyFieldValue )) {
          $getStringKeyField = $getStringKeyField . $keyFieldValue['required'] . ': ' ;
        }
        $getStringKeyField = $getStringKeyField . $keyFieldValue['valueTimes'] . '][' . $keyFieldValue['type']  ;
        // If it is date type then add formet of date
        if( $keyFieldValue['type'] == 'Date') {
            $getStringKeyField = $getStringKeyField . ' yyyy-mm-dd';
        }
        $getStringKeyField = $getStringKeyField . ']' ;
        // If option is present their 
        if( array_key_exists('option', $keyFieldValue) ) {
          $getStringKeyField = $getStringKeyField . '(' . $keyFieldValue['option'] . ')' ;
        }
        $csvFileColumnNameString = $csvFileColumnNameString  . $getStringKeyField ;
      } else if( $keyField == 'language'  ) {

          $topStructure = Engine_Api::_()->fields()->getFieldStructureTop( 'user' );
          $options = $topStructure[0]->getChild()->getOptions();
          $profileType = $options[0]->option_id;
          $form = new Siteuserimport_Form_Admin_AddDataBulkForm(
                                        array(   
                                                'profileType' => $profileType,
                                        )                                            
                                    );

          $getLanguage = $form->language->options ;   
          $csvLangageOption = implode(':', array_keys( $getLanguage ) );

          $csvFileColumnNameString = $csvFileColumnNameString . '|' 
                                      . '[' . $keyFieldValue['label'] . '][' 
                                      
                                      . $keyFieldValue['valueTimes'] . ']' 
                                      . '[' . $keyFieldValue['type'] . '](' 
                                      . $csvLangageOption . ')'
                                      ;
      }
    }

    $createDefaultPath = realpath(APPLICATION_PATH . "/public/");
    $filePath = "$createDefaultPath/siteuserimport/default_user/customDummyData.csv";
    @chmod($createDefaultpath, 0777); 
    @chmod($filePath, 0777);

    // If file is already exits then delete it.
    if( file_exists( $filePath )) {
      unlink( $filePath );
    }

    @chmod($createDefaultpath, 0777); 
    @chmod($filePath, 0777);

    $setDataCsv = fopen($filePath, 'w+');
    $enterDefaultCsvFileIndex = 1;
    $enterDefaultCsvFile[0] = $csvFileColumnNameString ;
    // fwrite($setDataCsv, $csvFileColumnNamseString );
    
    $getColumnIndex = explode( '|', $csvFileColumnNameString );
   // $timezoneIndex = array_search( "[Timezone][Required: Single Value][Select]" , $getColumnIndex );

 
    // If email id is already then do not add that id.
    $userTableData = Engine_Api::_()->getDbtable( 'users', 'user' );
    $select = $userTableData->select()
                        ->from($userTableData->info('name'), 'email');
    $emailId = $userTableData->fetchAll($select);

    foreach ($emailId as $emailKey => $emailValue) {
      $emailArray[ $emailKey ] = $emailValue['email'] ;
    }

    // Write data in new csv file.
    // Make Csv file Data In form Of array then set as A string.

    $genderKey = $getDefaultCsvData[ $params['gender'] ]; 
    if( empty( $genderKey ) ){
      $genderKey = 5;
    }

    foreach( $defaultCsvFiledata as $defaultCsvSingleLineKey => $defaultCsvSingleLineValue ) {
      
        $singleUserDataString = NULL ;
        $singleUserDataString = array();

        // At index 0 email id will be store then check all email from here.
        if( in_array( explode( '@', $defaultCsvSingleLineValue[0] )[0] ."@". $params['domainName'] , $emailArray ) ) {
          continue ;
        }

        if( ($params['type_of_insertion'] == 1 && $defaultCsvSingleLineValue[$genderKey] == 'Female') || ($params['type_of_insertion'] == 2 && $defaultCsvSingleLineValue[$genderKey] == 'Male') ){
            continue;
        }

        foreach ( $keyDownloadCsvFile as $getDownloadFileKey => $getDownloadFileColumnValue) {
          if( array_key_exists( $getDownloadFileKey, $getDefaultCsvData )) {
              // If key Exist then then Set value from csc file

              $singleUserDataString[ $getDownloadFileKey ] = $defaultCsvSingleLineValue[ $getDefaultCsvData[ $getDownloadFileKey] ];
          } else {
            $singleUserDataString[ $getDownloadFileKey ] = NULL;
          }
        }


        // Set package name for data 
        if( !empty( $params['package_id'])) {
          $singleUserDataString['package_id'] = explode( '(', $keysFieldStructure['package_id']['optionStore'][ $params['package_id'] ] )[0];
        }

        // Domain Name in last of email id
        $singleUserDataString['email'] = explode( '@', $singleUserDataString['email'] )[0] ."@". $params['domainName'] ;
        $singleUserDataString['timezone'] = $params['timezone'] ;

        if( !empty( $params['language'] )) {
         
          $topStructure = Engine_Api::_()->fields()->getFieldStructureTop( 'user' );
          $options = $topStructure[0]->getChild()->getOptions();
          $profileType = $options[0]->option_id;
          $form = new Siteuserimport_Form_Admin_AddDataBulkForm(
                                        array(   
                                                'profileType' => $profileType,
                                        )                                            
                                    );

          $singleUserDataString['language'] = $params['language'] ;
        }
        // Set member level 
        if( $userIdIs['title'] == "Superadmins" ) {

          $singleUserDataString['member_level'] = "Super Admins";
        } else  {

          $singleUserDataString['member_level'] = $userIdIs['title'];
        }
        
        // Check if last word is newline charecter
        $len = strlen( $singleUserDataString['username'] );
        if( $singleUserDataString['username'][$len - 1 ] == "\n" ) {
          
          $singleUserDataString['username'] = substr( $singleUserDataString['username'] , 0 , $len - 1 );
        }
        $finaleSingleUserData = '';
        $finaleSingleUserData = implode('|', $singleUserDataString );
        array_push( $enterDefaultCsvFile , $finaleSingleUserData) ; 
        
    }
    
    $enterDefaultCsvFile = implode("\n", $enterDefaultCsvFile );
    fwrite( $setDataCsv, $enterDefaultCsvFile ) ;
    fclose( $setDataCsv );
   return ;

  }


  // Download Csv files with default csv data
  public function downloadDefaultCsvAction()
  {

    $filePath = realpath(APPLICATION_PATH . "/public/siteuserimport/default_user/customDummyData.csv");
    @chmod($filePath, 0777);

    //KILL ZEND'S OB
    $isGZIPEnabled = false;
    if (ob_get_level()) {
        $isGZIPEnabled = true;
          @ob_end_clean();
    }
   
    header("Content-Disposition: attachment; filename=" . urlencode(basename($filePath)), true);
    header("Content-Transfer-Encoding: Binary", true);
    //header("Content-Type: application/x-tar", true);
    // header("Content-Type: application/force-download", true);
    header("Content-Type: application/octet-stream", true);
    header("Content-Type: application/download", true);
    header("Content-Description: File Transfer", true);
    if(empty($isGZIPEnabled)){
      header("Content-Length: " . filesize($filePath), true);
    } 
    
    readfile("$filePath");
    exit();
  }

  // Download default csv file Profile Photo
  public function downloadDefaultCsvProfilePhotoAction() 
  {

    $filePath = realpath(APPLICATION_PATH . "/public/siteuserimport/default_user/profile_photo/profile_photo.zip");
    //@chmod($path, 0777);
    @chmod($file_path, 0777);

    //KILL ZEND'S OB
    $isGZIPEnabled = false;
    if (ob_get_level()) {
        $isGZIPEnabled = true;
          @ob_end_clean();
    }
   
    header("Content-Disposition: attachment; filename=" . urlencode(basename($filePath)), true);
    header("Content-Transfer-Encoding: Binary", true);
    //header("Content-Type: application/x-tar", true);
    // header("Content-Type: application/force-download", true);
    header("Content-Type: application/octet-stream", true);
    header("Content-Type: application/download", true);
    header("Content-Description: File Transfer", true);
    if(empty($isGZIPEnabled)){
      header("Content-Length: " . filesize($filePath), true);
    } 
    
    readfile("$filePath");
    exit();
  }
  // To Do's after chunks finish inertion
  public function afterBulkSaveAction(){

      $data = array('status'=>'error');
      try{
        
        $post = $this->_getAllParams();
        if(empty($post)){
          throw new Exception('Required status approval data missing') ;
        }
        
        $params = $post['params'];
        $referer = $post['referer'];

        if(!isset($params['keys'])) {
          $params['keys'] = array();
        }

        if($referer == "add-bulk-data-csv"){
          
          $getDummyUserSetting = Engine_Api::_()->getApi('settings', 'core');

          $maleUser = $getDummyUserSetting->getSetting('siteuserimport.maleuser', 0);
          $femaleUser = $getDummyUserSetting->getSetting('siteuserimport.femaleuser', 0);
          
          if( $params[ 'type_of_insertion' ] == '3' ) {
              
              $getDummyUserSetting->setSetting('siteuserimport.femaleuser', 0);
              $getDummyUserSetting->setSetting('siteuserimport.maleuser', 0);
              $getDummyUserSetting->setSetting( 'siteuserimport.bothuser' , 0);
          }
          
          if ( $params[ 'type_of_insertion' ] == '2' ) {
              $getDummyUserSetting->setSetting('siteuserimport.femaleuser', 0);
              if( $maleUser == 0 ) {
                  $getDummyUserSetting->setSetting( 'siteuserimport.bothuser' , 0);
              }
          }
          
          if($params[ 'type_of_insertion' ] == '1' ) {
              $getDummyUserSetting->setSetting('siteuserimport.maleuser', 0);
                if( $femaleUser == 0 ) {
                  $getDummyUserSetting->setSetting( 'siteuserimport.bothuser' , 0);
                } 
          }        

        }else if($referer == 'edit'){
            
              // $deleteValues = $params['keys'] ;
              $getFileTable = Engine_Api::_()->getDbtable('addFileDetails', 'siteuserimport');
              
              $getFileTable->deleteRow( $params['fileId'], $params['keys']);
        }
        $data['status']='success';          
      }catch(Exception $e){

          $data['msg'] = $e->getMessage();
      }
      echo json_encode($data);
      die();
  }

  //ACTION FOR SAVING CHUNK 
  public function bulkSaveAction(){

    $result = array();
    $getPost = $this->getRequest()->getPost();
    $post = $getPost['data'];
    $params =  $getPost['params'];

    if(empty($post)){
      $result['status'] = 'error';
      $result['msg'] = 'Chunk Posted is empty';
    }
    if(isset($post) && count($post)>0){
      
      $file = NULL;
      if(!empty($params['fileId'])){
        $file = $params['fileId'];
      }

      $isDummy = false;
      if(!empty($getPost['referer']) && $getPost['referer'] == 'add-bulk-data-csv'){
        $isDummy = true;
      }

      $db = Zend_Db_Table_Abstract::getDefaultAdapter();
      
      try{
        
        foreach($post as $userData){
          
          $db->beginTransaction();
          $profilePhoto = isset($userData['profile_photo']) ? $userData['profile_photo'] : null;
          $coverPhoto = isset($userData['cover_photo']) ? $userData['cover_photo'] : null;
         
          $savedUser = $this->saveUser( $userData , $file, $isDummy, $profilePhoto, $coverPhoto);
          if(!$savedUser){
            throw new Exception("User not saved. Error in func : saveUser");
          }

          $db->commit();
        }
        // $this->afterBulkSave($getPost['referer'],$getPost['params']);
        
        $result['status'] = 'success';
        $result['count'] = count($post);
        $result['msg'] = 'Saved Successfully';   
      }catch(Exception $e){
        $db->rollback();
        $result['status'] = 'error';
        $result['msg'] = $e->getMessage();
      }
    }
    echo json_encode($result);
    die();
  }
  //ACTION FOR SHOWING THE FAQ
  public function faqAction() 
  {
    
    $this->view->faq = $faq = 1;
    
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                       ->getNavigation('siteuserimport_admin_main', array(), 'siteuserimport_admin_main_faq');
    
    $this->view->faq_type = $this->_getParam('faq_type', 'general');        
  }

  // Get data in  bulk t store.
  public function importAction() 
  {
      //INCREASE THE MEMORY ALLOCATION SIZE AND INFINITE SET TIME OUT
      ini_set('memory_limit', '2048M');
      set_time_limit(0);
      $this->_helper->layout->setLayout('default-simple');
      $this->view->form = $form = new Siteuserimport_Form_Admin_Import();

      if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {

        //MAKE SURE THAT FILE EXTENSION SHOULD NOT DIFFER FROM ALLOWED TYPE
        $ext = str_replace(".", "", strrchr($_FILES['filename']['name'], "."));
        if (!in_array($ext, array('csv', 'CSV'))) {
          $error = $this->view->translate("Invalid file extension. Only 'csv' extension is allowed.");
          $error = Zend_Registry::get('Zend_Translate')->_($error);
          $form->getDecorator('errors')->setOption('escape', false);
          $form->addError($error);
          return;
        }

        $formData = array();
        $formData = $form->getValues();
        if($formData['profile_type'] == NULL) {
          $topStructure = Engine_Api::_()->fields()->getFieldStructureTop( 'user' );
          $options = $topStructure[0]->getChild()->getOptions();
          $formData['profile_type'] = $options[0]->option_id;
        }
        $profile_type = $formData['profile_type'];
        // Create a table for profile field.
        $finalStringIs = $this->getColumnStructure($profile_type);

        //START READING DATA FROM CSV FILE
        $temp_name = $_FILES['filename']['tmp_name']; 
        $pos = strrpos($temp_name, "/");
        $substring = substr($temp_name, 0,$pos+1);
        $fname = $substring.$_FILES['filename']['name'];
        @chmod($fname, 0777);
        $fp = fopen($fname, "r");
        if ((!$fp)) {
          echo "$fname File opening error";
          exit;
        }
        if ($formData['import_seperate'] == 1) {
          while ($buffer = fgets($fp, 10000)) {
            $explode_array[] = explode('|', $buffer);
          }
        } else {
          while ($buffer = fgets($fp, 10000)) {
            $explode_array[] = explode(',', $buffer);
          }
        }
        $countNumberOfColumn = 0;
        foreach ($finalStringIs as $columnValue) {
            if( $columnValue['name'] == 'submit' || $columnValue['name'] == 'profile_type') {
                continue ;
          }
          $countNumberOfColumn++;
        }
        $countNumberOfCsvColumn = 0;
         foreach ($explode_array as $explodearrayKey => $explode_data) {

          if($explodearrayKey == 0 ) {
            foreach ($explode_data as $countColumn) { 
              $countNumberOfCsvColumn++;
            }
            break ;
          }
        }
        if( $countNumberOfCsvColumn != $countNumberOfColumn ) {
          $form->addError('Fields listed in the CSV file do not match with the fields of the selected profile type.');
          return ;
        } else if( count($explode_array) < 2 ) {
              $form->addError('CSV file does not contain any user detail. Csv file must have details of atleast one user.');
              return ;
        }else if( count($explode_array) > 501 ) {
              $form->addError('CSV file contains details of more then 500 users. Only 500 or less users can be add by a single CSV file.');
              return ;
        }
        
        else {
          $getStructureCsv =$this->getCsvFileColumnStructure( $finalStringIs );
          while($countNumberOfCsvColumn > 0) {
            $str1 = explode(']',$explode_array[0][$countNumberOfCsvColumn-1])[0];
            $str2 = explode(']',$getStructureCsv[$countNumberOfCsvColumn-1])[0];
            if( strcasecmp($str1,$str2) != 0) {
              $form->addError('Fields listed in the CSV file do not match with the fields of the selected profile type.');
              return ;
            }
              $countNumberOfCsvColumn--;
            }
        }
        $db = Engine_Db_Table::getDefaultAdapter();
        try {
            $getFileName = str_replace(" ", "", $_FILES['filename']['name']);
            $getFileName = str_replace(".csv", "", $getFileName);
            $db = Engine_Api::_()->getDbtable('addFileDetails', 'siteuserimport')->getAdapter();
            $db->beginTransaction();
            try {
              //SAVE OTHER DATA IN engine4_siteuserimport_fileimport TABLE
              $importFileDb = Engine_Api::_()->getDbtable('addFileDetails', 'siteuserimport');
              $importFile = $importFileDb->createRow();
              $importFile->filename = $_FILES['filename']['name'];
              $importFile->status = 'Pending';
              $date = $importFile->creation_date = date( 'Y-m-d H:i:s' );
              $importFile->profile_photo = NULL;
              $importFile->cover_photo = NULL;
              $importFile->total_count =  0;
              $importFile->profile_type = $profile_type ;
              $importFile->save();
              //COMMIT
              $db->commit();
              $sqlquery = $importFileDb->select()
                                        ->from( $importFileDb->info( 'name' ), 'fileimport_id' )
                                        ->where( 'creation_date = ?', $date )
                                        ->where( 'filename = ?', $_FILES['filename']['name'] );
             $getFileId = $importFileDb->fetchRow( $sqlquery ) ;
            } catch (Exception $e) {
              $db->rollBack();
              throw $e;
            }
            if(strlen($getFileName) > 20 ) {
              $getTableName = "";
              $getNameTable =  explode("_", $getFileName );
                foreach ($getNameTable as $key => $getNameT) {
                  $getTableName = $getTableName. substr($getNameT, 0,2).'_';
                }
                if(strlen($getTableName) <5) {
                  $getTableName =$getTableName.substr($getFileName, 0,5);
                }
             } else {
              $getTableName = "".$getFileName;
             }
              $getFileName = $getTableName;
            $tableName = 'engine4_siteuserimport_'.$getFileName.'_'.$getFileId['fileimport_id'];
            $sqlqueryIsAs = "CREATE TABLE IF NOT EXISTS `$tableName` ( `unique_Id` int(11) unsigned NOT NULL AUTO_INCREMENT,";
            foreach ($finalStringIs as $columnValue) {
              if( $columnValue['name'] == 'submit' || $columnValue['name'] == 'profile_type') {
                  continue ;
                }
              $sqlqueryIsAs = $sqlqueryIsAs .'`'.$columnValue['name']. '` varchar(255),';
           }
           $sqlqueryIsAs = $sqlqueryIsAs.'`error_is` text, primary key(`unique_Id`))'; 
           // Execuite query.
            $db->query($sqlqueryIsAs);
        } catch (Exception $e) {
            throw $e;
        }
        $import_count = 0;
        foreach ($explode_array as $explodearrayKey => $explode_data) {
          if($explodearrayKey == 0) {
            continue ;
          }
          $getInsertData = array();
          $indexRow =0;
          foreach ($finalStringIs as $columnValue) {
            if( $columnValue['name'] == 'submit' || $columnValue['name'] == 'profile_type' ) {
                continue ;
              }
              $getInsertData[$columnValue['name']] = isset($explode_data[$indexRow]) ? $explode_data[$indexRow] : '';
              $indexRow++;
           }
          $db = Engine_Db_Table::getDefaultAdapter();
          $db->beginTransaction();
          $conn = $db->getConnection();

          try {
              // Make  structure for insert  
              $insertQuery = "insert into `$tableName` ";
              $insertKeyIs = " (";
              $insertValueIs = " (";
              foreach ($getInsertData as $key => $value) {
                $insertKeyIs = $insertKeyIs.'`'.$key.'`, ' ;
                $value = str_replace("\n", "", $value );
                $value = $db->quote( $value );
                $insertValueIs = $insertValueIs." $value, " ;
              }
              $insertKeyIs = $insertKeyIs . ') ';
              $insertKeyIs = str_replace(", )"," )",$insertKeyIs);
              $insertValueIs = $insertValueIs . ') ';
              $insertValueIs = str_replace(", )"," )",$insertValueIs);
              $insertQuery = $insertQuery . $insertKeyIs . ' VALUES ' . $insertValueIs  ;
              $db->query($insertQuery);
            //COMMIT
            $db->commit();
            $import_count++;
          } catch (Exception $e) {
            $db->rollBack();
            throw $e;
          } 
      }

      try {
            $importFileDb->update(array('table_name' => $tableName, 'total_count' => $import_count), array('fileimport_id = ?' => $getFileId['fileimport_id']));
      } catch(Exception $e) {
          throw $e;
      }
    
      //CLOSE THE SMOOTHBOX
      $this->_forward('success', 'utility', 'core', array(
                      'smoothboxClose' => true,
                      'parentRedirect' => $this->_helper->url->url(array('module' => 'siteuserimport', 'controller' => 'index', 'action' => 'manage')),
                      'parentRedirectTime' => '15',
                      'format' => 'smoothbox',
                      'messages' => array(Zend_Registry::get('Zend_Translate')->_('CSV file has been imported succesfully !'))
                  ));
    }
  }



  public function multiDeleteAction() 
  {

      if( !$this->getRequest()->isPost() )
      {
          return $this->_helper->redirector->gotoRoute(array('module' => 'siteuserimport', 'controller' => 'index', 'action' => 'manage', ));
      }
      // Now get ids of file here which is going to delete.
      $fileIdIs = $this->getRequest()->getPost();
      if( is_null( $fileIdIs) ) {
        return $this->_helper->redirector->gotoRoute(array('module' => 'siteuserimport', 'controller' => 'index', 'action' => 'manage', ));
      }
      // first delete photos from this location.
      foreach ($fileIdIs as  $fileId) {
        $reviewimportfileTable = Engine_Api::_()->getDbtable('addFileDetails', 'siteuserimport');
        $selectImportTable = $reviewimportfileTable->select()
                           ->from($reviewimportfileTable->info('name'))
                            ->where('fileimport_id = ?',$fileId);
        $fileRow = $reviewimportfileTable->fetchRow($selectImportTable);

        if( count($fileRow) < 1) {
          return $this->_helper->redirector->gotoRoute(array('module' => 'siteuserimport', 'controller' => 'index', 'action' => 'manage', ));
        }

        // delete row from table as well as drop table.
        try {
          $db = Engine_Db_Table::getDefaultAdapter();
        $dropTable = "DROP TABLE IF EXISTS `".$fileRow['table_name']."`" ;
        
        $status1 = $db->query($dropTable);
        $status2 = $reviewimportfileTable->delete(array('fileimport_id = ?' => $fileRow['fileimport_id']));
        
        $path = APPLICATION_PATH . "/public/siteuserimport/fileimport_".$fileRow['fileimport_id'] ;
        $reviewimportfileTable->removeDirectory($path);  

        } catch(Exception $e ) {
          throw $e ;
        }
      }
      return $this->_helper->redirector->gotoRoute(array('module' => 'siteuserimport', 'controller' => 'index', 'action' => 'manage', ));
  }

 public function uploadAction()
  {
    $fileimport_id = $this->_getParam('fileimport_id');
    $fileType = $this->_getParam('type');
    $basePath = 'siteuserimport/fileimport_' . $fileimport_id;
    if($fileType == 1) {
        $photo = 'profile_photo';
    } else {
          $photo = 'cover_photo';
    }
    if (is_dir(APPLICATION_PATH . "/public/$basePath/$photo") != 1) {
      @mkdir(APPLICATION_PATH . "/public/$basePath/$photo", 0777, true);
    }
    @chmod(APPLICATION_PATH . "/public/$basePath/$photo", 0777);
    $this->view->path = $path = APPLICATION_PATH . "/public/$basePath/$photo";
    $getSubDirInfo = scandir($path) ;
    // Check method
    if (!$this->getRequest()->isPost()) {
      return;
    }
    // Check ul bit
    if (null === $this->_getParam('ul')) {
      return;
    }

    // Prepare
    if (empty($_FILES['Filedata'])) {
      $this->view->error = 'File failed to upload. Check your server settings (such as php.ini max_upload_filesize).';
      return;
    }

    // Prevent evil files from being uploaded
    $disallowedExtensions = array('zip');
    //end function only accept array, so first check the exploded var is array or not
    $explodeResults = explode(".", $_FILES['Filedata']['name']);
    if ( is_array($explodeResults) && !in_array(end($explodeResults), $disallowedExtensions)) {
      $this->view->error = 'File type or extension forbidden.';
      return;
    }

    $info = $_FILES['Filedata'];
    $targetFile = $path . '/' . $info['name'];
    $vals = array();

    if (file_exists($targetFile)) {
      $this->view->error = Zend_Registry::get('Zend_Translate')->_("File already exists.");
      return;
    }
    
    //If their is already a file at that location remove that with folder.
    foreach ($getSubDirInfo as $dirKey => $subDir ) {
        if ( $subDir === '.' or $subDir === '..') continue;
        if (is_dir($archiveProfilePhoto . $subDir )) {
            $getExtractFileName = $archiveProfilePhoto  . $subDir  ;
            break ;
        }
    }

    // Try to move uploaded file
    @chmod(APPLICATION_PATH. "/public/siteuserimport", 0777);
    if (!move_uploaded_file($info['tmp_name'], $targetFile)) {
      $this->view->error = Zend_Registry::get('Zend_Translate')->_("Unable to move file to upload directory.");
      return;
    }

    $reviewimportfileTable = Engine_Api::_()->getDbtable('addFileDetails', 'siteuserimport');
    
    $selectImportTable = $reviewimportfileTable->select()
                           ->from($reviewimportfileTable->info('name'),$photo)
                            ->where('fileimport_id = ?',$fileimport_id);
    $fileName = $selectImportTable->query()->fetchColumn();
    
    if(!empty($fileName)) {
      $import_image_path = "$basePath/$photo/$fileName";
      @unlink(APPLICATION_PATH . "/public/".$import_image_path );
    }
   
    $reviewimportfileTable->update(array($photo => $_FILES['Filedata']['name']), array('fileimport_id = ?' => $fileimport_id));

    $this->view->target_path = $info['tmp_name'];
    $this->view->status = 1;

    // Redirect
    if (null === $this->_helper->contextSwitch->getCurrentContext()) {
      return $this->_helper->redirector->gotoRoute(array('action' => 'index'));
    } else if ('smoothbox' === $this->_helper->contextSwitch->getCurrentContext()) {
      return $this->_forward('success', 'utility', 'core', array(
                  'smoothboxClose' => true,
                  'parentRefresh' => true,
              ));
    }
  }

 

  public function uploadPhotoAction() 
  {
      //GET NAVIGATION
    
     $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
          ->getNavigation('siteuserimport_admin_main', array(), 'siteuserimport_admin_import');
          // Get id of file from which photo is going to upload
      $this->view->importfile_id = $importfile_id = $this->_getParam('importfile_id');

      $this->view->importFile = Engine_Api::_()->getItem('siteuserimport_addFileDetail', $importfile_id);

      $tableImportFile = Engine_Api::_()->getDbTable('addFileDetails', 'siteuserimport');
      $select = $tableImportFile->select();
     // If already a file then remove it.
      
  }
  

    //ACTION FOR MANAGING THE CSV FILES DATAS
  public function manageAction() {
    //GET NAVIGATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
            ->getNavigation('siteuserimport_admin_main', array(), 'siteuserimport_admin_import');

     $this->view->siteusercoverphoto = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('siteusercoverphoto');

    //FORM CREATION FOR SORTING
    $this->view->formFilter = $formFilter = new Siteuserimport_Form_Admin_Filter();
    $page = $this->_getParam('page', 1);
    
    $tableImportFile = Engine_Api::_()->getDbTable('addFileDetails', 'siteuserimport');
    $select = $tableImportFile->select();

    //IF IMPORT IS IN RUNNING STATUS FOR SOME FILE THAN DONT SHOW THE START BUTTON FOR ALL
    $importFileStatusData = $tableImportFile->fetchRow(array('status = ?' => 'Running'));
    $this->view->runningSomeImport = 0;
    if (!empty($importFileStatusData)) {
      $this->view->runningSomeImport = 1;
    }

    $values = array();
    if ($formFilter->isValid($this->_getAllParams())) {
      $values = $formFilter->getValues();
    }

    foreach ($values as $key => $value) {
      if (null === $value) {
        unset($values[$key]);
      }
    }

    $values = array_merge(array(
        'order' => 'fileimport_id',
        'order_direction' => 'DESC',
            ), $values);

    $this->view->assign($values);

    $select->order((!empty($values['order']) ? $values['order'] : 'fileimport_id' ) . ' ' . (!empty($values['order_direction']) ? $values['order_direction'] : 'DESC' ));
    $this->view->paginator = $paginator = Zend_Paginator::factory($select);
   
    $this->view->total_slideshows = $paginator->getTotalItemCount();
    $this->view->paginator->setItemCountPerPage(10);
    $this->view->paginator = $paginator->setCurrentPageNumber( $page );
  }



  public function editAction() 
  {
    
    $editUser = Zend_Registry::isRegistered('editImportFile')?Zend_Registry::get('editImportFile'):null;
    
    if(empty($editUser)){
      $this->_helper->content->setNoRender() ;
    }

    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
                                                           ->getNavigation('siteuserimport_admin_main', array(), 'siteuserimport_admin_import');
    
    $this->view->userTable = $userTable = Engine_Api::_()->getDbTable('users','siteuserimport');
    $this->view->fileImportId = $fileImportId = $this->_getParam('fileimport_id');
    $this->view->page = $page = $this->_getParam('page', 1);
    $this->view->itemCountPerPage = $itemCountPerPage = $this->_getParam('itemCountPerPage',20);
    $this->view->isAjax = $ajax = $this->_getParam('is_ajax', false);
    $tableFileDetails = Engine_Api::_()->getDbtable('addFileDetails', 'siteuserimport');
    $sqlquery = $tableFileDetails->select()
               ->from($tableFileDetails->info('name'))
               ->where('fileimport_id = ?', $fileImportId);
    $fileDetailsIs =  $tableFileDetails->fetchAll($sqlquery)->toarray();
    if ( count( $fileDetailsIs ) <= 0 ) {
      return $this->_helper->redirector->gotoRoute(array('module' => 'siteuserimport', 'controller' => 'index', 'action' => 'manage', ));
    }
    $this->view->fileName = $fileDetailsIs[0]['filename'];
       
    $db = Engine_Db_Table::getDefaultAdapter();
    try{
      $getTableIfExist = $db->describeTable( $fileDetailsIs[0]['table_name'] );
    } catch (Exception $e) {
     // throw $e;
      // All data is From table is deleted  and table is droped
      // Move on manage Action
      return $this->_helper->redirector->gotoRoute(array('module' => 'siteuserimport', 'controller' => 'index', 'action' => 'manage', ));
      
    }

    try {
      $getFinalStringAs = $this->getColumnStructure( $fileDetailsIs[0]['profile_type'] );
      // All element to set a select box in static field.
      $getElementsSelect = array();
      foreach ($getFinalStringAs as $value) {
        $getElementsSelect[ $value['name']] = $value;
      }
      $this->view->getElementsSelect = $getElementsSelect;

      $nameLabels = array();
      foreach ($getFinalStringAs as $value) {
            $nameLabels[$value['name']] = $value['label'];  
      }
      $this->view->nameLabels = $nameLabels;

      $select = new Zend_Db_Select($db);
      $select->from($fileDetailsIs[0]['table_name']);
      $this->view->getEditData = $getEditData = $select->query()->fetchAll();
     
      // Get Table Columns 
      $this->view->TotalNumberRow = $TotalNumberRow = count( $getEditData ) ;
        if( $TotalNumberRow == 0 ) {
          $this->view->ShowData = "Their is no data to show " ;
        } else {

          $this->view->paginator = $paginator = Zend_Paginator::factory($getEditData);
         
          $this->view->totalCount = $paginator->getTotalItemCount();
          $paginator->setItemCountPerPage($itemCountPerPage);
          $paginator->setCurrentPageNumber($page);
          $this->view->paginator= $paginator;

        }
      
      $query = $db->query('SELECT COUNT(1) as `errors` FROM `'.$fileDetailsIs[0]['table_name'].'` WHERE `error_is` IS NOT NULL');
      $errorsCount = $query->fetch();
      $this->view->errorCount = $errorsCount = $errorsCount['errors'];
      $this->view->sNo = $sNo = $this->_getParam('sNo',1);
        if($ajax){
          $html = '';
          foreach ($paginator as $item ){ 
            $html.='<tr><td><input name="'.'d_'.$item['unique_Id'].'" type="checkbox" class="checkbox" value="'.$item['unique_Id'].'"/></td>';
            $html.='<td><b>'.($sNo++).'<b></td>';
            $errors = json_decode($item['error_is']);
            $renderError = false;
            foreach ($item as $key => $data) {
              if( ($key == 'unique_Id' && $errorsCount == 0) || $key == 'error_is'){
                continue;
              }
              
              $html.='<td width="100%" >';
                if($errorsCount > 0 && !$renderError){
                  $renderError = true;
                  $html.='<div width="1%" align="left"  style="width: 240px; max-width:250px !important; max-height: 60px !important; overflow:auto;  "> 
                            <ul>';
                              foreach ($errors as $name=>$error) { 
                                $html.='<li><b>'.$nameLabels[$name].'</b> : '.$error.'</li>'; 
                              }
                  $html.='</ul></div>';
                }else{
                  $errorClass = "";
                  if(array_key_exists($key, $errors)){
                    $errorClass = "error";
                  }
                  // For all static element make dropdown if it consist option
                  if(! preg_match( '/^[0-9]+_[0-9]+_[0-9]+$/', $key ) && array_key_exists('optionStore', $getElementsSelect[ $key ]) && $getElementsSelect[ $key ]['valueTimes'] == 'Single Value' ) {
                      $html.=$userTable->setSelectDropdown($data,$item['unique_Id'],$errorClass, $key, $getElementsSelect[$key][ 'optionStore' ], $getElementsSelect[$key][ 'name' ], empty( $errors ));
                  } else{
                    $html.='<input name="'.$key.'" class="data_'.$item['unique_Id'].' '.$errorClass.'" type="text" id="'.$this->fileImportId.'" value="'.$data.'"/>';
                  }  
                }
              $html.='</td>';
            }
            $html.='';
          }

          $data = array('data'=>$html,'sNo'=>$sNo);
          echo json_encode($data);
          die();
        }

    } catch(Exception $e) {
      throw $e;         
    }
  }
  
  // getdata to insertion here. [CSV Import Save]
  public function bulkInsertionAction()
  {
    $data = $this->getRequest()->getPost() ;
    // get file details here.
    $fileId = $this->_getParam('fileimport_id');
    $this->_helper->content->setNoRender();

    //pfofile type
    $table = Engine_Api::_()->getDbtable('addFileDetails','siteuserimport');
    $db = $table->getAdapter();
    $sqlQuery = $table->select()
               ->from($table->info('name'))
               ->where('fileimport_id = ?', $fileId );
          
    $userProfileType =  $table->fetchRow($sqlQuery)->toarray();
   
    // Check if a user and profile photo zip is uploaded or not.
    $archiveProfilePhoto = APPLICATION_PATH . "/public/siteuserimport" . DIRECTORY_SEPARATOR ."fileimport_".$fileId. DIRECTORY_SEPARATOR . "profile_photo/";
    // IF not Null not then extract them And get Data 
    $isProfilePhotoZip = false ;
    $isCoverPhotoZip = false ;
    // Assign values here.
    Siteuserimport_Form_Admin_Addnewuserinformation:: $getProfilePhoto = $isProfilePhotoZip;
    Siteuserimport_Form_Admin_Addnewuserinformation:: $getCoverPhoto = $isCoverPhotoZip ;
    Siteuserimport_Form_Admin_Addnewuserinformation:: $getFileId = $fileId ;
     if( $userProfileType['profile_photo'] != NULL ) {

      $archiveProfilePhoto = APPLICATION_PATH . "/public/siteuserimport" . DIRECTORY_SEPARATOR ."fileimport_".$fileId. DIRECTORY_SEPARATOR . "profile_photo/";
      
        if(file_exists( $archiveProfilePhoto.$userProfileType['profile_photo'] )) {

          $zip = new ZipArchive;
          $res = $zip->open($archiveProfilePhoto.$userProfileType['profile_photo'] );
          $zip->extractTo( $archiveProfilePhoto );
          $zip->close();
          $getSubDirInfo = scandir($archiveProfilePhoto) ;
          foreach ($getSubDirInfo as $dirKey => $subDir ) {
                if ( $subDir === '.' or $subDir === '..') { 
                  continue;
                }

                if (is_dir($archiveProfilePhoto . $subDir )) {
                    $getExtractFileName = $archiveProfilePhoto  . $subDir  ;
                    break ;
                }
          }
          @chmod( $getExtractFileName, 0777);
          $isProfilePhotoZip = true ;
        }
     } 
     if( $userProfileType['cover_photo'] != NULL ) {
        $archiveCoverPhoto = APPLICATION_PATH ."/public/siteuserimport".DIRECTORY_SEPARATOR ."fileimport_".$fileId. DIRECTORY_SEPARATOR ."cover_photo/";
        if(file_exists( $archiveCoverPhoto.$userProfileType['cover_photo'] )) {
            // Extract
          $zip = new ZipArchive;
          $res = $zip->open($archiveCoverPhoto.$userProfileType['cover_photo'] );
          $result = $zip->extractTo( $archiveCoverPhoto );
          $zip->close();
          //If file exit 
       
        $getSubDirInfo = scandir($archiveCoverPhoto) ;
          foreach ( $getSubDirInfo as $dirKey => $subDir ) {
            if ( $subDir === '.' or $subDir === '..') continue;
            if (is_dir($archiveCoverPhoto . $subDir )) {
                $getExtractFileName = $archiveCoverPhoto  . $subDir  ;
                break ;
            }
          } 
          @chmod( $getExtractFileName, 0777);
          $isCoverPhotoZip = true ;
        }
     }

    // Profile And cover Photo Info to The Form
    Siteuserimport_Form_Admin_Addnewuserinformation::$getProfilePhoto = $isProfilePhotoZip;
    Siteuserimport_Form_Admin_Addnewuserinformation::$getCoverPhoto = $isCoverPhotoZip ;
    $finalStringIs = $this->getColumnStructure($userProfileType['profile_type']);
    $dynamicField = array();
    foreach ($finalStringIs as  $value) {
      if( $value['name'] == 'profile_type') {
        continue ;
      }
        $dynamicField[$value['name']] = $value;
    }
   
    $jsonData = array();
    $data['data'] = json_decode($data['data']);
    $uniqueKeys = array();
    foreach($data['data'] as $key => $Values) {
      
      $Values = (array)$Values;
      $formData = array();
      $error = null;
      $formData['profile_type'] = $userProfileType['profile_type'] ;
      $formData['submit'] = "";
      $formData['sitevarify'] = 0 ;
      $getListOfDates = array();

        foreach ( $Values  as $elementKey => $elementValue) {
          
          if( $elementKey == 'error_is') 
            continue ;
          
          if( $elementKey != 'timezone' && $elementKey != 'profile_photo' && $elementKey != 'cover_photo' && $elementKey != 'language' && $elementKey != 'multiCheckbox' && $dynamicField[ $elementKey ]['type'] != 'Text' ) {
            $elementValue = strtolower( $elementValue );
          }
            
          if( $elementKey == 'member_level' ) {
              $authorizationLevels = Engine_Api::_()->getDbtable('levels', 'authorization');
                $sqlquery = $authorizationLevels->select()
                                                ->from($authorizationLevels->info('name'),array('level_id', 'title'));
                $userMemberLevelIs  = $authorizationLevels->fetchAll($sqlquery)->toarray();
                $memberFlag = 0;
                foreach($userMemberLevelIs as $title) {
                  if( $elementValue == strtolower( $title['level_id'] )) {
                    
                    $memberFlag = 1;
                    $formData['member_level'] = $title['level_id'] ;
                    break;
                  }
                }
                
                if( $memberFlag == 0 ) {
                  $error['member_level'] = 'Please enter a member level here.' ;
                }
          } elseif ( $elementKey == 'multiCheckbox') {
               // $elementValue = strtolower( $elementValue );
                $index = 0 ;

                if( stripos($elementValue, $this->view->translate( 'Enabled' ) ) !== false )
                {
                    $formData['multiCheckbox'][ $index ] = 'enabled' ; 
                    $index++;    
                }
                if( stripos($elementValue, $this->view->translate( 'Approved' )) !== false ) {
                    
                    $formData['multiCheckbox'][ $index ] = 'approved' ;
                    $index++;
                }
                if( stripos($elementValue, $this->view->translate( 'Verified' )) !== false )
                {
                  $formData['multiCheckbox'][ $index ] = 'verified' ;
                  $index++;
                }
          } else if(  ! preg_match( '/[^0-9_]/', $elementKey )) {
                
                $testElementKey = explode('_', $elementKey);
                if( $testElementKey[0] != '1'  && $elementValue != NULL) {
                      $checkParent =  explode('_', $elementKey) ;
                        $getResultKeyValue = $this->checkArrayKey(array_keys($Values), $checkParent[ 0 ] );
                        // Make radio and Multi select box to decide one value.
                        $dynamicFieldType = strtolower($dynamicField[$getResultKeyValue]['type']) ;
                        if( $dynamicFieldType == 'select' || $dynamicFieldType == 'radio' ) {
                          if( isset($formData[ $getResultKeyValue ]) && $formData[ $getResultKeyValue ] != $checkParent[ 1 ]) {
                            // Set Error
                            $error[ $elementKey ] = " This field must be empty for the selected value of parent field ".$dynamicField[$getResultKeyValue]['label']."." ;
                          } else {
                              $formData[ $elementKey ] = $elementValue ;         
                          }
                        } else {
                          $flagCheck = false ;
                          if(isset($formData[ $getResultKeyValue ])) {
                            foreach( $formData[ $getResultKeyValue ] as  $getElementForm ) {
                              if( $getElementForm == $checkParent[ 1 ] || $elementValue == Null || $elementValue == '') {
                                  $flagCheck = true ;
                                  break ;
                              }
                            }
                          }

                          if( $flagCheck == false ) {
                            $error[$elementKey] = "This field must be empty for the selected value of parent field ". $dynamicField[$getResultKeyValue]['label']."." ;
                          } else {
                              $formData[ $elementKey ] = $elementValue ; 
                          }
                        }
                }

                $elementValue = trim( $elementValue );
                if( ( !isset($dynamicField[$elementKey]['option']) || isset($dynamicField[$elementKey]['option']) && is_null($dynamicField[$elementKey]['option']) ) && !empty( $elementValue ) ) {

                  // for date set here month and year and day
                  if( strcmp( $dynamicField[$elementKey]['type'], 'Date') == 0 ) {
                    // check if date is in correct formet or not.
                    $errorInDate = true;
                    if( preg_match( '/^[0-9]{4}-[0-9]{2}-[0-9]{2}$/', trim( $elementValue ) )) {
                        $getUserDate = explode( '-', $elementValue );
                        // YYYY-MM-DD
                        if( checkdate(  (int)$getUserDate[1], (int)$getUserDate[2], (int)$getUserDate[0]) ) {
                          $errorInDate = false;
                        }
                    }

                    // Set date in the form.
                    if( $errorInDate == false ) {
                      $getListOfDates[] = $elementKey;
                      $formData[ $elementKey ]['year'] = $getUserDate[0];
                      $formData[ $elementKey ]['month'] = $getUserDate[1];
                      $formData[ $elementKey ]['day'] = $getUserDate[2];
                    } else {
                      $error[ $elementKey ] = "Date format must be YYYY-MM-DD";
                    }
                  } else {

                    $formData[ $elementKey ] = $elementValue ;

                  }
                } else {
                  $index = 0;
                  $elementValue = strtolower($elementValue) ;

                  // Get type here
                  $dynamicFieldType = strtolower($dynamicField[$elementKey]['type']) ;
                  if( $dynamicFieldType == 'select' || $dynamicFieldType == 'radio' ) {
                 
                        foreach ( $dynamicField[$elementKey]['optionStore'] as $key1 => $value) {
                        # code...
                        $value = strtolower($value) ;
                        $flag = false ;
                        if( strpos($elementValue, $value ) !== false )
                        {
                              $formData[$elementKey] = $key1;
                              $flag = true;
                              break;
                        }
                      }
                      if( $flag == false && ! empty($elementValue) ) {
                        $error[ $elementKey ] = "This option is not available in this fields for radio, select dropdown, and checkbox. " ;
                      }
                      if( count(explode(',', $elementValue)) > 1 ) {
                        $error[ $elementKey ] = "Cannot select more than one value." ;  
                      }
                  }  else {

                      if( ! empty( $elementValue )) {
                        $getElementValue = explode(',', $elementValue);
                        foreach ($getElementValue as $elementString ) {
                          if( ! in_array($elementString, array_map('strtolower',$dynamicField[$elementKey]['optionStore'] )) ) {
                            $error[ $elementKey ] = "It contains values which are not the part of this field.";
                          }
                        }
                      }
                      $formData[$elementKey] = NULL ;
                      $index = 0; 
                      if( isset($dynamicField[$elementKey]['optionStore']) ) {
                        foreach ( $dynamicField[$elementKey]['optionStore'] as $key1 => $value) {
                          $value = strtolower($value) ;
                          if( strpos($elementValue, $value ) !== false )
                          {
                            $formData[$elementKey][ $index] = $key1;
                            $index++;
                          }
                        }
                      }
                  }
                }
            } else if( $elementKey == 'sitevarify'  ) {
                  if( trim( $elementValue ) == '1' ) { 
                    $formData['sitevarify'] = 1 ;
                  } else if( trim( $elementValue ) == '0' || trim( $elementValue ) == '' || $elementValue == null){
                    $formData['sitevarify'] = 0 ;
                  }
                  else {
                    $error['sitevarify'] = "Use Yes to set Verify Icon else use No or leave it blank.";
                  }
            } elseif( $elementKey == 'timezone'){
                    if(empty( $elementValue )){
                      $error['timezone'] = "Timezone cannot be empty";
                    } else {
                      $formData[$elementKey] = $elementValue ;
                    }
                    
            } /*elseif ( $elementKey == 'package_id' ) {
              // Add package id here get 
            } */ else {
              $formData[$elementKey] = $elementValue ;
            }
        }
        if(!isset($formData['member_level'])) {
          $formData['member_level'] = '';
        }
        $form = new Siteuserimport_Form_Admin_Addnewuserinformation( 
        array( 
                  'profileType' => $formData['profile_type'],
                  'memberLevel'=> $formData['member_level'],
          ) );
        $form->setControllerName('bulkInsertionAction');
        $isValid = false ;
        $isValid = $form->isValid($formData );
        // To get Date here 
        /*
            formdata has date as ['year'] = 
            ['month'] =
            ['day'] = 
            set it as [ key ] = 'date';
        */
        $getFormDataForDate = $form->getValues();
        // set date in the form data
        if( count( $getListOfDates ) > 0) {
          foreach( $getListOfDates as $dateKey => $dateValue ) {
            $formData[ $dateValue ] = $getFormDataForDate[ $dateValue ];

          }

        }




        if( isset($formData['multiCheckbox']) && $formData['multiCheckbox'] == Null ) {
          $error['multiCheckbox'] = "Please set values 'approved', 'enabled' or 'verified' for user." ;
          $isValid = false ;
        }
        
        if(  $form->profile_photo->getErrorMessages() != null ) {
          $isValid = false ;
          $error['profile_photo'] =  $form->profile_photo->getErrorMessages()[0] ; 
        }
        if( isset($form->cover_photo) && $form->cover_photo->getErrorMessages() != null ) {
          $isValid = false ;
          $error['cover_photo'] =  $form->cover_photo->getErrorMessages()[0] ; 
        }
        $getFormErrorMessage = $form->getMessages() ;
        if( $getFormErrorMessage != null ) {
          $isValid = false ;
          foreach ( $getFormErrorMessage as $keyErrormsg => $errorMsg) {
            foreach ($errorMsg as  $errorMsgChild ) {
              $error[ $keyErrormsg ] = $errorMsgChild;
            }
          }
        }
         if( $error != null ) {
          $isValid = false ;
        }
        $db = Engine_Db_Table::getDefaultAdapter();
        if( $isValid == false ) {
          // Store this error in the database.
          $getFileTable = Engine_Api::_()->getDbtable('addFileDetails', 'siteuserimport');
          $fileId = $this->_getParam('fileimport_id');
          $getTableRow = $getFileTable->fetchRow( $getFileTable->select()->where( 'fileimport_id = ?', $fileId ));
          $jsonError = json_encode($error);
          $Values['error_is'] = $jsonError ;
          $db->update( $getTableRow['table_name'],$Values, "unique_Id = $key" );
        }

        if( $isValid == true ) {
          if(empty($formData['profile_photo'])){
            $formData['profile_photo'] = NULL;
          }
          if(empty($formData['cover_photo'])){
            $formData['cover_photo'] = NULL;
          }

          $jsonData[] =  $formData;
          $uniqueKeys[] = $key;
          //$result = $this->saveUser( $formData ,$fileId, false, $formData['profile_photo'], $formData['cover_photo']);
          
        }
    }
    
    $returnData = array();
    $returnData['data'] = $jsonData;
    $returnData['keys'] = $uniqueKeys;
    echo Zend_Json_Encoder::encode($returnData);
    die;
  }

 /*  Saving a user */
 /**  
   *  @param $getFormData - User Data. 
   * @return $getFileId - when saving uploaded data, this keeps details of file.
  **/     
  public function saveUser( $getFormData, $getFileId = NULL, $dummyUsers = false, $photo = null, $coverPhoto = null ){

        // Get field stucture for user profile here
        $result = $this->getFieldsUserSearch( $getFormData[ 'profile_type' ] );
        // Getdisplay name here
        $displayUserName = $this->setUserName( $result, $getFormData );
        if( $displayUserName == '' && ! empty( $getFormData[ 'username' ] ) ) {
                $displayUserName = $getFormData[ 'username' ];
        }

        //get salt for password here for encyt password.
        $salt = ( string ) rand( 1000000, 9999999 );
        $settings = Engine_Api::_()->getApi( 'settings', 'core' );
        $password = md5( $settings->getSetting( 'core.secret', 'staticSalt' ) . $getFormData[ 'password' ]. $salt );
        
        //Prepare field for user table.
        $userDetails = array();
        $userDetails[ 'email' ] = $getFormData[ 'email' ];
        if( !empty( $getFormData[ 'username' ] ) ) {
            $userDetails[ 'username' ] = $getFormData[ 'username' ];
        }
        $userDetails[ 'displayname' ] = $displayUserName;
        $userDetails[ 'password' ] = $password;
        $userDetails[ 'salt' ] = $salt;
        if( !empty( $getFormData[ 'language' ] ) ) {
          $userDetails[ 'language' ] = $getFormData[ 'language' ];  
        }
        $userDetails[ 'timezone' ] = $getFormData[ 'timezone' ];
        $userDetails[ 'creation_date' ] = date( 'Y-m-d H:i:s' );
        $userDetails[ 'creation_ip' ] = $_SERVER['REMOTE_ADDR'];
        $userDetails[ 'modified_date' ] = date( 'Y-m-d H:i:s' );
        $userDetails[ 'level_id' ] = $getFormData[ 'member_level' ];
        $userDetails[ 'enabled' ] =  0;
        $userDetails[ 'approved' ] = 0;
        $userDetails[ 'verified' ] = 0;
        if(isset($getFormData[ 'multiCheckbox' ])) {
          // set field to decides characterstics. (approved, enabled, verified)
          foreach ( $getFormData[ 'multiCheckbox' ] as $key  => $value ) {
              $userDetails[$value] = 1;
          }
        } 
        $userTable = Engine_Api::_()->getDbtable( 'users', 'siteuserimport' );

        // Data for user_fields values
        $profilefieldsValues = Engine_Api::_()->getDbtable( 'addprofilefieldsvalues', 'siteuserimport' ); 
        
        //Data for user_fields_search  which stored name birthdate and gender.
        $userSearchFieldsTable = Engine_Api::_()->getDbtable( 'addUserSearchFields', 'siteuserimport' );
        
        try {
              $userinfo = $userTable->createRow();
              $userinfo->setFromarray( $userDetails );
              $userinfo->save();
              $sqlquery = $userTable->select()
                                    ->from( $userTable->info( 'name' ), array('user_id') )
                                    ->where( 'email = ?', $userDetails[ 'email' ] );
              $userId =  $userTable->fetchRow( $sqlquery )->user_id;
              $getResultData = $this->getFieldValues( $getFormData, $userId );


              // Add details in payment table if payment option is availabel for signup.
              if( array_key_exists( 'package_id', $getFormData )) {

                // get amount
                $selectPaymentPackageTable = Engine_Api::_()->getDbtable( 'packages', 'payment' );
                $sqlqueryPaymentPackageQuery = $selectPaymentPackageTable->select()
                                      ->from( $selectPaymentPackageTable->info( 'name' ) )
                                      ->where( 'package_id = ?', $getFormData['package_id'] );
                $getPaymentPackageDetails =  $selectPaymentPackageTable->fetchRow( $sqlqueryPaymentPackageQuery );
                // Ckeck expiray date of this plan for the user.
                if( $getPaymentPackageDetails->duration_type != 'forever') {

                  $expiration_date = date("Y-m-d H:i:s", strtotime("+" . $getPaymentPackageDetails->duration. " " . $getPaymentPackageDetails->duration_type ) );
                } else { 
                  $expiration_date = NULL;
                }

                // make an entry in the payment subscriptions table for the user.
                $selectGatewayTable = Engine_Api::_()->getDbtable( 'gateways', 'payment' );
                $sqlqueryGateway = $selectGatewayTable->select()
                                    ->from( $selectGatewayTable->info( 'name' ), array('gateway_id') )
                                    ->where( 'enabled = ?', 1 );

                $singleGatewayObject = $selectGatewayTable->fetchRow( $sqlqueryGateway );
                if ( !empty( $singleGatewayObject )) {
                  $gatewayId = $singleGatewayObject->gateway_id;
                } else {
                  $gatewayId = null;
                }
                $getPaymentTable = Engine_Api::_()->getDbtable( 'subscriptions', 'payment' );
                $setPaymentData['user_id'] = $userId;
                $setPaymentData['package_id'] = $getFormData['package_id'];
                $setPaymentData['active'] = 1;
                $setPaymentData['status'] = 'active';
                $setPaymentData['creation_date'] = new Zend_Db_Expr('NOW()');
                $setPaymentData['modified_date'] = new Zend_Db_Expr('NOW()');
                $setPaymentData['payment_date'] = NULL;
                $setPaymentData['expiration_date'] = $expiration_date;
                $setPaymentData['notes'] = NULL;
                $setPaymentData['gateway_id'] = $gatewayId;
                if( $getPaymentPackageDetails->price != (0.00) ) {
                  $setPaymentData['gateway_profile_id'] = 'SEACOREDUMMY'. $userId;  
                } else {
                  $setPaymentData['gateway_profile_id'] = NULL;
                }
                
                $setPayment = $getPaymentTable->createRow();
                $setPayment->setFromarray( $setPaymentData );
                $setPayment->save();

                // Get Source Id 
                $sqlquerySourceId = $getPaymentTable->select()
                                      ->from( $getPaymentTable->info( 'name' ), array('subscription_id') )
                                      ->where( 'user_id = ?', $userId );
                $subscriptionId =  $getPaymentTable->fetchRow( $sqlquerySourceId )->subscription_id;
                
                if( $getPaymentPackageDetails->price != (0.00) && $gatewayId != NULL ) {
                  // Set data into payment_order_table
                  // Select gateway for the user
                  $getPaymentOrderTable = Engine_Api::_()->getDbtable( 'orders', 'payment' );
                  $setPaymentOrderData['user_id'] = $userId;
                  $setPaymentOrderData['gateway_id'] = $gatewayId;
                  $setPaymentOrderData['gateway_order_id'] = NULL;
                  // Set default of the user.
                  $setPaymentOrderData['gateway_transaction_id'] =  'SEACOREDUMMY'. $userId;
                  $setPaymentOrderData['state'] = 'complete';
                  $setPaymentOrderData['creation_date'] = new Zend_Db_Expr('NOW()');
                  $setPaymentOrderData['source_type'] = 'payment_subscription';
                  // Id from payment subscription table.
                  // Source id an id from $getPaymentTable table
                  $setPaymentOrderData['source_id'] = $subscriptionId;
                  $setPaymentOrder = $getPaymentOrderTable->createRow();
                  $setPaymentOrder->setFromarray( $setPaymentOrderData );
                  $setPaymentOrder->save();
                  $sqlqueryOrder = $getPaymentOrderTable->select()
                                        ->from( $getPaymentOrderTable->info( 'name' ), array('order_id') )
                                        ->where( 'user_id = ?', $userId );
                  $getPaymentOrderId =  $getPaymentOrderTable->fetchRow( $sqlqueryOrder )->order_id;

                  // Set data in the 
                  $selectTransactionTable = Engine_Api::_()->getDbtable( 'transactions', 'payment' );


                  $setPaymentTransactionData['user_id'] = $userId;
                  $setPaymentTransactionData['gateway_id'] = $gatewayId;
                  $setPaymentTransactionData['timestamp'] = new Zend_Db_Expr('NOW()');
                  $setPaymentTransactionData['order_id'] = $getPaymentOrderId;
                  $setPaymentTransactionData['type'] = 'payment';
                  $setPaymentTransactionData['state'] = 'okay';
                  $setPaymentTransactionData['gateway_transaction_id'] = 'SEACOREDUMMY'. $userId;
                  $setPaymentTransactionData['gateway_parent_transaction_id'] = NULL;
                  $setPaymentTransactionData['gateway_order_id'] = NULL;
                  $setPaymentTransactionData['amount'] = $getPaymentPackageDetails->price;
                  $currency = (array) Engine_Api::_()->getApi('settings', 'core')->payment;
                  $setPaymentTransactionData['currency'] = $currency['currency'];  
                  $setPaymentTransaction = $selectTransactionTable->createRow();
                  $setPaymentTransaction->setFromarray( $setPaymentTransactionData );
                  $setPaymentTransaction->save();

                }
              }




              // Insert data in user_field_value table.
              foreach ( $getResultData as $tuple ) {

                  $userFieldsValues = $profilefieldsValues->createRow();
                  $userFieldsValues->setFromArray( $tuple );
                  $selectQuery = $profilefieldsValues->select()
                                   ->from($profilefieldsValues->info('name'),array('COUNT(1) AS exists'))
                                   ->where('`item_id` = ?',$userFieldsValues->item_id)
                                   ->where('`index` = ?',$userFieldsValues->index)
                                   ->where('`field_id` = ?',$userFieldsValues->field_id);
                  
                  $result = $profilefieldsValues->fetchRow($selectQuery);
                  if($result->exists == 0 ){                  
                    $userFieldsValues->save();
                  }   
                  unset($userFieldsValues);
              }
              
              // Insert data in user_field_search table
              $enterInSearchFields = $this->setFieldStructure( $result, $getFormData );
              $enterInSearchFields[ 'item_id' ] = $userId;
              $userSearchFields = $userSearchFieldsTable->createRow();
              $userSearchFields->setFromarray( $enterInSearchFields );
              $selectQuery = $userSearchFieldsTable->select()
                                   ->from($userSearchFieldsTable->info('name'),array('COUNT(1) AS exists'))
                                   ->where('`item_id` = ?',$userId);
              $result = $userSearchFieldsTable->fetchRow($selectQuery);
              if($result->exists == 0 ){                  
                $userSearchFields->save();
              }                                 
              

              //get Authentication permission for use
              $authAllowTable = Engine_Api::_()->getDbtable( 'allow', 'authorization' );
              $getAuthCommentPermission = Engine_Api::_()->getApi( 'core','authorization' )->getPermission( $userDetails[ 'level_id' ],'user','auth_comment' );
              $getAuthCommentPermission = str_replace( '["', '', $getAuthCommentPermission );
              $getAuthCommentPermission = str_replace( '"]', '', $getAuthCommentPermission );
              $getAuthCommentPermission = explode( '","' , $getAuthCommentPermission );
              
              if( ! is_null( $getAuthCommentPermission ) ) {
                  $getAuthRowarray = $this->getFieldsAuthAllow( $userId,'comment', $getAuthCommentPermission );
                  foreach ( $getAuthRowarray as $tuple )  {
                          
                          $userAuthAllow = $authAllowTable->createRow();
                          $userAuthAllow->setFromArray( $tuple );

                          $selectQuery = $authAllowTable->select()
                                                       ->from($authAllowTable->info('name'),array('COUNT(1) AS exists'))
                                                       ->where('`resource_type` = ?', $userAuthAllow->resource_type)
                                                       ->where('`resource_id` = ?', $userAuthAllow->resource_id)
                                                       ->where('`action` = ?', $userAuthAllow->action)
                                                       ->where('`role` = ?', $userAuthAllow->role)
                                                       ->where('`role_id` = ?', $userAuthAllow->role_id)
                                                       ->where('`value` = ?', $userAuthAllow->value);

                          $result = $authAllowTable->fetchRow($selectQuery);
                          if($result->exists == 0 ){                  
                            $userAuthAllow->save();  
                          }
                           
                      }
              }

              $getAuthViewPermission = Engine_Api::_()->getApi( 'core','authorization' )->getPermission( $userDetails[ 'level_id' ],'user','auth_view' );
              $getAuthViewPermission = str_replace( '["', '', $getAuthViewPermission );
              $getAuthViewPermission = str_replace( '"]', '', $getAuthViewPermission );
              $getAuthViewPermission = explode( '","', $getAuthViewPermission );
              
              if( !is_null( $getAuthViewPermission ) ) {
                  $getAuthRowarray = $this->getFieldsAuthAllow( $userId,'view', $getAuthViewPermission );    
                  foreach ( $getAuthRowarray as $tuple )  {
                          $userAuthAllowViewPermission = $authAllowTable->createRow();
                          $userAuthAllowViewPermission->setFromarray( $tuple );

                          $selectQuery = $authAllowTable->select()
                                                       ->from($authAllowTable->info('name'),array('COUNT(1) AS exists'))
                                                       ->where('`resource_type` = ?', $userAuthAllowViewPermission->resource_type)
                                                       ->where('`resource_id` = ?', $userAuthAllowViewPermission->resource_id)
                                                       ->where('`action` = ?', $userAuthAllowViewPermission->action)
                                                       ->where('`role` = ?', $userAuthAllowViewPermission->role)
                                                       ->where('`role_id` = ?', $userAuthAllowViewPermission->role_id)
                                                       ->where('`value` = ?', $userAuthAllowViewPermission->value);

                          $result = $authAllowTable->fetchRow($selectQuery);
                          if($result->exists == 0 ){                  
                            $userAuthAllowViewPermission->save();  
                          }
                      }
              }
              
              //end
              $userTable = Engine_Api::_()->getDbtable( 'users', 'user' );
              $user = $userTable->fetchRow( $userTable->select()->where( 'email = ?', $userDetails[ 'email' ] ) );
              $user->disableHooks(true);
              
              //Add action activity and stream table data here.
              // $getFormData = $form->getValues();
              if(!empty($getFileId)){

                $type = 'importUsers';
              }elseif($dummyUsers){

                $type = 'dummyUsers';
              }else{

                $type = 'singleUserForm';
              }
              if(!empty($getFormData['profile_photo'])) {

                $passPhotoId = Engine_Api::_()->getDbTable( 'users','siteuserimport' )->setProfilePhoto($type, $photo, $getFileId, $userId);
                $userDetails[ 'photo_id' ] = $passPhotoId;
                $user->photo_id = $passPhotoId;
                $user->save();
              }

              //Add data in activity fields
              // if ( $user->verified && ( $user->enabled || $user->approved ) ) {
              //   Engine_Api::_()->getDbtable( 'actions', 'activity' )->addActivity( $user, $user, 'signup' );
              // }

              // Send email for verification validation
              // if( $userDetails[ 'verified' ] ==  0 && !$dummyUsers) {
              //     $this->sendEmailForVarification( $userDetails[ 'email' ] );
              // }

              // For varify Icon here..
              if( ! is_null( $this->_getParam( 'sitevarify' ) ) && $this->_getParam( 'sitevarify' ) == 1 ) {
                  // call setUserAsVerified
                  Engine_Api::_()->getDbTable( 'users','siteuserimport' )->setUserAsVerified( $user->user_id );
              }

              // Add a cover photo here for that user if it consist a  User Profiles - Cover Photo, Banner & Site Branding Plugin
              if( !empty( $getFormData['cover_photo'] )) {
                  
                  //CREATE PHOTO
                  if ( Engine_Api::_()->hasModuleBootstrap( 'advalbum' ) ) {
                      $tablePhoto = Engine_Api::_()->getDbtable( 'photos', 'advalbum' );
                  } else {
                      $tablePhoto = Engine_Api::_()->getDbtable( 'photos', 'album' );
                  }
                  
                  $photo = $tablePhoto->createRow();
                      $photo->setFromarray( array( 
                          'owner_id'  => $user->user_id ,
                          'owner_type'  => 'user'
                      ) );
                  $photo->save();

                  $coverPhotoId = Engine_Api::_()->getDbTable( 'users','siteuserimport' )->setProfileCoverPhoto( $type, $coverPhoto, $photo, $getFileId );

                  $tableAlbum = Engine_Api::_()->getDbtable( 'albums', 'siteusercoverphoto' );
                  $album = $tableAlbum->getSpecialAlbumCover( $user, 'cover' );
                  
                  //get id of photo.
                  $photo->album_id = $album->album_id;
                  $photo->save();
                  
                  //Add param here
                  $album->cover_params = Zend_Json_Encoder::encode( $this->_getParam( 'position', array( 'top'  => '0', 'left'  => 0 ) ) );
                  $album->save();
                  if ( !$album->photo_id ) {
                      $album->photo_id = $photo->photo_id;
                      $album->save();
                  }
                  $user->user_cover = $photo->photo_id;
                  $user->save();
                  // $activityApi = Engine_Api::_()->getDbtable( 'actions', 'activity' );
                  // $action = $activityApi->addActivity( $user, $photo, 'user_cover_update' );
                  // if ( $action ) {
                  //     if ( $photo ) {
                  //         Engine_Api::_()->getDbtable( 'actions', 'activity' )->attachActivity( $action, $photo );
                  //     }
                  // }                  
              }

              return true;
        } catch ( Exception $e ) {
          
          throw $e;
        }    
  }
 
  public function checkArrayKey($allKeys , $checkKey)
  {
   
    foreach ($allKeys as $key) {
      $outputKey = explode('_', $key) ;
      if( isset($outputKey[2]) && ( $outputKey[2] == $checkKey ) ) {
        return $key;
      }
    }
      return Null;
  }
  // delete Row from Data here.
  public function deleteDataAction( ) 
  {
    if( !$this->getRequest()->isPost()) {
      return ;
    }
    // Handle all keys
    $deleteValues = $this->getRequest()->getPost();
    foreach ($deleteValues as $key => $value) {
    if ( ! preg_match( '/d_[0-9]+$/', $key ) )
      {
        unset($deleteValues[ $key ]);
      }
    }
    $fileId = $this->_getParam('fileimport_id') ;
    $getFileTable = Engine_Api::_()->getDbtable('addFileDetails', 'siteuserimport');
    if(is_null($deleteValues) ) {
      return $this->_helper->redirector->gotoRoute(array('module' => 'siteuserimport', 'controller' => 'index', 'action' => 'manage', ));
    }

    $flag = $getFileTable->deleteRow( $fileId, $deleteValues);
    if($flag == 0 ) {
      return $this->_helper->redirector->gotoRoute(array('module' => 'siteuserimport', 'controller' => 'index', 'action' => 'manage', ));
    } 
    return $this->_helper->redirector->gotoRoute(array('module' => 'siteuserimport', 'controller' => 'index', 'action' => 'edit','fileimport_id' => $fileId ));
  }

  public function getCsvFileColumnStructure( $finalStringIs )
  {
    $resultedStringIsAs = array();
       $resultStringIndex = 0;
       $finalCsvStringIs = "";

       foreach ($finalStringIs as $key => $value) {
          if( $value['name'] == 'submit' || $value['name'] == 'profile_type') {
            continue ;
          } 
          if( isset($value['required']) ) {
            $resultedStringIsAs[$resultStringIndex] = '['.$value['label'].']'.'['.$value['required'].': '.$value['valueTimes'].']'.'['.$value['type'].']';    
          } else {
              $resultedStringIsAs[$resultStringIndex] = '['.$value['label'].']'.'['.$value['valueTimes'].']'.'['.$value['type'].']';
          }
        
          if( isset($value['option']) && ! is_null( $value['option'] ) ) {
            $resultedStringIsAs[$resultStringIndex] = $resultedStringIsAs[$resultStringIndex].'('.$value['option'].')';
          }
          $resultStringIndex++;
       }     
      return $resultedStringIsAs;
  }


  // Make index for that profile Type 
  public function getColumnStructure($profileType)
  {
    
    $table1 = Engine_Api::_()->getDbtable('levels', 'authorization');
    $sqlquery = $table1->select()
              ->from($table1->info('name'))
              ->where('flag like ?','default');
          $userMemberLevelIs =  $table1->fetchAll($sqlquery)->toarray();
    $form1 = new Siteuserimport_Form_Admin_Addnewuserinformation( 
    array( 
            'profileType' => $profileType,
            'memberLevel'=> $userMemberLevelIs[0]['level_id'],
    ) );
    $allDataFormIsas =array();
    $indexForm = 0;
    foreach ($form1->getElements() as $key => $value) {
      $allDataFormIsas[$indexForm]['key'] = $key;
      $allDataFormIsas[$indexForm]['multiple'] = $value->multiple;
      $allDataFormIsas[$indexForm]['helper'] = $value->helper;
      $allDataFormIsas[$indexForm]['options'] = $value->options;
      $allDataFormIsas[$indexForm]['allowEmpty'] = $value->getAllowEmpty();
      $allDataFormIsas[$indexForm]['label'] = $value->getLabel();
      $allDataFormIsas[$indexForm]['name'] = $value->getName();
      $allDataFormIsas[$indexForm]['class'] = $value->class;
      $indexForm++;
    }
    $finalStringIs = array();
    $indexIsAs = 0;
    foreach( $allDataFormIsas as $keyform => $formValueIsAs ) {
      if ( $formValueIsAs['helper'] == 'formHeading') {
        continue;
      } 

      else if( $formValueIsAs['label'] == '' ) {
        continue ;
      }

      
      // Label
      $finalStringIs[$indexIsAs]['label'] = $formValueIsAs['label'];
      // Type of Value
      $finalStringIs[$indexIsAs]['type'] = str_replace("form","",$formValueIsAs['helper'] );
      // Get value name here.
      $finalStringIs[$indexIsAs]['name'] = $formValueIsAs['name'] ;
      // For rules here

      if( is_null($formValueIsAs['allowEmpty']) || $formValueIsAs['allowEmpty'] == true ) {
        } else {

             $finalStringIs[$indexIsAs]['required'] = 'Required' ;   
        }
      if( ($formValueIsAs['helper'] == 'formMultiCheckbox') ||  ( $formValueIsAs['multiple'] == 'multiple' )) {
          $finalStringIs[$indexIsAs]['valueTimes'] = 'multiple allow' ;
      } else {
          $finalStringIs[$indexIsAs]['valueTimes'] = 'Single Value' ;
      }
      // if value contain option here then but only for dynamic field.
 
      if ( ! preg_match( '/[^0-9_]/', $formValueIsAs['name'] ) )
      {
          if( ! is_null($formValueIsAs['options']) ) {
            foreach ($formValueIsAs['options'] as $keyOption => $option) {
                   # code...
              if( $option != "" ) {
               
                $finalStringIs[$indexIsAs]['optionStore'][$keyOption] = $option;
                $finalStringIs[$indexIsAs]['option'] = (isset( $finalStringIs[$indexIsAs]['option'] ) ? $finalStringIs[$indexIsAs]['option'] : '').$option.':';  
              }
            }
          }
        } else if( ! is_null($formValueIsAs['options']) ) {
          foreach ($formValueIsAs['options'] as $keyOption => $option) {
                 # code...
            if( $option != "" ) {
             
              $finalStringIs[$indexIsAs]['optionStore'][$keyOption] = $option;
              $finalStringIs[$indexIsAs]['option'] = (isset( $finalStringIs[$indexIsAs]['option'] ) ? $finalStringIs[$indexIsAs]['option'] : '').$option.':';  
            }
          }   
        }
        $indexIsAs++;
    }
    return $finalStringIs;
  }

  //    for download csv 
  public function downloadSampleAction()
  {
    
    // $this->_helper->layout->setLayout('default-simple');
    $directDownload = $this->_getParam('directDownload',false);
    
    if(!$directDownload) {
      // create a form     
      $this->view->form = $form = new Siteuserimport_Form_Admin_CreateCsvFile( );
      //Get Request
      if( !$this->getRequest()->isPost() ) {
          return;
      }

      if( ! $form->isValid( $this->getRequest()->getPost() ) ) {
         $form->populate( $form->getValues() );
        return;
      }

      $profileType = $form->getValues()['profile_type'];

    } else {
          
      $profileType = $this->_getParam('profile_type');
    }

    $table1 = Engine_Api::_()->getDbtable('levels', 'authorization');
    $sqlquery = $table1->select()
             ->from($table1->info('name'))
             ->where('flag like ?','default');
    $userMemberLevelIs =  $table1->fetchAll($sqlquery)->toarray();

    $form1 = new Siteuserimport_Form_Admin_Addnewuserinformation(
                    array( 
                            'profileType' => $profileType,
                            'memberLevel'=> $userMemberLevelIs[0]['level_id'],
                    )
                  );

    // GetField Structure for all data here.
    $allDataFormIsas =array();
    $indexForm = 0;
    
    foreach ($form1->getElements() as $key => $value) {
      $allDataFormIsas[$indexForm]['key'] = $key;
      $allDataFormIsas[$indexForm]['multiple'] = $value->multiple;
      $allDataFormIsas[$indexForm]['helper'] = $value->helper;
      $allDataFormIsas[$indexForm]['options'] = $value->options;
      $allDataFormIsas[$indexForm]['allowEmpty'] = $value->getAllowEmpty();
      $allDataFormIsas[$indexForm]['label'] = $value->getLabel();
      $allDataFormIsas[$indexForm]['name'] = $value->getName();
      $allDataFormIsas[$indexForm]['class'] = $value->class;
      $indexForm++;
     
    }

    $finalStringIs = array();
    $indexIsAs = 0;
    
    foreach( $allDataFormIsas as $keyform => $formValueIsAs ) {
      if ( $formValueIsAs['helper'] == 'formHeading') {
        continue;
      }
      else if( $formValueIsAs['label'] == '' ) {
        continue ;
      }

      // Label
      $finalStringIs[$indexIsAs]['label'] = $formValueIsAs['label'];
      // Type of Value

      // for date 
      if( $formValueIsAs['helper'] == 'formDate') {
          $finalStringIs[$indexIsAs]['type'] = "Date yyyy-mm-dd" ;  
      } else {
          $finalStringIs[$indexIsAs]['type'] = str_replace("form","",$formValueIsAs['helper'] );  
      }
      
      // Get value name here.
      $finalStringIs[$indexIsAs]['name'] = $formValueIsAs['name'] ;
      // For rules here

      if( is_null($formValueIsAs['allowEmpty']) || $formValueIsAs['allowEmpty'] == true || $formValueIsAs['name'] == 'cover_photo' || $formValueIsAs['name'] == 'sitevarify') {
               // $finalStringIs[$indexIsAs]['required'] = 'not Required' ;

        } else {

             $finalStringIs[$indexIsAs]['required'] = 'Required' ;   
        }
      if( ($formValueIsAs['helper'] == 'formMultiCheckbox') ||  ( $formValueIsAs['multiple'] == 'multiple' )) {
          $finalStringIs[$indexIsAs]['valueTimes'] = 'multiple allow' ;
      } else {
          $finalStringIs[$indexIsAs]['valueTimes'] = 'Single Value' ;
      }
      // if value contain option here then but only for dynamic field.

      if ( ! preg_match( '/[^0-9_]/', $formValueIsAs['name'] ) )
      {
        if( ! is_null($formValueIsAs['options']) ) {
          //$finalStringIs[$indexIsAs]['option'] = '' ;
          foreach ($formValueIsAs['options'] as $keyOption => $option) {
            if( $option != "" ) {             
              $finalStringIs[$indexIsAs]['optionStore'][$keyOption] = $option;
              $finalStringIs[$indexIsAs]['option'] = (isset( $finalStringIs[$indexIsAs]['option'] ) ? $finalStringIs[$indexIsAs]['option'] : '').$option.':';  
            }                  
          }
        }
      } else if( $formValueIsAs['key'] !== 'timezone'  && ! is_null($formValueIsAs['options'])) {
        // add option for all fields but time zone fields will not be added here.
        foreach ($formValueIsAs['options'] as $keyOption => $option) {
          if( $option != "" ) {
            // Remove data from package id which shows price and time
            if( $formValueIsAs['key'] == 'package_id' ) {
              $finalStringIs[$indexIsAs]['optionStore'][$keyOption] = explode( '(', $option )[0];
              $finalStringIs[$indexIsAs]['option'] = explode( '(', (isset( $finalStringIs[$indexIsAs]['option'] ) ? $finalStringIs[$indexIsAs]['option'] : '').$option )[0] .':';                
            } else {
              $finalStringIs[$indexIsAs]['optionStore'][$keyOption] = $option;
              $finalStringIs[$indexIsAs]['option'] = (isset( $finalStringIs[$indexIsAs]['option'] ) ? $finalStringIs[$indexIsAs]['option'] : '').$option.':';  
            }  
          }                  
        }


      }
      $indexIsAs++;
    }
      // At timezone, member level with required fields
      foreach ($finalStringIs as $key => $value) {
        if( $value['name'] == 'timezone' || $value['name'] ==  'member_level' ) {
          $finalStringIs[ $key ]['required'] = 'Required' ;
        }
      }
     $resultedStringIsAs = array();
     $resultStringIndex = 0;
     $finalCsvStringIs = "";
       
       foreach ($finalStringIs as $key => $value) {
          if( $value['name'] == 'submit' || $value['name'] == 'profile_type') {
            continue ;
          } 
          // Add a condition when to check if required is set.
          if( isset($value['required']) ) {
            $resultedStringIsAs[$resultStringIndex] = '['.$value['label'].']'.'['.$value['required'].': '.$value['valueTimes'].']'.'['.$value['type'].']';    
          } else {
              $resultedStringIsAs[$resultStringIndex] = '['.$value['label'].']'.'['.$value['valueTimes'].']'.'['.$value['type'].']';
          }
          // $resultedStringIsAs[$resultStringIndex] = '['.$value['label'].']'.'['.$value['required'].': '.$value['valueTimes'].']'.'['.$value['type'].']';
          if(isset($value['option']) && ! is_null( $value['option'] ) ) {
            $resultedStringIsAs[$resultStringIndex] = $resultedStringIsAs[$resultStringIndex].'('.$value['option'].')';
          }
          if( $resultStringIndex > 0) {
            $finalCsvStringIs = $finalCsvStringIs.'|'.$resultedStringIsAs[$resultStringIndex];    
          }  else {
            $finalCsvStringIs = $resultedStringIsAs[$resultStringIndex];    
          }
          
          $resultStringIndex++;
       }

        $Path = realpath(APPLICATION_PATH . "/temporary");
        $filePath = "$Path/user_signup_data.csv";
        @chmod($path, 0777);
        @chmod($file_path, 0777);
        $fp = fopen($filePath, 'w+');
        fwrite($fp, $finalCsvStringIs);
        fclose($fp);

        //KILL ZEND'S OB
        $isGZIPEnabled = false;
        if (ob_get_level()) {
            $isGZIPEnabled = true;
              @ob_end_clean();
        }
       
        header("Content-Disposition: attachment; filename=" . urlencode(basename($filePath)), true);
        header("Content-Transfer-Encoding: Binary", true);
        //header("Content-Type: application/x-tar", true);
        // header("Content-Type: application/force-download", true);
        header("Content-Type: application/octet-stream", true);
        header("Content-Type: application/download", true);
        header("Content-Description: File Transfer", true);
        if(empty($isGZIPEnabled)){
          header("Content-Length: " . filesize($filePath), true);
        } 
        
        readfile("$filePath");
        exit();

  }
  
  // Creating Dummy Users
  public function addBulkDataCsvAction() {

    $dummyUsers = Zend_Registry::isRegistered('dummyUserValues')?Zend_Registry::get('dummyUserValues'):null;
    if(empty($dummyUsers)){
      $this->_helper->content->setNoRender();
    }
    $postForm = $post = $this->getRequest()->getPost();

    if(!isset($postForm['format'])) {
      $postForm['format'] = '';
    }
    if(!isset($postForm['profileTypeChange'])) {
      $postForm['profileTypeChange'] = '';
    }
    
    if(isset($post['data'])){ 
      $post = $post['data']; 
    }
    if(!isset($post['type_of_insertion'])) {
      $post['type_of_insertion'] = '';
    }
    if(!isset($post['format'])) {
      $post['format'] = '';
    }
    if(!empty($post['profile_type'])){

      $profileType = $post['profile_type'];  
    }
    
    // profile type is null then set it as default which is showing
    if(empty($profileType)) {
        
        $topStructure = Engine_Api::_()->fields()->getFieldStructureTop( 'user' );
        $options = $topStructure[0]->getChild()->getOptions();
        $profileType = $options[0]->option_id;
    }

    $settings = Engine_Api::_()->getApi('settings', 'core');
    $this->view->maleUser = $maleUser = $settings->getSetting('siteuserimport.maleuser',0);
    $this->view->femaleUser = $femaleUser = $settings->getSetting('siteuserimport.femaleuser',0);
    $this->view->bothUser = $bothUser = $settings->getSetting('siteuserimport.bothuser',0);
    
    $this->view->form = $form = new Siteuserimport_Form_Admin_AddDataBulkForm(
                                        array(   
                                                'profileType' => $profileType,
                                        )                                            
                                    );

    $this->view->setDownloadFile = false ;
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
               ->getNavigation('siteuserimport_admin_main', array(), 'siteuserimport_admin_dummy');

    // Check if user for current option is created or not.
    if( $postForm['format'] != "json" && ($post['type_of_insertion'] == '1' && $maleUser == 0) || ($post['type_of_insertion'] == '2' && $femaleUser == 0) || ( $post['type_of_insertion'] == '3' && $bothUser == 0 )) {
        $form->populate($this->_getAllParams());
        $form->type_of_insertion->addError("You have already added these dummy users.");
        return ;
    }
    
    // profile type update
    if($postForm['format'] != 'json' && $postForm['profileTypeChange'] ){
        
        $form->populate($this->_getAllParams());
        return;
    }
    
    if($postForm['format'] != 'json'){
        return;
    } 

    $form->isValid($post); // to initialize values to form.
    $getFormValues = $form->getValues();
    
    $getProfileLevel = $getFormValues['profile_type'];
    
    // Get Data from csv file to according to name of column.
    $fname = APPLICATION_PATH ."/public/siteuserimport".DIRECTORY_SEPARATOR ."default_user". DIRECTORY_SEPARATOR ."default_user_csv_file.csv";
    @chmod($fname, 0777);
    $fp = fopen($fname, "r");    
    if ((!$fp)) {
      echo "$fname File opening error";
      exit;
    }
    while ($buffer = fgets($fp, 5000)) {
      $explode_array[] = explode('|', $buffer);
    }

    // get keies of profile
    $getRegularFieldStructure = $this->getColumnStructure( $getProfileLevel ) ;
    $keysFieldStructure = array();
    $getDateField = array();
    foreach ($getRegularFieldStructure as  $value) {
      $keysFieldStructure[$value['name']] = $value ;
      if( $keysFieldStructure[$value['name']]['type'] == 'Date' ) {
        $getDateField[] = $value['name'];
      }
    }
    // Get here static fields
    $getBirthDate = NULL;
    foreach ($explode_array[0] as $key => $value) {
        
       if( strpos($value, "Verification") !== false ) {
          $getFormValues['multiCheckbox'] = $key ;
       } else if( strpos($value, "User Profile Photo") !== false ) {
          $getFormValues['profile_photo'] = $key ;
       } else if( strpos($value, "Password Again") !== false ) {
          $getFormValues['passconf'] = $key ;
       } else if( strpos($value, "Password") !== false ) {
          $getFormValues['password'] = $key ;
       } else if( strpos($value, "Email Address") !== false ) {
            $getFormValues['email'] = $key ;
       } else if( strpos($value, "Profile Address") !== false ) {
          // Profile Address will be get when user.signup.username == 1 
          if( $settings->getSetting('user.signup.username', 1) > 0 ) {
            $getFormValues['username'] = $key ;  
          }      
       } else if( strpos($value, "Gender") !== false ) {
          // get gender Key
          $genderKey = $key ;
      } else if( strpos($value, "Birthday") !== false ) {
        $getBirthDate = $key;
       } else if( $value == 'selectLabel' ) {
        continue;
       }
    }
    // finding name of Gender Element
    $genderKeyCSV = $genderKey;
    $genderKey = array_search($genderKey,$getFormValues);
    
    // Get Element which is not part of form to evaluate.
    $getDataUser['type_of_insertion'] = $getFormValues['type_of_insertion'];
    $getDataUser['domainName'] = $getFormValues['domainName'] ;
    $getDataUser['profile_type'] = $getFormValues['profile_type'] ;
    $getDataUser['language'] = isset($getFormValues['language']) ? $getFormValues['language'] : '';
    $getDataUser['timezone'] = $getFormValues['timezone'];
    $getDataUser['member_level'] = $getFormValues['member_level'];
    // check if payment method is avaliable or not.
    if( array_key_exists( 'package_id', $getFormValues)) {
      $getDataUser['package_id'] = $getFormValues['package_id'];
    }
    $getDataUser['gender'] = $genderKey;
    // Unset all elements which is not used form form
    unset($getFormValues['type_of_insertion']);
    unset($getFormValues['domainName']);
    unset($getFormValues['profile_type']);
    unset($getFormValues['language']);
    unset($getFormValues['timezone']);
    unset($getFormValues['downloadCustom']);
    unset($getFormValues['member_level']);
    unset($getFormValues['loader']);
    unset($getFormValues['status']);

    $getFormValues = array_diff( $getFormValues, array('selectLabel'));
    
    ini_set("memory_limit", "256M");
    ini_set("max_execution_time", "600");

    $db = Engine_Db_Table::getDefaultAdapter();
    try{
        $profilleAddereeerrorMessagealue = 1;
        //ADD DUMMY USER
        $returnData = $data = array();
        $labelsCsv = $explode_array[0];
        unset($explode_array[0]);
        
        foreach( $explode_array as $key => $arrayValues ) {
            
            $genderValue = $arrayValues[$genderKeyCSV];
            $arrayValues[$genderKeyCSV] = $this->view->translate($arrayValues[$genderKeyCSV]);
            

            // For setting of date get all fields with date.
            $formData = $this->getUserSignup( $arrayValues, $getFormValues, $keysFieldStructure, $getDataUser['domainName'] , $labelsCsv , $getBirthDate);
            $userTable = Engine_Api::_()->getDbtable('users', 'user');
            $sqlquery = $userTable->select()
                             ->from($userTable->info('name'),array('email'))
                             ->where('email like ?',$formData['email']);
            $userCount =  $userTable->fetchRow($sqlquery);
            if( count($userCount) > 0 ) {
              continue ;
            }
            if( ($arrayValues[$genderKeyCSV] == "Male" && $getDataUser['type_of_insertion'] == 2) || ($arrayValues[$genderKeyCSV] == "Female" && $getDataUser['type_of_insertion'] == 1) ){
              continue;
            }
            
            $formData['profile_type'] = $getDataUser['profile_type'] ;
            $formData['timezone'] = $getDataUser['timezone'];
            if(!isset($formData[ 'member_level'])) {
              $formData[ 'member_level'] = ''; //just to ignore the warning of undefined index
            }
            // if language is not empty.
            if( !empty($getDataUser['language']) ) {
              $formData['language'] = $getDataUser['language'];
            }
            // Set package value here for all users.
            if( array_key_exists( 'package_id', $getDataUser)) {
                  $formData['package_id'] = $getDataUser['package_id'];
            }            

            $singleUserSignUpForm = new Siteuserimport_Form_Admin_Addnewuserinformation( 
                                              array(   
                                                      'profileType' => $formData['profile_type'],
                                                      'memberLevel'=> $formData['member_level'],
                                              )
                                            );
            $formData[ 'member_level'] = $getDataUser['member_level'];
            // validation of data will be done here.
            // get error message 
            if( array_key_exists( 'getError', $formData )) {
                $getFormDataError = $formData['getError'];
                unset( $formData[ 'getError']);
            }
            
            if( !$singleUserSignUpForm->isValid( $formData ) ) {

              $errorMessage = $singleUserSignUpForm->getMessages();

              // profile and cover photo will generate error message ignoure them.
              unset($errorMessage['profile_photo']);
              unset($errorMessage['cover_photo']);
             
              if(!empty($errorMessage['username']) && !empty($errorMessage['username']['recordFound'])){
                continue;
              }
              
              // if email have  error then show error in
              if(!empty($getFormDataError)){
                  $errorMessage = array_merge( $errorMessage , $getFormDataError );
              }
              
              if( !empty( $errorMessage['email'] ) || count($errorMessage)>0) {
                
                $this->view->setDownloadFile = false ;
                
                foreach ($errorMessage as $key => $value) {
                    
                    if($key == 'email'){
                        // $form->domainName->addError(" Your Domain Name is not valid. ");
                        $returnData['errors'][$form->domainName->getLabel()] = " Your Domain Name is not valid. ";
                        // return;
                    }elseif($key == $value){
                        // $form->$value->addError(" Type Mismatch in this mapped field. ");
                        $returnData['errors'][$form->$value->getLabel()] = " Type Mismatch in this mapped field. ";
                        // return;
                    }else{
                      if($form->$key) {
                        if(isset($value['isEmpty'])){
                          $returnData['errors'][$form->$key->getLabel()] = $value['isEmpty'];
                        }else{
                          foreach ($value as $k => $v) {
                            $returnData['errors'][$form->$key->getLabel()] = $v;
                          }
                        }
                      }
                    }
                }
                
              }
              
              if(count($errorMessage) > 0) {
                // Set a file to download it which have no error message.
                // Get all Dynamic field for which no error is generated as well as whose value is not Null
                $columnDefaultCsvFile = array();
                foreach ( $formData as $keyDefaultUser => $valueDefault ) {
                  if( ! array_key_exists( $keyDefaultUser, $errorMessage )  && ! empty( $valueDefault ) ) {
                    array_push( $columnDefaultCsvFile, $keyDefaultUser );
                  }
                }
                
                $this->makeCsvDefaultUserData( $columnDefaultCsvFile, $getFormValues, $keysFieldStructure, $getDataUser);
                
                $returnData['setDownloadFile'] = true ;
                $returnData['status'] = 'error';
                $returnData['errors']['Auto Dummy User Creation Failed'] = " Download this CSV file and fill the required fields.<br/>Now, upload this CSV file using 'CSV Import' method to create Dummy Users.<br/>Also, download the associated profile photos of these dummy users and upload it from 'Manage CSV Import' available in the 'CSV Import' section of this plugin. ";
                $returnData['type_of_insertion'] = array('maleUser'=>$maleUser,'femaleUser'=>$femaleUser,'bothUser'=>$bothUser);

                if(isset($returnData['errors'])){
                  
                  $returnData['status'] = 'error';
                  echo Zend_Json_Encoder::encode($returnData) ; die();
                }                  
              }
              // Set Data In a csv file to transfer.
            }
            // set date in format.
            if( count( $getDateField ) > 0) {
              $singleUserFormData = $singleUserSignUpForm->getValues( );
              foreach ($getDateField as $getDateFieldValue ) {
                if( !empty( $singleUserFormData[ $getDateFieldValue ]) ) {
                    $formData[ $getDateFieldValue ] = $singleUserFormData[ $getDateFieldValue ];
                }
              }
            }
            $userTable = Engine_Api::_()->getDbtable('users', 'user');
            $sqlquery = $userTable->select()
                             ->from($userTable->info('name'),array('email'))
                             ->where('email like ?',$formData['email']);
            $userCount =  $userTable->fetchRow($sqlquery);
            if( count($userCount) > 0 ) {
              continue ;
            }
            // Set profile Photo here.
            $userProfilePhoto = $formData['profile_photo'] ;
            $data[] = $formData;

        }
        
        $returnData['status'] = 'success';
        $returnData['data'] = $data;
        echo Zend_Json_Encoder::encode($returnData);
        die();

      }catch(Exception $e){
        
        throw $e;
    }  
  }

  // returns ready data to save by func: saveUser.
  public function getUserSignup( $arrayValues, $formValueCheck, $keysFieldStructure, $domainName , $explodeArray , $getBirthDate )
  {


    $formData = array();
    // get every dynamic field.
    
    foreach ( $formValueCheck as $formKey => $formValue ) {
      if( preg_match('/1_[0-9]+_[0-9]+$/', $formKey )) {

        // MAtch type here
        //strpos(haystack, needle)
        $getTypeOfField = strtolower( explode( ':', $explodeArray [ $formValueCheck[ $formKey ] ] )[1] );
        $getKeyOfFieldStructure = strtolower( $keysFieldStructure[  $formKey ][ 'type'] );
        
        if( strpos( $getTypeOfField , $getKeyOfFieldStructure ) === false ) {
           $formData['getError'][ $formKey ] =  $formKey ;
           continue ; 
        }

        if( isset($keysFieldStructure[ $formKey]['option']) && ($keysFieldStructure[ $formKey]['option'] == NULL) ) {
          // key field structure's option will be null for date set date formet.
          if( $keysFieldStructure[ $formKey]['type'] == 'Date') {
            $explodeDate = explode('-', $arrayValues[ $formValue ] );
            $formData[ $formKey ]['year'] = $explodeDate[0];
            $formData[ $formKey ]['month'] = $explodeDate[1];
            $formData[ $formKey ]['day'] = $explodeDate[2];
            //1988-05-02
          } else {
            $formData[ $formKey ] = $arrayValues[ $formValue ] ;  
          }

          
        } else {
          // set Select , MultiOption Type value here and Radio Type.
          $flagDefaultUser = 0;
          $optionValue = strtolower($arrayValues[ $formValue ] );
          if(isset($keysFieldStructure[ $formKey]['optionStore'])) {
            $optionsIs = $keysFieldStructure[ $formKey]['optionStore'] ;
            if($optionsIs) {
              foreach ($optionsIs as $key => $value) {
                if( strpos($optionValue, strtolower( $value )) !== false ) {
                  if($formKey) {
                    $formData[ $formKey ] = $key;
                  }
                  $flagDefaultUser = 1;
                  break;
                }
              }
            } 
          } 
          if( $flagDefaultUser == 0 && isset($arrayValues[ $formValue ]) && ! empty($arrayValues[ $formValue ]) ) {
          $formData[ $formKey ] = $arrayValues[ $formValue ];
          } elseif ( $flagDefaultUser == 0 ) {
          $formData[ $formKey ] = -999;
          }
        }
      } else if( $formKey == 'multiCheckbox') {
        $elementValue = strtolower( $arrayValues[ $formValue ] );
          $index = 0 ;
         if( strpos($elementValue, 'enabled') !== false )
         {
              $formData['multiCheckbox'][ $index ] = 'enabled' ; 
              $index++;    
         }
         if( strpos($elementValue, 'approved') !== false )
         {
            $formData['multiCheckbox'][ $index ] = 'approved' ;
            $index++;
         }
          if( strpos($elementValue, 'verified') !== false )
          {
            $formData['multiCheckbox'][ $index ] = 'verified' ;
            $index++;
          }
      } else if( $formKey == 'member_level' ) {

          $authorizationLevels = Engine_Api::_()->getDbtable('levels', 'authorization');
          $sqlquery = $authorizationLevels->select()
            ->from($authorizationLevels->info('name'),array('level_id', 'title'));
          $userMemberLevelIs =  $authorizationLevels->fetchAll($sqlquery)->toarray();

         $memberFlag = 0;
         $elementValue = strtolower( $arrayValues[ $formValue ] );

          foreach($userMemberLevelIs as $title) {
            if( $elementValue == strtolower( $title['title'] ))
            {
              $memberFlag = 1;
              $formData['member_level'] = $title['level_id'] ;
              break;
            }
          }
      } else if( $formKey == 'sitevarify' ) {

            $elementValue = strtolower( $arrayValues[ $formValue ] );
            if( strpos($elementValue, 'yes') !== false ) {
                $formData[ $formKey ] = 1;        
               
            } else {
              $formData[ $formKey ] = '';
            }
      } else if( $formKey == 'email' ) {
           $email = explode('@',$arrayValues[ $formValue ]);
           $email = $email[0].'@'.$domainName ;
           $formData['email'] = $email ;
      }else {
        if($formKey) {
          $formData[ $formKey ] = isset($arrayValues[ $formValue ]) ? $arrayValues[ $formValue ] : '';
        }
        
      }
      $len = null;
      if(!is_array($formData[ $formKey ])) {
        $len = strlen( $formData[ $formKey ] );
      }
      if(!empty($len) && $formData[ $formKey ][$len - 1 ] == "\n" ) {
        $formData[ $formKey ] = substr( $formData[ $formKey ] , 0,$len - 1) ;
        }
    }
    $formData['submit'] = '';
    return $formData;

  }

  // Manually create a user 
  // Collects all user data according to Profile Type and creates a new user.
  public function addsingleuserAction()
  {
      
      $profileType = $this->_getParam( 'profile_type' );
      $this->view->hideChildren = true;
      
      $addUserValue = Zend_Registry::isRegistered('addUserValue') ? Zend_Registry::get('addUserValue') : null;
      
      if(empty($addUserValue)){
        $this->_helper->content->setNoRender() ;
      }

      $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
                                                              ->getNavigation( 'siteuserimport_admin_main', 
                                                                              array(), 
                                                                              'siteuserimport_admin_adduser'
                                                                              );
      // selecting profile type if not selected
      if(empty($profileType)){
          
          $topStructure = Engine_Api::_()->fields()->getFieldStructureTop( 'user' );
          $options = $topStructure[0]->getChild()->getOptions();
          $profileType = $options[0]->option_id;
      }
       
      // find out default Member Level.
      $userTable = Engine_Api::_()->getDbtable('levels', 'authorization');
      $sqlquery = $userTable->select()
                           ->from($userTable->info('name'),array('level_id'))
                           ->where('flag like ?','default');

      $userMemberLevelId =  $userTable->fetchRow($sqlquery);   
      
      // Get form.
      $this->view->form = $form = new Siteuserimport_Form_Admin_Addnewuserinformation( 
                                        array(   
                                                'profileType' => $profileType,
                                                'memberLevel'=> $userMemberLevelId->level_id,
                                        )
                                      );
        // Varify Icon show.
        $viewer = Engine_Api::_()->user()->getViewer();
        $this->view->adminId = $adminId = $viewer->level_id;
        $this->view->verifyLevelManage = json_encode($this->verifyLevelPermission($adminId));
        
        $siteusercoverphoto = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('siteusercoverphoto');

        if(  $siteusercoverphoto == true )
        {
         $permissionTable = Engine_Api::_()->getDbtable('permissions', 'authorization');
          $permissionTableName = $permissionTable->info('name');
          $select = $permissionTable->select()
                                    ->from($permissionTableName, 'level_id')
                                    ->where('type LIKE ?', 'siteusercoverphoto')
                                    ->where('value = ?', 1);
          $levels = $permissionTable->fetchAll($select);
          $getLevels =array();
          foreach ( $levels->toarray() as  $value) {
            array_push($getLevels, $value['level_id']);
          }
          $this->view->verifyLevelManageCoverPhoto = json_encode($getLevels);
        }
        else {
          $this->view->verifyLevelManageCoverPhoto = NULL;
        }

        $isSubmit = $this->_getParam( 'submit' );
        if( ! isset( $isSubmit ) ) {
          return;
        }
        $this->view->hideChildren = false;

        // add for user profile for multiple changes.        
        $this->view->topLevelId = $topLevelId = $form->getTopLevelId();
        $this->view->topLevelValue = $topLevelValue = $form->getTopLevelValue();

        // If not post or form not valid, return
        if( !$this->getRequest()->isPost() ) {
          return;
        }
     
        if( ! $form->isValid( $this->getRequest()->getPost() ) ) {
          
          $form->populate( $form->getValues() );
          return;
        }

        $getFormData = $form->getValues(); 
        // If profile Type is null then 
        if( empty($getFormData['profile_type'] ) ) {
            
            $getFormData['profile_type'] = $profileType;
        }

        $db = Engine_Db_Table::getDefaultAdapter(); 
        try{
          
          $db->beginTransaction();
          $save = $this->saveUser($getFormData,NULL,false,$form->profile_photo, $form->cover_photo);
          //ADD SINGLE USER
          if( $save ) {
              $db->commit();
              $form->addNotice('Member has been created successfully.');
              $form->reset();
          }
        
        }catch(Exception $e){  
          $db->rollback();
          throw $e;
        }
  }

  /**
   *  @param user id,action, data for  permisssion
   * @return an array for authentication level.
  **/
    public function getFieldsAuthAllow( $userId, $action, $data ) 
    {

        $authAllowRow = array();
        $index = 0;
            if( $userId == NULL && $data == NULL && $action == NULL ) {
                return NULL;
            }
            foreach ( $data as $key  => $value ) {
                # code...
                $authAllowRow[$index][ 'resource_type' ] = 'user';
                $authAllowRow[$index][ 'resource_id' ] = $userId;
                $authAllowRow[$index][ 'action' ] = $action;
                $authAllowRow[$index][ 'role' ] = $value;
                $authAllowRow[$index][ 'role_id' ] = 0;
                $authAllowRow[$index][ 'value' ] = 1;
                $authAllowRow[$index][ 'params' ] = NULL;
                $index++;

            }
            return $authAllowRow;
    }

    /**
     *  @param Get email id 
     */

        
    public function sendEmailForVarification( $email )
    {

        $userTable = Engine_Api::_()->getDbtable( 'users', 'user' );
        $user = $userTable->fetchRow( $userTable->select()->where( 'email = ?', $email ) );
        
        // resend verify email
        $verifyTable = Engine_Api::_()->getDbtable( 'verify', 'user' );
        $verifyRow = $verifyTable->fetchRow( $verifyTable->select()->where( 'user_id = ?', $user->user_id )->limit( 1 ) );
        
        if( !$verifyRow ) {
          $settings = Engine_Api::_()->getApi( 'settings', 'core' );
          $verifyRow = $verifyTable->createRow();
          $verifyRow->user_id = $user->getIdentity();
          $verifyRow->code = md5( $user->email
              . $user->creation_date
              . $settings->getSetting( 'core.secret', 'staticSalt' )
              . ( string ) rand( 1000000, 9999999 ) );
          $verifyRow->date = $user->creation_date;
          $verifyRow->save();
        }
        
        $mailParams = array( 
          'host'  => $_SERVER[ 'HTTP_HOST' ],
          'email'  => $user->email,
          'date'  => time(),
          'recipient_title'  => $user->getTitle(),
          'recipient_link'  => $user->getHref(),
          'recipient_photo'  => $user->getPhotoUrl( 'thumb.icon' ),
          'queue'  => NUll,
        );
        
        $mailParams[ 'object_link' ] = Zend_Controller_Front::getInstance()->getRouter()->assemble( array( 
              'action'  => 'verify',
            ), 'user_signup', true )
          . '?'
          . http_build_query( array( 'email'  => $email, 'verify'  => $verifyRow->code ) )
          ;
        Engine_Api::_()->getApi( 'mail', 'core' )->sendSystem( 
          $user,
          'core_verification',
          $mailParams
        );
        return ;
    }    


    
    /**
     *  @param Get Field Structure 
     *  @param Get Form Data 
     * @return User _Search Data here.  
     */
    public function setFieldStructure( $result, $getData )
    {
       
        foreach ( $result as $key  => $value ) {
            $index = '1_'.$getData[ 'profile_type' ].'_'.$value[ 'field_id' ];
            if( $value[ 'type' ] == 'first_name' )
            {
               $fieldStructure[ 'first_name' ] = $getData[$index];
            } else if( $value[ 'type' ] ==  'last_name' ) {
               $fieldStructure[ 'last_name' ] = $getData[$index];
            } else if( $value[ 'type' ] ==  'gender' ) {
              $fieldStructure[ 'gender' ] = $getData[$index];

            }  else if( $value[ 'type' ] ==  'birthdate' ) {
               $fieldStructure[ 'birthdate' ] = $getData[$index];
            }

        }
        $fieldStructure[ 'profile_type' ] = $getData[ 'profile_type' ];
       
        return $fieldStructure;
    }
    /**
     *  @param Get Field Structure 
     *  @param Get Form Data 
     * @return USer display name here.
     */
    public function setUserName( $result, $getData )
    {
        
        foreach ( $result as $key  => $value ) {
            if( $value[ 'type' ] == 'first_name' )
            {
                $firstnamefield = $value[ 'field_id' ];
            }
            else if( $value[ 'type' ] ==  'last_name' ) {
                $lastnamefield = $value[ 'field_id' ];
            }
        }
        if( ! is_null( $firstnamefield ) && ! is_null( $lastnamefield ) ) {
            $set1 = '1_'.$getData[ 'profile_type' ].'_'.$firstnamefield;
            $set2 = '1_'.$getData[ 'profile_type' ].'_'.$lastnamefield;
            $displayname = $getData[$set1].' '.$getData[$set2];
        }
        else if( ! is_null( $firstnamefield ) &&  is_null( $lastnamefield ) ) {
            $set1 = '1_'.$getData[ 'profile_type' ].'_'.$firstnamefield;
            $displayname = $getData[$set1];
        }
        else if( is_null( $firstnamefield ) && ! is_null( $lastnamefield ) ) {
            $set2 = '1_'.$getData[ '
            _type' ].'_'.$lastnamefield;
            $displayname = $getData[$set2];
        }
        else {
                $displayname = '';
        }
        return $displayname;
    }
    /**
     *  @param Get profile type
     *  @return  Field Structure of Profile Field
     */
    public function getFieldsUserSearch( $profileTypeValue )
    {

      
      //  getFieldsObjectsByAlias
        if( is_null( $profileTypeValue ) ) {
            return NULL;
        }
        $getMapdata = Engine_Api::_()->getApi( 'core','fields' )->getFieldsMaps( 'user' );
         $getMetaData = Engine_Api::_()->getApi( 'core','fields' )->getFieldsMeta( 'user' );
         $getFieldsValues = array();
         $index = 0;

         // Get All field field for that profile type.

         //get field for proper profile type;
         foreach ( $getMapdata as $key  => $value ) {
                if( $value[ 'option_id' ] == $profileTypeValue ){
                    $getFieldsValues[$index] = $value[ 'child_id' ];
                    $index++;
                }
         }

        
          $limit = $index;
        if(isset($getFieldsValues[$index])) {
          for( $index =0; $getFieldsValues[$index] != NULL ; $index++ )
          {
            foreach ( $getMapdata as $key  => $value ) {
              if( isset($getFieldsValues[$index]) && ( $value->toarray()[ 'field_id' ] == $getFieldsValues[$index] ) ){
                                  $getFieldsValues[$limit] = $value[ 'child_id' ];
                   $limit++;
              }
           }
          }
        }  
        
         $index = 0;
         $getMetaValues = array();
         foreach( $getMetaData as $key  => $value ) {
            if( $value[ 'type' ] == 'first_name' || $value[ 'type' ] == 'last_name' || $value[ 'type' ] == 'gender' || $value[ 'type' ] == 'birthdate' )
            {
                $getMetaValues[$index][ 'field_id' ] = $value[ 'field_id' ];
                $getMetaValues[$index][ 'type' ]  = $value[ 'type' ];
                $index++;
            }
         }
         $index = 0;
         
         $getResultDataMap = array();
         foreach ( $getFieldsValues as $key1  => $value1 ) {
            foreach ( $getMetaValues as $key2  => $value2 ) {
                if( $value1 ==  $value2[ 'field_id' ] )
                {   
                    $getResultDataMap[$index][ 'field_id' ] = $value2[ 'field_id' ];
                    $getResultDataMap[$index][ 'type' ] = $value2[ 'type' ];
                    $index++;
                    break;
                }
            }
         }
       
         return $getResultDataMap;
    }
    /**
     *  @param Send all form data here.
     *  @param Send all User id here.
     *  @return  get value of every field
     */
    public function getFieldValues( $getData =  NUll, $userId )
    {

        if( is_null( $getData ) )
        {
            return NUll;
        }
        if( is_null( $getData['profile_type'] ) ) {
          $topStructure = Engine_Api::_()->fields()->getFieldStructureTop( 'user' );
          $options = $topStructure[0]->getChild()->getOptions();
          $getData['profile_type'] = $options[0]->option_id;

          
        }
       
        $customer_id = $userId;
        $makeFieldarray = array();
        $index = 1;

        //note: value will be profile type.
        $addprofilefieldsvalues = array( 
            'item_id'  => $userId,
            'field_id'  => 1,
            'index'   =>0,
            'value'   => $getData['profile_type'],
            );
        $makeFieldarray =  array( 
            0  => $addprofilefieldsvalues,

            );
        
        foreach ( $getData as $key  => $fieldvalue ) {
            // if field are dynaimic then key will be as given
            if ( ! preg_match( '/[^0-9_]/', $key ) )
            {
                
                $arrayValues = explode( "_", $key );
                // third value will be our fields_id in database.
                $fieldIdIs = $arrayValues[2];
                //this will only show profile dynamic fields.
                if( $fieldvalue  == NULL) {
                    $fieldvalue = "";
                }
                if( is_array( $fieldvalue ) )
                {
                    foreach ( $fieldvalue as $internalKey  => $internalValue ) {
                           $indexIDIs = $internalKey;
                            $ValueIs = $internalValue;
                           
                            $addprofilefieldsvalues = array( 
                                'item_id'  => $customer_id,
                                'field_id'  => $fieldIdIs,
                                'index'   => $indexIDIs,
                                'value'   => $ValueIs,
                            );
                           $makeFieldarray[$index] = $addprofilefieldsvalues;
                           $index++;
                    }
                 }
                else {
                        $indexIDIs = 0;
                        $ValueIs = $fieldvalue;
                                                 
                        $addprofilefieldsvalues = array( 
                            'item_id'  => $customer_id,
                            'field_id'  => $fieldIdIs,
                            'index'   => $indexIDIs,
                            'value'   => $ValueIs,
                        );
                        $makeFieldarray[$index] = $addprofilefieldsvalues;
                       $index++;
                 }
            }
        }
       
        return $makeFieldarray;
    }

    protected function verifyLevelPermission( $adminId ) {


        $permissionTable = Engine_Api::_()->getDbtable('permissions', 'authorization');
        $permissionTableName = $permissionTable->info('name');

        $select = $permissionTable->select()
                                  ->from($permissionTableName, array('levels'=>'GROUP_CONCAT(`'.$permissionTableName.'`.`level_id`)'))
                                  ->where('name = ?', 'allow_verify')
                                  ->where('value = 1')
                                  ->where( 'type = ?', 'siteverify_verify');
        $levels = $permissionTable->fetchRow($select);
        
        if( ! strpos( $levels->levels, ',' )) {
            $levels = array( 0=>$levels->levels );
        } else {
            
            $levels = explode(',',$levels->levels);
        }
        $select = $permissionTable->select()
                                  ->from($permissionTableName, array('level_id','params'))
                                  ->where('name = ?', 'auth_verify')
                                  ->where( 'type = ?', 'siteverify_verify')
                                  ->where('level_id IN (?) ', $levels);
        $params = $permissionTable->fetchAll($select);


        $userLevels = array();
        $index =0 ;

        foreach ($params as $key => $value) {
            $jsonDecodeValue= json_decode($value['params']) ;
            if (in_array((string)$adminId, $jsonDecodeValue))
            {
                $userLevels[ $index ] = $value[ 'level_id' ];
                $index++;
            }
        }

        return $userLevels;
    }
}