<?php

class Siteuserkyc_Form_UserKyc_UploadFile extends Engine_Form {

	protected $_engineApi = null;
	protected $_viewer = null;
	protected $_viewer_id = null;

	protected $_allowedDocuments = null;

	public function getAllowedDocuments( ) {
		return $this->_allowedDocuments;
	}


	public function setAllowedDocuments( array $allowedDocuments ) {
		$this->_allowedDocuments = $allowedDocuments;
		return $this;
	}


	public function init() {

		$this->_engineApi = Engine_Api::_();
		$this->_viewer = $this->_engineApi->user()->getViewer();
		$this->_viewer_id = $this->_viewer->getIdentity();
		$this->setTitle( 'Upload Document for KYC Verification' )->setAttrib( 'name', 'upload_users_kyc_document' );

		$tabindex = 1;

		$allowedDocuments = array( '' => 'Choose Document Type' );
		foreach ($this->_allowedDocuments as $key => $value) {
			$allowedDocuments[$value] = ucwords( str_replace('_', ' ', $value ) );
		}
        $this->addElement( 'Select', 'document_type', 
        					array( 'label' => 'Select Document Type',
						           'allowEmpty' => false,
						           'required' => true,
						           'order' => $tabindex++,
						           'autofocus' => 'autofocus',
						           'multiOptions' => $allowedDocuments,
							       'validators' => array( array('NotEmpty', true) ),
						        )
        				);
        $this->document_type->getValidator('NotEmpty')->setMessage('Please Select Document Type.', 'isEmpty');
  		$this->addElement( 'File', 'user_profile_photo', 
  							array(	'label' => 'User Photo',
			        				'required' => true,
			        				'allowEmpty' => false,
			        				'order' => $tabindex++
			      				)
  						);
		$this->user_profile_photo->addValidator('Extension', false, 'jpg,jpeg,png,pdf');
		$this->user_profile_photo->getValidator('upload')->setMessage('Please upload your photo.', 'fileUploadErrorNoFile');

  		$this->addElement( 'File', 'document_front_photo', 
  							array(	'label' => 'Upload Document for KYC (Front)',
			        				'required' => true,
			        				'allowEmpty' => false,
			        				'order' => $tabindex++
			      				)
  						);
		$this->document_front_photo->addValidator('Extension', false, 'jpg,jpeg,png,pdf');
		$this->document_front_photo->getValidator('upload')->setMessage('Please upload your doucment file.', 'fileUploadErrorNoFile');

		/*$this->addElement( 'Checkbox', 'is_document_back_photo_available', 
							array(	'label' => 'Is Document has details on it\'s back',
        							'required' => false,
        							'tabindex' => $tabindex++,
      							)
						);*/

  		$this->addElement( 'File', 'document_back_photo', 
  							array(	'label' => 'Upload Document for KYC (Back)',
			        				'required' => false,
			        				'allowEmpty' => true,
			        				'order' => $tabindex++
			      				)
  						);
		$this->document_back_photo->addValidator('Extension', false, 'jpg,jpeg,png,pdf');
		$this->document_back_photo->getValidator('upload')->setMessage('Please upload your photo.', 'fileUploadErrorNoFile');

    	// Add submit
    	$this->addElement('Button', 'submit', array( 'label' => 'Upload Document', 'type' => 'submit', 'order' => $tabindex++ ) );

	}


}