<?php

class Siteuserkyc_Model_Kyc extends Core_Model_Item_Abstract {

	protected $_engineApi = null;

	public function init() {

		$this->_engineApi = Engine_Api::_();
	}


	public function getParent($recurseType = null) {
    	return $this->getOwner($recurseType);
	}


	public function authorization($adapter = null) {
		$object = $this->_engineApi->getApi( 'allow', 'siteuserkyc' );
		return new Engine_ProxyObject($this, $object);
	}


	public function getOwner($recurseType = null) {
		return $this->_engineApi->getItem( 'user', $this->user_id );
	}


	public function uploadKYCPhoto( $photo , string $photoType = '' ) {


		//user_profile_photo	document_front_photo	document_back_photo
		if ( empty($photoType) || !in_array( $photoType, array( 'user_profile_photo',	'document_front_photo',	'document_back_photo') ) ) {
			throw new Exception("Invalid photo type", 1);
		}
		if( $photo instanceof Zend_Form_Element_File ) {
			$file = $photo->getFileName();
		} elseif( is_array($photo) && !empty($photo['tmp_name']) ) {
			$file = $photo['tmp_name'];
		} elseif( is_string($photo) && file_exists($photo) ) {
			$file = $photo;
		} else {
			throw new Entry_Model_Exception('Invalid argument passed to setPhoto: ' . print_r($photo, 1));
		}

		$name = basename($file);
		$path = APPLICATION_PATH . DIRECTORY_SEPARATOR . 'temporary';
		$params = array( 'parent_type' => 'siteuserkyc_kyc', 'parent_id' => $this->getIdentity() );

		$image = Engine_Image::factory();
		$image->open($file)->write($path . '/m_' . $name)->destroy();

		$storage = $this->_engineApi->storage();
		$iMain = $storage->create($path . '/m_' . $name, $params);
		@unlink($path . '/m_' . $name);
		$this->$photoType = $iMain->getIdentity();
		$this->save();

	}


	protected function _delete() {

		$table = $this->_engineApi->getItemTable('storage_file');
		$select = $table->select()->where( "parent_type = 'siteuserkyc_kyc'" )->where( 'parent_id = ?', $this->kyc_id );
		foreach( $table->fetchAll($select) as $file ) {
			try {
				$file->delete();
			} catch( Exception $e ) {
				if( !($e instanceof Engine_Exception) ) {
					Zend_Registry::get('Zend_Log')->log($e->__toString(), Zend_Log::WARN);
				}
			}
		}
		// Call parent
		parent::_delete();

	}

}