<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteuserurl
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Addurl.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteuserurl_Form_Admin_Settings_Addurl extends Engine_Form
{

  public function init()
  {
    $this
      ->setMethod('post')
      ->setAttrib('class', 'global_form_box')
    ;

    $bannedUsernamesTable = Engine_Api::_()->getDbtable('bannedUsernames', 'core');
    $bannedUsernames = $bannedUsernamesTable->select()
      ->from($bannedUsernamesTable, 'username')
      ->query()
      ->fetchAll(Zend_Db::FETCH_COLUMN);
    $modules = array();
    $manifest = Zend_Registry::get('Engine_Manifest');
        foreach ($manifest as $module => $config) {
            if ( isset($config['routes']) ) {
              foreach( $config['routes'] as $item ) {
                $route = $item['route'];
                $route_array = explode('/', $route);
                $route_url = strtolower($route_array[0]);
                if( !empty($route_url) ) {
                  if( !(in_array($route_url, $bannedUsernames)) ) {
                    if( !(in_array($module, $modules)) ) {
                      $modules[$module] = $module. ' ';
                    }
                  }
                }
              }
            }
          }

    $this->addElement('Select', 'module_name', array(
      'label' => 'Module Name',
      'description' => 'Select the module name which should be banned from being assigned as Username to your site users.',
      'multiOptions' => $modules,
      'value' => ($modules),
    ));
    // Element: execute
    $this->addElement('Button', 'submit', array(
      'label' => 'Add',
      'type' => 'submit',
      'ignore' => true,
      'decorators' => array(
        'ViewHelper',
      ),
    ));

    $this->addElement('Cancel', 'cancel', array(
      'label' => 'cancel',
      'link' => true,
      'prependText' => ' or ',
      'href' => '',
      'onClick' => 'javascript:parent.Smoothbox.close();',
      'decorators' => array(
        'ViewHelper'
      )
    ));
  }

}
