<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package Siteuserurl
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license http://www.socialengineaddons.com/license/
 * @version $Id: install.php 2010-10-25 9:40:21Z SocialEngineAddOns $
 * @author  SocialEngineAddOns
 */
class Siteuserurl_Installer extends Engine_Package_Installer_Module
{
  function onInstall()
  {

    //GET DB
    $db = $this->getDb();

    parent::onInstall();

    $select = new Zend_Db_Select($db);
    $select
      ->from('engine4_core_modules', 'name')
      ->where('enabled = ?', 1);
    $enableAllModules = $select->query()->fetchAll(Zend_Db::FETCH_COLUMN);

    $routs = array();
    foreach( $enableAllModules as $moduleName ) {
      $file_path = APPLICATION_PATH . "/application/modules/" . ucfirst($moduleName) . "/settings/manifest.php";
      if( @file_exists($file_path) ) {
        $ret = include $file_path;
        $is_exist = array();
        if( isset($ret['routes']) ) {
          foreach( $ret['routes'] as $item ) {
            $route = $item['route'];
            $route_array = explode('/', $route);
            $route_url = strtolower($route_array[0]);
            if( !empty($route_url) && !(in_array($route_url, $routs)) ) {
              $routs[] = $route_url;
            }
          }
        }
      }
    }
    $values = "('" . implode("'), ('", $routs) . "')";
    $db->query("INSERT IGNORE INTO `engine4_core_bannedusernames` (`username`) VALUES $values;");
  }
}

?>
