<?php

class Siteverify_IndexController extends Siteapi_Controller_Action_Standard {

    public function init() {
        if ($this->getRequestParam('user_id') && (0 !== ($user_id = (int) $this->getRequestParam('user_id')) &&
                null !== ($user = Engine_Api::_()->getItem('user', $user_id))))
            Engine_Api::_()->core()->setSubject($user);

        $viewer = Engine_Api::_()->user()->getViewer();
        if (!empty($viewer) && !Engine_Api::_()->core()->hasSubject())
            Engine_Api::_()->core()->setSubject($viewer);
        Engine_Api::_()->getApi('Core', 'siteapi')->setView();
    }

    public function allowVerifyAction() {
        //CHECK FOR USER LOGGED IN OR NOT
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();

        // WE GET RESOURCE ID,RESOURCE TYPE AND RESOURCE TITLE
        $subject = Engine_Api::_()->core()->getSubject();
        $resource_id = $subject->getIdentity();
        $resource_title = $subject->getTitle();

        if ($viewer_id == $resource_id) {
            $this->respondwitherror('unauthorized');
        }

        //TO CHECK ADMIN HAS ALLOWED TO VERIFY OR NOT
        $authorizationApi = Engine_Api::_()->authorization();

        $tempLevelId = ($subject && isset($subject->level_id) && !empty($subject->level_id)) ? $subject->level_id : 0;
        $allow_verify = $allowVerify = $authorizationApi->getPermission($tempLevelId, 'siteverify', 'allow_verify');

        $verifyOptions = $verifyOption = (array) Engine_Api::_()->authorization()->getAdapter('levels')->getAllowed('siteverify', $subject, 'auth_verify');

        if ((empty($allowVerify) || !in_array($viewer->level_id, $verifyOption))) {
            $this->respondwitherror('unauthorized');
        }
        $response = array();
        //TO CHECK CURRENT VIEWING USER HAS BEEN VERIFIED OR NOT
        $verifyTable = Engine_Api::_()->getDbtable('verifies', 'siteverify');
        $hasVerified = $verifyTable->hasVerify($resource_id);
        $allow_unverify = $authorizationApi->getPermission($tempLevelId, 'siteverify', 'allow_unverify');
        $is_comment = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteverify.comment.verifypopup', 1);
        if (!empty($hasVerified)) {
            $admin_approve = $hasVerified->admin_approve;
            $verify_id = $hasVerified->verify_id;
            $response['admin_approve'] = $admin_approve;
            $response['verify_id'] = $verify_id;
            $verifyObj = Engine_Api::_()->getItem('siteverify_verify', $verify_id);
            if (!empty($admin_approve)) {
                if (!empty($allow_unverify)) {
                    $menus[] = array(
                        'label' => $this->translate('Cancel Verification'),
                        'name' => 'cancel_verification',
                        'url' => 'memberverify/cancel-verify',
                        'urlParams' => array(
                            "user_id" => $resource_id,
                            "verify_id" => $verify_id
                        )
                    );
                }
                if (!empty($is_comment)) {
                    $menus[] = array(
                        'label' => $this->translate('Edit Verification'),
                        'name' => 'edit_verification',
                        'comments' => $verifyObj->comments,
                        'url' => 'memberverify/edit-verify',
                        'urlParams' => array(
                            "user_id" => $resource_id,
                            "verify_id" => $verify_id
                        )
                    );
                }
                $menus[] = array(
                    'label' => $this->translate('View Verification'),
                    'name' => 'view_details',
                    'url' => 'memberverify/verify-detail',
                    'urlParams' => array(
                        "user_id" => $resource_id
                    )
                );
            } else {
                if (!empty($allow_unverify)) {
                    $menus[] = array(
                        'label' => $this->translate('Cancel Request'),
                        'name' => 'cancel_verification',
                        'url' => 'memberverify/cancel-verify',
                        'urlParams' => array(
                            "user_id" => $resource_id,
                            "verify_id" => $verify_id
                        )
                    );
                }
                if (!empty($is_comment)) {
                    $menus[] = array(
                        'label' => $this->translate('Edit Request'),
                        'name' => 'edit_verification',
                        'comments' => $verifyObj->comments,
                        'url' => 'memberverify/edit-verify',
                        'urlParams' => array(
                            "user_id" => $resource_id,
                            "verify_id" => $verify_id
                        )
                    );
                }

                $menus[] = array(
                    'label' => $this->translate('View Verification'),
                    'name' => 'view_details',
                    'url' => 'memberverify/verify-detail',
                    'urlParams' => array(
                        "user_id" => $resource_id
                    )
                );
            }
        } else {
            $name = 'Verify ' . $resource_title;
            $menus[] = array(
                'label' => $this->translate($name),
                'name' => 'very_user',
                'is_comment' => $is_comment,
                'url' => 'memberverify/verify',
                'urlParams' => array(
                    "user_id" => $resource_id
                )
            );
            $verify_count = $verifyTable->getVerifyCount($resource_id);
            if (!empty($verify_count)) {
                $menus[] = array(
                    'label' => $this->translate('View Verification'),
                    'name' => 'view_details',
                    'url' => 'memberverify/verify-detail',
                    'urlParams' => array(
                        "user_id" => $resource_id
                    )
                );
            }
        }

        //TO COUNT NO OF USERS WHO VERIFIED CURRENT VIEWING USER
        $verify_count = $verifyTable->getVerifyCount($resource_id);
        $response['verify_count'] = $verify_count;

        //CHECK PERMISSIONS
        $verify_limit = $authorizationApi->getPermission($tempLevelId, 'siteverify', 'verify_limit');
        $allow_unverify = $authorizationApi->getPermission($tempLevelId, 'siteverify', 'allow_unverify');
        $is_comment = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteverify.comment.verifypopup', 1);
        $response['verify_limit'] = $verify_limit;
        $response['allow_unverify'] = $allow_unverify;
        $response['is_comment'] = $is_comment;
        $response['menu'] = $menus;
        $this->respondwithsuccess($response, false);
    }

    public function verifyAction() {
        //TO CHECK USER IS LOGGED IN OR NOT
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();
        if (!$this->_helper->requireUser()->isValid())
            return;


        //GET THE VALUE OF RESOURCE ID ,RESOURCE TYPE AND RESOURCR TITLE
        $resource_id = $this->_getParam('user_id');
        $resource = Engine_Api::_()->getItem('user', $resource_id);
        //TO CHECK ADMIN HAS ALLOWED TO VERIFY OR NOT
        $allow_verify = Engine_Api::_()->authorization()->getPermission($resource->level_id, 'siteverify', 'allow_verify');
        $verifyOptions = (array) Engine_Api::_()->authorization()->getAdapter('levels')->getAllowed('siteverify', $resource, 'auth_verify');

        if (empty($allow_verify) || !in_array($viewer->level_id, $verifyOptions)) {
            return;
        }

        $resource_title = $resource->getTitle();
        //DUMP ALL THE VALUE IN AN ARRAY
        $values = array();
        $values['resource_type'] = 'user';
        $values['resource_id'] = $resource_id;
        $values['poster_type'] = "user";
        $values['poster_id'] = $viewer_id;
        $values['comments'] = $this->_getParam('comments');
      
        if (empty($values['comments']))
            unset($values['comments']);
        //GET THE VERIFY COUNT ,VERIFY LIMIT, ALLOW UNVERIFY AND IS COMMENT .
        $verifyTableObj = Engine_Api::_()->getDbtable('verifies', 'siteverify');
        $authorizationApi = Engine_Api::_()->authorization();

        $verify_count = $verifyTableObj->getVerifyCount($resource_id);
        $verify_limit = $authorizationApi->getPermission($resource->level_id, 'siteverify', 'verify_limit');
        $allow_unverify = $authorizationApi->getPermission($resource->level_id, 'siteverify', 'allow_unverify');
        $is_comment = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteverify.comment.verifypopup', 1);

        //IF ADMIN APPROVE IS ENABLED THEN ADMIN APPROVE WILL BE 0.
        $admin_approve = $authorizationApi->getPermission($resource->level_id, 'siteverify', 'admin_approve');
        if (!empty($admin_approve))
            $values['admin_approve'] = 0;
        else
            $verify_count = ++$verify_count; //OTHERWISE VERIFYCOUNT WILL BE INCREASED.
        $verify_count = $verify_count;

        //TO INSERT DATA IN VERIFY TABLE
        $db = Engine_Db_Table::getDefaultAdapter();
        $db->beginTransaction();
        try {
            $verify = $verifyTableObj->createRow();
            $verify->setFromArray($values);
            $verify->save();
            $verify_id = $verify->verify_id; //$db->lastInsertId($verifyTableName);
            // NOTIFICATION AND ACTIVITY FEED WORK

            if (empty($admin_approve)) {
                Engine_Api::_()->getDbtable('notifications', 'activity')->addNotification($resource, $viewer, $verify, 'siteverify_new');
                Engine_Api::_()->getDbtable('actions', 'activity')->addActivity($viewer, $resource, 'siteverify_new');
            } else {
                $userObj = Engine_Api::_()->getDbtable('users', 'user');
                $select = $userObj->select()->where('level_id = ?', 1);
                $adminObj = $userObj->fetchAll($select);
                foreach ($adminObj as $adminRow) {
                    Engine_Api::_()->getDbtable('notifications', 'activity')->addNotification($adminRow, $viewer, $verify, 'siteverify_user_request');
                }
            }

            // Commit
            $db->commit();
            $this->successResponseNoContent('no_content');
        } catch (Exception $e) {
            $db->rollBack();
            throw $e;
        }
    }

    public function editVerifyAction() {
        //TO CHECK USER IS LOGGED IN OR NOT
        if (!$this->_helper->requireUser()->isValid())
            return;

        //TO CHECK ADMIN HAS ALLOWED TO VERIFY OR NOT
        $is_comment = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteverify.comment.verifypopup', 1);

        if (empty($is_comment)) {
            //unauthorized
        }

        if ($this->getRequest()->isPost() || $this->getRequest()->isPut()) {

            //GET  VERIFY ID,COMMENTS
            $verify_id = $this->_getParam('verify_id');
            $comments = $this->_getParam('comments');
            $verifyObj = Engine_Api::_()->getItem('siteverify_verify', $verify_id);
            $resource_id = $verifyObj->resource_id;
            $resource = Engine_Api::_()->getItem('user', $resource_id);
            $resource_title = $resource->getTitle();

            //GET THE VERIFY COUNT  VERIFY LIMIT AND ALLOW UNVERIFY.
            $verifyTableObj = Engine_Api::_()->getDbtable('verifies', 'siteverify');
            $authorizationApi = Engine_Api::_()->authorization();
            
            $verify_count = $verifyTableObj->getVerifyCount($resource_id);
            $verify_limit = $authorizationApi->getPermission($resource->level_id, 'siteverify', 'verify_limit');

            $allow_unverify = $authorizationApi->getPermission($resource->level_id, 'siteverify', 'allow_unverify');

            $is_comment = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteverify.comment.verifypopup', 1);

            $admin_approve = $verifyObj->admin_approve;
            //UPDATE VERIFY DATA BASE
            $db = Engine_Db_Table::getDefaultAdapter();
            $db->beginTransaction();
            try {
                $verifyObj->comments = $comments;
                // UPDATE THE VERIFY ENTRY FROM DATABASE
                $verifyObj->save();

                $db->commit();
                $this->successResponseNoContent('no_content');
            } catch (Exception $e) {
                $db->rollBack();
                throw $e;
            }
        }
    }

    // DELETE ENTRY FROM DATA BASE AFETR DELETR REQUEST
    public function cancelVerifyAction() {

        if (!$this->_helper->requireUser()->isValid())
            return;

        //GET VERIFY ID ,RESOURCE ID AND RESOURCE TYPE
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();

        $verify_id = $this->_getParam('verify_id');
        $verifyObj = Engine_Api::_()->getItem('siteverify_verify', $verify_id);
        $resource_id = $resource_id = $verifyObj->resource_id;
        $resource = Engine_Api::_()->getItem('user', $resource_id);
        $resource_title = $resource->getTitle();

        //GET THE VERIFY COUNT ,VERIFY LIMIT AND ALLOW VERIFY
        $verifyTableObj = Engine_Api::_()->getDbtable('verifies', 'siteverify');
        $authorizationApi = Engine_Api::_()->authorization();

        $verify_count = $verifyTableObj->getVerifyCount($resource_id);

        $verify_limit = $authorizationApi->getPermission($resource->level_id, 'siteverify', 'verify_limit');

        $admin_approve = $verifyObj->admin_approve;

        if (!empty($admin_approve))
            $verify_count = $verify_count - 1;
        else
            $verify_count = $verify_count;

        //TO DELETE  DATA IN VERIFY TABLE
        $db = Engine_Db_Table::getDefaultAdapter();
        $db->beginTransaction();
        try {

            //DELETE ACTIVITY FEED
            $action_id = Engine_Api::_()->getDbtable('actions', 'activity')->fetchRow(array('type = ?' => 'siteverify_new', 'subject_id = ?' => $verifyObj->poster_id, 'object_id = ?' => $verifyObj->resource_id));
            if (!empty($action_id)) {
                $action = Engine_Api::_()->getItem('activity_action', $action_id->action_id);
                $action->delete();
            }

            // DELETE THE VERIFY ENTRY FROM DATABASE
            $verifyObj->delete();
            $db->commit();
            $this->successResponseNoContent('no_content');
        } catch (Exception $e) {
            $db->rollBack();
            throw $e;
        }
    }

    public function verifyDetailAction() {

        //TO CHECK USER IS LOGGED IN OR NOT
        if (!$this->_helper->requireUser()->isValid())
            return;

        $resource_id = $this->_getParam('user_id');
        $resource = Engine_Api::_()->getItem('user', $resource_id);
        if (empty($resource)) {
            $this->respondwitherror('unauthorized');
        }
        $resource_title = $resource->getTitle();

        $current_page = $page = $this->_getParam('page', 1);
        $current_total_verify = $page * 10;

        $verifyTable = Engine_Api::_()->getDbtable('verifies', 'siteverify');
        $verify_count = $verifyTable->getVerifyCount($resource_id);
        $users = array();
        // GET LIST OF USERS WHO HAS VERIFIED CURRENT VIEWING USERS
        $params = array('admin_approve' => 1, 'resource_id' => $resource_id, 'status' => 1);
        $paginator = Engine_Api::_()->getDbTable('verifies', 'siteverify')->getVerifyPaginator($params);
        $paginator->setCurrentPageNumber($page);
        $paginator->setItemCountPerPage(10);
        $users['totalItemCount'] = $paginator->getTotalItemCount();
        foreach ($paginator as $verifyObj) {
            $poster_id = $verifyObj->poster_id;
            $user = Engine_Api::_()->getItem('user', $poster_id);
            if (empty($user) || empty($user->toArray())) {
                $users['totalItemCount'] = $users['totalItemCount'] - 1;
                continue;
            }
            $tempUser = Engine_Api::_()->getApi('Core', 'siteapi')->validateUserArray($user);
            // Add images
            $getContentImages = Engine_Api::_()->getApi('Core', 'siteapi')->getContentImage($user);
            $tempUser = array_merge($tempUser, $getContentImages);
            $tempUser['comments'] = $verifyObj->comments;
            $users['response'][] = $tempUser;
            //$users[] = $tempUser;
        }

        $this->respondWithSuccess($users);
    }

}

?>