<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteverify
 * @copyright  Copyright 2014-2015 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 2014-09-11 00:00:00 SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteverify_Installer extends Engine_Package_Installer_Module
{

    public function onInstall()
    {
        $db = $this->getDb();

        //Member profile page
        $select = new Zend_Db_Select($db);
        $select
            ->from('engine4_core_pages')
            ->where('name = ?', 'user_profile_index')
            ->limit(1);
        $page_id = $select->query()->fetchObject()->page_id;
        if (!empty($page_id)) {
            $select = new Zend_Db_Select($db);
            $select
                ->from('engine4_core_content')
                ->where('page_id = ?', $page_id)
                ->where('type = ?', 'container')
                ->where('name = ?', 'main')
                ->limit(1);
            $container_id = $select->query()->fetchObject()->content_id;
            if (!empty($container_id)) {
                $select = new Zend_Db_Select($db);
                $select
                    ->from('engine4_core_content')
                    ->where('parent_content_id = ?', $container_id)
                    ->where('type = ?', 'container')
                    ->where('name = ?', 'middle')
                    ->limit(1);
                $middle_id = $select->query()->fetchObject()->content_id;
                if (!empty($middle_id)) {
                    $select = new Zend_Db_Select($db);
                    $select
                        ->from('engine4_core_content')
                        ->where('parent_content_id = ?', $middle_id)
                        ->where('type = ?', 'widget')
                        ->where('name = ?', 'siteverify.verify-button');
                    $info = $select->query()->fetch();
                    if (empty($info)) {
                        // tab on profile
                        $db->insert('engine4_core_content', array(
                            'page_id'           => $page_id,
                            'type'              => 'widget',
                            'name'              => 'siteverify.verify-button',
                            'parent_content_id' => $middle_id,
                            'order'             => 1,
                            'params'            => '{"title":""}',
                        ));
                    }
                }
            }
        }

        $isModEnabled = $this->isModuleEnabled('sitemember');
        if (!empty($isModEnabled)) {
            //START UPDATE BROWSE MEMBER PAGE WIDGET.
            $select = new Zend_Db_Select($db);
            $select
                ->from('engine4_core_content', array('content_id', 'params'))
                ->where('type =?', 'widget')
                ->where('name =?', 'sitemember.browse-members-sitemember');
            $fetch = $select->query()->fetchAll();
            foreach ($fetch as $modArray) {
                $params = !empty($modArray['params']) ? Zend_Json::decode($modArray['params']) : array();
                if (is_array($params)) {
                    if (!in_array("verifyCount", $params['memberInfo'])) {
                        $params['memberInfo'][] = "verifyCount";
                    }

                    if (!in_array("verifyLabel", $params['memberInfo'])) {
                        $params['memberInfo'][] = "verifyLabel";
                    }

                    $paramss = Zend_Json::encode($params);
                    $db->update('engine4_core_content', array(
                        'params' => $paramss,
                    ), array(
                        'content_id = ?' => $modArray['content_id'],
                    ));
                }
            }
            //END UPDATE BROWSE MEMBER PAGE WIDGET.
        }

        $isModEnabled = $this->isModuleEnabled('siteusercoverphoto');
        if (!empty($isModEnabled)) {
            //START UPDATE MEMBER PROFILE COVER PHOTO.
            $select = new Zend_Db_Select($db);
            $select
                ->from('engine4_core_content', array('content_id', 'params'))
                ->where('type =?', 'widget')
                ->where('name =?', 'siteusercoverphoto.user-cover-photo');
            $fetch = $select->query()->fetchAll();
            foreach ($fetch as $modArray) {
                $params = !empty($modArray['params']) ? Zend_Json::decode($modArray['params']) : array();
                if (is_array($params)) {
                    if (!in_array("verify", $params['memberInfo'])) {
                        $params['showContent'][] = "verify";
                    }

                    $paramss = Zend_Json::encode($params);
                    $db->update('engine4_core_content', array(
                        'params' => $paramss,
                    ), array(
                        'content_id = ?' => $modArray['content_id'],
                    ));
                }
            }
            //END UPDATE MEMBER PROFILE COVER PHOTO
        }

        $db->query('UPDATE  `engine4_activity_notificationtypes` SET  `body` =  \'You have been verified by {item:$subject}.\' WHERE `engine4_activity_notificationtypes`.`type` =  "siteverify_new";');

        parent::onInstall();
    }

    public function isModuleEnabled($moduleName)
    {
        $db     = $this->getDb();
        $select = new Zend_Db_Select($db);
        $select
            ->from('engine4_core_modules')
            ->where('name = ?', $moduleName)
            ->where('enabled = ?', 1);
        $is_module_object = $select->query()->fetchObject();
        if ($is_module_object) {
            return true;
        }

        return false;
    }
}