<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitevideointegration
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminImportvideoController.php 6590 2015-1-22 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitevideointegration_AdminImportvideoController extends Core_Controller_Action_Admin {

    //ACTION FOR SHOWING IMPORT INSTRUCTIONS
    public function indexAction() {

        //INCREASE THE MEMORY ALLOCATION SIZE AND INFINITE SET TIME OUT
        ini_set('memory_limit', '2048M');
        set_time_limit(0);
        ini_set('upload_max_filesize', '100M');
        ini_set('post_max_size', '100M');
        ini_set('max_input_time', 600);
        ini_set('max_execution_time', 600);
        $coreModuleTable = Engine_Api::_()->getDbtable('modules', 'core');

        //GET NAVIGATION
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitevideo_admin_main', array(), 'sitevideo_admin_main_import');

        //START CODE FOR CREATING THE VideoToReviewImport.log FILE
        if (!file_exists(APPLICATION_PATH . '/temporary/log/VideoToSitevideoImport.log')) {
            $log = new Zend_Log();
            try {
                $log->addWriter(new Zend_Log_Writer_Stream(APPLICATION_PATH . '/temporary/log/VideoToSitevideoImport.log'));
            } catch (Exception $e) {
                //CHECK DIRECTORY
                if (!@is_dir(APPLICATION_PATH . '/temporary/log') && @mkdir(APPLICATION_PATH . '/temporary/log', 0777, true)) {
                    $log->addWriter(new Zend_Log_Writer_Stream(APPLICATION_PATH . '/temporary/log/VideoToSitevideoImport.log'));
                } else {
                    //Silence ...
                    if (APPLICATION_ENV !== 'production') {
                        $log->log($e->__toString(), Zend_Log::CRIT);
                    } else {
                        //MAKE SURE LOGGING DOESN'T CAUSE EXCEPTIONS
                        $log->addWriter(new Zend_Log_Writer_Null());
                    }
                }
            }
        }

        //GIVE WRITE PERMISSION IF FILE EXIST
        if (file_exists(APPLICATION_PATH . '/temporary/log/VideoToSitevideoImport.log')) {
            @chmod(APPLICATION_PATH . '/temporary/log/VideoToSitevideoImport.log', 0777);
        }
        //END CODE FOR CREATING THE VideoToSitevideoImport.log FILE
        //IMPORT ALL THE CORE VIDEOS IN SITEVIDEO PLUGIN
        //GET SITEVIDEO TABLE
        $sitevideoTable = Engine_Api::_()->getDbTable('videos', 'sitevideo');
        $sitevideoTableName = $sitevideoTable->info('name');

        $sitevideoratingsTable = Engine_Api::_()->getDbTable('ratings', 'sitevideo');
        $sitevideoratingsTableName = $sitevideoratingsTable->info('name');

        $streamTable = Engine_Api::_()->getDbTable('stream', 'activity');

        //GET VIDEO ATTACHMENT  TABLE
        $attachmentsTable = Engine_Api::_()->getDbtable('attachments', 'activity');
        $attachmentsTableName = $attachmentsTable->info('name');

        //GET STORAGE TABLE
        $storageTable = Engine_Api::_()->getDbtable('files', 'storage');

        //GET CORE LIKE TABLES
        $likeTable = Engine_Api::_()->getDbtable('likes', 'core');
        $likeTableName = $likeTable->info('name');

        //GET CORE COMMENT TABLES
        $commentTable = Engine_Api::_()->getDbtable('comments', 'core');
        $commentTableName = $commentTable->info('name');

        //GET TAGMAPS TABLE
        $tagmapsTable = Engine_Api::_()->getDbtable('TagMaps', 'core');
        $tagmapsTableName = $tagmapsTable->info('name');

        //GET STYLE TABLES
        $stylesTable = Engine_Api::_()->getDbtable('styles', 'core');
        $stylesTableName = $stylesTable->info('name');

        //GET ACTIONS TABLE
        $actionsTable = Engine_Api::_()->getDbtable('actions', 'activity');
        $actionsTableName = $actionsTable->info('name');
        $sitevideoOtherinfoTable = Engine_Api::_()->getDbTable('videootherinfo', 'sitevideo');

        $this->view->first_sitepagevideo_id = $first_sitepagevideo_id = 0;
        $this->view->last_sitepagevideo_id = $last_sitepagevideo_id = 0;

        $this->view->sitepagevideoEnabled = $sitepagevideoEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitepagevideo');

        if ($sitepagevideoEnabled && (Engine_Api::_()->getDbtable('modules', 'sitevideo')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'sitepage_page', 'item_module' => 'sitepage')))) {

            //GET VIDEO TABLES 
            $sitepagevideoTable = Engine_Api::_()->getDbTable('videos', 'sitepagevideo');
            $sitepagevideoTableName = $sitepagevideoTable->info('name');

            $sitepagevideoratingsTable = Engine_Api::_()->getDbTable('ratings', 'sitepagevideo');
            $sitepagevideoratingsTableName = $sitepagevideoratingsTable->info('name');
            //ADD NEW COLUMN IN VIDEO TABLE
            $db = Engine_Db_Table::getDefaultAdapter();
            $is_sitepagevideo_import = $db->query("SHOW COLUMNS FROM engine4_sitepagevideo_videos LIKE 'is_sitepagevideo_import'")->fetch();
            if (empty($is_sitepagevideo_import)) {
                $run_query = $db->query("ALTER TABLE `engine4_sitepagevideo_videos` ADD is_sitepagevideo_import TINYINT( 2 ) NOT NULL DEFAULT '0'");
            }

            //START IF IMPORTING IS BREAKED BY SOME REASON
            $selectVideos = $sitepagevideoTable->select()
                    ->from($sitepagevideoTableName, 'video_id')
                    ->where('is_sitepagevideo_import != ?', 1)
                    ->order('video_id ASC');
            $sitepagevideoDatas = $sitepagevideoTable->fetchAll($selectVideos);

            if (!empty($sitepagevideoDatas)) {

                $flag_first_sitepagevideo_id = 1;

                foreach ($sitepagevideoDatas as $sitepagevideoData) {

                    if ($flag_first_sitepagevideo_id == 1) {
                        $this->view->first_sitepagevideo_id = $first_sitepagevideo_id = $sitepagevideoData->video_id;
                    }
                    $flag_first_sitepagevideo_id++;

                    $this->view->last_sitepagevideo_id = $last_sitepagevideo_id = $sitepagevideoData->video_id;
                }

                if (isset($_GET['sitepagevideo_assigned_previous_id'])) {
                    $this->view->sitepagevideo_assigned_previous_id = $sitepagevideo_assigned_previous_id = $_GET['sitepagevideo_assigned_previous_id'];
                } else {
                    $this->view->sitepagevideo_assigned_previous_id = $sitepagevideo_assigned_previous_id = $first_sitepagevideo_id;
                }
            }
            //START IMPORTING IF REQUESTED
            if (isset($_GET['start_import']) && $_GET['start_import'] == 1 && $_GET['module'] == 'sitepagevideo') {

                try {
                    //ACTIVITY FEED IMPORT
                    $activity_sitepagevideo = $this->_getParam('activity_sitepagevideo');

                    //START VIDEO IMPORTING
                    $selectVideos = $sitepagevideoTable->select()
                            ->where('video_id >= ?', $sitepagevideo_assigned_previous_id)
                            ->from($sitepagevideoTableName, 'video_id')
                            ->where('is_sitepagevideo_import != ?', 1)
                            ->order('video_id ASC');
                    $sitepagevideoDatas = $sitepagevideoTable->fetchAll($selectVideos);

                    $next_import_count = 0;
                    $sitepagevideoDatasArray = $sitepagevideoDatas->toArray();
                    if ($sitepagevideoDatasArray) {
                        foreach ($sitepagevideoDatas as $sitepagevideoData) {
                            $db = Engine_Db_Table::getDefaultAdapter();
                            $db->beginTransaction();
                            try {
                                $sitepagevideo_id = $sitepagevideoData->video_id;
                                if (!empty($sitepagevideo_id)) {
                                    $sitepagevideo = Engine_Api::_()->getItem('sitepagevideo_video', $sitepagevideo_id);
                                    $sitevideo = $sitevideoTable->createRow();
                                    $sitevideo->title = $sitepagevideo->title;
                                    $sitevideo->description = $sitepagevideo->description;
                                    $sitevideo->owner_id = $sitepagevideo->owner_id;
                                    $sitevideo->parent_type = 'sitepage_page';
                                    $sitevideo->parent_id = $sitepagevideo->page_id;
                                    $sitepage = Engine_Api::_()->getItem('sitepage_page', $sitepagevideo->page_id);
                                    //$sitevideo->category_id = 1;
                                    $sitevideo->synchronized = 1;
                                    $sitevideo->creation_date = $sitepagevideo->creation_date;
                                    $sitevideo->modified_date = $sitepagevideo->modified_date;
                                    $sitevideo->save();
                                    $sitevideo->creation_date = $sitepagevideo->creation_date;
                                    $sitevideo->modified_date = $sitepagevideo->modified_date;
                                    $sitevideo->view_count = 1;
                                    if ($sitepagevideo->view_count > 0) {
                                        $sitevideo->view_count = $sitepagevideo->view_count;
                                    }
                                    $sitevideo->search = $sitepagevideo->search;

                                    if (isset($sitepagevideo->location))
                                        $sitevideo->location = $sitepagevideo->location;

                                    if (isset($sitepagevideo->seao_locationid))
                                        $sitevideo->seao_locationid = $sitepagevideo->seao_locationid;
                                    $sitevideo->featured = $sitepagevideo->featured;

                                    $sitevideo->type = $sitepagevideo->type;
                                    $sitevideo->code = $sitepagevideo->code;
                                    $sitevideo->photo_id = $sitepagevideo->photo_id;
                                    $sitevideo->rating = $sitepagevideo->rating;
                                    $sitevideo->status = $sitepagevideo->status;
                                    $sitevideo->file_id = $sitepagevideo->file_id;
                                    $sitevideo->duration = $sitepagevideo->duration;

                                    $sitevideo->save();
                                    $sitepagevideo->is_sitepagevideo_import = 1;

                                    $sitepagevideo->save();

                                    $row = $sitevideoOtherinfoTable->getOtherinfo($sitevideo->getIdentity());
                                    if (empty($row)) {
                                        $sitevideoOtherinfoTable->insert(array(
                                            'video_id' => $sitevideo->getIdentity(),
                                                // 'host_params' => json_encode($hostInfo),
                                        )); //COMMIT
                                    }

                                    $next_import_count++;
                                    //END GET DATA FROM VIDEO

                                    $values = array();

                                    //START FETCH PRIVACY
                                    $auth = Engine_Api::_()->authorization()->context;

                                    //START VIEW PRIVACY
                                    $auth = Engine_Api::_()->authorization()->context;
                                    $values = array();

                                    //START VIEW PRIVACY
                                    $rolesVideos = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    foreach ($rolesVideos as $rolesVideo) {

                                        if ($auth->isAllowed($sitepage, $rolesVideo, 'view')) {
                                            $values['auth_view'] = $rolesVideo;
                                            break;
                                        }
                                    }
                                    $rolesSitevideos = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    $viewMax = array_search($values['auth_view'], $rolesSitevideos);

                                    foreach ($rolesSitevideos as $i => $rolesSitevideo) {
                                        $auth->setAllowed($sitevideo, $rolesSitevideo, 'view', ($i >= $viewMax));
                                    }
                                    //END VIEW PRIVACY
                                    // //START VIEW PRIVACY
                                    $rolesVideos = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    foreach ($rolesVideos as $rolesVideo) {

                                        if ($auth->isAllowed($sitepage, $rolesVideo, 'comment')) {
                                            $values['auth_comment'] = $rolesVideo;
                                            break;
                                        }
                                    }
                                    $rolesSitevideos = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    $commentMax = array_search($values['auth_comment'], $rolesSitevideos);

                                    foreach ($rolesSitevideos as $i => $rolesSitevideo) {
                                        $auth->setAllowed($sitevideo, $rolesSitevideo, 'comment', ($i >= $commentMax));
                                    }
                                    //END VIEW PRIVACY
                                    //START FETCH COMMENTS
                                    $selectComment = $commentTable->select()
                                            ->from($commentTableName, 'comment_id')
                                            ->where('resource_type = ?', 'sitepagevideo_video')
                                            ->where('resource_id = ?', $sitepagevideo_id);
                                    $selectCommentDatas = $commentTable->fetchAll($selectComment);
                                    foreach ($selectCommentDatas as $selectCommentData) {
                                        $comment = Engine_Api::_()->getItem('core_comment', $selectCommentData->comment_id);
                                        $newCommentEntry = $commentTable->createRow();
                                        $newCommentEntry->resource_type = 'video';
                                        $newCommentEntry->resource_id = $sitevideo->getIdentity();
                                        $newCommentEntry->poster_type = 'user';
                                        $newCommentEntry->poster_id = $comment->poster_id;
                                        $newCommentEntry->creation_date = $comment->creation_date;
                                        $newCommentEntry->like_count = $comment->like_count;
                                        $newCommentEntry->save();

                                        $newCommentEntry->creation_date = $comment->creation_date;
                                        $comment_id = $newCommentEntry->save();

                                        //START FETCH LIKES
                                        $selectLike = $likeTable->select()
                                                ->from($likeTableName, 'like_id')
                                                ->where('resource_type = ?', 'core_comment')
                                                ->where('resource_id = ?', $selectCommentData->comment_id);
                                        $selectLikeDatas = $likeTable->fetchAll($selectLike);
                                        foreach ($selectLikeDatas as $selectLikeData) {
                                            $like = Engine_Api::_()->getItem('core_like', $selectLikeData->like_id);
                                            $newLikeEntry = $likeTable->createRow();
                                            $newLikeEntry->resource_type = 'core_comment';
                                            $newLikeEntry->resource_id = $comment_id;
                                            $newLikeEntry->poster_type = 'user';
                                            $newLikeEntry->poster_id = $like->poster_id;
                                            $newLikeEntry->creation_date = $like->creation_date;

                                            $newLikeEntry->save();
                                            $newLikeEntry->creation_date = $like->creation_date;
                                            $newLikeEntry->save();
                                        }
                                        //END FETCH LIKES
                                    }
                                    //END FETCH COMMENTS
                                    //START UPDATE TOTAL COMMENTS IN SITEVIDEO TABLE
                                    $selectCommentCount = $commentTable->select()
                                            ->from($commentTableName, array('COUNT(*) AS like_count'))
                                            ->where('resource_type = ?', 'sitepagevideo_video')
                                            ->where('resource_id = ?', $sitepagevideo_id);
                                    $selectCommentCounts = $commentTable->fetchAll($selectCommentCount);
                                    if (!empty($selectCommentCounts)) {
                                        $selectCommentCounts = $selectCommentCounts->toArray();
                                        $sitevideo->comment_count = $selectCommentCounts[0]['like_count'];
                                        $sitevideo->save();
                                    }
                                    //END UPDATE TOTAL COMMENTS IN SITEVIDEO TABLE
                                    //START FETCH LIKES
                                    $selectLike = $likeTable->select()
                                            ->from($likeTableName, 'like_id')
                                            ->where('resource_type = ?', 'sitepagevideo_video')
                                            ->where('resource_id = ?', $sitepagevideo_id);
                                    $selectLikeDatas = $likeTable->fetchAll($selectLike);
                                    foreach ($selectLikeDatas as $selectLikeData) {
                                        $like = Engine_Api::_()->getItem('core_like', $selectLikeData->like_id);
                                        $newLikeEntry = $likeTable->createRow();
                                        $newLikeEntry->resource_type = 'video';
                                        $newLikeEntry->resource_id = $sitevideo->getIdentity();
                                        $newLikeEntry->poster_type = 'user';
                                        $newLikeEntry->poster_id = $like->poster_id;
                                        $newLikeEntry->creation_date = $like->creation_date;
                                        $newLikeEntry->save();
                                        $newLikeEntry->creation_date = $like->creation_date;
                                        $newLikeEntry->save();
                                    }
                                    //END FETCH LIKES
                                    //START UPDATE TOTAL LIKES IN SITEVIDEO TABLE
                                    $selectLikeCount = $likeTable->select()
                                            ->from($likeTableName, array('COUNT(*) AS like_count'))
                                            ->where('resource_type = ?', 'sitepagevideo_video')
                                            ->where('resource_id = ?', $sitepagevideo_id);
                                    $selectLikeCounts = $likeTable->fetchAll($selectLikeCount);
                                    if (!empty($selectLikeCounts)) {
                                        $selectLikeCounts = $selectLikeCounts->toArray();
                                        $sitevideo->like_count = $selectLikeCounts[0]['like_count'];
                                        $sitevideo->save();
                                    }
                                    //END UPDATE TOTAL LIKES IN SITEVIDEO TABLES
                                    //RATING WORK
                                    //START FETCH RATINGS
                                    $selectSitepagevideoRating = $sitepagevideoratingsTable->select()
                                            ->from($sitepagevideoratingsTableName, '*')
                                            ->where('video_id = ?', $sitepagevideo_id);
                                    $selectSitepagevideoRatingDatas = $sitepagevideoratingsTable->fetchAll($selectSitepagevideoRating);
                                    $selectSitepagevideoRatingDatas = $selectSitepagevideoRatingDatas->toArray();
                                    foreach ($selectSitepagevideoRatingDatas as $selectSitepagevideoRatingData) {
                                        $sitevideoratingsTable->insert(array(
                                            'resource_type' => 'video',
                                            'resource_id' => $sitevideo->getIdentity(),
                                            'user_id' => $selectSitepagevideoRatingData['user_id'],
                                            'rating' => $selectSitepagevideoRatingData['rating'],
                                        ));
                                    }
                                }

                                //GENERATE ACITIVITY FEED
                                if ($activity_sitepagevideo) {
                                    //START FETCH ACTIONS
                                    $selectActionIds = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'sitepage_page')
                                            ->where('object_id = ?', $sitepage->getIdentity())
                                            ->where('type =?', 'sitepagevideo_admin_new')
                                            ->orWhere('type =?', 'sitepagevideo_new')
                                            ->query()
                                            ->fetchAll();
                                    foreach ($selectActionIds as $selectActionId) {
                                        $action = Engine_Api::_()->getItem('activity_action', $selectActionId);
                                        $action->type = 'sitevideo_video_new';
                                        $action->object_id = $sitevideo->getIdentity();
                                        $action->object_type = $sitevideo->getType();
                                        $action->save();
                                        $actionsTable->resetActivityBindings($action);
                                    }
                                    //END FETCH ACTIONS
                                    //START FETCH ACTIONS
                                    $selectActionId = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'sitepagevideo_video')
                                            ->where('object_id = ?', $sitepagevideo_id)
                                            ->where('type =?', 'post');
                                    $selectActionIds = $actionsTable->fetchAll($selectActionId);

                                    if ($selectActionIds) {
                                        foreach ($selectActionIds as $selectActionId) {
                                            $action = Engine_Api::_()->getItem('activity_action', $selectActionId['action_id']);

                                            $action->type = 'sitevideo_post';
                                            $action->object_id = $sitevideo->getIdentity();
                                            $action->object_type = $sitevideo->getType();
                                            $action->save();
                                            $actionsTable->resetActivityBindings($action);
                                        }
                                    }
                                    //END FETCH ACTIONS
                                    //START FETCH ACTIONS
                                    $selectActionId = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'sitepagevideo_video')
                                            ->where('object_id = ?', $sitepagevideo_id)
                                            ->where('type =?', 'sitetagcheckin_post');
                                    $selectActionIds = $actionsTable->fetchAll($selectActionId);
                                    if ($selectActionIds) {
                                        foreach ($selectActionIds as $selectActionId) {
                                            $action = Engine_Api::_()->getItem('activity_action', $selectActionId['action_id']);
                                            $action->type = 'sitetagcheckin_post';
                                            $action->object_id = $sitevideo->getIdentity();
                                            $action->object_type = $sitevideo->getType();
                                            $action->save();
                                            $actionsTable->resetActivityBindings($action);
                                        }
                                    }
                                    //END FETCH ACTIONS
                                    //START FETCH ACTIONS
                                    $selectActionId = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'sitepagevideo_video')
                                            ->where('object_id = ?', $sitepagevideo_id)
                                            ->where('type =?', 'like_sitepagevideo_video');
                                    $selectActionIds = $actionsTable->fetchAll($selectActionId);
                                    if ($selectActionIds) {
                                        foreach ($selectActionIds as $selectActionId) {
                                            $action = Engine_Api::_()->getItem('activity_action', $selectActionId['action_id']);
                                            $action->type = 'like_sitepagevideo_video';
                                            $action->object_id = $sitevideo->getIdentity();
                                            $action->object_type = $sitevideo->getType();
                                            $action->save();
                                            $actionsTable->resetActivityBindings($action);
                                        }
                                    }
                                    //END FETCH ACTIONS
                                    //UPDATE VIDEO TYPE 
                                    $attachmentsTable->update(array('type' => $sitevideo->getType(), 'id' => $sitevideo->getIdentity()), array('type = ?' => 'sitepagevideo_video', 'id =?' => $sitepagevideo_id));
                                }

                                if ($sitepagevideo->photo_id) {
                                    //STORAGE FILE WORK
                                    $storageData = $storageTable->fetchRow(array('file_id = ?' => $sitepagevideo->photo_id));
                                    if (!empty($storageData) && !empty($storageData->storage_path)) {
                                        // Get file
                                        $file = Engine_Api::_()->getItem('storage_file', $sitepagevideo->photo_id);

                                        // Pull video to a temporary file
                                        $tmpFile = $file->temporary();

                                        // Set the video
                                        $db = $sitevideo->getTable()->getAdapter();
                                        $db->beginTransaction();
                                        $params = array();
                                        $params['setPhotoId'] = true;
                                        try {
                                            $sitevideo->setVideo($tmpFile, $params);
                                            @unlink($tmpFile);
                                            $db->commit();
                                        } catch (Exception $e) {
                                            @unlink($tmpFile);
                                            $db->rollBack();
                                            throw $e;
                                        }
                                    }
                                }
                                if ($sitepagevideo->file_id) {
                                    //STORAGE FILE WORK
                                    $storageData = $storageTable->fetchRow(array('file_id = ?' => $sitepagevideo->file_id));
                                    if (!empty($storageData) && !empty($storageData->storage_path)) {
                                        $storage = Engine_Api::_()->getItemTable('storage_file');
                                        $storageObject = $storage->createFile($storageData->storage_path, array(
                                            'parent_id' => $sitevideo->getIdentity(),
                                            'parent_type' => $sitevideo->getType(),
                                            'user_id' => $sitevideo->getOwner()->getIdentity(),
                                        ));
                                        $sitevideo->file_id = $storageObject->file_id;
                                        $sitevideo->save();
                                    }
                                }

                                //CREATE LOG ENTRY IN LOG FILE
                                if (file_exists(APPLICATION_PATH . '/temporary/log/VideoToSitevideoImport.log')) {
                                    $myFile = APPLICATION_PATH . '/temporary/log/VideoToSitevideoImport.log';
                                    $error = Zend_Registry::get('Zend_Translate')->_("can't open file");
                                    $fh = fopen($myFile, 'a') or die($error);
                                    $current_time = date('D, d M Y H:i:s T');
                                    $sitevideo_title = $sitevideo->title;
                                    $stringData = $this->view->translate('Video with ID ') . $sitepagevideo_id . $this->view->translate(' is successfully imported into a Advanced Video with ID ') . $sitevideo->video_id . $this->view->translate(' at ') . $current_time . $this->view->translate(". Title of that Video is '") . $sitevideo_title . "'.\n\n";
                                    fwrite($fh, $stringData);
                                    fclose($fh);
                                }

                                $coreModuleTable->update(array('enabled' => 0), array('name = ?' => 'sitepagevideo'));
                                Engine_Api::_()->getDbtable('content', 'core')->delete(array('name =?' => 'sitepagevideo.profile-sitepagevideos'));
                                Engine_Api::_()->getDbtable('content', 'core')->delete(array('name =?' => 'sitepagevideo.profile-videos'));
                                Engine_Api::_()->getDbtable('admincontent', 'sitepage')->delete(array('name =?' => 'sitepagevideo.profile-sitepagevideos'));
                                Engine_Api::_()->getDbtable('admincontent', 'sitepage')->delete(array('name =?' => 'sitepagevideo.profile-videos'));
                                Engine_Api::_()->getDbtable('content', 'sitepage')->delete(array('name =?' => 'sitepagevideo.profile-sitepagevideos'));
                                Engine_Api::_()->getDbtable('content', 'sitepage')->delete(array('name =?' => 'sitepagevideo.profile-videos'));
                                $db->commit();
                                $this->view->sitepagevideo_assigned_previous_id = $sitepagevideo_id;
                            } catch (Exception $e) {
                                $db->rollback();
                                throw($e);
                            }
                            if ($next_import_count >= 100) {
                                $this->_redirect("admin/sitevideointegration/importvideo/index?start_import=1&module=sitepagevideo&recall=1&activity_sitepagevideo=$activity_sitepagevideo");
                            }
                        }
                    } else {
                        if ($_GET['recall']) {
                            echo json_encode(array('success' => 1));
                            exit();
                        }
                    }
                } catch (Exception $e) {
                    throw($e);
                }
            }
        }

        $this->view->first_sitebusinessvideo_id = $first_sitebusinessvideo_id = 0;
        $this->view->last_sitebusinessvideo_id = $last_sitebusinessvideo_id = 0;

        $this->view->sitebusinessvideoEnabled = $sitebusinessvideoEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessvideo');

        if ($sitebusinessvideoEnabled && (Engine_Api::_()->getDbtable('modules', 'sitevideo')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'sitebusiness_business', 'item_module' => 'sitebusiness')))) {

            //GET VIDEO TABLES 
            $sitebusinessvideoTable = Engine_Api::_()->getDbTable('videos', 'sitebusinessvideo');
            $sitebusinessvideoTableName = $sitebusinessvideoTable->info('name');

            $sitebusinessvideoratingsTable = Engine_Api::_()->getDbTable('ratings', 'sitebusinessvideo');
            $sitebusinessvideoratingsTableName = $sitebusinessvideoratingsTable->info('name');
            //ADD NEW COLUMN IN VIDEO TABLE
            $db = Engine_Db_Table::getDefaultAdapter();
            $is_sitebusinessvideo_import = $db->query("SHOW COLUMNS FROM engine4_sitebusinessvideo_videos LIKE 'is_sitebusinessvideo_import'")->fetch();
            if (empty($is_sitebusinessvideo_import)) {
                $run_query = $db->query("ALTER TABLE `engine4_sitebusinessvideo_videos` ADD is_sitebusinessvideo_import TINYINT( 2 ) NOT NULL DEFAULT '0'");
            }

            //START IF IMPORTING IS BREAKED BY SOME REASON
            $selectVideos = $sitebusinessvideoTable->select()
                    ->from($sitebusinessvideoTableName, 'video_id')
                    ->where('is_sitebusinessvideo_import != ?', 1)
                    ->order('video_id ASC');
            $sitebusinessvideoDatas = $sitebusinessvideoTable->fetchAll($selectVideos);

            if (!empty($sitebusinessvideoDatas)) {

                $flag_first_sitebusinessvideo_id = 1;

                foreach ($sitebusinessvideoDatas as $sitebusinessvideoData) {

                    if ($flag_first_sitebusinessvideo_id == 1) {
                        $this->view->first_sitebusinessvideo_id = $first_sitebusinessvideo_id = $sitebusinessvideoData->video_id;
                    }
                    $flag_first_sitebusinessvideo_id++;

                    $this->view->last_sitebusinessvideo_id = $last_sitebusinessvideo_id = $sitebusinessvideoData->video_id;
                }

                if (isset($_GET['sitebusinessvideo_assigned_previous_id'])) {
                    $this->view->sitebusinessvideo_assigned_previous_id = $sitebusinessvideo_assigned_previous_id = $_GET['sitebusinessvideo_assigned_previous_id'];
                } else {
                    $this->view->sitebusinessvideo_assigned_previous_id = $sitebusinessvideo_assigned_previous_id = $first_sitebusinessvideo_id;
                }
            }
            //START IMPORTING IF REQUESTED
            if (isset($_GET['start_import']) && $_GET['start_import'] == 1 && $_GET['module'] == 'sitebusinessvideo') {

                try {
                    //ACTIVITY FEED IMPORT
                    $activity_sitebusinessvideo = $this->_getParam('activity_sitebusinessvideo');

                    //START VIDEO IMPORTING
                    $selectVideos = $sitebusinessvideoTable->select()
                            ->where('video_id >= ?', $sitebusinessvideo_assigned_previous_id)
                            ->from($sitebusinessvideoTableName, 'video_id')
                            ->where('is_sitebusinessvideo_import != ?', 1)
                            ->order('video_id ASC');
                    $sitebusinessvideoDatas = $sitebusinessvideoTable->fetchAll($selectVideos);

                    $next_import_count = 0;
                    $sitebusinessvideoDatasArray = $sitebusinessvideoDatas->toArray();
                    if ($sitebusinessvideoDatasArray) {
                        foreach ($sitebusinessvideoDatas as $sitebusinessvideoData) {
                            $db = Engine_Db_Table::getDefaultAdapter();
                            $db->beginTransaction();
                            try {
                                $sitebusinessvideo_id = $sitebusinessvideoData->video_id;
                                if (!empty($sitebusinessvideo_id)) {
                                    $sitebusinessvideo = Engine_Api::_()->getItem('sitebusinessvideo_video', $sitebusinessvideo_id);
                                    $sitevideo = $sitevideoTable->createRow();
                                    $sitevideo->title = $sitebusinessvideo->title;
                                    $sitevideo->description = $sitebusinessvideo->description;
                                    $sitevideo->owner_id = $sitebusinessvideo->owner_id;
                                    $sitevideo->parent_type = 'sitebusiness_business';
                                    $sitevideo->parent_id = $sitebusinessvideo->business_id;
                                    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $sitebusinessvideo->business_id);
                                    // $sitevideo->category_id = 1;

                                    $sitevideo->creation_date = $sitebusinessvideo->creation_date;
                                    $sitevideo->modified_date = $sitebusinessvideo->modified_date;
                                    $sitevideo->save();
                                    $sitevideo->creation_date = $sitebusinessvideo->creation_date;
                                    $sitevideo->modified_date = $sitebusinessvideo->modified_date;
                                    $sitevideo->view_count = 1;
                                    if ($sitebusinessvideo->view_count > 0) {
                                        $sitevideo->view_count = $sitebusinessvideo->view_count;
                                    }
                                    $sitevideo->search = $sitebusinessvideo->search;

                                    if (isset($sitebusinessvideo->location))
                                        $sitevideo->location = $sitebusinessvideo->location;

                                    if (isset($sitebusinessvideo->seao_locationid))
                                        $sitevideo->seao_locationid = $sitebusinessvideo->seao_locationid;
                                    $sitevideo->featured = $sitebusinessvideo->featured;

                                    $sitevideo->type = $sitebusinessvideo->type;
                                    $sitevideo->code = $sitebusinessvideo->code;
                                    $sitevideo->photo_id = $sitebusinessvideo->photo_id;
                                    $sitevideo->rating = $sitebusinessvideo->rating;
                                    $sitevideo->status = $sitebusinessvideo->status;
                                    $sitevideo->file_id = $sitebusinessvideo->file_id;
                                    $sitevideo->duration = $sitebusinessvideo->duration;

                                    $sitevideo->save();
                                    $sitebusinessvideo->is_sitebusinessvideo_import = 1;

                                    $sitebusinessvideo->save();
                                    
                                    $row = $sitevideoOtherinfoTable->getOtherinfo($sitevideo->getIdentity());
                                    if (empty($row)) {
                                        $sitevideoOtherinfoTable->insert(array(
                                            'video_id' => $sitevideo->getIdentity(),
                                                // 'host_params' => json_encode($hostInfo),
                                        )); //COMMIT
                                    }
                                    $next_import_count++;
                                    //END GET DATA FROM VIDEO

                                    $values = array();

                                    //START FETCH PRIVACY
                                    $auth = Engine_Api::_()->authorization()->context;

                                    //START VIEW PRIVACY
                                    $auth = Engine_Api::_()->authorization()->context;
                                    $values = array();

                                    //START VIEW PRIVACY
                                    $rolesVideos = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    foreach ($rolesVideos as $rolesVideo) {

                                        if ($auth->isAllowed($sitebusiness, $rolesVideo, 'view')) {
                                            $values['auth_view'] = $rolesVideo;
                                            break;
                                        }
                                    }
                                    $rolesSitevideos = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    $viewMax = array_search($values['auth_view'], $rolesSitevideos);

                                    foreach ($rolesSitevideos as $i => $rolesSitevideo) {
                                        $auth->setAllowed($sitevideo, $rolesSitevideo, 'view', ($i >= $viewMax));
                                    }
                                    //END VIEW PRIVACY
                                    // //START VIEW PRIVACY
                                    $rolesVideos = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    foreach ($rolesVideos as $rolesVideo) {

                                        if ($auth->isAllowed($sitebusiness, $rolesVideo, 'comment')) {
                                            $values['auth_comment'] = $rolesVideo;
                                            break;
                                        }
                                    }
                                    $rolesSitevideos = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    $commentMax = array_search($values['auth_comment'], $rolesSitevideos);

                                    foreach ($rolesSitevideos as $i => $rolesSitevideo) {
                                        $auth->setAllowed($sitevideo, $rolesSitevideo, 'comment', ($i >= $commentMax));
                                    }
                                    //END VIEW PRIVACY
                                    //START FETCH COMMENTS
                                    $selectComment = $commentTable->select()
                                            ->from($commentTableName, 'comment_id')
                                            ->where('resource_type = ?', 'sitebusinessvideo_video')
                                            ->where('resource_id = ?', $sitebusinessvideo_id);
                                    $selectCommentDatas = $commentTable->fetchAll($selectComment);
                                    foreach ($selectCommentDatas as $selectCommentData) {
                                        $comment = Engine_Api::_()->getItem('core_comment', $selectCommentData->comment_id);
                                        $newCommentEntry = $commentTable->createRow();
                                        $newCommentEntry->resource_type = 'video';
                                        $newCommentEntry->resource_id = $sitevideo->getIdentity();
                                        $newCommentEntry->poster_type = 'user';
                                        $newCommentEntry->poster_id = $comment->poster_id;
                                        $newCommentEntry->creation_date = $comment->creation_date;
                                        $newCommentEntry->like_count = $comment->like_count;
                                        $newCommentEntry->save();

                                        $newCommentEntry->creation_date = $comment->creation_date;
                                        $comment_id = $newCommentEntry->save();

                                        //START FETCH LIKES
                                        $selectLike = $likeTable->select()
                                                ->from($likeTableName, 'like_id')
                                                ->where('resource_type = ?', 'core_comment')
                                                ->where('resource_id = ?', $selectCommentData->comment_id);
                                        $selectLikeDatas = $likeTable->fetchAll($selectLike);
                                        foreach ($selectLikeDatas as $selectLikeData) {
                                            $like = Engine_Api::_()->getItem('core_like', $selectLikeData->like_id);
                                            $newLikeEntry = $likeTable->createRow();
                                            $newLikeEntry->resource_type = 'core_comment';
                                            $newLikeEntry->resource_id = $comment_id;
                                            $newLikeEntry->poster_type = 'user';
                                            $newLikeEntry->poster_id = $like->poster_id;
                                            $newLikeEntry->creation_date = $like->creation_date;

                                            $newLikeEntry->save();
                                            $newLikeEntry->creation_date = $like->creation_date;
                                            $newLikeEntry->save();
                                        }
                                        //END FETCH LIKES
                                    }
                                    //END FETCH COMMENTS
                                    //START UPDATE TOTAL COMMENTS IN SITEVIDEO TABLE
                                    $selectCommentCount = $commentTable->select()
                                            ->from($commentTableName, array('COUNT(*) AS like_count'))
                                            ->where('resource_type = ?', 'sitebusinessvideo_video')
                                            ->where('resource_id = ?', $sitebusinessvideo_id);
                                    $selectCommentCounts = $commentTable->fetchAll($selectCommentCount);
                                    if (!empty($selectCommentCounts)) {
                                        $selectCommentCounts = $selectCommentCounts->toArray();
                                        $sitevideo->comment_count = $selectCommentCounts[0]['like_count'];
                                        $sitevideo->save();
                                    }
                                    //END UPDATE TOTAL COMMENTS IN SITEVIDEO TABLE
                                    //START FETCH LIKES
                                    $selectLike = $likeTable->select()
                                            ->from($likeTableName, 'like_id')
                                            ->where('resource_type = ?', 'sitebusinessvideo_video')
                                            ->where('resource_id = ?', $sitebusinessvideo_id);
                                    $selectLikeDatas = $likeTable->fetchAll($selectLike);
                                    foreach ($selectLikeDatas as $selectLikeData) {
                                        $like = Engine_Api::_()->getItem('core_like', $selectLikeData->like_id);
                                        $newLikeEntry = $likeTable->createRow();
                                        $newLikeEntry->resource_type = 'video';
                                        $newLikeEntry->resource_id = $sitevideo->getIdentity();
                                        $newLikeEntry->poster_type = 'user';
                                        $newLikeEntry->poster_id = $like->poster_id;
                                        $newLikeEntry->creation_date = $like->creation_date;
                                        $newLikeEntry->save();
                                        $newLikeEntry->creation_date = $like->creation_date;
                                        $newLikeEntry->save();
                                    }
                                    //END FETCH LIKES
                                    //START UPDATE TOTAL LIKES IN SITEVIDEO TABLE
                                    $selectLikeCount = $likeTable->select()
                                            ->from($likeTableName, array('COUNT(*) AS like_count'))
                                            ->where('resource_type = ?', 'sitebusinessvideo_video')
                                            ->where('resource_id = ?', $sitebusinessvideo_id);
                                    $selectLikeCounts = $likeTable->fetchAll($selectLikeCount);
                                    if (!empty($selectLikeCounts)) {
                                        $selectLikeCounts = $selectLikeCounts->toArray();
                                        $sitevideo->like_count = $selectLikeCounts[0]['like_count'];
                                        $sitevideo->save();
                                    }
                                    //END UPDATE TOTAL LIKES IN SITEVIDEO TABLES
                                    //RATING WORK
                                    //START FETCH RATINGS
                                    $selectSitebusinessvideoRating = $sitebusinessvideoratingsTable->select()
                                            ->from($sitebusinessvideoratingsTableName, '*')
                                            ->where('video_id = ?', $sitebusinessvideo_id);
                                    $selectSitebusinessvideoRatingDatas = $sitebusinessvideoratingsTable->fetchAll($selectSitebusinessvideoRating);
                                    $selectSitebusinessvideoRatingDatas = $selectSitebusinessvideoRatingDatas->toArray();
                                    foreach ($selectSitebusinessvideoRatingDatas as $selectSitebusinessvideoRatingData) {
                                        $sitevideoratingsTable->insert(array(
                                            'resource_type' => 'video',
                                            'resource_id' => $sitevideo->getIdentity(),
                                            'user_id' => $selectSitebusinessvideoRatingData['user_id'],
                                            'rating' => $selectSitebusinessvideoRatingData['rating'],
                                        ));
                                    }
                                }

                                //GENERATE ACITIVITY FEED
                                if ($activity_sitebusinessvideo) {
                                    //START FETCH ACTIONS
                                    $selectActionIds = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'sitebusiness_business')
                                            ->where('object_id = ?', $sitebusiness->getIdentity())
                                            ->where('type =?', 'sitebusinessvideo_admin_new')
                                            ->orWhere('type =?', 'sitebusinessvideo_new')
                                            ->query()
                                            ->fetchAll();
                                    foreach ($selectActionIds as $selectActionId) {
                                        $action = Engine_Api::_()->getItem('activity_action', $selectActionId);
                                        $action->type = 'sitevideo_video_new';
                                        $action->object_id = $sitevideo->getIdentity();
                                        $action->object_type = $sitevideo->getType();
                                        $action->save();
                                        $actionsTable->resetActivityBindings($action);
                                    }
                                    //END FETCH ACTIONS
                                    //START FETCH ACTIONS
                                    $selectActionId = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'sitebusinessvideo_video')
                                            ->where('object_id = ?', $sitebusinessvideo_id)
                                            ->where('type =?', 'post');
                                    $selectActionIds = $actionsTable->fetchAll($selectActionId);

                                    if ($selectActionIds) {
                                        foreach ($selectActionIds as $selectActionId) {
                                            $action = Engine_Api::_()->getItem('activity_action', $selectActionId['action_id']);

                                            $action->type = 'sitevideo_post';
                                            $action->object_id = $sitevideo->getIdentity();
                                            $action->object_type = $sitevideo->getType();
                                            $action->save();
                                            $actionsTable->resetActivityBindings($action);
                                        }
                                    }
                                    //END FETCH ACTIONS
                                    //START FETCH ACTIONS
                                    $selectActionId = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'sitebusinessvideo_video')
                                            ->where('object_id = ?', $sitebusinessvideo_id)
                                            ->where('type =?', 'sitetagcheckin_post');
                                    $selectActionIds = $actionsTable->fetchAll($selectActionId);
                                    if ($selectActionIds) {
                                        foreach ($selectActionIds as $selectActionId) {
                                            $action = Engine_Api::_()->getItem('activity_action', $selectActionId['action_id']);
                                            $action->type = 'sitetagcheckin_post';
                                            $action->object_id = $sitevideo->getIdentity();
                                            $action->object_type = $sitevideo->getType();
                                            $action->save();
                                            $actionsTable->resetActivityBindings($action);
                                        }
                                    }
                                    //END FETCH ACTIONS
                                    //START FETCH ACTIONS
                                    $selectActionId = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'sitebusinessvideo_video')
                                            ->where('object_id = ?', $sitebusinessvideo_id)
                                            ->where('type =?', 'like_sitebusinessvideo_video');
                                    $selectActionIds = $actionsTable->fetchAll($selectActionId);
                                    if ($selectActionIds) {
                                        foreach ($selectActionIds as $selectActionId) {
                                            $action = Engine_Api::_()->getItem('activity_action', $selectActionId['action_id']);
                                            $action->type = 'like_sitebusinessvideo_video';
                                            $action->object_id = $sitevideo->getIdentity();
                                            $action->object_type = $sitevideo->getType();
                                            $action->save();
                                            $actionsTable->resetActivityBindings($action);
                                        }
                                    }
                                    //END FETCH ACTIONS
                                    //UPDATE VIDEO TYPE 
                                    $attachmentsTable->update(array('type' => $sitevideo->getType(), 'id' => $sitevideo->getIdentity()), array('type = ?' => 'sitebusinessvideo_video', 'id =?' => $sitebusinessvideo_id));
                                }

                                //STORAGE FILE WORK
                                if ($sitebusinessvideo->photo_id) {
                                    $storageData = $storageTable->fetchRow(array('file_id = ?' => $sitebusinessvideo->photo_id));
                                    if (!empty($storageData) && !empty($storageData->storage_path)) {
                                        // Get file
                                        $file = Engine_Api::_()->getItem('storage_file', $sitebusinessvideo->photo_id);

                                        // Pull video to a temporary file
                                        $tmpFile = $file->temporary();

                                        // Set the video
                                        $db = $sitevideo->getTable()->getAdapter();
                                        $db->beginTransaction();
                                        $params = array();
                                        $params['setPhotoId'] = true;
                                        try {
                                            $sitevideo->setVideo($tmpFile, $params);
                                            @unlink($tmpFile);
                                            $db->commit();
                                        } catch (Exception $e) {
                                            @unlink($tmpFile);
                                            $db->rollBack();
                                            throw $e;
                                        }
                                    }
                                }

                                if ($sitebusinessvideo->file_id) {
                                    //STORAGE FILE WORK
                                    $storageData = $storageTable->fetchRow(array('file_id = ?' => $sitebusinessvideo->file_id));
                                    if (!empty($storageData) && !empty($storageData->storage_path)) {
                                        $storage = Engine_Api::_()->getItemTable('storage_file');
                                        $storageObject = $storage->createFile($storageData->storage_path, array(
                                            'parent_id' => $sitevideo->getIdentity(),
                                            'parent_type' => $sitevideo->getType(),
                                            'user_id' => $sitevideo->getOwner()->getIdentity(),
                                        ));
                                        $sitevideo->file_id = $storageObject->file_id;
                                        $sitevideo->save();
                                    }
                                }

                                //CREATE LOG ENTRY IN LOG FILE
                                if (file_exists(APPLICATION_PATH . '/temporary/log/VideoToSitevideoImport.log')) {
                                    $myFile = APPLICATION_PATH . '/temporary/log/VideoToSitevideoImport.log';
                                    $error = Zend_Registry::get('Zend_Translate')->_("can't open file");
                                    $fh = fopen($myFile, 'a') or die($error);
                                    $current_time = date('D, d M Y H:i:s T');
                                    $sitevideo_title = $sitevideo->title;
                                    $stringData = $this->view->translate('Video with ID ') . $sitebusinessvideo_id . $this->view->translate(' is successfully imported into a Advanced Video with ID ') . $sitevideo->video_id . $this->view->translate(' at ') . $current_time . $this->view->translate(". Title of that Video is '") . $sitevideo_title . "'.\n\n";
                                    fwrite($fh, $stringData);
                                    fclose($fh);
                                }

                                $coreModuleTable->update(array('enabled' => 0), array('name = ?' => 'sitebusinessvideo'));
                                Engine_Api::_()->getDbtable('content', 'core')->delete(array('name =?' => 'sitebusinessvideo.profile-sitebusinessvideos'));
                                Engine_Api::_()->getDbtable('content', 'core')->delete(array('name =?' => 'sitebusinessvideo.profile-videos'));
                                Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->delete(array('name =?' => 'sitebusinessvideo.profile-sitebusinessvideos'));
                                Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->delete(array('name =?' => 'sitebusinessvideo.profile-videos'));
                                Engine_Api::_()->getDbtable('content', 'sitebusiness')->delete(array('name =?' => 'sitebusinessvideo.profile-sitebusinessvideos'));
                                Engine_Api::_()->getDbtable('content', 'sitebusiness')->delete(array('name =?' => 'sitebusinessvideo.profile-videos'));
                                $db->commit();
                                $this->view->sitebusinessvideo_assigned_previous_id = $sitebusinessvideo_id;
                            } catch (Exception $e) {
                                $db->rollback();
                                throw($e);
                            }
                            if ($next_import_count >= 100) {
                                $this->_redirect("admin/sitevideointegration/importvideo/index?start_import=1&module=sitebusinessvideo&recall=1&activity_sitebusinessvideo=$activity_sitebusinessvideo");
                            }
                        }
                    } else {
                        if ($_GET['recall']) {
                            echo json_encode(array('success' => 1));
                            exit();
                        }
                    }
                } catch (Exception $e) {
                    throw($e);
                }
            }
        }

        $this->view->first_sitegroupvideo_id = $first_sitegroupvideo_id = 0;
        $this->view->last_sitegroupvideo_id = $last_sitegroupvideo_id = 0;

        $this->view->sitegroupvideoEnabled = $sitegroupvideoEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitegroupvideo');

        if ($sitegroupvideoEnabled && (Engine_Api::_()->getDbtable('modules', 'sitevideo')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'sitegroup_group', 'item_module' => 'sitegroup')))) {

            //GET VIDEO TABLES 
            $sitegroupvideoTable = Engine_Api::_()->getDbTable('videos', 'sitegroupvideo');
            $sitegroupvideoTableName = $sitegroupvideoTable->info('name');

            $sitegroupvideoratingsTable = Engine_Api::_()->getDbTable('ratings', 'sitegroupvideo');
            $sitegroupvideoratingsTableName = $sitegroupvideoratingsTable->info('name');
            //ADD NEW COLUMN IN VIDEO TABLE
            $db = Engine_Db_Table::getDefaultAdapter();
            $is_sitegroupvideo_import = $db->query("SHOW COLUMNS FROM engine4_sitegroupvideo_videos LIKE 'is_sitegroupvideo_import'")->fetch();
            if (empty($is_sitegroupvideo_import)) {
                $run_query = $db->query("ALTER TABLE `engine4_sitegroupvideo_videos` ADD is_sitegroupvideo_import TINYINT( 2 ) NOT NULL DEFAULT '0'");
            }

            //START IF IMPORTING IS BREAKED BY SOME REASON
            $selectVideos = $sitegroupvideoTable->select()
                    ->from($sitegroupvideoTableName, 'video_id')
                    ->where('is_sitegroupvideo_import != ?', 1)
                    ->order('video_id ASC');
            $sitegroupvideoDatas = $sitegroupvideoTable->fetchAll($selectVideos);

            if (!empty($sitegroupvideoDatas)) {

                $flag_first_sitegroupvideo_id = 1;

                foreach ($sitegroupvideoDatas as $sitegroupvideoData) {

                    if ($flag_first_sitegroupvideo_id == 1) {
                        $this->view->first_sitegroupvideo_id = $first_sitegroupvideo_id = $sitegroupvideoData->video_id;
                    }
                    $flag_first_sitegroupvideo_id++;

                    $this->view->last_sitegroupvideo_id = $last_sitegroupvideo_id = $sitegroupvideoData->video_id;
                }

                if (isset($_GET['sitegroupvideo_assigned_previous_id'])) {
                    $this->view->sitegroupvideo_assigned_previous_id = $sitegroupvideo_assigned_previous_id = $_GET['sitegroupvideo_assigned_previous_id'];
                } else {
                    $this->view->sitegroupvideo_assigned_previous_id = $sitegroupvideo_assigned_previous_id = $first_sitegroupvideo_id;
                }
            }
            //START IMPORTING IF REQUESTED
            if (isset($_GET['start_import']) && $_GET['start_import'] == 1 && $_GET['module'] == 'sitegroupvideo') {

                try {
                    //ACTIVITY FEED IMPORT
                    $activity_sitegroupvideo = $this->_getParam('activity_sitegroupvideo');

                    //START VIDEO IMPORTING
                    $selectVideos = $sitegroupvideoTable->select()
                            ->where('video_id >= ?', $sitegroupvideo_assigned_previous_id)
                            ->from($sitegroupvideoTableName, 'video_id')
                            ->where('is_sitegroupvideo_import != ?', 1)
                            ->order('video_id ASC');
                    $sitegroupvideoDatas = $sitegroupvideoTable->fetchAll($selectVideos);

                    $next_import_count = 0;
                    $sitegroupvideoDatasArray = $sitegroupvideoDatas->toArray();
                    if ($sitegroupvideoDatasArray) {
                        foreach ($sitegroupvideoDatas as $sitegroupvideoData) {
                            $db = Engine_Db_Table::getDefaultAdapter();
                            $db->beginTransaction();
                            try {
                                $sitegroupvideo_id = $sitegroupvideoData->video_id;
                                if (!empty($sitegroupvideo_id)) {
                                    $sitegroupvideo = Engine_Api::_()->getItem('sitegroupvideo_video', $sitegroupvideo_id);
                                    $sitevideo = $sitevideoTable->createRow();
                                    $sitevideo->title = $sitegroupvideo->title;
                                    $sitevideo->description = $sitegroupvideo->description;
                                    $sitevideo->owner_id = $sitegroupvideo->owner_id;
                                    $sitevideo->parent_type = 'sitegroup_group';
                                    $sitevideo->parent_id = $sitegroupvideo->group_id;
                                    $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $sitegroupvideo->group_id);
                                    // $sitevideo->category_id = 1;

                                    $sitevideo->creation_date = $sitegroupvideo->creation_date;
                                    $sitevideo->modified_date = $sitegroupvideo->modified_date;
                                    $sitevideo->save();
                                    $sitevideo->creation_date = $sitegroupvideo->creation_date;
                                    $sitevideo->modified_date = $sitegroupvideo->modified_date;
                                    $sitevideo->view_count = 1;
                                    if ($sitegroupvideo->view_count > 0) {
                                        $sitevideo->view_count = $sitegroupvideo->view_count;
                                    }
                                    $sitevideo->search = $sitegroupvideo->search;

                                    if (isset($sitegroupvideo->location))
                                        $sitevideo->location = $sitegroupvideo->location;

                                    if (isset($sitegroupvideo->seao_locationid))
                                        $sitevideo->seao_locationid = $sitegroupvideo->seao_locationid;
                                    $sitevideo->featured = $sitegroupvideo->featured;

                                    $sitevideo->type = $sitegroupvideo->type;
                                    $sitevideo->code = $sitegroupvideo->code;
                                    $sitevideo->photo_id = $sitegroupvideo->photo_id;
                                    $sitevideo->rating = $sitegroupvideo->rating;
                                    $sitevideo->status = $sitegroupvideo->status;
                                    $sitevideo->file_id = $sitegroupvideo->file_id;
                                    $sitevideo->duration = $sitegroupvideo->duration;

                                    $sitevideo->save();
                                    $sitegroupvideo->is_sitegroupvideo_import = 1;

                                    $sitegroupvideo->save();
                                    
                                    $row = $sitevideoOtherinfoTable->getOtherinfo($sitevideo->getIdentity());
                                    if (empty($row)) {
                                        $sitevideoOtherinfoTable->insert(array(
                                            'video_id' => $sitevideo->getIdentity(),
                                                // 'host_params' => json_encode($hostInfo),
                                        )); //COMMIT
                                    }
                                    
                                    $next_import_count++;
                                    //END GET DATA FROM VIDEO

                                    $values = array();

                                    //START FETCH PRIVACY
                                    $auth = Engine_Api::_()->authorization()->context;

                                    //START VIEW PRIVACY
                                    $auth = Engine_Api::_()->authorization()->context;
                                    $values = array();

                                    //START VIEW PRIVACY
                                    $rolesVideos = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    foreach ($rolesVideos as $rolesVideo) {

                                        if ($auth->isAllowed($sitegroup, $rolesVideo, 'view')) {
                                            $values['auth_view'] = $rolesVideo;
                                            break;
                                        }
                                    }
                                    $rolesSitevideos = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    $viewMax = array_search($values['auth_view'], $rolesSitevideos);

                                    foreach ($rolesSitevideos as $i => $rolesSitevideo) {
                                        $auth->setAllowed($sitevideo, $rolesSitevideo, 'view', ($i >= $viewMax));
                                    }
                                    //END VIEW PRIVACY
                                    // //START VIEW PRIVACY
                                    $rolesVideos = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    foreach ($rolesVideos as $rolesVideo) {

                                        if ($auth->isAllowed($sitegroup, $rolesVideo, 'comment')) {
                                            $values['auth_comment'] = $rolesVideo;
                                            break;
                                        }
                                    }
                                    $rolesSitevideos = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    $commentMax = array_search($values['auth_comment'], $rolesSitevideos);

                                    foreach ($rolesSitevideos as $i => $rolesSitevideo) {
                                        $auth->setAllowed($sitevideo, $rolesSitevideo, 'comment', ($i >= $commentMax));
                                    }
                                    //END VIEW PRIVACY
                                    //START FETCH COMMENTS
                                    $selectComment = $commentTable->select()
                                            ->from($commentTableName, 'comment_id')
                                            ->where('resource_type = ?', 'sitegroupvideo_video')
                                            ->where('resource_id = ?', $sitegroupvideo_id);
                                    $selectCommentDatas = $commentTable->fetchAll($selectComment);
                                    foreach ($selectCommentDatas as $selectCommentData) {
                                        $comment = Engine_Api::_()->getItem('core_comment', $selectCommentData->comment_id);
                                        $newCommentEntry = $commentTable->createRow();
                                        $newCommentEntry->resource_type = 'video';
                                        $newCommentEntry->resource_id = $sitevideo->getIdentity();
                                        $newCommentEntry->poster_type = 'user';
                                        $newCommentEntry->poster_id = $comment->poster_id;
                                        $newCommentEntry->creation_date = $comment->creation_date;
                                        $newCommentEntry->like_count = $comment->like_count;
                                        $newCommentEntry->save();

                                        $newCommentEntry->creation_date = $comment->creation_date;
                                        $comment_id = $newCommentEntry->save();

                                        //START FETCH LIKES
                                        $selectLike = $likeTable->select()
                                                ->from($likeTableName, 'like_id')
                                                ->where('resource_type = ?', 'core_comment')
                                                ->where('resource_id = ?', $selectCommentData->comment_id);
                                        $selectLikeDatas = $likeTable->fetchAll($selectLike);
                                        foreach ($selectLikeDatas as $selectLikeData) {
                                            $like = Engine_Api::_()->getItem('core_like', $selectLikeData->like_id);
                                            $newLikeEntry = $likeTable->createRow();
                                            $newLikeEntry->resource_type = 'core_comment';
                                            $newLikeEntry->resource_id = $comment_id;
                                            $newLikeEntry->poster_type = 'user';
                                            $newLikeEntry->poster_id = $like->poster_id;
                                            $newLikeEntry->creation_date = $like->creation_date;

                                            $newLikeEntry->save();
                                            $newLikeEntry->creation_date = $like->creation_date;
                                            $newLikeEntry->save();
                                        }
                                        //END FETCH LIKES
                                    }
                                    //END FETCH COMMENTS
                                    //START UPDATE TOTAL COMMENTS IN SITEVIDEO TABLE
                                    $selectCommentCount = $commentTable->select()
                                            ->from($commentTableName, array('COUNT(*) AS like_count'))
                                            ->where('resource_type = ?', 'sitegroupvideo_video')
                                            ->where('resource_id = ?', $sitegroupvideo_id);
                                    $selectCommentCounts = $commentTable->fetchAll($selectCommentCount);
                                    if (!empty($selectCommentCounts)) {
                                        $selectCommentCounts = $selectCommentCounts->toArray();
                                        $sitevideo->comment_count = $selectCommentCounts[0]['like_count'];
                                        $sitevideo->save();
                                    }
                                    //END UPDATE TOTAL COMMENTS IN SITEVIDEO TABLE
                                    //START FETCH LIKES
                                    $selectLike = $likeTable->select()
                                            ->from($likeTableName, 'like_id')
                                            ->where('resource_type = ?', 'sitegroupvideo_video')
                                            ->where('resource_id = ?', $sitegroupvideo_id);
                                    $selectLikeDatas = $likeTable->fetchAll($selectLike);
                                    foreach ($selectLikeDatas as $selectLikeData) {
                                        $like = Engine_Api::_()->getItem('core_like', $selectLikeData->like_id);
                                        $newLikeEntry = $likeTable->createRow();
                                        $newLikeEntry->resource_type = 'video';
                                        $newLikeEntry->resource_id = $sitevideo->getIdentity();
                                        $newLikeEntry->poster_type = 'user';
                                        $newLikeEntry->poster_id = $like->poster_id;
                                        $newLikeEntry->creation_date = $like->creation_date;
                                        $newLikeEntry->save();
                                        $newLikeEntry->creation_date = $like->creation_date;
                                        $newLikeEntry->save();
                                    }
                                    //END FETCH LIKES
                                    //START UPDATE TOTAL LIKES IN SITEVIDEO TABLE
                                    $selectLikeCount = $likeTable->select()
                                            ->from($likeTableName, array('COUNT(*) AS like_count'))
                                            ->where('resource_type = ?', 'sitegroupvideo_video')
                                            ->where('resource_id = ?', $sitegroupvideo_id);
                                    $selectLikeCounts = $likeTable->fetchAll($selectLikeCount);
                                    if (!empty($selectLikeCounts)) {
                                        $selectLikeCounts = $selectLikeCounts->toArray();
                                        $sitevideo->like_count = $selectLikeCounts[0]['like_count'];
                                        $sitevideo->save();
                                    }
                                    //END UPDATE TOTAL LIKES IN SITEVIDEO TABLES
                                    //RATING WORK
                                    //START FETCH RATINGS
                                    $selectSitegroupvideoRating = $sitegroupvideoratingsTable->select()
                                            ->from($sitegroupvideoratingsTableName, '*')
                                            ->where('video_id = ?', $sitegroupvideo_id);
                                    $selectSitegroupvideoRatingDatas = $sitegroupvideoratingsTable->fetchAll($selectSitegroupvideoRating);
                                    $selectSitegroupvideoRatingDatas = $selectSitegroupvideoRatingDatas->toArray();
                                    foreach ($selectSitegroupvideoRatingDatas as $selectSitegroupvideoRatingData) {
                                        $sitevideoratingsTable->insert(array(
                                            'resource_type' => 'video',
                                            'resource_id' => $sitevideo->getIdentity(),
                                            'user_id' => $selectSitegroupvideoRatingData['user_id'],
                                            'rating' => $selectSitegroupvideoRatingData['rating'],
                                        ));
                                    }
                                }

                                //GENERATE ACITIVITY FEED
                                if ($activity_sitegroupvideo) {
                                    //START FETCH ACTIONS
                                    $selectActionIds = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'sitegroup_group')
                                            ->where('object_id = ?', $sitegroup->getIdentity())
                                            ->where('type =?', 'sitegroupvideo_admin_new')
                                            ->orWhere('type =?', 'sitegroupvideo_new')
                                            ->query()
                                            ->fetchAll();
                                    foreach ($selectActionIds as $selectActionId) {
                                        $action = Engine_Api::_()->getItem('activity_action', $selectActionId);
                                        $action->type = 'sitevideo_video_new';
                                        $action->object_id = $sitevideo->getIdentity();
                                        $action->object_type = $sitevideo->getType();
                                        $action->save();
                                        $actionsTable->resetActivityBindings($action);
                                    }
                                    //END FETCH ACTIONS
                                    //START FETCH ACTIONS
                                    $selectActionId = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'sitegroupvideo_video')
                                            ->where('object_id = ?', $sitegroupvideo_id)
                                            ->where('type =?', 'post');
                                    $selectActionIds = $actionsTable->fetchAll($selectActionId);

                                    if ($selectActionIds) {
                                        foreach ($selectActionIds as $selectActionId) {
                                            $action = Engine_Api::_()->getItem('activity_action', $selectActionId['action_id']);

                                            $action->type = 'sitevideo_post';
                                            $action->object_id = $sitevideo->getIdentity();
                                            $action->object_type = $sitevideo->getType();
                                            $action->save();
                                            $actionsTable->resetActivityBindings($action);
                                        }
                                    }
                                    //END FETCH ACTIONS
                                    //START FETCH ACTIONS
                                    $selectActionId = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'sitegroupvideo_video')
                                            ->where('object_id = ?', $sitegroupvideo_id)
                                            ->where('type =?', 'sitetagcheckin_post');
                                    $selectActionIds = $actionsTable->fetchAll($selectActionId);
                                    if ($selectActionIds) {
                                        foreach ($selectActionIds as $selectActionId) {
                                            $action = Engine_Api::_()->getItem('activity_action', $selectActionId['action_id']);
                                            $action->type = 'sitetagcheckin_post';
                                            $action->object_id = $sitevideo->getIdentity();
                                            $action->object_type = $sitevideo->getType();
                                            $action->save();
                                            $actionsTable->resetActivityBindings($action);
                                        }
                                    }
                                    //END FETCH ACTIONS
                                    //START FETCH ACTIONS
                                    $selectActionId = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'sitegroupvideo_video')
                                            ->where('object_id = ?', $sitegroupvideo_id)
                                            ->where('type =?', 'like_sitegroupvideo_video');
                                    $selectActionIds = $actionsTable->fetchAll($selectActionId);
                                    if ($selectActionIds) {
                                        foreach ($selectActionIds as $selectActionId) {
                                            $action = Engine_Api::_()->getItem('activity_action', $selectActionId['action_id']);
                                            $action->type = 'like_sitegroupvideo_video';
                                            $action->object_id = $sitevideo->getIdentity();
                                            $action->object_type = $sitevideo->getType();
                                            $action->save();
                                            $actionsTable->resetActivityBindings($action);
                                        }
                                    }
                                    //END FETCH ACTIONS
                                    //UPDATE VIDEO TYPE 
                                    $attachmentsTable->update(array('type' => $sitevideo->getType(), 'id' => $sitevideo->getIdentity()), array('type = ?' => 'sitegroupvideo_video', 'id =?' => $sitegroupvideo_id));
                                }
                                if ($sitegroupvideo->photo_id) {
                                    //STORAGE FILE WORK
                                    $storageData = $storageTable->fetchRow(array('file_id = ?' => $sitegroupvideo->photo_id));
                                    if (!empty($storageData) && !empty($storageData->storage_path)) {
                                        // Get file
                                        $file = Engine_Api::_()->getItem('storage_file', $sitegroupvideo->photo_id);

                                        // Pull video to a temporary file
                                        $tmpFile = $file->temporary();

                                        // Set the video
                                        $db = $sitevideo->getTable()->getAdapter();
                                        $db->beginTransaction();
                                        $params = array();
                                        $params['setPhotoId'] = true;
                                        try {
                                            $sitevideo->setVideo($tmpFile, $params);
                                            @unlink($tmpFile);
                                            $db->commit();
                                        } catch (Exception $e) {
                                            @unlink($tmpFile);
                                            $db->rollBack();
                                            throw $e;
                                        }
                                    }
                                }
                                if ($sitegroupvideo->file_id) {
                                    //STORAGE FILE WORK
                                    $storageData = $storageTable->fetchRow(array('file_id = ?' => $sitegroupvideo->file_id));
                                    if (!empty($storageData) && !empty($storageData->storage_path)) {
                                        $storage = Engine_Api::_()->getItemTable('storage_file');
                                        $storageObject = $storage->createFile($storageData->storage_path, array(
                                            'parent_id' => $sitevideo->getIdentity(),
                                            'parent_type' => $sitevideo->getType(),
                                            'user_id' => $sitevideo->getOwner()->getIdentity(),
                                        ));
                                        $sitevideo->file_id = $storageObject->file_id;
                                        $sitevideo->save();
                                    }
                                }

                                //CREATE LOG ENTRY IN LOG FILE
                                if (file_exists(APPLICATION_PATH . '/temporary/log/VideoToSitevideoImport.log')) {
                                    $myFile = APPLICATION_PATH . '/temporary/log/VideoToSitevideoImport.log';
                                    $error = Zend_Registry::get('Zend_Translate')->_("can't open file");
                                    $fh = fopen($myFile, 'a') or die($error);
                                    $current_time = date('D, d M Y H:i:s T');
                                    $sitevideo_title = $sitevideo->title;
                                    $stringData = $this->view->translate('Video with ID ') . $sitegroupvideo_id . $this->view->translate(' is successfully imported into a Advanced Video with ID ') . $sitevideo->video_id . $this->view->translate(' at ') . $current_time . $this->view->translate(". Title of that Video is '") . $sitevideo_title . "'.\n\n";
                                    fwrite($fh, $stringData);
                                    fclose($fh);
                                }

                                $coreModuleTable->update(array('enabled' => 0), array('name = ?' => 'sitegroupvideo'));
                                Engine_Api::_()->getDbtable('content', 'core')->delete(array('name =?' => 'sitegroupvideo.profile-sitegroupvideos'));
                                Engine_Api::_()->getDbtable('content', 'core')->delete(array('name =?' => 'sitegroupvideo.profile-videos'));
                                Engine_Api::_()->getDbtable('admincontent', 'sitegroup')->delete(array('name =?' => 'sitegroupvideo.profile-sitegroupvideos'));
                                Engine_Api::_()->getDbtable('admincontent', 'sitegroup')->delete(array('name =?' => 'sitegroupvideo.profile-videos'));
                                Engine_Api::_()->getDbtable('content', 'sitegroup')->delete(array('name =?' => 'sitegroupvideo.profile-sitegroupvideos'));
                                Engine_Api::_()->getDbtable('content', 'sitegroup')->delete(array('name =?' => 'sitegroupvideo.profile-videos'));
                                $db->commit();
                                $this->view->sitegroupvideo_assigned_previous_id = $sitegroupvideo_id;
                            } catch (Exception $e) {
                                $db->rollback();
                                throw($e);
                            }
                            if ($next_import_count >= 100) {
                                $this->_redirect("admin/sitevideointegration/importvideo/index?start_import=1&module=sitegroupvideo&recall=1&activity_sitegroupvideo=$activity_sitegroupvideo");
                            }
                        }
                    } else {
                        if ($_GET['recall']) {
                            echo json_encode(array('success' => 1));
                            exit();
                        }
                    }
                } catch (Exception $e) {
                    throw($e);
                }
            }
        }

        $this->view->first_sitestorevideo_id = $first_sitestorevideo_id = 0;
        $this->view->last_sitestorevideo_id = $last_sitestorevideo_id = 0;

        $this->view->sitestorevideoEnabled = $sitestorevideoEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitestorevideo');

        if ($sitestorevideoEnabled && (Engine_Api::_()->getDbtable('modules', 'sitevideo')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'sitestore_store', 'item_module' => 'sitestore')))) {

            //GET VIDEO TABLES 
            $sitestorevideoTable = Engine_Api::_()->getDbTable('videos', 'sitestorevideo');
            $sitestorevideoTableName = $sitestorevideoTable->info('name');

            $sitestorevideoratingsTable = Engine_Api::_()->getDbTable('ratings', 'sitestorevideo');
            $sitestorevideoratingsTableName = $sitestorevideoratingsTable->info('name');
            //ADD NEW COLUMN IN VIDEO TABLE
            $db = Engine_Db_Table::getDefaultAdapter();
            $is_sitestorevideo_import = $db->query("SHOW COLUMNS FROM engine4_sitestorevideo_videos LIKE 'is_sitestorevideo_import'")->fetch();
            if (empty($is_sitestorevideo_import)) {
                $run_query = $db->query("ALTER TABLE `engine4_sitestorevideo_videos` ADD is_sitestorevideo_import TINYINT( 2 ) NOT NULL DEFAULT '0'");
            }

            //START IF IMPORTING IS BREAKED BY SOME REASON
            $selectVideos = $sitestorevideoTable->select()
                    ->from($sitestorevideoTableName, 'video_id')
                    ->where('is_sitestorevideo_import != ?', 1)
                    ->order('video_id ASC');
            $sitestorevideoDatas = $sitestorevideoTable->fetchAll($selectVideos);

            if (!empty($sitestorevideoDatas)) {

                $flag_first_sitestorevideo_id = 1;

                foreach ($sitestorevideoDatas as $sitestorevideoData) {

                    if ($flag_first_sitestorevideo_id == 1) {
                        $this->view->first_sitestorevideo_id = $first_sitestorevideo_id = $sitestorevideoData->video_id;
                    }
                    $flag_first_sitestorevideo_id++;

                    $this->view->last_sitestorevideo_id = $last_sitestorevideo_id = $sitestorevideoData->video_id;
                }

                if (isset($_GET['sitestorevideo_assigned_previous_id'])) {
                    $this->view->sitestorevideo_assigned_previous_id = $sitestorevideo_assigned_previous_id = $_GET['sitestorevideo_assigned_previous_id'];
                } else {
                    $this->view->sitestorevideo_assigned_previous_id = $sitestorevideo_assigned_previous_id = $first_sitestorevideo_id;
                }
            }
            //START IMPORTING IF REQUESTED
            if (isset($_GET['start_import']) && $_GET['start_import'] == 1 && $_GET['module'] == 'sitestorevideo') {

                try {
                    //ACTIVITY FEED IMPORT
                    $activity_sitestorevideo = $this->_getParam('activity_sitestorevideo');

                    //START VIDEO IMPORTING
                    $selectVideos = $sitestorevideoTable->select()
                            ->where('video_id >= ?', $sitestorevideo_assigned_previous_id)
                            ->from($sitestorevideoTableName, 'video_id')
                            ->where('is_sitestorevideo_import != ?', 1)
                            ->order('video_id ASC');
                    $sitestorevideoDatas = $sitestorevideoTable->fetchAll($selectVideos);

                    $next_import_count = 0;
                    $sitestorevideoDatasArray = $sitestorevideoDatas->toArray();
                    if ($sitestorevideoDatasArray) {
                        foreach ($sitestorevideoDatas as $sitestorevideoData) {
                            $db = Engine_Db_Table::getDefaultAdapter();
                            $db->beginTransaction();
                            try {
                                $sitestorevideo_id = $sitestorevideoData->video_id;
                                if (!empty($sitestorevideo_id)) {
                                    $sitestorevideo = Engine_Api::_()->getItem('sitestorevideo_video', $sitestorevideo_id);
                                    $sitevideo = $sitevideoTable->createRow();
                                    $sitevideo->title = $sitestorevideo->title;
                                    $sitevideo->description = $sitestorevideo->description;
                                    $sitevideo->owner_id = $sitestorevideo->owner_id;
                                    $sitevideo->parent_type = 'sitestore_store';
                                    $sitevideo->parent_id = $sitestorevideo->store_id;
                                    $sitestore = Engine_Api::_()->getItem('sitestore_store', $sitestorevideo->store_id);
                                    // $sitevideo->category_id = 1;

                                    $sitevideo->creation_date = $sitestorevideo->creation_date;
                                    $sitevideo->modified_date = $sitestorevideo->modified_date;
                                    $sitevideo->save();
                                    $sitevideo->creation_date = $sitestorevideo->creation_date;
                                    $sitevideo->modified_date = $sitestorevideo->modified_date;
                                    $sitevideo->view_count = 1;
                                    if ($sitestorevideo->view_count > 0) {
                                        $sitevideo->view_count = $sitestorevideo->view_count;
                                    }
                                    $sitevideo->search = $sitestorevideo->search;

                                    if (isset($sitestorevideo->location))
                                        $sitevideo->location = $sitestorevideo->location;

                                    if (isset($sitestorevideo->seao_locationid))
                                        $sitevideo->seao_locationid = $sitestorevideo->seao_locationid;
                                    $sitevideo->featured = $sitestorevideo->featured;

                                    $sitevideo->type = $sitestorevideo->type;
                                    $sitevideo->code = $sitestorevideo->code;
                                    $sitevideo->photo_id = $sitestorevideo->photo_id;
                                    $sitevideo->rating = $sitestorevideo->rating;
                                    $sitevideo->status = $sitestorevideo->status;
                                    $sitevideo->file_id = $sitestorevideo->file_id;
                                    $sitevideo->duration = $sitestorevideo->duration;

                                    $sitevideo->save();
                                    $sitestorevideo->is_sitestorevideo_import = 1;

                                    $sitestorevideo->save();
                                    
                                    $row = $sitevideoOtherinfoTable->getOtherinfo($sitevideo->getIdentity());
                                    if (empty($row)) {
                                        $sitevideoOtherinfoTable->insert(array(
                                            'video_id' => $sitevideo->getIdentity(),
                                                // 'host_params' => json_encode($hostInfo),
                                        )); //COMMIT
                                    }
                                    
                                    $next_import_count++;
                                    //END GET DATA FROM VIDEO

                                    $values = array();

                                    //START FETCH PRIVACY
                                    $auth = Engine_Api::_()->authorization()->context;

                                    //START VIEW PRIVACY
                                    $auth = Engine_Api::_()->authorization()->context;
                                    $values = array();

                                    //START VIEW PRIVACY
                                    $rolesVideos = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    foreach ($rolesVideos as $rolesVideo) {

                                        if ($auth->isAllowed($sitestore, $rolesVideo, 'view')) {
                                            $values['auth_view'] = $rolesVideo;
                                            break;
                                        }
                                    }
                                    $rolesSitevideos = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    $viewMax = array_search($values['auth_view'], $rolesSitevideos);

                                    foreach ($rolesSitevideos as $i => $rolesSitevideo) {
                                        $auth->setAllowed($sitevideo, $rolesSitevideo, 'view', ($i >= $viewMax));
                                    }
                                    //END VIEW PRIVACY
                                    // //START VIEW PRIVACY
                                    $rolesVideos = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    foreach ($rolesVideos as $rolesVideo) {

                                        if ($auth->isAllowed($sitestore, $rolesVideo, 'comment')) {
                                            $values['auth_comment'] = $rolesVideo;
                                            break;
                                        }
                                    }
                                    $rolesSitevideos = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    $commentMax = array_search($values['auth_comment'], $rolesSitevideos);

                                    foreach ($rolesSitevideos as $i => $rolesSitevideo) {
                                        $auth->setAllowed($sitevideo, $rolesSitevideo, 'comment', ($i >= $commentMax));
                                    }
                                    //END VIEW PRIVACY
                                    //START FETCH COMMENTS
                                    $selectComment = $commentTable->select()
                                            ->from($commentTableName, 'comment_id')
                                            ->where('resource_type = ?', 'sitestorevideo_video')
                                            ->where('resource_id = ?', $sitestorevideo_id);
                                    $selectCommentDatas = $commentTable->fetchAll($selectComment);
                                    foreach ($selectCommentDatas as $selectCommentData) {
                                        $comment = Engine_Api::_()->getItem('core_comment', $selectCommentData->comment_id);
                                        $newCommentEntry = $commentTable->createRow();
                                        $newCommentEntry->resource_type = 'video';
                                        $newCommentEntry->resource_id = $sitevideo->getIdentity();
                                        $newCommentEntry->poster_type = 'user';
                                        $newCommentEntry->poster_id = $comment->poster_id;
                                        $newCommentEntry->creation_date = $comment->creation_date;
                                        $newCommentEntry->like_count = $comment->like_count;
                                        $newCommentEntry->save();

                                        $newCommentEntry->creation_date = $comment->creation_date;
                                        $comment_id = $newCommentEntry->save();

                                        //START FETCH LIKES
                                        $selectLike = $likeTable->select()
                                                ->from($likeTableName, 'like_id')
                                                ->where('resource_type = ?', 'core_comment')
                                                ->where('resource_id = ?', $selectCommentData->comment_id);
                                        $selectLikeDatas = $likeTable->fetchAll($selectLike);
                                        foreach ($selectLikeDatas as $selectLikeData) {
                                            $like = Engine_Api::_()->getItem('core_like', $selectLikeData->like_id);
                                            $newLikeEntry = $likeTable->createRow();
                                            $newLikeEntry->resource_type = 'core_comment';
                                            $newLikeEntry->resource_id = $comment_id;
                                            $newLikeEntry->poster_type = 'user';
                                            $newLikeEntry->poster_id = $like->poster_id;
                                            $newLikeEntry->creation_date = $like->creation_date;

                                            $newLikeEntry->save();
                                            $newLikeEntry->creation_date = $like->creation_date;
                                            $newLikeEntry->save();
                                        }
                                        //END FETCH LIKES
                                    }
                                    //END FETCH COMMENTS
                                    //START UPDATE TOTAL COMMENTS IN SITEVIDEO TABLE
                                    $selectCommentCount = $commentTable->select()
                                            ->from($commentTableName, array('COUNT(*) AS like_count'))
                                            ->where('resource_type = ?', 'sitestorevideo_video')
                                            ->where('resource_id = ?', $sitestorevideo_id);
                                    $selectCommentCounts = $commentTable->fetchAll($selectCommentCount);
                                    if (!empty($selectCommentCounts)) {
                                        $selectCommentCounts = $selectCommentCounts->toArray();
                                        $sitevideo->comment_count = $selectCommentCounts[0]['like_count'];
                                        $sitevideo->save();
                                    }
                                    //END UPDATE TOTAL COMMENTS IN SITEVIDEO TABLE
                                    //START FETCH LIKES
                                    $selectLike = $likeTable->select()
                                            ->from($likeTableName, 'like_id')
                                            ->where('resource_type = ?', 'sitestorevideo_video')
                                            ->where('resource_id = ?', $sitestorevideo_id);
                                    $selectLikeDatas = $likeTable->fetchAll($selectLike);
                                    foreach ($selectLikeDatas as $selectLikeData) {
                                        $like = Engine_Api::_()->getItem('core_like', $selectLikeData->like_id);
                                        $newLikeEntry = $likeTable->createRow();
                                        $newLikeEntry->resource_type = 'video';
                                        $newLikeEntry->resource_id = $sitevideo->getIdentity();
                                        $newLikeEntry->poster_type = 'user';
                                        $newLikeEntry->poster_id = $like->poster_id;
                                        $newLikeEntry->creation_date = $like->creation_date;
                                        $newLikeEntry->save();
                                        $newLikeEntry->creation_date = $like->creation_date;
                                        $newLikeEntry->save();
                                    }
                                    //END FETCH LIKES
                                    //START UPDATE TOTAL LIKES IN SITEVIDEO TABLE
                                    $selectLikeCount = $likeTable->select()
                                            ->from($likeTableName, array('COUNT(*) AS like_count'))
                                            ->where('resource_type = ?', 'sitestorevideo_video')
                                            ->where('resource_id = ?', $sitestorevideo_id);
                                    $selectLikeCounts = $likeTable->fetchAll($selectLikeCount);
                                    if (!empty($selectLikeCounts)) {
                                        $selectLikeCounts = $selectLikeCounts->toArray();
                                        $sitevideo->like_count = $selectLikeCounts[0]['like_count'];
                                        $sitevideo->save();
                                    }
                                    //END UPDATE TOTAL LIKES IN SITEVIDEO TABLES
                                    //RATING WORK
                                    //START FETCH RATINGS
                                    $selectSitestorevideoRating = $sitestorevideoratingsTable->select()
                                            ->from($sitestorevideoratingsTableName, '*')
                                            ->where('video_id = ?', $sitestorevideo_id);
                                    $selectSitestorevideoRatingDatas = $sitestorevideoratingsTable->fetchAll($selectSitestorevideoRating);
                                    $selectSitestorevideoRatingDatas = $selectSitestorevideoRatingDatas->toArray();
                                    foreach ($selectSitestorevideoRatingDatas as $selectSitestorevideoRatingData) {
                                        $sitevideoratingsTable->insert(array(
                                            'resource_type' => 'video',
                                            'resource_id' => $sitevideo->getIdentity(),
                                            'user_id' => $selectSitestorevideoRatingData['user_id'],
                                            'rating' => $selectSitestorevideoRatingData['rating'],
                                        ));
                                    }
                                }

                                //GENERATE ACITIVITY FEED
                                if ($activity_sitestorevideo) {
                                    //START FETCH ACTIONS
                                    $selectActionIds = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'sitestore_store')
                                            ->where('object_id = ?', $sitestore->getIdentity())
                                            ->where('type =?', 'sitestorevideo_admin_new')
                                            ->orWhere('type =?', 'sitestorevideo_new')
                                            ->query()
                                            ->fetchAll();
                                    foreach ($selectActionIds as $selectActionId) {
                                        $action = Engine_Api::_()->getItem('activity_action', $selectActionId);
                                        $action->type = 'sitevideo_video_new';
                                        $action->object_id = $sitevideo->getIdentity();
                                        $action->object_type = $sitevideo->getType();
                                        $action->save();
                                        $actionsTable->resetActivityBindings($action);
                                    }
                                    //END FETCH ACTIONS
                                    //START FETCH ACTIONS
                                    $selectActionId = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'sitestorevideo_video')
                                            ->where('object_id = ?', $sitestorevideo_id)
                                            ->where('type =?', 'post');
                                    $selectActionIds = $actionsTable->fetchAll($selectActionId);

                                    if ($selectActionIds) {
                                        foreach ($selectActionIds as $selectActionId) {
                                            $action = Engine_Api::_()->getItem('activity_action', $selectActionId['action_id']);

                                            $action->type = 'sitevideo_post';
                                            $action->object_id = $sitevideo->getIdentity();
                                            $action->object_type = $sitevideo->getType();
                                            $action->save();
                                            $actionsTable->resetActivityBindings($action);
                                        }
                                    }
                                    //END FETCH ACTIONS
                                    //START FETCH ACTIONS
                                    $selectActionId = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'sitestorevideo_video')
                                            ->where('object_id = ?', $sitestorevideo_id)
                                            ->where('type =?', 'sitetagcheckin_post');
                                    $selectActionIds = $actionsTable->fetchAll($selectActionId);
                                    if ($selectActionIds) {
                                        foreach ($selectActionIds as $selectActionId) {
                                            $action = Engine_Api::_()->getItem('activity_action', $selectActionId['action_id']);
                                            $action->type = 'sitetagcheckin_post';
                                            $action->object_id = $sitevideo->getIdentity();
                                            $action->object_type = $sitevideo->getType();
                                            $action->save();
                                            $actionsTable->resetActivityBindings($action);
                                        }
                                    }
                                    //END FETCH ACTIONS
                                    //START FETCH ACTIONS
                                    $selectActionId = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'sitestorevideo_video')
                                            ->where('object_id = ?', $sitestorevideo_id)
                                            ->where('type =?', 'like_sitestorevideo_video');
                                    $selectActionIds = $actionsTable->fetchAll($selectActionId);
                                    if ($selectActionIds) {
                                        foreach ($selectActionIds as $selectActionId) {
                                            $action = Engine_Api::_()->getItem('activity_action', $selectActionId['action_id']);
                                            $action->type = 'like_sitestorevideo_video';
                                            $action->object_id = $sitevideo->getIdentity();
                                            $action->object_type = $sitevideo->getType();
                                            $action->save();
                                            $actionsTable->resetActivityBindings($action);
                                        }
                                    }
                                    //END FETCH ACTIONS
                                    //UPDATE VIDEO TYPE 
                                    $attachmentsTable->update(array('type' => $sitevideo->getType(), 'id' => $sitevideo->getIdentity()), array('type = ?' => 'sitestorevideo_video', 'id =?' => $sitestorevideo_id));
                                }

                                //STORAGE FILE WORK
                                $storageData = $storageTable->fetchRow(array('file_id = ?' => $sitestorevideo->photo_id));
                                if ($sitegroupvideo->photo_id) {
                                    if (!empty($storageData) && !empty($storageData->storage_path)) {
                                        // Get file
                                        $file = Engine_Api::_()->getItem('storage_file', $sitestorevideo->photo_id);

                                        // Pull video to a temporary file
                                        $tmpFile = $file->temporary();

                                        // Set the video
                                        $db = $sitevideo->getTable()->getAdapter();
                                        $db->beginTransaction();
                                        $params = array();
                                        $params['setPhotoId'] = true;
                                        try {
                                            $sitevideo->setVideo($tmpFile, $params);
                                            @unlink($tmpFile);
                                            $db->commit();
                                        } catch (Exception $e) {
                                            @unlink($tmpFile);
                                            $db->rollBack();
                                            throw $e;
                                        }
                                    }
                                }
                                if ($sitegroupvideo->file_id) {
                                    //STORAGE FILE WORK
                                    $storageData = $storageTable->fetchRow(array('file_id = ?' => $sitestorevideo->file_id));
                                    if (!empty($storageData) && !empty($storageData->storage_path)) {
                                        $storage = Engine_Api::_()->getItemTable('storage_file');
                                        $storageObject = $storage->createFile($storageData->storage_path, array(
                                            'parent_id' => $sitevideo->getIdentity(),
                                            'parent_type' => $sitevideo->getType(),
                                            'user_id' => $sitevideo->getOwner()->getIdentity(),
                                        ));
                                        $sitevideo->file_id = $storageObject->file_id;
                                        $sitevideo->save();
                                    }
                                }
                                //CREATE LOG ENTRY IN LOG FILE
                                if (file_exists(APPLICATION_PATH . '/temporary/log/VideoToSitevideoImport.log')) {
                                    $myFile = APPLICATION_PATH . '/temporary/log/VideoToSitevideoImport.log';
                                    $error = Zend_Registry::get('Zend_Translate')->_("can't open file");
                                    $fh = fopen($myFile, 'a') or die($error);
                                    $current_time = date('D, d M Y H:i:s T');
                                    $sitevideo_title = $sitevideo->title;
                                    $stringData = $this->view->translate('Video with ID ') . $sitestorevideo_id . $this->view->translate(' is successfully imported into a Advanced Video with ID ') . $sitevideo->video_id . $this->view->translate(' at ') . $current_time . $this->view->translate(". Title of that Video is '") . $sitevideo_title . "'.\n\n";
                                    fwrite($fh, $stringData);
                                    fclose($fh);
                                }

                                $coreModuleTable->update(array('enabled' => 0), array('name = ?' => 'sitestorevideo'));
                                Engine_Api::_()->getDbtable('content', 'core')->delete(array('name =?' => 'sitestorevideo.profile-sitestorevideos'));
                                Engine_Api::_()->getDbtable('content', 'core')->delete(array('name =?' => 'sitestorevideo.profile-videos'));
                                Engine_Api::_()->getDbtable('admincontent', 'sitestore')->delete(array('name =?' => 'sitestorevideo.profile-sitestorevideos'));
                                Engine_Api::_()->getDbtable('admincontent', 'sitestore')->delete(array('name =?' => 'sitestorevideo.profile-videos'));
                                Engine_Api::_()->getDbtable('content', 'sitestore')->delete(array('name =?' => 'sitestorevideo.profile-sitestorevideos'));
                                Engine_Api::_()->getDbtable('content', 'sitestore')->delete(array('name =?' => 'sitestorevideo.profile-videos'));
                                $db->commit();
                                $this->view->sitestorevideo_assigned_previous_id = $sitestorevideo_id;
                            } catch (Exception $e) {
                                $db->rollback();
                                throw($e);
                            }
                            if ($next_import_count >= 100) {
                                $this->_redirect("admin/sitevideointegration/importvideo/index?start_import=1&module=sitestorevideo&recall=1&activity_sitestorevideo=$activity_sitestorevideo");
                            }
                        }
                    } else {
                        if ($_GET['recall']) {
                            echo json_encode(array('success' => 1));
                            exit();
                        }
                    }
                } catch (Exception $e) {
                    throw($e);
                }
            }
        }

        $this->view->first_sitereview_id = $first_sitereview_id = 0;
        $this->view->last_sitereview_id = $last_sitereview_id = 0;

        $this->view->sitereviewEnabled = $sitereviewEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitereview');
        $this->view->listingtype_id = $listingtype_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('listingtype_id');
        if ($listingtype_id && $sitereviewEnabled && (Engine_Api::_()->getDbtable('modules', 'sitevideo')->getIntegratedModules(array('enabled' => 1, 'item_type' => "sitereview_listing_$listingtype_id", 'item_module' => 'sitereview')))) {

            $sitereviewclasfvideosTable = Engine_Api::_()->getDbTable('clasfvideos', 'sitereview');
            $sitereviewclasfvideosTableName = $sitereviewclasfvideosTable->info('name');
            //GET VIDEO TABLES 
            $sitereviewlistingsTable = Engine_Api::_()->getDbTable('listings', 'sitereview');
            $sitereviewlistingsTableName = $sitereviewlistingsTable->info('name');
            $selectVideoListings = $sitereviewclasfvideosTable->select()->setIntegrityCheck(false)
                    ->from($sitereviewclasfvideosTableName, array('video_id', 'listing_id'))
                    ->join($sitereviewlistingsTableName, $sitereviewclasfvideosTableName . ".listing_id=" . $sitereviewlistingsTableName . ".listing_id", null)
                    ->where("$sitereviewclasfvideosTableName.is_import =?", 0)
                    ->where("$sitereviewlistingsTableName.listingtype_id =?", $listingtype_id)
                    ->query()
                    ->fetchAll()
            ;
            $sitevideoTable = Engine_Api::_()->getDbTable('videos', 'sitevideo');
            foreach ($selectVideoListings as $results) {
                $sitevideoTable->update(array('parent_type' => 'sitereview_listing_' . $listingtype_id, 'parent_id' => $results['listing_id']), array('video_id = ?' => $results['video_id']));
            }

            //GET VIDEO TABLES 
            $sitereviewTable = Engine_Api::_()->getDbTable('videos', 'sitereview');
            $sitereviewTableName = $sitereviewTable->info('name');

            $sitereviewratingsTable = Engine_Api::_()->getDbTable('videoratings', 'sitereview');
            $sitereviewratingsTableName = $sitereviewratingsTable->info('name');
            //ADD NEW COLUMN IN VIDEO TABLE
            $db = Engine_Db_Table::getDefaultAdapter();
            $is_sitereview_import = $db->query("SHOW COLUMNS FROM engine4_sitereview_videos LIKE 'is_sitereview_import'")->fetch();
            if (empty($is_sitereview_import)) {
                $run_query = $db->query("ALTER TABLE `engine4_sitereview_videos` ADD is_sitereview_import TINYINT( 2 ) NOT NULL DEFAULT '0'");
            }

            //START IF IMPORTING IS BREAKED BY SOME REASON
//            $selectVideos = $sitereviewTable->select()
//                    ->from($sitereviewTableName, 'video_id')
//                    ->where('is_sitereview_import != ?', 1)
//                    ->order('video_id ASC');
//            $sitereviewDatas = $sitereviewTable->fetchAll($selectVideos);

            $selectVideos = $sitereviewTable->select()->setIntegrityCheck(false)
                    ->from($sitereviewTableName, 'video_id')
                    ->join($sitereviewlistingsTableName, $sitereviewTableName . ".listing_id=" . $sitereviewlistingsTableName . ".listing_id", null)
                     ->where('is_sitereview_import != ?', 1)
                     ->where("$sitereviewlistingsTableName.listingtype_id =?", $listingtype_id)
                    ->order('video_id ASC')
            ;
            $sitereviewDatas = $sitereviewTable->fetchAll($selectVideos);
            
            if (!empty($sitereviewDatas)) {

                $flag_first_sitereview_id = 1;

                foreach ($sitereviewDatas as $sitereviewData) {

                    if ($flag_first_sitereview_id == 1) {
                        $this->view->first_sitereview_id = $first_sitereview_id = $sitereviewData->video_id;
                    }
                    $flag_first_sitereview_id++;

                    $this->view->last_sitereview_id = $last_sitereview_id = $sitereviewData->video_id;
                }

                if (isset($_GET['sitereview_assigned_previous_id'])) {
                    $this->view->sitereview_assigned_previous_id = $sitereview_assigned_previous_id = $_GET['sitereview_assigned_previous_id'];
                } else {
                    $this->view->sitereview_assigned_previous_id = $sitereview_assigned_previous_id = $first_sitereview_id;
                }
            }

            //START IMPORTING IF REQUESTED
            if (isset($_GET['start_import']) && $_GET['start_import'] == 1 && $_GET['module'] == 'sitereview') {

                try {
                    //ACTIVITY FEED IMPORT
                    $activity_sitereview = $this->_getParam('activity_sitereview');

                    //START VIDEO IMPORTING
//                    $selectVideos = $sitereviewTable->select()
//                            ->where('video_id >= ?', $sitereview_assigned_previous_id)
//                            ->from($sitereviewTableName, 'video_id')
//                            ->where('is_sitereview_import != ?', 1)
//                            ->order('video_id ASC');
                    
                     $selectVideos = $sitereviewTable->select()->setIntegrityCheck(false)
                    ->from($sitereviewTableName)
                    ->join($sitereviewlistingsTableName, $sitereviewTableName . ".listing_id=" . $sitereviewlistingsTableName . ".listing_id", null)
                              ->where('is_sitereview_import != ?', 1) 
                              ->where('video_id >= ?', $sitereview_assigned_previous_id)
                     ->where("$sitereviewlistingsTableName.listingtype_id =?", $listingtype_id)
                    ->order('video_id ASC')
            ;
            $sitereviewDatas = $sitereviewTable->fetchAll($selectVideos);
            

                    $next_import_count = 0;
                    $sitereviewDatasArray = $sitereviewDatas->toArray();
                    if ($sitereviewDatasArray) {
                        foreach ($sitereviewDatas as $sitereviewData) {
                            $db = Engine_Db_Table::getDefaultAdapter();
                            $db->beginTransaction();
                            try {
                                $sitereview_id = $sitereviewData->video_id;
                                if (!empty($sitereview_id)) {
                                    $sitereview = Engine_Api::_()->getItem('sitereview_video', $sitereview_id);

                                    $sitevideo = $sitevideoTable->createRow();
                                    $sitevideo->title = $sitereview->title;
                                    $sitevideo->description = $sitereview->description;
                                    $sitevideo->owner_id = $sitereview->owner_id;
                                    $sitevideo->parent_type = 'sitereview_listing_' . $listingtype_id;
                                    $sitevideo->parent_id = $sitereview->listing_id;

                                    $sitevideo->creation_date = $sitereview->creation_date;
                                    $sitevideo->modified_date = $sitereview->modified_date;
                                    $sitevideo->save();
                                    $sitevideo->creation_date = $sitereview->creation_date;
                                    $sitevideo->modified_date = $sitereview->modified_date;
                                    $sitevideo->view_count = 1;
                                    if ($sitereview->view_count > 0) {
                                        $sitevideo->view_count = $sitereview->view_count;
                                    }
                                    $sitevideo->search = $sitereview->search;

                                    if (isset($sitereview->location))
                                        $sitevideo->location = $sitereview->location;

                                    if (isset($sitereview->seao_locationid))
                                        $sitevideo->seao_locationid = $sitereview->seao_locationid;

                                    $sitevideo->type = $sitereview->type;
                                    $sitevideo->code = $sitereview->code;
                                    $sitevideo->photo_id = $sitereview->photo_id;
                                    $sitevideo->rating = $sitereview->rating;
                                    $sitevideo->status = $sitereview->status;
                                    $sitevideo->file_id = $sitereview->file_id;
                                    $sitevideo->duration = $sitereview->duration;

                                    $sitevideo->save();
                                    $sitereview->is_sitereview_import = 1;

                                    $sitereview->save();
                                    $row = $sitevideoOtherinfoTable->getOtherinfo($sitevideo->getIdentity());
                                    if (empty($row)) {
                                        $sitevideoOtherinfoTable->insert(array(
                                            'video_id' => $sitevideo->getIdentity(),
                                                // 'host_params' => json_encode($hostInfo),
                                        )); //COMMIT
                                    }
                                    if ($sitereview->photo_id) {
                                        //STORAGE FILE WORK
                                        $storageData = $storageTable->fetchRow(array('file_id = ?' => $sitereview->photo_id));
                                        if (!empty($storageData) && !empty($storageData->storage_path)) {
                                            // Get file
                                            $file = Engine_Api::_()->getItem('storage_file', $sitereview->photo_id);

                                            // Pull video to a temporary file
                                            $tmpFile = $file->temporary();

                                            // Set the video
                                            $db = $sitevideo->getTable()->getAdapter();
                                            $db->beginTransaction();
                                            $params = array();
                                            $params['setPhotoId'] = true;
                                            try {
                                                $sitevideo->setVideo($tmpFile, $params);
                                                @unlink($tmpFile);
                                                $db->commit();
                                            } catch (Exception $e) {
                                                @unlink($tmpFile);
                                                $db->rollBack();
                                                throw $e;
                                            }
                                        }
                                    }

                                    if ($sitereview->file_id) {
                                        //STORAGE FILE WORK
                                        $storageData = $storageTable->fetchRow(array('file_id = ?' => $sitereview->file_id));
                                        if (!empty($storageData) && !empty($storageData->storage_path)) {
                                            $storage = Engine_Api::_()->getItemTable('storage_file');
                                            $storageObject = $storage->createFile($storageData->storage_path, array(
                                                'parent_id' => $sitevideo->getIdentity(),
                                                'parent_type' => $sitevideo->getType(),
                                                'user_id' => $sitevideo->getOwner()->getIdentity(),
                                            ));
                                            $sitevideo->file_id = $storageObject->file_id;
                                            $sitevideo->save();
                                        }
                                    }

                                    $next_import_count++;
                                    //END GET DATA FROM VIDEO
                                    $sitereview = Engine_Api::_()->getItem('sitereview_listing', $sitereview->listing_id);
                                    $values = array();

                                    //START FETCH PRIVACY
                                    $auth = Engine_Api::_()->authorization()->context;

                                    //START VIEW PRIVACY
                                    $auth = Engine_Api::_()->authorization()->context;
                                    $values = array();

                                    //START VIEW PRIVACY
                                    $rolesVideos = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    foreach ($rolesVideos as $rolesVideo) {

                                        if ($auth->isAllowed($sitereview, $rolesVideo, 'view')) {
                                            $values['auth_view'] = $rolesVideo;
                                            break;
                                        }
                                    }
                                    $rolesSitevideos = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    $viewMax = array_search($values['auth_view'], $rolesSitevideos);

                                    foreach ($rolesSitevideos as $i => $rolesSitevideo) {
                                        $auth->setAllowed($sitevideo, $rolesSitevideo, 'view', ($i >= $viewMax));
                                    }
                                    //END VIEW PRIVACY
                                    // //START VIEW PRIVACY
                                    $rolesVideos = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    foreach ($rolesVideos as $rolesVideo) {

                                        if ($auth->isAllowed($sitereview, $rolesVideo, 'comment')) {
                                            $values['auth_comment'] = $rolesVideo;
                                            break;
                                        }
                                    }
                                    $rolesSitevideos = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    $commentMax = array_search($values['auth_comment'], $rolesSitevideos);

                                    foreach ($rolesSitevideos as $i => $rolesSitevideo) {
                                        $auth->setAllowed($sitevideo, $rolesSitevideo, 'comment', ($i >= $commentMax));
                                    }
                                    //END VIEW PRIVACY
                                    //START FETCH COMMENTS
                                    $selectComment = $commentTable->select()
                                            ->from($commentTableName, 'comment_id')
                                            ->where('resource_type = ?', 'sitereview_video')
                                            ->where('resource_id = ?', $sitereview_id);
                                    $selectCommentDatas = $commentTable->fetchAll($selectComment);
                                    foreach ($selectCommentDatas as $selectCommentData) {
                                        $comment = Engine_Api::_()->getItem('core_comment', $selectCommentData->comment_id);
                                        $newCommentEntry = $commentTable->createRow();
                                        $newCommentEntry->resource_type = 'video';
                                        $newCommentEntry->resource_id = $sitevideo->getIdentity();
                                        $newCommentEntry->poster_type = 'user';
                                        $newCommentEntry->poster_id = $comment->poster_id;
                                        $newCommentEntry->creation_date = $comment->creation_date;
                                        $newCommentEntry->like_count = $comment->like_count;
                                        $newCommentEntry->save();

                                        $newCommentEntry->creation_date = $comment->creation_date;
                                        $comment_id = $newCommentEntry->save();

                                        //START FETCH LIKES
                                        $selectLike = $likeTable->select()
                                                ->from($likeTableName, 'like_id')
                                                ->where('resource_type = ?', 'core_comment')
                                                ->where('resource_id = ?', $selectCommentData->comment_id);
                                        $selectLikeDatas = $likeTable->fetchAll($selectLike);
                                        foreach ($selectLikeDatas as $selectLikeData) {
                                            $like = Engine_Api::_()->getItem('core_like', $selectLikeData->like_id);
                                            $newLikeEntry = $likeTable->createRow();
                                            $newLikeEntry->resource_type = 'core_comment';
                                            $newLikeEntry->resource_id = $comment_id;
                                            $newLikeEntry->poster_type = 'user';
                                            $newLikeEntry->poster_id = $like->poster_id;
                                            $newLikeEntry->creation_date = $like->creation_date;

                                            $newLikeEntry->save();
                                            $newLikeEntry->creation_date = $like->creation_date;
                                            $newLikeEntry->save();
                                        }
                                        //END FETCH LIKES
                                    }
                                    //END FETCH COMMENTS
                                    //START UPDATE TOTAL COMMENTS IN SITEVIDEO TABLE
                                    $selectCommentCount = $commentTable->select()
                                            ->from($commentTableName, array('COUNT(*) AS like_count'))
                                            ->where('resource_type = ?', 'sitereview_video')
                                            ->where('resource_id = ?', $sitereview_id);
                                    $selectCommentCounts = $commentTable->fetchAll($selectCommentCount);
                                    if (!empty($selectCommentCounts)) {
                                        $selectCommentCounts = $selectCommentCounts->toArray();
                                        $sitevideo->comment_count = $selectCommentCounts[0]['like_count'];
                                        $sitevideo->save();
                                    }
                                    //END UPDATE TOTAL COMMENTS IN SITEVIDEO TABLE
                                    //START FETCH LIKES
                                    $selectLike = $likeTable->select()
                                            ->from($likeTableName, 'like_id')
                                            ->where('resource_type = ?', 'sitereview_video')
                                            ->where('resource_id = ?', $sitereview_id);
                                    $selectLikeDatas = $likeTable->fetchAll($selectLike);
                                    foreach ($selectLikeDatas as $selectLikeData) {
                                        $like = Engine_Api::_()->getItem('core_like', $selectLikeData->like_id);
                                        $newLikeEntry = $likeTable->createRow();
                                        $newLikeEntry->resource_type = 'video';
                                        $newLikeEntry->resource_id = $sitevideo->getIdentity();
                                        $newLikeEntry->poster_type = 'user';
                                        $newLikeEntry->poster_id = $like->poster_id;
                                        $newLikeEntry->creation_date = $like->creation_date;
                                        $newLikeEntry->save();
                                        $newLikeEntry->creation_date = $like->creation_date;
                                        $newLikeEntry->save();
                                    }
                                    //END FETCH LIKES
                                    //START UPDATE TOTAL LIKES IN SITEVIDEO TABLE
                                    $selectLikeCount = $likeTable->select()
                                            ->from($likeTableName, array('COUNT(*) AS like_count'))
                                            ->where('resource_type = ?', 'sitereview_video')
                                            ->where('resource_id = ?', $sitereview_id);
                                    $selectLikeCounts = $likeTable->fetchAll($selectLikeCount);
                                    if (!empty($selectLikeCounts)) {
                                        $selectLikeCounts = $selectLikeCounts->toArray();
                                        $sitevideo->like_count = $selectLikeCounts[0]['like_count'];
                                        $sitevideo->save();
                                    }
                                    //END UPDATE TOTAL LIKES IN SITEVIDEO TABLES
                                    //RATING WORK
                                    //START FETCH RATINGS
                                    $selectSitereviewvideoRating = $sitereviewratingsTable->select()
                                            ->from($sitereviewratingsTableName, '*')
                                            ->where('videorating_id = ?', $sitereview_id);
                                    $selectSitereviewvideoRatingDatas = $sitereviewratingsTable->fetchAll($selectSitereviewvideoRating);
                                    $selectSitereviewvideoRatingDatas = $selectSitereviewvideoRatingDatas->toArray();
                                    foreach ($selectSitereviewvideoRatingDatas as $selectSitereviewvideoRatingData) {
                                        $sitevideoratingsTable->insert(array(
                                            'resource_type' => 'video',
                                            'resource_id' => $sitevideo->getIdentity(),
                                            'user_id' => $selectSitereviewvideoRatingData['user_id'],
                                            'rating' => $selectSitereviewvideoRatingData['rating'],
                                        ));
                                    }
                                }

                                //GENERATE ACITIVITY FEED
                                if ($activity_sitereview) {
                                    //START FETCH ACTIONS
                                    $selectActionIds = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'sitereview_listing')
                                            ->where('object_id = ?', $sitereview->getIdentity())
                                            ->where('type =?', 'sitereview_video_new_listtype_' . $listingtype_id)
                                            ->query()
                                            ->fetchAll();
                                    foreach ($selectActionIds as $selectActionId) {
                                        $action = Engine_Api::_()->getItem('activity_action', $selectActionId);
                                        $action->type = 'sitevideo_video_new';
                                        $action->object_id = $sitevideo->getIdentity();
                                        $action->object_type = $sitevideo->getType();
                                        $action->save();
                                        $actionsTable->resetActivityBindings($action);
                                    }
                                    //END FETCH ACTIONS
                                    //START FETCH ACTIONS
                                    $selectActionId = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'sitereview_video')
                                            ->where('object_id = ?', $sitereview_id)
                                            ->where('type =?', 'post');
                                    $selectActionIds = $actionsTable->fetchAll($selectActionId);

                                    if ($selectActionIds) {
                                        foreach ($selectActionIds as $selectActionId) {
                                            $action = Engine_Api::_()->getItem('activity_action', $selectActionId['action_id']);

                                            $action->type = 'sitevideo_post';
                                            $action->object_id = $sitevideo->getIdentity();
                                            $action->object_type = $sitevideo->getType();
                                            $action->save();
                                            $actionsTable->resetActivityBindings($action);
                                        }
                                    }
                                    //END FETCH ACTIONS
                                    //START FETCH ACTIONS
                                    $selectActionId = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'sitereview_video')
                                            ->where('object_id = ?', $sitereview_id)
                                            ->where('type =?', 'sitetagcheckin_post');
                                    $selectActionIds = $actionsTable->fetchAll($selectActionId);
                                    if ($selectActionIds) {
                                        foreach ($selectActionIds as $selectActionId) {
                                            $action = Engine_Api::_()->getItem('activity_action', $selectActionId['action_id']);
                                            $action->type = 'sitetagcheckin_post';
                                            $action->object_id = $sitevideo->getIdentity();
                                            $action->object_type = $sitevideo->getType();
                                            $action->save();
                                            $actionsTable->resetActivityBindings($action);
                                        }
                                    }
                                    //END FETCH ACTIONS
                                    //START FETCH ACTIONS
                                    $selectActionId = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'sitereview_video')
                                            ->where('object_id = ?', $sitereview_id)
                                            ->where('type =?', 'like_sitereview_video');
                                    $selectActionIds = $actionsTable->fetchAll($selectActionId);
                                    if ($selectActionIds) {
                                        foreach ($selectActionIds as $selectActionId) {
                                            $action = Engine_Api::_()->getItem('activity_action', $selectActionId['action_id']);
                                            $action->type = 'like_sitereview_video';
                                            $action->object_id = $sitevideo->getIdentity();
                                            $action->object_type = $sitevideo->getType();
                                            $action->save();
                                            $actionsTable->resetActivityBindings($action);
                                        }
                                    }
                                    //END FETCH ACTIONS
                                    //UPDATE VIDEO TYPE 
                                    $attachmentsTable->update(array('type' => $sitevideo->getType(), 'id' => $sitevideo->getIdentity()), array('type = ?' => 'sitereview_video', 'id =?' => $sitereview_id));
                                }



                                //CREATE LOG ENTRY IN LOG FILE
                                if (file_exists(APPLICATION_PATH . '/temporary/log/VideoToSitevideoImport.log')) {
                                    $myFile = APPLICATION_PATH . '/temporary/log/VideoToSitevideoImport.log';
                                    $error = Zend_Registry::get('Zend_Translate')->_("can't open file");
                                    $fh = fopen($myFile, 'a') or die($error);
                                    $current_time = date('D, d M Y H:i:s T');
                                    $sitevideo_title = $sitevideo->title;
                                    $stringData = $this->view->translate('Video with ID ') . $sitereview_id . $this->view->translate(' is successfully imported into a Advanced Video with ID ') . $sitevideo->video_id . $this->view->translate(' at ') . $current_time . $this->view->translate(". Title of that Video is '") . $sitevideo_title . "'.\n\n";
                                    fwrite($fh, $stringData);
                                    fclose($fh);
                                }

                                $db->commit();
                                $this->view->sitereview_assigned_previous_id = $sitereview_id;
                            } catch (Exception $e) {
                                $db->rollback();
                                throw($e);
                            }
                            if ($next_import_count >= 100) {
                                $this->_redirect("admin/sitevideointegration/importvideo/index?start_import=1&module=sitereview&recall=1&activity_sitereview=$activity_sitereview&listingtype_id=$listingtype_id");
                            }
                        }
                    } else {
                        if ($_GET['recall']) {
                            echo json_encode(array('success' => 1));
                            exit();
                        }
                    }
                } catch (Exception $e) {
                    throw($e);
                }
            }
        }

        $this->view->first_siteevent_id = $first_siteevent_id = 0;
        $this->view->last_siteevent_id = $last_siteevent_id = 0;

        $this->view->siteeventEnabled = $siteeventEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('siteevent');

        if ($siteeventEnabled && (Engine_Api::_()->getDbtable('modules', 'sitevideo')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'siteevent_event', 'item_module' => 'siteevent')))) {

            $siteeventclasfvideosTable = Engine_Api::_()->getDbTable('clasfvideos', 'siteevent');
            $siteeventclasfvideosTableName = $siteeventclasfvideosTable->info('name');

            $siteeventeventsTable = Engine_Api::_()->getDbTable('events', 'siteevent');
            $siteeventeventsTableName = $siteeventeventsTable->info('name');
            $selectVideoEvents = $siteeventclasfvideosTable->select()->setIntegrityCheck(false)
                    ->from($siteeventclasfvideosTableName, array('video_id', 'event_id'))
                    ->join($siteeventeventsTableName, $siteeventclasfvideosTableName . ".event_id=" . $siteeventeventsTableName . ".event_id", null)
                    ->where("$siteeventclasfvideosTableName.is_import =?", 0)
                    ->query()
                    ->fetchAll();

            $sitevideoTable = Engine_Api::_()->getDbTable('videos', 'sitevideo');
            foreach ($selectVideoEvents as $results) {
                $sitevideoTable->update(array('parent_type' => 'siteevent_event', 'parent_id' => $results['event_id']), array('video_id = ?' => $results['video_id']));
            }
            //GET VIDEO TABLES 
            $siteeventTable = Engine_Api::_()->getDbTable('videos', 'siteevent');
            $siteeventTableName = $siteeventTable->info('name');

            $siteeventratingsTable = Engine_Api::_()->getDbTable('videoratings', 'siteevent');
            $siteeventratingsTableName = $siteeventratingsTable->info('name');
            //ADD NEW COLUMN IN VIDEO TABLE
            $db = Engine_Db_Table::getDefaultAdapter();
            $is_siteevent_import = $db->query("SHOW COLUMNS FROM engine4_siteevent_videos LIKE 'is_siteevent_import'")->fetch();
            if (empty($is_siteevent_import)) {
                $run_query = $db->query("ALTER TABLE `engine4_siteevent_videos` ADD is_siteevent_import TINYINT( 2 ) NOT NULL DEFAULT '0'");
            }

            //START IF IMPORTING IS BREAKED BY SOME REASON
            $selectVideos = $siteeventTable->select()
                    ->from($siteeventTableName, 'video_id')
                    ->where('is_siteevent_import != ?', 1)
                    ->order('video_id ASC');
            $siteeventDatas = $siteeventTable->fetchAll($selectVideos);

            if (!empty($siteeventDatas)) {

                $flag_first_siteevent_id = 1;

                foreach ($siteeventDatas as $siteeventData) {

                    if ($flag_first_siteevent_id == 1) {
                        $this->view->first_siteevent_id = $first_siteevent_id = $siteeventData->video_id;
                    }
                    $flag_first_siteevent_id++;

                    $this->view->last_siteevent_id = $last_siteevent_id = $siteeventData->video_id;
                }

                if (isset($_GET['siteevent_assigned_previous_id'])) {
                    $this->view->siteevent_assigned_previous_id = $siteevent_assigned_previous_id = $_GET['siteevent_assigned_previous_id'];
                } else {
                    $this->view->siteevent_assigned_previous_id = $siteevent_assigned_previous_id = $first_siteevent_id;
                }
            }

            //START IMPORTING IF REQUESTED
            if (isset($_GET['start_import']) && $_GET['start_import'] == 1 && $_GET['module'] == 'siteevent') {

                try {
                    //ACTIVITY FEED IMPORT
                    $activity_siteevent = $this->_getParam('activity_siteevent');

                    //START VIDEO IMPORTING
                    $selectVideos = $siteeventTable->select()
                            ->where('video_id >= ?', $siteevent_assigned_previous_id)
                            ->from($siteeventTableName, 'video_id')
                            ->where('is_siteevent_import != ?', 1)
                            ->order('video_id ASC');
                    $siteeventDatas = $siteeventTable->fetchAll($selectVideos);

                    $next_import_count = 0;
                    $siteeventDatasArray = $siteeventDatas->toArray();
                    if ($siteeventDatasArray) {
                        foreach ($siteeventDatas as $siteeventData) {
                            $db = Engine_Db_Table::getDefaultAdapter();
                            $db->beginTransaction();
                            try {
                                $siteevent_id = $siteeventData->video_id;
                                if (!empty($siteevent_id)) {
                                    $siteevent = Engine_Api::_()->getItem('siteevent_video', $siteevent_id);

                                    $sitevideo = $sitevideoTable->createRow();
                                    $sitevideo->title = $siteevent->title;
                                    $sitevideo->description = $siteevent->description;
                                    $sitevideo->owner_id = $siteevent->owner_id;
                                    $sitevideo->parent_type = 'siteevent_event';
                                    $sitevideo->parent_id = $siteevent->event_id;

                                    // $sitevideo->category_id = 1;

                                    $sitevideo->creation_date = $siteevent->creation_date;
                                    $sitevideo->modified_date = $siteevent->modified_date;
                                    $sitevideo->save();
                                    $sitevideo->creation_date = $siteevent->creation_date;
                                    $sitevideo->modified_date = $siteevent->modified_date;
                                    $sitevideo->view_count = 1;
                                    if ($siteevent->view_count > 0) {
                                        $sitevideo->view_count = $siteevent->view_count;
                                    }
                                    $sitevideo->search = $siteevent->search;

                                    if (isset($siteevent->location))
                                        $sitevideo->location = $siteevent->location;

                                    if (isset($siteevent->seao_locationid))
                                        $sitevideo->seao_locationid = $siteevent->seao_locationid;

                                    $sitevideo->type = $siteevent->type;
                                    $sitevideo->code = $siteevent->code;
                                    $sitevideo->photo_id = $siteevent->photo_id;
                                    $sitevideo->rating = $siteevent->rating;
                                    $sitevideo->status = $siteevent->status;
                                    $sitevideo->file_id = $siteevent->file_id;
                                    $sitevideo->duration = $siteevent->duration;

                                    $sitevideo->save();
                                    $siteevent->is_siteevent_import = 1;

                                    $siteevent->save();
                                    $row = $sitevideoOtherinfoTable->getOtherinfo($sitevideo->getIdentity());
                                    if (empty($row)) {
                                        $sitevideoOtherinfoTable->insert(array(
                                            'video_id' => $sitevideo->getIdentity(),
                                                // 'host_params' => json_encode($hostInfo),
                                        )); //COMMIT
                                    }
                                    if ($siteevent->photo_id) {
                                        //STORAGE FILE WORK
                                        $storageData = $storageTable->fetchRow(array('file_id = ?' => $siteevent->photo_id));
                                        if (!empty($storageData) && !empty($storageData->storage_path)) {
                                            // Get file
                                            $file = Engine_Api::_()->getItem('storage_file', $siteevent->photo_id);

                                            // Pull video to a temporary file
                                            $tmpFile = $file->temporary();

                                            // Set the video
                                            $db = $sitevideo->getTable()->getAdapter();
                                            $db->beginTransaction();
                                            $params = array();
                                            $params['setPhotoId'] = true;
                                            try {
                                                $sitevideo->setVideo($tmpFile, $params);
                                                @unlink($tmpFile);
                                                $db->commit();
                                            } catch (Exception $e) {
                                                @unlink($tmpFile);
                                                $db->rollBack();
                                                throw $e;
                                            }
                                        }
                                    }
                                    if ($siteevent->file_id) {
                                        //STORAGE FILE WORK
                                        $storageData = $storageTable->fetchRow(array('file_id = ?' => $siteevent->file_id));
                                        if (!empty($storageData) && !empty($storageData->storage_path)) {
                                            $storage = Engine_Api::_()->getItemTable('storage_file');
                                            $storageObject = $storage->createFile($storageData->storage_path, array(
                                                'parent_id' => $sitevideo->getIdentity(),
                                                'parent_type' => $sitevideo->getType(),
                                                'user_id' => $sitevideo->getOwner()->getIdentity(),
                                            ));
                                            $sitevideo->file_id = $storageObject->file_id;
                                            $sitevideo->save();
                                        }
                                    }

                                    $next_import_count++;
                                    //END GET DATA FROM VIDEO
                                    $siteevent = Engine_Api::_()->getItem('siteevent_event', $siteevent->event_id);
                                    $values = array();

                                    //START FETCH PRIVACY
                                    $auth = Engine_Api::_()->authorization()->context;

                                    //START VIEW PRIVACY
                                    $auth = Engine_Api::_()->authorization()->context;
                                    $values = array();

                                    //START VIEW PRIVACY
                                    $rolesVideos = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    foreach ($rolesVideos as $rolesVideo) {

                                        if ($auth->isAllowed($siteevent, $rolesVideo, 'view')) {
                                            $values['auth_view'] = $rolesVideo;
                                            break;
                                        }
                                    }
                                    $rolesSitevideos = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    $viewMax = array_search($values['auth_view'], $rolesSitevideos);

                                    foreach ($rolesSitevideos as $i => $rolesSitevideo) {
                                        $auth->setAllowed($sitevideo, $rolesSitevideo, 'view', ($i >= $viewMax));
                                    }
                                    //END VIEW PRIVACY
                                    // //START VIEW PRIVACY
                                    $rolesVideos = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    foreach ($rolesVideos as $rolesVideo) {

                                        if ($auth->isAllowed($siteevent, $rolesVideo, 'comment')) {
                                            $values['auth_comment'] = $rolesVideo;
                                            break;
                                        }
                                    }
                                    $rolesSitevideos = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    $commentMax = array_search($values['auth_comment'], $rolesSitevideos);

                                    foreach ($rolesSitevideos as $i => $rolesSitevideo) {
                                        $auth->setAllowed($sitevideo, $rolesSitevideo, 'comment', ($i >= $commentMax));
                                    }
                                    //END VIEW PRIVACY
                                    //START FETCH COMMENTS
                                    $selectComment = $commentTable->select()
                                            ->from($commentTableName, 'comment_id')
                                            ->where('resource_type = ?', 'siteevent_video')
                                            ->where('resource_id = ?', $siteevent_id);
                                    $selectCommentDatas = $commentTable->fetchAll($selectComment);
                                    foreach ($selectCommentDatas as $selectCommentData) {
                                        $comment = Engine_Api::_()->getItem('core_comment', $selectCommentData->comment_id);
                                        $newCommentEntry = $commentTable->createRow();
                                        $newCommentEntry->resource_type = 'video';
                                        $newCommentEntry->resource_id = $sitevideo->getIdentity();
                                        $newCommentEntry->poster_type = 'user';
                                        $newCommentEntry->poster_id = $comment->poster_id;
                                        $newCommentEntry->creation_date = $comment->creation_date;
                                        $newCommentEntry->like_count = $comment->like_count;
                                        $newCommentEntry->save();

                                        $newCommentEntry->creation_date = $comment->creation_date;
                                        $comment_id = $newCommentEntry->save();

                                        //START FETCH LIKES
                                        $selectLike = $likeTable->select()
                                                ->from($likeTableName, 'like_id')
                                                ->where('resource_type = ?', 'core_comment')
                                                ->where('resource_id = ?', $selectCommentData->comment_id);
                                        $selectLikeDatas = $likeTable->fetchAll($selectLike);
                                        foreach ($selectLikeDatas as $selectLikeData) {
                                            $like = Engine_Api::_()->getItem('core_like', $selectLikeData->like_id);
                                            $newLikeEntry = $likeTable->createRow();
                                            $newLikeEntry->resource_type = 'core_comment';
                                            $newLikeEntry->resource_id = $comment_id;
                                            $newLikeEntry->poster_type = 'user';
                                            $newLikeEntry->poster_id = $like->poster_id;
                                            $newLikeEntry->creation_date = $like->creation_date;

                                            $newLikeEntry->save();
                                            $newLikeEntry->creation_date = $like->creation_date;
                                            $newLikeEntry->save();
                                        }
                                        //END FETCH LIKES
                                    }
                                    //END FETCH COMMENTS
                                    //START UPDATE TOTAL COMMENTS IN SITEVIDEO TABLE
                                    $selectCommentCount = $commentTable->select()
                                            ->from($commentTableName, array('COUNT(*) AS like_count'))
                                            ->where('resource_type = ?', 'siteevent_video')
                                            ->where('resource_id = ?', $siteevent_id);
                                    $selectCommentCounts = $commentTable->fetchAll($selectCommentCount);
                                    if (!empty($selectCommentCounts)) {
                                        $selectCommentCounts = $selectCommentCounts->toArray();
                                        $sitevideo->comment_count = $selectCommentCounts[0]['like_count'];
                                        $sitevideo->save();
                                    }
                                    //END UPDATE TOTAL COMMENTS IN SITEVIDEO TABLE
                                    //START FETCH LIKES
                                    $selectLike = $likeTable->select()
                                            ->from($likeTableName, 'like_id')
                                            ->where('resource_type = ?', 'siteevent_video')
                                            ->where('resource_id = ?', $siteevent_id);
                                    $selectLikeDatas = $likeTable->fetchAll($selectLike);
                                    foreach ($selectLikeDatas as $selectLikeData) {
                                        $like = Engine_Api::_()->getItem('core_like', $selectLikeData->like_id);
                                        $newLikeEntry = $likeTable->createRow();
                                        $newLikeEntry->resource_type = 'video';
                                        $newLikeEntry->resource_id = $sitevideo->getIdentity();
                                        $newLikeEntry->poster_type = 'user';
                                        $newLikeEntry->poster_id = $like->poster_id;
                                        $newLikeEntry->creation_date = $like->creation_date;
                                        $newLikeEntry->save();
                                        $newLikeEntry->creation_date = $like->creation_date;
                                        $newLikeEntry->save();
                                    }
                                    //END FETCH LIKES
                                    //START UPDATE TOTAL LIKES IN SITEVIDEO TABLE
                                    $selectLikeCount = $likeTable->select()
                                            ->from($likeTableName, array('COUNT(*) AS like_count'))
                                            ->where('resource_type = ?', 'siteevent_video')
                                            ->where('resource_id = ?', $siteevent_id);
                                    $selectLikeCounts = $likeTable->fetchAll($selectLikeCount);
                                    if (!empty($selectLikeCounts)) {
                                        $selectLikeCounts = $selectLikeCounts->toArray();
                                        $sitevideo->like_count = $selectLikeCounts[0]['like_count'];
                                        $sitevideo->save();
                                    }
                                    //END UPDATE TOTAL LIKES IN SITEVIDEO TABLES
                                    //RATING WORK
                                    //START FETCH RATINGS
                                    $selectSiteeventvideoRating = $siteeventratingsTable->select()
                                            ->from($siteeventratingsTableName, '*')
                                            ->where('videorating_id = ?', $siteevent_id);
                                    $selectSiteeventvideoRatingDatas = $siteeventratingsTable->fetchAll($selectSiteeventvideoRating);
                                    $selectSiteeventvideoRatingDatas = $selectSiteeventvideoRatingDatas->toArray();
                                    foreach ($selectSiteeventvideoRatingDatas as $selectSiteeventvideoRatingData) {
                                        $sitevideoratingsTable->insert(array(
                                            'resource_type' => 'video',
                                            'resource_id' => $sitevideo->getIdentity(),
                                            'user_id' => $selectSiteeventvideoRatingData['user_id'],
                                            'rating' => $selectSiteeventvideoRatingData['rating'],
                                        ));
                                    }
                                }

                                //GENERATE ACITIVITY FEED
                                if ($activity_siteevent) {
                                    //START FETCH ACTIONS
                                    $selectActionIds = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'siteevent_event')
                                            ->where('object_id = ?', $siteevent->getIdentity())
                                            ->where('type =?', 'siteevent_video_new')
                                            ->query()
                                            ->fetchAll();
                                    foreach ($selectActionIds as $selectActionId) {
                                        $action = Engine_Api::_()->getItem('activity_action', $selectActionId);
                                        $action->type = 'sitevideo_video_new';
                                        $action->object_id = $sitevideo->getIdentity();
                                        $action->object_type = $sitevideo->getType();
                                        $action->save();
                                        $actionsTable->resetActivityBindings($action);
                                    }
                                    //END FETCH ACTIONS
                                    //START FETCH ACTIONS
                                    $selectActionId = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'siteevent_video')
                                            ->where('object_id = ?', $siteevent_id)
                                            ->where('type =?', 'post');
                                    $selectActionIds = $actionsTable->fetchAll($selectActionId);

                                    if ($selectActionIds) {
                                        foreach ($selectActionIds as $selectActionId) {
                                            $action = Engine_Api::_()->getItem('activity_action', $selectActionId['action_id']);

                                            $action->type = 'sitevideo_post';
                                            $action->object_id = $sitevideo->getIdentity();
                                            $action->object_type = $sitevideo->getType();
                                            $action->save();
                                            $actionsTable->resetActivityBindings($action);
                                        }
                                    }
                                    //END FETCH ACTIONS
                                    //START FETCH ACTIONS
                                    $selectActionId = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'siteevent_video')
                                            ->where('object_id = ?', $siteevent_id)
                                            ->where('type =?', 'sitetagcheckin_post');
                                    $selectActionIds = $actionsTable->fetchAll($selectActionId);
                                    if ($selectActionIds) {
                                        foreach ($selectActionIds as $selectActionId) {
                                            $action = Engine_Api::_()->getItem('activity_action', $selectActionId['action_id']);
                                            $action->type = 'sitetagcheckin_post';
                                            $action->object_id = $sitevideo->getIdentity();
                                            $action->object_type = $sitevideo->getType();
                                            $action->save();
                                            $actionsTable->resetActivityBindings($action);
                                        }
                                    }
                                    //END FETCH ACTIONS
                                    //START FETCH ACTIONS
                                    $selectActionId = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'siteevent_video')
                                            ->where('object_id = ?', $siteevent_id)
                                            ->where('type =?', 'like_siteevent_video');
                                    $selectActionIds = $actionsTable->fetchAll($selectActionId);
                                    if ($selectActionIds) {
                                        foreach ($selectActionIds as $selectActionId) {
                                            $action = Engine_Api::_()->getItem('activity_action', $selectActionId['action_id']);
                                            $action->type = 'like_siteevent_video';
                                            $action->object_id = $sitevideo->getIdentity();
                                            $action->object_type = $sitevideo->getType();
                                            $action->save();
                                            $actionsTable->resetActivityBindings($action);
                                        }
                                    }
                                    //END FETCH ACTIONS
                                    //UPDATE VIDEO TYPE 
                                    $attachmentsTable->update(array('type' => $sitevideo->getType(), 'id' => $sitevideo->getIdentity()), array('type = ?' => 'siteevent_video', 'id =?' => $siteevent_id));
                                }



                                //CREATE LOG ENTRY IN LOG FILE
                                if (file_exists(APPLICATION_PATH . '/temporary/log/VideoToSitevideoImport.log')) {
                                    $myFile = APPLICATION_PATH . '/temporary/log/VideoToSitevideoImport.log';
                                    $error = Zend_Registry::get('Zend_Translate')->_("can't open file");
                                    $fh = fopen($myFile, 'a') or die($error);
                                    $current_time = date('D, d M Y H:i:s T');
                                    $sitevideo_title = $sitevideo->title;
                                    $stringData = $this->view->translate('Video with ID ') . $siteevent_id . $this->view->translate(' is successfully imported into a Advanced Video with ID ') . $sitevideo->video_id . $this->view->translate(' at ') . $current_time . $this->view->translate(". Title of that Video is '") . $sitevideo_title . "'.\n\n";
                                    fwrite($fh, $stringData);
                                    fclose($fh);
                                }

                                $db->commit();
                                $this->view->siteevent_assigned_previous_id = $siteevent_id;
                            } catch (Exception $e) {
                                $db->rollback();
                                throw($e);
                            }
                            if ($next_import_count >= 100) {
                                $this->_redirect("admin/sitevideointegration/importvideo/index?start_import=1&module=siteevent&recall=1&activity_siteevent=$activity_siteevent");
                            }
                        }
                    } else {
                        if ($_GET['recall']) {
                            echo json_encode(array('success' => 1));
                            exit();
                        }
                    }
                } catch (Exception $e) {
                    throw($e);
                }
            }
        }

        $this->view->first_sitestoreproduct_id = $first_sitestoreproduct_id = 0;
        $this->view->last_sitestoreproduct_id = $last_sitestoreproduct_id = 0;

        $this->view->sitestoreproductEnabled = $sitestoreproductEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitestoreproduct');

        if ($sitestoreproductEnabled && (Engine_Api::_()->getDbtable('modules', 'sitevideo')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'sitestoreproduct_product', 'item_module' => 'sitestoreproduct')))) {

            //GET VIDEO TABLES 
            $sitestoreproductTable = Engine_Api::_()->getDbTable('videos', 'sitestoreproduct');
            $sitestoreproductTableName = $sitestoreproductTable->info('name');

            $sitestoreproductratingsTable = Engine_Api::_()->getDbTable('videoratings', 'sitestoreproduct');
            $sitestoreproductratingsTableName = $sitestoreproductratingsTable->info('name');
            //ADD NEW COLUMN IN VIDEO TABLE
            $db = Engine_Db_Table::getDefaultAdapter();
            $is_sitestoreproduct_import = $db->query("SHOW COLUMNS FROM engine4_sitestoreproduct_videos LIKE 'is_sitestoreproduct_import'")->fetch();
            if (empty($is_sitestoreproduct_import)) {
                $run_query = $db->query("ALTER TABLE `engine4_sitestoreproduct_videos` ADD is_sitestoreproduct_import TINYINT( 2 ) NOT NULL DEFAULT '0'");
            }

            //START IF IMPORTING IS BREAKED BY SOME REASON
            $selectVideos = $sitestoreproductTable->select()
                    ->from($sitestoreproductTableName, 'video_id')
                    ->where('is_sitestoreproduct_import != ?', 1)
                    ->order('video_id ASC');
            $sitestoreproductDatas = $sitestoreproductTable->fetchAll($selectVideos);

            if (!empty($sitestoreproductDatas)) {

                $flag_first_sitestoreproduct_id = 1;

                foreach ($sitestoreproductDatas as $sitestoreproductData) {

                    if ($flag_first_sitestoreproduct_id == 1) {
                        $this->view->first_sitestoreproduct_id = $first_sitestoreproduct_id = $sitestoreproductData->video_id;
                    }
                    $flag_first_sitestoreproduct_id++;

                    $this->view->last_sitestoreproduct_id = $last_sitestoreproduct_id = $sitestoreproductData->video_id;
                }

                if (isset($_GET['sitestoreproduct_assigned_previous_id'])) {
                    $this->view->sitestoreproduct_assigned_previous_id = $sitestoreproduct_assigned_previous_id = $_GET['sitestoreproduct_assigned_previous_id'];
                } else {
                    $this->view->sitestoreproduct_assigned_previous_id = $sitestoreproduct_assigned_previous_id = $first_sitestoreproduct_id;
                }
            }

            //START IMPORTING IF REQUESTED
            if (isset($_GET['start_import']) && $_GET['start_import'] == 1 && $_GET['module'] == 'sitestoreproduct') {

                try {
                    //ACTIVITY FEED IMPORT
                    $activity_sitestoreproduct = $this->_getParam('activity_sitestoreproduct');

                    //START VIDEO IMPORTING
                    $selectVideos = $sitestoreproductTable->select()
                            ->where('video_id >= ?', $sitestoreproduct_assigned_previous_id)
                            ->from($sitestoreproductTableName, 'video_id')
                            ->where('is_sitestoreproduct_import != ?', 1)
                            ->order('video_id ASC');
                    $sitestoreproductDatas = $sitestoreproductTable->fetchAll($selectVideos);

                    $next_import_count = 0;
                    $sitestoreproductDatasArray = $sitestoreproductDatas->toArray();
                    if ($sitestoreproductDatasArray) {
                        foreach ($sitestoreproductDatas as $sitestoreproductData) {
                            $db = Engine_Db_Table::getDefaultAdapter();
                            $db->beginTransaction();
                            try {
                                $sitestoreproduct_id = $sitestoreproductData->video_id;
                                if (!empty($sitestoreproduct_id)) {
                                    $sitestoreproduct = Engine_Api::_()->getItem('sitestoreproduct_video', $sitestoreproduct_id);

                                    $sitevideo = $sitevideoTable->createRow();
                                    $sitevideo->title = $sitestoreproduct->title;
                                    $sitevideo->description = $sitestoreproduct->description;
                                    $sitevideo->owner_id = $sitestoreproduct->owner_id;
                                    $sitevideo->parent_type = 'sitestoreproduct_product';
                                    $sitevideo->parent_id = $sitestoreproduct->product_id;

                                    // $sitevideo->category_id = 1;

                                    $sitevideo->creation_date = $sitestoreproduct->creation_date;
                                    $sitevideo->modified_date = $sitestoreproduct->modified_date;
                                    $sitevideo->save();
                                    $sitevideo->creation_date = $sitestoreproduct->creation_date;
                                    $sitevideo->modified_date = $sitestoreproduct->modified_date;
                                    $sitevideo->view_count = 1;
                                    if ($sitestoreproduct->view_count > 0) {
                                        $sitevideo->view_count = $sitestoreproduct->view_count;
                                    }
                                    $sitevideo->search = $sitestoreproduct->search;

                                    if (isset($sitestoreproduct->location))
                                        $sitevideo->location = $sitestoreproduct->location;

                                    if (isset($sitestoreproduct->seao_locationid))
                                        $sitevideo->seao_locationid = $sitestoreproduct->seao_locationid;

                                    $sitevideo->type = $sitestoreproduct->type;
                                    $sitevideo->code = $sitestoreproduct->code;
                                    $sitevideo->photo_id = $sitestoreproduct->photo_id;
                                    $sitevideo->rating = $sitestoreproduct->rating;
                                    $sitevideo->status = $sitestoreproduct->status;
                                    $sitevideo->file_id = $sitestoreproduct->file_id;
                                    $sitevideo->duration = $sitestoreproduct->duration;

                                    $sitevideo->save();
                                    $sitestoreproduct->is_sitestoreproduct_import = 1;

                                    $sitestoreproduct->save();
                                    $row = $sitevideoOtherinfoTable->getOtherinfo($sitevideo->getIdentity());
                                    if (empty($row)) {
                                        $sitevideoOtherinfoTable->insert(array(
                                            'video_id' => $sitevideo->getIdentity(),
                                                // 'host_params' => json_encode($hostInfo),
                                        )); //COMMIT
                                    }
                                    if ($sitestoreproduct->photo_id) {
                                        //STORAGE FILE WORK
                                        $storageData = $storageTable->fetchRow(array('file_id = ?' => $sitestoreproduct->photo_id));
                                        if (!empty($storageData) && !empty($storageData->storage_path)) {
                                            // Get file
                                            $file = Engine_Api::_()->getItem('storage_file', $sitestoreproduct->photo_id);

                                            // Pull video to a temporary file
                                            $tmpFile = $file->temporary();

                                            // Set the video
                                            $db = $sitevideo->getTable()->getAdapter();
                                            $db->beginTransaction();
                                            $params = array();
                                            $params['setPhotoId'] = true;
                                            try {
                                                $sitevideo->setVideo($tmpFile, $params);
                                                @unlink($tmpFile);
                                                $db->commit();
                                            } catch (Exception $e) {
                                                @unlink($tmpFile);
                                                $db->rollBack();
                                                throw $e;
                                            }
                                        }
                                    }
                                    if ($sitestoreproduct->file_id) {
                                        //STORAGE FILE WORK
                                        $storageData = $storageTable->fetchRow(array('file_id = ?' => $sitestoreproduct->file_id));
                                        if (!empty($storageData) && !empty($storageData->storage_path)) {
                                            $storage = Engine_Api::_()->getItemTable('storage_file');
                                            $storageObject = $storage->createFile($storageData->storage_path, array(
                                                'parent_id' => $sitevideo->getIdentity(),
                                                'parent_type' => $sitevideo->getType(),
                                                'user_id' => $sitevideo->getOwner()->getIdentity(),
                                            ));
                                            $sitevideo->file_id = $storageObject->file_id;
                                            $sitevideo->save();
                                        }
                                    }

                                    $next_import_count++;
                                    //END GET DATA FROM VIDEO
                                    $sitestoreproduct = Engine_Api::_()->getItem('sitestoreproduct_product', $sitestoreproduct->product_id);
                                    $values = array();

                                    //START FETCH PRIVACY
                                    $auth = Engine_Api::_()->authorization()->context;

                                    //START VIEW PRIVACY
                                    $auth = Engine_Api::_()->authorization()->context;
                                    $values = array();

                                    //START VIEW PRIVACY
                                    $rolesVideos = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    foreach ($rolesVideos as $rolesVideo) {

                                        if ($auth->isAllowed($sitestoreproduct, $rolesVideo, 'view')) {
                                            $values['auth_view'] = $rolesVideo;
                                            break;
                                        }
                                    }
                                    $rolesSitevideos = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    $viewMax = array_search($values['auth_view'], $rolesSitevideos);

                                    foreach ($rolesSitevideos as $i => $rolesSitevideo) {
                                        $auth->setAllowed($sitevideo, $rolesSitevideo, 'view', ($i >= $viewMax));
                                    }
                                    //END VIEW PRIVACY
                                    // //START VIEW PRIVACY
                                    $rolesVideos = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    foreach ($rolesVideos as $rolesVideo) {

                                        if ($auth->isAllowed($sitestoreproduct, $rolesVideo, 'comment')) {
                                            $values['auth_comment'] = $rolesVideo;
                                            break;
                                        }
                                    }
                                    $rolesSitevideos = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    $commentMax = array_search($values['auth_comment'], $rolesSitevideos);

                                    foreach ($rolesSitevideos as $i => $rolesSitevideo) {
                                        $auth->setAllowed($sitevideo, $rolesSitevideo, 'comment', ($i >= $commentMax));
                                    }
                                    //END VIEW PRIVACY
                                    //START FETCH COMMENTS
                                    $selectComment = $commentTable->select()
                                            ->from($commentTableName, 'comment_id')
                                            ->where('resource_type = ?', 'sitestoreproduct_video')
                                            ->where('resource_id = ?', $sitestoreproduct_id);
                                    $selectCommentDatas = $commentTable->fetchAll($selectComment);
                                    foreach ($selectCommentDatas as $selectCommentData) {
                                        $comment = Engine_Api::_()->getItem('core_comment', $selectCommentData->comment_id);
                                        $newCommentEntry = $commentTable->createRow();
                                        $newCommentEntry->resource_type = 'video';
                                        $newCommentEntry->resource_id = $sitevideo->getIdentity();
                                        $newCommentEntry->poster_type = 'user';
                                        $newCommentEntry->poster_id = $comment->poster_id;
                                        $newCommentEntry->creation_date = $comment->creation_date;
                                        $newCommentEntry->like_count = $comment->like_count;
                                        $newCommentEntry->save();

                                        $newCommentEntry->creation_date = $comment->creation_date;
                                        $comment_id = $newCommentEntry->save();

                                        //START FETCH LIKES
                                        $selectLike = $likeTable->select()
                                                ->from($likeTableName, 'like_id')
                                                ->where('resource_type = ?', 'core_comment')
                                                ->where('resource_id = ?', $selectCommentData->comment_id);
                                        $selectLikeDatas = $likeTable->fetchAll($selectLike);
                                        foreach ($selectLikeDatas as $selectLikeData) {
                                            $like = Engine_Api::_()->getItem('core_like', $selectLikeData->like_id);
                                            $newLikeEntry = $likeTable->createRow();
                                            $newLikeEntry->resource_type = 'core_comment';
                                            $newLikeEntry->resource_id = $comment_id;
                                            $newLikeEntry->poster_type = 'user';
                                            $newLikeEntry->poster_id = $like->poster_id;
                                            $newLikeEntry->creation_date = $like->creation_date;

                                            $newLikeEntry->save();
                                            $newLikeEntry->creation_date = $like->creation_date;
                                            $newLikeEntry->save();
                                        }
                                        //END FETCH LIKES
                                    }
                                    //END FETCH COMMENTS
                                    //START UPDATE TOTAL COMMENTS IN SITEVIDEO TABLE
                                    $selectCommentCount = $commentTable->select()
                                            ->from($commentTableName, array('COUNT(*) AS like_count'))
                                            ->where('resource_type = ?', 'sitestoreproduct_video')
                                            ->where('resource_id = ?', $sitestoreproduct_id);
                                    $selectCommentCounts = $commentTable->fetchAll($selectCommentCount);
                                    if (!empty($selectCommentCounts)) {
                                        $selectCommentCounts = $selectCommentCounts->toArray();
                                        $sitevideo->comment_count = $selectCommentCounts[0]['like_count'];
                                        $sitevideo->save();
                                    }
                                    //END UPDATE TOTAL COMMENTS IN SITEVIDEO TABLE
                                    //START FETCH LIKES
                                    $selectLike = $likeTable->select()
                                            ->from($likeTableName, 'like_id')
                                            ->where('resource_type = ?', 'sitestoreproduct_video')
                                            ->where('resource_id = ?', $sitestoreproduct_id);
                                    $selectLikeDatas = $likeTable->fetchAll($selectLike);
                                    foreach ($selectLikeDatas as $selectLikeData) {
                                        $like = Engine_Api::_()->getItem('core_like', $selectLikeData->like_id);
                                        $newLikeEntry = $likeTable->createRow();
                                        $newLikeEntry->resource_type = 'video';
                                        $newLikeEntry->resource_id = $sitevideo->getIdentity();
                                        $newLikeEntry->poster_type = 'user';
                                        $newLikeEntry->poster_id = $like->poster_id;
                                        $newLikeEntry->creation_date = $like->creation_date;
                                        $newLikeEntry->save();
                                        $newLikeEntry->creation_date = $like->creation_date;
                                        $newLikeEntry->save();
                                    }
                                    //END FETCH LIKES
                                    //START UPDATE TOTAL LIKES IN SITEVIDEO TABLE
                                    $selectLikeCount = $likeTable->select()
                                            ->from($likeTableName, array('COUNT(*) AS like_count'))
                                            ->where('resource_type = ?', 'sitestoreproduct_video')
                                            ->where('resource_id = ?', $sitestoreproduct_id);
                                    $selectLikeCounts = $likeTable->fetchAll($selectLikeCount);
                                    if (!empty($selectLikeCounts)) {
                                        $selectLikeCounts = $selectLikeCounts->toArray();
                                        $sitevideo->like_count = $selectLikeCounts[0]['like_count'];
                                        $sitevideo->save();
                                    }
                                    //END UPDATE TOTAL LIKES IN SITEVIDEO TABLES
                                    //RATING WORK
                                    //START FETCH RATINGS
                                    $selectSitestoreproductvideoRating = $sitestoreproductratingsTable->select()
                                            ->from($sitestoreproductratingsTableName, '*')
                                            ->where('videorating_id = ?', $sitestoreproduct_id);
                                    $selectSitestoreproductvideoRatingDatas = $sitestoreproductratingsTable->fetchAll($selectSitestoreproductvideoRating);
                                    $selectSitestoreproductvideoRatingDatas = $selectSitestoreproductvideoRatingDatas->toArray();
                                    foreach ($selectSitestoreproductvideoRatingDatas as $selectSitestoreproductvideoRatingData) {
                                        $sitevideoratingsTable->insert(array(
                                            'resource_type' => 'video',
                                            'resource_id' => $sitevideo->getIdentity(),
                                            'user_id' => $selectSitestoreproductvideoRatingData['user_id'],
                                            'rating' => $selectSitestoreproductvideoRatingData['rating'],
                                        ));
                                    }
                                }

                                //GENERATE ACITIVITY FEED
                                if ($activity_sitestoreproduct) {
                                    //START FETCH ACTIONS
                                    $selectActionIds = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'sitestoreproduct_storeproduct')
                                            ->where('object_id = ?', $sitestoreproduct->getIdentity())
                                            ->where('type =?', 'sitestoreproduct_video_new')
                                            ->query()
                                            ->fetchAll();
                                    foreach ($selectActionIds as $selectActionId) {
                                        $action = Engine_Api::_()->getItem('activity_action', $selectActionId);
                                        $action->type = 'sitevideo_video_new';
                                        $action->object_id = $sitevideo->getIdentity();
                                        $action->object_type = $sitevideo->getType();
                                        $action->save();
                                        $actionsTable->resetActivityBindings($action);
                                    }
                                    //END FETCH ACTIONS
                                    //START FETCH ACTIONS
                                    $selectActionId = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'sitestoreproduct_video')
                                            ->where('object_id = ?', $sitestoreproduct_id)
                                            ->where('type =?', 'post');
                                    $selectActionIds = $actionsTable->fetchAll($selectActionId);

                                    if ($selectActionIds) {
                                        foreach ($selectActionIds as $selectActionId) {
                                            $action = Engine_Api::_()->getItem('activity_action', $selectActionId['action_id']);

                                            $action->type = 'sitevideo_post';
                                            $action->object_id = $sitevideo->getIdentity();
                                            $action->object_type = $sitevideo->getType();
                                            $action->save();
                                            $actionsTable->resetActivityBindings($action);
                                        }
                                    }
                                    //END FETCH ACTIONS
                                    //START FETCH ACTIONS
                                    $selectActionId = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'sitestoreproduct_video')
                                            ->where('object_id = ?', $sitestoreproduct_id)
                                            ->where('type =?', 'sitetagcheckin_post');
                                    $selectActionIds = $actionsTable->fetchAll($selectActionId);
                                    if ($selectActionIds) {
                                        foreach ($selectActionIds as $selectActionId) {
                                            $action = Engine_Api::_()->getItem('activity_action', $selectActionId['action_id']);
                                            $action->type = 'sitetagcheckin_post';
                                            $action->object_id = $sitevideo->getIdentity();
                                            $action->object_type = $sitevideo->getType();
                                            $action->save();
                                            $actionsTable->resetActivityBindings($action);
                                        }
                                    }
                                    //END FETCH ACTIONS
                                    //START FETCH ACTIONS
                                    $selectActionId = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'sitestoreproduct_video')
                                            ->where('object_id = ?', $sitestoreproduct_id)
                                            ->where('type =?', 'like_sitestoreproduct_video');
                                    $selectActionIds = $actionsTable->fetchAll($selectActionId);
                                    if ($selectActionIds) {
                                        foreach ($selectActionIds as $selectActionId) {
                                            $action = Engine_Api::_()->getItem('activity_action', $selectActionId['action_id']);
                                            $action->type = 'like_sitestoreproduct_video';
                                            $action->object_id = $sitevideo->getIdentity();
                                            $action->object_type = $sitevideo->getType();
                                            $action->save();
                                            $actionsTable->resetActivityBindings($action);
                                        }
                                    }
                                    //END FETCH ACTIONS
                                    //UPDATE VIDEO TYPE 
                                    $attachmentsTable->update(array('type' => $sitevideo->getType(), 'id' => $sitevideo->getIdentity()), array('type = ?' => 'sitestoreproduct_video', 'id =?' => $sitestoreproduct_id));
                                }



                                //CREATE LOG ENTRY IN LOG FILE
                                if (file_exists(APPLICATION_PATH . '/temporary/log/VideoToSitevideoImport.log')) {
                                    $myFile = APPLICATION_PATH . '/temporary/log/VideoToSitevideoImport.log';
                                    $error = Zend_Registry::get('Zend_Translate')->_("can't open file");
                                    $fh = fopen($myFile, 'a') or die($error);
                                    $current_time = date('D, d M Y H:i:s T');
                                    $sitevideo_title = $sitevideo->title;
                                    $stringData = $this->view->translate('Video with ID ') . $sitestoreproduct_id . $this->view->translate(' is successfully imported into a Advanced Video with ID ') . $sitevideo->video_id . $this->view->translate(' at ') . $current_time . $this->view->translate(". Title of that Video is '") . $sitevideo_title . "'.\n\n";
                                    fwrite($fh, $stringData);
                                    fclose($fh);
                                }

                                $db->commit();
                                $this->view->sitestoreproduct_assigned_previous_id = $sitestoreproduct_id;
                            } catch (Exception $e) {
                                $db->rollback();
                                throw($e);
                            }
                            if ($next_import_count >= 100) {
                                $this->_redirect("admin/sitevideointegration/importvideo/index?start_import=1&module=sitestoreproduct&recall=1&activity_sitestoreproduct=$activity_sitestoreproduct");
                            }
                        }
                    } else {
                        if ($_GET['recall']) {
                            echo json_encode(array('success' => 1));
                            exit();
                        }
                    }
                } catch (Exception $e) {
                    throw($e);
                }
            }
        }

    }

}
