<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitevideointegration
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 6590 2015-1-22 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitevideointegration_Installer extends Engine_Package_Installer_Module {

    public function onPreinstall() {

        $getErrorMsg = $this->getVersion();
        if (!empty($getErrorMsg)) {
            return $this->_error($getErrorMsg);
        }

        $db = $this->getDb();
        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_settings')
                ->where('name = ?', 'sitevideo.isActivate')
                ->limit(1);
        $sitevideo_settings = $select->query()->fetchAll();

        $sitevideo_is_active = !empty($sitevideo_settings) ? $sitevideo_settings[0]['value'] : 0;

        $select = new Zend_Db_Select($db);
        $issitevideoEnabled = $select
                ->from('engine4_core_modules', 'enabled')
                ->where('name = ?', 'sitevideo')
                ->where('enabled = ?', 1)
                ->query()
                ->fetchColumn()
        ;

        if (empty($issitevideoEnabled)) {
            $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();

            $installErrMsg .= "<span style='color:red'>Note: You have not installed the '<a href='https://www.socialengineaddons.com/socialengine-advanced-videos-channels-playlists-plugin' target='_blank'>Advanced Videos / Channels / Playlists Plugin</a>' on your site yet. Please install it first before installing the 'Advanced Videos - Pages, Businesses, Groups, Multiple Listing Types, Events, Stores, etc Extension'. <a href='" . $base_url . "/manage'>Click here</a> to go to Manage Packages.</span>";
        } else {
            if (empty($sitevideo_is_active)) {
                $newVar = !empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://' : 'http://';
                $core_final_url = '';
                $baseUrl = $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getBaseUrl();
                $explode_base_url = explode("/", $baseUrl);
                foreach ($explode_base_url as $url_key) {
                    if ($url_key != 'install') {
                        $core_final_url .= $url_key . '/';
                    }
                }
                $activateErrMsg .= "<span style='color:red'>Note: You have installed the 'Advanced Videos / Channels / Playlists Plugin' but not activated it on your site yet. Please activate it first before installing the 'Advanced Videos - Pages, Businesses, Groups, Multiple Listing Types, Events, Stores, etc Extension'.</span> <a href='" . $newVar . $core_final_url . "admin/sitevideo/settings/readme'>Click here</a> to activate the 'Advanced Videos / Channels / Playlists Plugin'.";
            }
        }

        if (!empty($installErrMsg))
            return $this->_error($installErrMsg);

        if (!empty($activateErrMsg))
            return $this->_error($activateErrMsg);

        $PRODUCT_TYPE = 'sitevideointegration';
        $PLUGIN_TITLE = 'Sitevideointegration';
        $PLUGIN_VERSION = '5.4.1';
        $PLUGIN_CATEGORY = 'plugin';
        $PRODUCT_DESCRIPTION = 'Advanced Videos - Pages, Businesses, Groups, Multiple Listing Types, Events, Stores, etc Extension';
        $PRODUCT_TITLE = 'Advanced Videos - Pages, Businesses, Groups, Multiple Listing Types, Events, Stores, etc Extension';
        $_PRODUCT_FINAL_FILE = 0;
        $SocialEngineAddOns_version = '4.8.11';
        $file_path = APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/ilicense.php";
        $is_file = file_exists($file_path);
        if (empty($is_file)) {
            include APPLICATION_PATH . "/application/modules/Sitevideo/controllers/license/license3.php";
        } else {
            $db = $this->getDb();
            $select = new Zend_Db_Select($db);
            $select->from('engine4_core_modules')->where('name = ?', $PRODUCT_TYPE);
            $is_Mod = $select->query()->fetchObject();
            if (empty($is_Mod)) {
                include_once $file_path;
            }
        }

        parent::onPreinstall();
    }

    public function onInstall() {
        $db = $this->getDb();
        $db->query("UPDATE  `engine4_seaocores` SET  `is_activate` =  '1' WHERE  `engine4_seaocores`.`module_name` ='sitevideointegration';");
        $db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `order`) VALUES ("sitevideo_admin_main_modules", "sitevideointegration", "Integration of Content Modules", "", \'{"route":"admin_default","module":"sitevideointegration","controller":"modules"}\', "sitevideo_admin_main", "", 15),
("sitevideo_admin_main_import", "sitevideointegration", "Import", "", \'{"route":"admin_default","module":"sitevideointegration","controller":"importvideo"}\', "sitevideo_admin_main", "", 16)');
        $this->setManageModules();
        parent::onInstall();
    }

    public function setManageModules() {
        $db = $this->getDb();
        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_settings')
                ->where('name = ?', 'sitepage.isActivate')
                ->where('value = ?', 1);
        $sitepage_isActivate_object = $select->query()->fetchObject();
        if ($sitepage_isActivate_object) {
            $db->query("INSERT IGNORE INTO `engine4_sitevideo_modules` (`item_type`, `item_id`, `item_module`, `enabled`, `integrated`, `item_title`, `item_membertype`) VALUES ('sitepage_page', 'page_id', 'sitepage', '0', '0', 'Page Videos', 'a:3:{i:0;s:14:\"contentmembers\";i:1;s:18:\"contentlikemembers\";i:2;s:20:\"contentfollowmembers\";}')");
            $db->query('INSERT IGNORE INTO `engine4_core_menuitems` ( `name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES("sitepage_admin_main_managevideo", "sitevideo", "Manage Videos", "", \'{"uri":"admin/sitevideo/manage-video/index/contentType/sitepage_page/contentModule/sitepage"}\', "sitepage_admin_main", "", 0, 0, 24);');
            $db->query('INSERT IGNORE INTO `engine4_core_settings` ( `name`, `value`) VALUES( "sitevideo.video.leader.owner.sitepage.page", "1");');

            //ENTER THE MEMBER LEVEL SETTING FOR THE VIDEO CREATION OPTIONS IN PAGE PLUGIN
            $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
              SELECT
                level_id as `level_id`,
                'sitepage_page' as `type`,
                'svcreate' as `name`,
                1 as `value`,
                NULL as `params`
              FROM `engine4_authorization_levels` WHERE `type` NOT IN('public');
            ");

            $select = new Zend_Db_Select($db);
            $select
                    ->from('engine4_core_settings')
                    ->where('name = ?', 'sitepagemember.isActivate')
                    ->where('value = ?', 1);
            $sitepagemember_isActivate_object = $select->query()->fetchObject();
            if($sitepagemember_isActivate_object) {
                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
                  SELECT
                    level_id as `level_id`,
                    'sitepage_page' as `type`,
                    'auth_svcreate' as `name`,
                    5 as `value`,
                    '[\"registered\",\"owner_network\",\"owner_member_member\", \"owner_member\", \"member\", \"like_member\", \"owner\"]' as `params`
                  FROM `engine4_authorization_levels` WHERE `type` NOT IN('public');
                ");
            } else {
                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
                  SELECT
                    level_id as `level_id`,
                    'sitepage_page' as `type`,
                    'auth_svcreate' as `name`,
                    5 as `value`,
                    '[\"registered\",\"owner_network\",\"owner_member_member\", \"owner_member\", \"like_member\", \"owner\"]' as `params`
                  FROM `engine4_authorization_levels` WHERE `type` NOT IN('public');
                ");
            }
        }

        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_settings')
                ->where('name = ?', 'sitebusiness.isActivate')
                ->where('value = ?', 1);
        $sitebusiness_isActivate_object = $select->query()->fetchObject();
        if ($sitebusiness_isActivate_object) {
            $db->query("INSERT IGNORE INTO `engine4_sitevideo_modules` (`item_type`, `item_id`, `item_module`, `enabled`, `integrated`, `item_title`, `item_membertype`) VALUES ('sitebusiness_business', 'business_id', 'sitebusiness', '0', '0', 'Business Videos', 'a:3:{i:0;s:14:\"contentmembers\";i:1;s:18:\"contentlikemembers\";i:2;s:20:\"contentfollowmembers\";}')");
            $db->query('INSERT IGNORE INTO `engine4_core_menuitems` ( `name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES("sitebusiness_admin_main_managevideo", "sitevideo", "Manage Videos", "", \'{"uri":"admin/sitevideo/manage-video/index/contentType/sitebusiness_business/contentModule/sitebusiness"}\', "sitebusiness_admin_main", "", 0, 0, 24);');
            $db->query('INSERT IGNORE INTO `engine4_core_settings` ( `name`, `value`) VALUES( "sitevideo.video.leader.owner.sitebusiness.business", "1");');

            //ENTER THE MEMBER LEVEL SETTING FOR THE VIDEO CREATION OPTIONS IN BUSINESS PLUGIN
            $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
              SELECT
                level_id as `level_id`,
                'sitebusiness_business' as `type`,
                'svcreate' as `name`,
                1 as `value`,
                NULL as `params`
              FROM `engine4_authorization_levels` WHERE `type` NOT IN('public');
            ");

            $select = new Zend_Db_Select($db);
            $select
                    ->from('engine4_core_settings')
                    ->where('name = ?', 'sitebusinessmember.isActivate')
                    ->where('value = ?', 1);
            $sitebusinessmember_isActivate_object = $select->query()->fetchObject();
            if($sitebusinessmember_isActivate_object) {
                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
                  SELECT
                    level_id as `level_id`,
                    'sitebusiness_business' as `type`,
                    'auth_svcreate' as `name`,
                    5 as `value`,
                    '[\"registered\",\"owner_network\",\"owner_member_member\", \"owner_member\", \"member\", \"like_member\", \"owner\"]' as `params`
                  FROM `engine4_authorization_levels` WHERE `type` NOT IN('public');
                ");
            } else {
                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
                  SELECT
                    level_id as `level_id`,
                    'sitebusiness_business' as `type`,
                    'auth_svcreate' as `name`,
                    5 as `value`,
                    '[\"registered\",\"owner_network\",\"owner_member_member\", \"owner_member\", \"like_member\", \"owner\"]' as `params`
                  FROM `engine4_authorization_levels` WHERE `type` NOT IN('public');
                ");
            }
        }

        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_settings')
                ->where('name = ?', 'sitegroup.isActivate')
                ->where('value = ?', 1);
        $sitegroup_isActivate_object = $select->query()->fetchObject();
        if ($sitegroup_isActivate_object) {
            $db->query("INSERT IGNORE INTO `engine4_sitevideo_modules` (`item_type`, `item_id`, `item_module`, `enabled`, `integrated`, `item_title`, `item_membertype`) VALUES ('sitegroup_group', 'group_id', 'sitegroup', '0', '0', 'Group Videos', 'a:3:{i:0;s:14:\"contentmembers\";i:1;s:18:\"contentlikemembers\";i:2;s:20:\"contentfollowmembers\";}')");
            $db->query('INSERT IGNORE INTO `engine4_core_menuitems` ( `name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES("sitegroup_admin_main_managevideo", "sitevideo", "Manage Videos", "", \'{"uri":"admin/sitevideo/manage-video/index/contentType/sitegroup_group/contentModule/sitegroup"}\', "sitegroup_admin_main", "", 0, 0, 24);');
            $db->query('INSERT IGNORE INTO `engine4_core_settings` ( `name`, `value`) VALUES( "sitevideo.video.leader.owner.sitegroup.group", "1");');

            //ENTER THE MEMBER LEVEL SETTING FOR THE VIDEO CREATION OPTIONS IN GROUP PLUGIN
            $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
              SELECT
                level_id as `level_id`,
                'sitegroup_group' as `type`,
                'svcreate' as `name`,
                1 as `value`,
                NULL as `params`
              FROM `engine4_authorization_levels` WHERE `type` NOT IN('public');
            ");

            $select = new Zend_Db_Select($db);
            $select
                    ->from('engine4_core_settings')
                    ->where('name = ?', 'sitegroupmember.isActivate')
                    ->where('value = ?', 1);
            $sitegroupmember_isActivate_object = $select->query()->fetchObject();
            if($sitegroupmember_isActivate_object) {
                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
                  SELECT
                    level_id as `level_id`,
                    'sitegroup_group' as `type`,
                    'auth_svcreate' as `name`,
                    5 as `value`,
                    '[\"registered\",\"owner_network\",\"owner_member_member\", \"owner_member\", \"member\", \"like_member\", \"owner\"]' as `params`
                  FROM `engine4_authorization_levels` WHERE `type` NOT IN('public');
                ");
            } else {
                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
                  SELECT
                    level_id as `level_id`,
                    'sitegroup_group' as `type`,
                    'auth_svcreate' as `name`,
                    5 as `value`,
                    '[\"registered\",\"owner_network\",\"owner_member_member\", \"owner_member\", \"like_member\", \"owner\"]' as `params`
                  FROM `engine4_authorization_levels` WHERE `type` NOT IN('public');
                ");
            }
        }

        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_settings')
                ->where('name = ?', 'sitestore.isActivate')
                ->where('value = ?', 1);
        $sitestore_isActivate_object = $select->query()->fetchObject();
        if ($sitestore_isActivate_object) {
            $db->query("INSERT IGNORE INTO `engine4_sitevideo_modules` (`item_type`, `item_id`, `item_module`, `enabled`, `integrated`, `item_title`, `item_membertype`) VALUES ('sitestore_store', 'store_id', 'sitestore', '0', '0', 'Store Videos', 'a:3:{i:0;s:14:\"contentmembers\";i:1;s:18:\"contentlikemembers\";i:2;s:20:\"contentfollowmembers\";}')");
            $db->query('INSERT IGNORE INTO `engine4_core_menuitems` ( `name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES("sitestore_admin_main_managevideo", "sitevideo", "Manage Videos", "", \'{"uri":"admin/sitevideo/manage-video/index/contentType/sitestore_store/contentModule/sitestore"}\', "sitestore_admin_main", "", 0, 0, 24);');
            $db->query('INSERT IGNORE INTO `engine4_core_settings` ( `name`, `value`) VALUES( "sitevideo.video.leader.owner.sitestore.store", "1");');

            $db->query("UPDATE `engine4_core_menuitems` SET `enabled` = '0' WHERE `engine4_core_menuitems`.`name` = 'sitestore_admin_main_sitestorevideo'");


            // ADVANCED VIDEO INTEGRATION WORK FOR STORE PRODUCTS
            $db->query("INSERT IGNORE INTO `engine4_sitevideo_modules` (`item_type`, `item_id`, `item_module`, `enabled`, `integrated`, `item_title`, `item_membertype`) VALUES ('sitestoreproduct_product', 'product_id', 'sitestoreproduct', '0', '0', 'Store Product Videos', 'a:3:{i:0;s:14:\"contentmembers\";i:1;s:18:\"contentlikemembers\";i:2;s:20:\"contentfollowmembers\";}')");
            $db->query('INSERT IGNORE INTO `engine4_core_menuitems` ( `name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES("sitestoreproduct_admin_main_managevideo", "sitevideointegration", "Manage Product Videos", "", \'{"uri":"admin/sitevideo/manage-video/index/contentType/sitestoreproduct_product/contentModule/sitestoreproduct"}\', "sitestore_admin_main", "", 0, 0, 25);');
            $db->query('INSERT IGNORE INTO `engine4_core_settings` ( `name`, `value`) VALUES( "sitevideo.video.leader.owner.sitestoreproduct.product", "1");');
        }

        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_settings')
                ->where('name = ?', 'siteevent.isActivate')
                ->where('value = ?', 1);
        $siteevent_isActivate_object = $select->query()->fetchObject();
        if ($siteevent_isActivate_object) {

            $db->query("INSERT IGNORE INTO `engine4_sitevideo_modules` (`item_type`, `item_id`, `item_module`, `enabled`, `integrated`, `item_title`, `item_membertype`) VALUES ('siteevent_event', 'event_id', 'siteevent', '0', '0', 'Events Videos', 'a:3:{i:0;s:14:\"contentmembers\";i:1;s:18:\"contentlikemembers\";i:2;s:20:\"contentfollowmembers\";}')");
            $db->query('INSERT IGNORE INTO `engine4_core_menuitems` ( `name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES("siteevent_admin_main_managevideo", "sitevideointegration", "Manage Videos", "", \'{"uri":"admin/sitevideo/manage-video/index/contentType/siteevent_event/contentModule/siteevent"}\', "siteevent_admin_main", "", 0, 0, 45);');
            $db->query('INSERT IGNORE INTO `engine4_core_settings` ( `name`, `value`) VALUES( "sitevideo.video.leader.owner.siteevent.event", "1");');

            $db->query("UPDATE `engine4_core_menuitems` SET `enabled` = '0' WHERE `engine4_core_menuitems`.`name` = 'siteevent_admin_main_video'");

            //ENTER THE MEMBER LEVEL SETTING FOR THE VIDEO CREATION OPTIONS IN THE EVENT PLUGIN
            $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
              SELECT
                level_id as `level_id`,
                'siteevent_event' as `type`,
                'video' as `name`,
                1 as `value`,
                NULL as `params`
              FROM `engine4_authorization_levels` WHERE `type` NOT IN('public');
            ");
            $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
              SELECT
                level_id as `level_id`,
                'siteevent_event' as `type`,
                'auth_video' as `name`,
                5 as `value`,
                '[\"registered\",\"owner_network\",\"owner_member_member\", \"owner_member\", \"member\", \"leader\"]' as `params`
              FROM `engine4_authorization_levels` WHERE `type` NOT IN('public');
            ");
        }
        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_modules')
                ->where('name = ?', 'sitereview')
                ->where('enabled = ?', 1);
        $is_sitereview_object = $select->query()->fetchObject();
        if (!empty($is_sitereview_object)) {

            $table_listingtype_exist = $db->query('SHOW TABLES LIKE \'engine4_sitereview_listingtypes\'')->fetch();
            if (!empty($table_listingtype_exist)) {
                $select = new Zend_Db_Select($db);
                $listingtypeObject = $select
                        ->from('engine4_sitereview_listingtypes', array('listingtype_id', 'title_singular'))
                        ->query()
                        ->fetchAll();
                foreach ($listingtypeObject as $values) {
                    $listingtype_id = $values['listingtype_id'];
                    $singular_title = ucfirst($values['title_singular']);
                    $db->query("INSERT IGNORE INTO `engine4_sitevideo_modules` (`item_type`, `item_id`, `item_module`, `enabled`, `integrated`, `item_title`, `item_membertype`) VALUES ('sitereview_listing_$listingtype_id', 'listing_id', 'sitereview', '0', '0', '$singular_title Videos', 'a:1:{i:0;s:18:\"contentlikemembers\";}')");
                    $db->query('INSERT IGNORE INTO `engine4_core_settings` ( `name`, `value`) VALUES( "sitevideo.video.leader.owner.sitereview.listing.' . $listingtype_id . '", "1");');
                }

                $db->query('INSERT IGNORE INTO `engine4_core_menuitems` ( `name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES("sitereview_admin_main_managevideo", "sitevideointegration", "Manage Videos", "", \'{"uri":"admin/sitevideo/manage-video/index/contentType/sitereview_listing_1/contentModule/sitereview"}\', "sitereview_admin_main", "", 0, 0, 55);');

                $db->query("UPDATE `engine4_core_menuitems` SET `enabled` = '0' WHERE `engine4_core_menuitems`.`name` = 'sitereview_admin_main_video'");
            }
        }
        
        $select = new Zend_Db_Select($db);
        $select->from('engine4_core_settings')
                ->where('name = ?', 'sitecrowdfunding.isActivate')
                ->where('value = ?', 1);
        $sitecrowdfunding_isActivate_object = $select->query()->fetchObject();
        if ($sitecrowdfunding_isActivate_object) {
            $db->query("INSERT IGNORE INTO engine4_sitevideo_modules(`item_type`, `item_id`, `item_module`, `item_title`, `enabled`, `integrated`) VALUES ('sitecrowdfunding_project', 'project_id', 'sitecrowdfunding', 'Project Videos', 0, 0);");
            $db->query('INSERT IGNORE INTO `engine4_core_menuitems` ( `name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES("sitecrowdfunding_admin_main_managevideo", "sitevideointegration", "Manage Videos", "", \'{"uri":"admin/sitevideo/manage-video/index/contentType/sitecrowdfunding_project/contentModule/sitecrowdfunding"}\', "sitecrowdfunding_admin_main", "", 0, 0, 19);');
            $db->query('INSERT IGNORE INTO `engine4_core_settings` ( `name`, `value`) VALUES( "sitevideo.video.leader.owner.sitecrowdfunding.project", "1");');
        }
}

    private function getVersion() {
        $db = $this->getDb();

        $errorMsg = '';
        $finalModules = $getResultArray = array();
        $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();

        $modArray = array(
            'sitebusiness' => '4.8.10p3',
            'siteevent' => '4.8.10p3',
            'sitegroup' => '4.8.10p2',
            'sitepage' => '4.8.10p2',
            'sitereview' => '4.8.10p5',
            'sitestore' => '4.8.10p3',
        );

        foreach ($modArray as $key => $value) {
            $isMod = $db->query("SELECT * FROM  `engine4_core_modules` WHERE  `name` LIKE  '" . $key . "'")->fetch();
            if (!empty($isMod) && !empty($isMod['version'])) {
                $isModSupport = $this->checkVersion($isMod['version'], $value);
                if (empty($isModSupport)) {
                    $finalModules['modName'] = $key;
                    $finalModules['title'] = $isMod['title'];
                    $finalModules['versionRequired'] = $value;
                    $finalModules['versionUse'] = $isMod['version'];
                    $getResultArray[] = $finalModules;
                }
            }
        }

        foreach ($getResultArray as $modArray) {
            $errorMsg .= '<div class="tip"><span>Note: Your website does not have the latest version of "' . $modArray['title'] . '". Please upgrade "' . $modArray['title'] . '" on your website to the latest version available in your SocialEngineAddOns Client Area to enable its integration with "Advanced Videos - Pages, Businesses, Groups, Multiple Listing Types, Events, Stores, etc Extension".<br/> Please <a href="' . $base_url . '/manage">Click here</a> to go Manage Packages.</span></div>';
        }

        return $errorMsg;
    }

    function checkVersion($databaseVersion, $checkDependancyVersion) {
        if (strcasecmp($databaseVersion, $checkDependancyVersion) == 0)
            return -1;
        $databaseVersionArr = explode(".", $databaseVersion);
        $checkDependancyVersionArr = explode('.', $checkDependancyVersion);
        $fValueCount = $count = count($databaseVersionArr);
        $sValueCount = count($checkDependancyVersionArr);
        if ($fValueCount > $sValueCount)
            $count = $sValueCount;
        for ($i = 0; $i < $count; $i++) {
            $fValue = $databaseVersionArr[$i];
            $sValue = $checkDependancyVersionArr[$i];
            if (is_numeric($fValue) && is_numeric($sValue)) {
                $result = $this->compareValues($fValue, $sValue);
                if ($result == -1) {
                    if (($i + 1) == $count) {
                        return $this->compareValues($fValueCount, $sValueCount);
                    } else
                        continue;
                }
                return $result;
            }
            elseif (is_string($fValue) && is_numeric($sValue)) {
                $fsArr = explode("p", $fValue);
                $result = $this->compareValues($fsArr[0], $sValue);
                return $result == -1 ? 1 : $result;
            } elseif (is_numeric($fValue) && is_string($sValue)) {
                $ssArr = explode("p", $sValue);
                $result = $this->compareValues($fValue, $ssArr[0]);
                return $result == -1 ? 0 : $result;
            } elseif (is_string($fValue) && is_string($sValue)) {
                $fsArr = explode("p", $fValue);
                $ssArr = explode("p", $sValue);
                $result = $this->compareValues($fsArr[0], $ssArr[0]);
                if ($result != -1)
                    return $result;
                $result = $this->compareValues($fsArr[1], $ssArr[1]);
                return $result;
            }
        }
    }

    public function compareValues($firstVal, $secondVal) {
        $num = $firstVal - $secondVal;
        return ($num > 0) ? 1 : ($num < 0 ? 0 : -1);
    }

}
