<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitevod
 * @copyright  Copyright 2018-2019 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: 4.10.3 2018-09-08 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitevod_Plugin_Job_SourceRemove extends Core_Plugin_Job_Abstract
{

  protected function _execute()
  {
    // Get job and params
    $job = $this->getJob();

    // No video id?
    if( !($stream_id = $this->getParam('stream_id')) ) {
      $this->_setState('failed', 'No file identity provided.');
      $this->_setWasIdle();
      return;
    }

    // Get video object
    $stream = Engine_Api::_()->getDbtable('stream', 'sitevod')->fetchRow(array(
      'stream_id = ?' => $stream_id
    ));
    if( !$stream || !($stream instanceof Sitevod_Model_Stream) ) {
      $this->_setState('failed', 'Stream is missing.');
      $this->_setWasIdle();
      return;
    }

    // Process
    try {
      $this->_process($stream);
      $this->_setIsComplete(true);
    } catch( Exception $e ) {
      $this->_setState('failed', 'Exception: ' . $e->getMessage());
    }
  }


  protected function _process($stream)
  {
    $service = Engine_Api::_()->sitevod()->getAwsSourceStreamService();
    $service->removeFile($stream->file_name);
  }

}