<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitevod
 * @copyright  Copyright 2018-2019 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: 4.10.3 2018-09-08 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitevod_Plugin_Job_Upload extends Core_Plugin_Job_Abstract
{

  protected function _execute()
  {
    // Get job and params
    $job = $this->getJob();

    // No video id?
    if( !($stream_id = $this->getParam('stream_id')) ) {
      $this->_setState('failed', 'No file identity provided.');
      $this->_setWasIdle();
      return;
    }

    // Get video object
    $stream = Engine_Api::_()->getDbtable('stream', 'sitevod')->fetchRow(array(
      'stream_id = ?' => $stream_id
    ));
    if( !$stream || !($stream instanceof Sitevod_Model_Stream) ) {
      $this->_setState('failed', 'Stream is missing.');
      $this->_setWasIdle();
      return;
    }

    // Check video status
    if( Sitevod_Api_Core::STREAM_INITIAL_STATUS != $stream->status ) {
      $this->_setState('failed', 'Stream has already been uploaded, or has already failed uplaoded.');
      $this->_setWasIdle();
      return;
    }

    // Process
    try {
      $this->_process($stream);
      $this->_setIsComplete(true);
    } catch( Exception $e ) {
      $this->_setState('failed', 'Exception: ' . $e->getMessage());
    }
  }

  private function getStorageObject($file_id)
  {
    // Pull video from storage system for encoding
    return Engine_Api::_()->getItem('storage_file', $file_id);

    if( !$storageObject ) {
      throw new Video_Model_Exception('Video storage file was missing');
    }

    return $storageObject;
  }

  protected function _process($stream)
  {
    $storageFile = $this->getStorageObject($stream->file_id);
    $service = Engine_Api::_()->sitevod()->getAwsSourceStreamService();
    $stream->file_name = $service->getFilePath($storageFile);
    $stream->save();
    $storageFile->move($service);
    $stream->status = Sitevod_Api_Core::STREAM_UPLOADED_STATUS;
    $stream->save();
  }

}