<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Spectacular
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 2015-06-04 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Spectacular_Plugin_Core extends Zend_Controller_Plugin_Abstract {

    public function onRenderLayoutDefault($event) {

        $view = $event->getPayload();
        $view->headTranslate(array("Forgot Password?", "Login with Twitter", "Login with Facebook", "Mark as Read", "Mark as Unread"));
        $view->headLink()->appendStylesheet('https://fonts.googleapis.com/css?family=Roboto')
                ->appendStylesheet('https://fonts.googleapis.com/css?family=Source+Sans+Pro');
        $view->headLink()->appendStylesheet($view->layout()->staticBaseUrl . 'application/modules/Spectacular/externals/styles/style.css');


        $themeTable = Engine_Api::_()->getDbtable('themes', 'core');
        $active = $themeTable->select()
                ->from($themeTable->info('name'), 'active')
                ->where('name = ?', 'spectacular')
                ->where('active = ?', 1)
                ->query()
                ->fetchColumn()
        ;
        if ($active) {

            $includeThemeBasedClass = <<<EOF
            en4.core.runonce.add(function(){
                if(($$('.layout_siteusercoverphoto_user_cover_photo').length > 0) || ($$('.layout_sitecontentcoverphoto_content_cover_photo').length > 0) || ($$('.layout_spectacular_banner_images').length > 0)) {
                   if ($$('.layout_main')) {
                       $$('.layout_main').setStyles({                                                                'width' : '1200px',                                                                          'margin' : '0 auto'                                                                        });
                   }
                }   
            });
            window.addEvent('scroll', function () {
                if ($$(".layout_page_header").length > 0)
                {
                    var scrollTop = document.body.scrollTop ? document.body.scrollTop : document.documentElement.scrollTop; 
                    if (scrollTop > 0) {
                        $$(".layout_page_header").addClass("spectacular_fix_header");
                    } else {
                        $$(".layout_page_header").removeClass("spectacular_fix_header");
                    }
                }
            }); 
EOF;
            $view->headScript()->appendScript($includeThemeBasedClass);
        }
    }

    public function onRenderLayoutDefaultSimple($event) {
        // Forward
        return $this->onRenderLayoutDefault($event, 'simple');
    }

}
