<?php


/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Twitterclone
 * @copyright  Copyright 2015-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Layout.php 2018-04-05 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Twitterclone_Form_Admin_Settings_Landingpage_Landing extends Engine_Form
{

  public function init()
  {
    $description = sprintf(Zend_Registry::get('Zend_Translate')->_("Here you can manage Right Layout of Landing Page.<a title='Preview - Text Banner' href='application/modules/Twitterclone/externals/images/screenshots/right.png' target='_blank' class='twitterclone_icon_view' > </a>"));
    $this->setTitle("Manage Right Layout of Landing Page");
    $this->setDescription("$description");
  
    $this->loadDefaultDecorators();
    $this->getDecorator('Description')->setOption('escape', false);

    $coreSettings = Engine_Api::_()->getApi('settings', 'core');
    $this->setAttrib('id', 'form-upload');

    // Get available files
    $logoOptions = Engine_Api::_()->twitterclone()->getImages(array('application/modules/Twitterclone/externals/images/twitter_logo.png' => 'Default logo','' => "Text-only (No logo)"));
    $backgroundOptions = Engine_Api::_()->twitterclone()->getImages(array('' => 'Default Image'));

    $this->addElement('Select', 'twitterclone_landing_slider_logo', array(
      'label' => 'Select Logo',
      'description' => 'Select the logo for your website. [Note: You can upload logo from: "Appearance" > "File & Media Manager".]',
      'value' => $coreSettings->getSetting('twitterclone.landing.slider.logo', 'application/modules/Twitterclone/externals/images/twitter_logo.png'),
      'multiOptions' => $logoOptions,
    ));

    $this->addElement('Text', 'twitterclone_landing_slider_description1', array(
      'label' => 'Main Tagline on Landing Page',
      'description' => 'Enter the main tagline text that you want to display on the landing page.',
      // 'style' => 'width:350px;',
      'value' => $coreSettings->getSetting("twitterclone.landing.slider.description1", "Find what's taking place across the globe"),
    ));

    $this->addElement('Text', 'twitterclone_landing_button_description1', array(
      'label' => 'Sub Tagline on Landing Page',
      'description' => 'Enter the sub tagline text that you want to display on the landing page.',
      // 'style' => 'width:350px;',
      'value' => $coreSettings->getSetting('twitterclone.landing.button.description1', 'Begin this journey today'),
    ));

    $this->addElement('Select', 'twitterclone_landing_background', array(
      'label' => 'Select Background Image',
      'description' => 'Select the background image for your website landing page. [Note: You can upload the image from: "Appearance" > "File & Media Manager".]',
      'value' => $coreSettings->getSetting('twitterclone.landing.background', ''),
      'multiOptions' => $backgroundOptions,
    ));

    $this->addElement('Button', 'submit', array(
      'label' => 'Save Changes',
      'type' => 'submit',
      'decorators' => array(
        'ViewHelper',
      ),
    ));
  }

}
?>
