<?php


/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Twitterclone
 * @copyright  Copyright 2015-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Layout.php 2018-04-05 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Twitterclone_Form_Admin_Settings_Landingpage_TextBanner extends Engine_Form
{

  public function init()
  {

    $description = sprintf(Zend_Registry::get('Zend_Translate')->_("Here you can manage various settings for the taglines displaying on Left Layout of Landing Page. <a title='Preview - Text Banner' href='application/modules/Twitterclone/externals/images/screenshots/left.png' target='_blank' class='twitterclone_icon_view' > </a>"));

    $this->setTitle("Manage Left Layout of Landing Page");
    $this->setDescription("$description");
    $this->loadDefaultDecorators();
    $this->getDecorator('Description')->setOption('escape', false);
    $coreSettings = Engine_Api::_()->getApi('settings', 'core');
    $this->setAttrib('id', 'form-upload');

    // Get available files
    $iconOptions = Engine_Api::_()->twitterclone()->getImages(array('' => 'Default icon'));
     

      $this->addElement('Select', 'twitterclone_landing_first_icon', array(
        'label' => 'Select 1st Icon',
        'description' => 'Select the icon for first tagline. [Note: You can upload icon from: "Appearance" > "File & Media Manager".]',
        'value' => $coreSettings->getSetting('twitterclone.landing.first.icon', ''),
        'multiOptions' => $iconOptions,
      ));

      $this->addElement('Text', 'twitterclone_landing_first_text', array(
        'label' => '1st Tagline Text',
        'value' => $coreSettings->getSetting('twitterclone.landing.first.text', "Let's connect with the world"),
      ));

      $this->addElement('Select', 'twitterclone_landing_second_icon', array(
        'label' => 'Select 2nd Icon',
        'description' => 'Select the icon for second tagline. [Note: You can upload icon from: "Appearance" > "File & Media Manager".]',
        'value' => $coreSettings->getSetting('twitterclone.landing.second.icon', ''),
        'multiOptions' => $iconOptions,
      ));

      $this->addElement('Text', 'twitterclone_landing_second_text', array(
        'label' => '2nd Tagline Text',
        'value' => $coreSettings->getSetting('twitterclone.landing.second.text', 'Raise important social topics'),
      ));

      $this->addElement('Select', 'twitterclone_landing_third_icon', array(
        'label' => 'Select 3rd Icon',
        'description' => 'Select the icon for third tagline. [Note: You can upload icon from: "Appearance" > "File & Media Manager".]',
        'value' => $coreSettings->getSetting('twitterclone.landing.third.icon', ''),
        'multiOptions' => $iconOptions,
      ));

      $this->addElement('Text', 'twitterclone_landing_third_text', array(
        'label' => '3rd Tagline Text',
        'value' => $coreSettings->getSetting('twitterclone.landing.third.text', 'See what other people think'),
      ));
      $this->addElement('Button', 'submit', array(
        'label' => 'Save Changes',
        'type' => 'submit',
        'decorators' => array(
          'ViewHelper',
        ),
      ));
  }
}
?>

