<?php


/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Twitterclone
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminSettingsController.php 2015-06-04 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Twitterclone_AdminSettingsController extends Core_Controller_Action_Admin
{

  public function __call($method, $params)
  {
    /*
     * YOU MAY DISPLAY ANY ERROR MESSAGE USING FORM OBJECT.
     * YOU MAY EXECUTE ANY SCRIPT, WHICH YOU WANT TO EXECUTE ON FORM SUBMIT.
     * REMEMBER:
     *    RETURN TRUE: IF YOU DO NOT WANT TO STOP EXECUTION.
     *    RETURN FALSE: IF YOU WANT TO STOP EXECUTION.
     */

    if( !empty($method) && $method == 'Twitterclone_Form_Admin_Settings' ) {
      
    }
    return true;
  }

  public function configurePagesAction() {
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('twitterclone_admin_main', array(), 'twitterclone_admin_configure_pages');

     
    $this->view->form = $form = new Twitterclone_Form_Admin_Settings_Configure();

    if( $this->getRequest()->isPost() && $form->isValid($this->_getAllParams()) ) {
      $values = $form->getValues();
      
      foreach( $values as $key => $value ) {
        Engine_Api::_()->getApi('settings', 'core')->setSetting($key, $value);
      }
      $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
      $URL = $view->baseUrl() . '/admin/content';

      if ($values['twitterclone_landing_page_layout']) {
        Engine_Api::_()->getApi('pagelayouts', 'twitterclone')->setDefaultLayout($values);
      } else {
        Engine_Api::_()->getApi('pagelayouts', 'twitterclone')->restorePageBackup(array('pageUrl' => 'landing_page_backup', 'name' => 'core_index_index'));
      }

      if ($values['twitterclone_header_page_layout']) {
        Engine_Api::_()->getApi('pagelayouts', 'twitterclone')->setHeaderLayout($values);
      } else {
        Engine_Api::_()->getApi('pagelayouts', 'twitterclone')->restorePageBackup(array('pageUrl' => 'header_backup', 'name' => 'header'));
      }

      if ($values['twitterclone_footer_page_layout']) {
        Engine_Api::_()->getApi('pagelayouts', 'twitterclone')->setFooterLayout($values);
      } else {
        Engine_Api::_()->getApi('pagelayouts', 'twitterclone')->restorePageBackup(array('pageUrl' => 'footer_backup', 'name' => 'footer'));
      }

      if ($values['twitterclone_login_page_layout']) {
        Engine_Api::_()->getApi('pagelayouts', 'twitterclone')->setSignInPageLayout($values);
      } else {
        Engine_Api::_()->getApi('pagelayouts', 'twitterclone')->restorePageBackup(array('pageUrl' => 'user_auth_login_backup', 'name' => 'user_auth_login'));
      }

      if ($values['twitterclone_login_required_page_layout']) {
        Engine_Api::_()->getApi('pagelayouts', 'twitterclone')->setSignInRequiredPageLayout($values);
      } else {
        Engine_Api::_()->getApi('pagelayouts', 'twitterclone')->restorePageBackup(array('pageUrl' => 'core_error_requireuser_backup', 'name' => 'core_error_requireuser'));
      }
      
      if ($values['twitterclone_signup_page_layout']) {
        Engine_Api::_()->getApi('pagelayouts', 'twitterclone')->setSignUpPageLayout($values);
      } else {
        Engine_Api::_()->getApi('pagelayouts', 'twitterclone')->restorePageBackup(array('pageUrl' => 'user_signup_index_backup', 'name' => 'user_signup_index'));
      }
      $form->addNotice('Your changes have been saved. Please check your pages layout from <a href="' . $URL . '" target="_blank">here</a>.');
    }
  }

  public function activateAction() {
    //CHANGE LAYOUT OF HEADER,FOOTER,SIGNIN,SIGNUP AND LANDING PAGE
    Engine_Api::_()->getApi('pagelayouts', 'twitterclone')->setDefaultLayout(array('twitterclone_landing_page_layout' => 1));
    Engine_Api::_()->getApi('pagelayouts', 'twitterclone')->setHeaderLayout(array('twitterclone_header_page_layout' => 1));
    Engine_Api::_()->getApi('pagelayouts', 'twitterclone')->setFooterLayout(array('twitterclone_footer_page_layout' => 1));
    Engine_Api::_()->getApi('pagelayouts', 'twitterclone')->setSignInPageLayout(array('twitterclone_login_page_layout' => 1));
    Engine_Api::_()->getApi('pagelayouts', 'twitterclone')->setSignInRequiredPageLayout(array('twitterclone_login_required_page_layout' => 1));
    Engine_Api::_()->getApi('pagelayouts', 'twitterclone')->setSignUpPageLayout(array('twitterclone_signup_page_layout' => 1));

    $redirect = $this->_getParam('redirect', false);
    if( $redirect == 'install' ) {
      $this->_redirect('install/manage');
    } elseif( $redirect == 'query' ) {
      $this->_redirect('install/manage/complete');
    }
  }

  public function setOrderAction()
  {
    if( empty($_POST) || empty($_POST['order']) ) {
      return;
    }

    $item = $_POST['item'];
    foreach( $_POST['order'] as $key => $value ) {
      if( strstr($key, "content_") ) {
        $keyArray = explode("content_", $key);
        $itemId = end($keyArray);

        if( !empty($itemId) ) {
          $obj = Engine_Api::_()->getItem($item, $itemId);
          print_r($obj->toArray());
          $obj->order = $value;
          $obj->save();
        }
      }
    }
  }


  public function faqAction()
  {
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('twitterclone_admin_main', array(), 'twitterclone_admin_settings_faq');
    $this->view->faq_id = $faq_id = $this->_getParam('faq', 'faq_1');
  }

  public function footerMenuAction()
  {
    $this->_redirect('admin/menus/index?name=twitterclone_footer');
  }

  public function placeHtaccessFileAction()
  {
    if( $this->getRequest()->isPost() ) {
      $successfullyAdded = false;
      $getFileContent = '<FilesMatch ".(ttf|otf|woff)$">
    Header set Access-Control-Allow-Origin "*"
</FilesMatch>';

      $global_directory_name = APPLICATION_PATH . '/application/themes/twitterclone';
      $global_settings_file = $global_directory_name . '/.htaccess';
      $is_file_exist = @file_exists($global_settings_file);

      // IF FILE NOT EXIST THEN CREATE NEW .HTACCESS FILE THERE.
      if( empty($is_file_exist) ) {
        if( is_dir($global_directory_name) ) {
          @mkdir($global_directory_name, 0777);

          $fh = @fopen($global_settings_file, 'w') or die('Unable to create .htaccess file; please give the CHMOD 777 recursive permission to the directory "' . APPLICATION_PATH . '/application/themes/twitterclone' . '" and then try again.');
          @fwrite($fh, $getFileContent);
          @fclose($fh);

          @chmod($global_settings_file, 0777);
          $successfullyAdded = true;
        }
      } else {
        if( !is_writable($global_settings_file) ) {
          @chmod($global_settings_file, 0777);
          if( !is_writable($global_settings_file) ) {
            $form->addError('Unable to create .htaccess file; please give the CHMOD 777 recursive permission to the directory "' . APPLICATION_PATH . '/application/themes/twitterclone' . '" and then try again.');
            return;
          }
        }
        $successfullyAdded = @file_put_contents($global_settings_file, $getFileContent);
      }

      if( !empty($successfullyAdded) ) {
        $this->_forward('success', 'utility', 'core', array(
          'smoothboxClose' => 10,
          'parentRefresh' => 10,
          'messages' => array('File Succesfully Created.')
        ));
      }
    }
  }

  public function placeCustomizationFileAction()
  {
    if( $this->getRequest()->isPost() ) {
      $global_directory_name = APPLICATION_PATH . '/application/themes/twitterclone';
      @chmod($global_directory_name, 0777);

      if( !is_readable($global_directory_name) ) {
        $this->view->error_message = "<span style='color:red'>Note: You do not have readable permission on the path below, please give 'chmod 777 recursive permission' on it to continue with the installation process : <br /> 
Path Name: <b>" . $global_directory_name . "</b></span>";
        return;
      }

      $global_settings_file = $global_directory_name . '/customization.css';
      $is_file_exist = @file_exists($global_settings_file);
      if( empty($is_file_exist) ) {
        @chmod($global_directory_name, 0777);
        if( !is_writable($global_directory_name) ) {
          $this->view->error_message = "<span style='color:red'>Note: You do not have writable permission on the path below, please give 'chmod 777 recursive permission' on it to continue with the installation process : <br /> 
Path Name: " . $global_directory_name . "</span>";
          return;
        }

        $fh = @fopen($global_settings_file, 'w');
        @fwrite($fh, '/* ADD CUSTOM STYLE */');
        @fclose($fh);

        @chmod($global_settings_file, 0777);
      }

      $this->_forward('success', 'utility', 'core', array(
        'smoothboxClose' => 10,
        'parentRefresh' => 10,
        'messages' => array('File Succesfully Created.')
      ));
    }
  }


  public function customCssAction()
  {
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('twitterclone_admin_main', array(), 'twitterclone_admin_theme_customization');
    $this->view->subNavigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('twitterclone_admin_theme_customization', array(), 'twitterclone_admin_settings_custom_css');
    $filePath = APPLICATION_PATH . '/application/themes/twitterclone/customization.css';
    $isFileExist = @file_exists($filePath);

    $this->view->message = '';
    $this->view->sucess = false;

    if( empty($isFileExist) ) {
      $fh = @fopen($filePath, 'w') or die('Unable to write customization CSS file; please give the CHMOD 777 recursive permission to the directory /application/themes/twitterclone/, then try again.');
      @fclose($fh);
    } elseif( !is_writable($filePath) ) {
      @chmod($filePath, 0777);
      if( !is_writable($filePath) ) {
        $this->view->message = 'Unable to write customization CSS file; please give the CHMOD 777 recursive permission to the directory /application/themes/twitterclone/, then try again.';
        return;
      }
    }

    $this->view->fileContent = file_get_contents($filePath);

    // Check method/data
    if( !$this->getRequest()->isPost() ) {
      return;
    }

    if( !isset($_POST['twitterclone_custom_css']) ) {
      return;
    }

    if( @file_put_contents($filePath, $_POST['twitterclone_custom_css']) ) {
      @chmod($filePath, 0777);
      $this->view->message = 'Your changes have been saved.';
      $this->view->sucess = true;
    }
    $this->view->fileContent = $_POST['twitterclone_custom_css'];
  } 
}
