<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Phpfoximporter
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    PagesSitepagesCategories.php 2015-07-30 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Install_Import_Phpfox_PagesSitepageCategories extends Install_Import_Phpfox_Abstract {

    protected $_fromTable = '';
    protected $_toTable = '';
    protected $_fromWhere = array('type_id<>?' => 3);
    protected $_priority = 4001;
    protected $_warningMessage = array();

    protected function _initPre() {
        $this->_truncateTable($this->getToDb(), 'engine4_sitepage_profilemaps');
        $this->_fromTable = $this->getFromPrefix() . 'pages_category';
        $this->_toTable = 'engine4_sitepage_categories';
        $this->_warningMessage = array("key" => 'pagekit', 'value' => '<span style="font-weight:bolder;">Warning:</span>  Your PHPfox Pages Blogs, PHPfox Pages Music and PHPfox Pages Videos content are not migrated into SocialEngine PHP. You may ignore this warning or you can install<a target="_blank" href="http://www.socialengineaddons.com/socialengine-directory-pages-plugin" > Directory / Pages and Essential Extensions - Product Kit</a>  on your SocialEngine PHP site to fix this warning.  ');
    }

    protected function _translateRow(array $data, $key = null) {

        //RETURN FALSE IF USER NOT SELECTED "SOCIAL ENGINE ADDON DIRECTORY AND PAGES PLUGIN" TO INSERT DATA.
        if ($this->getParam('import_group_sepage', 1) == 1)
            return false;

        //MAKING CATEGORY ARRAY FOR INSERTION
        $newData = array();
        $newData['category_id'] = $data['category_id'];
        $newData['category_name'] = $this->getPharseLabel($data['name']);
        $newData['cat_order'] = $data['ordering'];
        //MAP COTEGORY WITH DEFAULT PROFILE TYPE
        $this->getToDb()->insert('engine4_sitepage_profilemaps', array(
            'category_id' => $data['category_id'],
            'profile_type' => 1
        ));
        return $newData;
    }

}

/*
 * CREATE TABLE IF NOT EXISTS `phpfox_pages_category` (
`category_id` mediumint(8) unsigned NOT NULL,
  `type_id` smallint(4) unsigned NOT NULL,
  `name` varchar(200) NOT NULL,
  `page_type` tinyint(1) NOT NULL DEFAULT '0',
  `is_active` tinyint(1) NOT NULL DEFAULT '1',
  `ordering` int(10) unsigned NOT NULL DEFAULT '0'
) ENGINE=InnoDB AUTO_INCREMENT=169 DEFAULT CHARSET=latin1;

 */

/*
 *CREATE TABLE IF NOT EXISTS `engine4_sitepage_categories` (
`category_id` int(11) unsigned NOT NULL,
  `category_name` varchar(128) COLLATE utf8_unicode_ci NOT NULL,
  `cat_order` int(2) NOT NULL DEFAULT '0',
  `cat_dependency` int(11) NOT NULL DEFAULT '0',
  `subcat_dependency` int(11) NOT NULL DEFAULT '0',
  `file_id` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB AUTO_INCREMENT=52 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

 */