<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Phpfoximporter
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    SitegroupClaims.php 2015-07-30 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Install_Import_Phpfox_SitegroupClaims extends Install_Import_Phpfox_Abstract {

    protected $_fromTable = '';
    protected $_toTable = '';
    protected $_warningMessage = array();

    protected function _initPre() {
        $this->_fromTable = $this->getFromPrefix() . 'pages_claim';
        $this->_toTable = 'engine4_sitegroup_claims';
        $this->_warningMessage = array("key" => 'groupkit', 'value' => '<span style="font-weight:bolder;">Warning:</span>  Your PHPfox Groups Blogs, PHPfox Groups Music and PHPfox Groups Videos content are not migrated into SocialEngine PHP. You may ignore this warning or you can install <a target="_blank" href="http://www.socialengineaddons.com/socialengine-groups-communities-plugin" >Groups - Product Kit </a> on your SocialEngine PHP site to fix this warning. ');
    }

    protected function _translateRow(array $data, $key = null) {

        //RETURN FALSE IF USER NOT SELECTED TO INSERT DATA INSIDE THE SOCIAL ENGINE ADDON GROUP COMMUNITY PLUGIN
        if ($this->getParam('import_group_segroup', 1) == 1)
            return false;
        $type_id = $this->getFromDb()->select()
                ->from($this->getfromPrefix() . 'pages', 'type_id')
                ->where('page_id = ?', $data['page_id'])
                ->query()
                ->fetchColumn();
        if ($type_id != 3)
            return false;

        //FIND DETAIL OF THIS USER 
        $userModel = $this->getToDb()->select()
                ->from('engine4_users', '*')
                ->where('user_id = ?', $data['user_id'])
                ->query()
                ->fetch();
        $status = 3;
        switch ($data['status_id']) {
            case 1 : $status = 3;
                break;
            case 2 : $status = 1;
                break;
            case 3 : $status = 2;
                break;
        }
        //MAKING AN ARRAY FOR INSERTION OF GROUP CLAIMS
        $newData = array();
        $newData['claim_id'] = $data['claim_id'];
        $newData['group_id'] = $data['page_id'];
        $newData['user_id'] = $data['user_id'];
        $newData['nickname'] = $userModel['displayname'];
        $newData['email'] = $userModel['email'];
        $newData['creation_date'] = $this->_translateTime($data['time_stamp']);
        $newData['modified_date'] = $this->_translateTime($data['time_stamp']);
        $newData['status'] = $status;
        return $newData;
    }

}

/*
 * 
 * 
 */
