<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Phpfoximporter
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    SitepageForumTopics.php 2015-07-30 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Install_Import_Phpfox_SitepageForumTopics extends Install_Import_Phpfox_Abstract {

    protected $_fromTable = '';
    protected $_toTable = '';
    protected $_priority = 92;
    protected $_fromWhere = array('group_id <>? ' => 0);
    protected $_warningMessage = array();

    protected function _initPre() {
        $this->_truncateTable($this->getToDb(), 'engine4_sitepage_topicwatches');
        $this->_truncateTable($this->getToDb(), 'engine4_sitepage_posts');
        $this->_fromTable = $this->getFromPrefix() . 'forum_thread';
        $this->_toTable = 'engine4_sitepage_topics';
        $this->_warningMessage = array("key" => 'pagekit', 'value' => '<span style="font-weight:bolder;">Warning:</span>  Your PHPfox Pages Blogs, PHPfox Pages Music and PHPfox Pages Videos content are not migrated into SocialEngine PHP. You may ignore this warning or you can install<a target="_blank" href="http://www.socialengineaddons.com/socialengine-directory-pages-plugin" > Directory / Pages and Essential Extensions - Product Kit</a>  on your SocialEngine PHP site to fix this warning.  ');
    }

    protected function _translateRow(array $data, $key = null) {

        //RETURN FALSE IF USER NOT SELECTED TO INSERT DATA INSIDE THE SOCIAL ENGINE ADDON DIRECTORY/PAGES PLUGIN
        if ($this->getParam('import_group_sepage', 1) == 1)
            return false;
        $newData = array();
        $type_id = $this->getFromDb()->select()
                ->from($this->getfromPrefix() . 'pages', 'type_id')
                ->where('page_id = ?', $data['group_id'])
                ->query()
                ->fetchColumn();
        if ($type_id == 3)
            return false;

        //Get Owner UserId
        $userId = $this->getFromDb()->query("SELECT  " . $this->getfromPrefix() . "pages.user_id FROM " . $this->getfromPrefix() . "user left join  " . $this->getfromPrefix() . "pages on page_id=profile_page_id where profile_page_id<>0 and  " . $this->getfromPrefix() . "user.user_id=" . $data['user_id'])->fetchColumn(0);
        if ($userId)
            $data['user_id'] = $userId;
        //PREPARING AN ARRAY FOR PAGES FORUM TOPIC
        $newData['topic_id'] = $data['thread_id'];
        $newData['page_id'] = $data['group_id'];
        $newData['user_id'] = $data['user_id'];
        $newData['title'] = $data['title'];
        $newData['closed'] = $data['is_closed'];
        $newData['creation_date'] = $this->_translateTime($data['time_stamp']);
        $newData['modified_date'] = $this->_translateTime($data['time_update']);
        $newData['sticky'] = $data['order_id'];
        $newData['lastposter_id'] = $data['last_user_id'] ? $data['last_user_id'] : $data['user_id'];
        $newData['view_count'] = $data['total_view'];
        //INSERT THE FORUM TOPIC
        $this->getToDb()->insert('engine4_sitepage_topics', $newData);
        $topic_id = $this->getToDb()->lastInsertId();
        //SEARCH FORUM TOPIC
        $this->_insertSearch('sitepage_topic', $topic_id, $data['title'], '');
        //FIND ALL THE POST OF THIS TOPIC
        $posts = $this->getFromDb()->select()
                ->from($this->getfromPrefix() . 'forum_post', '*')
                ->where('thread_id = ?', $data['thread_id'])
                ->query()
                ->fetchAll();
        $newPostData = array();
        $count = 0;
        $post_id = null;
        //INSERTION OF EACH POST OF THIS TOPIC
        foreach ($posts as $post) {
            //Get Owner UserId
            $userId = $this->getFromDb()->query("SELECT  " . $this->getfromPrefix() . "pages.user_id FROM " . $this->getfromPrefix() . "user left join  " . $this->getfromPrefix() . "pages on page_id=profile_page_id where profile_page_id<>0 and  " . $this->getfromPrefix() . "user.user_id=" . $post['user_id'])->fetchColumn(0);
            if ($userId)
                $post['user_id'] = $userId;
            //GETTING TEXT
            $text = $this->getFromDb()->select()
                    ->from($this->getfromPrefix() . 'forum_post_text', 'text')
                    ->where('post_id = ?', $post['post_id'])
                    ->query()
                    ->fetchColumn();
            if (is_null($text) || $text === false)
                $text = '';
            $userInfo = array(
                'user_id' => $post['user_id'],
                'time_stamp' => $post['time_stamp'],
                'text' => $text,
                'item_id' => $post['post_id'],
                'album_title' => 'Discussions Photos',
                'album_type' => 'discussions',
                'page_id' => $data['group_id'],
                'album_table' => 'sitepage_albums',
                'categoryId' => 'forum'
            );
            //FIND THE BODY OF THIS PAGE'S FORUM POST.
            $body = $this->getBody($userInfo);
            if (is_null($body))
                $body = '';

            //PREPARING ARRAY FOR INSERTION OF FORUM POST.
            $newPostData['post_id'] = $post['post_id'];
            $newPostData['topic_id'] = $data['thread_id'];
            $newPostData['user_id'] = $post['user_id'];
            $newPostData['body'] = $body;
            $newPostData['creation_date'] = $this->_translateTime($post['time_stamp']);
            $newPostData['modified_date'] = $post['update_time'] ? $this->_translateTime($post['update_time']) : $this->_translateTime($post['time_stamp']);
            $newPostData['page_id'] = $data['group_id'];
            //INSERT THE PAGE'S FORUM POST
            $this->getToDb()->insert('engine4_sitepage_posts', $newPostData);
            $post_id = $this->getToDb()->lastInsertId();
            //UPDATE THE COUNT OF POST IN THIS TOPIC
            if (!empty($post_id)) {
                $this->getToDb()->update('engine4_sitepage_topics', array(
                    'lastpost_id' => $post_id,
                    'post_count' => ++$count
                        ), array(
                    'topic_id = ?' => $topic_id
                ));
            }
            //SEARCH
            $this->_insertSearch('sitepage_post', $post_id, '', $body);
        }
        //PREPARING ARRAY OF TOPIC WATCHES
        $newWatchData = array();
        $newWatchData['topic_id'] = $data['thread_id'];
        $newWatchData['user_id'] = $data['user_id'];
        $newWatchData['watch'] = 1;
        $newWatchData['resource_id'] = $data['group_id'];
        //INSERT THE TOPIC WATCH
        $this->getToDb()->insert('engine4_sitepage_topicwatches', $newWatchData);
    }

}

/*
 * CREATE TABLE IF NOT EXISTS `phpfox_forum` (
  `forum_id` smallint(4) unsigned NOT NULL AUTO_INCREMENT,
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `view_id` tinyint(1) NOT NULL DEFAULT '0',
  `is_category` tinyint(1) NOT NULL DEFAULT '0',
  `name` varchar(255) NOT NULL,
  `name_url` varchar(255) NOT NULL,
  `description` mediumtext,
  `is_closed` tinyint(1) NOT NULL DEFAULT '0',
  `thread_id` int(10) unsigned NOT NULL DEFAULT '0',
  `post_id` int(10) unsigned NOT NULL DEFAULT '0',
  `last_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `total_post` int(10) unsigned NOT NULL DEFAULT '0',
  `total_thread` int(10) unsigned NOT NULL DEFAULT '0',
  `ordering` smallint(4) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`forum_id`),
  KEY `view_id` (`view_id`),
  KEY `post_id` (`post_id`),
  KEY `thread_id` (`thread_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
 */
/*
CREATE TABLE IF NOT EXISTS `engine4_sitepage_topics` (
`topic_id` int(11) unsigned NOT NULL,
  `page_id` int(11) unsigned NOT NULL,
  `user_id` int(11) unsigned NOT NULL,
  `title` varchar(64) COLLATE utf8_unicode_ci NOT NULL,
  `creation_date` datetime NOT NULL,
  `modified_date` datetime NOT NULL,
  `sticky` tinyint(1) NOT NULL DEFAULT '0',
  `closed` tinyint(1) NOT NULL DEFAULT '0',
  `post_count` int(11) unsigned NOT NULL DEFAULT '0',
  `view_count` int(11) unsigned NOT NULL DEFAULT '0',
  `lastpost_id` int(11) unsigned NOT NULL DEFAULT '0',
  `lastposter_id` int(11) unsigned NOT NULL DEFAULT '0',
  `resource_type` varchar(64) COLLATE utf8_unicode_ci DEFAULT NULL,
  `resource_id` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB AUTO_INCREMENT=10 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
*/
/*
CREATE TABLE IF NOT EXISTS `engine4_sitepage_topicwatches` (
  `resource_id` int(10) unsigned NOT NULL,
  `topic_id` int(10) unsigned NOT NULL,
  `user_id` int(10) unsigned NOT NULL,
  `watch` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `page_id` int(11) unsigned NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
*/
/*
CREATE TABLE IF NOT EXISTS `engine4_sitepage_posts` (
`post_id` int(11) unsigned NOT NULL,
  `topic_id` int(11) unsigned NOT NULL,
  `page_id` int(11) unsigned NOT NULL,
  `user_id` int(11) unsigned NOT NULL,
  `body` text COLLATE utf8_unicode_ci NOT NULL,
  `creation_date` datetime NOT NULL,
  `modified_date` datetime NOT NULL
) ENGINE=InnoDB AUTO_INCREMENT=21 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
*/